var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 105624;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 105664;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(106491);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,96,3,0,0,250,10,0,0,7,0,0,0,250,10,0,0,74,0,0,0,0,0,0,0,73,110,118,101,114,115,101,32,102,111,114,32,115,32,110,111,116,32,99,111,114,114,101,99,116,108,121,32,99,111,109,112,117,116,101,100,0,0,0,0,96,3,0,0,249,10,0,0,7,0,0,0,249,10,0,0,74,0,0,0,0,0,0,0,73,110,118,101,114,115,101,32,102,111,114,32,104,32,110,111,116,32,99,111,114,114,101,99,116,108,121,32,99,111,109,112,117,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,82,101,102,101,114,101,110,99,101,65,105,114,46,73,110,118,101,114,115,101,95,115,104,95,84,88,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,0,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,82,101,102,101,114,101,110,99,101,65,105,114,46,73,110,118,101,114,115,101,95,115,104,95,84,88,95,105,110,102,111,46,120,109,108,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,84,104,101,32,97,114,103,117,109,101,110,116,115,32,117,95,109,105,110,32,97,110,100,32,117,95,109,97,120,32,112,114,111,118,105,100,101,100,32,105,110,32,116,104,101,32,102,117,110,99,116,105,111,110,32,99,97,108,108,10,32,32,32,32,115,111,108,118,101,79,110,101,78,111,110,108,105,110,101,97,114,69,113,117,97,116,105,111,110,40,102,44,117,95,109,105,110,44,117,95,109,97,120,41,10,100,111,32,110,111,116,32,98,114,97,99,107,101,116,32,116,104,101,32,114,111,111,116,32,111,102,32,116,104,101,32,115,105,110,103,108,101,32,110,111,110,45,108,105,110,101,97,114,32,101,113,117,97,116,105,111,110,32,48,61,102,40,117,41,58,10,32,32,117,95,109,105,110,32,32,61,32,0,0,10,0,0,0,0,0,0,0,32,32,117,95,109,97,120,32,32,61,32,0,0,0,0,0,32,32,102,97,32,61,32,102,40,117,95,109,105,110,41,32,61,32,0,0,0,0,0,0,32,32,102,98,32,61,32,102,40,117,95,109,97,120,41,32,61,32,0,0,0,0,0,0,102,97,32,97,110,100,32,102,98,32,109,117,115,116,32,104,97,118,101,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,119,104,105,99,104,32,105,115,32,110,111,116,32,116,104,101,32,99,97,115,101,0,1,0,0,0,160,24,0,0,168,24,0,0,0,0,0,0,1,0,0,0,0,24,0,0,8,24,0,0,0,0,0,0,1,0,0,0,168,23,0,0,176,23,0,0,0,0,0,0,1,0,0,0,8,23,0,0,16,23,0,0,0,0,0,0,1,0,0,0,176,22,0,0,184,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,116,97,117,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,45,32,101,120,112,40,45,50,53,46,51,54,51,54,53,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,45,32,101,120,112,40,45,49,54,46,57,48,55,52,49,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,32,43,32,101,120,112,40,56,55,46,51,49,50,55,57,48,48,48,48,48,48,48,48,49,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,102,46,116,97,117,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,128,22,0,0,136,22,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,40,99,49,46,114,101,32,94,32,50,46,48,32,43,32,99,49,46,105,109,32,94,32,50,46,48,41,32,94,32,48,46,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,1,0,0,0,96,22,0,0,104,22,0,0,0,0,0,0,1,0,0,0,64,22,0,0,72,22,0,0,0,0,0,0,1,0,0,0,232,21,0,0,240,21,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,70,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,69,32,42,32,71,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,40,54,53,48,46,49,55,53,51,52,56,52,52,55,57,56,32,43,32,68,41,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,40,45,48,46,50,51,56,53,53,53,53,55,53,54,55,56,52,57,32,43,32,54,53,48,46,49,55,53,51,52,56,52,52,55,57,56,32,42,32,68,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,65,105,114,46,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,32,42,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,66,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,65,32,42,32,67,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,1,0,0,0,192,21,0,0,200,21,0,0,0,0,0,0,1,0,0,0,144,21,0,0,152,21,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,64,14,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,64,14,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,64,14,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,64,14,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,64,14,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,64,14,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,64,14,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,64,14,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,64,14,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,64,14,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,64,14,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,64,14,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,56,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,14,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,64,14,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,64,14,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,64,14,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,64,14,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,84,32,61,32,0,0,41,0,0,0,0,0,0,0,64,14,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,4,0,0,0,0,0,0,0,238,125,147,110,151,114,146,63,182,225,201,209,144,175,156,63,225,193,5,143,37,98,160,63,146,202,20,115,16,116,164,63,10,0,0,0,0,0,0,0,69,72,146,101,53,60,146,64,230,57,133,85,234,25,38,193,213,154,16,162,231,18,49,192,202,188,217,143,105,122,199,64,133,56,32,132,149,169,72,193,107,204,190,29,137,212,45,64,179,240,72,7,68,215,178,192,229,145,38,159,229,185,24,65,14,166,232,53,253,136,206,191,212,75,22,29,103,81,132,64,3,0,0,0,0,0,0,0,79,211,114,180,129,78,107,63,237,43,205,181,129,78,243,63,162,150,40,115,218,64,251,63,3,0,0,0,0,0,0,0,39,62,45,245,226,54,53,192,248,186,86,140,4,82,59,64,68,243,165,92,134,108,24,192,5,0,0,0,0,0,0,0,70,177,134,119,168,73,35,193,22,51,58,37,241,245,228,63,221,99,66,105,92,85,84,190,215,161,171,33,3,154,238,60,242,95,162,72,204,5,133,187,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,133,235,81,184,30,213,63,41,92,143,194,245,40,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,51,51,51,51,51,195,63,0,0,0,0,0,0,0,0,154,153,153,153,153,153,201,63,102,102,102,102,102,102,214,63,154,153,153,153,153,153,245,63,154,153,153,153,153,153,249,63,154,153,153,153,153,153,233,63,102,102,102,102,102,102,238,63,0,0,0,0,0,0,244,63,205,204,204,204,204,204,12,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,10,64,0,0,0,0,0,0,12,64,0,0,0,0,0,0,46,64,19,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,6,0,0,0,1,0,0,0,3,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,3,0,0,0,11,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,124,252,4,97,200,63,190,63,242,16,199,119,217,209,230,63,184,179,228,163,81,228,249,191,152,16,88,103,48,72,178,63,160,215,149,43,160,39,182,191,18,198,89,243,212,45,193,63,152,159,4,9,226,16,135,63,201,151,243,92,3,136,165,191,52,55,71,248,133,222,161,63,205,17,255,105,11,159,37,63,246,50,202,34,15,243,185,191,244,22,40,235,134,63,198,191,245,117,228,106,243,43,168,191,250,23,206,78,195,23,137,191,160,217,43,81,194,196,194,191,96,8,130,141,155,46,160,191,108,25,21,27,36,158,46,63,220,143,38,101,142,94,142,63,129,224,3,15,237,57,131,191,13,0,0,0,0,0,0,0,115,193,105,214,120,66,112,62,184,97,171,53,133,12,246,190,32,173,224,40,123,210,36,191,39,2,96,50,17,175,43,192,147,78,201,222,119,70,49,64,108,58,221,255,78,155,41,191,158,128,91,180,86,237,3,64,244,102,197,81,104,82,233,63,115,204,200,12,147,42,203,63,99,158,164,223,15,86,201,63,190,48,153,42,24,93,57,64,56,16,146,5,76,232,48,64,4,33,89,192,4,212,85,64,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,116,105,109,101,32,60,32,48,46,48,0,0,0,0,0,0,116,105,109,101,32,62,32,49,46,48,0,0,0,0,0,0,1,0,0,0,7,0,0,0,1,0,0,0,7,0,0,0,136,25,0,0,144,25,0,0,104,25,0,0,120,25,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,101,109,112,116,121,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,184,26,0,0,185,10,0,0,7,0,0,0,186,10,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,95,109,97,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,95,109,97,120,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,184,26,0,0,182,10,0,0,7,0,0,0,183,10,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,184,26,0,0,180,10,0,0,7,0,0,0,181,10,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,152,28,0,0,217,10,0,0,7,0,0,0,217,10,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,28,0,0,218,10,0,0,7,0,0,0,218,10,0,0,69,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,82,101,102,101,114,101,110,99,101,65,105,114,95,73,110,118,101,114,115,101,95,95,115,104,95,95,84,88,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,49,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,49,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,49,44,49,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,49,44,48,93,32,61,32,122,101,114,111,115,40,49,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,49,93,32,61,32,122,101,114,111,115,40,48,44,49,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,49,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,36,100,117,109,109,121,32,61,32,120,91,49,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,82,101,102,101,114,101,110,99,101,65,105,114,95,73,110,118,101,114,115,101,95,95,115,104,95,95,84,88,59,10,0,0,0,0,0,120,32,0,0,136,32,0,0,152,32,0,0,176,32,0,0,208,32,0,0,224,32,0,0,248,32,0,0,8,33,0,0,32,33,0,0,64,33,0,0,104,33,0,0,128,33,0,0,160,33,0,0,184,33,0,0,224,33,0,0,0,34,0,0,48,34,0,0,96,34,0,0,120,34,0,0,176,34,0,0,200,34,0,0,248,34,0,0,24,35,0,0,80,35,0,0,120,35,0,0,176,35,0,0,224,35,0,0,240,35,0,0,16,36,0,0,56,36,0,0,88,36,0,0,128,36,0,0,168,36,0,0,192,36,0,0,216,36,0,0,232,36,0,0,0,37,0,0,48,37,0,0,128,37,0,0,192,37,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,240,51,0,0,128,50,0,0,8,49,0,0,144,47,0,0,144,47,0,0,24,46,0,0,8,49,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,184,62,0,0,64,59,0,0,208,57,0,0,96,56,0,0,96,56,0,0,240,54,0,0,208,57,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,0,61,0,0,16,61,0,0,32,61,0,0,240,45,0,0,40,61,0,0,56,61,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,152,64,0,0,160,64,0,0,168,64,0,0,176,64,0,0,40,64,0,0,184,64,0,0,200,64,0,0,208,64,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,88,66,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,16,67,0,0,32,67,0,0,40,67,0,0,48,67,0,0,64,67,0,0,80,67,0,0,88,67,0,0,104,67,0,0,120,67,0,0,136,67,0,0,152,67,0,0,168,67,0,0,184,67,0,0,200,67,0,0,216,67,0,0,224,67,0,0,232,67,0,0,248,67,0,0,0,68,0,0,16,68,0,0,32,68,0,0,48,68,0,0,64,68,0,0,80,68,0,0,96,68,0,0,112,68,0,0,128,68,0,0,144,68,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,24,69,0,0,32,69,0,0,32,69,0,0,64,69,0,0,112,69,0,0,144,69,0,0,200,69,0,0,248,69,0,0,40,70,0,0,72,70,0,0,120,70,0,0,144,70,0,0,176,70,0,0,216,70,0,0,248,70,0,0,40,71,0,0,72,71,0,0,112,71,0,0,144,71,0,0,184,71,0,0,232,71,0,0,32,72,0,0,72,72,0,0,120,72,0,0,168,72,0,0,208,72,0,0,0,73,0,0,8,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,24,69,0,0,8,76,0,0,16,76,0,0,24,76,0,0,40,67,0,0,32,76,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,24,77,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,48,77,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,72,77,0,0,80,77,0,0,88,77,0,0,104,77,0,0,120,77,0,0,128,77,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10248);
/* memory initializer */ allocate([112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,152,89,0,0,0,0,0,0,16,89,0,0,0,0,0,0,136,88,0,0,0,0,0,0,0,88,0,0,0,0,0,0,248,86,0,0,0,0,0,0,240,85,0,0,0,0,0,0,232,84,0,0,0,0,0,0,224,83,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20488);
/* memory initializer */ allocate([70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,32,90,0,0,48,90,0,0,56,90,0,0,64,90,0,0,80,90,0,0,88,90,0,0,96,90,0,0,104,90,0,0,112,90,0,0,120,90,0,0,128,90,0,0,144,90,0,0,152,90,0,0,168,90,0,0,184,90,0,0,200,90,0,0,208,90,0,0,224,90,0,0,232,90,0,0,248,90,0,0,0,91,0,0,24,91,0,0,32,91,0,0,40,91,0,0,56,91,0,0,64,91,0,0,80,91,0,0,96,91,0,0,104,91,0,0,112,91,0,0,120,91,0,0,128,91,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,16,92,0,0,24,92,0,0,96,92,0,0,144,92,0,0,192,92,0,0,8,93,0,0,72,93,0,0,144,93,0,0,192,93,0,0,8,94,0,0,32,94,0,0,64,94,0,0,120,94,0,0,160,94,0,0,200,94,0,0,0,95,0,0,80,95,0,0,176,95,0,0,224,95,0,0,24,96,0,0,72,96,0,0,144,96,0,0,184,96,0,0,232,96,0,0,24,97,0,0,112,97,0,0,184,97,0,0,40,98,0,0,88,98,0,0,160,98,0,0,192,98,0,0,128,91,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,16,92,0,0,128,99,0,0,40,100,0,0,144,92,0,0,192,92,0,0,144,100,0,0,72,93,0,0,144,93,0,0,24,101,0,0,88,101,0,0,32,94,0,0,64,94,0,0,248,101,0,0,56,102,0,0,120,102,0,0,0,95,0,0,80,95,0,0,184,102,0,0,240,102,0,0,120,103,0,0,160,103,0,0,144,96,0,0,184,96,0,0,232,96,0,0,8,104,0,0,144,104,0,0,144,105,0,0,40,98,0,0,88,98,0,0,160,98,0,0,192,98,0,0,128,91,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,111,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+23064);
/* memory initializer */ allocate([47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,129,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+33304);
/* memory initializer */ allocate([112,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,134,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,135,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,138,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,138,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,64,174,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,32,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,112,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,175,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,32,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,40,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,112,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,112,176,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,232,188,0,0,8,190,0,0,16,190,0,0,32,190,0,0,48,190,0,0,64,190,0,0,88,190,0,0,112,190,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,232,188,0,0,240,188,0,0,56,189,0,0,96,189,0,0,128,189,0,0,160,189,0,0,200,189,0,0,240,189,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,80,197,0,0,96,197,0,0,104,197,0,0,112,197,0,0,120,197,0,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,152,197,0,0,160,197,0,0,176,197,0,0,192,197,0,0,120,197,0,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+43684);
/* memory initializer */ allocate([0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,8,215,0,0,208,216,0,0,216,216,0,0,224,216,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,8,215,0,0,16,216,0,0,96,216,0,0,144,216,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,8,215,0,0,208,215,0,0,216,215,0,0,224,215,0,0,240,215,0,0,248,215,0,0,8,216,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,8,215,0,0,16,215,0,0,40,215,0,0,56,215,0,0,128,215,0,0,144,215,0,0,176,215,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,184,226,0,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,184,226,0,0,10,0,0,0,11,0,0,0,92,226,0,0,212,226,0,0,232,226,0,0,112,226,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,200,156,1,0,136,226,0,0,80,88,1,0,0,0,0,0,104,0,0,0,0,0,0,0,80,88,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,80,88,1,0,14,0,0,0,15,0,0,0,0,0,0,0,96,227,0,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,200,156,1,0,48,227,0,0,72,87,1,0,0,0,0,0,0,0,0,0,232,227,0,0,240,227,0,0,224,227,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,192,227,0,0,208,227,0,0,224,227,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,64,244,0,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,64,244,0,0,20,0,0,0,21,0,0,0,228,243,0,0,92,244,0,0,112,244,0,0,248,243,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,200,156,1,0,16,244,0,0,192,87,1,0,0,0,0,0,108,0,0,0,0,0,0,0,192,87,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,192,87,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,120,254,0,0,96,0,1,0,104,0,1,0,176,2,1,0,200,0,1,0,216,0,1,0,184,2,1,0,192,2,1,0,200,2,1,0,208,2,1,0,224,2,1,0,240,2,1,0,0,3,1,0,16,3,1,0,32,3,1,0,48,3,1,0,64,3,1,0,88,3,1,0,144,2,1,0,168,2,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,120,254,0,0,96,0,1,0,104,0,1,0,120,0,1,0,200,0,1,0,216,0,1,0,232,0,1,0,8,1,1,0,40,1,1,0,72,1,1,0,112,1,1,0,152,1,1,0,192,1,1,0,232,1,1,0,0,2,1,0,32,2,1,0,64,2,1,0,104,2,1,0,144,2,1,0,168,2,1,0,114,101,99,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+53924);
/* memory initializer */ allocate([103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,120,254,0,0,64,0,1,0,72,0,1,0,80,0,1,0,120,254,0,0,128,255,0,0,208,255,0,0,0,0,1,0,120,254,0,0,64,255,0,0,72,255,0,0,80,255,0,0,96,255,0,0,104,255,0,0,120,255,0,0,0,0,0,0,120,254,0,0,128,254,0,0,152,254,0,0,168,254,0,0,240,254,0,0,0,255,0,0,32,255,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,152,5,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,152,5,1,0,29,0,0,0,30,0,0,0,36,5,1,0,180,5,1,0,200,5,1,0,56,5,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,200,156,1,0,80,5,1,0,80,88,1,0,0,0,0,0,56,0,0,0,0,0,0,0,80,88,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,80,88,1,0,14,0,0,0,15,0,0,0,0,0,0,0,88,6,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,200,156,1,0,16,6,1,0,72,87,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,232,26,1,0,232,26,1,0,232,26,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,144,29,1,0,160,29,1,0,184,29,1,0,216,29,1,0,248,29,1,0,16,30,1,0,48,30,1,0,72,30,1,0,88,30,1,0,104,30,1,0,128,30,1,0,152,30,1,0,184,30,1,0,216,30,1,0,104,30,1,0,240,30,1,0,16,31,1,0,40,31,1,0,64,31,1,0,88,31,1,0,120,31,1,0,136,31,1,0,168,31,1,0,200,31,1,0,224,31,1,0,248,31,1,0,16,32,1,0,32,32,1,0,56,32,1,0,80,32,1,0,104,32,1,0,136,32,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+64164);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+78904);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,144,73,1,0,152,73,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,168,73,1,0,176,73,1,0,184,73,1,0,192,73,1,0,144,1,0,0,0,0,0,0,48,74,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+84128);
/* memory initializer */ allocate([8,81,1,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,200,156,1,0,232,80,1,0,136,87,1,0,0,0,0,0,0,0,0,0,112,81,1,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,200,156,1,0,88,81,1,0,136,87,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,8,82,1,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,200,156,1,0,232,81,1,0,72,87,1,0,0,0,0,0,0,0,0,0,112,82,1,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,200,156,1,0,88,82,1,0,72,87,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,160,156,1,0,128,82,1,0,0,0,0,0,232,82,1,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,144,83,1,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,200,156,1,0,216,82,1,0,0,0,0,0,0,0,0,0,0,0,0,0,40,83,1,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,200,156,1,0,16,83,1,0,232,82,1,0,0,0,0,0,0,0,0,0,104,83,1,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,200,156,1,0,80,83,1,0,232,82,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,200,156,1,0,120,83,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,216,83,1,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,200,156,1,0,192,83,1,0,144,83,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,160,156,1,0,232,83,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,200,156,1,0,16,84,1,0,8,84,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,192,86,1,0,49,0,0,0,50,0,0,0,0,0,0,0,72,87,1,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,136,87,1,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,192,87,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,192,87,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,8,88,1,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,8,88,1,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,80,88,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,80,88,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,152,88,1,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,152,88,1,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,86,1,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,136,86,1,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,200,156,1,0,64,86,1,0,216,83,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,160,156,1,0,112,86,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,200,156,1,0,144,86,1,0,136,86,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,200,156,1,0,208,86,1,0,136,86,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,160,156,1,0,16,87,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,160,156,1,0,80,87,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,40,157,1,0,144,87,1,0,0,0,0,0,1,0,0,0,192,86,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,40,157,1,0,216,87,1,0,0,0,0,0,1,0,0,0,0,87,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,40,157,1,0,32,88,1,0,0,0,0,0,1,0,0,0,192,86,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,40,157,1,0,104,88,1,0,0,0,0,0,1,0,0,0,0,87,1,0,3,244,255,255,0,0,0,0,248,88,1,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,200,156,1,0,216,88,1,0,40,84,1,0,0,0,0,0,0,0,0,0,32,103,1,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,103,1,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,107,1,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,144,108,1,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,109,1,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,109,1,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,16,105,1,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,16,105,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,176,105,1,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,176,105,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,64,106,1,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,106,1,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,103,1,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,103,1,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,104,1,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,104,1,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,110,1,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,8,111,1,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,152,111,1,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,40,112,1,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,107,1,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,107,1,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,248,102,1,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,99,1,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,100,1,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,102,1,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,208,102,1,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,8,99,1,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,200,156,1,0,240,98,1,0,160,82,1,0,0,0,0,0,0,0,0,0,152,99,1,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,160,156,1,0,120,99,1,0,40,157,1,0,96,99,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,99,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,40,157,1,0,184,99,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,99,1,0,2,0,0,0,0,0,0,0,104,100,1,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,160,156,1,0,72,100,1,0,40,157,1,0,32,100,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,96,100,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,40,157,1,0,136,100,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,96,100,1,0,2,0,0,0,0,0,0,0,40,101,1,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,40,157,1,0,0,101,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,96,100,1,0,2,0,0,0,0,0,0,0,160,101,1,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,40,157,1,0,120,101,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,96,100,1,0,2,0,0,0,0,0,0,0,24,102,1,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,200,156,1,0,240,101,1,0,160,101,1,0,0,0,0,0,0,0,0,0,128,102,1,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,200,156,1,0,88,102,1,0,160,101,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,200,156,1,0,144,102,1,0,8,99,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,200,156,1,0,184,102,1,0,8,99,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,200,156,1,0,224,102,1,0,8,99,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,200,156,1,0,8,103,1,0,8,99,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,200,156,1,0,48,103,1,0,8,99,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,160,156,1,0,120,103,1,0,40,157,1,0,88,103,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,103,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,40,157,1,0,184,103,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,103,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,40,157,1,0,248,103,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,103,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,40,157,1,0,56,104,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,103,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,160,156,1,0,192,104,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,160,156,1,0,224,104,1,0,40,157,1,0,120,104,1,0,0,0,0,0,3,0,0,0,8,99,1,0,2,0,0,0,216,104,1,0,2,0,0,0,8,105,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,160,156,1,0,128,105,1,0,40,157,1,0,56,105,1,0,0,0,0,0,3,0,0,0,8,99,1,0,2,0,0,0,216,104,1,0,2,0,0,0,168,105,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,160,156,1,0,32,106,1,0,40,157,1,0,216,105,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,56,106,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,40,157,1,0,96,106,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,56,106,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,160,156,1,0,224,106,1,0,40,157,1,0,200,106,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,248,106,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,40,157,1,0,32,107,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,248,106,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,160,156,1,0,184,107,1,0,40,157,1,0,160,107,1,0,0,0,0,0,1,0,0,0,216,107,1,0,0,0,0,0,40,157,1,0,88,107,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,224,107,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,40,157,1,0,96,108,1,0,0,0,0,0,1,0,0,0,216,107,1,0,0,0,0,0,40,157,1,0,24,108,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,120,108,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,160,156,1,0,16,109,1,0,40,157,1,0,248,108,1,0,0,0,0,0,1,0,0,0,48,109,1,0,0,0,0,0,40,157,1,0,176,108,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,56,109,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,40,157,1,0,184,109,1,0,0,0,0,0,1,0,0,0,48,109,1,0,0,0,0,0,40,157,1,0,112,109,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,208,109,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,160,156,1,0,80,110,1,0,40,157,1,0,8,110,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,112,110,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,160,156,1,0,224,110,1,0,40,157,1,0,152,110,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,0,111,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,160,156,1,0,112,111,1,0,40,157,1,0,40,111,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,144,111,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,160,156,1,0,0,112,1,0,40,157,1,0,184,111,1,0,0,0,0,0,2,0,0,0,8,99,1,0,2,0,0,0,32,112,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+86180);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,16,154,1,0,110,0,0,0,24,154,1,0,114,0,0,0,32,154,1,0,102,0,0,0,40,154,1,0,97,0,0,0,48,154,1,0,101,0,0,0,56,154,1,0,119,0,0,0,64,154,1,0,87,0,0,0,80,154,1,0,115,0,0,0,96,154,1,0,83,0,0,0,112,154,1,0,100,0,0,0,128,154,1,0,68,0,0,0,144,154,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,24,156,1,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,160,156,1,0,240,155,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,200,156,1,0,8,156,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,200,156,1,0,40,156,1,0,0,156,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,200,156,1,0,96,156,1,0,80,156,1,0,0,0,0,0,0,0,0,0,136,156,1,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,16,157,1,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,200,156,1,0,232,156,1,0,136,156,1,0,0,0,0,0,0,0,0,0,112,157,1,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,200,156,1,0,72,157,1,0,136,156,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,159,1,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,200,156,1,0,160,159,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+96520);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  var _fseeko=_fseek;



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_setjmp=true;

  var _floor=Math_floor;

  var _atan2=Math_atan2;


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiiiiiiiiiiiiiiiiiiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_viiiiii;var Ba=env.invoke_iid;var Ca=env.invoke_viiiiiii;var Da=env.invoke_viiiiiid;var Ea=env.invoke_viiiiiiiii;var Fa=env.invoke_iii;var Ga=env.invoke_iiiiii;var Ha=env.invoke_iiiiidi;var Ia=env.invoke_iiiiiiiii;var Ja=env.invoke_i;var Ka=env.invoke_iiiiiiiiii;var La=env.invoke_viii;var Ma=env.invoke_v;var Na=env.invoke_viidii;var Oa=env.invoke_iiiii;var Pa=env.invoke_viiii;var Qa=env._fabs;var Ra=env._exp;var Sa=env._strrchr;var Ta=env._pthread_key_create;var Ua=env._vsscanf;var Va=env.__ZSt9terminatev;var Wa=env.___cxa_guard_acquire;var Xa=env.__reallyNegative;var Ya=env._fstat;var Za=env._pclose;var _a=env._lis_solver_create;var $a=env.___assert_fail;var ab=env.__ZSt18uncaught_exceptionv;var bb=env._longjmp;var cb=env.__isLeapYear;var db=env._clock_gettime;var eb=env._fsync;var fb=env._signal;var gb=env._GC_collect_a_little;var hb=env._sbrk;var ib=env._strtoull;var jb=env._emscripten_memcpy_big;var kb=env.__parseInt64;var lb=env._close;var mb=env._rewind;var nb=env._cos;var ob=env._fileno;var pb=env._fread;var qb=env._puts;var rb=env._isatty;var sb=env._lis_matrix_set_value;var tb=env._write;var ub=env._isblank;var vb=env._ftell;var wb=env.__ZNSt9exceptionD2Ev;var xb=env._round;var yb=env.___cxa_does_inherit;var zb=env._strtoll_l;var Ab=env._strstr;var Bb=env.___cxa_rethrow;var Cb=env._llvm_lifetime_end;var Db=env._catclose;var Eb=env._tmpnam;var Fb=env._lis_vector_destroy;var Gb=env._lis_solver_set_option;var Hb=env._tmpfile;var Ib=env._send;var Jb=env._pow;var Kb=env._atan2;var Lb=env.___cxa_is_number_type;var Mb=env.___cxa_free_exception;var Nb=env.___cxa_find_matching_catch;var Ob=env._isxdigit_l;var Pb=env.___cxa_guard_release;var Qb=env._truncate;var Rb=env._strtol;var Sb=env._sin;var Tb=env._strtok;var Ub=env.___setErrNo;var Vb=env._newlocale;var Wb=env._isdigit_l;var Xb=env.___resumeException;var Yb=env._freelocale;var Zb=env._srand;var _b=env._fscanf;var $b=env._qsort;var ac=env._putchar;var bc=env._floor;var cc=env._pthread_mutex_unlock;var dc=env._printf;var ec=env._sprintf;var fc=env._fopen;var gc=env._vasprintf;var hc=env._emscripten_get_now;var ic=env._stat;var jc=env._vsnprintf;var kc=env._strtoull_l;var lc=env._read;var mc=env.__addDays;var nc=env._fwrite;var oc=env._time;var pc=env._pthread_mutex_lock;var qc=env._catopen;var rc=env._exit;var sc=env._GC_strdup;var tc=env._freopen;var uc=env.___ctype_b_loc;var vc=env._fmod;var wc=env._strtok_r;var xc=env._lseek;var yc=env._access;var zc=env._vfprintf;var Ac=env.___cxa_allocate_exception;var Bc=env._atoi;var Cc=env._strtoll;var Dc=env._pwrite;var Ec=env._localtime_r;var Fc=env._tzset;var Gc=env._open;var Hc=env._uselocale;var Ic=env._snprintf;var Jc=env.___errno_location;var Kc=env._GC_malloc;var Lc=env.___cxa_end_catch;var Mc=env._perror;var Nc=env.___cxa_begin_catch;var Oc=env._strftime;var Pc=env._ftruncate;var Qc=env._GC_init;var Rc=env._fseek;var Sc=env._isxdigit;var Tc=env._fclose;var Uc=env.__parseInt;var Vc=env._log;var Wc=env._pthread_cond_broadcast;var Xc=env._popen;var Yc=env._recv;var Zc=env._fgetc;var _c=env._sysconf;var $c=env.__getFloat;var ad=env._abort;var bd=env._ceil;var cd=env._isspace;var dd=env._localtime;var ed=env._pthread_getspecific;var fd=env._pthread_cond_wait;var gd=env._llvm_lifetime_start;var hd=env._acos;var id=env._ungetc;var jd=env._system;var kd=env._fmin;var ld=env._fmax;var md=env._fflush;var nd=env._strftime_l;var od=env._fprintf;var pd=env._sscanf;var qd=env._catgets;var rd=env._strdup;var sd=env._asprintf;var td=env.__exit;var ud=env.___ctype_toupper_loc;var vd=env._bsearch;var wd=env.__arraySum;var xd=env.__formatString;var yd=env._htonl;var zd=env.___ctype_tolower_loc;var Ad=env._unlink;var Bd=env._fputs;var Cd=env._GC_malloc_atomic;var Dd=env._pread;var Ed=env._lis_vector_set_size;var Fd=env._mkport;var Gd=env.__scanString;var Hd=env._pthread_setspecific;var Id=env._copysign;var Jd=env._fputc;var Kd=env.___cxa_throw;var Ld=env._lis_solver_destroy;var Md=env._isdigit;var Nd=env._strerror;var Od=env._emscripten_longjmp;var Pd=env._lis_vector_create;var Qd=env._atexit;var Rd=env._sqrt;var Sd=env._strerror_r;var Td=0.0;
// EMSCRIPTEN_START_FUNCS
function ek(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Qj(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 2:{k=yk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=uk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Qj(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function fk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Qj(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Qj(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function gk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Qj(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function hk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Qj(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=uk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Qj(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ik(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Qj(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=uk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=vk(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Qj(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function jk(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Qj(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=Qj(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function kk(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function lk(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Qj(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function mk(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Qj(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function nk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Qj(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Qj(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function ok(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=cj(c)|0;k=j;i=b;return k|0}function pk(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function qk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Qj(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Qj(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function rk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Qj(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function sk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function tk(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function uk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 19:{k=wk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Qj(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function vk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Qj(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function wk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=xk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Qj(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function xk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Qj(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Qj(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function yk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Bk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Qj(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=zk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Ak(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Ck(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Qj(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 17:{break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Qj(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 24:case 22:{break};case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 11:{o=90;break b;break};case 6:{o=42;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Qj(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 7:{o=84;break d;break};case 17:{break c;break};case 5:{o=78;break d;break};case 29:{o=75;break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Dk(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function zk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Qj(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Ak(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[12544+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Bk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Qj(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Qj(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Ek(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Qj(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Ek(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Ck(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Qj(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{n=37;break b;break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Qj(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Dk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Qj(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Qj(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=Qj(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 29:{if((c[10224+((d[9968+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 24:case 22:{break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};case 29:{if((c[10224+((d[11504+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Qj(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=Qj(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=uk(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=Qj(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=Qj(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[10224+((d[9968+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Ek(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Fk(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Qj(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Qj(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Gk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Qj(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Qj(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=zk(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Hk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Qj(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Ik(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((me[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((me[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 30:{k=gl(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=ql(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((me[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((me[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=rl(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=ml(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((me[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((me[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 19:{k=sl(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 13:{k=ql(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 34:{n=110;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 29:{n=69;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}p=b;if((me[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=p+4|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){n=104;break b}q=b;if((me[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=q+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}r=b;if((me[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=r+3|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}s=b;if((me[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=s+2|0;continue b;break};case 29:{n=91;break b;break};default:{m=19;continue b}}break};case 33:{n=113;break b;break};case 5:{if((e-b|0)<2){n=72;break b}t=b;if((me[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=t+2|0;continue b;break};case 15:{n=116;break b;break};case 6:{if((e-b|0)<3){n=77;break b}u=b;if((me[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=u+3|0;continue b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==110){q=b;if((m|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){q=b;if((m|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){q=b;if((m|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function Jk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=jl(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=fl(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((me[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((me[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((me[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Kk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 6:{if((e-b|0)<3){n=43;break b}if((me[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 5:{if((e-b|0)<2){n=39;break b}if((me[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((me[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Lk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((me[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((me[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((me[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function Mk(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 10:{m=13;break a;break};case 21:{m=23;break a;break};case 3:{m=9;break a;break};case 2:{m=12;break a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=16;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=fl(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Nk(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 10:{m=15;break a;break};case 6:{a=a+3|0;continue a;break};case 3:{m=9;break a;break};case 9:{m=18;break a;break};case 30:{m=12;break a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=fl(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=gl(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Ok(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 5:{break};case 7:{e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=4;break a}else{j=5}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{h=c;c=h+1|0;e=b;b=e+1|0;if((a[h]|0)!=(a[e]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Pk(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Qk(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Rk(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Sk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Tk(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=cj(c)|0;g=f;i=b;return g|0}function Uk(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Vk(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 6:{a=a+3|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 5:{a=a+2|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Wk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Xk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Yk(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}o=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;o=o-65536|0;b[j>>1]=o>>>10|55296;b[j+2>>1]=o&1023|56320;j=j+4|0;m=m+4|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Zk(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[10224+(((d[11504+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function _k(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[10224+(((d[11504+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function $k(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function al(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[10224+(((d[9968+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function bl(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[10224+(((d[9968+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function cl(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function dl(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function el(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function fl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=hl(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=38;break b}m=a;if((me[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((me[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((me[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function gl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}m=a;if((me[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((me[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 18:{l=42;break b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((me[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function hl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=il(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function il(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function jl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=ml(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=ll(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=kl(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=nl(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}n=b;if((me[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 29:{m=33;break b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((me[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 6:{if((e-b|0)<3){m=41;break b}p=b;if((me[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=p+3|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=63;break b}q=b;if((me[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}r=b;if((me[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=r+2|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=55;break b;break};case 7:{if((e-b|0)<4){m=68;break b}s=b;if((me[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=s+4|0;continue b;break};default:{m=72;break b}}break};case 11:{m=97;break b;break};case 17:{break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{m=88;break d;break};case 29:{m=76;break d;break};case 5:{m=78;break d;break};case 6:{m=83;break d;break};case 24:case 22:{m=77;break d;break};case 11:{m=97;break c;break};case 17:{break c;break};case 10:case 9:case 21:{break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((me[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=ol(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function kl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=8;break b}n=b;if((me[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=n+2|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((me[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((me[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function ll(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[12920+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function ml(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((me[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((me[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((me[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{o=41;break b;break};case 6:{if((e-b|0)<3){o=32;break b}p=b;if((me[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((me[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((me[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};case 29:{o=24;break b;break};case 15:{o=68;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((pl(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 8:case 1:case 0:{o=61;break c;break};case 5:{if((e-b|0)<2){o=47;break c}s=b;if((me[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((me[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((me[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((pl(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function nl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{l=41;break b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((me[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((me[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((me[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 11:{l=49;break b;break};case 23:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function ol(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 14:{break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(me[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=m+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(me[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=n+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(me[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=o+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 29:{l=26;break a;break};default:{l=43;break a}}break};case 29:{l=4;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=48;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}p=(me[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!p){l=19;break a}c[j>>2]=q+4;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}p=(me[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!p){l=9;break a}c[j>>2]=r+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}p=(me[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!p){l=14;break a}c[j>>2]=s+3;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}p=t;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}p=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((p|0)==(t|0)){break}switch(p|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}p=(me[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(p){l=68;break a}c[j>>2]=u+3;continue c;break};case 2:{l=80;break a;break};case 3:{v=fl(k,(c[j>>2]|0)+1|0,e,j)|0;if((v|0)<=0){l=77;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}p=(me[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(p){l=73;break a}c[j>>2]=w+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}p=(me[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(p){l=63;break a}c[j>>2]=x+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 7:{l=101;break d;break};case 17:{l=107;break a;break};case 5:{l=91;break d;break};case 29:{l=89;break a;break};case 24:case 22:{l=90;break d;break};case 6:{l=96;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}p=(me[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!p){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}p=(me[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!p){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}p=(me[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!p){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((v|0)==0){c[f>>2]=c[j>>2]}B=v;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function pl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function ql(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((me[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((me[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((me[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function rl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=kl(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function sl(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((me[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((me[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((me[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((me[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function tl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function ul(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function vl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}



function xE(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=aR(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=ER(f|0)|0;c[e+64>>2]=k;k=c[17950]|0;do{if((k|0)==0){c[17950]=e;c[e+44>>2]=0;l=aR(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){rc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=aR(384)|0;c[l>>2]=n;if((n|0)==0){rc(-1)}else{IR(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[17950]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[17950]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=ER(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(ER(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 1:{B=o;C=x;D=y;E=22;break};case 5:{F=o;G=y;E=18;break};case 8:{H=o;E=15;break};case 4:{I=o;J=y;E=19;break};case 9:{K=o;E=14;break};case 2:{L=o;M=x;N=y;E=21;break};case 7:{O=o;P=y;E=16;break};case 3:{Q=o;R=x;S=y;E=20;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;T=z;E=13;break};case 10:{T=o;E=13;break};case 6:{U=o;V=y;E=17;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+T|0;c[p>>2]=o;K=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+K|0;c[p>>2]=o;H=o;E=15}if((E|0)==15){O=H;P=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){U=O;V=((d[A+6|0]|0)<<16)+P|0;E=17}if((E|0)==17){F=U;G=((d[A+5|0]|0)<<8)+V|0;E=18}if((E|0)==18){I=F;J=(d[A+4|0]|0)+G|0;E=19}if((E|0)==19){Q=I;R=((d[A+3|0]|0)<<24)+x|0;S=J;E=20}if((E|0)==20){L=Q;M=((d[A+2|0]|0)<<16)+R|0;N=S;E=21}if((E|0)==21){B=L;C=((d[A+1|0]|0)<<8)+M|0;D=N;E=22}if((E|0)==22){W=B;X=(d[A]|0)+C|0;Y=D}D=X-Y-W^W>>>13;X=Y-W-D^D<<8;Y=W-D-X^X>>>13;W=D-X-Y^Y>>>12;D=X-Y-W^W<<16;X=Y-W-D^D>>>5;Y=W-D-X^X>>>3;W=D-X-Y^Y<<10;D=X-Y-W^W>>>15;c[p>>2]=D;p=(c[17950]|0)+40|0;W=c[p>>2]|0;Y=D&(c[W+4>>2]|0)+ -1;D=c[W>>2]|0;W=D+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[D+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[17950]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[17950]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=aR((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){rc(-1)}IR(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;D=c[j>>2]|0;c[Y+24>>2]=(((D<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((D|0)==0){_=e}else{D=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=D}else{W=D;X=j;while(1){j=X+16|0;C=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];B=Z+(A*12|0)+4|0;E=(c[B>>2]|0)+1|0;c[B>>2]=E;N=c[W+24>>2]|0;if(E>>>0>N>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[B>>2]|0)>>>0)/(N>>>0)|0}c[X+12>>2]=0;N=Z+(A*12|0)|0;c[j>>2]=c[N>>2];j=c[N>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[N>>2]=X;N=c[h>>2]|0;if((C|0)==0){$=N;break}else{W=N;X=C}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){D=$;Y=W;e=X}else{_=W;break}}}bR(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function yE(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[17950]|0)==0){f=24}else{g=ER(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(ER(a|0)|0)+s|0;switch(v|0){case 4:{x=h;y=u;f=12;break};case 10:{z=h;f=6;break};case 1:{A=h;B=t;C=u;f=15;break};case 2:{D=h;E=t;F=u;f=14;break};case 3:{G=h;H=t;I=u;f=13;break};case 5:{J=h;K=u;f=11;break};case 11:{z=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 7:{L=h;M=u;f=9;break};case 6:{N=h;O=u;f=10;break};case 8:{P=h;f=8;break};case 9:{Q=h;f=7;break};default:{R=h;S=t;T=u}}if((f|0)==6){Q=((d[w+9|0]|0)<<16)+z|0;f=7}if((f|0)==7){P=((d[w+8|0]|0)<<8)+Q|0;f=8}if((f|0)==8){L=P;M=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){N=L;O=((d[w+6|0]|0)<<16)+M|0;f=10}if((f|0)==10){J=N;K=((d[w+5|0]|0)<<8)+O|0;f=11}if((f|0)==11){x=J;y=(d[w+4|0]|0)+K|0;f=12}if((f|0)==12){G=x;H=((d[w+3|0]|0)<<24)+t|0;I=y;f=13}if((f|0)==13){D=G;E=((d[w+2|0]|0)<<16)+H|0;F=I;f=14}if((f|0)==14){A=D;B=((d[w+1|0]|0)<<8)+E|0;C=F;f=15}if((f|0)==15){R=A;S=(d[w]|0)+B|0;T=C}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[17950]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=ER(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((zR(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Ab(a|0,72360)|0)==0){V=0;break}else{W=72384}i=b;return W|0}}while(0);c[e>>2]=a;Um(0,(V|0)!=0|0,72432,e);W=V+4|0;i=b;return W|0}function zE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((AE(72488,a,b)|0)!=0){d=1;i=c;return d|0}d=(AE(72496,a,b)|0)!=0|0;i=c;return d|0}function AE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((AR(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function BE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(AR(c[23564>>2]|0,72504)|0)==0|0;Um(0,m,72520,l);l=(AR(c[25468>>2]|0,72504)|0)==0|0;Um(0,l,72576,k);k=(AR(c[27460>>2]|0,72504)|0)==0|0;Um(0,k,72632,j);j=72696|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=72824|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[27464+(k<<2)>>2]|0;if((l|0)==2){q=c[23440+(k<<2)>>2]|0;if(!((AE(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[23440+(k<<2)>>2]|0;if((DE(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((AE(c[23440+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=72696+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=72696+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[72824+(k<<2)>>2]=CE(q,p)|0;t=j}else if((r|0)==13){r=0;l=72696+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[72824+(k<<2)>>2]=EE(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];Tm(1,0,72952,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];Tm(1,0,72952,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];Tm(1,0,72952,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];Tm(1,0,73008,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function CE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((AR(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function DE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(EE(a,b)|0)!=0|0;i=c;return d|0}function EE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=ER(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((BR(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function FE(){i=i;return}function GE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){rc(0)}e=c[r>>2]|0;nc(73040,5,1,e|0)|0;f=b;b=0;while(1){Jd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}nc(73048,20,1,e|0)|0;rc(0);return 0}function HE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;od(d|0,73072,e|0)|0;if((b|0)==0){rc(1)}else{md(d|0)|0;NE();md(d|0)|0;fb(6,0)|0;ad()}}function IE(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function JE(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function KE(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function LE(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}IR(p|0,32,b+(d-p)|0)|0;i=f;return}function ME(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=74112+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[74156+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[74152+(e*48|0)>>2]|0)==1){OE(b)|0}k=74116+(e*48|0)|0;if((c[k>>2]|0)==0){break}Tc(c[f>>2]|0)|0;bR(c[k>>2]|0)}}while(0);do{if((h|0)==10){Tc(g|0)|0;b=74116+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Ad(k|0)|0;bR(c[b>>2]|0)}}while(0);c[f>>2]=0}c[74148+(e*48|0)>>2]=0;c[74116+(e*48|0)>>2]=0;i=d;return 0}function NE(){var a=0,b=0;a=i;if((c[18270]|0)!=0){i=a;return}c[18270]=1;c[73088>>2]=0;b=0;do{c[73084>>2]=b;ME(73080)|0;b=b+1|0;}while((b|0)<100);i=a;return}function OE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[74128+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=74112+(d*48|0)|0;g=c[f>>2]|0;h=vb(g|0)|0;Rc(g|0,0,2)|0;if((h|0)>=(vb(g|0)|0)){e=0;i=b;return e|0}if((c[74132+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[74140+(d*48|0)>>2]&2|0)!=0){md(c[f>>2]|0)|0}d=Pc(ob(c[f>>2]|0)|0,h|0)|0;Rc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){QE(111,73096);e=111;i=b;return e|0}else{c[(Jc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function PE(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((Ya(ob(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(rb(ob(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function QE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Mc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;od(m|0,74008,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;od(m|0,74040,j|0)|0;l=m;break}else{n=c[73880+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;od(m|0,74064,h|0)|0;l=m;break}}}while(0);h=c[18518]|0;do{if((h|0)==0){nc(78944,29,1,l|0)|0}else{c[g>>2]=(h-74112|0)/48|0;od(l|0,74080,g|0)|0;b=c[(c[18518]|0)+4>>2]|0;if((b|0)==0){nc(78928,10,1,l|0)|0;break}else{c[f>>2]=b;od(l|0,78912,f|0)|0;break}}}while(0);f=c[19744]|0;if((f|0)!=0){c[d>>2]=f;od(l|0,78984,d|0)|0}d=(c[19764]|0)!=0?79064:79080;f=(c[19772]|0)!=0?79096:79112;g=(c[19782]|0)!=0?79136:79152;c[e>>2]=(c[19758]|0)!=0?79040:79048;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;od(l|0,79008,e|0)|0;HE(79168,1)}function RE(){var a=0,b=0;a=i;c[19794]=1;b=c[r>>2]|0;c[18528]=b;c[74132>>2]=PE(b)|0;c[74136>>2]=1;c[74152>>2]=1;b=c[s>>2]|0;c[74352>>2]=b;c[74372>>2]=PE(b)|0;c[74376>>2]=1;c[74392>>2]=0;b=c[t>>2]|0;c[74400>>2]=b;c[74420>>2]=PE(b)|0;c[74424>>2]=1;c[74440>>2]=1;i=a;return}function SE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=tc(g|0,c[84424+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[19796]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=vb(c[k>>2]|0)|0;l=tc(c[f>>2]|0,c[84424+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[19796]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Rc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Jc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Rc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function TE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){QE(b,d)}d=c[19798]|0;if((d|0)!=0){qe[d&7]()|0}c[(Jc()|0)>>2]=b;i=e;return b|0}function UE(a){a=a|0;var b=0,d=0;b=i;c[19828]=0;c[19830]=0;c[19832]=0;d=((VE(a,0)|0)==0)<<31>>31;i=b;return d|0}function VE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[19832]|0;c[19832]=j+1;if((j|0)==1){c[19830]=d}if((_E(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=$E(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function WE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[19828]|0;l=79336+(k<<4)|0;m=c[l>>2]|0;switch(XE(m)|0){case 8:{n=c[21044]|0;o=84184+(n<<2)|0;p=c[o>>2]|0;if((p|0)>=1){q=10;break b}c[21044]=n+ -1;c[19828]=k+1;continue b;break};case 20:{c[19824]=c[79340+(k<<4)>>2];c[19828]=k+1;continue b;break};case 6:{n=c[79340+(k<<4)>>2]|0;s=(c[21044]|0)+1|0;c[21044]=s;c[84184+(s<<2)>>2]=n;c[19828]=k+1;continue b;break};case 3:{n=c[21044]|0;s=84184+(n<<2)|0;t=c[s>>2]|0;c[s>>2]=t+ -1;if((t|0)<2){c[21044]=n+ -1;c[21060]=(c[21060]|0)+ -1;c[19828]=k+1;continue b}else{n=c[21060]|0;c[21060]=n+ -1;c[19828]=(c[84248+(n<<2)>>2]|0)+1;continue b}break};case 22:{c[19806]=1;c[19828]=k+1;continue b;break};case 21:{c[19806]=0;c[19828]=k+1;continue b;break};case 1:{n=c[79340+(k<<4)>>2]|0;t=(c[21060]|0)+1|0;c[21060]=t;c[84248+(t<<2)>>2]=n;c[19828]=k+1;continue b;break};case 16:{if(b){q=28;break a}c[19828]=k+1;continue b;break};case 33:{c[21072]=1;c[19828]=k+1;continue b;break};case 2:{c[21044]=0;c[21060]=0;c[19828]=c[79340+(k<<4)>>2];if(b){q=24;break a}if((c[21056]|0)==0){j=0;q=37;break a}n=qe[c[19814]&7]()|0;if((n|0)==0){continue b}else{j=n;q=37;break a}break};case 19:case 17:{c[19804]=0;c[19828]=k+1;continue b;break};case 9:{n=($d[c[19812]&127](l)|0)==0;c[19828]=(c[19828]|0)+1;if(n){break b}else{continue b}break};case 18:{c[19804]=1;c[19828]=k+1;continue b;break};default:{q=4;break a}}}if((q|0)==10){q=0;if(b){q=11;break}c[o>>2]=p+ -1;c[21056]=1;k=ee[c[19810]&63](l,g,d)|0;if((k|0)>0){q=13;break}if((k|0)<0){q=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;q=37;break}}if((q|0)==4){h=c[r>>2]|0;d=c[19744]|0;c[f>>2]=m;c[f+4>>2]=d;od(h|0,84136,f|0)|0;if((c[c[19800]>>2]|0)==0){QE(100,84168);j=100;i=e;return j|0}else{c[(Jc()|0)>>2]=100;j=100;i=e;return j|0}}else if((q|0)==11){j=qe[c[19798]&7]()|0;i=e;return j|0}else if((q|0)==13){f=c[c[19800]>>2]|0;j=TE(f,c[(Jc()|0)>>2]|0,84232)|0;i=e;return j|0}else if((q|0)==15){if((c[(c[19800]|0)+8>>2]|0)==0){QE(-1,84232);j=-1;i=e;return j|0}else{c[(Jc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((q|0)==24){j=qe[c[19798]&7]()|0;i=e;return j|0}else if((q|0)==28){j=qe[c[19798]&7]()|0;i=e;return j|0}else if((q|0)==37){i=e;return j|0}return 0}function XE(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function YE(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=WE(b,0,0)|0;i=a;return d|0}function ZE(){c[19820]=0;c[19828]=0;c[21060]=0;c[21044]=0;c[21056]=0;c[21062]=0;c[21046]=0;i=i;return}function _E(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[19828]|0;if((g|0)>299){nc(84312,24,1,c[r>>2]|0)|0;HE(c[19744]|0,1)}else{c[79336+(g<<4)>>2]=a;c[79340+(g<<4)>>2]=b;c[79344+(g<<4)>>2]=d;c[79348+(g<<4)>>2]=e;c[19828]=g+1;i=f;return g|0}return 0}function $E(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=aF(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[19832]|0)+ -1|0;c[19832]=h;if((h|0)==0){_E(2,c[19830]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{_E(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function aF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((bF(b,e)|0)!=0){g=c[e>>2]|0;break}if((cF(b,e)|0)!=0){g=c[e>>2]|0;break}h=dF(b,f,1)|0;j=_E(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=VE(h,j)|0}}while(0);i=d;return g|0}function bF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==76|h<<24>>24==108){j=g;k=13}else if(h<<24>>24==82|h<<24>>24==114){j=g;k=14}else{j=b;k=15}g=dF(j+1|0,f,0)|0;if((g|0)==0){l=15;break a}_E(k,c[f>>2]|0,0,0)|0;m=g+ -1|0;l=30;break};case 58:{_E(16,0,0,0)|0;m=b;l=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{n=b;o=0;l=14;break};case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){_E(22,0,0,0)|0;m=g;l=30;break a}else{_E(21,0,0,0)|0;m=g;l=30;break a}break};case 39:case 34:case 2:{c[79344+((_E(11,0,0,0)|0)<<4)>>2]=b;g=eF(b)|0;c[d>>2]=g;p=(g|0)!=0|0;i=e;return p|0};case 47:{_E(5,0,0,0)|0;m=b;l=30;break};case 112:case 80:{_E(20,1,0,0)|0;m=b;l=30;break};case 43:{q=0;l=13;break};case 120:case 88:{_E(4,1,0,0)|0;m=b;l=30;break};case 45:{q=1;l=13;break};case 36:{_E(33,0,0,0)|0;m=b;l=30;break};case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==80|h<<24>>24==112){r=g;s=18}else if(h<<24>>24==83|h<<24>>24==115){r=g;s=19}else{r=b;s=17}_E(s,0,0,0)|0;m=r;l=30;break};default:{p=0;i=e;return p|0}}}while(0);if((l|0)==13){n=b+1|0;o=q;l=14}b:do{if((l|0)==14){q=dF(n,f,0)|0;if((q|0)==0){l=15;break}switch(a[q]|0){case 112:case 80:{b=c[f>>2]|0;if((o|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}_E(20,t,0,0)|0;m=q;l=30;break b;break};case 120:case 88:{_E(4,c[f>>2]|0,0,0)|0;m=q;l=30;break b;break};case 104:case 72:{r=c[f>>2]|0;c[79344+((_E(12,r,0,0)|0)<<4)>>2]=q+1;m=q+r|0;l=30;break b;break};default:{p=0;i=e;return p|0}}}}while(0);if((l|0)==15){c[d>>2]=0;p=1;i=e;return p|0}else if((l|0)==30){c[d>>2]=m+1;p=1;i=e;return p|0}return 0}function cF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=dF(b,f,1)|0;_E(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 97:case 65:{l=f;while(1){m=a[l]|0;if(m<<24>>24==32){l=l+1|0}else{break}}if(!((m+ -48<<24>>24&255)<10)){_E(30,0,0,0)|0;n=l;o=45;break a}p=dF(l,g,1)|0;q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}_E(31,q,0,0)|0;n=p;o=45;break};case 100:case 68:{p=dF(f,g,0)|0;if((p|0)==0){o=4;break a}q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}if((a[p]|0)==46){r=dF(p+1|0,h,0)|0;if((r|0)==0){o=4;break a}s=r;t=c[h>>2]|0}else{c[h>>2]=0;s=p;t=0}_E(26,q,t,0)|0;n=s;o=45;break};case 105:case 73:{u=7;v=10;o=38;break};case 102:case 70:{q=dF(f,g,0)|0;if((q|0)==0){o=4;break a}p=c[g>>2]|0;if((p|0)==0){n=q;o=45;break a}if((a[q]|0)==46){r=dF(q+1|0,h,0)|0;if((r|0)==0){o=4;break a}w=r;x=c[h>>2]|0}else{c[h>>2]=0;w=q;x=0}_E(23,p,x,0)|0;n=w;o=45;break};case 103:case 71:{y=0;o=3;break};case 111:case 79:{u=32;v=34;o=38;break};case 122:case 90:{u=35;v=36;o=38;break};case 108:case 76:{p=dF(f,g,0)|0;if((p|0)==0){o=4;break a}q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}_E(29,q,0,0)|0;n=p;o=45;break};case 101:case 69:{y=1;o=3;break};default:{c[19828]=(c[19828]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((o|0)==3){b=dF(f,g,0)|0;if((b|0)==0){o=4;break}w=c[g>>2]|0;if((w|0)==0){n=b;o=45;break}x=a[b]|0;if(x<<24>>24==46){s=dF(b+1|0,h,0)|0;if((s|0)==0){o=4;break}A=s;B=a[s]|0}else{c[h>>2]=0;A=b;B=x}if(!(B<<24>>24==101|B<<24>>24==69)){_E((y|0)==1?24:27,w,c[h>>2]|0,0)|0;n=A;o=45;break}x=dF(A+1|0,j,0)|0;if((x|0)==0){o=4;break}_E((y|0)==1?25:28,w,c[h>>2]|0,c[j>>2]|0)|0;n=x;o=45}else if((o|0)==38){x=dF(f,g,0)|0;if((x|0)==0){o=4;break}w=c[g>>2]|0;if((w|0)==0){n=x;o=45;break}if((a[x]|0)!=46){_E(u,w,0,0)|0;n=x;o=45;break}b=dF(x+1|0,h,0)|0;if((b|0)==0){o=4;break}_E(v,w,c[h>>2]|0,0)|0;n=b;o=45}}while(0);if((o|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((o|0)==45){c[d>>2]=n;z=1;i=e;return z|0}return 0}function dF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function eF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[19800]>>2]|0)==0){QE(100,84296);n=0;i=d;return n|0}else{c[(Jc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function fF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[84366|0]=48;k=84366|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=84344+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function gF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[19822]|0;f=c[19818]|0;if((e|0)>(f|0)){c[19818]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[21110]|0)){h=g}else{hF(f,g);h=c[19818]|0}g=c[21112]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Bd(g|0,c[19796]|0)|0;h=ER(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Jd(a[k]|0,c[19796]|0)|0;Bd(h|0,c[19796]|0)|0;b=ER(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function hF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[21112]|0;if((f|0)==84528){c[21110]=1024;g=1024}else{g=c[21110]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[21110]=j;h=j}j=aR(h)|0;if((j|0)==0){QE(113,84928);k=c[21112]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[21112]|0}else{l=k}if((l|0)==84528){m=84448;c[21112]=j;i=e;return}bR(l);m=84448;c[21112]=j;i=e;return}function iF(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[19818]|0;f=c[21110]|0;if((e|0)<(f|0)){g=e}else{hF(e,f);g=c[19818]|0}c[19818]=g+1;a[(c[21112]|0)+g|0]=b;i=d;return}function jF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[19782]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){QE(101,84456);l=101;i=d;return l|0}else{c[(Jc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[19794]|0)==0){RE();m=c[f>>2]|0}else{m=k}k=74112+(m*48|0)|0;c[18518]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){oF(k,c[b+12>>2]|0,j);o=pF(j,h)|0;if((o|0)==(c[74120+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[74124+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=ME(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[74144+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=74128+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[74144+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=74136+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[74136+(m*48|0)>>2]=1;r=1;break}else{c[74136+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];ec(j|0,84464,e|0)|0}else{oF(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){kF(107,84456,b);l=107;i=d;return l|0}else{c[(Jc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=74156+(m*48|0)|0;c[q>>2]=0;c[74148+(m*48|0)>>2]=0;e=74152+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=74140+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 79:case 111:{if((yc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Jc()|0;s=c[k>>2]|0;if(o){kF(s,84456,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Hb()|0;c[n>>2]=s;if((s|0)!=0){c[74116+(m*48|0)>>2]=0;c[74124+(m*48|0)>>2]=-1;c[74120+(m*48|0)>>2]=-1;c[74132+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Jc()|0;o=c[k>>2]|0;if(s){kF(o,84456,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((yc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){kF(128,84456,b);l=128;i=d;return l|0}else{c[(Jc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=fc(j|0,c[21106]|0)|0;if((o|0)==0){break}Tc(o|0)|0}}while(0);q=aR((ER(j|0)|0)+1|0)|0;c[74116+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){kF(113,84480,b);l=113;i=d;return l|0}else{c[(Jc()|0)>>2]=113;l=113;i=d;return l|0}}KR(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=fc(j|0,c[84424+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=fc(j|0,c[84384+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=fc(j|0,c[84424+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Jc()|0;o=c[g>>2]|0;if(h){QE(o,84456);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=74132+(m*48|0)|0;c[r>>2]=PE(u)|0;u=pF(j,74124+(m*48|0)|0)|0;c[74120+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){kF(108,84456,b);l=108;i=d;return l|0}else{c[(Jc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){mb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Rc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){kF(129,84456,b);l=129;i=d;return l|0}else{c[(Jc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function kF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){QE(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[21110]|0)){j=d;k=g}else{hF(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[21112]|0;c[(c[18518]|0)+4>>2]=f;oF(k,j,f);QE(a,b);i=e;return}function lF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;ec(j|0,84464,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=ER(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?84496:84504;c[h+24>>2]=(b|0)==5?84512:84520;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=jF(h)|0;i=e;return a|0}function mF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=74112+(d*48|0)|0;c[18518]=e;if(d>>>0>99){if((c[a>>2]|0)==0){QE(101,84944);f=101;i=b;return f|0}else{c[(Jc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((lF(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){QE(114,84952);f=114;i=b;return f|0}else{c[(Jc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[74136+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){QE(102,84952);f=102;i=b;return f|0}else{c[(Jc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function nF(){var a=0,b=0;a=i;b=YE()|0;c[19744]=0;i=a;return b|0}function oF(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function pF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((ic(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function qF(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[19824]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[19804]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ec(p|0,84960,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(ER(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;Yd[c[19808]&255](32);}while((A|0)>0)}if((D|0)!=0){Yd[c[19808]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{Yd[c[19808]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Bc(A|0)|0)+1|0;c[m>>2]=t-(c[19824]|0);ec(A|0,84968,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;Yd[c[19808]&255](32);}while((z|0)>0)}if((x|0)!=0){Yd[c[19808]&255]((w|0)!=0?45:43)}z=c[19824]|0;do{if((z|0)<1){Yd[c[19808]&255](46);y=c[19808]|0;if((z|0)<0){G=y;J=z;while(1){Yd[G&255](48);I=J+1|0;K=c[19808]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}Yd[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}Yd[c[19808]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[19808]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){Yd[P&255](a[J]|0);R=Q+ -1|0;S=c[19808]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}Yd[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;Yd[c[19808]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){Yd[c[19808]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;Yd[c[19808]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){Yd[c[19808]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;Yd[c[19808]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;Yd[c[19808]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;Yd[c[19808]&255](42);}while((_|0)>0);i=l;return 0}function rF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[19824]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(ec(n|0,84976,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[19804]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;Yd[c[19808]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;Yd[c[19808]&255](32);}while((b|0)>0)}do{if(q){if((c[19804]|0)==0){break}Yd[c[19808]&255](43)}else{Yd[c[19808]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;Yd[c[19808]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;Yd[c[19808]&255](48);}while((z|0)>0);i=j;return 0}function sF(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{Yd[c[19808]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[19808]|0;if((h|0)==0){Yd[d&255](70);i=g;return 0}else{Yd[d&255](84);i=g;return 0}return 0}function tF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[19820]|0)!=0){g=uF()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 7:{vF(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 29:{sF(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 35:{AF(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 28:case 27:{h=zF(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 25:case 24:case 26:{h=qF(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 23:{h=rF(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 31:{yF(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 34:{wF(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 10:{wF(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 32:{vF(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 30:{xF(b,d);h=0;i=e;return h|0};case 36:{AF(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;od(h|0,84984,f|0)|0;HE(c[19744]|0,1)}}return 0}function uF(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[19820]|0;c[19820]=0;if((c[19782]|0)!=0){if((b|0)>0){d=c[19822]|0;e=c[19818]|0;if((d|0)<=(e|0)){f=b;while(1){Yd[c[19808]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[19818]=f;h=0;i=a;return h|0}f=b-d+e|0;c[19818]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){Yd[c[19808]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[19818]|0;f=j+b|0;if((f|0)>=0){if((c[19822]|0)<(j|0)){c[19822]=j}c[19818]=f;h=0;i=a;return h|0}if((c[c[19800]>>2]|0)==0){QE(110,85072);h=110;i=a;return h|0}else{c[(Jc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[19818]|0;if((c[19822]|0)<(f|0)){c[19822]=f}j=f+b|0;c[19818]=j;c[19826]=(c[19826]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[19800]>>2]|0)==0){QE(110,85072);h=110;i=a;return h|0}else{c[(Jc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[19818]|0;f=j+b|0;if((f|0)>=(c[(c[19802]|0)+16>>2]|0)){if((c[c[19800]>>2]|0)==0){QE(110,85088);h=110;i=a;return h|0}else{c[(Jc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[19822]|0;if((d|0)<=(j|0)){e=b;while(1){Yd[c[19808]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[19826]=(c[19826]|0)+b;c[19818]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[19826]=(c[19826]|0)+f;c[19818]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){Yd[c[19808]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function vF(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=fF(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[19804]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{Yd[c[19808]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{Yd[c[19808]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[19804]|0)==0){break}Yd[c[19808]&255](43)}else{Yd[c[19808]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){Yd[c[19808]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function wF(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=fF(m,k,l,h)|0;h=c[l>>2]|0;g=(c[19804]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{Yd[c[19808]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{Yd[c[19808]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[19804]|0)==0){break}Yd[c[19808]&255](43)}else{Yd[c[19808]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){Yd[c[19808]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){Yd[c[19808]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{Yd[c[19808]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function xF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;Yd[c[19808]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function yF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;Yd[c[19808]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;Yd[c[19808]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function zF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=qF(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=qF(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[19824]|0;c[19824]=0;p=(e|0)==0?4:e+2|0;e=rF(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{Yd[c[19808]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[19824]=o;n=e;i=j;return n|0}function AF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{Yd[c[19808]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;Yd[c[19808]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;Yd[c[19808]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){Yd[c[19808]&255](a[85048+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){Yd[c[19808]&255](a[85048+((d[p]|0)>>>4)|0]|0);Yd[c[19808]&255](a[85048+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function BF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 5:{f=qe[c[19816]&7]()|0;i=b;return f|0};case 13:{g=(c[19820]|0)-(c[a+4>>2]|0)|0;h=0-(c[19818]|0)|0;c[19820]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 12:{f=DF(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 15:{c[19820]=(c[a+4>>2]|0)+ -1-(c[19818]|0);f=1;i=b;return f|0};case 11:{f=CF(c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[19820]=(c[19820]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;od(f|0,85016,d|0)|0;HE(c[19744]|0,1)}}return 0}function CF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[19820]|0)!=0){e=uF()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}Yd[c[19808]&255](e<<24>>24);n=b}else{Yd[c[19808]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function DF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[19820]|0)!=0){f=uF()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;Yd[c[19808]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function EF(){var a=0,b=0;a=i;b=gF(10)|0;c[19820]=0;c[19818]=0;c[19822]=0;i=a;return(b|0)==0|0}function FF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[19794]|0)==0){RE()}c[19758]=0;c[19764]=1;c[19772]=1;c[19782]=1;d=mF(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[19800]=a;c[19818]=0;c[19820]=0;c[19822]=0;c[21072]=0;c[19824]=0;d=c[a+12>>2]|0;c[19744]=d;c[19796]=c[c[18518]>>2];if((UE(d)|0)<0){if((c[a>>2]|0)==0){QE(100,85096);e=100;i=b;return e|0}else{c[(Jc()|0)>>2]=100;e=100;i=b;return e|0}}c[19808]=169;c[19810]=44;c[19812]=111;c[19798]=4;c[19814]=5;c[19816]=6;ZE();c[19804]=0;d=c[18518]|0;c[19806]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((SE(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Jc()|0;f=c[a>>2]|0;if(d){QE(f,85104);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function GF(){var a=0,b=0;a=i;if((c[21072]|0)==0){b=gF(10)|0}else{gF(0)|0;md(c[19796]|0)|0;b=0}c[19820]=0;c[19818]=0;c[19822]=0;i=a;return b|0}function HF(){var a=0,b=0,d=0;a=i;if((c[21056]|0)==0){b=0}else{d=gF(10)|0;c[21056]=0;b=d}c[19820]=0;c[19818]=0;c[19822]=0;i=a;return b|0}function IF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;cG(85832,h,85888);c[21280]=87340;c[85128>>2]=87360;c[85124>>2]=0;VH(85128|0,85832);c[85200>>2]=0;c[85204>>2]=-1;j=c[t>>2]|0;c[21484]=87208;DN(85940|0);k=85944|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[21484]=86448;c[85968>>2]=j;EN(g,85940|0);k=HN(g,9e4)|0;l=k;FN(g);c[85972>>2]=l;c[85976>>2]=85896;a[85980|0]=($d[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[21302]=87420;c[85212>>2]=87440;VH(85212|0,85936);c[85284>>2]=0;c[85288>>2]=-1;l=c[r>>2]|0;c[21496]=87208;DN(85988|0);k=85992|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[21496]=86448;c[86016>>2]=l;EN(f,85988|0);k=HN(f,9e4)|0;g=k;FN(f);c[86020>>2]=g;c[86024>>2]=85904;a[86028|0]=($d[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[21324]=87420;c[85300>>2]=87440;VH(85300|0,85984);c[85372>>2]=0;c[85376>>2]=-1;g=c[(c[(c[21324]|0)+ -12>>2]|0)+85320>>2]|0;c[21346]=87420;c[85388>>2]=87440;VH(85388|0,g);c[85460>>2]=0;c[85464>>2]=-1;c[(c[(c[21280]|0)+ -12>>2]|0)+85192>>2]=85208;g=(c[(c[21324]|0)+ -12>>2]|0)+85300|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[21324]|0)+ -12>>2]|0)+85368>>2]=85208;QF(86032,h,85912|0);c[21368]=87380;c[85480>>2]=87400;c[85476>>2]=0;VH(85480|0,86032);c[85552>>2]=0;c[85556>>2]=-1;c[21522]=87272;DN(86092|0);h=86096|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[21522]=86192;c[86120>>2]=j;EN(e,86092|0);j=HN(e,90008)|0;h=j;FN(e);c[86124>>2]=h;c[86128>>2]=85920;a[86132|0]=($d[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[21390]=87460;c[85564>>2]=87480;VH(85564|0,86088);c[85636>>2]=0;c[85640>>2]=-1;c[21534]=87272;DN(86140|0);h=86144|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[21534]=86192;c[86168>>2]=l;EN(d,86140|0);l=HN(d,90008)|0;h=l;FN(d);c[86172>>2]=h;c[86176>>2]=85928;a[86180|0]=($d[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[21412]=87460;c[85652>>2]=87480;VH(85652|0,86136);c[85724>>2]=0;c[85728>>2]=-1;h=c[(c[(c[21412]|0)+ -12>>2]|0)+85672>>2]|0;c[21434]=87460;c[85740>>2]=87480;VH(85740|0,h);c[85812>>2]=0;c[85816>>2]=-1;c[(c[(c[21368]|0)+ -12>>2]|0)+85544>>2]=85560;h=(c[(c[21412]|0)+ -12>>2]|0)+85652|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[21412]|0)+ -12>>2]|0)+85720>>2]=85560;i=b;return}function JF(a){a=a|0;a=i;TI(85208)|0;TI(85384)|0;_I(85560)|0;_I(85736)|0;i=a;return}function KF(a){a=a|0;var b=0;b=i;c[a>>2]=87272;FN(a+4|0);i=b;return}function LF(a){a=a|0;var b=0;b=i;c[a>>2]=87272;FN(a+4|0);iR(a);i=b;return}function MF(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=HN(d,90008)|0;d=f;c[b+36>>2]=d;a[b+44|0]=($d[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function NF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ne[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((nc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((md(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function OF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=nc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((me[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function PF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((nc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=pe[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((nc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((nc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function QF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=87272;j=b+4|0;DN(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=86304;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;EN(g,j);j=HN(g,90008)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=$d[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=($d[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){PM(86400)}else{FN(g);i=f;return}}function RF(a){a=a|0;var b=0;b=i;c[a>>2]=87272;FN(a+4|0);i=b;return}function SF(a){a=a|0;var b=0;b=i;c[a>>2]=87272;FN(a+4|0);iR(a);i=b;return}function TF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=HN(d,90008)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=$d[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=($d[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){PM(86400)}else{i=e;return}}function UF(a){a=a|0;var b=0,c=0;b=i;c=XF(a,0)|0;i=b;return c|0}function VF(a){a=a|0;var b=0,c=0;b=i;c=XF(a,1)|0;i=b;return c|0}function WF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=pe[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((id(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function XF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Zc(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=pe[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Zc(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((id(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function YF(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);i=b;return}function ZF(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);iR(a);i=b;return}function _F(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=HN(d,9e4)|0;d=f;c[b+36>>2]=d;a[b+44|0]=($d[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function $F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ne[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((nc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((md(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function aG(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=nc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((me[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function bG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((nc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=pe[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((nc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((nc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function cG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=87208;j=b+4|0;DN(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=86560;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;EN(g,j);j=HN(g,9e4)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=$d[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=($d[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){PM(86400)}else{FN(g);i=f;return}}function dG(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);i=b;return}function eG(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);iR(a);i=b;return}function fG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=HN(d,9e4)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=$d[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=($d[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){PM(86400)}else{i=e;return}}function gG(a){a=a|0;var b=0,c=0;b=i;c=jG(a,0)|0;i=b;return c|0}function hG(a){a=a|0;var b=0,c=0;b=i;c=jG(a,1)|0;i=b;return c|0}function iG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=pe[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((id(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function jG(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Zc(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=pe[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Zc(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((id(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function kG(){var a=0;a=i;IF(0);Qd(170,85824,q|0)|0;i=a;return}function lG(a){a=a|0;i=i;return}function mG(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function nG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}Yd[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function oG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=86704;e=ER(b|0)|0;f=hR(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;GR(g|0,b|0,e+1|0)|0;i=d;return}function pG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=86704;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}jR((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}function qG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=86704;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);i=b;return}jR((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);i=b;return}function rG(a){a=a|0;i=i;return c[a+4>>2]|0}function sG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=86728;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=ER(f|0)|0;g=hR(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;GR(h|0,f|0,d+1|0)|0;i=e;return}function tG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=86728;e=ER(b|0)|0;f=hR(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;GR(g|0,b|0,e+1|0)|0;i=d;return}function uG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=86728;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}jR((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}function vG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=86728;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);i=b;return}jR((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);i=b;return}function wG(a){a=a|0;i=i;return c[a+4>>2]|0}function xG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=86704;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}jR((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}function yG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=86704;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}jR((c[d>>2]|0)+ -12|0);g=a;h=g;wb(h|0);j=a;iR(j);i=b;return}function zG(a){a=a|0;i=i;return}function AG(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function BG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;se[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function CG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function DG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Nd(e|0)|0;e=ER(f|0)|0;if(e>>>0>4294967279){JG(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;GR(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=gR(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;GR(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function EG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{oH(e,86944,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;se[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}oH(e,o,p)|0;if((a[g]&1)==0){break}iR(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function FG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=ER(e|0)|0;if(j>>>0>4294967279){JG(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=gR(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}GR(k|0,e|0,j|0)|0;a[k+j|0]=0;EG(g,d,h);sG(b,g);if(!((a[g]&1)==0)){iR(c[g+8>>2]|0)}if(!((a[h]&1)==0)){iR(c[h+8>>2]|0)}c[b>>2]=86960;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function GG(a){a=a|0;var b=0;b=i;vG(a);iR(a);i=b;return}function HG(a){a=a|0;var b=0;b=i;vG(a);i=b;return}function IG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;pc(87096)|0;if((c[a>>2]|0)==1){do{fd(87120,87096)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;cc(87096)|0;Yd[d&255](b);pc(87096)|0;c[a>>2]=-1;cc(87096)|0;Wc(87120)|0;i=e;return}else{cc(87096)|0;i=e;return}}function JG(a){a=a|0;a=Ac(8)|0;oG(a,87168);c[a>>2]=86784;Kd(a|0,86824,41)}function KG(a){a=a|0;a=Ac(8)|0;oG(a,87168);c[a>>2]=86848;Kd(a|0,86888,41)}function LG(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function MG(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function NG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){JG(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=gR(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}GR(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function OG(b){b=b|0;i=i;return(a[b]&1)!=0|0}function PG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){JG(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=gR(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}GR(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function QG(a){a=a|0;i=i;return a|0}function RG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=ER(d|0)|0;if(f>>>0>4294967279){JG(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;GR(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=gR(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;GR(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function SG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){JG(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=gR(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}IR(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function TG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){JG(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;IR(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=gR(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;IR(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function UG(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){KG(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){JG(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;GR(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=gR(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;GR(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function VG(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function WG(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function XG(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}iR(c[b+8>>2]|0);i=d;return}function YG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}pH(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}HR(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function ZG(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=_G(a,b)|0;i=c;return d|0}function _G(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=ER(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}pH(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}HR(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function $G(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function aH(a){a=a|0;i=i;return a+1|0}function bH(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function cH(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function dH(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function eH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){fH(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function fH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){qH(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}IR(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function gH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){fH(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function hH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){JG(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=gR(f)|0}else{p=gR(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}GR(l|0,n|0,q+1|0)|0;if(o){iR(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function iH(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function jH(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function kH(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function lH(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function mH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=oH(b,g,h)|0;i=e;return d|0}function nH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){qH(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function oH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){pH(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}GR(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function pH(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){JG(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=gR(q)|0;if((g|0)!=0){GR(e|0,m|0,g|0)|0}if((j|0)!=0){GR(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){GR(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){iR(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function qH(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){JG(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=gR(p)|0;if((g|0)!=0){GR(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){GR(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}iR(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function rH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;UG(a,b,c,d,0);i=e;return}function sH(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function tH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=ER(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function uH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=zR(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function vH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=ER(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){KG(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=zR(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function wH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){JG(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;GR(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=gR(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;GR(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function xH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){JG(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=gR(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}DQ(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function yH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){JG(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=gR(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}FQ(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function zH(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}iR(c[b+8>>2]|0);i=d;return}function AH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BH(a,b,CQ(b)|0)|0;i=c;return d|0}function BH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}EH(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}EQ(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function CH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){JG(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=gR(f)|0}else{p=gR(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}DQ(l,n,q+1|0)|0;if(o){iR(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function DH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){FH(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function EH(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){JG(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=gR(q<<2)|0;p=e;if((g|0)!=0){DQ(p,m,g)|0}if((j|0)!=0){DQ(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){DQ(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){iR(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function FH(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){JG(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=gR(p<<2)|0;o=e;if((g|0)!=0){DQ(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){DQ(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}iR(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function GH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=ER(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){JG(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=gR(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}GR(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=oH(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=oH(b,m,j)|0;i=f;return}}function HH(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function IH(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function JH(a,b){a=a|0;b=b|0;var c=0;c=i;KH(a,b);i=c;return}function KH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ac(16)|0;do{if((a[87552]|0)==0){if((Wa(87552)|0)==0){break}c[21886]=88248;Qd(67,87544,q|0)|0;Pb(87552)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=87544;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];FG(b,f,87600);c[e>>2]=87568;Kd(e|0,87648,63)}function LH(a,b){a=a|0;b=b|0;var d=0;d=i;KH(a,c[a+16>>2]|b);i=d;return}function MH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=87592;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;se[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}FN(a+28|0);bR(c[e>>2]|0);bR(c[f>>2]|0);bR(c[a+48>>2]|0);bR(c[a+60>>2]|0);i=b;return}function NH(a){a=a|0;var b=0;b=i;MH(a);iR(a);i=b;return}function OH(a){a=a|0;var b=0;b=i;MH(a);i=b;return}function PH(a){a=a|0;var b=0;b=i;MH(a);i=b;return}function QH(a){a=a|0;i=i;return c[a+24>>2]|0}function RH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}EN(d,a+28|0);a=HN(d,89936)|0;f=me[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;FN(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function SH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;EN(e,a+28|0);a=HN(e,89936)|0;f=me[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;FN(e);i=d;return f|0}function TH(a,b){a=a|0;b=b|0;var c=0;c=i;EN(a,b+28|0);i=c;return}function UH(a){a=a|0;c[a>>2]=87192;i=i;return}function VH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));DN(b);i=d;return}function WH(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);iR(a);i=b;return}function XH(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);i=b;return}function YH(a){a=a|0;var b=0;b=i;c[a>>2]=87208;FN(a+4|0);i=b;return}function ZH(a,b){a=a|0;b=b|0;var c=0;c=i;EN(a,b+4|0);i=c;return}function _H(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=$d[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function $H(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=me[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function aI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ee[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function bI(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=87208;DN(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function cI(a){a=a|0;i=i;return c[a+8>>2]|0}function dI(a){a=a|0;i=i;return c[a+12>>2]|0}function eI(a){a=a|0;i=i;return c[a+16>>2]|0}function fI(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function gI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function hI(a){a=a|0;i=i;return c[a+20>>2]|0}function iI(a){a=a|0;i=i;return c[a+24>>2]|0}function jI(a){a=a|0;i=i;return c[a+28>>2]|0}function kI(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function lI(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function mI(a,b){a=a|0;b=b|0;i=i;return}function nI(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function oI(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function pI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function qI(a){a=a|0;i=i;return 0}function rI(a){a=a|0;i=i;return 0}function sI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=$d[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function tI(a){a=a|0;i=i;return-1}function uI(a){a=a|0;var b=0,e=0,f=0;b=i;if(($d[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function vI(a,b){a=a|0;b=b|0;i=i;return-1}function wI(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((me[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function xI(a,b){a=a|0;b=b|0;i=i;return-1}function yI(a){a=a|0;var b=0;b=i;c[a>>2]=87272;FN(a+4|0);iR(a);i=b;return}function zI(a){a=a|0;var b=0;b=i;c[a>>2]=87272;FN(a+4|0);i=b;return}function AI(a,b){a=a|0;b=b|0;i=i;return}function BI(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function CI(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function DI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function EI(a){a=a|0;i=i;return 0}function FI(a){a=a|0;i=i;return 0}function GI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=$d[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function HI(a){a=a|0;i=i;return-1}function II(a){a=a|0;var b=0,d=0,e=0;b=i;if(($d[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function JI(a,b){a=a|0;b=b|0;i=i;return-1}function KI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((me[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function LI(a,b){a=a|0;b=b|0;i=i;return-1}function MI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));DN(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function NI(a){a=a|0;var b=0;b=i;MH(a+8|0);iR(a);i=b;return}function OI(a){a=a|0;var b=0;b=i;MH(a+8|0);i=b;return}function PI(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MH(a+(d+8)|0);iR(a+d|0);i=b;return}function QI(a){a=a|0;var b=0;b=i;MH(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function RI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;SI(a,b,c);i=d;return}function SI(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){KH(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){TI(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}EN(h,e+(k+28)|0);k=HN(h,89936)|0;FN(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){$d[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!(($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;KH(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function TI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{TI(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!(($d[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;KH(b+h|0,c[b+(h+16)>>2]|1)}}while(0);gJ(e);i=d;return b|0}function UI(b){b=b|0;i=i;return(a[b]|0)!=0|0}function VI(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Bb()}}function WI(a){a=a|0;var b=0;b=i;MH(a+8|0);iR(a);i=b;return}function XI(a){a=a|0;var b=0;b=i;MH(a+8|0);i=b;return}function YI(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MH(a+(d+8)|0);iR(a+d|0);i=b;return}function ZI(a){a=a|0;var b=0;b=i;MH(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function _I(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{_I(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!(($d[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;KH(b+h|0,c[b+(h+16)>>2]|1)}}while(0);sJ(e);i=d;return b|0}function $I(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));DN(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function aJ(a){a=a|0;var b=0;b=i;MH(a+4|0);iR(a);i=b;return}function bJ(a){a=a|0;var b=0;b=i;MH(a+4|0);i=b;return}function cJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MH(a+(d+4)|0);iR(a+d|0);i=b;return}function dJ(a){a=a|0;var b=0;b=i;MH(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function eJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){TI(g)|0}a[f]=1;i=e;return}function fJ(a){a=a|0;var b=0;b=i;gJ(a);i=b;return}function gJ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(ab()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!(($d[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;KH(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function hJ(b){b=b|0;i=i;return(a[b]|0)!=0|0}function iJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=$d[b&127](a)|0;i=c;return d|0}function jJ(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){gJ(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{TI(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;EN(k,b+(p+28)|0);p=HN(k,88656)|0;m=p;FN(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){EN(h,b+(k+28)|0);r=HN(h,89936)|0;s=me[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;FN(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];fe[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){gJ(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;KH(b+l|0,c[b+(l+16)>>2]|5);gJ(j);i=e;return b|0}function kJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){gJ(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{TI(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;gJ(f);i=e;return b|0}if((me[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{gJ(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;KH(b+d|0,c[b+(d+16)>>2]|1);gJ(f);i=e;return b|0}function lJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){gJ(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){TI(k)|0}a[h]=1;if((e|0)==0){gJ(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ee[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){gJ(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;KH(b+e|0,c[b+(e+16)>>2]|1);gJ(g);i=f;return b|0}function mJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;he[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function nJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){gJ(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{TI(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];we[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){gJ(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;KH(b+f|0,c[b+(f+16)>>2]|4);gJ(h);i=e;return b|0}function oJ(a){a=a|0;var b=0;b=i;MH(a+4|0);iR(a);i=b;return}function pJ(a){a=a|0;var b=0;b=i;MH(a+4|0);i=b;return}function qJ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;MH(a+(d+4)|0);iR(a+d|0);i=b;return}function rJ(a){a=a|0;var b=0;b=i;MH(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function sJ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(ab()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!(($d[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;KH(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function tJ(a){a=a|0;i=i;return 87488}function uJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){PG(a,87504,35);i=d;return}else{DG(a,b,c);i=d;return}}function vJ(a){a=a|0;i=i;return}function wJ(a){a=a|0;var b=0;b=i;HG(a);iR(a);i=b;return}function xJ(a){a=a|0;var b=0;b=i;HG(a);i=b;return}function yJ(a){a=a|0;var b=0;b=i;MH(a);iR(a);i=b;return}function zJ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function AJ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function BJ(a){a=a|0;i=i;return}function CJ(a){a=a|0;i=i;return}function DJ(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function EJ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){JG(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=gR(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function FJ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function GJ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function HJ(a){a=a|0;i=i;return}function IJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function JJ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){JG(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=gR(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function KJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function LJ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function MJ(a){a=a|0;i=i;return}function NJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];je[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}TH(u,g);m=u;u=c[m>>2]|0;if(!((c[22484]|0)==-1)){c[p>>2]=89936;c[p+4>>2]=171;c[p+8>>2]=0;IG(89936,p,172)}p=(c[89940>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}F=u;nG(c[m>>2]|0)|0;TH(v,g);g=v;v=c[g>>2]|0;if(!((c[22520]|0)==-1)){c[o>>2]=90080;c[o+4>>2]=171;c[o+8>>2]=0;IG(90080,o,172)}o=(c[90084>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}J=v;nG(c[g>>2]|0)|0;g=w;Zd[c[(c[v>>2]|0)+24>>2]&63](g,J);Zd[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=OJ(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];XG(w+12|0);XG(w);i=k;return}



function OJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=aR(l)|0;if((n|0)!=0){o=n;p=n;break}nR()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if(($d[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!(($d[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=me[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(me[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){$d[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if(($d[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}bR(o);i=k;return _|0}function PJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QJ(a,0,k,j,f,g,h);i=b;return}function QJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;GK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}eH(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}eH(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((gK(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=CP(F,c[o>>2]|0,h,t)|0;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}function RJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SJ(a,0,k,j,f,g,h);i=b;return}function SJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;GK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}eH(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}eH(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((gK(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=BP(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}function TJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];UJ(a,0,k,j,f,g,h);i=b;return}function UJ(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;GK(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if(($d[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}eH(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}eH(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((gK(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){$d[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=AP(G,c[p>>2]|0,j,u)|0;TM(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;XG(o);XG(n);i=e;return}if(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;XG(o);XG(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;XG(o);XG(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;XG(o);XG(n);i=e;return}function VJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];WJ(a,0,k,j,f,g,h);i=b;return}function WJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;GK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}eH(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}eH(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((gK(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=zP(F,c[o>>2]|0,h,t)|0;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}function XJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];YJ(a,0,k,j,f,g,h);i=b;return}function YJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;GK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}eH(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}eH(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((gK(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=yP(F,c[o>>2]|0,h,t)|0;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;XG(n);XG(m);i=d;return}function ZJ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_J(a,0,k,j,f,g,h);i=b;return}function _J(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;GK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}eH(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}eH(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((gK(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=xP(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;XG(n);XG(m);i=d;return}function $J(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];aK(a,0,k,j,f,g,h);i=b;return}function aK(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;HK(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}eH(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eH(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((IK(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+wP(I,c[p>>2]|0,j);TM(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}function bK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];cK(a,0,k,j,f,g,h);i=b;return}function cK(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;HK(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}eH(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eH(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((IK(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+vP(I,c[p>>2]|0,j);TM(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}function dK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];eK(a,0,k,j,f,g,h);i=b;return}function eK(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;HK(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}eH(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eH(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((IK(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+uP(I,c[p>>2]|0,j);TM(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;XG(o);XG(n);i=d;return}function fK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;TH(o,g);g=o;o=c[g>>2]|0;if(!((c[22484]|0)==-1)){c[l>>2]=89936;c[l+4>>2]=171;c[l+8>>2]=0;IG(89936,l,172)}l=(c[89940>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}y=m;ve[c[(c[o>>2]|0)+32>>2]&63](o,88480,88506|0,y)|0;nG(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if(($d[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}eH(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}eH(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=($d[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((gK(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){$d[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);K=c[22456]|0;c[k>>2]=j;if((hK(E,K,88520,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!(($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;XG(p);XG(n);i=d;return}if(($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;XG(p);XG(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;XG(p);XG(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;XG(p);XG(n);i=d;return}function gK(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[88480+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[88480+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function hK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Hc(b|0)|0;b=Ua(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Hc(e|0)|0;i=f;return b|0}function iK(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function jK(a){a=a|0;i=i;return}function kK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];je[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}TH(u,g);m=u;u=c[m>>2]|0;if(!((c[22482]|0)==-1)){c[p>>2]=89928;c[p+4>>2]=171;c[p+8>>2]=0;IG(89928,p,172)}p=(c[89932>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}F=u;nG(c[m>>2]|0)|0;TH(v,g);g=v;v=c[g>>2]|0;if(!((c[22522]|0)==-1)){c[o>>2]=90088;c[o+4>>2]=171;c[o+8>>2]=0;IG(90088,o,172)}o=(c[90092>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}J=v;nG(c[g>>2]|0)|0;g=w;Zd[c[(c[v>>2]|0)+24>>2]&63](g,J);Zd[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=lK(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];zH(w+12|0);zH(w);i=k;return}function lK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=aR(l)|0;if((n|0)!=0){o=n;p=n;break}nR()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=me[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(me[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){$d[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}bR(o);i=k;return ba|0}function mK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nK(a,0,k,j,f,g,h);i=b;return}function nK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;JK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}eH(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}eH(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((FK(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=CP(I,c[o>>2]|0,h,t)|0;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}function oK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pK(a,0,k,j,f,g,h);i=b;return}function pK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;JK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}eH(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eH(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((FK(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=BP(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;XG(n);XG(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;XG(n);XG(m);i=d;return}function qK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rK(a,0,k,j,f,g,h);i=b;return}function rK(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;JK(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=$d[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}eH(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}eH(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((FK(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){$d[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=AP(J,c[p>>2]|0,j,u)|0;TM(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=$d[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;XG(o);XG(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;XG(o);XG(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;XG(o);XG(n);i=e;return}function sK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tK(a,0,k,j,f,g,h);i=b;return}function tK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;JK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}eH(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}eH(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((FK(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=zP(I,c[o>>2]|0,h,t)|0;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}function uK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];vK(a,0,k,j,f,g,h);i=b;return}function vK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;JK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}eH(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}eH(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((FK(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=yP(I,c[o>>2]|0,h,t)|0;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;XG(n);XG(m);i=d;return}function wK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xK(a,0,k,j,f,g,h);i=b;return}function xK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;JK(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}eH(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}eH(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((FK(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=xP(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;TM(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;XG(n);XG(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;XG(n);XG(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;XG(n);XG(m);i=d;return}function yK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];zK(a,0,k,j,f,g,h);i=b;return}function zK(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;KK(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}eH(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}eH(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((LK(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+wP(L,c[p>>2]|0,j);TM(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}function AK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];BK(a,0,k,j,f,g,h);i=b;return}function BK(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;KK(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}eH(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}eH(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((LK(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+vP(L,c[p>>2]|0,j);TM(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}function CK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];DK(a,0,k,j,f,g,h);i=b;return}function DK(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;KK(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}eH(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}eH(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((LK(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+uP(L,c[p>>2]|0,j);TM(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;XG(o);XG(n);i=d;return}function EK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;TH(o,g);g=o;o=c[g>>2]|0;if(!((c[22482]|0)==-1)){c[l>>2]=89928;c[l+4>>2]=171;c[l+8>>2]=0;IG(89928,l,172)}l=(c[89932>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}y=m;ve[c[(c[o>>2]|0)+48>>2]&63](o,88480,88506|0,y)|0;nG(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;eH(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}eH(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}eH(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((FK(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){$d[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);N=c[22456]|0;c[k>>2]=j;if((hK(H,N,88520,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=$d[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;XG(p);XG(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;XG(p);XG(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;XG(p);XG(n);i=d;return}function FK(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[88480+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[88480+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function GK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;TH(k,d);d=k;k=c[d>>2]|0;if(!((c[22484]|0)==-1)){c[j>>2]=89936;c[j+4>>2]=171;c[j+8>>2]=0;IG(89936,j,172)}j=(c[89940>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ac(4)|0;n=m;HQ(n);o=105496;p=128;Kd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ac(4)|0;n=m;HQ(n);o=105496;p=128;Kd(m|0,o|0,p|0)}ve[c[(c[k>>2]|0)+32>>2]&63](k,88480,88506|0,e)|0;e=c[d>>2]|0;if(!((c[22520]|0)==-1)){c[h>>2]=90080;c[h+4>>2]=171;c[h+8>>2]=0;IG(90080,h,172)}h=(c[90084>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}else{t=e;a[f]=$d[c[(c[e>>2]|0)+16>>2]&127](t)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](b,t);nG(c[d>>2]|0)|0;i=g;return}}function HK(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;TH(l,d);d=l;l=c[d>>2]|0;if(!((c[22484]|0)==-1)){c[k>>2]=89936;c[k+4>>2]=171;c[k+8>>2]=0;IG(89936,k,172)}k=(c[89940>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ac(4)|0;o=n;HQ(o);p=105496;q=128;Kd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ac(4)|0;o=n;HQ(o);p=105496;q=128;Kd(n|0,p|0,q|0)}ve[c[(c[l>>2]|0)+32>>2]&63](l,88480,88512|0,e)|0;e=c[d>>2]|0;if(!((c[22520]|0)==-1)){c[j>>2]=90080;c[j+4>>2]=171;c[j+8>>2]=0;IG(90080,j,172)}j=(c[90084>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ac(4)|0;s=r;HQ(s);t=105496;u=128;Kd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ac(4)|0;s=r;HQ(s);t=105496;u=128;Kd(r|0,t|0,u|0)}else{u=e;a[f]=$d[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=$d[c[(c[e>>2]|0)+16>>2]&127](u)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](b,u);nG(c[d>>2]|0)|0;i=h;return}}function IK(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[88480+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function JK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;TH(j,b);b=j;j=c[b>>2]|0;if(!((c[22482]|0)==-1)){c[h>>2]=89928;c[h+4>>2]=171;c[h+8>>2]=0;IG(89928,h,172)}h=(c[89932>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ac(4)|0;m=l;HQ(m);n=105496;o=128;Kd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ac(4)|0;m=l;HQ(m);n=105496;o=128;Kd(l|0,n|0,o|0)}ve[c[(c[j>>2]|0)+48>>2]&63](j,88480,88506|0,d)|0;d=c[b>>2]|0;if(!((c[22522]|0)==-1)){c[g>>2]=90088;c[g+4>>2]=171;c[g+8>>2]=0;IG(90088,g,172)}g=(c[90092>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}else{s=d;c[e>>2]=$d[c[(c[d>>2]|0)+16>>2]&127](s)|0;Zd[c[(c[d>>2]|0)+20>>2]&63](a,s);nG(c[b>>2]|0)|0;i=f;return}}function KK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;TH(k,b);b=k;k=c[b>>2]|0;if(!((c[22482]|0)==-1)){c[j>>2]=89928;c[j+4>>2]=171;c[j+8>>2]=0;IG(89928,j,172)}j=(c[89932>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ac(4)|0;n=m;HQ(n);o=105496;p=128;Kd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ac(4)|0;n=m;HQ(n);o=105496;p=128;Kd(m|0,o|0,p|0)}ve[c[(c[k>>2]|0)+48>>2]&63](k,88480,88512|0,d)|0;d=c[b>>2]|0;if(!((c[22522]|0)==-1)){c[h>>2]=90088;c[h+4>>2]=171;c[h+8>>2]=0;IG(90088,h,172)}h=(c[90092>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}else{t=d;c[e>>2]=$d[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=$d[c[(c[d>>2]|0)+16>>2]&127](t)|0;Zd[c[(c[d>>2]|0)+20>>2]&63](a,t);nG(c[b>>2]|0)|0;i=g;return}}function LK(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[88480+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function MK(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function NK(a){a=a|0;i=i;return}function OK(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];he[p&31](b,d,k,f,g,q);i=j;return}TH(n,f);f=n;n=c[f>>2]|0;if(!((c[22520]|0)==-1)){c[l>>2]=90080;c[l+4>>2]=171;c[l+8>>2]=0;IG(90080,l,172)}l=(c[90084>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ac(4)|0;u=t;HQ(u);v=105496;w=128;Kd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ac(4)|0;u=t;HQ(u);v=105496;w=128;Kd(t|0,v|0,w|0)}w=n;nG(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Zd[c[f+24>>2]&63](o,w)}else{Zd[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((me[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];XG(o);i=j;return}function PK(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=88728;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);v=c[22456]|0;c[k>>2]=h;h=QK(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TH(q,f);RK(w,y,k,z,o,p,q);nG(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];vD(b,j,z,e,o,f,g);i=d;return}function QK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Hc(d|0)|0;d=jc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Hc(f|0)|0;i=g;return d|0}function RK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[22484]|0)==-1)){c[m>>2]=89936;c[m+4>>2]=171;c[m+8>>2]=0;IG(89936,m,172)}m=(c[89940>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[22520]|0)==-1)){c[l>>2]=90080;c[l+4>>2]=171;c[l+8>>2]=0;IG(90080,l,172)}l=(c[90084>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ve[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=me[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=me[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=me[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=me[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;XG(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;XG(n);i=k;return}}function SK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);w=c[22456]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=QK(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TH(r,f);RK(x,z,l,A,p,q,r);nG(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];vD(b,k,A,e,p,f,g);i=d;return}function TK(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=88728;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);v=c[22456]|0;c[k>>2]=h;h=QK(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TH(q,f);RK(w,y,k,z,o,p,q);nG(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];vD(b,j,z,e,o,f,g);i=d;return}function UK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);w=c[22456]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=QK(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TH(r,f);RK(x,z,l,A,p,q,r);nG(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];vD(b,k,A,e,p,f,g);i=d;return}function VK(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QK(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QK(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[89832]|0)==0;if(F){do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WK(s,r,z,n)|0}else{do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);o=c[22456]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WK(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nR()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aR(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}nR()}}while(0);TH(w,f);XK(N,L,G,P,u,v,w);nG(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];vD(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bR(O)}if((J|0)==0){i=d;return}bR(J);i=d;return}function WK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Hc(b|0)|0;b=gc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Hc(e|0)|0;i=f;return b|0}function XK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[22484]|0)==-1)){c[m>>2]=89936;c[m+4>>2]=171;c[m+8>>2]=0;IG(89936,m,172)}m=(c[89940>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[22520]|0)==-1)){c[l>>2]=90080;c[l+4>>2]=171;c[l+8>>2]=0;IG(90080,l,172)}l=(c[90084>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=me[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=me[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=me[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);w=A+1|0;if((Sc(l<<24>>24|0,c[22456]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);l=D+1|0;if((Md(A<<24>>24|0,c[22456]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ve[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=me[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=me[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=$d[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);ve[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;XG(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;XG(n);i=k;return}function YK(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QK(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QK(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[89832]|0)==0;if(F){do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WK(s,r,z,n)|0}else{do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);o=c[22456]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WK(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nR()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aR(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}nR()}}while(0);TH(w,f);XK(N,L,G,P,u,v,w);nG(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];vD(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bR(O)}if((J|0)==0){i=d;return}bR(J);i=d;return}function ZK(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=88736;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);s=c[22456]|0;c[k>>2]=h;h=QK(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;TH(p,f);r=p;p=c[r>>2]|0;if(!((c[22484]|0)==-1)){c[l>>2]=89936;c[l+4>>2]=171;c[l+8>>2]=0;IG(89936,l,172)}l=(c[89940>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}nG(c[r>>2]|0)|0;ve[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];vD(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];vD(b,j,u,z,m,f,g);I=j;i=d;return}function _K(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function $K(a){a=a|0;i=i;return}function aL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];he[p&31](b,d,k,f,g,q);i=j;return}TH(n,f);f=n;n=c[f>>2]|0;if(!((c[22522]|0)==-1)){c[l>>2]=90088;c[l+4>>2]=171;c[l+8>>2]=0;IG(90088,l,172)}l=(c[90092>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ac(4)|0;u=t;HQ(u);v=105496;w=128;Kd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ac(4)|0;u=t;HQ(u);v=105496;w=128;Kd(t|0,v|0,w|0)}w=n;nG(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Zd[c[f+24>>2]&63](o,w)}else{Zd[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=me[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];zH(o);i=j;return}function bL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=88728;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);v=c[22456]|0;c[k>>2]=h;h=QK(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TH(q,f);cL(w,y,k,z,o,p,q);nG(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];dL(b,j,z,e,o,f,g);i=d;return}



function XM(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;_M(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=173;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 3:{P=a[y]|0;R=(P&1)==0;if(R){_=(P&255)>>>1}else{_=c[D>>2]|0}$=a[z]|0;aa=($&1)==0;if(aa){ba=($&255)>>>1}else{ba=c[e>>2]|0}if((_|0)==(0-ba|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}if(R){ha=(P&255)>>>1}else{ha=c[D>>2]|0}do{if((ha|0)!=0){if(aa){ia=($&255)>>>1}else{ia=c[e>>2]|0}if((ia|0)==0){break}ja=c[g>>2]|0;ka=c[ja+12>>2]|0;if((ka|0)==(c[ja+16>>2]|0)){la=$d[c[(c[ja>>2]|0)+36>>2]&127](ja)|0;ma=la;na=a[y]|0}else{ma=c[ka>>2]|0;na=P}ka=c[g>>2]|0;la=ka+12|0;ja=c[la>>2]|0;oa=(ja|0)==(c[ka+16>>2]|0);if((ma|0)==(c[((na&1)==0?D:c[E>>2]|0)>>2]|0)){if(oa){$d[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=ja+4}la=a[y]|0;if((la&1)==0){pa=(la&255)>>>1}else{pa=c[D>>2]|0}ca=M;da=r;ea=L;fa=pa>>>0>1?y:N;ga=O;break b}if(oa){qa=$d[c[(c[ka>>2]|0)+36>>2]&127](ka)|0}else{qa=c[ja>>2]|0}if((qa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}ja=c[g>>2]|0;ka=ja+12|0;oa=c[ka>>2]|0;if((oa|0)==(c[ja+16>>2]|0)){$d[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[ka>>2]=oa+4}a[k]=1;oa=a[z]|0;if((oa&1)==0){ra=(oa&255)>>>1}else{ra=c[e>>2]|0}ca=M;da=r;ea=L;fa=ra>>>0>1?z:N;ga=O;break b}}while(0);if(R){sa=(P&255)>>>1}else{sa=c[D>>2]|0}aa=c[g>>2]|0;oa=c[aa+12>>2]|0;ka=(oa|0)==(c[aa+16>>2]|0);if((sa|0)==0){if(ka){ja=$d[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;ta=ja;ua=a[z]|0}else{ta=c[oa>>2]|0;ua=$}if((ta|0)!=(c[((ua&1)==0?e:c[f>>2]|0)>>2]|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}ja=c[g>>2]|0;la=ja+12|0;va=c[la>>2]|0;if((va|0)==(c[ja+16>>2]|0)){$d[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[la>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){wa=(va&255)>>>1}else{wa=c[e>>2]|0}ca=M;da=r;ea=L;fa=wa>>>0>1?z:N;ga=O;break b}if(ka){ka=$d[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;xa=ka;ya=a[y]|0}else{xa=c[oa>>2]|0;ya=P}if((xa|0)!=(c[((ya&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=c[g>>2]|0;ka=oa+12|0;aa=c[ka>>2]|0;if((aa|0)==(c[oa+16>>2]|0)){$d[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[ka>>2]=aa+4}aa=a[y]|0;if((aa&1)==0){za=(aa&255)>>>1}else{za=c[D>>2]|0}ca=M;da=r;ea=L;fa=za>>>0>1?y:N;ga=O;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}aa=c[g>>2]|0;ka=c[aa+12>>2]|0;if((ka|0)==(c[aa+16>>2]|0)){Aa=$d[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Aa=c[ka>>2]|0}if(!(ee[c[(c[l>>2]|0)+12>>2]&63](l,8192,Aa)|0)){T=27;break a}ka=c[g>>2]|0;aa=ka+12|0;oa=c[aa>>2]|0;if((oa|0)==(c[ka+16>>2]|0)){Ba=$d[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[aa>>2]=oa+4;Ba=c[oa>>2]|0}DH(A,Ba);T=28;break};case 4:{oa=M;aa=r;ka=L;va=0;la=O;c:while(1){ja=c[g>>2]|0;do{if((ja|0)==0){Ca=1}else{Da=c[ja+12>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){Ea=$d[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Ea=c[Da>>2]|0}if((Ea|0)==-1){c[g>>2]=0;Ca=1;break}else{Ca=(c[g>>2]|0)==0;break}}}while(0);ja=c[b>>2]|0;do{if((ja|0)==0){T=188}else{Da=c[ja+12>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){Fa=$d[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Fa=c[Da>>2]|0}if((Fa|0)==-1){c[b>>2]=0;T=188;break}else{if(Ca){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(Ca){break}}ja=c[g>>2]|0;Da=c[ja+12>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){Ga=$d[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Ga=c[Da>>2]|0}if(ee[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ga)|0){Da=c[n>>2]|0;if((Da|0)==(c[q>>2]|0)){$M(m,n,q);Ha=c[n>>2]|0}else{Ha=Da}c[n>>2]=Ha+4;c[Ha>>2]=Ga;Ia=oa;Ja=aa;Ka=ka;La=va+1|0;Ma=la}else{Da=a[w]|0;if((Da&1)==0){Na=(Da&255)>>>1}else{Na=c[K>>2]|0}if((Na|0)==0|(va|0)==0){break}if((Ga|0)!=(c[v>>2]|0)){break}if((aa|0)==(ka|0)){Da=aa-oa|0;ja=Da>>>0<2147483647?Da<<1:-1;if((la|0)!=173){Oa=oa}else{Oa=0}Pa=dR(Oa,ja)|0;if((Pa|0)==0){T=206;break a}Qa=Pa;Ra=Pa+(Da>>2<<2)|0;Sa=Pa+(ja>>>2<<2)|0;Ta=148}else{Qa=oa;Ra=aa;Sa=ka;Ta=la}c[Ra>>2]=va;Ia=Qa;Ja=Ra+4|0;Ka=Sa;La=0;Ma=Ta}ja=c[g>>2]|0;Pa=ja+12|0;Da=c[Pa>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){$d[c[(c[ja>>2]|0)+40>>2]&127](ja)|0;oa=Ia;aa=Ja;ka=Ka;va=La;la=Ma;continue}else{c[Pa>>2]=Da+4;oa=Ia;aa=Ja;ka=Ka;va=La;la=Ma;continue}}if((oa|0)==(aa|0)|(va|0)==0){Ua=oa;Va=aa;Wa=ka;Xa=la}else{if((aa|0)==(ka|0)){P=aa-oa|0;$=P>>>0<2147483647?P<<1:-1;if((la|0)!=173){Ya=oa}else{Ya=0}R=dR(Ya,$)|0;if((R|0)==0){T=217;break a}Za=R;_a=R+(P>>2<<2)|0;$a=R+($>>>2<<2)|0;ab=148}else{Za=oa;_a=aa;$a=ka;ab=la}c[_a>>2]=va;Ua=Za;Va=_a+4|0;Wa=$a;Xa=ab}$=c[B>>2]|0;if(($|0)>0){R=c[g>>2]|0;do{if((R|0)==0){bb=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){cb=$d[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{cb=c[P>>2]|0}if((cb|0)==-1){c[g>>2]=0;bb=1;break}else{bb=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){db=$d[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{db=c[va>>2]|0}if((db|0)==-1){c[b>>2]=0;T=234;break}else{if(bb){eb=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(bb){T=240;break a}else{eb=0}}R=c[g>>2]|0;va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){fb=$d[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{fb=c[va>>2]|0}if((fb|0)!=(c[u>>2]|0)){T=240;break a}va=c[g>>2]|0;R=va+12|0;la=c[R>>2]|0;if((la|0)==(c[va+16>>2]|0)){$d[c[(c[va>>2]|0)+40>>2]&127](va)|0;gb=eb;hb=$;ib=eb}else{c[R>>2]=la+4;gb=eb;hb=$;ib=eb}while(1){la=c[g>>2]|0;do{if((la|0)==0){jb=1}else{R=c[la+12>>2]|0;if((R|0)==(c[la+16>>2]|0)){kb=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{kb=c[R>>2]|0}if((kb|0)==-1){c[g>>2]=0;jb=1;break}else{jb=(c[g>>2]|0)==0;break}}}while(0);do{if((ib|0)==0){lb=gb;T=257}else{la=c[ib+12>>2]|0;if((la|0)==(c[ib+16>>2]|0)){mb=$d[c[(c[ib>>2]|0)+36>>2]&127](ib)|0}else{mb=c[la>>2]|0}if((mb|0)==-1){c[b>>2]=0;lb=0;T=257;break}else{if(jb^(gb|0)==0){nb=gb;ob=gb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(jb){T=263;break a}else{nb=lb;ob=0}}la=c[g>>2]|0;R=c[la+12>>2]|0;if((R|0)==(c[la+16>>2]|0)){pb=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{pb=c[R>>2]|0}if(!(ee[c[(c[l>>2]|0)+12>>2]&63](l,2048,pb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){$M(m,n,q)}R=c[g>>2]|0;la=c[R+12>>2]|0;if((la|0)==(c[R+16>>2]|0)){qb=$d[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{qb=c[la>>2]|0}la=c[n>>2]|0;c[n>>2]=la+4;c[la>>2]=qb;la=hb+ -1|0;c[B>>2]=la;R=c[g>>2]|0;va=R+12|0;ka=c[va>>2]|0;if((ka|0)==(c[R+16>>2]|0)){$d[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[va>>2]=ka+4}if((la|0)>0){gb=nb;hb=la;ib=ob}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ca=Ua;da=Va;ea=Wa;fa=N;ga=Xa}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){rb=(a[J]|0)!=0}else{rb=0}if(!(F|rb)){ca=M;da=r;ea=L;fa=0;ga=O;break b}}$=a[x]|0;la=($&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){sb=V;tb=V;ub=$;vb=la}else{if((d[s+(o+ -1)|0]|0)<2){wb=$;xb=la}else{sb=V;tb=V;ub=$;vb=la;break}while(1){if((wb&1)==0){yb=h;zb=(wb&255)>>>1}else{yb=c[G>>2]|0;zb=c[h>>2]|0}if((xb|0)==(yb+(zb<<2)|0)){Ab=wb;break}if(!(ee[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[xb>>2]|0)|0)){T=129;break}wb=a[x]|0;xb=xb+4|0}if((T|0)==129){T=0;Ab=a[x]|0}ka=(Ab&1)==0;va=xb-(ka?h:c[G>>2]|0)>>2;R=a[A]|0;aa=(R&1)==0;if(aa){Bb=(R&255)>>>1}else{Bb=c[H>>2]|0}e:do{if(!(va>>>0>Bb>>>0)){if(aa){Cb=H+(((R&255)>>>1)-va<<2)|0;Db=H;Eb=(R&255)>>>1}else{oa=c[I>>2]|0;P=c[H>>2]|0;Cb=oa+(P-va<<2)|0;Db=oa;Eb=P}P=Db+(Eb<<2)|0;if((Cb|0)==(P|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}else{Fb=ka?h:c[G>>2]|0;Gb=Cb}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}oa=Gb+4|0;if((oa|0)==(P|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}Fb=Fb+4|0;Gb=oa}}}while(0);sb=V;tb=V;ub=Ab;vb=ka?h:c[G>>2]|0}}while(0);f:while(1){if((ub&1)==0){Hb=h;Ib=(ub&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((vb|0)==(Hb+(Ib<<2)|0)){break}la=c[g>>2]|0;do{if((la|0)==0){Jb=1}else{$=c[la+12>>2]|0;if(($|0)==(c[la+16>>2]|0)){Kb=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Kb=c[$>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((tb|0)==0){Lb=sb;T=159}else{la=c[tb+12>>2]|0;if((la|0)==(c[tb+16>>2]|0)){Mb=$d[c[(c[tb>>2]|0)+36>>2]&127](tb)|0}else{Mb=c[la>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(sb|0)==0){Nb=sb;Ob=sb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}la=c[g>>2]|0;ka=c[la+12>>2]|0;if((ka|0)==(c[la+16>>2]|0)){Pb=$d[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Pb=c[ka>>2]|0}if((Pb|0)!=(c[vb>>2]|0)){break}ka=c[g>>2]|0;la=ka+12|0;$=c[la>>2]|0;if(($|0)==(c[ka+16>>2]|0)){$d[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=$+4}sb=Nb;tb=Ob;ub=a[x]|0;vb=vb+4|0}if(!F){ca=M;da=r;ea=L;fa=N;ga=O;break b}$=a[x]|0;if(($&1)==0){Qb=h;Rb=($&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((vb|0)==(Qb+(Rb<<2)|0)){ca=M;da=r;ea=L;fa=N;ga=O}else{T=174;break a}break};case 0:{T=28;break};default:{ca=M;da=r;ea=L;fa=N;ga=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){$=c[g>>2]|0;do{if(($|0)==0){Ub=1}else{la=c[$+12>>2]|0;if((la|0)==(c[$+16>>2]|0)){Vb=$d[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Vb=c[la>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{$=c[Tb+12>>2]|0;if(($|0)==(c[Tb+16>>2]|0)){Xb=$d[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[$>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ca=M;da=r;ea=L;fa=N;ga=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ca=M;da=r;ea=L;fa=N;ga=O;break g}else{Yb=Wb;Zb=0}}$=c[g>>2]|0;la=c[$+12>>2]|0;if((la|0)==(c[$+16>>2]|0)){_b=$d[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{_b=c[la>>2]|0}if(!(ee[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ca=M;da=r;ea=L;fa=N;ga=O;break g}la=c[g>>2]|0;$=la+12|0;ka=c[$>>2]|0;if((ka|0)==(c[la+16>>2]|0)){$b=$d[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[$>>2]=ka+4;$b=c[ka>>2]|0}DH(A,$b);Sb=Yb;Tb=Zb}}}while(0);ka=o+1|0;if(ka>>>0<4){L=ea;r=da;M=ca;o=ka;N=fa;O=ga}else{W=ca;X=da;Y=fa;Z=ga;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){nR()}else if((T|0)==217){nR()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==276){i:do{if((Y|0)!=0){ga=Y+4|0;fa=Y+8|0;da=1;j:while(1){ca=a[Y]|0;if((ca&1)==0){dc=(ca&255)>>>1}else{dc=c[ga>>2]|0}if(!(da>>>0<dc>>>0)){break i}ca=c[g>>2]|0;do{if((ca|0)==0){ec=1}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){fc=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ca=c[b>>2]|0;do{if((ca|0)==0){T=295}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){gc=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ca=c[g>>2]|0;N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){hc=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ga}else{ic=c[fa>>2]|0}if((hc|0)!=(c[ic+(da<<2)>>2]|0)){break}N=da+1|0;ca=c[g>>2]|0;o=ca+12|0;r=c[o>>2]|0;if((r|0)==(c[ca+16>>2]|0)){$d[c[(c[ca>>2]|0)+40>>2]&127](ca)|0;da=N;continue}else{c[o>>2]=r+4;da=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;TM(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);zH(A);zH(z);zH(y);zH(x);XG(w);if((bc|0)==0){i=p;return ac|0}Yd[cc&255](bc);i=p;return ac|0}function YM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=173;v=n+400|0;TH(q,h);n=q;w=c[n>>2]|0;if(!((c[22482]|0)==-1)){c[m>>2]=89928;c[m+4>>2]=171;c[m+8>>2]=0;IG(89928,m,172)}m=(c[89932>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ac(4)|0;z=y;HQ(z);A=105496;B=128;Kd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ac(4)|0;z=y;HQ(z);A=105496;B=128;Kd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=XM(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){DH(k,me[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=me[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);ZM(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=$d[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];nG(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Yd[c[u>>2]&255](n);i=d;return}function ZM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){FH(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function _M(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[22376]|0)==-1)){c[p>>2]=89504;c[p+4>>2]=171;c[p+8>>2]=0;IG(89504,p,172)}p=(c[89508>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}E=b;Zd[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Zd[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CH(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zH(r);Zd[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CH(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zH(s);c[f>>2]=$d[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=$d[c[(c[b>>2]|0)+16>>2]&127](E)|0;Zd[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hH(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XG(t);Zd[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}CH(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zH(u);F=$d[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[22360]|0)==-1)){c[o>>2]=89440;c[o+4>>2]=171;c[o+8>>2]=0;IG(89440,o,172)}o=(c[89444>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}J=E;Zd[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Zd[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CH(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;zH(w);Zd[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CH(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;zH(x);c[f>>2]=$d[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=$d[c[(c[E>>2]|0)+16>>2]&127](J)|0;Zd[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hH(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;XG(y);Zd[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}CH(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;zH(z);F=$d[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function $M(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=173;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=dR(m,l)|0;m=a;if((a|0)==0){nR()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}Yd[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=148;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function aN(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function bN(a){a=a|0;i=i;return}function cN(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Ic(G|0,100,89688,o|0)|0;do{if(s>>>0>99){do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);o=c[22456]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=WK(r,o,89688,n)|0;o=c[r>>2]|0;if((o|0)==0){nR()}H=aR(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}nR()}else{I=0;J=0;K=q;L=s}}while(0);TH(t,g);s=t;q=c[s>>2]|0;if(!((c[22484]|0)==-1)){c[p>>2]=89936;c[p+4>>2]=171;c[p+8>>2]=0;IG(89936,p,172)}p=(c[89940>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ac(4)|0;N=M;HQ(N);O=105496;P=128;Kd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ac(4)|0;N=M;HQ(N);O=105496;P=128;Kd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;ve[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;dN(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=aR(V)|0;if((T|0)!=0){W=T;X=T;break}nR()}else{W=0;X=t}}while(0);eN(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];vD(b,m,X,e,D,g,j);if((W|0)!=0){bR(W)}XG(A);XG(z);XG(y);nG(c[s>>2]|0)|0;if((J|0)!=0){bR(J)}if((I|0)==0){i=d;return}bR(I);i=d;return}function dN(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[22344]|0)==-1)){c[p>>2]=89376;c[p+4>>2]=171;c[p+8>>2]=0;IG(89376,p,172)}p=(c[89380>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ac(4)|0;I=H;HQ(I);J=105496;K=128;Kd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ac(4)|0;I=H;HQ(I);J=105496;K=128;Kd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Zd[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Zd[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hH(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;XG(s)}else{Zd[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Zd[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hH(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XG(v)}a[g]=$d[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=$d[c[(c[e>>2]|0)+16>>2]&127](K)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hH(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XG(w);Zd[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hH(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XG(x);L=$d[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[22328]|0)==-1)){c[o>>2]=89312;c[o+4>>2]=171;c[o+8>>2]=0;IG(89312,o,172)}o=(c[89316>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ac(4)|0;N=M;HQ(N);O=105496;P=128;Kd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ac(4)|0;N=M;HQ(N);O=105496;P=128;Kd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Zd[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Zd[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hH(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;XG(A)}else{Zd[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Zd[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hH(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;XG(D)}a[g]=$d[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=$d[c[(c[G>>2]|0)+16>>2]&127](P)|0;Zd[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hH(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;XG(E);Zd[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hH(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;XG(F);L=$d[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function eN(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){N=(J&255)>>>1}else{N=c[A>>2]|0}if((N|0)==0|x){L=H;break a}if(I){O=y;P=(J&255)>>>1}else{O=c[z>>2]|0;P=c[A>>2]|0}J=O+P|0;I=c[f>>2]|0;if((O|0)==(J|0)){Q=I}else{R=I;I=O;while(1){a[R]=a[I]|0;S=I+1|0;T=R+1|0;if((S|0)==(J|0)){Q=T;break}else{I=S;R=T}}}c[f>>2]=Q;L=H;break};case 4:{R=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){J=I;while(1){T=a[J]|0;if(!(T<<24>>24>-1)){U=J;break b}S=J+1|0;if((b[(c[F>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){U=J;break b}if(S>>>0<j>>>0){J=S}else{U=S;break}}}else{U=I}}while(0);J=U;if(B){if(U>>>0>I>>>0){S=I+(0-J)|0;J=S>>>0<G>>>0?G:S;S=J+s|0;T=R;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=T+1;a[T]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>I>>>0&Z)){break}T=c[f>>2]|0;W=Y;V=X}V=U+J|0;if(Z){_=V;$=S;aa=32}else{ba=0;ca=V;da=S}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=me[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;T=da;while(1){a[W]=ba;X=T+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){T=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(I|0)){W=me[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;T=c[f>>2]|0;c[f>>2]=T+1;a[T]=W}else{W=a[p]|0;T=(W&1)==0;if(T){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(T){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){T=c[f>>2]|0;c[f>>2]=T+1;a[T]=o;T=ja+1|0;W=a[p]|0;S=(W&1)==0;if(S){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(T>>>0<ma>>>0)){na=ia;oa=T;pa=0;break}if(S){qa=C}else{qa=c[D>>2]|0}if((a[qa+T|0]|0)==127){na=-1;oa=T;pa=0;break}if(S){ra=C}else{ra=c[D>>2]|0}na=a[ra+T|0]|0;oa=T;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);T=ha+ -1|0;S=a[T]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=S;if((T|0)==(I|0)){break}else{ha=T;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((R|0)==(V|0)){L=I;break a}T=V+ -1|0;if(T>>>0>R>>>0){sa=R;ta=T}else{L=I;break a}while(1){T=a[sa]|0;a[sa]=a[ta]|0;a[ta]=T;T=sa+1|0;V=ta+ -1|0;if(T>>>0<V>>>0){ta=V;sa=T}else{L=I;break}}break};case 1:{c[e>>2]=c[f>>2];I=me[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=I;L=H;break};default:{L=H}}}while(0);I=h+1|0;if(I>>>0<4){H=L;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function fN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;TH(m,g);z=m;A=c[z>>2]|0;if(!((c[22484]|0)==-1)){c[l>>2]=89936;c[l+4>>2]=171;c[l+8>>2]=0;IG(89936,l,172)}l=(c[89940>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(me[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;dN(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=aR(P)|0;if((N|0)!=0){Q=N;R=N;break}nR()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}eN(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];vD(b,k,R,e,w,g,h);if((Q|0)==0){XG(t);XG(s);XG(r);U=c[z>>2]|0;V=U;W=V;X=nG(W)|0;i=d;return}bR(Q);XG(t);XG(s);XG(r);U=c[z>>2]|0;V=U;W=V;X=nG(W)|0;i=d;return}function gN(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function hN(a){a=a|0;i=i;return}function iN(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Ic(G|0,100,89688,o|0)|0;do{if(s>>>0>99){do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);o=c[22456]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=WK(r,o,89688,n)|0;o=c[r>>2]|0;if((o|0)==0){nR()}H=aR(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}nR()}else{J=0;K=0;L=q;M=s}}while(0);TH(t,g);s=t;q=c[s>>2]|0;if(!((c[22482]|0)==-1)){c[p>>2]=89928;c[p+4>>2]=171;c[p+8>>2]=0;IG(89928,p,172)}p=(c[89932>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ac(4)|0;O=N;HQ(O);P=105496;Q=128;Kd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ac(4)|0;O=N;HQ(O);P=105496;Q=128;Kd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;ve[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;jN(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=aR(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}nR()}else{X=0;Y=t}}while(0);kN(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];dL(b,m,Y,e,D,g,j);if((X|0)!=0){bR(X)}zH(A);zH(z);XG(y);nG(c[s>>2]|0)|0;if((K|0)!=0){bR(K)}if((J|0)==0){i=d;return}bR(J);i=d;return}function jN(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[22376]|0)==-1)){c[p>>2]=89504;c[p+4>>2]=171;c[p+8>>2]=0;IG(89504,p,172)}p=(c[89508>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ac(4)|0;I=H;HQ(I);J=105496;K=128;Kd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ac(4)|0;I=H;HQ(I);J=105496;K=128;Kd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Zd[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Zd[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CH(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;zH(s)}else{Zd[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Zd[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CH(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zH(v)}c[g>>2]=$d[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=$d[c[(c[e>>2]|0)+16>>2]&127](K)|0;Zd[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hH(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XG(w);Zd[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CH(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zH(x);L=$d[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[22360]|0)==-1)){c[o>>2]=89440;c[o+4>>2]=171;c[o+8>>2]=0;IG(89440,o,172)}o=(c[89444>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ac(4)|0;N=M;HQ(N);O=105496;P=128;Kd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ac(4)|0;N=M;HQ(N);O=105496;P=128;Kd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Zd[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Zd[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CH(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;zH(A)}else{Zd[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Zd[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}CH(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;zH(D)}c[g>>2]=$d[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=$d[c[(c[G>>2]|0)+16>>2]&127](P)|0;Zd[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hH(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;XG(E);Zd[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}CH(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;zH(F);L=$d[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function kN(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){F=E;while(1){G=F+4|0;if(!(ee[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[F>>2]|0)|0)){H=F;break b}if(G>>>0<h>>>0){F=G}else{H=G;break}}}else{H=E}}while(0);if(y){do{if(H>>>0>E>>>0){F=c[e>>2]|0;G=H;I=r;while(1){J=G+ -4|0;K=F+4|0;c[F>>2]=c[J>>2];L=I+ -1|0;M=(L|0)>0;if(J>>>0>E>>>0&M){I=L;G=J;F=K}else{break}}c[e>>2]=K;if(M){N=J;O=L;P=34;break}F=c[e>>2]|0;c[e>>2]=F+4;Q=F;R=J}else{N=H;O=r;P=34}}while(0);do{if((P|0)==34){P=0;F=me[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;G=c[e>>2]|0;I=G+4|0;c[e>>2]=I;if((O|0)>0){S=I;T=G;U=O}else{Q=G;R=N;break}while(1){c[T>>2]=F;I=U+ -1|0;if((I|0)>0){U=I;T=S;S=S+4|0}else{break}}c[e>>2]=G+(O+1<<2);Q=G+(O<<2)|0;R=N}}while(0);c[Q>>2]=m;V=R}else{V=H}if((V|0)==(E|0)){F=me[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;I=c[e>>2]|0;W=I+4|0;c[e>>2]=W;c[I>>2]=F;X=W}else{W=a[o]|0;F=(W&1)==0;if(F){Y=(W&255)>>>1}else{Y=c[B>>2]|0}if((Y|0)==0){Z=V;_=-1;$=0;aa=0}else{if(F){ba=z}else{ba=c[A>>2]|0}Z=V;_=a[ba]|0;$=0;aa=0}while(1){F=c[e>>2]|0;do{if((aa|0)==(_|0)){W=F+4|0;c[e>>2]=W;c[F>>2]=n;I=$+1|0;ca=a[o]|0;da=(ca&1)==0;if(da){ea=(ca&255)>>>1}else{ea=c[B>>2]|0}if(!(I>>>0<ea>>>0)){fa=W;ga=_;ha=I;ia=0;break}if(da){ja=z}else{ja=c[A>>2]|0}if((a[ja+I|0]|0)==127){fa=W;ga=-1;ha=I;ia=0;break}if(da){ka=z}else{ka=c[A>>2]|0}fa=W;ga=a[ka+I|0]|0;ha=I;ia=0}else{fa=F;ga=_;ha=$;ia=aa}}while(0);F=Z+ -4|0;G=c[F>>2]|0;I=fa+4|0;c[e>>2]=I;c[fa>>2]=G;if((F|0)==(E|0)){X=I;break}else{Z=F;_=ga;$=ha;aa=ia+1|0}}}if((D|0)==(X|0)){la=E;break a}F=X+ -4|0;if(F>>>0>D>>>0){ma=D;na=F}else{la=E;break a}while(1){F=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=F;F=ma+4|0;I=na+ -4|0;if(F>>>0<I>>>0){na=I;ma=F}else{la=E;break}}break};case 1:{c[d>>2]=c[e>>2];E=me[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;D=c[e>>2]|0;c[e>>2]=D+4;c[D>>2]=E;la=C;break};case 0:{c[d>>2]=c[e>>2];la=C;break};case 2:{E=a[p]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0|v){la=C;break a}if(D){pa=w;qa=(E&255)>>>1}else{pa=c[x>>2]|0;qa=c[w>>2]|0}E=pa+(qa<<2)|0;D=c[e>>2]|0;if((pa|0)==(E|0)){ra=D}else{F=(pa+(qa+ -1<<2)+(0-pa)|0)>>>2;I=D;G=pa;while(1){c[I>>2]=c[G>>2];W=G+4|0;if((W|0)==(E|0)){break}I=I+4|0;G=W}ra=D+(F+1<<2)|0}c[e>>2]=ra;la=C;break};case 3:{G=a[q]|0;I=(G&1)==0;if(I){sa=(G&255)>>>1}else{sa=c[t>>2]|0}if((sa|0)==0){la=C;break a}if(I){ta=t}else{ta=c[u>>2]|0}I=c[ta>>2]|0;G=c[e>>2]|0;c[e>>2]=G+4;c[G>>2]=I;la=C;break};default:{la=C}}}while(0);I=g+1|0;if(I>>>0<4){C=la;g=I}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function lN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;TH(m,g);z=m;A=c[z>>2]|0;if(!((c[22482]|0)==-1)){c[l>>2]=89928;c[l+4>>2]=171;c[l+8>>2]=0;IG(89928,l,172)}l=(c[89932>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ac(4)|0;D=C;HQ(D);E=105496;F=128;Kd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(me[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;jN(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=aR(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}nR()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}kN(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];dL(b,k,R,e,w,g,h);if((Q|0)==0){zH(t);zH(s);XG(r);U=c[z>>2]|0;V=U;W=V;X=nG(W)|0;i=d;return}bR(Q);zH(t);zH(s);XG(r);U=c[z>>2]|0;V=U;W=V;X=nG(W)|0;i=d;return}function mN(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function nN(a){a=a|0;i=i;return}function oN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=qc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function pN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{nH(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=qd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=ER(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{XG(j);i=d;return}do{nH(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);XG(j);i=d;return}function qN(a,b){a=a|0;b=b|0;a=i;Db(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function rN(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function sN(a){a=a|0;i=i;return}function tN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=qc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function uN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=91592;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=91592|0;while(1){c[m>>2]=y;A=(pe[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{nH(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}PM(90816)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=qd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=91696;D=ER(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){XG(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=91696|0;while(1){c[q>>2]=o;h=(pe[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{DH(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){PM(90816)}else if((E|0)==25){XG(r);i=d;return}}function vN(a,b){a=a|0;b=b|0;a=i;Db(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function wN(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=90024;e=b+8|0;b=c[e>>2]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);if((b|0)==(c[22456]|0)){i=d;return}Yb(c[e>>2]|0);i=d;return}function xN(a){a=a|0;a=Ac(8)|0;oG(a,89816);c[a>>2]=86784;Kd(a|0,86824,41)}function yN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=89856;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);PG(b+144|0,89840,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[94748>>2]=0;c[23686]=88336;if(!((c[22090]|0)==-1)){c[G>>2]=88360;c[G+4>>2]=171;c[G+8>>2]=0;IG(88360,G,172)}zN(b,94744,(c[88364>>2]|0)+ -1|0);c[94740>>2]=0;c[23684]=88376;if(!((c[22100]|0)==-1)){c[F>>2]=88400;c[F+4>>2]=171;c[F+8>>2]=0;IG(88400,F,172)}zN(b,94736,(c[88404>>2]|0)+ -1|0);c[94724>>2]=0;c[23680]=89952;c[94728>>2]=0;a[94732|0]=0;F=c[(uc()|0)>>2]|0;c[94728>>2]=F;if(!((c[22484]|0)==-1)){c[E>>2]=89936;c[E+4>>2]=171;c[E+8>>2]=0;IG(89936,E,172)}zN(b,94720,(c[89940>>2]|0)+ -1|0);c[94716>>2]=0;c[23678]=90912;if(!((c[22482]|0)==-1)){c[D>>2]=89928;c[D+4>>2]=171;c[D+8>>2]=0;IG(89928,D,172)}zN(b,94712,(c[89932>>2]|0)+ -1|0);c[94708>>2]=0;c[23676]=91128;if(!((c[22500]|0)==-1)){c[C>>2]=9e4;c[C+4>>2]=171;c[C+8>>2]=0;IG(9e4,C,172)}zN(b,94704,(c[90004>>2]|0)+ -1|0);c[94692>>2]=0;c[23672]=90024;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);c[94696>>2]=c[22456];if(!((c[22502]|0)==-1)){c[B>>2]=90008;c[B+4>>2]=171;c[B+8>>2]=0;IG(90008,B,172)}zN(b,94688,(c[90012>>2]|0)+ -1|0);c[94684>>2]=0;c[23670]=91352;if(!((c[22516]|0)==-1)){c[A>>2]=90064;c[A+4>>2]=171;c[A+8>>2]=0;IG(90064,A,172)}zN(b,94680,(c[90068>>2]|0)+ -1|0);c[94676>>2]=0;c[23668]=91472;if(!((c[22518]|0)==-1)){c[z>>2]=90072;c[z+4>>2]=171;c[z+8>>2]=0;IG(90072,z,172)}zN(b,94672,(c[90076>>2]|0)+ -1|0);c[94652>>2]=0;c[23662]=90104;a[94656|0]=46;a[94657|0]=44;z=94660|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[22520]|0)==-1)){c[y>>2]=90080;c[y+4>>2]=171;c[y+8>>2]=0;IG(90080,y,172)}zN(b,94648,(c[90084>>2]|0)+ -1|0);c[94620>>2]=0;c[23654]=90144;c[94624>>2]=46;c[94628>>2]=44;y=94632|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[22522]|0)==-1)){c[x>>2]=90088;c[x+4>>2]=171;c[x+8>>2]=0;IG(90088,x,172)}zN(b,94616,(c[90092>>2]|0)+ -1|0);c[94612>>2]=0;c[23652]=88416;if(!((c[22118]|0)==-1)){c[w>>2]=88472;c[w+4>>2]=171;c[w+8>>2]=0;IG(88472,w,172)}zN(b,94608,(c[88476>>2]|0)+ -1|0);c[94604>>2]=0;c[23650]=88536;if(!((c[22148]|0)==-1)){c[v>>2]=88592;c[v+4>>2]=171;c[v+8>>2]=0;IG(88592,v,172)}zN(b,94600,(c[88596>>2]|0)+ -1|0);c[94596>>2]=0;c[23648]=88608;if(!((c[22164]|0)==-1)){c[u>>2]=88656;c[u+4>>2]=171;c[u+8>>2]=0;IG(88656,u,172)}zN(b,94592,(c[88660>>2]|0)+ -1|0);c[94588>>2]=0;c[23646]=88672;if(!((c[22180]|0)==-1)){c[t>>2]=88720;c[t+4>>2]=171;c[t+8>>2]=0;IG(88720,t,172)}zN(b,94584,(c[88724>>2]|0)+ -1|0);c[94580>>2]=0;c[23644]=89264;if(!((c[22328]|0)==-1)){c[s>>2]=89312;c[s+4>>2]=171;c[s+8>>2]=0;IG(89312,s,172)}zN(b,94576,(c[89316>>2]|0)+ -1|0);c[94572>>2]=0;c[23642]=89328;if(!((c[22344]|0)==-1)){c[r>>2]=89376;c[r+4>>2]=171;c[r+8>>2]=0;IG(89376,r,172)}zN(b,94568,(c[89380>>2]|0)+ -1|0);c[94564>>2]=0;c[23640]=89392;if(!((c[22360]|0)==-1)){c[q>>2]=89440;c[q+4>>2]=171;c[q+8>>2]=0;IG(89440,q,172)}zN(b,94560,(c[89444>>2]|0)+ -1|0);c[94556>>2]=0;c[23638]=89456;if(!((c[22376]|0)==-1)){c[p>>2]=89504;c[p+4>>2]=171;c[p+8>>2]=0;IG(89504,p,172)}zN(b,94552,(c[89508>>2]|0)+ -1|0);c[94548>>2]=0;c[23636]=89520;if(!((c[22386]|0)==-1)){c[o>>2]=89544;c[o+4>>2]=171;c[o+8>>2]=0;IG(89544,o,172)}zN(b,94544,(c[89548>>2]|0)+ -1|0);c[94540>>2]=0;c[23634]=89600;if(!((c[22406]|0)==-1)){c[n>>2]=89624;c[n+4>>2]=171;c[n+8>>2]=0;IG(89624,n,172)}zN(b,94536,(c[89628>>2]|0)+ -1|0);c[94532>>2]=0;c[23632]=89656;if(!((c[22420]|0)==-1)){c[m>>2]=89680;c[m+4>>2]=171;c[m+8>>2]=0;IG(89680,m,172)}zN(b,94528,(c[89684>>2]|0)+ -1|0);c[94524>>2]=0;c[23630]=89704;if(!((c[22432]|0)==-1)){c[l>>2]=89728;c[l+4>>2]=171;c[l+8>>2]=0;IG(89728,l,172)}zN(b,94520,(c[89732>>2]|0)+ -1|0);c[94508>>2]=0;c[23626]=88752;c[94512>>2]=88800;if(!((c[22208]|0)==-1)){c[k>>2]=88832;c[k+4>>2]=171;c[k+8>>2]=0;IG(88832,k,172)}zN(b,94504,(c[88836>>2]|0)+ -1|0);c[94492>>2]=0;c[23622]=88904;c[94496>>2]=88952;if(!((c[22246]|0)==-1)){c[j>>2]=88984;c[j+4>>2]=171;c[j+8>>2]=0;IG(88984,j,172)}zN(b,94488,(c[88988>>2]|0)+ -1|0);c[94476>>2]=0;c[23618]=90848;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);c[94480>>2]=c[22456];c[23618]=89200;if(!((c[22304]|0)==-1)){c[h>>2]=89216;c[h+4>>2]=171;c[h+8>>2]=0;IG(89216,h,172)}zN(b,94472,(c[89220>>2]|0)+ -1|0);c[94460>>2]=0;c[23614]=90848;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);c[94464>>2]=c[22456];c[23614]=89232;if(!((c[22312]|0)==-1)){c[g>>2]=89248;c[g+4>>2]=171;c[g+8>>2]=0;IG(89248,g,172)}zN(b,94456,(c[89252>>2]|0)+ -1|0);c[94452>>2]=0;c[23612]=89744;if(!((c[22442]|0)==-1)){c[f>>2]=89768;c[f+4>>2]=171;c[f+8>>2]=0;IG(89768,f,172)}zN(b,94448,(c[89772>>2]|0)+ -1|0);c[94444>>2]=0;c[23610]=89784;if((c[22452]|0)==-1){N=89808;O=89808;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=94440;zN(b,T,S);i=e;return}c[H>>2]=89808;c[H+4>>2]=171;c[H+8>>2]=0;IG(89808,H,172);N=89808;O=89808;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=94440;zN(b,T,S);i=e;return}function zN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;mG(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){EP(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}nG(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function AN(a){a=a|0;var b=0;b=i;BN(a);iR(a);i=b;return}function BN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=89856;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{nG(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}XG(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{iR(h);i=d;return}}function CN(){var b=0,d=0,e=0,f=0;b=i;if((a[89912]|0)!=0){d=89904;e=c[22476]|0;i=b;return e|0}if((Wa(89912)|0)==0){d=89904;e=c[22476]|0;i=b;return e|0}do{if((a[89888]|0)==0){if((Wa(89888)|0)==0){break}yN(94280,1);c[22468]=94280;c[22470]=89872;Pb(89888)}}while(0);f=c[c[22470]>>2]|0;c[22474]=f;mG(f);c[22476]=89896;Pb(89912);d=89904;e=c[22476]|0;i=b;return e|0}function DN(a){a=a|0;var b=0,d=0;b=i;d=c[(CN()|0)>>2]|0;c[a>>2]=d;mG(d);i=b;return}function EN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;mG(e);i=d;return}function FN(a){a=a|0;var b=0;b=i;nG(c[a>>2]|0)|0;i=b;return}function GN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=171;c[e+8>>2]=0;IG(a,e,172)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function HN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=171;c[e+8>>2]=0;IG(a,e,172)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ac(4)|0;h=g;HQ(h);j=105496;k=128;Kd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ac(4)|0;h=g;HQ(h);j=105496;k=128;Kd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function IN(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function JN(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}Yd[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function KN(a){a=a|0;var b=0;b=c[22480]|0;c[22480]=1+b;c[a+4>>2]=b+1;i=i;return}function LN(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function MN(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(uc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function NN(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(uc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function ON(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(uc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function PN(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(uc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function QN(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function RN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function SN(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function TN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function UN(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function VN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function WN(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function XN(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function YN(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=89952;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}jR(e)}}while(0);iR(b);i=d;return}function ZN(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=89952;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}jR(e);i=d;return}function _N(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function $N(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(ud()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function aO(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function bO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(zd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function cO(a,b){a=a|0;b=b|0;i=i;return b|0}function dO(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function eO(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function fO(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function gO(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function hO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function iO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function jO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function kO(a){a=a|0;i=i;return 1}function lO(a){a=a|0;i=i;return 1}function mO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function nO(a){a=a|0;i=i;return 1}function oO(a){a=a|0;var b=0;b=i;wN(a);iR(a);i=b;return}function pO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Hc(c[s>>2]|0)|0;A=gQ(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Hc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Hc(c[s>>2]|0)|0;A=fQ(u,0,d)|0;if((z|0)!=0){Hc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Hc(c[s>>2]|0)|0;G=fQ(u,r,n)|0;if((z|0)!=0){Hc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function qO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Hc(c[r>>2]|0)|0;y=cQ(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Hc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Hc(c[r>>2]|0)|0;F=bQ(x,y,1,d)|0;if((w|0)!=0){Hc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Hc(c[r>>2]|0)|0;y=bQ(q,v,z-v|0,n)|0;if((w|0)!=0){Hc(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function rO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Hc(c[b+8>>2]|0)|0;b=fQ(e,0,d)|0;if((j|0)!=0){Hc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function sO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Hc(c[d>>2]|0)|0;e=eQ(0,0,4)|0;if((a|0)!=0){Hc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Hc(a|0)|0;if((g|0)==0){f=0;break}Hc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function tO(a){a=a|0;i=i;return 0}function uO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Hc(c[k>>2]|0)|0;n=aQ(a,j-a|0,b)|0;if((m|0)!=0){Hc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function vO(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Hc(d|0)|0;if((a|0)==0){e=4;break}Hc(a|0)|0;e=4}}while(0);i=b;return e|0}function wO(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function xO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=yO(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function yO(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function zO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=AO(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function AO(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function BO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function CO(a){a=a|0;i=i;return 0}function DO(a){a=a|0;i=i;return 0}function EO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=FO(c,d,e,1114111,0)|0;i=b;return a|0}function FO(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function GO(a){a=a|0;i=i;return 4}function HO(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function IO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JO(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function JO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function KO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=LO(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function LO(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function MO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function NO(a){a=a|0;i=i;return 0}function OO(a){a=a|0;i=i;return 0}function PO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=QO(c,d,e,1114111,0)|0;i=b;return a|0}function QO(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function RO(a){a=a|0;i=i;return 4}function SO(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function TO(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function UO(a){a=a|0;var b=0;b=i;c[a>>2]=90104;XG(a+12|0);iR(a);i=b;return}function VO(a){a=a|0;var b=0;b=i;c[a>>2]=90104;XG(a+12|0);i=b;return}function WO(a){a=a|0;var b=0;b=i;c[a>>2]=90144;XG(a+16|0);iR(a);i=b;return}function XO(a){a=a|0;var b=0;b=i;c[a>>2]=90144;XG(a+16|0);i=b;return}function YO(b){b=b|0;i=i;return a[b+8|0]|0}function ZO(a){a=a|0;i=i;return c[a+8>>2]|0}function _O(b){b=b|0;i=i;return a[b+9|0]|0}function $O(a){a=a|0;i=i;return c[a+12>>2]|0}function aP(a,b){a=a|0;b=b|0;var c=0;c=i;NG(a,b+12|0);i=c;return}function bP(a,b){a=a|0;b=b|0;var c=0;c=i;NG(a,b+16|0);i=c;return}function cP(a,b){a=a|0;b=b|0;b=i;PG(a,90176,4);i=b;return}function dP(a,b){a=a|0;b=b|0;b=i;xH(a,90184,CQ(90184)|0);i=b;return}function eP(a,b){a=a|0;b=b|0;b=i;PG(a,90208,5);i=b;return}function fP(a,b){a=a|0;b=b|0;b=i;xH(a,90216,CQ(90216)|0);i=b;return}function gP(b){b=b|0;var d=0,e=0;b=i;if((a[90248]|0)!=0){d=90240;e=c[22560]|0;i=b;return e|0}if((Wa(90248)|0)==0){d=90240;e=c[22560]|0;i=b;return e|0}do{if((a[97448]|0)==0){if((Wa(97448)|0)==0){break}IR(97280,0,168)|0;Qd(174,0,q|0)|0;Pb(97448)}}while(0);_G(97280,97456)|0;_G(97292|0,97464)|0;_G(97304|0,97472)|0;_G(97316|0,97480)|0;_G(97328|0,97496)|0;_G(97340|0,97512)|0;_G(97352|0,97520)|0;_G(97364|0,97536)|0;_G(97376|0,97544)|0;_G(97388|0,97552)|0;_G(97400|0,97560)|0;_G(97412|0,97568)|0;_G(97424|0,97576)|0;_G(97436|0,97584)|0;c[22560]=97280;Pb(90248);d=90240;e=c[22560]|0;i=b;return e|0}function hP(b){b=b|0;var d=0,e=0;b=i;if((a[90264]|0)!=0){d=90256;e=c[22564]|0;i=b;return e|0}if((Wa(90264)|0)==0){d=90256;e=c[22564]|0;i=b;return e|0}do{if((a[96912]|0)==0){if((Wa(96912)|0)==0){break}IR(96744,0,168)|0;Qd(175,0,q|0)|0;Pb(96912)}}while(0);AH(96744,96920)|0;AH(96756|0,96952)|0;AH(96768|0,96984)|0;AH(96780|0,97016)|0;AH(96792|0,97056)|0;AH(96804|0,97096)|0;AH(96816|0,97128)|0;AH(96828|0,97168)|0;AH(96840|0,97184)|0;AH(96852|0,97200)|0;AH(96864|0,97216)|0;AH(96876|0,97232)|0;AH(96888|0,97248)|0;AH(96900|0,97264)|0;c[22564]=96744;Pb(90264);d=90256;e=c[22564]|0;i=b;return e|0}function iP(b){b=b|0;var d=0,e=0;b=i;if((a[90280]|0)!=0){d=90272;e=c[22568]|0;i=b;return e|0}if((Wa(90280)|0)==0){d=90272;e=c[22568]|0;i=b;return e|0}do{if((a[96520]|0)==0){if((Wa(96520)|0)==0){break}IR(96232,0,288)|0;Qd(176,0,q|0)|0;Pb(96520)}}while(0);_G(96232,96528)|0;_G(96244|0,96536)|0;_G(96256|0,96552)|0;_G(96268|0,96560)|0;_G(96280|0,96568)|0;_G(96292|0,96576)|0;_G(96304|0,96584)|0;_G(96316|0,96592)|0;_G(96328|0,96600)|0;_G(96340|0,96616)|0;_G(96352|0,96624)|0;_G(96364|0,96640)|0;_G(96376|0,96656)|0;_G(96388|0,96664)|0;_G(96400|0,96672)|0;_G(96412|0,96680)|0;_G(96424|0,96568)|0;_G(96436|0,96688)|0;_G(96448|0,96696)|0;_G(96460|0,96704)|0;_G(96472|0,96712)|0;_G(96484|0,96720)|0;_G(96496|0,96728)|0;_G(96508|0,96736)|0;c[22568]=96232;Pb(90280);d=90272;e=c[22568]|0;i=b;return e|0}function jP(b){b=b|0;var d=0,e=0;b=i;if((a[90296]|0)!=0){d=90288;e=c[22572]|0;i=b;return e|0}if((Wa(90296)|0)==0){d=90288;e=c[22572]|0;i=b;return e|0}do{if((a[95680]|0)==0){if((Wa(95680)|0)==0){break}IR(95392,0,288)|0;Qd(177,0,q|0)|0;Pb(95680)}}while(0);AH(95392,95688)|0;AH(95404|0,95720)|0;AH(95416|0,95760)|0;AH(95428|0,95784)|0;AH(95440|0,96104)|0;AH(95452|0,95808)|0;AH(95464|0,95832)|0;AH(95476|0,95856)|0;AH(95488|0,95888)|0;AH(95500|0,95928)|0;AH(95512|0,95960)|0;AH(95524|0,96e3)|0;AH(95536|0,96040)|0;AH(95548|0,96056)|0;AH(95560|0,96072)|0;AH(95572|0,96088)|0;AH(95584|0,96104)|0;AH(95596|0,96120)|0;AH(95608|0,96136)|0;AH(95620|0,96152)|0;AH(95632|0,96168)|0;AH(95644|0,96184)|0;AH(95656|0,96200)|0;AH(95668|0,96216)|0;c[22572]=95392;Pb(90296);d=90288;e=c[22572]|0;i=b;return e|0}function kP(b){b=b|0;var d=0,e=0;b=i;if((a[90312]|0)!=0){d=90304;e=c[22576]|0;i=b;return e|0}if((Wa(90312)|0)==0){d=90304;e=c[22576]|0;i=b;return e|0}do{if((a[95368]|0)==0){if((Wa(95368)|0)==0){break}IR(95080,0,288)|0;Qd(178,0,q|0)|0;Pb(95368)}}while(0);_G(95080,95376)|0;_G(95092|0,95384)|0;c[22576]=95080;Pb(90312);d=90304;e=c[22576]|0;i=b;return e|0}function lP(b){b=b|0;var d=0,e=0;b=i;if((a[90328]|0)!=0){d=90320;e=c[22580]|0;i=b;return e|0}if((Wa(90328)|0)==0){d=90320;e=c[22580]|0;i=b;return e|0}do{if((a[95040]|0)==0){if((Wa(95040)|0)==0){break}IR(94752,0,288)|0;Qd(179,0,q|0)|0;Pb(95040)}}while(0);AH(94752,95048)|0;AH(94764|0,95064)|0;c[22580]=94752;Pb(90328);d=90320;e=c[22580]|0;i=b;return e|0}function mP(b){b=b|0;var c=0;b=i;if((a[90352]|0)!=0){c=90336;i=b;return c|0}if((Wa(90352)|0)==0){c=90336;i=b;return c|0}PG(90336,90360,8);Qd(180,90336,q|0)|0;Pb(90352);c=90336;i=b;return c|0}function nP(b){b=b|0;var c=0;b=i;if((a[90392]|0)!=0){c=90376;i=b;return c|0}if((Wa(90392)|0)==0){c=90376;i=b;return c|0}xH(90376,90400,CQ(90400)|0);Qd(181,90376,q|0)|0;Pb(90392);c=90376;i=b;return c|0}function oP(b){b=b|0;var c=0;b=i;if((a[90456]|0)!=0){c=90440;i=b;return c|0}if((Wa(90456)|0)==0){c=90440;i=b;return c|0}PG(90440,90464,8);Qd(180,90440,q|0)|0;Pb(90456);c=90440;i=b;return c|0}function pP(b){b=b|0;var c=0;b=i;if((a[90496]|0)!=0){c=90480;i=b;return c|0}if((Wa(90496)|0)==0){c=90480;i=b;return c|0}xH(90480,90504,CQ(90504)|0);Qd(181,90480,q|0)|0;Pb(90496);c=90480;i=b;return c|0}function qP(b){b=b|0;var c=0;b=i;if((a[90560]|0)!=0){c=90544;i=b;return c|0}if((Wa(90560)|0)==0){c=90544;i=b;return c|0}PG(90544,90568,20);Qd(180,90544,q|0)|0;Pb(90560);c=90544;i=b;return c|0}function rP(b){b=b|0;var c=0;b=i;if((a[90608]|0)!=0){c=90592;i=b;return c|0}if((Wa(90608)|0)==0){c=90592;i=b;return c|0}xH(90592,90616,CQ(90616)|0);Qd(181,90592,q|0)|0;Pb(90608);c=90592;i=b;return c|0}function sP(b){b=b|0;var c=0;b=i;if((a[90720]|0)!=0){c=90704;i=b;return c|0}if((Wa(90720)|0)==0){c=90704;i=b;return c|0}PG(90704,90728,11);Qd(180,90704,q|0)|0;Pb(90720);c=90704;i=b;return c|0}function tP(b){b=b|0;var c=0;b=i;if((a[90760]|0)!=0){c=90744;i=b;return c|0}if((Wa(90760)|0)==0){c=90744;i=b;return c|0}xH(90744,90768,CQ(90768)|0);Qd(181,90744,q|0)|0;Pb(90760);c=90744;i=b;return c|0}function uP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Jc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);l=+yR(b,g,c[22456]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function vP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Jc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);l=+yR(b,g,c[22456]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function wP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Jc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);l=+yR(b,g,c[22456]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function xP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;do{if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0}else{if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;break}l=Jc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);n=ib(b|0,h|0,f|0,c[22456]|0)|0;o=c[l>>2]|0;if((o|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)!=34){j=n;k=J;break}c[e>>2]=4;j=-1;k=-1}}while(0);J=k;i=g;return j|0}function yP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Jc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);m=ib(b|0,h|0,f|0,c[22456]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function zP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Jc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);m=ib(b|0,h|0,f|0,c[22456]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function AP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Jc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);m=ib(b|0,h|0,f|0,c[22456]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function BP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Jc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);n=Cc(b|0,h|0,f|0,c[22456]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function CP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Jc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);m=Cc(b|0,h|0,f|0,c[22456]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function DP(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;Yd[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;Yd[h&255](a);i=b;return}}function EP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){xN(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=gR(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;GR(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{iR(h);i=e;return}}function FP(a){a=a|0;a=i;zH(95028|0);zH(95016|0);zH(95004|0);zH(94992|0);zH(94980|0);zH(94968|0);zH(94956|0);zH(94944|0);zH(94932|0);zH(94920|0);zH(94908|0);zH(94896|0);zH(94884|0);zH(94872|0);zH(94860|0);zH(94848|0);zH(94836|0);zH(94824|0);zH(94812|0);zH(94800|0);zH(94788|0);zH(94776|0);zH(94764|0);zH(94752);i=a;return}function GP(a){a=a|0;a=i;XG(95356|0);XG(95344|0);XG(95332|0);XG(95320|0);XG(95308|0);XG(95296|0);XG(95284|0);XG(95272|0);XG(95260|0);XG(95248|0);XG(95236|0);XG(95224|0);XG(95212|0);XG(95200|0);XG(95188|0);XG(95176|0);XG(95164|0);XG(95152|0);XG(95140|0);XG(95128|0);XG(95116|0);XG(95104|0);XG(95092|0);XG(95080);i=a;return}



function cL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[22482]|0)==-1)){c[m>>2]=89928;c[m+4>>2]=171;c[m+8>>2]=0;IG(89928,m,172)}m=(c[89932>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[22522]|0)==-1)){c[l>>2]=90088;c[l+4>>2]=171;c[l+8>>2]=0;IG(90088,l,172)}l=(c[90092>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ve[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=me[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=me[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=me[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=me[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;XG(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;XG(n);i=k;return}function dL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ee[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){yH(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ee[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){zH(l);break}c[m>>2]=0;c[b>>2]=0;zH(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ee[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function eL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);y=c[22456]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=QK(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TH(r,f);cL(x,z,l,A,p,q,r);nG(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];dL(b,k,A,e,p,f,g);i=d;return}function fL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=88728;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);x=c[22456]|0;c[k>>2]=h;h=QK(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;TH(q,f);cL(w,y,k,z,o,p,q);nG(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];dL(b,j,z,e,o,f,g);i=d;return}function gL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);y=c[22456]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=QK(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;TH(r,f);cL(x,z,l,A,p,q,r);nG(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];dL(b,k,A,e,p,f,g);i=d;return}function hL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QK(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QK(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[89832]|0)==0;if(F){do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WK(s,r,z,n)|0}else{do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);o=c[22456]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WK(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nR()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aR(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}nR()}}while(0);TH(w,f);iL(N,L,G,P,u,v,w);nG(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];dL(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bR(O)}if((J|0)==0){i=d;return}bR(J);i=d;return}function iL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[22482]|0)==-1)){c[m>>2]=89928;c[m+4>>2]=171;c[m+8>>2]=0;IG(89928,m,172)}m=(c[89932>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ac(4)|0;r=q;HQ(r);s=105496;t=128;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[22522]|0)==-1)){c[l>>2]=90088;c[l+4>>2]=171;c[l+8>>2]=0;IG(90088,l,172)}l=(c[90092>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ac(4)|0;v=u;HQ(v);w=105496;x=128;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=me[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=me[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=me[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);w=A+1|0;if((Sc(l<<24>>24|0,c[22456]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);l=D+1|0;if((Md(A<<24>>24|0,c[22456]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ve[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=me[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=me[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=$d[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);ve[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;XG(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;XG(n);i=k;return}function jL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=QK(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=QK(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[89832]|0)==0;if(F){do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);r=c[22456]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=WK(s,r,z,n)|0}else{do{if(o){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);o=c[22456]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=WK(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}nR()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=aR(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}nR()}}while(0);TH(w,f);iL(N,L,G,P,u,v,w);nG(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];dL(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){bR(O)}if((J|0)==0){i=d;return}bR(J);i=d;return}function kL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=88736;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);s=c[22456]|0;c[k>>2]=h;h=QK(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}TH(p,f);u=p;p=c[u>>2]|0;if(!((c[22482]|0)==-1)){c[l>>2]=89928;c[l+4>>2]=171;c[l+8>>2]=0;IG(89928,l,172)}l=(c[89932>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}nG(c[u>>2]|0)|0;u=o;ve[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];dL(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];dL(b,j,u,z,m,f,g);I=j;i=d;return}function lL(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;TH(r,h);v=r;r=c[v>>2]|0;if(!((c[22484]|0)==-1)){c[q>>2]=89936;c[q+4>>2]=171;c[q+8>>2]=0;IG(89936,q,172)}q=(c[89940>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ac(4)|0;y=x;HQ(y);z=105496;A=128;Kd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ac(4)|0;y=x;HQ(y);z=105496;A=128;Kd(x|0,z|0,A|0)}A=r;nG(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ee[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=($d[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=me[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(me[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ee[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ee[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];le[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){$d[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){$d[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!(($d[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!(($d[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function mL(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function nL(a){a=a|0;i=i;return}function oL(a){a=a|0;i=i;return 2}function pL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];lL(a,b,l,k,f,g,h,88840,88848|0);i=j;return}function qL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=$d[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];lL(b,d,m,l,g,h,j,s,q);i=k;return}function rL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TH(n,f);f=n;n=c[f>>2]|0;if(!((c[22484]|0)==-1)){c[m>>2]=89936;c[m+4>>2]=171;c[m+8>>2]=0;IG(89936,m,172)}m=(c[89940>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}s=n;nG(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=OJ(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function sL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TH(n,f);f=n;n=c[f>>2]|0;if(!((c[22484]|0)==-1)){c[m>>2]=89936;c[m+4>>2]=171;c[m+8>>2]=0;IG(89936,m,172)}m=(c[89940>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}s=n;nG(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=OJ(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function tL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;TH(m,f);f=m;m=c[f>>2]|0;if(!((c[22484]|0)==-1)){c[l>>2]=89936;c[l+4>>2]=171;c[l+8>>2]=0;IG(89936,l,172)}l=(c[89940>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ac(4)|0;p=o;HQ(p);q=105496;r=128;Kd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ac(4)|0;p=o;HQ(p);q=105496;r=128;Kd(o|0,q|0,r|0)}r=m;nG(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=yL(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function uL(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;TH(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[22484]|0)==-1)){c[ba>>2]=89936;c[ba+4>>2]=171;c[ba+8>>2]=0;IG(89936,ba,172)}ba=(c[89940>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ac(4)|0;Ga=Fa;HQ(Ga);Ha=105496;Ia=128;Kd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ac(4)|0;Ga=Fa;HQ(Ga);Ha=105496;Ia=128;Kd(Fa|0,Ha|0,Ia|0)}Ia=ca;nG(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=$d[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(OJ(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=yL(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];vL(0,e,C,h,Ia);break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];lL(ua,d,v,u,g,h,j,88888,88896|0);c[Ha>>2]=c[ua>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=yL(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];lL(ra,d,y,x,g,h,j,88880,88885|0);c[Da>>2]=c[ra>>2];break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];lL(ga,d,L,K,g,h,j,88848,88856|0);c[Da>>2]=c[ga>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=yL(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ja=Da+2e3|0}else{Ja=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ja+ -1900;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=yL(e,E,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=Ha|4;break a}break};case 104:case 66:case 98:{Ha=c[f>>2]|0;Da=d+8|0;ca=$d[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=Ha;c[P+0>>2]=c[$+0>>2];Ha=(OJ(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Ha|0)>=288){break a}c[j+16>>2]=((Ha|0)/12|0|0)%12|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=yL(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=yL(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=yL(e,M,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Da|4;break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];je[ca&63](b,d,s,r,g,h,j);i=l;return};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=yL(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=yL(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];lL(oa,d,A,z,g,h,j,88864,88875|0);c[ca>>2]=c[oa>>2];break};case 88:{ca=d+8|0;Ha=$d[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Ka=Ha+1|0;La=Ha+1|0;Ma=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Ka=Da;La=Da;Ma=c[Ha+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];lL(za,d,q,p,g,h,j,La,Ka+Ma|0);c[ca>>2]=c[za>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];wL(d,j+8|0,e,B,h,Ia);break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];lL(ja,d,J,I,g,h,j,88856,88864|0);c[ca>>2]=c[ja>>2];break};case 99:{ca=d+8|0;Ha=$d[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Na=Ha+1|0;Oa=Ha+1|0;Pa=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Na=Da;Oa=Da;Pa=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];lL(da,d,O,N,g,h,j,Oa,Na+Pa|0);c[ca>>2]=c[da>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=yL(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];xL(0,e,m,h,Ia);break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function vL(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if(($d[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){$d[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if(($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!(($d[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function wL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=$d[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=OJ(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function xL(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if(($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ee[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){$d[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function yL(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if(($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ee[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if(($d[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!(($d[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ee[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!(($d[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function zL(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;TH(p,f);t=p;p=c[t>>2]|0;if(!((c[22482]|0)==-1)){c[o>>2]=89928;c[o+4>>2]=171;c[o+8>>2]=0;IG(89928,o,172)}o=(c[89932>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ac(4)|0;w=v;HQ(w);x=105496;y=128;Kd(v|0,x|0,y|0)}y=p;nG(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ee[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ee[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=me[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(me[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ee[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ee[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];le[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ee[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=$d[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=$d[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ee[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){$d[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function AL(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function BL(a){a=a|0;i=i;return}function CL(a){a=a|0;i=i;return 2}function DL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];zL(a,b,l,k,f,g,h,88992,89024|0);i=j;return}function EL(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=$d[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];zL(b,d,m,l,g,h,j,s,q);i=k;return}function FL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TH(n,f);f=n;n=c[f>>2]|0;if(!((c[22482]|0)==-1)){c[m>>2]=89928;c[m+4>>2]=171;c[m+8>>2]=0;IG(89928,m,172)}m=(c[89932>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}s=n;nG(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=lK(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function GL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;TH(n,f);f=n;n=c[f>>2]|0;if(!((c[22482]|0)==-1)){c[m>>2]=89928;c[m+4>>2]=171;c[m+8>>2]=0;IG(89928,m,172)}m=(c[89932>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ac(4)|0;q=p;HQ(q);r=105496;s=128;Kd(p|0,r|0,s|0)}s=n;nG(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=lK(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function HL(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;TH(m,f);f=m;m=c[f>>2]|0;if(!((c[22482]|0)==-1)){c[l>>2]=89928;c[l+4>>2]=171;c[l+8>>2]=0;IG(89928,l,172)}l=(c[89932>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ac(4)|0;p=o;HQ(p);q=105496;r=128;Kd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ac(4)|0;p=o;HQ(p);q=105496;r=128;Kd(o|0,q|0,r|0)}r=m;nG(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=ML(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function IL(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;TH(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[22482]|0)==-1)){c[ba>>2]=89928;c[ba+4>>2]=171;c[ba+8>>2]=0;IG(89928,ba,172)}ba=(c[89932>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ac(4)|0;Ga=Fa;HQ(Ga);Ha=105496;Ia=128;Kd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ac(4)|0;Ga=Fa;HQ(Ga);Ha=105496;Ia=128;Kd(Fa|0,Ha|0,Ia|0)}Ia=ca;nG(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=ML(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=$d[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(lK(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];zL(ua,d,v,u,g,h,j,89160,89192|0);c[ca>>2]=c[ua>>2];break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];je[ca&63](b,d,s,r,g,h,j);i=l;return};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=ML(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];zL(ga,d,L,K,g,h,j,89024,89056|0);c[Ha>>2]=c[ga>>2];break};case 88:{Ha=d+8|0;ca=$d[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];Da=a[ca]|0;if((Da&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Da&255)>>>1}else{Da=c[ca+8>>2]|0;Ja=Da;Ka=Da;La=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];zL(za,d,q,p,g,h,j,Ka,Ja+(La<<2)|0);c[Ha>>2]=c[za>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=ML(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];KL(d,j+8|0,e,B,h,Ia);break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];zL(ja,d,J,I,g,h,j,89056,89088|0);c[ca>>2]=c[ja>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];JL(0,e,C,h,Ia);break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=ML(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 65:case 97:{Ha=c[f>>2]|0;ca=d+8|0;Da=$d[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Ha;c[Q+0>>2]=c[aa+0>>2];Ha=(lK(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((Ha|0)>=168){break a}c[j+24>>2]=((Ha|0)/12|0|0)%7|0;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Ha=ML(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Ha+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];LL(0,e,m,h,Ia);break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=ML(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=ML(e,M,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=ca|4;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=ML(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=ML(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=ML(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Ma=Ha+2e3|0}else{Ma=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Ma+ -1900;break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];zL(ra,d,y,x,g,h,j,89136,89156|0);c[Ha>>2]=c[ra>>2];break};case 114:{Ha=e;c[pa>>2]=c[Ha>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];zL(oa,d,A,z,g,h,j,89088,89132|0);c[Ha>>2]=c[oa>>2];break};case 99:{Ha=d+8|0;Da=$d[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Na=Da+4|0;Oa=Da+4|0;Pa=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Na=ca;Oa=ca;Pa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];zL(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[Ha>>2]=c[da>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function JL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ee[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){$d[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=$d[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=$d[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function KL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=$d[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=lK(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function LL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=$d[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=$d[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ee[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){$d[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=$d[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function ML(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=$d[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=$d[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=$d[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ee[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ee[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=$d[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=$d[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ee[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ee[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){$d[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function NL(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);if((f|0)==(c[22456]|0)){g=b;iR(g);i=d;return}Yb(c[e>>2]|0);g=b;iR(g);i=d;return}function OL(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);if((b|0)==(c[22456]|0)){i=d;return}Yb(c[e>>2]|0);i=d;return}function PL(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Oc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(me[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function QL(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);if((f|0)==(c[22456]|0)){g=b;iR(g);i=d;return}Yb(c[e>>2]|0);g=b;iR(g);i=d;return}function RL(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[89832]|0)==0){if((Wa(89832)|0)==0){break}c[22456]=Vb(2147483647,89840,0)|0;Pb(89832)}}while(0);if((b|0)==(c[22456]|0)){i=d;return}Yb(c[e>>2]|0);i=d;return}function SL(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;TL(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=me[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function TL(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Oc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Hc(c[g>>2]|0)|0;g=dQ(d,m,n,l)|0;if((f|0)!=0){Hc(f|0)|0}if((g|0)==-1){PM(90816)}else{c[e>>2]=d+(g<<2);i=j;return}}function UL(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function VL(a){a=a|0;i=i;return}function WL(a){a=a|0;i=i;return 127}function XL(a){a=a|0;i=i;return 127}function YL(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function ZL(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function _L(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $L(a,b){a=a|0;b=b|0;b=i;TG(a,1,45);i=b;return}function aM(a){a=a|0;i=i;return 0}function bM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function cM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function dM(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function eM(a){a=a|0;i=i;return}function fM(a){a=a|0;i=i;return 127}function gM(a){a=a|0;i=i;return 127}function hM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function iM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function jM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function kM(a,b){a=a|0;b=b|0;b=i;TG(a,1,45);i=b;return}function lM(a){a=a|0;i=i;return 0}function mM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function nM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function oM(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function pM(a){a=a|0;i=i;return}function qM(a){a=a|0;i=i;return 2147483647}function rM(a){a=a|0;i=i;return 2147483647}function sM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function tM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function vM(a,b){a=a|0;b=b|0;b=i;yH(a,1,45);i=b;return}function wM(a){a=a|0;i=i;return 0}function xM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function yM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function zM(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function AM(a){a=a|0;i=i;return}function BM(a){a=a|0;i=i;return 2147483647}function CM(a){a=a|0;i=i;return 2147483647}function DM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function EM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function FM(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function GM(a,b){a=a|0;b=b|0;b=i;yH(a,1,45);i=b;return}function HM(a){a=a|0;i=i;return 0}function IM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function JM(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function KM(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function LM(a){a=a|0;i=i;return}function MM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=173;y=o+100|0;TH(r,h);o=r;z=c[o>>2]|0;if(!((c[22484]|0)==-1)){c[n>>2]=89936;c[n+4>>2]=171;c[n+8>>2]=0;IG(89936,n,172)}n=(c[89940>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=OM(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ve[c[(c[z>>2]|0)+32>>2]&63](E,89552,89562|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=aR(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}nR()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[89552+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((pd(p|0,89568,m|0)|0)!=1){t=Ac(8)|0;tG(t,89576);Kd(t|0,86928,43)}if((F|0)==0){break}bR(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;nG(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Yd[c[x>>2]&255](o);i=d;return}function NM(a){a=a|0;i=i;return}function OM(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;SM(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=173;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if(($d[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 0:{X=26;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=($d[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=($d[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}nH(A,ea);X=26;break};case 4:{da=D;W=R;ba=r;fa=Q;ga=0;ha=T;c:while(1){ia=c[h>>2]|0;do{if((ia|0)==0){ja=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){ja=ia;break}if(($d[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;ja=0;break}else{ja=c[h>>2]|0;break}}}while(0);ia=(ja|0)==0;ka=c[e>>2]|0;do{if((ka|0)==0){X=173}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){if(ia){break}else{break c}}if(($d[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[e>>2]=0;X=173;break}else{if(ia){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(ia){break}}ka=c[h>>2]|0;la=c[ka+12>>2]|0;if((la|0)==(c[ka+16>>2]|0)){ma=($d[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)&255}else{ma=a[la]|0}do{if(ma<<24>>24>-1){if((b[(c[f>>2]|0)+(ma<<24>>24<<1)>>1]&2048)==0){X=189;break}la=c[o>>2]|0;if((la|0)==(da|0)){ka=(c[P>>2]|0)!=173;na=c[t>>2]|0;oa=da-na|0;pa=oa>>>0<2147483647?oa<<1:-1;qa=dR(ka?na:0,pa)|0;if((qa|0)==0){X=182;break a}do{if(ka){c[t>>2]=qa;ra=qa}else{na=c[t>>2]|0;c[t>>2]=qa;if((na|0)==0){ra=qa;break}Yd[c[P>>2]&255](na);ra=c[t>>2]|0}}while(0);c[P>>2]=148;qa=ra+oa|0;c[o>>2]=qa;sa=qa;ta=(c[t>>2]|0)+pa|0}else{sa=la;ta=da}c[o>>2]=sa+1;a[sa]=ma;ua=ta;va=W;wa=ba;xa=fa;ya=ga+1|0;za=ha}else{X=189}}while(0);if((X|0)==189){X=0;ia=a[w]|0;if((ia&1)==0){Aa=(ia&255)>>>1}else{Aa=c[n>>2]|0}if((Aa|0)==0|(ga|0)==0){break}if(!(ma<<24>>24==(a[v]|0))){break}if((ba|0)==(fa|0)){ia=ba-W|0;qa=ia>>>0<2147483647?ia<<1:-1;if((ha|0)==173){Ba=0}else{Ba=W}ka=dR(Ba,qa)|0;if((ka|0)==0){X=198;break a}Ca=ka;Da=ka+(ia>>2<<2)|0;Ea=ka+(qa>>>2<<2)|0;Fa=148}else{Ca=W;Da=ba;Ea=fa;Fa=ha}c[Da>>2]=ga;ua=da;va=Ca;wa=Da+4|0;xa=Ea;ya=0;za=Fa}qa=c[h>>2]|0;ka=qa+12|0;ia=c[ka>>2]|0;if((ia|0)==(c[qa+16>>2]|0)){$d[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;da=ua;W=va;ba=wa;fa=xa;ga=ya;ha=za;continue}else{c[ka>>2]=ia+1;da=ua;W=va;ba=wa;fa=xa;ga=ya;ha=za;continue}}if((W|0)==(ba|0)|(ga|0)==0){Ga=W;Ha=ba;Ia=fa;Ja=ha}else{if((ba|0)==(fa|0)){ia=ba-W|0;ka=ia>>>0<2147483647?ia<<1:-1;if((ha|0)==173){Ka=0}else{Ka=W}qa=dR(Ka,ka)|0;if((qa|0)==0){X=209;break a}La=qa;Ma=qa+(ia>>2<<2)|0;Na=qa+(ka>>>2<<2)|0;Oa=148}else{La=W;Ma=ba;Na=fa;Oa=ha}c[Ma>>2]=ga;Ga=La;Ha=Ma+4|0;Ia=Na;Ja=Oa}if((c[B>>2]|0)>0){ka=c[h>>2]|0;do{if((ka|0)==0){Pa=0}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){Pa=ka;break}if(($d[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[h>>2]=0;Pa=0;break}else{Pa=c[h>>2]|0;break}}}while(0);ka=(Pa|0)==0;ga=c[e>>2]|0;do{if((ga|0)==0){X=223}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){if(ka){Qa=ga;break}else{X=229;break a}}if(($d[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[e>>2]=0;X=223;break}else{if(ka){Qa=ga;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ka){X=229;break a}else{Qa=0}}ga=c[h>>2]|0;ha=c[ga+12>>2]|0;if((ha|0)==(c[ga+16>>2]|0)){Ra=($d[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{Ra=a[ha]|0}if(!(Ra<<24>>24==(a[u]|0))){X=229;break a}ha=c[h>>2]|0;ga=ha+12|0;fa=c[ga>>2]|0;if((fa|0)==(c[ha+16>>2]|0)){$d[c[(c[ha>>2]|0)+40>>2]&127](ha)|0;Sa=Qa;Ta=Qa;Ua=da}else{c[ga>>2]=fa+1;Sa=Qa;Ta=Qa;Ua=da}while(1){fa=c[h>>2]|0;do{if((fa|0)==0){Va=0}else{if((c[fa+12>>2]|0)!=(c[fa+16>>2]|0)){Va=fa;break}if(($d[c[(c[fa>>2]|0)+36>>2]&127](fa)|0)==-1){c[h>>2]=0;Va=0;break}else{Va=c[h>>2]|0;break}}}while(0);fa=(Va|0)==0;do{if((Ta|0)==0){Wa=Sa;X=243}else{if((c[Ta+12>>2]|0)!=(c[Ta+16>>2]|0)){if(fa){Xa=Sa;Ya=Ta;break}else{X=250;break a}}if(($d[c[(c[Ta>>2]|0)+36>>2]&127](Ta)|0)==-1){c[e>>2]=0;Wa=0;X=243;break}else{if(fa^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(fa){X=250;break a}else{Xa=Wa;Ya=0}}ga=c[h>>2]|0;ha=c[ga+12>>2]|0;if((ha|0)==(c[ga+16>>2]|0)){Za=($d[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{Za=a[ha]|0}if(!(Za<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Za<<24>>24<<1)>>1]&2048)==0){X=250;break a}ha=c[o>>2]|0;if((ha|0)==(Ua|0)){ga=(c[P>>2]|0)!=173;ba=c[t>>2]|0;W=Ua-ba|0;qa=W>>>0<2147483647?W<<1:-1;ia=dR(ga?ba:0,qa)|0;if((ia|0)==0){X=253;break a}do{if(ga){c[t>>2]=ia;_a=ia}else{ba=c[t>>2]|0;c[t>>2]=ia;if((ba|0)==0){_a=ia;break}Yd[c[P>>2]&255](ba);_a=c[t>>2]|0}}while(0);c[P>>2]=148;ia=_a+W|0;c[o>>2]=ia;$a=ia;ab=(c[t>>2]|0)+qa|0}else{$a=ha;ab=Ua}ia=c[h>>2]|0;ga=c[ia+12>>2]|0;if((ga|0)==(c[ia+16>>2]|0)){fa=($d[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;bb=fa;cb=c[o>>2]|0}else{bb=a[ga]|0;cb=$a}c[o>>2]=cb+1;a[cb]=bb;ga=(c[B>>2]|0)+ -1|0;c[B>>2]=ga;fa=c[h>>2]|0;ia=fa+12|0;ba=c[ia>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){$d[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[ia>>2]=ba+1}if((ga|0)>0){Sa=Xa;Ta=Ya;Ua=ab}else{db=ab;break}}}else{db=da}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{eb=db;fb=Ga;gb=Ha;hb=Ia;ib=S;jb=Ja}break};case 3:{ka=a[y]|0;ga=(ka&1)==0;if(ga){kb=(ka&255)>>>1}else{kb=c[G>>2]|0}ba=a[z]|0;ia=(ba&1)==0;if(ia){lb=(ba&255)>>>1}else{lb=c[g>>2]|0}if((kb|0)==(0-lb|0)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}if(ga){mb=(ka&255)>>>1}else{mb=c[G>>2]|0}do{if((mb|0)!=0){if(ia){nb=(ba&255)>>>1}else{nb=c[g>>2]|0}if((nb|0)==0){break}fa=c[h>>2]|0;na=c[fa+12>>2]|0;ob=c[fa+16>>2]|0;if((na|0)==(ob|0)){pb=($d[c[(c[fa>>2]|0)+36>>2]&127](fa)|0)&255;qb=c[h>>2]|0;rb=pb;sb=c[qb+16>>2]|0;tb=c[qb+12>>2]|0;ub=qb;vb=a[y]|0}else{rb=a[na]|0;sb=ob;tb=na;ub=fa;vb=ka}fa=ub+12|0;na=(tb|0)==(sb|0);if(rb<<24>>24==(a[(vb&1)==0?F:c[H>>2]|0]|0)){if(na){$d[c[(c[ub>>2]|0)+40>>2]&127](ub)|0}else{c[fa>>2]=tb+1}fa=a[y]|0;if((fa&1)==0){wb=(fa&255)>>>1}else{wb=c[G>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=wb>>>0>1?y:S;jb=T;break b}if(na){xb=($d[c[(c[ub>>2]|0)+36>>2]&127](ub)|0)&255}else{xb=a[tb]|0}if(!(xb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}na=c[h>>2]|0;fa=na+12|0;ob=c[fa>>2]|0;if((ob|0)==(c[na+16>>2]|0)){$d[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[fa>>2]=ob+1}a[l]=1;ob=a[z]|0;if((ob&1)==0){yb=(ob&255)>>>1}else{yb=c[g>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=yb>>>0>1?z:S;jb=T;break b}}while(0);if(ga){zb=(ka&255)>>>1}else{zb=c[G>>2]|0}ia=c[h>>2]|0;da=c[ia+12>>2]|0;ob=(da|0)==(c[ia+16>>2]|0);if((zb|0)==0){if(ob){fa=($d[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Ab=fa;Bb=a[z]|0}else{Ab=a[da]|0;Bb=ba}if(!(Ab<<24>>24==(a[(Bb&1)==0?m:c[E>>2]|0]|0))){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}fa=c[h>>2]|0;na=fa+12|0;qb=c[na>>2]|0;if((qb|0)==(c[fa+16>>2]|0)){$d[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[na>>2]=qb+1}a[l]=1;qb=a[z]|0;if((qb&1)==0){Cb=(qb&255)>>>1}else{Cb=c[g>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Cb>>>0>1?z:S;jb=T;break b}if(ob){ob=($d[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Db=ob;Eb=a[y]|0}else{Db=a[da]|0;Eb=ka}if(!(Db<<24>>24==(a[(Eb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}da=c[h>>2]|0;ob=da+12|0;ia=c[ob>>2]|0;if((ia|0)==(c[da+16>>2]|0)){$d[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ob>>2]=ia+1}ia=a[y]|0;if((ia&1)==0){Fb=(ia&255)>>>1}else{Fb=c[G>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Fb>>>0>1?y:S;jb=T;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){eb=D;fb=R;gb=r;hb=Q;ib=0;jb=T;break b}}ia=a[x]|0;ob=(ia&1)==0;da=ob?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=ia;Kb=da}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=ia;Kb=da;break}qb=da+(ob?(ia&255)>>>1:c[K>>2]|0)|0;na=da;while(1){if((na|0)==(qb|0)){Lb=qb;break}fa=a[na]|0;if(!(fa<<24>>24>-1)){Lb=na;break}if((b[(c[f>>2]|0)+(fa<<24>>24<<1)>>1]&8192)==0){Lb=na;break}else{na=na+1|0}}na=Lb-da|0;qb=a[A]|0;ha=(qb&1)==0;if(ha){Mb=(qb&255)>>>1}else{Mb=c[N>>2]|0}if(na>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=ia;Kb=da;break}if(ha){ha=(qb&255)>>>1;Nb=A+1+(ha-na)|0;Ob=L;Pb=ha}else{ha=c[M>>2]|0;qb=c[N>>2]|0;Nb=ha+(qb-na)|0;Ob=ha;Pb=qb}qb=Ob+Pb|0;if((Nb|0)==(qb|0)){Hb=Y;Ib=Y;Jb=ia;Kb=Lb;break}else{Qb=da;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=ia;Kb=da;break d}ha=Rb+1|0;if((ha|0)==(qb|0)){Hb=Y;Ib=Y;Jb=ia;Kb=Lb;break}else{Qb=Qb+1|0;Rb=ha}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}ia=c[h>>2]|0;do{if((ia|0)==0){Ub=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){Ub=ia;break}if(($d[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);ia=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(ia){Wb=Hb;Xb=Ib;break}else{break e}}if(($d[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(ia^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ia){break}else{Wb=Vb;Xb=0}}da=c[h>>2]|0;ob=c[da+12>>2]|0;if((ob|0)==(c[da+16>>2]|0)){Yb=($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{Yb=a[ob]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}ob=c[h>>2]|0;da=ob+12|0;ka=c[da>>2]|0;if((ka|0)==(c[ob+16>>2]|0)){$d[c[(c[ob>>2]|0)+40>>2]&127](ob)|0}else{c[da>>2]=ka+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}ka=a[x]|0;if((ka&1)==0){Zb=j;_b=(ka&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T}else{X=162;break a}break};default:{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}}if(($d[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}else{dc=cc;ec=0}}ia=c[h>>2]|0;ka=c[ia+12>>2]|0;if((ka|0)==(c[ia+16>>2]|0)){fc=($d[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255}else{fc=a[ka]|0}if(!(fc<<24>>24>-1)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}ka=c[h>>2]|0;ia=ka+12|0;da=c[ia>>2]|0;if((da|0)==(c[ka+16>>2]|0)){gc=($d[c[(c[ka>>2]|0)+40>>2]&127](ka)|0)&255}else{c[ia>>2]=da+1;gc=a[da]|0}nH(A,gc);$b=dc;ac=ec}}}while(0);da=p+1|0;if(da>>>0<4){Q=hb;r=gb;R=fb;D=eb;p=da;S=ib;T=jb}else{Z=fb;_=gb;$=ib;aa=jb;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){nR()}else if((X|0)==198){nR()}else if((X|0)==209){nR()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=Ga;jc=Ja}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=Ga;jc=Ja}else if((X|0)==253){nR()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=Ga;jc=Ja}else if((X|0)==269){h:do{if(($|0)!=0){jb=$+1|0;ib=$+8|0;gb=$+4|0;fb=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[gb>>2]|0}if(!(fb>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if(($d[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=jb}else{nc=c[ib>>2]|0}if(!(mc<<24>>24==(a[nc+fb|0]|0))){break}p=fb+1|0;U=c[h>>2]|0;eb=U+12|0;D=c[eb>>2]|0;if((D|0)==(c[U+16>>2]|0)){$d[c[(c[U>>2]|0)+40>>2]&127](U)|0;fb=p;continue}else{c[eb>>2]=D+1;fb=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;TM(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);XG(A);XG(z);XG(y);XG(x);XG(w);if((ic|0)==0){i=q;return hc|0}Yd[jc&255](ic);i=q;return hc|0}function PM(a){a=a|0;var b=0;b=Ac(8)|0;tG(b,a);Kd(b|0,86928,43)}function QM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=173;v=n+100|0;TH(q,h);n=q;w=c[n>>2]|0;if(!((c[22484]|0)==-1)){c[m>>2]=89936;c[m+4>>2]=171;c[m+8>>2]=0;IG(89936,m,172)}m=(c[89940>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ac(4)|0;z=y;HQ(z);A=105496;B=128;Kd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ac(4)|0;z=y;HQ(z);A=105496;B=128;Kd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=OM(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){nH(k,me[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=me[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);RM(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if(($d[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;nG(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Yd[c[u>>2]&255](n);i=d;return}function RM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){qH(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function SM(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[22344]|0)==-1)){c[p>>2]=89376;c[p+4>>2]=171;c[p+8>>2]=0;IG(89376,p,172)}p=(c[89380>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}E=b;Zd[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Zd[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hH(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XG(r);Zd[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hH(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XG(s);a[f]=$d[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=$d[c[(c[b>>2]|0)+16>>2]&127](E)|0;Zd[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hH(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XG(t);Zd[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hH(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;XG(u);F=$d[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[22328]|0)==-1)){c[o>>2]=89312;c[o+4>>2]=171;c[o+8>>2]=0;IG(89312,o,172)}o=(c[89316>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ac(4)|0;H=G;HQ(H);I=105496;J=128;Kd(G|0,I|0,J|0)}J=E;Zd[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Zd[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}hH(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;XG(w);Zd[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}hH(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;XG(x);a[f]=$d[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=$d[c[(c[E>>2]|0)+16>>2]&127](J)|0;Zd[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}hH(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;XG(y);Zd[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}hH(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;XG(z);F=$d[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function TM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function UM(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function VM(a){a=a|0;i=i;return}function WM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=173;y=o+400|0;TH(r,h);o=r;z=c[o>>2]|0;if(!((c[22482]|0)==-1)){c[n>>2]=89928;c[n+4>>2]=171;c[n+8>>2]=0;IG(89928,n,172)}n=(c[89932>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ac(4)|0;C=B;HQ(C);D=105496;E=128;Kd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=XM(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ve[c[(c[z>>2]|0)+48>>2]&63](E,89632,89642|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=aR((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}nR()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[89632+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((pd(p|0,89568,m|0)|0)!=1){t=Ac(8)|0;tG(t,89576);Kd(t|0,86928,43)}if((F|0)==0){break}bR(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=$d[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];nG(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Yd[c[x>>2]&255](o);i=d;return}



function ar(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=ER(b|0)|0;do{if((d|0)==0){e=aR(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=aR(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((zR(e,56040,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;GR(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((zR(e,56040,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=aR(64)|0;z=y;Um(0,(y|0)!=0|0,56048,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=cR(Z,8)|0;c[E>>2]=y;Um(0,(y|0)!=0|0,56048,w);w=cR(Z,8)|0;c[F>>2]=w;Um(0,(w|0)!=0|0,56048,v);v=cR(Z,8)|0;c[G>>2]=v;Um(0,(v|0)!=0|0,56048,u);u=cR(Z,8)|0;c[H>>2]=u;Um(0,(u|0)!=0|0,56048,t);t=cR(Z,8)|0;c[I>>2]=t;Um(0,(t|0)!=0|0,56048,s);s=cR(Z,4)|0;t=s;c[J>>2]=t;Um(0,(s|0)!=0|0,56048,r);Rm(9,0,56064,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;Rm(9,0,56088,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rm(9,0,56176,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Rm(9,0,56224,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Rm(9,0,56280,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;Rm(9,0,56336,l);c[j>>2]=ya;Rm(9,0,56408,j);j=cR(sa,8)|0;c[K>>2]=j;Um(0,(j|0)!=0|0,56048,g);g=aR(sa<<3)|0;c[L>>2]=g;Um(0,(g|0)!=0|0,56048,f);f=aR(ya<<3)|0;c[M>>2]=f;Um(0,(f|0)!=0|0,56048,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function cr(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){bR(d)}d=c[a+28>>2]|0;if((d|0)!=0){bR(d)}d=c[a+32>>2]|0;if((d|0)!=0){bR(d)}d=c[a+36>>2]|0;if((d|0)!=0){bR(d)}d=c[a+40>>2]|0;if((d|0)!=0){bR(d)}d=c[a+44>>2]|0;if((d|0)!=0){bR(d)}d=c[a+48>>2]|0;if((d|0)!=0){bR(d)}d=c[a+52>>2]|0;if((d|0)!=0){bR(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;bR(e);i=b;return}bR(d);e=a;bR(e);i=b;return}function dr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=cR(o,8)|0;q=cR(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=cR(s,8)|0;u=cR(s,8)|0;v=cR(o,8)|0;w=cR(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Tq(b,1.0);s=c[n>>2]|0;if((s|0)>0){GR(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Tq(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){GR(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;Rm(9,0,56448,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}bR(p);bR(q);bR(t);bR(u);bR(v);bR(w);i=d;return}function er(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function fr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function hr(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Vm(c[a+536>>2]|0,56520,d);return 0}function ir(a){a=a|0;a=i;i=i+8|0;Vm(0,56552,a);return 0}function jr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[18908>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=cR((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Um(0,(n|0)!=0|0,56592,b);c[14152]=c[a+60>>2];c[14154]=c[a+48>>2];ap(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;bR(n);c[14152]=0;c[14154]=0;n=Sq(a)|0;i=b;return n|0}function kr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[14154];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[14152];h[d>>3]=+Tq(f,1.0);i=e;return}function lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=aR(x)|0;z=y;A=aR(x)|0;x=A;Um(0,(y|0)!=0|0,56624,n);Um(0,(A|0)!=0|0,56624,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[18908>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Tq(a,1.0);h[o>>3]=D;if(D!=0.0){c[14160]=c[a+60>>2];c[14162]=c[a+48>>2];Zo(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[14160]=0;c[14162]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Rm(9,0,56656,l)}D=+Tq(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Rm(9,0,56760,j);j=c[u>>2]|0;do{if((j|0)==4){Tm(9,0,56992,d);F=-4;i=b;return F|0}else if((j|0)==3){Tm(9,0,56920,e);F=-3;i=b;return F|0}else if((j|0)==2){Tm(9,0,56856,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];Tm(9,0,56776,g);F=-1;i=b;return F|0}}while(0);F=Sq(a)|0;i=b;return F|0}function mr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[14162];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[14160];h[d>>3]=+Tq(f,1.0);i=e;return}function nr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;Rm(9,1,57048,g);if((c[18908>>2]|0)==0){l=0}else{l=(k|0)/10|0}or(a,d,k,l,b,j);c[f>>2]=c[j>>2];Rm(9,0,57072,f);Yd[c[4856]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Sq(a)|0;if((b|0)==0){m=0;i=e;return m|0}Tm(9,0,57088,e);m=b;i=e;return m|0}function or(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=aR(fa(N,M)|0)|0;P=aR(M<<3)|0;Q=aR(N)|0;R=Q;S=aR(N)|0;T=S;V=aR(N)|0;W=V;X=aR(N)|0;Y=+h[f>>3];if((c[18908>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];ec(N|0,57136,I|0)|0;I=fc(N|0,57152)|0;c[H>>2]=57168;od(I|0,57160,H|0)|0;c[G>>2]=57184;od(I|0,57160,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];od(I|0,57160,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Jd(10,I|0)|0;c[E>>2]=0;od(I|0,57192,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];od(I|0,57200,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];od(I|0,57200,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Jd(10,I|0)|0;Z=I}else{Z=0}Um(0,(O|0)!=0|0,57208,B);Um(0,(P|0)!=0|0,57208,A);Um(0,(Q|0)!=0|0,57208,z);Um(0,(S|0)!=0|0,57208,y);Um(0,(V|0)!=0|0,57208,x);Um(0,(X|0)!=0|0,57208,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{fr(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Tq(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;fr(a,la);+Tq(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Rm(9,0,57224,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){IR(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);fr(a,R);za=+Tq(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}GR(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}fr(a,T);if(+Tq(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}GR(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}GR(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}fr(a,W);Ba=+Tq(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}fr(a,W);Ba=+Tq(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}GR(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rm(9,0,57264,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;od(Z|0,57192,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];od(Z|0,57200,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];od(Z|0,57200,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Jd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Tm(9,0,57312,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Tm(9,0,57328,p);Vm(0,57344,o)}fr(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){bR(S);bR(Q);bR(V);bR(X);bR(P);bR(O);i=j;return}c[n>>2]=ia;od(Z|0,57192,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(Z|0,57200,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(Z|0,57200,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Jd(10,Z|0)|0;Tc(Z|0)|0;bR(S);bR(Q);bR(V);bR(X);bR(P);bR(O);i=j;return}function pr(a,b){a=a|0;b=b|0;i=i;return}function qr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;no(3);qo(0);w=+io(0);no(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(v|0,57424,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];od(v|0,57424,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];od(v|0,57424,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];od(v|0,57432,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;od(v|0,57432,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];od(v|0,57440,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];od(v|0,57424,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];od(v|0,57424,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;od(v|0,57432,l|0)|0;break}else{c[m>>2]=0-E;od(v|0,57432,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;od(v|0,57432,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;od(v|0,57432,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Jd(10,v|0)|0;qo(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];od(v|0,57440,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Jd(10,v|0)|0;qo(3);i=e;return}function rr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=fc(c[r>>2]|0,57448)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Nd(c[(Jc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Um(t,(s|0)!=0|0,57456,q);c[p>>2]=57512;od(s|0,57440,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=57520;od(s|0,57440,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];od(s|0,57440,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];od(s|0,57440,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];od(s|0,57440,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];od(s|0,57440,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];od(s|0,57440,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];od(s|0,57440,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];od(s|0,57440,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Jd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];od(s|0,57440,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Jd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function sr(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;no(3);Tc(d|0)|0;qo(3);i=b;return}function tr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;mJ(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];nJ(p,f)|0;ur(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;vr(a,b,57536,c[j>>2]|0,c[g>>2]|0,o,8);bR(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];nJ(p,e)|0;i=d;return}function ur(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=cR(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Um(c[b+536>>2]|0,(p|0)!=0|0,57816,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function vr(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;Gr(a,b,d,e,f,h);lJ(l,g,fa(fa(f,e)|0,h)|0)|0;if(IH(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Vm(l,57768,k)}else{i=j;return}}function wr(a){a=a|0;var b=0;b=i;if((ys(a+4|0)|0)!=0){i=b;return}LH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function xr(a){a=a|0;Nc(a|0)|0;Va()}function yr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=gR(320)|0;IR(q|0,0,320)|0;zr(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;no(3);t=a+8|0;u=Ar(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=Br(a,b,u+s|0)|0;u=q+184|0;Cr(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;Cr(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;Dr(q,c[x>>2]|0,36);if(IH(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Vm(y,57592,e)}else{vr(a,b,57624,4,11,57544,1);Er((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;vr(a,b,57632,c[g>>2]|0,c[j>>2]|0,e,1);bR(e);c[f>>2]=0;Er((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;vr(a,b,57640,c[g>>2]|0,c[j>>2]|0,e,1);bR(e);c[f>>2]=0;Fr(a,b,k,g,j,c[r>>2]|0,s);vr(a,b,57656,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;mJ(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];ur(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;vr(a,b,57536,c[j>>2]|0,c[g>>2]|0,n,8);mJ(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=Hr(q+240|0)|0;w=Hr(q+264|0)|0;p=Hr(q+288|0)|0;Gr(a,b,57672,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);bR(n);bR(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;TI(s)|0;bR(v);qo(3);i=d;return}}function zr(a){a=a|0;var b=0;b=i;Iu(a);i=b;return}function Ar(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(Mt(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(Mt(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(Mt(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function Br(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=aR(e<<2)|0;e=l;c[l>>2]=58224;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=58264;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(Mt(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(Mt(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(Mt(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function Cr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;xs(a,b,c);i=d;return}function Dr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(ws(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){LH(d,4);i=e;return}else{JH(d,0);i=e;return}}function Er(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=ER(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=cR((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Um(0,(o|0)!=0|0,57744,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;PR(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;Lr(q,ER(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=cR(1,1)|0;c[d>>2]=q;Um(0,(q|0)!=0|0,57744,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function Fr(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=cR(c[f>>2]<<2,4)|0;c[e>>2]=g;Um(c[d+536>>2]|0,(g|0)!=0|0,57792,k);g=s+240|0;f=Hr(g)|0;h=s+264|0;t=Hr(h)|0;u=s+288|0;v=Hr(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=Hr(g)|0;D=Hr(h)|0;E=Hr(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){Mr(l,b,A+(v*52|0)+4|0);Or(n,b);if(!(Nr(l,n)|0)){F=w;break}G=(c[(Pr(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){Mr(l,g,A+(v*52|0)+4|0);Or(m,g);if(!(Nr(l,m)|0)){F=w;break}G=(c[(Pr(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){Mr(l,v,G+(t*52|0)+4|0);Or(p,v);J=(Nr(l,p)|0)&1}else if(f<<24>>24==0){Mr(l,h,G+(t*52|0)+4|0);Or(o,h);f=Nr(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(Pr(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){Mr(l,d,y+(t*52|0)+4|0);Or(r,d);M=(Nr(l,r)|0)&1}else if(x<<24>>24==0){Mr(l,u,y+(t*52|0)+4|0);Or(q,u);x=Nr(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(Pr(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function Gr(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(ER(d|0)|0)+1;e=m;lJ(e,l,20)|0;if(IH(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Vm(l,57768,k)}lJ(e,d,c[f>>2]|0)|0;if(IH(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Vm(m,57768,j)}else{i=h;return}}function Hr(a){a=a|0;var b=0,d=0;b=i;d=c[(ts(a)|0)>>2]|0;i=b;return d|0}function Ir(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;no(3);do{if(HH(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];nJ(k,e)|0;k=Hr(h+240|0)|0;m=Hr(h+264|0)|0;l=Hr(h+288|0)|0;Gr(a,b,57672,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);wr(h)}else{if((h|0)!=0){break}c[g>>2]=0;qo(3);i=d;return}}while(0);Jr(j);iR(h);c[g>>2]=0;qo(3);i=d;return}function Jr(a){a=a|0;var b=0;b=i;Rs(a);i=b;return}function Kr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;no(3);qo(0);h[j>>3]=+io(0);no(0);l=k;m=d+4|0;lJ(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){lJ(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){lJ(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);lJ(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);lJ(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);lJ(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(IH(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Vm(t,57712,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;qo(3);i=e;return}}function Lr(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((BR(b,57928,4)|0)!=0){i=d;return}c=b;while(1){e=Sa(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((BR(b,57928,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function Mr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;fs(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Xr(a,f);i=e;return}function Nr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Vr(a,b)|0;i=c;return d|0}function Or(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Yr(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Xr(a,e);i=d;return}function Pr(a){a=a|0;var b=0,c=0;b=i;c=Qr(Rr(a)|0)|0;i=b;return c|0}function Qr(a){a=a|0;var b=0,c=0;b=i;c=Ur(a)|0;i=b;return c|0}function Rr(a){a=a|0;var b=0,d=0;b=i;d=Sr((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Sr(a){a=a|0;var b=0,c=0;b=i;c=Tr(a)|0;i=b;return c|0}function Tr(a){a=a|0;i=i;return a|0}function Ur(a){a=a|0;i=i;return a|0}function Vr(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Wr(a,b)|0)^1;i=c;return d|0}function Wr(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Xr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];es(a,e);i=d;return}function Yr(a,b){a=a|0;b=b|0;var c=0;c=i;Zr(a,_r(b)|0);i=c;return}function Zr(a,b){a=a|0;b=b|0;var c=0;c=i;ds(a,b);i=c;return}function _r(a){a=a|0;var b=0,c=0;b=i;c=$r(as(a+4|0)|0)|0;i=b;return c|0}function $r(a){a=a|0;var b=0,c=0;b=i;c=cs(a)|0;i=b;return c|0}function as(a){a=a|0;var b=0,c=0;b=i;c=bs(a)|0;i=b;return c|0}function bs(a){a=a|0;i=i;return a|0}function cs(a){a=a|0;i=i;return a|0}function ds(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function es(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function fs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=hs(b)|0;gs(f,b,d,h,_r(b)|0);Yr(g,b);do{if(Vr(f,g)|0){h=is(b)|0;if(js(h,d,ks(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Yr(a,b);i=e;return}function gs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;os(h);a:do{if((e|0)==0){j=f}else{k=is(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(ps(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;os(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;os(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Zr(a,j);i=g;return}function hs(a){a=a|0;var b=0,d=0;b=i;d=c[(_r(a)|0)>>2]|0;i=b;return d|0}function is(a){a=a|0;var b=0,c=0;b=i;c=ms(a+8|0)|0;i=b;return c|0}function js(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=ls(0,b,c)|0;i=a;return d|0}function ks(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function ls(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function ms(a){a=a|0;var b=0,c=0;b=i;c=ns(a)|0;i=b;return c|0}function ns(a){a=a|0;i=i;return a|0}function os(a){a=a|0;var b=0;b=i;qs(a,-1);i=b;return}function ps(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=ls(0,b,c)|0;i=a;return d|0}function qs(a,b){a=a|0;b=b|0;b=i;rs(a,0);i=b;return}function rs(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function ss(a){a=a|0;i=i;return c[a+4>>2]|0}function ts(a){a=a|0;var b=0,c=0;b=i;c=us(a+8|0)|0;i=b;return c|0}function us(a){a=a|0;var b=0,c=0;b=i;c=vs(a)|0;i=b;return c|0}function vs(a){a=a|0;i=i;return a|0}function ws(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 1:case 17:{h=57840;break};case 52:case 20:{h=57880;break};case 24:{h=57856;break};case 28:{h=57904;break};case 56:{h=57864;break};case 13:case 29:{h=57920;break};case 48:case 16:{h=57832;break};case 9:case 25:{h=57872;break};case 12:{h=57896;break};case 60:{h=57912;break};case 8:{h=57848;break};case 5:case 21:{h=57888;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=fc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Rc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Tc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function xs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function ys(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}zs(d,f,102);f=$d[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Tc(As(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}Bs(d);g=h;i=b;return g|0}function zs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Is(a,b,c);i=d;return}function As(a){a=a|0;var b=0,d=0;b=i;d=Es(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Bs(a){a=a|0;var b=0;b=i;Cs(a);i=b;return}function Cs(a){a=a|0;var b=0;b=i;Ds(a,0);i=b;return}function Ds(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Es(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$d[c[(Fs(e)|0)>>2]&127](f)|0;i=d;return}function Es(a){a=a|0;var b=0,c=0;b=i;c=Hs(a)|0;i=b;return c|0}function Fs(a){a=a|0;var b=0,c=0;b=i;c=Gs(a)|0;i=b;return c|0}function Gs(a){a=a|0;i=i;return a+4|0}function Hs(a){a=a|0;i=i;return a|0}function Is(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Ks(f)|0)>>2]|0;Js(a,d,c[(Ls(g)|0)>>2]|0);i=e;return}function Js(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Ms(a,b,c);i=d;return}function Ks(a){a=a|0;i=i;return a|0}function Ls(a){a=a|0;i=i;return a|0}function Ms(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Os(f)|0)>>2]|0;Ns(a,d,c[(Ps(g)|0)>>2]|0);i=e;return}function Ns(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(Os(f)|0)>>2];c[a+4>>2]=c[(Ps(g)|0)>>2];i=e;return}function Os(a){a=a|0;i=i;return a|0}function Ps(a){a=a|0;i=i;return a|0}function Qs(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function Rs(a){a=a|0;var b=0;b=i;Ss(a+300|0);Ss(a+288|0);Ss(a+276|0);Ss(a+264|0);Ss(a+252|0);Ss(a+240|0);Ts(a);i=b;return}function Ss(a){a=a|0;var b=0;b=i;Dt(a);i=b;return}function Ts(a){a=a|0;var b=0;b=i;Us(a,57976);PH(a+104|0);i=b;return}function Us(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Ys(a+4|0);i=d;return}function Vs(a){a=a|0;var b=0;b=i;Ts(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Ws(a){a=a|0;var b=0;b=i;Ts(a);iR(a);i=b;return}function Xs(a){a=a|0;var b=0;b=i;Ws(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Ys(a){a=a|0;var b=0;b=i;Zs(a);i=b;return}function Zs(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=58104;ys(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}jR(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}jR(e)}}while(0);YH(b);i=d;return}function _s(a){a=a|0;var b=0;b=i;Ys(a);iR(a);i=b;return}function $s(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Bt(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=Ct(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;gI(h,0,0,0);lI(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}jR(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=hR(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=hR(h)|0;a[b+97|0]=1;i=e;return}function at(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;gI(e,0,0,0);lI(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}jR(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}jR(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=hR(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(yt(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=hR(o)|0;a[k]=1;i=f;return e|0}return 0}function bt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ac(4)|0;HQ(n);Kd(n|0,105496,128)}n=ut(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if(($d[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){Cr(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=XR(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Rc(p|0,q|0,f|0)|0)==0){p=vb(c[m>>2]|0)|0;Cr(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];xt(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{Cr(a,-1,-1);i=g;return}}}while(0);Cr(a,-1,-1);i=g;return}function ct(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if(($d[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=Qs(d)|0;if((Rc(j|0,k|0,0)|0)==0){wt(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{Cr(a,-1,-1);i=e;return}}}while(0);Cr(a,-1,-1);i=e;return}function dt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ac(4)|0;HQ(m);Kd(m|0,105496,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=ut(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=eI(s)|0;u=(fa(t-(dI(s)|0)|0,p)|0)+r|0;v=0;break}p=dI(s)|0;if((p|0)==(eI(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=vt(t,g,x,o,p-(cI(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=eI(w)|0;u=q-(dI(w)|0)|0;v=0}}while(0);if((Rc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;gI(b,0,0,0);c[m>>2]=0}else{q=b;y=iI(q)|0;do{if((y|0)!=(hI(q)|0)){if((me[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=tt(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((nc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((md(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function et(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=ot(b)|0;o=b;if((dI(o)|0)==0){p=e+1|0;gI(o,e,p,p)}if(n){q=0}else{n=eI(o)|0;c[f>>2]=(n-(cI(o)|0)|0)/2|0;c[g>>2]=4;q=c[(pt(f,g)|0)>>2]|0}g=dI(o)|0;do{if((g|0)==(eI(o)|0)){HR(cI(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=eI(o)|0;n=cI(o)|0;p=pb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=cI(o)|0;gI(o,n,n+q|0,n+(p+q)|0);r=mt(a[dI(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;HR(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(pt(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=pb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ac(4)|0;HQ(t);Kd(t|0,105496,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=cI(o)|0;if((qt(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;gI(o,f,f,c[s>>2]|0);r=mt(a[dI(o)|0]|0)|0;break}s=c[k>>2]|0;f=cI(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}gI(o,f,p,s);r=mt(a[dI(o)|0]|0)|0}else{r=mt(a[g]|0)|0}}while(0);if((cI(o)|0)!=(e|0)){m=r;i=d;return m|0}gI(o,0,0,0);m=r;i=d;return m|0}function ft(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=cI(g)|0;j=dI(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(it(d,-1)|0){fI(g,-1);f=lt(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=jt(d)|0;do{if(h){if(nt(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);fI(g,-1);a[dI(g)|0]=b;f=d;i=e;return f|0}function gt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}ht(b);l=b;m=hI(l)|0;n=jI(l)|0;if(!(it(d,-1)|0)){if((iI(l)|0)==0){lI(l,f,f+1|0)}f=jt(d)|0;a[iI(l)|0]=f;kI(l,1)}f=iI(l)|0;o=hI(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ac(4)|0;u=t;HQ(u);v=105496;w=128;Kd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=hI(l)|0;A=iI(l)|0;B=kt(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=hI(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((nc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;lI(l,B,iI(l)|0);B=jI(l)|0;kI(l,B-(hI(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ac(4)|0;u=t;HQ(u);v=105496;w=128;Kd(t|0,v|0,w|0)}else if((D|0)==14){q=(iI(l)|0)-C|0;if((nc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((nc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);lI(l,m,n)}k=lt(d)|0;i=e;return k|0}function ht(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;gI(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;lI(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;lI(f,h,h+(g+ -1)|0);break}}else{lI(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function it(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function jt(a){a=a|0;i=i;return a&255|0}function kt(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=pe[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function lt(a){a=a|0;var b=0,c=0;b=i;c=it(a,-1)|0;i=b;return(c?0:a)|0}function mt(a){a=a|0;i=i;return a&255|0}function nt(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function ot(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;lI(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;gI(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;gI(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function pt(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=rt(b,c,e)|0;i=d;return g|0}function qt(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=pe[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function rt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=st(0,b,a)|0;i=c;return(d?b:a)|0}function st(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function tt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ne[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function ut(a){a=a|0;var b=0,d=0;b=i;d=$d[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function vt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ne[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function wt(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function xt(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function yt(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=zt(b,c,e)|0;i=d;return g|0}function zt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=At(0,a,b)|0;i=c;return(d?b:a)|0}function At(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function Bt(a){a=a|0;var b=0,c=0;b=i;c=HN(a,9e4)|0;i=b;return c|0}function Ct(a){a=a|0;var b=0,d=0;b=i;d=$d[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function Dt(a){a=a|0;var b=0;b=i;Et(a);i=b;return}function Et(a){a=a|0;var b=0;b=i;Ft(a);i=b;return}function Ft(a){a=a|0;var b=0;b=i;Gt(a,hs(a)|0);i=b;return}function Gt(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;os(d);if((b|0)==0){i=d;return}Gt(a,c[b>>2]|0);Gt(a,c[b+4>>2]|0);It(Ht(a)|0,b,1);i=d;return}function Ht(a){a=a|0;var b=0,c=0;b=i;c=Kt(a+4|0)|0;i=b;return c|0}function It(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Jt(0,b,0);i=c;return}function Jt(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iR(b);i=c;return}function Kt(a){a=a|0;var b=0,c=0;b=i;c=Lt(a)|0;i=b;return c|0}function Lt(a){a=a|0;i=i;return a|0}function Mt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Nt(a,f,b)|0;l=c[k>>2]|0;os(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Pt(j,a,b);Qt(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Ot(g,e);Rt(j);j=c[f>>2]|0;St(a,j,k,Tt(g)|0);k=Ut(g)|0;Rt(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Nt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=hs(h)|0;os(e);if((a|0)==0){j=_r(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(ls(0,d,a)|0){m=l;j=c[m>>2]|0;os(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(ls(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;os(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Ot(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Gu(a,e);i=d;return}function Pt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Ht(d)|0;d=pu(n,1)|0;qu(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];ou(j,d,h);ru(0,ku((su(j)|0)+16|0)|0,e);e=tu(j)|0;a[e+4|0]=1;uu(0,ju((su(j)|0)+20|0)|0);a[e+5|0]=1;vu(m,j);Qt(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Ot(b,g);Rt(m);Rt(j);i=f;return}function Qt(a,b){a=a|0;b=b|0;var c=0;c=i;mu(a,b);i=c;return}function Rt(a){a=a|0;var b=0;b=i;fu(a);i=b;return}function St(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;os(f);c[e>>2]=0;os(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Zt(a)|0;b=c[c[e>>2]>>2]|0;os(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(_r(a)|0)>>2]|0;_t(e,c[d>>2]|0);d=$t(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Tt(a){a=a|0;var b=0,d=0;b=i;d=c[(Xt(a)|0)>>2]|0;i=b;return d|0}function Ut(a){a=a|0;var b=0,d=0;b=i;d=Vt(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Vt(a){a=a|0;var b=0,c=0;b=i;c=Wt(a)|0;i=b;return c|0}function Wt(a){a=a|0;i=i;return a|0}function Xt(a){a=a|0;var b=0,c=0;b=i;c=Yt(a)|0;i=b;return c|0}function Yt(a){a=a|0;i=i;return a|0}function Zt(a){a=a|0;i=i;return a|0}function _t(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=cu(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;os(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;os(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(cu(j)|0){p=j}else{o=c[k>>2]|0;du(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;eu(p);i=e;return}else if((l|0)==14){if(cu(j)|0){p=c[k>>2]|0;eu(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;du(q);i=e;return}else if((l|0)==17){i=e;return}}function $t(a){a=a|0;var b=0,c=0;b=i;c=au(a+8|0)|0;i=b;return c|0}function au(a){a=a|0;var b=0,c=0;b=i;c=bu(a)|0;i=b;return c|0}function bu(a){a=a|0;i=i;return a|0}function cu(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function du(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;os(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=cu(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;os(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=cu(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function fu(a){a=a|0;var b=0;b=i;gu(a,0);i=b;return}function gu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Vt(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}iu(hu(e)|0,f);i=d;return}function hu(a){a=a|0;var b=0,c=0;b=i;c=lu(a)|0;i=b;return c|0}function iu(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}It(c[a>>2]|0,b,1);i=d;return}function ju(a){a=a|0;i=i;return a|0}function ku(a){a=a|0;i=i;return a|0}function lu(a){a=a|0;i=i;return a+4|0}function mu(a,b){a=a|0;b=b|0;var c=0;c=i;nu(a,b);i=c;return}function nu(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function ou(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];yu(a,b,f);i=e;return}function pu(a,b){a=a|0;b=b|0;var c=0;a=i;c=xu(0,b,0)|0;i=a;return c|0}function qu(a,b){a=a|0;b=b|0;var c=0;c=i;wu(a,b);i=c;return}function ru(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function su(a){a=a|0;var b=0,d=0;b=i;d=c[(Xt(a)|0)>>2]|0;i=b;return d|0}function tu(a){a=a|0;var b=0,c=0;b=i;c=hu(a)|0;i=b;return c|0}function uu(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function vu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;mu(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Ot(h,f);Qt(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Ot(a,e);Rt(h);i=d;return}function wu(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function xu(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gR(b*24|0)|0;i=c;return a|0}function yu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Au(g)|0)>>2]|0;g=Bu(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];zu(b,a,f);i=e;return}function zu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Cu(a,b,f);i=e;return}function Au(a){a=a|0;i=i;return a|0}function Bu(a){a=a|0;i=i;return a|0}function Cu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Eu(g)|0)>>2]|0;g=Fu(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Du(b,a,f);i=e;return}function Du(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Eu(f)|0)>>2];f=Fu(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Eu(a){a=a|0;i=i;return a|0}function Fu(a){a=a|0;i=i;return a|0}function Gu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Ut(Hu(b)|0)|0;h=Fu(tu(Hu(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];zu(g,a,e);i=d;return}function Hu(a){a=a|0;i=i;return c[a>>2]|0}function Iu(a){a=a|0;var b=0;b=i;i=i+48|0;Ju(a);Cr(a+184|0,0,0);Cr(a+200|0,0,0);Ku(a+240|0,b);Ku(a+252|0,b+8|0);Ku(a+264|0,b+16|0);Ku(a+276|0,b+24|0);Ku(a+288|0,b+32|0);Ku(a+300|0,b+40|0);i=b;return}function Ju(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;UH(d);e=a;c[e>>2]=57948;f=d;c[f>>2]=57968;d=a+4|0;$I(a,57980|0,d);c[e>>2]=57948;c[f>>2]=57968;Xu(d);i=b;return}function Ku(a,b){a=a|0;b=b|0;b=i;Lu(a,0);i=b;return}function Lu(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Mu(a,b);i=b;return}function Mu(a,b){a=a|0;b=b|0;b=i;Nu(a,0);i=b;return}function Nu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Ou(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Pu(f,0,e);e=_r(b)|0;c[(Zt(b)|0)>>2]=e;i=d;return}function Ou(a){a=a|0;var b=0;b=i;Tu(a);i=b;return}function Pu(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Qu(b,c,f);i=e;return}function Qu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Su(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Ru(d,b,f);i=e;return}function Ru(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Su(e)|0)>>2];i=d;return}function Su(a){a=a|0;i=i;return a|0}function Tu(a){a=a|0;var b=0;b=i;Uu(a);i=b;return}function Uu(a){a=a|0;var b=0;b=i;Vu(a);i=b;return}function Vu(a){a=a|0;var b=0;b=i;Wu(a);i=b;return}function Wu(a){a=a|0;c[a>>2]=0;i=i;return}function Xu(a){a=a|0;var b=0;b=i;Yu(a);i=b;return}function Yu(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;bI(j);c[d>>2]=58104;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;os(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;ZH(g,j);l=Zu(g)|0;FN(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ee[r&63](d,0,4096)|0;i=e;return}ZH(h,j);c[k>>2]=Bt(h)|0;FN(h);a[f]=(Ct(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ee[r&63](d,0,4096)|0;i=e;return}function Zu(a){a=a|0;var b=0,c=0;b=i;c=GN(a,9e4)|0;i=b;return c|0}function _u(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;no(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){$u(a,b,c[f>>2]|0,h);qo(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=dR(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Vm(k,58376,e)}$u(a,b,l,h);qo(3);i=d;return}function $u(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;qo(0);k=+io(0);no(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function av(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=aR(24)|0;no(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Um(c[m>>2]|0,l>>>31^1,58432,f);f=b+8|0;b=c[a+8>>2]|0;l=bv(b,f)|0;c[g+20>>2]=l;l=bv(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=aR(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Vm(k,58512,e)}else{c[h>>2]=0;c[a+12>>2]=g;qo(3);i=d;return}}function bv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function cv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;no(3);u=b;v=fc(c[u>>2]|0,58576)|0;if((v|0)==0){dv(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Nd(c[(Jc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Vm(w,58584,q)}nc(58640,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];od(v|0,58688,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];od(v|0,58712,o|0)|0;nc(58736,40,1,v|0)|0;nc(58784,11,1,v|0)|0;nc(58800,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];ev(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Jd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{nc(58816,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;ev(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Jd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];od(v|0,58840,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;ev(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Jd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];od(v|0,58840,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;ev(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Jd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];od(v|0,58840,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;ev(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Jd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];od(v|0,58840,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;ev(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Jd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];od(v|0,58840,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;ev(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Jd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];od(v|0,58840,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;ev(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Jd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}dv(t);if((Tc(v|0)|0)==0){bR(c[r>>2]|0);c[r>>2]=0;qo(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Vm(e,58856,f)}}function dv(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}bR(a);c[d>>2]=0;i=b;return}function ev(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];od(a|0,58904,f|0)|0;i=e;return}function fv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=gR(192)|0;IR(m|0,0,192)|0;gv(m);c[a+12>>2]=m;n=m;o=a;Dr(n,c[o>>2]|0,36);if(IH(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Vm(a,58944,g)}else{g=m;lJ(g,58920,14)|0;mJ(h,g);a=Qs(h)|0;h=m+184|0;c[h>>2]=a;lJ(g,58936,4)|0;hv(n,b+8|0);mJ(j,g);b=Qs(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;Cr(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];nJ(g,f)|0;iv(n,-4-m+b|0);b=c[j>>2]|0;Cr(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];nJ(g,e)|0;qo(3);i=d;return}}function gv(a){a=a|0;var b=0;b=i;Bv(a);i=b;return}function hv(a,b){a=a|0;b=b|0;var c=0;c=i;kv(a,3);lv(a,59120);kv(a,0);lv(a,59128);kv(a,2);wv(a,b);xv(a,b);lv(a,59136);kv(a,0);i=c;return}function iv(a,b){a=a|0;b=b|0;var d=0;d=i;c[14778]=yd(b|0)|0;lJ(a,59112,4)|0;i=d;return}function jv(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;mJ(l,q);r=Qs(l)|0;iv(b,0);mJ(m,q);l=Qs(m)|0;kv(b,1);lv(b,59008);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;mv(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);nv(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{nv(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{ov(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{pv(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{lv(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}mJ(n,q);u=Qs(n)|0;n=FR(0,r|0,32)|0;Cr(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];nJ(q,k)|0;iv(b,u-l|0);Cr(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];nJ(q,j)|0;i=g;return}function kv(b,d){b=b|0;d=d|0;var e=0;e=i;a[59096]=-33;c[14776]=yd(d|0)|0;d=b;lJ(d,59096,1)|0;lJ(d,59104,4)|0;i=e;return}function lv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=yd(ER(d|0)|0)|0;a[59088]=-37;g=b;lJ(g,59088,1)|0;lJ(g,f,4)|0;lJ(g,d,ER(d|0)|0)|0;i=e;return}function mv(b,d){b=b|0;d=d|0;var e=0;e=i;a[59072]=-35;c[14770]=yd(d|0)|0;d=b;lJ(d,59072,1)|0;lJ(d,59080,4)|0;i=e;return}function nv(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[59056]=-53;vv(c);e=b;lJ(e,59056,1)|0;lJ(e,59064,8)|0;i=d;return}function ov(b,d){b=b|0;d=d|0;var e=0;e=i;a[59040]=-46;c[14762]=yd(d|0)|0;d=b;lJ(d,59040,1)|0;lJ(d,59048,4)|0;i=e;return}function pv(b,c){b=b|0;c=c|0;var d=0;d=i;a[59032]=c?-61:-62;lJ(b,59032,1)|0;i=d;return}function qv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;jv(e,+h[f>>3],a,f);jv(e,+h[b+248>>3],a,f);i=d;return}function rv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;mJ(j,p);o=Qs(j)|0;iv(b,0);mJ(k,p);j=Qs(k)|0;kv(b,1);lv(b,59016);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;mv(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;nv(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{nv(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{ov(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{pv(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{lv(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}mJ(l,p);s=Qs(l)|0;l=FR(0,o|0,32)|0;Cr(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];nJ(p,g)|0;iv(b,s-j|0);Cr(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];nJ(p,f)|0;i=e;return}function sv(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;wr(a);no(3);if((a|0)!=0){tv(a);iR(a)}c[d>>2]=0;qo(3);i=b;return}function tv(a){a=a|0;var b=0;b=i;uv(a);i=b;return}function uv(a){a=a|0;var b=0;b=i;Ts(a);i=b;return}function vv(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((yd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=59064;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[59064+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function wv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;lv(a,59008);kv(a,4);lv(a,59144);kv(a,0);lv(a,59152);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;mv(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);lv(a,59160);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{lv(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{lv(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{lv(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{lv(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=59248;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];yv(a,b,e);lv(a,59184);kv(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);zv(a,59160,59192);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;zv(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;zv(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;zv(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;zv(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}



function Ni(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=ii(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Qh(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=ii(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Ti(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=ve[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=me[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}ve[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=vi(k,b,v,w+(me[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=ri(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=zi(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=mi(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=mi(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=me[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(ii(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((fi(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((fi(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((fi(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=$d[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;GR(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}Yd[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;GR(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;GR(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function Oi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=ve[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 0:{k=14;break a;break};case 11:{if((Gi(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 13:{if((Hi(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-4:{k=7;break a;break};case-2:{k=18;break a;break};case-1:{k=15;break a;break};case-15:{k=3;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}di(j,c[j+144>>2]|0,b,c[h>>2]|0);break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){di(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function Pi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=ve[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 0:{r=24;break a;break};case-4:case-1:{r=28;break a;break};case-2:{r=25;break a;break};case 40:{r=6;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;se[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}di(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}di(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){se[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Vd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];se[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){Yd[c[n+76>>2]&255](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}di(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function Qi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Pi(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=Ri(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=ti(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Ri(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Ki(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Si(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Si(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=me[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}GR(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Ti(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((fi(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((fi(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=ii(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Ui(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(ve[c[b+16>>2]&63](b,f,g,l)|0){case 9:{o=(ee[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(o<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((fi(h)|0)<<24>>24!=0)){p=42;break a}}q=h+12|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=o;break b}o=ri(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((o|0)==0){p=44;break a}r=ii(n,j,o,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){s=(c[n+300>>2]|0)!=0}else{s=(a[j+129|0]|0)!=0}t=((s^1)&1|0)!=0}else{t=0}u=t&1}else{if((a[j+129|0]|0)!=0){v=(d[j+130|0]|0)!=0}else{v=1}u=v&1}o=(r|0)!=0;if(u<<24>>24!=0){if(!o){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!o){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}o=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;w=Ui(n,c[n+228>>2]|0,e,c[r+4>>2]|0,o,h)|0;a[r+32|0]=0;if((w|0)!=0){p=74;break a}break};case 6:{if((xi(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case-4:{p=3;break a;break};case 0:{p=4;break a;break};case-1:{p=7;break a;break};case 10:{r=me[c[b+44>>2]&63](b,f)|0;if((r|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((r|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);r=$i(r,m)|0;if((r|0)==0){p=19;break a}o=0;while(1){if((o|0)>=(r|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((fi(h)|0)<<24>>24!=0)){p=27;break a}}q=a[m+o|0]|0;x=h+12|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=q;o=o+1|0}break};case 7:case 39:{p=31;break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((fi(h)|0)<<24>>24!=0)){p=37;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=w;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function Vi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ee[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=aj()|0;c[g+240>>2]=$d[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=ve[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){Yd[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}Yd[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Wi(){var a=0,b=0;a=i;i=i+8|0;Zb(((oc(0)|0)>>>0)%4294967295|0|0);b=MR()|0;i=a;return b|0}function Xi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=ni(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=oi(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Yi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=$d[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Zi(f+80|0,e);Zi(b+104|0,e);_i(b,e);_i(b+20|0,e);_i(b+40|0,e);_i(b+60|0,e);a[b+131|0]=0;_i(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Zi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function _i(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function $i(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function aj(){i=i;return 1912}function bj(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[16056+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[16132+l|0]|0|0)!=28){if((d[16132+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[16132+q|0]|0|0)!=28){if((d[16132+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[16132+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((cj(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[10224+(((d[9968+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[10224+(((d[11504+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=$i(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=48;c[h+336>>2]=48;c[h+340>>2]=48;c[h+344>>2]=49;c[h+348>>2]=49;c[h+352>>2]=49;c[h+356>>2]=50;c[h+360>>2]=50;c[h+364>>2]=50}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function cj(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};case 0:{if((d[16132+c|0]|0|0)!=0){e=7;break a}f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function dj(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=me[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[10224+(((d[11504+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function ej(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=me[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[10224+(((d[9968+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function fj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=me[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(cj(a)|0)<0;g=f&1;i=d;return g|0}function gj(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=$i(me[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function hj(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(me[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function ij(){i=i;return 15688}function jj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=kj(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=19;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function kj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((yj(d,c[15592+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function lj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=wl(14032,a,0,b,c,d)|0;i=e;return f|0}function mj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=wl(14032,a,1,b,c,d)|0;i=e;return f|0}function nj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Vk(14800,b,c,d);i=a;return}function oj(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=pj(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function pj(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(xl(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((ve[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,15536)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((xl(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((ve[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,15544)|0)!=0){h=yl(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ee[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((xl(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((ve[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,15560)|0)!=0){if((a|0)!=0){break}do{if((ve[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,15576)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((ve[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,15584)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((zl(yl(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function qj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((yj(h,11760)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=kj(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[14032+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function rj(){i=i;return 13664}function sj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=kj(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=19;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function tj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=wl(11768,a,0,b,c,d)|0;i=e;return f|0}function uj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=wl(11768,a,1,b,c,d)|0;i=e;return f|0}function vj(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=pj(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function wj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((yj(h,11760)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=kj(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[11768+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function xj(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=bj(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function yj(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function zj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 19:{k=ck(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 30:{k=Sj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Qj(a[g+1|0]|0,a[b]|0)|0}switch(n|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=bk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Yj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{g=b;if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[10224+((d[11504+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 10:case 21:{p=25;break};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 13:{k=ak(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=ak(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=Qj(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=Qj(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Qj(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 33:{p=119;break b;break};case 15:{p=122;break b;break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=83;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=91;break b;break};case 34:{p=116;break b;break};case 5:{p=85;break b;break};case 6:{p=88;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Qj(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 6:{p=108;break b;break};case 7:{p=111;break b;break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=105;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function Aj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Qj(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=Rj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=Vj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Qj(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Bj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Qj(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Qj(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Cj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Qj(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Dj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Qj(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 21:{n=29;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Rj(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Qj(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ej(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Qj(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 9:{n=21;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=18;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Rj(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Sj(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Qj(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Fj(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Qj(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{j=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[j]|0)|0]|0}else{n=Qj(a[j+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Gj(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Hj(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Qj(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Ij(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Qj(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Jj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Qj(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Qj(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Kj(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=cj(c)|0;k=j;i=b;return k|0}function Lj(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function Mj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Qj(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Qj(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Nj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Qj(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Oj(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Pj(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Qj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 219:case 218:case 217:case 216:{e=7;break};case 223:case 222:case 221:case 220:{e=8;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function Rj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=Tj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Qj(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Sj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Qj(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Tj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Uj(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Qj(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Uj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Qj(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Qj(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Vj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 15:{k=Yj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Qj(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=Wj(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Xj(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Zj(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Qj(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Qj(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 11:{o=90;break b;break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 17:{break b;break};case 5:{o=39;break b;break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Qj(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 11:{o=90;break c;break};case 17:{break c;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 29:{o=75;break d;break};case 5:{o=78;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=_j(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Wj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Qj(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Xj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[12168+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Yj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Qj(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Qj(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if(($j(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Qj(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if(($j(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Zj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Qj(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Qj(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function _j(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Qj(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Qj(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 6:{l=33;break a;break};case 5:{l=30;break a;break};case 24:case 22:{break};case 7:{l=36;break a;break};case 29:{if((c[10224+((d[9968+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};case 29:{if((c[10224+((d[11504+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 6:{l=13;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=Qj(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 7:{l=16;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=Qj(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=Qj(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=Rj(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=Qj(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=Qj(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 7:{l=103;break a;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[10224+((d[9968+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function $j(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function ak(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Qj(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Qj(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function bk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=Wj(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Qj(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Qj(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function ck(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Qj(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[10224+((d[9968+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Qj(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[10224+((d[11504+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function dk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Qj(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 10:case 21:{n=25;break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;n=77;break};case 30:{k=vk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Qj(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=Qj(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=Bk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=Gk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 29:{g=b;if((c[10224+((d[9968+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;n=77;break a}if((c[10224+((d[11504+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;o=19;n=77;break};case 12:{k=Fk(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=Fk(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=Hk(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;n=77;break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=Qj(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Qj(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 34:{n=116;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};case 7:{n=91;break b;break};case 6:{n=88;break b;break};case 33:{n=119;break b;break};case 15:{n=122;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Qj(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=105;break b;break};case 29:{if((c[10224+((d[11504+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};case 6:{n=108;break b;break};case 7:{n=111;break b;break};default:{o=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 5:{n=85;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}



function Df(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;On(Oa,1,Na);c[Oa+0>>2]=c[2624+0>>2];c[Oa+4>>2]=c[2624+4>>2];c[Oa+8>>2]=c[2624+8>>2];c[Ma>>2]=2;Xm(Pa,16,1,Ma);c[La>>2]=1;Ma=Ym(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=Ym(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;Xm(Qa,16,1,Ja);c[Ia>>2]=1;Ja=Ym(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=Ym(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=Ym(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;Xm(Ua,16,1,Fa);if((xf(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +Mn(2624,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((xf(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=Ym(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(Ym(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((xf(2,2,3)|0)!=0){Fa=2;do{of(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=Ym(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];Ef(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];Ff(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((xf(Fa,2,3)|0)!=0)}if((xf(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +Mn(2624,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((xf(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}of(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=Ym(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];Gf(Ya,0,f+2512|0,f+2496|0);of(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=Ym(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];Gf(_a,0,f+2480|0,f+2464|0);of($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];Ef(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];Ff(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((xf(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +Mn(2624,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((xf(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}of(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=Ym(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];Ef(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;of(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=Ym(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];Hf(db,0,f+2352|0,f+2336|0);of(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=Ym(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];Hf(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];If(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];Ef(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=Ym(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(Ym(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;of(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=Ym(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];Ff(ib,0,f+2240|0,f+2224|0);of(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=Ym(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];Ff(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];If(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];Ef(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=Ym(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(Ym(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;of(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=Ym(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];Hf(nb,0,f+2128|0,f+2112|0);of(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=Ym(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];Hf(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];If(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];Ef(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=Ym(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(Ym(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;of(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=Ym(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];Ff(sb,0,f+2016|0,f+2e3|0);of(tb,0,e/273.16,0.0);c[la>>2]=2;rb=Ym(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];Ff(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];If(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];Ef($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=Ym(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(Ym(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;of(wb,0,2.0,0.0);c[ia>>2]=1;$c=Ym(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];Ef(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=Ym(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];If(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];Ef(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=Ym(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(Ym(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;of(zb,0,2.0,0.0);c[ea>>2]=2;ad=Ym(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];Ef(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=Ym(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];If(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];Ef(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=Ym(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(Ym(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;of(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=Ym(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];Gf(cd,0,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=Ym(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(Ym(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;of(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=Ym(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];Gf(dd,0,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=Ym(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Air_ReferenceMoistAir_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function Ef(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];of(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function Ff(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;of(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function Gf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;of(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function Hf(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;of(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function If(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];wf(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[16252]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=4848;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];we[d&31](b,f,2640,g);}of(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function Jf(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function Kf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;i=i+72|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+32|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+32|0;w=i;i=i+32|0;x=i;i=i+8|0;y=i;i=i+8|0;z=r+16|0;c[q>>2]=2;On(z,1,q);c[p>>2]=2;On(z,1,p);if((Hm(f,1)|0)==2){p=m;q=f;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];Lf(x,b,d,e,m);A=+h[x>>3];x=s;m=l;q=f;c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];pf(x,0,d,A,l);l=s;s=w;c[s+0>>2]=c[l+0>>2];c[s+4>>2]=c[l+4>>2];c[s+8>>2]=c[l+8>>2];c[s+12>>2]=c[l+12>>2];c[s+16>>2]=c[l+16>>2];c[s+20>>2]=c[l+20>>2];c[s+24>>2]=c[l+24>>2];c[s+28>>2]=c[l+28>>2];B=w;C=B;D=+h[C>>3];E=r;F=E;h[F>>3]=D;G=w;H=G+8|0;I=H;J=+h[I>>3];K=r;L=K+8|0;M=L;h[M>>3]=J;N=w;O=N+16|0;P=O;Pn(P,z);Q=r;R=a;c[R+0>>2]=c[Q+0>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];c[R+12>>2]=c[Q+12>>2];c[R+16>>2]=c[Q+16>>2];c[R+20>>2]=c[Q+20>>2];c[R+24>>2]=c[Q+24>>2];c[R+28>>2]=c[Q+28>>2];i=g;return}else{l=k;s=f;c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];Lf(y,b,d,e,k);e=+h[y>>3];A=1.0- +Wn(f);Tn(t,1,A,o);c[n>>2]=t;Vn(1,u,2,f,n);n=v;f=j;t=u;c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];pf(n,0,d,e,j);j=v;v=w;c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];c[v+16>>2]=c[j+16>>2];c[v+20>>2]=c[j+20>>2];c[v+24>>2]=c[j+24>>2];c[v+28>>2]=c[j+28>>2];B=w;C=B;D=+h[C>>3];E=r;F=E;h[F>>3]=D;G=w;H=G+8|0;I=H;J=+h[I>>3];K=r;L=K+8|0;M=L;h[M>>3]=J;N=w;O=N+16|0;P=O;Pn(P,z);Q=r;R=a;c[R+0>>2]=c[Q+0>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];c[R+12>>2]=c[Q+12>>2];c[R+16>>2]=c[Q+16>>2];c[R+20>>2]=c[Q+20>>2];c[R+24>>2]=c[Q+24>>2];c[R+28>>2]=c[Q+28>>2];i=g;return}}function Lf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;g=i;i=i+24|0;j=g;l=g+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;c[q>>2]=2;On(r,1,q);if((Hm(f,1)|0)==2){q=t;v=f;c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2]}else{w=1.0- +Wn(f);Tn(s,1,w,p);c[o>>2]=s;Vn(1,t,2,f,o)}o=r;f=t;c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[n>>2]=1;w=+h[(Un(r,1,n)|0)>>3];c[m>>2]=2;x=+h[(Un(r,1,m)|0)>>3];m=l;h[k>>3]=x;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Tn(u,2,w,l);l=a;a=j;m=u;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];gf(l,b,d,e,j,173.15,2.0e3,1.0e-9);i=g;return}function Mf(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function Nf(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;mf(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function Of(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;On(g,1,f);f=g;g=2728;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;On(j,1,e);e=j;j=2744;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((xf(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+Mn(2728,j);t=s+d*+W(+k,+(+Mn(2744,j)));j=r+1|0;if((xf(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function Pf(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Qf(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Mf(b,0,0.0,0.0,g);i=f;return}function Qf(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;Df(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+to(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function Rf(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Sf(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Qf(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Rf(b,0,0.0,0.0,g);i=f;return}function Tf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(Un(f,1,n)|0)>>3]==0.0){qf(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];jg(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(Un(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(Un(f,1,l)|0)>>3]);kg(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){qf(u,b,G,e);J=+h[u>>3];Af(v,b,F,e,0);K=J+I*+h[v>>3];break}else{qf(r,b,G,e);J=+h[r>>3];Af(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];ng(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){qf(w,b,G,e);L=+h[w>>3];Af(x,b,F,e,0);J=+h[x>>3];Pf(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{qf(z,b,G,e);J=+h[z>>3];Af(A,b,F,e,0);L=+h[A>>3];og(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function Uf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(Un(f,1,n)|0)>>3]==0.0){yf(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];jg(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(Un(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(Un(f,1,l)|0)>>3]);kg(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){yf(u,b,G,e);J=+h[u>>3];Cf(v,b,F,e,0);K=J+I*+h[v>>3];break}else{yf(r,b,G,e);J=+h[r>>3];Cf(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];lg(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){yf(w,b,G,e);L=+h[w>>3];Cf(x,b,F,e,0);J=+h[x>>3];Sf(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{yf(z,b,G,e);J=+h[z>>3];Cf(A,b,F,e,0);L=+h[A>>3];mg(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function Vf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;g=i;i=i+24|0;j=g;l=g+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;c[q>>2]=2;On(r,1,q);if((Hm(f,1)|0)==2){q=t;v=f;c[q+0>>2]=c[v+0>>2];c[q+4>>2]=c[v+4>>2];c[q+8>>2]=c[v+8>>2]}else{w=1.0- +Wn(f);Tn(s,1,w,p);c[o>>2]=s;Vn(1,t,2,f,o)}o=r;f=t;c[o+0>>2]=c[f+0>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[n>>2]=1;w=+h[(Un(r,1,n)|0)>>3];c[m>>2]=2;x=+h[(Un(r,1,m)|0)>>3];m=l;h[k>>3]=x;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Tn(u,2,w,l);l=a;a=j;m=u;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];kf(l,b,d,e,j,173.15,2.0e3,1.0e-9);i=g;return}function Wf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;On(u,1,n);c[m>>2]=2;On(u,1,m);if((Hm(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];pf(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +Wn(f);Tn(q,1,w,l);c[k>>2]=q;Vn(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];pf(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];Pn(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function Xf(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){Of(j,0,d);m=+h[j>>3];Nf(k,b,c);n=+h[k>>3];o=m}else{Yf(f,b,d);m=+h[f>>3];Zf(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}_f(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function Yf(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;On(l,1,j);j=l;l=2760;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+kd(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[16252]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=4848;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];we[j&31](b,f,3424,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function Zf(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;On(n,1,m);m=n;n=2760;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[16252]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=4848;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];we[m&31](b,g,2776,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[16252]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=4848;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];we[g&31](b,f,2856,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function _f(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function $f(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function ag(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(Un(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[16252]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=4848;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];we[f&31](b,j,2992,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function bg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(Un(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[16252]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=4848;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];we[p&31](b,j,3064,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(Un(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function cg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(Un(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[16252]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=4848;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];we[p&31](b,j,2992,m);}c[l>>2]=1;h[a>>3]=+h[(Un(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function dg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(Un(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(Un(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(Un(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(Un(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Tn(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];cg(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[16252]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=4848;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];we[l&31](b,j,3136,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function eg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(Un(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(Un(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[16252]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=4848;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];we[f&31](b,j,3336,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function fg(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function gg(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function hg(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function ig(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function jg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(Un(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(Un(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(Un(f,1,j)|0)>>3]);Xf(m,b,d,e);r=+h[m>>3];kg(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function kg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;Xf(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){Zf(j,b,c);l=+h[j>>3]}else{Nf(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function lg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;On(Na,1,Ma);c[La>>2]=4;On(Oa,1,La);c[Ka>>2]=4;On(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(Un(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(Un(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(Un(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(Un(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Tn(Qa,4,ob,Fa);Pn(Qa,Oa);Qa=(xf(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+Mn(3504,Fa+ -1|0);c[Ea>>2]=Fa;h[(Un(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((xf(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(Un(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(Un(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(Un(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(Un(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(Un(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(Un(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(Un(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(Un(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(Un(Oa,1,va)|0)>>3];pb=sb*(ob/+Mn(3504,Qa+ -1|0));c[ua>>2]=Qa;h[(Un(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((xf(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(Un(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(Un(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(Un(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(Un(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];Tn(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];cg($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(Un(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(Un(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(Un(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(Un(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];Tn(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];bg(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(Un(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(Un(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(Un(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(Un(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];Tn(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];dg(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(Un(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(Un(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(Un(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(Un(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];Tn(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];ag(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(Un(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(Un(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(Un(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(Un(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Tn(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];eg(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(Un(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(Un(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(Un(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(Un(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Tn(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];cg(eb,b,d,e,o);tb=+h[eb>>3];$f(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(Un(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(Un(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(Un(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(Un(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Tn(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];bg(gb,b,d,e,n);qb=+h[gb>>3];gg(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(Un(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(Un(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(Un(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(Un(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Tn(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];dg(ib,b,d,e,m);vb=+h[ib>>3];fg(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(Un(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(Un(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(Un(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(Un(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Tn(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];ag(kb,b,d,e,l);d=+h[kb>>3];hg(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(Un(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(Un(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(Un(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(Un(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Tn(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];eg(mb,b,0.0,e,j);yb=+h[mb>>3];ig(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(Un(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(Un(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(Un(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(Un(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function mg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;Mg(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));Rg(f,0,0.0,0.0,h);i=g;return}function ng(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;On(Na,1,Ma);c[La>>2]=4;On(Oa,1,La);c[Ka>>2]=4;On(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(Un(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(Un(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(Un(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(Un(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Tn(Qa,4,ob,Fa);Pn(Qa,Oa);Qa=(xf(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+Mn(3504,Fa+ -1|0);c[Ea>>2]=Fa;h[(Un(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((xf(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(Un(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(Un(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(Un(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(Un(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(Un(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(Un(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(Un(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(Un(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(Un(Oa,1,va)|0)>>3];pb=sb*(ob/+Mn(3504,Qa+ -1|0));c[ua>>2]=Qa;h[(Un(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((xf(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(Un(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(Un(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(Un(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(Un(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];Tn(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];cg($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(Un(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(Un(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(Un(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(Un(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];Tn(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];bg(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(Un(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(Un(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(Un(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(Un(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];Tn(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];dg(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(Un(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(Un(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(Un(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(Un(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];Tn(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];ag(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(Un(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(Un(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(Un(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(Un(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Tn(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];eg(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(Un(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(Un(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(Un(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(Un(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Tn(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];cg(eb,b,d,e,o);tb=+h[eb>>3];$f(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(Un(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(Un(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(Un(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(Un(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Tn(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];bg(gb,b,d,e,n);qb=+h[gb>>3];gg(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(Un(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(Un(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(Un(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(Un(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Tn(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];dg(ib,b,d,e,m);vb=+h[ib>>3];fg(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(Un(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(Un(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(Un(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(Un(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Tn(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];ag(kb,b,d,e,l);d=+h[kb>>3];hg(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(Un(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(Un(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(Un(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(Un(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Tn(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];eg(mb,b,0.0,e,j);yb=+h[mb>>3];ig(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(Un(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(Un(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(Un(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(zb*((yb+(pb+(d+ +h[(Un(Oa,1,u)|0)>>3]/.039948)))/ub)*e);i=g;return}function og(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;Mg(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));Ng(f,0,0.0,0.0,h);i=g;return}function pg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;i=i+72|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+32|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+32|0;w=i;i=i+32|0;x=i;i=i+8|0;y=i;i=i+8|0;z=r+16|0;c[q>>2]=2;On(z,1,q);c[p>>2]=2;On(z,1,p);if((Hm(f,1)|0)==2){p=m;q=f;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];Vf(x,b,d,e,m);A=+h[x>>3];x=s;m=l;q=f;c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];pf(x,0,d,A,l);l=s;s=w;c[s+0>>2]=c[l+0>>2];c[s+4>>2]=c[l+4>>2];c[s+8>>2]=c[l+8>>2];c[s+12>>2]=c[l+12>>2];c[s+16>>2]=c[l+16>>2];c[s+20>>2]=c[l+20>>2];c[s+24>>2]=c[l+24>>2];c[s+28>>2]=c[l+28>>2];B=w;C=B;D=+h[C>>3];E=r;F=E;h[F>>3]=D;G=w;H=G+8|0;I=H;J=+h[I>>3];K=r;L=K+8|0;M=L;h[M>>3]=J;N=w;O=N+16|0;P=O;Pn(P,z);Q=r;R=a;c[R+0>>2]=c[Q+0>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];c[R+12>>2]=c[Q+12>>2];c[R+16>>2]=c[Q+16>>2];c[R+20>>2]=c[Q+20>>2];c[R+24>>2]=c[Q+24>>2];c[R+28>>2]=c[Q+28>>2];i=g;return}else{l=k;s=f;c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];Vf(y,b,d,e,k);e=+h[y>>3];A=1.0- +Wn(f);Tn(t,1,A,o);c[n>>2]=t;Vn(1,u,2,f,n);n=v;f=j;t=u;c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];pf(n,0,d,e,j);j=v;v=w;c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];c[v+16>>2]=c[j+16>>2];c[v+20>>2]=c[j+20>>2];c[v+24>>2]=c[j+24>>2];c[v+28>>2]=c[j+28>>2];B=w;C=B;D=+h[C>>3];E=r;F=E;h[F>>3]=D;G=w;H=G+8|0;I=H;J=+h[I>>3];K=r;L=K+8|0;M=L;h[M>>3]=J;N=w;O=N+16|0;P=O;Pn(P,z);Q=r;R=a;c[R+0>>2]=c[Q+0>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];c[R+12>>2]=c[Q+12>>2];c[R+16>>2]=c[Q+16>>2];c[R+20>>2]=c[Q+20>>2];c[R+24>>2]=c[Q+24>>2];c[R+28>>2]=c[Q+28>>2];i=g;return}}function qg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Kf(k,b,d,e,j);j=a;a=h;b=k;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];rg(j,0,h);i=g;return}function rg(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function sg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Wf(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];tg(j,b,h);i=g;return}function tg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(Un(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(Un(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Tn(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Tf(d,b,o,p,f);i=e;return}function ug(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Wf(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];vg(j,b,h);i=g;return}function vg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(Un(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(Un(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Tn(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Uf(d,b,o,p,f);i=e;return}function wg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];pg(k,b,d,e,j);j=a;a=h;b=k;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];rg(j,0,h);i=g;return}function xg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;On(k,1,j);j=k;k=3520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=zn(zn(3536,xn(d,0,1,6)|0)|0,3608)|0;j=zn(zn(k,xn(611.657,0,1,6)|0)|0,3616)|0;k=c[16252]|0;s=f;t=3736;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];we[k&31](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function yg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;On(ia,1,ha);if(!(d>611.657)){ha=zn(zn(3760,xn(d,0,1,6)|0)|0,3608)|0;ja=zn(zn(ha,xn(611.657,0,1,6)|0)|0,3616)|0;ha=c[16252]|0;ka=f;la=3824;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];we[ha&31](b,f,ja,ga);}ma=+kd(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(Un(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(Un(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(Un(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(Un(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(Un(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(Un(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(Un(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(Un(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(Un(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(Un(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(Un(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(Un(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(Un(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(Un(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(Un(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(Un(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(Un(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(Un(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(Un(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(Un(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(Un(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(Un(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(Un(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(Un(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(Un(ia,1,H)|0)>>3];c[G>>2]=12;h[(Un(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(Un(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(Un(ia,1,E)|0)>>3];c[D>>2]=13;h[(Un(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(Un(ia,1,C)|0)>>3]));c[B>>2]=14;h[(Un(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(Un(ia,1,A)|0)>>3];c[z>>2]=15;h[(Un(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(Un(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(Un(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(Un(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(Un(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(Un(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(Un(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(Un(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(Un(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(Un(ia,1,q)|0)>>3];c[p>>2]=19;h[(Un(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(Un(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(Un(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(Un(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(Un(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(Un(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(Un(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(Un(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function _omc_Modelica_Media_Air_ReferenceMoistAir_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(Ym(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=Ym(x,16,1,Ua)|0;c[Va>>2]=2;Db=Ym(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];Ff(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=Ym(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];Hf(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=Ym(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];Hf(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=Ym(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(Ym(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=Ym(x,16,1,_a)|0;c[$a>>2]=4;Cb=Ym(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];Ff(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=Ym(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];Hf(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=Ym(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];Hf(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=Ym(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(Ym(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=Ym(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];Ef(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=Ym(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];Ef(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];Ff(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];Jf(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=Ym(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];Ef(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];Jf(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=Ym(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];Ef(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];Jf(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;of(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=Ym(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];Ff(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];If(G,d,a+1248|0);of(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=Ym(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];Gf(I,0,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];Hf(J,0,a+1200|0,a+1184|0);of(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=Ym(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];Hf(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];If(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];Hf(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=Ym(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(Ym(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;of(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=Ym(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];Ff(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];If(P,d,a+1056|0);of(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=Ym(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];Hf(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];If(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];Hf(T,0,a+992|0,a+976|0);of(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=Ym(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];Gf(V,0,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];Hf(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=Ym(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(Ym(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=Ym(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];Ef(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=Ym(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];Ef(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];Ff(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];Jf(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;of($,0,1.0,0.0);of(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=Ym(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];Hf(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];Gf(ca,0,a+752|0,a+736|0);of(da,0,1.0,0.0);of(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=Ym(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];Ff(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];Gf(ga,0,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];Ff(ha,0,a+656|0,a+640|0);of(ia,0,2.0,0.0);c[wb>>2]=1;Cb=Ym(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];Gf(ja,0,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];Hf(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];Ef(la,0,a+560|0,a+544|0);of(ma,0,1.0,0.0);of(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=Ym(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];Hf(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];Gf(pa,0,a+496|0,a+480|0);of(qa,0,1.0,0.0);of(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=Ym(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];Ff(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];Gf(ta,0,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];Ff(ua,0,a+400|0,a+384|0);of(va,0,2.0,0.0);c[zb>>2]=2;Cb=Ym(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];Gf(wa,0,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];Hf(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];Ef(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];Ff(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];Jf(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;of(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=Ym(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];Ff(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];If(Ca,d,a+192|0);of(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=Ym(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];Gf(Ea,0,a+176|0,a+160|0);of(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=Ym(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];Hf(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];If(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];Ff(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];Hf(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];Ef(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];Jf(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function Zo(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[43684>>2]=6;FF(43680)|0;WE(44424,j,4)|0;nF()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[10222]=0;c[10828]=0;c[10816]=0;a[43288]=0;t=c[e>>2]|0;c[9776]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[10222]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[9776]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[9776]=1;if((v|0)>=1){x=1;while(1){h[35576+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[9776]=v+1}c[10820]=2;x=c[e>>2]|0;c[9776]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[9778]=1;if((E|0)<1){F=C}else{G=1;while(1){h[35576+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[9778]=E+1;F=+h[B>>3]}h[35576+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[10820]=G;D=G}G=z+1|0;c[9776]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[10222]|0;y=z+1|0;c[10218]=y;c[9776]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[9778]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[35576+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[9778]=x+1}ee[u&63](e,b,38936+(z+ -1<<3)|0)|0;c[10828]=(c[10828]|0)+1;if((c[j>>2]|0)>=1){c[43708>>2]=6;FF(43704)|0;WE(44424,43312,4)|0;WE(44424,38936+((c[9776]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[9778]=1;if((v|0)>=1){A=1;do{WE(44424,b+(A+ -1<<3)|0,8)|0;B=c[9778]|0;A=B+1|0;c[9778]=A;}while((B|0)<(v|0))}nF()|0}v=c[9776]|0;z=v+1|0;c[9776]=z;}while((v|0)<(y|0))}y=c[10816]|0;b:while(1){c[10816]=y+1;c[10728]=1;c[10724]=1;C=+h[4867];h[5363]=C;h[5365]=C;z=c[10218]|0;c[9776]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[38936+(A+ -1<<3)>>3];do{if(!(C<=K)){c[10728]=A;L=+h[38936+(A+ -1<<3)>>3];h[5363]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[10724]=A;L=+h[38936+(A+ -1<<3)>>3];h[5365]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[9776]=z+1;H=O}A=c[e>>2]|0;c[9776]=1;if((A|0)>=1){v=1;while(1){h[41056+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[9776]=A+1}c[9776]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[9778]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=41056+(Q+ -1<<3)|0;h[B>>3]=+h[35576+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[9778]=x+1;P=v}}while(0);v=P+1|0;c[9776]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[9778]=1;if((z|0)>=1){K=+(c[10222]|0);v=1;while(1){A=41056+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[9778]=z+1}v=c[e>>2]|0;c[9776]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[41056+(B<<3)>>3];h[43336+(B<<3)>>3]=K+(K- +h[35576+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[9776]=v+1}ee[u&63](e,43336,43328)|0;A=(c[10828]|0)+1|0;c[10828]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[43732>>2]=6;FF(43728)|0;WE(44424,43312,4)|0;WE(44424,43328,8)|0;B=c[e>>2]|0;c[9778]=1;if((B|0)>=1){E=1;do{WE(44424,43336+(E+ -1<<3)|0,8)|0;G=c[9778]|0;E=G+1|0;c[9778]=E;}while((G|0)<(B|0))}nF()|0}}while(0);K=+h[5416];c:do{if(!(K>=+h[5365])){z=c[e>>2]|0;c[9776]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[41056+(v<<3)>>3];h[43504+(v<<3)>>3]=I+(+h[43336+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[9776]=z+1}ee[u&63](e,43504,43496)|0;A=(c[10828]|0)+1|0;c[10828]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[43756>>2]=6;FF(43752)|0;WE(44424,43312,4)|0;WE(44424,43496,8)|0;B=c[e>>2]|0;c[9778]=1;if((B|0)>=1){E=1;do{WE(44424,43504+(E+ -1<<3)|0,8)|0;G=c[9778]|0;E=G+1|0;c[9778]=E;}while((G|0)<(B|0))}nF()|0}}while(0);I=+h[5437];if(I>=+h[5365]){R=118;break}v=c[e>>2]|0;c[9776]=1;A=c[10728]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[35576+((z*21|0)+ -22+A<<3)>>3]=+h[43504+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[9776]=v+1}h[38936+(A+ -1<<3)>>3]=I}else{z=c[10218]|0;c[9776]=1;if((z|0)>=1){B=c[10728]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[38936+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[9776]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[5363])){E=c[e>>2]|0;c[9776]=1;z=c[10728]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[35576+((B*21|0)+ -22+z<<3)>>3]=+h[43336+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[9776]=E+1}h[5363]=K;h[38936+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[9776]=1;if((B|0)>=1){A=c[10728]|0;v=1;while(1){x=v+ -1|0;h[43504+(x<<3)>>3]=+h[35576+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[41056+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[9776]=B+1}ee[u&63](e,43504,43496)|0;v=(c[10828]|0)+1|0;c[10828]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[43780>>2]=6;FF(43776)|0;WE(44424,43312,4)|0;WE(44424,43496,8)|0;z=c[e>>2]|0;c[9778]=1;if((z|0)>=1){E=1;do{WE(44424,43504+(E+ -1<<3)|0,8)|0;x=c[9778]|0;E=x+1|0;c[9778]=E;}while((x|0)<(z|0))}nF()|0}}while(0);I=+h[5437];if(!(I>+h[5363])){A=c[e>>2]|0;c[9776]=1;v=c[10728]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[35576+((B*21|0)+ -22+v<<3)>>3]=+h[43504+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[9776]=A+1}h[38936+(v+ -1<<3)>>3]=I;break}B=c[10218]|0;c[9776]=1;if((B|0)<1){break}else{S=1}do{z=c[10724]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[9778]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=35576+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[35576+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[35576+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[9778]=E+1}ee[u&63](e,b,38936+(S+ -1<<3)|0)|0;G=(c[10828]|0)+1|0;c[10828]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[43804>>2]=6;FF(43800)|0;WE(44424,43312,4)|0;WE(44424,38936+((c[9776]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[9778]=1;if((x|0)>=1){G=1;do{WE(44424,b+(G+ -1<<3)|0,8)|0;T=c[9778]|0;G=T+1|0;c[9778]=G;}while((T|0)<(x|0))}nF()|0}}while(0);z=c[9776]|0;S=z+1|0;c[9776]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[9776]=1;v=c[10728]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[35576+((A*21|0)+ -22+v<<3)>>3]=+h[43336+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[9776]=B+1}h[38936+(v+ -1<<3)>>3]=+h[5416]}A=c[10816]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[5366]=0.0;h[5412]=0.0;A=c[10218]|0;c[9776]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[5412]=0.0/K;c[9776]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[38936+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[5412]=I;c[9776]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[38936+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[5366]=$;c[9776]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[5366]=I;do{if(!(I<=+h[k>>3])){if((c[10828]|0)>(c[g>>2]|0)){break}a[43288]=0;c[10816]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[9776]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[9778]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[35576+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[9778]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[9776]=v+1}ee[u&63](e,b,f)|0;B=(c[10828]|0)+1|0;c[10828]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[43828>>2]=6;FF(43824)|0;WE(44424,43312,4)|0;WE(44424,s,8)|0;z=c[e>>2]|0;c[9778]=1;if((z|0)>=1){E=1;do{WE(44424,b+(E+ -1<<3)|0,8)|0;x=c[9778]|0;E=x+1|0;c[9778]=E;}while((x|0)<(z|0))}nF()|0;ba=c[10828]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[43948>>2]=6;FF(43944)|0;nF()|0;c[43972>>2]=6;FF(43968)|0;B=c[e>>2]|0;c[9776]=1;if((B|0)>=1){A=1;do{WE(44424,b+(A+ -1<<3)|0,8)|0;v=c[9776]|0;A=v+1|0;c[9776]=A;}while((v|0)<(B|0))}nF()|0;c[43996>>2]=6;FF(43992)|0;WE(44424,s,8)|0;nF()|0}if(a[43288]&1){I=+h[5412];K=+h[5458]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[43288]=1;da=+h[5412]}h[5458]=da;c[10816]=0;y=0}if((c[j>>2]|0)>=0){c[44020>>2]=6;FF(44016)|0;WE(44424,43312,4)|0;nF()|0;c[44044>>2]=6;FF(44040)|0;y=c[e>>2]|0;c[9776]=1;if((y|0)>=1){B=1;do{WE(44424,b+(B+ -1<<3)|0,8)|0;A=c[9776]|0;B=A+1|0;c[9776]=B;}while((A|0)<(y|0))}nF()|0;c[44068>>2]=6;FF(44064)|0;WE(44424,s,8)|0;nF()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[44092>>2]=6;FF(44088)|0;nF()|0}h[5365]=+h[f>>3];c[10830]=0;y=c[10218]|0;c[9776]=1;if((y|0)>=1){B=1;while(1){A=38936+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[9776]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[9778]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=35576+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[43504+(E+ -1<<3)>>3]=+h[35576+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[9778]=v+1}ee[u&63](e,43504,A)|0;c[10830]=(c[10830]|0)+1;c[10828]=(c[10828]|0)+1;E=c[9776]|0;I=+h[38936+(E+ -1<<3)>>3];if(I>=+h[5365]){B=E;continue}h[5365]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[44116>>2]=6;FF(44112)|0;WE(44424,43312,4)|0;WE(44424,42920,8)|0;E=c[e>>2]|0;c[9778]=1;if((E|0)>=1){z=1;do{WE(44424,43504+(z+ -1<<3)|0,8)|0;G=c[9778]|0;z=G+1|0;c[9778]=z;}while((G|0)<(E|0))}nF()|0;B=c[9776]|0}}B=c[10222]|0;c[9776]=1;do{if((B|0)<1){h[4892]=+h[4867];c[9776]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[9786]=E;z=c[e>>2]|0;c[9778]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[43336+(A+ -1<<3)>>3]=(+h[35576+(v+ -21<<3)>>3]+ +h[35576+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[9778]=z+1}ee[u&63](e,43336,40896+(y+ -1<<3)|0)|0;c[10830]=(c[10830]|0)+1;c[10828]=(c[10828]|0)+1;A=c[9776]|0;y=A+1|0;c[9776]=y;}while((A|0)<(B|0));y=c[10222]|0;I=+h[4867];h[4892]=I;c[9776]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[9786]=A;c[9788]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[9778]=1;E=1;while(1){v=E+1|0;c[9790]=v;G=c[e>>2]|0;c[9780]=1;if((G|0)>=1){x=c[9788]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[43504+(T+ -1<<3)>>3]=(+h[35576+(U+x<<3)>>3]+ +h[35576+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[9780]=G+1}ee[u&63](e,43504,43496)|0;c[10830]=(c[10830]|0)+1;c[10828]=(c[10828]|0)+1;T=c[9776]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[9778]|0;la=U+x|0;c[9782]=la;I=+h[4892];h[41216+(la+ -1<<3)>>3]=(+h[5437]+I- +h[40896+(v<<3)>>3]- +h[40896+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[9778]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[9776]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[10222]|0;c[9782]=0;c[9776]=1;E=(y|0)<1;if(E){c[9776]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=XR(A|0,0,y+ -2|0,0)|0;A=QR(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[41216+(U+ -1<<3)>>3]=(+h[38936+(v<<3)>>3]+ka- +h[40896+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[9786]=v+1;c[9782]=(z|1)+A;c[9776]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=40896+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[38936+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[9786]=T+1;c[9776]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[9782]=0;c[9776]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[9776]=1;if((B|0)>=1){A=1;while(1){h[42936+(A+ -1<<3)>>3]=+h[35576+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[9776]=B+1}c[9776]=1;do{if(ma){c[9776]=1}else{A=1;while(1){z=A+1|0;c[9786]=z;v=c[e>>2]|0;c[9778]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=35576+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[35576+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[9778]=v+1}c[9776]=z;if((A|0)<(na|0)){A=z}else{break}}c[9776]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[9786]=A;y=c[e>>2]|0;c[9778]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[35576+(T+oa<<3)>>3]=+h[35576+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[9778]=y+1}c[9776]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=41216;_o(B,40888,B,43096,43672,q,43256)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[44140>>2]=6;FF(44136)|0;nF()|0}c[q>>2]=2;if((c[10828]|0)>(c[g>>2]|0)){R=312;break}c[44164>>2]=6;FF(44160)|0;nF()|0;B=c[e>>2]|0;c[9776]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[9776]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[43852>>2]=6;FF(43848)|0;WE(44424,g,4)|0;nF()|0;c[43876>>2]=6;FF(43872)|0;WE(44424,42928,8)|0;nF()|0;c[43900>>2]=6;FF(43896)|0;u=c[e>>2]|0;c[9776]=1;if((u|0)>=1){E=1;do{WE(44424,b+(E+ -1<<3)|0,8)|0;z=c[9776]|0;E=z+1|0;c[9776]=E;}while((z|0)<(u|0))}nF()|0;c[43924>>2]=6;FF(43920)|0;WE(44424,s,8)|0;nF()|0;i=r;return 0}else if((R|0)==226){u=c[10222]|0;c[10826]=u-(c[10918]|0);c[9776]=1;E=(u|0)<1;do{if(E){h[5409]=0.0;c[9776]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[38936+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=38936+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[41216+(sa+ -1<<3)>>3]*+h[40896+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[9782]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[9778]=z;h[5409]=0.0;c[9776]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[38936+(v<<3)>>3]*+h[40896+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[5409]=wa;c[9776]=u+1;qa=wa}}while(0);h[5409]=+h[4892]-qa;s=c[e>>2]|0;c[9776]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[43504+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=43504+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[38936+(T+ -1<<3)>>3]*+h[35576+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[9776]=s+1;c[9778]=xa}v=c[e>>2]|0;c[9776]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=42936+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[43504+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[9776]=v+1}if((c[j>>2]|0)>=0){c[44188>>2]=6;FF(44184)|0;WE(44424,43272,8)|0;z=c[e>>2]|0;c[9776]=1;if((z|0)>=1){s=1;do{WE(44424,42936+(s+ -1<<3)|0,8)|0;u=c[9776]|0;s=u+1|0;c[9776]=s;}while((u|0)<(z|0))}nF()|0;c[44212>>2]=6;FF(44208)|0;nF()|0}z=c[e>>2]|0;c[9776]=1;if((z|0)>=1){s=c[10222]|0;v=1;while(1){c[9778]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[38936+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=38936+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[41216+(Aa+ -1<<3)>>3]*+h[35576+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[9782]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[9780]=E;c[9778]=s+1}T=c[e>>2]|0;c[9778]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=39192+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[38936+(Ea+ -1<<3)>>3]*+h[35576+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[9778]=T+1;c[9782]=Ca;c[9780]=Da}za=v+1|0;c[9776]=za;if((v|0)<(z|0)){v=za}else{break}}}c[9778]=0;v=c[e>>2]|0;c[9776]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[39192+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[9778]=Ga;c[9776]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[44236>>2]=6;FF(44232)|0;WE(44424,43304,4)|0;nF()|0;c[10220]=1;z=1;d:while(1){c[9782]=z;do{if((z|0)>(c[e>>2]|0)){s=c[10220]|0;if((s|0)==1){c[44260>>2]=6;FF(44256)|0;nF()|0;_o(39192,40888,41216,43096,43672,q,43256)|0;c[44284>>2]=6;FF(44280)|0;nF()|0;c[10220]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[10220]=2;c[9792]=0;c[9794]=0;s=c[e>>2]|0;c[9776]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=XR(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=QR(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=39192+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=39192+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[39192+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[9796]=Na;c[9794]=Ta;c[9792]=Ia;c[9778]=Ma;c[9776]=s+1}c[44308>>2]=6;FF(44304)|0;nF()|0;c[9792]=0;u=c[e>>2]|0;c[9776]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=39192+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[9792]=Wa;c[9776]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[9792]=T;s=c[e>>2]|0;c[9776]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[9786]=B;Qa=za+la|0;c[9792]=Qa;Pa=B+5|0;c[9788]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[10220]|0)==3){c[44380>>2]=6;FF(44376)|0;Pa=c[9788]|0;Qa=c[9786]|0;c[9778]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{WE(44424,41216+(B+ -1<<3)|0,8)|0;Qa=c[9778]|0;B=Qa+1|0;c[9778]=B;}while((Qa|0)<(Pa|0))}nF()|0}else{c[44356>>2]=6;FF(44352)|0;Pa=c[9788]|0;B=c[9786]|0;c[9778]=B;if((B|0)<=(Pa|0)){x=B;do{WE(44424,39192+(x+ -1<<3)|0,8)|0;B=c[9778]|0;x=B+1|0;c[9778]=x;}while((B|0)<(Pa|0))}nF()|0}Pa=c[9776]|0;x=Pa+1|0;c[9776]=x;if((Pa|0)>=(s|0)){break e}E=c[9782]|0;la=c[9792]|0;za=x}}}while(0);c[44404>>2]=6;FF(44400)|0;nF()|0;z=(c[9782]|0)+6|0}c[44332>>2]=6;FF(44328)|0;WE(44424,43320,4)|0;nF()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ee[p&63](e,b,f)|0;i=r;return 0}function _o(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[11126]=c[b>>2];c[g>>2]=1;if((c[11126]|0)<1){i=k;return 0}c[g>>2]=0;$o(a,44504,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[11126]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[11118]=f;c[11124]=g;c[11130]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=XR(a|0,0,g+ -2|0,0)|0;m=QR(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[11110]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=XR(p|0,0,a-n|0,0)|0;p=QR(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[11110]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[11108]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[11108]=j}c[11120]=g;c[11122]=f;c[11128]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[5558]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[5558]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[5558]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[11128]=D;E=v+ -1|0;c[11120]=E;F=w+ -1|0;c[11122]=F;q=D;v=E;w=F}c[11112]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[11114]=t;c[11124]=0;c[11130]=l-g;i=k;return 0}function $o(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[5572]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[5572]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[5572];c[11134]=1;c[11136]=0;n=c[b>>2]|0;c[11148]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[11138]=0;c[11150]=1;do{if((o|0)>=1){p=1;q=c[11136]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[5571]=m;u=(p|0)==(o|0);if(u){l=m*+h[5572];h[5573]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[5571]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[5573]=+h[5573]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[11138]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[11138]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[5571];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[11150]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[11132]=y;c[11140]=x;c[11136]=s;break}else if((D|0)==26){D=0;c[11132]=y;c[11140]=x;c[11136]=s;break}}}while(0);m=+V(+(+h[5573]));h[5573]=m;H=+h[5571];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[11136]|0)+ -1<<3)>>3]=G;G=+h[5573]/+h[5571];h[j+((c[11132]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[11136]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[11134]|0;O=c[11148]|0}}while(0);b=N+O|0;c[11134]=b;o=O+1|0;c[11148]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[11132]=y;c[11140]=x;c[11136]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function ap(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[11174]=n;o=(c[d>>2]|0)-n|0;c[11196]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[11194]=s;a[44720]=1;t=c[b>>2]|0;u=t+1|0;c[11190]=u;v=c[b>>2]|0;w=u+v|0;c[11188]=w;u=w+(c[b>>2]|0)|0;c[11192]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[11182]=w;x=w+(c[d>>2]|0)|0;c[11176]=x;y=x+(c[b>>2]|0)|0;c[11178]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[11184]=z;A=z+(c[d>>2]|0)|0;c[11198]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[11200]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[11172]=C;D=C+(c[b>>2]|0)|0;c[11186]=D;bp(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,44776,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);FF(44808)|0;nF()|0;i=m;return 0}function bp(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[5686]=.5;h[5677]=1.0;h[5717]=.1;F=(c[a>>2]|0)+1|0;c[11350]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[11342]=H;I=(c[b>>2]|0)-F|0;c[11396]=I;F=c[j>>2]|0;c[11450]=(F|0)<1?1:F;F=c[a>>2]|0;c[11334]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[11336]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[11336]=J+1}L=c[u>>2]|0;c[11332]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[11332]=L+1}K=j+1|0;c[11334]=K;if((j|0)<(F|0)){j=K}else{break}}}c[11338]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[11338]=H+1}H=c[b>>2]|0;c[11336]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[11334]=M;c[11336]=H+1}N=+h[e>>3];O=N*N;h[5722]=O;h[5708]=+h[5677]/O;h[5709]=+V(+(+h[5686]))/O;c[11340]=0;H=y;y=A;M=0;a:while(1){c[11352]=M;F=M-(c[a>>2]|0)|0;c[11376]=F;j=M+1|0;c[11340]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[11426]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[11364]=L;K=L+G|0;c[11362]=K;if((K|0)>(c[a>>2]|0)){c[11426]=L;G=K-(c[a>>2]|0)|0;c[11364]=G;c[11362]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[5699]=O;L=c[11350]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[5699]=N;R=N}else{R=O}O=+h[e>>3];h[5700]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[5700]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[5700];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[11334]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[11334]=S+1}if((M|0)>=(c[11450]|0)){T=j;U=159;break}while(1){ee[H&63](a,d,45320)|0;if((c[g>>2]|0)==3){FF(45848)|0;WE(46016,45360,4)|0;WE(46016,45320,8)|0;I=c[a>>2]|0;c[11332]=1;if((I|0)>=1){F=1;do{WE(46016,d+(F+ -1<<3)|0,8)|0;L=c[11332]|0;F=L+1|0;c[11332]=F;}while((L|0)<(I|0))}nF()|0}I=c[11340]|0;do{if((I|0)>(c[b>>2]|0)){F=c[11380]|0;if((F|0)==-1){break a}h[5718]=0.0;c[11338]=0;L=c[a>>2]|0;c[11334]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[5718]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[5691]=N;if((X|0)==(G|0)){ea=N*+h[5686];h[5691]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[5718]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[11338]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[11332]=Y;c[11334]=L+1;W=Z}J=c[b>>2]|0;c[11336]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[5718]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[11336]=J+1;ia=ja}O=+h[5665];ba=+h[5694];N=O-ba-ia;h[5685]=N;h[5704]=+h[5703];h[5703]=+h[5702];if(!(N>=0.0)){ka=-N}else{ka=N}h[5702]=ka;if(+h[5714]>+h[5680]){c[11424]=I}h[5710]=ba;do{if(O<ba){h[5694]=O;h[5727]=0.0;G=c[a>>2]|0;c[11332]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[5727]=+h[5727]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[11332]=G+1;h[A>>3]=ma}}while(0);c[11422]=F;if((F|0)<=0){O=+h[5718];if(O>=0.0){U=190;break a}ba=+h[5665];N=+h[5710];ea=(ba-N)/O;h[5715]=ea;O=+h[5717];do{if(!(ea<=O)){na=+h[5686]*+h[5707];h[A>>3]=na;oa=+h[5714];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[5707]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[5707]=qa;ra=qa;break}}else{qa=+h[5686]*+h[5714];h[5707]=qa;ra=qa}}while(0);ea=+h[5680];if(!(ra<=ea*1.5)){sa=ra}else{h[5707]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[5722]=ea;c[11438]=0;h[5723]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[11394]|0;c[11438]=J;oa=+h[5677];h[5723]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[11336]=1;if((J|0)<1){va=F}else{L=c[11396]|0;oa=ua;K=1;ca=F;while(1){h[5705]=0.0;c[11334]=1;if((L|0)<1){wa=0.0}else{X=c[11356]|0;aa=K+C|0;qa=+h[5677];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[5691]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[5705]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[11334]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[5687]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[5691]=za;h[5726]=0.0;$=c[a>>2]|0;c[11334]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[5726]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[11334]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[5691]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[5723]=Fa;c[11380]=K;Ga=Fa;Ha=K}aa=K+1|0;c[11336]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}dp(a,b,s,t,45424,u,w,45496,45520,x)|0;ca=c[11380]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[5665];c[11338]=0;J=c[a>>2]|0;c[11332]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[5691]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[5691];G=G+1|0;da=da+1|0}da=X+aa|0;c[11338]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[11334]=La;c[11332]=J+1}h[L>>3]=0.0;X=c[11396]|0;c[11334]=1;aa=(X|0)<1;if(!aa){F=c[11356]|0;K=1;while(1){da=fa(K,B)|0;O=+h[5685]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[5691]=Oa;G=c[b>>2]|0;c[11336]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[5691];$=$+1|0}c[11336]=G+1}$=K+1|0;c[11334]=$;if((K|0)<(X|0)){K=$}else{break}}}h[5696]=0.0;K=c[a>>2]|0;c[11332]=1;if((K|0)>=1){F=1;while(1){O=+h[5685]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[5696]=+h[5696]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[11332]=K+1;h[A>>3]=Pa}F=c[11422]|0;do{if((F|0)==0){if(!(+h[5707]==+h[5680])){break}O=+h[5715];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[11442]=0;break}L=c[b>>2]|0;c[11336]=1;if((L|0)>=1){J=o+((c[11394]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[11336]=L+1}h[5689]=0.0;$=c[a>>2]|0;c[11332]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[5683]=0.0;G=c[b>>2]|0;c[11336]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[5683]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[11336]=G+1;Sa=Ta}h[5689]=+h[5689]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[11332]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[5689]*100.0}J=c[11442]|0;c[11442]=J+1;if(+h[5696]<Ra){c[11442]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[11332]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[11332]=J+1}$=c[11342]|0;c[11338]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[11338]=$+1}c[11334]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[11336]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[11336]=Na+1;Ua=Wa}if((L|0)<(c[11356]|0)){h[J>>3]=-Ua}Va=L+1|0;c[11334]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[11336]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[11334]=Xa;c[11336]=L+1}c[11442]=0}}while(0);O=+h[5665];ea=+h[5710];if(O<ea){c[11394]=ca}oa=+h[5717];if(O<=ea+oa*+h[5718]|(F|0)>0){U=54;break}c[11380]=0;Ia=0;Ja=+h[5707];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[5665];oa=+h[5665];do{if((I|0)==1){h[5684]=oa;h[5694]=oa;c[11394]=1;Ya=1}else{if(!(oa<+h[5694])){Ya=I;break}h[5694]=oa;c[11394]=I;Ya=I}}while(0);F=c[11352]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[11362]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[11364]|0;Va=K+aa|0;c[11338]=Va;if(+h[5699]<0.0){aa=X+(c[a>>2]|0)|0;c[11362]=aa;Za=aa}else{Za=X}if(+h[5700]<0.0){X=K+(c[a>>2]|0)|0;c[11364]=X;_a=X}else{_a=K}K=fa(c[11376]|0,B)|0;h[t+(K-B<<3)>>3]=+h[5708];h[t+(Ya+C+K<<3)>>3]=+h[5708];h[t+(Za-B+K<<3)>>3]=-+h[5708];h[t+(_a-B+K<<3)>>3]=-+h[5708];h[q+(Va+ -1<<3)>>3]=(+h[5684]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[5665])/(+h[5699]*+h[5700])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[11376]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[5686]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[5686]/+h[e>>3];ea=+h[5709];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[5709];h[t+(X+K<<3)>>3]=+h[5709];K=(fa(Va+1|0,Va)|0)/2|0;c[11338]=K;ea=(+h[5684]- +h[5665])/+h[e>>3];h[5691]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[5686]*(+h[X>>3]+ +h[5691]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[5684])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[5677]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[5677]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[5686]*+h[5722]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[5680]=oa;h[5707]=oa;c[11356]=1;h[5702]=0.0;h[5703]=0.0;c[11442]=0;h[5727]=0.0;F=c[a>>2]|0;c[11332]=1;if((F|0)<1){U=53;break}ca=c[11394]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[5727]=+h[5727]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[11332]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[11424]=c[11340];U=54;continue}else if((U|0)==54){U=0;c[11380]=0;I=(c[11350]|0)+ -1|0;K=c[a>>2]|0;cp(a,b,l,n,p,q,r,45656,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,45792)|0;h[5679]=0.0;K=c[a>>2]|0;c[11332]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[5679]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[11332]=K+1;ab=cb}oa=+h[5707];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[5714]=O;ea=+h[5680];if(!(O<+h[5686]*ea)){db=ab;U=62;break}c[11380]=-1;O=+h[5717];N=O*oa;h[5707]=N;h[5715]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[5707]=ea;eb=ea}if((c[11340]|0)<=((c[11424]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[5724]*.125*ea;h[5691]=N;oa=+h[5702];ba=+h[5703];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[5704];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[5726]=O;I=c[b>>2]|0;c[11336]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[5683]=0.0;X=c[a>>2]|0;c[11334]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[5683]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[11334]=X+1;jb=lb}if(jb>ea){c[11380]=F;h[5726]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[11336]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[5715]>0.0){U=54;continue}ea=+h[5714];O=+h[5680];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[5686];h[5707]=O;ea=hb/+h[f>>3];h[5715]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[5680]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[5680]=na;ob=na;break}}else{na=+h[f>>3];h[5680]=na;ob=na}}while(0);h[5707]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){FF(45896)|0;nF()|0}FF(45920)|0;WE(46016,45440,8)|0;WE(46016,45360,4)|0;nF()|0;FF(45944)|0;WE(46016,45552,8)|0;ca=c[a>>2]|0;c[11332]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];WE(46016,y,8)|0;I=c[11332]|0;F=I+1|0;c[11332]=F;}while((I|0)<(ca|0))}nF()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[5686]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[5680];O=na>=ea?na:ea;h[5716]=O;ea=O*O;h[5679]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[5727];if(db<=ea*.001){h[5720]=ea*.25;ca=c[b>>2]|0;c[11336]=1;if((ca|0)>=1){F=1;while(1){h[5683]=0.0;I=c[a>>2]|0;c[11332]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[5683]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[11332]=I+1;pb=qb}h[5691]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[5686]*+h[5727];h[5683]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[11332]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[5691]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[5686]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[5683]*+h[n+(F+C+Va<<3)>>3]+ +h[5720]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[11344]=aa;c[11334]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[11334]=Va;rb=Va}c[11332]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[11336]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[11396]|0;c[11336]=1;if((F|0)>=1){ca=1;while(1){h[5701]=0.0;X=c[b>>2]|0;c[11332]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[5701]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[11332]=I;if((K|0)>=(X|0)){break b}O=+h[5701];K=I}}}while(0);X=c[a>>2]|0;c[11334]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[5720]*+h[5701]*+h[l+(I<<3)>>3];h[5683]=O;Va=c[b>>2]|0;c[11332]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[5683]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[11332]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[11356]|0)){h[5683]=-+h[5683]}L=c[b>>2]|0;c[11332]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[5683]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[11332]=L+1}J=K+1|0;c[11334]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[11332]=1;if((K|0)>=1){X=c[11356]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[11344]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[5691]=ub;c[11334]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[5691];aa=aa+1|0}aa=J+1|0;c[11334]=aa;vb=aa}c[11332]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[11336]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[11338]=0;ca=c[a>>2]|0;c[11334]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[11336]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[5686]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[11336]=aa+1}c[11332]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[11338]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[11332]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[11334]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[11334]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[11334]=J+1}h[5727]=0.0}if((c[11380]|0)>0){F=(c[11350]|0)+ -1|0;xo(a,b,l,n,s,t,45424,u,45520,45728,v,45648,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[11336]=1;if((F|0)>=1){L=1;while(1){h[5692]=0.0;h[5693]=0.0;h[5683]=0.0;ca=c[a>>2]|0;c[11334]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[5692]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[5693]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[5683]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[11334]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[5686]+Ab);h[w+(K<<3)>>3]=+h[5683];K=L+1|0;c[11336]=K;if((L|0)<(F|0)){L=K}else{break}}}h[5687]=0.0;L=c[11396]|0;c[11336]=1;if((L|0)>=1){F=1;while(1){h[5683]=0.0;J=c[b>>2]|0;c[11332]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[5683]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[11332]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[5687];if((F|0)<(c[11356]|0)){h[5687]=O+ea;na=-Eb;h[5683]=na;Gb=na}else{h[5687]=O-ea;Gb=Eb}K=c[b>>2]|0;c[11332]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[5683];X=X+1|0}c[11332]=K+1}X=F+1|0;c[11336]=X;if((F|0)<(L|0)){F=X}else{break}}}h[5695]=0.0;h[5674]=0.0;F=c[a>>2]|0;c[11334]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[5683]=0.0;X=c[b>>2]|0;c[11332]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[5683]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[11332]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[5695]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[11346]=K;Va=c[a>>2]|0;c[11336]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[5683]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[11336]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[5695]+ +h[5683]*+h[ca>>3];h[5695]=O;na=+h[5674]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[5674]=na;aa=L+1|0;c[11334]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[5679];h[5687]=+h[5687]+(Ib*Ib+ea*(Ib+(Ib+ +h[5727])+ea*+h[5686]))-Hb;L=w+((c[11394]|0)+ -1<<3)|0;h[L>>3]=+h[5677]+ +h[L>>3];L=c[11380]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[5677]+ +h[5706]*+h[5687]/(ea*ea);h[5691]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;wo(a,b,l,n,s,t,45424,u,45576,45520,v,x,w,45496,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[11332]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[11332]=L+1}F=c[11340]|0;aa=F+1|0;c[11340]=aa;if((F|0)>=(c[11450]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[11340]=T+ -1;if((c[g>>2]|0)<=0){break}FF(45824)|0;nF()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}FF(45872)|0;nF()|0}}while(0);Nb=+h[5694];if(Nb<=+h[5665]){U=c[a>>2]|0;c[11332]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[11332]=U+1;Ob=+h[5694]}h[5665]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}FF(45968)|0;WE(46016,45360,4)|0;nF()|0;FF(45992)|0;WE(46016,45320,8)|0;g=c[a>>2]|0;c[11332]=1;if((g|0)>=1){a=1;do{WE(46016,d+(a+ -1<<3)|0,8)|0;U=c[11332]|0;a=U+1|0;c[11332]=a;}while((U|0)<(g|0))}nF()|0;i=z;return 0}function cp(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[5772]=.5;h[5790]=6.283185307179586;v=+h[l>>3];h[5785]=v*v;c[11566]=0;l=c[b>>2]|0;c[11584]=l;c[11582]=l;w=c[b>>2]|0;c[11506]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[11506]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[11506]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[11506]=w+1}z=c[d>>2]|0;c[11510]=1;if((z|0)>=1){e=1;while(1){h[5776]=0.0;A=c[b>>2]|0;c[11508]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[5776]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[11508]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[5776]=v;C=c[b>>2]|0;c[11506]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[5776];F=F+1|0}c[11506]=C+1}F=e+1|0;c[11510]=F;if((e|0)<(z|0)){e=F}else{break}}}c[11520]=0;e=c[b>>2]|0;c[11508]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[11520]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[11506]=H;c[11508]=e+1}do{if((y|0)==0){h[5774]=0.0;h[5756]=0.0;w=c[b>>2]|0;c[11506]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[5756]=+h[5756]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[11506]=w+1}h[r>>3]=0.0;D=+h[5756];if(D==0.0){O=55;break a}h[5761]=0.0;h[5764]=0.0;h[5759]=D;h[5779]=D;P=D;Q=0.0;R=0.0;S=+h[5785];T=0}else{if((y|0)>(x|0)){h[5758]=0.0;h[5765]=0.0;h[5766]=0.0;z=c[b>>2]|0;c[11506]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[5758]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[5765]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[5766]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[11506]=z+1;U=ba;W=$;Z=aa}D=+h[5772];v=D*(+h[5769]-Z);h[5757]=v;_=+h[5762];ca=_+v;h[5773]=ca;h[5777]=ca;h[5775]=ca;c[11576]=0;a[46104]=1;da=+h[5790]/50.0;h[5776]=da;c[11506]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[5775]=ka;c[11576]=w;h[5786]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[5787]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[5781]=ha;h[5767]=ia;h[5770]=ja;h[5778]=ka;c[11506]=50;h[5777]=ka;if((la|0)==49){h[5787]=ca;na=ca}else if((la|0)==0){h[5786]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[5787]}h[5781]=0.0;ga=+h[5786];if(ga!=na){ea=ga-ma;h[5786]=ea;ga=na-ma;h[5787]=ga;oa=D*(ea-ga)/(ea+ga);h[5781]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[5781]=oa;ga=+X(+oa);h[5767]=ga;ea=+Y(+oa);h[5770]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[5782]=oa;h[5759]=0.0;w=c[b>>2]|0;c[11506]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[5767]*+h[J>>3]+ +h[5770]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[5759]+sa*sa;h[5759]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[5770];ea=+h[5767];F=F+1|0;z=K}c[11506]=w+1;qa=ta;ra=+h[5782]}ea=ra+ +h[5774];h[5774]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[5765]=0.0;z=c[b>>2]|0;c[11508]=1;do{if((z|0)<1){ea=+h[5789];h[5780]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[5765]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[11508]=z+1;ea=+h[5789];h[5780]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[5756];h[5776]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[5776]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[5780];oa=+h[5759];v=+h[5765];_=oa/v;ca=ea<=_?ea:_;h[5780]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[5759];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[5772]*Ca);h[5771]=ca;h[5774]=+h[5774]+ca;h[5784]=Ba;h[5759]=0.0;z=c[b>>2]|0;c[11506]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[5780]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[5759]+oa*oa;h[5759]=Ga;Ha=+h[5780];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[11506]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[5789]){if(+h[5771]<=+h[5774]*.01){O=55;break a}if(Fa<=+h[5779]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[5784];h[5776]=ca;h[5756]=0.0;h[5761]=0.0;h[5764]=0.0;w=c[b>>2]|0;c[11506]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[5756]+ca*ca;h[5756]=La;J=m+(F<<3)|0;Ma=+h[5761]+ +h[K>>3]*+h[J>>3];h[5761]=Ma;ca=+h[J>>3];Na=+h[5764]+ca*ca;h[5764]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[5776];Ja=Ja+1|0;Ka=J}c[11506]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[5785];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[11582]=y;ua=+h[5759];va=y}if(ua<=+h[5779]*1.0e-4){O=55;break a}h[5762]=0.0;h[5769]=0.0;z=c[b>>2]|0;c[11506]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[5762]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[5769]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[11506]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[5768]=ca;oa=+h[5785];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[11566]=J;_=+V(+(v-ca*ca));h[5776]=_;v=oa/_;h[5786]=v;oa=ca/_;h[5787]=oa;w=c[b>>2]|0;c[11506]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[5787];Ta=+h[5786];Ua=Ua+1|0;Va=K}c[11506]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[11566]=e;v=S-R;h[5776]=v;h[5789]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function dp(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[5799]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[11604]=t;c[11594]=1;c[11588]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[11594]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[5801]=D;C=+h[x>>3]/D;h[5808]=C;z=+h[f+(B+y<<3)>>3]/D;h[5809]=z;B=c[d>>2]|0;c[11586]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[5801]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[5801];if((x|0)>=(B|0)){break}D=+h[5809];z=+h[5808];x=x+1|0}c[11586]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[11588]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[5808]=z;if((c[g>>2]|0)>1){D=-z;h[5808]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[5809]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[11586]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[5809]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[5808];t=t+1|0;x=A}c[11586]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[5806]=z;x=k+(w<<3)|0;H=+h[x>>3];h[5800]=H;D=H*H;h[5810]=D;h[5807]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[5799];a[46424]=0;do{if((u|0)==1){z=+h[5807];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[5801]=z;D=+h[5808]/z;h[5809]=D;H=+h[5800]/z;h[5808]=H;x=c[d>>2]|0;c[11586]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[5809];D=+h[5808];w=w+1|0;t=s}c[11586]=x+1;J=+h[5801]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[11590]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[11590]=u;M=u}t=u+1-M|0;c[11592]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[5807];z=+h[f+(t+w<<3)>>3]/D;h[5801]=z;h[5808]=z*+h[l>>3];H=+h[5800];h[5809]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[5801]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[5799]/+V(+(+h[5810]+z*N*z));h[5804]=C;if(!(D>=0.0)){O=-D}else{O=D}h[5805]=C*+V(+O);t=c[d>>2]|0;c[11586]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[5805]*(+h[A>>3]- +h[5808]*+h[n+(G<<3)>>3]- +h[5809]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[5801];z=+h[5800];H=+h[5804];v=v+1|0}c[11586]=t+1;P=+h[5807]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[46424]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[11586]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[5801]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[5801];K=Q+1|0;c[11586]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[11588]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[11596]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[5800];N=+h[5807];J=(+h[5806]*+h[f>>3]-O*P)/N;h[5808]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[5809]=P;c[11586]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[11586]=q;if((f|0)>=(b|0)){break a}N=+h[5809];O=+h[5808];f=q}}}while(0);b=R+1|0;c[11588]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function ep(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function fp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((ep(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){$a(46488,46504,116,46528)}else if((s|0)==14){i=g;return o|0}return 0}function gp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((AR(w,c[46536+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[46640+(x<<2)>>2]|0;c[q>>2]=c[46536+(x<<2)>>2];c[q+4>>2]=y;Rm(23,0,46712,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=cR(D,8)|0;c[e+40>>2]=B;D=b+536|0;Um(c[D>>2]|0,(B|0)!=0|0,46752,p);B=cR(c[A>>2]|0,4)|0;c[e+36>>2]=B;Um(c[D>>2]|0,(B|0)!=0|0,46752,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=cR(c[C>>2]|0,4)|0;c[e+24>>2]=aR(8)|0;C=aR(4)|0;c[e+20>>2]=C;c[C>>2]=c[18928>>2];Um(c[D>>2]|0,(C|0)!=0|0,46752,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=aR(C)|0;A=e+44|0;c[A>>2]=aR(C)|0;C=cR(15,4)|0;E=e+12|0;c[E>>2]=C;Um(c[D>>2]|0,(C|0)!=0|0,46752,m);C=cR(5,4)|0;c[e+4>>2]=C;Um(c[D>>2]|0,(C|0)!=0|0,46752,l);C=cR(5,4)|0;c[e+8>>2]=C;Um(c[D>>2]|0,(C|0)!=0|0,46752,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=aR(C)|0;c[e+76>>2]=aR(C)|0;c[e+80>>2]=aR(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if(($d[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){Rm(23,0,46768,j)}else{Rm(1,0,46840,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[18964>>2]|c[4716]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=46672;W=V;Vm(Q,W,r)}c[t>>2]=w;Tm(23,1,46568,t);t=1;do{w=c[46640+(t<<2)>>2]|0;c[s>>2]=c[46536+(t<<2)>>2];c[s+4>>2]=w;Tm(23,0,46624,s);t=t+1|0;}while((t|0)<8);Yd[c[4856]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=46672;W=V;Vm(Q,W,r);return 0}function hp(a){a=a|0;var b=0;b=i;bR(c[a+40>>2]|0);bR(c[a+36>>2]|0);bR(c[a+20>>2]|0);bR(c[a+12>>2]|0);bR(c[a+4>>2]|0);bR(c[a+8>>2]|0);bR(a);i=b;return 0}function ip(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Um(c[N>>2]|0,(c[M>>2]|0)!=0|0,46936,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){Rm(3,0,46968,B);Rm(3,0,47008,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];$d[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rm(3,0,47032,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];Rm(23,0,47072,y);if((c[z>>2]|0)==1){bo(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Rq(a)|0;$d[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 4:{zo(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 7:{zo(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 6:{zo(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 3:{zo(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 5:{zo(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){zo(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{zo(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){md(_|0)|0;md($|0)|0;Tm(3,0,47104,x);Rm(3,0,47192,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){md(_|0)|0;md($|0)|0;$=rp(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Rq(a)|0;$d[c[(c[ba>>2]|0)+40>>2]&127](a)|0}$d[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Tm(1,0,47216,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[18884>>2]|0)!=0){Rm(3,1,47248,u);c[s>>2]=c[z>>2];Rm(3,0,47272,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Rm(3,0,47296,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Rm(3,0,47328,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Rm(3,0,47368,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Rm(3,0,47416,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];Rm(3,0,47464,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];Rm(3,0,47504,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];Rm(3,0,47544,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];Rm(3,0,47584,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];Rm(3,0,47632,f);Yd[c[4856]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){$a(47672,47704,410,47736)}Rm(3,0,47752,e);S=0;i=d;return S|0}function jp(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Rq(g)|0;a=f+540|0;$d[c[(c[a>>2]|0)+40>>2]&127](g)|0;$d[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function kp(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Rq(l)|0;b=k+540|0;$d[c[(c[b>>2]|0)+40>>2]&127](l)|0;$d[c[(c[b>>2]|0)+28>>2]&127](l)|0;tp(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function lp(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Rq(g)|0;l=e+540|0;$d[c[(c[l>>2]|0)+40>>2]&127](g)|0;$d[c[(c[l>>2]|0)+28>>2]&127](g)|0;$d[c[(c[l>>2]|0)+32>>2]&127](g)|0;ee[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function mp(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;up(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function np(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Rq(l)|0;b=k+540|0;$d[c[(c[b>>2]|0)+40>>2]&127](l)|0;$d[c[(c[b>>2]|0)+28>>2]&127](l)|0;sp(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function op(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function pp(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;vp(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function qp(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function rp(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-3:{m=-3;i=b;return m|0};case-2:{Tm(1,0,47776,k);m=-2;i=b;return m|0};case-33:{Tm(1,0,48296,b);m=-33;i=b;return m|0};case-11:{Tm(1,0,48160,d);m=-11;i=b;return m|0};case-10:{Tm(1,0,48064,e);m=-10;i=b;return m|0};case-9:{Tm(1,0,47976,f);m=-9;i=b;return m|0};case-8:{Tm(1,0,47928,g);m=-8;i=b;return m|0};case-12:{Tm(1,0,48248,c);m=-12;i=b;return m|0};case-7:{Tm(1,0,47888,h);m=-7;i=b;return m|0};case-1:{Tm(3,0,47104,l);m=1;i=b;return m|0};case-6:{Tm(1,0,47816,j);m=-6;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function sp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}$d[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function tp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;$d[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function up(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+ld(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+ld(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;jp(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function vp(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+ld(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+ld(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}jp(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function wp(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function xp(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;Yd[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function yp(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function zp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=dn(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{me[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;bn(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=dn(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function Ap(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((zp(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}Bp(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(dn(d)|0)>0;h=b?2:0;i=e;return h|0}function Bp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=aR(q)|0;s=r;t=aR(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[12264]=$m(4)|0;if((r|0)==0){$a(49064,49080,308,49112)}if((t|0)==0){$a(49128,49080,309,49112)}v=gn(b)|0;if((v|0)!=0){w=v;do{v=jn(w)|0;c[l>>2]=c[v>>2];Rm(27,0,49144,l);w=hn(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;GR(t|0,c[a+384>>2]|0,v|0)|0;GR(r|0,l|0,v|0)|0}h[d>>3]=+Ep(a,n,o,q,s,c[12264]|0,b);do{if((dn(c[12264]|0)|0)==0){s=en(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=gn(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=jn(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=hn(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Rm(27,0,49192,j);v=gn(b)|0;if((v|0)==0){break}else{B=v}do{v=jn(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[12264]|0;cn(v,jn(B)|0);v=jn(B)|0;c[g>>2]=c[v>>2];Rm(27,0,49216,g)}B=hn(B)|0;}while((B|0)!=0)}}while(0);an(b);if((c[18900>>2]|0)!=0){dn(c[12264]|0)|0}if((dn(c[12264]|0)|0)>0){B=m;do{g=en(c[12264]|0)|0;c[m>>2]=c[g>>2];fn(c[12264]|0);c[f>>2]=c[m>>2];Rm(7,0,49240,f);bn(b,B);}while((dn(c[12264]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){GR(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ne(a);Hp(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){bR(t);bR(r);i=e;return}GR(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;bR(t);bR(r);i=e;return}function Cp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){Lp(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rm(7,0,48784,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((dn(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[18900>>2]|0)!=0){e=gn(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=jn(s)|0;x=c[e>>2]|0;e=me[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;Qm(7,0,w,48808,l);s=hn(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=jn(gn(d)|0)|0;x=me[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;Qm(1,0,e,48824,j);c[s>>2]=1}}while(0);an(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;Gp(b);Dp(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function Dp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;Rm(27,0,49432,b);d=a+344|0;ee[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}



function Ep(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=aR(p<<3)|0;if((q|0)==0){$a(49248,49080,409,49264)}if((p|0)>0){GR(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Rm(27,0,49280,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rm(27,0,49328,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){bR(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Rq(a)|0;$d[c[(c[p>>2]|0)+40>>2]&127](a)|0;$d[c[(c[p>>2]|0)+28>>2]&127](a)|0;$d[c[(c[p>>2]|0)+32>>2]&127](a)|0;ee[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(Fp(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}GR(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}bR(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function Fp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;an(b);Rm(27,0,49352,g);g=gn(d)|0;if((g|0)==0){j=dn(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=jn(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=jn(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=jn(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=jn(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=jn(a)|0;o=c[g>>2]|0;g=jn(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?48768:48776;g=jn(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?48768:48776;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;Rm(27,0,49392,f);bn(b,jn(a)|0)}a=hn(a)|0;}while((a|0)!=0);j=dn(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;me[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;Hp(b);Ip(b);$d[c[(c[g>>2]|0)+36>>2]&127](b)|0;Jp(b,8);h=Kp(b)|0;j=$d[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{Ip(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}Lp(b);Hp(b);Jp(b,8);$d[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=Kp(b)|0;j=$d[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Vm(c[b+536>>2]|0,49472,e)}else if((o|0)==7){Ip(b);i=d;return}}function Hp(a){a=a|0;var b=0;b=i;GR(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function Ip(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function Jp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[18872+(d<<2)>>2]|0)==0){i=e;return}Rm(d,1,49896,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=$d[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=$d[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;Rm(d,0,49920,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}Yd[c[4856]&255](d);i=e;return}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function Lp(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;GR(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;GR(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;GR(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;GR(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ee[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function Np(a){a=a|0;var b=0;b=i;Op(a);Pp(a);Lp(a);Qp(a);i=b;return}function Op(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function Pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function Qp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((ao(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];GR(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;GR(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;GR(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;GR(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(ao(c[d>>2]|0)|0));i=b;return}function Rp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[18872+(d<<2)>>2]|0)==0){i=e;return}Rm(d,1,49568,q);q=b+136|0;if((c[q>>2]|0)>0){Rm(d,1,49592,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?49552:49560;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Rm(d,0,49608,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}Yd[c[4856]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){Rm(d,1,49664,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?49552:49560;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;Rm(d,0,49688,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}Yd[c[4856]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){Rm(d,1,49744,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?49552:49560;v=(a[n+(m*48|0)+40|0]|0)!=0?49552:49560;n=(a[(c[s>>2]|0)+m|0]|0)!=0?49552:49560;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;Rm(d,0,49768,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}Yd[c[4856]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){Rm(d,1,49824,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;Rm(d,0,49848,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}Yd[c[4856]&255](d)}Yd[c[4856]&255](d);i=e;return}function Sp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((ao(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];GR(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;GR(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;GR(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;GR(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(ao(c[d>>2]|0)|0));i=b;return}function Tp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function Up(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];GR(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;GR(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;GR(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;GR(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Xn(3,32)|0;c[o>>2]=p;if((p|0)==0){Vm(c[b+536>>2]|0,49952,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=cR(c[p>>2]|0,8)|0;c[q>>2]=z;Um(c[r>>2]|0,(z|0)!=0|0,50008,l);z=cR(c[s>>2]|0,4)|0;c[t>>2]=z;Um(c[r>>2]|0,(z|0)!=0|0,50008,k);z=cR(c[u>>2]|0,1)|0;c[v>>2]=z;Um(c[r>>2]|0,(z|0)!=0|0,50008,j);z=cR(c[w>>2]|0,4)|0;c[x>>2]=z;Um(c[r>>2]|0,(z|0)!=0|0,50008,g);$n(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=cR(3,4)|0;c[b+4>>2]=n;bo(c[o>>2]|0,0,n);c[b+8>>2]=cR(c[p>>2]|0,112)|0;c[b+12>>2]=cR(c[s>>2]|0,60)|0;c[b+16>>2]=cR(c[u>>2]|0,48)|0;c[b+20>>2]=cR(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=cR(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=cR(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=cR(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=cR(g,52)|0;c[b+40>>2]=cR(c[b+216>>2]|0,52)|0;c[b+44>>2]=cR(c[b+220>>2]|0,52)|0;c[b+48>>2]=cR(c[b+224>>2]|0,52)|0;c[b+52>>2]=cR(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=cR(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=cR(x,8)|0;c[b+340>>2]=cR(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=cR(x,8)|0;c[b+348>>2]=cR(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=cR(j,1)|0;c[b+356>>2]=cR(j,1)|0;c[b+360>>2]=cR(j,1)|0;j=aR(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=aR(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=cR(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=cR(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=cR(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=cR(u,4)|0;c[b+400>>2]=cR(x,8)|0;c[b+404>>2]=cR(p,4)|0;c[b+408>>2]=cR(s,1)|0;c[b+412>>2]=cR(u,4)|0;c[b+416>>2]=cR(c[n>>2]|0,8)|0;c[b+420>>2]=cR(o,4)|0;c[b+424>>2]=cR(y,1)|0;c[b+428>>2]=cR(g,4)|0;c[b+432>>2]=cR(c[b+152>>2]|0,8)|0;c[b+436>>2]=cR(c[b+156>>2]|0,8)|0;g=aR((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;Yd[c[(c[y>>2]|0)+20>>2]&255](g);g=aR((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;Yd[c[(c[y>>2]|0)+16>>2]&255](g);g=aR((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;Yd[c[(c[y>>2]|0)+12>>2]&255](g);g=aR((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;Zd[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=aR((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=cR(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Um(c[r>>2]|0,(g|0)!=0|0,50024,f);c[b+512>>2]=100;c[b+516>>2]=cR(100,4)|0;c[b+520>>2]=cR(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=aR(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Um(c[r>>2]|0,(g|0)!=0|0,50008,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Xn(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function Wp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;bR(c[g+8>>2]|0);bR(c[g+12>>2]|0);bR(c[g+16>>2]|0);bR(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);bR(e);Yn(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){uo(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}bR(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){uo(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}bR(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){uo(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}bR(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){uo(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}bR(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){uo(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}bR(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){uo(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}bR(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){uo(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}bR(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){uo(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}bR(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){uo(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}bR(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){uo(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}bR(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){uo(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}bR(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){uo(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}bR(v);bR(c[a+108>>2]|0);bR(c[a+336>>2]|0);bR(c[a+340>>2]|0);bR(c[a+344>>2]|0);bR(c[a+348>>2]|0);bR(c[a+352>>2]|0);bR(c[a+356>>2]|0);bR(c[a+360>>2]|0);bR(c[a+368>>2]|0);bR(c[a+384>>2]|0);bR(c[a+388>>2]|0);bR(c[a+392>>2]|0);bR(c[a+396>>2]|0);bR(c[a+400>>2]|0);bR(c[a+404>>2]|0);bR(c[a+408>>2]|0);bR(c[a+412>>2]|0);bR(c[a+416>>2]|0);bR(c[a+420>>2]|0);bR(c[a+424>>2]|0);bR(c[a+428>>2]|0);bR(c[a+488>>2]|0);bR(c[a+484>>2]|0);bR(c[a+476>>2]|0);bR(c[a+468>>2]|0);bR(c[a+464>>2]|0);bR(c[a+432>>2]|0);bR(c[a+436>>2]|0);bR(c[a+320>>2]|0);bR(c[a+516>>2]|0);bR(c[a+520>>2]|0);wE(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;bR(x);i=b;return}else{y=a;z=0}while(1){Yn(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;bR(x);i=b;return}function Xp(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[6258]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];Rm(8,0,50072,d);i=b;return}function Yp(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[6258];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function Zp(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[6258];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function _p(a,b){a=+a;b=+b;i=i;return a<b|0}function $p(a,b){a=+a;b=+b;i=i;return a<=b|0}function aq(a,b){a=+a;b=+b;i=i;return a>b|0}function bq(a,b){a=+a;b=+b;i=i;return a>=b|0}function cq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=aR(k)|0;c[e+(h*40|0)+24>>2]=aR(k)|0;if((c[g>>2]|0)!=1){l=5;break}fq(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Vm(c[a+536>>2]|0,50128,d)}else if((l|0)==6){i=b;return 0}return 0}function dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){bR(c[e+(h*40|0)+20>>2]|0);bR(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;gq(k)|0;bR(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Vm(c[a+536>>2]|0,50128,d)}else if((j|0)==6){i=b;return 0}return 0}function eq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[18940>>2]|c[4716]|0)==0){z=w;A=1;break}uE(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Tm(17,1,50160,g);uE(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;uE(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Tm(17,0,50192,f);uE(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Yd[c[4856]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function fq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aR(20)|0;c[b>>2]=f;Um(0,(f|0)!=0|0,50200,e);e=aR(a)|0;c[f>>2]=e;e=aR(a)|0;c[f+4>>2]=e;e=aR(a)|0;c[f+8>>2]=e;e=aR(a)|0;c[f+16>>2]=e;Um(0,(c[b>>2]|0)!=0|0,50232,d);i=d;return 0}function gq(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bR(c[d>>2]|0);bR(c[d+4>>2]|0);bR(c[d+8>>2]|0);bR(c[d+16>>2]|0);i=b;return 0}function hq(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Vm(c[a+536>>2]|0,50280,b);return 0}function iq(a){a=a|0;a=i;i=i+8|0;Vm(0,50280,a);return 0}function jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=aR(l)|0;c[e+(h<<6)+36>>2]=aR(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;qq(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=aR(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;oq(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){Vm(c[a+536>>2]|0,50320,d)}else if((n|0)==8){i=b;return 0}return 0}function kq(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function lq(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;sb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function mq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){bR(c[e+(h<<6)+28>>2]|0);bR(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){pq(e+(h<<6)+24|0)|0;bR(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){rq(e+(h<<6)+24|0)|0}else{k=6;break}bR(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Vm(c[a+536>>2]|0,50320,d)}else if((k|0)==8){i=b;return 0}return 0}function nq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[18932>>2]|c[4716]|0)==0){z=w;A=1;break}uE(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Tm(15,1,50352,g);uE(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;uE(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Tm(15,0,50384,f);uE(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Yd[c[4856]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function oq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=aR(12)|0;f=aR(a<<2)|0;c[e>>2]=f;Um(0,(f|0)!=0|0,50392,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function pq(a){a=a|0;var b=0;b=i;bR(c[c[a>>2]>>2]|0);i=b;return 0}function qq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=aR(32)|0;Um(0,(g|0)!=0|0,50448,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Pd(0,d|0)|0;Ed(c[d>>2]|0,c[b>>2]|0,0)|0;Pd(0,g+4|0)|0;Ed(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;_a(b|0)|0;Gb(50496,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function rq(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ld(c[d+12>>2]|0)|0;Fb(c[d+8>>2]|0)|0;Fb(c[d+4>>2]|0)|0;i=b;return 0}function sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Um(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,50664,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Um(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,50704,e);if(($d[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=aR(p)|0;c[g+(m*80|0)+52>>2]=aR(p)|0;c[g+(m*80|0)+48>>2]=aR(p)|0;c[g+(m*80|0)+16>>2]=aR(p)|0;c[g+(m*80|0)+8>>2]=aR(p)|0;c[g+(m*80|0)+12>>2]=aR(p)|0;Zd[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){xq(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){vq(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){hq(a,n)|0;break}else if((p|0)==3){xq(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){Vm(c[j>>2]|0,50744,d)}else if((q|0)==14){i=b;return 0}return 0}function tq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;bR(c[e+(h*80|0)+44>>2]|0);bR(c[e+(h*80|0)+52>>2]|0);bR(c[e+(h*80|0)+48>>2]|0);bR(c[e+(h*80|0)+16>>2]|0);bR(c[e+(h*80|0)+8>>2]|0);bR(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;yq(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==1){m=e+(h*80|0)+40|0;wq(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==3){k=e+(h*80|0)+40|0;yq(k)|0;l=k;break}else{n=9;break a}}}while(0);bR(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){iq(j)|0}else if((n|0)==9){Vm(c[a+536>>2]|0,50744,d)}else if((n|0)==11){i=b;return 0}return 0}function uq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;uE(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Sm(17,1,u,50776,m);do{if((a[b+312|0]|0)==0){uE(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;uE(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;Tm(17,0,50976,f);uE(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{Tm(17,1,50816,l);uE(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;uE(q,d,c[v>>2]|0);if((AR(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Tm(17,0,50896,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;uE(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;Tm(17,0,50936,g);G=E}uE(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[18940>>2]|c[4716]|0)==0){break}Yd[c[4856]&255](17)}}while(0);if((c[18940>>2]|c[4716]|0)==0){x=1;i=e;return x|0}Yd[c[4856]&255](17);x=1;i=e;return x|0}function vq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aR(144)|0;c[b>>2]=f;Um(0,(f|0)!=0|0,50992,e);c[f>>2]=0;e=a<<3;g=aR(e)|0;c[f+4>>2]=g;g=aR(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=aR(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=aR(e)|0;c[f+24>>2]=g;g=cR(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=aR(e)|0;c[f+64>>2]=g;g=aR(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=cR(g,8)|0;c[f+104>>2]=j;j=cR(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=aR(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=aR(e)|0;c[f+124>>2]=j;j=aR(e)|0;c[f+128>>2]=j;j=aR(e)|0;c[f+132>>2]=j;j=aR(e)|0;c[f+136>>2]=j;j=aR(e)|0;c[f+140>>2]=j;Um(0,(c[b>>2]|0)!=0|0,51024,d);i=d;return 0}function wq(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bR(c[d+4>>2]|0);bR(c[d+16>>2]|0);bR(c[d+12>>2]|0);bR(c[d+24>>2]|0);bR(c[d+28>>2]|0);bR(c[d+64>>2]|0);bR(c[d+68>>2]|0);bR(c[d+104>>2]|0);bR(c[d+108>>2]|0);bR(c[d+116>>2]|0);bR(c[d+124>>2]|0);bR(c[d+128>>2]|0);bR(c[d+132>>2]|0);bR(c[d+136>>2]|0);bR(c[d+140>>2]|0);i=b;return 0}function xq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aR(80)|0;c[b>>2]=f;Um(0,(f|0)!=0|0,51064,e);c[f>>2]=0;e=a<<3;g=aR(e)|0;c[f+4>>2]=g;g=aR(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=aR(e)|0;c[f+16>>2]=g;g=cR(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=aR(fa(e,a)|0)|0;c[f+64>>2]=g;g=aR(e)|0;c[f+68>>2]=g;g=aR(a<<2)|0;c[f+72>>2]=g;Um(0,(c[b>>2]|0)!=0|0,51096,d);i=d;return 0}function yq(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;bR(c[d+4>>2]|0);bR(c[d+8>>2]|0);bR(c[d+16>>2]|0);bR(c[d+20>>2]|0);bR(c[d+64>>2]|0);bR(c[d+68>>2]|0);bR(c[d+72>>2]|0);i=b;return 0}function zq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){ie[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==3){f=ip(a,b)|0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;Bq(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==2){Aq(a,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function Aq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[51136+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[51136+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];$d[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function Bq(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function Cq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=$m(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=aR(8)|0;c[j+4>>2]=4;k=aR(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=cR(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==4){k=c[268]|0;m=aR(k<<2)|0;c[12798]=m;if((k|0)<=0){n=0;break}l=c[b+116>>2]|0;o=m;m=0;while(1){c[o+(m<<2)>>2]=cR(l,8)|0;p=m+1|0;if((p|0)>=(k|0)){n=0;break a}o=c[12798]|0;m=p}}else if((g|0)==3){m=aR(88)|0;Rm(23,0,51168,f);o=gp(b,d,m)|0;c[d+48>>2]=m;n=o}else{n=0}}while(0);Pq(b)|0;if((c[2]|0)==0){i=e;return n|0}qo(6);no(1);i=e;return n|0}function Dq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){f=b+48|0;g=c[f>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){bR(c[g+(j<<2)>>2]|0);k=c[f>>2]|0;l=c[k>>2]|0;if((j|0)<(c[k+4>>2]|0)){j=j+1|0;g=l}else{m=l;break}}}else{m=h}bR(m);bR(c[f>>2]|0)}else if((e|0)==3){hp(c[b+48>>2]|0)|0}else if((e|0)==4){e=c[268]|0;b=c[12798]|0;if((e|0)>0){f=b;m=0;while(1){bR(c[f+(m<<2)>>2]|0);h=m+1|0;g=c[12798]|0;if((h|0)<(e|0)){m=h;f=g}else{n=g;break}}}else{n=b}bR(n)}Qq(a)|0;Kq(a);i=d;return 0}function Eq(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(155,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=RR(c[s>>2]|0,o)|0;if((t|0)==0){bb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=RR(c[s>>2]|0,o)|0;if((B|0)==0){bb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=RR(c[C>>2]|0,o)|0;if((D|0)==0){bb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=RR(c[C>>2]|0,o)|0;if((E|0)==0){bb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=RR(c[s>>2]|0,o)|0;if((F|0)==0){bb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(156,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=RR(c[s>>2]|0,o)|0;if((G|0)==0){bb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=RR(c[s>>2]|0,o)|0;if((H|0)==0){bb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;DR(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=RR(c[L>>2]|0,o)|0;if((M|0)==0){bb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ha(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=RR(c[p>>2]|0,o)|0;if((N|0)==0){bb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Pa(14,1,0,51200,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=RR(c[M>>2]|0,o)|0;if((U|0)==0){bb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=RR(c[M>>2]|0,o)|0;if((V|0)==0){bb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Pa(15,2,0,51296,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=RR(c[M>>2]|0,o)|0;if((X|0)==0){bb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[57416>>2]|0,57392,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=RR(c[M>>2]|0,o)|0;if((Y|0)==0){bb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Pa(15,23,0,51352,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=RR(c[M>>2]|0,o)|0;if((Z|0)==0){bb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(157,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=RR(c[M>>2]|0,o)|0;if(($|0)==0){bb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function Fq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Rm(8,0,51448,G);I=b+313|0;a[I]=1;Gp(b);if((c[72788>>2]|0)==0){Zd[c[57412>>2]&63](57392,b)}a[I]=0}}while(0);if((e|0)!=0){Gq(rd(e|0)|0,b)}if((c[18972>>2]|0)==0){i=f;return 0}qo(0);Rm(25,0,51496,F);Rm(25,1,51520,E);H=+io(6);J=+io(6);K=J/+io(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Rm(25,0,51528,D);K=+io(1);H=+io(1);J=H/+io(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Rm(25,0,51568,C);J=+io(2);K=+io(2);H=K/+io(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rm(25,0,51600,B);H=+io(3);J=+io(3);K=J/+io(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Rm(25,0,51624,A);K=+io(4);H=+io(4);J=H/+io(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rm(25,0,51664,z);J=+io(7);K=+io(7);H=K/+io(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(25,0,51696,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+io(0);J=H- +io(7);H=J- +io(4);J=H- +io(3);H=J- +io(2);J=H- +io(1);H=J- +io(6);J=+io(0);K=J- +io(7);J=K- +io(4);K=J- +io(3);J=K- +io(2);K=J- +io(1);J=K- +io(6);K=J/+io(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(25,0,51760,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rm(25,0,51728,x)}K=+io(0);H=+io(0);J=H/+io(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Rm(25,0,51792,v);Yd[c[4856]&255](25);Rm(25,1,51816,u);c[t>>2]=c[d+40>>2];Rm(25,0,51824,t);c[s>>2]=c[d+44>>2];Rm(25,0,51848,s);Yd[c[4856]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);Rm(25,1,51872,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];Rm(25,0,51888,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];Rm(25,0,51904,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];Rm(25,0,51936,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];Rm(25,0,51968,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];Rm(25,0,51992,m);Yd[c[4856]&255](25)}else if((s|0)!=5){Rm(25,1,52024,l);Rm(25,0,52032,j);Yd[c[4856]&255](25)}Rm(25,0,52096,g);no(0);i=f;return 0}function Gq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Tb(b|0,52568)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(b|0,52576,y|0)|0;if((z|0)==0){C=Jd(10,b|0)|0;D=md(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,52592,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;od(b|0,52608,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;od(b|0,52616,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;od(b|0,52624,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((AR(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,52592,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,52592,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((AR(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;od(b|0,52608,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;od(b|0,52608,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((AR(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;od(b|0,52616,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;od(b|0,52616,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((AR(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;od(b|0,52624,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];od(b|0,52592,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;od(b|0,52608,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;od(b|0,52616,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((AR(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;od(b|0,52624,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Tb(0,52568)|0;}while((d|0)!=0);C=Jd(10,b|0)|0;D=md(b|0)|0;i=e;return}function Hq(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 5:{Tm(1,0,52192,q);v=1;i=m;return v|0};case 11:case 10:case 9:case 6:case 7:case 8:{Tm(1,0,52120,r);v=1;i=m;return v|0};case 18:{w=c[266]|0;do{if((w|0)!=0){if((AR(w,52376)|0)!=0){break}c[u>>2]=4;break a}}while(0);Rm(23,0,52400,o);v=1;i=m;return v|0};case 4:{w=c[266]|0;if((w|0)!=0){if((AR(w,52232)|0)==0){break a}}Rm(23,0,52248,p);v=1;i=m;return v|0};default:{}}}while(0);p=Cq(a,s)|0;qe[c[19660>>2]&7]()|0;do{if((p|0)==0){o=Eq(a,b,d,e,f,g)|0;qe[c[19660>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){Zd[c[57412>>2]&63](57392,a);Qp(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Rm(23,0,52528,n);o=me[c[c[a+540>>2]>>2]&63](a,t)|0;qe[c[19660>>2]&7]()|0;Fq(a,s,l)|0;qe[c[19660>>2]&7]()|0;x=o}else{qe[c[19660>>2]&7]()|0;x=p}}while(0);Dq(a,s)|0;v=x;i=m;return v|0}function Iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){Jq(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if(($d[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Vm(c[a+536>>2]|0,52640,d)}else if((k|0)==6){Jq(a);i=b;return}}function Jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;IR(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Kq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;bR(c[f+(a*48|0)+28>>2]|0);bR(c[f+(a*48|0)+32>>2]|0);bR(c[f+(a*48|0)+16>>2]|0);bR(c[f+(a*48|0)+20>>2]|0);bR(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Lq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=aR(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=aR(c[y>>2]<<2)|0;Mq(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;GR(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;GR(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((fp(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Nq(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){GR(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;GR(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;bR(x);bR(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;Tm(5,1,52696,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ec(q|0,52728,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;Tm(5,0,52736,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=19424;K=c[4856]|0;Yd[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=52744;aa=$;Vm(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];Tm(5,0,52736,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=19424;K=c[4856]|0;Yd[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=52744;aa=$;Vm(O,aa,g);return 0}function Mq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;IR(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}$d[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Nq(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=cR(d,4)|0;r=cR(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;bR(q);bR(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;bR(q);bR(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){bR(q);bR(r);i=o;return v|0}if((n|0)==0){v=-1;bR(q);bR(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rm(5,1,52848,p);Oq(s,d,f,c[g>>2]|0,j,l,m);if((c[18892>>2]|0)==0){v=-1;bR(q);bR(r);i=o;return v|0}Yd[c[4856]&255](5);v=-1;bR(q);bR(r);i=o;return v|0}function Oq(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;IR(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];Rm(5,0,52880,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Pq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=fc(52896,52920)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Zc(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;mb(n|0);do{}while((Zc(n|0)|0)!=10);q=c[b+152>>2]|0;r=cR(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=cR(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=cR(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=_b(n|0,52928,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=_b(n|0,52928,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=cR(s,8)|0;x=v}}while(0);dc(52936,j|0)|0;dc(52992,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];dc(52952,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];dc(52976,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}qb(52992)|0;Tc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Qq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}bR(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){bR(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}bR(l);i=d;return 0}function Rq(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Sq(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Tq(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[18908>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Rm(9,1,53056,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rm(9,0,53168,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}Yd[c[4856]&255](9);g=1;i=b;return g|0}function Tq(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;gr(b);g=f+540|0;$d[c[(c[g>>2]|0)+84>>2]&127](f)|0;$d[c[(c[g>>2]|0)+36>>2]&127](f)|0;$d[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;me[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Uq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Tq(b,1.0);if((c[18908>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}Rm(9,1,53192,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(9,0,53256,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(9,0,53216,s)}Rm(9,1,53280,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;Rm(9,0,53352,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Rm(9,0,53304,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;Rm(9,0,53440,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(9,0,53376,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;Rm(9,0,53528,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Rm(9,0,53472,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}Yd[c[4856]&255](9);Rm(9,1,53560,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=$d[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;Rm(9,0,53352,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Rm(9,0,53304,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}Yd[c[4856]&255](9);Yd[c[4856]&255](9);i=d;return}function Vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[18908>>2]|0)!=0){Rp(b,9)}if((c[18968>>2]|0)==0){i=d;return}Rm(24,1,53584,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){Rm(24,1,53624,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rm(24,0,53648,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}Yd[c[4856]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}Rm(24,1,53704,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rm(24,0,53728,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}Yd[c[4856]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){Rm(24,1,53760,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(24,0,53648,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}Yd[c[4856]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){Rm(24,1,53784,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;Rm(24,0,53808,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}Yd[c[4856]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){Rm(24,1,53856,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?53928:53936;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?53928:53936;t=(a[(c[l>>2]|0)+n|0]|0)!=0?53928:53936;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;Rm(24,0,53880,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}Yd[c[4856]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){Rm(24,1,53944,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;Rm(24,0,53968,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}Yd[c[4856]&255](24)}Yd[c[4856]&255](24);i=d;return}function Wq(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;Rm(9,0,54016,z);if((f|0)==0){Op(b);Pp(b);C=6}else{if((a[f]|0)!=0){Xq(b,f,g)}Op(b);Pp(b);if((a[f]|0)==0){C=6}}if((C|0)==6){$d[c[(c[A>>2]|0)+84>>2]&127](b)|0;$d[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(AR(d,55504)|0)==0|0;f=(AR(d,55512)|0)==0;z=(AR(d,55520)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;Tm(1,0,54064,y);Tm(1,0,54096,x);c[w>>2]=55504;c[w+4>>2]=55312;Tm(1,0,54120,w);c[v>>2]=55512;c[v+4>>2]=55392;Tm(1,0,54120,v);c[u>>2]=55520;c[u+4>>2]=55440;Tm(1,0,54120,u);Vm(c[b+536>>2]|0,54152,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(AR(e,c[54176+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;Tm(1,0,54208,s);Tm(1,0,54096,r);t=1;do{u=c[54240+(t<<2)>>2]|0;c[q>>2]=c[54176+(t<<2)>>2];c[q+4>>2]=u;Tm(1,0,54120,q);t=t+1|0;}while((t|0)<7);Vm(c[b+536>>2]|0,54152,p)}}while(0);p=c[54136+(D<<2)>>2]|0;c[o>>2]=c[54048+(D<<2)>>2];c[o+4>>2]=p;Rm(9,0,54272,o);o=(D|0)==2;if(o){p=c[54240+(F<<2)>>2]|0;c[n>>2]=c[54176+(F<<2)>>2];c[n+4>>2]=p;Rm(9,0,54312,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Yq(b,F,j)|0;break}if((D|0)==3){Zq(b,j);I=0;break}else{Vm(c[b+536>>2]|0,54352,m)}}}while(0);if((uq(b,1)|0)!=0){J=-2;Vq(b);K=15;L=K;M=54376;N=M;Rm(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];xp(b,R,V);W=152;Lp(b);X=158;Qp(b);Y=153;Gp(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=me[ha&63](b,1)|0;ja=161;Mp(b);i=k;return J|0}if((nq(b,1)|0)!=0){J=-3;Vq(b);K=15;L=K;M=54376;N=M;Rm(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];xp(b,R,V);W=152;Lp(b);X=158;Qp(b);Y=153;Gp(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=me[ha&63](b,1)|0;ja=161;Mp(b);i=k;return J|0}m=(eq(b,1)|0)==0;J=m?I:-4;Vq(b);K=15;L=K;M=54376;N=M;Rm(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];xp(b,R,V);W=152;Lp(b);X=158;Qp(b);Y=153;Gp(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=me[ha&63](b,1)|0;ja=161;Mp(b);i=k;return J|0}function Xq(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Rm(9,0,55536,z);z=En(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Vm(C,55576,y)}Rm(9,0,55616,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=Fn(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=ar(c[d+(C*112|0)+4>>2]|0)|0;E=Fn(A,D)|0;bR(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((BR(E,55656,6)|0)==0){if((c[18908>>2]|0)==0){break}}else{D=BR(E,55664,6)|0;if((c[18908>>2]|D|0)==0){break}}c[v>>2]=E;Tm(9,0,55672,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;Ln(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(9,0,55640,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}Rm(9,0,55728,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=Fn(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=ar(c[G+(w*112|0)+4>>2]|0)|0;v=Fn(A,F)|0;bR(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];Tm(9,0,55752,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;Ln(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Rm(9,0,55640,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}Rm(9,0,55808,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=Fn(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=ar(c[t+(x*112|0)+4>>2]|0)|0;K=Fn(A,C)|0;bR(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];Tm(9,0,55752,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;Ln(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Rm(9,0,55640,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}Rm(9,0,55832,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=Fn(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=ar(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=Fn(A,u)|0;bR(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];Tm(9,0,55880,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;Ln(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;Rm(9,0,55864,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}Rm(9,0,55936,l);l=b+144|0;if((c[l>>2]|0)<=0){Cn(A);i=f;return}o=b+32|0;b=0;do{x=Fn(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=ar(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=Fn(A,n)|0;bR(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];Tm(9,0,55984,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;Ln(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?53928:53936;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;Rm(9,0,55968,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));Cn(A);i=f;return}function Yq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;wp(a,+h[a+240>>3]);Lp(a);Qp(a);Gp(a);Sp(a);Jq(a);Hp(a);Lp(a);e=_q(a,b,c)|0;Qp(a);Gp(a);Mp(a);Qp(a);i=d;return e|0}function Zq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;wp(b,+h[b+240>>3]);Lp(b);Qp(b);Lq(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=cR(c[y>>2]|0,8)|0;A=b+124|0;B=cR(c[A>>2]|0,4)|0;C=b+128|0;D=cR(c[C>>2]|0,1)|0;E=b+132|0;F=cR(c[E>>2]|0,4)|0;G=b+536|0;Um(c[G>>2]|0,(z|0)!=0|0,54408,t);Um(c[G>>2]|0,(B|0)!=0|0,54408,s);Um(c[G>>2]|0,(D|0)!=0|0,54408,r);Um(c[G>>2]|0,(F|0)!=0|0,54408,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[18908>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];ec(x|0,54424,p|0)|0;p=fc(x|0,54440)|0;c[o>>2]=54456;od(p|0,54448,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];od(p|0,54448,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Jd(10,p|0)|0;H=p}Rm(9,1,54464,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;$d[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Rm(9,0,54488,l);if((c[18908>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(H|0,54512,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];od(H|0,54512,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Jd(10,H|0)|0}if((uq(b,0)|0)!=0){break a}if((nq(b,0)|0)!=0){break a}if((eq(b,0)|0)!=0){break a}Tp(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);Yd[c[4856]&255](9);if((c[18908>>2]|0)!=0){Tc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}bR(z);bR(B);bR(D);bR(F)}else{h[b+304>>3]=1.0;$d[c[w+80>>2]&127](b)|0}Ip(b);if((Lq(b,1,1)|0)!=1){i=e;return}$d[c[(c[v>>2]|0)+80>>2]&127](b)|0;Ip(b);if((Lq(b,1,1)|0)!=1){i=e;return}Tm(1,0,54520,f);i=e;return}function _q(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=br(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){Rm(9,0,54624,u);if((c[b+184>>2]|0)==0){me[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}bR(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){Rm(9,0,54656,t);me[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;bR(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){Rm(9,1,54728,s);t=aR(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Tq(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Tq(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}Rm(9,1,54752,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Rm(9,0,54776,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Rm(9,0,54776,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];Rm(9,0,54776,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[18908>>2]|0)!=0){Yd[c[4856]&255](9);Yd[c[4856]&255](9)}bR(t);cr(v);H=br(b)|0;if((c[H>>2]|0)!=0){$=H;break}Rm(9,0,54800,n);bR(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}Rm(9,0,54832,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){Rm(9,0,54848,l);$q($,d,1,e);Uq(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Tq($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){bR(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){bR(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){bR(v);c[l>>2]=0}$q($,d,0,e);Uq(b,$);+Tq($,1.0)}else{Rm(9,0,54872,j)}Rm(9,1,54896,g);Uq(b,$);b=Sq($)|0;if((c[18908>>2]|0)!=0){Yd[c[4856]&255](9)}cr($);y=b;i=f;return y|0}function $q(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=aR(c[p>>2]<<3)|0;r=q;s=+Tq(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;er(a,r);bR(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=55024;F=E;Rm(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;Rm(9,0,54936,m);if(!t){dr(a)}switch(b|0){case 5:{G=13;break a;break};case 3:{H=nr(a,n,e)|0;break};case 2:{H=jr(a)|0;break};case 4:{G=12;break a;break};case 1:{H=lr(a)|0;break};case 6:{G=14;break a;break};default:{G=15;break a}}Qp(o);Gp(o);Mp(o);Qp(o);s=+Tq(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}Rm(9,0,54984,k);Uq(o,a);K=s}else{Rm(9,0,55e3,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){ir(a)|0}else if((G|0)==13){ir(a)|0}else if((G|0)==14){hr(o,a,0)|0}else if((G|0)==15){Vm(c[o+536>>2]|0,54960,l)}else if((G|0)==23){er(a,r);bR(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=55024;F=E;Rm(9,0,F,g);i=f;return}}



function xe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function ye(){return i|0}function ze(a){a=a|0;i=a}function Ae(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Be(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ce(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function De(a){a=a|0;J=a}function Ee(a){a=a|0;K=a}function Fe(a){a=a|0;L=a}function Ge(a){a=a|0;M=a}function He(a){a=a|0;N=a}function Ie(a){a=a|0;O=a}function Je(a){a=a|0;P=a}function Ke(a){a=a|0;Q=a}function Le(a){a=a|0;R=a}function Me(a){a=a|0;S=a}function Ne(a){a=a|0;var b=0,d=0;b=i;Rq(a)|0;d=a+540|0;$d[c[(c[d>>2]|0)+40>>2]&127](a)|0;$d[c[(c[d>>2]|0)+28>>2]&127](a)|0;$d[c[(c[d>>2]|0)+32>>2]&127](a)|0;$d[c[(c[d>>2]|0)+48>>2]&127](a)|0;$d[c[(c[d>>2]|0)+52>>2]&127](a)|0;Lp(a);i=b;return}function Oe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=ER(B|0)|0;D=aR(C+11|0)|0;PR(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=fc(D|0,32)|0;if((C|0)==0){B=Nd(c[(Jc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;Tm(23,0,40,u);Tc(0)|0;F=0}else{F=C}bR(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}qe[c[19660>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{oo(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}oo(2);no(2)}bo(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rm(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];yp(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rm(23,1,144,r);Z=zq(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ne(b);Mp(b);if((c[18964>>2]|0)!=0){Yd[c[4856]&255](23)}if((c[2]|0)!=0){no(4)}A=Ap(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Rm(7,1,200,q);if((c[72788>>2]|0)==0){Zd[c[57412>>2]&63](57392,b)}Cp(b,c[J>>2]|0,z,d);if((c[18900>>2]|0)!=0){Yd[c[4856]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;Qp(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){qo(4)}if((Lq(b,1,1)|0)!=0){c[B>>2]=1;Qp(b)}$d[c[(c[K>>2]|0)+88>>2]&127](b)|0;Lp(b);Up(b);Mp(b);do{if((T|0)==0){_=0}else{no(7);qo(2);A=(nc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(nc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+io(2);if(!$){aa=0;break}aa=(nc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+io(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=co(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(nc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+io(ba+9|0);if((ca|0)==0){ka=0}else{ka=(nc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}qo(7);if((la|0)!=0){_=T;break}c[p>>2]=Nd(c[(Jc()|0)>>2]|0)|0;Tm(23,0,240,p);Tc(T|0)|0;_=0}}while(0);if((c[72788>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;Zd[c[57412>>2]&63](57392,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[15748]|0)!=0){ca=f;ba=63e3;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];Jm(M,f);Jd(10,M|0)|0;ba=c[15756]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;Rm(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((uq(b,0)|0)!=0){ma=58;break}if((nq(b,0)|0)!=0){ma=58;break}if((eq(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rm(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((uq(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rm(1,0,448,m);U=_;V=-2;break}if((nq(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rm(1,0,536,l);U=_;V=-3;break}T=(eq(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rm(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Rm(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Tc(U|0)|0;i=e;return V|0}function Pe(a){a=a|0;i=i;return 0}function Qe(a){a=a|0;i=i;return 0}function Re(a){a=a|0;i=i;return 0}function Se(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function Te(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=350.7919654772122;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+32|0;x=w;h[x>>3]=l;i=d;return}do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=j;y=g;break}else{g=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;g=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=f;break}else{f=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=f;y=f;break}}}}while(0);if(!(y<<24>>24==0)){l=873.6797342484729;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+32|0;x=w;h[x>>3]=l;i=d;return}l=+h[c[c[b+4>>2]>>2]>>3]*522.8877687712607+350.7919654772122;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+32|0;x=w;h[x>>3]=l;i=d;return}function Ue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+32>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];qg(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[g>>3];i=b;return}function Ve(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];sg(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[g>>3];i=b;return}function We(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=52261.1444812124;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+56|0;x=w;h[x>>3]=l;i=d;return}do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=j;y=g;break}else{g=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;g=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=f;break}else{f=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=f;y=f;break}}}}while(0);if(!(y<<24>>24==0)){l=257184.9562751197;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+56|0;x=w;h[x>>3]=l;i=d;return}l=+h[c[c[b+4>>2]>>2]>>3]*204923.8117939073+52261.1444812124;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+56|0;x=w;h[x>>3]=l;i=d;return}function Xe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+56>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];wg(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[g>>3];i=b;return}function Ye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+40>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];ug(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[g>>3];i=b;return}function Ze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;if(!((_p(+U(+(+h[f+32>>3]- +h[f+24>>3])),.001)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[16252]|0;g=d;j=936;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];we[a&31](f,d,960,e);i=b;return}function _e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;if(!((_p(+U(+(+h[f+56>>3]- +h[f+48>>3])),.001)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[16252]|0;g=d;j=1e3;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];we[a&31](f,d,1024,e);i=b;return}function $e(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Se(b);Te(b);Ue(b);Ve(b);We(b);Xe(b);Ye(b);Ze(b);_e(b);i=c;return 0}function af(b){b=b|0;var c=0;c=i;a[b+314|0]=0;bf(b);i=c;return 0}function bf(a){a=a|0;var b=0;b=i;Se(a);i=b;return}function cf(a,b){a=a|0;b=+b;i=i;return 0}function df(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;Um(c[a+536>>2]|0,(a|0)!=0|0,1272,b);c[a+540>>2]=1080;c[a+84>>2]=1304;c[a+88>>2]=1304;c[a+92>>2]=1360;c[a+96>>2]=1424;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=1;c[a+116>>2]=8;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=9;d=a+232|0;e=a+140|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[d>>2]=5;d=a+160|0;e=a+216|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=2;c[a+104>>2]=0;c[a+164>>2]=2;c[a+168>>2]=0;d=a+56|0;e=a+176|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=1464;c[a+64>>2]=101;c[a+72>>2]=0;c[a+68>>2]=22;c[a+172>>2]=0;d=a+192|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function ef(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Ma(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=RR(c[k>>2]|0,e)|0;if((l|0)==0){bb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=19640;F=19664;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Ma(c[4910]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=RR(c[F>>2]|0,e)|0;if((G|0)==0){bb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[4168]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=RR(c[H>>2]|0,e)|0;if((I|0)==0){bb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Fa(46,c[4168]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=RR(c[H>>2]|0,e)|0;if((K|0)==0){bb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;DR(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=RR(c[L>>2]|0,e)|0;if((M|0)==0){bb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;DR(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=RR(c[I>>2]|0,e)|0;if((N|0)==0){bb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Fa(46,c[4168]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=RR(c[M>>2]|0,e)|0;if((R|0)==0){bb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Ma(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=RR(c[M>>2]|0,e)|0;if((V|0)==0){bb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Ma(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=RR(c[M>>2]|0,e)|0;if((W|0)==0){bb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Oa(34,1528,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=RR(c[M>>2]|0,e)|0;if((ba|0)==0){bb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=RR(c[M>>2]|0,e)|0;if((ca|0)==0){bb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=RR(c[M>>2]|0,e)|0;if((da|0)==0){bb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=RR(c[M>>2]|0,e)|0;if((ea|0)==0){bb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=xa(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=RR(c[h>>2]|0,e)|0;if((fa|0)==0){bb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=RR(c[h>>2]|0,e)|0;if((ga|0)==0){bb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Fa(46,c[4168]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=RR(c[h>>2]|0,e)|0;if((ha|0)==0){bb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=RR(c[h>>2]|0,e)|0;if((ia|0)==0){bb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=RR(c[h>>2]|0,e)|0;if((ja|0)==0){bb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=RR(c[M>>2]|0,e)|0;if((ka|0)==0){bb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function ff(){var a=0;a=i;md(0)|0;nc(1688,18,1,c[r>>2]|0)|0;md(0)|0;i=a;return}function gf(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=+k;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0;l=i;i=i+72|0;m=l;n=l+16|0;o=l+32|0;p=l+48|0;q=l+56|0;r=l+64|0;s=o;t=f;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];hf(p,b,g,d,e,o);u=+h[p>>3];p=n;o=f;c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];hf(q,b,j,d,e,n);v=+h[q>>3];if(u>0.0&v>0.0){w=3}else{if(u<0.0&v<0.0){w=3}}if((w|0)==3){w=zn(zn(zn(1712,xn(g,0,1,6)|0)|0,1896)|0,1904)|0;q=zn(zn(zn(w,xn(j,0,1,6)|0)|0,1896)|0,1920)|0;w=zn(zn(zn(q,xn(u,0,1,6)|0)|0,1896)|0,1944)|0;jf(0,zn(zn(zn(w,xn(v,0,1,6)|0)|0,1896)|0,1968)|0)}x=j-g;w=r;y=g;z=j;j=g;g=x;A=x;x=u;B=v;v=u;while(1){if(+U(+v)<+U(+B)){C=z;D=j;E=z;F=B;G=v;H=B}else{C=y;D=z;E=j;F=x;G=B;H=v}u=+U(+D)*2.0e-15+k;I=E*.5+D*-.5;if(+U(+I)<=u|G==0.0){break}do{if(+U(+A)<u){J=I;K=I}else{if(+U(+F)<=+U(+G)){J=I;K=I;break}L=G/F;if(C==E){M=I*L*2.0;N=1.0-L}else{O=F/H;P=G/H;Q=P+-1.0;M=L*(I*O*(O-P)*2.0-(D-C)*Q);N=(O+-1.0)*(L+-1.0)*Q}if(M>0.0){R=M;S=-N}else{R=-M;S=N}if(!(R*2.0<I*S*3.0- +U(+(u*S)))){J=I;K=I;break}if(!(R<+U(+(A*S*.5)))){J=I;K=I;break}J=R/S;K=g}}while(0);do{if(+U(+J)>u){T=J}else{if(I>0.0){T=u;break}T=-u}}while(0);u=D+T;q=m;n=f;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];hf(r,b,u,d,e,m);I=+h[w>>3];if(!(I>0.0&H>0.0)){if(!(I<0.0&H<0.0)){y=D;z=u;j=E;g=J;A=K;x=G;B=I;v=H;continue}}Q=u-D;y=D;z=u;j=D;g=Q;A=Q;x=G;B=I;v=G}h[a>>3]=D;i=l;return}function hf(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+24|0;k=j;l=j+16|0;m=k;n=g;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];Tf(l,b,e,d,k);h[a>>3]=+h[l>>3]-f;i=j;return}function jf(a,b){a=a|0;b=b|0;a=i;vo(b);i=a;return}function kf(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=+k;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0;l=i;i=i+72|0;m=l;n=l+16|0;o=l+32|0;p=l+48|0;q=l+56|0;r=l+64|0;s=o;t=f;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];lf(p,b,g,d,e,o);u=+h[p>>3];p=n;o=f;c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];lf(q,b,j,d,e,n);v=+h[q>>3];if(u>0.0&v>0.0){w=3}else{if(u<0.0&v<0.0){w=3}}if((w|0)==3){w=zn(zn(zn(1712,xn(g,0,1,6)|0)|0,1896)|0,1904)|0;q=zn(zn(zn(w,xn(j,0,1,6)|0)|0,1896)|0,1920)|0;w=zn(zn(zn(q,xn(u,0,1,6)|0)|0,1896)|0,1944)|0;jf(0,zn(zn(zn(w,xn(v,0,1,6)|0)|0,1896)|0,1968)|0)}x=j-g;w=r;y=g;z=j;j=g;g=x;A=x;x=u;B=v;v=u;while(1){if(+U(+v)<+U(+B)){C=z;D=j;E=z;F=B;G=v;H=B}else{C=y;D=z;E=j;F=x;G=B;H=v}u=+U(+D)*2.0e-15+k;I=E*.5+D*-.5;if(+U(+I)<=u|G==0.0){break}do{if(+U(+A)<u){J=I;K=I}else{if(+U(+F)<=+U(+G)){J=I;K=I;break}L=G/F;if(C==E){M=I*L*2.0;N=1.0-L}else{O=F/H;P=G/H;Q=P+-1.0;M=L*(I*O*(O-P)*2.0-(D-C)*Q);N=(O+-1.0)*(L+-1.0)*Q}if(M>0.0){R=M;S=-N}else{R=-M;S=N}if(!(R*2.0<I*S*3.0- +U(+(u*S)))){J=I;K=I;break}if(!(R<+U(+(A*S*.5)))){J=I;K=I;break}J=R/S;K=g}}while(0);do{if(+U(+J)>u){T=J}else{if(I>0.0){T=u;break}T=-u}}while(0);u=D+T;q=m;n=f;c[q+0>>2]=c[n+0>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];lf(r,b,u,d,e,m);I=+h[w>>3];if(!(I>0.0&H>0.0)){if(!(I<0.0&H<0.0)){y=D;z=u;j=E;g=J;A=K;x=G;B=I;v=H;continue}}Q=u-D;y=D;z=u;j=D;g=Q;A=Q;x=G;B=I;v=G}h[a>>3]=D;i=l;return}function lf(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+24|0;k=j;l=j+16|0;m=k;n=g;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];Uf(l,b,e,d,k);h[a>>3]=+h[l>>3]-f;i=j;return}function mf(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;nf(j,b,d,c);m=+h[j>>3];nf(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=zn(zn(zn(1712,xn(d,0,1,6)|0)|0,1896)|0,1904)|0;k=zn(zn(zn(o,xn(e,0,1,6)|0)|0,1896)|0,1920)|0;o=zn(zn(zn(k,xn(m,0,1,6)|0)|0,1896)|0,1944)|0;jf(0,zn(zn(zn(o,xn(n,0,1,6)|0)|0,1896)|0,1968)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;nf(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function nf(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;Of(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function of(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function pf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function qf(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;rf(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));sf(b,0,0.0,0.0,g);i=f;return}function rf(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;e=i;i=i+96|0;f=e;g=e+8|0;tf(f,b,c,d,.1);j=+h[f>>3];uf(g,b,j,d);k=+h[g+24>>3];l=+h[g+32>>3];m=+h[g+48>>3];n=l*+h[g+64>>3];o=(n- +h[g+40>>3])*287.117+-6610.41237132543;p=k*(m*2.0+k*+h[g+56>>3])*d*287.117;q=j*k*(m-l*+h[g+80>>3])*287.117;r=l*l*+h[g+72>>3]*-287.117;l=q/j;s=-+to(j,-2)/p;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=(k*m+n)*d*287.117+-1589557.62320524;h[a+24>>3]=287.117;h[a+32>>3]=r+l*l/p*d;h[a+40>>3]=r;h[a+48>>3]=j;h[a+56>>3]=o;h[a+64>>3]=q;h[a+72>>3]=p;h[a+80>>3]=q/(j*j*p);h[a+88>>3]=s;i=e;return}function sf(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function tf(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0,Z=0,_=0;g=i;i=i+280|0;j=g;k=g+88|0;l=g+176|0;m=g+264|0;n=l;o=l+8|0;p=l+16|0;q=l+24|0;r=l+32|0;s=l+40|0;t=l+48|0;u=l+56|0;v=l+64|0;w=l+72|0;x=l+80|0;y=k;z=k+8|0;A=k+16|0;B=k+24|0;C=k+32|0;D=k+40|0;E=k+48|0;F=k+56|0;G=k+64|0;H=k+72|0;I=k+80|0;J=m;K=m+8|0;L=d/(e*287.117);M=0;do{uf(l,b,L,e);N=+h[o>>3];O=+h[p>>3];P=+h[q>>3];Q=+h[r>>3];R=+h[s>>3];S=+h[t>>3];T=+h[u>>3];V=+h[v>>3];W=+h[w>>3];X=+h[x>>3];h[y>>3]=+h[n>>3];h[z>>3]=N;h[A>>3]=O;h[B>>3]=P;h[C>>3]=Q;h[D>>3]=R;h[E>>3]=S;h[F>>3]=T;h[G>>3]=V;h[H>>3]=W;h[I>>3]=X;Y=j+0|0;Z=k+0|0;_=Y+88|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));vf(m,0,j);X=+h[J>>3]-d;L=L-X/+h[K>>3];M=M+1|0;}while((M|0)<100&!(+U(+X)<=f));h[a>>3]=L;i=g;return}function uf(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0;f=i;i=i+176|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=f+120|0;p=f+144|0;q=f+168|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;c[B>>2]=13;On(C,1,B);B=C;C=2024;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[A>>2]=19;On(D,1,A);A=D;D=2040;c[A+0>>2]=c[D+0>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];c[z>>2]=19;_m(E,1,z);z=E;E=2056;c[z+0>>2]=c[E+0>>2];c[z+4>>2]=c[E+4>>2];c[z+8>>2]=c[E+8>>2];c[y>>2]=19;On(F,1,y);y=F;F=2072;c[y+0>>2]=c[F+0>>2];c[y+4>>2]=c[F+4>>2];c[y+8>>2]=c[F+8>>2];c[x>>2]=19;_m(G,1,x);x=G;G=2088;c[x+0>>2]=c[G+0>>2];c[x+4>>2]=c[G+4>>2];c[x+8>>2]=c[G+8>>2];H=d/302.55076522;I=132.6312/e;G=(xf(1,1,5)|0)==0;if(G){J=0.0}else{K=0.0;x=1;while(1){L=K+ +Mn(2024,x+ -1|0)*+W(+I,+(+(x+ -4|0)));F=x+1|0;if((xf(F,1,5)|0)==0){J=L;break}else{x=F;K=L}}}if(!(H>0.0)){x=c[16252]|0;F=w;h[k>>3]=H;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=x;x=p;y=4848;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];c[x+16>>2]=c[y+16>>2];c[x+20>>2]=c[y+20>>2];we[F&31](b,p,2112,w);}if(!(I>0.0)){w=c[16252]|0;p=v;h[k>>3]=I;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=w;w=o;F=4848;c[w+0>>2]=c[F+0>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];c[w+12>>2]=c[F+12>>2];c[w+16>>2]=c[F+16>>2];c[w+20>>2]=c[F+20>>2];we[p&31](b,o,2176,v);}K=1.0- +ca(+(I*-25.36365));if(!(K>0.0)){v=c[16252]|0;o=u;h[k>>3]=K;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=v;v=n;p=4848;c[v+0>>2]=c[p+0>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];c[v+12>>2]=c[p+12>>2];c[v+16>>2]=c[p+16>>2];c[v+20>>2]=c[p+20>>2];we[o&31](b,n,2240,u);}L=1.0- +ca(+(I*-16.90741));if(!(L>0.0)){u=c[16252]|0;n=t;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=u;u=m;o=4848;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];we[n&31](b,m,2320,t);}M=+ca(+(I*87.31279))+.6666666666666666;if(!(M>0.0)){t=c[16252]|0;m=s;h[k>>3]=M;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=t;t=l;n=4848;c[t+0>>2]=c[n+0>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[t+12>>2]=c[n+12>>2];c[t+16>>2]=c[n+16>>2];c[t+20>>2]=c[n+20>>2];we[m&31](b,l,2400,s);}N=J+(+da(+H)+(+W(+I,1.5)*-.00019536342+(+da(+I)*2.490888032+(+da(+K)*.791309509+(+da(+L)*.212236768+ +da(+M)*.197938904)))));s=(xf(1,1,10)|0)==0;if(s){O=N}else{M=N;l=1;while(1){m=l+ -1|0;N=+Mn(2040,m);L=+W(+H,+(+(Zm(2056,m)|0)));K=M+N*L*+W(+I,+(+Mn(2072,m)));m=l+1|0;if((xf(m,1,10)|0)==0){O=K;break}else{l=m;M=K}}}l=(xf(11,11,19)|0)==0;if(l){P=O}else{M=O;m=11;while(1){n=m+ -1|0;O=+ca(+-+W(+H,+(+(Zm(2088,n)|0))));K=+Mn(2040,n);L=+W(+H,+(+(Zm(2056,n)|0)));N=M+K*L*O*+W(+I,+(+Mn(2072,n)));n=m+1|0;if((xf(n,11,19)|0)==0){P=N;break}else{m=n;M=N}}}M=1.0/H;if(s){Q=M}else{N=M;m=1;while(1){n=m+ -1|0;M=+(Zm(2056,n)|0);O=+Mn(2040,n);L=+W(+H,+(+((Zm(2056,n)|0)+ -1|0)));K=N+M*O*L*+W(+I,+(+Mn(2072,n)));n=m+1|0;if((xf(n,1,10)|0)==0){Q=K;break}else{m=n;N=K}}}if(l){R=Q}else{N=Q;m=11;while(1){n=m+ -1|0;Q=+ca(+-+W(+H,+(+(Zm(2088,n)|0))));K=+Mn(2040,n);L=+W(+H,+(+((Zm(2056,n)|0)+ -1|0)));O=+W(+I,+(+Mn(2072,n)));M=+(Zm(2056,n)|0);J=+(Zm(2088,n)|0);S=N+K*L*O*Q*(M-J*+W(+H,+(+(Zm(2088,n)|0))));n=m+1|0;if((xf(n,11,19)|0)==0){R=S;break}else{m=n;N=S}}}N=-+to(H,-2);if(s){T=N}else{S=N;m=1;while(1){n=m+ -1|0;t=Zm(2056,n)|0;N=+(fa((Zm(2056,n)|0)+ -1|0,t)|0);J=+Mn(2040,n);M=+W(+H,+(+((Zm(2056,n)|0)+ -2|0)));Q=S+N*J*M*+W(+I,+(+Mn(2072,n)));n=m+1|0;if((xf(n,1,10)|0)==0){T=Q;break}else{m=n;S=Q}}}if(l){U=T}else{S=T;m=11;while(1){n=m+ -1|0;T=+ca(+-+W(+H,+(+(Zm(2088,n)|0))));Q=+(Zm(2088,n)|0);M=+Mn(2040,n);J=+W(+H,+(+((Zm(2056,n)|0)+ -2|0)));N=+W(+I,+(+Mn(2072,n)));O=+(Zm(2056,n)|0);L=+(Zm(2088,n)|0);K=O-L*+W(+H,+(+(Zm(2088,n)|0)));L=+((Zm(2056,n)|0)+ -1|0);O=+(Zm(2088,n)|0);X=K*(L-O*+W(+H,+(+(Zm(2088,n)|0))));O=S+M*J*N*T*(X-Q*Q*+W(+H,+(+(Zm(2088,n)|0))));n=m+1|0;if((xf(n,11,19)|0)==0){U=O;break}else{m=n;S=O}}}if(G){Y=0.0}else{S=0.0;G=1;while(1){O=S+ +(G+ -4|0)*+Mn(2024,G+ -1|0)*+W(+I,+(+(G+ -5|0)));m=G+1|0;if((xf(m,1,5)|0)==0){Y=O;break}else{G=m;S=O}}}G=I>=0.0;if(!G){m=c[16252]|0;n=r;h[k>>3]=I;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m;m=j;t=4848;c[m+0>>2]=c[t+0>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];c[m+12>>2]=c[t+12>>2];c[m+16>>2]=c[t+16>>2];c[m+20>>2]=c[t+20>>2];we[n&31](b,j,2504,r);}S=+ca(+(I*25.36365));O=+ca(+(I*16.90741));Q=+ca(+(I*-87.31279));X=+V(+I);T=S+-1.0;N=O+-1.0;J=Q*.6666666666666666+1.0;M=Y+(X*-.00029304513+(2.490888032/I+(20.07049742794785/T+(3.58837405365088/N+17.28259795778216/J))));if(s){Z=M}else{Y=M;r=1;while(1){j=r+ -1|0;M=+Mn(2072,j);L=+Mn(2040,j);K=+W(+H,+(+(Zm(2056,j)|0)));_=Y+M*L*K*+W(+I,+(+Mn(2072,j)+-1.0));j=r+1|0;if((xf(j,1,10)|0)==0){Z=_;break}else{r=j;Y=_}}}if(l){$=Z}else{Y=Z;r=11;while(1){j=r+ -1|0;Z=+ca(+-+W(+H,+(+(Zm(2088,j)|0))));_=+Mn(2072,j);K=+Mn(2040,j);L=+W(+H,+(+(Zm(2056,j)|0)));M=Y+_*K*L*Z*+W(+I,+(+Mn(2072,j)+-1.0));j=r+1|0;if((xf(j,11,19)|0)==0){$=M;break}else{r=j;Y=M}}}if((xf(1,1,3)|0)==0){aa=0.0}else{Y=0.0;r=1;while(1){M=+(fa(r+ -4|0,r+ -5|0)|0);Z=Y+M*+Mn(2024,r+ -1|0)*+W(+I,+(+(r+ -6|0)));j=r+1|0;if((xf(j,1,3)|0)==0){aa=Z;break}else{r=j;Y=Z}}}if(!G){G=c[16252]|0;r=q;h[k>>3]=I;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=G;G=g;j=4848;c[G+0>>2]=c[j+0>>2];c[G+4>>2]=c[j+4>>2];c[G+8>>2]=c[j+8>>2];c[G+12>>2]=c[j+12>>2];c[G+16>>2]=c[j+16>>2];c[G+20>>2]=c[j+20>>2];we[r&31](b,g,2504,q);}Y=aa+(-.000146522565/X+(-2.490888032/(I*I)+(S/(T*T)*-509.0610720883695+(O/(N*N)*-60.67011135843742+Q/(J*J)*1005.994564094842))));if(s){ba=Y}else{J=Y;q=1;while(1){g=q+ -1|0;Y=+Mn(2072,g);Q=+Mn(2072,g)+-1.0;N=+Mn(2040,g);O=+W(+H,+(+(Zm(2056,g)|0)));T=J+Y*Q*N*O*+W(+I,+(+Mn(2072,g)+-2.0));g=q+1|0;if((xf(g,1,10)|0)==0){ba=T;break}else{q=g;J=T}}}if(l){ea=ba}else{J=ba;q=11;while(1){g=q+ -1|0;ba=+ca(+-+W(+H,+(+(Zm(2088,g)|0))));T=+Mn(2072,g);O=+Mn(2072,g)+-1.0;N=+Mn(2040,g);Q=+W(+H,+(+(Zm(2056,g)|0)));Y=J+T*O*N*Q*ba*+W(+I,+(+Mn(2072,g)+-2.0));g=q+1|0;if((xf(g,11,19)|0)==0){ea=Y;break}else{q=g;J=Y}}}if(s){ga=0.0}else{J=0.0;s=1;while(1){q=s+ -1|0;Y=+(Zm(2056,q)|0);ba=+Mn(2072,q);Q=+Mn(2040,q);N=+W(+H,+(+((Zm(2056,q)|0)+ -1|0)));O=J+Y*ba*Q*N*+W(+I,+(+Mn(2072,q)+-1.0));q=s+1|0;if((xf(q,1,10)|0)==0){ga=O;break}else{s=q;J=O}}}if(l){ha=ga;ia=a;ja=ia;h[ja>>3]=d;ka=a;la=ka+8|0;ma=la;h[ma>>3]=e;na=a;oa=na+16|0;pa=oa;h[pa>>3]=287.117;qa=a;ra=qa+24|0;sa=ra;h[sa>>3]=H;ta=a;ua=ta+32|0;va=ua;h[va>>3]=I;wa=a;xa=wa+40|0;ya=xa;h[ya>>3]=P;za=a;Aa=za+48|0;Ba=Aa;h[Ba>>3]=R;Ca=a;Da=Ca+56|0;Ea=Da;h[Ea>>3]=U;Fa=a;Ga=Fa+64|0;Ha=Ga;h[Ha>>3]=$;Ia=a;Ja=Ia+72|0;Ka=Ja;h[Ka>>3]=ea;La=a;Ma=La+80|0;Na=Ma;h[Na>>3]=ha;i=f;return}else{Oa=ga;Pa=11}while(1){l=Pa+ -1|0;ga=+ca(+-+W(+H,+(+(Zm(2088,l)|0))));J=+Mn(2072,l);O=+Mn(2040,l);N=+W(+H,+(+((Zm(2056,l)|0)+ -1|0)));Q=+W(+I,+(+Mn(2072,l)+-1.0));ba=+(Zm(2056,l)|0);Y=+(Zm(2088,l)|0);T=Oa+J*O*N*Q*ga*(ba-Y*+W(+H,+(+(Zm(2088,l)|0))));l=Pa+1|0;if((xf(l,11,19)|0)==0){ha=T;break}else{Pa=l;Oa=T}}ia=a;ja=ia;h[ja>>3]=d;ka=a;la=ka+8|0;ma=la;h[ma>>3]=e;na=a;oa=na+16|0;pa=oa;h[pa>>3]=287.117;qa=a;ra=qa+24|0;sa=ra;h[sa>>3]=H;ta=a;ua=ta+32|0;va=ua;h[va>>3]=I;wa=a;xa=wa+40|0;ya=xa;h[ya>>3]=P;za=a;Aa=za+48|0;Ba=Aa;h[Ba>>3]=R;Ca=a;Da=Ca+56|0;Ea=Da;h[Ea>>3]=U;Fa=a;Ga=Fa+64|0;Ha=Ga;h[Ha>>3]=$;Ia=a;Ja=Ia+72|0;Ka=Ja;h[Ka>>3]=ea;La=a;Ma=La+80|0;Na=Ma;h[Na>>3]=ha;i=f;return}function vf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}function wf(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;var f=0.0,g=0.0;f=+ba(+c,+d);if(e==0.0){g=f}else{g=f+ +(~~+T(+((e-f)/6.283185307179586+.5))|0)*6.283185307179586}h[a>>3]=g;i=i;return}function xf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function yf(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;rf(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));zf(b,0,0.0,0.0,g);i=f;return}function zf(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Af(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;Bf(f,b,c,d);h[a>>3]=+h[f+16>>3]*(+h[f+32>>3]*+h[f+64>>3]- +h[f+40>>3]);i=e;return}function Bf(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;On(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(Un(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(Un(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(Un(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(Un(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(Un(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(Un(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(Un(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(Un(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(Un(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(Un(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(Un(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(Un(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(Un(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(Un(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(Un(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(Un(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(Un(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(Un(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(Un(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(Un(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(Un(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(Un(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(Un(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(Un(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(Un(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(Un(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(Un(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(Un(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(Un(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(Un(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(Un(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(Un(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(Un(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(Un(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(Un(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(Un(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(Un(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(Un(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(Un(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(Un(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(Un(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(Un(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(Un(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(Un(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(Un(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(Un(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(Un(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(Un(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(Un(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(Un(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(Un(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(Un(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(Un(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(Un(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(Un(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(Un(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(Un(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(Un(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(Un(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(Un(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(Un(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(Un(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(Un(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(Un(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(Un(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(Un(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(Un(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(Un(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(Un(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(Un(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(Un(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(Un(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(Un(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(Un(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(Un(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(Un(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(Un(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(Un(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(Un(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(Un(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(Un(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(Un(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(Un(Xf,1,se)|0)>>3];c[re>>2]=31;h[(Un(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(Un(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(Un(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(Un(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(Un(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(Un(Xf,1,me)|0)>>3];c[le>>2]=34;h[(Un(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(Un(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(Un(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(Un(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(Un(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(Un(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(Un(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(Un(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(Un(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(Un(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(Un(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(Un(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(Un(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(Un(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(Un(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(Un(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(Un(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(Un(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(Un(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(Un(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(Un(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(Un(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(Un(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(Un(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(Un(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(Un(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(Un(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(Un(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(Un(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(Un(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(Un(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(Un(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(Un(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(Un(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(Un(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(Un(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(Un(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(Un(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(Un(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(Un(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(Un(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(Un(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(Un(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(Un(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(Un(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(Un(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(Un(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(Un(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(Un(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(Un(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Air_ReferenceMoistAir_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function Cf(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;Bf(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function _omc_Modelica_Media_Air_ReferenceMoistAir_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(Un(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(Un(l,1,pb)|0)>>3];c[qb>>2]=55;h[(Un(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[16252]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[4848+0>>2];c[a+4>>2]=c[4848+4>>2];c[a+8>>2]=c[4848+8>>2];c[a+12>>2]=c[4848+12>>2];c[a+16>>2]=c[4848+16>>2];c[a+20>>2]=c[4848+20>>2];we[td&31](d,a,2568,rb);}c[sb>>2]=9;sd=+h[(Un(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(Un(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(Un(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(Un(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(Un(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(Un(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(Un(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(Un(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(Un(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(Un(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(Un(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(Un(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(Un(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(Un(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(Un(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(Un(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(Un(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(Un(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(Un(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(Un(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(Un(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(Un(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(Un(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(Un(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(Un(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(Un(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(Un(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(Un(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(Un(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(Un(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(Un(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(Un(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(Un(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(Un(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(Un(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(Un(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(Un(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(Un(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(Un(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(Un(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(Un(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(Un(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(Un(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(Un(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(Un(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(Un(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(Un(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(Un(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(Un(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(Un(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(Un(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(Un(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(Un(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(Un(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(Un(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(Un(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(Un(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(Un(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(Un(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(Un(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(Un(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(Un(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(Un(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(Un(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(Un(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(Un(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(Un(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(Un(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(Un(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(Un(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(Un(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(Un(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(Un(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(Un(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(Un(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(Un(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(Un(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(Un(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(Un(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(Un(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(Un(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(Un(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(Un(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(Un(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(Un(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(Un(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(Un(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(Un(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(Un(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(Un(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(Un(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(Un(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(Un(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(Un(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(Un(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(Un(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(Un(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(Un(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(Un(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(Un(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(Un(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(Un(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(Un(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(Un(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(Un(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(Un(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(Un(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(Un(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(Un(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(Un(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(Un(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(Un(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(Un(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(Un(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(Un(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(Un(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(Un(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(Un(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(Un(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(Un(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(Un(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(Un(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(Un(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(Un(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(Un(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(Un(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(Un(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(Un(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(Un(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(Un(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(Un(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(Un(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(Un(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(Un(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(Un(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(Un(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(Un(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(Un(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(Un(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(Un(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(Un(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(Un(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(Un(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(Un(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(Un(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(Un(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(Un(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(Un(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(Un(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(Un(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(Un(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(Un(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(Un(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(Un(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(Un(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(Un(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(Un(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(Un(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(Un(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(Un(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(Un(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(Un(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(Un(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(Un(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(Un(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(Un(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(Un(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(Un(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(Un(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(Un(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(Un(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(Un(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(Un(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(Un(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(Un(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(Un(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(Un(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(Un(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(Un(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(Un(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(Un(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(Un(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(Un(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(Un(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(Un(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(Un(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(Un(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(Un(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(Un(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(Un(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(Un(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(Un(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(Un(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(Un(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(Un(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(Un(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(Un(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(Un(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(Un(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(Un(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(Un(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(Un(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(Un(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(Un(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(Un(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(Un(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(Un(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(Un(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(Un(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(Un(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(Un(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(Un(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(Un(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(Un(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(Un(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(Un(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(Un(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}



function wl(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=ve[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=ve[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=ve[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=ve[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function xl(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((zl(yl(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((zl(yl(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=yl(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((zl(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=yl(k,a,b)|0;n=h;}while((zl(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=yl(k,a,b)|0;while(1){if((zl(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=yl(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=yl(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function yl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function zl(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function Al(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function Bl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{c[h>>2]=14;j=0;break};case 13:{c[h>>2]=14;j=56;break};case 14:{j=0;break};case 16:{if((ve[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,16664)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 29:{c[h>>2]=16;j=2;break};case 12:{c[h>>2]=14;j=1;break};case 11:{c[h>>2]=14;j=55;break};default:{k=10}}}while(0);if((k|0)==10){j=Fl(h,a)|0}i=g;return j|0}function Cl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 33:{c[h>>2]=17;k=0;break};case 15:{k=0;break};case 26:{j=9;break};default:{k=El(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=Fl(h,a)|0}i=g;return k|0}function Dl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((ve[c[e+28>>2]&63](e,b,d,16648)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((ve[c[e+28>>2]&63](e,b,d,16656)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=Fl(h,a)|0;l=k;i=g;return l|0}function El(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 16:{if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,16424)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,16432)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,16440)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,16448)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};default:{}}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function Fl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function Gl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function Hl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else{g=Fl(e,a)|0}i=f;return g|0}function Il(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=Fl(e,a)|0}i=f;return g|0}function Jl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=Fl(e,a)|0}i=f;return g|0}function Kl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=Fl(e,a)|0}i=f;return g|0}function Ll(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=Fl(e,a)|0}i=f;return g|0}function Ml(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==15){g=0}else if((b|0)==11){g=55}else{g=Fl(e,a)|0}i=f;return g|0}function Nl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((ve[c[e+28>>2]&63](e,b,d,16464)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((ve[c[e+28>>2]&63](e,b,d,16472)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=Fl(h,a)|0;l=k;i=g;return l|0}function Ol(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=Fl(e,a)|0}i=f;return g|0}function Pl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=Fl(e,a)|0}i=f;return g|0}function Ql(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=Fl(e,a)|0}i=f;return g|0}function Rl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=Fl(e,a)|0;h=g;i=f;return h|0}return 0}function Sl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((ve[c[e+28>>2]&63](e,b,d,16480)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b,d,16488)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function Tl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 20:{if((ve[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,16496)|0)==0){j=10;break a}c[h>>2]=38;k=43;break};case 41:case 18:{c[h>>2]=40;k=51;break};case 15:{k=39;break};case 30:{c[h>>2]=40;k=53;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;k=44;break};case 31:{c[h>>2]=40;k=52;break};case 32:{c[h>>2]=40;k=54;break};default:{j=10}}}while(0);if((j|0)==10){k=Fl(h,a)|0}i=g;return k|0}function Ul(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else{g=Fl(e,a)|0}i=f;return g|0}function Vl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 30:{c[e>>2]=40;g=53;break};case 15:{g=39;break};case 31:{c[e>>2]=40;g=52;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};default:{g=Fl(e,a)|0}}i=f;return g|0}function Wl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=Fl(e,a)|0;h=g;i=f;return h|0}}return 0}function Xl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=Fl(e,a)|0}i=f;return g|0}function Yl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=Fl(e,a)|0}i=f;return g|0}function Zl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=Fl(e,a)|0}i=f;return g|0}function _l(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((ve[k&63](l,m,n,c[16504+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((ve[k&63](l,m,n,16448)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}}while(0);p=Fl(h,a)|0;q=p;i=g;return q|0}function $l(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,16608)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,16616)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,16632)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function am(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=Fl(e,a)|0}i=f;return g|0}function bm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=Fl(e,a)|0}i=f;return g|0}function cm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=46;g=33}else{g=Fl(e,a)|0}i=f;return g|0}function dm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=Fl(e,a)|0}i=f;return g|0}function em(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=Fl(e,a)|0}i=f;return g|0}function fm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=Fl(e,a)|0}i=f;return g|0}function gm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=Fl(e,a)|0}i=f;return g|0}function hm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((ve[c[e+28>>2]&63](e,b,d,16464)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b,d,16472)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function im(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=Fl(e,a)|0}i=f;return g|0}function jm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=Fl(e,a)|0}i=f;return g|0}function km(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==18){if((ve[c[e+28>>2]&63](e,b,d,16640)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function lm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=Fl(e,a)|0}i=f;return g|0}function mm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((ve[c[e+28>>2]&63](e,b,d,16464)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b,d,16472)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function nm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=Fl(e,a)|0}i=f;return g|0}function om(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=Fl(e,a)|0}i=f;return g|0}function pm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=Fl(e,a)|0;h=g;i=f;return h|0}return 0}function qm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=Fl(e,a)|0;h=g;i=f;return h|0}return 0}function rm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=Fl(e,a)|0}i=f;return g|0}function sm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 13:{j=56;break};case 15:{j=0;break};case 11:{j=55;break};case 16:{if((ve[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,16664)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=Fl(h,a)|0}i=g;return j|0}function tm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=Fl(e,a)|0}i=f;return g|0}function um(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((ve[c[e+28>>2]&63](e,b,d,16464)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((ve[c[e+28>>2]&63](e,b,d,16472)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}}while(0);j=Fl(h,a)|0;k=j;i=g;return k|0}function vm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=Fl(e,a)|0}i=f;return g|0}function wm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=Fl(e,a)|0}i=f;return g|0}function xm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else{g=Fl(e,a)|0}i=f;return g|0}function ym(){i=i;return}function zm(){i=i;return}function Am(){var a=0;a=i;Ta(16672,0)|0;i=a;return}function Bm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;nc(16680,29,1,e|0)|0;md(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;nc(16712,54,1,g|0)|0;md(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;nc(16768,47,1,a|0)|0;md(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;od(k|0,16816,d|0)|0;md(k|0)|0;f=0;i=b;return f|0}function Cm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;od(j|0,16904,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;od(n|0,16936,e|0)|0;k=0;i=d;return k|0}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function Em(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=pn(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function Fm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=pn(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function Gm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[16252]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=16992;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];we[p&31](0,f,17016,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function Hm(a,b){a=a|0;b=b|0;var d=0;d=i;if((Bm(a)|0)==0){$a(17072,16880,347,17096)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);$a(17128,16880,348,17096);return 0}function Im(){var a=0,b=0,d=0;a=i;b=18872|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=18984|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=19096|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[18876>>2]=1;c[18880>>2]=1;i=a;return}function Jm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?19232:19248;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;od(a|0,19208,e|0)|0;i=d;return}function Km(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=19096+(d<<2)|0;o=18984+(d<<2)|0;p=19296+(b<<2)|0;q=17576+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=19280;dc(19264,l|0)|0;s=19280}else{if((c[4714]|0)==(d|0)){if((c[o>>2]|0)>0){t=19280}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;dc(19264,m|0)|0;do{if((c[4714]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=19280;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;dc(19288,k|0)|0;c[n>>2]=b;c[4714]=d;if((c[o>>2]|0)>0){g=0;while(1){dc(19320,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;qb(e|0)|0;r=0;e=e+(w+1)|0;f=1}qb(e|0)|0;md(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function Lm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[19296+(a<<2)>>2]|0;c[j>>2]=c[17576+(b<<2)>>2];c[j+4>>2]=k;dc(19328,j|0)|0;Mm(e);if((g|0)==0){Bd(((d|0)!=0?19368:19416)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}qb(19496)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];dc(19376,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}nc(19400,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}function Mm(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){nc(19456,4,1,e|0)|0}else if(b<<24>>24==60){nc(19448,4,1,e|0)|0}else if(b<<24>>24==38){nc(19440,5,1,e|0)|0}else if(b<<24>>24==0){break}else{Jd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function Nm(a){a=a|0;var b=0;b=18984+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function Om(a){a=a|0;var b=0;b=(a|0)==0;c[4858]=b?1:19;c[4856]=b?7:149;i=i;return}function Pm(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;nc(19400,11,1,b|0)|0;md(b|0)|0;i=a;return}function Qm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[18872+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;jc(j|0,2048,e|0,h|0)|0;he[c[4858]&31](1,a,b,j,0,d);i=g;return}function Rm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[18872+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;jc(h|0,2048,d|0,g|0)|0;he[c[4858]&31](1,a,b,h,0,0);i=f;return}function Sm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[4716]|0)==0){if((c[18872+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;jc(k|0,2048,e|0,j|0)|0;he[c[4858]&31](2,a,b,k,0,d);i=g;return}function Tm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[4716]|0)==0){if((c[18872+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;jc(j|0,2048,d|0,h|0)|0;he[c[4858]&31](2,a,b,j,0,0);i=f;return}function Um(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;jc(b|0,2048,d|0,g|0)|0;he[c[4858]&31](4,2,0,b,0,0);if((a|0)==0){h=ed(c[4168]|0)|0}else{h=a}bb(c[h+76>>2]|0,1)}function Vm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;jc(g|0,2048,b|0,f|0)|0;he[c[4858]&31](5,2,0,g,0,0);if((a|0)==0){h=ed(c[4168]|0)|0}else{h=a}bb(c[h+76>>2]|0,1)}function Wm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+8>>2]|0)+(fa(d,b)|0)|0;i=i;return e|0}function Xm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;c[a+8>>2]=qn(Fm(a,d,g)|0,b)|0;i=f;return}function Ym(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Wm(a,Gm(a,d,g)|0,b)|0;i=f;return e|0}function Zm(a,b){a=a|0;b=b|0;i=i;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function _m(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=on(Fm(a,b,f)|0)|0;i=e;return}function $m(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=aR(16)|0;Um(0,(d|0)!=0|0,19504,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function an(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;bR(c[f>>2]|0);bR(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function bn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Um(0,(a|0)!=0|0,19520,f);f=aR(8)|0;g=f;Um(0,(f|0)!=0|0,19504,e);e=a+8|0;h=aR(c[e>>2]|0)|0;c[f>>2]=h;Um(0,(h|0)!=0|0,19504,d);GR(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function cn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Um(0,(a|0)!=0|0,19520,f);f=aR(8)|0;g=f;Um(0,(f|0)!=0|0,19504,e);e=a+8|0;h=aR(c[e>>2]|0)|0;c[f>>2]=h;Um(0,(h|0)!=0|0,19504,d);GR(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function dn(a){a=a|0;var b=0;b=i;i=i+8|0;Um(0,(a|0)!=0|0,19520,b);i=b;return c[a+12>>2]|0}function en(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Um(0,(a|0)!=0|0,19520,d);d=a;Um(0,(c[d>>2]|0)!=0|0,19544,b);i=b;return c[c[d>>2]>>2]|0}function fn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;bR(c[e>>2]|0);bR(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function gn(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Um(0,(a|0)!=0|0,19520,d);d=a;Um(0,(c[d>>2]|0)!=0|0,19560,b);i=b;return c[d>>2]|0}function hn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Um(0,d&1,19592,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function jn(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Um(0,(a|0)!=0|0,19592,d);d=a;Um(0,(c[d>>2]|0)!=0|0,19616,b);i=b;return c[d>>2]|0}function kn(){var a=0,b=0,d=0;a=i;b=aR(16)|0;c[4922]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=aR(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function ln(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=rn(a)|0;pc(19696)|0;sn(d);a=c[4922]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;cc(19696)|0;IR(g|0,0,d|0)|0;i=b;return g|0}function mn(){var a=0,b=0,d=0,e=0;a=i;b=c[4922]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;bR(c[b>>2]|0);bR(b);if((d|0)==0){break}else{b=d}}e=c[4922]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function nn(a){a=a|0;var b=0,d=0;b=i;d=$d[c[19648>>2]&127](a<<3)|0;i=b;return d|0}function on(a){a=a|0;var b=0,d=0;b=i;d=$d[c[19648>>2]&127](a<<2)|0;i=b;return d|0}function pn(a){a=a|0;var b=0,d=0;b=i;d=$d[c[19648>>2]&127](a<<2)|0;i=b;return d|0}function qn(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=fa(b,a)|0;a=$d[c[19644>>2]&127](e)|0;i=d;return a|0}function rn(a){a=a|0;i=i;return a+7&-8|0}function sn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[4922]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=aR(16)|0;c[f+12>>2]=d;c[4922]=f;c[f+4>>2]=0;d=tn((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=aR(d)|0;c[f>>2]=a;i=b;return}function tn(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function un(a){a=a|0;var b=0,c=0;b=i;c=ER(a|0)|0;i=b;return c|0}function vn(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;KR(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ec(m|0,l|0,f|0)|0;f=wn(m)|0;i=e;return f|0}function wn(a){a=a|0;var b=0,c=0,d=0;b=i;c=ER(a|0)|0;d=yn(c)|0;GR(d|0,a|0,c|0)|0;i=b;return d|0}function xn(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;ec(o|0,19728,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;ec(o|0,19720,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ec(q|0,p|0,j|0)|0;j=wn(q)|0;i=g;return j|0}function yn(b){b=b|0;var d=0,e=0;d=i;e=$d[c[19652>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function zn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=un(a)|0;e=un(b)|0;f=yn(e+d|0)|0;GR(f|0,a|0,d|0)|0;GR(f+d|0,b|0,e|0)|0;i=c;return f|0}function An(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=AR(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function Bn(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}else if((e|0)==2){f=-1;break}switch(d|0){case 2:{f=4;break a;break};case 0:{f=8;break a;break};case 3:{f=2;break a;break};case 4:{f=2;break a;break};case 5:{f=1;break a;break};case 1:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function Cn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Tc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){bR(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{bR(c[(c[f>>2]|0)+(g<<4)>>2]|0);bR(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;bR(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){bR(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{bR(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}bR(d);c[g>>2]=0;i=b;return}function Dn(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(ER(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function En(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=fc(b|0,19896)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Nd(c[(Jc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=rd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=pb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=19904;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[19872+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=19928;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=19952;E=131;break}G=Bn(D)|0;if((G|0)==-1){n=19984;E=131;break}D=c[q>>2]|0;H=aR(D)|0;if((pb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=20032;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=20056;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((AR(H,c[19848+(C<<2)>>2]|0)|0)!=0){n=20080;E=131;break}bR(H);H=20656;b:do{switch(C|0){case 3:{F=fa(I<<2,D)|0;K=aR(F)|0;if((pb(K|0,F|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}F=c[v>>2]|0;G=0;do{L=fa(D,G)|0;c[F+(G<<4)+8>>2]=(c[K+(L<<2)>>2]|0)==1;c[F+(G<<4)+12>>2]=c[K+(L+1<<2)>>2];G=G+1|0;}while(G>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}G=c[v>>2]|0;F=0;do{c[G+(F<<4)+8>>2]=(c[K+(F<<2)>>2]|0)==1;c[G+(F<<4)+12>>2]=c[K+(D+F<<2)>>2];F=F+1|0;}while(F>>>0<D>>>0)}}while(0);bR(K);$b(c[v>>2]|0,c[u>>2]|0,16,52);M=d;E=130;break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;G=aR((F?D:I)<<4)|0;c[v>>2]=G;c:do{if(d<<24>>24==1){if((I|0)==0){N=0;break}L=D+1|0;O=G;P=0;while(1){c[O+(P<<4)>>2]=aR(L)|0;if((pb(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=20280;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;Q=c[v>>2]|0;c[Q+(P<<4)+8>>2]=-1;c[Q+(P<<4)+12>>2]=-1;Dn(c[Q+(P<<4)>>2]|0);Q=P+1|0;if(!(Q>>>0<I>>>0)){N=I;break c}O=c[v>>2]|0;P=Q}}else{N=I}}while(0);if(!F){M=d;E=130;break b}G=fa(D,N)|0;R=aR(G+1|0)|0;if((pb(R|0,G|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){G=N+1|0;P=(N|0)==0;O=0;do{L=aR(G)|0;c[(c[v>>2]|0)+(O<<4)>>2]=L;if(!P){L=0;do{Q=a[R+((fa(D,L)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+L|0]=Q;L=L+1|0;}while(L>>>0<N>>>0)}a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+N|0]=0;L=c[v>>2]|0;c[L+(O<<4)+8>>2]=-1;c[L+(O<<4)+12>>2]=-1;Dn(c[L+(O<<4)>>2]|0);O=O+1|0;}while(O>>>0<D>>>0)}bR(R);M=0;E=130;break};case 2:{if(d<<24>>24==1){if((I|0)==0){S=1;E=129;break b}O=D+1|0;P=0;while(1){G=aR(O)|0;c[(c[v>>2]|0)+(P<<4)+4>>2]=G;if((pb(c[(c[v>>2]|0)+(P<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=20280;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)+4>>2]|0)+D|0]=0;G=P+1|0;if(G>>>0<I>>>0){P=G}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){S=d;E=129;break b}P=fa(D,I)|0;T=aR(P+1|0)|0;if((pb(T|0,P|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){P=I+1|0;O=(I|0)==0;G=0;do{F=aR(P)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=F;if(!O){F=0;do{L=a[T+((fa(D,F)|0)+G)|0]|0;a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+F|0]=L;F=F+1|0;}while(F>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+I|0]=0;G=G+1|0;}while(G>>>0<D>>>0)}bR(T);M=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=20344;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=20400;E=131;break a}c[w>>2]=D;G=fa(I,D)|0;if((a[l]|0)==1){O=aR(G<<3)|0;c[x>>2]=O;if((pb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=20440;E=131;break a}}else{O=aR(G<<2)|0;c[x>>2]=aR(fa(D<<3,I)|0)|0;if((pb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=20440;E=131;break a}if((G|0)!=0){P=c[x>>2]|0;F=0;do{h[P+(F<<3)>>3]=+g[O+(F<<2)>>2];F=F+1|0;}while(F>>>0<G>>>0)}bR(O)}G=c[w>>2]|0;if(!(G>>>0>1)){M=1;E=130;break b}F=(I|0)==2;P=1;while(1){if(F){L=c[x>>2]|0;if(+h[L+(P<<3)>>3]!=+h[L+(G+P<<3)>>3]){n=20472;E=131;break a}}L=P+1|0;if(L>>>0<G>>>0){P=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){S=d;E=129;break b}if((I|0)==0){n=20344;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=20552;E=131;break a}c[w>>2]=I;P=fa(I,D)|0;if((a[l]|0)==1){G=aR(P<<3)|0;c[x>>2]=aR(fa(D<<3,I)|0)|0;if((pb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=20440;E=131;break a}if((D|0)!=0){F=0;do{O=c[x>>2]|0;L=0;do{h[O+((fa(I,F)|0)+L<<3)>>3]=+h[G+((fa(D,L)|0)+F<<3)>>3];L=L+1|0;}while(L>>>0<I>>>0);F=F+1|0;}while(F>>>0<D>>>0)}bR(G)}else{F=aR(P<<2)|0;c[x>>2]=aR(fa(D<<3,I)|0)|0;if((pb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=20440;E=131;break a}if((D|0)!=0){L=0;do{O=c[x>>2]|0;Q=0;do{h[O+((fa(I,L)|0)+Q<<3)>>3]=+g[F+((fa(D,Q)|0)+L<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}bR(F)}L=c[w>>2]|0;if(!(L>>>0>1)){M=d;E=130;break b}P=(D|0)==2;G=1;while(1){if(P){Q=c[x>>2]|0;if(+h[Q+(G<<3)>>3]!=+h[Q+(L+G<<3)>>3]){n=20472;E=131;break a}}Q=G+1|0;if(Q>>>0<L>>>0){G=Q}else{M=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=20592;E=131;break a}c[z>>2]=D;c[A>>2]=vb(c[m>>2]|0)|0;c[B>>2]=cR(c[z>>2]<<1,4)|0;if((Rc(c[m>>2]|0,J|0,1)|0)==-1){n=20624;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=20592;E=131;break a}c[z>>2]=I;c[A>>2]=vb(c[m>>2]|0)|0;c[B>>2]=cR(c[z>>2]<<1,4)|0;G=fa(I,D)|0;if((a[l]|0)==1){L=aR(G<<3)|0;if((pb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=20624;E=131;break a}if((I|0)!=0){P=D<<3;F=(D|0)==0;Q=D<<3;O=0;do{U=aR(P)|0;c[(c[B>>2]|0)+(O<<2)>>2]=U;if(!F){U=L+(fa(Q,O)|0)|0;GR(c[(c[B>>2]|0)+(O<<2)>>2]|0,U|0,Q|0)|0}O=O+1|0;}while(O>>>0<I>>>0)}O=c[z>>2]|0;Q=O<<1;if(O>>>0<Q>>>0){F=D<<3;P=(D|0)==0;U=O;do{V=aR(F)|0;c[(c[B>>2]|0)+(U<<2)>>2]=V;if(!P){V=c[B>>2]|0;W=c[V+(U-O<<2)>>2]|0;X=c[V+(U<<2)>>2]|0;V=0;do{h[X+(V<<3)>>3]=-+h[W+(V<<3)>>3];V=V+1|0;}while(V>>>0<D>>>0)}U=U+1|0;}while(U>>>0<Q>>>0)}bR(L)}else{Q=aR(G<<2)|0;if((pb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=20624;E=131;break a}if((I|0)!=0){U=D<<3;O=(D|0)==0;P=0;do{F=aR(U)|0;c[(c[B>>2]|0)+(P<<2)>>2]=F;if(!O){F=c[(c[B>>2]|0)+(P<<2)>>2]|0;V=0;do{h[F+(V<<3)>>3]=+g[Q+((fa(D,P)|0)+V<<2)>>2];V=V+1|0;}while(V>>>0<D>>>0)}P=P+1|0;}while(P>>>0<I>>>0)}P=c[z>>2]|0;O=P<<1;if(P>>>0<O>>>0){U=D<<3;G=(D|0)==0;L=P;do{V=aR(U)|0;c[(c[B>>2]|0)+(L<<2)>>2]=V;if(!G){V=c[B>>2]|0;F=c[V+(L-P<<2)>>2]|0;W=c[V+(L<<2)>>2]|0;V=0;do{h[W+(V<<3)>>3]=-+h[F+(V<<3)>>3];V=V+1|0;}while(V>>>0<D>>>0)}L=L+1|0;}while(L>>>0<O>>>0)}bR(Q)}if((Rc(c[m>>2]|0,J|0,1)|0)==-1){n=20624;E=131;break a}else{M=d;E=130}break};case 0:{if((D|0)!=4){n=20104;E=131;break a}if((I|0)!=11){n=20144;E=131;break a}if((pb(f|0,44,1,c[m>>2]|0)|0)==1){Y=0}else{n=20184;E=131;break a}while(1){O=0;do{a[k+O|0]=a[j+((O<<2)+Y)|0]|0;O=O+1|0;}while(O>>>0<11);a[k+11|0]=0;if((Y|0)==3){break}O=Y+1|0;if(O>>>0<4){Y=O}else{M=d;E=130;break b}}if((BR(t,c[4938]|0,8)|0)==0){M=1;E=130;break b}if((BR(t,c[4944]|0,9)|0)==0){M=0;E=130}else{n=20216;E=131;break a}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=S;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){bR(R);n=20280;i=e;return n|0}else if((E|0)==46){bR(T);n=20280;i=e;return n|0}else if((E|0)==52){bR(K);n=20312;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function Fn(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=vd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,52)|0;i=d;return b|0}function Gn(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=20696;o=n;p=20744;q=p;r=20768;s=r;$a(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=20696;o=n;p=20744;q=p;r=20768;s=r;$a(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=aR(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Rc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((pb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}bR(r);t=0;i=e;return t|0}else{k=aR(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Rc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((pb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}bR(k);bR(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);bR(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function Hn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=20696;r=q;s=20744;t=s;u=20792;v=u;$a(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=20696;r=q;s=20744;t=s;u=20792;v=u;$a(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Rc(o|0,t+(r<<3)|0,0)|0;f=(pb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Rc(o|0,t+(r<<2)|0,0)|0;if((pb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function In(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function Jn(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function Kn(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function Ln(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+Kn(b)<e){q=1;i=f;return q|0}if(+Jn(b)>e){q=1;i=f;return q|0}if((Gn(b,1)|0)==0){q=1;i=f;return q|0}In(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+Hn(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+Hn(a,b,d,o);i=f;return q|0}if(+Hn(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+Hn(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function Mn(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function Nn(a,b){a=a|0;b=b|0;var c=0;c=i;Em(a,b,nn(b)|0);i=c;return}function On(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=nn(Fm(a,b,f)|0)|0;i=e;return}function Pn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((Bm(a)|0)==0){$a(20824,20848,127,20872)}if((Bm(b)|0)==0){$a(20896,20848,128,20872)}if((Cm(a,b)|0)==0){$a(20920,20848,129,20872)}e=Dm(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+Mn(a,b);Qn(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function Qn(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function Rn(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function Sn(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;Qn(c[d+8>>2]|0,b,a);i=e;return}function Tn(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;Nn(a,b);j=g;c[g>>2]=e;Sn(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;Sn(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function Un(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=Gm(a,b,f)|0;f=Rn(c[a+8>>2]|0,d)|0;i=e;return f|0}function Vn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=aR(d<<2)|0;if((j|0)==0){$a(20960,20848,784,20992)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){$a(20968,20848,795,20992)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){$a(21016,20848,798,20992)}else if((s|0)==17){$a(21056,20848,800,20992)}else if((s|0)==22){$a(21056,20848,804,20992)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=nn(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=pn(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){bR(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+Mn(a,k+s|0);Qn(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}bR(j);i=g;return}function Wn(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if((Bm(a)|0)==0){$a(21104,20848,1547,21128)}c=Dm(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +Mn(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function Xn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=aR(20)|0;Um(0,(f|0)!=0|0,21144,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=cR(e,b)|0;c[f>>2]=a;Um(0,(a|0)!=0|0,21144,d);i=d;return f|0}function Yn(a){a=a|0;var b=0;b=i;bR(c[a>>2]|0);bR(a);i=b;return}function Zn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Um(0,(c[h>>2]|0)>0|0,21160,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Um(0,(g|0)>(b|0)|0,21184,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Um(0,(0-f|0)<(b|0)|0,21184,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function _n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=cR(c[d>>2]<<1,c[e>>2]|0)|0;Um(0,(f|0)!=0|0,21144,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Zn(a,j)|0;h=c[e>>2]|0;GR(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;bR(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function $n(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){_n(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;GR((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function ao(a){a=a|0;i=i;return c[a+12>>2]|0}function bo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Um(0,(c[j>>2]|0)>0|0,21160,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Um(0,(h|0)>(b|0)|0,21184,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Um(0,b>>>31^1,21184,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Zn(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function co(a){a=a|0;i=i;return c[(c[5304]|0)+(a<<2)>>2]|0}function eo(a){a=a|0;i=i;return c[(c[5306]|0)+(a<<2)>>2]|0}function fo(a){a=a|0;i=i;return c[(c[5308]|0)+(a<<2)>>2]|0}function go(a){a=a|0;i=i;return c[(c[5310]|0)+(a<<2)>>2]|0}function ho(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[5306]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[5308]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[5304]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function io(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5312]|0;e=+jo(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function jo(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function ko(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5314]|0;e=+jo(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function lo(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5316]|0;e=+jo(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function mo(a){a=a|0;i=i;return 0}function no(a){a=a|0;var b=0,d=0;b=i;db(4,(c[5318]|0)+(a<<3)|0)|0;d=(c[5304]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function oo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[5312]|0;f=e+(a<<3)|0;g=c[5316]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[5310]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[5304]|0)+(a<<2)>>2]|0);e=c[5314]|0;g=e+(a<<3)|0;po(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;ho(a);d=c[5312]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[5304]|0)+(a<<2)>>2]=0;i=b;return}function po(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(so(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;db(4,d|0)|0;e=c[5318]|0;f=c[5312]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function ro(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=cR(a,8)|0;c[5312]=d;e=cR(a,8)|0;c[5314]=e;f=cR(a,8)|0;c[5316]=f;g=cR(a,8)|0;c[5318]=g;h=cR(a,4)|0;c[5304]=h;j=cR(a,4)|0;c[5310]=j;k=a<<2;l=aR(k)|0;c[5306]=l;m=cR(a,4)|0;c[5308]=m;IR(l|0,-1,k|0)|0;if((d|0)==0){$a(21280,21296,393,21312)}if((e|0)==0){$a(21320,21296,394,21312)}if((f|0)==0){$a(21336,21296,395,21312)}if((g|0)==0){$a(21352,21296,396,21312)}if((h|0)==0){$a(21368,21296,397,21312)}if((l|0)==0){$a(21392,21296,398,21312)}if((m|0)==0){$a(21416,21296,399,21312)}if((j|0)==0){$a(21440,21296,400,21312)}else{i=b;return}}function so(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function to(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function uo(a){a=a|0;var b=0;b=i;bR(c[a+12>>2]|0);bR(c[a+4>>2]|0);bR(c[a+8>>2]|0);i=b;return}function vo(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Bd(a|0,d|0)|0;md(d|0)|0;Yd[c[16256]&255](0);i=b;return}function wo(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[3482]=.5;h[3468]=1.0;h[3505]=.25;h[3480]=2.0;h[3507]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[6972]=A;B=c[d>>2]|0;c[6902]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[6902]=D;if((C|0)<(B|0)){C=D}else{break}}}c[6900]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[3483]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[3483]=F;G=F}else{G=E}D=c[d>>2]|0;c[6902]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[6902]=I;if((H|0)>=(D|0)){break a}E=+h[3483];H=I}}}while(0);D=C+1|0;c[6900]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[3487]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[3452]=0.0;h[3454]=0.0;h[3458]=0.0;h[3515]=0.0;c[6898]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[3452]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[3454]+ +h[B>>3]*F;h[3454]=E;F=+h[I>>3];M=+h[3458]+F*F;h[3458]=M;F=+h[H>>3];h[3515]=+h[3515]+F*F;H=A+1|0;c[6898]=H;F=+h[3452];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[6968]=A;E=G/J;h[3504]=E;C=c[d>>2]|0;c[6902]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[3512]=0.0;h[3514]=0.0;I=c[b>>2]|0;c[6898]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[3481]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[3512]=ba;ca=E+aa*aa;h[3514]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[6898]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[6968]=A;h[3504]=E;h[3454]=Z;h[3458]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[6902]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[6898]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[6898]=A+1;da=+h[3454];ea=+h[3458];ga=+h[3452]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[3503]=K;c[6996]=0;h[3511]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[6996]=C;K=+h[3468]/+V(+ga);h[3483]=K;h[3506]=0.0;h[3508]=0.0;B=c[b>>2]|0;c[6898]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[3506]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[3506]=oa;pa=+h[3508]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[3508]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[3454];L=+h[3452];N=+h[3483];D=D+1|0;la=ma}c[6898]=B+1;ia=+h[3452];ja=pa;ka=oa}N=+h[3482];L=ka*N*ka;h[3499]=L;J=ja*N*ja;h[3500]=J;h[3459]=J+(L+ia*(+h[3515]+ia*N));N=+h[3480];h[27680>>3]=N*ka*ia;h[27688>>3]=N*ja*ia;h[27696>>3]=L-J;h[27704>>3]=ka*ja;la=27712|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[6898]=10;la=c[d>>2]|0;c[6902]=1;if((la|0)>=1){D=1;while(1){h[3499]=0.0;h[3500]=0.0;h[3501]=0.0;A=c[b>>2]|0;c[6898]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[3499]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[3500]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[3501]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[6898]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[3505]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[3499]*+h[3501];h[t+(U+D<<3)>>3]=+h[3500]*+h[3501];J=+h[3499];L=+h[3500];h[t+(P+D<<3)>>3]=+h[3505]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[3482]*+h[3499]*+h[3500];na=D+1|0;c[6902]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[6898]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[6910]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[6898]=B;if((la|0)<(D|0)){la=B}else{break}}}c[6906]=1;la=1;do{D=c[d>>2]|0;c[6914]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[6914]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[6902]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[6902]=D+1}na=c[6972]|0;c[6900]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[3479]=0.0;ma=c[d>>2]|0;c[6902]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[3479]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[6902]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[3479]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[6902]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[3479];Ca=Ca+1|0}c[6902]=ta+1}Ca=B+1|0;c[6900]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[6902]=1;if((A|0)<1){break}else{Ea=1}while(1){h[3479]=0.0;B=c[b>>2]|0;c[6900]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[3479]=N;Ca=na+1|0;c[6900]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[6902]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[6900]=1;if((A|0)>=1){ta=1;while(1){h[3479]=0.0;c[6898]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[3479]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[6898]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[6900]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[6906]=la;}while((la|0)<6);la=c[l>>2]|0;c[6902]=1;h[3479]=0.0;c[6898]=1;L=+h[3482];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[27752+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[27752+(A+ -1<<3)>>3]+L;h[3479]=L;A=A+1|0;}while((A|0)<6);h[3459]=+h[3459]- +h[3469]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[3499]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[3500]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[3501]=O;h[27680>>3]=+h[27680>>3]-J-N*(O+K);h[27712>>3]=+h[27712>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[3499]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[3500]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[3501]=J;h[27688>>3]=+h[27688>>3]-O-N*(K-J);h[27720>>3]=+h[27720>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[3499]=J;h[27696>>3]=+h[27768>>3]+(+h[27696>>3]-J- +h[27760>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[3499]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[3500]=K;Oa=+h[3482];h[27704>>3]=+h[27704>>3]-J-K*Oa;h[27728>>3]=+h[27728>>3]- +h[27776>>3]+ +h[27784>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[3499]=K;h[27736>>3]=+h[27736>>3]-Oa*K;h[3479]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[6902]=la+1;c[6898]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[27752+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[27752+(ta+ -1<<3)>>3]+N;h[3479]=N;ta=ta+1|0;c[6898]=ta;}while((ta|0)<6);K=+h[3487];h[3489]=K*+h[3459]+ +h[3469]+N;J=+h[3480];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[3499]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[3500]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[3501]=R;T=R+(K*+h[27680>>3]+O+S);h[27920>>3]=T;O=K*+h[27712>>3]+S-R;h[27952>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[3499]=R;S=+h[I>>3]*+h[ma>>3];h[3500]=S;Z=+h[Ma>>3]*+h[Na>>3];h[3501]=Z;h[27928>>3]=K*+h[27688>>3]+R+S-Z;h[27960>>3]=K*+h[27720>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[3499]=Z;R=+h[27760>>3]+(Z+K*+h[27696>>3])- +h[27768>>3];h[27936>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[3499]=Z;h[27944>>3]=Z+K*+h[27704>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[27728>>3]+ +h[27776>>3]- +h[27784>>3];h[27968>>3]=J;h[27976>>3]=+h[3487]*+h[27736>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[3489]+T+R+O+J;h[3479]=K;h[3509]=K;h[3510]=K;c[7004]=0;J=+h[3507]/50.0;h[3483]=J;h[3469]=+h[3468];c[6898]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[27760>>3]=Z;W=+Y(+Pa);h[27768>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[27752+(Ma+ -1<<3)>>3]=Z;Q=+h[27760>>3]*G+ +h[27768>>3]*W;h[27752+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[27768>>3];ca=+h[27760>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[27912+(Ma<<3)>>3]*+h[27752+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[3510]=Ra;c[7004]=Na;h[3499]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[3500]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[6900]=10;h[3479]=Ra;h[3488]=Pa;h[3513]=O;c[6898]=50;if((Xa|0)==49){h[3500]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[3499]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[3485]=0.0;if(Ya!=Za){S=Ya-Ua;h[3499]=S;T=Za-Ua;h[3500]=T;R=+h[3482]*(S-T)/(S+T);h[3485]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[3488]=R;T=+X(+R);h[27760>>3]=T;S=+Y(+R);h[27768>>3]=S;c[6900]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[27752+(Na+ -1<<3)>>3]=T;W=+h[27760>>3]*G+ +h[27768>>3]*S;h[27752+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[27768>>3];N=+h[27760>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[3510]=0.0;c[6900]=1;Na=1;do{ma=Na+ -1|0;Ma=27752+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[27672+(ma<<3)>>3]*+h[Ma>>3];h[3510]=+h[3510]+ +h[27912+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[6900]=10;Na=c[l>>2]|0;c[6902]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[27752+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[6900]=6;c[6902]=Na+1}h[3478]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[3452]=0.0;h[3499]=0.0;h[3500]=0.0;Ma=c[b>>2]|0;c[6898]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[27760>>3]*+h[la>>3]+ +h[27768>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[3452]=+h[3452]+G*G;bb=+h[3499]+ +h[la>>3]*+h[ta>>3];h[3499]=bb;G=+h[ta>>3];cb=+h[3500]+G*G;h[3500]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[6898]=Ma+1;$a=cb;ab=bb}ma=c[6996]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[3511];S=+h[3509];h[3511]=G>=S?G:S}S=+h[3510];if(!(S>=0.0)){db=-S}else{db=S}G=+h[3511];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[3511]=S;c[6898]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[3483]=N;R=+h[3478]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[3487];la=ta+1|0;c[6898]=la;if((ta|0)>=(Na|0)){break b}S=+h[3500];G=+h[3499];ta=la}}}while(0);Na=c[d>>2]|0;c[6902]=1;if((Na|0)>=1){Ma=1;while(1){h[3479]=0.0;ta=c[b>>2]|0;c[6900]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[3479]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[6900]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[3478]*+h[p+(la+ -1+Ma<<3)>>3]- +h[3487]*+h[q+(Ma+ -1<<3)>>3]);h[3483]=G;c[6898]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[3483];I=I+1|0}c[6898]=la+1}I=Ma+1|0;c[6902]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[3458]=0.0;h[3454]=0.0;Ma=c[b>>2]|0;c[6898]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[3458]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[3454]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[6898]=Ma+1;hb=kb;ib=jb}S=+h[3452];G=S*ib-hb*hb;h[3503]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[27648]=1;C=c[l>>2]|0;c[6902]=1;if((C|0)<1){lb=27744;mb=+h[3468];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[27752+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[6900]=6;c[6902]=C+1;lb=27744;mb=+h[3468];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function xo(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[3535]=.5;h[3531]=1.0;h[3547]=6.283185307179586;z=+h[n>>3];h[3544]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[7076]=A;c[7084]=0;B=c[d>>2]|0;c[7036]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[7036]=B+1}c[7034]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[3536]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[3536]=F;G=F}else{G=z}H=c[d>>2]|0;c[7036]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[3536];I=I+1|0}c[7036]=H+1}I=B+1|0;c[7034]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[3519]=0.0;D=c[b>>2]|0;c[7032]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[3519]=+h[3519]+G*G;A=p+1|0;c[7032]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[7036]=1;if((p|0)>=1){D=1;while(1){h[3536]=0.0;h[3534]=0.0;y=c[b>>2]|0;c[7034]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[3536]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[3534]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[7034]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[3536]=G;h[3534]=+h[g>>3]*L;g=c[b>>2]|0;c[7032]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[3534]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[3536];H=H+1|0}c[7032]=g+1}H=D+1|0;c[7036]=H;if((D|0)<(p|0)){D=H}else{break}}}h[3520]=0.0;h[3522]=0.0;h[3529]=0.0;D=c[b>>2]|0;c[7032]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[3520]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[3522]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[3529]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[7032]=D+1;O=R;P=T;Q=S}S=+h[3519];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[3540]=U;h[3536]=0.0;if(Q*Q>S*.99*O){h[3536]=+h[3531]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[3535]*U*Z);h[3532]=P;if(O*+h[3544]<P*P*.01){h[3536]=+h[3531]}n=c[b>>2]|0;c[7032]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[3540]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[3536]*U;if((D|0)>=(n|0)){break}e=D;P=+h[3540];D=D+1|0;p=e}c[7032]=n+1;_=0}while(1){n=_+1|0;c[7084]=n;h[3519]=0.0;h[3522]=0.0;h[3523]=0.0;p=c[b>>2]|0;c[7032]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[3519]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[3522]=da;Z=+h[H>>3];ea=P+Z*Z;h[3523]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[7032]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[3536]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[3541]=U;D=c[b>>2]|0;c[7032]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[3541];U=+h[3522];O=+h[3519];g=g+1|0;H=e}c[7032]=D+1}H=c[d>>2]|0;c[7036]=1;if((H|0)>=1){g=1;while(1){h[3534]=0.0;p=c[b>>2]|0;c[7034]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[3534]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[7034]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[3534]=O;e=c[b>>2]|0;c[7032]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[3534];l=l+1|0}c[7032]=e+1}l=g+1|0;c[7036]=l;if((g|0)<(H|0)){g=l}else{break}}}h[3524]=0.0;h[3525]=0.0;h[3526]=0.0;h[3527]=0.0;h[3528]=0.0;g=c[b>>2]|0;c[7032]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[3524]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[3525]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[3526]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[3527]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[3528]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[7032]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[3535];O=U*na;h[3524]=O;P=U*ma-O;h[3527]=P;Z=O+la+P;h[3548]=Z;h[3550]=Z;h[3549]=Z;c[7086]=0;a[28168]=1;W=+h[3547]/50.0;h[3536]=W;c[7032]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[3550]=wa;c[7086]=p;h[3545]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[3546]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[3539]=ta;h[3530]=ua;h[3533]=va;h[3532]=wa;c[7032]=50;h[3549]=wa;if((za|0)==49){h[3546]=Z;Ba=Z}else if((za|0)==0){h[3545]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[3546]}h[3537]=0.0;S=+h[3545];if(S!=Ba){Q=S-Aa;h[3545]=Q;S=Ba-Aa;h[3546]=S;T=U*(Q-S)/(Q+S);h[3537]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[3539]=T;S=+X(+T);h[3530]=S;Q=+Y(+T);h[3533]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[3532]=T;p=c[b>>2]|0;c[7032]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[3530]*+h[y>>3]+ +h[3533]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[3533];Q=+h[3530];H=H+1|0;g=e}c[7032]=p+1;Da=+h[3532]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[3548];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function yo(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[28624]=1;a[28616]=1;c[28636>>2]=6;FF(28632)|0;e=c[d>>2]|0;c[7152]=1;if((e|0)>=1){d=1;do{WE(28752,b+(d+ -1)|0,1)|0;o=c[7152]|0;d=o+1|0;c[7152]=d;}while((o|0)<(e|0))}nF()|0;e=c[g>>2]|0;if((e|0)==1){c[28660>>2]=a[28616]&1?6:0;FF(28656)|0;WE(28752,h,4)|0;nF()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[28684>>2]=a[28616]&1?6:0;FF(28680)|0;WE(28752,h,4)|0;WE(28752,j,4)|0;nF()|0}j=c[k>>2]|0;if((j|0)==1){c[28708>>2]=a[28616]&1?6:0;FF(28704)|0;WE(28752,l,8)|0;nF()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[28732>>2]=a[28616]&1?6:0;FF(28728)|0;WE(28752,l,8)|0;WE(28752,m,8)|0;nF()|0}if((c[f>>2]|0)==2){GE(28760,0)|0}else{i=n;return 0}return 0}



function lA(a,b,c){a=a|0;b=b|0;c=c|0;b=i;XG(c);i=b;return}function mA(a,b,c){a=a|0;b=b|0;c=c|0;b=i;XG(c);i=b;return}function nA(a){a=a|0;i=i;return a+4|0}function oA(a,b){a=a|0;b=b|0;var c=0;c=i;pA(a,b);i=c;return}function pA(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function qA(a){a=a|0;var b=0,c=0;b=i;c=JA(a+4|0)|0;i=b;return c|0}function rA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];BA(a,b,f);i=e;return}function sA(a,b){a=a|0;b=b|0;var c=0;a=i;c=AA(0,b,0)|0;i=a;return c|0}function tA(a,b){a=a|0;b=b|0;var c=0;c=i;zA(a,b);i=c;return}function uA(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}NG(b,c);i=a;return}function vA(a){a=a|0;var b=0,d=0;b=i;d=c[(Zz(a)|0)>>2]|0;i=b;return d|0}function wA(a){a=a|0;var b=0,c=0;b=i;c=eA(a)|0;i=b;return c|0}function xA(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}LG(b);i=a;return}function yA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;oA(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Qz(h,f);Sz(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Qz(a,e);Tz(h);i=d;return}function zA(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function AA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gR(b*40|0)|0;i=c;return a|0}function BA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DA(g)|0)>>2]|0;g=EA(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];CA(b,a,f);i=e;return}function CA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];FA(a,b,f);i=e;return}function DA(a){a=a|0;i=i;return a|0}function EA(a){a=a|0;i=i;return a|0}function FA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HA(g)|0)>>2]|0;g=IA(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];GA(b,a,f);i=e;return}function GA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(HA(f)|0)>>2];f=IA(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function HA(a){a=a|0;i=i;return a|0}function IA(a){a=a|0;i=i;return a|0}function JA(a){a=a|0;var b=0,c=0;b=i;c=KA(a)|0;i=b;return c|0}function KA(a){a=a|0;i=i;return a|0}function LA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Wz(MA(b)|0)|0;h=IA(wA(MA(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];CA(g,a,e);i=d;return}function MA(a){a=a|0;i=i;return c[a>>2]|0}function NA(a){a=a|0;var b=0;b=i;OA(a);i=b;return}function OA(a){a=a|0;var b=0;b=i;PA(a);i=b;return}function PA(a){a=a|0;var b=0;b=i;QA(a,py(a)|0);i=b;return}function QA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;os(d);if((b|0)==0){i=d;return}QA(a,c[b>>2]|0);QA(a,c[b+4>>2]|0);e=qA(a)|0;RA(e,SA(b+16|0)|0);jA(e,b,1);i=d;return}function RA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;TA(d,0,c);i=b;return}function SA(a){a=a|0;i=i;return a|0}function TA(a,b,c){a=a|0;b=b|0;c=c|0;b=i;UA(c);i=b;return}function UA(a){a=a|0;var b=0;b=i;VA(a);i=b;return}function VA(a){a=a|0;var b=0;b=i;WA(a);i=b;return}function WA(a){a=a|0;var b=0;b=i;XA(a);i=b;return}function XA(a){a=a|0;var b=0;b=i;XG(a+12|0);XG(a);i=b;return}function YA(a){a=a|0;var b=0;b=i;ZA(a+180|0);ZA(a+168|0);ZA(a+156|0);ZA(a+144|0);ZA(a+132|0);ZA(a+120|0);ZA(a+108|0);ZA(a+96|0);ZA(a+84|0);ZA(a+72|0);ZA(a+60|0);ZA(a+48|0);ZA(a+36|0);ZA(a+24|0);mw(a+12|0);mw(a);i=b;return}function ZA(a){a=a|0;var b=0;b=i;_A(a);i=b;return}function _A(a){a=a|0;var b=0;b=i;$A(a);i=b;return}function $A(a){a=a|0;var b=0;b=i;aB(a);i=b;return}function aB(a){a=a|0;var b=0;b=i;bB(a,Ez(a)|0);i=b;return}function bB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;os(d);if((b|0)==0){i=d;return}bB(a,c[b>>2]|0);bB(a,c[b+4>>2]|0);e=hz(a)|0;cB(e,dB(b+16|0)|0);bz(e,b,1);i=d;return}function cB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;eB(d,0,c);i=b;return}function dB(a){a=a|0;i=i;return a|0}function eB(a,b,c){a=a|0;b=b|0;c=c|0;b=i;fB(c);i=b;return}function fB(a){a=a|0;var b=0;b=i;gB(a);i=b;return}function gB(a){a=a|0;var b=0;b=i;hB(a);i=b;return}function hB(a){a=a|0;var b=0;b=i;iB(a);i=b;return}function iB(a){a=a|0;var b=0;b=i;mw(a+4|0);i=b;return}function jB(a){a=a|0;var b=0;b=i;kB(a);i=b;return}function kB(a){a=a|0;var b=0;b=i;lB(a);i=b;return}function lB(a){a=a|0;var b=0;b=i;mB(a,$w(a)|0);i=b;return}function mB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;os(d);if((b|0)==0){i=d;return}mB(a,c[b>>2]|0);mB(a,c[b+4>>2]|0);e=Jx(a)|0;nB(e,Ow(b+16|0)|0);Dx(e,b,1);i=d;return}function nB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;oB(d,0,c);i=b;return}function oB(a,b,c){a=a|0;b=b|0;c=c|0;b=i;pB(c);i=b;return}function pB(a){a=a|0;var b=0;b=i;qB(a);i=b;return}function qB(a){a=a|0;var b=0;b=i;rB(a);i=b;return}function rB(a){a=a|0;var b=0;b=i;sB(a);i=b;return}function sB(a){a=a|0;var b=0;b=i;XG(a);i=b;return}function tB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;uB(a);wB(g,b);xB(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];vB(a,f,e);i=d;return a|0}function uB(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;QA(a,py(a)|0);c[($z(a)|0)>>2]=0;d=iy(a)|0;c[(Kz(a)|0)>>2]=d;os(b);c[d>>2]=0;i=b;return}function vB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;FB(h,a);if(!(GB(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];yB(j,g);o=IB(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];HB(l,a,f,o);JB(b)|0;}while(GB(b,d)|0);i=e;return}function wB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;DB(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];yB(a,e);i=d;return}function xB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;zB(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];yB(a,e);i=d;return}function yB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CB(a,e);i=d;return}function zB(a,b){a=a|0;b=b|0;var c=0;c=i;AB(a,ow(b)|0);i=c;return}function AB(a,b){a=a|0;b=b|0;var c=0;c=i;BB(a,b);i=c;return}function BB(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function CB(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function DB(a,b){a=a|0;b=b|0;var d=0;d=i;AB(a,c[(EB(b)|0)>>2]|0);i=d;return}function EB(a){a=a|0;i=i;return a|0}function FB(a,b){a=a|0;b=b|0;var c=0;c=i;xB(a,b);i=c;return}function GB(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=PC(a,b)|0;i=c;return d|0}function HB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];RB(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];QB(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];fy(a,g);UA(l);i=f;return}function IB(a){a=a|0;var b=0,c=0;b=i;c=NB(a)|0;i=b;return c|0}function JB(a){a=a|0;var b=0;b=i;KB(a)|0;i=b;return a|0}function KB(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=LB(c[d>>2]|0)|0;i=b;return a|0}function LB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;os(b);if((e|0)==0){e=a;while(1){a=cu(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=MB(c[d>>2]|0)|0;i=b;return g|0}return 0}function MB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;os(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;os(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function NB(a){a=a|0;var b=0,d=0;b=i;d=OB((c[a>>2]|0)+16|0)|0;i=b;return d|0}function OB(a){a=a|0;var b=0,c=0;b=i;c=PB(a)|0;i=b;return c|0}function PB(a){a=a|0;i=i;return a|0}function QB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=VB(b,h,j,e)|0;h=c[p>>2]|0;os(l);if((h|0)!=0){q=h;hy(a,q);i=f;return}XB(o,b,e);YB(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];WB(m,g);ZB(o);o=c[j>>2]|0;Uz(b,o,p,_B(m)|0);p=$B(m)|0;ZB(m);q=p;hy(a,q);i=f;return}function RB(a,b){a=a|0;b=b|0;var c=0;c=i;SB(a,b);i=c;return}function SB(a,b){a=a|0;b=b|0;var c=0;c=i;TB(a,b);i=c;return}function TB(a,b){a=a|0;b=b|0;var c=0;c=i;UB(a,b);i=c;return}function UB(a,b){a=a|0;b=b|0;var c=0;c=i;NG(a,b);NG(a+12|0,b+12|0);i=c;return}function VB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;gy(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];DC(l,k);do{if(!(CC(b,l)|0)){k=ry(a)|0;x=FC(b)|0;if(EC(k,e,x)|0){break}w=EC(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];JC(r,h,1,0);gy(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];DC(t,g);do{if(!(CC(r,t)|0)){if(EC(k,e,FC(r)|0)|0){break}y=IC(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;os(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;GC(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];DC(o,j);do{if(!(CC(n,o)|0)){j=ry(a)|0;if(EC(j,FC(HC(n)|0)|0,e)|0){break}y=IC(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;os(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function WB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];AC(a,e);i=d;return}function XB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qA(d)|0;d=sA(n,1)|0;mC(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];lC(j,d,h);nC(0,SA((oC(j)|0)+16|0)|0,e);a[(pC(j)|0)+4|0]=1;qC(m,j);YB(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];WB(b,g);ZB(m);ZB(j);i=f;return}function YB(a,b){a=a|0;b=b|0;var c=0;c=i;jC(a,b);i=c;return}function ZB(a){a=a|0;var b=0;b=i;eC(a);i=b;return}function _B(a){a=a|0;var b=0,d=0;b=i;d=c[(cC(a)|0)>>2]|0;i=b;return d|0}function $B(a){a=a|0;var b=0,d=0;b=i;d=aC(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function aC(a){a=a|0;var b=0,c=0;b=i;c=bC(a)|0;i=b;return c|0}function bC(a){a=a|0;i=i;return a|0}function cC(a){a=a|0;var b=0,c=0;b=i;c=dC(a)|0;i=b;return c|0}function dC(a){a=a|0;i=i;return a|0}function eC(a){a=a|0;var b=0;b=i;fC(a,0);i=b;return}function fC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=aC(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}hC(gC(e)|0,f);i=d;return}function gC(a){a=a|0;var b=0,c=0;b=i;c=iC(a)|0;i=b;return c|0}function hC(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;RA(f,SA(d+16|0)|0)}if((d|0)==0){i=e;return}jA(c[b>>2]|0,d,1);i=e;return}function iC(a){a=a|0;i=i;return a+4|0}function jC(a,b){a=a|0;b=b|0;var c=0;c=i;kC(a,b);i=c;return}function kC(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function lC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];uC(a,b,f);i=e;return}function mC(a,b){a=a|0;b=b|0;var c=0;c=i;tC(a,b);i=c;return}function nC(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}rC(b,c);i=a;return}function oC(a){a=a|0;var b=0,d=0;b=i;d=c[(cC(a)|0)>>2]|0;i=b;return d|0}function pC(a){a=a|0;var b=0,c=0;b=i;c=gC(a)|0;i=b;return c|0}function qC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;jC(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];WB(h,f);YB(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];WB(a,e);ZB(h);i=d;return}function rC(a,b){a=a|0;b=b|0;var c=0;c=i;sC(a,b);i=c;return}function sC(a,b){a=a|0;b=b|0;var c=0;c=i;TB(a,b);i=c;return}function tC(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function uC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DA(g)|0)>>2]|0;g=wC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];vC(b,a,f);i=e;return}function vC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];xC(a,b,f);i=e;return}function wC(a){a=a|0;i=i;return a|0}function xC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HA(g)|0)>>2]|0;g=zC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];yC(b,a,f);i=e;return}function yC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(HA(f)|0)>>2];f=zC(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function zC(a){a=a|0;i=i;return a|0}function AC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=$B(BC(b)|0)|0;h=zC(pC(BC(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];vC(g,a,e);i=d;return}function BC(a){a=a|0;i=i;return c[a>>2]|0}function CC(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function DC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];OC(a,e);i=d;return}function EC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=tw(0,b,c)|0;i=a;return d|0}function FC(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function GC(a,b){a=a|0;b=b|0;var d=0;d=i;hy(a,c[(Kz(b)|0)>>2]|0);i=d;return}function HC(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=MC(c[d>>2]|0)|0;i=b;return a|0}function IC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=py(a)|0;os(e);if((h|0)==0){j=iy(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=ry(a)|0;a=h;while(1){h=a+16|0;if(EC(j,d,h)|0){l=a;m=c[l>>2]|0;os(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(EC(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;os(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function JC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;KC(b,d);c[a>>2]=c[b>>2];i=e;return}function KC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;LC(b,c,e);i=d;return}function LC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{HC(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{KB(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function MC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;os(b);if((e|0)==0){e=a;while(1){a=cu(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=NC(c[d>>2]|0)|0;i=b;return g|0}return 0}function NC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;os(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;os(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function OC(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function PC(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(CC(a,b)|0)^1;i=c;return d|0}function QC(a){a=a|0;var b=0;b=i;i=i+128|0;ew(a,b);ew(a+12|0,b+8|0);RC(a+24|0,b+16|0);RC(a+36|0,b+24|0);RC(a+48|0,b+32|0);RC(a+60|0,b+40|0);RC(a+72|0,b+48|0);RC(a+84|0,b+56|0);RC(a+96|0,b+64|0);RC(a+108|0,b+72|0);RC(a+120|0,b+80|0);RC(a+132|0,b+88|0);RC(a+144|0,b+96|0);RC(a+156|0,b+104|0);RC(a+168|0,b+112|0);RC(a+180|0,b+120|0);i=b;return}function RC(a,b){a=a|0;b=b|0;b=i;SC(a,0);i=b;return}function SC(a,b){a=a|0;b=b|0;b=i;i=i+8|0;TC(a,b);i=b;return}function TC(a,b){a=a|0;b=b|0;b=i;UC(a,0);i=b;return}function UC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;VC(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;WC(f,0,e);e=Ry(b)|0;c[(Qy(b)|0)>>2]=e;i=d;return}function VC(a){a=a|0;var b=0;b=i;ZC(a);i=b;return}function WC(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;XC(b,c,f);i=e;return}function XC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Su(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;YC(d,b,f);i=e;return}function YC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Su(e)|0)>>2];i=d;return}function ZC(a){a=a|0;var b=0;b=i;_C(a);i=b;return}function _C(a){a=a|0;var b=0;b=i;Vu(a);i=b;return}function $C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[72900>>2]|0;if((m|0)==0){n=0}else{o=gR(12)|0;RG(o,m);n=o}if((c[72816>>2]|0)!=0){c[4716]=1}if((n|0)==0){c[18876>>2]=1;c[18880>>2]=1;i=b;return}do{if((tH(n,63040,0)|0)==-1){NG(g,n);LG(h);o=c[4290]|0;m=(o|0)<28;while(1){p=tH(g,63048,0)|0;q=(p|0)!=-1;if(q){rH(j,g,0,p);YG(h,j)|0;XG(j);rH(k,g,p+1|0,-1);YG(g,k)|0;XG(k)}else{YG(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){RG(l,c[17576+(s<<2)>>2]|0);p=aD(h,l)|0;XG(l);if(p){c[18872+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){Tm(1,1,63056,f);if(m){v=o}else{w=19424;x=c[4856]|0;Yd[x&255](1);y=sH(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=63096;E=D;Vm(0,E,a)}do{p=c[18744+(v<<2)>>2]|0;c[e>>2]=c[17576+(v<<2)>>2];c[e+4>>2]=p;Tm(1,0,63080,e);v=v+1|0;}while((v|0)<28);w=19424;x=c[4856]|0;Yd[x&255](1);y=sH(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=63096;E=D;Vm(0,E,a)}else if((t|0)==20){Tm(1,1,63056,d);w=19424;x=c[4856]|0;Yd[x&255](1);y=sH(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=63096;E=D;Vm(0,E,a)}else if((t|0)==23){XG(h);XG(g);break}}else{o=1;do{c[18872+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[18876>>2]=1;c[18880>>2]=1;if((c[18908>>2]|0)!=0){c[18968>>2]=1}if((c[18964>>2]|0)==1){c[18972>>2]=1}if((c[18944>>2]|0)!=0){c[18940>>2]=1}if((c[18952>>2]|0)!=0){c[18940>>2]=1}if((c[18904>>2]|0)!=0){c[18900>>2]=1}if((c[18948>>2]|0)!=0){c[18940>>2]=1}if((c[18896>>2]|0)!=0){c[18892>>2]=1}XG(n);iR(n);i=b;return}function aD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=VG(b)|0;if((e|0)!=(VG(c)|0)){f=0;i=d;return f|0}g=WG(b)|0;h=WG(c)|0;if(OG(b)|0){f=(vw(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function bD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[72908>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=gR(12)|0;l=k;RG(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(cD(l,c[50560+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=sH(l)|0;Tm(1,1,63128,g);g=c[50644>>2]|0;c[f>>2]=c[50564>>2];c[f+4>>2]=g;Tm(1,0,63080,f);f=c[50648>>2]|0;c[e>>2]=c[50568>>2];c[e+4>>2]=f;Tm(1,0,63080,e);e=c[50652>>2]|0;c[d>>2]=c[50572>>2];c[d+4>>2]=e;Tm(1,0,63080,d);Yd[c[4856]&255](1);Vm(0,63184,a)}else if((n|0)==6){i=b;return j|0}return 0}function cD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(vH(a,b)|0)==0;i=c;return d|0}function dD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[72892>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=gR(12)|0;l=k;RG(l,h);if((k|0)==0){j=1;i=b;return j|0}RG(f,63208);k=aD(l,f)|0;XG(f);if(k){j=1;i=b;return j|0}RG(g,63216);k=aD(l,g)|0;XG(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=sH(l)|0;Tm(1,1,63224,e);c[d>>2]=63208;c[d+4>>2]=63280;Tm(1,0,63080,d);c[a>>2]=63216;c[a+4>>2]=63296;Tm(1,0,63080,a);Yd[c[4856]&255](1);Vm(0,63184,b)}return 0}function eD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;eJ(f,a);if(!(hJ(f)|0)){fJ(f);i=d;return a|0}j=Dw(b)|0;sD(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((ss(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=RH(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];vD(h,e,b,m,k,l,n);if(!(tD(h)|0)){fJ(f);i=d;return a|0}LH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);fJ(f);i=d;return a|0}function fD(a){a=a|0;var b=0;b=i;kJ(a,SH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;TI(a)|0;i=b;return a|0}function gD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;RG(h,d);GH(k,63304,h);Qv(j,k,63312);XG(k);k=sH(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((AR(c[n+4>>2]|0,63320)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((AR(k,63328)|0)==0){XG(j);XG(h);i=f;return}d=iQ(g,k,1)|0;if((d|0)!=0){m=l;IR(m|0,0,2048)|0;vQ(d,g,m,2048)|0;iJ(eD(eD(eD(eD(eD(85296,63336)|0,k)|0,63376)|0,m)|0,63392)|0,103)|0;XG(j);XG(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(wQ(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(wQ(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(wQ(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(wQ(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==0){q=(wQ(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(wQ(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){d=b+8|0;k=l;l=0;while(1){s=c[d>>2]|0;if((a[s+(l*48|0)+44|0]|0)==0){m=(wQ(g,c[s+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(l*48|0)+44|0]=m;t=c[o>>2]|0}else{t=k}m=l+1|0;if((m|0)<(t|0)){k=t;l=m}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;d=b+24|0;m=0;do{s=c[t>>2]|0;do{if((a[s+(m*52|0)+48|0]|0)==0){p=a[s+(m*52|0)+8|0]|0;if(p<<24>>24==0){n=(wQ(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==1){p=(wQ(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(m*52|0)+48|0]|0)!=0|o){break}a[(c[d>>2]|0)+((c[p+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[l>>2]|0))}l=b+124|0;m=c[l>>2]|0;if((m|0)>0){d=b+12|0;o=m;m=0;while(1){t=c[d>>2]|0;if((a[t+(m*52|0)+48|0]|0)==0){k=(wQ(g,c[t+(m*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(m*52|0)+48|0]=k;u=c[l>>2]|0}else{u=o}k=m+1|0;if((k|0)<(u|0)){o=u;m=k}else{break}}}m=b+220|0;if((c[m>>2]|0)>0){u=b+44|0;o=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{d=c[u>>2]|0;do{if((a[d+(b*52|0)+48|0]|0)==0){k=a[d+(b*52|0)+8|0]|0;if(k<<24>>24==1){t=(wQ(g,c[d+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==0){k=(wQ(g,c[d+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[m>>2]|0))}mQ(g);XG(j);XG(h);i=f;return}function hD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[72756>>2]|0;H=c[72884>>2]|0;I=c[2]|0;if((c[18972>>2]|0)==0){if(!((c[72704>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+xb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;Rm(23,0,63440,l);l=c[72828>>2]|0;do{if((l|0)==0){M=0}else{if((AR(l,63464)|0)==0){M=1;break}if((AR(l,63472)|0)==0){M=0;break}if((AR(l,63480)|0)==0){M=2;break}c[j>>2]=l;Tm(1,0,63488,j);M=0}}while(0);if((mo(M)|0)!=0){c[g>>2]=l;Tm(1,0,63560,g)}if((c[2]|0)!=0){rE(d+56|0);ro((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);no(0);no(6);oo(3);oo(4);oo(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+wR(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Rm(1,0,63648,f)}do{if((c[72812>>2]|0)!=0){f=gR(12)|0;J=f;RG(J,c[72940>>2]|0);if((f|0)==0){break}f=sH(J)|0;c[d+280>>2]=f;c[e>>2]=f;Rm(23,0,63704,e)}}while(0);e=c[72936>>2]|0;LG(m);if((e|0)==0){RG(p,c[d+88>>2]|0);RG(q,63752);iD(o,p,q);Qv(n,o,c[d+284>>2]|0);YG(m,n)|0;XG(n);XG(o);XG(q);XG(p)}else{ZG(m,e)|0}RG(r,63760);RG(s,63760);RG(t,63760);RG(u,63760);RG(v,63760);RG(w,63760);e=c[72704>>2]|0;if((c[72724>>2]|0)!=0){ZG(r,c[72852>>2]|0)|0}if((c[72740>>2]|0)!=0){ZG(s,c[72868>>2]|0)|0}if((c[72720>>2]|0)!=0){ZG(t,c[72848>>2]|0)|0}if((c[72728>>2]|0)==0){O=0.0}else{ZG(u,c[72856>>2]|0)|0;O=+wR(sH(u)|0)}if((c[72732>>2]|0)==0){P=1}else{ZG(v,c[72860>>2]|0)|0;P=Bc(sH(v)|0)|0}if((c[72792>>2]|0)!=0){ZG(w,c[72920>>2]|0)|0}NG(x,m);NG(y,r);NG(z,s);NG(A,t);NG(B,w);p=jD(d,x,y,z,A,O,P,B,e)|0;XG(B);XG(A);XG(z);XG(y);XG(x);if((p|0)!=0|g^1){Q=p}else{no(5);p=ID(d)|0;qo(5);Rm(1,0,63768,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;XG(w);XG(v);XG(u);XG(t);XG(s);XG(r);XG(m);i=b;return R|0}Q=d+88|0;RG(D,c[Q>>2]|0);Qv(C,D,63800);XG(D);RG(F,c[Q>>2]|0);Qv(E,F,63816);XG(F);qo(0);F=c[72904>>2]|0;Q=sH(C)|0;D=sH(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;fE(d,Q,D,(F|0)!=0?F:63832,I,p,sH(m)|0)|0;XG(E);XG(C);R=0;XG(w);XG(v);XG(u);XG(t);XG(s);XG(r);XG(m);i=b;return R|0}function iD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;MG(a,d);e=VG(b)|0;f=VG(c)|0;wH(a,WG(b)|0,e,f+e|0);oH(a,WG(c)|0,f)|0;i=d;return}function jD(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((VG(j)|0)==0){u=0}else{u=sH(j)|0}NG(r,b);b=(kD(a,r,k)|0)==0;XG(r);if(!b){v=-1;i=l;return v|0}RG(s,63760);b=a+280|0;r=cD(s,c[b>>2]|0)|0;XG(s);do{if(r){w=3}else{s=1;k=0;do{RG(t,c[63976+(s<<2)>>2]|0);j=cD(t,c[b>>2]|0)|0;XG(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];Tm(1,0,64056,q);Tm(1,0,63056,p);s=1;do{j=c[64088+(s<<2)>>2]|0;c[o>>2]=c[63976+(s<<2)>>2];c[o+4>>2]=j;Tm(1,0,63080,o);s=s+1|0;}while((s|0)<20);Vm(c[a+536>>2]|0,63184,n)}}while(0);c[m>>2]=c[63976+(w<<2)>>2];Rm(23,0,64168,m);m=sH(d)|0;d=sH(e)|0;e=Hq(a,m,d,sH(f)|0,g,h,w,u)|0;Zd[c[57420>>2]&63](57392,a);v=e;i=l;return v|0}function kD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[14348]=rd(sH(b)|0)|0;c[57396>>2]=g;c[57400>>2]=d;d=a+284|0;do{if((c[15758]|0)==0){g=c[d>>2]|0;if((AR(63840,g)|0)==0){h=0;break}if((AR(63848,g)|0)==0){c[57408>>2]=45;c[57412>>2]=46;c[57420>>2]=47;h=0;break}if((AR(63856,g)|0)==0){c[57408>>2]=48;c[57412>>2]=49;c[57416>>2]=50;c[57420>>2]=51;h=1;break}if((AR(63864,g)|0)==0){c[57408>>2]=52;c[57412>>2]=53;c[57416>>2]=54;c[57420>>2]=55;h=1;break}if((AR(63872,g)|0)==0){c[57408>>2]=56;c[57412>>2]=57;c[57420>>2]=58;h=0;break}g=eD(85296,63880)|0;iJ(eD(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);gD(a+8|0,c[a+288>>2]|0,h);Zd[c[57408>>2]&63](57392,a);a=c[14348]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;Rm(23,0,63904,f);j=0;i=e;return j|0}function lD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;Im();do{if((zE(a,b)|0)==0){if((BE(a,b)|0)!=0){break}do{if((c[72760>>2]|0)!=0){w=c[72888>>2]|0;if((AR(w,64288)|0)==0){Om(1);break}if((AR(w,64296)|0)==0){Om(0);break}else{c[p>>2]=w;Tm(1,0,64304,p);md(0)|0;td(0)}}}while(0);if((c[72716>>2]|0)==0){$C(0,0);Vp(d);if((d|0)==0){iJ(eD(85296,64672)|0,103)|0}c[d+300>>2]=bD(0,0)|0;c[d+292>>2]=dD(0,0)|0;Nv(d+8|0,d+240|0);cq(d)|0;jq(d)|0;sq(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}iJ(eD(85296,64736)|0,103)|0;x=1;i=e;return x|0}}while(0);c[15758]=c[72784>>2];x=0;i=e;return x|0}RG(u,c[72844>>2]|0);w=1;while(1){y=23440+(w<<2)|0;RG(v,c[y>>2]|0);z=aD(u,v)|0;XG(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=sH(u)|0;Tm(1,0,64576,g);c[f>>2]=c[b>>2];Tm(1,0,64616,f);md(0)|0;td(0)}A=c[27464+(w<<2)>>2]|0;do{if((A|0)==1){z=c[27336+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;Rm(1,1,64376,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[27336+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;Rm(1,1,64416,n);break}else{c[m>>2]=z;Tm(1,1,64256,m);break}}}while(0);if((w|0)==19){A=c[4290]|0;if((A|0)<28){D=A}else{E=19424;F=c[4856]|0;Yd[F&255](1);G=md(0)|0;td(0)}do{A=c[18744+(D<<2)>>2]|0;c[l>>2]=c[17576+(D<<2)>>2];c[l+4>>2]=A;Rm(1,0,63080,l);D=D+1|0;}while((D|0)<28);E=19424;F=c[4856]|0;Yd[F&255](1);G=md(0)|0;td(0)}else if((w|0)==7){A=1;do{z=c[64496+(A<<2)>>2]|0;c[k>>2]=c[64480+(A<<2)>>2];c[k+4>>2]=z;Rm(1,0,63080,k);A=A+1|0;}while((A|0)<4);E=19424;F=c[4856]|0;Yd[F&255](1);G=md(0)|0;td(0)}else if((w|0)==29){A=1;do{z=c[64088+(A<<2)>>2]|0;c[h>>2]=c[63976+(A<<2)>>2];c[h+4>>2]=z;Rm(1,0,63080,h);A=A+1|0;}while((A|0)<20);E=19424;F=c[4856]|0;Yd[F&255](1);G=md(0)|0;td(0)}else if((w|0)==11){A=1;do{z=c[64544+(A<<2)>>2]|0;c[j>>2]=c[64512+(A<<2)>>2];c[j+4>>2]=z;Rm(1,0,63080,j);A=A+1|0;}while((A|0)<7);E=19424;F=c[4856]|0;Yd[F&255](1);G=md(0)|0;td(0)}else{E=19424;F=c[4856]|0;Yd[F&255](1);G=md(0)|0;td(0)}}}while(0);c[t>>2]=c[b>>2];Rm(1,1,64192,t);t=1;do{b=c[27464+(t<<2)>>2]|0;do{if((b|0)==1){G=c[25344+(t<<2)>>2]|0;c[s>>2]=c[23440+(t<<2)>>2];c[s+4>>2]=G;Rm(1,0,64208,s)}else{G=c[23440+(t<<2)>>2]|0;if((b|0)==2){F=c[25344+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;Rm(1,0,64224,r);break}else{c[q>>2]=G;Tm(1,0,64256,q);break}}}while(0);t=t+1|0;}while((t|0)<31);Yd[c[4856]&255](1);md(0)|0;td(0);return 0}function mD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[16192]|0;qb(66416)|0;c[l>>2]=c[m+88>>2];dc(64776,l|0)|0;qb(66432)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];dc(64800,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];dc(64840,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];dc(64872,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];dc(64904,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];dc(64936,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];dc(64968,b|0)|0;qb(66456)|0;i=a;return}function nD(a,b){a=a|0;b=+b;i=i;return}function oD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;DR(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=RR(c[g>>2]|0,f)|0;if((k|0)==0){bb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=xa(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=RR(c[g>>2]|0,f)|0;if((m|0)==0){bb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[16192]=d;u=0;Fa(54,10,167)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=RR(c[k>>2]|0,f)|0;if((p|0)==0){bb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=xa(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=RR(c[g>>2]|0,f)|0;if((q|0)==0){bb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=RR(c[g>>2]|0,f)|0;if((r|0)==0){bb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=RR(c[g>>2]|0,f)|0;if((s|0)==0){bb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=RR(c[g>>2]|0,f)|0;if((t|0)==0){bb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=RR(c[g>>2]|0,f)|0;if((w|0)==0){bb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(168,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=RR(c[g>>2]|0,f)|0;if((x|0)==0){bb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=RR(c[g>>2]|0,f)|0;if((y|0)==0){bb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=RR(c[k>>2]|0,f)|0;if((A|0)==0){bb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function pD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=ed(c[4168]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 3:{if((c[18940>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;nc(65104,7,1,a|0)|0;zc(a|0,d|0,f|0)|0;Jd(10,a|0)|0;md(0)|0;i=b;return};case 1:{c[f>>2]=e;a=c[r>>2]|0;nc(65104,7,1,a|0)|0;zc(a|0,d|0,f|0)|0;Jd(10,a|0)|0;md(0)|0;bb(c[g+80>>2]|0,1);break};case 2:{if((c[18884>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;bb(n|0,1)}c[f>>2]=e;e=c[r>>2]|0;nc(65104,7,1,e|0)|0;zc(e|0,d|0,f|0)|0;Jd(10,e|0)|0;md(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;bb(n|0,1);break};case 5:case 4:{i=b;return};default:{Vm(g,65112,b)}}}function qD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;nc(65088,9,1,d|0)|0;zc(d|0,b|0,e|0)|0;Jd(10,d|0)|0;md(0)|0;i=a;return}function rD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;yD(65032,b);c[15750]=63760;b=63004|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[63020>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;bb(k|0,1)}d=ed(c[4168]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;bb(k|0,1)}function sD(a,b){a=a|0;b=b|0;var c=0;c=i;uD(a,b);i=c;return}function tD(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function uD(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=QH(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function vD(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;os(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=wD(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((aI(b,d,r)|0)==(r|0)){break}os(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){SG(l,s,h);if((aI(b,WG(l)|0,s)|0)==(s|0)){XG(l);break}os(m);c[o>>2]=0;c[a>>2]=0;XG(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((aI(b,e,l)|0)==(l|0)){break}os(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);xD(g,0)|0;c[a>>2]=b;i=j;return}function wD(a){a=a|0;i=i;return c[a+12>>2]|0}function xD(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function yD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[15756]|0;if((g|0)==0){c[e>>2]=(ER(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(Ew(e,f)|0)>>2]|0;c[16270]=h;f=aR(h)|0;c[15756]=f;j=h;k=f}else{j=c[16270]|0;k=g}g=jc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[16270]|0)>>>0){i=d;return}bR(c[15756]|0);j=g<<1|1;c[16270]=j;g=aR(j)|0;c[15756]=g;jc(g|0,j|0,a|0,b|0)|0;i=d;return}function zD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;AD(g,16);BD(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){CD(a,g);DD(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){eD(jJ(m,+h[b+(p<<3)>>3])|0,66472)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){jJ(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){eD(m,66480)|0}}while((e|0)<(d|0));CD(a,g);DD(g);i=f;return}function AD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;UH(e);f=a;c[f>>2]=66852;g=e;c[g>>2]=66872;e=a+4|0;$I(a,66884|0,e);c[f>>2]=66852;c[g>>2]=66872;PD(e,b|16);i=d;return}function BD(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function CD(a,b){a=a|0;b=b|0;var c=0;c=i;JD(a,b+4|0);i=c;return}function DD(a){a=a|0;var b=0;b=i;TD(a,66880);PH(a+56|0);i=b;return}function ED(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[18928>>2]|0)!=0){qb(67176)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(14,0,66488,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(14,0,66560,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[18928>>2]|0)==0){i=d;return 0}Rm(14,0,66608,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];dc(66624,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ac(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function FD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[18928>>2]|0)!=0){qb(67176)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(14,0,66488,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(14,0,66560,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[18928>>2]|0)==0){i=d;return 0}Rm(14,0,66608,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];dc(66624,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ac(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function GD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[18928>>2]|0)!=0){qb(67176)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(14,0,66488,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(14,0,66560,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[18928>>2]|0)==0){i=d;return 0}Rm(14,0,66608,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];dc(66624,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ac(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function HD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[18928>>2]|0)!=0){qb(67176)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Rm(14,0,66488,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Rm(14,0,66560,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[18928>>2]|0)==0){i=d;return 0}Rm(14,0,66608,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];dc(66624,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ac(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function ID(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=cR(fa(F,F)|0,8)|0;J=I;K=cR(fa(G,F)|0,8)|0;L=K;M=cR(fa(H,F)|0,8)|0;N=M;O=cR(fa(H,G)|0,8)|0;P=O;LG(p);LG(q);LG(r);LG(s);LG(t);LG(u);LG(v);Q=a+536|0;Um(c[Q>>2]|0,(I|0)!=0|0,66632,o);Um(c[Q>>2]|0,(K|0)!=0|0,66632,n);Um(c[Q>>2]|0,(M|0)!=0|0,66632,m);Um(c[Q>>2]|0,(O|0)!=0|0,66632,l);l=a+540|0;m=a;if(($d[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;ED(a,J)|0;Um(n,1,66648,k)}zD(w,J,F,F);YG(p,w)|0;XG(w);if(($d[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;FD(a,L)|0;Um(w,1,66680,j)}zD(x,L,F,G);YG(q,x)|0;XG(x);if(($d[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;GD(a,N)|0;Um(x,1,66712,h)}zD(y,N,H,F);YG(r,y)|0;XG(y);if(($d[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;HD(a,P)|0;Um(m,1,66744,g)}zD(z,P,H,G);YG(s,z)|0;XG(z);if((F|0)==0){ZG(t,66776)|0}else{zD(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);YG(t,A)|0;XG(A)}if((G|0)==0){ZG(u,66776)|0}else{zD(B,c[a+432>>2]|0,1,G);YG(u,B)|0;XG(B)}bR(I);bR(K);bR(M);bR(O);RG(E,c[a+84>>2]|0);GH(D,66792,E);Qv(C,D,66800);YG(v,C)|0;XG(C);XG(D);XG(E);E=fc(sH(v)|0,66808)|0;D=c[Q>>2]|0;c[f>>2]=sH(v)|0;Um(D,(E|0)!=0|0,66816,f);f=qe[c[(c[l>>2]|0)+176>>2]&7]()|0;D=sH(t)|0;Q=sH(u)|0;C=sH(p)|0;a=sH(q)|0;O=sH(r)|0;M=sH(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;od(E|0,f|0,e|0)|0;if((c[18972>>2]|0)==0){R=md(E|0)|0;S=Tc(E|0)|0;XG(v);XG(u);XG(t);XG(s);XG(r);XG(q);XG(p);i=b;return 0}e=qe[c[(c[l>>2]|0)+176>>2]&7]()|0;l=sH(t)|0;f=sH(u)|0;M=sH(p)|0;O=sH(q)|0;a=sH(r)|0;C=sH(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;Rm(25,0,e,d);R=md(E|0)|0;S=Tc(E|0)|0;XG(v);XG(u);XG(t);XG(s);XG(r);XG(q);XG(p);i=b;return 0}function JD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=iI(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}KD(a,hI(l)|0,n,e);i=d;return}if((h&8|0)==0){MG(a,g);i=d;return}else{g=b;b=cI(g)|0;KD(a,b,eI(g)|0,f);i=d;return}}function KD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;LD(a,b,c,0);i=d;return}function LD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;MD(a,b,c);i=d;return}function MD(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=ND(c,d)|0;if(g>>>0>4294967279){JG(0)}if(g>>>0<11){bH(b,g);h=aH(b)|0}else{j=iH(g)|0;k=j+1|0;j=Aw(QG(b)|0,k)|0;kH(b,j);jH(b,k);$G(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;Bw(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){Bw(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;Bw(l,f);i=e;return}function ND(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=OD(b,c,e)|0;i=d;return g|0}function OD(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function PD(a,b){a=a|0;b=b|0;var c=0;c=i;dE(a,b);i=c;return}function QD(a){a=a|0;var b=0;b=i;DD(a);iR(a);i=b;return}function RD(a){a=a|0;var b=0;b=i;DD(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function SD(a){a=a|0;var b=0;b=i;QD(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function TD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];UD(a+4|0);i=d;return}function UD(a){a=a|0;var b=0;b=i;VD(a);i=b;return}function VD(a){a=a|0;var b=0;b=i;c[a>>2]=67032;XG(a+32|0);YH(a);i=b;return}function WD(a){a=a|0;var b=0;b=i;UD(a);iR(a);i=b;return}function XD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=iI(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}Cr(a,-1,-1);i=h;return}else if((k|0)==0){Cr(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=iI(l)|0;j=m-(hI(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=dI(l)|0;m=j-(cI(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(WG(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){Cr(a,-1,-1);i=h;return}o=OR(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(WG(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((dI(l)|0)!=0){break}Cr(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((iI(l)|0)!=0){break}Cr(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=cI(l)|0;gI(l,q,q+o|0,n)}if((g&16|0)!=0){q=hI(l)|0;lI(l,q,jI(l)|0);kI(l,o)}Cr(a,o,e);i=h;return}}while(0);Cr(a,-1,-1);i=h;return}function YD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=Qs(d)|0;he[g&31](a,b,h,J,0,e);i=f;return}function ZD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=iI(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((eI(g)|0)>>>0<j>>>0){b=cI(g)|0;gI(g,b,dI(g)|0,j)}j=dI(g)|0;if(!(j>>>0<(eI(g)|0)>>>0)){k=-1;i=d;return k|0}k=mt(a[j]|0)|0;i=d;return k|0}function _D(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=iI(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=cI(h)|0;j=dI(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(it(d,-1)|0){gI(h,g,j+ -1|0,k);l=lt(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=jt(d)|0;do{if(g){if(nt(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=cI(h)|0;gI(h,j,(dI(h)|0)+ -1|0,k);a[dI(h)|0]=b;l=d;i=e;return l|0}function $D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(it(b,-1)|0){f=lt(b)|0;i=d;return f|0}g=a;h=dI(g)|0;j=h-(cI(g)|0)|0;h=iI(g)|0;do{if((h|0)==(jI(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=hI(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;nH(o,0);gH(o,dH(o)|0);p=WG(o)|0;lI(g,p,p+(VG(o)|0)|0);kI(g,h-l|0);c[m>>2]=(hI(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(iI(g)|0)+1;h=c[(aE(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=WG(a+32|0)|0;gI(g,q,q+j|0,h)}f=$H(g,b&255)|0;i=d;return f|0}function aE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=bE(b,c,e)|0;i=d;return g|0}function bE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=cE(0,a,b)|0;i=c;return(d?b:a)|0}function cE(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function dE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;bI(a);c[a>>2]=67032;LG(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;LG(e);eE(a,e);XG(e);i=d;return}function eE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;YG(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=WG(e)|0;j=g+(VG(e)|0)|0;c[b>>2]=j;g=WG(e)|0;gI(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=VG(e)|0;c[b>>2]=(WG(e)|0)+h;gH(e,dH(e)|0);b=a;a=WG(e)|0;lI(b,a,a+(VG(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}kI(b,h);i=d;return}function fE(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=fc(d|0,67456)|0;J=Xc(67464,67456)|0;K=(J|0)!=0;L=Jc()|0;if(K){M=c[b+536>>2]|0;N=Nd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Um(M,(I|0)!=0|0,67520,E);nc(67544,17,1,J|0)|0;nc(67568,10,1,J|0)|0;nc(67584,18,1,J|0)|0;gE(J,f,67608,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,67640)}else{c[G>>2]=Nd(c[L>>2]|0)|0;Tm(26,0,67472,G);G=c[b+536>>2]|0;E=Nd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Um(G,(I|0)!=0|0,67520,F)}nc(67648,348,1,I|0)|0;if((oc(H|0)|0)<0){c[D>>2]=Nd(c[L>>2]|0)|0;Tm(26,0,68e3,D);Tc(I|0)|0;Za(J|0)|0;O=1;i=j;return O|0}if((Oc(67200,250,68024,dd(H|0)|0)|0)==0){Tm(26,0,68048,C);Tc(I|0)|0;O=1;i=j;return O|0}nc(68072,13,1,I|0)|0;nc(68088,12,1,I|0)|0;hE(I,2);nc(68104,6,1,I|0)|0;iE(I,c[b+84>>2]|0);nc(68112,8,1,I|0)|0;hE(I,2);nc(68128,8,1,I|0)|0;C=b+88|0;iE(I,c[C>>2]|0);nc(68144,10,1,I|0)|0;hE(I,2);nc(68160,6,1,I|0)|0;iE(I,67200);nc(68168,8,1,I|0)|0;hE(I,2);nc(68184,8,1,I|0)|0;iE(I,c[b+280>>2]|0);nc(68200,10,1,I|0)|0;hE(I,2);nc(68216,14,1,I|0)|0;iE(I,c[b+284>>2]|0);nc(68232,16,1,I|0)|0;hE(I,2);nc(68256,16,1,I|0)|0;iE(I,l);nc(68280,18,1,I|0)|0;hE(I,2);c[B>>2]=jE(l)|0;od(I|0,68304,B|0)|0;hE(I,2);P=+io(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(I|0,68344,A|0)|0;hE(I,2);P=+io(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];od(I|0,68384,z|0)|0;hE(I,2);P=+io(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];od(I|0,68416,y|0)|0;hE(I,2);P=+io(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(I|0,68448,x|0)|0;hE(I,2);P=+io(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];od(I|0,68480,w|0)|0;hE(I,2);P=+io(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];od(I|0,68512,v|0)|0;hE(I,2);P=+io(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];od(I|0,68552,u|0)|0;hE(I,2);P=+lo(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];od(I|0,68584,t|0)|0;hE(I,2);c[s>>2]=go(2)|0;od(I|0,68624,s|0)|0;hE(I,2);P=+ko(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];od(I|0,68648,r|0)|0;nc(68680,13,1,I|0)|0;nc(68696,16,1,I|0)|0;hE(I,2);P=+io(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];od(I|0,68720,q|0)|0;hE(I,2);c[p>>2]=co(8)|0;od(I|0,68744,p|0)|0;nc(68784,17,1,I|0)|0;nc(68808,22,1,I|0)|0;kE(I,b);nc(68832,23,1,I|0)|0;nc(68856,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{lE(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{lE(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{lE(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{lE(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{lE(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{lE(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{lE(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{lE(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}nc(68872,13,1,I|0)|0;nc(68888,12,1,I|0)|0;mE(I,J,f,c[C>>2]|0,b);nc(68904,13,1,I|0)|0;nc(68920,12,1,I|0)|0;nE(I,c[b+68>>2]|0,b+56|0);nc(68936,13,1,I|0)|0;nc(68952,16,1,I|0)|0;oE(I,J,f,b);nc(68976,17,1,I|0)|0;nc(69e3,14,1,I|0)|0;Tc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((ER(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(ER(K|0)|0)<<1}else{Q=0}I=aR(b+Q|0)|0;if((I|0)==0){$a(69016,69024,404,69048)}if((Za(J|0)|0)!=0){Tm(26,0,69064,o)}if(e){e=c[C>>2]|0;c[n>>2]=69096;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;ec(I|0,69112,n|0)|0;if((jd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=69192|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;Tm(1,0,69224,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;Rm(1,0,69288,g);bR(I);O=0;i=j;return O|0}function gE(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=eo(F)|0;H=fo(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+ko(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}nc(67544,17,1,a|0)|0;nc(70456,12,1,a|0)|0;nc(70472,12,1,a|0)|0;nc(70488,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;od(a|0,70504,D|0)|0;nc(70544,10,1,a|0)|0;nc(70560,11,1,a|0)|0;nc(70576,11,1,a|0)|0;nc(70592,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];od(a|0,70608,C|0)|0}else{nc(70632,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;od(a|0,70232,B|0)|0;nc(70656,13,1,a|0)|0;if(E){nc(70472,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(a|0,70672,A|0)|0}else{nc(70632,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;od(a|0,70696,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;od(a|0,70352,y|0)|0;nc(70744,10,1,a|0)|0;nc(70760,10,1,a|0)|0;nc(70744,10,1,a|0)|0;nc(70776,11,1,a|0)|0;c[x>>2]=b;od(a|0,70792,x|0)|0;c[w>>2]=d;od(a|0,70816,w|0)|0;nc(70832,33,1,a|0)|0;nc(70872,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;od(a|0,70912,v|0)|0;nc(70592,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];od(a|0,70608,u|0)|0}else{nc(70760,10,1,a|0)|0;nc(70744,10,1,a|0)|0;nc(70776,11,1,a|0)|0;c[t>>2]=b;od(a|0,70792,t|0)|0;c[s>>2]=d;od(a|0,70816,s|0)|0;nc(70832,33,1,a|0)|0;nc(70872,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;od(a|0,70912,r|0)|0;nc(70592,10,1,a|0)|0;nc(70632,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;od(a|0,70232,q|0)|0;nc(70656,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];od(a|0,70672,p|0)|0}else{nc(70632,17,1,a|0)|0}nc(70944,32,1,a|0)|0;nc(70984,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;od(a|0,71016,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;od(a|0,70352,n|0)|0;i=m;return}function hE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Jd(32,a|0)|0;}while((d|0)!=0);i=c;return}function iE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){nc(70208,4,1,b|0)|0}else if((e|0)==60){nc(70200,4,1,b|0)|0}else if((e|0)==39){nc(70216,6,1,b|0)|0}else if((e|0)==34){nc(70224,6,1,b|0)|0}else{Jd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function jE(a){a=a|0;var b=0,c=0,d=0;b=i;c=fc(a|0,70192)|0;if((c|0)==0){d=-1;i=b;return d|0}Rc(c|0,0,2)|0;a=vb(c|0)|0;Tc(c|0)|0;d=a;i=b;return d|0}function kE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=aR((ER(l|0)|0)+15|0)|0;c[f>>2]=l;ec(m|0,69920,f|0)|0;hE(a,2);nc(69936,10,1,a|0)|0;iE(a,m);nc(69952,12,1,a|0)|0;hE(a,2);c[e>>2]=jE(m)|0;od(a|0,69968,e|0)|0;bR(m);hE(a,2);nc(7e4,9,1,a|0)|0;hE(a,4);nc(70016,22,1,a|0)|0;hE(a,4);nc(70040,22,1,a|0)|0;hE(a,4);nc(70064,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){qE(g,m,n);o=c[l>>2]|0;hE(a,4);nc(70096,8,1,a|0)|0;iE(a,o);nc(70112,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{vE(h,m,l);g=c[n>>2]|0;hE(a,4);nc(70096,8,1,a|0)|0;iE(a,g);nc(70112,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{qE(j,m,q);b=c[t>>2]|0;hE(a,4);nc(70136,8,1,a|0)|0;iE(a,b);nc(70152,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){hE(a,2);v=70176;w=v;x=nc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{vE(k,m,s);e=c[u>>2]|0;hE(a,4);nc(70136,8,1,a|0)|0;iE(a,e);nc(70152,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));hE(a,2);v=70176;w=v;x=nc(w|0,10,1,a|0)|0;i=d;return}function lE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;hE(a,2);c[f>>2]=c[b>>2];od(a|0,69856,f|0)|0;iE(a,c[b+4>>2]|0);nc(69888,11,1,a|0)|0;iE(a,c[b+8>>2]|0);nc(69560,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];pE(a,4,e);hE(a,2);nc(69904,12,1,a|0)|0;i=d;return}function mE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{qE(p,r,v);gE(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,69672);w=v+9|0;oo(w);hE(a,2);c[o>>2]=c[f>>2];od(a|0,69680,o|0)|0;hE(a,4);nc(68104,6,1,a|0)|0;iE(a,c[s>>2]|0);nc(68112,8,1,a|0)|0;hE(a,4);c[n>>2]=go(w)|0;od(a|0,69456,n|0)|0;hE(a,4);x=+lo(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(a|0,69480,m|0)|0;hE(a,4);x=+ko(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];od(a|0,68648,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];pE(a,6,j);hE(a,2);nc(69704,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function nE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{hE(a,2);uE(l,d,x);c[j>>2]=c[q>>2];od(a|0,69528,j|0)|0;uE(m,d,x);iE(a,c[r>>2]|0);nc(69560,3,1,a|0)|0;hE(a,4);nc(69568,7,1,a|0)|0;uE(n,d,x);if((c[s>>2]|0)>0){y=0;do{hE(a,6);c[g>>2]=0;od(a|0,69576,g|0)|0;y=y+1|0;uE(n,d,x);}while((y|0)<(c[s>>2]|0))}hE(a,4);nc(69600,8,1,a|0)|0;hE(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;uE(o,d,x);z=+io(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;uE(p,d,x);A=co(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;od(a|0,69616,f|0)|0;hE(a,2);nc(69656,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function oE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{vE(n,o,v-u|0);gE(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,69408);q=v+9|0;oo(q);hE(a,2);nc(69416,15,1,a|0)|0;hE(a,4);c[m>>2]=c[e>>2];od(a|0,69432,m|0)|0;hE(a,4);c[l>>2]=go(q)|0;od(a|0,69456,l|0)|0;hE(a,4);w=+lo(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];od(a|0,69480,j|0)|0;hE(a,4);w=+ko(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];od(a|0,68648,g|0)|0;hE(a,2);nc(69504,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function pE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;hE(a,b);nc(69720,16,1,a|0)|0;iE(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?69824:69840;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;od(a|0,69744,f|0)|0;i=e;return}function qE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){rE(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function rE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=fc(c[o>>2]|0,71056)|0;if((p|0)!=0){q=p;break}p=Nd(c[(Jc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Vm(0,71064,g)}else{q=0}}while(0);g=Lh(0)|0;if((g|0)==0){Vm(0,71096,f)}f=a+8|0;c[a+20>>2]=cR(c[f>>2]|0,32)|0;p=a+12|0;o=cR((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=71128;c[o+12>>2]=0;c[o+16>>2]=0;Wh(g,h);Xh(g,10,59);h=c[n>>2]|0;do{if((h|0)==0){o=j;IR(o|0,0,1024)|0;while(1){r=pb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Yh(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=ei(bi(g)|0)|0;s=ci(g)|0;Tc(q|0)|0;Sh(g);r=c[a>>2]|0;c[e>>2]=71232;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Vm(0,71168,e)}else if((t|0)==11){Tc(q|0)|0;break}}else{if((Yh(g,h,ER(h|0)|0,1)|0)!=0){break}s=ei(bi(g)|0)|0;o=ci(g)|0;Sh(g);r=c[n>>2]|0;c[d>>2]=71232;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Vm(0,71272,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){$a(71336,71232,295,71376)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{$a(71400,71232,297,71376)}}function sE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((AR(71808,b)|0)==0){if((AR(c[d>>2]|0,71816)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Um(0,p,71824,l);l=c[17916]|0;p=c[17970]|0;do{if((l|0)==0|(p|0)==0){c[17970]=32;a=aR(1152)|0;c[17916]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[17970]=p<<1;a=dR(l,p*72|0)|0;c[17916]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(yE(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((AR(71888,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((AR(71896,u)|0)==0){c[17976]=rd(c[t+4>>2]|0)|0}else{if((AR(71928,u)|0)==0){c[71908>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((AR(71944,u)|0)==0){c[71916>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((AR(71952,u)|0)==0){c[71912>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((AR(71968,u)|0)==0){c[71920>>2]=Rb(c[t+4>>2]|0,0,10)|0;break}if((AR(71976,u)|0)!=0){v=23;break a}c[71924>>2]=(AR(c[t+4>>2]|0,71992)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Vm(0,72e3,k)}else if((v|0)==45){i=e;return}}if((AR(71648,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=71232;c[j+4>>2]=k;c[j+8>>2]=v;Vm(0,72032,j)}if((AR(72096,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=71232;c[h+4>>2]=j;Vm(0,72104,h)}h=Rb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=71232;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Vm(0,72160,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=72224;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((AR(71592,b)|0)!=0){if((AR(71784,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=72328;m=rd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=72336;i=e;return}c[71612>>2]=0;c[71616>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((AR(m,71816)|0)==0){c[71612>>2]=rd(c[b+4>>2]|0)|0}else{if((AR(m,72280)|0)!=0){break}c[71616>>2]=rd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[71612>>2]|0)==0){w=0;break}w=(c[71616>>2]|0)!=0|0}}while(0);Um(0,w,72288,f);c[17902]=-1;f=71620|0;w=71904;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function tE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((AR(71592,b)|0)==0){o=e+0|0;p=71608|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));xE(e);i=d;return}if((AR(71648,b)|0)==0){e=h+24|0;r=aR((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=aR(36)|0;t=s;o=s+0|0;p=(c[17916]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((AR(71672,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;sd(e+(k*20|0)+8|0,71680,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((AR(71720,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;sd(h+(k*20|0)+8|0,71736,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((AR(71784,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function uE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){rE(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function vE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){rE(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Vm(0,71440,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=71520;p=o;Vm(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=71520;p=o;Vm(0,p,f)}}function wE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){bR(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){bR(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}bR(k);c[d>>2]=0;i=b;return}



function Bg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,xe=0,ye=0,ze=0,Ae=0,Be=0.0,Ce=0.0,De=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0.0,Ne=0.0,Oe=0.0,Pe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;xe=i;i=i+16|0;c[ve>>2]=45;On(xe,1,ve);if(!(d>611.657)){ve=zn(zn(4288,xn(d,0,1,6)|0)|0,3608)|0;ye=zn(zn(ve,xn(611.657,0,1,6)|0)|0,3616)|0;ve=c[16252]|0;ze=k;Ae=4352;c[ze+0>>2]=c[Ae+0>>2];c[ze+4>>2]=c[Ae+4>>2];c[ze+8>>2]=c[Ae+8>>2];c[ze+12>>2]=c[Ae+12>>2];c[ze+16>>2]=c[Ae+16>>2];c[ze+20>>2]=c[Ae+20>>2];we[ve&31](b,k,ye,ue);}if(!(d<=1.0e8)){ue=zn(zn(4376,xn(d,0,1,6)|0)|0,4e3)|0;ye=c[16252]|0;k=j;ve=4424;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];we[ye&31](b,j,ue,te);}if(!(e>=273.15)){te=zn(zn(4448,xn(e,0,1,6)|0)|0,4104)|0;ue=c[16252]|0;j=g;ye=4496;c[j+0>>2]=c[ye+0>>2];c[j+4>>2]=c[ye+4>>2];c[j+8>>2]=c[ye+8>>2];c[j+12>>2]=c[ye+12>>2];c[j+16>>2]=c[ye+16>>2];c[j+20>>2]=c[ye+20>>2];we[ue&31](b,g,te,se);}Be=d/1653.0e4;Ce=1386.0/e;De=7.1-Be;Ee=Ce+-1.222;c[re>>2]=1;h[(Un(xe,1,re)|0)>>3]=Ee*Ee;c[qe>>2]=1;Fe=+h[(Un(xe,1,qe)|0)>>3];c[pe>>2]=2;h[(Un(xe,1,pe)|0)>>3]=Fe*Fe;c[oe>>2]=2;Fe=+h[(Un(xe,1,oe)|0)>>3];c[ne>>2]=3;h[(Un(xe,1,ne)|0)>>3]=Fe*Fe;c[me>>2]=3;Fe=Ee*+h[(Un(xe,1,me)|0)>>3];c[le>>2]=4;h[(Un(xe,1,le)|0)>>3]=Fe;c[ke>>2]=4;Fe=1.0/+h[(Un(xe,1,ke)|0)>>3];c[je>>2]=5;h[(Un(xe,1,je)|0)>>3]=Fe;c[ie>>2]=1;Fe=+h[(Un(xe,1,ie)|0)>>3];c[he>>2]=2;Ge=Fe*+h[(Un(xe,1,he)|0)>>3];c[ge>>2]=6;h[(Un(xe,1,ge)|0)>>3]=Ge;c[fe>>2]=1;Ge=Ee*+h[(Un(xe,1,fe)|0)>>3];c[ee>>2]=7;h[(Un(xe,1,ee)|0)>>3]=Ge;c[de>>2]=7;Ge=1.0/+h[(Un(xe,1,de)|0)>>3];c[ce>>2]=8;h[(Un(xe,1,ce)|0)>>3]=Ge;c[be>>2]=1;Ge=+h[(Un(xe,1,be)|0)>>3];c[ae>>2]=2;Fe=+h[(Un(xe,1,ae)|0)>>3];c[$d>>2]=3;He=Ge*Fe*+h[(Un(xe,1,$d)|0)>>3];c[_d>>2]=9;h[(Un(xe,1,_d)|0)>>3]=He;c[Zd>>2]=2;He=1.0/+h[(Un(xe,1,Zd)|0)>>3];c[Yd>>2]=10;h[(Un(xe,1,Yd)|0)>>3]=He;c[Xd>>2]=2;He=Ee*+h[(Un(xe,1,Xd)|0)>>3];c[Wd>>2]=11;h[(Un(xe,1,Wd)|0)>>3]=He;c[Vd>>2]=11;He=1.0/+h[(Un(xe,1,Vd)|0)>>3];c[Ud>>2]=12;h[(Un(xe,1,Ud)|0)>>3]=He;c[Td>>2]=2;He=+h[(Un(xe,1,Td)|0)>>3];c[Sd>>2]=3;Fe=He*+h[(Un(xe,1,Sd)|0)>>3];c[Rd>>2]=13;h[(Un(xe,1,Rd)|0)>>3]=Fe;c[Qd>>2]=3;Fe=1.0/+h[(Un(xe,1,Qd)|0)>>3];c[Pd>>2]=14;h[(Un(xe,1,Pd)|0)>>3]=Fe;c[Od>>2]=15;h[(Un(xe,1,Od)|0)>>3]=De*De;c[Nd>>2]=15;Fe=De*+h[(Un(xe,1,Nd)|0)>>3];c[Md>>2]=16;h[(Un(xe,1,Md)|0)>>3]=Fe;c[Ld>>2]=15;Fe=+h[(Un(xe,1,Ld)|0)>>3];c[Kd>>2]=17;h[(Un(xe,1,Kd)|0)>>3]=Fe*Fe;c[Jd>>2]=17;Fe=+h[(Un(xe,1,Jd)|0)>>3];c[Id>>2]=18;h[(Un(xe,1,Id)|0)>>3]=Fe*Fe;c[Hd>>2]=17;Fe=+h[(Un(xe,1,Hd)|0)>>3];c[Gd>>2]=18;He=Fe*De*+h[(Un(xe,1,Gd)|0)>>3];c[Fd>>2]=19;h[(Un(xe,1,Fd)|0)>>3]=He;c[Ed>>2]=15;He=+h[(Un(xe,1,Ed)|0)>>3];c[Dd>>2]=17;Fe=He*+h[(Un(xe,1,Dd)|0)>>3];c[Cd>>2]=20;h[(Un(xe,1,Cd)|0)>>3]=Fe;c[Bd>>2]=3;Fe=+h[(Un(xe,1,Bd)|0)>>3];c[Ad>>2]=21;h[(Un(xe,1,Ad)|0)>>3]=Fe*Fe;c[zd>>2]=21;Fe=+h[(Un(xe,1,zd)|0)>>3];c[yd>>2]=22;h[(Un(xe,1,yd)|0)>>3]=Fe*Fe;c[xd>>2]=22;Fe=+h[(Un(xe,1,xd)|0)>>3];c[wd>>2]=3;He=Fe*Ee*+h[(Un(xe,1,wd)|0)>>3];c[vd>>2]=23;h[(Un(xe,1,vd)|0)>>3]=He;c[ud>>2]=23;He=1.0/+h[(Un(xe,1,ud)|0)>>3];c[td>>2]=24;h[(Un(xe,1,td)|0)>>3]=He;c[sd>>2]=22;He=+h[(Un(xe,1,sd)|0)>>3];c[rd>>2]=3;Fe=He*+h[(Un(xe,1,rd)|0)>>3];c[qd>>2]=25;h[(Un(xe,1,qd)|0)>>3]=Fe;c[pd>>2]=25;Fe=1.0/+h[(Un(xe,1,pd)|0)>>3];c[od>>2]=26;h[(Un(xe,1,od)|0)>>3]=Fe;c[nd>>2]=1;Fe=+h[(Un(xe,1,nd)|0)>>3];c[md>>2]=2;He=+h[(Un(xe,1,md)|0)>>3];c[ld>>2]=22;Ge=Fe*He*Ee*+h[(Un(xe,1,ld)|0)>>3];c[kd>>2]=27;h[(Un(xe,1,kd)|0)>>3]=Ge;c[jd>>2]=27;Ge=1.0/+h[(Un(xe,1,jd)|0)>>3];c[id>>2]=28;h[(Un(xe,1,id)|0)>>3]=Ge;c[hd>>2]=1;Ge=+h[(Un(xe,1,hd)|0)>>3];c[gd>>2]=2;He=+h[(Un(xe,1,gd)|0)>>3];c[fd>>2]=22;Fe=Ge*He*+h[(Un(xe,1,fd)|0)>>3];c[ed>>2]=29;h[(Un(xe,1,ed)|0)>>3]=Fe;c[dd>>2]=29;Fe=1.0/+h[(Un(xe,1,dd)|0)>>3];c[cd>>2]=30;h[(Un(xe,1,cd)|0)>>3]=Fe;c[bd>>2]=1;Fe=+h[(Un(xe,1,bd)|0)>>3];c[ad>>2]=2;He=+h[(Un(xe,1,ad)|0)>>3];c[$c>>2]=21;Ge=+h[(Un(xe,1,$c)|0)>>3];c[_c>>2]=3;Ie=Fe*He*Ge*Ee*+h[(Un(xe,1,_c)|0)>>3];c[Zc>>2]=31;h[(Un(xe,1,Zc)|0)>>3]=Ie;c[Yc>>2]=31;Ie=1.0/+h[(Un(xe,1,Yc)|0)>>3];c[Xc>>2]=32;h[(Un(xe,1,Xc)|0)>>3]=Ie;c[Wc>>2]=2;Ie=+h[(Un(xe,1,Wc)|0)>>3];c[Vc>>2]=21;Ge=+h[(Un(xe,1,Vc)|0)>>3];c[Uc>>2]=3;He=Ie*Ge*Ee*+h[(Un(xe,1,Uc)|0)>>3];c[Tc>>2]=33;h[(Un(xe,1,Tc)|0)>>3]=He;c[Sc>>2]=33;He=1.0/+h[(Un(xe,1,Sc)|0)>>3];c[Rc>>2]=34;h[(Un(xe,1,Rc)|0)>>3]=He;c[Qc>>2]=1;He=+h[(Un(xe,1,Qc)|0)>>3];c[Pc>>2]=3;Ge=He*Ee*+h[(Un(xe,1,Pc)|0)>>3];c[Oc>>2]=35;h[(Un(xe,1,Oc)|0)>>3]=Ge;c[Nc>>2]=35;Ge=1.0/+h[(Un(xe,1,Nc)|0)>>3];c[Mc>>2]=36;h[(Un(xe,1,Mc)|0)>>3]=Ge;c[Lc>>2]=1;Ge=+h[(Un(xe,1,Lc)|0)>>3];c[Kc>>2]=3;He=Ge*+h[(Un(xe,1,Kc)|0)>>3];c[Jc>>2]=37;h[(Un(xe,1,Jc)|0)>>3]=He;c[Ic>>2]=37;He=1.0/+h[(Un(xe,1,Ic)|0)>>3];c[Hc>>2]=38;h[(Un(xe,1,Hc)|0)>>3]=He;c[Gc>>2]=6;He=1.0/+h[(Un(xe,1,Gc)|0)>>3];c[Fc>>2]=39;h[(Un(xe,1,Fc)|0)>>3]=He;c[Ec>>2]=1;He=+h[(Un(xe,1,Ec)|0)>>3];c[Dc>>2]=22;Ge=+h[(Un(xe,1,Dc)|0)>>3];c[Cc>>2]=3;Ie=He*Ge*+h[(Un(xe,1,Cc)|0)>>3];c[Bc>>2]=40;h[(Un(xe,1,Bc)|0)>>3]=Ie;c[Ac>>2]=40;Ie=1.0/+h[(Un(xe,1,Ac)|0)>>3];c[zc>>2]=41;h[(Un(xe,1,zc)|0)>>3]=Ie;c[yc>>2]=22;Ie=1.0/+h[(Un(xe,1,yc)|0)>>3];c[xc>>2]=42;h[(Un(xe,1,xc)|0)>>3]=Ie;c[wc>>2]=1;Ie=+h[(Un(xe,1,wc)|0)>>3];c[vc>>2]=2;Ge=+h[(Un(xe,1,vc)|0)>>3];c[uc>>2]=21;He=+h[(Un(xe,1,uc)|0)>>3];c[tc>>2]=3;Fe=Ie*Ge*He*+h[(Un(xe,1,tc)|0)>>3];c[sc>>2]=43;h[(Un(xe,1,sc)|0)>>3]=Fe;c[rc>>2]=43;Fe=1.0/+h[(Un(xe,1,rc)|0)>>3];c[qc>>2]=44;h[(Un(xe,1,qc)|0)>>3]=Fe;c[pc>>2]=13;Fe=1.0/+h[(Un(xe,1,pc)|0)>>3];c[oc>>2]=45;h[(Un(xe,1,oc)|0)>>3]=Fe;c[nc>>2]=10;Fe=+h[(Un(xe,1,nc)|0)>>3];c[mc>>2]=2;He=+h[(Un(xe,1,mc)|0)>>3];c[lc>>2]=6;Ge=Fe*(He*(+h[(Un(xe,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;He=+h[(Un(xe,1,kc)|0)>>3];c[jc>>2]=13;Fe=+h[(Un(xe,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;Ie=He*(Fe*+h[(Un(xe,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Fe=+h[(Un(xe,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;He=+h[(Un(xe,1,gc)|0)>>3];c[fc>>2]=11;Je=+h[(Un(xe,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Ke=Je*+h[(Un(xe,1,ec)|0)>>3];c[dc>>2]=19;Je=+h[(Un(xe,1,dc)|0)>>3];c[cc>>2]=34;Le=+h[(Un(xe,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Me=+h[(Un(xe,1,bc)|0)>>3];c[ac>>2]=32;Ne=+h[(Un(xe,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Oe=+h[(Un(xe,1,$b)|0)>>3];c[_b>>2]=30;Pe=+h[(Un(xe,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(Un(xe,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(Un(xe,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=De*(Ge+De*(Ie+De*(Fe+He*(Ke+Je*(Le+Me*(Ne+Oe*(Pe+De*(Qe+De*(Re+De*+h[(Un(xe,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(Un(xe,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(Un(xe,1,Vb)|0)>>3];c[Ub>>2]=1;Pe=+h[(Un(xe,1,Ub)|0)>>3];c[Tb>>2]=9;Oe=De*(Re*(Qe*(Ee*(Pe*(+h[(Un(xe,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(Un(xe,1,Sb)|0)>>3];c[Rb>>2]=1;Pe=+h[(Un(xe,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(Un(xe,1,Qb)|0)>>3];c[Pb>>2]=1;Re=De*(Oe+Se*(Pe*(Qe*(Ee*(Ee*(+h[(Un(xe,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(Un(xe,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(Un(xe,1,Nb)|0)>>3];c[Mb>>2]=2;Pe=+h[(Un(xe,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Pe*(+h[(Un(xe,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Pe=+h[(Un(xe,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(Un(xe,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Oe=Pe*(Re*+h[(Un(xe,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(Un(xe,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Pe=+h[(Un(xe,1,Gb)|0)>>3];c[Fb>>2]=11;Ne=+h[(Un(xe,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Me=Ne*+h[(Un(xe,1,Eb)|0)>>3];c[Db>>2]=19;Ne=+h[(Un(xe,1,Db)|0)>>3];c[Cb>>2]=34;Le=+h[(Un(xe,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Je=+h[(Un(xe,1,Bb)|0)>>3];c[Ab>>2]=32;Ke=+h[(Un(xe,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;He=+h[(Un(xe,1,zb)|0)>>3];c[yb>>2]=30;Fe=+h[(Un(xe,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;Ie=+h[(Un(xe,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Ge=+h[(Un(xe,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=De*(Se+De*(Oe+De*(Re+Pe*(Me+Ne*(Le+Je*(Ke+He*(Fe+De*(Ie+De*(Ge+De*+h[(Un(xe,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Ge=+h[(Un(xe,1,ub)|0)>>3];c[tb>>2]=7;Ie=+h[(Un(xe,1,tb)|0)>>3];c[sb>>2]=1;Fe=+h[(Un(xe,1,sb)|0)>>3];c[rb>>2]=9;He=De*(Ge*(Ie*(Ee*(Fe*(+h[(Un(xe,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(Un(xe,1,qb)|0)>>3];c[pb>>2]=1;Fe=+h[(Un(xe,1,pb)|0)>>3];c[ob>>2]=6;Ie=+h[(Un(xe,1,ob)|0)>>3];c[nb>>2]=1;Ge=He+Te*(Fe*(Ie*(Ee*(Ee*(+h[(Un(xe,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;Ie=+h[(Un(xe,1,mb)|0)>>3];c[lb>>2]=2;Fe=+h[(Un(xe,1,lb)|0)>>3];c[kb>>2]=6;Te=Ie*(Fe*(+h[(Un(xe,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Fe=+h[(Un(xe,1,jb)|0)>>3];c[ib>>2]=13;Ie=+h[(Un(xe,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;He=Fe*(Ie*+h[(Un(xe,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;Ie=+h[(Un(xe,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Fe=+h[(Un(xe,1,fb)|0)>>3];c[eb>>2]=11;Ke=+h[(Un(xe,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Je=Ke*+h[(Un(xe,1,db)|0)>>3];c[cb>>2]=19;Ke=+h[(Un(xe,1,cb)|0)>>3];c[bb>>2]=34;Le=+h[(Un(xe,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Ne=+h[(Un(xe,1,ab)|0)>>3];c[$a>>2]=32;Me=+h[(Un(xe,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Pe=+h[(Un(xe,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(Un(xe,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Oe=+h[(Un(xe,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(Un(xe,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=De*(Te+De*(He+De*(Ie+Fe*(Je+Ke*(Le+Ne*(Me+Pe*(Re+De*(Oe+De*(Se+De*+h[(Un(xe,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(Un(xe,1,Va)|0)>>3];c[Ua>>2]=7;Oe=+h[(Un(xe,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(Un(xe,1,Ta)|0)>>3];c[Sa>>2]=9;Pe=Se*(Oe*(Ee*(Re*(+h[(Un(xe,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(Un(xe,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(Un(xe,1,Qa)|0)>>3];c[Pa>>2]=1;Oe=+h[(Un(xe,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Oe*+h[(Un(xe,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Oe=Ue*(Re*(Se*+h[(Un(xe,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(Un(xe,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(Un(xe,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(Un(xe,1,Ka)|0)>>3];c[Ja>>2]=9;Me=Se*(Re*(Ue*(+h[(Un(xe,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(Un(xe,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(Un(xe,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(Un(xe,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(Un(xe,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Ne=Ue*(Se*+h[(Un(xe,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(Un(xe,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(Un(xe,1,Ca)|0)>>3];c[Ba>>2]=11;Le=+h[(Un(xe,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Ke=Le*+h[(Un(xe,1,Aa)|0)>>3];c[za>>2]=19;Le=+h[(Un(xe,1,za)|0)>>3];c[ya>>2]=44;Je=+h[(Un(xe,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Fe=+h[(Un(xe,1,xa)|0)>>3];c[wa>>2]=42;Ie=+h[(Un(xe,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;He=+h[(Un(xe,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(Un(xe,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(Un(xe,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(Un(xe,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=De*(Oe+De*(Me+De*(Re+De*(Ne+De*(Se+Ue*(Ke+Le*(Je+Fe*(Ie+He*(Te+De*(Ve+De*(We+De*+h[(Un(xe,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(Un(xe,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(Ee*((Ee*(Ee*(Ee*(Ee*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(Un(xe,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(Un(xe,1,oa)|0)>>3];c[na>>2]=1;We=+h[(Un(xe,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(Un(xe,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;He=Xe*(We*(Te*+h[(Un(xe,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(Un(xe,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(Un(xe,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(Un(xe,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(Un(xe,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(Un(xe,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(Un(xe,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;Ie=+h[(Un(xe,1,ea)|0)>>3];c[da>>2]=19;Fe=+h[(Un(xe,1,da)|0)>>3];c[ca>>2]=32;Je=+h[(Un(xe,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Le=+h[(Un(xe,1,ba)|0)>>3];c[aa>>2]=20;Ke=+h[(Un(xe,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(Un(xe,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(Un(xe,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Ne=+h[(Un(xe,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(Un(xe,1,Y)|0)>>3];c[X>>2]=22;Me=Re*+h[(Un(xe,1,X)|0)>>3];c[W>>2]=3;Re=Ke*(Ue+De*(Se+De*(Ne+De/(Ee*Me*+h[(Un(xe,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Me=Fe*(Je+Le*(1.43624813658928e-17/(Ee*+h[(Un(xe,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(Un(xe,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Le=+h[(Un(xe,1,T)|0)>>3];c[S>>2]=3;Je=De*(We+Ie*(Re/(Ee*Le*+h[(Un(xe,1,S)|0)>>3])+Me));c[R>>2]=13;Me=+h[(Un(xe,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Le=Me*+h[(Un(xe,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Me=+h[(Un(xe,1,P)|0)>>3];c[O>>2]=2;Re=De*(He+De*(Xe+De*(Te+De*(Je+Le/(Ee*Me*+h[(Un(xe,1,O)|0)>>3])))));c[N>>2]=10;Me=+h[(Un(xe,1,N)|0)>>3];c[M>>2]=7;Le=Re+Me*(Ee*((Ee*(Ee*(Ee*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(Un(xe,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;Ee=+h[(Un(xe,1,L)|0)>>3];c[K>>2]=1;Me=+h[(Un(xe,1,K)|0)>>3];c[J>>2]=1;Re=+h[(Un(xe,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Je=Re*+h[(Un(xe,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=Ee*(Me*(Je*+h[(Un(xe,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Je=+h[(Un(xe,1,G)|0)>>3];c[F>>2]=2;Me=+h[(Un(xe,1,F)|0)>>3];c[E>>2]=1;Ee=+h[(Un(xe,1,E)|0)>>3];c[D>>2]=9;Te=Je*(Me*(Ee*(+h[(Un(xe,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;Ee=+h[(Un(xe,1,C)|0)>>3];c[B>>2]=37;Me=Ee*(+h[(Un(xe,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;Ee=+h[(Un(xe,1,A)|0)>>3];c[z>>2]=13;Je=+h[(Un(xe,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=Ee*(Je*+h[(Un(xe,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Je=+h[(Un(xe,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;Ee=+h[(Un(xe,1,w)|0)>>3];c[v>>2]=11;He=+h[(Un(xe,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;Ie=He*+h[(Un(xe,1,u)|0)>>3];c[t>>2]=19;He=+h[(Un(xe,1,t)|0)>>3];c[s>>2]=44;We=+h[(Un(xe,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Fe=+h[(Un(xe,1,r)|0)>>3];c[q>>2]=42;Ne=+h[(Un(xe,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(Un(xe,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(Un(xe,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Ke=+h[(Un(xe,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Oe=+h[(Un(xe,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+De*(Te+De*(Me+De*(Xe+De*(Je+Ee*(Ie+He*(We+Fe*(Ne+Se*(Ue+De*(Ke+De*(Oe+De*+h[(Un(xe,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Be;h[a+32>>3]=Ce;h[a+40>>3]=Qe;h[a+48>>3]=Ge;h[a+56>>3]=Pe;h[a+64>>3]=Ve;h[a+72>>3]=Le;h[a+80>>3]=Ye;i=f;return}function Cg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;On(ia,1,ha);if(!(d>0.0)){ha=zn(zn(4520,xn(d,0,1,6)|0)|0,3912)|0;ja=c[16252]|0;ka=m;la=4584;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];we[ja&31](b,m,ha,ga);}if(!(d<=1.0e7)){ga=zn(zn(4608,xn(d,0,1,6)|0)|0,4656)|0;ha=c[16252]|0;m=l;ja=4696;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];we[ha&31](b,l,ga,fa);}if(!(e<=2273.15)){fa=zn(zn(4720,xn(e,0,1,6)|0)|0,4768)|0;ga=c[16252]|0;l=j;ha=4824;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];we[ga&31](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(Un(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(Un(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(Un(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(Un(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(Un(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(Un(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(Un(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(Un(ia,1,X)|0)>>3];c[W>>2]=5;h[(Un(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(Un(ia,1,V)|0)>>3];c[U>>2]=6;h[(Un(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(Un(ia,1,T)|0)>>3];c[S>>2]=7;h[(Un(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(Un(ia,1,R)|0)>>3];c[Q>>2]=8;h[(Un(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(Un(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(Un(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(Un(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(Un(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(Un(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[16252]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=4848;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];we[M&31](b,g,2568,K);}c[J>>2]=4;oa=+h[(Un(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(Un(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(Un(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(Un(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(Un(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(Un(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(Un(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(Un(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(Un(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(Un(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(Un(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(Un(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(Un(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(Un(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(Un(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(Un(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(Un(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(Un(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(Un(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(Un(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(Un(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(Un(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(Un(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function Dg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;On(I,1,H);J=+kd(+d,647.096);if(!(d>=273.16)){H=c[16252]|0;K=f;L=4872;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];we[H&31](b,f,4896,G);}c[F>>2]=1;h[(Un(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(Un(I,1,E)|0)>>3];c[D>>2]=2;h[(Un(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(Un(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(Un(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(Un(I,1,A)|0)>>3];c[z>>2]=4;h[(Un(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(Un(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(Un(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(Un(I,1,w)|0)>>3];c[v>>2]=6;h[(Un(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(Un(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(Un(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(Un(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(Un(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(Un(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(Un(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(Un(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(Un(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(Un(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(Un(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(Un(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(Un(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(Un(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function Eg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=zn(zn(5008,xn(d,0,1,6)|0)|0,5080)|0;H=zn(zn(G,xn(16529200.0,0,1,6)|0)|0,5088)|0;G=c[16252]|0;I=n;J=5096;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];we[G&31](b,n,H,r);}if(!(e>=623.15)){r=zn(zn(5120,xn(e,0,1,6)|0)|0,5192)|0;H=zn(zn(r,xn(623.15,0,1,6)|0)|0,5200)|0;r=c[16252]|0;n=m;G=5208;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];we[r&31](b,m,H,q);}Fg(t,0,e);if(!(+h[t>>3]<=d)){t=zn(zn(5232,xn(d,0,1,6)|0)|0,5304)|0;q=zn(zn(t,xn(e,0,1,6)|0)|0,5200)|0;t=c[16252]|0;H=l;m=5320;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];we[t&31](b,l,q,p);}xg(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];Gg(v,0,d);L=+h[v>>3];Hg(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{yg(x,b,d);if(+h[x>>3]>e){Gg(y,0,d);M=+h[y>>3];Ig(z,0,d);L=+h[z>>3];Jg(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{Kg(B,0,d);L=+h[B>>3];Hg(C,0,d);M=+h[C>>3];Lg(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){Ag(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));vf(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[16252]|0;S=j;R=5344;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];we[fa&31](b,j,5368,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function Fg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;On(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function Gg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;On(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(Un(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(Un(s,1,p)|0)>>3];c[o>>2]=2;h[(Un(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(Un(s,1,n)|0)>>3];c[m>>2]=3;h[(Un(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(Un(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(Un(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(Un(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(Un(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(Un(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(Un(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function Hg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;On(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(Un(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(Un(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(Un(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(Un(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(Un(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(Un(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(Un(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(Un(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(Un(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(Un(La,1,Aa)|0)>>3];c[za>>2]=6;h[(Un(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(Un(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(Un(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(Un(La,1,wa)|0)>>3];c[va>>2]=7;h[(Un(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(Un(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(Un(La,1,ta)|0)>>3];c[sa>>2]=8;h[(Un(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(Un(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(Un(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(Un(La,1,pa)|0)>>3];c[oa>>2]=9;h[(Un(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(Un(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(Un(La,1,ma)|0)>>3];c[la>>2]=11;h[(Un(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(Un(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(Un(La,1,ja)|0)>>3];c[ia>>2]=12;h[(Un(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(Un(La,1,ha)|0)>>3];c[ga>>2]=13;h[(Un(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(Un(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(Un(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(Un(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(Un(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(Un(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(Un(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(Un(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(Un(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(Un(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(Un(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(Un(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(Un(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(Un(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(Un(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(Un(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(Un(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(Un(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(Un(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(Un(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(Un(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(Un(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(Un(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(Un(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(Un(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(Un(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(Un(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(Un(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(Un(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(Un(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(Un(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(Un(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(Un(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(Un(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(Un(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(Un(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(Un(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(Un(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(Un(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(Un(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(Un(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(Un(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(Un(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(Un(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(Un(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(Un(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(Un(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(Un(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(Un(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(Un(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(Un(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(Un(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(Un(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(Un(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function Ig(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Jg(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Dg(e,b,c);j=+h[e>>3];do{if(c<623.15){Qg(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Ig(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Kg(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Lg(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Dg(e,b,c);j=+h[e>>3];do{if(c<623.15){Pg(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Kg(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Mg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){Og(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==2){zg(n,b,d,e);s=+h[n+24>>3];t=+h[n+32>>3];u=+h[n+48>>3];v=+h[n+56>>3];w=+h[n+72>>3];x=+h[n+80>>3];y=t*+h[n+64>>3];z=(y- +h[n+40>>3])*461.526;A=s*u;B=(A-t*s*x)/d*461.526;C=s*s*v*+to(d,-2)*e*461.526;s=t*t*w;w=u-t*x;D=0.0;E=0.0;F=B;G=C;H=1.0;I=-B/C;J=y*e*461.526;K=s*-461.526;L=(w*w/v-s)*461.526;M=d/(A*e*461.526);N=z}else if((r|0)==1){Bg(m,b,d,e);z=+h[m+24>>3];A=+h[m+32>>3];s=+h[m+48>>3];v=+h[m+56>>3];w=+h[m+72>>3];y=+h[m+80>>3];C=A*+h[m+64>>3];B=(C- +h[m+40>>3])*461.526;x=z*s;t=(x-A*z*y)/d*461.526;u=z*z*v*+to(d,-2)*e*461.526;z=A*A*w;w=s-A*y;D=0.0;E=0.0;F=t;G=u;H=0.0;I=-t/u;J=C*e*461.526;K=z*-461.526;L=(w*w/v-z)*461.526;M=d/(x*e*461.526);N=B}else if((r|0)==5){Cg(q,b,d,e);B=+h[q+24>>3];x=+h[q+32>>3];z=+h[q+48>>3];v=+h[q+56>>3];w=+h[q+72>>3];C=+h[q+80>>3];u=x*+h[q+64>>3];t=(u- +h[q+40>>3])*461.526;y=B*z;A=(y-x*B*C)/d*461.526;s=B*B*v*+to(d,-2)*e*461.526;B=x*x*w;w=z-x*C;D=0.0;E=0.0;F=A;G=s;H=1.0;I=-A/s;J=u*e*461.526;K=B*-461.526;L=(w*w/v-B)*461.526;M=d/(y*e*461.526);N=t}else if((r|0)==3){Eg(o,b,d,e,1.0e-7);t=+h[o>>3];Ag(p,b,t,e);y=+h[p+24>>3];B=+h[p+32>>3];v=+h[p+48>>3];w=B*+h[p+64>>3];u=t*y*(v-B*+h[p+80>>3])*461.526;D=u;E=y*(v*2.0+y*+h[p+56>>3])*e*461.526;F=0.0;G=0.0;H=0.0;I=u;J=(y*v+w)*e*461.526;K=0.0;L=B*B*+h[p+72>>3]*-461.526;M=t;N=(w- +h[p+40>>3])*461.526}else{p=zn(zn(5424,xn(d,0,1,6)|0)|0,5480)|0;o=zn(zn(p,xn(e,0,1,6)|0)|0,5488)|0;p=c[16252]|0;q=j;m=5496;c[q+0>>2]=c[m+0>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];c[q+12>>2]=c[m+12>>2];c[q+16>>2]=c[m+16>>2];c[q+20>>2]=c[m+20>>2];we[p&31](b,j,o,k);D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0;L=0.0;M=0.0;N=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=J;h[a+32>>3]=461.526;h[a+40>>3]=K;h[a+48>>3]=L;h[a+56>>3]=M;h[a+64>>3]=N;h[a+72>>3]=D;h[a+80>>3]=E;h[a+88>>3]=F;h[a+96>>3]=G;h[a+104>>3]=H;h[a+112>>3]=I;i=g;return}function Ng(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+64>>3];i=i;return}function Og(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}yg(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}xg(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function Pg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;On(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(Un(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(Un(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(Un(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(Un(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(Un(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(Un(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(Un(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(Un(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(Un(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(Un(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(Un(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(Un(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(Un(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(Un(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(Un(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(Un(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(Un(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(Un(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(Un(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(Un(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(Un(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(Un(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(Un(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(Un(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(Un(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(Un(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(Un(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(Un(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(Un(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(Un(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(Un(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(Un(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(Un(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(Un(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(Un(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(Un(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(Un(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(Un(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(Un(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(Un(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(Un(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(Un(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(Un(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(Un(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(Un(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(Un(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(Un(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(Un(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(Un(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(Un(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(Un(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(Un(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(Un(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(Un(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(Un(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(Un(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(Un(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(Un(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(Un(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(Un(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(Un(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(Un(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(Un(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(Un(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(Un(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(Un(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(Un(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(Un(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(Un(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(Un(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(Un(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(Un(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(Un(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(Un(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(Un(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(Un(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(Un(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(Un(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(Un(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(Un(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(Un(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function Qg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;On(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(Un(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(Un(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(Un(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(Un(ta,1,oa)|0)>>3];c[na>>2]=3;h[(Un(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(Un(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(Un(ta,1,la)|0)>>3];c[ka>>2]=4;h[(Un(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(Un(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(Un(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(Un(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(Un(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(Un(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(Un(ta,1,ea)|0)>>3];c[da>>2]=8;h[(Un(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(Un(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(Un(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(Un(ta,1,aa)|0)>>3];c[$>>2]=10;h[(Un(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(Un(ta,1,_)|0)>>3];c[Z>>2]=11;h[(Un(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(Un(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(Un(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(Un(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(Un(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(Un(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(Un(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(Un(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(Un(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(Un(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(Un(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(Un(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(Un(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(Un(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(Un(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(Un(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(Un(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(Un(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(Un(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(Un(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(Un(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(Un(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(Un(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(Un(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(Un(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(Un(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(Un(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(Un(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(Un(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(Un(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(Un(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(Un(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(Un(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(Un(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(Un(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(Un(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(Un(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(Un(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(Un(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(Un(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(Un(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(Un(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(Un(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(Un(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(Un(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function Rg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function Sg(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;Rm(4,0,6416,b);Rm(4,0,6456,a);i=a;return}function Tg(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}bR(a);c[d>>2]=0;i=b;return}function Ug(a){a=a|0;i=i;return}function Vg(a){a=a|0;i=i;return}function Wg(a,b){a=a|0;b=b|0;i=i;return}function Xg(a){a=a|0;i=i;return}function Yg(a,b){a=a|0;b=b|0;c[b>>2]=c[6552+(a<<2)>>2];i=i;return c[6560+(a<<2)>>2]|0}function Zg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=b+4|0;g=b+360|0;b=(Yp(+h[c[c[f>>2]>>2]>>3],0.0,a[c[g>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=(Zp(+h[c[c[f>>2]>>2]>>3],1.0,a[(c[g>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=b?1.0:-1.0;i=e;return 0}function _g(a){a=a|0;i=i;return c[6560+(a<<2)>>2]|0}function $g(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<0.0|0;a[(c[d>>2]|0)+1|0]=+h[c[c[f>>2]>>2]>>3]>1.0|0;i=e;return 0}else{d=b+360|0;j=Yp(g,0.0,a[c[d>>2]|0]|0)|0;k=b+352|0;a[c[k>>2]|0]=j;j=Zp(+h[c[c[f>>2]>>2]>>3],1.0,a[(c[d>>2]|0)+1|0]|0)|0;a[(c[k>>2]|0)+1|0]=j;i=e;return 0}return 0}function ah(a){a=a|0;a=i;i=i+8|0;Rm(8,1,6568,a);if((c[18904>>2]|0)==0){i=a;return 0}Yd[c[4856]&255](8);i=a;return 0}function bh(a){a=a|0;i=i;return 6600}function ch(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Rm(21,1,6608,b);if((c[18956>>2]|0)==0){i=b;return 0}Yd[c[4856]&255](21);i=b;return 0}function dh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=52261.1444812124;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+56|0;x=w;h[x>>3]=l;i=d;return}do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=j;y=g;break}else{g=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;g=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=f;break}else{f=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=f;y=f;break}}}}while(0);if(!(y<<24>>24==0)){l=257184.9562751197;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+56|0;x=w;h[x>>3]=l;i=d;return}l=+h[c[c[b+4>>2]>>2]>>3]*204923.8117939073+52261.1444812124;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+56|0;x=w;h[x>>3]=l;i=d;return}function eh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+56>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];wg(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[g>>3];i=b;return}function fh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+40>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];ug(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[g>>3];i=b;return}function gh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Yp(+h[c[c[b+4>>2]>>2]>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=_p(+h[c[c[b+4>>2]>>2]>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=350.7919654772122;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+32|0;x=w;h[x>>3]=l;i=d;return}do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=j;y=g;break}else{g=Zp(+h[c[c[b+4>>2]>>2]>>3],1.0,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;g=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=g;y=f;break}else{f=aq(+h[c[c[b+4>>2]>>2]>>3],1.0)|0;a[(c[b+352>>2]|0)+1|0]=f;y=f;break}}}}while(0);if(!(y<<24>>24==0)){l=873.6797342484729;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+32|0;x=w;h[x>>3]=l;i=d;return}l=+h[c[c[b+4>>2]>>2]>>3]*522.8877687712607+350.7919654772122;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+32|0;x=w;h[x>>3]=l;i=d;return}function hh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+32>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];qg(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[g>>3];i=b;return}function ih(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l>>3];n=e;h[k>>3]=+h[l+8>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Tn(f,2,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+32>>3];j=a+4|0;o=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];sg(g,e,m,o,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[g>>3];i=b;return}function jh(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);a[d]=0;i=c;return 0}function kh(a){a=a|0;i=i;return}function lh(a){a=a|0;i=i;return 0}function mh(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;Rm(9,1,6640,e);if((c[18908>>2]|0)!=0){Yd[c[4856]&255](9)}Rm(9,1,6664,d);if((c[18908>>2]|0)!=0){Yd[c[4856]&255](9)}Rm(9,1,6688,b);if((c[18908>>2]|0)!=0){Yd[c[4856]&255](9)}Rm(9,1,6712,a);if((c[18908>>2]|0)==0){i=a;return 0}Yd[c[4856]&255](9);i=a;return 0}function nh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6736]&1){i=d;return}g=b+416|0;b=bq(+h[(c[g>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|($p(+h[(c[g>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=zn(6752,vn(+h[(c[g>>2]|0)+8>>3],6744)|0)|0;g=c[16254]|0;j=e;k=7008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];se[g&15](e,b,f);a[6736]=1;i=d;return}function oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6912]&1){i=d;return}g=b+416|0;b=bq(+h[c[g>>2]>>3],0.0)|0;if(!(b<<24>>24==0|($p(+h[c[g>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=zn(6920,vn(+h[c[g>>2]>>3],6744)|0)|0;g=c[16254]|0;j=e;k=7008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];se[g&15](e,b,f);a[6912]=1;i=d;return}function ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7032]&1){i=d;return}g=b+416|0;if(!((bq(+h[(c[g>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=d;return}b=zn(7040,vn(+h[(c[g>>2]|0)+24>>3],6744)|0)|0;g=c[16254]|0;j=e;k=7112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];se[g&15](e,b,f);a[7032]=1;i=d;return}function qh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7136]&1){i=d;return}g=b+416|0;if(!((bq(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=zn(7144,vn(+h[(c[g>>2]|0)+16>>3],6744)|0)|0;g=c[16254]|0;j=e;k=7216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];se[g&15](e,b,f);a[7136]=1;i=d;return}function rh(a){a=a|0;var b=0;b=i;nh(a);oh(a);ph(a);qh(a);i=b;return 0}function sh(b){b=b|0;var c=0;c=i;a[b+314|0]=0;th(b);i=c;return 0}function th(a){a=a|0;var b=0;b=i;We(a);Xe(a);Ye(a);Te(a);Ue(a);Ve(a);Ze(a);_e(a);i=b;return}function uh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7240]&1){i=d;return}g=b+4|0;if(!((bq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=d;return}b=zn(7256,vn(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],7248)|0)|0;g=c[16254]|0;j=e;k=7392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];se[g&15](e,b,f);a[7240]=1;i=d;return}function vh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7416]&1){i=d;return}g=b+4|0;if(!((bq(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=zn(7424,vn(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],7248)|0)|0;g=c[16254]|0;j=e;k=7488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];se[g&15](e,b,f);a[7416]=1;i=d;return}function wh(a){a=a|0;var b=0;b=i;uh(a);vh(a);i=b;return 0}function xh(a){a=a|0;i=i;return 1}function yh(a){a=a|0;i=i;return 1}function zh(a){a=a|0;i=i;return 1}function Ah(a){a=a|0;i=i;return 1}function Bh(a){a=a|0;i=i;return 1}function Ch(a){a=a|0;i=i;return 0}function Dh(a){a=a|0;i=i;return 0}function Eh(a){a=a|0;i=i;return 0}function Fh(a){a=a|0;i=i;return 0}function Gh(a){a=a|0;i=i;return 0}function Hh(a,b){a=a|0;b=b|0;i=i;return-1}function Ih(a,b){a=a|0;b=b|0;i=i;return-1}function Jh(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Kh(){i=i;return 7512}function Lh(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=Mh(a,0,0)|0;i=b;return c|0}function Mh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=Nh(a,b,c,0)|0;i=d;return e|0}function Nh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=$d[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=aR(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=47;c[f+8>>2]=148}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=$d[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){Yd[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=$d[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){Yd[c[b+20>>2]&255](c[j+392>>2]|0);Yd[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Yi(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}Yd[c[j+20>>2]&255](c[j+44>>2]|0);Yd[c[j+20>>2]&255](c[j+392>>2]|0);Yd[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Zi(j+416|0,j+12|0);Zi(j+440|0,j+12|0);Ph(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}Sh(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=rj()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=ij()|0}k=j;l=k;i=g;return l|0}function Oh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Ph(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;Al(f+256|0);if((b|0)!=0){g=Qh(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;jj(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Qh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((fi(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Rh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=ii(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Qh(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((fi(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((fi(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((mi(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=ii(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function Sh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;Yd[c[e+20>>2]&255](c[g+36>>2]|0);Th(c[g+44>>2]|0,e);Yd[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;Yd[c[e+20>>2]&255](f)}Th(c[h+376>>2]|0,e);Th(c[e+372>>2]|0,e);Uh(e+416|0);Uh(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Vh(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);Yd[c[e+20>>2]&255](c[e+392>>2]|0);Yd[c[e+20>>2]&255](c[e+464>>2]|0);Yd[c[e+20>>2]&255](c[e+8>>2]|0);Yd[c[e+20>>2]&255](c[e+44>>2]|0);Yd[c[e+20>>2]&255](c[e+396>>2]|0);Yd[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){Yd[c[e+252>>2]&255](c[e+244>>2]|0)}Yd[c[e+20>>2]&255](e);i=d;return}function Th(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;Yd[c[a+20>>2]&255](c[b+16>>2]|0);Yd[c[a+20>>2]&255](b)}i=d;return}function Uh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Yd[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Yd[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}



function HP(a){a=a|0;a=i;zH(95668|0);zH(95656|0);zH(95644|0);zH(95632|0);zH(95620|0);zH(95608|0);zH(95596|0);zH(95584|0);zH(95572|0);zH(95560|0);zH(95548|0);zH(95536|0);zH(95524|0);zH(95512|0);zH(95500|0);zH(95488|0);zH(95476|0);zH(95464|0);zH(95452|0);zH(95440|0);zH(95428|0);zH(95416|0);zH(95404|0);zH(95392);i=a;return}function IP(a){a=a|0;a=i;XG(96508|0);XG(96496|0);XG(96484|0);XG(96472|0);XG(96460|0);XG(96448|0);XG(96436|0);XG(96424|0);XG(96412|0);XG(96400|0);XG(96388|0);XG(96376|0);XG(96364|0);XG(96352|0);XG(96340|0);XG(96328|0);XG(96316|0);XG(96304|0);XG(96292|0);XG(96280|0);XG(96268|0);XG(96256|0);XG(96244|0);XG(96232);i=a;return}function JP(a){a=a|0;a=i;zH(96900|0);zH(96888|0);zH(96876|0);zH(96864|0);zH(96852|0);zH(96840|0);zH(96828|0);zH(96816|0);zH(96804|0);zH(96792|0);zH(96780|0);zH(96768|0);zH(96756|0);zH(96744);i=a;return}function KP(a){a=a|0;a=i;XG(97436|0);XG(97424|0);XG(97412|0);XG(97400|0);XG(97388|0);XG(97376|0);XG(97364|0);XG(97352|0);XG(97340|0);XG(97328|0);XG(97316|0);XG(97304|0);XG(97292|0);XG(97280);i=a;return}function LP(a){a=a|0;var b=0,c=0;b=i;if((RP(a)|0)==0){c=(MP(a)|0)!=0|0}else{c=1}i=b;return c|0}function MP(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[97592+((d[97592+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function NP(a){a=a|0;var b=0,c=0;b=i;c=ub(a|0)|0;i=b;return c|0}function OP(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function PP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 8:{d=UP(a)|0;break};case 3:{d=NP(a)|0;break};case 12:{d=YP(a)|0;break};case 10:{d=WP(a)|0;break};case 1:{d=LP(a)|0;break};case 7:{d=TP(a)|0;break};case 2:{d=MP(a)|0;break};case 5:{d=RP(a)|0;break};case 9:{d=VP(a)|0;break};case 6:{d=SP(a)|0;break};case 11:{d=XP(a)|0;break};case 4:{d=OP(a)|0;break};default:{d=0}}i=c;return d|0}function QP(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=100568;while(1){if(d<<24>>24==e<<24>>24){if((AR(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function RP(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function SP(a){a=a|0;var b=0,c=0;b=i;if((WP(a)|0)==0){c=(UP(a)|0)!=0|0}else{c=0}i=b;return c|0}function TP(a){a=a|0;var b=0,c=0;b=i;if((ZP(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function UP(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function VP(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[100648+((d[100648+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function WP(a){a=a|0;var b=0,c=0;b=i;c=(BQ(103816,a)|0)!=0|0;i=b;return c|0}function XP(a){a=a|0;var b=0,c=0;b=i;c=($P(a)|0)!=(a|0)|0;i=b;return c|0}function YP(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function ZP(a){a=a|0;var b=0,c=0;b=i;c=_P(a,0)|0;i=b;return c|0}function _P(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((MP(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[103906+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[103904+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[103907+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[104152+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[104152+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[104152+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function $P(a){a=a|0;var b=0,c=0;b=i;c=_P(a,1)|0;i=b;return c|0}function aQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=bQ(0,a,b,(c|0)!=0?c:104856)|0;i=d;return e|0}function bQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?104864:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[104648+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Jc()|0)>>2]=84;k=-1;i=g;return k|0}function cQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=dQ(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=bQ(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function dQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[104648+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[104648+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Jc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function eQ(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[104648+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Jc()|0)>>2]=84;j=-1;i=g;return j|0}function fQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Jc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function gQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=hQ(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=fQ(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function hQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=fQ(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=fQ(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=fQ(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}fQ(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function iQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=aR(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=aR(2048)|0;c[p+16>>2]=s;if((s|0)==0){bR(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=yQ(0,0)|0;if((s|0)==0){bR(c[p+16>>2]|0);bR(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=jQ(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=cR(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=kQ(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=aR(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;IR(y|0,-1,v|0)|0;I=H}else{I=0}H=cR(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=cR(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=kQ(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=qQ(q,x)|0;b:do{if((v|0)==0){y=qQ(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=rQ(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=AQ(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=AQ(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=rQ(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=AQ(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=AQ(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=rQ(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=AQ(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=AQ(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=AQ(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=AQ(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=AQ(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=AQ(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=AQ(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=AQ(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==2){U=c[S+4>>2]|0;W=qQ(q,L)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,S)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,1)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{wa=L}}if((F|0)==45){F=0;c[j>>2]=0;wa=0}ra=wa;sa=M+1|0;ta=N;break}else if((T|0)==0){U=c[S+4>>2]|0;W=c[U>>2]|0;if(!((W|0)>-1|(W|0)==-4)){ra=L;sa=M;ta=N;break}W=U+8|0;U=(c[W>>2]|0)+L|0;c[W>>2]=U;if((U|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=U;ra=L;sa=M;ta=N;break}else if((T|0)==1){U=c[S+4>>2]|0;W=qQ(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}xa=qQ(q,0)|0}else if((T|0)==3){T=c[S+4>>2]|0;W=qQ(q,c[T+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=qQ(q,c[T>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}xa=qQ(q,0)|0}else{ra=L;sa=M;ta=N;break}if((xa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=xa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=AQ(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=AQ(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=AQ(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=AQ(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=qQ(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=qQ(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==1){L=qQ(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=qQ(q,2)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=qQ(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qQ(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qQ(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qQ(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==0){R=c[ya+4>>2]|0;L=c[R>>2]|0;if((L|0)==-4){c[ya+8>>2]=0;Q=R+8|0;W=c[Q>>2]|0;T=AQ(s,0,0,1,64)|0;if((T|0)==0){F=104;break g}U=T;c[T>>2]=W;c[T+4>>2]=0;c[T+8>>2]=1114111;c[T+20>>2]=0;c[T+24>>2]=0;W=T+28|0;T=ya+24|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[T>>2]=U;U=c[Q>>2]|0;Q=c[R+4>>2]|0;T=AQ(s,0,0,1,64)|0;if((T|0)==0){F=106;break g}c[T>>2]=U;c[T+4>>2]=0;c[T+8>>2]=1114111;c[T+20>>2]=0;c[T+24>>2]=0;c[T+28>>2]=Q;c[T+32>>2]=-1;c[T+36>>2]=-1;c[T+40>>2]=-1;c[ya+28>>2]=T;break}T=ya+8|0;if((L|0)<0){c[T>>2]=1;Q=AQ(s,0,0,1,32)|0;if((Q|0)==0){F=110;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+24>>2]=Q;Q=AQ(s,0,0,1,32)|0;if((Q|0)==0){F=112;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+28>>2]=Q;break}else{c[T>>2]=0;T=R+8|0;Q=c[T>>2]|0;U=R+4|0;W=c[U>>2]|0;ea=AQ(s,0,0,1,64)|0;if((ea|0)==0){F=115;break g}fa=ea;c[ea>>2]=Q;c[ea+4>>2]=L;c[ea+8>>2]=W;c[ea+20>>2]=0;c[ea+24>>2]=0;W=ea+28|0;ea=ya+24|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[ea>>2]=fa;fa=c[T>>2]|0;T=c[R>>2]|0;ea=c[U>>2]|0;U=c[R+12>>2]|0;W=c[R+16>>2]|0;R=AQ(s,0,0,1,64)|0;if((R|0)==0){F=117;break g}L=R;c[R>>2]=fa;c[R+4>>2]=T;c[R+8>>2]=ea;c[R+20>>2]=U;c[R+24>>2]=W;W=R+28|0;R=ya+28|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[R>>2]=L;break}}else if((M|0)==3){L=qQ(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=qQ(q,1)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=qQ(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qQ(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qQ(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=qQ(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==2){M=qQ(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=qQ(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=qQ(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=qQ(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==3){M=c[ya+4>>2]|0;R=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[R+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[R+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==2){L=c[ya+4>>2]|0;W=c[L>>2]|0;U=W+8|0;if((c[U>>2]|0)==0){za=0}else{za=(c[(c[L+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[U>>2]|0)==0){c[ya+24>>2]=c[W+24>>2];Aa=L+4|0}else{U=pQ(q,W,0,0,g)|0;if((U|0)!=0){z=0;A=U;B=0;C=D;break a}Ba=aR((c[g>>2]<<2)+4|0)|0;U=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=pQ(q,c[L>>2]|0,U,h,0)|0;if((Ca|0)!=0){F=150;break g}W=L+4|0;ea=oQ(s,c[(c[W>>2]|0)+24>>2]|0,c[(c[L>>2]|0)+24>>2]|0,U,c[h>>2]|0)|0;U=ya+24|0;c[U>>2]=ea;bR(Ba);if((c[U>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=W}}W=c[Aa>>2]|0;if((c[W+8>>2]|0)==0){c[ya+28>>2]=c[W+28>>2];break}U=pQ(q,W,0,0,g)|0;if((U|0)!=0){z=0;A=U;B=0;C=D;break a}Da=aR((c[g>>2]<<2)+4|0)|0;U=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=pQ(q,c[Aa>>2]|0,U,h,0)|0;if((Ea|0)!=0){F=157;break g}W=oQ(s,c[(c[L>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,U,c[h>>2]|0)|0;U=ya+28|0;c[U>>2]=W;bR(Da);if((c[U>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){U=c[ya+4>>2]|0;W=c[U>>2]|0;L=U+4|0;ea=c[L>>2]|0;if((c[W+8>>2]|0)==0){Fa=(c[ea+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;T=oQ(s,c[W+24>>2]|0,c[ea+24>>2]|0,0,0)|0;c[ya+24>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}T=oQ(s,c[(c[U>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){bR(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){bR(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=aR(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=aR(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){IR(O|0,0,((E|0)>1?E<<2:4)|0)|0}lQ(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;T=O+(S<<2)|0;L=K+1+(c[T>>2]|0)|0;c[T>>2]=0;T=S+1|0;if((T|0)<(E|0)){S=T;K=L}else{Ga=L;break}}}else{Ga=0}K=cR(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;L=lQ(y,S,x,u)|0;if((L|0)!=0){z=x;A=L;B=u;C=D;break}c[w+20>>2]=0;L=v+24|0;S=c[L>>2]|0;if((c[S>>2]|0)>-1){T=1;U=S;while(1){S=U+32|0;ea=T+1|0;if((c[S>>2]|0)>-1){U=S;T=ea}else{Ha=ea;break}}}else{Ha=1}T=cR(Ha,32)|0;if((T|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=T;U=c[L>>2]|0;y=c[U>>2]|0;if((y|0)>-1){ea=y;y=U;U=0;while(1){c[T+(U<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[T+(U<<5)+12>>2]=ea;S=T+(U<<5)+16|0;c[S>>2]=0;W=y+12|0;fa=c[W>>2]|0;if((fa|0)!=0){Q=0;while(1){Ia=Q+1|0;if((c[fa+(Q<<2)>>2]|0)>-1){Q=Ia}else{break}}Q=Ia<<2;fa=aR(Q)|0;c[S>>2]=fa;if((fa|0)==0){z=x;A=12;B=u;C=D;break a}GR(fa|0,c[W>>2]|0,Q|0)|0}c[T+(U<<5)+20>>2]=c[y+16>>2];Q=U+1|0;fa=y+32|0;da=c[fa>>2]|0;if((da|0)>-1){ea=da;y=fa;U=Q}else{Ja=Q;break}}}else{Ja=0}c[T+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;zQ(s);bR(c[p+16>>2]|0);bR(p);bR(O);bR(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);zQ(s);bR(c[p+16>>2]|0);bR(p);if((z|0)!=0){bR(z)}if((B|0)!=0){bR(B)}c[b+4>>2]=C;mQ(b);r=A;i=f;return r|0}function jQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;qQ(m,c[p>>2]|0)|0;qQ(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=qQ(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 4:{Q=qQ(m,9)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=qQ(m,1)|0;break};case 6:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;Y=AQ(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=AQ(Q,0,0,1,8)|0;Q=Y+4|0;c[Q>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=X;c[(c[Q>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=Y;W=0;break};case 0:{if((c[v>>2]&1|0)!=0){Y=qQ(m,7)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}}U=M;V=N;W=qQ(m,3)|0;break};case 3:{Y=qQ(m,5)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}U=M;V=N;W=qQ(m,4)|0;break};case 7:{Y=c[q>>2]|0;X=a[Y]|0;if((X|0)==41){c[q>>2]=Y+1;U=M;V=N;W=0;break c}else if((X|0)!=124){U=M;V=N;W=0;break c}X=qQ(m,7)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=qQ(m,N)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=qQ(m,8)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=qQ(m,3)|0;if((X|0)!=0){R=M;S=X;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 1:{X=c[q>>2]|0;d:do{switch(a[X]|0){case 40:{if((c[v>>2]&1|0)!=0){$=X;T=74}break};case 91:{Y=X+1|0;c[q>>2]=Y;Q=aR(128)|0;if((Q|0)==0){Z=12;T=294;break b}if((a[Y]|0)==94){_=X+2|0;c[q>>2]=_;aa=_;ba=1}else{aa=Y;ba=0}Y=(ba|0)==0;_=Q;Q=0;ca=0;da=32;ea=aa;e:while(1){fa=a[ea]|0;if(fa<<24>>24==0){ga=_;ha=ea;ia=7;T=140;break}else if(fa<<24>>24==93){if(ea>>>0>(c[q>>2]|0)>>>0){T=85;break}}fa=eQ(e,ea,-1)|0;if((fa|0)<0){c[e>>2]=-1;ja=1}else{ja=fa}fa=ea+ja|0;do{if((a[fa]|0)==45){ka=ja+1|0;la=ea+ka|0;if((a[la]|0)==93){T=94;break}ma=c[e>>2]|0;na=eQ(e,la,-1)|0;if((na|0)<0){c[e>>2]=-1;oa=-1;pa=1}else{oa=c[e>>2]|0;pa=na}qa=0;ra=oa;sa=ma;ta=ea+(pa+ka)|0;ua=ma>>>0>oa>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;ma=a[ea]|0;do{if(ma<<24>>24==91){ka=a[ea+1|0]|0;if(ka<<24>>24==61|ka<<24>>24==46){ga=_;ha=ea;ia=3;T=140;break e}else if(!(ka<<24>>24==58)){va=0;break}ka=ea+2|0;na=ka;while(1){la=a[na]|0;wa=la<<24>>24==0;if(la<<24>>24!=58&(wa^1)){na=na+1|0}else{break}}if(wa){ga=_;ha=ea;ia=4;T=140;break e}la=na-ea+ -2|0;xa=(la|0)>63?63:la;PR(A|0,ka|0,xa|0)|0;a[f+xa|0]=0;xa=QP(A)|0;qa=xa;ra=1114111;sa=0;ta=na+2|0;ua=(xa|0)==0?4:0;break f}else if(ma<<24>>24==45){if((a[ea+1|0]|0)==93){va=0;break}va=(c[q>>2]|0)==(ea|0)?0:11}else{va=0}}while(0);ma=c[e>>2]|0;qa=0;ra=ma;sa=ma;ta=fa;ua=va}}while(0);if((ua|0)!=0){ga=_;ha=ta;ia=ua;T=140;break}fa=(qa|0)!=0;do{if(Y|fa^1){ma=c[w>>2]|0;if((ca|0)<(da|0)){ya=_;za=da}else{if((da|0)>1024){ga=_;ha=ta;ia=12;T=140;break e}xa=dR(_,da<<3)|0;if((xa|0)==0){ga=_;ha=ta;ia=12;T=140;break e}else{ya=xa;za=da<<1}}xa=AQ(ma,0,0,1,32)|0;if((xa|0)==0){T=112;break e}la=AQ(ma,0,0,1,20)|0;ma=xa+4|0;c[ma>>2]=la;if((la|0)==0){T=112;break e}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[la>>2]=sa;c[la+4>>2]=ra;c[la+8>>2]=-1;c[ya+(ca<<2)>>2]=xa;c[(c[ma>>2]|0)+12>>2]=qa;Aa=ya;Ba=Q;Ca=ca+1|0;Da=za;Ea=0}else{if((Q|0)>63){Aa=_;Ba=Q;Ca=ca;Da=da;Ea=12;break}c[g+(Q<<2)>>2]=qa;Aa=_;Ba=Q+1|0;Ca=ca;Da=da;Ea=0}}while(0);ma=(Ea|0)==0;if(ma&(((c[v>>2]&2|0)==0|fa)^1)){Fa=Aa;Ga=Ca;Ha=Da;Ia=sa}else{if(ma){_=Aa;Q=Ba;ca=Ca;da=Da;ea=ta;continue}else{ga=Aa;ha=ta;ia=Ea;T=140;break}}while(1){ma=Ia;while(1){if(ma>>>0>ra>>>0){_=Fa;Q=Ba;ca=Ga;da=Ha;ea=ta;continue e}if((TP(ma)|0)!=0){T=118;break}Ja=ma+1|0;if((XP(ma)|0)==0){ma=Ja}else{T=129;break}}if((T|0)==118){T=0;xa=ZP(ma)|0;la=ma+1|0;g:do{if((TP(la)|0)==0){Ka=xa;La=la}else{Ma=xa;Na=la;while(1){if((ZP(Na)|0)!=(Ma+1|0)|Na>>>0>ra>>>0){Ka=Ma;La=Na;break g}Oa=ZP(Na)|0;Pa=Na+1|0;if((TP(Pa)|0)==0){Ka=Oa;La=Pa;break}else{Ma=Oa;Na=Pa}}}}while(0);la=c[w>>2]|0;if((Ga|0)<(Ha|0)){Qa=Fa;Ra=Ha}else{if((Ha|0)>1024){ga=Fa;ha=ta;ia=12;T=140;break e}Na=dR(Fa,Ha<<3)|0;if((Na|0)==0){ga=Fa;ha=ta;ia=12;T=140;break e}else{Qa=Na;Ra=Ha<<1}}Na=AQ(la,0,0,1,32)|0;Ma=Na;do{if((Na|0)==0){Sa=0}else{na=AQ(la,0,0,1,20)|0;c[Na+4>>2]=na;if((na|0)==0){Sa=0;break}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[na>>2]=xa;c[na+4>>2]=Ka;c[na+8>>2]=-1;Sa=Ma}}while(0);c[Qa+(Ga<<2)>>2]=Sa;Ta=Sa;Ua=Qa;Va=Ra;Wa=La}else if((T|0)==129){T=0;Ma=$P(ma)|0;h:do{if((XP(Ja)|0)==0){Xa=Ma;Ya=Ja}else{xa=Ma;Na=Ja;while(1){if(($P(Na)|0)!=(xa+1|0)|Na>>>0>ra>>>0){Xa=xa;Ya=Na;break h}la=Na+1|0;na=$P(Na)|0;if((XP(la)|0)==0){Xa=na;Ya=la;break}else{xa=na;Na=la}}}}while(0);ma=c[w>>2]|0;if((Ga|0)<(Ha|0)){Za=Fa;_a=Ha}else{if((Ha|0)>1024){ga=Fa;ha=ta;ia=12;T=140;break e}Na=dR(Fa,Ha<<3)|0;if((Na|0)==0){ga=Fa;ha=ta;ia=12;T=140;break e}else{Za=Na;_a=Ha<<1}}Na=AQ(ma,0,0,1,32)|0;xa=Na;do{if((Na|0)==0){$a=0}else{la=AQ(ma,0,0,1,20)|0;c[Na+4>>2]=la;if((la|0)==0){$a=0;break}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[la>>2]=Ma;c[la+4>>2]=Xa;c[la+8>>2]=-1;$a=xa}}while(0);c[Za+(Ga<<2)>>2]=$a;Ta=$a;Ua=Za;Va=_a;Wa=Ya}if((Ta|0)==0){T=141;break e}else{Fa=Ua;Ga=Ga+1|0;Ha=Va;Ia=Wa}}}i:do{if((T|0)==85){T=0;c[q>>2]=ea+1;da=(ba|0)!=0;if(da){$b(_|0,ca|0,4,55)}j:do{if((ca|0)>0){Y=(Q|0)>0;fa=Q<<2;xa=fa+4|0;if(da){ab=0;bb=0;cb=0;db=0}else{Ma=0;Na=0;while(1){ma=_+(Ma<<2)|0;la=c[(c[ma>>2]|0)+4>>2]|0;do{if((la|0)==0){eb=Na;fb=0}else{c[la+8>>2]=c[x>>2];if(Y){na=AQ(c[w>>2]|0,0,0,0,xa)|0;ka=la+16|0;c[ka>>2]=na;if((na|0)==0){gb=_;hb=Na;ib=12;break i}GR(na|0,z|0,fa|0)|0;c[(c[ka>>2]|0)+(Q<<2)>>2]=0}else{c[la+16>>2]=0}if((Na|0)==0){eb=c[ma>>2]|0;fb=0;break}ka=c[w>>2]|0;na=c[ma>>2]|0;Pa=AQ(ka,0,0,1,32)|0;Oa=Pa;do{if((Pa|0)==0){jb=0}else{kb=AQ(ka,0,0,1,8)|0;lb=Pa+4|0;c[lb>>2]=kb;if((kb|0)==0){jb=0;break}c[Pa>>2]=3;c[Pa+8>>2]=-1;c[Pa+12>>2]=-1;c[kb>>2]=Na;c[(c[lb>>2]|0)+4>>2]=na;c[Pa+16>>2]=(c[na+16>>2]|0)+(c[Na+16>>2]|0);jb=Oa}}while(0);eb=jb;fb=(jb|0)==0?12:0}}while(0);ma=Ma+1|0;if((ma|0)<(ca|0)&(fb|0)==0){Ma=ma;Na=eb}else{mb=0;nb=eb;ob=fb;break j}}}while(1){Na=_+(cb<<2)|0;Ma=c[(c[Na>>2]|0)+4>>2]|0;ma=c[Ma>>2]|0;la=Ma+4|0;Oa=c[la>>2]|0;do{if((ma|0)<(ab|0)){na=Oa+1|0;pb=(na|0)<(ab|0)?ab:na;qb=bb;rb=db;sb=0}else{if((ma|0)<=(bb|0)){na=Oa+1|0;pb=na;qb=na;rb=db;sb=0;break}c[Ma>>2]=bb;c[la>>2]=ma+ -1;na=Oa+1|0;if((Ma|0)==0){pb=na;qb=na;rb=db;sb=0;break}c[Ma+8>>2]=c[x>>2];if(Y){Pa=AQ(c[w>>2]|0,0,0,0,xa)|0;ka=Ma+16|0;c[ka>>2]=Pa;if((Pa|0)==0){gb=_;hb=db;ib=12;break i}GR(Pa|0,z|0,fa|0)|0;c[(c[ka>>2]|0)+(Q<<2)>>2]=0}else{c[Ma+16>>2]=0}if((db|0)==0){pb=na;qb=na;rb=c[Na>>2]|0;sb=0;break}ka=c[w>>2]|0;Pa=c[Na>>2]|0;lb=AQ(ka,0,0,1,32)|0;kb=lb;do{if((lb|0)==0){tb=0}else{ub=AQ(ka,0,0,1,8)|0;vb=lb+4|0;c[vb>>2]=ub;if((ub|0)==0){tb=0;break}c[lb>>2]=3;c[lb+8>>2]=-1;c[lb+12>>2]=-1;c[ub>>2]=db;c[(c[vb>>2]|0)+4>>2]=Pa;c[lb+16>>2]=(c[Pa+16>>2]|0)+(c[db+16>>2]|0);tb=kb}}while(0);pb=na;qb=na;rb=tb;sb=(tb|0)==0?12:0}}while(0);Na=cb+1|0;if((Na|0)<(ca|0)&(sb|0)==0){ab=pb;bb=qb;cb=Na;db=rb}else{mb=qb;nb=rb;ob=sb;break}}}else{mb=0;nb=0;ob=0}}while(0);if((ob|0)!=0|da^1){gb=_;hb=nb;ib=ob;break}fa=c[w>>2]|0;xa=c[x>>2]|0;Y=AQ(fa,0,0,1,32)|0;Na=Y;if((Y|0)==0){gb=_;hb=nb;ib=12;break}Ma=AQ(fa,0,0,1,20)|0;c[Y+4>>2]=Ma;if((Ma|0)==0){gb=_;hb=nb;ib=12;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Ma>>2]=mb;c[Ma+4>>2]=1114111;c[Ma+8>>2]=xa;if((Q|0)>0){xa=Q<<2;fa=AQ(c[w>>2]|0,0,0,0,xa+4|0)|0;Oa=Ma+16|0;c[Oa>>2]=fa;if((fa|0)==0){gb=_;hb=nb;ib=12;break}GR(fa|0,z|0,xa|0)|0;c[(c[Oa>>2]|0)+(Q<<2)>>2]=0}else{c[Ma+16>>2]=0}if((nb|0)==0){gb=_;hb=Na;ib=0;break}Ma=c[w>>2]|0;Oa=AQ(Ma,0,0,1,32)|0;xa=Oa;do{if((Oa|0)==0){wb=0}else{fa=AQ(Ma,0,0,1,8)|0;ma=Oa+4|0;c[ma>>2]=fa;if((fa|0)==0){wb=0;break}c[Oa>>2]=3;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[fa>>2]=nb;c[(c[ma>>2]|0)+4>>2]=Na;c[Oa+16>>2]=(c[Y+16>>2]|0)+(c[nb+16>>2]|0);wb=xa}}while(0);gb=_;hb=wb;ib=(wb|0)==0?12:0}else if((T|0)==112){T=0;c[ya+(ca<<2)>>2]=0;ga=ya;ha=ta;ia=12;T=140}else if((T|0)==141){T=0;c[q>>2]=ta;gb=Ua;hb=0;ib=12}}while(0);if((T|0)==140){T=0;c[q>>2]=ha;gb=ga;hb=0;ib=ia}bR(gb);c[x>>2]=(c[x>>2]|0)+1;if((ib|0)==0){U=M;V=hb;W=0;break c}else{Z=ib;T=294;break b}break};case 94:{if((c[v>>2]&1|0)==0){if((X|0)!=(c[r>>2]|0)){break d}ca=qQ(m,5)|0;if((ca|0)!=0){R=M;S=ca;T=6;break b}}ca=c[w>>2]|0;_=AQ(ca,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}Q=AQ(ca,0,0,1,20)|0;c[_+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=1;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=_;W=0;break c;break};case 41:{if((M|0)!=0){T=264}break};case 36:{if((c[v>>2]&1|0)==0){if((a[X+1|0]|0)!=0){break d}}_=c[w>>2]|0;Q=AQ(_,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}ca=AQ(_,0,0,1,20)|0;c[Q+4>>2]=ca;if((ca|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[ca>>2]=-2;c[ca+4>>2]=2;c[ca+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Q;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 46:{Q=(c[v>>2]&4|0)==0;ca=c[w>>2]|0;_=c[x>>2]|0;ea=AQ(ca,0,0,1,32)|0;xa=ea;Y=(ea|0)==0;if(Q){if(Y){Z=12;T=294;break b}Q=AQ(ca,0,0,1,20)|0;c[ea+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Q>>2]=0;c[Q+4>>2]=1114111;c[Q+8>>2]=_;xb=xa;yb=(c[x>>2]|0)+1|0}else{if(Y){Z=12;T=294;break b}Y=AQ(ca,0,0,1,20)|0;c[ea+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Y>>2]=0;c[Y+4>>2]=9;c[Y+8>>2]=_;_=c[w>>2]|0;Y=(c[x>>2]|0)+1|0;ca=AQ(_,0,0,1,32)|0;if((ca|0)==0){Z=12;T=294;break b}Q=AQ(_,0,0,1,20)|0;c[ca+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[Q>>2]=11;c[Q+4>>2]=1114111;c[Q+8>>2]=Y;Y=c[w>>2]|0;Q=AQ(Y,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}_=AQ(Y,0,0,1,8)|0;Y=Q+4|0;c[Y>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[_>>2]=xa;c[(c[Y>>2]|0)+4>>2]=ca;c[Q+16>>2]=(c[ca+16>>2]|0)+(c[ea+16>>2]|0);xb=Q;yb=(c[x>>2]|0)+2|0}c[x>>2]=yb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=xb;W=0;break c;break};case 92:{Q=X+1|0;ea=a[Q]|0;do{if((c[v>>2]&1|0)==0){if(ea<<24>>24==40){c[q>>2]=Q;$=Q;T=74;break d}else{ca=a[X+1|0]|0;if(ca<<24>>24==41){T=265;break d}else{zb=ca;break}}}else{zb=ea}}while(0);ea=X+1|0;Q=zb<<24>>24==0;if(Q){Z=5;T=294;break b}else{Ab=104876|0;Bb=0}while(1){ca=Bb+1|0;if((a[104872+(Bb<<3)|0]|0)==zb<<24>>24){Cb=Ab;break}Y=104876+(ca<<3)|0;if((ca|0)==12){Cb=Y;break}else{Ab=Y;Bb=ca}}ca=c[Cb>>2]|0;if((ca|0)!=0){Y=F+0|0;xa=G+0|0;_=Y+40|0;do{c[Y>>2]=c[xa>>2];Y=Y+4|0;xa=xa+4|0}while((Y|0)<(_|0));c[H>>2]=ca;c[I>>2]=1;xa=jQ(j)|0;if((xa|0)!=0){Z=xa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(Q){Z=5;T=294;break b}c[q>>2]=ea;xa=a[ea]|0;k:do{switch(xa|0){case 60:{Y=c[w>>2]|0;_=AQ(Y,0,0,1,32)|0;Oa=_;do{if((_|0)==0){Db=0}else{Na=AQ(Y,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Db=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=16;c[Na+8>>2]=-1;Db=Oa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Eb=Db;break};case 62:{Oa=c[w>>2]|0;_=AQ(Oa,0,0,1,32)|0;Y=_;do{if((_|0)==0){Fb=0}else{Na=AQ(Oa,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Fb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=32;c[Na+8>>2]=-1;Fb=Y}}while(0);c[q>>2]=(c[q>>2]|0)+1;Eb=Fb;break};case 66:{Y=c[w>>2]|0;_=AQ(Y,0,0,1,32)|0;Oa=_;do{if((_|0)==0){Gb=0}else{Na=AQ(Y,0,0,1,20)|0;c[_+4>>2]=Na;if((Na|0)==0){Gb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Na>>2]=-2;c[Na+4>>2]=128;c[Na+8>>2]=-1;Gb=Oa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Eb=Gb;break};case 120:{Oa=X+2|0;c[q>>2]=Oa;_=a[Oa]|0;if(_<<24>>24==123){Oa=X+3|0;c[q>>2]=Oa;Y=Oa;Oa=0;while(1){Na=a[Y]|0;if(Na<<24>>24==0|Na<<24>>24==125){Hb=Oa;Ib=Y;break}if((YP(Na<<24>>24)|0)==0){Z=9;T=294;break b}Na=c[q>>2]|0;a[l+Oa|0]=a[Na]|0;Ma=Oa+1|0;da=Na+1|0;c[q>>2]=da;if(Ma>>>0>31){Hb=Ma;Ib=da;break}else{Y=da;Oa=Ma}}c[q>>2]=Ib+1;a[l+Hb|0]=0;Oa=Rb(C|0,0,16)|0;Y=c[w>>2]|0;Ma=c[x>>2]|0;da=AQ(Y,0,0,1,32)|0;Na=da;do{if((da|0)==0){Jb=0}else{ma=AQ(Y,0,0,1,20)|0;c[da+4>>2]=ma;if((ma|0)==0){Jb=0;break}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ma>>2]=Oa;c[ma+4>>2]=Oa;c[ma+8>>2]=Ma;Jb=Na}}while(0);c[x>>2]=(c[x>>2]|0)+1;Eb=Jb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Na=(YP(_<<24>>24)|0)==0;Ma=c[q>>2]|0;if(Na){Kb=Ma}else{a[D]=a[Ma]|0;Na=Ma+1|0;c[q>>2]=Na;Kb=Na}if((YP(a[Kb]|0)|0)!=0){Na=c[q>>2]|0;a[E]=a[Na]|0;c[q>>2]=Na+1}Na=Rb(D|0,0,16)|0;Ma=c[w>>2]|0;Oa=c[x>>2]|0;da=AQ(Ma,0,0,1,32)|0;Y=da;do{if((da|0)==0){Lb=0}else{ma=AQ(Ma,0,0,1,20)|0;c[da+4>>2]=ma;if((ma|0)==0){Lb=0;break}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ma>>2]=Na;c[ma+4>>2]=Na;c[ma+8>>2]=Oa;Lb=Y}}while(0);c[x>>2]=(c[x>>2]|0)+1;Eb=Lb;break k}break};case 98:{Y=c[w>>2]|0;Oa=AQ(Y,0,0,1,32)|0;Na=Oa;do{if((Oa|0)==0){Mb=0}else{da=AQ(Y,0,0,1,20)|0;c[Oa+4>>2]=da;if((da|0)==0){Mb=0;break}c[Oa>>2]=0;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[da>>2]=-2;c[da+4>>2]=64;c[da+8>>2]=-1;Mb=Na}}while(0);c[q>>2]=(c[q>>2]|0)+1;Eb=Mb;break};default:{if((RP(xa)|0)!=0){Na=(a[c[q>>2]|0]|0)+ -48|0;Oa=c[w>>2]|0;Y=c[x>>2]|0;da=AQ(Oa,0,0,1,32)|0;if((da|0)==0){Z=12;T=294;break b}Ma=AQ(Oa,0,0,1,20)|0;c[da+4>>2]=Ma;if((Ma|0)==0){Z=12;T=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Ma>>2]=-4;c[Ma+4>>2]=Na;c[Ma+8>>2]=Y;c[x>>2]=(c[x>>2]|0)+1;Y=c[B>>2]|0;c[B>>2]=(Na|0)<(Y|0)?Y:Na;c[q>>2]=(c[q>>2]|0)+1;U=M;V=da;W=0;break c}da=c[w>>2]|0;Na=a[c[q>>2]|0]|0;Y=c[x>>2]|0;Ma=AQ(da,0,0,1,32)|0;Oa=Ma;do{if((Ma|0)==0){Nb=0}else{_=AQ(da,0,0,1,20)|0;c[Ma+4>>2]=_;if((_|0)==0){Nb=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[_>>2]=Na;c[_+4>>2]=Na;c[_+8>>2]=Y;Nb=Oa}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Eb=Nb}}}while(0);if((Eb|0)==0){Z=12;T=294;break b}else{U=M;V=Eb;W=0;break c}break};default:{}}}while(0);if((T|0)==74){T=0;xa=M+1|0;c[q>>2]=$+1;ea=qQ(m,c[y>>2]|0)|0;if((ea|0)!=0){R=xa;S=ea;T=6;break b}ea=qQ(m,2)|0;if((ea|0)!=0){R=xa;S=ea;T=6;break b}ea=qQ(m,0)|0;if((ea|0)!=0){R=xa;S=ea;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=xa;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;xa=c[w>>2]|0;ea=AQ(xa,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}Q=AQ(xa,0,0,1,20)|0;c[ea+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;U=M;V=ea;W=0;break c}ea=eQ(h,X,-1)|0;if((ea|0)<0){c[h>>2]=-1;Ob=1}else{Ob=ea}do{if((c[v>>2]&2|0)==0){T=280}else{if((XP(c[h>>2]|0)|0)==0){if((TP(c[h>>2]|0)|0)==0){T=280;break}}ea=c[w>>2]|0;Q=ZP(c[h>>2]|0)|0;xa=ZP(c[h>>2]|0)|0;ca=c[x>>2]|0;Oa=AQ(ea,0,0,1,32)|0;if((Oa|0)==0){Z=12;T=294;break b}Y=AQ(ea,0,0,1,20)|0;c[Oa+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[Oa>>2]=0;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[Y>>2]=Q;c[Y+4>>2]=xa;c[Y+8>>2]=ca;ca=c[w>>2]|0;Y=$P(c[h>>2]|0)|0;xa=$P(c[h>>2]|0)|0;Q=c[x>>2]|0;ea=AQ(ca,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}Na=AQ(ca,0,0,1,20)|0;c[ea+4>>2]=Na;if((Na|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Na>>2]=Y;c[Na+4>>2]=xa;c[Na+8>>2]=Q;Q=c[w>>2]|0;Na=AQ(Q,0,0,1,32)|0;if((Na|0)==0){Z=12;T=294;break b}xa=AQ(Q,0,0,1,8)|0;Q=Na+4|0;c[Q>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[Na>>2]=3;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[xa>>2]=Oa;c[(c[Q>>2]|0)+4>>2]=ea;c[Na+16>>2]=(c[ea+16>>2]|0)+(c[Oa+16>>2]|0);Pb=Na}}while(0);if((T|0)==280){T=0;X=c[w>>2]|0;Na=c[h>>2]|0;Oa=c[x>>2]|0;ea=AQ(X,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}Q=AQ(X,0,0,1,20)|0;c[ea+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Q>>2]=Na;c[Q+4>>2]=Na;c[Q+8>>2]=Oa;Pb=ea}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Ob;U=M;V=Pb;W=0;break};case 2:{ea=L+ -2|0;c[n>>2]=ea;Oa=c[P+(ea<<2)>>2]|0;if((c[N+12>>2]|0)>-1){ea=c[w>>2]|0;Q=AQ(ea,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}Na=AQ(ea,0,0,1,20)|0;c[Q+4>>2]=Na;if((Na|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Na>>2]=-1;c[Na+4>>2]=-1;c[Na+8>>2]=-1;Na=c[w>>2]|0;ea=AQ(Na,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}X=AQ(Na,0,0,1,8)|0;Na=ea+4|0;c[Na>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[ea>>2]=1;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[X>>2]=Q;c[(c[Na>>2]|0)+4>>2]=N;Na=N+16|0;X=ea+16|0;c[X>>2]=(c[Na>>2]|0)+(c[Q+16>>2]|0);c[X>>2]=c[Na>>2];Qb=ea}else{Qb=N}c[Qb+12>>2]=Oa;Oa=Qb+16|0;c[Oa>>2]=(c[Oa>>2]|0)+1;U=M;V=Qb;W=0;break};case 5:{Oa=c[q>>2]|0;ea=a[Oa]|0;if(ea<<24>>24==0){U=M;V=N;W=0;break c}Na=c[v>>2]&1;X=(Na|0)!=0;if(X&ea<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(X&ea<<24>>24==41&(M|0)>0)){if((Na|0)==0&ea<<24>>24==92){if((a[Oa+1|0]|0)==41){break}}Q=qQ(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qQ(m,N)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=qQ(m,6)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=qQ(m,4)|0;break c}}while(0);ea=(Na|M|0)==0?8:0;X=M+ -1|0;if((Na|0)!=0){U=X;V=N;W=ea;break c}c[q>>2]=Oa+2;U=X;V=N;W=ea;break};case 10:{ea=L+ -2|0;c[n>>2]=ea;c[v>>2]=c[P+(ea<<2)>>2];U=M;V=N;W=0;break};case 8:{ea=L+ -2|0;c[n>>2]=ea;X=c[P+(ea<<2)>>2]|0;ea=c[w>>2]|0;Q=AQ(ea,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}xa=AQ(ea,0,0,1,8)|0;ea=Q+4|0;c[ea>>2]=xa;if((xa|0)==0){Z=12;T=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[xa>>2]=X;c[(c[ea>>2]|0)+4>>2]=N;c[Q+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=Q;W=0;break};case 9:{Q=c[q>>2]|0;X=a[Q]|0;switch(X<<24>>24|0){case 92:{ea=c[v>>2]|0;if((ea&1|0)!=0){U=M;V=N;W=0;break c}xa=Q+1|0;if((a[xa]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=xa;Sb=ea;Tb=xa;break};case 42:{T=41;break};case 123:{xa=c[v>>2]|0;if((xa&1|0)==0){U=M;V=N;W=0;break c}else{Sb=xa;Tb=Q}break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Q+1;Q=c[w>>2]|0;xa=AQ(Q,0,0,1,32)|0;if((xa|0)==0){Z=12;T=294;break b}ea=AQ(Q,0,0,1,16)|0;c[xa+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[xa>>2]=2;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[ea>>2]=N;c[ea+4>>2]=X<<24>>24==43;c[ea+8>>2]=X<<24>>24==63?1:-1;X=ea+12|0;a[X]=a[X]&-2;c[xa+16>>2]=c[N+16>>2];U=M;V=xa;W=qQ(m,9)|0;break c}xa=Tb+1|0;c[q>>2]=xa;X=a[xa]|0;if((X+ -48<<24>>24&255)<10){ea=X<<24>>24;if((ea+ -48|0)>>>0<10){Ub=ea;Vb=-1;Wb=xa}else{Z=10;T=294;break b}while(1){ea=((Vb|0)<0?-48:(Vb*10|0)+ -48|0)+Ub|0;Q=Wb+1|0;Y=a[Q]|0;ca=Y<<24>>24;if((ca+ -48|0)>>>0<10){Wb=Q;Vb=ea;Ub=ca}else{Xb=Y;Yb=ea;Zb=Q;break}}}else{Xb=X;Yb=-1;Zb=xa}do{if(Xb<<24>>24==44){Oa=Zb+1|0;Na=a[Oa]|0;Q=Na<<24>>24;if((Q+ -48|0)>>>0<10){_b=Q;ac=-1;bc=Oa}else{cc=Na;dc=-1;ec=Oa;break}while(1){Oa=((ac|0)<0?-48:(ac*10|0)+ -48|0)+_b|0;Na=bc+1|0;Q=a[Na]|0;ea=Q<<24>>24;if((ea+ -48|0)>>>0<10){bc=Na;ac=Oa;_b=ea}else{fc=Q;gc=Oa;hc=Na;T=54;break}}}else{fc=Xb;gc=Yb;hc=Zb;T=54}}while(0);do{if((T|0)==54){T=0;if(!((gc|0)>-1)){cc=fc;dc=gc;ec=hc;break}if((Yb|0)>(gc|0)|(gc|0)>255){Z=10;T=294;break b}else{cc=fc;dc=gc;ec=hc}}}while(0);if(cc<<24>>24==0){Z=9;T=294;break b}if((ec|0)==(xa|0)){Z=10;T=294;break b}if((Sb&1|0)==0){if(!(cc<<24>>24==92)){Z=10;T=294;break b}if((a[ec+1|0]|0)!=125){Z=10;T=294;break b}ic=ec+2|0}else{if(!(cc<<24>>24==125)){Z=10;T=294;break b}ic=ec+1|0}if((dc|Yb|0)==0){X=c[w>>2]|0;Na=AQ(X,0,0,1,32)|0;if((Na|0)==0){Z=12;T=294;break b}Oa=AQ(X,0,0,1,20)|0;c[Na+4>>2]=Oa;if((Oa|0)==0){Z=12;T=294;break b}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[Oa>>2]=-1;c[Oa+4>>2]=-1;c[Oa+8>>2]=-1;jc=Na}else{Na=(dc&Yb|0)<0;Oa=c[w>>2]|0;X=AQ(Oa,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Q=AQ(Oa,0,0,1,16)|0;c[X+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=Na?1:Yb;c[Q+8>>2]=Na?1:dc;Na=Q+12|0;a[Na]=a[Na]&-2;c[X+16>>2]=c[N+16>>2];jc=X}c[q>>2]=ic;U=M;V=jc;W=qQ(m,9)|0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{kc=O;lc=U;mc=V;nc=W;break a}}if((T|0)==6){kc=(S|0)==0;lc=R;mc=N;nc=S;break}else if((T|0)==294){i=d;return Z|0}}else{kc=t;lc=0;mc=0;nc=p}}while(0);p=(lc|0)>0;if(p|kc^1){Z=p?8:nc;i=d;return Z|0}c[b+8>>2]=mc;Z=0;i=d;return Z|0}function kQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=aR((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=aR((l<<2)+4|0)|0;if((p|0)==0){bR(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}qQ(d,e)|0;e=qQ(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 4:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=u+ -3|0;c[h>>2]=E;G=v;H=w;I=c[D+(E<<2)>>2]|0;J=y;K=z;L=A;M=0;N=(F|0)>-1?F:B;break};case 2:{F=A;while(1){if((c[F>>2]|0)>-1){F=F+4|0}else{G=v;H=w;I=x;J=y;K=z;L=F;M=0;N=B;break}}break};case 1:{F=u+ -2|0;c[h>>2]=F;E=c[D+(F<<2)>>2]|0;if(k){F=c[(c[c[E+4>>2]>>2]|0)+20>>2]|0;O=u+ -3|0;c[h>>2]=O;c[E+20>>2]=(c[D+(O<<2)>>2]|0)+F;G=v;H=-1;I=x;J=y;K=z;L=A;M=0;N=B;break b}else{F=u+ -3|0;c[h>>2]=F;O=c[D+(F<<2)>>2]|0;F=u+ -4|0;c[h>>2]=F;E=(O|0)==0;G=E&1;H=E?w:c[D+(F<<2)>>2]|0;I=x;J=y;K=z;L=A;M=0;N=B;break b}break};case 5:{F=u+ -2|0;c[h>>2]=F;E=c[D+(F<<2)>>2]|0;if(!k){G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break b}F=c[E+4>>2]|0;c[E+20>>2]=(c[(c[F+4>>2]|0)+20>>2]|0)+(c[(c[F>>2]|0)+20>>2]|0);G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 6:{F=u+ -2|0;c[h>>2]=F;E=c[D+(F<<2)>>2]|0;F=0;do{P=A+(F<<2)|0;F=F+1|0}while((c[P>>2]|0)>-1);c[P>>2]=E<<1|1;c[A+(F<<2)>>2]=-1;O=0;while(1){if((c[p+(O<<2)>>2]|0)>-1){O=O+1|0}else{break}}c[p+(O+ -1<<2)>>2]=-1;G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 3:{F=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;Q=c[D+(u+ -4<<2)>>2]|0;R=u+ -5|0;c[h>>2]=R;if(k){S=c[Q+4>>2]|0;T=Q+16|0;c[Q+20>>2]=(c[(c[S>>2]|0)+20>>2]|0)+(c[D+(R<<2)>>2]|0)+(c[(c[S+4>>2]|0)+20>>2]|0)+((c[T>>2]|0)>0?2:0);U=T;V=c[h>>2]|0}else{U=Q+16|0;V=R}R=c[D+(V+ -1<<2)>>2]|0;Q=V+ -2|0;c[h>>2]=Q;T=c[D+(Q<<2)>>2]|0;Q=V+ -3|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;if((c[U>>2]|0)<=0){G=1;H=w;I=x;J=y;K=z;L=R;M=0;N=B;break b}if(k){W=0}else{tQ(b,F,T)|0;c[(c[r>>2]|0)+(T<<2)>>2]=1;T=tQ(b,E,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;W=T}G=1;H=w;I=x;J=y;K=z+2|0;L=R;M=W;N=B;break};case 0:{R=u+ -2|0;c[h>>2]=R;T=c[D+(R<<2)>>2]|0;R=T;S=T+12|0;E=c[S>>2]|0;if((E|0)>-1){F=0;do{X=A+(F<<2)|0;F=F+1|0}while((c[X>>2]|0)>-1);c[X>>2]=E<<1;c[A+(F<<2)>>2]=-1;do{if(!k){O=0;while(1){if((c[p+(O<<2)>>2]|0)>-1){O=O+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((O|0)<=0){break}Q=aR((O<<2)+4|0)|0;Y=Q;if((Q|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=Q+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=qQ(d,c[S>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=qQ(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[T>>2]|0;do{if((E|0)==0){F=c[c[T+4>>2]>>2]|0;if(!((F|0)>-1|(F|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[T+20>>2]=1;ra=w;sa=y;ta=0}else{F=sQ(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;fa=0;while(1){ua=ea+(fa<<2)|0;va=fa+1|0;if((c[ua>>2]|0)>-1){fa=va}else{break}}c[ua>>2]=B;c[ea+(va<<2)>>2]=w;c[ea+(fa+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;Q=Y;Y=0;do{O=(Q|0)/2|0;if((Q&1|0)==0){c[da+(O*12|0)>>2]=B}else{c[da+(O*12|0)+4>>2]=B}Y=Y+1|0;Q=c[A+(Y<<2)>>2]|0;}while((Q|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=F}c[A>>2]=-1;ka=v;la=ra;ma=x+1|0;na=sa;oa=z+1|0;pa=ta;qa=x}else if((E|0)==1){Q=c[T+4>>2]|0;Y=c[Q>>2]|0;da=c[Q+4>>2]|0;Q=qQ(d,T)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=qQ(d,5)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=qQ(d,da)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=qQ(d,0)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=Y+20|0;fa=qQ(d,(c[Q>>2]|0)+x|0)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}if((c[Q>>2]|0)>0){Q=(c[da+20>>2]|0)>0;ya=(Q&1)+x|0;za=Q?x:-1}else{ya=x;za=-1}Q=qQ(d,za)|0;if((Q|0)!=0){ka=v;la=w;ma=ya;na=y;oa=z;pa=Q;qa=B;break}Q=qQ(d,4)|0;if((Q|0)!=0){ka=v;la=w;ma=ya;na=y;oa=z;pa=Q;qa=B;break}Q=qQ(d,Y)|0;if((Q|0)!=0){ka=v;la=w;ma=ya;na=y;oa=z;pa=Q;qa=B;break}ka=v;la=w;ma=ya;na=y;oa=z;pa=qQ(d,0)|0;qa=B}else if((E|0)==3){Q=c[T+4>>2]|0;Y=c[Q>>2]|0;da=c[Q+4>>2]|0;Q=(c[A>>2]|0)>-1;fa=x+1|0;ea=qQ(d,Q?fa:x)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qQ(d,Q?x:B)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qQ(d,A)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qQ(d,(c[A>>2]|0)>>>31^1)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=qQ(d,T)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=da;da=qQ(d,ea)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=Y;Y=qQ(d,da)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qQ(d,3)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qQ(d,ea)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qQ(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qQ(d,2)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qQ(d,da)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=qQ(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if((c[A>>2]|0)>-1){if(k){Aa=w;Ba=y;Ca=0}else{Y=sQ(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;ea=0;while(1){Da=da+(ea<<2)|0;Ea=ea+1|0;if((c[Da>>2]|0)>-1){ea=Ea}else{break}}c[Da>>2]=B;c[da+(Ea<<2)>>2]=w;c[da+(ea+2<<2)>>2]=-1;Fa=-1;Ga=y+1|0}else{Fa=w;Ga=y}F=c[A>>2]|0;if((F|0)>-1){Q=c[s>>2]|0;O=F;F=0;do{ia=(O|0)/2|0;if((O&1|0)==0){c[Q+(ia*12|0)>>2]=B}else{c[Q+(ia*12|0)+4>>2]=B}F=F+1|0;O=c[A+(F<<2)>>2]|0;}while((O|0)>-1)}c[A>>2]=-1;Aa=Fa;Ba=Ga;Ca=Y}c[A>>2]=-1;Ha=Aa;Ia=fa;Ja=Ba;Ka=z+1|0;La=Ca;Ma=x}else{Ha=w;Ia=x;Ja=y;Ka=z;La=0;Ma=B}if((c[T+16>>2]|0)<=0){ka=v;la=Ha;ma=Ia;na=Ja;oa=Ka;pa=La;qa=Ma;break}ka=v;la=Ha;ma=Ia+2|0;na=Ja;oa=Ka;pa=La;qa=Ia+1|0}else if((E|0)==2){O=c[T+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Na=1}else{Na=a[O+12|0]&1}F=qQ(d,Na)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}}else{F=qQ(d,B)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}F=qQ(d,a[O+12|0]&1)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}}F=qQ(d,T)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}F=qQ(d,1)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}F=qQ(d,c[O>>2]|0)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}F=qQ(d,0)|0;if((F|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=F;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[O+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){Oa=w;Pa=y;Qa=0}else{F=sQ(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[O+12|0]&1)==0?v:1;if((w|0)>-1){O=c[t>>2]|0;Q=0;while(1){Ra=O+(Q<<2)|0;Sa=Q+1|0;if((c[Ra>>2]|0)>-1){Q=Sa}else{break}}c[Ra>>2]=B;c[O+(Sa<<2)>>2]=w;c[O+(Q+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}fa=c[A>>2]|0;if((fa|0)>-1){Y=c[s>>2]|0;ea=fa;fa=0;do{da=(ea|0)/2|0;if((ea&1|0)==0){c[Y+(da*12|0)>>2]=B}else{c[Y+(da*12|0)+4>>2]=B}fa=fa+1|0;ea=c[A+(fa<<2)>>2]|0;}while((ea|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=F}c[A>>2]=-1;ka=0;la=Oa;ma=x+1|0;na=Pa;oa=z+1|0;pa=Qa;qa=x}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);R=c[S>>2]|0;if((R|0)>-1){Va=0}else{G=ka;H=la;I=ma;J=na;K=oa;L=A;M=pa;N=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=R;c[p+(Va<<2)>>2]=-1;G=ka;H=la;I=ma;J=na;K=oa;L=A;M=pa;N=qa;break};default:{G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(M|0)==0){u=D;v=G;w=H;x=I;y=J;z=K;A=L;B=N}else{Z=H;_=J;$=K;aa=L;ba=M;ca=N;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;N=e;e=0;do{M=(N|0)/2|0;if((N&1|0)==0){c[n+(M*12|0)>>2]=ca}else{c[n+(M*12|0)+4>>2]=ca}e=e+1|0;N=c[aa+(e<<2)>>2]|0;}while((N|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}N=c[f+36>>2]|0;e=0;while(1){Ya=N+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[N+(Za<<2)>>2]=Z;c[N+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;bR(m);bR(p);o=ba;i=g;return o|0}function lQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=nQ(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==3){h=c[g+4>>2]|0;j=lQ(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=nQ(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=lQ(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function mQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{bR(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}bR(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){bR(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){bR(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}bR(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{bR(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}bR(m)}m=c[d+32>>2]|0;if((m|0)!=0){bR(m)}m=c[d+20>>2]|0;if((m|0)!=0){bR(m)}m=c[d+36>>2]|0;if((m|0)!=0){bR(m)}bR(d);i=b;return}function nQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=aR(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){bR(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=aR((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function oQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=AQ(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=AQ(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=AQ(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function pQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=qQ(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==1){r=c[o+4>>2]|0;s=qQ(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=qQ(a,c[r+4>>2]|0)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=qQ(a,r)|0}else if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=qQ(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=qQ(a,s)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function qQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=dR(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;qQ(a,b)|0;i=d;return 0}return 0}function rQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;qQ(d,e)|0;e=qQ(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==3){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=AQ(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}H=AQ(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;I=qQ(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=qQ(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=qQ(d,F+4|0)|0;if((I|0)!=0){v=s;w=I;break a}I=qQ(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=qQ(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=F;M=qQ(d,0)|0}else if((z|0)==2){F=c[u+4>>2]|0;I=qQ(d,c[F>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=qQ(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=c[F>>2]|0;y=c[F+4>>2]|0;D=c[F+8>>2]|0;x=a[F+12|0]|0;F=AQ(b,0,0,1,32)|0;if((F|0)==0){G=40;break b}E=AQ(b,0,0,1,16)|0;H=F+4|0;c[H>>2]=E;if((E|0)==0){G=40;break b}c[F>>2]=2;c[F+8>>2]=-1;c[F+12>>2]=-1;c[E>>2]=I;c[E+4>>2]=y;c[E+8>>2]=D;D=E+12|0;a[D]=a[D]&-2|x&1;c[F+16>>2]=c[I+16>>2];c[t>>2]=F;A=s;B=r;t=c[H>>2]|0;s=A;r=B;continue b}else if((z|0)==0){H=c[u+4>>2]|0;F=c[H+8>>2]|0;I=c[H>>2]|0;x=c[H+4>>2]|0;do{if((I|0)>-1|(I|0)==-4){N=r;O=x;P=I;Q=s+1|0;R=(c[g>>2]|0)+F|0}else{if(!((I|0)==-3)){N=r;O=x;P=I;Q=s;R=F;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=x;P=-3;Q=s;R=F;break}c[h+(x<<2)>>2]=1;N=0;O=x;P=-3;Q=s;R=F}}while(0);F=AQ(b,0,0,1,32)|0;x=F;do{if((F|0)==0){S=0}else{I=AQ(b,0,0,1,20)|0;c[F+4>>2]=I;if((I|0)==0){S=0;break}c[F>>2]=0;c[F+8>>2]=-1;c[F+12>>2]=-1;c[I>>2]=P;c[I+4>>2]=O;c[I+8>>2]=R;S=x}}while(0);c[t>>2]=S;x=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=x;break}c[k>>2]=R;J=N;K=Q;L=t;M=x}else if((z|0)==1){x=c[u+4>>2]|0;F=c[x>>2]|0;I=x+4|0;H=c[I>>2]|0;D=AQ(b,0,0,1,32)|0;if((D|0)==0){G=29;break b}E=AQ(b,0,0,1,8)|0;y=D+4|0;c[y>>2]=E;if((E|0)==0){G=29;break b}c[D>>2]=1;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=F;c[(c[y>>2]|0)+4>>2]=H;c[D+16>>2]=(c[H+16>>2]|0)+(c[F+16>>2]|0);c[t>>2]=D;D=c[y>>2]|0;c[D>>2]=0;y=D+4|0;c[y>>2]=0;F=qQ(d,c[I>>2]|0)|0;if((F|0)!=0){v=s;w=F;break a}F=qQ(d,0)|0;if((F|0)!=0){v=s;w=F;break a}F=qQ(d,y)|0;if((F|0)!=0){v=s;w=F;break a}F=qQ(d,1)|0;if((F|0)!=0){v=s;w=F;break a}F=qQ(d,c[x>>2]|0)|0;if((F|0)!=0){v=s;w=F;break a}J=r;K=s;L=D;M=qQ(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function sQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=AQ(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=AQ(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=AQ(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=AQ(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function tQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=AQ(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=AQ(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=AQ(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=AQ(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function uQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function vQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=105120}else{j=b;k=105120;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((ER(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Ic(e|0,f|0,105408,g|0)|0)+1|0;i=d;return h|0}



function zo(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==-1){LE(28832,29064,80,49);C=29136;D=29144;yo(28832,29120,29128,C,C,C,C,C,D,D,80)|0;LE(28832,29152,80,47);D=29136;C=29144;yo(28832,29200,29208,D,29216,n,D,D,C,C,80)|0;LE(28832,29224,80,41);C=29136;D=29144;yo(28832,29272,29280,29216,C,C,C,C,D,D,80)|0;i=y;return 0}else if((A|0)==0){c[7194]=2;D=2;while(1){C=D+1|0;if(!((c[k+(D+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[7194]=C;if((C|0)<12){D=C}else{break}}if((c[d>>2]|0)<1){LE(28832,30528,80,25);D=29136;C=29144;yo(28832,30560,29312,D,29216,d,D,D,C,C,80)|0;break}c[7258]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{D=c[C>>2]|0;c[7258]=D;if(!((D+ -1|0)>>>0>4)){E=D;break}LE(28832,30568,80,34);D=29136;F=29144;yo(28832,30608,29304,D,29216,29032,D,D,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;D=fa(F,F)|0;c[7244]=D;c[7256]=D+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);D=q+12|0;if((c[k+16>>2]|0)==0){c[D>>2]=2;break}else{c[D>>2]=1;break}}else{D=c[q>>2]|0;do{if((D|0)>=0){F=c[d>>2]|0;if((D|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){LE(28832,31392,80,52);I=29136;J=29144;yo(28832,31376,31448,I,29216,G,I,I,J,J,80)|0;break a}c[7244]=fa((D<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[7256]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[7244]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[7256]=F+(c[7244]|0);break b}}}while(0);LE(28832,31320,80,52);D=29136;F=29144;yo(28832,31376,31384,D,29216,q,D,D,F,F,80)|0;break a}}while(0);c[7248]=(c[d>>2]|0)+20;c[q+64>>2]=c[7244];if((c[p>>2]|0)<(c[7256]|0)){LE(28832,30616,80,60);C=29136;F=29144;yo(28832,30680,30688,C,29312,29024,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[7248]|0)){LE(28832,30696,80,60);F=29136;C=29144;yo(28832,30680,30760,F,29312,28992,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){LE(28832,31504,80,24);C=29216;F=29136;D=29144;yo(28832,31536,31544,C,C,w,F,F,D,D,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[3619]=K;if(!(K<=0.0)){break}LE(28832,31e3,80,28);D=29136;yo(28832,29712,31032,D,D,D,D,29216,28952,29144,80)|0;break a}}while(0);c[q+60>>2]=0;D=q+36|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[n>>2]=1;B=27}else{B=210}}while(0);c:do{if((B|0)==27){a[29008]=0;K=+h[l>>3];h[3630]=K;L=+h[m>>3];h[3623]=L;r=c[d>>2]|0;c[7194]=1;do{if((r|0)>=1){p=k+4|0;E=0;A=1;M=L;N=K;while(1){if((c[p>>2]|0)==1){D=A+ -1|0;O=+h[l+(D<<3)>>3];h[3630]=O;P=+h[m+(D<<3)>>3];h[3623]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[29008]=1;S=1}else{S=E}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}D=A+1|0;c[7194]=D;if((A|0)<(r|0)){E=S;A=D;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}A=c[d>>2]|0;E=A+51|0;c[7204]=E;p=E+(c[w>>2]|0)|0;c[7206]=p;E=p+(c[w>>2]|0)|0;c[7228]=E;D=E+(c[w>>2]|0)|0;c[7198]=D;F=D+(c[d>>2]|0)|0;c[7234]=F;C=F+(c[d>>2]|0)|0;c[7240]=C;c[7230]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[7254]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[3632]=+h[F>>3];a[28944]=0;h[3601]=+h[o+24>>3];J=o+16|0;h[3596]=+h[J>>3];do{if((c[w>>2]|0)!=0){Ao(29312,v,w,d,28808,j,f,o+(D+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(A+50<<3)|0,o+(p+ -1<<3)|0,o+(E+ -1<<3)|0,x,28928,F,0,o,q,s,t)|0;if((c[7324]|0)>0){i=y;return 0}if((c[7232]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=29216;Xo(d,o+((c[7198]|0)+ -1<<3)|0,G,g,G)|0;a[28944]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[3596];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[3596]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[3596];if((M-N)*P>0.0){B=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[3631]=O;U=+h[3601];V=U-O;G=V*P>0.0;do{if(F){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[7240]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){Fo(28808,j,f,g,d,H,I,X)|0;if((c[7324]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[28944]=1;B=197;break d}}else{Y=28808;Fo(Y,Y,f,g,d,H,I,X)|0;if((c[7324]|0)>0){i=y;return 0}else{h[e>>3]=+h[3601];c[n>>2]=1;a[28944]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}Fo(28808,j,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[28944]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[3632]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[3596]=W;h[J>>3]=W;break}Fo(28808,29048,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[3631];a[28944]=1;B=197;break d}}else{W=+h[3601];if(!F){if(P*(W-N)<0.0){break}Fo(28808,j,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[28944]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[7240]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){Fo(28808,j,f,g,d,G,X,I)|0;if((c[7324]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[28944]=1;B=197;break d}}else{H=28808;Fo(H,H,f,g,d,G,X,I)|0;if((c[7324]|0)>0){i=y;return 0}else{h[e>>3]=+h[3601];c[n>>2]=1;a[28944]=1;B=197;break d}}}}while(0);if(a[28944]&1){B=197}else{B=128}}else{h[3601]=+h[e>>3];c[n>>2]=1;Co(d,k+4|0,l,m,f,o+((c[7234]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[7194]=1;e:do{if((F|0)>=1){J=c[7234]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[7194]=X;if((I|0)<(F|0)){I=X}else{break e}}LE(28832,31136,80,39);I=29136;J=29144;yo(28832,30808,31176,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+Jo(29288,1);h[3632]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[3632]*4.0*(aa>=ba?aa:ba);h[3621]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){LE(28832,31184,80,60);J=29136;yo(28832,30680,31248,J,J,J,J,29312,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[3600]=ca*.001;U=+Do(d,g,o+((c[7234]|0)+ -1<<3)|0,s,t);if(U>.5/+h[3600]){h[3600]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+KE(28800,z);h[3600]=U;da=U}else{U=+h[o+16>>3];h[3600]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}LE(28832,31088,80,29);J=29136;I=29144;yo(28832,31120,31128,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[3600]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[3631]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[3600]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{Eo(28808,f,g,d,b,u,28800,o+((c[7234]|0)+ -1<<3)|0,n,s,t,o+((c[7240]|0)+ -1<<3)|0,o+400|0,o+((c[7198]|0)+ -1<<3)|0,o+((c[7230]|0)+ -1<<3)|0,q,28968,F,k+36|0,29016)|0;if((c[7324]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[3600]}h[3596]=ja;h[o+16>>3]=ja;J=c[7240]|0;X=(c[d>>2]|0)+J|0;c[7250]=X;G=c[d>>2]|0;c[7194]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[3596]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[7194]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[3596];h[o+232>>3]=+h[3596]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}Ao(29216,v,w,d,e,j,f,o+((c[7198]|0)+ -1<<3)|0,o+((c[7240]|0)+ -1<<3)|0,J,Y,o+((c[7204]|0)+ -1<<3)|0,o+((c[7206]|0)+ -1<<3)|0,o+((c[7228]|0)+ -1<<3)|0,x,28928,F,0,o,q,s,t)|0;if((c[7324]|0)>0){i=y;return 0}if((c[7232]|0)!=0){LE(28832,31552,80,47);la=29136;ma=29144;yo(28832,29200,31600,29216,la,la,la,la,ma,ma,80)|0;LE(28832,31608,80,38);ma=29136;la=29144;yo(28832,29360,31600,29216,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}Ao(29304,v,w,d,28808,j,f,o+((c[7198]|0)+ -1<<3)|0,o+((c[7240]|0)+ -1<<3)|0,J,Y,o+((c[7204]|0)+ -1<<3)|0,o+((c[7206]|0)+ -1<<3)|0,o+((c[7228]|0)+ -1<<3)|0,x,28928,F,0,o,q,s,t)|0;if((c[7324]|0)>0){i=y;return 0}if((c[7232]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=29216;Xo(d,o+((c[7198]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){LE(28832,30928,80,54);E=29136;yo(28832,30984,30992,E,E,E,E,29312,29048,j,80)|0;break c}else if((B|0)==220){LE(28832,31040,80,34);E=29136;yo(28832,30608,31080,E,E,E,E,29312,j,e,80)|0;break c}else if((B|0)==224){LE(28832,31256,80,49);E=29136;yo(28832,29120,31312,E,E,E,E,29312,29048,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;Co(d,oa,l,m,o+((c[7240]|0)+ -1<<3)|0,o+((c[7234]|0)+ -1<<3)|0,s,t)|0;if((c[7324]|0)>0){B=233;break}E=c[d>>2]|0;c[7194]=1;p=c[7234]|0;if((E|0)>=1){A=1;while(1){C=A+1|0;if(!(+h[o+(A+ -2+p<<3)>>3]>0.0)){B=136;break f}c[7194]=C;if((A|0)<(E|0)){A=C}else{break}}}O=+Do(d,o+((c[7240]|0)+ -1<<3)|0,o+(p+ -1<<3)|0,s,t)*100.0;V=+h[3632];pa=O*V;h[3598]=pa;if(!(pa<=1.0)){B=138;break}O=+h[3601];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[3621]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[3596];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[3596]=V/O}}while(0);Go(28808,f,g,d,b,u,28768,o+((c[7234]|0)+ -1<<3)|0,k,n,s,t,o+((c[7240]|0)+ -1<<3)|0,o+400|0,o+((c[7198]|0)+ -1<<3)|0,o+((c[7230]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,28968,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,29016)|0;if((c[7324]|0)>0){B=233;break}p=c[n>>2]|0;if((p|0)<0){na=p;break}do{if((c[w>>2]|0)!=0){Ao(29304,v,w,d,28808,j,f,o+((c[7198]|0)+ -1<<3)|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[7204]|0)+ -1<<3)|0,o+((c[7206]|0)+ -1<<3)|0,o+((c[7228]|0)+ -1<<3)|0,x,28928,o+64|0,0,o,q,s,t)|0;if((c[7324]|0)>0){B=233;break f}if((c[7232]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];p=29216;Xo(d,o+((c[7198]|0)+ -1<<3)|0,p,g,p)|0;B=197;continue f}}while(0);p=(c[k+8>>2]|0)!=0;O=+h[3601];V=+h[3596];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!p){if(U<0.0){B=128;continue}Fo(28808,j,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}Fo(28808,j,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(p){if(U>=0.0){Fo(28808,j,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[3631];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[3632]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}Fo(28808,29048,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[3631];B=197;continue}if(!(U<0.0)){Fo(28808,j,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[3631];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[3632]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[3596]=U-O;B=128;continue}else{Fo(28808,29048,f,g,d,q+28|0,o+((c[7240]|0)+ -1<<3)|0,o+224|0)|0;if((c[7324]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[3631];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[3601];h[o+16>>3]=+h[3596];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[3598]*+h[m>>3];c[n>>2]=-2;na=-2;break}p=c[d>>2]|0;c[7194]=1;if((p|0)>=1){O=pa;A=1;E=0;while(1){F=l+(E<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(A+ -1<<3)|0;h[F>>3]=+h[3598]*+h[F>>3];if((A|0)>=(p|0)){break}F=A;O=+h[3598];A=A+1|0;E=F}c[7194]=p+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);E=0-na|0;c[7250]=E;switch(E|0){case 2:{LE(28832,29448,80,47);E=29136;yo(28832,29200,29496,E,E,E,E,29216,28808,29144,80)|0;LE(28832,29504,80,48);E=29136;A=29144;yo(28832,29432,29560,E,E,E,E,E,A,A,80)|0;LE(28832,29568,80,45);A=29136;E=29144;yo(28832,29616,29624,A,A,A,A,A,E,E,80)|0;break};case 3:{LE(28832,29632,80,38);E=29136;yo(28832,29360,29672,E,E,E,E,29216,28808,29144,80)|0;LE(28832,29680,80,28);E=29136;A=29144;yo(28832,29712,29720,E,E,E,E,E,A,A,80)|0;break};case 6:{LE(28832,29728,80,44);A=29136;yo(28832,29776,29784,A,A,A,A,29312,28808,28768,80)|0;LE(28832,29792,80,57);A=29136;E=29144;yo(28832,29856,29864,A,A,A,A,A,E,E,80)|0;break};case 7:{LE(28832,29728,80,44);E=29136;yo(28832,29776,29872,E,E,E,E,29312,28808,28768,80)|0;LE(28832,29880,80,48);E=29136;A=29144;yo(28832,29432,29936,E,E,E,E,E,A,A,80)|0;LE(28832,29944,80,28);A=29136;E=29144;yo(28832,29712,29976,A,A,A,A,A,E,E,80)|0;break};case 8:{LE(28832,29728,80,44);E=29136;yo(28832,29776,29984,E,E,E,E,29312,28808,28768,80)|0;LE(28832,29992,80,37);E=29136;A=29144;yo(28832,30032,30040,E,E,E,E,E,A,A,80)|0;break};case 9:{LE(28832,29728,80,44);A=29136;yo(28832,29776,30048,A,A,A,A,29312,28808,28768,80)|0;LE(28832,30056,80,49);A=29136;E=29144;yo(28832,29120,30112,A,A,A,A,A,E,E,80)|0;LE(28832,30120,80,38);E=29136;A=29144;yo(28832,29360,30160,E,E,E,E,E,A,A,80)|0;break};case 10:{LE(28832,29728,80,44);A=29136;yo(28832,29776,30168,A,A,A,A,29312,28808,28768,80)|0;LE(28832,30176,80,45);A=29136;E=29144;yo(28832,29616,30224,A,A,A,A,A,E,E,80)|0;LE(28832,30232,80,36);E=29136;A=29144;yo(28832,30272,30280,E,E,E,E,E,A,A,80)|0;break};case 11:{LE(28832,30288,80,40);A=29136;yo(28832,30336,30344,A,A,A,A,29312,28808,28768,80)|0;LE(28832,30352,80,36);A=29136;E=29144;yo(28832,30272,30392,A,A,A,A,A,E,E,80)|0;break};case 12:{LE(28832,29728,80,44);E=29136;yo(28832,29776,30400,E,E,E,E,29312,28808,28800,80)|0;LE(28832,30408,80,45);E=29136;A=29144;yo(28832,29616,30456,E,E,E,E,E,A,A,80)|0;break};case 5:case 4:{break};default:{LE(28832,29320,80,38);A=29136;yo(28832,29360,29368,A,A,A,A,29216,28808,29144,80)|0;LE(28832,29376,80,48);A=29136;E=29144;yo(28832,29432,29440,A,A,A,A,A,E,E,80)|0}}c[k>>2]=-1;h[e>>3]=+h[3601];h[o+24>>3]=+h[3601];h[o+16>>3]=+h[3596];i=y;return 0}else if((B|0)==215){LE(28832,30768,80,39);E=29136;A=29144;yo(28832,30808,30816,E,E,E,E,E,A,A,80)|0;break c}else if((B|0)==216){LE(28832,30824,80,39);A=29136;E=29144;yo(28832,30808,30864,A,A,A,A,A,E,E,80)|0;break c}}}while(0);LE(28832,30872,80,47);r=29136;E=29144;yo(28832,29200,30920,r,r,r,r,r,E,E,80)|0}else if((B|0)==210){LE(28832,30464,80,55);E=29136;r=29144;yo(28832,30520,29216,E,E,E,E,E,r,r,80)|0}}while(0);if((B|0)==227){LE(28832,31456,80,39);B=29136;yo(28832,30808,31496,B,B,B,B,29312,j,e,80)|0}if((c[k>>2]|0)==-1){LE(28832,31648,80,46);e=29136;j=29144;yo(28832,31696,31704,e,e,e,e,e,j,j,80)|0;LE(28832,31712,80,47);j=29136;e=29144;yo(28832,29200,31760,29216,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function Ao(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[3971]=C;c[t>>2]=0;D=c[e>>2]|0;c[7944]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[7944]|0;E=F+1|0;c[7944]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[3978]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;Fo(g,b,k,l,f,o,m,n)|0;if((c[7324]|0)>0){i=v;return 0}D=d;Ud[D&7](f,b,k,e,p,y,z)|0;if((c[7324]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[31832]=0;F=c[e>>2]|0;c[7944]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[31832]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[7944]=F+1;if(!M){break}I=+KE(31824,31768);h[3975]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[3971];do{if((H- +h[g>>3])*I<0.0){Fo(g,b,k,l,f,o,m,n)|0;if((c[7324]|0)<=0){break}i=v;return 0}else{G=+h[3975]/I;h[3976]=G;N=c[f>>2]|0;c[7944]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[3976];Q=Q+1|0}c[7944]=N+1}}while(0);Ud[D&7](f,b,k,e,p,y,z)|0;if((c[7324]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[31832]=0;F=c[e>>2]|0;c[7944]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[31832]=1;V=1;W=c[7944]|0}Q=W+1|0;c[7944]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[3971];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;Fo(g,F,k,l,f,o,m,n)|0;if((c[7324]|0)>0){i=v;return 0}E=d;Ud[E&7](f,F,k,e,p,y,z)|0;if((c[7324]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[31832]=0;D=c[e>>2]|0;c[7944]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[31832]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[7944]=D+1;if(!aa){i=v;return 0}I=+KE(31824,31768);h[3975]=I;h[F>>3]=I+ +h[F>>3];I=+h[3975]/+h[3971];h[3976]=I;Q=c[f>>2]|0;c[7944]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[3976];R=R+1|0}c[7944]=Q+1}Ud[E&7](f,F,k,e,p,y,z)|0;if((c[7324]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[31832]=0;R=c[e>>2]|0;c[7944]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[31832]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[7944]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[3974]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}Fo(g,31792,k,l,f,o,m,n)|0;if((c[7324]|0)<=0){break}i=v;return 0}else{h[3974]=Y;j=c[f>>2]|0;c[7944]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[7944]=j+1}}while(0);ga=d;Ud[ga&7](f,31792,k,e,q,y,z)|0;if((c[7324]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[7954]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){Bo(e,31824,31816,R,31792,p,q,r,31784,s,fa,da,x,ca)|0;if((c[7324]|0)>0){ha=76;break}if((c[7954]|0)>1){ha=73;break}Fo(g,31784,k,l,f,o,m,n)|0;if((c[7324]|0)>0){ha=76;break}Ud[ga&7](f,31784,k,e,r,y,z)|0;if((c[7324]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[3973];R=29216;Xo(e,r,R,p,R)|0;if((c[7954]|0)==4){i=v;return 0}Fo(g,31784,k,l,f,o,m,n)|0;if((c[7324]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function Bo(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[7970]=c[o>>2];c[o>>2]=0;h[3981]=0.0;a[31864]=0;t=c[b>>2]|0;c[7960]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+KE(31896,j+(v<<3)|0);if(w==+KE(31896,l+((c[7960]|0)+ -1<<3)|0)){break}y=c[7960]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[3981]){break}h[3981]=B;c[o>>2]=y}else{a[31864]=1}}while(0);v=c[7960]|0;u=v+1|0;c[7960]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[31872]=1;c[7972]=c[p>>2];h[g>>3]=+h[r>>3];t=29216;Xo(b,l,t,k,t)|0;c[p>>2]=1;a[31856]=0;C=0}else{a[31872]=0;c[o>>2]=c[7970];c[7972]=c[p>>2];if(a[31864]&1){h[g>>3]=+h[r>>3];t=29216;Xo(b,l,t,k,t)|0;a[31856]=1;C=1;break}else{t=29216;Xo(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[31856]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[31856]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=29216;Xo(b,k,t,l,t)|0;t=c[b>>2]|0;c[7960]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[7960]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+KE(31896,j+(u<<3)|0);if(!(A!=+KE(31896,k+((c[7960]|0)+ -1<<3)|0))){break}c[n+((c[7960]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[7960]|0;F=u+1|0;c[7960]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[3981]=0.0;a[31864]=0;t=c[b>>2]|0;c[7960]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+KE(31896,j+(v<<3)|0);if(A==+KE(31896,k+((c[7960]|0)+ -1<<3)|0)){break}y=c[7960]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[3981]){break}h[3981]=I;c[o>>2]=y}else{a[31864]=1}}while(0);v=c[7960]|0;u=v+1|0;c[7960]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[31872]=t&1;if(t){a[31856]=0;c[7972]=0;c[p>>2]=1;break}if(!(a[31864]&1)){t=29216;Xo(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=29216;Xo(b,k,t,l,t)|0;t=c[b>>2]|0;c[7960]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[7960]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[7960]|0}u=K+1|0;c[7960]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[7972]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function Co(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[3990]=+h[d>>3];h[3989]=+h[e>>3];j=c[a>>2]|0;c[7976]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[3990]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[3990]=o;h[3989]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[3989];a=l+1|0;c[7976]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function Do(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[3993]=0.0;e=c[a>>2]|0;c[7982]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[3993]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[7982]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[3992]=0.0;e=c[a>>2]|0;c[7982]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[3992]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[7982]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function Eo(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[8e3]=0;c[7998]=0;c[8004]=0;h[4005]=+h[b>>3];h[4007]=+Do(f,d,l,0,0);C=c[f>>2]|0;c[7988]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[7988]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[3998]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[7988]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[7988]=G+1}a[32048]=1;c[7990]=0;a[32064]=1;c[C>>2]=(c[C>>2]|0)+1;c[8008]=0;Ud[B&7](b,d,e,q,32032,n,o)|0;b:do{if((c[8008]|0)<0){K=35}else{while(1){if(a[32048]&1){c[E>>2]=(c[E>>2]|0)+1;a[32048]=0;Ho(f,b,d,e,q,31984,k,32008,l,r,s,t,g,32032,v,j,n,o,x)|0;h[3997]=1.0e6;if((c[8008]|0)<0|(c[8002]|0)!=0){K=35;break b}c[8004]=0}H=c[f>>2]|0;c[7988]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[7988]=H+1}Io(f,q,s,t)|0;I=c[f>>2]|0;c[7988]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[3998]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[7988]=I+1}N=+Do(f,q,l,0,0);h[4009]=N;if(N<=+h[v>>3]*100.0*+h[4007]){break}J=c[7990]|0;if((J|0)>0){h[z>>3]=N/+h[4010];h[A>>3]=1.0/+(J|0);O=+IE(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[3997]=P;Q=+h[4009];R=P}else{h[4010]=N;Q=N;R=+h[3997]}if(R*Q<=.33){break}J=c[7990]|0;H=J+1|0;c[7990]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[32048]=1}c[C>>2]=(c[C>>2]|0)+1;c[8008]=0;Ud[B&7](b,d,e,q,32032,n,o)|0;if((c[8008]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[7988]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[7988]=H+1}N=+Do(f,q,l,0,0);h[4009]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[7988]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[3998]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[7988]=J+1}}while(0);if(!(a[32064]&1)){break}H=c[f>>2]|0;c[7988]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[7988]=H+1}N=+Do(f,r,l,0,0);h[4003]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[32064]=0}h[b>>3]=+h[4005];G=c[f>>2]|0;c[7988]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[7988]=G+1}if(a[32064]&1){I=(c[8e3]|0)+1|0;c[8e3]=I;N=.9/(+h[4003]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[3996]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[8002]|0)!=0){I=(c[8004]|0)+1|0;c[8004]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[8008]|0)>-2)){K=53;break}I=(c[7998]|0)+1|0;c[7998]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function Fo(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[8034]=o;p=+h[b>>3]- +h[a>>3];h[4015]=p;a=c[f>>2]|0;c[8026]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[8026]=a+1;q=+h[4015]}h[4011]=1.0;h[4012]=0.0;p=q/+h[k>>3];h[4016]=p;c[8028]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[4012]=u*t+s/+h[a>>3];p=t*s;h[4011]=p;h[4016]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[8026]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[4012]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[4011];g=g+1|0}c[8026]=a+1}g=v+1|0;c[8028]=g;if((v|0)>=(o|0)){break}r=+h[4015];s=+h[4011];t=+h[4016];u=+h[4012];v=g}i=l;return 0}function Go(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[4038]=+h[b>>3];c[8054]=0;c[8062]=0;c[8056]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[4050]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[8050]=(c[I>>2]|0)+1;c[8052]=(c[I>>2]|0)+2;c[8048]=(c[I>>2]|0)+ -1;h[4038]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[8066]=$+1;$=c[8050]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[4041]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[8036]=2;if(($|0)>=2){Y=2;while(1){h[4042]=+h[y+(Y+ -2<<3)>>3];U=+h[4041];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[4042];U=+h[4042]+ +h[k>>3];h[4041]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[8036]=$+1}h[y+($+ -1<<3)>>3]=+h[4041]}h[4048]=0.0;h[4046]=0.0;Y=c[I>>2]|0;c[8036]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[4048]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[4046]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[8036]=Y+1;da=ea}h[4049]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[4048]- +h[4046];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[4023]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[4023]=ha>=ca?ha:ca;h[4041]=.6;h[4042]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[4049]){h[D>>3]=100.0}aa=c[8050]|0;ba=c[8066]|0;if((aa|0)>=(ba|0)){c[8038]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[8036]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[8036]=ba+1}ja=ia+1|0;c[8038]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[8036]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[8036]=ia+1}aa=c[8050]|0;c[8038]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[8036]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[8036]=$+1}la=ba+1|0;c[8038]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[4045]=+Do(f,d,l,0,0);a[32408]=1;c[8040]=0;c[T>>2]=(c[T>>2]|0)+1;c[8070]=0;Ud[m&7](b,d,e,r,32280,o,p)|0;if((c[8070]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;Ho(f,b,d,e,r,A,k,32232,l,s,t,u,g,32280,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[8070]|0)<0|(c[8058]|0)!=0){X=70;break}c[8062]=0}ba=c[f>>2]|0;c[8036]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8036]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[4041]=ca;aa=c[f>>2]|0;c[8036]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[4041];ia=ia+1|0;la=ka}c[8036]=aa+1}Io(f,r,t,u)|0;la=c[f>>2]|0;c[8036]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[8036]=la+1}U=+Do(f,r,l,0,0);h[4050]=U;if(U<=+h[F>>3]*100.0*+h[4045]){X=63;break a}ia=c[8040]|0;if((ia|0)>0){h[O>>3]=U/+h[4052];h[P>>3]=1.0/+(ia|0);ca=+IE(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[4050];oa=ga}else{h[4052]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[8040]|0;c[8040]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[8070]=0;Ud[m&7](b,d,e,r,32280,o,p)|0;if((c[8070]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[8036]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[8036]=ba+1}U=+Do(f,r,l,0,0);h[4050]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[8036]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[8036]=ia+1}}while(0);if((X|0)==70){X=0;a[32408]=0}c[H>>2]=1;if(a[32408]&1){U=+Do(f,s,l,0,0);h[4044]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[4030]=ga;h[4037]=ga*+(ba+1|0);h[4032]=ga;c[8072]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[8036]=1;if((ba|0)>=1){aa=fa(c[8050]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[8036]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+Do(f,r,l,0,0);h[4039]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[4047]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[8036]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[8036]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+Do(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[4047];if((sa>=ca?sa:ca)>+h[4037]){break}ta=+h[4039];ua=Y}else{if(!(ga<=+h[4037]*.5)){break}else{ta=U;ua=ka}}c[8072]=ua+ -1;h[4032]=ta}}while(0);if(!(+h[4023]*+h[4044]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[4038];Y=c[8050]|0;ia=c[8066]|0;if((Y|0)>=(ia|0)){c[8038]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[4041]=ca;ia=c[f>>2]|0;c[8036]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[4041];ja=ja+1|0}c[8036]=ia+1}ja=aa+1|0;c[8038]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[8036]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[8036]=Y+1}if(!(a[32408]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[8058]|0)!=0){aa=(c[8062]|0)+1|0;c[8062]=aa;h[4021]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[8070]|0)>-2)){X=146;break}aa=(c[8054]|0)+1|0;c[8054]=aa;h[4021]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[8056]=(c[8056]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[8056]|0;if((aa|0)<=1){ja=c[8072]|0;c[I>>2]=ja;sa=+(ja+1|0);h[4042]=sa;h[O>>3]=+h[4032]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+IE(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[4021]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[8072];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[8086]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[8072]|0;E=c[8048]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[8050];za=+h[k>>3]*2.0;h[4034]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[8048]|0;Ba=c[8072]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[8050]|0)>=(c[K>>2]|0)|(c[8086]|0)==1){Fa=G;break}G=c[f>>2]|0;c[8036]=1;if((G|0)>=1){E=fa(c[8052]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[8036]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+Do(f,r,l,0,0);h[4040]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[4037];E=xa<=za;if(+h[4047]<=(E?xa:za)){Ea=c[8048]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[4037]*.5){Fa=S;break}}S=c[8050]|0;c[I>>2]=S;h[4032]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[4032]=+h[4039];Fa=Ea}h[4034]=+h[k>>3];ya=+(Fa+1|0);h[4042]=ya;h[O>>3]=+h[4032]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+IE(O,P);h[4021]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[4034];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[4021]=xa;za=+h[k>>3]*xa;h[4034]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[4034]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[8036]=1;if((k|0)<1){break}u=fa(c[8052]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[8036]=k+1}}while(0);Ca=c[f>>2]|0;c[8036]=1;if((Ca|0)>=1){J=fa(c[8050]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[8036]=Ca+1}Ca=c[8050]|0;c[8044]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[8038]=P;s=c[f>>2]|0;c[8036]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[8036]=s+1}P=Ha+1|0;c[8044]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[8070]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[8056]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}Fo(b,b,d,e,f,I,q,y)|0;i=N;return 0}function Ho(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[8132]=R;S=c[b>>2]|0;c[8122]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[8140]=R+S;c[8126]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[8136]=Q+1;R=c[x>>2]|0;c[8134]=R+ -1;c[8144]=R+Q;c[s>>2]=0;h[4065]=+V(+(+h[t>>3]));Q=c[8122]|0;c[8108]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[8132]|0;c[8114]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[8110]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[8134]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[8144]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[4062]=+h[4065]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+KE(32496,N);h[4062]=da;ca=c[8114]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[4062]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[4062]+ +h[ba>>3];ba=ca+W|0;c[8114]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[8132]|0;Z=c[8108]|0;_=ba}}}while(0);Ud[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[8132]|0;W=c[8108]|0;c[8114]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[8110]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[8134]|0)+ca<<3)>>3];ja=+h[p+((c[8144]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[4062]=+h[4065]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+KE(32496,N);h[4062]=ha;ca=c[8114]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[4062]=da;ja=1.0/da;h[4071]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[8116]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[8118]=oa;pa=fa(c[8126]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[8120]=qa;c[8106]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[4071];na=na+1|0}c[8106]=aa+1}na=ca+X|0;c[8114]=na;oa=c[8108]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[8132]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[8108]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[8128]=0;h[4065]=+V(+(+h[t>>3]));S=c[b>>2]|0;c[8106]=1;d:do{if((S|0)>=1){Q=r;P=1;while(1){R=P+ -1|0;da=+h[e+(R<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}W=f+(R<<3)|0;da=+h[l>>3]*+h[W>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(R<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[4062]=+h[4065]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[W>>3];da=+KE(32496,N);h[4062]=da;W=(c[8106]|0)+ -1|0;R=e+(W<<3)|0;ja=+h[R>>3];ha=da+ja-ja;h[4062]=ha;h[4069]=+h[R>>3];U=f+(W<<3)|0;h[4073]=+h[U>>3];h[R>>3]=ha+ +h[R>>3];h[U>>3]=+h[j>>3]*+h[4062]+ +h[U>>3];Ud[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[4062];h[4071]=ha;U=c[b>>2]|0;c[8112]=1;R=c[8128]|0;if((U|0)>=1){ja=ha;W=1;_=0;while(1){h[p+(_+R<<3)>>3]=(+h[o+(_<<3)>>3]- +h[g+(_<<3)>>3])*ja;if((W|0)>=(U|0)){break}X=W;ja=+h[4071];W=W+1|0;_=X}c[8112]=U+1}c[8128]=R+(c[b>>2]|0);_=c[8106]|0;W=_+ -1|0;h[e+(W<<3)>>3]=+h[4069];h[f+(W<<3)>>3]=+h[4073];P=_+1|0;c[8106]=P;if((_|0)>=(S|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[8128]=0;S=c[b>>2]|0;if((c[18928>>2]|0)==0){T=42;break}P=aR(S*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Rm(14,1,32592,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Rm(14,0,32616,E);Rm(14,1,32624,D);c[8110]=0;if((c[b>>2]|0)>0){Q=0;do{ja=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;_=C+4|0;h[k>>3]=ja;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];Rm(14,0,32632,C);Q=(c[8110]|0)+1|0;c[8110]=Q;}while((Q|0)<(c[b>>2]|0))}Yd[c[4856]&255](14);Rm(14,1,32688,B);c[8106]=1;if((S|0)>=1){Q=P+1|0;_=c[8128]|0;W=1;do{X=p+(W+ -1+_<<3)|0;h[X>>3]=+h[j>>3]+ +h[X>>3];a[P]=0;a[Q]=0;c[8112]=1;X=_;ba=0;while(1){ja=+h[p+(ba+X<<3)>>3];c[A>>2]=P;Y=A+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];ec(P|0,32672,A|0)|0;Y=c[8112]|0;c[8112]=Y+1;if((Y|0)>=(S|0)){break}X=c[8128]|0;ba=Y}c[z>>2]=P;Rm(14,0,32680,z);ba=c[8128]|0;X=c[8106]|0;Y=p+(ba+ -1+X<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];_=ba+(c[b>>2]|0)|0;c[8128]=_;W=X+1|0;c[8106]=W;}while((X|0)<(S|0))}Yd[c[4856]&255](14);Yd[c[4856]&255](14);bR(P);T=42}else if((O|0)==4){S=c[q>>2]|0;W=q+4|0;_=c[W>>2]|0;Q=c[b>>2]|0;X=fa(_+1+(S<<1)|0,Q)|0;c[8106]=1;if((X|0)>=1){ba=fa(Q,_+(S<<1)+1|0)|0;S=(ba|0)<1;_=1;while(1){h[p+(_+ -1<<3)>>3]=0.0;if((_|0)<(X|0)){_=_+1|0}else{break}}c[8106]=S?2:ba+1|0}_d[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[8140]=(c[W>>2]|0)+1+(c[q>>2]<<1);T=75}else if((O|0)==3){i=y;return 0}else{_=c[b>>2]|0;X=fa(_,_)|0;c[8106]=1;if((X|0)!=0){_=(X|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(X|0)){P=P+1|0}else{break}}c[8106]=_?2:X+1|0}_d[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[8128]=0;P=c[b>>2]|0;if((c[18928>>2]|0)==0){T=42;break}W=aR(P*20|0)|0;ba=M;h[k>>3]=+h[d>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];Rm(14,1,32592,M);ba=L;h[k>>3]=+h[j>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];Rm(14,0,32616,L);Rm(14,1,32624,K);c[8110]=0;if((c[b>>2]|0)>0){ba=0;do{ja=+h[e+(ba<<3)>>3];c[J>>2]=ba+1;S=J+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];Rm(14,0,32632,J);ba=(c[8110]|0)+1|0;c[8110]=ba;}while((ba|0)<(c[b>>2]|0))}Yd[c[4856]&255](14);Rm(14,1,32648,I);c[8106]=1;if((P|0)>=1){ba=W+1|0;X=c[8128]|0;_=1;do{S=p+(_+ -1+X<<3)|0;h[S>>3]=+h[j>>3]+ +h[S>>3];a[W]=0;a[ba]=0;c[8112]=1;S=X;Q=0;while(1){ja=+h[p+(Q+S<<3)>>3];c[H>>2]=W;Y=H+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];ec(W|0,32672,H|0)|0;Y=c[8112]|0;c[8112]=Y+1;if((Y|0)>=(P|0)){break}S=c[8128]|0;Q=Y}c[G>>2]=W;Rm(14,0,32680,G);Q=c[8128]|0;S=c[8106]|0;Y=p+(Q+ -1+S<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];X=Q+(c[b>>2]|0)|0;c[8128]=X;_=S+1|0;c[8106]=_;}while((S|0)<(P|0))}Yd[c[4856]&255](14);Yd[c[4856]&255](14);bR(W);T=42}}while(0);if((T|0)==42){Po(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){Vo(p,32560,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function Io(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[8178]=(c[g>>2]|0)+1+(c[e>>2]<<1);Wo(d,32712,a,e,g,e+80|0,b,32720)|0;i=f;return 0}else{To(d,a,a,e+80|0,b,32720)|0;i=f;return 0}return 0}function Jo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[32728]&1)){a[32728]=1;Ko(32776,32744,32824,32760,32808,32832,32816,32840)|0;h[4096]=+(c[8194]|0);f=c[8186]|0;h[4092]=+(f|0);if((c[8206]|0)==0){h[4094]=0.0;c[e>>2]=1-f;g=+JE(32768,e)}else{h[4094]=1.0;c[e>>2]=1-f;g=+JE(32768,e)*.5}h[4095]=g;h[4099]=g*+h[4096];h[4098]=+(c[8202]|0);h[4100]=+(c[8204]|0);j=+h[4104];h[4107]=j;k=1.0/+h[4105];if(!(k>=j)){break}h[4107]=k*(g+1.0)}}while(0);if((Yo(b,32864,1,1)|0)!=0){g=+h[4095];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32872,1,1)|0)!=0){g=+h[4107];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32880,1,1)|0)!=0){g=+h[4096];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32888,1,1)|0)!=0){g=+h[4099];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32896,1,1)|0)!=0){g=+h[4092];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32904,1,1)|0)!=0){g=+h[4094];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32912,1,1)|0)!=0){g=+h[4098];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32920,1,1)|0)!=0){g=+h[4104];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32928,1,1)|0)!=0){g=+h[4100];h[4106]=g;l=g;i=d;return+l}if((Yo(b,32936,1,1)|0)==0){l=+h[4106];i=d;return+l}else{g=+h[4105];h[4106]=g;l=g;i=d;return+l}return 0.0}function Ko(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[33048]&1){q=33416;r=c[8354]|0;c[b>>2]=r;s=33352;t=c[8338]|0;c[d>>2]=t;u=33392;v=c[8348]|0;c[e>>2]=v;w=33400;x=+h[4175];h[f>>3]=x;y=33432;z=c[8358]|0;c[g>>2]=z;A=33480;B=+h[4185];h[j>>3]=B;C=33440;D=c[8360]|0;c[k>>2]=D;E=33488;F=+h[4186];h[l>>3]=F;i=m;return 0}a[33048]=1;h[4176]=0.0;h[4170]=1.0;h[4171]=2.0;Lo(33416,33352,33392,33504)|0;h[4166]=+(c[8354]|0);c[n>>2]=0-(c[8338]|0);G=+JE(33328,n);h[4165]=G;h[4175]=G;H=+h[4171];h[4166]=H/3.0;I=+h[4170];J=I*.5;h[4173]=J;K=-J;h[o>>3]=K;h[4187]=+Mo(33328,o);L=33496;h[4184]=+Mo(L,L);h[o>>3]=K;h[4166]=+Mo(33472,o);K=+Mo(33328,33496);h[4166]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[4166]=K;h[4175]=1.0;M=+h[4176];if(K<1.0&K>M){N=K;while(1){h[4175]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+Mo(o,p);h[4167]=K;h[o>>3]=-K;h[4167]=+Mo(33384,o);K=+Mo(33384,33336);h[4166]=K;h[o>>3]=-K;h[4167]=+Mo(33384,o);K=+Mo(33384,33336);h[4166]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[4175]=G}G=I/+(c[8354]|0);h[4178]=G;h[4182]=I;c[8336]=1;p=1;O=I;do{h[o>>3]=O*G;O=+Mo(o,33408);h[4182]=O;p=p+1|0;c[8336]=p;}while((p|0)<4);h[4165]=+Mo(33360,33456);No(33520,33360,33416)|0;h[o>>3]=-+h[4170];No(33512,o,33416)|0;No(33464,33320,33416)|0;h[o>>3]=-+h[4165];No(33448,o,33416)|0;c[8344]=0;p=c[8380]|0;L=c[8378]|0;P=c[8366]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[8362]|0)){if(Q){c[8358]=p;R=0;S=25;break}if((P-p|0)==3){c[8358]=p+ -1+(c[8338]|0);c[8344]=1;R=1;S=25;break}else{c[8358]=(p|0)<=(P|0)?p:P;a[33056]=1;S=26;break}}else{T=Q&(L|0)==(c[8362]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[8358]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[8358]=(p|0)<=(L|0)?p:L;a[33056]=1;S=26;break}}T=c[8362]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[8358]=(V|0)<=(T|0)?V:T;a[33056]=1;S=26;break}if((P-U|0)==3){c[8358]=((p|0)>=(L|0)?p:L)+ -1+(c[8338]|0);R=0;S=25;break}else{c[8358]=U;a[33056]=1;S=26;break}}}while(0);if((S|0)==25){if(a[33056]&1){S=26}else{W=R}}if((S|0)==26){a[33048]=0;FF(33528)|0;WE(33552,33432,4)|0;nF()|0;W=c[8344]|0}if((W|0)==0){X=(c[8376]|0)!=0|0}else{X=1}c[8344]=X;h[4185]=1.0;X=c[8358]|0;W=1-X|0;c[n>>2]=W;c[8336]=1;if((X|0)<=0){O=+h[4178];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+Mo(o,33408);h[4185]=I;n=X+1|0;c[8336]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}Oo(33416,33352,33432,33376,33440,33488)|0;q=33416;r=c[8354]|0;c[b>>2]=r;s=33352;t=c[8338]|0;c[d>>2]=t;u=33392;v=c[8348]|0;c[e>>2]=v;w=33400;x=+h[4175];h[f>>3]=x;y=33432;z=c[8358]|0;c[g>>2]=z;A=33480;B=+h[4185];h[j>>3]=B;C=33440;D=c[8360]|0;c[k>>2]=D;E=33488;F=+h[4186];h[l>>3]=F;i=m;return 0}function Lo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[32944]&1){l=a[33016]&1;m=c[8256]|0;c[b>>2]=m;n=32992;o=c[8248]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=33040;r=c[8260]|0;c[f>>2]=r;i=g;return 0}a[32944]=1;h[4125]=1.0;h[4119]=1.0;h[4121]=1.0;s=1.0;do{s=s*2.0;h[4119]=s;h[4121]=+Mo(32952,33e3);h[j>>3]=-s;t=+Mo(32968,j);h[4121]=t;}while(t==1.0);h[4120]=1.0;t=+Mo(32952,32960);h[4121]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[4120]=v;w=+Mo(32952,32960);h[4121]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[4126]=.25;h[4129]=x;h[j>>3]=-s;t=+Mo(32968,j);h[4121]=t;y=~~(t+.25);c[8256]=y;t=+(y|0);h[4120]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[4122]=+Mo(j,k);w=+Mo(32976,32952);h[4121]=w;z=w==s;a[33016]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[4122]=+Mo(j,k);w=+Mo(32976,32952);h[4121]=w;if(z&w==s){a[33016]=0;A=0}else{A=z}h[j>>3]=u;w=+Mo(j,32952);h[4123]=w;h[j>>3]=u;z=w==s&+Mo(j,33032)>x;c[8260]=z?A&1:0;c[8248]=0;h[4119]=1.0;h[4121]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[8248]=k;s=x*t;h[4119]=s;h[4121]=+Mo(32952,33e3);h[j>>3]=-s;w=+Mo(32968,j);h[4121]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=32992;o=c[8248]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=33040;r=c[8260]|0;c[f>>2]=r;i=g;return 0}function Mo(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function No(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[4195]=g;j=1.0/+(c[d>>2]|0);h[4204]=j;h[4203]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+Mo(f,33624);h[4197]=k;h[4199]=g;h[4200]=g;h[4201]=g;h[4202]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[4195]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+Mo(f,33624);h[4197]=g;h[f>>3]=g*k;k=+Mo(f,33624);h[4199]=k;h[4201]=0.0;c[8392]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[4201]=q;c[8392]=b+1;n=q}h[f>>3]=m*j;p=+Mo(f,33624);h[4198]=p;h[f>>3]=p/j;r=+Mo(f,33624);h[4200]=r;h[4202]=0.0;o=c[d>>2]|0;c[8392]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[4202]=v;c[8392]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function Oo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[8416]=1;c[8424]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[8416]=q;r=l+1|0;c[8424]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[8420]=n;u=n}else{c[8420]=m;c[8424]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[8426]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[8424]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[4211]=x;y=w+-1.0;h[4207]=y;h[4206]=0.0;v=c[b>>2]|0;c[8410]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[4207]=B;if(w<1.0){h[4209]=w}C=+Mo(33648,33656);h[4206]=C;e=b+1|0;c[8410]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[4209];h[4206]=A;z=A}}while(0);v=c[f>>2]|0;c[8410]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+Mo(k,33712);h[4206]=z;f=E+1|0;c[8410]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function Po(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[8432]=1;m=1;do{c[8438]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=Qo(j,a+(m+b+(fa(m,l)|0)<<3)|0,33760)|0;q=c[8432]|0;r=p+ -1+q|0;c[8434]=r;c[e+(q+ -1<<2)>>2]=r;r=c[8434]|0;q=c[8432]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[4218]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[4218];t=q}u=fa(t,l)|0;h[4218]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;Ro(j,33744,a+(t-l+u<<3)|0,33760)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[8438]|0;c[8430]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[8434]|0;x=fa(w,l)|0;h[4218]=+h[a+(x+b+v<<3)>>3];y=c[8432]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[4218];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=33760;So(k,33744,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[8430]|0;w=A+1|0;c[8430]=w;}while((A|0)<(u|0))}}while(0);q=c[8432]|0;m=q+1|0;c[8432]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function Qo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[8530]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[4266]=k;l=(c[d>>2]|0)+1|0;c[8530]=l;m=c[a>>2]|0;c[8528]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[4266]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[8530]=l;a=n+1|0;c[8528]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[4266]=v;c[8528]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[4266]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[8528]=f+1;g=C;i=e;return g|0}function Ro(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[8514]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[8514]=l;i=f;return 0}l=(g|0)%5|0;c[8516]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[8514]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[8514]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[8514]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[8514]=o;i=f;return 0}function So(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[8500]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[8498]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[8498]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[8498]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[8498]=s;i=j;return 0}}while(0);c[8502]=1;c[8504]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[8502]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[8504]=s;u=s}else{u=1}s=c[a>>2]|0;c[8498]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[8502]=t;u=x+(c[g>>2]|0)|0;c[8504]=u;a=w+1|0;c[8498]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function To(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[8450]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[8442]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[8444]=o;p=f+(o+ -1<<3)|0;h[4223]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[4223]}c[k>>2]=(c[d>>2]|0)-m;o=33760;So(k,33784,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[8442]|0;m=o+1|0;c[8442]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[8448]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[8442]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[4223]=-s;c[k>>2]=g;g=33760;So(k,33784,a+(p-l<<3)|0,g,f,g)|0;g=c[8448]|0;q=g+1|0;c[8448]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[8442]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=33760;s=+Uo(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[4223]=s;q=c[8442]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[8442]=n;}while((q|0)<(m|0));t=c[8450]|0}if((t|0)<1){i=j;return 0}c[8448]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[8442]=n;c[k>>2]=(c[d>>2]|0)-n;b=33760;s=+Uo(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[8442]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[8444]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[4223]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[4223]}q=c[8448]|0;m=q+1|0;c[8448]=m;}while((q|0)<(t|0));i=j;return 0}function Uo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[4263]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[8520]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[8518]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[4263]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[8518]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[8518]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[4263]=t;u=u+5|0;}while((u|0)<=(m|0));c[8518]=u;k=t;i=g;return+k}}while(0);c[8522]=1;c[8524]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[8522]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[8524]=u;y=u}else{y=1}u=c[a>>2]|0;c[8518]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[4263]=t;x=C+(c[d>>2]|0)|0;c[8522]=x;y=B+(c[f>>2]|0)|0;c[8524]=y;a=z+1|0;c[8518]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function Vo(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[8460]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[8466]=n;o=c[d>>2]|0;p=c[8460]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[8468]=o;do{if((q|0)>(n|0)){c[8476]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[8464]=s;t=c[e>>2]|0;c[8452]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[8452]=t+1}u=r+1|0;c[8476]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[8476]=o;c[8474]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[8456]=1;t=o;o=1;while(1){c[8478]=o+1;p=t+1|0;c[8476]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[8452]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[8452]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[8470]=s;c[l>>2]=s+1;s=Qo(l,a+((c[8460]|0)+b+(fa(o,m)|0)<<3)|0,33760)|0;p=s+ -1|0;c[8458]=p+(c[8460]|0);s=c[8456]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[8458]|0;p=c[8456]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[8460]|0;if((s|0)==(u|0)){y=s}else{h[4231]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[4231];y=u}h[4231]=-1.0/+h[a+(y+b+n<<3)>>3];Ro(33880,33848,a+(y-m+n<<3)|0,33760)|0;u=c[8474]|0;z=(c[g+((c[8456]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[8474]=u;A=c[8460]|0;c[8472]=A;z=c[8478]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[8454]=z;B=z;z=A;while(1){A=(c[8458]|0)+ -1|0;c[8458]=A;C=z+ -1|0;c[8472]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[4231]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[4231];F=C}C=33760;So(33880,33848,a+((c[8460]|0)-m+(fa(c[8456]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[8454]|0;D=C+1|0;c[8454]=D;if((C|0)>=(u|0)){break a}B=D;z=c[8472]|0}}}while(0);n=c[8456]|0;s=n+1|0;c[8456]=s;if((n|0)>=(r|0)){break}t=c[8476]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[8460]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function Wo(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[8484]=n;f=c[d>>2]|0;o=f+ -1|0;c[8496]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[8480]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[8494]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[8482]=k;q=j+(k+ -1<<3)|0;h[4243]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[4243]}k=33760;So(33976,33944,a+((c[8484]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[8480]|0;f=k+1|0;c[8480]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[8488]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[8480]=k;q=c[8484]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[8494]=s;u=q-s|0;c[8490]=u;q=k-s|0;c[8492]=q;h[4243]=-t;s=33760;So(33976,33944,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[8488]|0;r=s+1|0;c[8488]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[8480]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[8494]=r;s=o-r|0;c[8490]=s;q=n-r|0;c[8492]=q;r=33760;t=+Uo(33976,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[4243]=t;r=c[8480]|0;q=j+(r+ -1<<3)|0;o=c[8484]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[8480]=n;}while((r|0)<(f|0));v=o;w=c[8496]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[8488]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[8480]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[8494]=(n|0)<=(b|0)?n:b;b=33760;t=+Uo(33976,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[8480]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[8482]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[4243]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[4243]}n=c[8488]|0;b=n+1|0;c[8488]=b;if((n|0)>=(w|0)){break}o=c[8484]|0;v=b}i=l;return 0}function Xo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[8508]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[8506]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[8506]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[8506]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[8506]=o;i=g;return 0}}while(0);c[8510]=1;c[8512]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[8510]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[8512]=o;q=o}else{q=1}o=c[a>>2]|0;c[8506]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[8510]=p;q=s+(c[f>>2]|0)|0;c[8512]=q;a=r+1|0;c[8506]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function Yo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[34152]=1;f=d[b]|0;c[8534]=f;b=d[e]|0;c[8536]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[8534]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[8536]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function xv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;lv(a,59016);kv(a,4);lv(a,59144);kv(a,0);lv(a,59152);o=g+1+j+l+n|0;mv(a,o);lv(a,59160);if((c[f>>2]|0)>0){n=b;l=0;do{lv(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{lv(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{lv(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{lv(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=59168;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];yv(a,b,e);lv(a,59184);kv(a,o);zv(a,59160,59192);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;zv(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;zv(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;zv(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;zv(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function yv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;lv(b,59216);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}kv(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?59160:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}Av(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?59160:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}Av(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?59160:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}Av(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?59160:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}Av(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function zv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lv(a,b);kv(a,1);lv(a,59200);lv(a,c);i=d;return}function Av(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;lv(a,b);kv(a,d?2:1);lv(a,59224);lv(a,c);if(!d){i=e;return}lv(a,59232);lv(a,59240);i=e;return}function Bv(a){a=a|0;var b=0;b=i;Ju(a);i=b;return}function Cv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;RG(e,59264);NG(d,Ev(a,e)|0);Dv(d,b+4|0);XG(d);XG(e);RG(g,59272);NG(f,Ev(a,g)|0);Fv(f,b);XG(f);XG(g);RG(j,59288);NG(h,Ev(a,j)|0);Dv(h,b+8|0);XG(h);XG(j);RG(l,59304);NG(k,Ev(a,l)|0);Dv(k,b+12|0);XG(k);XG(l);RG(n,59320);NG(m,Ev(a,n)|0);Gv(m,b+16|0,0);XG(m);XG(n);RG(p,59336);NG(o,Ev(a,p)|0);Gv(o,b+20|0,0);XG(o);XG(p);RG(r,59352);NG(q,Ev(a,r)|0);Gv(q,b+24|0,0);XG(q);XG(r);RG(t,59360);NG(s,Ev(a,t)|0);Gv(s,b+28|0,0);XG(s);XG(t);RG(v,59376);NG(u,Ev(a,v)|0);Gv(u,b+32|0,0);XG(u);XG(v);i=c;return}function Dv(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){Tm(22,0,62584,d);i=d;return}else{c[b>>2]=rd(sH(a)|0)|0;i=d;return}}function Ev(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Pz(a,f,b)|0;l=c[k>>2]|0;os(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}Rz(j,a,b);Sz(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Qz(g,e);Tz(j);j=c[f>>2]|0;Uz(a,j,k,Vz(g)|0);k=Wz(g)|0;Tz(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function Fv(a,b){a=a|0;b=b|0;var d=0;d=i;if((vH(a,59552)|0)==0){c[b>>2]=1;i=d;return}if((vH(a,59560)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Bc(sH(a)|0)|0;i=d;return}}function Gv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((vH(a,59528)|0)==0){c[b>>2]=d}if((vH(a,59552)|0)==0){c[b>>2]=1;i=e;return}if((vH(a,59560)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Bc(sH(a)|0)|0;i=e;return}}function Hv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;RG(j,59392);NG(g,Ev(b,j)|0);y=d+48|0;Iv(g,y);XG(g);XG(j);RG(m,59408);NG(l,Ev(b,m)|0);j=d+56|0;Jv(l,j,0.0);XG(l);XG(m);RG(o,59416);NG(n,Ev(b,o)|0);m=d+32|0;Iv(n,m);XG(n);XG(o);RG(q,59424);NG(p,Ev(b,q)|0);o=d+33|0;Iv(p,o);XG(p);XG(q);RG(s,59440);NG(r,Ev(b,s)|0);q=d+40|0;Jv(r,q,1.0);XG(r);XG(s);RG(u,59448);NG(t,Ev(b,u)|0);s=d+16|0;Jv(t,s,-1.7976931348623157e+308);XG(t);XG(u);RG(w,59456);NG(v,Ev(b,w)|0);u=d+24|0;Jv(v,u,1.7976931348623157e+308);XG(v);XG(w);RG(x,59264);w=sH(Ev(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?59552:59560;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?59528:59536;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?59528:59544;c[f+20>>2]=j;c[f+24>>2]=m?59528:59536;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?59528:59544;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Rm(4,0,59464,f);XG(x);i=e;return}function Iv(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(vH(b,59552)|0)==0|0;i=d;return}function Jv(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((vH(a,59528)|0)==0){h[b>>3]=c;i=d;return}if((vH(a,59552)|0)==0){h[b>>3]=1.0;i=d;return}if((vH(a,59560)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+wR(sH(a)|0);i=d;return}}function Kv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;RG(h,59392);NG(g,Ev(b,h)|0);s=d+13|0;Iv(g,s);XG(g);XG(h);RG(k,59408);NG(j,Ev(b,k)|0);h=d+16|0;Gv(j,h,0);XG(j);XG(k);RG(m,59416);NG(l,Ev(b,m)|0);k=d+12|0;Iv(l,k);XG(l);XG(m);RG(o,59448);NG(n,Ev(b,o)|0);m=d+4|0;Gv(n,m,-2147483648);XG(n);XG(o);RG(q,59456);NG(p,Ev(b,q)|0);o=d+8|0;Gv(p,o,2147483647);XG(p);XG(q);RG(r,59264);q=sH(Ev(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?59552:59560;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?59528:59536;c[f+8>>2]=s;c[f+12>>2]=b?59528:59544;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;Rm(4,0,59568,f);XG(r);i=e;return}function Lv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;RG(h,59392);NG(g,Ev(b,h)|0);o=d+5|0;Iv(g,o);XG(g);XG(h);RG(k,59408);NG(j,Ev(b,k)|0);h=d+6|0;Iv(j,h);XG(j);XG(k);RG(m,59416);NG(l,Ev(b,m)|0);k=d+4|0;Iv(l,k);XG(l);XG(m);RG(n,59264);m=sH(Ev(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?59552:59560;h=(a[k]|0)!=0?59552:59560;c[f>>2]=m;c[f+4>>2]=b?59528:59536;c[f+8>>2]=o;c[f+12>>2]=b?59528:59544;c[f+16>>2]=h;Rm(4,0,59624,f);XG(n);i=e;return}function Mv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;RG(h,59392);NG(g,Ev(b,h)|0);m=d+4|0;Iv(g,m);XG(g);XG(h);RG(k,59408);NG(j,Ev(b,k)|0);h=d+8|0;Dv(j,h);XG(j);XG(k);RG(l,59264);k=sH(Ev(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?59528:59536;c[f+8>>2]=m;c[f+12>>2]=b?59528:59544;Rm(4,0,59664,f);XG(l);i=e;return}function Nv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;gc=i;i=i+16|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=qa;Ov(qa);LG(ra);Pv(sa,ta);Pv(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[72712>>2]|0)==0){RG(za,c[b+80>>2]|0);Qv(ya,za,59688);YG(ra,ya)|0;XG(ya);XG(za)}else{ZG(ra,c[72840>>2]|0)|0}ta=fc(sH(ra)|0,59704)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=sH(ra)|0;Vm(0,59712,pa)}else{Xc=0}}while(0);pa=Lh(0)|0;if((pa|0)==0){Tc(Xc|0)|0;Vm(0,59816,oa)}Wh(pa,Wc);Xh(pa,9,44);Wc=c[va>>2]|0;do{if((Wc|0)==0){oa=Aa;IR(oa|0,0,1024)|0;while(1){za=pb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((Yh(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Tc(Xc|0)|0;oa=sH(ra)|0;ya=ei(bi(pa)|0)|0;za=ci(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;Tm(1,0,59896,na);Sh(pa);Vm(0,59984,ma)}else if((Yc|0)==14){Tc(Xc|0)|0;break}}else{if((Yh(pa,Wc,ER(Wc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=ei(bi(pa)|0)|0;ta=ci(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;od(za|0,60008,la|0)|0;za=c[va>>2]|0;ta=ei(bi(pa)|0)|0;oa=ci(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;Tm(1,0,60024,ka);Sh(pa);Vm(0,59984,ja)}}while(0);ja=qa;RG(Ca,60112);Uv(Ba,ja,Ca);Vv(Da,ja);ka=Tv(Ba,Da)|0;XG(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=sH(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;Tm(1,0,60120,ia)}else{RG(Ea,60112);Ba=AR(Da,sH(Ev(ja,Ea)|0)|0)|0;XG(Ea);if((Ba|0)==0){break}Sh(pa);RG(Fa,60112);Ba=sH(Ev(ja,Fa)|0)|0;va=sH(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;Tm(1,0,60168,ha);XG(Fa);Vm(0,59984,ga)}}while(0);Wv(qa,b,c[72924>>2]|0,c[72928>>2]|0);Rm(23,1,60264,fa);fa=qa+12|0;RG(Ha,60304);NG(Ga,Ev(fa,Ha)|0);ga=d;Jv(Ga,ga,0.0);XG(Ga);XG(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];Rm(23,0,60320,ea);RG(Ja,60336);NG(Ia,Ev(fa,Ja)|0);ea=d+8|0;Jv(Ia,ea,1.0);XG(Ia);XG(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];Rm(23,0,60352,da);RG(La,60368);NG(Ka,Ev(fa,La)|0);da=d+24|0;Jv(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);XG(Ka);XG(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];Rm(23,0,60384,ca);RG(Na,60400);NG(Ma,Ev(fa,Na)|0);ca=d+32|0;Jv(Ma,ca,1.0e-5);XG(Ma);XG(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];Rm(23,0,60416,ba);RG(Pa,60432);NG(Oa,Ev(fa,Pa)|0);ba=d+40|0;Dv(Oa,ba);XG(Oa);XG(Pa);c[aa>>2]=c[ba>>2];Rm(23,0,60440,aa);RG(Ra,60464);NG(Qa,Ev(fa,Ra)|0);aa=d+44|0;Dv(Qa,aa);XG(Qa);XG(Ra);c[$>>2]=c[aa>>2];Rm(23,0,60480,$);RG(Ta,60504);NG(Sa,Ev(fa,Ta)|0);fa=d+48|0;Dv(Sa,fa);XG(Sa);XG(Ta);c[_>>2]=c[fa>>2];Rm(23,0,60520,_);RG(Va,60544);NG(Ua,Ev(ja,Va)|0);_=d+268|0;Dv(Ua,_);XG(Ua);XG(Va);c[Z>>2]=c[_>>2];Rm(23,0,60568,Z);if((c[18964>>2]|0)!=0){Yd[c[4856]&255](23)}RG(eb,60592);NG(db,Ev(ja,eb)|0);Gv(db,Wa,0);XG(db);XG(eb);RG(gb,60624);NG(fb,Ev(ja,gb)|0);Gv(fb,Xa,0);XG(fb);XG(gb);RG(ib,60656);NG(hb,Ev(ja,ib)|0);Gv(hb,Ya,0);XG(hb);XG(ib);RG(kb,60680);NG(jb,Ev(ja,kb)|0);Gv(jb,_a,0);XG(jb);XG(kb);RG(mb,60712);NG(lb,Ev(ja,mb)|0);Gv(lb,Za,0);XG(lb);XG(mb);RG(ob,60752);NG(nb,Ev(ja,ob)|0);Gv(nb,ab,0);XG(nb);XG(ob);RG(rb,60784);NG(qb,Ev(ja,rb)|0);Gv(qb,$a,0);XG(qb);XG(rb);RG(tb,60824);NG(sb,Ev(ja,tb)|0);Gv(sb,cb,0);XG(sb);XG(tb);RG(vb,60856);NG(ub,Ev(ja,vb)|0);Gv(ub,bb,0);XG(ub);XG(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}rb=b+136|0;if((c[ab>>2]|0)!=(c[rb>>2]|0)){break}qb=b+120|0;if((c[$a>>2]|0)!=(c[qb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=61400;Rm(4,1,61376,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=Xv(lb,wb)|0;Cv(ib,jb+(kb*112|0)|0);Hv(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(xb,61416);jb=(vH(Ev(ib,xb)|0,59552)|0)==0;XG(xb);if(!jb){break}c[N>>2]=c[hb>>2];Rm(4,0,61432,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);RG(yb,c[hb>>2]|0);c[(Yv(sa,yb)|0)>>2]=kb;XG(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[M>>2]=61464;Rm(4,1,61376,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=Xv(lb,zb)|0;Cv(fb,gb+(jb*112|0)|0);Hv(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Ab,61416);gb=(vH(Ev(fb,Ab)|0,59552)|0)==0;XG(Ab);if(!gb){break}c[L>>2]=c[eb>>2];Rm(4,0,61432,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);RG(Bb,c[eb>>2]|0);c[(Yv(sa,Bb)|0)>>2]=jb;XG(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[K>>2]=61488;Rm(4,1,61376,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=Xv(mb,Cb)|0;Cv(gb,hb+(fb*112|0)|0);Hv(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Db,61416);hb=(vH(Ev(gb,Db)|0,59552)|0)==0;XG(Db);if(!hb){break}c[J>>2]=c[db>>2];Rm(4,0,61432,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);RG(Eb,c[db>>2]|0);c[(Yv(sa,Eb)|0)>>2]=fb;XG(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[I>>2]=61504;Rm(4,1,61376,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=Xv(ub,Fb)|0;Cv(mb,kb+(ib*60|0)|0);Kv(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Gb,61416);kb=(vH(Ev(mb,Gb)|0,59552)|0)==0;XG(Gb);if(!kb){break}c[H>>2]=c[gb>>2];Rm(4,0,61432,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);RG(Hb,c[gb>>2]|0);c[(Yv(sa,Hb)|0)>>2]=ib;XG(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[G>>2]=61528;Rm(4,1,61376,G);if((c[qb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=Xv(ib,Ib)|0;Cv(mb,ub+(lb*48|0)|0);Lv(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Jb,61416);ub=(vH(Ev(mb,Jb)|0,59552)|0)==0;XG(Jb);if(!ub){break}c[F>>2]=c[fb>>2];Rm(4,0,61432,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);RG(Kb,c[fb>>2]|0);c[(Yv(sa,Kb)|0)>>2]=lb;XG(Kb);lb=lb+1|0;}while((lb|0)<(c[qb>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[E>>2]=61552;Rm(4,1,61376,E);if((c[nb>>2]|0)>0){qb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[qb>>2]|0;c[Lb>>2]=sb;mb=Xv(lb,Lb)|0;Cv(mb,ib+(sb*52|0)|0);Mv(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Mb,61416);ib=(vH(Ev(mb,Mb)|0,59552)|0)==0;XG(Mb);if(!ib){break}c[D>>2]=c[gb>>2];Rm(4,0,61432,D);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);RG(Nb,c[gb>>2]|0);c[(Yv(sa,Nb)|0)>>2]=sb;XG(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[C>>2]=61576;Rm(4,1,61376,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;qb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=qb;mb=Xv(sb,Ob)|0;Cv(mb,lb+(qb*112|0)|0);Hv(mb,lb+(qb*112|0)+40|0);fb=lb+(qb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Pb,61416);lb=(vH(Ev(mb,Pb)|0,59552)|0)==0;XG(Pb);if(!lb){break}c[B>>2]=c[fb>>2];Rm(4,0,61432,B);a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}}while(0);RG(Qb,c[fb>>2]|0);c[(Yv(ua,Qb)|0)>>2]=qb;XG(Qb);qb=qb+1|0;}while((qb|0)<(c[ja>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[A>>2]=61592;Rm(4,1,61376,A);if((c[tb>>2]|0)>0){ja=b+20|0;qb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=Xv(qb,Rb)|0;Cv(mb,sb+(nb*60|0)|0);Kv(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Sb,61416);sb=(vH(Ev(mb,Sb)|0,59552)|0)==0;XG(Sb);if(!sb){break}c[z>>2]=c[gb>>2];Rm(4,0,61432,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);RG(Tb,c[gb>>2]|0);c[(Yv(ua,Tb)|0)>>2]=nb;XG(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[y>>2]=61616;Rm(4,1,61376,y);if((c[rb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{qb=c[tb>>2]|0;c[Ub>>2]=ja;mb=Xv(nb,Ub)|0;Cv(mb,qb+(ja*48|0)|0);Lv(mb,qb+(ja*48|0)+36|0);fb=qb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Vb,61416);qb=(vH(Ev(mb,Vb)|0,59552)|0)==0;XG(Vb);if(!qb){break}c[x>>2]=c[fb>>2];Rm(4,0,61432,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);RG(Wb,c[fb>>2]|0);c[(Yv(ua,Wb)|0)>>2]=ja;XG(Wb);ja=ja+1|0;}while((ja|0)<(c[rb>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}c[w>>2]=61640;Rm(4,1,61376,w);if((c[ob>>2]|0)>0){rb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[rb>>2]|0;c[Xb>>2]=tb;mb=Xv(ja,Xb)|0;Cv(mb,nb+(tb*52|0)|0);Mv(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[72708>>2]|0)!=0){break}RG(Yb,61416);nb=(vH(Ev(mb,Yb)|0,59552)|0)==0;XG(Yb);if(!nb){break}c[v>>2]=c[gb>>2];Rm(4,0,61432,v);a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);RG(Zb,c[gb>>2]|0);c[(Yv(ua,Zb)|0)>>2]=tb;XG(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}Rm(4,1,61664,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;rb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=Xv(tb,_b)|0;Cv(mb,(c[rb>>2]|0)+(ja*52|0)+12|0);LG($b);c[bc>>2]=ja;mb=Xv(tb,bc)|0;RG(cc,61704);NG(ac,Ev(mb,cc)|0);Zv(ac,$b);XG(ac);XG(cc);mb=(vH($b,61712)|0)==0;fb=c[rb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;Rm(4,0,61728,t);nb=c[rb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=Xv(tb,ec)|0;RG(gc,61768);NG(dc,Ev(nb,gc)|0);Zv(dc,$b);XG(dc);XG(gc);_v(wa,sa,$b);_v(xa,ua,$b);aw(hc,sa);do{if($v(wa,hc)|0){nb=c[(bw(wa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{aw(ic,ua);if($v(xa,ic)|0){fb=c[(bw(xa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((vH($b,61784)|0)!=0){break b}a[(c[rb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);XG($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}GH(kc,61792,$b);Qv(jc,kc,61816);XG(kc);c[s>>2]=sH(jc)|0;Vm(0,61832,s)}}while(0);if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}Rm(4,1,61840,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;rb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=Xv(ja,lc)|0;Cv(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);LG(mc);c[oc>>2]=tb;gb=Xv(ja,oc)|0;RG(pc,61704);NG(nc,Ev(gb,pc)|0);Zv(nc,mc);XG(nc);XG(pc);gb=(vH(mc,61712)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;Rm(4,0,61728,p);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=Xv(ja,rc)|0;RG(sc,61768);NG(qc,Ev(fb,sc)|0);Zv(qc,mc);XG(qc);XG(sc);_v(wa,sa,mc);_v(xa,ua,mc);aw(tc,sa);if($v(wa,tc)|0){fb=c[(bw(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{aw(uc,ua);if(!($v(xa,uc)|0)){break}nb=c[(bw(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}XG(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}GH(wc,61880,mc);Qv(vc,wc,61816);XG(wc);c[o>>2]=sH(vc)|0;Vm(0,61832,o)}}while(0);if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}Rm(4,1,61904,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;rb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=Xv(tb,xc)|0;Cv(fb,(c[rb>>2]|0)+(ja*52|0)+12|0);LG(yc);c[Ac>>2]=ja;fb=Xv(tb,Ac)|0;RG(Bc,61704);NG(zc,Ev(fb,Bc)|0);Zv(zc,yc);XG(zc);XG(Bc);fb=(vH(yc,61712)|0)==0;nb=c[rb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;Rm(4,0,61728,m);gb=c[rb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=Xv(tb,Dc)|0;RG(Ec,61768);NG(Cc,Ev(gb,Ec)|0);Zv(Cc,yc);XG(Cc);XG(Ec);_v(wa,sa,yc);_v(xa,ua,yc);aw(Fc,sa);if($v(wa,Fc)|0){gb=c[(bw(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{aw(Gc,ua);if(!($v(xa,Gc)|0)){break}nb=c[(bw(xa)|0)+12>>2]|0;gb=c[rb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}XG(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}GH(Ic,61944,yc);Qv(Hc,Ic,61816);XG(Ic);c[l>>2]=sH(Hc)|0;Vm(0,61832,l)}}while(0);if((c[18888>>2]|0)!=0){Yd[c[4856]&255](4)}Rm(4,1,61968,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;rb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=Xv(ja,Jc)|0;Cv(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);LG(Kc);c[Mc>>2]=tb;gb=Xv(ja,Mc)|0;RG(Nc,61704);NG(Lc,Ev(gb,Nc)|0);Zv(Lc,Kc);XG(Lc);XG(Nc);gb=(vH(Kc,61712)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;Rm(4,0,61728,g);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=Xv(ja,Pc)|0;RG(Qc,61768);NG(Oc,Ev(fb,Qc)|0);Zv(Oc,Kc);XG(Oc);XG(Qc);_v(wa,sa,Kc);_v(xa,ua,Kc);aw(Rc,sa);if($v(wa,Rc)|0){fb=c[(bw(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{aw(Sc,ua);if(!($v(xa,Sc)|0)){break}nb=c[(bw(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}XG(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}GH(Vc,62008,Kc);Qv(Uc,Vc,61816);XG(Vc);c[f>>2]=sH(Uc)|0;Vm(0,61832,f)}}while(0);if((c[18888>>2]|0)==0){Sh(pa);cw(ua);cw(sa);XG(ra);dw(qa);i=e;return}Yd[c[4856]&255](4);Sh(pa);cw(ua);cw(sa);XG(ra);dw(qa);i=e;return}}while(0);if((c[18960>>2]|c[4716]|0)==0){Sh(pa);Zc=md(0)|0;td(-1)}Tm(22,1,60896,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;Tm(22,0,60944,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;Tm(22,0,60992,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;Tm(22,0,61040,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;Tm(22,0,61088,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;Tm(22,0,61136,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;Tm(22,0,61184,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;Tm(22,0,61232,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;Tm(22,0,61280,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;Tm(22,0,61328,P);Yd[c[4856]&255](22);Sh(pa);Zc=md(0)|0;td(-1)}function Ov(a){a=a|0;var b=0;b=i;QC(a);i=b;return}function Pv(a,b){a=a|0;b=b|0;b=i;vy(a,0);i=b;return}function Qv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;MG(a,d);e=VG(b)|0;f=Dw(c)|0;wH(a,WG(b)|0,e,f+e|0);oH(a,c,f)|0;i=d;return}function Rv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((AR(b,62640)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{RG(g,v);w=Ev(u,g)|0;ZG(w,c[d+((t|1)<<2)>>2]|0)|0;XG(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((AR(b,62664)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{RG(h,g);u=Ev(t,h)|0;ZG(u,c[d+((v|1)<<2)>>2]|0)|0;XG(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((AR(b,62688)|0)!=0){do{if((AR(b,62944)|0)!=0){if((AR(b,62952)|0)==0){break}if((AR(b,62960)|0)==0){break}if((AR(b,62968)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=Xv(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){RG(r,c[t>>2]|0);w=Ev(g,r)|0;ZG(w,c[d+((u|1)<<2)>>2]|0)|0;XG(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=Xv(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}RG(s,62976);ZG(Ev(x,s)|0,b)|0;XG(s);i=e;return}ew(j,k);LG(l);LG(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{RG(n,g);t=Ev(j,n)|0;ZG(t,c[d+((x|1)<<2)>>2]|0)|0;XG(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}RG(o,62704);YG(l,Ev(j,o)|0)|0;XG(o);RG(p,62720);YG(m,Ev(j,p)|0)|0;XG(p);c[k>>2]=Bc(sH(l)|0)|0;if((vH(m,62736)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((vH(m,62744)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((vH(m,62752)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((vH(m,62760)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((vH(m,62768)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((vH(m,62776)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((vH(m,62784)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((vH(m,62792)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((vH(m,62800)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((vH(m,62808)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((vH(m,62816)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((vH(m,62824)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((vH(m,62832)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((vH(m,62840)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=sH(m)|0;RG(q,59264);N=sH(Ev(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Um(0,(O|0)!=0|0,62848,f);XG(q);tB(Xv(c[b>>2]|0,s)|0,j)|0;XG(m);XG(l);mw(j);i=e;return}function Sv(a,b){a=a|0;b=b|0;i=i;return}function Tv(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ey(a,b)|0;i=c;return d|0}function Uv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;ny(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];fy(a,f);i=e;return}function Vv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;gy(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];fy(a,e);i=d;return}function Wv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Ub=i;i=i+16|0;Vb=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;ew(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Vm(0,62032,n)}if(p){ec=rd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;Rm(23,0,62176,m);fw(q);gw(q,e,8);if(!(hw(q)|0)){c[l>>2]=e;Vm(0,62216,l)}LG(r);l=q;iw(l,r)|0;NG(s,r);while(1){e=iw(l,r)|0;if(!(HH(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}GH(t,62296,r);mH(s,t)|0;XG(t)}t=rd(sH(s)|0)|0;jw(q);XG(s);XG(r);kw(q);fc=t}if((fc|0)==0){Rm(23,0,62384,g);mw(o);i=f;return}LG(u);LG(v);c[k>>2]=fc;Rm(23,0,62304,k);k=Tb(fc|0,62296)|0;if((k|0)!=0){g=k;do{k=gR(12)|0;RG(k,g);t=tH(k,62336,0)|0;rH(w,k,0,t);YG(u,w)|0;XG(w);rH(x,k,t+1|0,(cH(k)|0)+~t|0);YG(v,x)|0;XG(x);YG(Ev(o,u)|0,v)|0;t=sH(u)|0;k=sH(v)|0;c[j>>2]=t;c[j+4>>2]=k;Rm(23,0,62344,j);g=Tb(0,62296)|0;}while((g|0)!=0)}bR(fc);fc=a+12|0;RG(y,60432);g=Ev(fc,y)|0;RG(z,60432);if((lw(o,z)|0)==0){RG(B,60432);gc=1;hc=0;ic=Ev(fc,B)|0}else{RG(A,60432);gc=0;hc=1;ic=Ev(o,A)|0}YG(g,ic)|0;if(gc){XG(B)}if(hc){XG(A)}XG(z);XG(y);RG(C,60304);y=Ev(fc,C)|0;RG(D,60304);if((lw(o,D)|0)==0){RG(F,60304);jc=1;kc=0;lc=Ev(fc,F)|0}else{RG(E,60304);jc=0;kc=1;lc=Ev(o,E)|0}YG(y,lc)|0;if(jc){XG(F)}if(kc){XG(E)}XG(D);XG(C);RG(G,60336);C=Ev(fc,G)|0;RG(H,60336);if((lw(o,H)|0)==0){RG(J,60336);mc=1;nc=0;oc=Ev(fc,J)|0}else{RG(I,60336);mc=0;nc=1;oc=Ev(o,I)|0}YG(C,oc)|0;if(mc){XG(J)}if(nc){XG(I)}XG(H);XG(G);RG(K,60368);G=Ev(fc,K)|0;RG(L,60368);if((lw(o,L)|0)==0){RG(N,60368);pc=0;qc=1;rc=Ev(fc,N)|0}else{RG(M,60368);pc=1;qc=0;rc=Ev(o,M)|0}YG(G,rc)|0;if(qc){XG(N)}if(pc){XG(M)}XG(L);XG(K);RG(O,60400);K=Ev(fc,O)|0;RG(P,60400);if((lw(o,P)|0)==0){RG(R,60400);sc=1;tc=0;uc=Ev(fc,R)|0}else{RG(Q,60400);sc=0;tc=1;uc=Ev(o,Q)|0}YG(K,uc)|0;if(sc){XG(R)}if(tc){XG(Q)}XG(P);XG(O);RG(S,60464);O=Ev(fc,S)|0;RG(T,60464);if((lw(o,T)|0)==0){RG(V,60464);vc=1;wc=0;xc=Ev(fc,V)|0}else{RG(U,60464);vc=0;wc=1;xc=Ev(o,U)|0}YG(O,xc)|0;if(vc){XG(V)}if(wc){XG(U)}XG(T);XG(S);RG(W,60504);S=Ev(fc,W)|0;RG(X,60504);if((lw(o,X)|0)==0){RG(Z,60504);yc=1;zc=0;Ac=Ev(fc,Z)|0}else{RG(Y,60504);yc=0;zc=1;Ac=Ev(o,Y)|0}YG(S,Ac)|0;if(yc){XG(Z)}if(zc){XG(Y)}XG(X);XG(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=Xv(Y,_)|0;RG($,59408);Ac=Ev(yc,$)|0;c[aa>>2]=Z;yc=Xv(Y,aa)|0;RG(ba,59264);if((lw(o,Ev(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=Xv(Y,ea)|0;RG(fa,59408);Bc=1;Cc=0;Dc=Ev(yc,fa)|0}else{c[ca>>2]=Z;yc=Xv(Y,ca)|0;RG(da,59264);Bc=0;Cc=1;Dc=Ev(o,Ev(yc,da)|0)|0}YG(Ac,Dc)|0;if(Bc){XG(fa)}if(Cc){XG(da)}XG(ba);XG($);c[ga>>2]=Z;Ac=Xv(zc,ga)|0;RG(ha,59408);yc=Ev(Ac,ha)|0;c[ia>>2]=Z;Ac=Xv(zc,ia)|0;RG(ja,59264);if((lw(o,Ev(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=Xv(zc,ma)|0;RG(na,59408);Ec=1;Fc=0;Gc=Ev(Ac,na)|0}else{c[ka>>2]=Z;Ac=Xv(zc,ka)|0;RG(la,59264);Ec=0;Fc=1;Gc=Ev(o,Ev(Ac,la)|0)|0}YG(yc,Gc)|0;if(Ec){XG(na)}if(Fc){XG(la)}XG(ja);XG(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=Xv(Hc,oa)|0;RG(pa,59408);ja=Ev(ha,pa)|0;c[qa>>2]=Z;ha=Xv(Hc,qa)|0;RG(ra,59264);if((lw(o,Ev(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=Xv(Hc,ua)|0;RG(va,59408);Ic=1;Jc=0;Kc=Ev(ha,va)|0}else{c[sa>>2]=Z;ha=Xv(Hc,sa)|0;RG(ta,59264);Ic=0;Jc=1;Kc=Ev(o,Ev(ha,ta)|0)|0}YG(ja,Kc)|0;if(Ic){XG(va)}if(Jc){XG(ta)}XG(ra);XG(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=Xv(X,wa)|0;RG(xa,59408);ra=Ev(pa,xa)|0;c[ya>>2]=Z;pa=Xv(X,ya)|0;RG(za,59264);if((lw(o,Ev(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=Xv(X,Ca)|0;RG(Da,59408);Lc=1;Mc=0;Nc=Ev(pa,Da)|0}else{c[Aa>>2]=Z;pa=Xv(X,Aa)|0;RG(Ba,59264);Lc=0;Mc=1;Nc=Ev(o,Ev(pa,Ba)|0)|0}YG(ra,Nc)|0;if(Lc){XG(Da)}if(Mc){XG(Ba)}XG(za);XG(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=Xv(Z,Ea)|0;RG(Fa,59408);Ba=Ev(za,Fa)|0;c[Ga>>2]=xa;za=Xv(Z,Ga)|0;RG(Ha,59264);if((lw(o,Ev(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=Xv(Z,Ka)|0;RG(La,59408);Oc=1;Pc=0;Qc=Ev(za,La)|0}else{c[Ia>>2]=xa;za=Xv(Z,Ia)|0;RG(Ja,59264);Oc=0;Pc=1;Qc=Ev(o,Ev(za,Ja)|0)|0}YG(Ba,Qc)|0;if(Oc){XG(La)}if(Pc){XG(Ja)}XG(Ha);XG(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=Xv(xa,Ma)|0;RG(Na,59408);Ja=Ev(Ha,Na)|0;c[Oa>>2]=Fa;Ha=Xv(xa,Oa)|0;RG(Pa,59264);if((lw(o,Ev(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=Xv(xa,Sa)|0;RG(Ta,59408);Rc=1;Sc=0;Tc=Ev(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=Xv(xa,Qa)|0;RG(Ra,59264);Rc=0;Sc=1;Tc=Ev(o,Ev(Ha,Ra)|0)|0}YG(Ja,Tc)|0;if(Rc){XG(Ta)}if(Sc){XG(Ra)}XG(Pa);XG(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=Xv(Fa,Ua)|0;RG(Va,59408);Ra=Ev(Pa,Va)|0;c[Wa>>2]=Na;Pa=Xv(Fa,Wa)|0;RG(Xa,59264);if((lw(o,Ev(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=Xv(Fa,_a)|0;RG($a,59408);Uc=1;Vc=0;Wc=Ev(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=Xv(Fa,Ya)|0;RG(Za,59264);Uc=0;Vc=1;Wc=Ev(o,Ev(Pa,Za)|0)|0}YG(Ra,Wc)|0;if(Uc){XG($a)}if(Vc){XG(Za)}XG(Xa);XG(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=Xv(Na,ab)|0;RG(bb,59408);Za=Ev(Xa,bb)|0;c[cb>>2]=Va;Xa=Xv(Na,cb)|0;RG(db,59264);if((lw(o,Ev(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=Xv(Na,gb)|0;RG(hb,59408);Xc=1;Yc=0;Zc=Ev(Xa,hb)|0}else{c[eb>>2]=Va;Xa=Xv(Na,eb)|0;RG(fb,59264);Xc=0;Yc=1;Zc=Ev(o,Ev(Xa,fb)|0)|0}YG(Za,Zc)|0;if(Xc){XG(hb)}if(Yc){XG(fb)}XG(db);XG(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=Xv(Va,ib)|0;RG(jb,59408);fb=Ev(db,jb)|0;c[kb>>2]=bb;db=Xv(Va,kb)|0;RG(lb,59264);if((lw(o,Ev(db,lb)|0)|0)==0){c[ob>>2]=bb;db=Xv(Va,ob)|0;RG(pb,59408);_c=1;$c=0;ad=Ev(db,pb)|0}else{c[mb>>2]=bb;db=Xv(Va,mb)|0;RG(nb,59264);_c=0;$c=1;ad=Ev(o,Ev(db,nb)|0)|0}YG(fb,ad)|0;if(_c){XG(pb)}if($c){XG(nb)}XG(lb);XG(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=Xv(bb,qb)|0;RG(rb,59408);nb=Ev(lb,rb)|0;c[sb>>2]=jb;lb=Xv(bb,sb)|0;RG(tb,59264);if((lw(o,Ev(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=Xv(bb,wb)|0;RG(xb,59408);bd=1;cd=0;dd=Ev(lb,xb)|0}else{c[ub>>2]=jb;lb=Xv(bb,ub)|0;RG(vb,59264);bd=0;cd=1;dd=Ev(o,Ev(lb,vb)|0)|0}YG(nb,dd)|0;if(bd){XG(xb)}if(cd){XG(vb)}XG(tb);XG(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=Xv(jb,yb)|0;RG(zb,59408);vb=Ev(tb,zb)|0;c[Ab>>2]=rb;tb=Xv(jb,Ab)|0;RG(Bb,59264);if((lw(o,Ev(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=Xv(jb,Eb)|0;RG(Fb,59408);ed=1;fd=0;gd=Ev(tb,Fb)|0}else{c[Cb>>2]=rb;tb=Xv(jb,Cb)|0;RG(Db,59264);ed=0;fd=1;gd=Ev(o,Ev(tb,Db)|0)|0}YG(vb,gd)|0;if(ed){XG(Fb)}if(fd){XG(Db)}XG(Bb);XG(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=Xv(rb,Gb)|0;RG(Hb,59408);Db=Ev(Bb,Hb)|0;c[Ib>>2]=zb;Bb=Xv(rb,Ib)|0;RG(Jb,59264);if((lw(o,Ev(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=Xv(rb,Mb)|0;RG(Nb,59408);hd=0;id=1;jd=Ev(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=Xv(rb,Kb)|0;RG(Lb,59264);hd=1;id=0;jd=Ev(o,Ev(Bb,Lb)|0)|0}YG(Db,jd)|0;if(id){XG(Nb)}if(hd){XG(Lb)}XG(Jb);XG(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=Xv(zb,Ob)|0;RG(Pb,59408);Lb=Ev(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=Xv(zb,Qb)|0;RG(Rb,59264);if((lw(o,Ev(Jb,Rb)|0)|0)==0){c[Vb>>2]=Hb;Jb=Xv(zb,Vb)|0;RG(Wb,59408);kd=1;ld=0;md=Ev(Jb,Wb)|0}else{c[Sb>>2]=Hb;Jb=Xv(zb,Sb)|0;RG(Ub,59264);kd=0;ld=1;md=Ev(o,Ev(Jb,Ub)|0)|0}YG(Lb,md)|0;if(kd){XG(Wb)}if(ld){XG(Ub)}XG(Rb);XG(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=Xv(b,Xb)|0;RG(Yb,59408);Pb=Ev(Hb,Yb)|0;c[Zb>>2]=a;Hb=Xv(b,Zb)|0;RG(_b,59264);if((lw(o,Ev(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=Xv(b,bc)|0;RG(cc,59408);nd=1;od=0;pd=Ev(Hb,cc)|0}else{c[$b>>2]=a;Hb=Xv(b,$b)|0;RG(ac,59264);nd=0;od=1;pd=Ev(o,Ev(Hb,ac)|0)|0}YG(Pb,pd)|0;if(nd){XG(cc)}if(od){XG(ac)}XG(_b);XG(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}Rm(23,0,62368,h);XG(v);XG(u);mw(o);i=f;return}function Xv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Ey(a,f,b)|0;l=c[k>>2]|0;os(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Gy(j,a,b);Hy(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Fy(g,e);Iy(j);j=c[f>>2]|0;Jy(a,j,k,Ky(g)|0);k=Ly(g)|0;Iy(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Yv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=gx(a,f,b)|0;l=c[k>>2]|0;os(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}ix(j,a,b);jx(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];hx(g,e);kx(j);j=c[f>>2]|0;lx(a,j,k,mx(g)|0);k=nx(g)|0;kx(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function Zv(a,b){a=a|0;b=b|0;var c=0;c=i;YG(b,a)|0;i=c;return}function _v(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Zw(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Rw(a,f);i=e;return}function $v(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Pw(a,b)|0;i=c;return d|0}function aw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Sw(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Rw(a,e);i=d;return}function bw(a){a=a|0;var b=0,c=0;b=i;c=Mw(a)|0;i=b;return c|0}function cw(a){a=a|0;var b=0;b=i;jB(a);i=b;return}function dw(a){a=a|0;var b=0;b=i;YA(a);i=b;return}function ew(a,b){a=a|0;b=b|0;b=i;Fz(a,0);i=b;return}function fw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;UH(d);e=a;c[e>>2]=62436;f=d;c[f>>2]=62456;d=a+8|0;MI(a,62468|0,d);c[e>>2]=62436;c[f>>2]=62456;Xu(d);i=b;return}function gw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(ws(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){LH(d,4);i=e;return}else{JH(d,0);i=e;return}}function hw(a){a=a|0;var b=0,c=0;b=i;c=Hw(a+8|0)|0;i=b;return c|0}function iw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Gw(a,b,SH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function jw(a){a=a|0;var b=0;b=i;if((ys(a+8|0)|0)!=0){i=b;return}LH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function kw(a){a=a|0;var b=0;b=i;Lw(a,62464);PH(a+108|0);i=b;return}function lw(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nw(a,b)|0;i=c;return d|0}function mw(a){a=a|0;var b=0;b=i;NA(a);i=b;return}function nw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=pw(a)|0;os(e);if((f|0)==0){g=0;i=d;return g|0}h=qw(a)|0;a=f;while(1){f=a+16|0;if(rw(h,b,f)|0){j=a}else{if(!(sw(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;os(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function ow(a){a=a|0;var b=0,c=0;b=i;c=$r(yw(a+4|0)|0)|0;i=b;return c|0}function pw(a){a=a|0;var b=0,d=0;b=i;d=c[(ow(a)|0)>>2]|0;i=b;return d|0}function qw(a){a=a|0;var b=0,c=0;b=i;c=ww(a+8|0)|0;i=b;return c|0}function rw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=tw(0,b,c)|0;i=a;return d|0}function sw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=tw(0,b,c)|0;i=a;return d|0}function tw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uw(b,c)|0;i=a;return d|0}function uw(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(uH(a,b)|0)<0;i=c;return d|0}function vw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=zR(a,b,c)|0;i=d;return e|0}function ww(a){a=a|0;var b=0,c=0;b=i;c=xw(a)|0;i=b;return c|0}function xw(a){a=a|0;i=i;return a|0}function yw(a){a=a|0;var b=0,c=0;b=i;c=zw(a)|0;i=b;return c|0}function zw(a){a=a|0;i=i;return a|0}function Aw(a,b){a=a|0;b=b|0;var c=0;a=i;c=Cw(0,b,0)|0;i=a;return c|0}function Bw(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function Cw(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gR(b)|0;i=c;return a|0}function Dw(a){a=a|0;var b=0,c=0;b=i;c=ER(a|0)|0;i=b;return c|0}function Ew(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Fw(b,c,e)|0;i=d;return g|0}function Fw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=st(0,a,b)|0;i=c;return(d?b:a)|0}function Gw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;RI(f,a,1);if(!(UI(f)|0)){i=e;return a|0}lH(b);f=0;while(1){g=_H(QH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(it(g,-1)|0){h=2;j=f;break}k=f+1|0;l=jt(g)|0;if(nt(l,d)|0){h=0;j=k;break}nH(b,l);if((VG(b)|0)==-17){h=4;j=k;break}else{f=k}}LH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function Hw(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function Iw(a){a=a|0;var b=0;b=i;kw(a);iR(a);i=b;return}function Jw(a){a=a|0;var b=0;b=i;kw(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Kw(a){a=a|0;var b=0;b=i;Iw(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Lw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Ys(a+8|0);i=d;return}function Mw(a){a=a|0;var b=0,d=0;b=i;d=Nw((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Nw(a){a=a|0;var b=0,c=0;b=i;c=Ow(a)|0;i=b;return c|0}function Ow(a){a=a|0;i=i;return a|0}function Pw(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Qw(a,b)|0)^1;i=c;return d|0}function Qw(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Rw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Yw(a,e);i=d;return}function Sw(a,b){a=a|0;b=b|0;var c=0;c=i;Tw(a,Uw(b)|0);i=c;return}function Tw(a,b){a=a|0;b=b|0;var c=0;c=i;Xw(a,b);i=c;return}function Uw(a){a=a|0;var b=0,c=0;b=i;c=$r(Vw(a+4|0)|0)|0;i=b;return c|0}function Vw(a){a=a|0;var b=0,c=0;b=i;c=Ww(a)|0;i=b;return c|0}function Ww(a){a=a|0;i=i;return a|0}function Xw(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Yw(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Zw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=$w(b)|0;_w(f,b,d,h,Uw(b)|0);Sw(g,b);do{if(Pw(f,g)|0){h=ax(b)|0;if(bx(h,d,cx(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Sw(a,b);i=e;return}function _w(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;os(h);a:do{if((e|0)==0){j=f}else{k=ax(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(fx(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;os(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;os(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Tw(a,j);i=g;return}function $w(a){a=a|0;var b=0,d=0;b=i;d=c[(Uw(a)|0)>>2]|0;i=b;return d|0}function ax(a){a=a|0;var b=0,c=0;b=i;c=dx(a+8|0)|0;i=b;return c|0}function bx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=tw(0,b,c)|0;i=a;return d|0}function cx(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function dx(a){a=a|0;var b=0,c=0;b=i;c=ex(a)|0;i=b;return c|0}function ex(a){a=a|0;i=i;return a|0}function fx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=tw(0,b,c)|0;i=a;return d|0}function gx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=$w(h)|0;os(e);if((a|0)==0){j=Uw(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(tw(0,d,a)|0){m=l;j=c[m>>2]|0;os(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(tw(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;os(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function hx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cy(a,e);i=d;return}function ix(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Jx(d)|0;d=Lx(n,1)|0;Mx(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Kx(j,d,h);Nx(0,Cx((Ox(j)|0)+16|0)|0,e);e=Px(j)|0;a[e+4|0]=1;Qx(0,Ax((Ox(j)|0)+28|0)|0);a[e+5|0]=1;Rx(m,j);jx(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];hx(b,g);kx(m);kx(j);i=f;return}function jx(a,b){a=a|0;b=b|0;var c=0;c=i;Hx(a,b);i=c;return}function kx(a){a=a|0;var b=0;b=i;wx(a);i=b;return}function lx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;os(f);c[e>>2]=0;os(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=sx(a)|0;b=c[c[e>>2]>>2]|0;os(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Uw(a)|0)>>2]|0;_t(e,c[d>>2]|0);d=tx(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function mx(a){a=a|0;var b=0,d=0;b=i;d=c[(qx(a)|0)>>2]|0;i=b;return d|0}function nx(a){a=a|0;var b=0,d=0;b=i;d=ox(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function ox(a){a=a|0;var b=0,c=0;b=i;c=px(a)|0;i=b;return c|0}function px(a){a=a|0;i=i;return a|0}function qx(a){a=a|0;var b=0,c=0;b=i;c=rx(a)|0;i=b;return c|0}function rx(a){a=a|0;i=i;return a|0}function sx(a){a=a|0;i=i;return a|0}function tx(a){a=a|0;var b=0,c=0;b=i;c=ux(a+8|0)|0;i=b;return c|0}function ux(a){a=a|0;var b=0,c=0;b=i;c=vx(a)|0;i=b;return c|0}function vx(a){a=a|0;i=i;return a|0}function wx(a){a=a|0;var b=0;b=i;xx(a,0);i=b;return}function xx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=ox(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}zx(yx(e)|0,f);i=d;return}function yx(a){a=a|0;var b=0,c=0;b=i;c=Gx(a)|0;i=b;return c|0}function zx(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;Bx(f,Cx(d+16|0)|0)}if((d|0)==0){i=e;return}Dx(c[b>>2]|0,d,1);i=e;return}function Ax(a){a=a|0;i=i;return a|0}function Bx(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Fx(d,0,c);i=b;return}function Cx(a){a=a|0;i=i;return a|0}function Dx(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Ex(0,b,0);i=c;return}function Ex(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iR(b);i=c;return}function Fx(a,b,c){a=a|0;b=b|0;c=c|0;b=i;XG(c);i=b;return}function Gx(a){a=a|0;i=i;return a+4|0}function Hx(a,b){a=a|0;b=b|0;var c=0;c=i;Ix(a,b);i=c;return}function Ix(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Jx(a){a=a|0;var b=0,c=0;b=i;c=ay(a+4|0)|0;i=b;return c|0}function Kx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Ux(a,b,f);i=e;return}function Lx(a,b){a=a|0;b=b|0;var c=0;a=i;c=Tx(0,b,0)|0;i=a;return c|0}function Mx(a,b){a=a|0;b=b|0;var c=0;c=i;Sx(a,b);i=c;return}function Nx(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}NG(b,c);i=a;return}function Ox(a){a=a|0;var b=0,d=0;b=i;d=c[(qx(a)|0)>>2]|0;i=b;return d|0}function Px(a){a=a|0;var b=0,c=0;b=i;c=yx(a)|0;i=b;return c|0}function Qx(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function Rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Hx(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];hx(h,f);jx(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];hx(a,e);kx(h);i=d;return}function Sx(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function Tx(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gR(b<<5)|0;i=c;return a|0}function Ux(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Wx(g)|0)>>2]|0;g=Xx(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Vx(b,a,f);i=e;return}function Vx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Yx(a,b,f);i=e;return}function Wx(a){a=a|0;i=i;return a|0}function Xx(a){a=a|0;i=i;return a|0}function Yx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(_x(g)|0)>>2]|0;g=$x(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Zx(b,a,f);i=e;return}function Zx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(_x(f)|0)>>2];f=$x(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function _x(a){a=a|0;i=i;return a|0}function $x(a){a=a|0;i=i;return a|0}function ay(a){a=a|0;var b=0,c=0;b=i;c=by(a)|0;i=b;return c|0}function by(a){a=a|0;i=i;return a|0}function cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=nx(dy(b)|0)|0;h=$x(Px(dy(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Vx(g,a,e);i=d;return}function dy(a){a=a|0;i=i;return c[a>>2]|0}function ey(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];my(a,e);i=d;return}function gy(a,b){a=a|0;b=b|0;var c=0;c=i;hy(a,iy(b)|0);i=c;return}function hy(a,b){a=a|0;b=b|0;var c=0;c=i;ly(a,b);i=c;return}function iy(a){a=a|0;var b=0,c=0;b=i;c=$r(jy(a+4|0)|0)|0;i=b;return c|0}function jy(a){a=a|0;var b=0,c=0;b=i;c=ky(a)|0;i=b;return c|0}function ky(a){a=a|0;i=i;return a|0}function ly(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function my(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function ny(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=py(b)|0;oy(f,b,d,h,iy(b)|0);gy(g,b);do{if(qy(f,g)|0){h=ry(b)|0;if(rw(h,d,sy(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);gy(a,b);i=e;return}function oy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;os(h);a:do{if((e|0)==0){j=f}else{k=ry(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(sw(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;os(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;os(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);hy(a,j);i=g;return}function py(a){a=a|0;var b=0,d=0;b=i;d=c[(iy(a)|0)>>2]|0;i=b;return d|0}function qy(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(ey(a,b)|0)^1;i=c;return d|0}function ry(a){a=a|0;var b=0,c=0;b=i;c=ty(a+8|0)|0;i=b;return c|0}function sy(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function ty(a){a=a|0;var b=0,c=0;b=i;c=uy(a)|0;i=b;return c|0}function uy(a){a=a|0;i=i;return a|0}function vy(a,b){a=a|0;b=b|0;b=i;i=i+8|0;wy(a,b);i=b;return}function wy(a,b){a=a|0;b=b|0;b=i;xy(a,0);i=b;return}function xy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;yy(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;zy(f,0,e);e=Uw(b)|0;c[(sx(b)|0)>>2]=e;i=d;return}function yy(a){a=a|0;var b=0;b=i;Cy(a);i=b;return}function zy(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Ay(b,c,f);i=e;return}function Ay(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Su(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;By(d,b,f);i=e;return}function By(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Su(e)|0)>>2];i=d;return}function Cy(a){a=a|0;var b=0;b=i;Dy(a);i=b;return}function Dy(a){a=a|0;var b=0;b=i;Vu(a);i=b;return}function Ey(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Ez(h)|0;os(e);if((a|0)==0){j=Ry(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(ls(0,d,a)|0){m=l;j=c[m>>2]|0;os(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(ls(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;os(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Cz(a,e);i=d;return}function Gy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hz(d)|0;d=jz(n,1)|0;kz(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];iz(j,d,h);lz(0,ku((mz(j)|0)+16|0)|0,e);e=nz(j)|0;a[e+4|0]=1;oz(0,az((mz(j)|0)+20|0)|0);a[e+5|0]=1;pz(m,j);Hy(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Fy(b,g);Iy(m);Iy(j);i=f;return}function Hy(a,b){a=a|0;b=b|0;var c=0;c=i;fz(a,b);i=c;return}function Iy(a){a=a|0;var b=0;b=i;Xy(a);i=b;return}function Jy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;os(f);c[e>>2]=0;os(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Qy(a)|0;b=c[c[e>>2]>>2]|0;os(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Ry(a)|0)>>2]|0;_t(e,c[d>>2]|0);d=Sy(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Ky(a){a=a|0;var b=0,d=0;b=i;d=c[(Oy(a)|0)>>2]|0;i=b;return d|0}function Ly(a){a=a|0;var b=0,d=0;b=i;d=My(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function My(a){a=a|0;var b=0,c=0;b=i;c=Ny(a)|0;i=b;return c|0}function Ny(a){a=a|0;i=i;return a|0}function Oy(a){a=a|0;var b=0,c=0;b=i;c=Py(a)|0;i=b;return c|0}function Py(a){a=a|0;i=i;return a|0}function Qy(a){a=a|0;i=i;return a|0}function Ry(a){a=a|0;var b=0,c=0;b=i;c=$r(Vy(a+4|0)|0)|0;i=b;return c|0}function Sy(a){a=a|0;var b=0,c=0;b=i;c=Ty(a+8|0)|0;i=b;return c|0}function Ty(a){a=a|0;var b=0,c=0;b=i;c=Uy(a)|0;i=b;return c|0}function Uy(a){a=a|0;i=i;return a|0}function Vy(a){a=a|0;var b=0,c=0;b=i;c=Wy(a)|0;i=b;return c|0}function Wy(a){a=a|0;i=i;return a|0}function Xy(a){a=a|0;var b=0;b=i;Yy(a,0);i=b;return}function Yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=My(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}_y(Zy(e)|0,f);i=d;return}function Zy(a){a=a|0;var b=0,c=0;b=i;c=ez(a)|0;i=b;return c|0}function _y(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;$y(f,az(d+20|0)|0)}if((d|0)==0){i=e;return}bz(c[b>>2]|0,d,1);i=e;return}function $y(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;dz(d,0,c);i=b;return}function az(a){a=a|0;i=i;return a|0}function bz(a,b,c){a=a|0;b=b|0;c=c|0;c=i;cz(0,b,0);i=c;return}function cz(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iR(b);i=c;return}function dz(a,b,c){a=a|0;b=b|0;c=c|0;b=i;mw(c);i=b;return}function ez(a){a=a|0;i=i;return a+4|0}function fz(a,b){a=a|0;b=b|0;var c=0;c=i;gz(a,b);i=c;return}function gz(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function hz(a){a=a|0;var b=0,c=0;b=i;c=Az(a+4|0)|0;i=b;return c|0}function iz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];sz(a,b,f);i=e;return}function jz(a,b){a=a|0;b=b|0;var c=0;a=i;c=rz(0,b,0)|0;i=a;return c|0}function kz(a,b){a=a|0;b=b|0;var c=0;c=i;qz(a,b);i=c;return}function lz(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function mz(a){a=a|0;var b=0,d=0;b=i;d=c[(Oy(a)|0)>>2]|0;i=b;return d|0}function nz(a){a=a|0;var b=0,c=0;b=i;c=Zy(a)|0;i=b;return c|0}function oz(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}ew(b,a);i=a;return}function pz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;fz(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Fy(h,f);Hy(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Fy(a,e);Iy(h);i=d;return}function qz(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function rz(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=gR(b<<5)|0;i=c;return a|0}function sz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uz(g)|0)>>2]|0;g=vz(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];tz(b,a,f);i=e;return}function tz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wz(a,b,f);i=e;return}function uz(a){a=a|0;i=i;return a|0}function vz(a){a=a|0;i=i;return a|0}function wz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yz(g)|0)>>2]|0;g=zz(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xz(b,a,f);i=e;return}function xz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yz(f)|0)>>2];f=zz(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function yz(a){a=a|0;i=i;return a|0}function zz(a){a=a|0;i=i;return a|0}function Az(a){a=a|0;var b=0,c=0;b=i;c=Bz(a)|0;i=b;return c|0}function Bz(a){a=a|0;i=i;return a|0}function Cz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Ly(Dz(b)|0)|0;h=zz(nz(Dz(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];tz(g,a,e);i=d;return}function Dz(a){a=a|0;i=i;return c[a>>2]|0}function Ez(a){a=a|0;var b=0,d=0;b=i;d=c[(Ry(a)|0)>>2]|0;i=b;return d|0}function Fz(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Gz(a,b);i=b;return}function Gz(a,b){a=a|0;b=b|0;b=i;Hz(a,0);i=b;return}function Hz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Iz(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Jz(f,0,e);e=iy(b)|0;c[(Kz(b)|0)>>2]=e;i=d;return}function Iz(a){a=a|0;var b=0;b=i;Nz(a);i=b;return}function Jz(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Lz(b,c,f);i=e;return}function Kz(a){a=a|0;i=i;return a|0}function Lz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Su(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Mz(d,b,f);i=e;return}function Mz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Su(e)|0)>>2];i=d;return}function Nz(a){a=a|0;var b=0;b=i;Oz(a);i=b;return}function Oz(a){a=a|0;var b=0;b=i;Vu(a);i=b;return}function Pz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=py(h)|0;os(e);if((a|0)==0){j=iy(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(tw(0,d,a)|0){m=l;j=c[m>>2]|0;os(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(tw(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;os(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];LA(a,e);i=d;return}function Rz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=qA(d)|0;d=sA(n,1)|0;tA(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];rA(j,d,h);uA(0,Cx((vA(j)|0)+16|0)|0,e);e=wA(j)|0;a[e+4|0]=1;xA(0,hA((vA(j)|0)+28|0)|0);a[e+5|0]=1;yA(m,j);Sz(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Qz(b,g);Tz(m);Tz(j);i=f;return}function Sz(a,b){a=a|0;b=b|0;var c=0;c=i;oA(a,b);i=c;return}function Tz(a){a=a|0;var b=0;b=i;cA(a);i=b;return}function Uz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;os(f);c[e>>2]=0;os(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Kz(a)|0;b=c[c[e>>2]>>2]|0;os(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(iy(a)|0)>>2]|0;_t(e,c[d>>2]|0);d=$z(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Vz(a){a=a|0;var b=0,d=0;b=i;d=c[(Zz(a)|0)>>2]|0;i=b;return d|0}function Wz(a){a=a|0;var b=0,d=0;b=i;d=Xz(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Xz(a){a=a|0;var b=0,c=0;b=i;c=Yz(a)|0;i=b;return c|0}function Yz(a){a=a|0;i=i;return a|0}function Zz(a){a=a|0;var b=0,c=0;b=i;c=_z(a)|0;i=b;return c|0}function _z(a){a=a|0;i=i;return a|0}function $z(a){a=a|0;var b=0,c=0;b=i;c=aA(a+8|0)|0;i=b;return c|0}function aA(a){a=a|0;var b=0,c=0;b=i;c=bA(a)|0;i=b;return c|0}function bA(a){a=a|0;i=i;return a|0}function cA(a){a=a|0;var b=0;b=i;dA(a,0);i=b;return}function dA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Xz(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}fA(eA(e)|0,f);i=d;return}function eA(a){a=a|0;var b=0,c=0;b=i;c=nA(a)|0;i=b;return c|0}function fA(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;gA(f,hA(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;iA(f,Cx(d+16|0)|0)}if((d|0)==0){i=e;return}jA(c[b>>2]|0,d,1);i=e;return}function gA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;mA(d,0,c);i=b;return}function hA(a){a=a|0;i=i;return a|0}function iA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;lA(d,0,c);i=b;return}function jA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;kA(0,b,0);i=c;return}function kA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;iR(b);i=c;return}



function wQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=aR(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=aR(y)|0;if((z|0)==0){A=12;break}IR(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=eQ(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((LP(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((LP(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((LP(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((LP(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(LP(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(LP(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(LP(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(LP(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){IR(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=eQ(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((LP(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((LP(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((LP(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((LP(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(LP(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(LP(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(LP(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(LP(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((PP(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=$P(X)|0;qb=_a+24|0;if((PP(fb,c[qb>>2]|0)|0)!=0){break}fb=ZP(X)|0;if((PP(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((PP(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=ZP(X)|0;if((PP(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=$P(X)|0;if((PP(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}bR(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=yQ(0,0)|0;if((S|0)==0){A=12;break}R=AQ(S,0,0,0,32)|0;Q=R;if((R|0)==0){zQ(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=aR(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=aR(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=aR(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){IR(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){IR(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=eQ(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((LP(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((LP(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((LP(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((LP(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(LP(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(LP(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(LP(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(LP(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=AQ(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=AQ(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;xQ(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((BR(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=eQ(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=eQ(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((LP(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((LP(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((LP(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((LP(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(LP(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(LP(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(LP(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(LP(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((PP(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=$P(tc)|0;aa=Ca+24|0;if((PP(qa,c[aa>>2]|0)|0)!=0){break}qa=ZP(tc)|0;if((PP(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((PP(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=ZP(tc)|0;if((PP(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=$P(tc)|0;if((PP(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=AQ(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=AQ(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){zQ(S);if((Eb|0)!=0){bR(O)}if((Kb|0)!=0){bR(Kb)}if((Lb|0)==0){A=12;break a}bR(N);A=12;break a}else if((sa|0)==67){zQ(S);if((Eb|0)!=0){bR(O)}if((Kb|0)!=0){bR(Kb)}if((Lb|0)==0){A=12;break a}bR(N);A=12;break a}else if((sa|0)==169){zQ(S);if((Eb|0)!=0){bR(O)}if((Kb|0)!=0){bR(Kb)}if((Lb|0)==0){A=12;break a}bR(N);A=12;break a}else if((sa|0)==176){zQ(S);if((Eb|0)!=0){bR(O)}if((Kb|0)!=0){bR(Kb)}if((Lb|0)==0){A=12;break a}bR(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);zQ(S);if((Jb|0)!=0){bR(Jb)}if((Gb|0)!=0){bR(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}bR(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}xQ(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}bR(m);p=A;i=g;return p|0}function xQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function yQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=cR(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function zQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;bR(e);i=b;return}else{f=d}while(1){bR(c[f>>2]|0);d=c[f+4>>2]|0;bR(f);if((d|0)==0){break}else{f=d}}e=a;bR(e);i=b;return}function AQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=aR(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=aR(p)|0;c[o>>2]=r;if((r|0)==0){bR(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}IR(m|0,0,h|0)|0;j=m;i=g;return j|0}function BQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((CQ(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function CQ(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function DQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function EQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function FQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function GQ(a){a=a|0;i=i;return}function HQ(a){a=a|0;c[a>>2]=105424;i=i;return}function IQ(a){a=a|0;var b=0;b=i;wb(a|0);iR(a);i=b;return}function JQ(a){a=a|0;var b=0;b=i;wb(a|0);i=b;return}function KQ(a){a=a|0;i=i;return 105440}function LQ(a){a=a|0;i=i;return}function MQ(a){a=a|0;i=i;return}function NQ(a){a=a|0;i=i;return}function OQ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function PQ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function QQ(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function RQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=VQ(b,105552,105608,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;we[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function SQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function TQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;we[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function UQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;we[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;we[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function VQ(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;he[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Vd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function WQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;he[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Vd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Vd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Vd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Vd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function XQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Vd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;he[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function YQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function ZQ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;he[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;he[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function _Q(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;he[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function $Q(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function aR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[26464]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=105896+(j<<2)|0;l=105896+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[26464]=f&~(1<<h)}else{if(n>>>0<(c[105872>>2]|0)>>>0){ad()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{ad()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[105864>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=105896+(r<<2)|0;o=105896+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[26464]=f&~(1<<t)}else{if(n>>>0<(c[105872>>2]|0)>>>0){ad()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{ad()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[105864>>2]|0;if((n|0)!=0){f=c[105876>>2]|0;e=n>>>3;n=e<<1;g=105896+(n<<2)|0;m=c[26464]|0;j=1<<e;do{if((m&j|0)==0){c[26464]=m|j;u=105896+(n+2<<2)|0;v=g}else{e=105896+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[105872>>2]|0)>>>0)){u=e;v=h;break}ad()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[105864>>2]=o;c[105876>>2]=s;p=k;i=b;return p|0}n=c[105860>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[106160+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[105872>>2]|0;if(h>>>0<k>>>0){ad()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){ad()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){ad()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){ad()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){ad()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{ad()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=106160+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<h);break a}else{if(s>>>0<(c[105872>>2]|0)>>>0){ad()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[105872>>2]|0)>>>0){ad()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[105864>>2]|0;if((h|0)!=0){s=c[105876>>2]|0;k=h>>>3;h=k<<1;f=105896+(h<<2)|0;m=c[26464]|0;g=1<<k;do{if((m&g|0)==0){c[26464]=m|g;A=105896+(h+2<<2)|0;B=f}else{k=105896+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[105872>>2]|0)>>>0)){A=k;B=e;break}ad()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[105864>>2]=t;c[105876>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[105860>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[106160+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[106160+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[105864>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[105872>>2]|0;if(t>>>0<f>>>0){ad()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){ad()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){ad()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){ad()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){ad()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{ad()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=106160+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<e);break c}else{if(t>>>0<(c[105872>>2]|0)>>>0){ad()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[105872>>2]|0)>>>0){ad()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=105896+(t<<2)|0;s=c[26464]|0;r=1<<e;do{if((s&r|0)==0){c[26464]=s|r;S=105896+(t+2<<2)|0;T=f}else{e=105896+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[105872>>2]|0)>>>0)){S=e;T=k;break}ad()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=106160+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[105860>>2]|0;l=1<<U;if((f&l|0)==0){c[105860>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[105872>>2]|0;if(W>>>0<k>>>0){ad()}if(r>>>0<k>>>0){ad()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[105864>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[105876>>2]|0;if(W>>>0>15){c[105876>>2]=X+q;c[105864>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[105864>>2]=0;c[105876>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[105868>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[105868>>2]=W;X=c[105880>>2]|0;c[105880>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[26582]|0)==0){X=_c(30)|0;if((X+ -1&X|0)==0){c[106336>>2]=X;c[106332>>2]=X;c[106340>>2]=-1;c[106344>>2]=-1;c[106348>>2]=0;c[106300>>2]=0;c[26582]=(oc(0)|0)&-16^1431655768;break}else{ad()}}}while(0);X=q+48|0;W=c[106336>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[106296>>2]|0;do{if((U|0)!=0){T=c[106288>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[106300>>2]&4|0)==0){U=c[105880>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=106304|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[105868>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=hb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=hb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[106332>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[106288>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[106296>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=hb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[106336>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((hb(t|0)|0)==(-1|0)){hb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[106300>>2]=c[106300>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=hb(W|0)|0;ha=hb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[106288>>2]|0)+ga|0;c[106288>>2]=ia;if(ia>>>0>(c[106292>>2]|0)>>>0){c[106292>>2]=ia}ia=c[105880>>2]|0;W=106304|0;i:do{if((ia|0)==0){aa=c[105872>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[105872>>2]=fa}c[106304>>2]=fa;c[106308>>2]=ga;c[106316>>2]=0;c[105892>>2]=c[26582];c[105888>>2]=-1;aa=0;do{ha=aa<<1;$=105896+(ha<<2)|0;c[105896+(ha+3<<2)>>2]=$;c[105896+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[105880>>2]=fa+ja;c[105868>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[105884>>2]=c[106344>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[105868>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[105880>>2]=ia+na;c[105868>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[105884>>2]=c[106344>>2];break i}}while(0);if(fa>>>0<(c[105872>>2]|0)>>>0){c[105872>>2]=fa}aa=fa+ga|0;$=106304|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[105880>>2]|0)){ca=(c[105868>>2]|0)+X|0;c[105868>>2]=ca;c[105880>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[105876>>2]|0)){ca=(c[105864>>2]|0)+X|0;c[105864>>2]=ca;c[105876>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=105896+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[105872>>2]|0)>>>0){ad()}if((c[V+12>>2]|0)==(ha|0)){break}ad()}}while(0);if((L|0)==(V|0)){c[26464]=c[26464]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[105872>>2]|0)>>>0){ad()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}ad()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[105872>>2]|0)>>>0){ad()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){ad()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{ad()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=106160+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<t);break k}else{if(T>>>0<(c[105872>>2]|0)>>>0){ad()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[105872>>2]|0)>>>0){ad()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=105896+(Z<<2)|0;t=c[26464]|0;T=1<<ca;do{if((t&T|0)==0){c[26464]=t|T;xa=105896+(Z+2<<2)|0;ya=ea}else{ca=105896+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[105872>>2]|0)>>>0)){xa=ca;ya=V;break}ad()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=106160+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[105860>>2]|0;L=1<<za;if((ea&L|0)==0){c[105860>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[105872>>2]|0;if(Ba>>>0<S>>>0){ad()}if(T>>>0<S>>>0){ad()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=106304|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[105880>>2]=fa+Ha;c[105868>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[105884>>2]=c[106344>>2];c[ba+4>>2]=27;X=106304|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[106304>>2]=fa;c[106308>>2]=ga;c[106316>>2]=0;c[106312>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=105896+(da<<2)|0;aa=c[26464]|0;f=1<<M;do{if((aa&f|0)==0){c[26464]=aa|f;Ia=105896+(da+2<<2)|0;Ja=ha}else{M=105896+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[105872>>2]|0)>>>0)){Ia=M;Ja=T;break}ad()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=106160+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[105860>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[105860>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[105872>>2]|0;if(Ma>>>0<f>>>0){ad()}if(M>>>0<f>>>0){ad()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[105868>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[105868>>2]=W;ia=c[105880>>2]|0;c[105880>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Jc()|0)>>2]=12;p=0;i=b;return p|0}function bR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[105872>>2]|0;if(d>>>0<f>>>0){ad()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){ad()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){ad()}if((p|0)==(c[105876>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[105864>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=105896+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){ad()}if((c[m+12>>2]|0)==(p|0)){break}ad()}}while(0);if((u|0)==(m|0)){c[26464]=c[26464]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){ad()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}ad()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){ad()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){ad()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){ad()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{ad()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=106160+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[105872>>2]|0)>>>0){ad()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[105872>>2]|0)>>>0){ad()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){ad()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){ad()}do{if((C&2|0)==0){if((l|0)==(c[105880>>2]|0)){f=(c[105868>>2]|0)+t|0;c[105868>>2]=f;c[105880>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[105876>>2]|0)){i=b;return}c[105876>>2]=0;c[105864>>2]=0;i=b;return}if((l|0)==(c[105876>>2]|0)){f=(c[105864>>2]|0)+t|0;c[105864>>2]=f;c[105876>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=105896+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[105872>>2]|0)>>>0){ad()}if((c[E+12>>2]|0)==(l|0)){break}ad()}}while(0);if((w|0)==(E|0)){c[26464]=c[26464]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[105872>>2]|0)>>>0){ad()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}ad()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[105872>>2]|0)>>>0){ad()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){ad()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{ad()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=106160+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<g);break b}else{if(d>>>0<(c[105872>>2]|0)>>>0){ad()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[105872>>2]|0)>>>0){ad()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[105876>>2]|0)){J=f;break}c[105864>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=105896+(C<<2)|0;G=c[26464]|0;j=1<<t;do{if((G&j|0)==0){c[26464]=G|j;K=105896+(C+2<<2)|0;L=e}else{t=105896+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[105872>>2]|0)>>>0)){K=t;L=a;break}ad()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=106160+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[105860>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[105860>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[105872>>2]|0;if(O>>>0<K>>>0){ad()}if(f>>>0<K>>>0){ad()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[105888>>2]|0)+ -1|0;c[105888>>2]=s;if((s|0)==0){Q=106312|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[105888>>2]=-1;i=b;return}function cR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=aR(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}IR(b|0,0,e|0)|0;i=d;return b|0}function dR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=aR(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Jc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=eR(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=aR(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;GR(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;bR(a);e=g;i=d;return e|0}function eR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[105872>>2]|0;if(h>>>0<l>>>0){ad()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){ad()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){ad()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[106336>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;fR(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[105880>>2]|0)){m=(c[105868>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[105880>>2]=a+b;c[105868>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[105876>>2]|0)){h=(c[105864>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[105864>>2]=r;c[105876>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=105896+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){ad()}if((c[h+12>>2]|0)==(k|0)){break}ad()}}while(0);if((m|0)==(h|0)){c[26464]=c[26464]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){ad()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}ad()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){ad()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){ad()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){ad()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{ad()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=106160+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<u);break a}else{if(t>>>0<(c[105872>>2]|0)>>>0){ad()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[105872>>2]|0)>>>0){ad()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;fR(a+b|0,r);o=a;i=d;return o|0}return 0}function fR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[105872>>2]|0;if(j>>>0<m>>>0){ad()}if((k|0)==(c[105876>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[105864>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=105896+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){ad()}if((c[q+12>>2]|0)==(k|0)){break}ad()}}while(0);if((r|0)==(q|0)){c[26464]=c[26464]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){ad()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}ad()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){ad()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){ad()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){ad()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{ad()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=106160+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[105872>>2]|0)>>>0){ad()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[105872>>2]|0)>>>0){ad()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[105872>>2]|0;if(e>>>0<z>>>0){ad()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[105880>>2]|0)){t=(c[105868>>2]|0)+p|0;c[105868>>2]=t;c[105880>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[105876>>2]|0)){i=d;return}c[105876>>2]=0;c[105864>>2]=0;i=d;return}if((f|0)==(c[105876>>2]|0)){t=(c[105864>>2]|0)+p|0;c[105864>>2]=t;c[105876>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=105896+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){ad()}if((c[u+12>>2]|0)==(f|0)){break}ad()}}while(0);if((h|0)==(u|0)){c[26464]=c[26464]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){ad()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}ad()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){ad()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){ad()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){ad()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{ad()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=106160+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[105860>>2]=c[105860>>2]&~(1<<j);break b}else{if(m>>>0<(c[105872>>2]|0)>>>0){ad()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[105872>>2]|0)>>>0){ad()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[105872>>2]|0)>>>0){ad()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[105876>>2]|0)){G=t;break}c[105864>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=105896+(B<<2)|0;D=c[26464]|0;b=1<<p;do{if((D&b|0)==0){c[26464]=D|b;H=105896+(B+2<<2)|0;I=A}else{p=105896+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[105872>>2]|0)>>>0)){H=p;I=a;break}ad()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=106160+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[105860>>2]|0;B=1<<J;if((a&B|0)==0){c[105860>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[105872>>2]|0)>>>0){ad()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[105872>>2]|0;if(L>>>0<B>>>0){ad()}if(G>>>0<B>>>0){ad()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function gR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=aR(d)|0;if((e|0)!=0){f=6;break}a=c[26588]|0;c[26588]=0+a;if((a|0)==0){f=5;break}te[a&7]()}if((f|0)==5){d=Ac(4)|0;c[d>>2]=106368;Kd(d|0,106416,136)}else if((f|0)==6){i=b;return e|0}return 0}function hR(a){a=a|0;var b=0,c=0;b=i;c=gR(a)|0;i=b;return c|0}function iR(a){a=a|0;var b=0;b=i;if((a|0)!=0){bR(a)}i=b;return}function jR(a){a=a|0;var b=0;b=i;iR(a);i=b;return}function kR(a){a=a|0;var b=0;b=i;wb(a|0);iR(a);i=b;return}function lR(a){a=a|0;var b=0;b=i;wb(a|0);i=b;return}function mR(a){a=a|0;i=i;return 106384}function nR(){var a=0;a=Ac(4)|0;c[a>>2]=106368;Kd(a|0,106416,136)}



function Vh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;gi(f,g+20|0);while(1){d=hi(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}Yd[c[b+8>>2]&255](c[d+20>>2]|0)}li(g);li(g+132|0);li(g+20|0);li(g+40|0);li(g+60|0);Uh(g+80|0);Uh(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Yd[m&255](o);i=e;return}Yd[c[b+8>>2]&255](c[g+184>>2]|0);Yd[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Yd[m&255](o);i=e;return}function Wh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Xh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Yh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Zh(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=$h(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{GR(f|0,b|0,d|0)|0;j=ai(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=ve[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){we[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function Zh(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Wi()|0}if((a[e+236|0]|0)!=0){f=Rh(e,9920)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function _h(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function $h(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;HR(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=$d[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;GR(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;Yd[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function ai(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Zh(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=ve[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);we[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function bi(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function ci(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}we[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function di(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){se[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Vd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];se[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function ei(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[8144+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;GR((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=me[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=$d[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){GR(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function gi(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function hi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function ii(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=$d[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){IR(c[m>>2]|0,0,g|0)|0;g=ji(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=ji(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((ki(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=$d[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}IR(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=ji(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}Yd[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=$d[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){IR(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function ji(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function ki(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function li(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}Yd[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}Yd[e&255](c[d>>2]|0);i=b;return}function mi(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[9728+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[9768+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=me[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=$d[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=$d[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}Yd[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;GR(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}se[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function ni(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ee[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Vi(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function oi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=ve[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=pi(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function pi(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case-4:{r=13;break a;break};case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ne[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=qi(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=ii(o,l+132|0,9800,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((ve[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=ri(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}si(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=ri(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Vd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Oh(o+416|0);h=0;break};case 57:{v=qi(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=vi(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Vd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Oh(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=ii(o,l+132|0,9800,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ne[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}Yd[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=ui(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=9904}else{x=(s|0)==32?9888:9912}if((wi(o+416|0,x)|0)==0){r=111;break a}if((xi(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=9808;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=9816;r=102;break};case 25:{c[o+332>>2]=9824;r=102;break};case 26:{c[o+332>>2]=9832;r=102;break};case 27:{c[o+332>>2]=9840;r=102;break};case 28:{c[o+332>>2]=9848;r=102;break};case 29:{c[o+332>>2]=9864;r=102;break};case 30:{c[o+332>>2]=9872;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((yi(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((fi(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((fi(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;he[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Oh(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=ri(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=9800}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=ii(o,l+132|0,9800,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=zi(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((yi(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((fi(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((fi(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;he[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);Oh(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=Ai(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;le[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;le[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=ri(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;he[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;le[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((ee[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=ri(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=ii(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=ri(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=ii(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){di(o,b,e,c[n>>2]|0)}h=0;D=Bi(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=ri(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((ve[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=ri(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}si(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=ri(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Vd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);Oh(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Vd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Oh(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=$d[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=me[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=me[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=Di(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=ri(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=ii(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}se[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=Ei(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(ne[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=ui(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=$d[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;se[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((Hi(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((Gi(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((ve[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=ri(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=Di(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=ui(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=Fi(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;se[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=ri(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}si(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}di(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=ve[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((ne[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=ii(o,l+132|0,9800,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ne[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=ti(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function qi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((_d[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=ri(n+440|0,p,b,s+(me[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=ri(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);we[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}di(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=ri(n+440|0,e,d,m+(me[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Vi(n,f)|0;Oh(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Oh(n+440|0)}q=0;r=q;i=g;return r|0}function ri(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((xi(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((fi(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function si(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function ti(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Ki(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Si(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function ui(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=ri(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=ii(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Ti(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function vi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((fi(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=ri(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=ii(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=ii(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((fi(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((fi(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=ii(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function wi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((fi(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function xi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((fi(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Vd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((fi(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function yi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=$d[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=me[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function zi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Ui(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((fi(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function Ai(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((fi(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(ve[c[b+20>>2]&63](b,e,f,j)|0){case-4:{r=24;break a;break};case 6:case 9:{if((xi(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=ri(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=ii(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=Ai(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(ne[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 10:{s=me[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=$i(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((fi(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 7:{r=28;break};case-1:{r=46;break a;break};case 0:{r=49;break a;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((fi(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function Bi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=ve[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){di(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function Ci(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Bi(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=oi(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function Di(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=$d[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=me[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=$d[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function Ei(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=$d[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=ve[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=pi(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=Ki(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function Fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=$d[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;Ji(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function Gi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){di(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(me[c[a+32>>2]&63](a,b)|0)|0;k=ri(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=me[c[a+36>>2]&63](a,e)|0;e=ri(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){Ii(e);se[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Oh(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Hi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){di(g,a,b,d)}h=1;j=h;i=f;return j|0}k=ri(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){Ii(k);Zd[c[g+68>>2]&63](c[g+4>>2]|0,k);Oh(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Ii(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function Ji(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}Ji(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function Ki(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=ve[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 3:case 4:{B=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;C=1;c[t>>2]=ri(y+416|0,e,B,B+(me[c[e+32>>2]&63](e,B)|0)|0)|0;if((c[t>>2]|0)==0){D=89;break a}c[y+432>>2]=c[y+428>>2];E=Ni(y,e,c[m>>2]|0,t,s)|0;if((E|0)!=0){D=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){se[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);C=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}Zd[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);C=0}do{if((C&255|0)!=0){if((c[y+80>>2]|0)==0){break}di(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Oh(y+416|0);while(1){if((c[s>>2]|0)==0){break}C=c[s>>2]|0;if((c[y+104>>2]|0)!=0){Zd[c[y+104>>2]&63](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){D=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){D=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;F=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;B=me[c[e+32>>2]&63](e,F)|0;if((B|0)!=(c[C+8>>2]|0)){D=112;break a}if((zR(c[C+4>>2]|0,F,B)|0)!=0){D=112;break a}B=y+312|0;c[B>>2]=(c[B>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){B=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((B|0)==0){break}G=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[B]|0)==0){break}H=B;B=H+1|0;I=G;G=I+1|0;a[I]=a[H]|0}H=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((H|0)==0){break}I=G;G=I+1|0;a[I]=a[y+472|0]|0;while(1){if((a[H]|0)==0){break c}I=H;H=I+1|0;J=G;G=J+1|0;a[J]=a[I]|0}}}while(0);a[G]=0}}while(0);Zd[c[y+56>>2]&63](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}di(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}B=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){Zd[c[y+104>>2]&63](c[y+4>>2]|0,c[c[B>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[B+4>>2]=c[y+376>>2];c[y+376>>2]=B;c[(c[B>>2]|0)+4>>2]=c[B+8>>2]}if((c[y+312>>2]|0)==0){D=133;break a}break};case 9:{a[p]=ee[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){se[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=ri(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){D=37;break a}B=ii(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){D=40;break}if((B|0)!=0){break}H=y;if((c[y+120>>2]|0)!=0){se[c[H+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[H+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{D=40}}while(0);if((D|0)==40){D=0;if((B|0)==0){D=41;break a}if((a[B+34|0]|0)==0){D=43;break a}}if((a[B+32|0]|0)!=0){D=50;break a}if((c[B+28>>2]|0)!=0){D=52;break a}C=y;if((c[B+4>>2]|0)!=0){H=y;if((a[C+308|0]|0)!=0){K=Ei(H,B,0)|0;if((K|0)!=0){D=60;break a}else{break b}}I=y;if((c[H+120>>2]|0)!=0){se[c[I+120>>2]&15](c[y+4>>2]|0,c[B>>2]|0,0);break b}if((c[I+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[B+32|0]=1;C=Mi(y)|0;a[B+32|0]=0;if((C|0)==0){D=63;break a}if((ne[c[y+112>>2]&63](c[y+116>>2]|0,C,c[B+20>>2]|0,c[B+16>>2]|0,c[B+24>>2]|0)|0)==0){D=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 10:{C=me[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((C|0)<0){D=135;break a}I=y;if((c[y+60>>2]|0)!=0){H=c[I+60>>2]|0;J=c[y+4>>2]|0;L=$i(C,u)|0;se[H&15](J,u,L);break b}if((c[I+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{I=y;do{if((c[y+72>>2]|0)!=0){Yd[c[I+72>>2]&255](c[y+4>>2]|0)}else{if((c[I+80>>2]|0)==0){break}di(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);M=Pi(y,e,n,g,h,j)|0;if((M|0)!=0){D=150;break a}if((c[n>>2]|0)==0){D=152;break a}break};case-5:{D=153;break a;break};case 6:{I=c[y+60>>2]|0;if((I|0)==0){if((c[y+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){se[I&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Vd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];se[I&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((Gi(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=174;break a}break};case 13:{if((Hi(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=176;break a}break};case 0:{D=24;break a;break};case-1:{D=25;break a;break};case-2:{D=28;break a;break};case-4:{D=17;break a;break};case 1:case 2:{I=y;if((c[y+368>>2]|0)!=0){N=c[I+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{N=$d[c[I+12>>2]&127](48)|0;if((N|0)==0){D=72;break a}c[N+36>>2]=$d[c[y+12>>2]&127](32)|0;if((c[N+36>>2]|0)==0){D=74;break a}c[N+40>>2]=(c[N+36>>2]|0)+32}c[N+44>>2]=0;c[N>>2]=c[y+364>>2];c[y+364>>2]=N;c[N+16>>2]=0;c[N+20>>2]=0;c[N+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[N+8>>2]=me[c[e+32>>2]&63](e,c[N+4>>2]|0)|0;I=y+312|0;c[I>>2]=(c[I>>2]|0)+1;I=(c[N+4>>2]|0)+(c[N+8>>2]|0)|0;c[r>>2]=c[N+4>>2];c[q>>2]=c[N+36>>2];while(1){Vd[c[e+60>>2]&31](e,r,I,q,(c[N+40>>2]|0)+ -1|0);O=(c[q>>2]|0)-(c[N+36>>2]|0)|0;if((c[r>>2]|0)==(I|0)){break}B=(c[N+40>>2]|0)-(c[N+36>>2]|0)<<1;L=me[c[y+16>>2]&63](c[N+36>>2]|0,B)|0;if((L|0)==0){D=80;break a}c[N+36>>2]=L;c[N+40>>2]=L+B;c[q>>2]=L+O}c[N+24>>2]=O;c[N+12>>2]=c[N+36>>2];a[c[q>>2]|0]=0;P=Ni(y,e,c[m>>2]|0,N+12|0,N+44|0)|0;if((P|0)!=0){D=82;break a}I=y;do{if((c[y+52>>2]|0)!=0){se[c[I+52>>2]&15](c[y+4>>2]|0,c[N+12>>2]|0,c[y+392>>2]|0)}else{if((c[I+80>>2]|0)==0){break}di(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Oh(y+416|0);break};case 12:{D=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;se[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0);break};case-3:{D=6;break a;break};default:{if((c[y+80>>2]|0)==0){break b}di(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){D=181;break}else if((f|0)==3){D=180;break}}if((D|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;se[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}di(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=g;Q=0;R=Q;i=l;return R|0}}else if((D|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}if((b|0)<=0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}}else if((D|0)==24){c[z>>2]=c[n>>2];Q=4;R=Q;i=l;return R|0}else if((D|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=5;R=Q;i=l;return R|0}}else if((D|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=6;R=Q;i=l;return R|0}}else if((D|0)==37){Q=1;R=Q;i=l;return R|0}else if((D|0)==41){Q=11;R=Q;i=l;return R|0}else if((D|0)==43){Q=24;R=Q;i=l;return R|0}else if((D|0)==50){Q=12;R=Q;i=l;return R|0}else if((D|0)==52){Q=15;R=Q;i=l;return R|0}else if((D|0)==60){Q=K;R=Q;i=l;return R|0}else if((D|0)==63){Q=1;R=Q;i=l;return R|0}else if((D|0)==65){Q=21;R=Q;i=l;return R|0}else if((D|0)==72){Q=1;R=Q;i=l;return R|0}else if((D|0)==74){Yd[c[y+20>>2]&255](N);Q=1;R=Q;i=l;return R|0}else if((D|0)==80){Q=1;R=Q;i=l;return R|0}else if((D|0)==82){Q=P;R=Q;i=l;return R|0}else if((D|0)==89){Q=1;R=Q;i=l;return R|0}else if((D|0)==91){Q=E;R=Q;i=l;return R|0}else if((D|0)==107){Q=Oi(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((D|0)==109){Q=13;R=Q;i=l;return R|0}else if((D|0)==112){c[z>>2]=F;Q=7;R=Q;i=l;return R|0}else if((D|0)==133){Q=Oi(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((D|0)==135){Q=14;R=Q;i=l;return R|0}else if((D|0)==140){Q=17;R=Q;i=l;return R|0}else if((D|0)==150){Q=M;R=Q;i=l;return R|0}else if((D|0)==152){c[y+280>>2]=42;Q=M;R=Q;i=l;return R|0}else if((D|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){se[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Vd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);se[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}di(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;Q=3;R=Q;i=l;return R|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;Q=13;R=Q;i=l;return R|0}else{c[h>>2]=m;Q=0;R=Q;i=l;return R|0}}else if((D|0)==174){Q=1;R=Q;i=l;return R|0}else if((D|0)==176){Q=1;R=Q;i=l;return R|0}else if((D|0)==180){c[h>>2]=c[n>>2];Q=0;R=Q;i=l;return R|0}else if((D|0)==181){Q=35;R=Q;i=l;return R|0}return 0}function Li(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=ve[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=pi(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=Ki(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=ve[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=pi(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Ki(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function Mi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((fi(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);gi(e,b+60|0);a:while(1){k=hi(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((fi(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((fi(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){gi(e,b);b:while(1){b=hi(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((fi(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((fi(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}



function zg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;On(ag,1,$f);if(!(d>0.0)){$f=zn(zn(3848,xn(d,0,1,6)|0)|0,3912)|0;bg=c[16252]|0;cg=f+96|0;c[cg+0>>2]=c[3928+0>>2];c[cg+4>>2]=c[3928+4>>2];c[cg+8>>2]=c[3928+8>>2];c[cg+12>>2]=c[3928+12>>2];c[cg+16>>2]=c[3928+16>>2];c[cg+20>>2]=c[3928+20>>2];we[bg&31](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=zn(zn(3952,xn(d,0,1,6)|0)|0,4e3)|0;$f=c[16252]|0;bg=f+72|0;c[bg+0>>2]=c[4032+0>>2];c[bg+4>>2]=c[4032+4>>2];c[bg+8>>2]=c[4032+8>>2];c[bg+12>>2]=c[4032+12>>2];c[bg+16>>2]=c[4032+16>>2];c[bg+20>>2]=c[4032+20>>2];we[$f&31](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=zn(zn(4056,xn(e,0,1,6)|0)|0,4104)|0;_f=c[16252]|0;$f=f+48|0;c[$f+0>>2]=c[4136+0>>2];c[$f+4>>2]=c[4136+4>>2];c[$f+8>>2]=c[4136+8>>2];c[$f+12>>2]=c[4136+12>>2];c[$f+16>>2]=c[4136+16>>2];c[$f+20>>2]=c[4136+20>>2];we[_f&31](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=zn(zn(4160,xn(e,0,1,6)|0)|0,4216)|0;Zf=c[16252]|0;_f=f+24|0;c[_f+0>>2]=c[4264+0>>2];c[_f+4>>2]=c[4264+4>>2];c[_f+8>>2]=c[4264+8>>2];c[_f+12>>2]=c[4264+12>>2];c[_f+16>>2]=c[4264+16>>2];c[_f+20>>2]=c[4264+20>>2];we[Zf&31](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(Un(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(Un(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(Un(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(Un(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(Un(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(Un(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(Un(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(Un(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(Un(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(Un(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(Un(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(Un(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(Un(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(Un(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(Un(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(Un(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(Un(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(Un(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(Un(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(Un(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(Un(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(Un(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(Un(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(Un(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(Un(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(Un(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(Un(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(Un(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(Un(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(Un(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(Un(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(Un(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(Un(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(Un(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(Un(ag,1,of)|0)>>3];c[nf>>2]=16;h[(Un(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(Un(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(Un(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(Un(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(Un(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(Un(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(Un(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(Un(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(Un(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(Un(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(Un(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(Un(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(Un(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(Un(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(Un(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(Un(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(Un(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(Un(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(Un(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(Un(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(Un(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(Un(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(Un(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(Un(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(Un(ag,1,Qe)|0)>>3];c[Pe>>2]=25;h[(Un(ag,1,Pe)|0)>>3]=fg*fg;c[Oe>>2]=11;fg=+h[(Un(ag,1,Oe)|0)>>3];c[Ne>>2]=12;gg=+h[(Un(ag,1,Ne)|0)>>3];c[Me>>2]=25;eg=fg*gg*dg*+h[(Un(ag,1,Me)|0)>>3];c[Le>>2]=26;h[(Un(ag,1,Le)|0)>>3]=eg;c[Ke>>2]=10;eg=+h[(Un(ag,1,Ke)|0)>>3];c[Je>>2]=12;gg=eg*+h[(Un(ag,1,Je)|0)>>3];c[Ie>>2]=27;h[(Un(ag,1,Ie)|0)>>3]=gg;c[He>>2]=1;gg=+h[(Un(ag,1,He)|0)>>3];c[Ge>>2]=10;eg=+h[(Un(ag,1,Ge)|0)>>3];c[Fe>>2]=11;fg=gg*eg*dg*+h[(Un(ag,1,Fe)|0)>>3];c[Ee>>2]=28;h[(Un(ag,1,Ee)|0)>>3]=fg;c[De>>2]=10;fg=+h[(Un(ag,1,De)|0)>>3];c[Ce>>2]=12;eg=+h[(Un(ag,1,Ce)|0)>>3];c[Be>>2]=25;gg=fg*eg*dg*+h[(Un(ag,1,Be)|0)>>3];c[Ae>>2]=29;h[(Un(ag,1,Ae)|0)>>3]=gg;c[ze>>2]=1;gg=+h[(Un(ag,1,ze)|0)>>3];c[ye>>2]=10;eg=+h[(Un(ag,1,ye)|0)>>3];c[xe>>2]=25;fg=gg*eg*dg*+h[(Un(ag,1,xe)|0)>>3];c[ve>>2]=30;h[(Un(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(Un(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(Un(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(Un(ag,1,se)|0)>>3];c[re>>2]=31;h[(Un(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(Un(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(Un(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(Un(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(Un(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(Un(ag,1,me)|0)>>3];c[le>>2]=34;h[(Un(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(Un(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(Un(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(Un(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(Un(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(Un(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(Un(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(Un(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(Un(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(Un(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(Un(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(Un(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(Un(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(Un(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(Un(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(Un(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(Un(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(Un(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(Un(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(Un(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(Un(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(Un(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(Un(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(Un(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(Un(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(Un(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(Un(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(Un(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(Un(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(Un(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(Un(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(Un(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(Un(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(Un(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(Un(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(Un(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(Un(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(Un(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function Ag(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;On(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(Un(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(Un(od,1,ld)|0)>>3];c[kd>>2]=2;h[(Un(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(Un(od,1,jd)|0)>>3];c[id>>2]=3;h[(Un(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(Un(od,1,hd)|0)>>3];c[gd>>2]=4;h[(Un(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(Un(od,1,fd)|0)>>3];c[ed>>2]=5;h[(Un(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(Un(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(Un(od,1,cd)|0)>>3];c[bd>>2]=6;h[(Un(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(Un(od,1,ad)|0)>>3];c[$c>>2]=7;h[(Un(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(Un(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(Un(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(Un(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(Un(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(Un(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(Un(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(Un(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(Un(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(Un(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(Un(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(Un(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(Un(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(Un(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(Un(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(Un(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(Un(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(Un(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(Un(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(Un(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(Un(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(Un(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(Un(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(Un(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(Un(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(Un(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(Un(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(Un(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(Un(od,1,zc)|0)>>3];c[yc>>2]=18;h[(Un(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(Un(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(Un(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(Un(od,1,vc)|0)>>3];c[uc>>2]=19;h[(Un(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(Un(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(Un(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(Un(od,1,rc)|0)>>3];c[qc>>2]=20;h[(Un(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(Un(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(Un(od,1,oc)|0)>>3];c[nc>>2]=21;h[(Un(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(Un(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(Un(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(Un(od,1,kc)|0)>>3];c[jc>>2]=22;h[(Un(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(Un(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(Un(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(Un(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(Un(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(Un(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(Un(od,1,dc)|0)>>3];c[cc>>2]=25;h[(Un(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(Un(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(Un(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(Un(od,1,$b)|0)>>3];c[_b>>2]=27;h[(Un(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(Un(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(Un(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(Un(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(Un(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(Un(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(Un(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(Un(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(Un(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(Un(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(Un(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(Un(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(Un(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(Un(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(Un(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(Un(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(Un(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(Un(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(Un(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(Un(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(Un(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(Un(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(Un(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(Un(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(Un(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(Un(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(Un(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(Un(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(Un(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(Un(od,1,xb)|0)>>3];c[wb>>2]=40;h[(Un(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[16252]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=4848;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];we[xb&31](b,g,2112,vb);}c[ub>>2]=3;rd=+h[(Un(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(Un(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(Un(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(Un(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(Un(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(Un(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(Un(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(Un(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(Un(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(Un(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(Un(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(Un(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(Un(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(Un(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(Un(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(Un(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(Un(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(Un(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(Un(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(Un(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(Un(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(Un(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(Un(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(Un(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(Un(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(Un(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(Un(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(Un(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(Un(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(Un(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(Un(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(Un(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(Un(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(Un(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(Un(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(Un(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(Un(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(Un(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(Un(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(Un(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(Un(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(Un(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(Un(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(Un(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(Un(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(Un(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(Un(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(Un(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(Un(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(Un(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(Un(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(Un(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(Un(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(Un(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(Un(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(Un(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(Un(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(Un(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(Un(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(Un(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(Un(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(Un(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(Un(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(Un(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(Un(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(Un(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(Un(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(Un(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(Un(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(Un(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(Un(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(Un(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(Un(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(Un(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(Un(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(Un(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(Un(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(Un(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(Un(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(Un(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(Un(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(Un(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(Un(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(Un(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(Un(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(Un(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(Un(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(Un(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(Un(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(Un(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(Un(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(Un(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(Un(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(Un(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(Un(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(Un(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(Un(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(Un(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(Un(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(Un(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(Un(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(Un(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(Un(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(Un(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(Un(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(Un(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(Un(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(Un(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(Un(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(Un(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(Un(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(Un(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(Un(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(Un(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(Un(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(Un(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(Un(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(Un(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(Un(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(Un(l,1,tb)|0)>>3];c[ub>>2]=52;h[(Un(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(Un(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(Un(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(Un(l,1,xb)|0)>>3];c[yb>>2]=53;h[(Un(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(Un(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(Un(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(Un(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(Un(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(Un(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(Un(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(Un(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[16252]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[4848+0>>2];c[a+4>>2]=c[4848+4>>2];c[a+8>>2]=c[4848+8>>2];c[a+12>>2]=c[4848+12>>2];c[a+16>>2]=c[4848+16>>2];c[a+20>>2]=c[4848+20>>2];we[Gd&31](d,a,2568,Gb);}c[Hb>>2]=9;Ed=+h[(Un(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(Un(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(Un(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(Un(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(Un(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(Un(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(Un(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(Un(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(Un(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(Un(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(Un(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(Un(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(Un(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(Un(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(Un(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(Un(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(Un(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(Un(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(Un(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(Un(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(Un(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(Un(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(Un(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(Un(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(Un(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(Un(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(Un(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(Un(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(Un(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(Un(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(Un(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(Un(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(Un(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(Un(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(Un(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(Un(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(Un(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(Un(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(Un(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(Un(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(Un(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(Un(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(Un(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(Un(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(Un(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(Un(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(Un(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(Un(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(Un(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(Un(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(Un(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(Un(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(Un(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(Un(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(Un(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(Un(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(Un(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(Un(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(Un(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(Un(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(Un(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(Un(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(Un(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(Un(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(Un(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(Un(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(Un(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(Un(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(Un(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(Un(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(Un(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(Un(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(Un(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(Un(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(Un(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(Un(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(Un(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(Un(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(Un(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(Un(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(Un(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(Un(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(Un(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(Un(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(Un(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(Un(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(Un(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(Un(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(Un(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(Un(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(Un(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(Un(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(Un(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(Un(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(Un(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(Un(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(Un(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(Un(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(Un(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(Un(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(Un(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(Un(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(Un(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(Un(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(Un(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(Un(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(Un(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(Un(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(Un(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(Un(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(Un(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(Un(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(Un(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(Un(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(Un(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(Un(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(Un(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(Un(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(Un(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(Un(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(Un(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(Un(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(Un(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(Un(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(Un(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(Un(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(Un(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(Un(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(Un(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(Un(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(Un(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(Un(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(Un(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(Un(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(Un(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(Un(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(Un(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(Un(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(Un(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(Un(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(Un(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(Un(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(Un(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(Un(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(Un(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(Un(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(Un(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(Un(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(Un(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(Un(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(Un(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(Un(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(Un(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(Un(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(Un(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(Un(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(Un(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(Un(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(Un(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(Un(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(Un(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(Un(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(Un(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(Un(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(Un(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(Un(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(Un(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(Un(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(Un(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(Un(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(Un(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(Un(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(Un(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(Un(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(Un(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(Un(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(Un(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(Un(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(Un(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(Un(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(Un(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(Un(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(Un(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(Un(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(Un(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(Un(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(Un(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(Un(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(Un(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(Un(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(Un(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(Un(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(Un(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(Un(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(Un(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(Un(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(Un(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(Un(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(Un(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(Un(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(Un(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(Un(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(Un(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(Un(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(Un(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(Un(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(Un(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(Un(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(Un(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(Un(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(Un(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(Un(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(Un(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(Un(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(Un(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(Un(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(Un(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function oR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Kc=0,Lc=0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=rR(b)|0}}while((cd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=rR(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[106432+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=rR(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[106448+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=rR(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=rR(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=rR(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=rR(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=rR(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=rR(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=OR(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=OR(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=rR(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){qR(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=OR(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=pR(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){qR(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=JR(q|0,n|0,2)|0;o=OR(p|0,J|0,-32,-1)|0;p=OR(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Jc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Jc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=OR(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=NR(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=OR(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Id(+(+sR(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Jc()|0)>>2]=34}l=+tR(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=rR(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=rR(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=rR(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=OR(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=OR(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=rR(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=pR(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){qR(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=OR(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Jc()|0)>>2]=22;qR(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Jc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Jc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[106464+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[106464+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[106464+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=JR(c[Ra>>2]|0,0,29)|0;Qa=OR(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=YR(Qa|0,Ta|0,1e9,0)|0;pa=ZR(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=JR(c[Ua>>2]|0,0,29)|0;Ra=OR(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=YR(Ra|0,Sa|0,1e9,0)|0;Pa=ZR(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[106456+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Id(+(+sR(1.0,105-tc|0)),+sc);wc=+vc(+sc,+(+sR(1.0,53-tc|0)));xc=va;yc=wc;zc=va+(sc-wc)}else{xc=0.0;yc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=yc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=yc;break}}Bc=la*.25+yc}else{if(na>>>0>5e8){Bc=la*.75+yc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+yc;break}else{Bc=la*.75+yc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+vc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-xc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Jc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+tR(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=rR(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Kc=d[p]|0}else{Kc=rR(b)|0}if(!((Kc+ -48|0)>>>0<10|(Kc+ -65|0)>>>0<26)){if(!((Kc+ -97|0)>>>0<26|(Kc|0)==95)){break}}Ic=Ic+1|0}if((Kc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Jc()|0)>>2]=22;qR(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Lc=Ic}while(1){p=Lc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Lc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Jc()|0)>>2]=22;qR(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function pR(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=rR(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=rR(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=rR(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=XR(q|0,m|0,10,0)|0;b=J;g=OR(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=OR(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=rR(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=rR(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=NR(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function qR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function rR(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=vR(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function sR(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=JR(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function tR(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+sR(a,b);i=c;return+d}function uR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ee[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function vR(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((uR(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ee[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function wR(a){a=a|0;var b=0,c=0.0;b=i;c=+xR(a,0);i=b;return+c}function xR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;qR(e,0);h=+oR(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function yR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;qR(e,0);h=+oR(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function zR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function AR(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function BR(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function CR(){c[21692]=p;c[21734]=p;c[26376]=p;c[26606]=p}function DR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}ac(116);ac(111);ac(111);ac(32);ac(109);ac(97);ac(110);ac(121);ac(32);ac(115);ac(101);ac(116);ac(106);ac(109);ac(112);ac(115);ac(32);ac(105);ac(110);ac(32);ac(97);ac(32);ac(102);ac(117);ac(110);ac(99);ac(116);ac(105);ac(111);ac(110);ac(32);ac(99);ac(97);ac(108);ac(108);ac(44);ac(32);ac(98);ac(117);ac(105);ac(108);ac(100);ac(32);ac(119);ac(105);ac(116);ac(104);ac(32);ac(97);ac(32);ac(104);ac(105);ac(103);ac(104);ac(101);ac(114);ac(32);ac(118);ac(97);ac(108);ac(117);ac(101);ac(32);ac(102);ac(111);ac(114);ac(32);ac(77);ac(65);ac(88);ac(95);ac(83);ac(69);ac(84);ac(74);ac(77);ac(80);ac(83);ac(10);ga(0);return 0}function ER(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function FR(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function GR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return jb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function HR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{GR(b,c,d)|0}return b|0}function IR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function JR(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function KR(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function LR(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function MR(){return LR(o)|0}function NR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function OR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function PR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function QR(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function RR(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function SR(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function TR(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function UR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function VR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=NR(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=NR((_R(i,b,NR(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function WR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=NR(h^a,j^b,h,j)|0;b=J;_R(m,b,NR(k^d,l^e,k,l)|0,J,g)|0;l=NR(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function XR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=UR(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function YR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=_R(a,b,c,d,0)|0;return(J=J,e)|0}function ZR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;_R(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function _R(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((TR(l|0)|0)>>>0);return(J=n,o)|0}p=(SR(l|0)|0)-(SR(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(SR(l|0)|0)-(SR(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(SR(j|0)|0)+33-(SR(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=TR(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=OR(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;NR(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=NR(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function $R(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ud[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function aS(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Vd[a&31](b|0,c|0,d|0,e|0,f|0)}function bS(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return Wd[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function cS(a,b){a=a|0;b=+b;Xd[a&1](+b)}function dS(a,b){a=a|0;b=b|0;Yd[a&255](b|0)}function eS(a,b,c){a=a|0;b=b|0;c=c|0;Zd[a&63](b|0,c|0)}function fS(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return _d[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function gS(a,b){a=a|0;b=b|0;return $d[a&127](b|0)|0}function hS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ae[a&1](b|0,c|0,+d,e|0)}function iS(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return be[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function jS(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ce[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function kS(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return de[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function lS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ee[a&63](b|0,c|0,d|0)|0}function mS(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;fe[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function nS(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ge[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function oS(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;he[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function pS(a,b,c){a=a|0;b=b|0;c=+c;return ie[a&1](b|0,+c)|0}function qS(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;je[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function rS(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ke[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function sS(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;le[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function tS(a,b,c){a=a|0;b=b|0;c=c|0;return me[a&63](b|0,c|0)|0}function uS(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ne[a&63](b|0,c|0,d|0,e|0,f|0)|0}function vS(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return oe[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function wS(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return pe[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function xS(a){a=a|0;return qe[a&7]()|0}function yS(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return re[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function zS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;se[a&15](b|0,c|0,d|0)}function AS(a){a=a|0;te[a&7]()}function BS(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ue[a&3](b|0,c|0,+d,e|0,f|0)}function CS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ve[a&63](b|0,c|0,d|0,e|0)|0}function DS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;we[a&31](b|0,c|0,d|0,e|0)}function ES(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function FS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function GS(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function HS(a){a=+a;ga(3)}function IS(a){a=a|0;ga(4)}function JS(a){a=a|0;td(a|0)}function KS(a,b){a=a|0;b=b|0;ga(5)}function LS(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function MS(a){a=a|0;ga(7);return 0}function NS(a){a=a|0;return Kc(a|0)|0}function OS(a){a=a|0;return Cd(a|0)|0}function PS(a){a=a|0;return sc(a|0)|0}function QS(a){a=a|0;return rd(a|0)|0}function RS(a){a=a|0;return ed(a|0)|0}function SS(a){a=a|0;return md(a|0)|0}function TS(a){a=a|0;return Tc(a|0)|0}function US(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function VS(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function WS(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(10);return 0}function XS(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function YS(a,b,c){a=a|0;b=b|0;c=c|0;ga(12);return 0}function ZS(a,b,c){a=a|0;b=b|0;c=c|0;return od(a|0,b|0,c|0)|0}function _S(a,b,c){a=a|0;b=b|0;c=c|0;return ec(a|0,b|0,c|0)|0}function $S(a,b,c){a=a|0;b=b|0;c=c|0;return _b(a|0,b|0,c|0)|0}function aT(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function bT(a,b,c){a=a|0;b=b|0;c=c|0;return pd(a|0,b|0,c|0)|0}function cT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function dT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function eT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(15)}function fT(a,b){a=a|0;b=+b;ga(16);return 0}function gT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(17)}function hT(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(18)}function iT(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(19)}function jT(a,b){a=a|0;b=b|0;ga(20);return 0}function kT(a,b){a=a|0;b=b|0;return Hd(a|0,b|0)|0}function lT(a,b){a=a|0;b=b|0;return dc(a|0,b|0)|0}function mT(a,b){a=a|0;b=b|0;return fb(a|0,b|0)|0}function nT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(21);return 0}function oT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(22);return 0}function pT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(23);return 0}function qT(){ga(24);return 0}function rT(){return gb()|0}function sT(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(25);return 0}function tT(a,b,c){a=a|0;b=b|0;c=c|0;ga(26)}function uT(){ga(27)}function vT(){Qc()}function wT(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(28)}function xT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(29);return 0}function yT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nc(a|0,b|0,c|0,d|0)|0}function zT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ic(a|0,b|0,c|0,d|0)|0}function AT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(30)}




// EMSCRIPTEN_END_FUNCS
var Ud=[ES,jp,lp,qp,fE,ES,ES,ES];var Vd=[FS,Oj,Pj,sk,tk,Xk,Yk,tl,ul,vl,YQ,XQ,WQ,Vn,gj,hj,Qm,Sm,FS,FS,FS,FS,FS,FS,FS,FS,FS,FS,FS,FS,FS,FS];var Wd=[GS,Hq];var Xd=[HS,Xp];var Yd=[IS,Sg,Tg,Ug,Vg,kh,Xg,Nm,Ts,Ws,Vs,Xs,bJ,aJ,dJ,cJ,Ys,_s,kw,Iw,Jw,Kw,OI,NI,QI,PI,rD,DD,QD,RD,SD,UD,WD,KF,LF,RF,SF,YF,ZF,dG,eG,qG,pG,vG,uG,xG,yG,HG,GG,OH,NH,XH,WH,zI,yI,XI,WI,ZI,YI,pJ,oJ,rJ,qJ,xJ,wJ,MH,yJ,vJ,zJ,BJ,AJ,JN,HJ,GJ,MJ,LJ,jK,iK,NK,MK,$K,_K,nL,mL,BL,AL,OL,NL,RL,QL,VL,UL,eM,dM,pM,oM,AM,zM,LM,KM,VM,UM,bN,aN,hN,gN,nN,mN,sN,rN,BN,AN,ZN,YN,wN,oO,VO,UO,XO,WO,CJ,IN,LN,gO,wO,HO,SO,TO,JQ,IQ,LQ,OQ,MQ,NQ,PQ,QQ,lR,kR,df,JS,We,Xe,Ye,Te,Ue,Ve,Ze,_e,bR,Pm,Ne,Hp,Lp,Gp,Kq,Np,Iq,qo,Qp,Op,Pp,Mp,Sp,Jq,Tp,Ip,Vp,mD,Wp,iF,JF,KN,DP,NM,KP,JP,IP,HP,GP,FP,XG,zH,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS,IS];var Zd=[KS,Wg,pr,$s,mI,MF,TF,_F,fG,AI,YL,ZL,_L,$L,bM,cM,hM,iM,jM,kM,mM,nM,sM,tM,uM,vM,xM,yM,DM,EM,FM,GM,IM,JM,qN,vN,aP,cP,eP,bP,dP,fP,yp,Rp,Sv,rr,qr,sr,yr,Kr,tr,Ir,fv,rv,qv,sv,av,_u,cv,tE,KS,KS,KS,KS];var _d=[LS,vj,oj,kp,mp,np,op,pp];var $d=[MS,af,sh,$e,Pe,Qe,Re,lh,mh,bh,jh,rh,wh,ah,_g,xh,yh,zh,Ah,Bh,Ch,Dh,Eh,Fh,Gh,NS,OS,PS,ln,aR,QS,dt,rI,et,uI,qI,ZD,NF,FI,HI,II,EI,UF,VF,$F,tI,gG,hG,rG,wG,tJ,oL,gP,iP,kP,qP,sP,mP,oP,CL,hP,jP,lP,rP,tP,nP,pP,WL,XL,aM,fM,gM,lM,qM,rM,wM,BM,CM,HM,sO,tO,vO,YO,_O,ZO,$O,kO,lO,nO,CO,DO,GO,NO,OO,RO,KQ,mR,Rq,RS,SS,Pq,Qq,TS,fD,ID,cq,jq,sq,dq,mq,tq,BF,vR,MS,MS,MS,MS,MS,MS,MS,MS,MS,MS,MS,MS,MS,MS,MS];var ae=[US,Tn];var be=[VS,Zo];var ce=[WS,zo];var de=[XS,bp];var ee=[YS,Zg,Fj,Lj,jk,pk,Ok,Uk,at,sI,wI,nI,BI,GI,OF,KI,aG,BG,CG,FJ,KJ,oN,tN,$N,bO,eO,MN,RN,TN,WN,RQ,oD,Un,sj,jj,qj,wj,ZS,_S,$S,Lq,lD,hD,aT,tF,bT,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS,YS];var fe=[cT,VK,YK,hL,jL,cT,cT,cT];var ge=[dT,PL,SL,MM,QM,WM,YM,dT];var he=[eT,Km,bt,XD,CI,oI,OK,PK,TK,ZK,aL,bL,fL,kL,pN,uN,$Q,_Q,ZQ,Lm,eT,eT,eT,eT,eT,eT,eT,eT,eT,eT,eT,eT];var ie=[fT,cf];var je=[gT,NJ,PJ,RJ,TJ,VJ,XJ,ZJ,$J,bK,dK,fK,kK,mK,oK,qK,sK,uK,wK,yK,AK,CK,EK,SK,UK,eL,gL,pL,qL,rL,sL,tL,DL,EL,FL,GL,HL,fN,lN,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT,gT];var ke=[hT,cN,iN,hT];var le=[iT,uL,IL,iT];var me=[jT,Oe,ch,$g,Yg,Hh,Ih,Hj,Ij,Kj,lk,mk,ok,Qk,Rk,Tk,Zk,_k,$k,al,bl,cl,dl,el,ft,gt,_D,$D,JI,PF,WF,LI,vI,bG,iG,xI,_N,aO,cO,QN,SN,UN,zq,uq,nq,eq,kT,dR,dj,ej,fj,lT,An,hq,mT,uQ,jT,jT,jT,jT,jT,jT,jT,jT];var ne=[nT,DJ,IJ,fO,rO,uO,XN,jO,mO,BO,EO,MO,PO,Bl,sm,tm,Gl,Dl,qm,rm,Hl,Il,Jl,Kl,Ll,gm,hm,Zl,Sl,Nl,Ml,Ol,Pl,Rl,Ql,El,Cl,Tl,Ul,Vl,Wl,Xl,Yl,_l,$l,am,bm,fm,dm,cm,em,mm,im,jm,km,lm,nm,om,pm,um,vm,wm,xm,QK];var oe=[oT,Wq];var pe=[pT,Jh,pO,qO,hO,iO,xO,zO,IO,KO,pT,pT,pT,pT,pT,pT];var qe=[qT,Kh,rT,mn,GF,HF,EF,qT];var re=[sT,ap];var se=[tT,qD,AG,uJ,On,_m,Vm,kr,mr,Rv,sE,tT,tT,tT,tT,tT];var te=[uT,vT,kn,Am,ff,uT,uT,uT];var ue=[wT,kq,lq,wT];var ve=[xT,zj,Aj,Bj,Cj,Dj,Ej,Gj,Jj,Nj,dk,ek,fk,gk,hk,ik,kk,nk,rk,Ik,Jk,Kk,Lk,Mk,Nk,Pk,Sk,Wk,dO,NN,ON,PN,VN,Ap,yT,Ym,Xi,_h,ti,Ci,oi,Li,Qi,Oi,Ri,xj,bj,lj,mj,tj,uj,hK,WK,zT,xT,xT,xT,xT,xT,xT,xT,xT,xT,xT];var we=[AT,Mj,qk,Vk,ct,pD,YD,DI,pI,EJ,JJ,SQ,TQ,UQ,Tm,Rm,Cp,Um,Xm,nj,LE,AT,AT,AT,AT,AT,AT,AT,AT,AT,AT,AT];return{_testSetjmp:RR,_saveSetjmp:DR,_free:bR,_main:ef,_rand_r:LR,_realloc:dR,_i64Add:OR,_memmove:HR,_bitshift64Ashr:FR,_memset:IR,_malloc:aR,_strncpy:PR,_memcpy:GR,_strlen:ER,_bitshift64Lshr:QR,_bitshift64Shl:JR,_i64Subtract:NR,_strcpy:KR,_calloc:cR,_rand:MR,__GLOBAL__I_a:kG,runPostSets:CR,stackAlloc:xe,stackSave:ye,stackRestore:ze,setThrew:Ae,setTempRet0:De,setTempRet1:Ee,setTempRet2:Fe,setTempRet3:Ge,setTempRet4:He,setTempRet5:Ie,setTempRet6:Je,setTempRet7:Ke,setTempRet8:Le,setTempRet9:Me,dynCall_iiiiiiii:$R,dynCall_viiiii:aS,dynCall_iiiiidiii:bS,dynCall_vd:cS,dynCall_vi:dS,dynCall_vii:eS,dynCall_iiiiiiiiiii:fS,dynCall_ii:gS,dynCall_viidi:hS,dynCall_iiiiiiiiiiiiii:iS,dynCall_iiiiiiiiiiiiiiiiiiiii:jS,dynCall_iiiiiiiiiiiiiiiiiiiiiii:kS,dynCall_iiii:lS,dynCall_viiiiid:mS,dynCall_viiiiiiii:nS,dynCall_viiiiii:oS,dynCall_iid:pS,dynCall_viiiiiii:qS,dynCall_viiiiiid:rS,dynCall_viiiiiiiii:sS,dynCall_iii:tS,dynCall_iiiiii:uS,dynCall_iiiiidi:vS,dynCall_iiiiiiiii:wS,dynCall_i:xS,dynCall_iiiiiiiiii:yS,dynCall_viii:zS,dynCall_v:AS,dynCall_viidii:BS,dynCall_iiiii:CS,dynCall_viiii:DS}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_viidii": invoke_viidii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_atan2": _atan2, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_acos": _acos, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






