var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 124864;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 124904;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(125731);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,89,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,44,32,123,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,0,1,0,0,0,92,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,95,0,0,0,49,46,48,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,96,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,101,0,0,0,109,97,120,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,1,0,0,0,103,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,106,0,0,0,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,1,0,0,0,107,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,108,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,1,0,0,0,110,0,0,0,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,118,0,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,122,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,44,32,123,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,125,41,0,0,0,1,0,0,0,127,0,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,128,0,0,0,84,101,109,112,101,114,97,116,117,114,101,32,84,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,97,108,108,111,119,101,100,32,114,97,110,103,101,32,49,52,51,46,49,53,32,75,32,60,61,32,40,84,32,61,0,0,0,0,0,0,32,75,41,32,60,61,32,50,48,48,48,32,75,32,114,101,113,117,105,114,101,100,32,102,114,111,109,32,109,101,100,105,117,109,32,109,111,100,101,108,32,34,0,0,0,0,0,0,77,111,105,115,116,32,97,105,114,0,0,0,0,0,0,0,34,46,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,49,93,32,61,32,0,0,0,111,102,32,115,117,98,115,116,97,110,99,101,32,0,0,0,87,97,116,101,114,0,0,0,10,111,102,32,109,101,100,105,117,109,32,0,0,0,0,0,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,114,97,110,103,101,32,48,46,46,49,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,50,93,32,61,32,0,0,0,65,105,114,0,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,240,7,0,0,67,0,0,0,5,0,0,0,69,0,0,0,77,0,0,0,0,0,0,0,168,8,0,0,74,17,0,0,11,0,0,0,77,17,0,0,41,0,0,0,0,0,0,0,168,8,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,82,101,102,101,114,101,110,99,101,65,105,114,46,77,111,105,115,116,65,105,114,49,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,0,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,82,101,102,101,114,101,110,99,101,65,105,114,46,77,111,105,115,116,65,105,114,49,95,105,110,102,111,46,120,109,108,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,84,104,101,32,97,114,103,117,109,101,110,116,115,32,117,95,109,105,110,32,97,110,100,32,117,95,109,97,120,32,112,114,111,118,105,100,101,100,32,105,110,32,116,104,101,32,102,117,110,99,116,105,111,110,32,99,97,108,108,10,32,32,32,32,115,111,108,118,101,79,110,101,78,111,110,108,105,110,101,97,114,69,113,117,97,116,105,111,110,40,102,44,117,95,109,105,110,44,117,95,109,97,120,41,10,100,111,32,110,111,116,32,98,114,97,99,107,101,116,32,116,104,101,32,114,111,111,116,32,111,102,32,116,104,101,32,115,105,110,103,108,101,32,110,111,110,45,108,105,110,101,97,114,32,101,113,117,97,116,105,111,110,32,48,61,102,40,117,41,58,10,32,32,117,95,109,105,110,32,32,61,32,0,0,10,0,0,0,0,0,0,0,32,32,117,95,109,97,120,32,32,61,32,0,0,0,0,0,32,32,102,97,32,61,32,102,40,117,95,109,105,110,41,32,61,32,0,0,0,0,0,0,32,32,102,98,32,61,32,102,40,117,95,109,97,120,41,32,61,32,0,0,0,0,0,0,102,97,32,97,110,100,32,102,98,32,109,117,115,116,32,104,97,118,101,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,119,104,105,99,104,32,105,115,32,110,111,116,32,116,104,101,32,99,97,115,101,0,1,0,0,0,232,31,0,0,240,31,0,0,0,0,0,0,1,0,0,0,72,31,0,0,80,31,0,0,0,0,0,0,1,0,0,0,240,30,0,0,248,30,0,0,0,0,0,0,1,0,0,0,80,30,0,0,88,30,0,0,0,0,0,0,1,0,0,0,248,29,0,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,116,97,117,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,45,32,101,120,112,40,45,50,53,46,51,54,51,54,53,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,45,32,101,120,112,40,45,49,54,46,57,48,55,52,49,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,32,43,32,101,120,112,40,56,55,46,51,49,50,55,57,48,48,48,48,48,48,48,48,49,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,102,46,116,97,117,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,1,0,0,0,160,29,0,0,168,29,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,66,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,65,32,42,32,67,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,1,0,0,0,128,29,0,0,136,29,0,0,0,0,0,0,1,0,0,0,96,29,0,0,104,29,0,0,0,0,0,0,1,0,0,0,48,29,0,0,56,29,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,40,99,49,46,114,101,32,94,32,50,46,48,32,43,32,99,49,46,105,109,32,94,32,50,46,48,41,32,94,32,48,46,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,65,109,98,105,101,110,116,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,32,42,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,70,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,69,32,42,32,71,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,40,54,53,48,46,49,55,53,51,52,56,52,52,55,57,56,32,43,32,68,41,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,40,45,48,46,50,51,56,53,53,53,53,55,53,54,55,56,52,57,32,43,32,54,53,48,46,49,55,53,51,52,56,52,52,55,57,56,32,42,32,68,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,1,0,0,0,8,29,0,0,16,29,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,96,21,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,96,21,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,96,21,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,96,21,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,96,21,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,96,21,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,96,21,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,96,21,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,96,21,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,96,21,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,96,21,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,96,21,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,96,21,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,96,21,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,168,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,96,21,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,96,21,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,1,0,0,0,216,28,0,0,224,28,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,96,21,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,84,32,61,32,0,0,41,0,0,0,0,0,0,0,96,21,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,4,0,0,0,0,0,0,0,238,125,147,110,151,114,146,63,182,225,201,209,144,175,156,63,225,193,5,143,37,98,160,63,146,202,20,115,16,116,164,63,5,0,0,0,0,0,0,0,70,177,134,119,168,73,35,193,22,51,58,37,241,245,228,63,221,99,66,105,92,85,84,190,215,161,171,33,3,154,238,60,242,95,162,72,204,5,133,187,3,0,0,0,0,0,0,0,79,211,114,180,129,78,107,63,237,43,205,181,129,78,243,63,162,150,40,115,218,64,251,63,3,0,0,0,0,0,0,0,39,62,45,245,226,54,53,192,248,186,86,140,4,82,59,64,68,243,165,92,134,108,24,192,10,0,0,0,0,0,0,0,69,72,146,101,53,60,146,64,230,57,133,85,234,25,38,193,213,154,16,162,231,18,49,192,202,188,217,143,105,122,199,64,133,56,32,132,149,169,72,193,107,204,190,29,137,212,45,64,179,240,72,7,68,215,178,192,229,145,38,159,229,185,24,65,14,166,232,53,253,136,206,191,212,75,22,29,103,81,132,64,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,133,235,81,184,30,213,63,41,92,143,194,245,40,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,51,51,51,51,51,195,63,0,0,0,0,0,0,0,0,154,153,153,153,153,153,201,63,102,102,102,102,102,102,214,63,154,153,153,153,153,153,245,63,154,153,153,153,153,153,249,63,154,153,153,153,153,153,233,63,102,102,102,102,102,102,238,63,0,0,0,0,0,0,244,63,205,204,204,204,204,204,12,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,10,64,0,0,0,0,0,0,12,64,0,0,0,0,0,0,46,64,19,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,6,0,0,0,1,0,0,0,3,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,3,0,0,0,11,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,124,252,4,97,200,63,190,63,242,16,199,119,217,209,230,63,184,179,228,163,81,228,249,191,152,16,88,103,48,72,178,63,160,215,149,43,160,39,182,191,18,198,89,243,212,45,193,63,152,159,4,9,226,16,135,63,201,151,243,92,3,136,165,191,52,55,71,248,133,222,161,63,205,17,255,105,11,159,37,63,246,50,202,34,15,243,185,191,244,22,40,235,134,63,198,191,245,117,228,106,243,43,168,191,250,23,206,78,195,23,137,191,160,217,43,81,194,196,194,191,96,8,130,141,155,46,160,191,108,25,21,27,36,158,46,63,220,143,38,101,142,94,142,63,129,224,3,15,237,57,131,191,13,0,0,0,0,0,0,0,115,193,105,214,120,66,112,62,184,97,171,53,133,12,246,190,32,173,224,40,123,210,36,191,39,2,96,50,17,175,43,192,147,78,201,222,119,70,49,64,108,58,221,255,78,155,41,191,158,128,91,180,86,237,3,64,244,102,197,81,104,82,233,63,115,204,200,12,147,42,203,63,99,158,164,223,15,86,201,63,190,48,153,42,24,93,57,64,56,16,146,5,76,232,48,64,4,33,89,192,4,212,85,64,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,45,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,0,216,32,0,0,0,33,0,0,40,33,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,13,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,1,0,0,0,15,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,0,0,0,0,1,0,0,0,19,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,65,109,98,105,101,110,116,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,44,32,123,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,1,0,0,0,22,0,0,0,109,97,120,40,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,1,0,0,0,23,0,0,0,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,26,0,0,0,49,46,48,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,1,0,0,0,27,0,0,0,109,97,120,40,49,101,45,49,51,44,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,28,0,0,0,109,97,120,40,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,1,0,0,0,32,0,0,0,109,97,120,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,1,0,0,0,33,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,1,0,0,0,39,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,44,32,123,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,0,1,0,0,0,42,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,43,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,46,0,0,0,49,46,48,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,51,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,52,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,55,0,0,0,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,1,0,0,0,57,0,0,0,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,59,0,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,68,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,44,32,123,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,125,41,0,0,0,1,0,0,0,71,0,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,72,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,153,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,1,0,0,0,155,0,0,0,109,97,120,40,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,1,0,0,0,162,0,0,0,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,163,0,0,0,109,97,120,40,49,101,45,49,51,44,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,166,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,0,0,0,0,1,0,0,0,169,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,65,109,98,105,101,110,116,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,44,32,123,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,1,0,0,0,174,0,0,0,49,46,48,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,1,0,0,0,175,0,0,0,109,97,120,40,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,32,44,0,0,107,13,0,0,9,0,0,0,108,13,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,44,0,0,105,13,0,0,9,0,0,0,106,13,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,44,0,0,40,13,0,0,9,0,0,0,42,13,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,44,0,0,36,13,0,0,9,0,0,0,39,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,44,0,0,31,13,0,0,9,0,0,0,35,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,44,0,0,25,13,0,0,9,0,0,0,27,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,44,0,0,22,13,0,0,9,0,0,0,24,13,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,44,0,0,206,12,0,0,9,0,0,0,207,12,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,44,0,0,202,12,0,0,9,0,0,0,205,12,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,32,44,0,0,197,12,0,0,9,0,0,0,201,12,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,44,0,0,191,12,0,0,9,0,0,0,192,12,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,44,0,0,117,12,0,0,9,0,0,0,119,12,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,44,0,0,113,12,0,0,9,0,0,0,116,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,44,0,0,108,12,0,0,9,0,0,0,112,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,44,0,0,102,12,0,0,9,0,0,0,104,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,44,0,0,99,12,0,0,9,0,0,0,101,12,0,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,44,0,0,176,13,0,0,9,0,0,0,177,13,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,44,0,0,174,13,0,0,9,0,0,0,175,13,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,44,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,184,59,0,0,65,0,0,0,5,0,0,0,65,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,44,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,44,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,32,44,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,184,59,0,0,61,0,0,0,5,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,184,59,0,0,58,0,0,0,5,0,0,0,58,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,184,59,0,0,59,0,0,0,5,0,0,0,59,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,44,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,184,59,0,0,63,0,0,0,5,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,184,59,0,0,54,0,0,0,5,0,0,0,54,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,72,67,0,0,252,11,0,0,9,0,0,0,253,11,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,72,67,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,72,67,0,0,31,17,0,0,7,0,0,0,32,17,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,72,67,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,72,67,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,67,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,72,67,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,200,74,0,0,54,0,0,0,5,0,0,0,54,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,72,67,0,0,125,12,0,0,9,0,0,0,125,12,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,67,0,0,126,12,0,0,9,0,0,0,127,12,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,72,67,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,72,67,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,72,67,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,200,74,0,0,58,0,0,0,5,0,0,0,58,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,74,0,0,59,0,0,0,5,0,0,0,59,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,74,0,0,61,0,0,0,5,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,74,0,0,63,0,0,0,5,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,74,0,0,65,0,0,0,5,0,0,0,65,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,72,67,0,0,255,11,0,0,9,0,0,0,0,12,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,67,0,0,4,12,0,0,9,0,0,0,5,12,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,67,0,0,1,12,0,0,9,0,0,0,2,12,0,0,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,72,67,0,0,6,12,0,0,9,0,0,0,7,12,0,0,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,72,67,0,0,118,13,0,0,9,0,0,0,119,13,0,0,87,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,82,101,102,101,114,101,110,99,101,65,105,114,95,77,111,105,115,116,65,105,114,49,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,51,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,51,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,51,44,51,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,51,44,48,93,32,61,32,122,101,114,111,115,40,51,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,51,93,32,61,32,122,101,114,111,115,40,48,44,51,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,51,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,49,114,66,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,84,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,112,32,61,32,120,91,51,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,82,101,102,101,114,101,110,99,101,65,105,114,95,77,111,105,115,116,65,105,114,49,59,10,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,96,0,0,32,96,0,0,48,96,0,0,72,96,0,0,104,96,0,0,120,96,0,0,144,96,0,0,160,96,0,0,184,96,0,0,216,96,0,0,0,97,0,0,24,97,0,0,56,97,0,0,80,97,0,0,120,97,0,0,152,97,0,0,200,97,0,0,248,97,0,0,16,98,0,0,72,98,0,0,96,98,0,0,144,98,0,0,176,98,0,0,232,98,0,0,16,99,0,0,72,99,0,0,120,99,0,0,136,99,0,0,168,99,0,0,208,99,0,0,240,99,0,0,24,100,0,0,64,100,0,0,88,100,0,0,112,100,0,0,128,100,0,0,152,100,0,0,200,100,0,0,24,101,0,0,88,101,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,136,115,0,0,24,114,0,0,160,112,0,0,40,111,0,0,40,111,0,0,176,109,0,0,160,112,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,80,126,0,0,216,122,0,0,104,121,0,0,248,119,0,0,248,119,0,0,136,118,0,0,104,121,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,152,124,0,0,168,124,0,0,184,124,0,0,136,109,0,0,192,124,0,0,208,124,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,48,128,0,0,56,128,0,0,64,128,0,0,72,128,0,0,192,127,0,0,80,128,0,0,96,128,0,0,104,128,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,240,129,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,168,130,0,0,184,130,0,0,192,130,0,0,200,130,0,0,216,130,0,0,232,130,0,0,240,130,0,0,0,131,0,0,16,131,0,0,32,131,0,0,48,131,0,0,64,131,0,0,80,131,0,0,96,131,0,0,112,131,0,0,120,131,0,0,128,131,0,0,144,131,0,0,152,131,0,0,168,131,0,0,184,131,0,0,200,131,0,0,216,131,0,0,232,131,0,0,248,131,0,0,8,132,0,0,24,132,0,0,40,132,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,176,132,0,0,184,132,0,0,184,132,0,0,216,132,0,0,8,133,0,0,40,133,0,0,96,133,0,0,144,133,0,0,192,133,0,0,224,133,0,0,16,134,0,0,40,134,0,0,72,134,0,0,112,134,0,0,144,134,0,0,192,134,0,0,224,134,0,0,8,135,0,0,40,135,0,0,80,135,0,0,128,135,0,0,184,135,0,0,224,135,0,0,16,136,0,0,64,136,0,0,104,136,0,0,152,136,0,0,160,136,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,176,132,0,0,160,139,0,0,168,139,0,0,176,139,0,0,192,130,0,0,184,139,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,32,141,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,56,141,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,80,141,0,0,88,141,0,0,96,141,0,0,112,141,0,0,128,141,0,0,136,141,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,160,153,0,0,0,0,0,0,24,153,0,0,0,0,0,0,144,152,0,0,0,0,0,0,8,152,0,0,0,0,0,0,0,151,0,0,0,0,0,0,248,149,0,0,0,0,0,0,240,148,0,0,0,0,0,0,232,147,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,155,0,0,152,155,0,0,160,155,0,0,168,155,0,0,184,155,0,0,192,155,0,0,200,155,0,0,208,155,0,0,216,155,0,0,224,155,0,0,232,155,0,0,248,155,0,0,0,156,0,0,16,156,0,0,32,156,0,0,48,156,0,0,56,156,0,0,72,156,0,0,80,156,0,0,96,156,0,0,104,156,0,0,128,156,0,0,136,156,0,0,144,156,0,0,160,156,0,0,168,156,0,0,184,156,0,0,200,156,0,0,208,156,0,0,216,156,0,0,224,156,0,0,232,156,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,157,0,0,128,157,0,0,200,157,0,0,248,157,0,0,40,158,0,0,112,158,0,0,176,158,0,0,248,158,0,0,40,159,0,0,112,159,0,0,136,159,0,0,168,159,0,0,224,159,0,0,8,160,0,0,48,160,0,0,104,160,0,0,184,160,0,0,24,161,0,0,72,161,0,0,128,161,0,0,176,161,0,0,248,161,0,0,32,162,0,0,80,162,0,0,128,162,0,0,216,162,0,0,32,163,0,0,144,163,0,0,192,163,0,0,8,164,0,0,40,164,0,0,232,156,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,157,0,0,232,164,0,0,144,165,0,0,248,157,0,0,40,158,0,0,248,165,0,0,176,158,0,0,248,158,0,0,128,166,0,0,192,166,0,0,136,159,0,0,168,159,0,0,96,167,0,0,160,167,0,0,224,167,0,0,104,160,0,0,184,160,0,0,32,168,0,0,88,168,0,0,224,168,0,0,8,169,0,0,248,161,0,0,32,162,0,0,80,162,0,0,112,169,0,0,248,169,0,0,248,170,0,0,144,163,0,0,192,163,0,0,8,164,0,0,40,164,0,0,232,156,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,176,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,176,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+39456);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,194,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+49800);
/* memory initializer */ allocate([16,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,204,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,239,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,241,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,242,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,242,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,152,254,0,0,184,255,0,0,192,255,0,0,208,255,0,0,224,255,0,0,240,255,0,0,8,0,1,0,32,0,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,152,254,0,0,160,254,0,0,232,254,0,0,16,255,0,0,48,255,0,0,80,255,0,0,120,255,0,0,160,255,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,0,7,1,0,16,7,1,0,24,7,1,0,32,7,1,0,40,7,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,72,7,1,0,80,7,1,0,96,7,1,0,112,7,1,0,40,7,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+60484);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,48,34,1,0,248,35,1,0,0,36,1,0,8,36,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,48,34,1,0,56,35,1,0,136,35,1,0,184,35,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,48,34,1,0,248,34,1,0,0,35,1,0,8,35,1,0,24,35,1,0,32,35,1,0,48,35,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,48,34,1,0,56,34,1,0,80,34,1,0,96,34,1,0,168,34,1,0,184,34,1,0,216,34,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,224,45,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,224,45,1,0,10,0,0,0,11,0,0,0,132,45,1,0,252,45,1,0,16,46,1,0,152,45,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,240,231,1,0,176,45,1,0,120,163,1,0,0,0,0,0,104,0,0,0,0,0,0,0,120,163,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,120,163,1,0,14,0,0,0,15,0,0,0,0,0,0,0,136,46,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,240,231,1,0,88,46,1,0,112,162,1,0,0,0,0,0,0,0,0,0,16,47,1,0,24,47,1,0,8,47,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,232,46,1,0,248,46,1,0,8,47,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+70728);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,104,63,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,104,63,1,0,20,0,0,0,21,0,0,0,12,63,1,0,132,63,1,0,152,63,1,0,32,63,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,240,231,1,0,56,63,1,0,232,162,1,0,0,0,0,0,108,0,0,0,0,0,0,0,232,162,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,232,162,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,160,73,1,0,136,75,1,0,144,75,1,0,216,77,1,0,240,75,1,0,0,76,1,0,224,77,1,0,232,77,1,0,240,77,1,0,248,77,1,0,8,78,1,0,24,78,1,0,40,78,1,0,56,78,1,0,72,78,1,0,88,78,1,0,104,78,1,0,128,78,1,0,184,77,1,0,208,77,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,160,73,1,0,136,75,1,0,144,75,1,0,160,75,1,0,240,75,1,0,0,76,1,0,16,76,1,0,48,76,1,0,80,76,1,0,112,76,1,0,152,76,1,0,192,76,1,0,232,76,1,0,16,77,1,0,40,77,1,0,72,77,1,0,104,77,1,0,144,77,1,0,184,77,1,0,208,77,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,160,73,1,0,104,75,1,0,112,75,1,0,120,75,1,0,160,73,1,0,168,74,1,0,248,74,1,0,40,75,1,0,160,73,1,0,104,74,1,0,112,74,1,0,120,74,1,0,136,74,1,0,144,74,1,0,160,74,1,0,0,0,0,0,160,73,1,0,168,73,1,0,192,73,1,0,208,73,1,0,24,74,1,0,40,74,1,0,72,74,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,192,80,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,192,80,1,0,29,0,0,0,30,0,0,0,76,80,1,0,220,80,1,0,240,80,1,0,96,80,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,240,231,1,0,120,80,1,0,120,163,1,0,0,0,0,0,56,0,0,0,0,0,0,0,120,163,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,120,163,1,0,14,0,0,0,15,0,0,0,0,0,0,0,128,81,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,240,231,1,0,56,81,1,0,112,162,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+80968);
/* memory initializer */ allocate([114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,16,102,1,0,16,102,1,0,16,102,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,184,104,1,0,200,104,1,0,224,104,1,0,0,105,1,0,32,105,1,0,56,105,1,0,88,105,1,0,112,105,1,0,128,105,1,0,144,105,1,0,168,105,1,0,192,105,1,0,224,105,1,0,0,106,1,0,144,105,1,0,24,106,1,0,56,106,1,0,80,106,1,0,104,106,1,0,128,106,1,0,160,106,1,0,176,106,1,0,208,106,1,0,240,106,1,0,8,107,1,0,32,107,1,0,56,107,1,0,72,107,1,0,96,107,1,0,120,107,1,0,144,107,1,0,176,107,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+91208);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+98144);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,184,148,1,0,192,148,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,208,148,1,0,216,148,1,0,224,148,1,0,232,148,1,0,144,1,0,0,0,0,0,0,88,149,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+103368);
/* memory initializer */ allocate([48,156,1,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,240,231,1,0,16,156,1,0,176,162,1,0,0,0,0,0,0,0,0,0,152,156,1,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,240,231,1,0,128,156,1,0,176,162,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,48,157,1,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,240,231,1,0,16,157,1,0,112,162,1,0,0,0,0,0,0,0,0,0,152,157,1,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,240,231,1,0,128,157,1,0,112,162,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,200,231,1,0,168,157,1,0,0,0,0,0,16,158,1,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,184,158,1,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,240,231,1,0,0,158,1,0,0,0,0,0,0,0,0,0,0,0,0,0,80,158,1,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,240,231,1,0,56,158,1,0,16,158,1,0,0,0,0,0,0,0,0,0,144,158,1,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,240,231,1,0,120,158,1,0,16,158,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,240,231,1,0,160,158,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,0,159,1,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,240,231,1,0,232,158,1,0,184,158,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,200,231,1,0,16,159,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,240,231,1,0,56,159,1,0,48,159,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,232,161,1,0,49,0,0,0,50,0,0,0,0,0,0,0,112,162,1,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,176,162,1,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,232,162,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,232,162,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,48,163,1,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,48,163,1,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,120,163,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,120,163,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,192,163,1,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,192,163,1,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,161,1,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,176,161,1,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,240,231,1,0,104,161,1,0,0,159,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,200,231,1,0,152,161,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,240,231,1,0,184,161,1,0,176,161,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,240,231,1,0,248,161,1,0,176,161,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,200,231,1,0,56,162,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,200,231,1,0,120,162,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,80,232,1,0,184,162,1,0,0,0,0,0,1,0,0,0,232,161,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,80,232,1,0,0,163,1,0,0,0,0,0,1,0,0,0,40,162,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,80,232,1,0,72,163,1,0,0,0,0,0,1,0,0,0,232,161,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,80,232,1,0,144,163,1,0,0,0,0,0,1,0,0,0,40,162,1,0,3,244,255,255,0,0,0,0,32,164,1,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,240,231,1,0,0,164,1,0,80,159,1,0,0,0,0,0,0,0,0,0,72,178,1,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,178,1,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,183,1,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,184,183,1,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,184,1,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,185,1,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,56,180,1,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,56,180,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,216,180,1,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,216,180,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,104,181,1,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,181,1,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,178,1,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,179,1,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,179,1,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,179,1,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,185,1,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,48,186,1,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,192,186,1,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,80,187,1,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,182,1,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,182,1,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,32,178,1,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,174,1,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,175,1,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,177,1,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,248,177,1,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,48,174,1,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,240,231,1,0,24,174,1,0,200,157,1,0,0,0,0,0,0,0,0,0,192,174,1,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,200,231,1,0,160,174,1,0,80,232,1,0,136,174,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,174,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,80,232,1,0,224,174,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,174,1,0,2,0,0,0,0,0,0,0,144,175,1,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,200,231,1,0,112,175,1,0,80,232,1,0,72,175,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,136,175,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,80,232,1,0,176,175,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,136,175,1,0,2,0,0,0,0,0,0,0,80,176,1,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,80,232,1,0,40,176,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,136,175,1,0,2,0,0,0,0,0,0,0,200,176,1,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,80,232,1,0,160,176,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,136,175,1,0,2,0,0,0,0,0,0,0,64,177,1,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,240,231,1,0,24,177,1,0,200,176,1,0,0,0,0,0,0,0,0,0,168,177,1,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,240,231,1,0,128,177,1,0,200,176,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,240,231,1,0,184,177,1,0,48,174,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,240,231,1,0,224,177,1,0,48,174,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,240,231,1,0,8,178,1,0,48,174,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,240,231,1,0,48,178,1,0,48,174,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,240,231,1,0,88,178,1,0,48,174,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,200,231,1,0,160,178,1,0,80,232,1,0,128,178,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,178,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,80,232,1,0,224,178,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,178,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,80,232,1,0,32,179,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,178,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,80,232,1,0,96,179,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,178,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,200,231,1,0,232,179,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,200,231,1,0,8,180,1,0,80,232,1,0,160,179,1,0,0,0,0,0,3,0,0,0,48,174,1,0,2,0,0,0,0,180,1,0,2,0,0,0,48,180,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,200,231,1,0,168,180,1,0,80,232,1,0,96,180,1,0,0,0,0,0,3,0,0,0,48,174,1,0,2,0,0,0,0,180,1,0,2,0,0,0,208,180,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,200,231,1,0,72,181,1,0,80,232,1,0,0,181,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,96,181,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,80,232,1,0,136,181,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,96,181,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,200,231,1,0,8,182,1,0,80,232,1,0,240,181,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,32,182,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,80,232,1,0,72,182,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,32,182,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,200,231,1,0,224,182,1,0,80,232,1,0,200,182,1,0,0,0,0,0,1,0,0,0,0,183,1,0,0,0,0,0,80,232,1,0,128,182,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,8,183,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,80,232,1,0,136,183,1,0,0,0,0,0,1,0,0,0,0,183,1,0,0,0,0,0,80,232,1,0,64,183,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,160,183,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,200,231,1,0,56,184,1,0,80,232,1,0,32,184,1,0,0,0,0,0,1,0,0,0,88,184,1,0,0,0,0,0,80,232,1,0,216,183,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,96,184,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,80,232,1,0,224,184,1,0,0,0,0,0,1,0,0,0,88,184,1,0,0,0,0,0,80,232,1,0,152,184,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,248,184,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,200,231,1,0,120,185,1,0,80,232,1,0,48,185,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,152,185,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,200,231,1,0,8,186,1,0,80,232,1,0,192,185,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,40,186,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,200,231,1,0,152,186,1,0,80,232,1,0,80,186,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,184,186,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,200,231,1,0,40,187,1,0,80,232,1,0,224,186,1,0,0,0,0,0,2,0,0,0,48,174,1,0,2,0,0,0,72,187,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+105420);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,56,229,1,0,110,0,0,0,64,229,1,0,114,0,0,0,72,229,1,0,102,0,0,0,80,229,1,0,97,0,0,0,88,229,1,0,101,0,0,0,96,229,1,0,119,0,0,0,104,229,1,0,87,0,0,0,120,229,1,0,115,0,0,0,136,229,1,0,83,0,0,0,152,229,1,0,100,0,0,0,168,229,1,0,68,0,0,0,184,229,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,64,231,1,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,200,231,1,0,24,231,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,240,231,1,0,48,231,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,240,231,1,0,80,231,1,0,40,231,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,240,231,1,0,136,231,1,0,120,231,1,0,0,0,0,0,0,0,0,0,176,231,1,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,56,232,1,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,240,231,1,0,16,232,1,0,176,231,1,0,0,0,0,0,0,0,0,0,152,232,1,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,240,231,1,0,112,232,1,0,176,231,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,234,1,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,240,231,1,0,200,234,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+115760);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_setjmp=true;

  var _floor=Math_floor;

  var _atan2=Math_atan2;


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_destroy;var Kb=env._lis_solver_set_option;var Lb=env._tmpfile;var Mb=env._send;var Nb=env._pow;var Ob=env._atan2;var Pb=env.___cxa_is_number_type;var Qb=env.___cxa_free_exception;var Rb=env.___cxa_find_matching_catch;var Sb=env._isxdigit_l;var Tb=env.___cxa_guard_release;var Ub=env._truncate;var Vb=env._strtol;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._fscanf;var dc=env._qsort;var ec=env._putchar;var fc=env._floor;var gc=env._pthread_mutex_unlock;var hc=env._printf;var ic=env._sprintf;var jc=env._fopen;var kc=env._vasprintf;var lc=env._emscripten_get_now;var mc=env._stat;var nc=env._vsnprintf;var oc=env._strtoull_l;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._fseek;var Wc=env._isxdigit;var Xc=env._fclose;var Yc=env.__parseInt;var Zc=env._log;var _c=env._pthread_cond_broadcast;var $c=env._popen;var ad=env._recv;var bd=env._fgetc;var cd=env._sysconf;var dd=env.__getFloat;var ed=env._abort;var fd=env._ceil;var gd=env._isspace;var hd=env._localtime;var id=env._pthread_getspecific;var jd=env._pthread_cond_wait;var kd=env._llvm_lifetime_start;var ld=env._acos;var md=env._ungetc;var nd=env._system;var od=env._fmin;var pd=env._fmax;var qd=env._fflush;var rd=env._strftime_l;var sd=env._fprintf;var td=env._sscanf;var ud=env._catgets;var vd=env._strdup;var wd=env._asprintf;var xd=env.__exit;var yd=env.___ctype_toupper_loc;var zd=env._bsearch;var Ad=env.__arraySum;var Bd=env.__formatString;var Cd=env._htonl;var Dd=env.___ctype_tolower_loc;var Ed=env._unlink;var Fd=env._fputs;var Gd=env._GC_malloc_atomic;var Hd=env._pread;var Id=env._lis_vector_set_size;var Jd=env._mkport;var Kd=env.__scanString;var Ld=env._pthread_setspecific;var Md=env._copysign;var Nd=env._fputc;var Od=env.___cxa_throw;var Pd=env._lis_solver_destroy;var Qd=env._isdigit;var Rd=env._strerror;var Sd=env._emscripten_longjmp;var Td=env._lis_vector_create;var Ud=env._atexit;var Vd=env._sqrt;var Wd=env._strerror_r;var Xd=0.0;
// EMSCRIPTEN_START_FUNCS
function fi(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;nu(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(tu(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(tu(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(tu(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(tu(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(tu(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(tu(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(tu(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(tu(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(tu(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(tu(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(tu(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(tu(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(tu(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(tu(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(tu(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(tu(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(tu(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(tu(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(tu(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(tu(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(tu(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(tu(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(tu(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(tu(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(tu(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(tu(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(tu(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(tu(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(tu(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(tu(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(tu(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(tu(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(tu(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(tu(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(tu(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(tu(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(tu(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(tu(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(tu(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(tu(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(tu(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(tu(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(tu(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(tu(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(tu(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(tu(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(tu(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(tu(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(tu(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(tu(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(tu(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(tu(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(tu(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(tu(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(tu(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(tu(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(tu(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(tu(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(tu(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(tu(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(tu(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(tu(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(tu(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(tu(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(tu(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(tu(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(tu(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(tu(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(tu(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(tu(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(tu(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(tu(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(tu(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(tu(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(tu(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(tu(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(tu(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(tu(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(tu(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(tu(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(tu(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(tu(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(tu(Xf,1,se)|0)>>3];c[re>>2]=31;h[(tu(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(tu(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(tu(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(tu(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(tu(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(tu(Xf,1,me)|0)>>3];c[le>>2]=34;h[(tu(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(tu(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(tu(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(tu(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(tu(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(tu(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(tu(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(tu(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(tu(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(tu(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(tu(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(tu(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(tu(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(tu(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(tu(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(tu(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(tu(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(tu(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(tu(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(tu(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(tu(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(tu(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(tu(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(tu(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(tu(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(tu(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(tu(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(tu(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(tu(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(tu(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(tu(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(tu(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(tu(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(tu(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(tu(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(tu(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(tu(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(tu(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(tu(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(tu(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(tu(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(tu(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(tu(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(tu(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(tu(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(tu(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(tu(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(tu(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(tu(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(tu(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function gi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function hi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0;e=i;i=i+88|0;f=e;fi(f,b,c,d);h[a>>3]=c/(+h[f+16>>3]*+h[f+24>>3]*+h[f+48>>3]*d);i=e;return}function ii(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;fi(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function ji(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;var j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;i=i+88|0;j=e;fi(j,b,c,d);k=+h[j+16>>3];l=+h[j+24>>3];m=+h[j+32>>3];n=+h[j+72>>3];o=l*+h[j+48>>3];p=k*((o-m*l*+h[j+80>>3])/c);h[a>>3]=(1.0/+pd(+(c/(k*o*d)),1.0e-9)-p*d)*f-k*m*m*n*g;i=e;return}function ki(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;nu(Oa,1,Na);c[Oa+0>>2]=c[4088+0>>2];c[Oa+4>>2]=c[4088+4>>2];c[Oa+8>>2]=c[4088+8>>2];c[Ma>>2]=2;xt(Pa,16,1,Ma);c[La>>2]=1;Ma=yt(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=yt(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;xt(Qa,16,1,Ja);c[Ia>>2]=1;Ja=yt(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=yt(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=yt(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;xt(Ua,16,1,Fa);if((wg(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +lu(4088,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((wg(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=yt(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(yt(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((wg(2,2,3)|0)!=0){Fa=2;do{li(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=yt(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];mi(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];ni(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((wg(Fa,2,3)|0)!=0)}if((wg(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +lu(4088,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((wg(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}li(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=yt(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];oi(Ya,0,f+2512|0,f+2496|0);li(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=yt(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];oi(_a,0,f+2480|0,f+2464|0);li($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];mi(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];ni(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((wg(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +lu(4088,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((wg(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}li(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=yt(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];mi(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;li(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=yt(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];pi(db,0,f+2352|0,f+2336|0);li(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=yt(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];pi(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];qi(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];mi(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=yt(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(yt(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;li(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=yt(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];ni(ib,0,f+2240|0,f+2224|0);li(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=yt(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];ni(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];qi(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];mi(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=yt(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(yt(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;li(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=yt(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];pi(nb,0,f+2128|0,f+2112|0);li(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=yt(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];pi(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];qi(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];mi(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=yt(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(yt(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;li(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=yt(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];ni(sb,0,f+2016|0,f+2e3|0);li(tb,0,e/273.16,0.0);c[la>>2]=2;rb=yt(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];ni(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];qi(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];mi($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=yt(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(yt(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;li(wb,0,2.0,0.0);c[ia>>2]=1;$c=yt(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];mi(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=yt(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];qi(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];mi(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=yt(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(yt(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;li(zb,0,2.0,0.0);c[ea>>2]=2;ad=yt(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];mi(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=yt(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];qi(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];mi(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=yt(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(yt(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;li(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=yt(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];oi(cd,0,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=yt(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(yt(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;li(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=yt(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];oi(dd,0,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=yt(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function li(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function mi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];li(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function ni(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;li(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function oi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;li(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function pi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;li(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function qi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];vg(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[21062]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=6928;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];De[d&31](b,f,4160,g);}li(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function ri(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function si(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;g=i;i=i+88|0;j=g;fi(j,b,c,d);k=+h[j+16>>3];l=+h[j+24>>3];m=+h[j+56>>3];n=l*+h[j+48>>3];o=k*((n- +h[j+32>>3]*l*+h[j+80>>3])/c);p=c/(k*n*d);h[a>>3]=-(p*p*(o*f+k*l*l*m*+Tu(c,-2)*d*e));i=g;return}function ti(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function ui(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(tu(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[21062]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=6928;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4248,m);}c[l>>2]=1;h[a>>3]=+h[(tu(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function vi(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;hg(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function wi(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function xi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;nu(g,1,f);f=g;g=4056;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;nu(j,1,e);e=j;j=4072;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((wg(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+lu(4056,j);t=s+d*+W(+k,+(+lu(4072,j)));j=r+1|0;if((wg(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function yi(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;zi(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));wi(b,0,0.0,0.0,g);i=f;return}function zi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;ki(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+Tu(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function Ai(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;c[g>>2]=3;nu(j,1,g);g=j;j=4056;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[f>>2]=3;nu(k,1,f);f=k;k=4072;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];l=d/273.16;if((wg(1,1,3)|0)==0){m=0.0;n=0.0;o=m/l;p=+ca(+o);q=l*n;r=m*.003660858105139845;s=q-r;t=+Tu(l,-2);u=p*e;v=t*u;w=s*v;x=w*611.657;y=a;z=y;h[z>>3]=x;i=b;return}else{A=1;B=0.0;C=0.0}while(1){k=A+ -1|0;d=+lu(4056,k);D=B+d*+W(+l,+(+lu(4072,k)));d=+lu(4056,k);E=+lu(4072,k);F=C+d*E*+W(+l,+(+lu(4072,k)+-1.0))*.003660858105139845;k=A+1|0;if((wg(k,1,3)|0)==0){m=D;n=F;break}else{C=F;B=D;A=k}}o=m/l;p=+ca(+o);q=l*n;r=m*.003660858105139845;s=q-r;t=+Tu(l,-2);u=p*e;v=t*u;w=s*v;x=w*611.657;y=a;z=y;h[z>>3]=x;i=b;return}function Bi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h[a>>3]=+h[e+32>>3]*g+(1.0/+h[e+48>>3]- +h[e+8>>3]*+h[e+80>>3])*f;i=i;return}function Ci(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;zi(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Di(b,0,0.0,0.0,g);i=f;return}function Di(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function Ei(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;d=+h[e+48>>3];h[a>>3]=-(d*d*(+h[e+88>>3]*f+ +h[e+80>>3]*g));i=i;return}function Fi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function Gi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(tu(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(tu(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[21062]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=6928;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];De[f&31](b,j,4616,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function Hi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(tu(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(tu(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(tu(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(tu(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];su(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];ui(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[21062]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=6928;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];De[l&31](b,j,5160,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function Ii(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(tu(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[21062]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=6928;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4320,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(tu(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function Ji(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0;m=i;i=i+80|0;n=m;o=m+24|0;p=m+48|0;q=m+72|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+16|0;c[K>>2]=4;nu(L,1,K);c[J>>2]=3;M=+h[(tu(f,1,J)|0)>>3];if(!(M>=0.0)){J=c[21062]|0;K=I;h[k>>3]=M;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=J;J=p;N=6928;c[J+0>>2]=c[N+0>>2];c[J+4>>2]=c[N+4>>2];c[J+8>>2]=c[N+8>>2];c[J+12>>2]=c[N+12>>2];c[J+16>>2]=c[N+16>>2];c[J+20>>2]=c[N+20>>2];De[K&31](b,p,4248,I);}O=+ca(+(-30283.3/e));P=+W(+(d/101325.0),-.5);Q=O*P;R=+V(+M)*Q*1075.5;c[H>>2]=1;h[(tu(L,1,H)|0)>>3]=R;c[G>>2]=1;R=+h[(tu(f,1,G)|0)>>3];c[F>>2]=3;M=R*Q*+W(+(+h[(tu(f,1,F)|0)>>3]),-1.5)*-537.75;c[E>>2]=2;h[(tu(L,1,E)|0)>>3]=M;c[D>>2]=3;M=+h[(tu(f,1,D)|0)>>3];if(!(M>=0.0)){D=c[21062]|0;E=C;h[k>>3]=M;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=o;F=6928;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];De[E&31](b,o,4248,C);}c[B>>2]=1;Q=+h[(tu(f,1,B)|0)>>3]*+W(+d,-1.5)*(O/+V(+M))*-171174.3649259798;c[A>>2]=3;h[(tu(L,1,A)|0)>>3]=Q;c[z>>2]=3;Q=+h[(tu(f,1,z)|0)>>3];if(!(Q>=0.0)){z=c[21062]|0;A=y;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z;z=n;B=6928;c[z+0>>2]=c[B+0>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];c[z+12>>2]=c[B+12>>2];c[z+16>>2]=c[B+16>>2];c[z+20>>2]=c[B+20>>2];De[A&31](b,n,4248,y);}c[x>>2]=1;M=+h[(tu(f,1,x)|0)>>3]*P*(O/(e*e*+V(+Q)))*32569689.15;c[w>>2]=4;h[(tu(L,1,w)|0)>>3]=M;c[v>>2]=1;M=+h[(tu(L,1,v)|0)>>3];c[u>>2]=1;Q=M*+h[(tu(l,1,u)|0)>>3];c[t>>2]=2;M=+h[(tu(L,1,t)|0)>>3];c[s>>2]=3;e=M*+h[(tu(l,1,s)|0)>>3];c[r>>2]=3;M=+h[(tu(L,1,r)|0)>>3]*g;c[q>>2]=4;h[a>>3]=Q+(e+(M+ +h[(tu(L,1,q)|0)>>3]*j));i=m;return}function Ki(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0.0;m=i;i=i+80|0;n=m;o=m+24|0;p=m+48|0;q=m+72|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+16|0;c[L>>2]=4;nu(M,1,L);N=+ca(+(-19526.8/e));c[K>>2]=1;O=+h[(tu(f,1,K)|0)>>3];if(!(O>=0.0)){K=c[21062]|0;L=J;h[k>>3]=O;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K;K=p;P=6928;c[K+0>>2]=c[P+0>>2];c[K+4>>2]=c[P+4>>2];c[K+8>>2]=c[P+8>>2];c[K+12>>2]=c[P+12>>2];c[K+16>>2]=c[P+16>>2];c[K+20>>2]=c[P+20>>2];De[L&31](b,p,4320,J);}c[I>>2]=3;Q=+W(+(+h[(tu(f,1,I)|0)>>3]/d),.25)*(N/+V(+O))*1480.390925128686;c[H>>2]=1;h[(tu(M,1,H)|0)>>3]=Q;c[G>>2]=1;Q=+h[(tu(f,1,G)|0)>>3];if(!(Q>=0.0)){G=c[21062]|0;H=F;h[k>>3]=Q;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=o;I=6928;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];De[H&31](b,o,4320,F);}O=+V(+Q);c[E>>2]=3;Q=O*+W(+(+h[(tu(f,1,E)|0)>>3]),-.75)*N*+W(+(d/101325.0),-.25)*41.4875;c[D>>2]=2;h[(tu(M,1,D)|0)>>3]=Q;c[C>>2]=1;Q=+h[(tu(f,1,C)|0)>>3];if(!(Q>=0.0)){C=c[21062]|0;D=B;h[k>>3]=Q;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C;C=n;E=6928;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];De[D&31](b,n,4320,B);}O=+V(+Q);c[A>>2]=3;Q=O*+W(+(+h[(tu(f,1,A)|0)>>3]),.25)*N*+W(+d,-1.25)*-740.1954625643428;c[z>>2]=3;h[(tu(M,1,z)|0)>>3]=Q;c[y>>2]=1;Q=+h[(tu(f,1,y)|0)>>3];c[x>>2]=3;O=Q*+W(+(+h[(tu(f,1,x)|0)>>3]*d),-.25)*(N/(e*e))*-57814595.03360564;c[w>>2]=4;h[(tu(M,1,w)|0)>>3]=O;c[v>>2]=1;O=+h[(tu(M,1,v)|0)>>3];c[u>>2]=1;e=O*+h[(tu(l,1,u)|0)>>3];c[t>>2]=2;O=+h[(tu(M,1,t)|0)>>3];c[s>>2]=3;N=O*+h[(tu(l,1,s)|0)>>3];c[r>>2]=3;O=+h[(tu(M,1,r)|0)>>3]*g;c[q>>2]=4;h[a>>3]=e+(N+(O+ +h[(tu(M,1,q)|0)>>3]*j));i=m;return}function Li(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(tu(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[21062]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=6928;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];De[f&31](b,j,4248,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function Mi(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0,bb=0;m=i;i=i+160|0;n=m;o=m+24|0;p=m+40|0;q=m+64|0;r=m+80|0;s=m+104|0;t=m+120|0;u=m+136|0;v=m+152|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+24|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+24|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+24|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+24|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;c[ea>>2]=3;nu(fa,1,ea);c[da>>2]=1;pa=+h[(tu(f,1,da)|0)>>3];c[ba>>2]=2;qa=+h[(tu(f,1,ba)|0)>>3];c[aa>>2]=3;ra=+h[(tu(f,1,aa)|0)>>3];c[$>>2]=4;sa=+h[(tu(f,1,$)|0)>>3];$=_;h[k>>3]=qa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=_+8|0;h[k>>3]=ra;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=_+16|0;h[k>>3]=sa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];su(ga,4,pa,_);c[Z>>2]=1;pa=+h[(tu(l,1,Z)|0)>>3];c[Y>>2]=2;sa=+h[(tu(l,1,Y)|0)>>3];c[X>>2]=3;ra=+h[(tu(l,1,X)|0)>>3];c[U>>2]=4;qa=+h[(tu(l,1,U)|0)>>3];U=T;h[k>>3]=sa;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];U=T+8|0;h[k>>3]=ra;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];U=T+16|0;h[k>>3]=qa;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];su(ha,4,pa,T);T=u;U=ga;c[T+0>>2]=c[U+0>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];U=t;T=ha;c[U+0>>2]=c[T+0>>2];c[U+4>>2]=c[T+4>>2];c[U+8>>2]=c[T+8>>2];Ji(la,b,d,e,u,g,j,t);pa=+h[la>>3];qa=+ca(+(-27488.0/e));c[S>>2]=1;ra=+h[(tu(f,1,S)|0)>>3];c[R>>2]=2;sa=+h[(tu(f,1,R)|0)>>3];c[Q>>2]=3;ta=+h[(tu(f,1,Q)|0)>>3];c[P>>2]=4;ua=+h[(tu(f,1,P)|0)>>3];P=O;h[k>>3]=sa;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=ta;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+16|0;h[k>>3]=ua;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];su(ia,4,ra,O);O=s;P=ia;c[O+0>>2]=c[P+0>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];ui(ma,b,d,e,s);ra=+h[ma>>3];if(!(ra>=0.0)){ma=c[21062]|0;s=N;h[k>>3]=ra;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=ma;ma=r;P=6928;c[ma+0>>2]=c[P+0>>2];c[ma+4>>2]=c[P+4>>2];c[ma+8>>2]=c[P+8>>2];c[ma+12>>2]=c[P+12>>2];c[ma+16>>2]=c[P+16>>2];c[ma+20>>2]=c[P+20>>2];De[s&31](b,r,5160,N);}ua=+W(+(d/101325.0),-.5);ta=pa*ua*(qa/+V(+ra))*745.875;c[M>>2]=1;h[(tu(fa,1,M)|0)>>3]=ta;c[L>>2]=1;ta=+h[(tu(f,1,L)|0)>>3];c[K>>2]=2;ra=+h[(tu(f,1,K)|0)>>3];c[J>>2]=3;pa=+h[(tu(f,1,J)|0)>>3];c[I>>2]=4;sa=+h[(tu(f,1,I)|0)>>3];I=H;h[k>>3]=ra;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];I=H+8|0;h[k>>3]=pa;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];I=H+16|0;h[k>>3]=sa;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];su(ja,4,ta,H);H=q;I=ja;c[H+0>>2]=c[I+0>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];ui(na,b,d,e,q);ta=+h[na>>3];if(!(ta>=0.0)){na=c[21062]|0;q=G;h[k>>3]=ta;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=na;na=p;I=6928;c[na+0>>2]=c[I+0>>2];c[na+4>>2]=c[I+4>>2];c[na+8>>2]=c[I+8>>2];c[na+12>>2]=c[I+12>>2];c[na+16>>2]=c[I+16>>2];c[na+20>>2]=c[I+20>>2];De[q&31](b,p,5160,G);}sa=+V(+ta)*qa*+W(+d,-1.5)*-237423.8576274573;c[F>>2]=2;h[(tu(fa,1,F)|0)>>3]=sa;c[E>>2]=1;sa=+h[(tu(f,1,E)|0)>>3];c[D>>2]=2;ta=+h[(tu(f,1,D)|0)>>3];c[C>>2]=3;pa=+h[(tu(f,1,C)|0)>>3];c[B>>2]=4;ra=+h[(tu(f,1,B)|0)>>3];B=A;h[k>>3]=ta;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=pa;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+16|0;h[k>>3]=ra;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];su(ka,4,sa,A);A=o;B=ka;c[A+0>>2]=c[B+0>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];ui(oa,b,d,e,o);d=+h[oa>>3];if(d>=0.0){va=+V(+d);wa=e*e;xa=qa/wa;ya=ua*xa;za=va*ya;Aa=za*-41005224.0;Ba=y;Ca=Ba;c[Ca>>2]=3;Da=32;Ea=Da;Fa=tu(fa,1,y)|0;h[Fa>>3]=Aa;Ga=x;Ha=Ga;c[Ha>>2]=1;Ia=32;Ja=Ia;Ka=tu(fa,1,x)|0;La=+h[Ka>>3];Ma=w;Na=Ma;c[Na>>2]=2;Oa=32;Pa=Oa;Qa=tu(fa,1,w)|0;Ra=+h[Qa>>3];Sa=Ra*g;Ta=v;Ua=Ta;c[Ua>>2]=3;Va=32;Wa=Va;Xa=tu(fa,1,v)|0;Ya=+h[Xa>>3];Za=Ya*j;_a=Sa+Za;$a=La+_a;ab=a;bb=ab;h[bb>>3]=$a;i=m;return}oa=c[21062]|0;o=z;h[k>>3]=d;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=oa;oa=n;B=6928;c[oa+0>>2]=c[B+0>>2];c[oa+4>>2]=c[B+4>>2];c[oa+8>>2]=c[B+8>>2];c[oa+12>>2]=c[B+12>>2];c[oa+16>>2]=c[B+16>>2];c[oa+20>>2]=c[B+20>>2];De[o&31](b,n,5160,z);va=+V(+d);wa=e*e;xa=qa/wa;ya=ua*xa;za=va*ya;Aa=za*-41005224.0;Ba=y;Ca=Ba;c[Ca>>2]=3;Da=32;Ea=Da;Fa=tu(fa,1,y)|0;h[Fa>>3]=Aa;Ga=x;Ha=Ga;c[Ha>>2]=1;Ia=32;Ja=Ia;Ka=tu(fa,1,x)|0;La=+h[Ka>>3];Ma=w;Na=Ma;c[Na>>2]=2;Oa=32;Pa=Oa;Qa=tu(fa,1,w)|0;Ra=+h[Qa>>3];Sa=Ra*g;Ta=v;Ua=Ta;c[Ua>>2]=3;Va=32;Wa=Va;Xa=tu(fa,1,v)|0;Ya=+h[Xa>>3];Za=Ya*j;_a=Sa+Za;$a=La+_a;ab=a;bb=ab;h[bb>>3]=$a;i=m;return}function Ni(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0;l=i;i=i+80|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+16|0;c[C>>2]=3;nu(D,1,C);E=+ca(+(-30807.8/e));c[B>>2]=3;F=+h[(tu(f,1,B)|0)>>3];if(!(F>=0.0)){B=c[21062]|0;C=A;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B;B=o;G=6928;c[B+0>>2]=c[G+0>>2];c[B+4>>2]=c[G+4>>2];c[B+8>>2]=c[G+8>>2];c[B+12>>2]=c[G+12>>2];c[B+16>>2]=c[G+16>>2];c[B+20>>2]=c[G+20>>2];De[C&31](b,o,4248,A);}H=+W(+(d/101325.0),-.5);I=H*(E/+V(+F))*1617.67;c[z>>2]=1;h[(tu(D,1,z)|0)>>3]=I;c[y>>2]=3;I=+h[(tu(f,1,y)|0)>>3];if(!(I>=0.0)){y=c[21062]|0;z=x;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y;y=n;A=6928;c[y+0>>2]=c[A+0>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];c[y+12>>2]=c[A+12>>2];c[y+16>>2]=c[A+16>>2];c[y+20>>2]=c[A+20>>2];De[z&31](b,n,4248,x);}F=+V(+I)*E*+W(+d,-1.5)*-514930.0509712873;c[w>>2]=2;h[(tu(D,1,w)|0)>>3]=F;c[v>>2]=3;F=+h[(tu(f,1,v)|0)>>3];if(F>=0.0){J=+V(+F);K=e*e;L=E/K;M=H*L;N=J*M;O=N*-99673707.652;P=t;Q=P;c[Q>>2]=3;R=32;S=R;T=tu(D,1,t)|0;h[T>>3]=O;U=s;X=U;c[X>>2]=1;Y=32;Z=Y;_=tu(D,1,s)|0;$=+h[_>>3];aa=r;ba=aa;c[ba>>2]=3;da=32;ea=da;fa=tu(f,1,r)|0;ga=+h[fa>>3];ha=$*ga;ia=q;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=tu(D,1,q)|0;na=+h[ma>>3];oa=na*g;pa=p;qa=pa;c[qa>>2]=3;ra=32;sa=ra;ta=tu(D,1,p)|0;ua=+h[ta>>3];va=ua*j;wa=oa+va;xa=ha+wa;ya=a;za=ya;h[za>>3]=xa;i=l;return}v=c[21062]|0;w=u;h[k>>3]=F;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=v;v=m;x=6928;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];De[w&31](b,m,4248,u);J=+V(+F);K=e*e;L=E/K;M=H*L;N=J*M;O=N*-99673707.652;P=t;Q=P;c[Q>>2]=3;R=32;S=R;T=tu(D,1,t)|0;h[T>>3]=O;U=s;X=U;c[X>>2]=1;Y=32;Z=Y;_=tu(D,1,s)|0;$=+h[_>>3];aa=r;ba=aa;c[ba>>2]=3;da=32;ea=da;fa=tu(f,1,r)|0;ga=+h[fa>>3];ha=$*ga;ia=q;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=tu(D,1,q)|0;na=+h[ma>>3];oa=na*g;pa=p;qa=pa;c[qa>>2]=3;ra=32;sa=ra;ta=tu(D,1,p)|0;ua=+h[ta>>3];va=ua*j;wa=oa+va;xa=ha+wa;ya=a;za=ya;h[za>>3]=xa;i=l;return}function Oi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function Pi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function Qi(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0;l=i;i=i+80|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+16|0;c[I>>2]=3;nu(J,1,I);g=+ca(+(-10973.6/e));c[H>>2]=2;d=+h[(tu(f,1,H)|0)>>3];c[G>>2]=3;K=d*+h[(tu(f,1,G)|0)>>3];if(!(K>=0.0)){G=c[21062]|0;H=F;h[k>>3]=K;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=o;I=6928;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];De[H&31](b,o,4616,F);}c[E>>2]=3;d=+h[(tu(f,1,E)|0)>>3]*(g/+V(+K))*2.2771;c[D>>2]=1;h[(tu(J,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(tu(f,1,C)|0)>>3];c[B>>2]=3;K=d*+h[(tu(f,1,B)|0)>>3];if(!(K>=0.0)){B=c[21062]|0;C=A;h[k>>3]=K;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B;B=n;D=6928;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[B+12>>2]=c[D+12>>2];c[B+16>>2]=c[D+16>>2];c[B+20>>2]=c[D+20>>2];De[C&31](b,n,4616,A);}c[z>>2]=2;d=+h[(tu(f,1,z)|0)>>3]*(g/+V(+K))*2.2771;c[y>>2]=2;h[(tu(J,1,y)|0)>>3]=d;c[x>>2]=2;d=+h[(tu(f,1,x)|0)>>3];c[w>>2]=3;K=d*+h[(tu(f,1,w)|0)>>3];if(K>=0.0){L=+V(+K);M=e*e;N=g/M;O=L*N;P=O*-49975.96912;Q=u;R=Q;c[R>>2]=3;S=32;T=S;U=tu(J,1,u)|0;h[U>>3]=P;W=t;X=W;c[X>>2]=1;Y=32;Z=Y;_=tu(J,1,t)|0;$=+h[_>>3];aa=s;ba=aa;c[ba>>2]=2;da=32;ea=da;fa=tu(f,1,s)|0;ga=+h[fa>>3];ha=$*ga;ia=r;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=tu(J,1,r)|0;na=+h[ma>>3];oa=q;pa=oa;c[pa>>2]=3;qa=32;ra=qa;sa=tu(f,1,q)|0;ta=+h[sa>>3];ua=na*ta;va=p;wa=va;c[wa>>2]=3;xa=32;ya=xa;za=tu(J,1,p)|0;Aa=+h[za>>3];Ba=Aa*j;Ca=ua+Ba;Da=ha+Ca;Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}w=c[21062]|0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=w;w=m;y=6928;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];De[x&31](b,m,4616,v);L=+V(+K);M=e*e;N=g/M;O=L*N;P=O*-49975.96912;Q=u;R=Q;c[R>>2]=3;S=32;T=S;U=tu(J,1,u)|0;h[U>>3]=P;W=t;X=W;c[X>>2]=1;Y=32;Z=Y;_=tu(J,1,t)|0;$=+h[_>>3];aa=s;ba=aa;c[ba>>2]=2;da=32;ea=da;fa=tu(f,1,s)|0;ga=+h[fa>>3];ha=$*ga;ia=r;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=tu(J,1,r)|0;na=+h[ma>>3];oa=q;pa=oa;c[pa>>2]=3;qa=32;ra=qa;sa=tu(f,1,q)|0;ta=+h[sa>>3];ua=na*ta;va=p;wa=va;c[wa>>2]=3;xa=32;ya=xa;za=tu(J,1,p)|0;Aa=+h[za>>3];Ba=Aa*j;Ca=ua+Ba;Da=ha+Ca;Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}function Ri(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-303.0e3/e+-14554.0e6/(e*c))*d;i=i;return}function Si(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-57200.0/e+-6272.0e6/(e*c))*d;i=i;return}function Ti(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;nu(n,1,m);m=n;n=3960;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[21062]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=6928;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];De[m&31](b,g,4704,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[21062]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=6928;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];De[g&31](b,f,4784,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function Ui(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function Vi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-393.0e3/e+-11652.0e6/(e*c))*d;i=i;return}function Wi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function Xi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-15.0e4/e+-15318.0e6/(e*c))*d;i=i;return}function Yi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-16200.0/e+-1988.0e6/(e*c))*d;i=i;return}function Zi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;nu(l,1,j);j=l;l=3960;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+od(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[21062]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=6928;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];De[j&31](b,f,3976,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function _omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(tu(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(tu(l,1,pb)|0)>>3];c[qb>>2]=55;h[(tu(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[21062]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[6928+0>>2];c[a+4>>2]=c[6928+4>>2];c[a+8>>2]=c[6928+8>>2];c[a+12>>2]=c[6928+12>>2];c[a+16>>2]=c[6928+16>>2];c[a+20>>2]=c[6928+20>>2];De[td&31](d,a,4104,rb);}c[sb>>2]=9;sd=+h[(tu(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(tu(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(tu(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(tu(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(tu(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(tu(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(tu(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(tu(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(tu(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(tu(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(tu(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(tu(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(tu(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(tu(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(tu(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(tu(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(tu(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(tu(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(tu(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(tu(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(tu(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(tu(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(tu(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(tu(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(tu(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(tu(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(tu(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(tu(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(tu(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(tu(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(tu(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(tu(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(tu(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(tu(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(tu(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(tu(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(tu(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(tu(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(tu(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(tu(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(tu(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(tu(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(tu(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(tu(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(tu(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(tu(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(tu(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(tu(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(tu(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(tu(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(tu(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(tu(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(tu(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(tu(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(tu(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(tu(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(tu(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(tu(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(tu(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(tu(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(tu(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(tu(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(tu(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(tu(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(tu(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(tu(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(tu(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(tu(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(tu(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(tu(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(tu(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(tu(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(tu(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(tu(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(tu(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(tu(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(tu(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(tu(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(tu(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(tu(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(tu(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(tu(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(tu(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(tu(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(tu(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(tu(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(tu(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(tu(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(tu(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(tu(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(tu(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(tu(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(tu(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(tu(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(tu(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(tu(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(tu(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(tu(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(tu(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(tu(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(tu(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(tu(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(tu(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(tu(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(tu(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(tu(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(tu(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(tu(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(tu(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(tu(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(tu(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(tu(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(tu(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(tu(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(tu(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(tu(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(tu(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(tu(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(tu(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(tu(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(tu(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(tu(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(tu(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(tu(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(tu(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(tu(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(tu(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(tu(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(tu(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(tu(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(tu(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(tu(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(tu(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(tu(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(tu(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(tu(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(tu(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(tu(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(tu(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(tu(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(tu(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(tu(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(tu(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(tu(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(tu(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(tu(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(tu(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(tu(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(tu(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(tu(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(tu(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(tu(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(tu(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(tu(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(tu(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(tu(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(tu(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(tu(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(tu(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(tu(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(tu(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(tu(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(tu(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(tu(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(tu(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(tu(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(tu(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(tu(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(tu(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(tu(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(tu(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(tu(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(tu(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(tu(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(tu(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(tu(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(tu(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(tu(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(tu(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(tu(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(tu(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(tu(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(tu(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(tu(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(tu(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(tu(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(tu(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(tu(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(tu(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(tu(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(tu(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(tu(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(tu(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(tu(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(tu(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(tu(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(tu(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(tu(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(tu(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(tu(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(tu(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(tu(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(tu(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(tu(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(tu(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(tu(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(tu(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(tu(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(tu(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(tu(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(tu(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(tu(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(tu(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(tu(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(tu(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(tu(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(tu(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}function _omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(yt(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=yt(x,16,1,Ua)|0;c[Va>>2]=2;Db=yt(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];ni(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=yt(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];pi(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=yt(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];pi(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=yt(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(yt(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=yt(x,16,1,_a)|0;c[$a>>2]=4;Cb=yt(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];ni(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=yt(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];pi(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=yt(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];pi(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=yt(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(yt(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=yt(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];mi(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=yt(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];mi(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];ni(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];ri(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=yt(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];mi(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];ri(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=yt(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];mi(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];ri(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;li(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=yt(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];ni(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];qi(G,d,a+1248|0);li(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=yt(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];oi(I,0,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];pi(J,0,a+1200|0,a+1184|0);li(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=yt(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];pi(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];qi(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];pi(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=yt(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(yt(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;li(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=yt(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];ni(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];qi(P,d,a+1056|0);li(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=yt(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];pi(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];qi(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];pi(T,0,a+992|0,a+976|0);li(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=yt(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];oi(V,0,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];pi(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=yt(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(yt(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=yt(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];mi(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=yt(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];mi(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];ni(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];ri(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;li($,0,1.0,0.0);li(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=yt(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];pi(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];oi(ca,0,a+752|0,a+736|0);li(da,0,1.0,0.0);li(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=yt(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];ni(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];oi(ga,0,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];ni(ha,0,a+656|0,a+640|0);li(ia,0,2.0,0.0);c[wb>>2]=1;Cb=yt(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];oi(ja,0,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];pi(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];mi(la,0,a+560|0,a+544|0);li(ma,0,1.0,0.0);li(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=yt(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];pi(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];oi(pa,0,a+496|0,a+480|0);li(qa,0,1.0,0.0);li(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=yt(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];ni(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];oi(ta,0,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];ni(ua,0,a+400|0,a+384|0);li(va,0,2.0,0.0);c[zb>>2]=2;Cb=yt(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];oi(wa,0,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];pi(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];mi(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];ni(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];ri(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;li(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=yt(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];ni(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];qi(Ca,d,a+192|0);li(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=yt(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];oi(Ea,0,a+176|0,a+160|0);li(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=yt(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];pi(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];qi(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];ni(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];pi(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];mi(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];ri(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function th(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;nu(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(tu(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(tu(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(tu(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(tu(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(tu(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(tu(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(tu(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(tu(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(tu(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(tu(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(tu(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(tu(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(tu(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(tu(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(tu(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(tu(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(tu(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(tu(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(tu(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(tu(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(tu(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(tu(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(tu(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(tu(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(tu(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(tu(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(tu(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(tu(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(tu(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(tu(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(tu(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(tu(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(tu(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(tu(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(tu(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(tu(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(tu(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(tu(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(tu(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(tu(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(tu(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(tu(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(tu(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(tu(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(tu(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(tu(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(tu(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(tu(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(tu(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(tu(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(tu(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(tu(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(tu(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(tu(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(tu(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(tu(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(tu(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(tu(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(tu(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(tu(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(tu(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(tu(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(tu(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(tu(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(tu(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(tu(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(tu(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(tu(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(tu(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(tu(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(tu(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(tu(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(tu(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(tu(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(tu(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(tu(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(tu(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(tu(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(tu(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(tu(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(tu(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(tu(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(tu(Xf,1,se)|0)>>3];c[re>>2]=31;h[(tu(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(tu(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(tu(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(tu(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(tu(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(tu(Xf,1,me)|0)>>3];c[le>>2]=34;h[(tu(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(tu(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(tu(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(tu(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(tu(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(tu(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(tu(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(tu(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(tu(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(tu(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(tu(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(tu(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(tu(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(tu(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(tu(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(tu(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(tu(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(tu(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(tu(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(tu(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(tu(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(tu(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(tu(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(tu(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(tu(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(tu(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(tu(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(tu(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(tu(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(tu(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(tu(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(tu(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(tu(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(tu(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(tu(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(tu(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(tu(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(tu(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(tu(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(tu(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(tu(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(tu(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(tu(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(tu(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(tu(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(tu(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(tu(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(tu(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(tu(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(tu(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function uh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function vh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;nu(Oa,1,Na);c[Oa+0>>2]=c[4088+0>>2];c[Oa+4>>2]=c[4088+4>>2];c[Oa+8>>2]=c[4088+8>>2];c[Ma>>2]=2;xt(Pa,16,1,Ma);c[La>>2]=1;Ma=yt(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=yt(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;xt(Qa,16,1,Ja);c[Ia>>2]=1;Ja=yt(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=yt(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=yt(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;xt(Ua,16,1,Fa);if((wg(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +lu(4088,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((wg(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=yt(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(yt(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((wg(2,2,3)|0)!=0){Fa=2;do{Bg(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=yt(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];wh(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];xh(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((wg(Fa,2,3)|0)!=0)}if((wg(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +lu(4088,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((wg(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}Bg(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=yt(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];yh(Ya,0,f+2512|0,f+2496|0);Bg(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=yt(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];yh(_a,0,f+2480|0,f+2464|0);Bg($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];wh(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];xh(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((wg(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +lu(4088,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((wg(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}Bg(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=yt(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];wh(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;Bg(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=yt(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];zh(db,0,f+2352|0,f+2336|0);Bg(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=yt(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];zh(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];Ah(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];wh(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=yt(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(yt(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;Bg(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=yt(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];xh(ib,0,f+2240|0,f+2224|0);Bg(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=yt(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];xh(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];Ah(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];wh(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=yt(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(yt(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;Bg(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=yt(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];zh(nb,0,f+2128|0,f+2112|0);Bg(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=yt(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];zh(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];Ah(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];wh(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=yt(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(yt(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;Bg(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=yt(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];xh(sb,0,f+2016|0,f+2e3|0);Bg(tb,0,e/273.16,0.0);c[la>>2]=2;rb=yt(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];xh(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];Ah(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];wh($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=yt(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(yt(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;Bg(wb,0,2.0,0.0);c[ia>>2]=1;$c=yt(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];wh(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=yt(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];Ah(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];wh(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=yt(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(yt(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;Bg(zb,0,2.0,0.0);c[ea>>2]=2;ad=yt(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];wh(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=yt(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];Ah(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];wh(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=yt(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(yt(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;Bg(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=yt(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];yh(cd,0,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=yt(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(yt(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;Bg(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=yt(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];yh(dd,0,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=yt(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function wh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];Bg(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function xh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Bg(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function yh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;Bg(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function zh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Bg(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function Ah(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];vg(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[21062]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=6928;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];De[d&31](b,f,4160,g);}Bg(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function Bh(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function Ch(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0;e=i;i=i+88|0;f=e;th(f,b,c,d);h[a>>3]=c/(+h[f+16>>3]*+h[f+24>>3]*+h[f+48>>3]*d);i=e;return}function Dh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;nu(l,1,j);j=l;l=3960;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+od(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[21062]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=6928;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];De[j&31](b,f,3976,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function Eh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(tu(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[21062]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=6928;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4320,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(tu(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function Fh(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;kg(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function Gh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Hh(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Ih(b,0,0.0,0.0,g);i=f;return}function Hh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;vh(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+Tu(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function Ih(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Jh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;nu(g,1,f);f=g;g=4056;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;nu(j,1,e);e=j;j=4072;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((wg(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+lu(4056,j);t=s+d*+W(+k,+(+lu(4072,j)));j=r+1|0;if((wg(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function Kh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function Lh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Hh(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Kh(b,0,0.0,0.0,g);i=f;return}function Mh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(tu(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[21062]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=6928;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4248,m);}c[l>>2]=1;h[a>>3]=+h[(tu(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function Nh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function Oh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(tu(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[21062]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=6928;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];De[f&31](b,j,4248,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function Ph(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(tu(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(tu(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(tu(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(tu(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];su(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];Mh(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[21062]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=6928;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];De[l&31](b,j,4936,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function Qh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(tu(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(tu(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[21062]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=6928;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];De[f&31](b,j,4616,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function Rh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function Sh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function Th(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function Uh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function Vh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;nu(n,1,m);m=n;n=3960;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[21062]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=6928;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];De[m&31](b,g,4704,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[21062]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=6928;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];De[g&31](b,f,4784,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function Wh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){Jh(j,0,d);m=+h[j>>3];Fh(k,b,c);n=+h[k>>3];o=m}else{Dh(f,b,d);m=+h[f>>3];Vh(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}Xh(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function Xh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function Yh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(tu(f,1,n)|0)>>3]==0.0){pg(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Zh(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(tu(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(tu(f,1,l)|0)>>3]);_h(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){pg(u,b,G,e);J=+h[u>>3];sh(v,b,F,e,0);K=J+I*+h[v>>3];break}else{pg(r,b,G,e);J=+h[r>>3];sh(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];$h(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){pg(w,b,G,e);L=+h[w>>3];sh(x,b,F,e,0);J=+h[x>>3];Gh(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{pg(z,b,G,e);J=+h[z>>3];sh(A,b,F,e,0);L=+h[A>>3];kh(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function Zh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(tu(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(tu(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(tu(f,1,j)|0)>>3]);Wh(m,b,d,e);r=+h[m>>3];_h(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function _h(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;Wh(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){Vh(j,b,c);l=+h[j>>3]}else{Fh(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function $h(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;nu(Na,1,Ma);c[La>>2]=4;nu(Oa,1,La);c[Ka>>2]=4;nu(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(tu(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(tu(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(tu(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(tu(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];su(Qa,4,ob,Fa);ou(Qa,Oa);Qa=(wg(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+lu(4920,Fa+ -1|0);c[Ea>>2]=Fa;h[(tu(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((wg(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(tu(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(tu(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(tu(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(tu(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(tu(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(tu(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(tu(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(tu(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(tu(Oa,1,va)|0)>>3];pb=sb*(ob/+lu(4920,Qa+ -1|0));c[ua>>2]=Qa;h[(tu(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((wg(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(tu(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(tu(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(tu(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(tu(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];su(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];Mh($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(tu(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(tu(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(tu(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(tu(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];su(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];Eh(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(tu(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(tu(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(tu(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(tu(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];su(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];Ph(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(tu(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(tu(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(tu(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(tu(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];su(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];Oh(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(tu(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(tu(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(tu(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(tu(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];su(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];Qh(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(tu(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(tu(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(tu(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(tu(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];su(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];Mh(eb,b,d,e,o);tb=+h[eb>>3];Nh(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(tu(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(tu(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(tu(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(tu(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];su(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];Eh(gb,b,d,e,n);qb=+h[gb>>3];Sh(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(tu(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(tu(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(tu(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(tu(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];su(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];Ph(ib,b,d,e,m);vb=+h[ib>>3];Rh(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(tu(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(tu(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(tu(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(tu(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];su(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];Oh(kb,b,d,e,l);d=+h[kb>>3];Uh(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(tu(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(tu(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(tu(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(tu(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];su(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Qh(mb,b,0.0,e,j);yb=+h[mb>>3];Th(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(tu(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(tu(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(tu(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(tu(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function ai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(tu(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(tu(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];su(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Yh(d,b,o,p,f);i=e;return}function bi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;nu(u,1,n);c[m>>2]=2;nu(u,1,m);if((ft(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];uh(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +vu(f);su(q,1,w,l);c[k>>2]=q;uu(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];uh(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];ou(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function ci(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;g=i;i=i+24|0;j=g;k=g+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[m>>2]=1;if(+h[(tu(f,1,m)|0)>>3]==0.0){xg(n,b,d,e);y=+h[n>>3];z=a;A=z;h[A>>3]=y;i=g;return}c[l>>2]=1;B=+h[(tu(f,1,l)|0)>>3];c[k>>2]=1;C=B/(1.0- +h[(tu(f,1,k)|0)>>3]);_h(o,b,d,e);B=+h[o>>3];o=j;k=f;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];Zh(p,b,d,e,j);D=+h[p>>3];E=d-D;p=e<273.16;if(C<=B|B==-1.0){if(p){xg(q,b,E,e);y=+h[q>>3]+D/(e*461.51805);z=a;A=z;h[A>>3]=y;i=g;return}else{xg(r,b,E,e);F=+h[r>>3];Ch(s,b,D,e);y=F+ +h[s>>3];z=a;A=z;h[A>>3]=y;i=g;return}}else{if(p){xg(t,b,E,e);F=+h[t>>3];Lh(u,b,d,e);y=(C+1.0)/((B+1.0)/(F+D/(e*461.51805))+(C-B)/+h[u>>3]);z=a;A=z;h[A>>3]=y;i=g;return}else{xg(v,b,E,e);E=+h[v>>3];Ch(w,b,D,e);D=+h[w>>3];oh(x,b,d,e,0);y=(C+1.0)/((B+1.0)/(E+D)+(C-B)/+h[x>>3]);z=a;A=z;h[A>>3]=y;i=g;return}}}function di(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;c[l>>2]=1;if(+h[(tu(f,1,l)|0)>>3]==0.0){p=0.0;q=a;r=q;h[r>>3]=p;i=g;return}c[k>>2]=1;s=+h[(tu(f,1,k)|0)>>3];c[j>>2]=1;t=s/(1.0- +h[(tu(f,1,j)|0)>>3]);if(!(e>=273.16)){Jh(n,0,e);u=+h[n>>3]}else{qh(m,b,e);u=+h[m>>3]}Xh(o,0,0.0,0.0);e=u*+h[o>>3];u=t*(d/(t+.6221042453709779));if(!(u<=e)){p=-1.0;q=a;r=q;h[r>>3]=p;i=g;return}p=u/e;q=a;r=q;h[r>>3]=p;i=g;return}function ei(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];bi(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];ai(j,b,h);i=g;return}function _omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(tu(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(tu(l,1,pb)|0)>>3];c[qb>>2]=55;h[(tu(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[21062]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[6928+0>>2];c[a+4>>2]=c[6928+4>>2];c[a+8>>2]=c[6928+8>>2];c[a+12>>2]=c[6928+12>>2];c[a+16>>2]=c[6928+16>>2];c[a+20>>2]=c[6928+20>>2];De[td&31](d,a,4104,rb);}c[sb>>2]=9;sd=+h[(tu(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(tu(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(tu(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(tu(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(tu(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(tu(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(tu(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(tu(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(tu(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(tu(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(tu(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(tu(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(tu(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(tu(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(tu(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(tu(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(tu(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(tu(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(tu(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(tu(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(tu(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(tu(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(tu(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(tu(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(tu(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(tu(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(tu(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(tu(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(tu(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(tu(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(tu(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(tu(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(tu(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(tu(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(tu(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(tu(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(tu(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(tu(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(tu(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(tu(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(tu(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(tu(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(tu(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(tu(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(tu(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(tu(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(tu(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(tu(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(tu(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(tu(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(tu(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(tu(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(tu(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(tu(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(tu(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(tu(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(tu(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(tu(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(tu(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(tu(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(tu(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(tu(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(tu(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(tu(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(tu(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(tu(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(tu(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(tu(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(tu(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(tu(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(tu(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(tu(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(tu(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(tu(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(tu(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(tu(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(tu(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(tu(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(tu(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(tu(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(tu(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(tu(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(tu(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(tu(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(tu(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(tu(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(tu(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(tu(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(tu(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(tu(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(tu(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(tu(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(tu(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(tu(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(tu(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(tu(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(tu(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(tu(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(tu(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(tu(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(tu(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(tu(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(tu(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(tu(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(tu(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(tu(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(tu(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(tu(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(tu(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(tu(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(tu(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(tu(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(tu(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(tu(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(tu(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(tu(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(tu(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(tu(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(tu(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(tu(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(tu(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(tu(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(tu(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(tu(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(tu(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(tu(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(tu(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(tu(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(tu(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(tu(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(tu(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(tu(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(tu(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(tu(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(tu(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(tu(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(tu(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(tu(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(tu(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(tu(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(tu(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(tu(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(tu(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(tu(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(tu(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(tu(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(tu(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(tu(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(tu(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(tu(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(tu(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(tu(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(tu(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(tu(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(tu(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(tu(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(tu(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(tu(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(tu(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(tu(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(tu(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(tu(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(tu(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(tu(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(tu(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(tu(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(tu(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(tu(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(tu(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(tu(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(tu(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(tu(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(tu(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(tu(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(tu(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(tu(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(tu(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(tu(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(tu(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(tu(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(tu(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(tu(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(tu(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(tu(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(tu(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(tu(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(tu(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(tu(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(tu(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(tu(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(tu(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(tu(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(tu(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(tu(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(tu(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(tu(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(tu(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(tu(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(tu(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(tu(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(tu(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(tu(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(tu(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(tu(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(tu(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(tu(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(tu(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(tu(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(tu(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(tu(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(tu(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(tu(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(tu(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(tu(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(tu(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(tu(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(tu(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}function _omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(yt(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=yt(x,16,1,Ua)|0;c[Va>>2]=2;Db=yt(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];xh(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=yt(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];zh(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=yt(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];zh(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=yt(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(yt(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=yt(x,16,1,_a)|0;c[$a>>2]=4;Cb=yt(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];xh(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=yt(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];zh(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=yt(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];zh(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=yt(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(yt(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=yt(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];wh(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=yt(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];wh(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];xh(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];Bh(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=yt(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];wh(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];Bh(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=yt(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];wh(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];Bh(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;Bg(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=yt(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];xh(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];Ah(G,d,a+1248|0);Bg(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=yt(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];yh(I,0,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];zh(J,0,a+1200|0,a+1184|0);Bg(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=yt(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];zh(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];Ah(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];zh(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=yt(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(yt(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;Bg(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=yt(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];xh(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];Ah(P,d,a+1056|0);Bg(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=yt(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];zh(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];Ah(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];zh(T,0,a+992|0,a+976|0);Bg(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=yt(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];yh(V,0,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];zh(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=yt(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(yt(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=yt(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];wh(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=yt(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];wh(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];xh(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];Bh(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;Bg($,0,1.0,0.0);Bg(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=yt(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];zh(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];yh(ca,0,a+752|0,a+736|0);Bg(da,0,1.0,0.0);Bg(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=yt(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];xh(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];yh(ga,0,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];xh(ha,0,a+656|0,a+640|0);Bg(ia,0,2.0,0.0);c[wb>>2]=1;Cb=yt(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];yh(ja,0,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];zh(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];wh(la,0,a+560|0,a+544|0);Bg(ma,0,1.0,0.0);Bg(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=yt(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];zh(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];yh(pa,0,a+496|0,a+480|0);Bg(qa,0,1.0,0.0);Bg(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=yt(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];xh(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];yh(ta,0,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];xh(ua,0,a+400|0,a+384|0);Bg(va,0,2.0,0.0);c[zb>>2]=2;Cb=yt(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];yh(wa,0,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];zh(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];wh(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];xh(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];Bh(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;Bg(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=yt(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];xh(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];Ah(Ca,d,a+192|0);Bg(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=yt(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];yh(Ea,0,a+176|0,a+160|0);Bg(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=yt(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];zh(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];Ah(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];xh(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];zh(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];wh(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];Bh(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function Eq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=Yq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=oq(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=Uq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=oq(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Fq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=oq(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=oq(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Gq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=oq(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Hq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=oq(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 2:{n=15;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=19;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Uq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=oq(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Iq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=oq(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=18;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Uq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Vq(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=oq(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Jq(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=oq(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 5:{break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=oq(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Kq(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Lq(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=oq(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Mq(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=oq(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Nq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=oq(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=oq(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Oq(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Cp(c)|0;k=j;i=b;return k|0}function Pq(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function Qq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=oq(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=oq(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Rq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=oq(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Sq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Tq(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Uq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=Wq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=oq(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Vq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=oq(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Wq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=Xq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=oq(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Xq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=oq(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=oq(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Yq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=ar(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=oq(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=Zq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=_q(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=$q(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=oq(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{o=42;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=45;break b;break};case 17:{break b;break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=oq(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 24:case 22:{break};default:{o=68;break b}}b=b+2|0;continue b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=oq(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 24:case 22:{break d;break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};case 17:{break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=br(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Zq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=oq(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function _q(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[28824+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function $q(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=oq(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=oq(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 15:{p=62;break b;break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((cr(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=oq(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((cr(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function ar(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=oq(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=oq(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function br(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=oq(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 5:{l=10;break a;break};case 29:{if((c[26504+((d[27784+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=oq(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=oq(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=oq(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=oq(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 3:{t=Uq(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 2:{l=79;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=oq(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=oq(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[26504+((d[26248+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function cr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function dr(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=oq(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=oq(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function er(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=oq(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=oq(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=Zq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function fr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=oq(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function gr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 30:{k=Gr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((se[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((se[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 13:{k=Qr(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((se[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((se[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 12:{k=Qr(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((se[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((se[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=Rr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Mr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 19:{k=Sr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{n=69;break b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 29:{n=91;break b;break};case 7:{if((e-b|0)<4){n=104;break b}p=b;if((se[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=p+4|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}q=b;if((se[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=q+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}r=b;if((se[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=r+3|0;continue b;break};default:{m=19;continue b}}break};case 6:{if((e-b|0)<3){n=77;break b}s=b;if((se[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=s+3|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}t=b;if((se[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=t+4|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 15:{n=116;break b;break};case 33:{n=113;break b;break};case 34:{n=110;break b;break};case 5:{if((e-b|0)<2){n=72;break b}u=b;if((se[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=u+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==110){p=b;if((m|0)==19){c[f>>2]=p;k=0;l=k;i=h;return l|0}else{c[f>>2]=p+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){p=b;if((m|0)==19){c[f>>2]=p;k=0;l=k;i=h;return l|0}else{c[f>>2]=p+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){p=b;if((m|0)==19){c[f>>2]=p;k=0;l=k;i=h;return l|0}else{c[f>>2]=p+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function hr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=Fr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=Jr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((se[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((se[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((se[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ir(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 6:{if((e-b|0)<3){n=43;break b}if((se[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((se[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 7:{if((e-b|0)<4){n=47;break b}if((se[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function jr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{k=19;break a;break};case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((se[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((se[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((se[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function kr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 10:{m=13;break a;break};case 3:{m=9;break a;break};case 21:{m=23;break a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=16;break a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 2:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Fr(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function lr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=18;break a;break};case 6:{a=a+3|0;continue a;break};case 30:{m=12;break a;break};case 10:{m=15;break a;break};case 3:{m=9;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Fr(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Gr(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function mr(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function nr(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function or(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{break a}}}i=c;return a-b|0}function pr(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function qr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function rr(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Cp(c)|0;g=f;i=b;return g|0}function sr(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function tr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 7:{a=a+4|0;break};case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function ur(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function vr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function wr(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function xr(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[26504+(((d[27784+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function yr(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[26504+(((d[27784+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function zr(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Ar(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[26504+(((d[26248+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Br(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[26504+(((d[26248+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Cr(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Dr(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Er(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Fr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=Hr(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}m=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Gr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{l=25;break b;break};case 6:{if((b-a|0)<3){l=33;break b}m=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Hr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Ir(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Ir(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Jr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:{k=Nr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=Lr(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=Kr(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Mr(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 17:{break b;break};case 7:{if((e-b|0)<4){m=46;break b}n=b;if((se[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((se[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}p=b;if((se[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=p+3|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=63;break b}q=b;if((se[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}r=b;if((se[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=r+4|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}s=b;if((se[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=s+2|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 11:{m=97;break b;break};case 29:{m=33;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{m=88;break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 24:case 22:{m=77;break d;break};case 11:{m=97;break c;break};case 29:{m=76;break d;break};case 6:{m=83;break d;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Or(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Kr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}n=b;if((se[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((se[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((se[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Lr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[29200+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Mr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){o=27;break b}p=b;if((se[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 29:{o=24;break b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((se[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 15:{o=68;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((se[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Pr(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 8:case 1:case 0:{o=61;break c;break};case 5:{if((e-b|0)<2){o=47;break c}s=b;if((se[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((se[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}u=b;if((se[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=u+4|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Pr(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Nr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 29:{l=24;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 11:{l=49;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 23:{a=a+1|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Or(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(se[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=m+2;continue a;break};case 29:{l=26;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(se[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=n+4;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(se[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=o+3;continue a;break};default:{l=43;break a}}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=48;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}p=(se[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!p){l=19;break a}c[j>>2]=q+4;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}p=(se[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!p){l=14;break a}c[j>>2]=r+3;continue a;break};case 14:{break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}p=(se[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!p){l=9;break a}c[j>>2]=s+2;continue a;break};case 29:{l=4;break a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}p=t;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}p=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((p|0)==(t|0)){break}switch(p|0){case 8:case 1:case 0:{l=75;break a;break};case 2:{l=80;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}p=(se[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(p){l=68;break a}c[j>>2]=u+3;continue c;break};case 3:{v=Fr(k,(c[j>>2]|0)+1|0,e,j)|0;if((v|0)<=0){l=77;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}p=(se[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(p){l=63;break a}c[j>>2]=w+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}p=(se[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(p){l=73;break a}c[j>>2]=x+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=89;break a;break};case 7:{l=101;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 5:{l=91;break d;break};case 6:{l=96;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}p=(se[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!p){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}p=(se[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!p){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}p=(se[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!p){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((v|0)==0){c[f>>2]=c[j>>2]}B=v;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Pr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Qr(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((se[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((se[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((se[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function Rr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=Kr(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function Sr(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 29:{l=24;break b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function Tr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function Ur(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function Vr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}



function QM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=bd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Be[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=bd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((md(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function RM(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);i=b;return}function SM(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);bY(a);i=b;return}function TM(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AU(d,109240)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(de[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function UM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=te[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function VM(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((se[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function WM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Be[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function XM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=106448;j=b+4|0;wU(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=105800;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;xU(g,j);j=AU(g,109240)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=de[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(de[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){IT(105640)}else{yU(g);i=f;return}}function YM(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);i=b;return}function ZM(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);bY(a);i=b;return}function _M(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=AU(d,109240)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=de[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(de[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){IT(105640)}else{i=e;return}}function $M(a){a=a|0;var b=0,c=0;b=i;c=cN(a,0)|0;i=b;return c|0}function aN(a){a=a|0;var b=0,c=0;b=i;c=cN(a,1)|0;i=b;return c|0}function bN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Be[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((md(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function cN(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=bd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Be[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=bd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((md(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function dN(){var a=0;a=i;BM(0);Ud(200,105064,q|0)|0;i=a;return}function eN(a){a=a|0;i=i;return}function fN(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function gN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}ae[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function hN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=105944;e=xY(b|0)|0;f=aY(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;zY(g|0,b|0,e+1|0)|0;i=d;return}function iN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=105944;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}cY((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}function jN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=105944;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}cY((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function kN(a){a=a|0;i=i;return c[a+4>>2]|0}function lN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=105968;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xY(f|0)|0;g=aY(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;zY(h|0,f|0,d+1|0)|0;i=e;return}function mN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=105968;e=xY(b|0)|0;f=aY(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;zY(g|0,b|0,e+1|0)|0;i=d;return}function nN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=105968;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}cY((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}function oN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=105968;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}cY((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function pN(a){a=a|0;i=i;return c[a+4>>2]|0}function qN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=105944;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}cY((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}function rN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=105944;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}cY((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;bY(j);i=b;return}function sN(a){a=a|0;i=i;return}function tN(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function uN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;ze[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function vN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function wN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Rd(e|0)|0;e=xY(f|0)|0;if(e>>>0>4294967279){CN(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;zY(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=$X(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;zY(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function xN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{hO(e,106184,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;ze[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}hO(e,o,p)|0;if((a[g]&1)==0){break}bY(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function yN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=xY(e|0)|0;if(j>>>0>4294967279){CN(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=$X(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}zY(k|0,e|0,j|0)|0;a[k+j|0]=0;xN(g,d,h);lN(b,g);if(!((a[g]&1)==0)){bY(c[g+8>>2]|0)}if(!((a[h]&1)==0)){bY(c[h+8>>2]|0)}c[b>>2]=106200;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function zN(a){a=a|0;var b=0;b=i;oN(a);bY(a);i=b;return}function AN(a){a=a|0;var b=0;b=i;oN(a);i=b;return}function BN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(106336)|0;if((c[a>>2]|0)==1){do{jd(106360,106336)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;gc(106336)|0;ae[d&255](b);tc(106336)|0;c[a>>2]=-1;gc(106336)|0;_c(106360)|0;i=e;return}else{gc(106336)|0;i=e;return}}function CN(a){a=a|0;a=Ec(8)|0;hN(a,106408);c[a>>2]=106024;Od(a|0,106064,41)}function DN(a){a=a|0;a=Ec(8)|0;hN(a,106408);c[a>>2]=106088;Od(a|0,106128,41)}function EN(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function FN(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function GN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){CN(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=$X(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}zY(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function HN(b){b=b|0;i=i;return(a[b]&1)!=0|0}function IN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){CN(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=$X(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}zY(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function JN(a){a=a|0;i=i;return a|0}function KN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=xY(d|0)|0;if(f>>>0>4294967279){CN(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;zY(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=$X(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;zY(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function LN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){CN(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=$X(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}BY(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function MN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){CN(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;BY(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=$X(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;BY(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function NN(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){DN(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){CN(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;zY(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=$X(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;zY(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function ON(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function PN(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function QN(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}bY(c[b+8>>2]|0);i=d;return}function RN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}iO(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}AY(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function SN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=TN(a,b)|0;i=c;return d|0}function TN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=xY(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}iO(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}AY(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function UN(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function VN(a){a=a|0;i=i;return a+1|0}function WN(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function XN(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function YN(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function ZN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){_N(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function _N(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){jO(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}BY(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function $N(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){_N(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function aO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){CN(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=$X(f)|0}else{p=$X(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}zY(l|0,n|0,q+1|0)|0;if(o){bY(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function bO(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function cO(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function dO(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function eO(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function fO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=hO(b,g,h)|0;i=e;return d|0}function gO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){jO(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function hO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){iO(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}zY(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function iO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){CN(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=$X(q)|0;if((g|0)!=0){zY(e|0,m|0,g|0)|0}if((j|0)!=0){zY(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){zY(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){bY(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function jO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){CN(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=$X(p)|0;if((g|0)!=0){zY(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){zY(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}bY(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function kO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;NN(a,b,c,d,0);i=e;return}function lO(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function mO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=xY(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function nO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=sY(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function oO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=xY(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){DN(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=sY(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function pO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){CN(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;zY(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=$X(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;zY(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function qO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){CN(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=$X(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}wX(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function rO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){CN(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=$X(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}yX(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function sO(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}bY(c[b+8>>2]|0);i=d;return}function tO(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=uO(a,b,vX(b)|0)|0;i=c;return d|0}function uO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}xO(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}xX(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function vO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){CN(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=$X(f)|0}else{p=$X(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}wX(l,n,q+1|0)|0;if(o){bY(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function wO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){yO(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function xO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){CN(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=$X(q<<2)|0;p=e;if((g|0)!=0){wX(p,m,g)|0}if((j|0)!=0){wX(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){wX(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){bY(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function yO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){CN(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=$X(p<<2)|0;o=e;if((g|0)!=0){wX(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){wX(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}bY(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function zO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=xY(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){CN(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=$X(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}zY(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=hO(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=hO(b,m,j)|0;i=f;return}}function AO(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function BO(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function CO(a,b){a=a|0;b=b|0;var c=0;c=i;DO(a,b);i=c;return}function DO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[106792]|0)==0){if((Za(106792)|0)==0){break}c[26696]=107488;Ud(67,106784,q|0)|0;Tb(106792)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=106784;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];yN(b,f,106840);c[e>>2]=106808;Od(e|0,106888,63)}function EO(a,b){a=a|0;b=b|0;var d=0;d=i;DO(a,c[a+16>>2]|b);i=d;return}function FO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=106832;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;ze[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}yU(a+28|0);WX(c[e>>2]|0);WX(c[f>>2]|0);WX(c[a+48>>2]|0);WX(c[a+60>>2]|0);i=b;return}function GO(a){a=a|0;var b=0;b=i;FO(a);bY(a);i=b;return}function HO(a){a=a|0;var b=0;b=i;FO(a);i=b;return}function IO(a){a=a|0;var b=0;b=i;FO(a);i=b;return}function JO(a){a=a|0;i=i;return c[a+24>>2]|0}function KO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}xU(d,a+28|0);a=AU(d,109176)|0;f=se[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;yU(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function LO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;xU(e,a+28|0);a=AU(e,109176)|0;f=se[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;yU(e);i=d;return f|0}function MO(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a,b+28|0);i=c;return}function NO(a){a=a|0;c[a>>2]=106432;i=i;return}function OO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));wU(b);i=d;return}function PO(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);bY(a);i=b;return}function QO(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);i=b;return}function RO(a){a=a|0;var b=0;b=i;c[a>>2]=106448;yU(a+4|0);i=b;return}function SO(a,b){a=a|0;b=b|0;var c=0;c=i;xU(a,b+4|0);i=c;return}function TO(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=de[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function UO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=se[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function VO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ge[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function WO(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=106448;wU(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function XO(a){a=a|0;i=i;return c[a+8>>2]|0}function YO(a){a=a|0;i=i;return c[a+12>>2]|0}function ZO(a){a=a|0;i=i;return c[a+16>>2]|0}function _O(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function $O(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function aP(a){a=a|0;i=i;return c[a+20>>2]|0}function bP(a){a=a|0;i=i;return c[a+24>>2]|0}function cP(a){a=a|0;i=i;return c[a+28>>2]|0}function dP(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function eP(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function fP(a,b){a=a|0;b=b|0;i=i;return}function gP(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function hP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function iP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function jP(a){a=a|0;i=i;return 0}function kP(a){a=a|0;i=i;return 0}function lP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=de[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function mP(a){a=a|0;i=i;return-1}function nP(a){a=a|0;var b=0,e=0,f=0;b=i;if((de[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function oP(a,b){a=a|0;b=b|0;i=i;return-1}function pP(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((se[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function qP(a,b){a=a|0;b=b|0;i=i;return-1}function rP(a){a=a|0;var b=0;b=i;c[a>>2]=106512;yU(a+4|0);bY(a);i=b;return}function sP(a){a=a|0;var b=0;b=i;c[a>>2]=106512;yU(a+4|0);i=b;return}function tP(a,b){a=a|0;b=b|0;i=i;return}function uP(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function vP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function wP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function xP(a){a=a|0;i=i;return 0}function yP(a){a=a|0;i=i;return 0}function zP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=de[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function AP(a){a=a|0;i=i;return-1}function BP(a){a=a|0;var b=0,d=0,e=0;b=i;if((de[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function CP(a,b){a=a|0;b=b|0;i=i;return-1}function DP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((se[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function EP(a,b){a=a|0;b=b|0;i=i;return-1}function FP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));wU(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function GP(a){a=a|0;var b=0;b=i;FO(a+8|0);bY(a);i=b;return}function HP(a){a=a|0;var b=0;b=i;FO(a+8|0);i=b;return}function IP(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FO(a+(d+8)|0);bY(a+d|0);i=b;return}function JP(a){a=a|0;var b=0;b=i;FO(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function KP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LP(a,b,c);i=d;return}function LP(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){DO(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){MP(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}xU(h,e+(k+28)|0);k=AU(h,109176)|0;yU(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(de[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){de[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((de[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;DO(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function MP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{MP(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((de[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;DO(b+h|0,c[b+(h+16)>>2]|1)}}while(0);$P(e);i=d;return b|0}function NP(b){b=b|0;i=i;return(a[b]|0)!=0|0}function OP(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function PP(a){a=a|0;var b=0;b=i;FO(a+8|0);bY(a);i=b;return}function QP(a){a=a|0;var b=0;b=i;FO(a+8|0);i=b;return}function RP(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FO(a+(d+8)|0);bY(a+d|0);i=b;return}function SP(a){a=a|0;var b=0;b=i;FO(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function TP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{TP(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((de[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;DO(b+h|0,c[b+(h+16)>>2]|1)}}while(0);lQ(e);i=d;return b|0}function UP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));wU(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function VP(a){a=a|0;var b=0;b=i;FO(a+4|0);bY(a);i=b;return}function WP(a){a=a|0;var b=0;b=i;FO(a+4|0);i=b;return}function XP(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FO(a+(d+4)|0);bY(a+d|0);i=b;return}function YP(a){a=a|0;var b=0;b=i;FO(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function ZP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){MP(g)|0}a[f]=1;i=e;return}function _P(a){a=a|0;var b=0;b=i;$P(a);i=b;return}function $P(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((de[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;DO(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function aQ(b){b=b|0;i=i;return(a[b]|0)!=0|0}function bQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=de[b&127](a)|0;i=c;return d|0}function cQ(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){$P(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{MP(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;xU(k,b+(p+28)|0);p=AU(k,107896)|0;m=p;yU(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){xU(h,b+(k+28)|0);r=AU(h,109176)|0;s=se[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;yU(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];je[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){$P(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;DO(b+l|0,c[b+(l+16)>>2]|5);$P(j);i=e;return b|0}function dQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){$P(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{MP(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;$P(f);i=e;return b|0}if((se[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{$P(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;DO(b+d|0,c[b+(d+16)>>2]|1);$P(f);i=e;return b|0}function eQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){$P(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){MP(k)|0}a[h]=1;if((e|0)==0){$P(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ge[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){$P(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;DO(b+e|0,c[b+(e+16)>>2]|1);$P(g);i=f;return b|0}function fQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;me[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function gQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){$P(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{MP(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];De[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){$P(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;DO(b+f|0,c[b+(f+16)>>2]|4);$P(h);i=e;return b|0}function hQ(a){a=a|0;var b=0;b=i;FO(a+4|0);bY(a);i=b;return}function iQ(a){a=a|0;var b=0;b=i;FO(a+4|0);i=b;return}function jQ(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;FO(a+(d+4)|0);bY(a+d|0);i=b;return}function kQ(a){a=a|0;var b=0;b=i;FO(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function lQ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((de[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;DO(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function mQ(a){a=a|0;i=i;return 106728}function nQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){IN(a,106744,35);i=d;return}else{wN(a,b,c);i=d;return}}function oQ(a){a=a|0;i=i;return}function pQ(a){a=a|0;var b=0;b=i;AN(a);bY(a);i=b;return}function qQ(a){a=a|0;var b=0;b=i;AN(a);i=b;return}function rQ(a){a=a|0;var b=0;b=i;FO(a);bY(a);i=b;return}function sQ(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function tQ(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function uQ(a){a=a|0;i=i;return}function vQ(a){a=a|0;i=i;return}function wQ(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function xQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){CN(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=$X(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function yQ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function zQ(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function AQ(a){a=a|0;i=i;return}function BQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function CQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){CN(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=$X(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function DQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function EQ(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function FQ(a){a=a|0;i=i;return}function GQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];pe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}MO(u,g);m=u;u=c[m>>2]|0;if(!((c[27294]|0)==-1)){c[p>>2]=109176;c[p+4>>2]=201;c[p+8>>2]=0;BN(109176,p,202)}p=(c[109180>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}F=u;gN(c[m>>2]|0)|0;MO(v,g);g=v;v=c[g>>2]|0;if(!((c[27330]|0)==-1)){c[o>>2]=109320;c[o+4>>2]=201;c[o+8>>2]=0;BN(109320,o,202)}o=(c[109324>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}J=v;gN(c[g>>2]|0)|0;g=w;be[c[(c[v>>2]|0)+24>>2]&63](g,J);be[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=HQ(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];QN(w+12|0);QN(w);i=k;return}function HQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=VX(l)|0;if((n|0)!=0){o=n;p=n;break}gY()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((de[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((de[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=se[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(se[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){de[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((de[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}WX(o);i=k;return _|0}function IQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];JQ(a,0,k,j,f,g,h);i=b;return}function JQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;zR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZN(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZN(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($Q(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=vW(F,c[o>>2]|0,h,t)|0;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}function KQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];LQ(a,0,k,j,f,g,h);i=b;return}function LQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;zR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}ZN(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZN(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if(($Q(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=uW(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}function MQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];NQ(a,0,k,j,f,g,h);i=b;return}function NQ(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;zR(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((de[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}ZN(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}ZN(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if(($Q(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){de[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=tW(G,c[p>>2]|0,j,u)|0;MT(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;QN(o);QN(n);i=e;return}if((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;QN(o);QN(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;QN(o);QN(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;QN(o);QN(n);i=e;return}function OQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];PQ(a,0,k,j,f,g,h);i=b;return}function PQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;zR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZN(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZN(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($Q(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=sW(F,c[o>>2]|0,h,t)|0;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}function QQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];RQ(a,0,k,j,f,g,h);i=b;return}function RQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;zR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}ZN(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}ZN(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if(($Q(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=rW(F,c[o>>2]|0,h,t)|0;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;QN(n);QN(m);i=d;return}function SQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];TQ(a,0,k,j,f,g,h);i=b;return}function TQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;zR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}ZN(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZN(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if(($Q(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=qW(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;QN(n);QN(m);i=d;return}function UQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];VQ(a,0,k,j,f,g,h);i=b;return}function VQ(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AR(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZN(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZN(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BR(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+pW(I,c[p>>2]|0,j);MT(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}function WQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XQ(a,0,k,j,f,g,h);i=b;return}function XQ(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AR(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZN(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZN(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BR(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+oW(I,c[p>>2]|0,j);MT(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}function YQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZQ(a,0,k,j,f,g,h);i=b;return}function ZQ(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;AR(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}ZN(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZN(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((BR(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+nW(I,c[p>>2]|0,j);MT(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;QN(o);QN(n);i=d;return}function _Q(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;MO(o,g);g=o;o=c[g>>2]|0;if(!((c[27294]|0)==-1)){c[l>>2]=109176;c[l+4>>2]=201;c[l+8>>2]=0;BN(109176,l,202)}l=(c[109180>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}y=m;Ce[c[(c[o>>2]|0)+32>>2]&63](o,107720,107746|0,y)|0;gN(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((de[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}ZN(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}ZN(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(de[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if(($Q(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){de[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);K=c[27266]|0;c[k>>2]=j;if((aR(E,K,107760,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;QN(p);QN(n);i=d;return}if((de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;QN(p);QN(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;QN(p);QN(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;QN(p);QN(n);i=d;return}function $Q(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[107720+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[107720+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function aR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function bR(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function cR(a){a=a|0;i=i;return}function dR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];pe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}MO(u,g);m=u;u=c[m>>2]|0;if(!((c[27292]|0)==-1)){c[p>>2]=109168;c[p+4>>2]=201;c[p+8>>2]=0;BN(109168,p,202)}p=(c[109172>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}F=u;gN(c[m>>2]|0)|0;MO(v,g);g=v;v=c[g>>2]|0;if(!((c[27332]|0)==-1)){c[o>>2]=109328;c[o+4>>2]=201;c[o+8>>2]=0;BN(109328,o,202)}o=(c[109332>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}J=v;gN(c[g>>2]|0)|0;g=w;be[c[(c[v>>2]|0)+24>>2]&63](g,J);be[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=eR(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];sO(w+12|0);sO(w);i=k;return}function eR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=VX(l)|0;if((n|0)!=0){o=n;p=n;break}gY()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=se[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(se[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){de[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}WX(o);i=k;return ba|0}function fR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];gR(a,0,k,j,f,g,h);i=b;return}function gR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;CR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZN(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZN(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yR(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=vW(I,c[o>>2]|0,h,t)|0;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}function hR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];iR(a,0,k,j,f,g,h);i=b;return}function iR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;CR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}ZN(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZN(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((yR(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=uW(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;QN(n);QN(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;QN(n);QN(m);i=d;return}function jR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];kR(a,0,k,j,f,g,h);i=b;return}function kR(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;CR(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=de[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}ZN(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}ZN(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((yR(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){de[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=tW(J,c[p>>2]|0,j,u)|0;MT(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=de[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;QN(o);QN(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;QN(o);QN(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;QN(o);QN(n);i=e;return}function lR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];mR(a,0,k,j,f,g,h);i=b;return}function mR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;CR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZN(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZN(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yR(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=sW(I,c[o>>2]|0,h,t)|0;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}function nR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];oR(a,0,k,j,f,g,h);i=b;return}function oR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;CR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}ZN(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}ZN(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((yR(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=rW(I,c[o>>2]|0,h,t)|0;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;QN(n);QN(m);i=d;return}function pR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];qR(a,0,k,j,f,g,h);i=b;return}



function qR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;CR(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}ZN(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}ZN(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((yR(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=qW(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;MT(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;QN(n);QN(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;QN(n);QN(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;QN(n);QN(m);i=d;return}function rR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];sR(a,0,k,j,f,g,h);i=b;return}function sR(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DR(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZN(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZN(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((ER(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+pW(L,c[p>>2]|0,j);MT(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}function tR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uR(a,0,k,j,f,g,h);i=b;return}function uR(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DR(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZN(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZN(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((ER(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+oW(L,c[p>>2]|0,j);MT(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}function vR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wR(a,0,k,j,f,g,h);i=b;return}function wR(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;DR(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}ZN(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}ZN(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((ER(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+nW(L,c[p>>2]|0,j);MT(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;QN(o);QN(n);i=d;return}function xR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;MO(o,g);g=o;o=c[g>>2]|0;if(!((c[27292]|0)==-1)){c[l>>2]=109168;c[l+4>>2]=201;c[l+8>>2]=0;BN(109168,l,202)}l=(c[109172>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}y=m;Ce[c[(c[o>>2]|0)+48>>2]&63](o,107720,107746|0,y)|0;gN(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;ZN(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}ZN(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}ZN(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((yR(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){de[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);N=c[27266]|0;c[k>>2]=j;if((aR(H,N,107760,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=de[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;QN(p);QN(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;QN(p);QN(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;QN(p);QN(n);i=d;return}function yR(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[107720+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[107720+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function zR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;MO(k,d);d=k;k=c[d>>2]|0;if(!((c[27294]|0)==-1)){c[j>>2]=109176;c[j+4>>2]=201;c[j+8>>2]=0;BN(109176,j,202)}j=(c[109180>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;AX(n);o=124736;p=128;Od(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;AX(n);o=124736;p=128;Od(m|0,o|0,p|0)}Ce[c[(c[k>>2]|0)+32>>2]&63](k,107720,107746|0,e)|0;e=c[d>>2]|0;if(!((c[27330]|0)==-1)){c[h>>2]=109320;c[h+4>>2]=201;c[h+8>>2]=0;BN(109320,h,202)}h=(c[109324>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}else{t=e;a[f]=de[c[(c[e>>2]|0)+16>>2]&127](t)|0;be[c[(c[e>>2]|0)+20>>2]&63](b,t);gN(c[d>>2]|0)|0;i=g;return}}function AR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;MO(l,d);d=l;l=c[d>>2]|0;if(!((c[27294]|0)==-1)){c[k>>2]=109176;c[k+4>>2]=201;c[k+8>>2]=0;BN(109176,k,202)}k=(c[109180>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;AX(o);p=124736;q=128;Od(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;AX(o);p=124736;q=128;Od(n|0,p|0,q|0)}Ce[c[(c[l>>2]|0)+32>>2]&63](l,107720,107752|0,e)|0;e=c[d>>2]|0;if(!((c[27330]|0)==-1)){c[j>>2]=109320;c[j+4>>2]=201;c[j+8>>2]=0;BN(109320,j,202)}j=(c[109324>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;AX(s);t=124736;u=128;Od(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;AX(s);t=124736;u=128;Od(r|0,t|0,u|0)}else{u=e;a[f]=de[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=de[c[(c[e>>2]|0)+16>>2]&127](u)|0;be[c[(c[e>>2]|0)+20>>2]&63](b,u);gN(c[d>>2]|0)|0;i=h;return}}function BR(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[107720+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function CR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;MO(j,b);b=j;j=c[b>>2]|0;if(!((c[27292]|0)==-1)){c[h>>2]=109168;c[h+4>>2]=201;c[h+8>>2]=0;BN(109168,h,202)}h=(c[109172>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;AX(m);n=124736;o=128;Od(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;AX(m);n=124736;o=128;Od(l|0,n|0,o|0)}Ce[c[(c[j>>2]|0)+48>>2]&63](j,107720,107746|0,d)|0;d=c[b>>2]|0;if(!((c[27332]|0)==-1)){c[g>>2]=109328;c[g+4>>2]=201;c[g+8>>2]=0;BN(109328,g,202)}g=(c[109332>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}else{s=d;c[e>>2]=de[c[(c[d>>2]|0)+16>>2]&127](s)|0;be[c[(c[d>>2]|0)+20>>2]&63](a,s);gN(c[b>>2]|0)|0;i=f;return}}function DR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;MO(k,b);b=k;k=c[b>>2]|0;if(!((c[27292]|0)==-1)){c[j>>2]=109168;c[j+4>>2]=201;c[j+8>>2]=0;BN(109168,j,202)}j=(c[109172>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;AX(n);o=124736;p=128;Od(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;AX(n);o=124736;p=128;Od(m|0,o|0,p|0)}Ce[c[(c[k>>2]|0)+48>>2]&63](k,107720,107752|0,d)|0;d=c[b>>2]|0;if(!((c[27332]|0)==-1)){c[h>>2]=109328;c[h+4>>2]=201;c[h+8>>2]=0;BN(109328,h,202)}h=(c[109332>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}else{t=d;c[e>>2]=de[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=de[c[(c[d>>2]|0)+16>>2]&127](t)|0;be[c[(c[d>>2]|0)+20>>2]&63](a,t);gN(c[b>>2]|0)|0;i=g;return}}function ER(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[107720+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function FR(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function GR(a){a=a|0;i=i;return}function HR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}MO(n,f);f=n;n=c[f>>2]|0;if(!((c[27330]|0)==-1)){c[l>>2]=109320;c[l+4>>2]=201;c[l+8>>2]=0;BN(109320,l,202)}l=(c[109324>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;AX(u);v=124736;w=128;Od(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;AX(u);v=124736;w=128;Od(t|0,v|0,w|0)}w=n;gN(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){be[c[f+24>>2]&63](o,w)}else{be[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((se[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];QN(o);i=j;return}function IR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=107968;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);x=c[27266]|0;c[k>>2]=h;h=JR(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MO(q,f);KR(w,y,k,z,o,p,q);gN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];mK(b,j,z,e,o,f,g);i=d;return}function JR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=nc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function KR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27294]|0)==-1)){c[m>>2]=109176;c[m+4>>2]=201;c[m+8>>2]=0;BN(109176,m,202)}m=(c[109180>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27330]|0)==-1)){c[l>>2]=109320;c[l+4>>2]=201;c[l+8>>2]=0;BN(109320,l,202)}l=(c[109324>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ce[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=se[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=se[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=se[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;QN(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;QN(n);i=k;return}}function LR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);y=c[27266]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JR(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MO(r,f);KR(x,z,l,A,p,q,r);gN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];mK(b,k,A,e,p,f,g);i=d;return}function MR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=107968;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);x=c[27266]|0;c[k>>2]=h;h=JR(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MO(q,f);KR(w,y,k,z,o,p,q);gN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];mK(b,j,z,e,o,f,g);i=d;return}function NR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);y=c[27266]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JR(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MO(r,f);KR(x,z,l,A,p,q,r);gN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];mK(b,k,A,e,p,f,g);i=d;return}function OR(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JR(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JR(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109072]|0)==0;if(F){do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PR(s,r,z,n)|0}else{do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);o=c[27266]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PR(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}gY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VX(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}gY()}}while(0);MO(w,f);QR(N,L,G,P,u,v,w);gN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];mK(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WX(O)}if((J|0)==0){i=d;return}WX(J);i=d;return}function PR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=kc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function QR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27294]|0)==-1)){c[m>>2]=109176;c[m+4>>2]=201;c[m+8>>2]=0;BN(109176,m,202)}m=(c[109180>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27330]|0)==-1)){c[l>>2]=109320;c[l+4>>2]=201;c[l+8>>2]=0;BN(109320,l,202)}l=(c[109324>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=se[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=se[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);w=A+1|0;if((Wc(l<<24>>24|0,c[27266]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);l=D+1|0;if((Qd(A<<24>>24|0,c[27266]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ce[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=se[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=se[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=de[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ce[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;QN(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;QN(n);i=k;return}function RR(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JR(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JR(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109072]|0)==0;if(F){do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PR(s,r,z,n)|0}else{do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);o=c[27266]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PR(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}gY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VX(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}gY()}}while(0);MO(w,f);QR(N,L,G,P,u,v,w);gN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];mK(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WX(O)}if((J|0)==0){i=d;return}WX(J);i=d;return}function SR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=107976;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);s=c[27266]|0;c[k>>2]=h;h=JR(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;MO(p,f);r=p;p=c[r>>2]|0;if(!((c[27294]|0)==-1)){c[l>>2]=109176;c[l+4>>2]=201;c[l+8>>2]=0;BN(109176,l,202)}l=(c[109180>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}gN(c[r>>2]|0)|0;Ce[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];mK(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];mK(b,j,u,z,m,f,g);I=j;i=d;return}function TR(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function UR(a){a=a|0;i=i;return}function VR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}MO(n,f);f=n;n=c[f>>2]|0;if(!((c[27332]|0)==-1)){c[l>>2]=109328;c[l+4>>2]=201;c[l+8>>2]=0;BN(109328,l,202)}l=(c[109332>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;AX(u);v=124736;w=128;Od(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;AX(u);v=124736;w=128;Od(t|0,v|0,w|0)}w=n;gN(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){be[c[f+24>>2]&63](o,w)}else{be[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=se[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];sO(o);i=j;return}function WR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=107968;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);v=c[27266]|0;c[k>>2]=h;h=JR(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MO(q,f);XR(w,y,k,z,o,p,q);gN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];YR(b,j,z,e,o,f,g);i=d;return}function XR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27292]|0)==-1)){c[m>>2]=109168;c[m+4>>2]=201;c[m+8>>2]=0;BN(109168,m,202)}m=(c[109172>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27332]|0)==-1)){c[l>>2]=109328;c[l+4>>2]=201;c[l+8>>2]=0;BN(109328,l,202)}l=(c[109332>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ce[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=se[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=se[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=se[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;QN(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;QN(n);i=k;return}function YR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ge[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){rO(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ge[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){sO(l);break}c[m>>2]=0;c[b>>2]=0;sO(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ge[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function ZR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);y=c[27266]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JR(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MO(r,f);XR(x,z,l,A,p,q,r);gN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];YR(b,k,A,e,p,f,g);i=d;return}function _R(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=107968;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);x=c[27266]|0;c[k>>2]=h;h=JR(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;MO(q,f);XR(w,y,k,z,o,p,q);gN(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];YR(b,j,z,e,o,f,g);i=d;return}function $R(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);y=c[27266]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=JR(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;MO(r,f);XR(x,z,l,A,p,q,r);gN(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];YR(b,k,A,e,p,f,g);i=d;return}function aS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JR(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JR(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109072]|0)==0;if(F){do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PR(s,r,z,n)|0}else{do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);o=c[27266]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PR(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}gY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VX(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}gY()}}while(0);MO(w,f);bS(N,L,G,P,u,v,w);gN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];YR(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WX(O)}if((J|0)==0){i=d;return}WX(J);i=d;return}function bS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27292]|0)==-1)){c[m>>2]=109168;c[m+4>>2]=201;c[m+8>>2]=0;BN(109168,m,202)}m=(c[109172>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;AX(r);s=124736;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27332]|0)==-1)){c[l>>2]=109328;c[l+4>>2]=201;c[l+8>>2]=0;BN(109328,l,202)}l=(c[109332>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;AX(v);w=124736;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=se[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=se[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);w=A+1|0;if((Wc(l<<24>>24|0,c[27266]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);l=D+1|0;if((Qd(A<<24>>24|0,c[27266]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ce[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=se[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=se[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=de[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ce[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;QN(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;QN(n);i=k;return}function cS(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=JR(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=JR(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109072]|0)==0;if(F){do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);r=c[27266]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=PR(s,r,z,n)|0}else{do{if(o){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);o=c[27266]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=PR(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}gY()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=VX(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}gY()}}while(0);MO(w,f);bS(N,L,G,P,u,v,w);gN(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];YR(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){WX(O)}if((J|0)==0){i=d;return}WX(J);i=d;return}function dS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=107976;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);s=c[27266]|0;c[k>>2]=h;h=JR(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}MO(p,f);u=p;p=c[u>>2]|0;if(!((c[27292]|0)==-1)){c[l>>2]=109168;c[l+4>>2]=201;c[l+8>>2]=0;BN(109168,l,202)}l=(c[109172>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}gN(c[u>>2]|0)|0;u=o;Ce[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];YR(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];YR(b,j,u,z,m,f,g);I=j;i=d;return}function eS(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;MO(r,h);v=r;r=c[v>>2]|0;if(!((c[27294]|0)==-1)){c[q>>2]=109176;c[q+4>>2]=201;c[q+8>>2]=0;BN(109176,q,202)}q=(c[109180>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;AX(y);z=124736;A=128;Od(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;AX(y);z=124736;A=128;Od(x|0,z|0,A|0)}A=r;gN(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ge[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(de[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=se[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(se[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ge[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ge[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];re[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(de[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){de[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){de[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((de[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((de[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function fS(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function gS(a){a=a|0;i=i;return}function hS(a){a=a|0;i=i;return 2}function iS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];eS(a,b,l,k,f,g,h,108080,108088|0);i=j;return}function jS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=de[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];eS(b,d,m,l,g,h,j,s,q);i=k;return}function kS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MO(n,f);f=n;n=c[f>>2]|0;if(!((c[27294]|0)==-1)){c[m>>2]=109176;c[m+4>>2]=201;c[m+8>>2]=0;BN(109176,m,202)}m=(c[109180>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}s=n;gN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=HQ(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function lS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MO(n,f);f=n;n=c[f>>2]|0;if(!((c[27294]|0)==-1)){c[m>>2]=109176;c[m+4>>2]=201;c[m+8>>2]=0;BN(109176,m,202)}m=(c[109180>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}s=n;gN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=HQ(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function mS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;MO(m,f);f=m;m=c[f>>2]|0;if(!((c[27294]|0)==-1)){c[l>>2]=109176;c[l+4>>2]=201;c[l+8>>2]=0;BN(109176,l,202)}l=(c[109180>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;AX(p);q=124736;r=128;Od(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;AX(p);q=124736;r=128;Od(o|0,q|0,r|0)}r=m;gN(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=rS(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function nS(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;MO(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[27294]|0)==-1)){c[ba>>2]=109176;c[ba+4>>2]=201;c[ba+8>>2]=0;BN(109176,ba,202)}ba=(c[109180>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;AX(Ga);Ha=124736;Ia=128;Od(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;AX(Ga);Ha=124736;Ia=128;Od(Fa|0,Ha|0,Ia|0)}Ia=ca;gN(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=rS(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];eS(ja,d,J,I,g,h,j,108096,108104|0);c[ca>>2]=c[ja>>2];break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];eS(oa,d,A,z,g,h,j,108104,108115|0);c[ca>>2]=c[oa>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];pS(d,j+8|0,e,B,h,Ia);break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=rS(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];pe[Da&63](b,d,s,r,g,h,j);i=l;return};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];eS(ua,d,v,u,g,h,j,108128,108136|0);c[Da>>2]=c[ua>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=rS(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];qS(0,e,m,h,Ia);break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=rS(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];eS(ra,d,y,x,g,h,j,108120,108125|0);c[ca>>2]=c[ra>>2];break};case 99:{ca=d+8|0;Da=de[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ja=Ha;Ka=Ha;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];eS(da,d,O,N,g,h,j,Ka,Ja+La|0);c[ca>>2]=c[da>>2];break};case 65:case 97:{ca=c[f>>2]|0;Da=d+8|0;Ha=de[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(HQ(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=rS(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=rS(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=rS(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];eS(ga,d,L,K,g,h,j,108088,108096|0);c[Ha>>2]=c[ga>>2];break};case 88:{Ha=d+8|0;ca=de[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];Da=a[ca]|0;if((Da&1)==0){Ma=ca+1|0;Na=ca+1|0;Oa=(Da&255)>>>1}else{Da=c[ca+8>>2]|0;Ma=Da;Na=Da;Oa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];eS(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Ha>>2]=c[za>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=rS(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=rS(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Pa=ca+2e3|0}else{Pa=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Pa+ -1900;break};case 104:case 66:case 98:{ca=c[f>>2]|0;Ha=d+8|0;Da=de[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(HQ(e,P,Da,Da+288|0,Ia,h,0)|0)-Da|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];oS(0,e,C,h,Ia);break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=rS(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function oS(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((de[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(de[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){de[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((de[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((de[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function pS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=de[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=HQ(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function qS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((de[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(de[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ge[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){de[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function rS(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((de[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(de[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ge[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((de[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((de[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ge[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((de[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function sS(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;MO(p,f);t=p;p=c[t>>2]|0;if(!((c[27292]|0)==-1)){c[o>>2]=109168;c[o+4>>2]=201;c[o+8>>2]=0;BN(109168,o,202)}o=(c[109172>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;AX(w);x=124736;y=128;Od(v|0,x|0,y|0)}y=p;gN(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ge[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=se[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(se[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ge[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ge[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];re[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=de[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=de[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){de[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=de[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function tS(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function uS(a){a=a|0;i=i;return}function vS(a){a=a|0;i=i;return 2}function wS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];sS(a,b,l,k,f,g,h,108232,108264|0);i=j;return}function xS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=de[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];sS(b,d,m,l,g,h,j,s,q);i=k;return}function yS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MO(n,f);f=n;n=c[f>>2]|0;if(!((c[27292]|0)==-1)){c[m>>2]=109168;c[m+4>>2]=201;c[m+8>>2]=0;BN(109168,m,202)}m=(c[109172>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}s=n;gN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=eR(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function zS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;MO(n,f);f=n;n=c[f>>2]|0;if(!((c[27292]|0)==-1)){c[m>>2]=109168;c[m+4>>2]=201;c[m+8>>2]=0;BN(109168,m,202)}m=(c[109172>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;AX(q);r=124736;s=128;Od(p|0,r|0,s|0)}s=n;gN(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=eR(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function AS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;MO(m,f);f=m;m=c[f>>2]|0;if(!((c[27292]|0)==-1)){c[l>>2]=109168;c[l+4>>2]=201;c[l+8>>2]=0;BN(109168,l,202)}l=(c[109172>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;AX(p);q=124736;r=128;Od(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;AX(p);q=124736;r=128;Od(o|0,q|0,r|0)}r=m;gN(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=FS(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function BS(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;MO(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[27292]|0)==-1)){c[ba>>2]=109168;c[ba+4>>2]=201;c[ba+8>>2]=0;BN(109168,ba,202)}ba=(c[109172>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;AX(Ga);Ha=124736;Ia=128;Od(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;AX(Ga);Ha=124736;Ia=128;Od(Fa|0,Ha|0,Ia|0)}Ia=ca;gN(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=FS(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];sS(oa,d,A,z,g,h,j,108328,108372|0);c[ca>>2]=c[oa>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=FS(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 88:{Da=d+8|0;ca=de[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ja=Fa;Ka=Fa;La=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];sS(za,d,q,p,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[za>>2];break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Fa=de[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(eR(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];CS(0,e,C,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=FS(e,t,h,Ia,1)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=Fa|4;break a}break};case 68:{Fa=e;c[ha>>2]=c[Fa>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];sS(ga,d,L,K,g,h,j,108264,108296|0);c[Fa>>2]=c[ga>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Fa=FS(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Fa|0)<60){c[j+4>>2]=Fa;break a}else{c[h>>2]=Da|4;break a}break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];sS(ua,d,v,u,g,h,j,108400,108432|0);c[Da>>2]=c[ua>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Fa=FS(e,M,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Fa+ -1|0)>>>0<31)){break}c[Da>>2]=Fa;break a}}while(0);c[h>>2]=ca|4;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Fa=FS(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Fa|0)<61){c[j>>2]=Fa;break a}else{c[h>>2]=Da|4;break a}break};case 65:case 97:{Da=c[f>>2]|0;Fa=d+8|0;Ha=de[c[c[Fa>>2]>>2]&127](Fa)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(eR(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=FS(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];sS(ja,d,J,I,g,h,j,108296,108328|0);c[Da>>2]=c[ja>>2];break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];pe[Da&63](b,d,s,r,g,h,j);i=l;return};case 99:{Da=d+8|0;Ha=de[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[Ha]|0;if((Fa&1)==0){Ma=Ha+4|0;Na=Ha+4|0;Oa=(Fa&255)>>>1}else{Fa=c[Ha+8>>2]|0;Ma=Fa;Na=Fa;Oa=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];sS(da,d,O,N,g,h,j,Na,Ma+(Oa<<2)|0);c[Da>>2]=c[da>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];ES(0,e,m,h,Ia);break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=FS(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=FS(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Pa=Ha+2e3|0}else{Pa=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Pa+ -1900;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];DS(d,j+8|0,e,B,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=FS(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];sS(ra,d,y,x,g,h,j,108376,108396|0);c[Da>>2]=c[ra>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function CS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ge[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){de[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=de[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=de[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function DS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=de[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=eR(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}



function Ee(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Fe(){return i|0}function Ge(a){a=a|0;i=a}function He(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ie(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Je(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ke(a){a=a|0;J=a}function Le(a){a=a|0;K=a}function Me(a){a=a|0;L=a}function Ne(a){a=a|0;M=a}function Oe(a){a=a|0;N=a}function Pe(a){a=a|0;O=a}function Qe(a){a=a|0;P=a}function Re(a){a=a|0;Q=a}function Se(a){a=a|0;R=a}function Te(a){a=a|0;S=a}function Ue(a){a=a|0;var b=0,d=0;b=i;Ix(a)|0;d=a+540|0;de[c[(c[d>>2]|0)+40>>2]&127](a)|0;de[c[(c[d>>2]|0)+28>>2]&127](a)|0;de[c[(c[d>>2]|0)+32>>2]&127](a)|0;de[c[(c[d>>2]|0)+48>>2]&127](a)|0;de[c[(c[d>>2]|0)+52>>2]&127](a)|0;sw(a);i=b;return}function Ve(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=xY(B|0)|0;D=VX(C+11|0)|0;IY(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=jc(D|0,32)|0;if((C|0)==0){B=Rd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;rt(23,0,40,u);Xc(0)|0;F=0}else{F=C}WX(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}xe[c[36052>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Ou(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Ou(2);Nu(2)}Cu(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pt(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];fw(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pt(23,1,144,r);Z=qx(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ue(b);tw(b);if((c[35244>>2]|0)!=0){ae[c[8926]&255](23)}if((c[2]|0)!=0){Nu(4)}A=hw(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pt(7,1,200,q);if((c[92028>>2]|0)==0){be[c[76652>>2]&63](76632,b)}jw(b,c[J>>2]|0,z,d);if((c[35180>>2]|0)!=0){ae[c[8926]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;xw(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Qu(4)}if((Cx(b,1,1)|0)!=0){c[B>>2]=1;xw(b)}de[c[(c[K>>2]|0)+88>>2]&127](b)|0;sw(b);Bw(b);tw(b);do{if((T|0)==0){_=0}else{Nu(7);Qu(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Iu(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Iu(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Du(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Iu(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Qu(7);if((la|0)!=0){_=T;break}c[p>>2]=Rd(c[(Nc()|0)>>2]|0)|0;rt(23,0,240,p);Xc(T|0)|0;_=0}}while(0);if((c[92028>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;be[c[76652>>2]&63](76632,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[20558]|0)!=0){ca=f;ba=82240;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];ht(M,f);Nd(10,M|0)|0;ba=c[20566]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;pt(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if(($w(b,0)|0)!=0){ma=58;break}if((Tw(b,0)|0)!=0){ma=58;break}if((Jw(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];pt(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if(($w(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];pt(1,0,448,m);U=_;V=-2;break}if((Tw(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];pt(1,0,536,l);U=_;V=-3;break}T=(Jw(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];pt(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];pt(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Xc(U|0)|0;i=e;return V|0}function We(a){a=a|0;i=i;return 0}function Xe(a){a=a|0;i=i;return 0}function Ye(a){a=a|0;i=i;return 0}function Ze(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+128>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+64|0;p=o;h[p>>3]=m;i=b;return}else{g=d+32|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+64|0;p=o;h[p>>3]=m;i=b;return}}function _e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];m=+h[(c[g>>2]|0)+136>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];di(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+200>>3]=+h[f>>3];i=b;return}function $e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];m=+h[(c[g>>2]|0)+136>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];ci(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[f>>3];i=b;return}function af(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;su(k,1,+h[(c[o>>2]|0)+32>>3],j);j=b+536|0;p=c[j>>2]|0;q=b+4|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3];s=+h[(c[o>>2]|0)+136>>3];t=f;u=k;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];Yh(m,p,r,s,f);s=+h[m>>3];su(l,1,+h[(c[o>>2]|0)+32>>3],g);g=c[j>>2]|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3];v=+h[(c[o>>2]|0)+136>>3];o=e;m=l;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];ci(n,g,r,v,e);v=+h[n>>3];n=c[c[q>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+16>>3];if(v!=0.0){w=e;x=r/v;y=s-x;z=w;A=z+216|0;B=A;h[B>>3]=y;i=d;return}if(r==0.0){w=e;x=r;y=s-x;z=w;A=z+216|0;B=A;h[B>>3]=y;i=d;return}C=r/+vt(c[j>>2]|0,v,872,864,+h[n>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[q>>2]>>2]|0)+8>>2]|0;x=C;y=s-x;z=w;A=z+216|0;B=A;h[B>>3]=y;i=d;return}function bf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];m=+h[(c[g>>2]|0)+136>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];ei(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+232>>3]=+h[f>>3];i=b;return}function cf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[a+416>>2]|0)+136>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[d>>3];i=b;return}function df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+h[g+16>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+vt(c[b+536>>2]|0,j,1048,1040,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+160>>3];j=+h[g+16>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+vt(c[b+536>>2]|0,l,1048,1040,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+176|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+160>>3];l=+h[y+16>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+vt(f,m,1048,1040,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+vt(f,A+-.3778957546290221,1088,1040,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+176|0;x=w;h[x>>3]=o;i=d;return}}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+176>>3];i=i;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+192>>3];i=i;return}function gf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=1.0-j;l=+h[g+104>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+vt(c[b+536>>2]|0,k,1184,1176,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+192>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+184>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+208|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+208|0;z=y;h[z>>3]=w;i=d;return}l=m/+vt(c[b+536>>2]|0,p,1184,1176,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+208|0;z=y;h[z>>3]=w;i=d;return}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+pd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+vt(c[b+536>>2]|0,k,1232,1224,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+168>>3]=m*.6221042453709779;i=d;return}function jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;su(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a+8>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3]=+h[f>>3];i=b;return}function kf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;su(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a+8>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];rj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3]=+h[f>>3];i=b;return}function lf(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+128>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+144>>3]=-(b*+h[(!(b>=0.0)?d+360|0:d+232|0)>>3]);i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=1.0- +h[b>>3];i=i;return}function nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+80>>3]),1.0e-13);k=+h[g>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,1312,1304,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function of(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;cj(d,c[a+536>>2]|0,+h[f+16>>3],+h[f+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[d>>3];i=b;return}function pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+272>>3];k=+h[g+16>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+vt(c[b+536>>2]|0,j,1352,1344,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+272>>3];j=+h[g+16>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+vt(c[b+536>>2]|0,l,1352,1344,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+288|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+272>>3];l=+h[y+16>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+vt(f,m,1352,1344,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+vt(f,A+-.3778957546290221,1384,1344,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+288|0;x=w;h[x>>3]=o;i=d;return}}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b>>3]- +h[b+288>>3];i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b>>3]- +h[b+304>>3];i=i;return}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+304>>3];k=1.0-j;l=+h[g+80>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+vt(c[b+536>>2]|0,k,1472,1464,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+304>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+296>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+336|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+336|0;z=y;h[z>>3]=w;i=d;return}l=m/+vt(c[b+536>>2]|0,p,1472,1464,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+336|0;z=y;h[z>>3]=w;i=d;return}function tf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+272>>3];k=+pd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+vt(c[b+536>>2]|0,k,1512,1504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+280>>3]=m*.6221042453709779;i=d;return}function uf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=j/.018015268-j/.0289586+34.53205610768476;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+328|0;q=p;h[q>>3]=n;i=d;return}j=+vt(c[b+536>>2]|0,k,1576,1568,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+328|0;q=p;h[q>>3]=n;i=d;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+16>>3]- +h[(c[a+416>>2]|0)+152>>3];i=i;return}function wf(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+192>>3];g=+h[e+184>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+112>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+120|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+120|0;r=q;h[r>>3]=o;i=d;return}s=l/+vt(c[b+536>>2]|0,g,1672,1664,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+120|0;r=q;h[r>>3]=o;i=d;return}function xf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Gw(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+48|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+56|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a;f=a;g=+h[e>>3];j=f;k=j+56|0;l=k;h[l>>3]=g;i=b;return}}function yf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Gw(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+136>>3]=+h[(a?e+480|0:e+360|0)>>3];i=b;return}function zf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+120>>3];h[b+128>>3]=-(d*+h[(!(d>=0.0)?b+480|0:b+360|0)>>3]);i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+128>>3]- +h[b+144>>3];i=i;return}function Bf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+120>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+48|0}else{e=b}h[b+48>>3]=-(d*+h[e>>3]);i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+48>>3]- +h[b+64>>3];i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[(c[a+416>>2]|0)+128>>3]- +h[b+120>>3];i=i;return}function Ef(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+88>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+376>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,e,1704,1696,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+8>>3]+-273.15;i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function If(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+4|0;su(k,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[q+16>>3];s=+h[q+8>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];dj(m,p,r,s,f);s=+h[m>>3];su(l,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],g);g=c[j>>2]|0;m=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[m+16>>3];u=+h[m+8>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];$i(n,g,r,u,e);u=+h[n>>3];n=c[c[o>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+16>>3];if(u!=0.0){v=e;w=r/u;x=s-w;y=v;z=y+344|0;A=z;h[A>>3]=x;i=d;return}if(r==0.0){v=e;w=r;x=s-w;y=v;z=y+344|0;A=z;h[A>>3]=x;i=d;return}B=r/+vt(c[j>>2]|0,u,1728,1720,+h[n>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[o>>2]>>2]|0)+8>>2]|0;w=B;x=s-w;y=v;z=y+344|0;A=z;h[A>>3]=x;i=d;return}function Jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;su(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a+8>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];$i(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3]=+h[f>>3];i=b;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[(c[a+416>>2]|0)+88>>3]*+h[b+352>>3];i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=+h[b>>3]*+h[b+240>>3];i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+240>>3]*+h[b+344>>3];i=i;return}function Nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3];k=+h[g+368>>3]- +h[g+376>>3]*+h[g+344>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,1872,1864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}function Of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3];k=+h[g+88>>3]- +h[g>>3]*+h[g+376>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+24|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+24|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,1872,1888,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+24|0;p=o;h[p>>3]=m;i=d;return}function Pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+32|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+ax(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+32>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+40|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+ax(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+40>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+8>>3]=k;_w(a,1)|0;a=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+32>>3]=+h[a>>3];h[f+40>>3]=+h[a+8>>3];i=b;return}function Qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Gw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],143.15)|0;if(!(g<<24>>24==0|(Fw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(1896,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,1960)|0,2008)|0,2024)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Gw(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Fw(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(_t(_t(2120,Yt(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,2144)|0,2160)|0,2168)|0,2008)|0,2184)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Sf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Gw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Fw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(_t(_t(2288,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],0,1,6)|0)|0,2144)|0,2312)|0,2168)|0,2008)|0,2184)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Tf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Gw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(2320,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,2336)|0,2008)|0,2360)|0;j=_t(_t(g,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,2392)|0;f=c[a+536>>2]|0;a=c[21062]|0;g=d;k=2448;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];De[a&31](f,d,j,e);i=b;return}function Uf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Gw(+h[(c[f>>2]|0)+136>>3],143.15)|0;if(!(g<<24>>24==0|(Fw(+h[(c[f>>2]|0)+136>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(1896,Yt(+h[(c[f>>2]|0)+136>>3],0,1,6)|0)|0,1960)|0,2008)|0,2024)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Gw(+h[(c[f>>2]|0)+32>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Fw(+h[(c[f>>2]|0)+32>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(_t(_t(2120,Yt(+h[(c[f>>2]|0)+32>>3],0,1,6)|0)|0,2144)|0,2160)|0,2168)|0,2008)|0,2184)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Wf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Gw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Fw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(_t(_t(2288,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0,1,6)|0)|0,2144)|0,2312)|0,2168)|0,2008)|0,2184)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Xf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Gw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(2320,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,2336)|0,2008)|0,2360)|0;f=_t(_t(g,Yt(+h[(c[a+416>>2]|0)+136>>3],0,1,6)|0)|0,2392)|0;g=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](g,d,f,e);i=b;return}function Yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Gw(+h[(c[f>>2]|0)+168>>3],143.15)|0;if(!(g<<24>>24==0|(Fw(+h[(c[f>>2]|0)+168>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(1896,Yt(+h[(c[f>>2]|0)+168>>3],0,1,6)|0)|0,1960)|0,2008)|0,2024)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Zf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Gw(+h[(c[f>>2]|0)+48>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Fw(+h[(c[f>>2]|0)+48>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(_t(_t(2120,Yt(+h[(c[f>>2]|0)+48>>3],0,1,6)|0)|0,2144)|0,2160)|0,2168)|0,2008)|0,2184)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function _f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Gw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Fw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(_t(_t(2288,Yt(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0,1,6)|0)|0,2144)|0,2312)|0,2168)|0,2008)|0,2184)|0;f=c[a+536>>2]|0;a=c[21062]|0;j=d;k=2424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function $f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((Gw(+h[(c[f>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=b;return}g=_t(_t(_t(_t(2320,Yt(+h[(c[f>>2]|0)+152>>3],0,1,6)|0)|0,2336)|0,2008)|0,2360)|0;j=_t(_t(g,Yt(+h[(c[f>>2]|0)+168>>3],0,1,6)|0)|0,2392)|0;f=c[a+536>>2]|0;a=c[21062]|0;g=d;k=2448;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];De[a&31](f,d,j,e);i=b;return}function ag(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);i=c;return 0}function bg(b){b=b|0;var c=0;c=i;a[b+314|0]=0;cg(b);i=c;return 0}function cg(a){a=a|0;var b=0;b=i;Ze(a);bf(a);kf(a);lf(a);vf(a);wf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);If(a);Jf(a);Kf(a);Nf(a);Of(a);Pf(a);i=b;return}function dg(a,b){a=a|0;b=+b;i=i;return 0}function eg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;st(c[a+536>>2]|0,(a|0)!=0|0,2680,b);c[a+540>>2]=2488;c[a+84>>2]=2712;c[a+88>>2]=2712;c[a+92>>2]=2760;c[a+96>>2]=2824;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=3;c[a+116>>2]=67;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=25;c[a+140>>2]=0;c[a+144>>2]=11;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=48;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;c[a+176>>2]=3;c[a+180>>2]=0;c[a+184>>2]=3;c[a+188>>2]=0;c[a+56>>2]=2864;c[a+64>>2]=223;c[a+72>>2]=0;c[a+68>>2]=247;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=2;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function fg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=KY(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=36032;F=36056;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[9008]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=KY(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[8238]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=KY(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(47,c[8238]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=KY(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;wY(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=KY(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;wY(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=KY(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(47,c[8238]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=KY(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=KY(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=KY(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(34,2920,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=KY(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=KY(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=KY(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=KY(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=KY(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=KY(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(47,c[8238]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=KY(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=KY(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=KY(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=KY(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function gg(){var a=0;a=i;qd(0)|0;rc(3080,18,1,c[r>>2]|0)|0;qd(0)|0;i=a;return}function hg(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;ig(j,b,d,c);m=+h[j>>3];ig(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=_t(_t(_t(3104,Yt(d,0,1,6)|0)|0,3288)|0,3296)|0;k=_t(_t(_t(o,Yt(e,0,1,6)|0)|0,3288)|0,3312)|0;o=_t(_t(_t(k,Yt(m,0,1,6)|0)|0,3288)|0,3336)|0;jg(0,_t(_t(_t(o,Yt(n,0,1,6)|0)|0,3288)|0,3360)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;ig(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function ig(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;xi(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function jg(a,b){a=a|0;b=b|0;a=i;Wu(b);i=a;return}function kg(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;lg(j,b,d,c);m=+h[j>>3];lg(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=_t(_t(_t(3104,Yt(d,0,1,6)|0)|0,3288)|0,3296)|0;k=_t(_t(_t(o,Yt(e,0,1,6)|0)|0,3288)|0,3312)|0;o=_t(_t(_t(k,Yt(m,0,1,6)|0)|0,3288)|0,3336)|0;jg(0,_t(_t(_t(o,Yt(n,0,1,6)|0)|0,3288)|0,3360)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;lg(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function lg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;Jh(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function mg(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;ng(j,b,d,c);m=+h[j>>3];ng(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=_t(_t(_t(3104,Yt(d,0,1,6)|0)|0,3288)|0,3296)|0;k=_t(_t(_t(o,Yt(e,0,1,6)|0)|0,3288)|0,3312)|0;o=_t(_t(_t(k,Yt(m,0,1,6)|0)|0,3288)|0,3336)|0;jg(0,_t(_t(_t(o,Yt(n,0,1,6)|0)|0,3288)|0,3360)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;ng(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function ng(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;Dg(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function og(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function pg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;qg(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));rg(b,0,0.0,0.0,g);i=f;return}function qg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;e=i;i=i+96|0;f=e;g=e+8|0;sg(f,b,c,d,.1);j=+h[f>>3];tg(g,b,j,d);k=+h[g+24>>3];l=+h[g+32>>3];m=+h[g+48>>3];n=l*+h[g+64>>3];o=(n- +h[g+40>>3])*287.117+-6610.41237132543;p=k*(m*2.0+k*+h[g+56>>3])*d*287.117;q=j*k*(m-l*+h[g+80>>3])*287.117;r=l*l*+h[g+72>>3]*-287.117;l=q/j;s=-+Tu(j,-2)/p;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=(k*m+n)*d*287.117+-1589557.62320524;h[a+24>>3]=287.117;h[a+32>>3]=r+l*l/p*d;h[a+40>>3]=r;h[a+48>>3]=j;h[a+56>>3]=o;h[a+64>>3]=q;h[a+72>>3]=p;h[a+80>>3]=q/(j*j*p);h[a+88>>3]=s;i=e;return}function rg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function sg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0,Z=0,_=0;g=i;i=i+280|0;j=g;k=g+88|0;l=g+176|0;m=g+264|0;n=l;o=l+8|0;p=l+16|0;q=l+24|0;r=l+32|0;s=l+40|0;t=l+48|0;u=l+56|0;v=l+64|0;w=l+72|0;x=l+80|0;y=k;z=k+8|0;A=k+16|0;B=k+24|0;C=k+32|0;D=k+40|0;E=k+48|0;F=k+56|0;G=k+64|0;H=k+72|0;I=k+80|0;J=m;K=m+8|0;L=d/(e*287.117);M=0;do{tg(l,b,L,e);N=+h[o>>3];O=+h[p>>3];P=+h[q>>3];Q=+h[r>>3];R=+h[s>>3];S=+h[t>>3];T=+h[u>>3];V=+h[v>>3];W=+h[w>>3];X=+h[x>>3];h[y>>3]=+h[n>>3];h[z>>3]=N;h[A>>3]=O;h[B>>3]=P;h[C>>3]=Q;h[D>>3]=R;h[E>>3]=S;h[F>>3]=T;h[G>>3]=V;h[H>>3]=W;h[I>>3]=X;Y=j+0|0;Z=k+0|0;_=Y+88|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));ug(m,0,j);X=+h[J>>3]-d;L=L-X/+h[K>>3];M=M+1|0;}while((M|0)<100&!(+U(+X)<=f));h[a>>3]=L;i=g;return}function tg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0;f=i;i=i+176|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=f+120|0;p=f+144|0;q=f+168|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;c[B>>2]=13;nu(C,1,B);B=C;C=3416;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[A>>2]=19;nu(D,1,A);A=D;D=3432;c[A+0>>2]=c[D+0>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];c[z>>2]=19;At(E,1,z);z=E;E=3448;c[z+0>>2]=c[E+0>>2];c[z+4>>2]=c[E+4>>2];c[z+8>>2]=c[E+8>>2];c[y>>2]=19;nu(F,1,y);y=F;F=3464;c[y+0>>2]=c[F+0>>2];c[y+4>>2]=c[F+4>>2];c[y+8>>2]=c[F+8>>2];c[x>>2]=19;At(G,1,x);x=G;G=3480;c[x+0>>2]=c[G+0>>2];c[x+4>>2]=c[G+4>>2];c[x+8>>2]=c[G+8>>2];H=d/302.55076522;I=132.6312/e;G=(wg(1,1,5)|0)==0;if(G){J=0.0}else{K=0.0;x=1;while(1){L=K+ +lu(3416,x+ -1|0)*+W(+I,+(+(x+ -4|0)));F=x+1|0;if((wg(F,1,5)|0)==0){J=L;break}else{x=F;K=L}}}if(!(H>0.0)){x=c[21062]|0;F=w;h[k>>3]=H;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=x;x=p;y=6928;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];c[x+16>>2]=c[y+16>>2];c[x+20>>2]=c[y+20>>2];De[F&31](b,p,3504,w);}if(!(I>0.0)){w=c[21062]|0;p=v;h[k>>3]=I;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=w;w=o;F=6928;c[w+0>>2]=c[F+0>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];c[w+12>>2]=c[F+12>>2];c[w+16>>2]=c[F+16>>2];c[w+20>>2]=c[F+20>>2];De[p&31](b,o,3568,v);}K=1.0- +ca(+(I*-25.36365));if(!(K>0.0)){v=c[21062]|0;o=u;h[k>>3]=K;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=v;v=n;p=6928;c[v+0>>2]=c[p+0>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];c[v+12>>2]=c[p+12>>2];c[v+16>>2]=c[p+16>>2];c[v+20>>2]=c[p+20>>2];De[o&31](b,n,3632,u);}L=1.0- +ca(+(I*-16.90741));if(!(L>0.0)){u=c[21062]|0;n=t;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=u;u=m;o=6928;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];De[n&31](b,m,3712,t);}M=+ca(+(I*87.31279))+.6666666666666666;if(!(M>0.0)){t=c[21062]|0;m=s;h[k>>3]=M;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=t;t=l;n=6928;c[t+0>>2]=c[n+0>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[t+12>>2]=c[n+12>>2];c[t+16>>2]=c[n+16>>2];c[t+20>>2]=c[n+20>>2];De[m&31](b,l,3792,s);}N=J+(+da(+H)+(+W(+I,1.5)*-.00019536342+(+da(+I)*2.490888032+(+da(+K)*.791309509+(+da(+L)*.212236768+ +da(+M)*.197938904)))));s=(wg(1,1,10)|0)==0;if(s){O=N}else{M=N;l=1;while(1){m=l+ -1|0;N=+lu(3432,m);L=+W(+H,+(+(zt(3448,m)|0)));K=M+N*L*+W(+I,+(+lu(3464,m)));m=l+1|0;if((wg(m,1,10)|0)==0){O=K;break}else{l=m;M=K}}}l=(wg(11,11,19)|0)==0;if(l){P=O}else{M=O;m=11;while(1){n=m+ -1|0;O=+ca(+-+W(+H,+(+(zt(3480,n)|0))));K=+lu(3432,n);L=+W(+H,+(+(zt(3448,n)|0)));N=M+K*L*O*+W(+I,+(+lu(3464,n)));n=m+1|0;if((wg(n,11,19)|0)==0){P=N;break}else{m=n;M=N}}}M=1.0/H;if(s){Q=M}else{N=M;m=1;while(1){n=m+ -1|0;M=+(zt(3448,n)|0);O=+lu(3432,n);L=+W(+H,+(+((zt(3448,n)|0)+ -1|0)));K=N+M*O*L*+W(+I,+(+lu(3464,n)));n=m+1|0;if((wg(n,1,10)|0)==0){Q=K;break}else{m=n;N=K}}}if(l){R=Q}else{N=Q;m=11;while(1){n=m+ -1|0;Q=+ca(+-+W(+H,+(+(zt(3480,n)|0))));K=+lu(3432,n);L=+W(+H,+(+((zt(3448,n)|0)+ -1|0)));O=+W(+I,+(+lu(3464,n)));M=+(zt(3448,n)|0);J=+(zt(3480,n)|0);S=N+K*L*O*Q*(M-J*+W(+H,+(+(zt(3480,n)|0))));n=m+1|0;if((wg(n,11,19)|0)==0){R=S;break}else{m=n;N=S}}}N=-+Tu(H,-2);if(s){T=N}else{S=N;m=1;while(1){n=m+ -1|0;t=zt(3448,n)|0;N=+(fa((zt(3448,n)|0)+ -1|0,t)|0);J=+lu(3432,n);M=+W(+H,+(+((zt(3448,n)|0)+ -2|0)));Q=S+N*J*M*+W(+I,+(+lu(3464,n)));n=m+1|0;if((wg(n,1,10)|0)==0){T=Q;break}else{m=n;S=Q}}}if(l){U=T}else{S=T;m=11;while(1){n=m+ -1|0;T=+ca(+-+W(+H,+(+(zt(3480,n)|0))));Q=+(zt(3480,n)|0);M=+lu(3432,n);J=+W(+H,+(+((zt(3448,n)|0)+ -2|0)));N=+W(+I,+(+lu(3464,n)));O=+(zt(3448,n)|0);L=+(zt(3480,n)|0);K=O-L*+W(+H,+(+(zt(3480,n)|0)));L=+((zt(3448,n)|0)+ -1|0);O=+(zt(3480,n)|0);X=K*(L-O*+W(+H,+(+(zt(3480,n)|0))));O=S+M*J*N*T*(X-Q*Q*+W(+H,+(+(zt(3480,n)|0))));n=m+1|0;if((wg(n,11,19)|0)==0){U=O;break}else{m=n;S=O}}}if(G){Y=0.0}else{S=0.0;G=1;while(1){O=S+ +(G+ -4|0)*+lu(3416,G+ -1|0)*+W(+I,+(+(G+ -5|0)));m=G+1|0;if((wg(m,1,5)|0)==0){Y=O;break}else{G=m;S=O}}}G=I>=0.0;if(!G){m=c[21062]|0;n=r;h[k>>3]=I;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m;m=j;t=6928;c[m+0>>2]=c[t+0>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];c[m+12>>2]=c[t+12>>2];c[m+16>>2]=c[t+16>>2];c[m+20>>2]=c[t+20>>2];De[n&31](b,j,3896,r);}S=+ca(+(I*25.36365));O=+ca(+(I*16.90741));Q=+ca(+(I*-87.31279));X=+V(+I);T=S+-1.0;N=O+-1.0;J=Q*.6666666666666666+1.0;M=Y+(X*-.00029304513+(2.490888032/I+(20.07049742794785/T+(3.58837405365088/N+17.28259795778216/J))));if(s){Z=M}else{Y=M;r=1;while(1){j=r+ -1|0;M=+lu(3464,j);L=+lu(3432,j);K=+W(+H,+(+(zt(3448,j)|0)));_=Y+M*L*K*+W(+I,+(+lu(3464,j)+-1.0));j=r+1|0;if((wg(j,1,10)|0)==0){Z=_;break}else{r=j;Y=_}}}if(l){$=Z}else{Y=Z;r=11;while(1){j=r+ -1|0;Z=+ca(+-+W(+H,+(+(zt(3480,j)|0))));_=+lu(3464,j);K=+lu(3432,j);L=+W(+H,+(+(zt(3448,j)|0)));M=Y+_*K*L*Z*+W(+I,+(+lu(3464,j)+-1.0));j=r+1|0;if((wg(j,11,19)|0)==0){$=M;break}else{r=j;Y=M}}}if((wg(1,1,3)|0)==0){aa=0.0}else{Y=0.0;r=1;while(1){M=+(fa(r+ -4|0,r+ -5|0)|0);Z=Y+M*+lu(3416,r+ -1|0)*+W(+I,+(+(r+ -6|0)));j=r+1|0;if((wg(j,1,3)|0)==0){aa=Z;break}else{r=j;Y=Z}}}if(!G){G=c[21062]|0;r=q;h[k>>3]=I;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=G;G=g;j=6928;c[G+0>>2]=c[j+0>>2];c[G+4>>2]=c[j+4>>2];c[G+8>>2]=c[j+8>>2];c[G+12>>2]=c[j+12>>2];c[G+16>>2]=c[j+16>>2];c[G+20>>2]=c[j+20>>2];De[r&31](b,g,3896,q);}Y=aa+(-.000146522565/X+(-2.490888032/(I*I)+(S/(T*T)*-509.0610720883695+(O/(N*N)*-60.67011135843742+Q/(J*J)*1005.994564094842))));if(s){ba=Y}else{J=Y;q=1;while(1){g=q+ -1|0;Y=+lu(3464,g);Q=+lu(3464,g)+-1.0;N=+lu(3432,g);O=+W(+H,+(+(zt(3448,g)|0)));T=J+Y*Q*N*O*+W(+I,+(+lu(3464,g)+-2.0));g=q+1|0;if((wg(g,1,10)|0)==0){ba=T;break}else{q=g;J=T}}}if(l){ea=ba}else{J=ba;q=11;while(1){g=q+ -1|0;ba=+ca(+-+W(+H,+(+(zt(3480,g)|0))));T=+lu(3464,g);O=+lu(3464,g)+-1.0;N=+lu(3432,g);Q=+W(+H,+(+(zt(3448,g)|0)));Y=J+T*O*N*Q*ba*+W(+I,+(+lu(3464,g)+-2.0));g=q+1|0;if((wg(g,11,19)|0)==0){ea=Y;break}else{q=g;J=Y}}}if(s){ga=0.0}else{J=0.0;s=1;while(1){q=s+ -1|0;Y=+(zt(3448,q)|0);ba=+lu(3464,q);Q=+lu(3432,q);N=+W(+H,+(+((zt(3448,q)|0)+ -1|0)));O=J+Y*ba*Q*N*+W(+I,+(+lu(3464,q)+-1.0));q=s+1|0;if((wg(q,1,10)|0)==0){ga=O;break}else{s=q;J=O}}}if(l){ha=ga;ia=a;ja=ia;h[ja>>3]=d;ka=a;la=ka+8|0;ma=la;h[ma>>3]=e;na=a;oa=na+16|0;pa=oa;h[pa>>3]=287.117;qa=a;ra=qa+24|0;sa=ra;h[sa>>3]=H;ta=a;ua=ta+32|0;va=ua;h[va>>3]=I;wa=a;xa=wa+40|0;ya=xa;h[ya>>3]=P;za=a;Aa=za+48|0;Ba=Aa;h[Ba>>3]=R;Ca=a;Da=Ca+56|0;Ea=Da;h[Ea>>3]=U;Fa=a;Ga=Fa+64|0;Ha=Ga;h[Ha>>3]=$;Ia=a;Ja=Ia+72|0;Ka=Ja;h[Ka>>3]=ea;La=a;Ma=La+80|0;Na=Ma;h[Na>>3]=ha;i=f;return}else{Oa=ga;Pa=11}while(1){l=Pa+ -1|0;ga=+ca(+-+W(+H,+(+(zt(3480,l)|0))));J=+lu(3464,l);O=+lu(3432,l);N=+W(+H,+(+((zt(3448,l)|0)+ -1|0)));Q=+W(+I,+(+lu(3464,l)+-1.0));ba=+(zt(3448,l)|0);Y=+(zt(3480,l)|0);T=Oa+J*O*N*Q*ga*(ba-Y*+W(+H,+(+(zt(3480,l)|0))));l=Pa+1|0;if((wg(l,11,19)|0)==0){ha=T;break}else{Pa=l;Oa=T}}ia=a;ja=ia;h[ja>>3]=d;ka=a;la=ka+8|0;ma=la;h[ma>>3]=e;na=a;oa=na+16|0;pa=oa;h[pa>>3]=287.117;qa=a;ra=qa+24|0;sa=ra;h[sa>>3]=H;ta=a;ua=ta+32|0;va=ua;h[va>>3]=I;wa=a;xa=wa+40|0;ya=xa;h[ya>>3]=P;za=a;Aa=za+48|0;Ba=Aa;h[Ba>>3]=R;Ca=a;Da=Ca+56|0;Ea=Da;h[Ea>>3]=U;Fa=a;Ga=Fa+64|0;Ha=Ga;h[Ha>>3]=$;Ia=a;Ja=Ia+72|0;Ka=Ja;h[Ka>>3]=ea;La=a;Ma=La+80|0;Na=Ma;h[Na>>3]=ha;i=f;return}function ug(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}function vg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;var f=0.0,g=0.0;f=+ba(+c,+d);if(e==0.0){g=f}else{g=f+ +(~~+T(+((e-f)/6.283185307179586+.5))|0)*6.283185307179586}h[a>>3]=g;i=i;return}function wg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function xg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;qg(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));yg(b,0,0.0,0.0,g);i=f;return}function yg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function zg(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;var j=0.0,k=0.0,l=0.0;b=i;c=+h[e+48>>3];j=+h[e+64>>3];k=+h[e+72>>3];l=(j*d-c*k)*+Tu(c,-2)*(f/k);f=c*c*k*+h[e+40>>3]+j*j*+h[e+8>>3];h[a>>3]=l+f*+Tu(c,-2)*(g/k);i=b;return}function Ag(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;d=+h[e+72>>3];h[a>>3]=f/d- +h[e+64>>3]*(g/d);i=i;return}function Bg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function Cg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;nu(l,1,j);j=l;l=3960;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+od(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[21062]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=6928;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];De[j&31](b,f,3976,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function Dg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;nu(g,1,f);f=g;g=4056;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;nu(j,1,e);e=j;j=4072;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((wg(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+lu(4056,j);t=s+d*+W(+k,+(+lu(4072,j)));j=r+1|0;if((wg(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function Eg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;Fg(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function Fg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function Gg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;nu(Oa,1,Na);c[Oa+0>>2]=c[4088+0>>2];c[Oa+4>>2]=c[4088+4>>2];c[Oa+8>>2]=c[4088+8>>2];c[Ma>>2]=2;xt(Pa,16,1,Ma);c[La>>2]=1;Ma=yt(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=yt(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;xt(Qa,16,1,Ja);c[Ia>>2]=1;Ja=yt(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=yt(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=yt(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;xt(Ua,16,1,Fa);if((wg(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +lu(4088,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((wg(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=yt(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(yt(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((wg(2,2,3)|0)!=0){Fa=2;do{Fg(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=yt(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];Hg(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];Ig(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((wg(Fa,2,3)|0)!=0)}if((wg(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +lu(4088,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((wg(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}Fg(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=yt(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];Eg(Ya,b,f+2512|0,f+2496|0);Fg(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=yt(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];Eg(_a,b,f+2480|0,f+2464|0);Fg($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];Hg(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];Ig(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((wg(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +lu(4088,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((wg(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}Fg(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=yt(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];Hg(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;Fg(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=yt(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];Jg(db,0,f+2352|0,f+2336|0);Fg(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=yt(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];Jg(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];Kg(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];Hg(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=yt(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(yt(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;Fg(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=yt(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];Ig(ib,0,f+2240|0,f+2224|0);Fg(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=yt(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];Ig(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];Kg(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];Hg(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=yt(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(yt(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;Fg(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=yt(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];Jg(nb,0,f+2128|0,f+2112|0);Fg(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=yt(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];Jg(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];Kg(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];Hg(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=yt(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(yt(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;Fg(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=yt(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];Ig(sb,0,f+2016|0,f+2e3|0);Fg(tb,0,e/273.16,0.0);c[la>>2]=2;rb=yt(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];Ig(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];Kg(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];Hg($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=yt(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(yt(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;Fg(wb,0,2.0,0.0);c[ia>>2]=1;$c=yt(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];Hg(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=yt(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];Kg(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];Hg(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=yt(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(yt(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;Fg(zb,0,2.0,0.0);c[ea>>2]=2;ad=yt(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];Hg(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=yt(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];Kg(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];Hg(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=yt(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(yt(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;Fg(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=yt(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];Eg(cd,b,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=yt(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(yt(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;Fg(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=yt(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];Eg(dd,b,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=yt(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function Hg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];Fg(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function Ig(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Fg(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function Jg(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Fg(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function Kg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];vg(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[21062]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=6928;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];De[d&31](b,f,4160,g);}Fg(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function Lg(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function Mg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;Ng(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function _omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(yt(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=yt(x,16,1,Ua)|0;c[Va>>2]=2;Db=yt(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];Ig(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=yt(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];Jg(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=yt(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];Jg(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=yt(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(yt(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=yt(x,16,1,_a)|0;c[$a>>2]=4;Cb=yt(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];Ig(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=yt(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];Jg(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=yt(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];Jg(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=yt(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(yt(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=yt(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];Hg(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=yt(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];Hg(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];Ig(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];Lg(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=yt(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];Hg(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];Lg(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=yt(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];Hg(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];Lg(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;Fg(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=yt(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];Ig(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];Kg(G,d,a+1248|0);Fg(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=yt(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];Eg(I,d,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];Jg(J,0,a+1200|0,a+1184|0);Fg(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=yt(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];Jg(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];Kg(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];Jg(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=yt(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(yt(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;Fg(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=yt(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];Ig(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];Kg(P,d,a+1056|0);Fg(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=yt(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];Jg(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];Kg(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];Jg(T,0,a+992|0,a+976|0);Fg(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=yt(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];Eg(V,d,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];Jg(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=yt(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(yt(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=yt(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];Hg(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=yt(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];Hg(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];Ig(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];Lg(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;Fg($,0,1.0,0.0);Fg(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=yt(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];Jg(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];Eg(ca,d,a+752|0,a+736|0);Fg(da,0,1.0,0.0);Fg(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=yt(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];Ig(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];Eg(ga,d,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];Ig(ha,0,a+656|0,a+640|0);Fg(ia,0,2.0,0.0);c[wb>>2]=1;Cb=yt(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];Eg(ja,d,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];Jg(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];Hg(la,0,a+560|0,a+544|0);Fg(ma,0,1.0,0.0);Fg(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=yt(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];Jg(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];Eg(pa,d,a+496|0,a+480|0);Fg(qa,0,1.0,0.0);Fg(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=yt(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];Ig(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];Eg(ta,d,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];Ig(ua,0,a+400|0,a+384|0);Fg(va,0,2.0,0.0);c[zb>>2]=2;Cb=yt(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];Eg(wa,d,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];Jg(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];Hg(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];Ig(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];Lg(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;Fg(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=yt(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];Ig(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];Kg(Ca,d,a+192|0);Fg(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=yt(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];Eg(Ea,d,a+176|0,a+160|0);Fg(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=yt(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];Jg(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];Kg(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];Ig(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];Jg(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];Hg(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];Lg(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function _i(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+16|0;c[y>>2]=3;nu(z,1,y);c[x>>2]=10;nu(A,1,x);x=A;A=3960;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];B=+od(+d,553.0);d=B+-650.17534844798;C=B+-.23855557567849/d;B=.23855557567849/(d*d)+1.0;d=C*C;D=d+C*1167.0521452767+-724213.16703206;E=C*12020.82470247+d*-17.073846940092+-3232555.0322333;F=C*-4823.2657361591+d*14.91510861353+405113.40542057;d=C*B;C=B*12020.82470247+d*-34.147693880184;G=B*-4823.2657361591+d*29.83021722706;c[w>>2]=1;h[(tu(z,1,w)|0)>>3]=E*C*2.0+(D*G+(B*1167.0521452767+d*2.0)*F)*-4.0;d=E*E+D*F*-4.0;w=d>=0.0;if(!w){A=c[21062]|0;x=v;h[k>>3]=d;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=A;A=m;y=6928;c[A+0>>2]=c[y+0>>2];c[A+4>>2]=c[y+4>>2];c[A+8>>2]=c[y+8>>2];c[A+12>>2]=c[y+12>>2];c[A+16>>2]=c[y+16>>2];c[A+20>>2]=c[y+20>>2];De[x&31](b,m,3976,v);}c[u>>2]=1;D=+V(+d);B=+h[(tu(z,1,u)|0)>>3]/D*.5-C;c[t>>2]=2;h[(tu(z,1,t)|0)>>3]=B;if(!w){t=c[21062]|0;u=s;h[k>>3]=d;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t;t=l;v=6928;c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[t+12>>2]=c[v+12>>2];c[t+16>>2]=c[v+16>>2];c[t+20>>2]=c[v+20>>2];De[u&31](b,l,3976,s);s=c[21062]|0;l=r;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=s;s=j;u=6928;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];De[l&31](b,j,3976,r);}B=D-E;c[q>>2]=2;E=(G*B-F*+h[(tu(z,1,q)|0)>>3])/(B*B)*2.0;c[p>>2]=3;h[(tu(z,1,p)|0)>>3]=E;if(w){H=F/B;I=H*H;J=H*I;K=n;L=K;c[L>>2]=3;M=32;N=M;O=tu(z,1,n)|0;P=+h[O>>3];Q=P*e;R=J*Q;S=R*32.0e6;T=a;U=T;h[U>>3]=S;i=f;return}w=c[21062]|0;p=o;h[k>>3]=d;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=w;w=g;q=6928;c[w+0>>2]=c[q+0>>2];c[w+4>>2]=c[q+4>>2];c[w+8>>2]=c[q+8>>2];c[w+12>>2]=c[q+12>>2];c[w+16>>2]=c[q+16>>2];c[w+20>>2]=c[q+20>>2];De[p&31](b,g,3976,o);H=F/B;I=H*H;J=H*I;K=n;L=K;c[L>>2]=3;M=32;N=M;O=tu(z,1,n)|0;P=+h[O>>3];Q=P*e;R=J*Q;S=R*32.0e6;T=a;U=T;h[U>>3]=S;i=f;return}function $i(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;g=i;i=i+24|0;j=g;k=g+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[m>>2]=1;if(+h[(tu(f,1,m)|0)>>3]==0.0){xg(n,b,d,e);y=+h[n>>3];z=a;A=z;h[A>>3]=y;i=g;return}c[l>>2]=1;B=+h[(tu(f,1,l)|0)>>3];c[k>>2]=1;C=B/(1.0- +h[(tu(f,1,k)|0)>>3]);aj(o,b,d,e);B=+h[o>>3];o=j;k=f;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];bj(p,b,d,e,j);D=+h[p>>3];E=d-D;p=e<273.16;if(C<=B|B==-1.0){if(p){xg(q,b,E,e);y=+h[q>>3]+D/(e*461.51805);z=a;A=z;h[A>>3]=y;i=g;return}else{xg(r,b,E,e);F=+h[r>>3];hi(s,b,D,e);y=F+ +h[s>>3];z=a;A=z;h[A>>3]=y;i=g;return}}else{if(p){xg(t,b,E,e);F=+h[t>>3];Ci(u,b,d,e);y=(C+1.0)/((B+1.0)/(F+D/(e*461.51805))+(C-B)/+h[u>>3]);z=a;A=z;h[A>>3]=y;i=g;return}else{xg(v,b,E,e);E=+h[v>>3];hi(w,b,D,e);D=+h[w>>3];oh(x,b,d,e,0);y=(C+1.0)/((B+1.0)/(E+D)+(C-B)/+h[x>>3]);z=a;A=z;h[A>>3]=y;i=g;return}}}function aj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;cj(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){Ti(j,b,c);l=+h[j>>3]}else{vi(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function bj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(tu(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(tu(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(tu(f,1,j)|0)>>3]);cj(m,b,d,e);r=+h[m>>3];aj(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function cj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){xi(j,0,d);m=+h[j>>3];vi(k,b,c);n=+h[k>>3];o=m}else{Zi(f,b,d);m=+h[f>>3];Ti(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}ti(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function dj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(tu(f,1,n)|0)>>3]==0.0){pg(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];bj(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(tu(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(tu(f,1,l)|0)>>3]);aj(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){pg(u,b,G,e);J=+h[u>>3];ii(v,b,F,e,0);K=J+I*+h[v>>3];break}else{pg(r,b,G,e);J=+h[r>>3];ii(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];ej(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){pg(w,b,G,e);L=+h[w>>3];ii(x,b,F,e,0);J=+h[x>>3];yi(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{pg(z,b,G,e);J=+h[z>>3];ii(A,b,F,e,0);L=+h[A>>3];kh(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function ej(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;nu(Na,1,Ma);c[La>>2]=4;nu(Oa,1,La);c[Ka>>2]=4;nu(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(tu(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(tu(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(tu(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(tu(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];su(Qa,4,ob,Fa);ou(Qa,Oa);Qa=(wg(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+lu(4920,Fa+ -1|0);c[Ea>>2]=Fa;h[(tu(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((wg(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(tu(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(tu(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(tu(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(tu(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(tu(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(tu(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(tu(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(tu(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(tu(Oa,1,va)|0)>>3];pb=sb*(ob/+lu(4920,Qa+ -1|0));c[ua>>2]=Qa;h[(tu(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((wg(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(tu(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(tu(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(tu(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(tu(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];su(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];ui($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(tu(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(tu(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(tu(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(tu(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];su(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];Ii(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(tu(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(tu(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(tu(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(tu(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];su(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];Hi(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(tu(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(tu(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(tu(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(tu(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];su(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];Li(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(tu(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(tu(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(tu(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(tu(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];su(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];Gi(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(tu(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(tu(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(tu(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(tu(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];su(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];ui(eb,b,d,e,o);tb=+h[eb>>3];Pi(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(tu(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(tu(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(tu(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(tu(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];su(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];Ii(gb,b,d,e,n);qb=+h[gb>>3];Oi(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(tu(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(tu(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(tu(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(tu(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];su(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];Hi(ib,b,d,e,m);vb=+h[ib>>3];Fi(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(tu(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(tu(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(tu(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(tu(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];su(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];Li(kb,b,d,e,l);d=+h[kb>>3];Ui(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(tu(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(tu(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(tu(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(tu(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];su(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Gi(mb,b,0.0,e,j);yb=+h[mb>>3];Wi(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(tu(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(tu(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(tu(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(tu(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function fj(a,b,d,e,f,j,l,m){a=a|0;b=b|0;d=+d;e=+e;f=f|0;j=+j;l=+l;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0.0,Fg=0.0,Gg=0.0,Hg=0.0,Ig=0.0,Jg=0.0,Kg=0.0,Lg=0.0,Mg=0.0;n=i;i=i+6224|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+24|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+24|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+24|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+24|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+24|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+24|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+24|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+24|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+24|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+24|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+24|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+24|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+24|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+24|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+24|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+24|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+24|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+24|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+24|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+24|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+24|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+24|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+24|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+24|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+24|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+24|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+24|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+24|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+24|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+24|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+24|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+24|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+24|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+24|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+24|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+24|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+24|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+24|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+24|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+24|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+24|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+16|0;Ne=i;i=i+16|0;Oe=i;i=i+16|0;Pe=i;i=i+16|0;Qe=i;i=i+16|0;Re=i;i=i+16|0;Se=i;i=i+16|0;Te=i;i=i+16|0;Ue=i;i=i+16|0;Ve=i;i=i+16|0;We=i;i=i+16|0;Xe=i;i=i+16|0;Ye=i;i=i+16|0;Ze=i;i=i+16|0;_e=i;i=i+16|0;$e=i;i=i+16|0;af=i;i=i+16|0;bf=i;i=i+16|0;cf=i;i=i+16|0;df=i;i=i+16|0;ef=i;i=i+16|0;ff=i;i=i+16|0;gf=i;i=i+16|0;hf=i;i=i+16|0;jf=i;i=i+16|0;kf=i;i=i+16|0;lf=i;i=i+16|0;mf=i;i=i+16|0;nf=i;i=i+16|0;of=i;i=i+16|0;pf=i;i=i+16|0;qf=i;i=i+16|0;rf=i;i=i+16|0;sf=i;i=i+16|0;tf=i;i=i+16|0;uf=i;i=i+16|0;vf=i;i=i+16|0;wf=i;i=i+16|0;xf=i;i=i+16|0;yf=i;i=i+16|0;zf=i;i=i+16|0;Af=i;i=i+16|0;Bf=i;i=i+16|0;Cf=i;i=i+16|0;Df=i;i=i+16|0;Ef=i;i=i+16|0;Ff=i;i=i+16|0;Gf=i;i=i+16|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+8|0;bg=i;i=i+8|0;cg=i;i=i+8|0;dg=i;i=i+8|0;eg=i;i=i+8|0;fg=i;i=i+8|0;gg=i;i=i+8|0;hg=i;i=i+8|0;ig=i;i=i+8|0;jg=i;i=i+8|0;kg=i;i=i+8|0;lg=i;i=i+8|0;mg=i;i=i+8|0;ng=i;i=i+8|0;og=i;i=i+8|0;pg=i;i=i+8|0;qg=i;i=i+8|0;rg=i;i=i+8|0;sg=i;i=i+8|0;tg=i;i=i+8|0;ug=i;i=i+8|0;vg=i;i=i+8|0;xg=i;i=i+8|0;yg=i;i=i+8|0;zg=i;i=i+8|0;Ag=i;i=i+8|0;Bg=i;i=i+8|0;Cg=i;i=i+8|0;Dg=i;i=i+8|0;c[Le>>2]=7;nu(Me,1,Le);c[Ke>>2]=4;nu(Ne,1,Ke);c[Je>>2]=4;nu(Oe,1,Je);c[Ie>>2]=4;nu(Pe,1,Ie);c[He>>2]=4;nu(Qe,1,He);c[Ge>>2]=4;nu(Re,1,Ge);c[Fe>>2]=1;Eg=+h[(tu(f,1,Fe)|0)>>3];c[Ee>>2]=2;Fg=+h[(tu(f,1,Ee)|0)>>3]*.7557;c[De>>2]=2;Gg=+h[(tu(f,1,De)|0)>>3]*.2316;c[Ce>>2]=2;Hg=+h[(tu(f,1,Ce)|0)>>3]*.0127;h[k>>3]=Fg;c[Be>>2]=c[k>>2];c[Be+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(Be+8|0)>>2]=c[k>>2];c[(Be+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Be+16|0)>>2]=c[k>>2];c[(Be+16|0)+4>>2]=c[k+4>>2];su(Se,4,Eg,Be);ou(Se,Oe);c[Ae>>2]=1;Eg=+h[(tu(m,1,Ae)|0)>>3];c[ze>>2]=2;Hg=+h[(tu(m,1,ze)|0)>>3]*.7557;c[ye>>2]=2;Gg=+h[(tu(m,1,ye)|0)>>3]*.2316;c[xe>>2]=2;Fg=+h[(tu(m,1,xe)|0)>>3]*.0127;h[k>>3]=Hg;c[we>>2]=c[k>>2];c[we+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(we+8|0)>>2]=c[k>>2];c[(we+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(we+16|0)>>2]=c[k>>2];c[(we+16|0)+4>>2]=c[k+4>>2];su(Te,4,Eg,we);ou(Te,Pe);Te=(wg(1,1,4)|0)==0;if(!Te){we=1;do{Eg=1.0/+lu(4920,we+ -1|0);c[ve>>2]=we;h[(tu(Ne,1,ve)|0)>>3]=Eg;we=we+1|0;}while((wg(we,1,4)|0)!=0)}c[ue>>2]=1;Eg=+h[(tu(Oe,1,ue)|0)>>3];c[te>>2]=1;Fg=Eg*+h[(tu(Ne,1,te)|0)>>3];c[se>>2]=2;Eg=+h[(tu(Oe,1,se)|0)>>3];c[re>>2]=2;Gg=Eg*+h[(tu(Ne,1,re)|0)>>3];c[qe>>2]=3;Eg=+h[(tu(Oe,1,qe)|0)>>3];c[pe>>2]=3;Hg=Eg*+h[(tu(Ne,1,pe)|0)>>3];c[oe>>2]=4;Eg=+h[(tu(Oe,1,oe)|0)>>3];c[ne>>2]=4;Ig=1.0/(Fg+(Gg+(Hg+Eg*+h[(tu(Ne,1,ne)|0)>>3])));c[me>>2]=1;Eg=+h[(tu(Oe,1,me)|0)>>3];c[le>>2]=1;Hg=Eg*+h[(tu(Ne,1,le)|0)>>3];c[ke>>2]=2;Eg=+h[(tu(Oe,1,ke)|0)>>3];c[je>>2]=2;Gg=Eg*+h[(tu(Ne,1,je)|0)>>3];c[ie>>2]=3;Eg=+h[(tu(Oe,1,ie)|0)>>3];c[he>>2]=3;Fg=Eg*+h[(tu(Ne,1,he)|0)>>3];c[ge>>2]=4;Eg=+h[(tu(Oe,1,ge)|0)>>3];c[fe>>2]=4;Jg=Hg+(Gg+(Fg+Eg*+h[(tu(Ne,1,fe)|0)>>3]));c[ee>>2]=3;Eg=+h[(tu(Pe,1,ee)|0)>>3];c[de>>2]=1;Fg=+h[(tu(Oe,1,de)|0)>>3];c[ce>>2]=1;Gg=Fg*+h[(tu(Ne,1,ce)|0)>>3];c[be>>2]=2;Fg=+h[(tu(Oe,1,be)|0)>>3];c[ae>>2]=2;Hg=Fg*+h[(tu(Ne,1,ae)|0)>>3];c[$d>>2]=3;Fg=+h[(tu(Oe,1,$d)|0)>>3];c[_d>>2]=3;Kg=Fg*+h[(tu(Ne,1,_d)|0)>>3];c[Zd>>2]=4;Fg=+h[(tu(Oe,1,Zd)|0)>>3];c[Yd>>2]=4;Lg=+Tu(Gg+(Hg+(Kg+Fg*+h[(tu(Ne,1,Yd)|0)>>3])),-2);c[Xd>>2]=3;Fg=Eg*Lg*+h[(tu(Ne,1,Xd)|0)>>3];c[Wd>>2]=4;Lg=+h[(tu(Pe,1,Wd)|0)>>3];c[Vd>>2]=1;Eg=+h[(tu(Oe,1,Vd)|0)>>3];c[Ud>>2]=1;Kg=Eg*+h[(tu(Ne,1,Ud)|0)>>3];c[Td>>2]=2;Eg=+h[(tu(Oe,1,Td)|0)>>3];c[Sd>>2]=2;Hg=Eg*+h[(tu(Ne,1,Sd)|0)>>3];c[Rd>>2]=3;Eg=+h[(tu(Oe,1,Rd)|0)>>3];c[Qd>>2]=3;Gg=Eg*+h[(tu(Ne,1,Qd)|0)>>3];c[Pd>>2]=4;Eg=+h[(tu(Oe,1,Pd)|0)>>3];c[Od>>2]=4;Mg=+Tu(Kg+(Hg+(Gg+Eg*+h[(tu(Ne,1,Od)|0)>>3])),-2);c[Nd>>2]=4;Eg=-(Lg*Mg*+h[(tu(Ne,1,Nd)|0)>>3])-Fg;c[Md>>2]=1;Fg=+h[(tu(Pe,1,Md)|0)>>3];c[Ld>>2]=1;Mg=Fg*+h[(tu(Ne,1,Ld)|0)>>3];c[Kd>>2]=2;Fg=+h[(tu(Pe,1,Kd)|0)>>3];c[Jd>>2]=2;Lg=Eg-(Mg+Fg*+h[(tu(Ne,1,Jd)|0)>>3])/(Jg*Jg);if(!Te){Te=1;do{c[Id>>2]=Te;Jg=+h[(tu(Oe,1,Id)|0)>>3];Jd=Te+ -1|0;Fg=Ig*(Jg/+lu(4920,Jd));c[Hd>>2]=Te;h[(tu(Qe,1,Hd)|0)>>3]=Fg;c[Gd>>2]=Te;Fg=Lg*+h[(tu(Oe,1,Gd)|0)>>3];c[Fd>>2]=Te;Jg=Fg+Ig*+h[(tu(Pe,1,Fd)|0)>>3];Fg=Jg/+lu(4920,Jd);c[Ed>>2]=Te;h[(tu(Re,1,Ed)|0)>>3]=Fg;Te=Te+1|0;}while((wg(Te,1,4)|0)!=0)}c[Dd>>2]=1;Ig=+h[(tu(Qe,1,Dd)|0)>>3];c[Cd>>2]=2;Lg=+h[(tu(Qe,1,Cd)|0)>>3];c[Bd>>2]=3;Fg=+h[(tu(Qe,1,Bd)|0)>>3];c[Ad>>2]=4;Jg=+h[(tu(Qe,1,Ad)|0)>>3];h[k>>3]=Lg;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Jg;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];su(Ue,4,Ig,zd);c[(n+624|0)+0>>2]=c[Ue+0>>2];c[(n+624|0)+4>>2]=c[Ue+4>>2];c[(n+624|0)+8>>2]=c[Ue+8>>2];ui(Hf,b,d,e,n+624|0);Ig=+h[Hf>>3];c[yd>>2]=1;Jg=+h[(tu(Qe,1,yd)|0)>>3];c[xd>>2]=2;Fg=+h[(tu(Qe,1,xd)|0)>>3];c[wd>>2]=3;Lg=+h[(tu(Qe,1,wd)|0)>>3];c[vd>>2]=4;Mg=+h[(tu(Qe,1,vd)|0)>>3];h[k>>3]=Fg;c[ud>>2]=c[k>>2];c[ud+4>>2]=c[k+4>>2];h[k>>3]=Lg;c[(ud+8|0)>>2]=c[k>>2];c[(ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Mg;c[(ud+16|0)>>2]=c[k>>2];c[(ud+16|0)+4>>2]=c[k+4>>2];su(Ve,4,Jg,ud);c[(n+608|0)+0>>2]=c[Ve+0>>2];c[(n+608|0)+4>>2]=c[Ve+4>>2];c[(n+608|0)+8>>2]=c[Ve+8>>2];Ii(If,b,d,e,n+608|0);Jg=+h[If>>3];c[td>>2]=1;Mg=+h[(tu(Qe,1,td)|0)>>3];c[sd>>2]=2;Lg=+h[(tu(Qe,1,sd)|0)>>3];c[rd>>2]=3;Fg=+h[(tu(Qe,1,rd)|0)>>3];c[qd>>2]=4;Eg=+h[(tu(Qe,1,qd)|0)>>3];h[k>>3]=Lg;c[pd>>2]=c[k>>2];c[pd+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(pd+8|0)>>2]=c[k>>2];c[(pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Eg;c[(pd+16|0)>>2]=c[k>>2];c[(pd+16|0)+4>>2]=c[k+4>>2];su(We,4,Mg,pd);c[(n+592|0)+0>>2]=c[We+0>>2];c[(n+592|0)+4>>2]=c[We+4>>2];c[(n+592|0)+8>>2]=c[We+8>>2];Hi(Jf,b,d,e,n+592|0);Mg=+h[Jf>>3];c[od>>2]=1;Eg=+h[(tu(Qe,1,od)|0)>>3];c[nd>>2]=2;Fg=+h[(tu(Qe,1,nd)|0)>>3];c[md>>2]=3;Lg=+h[(tu(Qe,1,md)|0)>>3];c[ld>>2]=4;Gg=+h[(tu(Qe,1,ld)|0)>>3];h[k>>3]=Fg;c[kd>>2]=c[k>>2];c[kd+4>>2]=c[k+4>>2];h[k>>3]=Lg;c[(kd+8|0)>>2]=c[k>>2];c[(kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(kd+16|0)>>2]=c[k>>2];c[(kd+16|0)+4>>2]=c[k+4>>2];su(Xe,4,Eg,kd);c[(n+576|0)+0>>2]=c[Xe+0>>2];c[(n+576|0)+4>>2]=c[Xe+4>>2];c[(n+576|0)+8>>2]=c[Xe+8>>2];Li(Kf,b,d,e,n+576|0);Eg=+h[Kf>>3];c[jd>>2]=1;Gg=+h[(tu(Qe,1,jd)|0)>>3];c[id>>2]=2;Lg=+h[(tu(Qe,1,id)|0)>>3];c[hd>>2]=3;Fg=+h[(tu(Qe,1,hd)|0)>>3];c[gd>>2]=4;Hg=+h[(tu(Qe,1,gd)|0)>>3];h[k>>3]=Lg;c[fd>>2]=c[k>>2];c[fd+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(fd+8|0)>>2]=c[k>>2];c[(fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(fd+16|0)>>2]=c[k>>2];c[(fd+16|0)+4>>2]=c[k+4>>2];su(Ye,4,Gg,fd);c[(n+560|0)+0>>2]=c[Ye+0>>2];c[(n+560|0)+4>>2]=c[Ye+4>>2];c[(n+560|0)+8>>2]=c[Ye+8>>2];Gi(Lf,b,0.0,e,n+560|0);Gg=Ig+(Jg+(Mg+(Eg+ +h[Lf>>3])))+1.0;c[ed>>2]=1;Eg=+h[(tu(Qe,1,ed)|0)>>3];c[dd>>2]=2;Mg=+h[(tu(Qe,1,dd)|0)>>3];c[cd>>2]=3;Jg=+h[(tu(Qe,1,cd)|0)>>3];c[bd>>2]=4;Ig=+h[(tu(Qe,1,bd)|0)>>3];h[k>>3]=Mg;c[ad>>2]=c[k>>2];c[ad+4>>2]=c[k+4>>2];h[k>>3]=Jg;c[(ad+8|0)>>2]=c[k>>2];c[(ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(ad+16|0)>>2]=c[k>>2];c[(ad+16|0)+4>>2]=c[k+4>>2];su(Ze,4,Eg,ad);c[$c>>2]=1;Eg=+h[(tu(Re,1,$c)|0)>>3];c[_c>>2]=2;Ig=+h[(tu(Re,1,_c)|0)>>3];c[Zc>>2]=3;Jg=+h[(tu(Re,1,Zc)|0)>>3];c[Yc>>2]=4;Mg=+h[(tu(Re,1,Yc)|0)>>3];h[k>>3]=Ig;c[Xc>>2]=c[k>>2];c[Xc+4>>2]=c[k+4>>2];h[k>>3]=Jg;c[(Xc+8|0)>>2]=c[k>>2];c[(Xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Mg;c[(Xc+16|0)>>2]=c[k>>2];c[(Xc+16|0)+4>>2]=c[k+4>>2];su(_e,4,Eg,Xc);c[(n+544|0)+0>>2]=c[Ze+0>>2];c[(n+544|0)+4>>2]=c[Ze+4>>2];c[(n+544|0)+8>>2]=c[Ze+8>>2];c[(n+528|0)+0>>2]=c[_e+0>>2];c[(n+528|0)+4>>2]=c[_e+4>>2];c[(n+528|0)+8>>2]=c[_e+8>>2];Ji(Mf,b,d,e,n+544|0,j,l,n+528|0);Eg=+h[Mf>>3];c[Wc>>2]=1;Mg=+h[(tu(Qe,1,Wc)|0)>>3];c[Vc>>2]=2;Jg=+h[(tu(Qe,1,Vc)|0)>>3];c[Uc>>2]=3;Ig=+h[(tu(Qe,1,Uc)|0)>>3];c[Tc>>2]=4;Hg=+h[(tu(Qe,1,Tc)|0)>>3];h[k>>3]=Jg;c[Sc>>2]=c[k>>2];c[Sc+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(Sc+8|0)>>2]=c[k>>2];c[(Sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Sc+16|0)>>2]=c[k>>2];c[(Sc+16|0)+4>>2]=c[k+4>>2];su($e,4,Mg,Sc);c[Rc>>2]=1;Mg=+h[(tu(Re,1,Rc)|0)>>3];c[Qc>>2]=2;Hg=+h[(tu(Re,1,Qc)|0)>>3];c[Pc>>2]=3;Ig=+h[(tu(Re,1,Pc)|0)>>3];c[Oc>>2]=4;Jg=+h[(tu(Re,1,Oc)|0)>>3];h[k>>3]=Hg;c[Nc>>2]=c[k>>2];c[Nc+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(Nc+8|0)>>2]=c[k>>2];c[(Nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Jg;c[(Nc+16|0)>>2]=c[k>>2];c[(Nc+16|0)+4>>2]=c[k+4>>2];su(af,4,Mg,Nc);c[(n+512|0)+0>>2]=c[$e+0>>2];c[(n+512|0)+4>>2]=c[$e+4>>2];c[(n+512|0)+8>>2]=c[$e+8>>2];c[(n+496|0)+0>>2]=c[af+0>>2];c[(n+496|0)+4>>2]=c[af+4>>2];c[(n+496|0)+8>>2]=c[af+8>>2];Ki(Nf,b,d,e,n+512|0,j,l,n+496|0);Mg=+h[Nf>>3];c[Mc>>2]=1;Jg=+h[(tu(Qe,1,Mc)|0)>>3];c[Lc>>2]=2;Ig=+h[(tu(Qe,1,Lc)|0)>>3];c[Kc>>2]=3;Hg=+h[(tu(Qe,1,Kc)|0)>>3];c[Jc>>2]=4;Fg=+h[(tu(Qe,1,Jc)|0)>>3];h[k>>3]=Ig;c[Ic>>2]=c[k>>2];c[Ic+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Ic+8|0)>>2]=c[k>>2];c[(Ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(Ic+16|0)>>2]=c[k>>2];c[(Ic+16|0)+4>>2]=c[k+4>>2];su(bf,4,Jg,Ic);c[Hc>>2]=1;Jg=+h[(tu(Re,1,Hc)|0)>>3];c[Gc>>2]=2;Fg=+h[(tu(Re,1,Gc)|0)>>3];c[Fc>>2]=3;Hg=+h[(tu(Re,1,Fc)|0)>>3];c[Ec>>2]=4;Ig=+h[(tu(Re,1,Ec)|0)>>3];h[k>>3]=Fg;c[Dc>>2]=c[k>>2];c[Dc+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Dc+8|0)>>2]=c[k>>2];c[(Dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(Dc+16|0)>>2]=c[k>>2];c[n+656>>2]=a;c[n+664>>2]=b;g[n+672>>2]=d;g[n+680>>2]=e;g[n+696>>2]=j;g[n+704>>2]=l;c[n+728>>2]=Qf;c[n+752>>2]=Rf;c[n+792>>2]=Sf;c[n+824>>2]=Tf;c[n+864>>2]=Uf;c[n+904>>2]=Vf;c[n+928>>2]=Wf;c[n+968>>2]=Xf;c[n+1008>>2]=Yf;c[n+1024>>2]=Zf;c[n+1072>>2]=_f;c[n+1104>>2]=$f;c[n+1136>>2]=ag;c[n+1168>>2]=bg;c[n+1200>>2]=cg;c[n+1240>>2]=dg;c[n+1280>>2]=eg;c[n+1312>>2]=fg;c[n+1344>>2]=gg;c[n+1392>>2]=hg;g[n+1400>>2]=Gg;c[n+1416>>2]=ig;c[n+1464>>2]=jg;c[n+1496>>2]=kg;g[n+1504>>2]=Eg;c[n+1528>>2]=lg;c[n+1576>>2]=mg;c[n+1592>>2]=ng;g[n+1600>>2]=Mg;c[n+1640>>2]=og;g[n+1648>>2]=Jg;c[n+1680>>2]=pg;c[n+1704>>2]=qg;c[n+1752>>2]=rg;c[n+1784>>2]=sg;c[n+1824>>2]=tg;c[n+1872>>2]=ug;c[n+1880>>2]=vg;c[n+1920>>2]=xg;c[n+1968>>2]=yg;c[n+1984>>2]=zg;c[n+2032>>2]=Ag;c[n+2048>>2]=Bg;c[n+2088>>2]=Cg;c[n+2144>>2]=Dg;c[n+3016>>2]=Of;c[n+3272>>2]=Pf;c[n+3424>>2]=Qe;c[n+3432>>2]=Re;c[n+3464>>2]=Oe;c[n+3472>>2]=Pe;c[n+3480>>2]=Me;c[n+3568>>2]=bf;c[n+3576>>2]=cf;c[n+3592>>2]=df;c[n+3600>>2]=ef;c[n+3608>>2]=ff;c[n+3616>>2]=gf;c[n+3624>>2]=hf;c[n+3632>>2]=jf;c[n+3640>>2]=kf;c[n+3648>>2]=lf;c[n+3656>>2]=mf;c[n+3664>>2]=nf;c[n+3672>>2]=of;c[n+3680>>2]=pf;c[n+3688>>2]=qf;c[n+3696>>2]=rf;c[n+3704>>2]=sf;c[n+3712>>2]=tf;c[n+3720>>2]=uf;c[n+3728>>2]=vf;c[n+3736>>2]=wf;c[n+3744>>2]=xf;c[n+3752>>2]=yf;c[n+3760>>2]=zf;c[n+3768>>2]=Af;c[n+3776>>2]=Bf;c[n+3784>>2]=Cf;c[n+3792>>2]=Df;c[n+3800>>2]=Ef;c[n+3808>>2]=Ff;c[n+3816>>2]=Gf;c[n+3840>>2]=ta;c[n+3848>>2]=sa;c[n+3864>>2]=ra;c[n+3872>>2]=qa;c[n+3880>>2]=pa;c[n+3888>>2]=oa;c[n+3896>>2]=na;c[n+3904>>2]=ma;c[n+3912>>2]=la;c[n+3920>>2]=ka;c[n+3928>>2]=ja;c[n+3944>>2]=ia;c[n+3952>>2]=ha;c[n+3960>>2]=ga;c[n+3968>>2]=fa;c[n+3976>>2]=ea;c[n+3984>>2]=da;c[n+3992>>2]=ca;c[n+4e3>>2]=ba;c[n+4008>>2]=aa;c[n+4024>>2]=$;c[n+4032>>2]=_;c[n+4040>>2]=Z;c[n+4048>>2]=Y;c[n+4056>>2]=X;c[n+4064>>2]=W;c[n+4072>>2]=V;c[n+4080>>2]=U;c[n+4088>>2]=T;c[n+4104>>2]=S;c[n+4112>>2]=R;c[n+4120>>2]=Q;c[n+4128>>2]=P;c[n+4136>>2]=O;c[n+4144>>2]=N;c[n+4152>>2]=M;c[n+4160>>2]=L;c[n+4168>>2]=K;c[n+4176>>2]=J;c[n+4192>>2]=G;c[n+4200>>2]=F;c[n+4208>>2]=E;c[n+4216>>2]=D;c[n+4224>>2]=C;c[n+4232>>2]=B;c[n+4240>>2]=z;c[n+4248>>2]=y;c[n+4256>>2]=x;c[n+4264>>2]=w;c[n+4280>>2]=v;c[n+4288>>2]=u;c[n+4296>>2]=t;c[n+4304>>2]=s;c[n+4312>>2]=r;c[n+4320>>2]=q;c[n+4328>>2]=p;c[n+4336>>2]=o;c[n+5096>>2]=Dc;c[n+5104>>2]=Cc;c[n+5112>>2]=Bc;c[n+5120>>2]=Ac;c[n+5136>>2]=zc;c[n+5144>>2]=yc;c[n+5160>>2]=xc;c[n+5168>>2]=wc;c[n+5176>>2]=vc;c[n+5184>>2]=uc;c[n+5192>>2]=tc;c[n+5200>>2]=sc;c[n+5208>>2]=rc;c[n+5216>>2]=qc;c[n+5224>>2]=pc;c[n+5240>>2]=oc;c[n+5248>>2]=nc;c[n+5256>>2]=mc;c[n+5264>>2]=lc;c[n+5272>>2]=kc;c[n+5280>>2]=jc;c[n+5288>>2]=ic;c[n+5296>>2]=hc;c[n+5304>>2]=gc;c[n+5320>>2]=fc;c[n+5328>>2]=ec;c[n+5336>>2]=dc;c[n+5344>>2]=cc;c[n+5352>>2]=bc;c[n+5360>>2]=ac;c[n+5368>>2]=$b;c[n+5376>>2]=_b;c[n+5384>>2]=Zb;c[n+5392>>2]=Yb;c[n+5400>>2]=Xb;c[n+5408>>2]=Wb;c[n+5416>>2]=Vb;c[n+5424>>2]=Ub;c[n+5440>>2]=Tb;c[n+5448>>2]=Sb;c[n+5456>>2]=Rb;c[n+5464>>2]=Qb;c[n+5472>>2]=Pb;c[n+5480>>2]=Ob;c[n+5488>>2]=Nb;c[n+5496>>2]=Mb;c[n+5504>>2]=Lb;c[n+5520>>2]=Kb;c[n+5528>>2]=Jb;c[n+5536>>2]=Ib;c[n+5544>>2]=Hb;c[n+5552>>2]=Gb;c[n+5560>>2]=Fb;c[n+5568>>2]=Eb;c[n+5576>>2]=Db;c[n+5584>>2]=Cb;c[n+5600>>2]=Bb;c[n+5608>>2]=Ab;c[n+5616>>2]=zb;c[n+5624>>2]=yb;c[n+5632>>2]=xb;c[n+5640>>2]=wb;c[n+5648>>2]=vb;c[n+5656>>2]=ub;c[n+5664>>2]=tb;c[n+5680>>2]=sb;c[n+5688>>2]=rb;c[n+5696>>2]=qb;c[n+5704>>2]=pb;c[n+5712>>2]=ob;c[n+5720>>2]=nb;c[n+5728>>2]=mb;c[n+5736>>2]=lb;c[n+5744>>2]=kb;c[n+5760>>2]=jb;c[n+5768>>2]=ib;c[n+5776>>2]=hb;c[n+5784>>2]=gb;c[n+5792>>2]=fb;c[n+5800>>2]=eb;c[n+5808>>2]=db;c[n+5816>>2]=cb;c[n+5824>>2]=bb;c[n+5832>>2]=ab;c[n+5848>>2]=$a;c[n+5856>>2]=_a;c[n+5864>>2]=Za;c[n+5872>>2]=Ya;c[n+5880>>2]=Xa;c[n+5888>>2]=Wa;c[n+5896>>2]=Va;c[n+5904>>2]=Ua;c[n+5912>>2]=Ta;c[n+5928>>2]=Sa;c[n+5936>>2]=Ra;c[n+5952>>2]=Qa;c[n+5960>>2]=Pa;c[n+5968>>2]=Oa;c[n+5976>>2]=Na;c[n+5984>>2]=Ma;c[n+5992>>2]=La;c[n+6e3>>2]=Ka;c[n+6016>>2]=Ja;c[n+6024>>2]=Ia;c[n+6032>>2]=Ha;c[n+6040>>2]=Ga;c[n+6048>>2]=Fa;c[n+6056>>2]=Ea;c[n+6064>>2]=Da;c[n+6072>>2]=Ca;c[n+6080>>2]=Ba;c[n+6096>>2]=Aa;c[n+6104>>2]=za;c[n+6112>>2]=ya;c[n+6120>>2]=xa;c[n+6128>>2]=wa;c[n+6136>>2]=va;c[n+6144>>2]=ua;c[n+6160>>2]=0;c[n+6164>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_h__dis__pTX__der$0(n);H=c[n+6160>>2]|0;A=c[n+6164>>2]|0;I=+g[n+6164>>2];c[n+6160>>2]=0;c[n+6164>>2]=0;if((H|0)==5){return}}function gj(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0;l=i;i=i+1032|0;m=l;n=l+16|0;o=l+136|0;p=l+256|0;q=l+352|0;r=l+448|0;s=l+544|0;t=l+640|0;u=l+736|0;v=l+752|0;w=l+768|0;x=l+784|0;y=l+880|0;z=l+896|0;A=l+912|0;B=l+928|0;C=l+1024|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+96|0;I=i;i=i+96|0;J=i;i=i+96|0;K=i;i=i+96|0;L=i;i=i+96|0;M=i;i=i+96|0;N=i;i=i+96|0;O=i;i=i+120|0;P=i;i=i+120|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;c[G>>2]=1;if(+h[(tu(f,1,G)|0)>>3]==0.0){qg(H,b,d,e);Aa=B+0|0;Ba=H+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));zg(Q,0,0.0,e,B,g,j);Da=+h[Q>>3];Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}Q=A;B=f;c[Q+0>>2]=c[B+0>>2];c[Q+4>>2]=c[B+4>>2];c[Q+8>>2]=c[B+8>>2];bj(R,b,d,e,A);Ga=+h[R>>3];R=z;A=f;c[R+0>>2]=c[A+0>>2];c[R+4>>2]=c[A+4>>2];c[R+8>>2]=c[A+8>>2];A=y;R=k;c[A+0>>2]=c[R+0>>2];c[A+4>>2]=c[R+4>>2];c[A+8>>2]=c[R+8>>2];hj(S,b,d,e,z,g,j,y);Ha=+h[S>>3];Ia=d-Ga;Ja=g-Ha;c[F>>2]=1;Ka=+h[(tu(f,1,F)|0)>>3];c[E>>2]=1;La=Ka/(1.0- +h[(tu(f,1,E)|0)>>3]);c[D>>2]=1;Ka=1.0- +h[(tu(f,1,D)|0)>>3];c[C>>2]=1;Ma=+h[(tu(k,1,C)|0)>>3]/(Ka*Ka);aj(T,b,d,e);Ka=+h[T>>3];ij(U,b,d,e,g,j);Na=+h[U>>3];U=La<=Ka|Ka==-1.0;do{if(U){if(!(e>=773.15)){qg(J,b,Ia,e);Aa=t+0|0;Ba=J+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));zg(_,0,0.0,e,t,Ja,j);Oa=+h[_>>3];ii($,b,Ga,e,0);Pa=+h[$>>3];ji(aa,b,Ga,e,0,Ha,j);Qa=Oa+(Ma*Pa+La*+h[aa>>3]);Ra=11;break}else{qg(I,b,Ia,e);Aa=x+0|0;Ba=I+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));zg(V,0,0.0,e,x,Ja,j);Pa=+h[V>>3];ii(W,b,Ga,e,0);Oa=+h[W>>3];ji(X,b,Ga,e,0,Ha,j);Sa=+h[X>>3];T=w;C=f;c[T+0>>2]=c[C+0>>2];c[T+4>>2]=c[C+4>>2];c[T+8>>2]=c[C+8>>2];ej(Y,b,d,e,w);Ta=+h[Y>>3];C=v;T=f;c[C+0>>2]=c[T+0>>2];c[C+4>>2]=c[T+4>>2];c[C+8>>2]=c[T+8>>2];T=u;C=k;c[T+0>>2]=c[C+0>>2];c[T+4>>2]=c[C+4>>2];c[T+8>>2]=c[C+8>>2];fj(Z,b,d,e,v,g,j,u);Ua=Pa+(Ma*Oa+(La*Sa+(Ma*Ta+La*+h[Z>>3])));Ra=10;break}}else{if(e<273.16){qg(K,b,Ia,e);Aa=s+0|0;Ba=K+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));zg(ba,0,0.0,e,s,Ja,j);Ta=+h[ba>>3];ii(ca,b,Ga,e,0);Sa=+h[ca>>3];ji(da,b,Ga,e,0,Ha,j);Oa=+h[da>>3];yi(ea,b,d,e);Pa=+h[ea>>3];zi(L,b,d,e);Aa=r+0|0;Ba=L+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));Bi(fa,0,0.0,0.0,r,g,j);Va=+h[fa>>3];yi(ga,b,d,e);Wa=+h[ga>>3];zi(M,b,d,e);Aa=q+0|0;Ba=M+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));Bi(ha,0,0.0,0.0,q,g,j);Ua=Ta+(Na*Sa+(Ka*Oa+(Ma*Pa+(La*Va+(-(Na*Wa)-Ka*+h[ha>>3])))));Ra=10;break}else{qg(N,b,d,e);Aa=p+0|0;Ba=N+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));zg(ia,0,0.0,e,p,Ja,j);Wa=+h[ia>>3];ii(ja,b,Ga,e,0);Va=+h[ja>>3];ji(ka,b,Ga,e,0,Ha,j);Pa=+h[ka>>3];kh(la,b,d,e,0);Oa=+h[la>>3];jj(O,b,d,e,0);Aa=o+0|0;Ba=O+0|0;Ca=Aa+120|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));kj(ma,0,0.0,e,o,g,j);Sa=+h[ma>>3];kh(na,b,d,e,0);Ta=+h[na>>3];jj(P,b,d,e,0);Aa=n+0|0;Ba=P+0|0;Ca=Aa+120|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));kj(oa,0,0.0,e,n,g,j);Xa=Wa+(Na*Va+(Ka*Pa+(Ma*Oa+(La*Sa+(-(Na*Ta)-Ka*+h[oa>>3])))));Ra=14;break}}}while(0);if((Ra|0)==10){if(U){Qa=Ua;Ra=11}else{Xa=Ua;Ra=14}}do{if((Ra|0)==11){if(!(e>=773.15)){pg(sa,b,Ia,e);Ua=+h[sa>>3];ii(ta,b,Ga,e,0);Ya=Ua+La*+h[ta>>3];Za=Qa;break}else{pg(pa,b,Ia,e);Ua=+h[pa>>3];ii(qa,b,Ga,e,0);Na=+h[qa>>3];U=m;oa=f;c[U+0>>2]=c[oa+0>>2];c[U+4>>2]=c[oa+4>>2];c[U+8>>2]=c[oa+8>>2];ej(ra,b,d,e,m);Ya=Ua+(La*Na+(La+1.0)*+h[ra>>3]);Za=Qa;break}}else if((Ra|0)==14){if(e<273.16){pg(ua,b,Ia,e);Na=+h[ua>>3];ii(va,b,Ga,e,0);Ua=+h[va>>3];yi(wa,b,d,e);Ya=Na+(Ka*Ua+(La-Ka)*+h[wa>>3]);Za=Xa;break}else{pg(xa,b,Ia,e);Ua=+h[xa>>3];ii(ya,b,Ga,e,0);Na=+h[ya>>3];kh(za,b,d,e,0);Ya=Ua+(Ka*Na+(La-Ka)*+h[za>>3]);Za=Xa;break}}}while(0);Xa=La+1.0;Da=(Xa*Za-Ma*Ya)/(Xa*Xa);Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}function hj(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;c[q>>2]=1;if(+h[(tu(f,1,q)|0)>>3]==0.0){t=0.0;u=a;v=u;h[v>>3]=t;i=l;return}c[p>>2]=1;w=+h[(tu(f,1,p)|0)>>3];c[o>>2]=1;x=w/(1.0- +h[(tu(f,1,o)|0)>>3]);c[n>>2]=1;w=1.0- +h[(tu(f,1,n)|0)>>3];c[m>>2]=1;y=+h[(tu(k,1,m)|0)>>3]/(w*w);lj(r,b,d,e,0.0,j);j=+h[r>>3];aj(s,b,d,e);e=+h[s>>3];t=x<=e|e==-1.0?y*d*.6221042453709779+x*(g/(x+.6221042453709779)):j;u=a;v=u;h[v>>3]=t;i=l;return}function ij(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;k=g+8|0;l=g+16|0;m=g+24|0;cj(j,b,c,d);e=+h[j>>3];lj(k,b,c,d,0.0,f);f=+h[k>>3];if(!(d<=273.16)){Ti(m,b,c);n=+h[m>>3]}else{vi(l,b,c);n=+h[l>>3]}if(!(n>=d)){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}d=c-e;o=f*(c/(d*d))*.6221042453709779;p=a;q=p;h[q>>3]=o;i=g;return}function jj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){Ij(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==3){uj(o,b,d,e,1.0e-7);s=+h[o>>3];Ej(p,b,s,e);t=+h[p+24>>3];u=+h[p+32>>3];v=+h[p+48>>3];w=u*+h[p+64>>3];x=s*t*(v-u*+h[p+80>>3])*461.526;y=x;z=t*(v*2.0+t*+h[p+56>>3])*e*461.526;A=0.0;B=0.0;C=0.0;D=x;E=(t*v+w)*e*461.526;F=0.0;G=u*u*+h[p+72>>3]*-461.526;H=s;I=(w- +h[p+40>>3])*461.526}else if((r|0)==5){Fj(q,b,d,e);w=+h[q+24>>3];s=+h[q+32>>3];u=+h[q+48>>3];v=+h[q+56>>3];t=+h[q+72>>3];x=+h[q+80>>3];J=s*+h[q+64>>3];K=(J- +h[q+40>>3])*461.526;L=w*u;M=(L-s*w*x)/d*461.526;N=w*w*v*+Tu(d,-2)*e*461.526;w=s*s*t;t=u-s*x;y=0.0;z=0.0;A=M;B=N;C=1.0;D=-M/N;E=J*e*461.526;F=w*-461.526;G=(t*t/v-w)*461.526;H=d/(L*e*461.526);I=K}else if((r|0)==1){Gj(m,b,d,e);K=+h[m+24>>3];L=+h[m+32>>3];w=+h[m+48>>3];v=+h[m+56>>3];t=+h[m+72>>3];J=+h[m+80>>3];N=L*+h[m+64>>3];M=(N- +h[m+40>>3])*461.526;x=K*w;s=(x-L*K*J)/d*461.526;u=K*K*v*+Tu(d,-2)*e*461.526;K=L*L*t;t=w-L*J;y=0.0;z=0.0;A=s;B=u;C=0.0;D=-s/u;E=N*e*461.526;F=K*-461.526;G=(t*t/v-K)*461.526;H=d/(x*e*461.526);I=M}else if((r|0)==2){Hj(n,b,d,e);M=+h[n+24>>3];x=+h[n+32>>3];K=+h[n+48>>3];v=+h[n+56>>3];t=+h[n+72>>3];N=+h[n+80>>3];u=x*+h[n+64>>3];s=(u- +h[n+40>>3])*461.526;J=M*K;L=(J-x*M*N)/d*461.526;w=M*M*v*+Tu(d,-2)*e*461.526;M=x*x*t;t=K-x*N;y=0.0;z=0.0;A=L;B=w;C=1.0;D=-L/w;E=u*e*461.526;F=M*-461.526;G=(t*t/v-M)*461.526;H=d/(J*e*461.526);I=s}else{n=_t(_t(7288,Yt(d,0,1,6)|0)|0,7344)|0;m=_t(_t(n,Yt(e,0,1,6)|0)|0,7352)|0;n=c[21062]|0;q=j;p=7360;c[q+0>>2]=c[p+0>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[q+12>>2]=c[p+12>>2];c[q+16>>2]=c[p+16>>2];c[q+20>>2]=c[p+20>>2];De[n&31](b,j,m,k);y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=E;h[a+32>>3]=461.526;h[a+40>>3]=F;h[a+48>>3]=G;h[a+56>>3]=H;h[a+64>>3]=I;h[a+72>>3]=y;h[a+80>>3]=z;h[a+88>>3]=A;h[a+96>>3]=B;h[a+104>>3]=C;h[a+112>>3]=D;i=g;return}function kj(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0;b=i;d=+h[f+56>>3];if((c[f+4>>2]|0)==3){k=+h[f+72>>3];l=+h[f+80>>3];m=(k*e-d*l)*+Tu(d,-2)*(g/l);e=d*d*l*+h[f+48>>3]+k*k*+h[f+16>>3];n=m+e*+Tu(d,-2)*(j/l);o=a;p=o;h[p>>3]=n;i=b;return}else{n=+h[f+40>>3]*j+(1.0/d- +h[f+16>>3]*+h[f+88>>3])*g;o=a;p=o;h[p>>3]=n;i=b;return}}function lj(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0,s=0;g=i;i=i+32|0;j=g;k=g+8|0;l=g+16|0;m=g+24|0;if(!(d>=273.16)){Ai(l,0,d,f);e=+h[l>>3];vi(m,b,c);n=+h[m>>3];o=e;p=!(n>=d);q=p?0.0:o;r=a;s=r;h[s>>3]=q;i=g;return}else{_i(j,b,d,f);f=+h[j>>3];Ti(k,b,c);n=+h[k>>3];o=f;p=!(n>=d);q=p?0.0:o;r=a;s=r;h[s>>3]=q;i=g;return}}function mj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;c[l>>2]=1;if(+h[(tu(f,1,l)|0)>>3]==0.0){p=0.0;q=a;r=q;h[r>>3]=p;i=g;return}c[k>>2]=1;s=+h[(tu(f,1,k)|0)>>3];c[j>>2]=1;t=s/(1.0- +h[(tu(f,1,j)|0)>>3]);if(!(e>=273.16)){xi(n,0,e);u=+h[n>>3]}else{qh(m,b,e);u=+h[m>>3]}ti(o,0,0.0,0.0);e=u*+h[o>>3];u=t*(d/(t+.6221042453709779));if(!(u<=e)){p=-1.0;q=a;r=q;h[r>>3]=p;i=g;return}p=u/e;q=a;r=q;h[r>>3]=p;i=g;return}function nj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;nu(u,1,n);c[m>>2]=2;nu(u,1,m);if((ft(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];gi(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +vu(f);su(q,1,w,l);c[k>>2]=q;uu(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];gi(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];ou(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function oj(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0;l=i;i=i+968|0;m=l;n=l+120|0;o=l+240|0;p=l+336|0;q=l+432|0;r=l+528|0;s=l+624|0;t=l+720|0;u=l+816|0;v=l+832|0;w=l+848|0;x=l+864|0;y=l+960|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+16|0;fa=i;i=i+96|0;ga=i;i=i+96|0;ha=i;i=i+96|0;ia=i;i=i+96|0;ja=i;i=i+96|0;ka=i;i=i+96|0;la=i;i=i+96|0;ma=i;i=i+120|0;na=i;i=i+120|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;c[da>>2]=5;nu(ea,1,da);c[ca>>2]=1;if(+h[(tu(f,1,ca)|0)>>3]==0.0){qg(fa,b,d,e);Na=x+0|0;Oa=fa+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ag(oa,0,0.0,0.0,x,g,j);Qa=+h[oa>>3];Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}c[ba>>2]=1;Ta=+h[(tu(f,1,ba)|0)>>3];c[aa>>2]=1;Ua=Ta/(1.0- +h[(tu(f,1,aa)|0)>>3]);c[$>>2]=1;Ta=1.0- +h[(tu(f,1,$)|0)>>3];c[_>>2]=1;Va=+h[(tu(k,1,_)|0)>>3]/(Ta*Ta);aj(pa,b,d,e);Ta=+h[pa>>3];ij(qa,b,d,e,g,j);Wa=+h[qa>>3];qa=w;pa=f;c[qa+0>>2]=c[pa+0>>2];c[qa+4>>2]=c[pa+4>>2];c[qa+8>>2]=c[pa+8>>2];bj(ra,b,d,e,w);Xa=+h[ra>>3];ra=v;w=f;c[ra+0>>2]=c[w+0>>2];c[ra+4>>2]=c[w+4>>2];c[ra+8>>2]=c[w+8>>2];w=u;ra=k;c[w+0>>2]=c[ra+0>>2];c[w+4>>2]=c[ra+4>>2];c[w+8>>2]=c[ra+8>>2];hj(sa,b,d,e,v,g,j,u);Ya=+h[sa>>3];Za=d-Xa;_a=g-Ya;sa=e<273.16;if(Ua<=Ta|Ta==-1.0){if(sa){qg(ga,b,Za,e);Na=t+0|0;Oa=ga+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ag(ta,0,0.0,0.0,t,_a,j);$a=e*461.51805;Qa=+h[ta>>3]+(Ya*e-Xa*j)/($a*$a)*461.51805;Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}else{qg(ha,b,Za,e);Na=s+0|0;Oa=ha+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ag(ua,0,0.0,0.0,s,_a,j);_a=+h[ua>>3];si(va,b,Xa,e,Ya,j);Qa=_a+ +h[va>>3];Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}}else{if(sa){xg(wa,b,Za,e);_a=+h[wa>>3];c[Z>>2]=1;h[(tu(ea,1,Z)|0)>>3]=_a;Ci(xa,b,d,e);_a=+h[xa>>3];c[Y>>2]=2;h[(tu(ea,1,Y)|0)>>3]=_a;xg(ya,b,Za,e);_a=+h[ya>>3];Ci(za,b,d,e);$a=Ta+1.0;ab=$a/(_a+Xa/(e*461.51805))+(Ua-Ta)/+h[za>>3];c[X>>2]=3;h[(tu(ea,1,X)|0)>>3]=ab;qg(ia,b,d,e);Na=r+0|0;Oa=ia+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ag(Aa,0,0.0,0.0,r,g,j);ab=+h[Aa>>3];c[W>>2]=4;h[(tu(ea,1,W)|0)>>3]=ab;c[V>>2]=1;ab=+h[(tu(ea,1,V)|0)>>3];zi(ja,b,d,e);Na=q+0|0;Oa=ja+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ei(Ba,0,0.0,0.0,q,g,j);_a=+h[Ba>>3];zi(ka,b,d,e);Na=p+0|0;Oa=ka+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ei(Ca,0,0.0,0.0,p,g,j);bb=+h[Ca>>3];c[U>>2]=2;cb=+h[(tu(ea,1,U)|0)>>3];c[T>>2]=1;db=Wa*+h[(tu(ea,1,T)|0)>>3];c[S>>2]=4;eb=(db-$a*+h[(tu(ea,1,S)|0)>>3])/(ab*ab);c[R>>2]=2;ab=Va*+h[(tu(ea,1,R)|0)>>3]-Ua*_a;c[Q>>2]=2;_a=eb+((Ya*e-Xa*j)/(e*e*461.51805)+(ab+(Ta*bb-Wa*+h[(tu(ea,1,Q)|0)>>3]))/(cb*cb));c[P>>2]=5;h[(tu(ea,1,P)|0)>>3]=_a;c[O>>2]=3;_a=+h[(tu(ea,1,O)|0)>>3];c[N>>2]=3;cb=Va*+h[(tu(ea,1,N)|0)>>3];c[M>>2]=5;Qa=(cb-(Ua+1.0)*+h[(tu(ea,1,M)|0)>>3])/(_a*_a);Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}else{xg(Da,b,Za,e);_a=+h[Da>>3];hi(Ea,b,Xa,e);cb=_a+ +h[Ea>>3];c[L>>2]=1;h[(tu(ea,1,L)|0)>>3]=cb;oh(Fa,b,d,e,0);cb=+h[Fa>>3];c[K>>2]=2;h[(tu(ea,1,K)|0)>>3]=cb;xg(Ga,b,Za,e);Za=+h[Ga>>3];hi(Ha,b,Xa,e);cb=+h[Ha>>3];oh(Ia,b,d,e,0);_a=Ta+1.0;bb=_a/(Za+cb)+(Ua-Ta)/+h[Ia>>3];c[J>>2]=3;h[(tu(ea,1,J)|0)>>3]=bb;qg(la,b,d,e);Na=o+0|0;Oa=la+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));Ag(Ja,0,0.0,0.0,o,g,j);bb=+h[Ja>>3];si(Ka,b,Xa,e,Ya,j);Ya=bb+ +h[Ka>>3];c[I>>2]=4;h[(tu(ea,1,I)|0)>>3]=Ya;c[H>>2]=1;Ya=+h[(tu(ea,1,H)|0)>>3];jj(ma,b,d,e,0);Na=n+0|0;Oa=ma+0|0;Pa=Na+120|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));pj(La,0,0.0,0.0,n,g,j);bb=+h[La>>3];jj(na,b,d,e,0);Na=m+0|0;Oa=na+0|0;Pa=Na+120|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));pj(Ma,0,0.0,0.0,m,g,j);j=+h[Ma>>3];c[G>>2]=2;g=+h[(tu(ea,1,G)|0)>>3];c[F>>2]=1;e=Wa*+h[(tu(ea,1,F)|0)>>3];c[E>>2]=4;d=(e-_a*+h[(tu(ea,1,E)|0)>>3])/(Ya*Ya);c[D>>2]=2;Ya=Va*+h[(tu(ea,1,D)|0)>>3]-Ua*bb;c[C>>2]=2;bb=d+(Ya+(Ta*j-Wa*+h[(tu(ea,1,C)|0)>>3]))/(g*g);c[B>>2]=5;h[(tu(ea,1,B)|0)>>3]=bb;c[A>>2]=3;bb=+h[(tu(ea,1,A)|0)>>3];c[z>>2]=3;g=Va*+h[(tu(ea,1,z)|0)>>3];c[y>>2]=5;Qa=(g-(Ua+1.0)*+h[(tu(ea,1,y)|0)>>3])/(bb*bb);Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}}}function pj(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0,m=0;b=i;if((c[f+4>>2]|0)==3){e=+h[f+80>>3];k=g/e- +h[f+72>>3]*(j/e);l=a;m=l;h[m>>3]=k;i=b;return}else{e=+h[f+56>>3];k=-(e*e*(+h[f+96>>3]*g+ +h[f+88>>3]*j));l=a;m=l;h[m>>3]=k;i=b;return}}function qj(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0;l=i;i=i+128|0;m=l;n=l+16|0;o=l+32|0;p=l+48|0;q=l+64|0;r=l+80|0;s=l+96|0;t=l+104|0;u=l+112|0;v=l+120|0;w=r;x=f;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];x=q;w=k;c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];gj(s,b,d,e,r,g,j,q);y=+h[s>>3];s=p;q=f;c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];q=o;s=k;c[q+0>>2]=c[s+0>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];oj(t,b,d,e,p,g,j,o);j=+h[t>>3];t=n;o=f;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];$i(u,b,d,e,n);z=+h[u>>3];u=m;n=f;c[u+0>>2]=c[n+0>>2];c[u+4>>2]=c[n+4>>2];c[u+8>>2]=c[n+8>>2];$i(v,b,d,e,m);e=+h[v>>3];h[a>>3]=y+(j*d-z*g)/(e*e);i=l;return}function rj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];nj(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];sj(j,b,h);i=g;return}function sj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(tu(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(tu(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];su(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];dj(d,b,o,p,f);i=e;return}function tj(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function uj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=_t(_t(5384,Yt(d,0,1,6)|0)|0,5456)|0;H=_t(_t(G,Yt(16529200.0,0,1,6)|0)|0,5464)|0;G=c[21062]|0;I=n;J=5560;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];De[G&31](b,n,H,r);}if(!(e>=623.15)){r=_t(_t(5584,Yt(e,0,1,6)|0)|0,5656)|0;H=_t(_t(r,Yt(623.15,0,1,6)|0)|0,5664)|0;r=c[21062]|0;n=m;G=5672;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];De[r&31](b,m,H,q);}vj(t,0,e);if(!(+h[t>>3]<=d)){t=_t(_t(5696,Yt(d,0,1,6)|0)|0,5768)|0;q=_t(_t(t,Yt(e,0,1,6)|0)|0,5664)|0;t=c[21062]|0;H=l;m=5784;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];De[t&31](b,l,q,p);}wj(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];xj(v,0,d);L=+h[v>>3];yj(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{zj(x,b,d);if(+h[x>>3]>e){xj(y,0,d);M=+h[y>>3];Aj(z,0,d);L=+h[z>>3];Bj(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{Cj(B,0,d);L=+h[B>>3];yj(C,0,d);M=+h[C>>3];Dj(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){Ej(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));ug(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[21062]|0;S=j;R=5808;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];De[fa&31](b,j,5832,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function vj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;nu(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function wj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;nu(k,1,j);j=k;k=7176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=_t(_t(7192,Yt(d,0,1,6)|0)|0,6296)|0;j=_t(_t(k,Yt(611.657,0,1,6)|0)|0,6304)|0;k=c[21062]|0;s=f;t=7264;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];De[k&31](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function xj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;nu(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(tu(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(tu(s,1,p)|0)>>3];c[o>>2]=2;h[(tu(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(tu(s,1,n)|0)>>3];c[m>>2]=3;h[(tu(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(tu(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(tu(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(tu(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(tu(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(tu(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(tu(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function yj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;nu(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(tu(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(tu(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(tu(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(tu(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(tu(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(tu(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(tu(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(tu(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(tu(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(tu(La,1,Aa)|0)>>3];c[za>>2]=6;h[(tu(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(tu(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(tu(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(tu(La,1,wa)|0)>>3];c[va>>2]=7;h[(tu(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(tu(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(tu(La,1,ta)|0)>>3];c[sa>>2]=8;h[(tu(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(tu(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(tu(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(tu(La,1,pa)|0)>>3];c[oa>>2]=9;h[(tu(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(tu(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(tu(La,1,ma)|0)>>3];c[la>>2]=11;h[(tu(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(tu(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(tu(La,1,ja)|0)>>3];c[ia>>2]=12;h[(tu(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(tu(La,1,ha)|0)>>3];c[ga>>2]=13;h[(tu(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(tu(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(tu(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(tu(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(tu(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(tu(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(tu(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(tu(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(tu(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(tu(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(tu(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(tu(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(tu(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(tu(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(tu(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(tu(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(tu(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(tu(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(tu(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(tu(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(tu(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(tu(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(tu(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(tu(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(tu(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(tu(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(tu(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(tu(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(tu(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(tu(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(tu(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(tu(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(tu(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(tu(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(tu(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(tu(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(tu(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(tu(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(tu(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(tu(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(tu(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(tu(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(tu(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(tu(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(tu(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(tu(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(tu(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(tu(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(tu(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(tu(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(tu(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(tu(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(tu(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(tu(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function zj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;nu(ia,1,ha);if(!(d>611.657)){ha=_t(_t(6952,Yt(d,0,1,6)|0)|0,6296)|0;ja=_t(_t(ha,Yt(611.657,0,1,6)|0)|0,6304)|0;ha=c[21062]|0;ka=f;la=7016;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];De[ha&31](b,f,ja,ga);}ma=+od(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(tu(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(tu(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(tu(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(tu(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(tu(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(tu(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(tu(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(tu(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(tu(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(tu(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(tu(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(tu(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(tu(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(tu(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(tu(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(tu(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(tu(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(tu(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(tu(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(tu(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(tu(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(tu(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(tu(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(tu(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(tu(ia,1,H)|0)>>3];c[G>>2]=12;h[(tu(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(tu(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(tu(ia,1,E)|0)>>3];c[D>>2]=13;h[(tu(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(tu(ia,1,C)|0)>>3]));c[B>>2]=14;h[(tu(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(tu(ia,1,A)|0)>>3];c[z>>2]=15;h[(tu(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(tu(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(tu(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(tu(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(tu(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(tu(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(tu(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(tu(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(tu(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(tu(ia,1,q)|0)>>3];c[p>>2]=19;h[(tu(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(tu(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(tu(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(tu(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(tu(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(tu(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(tu(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(tu(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function Aj(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Bj(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;qh(e,b,c);j=+h[e>>3];do{if(c<623.15){Kj(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Aj(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Cj(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Dj(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;qh(e,b,c);j=+h[e>>3];do{if(c<623.15){Jj(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Cj(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function _omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_h__dis__pTX__der$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0.0,be=0.0,ce=0.0,de=0.0,ee=0.0,fe=0.0,ge=0.0,he=0.0,ie=0.0,je=0.0,ke=0.0,le=0.0,me=0.0,ne=0.0;b=c[a+656>>2]|0;d=c[a+664>>2]|0;e=+g[a+672>>2];f=+g[a+680>>2];j=+g[a+696>>2];l=+g[a+704>>2];m=c[a+728>>2]|0;n=c[a+752>>2]|0;o=c[a+792>>2]|0;p=c[a+824>>2]|0;q=c[a+864>>2]|0;r=c[a+904>>2]|0;s=c[a+928>>2]|0;t=c[a+968>>2]|0;u=c[a+1008>>2]|0;v=c[a+1024>>2]|0;w=c[a+1072>>2]|0;x=c[a+1104>>2]|0;y=c[a+1136>>2]|0;z=c[a+1168>>2]|0;A=c[a+1200>>2]|0;B=c[a+1240>>2]|0;C=c[a+1280>>2]|0;D=c[a+1312>>2]|0;E=c[a+1344>>2]|0;F=c[a+1392>>2]|0;G=+g[a+1400>>2];H=c[a+1416>>2]|0;I=c[a+1464>>2]|0;J=c[a+1496>>2]|0;K=+g[a+1504>>2];L=c[a+1528>>2]|0;M=c[a+1576>>2]|0;N=c[a+1592>>2]|0;O=+g[a+1600>>2];P=c[a+1640>>2]|0;Q=+g[a+1648>>2];R=c[a+1680>>2]|0;S=c[a+1704>>2]|0;T=c[a+1752>>2]|0;U=c[a+1784>>2]|0;V=c[a+1824>>2]|0;W=c[a+1872>>2]|0;X=c[a+1880>>2]|0;Y=c[a+1920>>2]|0;Z=c[a+1968>>2]|0;_=c[a+1984>>2]|0;$=c[a+2032>>2]|0;aa=c[a+2048>>2]|0;ba=c[a+2088>>2]|0;ca=c[a+2144>>2]|0;da=c[a+3016>>2]|0;ea=c[a+3272>>2]|0;fa=c[a+3424>>2]|0;ga=c[a+3432>>2]|0;ha=c[a+3464>>2]|0;ia=c[a+3472>>2]|0;ja=c[a+3480>>2]|0;ka=c[a+3568>>2]|0;la=c[a+3576>>2]|0;ma=c[a+3592>>2]|0;na=c[a+3600>>2]|0;oa=c[a+3608>>2]|0;pa=c[a+3616>>2]|0;qa=c[a+3624>>2]|0;ra=c[a+3632>>2]|0;sa=c[a+3640>>2]|0;ta=c[a+3648>>2]|0;ua=c[a+3656>>2]|0;va=c[a+3664>>2]|0;wa=c[a+3672>>2]|0;xa=c[a+3680>>2]|0;ya=c[a+3688>>2]|0;za=c[a+3696>>2]|0;Aa=c[a+3704>>2]|0;Ba=c[a+3712>>2]|0;Ca=c[a+3720>>2]|0;Da=c[a+3728>>2]|0;Ea=c[a+3736>>2]|0;Fa=c[a+3744>>2]|0;Ga=c[a+3752>>2]|0;Ha=c[a+3760>>2]|0;Ia=c[a+3768>>2]|0;Ja=c[a+3776>>2]|0;Ka=c[a+3784>>2]|0;La=c[a+3792>>2]|0;Ma=c[a+3800>>2]|0;Na=c[a+3808>>2]|0;Oa=c[a+3816>>2]|0;Pa=c[a+3840>>2]|0;Qa=c[a+3848>>2]|0;Ra=c[a+3864>>2]|0;Sa=c[a+3872>>2]|0;Ta=c[a+3880>>2]|0;Ua=c[a+3888>>2]|0;Va=c[a+3896>>2]|0;Wa=c[a+3904>>2]|0;Xa=c[a+3912>>2]|0;Ya=c[a+3920>>2]|0;Za=c[a+3928>>2]|0;_a=c[a+3944>>2]|0;$a=c[a+3952>>2]|0;ab=c[a+3960>>2]|0;bb=c[a+3968>>2]|0;cb=c[a+3976>>2]|0;db=c[a+3984>>2]|0;eb=c[a+3992>>2]|0;fb=c[a+4e3>>2]|0;gb=c[a+4008>>2]|0;hb=c[a+4024>>2]|0;ib=c[a+4032>>2]|0;jb=c[a+4040>>2]|0;kb=c[a+4048>>2]|0;lb=c[a+4056>>2]|0;mb=c[a+4064>>2]|0;nb=c[a+4072>>2]|0;ob=c[a+4080>>2]|0;pb=c[a+4088>>2]|0;qb=c[a+4104>>2]|0;rb=c[a+4112>>2]|0;sb=c[a+4120>>2]|0;tb=c[a+4128>>2]|0;ub=c[a+4136>>2]|0;vb=c[a+4144>>2]|0;wb=c[a+4152>>2]|0;xb=c[a+4160>>2]|0;yb=c[a+4168>>2]|0;zb=c[a+4176>>2]|0;Ab=c[a+4192>>2]|0;Bb=c[a+4200>>2]|0;Cb=c[a+4208>>2]|0;Db=c[a+4216>>2]|0;Eb=c[a+4224>>2]|0;Fb=c[a+4232>>2]|0;Gb=c[a+4240>>2]|0;Hb=c[a+4248>>2]|0;Ib=c[a+4256>>2]|0;Jb=c[a+4264>>2]|0;Kb=c[a+4280>>2]|0;Lb=c[a+4288>>2]|0;Mb=c[a+4296>>2]|0;Nb=c[a+4304>>2]|0;Ob=c[a+4312>>2]|0;Pb=c[a+4320>>2]|0;Qb=c[a+4328>>2]|0;Rb=c[a+4336>>2]|0;Sb=c[a+5096>>2]|0;Tb=c[a+5104>>2]|0;Ub=c[a+5112>>2]|0;Vb=c[a+5120>>2]|0;Wb=c[a+5136>>2]|0;Xb=c[a+5144>>2]|0;Yb=c[a+5160>>2]|0;Zb=c[a+5168>>2]|0;_b=c[a+5176>>2]|0;$b=c[a+5184>>2]|0;ac=c[a+5192>>2]|0;bc=c[a+5200>>2]|0;cc=c[a+5208>>2]|0;dc=c[a+5216>>2]|0;ec=c[a+5224>>2]|0;fc=c[a+5240>>2]|0;gc=c[a+5248>>2]|0;hc=c[a+5256>>2]|0;ic=c[a+5264>>2]|0;jc=c[a+5272>>2]|0;kc=c[a+5280>>2]|0;lc=c[a+5288>>2]|0;mc=c[a+5296>>2]|0;nc=c[a+5304>>2]|0;oc=c[a+5320>>2]|0;pc=c[a+5328>>2]|0;qc=c[a+5336>>2]|0;rc=c[a+5344>>2]|0;sc=c[a+5352>>2]|0;tc=c[a+5360>>2]|0;uc=c[a+5368>>2]|0;vc=c[a+5376>>2]|0;wc=c[a+5384>>2]|0;xc=c[a+5392>>2]|0;yc=c[a+5400>>2]|0;zc=c[a+5408>>2]|0;Ac=c[a+5416>>2]|0;Bc=c[a+5424>>2]|0;Cc=c[a+5440>>2]|0;Dc=c[a+5448>>2]|0;Ec=c[a+5456>>2]|0;Fc=c[a+5464>>2]|0;Gc=c[a+5472>>2]|0;Hc=c[a+5480>>2]|0;Ic=c[a+5488>>2]|0;Jc=c[a+5496>>2]|0;Kc=c[a+5504>>2]|0;Lc=c[a+5520>>2]|0;Mc=c[a+5528>>2]|0;Nc=c[a+5536>>2]|0;Oc=c[a+5544>>2]|0;Pc=c[a+5552>>2]|0;Qc=c[a+5560>>2]|0;Rc=c[a+5568>>2]|0;Sc=c[a+5576>>2]|0;Tc=c[a+5584>>2]|0;Uc=c[a+5600>>2]|0;Vc=c[a+5608>>2]|0;Wc=c[a+5616>>2]|0;Xc=c[a+5624>>2]|0;Yc=c[a+5632>>2]|0;Zc=c[a+5640>>2]|0;_c=c[a+5648>>2]|0;$c=c[a+5656>>2]|0;ad=c[a+5664>>2]|0;bd=c[a+5680>>2]|0;cd=c[a+5688>>2]|0;dd=c[a+5696>>2]|0;ed=c[a+5704>>2]|0;fd=c[a+5712>>2]|0;gd=c[a+5720>>2]|0;hd=c[a+5728>>2]|0;id=c[a+5736>>2]|0;jd=c[a+5744>>2]|0;kd=c[a+5760>>2]|0;ld=c[a+5768>>2]|0;md=c[a+5776>>2]|0;nd=c[a+5784>>2]|0;od=c[a+5792>>2]|0;pd=c[a+5800>>2]|0;qd=c[a+5808>>2]|0;rd=c[a+5816>>2]|0;sd=c[a+5824>>2]|0;td=c[a+5832>>2]|0;ud=c[a+5848>>2]|0;vd=c[a+5856>>2]|0;wd=c[a+5864>>2]|0;xd=c[a+5872>>2]|0;yd=c[a+5880>>2]|0;zd=c[a+5888>>2]|0;Ad=c[a+5896>>2]|0;Bd=c[a+5904>>2]|0;Cd=c[a+5912>>2]|0;Dd=c[a+5928>>2]|0;Ed=c[a+5936>>2]|0;Fd=c[a+5952>>2]|0;Gd=c[a+5960>>2]|0;Hd=c[a+5968>>2]|0;Id=c[a+5976>>2]|0;Jd=c[a+5984>>2]|0;Kd=c[a+5992>>2]|0;Ld=c[a+6e3>>2]|0;Md=c[a+6016>>2]|0;Nd=c[a+6024>>2]|0;Od=c[a+6032>>2]|0;Pd=c[a+6040>>2]|0;Qd=c[a+6048>>2]|0;Rd=c[a+6056>>2]|0;Sd=c[a+6064>>2]|0;Td=c[a+6072>>2]|0;Ud=c[a+6080>>2]|0;Vd=c[a+6096>>2]|0;Wd=c[a+6104>>2]|0;Xd=c[a+6112>>2]|0;Yd=c[a+6120>>2]|0;Zd=c[a+6128>>2]|0;_d=c[a+6136>>2]|0;$d=c[a+6144>>2]|0;a:do{c[(Sb+16|0)+4>>2]=c[k+4>>2];su(la,4,Q,Sb);c[(a+480|0)+0>>2]=c[ka+0>>2];c[(a+480|0)+4>>2]=c[ka+4>>2];c[(a+480|0)+8>>2]=c[ka+8>>2];c[(a+464|0)+0>>2]=c[la+0>>2];c[(a+464|0)+4>>2]=c[la+4>>2];c[(a+464|0)+8>>2]=c[la+8>>2];Mi(da,d,e,f,a+480|0,j,l,a+464|0);ae=+h[da>>3];c[Tb>>2]=1;be=+h[(tu(fa,1,Tb)|0)>>3];c[Ub>>2]=2;ce=+h[(tu(fa,1,Ub)|0)>>3];c[Vb>>2]=3;de=+h[(tu(fa,1,Vb)|0)>>3];c[Wb>>2]=4;ee=+h[(tu(fa,1,Wb)|0)>>3];h[k>>3]=ce;c[Xb>>2]=c[k>>2];c[Xb+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Xb+8|0)>>2]=c[k>>2];c[(Xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(Xb+16|0)>>2]=c[k>>2];c[(Xb+16|0)+4>>2]=c[k+4>>2];su(ma,4,be,Xb);c[Yb>>2]=1;be=+h[(tu(ga,1,Yb)|0)>>3];c[Zb>>2]=2;ee=+h[(tu(ga,1,Zb)|0)>>3];c[_b>>2]=3;de=+h[(tu(ga,1,_b)|0)>>3];c[$b>>2]=4;ce=+h[(tu(ga,1,$b)|0)>>3];h[k>>3]=ee;c[ac>>2]=c[k>>2];c[ac+4>>2]=c[k+4>>2];h[k>>3]=de;c[(ac+8|0)>>2]=c[k>>2];c[(ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ce;c[(ac+16|0)>>2]=c[k>>2];c[(ac+16|0)+4>>2]=c[k+4>>2];su(na,4,be,ac);c[(a+448|0)+0>>2]=c[ma+0>>2];c[(a+448|0)+4>>2]=c[ma+4>>2];c[(a+448|0)+8>>2]=c[ma+8>>2];c[(a+432|0)+0>>2]=c[na+0>>2];c[(a+432|0)+4>>2]=c[na+4>>2];c[(a+432|0)+8>>2]=c[na+8>>2];Ni(ea,d,e,f,a+448|0,j,l,a+432|0);be=+h[ea>>3];c[bc>>2]=1;ce=+h[(tu(fa,1,bc)|0)>>3];c[cc>>2]=2;de=+h[(tu(fa,1,cc)|0)>>3];c[dc>>2]=3;ee=+h[(tu(fa,1,dc)|0)>>3];c[ec>>2]=4;fe=+h[(tu(fa,1,ec)|0)>>3];h[k>>3]=de;c[fc>>2]=c[k>>2];c[fc+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(fc+8|0)>>2]=c[k>>2];c[(fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(fc+16|0)>>2]=c[k>>2];c[(fc+16|0)+4>>2]=c[k+4>>2];su(oa,4,ce,fc);c[gc>>2]=1;ce=+h[(tu(ga,1,gc)|0)>>3];c[hc>>2]=2;fe=+h[(tu(ga,1,hc)|0)>>3];c[ic>>2]=3;ee=+h[(tu(ga,1,ic)|0)>>3];c[jc>>2]=4;de=+h[(tu(ga,1,jc)|0)>>3];h[k>>3]=fe;c[kc>>2]=c[k>>2];c[kc+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(kc+8|0)>>2]=c[k>>2];c[(kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=de;c[(kc+16|0)>>2]=c[k>>2];c[(kc+16|0)+4>>2]=c[k+4>>2];su(pa,4,ce,kc);c[(a+416|0)+0>>2]=c[oa+0>>2];c[(a+416|0)+4>>2]=c[oa+4>>2];c[(a+416|0)+8>>2]=c[oa+8>>2];c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];Qi(m,d,0.0,f,a+416|0,0.0,l,a+400|0);ce=K+(O+(ae+(be+ +h[m>>3])));c[lc>>2]=1;be=+h[(tu(fa,1,lc)|0)>>3];c[mc>>2]=2;ae=+h[(tu(fa,1,mc)|0)>>3];c[nc>>2]=3;de=+h[(tu(fa,1,nc)|0)>>3];c[oc>>2]=4;ee=+h[(tu(fa,1,oc)|0)>>3];h[k>>3]=ae;c[pc>>2]=c[k>>2];c[pc+4>>2]=c[k+4>>2];h[k>>3]=de;c[(pc+8|0)>>2]=c[k>>2];c[(pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(pc+16|0)>>2]=c[k>>2];c[(pc+16|0)+4>>2]=c[k+4>>2];su(qa,4,be,pc);c[qc>>2]=1;be=+h[(tu(ga,1,qc)|0)>>3];c[rc>>2]=2;ee=+h[(tu(ga,1,rc)|0)>>3];c[sc>>2]=3;de=+h[(tu(ga,1,sc)|0)>>3];c[tc>>2]=4;ae=+h[(tu(ga,1,tc)|0)>>3];h[k>>3]=ee;c[uc>>2]=c[k>>2];c[uc+4>>2]=c[k+4>>2];h[k>>3]=de;c[(uc+8|0)>>2]=c[k>>2];c[(uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(uc+16|0)>>2]=c[k>>2];c[(uc+16|0)+4>>2]=c[k+4>>2];su(ra,4,be,uc);c[(a+384|0)+0>>2]=c[qa+0>>2];c[(a+384|0)+4>>2]=c[qa+4>>2];c[(a+384|0)+8>>2]=c[qa+8>>2];c[(a+368|0)+0>>2]=c[ra+0>>2];c[(a+368|0)+4>>2]=c[ra+4>>2];c[(a+368|0)+8>>2]=c[ra+8>>2];Ji(n,d,e,f,a+384|0,j,l,a+368|0);be=+h[n>>3];Pi(o,0,f);ae=+h[o>>3];c[vc>>2]=1;de=+h[(tu(fa,1,vc)|0)>>3];c[wc>>2]=2;ee=+h[(tu(fa,1,wc)|0)>>3];c[xc>>2]=3;fe=+h[(tu(fa,1,xc)|0)>>3];c[yc>>2]=4;ge=+h[(tu(fa,1,yc)|0)>>3];h[k>>3]=ee;c[zc>>2]=c[k>>2];c[zc+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(zc+8|0)>>2]=c[k>>2];c[(zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(zc+16|0)>>2]=c[k>>2];c[(zc+16|0)+4>>2]=c[k+4>>2];su(sa,4,de,zc);c[(a+352|0)+0>>2]=c[sa+0>>2];c[(a+352|0)+4>>2]=c[sa+4>>2];c[(a+352|0)+8>>2]=c[sa+8>>2];ui(p,d,e,f,a+352|0);de=+h[p>>3];Ri(q,0,f,l);ge=(be*ae+de*+h[q>>3])/-30283.3;c[Ac>>2]=1;h[(tu(ja,1,Ac)|0)>>3]=ge;c[Bc>>2]=1;ge=+h[(tu(fa,1,Bc)|0)>>3];c[Cc>>2]=2;de=+h[(tu(fa,1,Cc)|0)>>3];c[Dc>>2]=3;ae=+h[(tu(fa,1,Dc)|0)>>3];c[Ec>>2]=4;be=+h[(tu(fa,1,Ec)|0)>>3];h[k>>3]=de;c[Fc>>2]=c[k>>2];c[Fc+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Fc+8|0)>>2]=c[k>>2];c[(Fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(Fc+16|0)>>2]=c[k>>2];c[(Fc+16|0)+4>>2]=c[k+4>>2];su(ta,4,ge,Fc);c[Gc>>2]=1;ge=+h[(tu(ga,1,Gc)|0)>>3];c[Hc>>2]=2;be=+h[(tu(ga,1,Hc)|0)>>3];c[Ic>>2]=3;ae=+h[(tu(ga,1,Ic)|0)>>3];c[Jc>>2]=4;de=+h[(tu(ga,1,Jc)|0)>>3];h[k>>3]=be;c[Kc>>2]=c[k>>2];c[Kc+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Kc+8|0)>>2]=c[k>>2];c[(Kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Kc+16|0)>>2]=c[k>>2];c[(Kc+16|0)+4>>2]=c[k+4>>2];su(ua,4,ge,Kc);c[(a+336|0)+0>>2]=c[ta+0>>2];c[(a+336|0)+4>>2]=c[ta+4>>2];c[(a+336|0)+8>>2]=c[ta+8>>2];c[(a+320|0)+0>>2]=c[ua+0>>2];c[(a+320|0)+4>>2]=c[ua+4>>2];c[(a+320|0)+8>>2]=c[ua+8>>2];Ki(r,d,e,f,a+336|0,j,l,a+320|0);ge=+h[r>>3];Oi(s,0,f);de=+h[s>>3];c[Lc>>2]=1;ae=+h[(tu(fa,1,Lc)|0)>>3];c[Mc>>2]=2;be=+h[(tu(fa,1,Mc)|0)>>3];c[Nc>>2]=3;fe=+h[(tu(fa,1,Nc)|0)>>3];c[Oc>>2]=4;ee=+h[(tu(fa,1,Oc)|0)>>3];h[k>>3]=be;c[Pc>>2]=c[k>>2];c[Pc+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(Pc+8|0)>>2]=c[k>>2];c[(Pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(Pc+16|0)>>2]=c[k>>2];c[(Pc+16|0)+4>>2]=c[k+4>>2];su(va,4,ae,Pc);c[(a+304|0)+0>>2]=c[va+0>>2];c[(a+304|0)+4>>2]=c[va+4>>2];c[(a+304|0)+8>>2]=c[va+8>>2];Ii(t,d,e,f,a+304|0);ae=+h[t>>3];Si(u,0,f,l);ee=(ge*de+ae*+h[u>>3])/-19526.8;c[Qc>>2]=2;h[(tu(ja,1,Qc)|0)>>3]=ee;c[Rc>>2]=1;ee=+h[(tu(fa,1,Rc)|0)>>3];c[Sc>>2]=2;ae=+h[(tu(fa,1,Sc)|0)>>3];c[Tc>>2]=3;de=+h[(tu(fa,1,Tc)|0)>>3];c[Uc>>2]=4;ge=+h[(tu(fa,1,Uc)|0)>>3];h[k>>3]=ae;c[Vc>>2]=c[k>>2];c[Vc+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Vc+8|0)>>2]=c[k>>2];c[(Vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(Vc+16|0)>>2]=c[k>>2];c[(Vc+16|0)+4>>2]=c[k+4>>2];su(wa,4,ee,Vc);c[Wc>>2]=1;ee=+h[(tu(ga,1,Wc)|0)>>3];c[Xc>>2]=2;ge=+h[(tu(ga,1,Xc)|0)>>3];c[Yc>>2]=3;de=+h[(tu(ga,1,Yc)|0)>>3];c[Zc>>2]=4;ae=+h[(tu(ga,1,Zc)|0)>>3];h[k>>3]=ge;c[_c>>2]=c[k>>2];c[_c+4>>2]=c[k+4>>2];h[k>>3]=de;c[(_c+8|0)>>2]=c[k>>2];c[(_c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(_c+16|0)>>2]=c[k>>2];c[(_c+16|0)+4>>2]=c[k+4>>2];su(xa,4,ee,_c);c[(a+288|0)+0>>2]=c[wa+0>>2];c[(a+288|0)+4>>2]=c[wa+4>>2];c[(a+288|0)+8>>2]=c[wa+8>>2];c[(a+272|0)+0>>2]=c[xa+0>>2];c[(a+272|0)+4>>2]=c[xa+4>>2];c[(a+272|0)+8>>2]=c[xa+8>>2];Mi(v,d,e,f,a+288|0,j,l,a+272|0);ee=+h[v>>3];Fi(w,0,f);ae=+h[w>>3];c[$c>>2]=1;de=+h[(tu(fa,1,$c)|0)>>3];c[ad>>2]=2;ge=+h[(tu(fa,1,ad)|0)>>3];c[bd>>2]=3;fe=+h[(tu(fa,1,bd)|0)>>3];c[cd>>2]=4;be=+h[(tu(fa,1,cd)|0)>>3];h[k>>3]=ge;c[dd>>2]=c[k>>2];c[dd+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(dd+8|0)>>2]=c[k>>2];c[(dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(dd+16|0)>>2]=c[k>>2];c[(dd+16|0)+4>>2]=c[k+4>>2];su(ya,4,de,dd);c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];Hi(x,d,e,f,a+256|0);de=+h[x>>3];Vi(y,0,f,l);be=(ee*ae+de*+h[y>>3])/-27488.0;c[ed>>2]=3;h[(tu(ja,1,ed)|0)>>3]=be;c[fd>>2]=1;be=+h[(tu(fa,1,fd)|0)>>3];c[gd>>2]=2;de=+h[(tu(fa,1,gd)|0)>>3];c[hd>>2]=3;ae=+h[(tu(fa,1,hd)|0)>>3];c[id>>2]=4;ee=+h[(tu(fa,1,id)|0)>>3];h[k>>3]=de;c[jd>>2]=c[k>>2];c[jd+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(jd+8|0)>>2]=c[k>>2];c[(jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(jd+16|0)>>2]=c[k>>2];c[(jd+16|0)+4>>2]=c[k+4>>2];su(za,4,be,jd);c[kd>>2]=1;be=+h[(tu(ga,1,kd)|0)>>3];c[ld>>2]=2;ee=+h[(tu(ga,1,ld)|0)>>3];c[md>>2]=3;ae=+h[(tu(ga,1,md)|0)>>3];c[nd>>2]=4;de=+h[(tu(ga,1,nd)|0)>>3];h[k>>3]=ee;c[od>>2]=c[k>>2];c[od+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(od+8|0)>>2]=c[k>>2];c[(od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=de;c[(od+16|0)>>2]=c[k>>2];c[(od+16|0)+4>>2]=c[k+4>>2];su(Aa,4,be,od);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+224|0)+0>>2]=c[Aa+0>>2];c[(a+224|0)+4>>2]=c[Aa+4>>2];c[(a+224|0)+8>>2]=c[Aa+8>>2];Ni(z,d,e,f,a+240|0,j,l,a+224|0);be=+h[z>>3];Ui(A,0,f);de=+h[A>>3];c[pd>>2]=1;ae=+h[(tu(fa,1,pd)|0)>>3];c[qd>>2]=2;ee=+h[(tu(fa,1,qd)|0)>>3];c[rd>>2]=3;fe=+h[(tu(fa,1,rd)|0)>>3];c[sd>>2]=4;ge=+h[(tu(fa,1,sd)|0)>>3];h[k>>3]=ee;c[td>>2]=c[k>>2];c[td+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(td+8|0)>>2]=c[k>>2];c[(td+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(td+16|0)>>2]=c[k>>2];c[(td+16|0)+4>>2]=c[k+4>>2];su(Ba,4,ae,td);c[(a+208|0)+0>>2]=c[Ba+0>>2];c[(a+208|0)+4>>2]=c[Ba+4>>2];c[(a+208|0)+8>>2]=c[Ba+8>>2];Li(B,d,e,f,a+208|0);ae=+h[B>>3];Xi(C,0,f,l);ge=(be*de+ae*+h[C>>3])/-30807.8;c[ud>>2]=4;h[(tu(ja,1,ud)|0)>>3]=ge;c[vd>>2]=1;ge=+h[(tu(fa,1,vd)|0)>>3];c[wd>>2]=2;ae=+h[(tu(fa,1,wd)|0)>>3];c[xd>>2]=3;de=+h[(tu(fa,1,xd)|0)>>3];c[yd>>2]=4;be=+h[(tu(fa,1,yd)|0)>>3];h[k>>3]=ae;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=de;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];su(Ca,4,ge,zd);c[Ad>>2]=1;ge=+h[(tu(ga,1,Ad)|0)>>3];c[Bd>>2]=2;be=+h[(tu(ga,1,Bd)|0)>>3];c[Cd>>2]=3;de=+h[(tu(ga,1,Cd)|0)>>3];c[Dd>>2]=4;ae=+h[(tu(ga,1,Dd)|0)>>3];h[k>>3]=be;c[Ed>>2]=c[k>>2];c[Ed+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Ed+8|0)>>2]=c[k>>2];c[(Ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Ed+16|0)>>2]=c[k>>2];c[(Ed+16|0)+4>>2]=c[k+4>>2];su(Da,4,ge,Ed);c[(a+192|0)+0>>2]=c[Ca+0>>2];c[(a+192|0)+4>>2]=c[Ca+4>>2];c[(a+192|0)+8>>2]=c[Ca+8>>2];c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];Qi(D,d,0.0,f,a+192|0,0.0,l,a+176|0);ge=+h[D>>3];Wi(E,0,f);ae=+h[E>>3];c[Fd>>2]=1;de=+h[(tu(fa,1,Fd)|0)>>3];c[Gd>>2]=2;be=+h[(tu(fa,1,Gd)|0)>>3];c[Hd>>2]=3;fe=+h[(tu(fa,1,Hd)|0)>>3];c[Id>>2]=4;ee=+h[(tu(fa,1,Id)|0)>>3];h[k>>3]=be;c[Jd>>2]=c[k>>2];c[Jd+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(Jd+8|0)>>2]=c[k>>2];c[(Jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(Jd+16|0)>>2]=c[k>>2];c[(Jd+16|0)+4>>2]=c[k+4>>2];su(Ea,4,de,Jd);c[(a+160|0)+0>>2]=c[Ea+0>>2];c[(a+160|0)+4>>2]=c[Ea+4>>2];c[(a+160|0)+8>>2]=c[Ea+8>>2];Gi(F,d,0.0,f,a+160|0);de=+h[F>>3];Yi(H,0,f,l);ee=(ge*ae+de*+h[H>>3])/-10973.6;c[Kd>>2]=5;h[(tu(ja,1,Kd)|0)>>3]=ee;c[Ld>>2]=1;ee=+h[(tu(fa,1,Ld)|0)>>3];c[Md>>2]=2;de=+h[(tu(fa,1,Md)|0)>>3];c[Nd>>2]=3;ae=+h[(tu(fa,1,Nd)|0)>>3];c[Od>>2]=4;ge=+h[(tu(fa,1,Od)|0)>>3];h[k>>3]=de;c[Pd>>2]=c[k>>2];c[Pd+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Pd+8|0)>>2]=c[k>>2];c[(Pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(Pd+16|0)>>2]=c[k>>2];c[(Pd+16|0)+4>>2]=c[k+4>>2];su(Fa,4,ee,Pd);c[(a+144|0)+0>>2]=c[Fa+0>>2];c[(a+144|0)+4>>2]=c[Fa+4>>2];c[(a+144|0)+8>>2]=c[Fa+8>>2];ui(I,d,e,f,a+144|0);ee=+h[I>>3];Pi(J,0,f);ge=+h[J>>3];c[Qd>>2]=1;ae=+h[(tu(fa,1,Qd)|0)>>3];c[Rd>>2]=2;de=+h[(tu(fa,1,Rd)|0)>>3];c[Sd>>2]=3;fe=+h[(tu(fa,1,Sd)|0)>>3];c[Td>>2]=4;be=+h[(tu(fa,1,Td)|0)>>3];h[k>>3]=de;c[Ud>>2]=c[k>>2];c[Ud+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(Ud+8|0)>>2]=c[k>>2];c[(Ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(Ud+16|0)>>2]=c[k>>2];c[(Ud+16|0)+4>>2]=c[k+4>>2];su(Ga,4,ae,Ud);c[(a+128|0)+0>>2]=c[Ga+0>>2];c[(a+128|0)+4>>2]=c[Ga+4>>2];c[(a+128|0)+8>>2]=c[Ga+8>>2];Ii(L,d,e,f,a+128|0);ae=+h[L>>3];Oi(M,0,f);be=+h[M>>3];c[Vd>>2]=1;fe=+h[(tu(fa,1,Vd)|0)>>3];c[Wd>>2]=2;de=+h[(tu(fa,1,Wd)|0)>>3];c[Xd>>2]=3;he=+h[(tu(fa,1,Xd)|0)>>3];c[Yd>>2]=4;ie=+h[(tu(fa,1,Yd)|0)>>3];h[k>>3]=de;c[Zd>>2]=c[k>>2];c[Zd+4>>2]=c[k+4>>2];h[k>>3]=he;c[(Zd+8|0)>>2]=c[k>>2];c[(Zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ie;c[(Zd+16|0)>>2]=c[k>>2];c[(Zd+16|0)+4>>2]=c[k+4>>2];su(Ha,4,fe,Zd);c[(a+112|0)+0>>2]=c[Ha+0>>2];c[(a+112|0)+4>>2]=c[Ha+4>>2];c[(a+112|0)+8>>2]=c[Ha+8>>2];Hi(N,d,e,f,a+112|0);fe=+h[N>>3];Fi(P,0,f);ie=+h[P>>3];c[_d>>2]=1;he=+h[(tu(fa,1,_d)|0)>>3];c[$d>>2]=2;de=+h[(tu(fa,1,$d)|0)>>3];c[Pa>>2]=3;je=+h[(tu(fa,1,Pa)|0)>>3];c[Qa>>2]=4;ke=+h[(tu(fa,1,Qa)|0)>>3];h[k>>3]=de;c[Ra>>2]=c[k>>2];c[Ra+4>>2]=c[k+4>>2];h[k>>3]=je;c[(Ra+8|0)>>2]=c[k>>2];c[(Ra+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ke;c[(Ra+16|0)>>2]=c[k>>2];c[(Ra+16|0)+4>>2]=c[k+4>>2];su(Ia,4,he,Ra);c[(a+96|0)+0>>2]=c[Ia+0>>2];c[(a+96|0)+4>>2]=c[Ia+4>>2];c[(a+96|0)+8>>2]=c[Ia+8>>2];Li(R,d,e,f,a+96|0);he=+h[R>>3];Ui(S,0,f);ke=+h[S>>3];c[Sa>>2]=1;je=+h[(tu(fa,1,Sa)|0)>>3];c[Ta>>2]=2;de=+h[(tu(fa,1,Ta)|0)>>3];c[Ua>>2]=3;le=+h[(tu(fa,1,Ua)|0)>>3];c[Va>>2]=4;me=+h[(tu(fa,1,Va)|0)>>3];h[k>>3]=de;c[Wa>>2]=c[k>>2];c[Wa+4>>2]=c[k+4>>2];h[k>>3]=le;c[(Wa+8|0)>>2]=c[k>>2];c[(Wa+8|0)+4>>2]=c[k+4>>2];h[k>>3]=me;c[(Wa+16|0)>>2]=c[k>>2];c[(Wa+16|0)+4>>2]=c[k+4>>2];su(Ja,4,je,Wa);c[(a+80|0)+0>>2]=c[Ja+0>>2];c[(a+80|0)+4>>2]=c[Ja+4>>2];c[(a+80|0)+8>>2]=c[Ja+8>>2];Gi(T,d,0.0,f,a+80|0);je=+h[T>>3];Wi(U,0,f);me=ee*ge*-3302150029884458.0e-20+(ae*be*-5121166806645226.0e-20+(fe*ie*-3637951105937136.0e-20+(he*ke*-32459312252092.0e-18+je*+h[U>>3]*-9112779762338704.0e-20)));c[Xa>>2]=1;je=+h[(tu(fa,1,Xa)|0)>>3];c[Ya>>2]=2;ke=+h[(tu(fa,1,Ya)|0)>>3];c[Za>>2]=3;he=+h[(tu(fa,1,Za)|0)>>3];c[_a>>2]=4;ie=+h[(tu(fa,1,_a)|0)>>3];h[k>>3]=ke;c[$a>>2]=c[k>>2];c[$a+4>>2]=c[k+4>>2];h[k>>3]=he;c[($a+8|0)>>2]=c[k>>2];c[($a+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ie;c[($a+16|0)>>2]=c[k>>2];c[($a+16|0)+4>>2]=c[k+4>>2];su(Ka,4,je,$a);c[(a+64|0)+0>>2]=c[Ka+0>>2];c[(a+64|0)+4>>2]=c[Ka+4>>2];c[(a+64|0)+8>>2]=c[Ka+8>>2];ui(V,d,e,f,a+64|0);je=+h[V>>3];Pi(W,0,f);ie=+h[W>>3];c[ab>>2]=1;he=+h[(tu(fa,1,ab)|0)>>3];c[bb>>2]=2;ke=+h[(tu(fa,1,bb)|0)>>3];c[cb>>2]=3;fe=+h[(tu(fa,1,cb)|0)>>3];c[db>>2]=4;be=+h[(tu(fa,1,db)|0)>>3];h[k>>3]=ke;c[eb>>2]=c[k>>2];c[eb+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(eb+8|0)>>2]=c[k>>2];c[(eb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(eb+16|0)>>2]=c[k>>2];c[(eb+16|0)+4>>2]=c[k+4>>2];su(La,4,he,eb);c[(a+48|0)+0>>2]=c[La+0>>2];c[(a+48|0)+4>>2]=c[La+4>>2];c[(a+48|0)+8>>2]=c[La+8>>2];Ii(X,d,e,f,a+48|0);he=+h[X>>3];Oi(Y,0,f);be=+h[Y>>3];c[fb>>2]=1;fe=+h[(tu(fa,1,fb)|0)>>3];c[gb>>2]=2;ke=+h[(tu(fa,1,gb)|0)>>3];c[hb>>2]=3;ae=+h[(tu(fa,1,hb)|0)>>3];c[ib>>2]=4;ge=+h[(tu(fa,1,ib)|0)>>3];h[k>>3]=ke;c[jb>>2]=c[k>>2];c[jb+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(jb+8|0)>>2]=c[k>>2];c[(jb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(jb+16|0)>>2]=c[k>>2];c[(jb+16|0)+4>>2]=c[k+4>>2];su(Ma,4,fe,jb);c[(a+32|0)+0>>2]=c[Ma+0>>2];c[(a+32|0)+4>>2]=c[Ma+4>>2];c[(a+32|0)+8>>2]=c[Ma+8>>2];Hi(Z,d,e,f,a+32|0);fe=+h[Z>>3];Fi(_,0,f);ge=+h[_>>3];c[kb>>2]=1;ae=+h[(tu(fa,1,kb)|0)>>3];c[lb>>2]=2;ke=+h[(tu(fa,1,lb)|0)>>3];c[mb>>2]=3;ee=+h[(tu(fa,1,mb)|0)>>3];c[nb>>2]=4;le=+h[(tu(fa,1,nb)|0)>>3];h[k>>3]=ke;c[ob>>2]=c[k>>2];c[ob+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(ob+8|0)>>2]=c[k>>2];c[(ob+8|0)+4>>2]=c[k+4>>2];h[k>>3]=le;c[(ob+16|0)>>2]=c[k>>2];c[(ob+16|0)+4>>2]=c[k+4>>2];su(Na,4,ae,ob);c[(a+16|0)+0>>2]=c[Na+0>>2];c[(a+16|0)+4>>2]=c[Na+4>>2];c[(a+16|0)+8>>2]=c[Na+8>>2];Li($,d,e,f,a+16|0);ae=+h[$>>3];Ui(aa,0,f);le=+h[aa>>3];c[pb>>2]=1;ee=+h[(tu(fa,1,pb)|0)>>3];c[qb>>2]=2;ke=+h[(tu(fa,1,qb)|0)>>3];c[rb>>2]=3;de=+h[(tu(fa,1,rb)|0)>>3];c[sb>>2]=4;ne=+h[(tu(fa,1,sb)|0)>>3];h[k>>3]=ke;c[tb>>2]=c[k>>2];c[tb+4>>2]=c[k+4>>2];h[k>>3]=de;c[(tb+8|0)>>2]=c[k>>2];c[(tb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ne;c[(tb+16|0)>>2]=c[k>>2];c[(tb+16|0)+4>>2]=c[k+4>>2];su(Oa,4,ee,tb);c[a+0>>2]=c[Oa+0>>2];c[a+4>>2]=c[Oa+4>>2];c[a+8>>2]=c[Oa+8>>2];Gi(ba,d,0.0,f,a);ee=+h[ba>>3];Wi(ca,0,f);ne=(je*ie*-3302150029884458.0e-20+(he*be*-5121166806645226.0e-20+(fe*ge*-3637951105937136.0e-20+(ae*le*-32459312252092.0e-18+ee*+h[ca>>3]*-9112779762338704.0e-20))))*f*-2.0;c[ub>>2]=1;ee=+h[(tu(ja,1,ub)|0)>>3];c[vb>>2]=2;le=+h[(tu(ja,1,vb)|0)>>3];c[wb>>2]=3;ae=+h[(tu(ja,1,wb)|0)>>3];c[xb>>2]=4;ge=+h[(tu(ja,1,xb)|0)>>3];c[yb>>2]=5;fe=ne-f*f*(ee+(le+(ae+(ge+ +h[(tu(ja,1,yb)|0)>>3]))));c[zb>>2]=6;h[(tu(ja,1,zb)|0)>>3]=fe;c[Ab>>2]=1;fe=+h[(tu(ha,1,Ab)|0)>>3]/.018015257;c[Bb>>2]=2;ge=+h[(tu(ha,1,Bb)|0)>>3]/.02801348;c[Cb>>2]=3;ae=+h[(tu(ha,1,Cb)|0)>>3]/.0319988;c[Db>>2]=4;le=ce*(fe+(ge+(ae+ +h[(tu(ha,1,Db)|0)>>3]/.039948)));c[Eb>>2]=1;ae=+h[(tu(ia,1,Eb)|0)>>3]/.018015257;c[Fb>>2]=2;ge=+h[(tu(ia,1,Fb)|0)>>3]/.02801348;c[Gb>>2]=3;fe=+h[(tu(ia,1,Gb)|0)>>3]/.0319988;c[Hb>>2]=4;ce=le+G*(ae+(ge+(fe+ +h[(tu(ia,1,Hb)|0)>>3]/.039948)));c[Ib>>2]=7;h[(tu(ja,1,Ib)|0)>>3]=ce;c[Jb>>2]=1;ce=+h[(tu(ha,1,Jb)|0)>>3]/.018015257;c[Kb>>2]=2;fe=+h[(tu(ha,1,Kb)|0)>>3]/.02801348;c[Lb>>2]=3;ge=+h[(tu(ha,1,Lb)|0)>>3]/.0319988;c[Mb>>2]=4;ae=G*(ce+(fe+(ge+ +h[(tu(ha,1,Mb)|0)>>3]/.039948)));c[Nb>>2]=6;ge=+h[(tu(ja,1,Nb)|0)>>3];c[Ob>>2]=1;fe=+h[(tu(ha,1,Ob)|0)>>3]/.018015257;c[Pb>>2]=2;ce=+h[(tu(ha,1,Pb)|0)>>3]/.02801348;c[Qb>>2]=3;le=+h[(tu(ha,1,Qb)|0)>>3]/.0319988;c[Rb>>2]=4;ee=ge*G*(fe+(ce+(le+ +h[(tu(ha,1,Rb)|0)>>3]/.039948)));c[(a+640|0)>>2]=7;h[b>>3]=(ee-me*+h[(tu(ja,1,a+640|0)|0)>>3])/(ae*ae);i=a;c[a+6160>>2]=5;break a}while(0)}



function ES(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=de[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=de[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ge[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){de[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=de[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function FS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=de[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=de[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=de[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ge[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ge[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=de[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=de[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ge[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ge[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){de[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function GS(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);if((f|0)==(c[27266]|0)){g=b;bY(g);i=d;return}ac(c[e>>2]|0);g=b;bY(g);i=d;return}function HS(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);if((b|0)==(c[27266]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function IS(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(se[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function JS(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);if((f|0)==(c[27266]|0)){g=b;bY(g);i=d;return}ac(c[e>>2]|0);g=b;bY(g);i=d;return}function KS(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);if((b|0)==(c[27266]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function LS(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;MS(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=se[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function MS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=YW(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){IT(110056)}else{c[e>>2]=d+(g<<2);i=j;return}}function NS(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function OS(a){a=a|0;i=i;return}function PS(a){a=a|0;i=i;return 127}function QS(a){a=a|0;i=i;return 127}function RS(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function SS(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function TS(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function US(a,b){a=a|0;b=b|0;b=i;MN(a,1,45);i=b;return}function VS(a){a=a|0;i=i;return 0}function WS(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function XS(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function YS(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function ZS(a){a=a|0;i=i;return}function _S(a){a=a|0;i=i;return 127}function $S(a){a=a|0;i=i;return 127}function aT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function bT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function cT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function dT(a,b){a=a|0;b=b|0;b=i;MN(a,1,45);i=b;return}function eT(a){a=a|0;i=i;return 0}function fT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function gT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function hT(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function iT(a){a=a|0;i=i;return}function jT(a){a=a|0;i=i;return 2147483647}function kT(a){a=a|0;i=i;return 2147483647}function lT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function mT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function oT(a,b){a=a|0;b=b|0;b=i;rO(a,1,45);i=b;return}function pT(a){a=a|0;i=i;return 0}function qT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function rT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function sT(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function tT(a){a=a|0;i=i;return}function uT(a){a=a|0;i=i;return 2147483647}function vT(a){a=a|0;i=i;return 2147483647}function wT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function xT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yT(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zT(a,b){a=a|0;b=b|0;b=i;rO(a,1,45);i=b;return}function AT(a){a=a|0;i=i;return 0}function BT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function CT(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function DT(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function ET(a){a=a|0;i=i;return}function FT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=203;y=o+100|0;MO(r,h);o=r;z=c[o>>2]|0;if(!((c[27294]|0)==-1)){c[n>>2]=109176;c[n+4>>2]=201;c[n+8>>2]=0;BN(109176,n,202)}n=(c[109180>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=HT(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ce[c[(c[z>>2]|0)+32>>2]&63](E,108792,108802|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=VX(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}gY()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[108792+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,108808,m|0)|0)!=1){t=Ec(8)|0;mN(t,108816);Od(t|0,106168,43)}if((F|0)==0){break}WX(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;gN(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ae[c[x>>2]&255](o);i=d;return}function GT(a){a=a|0;i=i;return}function HT(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;LT(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=203;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((de[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 0:{X=26;break};case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=(de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){de[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=(de[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ea=c[h>>2]|0;oa=c[ea+12>>2]|0;if((oa|0)==(c[ea+16>>2]|0)){Ia=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Ia=a[oa]|0}if(!(Ia<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Ia<<24>>24<<1)>>1]&8192)==0){X=25;break a}oa=c[h>>2]|0;ea=oa+12|0;qa=c[ea>>2]|0;if((qa|0)==(c[oa+16>>2]|0)){Ja=(de[c[(c[oa>>2]|0)+40>>2]&127](oa)|0)&255}else{c[ea>>2]=qa+1;Ja=a[qa]|0}gO(A,Ja);X=26;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Ka=(a[O]|0)!=0}else{Ka=0}if(!(I|Ka)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}qa=a[x]|0;ea=(qa&1)==0;oa=ea?j:c[J>>2]|0;c:do{if((p|0)==0){La=Y;Ma=Y;Na=qa;Oa=oa}else{if((d[s+(p+ -1)|0]|0)>=2){La=Y;Ma=Y;Na=qa;Oa=oa;break}ra=oa+(ea?(qa&255)>>>1:c[K>>2]|0)|0;sa=oa;while(1){if((sa|0)==(ra|0)){Pa=ra;break}pa=a[sa]|0;if(!(pa<<24>>24>-1)){Pa=sa;break}if((b[(c[f>>2]|0)+(pa<<24>>24<<1)>>1]&8192)==0){Pa=sa;break}else{sa=sa+1|0}}sa=Pa-oa|0;ra=a[A]|0;pa=(ra&1)==0;if(pa){Qa=(ra&255)>>>1}else{Qa=c[N>>2]|0}if(sa>>>0>Qa>>>0){La=Y;Ma=Y;Na=qa;Oa=oa;break}if(pa){pa=(ra&255)>>>1;Ra=A+1+(pa-sa)|0;Sa=L;Ta=pa}else{pa=c[M>>2]|0;ra=c[N>>2]|0;Ra=pa+(ra-sa)|0;Sa=pa;Ta=ra}ra=Sa+Ta|0;if((Ra|0)==(ra|0)){La=Y;Ma=Y;Na=qa;Oa=Pa;break}else{Ua=oa;Va=Ra}while(1){if((a[Va]|0)!=(a[Ua]|0)){La=Y;Ma=Y;Na=qa;Oa=oa;break c}pa=Va+1|0;if((pa|0)==(ra|0)){La=Y;Ma=Y;Na=qa;Oa=Pa;break}else{Ua=Ua+1|0;Va=pa}}}}while(0);d:while(1){if((Na&1)==0){Wa=j;Xa=(Na&255)>>>1}else{Wa=c[J>>2]|0;Xa=c[K>>2]|0}if((Oa|0)==(Wa+Xa|0)){break}qa=c[h>>2]|0;do{if((qa|0)==0){Ya=0}else{if((c[qa+12>>2]|0)!=(c[qa+16>>2]|0)){Ya=qa;break}if((de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)==-1){c[h>>2]=0;Ya=0;break}else{Ya=c[h>>2]|0;break}}}while(0);qa=(Ya|0)==0;do{if((Ma|0)==0){Za=La;X=147}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(qa){_a=La;$a=Ma;break}else{break d}}if((de[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;Za=0;X=147;break}else{if(qa^(La|0)==0){_a=La;$a=La;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(qa){break}else{_a=Za;$a=0}}oa=c[h>>2]|0;ea=c[oa+12>>2]|0;if((ea|0)==(c[oa+16>>2]|0)){ab=(de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255}else{ab=a[ea]|0}if(!(ab<<24>>24==(a[Oa]|0))){break}ea=c[h>>2]|0;oa=ea+12|0;W=c[oa>>2]|0;if((W|0)==(c[ea+16>>2]|0)){de[c[(c[ea>>2]|0)+40>>2]&127](ea)|0}else{c[oa>>2]=W+1}La=_a;Ma=$a;Na=a[x]|0;Oa=Oa+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}W=a[x]|0;if((W&1)==0){bb=j;cb=(W&255)>>>1}else{bb=c[J>>2]|0;cb=c[K>>2]|0}if((Oa|0)==(bb+cb|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 4:{W=D;oa=R;ea=r;da=Q;ba=0;ra=T;e:while(1){pa=c[h>>2]|0;do{if((pa|0)==0){db=0}else{if((c[pa+12>>2]|0)!=(c[pa+16>>2]|0)){db=pa;break}if((de[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)==-1){c[h>>2]=0;db=0;break}else{db=c[h>>2]|0;break}}}while(0);pa=(db|0)==0;qa=c[e>>2]|0;do{if((qa|0)==0){X=173}else{if((c[qa+12>>2]|0)!=(c[qa+16>>2]|0)){if(pa){break}else{break e}}if((de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)==-1){c[e>>2]=0;X=173;break}else{if(pa){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(pa){break}}qa=c[h>>2]|0;sa=c[qa+12>>2]|0;if((sa|0)==(c[qa+16>>2]|0)){eb=(de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255}else{eb=a[sa]|0}do{if(eb<<24>>24>-1){if((b[(c[f>>2]|0)+(eb<<24>>24<<1)>>1]&2048)==0){X=189;break}sa=c[o>>2]|0;if((sa|0)==(W|0)){qa=(c[P>>2]|0)!=203;fb=c[t>>2]|0;gb=W-fb|0;hb=gb>>>0<2147483647?gb<<1:-1;ib=YX(qa?fb:0,hb)|0;if((ib|0)==0){X=182;break a}do{if(qa){c[t>>2]=ib;jb=ib}else{fb=c[t>>2]|0;c[t>>2]=ib;if((fb|0)==0){jb=ib;break}ae[c[P>>2]&255](fb);jb=c[t>>2]|0}}while(0);c[P>>2]=178;ib=jb+gb|0;c[o>>2]=ib;kb=ib;lb=(c[t>>2]|0)+hb|0}else{kb=sa;lb=W}c[o>>2]=kb+1;a[kb]=eb;mb=lb;nb=oa;ob=ea;pb=da;qb=ba+1|0;rb=ra}else{X=189}}while(0);if((X|0)==189){X=0;pa=a[w]|0;if((pa&1)==0){sb=(pa&255)>>>1}else{sb=c[n>>2]|0}if((sb|0)==0|(ba|0)==0){break}if(!(eb<<24>>24==(a[v]|0))){break}if((ea|0)==(da|0)){pa=ea-oa|0;ib=pa>>>0<2147483647?pa<<1:-1;if((ra|0)==203){tb=0}else{tb=oa}qa=YX(tb,ib)|0;if((qa|0)==0){X=198;break a}ub=qa;vb=qa+(pa>>2<<2)|0;wb=qa+(ib>>>2<<2)|0;xb=178}else{ub=oa;vb=ea;wb=da;xb=ra}c[vb>>2]=ba;mb=W;nb=ub;ob=vb+4|0;pb=wb;qb=0;rb=xb}ib=c[h>>2]|0;qa=ib+12|0;pa=c[qa>>2]|0;if((pa|0)==(c[ib+16>>2]|0)){de[c[(c[ib>>2]|0)+40>>2]&127](ib)|0;W=mb;oa=nb;ea=ob;da=pb;ba=qb;ra=rb;continue}else{c[qa>>2]=pa+1;W=mb;oa=nb;ea=ob;da=pb;ba=qb;ra=rb;continue}}if((oa|0)==(ea|0)|(ba|0)==0){yb=oa;zb=ea;Ab=da;Bb=ra}else{if((ea|0)==(da|0)){pa=ea-oa|0;qa=pa>>>0<2147483647?pa<<1:-1;if((ra|0)==203){Cb=0}else{Cb=oa}ib=YX(Cb,qa)|0;if((ib|0)==0){X=209;break a}Db=ib;Eb=ib+(pa>>2<<2)|0;Fb=ib+(qa>>>2<<2)|0;Gb=178}else{Db=oa;Eb=ea;Fb=da;Gb=ra}c[Eb>>2]=ba;yb=Db;zb=Eb+4|0;Ab=Fb;Bb=Gb}if((c[B>>2]|0)>0){qa=c[h>>2]|0;do{if((qa|0)==0){Hb=0}else{if((c[qa+12>>2]|0)!=(c[qa+16>>2]|0)){Hb=qa;break}if((de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)==-1){c[h>>2]=0;Hb=0;break}else{Hb=c[h>>2]|0;break}}}while(0);qa=(Hb|0)==0;ba=c[e>>2]|0;do{if((ba|0)==0){X=223}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){if(qa){Ib=ba;break}else{X=229;break a}}if((de[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[e>>2]=0;X=223;break}else{if(qa){Ib=ba;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(qa){X=229;break a}else{Ib=0}}ba=c[h>>2]|0;ra=c[ba+12>>2]|0;if((ra|0)==(c[ba+16>>2]|0)){Jb=(de[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Jb=a[ra]|0}if(!(Jb<<24>>24==(a[u]|0))){X=229;break a}ra=c[h>>2]|0;ba=ra+12|0;da=c[ba>>2]|0;if((da|0)==(c[ra+16>>2]|0)){de[c[(c[ra>>2]|0)+40>>2]&127](ra)|0;Kb=Ib;Lb=Ib;Mb=W}else{c[ba>>2]=da+1;Kb=Ib;Lb=Ib;Mb=W}while(1){da=c[h>>2]|0;do{if((da|0)==0){Nb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Nb=da;break}if((de[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Nb=0;break}else{Nb=c[h>>2]|0;break}}}while(0);da=(Nb|0)==0;do{if((Lb|0)==0){Ob=Kb;X=243}else{if((c[Lb+12>>2]|0)!=(c[Lb+16>>2]|0)){if(da){Pb=Kb;Qb=Lb;break}else{X=250;break a}}if((de[c[(c[Lb>>2]|0)+36>>2]&127](Lb)|0)==-1){c[e>>2]=0;Ob=0;X=243;break}else{if(da^(Kb|0)==0){Pb=Kb;Qb=Kb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(da){X=250;break a}else{Pb=Ob;Qb=0}}ba=c[h>>2]|0;ra=c[ba+12>>2]|0;if((ra|0)==(c[ba+16>>2]|0)){Rb=(de[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Rb=a[ra]|0}if(!(Rb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Rb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ra=c[o>>2]|0;if((ra|0)==(Mb|0)){ba=(c[P>>2]|0)!=203;ea=c[t>>2]|0;oa=Mb-ea|0;ib=oa>>>0<2147483647?oa<<1:-1;pa=YX(ba?ea:0,ib)|0;if((pa|0)==0){X=253;break a}do{if(ba){c[t>>2]=pa;Sb=pa}else{ea=c[t>>2]|0;c[t>>2]=pa;if((ea|0)==0){Sb=pa;break}ae[c[P>>2]&255](ea);Sb=c[t>>2]|0}}while(0);c[P>>2]=178;pa=Sb+oa|0;c[o>>2]=pa;Tb=pa;Ub=(c[t>>2]|0)+ib|0}else{Tb=ra;Ub=Mb}pa=c[h>>2]|0;ba=c[pa+12>>2]|0;if((ba|0)==(c[pa+16>>2]|0)){da=(de[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255;Vb=da;Wb=c[o>>2]|0}else{Vb=a[ba]|0;Wb=Tb}c[o>>2]=Wb+1;a[Wb]=Vb;ba=(c[B>>2]|0)+ -1|0;c[B>>2]=ba;da=c[h>>2]|0;pa=da+12|0;ea=c[pa>>2]|0;if((ea|0)==(c[da+16>>2]|0)){de[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[pa>>2]=ea+1}if((ba|0)>0){Kb=Pb;Lb=Qb;Mb=Ub}else{Xb=Ub;break}}}else{Xb=W}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Xb;ha=yb;ia=zb;ja=Ab;ka=S;la=Bb}break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{Yb=Y;Zb=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){_b=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){_b=U;break}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;_b=0;break}else{_b=c[h>>2]|0;break}}}while(0);U=(_b|0)==0;do{if((Zb|0)==0){$b=Yb;X=37}else{if((c[Zb+12>>2]|0)!=(c[Zb+16>>2]|0)){if(U){ac=Yb;bc=Zb;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((de[c[(c[Zb>>2]|0)+36>>2]&127](Zb)|0)==-1){c[e>>2]=0;$b=0;X=37;break}else{if(U^(Yb|0)==0){ac=Yb;bc=Yb;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{ac=$b;bc=0}}ra=c[h>>2]|0;ib=c[ra+12>>2]|0;if((ib|0)==(c[ra+16>>2]|0)){cc=(de[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{cc=a[ib]|0}if(!(cc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(cc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}ib=c[h>>2]|0;ra=ib+12|0;oa=c[ra>>2]|0;if((oa|0)==(c[ib+16>>2]|0)){dc=(de[c[(c[ib>>2]|0)+40>>2]&127](ib)|0)&255}else{c[ra>>2]=oa+1;dc=a[oa]|0}gO(A,dc);Yb=ac;Zb=bc}}}while(0);W=p+1|0;if(W>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=W;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==182){gY()}else if((X|0)==198){gY()}else if((X|0)==209){gY()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==253){gY()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){hc=(S&255)>>>1}else{hc=c[ia>>2]|0}if(!(ha>>>0<hc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){ic=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){ic=S;break}if((de[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;ic=0;break}else{ic=c[h>>2]|0;break}}}while(0);S=(ic|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){jc=(de[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{jc=a[p]|0}if((a[$]&1)==0){kc=la}else{kc=c[ka>>2]|0}if(!(jc<<24>>24==(a[kc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){de[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa;break g}}while(0);if((Z|0)==(_|0)){ec=1;fc=_;gc=aa;break}c[C>>2]=0;MT(w,Z,_,C);if((c[C>>2]|0)==0){ec=1;fc=Z;gc=aa;break}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa}}while(0);QN(A);QN(z);QN(y);QN(x);QN(w);if((fc|0)==0){i=q;return ec|0}ae[gc&255](fc);i=q;return ec|0}function IT(a){a=a|0;var b=0;b=Ec(8)|0;mN(b,a);Od(b|0,106168,43)}function JT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=203;v=n+100|0;MO(q,h);n=q;w=c[n>>2]|0;if(!((c[27294]|0)==-1)){c[m>>2]=109176;c[m+4>>2]=201;c[m+8>>2]=0;BN(109176,m,202)}m=(c[109180>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;AX(z);A=124736;B=128;Od(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;AX(z);A=124736;B=128;Od(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=HT(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){gO(k,se[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=se[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);KT(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((de[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;gN(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ae[c[u>>2]&255](n);i=d;return}function KT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){jO(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function LT(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[27154]|0)==-1)){c[p>>2]=108616;c[p+4>>2]=201;c[p+8>>2]=0;BN(108616,p,202)}p=(c[108620>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}E=b;be[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;be[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aO(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QN(r);be[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aO(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QN(s);a[f]=de[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=de[c[(c[b>>2]|0)+16>>2]&127](E)|0;be[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aO(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QN(t);be[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aO(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QN(u);F=de[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[27138]|0)==-1)){c[o>>2]=108552;c[o+4>>2]=201;c[o+8>>2]=0;BN(108552,o,202)}o=(c[108556>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}J=E;be[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;be[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aO(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;QN(w);be[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aO(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;QN(x);a[f]=de[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=de[c[(c[E>>2]|0)+16>>2]&127](J)|0;be[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aO(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;QN(y);be[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aO(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QN(z);F=de[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function MT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function NT(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function OT(a){a=a|0;i=i;return}function PT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=203;y=o+400|0;MO(r,h);o=r;z=c[o>>2]|0;if(!((c[27292]|0)==-1)){c[n>>2]=109168;c[n+4>>2]=201;c[n+8>>2]=0;BN(109168,n,202)}n=(c[109172>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=QT(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ce[c[(c[z>>2]|0)+48>>2]&63](E,108872,108882|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=VX((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}gY()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[108872+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,108808,m|0)|0)!=1){t=Ec(8)|0;mN(t,108816);Od(t|0,106168,43)}if((F|0)==0){break}WX(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=de[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];gN(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ae[c[x>>2]&255](o);i=d;return}function QT(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;TT(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=203;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 0:{T=28;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=de[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=de[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=de[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){de[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){Ka=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Ka=c[R>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,Ka)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;na=c[P>>2]|0;if((na|0)==(c[R+16>>2]|0)){La=de[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=na+4;La=c[na>>2]|0}wO(A,La);T=28;break};case 4:{na=M;P=r;R=L;oa=0;pa=O;f:while(1){qa=c[g>>2]|0;do{if((qa|0)==0){Ma=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Na=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Na=c[wa>>2]|0}if((Na|0)==-1){c[g>>2]=0;Ma=1;break}else{Ma=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=188}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Oa=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Oa=c[wa>>2]|0}if((Oa|0)==-1){c[b>>2]=0;T=188;break}else{if(Ma){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(Ma){break}}qa=c[g>>2]|0;wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Pa=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Pa=c[wa>>2]|0}if(ge[c[(c[l>>2]|0)+12>>2]&63](l,2048,Pa)|0){wa=c[n>>2]|0;if((wa|0)==(c[q>>2]|0)){UT(m,n,q);Qa=c[n>>2]|0}else{Qa=wa}c[n>>2]=Qa+4;c[Qa>>2]=Pa;Ra=na;Sa=P;Ta=R;Ua=oa+1|0;Va=pa}else{wa=a[w]|0;if((wa&1)==0){Wa=(wa&255)>>>1}else{Wa=c[K>>2]|0}if((Wa|0)==0|(oa|0)==0){break}if((Pa|0)!=(c[v>>2]|0)){break}if((P|0)==(R|0)){wa=P-na|0;qa=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=203){Xa=na}else{Xa=0}va=YX(Xa,qa)|0;if((va|0)==0){T=206;break a}Ya=va;Za=va+(wa>>2<<2)|0;_a=va+(qa>>>2<<2)|0;$a=178}else{Ya=na;Za=P;_a=R;$a=pa}c[Za>>2]=oa;Ra=Ya;Sa=Za+4|0;Ta=_a;Ua=0;Va=$a}qa=c[g>>2]|0;va=qa+12|0;wa=c[va>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;na=Ra;P=Sa;R=Ta;oa=Ua;pa=Va;continue}else{c[va>>2]=wa+4;na=Ra;P=Sa;R=Ta;oa=Ua;pa=Va;continue}}if((na|0)==(P|0)|(oa|0)==0){ab=na;bb=P;cb=R;db=pa}else{if((P|0)==(R|0)){wa=P-na|0;va=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=203){eb=na}else{eb=0}qa=YX(eb,va)|0;if((qa|0)==0){T=217;break a}fb=qa;gb=qa+(wa>>2<<2)|0;hb=qa+(va>>>2<<2)|0;ib=178}else{fb=na;gb=P;hb=R;ib=pa}c[gb>>2]=oa;ab=fb;bb=gb+4|0;cb=hb;db=ib}va=c[B>>2]|0;if((va|0)>0){qa=c[g>>2]|0;do{if((qa|0)==0){jb=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){kb=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{kb=c[wa>>2]|0}if((kb|0)==-1){c[g>>2]=0;jb=1;break}else{jb=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=234}else{oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){lb=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{lb=c[oa>>2]|0}if((lb|0)==-1){c[b>>2]=0;T=234;break}else{if(jb){mb=qa;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(jb){T=240;break a}else{mb=0}}qa=c[g>>2]|0;oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){nb=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{nb=c[oa>>2]|0}if((nb|0)!=(c[u>>2]|0)){T=240;break a}oa=c[g>>2]|0;qa=oa+12|0;pa=c[qa>>2]|0;if((pa|0)==(c[oa+16>>2]|0)){de[c[(c[oa>>2]|0)+40>>2]&127](oa)|0;ob=mb;pb=va;qb=mb}else{c[qa>>2]=pa+4;ob=mb;pb=va;qb=mb}while(1){pa=c[g>>2]|0;do{if((pa|0)==0){rb=1}else{qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){sb=de[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{sb=c[qa>>2]|0}if((sb|0)==-1){c[g>>2]=0;rb=1;break}else{rb=(c[g>>2]|0)==0;break}}}while(0);do{if((qb|0)==0){tb=ob;T=257}else{pa=c[qb+12>>2]|0;if((pa|0)==(c[qb+16>>2]|0)){ub=de[c[(c[qb>>2]|0)+36>>2]&127](qb)|0}else{ub=c[pa>>2]|0}if((ub|0)==-1){c[b>>2]=0;tb=0;T=257;break}else{if(rb^(ob|0)==0){vb=ob;wb=ob;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(rb){T=263;break a}else{vb=tb;wb=0}}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){xb=de[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{xb=c[qa>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,2048,xb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){UT(m,n,q)}qa=c[g>>2]|0;pa=c[qa+12>>2]|0;if((pa|0)==(c[qa+16>>2]|0)){yb=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{yb=c[pa>>2]|0}pa=c[n>>2]|0;c[n>>2]=pa+4;c[pa>>2]=yb;pa=pb+ -1|0;c[B>>2]=pa;qa=c[g>>2]|0;oa=qa+12|0;R=c[oa>>2]|0;if((R|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=R+4}if((pa|0)>0){ob=vb;pb=pa;qb=wb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=ab;aa=bb;ba=cb;ca=N;da=db}break};case 3:{va=a[y]|0;pa=(va&1)==0;if(pa){zb=(va&255)>>>1}else{zb=c[D>>2]|0}R=a[z]|0;oa=(R&1)==0;if(oa){Ab=(R&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(pa){Bb=(va&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(oa){Cb=(R&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}qa=c[g>>2]|0;P=c[qa+12>>2]|0;if((P|0)==(c[qa+16>>2]|0)){na=de[c[(c[qa>>2]|0)+36>>2]&127](qa)|0;Db=na;Eb=a[y]|0}else{Db=c[P>>2]|0;Eb=va}P=c[g>>2]|0;na=P+12|0;qa=c[na>>2]|0;wa=(qa|0)==(c[P+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if(wa){de[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[na>>2]=qa+4}na=a[y]|0;if((na&1)==0){Fb=(na&255)>>>1}else{Fb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Fb>>>0>1?y:N;da=O;break b}if(wa){Gb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Gb=c[qa>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}qa=c[g>>2]|0;P=qa+12|0;wa=c[P>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[P>>2]=wa+4}a[k]=1;wa=a[z]|0;if((wa&1)==0){Hb=(wa&255)>>>1}else{Hb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Hb>>>0>1?z:N;da=O;break b}}while(0);if(pa){Ib=(va&255)>>>1}else{Ib=c[D>>2]|0}oa=c[g>>2]|0;wa=c[oa+12>>2]|0;P=(wa|0)==(c[oa+16>>2]|0);if((Ib|0)==0){if(P){qa=de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Jb=qa;Kb=a[z]|0}else{Jb=c[wa>>2]|0;Kb=R}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}qa=c[g>>2]|0;na=qa+12|0;Lb=c[na>>2]|0;if((Lb|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[na>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Mb>>>0>1?z:N;da=O;break b}if(P){P=de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Nb=P;Ob=a[y]|0}else{Nb=c[wa>>2]|0;Ob=va}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}wa=c[g>>2]|0;P=wa+12|0;oa=c[P>>2]|0;if((oa|0)==(c[wa+16>>2]|0)){de[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[P>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){Pb=(oa&255)>>>1}else{Pb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Pb>>>0>1?y:N;da=O;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){oa=c[g>>2]|0;do{if((oa|0)==0){Sb=1}else{P=c[oa+12>>2]|0;if((P|0)==(c[oa+16>>2]|0)){Tb=de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Tb=c[P>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{oa=c[Rb+12>>2]|0;if((oa|0)==(c[Rb+16>>2]|0)){Vb=de[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[oa>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Wb=Ub;Xb=0}}oa=c[g>>2]|0;P=c[oa+12>>2]|0;if((P|0)==(c[oa+16>>2]|0)){Yb=de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Yb=c[P>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}P=c[g>>2]|0;oa=P+12|0;wa=c[oa>>2]|0;if((wa|0)==(c[P+16>>2]|0)){Zb=de[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[oa>>2]=wa+4;Zb=c[wa>>2]|0}wO(A,Zb);Qb=Wb;Rb=Xb}}}while(0);va=o+1|0;if(va>>>0<4){L=ba;r=aa;M=$;o=va;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){gY()}else if((T|0)==217){gY()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=ab;ac=db}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=ab;ac=db}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=ab;ac=db}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){bc=($&255)>>>1}else{bc=c[da>>2]|0}if(!(aa>>>0<bc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){cc=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){dc=de[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){ec=de[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=de[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=da}else{gc=c[ca>>2]|0}if((fc|0)!=(c[gc+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){de[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;MT(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);sO(A);sO(z);sO(y);sO(x);QN(w);if(($b|0)==0){i=p;return _b|0}ae[ac&255]($b);i=p;return _b|0}function RT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=203;v=n+400|0;MO(q,h);n=q;w=c[n>>2]|0;if(!((c[27292]|0)==-1)){c[m>>2]=109168;c[m+4>>2]=201;c[m+8>>2]=0;BN(109168,m,202)}m=(c[109172>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;AX(z);A=124736;B=128;Od(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;AX(z);A=124736;B=128;Od(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=QT(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){wO(k,se[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=se[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);ST(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=de[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];gN(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ae[c[u>>2]&255](n);i=d;return}function ST(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){yO(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function TT(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[27186]|0)==-1)){c[p>>2]=108744;c[p+4>>2]=201;c[p+8>>2]=0;BN(108744,p,202)}p=(c[108748>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;AX(C);D=124736;E=128;Od(B|0,D|0,E|0)}E=b;be[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;be[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vO(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sO(r);be[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vO(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sO(s);c[f>>2]=de[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=de[c[(c[b>>2]|0)+16>>2]&127](E)|0;be[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aO(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;QN(t);be[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}vO(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;sO(u);F=de[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[27170]|0)==-1)){c[o>>2]=108680;c[o+4>>2]=201;c[o+8>>2]=0;BN(108680,o,202)}o=(c[108684>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;AX(H);I=124736;J=128;Od(G|0,I|0,J|0)}J=E;be[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;be[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vO(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;sO(w);be[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vO(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;sO(x);c[f>>2]=de[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=de[c[(c[E>>2]|0)+16>>2]&127](J)|0;be[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}aO(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;QN(y);be[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}vO(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;sO(z);F=de[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function UT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=203;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=YX(m,l)|0;m=a;if((a|0)==0){gY()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}ae[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=178;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function VT(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function WT(a){a=a|0;i=i;return}function XT(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,108928,o|0)|0;do{if(s>>>0>99){do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);o=c[27266]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=PR(r,o,108928,n)|0;o=c[r>>2]|0;if((o|0)==0){gY()}H=VX(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}gY()}else{I=0;J=0;K=q;L=s}}while(0);MO(t,g);s=t;q=c[s>>2]|0;if(!((c[27294]|0)==-1)){c[p>>2]=109176;c[p+4>>2]=201;c[p+8>>2]=0;BN(109176,p,202)}p=(c[109180>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;AX(N);O=124736;P=128;Od(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;AX(N);O=124736;P=128;Od(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ce[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;YT(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=VX(V)|0;if((T|0)!=0){W=T;X=T;break}gY()}else{W=0;X=t}}while(0);ZT(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];mK(b,m,X,e,D,g,j);if((W|0)!=0){WX(W)}QN(A);QN(z);QN(y);gN(c[s>>2]|0)|0;if((J|0)!=0){WX(J)}if((I|0)==0){i=d;return}WX(I);i=d;return}function YT(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[27154]|0)==-1)){c[p>>2]=108616;c[p+4>>2]=201;c[p+8>>2]=0;BN(108616,p,202)}p=(c[108620>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;AX(I);J=124736;K=128;Od(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;AX(I);J=124736;K=128;Od(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){be[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;be[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aO(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;QN(s)}else{be[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;be[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aO(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QN(v)}a[g]=de[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=de[c[(c[e>>2]|0)+16>>2]&127](K)|0;be[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aO(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QN(w);be[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aO(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QN(x);L=de[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[27138]|0)==-1)){c[o>>2]=108552;c[o+4>>2]=201;c[o+8>>2]=0;BN(108552,o,202)}o=(c[108556>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;AX(N);O=124736;P=128;Od(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;AX(N);O=124736;P=128;Od(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){be[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;be[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aO(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;QN(A)}else{be[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;be[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}aO(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;QN(D)}a[g]=de[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=de[c[(c[G>>2]|0)+16>>2]&127](P)|0;be[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aO(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QN(E);be[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}aO(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;QN(F);L=de[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function ZT(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 1:{c[e>>2]=c[f>>2];J=se[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 4:{J=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){N=I;while(1){O=a[N]|0;if(!(O<<24>>24>-1)){P=N;break b}Q=N+1|0;if((b[(c[F>>2]|0)+(O<<24>>24<<1)>>1]&2048)==0){P=N;break b}if(Q>>>0<j>>>0){N=Q}else{P=Q;break}}}else{P=I}}while(0);N=P;if(B){if(P>>>0>I>>>0){Q=I+(0-N)|0;N=Q>>>0<G>>>0?G:Q;Q=N+s|0;O=J;R=P;S=s;while(1){T=R+ -1|0;U=a[T]|0;c[f>>2]=O+1;a[O]=U;U=S+ -1|0;V=(U|0)>0;if(!(T>>>0>I>>>0&V)){break}O=c[f>>2]|0;S=U;R=T}R=P+N|0;if(V){W=R;X=Q;Y=32}else{Z=0;_=R;$=Q}}else{W=P;X=s;Y=32}if((Y|0)==32){Y=0;Z=se[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;_=W;$=X}R=c[f>>2]|0;c[f>>2]=R+1;if(($|0)>0){S=R;O=$;while(1){a[S]=Z;T=O+ -1|0;U=c[f>>2]|0;c[f>>2]=U+1;if((T|0)>0){O=T;S=U}else{aa=U;break}}}else{aa=R}a[aa]=n;ba=_}else{ba=P}if((ba|0)==(I|0)){S=se[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;O=c[f>>2]|0;c[f>>2]=O+1;a[O]=S}else{S=a[p]|0;O=(S&1)==0;if(O){ca=(S&255)>>>1}else{ca=c[E>>2]|0}if((ca|0)==0){da=ba;ea=-1;fa=0;ga=0}else{if(O){ha=C}else{ha=c[D>>2]|0}da=ba;ea=a[ha]|0;fa=0;ga=0}while(1){do{if((ga|0)==(ea|0)){O=c[f>>2]|0;c[f>>2]=O+1;a[O]=o;O=fa+1|0;S=a[p]|0;Q=(S&1)==0;if(Q){ia=(S&255)>>>1}else{ia=c[E>>2]|0}if(!(O>>>0<ia>>>0)){ja=ea;ka=O;la=0;break}if(Q){ma=C}else{ma=c[D>>2]|0}if((a[ma+O|0]|0)==127){ja=-1;ka=O;la=0;break}if(Q){na=C}else{na=c[D>>2]|0}ja=a[na+O|0]|0;ka=O;la=0}else{ja=ea;ka=fa;la=ga}}while(0);O=da+ -1|0;Q=a[O]|0;S=c[f>>2]|0;c[f>>2]=S+1;a[S]=Q;if((O|0)==(I|0)){break}else{da=O;ea=ja;fa=ka;ga=la+1|0}}}R=c[f>>2]|0;if((J|0)==(R|0)){L=I;break a}O=R+ -1|0;if(O>>>0>J>>>0){oa=J;pa=O}else{L=I;break a}while(1){O=a[oa]|0;a[oa]=a[pa]|0;a[pa]=O;O=oa+1|0;R=pa+ -1|0;if(O>>>0<R>>>0){pa=R;oa=O}else{L=I;break}}break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){qa=(I&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){L=H;break a}if(J){ra=y;sa=(I&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}I=ra+sa|0;J=c[f>>2]|0;if((ra|0)==(I|0)){ta=J}else{O=J;J=ra;while(1){a[O]=a[J]|0;R=J+1|0;Q=O+1|0;if((R|0)==(I|0)){ta=Q;break}else{J=R;O=Q}}}c[f>>2]=ta;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};default:{L=H}}}while(0);O=h+1|0;if(O>>>0<4){H=L;h=O}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function _T(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;MO(m,g);z=m;A=c[z>>2]|0;if(!((c[27294]|0)==-1)){c[l>>2]=109176;c[l+4>>2]=201;c[l+8>>2]=0;BN(109176,l,202)}l=(c[109180>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(se[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;YT(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=VX(P)|0;if((N|0)!=0){Q=N;R=N;break}gY()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}ZT(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];mK(b,k,R,e,w,g,h);if((Q|0)==0){QN(t);QN(s);QN(r);U=c[z>>2]|0;V=U;W=V;X=gN(W)|0;i=d;return}WX(Q);QN(t);QN(s);QN(r);U=c[z>>2]|0;V=U;W=V;X=gN(W)|0;i=d;return}function $T(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function aU(a){a=a|0;i=i;return}function bU(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,108928,o|0)|0;do{if(s>>>0>99){do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);o=c[27266]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=PR(r,o,108928,n)|0;o=c[r>>2]|0;if((o|0)==0){gY()}H=VX(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}gY()}else{J=0;K=0;L=q;M=s}}while(0);MO(t,g);s=t;q=c[s>>2]|0;if(!((c[27292]|0)==-1)){c[p>>2]=109168;c[p+4>>2]=201;c[p+8>>2]=0;BN(109168,p,202)}p=(c[109172>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;AX(O);P=124736;Q=128;Od(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;AX(O);P=124736;Q=128;Od(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ce[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cU(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=VX(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}gY()}else{X=0;Y=t}}while(0);dU(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];YR(b,m,Y,e,D,g,j);if((X|0)!=0){WX(X)}sO(A);sO(z);QN(y);gN(c[s>>2]|0)|0;if((K|0)!=0){WX(K)}if((J|0)==0){i=d;return}WX(J);i=d;return}function cU(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[27186]|0)==-1)){c[p>>2]=108744;c[p+4>>2]=201;c[p+8>>2]=0;BN(108744,p,202)}p=(c[108748>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;AX(I);J=124736;K=128;Od(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;AX(I);J=124736;K=128;Od(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){be[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;be[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vO(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;sO(s)}else{be[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;be[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vO(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sO(v)}c[g>>2]=de[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=de[c[(c[e>>2]|0)+16>>2]&127](K)|0;be[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aO(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;QN(w);be[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vO(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sO(x);L=de[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[27170]|0)==-1)){c[o>>2]=108680;c[o+4>>2]=201;c[o+8>>2]=0;BN(108680,o,202)}o=(c[108684>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;AX(N);O=124736;P=128;Od(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;AX(N);O=124736;P=128;Od(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){be[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;be[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vO(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;sO(A)}else{be[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;be[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}vO(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;sO(D)}c[g>>2]=de[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=de[c[(c[G>>2]|0)+16>>2]&127](P)|0;be[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}aO(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;QN(E);be[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}vO(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;sO(F);L=de[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function dU(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 4:{E=c[e>>2]|0;F=k?C+4|0:C;b:do{if(F>>>0<h>>>0){G=F;while(1){H=G+4|0;if(!(ge[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[G>>2]|0)|0)){I=G;break b}if(H>>>0<h>>>0){G=H}else{I=H;break}}}else{I=F}}while(0);if(y){do{if(I>>>0>F>>>0){G=c[e>>2]|0;H=I;J=r;while(1){K=H+ -4|0;L=G+4|0;c[G>>2]=c[K>>2];M=J+ -1|0;N=(M|0)>0;if(K>>>0>F>>>0&N){J=M;H=K;G=L}else{break}}c[e>>2]=L;if(N){O=K;P=M;Q=34;break}G=c[e>>2]|0;c[e>>2]=G+4;R=G;S=K}else{O=I;P=r;Q=34}}while(0);do{if((Q|0)==34){Q=0;G=se[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;H=c[e>>2]|0;J=H+4|0;c[e>>2]=J;if((P|0)>0){T=J;U=H;V=P}else{R=H;S=O;break}while(1){c[U>>2]=G;J=V+ -1|0;if((J|0)>0){V=J;U=T;T=T+4|0}else{break}}c[e>>2]=H+(P+1<<2);R=H+(P<<2)|0;S=O}}while(0);c[R>>2]=m;W=S}else{W=I}if((W|0)==(F|0)){G=se[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;J=c[e>>2]|0;X=J+4|0;c[e>>2]=X;c[J>>2]=G;Y=X}else{X=a[o]|0;G=(X&1)==0;if(G){Z=(X&255)>>>1}else{Z=c[B>>2]|0}if((Z|0)==0){_=W;$=-1;aa=0;ba=0}else{if(G){ca=z}else{ca=c[A>>2]|0}_=W;$=a[ca]|0;aa=0;ba=0}while(1){G=c[e>>2]|0;do{if((ba|0)==($|0)){X=G+4|0;c[e>>2]=X;c[G>>2]=n;J=aa+1|0;da=a[o]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[B>>2]|0}if(!(J>>>0<fa>>>0)){ga=X;ha=$;ia=J;ja=0;break}if(ea){ka=z}else{ka=c[A>>2]|0}if((a[ka+J|0]|0)==127){ga=X;ha=-1;ia=J;ja=0;break}if(ea){la=z}else{la=c[A>>2]|0}ga=X;ha=a[la+J|0]|0;ia=J;ja=0}else{ga=G;ha=$;ia=aa;ja=ba}}while(0);G=_+ -4|0;H=c[G>>2]|0;J=ga+4|0;c[e>>2]=J;c[ga>>2]=H;if((G|0)==(F|0)){Y=J;break}else{_=G;$=ha;aa=ia;ba=ja+1|0}}}if((E|0)==(Y|0)){D=F;break a}G=Y+ -4|0;if(G>>>0>E>>>0){ma=E;na=G}else{D=F;break a}while(1){G=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=G;G=ma+4|0;J=na+ -4|0;if(G>>>0<J>>>0){na=J;ma=G}else{D=F;break}}break};case 2:{F=a[p]|0;E=(F&1)==0;if(E){oa=(F&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0|v){D=C;break a}if(E){pa=w;qa=(F&255)>>>1}else{pa=c[x>>2]|0;qa=c[w>>2]|0}F=pa+(qa<<2)|0;E=c[e>>2]|0;if((pa|0)==(F|0)){ra=E}else{G=(pa+(qa+ -1<<2)+(0-pa)|0)>>>2;J=E;H=pa;while(1){c[J>>2]=c[H>>2];X=H+4|0;if((X|0)==(F|0)){break}J=J+4|0;H=X}ra=E+(G+1<<2)|0}c[e>>2]=ra;D=C;break};case 3:{H=a[q]|0;J=(H&1)==0;if(J){sa=(H&255)>>>1}else{sa=c[t>>2]|0}if((sa|0)==0){D=C;break a}if(J){ta=t}else{ta=c[u>>2]|0}J=c[ta>>2]|0;H=c[e>>2]|0;c[e>>2]=H+4;c[H>>2]=J;D=C;break};case 1:{c[d>>2]=c[e>>2];J=se[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;H=c[e>>2]|0;c[e>>2]=H+4;c[H>>2]=J;D=C;break};default:{D=C}}}while(0);J=g+1|0;if(J>>>0<4){C=D;g=J}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function eU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;MO(m,g);z=m;A=c[z>>2]|0;if(!((c[27292]|0)==-1)){c[l>>2]=109168;c[l+4>>2]=201;c[l+8>>2]=0;BN(109168,l,202)}l=(c[109172>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;AX(D);E=124736;F=128;Od(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(se[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;cU(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=VX(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}gY()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}dU(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];YR(b,k,R,e,w,g,h);if((Q|0)==0){sO(t);sO(s);QN(r);U=c[z>>2]|0;V=U;W=V;X=gN(W)|0;i=d;return}WX(Q);sO(t);sO(s);QN(r);U=c[z>>2]|0;V=U;W=V;X=gN(W)|0;i=d;return}function fU(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function gU(a){a=a|0;i=i;return}function hU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function iU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{gO(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=ud(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=xY(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{QN(j);i=d;return}do{gO(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);QN(j);i=d;return}function jU(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function kU(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function lU(a){a=a|0;i=i;return}function mU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function nU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=110832;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=110832|0;while(1){c[m>>2]=y;A=(Be[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{gO(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}IT(110056)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=ud(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=110936;D=xY(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){QN(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=110936|0;while(1){c[q>>2]=o;h=(Be[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{wO(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){IT(110056)}else if((E|0)==25){QN(r);i=d;return}}function oU(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function pU(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=109264;e=b+8|0;b=c[e>>2]|0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);if((b|0)==(c[27266]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function qU(a){a=a|0;a=Ec(8)|0;hN(a,109056);c[a>>2]=106024;Od(a|0,106064,41)}function rU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=109096;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);IN(b+144|0,109080,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[113988>>2]=0;c[28496]=107576;if(!((c[26900]|0)==-1)){c[G>>2]=107600;c[G+4>>2]=201;c[G+8>>2]=0;BN(107600,G,202)}sU(b,113984,(c[107604>>2]|0)+ -1|0);c[113980>>2]=0;c[28494]=107616;if(!((c[26910]|0)==-1)){c[F>>2]=107640;c[F+4>>2]=201;c[F+8>>2]=0;BN(107640,F,202)}sU(b,113976,(c[107644>>2]|0)+ -1|0);c[113964>>2]=0;c[28490]=109192;c[113968>>2]=0;a[113972|0]=0;F=c[(yc()|0)>>2]|0;c[113968>>2]=F;if(!((c[27294]|0)==-1)){c[E>>2]=109176;c[E+4>>2]=201;c[E+8>>2]=0;BN(109176,E,202)}sU(b,113960,(c[109180>>2]|0)+ -1|0);c[113956>>2]=0;c[28488]=110152;if(!((c[27292]|0)==-1)){c[D>>2]=109168;c[D+4>>2]=201;c[D+8>>2]=0;BN(109168,D,202)}sU(b,113952,(c[109172>>2]|0)+ -1|0);c[113948>>2]=0;c[28486]=110368;if(!((c[27310]|0)==-1)){c[C>>2]=109240;c[C+4>>2]=201;c[C+8>>2]=0;BN(109240,C,202)}sU(b,113944,(c[109244>>2]|0)+ -1|0);c[113932>>2]=0;c[28482]=109264;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);c[113936>>2]=c[27266];if(!((c[27312]|0)==-1)){c[B>>2]=109248;c[B+4>>2]=201;c[B+8>>2]=0;BN(109248,B,202)}sU(b,113928,(c[109252>>2]|0)+ -1|0);c[113924>>2]=0;c[28480]=110592;if(!((c[27326]|0)==-1)){c[A>>2]=109304;c[A+4>>2]=201;c[A+8>>2]=0;BN(109304,A,202)}sU(b,113920,(c[109308>>2]|0)+ -1|0);c[113916>>2]=0;c[28478]=110712;if(!((c[27328]|0)==-1)){c[z>>2]=109312;c[z+4>>2]=201;c[z+8>>2]=0;BN(109312,z,202)}sU(b,113912,(c[109316>>2]|0)+ -1|0);c[113892>>2]=0;c[28472]=109344;a[113896|0]=46;a[113897|0]=44;z=113900|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[27330]|0)==-1)){c[y>>2]=109320;c[y+4>>2]=201;c[y+8>>2]=0;BN(109320,y,202)}sU(b,113888,(c[109324>>2]|0)+ -1|0);c[113860>>2]=0;c[28464]=109384;c[113864>>2]=46;c[113868>>2]=44;y=113872|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[27332]|0)==-1)){c[x>>2]=109328;c[x+4>>2]=201;c[x+8>>2]=0;BN(109328,x,202)}sU(b,113856,(c[109332>>2]|0)+ -1|0);c[113852>>2]=0;c[28462]=107656;if(!((c[26928]|0)==-1)){c[w>>2]=107712;c[w+4>>2]=201;c[w+8>>2]=0;BN(107712,w,202)}sU(b,113848,(c[107716>>2]|0)+ -1|0);c[113844>>2]=0;c[28460]=107776;if(!((c[26958]|0)==-1)){c[v>>2]=107832;c[v+4>>2]=201;c[v+8>>2]=0;BN(107832,v,202)}sU(b,113840,(c[107836>>2]|0)+ -1|0);c[113836>>2]=0;c[28458]=107848;if(!((c[26974]|0)==-1)){c[u>>2]=107896;c[u+4>>2]=201;c[u+8>>2]=0;BN(107896,u,202)}sU(b,113832,(c[107900>>2]|0)+ -1|0);c[113828>>2]=0;c[28456]=107912;if(!((c[26990]|0)==-1)){c[t>>2]=107960;c[t+4>>2]=201;c[t+8>>2]=0;BN(107960,t,202)}sU(b,113824,(c[107964>>2]|0)+ -1|0);c[113820>>2]=0;c[28454]=108504;if(!((c[27138]|0)==-1)){c[s>>2]=108552;c[s+4>>2]=201;c[s+8>>2]=0;BN(108552,s,202)}sU(b,113816,(c[108556>>2]|0)+ -1|0);c[113812>>2]=0;c[28452]=108568;if(!((c[27154]|0)==-1)){c[r>>2]=108616;c[r+4>>2]=201;c[r+8>>2]=0;BN(108616,r,202)}sU(b,113808,(c[108620>>2]|0)+ -1|0);c[113804>>2]=0;c[28450]=108632;if(!((c[27170]|0)==-1)){c[q>>2]=108680;c[q+4>>2]=201;c[q+8>>2]=0;BN(108680,q,202)}sU(b,113800,(c[108684>>2]|0)+ -1|0);c[113796>>2]=0;c[28448]=108696;if(!((c[27186]|0)==-1)){c[p>>2]=108744;c[p+4>>2]=201;c[p+8>>2]=0;BN(108744,p,202)}sU(b,113792,(c[108748>>2]|0)+ -1|0);c[113788>>2]=0;c[28446]=108760;if(!((c[27196]|0)==-1)){c[o>>2]=108784;c[o+4>>2]=201;c[o+8>>2]=0;BN(108784,o,202)}sU(b,113784,(c[108788>>2]|0)+ -1|0);c[113780>>2]=0;c[28444]=108840;if(!((c[27216]|0)==-1)){c[n>>2]=108864;c[n+4>>2]=201;c[n+8>>2]=0;BN(108864,n,202)}sU(b,113776,(c[108868>>2]|0)+ -1|0);c[113772>>2]=0;c[28442]=108896;if(!((c[27230]|0)==-1)){c[m>>2]=108920;c[m+4>>2]=201;c[m+8>>2]=0;BN(108920,m,202)}sU(b,113768,(c[108924>>2]|0)+ -1|0);c[113764>>2]=0;c[28440]=108944;if(!((c[27242]|0)==-1)){c[l>>2]=108968;c[l+4>>2]=201;c[l+8>>2]=0;BN(108968,l,202)}sU(b,113760,(c[108972>>2]|0)+ -1|0);c[113748>>2]=0;c[28436]=107992;c[113752>>2]=108040;if(!((c[27018]|0)==-1)){c[k>>2]=108072;c[k+4>>2]=201;c[k+8>>2]=0;BN(108072,k,202)}sU(b,113744,(c[108076>>2]|0)+ -1|0);c[113732>>2]=0;c[28432]=108144;c[113736>>2]=108192;if(!((c[27056]|0)==-1)){c[j>>2]=108224;c[j+4>>2]=201;c[j+8>>2]=0;BN(108224,j,202)}sU(b,113728,(c[108228>>2]|0)+ -1|0);c[113716>>2]=0;c[28428]=110088;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);c[113720>>2]=c[27266];c[28428]=108440;if(!((c[27114]|0)==-1)){c[h>>2]=108456;c[h+4>>2]=201;c[h+8>>2]=0;BN(108456,h,202)}sU(b,113712,(c[108460>>2]|0)+ -1|0);c[113700>>2]=0;c[28424]=110088;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);c[113704>>2]=c[27266];c[28424]=108472;if(!((c[27122]|0)==-1)){c[g>>2]=108488;c[g+4>>2]=201;c[g+8>>2]=0;BN(108488,g,202)}sU(b,113696,(c[108492>>2]|0)+ -1|0);c[113692>>2]=0;c[28422]=108984;if(!((c[27252]|0)==-1)){c[f>>2]=109008;c[f+4>>2]=201;c[f+8>>2]=0;BN(109008,f,202)}sU(b,113688,(c[109012>>2]|0)+ -1|0);c[113684>>2]=0;c[28420]=109024;if((c[27262]|0)==-1){N=109048;O=109048;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=113680;sU(b,T,S);i=e;return}c[H>>2]=109048;c[H+4>>2]=201;c[H+8>>2]=0;BN(109048,H,202);N=109048;O=109048;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=113680;sU(b,T,S);i=e;return}function sU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;fN(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){xW(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}gN(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function tU(a){a=a|0;var b=0;b=i;uU(a);bY(a);i=b;return}function uU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=109096;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{gN(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}QN(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{bY(h);i=d;return}}function vU(){var b=0,d=0,e=0,f=0;b=i;if((a[109152]|0)!=0){d=109144;e=c[27286]|0;i=b;return e|0}if((Za(109152)|0)==0){d=109144;e=c[27286]|0;i=b;return e|0}do{if((a[109128]|0)==0){if((Za(109128)|0)==0){break}rU(113520,1);c[27278]=113520;c[27280]=109112;Tb(109128)}}while(0);f=c[c[27280]>>2]|0;c[27284]=f;fN(f);c[27286]=109136;Tb(109152);d=109144;e=c[27286]|0;i=b;return e|0}function wU(a){a=a|0;var b=0,d=0;b=i;d=c[(vU()|0)>>2]|0;c[a>>2]=d;fN(d);i=b;return}function xU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;fN(e);i=d;return}function yU(a){a=a|0;var b=0;b=i;gN(c[a>>2]|0)|0;i=b;return}function zU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=201;c[e+8>>2]=0;BN(a,e,202)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function AU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=201;c[e+8>>2]=0;BN(a,e,202)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;AX(h);j=124736;k=128;Od(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;AX(h);j=124736;k=128;Od(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function BU(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function CU(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}ae[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function DU(a){a=a|0;var b=0;b=c[27290]|0;c[27290]=1+b;c[a+4>>2]=b+1;i=i;return}function EU(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function FU(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function GU(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function HU(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function IU(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function JU(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(yd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function KU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(yd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function LU(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function MU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function NU(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}



function fK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;wY(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=KY(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=KY(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[21002]=d;u=0;Ha(58,10,197)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=KY(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=KY(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=KY(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=KY(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=KY(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=KY(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(198,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=KY(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=KY(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=KY(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function gK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=id(c[8238]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 1:{c[f>>2]=e;a=c[r>>2]|0;rc(84344,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Nd(10,a|0)|0;qd(0)|0;eb(c[g+80>>2]|0,1);break};case 3:{if((c[35220>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;rc(84344,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Nd(10,a|0)|0;qd(0)|0;i=b;return};case 5:case 4:{i=b;return};case 2:{if((c[35164>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;e=c[r>>2]|0;rc(84344,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Nd(10,e|0)|0;qd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};default:{tt(g,84352,b)}}}function hK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(84328,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Nd(10,d|0)|0;qd(0)|0;i=a;return}function iK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;pK(84272,b);c[20560]=83e3;b=82244|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[82260>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}d=id(c[8238]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}function jK(a,b){a=a|0;b=b|0;var c=0;c=i;lK(a,b);i=c;return}function kK(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function lK(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=JO(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function mK(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;fz(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=nK(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((VO(b,d,r)|0)==(r|0)){break}fz(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){LN(l,s,h);if((VO(b,PN(l)|0,s)|0)==(s|0)){QN(l);break}fz(m);c[o>>2]=0;c[a>>2]=0;QN(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((VO(b,e,l)|0)==(l|0)){break}fz(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);oK(g,0)|0;c[a>>2]=b;i=j;return}function nK(a){a=a|0;i=i;return c[a+12>>2]|0}function oK(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function pK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[20566]|0;if((g|0)==0){c[e>>2]=(xY(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(vD(e,f)|0)>>2]|0;c[21080]=h;f=VX(h)|0;c[20566]=f;j=h;k=f}else{j=c[21080]|0;k=g}g=nc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[21080]|0)>>>0){i=d;return}WX(c[20566]|0);j=g<<1|1;c[21080]=j;g=VX(j)|0;c[20566]=g;nc(g|0,j|0,a|0,b|0)|0;i=d;return}function qK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;rK(g,16);sK(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){tK(a,g);uK(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){XJ(cQ(m,+h[b+(p<<3)>>3])|0,85712)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){cQ(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){XJ(m,85720)|0}}while((e|0)<(d|0));tK(a,g);uK(g);i=f;return}function rK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;NO(e);f=a;c[f>>2]=86092;g=e;c[g>>2]=86112;e=a+4|0;UP(a,86124|0,e);c[f>>2]=86092;c[g>>2]=86112;GK(e,b|16);i=d;return}function sK(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function tK(a,b){a=a|0;b=b|0;var c=0;c=i;AK(a,b+4|0);i=c;return}function uK(a){a=a|0;var b=0;b=i;KK(a,86120);IO(a+56|0);i=b;return}function vK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35208>>2]|0)!=0){tb(86416)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(14,0,85728,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(14,0,85800,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35208>>2]|0)==0){i=d;return 0}pt(14,0,85848,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(85864,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function wK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35208>>2]|0)!=0){tb(86416)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(14,0,85728,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(14,0,85800,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35208>>2]|0)==0){i=d;return 0}pt(14,0,85848,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(85864,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function xK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35208>>2]|0)!=0){tb(86416)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(14,0,85728,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(14,0,85800,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35208>>2]|0)==0){i=d;return 0}pt(14,0,85848,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(85864,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function yK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35208>>2]|0)!=0){tb(86416)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(14,0,85728,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(14,0,85800,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35208>>2]|0)==0){i=d;return 0}pt(14,0,85848,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(85864,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function zK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=XX(fa(F,F)|0,8)|0;J=I;K=XX(fa(G,F)|0,8)|0;L=K;M=XX(fa(H,F)|0,8)|0;N=M;O=XX(fa(H,G)|0,8)|0;P=O;EN(p);EN(q);EN(r);EN(s);EN(t);EN(u);EN(v);Q=a+536|0;st(c[Q>>2]|0,(I|0)!=0|0,85872,o);st(c[Q>>2]|0,(K|0)!=0|0,85872,n);st(c[Q>>2]|0,(M|0)!=0|0,85872,m);st(c[Q>>2]|0,(O|0)!=0|0,85872,l);l=a+540|0;m=a;if((de[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;vK(a,J)|0;st(n,1,85888,k)}qK(w,J,F,F);RN(p,w)|0;QN(w);if((de[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;wK(a,L)|0;st(w,1,85920,j)}qK(x,L,F,G);RN(q,x)|0;QN(x);if((de[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;xK(a,N)|0;st(x,1,85952,h)}qK(y,N,H,F);RN(r,y)|0;QN(y);if((de[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;yK(a,P)|0;st(m,1,85984,g)}qK(z,P,H,G);RN(s,z)|0;QN(z);if((F|0)==0){SN(t,86016)|0}else{qK(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);RN(t,A)|0;QN(A)}if((G|0)==0){SN(u,86016)|0}else{qK(B,c[a+432>>2]|0,1,G);RN(u,B)|0;QN(B)}WX(I);WX(K);WX(M);WX(O);KN(E,c[a+84>>2]|0);zO(D,86032,E);HC(C,D,86040);RN(v,C)|0;QN(C);QN(D);QN(E);E=jc(lO(v)|0,86048)|0;D=c[Q>>2]|0;c[f>>2]=lO(v)|0;st(D,(E|0)!=0|0,86056,f);f=xe[c[(c[l>>2]|0)+176>>2]&7]()|0;D=lO(t)|0;Q=lO(u)|0;C=lO(p)|0;a=lO(q)|0;O=lO(r)|0;M=lO(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;sd(E|0,f|0,e|0)|0;if((c[35252>>2]|0)==0){R=qd(E|0)|0;S=Xc(E|0)|0;QN(v);QN(u);QN(t);QN(s);QN(r);QN(q);QN(p);i=b;return 0}e=xe[c[(c[l>>2]|0)+176>>2]&7]()|0;l=lO(t)|0;f=lO(u)|0;M=lO(p)|0;O=lO(q)|0;a=lO(r)|0;C=lO(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;pt(25,0,e,d);R=qd(E|0)|0;S=Xc(E|0)|0;QN(v);QN(u);QN(t);QN(s);QN(r);QN(q);QN(p);i=b;return 0}function AK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=bP(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}BK(a,aP(l)|0,n,e);i=d;return}if((h&8|0)==0){FN(a,g);i=d;return}else{g=b;b=XO(g)|0;BK(a,b,ZO(g)|0,f);i=d;return}}function BK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;CK(a,b,c,0);i=d;return}function CK(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;DK(a,b,c);i=d;return}function DK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=EK(c,d)|0;if(g>>>0>4294967279){CN(0)}if(g>>>0<11){WN(b,g);h=VN(b)|0}else{j=bO(g)|0;k=j+1|0;j=rD(JN(b)|0,k)|0;dO(b,j);cO(b,k);UN(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;sD(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){sD(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;sD(l,f);i=e;return}function EK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=FK(b,c,e)|0;i=d;return g|0}function FK(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function GK(a,b){a=a|0;b=b|0;var c=0;c=i;WK(a,b);i=c;return}function HK(a){a=a|0;var b=0;b=i;uK(a);bY(a);i=b;return}function IK(a){a=a|0;var b=0;b=i;uK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function JK(a){a=a|0;var b=0;b=i;HK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function KK(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];LK(a+4|0);i=d;return}function LK(a){a=a|0;var b=0;b=i;MK(a);i=b;return}function MK(a){a=a|0;var b=0;b=i;c[a>>2]=86272;QN(a+32|0);RO(a);i=b;return}function NK(a){a=a|0;var b=0;b=i;LK(a);bY(a);i=b;return}function OK(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=bP(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}ty(a,-1,-1);i=h;return}else if((k|0)==0){ty(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=bP(l)|0;j=m-(aP(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=YO(l)|0;m=j-(XO(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(PN(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){ty(a,-1,-1);i=h;return}q=HY(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(PN(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((YO(l)|0)!=0){break}ty(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((bP(l)|0)!=0){break}ty(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=XO(l)|0;$O(l,p,p+q|0,n)}if((g&16|0)!=0){p=aP(l)|0;eP(l,p,cP(l)|0);dP(l,q)}ty(a,q,e);i=h;return}}while(0);ty(a,-1,-1);i=h;return}function PK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=Hz(d)|0;me[g&31](a,b,h,J,0,e);i=f;return}function QK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=bP(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((ZO(g)|0)>>>0<j>>>0){b=XO(g)|0;$O(g,b,YO(g)|0,j)}j=YO(g)|0;if(!(j>>>0<(ZO(g)|0)>>>0)){k=-1;i=d;return k|0}k=dA(a[j]|0)|0;i=d;return k|0}function RK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=bP(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=XO(h)|0;j=YO(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if($z(d,-1)|0){$O(h,g,j+ -1|0,k);l=cA(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=aA(d)|0;do{if(g){if(eA(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=XO(h)|0;$O(h,j,(YO(h)|0)+ -1|0,k);a[YO(h)|0]=b;l=d;i=e;return l|0}function SK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if($z(b,-1)|0){f=cA(b)|0;i=d;return f|0}g=a;h=YO(g)|0;j=h-(XO(g)|0)|0;h=bP(g)|0;do{if((h|0)==(cP(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=aP(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;gO(o,0);$N(o,YN(o)|0);p=PN(o)|0;eP(g,p,p+(ON(o)|0)|0);dP(g,h-l|0);c[m>>2]=(aP(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(bP(g)|0)+1;h=c[(TK(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=PN(a+32|0)|0;$O(g,q,q+j|0,h)}f=UO(g,b&255)|0;i=d;return f|0}function TK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=UK(b,c,e)|0;i=d;return g|0}function UK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=VK(0,a,b)|0;i=c;return(d?b:a)|0}function VK(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function WK(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;WO(a);c[a>>2]=86272;EN(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;EN(e);XK(a,e);QN(e);i=d;return}function XK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;RN(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=PN(e)|0;j=g+(ON(e)|0)|0;c[b>>2]=j;g=PN(e)|0;$O(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=ON(e)|0;c[b>>2]=(PN(e)|0)+h;$N(e,YN(e)|0);b=a;a=PN(e)|0;eP(b,a,a+(ON(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}dP(b,h);i=d;return}function YK(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=jc(d|0,86696)|0;J=$c(86704,86696)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Rd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;st(M,(I|0)!=0|0,86760,E);rc(86784,17,1,J|0)|0;rc(86808,10,1,J|0)|0;rc(86824,18,1,J|0)|0;ZK(J,f,86848,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,86880)}else{c[G>>2]=Rd(c[L>>2]|0)|0;rt(26,0,86712,G);G=c[b+536>>2]|0;E=Rd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;st(G,(I|0)!=0|0,86760,F)}rc(86888,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Rd(c[L>>2]|0)|0;rt(26,0,87240,D);Xc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(86440,250,87264,hd(H|0)|0)|0)==0){rt(26,0,87288,C);Xc(I|0)|0;O=1;i=j;return O|0}rc(87312,13,1,I|0)|0;rc(87328,12,1,I|0)|0;_K(I,2);rc(87344,6,1,I|0)|0;$K(I,c[b+84>>2]|0);rc(87352,8,1,I|0)|0;_K(I,2);rc(87368,8,1,I|0)|0;C=b+88|0;$K(I,c[C>>2]|0);rc(87384,10,1,I|0)|0;_K(I,2);rc(87400,6,1,I|0)|0;$K(I,86440);rc(87408,8,1,I|0)|0;_K(I,2);rc(87424,8,1,I|0)|0;$K(I,c[b+280>>2]|0);rc(87440,10,1,I|0)|0;_K(I,2);rc(87456,14,1,I|0)|0;$K(I,c[b+284>>2]|0);rc(87472,16,1,I|0)|0;_K(I,2);rc(87496,16,1,I|0)|0;$K(I,l);rc(87520,18,1,I|0)|0;_K(I,2);c[B>>2]=aL(l)|0;sd(I|0,87544,B|0)|0;_K(I,2);P=+Iu(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(I|0,87584,A|0)|0;_K(I,2);P=+Iu(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];sd(I|0,87624,z|0)|0;_K(I,2);P=+Iu(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(I|0,87656,y|0)|0;_K(I,2);P=+Iu(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(I|0,87688,x|0)|0;_K(I,2);P=+Iu(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(I|0,87720,w|0)|0;_K(I,2);P=+Iu(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(I|0,87752,v|0)|0;_K(I,2);P=+Iu(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(I|0,87792,u|0)|0;_K(I,2);P=+Lu(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];sd(I|0,87824,t|0)|0;_K(I,2);c[s>>2]=Gu(2)|0;sd(I|0,87864,s|0)|0;_K(I,2);P=+Ku(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];sd(I|0,87888,r|0)|0;rc(87920,13,1,I|0)|0;rc(87936,16,1,I|0)|0;_K(I,2);P=+Iu(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];sd(I|0,87960,q|0)|0;_K(I,2);c[p>>2]=Du(8)|0;sd(I|0,87984,p|0)|0;rc(88024,17,1,I|0)|0;rc(88048,22,1,I|0)|0;bL(I,b);rc(88072,23,1,I|0)|0;rc(88096,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{cL(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{cL(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{cL(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{cL(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{cL(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{cL(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{cL(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{cL(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(88112,13,1,I|0)|0;rc(88128,12,1,I|0)|0;dL(I,J,f,c[C>>2]|0,b);rc(88144,13,1,I|0)|0;rc(88160,12,1,I|0)|0;eL(I,c[b+68>>2]|0,b+56|0);rc(88176,13,1,I|0)|0;rc(88192,16,1,I|0)|0;fL(I,J,f,b);rc(88216,17,1,I|0)|0;rc(88240,14,1,I|0)|0;Xc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((xY(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(xY(K|0)|0)<<1}else{Q=0}I=VX(b+Q|0)|0;if((I|0)==0){cb(88256,88264,404,88288)}if((ab(J|0)|0)!=0){rt(26,0,88304,o)}if(e){e=c[C>>2]|0;c[n>>2]=88336;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;ic(I|0,88352,n|0)|0;if((nd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=88432|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;rt(1,0,88464,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;pt(1,0,88528,g);WX(I);O=0;i=j;return O|0}function ZK(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Eu(F)|0;H=Fu(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Ku(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(86784,17,1,a|0)|0;rc(89696,12,1,a|0)|0;rc(89712,12,1,a|0)|0;rc(89728,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;sd(a|0,89744,D|0)|0;rc(89784,10,1,a|0)|0;rc(89800,11,1,a|0)|0;rc(89816,11,1,a|0)|0;rc(89832,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];sd(a|0,89848,C|0)|0}else{rc(89872,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;sd(a|0,89472,B|0)|0;rc(89896,13,1,a|0)|0;if(E){rc(89712,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(a|0,89912,A|0)|0}else{rc(89872,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;sd(a|0,89936,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;sd(a|0,89592,y|0)|0;rc(89984,10,1,a|0)|0;rc(9e4,10,1,a|0)|0;rc(89984,10,1,a|0)|0;rc(90016,11,1,a|0)|0;c[x>>2]=b;sd(a|0,90032,x|0)|0;c[w>>2]=d;sd(a|0,90056,w|0)|0;rc(90072,33,1,a|0)|0;rc(90112,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;sd(a|0,90152,v|0)|0;rc(89832,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(a|0,89848,u|0)|0}else{rc(9e4,10,1,a|0)|0;rc(89984,10,1,a|0)|0;rc(90016,11,1,a|0)|0;c[t>>2]=b;sd(a|0,90032,t|0)|0;c[s>>2]=d;sd(a|0,90056,s|0)|0;rc(90072,33,1,a|0)|0;rc(90112,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;sd(a|0,90152,r|0)|0;rc(89832,10,1,a|0)|0;rc(89872,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;sd(a|0,89472,q|0)|0;rc(89896,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];sd(a|0,89912,p|0)|0}else{rc(89872,17,1,a|0)|0}rc(90184,32,1,a|0)|0;rc(90224,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;sd(a|0,90256,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;sd(a|0,89592,n|0)|0;i=m;return}function _K(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Nd(32,a|0)|0;}while((d|0)!=0);i=c;return}function $K(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){rc(89448,4,1,b|0)|0}else if((e|0)==39){rc(89456,6,1,b|0)|0}else if((e|0)==60){rc(89440,4,1,b|0)|0}else if((e|0)==34){rc(89464,6,1,b|0)|0}else{Nd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function aL(a){a=a|0;var b=0,c=0,d=0;b=i;c=jc(a|0,89432)|0;if((c|0)==0){d=-1;i=b;return d|0}Vc(c|0,0,2)|0;a=yb(c|0)|0;Xc(c|0)|0;d=a;i=b;return d|0}function bL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=VX((xY(l|0)|0)+15|0)|0;c[f>>2]=l;ic(m|0,89160,f|0)|0;_K(a,2);rc(89176,10,1,a|0)|0;$K(a,m);rc(89192,12,1,a|0)|0;_K(a,2);c[e>>2]=aL(m)|0;sd(a|0,89208,e|0)|0;WX(m);_K(a,2);rc(89240,9,1,a|0)|0;_K(a,4);rc(89256,22,1,a|0)|0;_K(a,4);rc(89280,22,1,a|0)|0;_K(a,4);rc(89304,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){hL(g,m,n);o=c[l>>2]|0;_K(a,4);rc(89336,8,1,a|0)|0;$K(a,o);rc(89352,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{mL(h,m,l);g=c[n>>2]|0;_K(a,4);rc(89336,8,1,a|0)|0;$K(a,g);rc(89352,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{hL(j,m,q);b=c[t>>2]|0;_K(a,4);rc(89376,8,1,a|0)|0;$K(a,b);rc(89392,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){_K(a,2);v=89416;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{mL(k,m,s);e=c[u>>2]|0;_K(a,4);rc(89376,8,1,a|0)|0;$K(a,e);rc(89392,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));_K(a,2);v=89416;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function cL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;_K(a,2);c[f>>2]=c[b>>2];sd(a|0,89096,f|0)|0;$K(a,c[b+4>>2]|0);rc(89128,11,1,a|0)|0;$K(a,c[b+8>>2]|0);rc(88800,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];gL(a,4,e);_K(a,2);rc(89144,12,1,a|0)|0;i=d;return}function dL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{hL(p,r,v);ZK(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,88912);w=v+9|0;Ou(w);_K(a,2);c[o>>2]=c[f>>2];sd(a|0,88920,o|0)|0;_K(a,4);rc(87344,6,1,a|0)|0;$K(a,c[s>>2]|0);rc(87352,8,1,a|0)|0;_K(a,4);c[n>>2]=Gu(w)|0;sd(a|0,88696,n|0)|0;_K(a,4);x=+Lu(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(a|0,88720,m|0)|0;_K(a,4);x=+Ku(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(a|0,87888,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];gL(a,6,j);_K(a,2);rc(88944,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function eL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{_K(a,2);lL(l,d,x);c[j>>2]=c[q>>2];sd(a|0,88768,j|0)|0;lL(m,d,x);$K(a,c[r>>2]|0);rc(88800,3,1,a|0)|0;_K(a,4);rc(88808,7,1,a|0)|0;lL(n,d,x);if((c[s>>2]|0)>0){y=0;do{_K(a,6);c[g>>2]=0;sd(a|0,88816,g|0)|0;y=y+1|0;lL(n,d,x);}while((y|0)<(c[s>>2]|0))}_K(a,4);rc(88840,8,1,a|0)|0;_K(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;lL(o,d,x);z=+Iu(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;lL(p,d,x);A=Du(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;sd(a|0,88856,f|0)|0;_K(a,2);rc(88896,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function fL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{mL(n,o,v-u|0);ZK(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,88648);q=v+9|0;Ou(q);_K(a,2);rc(88656,15,1,a|0)|0;_K(a,4);c[m>>2]=c[e>>2];sd(a|0,88672,m|0)|0;_K(a,4);c[l>>2]=Gu(q)|0;sd(a|0,88696,l|0)|0;_K(a,4);w=+Lu(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(a|0,88720,j|0)|0;_K(a,4);w=+Ku(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];sd(a|0,87888,g|0)|0;_K(a,2);rc(88744,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function gL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;_K(a,b);rc(88960,16,1,a|0)|0;$K(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?89064:89080;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;sd(a|0,88984,f|0)|0;i=e;return}function hL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){iL(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function iL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=jc(c[o>>2]|0,90296)|0;if((p|0)!=0){q=p;break}p=Rd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;tt(0,90304,g)}else{q=0}}while(0);g=jo(0)|0;if((g|0)==0){tt(0,90336,f)}f=a+8|0;c[a+20>>2]=XX(c[f>>2]|0,32)|0;p=a+12|0;o=XX((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=90368;c[o+12>>2]=0;c[o+16>>2]=0;uo(g,h);vo(g,10,61);h=c[n>>2]|0;do{if((h|0)==0){o=j;BY(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((wo(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Eo(Bo(g)|0)|0;s=Co(g)|0;Xc(q|0)|0;qo(g);r=c[a>>2]|0;c[e>>2]=90472;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;tt(0,90408,e)}else if((t|0)==11){Xc(q|0)|0;break}}else{if((wo(g,h,xY(h|0)|0,1)|0)!=0){break}s=Eo(Bo(g)|0)|0;o=Co(g)|0;qo(g);r=c[n>>2]|0;c[d>>2]=90472;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;tt(0,90512,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(90576,90472,295,90616)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(90640,90472,297,90616)}}function jL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((tY(91048,b)|0)==0){if((tY(c[d>>2]|0,91056)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}st(0,p,91064,l);l=c[22726]|0;p=c[22780]|0;do{if((l|0)==0|(p|0)==0){c[22780]=32;a=VX(1152)|0;c[22726]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[22780]=p<<1;a=YX(l,p*72|0)|0;c[22726]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(pL(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((tY(91128,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((tY(91136,u)|0)==0){c[22786]=vd(c[t+4>>2]|0)|0}else{if((tY(91168,u)|0)==0){c[91148>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((tY(91184,u)|0)==0){c[91156>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((tY(91192,u)|0)==0){c[91152>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((tY(91208,u)|0)==0){c[91160>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((tY(91216,u)|0)!=0){v=23;break a}c[91164>>2]=(tY(c[t+4>>2]|0,91232)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];tt(0,91240,k)}else if((v|0)==45){i=e;return}}if((tY(90888,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=90472;c[j+4>>2]=k;c[j+8>>2]=v;tt(0,91272,j)}if((tY(91336,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=90472;c[h+4>>2]=j;tt(0,91344,h)}h=Vb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=90472;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;tt(0,91400,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=91464;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((tY(90832,b)|0)!=0){if((tY(91024,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=91568;m=vd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=91576;i=e;return}c[90852>>2]=0;c[90856>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((tY(m,91056)|0)==0){c[90852>>2]=vd(c[b+4>>2]|0)|0}else{if((tY(m,91520)|0)!=0){break}c[90856>>2]=vd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[90852>>2]|0)==0){w=0;break}w=(c[90856>>2]|0)!=0|0}}while(0);st(0,w,91528,f);c[22712]=-1;f=90860|0;w=91144;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function kL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((tY(90832,b)|0)==0){o=e+0|0;p=90848|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));oL(e);i=d;return}if((tY(90888,b)|0)==0){e=h+24|0;r=VX((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=VX(36)|0;t=s;o=s+0|0;p=(c[22726]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((tY(90912,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;wd(e+(k*20|0)+8|0,90920,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((tY(90960,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;wd(h+(k*20|0)+8|0,90976,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((tY(91024,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function lL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){iL(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function mL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){iL(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;tt(0,90680,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=90760;p=o;tt(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=90760;p=o;tt(0,p,f)}}function nL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){WX(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){WX(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}WX(k);c[d>>2]=0;i=b;return}function oL(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=VX(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=xY(f|0)|0;c[e+64>>2]=k;k=c[22760]|0;do{if((k|0)==0){c[22760]=e;c[e+44>>2]=0;l=VX(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=VX(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{BY(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[22760]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[22760]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=xY(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(xY(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 9:{B=o;C=14;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;D=z;C=13;break};case 5:{E=o;F=y;C=18;break};case 2:{G=o;H=x;I=y;C=21;break};case 8:{J=o;C=15;break};case 7:{K=o;L=y;C=16;break};case 1:{M=o;N=x;O=y;C=22;break};case 3:{P=o;Q=x;R=y;C=20;break};case 4:{S=o;T=y;C=19;break};case 6:{U=o;V=y;C=17;break};case 10:{D=o;C=13;break};default:{W=o;X=x;Y=y}}if((C|0)==13){o=((d[A+9|0]|0)<<16)+D|0;c[p>>2]=o;B=o;C=14}if((C|0)==14){o=((d[A+8|0]|0)<<8)+B|0;c[p>>2]=o;J=o;C=15}if((C|0)==15){K=J;L=((d[A+7|0]|0)<<24)+y|0;C=16}if((C|0)==16){U=K;V=((d[A+6|0]|0)<<16)+L|0;C=17}if((C|0)==17){E=U;F=((d[A+5|0]|0)<<8)+V|0;C=18}if((C|0)==18){S=E;T=(d[A+4|0]|0)+F|0;C=19}if((C|0)==19){P=S;Q=((d[A+3|0]|0)<<24)+x|0;R=T;C=20}if((C|0)==20){G=P;H=((d[A+2|0]|0)<<16)+Q|0;I=R;C=21}if((C|0)==21){M=G;N=((d[A+1|0]|0)<<8)+H|0;O=I;C=22}if((C|0)==22){W=M;X=(d[A]|0)+N|0;Y=O}O=X-Y-W^W>>>13;X=Y-W-O^O<<8;Y=W-O-X^X>>>13;W=O-X-Y^Y>>>12;O=X-Y-W^W<<16;X=Y-W-O^O>>>5;Y=W-O-X^X>>>3;W=O-X-Y^Y<<10;O=X-Y-W^W>>>15;c[p>>2]=O;p=(c[22760]|0)+40|0;W=c[p>>2]|0;Y=O&(c[W+4>>2]|0)+ -1;O=c[W>>2]|0;W=O+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[O+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[22760]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[22760]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=VX((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}BY(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;O=c[j>>2]|0;c[Y+24>>2]=(((O<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((O|0)==0){_=e}else{O=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=O}else{W=O;X=j;while(1){j=X+16|0;N=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];M=Z+(A*12|0)+4|0;C=(c[M>>2]|0)+1|0;c[M>>2]=C;I=c[W+24>>2]|0;if(C>>>0>I>>>0){C=W+28|0;c[C>>2]=(c[C>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[M>>2]|0)>>>0)/(I>>>0)|0}c[X+12>>2]=0;I=Z+(A*12|0)|0;c[j>>2]=c[I>>2];j=c[I>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[I>>2]=X;I=c[h>>2]|0;if((N|0)==0){$=I;break}else{W=I;X=N}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){O=$;Y=W;e=X}else{_=W;break}}}WX(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function pL(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[22760]|0)==0){f=24}else{g=xY(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(xY(a|0)|0)+s|0;switch(v|0){case 2:{x=h;y=t;z=u;f=14;break};case 4:{A=h;B=u;f=12;break};case 10:{C=h;f=6;break};case 6:{D=h;E=u;f=10;break};case 3:{F=h;G=t;H=u;f=13;break};case 11:{C=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 7:{I=h;J=u;f=9;break};case 9:{K=h;f=7;break};case 5:{L=h;M=u;f=11;break};case 8:{N=h;f=8;break};case 1:{O=h;P=t;Q=u;f=15;break};default:{R=h;S=t;T=u}}if((f|0)==6){K=((d[w+9|0]|0)<<16)+C|0;f=7}if((f|0)==7){N=((d[w+8|0]|0)<<8)+K|0;f=8}if((f|0)==8){I=N;J=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){D=I;E=((d[w+6|0]|0)<<16)+J|0;f=10}if((f|0)==10){L=D;M=((d[w+5|0]|0)<<8)+E|0;f=11}if((f|0)==11){A=L;B=(d[w+4|0]|0)+M|0;f=12}if((f|0)==12){F=A;G=((d[w+3|0]|0)<<24)+t|0;H=B;f=13}if((f|0)==13){x=F;y=((d[w+2|0]|0)<<16)+G|0;z=H;f=14}if((f|0)==14){O=x;P=((d[w+1|0]|0)<<8)+y|0;Q=z;f=15}if((f|0)==15){R=O;S=(d[w]|0)+P|0;T=Q}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[22760]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=xY(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((sY(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,91600)|0)==0){V=0;break}else{W=91624}i=b;return W|0}}while(0);c[e>>2]=a;st(0,(V|0)!=0|0,91672,e);W=V+4|0;i=b;return W|0}function qL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((rL(91728,a,b)|0)!=0){d=1;i=c;return d|0}d=(rL(91736,a,b)|0)!=0|0;i=c;return d|0}function rL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((tY(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function sL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(tY(c[40308>>2]|0,91744)|0)==0|0;st(0,m,91760,l);l=(tY(c[42212>>2]|0,91744)|0)==0|0;st(0,l,91816,k);k=(tY(c[44204>>2]|0,91744)|0)==0|0;st(0,k,91872,j);j=91936|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=92064|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[44208+(k<<2)>>2]|0;if((l|0)==2){q=c[40184+(k<<2)>>2]|0;if(!((rL(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[40184+(k<<2)>>2]|0;if((uL(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((rL(c[40184+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=91936+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=91936+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[92064+(k<<2)>>2]=tL(q,p)|0;t=j}else if((r|0)==13){r=0;l=91936+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[92064+(k<<2)>>2]=vL(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];rt(1,0,92192,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];rt(1,0,92192,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];rt(1,0,92192,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];rt(1,0,92248,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function tL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((tY(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function uL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(vL(a,b)|0)!=0|0;i=c;return d|0}function vL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=xY(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((uY(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function wL(){i=i;return}function xL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(92280,5,1,e|0)|0;f=b;b=0;while(1){Nd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(92288,20,1,e|0)|0;vc(0);return 0}function yL(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;sd(d|0,92312,e|0)|0;if((b|0)==0){vc(1)}else{qd(d|0)|0;GL();qd(d|0)|0;ib(6,0)|0;ed()}}function zL(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function AL(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function BL(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function CL(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function DL(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function EL(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}BY(p|0,32,b+(d-p)|0)|0;i=f;return}function FL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=93352+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[93396+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[93392+(e*48|0)>>2]|0)==1){HL(b)|0}k=93356+(e*48|0)|0;if((c[k>>2]|0)==0){break}Xc(c[f>>2]|0)|0;WX(c[k>>2]|0)}}while(0);do{if((h|0)==10){Xc(g|0)|0;b=93356+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Ed(k|0)|0;WX(c[b>>2]|0)}}while(0);c[f>>2]=0}c[93388+(e*48|0)>>2]=0;c[93356+(e*48|0)>>2]=0;i=d;return 0}function GL(){var a=0,b=0;a=i;if((c[23080]|0)!=0){i=a;return}c[23080]=1;c[92328>>2]=0;b=0;do{c[92324>>2]=b;FL(92320)|0;b=b+1|0;}while((b|0)<100);i=a;return}function HL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[93368+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=93352+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Vc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[93372+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[93380+(d*48|0)>>2]&2|0)!=0){qd(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Vc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){JL(111,92336);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function IL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function JL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;sd(m|0,93248,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;sd(m|0,93280,j|0)|0;l=m;break}else{n=c[93120+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;sd(m|0,93304,h|0)|0;l=m;break}}}while(0);h=c[23328]|0;do{if((h|0)==0){rc(98184,29,1,l|0)|0}else{c[g>>2]=(h-93352|0)/48|0;sd(l|0,93320,g|0)|0;b=c[(c[23328]|0)+4>>2]|0;if((b|0)==0){rc(98168,10,1,l|0)|0;break}else{c[f>>2]=b;sd(l|0,98152,f|0)|0;break}}}while(0);f=c[24554]|0;if((f|0)!=0){c[d>>2]=f;sd(l|0,98224,d|0)|0}d=(c[24574]|0)!=0?98304:98320;f=(c[24582]|0)!=0?98336:98352;g=(c[24592]|0)!=0?98376:98392;c[e>>2]=(c[24568]|0)!=0?98280:98288;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;sd(l|0,98248,e|0)|0;yL(98408,1)}function KL(){var a=0,b=0;a=i;c[24604]=1;b=c[r>>2]|0;c[23338]=b;c[93372>>2]=IL(b)|0;c[93376>>2]=1;c[93392>>2]=1;b=c[s>>2]|0;c[93592>>2]=b;c[93612>>2]=IL(b)|0;c[93616>>2]=1;c[93632>>2]=0;b=c[t>>2]|0;c[93640>>2]=b;c[93660>>2]=IL(b)|0;c[93664>>2]=1;c[93680>>2]=1;i=a;return}function LL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[103664+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[24606]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[103664+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[24606]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Vc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Vc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function ML(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){JL(b,d)}d=c[24608]|0;if((d|0)!=0){xe[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function NL(a){a=a|0;var b=0,d=0;b=i;c[24638]=0;c[24640]=0;c[24642]=0;d=((OL(a,0)|0)==0)<<31>>31;i=b;return d|0}function OL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[24642]|0;c[24642]=j+1;if((j|0)==1){c[24640]=d}if((TL(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=UL(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function PL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[24638]|0;l=98576+(k<<4)|0;m=c[l>>2]|0;switch(QL(m)|0){case 1:{n=c[98580+(k<<4)>>2]|0;o=(c[25870]|0)+1|0;c[25870]=o;c[103488+(o<<2)>>2]=n;c[24638]=k+1;continue b;break};case 8:{n=c[25854]|0;p=103424+(n<<2)|0;q=c[p>>2]|0;if((q|0)>=1){s=10;break b}c[25854]=n+ -1;c[24638]=k+1;continue b;break};case 19:case 17:{c[24614]=0;c[24638]=k+1;continue b;break};case 21:{c[24616]=0;c[24638]=k+1;continue b;break};case 2:{c[25854]=0;c[25870]=0;c[24638]=c[98580+(k<<4)>>2];if(b){s=24;break a}if((c[25866]|0)==0){j=0;s=37;break a}n=xe[c[24624]&7]()|0;if((n|0)==0){continue b}else{j=n;s=37;break a}break};case 33:{c[25882]=1;c[24638]=k+1;continue b;break};case 16:{if(b){s=28;break a}c[24638]=k+1;continue b;break};case 3:{n=c[25854]|0;o=103424+(n<<2)|0;t=c[o>>2]|0;c[o>>2]=t+ -1;if((t|0)<2){c[25854]=n+ -1;c[25870]=(c[25870]|0)+ -1;c[24638]=k+1;continue b}else{n=c[25870]|0;c[25870]=n+ -1;c[24638]=(c[103488+(n<<2)>>2]|0)+1;continue b}break};case 18:{c[24614]=1;c[24638]=k+1;continue b;break};case 6:{n=c[98580+(k<<4)>>2]|0;t=(c[25854]|0)+1|0;c[25854]=t;c[103424+(t<<2)>>2]=n;c[24638]=k+1;continue b;break};case 9:{n=(de[c[24622]&127](l)|0)==0;c[24638]=(c[24638]|0)+1;if(n){break b}else{continue b}break};case 22:{c[24616]=1;c[24638]=k+1;continue b;break};case 20:{c[24634]=c[98580+(k<<4)>>2];c[24638]=k+1;continue b;break};default:{s=4;break a}}}if((s|0)==10){s=0;if(b){s=11;break}c[p>>2]=q+ -1;c[25866]=1;k=ge[c[24620]&63](l,g,d)|0;if((k|0)>0){s=13;break}if((k|0)<0){s=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;s=37;break}}if((s|0)==4){h=c[r>>2]|0;d=c[24554]|0;c[f>>2]=m;c[f+4>>2]=d;sd(h|0,103376,f|0)|0;if((c[c[24610]>>2]|0)==0){JL(100,103408);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((s|0)==11){j=xe[c[24608]&7]()|0;i=e;return j|0}else if((s|0)==13){f=c[c[24610]>>2]|0;j=ML(f,c[(Nc()|0)>>2]|0,103472)|0;i=e;return j|0}else if((s|0)==15){if((c[(c[24610]|0)+8>>2]|0)==0){JL(-1,103472);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((s|0)==24){j=xe[c[24608]&7]()|0;i=e;return j|0}else if((s|0)==28){j=xe[c[24608]&7]()|0;i=e;return j|0}else if((s|0)==37){i=e;return j|0}return 0}function QL(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function RL(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=PL(b,0,0)|0;i=a;return d|0}function SL(){c[24630]=0;c[24638]=0;c[25870]=0;c[25854]=0;c[25866]=0;c[25872]=0;c[25856]=0;i=i;return}function TL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[24638]|0;if((g|0)>299){rc(103552,24,1,c[r>>2]|0)|0;yL(c[24554]|0,1)}else{c[98576+(g<<4)>>2]=a;c[98580+(g<<4)>>2]=b;c[98584+(g<<4)>>2]=d;c[98588+(g<<4)>>2]=e;c[24638]=g+1;i=f;return g|0}return 0}function UL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=VL(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[24642]|0)+ -1|0;c[24642]=h;if((h|0)==0){TL(2,c[24640]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{TL(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function VL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((WL(b,e)|0)!=0){g=c[e>>2]|0;break}if((XL(b,e)|0)!=0){g=c[e>>2]|0;break}h=YL(b,f,1)|0;j=TL(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=OL(h,j)|0}}while(0);i=d;return g|0}function WL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 47:{TL(5,0,0,0)|0;g=b;h=30;break};case 36:{TL(33,0,0,0)|0;g=b;h=30;break};case 116:case 84:{j=b+1|0;k=a[j]|0;if(k<<24>>24==82|k<<24>>24==114){l=j;m=14}else if(k<<24>>24==76|k<<24>>24==108){l=j;m=13}else{l=b;m=15}j=YL(l+1|0,f,0)|0;if((j|0)==0){h=15;break a}TL(m,c[f>>2]|0,0,0)|0;g=j+ -1|0;h=30;break};case 115:case 83:{j=b+1|0;k=a[j]|0;if(k<<24>>24==80|k<<24>>24==112){n=j;o=18}else if(k<<24>>24==83|k<<24>>24==115){n=j;o=19}else{n=b;o=17}TL(o,0,0,0)|0;g=n;h=30;break};case 39:case 34:case 2:{c[98584+((TL(11,0,0,0)|0)<<4)>>2]=b;j=ZL(b)|0;c[d>>2]=j;p=(j|0)!=0|0;i=e;return p|0};case 98:case 66:{j=b+1|0;k=a[j]|0;if(k<<24>>24==90|k<<24>>24==122){TL(22,0,0,0)|0;g=j;h=30;break a}else{TL(21,0,0,0)|0;g=j;h=30;break a}break};case 45:{q=1;h=13;break};case 58:{TL(16,0,0,0)|0;g=b;h=30;break};case 43:{q=0;h=13;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{r=b;s=0;h=14;break};case 120:case 88:{TL(4,1,0,0)|0;g=b;h=30;break};case 112:case 80:{TL(20,1,0,0)|0;g=b;h=30;break};default:{p=0;i=e;return p|0}}}while(0);if((h|0)==13){r=b+1|0;s=q;h=14}b:do{if((h|0)==14){q=YL(r,f,0)|0;if((q|0)==0){h=15;break}switch(a[q]|0){case 112:case 80:{b=c[f>>2]|0;if((s|0)==0){t=b}else{n=0-b|0;c[f>>2]=n;t=n}TL(20,t,0,0)|0;g=q;h=30;break b;break};case 104:case 72:{n=c[f>>2]|0;c[98584+((TL(12,n,0,0)|0)<<4)>>2]=q+1;g=q+n|0;h=30;break b;break};case 120:case 88:{TL(4,c[f>>2]|0,0,0)|0;g=q;h=30;break b;break};default:{p=0;i=e;return p|0}}}}while(0);if((h|0)==15){c[d>>2]=0;p=1;i=e;return p|0}else if((h|0)==30){c[d>>2]=g+1;p=1;i=e;return p|0}return 0}function XL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=YL(b,f,1)|0;TL(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 102:case 70:{l=YL(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=YL(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}TL(23,n,r,0)|0;o=q;m=45;break};case 105:case 73:{s=7;t=10;m=38;break};case 97:case 65:{n=f;while(1){u=a[n]|0;if(u<<24>>24==32){n=n+1|0}else{break}}if(!((u+ -48<<24>>24&255)<10)){TL(30,0,0,0)|0;o=n;m=45;break a}l=YL(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}TL(31,p,0,0)|0;o=l;m=45;break};case 101:case 69:{v=1;m=3;break};case 111:case 79:{s=32;t=34;m=38;break};case 103:case 71:{v=0;m=3;break};case 100:case 68:{l=YL(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){w=YL(l+1|0,h,0)|0;if((w|0)==0){m=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=l;y=0}TL(26,p,y,0)|0;o=x;m=45;break};case 108:case 76:{p=YL(f,g,0)|0;if((p|0)==0){m=4;break a}l=c[g>>2]|0;if((l|0)==0){o=p;m=45;break a}TL(29,l,0,0)|0;o=p;m=45;break};case 122:case 90:{s=35;t=36;m=38;break};default:{c[24638]=(c[24638]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=YL(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}y=a[b]|0;if(y<<24>>24==46){u=YL(b+1|0,h,0)|0;if((u|0)==0){m=4;break}A=u;B=a[u]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){TL((v|0)==1?24:27,x,c[h>>2]|0,0)|0;o=A;m=45;break}y=YL(A+1|0,j,0)|0;if((y|0)==0){m=4;break}TL((v|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=y;m=45}else if((m|0)==38){y=YL(f,g,0)|0;if((y|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=y;m=45;break}if((a[y]|0)!=46){TL(s,x,0,0)|0;o=y;m=45;break}b=YL(y+1|0,h,0)|0;if((b|0)==0){m=4;break}TL(t,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function YL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function ZL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[24610]>>2]|0)==0){JL(100,103536);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function _L(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[103606|0]=48;k=103606|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=103584+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function $L(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[24632]|0;f=c[24628]|0;if((e|0)>(f|0)){c[24628]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[25920]|0)){h=g}else{aM(f,g);h=c[24628]|0}g=c[25922]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Fd(g|0,c[24606]|0)|0;h=xY(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Nd(a[k]|0,c[24606]|0)|0;Fd(h|0,c[24606]|0)|0;b=xY(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function aM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[25922]|0;if((f|0)==103768){c[25920]=1024;g=1024}else{g=c[25920]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[25920]=j;h=j}j=VX(h)|0;if((j|0)==0){JL(113,104168);k=c[25922]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[25922]|0}else{l=k}if((l|0)==103768){m=103688;c[25922]=j;i=e;return}WX(l);m=103688;c[25922]=j;i=e;return}function bM(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[24628]|0;f=c[25920]|0;if((e|0)<(f|0)){g=e}else{aM(e,f);g=c[24628]|0}c[24628]=g+1;a[(c[25922]|0)+g|0]=b;i=d;return}function cM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[24592]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){JL(101,103696);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[24604]|0)==0){KL();m=c[f>>2]|0}else{m=k}k=93352+(m*48|0)|0;c[23328]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){hM(k,c[b+12>>2]|0,j);o=iM(j,h)|0;if((o|0)==(c[93360+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[93364+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=FL(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[93384+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=93368+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[93384+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=93376+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[93376+(m*48|0)>>2]=1;r=1;break}else{c[93376+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];ic(j|0,103704,e|0)|0}else{hM(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){dM(107,103696,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=93396+(m*48|0)|0;c[q>>2]=0;c[93388+(m*48|0)>>2]=0;e=93392+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=93380+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){dM(s,103696,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){dM(128,103696,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Lb()|0;c[n>>2]=s;if((s|0)!=0){c[93356+(m*48|0)>>2]=0;c[93364+(m*48|0)>>2]=-1;c[93360+(m*48|0)>>2]=-1;c[93372+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){dM(o,103696,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=jc(j|0,c[25916]|0)|0;if((o|0)==0){break}Xc(o|0)|0}}while(0);q=VX((xY(j|0)|0)+1|0)|0;c[93356+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){dM(113,103720,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}DY(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=jc(j|0,c[103664+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=jc(j|0,c[103624+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=jc(j|0,c[103664+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){JL(o,103696);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=93372+(m*48|0)|0;c[r>>2]=IL(u)|0;u=iM(j,93364+(m*48|0)|0)|0;c[93360+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){dM(108,103696,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Vc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){dM(129,103696,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function dM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){JL(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[25920]|0)){j=d;k=g}else{aM(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[25922]|0;c[(c[23328]|0)+4>>2]=f;hM(k,j,f);JL(a,b);i=e;return}function eM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;ic(j|0,103704,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=xY(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?103736:103744;c[h+24>>2]=(b|0)==5?103752:103760;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=cM(h)|0;i=e;return a|0}function fM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=93352+(d*48|0)|0;c[23328]=e;if(d>>>0>99){if((c[a>>2]|0)==0){JL(101,104184);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((eM(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){JL(114,104192);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[93376+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){JL(102,104192);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function gM(){var a=0,b=0;a=i;b=RL()|0;c[24554]=0;i=a;return b|0}function hM(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function iM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((mc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function jM(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[24634]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[24614]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ic(p|0,104200,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(xY(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;ae[c[24618]&255](32);}while((A|0)>0)}if((D|0)!=0){ae[c[24618]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{ae[c[24618]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[24634]|0);ic(A|0,104208,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;ae[c[24618]&255](32);}while((z|0)>0)}if((x|0)!=0){ae[c[24618]&255]((w|0)!=0?45:43)}z=c[24634]|0;do{if((z|0)<1){ae[c[24618]&255](46);y=c[24618]|0;if((z|0)<0){G=y;J=z;while(1){ae[G&255](48);I=J+1|0;K=c[24618]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}ae[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}ae[c[24618]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[24618]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){ae[P&255](a[J]|0);R=Q+ -1|0;S=c[24618]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}ae[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;ae[c[24618]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){ae[c[24618]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;ae[c[24618]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){ae[c[24618]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;ae[c[24618]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;ae[c[24618]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;ae[c[24618]&255](42);}while((_|0)>0);i=l;return 0}function kM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[24634]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(ic(n|0,104216,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[24614]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;ae[c[24618]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;ae[c[24618]&255](32);}while((b|0)>0)}do{if(q){if((c[24614]|0)==0){break}ae[c[24618]&255](43)}else{ae[c[24618]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;ae[c[24618]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;ae[c[24618]&255](48);}while((z|0)>0);i=j;return 0}function lM(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{ae[c[24618]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[24618]|0;if((h|0)==0){ae[d&255](70);i=g;return 0}else{ae[d&255](84);i=g;return 0}return 0}function mM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[24630]|0)!=0){g=nM()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 36:{tM(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 29:{lM(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 35:{tM(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=jM(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 23:{h=kM(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 10:{pM(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 7:{oM(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 32:{oM(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 34:{pM(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 28:case 27:{h=sM(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 30:{qM(b,d);h=0;i=e;return h|0};case 31:{rM(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;sd(h|0,104224,f|0)|0;yL(c[24554]|0,1)}}return 0}function nM(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[24630]|0;c[24630]=0;if((c[24592]|0)!=0){if((b|0)>0){d=c[24632]|0;e=c[24628]|0;if((d|0)<=(e|0)){f=b;while(1){ae[c[24618]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[24628]=f;h=0;i=a;return h|0}f=b-d+e|0;c[24628]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){ae[c[24618]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[24628]|0;f=j+b|0;if((f|0)>=0){if((c[24632]|0)<(j|0)){c[24632]=j}c[24628]=f;h=0;i=a;return h|0}if((c[c[24610]>>2]|0)==0){JL(110,104312);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[24628]|0;if((c[24632]|0)<(f|0)){c[24632]=f}j=f+b|0;c[24628]=j;c[24636]=(c[24636]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[24610]>>2]|0)==0){JL(110,104312);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[24628]|0;f=j+b|0;if((f|0)>=(c[(c[24612]|0)+16>>2]|0)){if((c[c[24610]>>2]|0)==0){JL(110,104328);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[24632]|0;if((d|0)<=(j|0)){e=b;while(1){ae[c[24618]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[24636]=(c[24636]|0)+b;c[24628]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[24636]=(c[24636]|0)+f;c[24628]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){ae[c[24618]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function oM(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=_L(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[24614]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{ae[c[24618]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{ae[c[24618]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[24614]|0)==0){break}ae[c[24618]&255](43)}else{ae[c[24618]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){ae[c[24618]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function pM(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=_L(m,k,l,h)|0;h=c[l>>2]|0;g=(c[24614]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{ae[c[24618]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{ae[c[24618]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[24614]|0)==0){break}ae[c[24618]&255](43)}else{ae[c[24618]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){ae[c[24618]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){ae[c[24618]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{ae[c[24618]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function qM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;ae[c[24618]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function rM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;ae[c[24618]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;ae[c[24618]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function sM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=jM(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=jM(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[24634]|0;c[24634]=0;p=(e|0)==0?4:e+2|0;e=kM(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{ae[c[24618]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[24634]=o;n=e;i=j;return n|0}function tM(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{ae[c[24618]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;ae[c[24618]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;ae[c[24618]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){ae[c[24618]&255](a[104288+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){ae[c[24618]&255](a[104288+((d[p]|0)>>>4)|0]|0);ae[c[24618]&255](a[104288+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function uM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 4:case 14:{c[24630]=(c[24630]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 15:{c[24630]=(c[a+4>>2]|0)+ -1-(c[24628]|0);f=1;i=b;return f|0};case 12:{f=wM(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[24630]|0)-(c[a+4>>2]|0)|0;h=0-(c[24628]|0)|0;c[24630]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 11:{f=vM(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=xe[c[24626]&7]()|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;sd(f|0,104256,d|0)|0;yL(c[24554]|0,1)}}return 0}function vM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[24630]|0)!=0){e=nM()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}ae[c[24618]&255](e<<24>>24);n=b}else{ae[c[24618]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function wM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[24630]|0)!=0){f=nM()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;ae[c[24618]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function xM(){var a=0,b=0;a=i;b=$L(10)|0;c[24630]=0;c[24628]=0;c[24632]=0;i=a;return(b|0)==0|0}function yM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[24604]|0)==0){KL()}c[24568]=0;c[24574]=1;c[24582]=1;c[24592]=1;d=fM(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[24610]=a;c[24628]=0;c[24630]=0;c[24632]=0;c[25882]=0;c[24634]=0;d=c[a+12>>2]|0;c[24554]=d;c[24606]=c[c[23328]>>2];if((NL(d)|0)<0){if((c[a>>2]|0)==0){JL(100,104336);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[24618]=199;c[24620]=44;c[24622]=111;c[24608]=4;c[24624]=5;c[24626]=6;SL();c[24614]=0;d=c[23328]|0;c[24616]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((LL(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){JL(f,104344);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function zM(){var a=0,b=0;a=i;if((c[25882]|0)==0){b=$L(10)|0}else{$L(0)|0;qd(c[24606]|0)|0;b=0}c[24630]=0;c[24628]=0;c[24632]=0;i=a;return b|0}function AM(){var a=0,b=0,d=0;a=i;if((c[25866]|0)==0){b=0}else{d=$L(10)|0;c[25866]=0;b=d}c[24630]=0;c[24628]=0;c[24632]=0;i=a;return b|0}function BM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;XM(105072,h,105128);c[26090]=106580;c[104368>>2]=106600;c[104364>>2]=0;OO(104368|0,105072);c[104440>>2]=0;c[104444>>2]=-1;j=c[t>>2]|0;c[26294]=106448;wU(105180|0);k=105184|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[26294]=105688;c[105208>>2]=j;xU(g,105180|0);k=AU(g,109240)|0;l=k;yU(g);c[105212>>2]=l;c[105216>>2]=105136;a[105220|0]=(de[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[26112]=106660;c[104452>>2]=106680;OO(104452|0,105176);c[104524>>2]=0;c[104528>>2]=-1;l=c[r>>2]|0;c[26306]=106448;wU(105228|0);k=105232|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[26306]=105688;c[105256>>2]=l;xU(f,105228|0);k=AU(f,109240)|0;g=k;yU(f);c[105260>>2]=g;c[105264>>2]=105144;a[105268|0]=(de[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[26134]=106660;c[104540>>2]=106680;OO(104540|0,105224);c[104612>>2]=0;c[104616>>2]=-1;g=c[(c[(c[26134]|0)+ -12>>2]|0)+104560>>2]|0;c[26156]=106660;c[104628>>2]=106680;OO(104628|0,g);c[104700>>2]=0;c[104704>>2]=-1;c[(c[(c[26090]|0)+ -12>>2]|0)+104432>>2]=104448;g=(c[(c[26134]|0)+ -12>>2]|0)+104540|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[26134]|0)+ -12>>2]|0)+104608>>2]=104448;JM(105272,h,105152|0);c[26178]=106620;c[104720>>2]=106640;c[104716>>2]=0;OO(104720|0,105272);c[104792>>2]=0;c[104796>>2]=-1;c[26332]=106512;wU(105332|0);h=105336|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[26332]=105432;c[105360>>2]=j;xU(e,105332|0);j=AU(e,109248)|0;h=j;yU(e);c[105364>>2]=h;c[105368>>2]=105160;a[105372|0]=(de[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[26200]=106700;c[104804>>2]=106720;OO(104804|0,105328);c[104876>>2]=0;c[104880>>2]=-1;c[26344]=106512;wU(105380|0);h=105384|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[26344]=105432;c[105408>>2]=l;xU(d,105380|0);l=AU(d,109248)|0;h=l;yU(d);c[105412>>2]=h;c[105416>>2]=105168;a[105420|0]=(de[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[26222]=106700;c[104892>>2]=106720;OO(104892|0,105376);c[104964>>2]=0;c[104968>>2]=-1;h=c[(c[(c[26222]|0)+ -12>>2]|0)+104912>>2]|0;c[26244]=106700;c[104980>>2]=106720;OO(104980|0,h);c[105052>>2]=0;c[105056>>2]=-1;c[(c[(c[26178]|0)+ -12>>2]|0)+104784>>2]=104800;h=(c[(c[26222]|0)+ -12>>2]|0)+104892|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[26222]|0)+ -12>>2]|0)+104960>>2]=104800;i=b;return}function CM(a){a=a|0;a=i;MP(104448)|0;MP(104624)|0;TP(104800)|0;TP(104976)|0;i=a;return}function DM(a){a=a|0;var b=0;b=i;c[a>>2]=106512;yU(a+4|0);i=b;return}function EM(a){a=a|0;var b=0;b=i;c[a>>2]=106512;yU(a+4|0);bY(a);i=b;return}function FM(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AU(d,109248)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(de[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function GM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=te[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function HM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((se[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function IM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Be[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function JM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=106512;j=b+4|0;wU(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=105544;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;xU(g,j);j=AU(g,109248)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=de[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(de[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){IT(105640)}else{yU(g);i=f;return}}function KM(a){a=a|0;var b=0;b=i;c[a>>2]=106512;yU(a+4|0);i=b;return}function LM(a){a=a|0;var b=0;b=i;c[a>>2]=106512;yU(a+4|0);bY(a);i=b;return}function MM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=AU(d,109248)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=de[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(de[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){IT(105640)}else{i=e;return}}function NM(a){a=a|0;var b=0,c=0;b=i;c=QM(a,0)|0;i=b;return c|0}function OM(a){a=a|0;var b=0,c=0;b=i;c=QM(a,1)|0;i=b;return c|0}function PM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Be[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((md(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}



function Hj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;nu(ag,1,$f);if(!(d>0.0)){$f=_t(_t(6568,Yt(d,0,1,6)|0)|0,5952)|0;bg=c[21062]|0;cg=f+96|0;c[cg+0>>2]=c[6632+0>>2];c[cg+4>>2]=c[6632+4>>2];c[cg+8>>2]=c[6632+8>>2];c[cg+12>>2]=c[6632+12>>2];c[cg+16>>2]=c[6632+16>>2];c[cg+20>>2]=c[6632+20>>2];De[bg&31](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=_t(_t(6656,Yt(d,0,1,6)|0)|0,6408)|0;$f=c[21062]|0;bg=f+72|0;c[bg+0>>2]=c[6704+0>>2];c[bg+4>>2]=c[6704+4>>2];c[bg+8>>2]=c[6704+8>>2];c[bg+12>>2]=c[6704+12>>2];c[bg+16>>2]=c[6704+16>>2];c[bg+20>>2]=c[6704+20>>2];De[$f&31](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=_t(_t(6728,Yt(e,0,1,6)|0)|0,6512)|0;_f=c[21062]|0;$f=f+48|0;c[$f+0>>2]=c[6776+0>>2];c[$f+4>>2]=c[6776+4>>2];c[$f+8>>2]=c[6776+8>>2];c[$f+12>>2]=c[6776+12>>2];c[$f+16>>2]=c[6776+16>>2];c[$f+20>>2]=c[6776+20>>2];De[_f&31](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=_t(_t(6800,Yt(e,0,1,6)|0)|0,6856)|0;Zf=c[21062]|0;_f=f+24|0;c[_f+0>>2]=c[6904+0>>2];c[_f+4>>2]=c[6904+4>>2];c[_f+8>>2]=c[6904+8>>2];c[_f+12>>2]=c[6904+12>>2];c[_f+16>>2]=c[6904+16>>2];c[_f+20>>2]=c[6904+20>>2];De[Zf&31](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(tu(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(tu(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(tu(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(tu(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(tu(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(tu(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(tu(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(tu(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(tu(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(tu(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(tu(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(tu(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(tu(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(tu(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(tu(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(tu(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(tu(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(tu(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(tu(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(tu(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(tu(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(tu(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(tu(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(tu(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(tu(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(tu(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(tu(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(tu(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(tu(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(tu(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(tu(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(tu(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(tu(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(tu(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(tu(ag,1,of)|0)>>3];c[nf>>2]=16;h[(tu(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(tu(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(tu(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(tu(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(tu(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(tu(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(tu(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(tu(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(tu(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(tu(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(tu(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(tu(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(tu(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(tu(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(tu(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(tu(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(tu(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(tu(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(tu(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(tu(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(tu(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(tu(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(tu(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(tu(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(tu(ag,1,Qe)|0)>>3];c[Pe>>2]=25;h[(tu(ag,1,Pe)|0)>>3]=fg*fg;c[Oe>>2]=11;fg=+h[(tu(ag,1,Oe)|0)>>3];c[Ne>>2]=12;gg=+h[(tu(ag,1,Ne)|0)>>3];c[Me>>2]=25;eg=fg*gg*dg*+h[(tu(ag,1,Me)|0)>>3];c[Le>>2]=26;h[(tu(ag,1,Le)|0)>>3]=eg;c[Ke>>2]=10;eg=+h[(tu(ag,1,Ke)|0)>>3];c[Je>>2]=12;gg=eg*+h[(tu(ag,1,Je)|0)>>3];c[Ie>>2]=27;h[(tu(ag,1,Ie)|0)>>3]=gg;c[He>>2]=1;gg=+h[(tu(ag,1,He)|0)>>3];c[Ge>>2]=10;eg=+h[(tu(ag,1,Ge)|0)>>3];c[Fe>>2]=11;fg=gg*eg*dg*+h[(tu(ag,1,Fe)|0)>>3];c[Ee>>2]=28;h[(tu(ag,1,Ee)|0)>>3]=fg;c[Ce>>2]=10;fg=+h[(tu(ag,1,Ce)|0)>>3];c[Be>>2]=12;eg=+h[(tu(ag,1,Be)|0)>>3];c[Ae>>2]=25;gg=fg*eg*dg*+h[(tu(ag,1,Ae)|0)>>3];c[ze>>2]=29;h[(tu(ag,1,ze)|0)>>3]=gg;c[ye>>2]=1;gg=+h[(tu(ag,1,ye)|0)>>3];c[xe>>2]=10;eg=+h[(tu(ag,1,xe)|0)>>3];c[we>>2]=25;fg=gg*eg*dg*+h[(tu(ag,1,we)|0)>>3];c[ve>>2]=30;h[(tu(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(tu(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(tu(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(tu(ag,1,se)|0)>>3];c[re>>2]=31;h[(tu(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(tu(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(tu(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(tu(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(tu(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(tu(ag,1,me)|0)>>3];c[le>>2]=34;h[(tu(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(tu(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(tu(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(tu(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(tu(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(tu(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(tu(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(tu(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(tu(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(tu(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(tu(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(tu(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(tu(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(tu(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(tu(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(tu(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(tu(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(tu(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(tu(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(tu(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(tu(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(tu(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(tu(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(tu(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(tu(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(tu(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(tu(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(tu(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(tu(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(tu(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(tu(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(tu(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(tu(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(tu(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(tu(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(tu(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(tu(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(tu(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function Ij(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}zj(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}wj(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function Jj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;nu(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(tu(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(tu(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(tu(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(tu(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(tu(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(tu(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(tu(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(tu(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(tu(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(tu(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(tu(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(tu(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(tu(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(tu(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(tu(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(tu(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(tu(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(tu(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(tu(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(tu(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(tu(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(tu(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(tu(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(tu(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(tu(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(tu(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(tu(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(tu(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(tu(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(tu(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(tu(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(tu(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(tu(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(tu(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(tu(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(tu(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(tu(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(tu(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(tu(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(tu(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(tu(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(tu(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(tu(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(tu(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(tu(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(tu(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(tu(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(tu(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(tu(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(tu(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(tu(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(tu(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(tu(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(tu(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(tu(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(tu(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(tu(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(tu(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(tu(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(tu(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(tu(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(tu(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(tu(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(tu(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(tu(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(tu(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(tu(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(tu(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(tu(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(tu(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(tu(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(tu(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(tu(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(tu(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(tu(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(tu(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(tu(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(tu(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(tu(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(tu(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(tu(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function Kj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;nu(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(tu(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(tu(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(tu(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(tu(ta,1,oa)|0)>>3];c[na>>2]=3;h[(tu(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(tu(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(tu(ta,1,la)|0)>>3];c[ka>>2]=4;h[(tu(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(tu(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(tu(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(tu(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(tu(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(tu(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(tu(ta,1,ea)|0)>>3];c[da>>2]=8;h[(tu(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(tu(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(tu(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(tu(ta,1,aa)|0)>>3];c[$>>2]=10;h[(tu(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(tu(ta,1,_)|0)>>3];c[Z>>2]=11;h[(tu(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(tu(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(tu(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(tu(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(tu(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(tu(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(tu(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(tu(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(tu(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(tu(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(tu(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(tu(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(tu(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(tu(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(tu(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(tu(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(tu(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(tu(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(tu(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(tu(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(tu(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(tu(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(tu(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(tu(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(tu(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(tu(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(tu(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(tu(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(tu(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(tu(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(tu(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(tu(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(tu(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(tu(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(tu(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(tu(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(tu(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(tu(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(tu(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(tu(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(tu(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(tu(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(tu(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(tu(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(tu(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function Lj(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function Mj(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;pt(4,0,8280,b);pt(4,0,8320,a);i=a;return}function Nj(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}WX(a);c[d>>2]=0;i=b;return}function Oj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+528>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+504>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+512>>3];h[a+8>>3]=+h[d+640>>3];h[e+8>>3]=+h[d+616>>3];h[f+8>>3]=+h[d+624>>3];i=i;return}function Pj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;e=i;i=i+72|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=a+4|0;w=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[w+32>>3]=+h[b>>3];h[w+40>>3]=+h[b+8>>3];su(p,1,+h[w>>3],o);su(q,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+24>>3],n);n=a+536|0;a=c[n>>2]|0;o=c[(c[c[v>>2]>>2]|0)+8>>2]|0;x=+h[o+16>>3];y=+h[o+8>>3];z=+h[o+40>>3];A=+h[o+32>>3];o=k;w=p;c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];w=j;o=q;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];qj(t,a,x,y,k,z,A,j);j=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[j+384>>3]- +h[t>>3];su(r,1,+h[j>>3],m);su(s,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+24>>3],l);l=c[n>>2]|0;n=c[(c[c[v>>2]>>2]|0)+8>>2]|0;A=+h[n+16>>3];z=+h[n+8>>3];y=+h[n+40>>3];x=+h[n+32>>3];n=g;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=f;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];oj(u,l,A,z,g,y,x,f);h[d+8>>3]=+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+392>>3]- +h[u>>3];i=e;return}function Qj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+528>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+504>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+512>>3];h[a+8>>3]=+h[d+640>>3];h[e+8>>3]=+h[d+616>>3];h[f+8>>3]=+h[d+624>>3];i=i;return}function Rj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;e=i;i=i+72|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=a+4|0;w=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[w+32>>3]=+h[b>>3];h[w+40>>3]=+h[b+8>>3];su(p,1,+h[w>>3],o);su(q,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+24>>3],n);n=a+536|0;a=c[n>>2]|0;o=c[(c[c[v>>2]>>2]|0)+8>>2]|0;x=+h[o+16>>3];y=+h[o+8>>3];z=+h[o+40>>3];A=+h[o+32>>3];o=k;w=p;c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];w=j;o=q;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];qj(t,a,x,y,k,z,A,j);j=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[j+384>>3]- +h[t>>3];su(r,1,+h[j>>3],m);su(s,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+24>>3],l);l=c[n>>2]|0;n=c[(c[c[v>>2]>>2]|0)+8>>2]|0;A=+h[n+16>>3];z=+h[n+8>>3];y=+h[n+40>>3];x=+h[n+32>>3];n=g;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=f;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];oj(u,l,A,z,g,y,x,f);h[d+8>>3]=+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+392>>3]- +h[u>>3];i=e;return}function Sj(a){a=a|0;c[a+4>>2]=75;c[a>>2]=2;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=131;c[a+80>>2]=2;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;i=i;return}function Tj(a){a=a|0;i=i;return}function Uj(a,b){a=a|0;b=b|0;i=i;return}function Vj(a){a=a|0;i=i;return}function Wj(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 8368}function Xj(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function Yj(a){a=a|0;i=i;return 8368}function Zj(a,b){a=a|0;b=b|0;i=i;return 0}function _j(a){a=a|0;a=i;i=i+8|0;pt(8,1,8376,a);if((c[35184>>2]|0)==0){i=a;return 0}ae[c[8926]&255](8);i=a;return 0}function $j(a){a=a|0;i=i;return c[8528+(a<<2)>>2]|0}function ak(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+8|0;pt(21,1,8544,j);j=a+4|0;l=a+416|0;m=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[(c[l>>2]|0)+96>>3];h[b>>3]=m;a=$j(0)|0;c[g>>2]=1;c[g+4>>2]=a;a=g+8|0;h[k>>3]=m;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];pt(21,0,8576,g);m=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3]- +h[(c[l>>2]|0)+112>>3];h[b+8>>3]=m;g=$j(1)|0;c[f>>2]=2;c[f+4>>2]=g;g=f+8|0;h[k>>3]=m;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];pt(21,0,8576,f);m=+h[c[(c[c[j>>2]>>2]|0)+8>>2]>>3]- +h[(c[l>>2]|0)+16>>3];h[b+16>>3]=m;b=$j(2)|0;c[e>>2]=3;c[e+4>>2]=b;b=e+8|0;h[k>>3]=m;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];pt(21,0,8576,e);if((c[35236>>2]|0)==0){i=d;return 0}ae[c[8926]&255](21);i=d;return 0}function bk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+8>>3];i=i;return}function ck(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b>>3];i=i;return}function dk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+72>>3];i=i;return}function ek(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+64>>3];i=i;return}function fk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b>>3]*.5;i=i;return}function gk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+72>>3]*1.2;i=i;return}function hk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b>>3];i=i;return}function ik(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+72>>3];i=i;return}function jk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+64>>3];i=i;return}function kk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+528>>3]=+h[(c[a+416>>2]|0)+136>>3]+-273.15;i=i;return}function lk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[(c[a+416>>2]|0)+152>>3]*1.0e-5;i=i;return}function mk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+512>>3]=+h[(c[a+416>>2]|0)+168>>3]+-273.15;i=i;return}function nk(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+32>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+vt(c[b+536>>2]|0,f,8600,8592,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]=1.0/j;i=d;return}function ok(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=1.0- +h[(c[a+416>>2]|0)+32>>3];i=i;return}function pk(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+48>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+vt(c[b+536>>2]|0,f,8720,8712,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3]=1.0/j;i=d;return}function qk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=c[a+416>>2]|0;eh(d,c[a+536>>2]|0,+h[e+152>>3],+h[e+168>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+488>>3]=+h[d>>3];i=b;return}function rk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=1.0- +h[(c[a+416>>2]|0)+48>>3];i=i;return}function sk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+152>>3];m=+h[k+168>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];rh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[f>>3];i=b;return}function tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;su(k,1,+h[(c[o>>2]|0)+48>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[o>>2]|0;r=+h[q+152>>3];s=+h[q+168>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];gh(m,p,r,s,f);s=+h[m>>3];su(l,1,+h[(c[o>>2]|0)+48>>3],g);g=c[j>>2]|0;m=c[o>>2]|0;r=+h[m+152>>3];u=+h[m+168>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];nh(n,g,r,u,e);u=+h[n>>3];r=+h[(c[o>>2]|0)+152>>3];do{if(u!=0.0){v=r/u}else{if(r==0.0){v=r;break}v=r/+vt(c[j>>2]|0,u,8824,8816,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+472>>3]=s-v;i=d;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+152>>3];m=+h[k+168>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];nh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+464>>3]=+h[f>>3];i=b;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+152>>3];m=+h[k+168>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];ph(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+456>>3]=+h[f>>3];i=b;return}function wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+104>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+448|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+448|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,8976,8968,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+448|0;p=o;h[p>>3]=m;i=d;return}function xk(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+488>>3];j=b+416|0;k=+h[(c[j>>2]|0)+152>>3];do{if(g!=0.0){l=k/g}else{if(k==0.0){l=k;break}l=k/+vt(c[b+536>>2]|0,g,9032,9024,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+488>>3];g=+h[(c[j>>2]|0)+152>>3];do{if(l!=0.0){m=g/l}else{if(g==0.0){m=g;break}m=g/+vt(c[b+536>>2]|0,l,9032,9024,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+440|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;y=c[c[e>>2]>>2]|0;m=+h[(c[y+8>>2]|0)+488>>3];l=+h[(c[j>>2]|0)+152>>3];do{if(m!=0.0){z=y;A=l/m}else{if(l==0.0){z=y;A=l;break}g=l/+vt(f,m,9032,9024,+h[y>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=g}}while(0);n=+vt(f,A+-.3778957546290221,9064,9024,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+440|0;x=w;h[x>>3]=o;i=d;return}}function yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+440>>3];i=i;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+432>>3];i=i;return}function Ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+432>>3];k=1.0-j;l=+h[g+96>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+vt(c[b+536>>2]|0,k,9152,9144,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+432>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+424>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+416|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+416|0;z=y;h[z>>3]=w;i=d;return}l=m/+vt(c[b+536>>2]|0,p,9152,9144,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+416|0;z=y;h[z>>3]=w;i=d;return}function Bk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3];k=+pd(1.0e-13,+(+h[(c[b+416>>2]|0)+152>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+vt(c[b+536>>2]|0,k,9192,9184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+408>>3]=m*.6221042453709779;i=d;return}function Ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+96>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+48>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+400|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,9264,9256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+400|0;p=o;h[p>>3]=m;i=d;return}function Dk(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+16>>3];i=i;return}function Ek(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+128>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+64|0;p=o;h[p>>3]=m;i=b;return}else{g=d+32|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+64|0;p=o;h[p>>3]=m;i=b;return}}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=1.0- +h[b>>3];i=i;return}function Gk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+80>>3]),1.0e-13);k=+h[g>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,9304,9296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+320|0;p=o;h[p>>3]=m;i=d;return}function Hk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=j/.018015268-j/.0289586+34.53205610768476;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+328|0;q=p;h[q>>3]=n;i=d;return}j=+vt(c[b+536>>2]|0,k,9344,9336,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+328|0;q=p;h[q>>3]=n;i=d;return}function Ik(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+112>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+8>>3]+-273.15;i=i;return}function Kk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+96>>3];i=i;return}function Lk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];m=+h[(c[g>>2]|0)+136>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];di(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+200>>3]=+h[f>>3];i=b;return}function Mk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];m=+h[(c[g>>2]|0)+136>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];ci(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[f>>3];i=b;return}function Nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;su(k,1,+h[(c[o>>2]|0)+32>>3],j);j=b+536|0;p=c[j>>2]|0;q=b+4|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3];s=+h[(c[o>>2]|0)+136>>3];t=f;u=k;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];Yh(m,p,r,s,f);s=+h[m>>3];su(l,1,+h[(c[o>>2]|0)+32>>3],g);g=c[j>>2]|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3];v=+h[(c[o>>2]|0)+136>>3];o=e;m=l;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];ci(n,g,r,v,e);v=+h[n>>3];n=c[c[q>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+16>>3];if(v!=0.0){w=e;x=r/v;y=s-x;z=w;A=z+216|0;B=A;h[B>>3]=y;i=d;return}if(r==0.0){w=e;x=r;y=s-x;z=w;A=z+216|0;B=A;h[B>>3]=y;i=d;return}C=r/+vt(c[j>>2]|0,v,9440,9432,+h[n>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[q>>2]>>2]|0)+8>>2]|0;x=C;y=s-x;z=w;A=z+216|0;B=A;h[B>>3]=y;i=d;return}function Ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];m=+h[(c[g>>2]|0)+136>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];ei(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+232>>3]=+h[f>>3];i=b;return}function Pk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[a+416>>2]|0)+136>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[d>>3];i=b;return}function Qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+pd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+vt(c[b+536>>2]|0,k,9616,9608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+168>>3]=m*.6221042453709779;i=d;return}function Rk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+h[g+16>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+vt(c[b+536>>2]|0,j,9696,9688,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+160>>3];j=+h[g+16>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+vt(c[b+536>>2]|0,l,9696,9688,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+176|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+160>>3];l=+h[y+16>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+vt(f,m,9696,9688,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+vt(f,A+-.3778957546290221,9736,9688,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+176|0;x=w;h[x>>3]=o;i=d;return}}function Sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+176>>3];i=i;return}function Tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+192>>3];i=i;return}function Uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=1.0-j;l=+h[g+104>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+vt(c[b+536>>2]|0,k,9832,9824,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+192>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+184>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+208|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+208|0;z=y;h[z>>3]=w;i=d;return}l=m/+vt(c[b+536>>2]|0,p,9832,9824,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+208|0;z=y;h[z>>3]=w;i=d;return}function Vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;su(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a+8>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3]=+h[f>>3];i=b;return}function Wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;su(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a+8>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];rj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3]=+h[f>>3];i=b;return}function Xk(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+128>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+144>>3]=-(b*+h[(!(b>=0.0)?d+360|0:d+232|0)>>3]);i=i;return}function Yk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;cj(d,c[a+536>>2]|0,+h[f+16>>3],+h[f+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[d>>3];i=b;return}function Zk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+272>>3];k=+pd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+vt(c[b+536>>2]|0,k,9880,9872,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+280>>3]=m*.6221042453709779;i=d;return}function _k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+272>>3];k=+h[g+16>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+vt(c[b+536>>2]|0,j,9944,9936,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+272>>3];j=+h[g+16>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+vt(c[b+536>>2]|0,l,9944,9936,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+288|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+272>>3];l=+h[y+16>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+vt(f,m,9944,9936,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+vt(f,A+-.3778957546290221,9976,9936,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+288|0;x=w;h[x>>3]=o;i=d;return}}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b>>3]- +h[b+288>>3];i=i;return}function al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b>>3]- +h[b+304>>3];i=i;return}function bl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+304>>3];k=1.0-j;l=+h[g+80>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+vt(c[b+536>>2]|0,k,10064,10056,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+304>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+296>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+336|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+336|0;z=y;h[z>>3]=w;i=d;return}l=m/+vt(c[b+536>>2]|0,p,10064,10056,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+336|0;z=y;h[z>>3]=w;i=d;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+16>>3]- +h[(c[a+416>>2]|0)+152>>3];i=i;return}function dl(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+192>>3];g=+h[e+184>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+112>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+120|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+120|0;r=q;h[r>>3]=o;i=d;return}s=l/+vt(c[b+536>>2]|0,g,10104,10096,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+120|0;r=q;h[r>>3]=o;i=d;return}function el(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[(c[a+416>>2]|0)+128>>3]- +h[b+120>>3];i=i;return}function fl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+88>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+376>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,e,10136,10128,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}function gl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+120>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+48|0}else{e=b}h[b+48>>3]=-(d*+h[e>>3]);i=i;return}function hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+48>>3]- +h[b+64>>3];i=i;return}function il(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+120>>3];h[b+128>>3]=-(d*+h[(!(d>=0.0)?b+480|0:b+360|0)>>3]);i=i;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+128>>3]- +h[b+144>>3];i=i;return}function kl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Gw(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+136>>3]=+h[(a?e+480|0:e+360|0)>>3];i=b;return}function ll(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Gw(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+48|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+56|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a;f=a;g=+h[e>>3];j=f;k=j+56|0;l=k;h[l>>3]=g;i=b;return}}function ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+4|0;su(k,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[q+16>>3];s=+h[q+8>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];dj(m,p,r,s,f);s=+h[m>>3];su(l,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],g);g=c[j>>2]|0;m=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[m+16>>3];u=+h[m+8>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];$i(n,g,r,u,e);u=+h[n>>3];n=c[c[o>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+16>>3];if(u!=0.0){v=e;w=r/u;x=s-w;y=v;z=y+344|0;A=z;h[A>>3]=x;i=d;return}if(r==0.0){v=e;w=r;x=s-w;y=v;z=y+344|0;A=z;h[A>>3]=x;i=d;return}B=r/+vt(c[j>>2]|0,u,10160,10152,+h[n>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[o>>2]>>2]|0)+8>>2]|0;w=B;x=s-w;y=v;z=y+344|0;A=z;h[A>>3]=x;i=d;return}function pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;su(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a+8>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];$i(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3]=+h[f>>3];i=b;return}function ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[(c[a+416>>2]|0)+88>>3]*+h[b+352>>3];i=i;return}function rl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3];k=+h[g+88>>3]- +h[g>>3]*+h[g+376>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+24|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+24|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,10304,10296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+24|0;p=o;h[p>>3]=m;i=d;return}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3];k=+h[g+368>>3]- +h[g+376>>3]*+h[g+344>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,10304,10320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+384|0;p=o;h[p>>3]=m;i=d;return}function tl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+32|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+ax(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+32>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+40|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+ax(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+40>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+8>>3]=k;_w(a,0)|0;a=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+32>>3]=+h[a>>3];h[f+40>>3]=+h[a+8>>3];i=b;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+240>>3]*+h[b+344>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=+h[b>>3]*+h[b+240>>3];i=i;return}function wl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+80>>3];i=i;return}function xl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+8>>3]*.5;i=i;return}function yl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+80>>3]*1.2;i=i;return}function zl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b+8>>3];i=i;return}function Al(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+80>>3];i=i;return}function Bl(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);a[d]=0;i=c;return 0}function Cl(a){a=a|0;i=i;return}function Dl(a){a=a|0;i=i;return 0}function El(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;pt(9,1,10328,e);if((c[35188>>2]|0)!=0){ae[c[8926]&255](9)}pt(9,1,10352,d);if((c[35188>>2]|0)!=0){ae[c[8926]&255](9)}pt(9,1,10376,b);if((c[35188>>2]|0)!=0){ae[c[8926]&255](9)}pt(9,1,10400,a);if((c[35188>>2]|0)==0){i=a;return 0}ae[c[8926]&255](9);i=a;return 0}function Fl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+64>>3];i=i;return}function Gl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+72>>3];i=i;return}function Hl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+80>>3];i=i;return}function Il(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b>>3];i=i;return}function Jl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b+8>>3];i=i;return}function Kl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+72>>3]*1.2;i=i;return}function Ll(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+528>>3]=+h[(c[a+416>>2]|0)+136>>3]+-273.15;i=i;return}function Ml(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+80>>3]*1.2;i=i;return}function Nl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b>>3]*.5;i=i;return}function Ol(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+32>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+vt(c[b+536>>2]|0,f,10432,10424,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]=1.0/j;i=d;return}function Pl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=1.0- +h[(c[a+416>>2]|0)+32>>3];i=i;return}function Ql(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+104>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+448|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+448|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,10552,10544,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+448|0;p=o;h[p>>3]=m;i=d;return}function Rl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+8>>3]*.5;i=i;return}function Sl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+64>>3];i=i;return}function Tl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[(c[a+416>>2]|0)+152>>3]*1.0e-5;i=i;return}function Ul(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+72>>3];i=i;return}function Vl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+512>>3]=+h[(c[a+416>>2]|0)+168>>3]+-273.15;i=i;return}function Wl(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=c[a+416>>2]|0;eh(d,c[a+536>>2]|0,+h[e+152>>3],+h[e+168>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+488>>3]=+h[d>>3];i=b;return}function Xl(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+488>>3];j=b+416|0;k=+h[(c[j>>2]|0)+152>>3];do{if(g!=0.0){l=k/g}else{if(k==0.0){l=k;break}l=k/+vt(c[b+536>>2]|0,g,10608,10600,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+488>>3];g=+h[(c[j>>2]|0)+152>>3];do{if(l!=0.0){m=g/l}else{if(g==0.0){m=g;break}m=g/+vt(c[b+536>>2]|0,l,10608,10600,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+440|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;y=c[c[e>>2]>>2]|0;m=+h[(c[y+8>>2]|0)+488>>3];l=+h[(c[j>>2]|0)+152>>3];do{if(m!=0.0){z=y;A=l/m}else{if(l==0.0){z=y;A=l;break}g=l/+vt(f,m,10608,10600,+h[y>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=g}}while(0);n=+vt(f,A+-.3778957546290221,10640,10600,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+440|0;x=w;h[x>>3]=o;i=d;return}}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(tu(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(tu(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(tu(l,1,tb)|0)>>3];c[ub>>2]=52;h[(tu(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(tu(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(tu(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(tu(l,1,xb)|0)>>3];c[yb>>2]=53;h[(tu(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(tu(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(tu(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(tu(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(tu(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(tu(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(tu(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(tu(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[21062]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[6928+0>>2];c[a+4>>2]=c[6928+4>>2];c[a+8>>2]=c[6928+8>>2];c[a+12>>2]=c[6928+12>>2];c[a+16>>2]=c[6928+16>>2];c[a+20>>2]=c[6928+20>>2];De[Gd&31](d,a,4104,Gb);}c[Hb>>2]=9;Ed=+h[(tu(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(tu(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(tu(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(tu(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(tu(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(tu(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(tu(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(tu(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(tu(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(tu(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(tu(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(tu(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(tu(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(tu(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(tu(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(tu(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(tu(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(tu(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(tu(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(tu(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(tu(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(tu(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(tu(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(tu(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(tu(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(tu(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(tu(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(tu(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(tu(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(tu(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(tu(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(tu(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(tu(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(tu(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(tu(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(tu(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(tu(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(tu(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(tu(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(tu(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(tu(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(tu(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(tu(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(tu(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(tu(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(tu(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(tu(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(tu(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(tu(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(tu(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(tu(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(tu(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(tu(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(tu(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(tu(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(tu(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(tu(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(tu(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(tu(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(tu(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(tu(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(tu(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(tu(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(tu(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(tu(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(tu(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(tu(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(tu(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(tu(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(tu(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(tu(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(tu(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(tu(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(tu(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(tu(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(tu(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(tu(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(tu(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(tu(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(tu(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(tu(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(tu(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(tu(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(tu(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(tu(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(tu(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(tu(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(tu(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(tu(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(tu(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(tu(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(tu(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(tu(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(tu(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(tu(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(tu(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(tu(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(tu(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(tu(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(tu(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(tu(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(tu(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(tu(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(tu(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(tu(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(tu(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(tu(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(tu(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(tu(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(tu(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(tu(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(tu(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(tu(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(tu(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(tu(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(tu(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(tu(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(tu(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(tu(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(tu(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(tu(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(tu(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(tu(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(tu(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(tu(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(tu(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(tu(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(tu(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(tu(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(tu(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(tu(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(tu(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(tu(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(tu(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(tu(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(tu(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(tu(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(tu(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(tu(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(tu(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(tu(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(tu(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(tu(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(tu(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(tu(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(tu(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(tu(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(tu(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(tu(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(tu(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(tu(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(tu(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(tu(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(tu(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(tu(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(tu(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(tu(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(tu(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(tu(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(tu(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(tu(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(tu(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(tu(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(tu(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(tu(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(tu(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(tu(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(tu(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(tu(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(tu(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(tu(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(tu(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(tu(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(tu(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(tu(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(tu(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(tu(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(tu(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(tu(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(tu(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(tu(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(tu(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(tu(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(tu(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(tu(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(tu(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(tu(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(tu(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(tu(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(tu(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(tu(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(tu(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(tu(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(tu(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(tu(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(tu(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(tu(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(tu(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(tu(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(tu(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(tu(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(tu(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(tu(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(tu(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(tu(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(tu(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(tu(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(tu(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(tu(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(tu(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(tu(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(tu(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(tu(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(tu(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(tu(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(tu(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(tu(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function lp(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Io(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=oo(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Io(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((rp(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ce[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=se[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ce[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=Vo(k,b,v,w+(se[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Ro(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=Zo(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Mo(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Mo(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=se[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Io(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Fo(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Fo(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Fo(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=de[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;zY(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}ae[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;zY(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;zY(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function mp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=44;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 11:{if((ep(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case-1:{k=15;break a;break};case-15:{k=3;break a;break};case 13:{if((fp(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-2:{k=18;break a;break};case 0:{k=14;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}Do(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-4:{k=7;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Do(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function np(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ce[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-2:{r=25;break a;break};case-4:case-1:{r=28;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Do(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){ze[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Zd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];ze[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;ze[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Do(o,b,c[k>>2]|0,c[l>>2]|0);break};case 40:{r=6;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){ae[c[m+76>>2]&255](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}Do(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function op(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=np(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=45;k=pp(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=To(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function pp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=ip(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((qp(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function qp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=se[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}zY(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function rp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Fo(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Fo(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Io(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function sp(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ce[c[b+16>>2]&63](b,f,g,l)|0){case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case-1:{o=7;break a;break};case 6:{if((Xo(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 10:{p=se[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=zp(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Fo(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 0:{o=4;break a;break};case-4:{o=3;break a;break};case 9:{q=(ge[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Fo(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=Ro(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=Io(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=sp(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 7:case 39:{o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Fo(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function tp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ge[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Ap()|0;c[g+240>>2]=de[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ce[((a[g+236|0]&255|0)!=0?46:47)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){ae[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}ae[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function up(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=FY()|0;i=a;return b|0}function vp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=No(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=41;h=Oo(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function wp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=de[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{xp(f+80|0,e);xp(b+104|0,e);yp(b,e);yp(b+20|0,e);yp(b+40|0,e);yp(b+60|0,e);a[b+131|0]=0;yp(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function xp(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function yp(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function zp(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Ap(){i=i;return 1912}function Bp(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[32336+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[32412+l|0]|0|0)!=28){if((d[32412+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[32412+q|0]|0|0)!=28){if((d[32412+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[32412+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Cp(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[26504+(((d[26248+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[26504+(((d[27784+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=zp(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function Cp(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 0:{if((d[32412+c|0]|0|0)!=0){f=7;break a}e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function Dp(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=se[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[26504+(((d[27784+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Ep(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=se[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[26504+(((d[26248+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Fp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=se[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Cp(a)|0)<0;g=f&1;i=d;return g|0}function Gp(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=zp(se[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Hp(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(se[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Ip(){i=i;return 31968}function Jp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Kp(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=22;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Kp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((Yp(d,c[31872+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Lp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Wr(30312,a,0,b,c,d)|0;i=e;return f|0}function Mp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Wr(30312,a,1,b,c,d)|0;i=e;return f|0}function Np(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;tr(31080,b,c,d);i=a;return}function Op(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Pp(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Pp(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(Xr(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,31816)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((Xr(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,31824)|0)!=0){h=Yr(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ge[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((Xr(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,31840)|0)!=0){if((a|0)!=0){break}do{if((Ce[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,31856)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ce[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,31864)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((Zr(Yr(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Qp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Yp(h,28040)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Kp(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[30312+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Rp(){i=i;return 29944}function Sp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Kp(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=50;c[g+4>>2]=51;c[g+52>>2]=22;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Tp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Wr(28048,a,0,b,c,d)|0;i=e;return f|0}function Up(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Wr(28048,a,1,b,c,d)|0;i=e;return f|0}function Vp(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Pp(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Wp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Yp(h,28040)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Kp(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[28048+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Xp(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Bp(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function Yp(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function Zp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=oq(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 29:{g=b;if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[26504+((d[27784+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 13:{k=Aq(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 30:{k=qq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=oq(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=Bq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=wq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=Aq(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 19:{k=Cq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=oq(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=oq(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 34:{o=116;break b;break};case 7:{o=91;break b;break};case 33:{o=119;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=85;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=oq(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 7:{o=111;break b;break};case 6:{o=108;break b;break};case 5:{o=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 6:{o=88;break b;break};case 15:{o=122;break b;break};case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function _p(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=oq(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=tq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 3:{k=pq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=oq(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function $p(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=oq(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=oq(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function aq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=oq(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function bq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=oq(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=16;break a;break};case 21:{n=29;break a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=pq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=oq(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function cq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=oq(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=pq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=qq(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=oq(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function dq(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=oq(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=oq(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function eq(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function fq(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=oq(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function gq(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=oq(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function hq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=oq(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=oq(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function iq(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Cp(c)|0;k=j;i=b;return k|0}function jq(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function kq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=oq(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=oq(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function lq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=oq(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function mq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function nq(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function oq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function pq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=rq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=oq(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function qq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=oq(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function rq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=sq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=oq(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function sq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=oq(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=oq(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function tq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 15:{k=wq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=xq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=oq(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=vq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=uq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=oq(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 11:{o=90;break b;break};case 17:{break b;break};case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 6:{o=42;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=oq(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 7:{o=45;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=oq(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 11:{o=90;break c;break};case 7:{o=84;break d;break};case 17:{break c;break};case 5:{o=78;break d;break};case 29:{o=75;break d;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=yq(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function uq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=oq(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function vq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[28448+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function wq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=oq(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=oq(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 15:{p=62;break b;break};case 6:{p=31;break b;break};case 7:{p=34;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((zq(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=oq(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((zq(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function xq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=oq(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=oq(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function yq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=oq(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=oq(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 7:{l=36;break a;break};case 29:{if((c[26504+((d[26248+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=oq(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};case 29:{if((c[26504+((d[27784+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=oq(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=oq(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 3:{t=pq(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=oq(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=oq(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[26504+((d[26248+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function zq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Aq(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=oq(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=oq(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Bq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=oq(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=oq(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=uq(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Cq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=oq(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[26504+((d[26248+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=oq(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 29:{if((c[26504+((d[27784+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Dq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=oq(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=oq(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 10:case 21:{p=25;break};case 29:{g=b;if((c[26504+((d[26248+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[26504+((d[27784+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 19:{k=fr(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=Vq(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=dr(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=oq(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=$q(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=er(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=dr(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=oq(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=oq(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=oq(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 7:{p=111;break b;break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=105;break b;break};case 6:{p=108;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 15:{p=122;break b;break};case 33:{p=119;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 34:{p=116;break b;break};case 5:{p=85;break b;break};case 6:{p=88;break b;break};case 7:{p=91;break b;break};case 29:{if((c[26504+((d[27784+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}



function Yl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3];k=+pd(1.0e-13,+(+h[(c[b+416>>2]|0)+152>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+vt(c[b+536>>2]|0,k,10728,10720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+408>>3]=m*.6221042453709779;i=d;return}function Zl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+80>>3];i=i;return}function _l(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b>>3];i=i;return}function $l(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+48>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+vt(c[b+536>>2]|0,f,10800,10792,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3]=1.0/j;i=d;return}function am(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=1.0- +h[(c[a+416>>2]|0)+48>>3];i=i;return}function bm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+152>>3];m=+h[k+168>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];rh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[f>>3];i=b;return}function cm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;su(k,1,+h[(c[o>>2]|0)+48>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[o>>2]|0;r=+h[q+152>>3];s=+h[q+168>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];gh(m,p,r,s,f);s=+h[m>>3];su(l,1,+h[(c[o>>2]|0)+48>>3],g);g=c[j>>2]|0;m=c[o>>2]|0;r=+h[m+152>>3];u=+h[m+168>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];nh(n,g,r,u,e);u=+h[n>>3];r=+h[(c[o>>2]|0)+152>>3];do{if(u!=0.0){v=r/u}else{if(r==0.0){v=r;break}v=r/+vt(c[j>>2]|0,u,10904,10896,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+472>>3]=s-v;i=d;return}function dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+152>>3];m=+h[k+168>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];nh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+464>>3]=+h[f>>3];i=b;return}function em(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;su(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+152>>3];m=+h[k+168>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];ph(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+456>>3]=+h[f>>3];i=b;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+440>>3];i=i;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+432>>3];i=i;return}function hm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+432>>3];k=1.0-j;l=+h[g+96>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+vt(c[b+536>>2]|0,k,11056,11048,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+432>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+424>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+416|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+416|0;z=y;h[z>>3]=w;i=d;return}l=m/+vt(c[b+536>>2]|0,p,11056,11048,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+416|0;z=y;h[z>>3]=w;i=d;return}function im(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+96>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+48>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+400|0;p=o;h[p>>3]=m;i=d;return}q=k/+vt(c[b+536>>2]|0,j,11096,11088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+400|0;p=o;h[p>>3]=m;i=d;return}function jm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+8>>3];i=i;return}function km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11128]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+192>>3],1.0e-10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+192>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(11144,Wt(+h[(c[g>>2]|0)+192>>3],11136)|0)|0;g=c[21064]|0;j=e;k=11368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[11128]=1;i=d;return}function lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11392]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+184>>3],1.0e-10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(11400,Wt(+h[(c[g>>2]|0)+184>>3],11136)|0)|0;g=c[21064]|0;j=e;k=11544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[11392]=1;i=d;return}function mm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11568]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(11576,Wt(+h[(c[g>>2]|0)+56>>3],11136)|0)|0;g=c[21064]|0;j=e;k=11856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[11568]=1;i=d;return}function nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11712]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+48>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+48>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(11720,Wt(+h[(c[g>>2]|0)+48>>3],11136)|0)|0;g=c[21064]|0;j=e;k=11856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[11712]=1;i=d;return}function om(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11880]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+176>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+176>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=_t(11888,Wt(+h[(c[g>>2]|0)+176>>3],11136)|0)|0;g=c[21064]|0;j=e;k=12032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[11880]=1;i=d;return}function pm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12056]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+168>>3],1.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+168>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=_t(12064,Wt(+h[(c[g>>2]|0)+168>>3],11136)|0)|0;g=c[21064]|0;j=e;k=12192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12056]=1;i=d;return}function qm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12216]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(12224,Wt(+h[(c[g>>2]|0)+160>>3],11136)|0)|0;g=c[21064]|0;j=e;k=12352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12216]=1;i=d;return}function rm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12376]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+152>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+152>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(12384,Wt(+h[(c[g>>2]|0)+152>>3],11136)|0)|0;g=c[21064]|0;j=e;k=12520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12376]=1;i=d;return}function sm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12544]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+40>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(12552,Wt(+h[(c[g>>2]|0)+40>>3],11136)|0)|0;g=c[21064]|0;j=e;k=12880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12544]=1;i=d;return}function tm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12712]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+32>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(12720,Wt(+h[(c[g>>2]|0)+32>>3],11136)|0)|0;g=c[21064]|0;j=e;k=12880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12712]=1;i=d;return}function um(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12904]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+144>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+144>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=_t(12912,Wt(+h[(c[g>>2]|0)+144>>3],11136)|0)|0;g=c[21064]|0;j=e;k=13088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12904]=1;i=d;return}function vm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13112]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+136>>3],1.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+136>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=_t(13120,Wt(+h[(c[g>>2]|0)+136>>3],11136)|0)|0;g=c[21064]|0;j=e;k=13280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13112]=1;i=d;return}function wm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13304]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+128>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(13312,Wt(+h[(c[g>>2]|0)+128>>3],11136)|0)|0;g=c[21064]|0;j=e;k=13472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13304]=1;i=d;return}function xm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13496]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+24>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(13504,Wt(+h[(c[g>>2]|0)+24>>3],11136)|0)|0;g=c[21064]|0;j=e;k=13768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13496]=1;i=d;return}function ym(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13632]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+16>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(13640,Wt(+h[(c[g>>2]|0)+16>>3],11136)|0)|0;g=c[21064]|0;j=e;k=13768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13632]=1;i=d;return}function zm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13792]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+120>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+120>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=_t(13800,Wt(+h[(c[g>>2]|0)+120>>3],11136)|0)|0;g=c[21064]|0;j=e;k=13936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13792]=1;i=d;return}function Am(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13960]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+112>>3],1.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+112>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=_t(13968,Wt(+h[(c[g>>2]|0)+112>>3],11136)|0)|0;g=c[21064]|0;j=e;k=14088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13960]=1;i=d;return}function Bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14112]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+104>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(14120,Wt(+h[(c[g>>2]|0)+104>>3],11136)|0)|0;g=c[21064]|0;j=e;k=14240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14112]=1;i=d;return}function Cm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14264]&1){i=d;return}g=b+416|0;b=Gw(+h[(c[g>>2]|0)+96>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[g>>2]|0)+96>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(14272,Wt(+h[(c[g>>2]|0)+96>>3],11136)|0)|0;g=c[21064]|0;j=e;k=14392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14264]=1;i=d;return}function Dm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14416]&1){i=d;return}g=b+416|0;if(!((Gw(+h[(c[g>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=d;return}b=_t(14424,Wt(+h[(c[g>>2]|0)+72>>3],11136)|0)|0;g=c[21064]|0;j=e;k=14496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14416]=1;i=d;return}function Em(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14520]&1){i=d;return}g=b+416|0;if(!((Gw(+h[(c[g>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=d;return}b=_t(14528,Wt(+h[(c[g>>2]|0)+64>>3],11136)|0)|0;g=c[21064]|0;j=e;k=14600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14520]=1;i=d;return}function Fm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14624]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],.001)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],.25)|0)<<24>>24==0)){i=d;return}b=_t(14632,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14624]=1;i=d;return}function Gm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14792]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(14800,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14792]=1;i=d;return}function Hm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14960]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],.001)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],.25)|0)<<24>>24==0)){i=d;return}b=_t(14968,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14960]=1;i=d;return}function Im(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15120]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(15128,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15120]=1;i=d;return}function Jm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15400]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(15408,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15400]=1;i=d;return}function Km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15560]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(15568,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15560]=1;i=d;return}function Lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15728]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(15736,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],11136)|0)|0;g=c[21064]|0;j=e;k=15864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15728]=1;i=d;return}function Mm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15888]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(15896,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],11136)|0)|0;g=c[21064]|0;j=e;k=17048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15888]=1;i=d;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16064]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(16072,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],11136)|0)|0;g=c[21064]|0;j=e;k=16208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16064]=1;i=d;return}function Om(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16232]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(16240,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],11136)|0)|0;g=c[21064]|0;j=e;k=16384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16232]=1;i=d;return}function Pm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16408]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(16416,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],11136)|0)|0;g=c[21064]|0;j=e;k=16552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16408]=1;i=d;return}function Qm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16576]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=_t(16584,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],11136)|0)|0;g=c[21064]|0;j=e;k=16712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16576]=1;i=d;return}function Rm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16736]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(16744,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],11136)|0)|0;g=c[21064]|0;j=e;k=16880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16736]=1;i=d;return}function Sm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16904]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(16912,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],11136)|0)|0;g=c[21064]|0;j=e;k=17048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16904]=1;i=d;return}function Tm(a){a=a|0;var b=0;b=i;Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Kl(a);Ll(a);Ml(a);Nl(a);Ol(a);Pl(a);Ql(a);Rl(a);Sl(a);Tl(a);Ul(a);Vl(a);Wl(a);Xl(a);Yl(a);Zl(a);_l(a);$l(a);am(a);bm(a);cm(a);dm(a);em(a);fm(a);gm(a);hm(a);im(a);jm(a);km(a);lm(a);mm(a);nm(a);om(a);pm(a);qm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);ym(a);zm(a);Am(a);Bm(a);Cm(a);Dm(a);Em(a);Fm(a);Gm(a);Hm(a);Im(a);Jm(a);Km(a);Lm(a);Mm(a);Nm(a);Om(a);Pm(a);Qm(a);Rm(a);Sm(a);i=b;return 0}function Um(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Vm(b);i=c;return 0}function Vm(a){a=a|0;var b=0;b=i;_e(a);$e(a);af(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);jf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);xf(a);yf(a);Ff(a);Gf(a);Hf(a);Lf(a);Mf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);i=b;return}function Wm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17072]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(17088,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],17080)|0)|0;g=c[21064]|0;j=e;k=17296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17072]=1;i=d;return}function Xm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17320]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(17328,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17320]=1;i=d;return}function Ym(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17472]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(17480,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17472]=1;i=d;return}function Zm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17632]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(17640,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],17080)|0)|0;g=c[21064]|0;j=e;k=17768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17632]=1;i=d;return}function _m(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17792]&1){i=d;return}g=b+4|0;b=Gw(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(17800,Wt(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],17080)|0)|0;g=c[21064]|0;j=e;k=17928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17792]=1;i=d;return}function $m(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17952]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=_t(17960,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],17080)|0)|0;g=c[21064]|0;j=e;k=18096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17952]=1;i=d;return}function an(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18120]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(18128,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18120]=1;i=d;return}function bn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18248]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=_t(18256,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],17080)|0)|0;g=c[21064]|0;j=e;k=18376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18248]=1;i=d;return}function cn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18400]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(18408,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],17080)|0)|0;g=c[21064]|0;j=e;k=18536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18400]=1;i=d;return}function dn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18560]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(18568,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18560]=1;i=d;return}function en(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18704]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=_t(18712,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18704]=1;i=d;return}function fn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18840]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],.001)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],.25)|0)<<24>>24==0)){i=d;return}b=_t(18848,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],17080)|0)|0;g=c[21064]|0;j=e;k=18976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18840]=1;i=d;return}function gn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19e3]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(19008,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],17080)|0)|0;g=c[21064]|0;j=e;k=19232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19e3]=1;i=d;return}function hn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19256]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(19264,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19256]=1;i=d;return}function jn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19400]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(19408,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19400]=1;i=d;return}function kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19544]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(19552,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19544]=1;i=d;return}function ln(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19680]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(19688,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19680]=1;i=d;return}function mn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19816]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(19824,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19816]=1;i=d;return}function nn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19984]&1){i=d;return}g=b+4|0;if(!((Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=_t(19992,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19984]=1;i=d;return}function on(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20096]&1){i=d;return}g=b+4|0;if(!((Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=d;return}b=_t(20104,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20096]=1;i=d;return}function pn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20216]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(20224,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20216]=1;i=d;return}function qn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20408]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(20416,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20408]=1;i=d;return}function rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20608]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=_t(20616,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20608]=1;i=d;return}function sn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20800]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(20808,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],17080)|0)|0;g=c[21064]|0;j=e;k=20984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20800]=1;i=d;return}function tn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21008]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(21016,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21008]=1;i=d;return}function un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21208]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(21216,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21208]=1;i=d;return}function vn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21400]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(21408,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21400]=1;i=d;return}function wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21592]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(21600,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],17080)|0)|0;g=c[21064]|0;j=e;k=21792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21592]=1;i=d;return}function xn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21816]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(21824,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21816]=1;i=d;return}function yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22e3]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(22008,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22e3]=1;i=d;return}function zn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22192]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=_t(22200,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22192]=1;i=d;return}function An(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22360]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=_t(22368,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22360]=1;i=d;return}function Bn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22520]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=_t(22528,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22520]=1;i=d;return}function Cn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22712]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(22720,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],17080)|0)|0;g=c[21064]|0;j=e;k=22888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22712]=1;i=d;return}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22912]&1){i=d;return}g=b+4|0;b=Gw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Fw(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=_t(22920,Wt(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],17080)|0)|0;g=c[21064]|0;j=e;k=23056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22912]=1;i=d;return}function En(a){a=a|0;var b=0;b=i;Wm(a);Xm(a);Ym(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);fn(a);gn(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);qn(a);rn(a);sn(a);tn(a);un(a);vn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);i=b;return 0}function Fn(a){a=a|0;i=i;return 1}function Gn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=3;c[a+48>>2]=3;c[a+72>>2]=XX(3,8)|0;a=XX(3,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=XX(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=VX(12)|0;c[(c[d>>2]|0)+52>>2]=a;a=VX(36)|0;c[(c[d>>2]|0)+56>>2]=a;a=VX(12)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=3;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=3;c[e+4>>2]=6;c[e+8>>2]=9;Hn(e,c[a+56>>2]|0);a=c[d>>2]|0;In(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Jn(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+8>>2]=1;c[a>>2]=2;c[a+4>>2]=3;i=b;return 0}function Hn(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function In(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -3<<2)>>2]=1;c[b+((c[a>>2]|0)+ -2<<2)>>2]=0;c[b+((c[a>>2]|0)+ -1<<2)>>2]=2;i=i;return}function Jn(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function Kn(a){a=a|0;i=i;return 1}function Ln(a){a=a|0;i=i;return 1}function Mn(a){a=a|0;i=i;return 1}function Nn(a){a=a|0;i=i;return 0}function On(a){a=a|0;i=i;return 0}function Pn(a){a=a|0;i=i;return 0}function Qn(a){a=a|0;i=i;return 0}function Rn(a){a=a|0;i=i;return 0}function Sn(a,b){a=a|0;b=b|0;i=i;return-1}function Tn(a,b){a=a|0;b=b|0;i=i;return-1}function Un(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Vn(){i=i;return 23080}function Wn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function Xn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function Yn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function Zn(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(23784,n|0)|0;i=m;return 0}function _n(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=Bv(a,23792)|0;z=Bv(b,23792)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((Bv(a,23800)|0)!=0){C=5;break}if((Bv(a,23808)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((Bv(b,23800)|0)!=0){break}if((Bv(b,23808)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){BY(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}BY(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}BY(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(23816,r|0)|0;i=q;return 0}function $n(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(Bv(a,23824)|0)!=0;v=c[(u?f:g)>>2]|0;w=Bv(e,23832)|0;x=Bv(b,23840)|0;c[p>>2]=0;do{if(u){y=4}else{if((Bv(a,23848)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((Bv(b,23824)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((Bv(d,23832)|0)==0){if((Bv(d,23856)|0)!=0){break}if((Bv(d,23864)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((Bv(e,23840)|0)==0){if((Bv(e,23832)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){BY(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(Bv(d,23832)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(23872,p|0)|0;i=o;return 0}function ao(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}co(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}eo(23888,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(23880,l|0)|0;i=k;return 0}function bo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+iv(23912);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(Wn(l,z,23920)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){Yn(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;Xn(l,n,d+(x-o+v<<3)|0,23920)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;Zn(l,m,23928,d+(B+y<<3)|0,23920,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(23904,k|0)|0;i=j;return 0}function co(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=23960;u=go(23944,23936,23952,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;bo(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;fo(k,d,e,m,l,f,23944)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;fo(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,23944)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;$n(23968,23976,23984,24e3,n,k,24008,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=23984;_n(H,H,k,l,n,24016,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,24008,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);bo(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(23936,j|0)|0;i=h;return 0}function eo(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(Bv(a,24024)|0)!=0;do{if(n){o=5}else{if((Bv(a,24032)|0)!=0){o=5;break}if((Bv(a,24040)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=24056;fo(d,h,j,q,b,g,q)|0;$n(24064,24072,24080,24096,b,d,24104,e,f,h,j)|0;$n(24064,24112,24080,24120,b,d,24104,e,f,h,j)|0;i=l;return 0}else{$n(24064,24112,24136,24120,b,d,24104,e,f,h,j)|0;$n(24064,24072,24136,24096,b,d,24104,e,f,h,j)|0;fo(d,h,j,24056,b,g,24152)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(24048,m|0)|0;i=l;return 0}function fo(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function go(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=xY(d|0)|0;switch(c[b>>2]|0){case 6:{q=c[f>>2]|0;r=c[g>>2]|0;s=~~(+(((q|0)>(r|0)?r:q)|0)*1.600000023841858);i=k;return s|0};case 7:{s=1;i=k;return s|0};case 8:{s=50;i=k;return s|0};case 9:{s=25;i=k;return s|0};case 10:{s=ho(24392,24400,24408)|0;i=k;return s|0};case 3:case 2:case 1:{q=o;EL(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;t=o+1|0;u=a[t]|0;if((u+ -97<<24>>24&255)<26){a[t]=u+ -32<<24>>24}u=o+2|0;t=a[u]|0;if((t+ -97<<24>>24&255)<26){a[u]=t+ -32<<24>>24}t=o+3|0;u=a[t]|0;if((u+ -97<<24>>24&255)<26){a[t]=u+ -32<<24>>24}u=o+4|0;t=a[u]|0;if((t+ -97<<24>>24&255)<26){a[u]=t+ -32<<24>>24}t=o+5|0;u=a[t]|0;if(!((u+ -97<<24>>24&255)<26)){v=r;break}a[t]=u+ -32<<24>>24;v=r}else{v=p}}while(0);p=v<<24>>24==83;q=v<<24>>24==68;r=p|q;if(!(v<<24>>24==67|v<<24>>24==68|v<<24>>24==83|v<<24>>24==90)){s=1;i=k;return s|0}u=l;EL(u,o+1|0,1,2);l=m;EL(l,o+3|0,1,3);o=n;EL(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((DL(u,24160,1,2)|0)==0){if((DL(l,24176,1,3)|0)==0){s=128;i=k;return s|0}if((DL(l,24184,1,3)|0)==0){s=128;i=k;return s|0}if((DL(l,24192,1,3)|0)==0){s=128;i=k;return s|0}if((DL(l,24200,1,3)|0)==0){s=128;i=k;return s|0}if((DL(l,24208,1,3)|0)==0){s=128;i=k;return s|0}n=(DL(l,24216,1,3)|0)==0;s=n?128:0;i=k;return s|0}if((DL(u,24240,1,2)|0)==0){if(!(v<<24>>24==68|v<<24>>24==83)){s=0;i=k;return s|0}n=(DL(l,24248,1,3)|0)==0;s=n?32:0;i=k;return s|0}if(v<<24>>24==68|v<<24>>24==83){w=141}else if(v<<24>>24==67|v<<24>>24==90){w=138}else{s=0;i=k;return s|0}do{if((w|0)==138){if((DL(u,24264,1,2)|0)==0){n=(DL(l,24248,1,3)|0)==0;s=n?32:0;i=k;return s|0}else{if(v<<24>>24==68|v<<24>>24==83){w=141;break}else if(v<<24>>24==67|v<<24>>24==90){break}else{s=0}i=k;return s|0}}}while(0);do{if((w|0)==141){if((DL(u,24272,1,2)|0)!=0){if(v<<24>>24==67|v<<24>>24==90){break}else{s=0}i=k;return s|0}if((a[l]|0)!=71){s=0;i=k;return s|0}do{if((DL(o,24280,1,2)|0)!=0){if((DL(o,24288,1,2)|0)==0){break}if((DL(o,24296,1,2)|0)==0){break}if((DL(o,24304,1,2)|0)==0){break}if((DL(o,24312,1,2)|0)==0){break}if((DL(o,24320,1,2)|0)==0){break}if((DL(o,24328,1,2)|0)==0){break}else{s=0}i=k;return s|0}}while(0);s=128;i=k;return s|0}}while(0);if((DL(u,24336,1,2)|0)!=0){s=0;i=k;return s|0}if((a[l]|0)!=71){s=0;i=k;return s|0}do{if((DL(o,24280,1,2)|0)!=0){if((DL(o,24288,1,2)|0)==0){break}if((DL(o,24296,1,2)|0)==0){break}if((DL(o,24304,1,2)|0)==0){break}if((DL(o,24312,1,2)|0)==0){break}if((DL(o,24320,1,2)|0)==0){break}if((DL(o,24328,1,2)|0)==0){break}else{s=0}i=k;return s|0}}while(0);s=128;i=k;return s|0}else if((m|0)==2){if((DL(u,24160,1,2)|0)==0){if((DL(l,24176,1,3)|0)==0){s=2;i=k;return s|0}if((DL(l,24184,1,3)|0)==0){s=2;i=k;return s|0}if((DL(l,24192,1,3)|0)==0){s=2;i=k;return s|0}if((DL(l,24200,1,3)|0)==0){s=2;i=k;return s|0}if((DL(l,24208,1,3)|0)==0){s=2;i=k;return s|0}if((DL(l,24216,1,3)|0)==0){s=2;i=k;return s|0}s=2;i=k;return s|0}if((DL(u,24240,1,2)|0)==0){m=(DL(l,24168,1,3)|0)==0;if(m|(p|q)^1){s=m?8:2;i=k;return s|0}s=2;i=k;return s|0}if(v<<24>>24==67|v<<24>>24==90){w=91}else if(v<<24>>24==68|v<<24>>24==83){w=94}else{s=2;i=k;return s|0}do{if((w|0)==91){if((DL(u,24264,1,2)|0)==0){s=2;i=k;return s|0}else{if(v<<24>>24==68|v<<24>>24==83){w=94;break}else if(v<<24>>24==67|v<<24>>24==90){break}else{s=2}i=k;return s|0}}}while(0);do{if((w|0)==94){if((DL(u,24272,1,2)|0)!=0){if(v<<24>>24==67|v<<24>>24==90){break}else{s=2}i=k;return s|0}m=a[l]|0;if(m<<24>>24==77){if((DL(o,24280,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24288,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24296,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24304,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24312,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24320,1,2)|0)==0){s=2;i=k;return s|0}s=2;i=k;return s|0}else if(m<<24>>24==71){if((DL(o,24280,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24288,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24296,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24304,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24312,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24320,1,2)|0)==0){s=2;i=k;return s|0}s=2;i=k;return s|0}else{s=2;i=k;return s|0}}}while(0);if((DL(u,24336,1,2)|0)!=0){s=2;i=k;return s|0}m=a[l]|0;if(m<<24>>24==77){if((DL(o,24280,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24288,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24296,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24304,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24312,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24320,1,2)|0)==0){s=2;i=k;return s|0}s=2;i=k;return s|0}else if(m<<24>>24==71){if((DL(o,24280,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24288,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24296,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24304,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24312,1,2)|0)==0){s=2;i=k;return s|0}if((DL(o,24320,1,2)|0)==0){s=2;i=k;return s|0}s=2;i=k;return s|0}else{s=2;i=k;return s|0}}else{if((DL(u,24160,1,2)|0)==0){if((DL(l,24168,1,3)|0)==0){s=64;i=k;return s|0}if((DL(l,24176,1,3)|0)==0){s=32;i=k;return s|0}if((DL(l,24184,1,3)|0)==0){s=32;i=k;return s|0}if((DL(l,24192,1,3)|0)==0){s=32;i=k;return s|0}if((DL(l,24200,1,3)|0)==0){s=32;i=k;return s|0}if((DL(l,24208,1,3)|0)==0){s=32;i=k;return s|0}if((DL(l,24216,1,3)|0)==0){s=32;i=k;return s|0}m=(DL(l,24224,1,3)|0)==0;s=m?64:1;i=k;return s|0}if((DL(u,24232,1,2)|0)==0){m=(DL(l,24168,1,3)|0)==0;s=m?64:1;i=k;return s|0}if((DL(u,24240,1,2)|0)==0){m=(DL(l,24168,1,3)|0)==0;if(m|r^1){s=m?64:1;i=k;return s|0}m=(DL(l,24248,1,3)|0)==0;if(m){s=m?32:1;i=k;return s|0}m=(DL(l,24256,1,3)|0)==0;s=m?64:1;i=k;return s|0}do{if(v<<24>>24==67|v<<24>>24==90){if((DL(u,24264,1,2)|0)!=0){if(v<<24>>24==68|v<<24>>24==83){w=29;break}else if(v<<24>>24==67|v<<24>>24==90){w=48;break}else{break}}if((DL(l,24168,1,3)|0)==0){s=64;i=k;return s|0}if((DL(l,24248,1,3)|0)==0){s=32;i=k;return s|0}m=(DL(l,24256,1,3)|0)==0;s=m?64:1;i=k;return s|0}else if(v<<24>>24==68|v<<24>>24==83){w=29}}while(0);do{if((w|0)==29){if((DL(u,24272,1,2)|0)!=0){if(v<<24>>24==67|v<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((DL(o,24280,1,2)|0)!=0){if((DL(o,24288,1,2)|0)==0){break}if((DL(o,24296,1,2)|0)==0){break}if((DL(o,24304,1,2)|0)==0){break}if((DL(o,24312,1,2)|0)==0){break}if((DL(o,24320,1,2)|0)==0){break}if((DL(o,24328,1,2)|0)==0){break}else{s=1}i=k;return s|0}}while(0);s=32;i=k;return s|0}else if(m<<24>>24==77){do{if((DL(o,24280,1,2)|0)!=0){if((DL(o,24288,1,2)|0)==0){break}if((DL(o,24296,1,2)|0)==0){break}if((DL(o,24304,1,2)|0)==0){break}if((DL(o,24312,1,2)|0)==0){break}if((DL(o,24320,1,2)|0)==0){break}if((DL(o,24328,1,2)|0)==0){break}else{s=1}i=k;return s|0}}while(0);s=32;i=k;return s|0}else{s=1;i=k;return s|0}}}while(0);do{if((w|0)==48){if((DL(u,24336,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((DL(o,24280,1,2)|0)!=0){if((DL(o,24288,1,2)|0)==0){break}if((DL(o,24296,1,2)|0)==0){break}if((DL(o,24304,1,2)|0)==0){break}if((DL(o,24312,1,2)|0)==0){break}if((DL(o,24320,1,2)|0)==0){break}if((DL(o,24328,1,2)|0)==0){break}else{s=1}i=k;return s|0}}while(0);s=32;i=k;return s|0}else if(m<<24>>24==77){do{if((DL(o,24280,1,2)|0)!=0){if((DL(o,24288,1,2)|0)==0){break}if((DL(o,24296,1,2)|0)==0){break}if((DL(o,24304,1,2)|0)==0){break}if((DL(o,24312,1,2)|0)==0){break}if((DL(o,24320,1,2)|0)==0){break}if((DL(o,24328,1,2)|0)==0){break}else{s=1}i=k;return s|0}}while(0);s=32;i=k;return s|0}else{s=1;i=k;return s|0}}}while(0);if((DL(u,24344,1,2)|0)==0){if((DL(l,24168,1,3)|0)!=0){s=1;i=k;return s|0}s=(c[j>>2]|0)<65?1:32;i=k;return s|0}if((DL(u,24352,1,2)|0)==0){if((DL(l,24168,1,3)|0)!=0){s=1;i=k;return s|0}s=(c[g>>2]|0)<65?1:32;i=k;return s|0}if((DL(u,24320,1,2)|0)==0){o=(DL(l,24224,1,3)|0)==0;s=o?64:1;i=k;return s|0}if((DL(u,24360,1,2)|0)==0){o=(DL(l,24368,1,3)|0)==0;s=o?64:1;i=k;return s|0}if(!(v<<24>>24==68|v<<24>>24==83)){s=1;i=k;return s|0}if((DL(u,24376,1,2)|0)==0){i=k;return 1}else{s=1;i=k;return s|0}}break};case 4:{s=6;i=k;return s|0};case 5:{s=2;i=k;return s|0};case 11:{s=ho(24416,24400,24408)|0;i=k;return s|0};case 16:case 15:case 14:case 13:case 12:{s=io(b,d,e,f,g,h,j)|0;i=k;return s|0};default:{s=-1;i=k;return s|0}}return 0}function ho(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function io(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(CL(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 15:{p=o;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 12:{p=75;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function jo(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=ko(a,0,0)|0;i=b;return c|0}function ko(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=lo(a,b,c,0)|0;i=d;return e|0}function lo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=de[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=VX(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=178}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=de[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){ae[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=de[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){ae[c[b+20>>2]&255](c[j+392>>2]|0);ae[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=wp(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}ae[c[j+20>>2]&255](c[j+44>>2]|0);ae[c[j+20>>2]&255](c[j+392>>2]|0);ae[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;xp(j+416|0,j+12|0);xp(j+440|0,j+12|0);no(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}qo(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Rp()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Ip()|0}k=j;l=k;i=g;return l|0}function mo(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function no(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=37;_r(f+256|0);if((b|0)!=0){g=oo(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Jp(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function oo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Fo(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function po(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Io(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=oo(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Fo(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Fo(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Mo(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Io(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;ae[c[e+20>>2]&255](c[g+36>>2]|0);ro(c[g+44>>2]|0,e);ae[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;ae[c[e+20>>2]&255](f)}ro(c[h+376>>2]|0,e);ro(c[e+372>>2]|0,e);so(e+416|0);so(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}to(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);ae[c[e+20>>2]&255](c[e+392>>2]|0);ae[c[e+20>>2]&255](c[e+464>>2]|0);ae[c[e+20>>2]&255](c[e+8>>2]|0);ae[c[e+20>>2]&255](c[e+44>>2]|0);ae[c[e+20>>2]&255](c[e+396>>2]|0);ae[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){ae[c[e+252>>2]&255](c[e+244>>2]|0)}ae[c[e+20>>2]&255](e);i=d;return}function ro(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;ae[c[a+20>>2]&255](c[b+16>>2]|0);ae[c[a+20>>2]&255](b)}i=d;return}function so(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ae[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ae[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function to(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Go(f,g+20|0);while(1){d=Ho(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}ae[c[b+8>>2]&255](c[d+20>>2]|0)}Lo(g);Lo(g+132|0);Lo(g+20|0);Lo(g+40|0);Lo(g+60|0);so(g+80|0);so(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ae[m&255](o);i=e;return}ae[c[b+8>>2]&255](c[g+184>>2]|0);ae[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ae[m&255](o);i=e;return}function uo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function vo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}



function OU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function PU(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function QU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function RU(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=109192;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}cY(e)}}while(0);bY(b);i=d;return}function SU(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=109192;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}cY(e);i=d;return}function TU(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(yd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function UU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(yd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function VU(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function WU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function XU(a,b){a=a|0;b=b|0;i=i;return b|0}function YU(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function ZU(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function _U(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function $U(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function aV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function bV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function cV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function dV(a){a=a|0;i=i;return 1}function eV(a){a=a|0;i=i;return 1}function fV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function gV(a){a=a|0;i=i;return 1}function hV(a){a=a|0;var b=0;b=i;pU(a);bY(a);i=b;return}function iV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=$W(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=_W(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=_W(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function jV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=XW(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=WW(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=WW(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function kV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=_W(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function lV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=ZW(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function mV(a){a=a|0;i=i;return 0}function nV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=VW(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function oV(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function pV(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function qV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=rV(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function rV(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function sV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=tV(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function tV(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function uV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function vV(a){a=a|0;i=i;return 0}function wV(a){a=a|0;i=i;return 0}function xV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=yV(c,d,e,1114111,0)|0;i=b;return a|0}function yV(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function zV(a){a=a|0;i=i;return 4}function AV(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function BV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=CV(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function CV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function DV(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=EV(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function EV(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function FV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function GV(a){a=a|0;i=i;return 0}function HV(a){a=a|0;i=i;return 0}function IV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=JV(c,d,e,1114111,0)|0;i=b;return a|0}function JV(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function KV(a){a=a|0;i=i;return 4}function LV(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function MV(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function NV(a){a=a|0;var b=0;b=i;c[a>>2]=109344;QN(a+12|0);bY(a);i=b;return}function OV(a){a=a|0;var b=0;b=i;c[a>>2]=109344;QN(a+12|0);i=b;return}function PV(a){a=a|0;var b=0;b=i;c[a>>2]=109384;QN(a+16|0);bY(a);i=b;return}function QV(a){a=a|0;var b=0;b=i;c[a>>2]=109384;QN(a+16|0);i=b;return}function RV(b){b=b|0;i=i;return a[b+8|0]|0}function SV(a){a=a|0;i=i;return c[a+8>>2]|0}function TV(b){b=b|0;i=i;return a[b+9|0]|0}function UV(a){a=a|0;i=i;return c[a+12>>2]|0}function VV(a,b){a=a|0;b=b|0;var c=0;c=i;GN(a,b+12|0);i=c;return}function WV(a,b){a=a|0;b=b|0;var c=0;c=i;GN(a,b+16|0);i=c;return}function XV(a,b){a=a|0;b=b|0;b=i;IN(a,109416,4);i=b;return}function YV(a,b){a=a|0;b=b|0;b=i;qO(a,109424,vX(109424)|0);i=b;return}function ZV(a,b){a=a|0;b=b|0;b=i;IN(a,109448,5);i=b;return}function _V(a,b){a=a|0;b=b|0;b=i;qO(a,109456,vX(109456)|0);i=b;return}function $V(b){b=b|0;var d=0,e=0;b=i;if((a[109488]|0)!=0){d=109480;e=c[27370]|0;i=b;return e|0}if((Za(109488)|0)==0){d=109480;e=c[27370]|0;i=b;return e|0}do{if((a[116688]|0)==0){if((Za(116688)|0)==0){break}BY(116520,0,168)|0;Ud(204,0,q|0)|0;Tb(116688)}}while(0);TN(116520,116696)|0;TN(116532|0,116704)|0;TN(116544|0,116712)|0;TN(116556|0,116720)|0;TN(116568|0,116736)|0;TN(116580|0,116752)|0;TN(116592|0,116760)|0;TN(116604|0,116776)|0;TN(116616|0,116784)|0;TN(116628|0,116792)|0;TN(116640|0,116800)|0;TN(116652|0,116808)|0;TN(116664|0,116816)|0;TN(116676|0,116824)|0;c[27370]=116520;Tb(109488);d=109480;e=c[27370]|0;i=b;return e|0}function aW(b){b=b|0;var d=0,e=0;b=i;if((a[109504]|0)!=0){d=109496;e=c[27374]|0;i=b;return e|0}if((Za(109504)|0)==0){d=109496;e=c[27374]|0;i=b;return e|0}do{if((a[116152]|0)==0){if((Za(116152)|0)==0){break}BY(115984,0,168)|0;Ud(205,0,q|0)|0;Tb(116152)}}while(0);tO(115984,116160)|0;tO(115996|0,116192)|0;tO(116008|0,116224)|0;tO(116020|0,116256)|0;tO(116032|0,116296)|0;tO(116044|0,116336)|0;tO(116056|0,116368)|0;tO(116068|0,116408)|0;tO(116080|0,116424)|0;tO(116092|0,116440)|0;tO(116104|0,116456)|0;tO(116116|0,116472)|0;tO(116128|0,116488)|0;tO(116140|0,116504)|0;c[27374]=115984;Tb(109504);d=109496;e=c[27374]|0;i=b;return e|0}function bW(b){b=b|0;var d=0,e=0;b=i;if((a[109520]|0)!=0){d=109512;e=c[27378]|0;i=b;return e|0}if((Za(109520)|0)==0){d=109512;e=c[27378]|0;i=b;return e|0}do{if((a[115760]|0)==0){if((Za(115760)|0)==0){break}BY(115472,0,288)|0;Ud(206,0,q|0)|0;Tb(115760)}}while(0);TN(115472,115768)|0;TN(115484|0,115776)|0;TN(115496|0,115792)|0;TN(115508|0,115800)|0;TN(115520|0,115808)|0;TN(115532|0,115816)|0;TN(115544|0,115824)|0;TN(115556|0,115832)|0;TN(115568|0,115840)|0;TN(115580|0,115856)|0;TN(115592|0,115864)|0;TN(115604|0,115880)|0;TN(115616|0,115896)|0;TN(115628|0,115904)|0;TN(115640|0,115912)|0;TN(115652|0,115920)|0;TN(115664|0,115808)|0;TN(115676|0,115928)|0;TN(115688|0,115936)|0;TN(115700|0,115944)|0;TN(115712|0,115952)|0;TN(115724|0,115960)|0;TN(115736|0,115968)|0;TN(115748|0,115976)|0;c[27378]=115472;Tb(109520);d=109512;e=c[27378]|0;i=b;return e|0}function cW(b){b=b|0;var d=0,e=0;b=i;if((a[109536]|0)!=0){d=109528;e=c[27382]|0;i=b;return e|0}if((Za(109536)|0)==0){d=109528;e=c[27382]|0;i=b;return e|0}do{if((a[114920]|0)==0){if((Za(114920)|0)==0){break}BY(114632,0,288)|0;Ud(207,0,q|0)|0;Tb(114920)}}while(0);tO(114632,114928)|0;tO(114644|0,114960)|0;tO(114656|0,115e3)|0;tO(114668|0,115024)|0;tO(114680|0,115344)|0;tO(114692|0,115048)|0;tO(114704|0,115072)|0;tO(114716|0,115096)|0;tO(114728|0,115128)|0;tO(114740|0,115168)|0;tO(114752|0,115200)|0;tO(114764|0,115240)|0;tO(114776|0,115280)|0;tO(114788|0,115296)|0;tO(114800|0,115312)|0;tO(114812|0,115328)|0;tO(114824|0,115344)|0;tO(114836|0,115360)|0;tO(114848|0,115376)|0;tO(114860|0,115392)|0;tO(114872|0,115408)|0;tO(114884|0,115424)|0;tO(114896|0,115440)|0;tO(114908|0,115456)|0;c[27382]=114632;Tb(109536);d=109528;e=c[27382]|0;i=b;return e|0}function dW(b){b=b|0;var d=0,e=0;b=i;if((a[109552]|0)!=0){d=109544;e=c[27386]|0;i=b;return e|0}if((Za(109552)|0)==0){d=109544;e=c[27386]|0;i=b;return e|0}do{if((a[114608]|0)==0){if((Za(114608)|0)==0){break}BY(114320,0,288)|0;Ud(208,0,q|0)|0;Tb(114608)}}while(0);TN(114320,114616)|0;TN(114332|0,114624)|0;c[27386]=114320;Tb(109552);d=109544;e=c[27386]|0;i=b;return e|0}function eW(b){b=b|0;var d=0,e=0;b=i;if((a[109568]|0)!=0){d=109560;e=c[27390]|0;i=b;return e|0}if((Za(109568)|0)==0){d=109560;e=c[27390]|0;i=b;return e|0}do{if((a[114280]|0)==0){if((Za(114280)|0)==0){break}BY(113992,0,288)|0;Ud(209,0,q|0)|0;Tb(114280)}}while(0);tO(113992,114288)|0;tO(114004|0,114304)|0;c[27390]=113992;Tb(109568);d=109560;e=c[27390]|0;i=b;return e|0}function fW(b){b=b|0;var c=0;b=i;if((a[109592]|0)!=0){c=109576;i=b;return c|0}if((Za(109592)|0)==0){c=109576;i=b;return c|0}IN(109576,109600,8);Ud(210,109576,q|0)|0;Tb(109592);c=109576;i=b;return c|0}function gW(b){b=b|0;var c=0;b=i;if((a[109632]|0)!=0){c=109616;i=b;return c|0}if((Za(109632)|0)==0){c=109616;i=b;return c|0}qO(109616,109640,vX(109640)|0);Ud(211,109616,q|0)|0;Tb(109632);c=109616;i=b;return c|0}function hW(b){b=b|0;var c=0;b=i;if((a[109696]|0)!=0){c=109680;i=b;return c|0}if((Za(109696)|0)==0){c=109680;i=b;return c|0}IN(109680,109704,8);Ud(210,109680,q|0)|0;Tb(109696);c=109680;i=b;return c|0}function iW(b){b=b|0;var c=0;b=i;if((a[109736]|0)!=0){c=109720;i=b;return c|0}if((Za(109736)|0)==0){c=109720;i=b;return c|0}qO(109720,109744,vX(109744)|0);Ud(211,109720,q|0)|0;Tb(109736);c=109720;i=b;return c|0}function jW(b){b=b|0;var c=0;b=i;if((a[109800]|0)!=0){c=109784;i=b;return c|0}if((Za(109800)|0)==0){c=109784;i=b;return c|0}IN(109784,109808,20);Ud(210,109784,q|0)|0;Tb(109800);c=109784;i=b;return c|0}function kW(b){b=b|0;var c=0;b=i;if((a[109848]|0)!=0){c=109832;i=b;return c|0}if((Za(109848)|0)==0){c=109832;i=b;return c|0}qO(109832,109856,vX(109856)|0);Ud(211,109832,q|0)|0;Tb(109848);c=109832;i=b;return c|0}function lW(b){b=b|0;var c=0;b=i;if((a[109960]|0)!=0){c=109944;i=b;return c|0}if((Za(109960)|0)==0){c=109944;i=b;return c|0}IN(109944,109968,11);Ud(210,109944,q|0)|0;Tb(109960);c=109944;i=b;return c|0}function mW(b){b=b|0;var c=0;b=i;if((a[11e4]|0)!=0){c=109984;i=b;return c|0}if((Za(11e4)|0)==0){c=109984;i=b;return c|0}qO(109984,110008,vX(110008)|0);Ud(211,109984,q|0)|0;Tb(11e4);c=109984;i=b;return c|0}function nW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);l=+rY(b,g,c[27266]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function oW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);l=+rY(b,g,c[27266]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function pW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);l=+rY(b,g,c[27266]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function qW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);n=lb(b|0,h|0,f|0,c[27266]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function rW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);m=lb(b|0,h|0,f|0,c[27266]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function sW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);m=lb(b|0,h|0,f|0,c[27266]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function tW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);m=lb(b|0,h|0,f|0,c[27266]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function uW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);n=Gc(b|0,h|0,f|0,c[27266]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function vW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109072]|0)==0){if((Za(109072)|0)==0){break}c[27266]=Zb(2147483647,109080,0)|0;Tb(109072)}}while(0);m=Gc(b|0,h|0,f|0,c[27266]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function wW(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;ae[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;ae[h&255](a);i=b;return}}function xW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){qU(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=$X(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;zY(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{bY(h);i=e;return}}function yW(a){a=a|0;a=i;sO(114268|0);sO(114256|0);sO(114244|0);sO(114232|0);sO(114220|0);sO(114208|0);sO(114196|0);sO(114184|0);sO(114172|0);sO(114160|0);sO(114148|0);sO(114136|0);sO(114124|0);sO(114112|0);sO(114100|0);sO(114088|0);sO(114076|0);sO(114064|0);sO(114052|0);sO(114040|0);sO(114028|0);sO(114016|0);sO(114004|0);sO(113992);i=a;return}function zW(a){a=a|0;a=i;QN(114596|0);QN(114584|0);QN(114572|0);QN(114560|0);QN(114548|0);QN(114536|0);QN(114524|0);QN(114512|0);QN(114500|0);QN(114488|0);QN(114476|0);QN(114464|0);QN(114452|0);QN(114440|0);QN(114428|0);QN(114416|0);QN(114404|0);QN(114392|0);QN(114380|0);QN(114368|0);QN(114356|0);QN(114344|0);QN(114332|0);QN(114320);i=a;return}function AW(a){a=a|0;a=i;sO(114908|0);sO(114896|0);sO(114884|0);sO(114872|0);sO(114860|0);sO(114848|0);sO(114836|0);sO(114824|0);sO(114812|0);sO(114800|0);sO(114788|0);sO(114776|0);sO(114764|0);sO(114752|0);sO(114740|0);sO(114728|0);sO(114716|0);sO(114704|0);sO(114692|0);sO(114680|0);sO(114668|0);sO(114656|0);sO(114644|0);sO(114632);i=a;return}function BW(a){a=a|0;a=i;QN(115748|0);QN(115736|0);QN(115724|0);QN(115712|0);QN(115700|0);QN(115688|0);QN(115676|0);QN(115664|0);QN(115652|0);QN(115640|0);QN(115628|0);QN(115616|0);QN(115604|0);QN(115592|0);QN(115580|0);QN(115568|0);QN(115556|0);QN(115544|0);QN(115532|0);QN(115520|0);QN(115508|0);QN(115496|0);QN(115484|0);QN(115472);i=a;return}function CW(a){a=a|0;a=i;sO(116140|0);sO(116128|0);sO(116116|0);sO(116104|0);sO(116092|0);sO(116080|0);sO(116068|0);sO(116056|0);sO(116044|0);sO(116032|0);sO(116020|0);sO(116008|0);sO(115996|0);sO(115984);i=a;return}function DW(a){a=a|0;a=i;QN(116676|0);QN(116664|0);QN(116652|0);QN(116640|0);QN(116628|0);QN(116616|0);QN(116604|0);QN(116592|0);QN(116580|0);QN(116568|0);QN(116556|0);QN(116544|0);QN(116532|0);QN(116520);i=a;return}function EW(a){a=a|0;var b=0,c=0;b=i;if((KW(a)|0)==0){c=(FW(a)|0)!=0|0}else{c=1}i=b;return c|0}function FW(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[116832+((d[116832+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function GW(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function HW(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function IW(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 9:{d=OW(a)|0;break};case 1:{d=EW(a)|0;break};case 10:{d=PW(a)|0;break};case 3:{d=GW(a)|0;break};case 12:{d=RW(a)|0;break};case 4:{d=HW(a)|0;break};case 8:{d=NW(a)|0;break};case 7:{d=MW(a)|0;break};case 5:{d=KW(a)|0;break};case 2:{d=FW(a)|0;break};case 6:{d=LW(a)|0;break};case 11:{d=QW(a)|0;break};default:{d=0}}i=c;return d|0}function JW(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=119808;while(1){if(d<<24>>24==e<<24>>24){if((tY(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function KW(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function LW(a){a=a|0;var b=0,c=0;b=i;if((PW(a)|0)==0){c=(NW(a)|0)!=0|0}else{c=0}i=b;return c|0}function MW(a){a=a|0;var b=0,c=0;b=i;if((SW(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function NW(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function OW(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[119888+((d[119888+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function PW(a){a=a|0;var b=0,c=0;b=i;c=(uX(123056,a)|0)!=0|0;i=b;return c|0}function QW(a){a=a|0;var b=0,c=0;b=i;c=(UW(a)|0)!=(a|0)|0;i=b;return c|0}function RW(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function SW(a){a=a|0;var b=0,c=0;b=i;c=TW(a,0)|0;i=b;return c|0}function TW(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((FW(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[123146+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[123144+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[123147+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[123392+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[123392+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[123392+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function UW(a){a=a|0;var b=0,c=0;b=i;c=TW(a,1)|0;i=b;return c|0}function VW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=WW(0,a,b,(c|0)!=0?c:124096)|0;i=d;return e|0}function WW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?124104:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[123888+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function XW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=YW(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=WW(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function YW(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[123888+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[123888+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function ZW(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[123888+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function _W(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function $W(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=aX(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=_W(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function aX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=_W(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=_W(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=_W(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}_W(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function bX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=VX(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=VX(2048)|0;c[p+16>>2]=s;if((s|0)==0){WX(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=rX(0,0)|0;if((s|0)==0){WX(c[p+16>>2]|0);WX(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=cX(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=XX(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=dX(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=VX(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;BY(y|0,-1,v|0)|0;I=H}else{I=0}H=XX(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=XX(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=dX(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=jX(q,x)|0;b:do{if((v|0)==0){y=jX(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==1){T=c[S+4>>2]|0;U=jX(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=jX(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=jX(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}X=jX(q,0)|0}else if((P|0)==3){U=c[S+4>>2]|0;T=jX(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=jX(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=jX(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}X=jX(q,0)|0}else if((P|0)==2){T=c[S+4>>2]|0;U=jX(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=jX(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=jX(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=jX(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=jX(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{Y=L}}if((F|0)==45){F=0;c[j>>2]=0;Y=0}Z=Y;_=M+1|0;$=N;break}else if((P|0)==0){P=c[S+4>>2]|0;T=c[P>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Z=L;_=M;$=N;break}T=P+8|0;P=(c[T>>2]|0)+L|0;c[T>>2]=P;if((P|0)<=(c[k>>2]|0)){Z=L;_=M;$=N;break}c[k>>2]=P;Z=L;_=M;$=N;break}else{Z=L;_=M;$=N;break}if((X|0)==0){Z=L;_=M;$=N}else{V=N;W=X;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=kX(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=tX(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=tX(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=kX(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=tX(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=tX(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=kX(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=tX(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=tX(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=tX(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=tX(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=tX(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=tX(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=tX(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=tX(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Z=da;_=U;$=T;break}c[j>>2]=T;Z=T;_=0;$=T}else{Z=L;_=M;$=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Z;M=_;N=$;O=S}else{V=$;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=tX(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=tX(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=tX(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=tX(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=jX(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=jX(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==2){M=c[ya+4>>2]|0;L=c[M>>2]|0;Q=L+8|0;if((c[Q>>2]|0)==0){za=0}else{za=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[Q>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Aa=M+4|0}else{Q=iX(q,L,0,0,g)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Ba=VX((c[g>>2]<<2)+4|0)|0;Q=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=iX(q,c[M>>2]|0,Q,h,0)|0;if((Ca|0)!=0){F=150;break g}L=M+4|0;R=hX(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,Q,c[h>>2]|0)|0;Q=ya+24|0;c[Q>>2]=R;WX(Ba);if((c[Q>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=L}}L=c[Aa>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}Q=iX(q,L,0,0,g)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Da=VX((c[g>>2]<<2)+4|0)|0;Q=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=iX(q,c[Aa>>2]|0,Q,h,0)|0;if((Ea|0)!=0){F=157;break g}L=hX(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,Q,c[h>>2]|0)|0;Q=ya+28|0;c[Q>>2]=L;WX(Da);if((c[Q>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){Q=c[ya+4>>2]|0;L=c[Q>>2]|0;do{if((c[Q+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[Q>>2]|0)+28>>2]}else if((S|0)==1){M=c[ya+4>>2]|0;R=c[M>>2]|0;T=M+4|0;U=c[T>>2]|0;if((c[R+8>>2]|0)==0){Fa=(c[U+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;ba=hX(s,c[R+24>>2]|0,c[U+24>>2]|0,0,0)|0;c[ya+24>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}ba=hX(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[T>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=ba;if((ba|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){ba=c[ya>>2]|0;if((ba|0)==3){T=jX(q,ya)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=jX(q,1)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=ya+4|0;M=jX(q,c[(c[T>>2]|0)+4>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,c[c[T>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else if((ba|0)==2){M=jX(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else if((ba|0)==1){M=jX(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=jX(q,2)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;T=jX(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=jX(q,0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=jX(q,c[c[M>>2]>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=jX(q,0)|0;if((T|0)==0){break}else{z=0;A=T;B=0;C=D;break a}}else if((ba|0)==0){ba=c[ya+4>>2]|0;T=c[ba>>2]|0;if((T|0)==-4){c[ya+8>>2]=0;M=ba+8|0;U=c[M>>2]|0;R=tX(s,0,0,1,64)|0;if((R|0)==0){F=104;break g}la=R;c[R>>2]=U;c[R+4>>2]=0;c[R+8>>2]=1114111;c[R+20>>2]=0;c[R+24>>2]=0;U=R+28|0;R=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[R>>2]=la;la=c[M>>2]|0;M=c[ba+4>>2]|0;R=tX(s,0,0,1,64)|0;if((R|0)==0){F=106;break g}c[R>>2]=la;c[R+4>>2]=0;c[R+8>>2]=1114111;c[R+20>>2]=0;c[R+24>>2]=0;c[R+28>>2]=M;c[R+32>>2]=-1;c[R+36>>2]=-1;c[R+40>>2]=-1;c[ya+28>>2]=R;break}R=ya+8|0;if((T|0)<0){c[R>>2]=1;M=tX(s,0,0,1,32)|0;if((M|0)==0){F=110;break g}c[M>>2]=-1;c[M+4>>2]=-1;c[M+8>>2]=-1;c[ya+24>>2]=M;M=tX(s,0,0,1,32)|0;if((M|0)==0){F=112;break g}c[M>>2]=-1;c[M+4>>2]=-1;c[M+8>>2]=-1;c[ya+28>>2]=M;break}else{c[R>>2]=0;R=ba+8|0;M=c[R>>2]|0;la=ba+4|0;U=c[la>>2]|0;ma=tX(s,0,0,1,64)|0;if((ma|0)==0){F=115;break g}ka=ma;c[ma>>2]=M;c[ma+4>>2]=T;c[ma+8>>2]=U;c[ma+20>>2]=0;c[ma+24>>2]=0;U=ma+28|0;ma=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ma>>2]=ka;ka=c[R>>2]|0;R=c[ba>>2]|0;ma=c[la>>2]|0;la=c[ba+12>>2]|0;U=c[ba+16>>2]|0;ba=tX(s,0,0,1,64)|0;if((ba|0)==0){F=117;break g}T=ba;c[ba>>2]=ka;c[ba+4>>2]=R;c[ba+8>>2]=ma;c[ba+20>>2]=la;c[ba+24>>2]=U;U=ba+28|0;ba=ya+28|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=T;break}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){WX(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){WX(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=VX(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=VX(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){BY(O|0,0,((E|0)>1?E<<2:4)|0)|0}eX(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;T=O+(S<<2)|0;ba=K+1+(c[T>>2]|0)|0;c[T>>2]=0;T=S+1|0;if((T|0)<(E|0)){S=T;K=ba}else{Ga=ba;break}}}else{Ga=0}K=XX(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;ba=eX(y,S,x,u)|0;if((ba|0)!=0){z=x;A=ba;B=u;C=D;break}c[w+20>>2]=0;ba=v+24|0;S=c[ba>>2]|0;if((c[S>>2]|0)>-1){T=1;U=S;while(1){S=U+32|0;la=T+1|0;if((c[S>>2]|0)>-1){U=S;T=la}else{Ha=la;break}}}else{Ha=1}T=XX(Ha,32)|0;if((T|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=T;U=c[ba>>2]|0;y=c[U>>2]|0;if((y|0)>-1){la=y;y=U;U=0;while(1){c[T+(U<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[T+(U<<5)+12>>2]=la;S=T+(U<<5)+16|0;c[S>>2]=0;ma=y+12|0;R=c[ma>>2]|0;if((R|0)!=0){ka=0;while(1){Ia=ka+1|0;if((c[R+(ka<<2)>>2]|0)>-1){ka=Ia}else{break}}ka=Ia<<2;R=VX(ka)|0;c[S>>2]=R;if((R|0)==0){z=x;A=12;B=u;C=D;break a}zY(R|0,c[ma>>2]|0,ka|0)|0}c[T+(U<<5)+20>>2]=c[y+16>>2];ka=U+1|0;R=y+32|0;M=c[R>>2]|0;if((M|0)>-1){la=M;y=R;U=ka}else{Ja=ka;break}}}else{Ja=0}c[T+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;sX(s);WX(c[p+16>>2]|0);WX(p);WX(O);WX(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);sX(s);WX(c[p+16>>2]|0);WX(p);if((z|0)!=0){WX(z)}if((B|0)!=0){WX(B)}c[b+4>>2]=C;fX(b);r=A;i=f;return r|0}function cX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;jX(m,c[p>>2]|0)|0;jX(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=jX(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 3:{Q=jX(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=jX(m,4)|0;break};case 5:{Q=c[q>>2]|0;X=a[Q]|0;if(X<<24>>24==0){U=M;V=N;W=0;break c}Y=c[v>>2]&1;Z=(Y|0)!=0;if(Z&X<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Z&X<<24>>24==41&(M|0)>0)){if((Y|0)==0&X<<24>>24==92){if((a[Q+1|0]|0)==41){break}}_=jX(m,5)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=jX(m,N)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=jX(m,6)|0;if((_|0)!=0){R=M;S=_;T=6;break b}U=M;V=N;W=jX(m,4)|0;break c}}while(0);X=(Y|M|0)==0?8:0;Z=M+ -1|0;if((Y|0)!=0){U=Z;V=N;W=X;break c}c[q>>2]=Q+2;U=Z;V=N;W=X;break};case 4:{X=jX(m,9)|0;if((X|0)!=0){R=M;S=X;T=6;break b}U=M;V=N;W=jX(m,1)|0;break};case 0:{if((c[v>>2]&1|0)!=0){X=jX(m,7)|0;if((X|0)!=0){R=M;S=X;T=6;break b}}U=M;V=N;W=jX(m,3)|0;break};case 8:{X=L+ -2|0;c[n>>2]=X;Z=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;_=tX(X,0,0,1,32)|0;if((_|0)==0){$=12;T=294;break b}aa=tX(X,0,0,1,8)|0;X=_+4|0;c[X>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[_>>2]=3;c[_+8>>2]=-1;c[_+12>>2]=-1;c[aa>>2]=Z;c[(c[X>>2]|0)+4>>2]=N;c[_+16>>2]=(c[N+16>>2]|0)+(c[Z+16>>2]|0);U=M;V=_;W=0;break};case 6:{_=L+ -2|0;c[n>>2]=_;Z=c[P+(_<<2)>>2]|0;_=c[w>>2]|0;X=tX(_,0,0,1,32)|0;if((X|0)==0){$=12;T=294;break b}aa=tX(_,0,0,1,8)|0;_=X+4|0;c[_>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[X>>2]=1;c[X+8>>2]=-1;c[X+12>>2]=-1;c[aa>>2]=Z;c[(c[_>>2]|0)+4>>2]=N;c[X+16>>2]=(c[N+16>>2]|0)+(c[Z+16>>2]|0);U=M;V=X;W=0;break};case 2:{X=L+ -2|0;c[n>>2]=X;Z=c[P+(X<<2)>>2]|0;if((c[N+12>>2]|0)>-1){X=c[w>>2]|0;_=tX(X,0,0,1,32)|0;if((_|0)==0){$=12;T=294;break b}aa=tX(X,0,0,1,20)|0;c[_+4>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[aa>>2]=-1;c[aa+4>>2]=-1;c[aa+8>>2]=-1;aa=c[w>>2]|0;X=tX(aa,0,0,1,32)|0;if((X|0)==0){$=12;T=294;break b}ba=tX(aa,0,0,1,8)|0;aa=X+4|0;c[aa>>2]=ba;if((ba|0)==0){$=12;T=294;break b}c[X>>2]=1;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ba>>2]=_;c[(c[aa>>2]|0)+4>>2]=N;aa=N+16|0;ba=X+16|0;c[ba>>2]=(c[aa>>2]|0)+(c[_+16>>2]|0);c[ba>>2]=c[aa>>2];ca=X}else{ca=N}c[ca+12>>2]=Z;Z=ca+16|0;c[Z>>2]=(c[Z>>2]|0)+1;U=M;V=ca;W=0;break};case 10:{Z=L+ -2|0;c[n>>2]=Z;c[v>>2]=c[P+(Z<<2)>>2];U=M;V=N;W=0;break};case 7:{Z=c[q>>2]|0;X=a[Z]|0;if((X|0)==41){c[q>>2]=Z+1;U=M;V=N;W=0;break c}else if((X|0)!=124){U=M;V=N;W=0;break c}X=jX(m,7)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=jX(m,N)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=jX(m,8)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=jX(m,3)|0;if((X|0)!=0){R=M;S=X;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 1:{X=c[q>>2]|0;d:do{switch(a[X]|0){case 91:{Z=X+1|0;c[q>>2]=Z;aa=VX(128)|0;if((aa|0)==0){$=12;T=294;break b}if((a[Z]|0)==94){ba=X+2|0;c[q>>2]=ba;da=ba;ea=1}else{da=Z;ea=0}Z=(ea|0)==0;ba=aa;aa=0;_=0;fa=32;ga=da;e:while(1){ha=a[ga]|0;if(ha<<24>>24==93){if(ga>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(ha<<24>>24==0){ia=ba;ja=ga;ka=7;T=140;break}ha=ZW(e,ga,-1)|0;if((ha|0)<0){c[e>>2]=-1;la=1}else{la=ha}ha=ga+la|0;do{if((a[ha]|0)==45){ma=la+1|0;na=ga+ma|0;if((a[na]|0)==93){T=94;break}oa=c[e>>2]|0;pa=ZW(e,na,-1)|0;if((pa|0)<0){c[e>>2]=-1;qa=-1;ra=1}else{qa=c[e>>2]|0;ra=pa}sa=0;ta=qa;ua=oa;va=ga+(ra+ma)|0;wa=oa>>>0>qa>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;oa=a[ga]|0;do{if(oa<<24>>24==45){if((a[ga+1|0]|0)==93){xa=0;break}xa=(c[q>>2]|0)==(ga|0)?0:11}else if(oa<<24>>24==91){ma=a[ga+1|0]|0;if(ma<<24>>24==61|ma<<24>>24==46){ia=ba;ja=ga;ka=3;T=140;break e}else if(!(ma<<24>>24==58)){xa=0;break}ma=ga+2|0;pa=ma;while(1){na=a[pa]|0;ya=na<<24>>24==0;if(na<<24>>24!=58&(ya^1)){pa=pa+1|0}else{break}}if(ya){ia=ba;ja=ga;ka=4;T=140;break e}na=pa-ga+ -2|0;za=(na|0)>63?63:na;IY(A|0,ma|0,za|0)|0;a[f+za|0]=0;za=JW(A)|0;sa=za;ta=1114111;ua=0;va=pa+2|0;wa=(za|0)==0?4:0;break f}else{xa=0}}while(0);oa=c[e>>2]|0;sa=0;ta=oa;ua=oa;va=ha;wa=xa}}while(0);if((wa|0)!=0){ia=ba;ja=va;ka=wa;T=140;break}ha=(sa|0)!=0;do{if(Z|ha^1){oa=c[w>>2]|0;if((_|0)<(fa|0)){Aa=ba;Ba=fa}else{if((fa|0)>1024){ia=ba;ja=va;ka=12;T=140;break e}za=YX(ba,fa<<3)|0;if((za|0)==0){ia=ba;ja=va;ka=12;T=140;break e}else{Aa=za;Ba=fa<<1}}za=tX(oa,0,0,1,32)|0;if((za|0)==0){T=112;break e}na=tX(oa,0,0,1,20)|0;oa=za+4|0;c[oa>>2]=na;if((na|0)==0){T=112;break e}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[na>>2]=ua;c[na+4>>2]=ta;c[na+8>>2]=-1;c[Aa+(_<<2)>>2]=za;c[(c[oa>>2]|0)+12>>2]=sa;Ca=Aa;Da=aa;Ea=_+1|0;Fa=Ba;Ga=0}else{if((aa|0)>63){Ca=ba;Da=aa;Ea=_;Fa=fa;Ga=12;break}c[g+(aa<<2)>>2]=sa;Ca=ba;Da=aa+1|0;Ea=_;Fa=fa;Ga=0}}while(0);oa=(Ga|0)==0;if(oa&(((c[v>>2]&2|0)==0|ha)^1)){Ha=Ca;Ia=Ea;Ja=Fa;Ka=ua}else{if(oa){ba=Ca;aa=Da;_=Ea;fa=Fa;ga=va;continue}else{ia=Ca;ja=va;ka=Ga;T=140;break}}while(1){oa=Ka;while(1){if(oa>>>0>ta>>>0){ba=Ha;aa=Da;_=Ia;fa=Ja;ga=va;continue e}if((MW(oa)|0)!=0){T=118;break}La=oa+1|0;if((QW(oa)|0)==0){oa=La}else{T=129;break}}if((T|0)==118){T=0;za=SW(oa)|0;na=oa+1|0;g:do{if((MW(na)|0)==0){Ma=za;Na=na}else{Oa=za;Pa=na;while(1){if((SW(Pa)|0)!=(Oa+1|0)|Pa>>>0>ta>>>0){Ma=Oa;Na=Pa;break g}Qa=SW(Pa)|0;Ra=Pa+1|0;if((MW(Ra)|0)==0){Ma=Qa;Na=Ra;break}else{Oa=Qa;Pa=Ra}}}}while(0);na=c[w>>2]|0;if((Ia|0)<(Ja|0)){Sa=Ha;Ta=Ja}else{if((Ja|0)>1024){ia=Ha;ja=va;ka=12;T=140;break e}Pa=YX(Ha,Ja<<3)|0;if((Pa|0)==0){ia=Ha;ja=va;ka=12;T=140;break e}else{Sa=Pa;Ta=Ja<<1}}Pa=tX(na,0,0,1,32)|0;Oa=Pa;do{if((Pa|0)==0){Ua=0}else{pa=tX(na,0,0,1,20)|0;c[Pa+4>>2]=pa;if((pa|0)==0){Ua=0;break}c[Pa>>2]=0;c[Pa+8>>2]=-1;c[Pa+12>>2]=-1;c[pa>>2]=za;c[pa+4>>2]=Ma;c[pa+8>>2]=-1;Ua=Oa}}while(0);c[Sa+(Ia<<2)>>2]=Ua;Va=Ua;Wa=Sa;Xa=Ta;Ya=Na}else if((T|0)==129){T=0;Oa=UW(oa)|0;h:do{if((QW(La)|0)==0){Za=Oa;_a=La}else{za=Oa;Pa=La;while(1){if((UW(Pa)|0)!=(za+1|0)|Pa>>>0>ta>>>0){Za=za;_a=Pa;break h}na=Pa+1|0;pa=UW(Pa)|0;if((QW(na)|0)==0){Za=pa;_a=na;break}else{za=pa;Pa=na}}}}while(0);oa=c[w>>2]|0;if((Ia|0)<(Ja|0)){$a=Ha;ab=Ja}else{if((Ja|0)>1024){ia=Ha;ja=va;ka=12;T=140;break e}Pa=YX(Ha,Ja<<3)|0;if((Pa|0)==0){ia=Ha;ja=va;ka=12;T=140;break e}else{$a=Pa;ab=Ja<<1}}Pa=tX(oa,0,0,1,32)|0;za=Pa;do{if((Pa|0)==0){bb=0}else{na=tX(oa,0,0,1,20)|0;c[Pa+4>>2]=na;if((na|0)==0){bb=0;break}c[Pa>>2]=0;c[Pa+8>>2]=-1;c[Pa+12>>2]=-1;c[na>>2]=Oa;c[na+4>>2]=Za;c[na+8>>2]=-1;bb=za}}while(0);c[$a+(Ia<<2)>>2]=bb;Va=bb;Wa=$a;Xa=ab;Ya=_a}if((Va|0)==0){T=141;break e}else{Ha=Wa;Ia=Ia+1|0;Ja=Xa;Ka=Ya}}}i:do{if((T|0)==85){T=0;c[q>>2]=ga+1;fa=(ea|0)!=0;if(fa){dc(ba|0,_|0,4,59)}j:do{if((_|0)>0){Z=(aa|0)>0;ha=aa<<2;za=ha+4|0;if(fa){cb=0;db=0;eb=0;fb=0}else{Oa=0;Pa=0;while(1){oa=ba+(Oa<<2)|0;na=c[(c[oa>>2]|0)+4>>2]|0;do{if((na|0)==0){gb=Pa;hb=0}else{c[na+8>>2]=c[x>>2];if(Z){pa=tX(c[w>>2]|0,0,0,0,za)|0;ma=na+16|0;c[ma>>2]=pa;if((pa|0)==0){ib=ba;jb=Pa;kb=12;break i}zY(pa|0,z|0,ha|0)|0;c[(c[ma>>2]|0)+(aa<<2)>>2]=0}else{c[na+16>>2]=0}if((Pa|0)==0){gb=c[oa>>2]|0;hb=0;break}ma=c[w>>2]|0;pa=c[oa>>2]|0;Ra=tX(ma,0,0,1,32)|0;Qa=Ra;do{if((Ra|0)==0){lb=0}else{mb=tX(ma,0,0,1,8)|0;nb=Ra+4|0;c[nb>>2]=mb;if((mb|0)==0){lb=0;break}c[Ra>>2]=3;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[mb>>2]=Pa;c[(c[nb>>2]|0)+4>>2]=pa;c[Ra+16>>2]=(c[pa+16>>2]|0)+(c[Pa+16>>2]|0);lb=Qa}}while(0);gb=lb;hb=(lb|0)==0?12:0}}while(0);oa=Oa+1|0;if((oa|0)<(_|0)&(hb|0)==0){Oa=oa;Pa=gb}else{ob=0;pb=gb;qb=hb;break j}}}while(1){Pa=ba+(eb<<2)|0;Oa=c[(c[Pa>>2]|0)+4>>2]|0;oa=c[Oa>>2]|0;na=Oa+4|0;Qa=c[na>>2]|0;do{if((oa|0)<(cb|0)){pa=Qa+1|0;rb=(pa|0)<(cb|0)?cb:pa;sb=db;tb=fb;ub=0}else{if((oa|0)<=(db|0)){pa=Qa+1|0;rb=pa;sb=pa;tb=fb;ub=0;break}c[Oa>>2]=db;c[na>>2]=oa+ -1;pa=Qa+1|0;if((Oa|0)==0){rb=pa;sb=pa;tb=fb;ub=0;break}c[Oa+8>>2]=c[x>>2];if(Z){Ra=tX(c[w>>2]|0,0,0,0,za)|0;ma=Oa+16|0;c[ma>>2]=Ra;if((Ra|0)==0){ib=ba;jb=fb;kb=12;break i}zY(Ra|0,z|0,ha|0)|0;c[(c[ma>>2]|0)+(aa<<2)>>2]=0}else{c[Oa+16>>2]=0}if((fb|0)==0){rb=pa;sb=pa;tb=c[Pa>>2]|0;ub=0;break}ma=c[w>>2]|0;Ra=c[Pa>>2]|0;nb=tX(ma,0,0,1,32)|0;mb=nb;do{if((nb|0)==0){vb=0}else{wb=tX(ma,0,0,1,8)|0;xb=nb+4|0;c[xb>>2]=wb;if((wb|0)==0){vb=0;break}c[nb>>2]=3;c[nb+8>>2]=-1;c[nb+12>>2]=-1;c[wb>>2]=fb;c[(c[xb>>2]|0)+4>>2]=Ra;c[nb+16>>2]=(c[Ra+16>>2]|0)+(c[fb+16>>2]|0);vb=mb}}while(0);rb=pa;sb=pa;tb=vb;ub=(vb|0)==0?12:0}}while(0);Pa=eb+1|0;if((Pa|0)<(_|0)&(ub|0)==0){cb=rb;db=sb;eb=Pa;fb=tb}else{ob=sb;pb=tb;qb=ub;break}}}else{ob=0;pb=0;qb=0}}while(0);if((qb|0)!=0|fa^1){ib=ba;jb=pb;kb=qb;break}ha=c[w>>2]|0;za=c[x>>2]|0;Z=tX(ha,0,0,1,32)|0;Pa=Z;if((Z|0)==0){ib=ba;jb=pb;kb=12;break}Oa=tX(ha,0,0,1,20)|0;c[Z+4>>2]=Oa;if((Oa|0)==0){ib=ba;jb=pb;kb=12;break}c[Z>>2]=0;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[Oa>>2]=ob;c[Oa+4>>2]=1114111;c[Oa+8>>2]=za;if((aa|0)>0){za=aa<<2;ha=tX(c[w>>2]|0,0,0,0,za+4|0)|0;Qa=Oa+16|0;c[Qa>>2]=ha;if((ha|0)==0){ib=ba;jb=pb;kb=12;break}zY(ha|0,z|0,za|0)|0;c[(c[Qa>>2]|0)+(aa<<2)>>2]=0}else{c[Oa+16>>2]=0}if((pb|0)==0){ib=ba;jb=Pa;kb=0;break}Oa=c[w>>2]|0;Qa=tX(Oa,0,0,1,32)|0;za=Qa;do{if((Qa|0)==0){yb=0}else{ha=tX(Oa,0,0,1,8)|0;oa=Qa+4|0;c[oa>>2]=ha;if((ha|0)==0){yb=0;break}c[Qa>>2]=3;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[ha>>2]=pb;c[(c[oa>>2]|0)+4>>2]=Pa;c[Qa+16>>2]=(c[Z+16>>2]|0)+(c[pb+16>>2]|0);yb=za}}while(0);ib=ba;jb=yb;kb=(yb|0)==0?12:0}else if((T|0)==112){T=0;c[Aa+(_<<2)>>2]=0;ia=Aa;ja=va;ka=12;T=140}else if((T|0)==141){T=0;c[q>>2]=va;ib=Wa;jb=0;kb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=ja;ib=ia;jb=0;kb=ka}WX(ib);c[x>>2]=(c[x>>2]|0)+1;if((kb|0)==0){U=M;V=jb;W=0;break c}else{$=kb;T=294;break b}break};case 46:{_=(c[v>>2]&4|0)==0;ba=c[w>>2]|0;aa=c[x>>2]|0;ga=tX(ba,0,0,1,32)|0;za=ga;Z=(ga|0)==0;if(_){if(Z){$=12;T=294;break b}_=tX(ba,0,0,1,20)|0;c[ga+4>>2]=_;if((_|0)==0){$=12;T=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[_>>2]=0;c[_+4>>2]=1114111;c[_+8>>2]=aa;zb=za;Ab=(c[x>>2]|0)+1|0}else{if(Z){$=12;T=294;break b}Z=tX(ba,0,0,1,20)|0;c[ga+4>>2]=Z;if((Z|0)==0){$=12;T=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Z>>2]=0;c[Z+4>>2]=9;c[Z+8>>2]=aa;aa=c[w>>2]|0;Z=(c[x>>2]|0)+1|0;ba=tX(aa,0,0,1,32)|0;if((ba|0)==0){$=12;T=294;break b}_=tX(aa,0,0,1,20)|0;c[ba+4>>2]=_;if((_|0)==0){$=12;T=294;break b}c[ba>>2]=0;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[_>>2]=11;c[_+4>>2]=1114111;c[_+8>>2]=Z;Z=c[w>>2]|0;_=tX(Z,0,0,1,32)|0;if((_|0)==0){$=12;T=294;break b}aa=tX(Z,0,0,1,8)|0;Z=_+4|0;c[Z>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[_>>2]=3;c[_+8>>2]=-1;c[_+12>>2]=-1;c[aa>>2]=za;c[(c[Z>>2]|0)+4>>2]=ba;c[_+16>>2]=(c[ba+16>>2]|0)+(c[ga+16>>2]|0);zb=_;Ab=(c[x>>2]|0)+2|0}c[x>>2]=Ab;c[q>>2]=(c[q>>2]|0)+1;U=M;V=zb;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((X|0)!=(c[r>>2]|0)){break d}_=jX(m,5)|0;if((_|0)!=0){R=M;S=_;T=6;break b}}_=c[w>>2]|0;ga=tX(_,0,0,1,32)|0;if((ga|0)==0){$=12;T=294;break b}ba=tX(_,0,0,1,20)|0;c[ga+4>>2]=ba;if((ba|0)==0){$=12;T=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[ba>>2]=-2;c[ba+4>>2]=1;c[ba+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ga;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[X+1|0]|0)!=0){break d}}ga=c[w>>2]|0;ba=tX(ga,0,0,1,32)|0;if((ba|0)==0){$=12;T=294;break b}_=tX(ga,0,0,1,20)|0;c[ba+4>>2]=_;if((_|0)==0){$=12;T=294;break b}c[ba>>2]=0;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[_>>2]=-2;c[_+4>>2]=2;c[_+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ba;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};case 92:{ba=X+1|0;_=a[ba]|0;do{if((c[v>>2]&1|0)==0){if(_<<24>>24==40){c[q>>2]=ba;Bb=ba;T=74;break d}else{ga=a[X+1|0]|0;if(ga<<24>>24==41){T=265;break d}else{Cb=ga;break}}}else{Cb=_}}while(0);_=X+1|0;ba=Cb<<24>>24==0;if(ba){$=5;T=294;break b}else{Db=124116|0;Eb=0}while(1){ga=Eb+1|0;if((a[124112+(Eb<<3)|0]|0)==Cb<<24>>24){Fb=Db;break}Z=124116+(ga<<3)|0;if((ga|0)==12){Fb=Z;break}else{Db=Z;Eb=ga}}ga=c[Fb>>2]|0;if((ga|0)!=0){Z=F+0|0;za=G+0|0;aa=Z+40|0;do{c[Z>>2]=c[za>>2];Z=Z+4|0;za=za+4|0}while((Z|0)<(aa|0));c[H>>2]=ga;c[I>>2]=1;za=cX(j)|0;if((za|0)!=0){$=za;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(ba){$=5;T=294;break b}c[q>>2]=_;za=a[_]|0;k:do{switch(za|0){case 62:{Z=c[w>>2]|0;aa=tX(Z,0,0,1,32)|0;Qa=aa;do{if((aa|0)==0){Gb=0}else{Pa=tX(Z,0,0,1,20)|0;c[aa+4>>2]=Pa;if((Pa|0)==0){Gb=0;break}c[aa>>2]=0;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[Pa>>2]=-2;c[Pa+4>>2]=32;c[Pa+8>>2]=-1;Gb=Qa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Gb;break};case 98:{Qa=c[w>>2]|0;aa=tX(Qa,0,0,1,32)|0;Z=aa;do{if((aa|0)==0){Ib=0}else{Pa=tX(Qa,0,0,1,20)|0;c[aa+4>>2]=Pa;if((Pa|0)==0){Ib=0;break}c[aa>>2]=0;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[Pa>>2]=-2;c[Pa+4>>2]=64;c[Pa+8>>2]=-1;Ib=Z}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Ib;break};case 120:{Z=X+2|0;c[q>>2]=Z;aa=a[Z]|0;if(aa<<24>>24==123){Z=X+3|0;c[q>>2]=Z;Qa=Z;Z=0;while(1){Pa=a[Qa]|0;if(Pa<<24>>24==0|Pa<<24>>24==125){Jb=Z;Kb=Qa;break}if((RW(Pa<<24>>24)|0)==0){$=9;T=294;break b}Pa=c[q>>2]|0;a[l+Z|0]=a[Pa]|0;Oa=Z+1|0;fa=Pa+1|0;c[q>>2]=fa;if(Oa>>>0>31){Jb=Oa;Kb=fa;break}else{Qa=fa;Z=Oa}}c[q>>2]=Kb+1;a[l+Jb|0]=0;Z=Vb(C|0,0,16)|0;Qa=c[w>>2]|0;Oa=c[x>>2]|0;fa=tX(Qa,0,0,1,32)|0;Pa=fa;do{if((fa|0)==0){Lb=0}else{oa=tX(Qa,0,0,1,20)|0;c[fa+4>>2]=oa;if((oa|0)==0){Lb=0;break}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[oa>>2]=Z;c[oa+4>>2]=Z;c[oa+8>>2]=Oa;Lb=Pa}}while(0);c[x>>2]=(c[x>>2]|0)+1;Hb=Lb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Pa=(RW(aa<<24>>24)|0)==0;Oa=c[q>>2]|0;if(Pa){Mb=Oa}else{a[D]=a[Oa]|0;Pa=Oa+1|0;c[q>>2]=Pa;Mb=Pa}if((RW(a[Mb]|0)|0)!=0){Pa=c[q>>2]|0;a[E]=a[Pa]|0;c[q>>2]=Pa+1}Pa=Vb(D|0,0,16)|0;Oa=c[w>>2]|0;Z=c[x>>2]|0;fa=tX(Oa,0,0,1,32)|0;Qa=fa;do{if((fa|0)==0){Nb=0}else{oa=tX(Oa,0,0,1,20)|0;c[fa+4>>2]=oa;if((oa|0)==0){Nb=0;break}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[oa>>2]=Pa;c[oa+4>>2]=Pa;c[oa+8>>2]=Z;Nb=Qa}}while(0);c[x>>2]=(c[x>>2]|0)+1;Hb=Nb;break k}break};case 60:{Qa=c[w>>2]|0;Z=tX(Qa,0,0,1,32)|0;Pa=Z;do{if((Z|0)==0){Ob=0}else{fa=tX(Qa,0,0,1,20)|0;c[Z+4>>2]=fa;if((fa|0)==0){Ob=0;break}c[Z>>2]=0;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[fa>>2]=-2;c[fa+4>>2]=16;c[fa+8>>2]=-1;Ob=Pa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Ob;break};case 66:{Pa=c[w>>2]|0;Z=tX(Pa,0,0,1,32)|0;Qa=Z;do{if((Z|0)==0){Pb=0}else{fa=tX(Pa,0,0,1,20)|0;c[Z+4>>2]=fa;if((fa|0)==0){Pb=0;break}c[Z>>2]=0;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[fa>>2]=-2;c[fa+4>>2]=128;c[fa+8>>2]=-1;Pb=Qa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Hb=Pb;break};default:{if((KW(za)|0)!=0){Qa=(a[c[q>>2]|0]|0)+ -48|0;Z=c[w>>2]|0;Pa=c[x>>2]|0;fa=tX(Z,0,0,1,32)|0;if((fa|0)==0){$=12;T=294;break b}Oa=tX(Z,0,0,1,20)|0;c[fa+4>>2]=Oa;if((Oa|0)==0){$=12;T=294;break b}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[Oa>>2]=-4;c[Oa+4>>2]=Qa;c[Oa+8>>2]=Pa;c[x>>2]=(c[x>>2]|0)+1;Pa=c[B>>2]|0;c[B>>2]=(Qa|0)<(Pa|0)?Pa:Qa;c[q>>2]=(c[q>>2]|0)+1;U=M;V=fa;W=0;break c}fa=c[w>>2]|0;Qa=a[c[q>>2]|0]|0;Pa=c[x>>2]|0;Oa=tX(fa,0,0,1,32)|0;Z=Oa;do{if((Oa|0)==0){Qb=0}else{aa=tX(fa,0,0,1,20)|0;c[Oa+4>>2]=aa;if((aa|0)==0){Qb=0;break}c[Oa>>2]=0;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[aa>>2]=Qa;c[aa+4>>2]=Qa;c[aa+8>>2]=Pa;Qb=Z}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Hb=Qb}}}while(0);if((Hb|0)==0){$=12;T=294;break b}else{U=M;V=Hb;W=0;break c}break};case 40:{if((c[v>>2]&1|0)!=0){Bb=X;T=74}break};default:{}}}while(0);if((T|0)==74){T=0;Q=M+1|0;c[q>>2]=Bb+1;Y=jX(m,c[y>>2]|0)|0;if((Y|0)!=0){R=Q;S=Y;T=6;break b}Y=jX(m,2)|0;if((Y|0)!=0){R=Q;S=Y;T=6;break b}Y=jX(m,0)|0;if((Y|0)!=0){R=Q;S=Y;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=Q;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;Q=c[w>>2]|0;Y=tX(Q,0,0,1,32)|0;if((Y|0)==0){$=12;T=294;break b}za=tX(Q,0,0,1,20)|0;c[Y+4>>2]=za;if((za|0)==0){$=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[za>>2]=-1;c[za+4>>2]=-1;c[za+8>>2]=-1;U=M;V=Y;W=0;break c}Y=ZW(h,X,-1)|0;if((Y|0)<0){c[h>>2]=-1;Rb=1}else{Rb=Y}do{if((c[v>>2]&2|0)==0){T=280}else{if((QW(c[h>>2]|0)|0)==0){if((MW(c[h>>2]|0)|0)==0){T=280;break}}Y=c[w>>2]|0;za=SW(c[h>>2]|0)|0;Q=SW(c[h>>2]|0)|0;_=c[x>>2]|0;ba=tX(Y,0,0,1,32)|0;if((ba|0)==0){$=12;T=294;break b}ga=tX(Y,0,0,1,20)|0;c[ba+4>>2]=ga;if((ga|0)==0){$=12;T=294;break b}c[ba>>2]=0;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[ga>>2]=za;c[ga+4>>2]=Q;c[ga+8>>2]=_;_=c[w>>2]|0;ga=UW(c[h>>2]|0)|0;Q=UW(c[h>>2]|0)|0;za=c[x>>2]|0;Y=tX(_,0,0,1,32)|0;if((Y|0)==0){$=12;T=294;break b}Z=tX(_,0,0,1,20)|0;c[Y+4>>2]=Z;if((Z|0)==0){$=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Z>>2]=ga;c[Z+4>>2]=Q;c[Z+8>>2]=za;za=c[w>>2]|0;Z=tX(za,0,0,1,32)|0;if((Z|0)==0){$=12;T=294;break b}Q=tX(za,0,0,1,8)|0;za=Z+4|0;c[za>>2]=Q;if((Q|0)==0){$=12;T=294;break b}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[Q>>2]=ba;c[(c[za>>2]|0)+4>>2]=Y;c[Z+16>>2]=(c[Y+16>>2]|0)+(c[ba+16>>2]|0);Sb=Z}}while(0);if((T|0)==280){T=0;X=c[w>>2]|0;Z=c[h>>2]|0;ba=c[x>>2]|0;Y=tX(X,0,0,1,32)|0;if((Y|0)==0){$=12;T=294;break b}za=tX(X,0,0,1,20)|0;c[Y+4>>2]=za;if((za|0)==0){$=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[za>>2]=Z;c[za+4>>2]=Z;c[za+8>>2]=ba;Sb=Y}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Rb;U=M;V=Sb;W=0;break};case 9:{Y=c[q>>2]|0;ba=a[Y]|0;switch(ba<<24>>24|0){case 42:{T=41;break};case 123:{za=c[v>>2]|0;if((za&1|0)==0){U=M;V=N;W=0;break c}else{Tb=za;Ub=Y}break};case 92:{za=c[v>>2]|0;if((za&1|0)!=0){U=M;V=N;W=0;break c}Z=Y+1|0;if((a[Z]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=Z;Tb=za;Ub=Z;break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Y+1;Y=c[w>>2]|0;Z=tX(Y,0,0,1,32)|0;if((Z|0)==0){$=12;T=294;break b}za=tX(Y,0,0,1,16)|0;c[Z+4>>2]=za;if((za|0)==0){$=12;T=294;break b}c[Z>>2]=2;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[za>>2]=N;c[za+4>>2]=ba<<24>>24==43;c[za+8>>2]=ba<<24>>24==63?1:-1;ba=za+12|0;a[ba]=a[ba]&-2;c[Z+16>>2]=c[N+16>>2];U=M;V=Z;W=jX(m,9)|0;break c}Z=Ub+1|0;c[q>>2]=Z;ba=a[Z]|0;if((ba+ -48<<24>>24&255)<10){za=ba<<24>>24;if((za+ -48|0)>>>0<10){Wb=za;Xb=-1;Yb=Z}else{$=10;T=294;break b}while(1){za=((Xb|0)<0?-48:(Xb*10|0)+ -48|0)+Wb|0;Y=Yb+1|0;X=a[Y]|0;Q=X<<24>>24;if((Q+ -48|0)>>>0<10){Yb=Y;Xb=za;Wb=Q}else{Zb=X;_b=za;$b=Y;break}}}else{Zb=ba;_b=-1;$b=Z}do{if(Zb<<24>>24==44){Y=$b+1|0;za=a[Y]|0;X=za<<24>>24;if((X+ -48|0)>>>0<10){ac=X;bc=-1;cc=Y}else{ec=za;fc=-1;gc=Y;break}while(1){Y=((bc|0)<0?-48:(bc*10|0)+ -48|0)+ac|0;za=cc+1|0;X=a[za]|0;Q=X<<24>>24;if((Q+ -48|0)>>>0<10){cc=za;bc=Y;ac=Q}else{hc=X;ic=Y;jc=za;T=54;break}}}else{hc=Zb;ic=_b;jc=$b;T=54}}while(0);do{if((T|0)==54){T=0;if(!((ic|0)>-1)){ec=hc;fc=ic;gc=jc;break}if((_b|0)>(ic|0)|(ic|0)>255){$=10;T=294;break b}else{ec=hc;fc=ic;gc=jc}}}while(0);if(ec<<24>>24==0){$=9;T=294;break b}if((gc|0)==(Z|0)){$=10;T=294;break b}if((Tb&1|0)==0){if(!(ec<<24>>24==92)){$=10;T=294;break b}if((a[gc+1|0]|0)!=125){$=10;T=294;break b}kc=gc+2|0}else{if(!(ec<<24>>24==125)){$=10;T=294;break b}kc=gc+1|0}if((fc|_b|0)==0){ba=c[w>>2]|0;za=tX(ba,0,0,1,32)|0;if((za|0)==0){$=12;T=294;break b}Y=tX(ba,0,0,1,20)|0;c[za+4>>2]=Y;if((Y|0)==0){$=12;T=294;break b}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;lc=za}else{za=(fc&_b|0)<0;Y=c[w>>2]|0;ba=tX(Y,0,0,1,32)|0;if((ba|0)==0){$=12;T=294;break b}X=tX(Y,0,0,1,16)|0;c[ba+4>>2]=X;if((X|0)==0){$=12;T=294;break b}c[ba>>2]=2;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=za?1:_b;c[X+8>>2]=za?1:fc;za=X+12|0;a[za]=a[za]&-2;c[ba+16>>2]=c[N+16>>2];lc=ba}c[q>>2]=kc;U=M;V=lc;W=jX(m,9)|0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{mc=O;nc=U;oc=V;pc=W;break a}}if((T|0)==6){mc=(S|0)==0;nc=R;oc=N;pc=S;break}else if((T|0)==294){i=d;return $|0}}else{mc=t;nc=0;oc=0;pc=p}}while(0);p=(nc|0)>0;if(p|mc^1){$=p?8:pc;i=d;return $|0}c[b+8>>2]=oc;$=0;i=d;return $|0}



function cw(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+pd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+pd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Sv(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function dw(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function ew(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;ae[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function fw(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function gw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Ft(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{se[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Dt(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Ft(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function hw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((gw(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}iw(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Ft(d)|0)>0;h=b?2:0;i=e;return h|0}function iw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=VX(q)|0;s=r;t=VX(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[16468]=Bt(4)|0;if((r|0)==0){cb(65880,65896,308,65928)}if((t|0)==0){cb(65944,65896,309,65928)}v=It(b)|0;if((v|0)!=0){w=v;do{v=Kt(w)|0;c[l>>2]=c[v>>2];pt(27,0,65960,l);w=Jt(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;zY(t|0,c[a+384>>2]|0,v|0)|0;zY(r|0,l|0,v|0)|0}h[d>>3]=+lw(a,n,o,q,s,c[16468]|0,b);do{if((Ft(c[16468]|0)|0)==0){s=Gt(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=It(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=Kt(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=Jt(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];pt(27,0,66008,j);v=It(b)|0;if((v|0)==0){break}else{B=v}do{v=Kt(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[16468]|0;Et(v,Kt(B)|0);v=Kt(B)|0;c[g>>2]=c[v>>2];pt(27,0,66032,g)}B=Jt(B)|0;}while((B|0)!=0)}}while(0);Ct(b);if((c[35180>>2]|0)!=0){Ft(c[16468]|0)|0}if((Ft(c[16468]|0)|0)>0){B=m;do{g=Gt(c[16468]|0)|0;c[m>>2]=c[g>>2];Ht(c[16468]|0);c[f>>2]=c[m>>2];pt(7,0,66056,f);Dt(b,B);}while((Ft(c[16468]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){zY(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ue(a);ow(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){WX(t);WX(r);i=e;return}zY(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;WX(t);WX(r);i=e;return}function jw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){sw(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pt(7,0,65600,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Ft(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[35180>>2]|0)!=0){e=It(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=Kt(s)|0;x=c[e>>2]|0;e=se[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;ot(7,0,w,65624,l);s=Jt(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=Kt(It(d)|0)|0;x=se[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;ot(1,0,e,65640,j);c[s>>2]=1}}while(0);Ct(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;nw(b);kw(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function kw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;pt(27,0,66248,b);d=a+344|0;ge[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function lw(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=VX(p<<3)|0;if((q|0)==0){cb(66064,65896,409,66080)}if((p|0)>0){zY(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];pt(27,0,66096,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pt(27,0,66144,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){WX(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Ix(a)|0;de[c[(c[p>>2]|0)+40>>2]&127](a)|0;de[c[(c[p>>2]|0)+28>>2]&127](a)|0;de[c[(c[p>>2]|0)+32>>2]&127](a)|0;ge[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(mw(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}zY(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}WX(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function mw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Ct(b);pt(27,0,66168,g);g=It(d)|0;if((g|0)==0){j=Ft(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=Kt(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=Kt(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=Kt(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=Kt(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=Kt(a)|0;o=c[g>>2]|0;g=Kt(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?65584:65592;g=Kt(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?65584:65592;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;pt(27,0,66208,f);Dt(b,Kt(a)|0)}a=Jt(a)|0;}while((a|0)!=0);j=Ft(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function nw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;se[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;ow(b);pw(b);de[c[(c[g>>2]|0)+36>>2]&127](b)|0;qw(b,8);h=rw(b)|0;j=de[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{pw(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}sw(b);ow(b);qw(b,8);de[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=rw(b)|0;j=de[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){tt(c[b+536>>2]|0,66288,e)}else if((o|0)==7){pw(b);i=d;return}}function ow(a){a=a|0;var b=0;b=i;zY(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function pw(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function qw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[35152+(d<<2)>>2]|0)==0){i=e;return}pt(d,1,66712,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=de[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=de[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;pt(d,0,66736,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}ae[c[8926]&255](d);i=e;return}function rw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function sw(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;zY(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;zY(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;zY(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;zY(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function tw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ge[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function uw(a){a=a|0;var b=0;b=i;vw(a);ww(a);sw(a);xw(a);i=b;return}function vw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function ww(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function xw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Bu(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];zY(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;zY(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;zY(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;zY(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Bu(c[d>>2]|0)|0));i=b;return}function yw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[35152+(d<<2)>>2]|0)==0){i=e;return}pt(d,1,66384,q);q=b+136|0;if((c[q>>2]|0)>0){pt(d,1,66408,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?66368:66376;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];pt(d,0,66424,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}ae[c[8926]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){pt(d,1,66480,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?66368:66376;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;pt(d,0,66504,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}ae[c[8926]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){pt(d,1,66560,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?66368:66376;v=(a[n+(m*48|0)+40|0]|0)!=0?66368:66376;n=(a[(c[s>>2]|0)+m|0]|0)!=0?66368:66376;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;pt(d,0,66584,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}ae[c[8926]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){pt(d,1,66640,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;pt(d,0,66664,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}ae[c[8926]&255](d)}ae[c[8926]&255](d);i=e;return}function zw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Bu(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];zY(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;zY(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;zY(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;zY(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Bu(c[d>>2]|0)|0));i=b;return}function Aw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function Bw(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];zY(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;zY(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;zY(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;zY(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Cw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=wu(3,32)|0;c[o>>2]=p;if((p|0)==0){tt(c[b+536>>2]|0,66768,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=XX(c[p>>2]|0,8)|0;c[q>>2]=z;st(c[r>>2]|0,(z|0)!=0|0,66824,l);z=XX(c[s>>2]|0,4)|0;c[t>>2]=z;st(c[r>>2]|0,(z|0)!=0|0,66824,k);z=XX(c[u>>2]|0,1)|0;c[v>>2]=z;st(c[r>>2]|0,(z|0)!=0|0,66824,j);z=XX(c[w>>2]|0,4)|0;c[x>>2]=z;st(c[r>>2]|0,(z|0)!=0|0,66824,g);Au(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=XX(3,4)|0;c[b+4>>2]=n;Cu(c[o>>2]|0,0,n);c[b+8>>2]=XX(c[p>>2]|0,112)|0;c[b+12>>2]=XX(c[s>>2]|0,60)|0;c[b+16>>2]=XX(c[u>>2]|0,48)|0;c[b+20>>2]=XX(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=XX(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=XX(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=XX(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=XX(g,52)|0;c[b+40>>2]=XX(c[b+216>>2]|0,52)|0;c[b+44>>2]=XX(c[b+220>>2]|0,52)|0;c[b+48>>2]=XX(c[b+224>>2]|0,52)|0;c[b+52>>2]=XX(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=XX(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=XX(x,8)|0;c[b+340>>2]=XX(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=XX(x,8)|0;c[b+348>>2]=XX(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=XX(j,1)|0;c[b+356>>2]=XX(j,1)|0;c[b+360>>2]=XX(j,1)|0;j=VX(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=VX(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=XX(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=XX(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=XX(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=XX(u,4)|0;c[b+400>>2]=XX(x,8)|0;c[b+404>>2]=XX(p,4)|0;c[b+408>>2]=XX(s,1)|0;c[b+412>>2]=XX(u,4)|0;c[b+416>>2]=XX(c[n>>2]|0,8)|0;c[b+420>>2]=XX(o,4)|0;c[b+424>>2]=XX(y,1)|0;c[b+428>>2]=XX(g,4)|0;c[b+432>>2]=XX(c[b+152>>2]|0,8)|0;c[b+436>>2]=XX(c[b+156>>2]|0,8)|0;g=VX((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;ae[c[(c[y>>2]|0)+20>>2]&255](g);g=VX((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;ae[c[(c[y>>2]|0)+16>>2]&255](g);g=VX((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;ae[c[(c[y>>2]|0)+12>>2]&255](g);g=VX((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;be[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=VX((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=XX(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;st(c[r>>2]|0,(g|0)!=0|0,66840,f);c[b+512>>2]=100;c[b+516>>2]=XX(100,4)|0;c[b+520>>2]=XX(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=VX(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;st(c[r>>2]|0,(g|0)!=0|0,66824,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=wu(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function Dw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;WX(c[g+8>>2]|0);WX(c[g+12>>2]|0);WX(c[g+16>>2]|0);WX(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);WX(e);xu(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){Vu(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}WX(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){Vu(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}WX(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){Vu(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}WX(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){Vu(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}WX(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){Vu(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}WX(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){Vu(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}WX(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){Vu(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}WX(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){Vu(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}WX(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){Vu(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}WX(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){Vu(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}WX(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){Vu(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}WX(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){Vu(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}WX(v);WX(c[a+108>>2]|0);WX(c[a+336>>2]|0);WX(c[a+340>>2]|0);WX(c[a+344>>2]|0);WX(c[a+348>>2]|0);WX(c[a+352>>2]|0);WX(c[a+356>>2]|0);WX(c[a+360>>2]|0);WX(c[a+368>>2]|0);WX(c[a+384>>2]|0);WX(c[a+388>>2]|0);WX(c[a+392>>2]|0);WX(c[a+396>>2]|0);WX(c[a+400>>2]|0);WX(c[a+404>>2]|0);WX(c[a+408>>2]|0);WX(c[a+412>>2]|0);WX(c[a+416>>2]|0);WX(c[a+420>>2]|0);WX(c[a+424>>2]|0);WX(c[a+428>>2]|0);WX(c[a+488>>2]|0);WX(c[a+484>>2]|0);WX(c[a+476>>2]|0);WX(c[a+468>>2]|0);WX(c[a+464>>2]|0);WX(c[a+432>>2]|0);WX(c[a+436>>2]|0);WX(c[a+320>>2]|0);WX(c[a+516>>2]|0);WX(c[a+520>>2]|0);nL(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;WX(x);i=b;return}else{y=a;z=0}while(1){xu(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;WX(x);i=b;return}function Ew(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[8360]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];pt(8,0,66888,d);i=b;return}function Fw(a,b){a=+a;b=+b;i=i;return a<=b|0}function Gw(a,b){a=+a;b=+b;i=i;return a>=b|0}function Hw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=VX(k)|0;c[e+(h*40|0)+24>>2]=VX(k)|0;if((c[g>>2]|0)!=1){l=5;break}Kw(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){tt(c[a+536>>2]|0,66944,d)}else if((l|0)==6){i=b;return 0}return 0}function Iw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){WX(c[e+(h*40|0)+20>>2]|0);WX(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Lw(k)|0;WX(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){tt(c[a+536>>2]|0,66944,d)}else if((j|0)==6){i=b;return 0}return 0}function Jw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[35220>>2]|c[8786]|0)==0){z=w;A=1;break}lL(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rt(17,1,66976,g);lL(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;lL(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;rt(17,0,67008,f);lL(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ae[c[8926]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Kw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VX(20)|0;c[b>>2]=f;st(0,(f|0)!=0|0,67016,e);e=VX(a)|0;c[f>>2]=e;e=VX(a)|0;c[f+4>>2]=e;e=VX(a)|0;c[f+8>>2]=e;e=VX(a)|0;c[f+16>>2]=e;st(0,(c[b>>2]|0)!=0|0,67048,d);i=d;return 0}function Lw(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;WX(c[d>>2]|0);WX(c[d+4>>2]|0);WX(c[d+8>>2]|0);WX(c[d+16>>2]|0);i=b;return 0}function Mw(a,b){a=a|0;b=b|0;b=i;i=i+8|0;tt(c[a+536>>2]|0,67096,b);return 0}function Nw(a){a=a|0;a=i;i=i+8|0;tt(0,67096,a);return 0}function Ow(a,b){a=a|0;b=b|0;b=i;i=i+8|0;tt(c[a+536>>2]|0,67096,b);return 0}function Pw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=VX(l)|0;c[e+(h<<6)+36>>2]=VX(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=VX(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;Uw(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;Ww(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){tt(c[a+536>>2]|0,67136,d)}else if((n|0)==8){i=b;return 0}return 0}function Qw(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Rw(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Sw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){WX(c[e+(h<<6)+28>>2]|0);WX(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){Vw(e+(h<<6)+24|0)|0;WX(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){Xw(e+(h<<6)+24|0)|0}else{k=6;break}WX(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){tt(c[a+536>>2]|0,67136,d)}else if((k|0)==8){i=b;return 0}return 0}function Tw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[35212>>2]|c[8786]|0)==0){z=w;A=1;break}lL(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rt(15,1,67168,g);lL(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;lL(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;rt(15,0,67200,f);lL(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ae[c[8926]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Uw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=VX(12)|0;f=VX(a<<2)|0;c[e>>2]=f;st(0,(f|0)!=0|0,67208,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function Vw(a){a=a|0;var b=0;b=i;WX(c[c[a>>2]>>2]|0);i=b;return 0}function Ww(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=VX(32)|0;st(0,(g|0)!=0|0,67264,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Td(0,d|0)|0;Id(c[d>>2]|0,c[b>>2]|0,0)|0;Td(0,g+4|0)|0;Id(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Kb(67312,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function Xw(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Pd(c[d+12>>2]|0)|0;Jb(c[d+8>>2]|0)|0;Jb(c[d+4>>2]|0)|0;i=b;return 0}function Yw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;st(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,67480,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){st(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,67520,e);if((de[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=VX(p)|0;c[g+(m*80|0)+52>>2]=VX(p)|0;c[g+(m*80|0)+48>>2]=VX(p)|0;c[g+(m*80|0)+16>>2]=VX(p)|0;c[g+(m*80|0)+8>>2]=VX(p)|0;c[g+(m*80|0)+12>>2]=VX(p)|0;be[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){jx(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){jx(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){Mw(a,n)|0;break}else if((p|0)==1){bx(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){tt(c[j>>2]|0,67560,d)}else if((q|0)==14){i=b;return 0}return 0}function Zw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;WX(c[e+(h*80|0)+44>>2]|0);WX(c[e+(h*80|0)+52>>2]|0);WX(c[e+(h*80|0)+48>>2]|0);WX(c[e+(h*80|0)+16>>2]|0);WX(c[e+(h*80|0)+8>>2]|0);WX(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;kx(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==1){n=e+(h*80|0)+40|0;cx(n)|0;l=n;break}else if((k|0)==3){k=e+(h*80|0)+40|0;kx(k)|0;l=k;break}else{m=9;break a}}}while(0);WX(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){Nw(j)|0}else if((m|0)==9){tt(c[a+536>>2]|0,67560,d)}else if((m|0)==11){i=b;return 0}return 0}function _w(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(mx(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(Ow(b,d)|0)&255;break}else if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=dx(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(mx(b,d)|0)&255;break}else{tt(c[b+536>>2]|0,67560,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function $w(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;lL(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];qt(17,1,u,67592,m);do{if((a[b+312|0]|0)==0){lL(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;lL(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;rt(17,0,67792,f);lL(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{rt(17,1,67632,l);lL(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;lL(q,d,c[v>>2]|0);if((tY(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];rt(17,0,67712,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;lL(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;rt(17,0,67752,g);G=E}lL(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[35220>>2]|c[8786]|0)==0){break}ae[c[8926]&255](17)}}while(0);if((c[35220>>2]|c[8786]|0)==0){x=1;i=e;return x|0}ae[c[8926]&255](17);x=1;i=e;return x|0}function ax(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function bx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VX(144)|0;c[b>>2]=f;st(0,(f|0)!=0|0,67808,e);c[f>>2]=0;e=a<<3;g=VX(e)|0;c[f+4>>2]=g;g=VX(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=VX(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=VX(e)|0;c[f+24>>2]=g;g=XX(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=VX(e)|0;c[f+64>>2]=g;g=VX(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=XX(g,8)|0;c[f+104>>2]=j;j=XX(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=VX(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=VX(e)|0;c[f+124>>2]=j;j=VX(e)|0;c[f+128>>2]=j;j=VX(e)|0;c[f+132>>2]=j;j=VX(e)|0;c[f+136>>2]=j;j=VX(e)|0;c[f+140>>2]=j;st(0,(c[b>>2]|0)!=0|0,67840,d);i=d;return 0}function cx(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;WX(c[d+4>>2]|0);WX(c[d+16>>2]|0);WX(c[d+12>>2]|0);WX(c[d+24>>2]|0);WX(c[d+28>>2]|0);WX(c[d+64>>2]|0);WX(c[d+68>>2]|0);WX(c[d+104>>2]|0);WX(c[d+108>>2]|0);WX(c[d+116>>2]|0);WX(c[d+124>>2]|0);WX(c[d+128>>2]|0);WX(c[d+132>>2]|0);WX(c[d+136>>2]|0);WX(c[d+140>>2]|0);i=b;return 0}function dx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=VX(c[Y>>2]|0)|0;if((c[35220>>2]|0)!=0){lL(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];pt(17,1,67880,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];pt(17,1,67936,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];pt(17,0,67952,F);ae[c[8926]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}ae[c[8926]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){zY(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{zY(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+pd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;ex($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+pd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[35224>>2]|0)!=0){fx(c[Q>>2]|0,$,18,67992);fx(c[ca>>2]|0,$,18,68024)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[35224>>2]|0)!=0){fx(c[ca>>2]|0,$,18,68056)}a[da]=R;Av(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){lL(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];Uu(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;ex($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;ex($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}ow(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[35224>>2]|0)!=0){pt(18,1,68096,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];pt(18,1,68136,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];pt(18,0,68168,C);ae[c[8926]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ae[c[8926]&255](18)}if((c[35228>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;pt(19,1,68200,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];ic(Ja|0,68224,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;pt(19,0,68232,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ae[c[8926]&255](19)}h[K>>3]=+zv($,c[Ia>>2]|0);h[J>>3]=+zv($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}zY(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];pt(17,0,68280,w);gx(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}pt(17,0,68352,v);gx(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+pd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}pt(17,0,68416,u);gx(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+pd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}pt(17,0,68488,t);gx(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}zY(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;zY(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}pt(17,0,68552,s);gx(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){zY(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}pt(17,0,68624,r);gx(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}pt(17,0,68696,q);gx(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}pt(17,0,68768,p);gx(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){zY(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}pt(17,0,68832,o);gx(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}pt(17,0,68904,n);gx(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];pt(17,0,69040,l);gx(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){zY(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{zY(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}pt(17,0,68968,m);gx(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35220>>2]|0)!=0){pt(17,1,68240,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;pt(17,0,68256,x);ae[c[8926]&255](17);gx(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}zY(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;ex($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;WX(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;WX(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;WX(Z);i=e;return kb|0}if((a[Ha]|0)==0){lL(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];Uu(0,f,hb);}if((c[35220>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;pt(17,0,69112,j);gx(S,L,J,K,17)}zY(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;WX(Z);i=e;return kb|0}return 0}function ex(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[35232>>2]|0)!=0){c[u>>2]=c[y+96>>2];pt(20,0,69360,u);fx(d,b,20,69392)}De[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[35232>>2]|0)!=0){fx(e,b,20,69408);c[t>>2]=c[y+96>>2];pt(20,0,69424,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[35232>>2]|0)!=0){pt(20,0,69464,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){ix(w,f,d,e,m)}else{hx(w,f,m)}do{if((c[35232>>2]|0)!=0){pt(20,0,69504,r);if((c[35228>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;pt(19,1,68200,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ic(m|0,69536,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;pt(19,0,68232,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}ae[c[8926]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;tt(g,69552,n)}return 0}function fx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[35152+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;pt(d,1,68232,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];pt(d,0,69344,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}ae[c[8926]&255](d);i=f;return}function gx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[35152+(f<<2)>>2]|0)==0){i=g;return}pt(f,1,69152,q);pt(f,1,69168,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];pt(f,0,69184,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}ae[c[8926]&255](f);pt(f,1,69224,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];pt(f,0,69240,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}ae[c[8926]&255](f);pt(f,1,69280,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];pt(f,0,69296,j);ae[c[8926]&255](f);ae[c[8926]&255](f);i=g;return}function hx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;BY(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;BY(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}de[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function ix(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+pd(+(n*+pd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;ex(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function jx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VX(80)|0;c[b>>2]=f;st(0,(f|0)!=0|0,69632,e);c[f>>2]=0;e=a<<3;g=VX(e)|0;c[f+4>>2]=g;g=VX(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=VX(e)|0;c[f+16>>2]=g;g=XX(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=VX(fa(e,a)|0)|0;c[f+64>>2]=g;g=VX(e)|0;c[f+68>>2]=g;g=VX(a<<2)|0;c[f+72>>2]=g;st(0,(c[b>>2]|0)!=0|0,69664,d);i=d;return 0}function kx(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;WX(c[d+4>>2]|0);WX(c[d+8>>2]|0);WX(c[d+16>>2]|0);WX(c[d+20>>2]|0);WX(c[d+64>>2]|0);WX(c[d+68>>2]|0);WX(c[d+72>>2]|0);i=b;return 0}function lx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;BY(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}de[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function mx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;zY(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[35220>>2]|0)==0){J=b+4|0}else{lL(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];pt(17,1,69704,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];pt(17,1,69776,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];pt(17,0,69792,t);ae[c[8926]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}ae[c[8926]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];nx(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){lL(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];Uu(3,g,P);}$=+zv(H,c[b>>2]|0);aa=+zv(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){zY(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;pt(17,0,69968,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;pt(17,0,70024,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;pt(17,0,70088,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[35220>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;pt(17,0,69840,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];pt(17,0,69880,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];pt(17,0,69936,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){lL(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];Uu(0,f,L);if((c[35220>>2]|0)==0){da=0;break}c[m>>2]=V;pt(17,0,70168,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pt(17,0,69880,l);if((c[35220>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pt(17,0,69936,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[35220>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;zY(ma|0,oa|0,qa|0)|0;i=e;return da|0}ae[c[8926]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;zY(ma|0,oa|0,qa|0)|0;i=e;return da|0}function nx(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[35224>>2]|0)!=0){c[z>>2]=j;pt(18,0,70208,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];pt(18,0,70256,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){ox(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){px(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{lx(E,m,r)|0}if((c[35228>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;pt(19,1,70272,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];ic(F|0,70296,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;pt(19,0,70304,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}ae[c[8926]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+zv(b,_);if(!(!(J<=H)&!(+zv(b,e)<=H))){$=31;break}ao(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;rt(17,0,70312,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;rt(17,0,70344,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+zv(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function ox(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;De[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function px(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+pd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;ox(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function qx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==1){f=c[a+4>>2]|0;g=c[f+4>>2]|0;sx(c[f>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);j=0;i=d;return j|0}else if((e|0)==2){rx(a,b);j=0;i=d;return j|0}else if((e|0)==4){oe[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];j=0;i=d;return j|0}else if((e|0)==3){j=Rv(a,b)|0;i=d;return j|0}else{j=1;i=d;return j|0}return 0}function rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[70376+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[70376+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];de[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function sx(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function tx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Bt(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=VX(8)|0;c[j+4>>2]=4;k=VX(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=XX(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==3){k=VX(88)|0;pt(23,0,70408,f);m=Pv(b,d,k)|0;c[d+48>>2]=k;n=m}else if((g|0)==4){m=c[620]|0;k=VX(m<<2)|0;c[17608]=k;if((m|0)<=0){n=0;break}l=c[b+116>>2]|0;o=k;k=0;while(1){c[o+(k<<2)>>2]=XX(l,8)|0;p=k+1|0;if((p|0)>=(m|0)){n=0;break a}o=c[17608]|0;k=p}}else{n=0}}while(0);Gx(b)|0;if((c[2]|0)==0){i=e;return n|0}Qu(6);Nu(1);i=e;return n|0}function ux(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){Qv(c[b+48>>2]|0)|0}else if((e|0)==2){f=b+48|0;b=c[f>>2]|0;g=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=g;h=0;while(1){WX(c[b+(h<<2)>>2]|0);j=c[f>>2]|0;k=c[j>>2]|0;if((h|0)<(c[j+4>>2]|0)){h=h+1|0;b=k}else{l=k;break}}}else{l=g}WX(l);WX(c[f>>2]|0)}else if((e|0)==4){e=c[620]|0;f=c[17608]|0;if((e|0)>0){l=f;g=0;while(1){WX(c[l+(g<<2)>>2]|0);b=g+1|0;h=c[17608]|0;if((b|0)<(e|0)){g=b;l=h}else{m=h;break}}}else{m=f}WX(m)}Hx(a)|0;Bx(a);i=d;return 0}function vx(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(185,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=KY(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=KY(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=KY(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=KY(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=KY(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(186,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=KY(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=KY(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;wY(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=KY(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=KY(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,70440,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=KY(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=KY(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,70536,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=KY(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[76656>>2]|0,76632,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=KY(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,70592,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=KY(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(187,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=KY(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function wx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];pt(8,0,70688,G);I=b+313|0;a[I]=1;nw(b);if((c[92028>>2]|0)==0){be[c[76652>>2]&63](76632,b)}a[I]=0}}while(0);if((e|0)!=0){xx(vd(e|0)|0,b)}if((c[35252>>2]|0)==0){i=f;return 0}Qu(0);pt(25,0,70736,F);pt(25,1,70760,E);H=+Iu(6);J=+Iu(6);K=J/+Iu(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];pt(25,0,70768,D);K=+Iu(1);H=+Iu(1);J=H/+Iu(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];pt(25,0,70808,C);J=+Iu(2);K=+Iu(2);H=K/+Iu(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];pt(25,0,70840,B);H=+Iu(3);J=+Iu(3);K=J/+Iu(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];pt(25,0,70864,A);K=+Iu(4);H=+Iu(4);J=H/+Iu(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pt(25,0,70904,z);J=+Iu(7);K=+Iu(7);H=K/+Iu(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(25,0,70936,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Iu(0);J=H- +Iu(7);H=J- +Iu(4);J=H- +Iu(3);H=J- +Iu(2);J=H- +Iu(1);H=J- +Iu(6);J=+Iu(0);K=J- +Iu(7);J=K- +Iu(4);K=J- +Iu(3);J=K- +Iu(2);K=J- +Iu(1);J=K- +Iu(6);K=J/+Iu(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(25,0,71e3,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];pt(25,0,70968,x)}K=+Iu(0);H=+Iu(0);J=H/+Iu(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];pt(25,0,71032,v);ae[c[8926]&255](25);pt(25,1,71056,u);c[t>>2]=c[d+40>>2];pt(25,0,71064,t);c[s>>2]=c[d+44>>2];pt(25,0,71088,s);ae[c[8926]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);pt(25,1,71112,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];pt(25,0,71128,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];pt(25,0,71144,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];pt(25,0,71176,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];pt(25,0,71208,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];pt(25,0,71232,m);ae[c[8926]&255](25)}else if((s|0)!=5){pt(25,1,71264,l);pt(25,0,71272,j);ae[c[8926]&255](25)}pt(25,0,71336,g);Nu(0);i=f;return 0}function xx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,71808)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(b|0,71816,y|0)|0;if((z|0)==0){C=Nd(10,b|0)|0;D=qd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,71832,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;sd(b|0,71848,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;sd(b|0,71856,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;sd(b|0,71864,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((tY(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,71832,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,71832,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((tY(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;sd(b|0,71848,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;sd(b|0,71848,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((tY(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;sd(b|0,71856,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;sd(b|0,71856,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((tY(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;sd(b|0,71864,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];sd(b|0,71832,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;sd(b|0,71848,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;sd(b|0,71856,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((tY(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;sd(b|0,71864,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,71808)|0;}while((d|0)!=0);C=Nd(10,b|0)|0;D=qd(b|0)|0;i=e;return}function yx(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 4:{v=c[618]|0;if((v|0)!=0){if((tY(v,71472)|0)==0){break a}}pt(23,0,71488,p);w=1;i=m;return w|0};case 5:{rt(1,0,71432,q);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{rt(1,0,71360,r);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 18:{v=c[618]|0;do{if((v|0)!=0){if((tY(v,71616)|0)!=0){break}c[u>>2]=4;break a}}while(0);pt(23,0,71640,o);w=1;i=m;return w|0};default:{}}}while(0);o=tx(a,s)|0;xe[c[36052>>2]&7]()|0;do{if((o|0)==0){r=vx(a,b,d,e,f,g)|0;xe[c[36052>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){be[c[76652>>2]&63](76632,a);xw(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(23,0,71768,n);r=se[c[c[a+540>>2]>>2]&63](a,t)|0;xe[c[36052>>2]&7]()|0;wx(a,s,l)|0;xe[c[36052>>2]&7]()|0;x=r}else{xe[c[36052>>2]&7]()|0;x=o}}while(0);ux(a,s)|0;w=x;i=m;return w|0}function zx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){Ax(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((de[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){tt(c[a+536>>2]|0,71880,d)}else if((k|0)==6){Ax(a);i=b;return}}function Ax(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;BY(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Bx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;WX(c[f+(a*48|0)+28>>2]|0);WX(c[f+(a*48|0)+32>>2]|0);WX(c[f+(a*48|0)+16>>2]|0);WX(c[f+(a*48|0)+20>>2]|0);WX(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}



function Cx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=VX(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=VX(c[y>>2]<<2)|0;Dx(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;zY(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;zY(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Ov(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Ex(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){zY(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;zY(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;WX(x);WX(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;rt(5,1,71936,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ic(q|0,71968,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;rt(5,0,71976,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=35704;K=c[8926]|0;ae[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=71984;aa=$;tt(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];rt(5,0,71976,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=35704;K=c[8926]|0;ae[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=71984;aa=$;tt(O,aa,g);return 0}function Dx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;BY(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}de[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Ex(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=XX(d,4)|0;r=XX(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;WX(q);WX(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;WX(q);WX(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){WX(q);WX(r);i=o;return v|0}if((n|0)==0){v=-1;WX(q);WX(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pt(5,1,72088,p);Fx(s,d,f,c[g>>2]|0,j,l,m);if((c[35172>>2]|0)==0){v=-1;WX(q);WX(r);i=o;return v|0}ae[c[8926]&255](5);v=-1;WX(q);WX(r);i=o;return v|0}function Fx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;BY(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];pt(5,0,72120,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Gx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=jc(72136,72160)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=bd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((bd(n|0)|0)!=10);q=c[b+152>>2]|0;r=XX(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=XX(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=XX(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=cc(n|0,72168,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=cc(n|0,72168,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=XX(s,8)|0;x=v}}while(0);hc(72176,j|0)|0;hc(72232,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hc(72192,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];hc(72216,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(72232)|0;Xc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Hx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}WX(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){WX(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}WX(l);i=d;return 0}function Ix(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Jx(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Kx(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[35188>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];pt(9,1,72296,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pt(9,0,72408,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}ae[c[8926]&255](9);g=1;i=b;return g|0}function Kx(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;Zx(b);g=f+540|0;de[c[(c[g>>2]|0)+84>>2]&127](f)|0;de[c[(c[g>>2]|0)+36>>2]&127](f)|0;de[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;se[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Lx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Kx(b,1.0);if((c[35188>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}pt(9,1,72432,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(9,0,72496,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(9,0,72456,s)}pt(9,1,72520,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;pt(9,0,72592,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];pt(9,0,72544,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;pt(9,0,72680,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(9,0,72616,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;pt(9,0,72768,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];pt(9,0,72712,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}ae[c[8926]&255](9);pt(9,1,72800,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=de[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;pt(9,0,72592,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];pt(9,0,72544,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}ae[c[8926]&255](9);ae[c[8926]&255](9);i=d;return}function Mx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[35188>>2]|0)!=0){yw(b,9)}if((c[35248>>2]|0)==0){i=d;return}pt(24,1,72824,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){pt(24,1,72864,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];pt(24,0,72888,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}ae[c[8926]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}pt(24,1,72944,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];pt(24,0,72968,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}ae[c[8926]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){pt(24,1,73e3,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];pt(24,0,72888,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}ae[c[8926]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){pt(24,1,73024,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;pt(24,0,73048,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}ae[c[8926]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){pt(24,1,73096,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?73168:73176;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?73168:73176;t=(a[(c[l>>2]|0)+n|0]|0)!=0?73168:73176;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;pt(24,0,73120,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}ae[c[8926]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){pt(24,1,73184,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;pt(24,0,73208,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}ae[c[8926]&255](24)}ae[c[8926]&255](24);i=d;return}function Nx(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;pt(9,0,73256,z);if((f|0)==0){vw(b);ww(b);C=6}else{if((a[f]|0)!=0){Ox(b,f,g)}vw(b);ww(b);if((a[f]|0)==0){C=6}}if((C|0)==6){de[c[(c[A>>2]|0)+84>>2]&127](b)|0;de[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(tY(d,74744)|0)==0|0;f=(tY(d,74752)|0)==0;z=(tY(d,74760)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;rt(1,0,73304,y);rt(1,0,73336,x);c[w>>2]=74744;c[w+4>>2]=74552;rt(1,0,73360,w);c[v>>2]=74752;c[v+4>>2]=74632;rt(1,0,73360,v);c[u>>2]=74760;c[u+4>>2]=74680;rt(1,0,73360,u);tt(c[b+536>>2]|0,73392,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(tY(e,c[73416+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;rt(1,0,73448,s);rt(1,0,73336,r);t=1;do{u=c[73480+(t<<2)>>2]|0;c[q>>2]=c[73416+(t<<2)>>2];c[q+4>>2]=u;rt(1,0,73360,q);t=t+1|0;}while((t|0)<7);tt(c[b+536>>2]|0,73392,p)}}while(0);p=c[73376+(D<<2)>>2]|0;c[o>>2]=c[73288+(D<<2)>>2];c[o+4>>2]=p;pt(9,0,73512,o);o=(D|0)==2;if(o){p=c[73480+(F<<2)>>2]|0;c[n>>2]=c[73416+(F<<2)>>2];c[n+4>>2]=p;pt(9,0,73552,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Px(b,F,j)|0;break}if((D|0)==3){Qx(b,j);I=0;break}else{tt(c[b+536>>2]|0,73592,m)}}}while(0);if(($w(b,1)|0)!=0){J=-2;Mx(b);K=15;L=K;M=73616;N=M;pt(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];ew(b,R,V);W=182;sw(b);X=188;xw(b);Y=183;nw(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=191;tw(b);i=k;return J|0}if((Tw(b,1)|0)!=0){J=-3;Mx(b);K=15;L=K;M=73616;N=M;pt(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];ew(b,R,V);W=182;sw(b);X=188;xw(b);Y=183;nw(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=191;tw(b);i=k;return J|0}m=(Jw(b,1)|0)==0;J=m?I:-4;Mx(b);K=15;L=K;M=73616;N=M;pt(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];ew(b,R,V);W=182;sw(b);X=188;xw(b);Y=183;nw(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=191;tw(b);i=k;return J|0}function Ox(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];pt(9,0,74776,z);z=du(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;tt(C,74816,y)}pt(9,0,74856,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=eu(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=Tx(c[d+(C*112|0)+4>>2]|0)|0;E=eu(A,D)|0;WX(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((uY(E,74896,6)|0)==0){if((c[35188>>2]|0)==0){break}}else{D=uY(E,74904,6)|0;if((c[35188>>2]|D|0)==0){break}}c[v>>2]=E;rt(9,0,74912,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;ku(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];pt(9,0,74880,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}pt(9,0,74968,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=eu(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=Tx(c[G+(w*112|0)+4>>2]|0)|0;v=eu(A,F)|0;WX(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];rt(9,0,74992,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;ku(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];pt(9,0,74880,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}pt(9,0,75048,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=eu(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=Tx(c[t+(x*112|0)+4>>2]|0)|0;K=eu(A,C)|0;WX(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];rt(9,0,74992,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;ku(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];pt(9,0,74880,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}pt(9,0,75072,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=eu(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=Tx(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=eu(A,u)|0;WX(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];rt(9,0,75120,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;ku(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;pt(9,0,75104,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}pt(9,0,75176,l);l=b+144|0;if((c[l>>2]|0)<=0){bu(A);i=f;return}o=b+32|0;b=0;do{x=eu(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=Tx(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=eu(A,n)|0;WX(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];rt(9,0,75224,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;ku(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?73168:73176;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;pt(9,0,75208,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));bu(A);i=f;return}function Px(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;dw(a,+h[a+240>>3]);sw(a);xw(a);nw(a);zw(a);Ax(a);ow(a);sw(a);e=Rx(a,b,c)|0;xw(a);nw(a);tw(a);xw(a);i=d;return e|0}function Qx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;dw(b,+h[b+240>>3]);sw(b);xw(b);Cx(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=XX(c[y>>2]|0,8)|0;A=b+124|0;B=XX(c[A>>2]|0,4)|0;C=b+128|0;D=XX(c[C>>2]|0,1)|0;E=b+132|0;F=XX(c[E>>2]|0,4)|0;G=b+536|0;st(c[G>>2]|0,(z|0)!=0|0,73648,t);st(c[G>>2]|0,(B|0)!=0|0,73648,s);st(c[G>>2]|0,(D|0)!=0|0,73648,r);st(c[G>>2]|0,(F|0)!=0|0,73648,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[35188>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];ic(x|0,73664,p|0)|0;p=jc(x|0,73680)|0;c[o>>2]=73696;sd(p|0,73688,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];sd(p|0,73688,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Nd(10,p|0)|0;H=p}pt(9,1,73704,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;de[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];pt(9,0,73728,l);if((c[35188>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(H|0,73752,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];sd(H|0,73752,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Nd(10,H|0)|0}if(($w(b,0)|0)!=0){break a}if((Tw(b,0)|0)!=0){break a}if((Jw(b,0)|0)!=0){break a}Aw(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);ae[c[8926]&255](9);if((c[35188>>2]|0)!=0){Xc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}WX(z);WX(B);WX(D);WX(F)}else{h[b+304>>3]=1.0;de[c[w+80>>2]&127](b)|0}pw(b);if((Cx(b,1,1)|0)!=1){i=e;return}de[c[(c[v>>2]|0)+80>>2]&127](b)|0;pw(b);if((Cx(b,1,1)|0)!=1){i=e;return}rt(1,0,73760,f);i=e;return}function Rx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=Ux(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){pt(9,0,73864,u);if((c[b+184>>2]|0)==0){se[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}WX(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){pt(9,0,73896,t);se[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;WX(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){pt(9,1,73968,s);t=VX(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Kx(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Kx(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}pt(9,1,73992,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];pt(9,0,74016,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];pt(9,0,74016,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];pt(9,0,74016,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[35188>>2]|0)!=0){ae[c[8926]&255](9);ae[c[8926]&255](9)}WX(t);Vx(v);H=Ux(b)|0;if((c[H>>2]|0)!=0){$=H;break}pt(9,0,74040,n);WX(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}pt(9,0,74072,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){pt(9,0,74088,l);Sx($,d,1,e);Lx(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Kx($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){WX(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){WX(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){WX(v);c[l>>2]=0}Sx($,d,0,e);Lx(b,$);+Kx($,1.0)}else{pt(9,0,74112,j)}pt(9,1,74136,g);Lx(b,$);b=Jx($)|0;if((c[35188>>2]|0)!=0){ae[c[8926]&255](9)}Vx($);y=b;i=f;return y|0}function Sx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=VX(c[p>>2]<<3)|0;r=q;s=+Kx(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;Xx(a,r);WX(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=74264;F=E;pt(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;pt(9,0,74176,m);if(!t){Wx(a)}switch(b|0){case 1:{G=cy(a)|0;break};case 2:{G=ay(a)|0;break};case 5:{H=13;break a;break};case 3:{G=ey(a,n,e)|0;break};case 4:{H=12;break a;break};case 6:{H=14;break a;break};default:{H=15;break a}}xw(o);nw(o);tw(o);xw(o);s=+Kx(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}pt(9,0,74224,k);Lx(o,a);K=s}else{pt(9,0,74240,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){$x(a)|0}else if((H|0)==13){$x(a)|0}else if((H|0)==14){_x(o,a,0)|0}else if((H|0)==15){tt(c[o+536>>2]|0,74200,l)}else if((H|0)==23){Xx(a,r);WX(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=74264;F=E;pt(9,0,F,g);i=f;return}}function Tx(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=xY(b|0)|0;do{if((d|0)==0){e=VX(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=VX(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((sY(e,75280,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;zY(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((sY(e,75280,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function Ux(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=VX(64)|0;z=y;st(0,(y|0)!=0|0,75288,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=XX(Z,8)|0;c[E>>2]=y;st(0,(y|0)!=0|0,75288,w);w=XX(Z,8)|0;c[F>>2]=w;st(0,(w|0)!=0|0,75288,v);v=XX(Z,8)|0;c[G>>2]=v;st(0,(v|0)!=0|0,75288,u);u=XX(Z,8)|0;c[H>>2]=u;st(0,(u|0)!=0|0,75288,t);t=XX(Z,8)|0;c[I>>2]=t;st(0,(t|0)!=0|0,75288,s);s=XX(Z,4)|0;t=s;c[J>>2]=t;st(0,(s|0)!=0|0,75288,r);pt(9,0,75304,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;pt(9,0,75328,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];pt(9,0,75416,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];pt(9,0,75464,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];pt(9,0,75520,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;pt(9,0,75576,l);c[j>>2]=ya;pt(9,0,75648,j);j=XX(sa,8)|0;c[K>>2]=j;st(0,(j|0)!=0|0,75288,g);g=VX(sa<<3)|0;c[L>>2]=g;st(0,(g|0)!=0|0,75288,f);f=VX(ya<<3)|0;c[M>>2]=f;st(0,(f|0)!=0|0,75288,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function Vx(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){WX(d)}d=c[a+28>>2]|0;if((d|0)!=0){WX(d)}d=c[a+32>>2]|0;if((d|0)!=0){WX(d)}d=c[a+36>>2]|0;if((d|0)!=0){WX(d)}d=c[a+40>>2]|0;if((d|0)!=0){WX(d)}d=c[a+44>>2]|0;if((d|0)!=0){WX(d)}d=c[a+48>>2]|0;if((d|0)!=0){WX(d)}d=c[a+52>>2]|0;if((d|0)!=0){WX(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;WX(e);i=b;return}WX(d);e=a;WX(e);i=b;return}function Wx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=XX(o,8)|0;q=XX(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=XX(s,8)|0;u=XX(s,8)|0;v=XX(o,8)|0;w=XX(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Kx(b,1.0);s=c[n>>2]|0;if((s|0)>0){zY(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Kx(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){zY(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;pt(9,0,75688,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}WX(p);WX(q);WX(t);WX(u);WX(v);WX(w);i=d;return}function Xx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Yx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function Zx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function _x(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;tt(c[a+536>>2]|0,75760,d);return 0}function $x(a){a=a|0;a=i;i=i+8|0;tt(0,75792,a);return 0}function ay(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[35188>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=XX((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;st(0,(n|0)!=0|0,75832,b);c[18962]=c[a+60>>2];c[18964]=c[a+48>>2];Fv(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;WX(n);c[18962]=0;c[18964]=0;n=Jx(a)|0;i=b;return n|0}function by(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[18964];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[18962];h[d>>3]=+Kx(f,1.0);i=e;return}function cy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=VX(x)|0;z=y;A=VX(x)|0;x=A;st(0,(y|0)!=0|0,75864,n);st(0,(A|0)!=0|0,75864,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[35188>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Kx(a,1.0);h[o>>3]=D;if(D!=0.0){c[18970]=c[a+60>>2];c[18972]=c[a+48>>2];Cv(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[18970]=0;c[18972]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];pt(9,0,75896,l)}D=+Kx(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];pt(9,0,76e3,j);j=c[u>>2]|0;do{if((j|0)==4){rt(9,0,76232,d);F=-4;i=b;return F|0}else if((j|0)==2){rt(9,0,76096,f);F=-2;i=b;return F|0}else if((j|0)==3){rt(9,0,76160,e);F=-3;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];rt(9,0,76016,g);F=-1;i=b;return F|0}}while(0);F=Jx(a)|0;i=b;return F|0}function dy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[18972];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[18970];h[d>>3]=+Kx(f,1.0);i=e;return}function ey(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;pt(9,1,76288,g);if((c[35188>>2]|0)==0){l=0}else{l=(k|0)/10|0}fy(a,d,k,l,b,j);c[f>>2]=c[j>>2];pt(9,0,76312,f);ae[c[8926]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Jx(a)|0;if((b|0)==0){m=0;i=e;return m|0}rt(9,0,76328,e);m=b;i=e;return m|0}function fy(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=VX(fa(N,M)|0)|0;P=VX(M<<3)|0;Q=VX(N)|0;R=Q;S=VX(N)|0;T=S;V=VX(N)|0;W=V;X=VX(N)|0;Y=+h[f>>3];if((c[35188>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];ic(N|0,76376,I|0)|0;I=jc(N|0,76392)|0;c[H>>2]=76408;sd(I|0,76400,H|0)|0;c[G>>2]=76424;sd(I|0,76400,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];sd(I|0,76400,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Nd(10,I|0)|0;c[E>>2]=0;sd(I|0,76432,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(I|0,76440,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];sd(I|0,76440,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Nd(10,I|0)|0;Z=I}else{Z=0}st(0,(O|0)!=0|0,76448,B);st(0,(P|0)!=0|0,76448,A);st(0,(Q|0)!=0|0,76448,z);st(0,(S|0)!=0|0,76448,y);st(0,(V|0)!=0|0,76448,x);st(0,(X|0)!=0|0,76448,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Yx(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Kx(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Yx(a,la);+Kx(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];pt(9,0,76464,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){BY(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Yx(a,R);za=+Kx(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}zY(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Yx(a,T);if(+Kx(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}zY(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}zY(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Yx(a,W);Ba=+Kx(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Yx(a,W);Ba=+Kx(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}zY(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];pt(9,0,76504,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;sd(Z|0,76432,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];sd(Z|0,76440,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(Z|0,76440,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Nd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];rt(9,0,76552,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];rt(9,0,76568,p);tt(0,76584,o)}Yx(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){WX(S);WX(Q);WX(V);WX(X);WX(P);WX(O);i=j;return}c[n>>2]=ia;sd(Z|0,76432,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,76440,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,76440,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Nd(10,Z|0)|0;Xc(Z|0)|0;WX(S);WX(Q);WX(V);WX(X);WX(P);WX(O);i=j;return}function gy(a,b){a=a|0;b=b|0;i=i;return}function hy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Nu(3);Qu(0);w=+Iu(0);Nu(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(v|0,76664,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];sd(v|0,76664,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(v|0,76664,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];sd(v|0,76672,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;sd(v|0,76672,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];sd(v|0,76680,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,76664,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,76664,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;sd(v|0,76672,l|0)|0;break}else{c[m>>2]=0-E;sd(v|0,76672,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;sd(v|0,76672,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;sd(v|0,76672,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Nd(10,v|0)|0;Qu(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];sd(v|0,76680,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Nd(10,v|0)|0;Qu(3);i=e;return}function iy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=jc(c[r>>2]|0,76688)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Rd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;st(t,(s|0)!=0|0,76696,q);c[p>>2]=76752;sd(s|0,76680,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=76760;sd(s|0,76680,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];sd(s|0,76680,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];sd(s|0,76680,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];sd(s|0,76680,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];sd(s|0,76680,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];sd(s|0,76680,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];sd(s|0,76680,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];sd(s|0,76680,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Nd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];sd(s|0,76680,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Nd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function jy(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Nu(3);Xc(d|0)|0;Qu(3);i=b;return}function ky(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;fQ(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];gQ(p,f)|0;ly(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;my(a,b,76776,c[j>>2]|0,c[g>>2]|0,o,8);WX(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];gQ(p,e)|0;i=d;return}function ly(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=XX(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;st(c[b+536>>2]|0,(p|0)!=0|0,77056,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function my(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;xy(a,b,d,e,f,h);eQ(l,g,fa(fa(f,e)|0,h)|0)|0;if(BO(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];tt(l,77008,k)}else{i=j;return}}function ny(a){a=a|0;var b=0;b=i;if((pz(a+4|0)|0)!=0){i=b;return}EO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function oy(a){a=a|0;Rc(a|0)|0;Ya()}function py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=$X(320)|0;BY(q|0,0,320)|0;qy(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Nu(3);t=a+8|0;u=ry(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=sy(a,b,u+s|0)|0;u=q+184|0;ty(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;ty(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;uy(q,c[x>>2]|0,36);if(BO(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];tt(y,76832,e)}else{my(a,b,76864,4,11,76784,1);vy((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;my(a,b,76872,c[g>>2]|0,c[j>>2]|0,e,1);WX(e);c[f>>2]=0;vy((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;my(a,b,76880,c[g>>2]|0,c[j>>2]|0,e,1);WX(e);c[f>>2]=0;wy(a,b,k,g,j,c[r>>2]|0,s);my(a,b,76896,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;fQ(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];ly(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;my(a,b,76776,c[j>>2]|0,c[g>>2]|0,n,8);fQ(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=yy(q+240|0)|0;w=yy(q+264|0)|0;p=yy(q+288|0)|0;xy(a,b,76912,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);WX(n);WX(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;MP(s)|0;WX(v);Qu(3);i=d;return}}function qy(a){a=a|0;var b=0;b=i;zB(a);i=b;return}function ry(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(DA(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(DA(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(DA(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function sy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=VX(e<<2)|0;e=l;c[l>>2]=77464;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=77504;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(DA(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(DA(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(DA(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function ty(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;oz(a,b,c);i=d;return}function uy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(nz(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){EO(d,4);i=e;return}else{CO(d,0);i=e;return}}function vy(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=xY(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=XX((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;st(0,(o|0)!=0|0,76984,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;IY(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;Cy(q,xY(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=XX(1,1)|0;c[d>>2]=q;st(0,(q|0)!=0|0,76984,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function wy(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=XX(c[f>>2]<<2,4)|0;c[e>>2]=g;st(c[d+536>>2]|0,(g|0)!=0|0,77032,k);g=s+240|0;f=yy(g)|0;h=s+264|0;t=yy(h)|0;u=s+288|0;v=yy(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=yy(g)|0;D=yy(h)|0;E=yy(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){Dy(l,b,A+(v*52|0)+4|0);Fy(n,b);if(!(Ey(l,n)|0)){F=w;break}G=(c[(Gy(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){Dy(l,g,A+(v*52|0)+4|0);Fy(m,g);if(!(Ey(l,m)|0)){F=w;break}G=(c[(Gy(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){Dy(l,v,G+(t*52|0)+4|0);Fy(p,v);J=(Ey(l,p)|0)&1}else if(f<<24>>24==0){Dy(l,h,G+(t*52|0)+4|0);Fy(o,h);f=Ey(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(Gy(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){Dy(l,u,y+(t*52|0)+4|0);Fy(q,u);F=Ey(l,q)|0;M=F?2:0}else if(x<<24>>24==1){Dy(l,d,y+(t*52|0)+4|0);Fy(r,d);M=(Ey(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(Gy(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function xy(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(xY(d|0)|0)+1;e=m;eQ(e,l,20)|0;if(BO(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];tt(l,77008,k)}eQ(e,d,c[f>>2]|0)|0;if(BO(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];tt(m,77008,j)}else{i=h;return}}function yy(a){a=a|0;var b=0,d=0;b=i;d=c[(kz(a)|0)>>2]|0;i=b;return d|0}function zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Nu(3);do{if(AO(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];gQ(k,e)|0;k=yy(h+240|0)|0;m=yy(h+264|0)|0;l=yy(h+288|0)|0;xy(a,b,76912,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);ny(h)}else{if((h|0)!=0){break}c[g>>2]=0;Qu(3);i=d;return}}while(0);Ay(j);bY(h);c[g>>2]=0;Qu(3);i=d;return}function Ay(a){a=a|0;var b=0;b=i;Iz(a);i=b;return}function By(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Nu(3);Qu(0);h[j>>3]=+Iu(0);Nu(0);l=k;m=d+4|0;eQ(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){eQ(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){eQ(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);eQ(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);eQ(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);eQ(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(BO(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];tt(t,76952,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Qu(3);i=e;return}}function Cy(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((uY(b,77168,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((uY(b,77168,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function Dy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Yy(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Oy(a,f);i=e;return}function Ey(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=My(a,b)|0;i=c;return d|0}function Fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Py(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Oy(a,e);i=d;return}function Gy(a){a=a|0;var b=0,c=0;b=i;c=Hy(Iy(a)|0)|0;i=b;return c|0}function Hy(a){a=a|0;var b=0,c=0;b=i;c=Ly(a)|0;i=b;return c|0}function Iy(a){a=a|0;var b=0,d=0;b=i;d=Jy((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Jy(a){a=a|0;var b=0,c=0;b=i;c=Ky(a)|0;i=b;return c|0}function Ky(a){a=a|0;i=i;return a|0}function Ly(a){a=a|0;i=i;return a|0}function My(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Ny(a,b)|0)^1;i=c;return d|0}function Ny(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Oy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Xy(a,e);i=d;return}function Py(a,b){a=a|0;b=b|0;var c=0;c=i;Qy(a,Ry(b)|0);i=c;return}function Qy(a,b){a=a|0;b=b|0;var c=0;c=i;Wy(a,b);i=c;return}function Ry(a){a=a|0;var b=0,c=0;b=i;c=Sy(Ty(a+4|0)|0)|0;i=b;return c|0}function Sy(a){a=a|0;var b=0,c=0;b=i;c=Vy(a)|0;i=b;return c|0}function Ty(a){a=a|0;var b=0,c=0;b=i;c=Uy(a)|0;i=b;return c|0}function Uy(a){a=a|0;i=i;return a|0}function Vy(a){a=a|0;i=i;return a|0}function Wy(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Xy(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Yy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=_y(b)|0;Zy(f,b,d,h,Ry(b)|0);Py(g,b);do{if(My(f,g)|0){h=$y(b)|0;if(az(h,d,bz(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Py(a,b);i=e;return}function Zy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;fz(h);a:do{if((e|0)==0){j=f}else{k=$y(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(gz(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;fz(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;fz(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Qy(a,j);i=g;return}function _y(a){a=a|0;var b=0,d=0;b=i;d=c[(Ry(a)|0)>>2]|0;i=b;return d|0}function $y(a){a=a|0;var b=0,c=0;b=i;c=dz(a+8|0)|0;i=b;return c|0}function az(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cz(0,b,c)|0;i=a;return d|0}function bz(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function cz(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function dz(a){a=a|0;var b=0,c=0;b=i;c=ez(a)|0;i=b;return c|0}function ez(a){a=a|0;i=i;return a|0}function fz(a){a=a|0;var b=0;b=i;hz(a,-1);i=b;return}function gz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=cz(0,b,c)|0;i=a;return d|0}function hz(a,b){a=a|0;b=b|0;b=i;iz(a,0);i=b;return}function iz(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function jz(a){a=a|0;i=i;return c[a+4>>2]|0}function kz(a){a=a|0;var b=0,c=0;b=i;c=lz(a+8|0)|0;i=b;return c|0}function lz(a){a=a|0;var b=0,c=0;b=i;c=mz(a)|0;i=b;return c|0}function mz(a){a=a|0;i=i;return a|0}function nz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 28:{h=77144;break};case 8:{h=77088;break};case 24:{h=77096;break};case 56:{h=77104;break};case 52:case 20:{h=77120;break};case 1:case 17:{h=77080;break};case 13:case 29:{h=77160;break};case 12:{h=77136;break};case 9:case 25:{h=77112;break};case 60:{h=77152;break};case 5:case 21:{h=77128;break};case 48:case 16:{h=77072;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=jc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Vc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Xc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function oz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function pz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}qz(d,f,102);f=de[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Xc(rz(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}sz(d);g=h;i=b;return g|0}function qz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;zz(a,b,c);i=d;return}function rz(a){a=a|0;var b=0,d=0;b=i;d=vz(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}



function _u(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==-1){EL(45576,45808,80,49);C=45880;D=45888;Zu(45576,45864,45872,C,C,C,C,C,D,D,80)|0;EL(45576,45896,80,47);D=45880;C=45888;Zu(45576,45944,45952,D,45960,n,D,D,C,C,80)|0;EL(45576,45968,80,41);C=45880;D=45888;Zu(45576,46016,46024,45960,C,C,C,C,D,D,80)|0;i=y;return 0}else if((A|0)==0){c[11380]=2;D=2;while(1){C=D+1|0;if(!((c[k+(D+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[11380]=C;if((C|0)<12){D=C}else{break}}if((c[d>>2]|0)<1){EL(45576,47272,80,25);D=45880;C=45888;Zu(45576,47304,46056,D,45960,d,D,D,C,C,80)|0;break}c[11444]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{D=c[C>>2]|0;c[11444]=D;if(!((D+ -1|0)>>>0>4)){E=D;break}EL(45576,47312,80,34);D=45880;F=45888;Zu(45576,47352,46048,D,45960,45776,D,D,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;D=fa(F,F)|0;c[11430]=D;c[11442]=D+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);D=q+12|0;if((c[k+16>>2]|0)==0){c[D>>2]=2;break}else{c[D>>2]=1;break}}else{D=c[q>>2]|0;do{if((D|0)>=0){F=c[d>>2]|0;if((D|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){EL(45576,48136,80,52);I=45880;J=45888;Zu(45576,48120,48192,I,45960,G,I,I,J,J,80)|0;break a}c[11430]=fa((D<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[11442]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[11430]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[11442]=F+(c[11430]|0);break b}}}while(0);EL(45576,48064,80,52);D=45880;F=45888;Zu(45576,48120,48128,D,45960,q,D,D,F,F,80)|0;break a}}while(0);c[11434]=(c[d>>2]|0)+20;c[q+64>>2]=c[11430];if((c[p>>2]|0)<(c[11442]|0)){EL(45576,47360,80,60);C=45880;F=45888;Zu(45576,47424,47432,C,46056,45768,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[11434]|0)){EL(45576,47440,80,60);F=45880;C=45888;Zu(45576,47424,47504,F,46056,45736,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){EL(45576,48248,80,24);C=45960;F=45880;D=45888;Zu(45576,48280,48288,C,C,w,F,F,D,D,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[5712]=K;if(!(K<=0.0)){break}EL(45576,47744,80,28);D=45880;Zu(45576,46456,47776,D,D,D,D,45960,45696,45888,80)|0;break a}}while(0);c[q+60>>2]=0;D=q+36|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[n>>2]=1;B=27}else{B=210}}while(0);c:do{if((B|0)==27){a[45752]=0;K=+h[l>>3];h[5723]=K;L=+h[m>>3];h[5716]=L;r=c[d>>2]|0;c[11380]=1;do{if((r|0)>=1){p=k+4|0;E=0;A=1;M=L;N=K;while(1){if((c[p>>2]|0)==1){D=A+ -1|0;O=+h[l+(D<<3)>>3];h[5723]=O;P=+h[m+(D<<3)>>3];h[5716]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[45752]=1;S=1}else{S=E}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}D=A+1|0;c[11380]=D;if((A|0)<(r|0)){E=S;A=D;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}A=c[d>>2]|0;E=A+51|0;c[11390]=E;p=E+(c[w>>2]|0)|0;c[11392]=p;E=p+(c[w>>2]|0)|0;c[11414]=E;D=E+(c[w>>2]|0)|0;c[11384]=D;F=D+(c[d>>2]|0)|0;c[11420]=F;C=F+(c[d>>2]|0)|0;c[11426]=C;c[11416]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[11440]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[5725]=+h[F>>3];a[45688]=0;h[5694]=+h[o+24>>3];J=o+16|0;h[5689]=+h[J>>3];do{if((c[w>>2]|0)!=0){$u(46056,v,w,d,45552,j,f,o+(D+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(A+50<<3)|0,o+(p+ -1<<3)|0,o+(E+ -1<<3)|0,x,45672,F,0,o,q,s,t)|0;if((c[11510]|0)>0){i=y;return 0}if((c[11418]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=45960;wv(d,o+((c[11384]|0)+ -1<<3)|0,G,g,G)|0;a[45688]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[5689];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[5689]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[5689];if((M-N)*P>0.0){B=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[5724]=O;U=+h[5694];V=U-O;G=V*P>0.0;do{if(F){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[11426]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){ev(45552,j,f,g,d,H,I,X)|0;if((c[11510]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45688]=1;B=197;break d}}else{Y=45552;ev(Y,Y,f,g,d,H,I,X)|0;if((c[11510]|0)>0){i=y;return 0}else{h[e>>3]=+h[5694];c[n>>2]=1;a[45688]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}ev(45552,j,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45688]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[5725]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[5689]=W;h[J>>3]=W;break}ev(45552,45792,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[5724];a[45688]=1;B=197;break d}}else{W=+h[5694];if(!F){if(P*(W-N)<0.0){break}ev(45552,j,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45688]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[11426]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){ev(45552,j,f,g,d,G,X,I)|0;if((c[11510]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[45688]=1;B=197;break d}}else{H=45552;ev(H,H,f,g,d,G,X,I)|0;if((c[11510]|0)>0){i=y;return 0}else{h[e>>3]=+h[5694];c[n>>2]=1;a[45688]=1;B=197;break d}}}}while(0);if(a[45688]&1){B=197}else{B=128}}else{h[5694]=+h[e>>3];c[n>>2]=1;bv(d,k+4|0,l,m,f,o+((c[11420]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[11380]=1;e:do{if((F|0)>=1){J=c[11420]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[11380]=X;if((I|0)<(F|0)){I=X}else{break e}}EL(45576,47880,80,39);I=45880;J=45888;Zu(45576,47552,47920,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+iv(46032,1);h[5725]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[5725]*4.0*(aa>=ba?aa:ba);h[5714]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){EL(45576,47928,80,60);J=45880;Zu(45576,47424,47992,J,J,J,J,46056,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[5693]=ca*.001;U=+cv(d,g,o+((c[11420]|0)+ -1<<3)|0,s,t);if(U>.5/+h[5693]){h[5693]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+BL(45544,z);h[5693]=U;da=U}else{U=+h[o+16>>3];h[5693]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}EL(45576,47832,80,29);J=45880;I=45888;Zu(45576,47864,47872,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[5693]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[5724]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[5693]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{dv(45552,f,g,d,b,u,45544,o+((c[11420]|0)+ -1<<3)|0,n,s,t,o+((c[11426]|0)+ -1<<3)|0,o+400|0,o+((c[11384]|0)+ -1<<3)|0,o+((c[11416]|0)+ -1<<3)|0,q,45712,F,k+36|0,45760)|0;if((c[11510]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[5693]}h[5689]=ja;h[o+16>>3]=ja;J=c[11426]|0;X=(c[d>>2]|0)+J|0;c[11436]=X;G=c[d>>2]|0;c[11380]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[5689]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[11380]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[5689];h[o+232>>3]=+h[5689]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}$u(45960,v,w,d,e,j,f,o+((c[11384]|0)+ -1<<3)|0,o+((c[11426]|0)+ -1<<3)|0,J,Y,o+((c[11390]|0)+ -1<<3)|0,o+((c[11392]|0)+ -1<<3)|0,o+((c[11414]|0)+ -1<<3)|0,x,45672,F,0,o,q,s,t)|0;if((c[11510]|0)>0){i=y;return 0}if((c[11418]|0)!=0){EL(45576,48296,80,47);la=45880;ma=45888;Zu(45576,45944,48344,45960,la,la,la,la,ma,ma,80)|0;EL(45576,48352,80,38);ma=45880;la=45888;Zu(45576,46104,48344,45960,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}$u(46048,v,w,d,45552,j,f,o+((c[11384]|0)+ -1<<3)|0,o+((c[11426]|0)+ -1<<3)|0,J,Y,o+((c[11390]|0)+ -1<<3)|0,o+((c[11392]|0)+ -1<<3)|0,o+((c[11414]|0)+ -1<<3)|0,x,45672,F,0,o,q,s,t)|0;if((c[11510]|0)>0){i=y;return 0}if((c[11418]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=45960;wv(d,o+((c[11384]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){EL(45576,47672,80,54);E=45880;Zu(45576,47728,47736,E,E,E,E,46056,45792,j,80)|0;break c}else if((B|0)==220){EL(45576,47784,80,34);E=45880;Zu(45576,47352,47824,E,E,E,E,46056,j,e,80)|0;break c}else if((B|0)==224){EL(45576,48e3,80,49);E=45880;Zu(45576,45864,48056,E,E,E,E,46056,45792,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;bv(d,oa,l,m,o+((c[11426]|0)+ -1<<3)|0,o+((c[11420]|0)+ -1<<3)|0,s,t)|0;if((c[11510]|0)>0){B=233;break}E=c[d>>2]|0;c[11380]=1;p=c[11420]|0;if((E|0)>=1){A=1;while(1){C=A+1|0;if(!(+h[o+(A+ -2+p<<3)>>3]>0.0)){B=136;break f}c[11380]=C;if((A|0)<(E|0)){A=C}else{break}}}O=+cv(d,o+((c[11426]|0)+ -1<<3)|0,o+(p+ -1<<3)|0,s,t)*100.0;V=+h[5725];pa=O*V;h[5691]=pa;if(!(pa<=1.0)){B=138;break}O=+h[5694];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[5714]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[5689];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[5689]=V/O}}while(0);fv(45552,f,g,d,b,u,45512,o+((c[11420]|0)+ -1<<3)|0,k,n,s,t,o+((c[11426]|0)+ -1<<3)|0,o+400|0,o+((c[11384]|0)+ -1<<3)|0,o+((c[11416]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,45712,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,45760)|0;if((c[11510]|0)>0){B=233;break}p=c[n>>2]|0;if((p|0)<0){na=p;break}do{if((c[w>>2]|0)!=0){$u(46048,v,w,d,45552,j,f,o+((c[11384]|0)+ -1<<3)|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[11390]|0)+ -1<<3)|0,o+((c[11392]|0)+ -1<<3)|0,o+((c[11414]|0)+ -1<<3)|0,x,45672,o+64|0,0,o,q,s,t)|0;if((c[11510]|0)>0){B=233;break f}if((c[11418]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];p=45960;wv(d,o+((c[11384]|0)+ -1<<3)|0,p,g,p)|0;B=197;continue f}}while(0);p=(c[k+8>>2]|0)!=0;O=+h[5694];V=+h[5689];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!p){if(U<0.0){B=128;continue}ev(45552,j,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}ev(45552,j,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(p){if(U>=0.0){ev(45552,j,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[5724];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[5725]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}ev(45552,45792,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[5724];B=197;continue}if(!(U<0.0)){ev(45552,j,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[5724];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[5725]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[5689]=U-O;B=128;continue}else{ev(45552,45792,f,g,d,q+28|0,o+((c[11426]|0)+ -1<<3)|0,o+224|0)|0;if((c[11510]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[5724];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[5694];h[o+16>>3]=+h[5689];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[5691]*+h[m>>3];c[n>>2]=-2;na=-2;break}p=c[d>>2]|0;c[11380]=1;if((p|0)>=1){O=pa;A=1;E=0;while(1){F=l+(E<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(A+ -1<<3)|0;h[F>>3]=+h[5691]*+h[F>>3];if((A|0)>=(p|0)){break}F=A;O=+h[5691];A=A+1|0;E=F}c[11380]=p+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);E=0-na|0;c[11436]=E;switch(E|0){case 2:{EL(45576,46192,80,47);E=45880;Zu(45576,45944,46240,E,E,E,E,45960,45552,45888,80)|0;EL(45576,46248,80,48);E=45880;A=45888;Zu(45576,46176,46304,E,E,E,E,E,A,A,80)|0;EL(45576,46312,80,45);A=45880;E=45888;Zu(45576,46360,46368,A,A,A,A,A,E,E,80)|0;break};case 3:{EL(45576,46376,80,38);E=45880;Zu(45576,46104,46416,E,E,E,E,45960,45552,45888,80)|0;EL(45576,46424,80,28);E=45880;A=45888;Zu(45576,46456,46464,E,E,E,E,E,A,A,80)|0;break};case 6:{EL(45576,46472,80,44);A=45880;Zu(45576,46520,46528,A,A,A,A,46056,45552,45512,80)|0;EL(45576,46536,80,57);A=45880;E=45888;Zu(45576,46600,46608,A,A,A,A,A,E,E,80)|0;break};case 7:{EL(45576,46472,80,44);E=45880;Zu(45576,46520,46616,E,E,E,E,46056,45552,45512,80)|0;EL(45576,46624,80,48);E=45880;A=45888;Zu(45576,46176,46680,E,E,E,E,E,A,A,80)|0;EL(45576,46688,80,28);A=45880;E=45888;Zu(45576,46456,46720,A,A,A,A,A,E,E,80)|0;break};case 8:{EL(45576,46472,80,44);E=45880;Zu(45576,46520,46728,E,E,E,E,46056,45552,45512,80)|0;EL(45576,46736,80,37);E=45880;A=45888;Zu(45576,46776,46784,E,E,E,E,E,A,A,80)|0;break};case 9:{EL(45576,46472,80,44);A=45880;Zu(45576,46520,46792,A,A,A,A,46056,45552,45512,80)|0;EL(45576,46800,80,49);A=45880;E=45888;Zu(45576,45864,46856,A,A,A,A,A,E,E,80)|0;EL(45576,46864,80,38);E=45880;A=45888;Zu(45576,46104,46904,E,E,E,E,E,A,A,80)|0;break};case 10:{EL(45576,46472,80,44);A=45880;Zu(45576,46520,46912,A,A,A,A,46056,45552,45512,80)|0;EL(45576,46920,80,45);A=45880;E=45888;Zu(45576,46360,46968,A,A,A,A,A,E,E,80)|0;EL(45576,46976,80,36);E=45880;A=45888;Zu(45576,47016,47024,E,E,E,E,E,A,A,80)|0;break};case 11:{EL(45576,47032,80,40);A=45880;Zu(45576,47080,47088,A,A,A,A,46056,45552,45512,80)|0;EL(45576,47096,80,36);A=45880;E=45888;Zu(45576,47016,47136,A,A,A,A,A,E,E,80)|0;break};case 12:{EL(45576,46472,80,44);E=45880;Zu(45576,46520,47144,E,E,E,E,46056,45552,45544,80)|0;EL(45576,47152,80,45);E=45880;A=45888;Zu(45576,46360,47200,E,E,E,E,E,A,A,80)|0;break};case 5:case 4:{break};default:{EL(45576,46064,80,38);A=45880;Zu(45576,46104,46112,A,A,A,A,45960,45552,45888,80)|0;EL(45576,46120,80,48);A=45880;E=45888;Zu(45576,46176,46184,A,A,A,A,A,E,E,80)|0}}c[k>>2]=-1;h[e>>3]=+h[5694];h[o+24>>3]=+h[5694];h[o+16>>3]=+h[5689];i=y;return 0}else if((B|0)==215){EL(45576,47512,80,39);E=45880;A=45888;Zu(45576,47552,47560,E,E,E,E,E,A,A,80)|0;break c}else if((B|0)==216){EL(45576,47568,80,39);A=45880;E=45888;Zu(45576,47552,47608,A,A,A,A,A,E,E,80)|0;break c}}}while(0);EL(45576,47616,80,47);r=45880;E=45888;Zu(45576,45944,47664,r,r,r,r,r,E,E,80)|0}else if((B|0)==210){EL(45576,47208,80,55);E=45880;r=45888;Zu(45576,47264,45960,E,E,E,E,E,r,r,80)|0}}while(0);if((B|0)==227){EL(45576,48200,80,39);B=45880;Zu(45576,47552,48240,B,B,B,B,46056,j,e,80)|0}if((c[k>>2]|0)==-1){EL(45576,48392,80,46);e=45880;j=45888;Zu(45576,48440,48448,e,e,e,e,e,j,j,80)|0;EL(45576,48456,80,47);j=45880;e=45888;Zu(45576,45944,48504,45960,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function $u(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[6064]=C;c[t>>2]=0;D=c[e>>2]|0;c[12130]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[12130]|0;E=F+1|0;c[12130]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[6071]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;ev(g,b,k,l,f,o,m,n)|0;if((c[11510]|0)>0){i=v;return 0}D=d;Yd[D&7](f,b,k,e,p,y,z)|0;if((c[11510]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[48576]=0;F=c[e>>2]|0;c[12130]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[48576]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[12130]=F+1;if(!M){break}I=+BL(48568,48512);h[6068]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[6064];do{if((H- +h[g>>3])*I<0.0){ev(g,b,k,l,f,o,m,n)|0;if((c[11510]|0)<=0){break}i=v;return 0}else{G=+h[6068]/I;h[6069]=G;N=c[f>>2]|0;c[12130]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[6069];Q=Q+1|0}c[12130]=N+1}}while(0);Yd[D&7](f,b,k,e,p,y,z)|0;if((c[11510]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[48576]=0;F=c[e>>2]|0;c[12130]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[48576]=1;V=1;W=c[12130]|0}Q=W+1|0;c[12130]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[6064];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;ev(g,F,k,l,f,o,m,n)|0;if((c[11510]|0)>0){i=v;return 0}E=d;Yd[E&7](f,F,k,e,p,y,z)|0;if((c[11510]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[48576]=0;D=c[e>>2]|0;c[12130]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[48576]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[12130]=D+1;if(!aa){i=v;return 0}I=+BL(48568,48512);h[6068]=I;h[F>>3]=I+ +h[F>>3];I=+h[6068]/+h[6064];h[6069]=I;Q=c[f>>2]|0;c[12130]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[6069];R=R+1|0}c[12130]=Q+1}Yd[E&7](f,F,k,e,p,y,z)|0;if((c[11510]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[48576]=0;R=c[e>>2]|0;c[12130]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[48576]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[12130]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[6067]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}ev(g,48536,k,l,f,o,m,n)|0;if((c[11510]|0)<=0){break}i=v;return 0}else{h[6067]=Y;j=c[f>>2]|0;c[12130]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[12130]=j+1}}while(0);ga=d;Yd[ga&7](f,48536,k,e,q,y,z)|0;if((c[11510]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[12140]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){av(e,48568,48560,R,48536,p,q,r,48528,s,fa,da,x,ca)|0;if((c[11510]|0)>0){ha=76;break}if((c[12140]|0)>1){ha=73;break}ev(g,48528,k,l,f,o,m,n)|0;if((c[11510]|0)>0){ha=76;break}Yd[ga&7](f,48528,k,e,r,y,z)|0;if((c[11510]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[6066];R=45960;wv(e,r,R,p,R)|0;if((c[12140]|0)==4){i=v;return 0}ev(g,48528,k,l,f,o,m,n)|0;if((c[11510]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function av(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[12156]=c[o>>2];c[o>>2]=0;h[6074]=0.0;a[48608]=0;t=c[b>>2]|0;c[12146]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+BL(48640,j+(v<<3)|0);if(w==+BL(48640,l+((c[12146]|0)+ -1<<3)|0)){break}y=c[12146]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[6074]){break}h[6074]=B;c[o>>2]=y}else{a[48608]=1}}while(0);v=c[12146]|0;u=v+1|0;c[12146]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[48616]=1;c[12158]=c[p>>2];h[g>>3]=+h[r>>3];t=45960;wv(b,l,t,k,t)|0;c[p>>2]=1;a[48600]=0;C=0}else{a[48616]=0;c[o>>2]=c[12156];c[12158]=c[p>>2];if(a[48608]&1){h[g>>3]=+h[r>>3];t=45960;wv(b,l,t,k,t)|0;a[48600]=1;C=1;break}else{t=45960;wv(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[48600]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[48600]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=45960;wv(b,k,t,l,t)|0;t=c[b>>2]|0;c[12146]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[12146]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+BL(48640,j+(u<<3)|0);if(!(A!=+BL(48640,k+((c[12146]|0)+ -1<<3)|0))){break}c[n+((c[12146]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[12146]|0;F=u+1|0;c[12146]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[6074]=0.0;a[48608]=0;t=c[b>>2]|0;c[12146]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+BL(48640,j+(v<<3)|0);if(A==+BL(48640,k+((c[12146]|0)+ -1<<3)|0)){break}y=c[12146]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[6074]){break}h[6074]=I;c[o>>2]=y}else{a[48608]=1}}while(0);v=c[12146]|0;u=v+1|0;c[12146]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[48616]=t&1;if(t){a[48600]=0;c[12158]=0;c[p>>2]=1;break}if(!(a[48608]&1)){t=45960;wv(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=45960;wv(b,k,t,l,t)|0;t=c[b>>2]|0;c[12146]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[12146]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[12146]|0}u=K+1|0;c[12146]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[12158]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function bv(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[6083]=+h[d>>3];h[6082]=+h[e>>3];j=c[a>>2]|0;c[12162]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[6083]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[6083]=o;h[6082]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[6082];a=l+1|0;c[12162]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function cv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[6086]=0.0;e=c[a>>2]|0;c[12168]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[6086]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[12168]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[6085]=0.0;e=c[a>>2]|0;c[12168]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[6085]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[12168]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function dv(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[12186]=0;c[12184]=0;c[12190]=0;h[6098]=+h[b>>3];h[6100]=+cv(f,d,l,0,0);C=c[f>>2]|0;c[12174]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[12174]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[6091]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[12174]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[12174]=G+1}a[48792]=1;c[12176]=0;a[48808]=1;c[C>>2]=(c[C>>2]|0)+1;c[12194]=0;Yd[B&7](b,d,e,q,48776,n,o)|0;b:do{if((c[12194]|0)<0){K=35}else{while(1){if(a[48792]&1){c[E>>2]=(c[E>>2]|0)+1;a[48792]=0;gv(f,b,d,e,q,48728,k,48752,l,r,s,t,g,48776,v,j,n,o,x)|0;h[6090]=1.0e6;if((c[12194]|0)<0|(c[12188]|0)!=0){K=35;break b}c[12190]=0}H=c[f>>2]|0;c[12174]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[12174]=H+1}hv(f,q,s,t)|0;I=c[f>>2]|0;c[12174]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[6091]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[12174]=I+1}N=+cv(f,q,l,0,0);h[6102]=N;if(N<=+h[v>>3]*100.0*+h[6100]){break}J=c[12176]|0;if((J|0)>0){h[z>>3]=N/+h[6103];h[A>>3]=1.0/+(J|0);O=+zL(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[6090]=P;Q=+h[6102];R=P}else{h[6103]=N;Q=N;R=+h[6090]}if(R*Q<=.33){break}J=c[12176]|0;H=J+1|0;c[12176]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[48792]=1}c[C>>2]=(c[C>>2]|0)+1;c[12194]=0;Yd[B&7](b,d,e,q,48776,n,o)|0;if((c[12194]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[12174]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[12174]=H+1}N=+cv(f,q,l,0,0);h[6102]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[12174]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[6091]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[12174]=J+1}}while(0);if(!(a[48808]&1)){break}H=c[f>>2]|0;c[12174]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[12174]=H+1}N=+cv(f,r,l,0,0);h[6096]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[48808]=0}h[b>>3]=+h[6098];G=c[f>>2]|0;c[12174]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[12174]=G+1}if(a[48808]&1){I=(c[12186]|0)+1|0;c[12186]=I;N=.9/(+h[6096]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[6089]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[12188]|0)!=0){I=(c[12190]|0)+1|0;c[12190]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[12194]|0)>-2)){K=53;break}I=(c[12184]|0)+1|0;c[12184]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function ev(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[12220]=o;p=+h[b>>3]- +h[a>>3];h[6108]=p;a=c[f>>2]|0;c[12212]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[12212]=a+1;q=+h[6108]}h[6104]=1.0;h[6105]=0.0;p=q/+h[k>>3];h[6109]=p;c[12214]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[6105]=u*t+s/+h[a>>3];p=t*s;h[6104]=p;h[6109]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[12212]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[6105]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[6104];g=g+1|0}c[12212]=a+1}g=v+1|0;c[12214]=g;if((v|0)>=(o|0)){break}r=+h[6108];s=+h[6104];t=+h[6109];u=+h[6105];v=g}i=l;return 0}function fv(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[6131]=+h[b>>3];c[12240]=0;c[12248]=0;c[12242]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[6143]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[12236]=(c[I>>2]|0)+1;c[12238]=(c[I>>2]|0)+2;c[12234]=(c[I>>2]|0)+ -1;h[6131]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[12252]=$+1;$=c[12236]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[6134]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[12222]=2;if(($|0)>=2){Y=2;while(1){h[6135]=+h[y+(Y+ -2<<3)>>3];U=+h[6134];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[6135];U=+h[6135]+ +h[k>>3];h[6134]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[12222]=$+1}h[y+($+ -1<<3)>>3]=+h[6134]}h[6141]=0.0;h[6139]=0.0;Y=c[I>>2]|0;c[12222]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[6141]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[6139]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[12222]=Y+1;da=ea}h[6142]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[6141]- +h[6139];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[6116]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[6116]=ha>=ca?ha:ca;h[6134]=.6;h[6135]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[6142]){h[D>>3]=100.0}aa=c[12236]|0;ba=c[12252]|0;if((aa|0)>=(ba|0)){c[12224]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[12222]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[12222]=ba+1}ja=ia+1|0;c[12224]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[12222]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[12222]=ia+1}aa=c[12236]|0;c[12224]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[12222]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[12222]=$+1}la=ba+1|0;c[12224]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[6138]=+cv(f,d,l,0,0);a[49152]=1;c[12226]=0;c[T>>2]=(c[T>>2]|0)+1;c[12256]=0;Yd[m&7](b,d,e,r,49024,o,p)|0;if((c[12256]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;gv(f,b,d,e,r,A,k,48976,l,s,t,u,g,49024,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[12256]|0)<0|(c[12244]|0)!=0){X=70;break}c[12248]=0}ba=c[f>>2]|0;c[12222]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[12222]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[6134]=ca;aa=c[f>>2]|0;c[12222]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[6134];ia=ia+1|0;la=ka}c[12222]=aa+1}hv(f,r,t,u)|0;la=c[f>>2]|0;c[12222]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[12222]=la+1}U=+cv(f,r,l,0,0);h[6143]=U;if(U<=+h[F>>3]*100.0*+h[6138]){X=63;break a}ia=c[12226]|0;if((ia|0)>0){h[O>>3]=U/+h[6145];h[P>>3]=1.0/+(ia|0);ca=+zL(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[6143];oa=ga}else{h[6145]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[12226]|0;c[12226]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[12256]=0;Yd[m&7](b,d,e,r,49024,o,p)|0;if((c[12256]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[12222]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[12222]=ba+1}U=+cv(f,r,l,0,0);h[6143]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[12222]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[12222]=ia+1}}while(0);if((X|0)==70){X=0;a[49152]=0}c[H>>2]=1;if(a[49152]&1){U=+cv(f,s,l,0,0);h[6137]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[6123]=ga;h[6130]=ga*+(ba+1|0);h[6125]=ga;c[12258]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[12222]=1;if((ba|0)>=1){aa=fa(c[12236]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[12222]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+cv(f,r,l,0,0);h[6132]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[6140]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[12222]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[12222]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+cv(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[6140];if((sa>=ca?sa:ca)>+h[6130]){break}ta=+h[6132];ua=Y}else{if(!(ga<=+h[6130]*.5)){break}else{ta=U;ua=ka}}c[12258]=ua+ -1;h[6125]=ta}}while(0);if(!(+h[6116]*+h[6137]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[6131];Y=c[12236]|0;ia=c[12252]|0;if((Y|0)>=(ia|0)){c[12224]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[6134]=ca;ia=c[f>>2]|0;c[12222]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[6134];ja=ja+1|0}c[12222]=ia+1}ja=aa+1|0;c[12224]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[12222]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[12222]=Y+1}if(!(a[49152]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[12244]|0)!=0){aa=(c[12248]|0)+1|0;c[12248]=aa;h[6114]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[12256]|0)>-2)){X=146;break}aa=(c[12240]|0)+1|0;c[12240]=aa;h[6114]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[12242]=(c[12242]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[12242]|0;if((aa|0)<=1){ja=c[12258]|0;c[I>>2]=ja;sa=+(ja+1|0);h[6135]=sa;h[O>>3]=+h[6125]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+zL(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[6114]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[12258];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[12272]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[12258]|0;E=c[12234]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[12236];za=+h[k>>3]*2.0;h[6127]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[12234]|0;Ba=c[12258]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[12236]|0)>=(c[K>>2]|0)|(c[12272]|0)==1){Fa=G;break}G=c[f>>2]|0;c[12222]=1;if((G|0)>=1){E=fa(c[12238]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[12222]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+cv(f,r,l,0,0);h[6133]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[6130];E=xa<=za;if(+h[6140]<=(E?xa:za)){Ea=c[12234]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[6130]*.5){Fa=S;break}}S=c[12236]|0;c[I>>2]=S;h[6125]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[6125]=+h[6132];Fa=Ea}h[6127]=+h[k>>3];ya=+(Fa+1|0);h[6135]=ya;h[O>>3]=+h[6125]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+zL(O,P);h[6114]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[6127];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[6114]=xa;za=+h[k>>3]*xa;h[6127]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[6127]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[12222]=1;if((k|0)<1){break}u=fa(c[12238]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[12222]=k+1}}while(0);Ca=c[f>>2]|0;c[12222]=1;if((Ca|0)>=1){J=fa(c[12236]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[12222]=Ca+1}Ca=c[12236]|0;c[12230]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[12224]=P;s=c[f>>2]|0;c[12222]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[12222]=s+1}P=Ha+1|0;c[12230]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[12256]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[12242]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}ev(b,b,d,e,f,I,q,y)|0;i=N;return 0}function gv(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[12318]=R;S=c[b>>2]|0;c[12308]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[12326]=R+S;c[12312]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[12322]=Q+1;R=c[x>>2]|0;c[12320]=R+ -1;c[12330]=R+Q;c[s>>2]=0;h[6158]=+V(+(+h[t>>3]));Q=c[12308]|0;c[12294]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[12318]|0;c[12300]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[12296]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[12320]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[12330]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[6155]=+h[6158]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+BL(49240,N);h[6155]=da;ca=c[12300]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[6155]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[6155]+ +h[ba>>3];ba=ca+W|0;c[12300]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[12318]|0;Z=c[12294]|0;_=ba}}}while(0);Yd[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[12318]|0;W=c[12294]|0;c[12300]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[12296]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[12320]|0)+ca<<3)>>3];ja=+h[p+((c[12330]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[6155]=+h[6158]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+BL(49240,N);h[6155]=ha;ca=c[12300]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[6155]=da;ja=1.0/da;h[6164]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[12302]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[12304]=oa;pa=fa(c[12312]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[12306]=qa;c[12292]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[6164];na=na+1|0}c[12292]=aa+1}na=ca+X|0;c[12300]=na;oa=c[12294]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[12318]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[12294]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[12314]=0;h[6158]=+V(+(+h[t>>3]));S=c[b>>2]|0;c[12292]=1;d:do{if((S|0)>=1){Q=r;P=1;while(1){R=P+ -1|0;da=+h[e+(R<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}W=f+(R<<3)|0;da=+h[l>>3]*+h[W>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(R<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[6155]=+h[6158]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[W>>3];da=+BL(49240,N);h[6155]=da;W=(c[12292]|0)+ -1|0;R=e+(W<<3)|0;ja=+h[R>>3];ha=da+ja-ja;h[6155]=ha;h[6162]=+h[R>>3];U=f+(W<<3)|0;h[6166]=+h[U>>3];h[R>>3]=ha+ +h[R>>3];h[U>>3]=+h[j>>3]*+h[6155]+ +h[U>>3];Yd[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[6155];h[6164]=ha;U=c[b>>2]|0;c[12298]=1;R=c[12314]|0;if((U|0)>=1){ja=ha;W=1;_=0;while(1){h[p+(_+R<<3)>>3]=(+h[o+(_<<3)>>3]- +h[g+(_<<3)>>3])*ja;if((W|0)>=(U|0)){break}X=W;ja=+h[6164];W=W+1|0;_=X}c[12298]=U+1}c[12314]=R+(c[b>>2]|0);_=c[12292]|0;W=_+ -1|0;h[e+(W<<3)>>3]=+h[6162];h[f+(W<<3)>>3]=+h[6166];P=_+1|0;c[12292]=P;if((_|0)>=(S|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[12314]=0;S=c[b>>2]|0;if((c[35208>>2]|0)==0){T=42;break}P=VX(S*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];pt(14,1,49336,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];pt(14,0,49360,E);pt(14,1,49368,D);c[12296]=0;if((c[b>>2]|0)>0){Q=0;do{ja=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;_=C+4|0;h[k>>3]=ja;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];pt(14,0,49376,C);Q=(c[12296]|0)+1|0;c[12296]=Q;}while((Q|0)<(c[b>>2]|0))}ae[c[8926]&255](14);pt(14,1,49432,B);c[12292]=1;if((S|0)>=1){Q=P+1|0;_=c[12314]|0;W=1;do{X=p+(W+ -1+_<<3)|0;h[X>>3]=+h[j>>3]+ +h[X>>3];a[P]=0;a[Q]=0;c[12298]=1;X=_;ba=0;while(1){ja=+h[p+(ba+X<<3)>>3];c[A>>2]=P;Y=A+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];ic(P|0,49416,A|0)|0;Y=c[12298]|0;c[12298]=Y+1;if((Y|0)>=(S|0)){break}X=c[12314]|0;ba=Y}c[z>>2]=P;pt(14,0,49424,z);ba=c[12314]|0;X=c[12292]|0;Y=p+(ba+ -1+X<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];_=ba+(c[b>>2]|0)|0;c[12314]=_;W=X+1|0;c[12292]=W;}while((X|0)<(S|0))}ae[c[8926]&255](14);ae[c[8926]&255](14);WX(P);T=42}else if((O|0)==3){i=y;return 0}else if((O|0)==4){S=c[q>>2]|0;W=q+4|0;_=c[W>>2]|0;Q=c[b>>2]|0;X=fa(_+1+(S<<1)|0,Q)|0;c[12292]=1;if((X|0)>=1){ba=fa(Q,_+(S<<1)+1|0)|0;S=(ba|0)<1;_=1;while(1){h[p+(_+ -1<<3)>>3]=0.0;if((_|0)<(X|0)){_=_+1|0}else{break}}c[12292]=S?2:ba+1|0}ce[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[12326]=(c[W>>2]|0)+1+(c[q>>2]<<1);T=75}else{_=c[b>>2]|0;X=fa(_,_)|0;c[12292]=1;if((X|0)!=0){_=(X|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(X|0)){P=P+1|0}else{break}}c[12292]=_?2:X+1|0}ce[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[12314]=0;P=c[b>>2]|0;if((c[35208>>2]|0)==0){T=42;break}W=VX(P*20|0)|0;ba=M;h[k>>3]=+h[d>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];pt(14,1,49336,M);ba=L;h[k>>3]=+h[j>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];pt(14,0,49360,L);pt(14,1,49368,K);c[12296]=0;if((c[b>>2]|0)>0){ba=0;do{ja=+h[e+(ba<<3)>>3];c[J>>2]=ba+1;S=J+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];pt(14,0,49376,J);ba=(c[12296]|0)+1|0;c[12296]=ba;}while((ba|0)<(c[b>>2]|0))}ae[c[8926]&255](14);pt(14,1,49392,I);c[12292]=1;if((P|0)>=1){ba=W+1|0;X=c[12314]|0;_=1;do{S=p+(_+ -1+X<<3)|0;h[S>>3]=+h[j>>3]+ +h[S>>3];a[W]=0;a[ba]=0;c[12298]=1;S=X;Q=0;while(1){ja=+h[p+(Q+S<<3)>>3];c[H>>2]=W;Y=H+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];ic(W|0,49416,H|0)|0;Y=c[12298]|0;c[12298]=Y+1;if((Y|0)>=(P|0)){break}S=c[12314]|0;Q=Y}c[G>>2]=W;pt(14,0,49424,G);Q=c[12314]|0;S=c[12292]|0;Y=p+(Q+ -1+S<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];X=Q+(c[b>>2]|0)|0;c[12314]=X;_=S+1|0;c[12292]=_;}while((S|0)<(P|0))}ae[c[8926]&255](14);ae[c[8926]&255](14);WX(W);T=42}}while(0);if((T|0)==42){ov(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){uv(p,49304,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function hv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[12364]=(c[h>>2]|0)+1+(c[e>>2]<<1);vv(d,49456,a,e,h,e+80|0,b,49464)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{sv(d,a,a,e+80|0,b,49464)|0;i=f;return 0}return 0}function iv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[49472]&1)){a[49472]=1;jv(49520,49488,49568,49504,49552,49576,49560,49584)|0;h[6189]=+(c[12380]|0);f=c[12372]|0;h[6185]=+(f|0);if((c[12392]|0)==0){h[6187]=0.0;c[e>>2]=1-f;g=+AL(49512,e)}else{h[6187]=1.0;c[e>>2]=1-f;g=+AL(49512,e)*.5}h[6188]=g;h[6192]=g*+h[6189];h[6191]=+(c[12388]|0);h[6193]=+(c[12390]|0);j=+h[6197];h[6200]=j;k=1.0/+h[6198];if(!(k>=j)){break}h[6200]=k*(g+1.0)}}while(0);if((Bv(b,49608,1,1)|0)!=0){g=+h[6188];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49616,1,1)|0)!=0){g=+h[6200];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49624,1,1)|0)!=0){g=+h[6189];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49632,1,1)|0)!=0){g=+h[6192];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49640,1,1)|0)!=0){g=+h[6185];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49648,1,1)|0)!=0){g=+h[6187];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49656,1,1)|0)!=0){g=+h[6191];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49664,1,1)|0)!=0){g=+h[6197];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49672,1,1)|0)!=0){g=+h[6193];h[6199]=g;l=g;i=d;return+l}if((Bv(b,49680,1,1)|0)==0){l=+h[6199];i=d;return+l}else{g=+h[6198];h[6199]=g;l=g;i=d;return+l}return 0.0}function jv(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[49792]&1){q=50160;r=c[12540]|0;c[b>>2]=r;s=50096;t=c[12524]|0;c[d>>2]=t;u=50136;v=c[12534]|0;c[e>>2]=v;w=50144;x=+h[6268];h[f>>3]=x;y=50176;z=c[12544]|0;c[g>>2]=z;A=50224;B=+h[6278];h[j>>3]=B;C=50184;D=c[12546]|0;c[k>>2]=D;E=50232;F=+h[6279];h[l>>3]=F;i=m;return 0}a[49792]=1;h[6269]=0.0;h[6263]=1.0;h[6264]=2.0;kv(50160,50096,50136,50248)|0;h[6259]=+(c[12540]|0);c[n>>2]=0-(c[12524]|0);G=+AL(50072,n);h[6258]=G;h[6268]=G;H=+h[6264];h[6259]=H/3.0;I=+h[6263];J=I*.5;h[6266]=J;K=-J;h[o>>3]=K;h[6280]=+lv(50072,o);L=50240;h[6277]=+lv(L,L);h[o>>3]=K;h[6259]=+lv(50216,o);K=+lv(50072,50240);h[6259]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[6259]=K;h[6268]=1.0;M=+h[6269];if(K<1.0&K>M){N=K;while(1){h[6268]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+lv(o,p);h[6260]=K;h[o>>3]=-K;h[6260]=+lv(50128,o);K=+lv(50128,50080);h[6259]=K;h[o>>3]=-K;h[6260]=+lv(50128,o);K=+lv(50128,50080);h[6259]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[6268]=G}G=I/+(c[12540]|0);h[6271]=G;h[6275]=I;c[12522]=1;p=1;O=I;do{h[o>>3]=O*G;O=+lv(o,50152);h[6275]=O;p=p+1|0;c[12522]=p;}while((p|0)<4);h[6258]=+lv(50104,50200);mv(50264,50104,50160)|0;h[o>>3]=-+h[6263];mv(50256,o,50160)|0;mv(50208,50064,50160)|0;h[o>>3]=-+h[6258];mv(50192,o,50160)|0;c[12530]=0;p=c[12566]|0;L=c[12564]|0;P=c[12552]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[12548]|0)){if(Q){c[12544]=p;R=0;S=25;break}if((P-p|0)==3){c[12544]=p+ -1+(c[12524]|0);c[12530]=1;R=1;S=25;break}else{c[12544]=(p|0)<=(P|0)?p:P;a[49800]=1;S=26;break}}else{T=Q&(L|0)==(c[12548]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[12544]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[12544]=(p|0)<=(L|0)?p:L;a[49800]=1;S=26;break}}T=c[12548]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[12544]=(V|0)<=(T|0)?V:T;a[49800]=1;S=26;break}if((P-U|0)==3){c[12544]=((p|0)>=(L|0)?p:L)+ -1+(c[12524]|0);R=0;S=25;break}else{c[12544]=U;a[49800]=1;S=26;break}}}while(0);if((S|0)==25){if(a[49800]&1){S=26}else{W=R}}if((S|0)==26){a[49792]=0;yM(50272)|0;PL(50296,50176,4)|0;gM()|0;W=c[12530]|0}if((W|0)==0){X=(c[12562]|0)!=0|0}else{X=1}c[12530]=X;h[6278]=1.0;X=c[12544]|0;W=1-X|0;c[n>>2]=W;c[12522]=1;if((X|0)<=0){O=+h[6271];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+lv(o,50152);h[6278]=I;n=X+1|0;c[12522]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}nv(50160,50096,50176,50120,50184,50232)|0;q=50160;r=c[12540]|0;c[b>>2]=r;s=50096;t=c[12524]|0;c[d>>2]=t;u=50136;v=c[12534]|0;c[e>>2]=v;w=50144;x=+h[6268];h[f>>3]=x;y=50176;z=c[12544]|0;c[g>>2]=z;A=50224;B=+h[6278];h[j>>3]=B;C=50184;D=c[12546]|0;c[k>>2]=D;E=50232;F=+h[6279];h[l>>3]=F;i=m;return 0}function kv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[49688]&1){l=a[49760]&1;m=c[12442]|0;c[b>>2]=m;n=49736;o=c[12434]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=49784;r=c[12446]|0;c[f>>2]=r;i=g;return 0}a[49688]=1;h[6218]=1.0;h[6212]=1.0;h[6214]=1.0;s=1.0;do{s=s*2.0;h[6212]=s;h[6214]=+lv(49696,49744);h[j>>3]=-s;t=+lv(49712,j);h[6214]=t;}while(t==1.0);h[6213]=1.0;t=+lv(49696,49704);h[6214]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[6213]=v;w=+lv(49696,49704);h[6214]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[6219]=.25;h[6222]=x;h[j>>3]=-s;t=+lv(49712,j);h[6214]=t;y=~~(t+.25);c[12442]=y;t=+(y|0);h[6213]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[6215]=+lv(j,k);w=+lv(49720,49696);h[6214]=w;z=w==s;a[49760]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[6215]=+lv(j,k);w=+lv(49720,49696);h[6214]=w;if(z&w==s){a[49760]=0;A=0}else{A=z}h[j>>3]=u;w=+lv(j,49696);h[6216]=w;h[j>>3]=u;z=w==s&+lv(j,49776)>x;c[12446]=z?A&1:0;c[12434]=0;h[6212]=1.0;h[6214]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[12434]=k;s=x*t;h[6212]=s;h[6214]=+lv(49696,49744);h[j>>3]=-s;w=+lv(49712,j);h[6214]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=49736;o=c[12434]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=49784;r=c[12446]|0;c[f>>2]=r;i=g;return 0}function lv(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function mv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[6288]=g;j=1.0/+(c[d>>2]|0);h[6297]=j;h[6296]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+lv(f,50368);h[6290]=k;h[6292]=g;h[6293]=g;h[6294]=g;h[6295]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[6288]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+lv(f,50368);h[6290]=g;h[f>>3]=g*k;k=+lv(f,50368);h[6292]=k;h[6294]=0.0;c[12578]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[6294]=q;c[12578]=b+1;n=q}h[f>>3]=m*j;p=+lv(f,50368);h[6291]=p;h[f>>3]=p/j;r=+lv(f,50368);h[6293]=r;h[6295]=0.0;o=c[d>>2]|0;c[12578]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[6295]=v;c[12578]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function nv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[12602]=1;c[12610]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[12602]=q;r=l+1|0;c[12610]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[12606]=n;u=n}else{c[12606]=m;c[12610]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[12612]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[12610]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[6304]=x;y=w+-1.0;h[6300]=y;h[6299]=0.0;v=c[b>>2]|0;c[12596]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[6300]=B;if(w<1.0){h[6302]=w}C=+lv(50392,50400);h[6299]=C;e=b+1|0;c[12596]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[6302];h[6299]=A;z=A}}while(0);v=c[f>>2]|0;c[12596]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+lv(k,50456);h[6299]=z;f=E+1|0;c[12596]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function ov(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[12618]=1;m=1;do{c[12624]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=pv(j,a+(m+b+(fa(m,l)|0)<<3)|0,50504)|0;q=c[12618]|0;r=p+ -1+q|0;c[12620]=r;c[e+(q+ -1<<2)>>2]=r;r=c[12620]|0;q=c[12618]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[6311]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[6311];t=q}u=fa(t,l)|0;h[6311]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;qv(j,50488,a+(t-l+u<<3)|0,50504)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[12624]|0;c[12616]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[12620]|0;x=fa(w,l)|0;h[6311]=+h[a+(x+b+v<<3)>>3];y=c[12618]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[6311];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=50504;rv(k,50488,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[12616]|0;w=A+1|0;c[12616]=w;}while((A|0)<(u|0))}}while(0);q=c[12618]|0;m=q+1|0;c[12618]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function pv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[12716]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[6359]=k;l=(c[d>>2]|0)+1|0;c[12716]=l;m=c[a>>2]|0;c[12714]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[6359]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[12716]=l;a=n+1|0;c[12714]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[6359]=v;c[12714]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[6359]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[12714]=f+1;g=C;i=e;return g|0}function qv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[12700]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[12700]=l;i=f;return 0}l=(g|0)%5|0;c[12702]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[12700]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[12700]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[12700]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[12700]=o;i=f;return 0}function rv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[12686]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[12684]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[12684]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[12684]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[12684]=s;i=j;return 0}}while(0);c[12688]=1;c[12690]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[12688]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[12690]=s;u=s}else{u=1}s=c[a>>2]|0;c[12684]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[12688]=t;u=x+(c[g>>2]|0)|0;c[12690]=u;a=w+1|0;c[12684]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function sv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[12636]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[12628]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[12630]=o;p=f+(o+ -1<<3)|0;h[6316]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[6316]}c[k>>2]=(c[d>>2]|0)-m;o=50504;rv(k,50528,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[12628]|0;m=o+1|0;c[12628]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[12634]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[12628]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[6316]=-s;c[k>>2]=g;g=50504;rv(k,50528,a+(p-l<<3)|0,g,f,g)|0;g=c[12634]|0;q=g+1|0;c[12634]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[12628]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=50504;s=+tv(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[6316]=s;q=c[12628]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[12628]=n;}while((q|0)<(m|0));t=c[12636]|0}if((t|0)<1){i=j;return 0}c[12634]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[12628]=n;c[k>>2]=(c[d>>2]|0)-n;b=50504;s=+tv(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[12628]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[12630]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[6316]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[6316]}q=c[12634]|0;m=q+1|0;c[12634]=m;}while((q|0)<(t|0));i=j;return 0}function tv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[6356]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[12706]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[12704]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[6356]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[12704]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[12704]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[6356]=t;u=u+5|0;}while((u|0)<=(m|0));c[12704]=u;k=t;i=g;return+k}}while(0);c[12708]=1;c[12710]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[12708]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[12710]=u;y=u}else{y=1}u=c[a>>2]|0;c[12704]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[6356]=t;x=C+(c[d>>2]|0)|0;c[12708]=x;y=B+(c[f>>2]|0)|0;c[12710]=y;a=z+1|0;c[12704]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function uv(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[12646]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[12652]=n;o=c[d>>2]|0;p=c[12646]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[12654]=o;do{if((q|0)>(n|0)){c[12662]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[12650]=s;t=c[e>>2]|0;c[12638]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[12638]=t+1}u=r+1|0;c[12662]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[12662]=o;c[12660]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[12642]=1;t=o;o=1;while(1){c[12664]=o+1;p=t+1|0;c[12662]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[12638]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[12638]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[12656]=s;c[l>>2]=s+1;s=pv(l,a+((c[12646]|0)+b+(fa(o,m)|0)<<3)|0,50504)|0;p=s+ -1|0;c[12644]=p+(c[12646]|0);s=c[12642]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[12644]|0;p=c[12642]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[12646]|0;if((s|0)==(u|0)){y=s}else{h[6324]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[6324];y=u}h[6324]=-1.0/+h[a+(y+b+n<<3)>>3];qv(50624,50592,a+(y-m+n<<3)|0,50504)|0;u=c[12660]|0;z=(c[g+((c[12642]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[12660]=u;A=c[12646]|0;c[12658]=A;z=c[12664]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[12640]=z;B=z;z=A;while(1){A=(c[12644]|0)+ -1|0;c[12644]=A;C=z+ -1|0;c[12658]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[6324]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[6324];F=C}C=50504;rv(50624,50592,a+((c[12646]|0)-m+(fa(c[12642]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[12640]|0;D=C+1|0;c[12640]=D;if((C|0)>=(u|0)){break a}B=D;z=c[12658]|0}}}while(0);n=c[12642]|0;s=n+1|0;c[12642]=s;if((n|0)>=(r|0)){break}t=c[12662]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[12646]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function vv(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[12670]=n;f=c[d>>2]|0;o=f+ -1|0;c[12682]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[12666]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[12680]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[12668]=k;q=j+(k+ -1<<3)|0;h[6336]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[6336]}k=50504;rv(50720,50688,a+((c[12670]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[12666]|0;f=k+1|0;c[12666]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[12674]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[12666]=k;q=c[12670]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[12680]=s;u=q-s|0;c[12676]=u;q=k-s|0;c[12678]=q;h[6336]=-t;s=50504;rv(50720,50688,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[12674]|0;r=s+1|0;c[12674]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[12666]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[12680]=r;s=o-r|0;c[12676]=s;q=n-r|0;c[12678]=q;r=50504;t=+tv(50720,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[6336]=t;r=c[12666]|0;q=j+(r+ -1<<3)|0;o=c[12670]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[12666]=n;}while((r|0)<(f|0));v=o;w=c[12682]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[12674]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[12666]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[12680]=(n|0)<=(b|0)?n:b;b=50504;t=+tv(50720,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[12666]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[12668]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[6336]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[6336]}n=c[12674]|0;b=n+1|0;c[12674]=b;if((n|0)>=(w|0)){break}o=c[12670]|0;v=b}i=l;return 0}function wv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[12694]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[12692]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[12692]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[12692]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[12692]=o;i=g;return 0}}while(0);c[12696]=1;c[12698]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[12696]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[12698]=o;q=o}else{q=1}o=c[a>>2]|0;c[12692]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[12696]=p;q=s+(c[f>>2]|0)|0;c[12698]=q;a=r+1|0;c[12692]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function xv(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+yv(50880);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+zv(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+zv(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+zv(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+zv(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function yv(a){a=a|0;i=i;return+(+h[50888+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function zv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function Av(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+yv(50920);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Be[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+zv(b,e);c[E>>2]=2;Be[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){Iv(b,b,f,g,50928,N,50920,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+zv(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=QY(ga|0,0,Z+ -2|0,0)|0;Z=JY(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}Hv(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Be[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);xv(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+zv(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Be[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+zv(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+zv(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+zv(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}Kv(b,b,s,t,v,w,x,D)|0;Jv(b,b,f,g,w,x)|0;W=50920;Jv(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Be[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Be[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function Bv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[50952]=1;f=d[b]|0;c[12734]=f;b=d[e]|0;c[12736]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[12734]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[12736]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function Cv(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[60484>>2]=6;yM(60480)|0;PL(61224,j,4)|0;gM()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[14422]=0;c[15028]=0;c[15016]=0;a[60088]=0;t=c[e>>2]|0;c[13976]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[14422]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[13976]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[13976]=1;if((v|0)>=1){x=1;while(1){h[52376+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[13976]=v+1}c[15020]=2;x=c[e>>2]|0;c[13976]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[13978]=1;if((E|0)<1){F=C}else{G=1;while(1){h[52376+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[13978]=E+1;F=+h[B>>3]}h[52376+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[15020]=G;D=G}G=z+1|0;c[13976]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[14422]|0;y=z+1|0;c[14418]=y;c[13976]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[13978]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[52376+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[13978]=x+1}ge[u&63](e,b,55736+(z+ -1<<3)|0)|0;c[15028]=(c[15028]|0)+1;if((c[j>>2]|0)>=1){c[60508>>2]=6;yM(60504)|0;PL(61224,60112,4)|0;PL(61224,55736+((c[13976]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[13978]=1;if((v|0)>=1){A=1;do{PL(61224,b+(A+ -1<<3)|0,8)|0;B=c[13978]|0;A=B+1|0;c[13978]=A;}while((B|0)<(v|0))}gM()|0}v=c[13976]|0;z=v+1|0;c[13976]=z;}while((v|0)<(y|0))}y=c[15016]|0;b:while(1){c[15016]=y+1;c[14928]=1;c[14924]=1;C=+h[6967];h[7463]=C;h[7465]=C;z=c[14418]|0;c[13976]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[55736+(A+ -1<<3)>>3];do{if(!(C<=K)){c[14928]=A;L=+h[55736+(A+ -1<<3)>>3];h[7463]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[14924]=A;L=+h[55736+(A+ -1<<3)>>3];h[7465]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[13976]=z+1;H=O}A=c[e>>2]|0;c[13976]=1;if((A|0)>=1){v=1;while(1){h[57856+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[13976]=A+1}c[13976]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[13978]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=57856+(Q+ -1<<3)|0;h[B>>3]=+h[52376+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[13978]=x+1;P=v}}while(0);v=P+1|0;c[13976]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[13978]=1;if((z|0)>=1){K=+(c[14422]|0);v=1;while(1){A=57856+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[13978]=z+1}v=c[e>>2]|0;c[13976]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[57856+(B<<3)>>3];h[60136+(B<<3)>>3]=K+(K- +h[52376+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[13976]=v+1}ge[u&63](e,60136,60128)|0;A=(c[15028]|0)+1|0;c[15028]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[60532>>2]=6;yM(60528)|0;PL(61224,60112,4)|0;PL(61224,60128,8)|0;B=c[e>>2]|0;c[13978]=1;if((B|0)>=1){E=1;do{PL(61224,60136+(E+ -1<<3)|0,8)|0;G=c[13978]|0;E=G+1|0;c[13978]=E;}while((G|0)<(B|0))}gM()|0}}while(0);K=+h[7516];c:do{if(!(K>=+h[7465])){z=c[e>>2]|0;c[13976]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[57856+(v<<3)>>3];h[60304+(v<<3)>>3]=I+(+h[60136+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[13976]=z+1}ge[u&63](e,60304,60296)|0;A=(c[15028]|0)+1|0;c[15028]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[60556>>2]=6;yM(60552)|0;PL(61224,60112,4)|0;PL(61224,60296,8)|0;B=c[e>>2]|0;c[13978]=1;if((B|0)>=1){E=1;do{PL(61224,60304+(E+ -1<<3)|0,8)|0;G=c[13978]|0;E=G+1|0;c[13978]=E;}while((G|0)<(B|0))}gM()|0}}while(0);I=+h[7537];if(I>=+h[7465]){R=118;break}v=c[e>>2]|0;c[13976]=1;A=c[14928]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[52376+((z*21|0)+ -22+A<<3)>>3]=+h[60304+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[13976]=v+1}h[55736+(A+ -1<<3)>>3]=I}else{z=c[14418]|0;c[13976]=1;if((z|0)>=1){B=c[14928]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[55736+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[13976]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[7463])){E=c[e>>2]|0;c[13976]=1;z=c[14928]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[52376+((B*21|0)+ -22+z<<3)>>3]=+h[60136+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[13976]=E+1}h[7463]=K;h[55736+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[13976]=1;if((B|0)>=1){A=c[14928]|0;v=1;while(1){x=v+ -1|0;h[60304+(x<<3)>>3]=+h[52376+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[57856+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[13976]=B+1}ge[u&63](e,60304,60296)|0;v=(c[15028]|0)+1|0;c[15028]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[60580>>2]=6;yM(60576)|0;PL(61224,60112,4)|0;PL(61224,60296,8)|0;z=c[e>>2]|0;c[13978]=1;if((z|0)>=1){E=1;do{PL(61224,60304+(E+ -1<<3)|0,8)|0;x=c[13978]|0;E=x+1|0;c[13978]=E;}while((x|0)<(z|0))}gM()|0}}while(0);I=+h[7537];if(!(I>+h[7463])){A=c[e>>2]|0;c[13976]=1;v=c[14928]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[52376+((B*21|0)+ -22+v<<3)>>3]=+h[60304+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[13976]=A+1}h[55736+(v+ -1<<3)>>3]=I;break}B=c[14418]|0;c[13976]=1;if((B|0)<1){break}else{S=1}do{z=c[14924]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[13978]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=52376+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[52376+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[52376+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[13978]=E+1}ge[u&63](e,b,55736+(S+ -1<<3)|0)|0;G=(c[15028]|0)+1|0;c[15028]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[60604>>2]=6;yM(60600)|0;PL(61224,60112,4)|0;PL(61224,55736+((c[13976]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[13978]=1;if((x|0)>=1){G=1;do{PL(61224,b+(G+ -1<<3)|0,8)|0;T=c[13978]|0;G=T+1|0;c[13978]=G;}while((T|0)<(x|0))}gM()|0}}while(0);z=c[13976]|0;S=z+1|0;c[13976]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[13976]=1;v=c[14928]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[52376+((A*21|0)+ -22+v<<3)>>3]=+h[60136+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[13976]=B+1}h[55736+(v+ -1<<3)>>3]=+h[7516]}A=c[15016]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[7466]=0.0;h[7512]=0.0;A=c[14418]|0;c[13976]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[7512]=0.0/K;c[13976]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[55736+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[7512]=I;c[13976]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[55736+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[7466]=$;c[13976]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[7466]=I;do{if(!(I<=+h[k>>3])){if((c[15028]|0)>(c[g>>2]|0)){break}a[60088]=0;c[15016]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[13976]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[13978]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[52376+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[13978]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[13976]=v+1}ge[u&63](e,b,f)|0;B=(c[15028]|0)+1|0;c[15028]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[60628>>2]=6;yM(60624)|0;PL(61224,60112,4)|0;PL(61224,s,8)|0;z=c[e>>2]|0;c[13978]=1;if((z|0)>=1){E=1;do{PL(61224,b+(E+ -1<<3)|0,8)|0;x=c[13978]|0;E=x+1|0;c[13978]=E;}while((x|0)<(z|0))}gM()|0;ba=c[15028]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[60748>>2]=6;yM(60744)|0;gM()|0;c[60772>>2]=6;yM(60768)|0;B=c[e>>2]|0;c[13976]=1;if((B|0)>=1){A=1;do{PL(61224,b+(A+ -1<<3)|0,8)|0;v=c[13976]|0;A=v+1|0;c[13976]=A;}while((v|0)<(B|0))}gM()|0;c[60796>>2]=6;yM(60792)|0;PL(61224,s,8)|0;gM()|0}if(a[60088]&1){I=+h[7512];K=+h[7558]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[60088]=1;da=+h[7512]}h[7558]=da;c[15016]=0;y=0}if((c[j>>2]|0)>=0){c[60820>>2]=6;yM(60816)|0;PL(61224,60112,4)|0;gM()|0;c[60844>>2]=6;yM(60840)|0;y=c[e>>2]|0;c[13976]=1;if((y|0)>=1){B=1;do{PL(61224,b+(B+ -1<<3)|0,8)|0;A=c[13976]|0;B=A+1|0;c[13976]=B;}while((A|0)<(y|0))}gM()|0;c[60868>>2]=6;yM(60864)|0;PL(61224,s,8)|0;gM()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[60892>>2]=6;yM(60888)|0;gM()|0}h[7465]=+h[f>>3];c[15030]=0;y=c[14418]|0;c[13976]=1;if((y|0)>=1){B=1;while(1){A=55736+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[13976]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[13978]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=52376+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[60304+(E+ -1<<3)>>3]=+h[52376+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[13978]=v+1}ge[u&63](e,60304,A)|0;c[15030]=(c[15030]|0)+1;c[15028]=(c[15028]|0)+1;E=c[13976]|0;I=+h[55736+(E+ -1<<3)>>3];if(I>=+h[7465]){B=E;continue}h[7465]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[60916>>2]=6;yM(60912)|0;PL(61224,60112,4)|0;PL(61224,59720,8)|0;E=c[e>>2]|0;c[13978]=1;if((E|0)>=1){z=1;do{PL(61224,60304+(z+ -1<<3)|0,8)|0;G=c[13978]|0;z=G+1|0;c[13978]=z;}while((G|0)<(E|0))}gM()|0;B=c[13976]|0}}B=c[14422]|0;c[13976]=1;do{if((B|0)<1){h[6992]=+h[6967];c[13976]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[13986]=E;z=c[e>>2]|0;c[13978]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[60136+(A+ -1<<3)>>3]=(+h[52376+(v+ -21<<3)>>3]+ +h[52376+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[13978]=z+1}ge[u&63](e,60136,57696+(y+ -1<<3)|0)|0;c[15030]=(c[15030]|0)+1;c[15028]=(c[15028]|0)+1;A=c[13976]|0;y=A+1|0;c[13976]=y;}while((A|0)<(B|0));y=c[14422]|0;I=+h[6967];h[6992]=I;c[13976]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[13986]=A;c[13988]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[13978]=1;E=1;while(1){v=E+1|0;c[13990]=v;G=c[e>>2]|0;c[13980]=1;if((G|0)>=1){x=c[13988]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[60304+(T+ -1<<3)>>3]=(+h[52376+(U+x<<3)>>3]+ +h[52376+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[13980]=G+1}ge[u&63](e,60304,60296)|0;c[15030]=(c[15030]|0)+1;c[15028]=(c[15028]|0)+1;T=c[13976]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[13978]|0;la=U+x|0;c[13982]=la;I=+h[6992];h[58016+(la+ -1<<3)>>3]=(+h[7537]+I- +h[57696+(v<<3)>>3]- +h[57696+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[13978]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[13976]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[14422]|0;c[13982]=0;c[13976]=1;E=(y|0)<1;if(E){c[13976]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=QY(A|0,0,y+ -2|0,0)|0;A=JY(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[58016+(U+ -1<<3)>>3]=(+h[55736+(v<<3)>>3]+ka- +h[57696+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[13986]=v+1;c[13982]=(z|1)+A;c[13976]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=57696+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[55736+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[13986]=T+1;c[13976]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[13982]=0;c[13976]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[13976]=1;if((B|0)>=1){A=1;while(1){h[59736+(A+ -1<<3)>>3]=+h[52376+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[13976]=B+1}c[13976]=1;do{if(ma){c[13976]=1}else{A=1;while(1){z=A+1|0;c[13986]=z;v=c[e>>2]|0;c[13978]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=52376+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[52376+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[13978]=v+1}c[13976]=z;if((A|0)<(na|0)){A=z}else{break}}c[13976]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[13986]=A;y=c[e>>2]|0;c[13978]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[52376+(T+oa<<3)>>3]=+h[52376+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[13978]=y+1}c[13976]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=58016;Dv(B,57688,B,59896,60472,q,60056)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[60940>>2]=6;yM(60936)|0;gM()|0}c[q>>2]=2;if((c[15028]|0)>(c[g>>2]|0)){R=312;break}c[60964>>2]=6;yM(60960)|0;gM()|0;B=c[e>>2]|0;c[13976]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[13976]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[60652>>2]=6;yM(60648)|0;PL(61224,g,4)|0;gM()|0;c[60676>>2]=6;yM(60672)|0;PL(61224,59728,8)|0;gM()|0;c[60700>>2]=6;yM(60696)|0;u=c[e>>2]|0;c[13976]=1;if((u|0)>=1){E=1;do{PL(61224,b+(E+ -1<<3)|0,8)|0;z=c[13976]|0;E=z+1|0;c[13976]=E;}while((z|0)<(u|0))}gM()|0;c[60724>>2]=6;yM(60720)|0;PL(61224,s,8)|0;gM()|0;i=r;return 0}else if((R|0)==226){u=c[14422]|0;c[15026]=u-(c[15118]|0);c[13976]=1;E=(u|0)<1;do{if(E){h[7509]=0.0;c[13976]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[55736+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=55736+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[58016+(sa+ -1<<3)>>3]*+h[57696+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[13982]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[13978]=z;h[7509]=0.0;c[13976]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[55736+(v<<3)>>3]*+h[57696+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[7509]=wa;c[13976]=u+1;qa=wa}}while(0);h[7509]=+h[6992]-qa;s=c[e>>2]|0;c[13976]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[60304+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=60304+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[55736+(T+ -1<<3)>>3]*+h[52376+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[13976]=s+1;c[13978]=xa}v=c[e>>2]|0;c[13976]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=59736+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[60304+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[13976]=v+1}if((c[j>>2]|0)>=0){c[60988>>2]=6;yM(60984)|0;PL(61224,60072,8)|0;z=c[e>>2]|0;c[13976]=1;if((z|0)>=1){s=1;do{PL(61224,59736+(s+ -1<<3)|0,8)|0;u=c[13976]|0;s=u+1|0;c[13976]=s;}while((u|0)<(z|0))}gM()|0;c[61012>>2]=6;yM(61008)|0;gM()|0}z=c[e>>2]|0;c[13976]=1;if((z|0)>=1){s=c[14422]|0;v=1;while(1){c[13978]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[55736+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=55736+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[58016+(Aa+ -1<<3)>>3]*+h[52376+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[13982]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[13980]=E;c[13978]=s+1}T=c[e>>2]|0;c[13978]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=55992+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[55736+(Ea+ -1<<3)>>3]*+h[52376+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[13978]=T+1;c[13982]=Ca;c[13980]=Da}za=v+1|0;c[13976]=za;if((v|0)<(z|0)){v=za}else{break}}}c[13978]=0;v=c[e>>2]|0;c[13976]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[55992+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[13978]=Ga;c[13976]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[61036>>2]=6;yM(61032)|0;PL(61224,60104,4)|0;gM()|0;c[14420]=1;z=1;d:while(1){c[13982]=z;do{if((z|0)>(c[e>>2]|0)){s=c[14420]|0;if((s|0)==1){c[61060>>2]=6;yM(61056)|0;gM()|0;Dv(55992,57688,58016,59896,60472,q,60056)|0;c[61084>>2]=6;yM(61080)|0;gM()|0;c[14420]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[14420]=2;c[13992]=0;c[13994]=0;s=c[e>>2]|0;c[13976]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=QY(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=JY(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=55992+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=55992+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[55992+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[13996]=Na;c[13994]=Ta;c[13992]=Ia;c[13978]=Ma;c[13976]=s+1}c[61108>>2]=6;yM(61104)|0;gM()|0;c[13992]=0;u=c[e>>2]|0;c[13976]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=55992+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[13992]=Wa;c[13976]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[13992]=T;s=c[e>>2]|0;c[13976]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[13986]=B;Qa=za+la|0;c[13992]=Qa;Pa=B+5|0;c[13988]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[14420]|0)==3){c[61180>>2]=6;yM(61176)|0;Pa=c[13988]|0;Qa=c[13986]|0;c[13978]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{PL(61224,58016+(B+ -1<<3)|0,8)|0;Qa=c[13978]|0;B=Qa+1|0;c[13978]=B;}while((Qa|0)<(Pa|0))}gM()|0}else{c[61156>>2]=6;yM(61152)|0;Pa=c[13988]|0;B=c[13986]|0;c[13978]=B;if((B|0)<=(Pa|0)){x=B;do{PL(61224,55992+(x+ -1<<3)|0,8)|0;B=c[13978]|0;x=B+1|0;c[13978]=x;}while((B|0)<(Pa|0))}gM()|0}Pa=c[13976]|0;x=Pa+1|0;c[13976]=x;if((Pa|0)>=(s|0)){break e}E=c[13982]|0;la=c[13992]|0;za=x}}}while(0);c[61204>>2]=6;yM(61200)|0;gM()|0;z=(c[13982]|0)+6|0}c[61132>>2]=6;yM(61128)|0;PL(61224,60120,4)|0;gM()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ge[p&63](e,b,f)|0;i=r;return 0}function Dv(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[15326]=c[b>>2];c[g>>2]=1;if((c[15326]|0)<1){i=k;return 0}c[g>>2]=0;Ev(a,61304,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[15326]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[15318]=f;c[15324]=g;c[15330]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=QY(a|0,0,g+ -2|0,0)|0;m=JY(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[15310]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=QY(p|0,0,a-n|0,0)|0;p=JY(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[15310]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[15308]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[15308]=j}c[15320]=g;c[15322]=f;c[15328]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[7658]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[7658]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[7658]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[15328]=D;E=v+ -1|0;c[15320]=E;F=w+ -1|0;c[15322]=F;q=D;v=E;w=F}c[15312]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[15314]=t;c[15324]=0;c[15330]=l-g;i=k;return 0}function Ev(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[7672]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[7672]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[7672];c[15334]=1;c[15336]=0;n=c[b>>2]|0;c[15348]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[15338]=0;c[15350]=1;do{if((o|0)>=1){p=1;q=c[15336]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[7671]=m;u=(p|0)==(o|0);if(u){l=m*+h[7672];h[7673]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[7671]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[7673]=+h[7673]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[15338]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[15338]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[7671];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[15350]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[15332]=y;c[15340]=x;c[15336]=s;break}else if((D|0)==26){D=0;c[15332]=y;c[15340]=x;c[15336]=s;break}}}while(0);m=+V(+(+h[7673]));h[7673]=m;H=+h[7671];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[15336]|0)+ -1<<3)>>3]=G;G=+h[7673]/+h[7671];h[j+((c[15332]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[15336]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[15334]|0;O=c[15348]|0}}while(0);b=N+O|0;c[15334]=b;o=O+1|0;c[15348]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[15332]=y;c[15340]=x;c[15336]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Fv(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[15374]=n;o=(c[d>>2]|0)-n|0;c[15396]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[15394]=s;a[61520]=1;t=c[b>>2]|0;u=t+1|0;c[15390]=u;v=c[b>>2]|0;w=u+v|0;c[15388]=w;u=w+(c[b>>2]|0)|0;c[15392]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[15382]=w;x=w+(c[d>>2]|0)|0;c[15376]=x;y=x+(c[b>>2]|0)|0;c[15378]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[15384]=z;A=z+(c[d>>2]|0)|0;c[15398]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[15400]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[15372]=C;D=C+(c[b>>2]|0)|0;c[15386]=D;Gv(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,61576,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);yM(61608)|0;gM()|0;i=m;return 0}function Gv(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[7786]=.5;h[7777]=1.0;h[7817]=.1;F=(c[a>>2]|0)+1|0;c[15550]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[15542]=H;I=(c[b>>2]|0)-F|0;c[15596]=I;F=c[j>>2]|0;c[15650]=(F|0)<1?1:F;F=c[a>>2]|0;c[15534]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[15536]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[15536]=J+1}L=c[u>>2]|0;c[15532]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[15532]=L+1}K=j+1|0;c[15534]=K;if((j|0)<(F|0)){j=K}else{break}}}c[15538]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[15538]=H+1}H=c[b>>2]|0;c[15536]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[15534]=M;c[15536]=H+1}N=+h[e>>3];O=N*N;h[7822]=O;h[7808]=+h[7777]/O;h[7809]=+V(+(+h[7786]))/O;c[15540]=0;H=y;y=A;M=0;a:while(1){c[15552]=M;F=M-(c[a>>2]|0)|0;c[15576]=F;j=M+1|0;c[15540]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[15626]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[15564]=L;K=L+G|0;c[15562]=K;if((K|0)>(c[a>>2]|0)){c[15626]=L;G=K-(c[a>>2]|0)|0;c[15564]=G;c[15562]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[7799]=O;L=c[15550]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[7799]=N;R=N}else{R=O}O=+h[e>>3];h[7800]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[7800]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[7800];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[15534]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[15534]=S+1}if((M|0)>=(c[15650]|0)){T=j;U=159;break}while(1){ge[H&63](a,d,62120)|0;if((c[g>>2]|0)==3){yM(62648)|0;PL(62816,62160,4)|0;PL(62816,62120,8)|0;I=c[a>>2]|0;c[15532]=1;if((I|0)>=1){F=1;do{PL(62816,d+(F+ -1<<3)|0,8)|0;L=c[15532]|0;F=L+1|0;c[15532]=F;}while((L|0)<(I|0))}gM()|0}I=c[15540]|0;do{if((I|0)>(c[b>>2]|0)){F=c[15580]|0;if((F|0)==-1){break a}h[7818]=0.0;c[15538]=0;L=c[a>>2]|0;c[15534]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[7818]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[7791]=N;if((X|0)==(G|0)){ea=N*+h[7786];h[7791]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[7818]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[15538]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[15532]=Y;c[15534]=L+1;W=Z}J=c[b>>2]|0;c[15536]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[7818]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[15536]=J+1;ia=ja}O=+h[7765];ba=+h[7794];N=O-ba-ia;h[7785]=N;h[7804]=+h[7803];h[7803]=+h[7802];if(!(N>=0.0)){ka=-N}else{ka=N}h[7802]=ka;if(+h[7814]>+h[7780]){c[15624]=I}h[7810]=ba;do{if(O<ba){h[7794]=O;h[7827]=0.0;G=c[a>>2]|0;c[15532]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[7827]=+h[7827]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[15532]=G+1;h[A>>3]=ma}}while(0);c[15622]=F;if((F|0)<=0){O=+h[7818];if(O>=0.0){U=190;break a}ba=+h[7765];N=+h[7810];ea=(ba-N)/O;h[7815]=ea;O=+h[7817];do{if(!(ea<=O)){na=+h[7786]*+h[7807];h[A>>3]=na;oa=+h[7814];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[7807]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[7807]=qa;ra=qa;break}}else{qa=+h[7786]*+h[7814];h[7807]=qa;ra=qa}}while(0);ea=+h[7780];if(!(ra<=ea*1.5)){sa=ra}else{h[7807]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[7822]=ea;c[15638]=0;h[7823]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[15594]|0;c[15638]=J;oa=+h[7777];h[7823]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[15536]=1;if((J|0)<1){va=F}else{L=c[15596]|0;oa=ua;K=1;ca=F;while(1){h[7805]=0.0;c[15534]=1;if((L|0)<1){wa=0.0}else{X=c[15556]|0;aa=K+C|0;qa=+h[7777];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[7791]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[7805]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[15534]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[7787]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[7791]=za;h[7826]=0.0;$=c[a>>2]|0;c[15534]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[7826]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[15534]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[7791]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[7823]=Fa;c[15580]=K;Ga=Fa;Ha=K}aa=K+1|0;c[15536]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Mv(a,b,s,t,62224,u,w,62296,62320,x)|0;ca=c[15580]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[7765];c[15538]=0;J=c[a>>2]|0;c[15532]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[7791]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[7791];G=G+1|0;da=da+1|0}da=X+aa|0;c[15538]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[15534]=La;c[15532]=J+1}h[L>>3]=0.0;X=c[15596]|0;c[15534]=1;aa=(X|0)<1;if(!aa){F=c[15556]|0;K=1;while(1){da=fa(K,B)|0;O=+h[7785]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[7791]=Oa;G=c[b>>2]|0;c[15536]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[7791];$=$+1|0}c[15536]=G+1}$=K+1|0;c[15534]=$;if((K|0)<(X|0)){K=$}else{break}}}h[7796]=0.0;K=c[a>>2]|0;c[15532]=1;if((K|0)>=1){F=1;while(1){O=+h[7785]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[7796]=+h[7796]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[15532]=K+1;h[A>>3]=Pa}F=c[15622]|0;do{if((F|0)==0){if(!(+h[7807]==+h[7780])){break}O=+h[7815];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[15642]=0;break}L=c[b>>2]|0;c[15536]=1;if((L|0)>=1){J=o+((c[15594]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[15536]=L+1}h[7789]=0.0;$=c[a>>2]|0;c[15532]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[7783]=0.0;G=c[b>>2]|0;c[15536]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[7783]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[15536]=G+1;Sa=Ta}h[7789]=+h[7789]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[15532]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[7789]*100.0}J=c[15642]|0;c[15642]=J+1;if(+h[7796]<Ra){c[15642]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[15532]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[15532]=J+1}$=c[15542]|0;c[15538]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[15538]=$+1}c[15534]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[15536]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[15536]=Na+1;Ua=Wa}if((L|0)<(c[15556]|0)){h[J>>3]=-Ua}Va=L+1|0;c[15534]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[15536]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[15534]=Xa;c[15536]=L+1}c[15642]=0}}while(0);O=+h[7765];ea=+h[7810];if(O<ea){c[15594]=ca}oa=+h[7817];if(O<=ea+oa*+h[7818]|(F|0)>0){U=54;break}c[15580]=0;Ia=0;Ja=+h[7807];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[7765];oa=+h[7765];do{if((I|0)==1){h[7784]=oa;h[7794]=oa;c[15594]=1;Ya=1}else{if(!(oa<+h[7794])){Ya=I;break}h[7794]=oa;c[15594]=I;Ya=I}}while(0);F=c[15552]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[15562]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[15564]|0;Va=K+aa|0;c[15538]=Va;if(+h[7799]<0.0){aa=X+(c[a>>2]|0)|0;c[15562]=aa;Za=aa}else{Za=X}if(+h[7800]<0.0){X=K+(c[a>>2]|0)|0;c[15564]=X;_a=X}else{_a=K}K=fa(c[15576]|0,B)|0;h[t+(K-B<<3)>>3]=+h[7808];h[t+(Ya+C+K<<3)>>3]=+h[7808];h[t+(Za-B+K<<3)>>3]=-+h[7808];h[t+(_a-B+K<<3)>>3]=-+h[7808];h[q+(Va+ -1<<3)>>3]=(+h[7784]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[7765])/(+h[7799]*+h[7800])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[15576]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[7786]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[7786]/+h[e>>3];ea=+h[7809];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[7809];h[t+(X+K<<3)>>3]=+h[7809];K=(fa(Va+1|0,Va)|0)/2|0;c[15538]=K;ea=(+h[7784]- +h[7765])/+h[e>>3];h[7791]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[7786]*(+h[X>>3]+ +h[7791]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[7784])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[7777]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[7777]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[7786]*+h[7822]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[7780]=oa;h[7807]=oa;c[15556]=1;h[7802]=0.0;h[7803]=0.0;c[15642]=0;h[7827]=0.0;F=c[a>>2]|0;c[15532]=1;if((F|0)<1){U=53;break}ca=c[15594]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[7827]=+h[7827]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[15532]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[15624]=c[15540];U=54;continue}else if((U|0)==54){U=0;c[15580]=0;I=(c[15550]|0)+ -1|0;K=c[a>>2]|0;Lv(a,b,l,n,p,q,r,62456,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,62592)|0;h[7779]=0.0;K=c[a>>2]|0;c[15532]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[7779]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[15532]=K+1;ab=cb}oa=+h[7807];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[7814]=O;ea=+h[7780];if(!(O<+h[7786]*ea)){db=ab;U=62;break}c[15580]=-1;O=+h[7817];N=O*oa;h[7807]=N;h[7815]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[7807]=ea;eb=ea}if((c[15540]|0)<=((c[15624]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[7824]*.125*ea;h[7791]=N;oa=+h[7802];ba=+h[7803];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[7804];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[7826]=O;I=c[b>>2]|0;c[15536]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[7783]=0.0;X=c[a>>2]|0;c[15534]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[7783]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[15534]=X+1;jb=lb}if(jb>ea){c[15580]=F;h[7826]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[15536]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[7815]>0.0){U=54;continue}ea=+h[7814];O=+h[7780];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[7786];h[7807]=O;ea=hb/+h[f>>3];h[7815]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[7780]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[7780]=na;ob=na;break}}else{na=+h[f>>3];h[7780]=na;ob=na}}while(0);h[7807]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){yM(62696)|0;gM()|0}yM(62720)|0;PL(62816,62240,8)|0;PL(62816,62160,4)|0;gM()|0;yM(62744)|0;PL(62816,62352,8)|0;ca=c[a>>2]|0;c[15532]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];PL(62816,y,8)|0;I=c[15532]|0;F=I+1|0;c[15532]=F;}while((I|0)<(ca|0))}gM()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[7786]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[7780];O=na>=ea?na:ea;h[7816]=O;ea=O*O;h[7779]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[7827];if(db<=ea*.001){h[7820]=ea*.25;ca=c[b>>2]|0;c[15536]=1;if((ca|0)>=1){F=1;while(1){h[7783]=0.0;I=c[a>>2]|0;c[15532]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[7783]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[15532]=I+1;pb=qb}h[7791]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[7786]*+h[7827];h[7783]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[15532]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[7791]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[7786]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[7783]*+h[n+(F+C+Va<<3)>>3]+ +h[7820]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[15544]=aa;c[15534]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[15534]=Va;rb=Va}c[15532]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[15536]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[15596]|0;c[15536]=1;if((F|0)>=1){ca=1;while(1){h[7801]=0.0;X=c[b>>2]|0;c[15532]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[7801]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[15532]=I;if((K|0)>=(X|0)){break b}O=+h[7801];K=I}}}while(0);X=c[a>>2]|0;c[15534]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[7820]*+h[7801]*+h[l+(I<<3)>>3];h[7783]=O;Va=c[b>>2]|0;c[15532]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[7783]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[15532]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[15556]|0)){h[7783]=-+h[7783]}L=c[b>>2]|0;c[15532]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[7783]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[15532]=L+1}J=K+1|0;c[15534]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[15532]=1;if((K|0)>=1){X=c[15556]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[15544]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[7791]=ub;c[15534]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[7791];aa=aa+1|0}aa=J+1|0;c[15534]=aa;vb=aa}c[15532]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[15536]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[15538]=0;ca=c[a>>2]|0;c[15534]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[15536]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[7786]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[15536]=aa+1}c[15532]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[15538]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[15532]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[15534]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[15534]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[15534]=J+1}h[7827]=0.0}if((c[15580]|0)>0){F=(c[15550]|0)+ -1|0;Yu(a,b,l,n,s,t,62224,u,62320,62528,v,62448,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[15536]=1;if((F|0)>=1){L=1;while(1){h[7792]=0.0;h[7793]=0.0;h[7783]=0.0;ca=c[a>>2]|0;c[15534]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[7792]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[7793]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[7783]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[15534]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[7786]+Ab);h[w+(K<<3)>>3]=+h[7783];K=L+1|0;c[15536]=K;if((L|0)<(F|0)){L=K}else{break}}}h[7787]=0.0;L=c[15596]|0;c[15536]=1;if((L|0)>=1){F=1;while(1){h[7783]=0.0;J=c[b>>2]|0;c[15532]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[7783]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[15532]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[7787];if((F|0)<(c[15556]|0)){h[7787]=O+ea;na=-Eb;h[7783]=na;Gb=na}else{h[7787]=O-ea;Gb=Eb}K=c[b>>2]|0;c[15532]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[7783];X=X+1|0}c[15532]=K+1}X=F+1|0;c[15536]=X;if((F|0)<(L|0)){F=X}else{break}}}h[7795]=0.0;h[7774]=0.0;F=c[a>>2]|0;c[15534]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[7783]=0.0;X=c[b>>2]|0;c[15532]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[7783]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[15532]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[7795]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[15546]=K;Va=c[a>>2]|0;c[15536]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[7783]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[15536]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[7795]+ +h[7783]*+h[ca>>3];h[7795]=O;na=+h[7774]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[7774]=na;aa=L+1|0;c[15534]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[7779];h[7787]=+h[7787]+(Ib*Ib+ea*(Ib+(Ib+ +h[7827])+ea*+h[7786]))-Hb;L=w+((c[15594]|0)+ -1<<3)|0;h[L>>3]=+h[7777]+ +h[L>>3];L=c[15580]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[7777]+ +h[7806]*+h[7787]/(ea*ea);h[7791]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;Xu(a,b,l,n,s,t,62224,u,62376,62320,v,x,w,62296,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[15532]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[15532]=L+1}F=c[15540]|0;aa=F+1|0;c[15540]=aa;if((F|0)>=(c[15650]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[15540]=T+ -1;if((c[g>>2]|0)<=0){break}yM(62624)|0;gM()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}yM(62672)|0;gM()|0}}while(0);Nb=+h[7794];if(Nb<=+h[7765]){U=c[a>>2]|0;c[15532]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[15532]=U+1;Ob=+h[7794]}h[7765]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}yM(62768)|0;PL(62816,62160,4)|0;gM()|0;yM(62792)|0;PL(62816,62120,8)|0;g=c[a>>2]|0;c[15532]=1;if((g|0)>=1){a=1;do{PL(62816,d+(a+ -1<<3)|0,8)|0;U=c[15532]|0;a=U+1|0;c[15532]=a;}while((U|0)<(g|0))}gM()|0;i=z;return 0}function Hv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){BY(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){BY(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function Iv(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+yv(62824);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+zv(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+zv(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+zv(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function Jv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function Kv(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+yv(62832);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=QY(u|0,0,t+ -2|0,0)|0;t=JY(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function Lv(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[7874]=.5;h[7892]=6.283185307179586;v=+h[l>>3];h[7887]=v*v;c[15770]=0;l=c[b>>2]|0;c[15788]=l;c[15786]=l;w=c[b>>2]|0;c[15710]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[15710]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[15710]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[15710]=w+1}z=c[d>>2]|0;c[15714]=1;if((z|0)>=1){e=1;while(1){h[7878]=0.0;A=c[b>>2]|0;c[15712]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[7878]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[15712]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[7878]=v;C=c[b>>2]|0;c[15710]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[7878];F=F+1|0}c[15710]=C+1}F=e+1|0;c[15714]=F;if((e|0)<(z|0)){e=F}else{break}}}c[15724]=0;e=c[b>>2]|0;c[15712]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[15724]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[15710]=H;c[15712]=e+1}do{if((y|0)==0){h[7876]=0.0;h[7858]=0.0;w=c[b>>2]|0;c[15710]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[7858]=+h[7858]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[15710]=w+1}h[r>>3]=0.0;D=+h[7858];if(D==0.0){O=55;break a}h[7863]=0.0;h[7866]=0.0;h[7861]=D;h[7881]=D;P=D;Q=0.0;R=0.0;S=+h[7887];T=0}else{if((y|0)>(x|0)){h[7860]=0.0;h[7867]=0.0;h[7868]=0.0;z=c[b>>2]|0;c[15710]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7860]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[7867]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[7868]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[15710]=z+1;U=ba;W=$;Z=aa}D=+h[7874];v=D*(+h[7871]-Z);h[7859]=v;_=+h[7864];ca=_+v;h[7875]=ca;h[7879]=ca;h[7877]=ca;c[15780]=0;a[62920]=1;da=+h[7892]/50.0;h[7878]=da;c[15710]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[7877]=ka;c[15780]=w;h[7888]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[7889]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[7883]=ha;h[7869]=ia;h[7872]=ja;h[7880]=ka;c[15710]=50;h[7879]=ka;if((la|0)==49){h[7889]=ca;na=ca}else if((la|0)==0){h[7888]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[7889]}h[7883]=0.0;ga=+h[7888];if(ga!=na){ea=ga-ma;h[7888]=ea;ga=na-ma;h[7889]=ga;oa=D*(ea-ga)/(ea+ga);h[7883]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[7883]=oa;ga=+X(+oa);h[7869]=ga;ea=+Y(+oa);h[7872]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[7884]=oa;h[7861]=0.0;w=c[b>>2]|0;c[15710]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[7869]*+h[J>>3]+ +h[7872]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[7861]+sa*sa;h[7861]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[7872];ea=+h[7869];F=F+1|0;z=K}c[15710]=w+1;qa=ta;ra=+h[7884]}ea=ra+ +h[7876];h[7876]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[7867]=0.0;z=c[b>>2]|0;c[15712]=1;do{if((z|0)<1){ea=+h[7891];h[7882]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[7867]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[15712]=z+1;ea=+h[7891];h[7882]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[7858];h[7878]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[7878]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[7882];oa=+h[7861];v=+h[7867];_=oa/v;ca=ea<=_?ea:_;h[7882]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[7861];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[7874]*Ca);h[7873]=ca;h[7876]=+h[7876]+ca;h[7886]=Ba;h[7861]=0.0;z=c[b>>2]|0;c[15710]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[7882]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[7861]+oa*oa;h[7861]=Ga;Ha=+h[7882];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[15710]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[7891]){if(+h[7873]<=+h[7876]*.01){O=55;break a}if(Fa<=+h[7881]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[7886];h[7878]=ca;h[7858]=0.0;h[7863]=0.0;h[7866]=0.0;w=c[b>>2]|0;c[15710]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[7858]+ca*ca;h[7858]=La;J=m+(F<<3)|0;Ma=+h[7863]+ +h[K>>3]*+h[J>>3];h[7863]=Ma;ca=+h[J>>3];Na=+h[7866]+ca*ca;h[7866]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[7878];Ja=Ja+1|0;Ka=J}c[15710]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[7887];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[15786]=y;ua=+h[7861];va=y}if(ua<=+h[7881]*1.0e-4){O=55;break a}h[7864]=0.0;h[7871]=0.0;z=c[b>>2]|0;c[15710]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7864]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[7871]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[15710]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[7870]=ca;oa=+h[7887];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[15770]=J;_=+V(+(v-ca*ca));h[7878]=_;v=oa/_;h[7888]=v;oa=ca/_;h[7889]=oa;w=c[b>>2]|0;c[15710]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[7889];Ta=+h[7888];Ua=Ua+1|0;Va=K}c[15710]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[15770]=e;v=S-R;h[7878]=v;h[7891]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Mv(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[7901]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[15808]=t;c[15798]=1;c[15792]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[15798]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[7903]=D;C=+h[x>>3]/D;h[7910]=C;z=+h[f+(B+y<<3)>>3]/D;h[7911]=z;B=c[d>>2]|0;c[15790]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[7903]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[7903];if((x|0)>=(B|0)){break}D=+h[7911];z=+h[7910];x=x+1|0}c[15790]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[15792]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[7910]=z;if((c[g>>2]|0)>1){D=-z;h[7910]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[7911]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[15790]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[7911]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[7910];t=t+1|0;x=A}c[15790]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[7908]=z;x=k+(w<<3)|0;H=+h[x>>3];h[7902]=H;D=H*H;h[7912]=D;h[7909]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[7901];a[63240]=0;do{if((u|0)==1){z=+h[7909];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[7903]=z;D=+h[7910]/z;h[7911]=D;H=+h[7902]/z;h[7910]=H;x=c[d>>2]|0;c[15790]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[7911];D=+h[7910];w=w+1|0;t=s}c[15790]=x+1;J=+h[7903]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[15794]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[15794]=u;M=u}t=u+1-M|0;c[15796]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[7909];z=+h[f+(t+w<<3)>>3]/D;h[7903]=z;h[7910]=z*+h[l>>3];H=+h[7902];h[7911]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[7903]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[7901]/+V(+(+h[7912]+z*N*z));h[7906]=C;if(!(D>=0.0)){O=-D}else{O=D}h[7907]=C*+V(+O);t=c[d>>2]|0;c[15790]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[7907]*(+h[A>>3]- +h[7910]*+h[n+(G<<3)>>3]- +h[7911]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[7903];z=+h[7902];H=+h[7906];v=v+1|0}c[15790]=t+1;P=+h[7909]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[63240]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[15790]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[7903]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[7903];K=Q+1|0;c[15790]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[15792]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[15800]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[7902];N=+h[7909];J=(+h[7908]*+h[f>>3]-O*P)/N;h[7910]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[7911]=P;c[15790]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[15790]=q;if((f|0)>=(b|0)){break a}N=+h[7911];O=+h[7910];f=q}}}while(0);b=R+1|0;c[15792]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Nv(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Ov(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Nv(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(63304,63320,116,63344)}else if((s|0)==14){i=g;return o|0}return 0}function Pv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((tY(w,c[63352+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[63456+(x<<2)>>2]|0;c[q>>2]=c[63352+(x<<2)>>2];c[q+4>>2]=y;pt(23,0,63528,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=XX(D,8)|0;c[e+40>>2]=B;D=b+536|0;st(c[D>>2]|0,(B|0)!=0|0,63568,p);B=XX(c[A>>2]|0,4)|0;c[e+36>>2]=B;st(c[D>>2]|0,(B|0)!=0|0,63568,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=XX(c[C>>2]|0,4)|0;c[e+24>>2]=VX(8)|0;C=VX(4)|0;c[e+20>>2]=C;c[C>>2]=c[35208>>2];st(c[D>>2]|0,(C|0)!=0|0,63568,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=VX(C)|0;A=e+44|0;c[A>>2]=VX(C)|0;C=XX(15,4)|0;E=e+12|0;c[E>>2]=C;st(c[D>>2]|0,(C|0)!=0|0,63568,m);C=XX(5,4)|0;c[e+4>>2]=C;st(c[D>>2]|0,(C|0)!=0|0,63568,l);C=XX(5,4)|0;c[e+8>>2]=C;st(c[D>>2]|0,(C|0)!=0|0,63568,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=VX(C)|0;c[e+76>>2]=VX(C)|0;c[e+80>>2]=VX(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((de[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){pt(23,0,63584,j)}else{pt(1,0,63656,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[35244>>2]|c[8786]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=63488;W=V;tt(Q,W,r)}c[t>>2]=w;rt(23,1,63384,t);t=1;do{w=c[63456+(t<<2)>>2]|0;c[s>>2]=c[63352+(t<<2)>>2];c[s+4>>2]=w;rt(23,0,63440,s);t=t+1|0;}while((t|0)<8);ae[c[8926]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=63488;W=V;tt(Q,W,r);return 0}function Qv(a){a=a|0;var b=0;b=i;WX(c[a+40>>2]|0);WX(c[a+36>>2]|0);WX(c[a+20>>2]|0);WX(c[a+12>>2]|0);WX(c[a+4>>2]|0);WX(c[a+8>>2]|0);WX(a);i=b;return 0}function Rv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;st(c[N>>2]|0,(c[M>>2]|0)!=0|0,63752,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){pt(3,0,63784,B);pt(3,0,63824,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];de[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];pt(3,0,63848,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];pt(23,0,63888,y);if((c[z>>2]|0)==1){Cu(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Ix(a)|0;de[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 3:{_u(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 7:{_u(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 6:{_u(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 4:{_u(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 5:{_u(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){_u(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{_u(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){qd(_|0)|0;qd($|0)|0;rt(3,0,63920,x);pt(3,0,64008,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){qd(_|0)|0;qd($|0)|0;$=_v(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Ix(a)|0;de[c[(c[ba>>2]|0)+40>>2]&127](a)|0}de[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];rt(1,0,64032,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[35164>>2]|0)!=0){pt(3,1,64064,u);c[s>>2]=c[z>>2];pt(3,0,64088,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];pt(3,0,64112,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];pt(3,0,64144,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];pt(3,0,64184,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];pt(3,0,64232,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];pt(3,0,64280,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];pt(3,0,64320,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];pt(3,0,64360,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];pt(3,0,64400,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];pt(3,0,64448,f);ae[c[8926]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(64488,64520,410,64552)}pt(3,0,64568,e);S=0;i=d;return S|0}function Sv(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Ix(g)|0;a=f+540|0;de[c[(c[a>>2]|0)+40>>2]&127](g)|0;de[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Tv(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Ix(l)|0;b=k+540|0;de[c[(c[b>>2]|0)+40>>2]&127](l)|0;de[c[(c[b>>2]|0)+28>>2]&127](l)|0;aw(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Uv(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Ix(g)|0;l=e+540|0;de[c[(c[l>>2]|0)+40>>2]&127](g)|0;de[c[(c[l>>2]|0)+28>>2]&127](g)|0;de[c[(c[l>>2]|0)+32>>2]&127](g)|0;ge[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function Vv(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;bw(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Wv(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Ix(l)|0;b=k+540|0;de[c[(c[b>>2]|0)+40>>2]&127](l)|0;de[c[(c[b>>2]|0)+28>>2]&127](l)|0;$v(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Xv(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function Yv(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;cw(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Zv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function _v(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-6:{rt(1,0,64632,j);m=-6;i=b;return m|0};case-9:{rt(1,0,64792,f);m=-9;i=b;return m|0};case-2:{rt(1,0,64592,k);m=-2;i=b;return m|0};case-12:{rt(1,0,65064,c);m=-12;i=b;return m|0};case-8:{rt(1,0,64744,g);m=-8;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-10:{rt(1,0,64880,e);m=-10;i=b;return m|0};case-11:{rt(1,0,64976,d);m=-11;i=b;return m|0};case-33:{rt(1,0,65112,b);m=-33;i=b;return m|0};case-7:{rt(1,0,64704,h);m=-7;i=b;return m|0};case-1:{rt(3,0,63920,l);m=1;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function $v(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}de[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function aw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;de[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function bw(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+pd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+pd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Sv(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function Wr(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function Xr(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((Zr(Yr(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((Zr(Yr(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=Yr(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((Zr(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=Yr(k,a,b)|0;n=h;}while((Zr(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=Yr(k,a,b)|0;while(1){if((Zr(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=Yr(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=Yr(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function Yr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function Zr(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function _r(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function $r(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 13:{c[h>>2]=14;j=56;break};case 11:{c[h>>2]=14;j=55;break};case 15:{c[h>>2]=14;j=0;break};case 16:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,32944)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};case 12:{c[h>>2]=14;j=1;break};case 29:{c[h>>2]=16;j=2;break};default:{k=10}}}while(0);if((k|0)==10){j=ds(h,a)|0}i=g;return j|0}function as(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 33:{c[h>>2]=17;j=0;break};case 34:{if((c[h+12>>2]|0)==0){k=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;j=0;break};case 26:{k=9;break};case-4:{if((c[h+12>>2]|0)!=0){k=9;break a}j=0;break};case 15:{j=0;break};default:{j=cs(h,a,d,e,f)|0}}}while(0);if((k|0)==9){j=ds(h,a)|0}i=g;return j|0}function bs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ce[c[e+28>>2]&63](e,b,d,32928)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,32936)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function cs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case-4:{j=0;k=j;i=g;return k|0};case 16:{if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,32704)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,32712)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,32720)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,32728)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};default:{}}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function ds(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function es(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function fs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else{g=ds(e,a)|0}i=f;return g|0}function gs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=ds(e,a)|0}i=f;return g|0}function hs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=ds(e,a)|0}i=f;return g|0}function is(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=ds(e,a)|0}i=f;return g|0}function js(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=ds(e,a)|0}i=f;return g|0}function ks(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==13){g=56}else if((b|0)==11){g=55}else{g=ds(e,a)|0}i=f;return g|0}function ls(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ce[c[e+28>>2]&63](e,b,d,32744)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,32752)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function ms(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=ds(e,a)|0}i=f;return g|0}function ns(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=ds(e,a)|0}i=f;return g|0}function os(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=ds(e,a)|0}i=f;return g|0}function ps(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=ds(e,a)|0;h=g;i=f;return h|0}return 0}function qs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,32760)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,32768)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function rs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 32:{c[h>>2]=40;j=54;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 20:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,32776)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 31:{c[h>>2]=40;j=52;break};case 15:{j=39;break};case 30:{c[h>>2]=40;j=53;break};default:{k=10}}}while(0);if((k|0)==10){j=ds(h,a)|0}i=g;return j|0}function ss(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else{g=ds(e,a)|0}i=f;return g|0}function ts(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 31:{c[e>>2]=40;g=52;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 30:{c[e>>2]=40;g=53;break};case 15:{g=39;break};case 32:{c[e>>2]=40;g=54;break};default:{g=ds(e,a)|0}}i=f;return g|0}function us(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};default:{g=ds(e,a)|0;h=g;i=f;return h|0}}return 0}function vs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=ds(e,a)|0}i=f;return g|0}function ws(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else{g=ds(e,a)|0}i=f;return g|0}function xs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else{g=ds(e,a)|0}i=f;return g|0}function ys(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ce[m&63](n,o,p,c[32784+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ce[m&63](n,o,p,32728)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function zs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,32888)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,32896)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,32912)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function As(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=ds(e,a)|0}i=f;return g|0}function Bs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=ds(e,a)|0}i=f;return g|0}function Cs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=ds(e,a)|0}i=f;return g|0}function Ds(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=ds(e,a)|0}i=f;return g|0}function Es(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=48;g=33}else{g=ds(e,a)|0}i=f;return g|0}function Fs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=ds(e,a)|0}i=f;return g|0}function Gs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=ds(e,a)|0}i=f;return g|0}function Hs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,32744)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,32752)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function Is(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=ds(e,a)|0}i=f;return g|0}function Js(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=ds(e,a)|0}i=f;return g|0}function Ks(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,32920)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function Ls(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=ds(e,a)|0}i=f;return g|0}function Ms(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,32744)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,32752)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function Ns(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=ds(e,a)|0}i=f;return g|0}function Os(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=ds(e,a)|0}i=f;return g|0}function Ps(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=ds(e,a)|0;h=g;i=f;return h|0}return 0}function Qs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=ds(e,a)|0;h=g;i=f;return h|0}return 0}function Rs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=ds(e,a)|0}i=f;return g|0}function Ss(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 16:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,32944)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 11:{j=55;break};case 13:{j=56;break};case 29:{c[h>>2]=16;j=2;break};case 15:{j=0;break};default:{k=9}}}while(0);if((k|0)==9){j=ds(h,a)|0}i=g;return j|0}function Ts(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=ds(e,a)|0}i=f;return g|0}function Us(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,32744)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,32752)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=ds(h,a)|0;k=j;i=g;return k|0}function Vs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=ds(e,a)|0}i=f;return g|0}function Ws(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=ds(e,a)|0}i=f;return g|0}function Xs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=ds(e,a)|0}i=f;return g|0}function Ys(){i=i;return}function Zs(){i=i;return}function _s(){var a=0;a=i;Wa(32952,0)|0;i=a;return}function $s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(32960,29,1,e|0)|0;qd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(32992,54,1,g|0)|0;qd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(33048,47,1,a|0)|0;qd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;sd(k|0,33096,d|0)|0;qd(k|0)|0;f=0;i=b;return f|0}function at(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;sd(j|0,33184,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;sd(n|0,33216,e|0)|0;k=0;i=d;return k|0}function bt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function ct(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Qt(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function dt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=Qt(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function et(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[21062]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=33272;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](0,f,33296,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function ft(a,b){a=a|0;b=b|0;var d=0;d=i;if(($s(a)|0)==0){cb(33352,33160,347,33376)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);cb(33408,33160,348,33376);return 0}function gt(){var a=0,b=0,d=0;a=i;b=35152|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=35264|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=35376|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[35156>>2]=1;c[35160>>2]=1;i=a;return}function ht(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?35512:35528;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;sd(a|0,35488,e|0)|0;i=d;return}function it(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=35376+(d<<2)|0;o=35264+(d<<2)|0;p=35576+(b<<2)|0;q=33856+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=35560;hc(35544,l|0)|0;s=35560}else{if((c[8784]|0)==(d|0)){if((c[o>>2]|0)>0){t=35560}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;hc(35544,m|0)|0;do{if((c[8784]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=35560;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;hc(35568,k|0)|0;c[n>>2]=b;c[8784]=d;if((c[o>>2]|0)>0){g=0;while(1){hc(35600,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;qd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function jt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[35576+(a<<2)>>2]|0;c[j>>2]=c[33856+(b<<2)>>2];c[j+4>>2]=k;hc(35608,j|0)|0;kt(e);if((g|0)==0){Fd(((d|0)!=0?35648:35696)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}tb(35776)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];hc(35656,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}rc(35680,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}function kt(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==38){rc(35720,5,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==62){rc(35736,4,1,e|0)|0}else if(b<<24>>24==60){rc(35728,4,1,e|0)|0}else{Nd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function lt(a){a=a|0;var b=0;b=35264+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function mt(a){a=a|0;var b=0;b=(a|0)==0;c[8928]=b?1:19;c[8926]=b?7:179;i=i;return}function nt(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(35680,11,1,b|0)|0;qd(b|0)|0;i=a;return}function ot(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[35152+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;nc(j|0,2048,e|0,h|0)|0;me[c[8928]&31](1,a,b,j,0,d);i=g;return}function pt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[35152+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;nc(h|0,2048,d|0,g|0)|0;me[c[8928]&31](1,a,b,h,0,0);i=f;return}function qt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[8786]|0)==0){if((c[35152+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;nc(k|0,2048,e|0,j|0)|0;me[c[8928]&31](2,a,b,k,0,d);i=g;return}function rt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[8786]|0)==0){if((c[35152+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;nc(j|0,2048,d|0,h|0)|0;me[c[8928]&31](2,a,b,j,0,0);i=f;return}function st(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;nc(b|0,2048,d|0,g|0)|0;me[c[8928]&31](4,2,0,b,0,0);if((a|0)==0){h=id(c[8238]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function tt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;nc(g|0,2048,b|0,f|0)|0;me[c[8928]&31](5,2,0,g,0,0);if((a|0)==0){h=id(c[8238]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function ut(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;nc(h|0,2048,d|0,g|0)|0;me[c[8928]&31](5,2,0,h,0,b);if((a|0)==0){j=id(c[8238]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function vt(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;ut(a,e,35848,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;qt(26,0,e,35784,m);i=j;return+b}return 0.0}function wt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+8>>2]|0)+(fa(d,b)|0)|0;i=i;return e|0}function xt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;c[a+8>>2]=Rt(dt(a,d,g)|0,b)|0;i=f;return}function yt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=wt(a,et(a,d,g)|0,b)|0;i=f;return e|0}function zt(a,b){a=a|0;b=b|0;i=i;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function At(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Pt(dt(a,b,f)|0)|0;i=e;return}function Bt(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=VX(16)|0;st(0,(d|0)!=0|0,35896,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Ct(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;WX(c[f>>2]|0);WX(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Dt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;st(0,(a|0)!=0|0,35912,f);f=VX(8)|0;g=f;st(0,(f|0)!=0|0,35896,e);e=a+8|0;h=VX(c[e>>2]|0)|0;c[f>>2]=h;st(0,(h|0)!=0|0,35896,d);zY(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Et(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;st(0,(a|0)!=0|0,35912,f);f=VX(8)|0;g=f;st(0,(f|0)!=0|0,35896,e);e=a+8|0;h=VX(c[e>>2]|0)|0;c[f>>2]=h;st(0,(h|0)!=0|0,35896,d);zY(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Ft(a){a=a|0;var b=0;b=i;i=i+8|0;st(0,(a|0)!=0|0,35912,b);i=b;return c[a+12>>2]|0}function Gt(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;st(0,(a|0)!=0|0,35912,d);d=a;st(0,(c[d>>2]|0)!=0|0,35936,b);i=b;return c[c[d>>2]>>2]|0}function Ht(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;WX(c[e>>2]|0);WX(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function It(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;st(0,(a|0)!=0|0,35912,d);d=a;st(0,(c[d>>2]|0)!=0|0,35952,b);i=b;return c[d>>2]|0}function Jt(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;st(0,d&1,35984,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function Kt(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;st(0,(a|0)!=0|0,35984,d);d=a;st(0,(c[d>>2]|0)!=0|0,36008,b);i=b;return c[d>>2]|0}function Lt(){var a=0,b=0,d=0;a=i;b=VX(16)|0;c[9020]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=VX(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=St(a)|0;tc(36088)|0;Tt(d);a=c[9020]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;gc(36088)|0;BY(g|0,0,d|0)|0;i=b;return g|0}function Nt(){var a=0,b=0,d=0,e=0;a=i;b=c[9020]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;WX(c[b>>2]|0);WX(b);if((d|0)==0){break}else{b=d}}e=c[9020]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Ot(a){a=a|0;var b=0,d=0;b=i;d=de[c[36040>>2]&127](a<<3)|0;i=b;return d|0}function Pt(a){a=a|0;var b=0,d=0;b=i;d=de[c[36040>>2]&127](a<<2)|0;i=b;return d|0}function Qt(a){a=a|0;var b=0,d=0;b=i;d=de[c[36040>>2]&127](a<<2)|0;i=b;return d|0}function Rt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=fa(b,a)|0;a=de[c[36036>>2]&127](e)|0;i=d;return a|0}function St(a){a=a|0;i=i;return a+7&-8|0}function Tt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[9020]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=VX(16)|0;c[f+12>>2]=d;c[9020]=f;c[f+4>>2]=0;d=Ut((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=VX(d)|0;c[f>>2]=a;i=b;return}function Ut(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function Vt(a){a=a|0;var b=0,c=0;b=i;c=xY(a|0)|0;i=b;return c|0}function Wt(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;DY(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ic(m|0,l|0,f|0)|0;f=Xt(m)|0;i=e;return f|0}function Xt(a){a=a|0;var b=0,c=0,d=0;b=i;c=xY(a|0)|0;d=Zt(c)|0;zY(d|0,a|0,c|0)|0;i=b;return d|0}function Yt(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;ic(o|0,36120,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;ic(o|0,36112,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ic(q|0,p|0,j|0)|0;j=Xt(q)|0;i=g;return j|0}function Zt(b){b=b|0;var d=0,e=0;d=i;e=de[c[36044>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function _t(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=Vt(a)|0;e=Vt(b)|0;f=Zt(e+d|0)|0;zY(f|0,a|0,d|0)|0;zY(f+d|0,b|0,e|0)|0;i=c;return f|0}function $t(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=tY(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function au(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}else if((e|0)==2){f=-1;break}switch(d|0){case 5:{f=1;break a;break};case 3:{f=2;break a;break};case 4:{f=2;break a;break};case 1:{f=4;break a;break};case 2:{f=4;break a;break};case 0:{f=8;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function bu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Xc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){WX(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{WX(c[(c[f>>2]|0)+(g<<4)>>2]|0);WX(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;WX(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){WX(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{WX(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}WX(d);c[g>>2]=0;i=b;return}function cu(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(xY(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function du(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=jc(b|0,36288)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Rd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=vd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=36296;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[36264+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=36320;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=36344;E=131;break}G=au(D)|0;if((G|0)==-1){n=36376;E=131;break}D=c[q>>2]|0;H=VX(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=36424;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=36448;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((tY(H,c[36240+(C<<2)>>2]|0)|0)!=0){n=36472;E=131;break}WX(H);H=37048;b:do{switch(C|0){case 2:{if(d<<24>>24==1){if((I|0)==0){K=1;E=129;break b}F=D+1|0;G=0;while(1){L=VX(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=L;if((sb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=36672;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;L=G+1|0;if(L>>>0<I>>>0){G=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}G=fa(D,I)|0;N=VX(G+1|0)|0;if((sb(N|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;L=0;do{O=VX(G)|0;c[(c[v>>2]|0)+(L<<4)+4>>2]=O;if(!F){O=0;do{P=a[N+((fa(D,O)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+O|0]=P;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+I|0]=0;L=L+1|0;}while(L>>>0<D>>>0)}WX(N);M=0;E=130;break};case 1:{L=d<<24>>24==0;c[u>>2]=L?D:I;F=VX((L?D:I)<<4)|0;c[v>>2]=F;c:do{if(d<<24>>24==1){if((I|0)==0){Q=0;break}G=D+1|0;O=F;P=0;while(1){c[O+(P<<4)>>2]=VX(G)|0;if((sb(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=36672;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;R=c[v>>2]|0;c[R+(P<<4)+8>>2]=-1;c[R+(P<<4)+12>>2]=-1;cu(c[R+(P<<4)>>2]|0);R=P+1|0;if(!(R>>>0<I>>>0)){Q=I;break c}O=c[v>>2]|0;P=R}}else{Q=I}}while(0);if(!L){M=d;E=130;break b}F=fa(D,Q)|0;S=VX(F+1|0)|0;if((sb(S|0,F|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){F=Q+1|0;P=(Q|0)==0;O=0;do{G=VX(F)|0;c[(c[v>>2]|0)+(O<<4)>>2]=G;if(!P){G=0;do{R=a[S+((fa(D,G)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+G|0]=R;G=G+1|0;}while(G>>>0<Q>>>0)}a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+Q|0]=0;G=c[v>>2]|0;c[G+(O<<4)+8>>2]=-1;c[G+(O<<4)+12>>2]=-1;cu(c[G+(O<<4)>>2]|0);O=O+1|0;}while(O>>>0<D>>>0)}WX(S);M=0;E=130;break};case 0:{if((D|0)!=4){n=36496;E=131;break a}if((I|0)!=11){n=36536;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){T=0}else{n=36576;E=131;break a}while(1){O=0;do{a[k+O|0]=a[j+((O<<2)+T)|0]|0;O=O+1|0;}while(O>>>0<11);a[k+11|0]=0;if((T|0)==3){break}O=T+1|0;if(O>>>0<4){T=O}else{M=d;E=130;break b}}if((uY(t,c[9036]|0,8)|0)==0){M=1;E=130;break b}if((uY(t,c[9042]|0,9)|0)==0){M=0;E=130}else{n=36608;E=131;break a}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=36984;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=XX(c[z>>2]<<1,4)|0;if((Vc(c[m>>2]|0,J|0,1)|0)==-1){n=37016;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=36984;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=XX(c[z>>2]<<1,4)|0;O=fa(I,D)|0;if((a[l]|0)==1){P=VX(O<<3)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=37016;E=131;break a}if((I|0)!=0){F=D<<3;L=(D|0)==0;G=D<<3;R=0;do{U=VX(F)|0;c[(c[B>>2]|0)+(R<<2)>>2]=U;if(!L){U=P+(fa(G,R)|0)|0;zY(c[(c[B>>2]|0)+(R<<2)>>2]|0,U|0,G|0)|0}R=R+1|0;}while(R>>>0<I>>>0)}R=c[z>>2]|0;G=R<<1;if(R>>>0<G>>>0){L=D<<3;F=(D|0)==0;U=R;do{V=VX(L)|0;c[(c[B>>2]|0)+(U<<2)>>2]=V;if(!F){V=c[B>>2]|0;W=c[V+(U-R<<2)>>2]|0;X=c[V+(U<<2)>>2]|0;V=0;do{h[X+(V<<3)>>3]=-+h[W+(V<<3)>>3];V=V+1|0;}while(V>>>0<D>>>0)}U=U+1|0;}while(U>>>0<G>>>0)}WX(P)}else{G=VX(O<<2)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=37016;E=131;break a}if((I|0)!=0){U=D<<3;R=(D|0)==0;F=0;do{L=VX(U)|0;c[(c[B>>2]|0)+(F<<2)>>2]=L;if(!R){L=c[(c[B>>2]|0)+(F<<2)>>2]|0;V=0;do{h[L+(V<<3)>>3]=+g[G+((fa(D,F)|0)+V<<2)>>2];V=V+1|0;}while(V>>>0<D>>>0)}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;R=F<<1;if(F>>>0<R>>>0){U=D<<3;O=(D|0)==0;P=F;do{V=VX(U)|0;c[(c[B>>2]|0)+(P<<2)>>2]=V;if(!O){V=c[B>>2]|0;L=c[V+(P-F<<2)>>2]|0;W=c[V+(P<<2)>>2]|0;V=0;do{h[W+(V<<3)>>3]=-+h[L+(V<<3)>>3];V=V+1|0;}while(V>>>0<D>>>0)}P=P+1|0;}while(P>>>0<R>>>0)}WX(G)}if((Vc(c[m>>2]|0,J|0,1)|0)==-1){n=37016;E=131;break a}else{M=d;E=130}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=36736;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=36792;E=131;break a}c[w>>2]=D;R=fa(I,D)|0;if((a[l]|0)==1){P=VX(R<<3)|0;c[x>>2]=P;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=36832;E=131;break a}}else{P=VX(R<<2)|0;c[x>>2]=VX(fa(D<<3,I)|0)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=36832;E=131;break a}if((R|0)!=0){F=c[x>>2]|0;O=0;do{h[F+(O<<3)>>3]=+g[P+(O<<2)>>2];O=O+1|0;}while(O>>>0<R>>>0)}WX(P)}R=c[w>>2]|0;if(!(R>>>0>1)){M=1;E=130;break b}O=(I|0)==2;F=1;while(1){if(O){G=c[x>>2]|0;if(+h[G+(F<<3)>>3]!=+h[G+(R+F<<3)>>3]){n=36864;E=131;break a}}G=F+1|0;if(G>>>0<R>>>0){F=G}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}if((I|0)==0){n=36736;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=36944;E=131;break a}c[w>>2]=I;F=fa(I,D)|0;if((a[l]|0)==1){R=VX(F<<3)|0;c[x>>2]=VX(fa(D<<3,I)|0)|0;if((sb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=36832;E=131;break a}if((D|0)!=0){O=0;do{P=c[x>>2]|0;G=0;do{h[P+((fa(I,O)|0)+G<<3)>>3]=+h[R+((fa(D,G)|0)+O<<3)>>3];G=G+1|0;}while(G>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}WX(R)}else{O=VX(F<<2)|0;c[x>>2]=VX(fa(D<<3,I)|0)|0;if((sb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=36832;E=131;break a}if((D|0)!=0){G=0;do{P=c[x>>2]|0;U=0;do{h[P+((fa(I,G)|0)+U<<3)>>3]=+g[O+((fa(D,U)|0)+G<<2)>>2];U=U+1|0;}while(U>>>0<I>>>0);G=G+1|0;}while(G>>>0<D>>>0)}WX(O)}G=c[w>>2]|0;if(!(G>>>0>1)){M=d;E=130;break b}F=(D|0)==2;R=1;while(1){if(F){U=c[x>>2]|0;if(+h[U+(R<<3)>>3]!=+h[U+(G+R<<3)>>3]){n=36864;E=131;break a}}U=R+1|0;if(U>>>0<G>>>0){R=U}else{M=d;E=130;break}}break};case 3:{R=fa(I<<2,D)|0;Y=VX(R)|0;if((sb(Y|0,R|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}R=c[v>>2]|0;G=0;do{F=fa(D,G)|0;c[R+(G<<4)+8>>2]=(c[Y+(F<<2)>>2]|0)==1;c[R+(G<<4)+12>>2]=c[Y+(F+1<<2)>>2];G=G+1|0;}while(G>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}G=c[v>>2]|0;R=0;do{c[G+(R<<4)+8>>2]=(c[Y+(R<<2)>>2]|0)==1;c[G+(R<<4)+12>>2]=c[Y+(D+R<<2)>>2];R=R+1|0;}while(R>>>0<D>>>0)}}while(0);WX(Y);dc(c[v>>2]|0,c[u>>2]|0,16,53);M=d;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=K;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){WX(S);n=36672;i=e;return n|0}else if((E|0)==46){WX(N);n=36672;i=e;return n|0}else if((E|0)==52){WX(Y);n=36704;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function eu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=zd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,53)|0;i=d;return b|0}function fu(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=37088;o=n;p=37136;q=p;r=37160;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=37088;o=n;p=37136;q=p;r=37160;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=VX(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Vc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}WX(r);t=0;i=e;return t|0}else{k=VX(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Vc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}WX(k);WX(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);WX(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function gu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=37088;r=q;s=37136;t=s;u=37184;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=37088;r=q;s=37136;t=s;u=37184;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Vc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Vc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function hu(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function iu(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function ju(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function ku(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+ju(b)<e){q=1;i=f;return q|0}if(+iu(b)>e){q=1;i=f;return q|0}if((fu(b,1)|0)==0){q=1;i=f;return q|0}hu(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+gu(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+gu(a,b,d,o);i=f;return q|0}if(+gu(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+gu(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function lu(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function mu(a,b){a=a|0;b=b|0;var c=0;c=i;ct(a,b,Ot(b)|0);i=c;return}function nu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Ot(dt(a,b,f)|0)|0;i=e;return}function ou(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if(($s(a)|0)==0){cb(37216,37240,127,37264)}if(($s(b)|0)==0){cb(37288,37240,128,37264)}if((at(a,b)|0)==0){cb(37312,37240,129,37264)}e=bt(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+lu(a,b);pu(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function pu(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function qu(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function ru(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;pu(c[d+8>>2]|0,b,a);i=e;return}function su(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;mu(a,b);j=g;c[g>>2]=e;ru(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;ru(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function tu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=et(a,b,f)|0;f=qu(c[a+8>>2]|0,d)|0;i=e;return f|0}function uu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=VX(d<<2)|0;if((j|0)==0){cb(37352,37240,784,37384)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){cb(37360,37240,795,37384)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){cb(37408,37240,798,37384)}else if((s|0)==17){cb(37448,37240,800,37384)}else if((s|0)==22){cb(37448,37240,804,37384)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=Ot(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=Qt(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){WX(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+lu(a,k+s|0);pu(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}WX(j);i=g;return}function vu(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if(($s(a)|0)==0){cb(37496,37240,1547,37520)}c=bt(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +lu(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function wu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=VX(20)|0;st(0,(f|0)!=0|0,37536,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=XX(e,b)|0;c[f>>2]=a;st(0,(a|0)!=0|0,37536,d);i=d;return f|0}function xu(a){a=a|0;var b=0;b=i;WX(c[a>>2]|0);WX(a);i=b;return}function yu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;st(0,(c[h>>2]|0)>0|0,37552,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;st(0,(g|0)>(b|0)|0,37576,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;st(0,(0-f|0)<(b|0)|0,37576,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function zu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=XX(c[d>>2]<<1,c[e>>2]|0)|0;st(0,(f|0)!=0|0,37536,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=yu(a,j)|0;h=c[e>>2]|0;zY(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;WX(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Au(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){zu(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;zY((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Bu(a){a=a|0;i=i;return c[a+12>>2]|0}function Cu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;st(0,(c[j>>2]|0)>0|0,37552,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;st(0,(h|0)>(b|0)|0,37576,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;st(0,b>>>31^1,37576,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=yu(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Du(a){a=a|0;i=i;return c[(c[9402]|0)+(a<<2)>>2]|0}function Eu(a){a=a|0;i=i;return c[(c[9404]|0)+(a<<2)>>2]|0}function Fu(a){a=a|0;i=i;return c[(c[9406]|0)+(a<<2)>>2]|0}function Gu(a){a=a|0;i=i;return c[(c[9408]|0)+(a<<2)>>2]|0}function Hu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[9404]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[9406]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[9402]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Iu(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9410]|0;e=+Ju(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Ju(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Ku(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9412]|0;e=+Ju(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Lu(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9414]|0;e=+Ju(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Mu(a){a=a|0;i=i;return 0}function Nu(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[9416]|0)+(a<<3)|0)|0;d=(c[9402]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[9410]|0;f=e+(a<<3)|0;g=c[9414]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[9408]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[9402]|0)+(a<<2)>>2]|0);e=c[9412]|0;g=e+(a<<3)|0;Pu(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Hu(a);d=c[9410]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[9402]|0)+(a<<2)>>2]=0;i=b;return}function Pu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Su(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Qu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[9416]|0;f=c[9410]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Ru(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=XX(a,8)|0;c[9410]=d;e=XX(a,8)|0;c[9412]=e;f=XX(a,8)|0;c[9414]=f;g=XX(a,8)|0;c[9416]=g;h=XX(a,4)|0;c[9402]=h;j=XX(a,4)|0;c[9408]=j;k=a<<2;l=VX(k)|0;c[9404]=l;m=XX(a,4)|0;c[9406]=m;BY(l|0,-1,k|0)|0;if((d|0)==0){cb(37672,37688,393,37704)}if((e|0)==0){cb(37712,37688,394,37704)}if((f|0)==0){cb(37728,37688,395,37704)}if((g|0)==0){cb(37744,37688,396,37704)}if((h|0)==0){cb(37760,37688,397,37704)}if((l|0)==0){cb(37784,37688,398,37704)}if((m|0)==0){cb(37808,37688,399,37704)}if((j|0)==0){cb(37832,37688,400,37704)}else{i=b;return}}function Su(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Tu(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function Uu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==1){c[l>>2]=c[b+8>>2];n=l+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];qt(17,0,o,39512,l);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];l=g+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];qt(17,0,o,39712,g);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];g=j+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];qt(17,0,o,39616,j);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];j=m+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];qt(17,0,o,39464,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];qt(17,0,o,39776,f);i=e;return}}function Vu(a){a=a|0;var b=0;b=i;WX(c[a+12>>2]|0);WX(c[a+4>>2]|0);WX(c[a+8>>2]|0);i=b;return}function Wu(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Fd(a|0,d|0)|0;qd(d|0)|0;ae[c[21066]&255](0);i=b;return}function Xu(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[5575]=.5;h[5561]=1.0;h[5598]=.25;h[5573]=2.0;h[5600]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[11158]=A;B=c[d>>2]|0;c[11088]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[11088]=D;if((C|0)<(B|0)){C=D}else{break}}}c[11086]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[5576]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[5576]=F;G=F}else{G=E}D=c[d>>2]|0;c[11088]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[11088]=I;if((H|0)>=(D|0)){break a}E=+h[5576];H=I}}}while(0);D=C+1|0;c[11086]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[5580]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[5545]=0.0;h[5547]=0.0;h[5551]=0.0;h[5608]=0.0;c[11084]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[5545]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[5547]+ +h[B>>3]*F;h[5547]=E;F=+h[I>>3];M=+h[5551]+F*F;h[5551]=M;F=+h[H>>3];h[5608]=+h[5608]+F*F;H=A+1|0;c[11084]=H;F=+h[5545];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[11154]=A;E=G/J;h[5597]=E;C=c[d>>2]|0;c[11088]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[5605]=0.0;h[5607]=0.0;I=c[b>>2]|0;c[11084]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[5574]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[5605]=ba;ca=E+aa*aa;h[5607]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[11084]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[11154]=A;h[5597]=E;h[5547]=Z;h[5551]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[11088]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[11084]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[11084]=A+1;da=+h[5547];ea=+h[5551];ga=+h[5545]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[5596]=K;c[11182]=0;h[5604]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[11182]=C;K=+h[5561]/+V(+ga);h[5576]=K;h[5599]=0.0;h[5601]=0.0;B=c[b>>2]|0;c[11084]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[5599]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[5599]=oa;pa=+h[5601]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[5601]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[5547];L=+h[5545];N=+h[5576];D=D+1|0;la=ma}c[11084]=B+1;ia=+h[5545];ja=pa;ka=oa}N=+h[5575];L=ka*N*ka;h[5592]=L;J=ja*N*ja;h[5593]=J;h[5552]=J+(L+ia*(+h[5608]+ia*N));N=+h[5573];h[44424>>3]=N*ka*ia;h[44432>>3]=N*ja*ia;h[44440>>3]=L-J;h[44448>>3]=ka*ja;la=44456|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[11084]=10;la=c[d>>2]|0;c[11088]=1;if((la|0)>=1){D=1;while(1){h[5592]=0.0;h[5593]=0.0;h[5594]=0.0;A=c[b>>2]|0;c[11084]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[5592]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[5593]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[5594]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[11084]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[5598]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[5592]*+h[5594];h[t+(U+D<<3)>>3]=+h[5593]*+h[5594];J=+h[5592];L=+h[5593];h[t+(P+D<<3)>>3]=+h[5598]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[5575]*+h[5592]*+h[5593];na=D+1|0;c[11088]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[11084]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[11096]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[11084]=B;if((la|0)<(D|0)){la=B}else{break}}}c[11092]=1;la=1;do{D=c[d>>2]|0;c[11100]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[11100]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[11088]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[11088]=D+1}na=c[11158]|0;c[11086]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[5572]=0.0;ma=c[d>>2]|0;c[11088]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[5572]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[11088]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[5572]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[11088]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[5572];Ca=Ca+1|0}c[11088]=ta+1}Ca=B+1|0;c[11086]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[11088]=1;if((A|0)<1){break}else{Ea=1}while(1){h[5572]=0.0;B=c[b>>2]|0;c[11086]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[5572]=N;Ca=na+1|0;c[11086]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[11088]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[11086]=1;if((A|0)>=1){ta=1;while(1){h[5572]=0.0;c[11084]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[5572]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[11084]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[11086]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[11092]=la;}while((la|0)<6);la=c[l>>2]|0;c[11088]=1;h[5572]=0.0;c[11084]=1;L=+h[5575];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[44496+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[44496+(A+ -1<<3)>>3]+L;h[5572]=L;A=A+1|0;}while((A|0)<6);h[5552]=+h[5552]- +h[5562]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[5592]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[5593]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[5594]=O;h[44424>>3]=+h[44424>>3]-J-N*(O+K);h[44456>>3]=+h[44456>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[5592]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[5593]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[5594]=J;h[44432>>3]=+h[44432>>3]-O-N*(K-J);h[44464>>3]=+h[44464>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[5592]=J;h[44440>>3]=+h[44512>>3]+(+h[44440>>3]-J- +h[44504>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[5592]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[5593]=K;Oa=+h[5575];h[44448>>3]=+h[44448>>3]-J-K*Oa;h[44472>>3]=+h[44472>>3]- +h[44520>>3]+ +h[44528>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[5592]=K;h[44480>>3]=+h[44480>>3]-Oa*K;h[5572]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[11088]=la+1;c[11084]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[44496+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[44496+(ta+ -1<<3)>>3]+N;h[5572]=N;ta=ta+1|0;c[11084]=ta;}while((ta|0)<6);K=+h[5580];h[5582]=K*+h[5552]+ +h[5562]+N;J=+h[5573];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[5592]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[5593]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[5594]=R;T=R+(K*+h[44424>>3]+O+S);h[44664>>3]=T;O=K*+h[44456>>3]+S-R;h[44696>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[5592]=R;S=+h[I>>3]*+h[ma>>3];h[5593]=S;Z=+h[Ma>>3]*+h[Na>>3];h[5594]=Z;h[44672>>3]=K*+h[44432>>3]+R+S-Z;h[44704>>3]=K*+h[44464>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[5592]=Z;R=+h[44504>>3]+(Z+K*+h[44440>>3])- +h[44512>>3];h[44680>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[5592]=Z;h[44688>>3]=Z+K*+h[44448>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[44472>>3]+ +h[44520>>3]- +h[44528>>3];h[44712>>3]=J;h[44720>>3]=+h[5580]*+h[44480>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[5582]+T+R+O+J;h[5572]=K;h[5602]=K;h[5603]=K;c[11190]=0;J=+h[5600]/50.0;h[5576]=J;h[5562]=+h[5561];c[11084]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[44504>>3]=Z;W=+Y(+Pa);h[44512>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[44496+(Ma+ -1<<3)>>3]=Z;Q=+h[44504>>3]*G+ +h[44512>>3]*W;h[44496+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[44512>>3];ca=+h[44504>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[44656+(Ma<<3)>>3]*+h[44496+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[5603]=Ra;c[11190]=Na;h[5592]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[5593]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[11086]=10;h[5572]=Ra;h[5581]=Pa;h[5606]=O;c[11084]=50;if((Xa|0)==49){h[5593]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[5592]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[5578]=0.0;if(Ya!=Za){S=Ya-Ua;h[5592]=S;T=Za-Ua;h[5593]=T;R=+h[5575]*(S-T)/(S+T);h[5578]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[5581]=R;T=+X(+R);h[44504>>3]=T;S=+Y(+R);h[44512>>3]=S;c[11086]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[44496+(Na+ -1<<3)>>3]=T;W=+h[44504>>3]*G+ +h[44512>>3]*S;h[44496+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[44512>>3];N=+h[44504>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[5603]=0.0;c[11086]=1;Na=1;do{ma=Na+ -1|0;Ma=44496+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[44416+(ma<<3)>>3]*+h[Ma>>3];h[5603]=+h[5603]+ +h[44656+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[11086]=10;Na=c[l>>2]|0;c[11088]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[44496+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[11086]=6;c[11088]=Na+1}h[5571]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[5545]=0.0;h[5592]=0.0;h[5593]=0.0;Ma=c[b>>2]|0;c[11084]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[44504>>3]*+h[la>>3]+ +h[44512>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[5545]=+h[5545]+G*G;bb=+h[5592]+ +h[la>>3]*+h[ta>>3];h[5592]=bb;G=+h[ta>>3];cb=+h[5593]+G*G;h[5593]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[11084]=Ma+1;$a=cb;ab=bb}ma=c[11182]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[5604];S=+h[5602];h[5604]=G>=S?G:S}S=+h[5603];if(!(S>=0.0)){db=-S}else{db=S}G=+h[5604];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[5604]=S;c[11084]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[5576]=N;R=+h[5571]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[5580];la=ta+1|0;c[11084]=la;if((ta|0)>=(Na|0)){break b}S=+h[5593];G=+h[5592];ta=la}}}while(0);Na=c[d>>2]|0;c[11088]=1;if((Na|0)>=1){Ma=1;while(1){h[5572]=0.0;ta=c[b>>2]|0;c[11086]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[5572]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[11086]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[5571]*+h[p+(la+ -1+Ma<<3)>>3]- +h[5580]*+h[q+(Ma+ -1<<3)>>3]);h[5576]=G;c[11084]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[5576];I=I+1|0}c[11084]=la+1}I=Ma+1|0;c[11088]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[5551]=0.0;h[5547]=0.0;Ma=c[b>>2]|0;c[11084]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[5551]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[5547]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[11084]=Ma+1;hb=kb;ib=jb}S=+h[5545];G=S*ib-hb*hb;h[5596]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[44392]=1;C=c[l>>2]|0;c[11088]=1;if((C|0)<1){lb=44488;mb=+h[5561];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[44496+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[11086]=6;c[11088]=C+1;lb=44488;mb=+h[5561];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function Yu(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[5628]=.5;h[5624]=1.0;h[5640]=6.283185307179586;z=+h[n>>3];h[5637]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[11262]=A;c[11270]=0;B=c[d>>2]|0;c[11222]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[11222]=B+1}c[11220]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[5629]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[5629]=F;G=F}else{G=z}H=c[d>>2]|0;c[11222]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[5629];I=I+1|0}c[11222]=H+1}I=B+1|0;c[11220]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[5612]=0.0;D=c[b>>2]|0;c[11218]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[5612]=+h[5612]+G*G;A=p+1|0;c[11218]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[11222]=1;if((p|0)>=1){D=1;while(1){h[5629]=0.0;h[5627]=0.0;y=c[b>>2]|0;c[11220]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[5629]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[5627]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[11220]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[5629]=G;h[5627]=+h[g>>3]*L;g=c[b>>2]|0;c[11218]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[5627]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[5629];H=H+1|0}c[11218]=g+1}H=D+1|0;c[11222]=H;if((D|0)<(p|0)){D=H}else{break}}}h[5613]=0.0;h[5615]=0.0;h[5622]=0.0;D=c[b>>2]|0;c[11218]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[5613]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[5615]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[5622]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[11218]=D+1;O=R;P=T;Q=S}S=+h[5612];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[5633]=U;h[5629]=0.0;if(Q*Q>S*.99*O){h[5629]=+h[5624]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[5628]*U*Z);h[5625]=P;if(O*+h[5637]<P*P*.01){h[5629]=+h[5624]}n=c[b>>2]|0;c[11218]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[5633]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[5629]*U;if((D|0)>=(n|0)){break}e=D;P=+h[5633];D=D+1|0;p=e}c[11218]=n+1;_=0}while(1){n=_+1|0;c[11270]=n;h[5612]=0.0;h[5615]=0.0;h[5616]=0.0;p=c[b>>2]|0;c[11218]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[5612]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[5615]=da;Z=+h[H>>3];ea=P+Z*Z;h[5616]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[11218]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[5629]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[5634]=U;D=c[b>>2]|0;c[11218]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[5634];U=+h[5615];O=+h[5612];g=g+1|0;H=e}c[11218]=D+1}H=c[d>>2]|0;c[11222]=1;if((H|0)>=1){g=1;while(1){h[5627]=0.0;p=c[b>>2]|0;c[11220]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[5627]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[11220]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[5627]=O;e=c[b>>2]|0;c[11218]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[5627];l=l+1|0}c[11218]=e+1}l=g+1|0;c[11222]=l;if((g|0)<(H|0)){g=l}else{break}}}h[5617]=0.0;h[5618]=0.0;h[5619]=0.0;h[5620]=0.0;h[5621]=0.0;g=c[b>>2]|0;c[11218]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[5617]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[5618]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[5619]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[5620]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[5621]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[11218]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[5628];O=U*na;h[5617]=O;P=U*ma-O;h[5620]=P;Z=O+la+P;h[5641]=Z;h[5643]=Z;h[5642]=Z;c[11272]=0;a[44912]=1;W=+h[5640]/50.0;h[5629]=W;c[11218]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[5643]=wa;c[11272]=p;h[5638]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[5639]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[5632]=ta;h[5623]=ua;h[5626]=va;h[5625]=wa;c[11218]=50;h[5642]=wa;if((za|0)==0){h[5638]=wa;ga=74}else if((za|0)==49){h[5639]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[5639]}h[5630]=0.0;S=+h[5638];if(S!=Ba){Q=S-Aa;h[5638]=Q;S=Ba-Aa;h[5639]=S;T=U*(Q-S)/(Q+S);h[5630]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[5632]=T;S=+X(+T);h[5623]=S;Q=+Y(+T);h[5626]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[5625]=T;p=c[b>>2]|0;c[11218]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[5623]*+h[y>>3]+ +h[5626]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[5626];Q=+h[5623];H=H+1|0;g=e}c[11218]=p+1;Da=+h[5625]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[5641];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function Zu(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[45368]=1;a[45360]=1;c[45380>>2]=6;yM(45376)|0;e=c[d>>2]|0;c[11338]=1;if((e|0)>=1){d=1;do{PL(45496,b+(d+ -1)|0,1)|0;o=c[11338]|0;d=o+1|0;c[11338]=d;}while((o|0)<(e|0))}gM()|0;e=c[g>>2]|0;if((e|0)==1){c[45404>>2]=a[45360]&1?6:0;yM(45400)|0;PL(45496,h,4)|0;gM()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[45428>>2]=a[45360]&1?6:0;yM(45424)|0;PL(45496,h,4)|0;PL(45496,j,4)|0;gM()|0}j=c[k>>2]|0;if((j|0)==1){c[45452>>2]=a[45360]&1?6:0;yM(45448)|0;PL(45496,l,8)|0;gM()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[45476>>2]=a[45360]&1?6:0;yM(45472)|0;PL(45496,l,8)|0;PL(45496,m,8)|0;gM()|0}if((c[f>>2]|0)==2){xL(45504,0)|0}else{i=n;return 0}return 0}



function dX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=VX((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=VX((l<<2)+4|0)|0;if((p|0)==0){WX(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}jX(d,e)|0;e=jX(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{F=v;G=w;H=x;I=y;J=z;K=E;L=0;M=B;break}}break};case 1:{E=u+ -2|0;c[h>>2]=E;N=c[D+(E<<2)>>2]|0;if(k){E=c[(c[c[N+4>>2]>>2]|0)+20>>2]|0;O=u+ -3|0;c[h>>2]=O;c[N+20>>2]=(c[D+(O<<2)>>2]|0)+E;F=v;G=-1;H=x;I=y;J=z;K=A;L=0;M=B;break b}else{E=u+ -3|0;c[h>>2]=E;O=c[D+(E<<2)>>2]|0;E=u+ -4|0;c[h>>2]=E;N=(O|0)==0;F=N&1;G=N?w:c[D+(E<<2)>>2]|0;H=x;I=y;J=z;K=A;L=0;M=B;break b}break};case 4:{E=u+ -2|0;c[h>>2]=E;N=c[D+(E<<2)>>2]|0;E=u+ -3|0;c[h>>2]=E;F=v;G=w;H=c[D+(E<<2)>>2]|0;I=y;J=z;K=A;L=0;M=(N|0)>-1?N:B;break};case 6:{N=u+ -2|0;c[h>>2]=N;E=c[D+(N<<2)>>2]|0;N=0;do{P=A+(N<<2)|0;N=N+1|0}while((c[P>>2]|0)>-1);c[P>>2]=E<<1|1;c[A+(N<<2)>>2]=-1;O=0;while(1){if((c[p+(O<<2)>>2]|0)>-1){O=O+1|0}else{break}}c[p+(O+ -1<<2)>>2]=-1;F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break};case 3:{N=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;Q=c[D+(u+ -4<<2)>>2]|0;R=u+ -5|0;c[h>>2]=R;if(k){S=c[Q+4>>2]|0;T=Q+16|0;c[Q+20>>2]=(c[(c[S>>2]|0)+20>>2]|0)+(c[D+(R<<2)>>2]|0)+(c[(c[S+4>>2]|0)+20>>2]|0)+((c[T>>2]|0)>0?2:0);U=T;V=c[h>>2]|0}else{U=Q+16|0;V=R}R=c[D+(V+ -1<<2)>>2]|0;Q=V+ -2|0;c[h>>2]=Q;T=c[D+(Q<<2)>>2]|0;Q=V+ -3|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;if((c[U>>2]|0)<=0){F=1;G=w;H=x;I=y;J=z;K=R;L=0;M=B;break b}if(k){W=0}else{mX(b,N,T)|0;c[(c[r>>2]|0)+(T<<2)>>2]=1;T=mX(b,E,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;W=T}F=1;G=w;H=x;I=y;J=z+2|0;K=R;L=W;M=B;break};case 0:{R=u+ -2|0;c[h>>2]=R;T=c[D+(R<<2)>>2]|0;R=T;S=T+12|0;E=c[S>>2]|0;if((E|0)>-1){N=0;do{X=A+(N<<2)|0;N=N+1|0}while((c[X>>2]|0)>-1);c[X>>2]=E<<1;c[A+(N<<2)>>2]=-1;do{if(!k){O=0;while(1){if((c[p+(O<<2)>>2]|0)>-1){O=O+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((O|0)<=0){break}Q=VX((O<<2)+4|0)|0;Y=Q;if((Q|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=Q+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=jX(d,c[S>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=jX(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[T>>2]|0;do{if((E|0)==2){N=c[T+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ka=1}else{ka=a[N+12|0]&1}ea=jX(d,ka)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}}else{ea=jX(d,B)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=jX(d,a[N+12|0]&1)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}}ea=jX(d,T)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=jX(d,1)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=jX(d,c[N>>2]|0)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=jX(d,0)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}if(!((c[A>>2]|0)>-1)){if((a[N+12|0]&1)==0){la=0;ma=w;na=x;oa=y;pa=z;qa=0;ra=B;break}}if(k){sa=w;ta=y;ua=0}else{ea=lX(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[N+12|0]&1)==0?v:1;if((w|0)>-1){N=c[t>>2]|0;fa=0;while(1){va=N+(fa<<2)|0;wa=fa+1|0;if((c[va>>2]|0)>-1){fa=wa}else{break}}c[va>>2]=B;c[N+(wa<<2)>>2]=w;c[N+(fa+2<<2)>>2]=-1;xa=-1;ya=y+1|0}else{xa=w;ya=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;Q=Y;Y=0;do{O=(Q|0)/2|0;if((Q&1|0)==0){c[da+(O*12|0)>>2]=B}else{c[da+(O*12|0)+4>>2]=B}Y=Y+1|0;Q=c[A+(Y<<2)>>2]|0;}while((Q|0)>-1)}c[A>>2]=-1;sa=xa;ta=ya;ua=ea}c[A>>2]=-1;la=0;ma=sa;na=x+1|0;oa=ta;pa=z+1|0;qa=ua;ra=x}else if((E|0)==1){Q=c[T+4>>2]|0;Y=c[Q>>2]|0;da=c[Q+4>>2]|0;Q=jX(d,T)|0;if((Q|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Q;ra=B;break}Q=jX(d,5)|0;if((Q|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Q;ra=B;break}Q=jX(d,da)|0;if((Q|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Q;ra=B;break}Q=jX(d,0)|0;if((Q|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Q;ra=B;break}Q=Y+20|0;fa=jX(d,(c[Q>>2]|0)+x|0)|0;if((fa|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=fa;ra=B;break}if((c[Q>>2]|0)>0){Q=(c[da+20>>2]|0)>0;za=(Q&1)+x|0;Aa=Q?x:-1}else{za=x;Aa=-1}Q=jX(d,Aa)|0;if((Q|0)!=0){la=v;ma=w;na=za;oa=y;pa=z;qa=Q;ra=B;break}Q=jX(d,4)|0;if((Q|0)!=0){la=v;ma=w;na=za;oa=y;pa=z;qa=Q;ra=B;break}Q=jX(d,Y)|0;if((Q|0)!=0){la=v;ma=w;na=za;oa=y;pa=z;qa=Q;ra=B;break}la=v;ma=w;na=za;oa=y;pa=z;qa=jX(d,0)|0;ra=B}else if((E|0)==3){Q=c[T+4>>2]|0;Y=c[Q>>2]|0;da=c[Q+4>>2]|0;Q=(c[A>>2]|0)>-1;fa=x+1|0;N=jX(d,Q?fa:x)|0;if((N|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=N;ra=B;break}N=jX(d,Q?x:B)|0;if((N|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=N;ra=B;break}N=jX(d,A)|0;if((N|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=N;ra=B;break}N=jX(d,(c[A>>2]|0)>>>31^1)|0;if((N|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=N;ra=B;break}N=jX(d,T)|0;if((N|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=N;ra=B;break}N=da;da=jX(d,N)|0;if((da|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=da;ra=B;break}da=Y;Y=jX(d,da)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=jX(d,3)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=jX(d,N)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=jX(d,0)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=jX(d,2)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=jX(d,da)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=jX(d,0)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}if((c[A>>2]|0)>-1){if(k){Ba=w;Ca=y;Da=0}else{Y=lX(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;N=0;while(1){Ea=da+(N<<2)|0;Fa=N+1|0;if((c[Ea>>2]|0)>-1){N=Fa}else{break}}c[Ea>>2]=B;c[da+(Fa<<2)>>2]=w;c[da+(N+2<<2)>>2]=-1;Ga=-1;Ha=y+1|0}else{Ga=w;Ha=y}ea=c[A>>2]|0;if((ea|0)>-1){Q=c[s>>2]|0;O=ea;ea=0;do{ia=(O|0)/2|0;if((O&1|0)==0){c[Q+(ia*12|0)>>2]=B}else{c[Q+(ia*12|0)+4>>2]=B}ea=ea+1|0;O=c[A+(ea<<2)>>2]|0;}while((O|0)>-1)}c[A>>2]=-1;Ba=Ga;Ca=Ha;Da=Y}c[A>>2]=-1;Ia=Ba;Ja=fa;Ka=Ca;La=z+1|0;Ma=Da;Na=x}else{Ia=w;Ja=x;Ka=y;La=z;Ma=0;Na=B}if((c[T+16>>2]|0)<=0){la=v;ma=Ia;na=Ja;oa=Ka;pa=La;qa=Ma;ra=Na;break}la=v;ma=Ia;na=Ja+2|0;oa=Ka;pa=La;qa=Ma;ra=Ja+1|0}else if((E|0)==0){O=c[c[T+4>>2]>>2]|0;if(!((O|0)>-1|(O|0)==-4)){la=v;ma=w;na=x;oa=y;pa=z;qa=0;ra=B;break}if(!((c[A>>2]|0)>-1)){la=v;ma=w;na=x;oa=y;pa=z;qa=0;ra=B;break}if(k){c[T+20>>2]=1;Oa=w;Pa=y;Qa=0}else{O=lX(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;Q=0;while(1){Ra=ea+(Q<<2)|0;Sa=Q+1|0;if((c[Ra>>2]|0)>-1){Q=Sa}else{break}}c[Ra>>2]=B;c[ea+(Sa<<2)>>2]=w;c[ea+(Q+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}fa=c[A>>2]|0;if((fa|0)>-1){Y=c[s>>2]|0;N=fa;fa=0;do{da=(N|0)/2|0;if((N&1|0)==0){c[Y+(da*12|0)>>2]=B}else{c[Y+(da*12|0)+4>>2]=B}fa=fa+1|0;N=c[A+(fa<<2)>>2]|0;}while((N|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=O}c[A>>2]=-1;la=v;ma=Oa;na=x+1|0;oa=Pa;pa=z+1|0;qa=Qa;ra=x}else{la=v;ma=w;na=x;oa=y;pa=z;qa=0;ra=B}}while(0);R=c[S>>2]|0;if((R|0)>-1){Va=0}else{F=la;G=ma;H=na;I=oa;J=pa;K=A;L=qa;M=ra;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=R;c[p+(Va<<2)>>2]=-1;F=la;G=ma;H=na;I=oa;J=pa;K=A;L=qa;M=ra;break};case 5:{S=u+ -2|0;c[h>>2]=S;T=c[D+(S<<2)>>2]|0;if(!k){F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break b}S=c[T+4>>2]|0;c[T+20>>2]=(c[(c[S+4>>2]|0)+20>>2]|0)+(c[(c[S>>2]|0)+20>>2]|0);F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break};default:{F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(L|0)==0){u=D;v=F;w=G;x=H;y=I;z=J;A=K;B=M}else{Z=G;_=I;$=J;aa=K;ba=L;ca=M;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;M=e;e=0;do{L=(M|0)/2|0;if((M&1|0)==0){c[n+(L*12|0)>>2]=ca}else{c[n+(L*12|0)+4>>2]=ca}e=e+1|0;M=c[aa+(e<<2)>>2]|0;}while((M|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}M=c[f+36>>2]|0;e=0;while(1){Ya=M+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[M+(Za<<2)>>2]=Z;c[M+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;WX(m);WX(p);o=ba;i=g;return o|0}function eX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=gX(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=gX(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=eX(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else if((a|0)==3){l=c[g+4>>2]|0;j=eX(c[l>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=l+4|0}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function fX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{WX(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}WX(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){WX(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){WX(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}WX(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{WX(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}WX(m)}m=c[d+32>>2]|0;if((m|0)!=0){WX(m)}m=c[d+20>>2]|0;if((m|0)!=0){WX(m)}m=c[d+36>>2]|0;if((m|0)!=0){WX(m)}WX(d);i=b;return}function gX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=VX(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){WX(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=VX((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function hX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=tX(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=tX(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=tX(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function iX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=jX(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=jX(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=jX(a,s)|0}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=jX(a,s)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==1){r=c[o+4>>2]|0;s=jX(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=jX(a,c[r+4>>2]|0)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function jX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=YX(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;jX(a,b)|0;i=d;return 0}return 0}function kX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;jX(d,e)|0;e=jX(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==1){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=tX(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}H=tX(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;c[F>>2]=0;I=F+4|0;c[I>>2]=0;x=jX(d,c[D>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=jX(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=jX(d,I)|0;if((x|0)!=0){v=s;w=x;break a}x=jX(d,1)|0;if((x|0)!=0){v=s;w=x;break a}x=jX(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}J=r;K=s;L=F;M=jX(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;x=c[F+8>>2]|0;y=c[F>>2]|0;I=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=I;P=y;Q=s+1|0;R=(c[g>>2]|0)+x|0}else{if(!((y|0)==-3)){N=r;O=I;P=y;Q=s;R=x;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=I;P=-3;Q=s;R=x;break}c[h+(I<<2)>>2]=1;N=0;O=I;P=-3;Q=s;R=x}}while(0);x=tX(b,0,0,1,32)|0;I=x;do{if((x|0)==0){S=0}else{y=tX(b,0,0,1,20)|0;c[x+4>>2]=y;if((y|0)==0){S=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=I}}while(0);c[t>>2]=S;I=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=I;break}c[k>>2]=R;J=N;K=Q;L=t;M=I}else if((z|0)==2){I=c[u+4>>2]|0;x=jX(d,c[I>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=jX(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[I>>2]|0;y=c[I+4>>2]|0;F=c[I+8>>2]|0;D=a[I+12|0]|0;I=tX(b,0,0,1,32)|0;if((I|0)==0){G=40;break b}E=tX(b,0,0,1,16)|0;H=I+4|0;c[H>>2]=E;if((E|0)==0){G=40;break b}c[I>>2]=2;c[I+8>>2]=-1;c[I+12>>2]=-1;c[E>>2]=x;c[E+4>>2]=y;c[E+8>>2]=F;F=E+12|0;a[F]=a[F]&-2|D&1;c[I+16>>2]=c[x+16>>2];c[t>>2]=I;A=s;B=r;t=c[H>>2]|0;s=A;r=B;continue b}else if((z|0)==3){H=c[u+4>>2]|0;I=c[H>>2]|0;x=H+4|0;D=c[x>>2]|0;F=tX(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}E=tX(b,0,0,1,8)|0;y=F+4|0;c[y>>2]=E;if((E|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[E>>2]=I;c[(c[y>>2]|0)+4>>2]=D;c[F+16>>2]=(c[D+16>>2]|0)+(c[I+16>>2]|0);c[t>>2]=F;F=c[y>>2]|0;y=jX(d,c[x>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}y=jX(d,0)|0;if((y|0)!=0){v=s;w=y;break a}y=jX(d,F+4|0)|0;if((y|0)!=0){v=s;w=y;break a}y=jX(d,1)|0;if((y|0)!=0){v=s;w=y;break a}y=jX(d,c[H>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}J=r;K=s;L=F;M=jX(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function lX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=tX(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=tX(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=tX(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=tX(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function mX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=tX(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=tX(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=tX(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=tX(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function nX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function oX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=124360}else{j=b;k=124360;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((xY(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,124648,g|0)|0)+1|0;i=d;return h|0}function pX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=VX(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=VX(y)|0;if((z|0)==0){A=12;break}BY(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=ZW(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((EW(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((EW(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((EW(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((EW(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(EW(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(EW(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(EW(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(EW(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){BY(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=ZW(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((EW(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((EW(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((EW(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((EW(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(EW(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(EW(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(EW(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(EW(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((IW(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=UW(X)|0;qb=_a+24|0;if((IW(fb,c[qb>>2]|0)|0)!=0){break}fb=SW(X)|0;if((IW(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((IW(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=SW(X)|0;if((IW(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=UW(X)|0;if((IW(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}WX(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=rX(0,0)|0;if((S|0)==0){A=12;break}R=tX(S,0,0,0,32)|0;Q=R;if((R|0)==0){sX(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=VX(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=VX(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=VX(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){BY(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){BY(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=ZW(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((EW(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((EW(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((EW(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((EW(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(EW(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(EW(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(EW(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(EW(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=tX(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=tX(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;qX(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((uY(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=ZW(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=ZW(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((EW(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((EW(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((EW(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((EW(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(EW(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(EW(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(EW(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(EW(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((IW(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=UW(tc)|0;aa=Ca+24|0;if((IW(qa,c[aa>>2]|0)|0)!=0){break}qa=SW(tc)|0;if((IW(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((IW(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=SW(tc)|0;if((IW(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=UW(tc)|0;if((IW(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=tX(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=tX(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){sX(S);if((Eb|0)!=0){WX(O)}if((Kb|0)!=0){WX(Kb)}if((Lb|0)==0){A=12;break a}WX(N);A=12;break a}else if((sa|0)==67){sX(S);if((Eb|0)!=0){WX(O)}if((Kb|0)!=0){WX(Kb)}if((Lb|0)==0){A=12;break a}WX(N);A=12;break a}else if((sa|0)==169){sX(S);if((Eb|0)!=0){WX(O)}if((Kb|0)!=0){WX(Kb)}if((Lb|0)==0){A=12;break a}WX(N);A=12;break a}else if((sa|0)==176){sX(S);if((Eb|0)!=0){WX(O)}if((Kb|0)!=0){WX(Kb)}if((Lb|0)==0){A=12;break a}WX(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);sX(S);if((Jb|0)!=0){WX(Jb)}if((Gb|0)!=0){WX(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}WX(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}qX(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}WX(m);p=A;i=g;return p|0}function qX(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function rX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=XX(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function sX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;WX(e);i=b;return}else{f=d}while(1){WX(c[f>>2]|0);d=c[f+4>>2]|0;WX(f);if((d|0)==0){break}else{f=d}}e=a;WX(e);i=b;return}function tX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=VX(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=VX(p)|0;c[o>>2]=r;if((r|0)==0){WX(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}BY(m|0,0,h|0)|0;j=m;i=g;return j|0}function uX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((vX(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function vX(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function wX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function xX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function yX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function zX(a){a=a|0;i=i;return}function AX(a){a=a|0;c[a>>2]=124664;i=i;return}function BX(a){a=a|0;var b=0;b=i;zb(a|0);bY(a);i=b;return}function CX(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function DX(a){a=a|0;i=i;return 124680}function EX(a){a=a|0;i=i;return}function FX(a){a=a|0;i=i;return}function GX(a){a=a|0;i=i;return}function HX(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function IX(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function JX(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function KX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=OX(b,124792,124848,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;De[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function LX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function MX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;De[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function NX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;De[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;De[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function OX(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;me[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Zd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function PX(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;me[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Zd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Zd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Zd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Zd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function QX(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Zd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;me[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function RX(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function SX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;me[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;me[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function TX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;me[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function UX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function VX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[31274]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=125136+(j<<2)|0;l=125136+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[31274]=f&~(1<<h)}else{if(n>>>0<(c[125112>>2]|0)>>>0){ed()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{ed()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[125104>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=125136+(r<<2)|0;o=125136+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[31274]=f&~(1<<t)}else{if(n>>>0<(c[125112>>2]|0)>>>0){ed()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{ed()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[125104>>2]|0;if((n|0)!=0){f=c[125116>>2]|0;e=n>>>3;n=e<<1;g=125136+(n<<2)|0;m=c[31274]|0;j=1<<e;do{if((m&j|0)==0){c[31274]=m|j;u=125136+(n+2<<2)|0;v=g}else{e=125136+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[125112>>2]|0)>>>0)){u=e;v=h;break}ed()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[125104>>2]=o;c[125116>>2]=s;p=k;i=b;return p|0}n=c[125100>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[125400+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[125112>>2]|0;if(h>>>0<k>>>0){ed()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){ed()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){ed()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){ed()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){ed()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{ed()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=125400+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<h);break a}else{if(s>>>0<(c[125112>>2]|0)>>>0){ed()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[125112>>2]|0)>>>0){ed()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[125104>>2]|0;if((h|0)!=0){s=c[125116>>2]|0;k=h>>>3;h=k<<1;f=125136+(h<<2)|0;m=c[31274]|0;g=1<<k;do{if((m&g|0)==0){c[31274]=m|g;A=125136+(h+2<<2)|0;B=f}else{k=125136+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[125112>>2]|0)>>>0)){A=k;B=e;break}ed()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[125104>>2]=t;c[125116>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[125100>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[125400+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[125400+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[125104>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[125112>>2]|0;if(t>>>0<f>>>0){ed()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){ed()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){ed()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){ed()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){ed()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{ed()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=125400+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<e);break c}else{if(t>>>0<(c[125112>>2]|0)>>>0){ed()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[125112>>2]|0)>>>0){ed()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=125136+(t<<2)|0;s=c[31274]|0;r=1<<e;do{if((s&r|0)==0){c[31274]=s|r;S=125136+(t+2<<2)|0;T=f}else{e=125136+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[125112>>2]|0)>>>0)){S=e;T=k;break}ed()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=125400+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[125100>>2]|0;l=1<<U;if((f&l|0)==0){c[125100>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[125112>>2]|0;if(W>>>0<k>>>0){ed()}if(r>>>0<k>>>0){ed()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[125104>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[125116>>2]|0;if(W>>>0>15){c[125116>>2]=X+q;c[125104>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[125104>>2]=0;c[125116>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[125108>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[125108>>2]=W;X=c[125120>>2]|0;c[125120>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[31392]|0)==0){X=cd(30)|0;if((X+ -1&X|0)==0){c[125576>>2]=X;c[125572>>2]=X;c[125580>>2]=-1;c[125584>>2]=-1;c[125588>>2]=0;c[125540>>2]=0;c[31392]=(sc(0)|0)&-16^1431655768;break}else{ed()}}}while(0);X=q+48|0;W=c[125576>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[125536>>2]|0;do{if((U|0)!=0){T=c[125528>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[125540>>2]&4|0)==0){U=c[125120>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=125544|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[125108>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[125572>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[125528>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[125536>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[125576>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[125540>>2]=c[125540>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[125528>>2]|0)+ga|0;c[125528>>2]=ia;if(ia>>>0>(c[125532>>2]|0)>>>0){c[125532>>2]=ia}ia=c[125120>>2]|0;W=125544|0;i:do{if((ia|0)==0){aa=c[125112>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[125112>>2]=fa}c[125544>>2]=fa;c[125548>>2]=ga;c[125556>>2]=0;c[125132>>2]=c[31392];c[125128>>2]=-1;aa=0;do{ha=aa<<1;$=125136+(ha<<2)|0;c[125136+(ha+3<<2)>>2]=$;c[125136+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[125120>>2]=fa+ja;c[125108>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[125124>>2]=c[125584>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[125108>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[125120>>2]=ia+na;c[125108>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[125124>>2]=c[125584>>2];break i}}while(0);if(fa>>>0<(c[125112>>2]|0)>>>0){c[125112>>2]=fa}aa=fa+ga|0;$=125544|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[125120>>2]|0)){ca=(c[125108>>2]|0)+X|0;c[125108>>2]=ca;c[125120>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[125116>>2]|0)){ca=(c[125104>>2]|0)+X|0;c[125104>>2]=ca;c[125116>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=125136+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[125112>>2]|0)>>>0){ed()}if((c[V+12>>2]|0)==(ha|0)){break}ed()}}while(0);if((L|0)==(V|0)){c[31274]=c[31274]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[125112>>2]|0)>>>0){ed()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}ed()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[125112>>2]|0)>>>0){ed()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){ed()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{ed()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=125400+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<t);break k}else{if(T>>>0<(c[125112>>2]|0)>>>0){ed()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[125112>>2]|0)>>>0){ed()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=125136+(Z<<2)|0;t=c[31274]|0;T=1<<ca;do{if((t&T|0)==0){c[31274]=t|T;xa=125136+(Z+2<<2)|0;ya=ea}else{ca=125136+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[125112>>2]|0)>>>0)){xa=ca;ya=V;break}ed()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=125400+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[125100>>2]|0;L=1<<za;if((ea&L|0)==0){c[125100>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[125112>>2]|0;if(Ba>>>0<S>>>0){ed()}if(T>>>0<S>>>0){ed()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=125544|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[125120>>2]=fa+Ha;c[125108>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[125124>>2]=c[125584>>2];c[ba+4>>2]=27;X=125544|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[125544>>2]=fa;c[125548>>2]=ga;c[125556>>2]=0;c[125552>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=125136+(da<<2)|0;aa=c[31274]|0;f=1<<M;do{if((aa&f|0)==0){c[31274]=aa|f;Ia=125136+(da+2<<2)|0;Ja=ha}else{M=125136+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[125112>>2]|0)>>>0)){Ia=M;Ja=T;break}ed()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=125400+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[125100>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[125100>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[125112>>2]|0;if(Ma>>>0<f>>>0){ed()}if(M>>>0<f>>>0){ed()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[125108>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[125108>>2]=W;ia=c[125120>>2]|0;c[125120>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}



function NC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;XC(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){tt(0,81272,n)}if(p){ec=vd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;pt(23,0,81416,m);YC(q);ZC(q,e,8);if(!(_C(q)|0)){c[l>>2]=e;tt(0,81456,l)}EN(r);l=q;$C(l,r)|0;GN(s,r);while(1){e=$C(l,r)|0;if(!(AO(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}zO(t,81536,r);fO(s,t)|0;QN(t)}t=vd(lO(s)|0)|0;aD(q);QN(s);QN(r);bD(q);fc=t}if((fc|0)==0){pt(23,0,81624,g);dD(o);i=f;return}EN(u);EN(v);c[k>>2]=fc;pt(23,0,81544,k);k=Xb(fc|0,81536)|0;if((k|0)!=0){g=k;do{k=$X(12)|0;KN(k,g);t=mO(k,81576,0)|0;kO(w,k,0,t);RN(u,w)|0;QN(w);kO(x,k,t+1|0,(XN(k)|0)+~t|0);RN(v,x)|0;QN(x);RN(vC(o,u)|0,v)|0;t=lO(u)|0;k=lO(v)|0;c[j>>2]=t;c[j+4>>2]=k;pt(23,0,81584,j);g=Xb(0,81536)|0;}while((g|0)!=0)}WX(fc);fc=a+12|0;KN(y,79672);g=vC(fc,y)|0;KN(z,79672);if((cD(o,z)|0)==0){KN(B,79672);gc=1;hc=0;ic=vC(fc,B)|0}else{KN(A,79672);gc=0;hc=1;ic=vC(o,A)|0}RN(g,ic)|0;if(gc){QN(B)}if(hc){QN(A)}QN(z);QN(y);KN(C,79544);y=vC(fc,C)|0;KN(D,79544);if((cD(o,D)|0)==0){KN(F,79544);jc=1;kc=0;lc=vC(fc,F)|0}else{KN(E,79544);jc=0;kc=1;lc=vC(o,E)|0}RN(y,lc)|0;if(jc){QN(F)}if(kc){QN(E)}QN(D);QN(C);KN(G,79576);C=vC(fc,G)|0;KN(H,79576);if((cD(o,H)|0)==0){KN(J,79576);mc=1;nc=0;oc=vC(fc,J)|0}else{KN(I,79576);mc=0;nc=1;oc=vC(o,I)|0}RN(C,oc)|0;if(mc){QN(J)}if(nc){QN(I)}QN(H);QN(G);KN(K,79608);G=vC(fc,K)|0;KN(L,79608);if((cD(o,L)|0)==0){KN(N,79608);pc=0;qc=1;rc=vC(fc,N)|0}else{KN(M,79608);pc=1;qc=0;rc=vC(o,M)|0}RN(G,rc)|0;if(qc){QN(N)}if(pc){QN(M)}QN(L);QN(K);KN(O,79640);K=vC(fc,O)|0;KN(P,79640);if((cD(o,P)|0)==0){KN(R,79640);sc=1;tc=0;uc=vC(fc,R)|0}else{KN(Q,79640);sc=0;tc=1;uc=vC(o,Q)|0}RN(K,uc)|0;if(sc){QN(R)}if(tc){QN(Q)}QN(P);QN(O);KN(S,79704);O=vC(fc,S)|0;KN(T,79704);if((cD(o,T)|0)==0){KN(V,79704);vc=1;wc=0;xc=vC(fc,V)|0}else{KN(U,79704);vc=0;wc=1;xc=vC(o,U)|0}RN(O,xc)|0;if(vc){QN(V)}if(wc){QN(U)}QN(T);QN(S);KN(W,79744);S=vC(fc,W)|0;KN(X,79744);if((cD(o,X)|0)==0){KN(Z,79744);yc=1;zc=0;Ac=vC(fc,Z)|0}else{KN(Y,79744);yc=0;zc=1;Ac=vC(o,Y)|0}RN(S,Ac)|0;if(yc){QN(Z)}if(zc){QN(Y)}QN(X);QN(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=OC(Y,_)|0;KN($,78648);Ac=vC(yc,$)|0;c[aa>>2]=Z;yc=OC(Y,aa)|0;KN(ba,78504);if((cD(o,vC(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=OC(Y,ea)|0;KN(fa,78648);Bc=1;Cc=0;Dc=vC(yc,fa)|0}else{c[ca>>2]=Z;yc=OC(Y,ca)|0;KN(da,78504);Bc=0;Cc=1;Dc=vC(o,vC(yc,da)|0)|0}RN(Ac,Dc)|0;if(Bc){QN(fa)}if(Cc){QN(da)}QN(ba);QN($);c[ga>>2]=Z;Ac=OC(zc,ga)|0;KN(ha,78648);yc=vC(Ac,ha)|0;c[ia>>2]=Z;Ac=OC(zc,ia)|0;KN(ja,78504);if((cD(o,vC(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=OC(zc,ma)|0;KN(na,78648);Ec=1;Fc=0;Gc=vC(Ac,na)|0}else{c[ka>>2]=Z;Ac=OC(zc,ka)|0;KN(la,78504);Ec=0;Fc=1;Gc=vC(o,vC(Ac,la)|0)|0}RN(yc,Gc)|0;if(Ec){QN(na)}if(Fc){QN(la)}QN(ja);QN(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=OC(Hc,oa)|0;KN(pa,78648);ja=vC(ha,pa)|0;c[qa>>2]=Z;ha=OC(Hc,qa)|0;KN(ra,78504);if((cD(o,vC(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=OC(Hc,ua)|0;KN(va,78648);Ic=1;Jc=0;Kc=vC(ha,va)|0}else{c[sa>>2]=Z;ha=OC(Hc,sa)|0;KN(ta,78504);Ic=0;Jc=1;Kc=vC(o,vC(ha,ta)|0)|0}RN(ja,Kc)|0;if(Ic){QN(va)}if(Jc){QN(ta)}QN(ra);QN(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=OC(X,wa)|0;KN(xa,78648);ra=vC(pa,xa)|0;c[ya>>2]=Z;pa=OC(X,ya)|0;KN(za,78504);if((cD(o,vC(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=OC(X,Ca)|0;KN(Da,78648);Lc=1;Mc=0;Nc=vC(pa,Da)|0}else{c[Aa>>2]=Z;pa=OC(X,Aa)|0;KN(Ba,78504);Lc=0;Mc=1;Nc=vC(o,vC(pa,Ba)|0)|0}RN(ra,Nc)|0;if(Lc){QN(Da)}if(Mc){QN(Ba)}QN(za);QN(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=OC(Z,Ea)|0;KN(Fa,78648);Ba=vC(za,Fa)|0;c[Ga>>2]=xa;za=OC(Z,Ga)|0;KN(Ha,78504);if((cD(o,vC(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=OC(Z,Ka)|0;KN(La,78648);Oc=1;Pc=0;Qc=vC(za,La)|0}else{c[Ia>>2]=xa;za=OC(Z,Ia)|0;KN(Ja,78504);Oc=0;Pc=1;Qc=vC(o,vC(za,Ja)|0)|0}RN(Ba,Qc)|0;if(Oc){QN(La)}if(Pc){QN(Ja)}QN(Ha);QN(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=OC(xa,Ma)|0;KN(Na,78648);Ja=vC(Ha,Na)|0;c[Oa>>2]=Fa;Ha=OC(xa,Oa)|0;KN(Pa,78504);if((cD(o,vC(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=OC(xa,Sa)|0;KN(Ta,78648);Rc=1;Sc=0;Tc=vC(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=OC(xa,Qa)|0;KN(Ra,78504);Rc=0;Sc=1;Tc=vC(o,vC(Ha,Ra)|0)|0}RN(Ja,Tc)|0;if(Rc){QN(Ta)}if(Sc){QN(Ra)}QN(Pa);QN(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=OC(Fa,Ua)|0;KN(Va,78648);Ra=vC(Pa,Va)|0;c[Wa>>2]=Na;Pa=OC(Fa,Wa)|0;KN(Xa,78504);if((cD(o,vC(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=OC(Fa,_a)|0;KN($a,78648);Uc=1;Vc=0;Wc=vC(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=OC(Fa,Ya)|0;KN(Za,78504);Uc=0;Vc=1;Wc=vC(o,vC(Pa,Za)|0)|0}RN(Ra,Wc)|0;if(Uc){QN($a)}if(Vc){QN(Za)}QN(Xa);QN(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=OC(Na,ab)|0;KN(bb,78648);Za=vC(Xa,bb)|0;c[cb>>2]=Va;Xa=OC(Na,cb)|0;KN(db,78504);if((cD(o,vC(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=OC(Na,gb)|0;KN(hb,78648);Xc=1;Yc=0;Zc=vC(Xa,hb)|0}else{c[eb>>2]=Va;Xa=OC(Na,eb)|0;KN(fb,78504);Xc=0;Yc=1;Zc=vC(o,vC(Xa,fb)|0)|0}RN(Za,Zc)|0;if(Xc){QN(hb)}if(Yc){QN(fb)}QN(db);QN(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=OC(Va,ib)|0;KN(jb,78648);fb=vC(db,jb)|0;c[kb>>2]=bb;db=OC(Va,kb)|0;KN(lb,78504);if((cD(o,vC(db,lb)|0)|0)==0){c[ob>>2]=bb;db=OC(Va,ob)|0;KN(pb,78648);_c=1;$c=0;ad=vC(db,pb)|0}else{c[mb>>2]=bb;db=OC(Va,mb)|0;KN(nb,78504);_c=0;$c=1;ad=vC(o,vC(db,nb)|0)|0}RN(fb,ad)|0;if(_c){QN(pb)}if($c){QN(nb)}QN(lb);QN(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=OC(bb,qb)|0;KN(rb,78648);nb=vC(lb,rb)|0;c[sb>>2]=jb;lb=OC(bb,sb)|0;KN(tb,78504);if((cD(o,vC(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=OC(bb,wb)|0;KN(xb,78648);bd=1;cd=0;dd=vC(lb,xb)|0}else{c[ub>>2]=jb;lb=OC(bb,ub)|0;KN(vb,78504);bd=0;cd=1;dd=vC(o,vC(lb,vb)|0)|0}RN(nb,dd)|0;if(bd){QN(xb)}if(cd){QN(vb)}QN(tb);QN(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=OC(jb,yb)|0;KN(zb,78648);vb=vC(tb,zb)|0;c[Ab>>2]=rb;tb=OC(jb,Ab)|0;KN(Bb,78504);if((cD(o,vC(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=OC(jb,Eb)|0;KN(Fb,78648);ed=1;fd=0;gd=vC(tb,Fb)|0}else{c[Cb>>2]=rb;tb=OC(jb,Cb)|0;KN(Db,78504);ed=0;fd=1;gd=vC(o,vC(tb,Db)|0)|0}RN(vb,gd)|0;if(ed){QN(Fb)}if(fd){QN(Db)}QN(Bb);QN(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=OC(rb,Gb)|0;KN(Hb,78648);Db=vC(Bb,Hb)|0;c[Ib>>2]=zb;Bb=OC(rb,Ib)|0;KN(Jb,78504);if((cD(o,vC(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=OC(rb,Mb)|0;KN(Nb,78648);hd=0;id=1;jd=vC(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=OC(rb,Kb)|0;KN(Lb,78504);hd=1;id=0;jd=vC(o,vC(Bb,Lb)|0)|0}RN(Db,jd)|0;if(id){QN(Nb)}if(hd){QN(Lb)}QN(Jb);QN(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=OC(zb,Ob)|0;KN(Pb,78648);Lb=vC(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=OC(zb,Qb)|0;KN(Rb,78504);if((cD(o,vC(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=OC(zb,Ub)|0;KN(Vb,78648);kd=1;ld=0;md=vC(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=OC(zb,Sb)|0;KN(Tb,78504);kd=0;ld=1;md=vC(o,vC(Jb,Tb)|0)|0}RN(Lb,md)|0;if(kd){QN(Vb)}if(ld){QN(Tb)}QN(Rb);QN(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=OC(b,Wb)|0;KN(Yb,78648);Pb=vC(Hb,Yb)|0;c[Zb>>2]=a;Hb=OC(b,Zb)|0;KN(_b,78504);if((cD(o,vC(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=OC(b,bc)|0;KN(cc,78648);nd=1;od=0;pd=vC(Hb,cc)|0}else{c[$b>>2]=a;Hb=OC(b,$b)|0;KN(ac,78504);nd=0;od=1;pd=vC(o,vC(Hb,ac)|0)|0}RN(Pb,pd)|0;if(nd){QN(cc)}if(od){QN(ac)}QN(_b);QN(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}pt(23,0,81608,h);QN(v);QN(u);dD(o);i=f;return}function OC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=vF(a,f,b)|0;l=c[k>>2]|0;fz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}xF(j,a,b);yF(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];wF(g,e);zF(j);j=c[f>>2]|0;AF(a,j,k,BF(g)|0);k=CF(g)|0;zF(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function PC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=ZD(a,f,b)|0;l=c[k>>2]|0;fz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}$D(j,a,b);aE(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];_D(g,e);bE(j);j=c[f>>2]|0;cE(a,j,k,dE(g)|0);k=eE(g)|0;bE(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function QC(a,b){a=a|0;b=b|0;var c=0;c=i;RN(b,a)|0;i=c;return}function RC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;QD(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];ID(a,f);i=e;return}function SC(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=GD(a,b)|0;i=c;return d|0}function TC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;JD(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];ID(a,e);i=d;return}function UC(a){a=a|0;var b=0,c=0;b=i;c=DD(a)|0;i=b;return c|0}function VC(a){a=a|0;var b=0;b=i;aI(a);i=b;return}function WC(a){a=a|0;var b=0;b=i;PH(a);i=b;return}function XC(a,b){a=a|0;b=b|0;b=i;wG(a,0);i=b;return}function YC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;NO(d);e=a;c[e>>2]=81676;f=d;c[f>>2]=81696;d=a+8|0;FP(a,81708|0,d);c[e>>2]=81676;c[f>>2]=81696;OB(d);i=b;return}function ZC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(nz(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){EO(d,4);i=e;return}else{CO(d,0);i=e;return}}function _C(a){a=a|0;var b=0,c=0;b=i;c=yD(a+8|0)|0;i=b;return c|0}function $C(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=xD(a,b,LO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function aD(a){a=a|0;var b=0;b=i;if((pz(a+8|0)|0)!=0){i=b;return}EO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function bD(a){a=a|0;var b=0;b=i;CD(a,81704);IO(a+108|0);i=b;return}function cD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=eD(a,b)|0;i=c;return d|0}function dD(a){a=a|0;var b=0;b=i;EH(a);i=b;return}function eD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=gD(a)|0;fz(e);if((f|0)==0){g=0;i=d;return g|0}h=hD(a)|0;a=f;while(1){f=a+16|0;if(iD(h,b,f)|0){j=a}else{if(!(jD(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;fz(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function fD(a){a=a|0;var b=0,c=0;b=i;c=Sy(pD(a+4|0)|0)|0;i=b;return c|0}function gD(a){a=a|0;var b=0,d=0;b=i;d=c[(fD(a)|0)>>2]|0;i=b;return d|0}function hD(a){a=a|0;var b=0,c=0;b=i;c=nD(a+8|0)|0;i=b;return c|0}function iD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kD(0,b,c)|0;i=a;return d|0}function jD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kD(0,b,c)|0;i=a;return d|0}function kD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=lD(b,c)|0;i=a;return d|0}function lD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(nO(a,b)|0)<0;i=c;return d|0}function mD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=sY(a,b,c)|0;i=d;return e|0}function nD(a){a=a|0;var b=0,c=0;b=i;c=oD(a)|0;i=b;return c|0}function oD(a){a=a|0;i=i;return a|0}function pD(a){a=a|0;var b=0,c=0;b=i;c=qD(a)|0;i=b;return c|0}function qD(a){a=a|0;i=i;return a|0}function rD(a,b){a=a|0;b=b|0;var c=0;a=i;c=tD(0,b,0)|0;i=a;return c|0}function sD(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function tD(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$X(b)|0;i=c;return a|0}function uD(a){a=a|0;var b=0,c=0;b=i;c=xY(a|0)|0;i=b;return c|0}function vD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=wD(b,c,e)|0;i=d;return g|0}function wD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=jA(0,a,b)|0;i=c;return(d?b:a)|0}function xD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;KP(f,a,1);if(!(NP(f)|0)){i=e;return a|0}eO(b);f=0;while(1){g=TO(JO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if($z(g,-1)|0){h=2;j=f;break}k=f+1|0;l=aA(g)|0;if(eA(l,d)|0){h=0;j=k;break}gO(b,l);if((ON(b)|0)==-17){h=4;j=k;break}else{f=k}}EO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function yD(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function zD(a){a=a|0;var b=0;b=i;bD(a);bY(a);i=b;return}function AD(a){a=a|0;var b=0;b=i;bD(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function BD(a){a=a|0;var b=0;b=i;zD(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function CD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Pz(a+8|0);i=d;return}function DD(a){a=a|0;var b=0,d=0;b=i;d=ED((c[a>>2]|0)+16|0)|0;i=b;return d|0}function ED(a){a=a|0;var b=0,c=0;b=i;c=FD(a)|0;i=b;return c|0}function FD(a){a=a|0;i=i;return a|0}function GD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(HD(a,b)|0)^1;i=c;return d|0}function HD(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function ID(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];PD(a,e);i=d;return}function JD(a,b){a=a|0;b=b|0;var c=0;c=i;KD(a,LD(b)|0);i=c;return}function KD(a,b){a=a|0;b=b|0;var c=0;c=i;OD(a,b);i=c;return}function LD(a){a=a|0;var b=0,c=0;b=i;c=Sy(MD(a+4|0)|0)|0;i=b;return c|0}function MD(a){a=a|0;var b=0,c=0;b=i;c=ND(a)|0;i=b;return c|0}function ND(a){a=a|0;i=i;return a|0}function OD(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function PD(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function QD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=SD(b)|0;RD(f,b,d,h,LD(b)|0);JD(g,b);do{if(GD(f,g)|0){h=TD(b)|0;if(UD(h,d,VD(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);JD(a,b);i=e;return}function RD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;fz(h);a:do{if((e|0)==0){j=f}else{k=TD(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(YD(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;fz(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;fz(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);KD(a,j);i=g;return}function SD(a){a=a|0;var b=0,d=0;b=i;d=c[(LD(a)|0)>>2]|0;i=b;return d|0}function TD(a){a=a|0;var b=0,c=0;b=i;c=WD(a+8|0)|0;i=b;return c|0}function UD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kD(0,b,c)|0;i=a;return d|0}function VD(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function WD(a){a=a|0;var b=0,c=0;b=i;c=XD(a)|0;i=b;return c|0}function XD(a){a=a|0;i=i;return a|0}function YD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kD(0,b,c)|0;i=a;return d|0}function ZD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=SD(h)|0;fz(e);if((a|0)==0){j=LD(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(kD(0,d,a)|0){m=l;j=c[m>>2]|0;fz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(kD(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function _D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];VE(a,e);i=d;return}function $D(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=AE(d)|0;d=CE(n,1)|0;DE(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];BE(j,d,h);EE(0,tE((FE(j)|0)+16|0)|0,e);e=GE(j)|0;a[e+4|0]=1;HE(0,rE((FE(j)|0)+28|0)|0);a[e+5|0]=1;IE(m,j);aE(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];_D(b,g);bE(m);bE(j);i=f;return}function aE(a,b){a=a|0;b=b|0;var c=0;c=i;yE(a,b);i=c;return}function bE(a){a=a|0;var b=0;b=i;nE(a);i=b;return}function cE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fz(f);c[e>>2]=0;fz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=jE(a)|0;b=c[c[e>>2]>>2]|0;fz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(LD(a)|0)>>2]|0;RA(e,c[d>>2]|0);d=kE(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function dE(a){a=a|0;var b=0,d=0;b=i;d=c[(hE(a)|0)>>2]|0;i=b;return d|0}function eE(a){a=a|0;var b=0,d=0;b=i;d=fE(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function fE(a){a=a|0;var b=0,c=0;b=i;c=gE(a)|0;i=b;return c|0}function gE(a){a=a|0;i=i;return a|0}function hE(a){a=a|0;var b=0,c=0;b=i;c=iE(a)|0;i=b;return c|0}function iE(a){a=a|0;i=i;return a|0}function jE(a){a=a|0;i=i;return a|0}function kE(a){a=a|0;var b=0,c=0;b=i;c=lE(a+8|0)|0;i=b;return c|0}function lE(a){a=a|0;var b=0,c=0;b=i;c=mE(a)|0;i=b;return c|0}function mE(a){a=a|0;i=i;return a|0}function nE(a){a=a|0;var b=0;b=i;oE(a,0);i=b;return}function oE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=fE(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}qE(pE(e)|0,f);i=d;return}function pE(a){a=a|0;var b=0,c=0;b=i;c=xE(a)|0;i=b;return c|0}function qE(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;sE(f,tE(d+16|0)|0)}if((d|0)==0){i=e;return}uE(c[b>>2]|0,d,1);i=e;return}function rE(a){a=a|0;i=i;return a|0}function sE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;wE(d,0,c);i=b;return}function tE(a){a=a|0;i=i;return a|0}function uE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;vE(0,b,0);i=c;return}function vE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bY(b);i=c;return}function wE(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QN(c);i=b;return}function xE(a){a=a|0;i=i;return a+4|0}function yE(a,b){a=a|0;b=b|0;var c=0;c=i;zE(a,b);i=c;return}function zE(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function AE(a){a=a|0;var b=0,c=0;b=i;c=TE(a+4|0)|0;i=b;return c|0}function BE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];LE(a,b,f);i=e;return}function CE(a,b){a=a|0;b=b|0;var c=0;a=i;c=KE(0,b,0)|0;i=a;return c|0}function DE(a,b){a=a|0;b=b|0;var c=0;c=i;JE(a,b);i=c;return}function EE(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}GN(b,c);i=a;return}function FE(a){a=a|0;var b=0,d=0;b=i;d=c[(hE(a)|0)>>2]|0;i=b;return d|0}function GE(a){a=a|0;var b=0,c=0;b=i;c=pE(a)|0;i=b;return c|0}function HE(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function IE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;yE(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];_D(h,f);aE(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];_D(a,e);bE(h);i=d;return}function JE(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function KE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$X(b<<5)|0;i=c;return a|0}function LE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(NE(g)|0)>>2]|0;g=OE(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];ME(b,a,f);i=e;return}function ME(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];PE(a,b,f);i=e;return}function NE(a){a=a|0;i=i;return a|0}function OE(a){a=a|0;i=i;return a|0}function PE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(RE(g)|0)>>2]|0;g=SE(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];QE(b,a,f);i=e;return}function QE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(RE(f)|0)>>2];f=SE(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function RE(a){a=a|0;i=i;return a|0}function SE(a){a=a|0;i=i;return a|0}function TE(a){a=a|0;var b=0,c=0;b=i;c=UE(a)|0;i=b;return c|0}function UE(a){a=a|0;i=i;return a|0}function VE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=eE(WE(b)|0)|0;h=SE(GE(WE(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];ME(g,a,e);i=d;return}function WE(a){a=a|0;i=i;return c[a>>2]|0}function XE(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function YE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];dF(a,e);i=d;return}function ZE(a,b){a=a|0;b=b|0;var c=0;c=i;_E(a,$E(b)|0);i=c;return}function _E(a,b){a=a|0;b=b|0;var c=0;c=i;cF(a,b);i=c;return}function $E(a){a=a|0;var b=0,c=0;b=i;c=Sy(aF(a+4|0)|0)|0;i=b;return c|0}function aF(a){a=a|0;var b=0,c=0;b=i;c=bF(a)|0;i=b;return c|0}function bF(a){a=a|0;i=i;return a|0}function cF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function dF(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function eF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=gF(b)|0;fF(f,b,d,h,$E(b)|0);ZE(g,b);do{if(hF(f,g)|0){h=iF(b)|0;if(iD(h,d,jF(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);ZE(a,b);i=e;return}function fF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;fz(h);a:do{if((e|0)==0){j=f}else{k=iF(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(jD(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;fz(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;fz(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);_E(a,j);i=g;return}function gF(a){a=a|0;var b=0,d=0;b=i;d=c[($E(a)|0)>>2]|0;i=b;return d|0}function hF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(XE(a,b)|0)^1;i=c;return d|0}function iF(a){a=a|0;var b=0,c=0;b=i;c=kF(a+8|0)|0;i=b;return c|0}function jF(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function kF(a){a=a|0;var b=0,c=0;b=i;c=lF(a)|0;i=b;return c|0}function lF(a){a=a|0;i=i;return a|0}function mF(a,b){a=a|0;b=b|0;b=i;i=i+8|0;nF(a,b);i=b;return}function nF(a,b){a=a|0;b=b|0;b=i;oF(a,0);i=b;return}function oF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;pF(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;qF(f,0,e);e=LD(b)|0;c[(jE(b)|0)>>2]=e;i=d;return}function pF(a){a=a|0;var b=0;b=i;tF(a);i=b;return}function qF(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;rF(b,c,f);i=e;return}function rF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JB(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;sF(d,b,f);i=e;return}function sF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JB(e)|0)>>2];i=d;return}function tF(a){a=a|0;var b=0;b=i;uF(a);i=b;return}function uF(a){a=a|0;var b=0;b=i;MB(a);i=b;return}function vF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=vG(h)|0;fz(e);if((a|0)==0){j=IF(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(cz(0,d,a)|0){m=l;j=c[m>>2]|0;fz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(cz(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function wF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];tG(a,e);i=d;return}function xF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=_F(d)|0;d=aG(n,1)|0;bG(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];$F(j,d,h);cG(0,bB((dG(j)|0)+16|0)|0,e);e=eG(j)|0;a[e+4|0]=1;fG(0,TF((dG(j)|0)+20|0)|0);a[e+5|0]=1;gG(m,j);yF(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];wF(b,g);zF(m);zF(j);i=f;return}function yF(a,b){a=a|0;b=b|0;var c=0;c=i;YF(a,b);i=c;return}function zF(a){a=a|0;var b=0;b=i;OF(a);i=b;return}function AF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fz(f);c[e>>2]=0;fz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=HF(a)|0;b=c[c[e>>2]>>2]|0;fz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(IF(a)|0)>>2]|0;RA(e,c[d>>2]|0);d=JF(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function BF(a){a=a|0;var b=0,d=0;b=i;d=c[(FF(a)|0)>>2]|0;i=b;return d|0}function CF(a){a=a|0;var b=0,d=0;b=i;d=DF(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function DF(a){a=a|0;var b=0,c=0;b=i;c=EF(a)|0;i=b;return c|0}function EF(a){a=a|0;i=i;return a|0}function FF(a){a=a|0;var b=0,c=0;b=i;c=GF(a)|0;i=b;return c|0}function GF(a){a=a|0;i=i;return a|0}function HF(a){a=a|0;i=i;return a|0}function IF(a){a=a|0;var b=0,c=0;b=i;c=Sy(MF(a+4|0)|0)|0;i=b;return c|0}function JF(a){a=a|0;var b=0,c=0;b=i;c=KF(a+8|0)|0;i=b;return c|0}function KF(a){a=a|0;var b=0,c=0;b=i;c=LF(a)|0;i=b;return c|0}function LF(a){a=a|0;i=i;return a|0}function MF(a){a=a|0;var b=0,c=0;b=i;c=NF(a)|0;i=b;return c|0}function NF(a){a=a|0;i=i;return a|0}function OF(a){a=a|0;var b=0;b=i;PF(a,0);i=b;return}function PF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=DF(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}RF(QF(e)|0,f);i=d;return}function QF(a){a=a|0;var b=0,c=0;b=i;c=XF(a)|0;i=b;return c|0}function RF(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;SF(f,TF(d+20|0)|0)}if((d|0)==0){i=e;return}UF(c[b>>2]|0,d,1);i=e;return}function SF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;WF(d,0,c);i=b;return}function TF(a){a=a|0;i=i;return a|0}function UF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;VF(0,b,0);i=c;return}function VF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bY(b);i=c;return}function WF(a,b,c){a=a|0;b=b|0;c=c|0;b=i;dD(c);i=b;return}function XF(a){a=a|0;i=i;return a+4|0}function YF(a,b){a=a|0;b=b|0;var c=0;c=i;ZF(a,b);i=c;return}function ZF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function _F(a){a=a|0;var b=0,c=0;b=i;c=rG(a+4|0)|0;i=b;return c|0}function $F(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];jG(a,b,f);i=e;return}function aG(a,b){a=a|0;b=b|0;var c=0;a=i;c=iG(0,b,0)|0;i=a;return c|0}function bG(a,b){a=a|0;b=b|0;var c=0;c=i;hG(a,b);i=c;return}function cG(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function dG(a){a=a|0;var b=0,d=0;b=i;d=c[(FF(a)|0)>>2]|0;i=b;return d|0}function eG(a){a=a|0;var b=0,c=0;b=i;c=QF(a)|0;i=b;return c|0}function fG(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}XC(b,a);i=a;return}function gG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;YF(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];wF(h,f);yF(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];wF(a,e);zF(h);i=d;return}function hG(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function iG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$X(b<<5)|0;i=c;return a|0}function jG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(lG(g)|0)>>2]|0;g=mG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];kG(b,a,f);i=e;return}function kG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];nG(a,b,f);i=e;return}function lG(a){a=a|0;i=i;return a|0}function mG(a){a=a|0;i=i;return a|0}function nG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pG(g)|0)>>2]|0;g=qG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];oG(b,a,f);i=e;return}function oG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(pG(f)|0)>>2];f=qG(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function pG(a){a=a|0;i=i;return a|0}function qG(a){a=a|0;i=i;return a|0}function rG(a){a=a|0;var b=0,c=0;b=i;c=sG(a)|0;i=b;return c|0}function sG(a){a=a|0;i=i;return a|0}function tG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=CF(uG(b)|0)|0;h=qG(eG(uG(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];kG(g,a,e);i=d;return}function uG(a){a=a|0;i=i;return c[a>>2]|0}function vG(a){a=a|0;var b=0,d=0;b=i;d=c[(IF(a)|0)>>2]|0;i=b;return d|0}function wG(a,b){a=a|0;b=b|0;b=i;i=i+8|0;xG(a,b);i=b;return}function xG(a,b){a=a|0;b=b|0;b=i;yG(a,0);i=b;return}function yG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;zG(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;AG(f,0,e);e=$E(b)|0;c[(BG(b)|0)>>2]=e;i=d;return}function zG(a){a=a|0;var b=0;b=i;EG(a);i=b;return}function AG(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;CG(b,c,f);i=e;return}function BG(a){a=a|0;i=i;return a|0}function CG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JB(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;DG(d,b,f);i=e;return}function DG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JB(e)|0)>>2];i=d;return}function EG(a){a=a|0;var b=0;b=i;FG(a);i=b;return}function FG(a){a=a|0;var b=0;b=i;MB(a);i=b;return}function GG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=gF(h)|0;fz(e);if((a|0)==0){j=$E(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(kD(0,d,a)|0){m=l;j=c[m>>2]|0;fz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(kD(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function HG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CH(a,e);i=d;return}function IG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hH(d)|0;d=jH(n,1)|0;kH(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];iH(j,d,h);lH(0,tE((mH(j)|0)+16|0)|0,e);e=nH(j)|0;a[e+4|0]=1;oH(0,_G((mH(j)|0)+28|0)|0);a[e+5|0]=1;pH(m,j);JG(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];HG(b,g);KG(m);KG(j);i=f;return}function JG(a,b){a=a|0;b=b|0;var c=0;c=i;fH(a,b);i=c;return}function KG(a){a=a|0;var b=0;b=i;VG(a);i=b;return}function LG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fz(f);c[e>>2]=0;fz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=BG(a)|0;b=c[c[e>>2]>>2]|0;fz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[($E(a)|0)>>2]|0;RA(e,c[d>>2]|0);d=SG(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function MG(a){a=a|0;var b=0,d=0;b=i;d=c[(QG(a)|0)>>2]|0;i=b;return d|0}function NG(a){a=a|0;var b=0,d=0;b=i;d=OG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function OG(a){a=a|0;var b=0,c=0;b=i;c=PG(a)|0;i=b;return c|0}function PG(a){a=a|0;i=i;return a|0}function QG(a){a=a|0;var b=0,c=0;b=i;c=RG(a)|0;i=b;return c|0}function RG(a){a=a|0;i=i;return a|0}function SG(a){a=a|0;var b=0,c=0;b=i;c=TG(a+8|0)|0;i=b;return c|0}function TG(a){a=a|0;var b=0,c=0;b=i;c=UG(a)|0;i=b;return c|0}function UG(a){a=a|0;i=i;return a|0}function VG(a){a=a|0;var b=0;b=i;WG(a,0);i=b;return}function WG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=OG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}YG(XG(e)|0,f);i=d;return}function XG(a){a=a|0;var b=0,c=0;b=i;c=eH(a)|0;i=b;return c|0}function YG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;ZG(f,_G(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;$G(f,tE(d+16|0)|0)}if((d|0)==0){i=e;return}aH(c[b>>2]|0,d,1);i=e;return}function ZG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;dH(d,0,c);i=b;return}function _G(a){a=a|0;i=i;return a|0}function $G(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;cH(d,0,c);i=b;return}function aH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bH(0,b,0);i=c;return}function bH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bY(b);i=c;return}function cH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QN(c);i=b;return}function dH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QN(c);i=b;return}function eH(a){a=a|0;i=i;return a+4|0}function fH(a,b){a=a|0;b=b|0;var c=0;c=i;gH(a,b);i=c;return}function gH(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function hH(a){a=a|0;var b=0,c=0;b=i;c=AH(a+4|0)|0;i=b;return c|0}function iH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];sH(a,b,f);i=e;return}function jH(a,b){a=a|0;b=b|0;var c=0;a=i;c=rH(0,b,0)|0;i=a;return c|0}function kH(a,b){a=a|0;b=b|0;var c=0;c=i;qH(a,b);i=c;return}function lH(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}GN(b,c);i=a;return}function mH(a){a=a|0;var b=0,d=0;b=i;d=c[(QG(a)|0)>>2]|0;i=b;return d|0}function nH(a){a=a|0;var b=0,c=0;b=i;c=XG(a)|0;i=b;return c|0}function oH(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}EN(b);i=a;return}function pH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;fH(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];HG(h,f);JG(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];HG(a,e);KG(h);i=d;return}function qH(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function rH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$X(b*40|0)|0;i=c;return a|0}function sH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uH(g)|0)>>2]|0;g=vH(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];tH(b,a,f);i=e;return}function tH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wH(a,b,f);i=e;return}function uH(a){a=a|0;i=i;return a|0}function vH(a){a=a|0;i=i;return a|0}function wH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yH(g)|0)>>2]|0;g=zH(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xH(b,a,f);i=e;return}function xH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yH(f)|0)>>2];f=zH(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function yH(a){a=a|0;i=i;return a|0}function zH(a){a=a|0;i=i;return a|0}function AH(a){a=a|0;var b=0,c=0;b=i;c=BH(a)|0;i=b;return c|0}function BH(a){a=a|0;i=i;return a|0}function CH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=NG(DH(b)|0)|0;h=zH(nH(DH(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];tH(g,a,e);i=d;return}function DH(a){a=a|0;i=i;return c[a>>2]|0}function EH(a){a=a|0;var b=0;b=i;FH(a);i=b;return}function FH(a){a=a|0;var b=0;b=i;GH(a);i=b;return}function GH(a){a=a|0;var b=0;b=i;HH(a,gF(a)|0);i=b;return}function HH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;fz(d);if((b|0)==0){i=d;return}HH(a,c[b>>2]|0);HH(a,c[b+4>>2]|0);e=hH(a)|0;IH(e,JH(b+16|0)|0);aH(e,b,1);i=d;return}function IH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;KH(d,0,c);i=b;return}function JH(a){a=a|0;i=i;return a|0}function KH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;LH(c);i=b;return}function LH(a){a=a|0;var b=0;b=i;MH(a);i=b;return}function MH(a){a=a|0;var b=0;b=i;NH(a);i=b;return}function NH(a){a=a|0;var b=0;b=i;OH(a);i=b;return}function OH(a){a=a|0;var b=0;b=i;QN(a+12|0);QN(a);i=b;return}function PH(a){a=a|0;var b=0;b=i;QH(a+180|0);QH(a+168|0);QH(a+156|0);QH(a+144|0);QH(a+132|0);QH(a+120|0);QH(a+108|0);QH(a+96|0);QH(a+84|0);QH(a+72|0);QH(a+60|0);QH(a+48|0);QH(a+36|0);QH(a+24|0);dD(a+12|0);dD(a);i=b;return}function QH(a){a=a|0;var b=0;b=i;RH(a);i=b;return}function RH(a){a=a|0;var b=0;b=i;SH(a);i=b;return}function SH(a){a=a|0;var b=0;b=i;TH(a);i=b;return}function TH(a){a=a|0;var b=0;b=i;UH(a,vG(a)|0);i=b;return}function UH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;fz(d);if((b|0)==0){i=d;return}UH(a,c[b>>2]|0);UH(a,c[b+4>>2]|0);e=_F(a)|0;VH(e,WH(b+16|0)|0);UF(e,b,1);i=d;return}function VH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;XH(d,0,c);i=b;return}function WH(a){a=a|0;i=i;return a|0}function XH(a,b,c){a=a|0;b=b|0;c=c|0;b=i;YH(c);i=b;return}function YH(a){a=a|0;var b=0;b=i;ZH(a);i=b;return}function ZH(a){a=a|0;var b=0;b=i;_H(a);i=b;return}function _H(a){a=a|0;var b=0;b=i;$H(a);i=b;return}function $H(a){a=a|0;var b=0;b=i;dD(a+4|0);i=b;return}function aI(a){a=a|0;var b=0;b=i;bI(a);i=b;return}function bI(a){a=a|0;var b=0;b=i;cI(a);i=b;return}function cI(a){a=a|0;var b=0;b=i;dI(a,SD(a)|0);i=b;return}function dI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;fz(d);if((b|0)==0){i=d;return}dI(a,c[b>>2]|0);dI(a,c[b+4>>2]|0);e=AE(a)|0;eI(e,FD(b+16|0)|0);uE(e,b,1);i=d;return}function eI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;fI(d,0,c);i=b;return}function fI(a,b,c){a=a|0;b=b|0;c=c|0;b=i;gI(c);i=b;return}function gI(a){a=a|0;var b=0;b=i;hI(a);i=b;return}function hI(a){a=a|0;var b=0;b=i;iI(a);i=b;return}function iI(a){a=a|0;var b=0;b=i;jI(a);i=b;return}function jI(a){a=a|0;var b=0;b=i;QN(a);i=b;return}function kI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;lI(a);nI(g,b);oI(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];mI(a,f,e);i=d;return a|0}function lI(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;HH(a,gF(a)|0);c[(SG(a)|0)>>2]=0;d=$E(a)|0;c[(BG(a)|0)>>2]=d;fz(b);c[d>>2]=0;i=b;return}function mI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;wI(h,a);if(!(xI(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];pI(j,g);o=zI(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];yI(l,a,f,o);AI(b)|0;}while(xI(b,d)|0);i=e;return}function nI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;uI(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];pI(a,e);i=d;return}function oI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;qI(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];pI(a,e);i=d;return}function pI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];tI(a,e);i=d;return}function qI(a,b){a=a|0;b=b|0;var c=0;c=i;rI(a,fD(b)|0);i=c;return}function rI(a,b){a=a|0;b=b|0;var c=0;c=i;sI(a,b);i=c;return}function sI(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function tI(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function uI(a,b){a=a|0;b=b|0;var d=0;d=i;rI(a,c[(vI(b)|0)>>2]|0);i=d;return}function vI(a){a=a|0;i=i;return a|0}function wI(a,b){a=a|0;b=b|0;var c=0;c=i;oI(a,b);i=c;return}function xI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=GJ(a,b)|0;i=c;return d|0}function yI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];II(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];HI(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];YE(a,g);LH(l);i=f;return}function zI(a){a=a|0;var b=0,c=0;b=i;c=EI(a)|0;i=b;return c|0}function AI(a){a=a|0;var b=0;b=i;BI(a)|0;i=b;return a|0}function BI(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=CI(c[d>>2]|0)|0;i=b;return a|0}function CI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;fz(b);if((e|0)==0){e=a;while(1){a=VA(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=DI(c[d>>2]|0)|0;i=b;return g|0}return 0}function DI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;fz(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;fz(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function EI(a){a=a|0;var b=0,d=0;b=i;d=FI((c[a>>2]|0)+16|0)|0;i=b;return d|0}function FI(a){a=a|0;var b=0,c=0;b=i;c=GI(a)|0;i=b;return c|0}function GI(a){a=a|0;i=i;return a|0}function HI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=MI(b,h,j,e)|0;h=c[p>>2]|0;fz(l);if((h|0)!=0){q=h;_E(a,q);i=f;return}OI(o,b,e);PI(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];NI(m,g);QI(o);o=c[j>>2]|0;LG(b,o,p,RI(m)|0);p=SI(m)|0;QI(m);q=p;_E(a,q);i=f;return}function II(a,b){a=a|0;b=b|0;var c=0;c=i;JI(a,b);i=c;return}function JI(a,b){a=a|0;b=b|0;var c=0;c=i;KI(a,b);i=c;return}function KI(a,b){a=a|0;b=b|0;var c=0;c=i;LI(a,b);i=c;return}function LI(a,b){a=a|0;b=b|0;var c=0;c=i;GN(a,b);GN(a+12|0,b+12|0);i=c;return}function MI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;ZE(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];uJ(l,k);do{if(!(tJ(b,l)|0)){k=iF(a)|0;x=wJ(b)|0;if(vJ(k,e,x)|0){break}w=vJ(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];AJ(r,h,1,0);ZE(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];uJ(t,g);do{if(!(tJ(r,t)|0)){if(vJ(k,e,wJ(r)|0)|0){break}y=zJ(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;fz(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;xJ(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];uJ(o,j);do{if(!(tJ(n,o)|0)){j=iF(a)|0;if(vJ(j,wJ(yJ(n)|0)|0,e)|0){break}y=zJ(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;fz(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function NI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];rJ(a,e);i=d;return}function OI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=hH(d)|0;d=jH(n,1)|0;dJ(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];cJ(j,d,h);eJ(0,JH((fJ(j)|0)+16|0)|0,e);a[(gJ(j)|0)+4|0]=1;hJ(m,j);PI(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];NI(b,g);QI(m);QI(j);i=f;return}function PI(a,b){a=a|0;b=b|0;var c=0;c=i;aJ(a,b);i=c;return}function QI(a){a=a|0;var b=0;b=i;XI(a);i=b;return}function RI(a){a=a|0;var b=0,d=0;b=i;d=c[(VI(a)|0)>>2]|0;i=b;return d|0}function SI(a){a=a|0;var b=0,d=0;b=i;d=TI(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function TI(a){a=a|0;var b=0,c=0;b=i;c=UI(a)|0;i=b;return c|0}function UI(a){a=a|0;i=i;return a|0}function VI(a){a=a|0;var b=0,c=0;b=i;c=WI(a)|0;i=b;return c|0}function WI(a){a=a|0;i=i;return a|0}function XI(a){a=a|0;var b=0;b=i;YI(a,0);i=b;return}function YI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=TI(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}_I(ZI(e)|0,f);i=d;return}function ZI(a){a=a|0;var b=0,c=0;b=i;c=$I(a)|0;i=b;return c|0}function _I(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;IH(f,JH(d+16|0)|0)}if((d|0)==0){i=e;return}aH(c[b>>2]|0,d,1);i=e;return}function $I(a){a=a|0;i=i;return a+4|0}function aJ(a,b){a=a|0;b=b|0;var c=0;c=i;bJ(a,b);i=c;return}function bJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];lJ(a,b,f);i=e;return}function dJ(a,b){a=a|0;b=b|0;var c=0;c=i;kJ(a,b);i=c;return}function eJ(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}iJ(b,c);i=a;return}function fJ(a){a=a|0;var b=0,d=0;b=i;d=c[(VI(a)|0)>>2]|0;i=b;return d|0}function gJ(a){a=a|0;var b=0,c=0;b=i;c=ZI(a)|0;i=b;return c|0}function hJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;aJ(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];NI(h,f);PI(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];NI(a,e);QI(h);i=d;return}function iJ(a,b){a=a|0;b=b|0;var c=0;c=i;jJ(a,b);i=c;return}function jJ(a,b){a=a|0;b=b|0;var c=0;c=i;KI(a,b);i=c;return}function kJ(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function lJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uH(g)|0)>>2]|0;g=nJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];mJ(b,a,f);i=e;return}function mJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];oJ(a,b,f);i=e;return}function nJ(a){a=a|0;i=i;return a|0}function oJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yH(g)|0)>>2]|0;g=qJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];pJ(b,a,f);i=e;return}function pJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(yH(f)|0)>>2];f=qJ(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function qJ(a){a=a|0;i=i;return a|0}function rJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=SI(sJ(b)|0)|0;h=qJ(gJ(sJ(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];mJ(g,a,e);i=d;return}function sJ(a){a=a|0;i=i;return c[a>>2]|0}function tJ(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function uJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];FJ(a,e);i=d;return}function vJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kD(0,b,c)|0;i=a;return d|0}function wJ(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function xJ(a,b){a=a|0;b=b|0;var d=0;d=i;_E(a,c[(BG(b)|0)>>2]|0);i=d;return}function yJ(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=DJ(c[d>>2]|0)|0;i=b;return a|0}function zJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=gF(a)|0;fz(e);if((h|0)==0){j=$E(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=iF(a)|0;a=h;while(1){h=a+16|0;if(vJ(j,d,h)|0){l=a;m=c[l>>2]|0;fz(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(vJ(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;fz(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function AJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;BJ(b,d);c[a>>2]=c[b>>2];i=e;return}function BJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;CJ(b,c,e);i=d;return}function CJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{yJ(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{BI(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function DJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;fz(b);if((e|0)==0){e=a;while(1){a=VA(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=EJ(c[d>>2]|0)|0;i=b;return g|0}return 0}function EJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;fz(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;fz(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function FJ(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function GJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(tJ(a,b)|0)^1;i=c;return d|0}function HJ(a){a=a|0;var b=0;b=i;i=i+128|0;XC(a,b);XC(a+12|0,b+8|0);IJ(a+24|0,b+16|0);IJ(a+36|0,b+24|0);IJ(a+48|0,b+32|0);IJ(a+60|0,b+40|0);IJ(a+72|0,b+48|0);IJ(a+84|0,b+56|0);IJ(a+96|0,b+64|0);IJ(a+108|0,b+72|0);IJ(a+120|0,b+80|0);IJ(a+132|0,b+88|0);IJ(a+144|0,b+96|0);IJ(a+156|0,b+104|0);IJ(a+168|0,b+112|0);IJ(a+180|0,b+120|0);i=b;return}function IJ(a,b){a=a|0;b=b|0;b=i;JJ(a,0);i=b;return}function JJ(a,b){a=a|0;b=b|0;b=i;i=i+8|0;KJ(a,b);i=b;return}function KJ(a,b){a=a|0;b=b|0;b=i;LJ(a,0);i=b;return}function LJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;MJ(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;NJ(f,0,e);e=IF(b)|0;c[(HF(b)|0)>>2]=e;i=d;return}function MJ(a){a=a|0;var b=0;b=i;QJ(a);i=b;return}function NJ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;OJ(b,c,f);i=e;return}function OJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JB(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;PJ(d,b,f);i=e;return}function PJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JB(e)|0)>>2];i=d;return}function QJ(a){a=a|0;var b=0;b=i;RJ(a);i=b;return}function RJ(a){a=a|0;var b=0;b=i;MB(a);i=b;return}function SJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[92140>>2]|0;if((m|0)==0){n=0}else{o=$X(12)|0;KN(o,m);n=o}if((c[92056>>2]|0)!=0){c[8786]=1}if((n|0)==0){c[35156>>2]=1;c[35160>>2]=1;i=b;return}do{if((mO(n,82280,0)|0)==-1){GN(g,n);EN(h);o=c[8360]|0;m=(o|0)<28;while(1){p=mO(g,82288,0)|0;q=(p|0)!=-1;if(q){kO(j,g,0,p);RN(h,j)|0;QN(j);kO(k,g,p+1|0,-1);RN(g,k)|0;QN(k)}else{RN(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){KN(l,c[33856+(s<<2)>>2]|0);p=TJ(h,l)|0;QN(l);if(p){c[35152+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){rt(1,1,82296,f);if(m){v=o}else{w=35704;x=c[8926]|0;ae[x&255](1);y=lO(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=82336;E=D;tt(0,E,a)}do{p=c[35024+(v<<2)>>2]|0;c[e>>2]=c[33856+(v<<2)>>2];c[e+4>>2]=p;rt(1,0,82320,e);v=v+1|0;}while((v|0)<28);w=35704;x=c[8926]|0;ae[x&255](1);y=lO(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=82336;E=D;tt(0,E,a)}else if((t|0)==20){rt(1,1,82296,d);w=35704;x=c[8926]|0;ae[x&255](1);y=lO(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=82336;E=D;tt(0,E,a)}else if((t|0)==23){QN(h);QN(g);break}}else{o=1;do{c[35152+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[35156>>2]=1;c[35160>>2]=1;if((c[35188>>2]|0)!=0){c[35248>>2]=1}if((c[35244>>2]|0)==1){c[35252>>2]=1}if((c[35224>>2]|0)!=0){c[35220>>2]=1}if((c[35232>>2]|0)!=0){c[35220>>2]=1}if((c[35184>>2]|0)!=0){c[35180>>2]=1}if((c[35228>>2]|0)!=0){c[35220>>2]=1}if((c[35176>>2]|0)!=0){c[35172>>2]=1}QN(n);bY(n);i=b;return}function TJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=ON(b)|0;if((e|0)!=(ON(c)|0)){f=0;i=d;return f|0}g=PN(b)|0;h=PN(c)|0;if(HN(b)|0){f=(mD(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function UJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[92148>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=$X(12)|0;l=k;KN(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(VJ(l,c[67376+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=lO(l)|0;rt(1,1,82368,g);g=c[67460>>2]|0;c[f>>2]=c[67380>>2];c[f+4>>2]=g;rt(1,0,82320,f);f=c[67464>>2]|0;c[e>>2]=c[67384>>2];c[e+4>>2]=f;rt(1,0,82320,e);e=c[67468>>2]|0;c[d>>2]=c[67388>>2];c[d+4>>2]=e;rt(1,0,82320,d);ae[c[8926]&255](1);tt(0,82424,a)}else if((n|0)==6){i=b;return j|0}return 0}function VJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(oO(a,b)|0)==0;i=c;return d|0}function WJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[92132>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=$X(12)|0;l=k;KN(l,h);if((k|0)==0){j=1;i=b;return j|0}KN(f,82448);k=TJ(l,f)|0;QN(f);if(k){j=1;i=b;return j|0}KN(g,82456);k=TJ(l,g)|0;QN(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=lO(l)|0;rt(1,1,82464,e);c[d>>2]=82448;c[d+4>>2]=82520;rt(1,0,82320,d);c[a>>2]=82456;c[a+4>>2]=82536;rt(1,0,82320,a);ae[c[8926]&255](1);tt(0,82424,b)}return 0}function XJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;ZP(f,a);if(!(aQ(f)|0)){_P(f);i=d;return a|0}j=uD(b)|0;jK(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((jz(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=KO(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];mK(h,e,b,m,k,l,n);if(!(kK(h)|0)){_P(f);i=d;return a|0}EO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);_P(f);i=d;return a|0}function YJ(a){a=a|0;var b=0;b=i;dQ(a,LO(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;MP(a)|0;i=b;return a|0}function ZJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;KN(h,d);zO(k,82544,h);HC(j,k,82552);QN(k);k=lO(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((tY(c[n+4>>2]|0,82560)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((tY(k,82568)|0)==0){QN(j);QN(h);i=f;return}d=bX(g,k,1)|0;if((d|0)!=0){m=l;BY(m|0,0,2048)|0;oX(d,g,m,2048)|0;bQ(XJ(XJ(XJ(XJ(XJ(104536,82576)|0,k)|0,82616)|0,m)|0,82632)|0,103)|0;QN(j);QN(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(pX(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(pX(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(pX(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(pX(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==1){q=(pX(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(pX(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){p=b+8|0;s=m;m=0;while(1){l=c[p>>2]|0;if((a[l+(m*48|0)+44|0]|0)==0){k=(pX(g,c[l+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(m*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=m+1|0;if((k|0)<(t|0)){s=t;m=k}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;p=b+24|0;k=0;do{l=c[t>>2]|0;do{if((a[l+(k*52|0)+48|0]|0)==0){d=a[l+(k*52|0)+8|0]|0;if(d<<24>>24==1){n=(pX(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[p>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(pX(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[d+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[m>>2]|0))}m=b+124|0;k=c[m>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){p=c[s>>2]|0;if((a[p+(k*52|0)+48|0]|0)==0){o=(pX(g,c[p+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==1){p=(pX(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=p;p=c[u>>2]|0;if((a[p+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[p+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(pX(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}fX(g);QN(j);QN(h);i=f;return}function _J(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[91996>>2]|0;H=c[92124>>2]|0;I=c[2]|0;if((c[35252>>2]|0)==0){if(!((c[91944>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;pt(23,0,82680,l);l=c[92068>>2]|0;do{if((l|0)==0){M=0}else{if((tY(l,82704)|0)==0){M=1;break}if((tY(l,82712)|0)==0){M=0;break}if((tY(l,82720)|0)==0){M=2;break}c[j>>2]=l;rt(1,0,82728,j);M=0}}while(0);if((Mu(M)|0)!=0){c[g>>2]=l;rt(1,0,82800,g)}if((c[2]|0)!=0){iL(d+56|0);Ru((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Nu(0);Nu(6);Ou(3);Ou(4);Ou(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+pY(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];pt(1,0,82888,f)}do{if((c[92052>>2]|0)!=0){f=$X(12)|0;J=f;KN(J,c[92180>>2]|0);if((f|0)==0){break}f=lO(J)|0;c[d+280>>2]=f;c[e>>2]=f;pt(23,0,82944,e)}}while(0);e=c[92176>>2]|0;EN(m);if((e|0)==0){KN(p,c[d+88>>2]|0);KN(q,82992);$J(o,p,q);HC(n,o,c[d+284>>2]|0);RN(m,n)|0;QN(n);QN(o);QN(q);QN(p)}else{SN(m,e)|0}KN(r,83e3);KN(s,83e3);KN(t,83e3);KN(u,83e3);KN(v,83e3);KN(w,83e3);e=c[91944>>2]|0;if((c[91964>>2]|0)!=0){SN(r,c[92092>>2]|0)|0}if((c[91980>>2]|0)!=0){SN(s,c[92108>>2]|0)|0}if((c[91960>>2]|0)!=0){SN(t,c[92088>>2]|0)|0}if((c[91968>>2]|0)==0){O=0.0}else{SN(u,c[92096>>2]|0)|0;O=+pY(lO(u)|0)}if((c[91972>>2]|0)==0){P=1}else{SN(v,c[92100>>2]|0)|0;P=Fc(lO(v)|0)|0}if((c[92032>>2]|0)!=0){SN(w,c[92160>>2]|0)|0}GN(x,m);GN(y,r);GN(z,s);GN(A,t);GN(B,w);p=aK(d,x,y,z,A,O,P,B,e)|0;QN(B);QN(A);QN(z);QN(y);QN(x);if((p|0)!=0|g^1){Q=p}else{Nu(5);p=zK(d)|0;Qu(5);pt(1,0,83008,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;QN(w);QN(v);QN(u);QN(t);QN(s);QN(r);QN(m);i=b;return R|0}Q=d+88|0;KN(D,c[Q>>2]|0);HC(C,D,83040);QN(D);KN(F,c[Q>>2]|0);HC(E,F,83056);QN(F);Qu(0);F=c[92144>>2]|0;Q=lO(C)|0;D=lO(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;YK(d,Q,D,(F|0)!=0?F:83072,I,p,lO(m)|0)|0;QN(E);QN(C);R=0;QN(w);QN(v);QN(u);QN(t);QN(s);QN(r);QN(m);i=b;return R|0}function $J(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;FN(a,d);e=ON(b)|0;f=ON(c)|0;pO(a,PN(b)|0,e,f+e|0);hO(a,PN(c)|0,f)|0;i=d;return}function aK(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((ON(j)|0)==0){u=0}else{u=lO(j)|0}GN(r,b);b=(bK(a,r,k)|0)==0;QN(r);if(!b){v=-1;i=l;return v|0}KN(s,83e3);b=a+280|0;r=VJ(s,c[b>>2]|0)|0;QN(s);do{if(r){w=3}else{s=1;k=0;do{KN(t,c[83216+(s<<2)>>2]|0);j=VJ(t,c[b>>2]|0)|0;QN(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];rt(1,0,83296,q);rt(1,0,82296,p);s=1;do{j=c[83328+(s<<2)>>2]|0;c[o>>2]=c[83216+(s<<2)>>2];c[o+4>>2]=j;rt(1,0,82320,o);s=s+1|0;}while((s|0)<20);tt(c[a+536>>2]|0,82424,n)}}while(0);c[m>>2]=c[83216+(w<<2)>>2];pt(23,0,83408,m);m=lO(d)|0;d=lO(e)|0;e=yx(a,m,d,lO(f)|0,g,h,w,u)|0;be[c[76660>>2]&63](76632,a);v=e;i=l;return v|0}function bK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[19158]=vd(lO(b)|0)|0;c[76636>>2]=g;c[76640>>2]=d;d=a+284|0;do{if((c[20568]|0)==0){g=c[d>>2]|0;if((tY(83080,g)|0)==0){h=0;break}if((tY(83088,g)|0)==0){c[76648>>2]=47;c[76652>>2]=48;c[76660>>2]=49;h=0;break}if((tY(83096,g)|0)==0){c[76648>>2]=50;c[76652>>2]=51;c[76656>>2]=52;c[76660>>2]=53;h=1;break}if((tY(83104,g)|0)==0){c[76648>>2]=54;c[76652>>2]=55;c[76656>>2]=56;c[76660>>2]=57;h=1;break}if((tY(83112,g)|0)==0){c[76648>>2]=58;c[76652>>2]=59;c[76660>>2]=60;h=0;break}g=XJ(104536,83120)|0;bQ(XJ(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);ZJ(a+8|0,c[a+288>>2]|0,h);be[c[76648>>2]&63](76632,a);a=c[19158]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;pt(23,0,83144,f);j=0;i=e;return j|0}function cK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;gt();do{if((qL(a,b)|0)==0){if((sL(a,b)|0)!=0){break}do{if((c[92e3>>2]|0)!=0){w=c[92128>>2]|0;if((tY(w,83528)|0)==0){mt(1);break}if((tY(w,83536)|0)==0){mt(0);break}else{c[p>>2]=w;rt(1,0,83544,p);qd(0)|0;xd(0)}}}while(0);if((c[91956>>2]|0)==0){SJ(0,0);Cw(d);if((d|0)==0){bQ(XJ(104536,83912)|0,103)|0}c[d+300>>2]=UJ(0,0)|0;c[d+292>>2]=WJ(0,0)|0;EC(d+8|0,d+240|0);Hw(d)|0;Pw(d)|0;Yw(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}bQ(XJ(104536,83976)|0,103)|0;x=1;i=e;return x|0}}while(0);c[20568]=c[92024>>2];x=0;i=e;return x|0}KN(u,c[92084>>2]|0);w=1;while(1){y=40184+(w<<2)|0;KN(v,c[y>>2]|0);z=TJ(u,v)|0;QN(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=lO(u)|0;rt(1,0,83816,g);c[f>>2]=c[b>>2];rt(1,0,83856,f);qd(0)|0;xd(0)}A=c[44208+(w<<2)>>2]|0;do{if((A|0)==1){z=c[44080+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;pt(1,1,83616,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[44080+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;pt(1,1,83656,n);break}else{c[m>>2]=z;rt(1,1,83496,m);break}}}while(0);if((w|0)==7){A=1;do{z=c[83736+(A<<2)>>2]|0;c[k>>2]=c[83720+(A<<2)>>2];c[k+4>>2]=z;pt(1,0,82320,k);A=A+1|0;}while((A|0)<4);D=35704;E=c[8926]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else if((w|0)==29){A=1;do{z=c[83328+(A<<2)>>2]|0;c[h>>2]=c[83216+(A<<2)>>2];c[h+4>>2]=z;pt(1,0,82320,h);A=A+1|0;}while((A|0)<20);D=35704;E=c[8926]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else if((w|0)==11){A=1;do{z=c[83784+(A<<2)>>2]|0;c[j>>2]=c[83752+(A<<2)>>2];c[j+4>>2]=z;pt(1,0,82320,j);A=A+1|0;}while((A|0)<7);D=35704;E=c[8926]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else if((w|0)==19){A=c[8360]|0;if((A|0)<28){G=A}else{D=35704;E=c[8926]|0;ae[E&255](1);F=qd(0)|0;xd(0)}do{A=c[35024+(G<<2)>>2]|0;c[l>>2]=c[33856+(G<<2)>>2];c[l+4>>2]=A;pt(1,0,82320,l);G=G+1|0;}while((G|0)<28);D=35704;E=c[8926]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else{D=35704;E=c[8926]|0;ae[E&255](1);F=qd(0)|0;xd(0)}}}while(0);c[t>>2]=c[b>>2];pt(1,1,83432,t);t=1;do{b=c[44208+(t<<2)>>2]|0;do{if((b|0)==1){F=c[42088+(t<<2)>>2]|0;c[s>>2]=c[40184+(t<<2)>>2];c[s+4>>2]=F;pt(1,0,83448,s)}else{F=c[40184+(t<<2)>>2]|0;if((b|0)==2){E=c[42088+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;pt(1,0,83464,r);break}else{c[q>>2]=F;rt(1,0,83496,q);break}}}while(0);t=t+1|0;}while((t|0)<31);ae[c[8926]&255](1);qd(0)|0;xd(0);return 0}function dK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[21002]|0;tb(85656)|0;c[l>>2]=c[m+88>>2];hc(84016,l|0)|0;tb(85672)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hc(84040,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];hc(84080,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hc(84112,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hc(84144,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];hc(84176,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];hc(84208,b|0)|0;tb(85696)|0;i=a;return}function eK(a,b){a=a|0;b=+b;i=i;return}



function sz(a){a=a|0;var b=0;b=i;tz(a);i=b;return}function tz(a){a=a|0;var b=0;b=i;uz(a,0);i=b;return}function uz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=vz(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}de[c[(wz(e)|0)>>2]&127](f)|0;i=d;return}function vz(a){a=a|0;var b=0,c=0;b=i;c=yz(a)|0;i=b;return c|0}function wz(a){a=a|0;var b=0,c=0;b=i;c=xz(a)|0;i=b;return c|0}function xz(a){a=a|0;i=i;return a+4|0}function yz(a){a=a|0;i=i;return a|0}function zz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Bz(f)|0)>>2]|0;Az(a,d,c[(Cz(g)|0)>>2]|0);i=e;return}function Az(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Dz(a,b,c);i=d;return}function Bz(a){a=a|0;i=i;return a|0}function Cz(a){a=a|0;i=i;return a|0}function Dz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Fz(f)|0)>>2]|0;Ez(a,d,c[(Gz(g)|0)>>2]|0);i=e;return}function Ez(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(Fz(f)|0)>>2];c[a+4>>2]=c[(Gz(g)|0)>>2];i=e;return}function Fz(a){a=a|0;i=i;return a|0}function Gz(a){a=a|0;i=i;return a|0}function Hz(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function Iz(a){a=a|0;var b=0;b=i;Jz(a+300|0);Jz(a+288|0);Jz(a+276|0);Jz(a+264|0);Jz(a+252|0);Jz(a+240|0);Kz(a);i=b;return}function Jz(a){a=a|0;var b=0;b=i;uA(a);i=b;return}function Kz(a){a=a|0;var b=0;b=i;Lz(a,77216);IO(a+104|0);i=b;return}function Lz(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Pz(a+4|0);i=d;return}function Mz(a){a=a|0;var b=0;b=i;Kz(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Nz(a){a=a|0;var b=0;b=i;Kz(a);bY(a);i=b;return}function Oz(a){a=a|0;var b=0;b=i;Nz(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Pz(a){a=a|0;var b=0;b=i;Qz(a);i=b;return}function Qz(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=77344;pz(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}cY(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}cY(e)}}while(0);RO(b);i=d;return}function Rz(a){a=a|0;var b=0;b=i;Pz(a);bY(a);i=b;return}function Sz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=sA(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=tA(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;$O(h,0,0,0);eP(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}cY(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=aY(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=aY(h)|0;a[b+97|0]=1;i=e;return}function Tz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;$O(e,0,0,0);eP(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}cY(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}cY(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=aY(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(pA(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=aY(o)|0;a[k]=1;i=f;return e|0}return 0}function Uz(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;AX(n);Od(n|0,124736,128)}n=lA(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((de[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){ty(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=QY(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Vc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;ty(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];oA(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{ty(a,-1,-1);i=g;return}}}while(0);ty(a,-1,-1);i=g;return}function Vz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((de[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=Hz(d)|0;if((Vc(j|0,k|0,0)|0)==0){nA(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{ty(a,-1,-1);i=e;return}}}while(0);ty(a,-1,-1);i=e;return}function Wz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;AX(m);Od(m|0,124736,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=lA(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=ZO(s)|0;u=(fa(t-(YO(s)|0)|0,p)|0)+r|0;v=0;break}p=YO(s)|0;if((p|0)==(ZO(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=mA(t,g,x,o,p-(XO(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=ZO(w)|0;u=q-(YO(w)|0)|0;v=0}}while(0);if((Vc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;$O(b,0,0,0);c[m>>2]=0}else{q=b;y=bP(q)|0;do{if((y|0)!=(aP(q)|0)){if((se[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=kA(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((qd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function Xz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=fA(b)|0;o=b;if((YO(o)|0)==0){p=e+1|0;$O(o,e,p,p)}if(n){q=0}else{n=ZO(o)|0;c[f>>2]=(n-(XO(o)|0)|0)/2|0;c[g>>2]=4;q=c[(gA(f,g)|0)>>2]|0}g=YO(o)|0;do{if((g|0)==(ZO(o)|0)){AY(XO(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=ZO(o)|0;n=XO(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=XO(o)|0;$O(o,n,n+q|0,n+(p+q)|0);r=dA(a[YO(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;AY(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(gA(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;AX(t);Od(t|0,124736,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=XO(o)|0;if((hA(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;$O(o,f,f,c[s>>2]|0);r=dA(a[YO(o)|0]|0)|0;break}s=c[k>>2]|0;f=XO(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}$O(o,f,p,s);r=dA(a[YO(o)|0]|0)|0}else{r=dA(a[g]|0)|0}}while(0);if((XO(o)|0)!=(e|0)){m=r;i=d;return m|0}$O(o,0,0,0);m=r;i=d;return m|0}function Yz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=XO(g)|0;j=YO(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if($z(d,-1)|0){_O(g,-1);f=cA(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=aA(d)|0;do{if(h){if(eA(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);_O(g,-1);a[YO(g)|0]=b;f=d;i=e;return f|0}function Zz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}_z(b);l=b;m=aP(l)|0;n=cP(l)|0;if(!($z(d,-1)|0)){if((bP(l)|0)==0){eP(l,f,f+1|0)}f=aA(d)|0;a[bP(l)|0]=f;dP(l,1)}f=bP(l)|0;o=aP(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;AX(u);v=124736;w=128;Od(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=aP(l)|0;A=bP(l)|0;B=bA(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=aP(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;eP(l,B,bP(l)|0);B=cP(l)|0;dP(l,B-(aP(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;AX(u);v=124736;w=128;Od(t|0,v|0,w|0)}else if((D|0)==14){q=(bP(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);eP(l,m,n)}k=cA(d)|0;i=e;return k|0}function _z(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;$O(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;eP(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;eP(f,h,h+(g+ -1)|0);break}}else{eP(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function $z(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function aA(a){a=a|0;i=i;return a&255|0}function bA(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Be[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function cA(a){a=a|0;var b=0,c=0;b=i;c=$z(a,-1)|0;i=b;return(c?0:a)|0}function dA(a){a=a|0;i=i;return a&255|0}function eA(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function fA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;eP(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;$O(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;$O(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function gA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=iA(b,c,e)|0;i=d;return g|0}function hA(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Be[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function iA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=jA(0,b,a)|0;i=c;return(d?b:a)|0}function jA(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function kA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=te[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function lA(a){a=a|0;var b=0,d=0;b=i;d=de[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function mA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=te[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function nA(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function oA(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function pA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=qA(b,c,e)|0;i=d;return g|0}function qA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=rA(0,a,b)|0;i=c;return(d?b:a)|0}function rA(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function sA(a){a=a|0;var b=0,c=0;b=i;c=AU(a,109240)|0;i=b;return c|0}function tA(a){a=a|0;var b=0,d=0;b=i;d=de[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function uA(a){a=a|0;var b=0;b=i;vA(a);i=b;return}function vA(a){a=a|0;var b=0;b=i;wA(a);i=b;return}function wA(a){a=a|0;var b=0;b=i;xA(a,_y(a)|0);i=b;return}function xA(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;fz(d);if((b|0)==0){i=d;return}xA(a,c[b>>2]|0);xA(a,c[b+4>>2]|0);zA(yA(a)|0,b,1);i=d;return}function yA(a){a=a|0;var b=0,c=0;b=i;c=BA(a+4|0)|0;i=b;return c|0}function zA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;AA(0,b,0);i=c;return}function AA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bY(b);i=c;return}function BA(a){a=a|0;var b=0,c=0;b=i;c=CA(a)|0;i=b;return c|0}function CA(a){a=a|0;i=i;return a|0}function DA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=EA(a,f,b)|0;l=c[k>>2]|0;fz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}GA(j,a,b);HA(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];FA(g,e);IA(j);j=c[f>>2]|0;JA(a,j,k,KA(g)|0);k=LA(g)|0;IA(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function EA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=_y(h)|0;fz(e);if((a|0)==0){j=Ry(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(cz(0,d,a)|0){m=l;j=c[m>>2]|0;fz(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(cz(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;fz(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function FA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];xB(a,e);i=d;return}function GA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=yA(d)|0;d=gB(n,1)|0;hB(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];fB(j,d,h);iB(0,bB((jB(j)|0)+16|0)|0,e);e=kB(j)|0;a[e+4|0]=1;lB(0,aB((jB(j)|0)+20|0)|0);a[e+5|0]=1;mB(m,j);HA(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];FA(b,g);IA(m);IA(j);i=f;return}function HA(a,b){a=a|0;b=b|0;var c=0;c=i;dB(a,b);i=c;return}function IA(a){a=a|0;var b=0;b=i;YA(a);i=b;return}function JA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;fz(f);c[e>>2]=0;fz(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=QA(a)|0;b=c[c[e>>2]>>2]|0;fz(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Ry(a)|0)>>2]|0;RA(e,c[d>>2]|0);d=SA(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function KA(a){a=a|0;var b=0,d=0;b=i;d=c[(OA(a)|0)>>2]|0;i=b;return d|0}function LA(a){a=a|0;var b=0,d=0;b=i;d=MA(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function MA(a){a=a|0;var b=0,c=0;b=i;c=NA(a)|0;i=b;return c|0}function NA(a){a=a|0;i=i;return a|0}function OA(a){a=a|0;var b=0,c=0;b=i;c=PA(a)|0;i=b;return c|0}function PA(a){a=a|0;i=i;return a|0}function QA(a){a=a|0;i=i;return a|0}function RA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=VA(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;fz(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;fz(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(VA(j)|0){p=j}else{o=c[k>>2]|0;WA(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;XA(p);i=e;return}else if((l|0)==14){if(VA(j)|0){p=c[k>>2]|0;XA(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;WA(q);i=e;return}else if((l|0)==17){i=e;return}}function SA(a){a=a|0;var b=0,c=0;b=i;c=TA(a+8|0)|0;i=b;return c|0}function TA(a){a=a|0;var b=0,c=0;b=i;c=UA(a)|0;i=b;return c|0}function UA(a){a=a|0;i=i;return a|0}function VA(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function WA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;fz(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=VA(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function XA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;fz(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=VA(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function YA(a){a=a|0;var b=0;b=i;ZA(a,0);i=b;return}function ZA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=MA(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$A(_A(e)|0,f);i=d;return}function _A(a){a=a|0;var b=0,c=0;b=i;c=cB(a)|0;i=b;return c|0}function $A(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}zA(c[a>>2]|0,b,1);i=d;return}function aB(a){a=a|0;i=i;return a|0}function bB(a){a=a|0;i=i;return a|0}function cB(a){a=a|0;i=i;return a+4|0}function dB(a,b){a=a|0;b=b|0;var c=0;c=i;eB(a,b);i=c;return}function eB(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function fB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];pB(a,b,f);i=e;return}function gB(a,b){a=a|0;b=b|0;var c=0;a=i;c=oB(0,b,0)|0;i=a;return c|0}function hB(a,b){a=a|0;b=b|0;var c=0;c=i;nB(a,b);i=c;return}function iB(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function jB(a){a=a|0;var b=0,d=0;b=i;d=c[(OA(a)|0)>>2]|0;i=b;return d|0}function kB(a){a=a|0;var b=0,c=0;b=i;c=_A(a)|0;i=b;return c|0}function lB(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function mB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;dB(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];FA(h,f);HA(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];FA(a,e);IA(h);i=d;return}function nB(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function oB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=$X(b*24|0)|0;i=c;return a|0}function pB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(rB(g)|0)>>2]|0;g=sB(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];qB(b,a,f);i=e;return}function qB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];tB(a,b,f);i=e;return}function rB(a){a=a|0;i=i;return a|0}function sB(a){a=a|0;i=i;return a|0}function tB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(vB(g)|0)>>2]|0;g=wB(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];uB(b,a,f);i=e;return}function uB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(vB(f)|0)>>2];f=wB(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function vB(a){a=a|0;i=i;return a|0}function wB(a){a=a|0;i=i;return a|0}function xB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=LA(yB(b)|0)|0;h=wB(kB(yB(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];qB(g,a,e);i=d;return}function yB(a){a=a|0;i=i;return c[a>>2]|0}function zB(a){a=a|0;var b=0;b=i;i=i+48|0;AB(a);ty(a+184|0,0,0);ty(a+200|0,0,0);BB(a+240|0,b);BB(a+252|0,b+8|0);BB(a+264|0,b+16|0);BB(a+276|0,b+24|0);BB(a+288|0,b+32|0);BB(a+300|0,b+40|0);i=b;return}function AB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;NO(d);e=a;c[e>>2]=77188;f=d;c[f>>2]=77208;d=a+4|0;UP(a,77220|0,d);c[e>>2]=77188;c[f>>2]=77208;OB(d);i=b;return}function BB(a,b){a=a|0;b=b|0;b=i;CB(a,0);i=b;return}function CB(a,b){a=a|0;b=b|0;b=i;i=i+8|0;DB(a,b);i=b;return}function DB(a,b){a=a|0;b=b|0;b=i;EB(a,0);i=b;return}function EB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;FB(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;GB(f,0,e);e=Ry(b)|0;c[(QA(b)|0)>>2]=e;i=d;return}function FB(a){a=a|0;var b=0;b=i;KB(a);i=b;return}function GB(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;HB(b,c,f);i=e;return}function HB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(JB(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;IB(d,b,f);i=e;return}function IB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(JB(e)|0)>>2];i=d;return}function JB(a){a=a|0;i=i;return a|0}function KB(a){a=a|0;var b=0;b=i;LB(a);i=b;return}function LB(a){a=a|0;var b=0;b=i;MB(a);i=b;return}function MB(a){a=a|0;var b=0;b=i;NB(a);i=b;return}function NB(a){a=a|0;c[a>>2]=0;i=i;return}function OB(a){a=a|0;var b=0;b=i;PB(a);i=b;return}function PB(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;WO(j);c[d>>2]=77344;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;fz(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;SO(g,j);l=QB(g)|0;yU(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ge[r&63](d,0,4096)|0;i=e;return}SO(h,j);c[k>>2]=sA(h)|0;yU(h);a[f]=(tA(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ge[r&63](d,0,4096)|0;i=e;return}function QB(a){a=a|0;var b=0,c=0;b=i;c=zU(a,109240)|0;i=b;return c|0}function RB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Nu(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){SB(a,b,c[f>>2]|0,h);Qu(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=YX(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;tt(k,77616,e)}SB(a,b,l,h);Qu(3);i=d;return}function SB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Qu(0);k=+Iu(0);Nu(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function TB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=VX(24)|0;Nu(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;st(c[m>>2]|0,l>>>31^1,77672,f);f=b+8|0;b=c[a+8>>2]|0;l=UB(b,f)|0;c[g+20>>2]=l;l=UB(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=VX(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;tt(k,77752,e)}else{c[h>>2]=0;c[a+12>>2]=g;Qu(3);i=d;return}}function UB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function VB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Nu(3);u=b;v=jc(c[u>>2]|0,77816)|0;if((v|0)==0){WB(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Rd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;tt(w,77824,q)}rc(77880,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];sd(v|0,77928,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];sd(v|0,77952,o|0)|0;rc(77976,40,1,v|0)|0;rc(78024,11,1,v|0)|0;rc(78040,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];XB(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Nd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(78056,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;XB(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Nd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];sd(v|0,78080,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;XB(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Nd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];sd(v|0,78080,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;XB(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Nd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];sd(v|0,78080,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;XB(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Nd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];sd(v|0,78080,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;XB(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Nd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];sd(v|0,78080,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;XB(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Nd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];sd(v|0,78080,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;XB(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Nd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}WB(t);if((Xc(v|0)|0)==0){WX(c[r>>2]|0);c[r>>2]=0;Qu(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];tt(e,78096,f)}}function WB(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}WX(a);c[d>>2]=0;i=b;return}function XB(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];sd(a|0,78144,f|0)|0;i=e;return}function YB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=$X(192)|0;BY(m|0,0,192)|0;ZB(m);c[a+12>>2]=m;n=m;o=a;uy(n,c[o>>2]|0,36);if(BO(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];tt(a,78184,g)}else{g=m;eQ(g,78160,14)|0;fQ(h,g);a=Hz(h)|0;h=m+184|0;c[h>>2]=a;eQ(g,78176,4)|0;_B(n,b+8|0);fQ(j,g);b=Hz(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;ty(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];gQ(g,f)|0;$B(n,-4-m+b|0);b=c[j>>2]|0;ty(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];gQ(g,e)|0;Qu(3);i=d;return}}function ZB(a){a=a|0;var b=0;b=i;sC(a);i=b;return}function _B(a,b){a=a|0;b=b|0;var c=0;c=i;bC(a,3);cC(a,78360);bC(a,0);cC(a,78368);bC(a,2);nC(a,b);oC(a,b);cC(a,78376);bC(a,0);i=c;return}function $B(a,b){a=a|0;b=b|0;var d=0;d=i;c[19588]=Cd(b|0)|0;eQ(a,78352,4)|0;i=d;return}function aC(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;fQ(l,q);r=Hz(l)|0;$B(b,0);fQ(m,q);l=Hz(m)|0;bC(b,1);cC(b,78248);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;dC(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);eC(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{eC(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{fC(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{gC(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{cC(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}fQ(n,q);u=Hz(n)|0;n=yY(0,r|0,32)|0;ty(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];gQ(q,k)|0;$B(b,u-l|0);ty(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];gQ(q,j)|0;i=g;return}function bC(b,d){b=b|0;d=d|0;var e=0;e=i;a[78336]=-33;c[19586]=Cd(d|0)|0;d=b;eQ(d,78336,1)|0;eQ(d,78344,4)|0;i=e;return}function cC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Cd(xY(d|0)|0)|0;a[78328]=-37;g=b;eQ(g,78328,1)|0;eQ(g,f,4)|0;eQ(g,d,xY(d|0)|0)|0;i=e;return}function dC(b,d){b=b|0;d=d|0;var e=0;e=i;a[78312]=-35;c[19580]=Cd(d|0)|0;d=b;eQ(d,78312,1)|0;eQ(d,78320,4)|0;i=e;return}function eC(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[78296]=-53;mC(c);e=b;eQ(e,78296,1)|0;eQ(e,78304,8)|0;i=d;return}function fC(b,d){b=b|0;d=d|0;var e=0;e=i;a[78280]=-46;c[19572]=Cd(d|0)|0;d=b;eQ(d,78280,1)|0;eQ(d,78288,4)|0;i=e;return}function gC(b,c){b=b|0;c=c|0;var d=0;d=i;a[78272]=c?-61:-62;eQ(b,78272,1)|0;i=d;return}function hC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;aC(e,+h[f>>3],a,f);aC(e,+h[b+248>>3],a,f);i=d;return}function iC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;fQ(j,p);o=Hz(j)|0;$B(b,0);fQ(k,p);j=Hz(k)|0;bC(b,1);cC(b,78256);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;dC(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;eC(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{eC(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{fC(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{gC(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{cC(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}fQ(l,p);s=Hz(l)|0;l=yY(0,o|0,32)|0;ty(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];gQ(p,g)|0;$B(b,s-j|0);ty(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];gQ(p,f)|0;i=e;return}function jC(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;ny(a);Nu(3);if((a|0)!=0){kC(a);bY(a)}c[d>>2]=0;Qu(3);i=b;return}function kC(a){a=a|0;var b=0;b=i;lC(a);i=b;return}function lC(a){a=a|0;var b=0;b=i;Kz(a);i=b;return}function mC(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Cd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=78304;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[78304+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function nC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;cC(a,78248);bC(a,4);cC(a,78384);bC(a,0);cC(a,78392);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;dC(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);cC(a,78400);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{cC(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{cC(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{cC(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{cC(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=78488;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];pC(a,b,e);cC(a,78424);bC(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);qC(a,78400,78432);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;qC(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;qC(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;qC(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;qC(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function oC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;cC(a,78256);bC(a,4);cC(a,78384);bC(a,0);cC(a,78392);o=g+1+j+l+n|0;dC(a,o);cC(a,78400);if((c[f>>2]|0)>0){n=b;l=0;do{cC(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{cC(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{cC(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{cC(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=78408;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];pC(a,b,e);cC(a,78424);bC(a,o);qC(a,78400,78432);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;qC(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;qC(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;qC(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;qC(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function pC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;cC(b,78456);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}bC(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?78400:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}rC(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?78400:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}rC(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?78400:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}rC(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?78400:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}rC(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function qC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;cC(a,b);bC(a,1);cC(a,78440);cC(a,c);i=d;return}function rC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;cC(a,b);bC(a,d?2:1);cC(a,78464);cC(a,c);if(!d){i=e;return}cC(a,78472);cC(a,78480);i=e;return}function sC(a){a=a|0;var b=0;b=i;AB(a);i=b;return}function tC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;KN(e,78504);GN(d,vC(a,e)|0);uC(d,b+4|0);QN(d);QN(e);KN(g,78512);GN(f,vC(a,g)|0);wC(f,b);QN(f);QN(g);KN(j,78528);GN(h,vC(a,j)|0);uC(h,b+8|0);QN(h);QN(j);KN(l,78544);GN(k,vC(a,l)|0);uC(k,b+12|0);QN(k);QN(l);KN(n,78560);GN(m,vC(a,n)|0);xC(m,b+16|0,0);QN(m);QN(n);KN(p,78576);GN(o,vC(a,p)|0);xC(o,b+20|0,0);QN(o);QN(p);KN(r,78592);GN(q,vC(a,r)|0);xC(q,b+24|0,0);QN(q);QN(r);KN(t,78600);GN(s,vC(a,t)|0);xC(s,b+28|0,0);QN(s);QN(t);KN(v,78616);GN(u,vC(a,v)|0);xC(u,b+32|0,0);QN(u);QN(v);i=c;return}function uC(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){rt(22,0,81824,d);i=d;return}else{c[b>>2]=vd(lO(a)|0)|0;i=d;return}}function vC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=GG(a,f,b)|0;l=c[k>>2]|0;fz(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}IG(j,a,b);JG(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];HG(g,e);KG(j);j=c[f>>2]|0;LG(a,j,k,MG(g)|0);k=NG(g)|0;KG(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function wC(a,b){a=a|0;b=b|0;var d=0;d=i;if((oO(a,78792)|0)==0){c[b>>2]=1;i=d;return}if((oO(a,78800)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(lO(a)|0)|0;i=d;return}}function xC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((oO(a,78768)|0)==0){c[b>>2]=d}if((oO(a,78792)|0)==0){c[b>>2]=1;i=e;return}if((oO(a,78800)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(lO(a)|0)|0;i=e;return}}function yC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;KN(j,78632);GN(g,vC(b,j)|0);y=d+48|0;zC(g,y);QN(g);QN(j);KN(m,78648);GN(l,vC(b,m)|0);j=d+56|0;AC(l,j,0.0);QN(l);QN(m);KN(o,78656);GN(n,vC(b,o)|0);m=d+32|0;zC(n,m);QN(n);QN(o);KN(q,78664);GN(p,vC(b,q)|0);o=d+33|0;zC(p,o);QN(p);QN(q);KN(s,78680);GN(r,vC(b,s)|0);q=d+40|0;AC(r,q,1.0);QN(r);QN(s);KN(u,78688);GN(t,vC(b,u)|0);s=d+16|0;AC(t,s,-1.7976931348623157e+308);QN(t);QN(u);KN(w,78696);GN(v,vC(b,w)|0);u=d+24|0;AC(v,u,1.7976931348623157e+308);QN(v);QN(w);KN(x,78504);w=lO(vC(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?78792:78800;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?78768:78776;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?78768:78784;c[f+20>>2]=j;c[f+24>>2]=m?78768:78776;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?78768:78784;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];pt(4,0,78704,f);QN(x);i=e;return}function zC(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(oO(b,78792)|0)==0|0;i=d;return}function AC(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((oO(a,78768)|0)==0){h[b>>3]=c;i=d;return}if((oO(a,78792)|0)==0){h[b>>3]=1.0;i=d;return}if((oO(a,78800)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+pY(lO(a)|0);i=d;return}}function BC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;KN(h,78632);GN(g,vC(b,h)|0);s=d+13|0;zC(g,s);QN(g);QN(h);KN(k,78648);GN(j,vC(b,k)|0);h=d+16|0;xC(j,h,0);QN(j);QN(k);KN(m,78656);GN(l,vC(b,m)|0);k=d+12|0;zC(l,k);QN(l);QN(m);KN(o,78688);GN(n,vC(b,o)|0);m=d+4|0;xC(n,m,-2147483648);QN(n);QN(o);KN(q,78696);GN(p,vC(b,q)|0);o=d+8|0;xC(p,o,2147483647);QN(p);QN(q);KN(r,78504);q=lO(vC(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?78792:78800;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?78768:78776;c[f+8>>2]=s;c[f+12>>2]=b?78768:78784;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;pt(4,0,78808,f);QN(r);i=e;return}function CC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;KN(h,78632);GN(g,vC(b,h)|0);o=d+5|0;zC(g,o);QN(g);QN(h);KN(k,78648);GN(j,vC(b,k)|0);h=d+6|0;zC(j,h);QN(j);QN(k);KN(m,78656);GN(l,vC(b,m)|0);k=d+4|0;zC(l,k);QN(l);QN(m);KN(n,78504);m=lO(vC(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?78792:78800;h=(a[k]|0)!=0?78792:78800;c[f>>2]=m;c[f+4>>2]=b?78768:78776;c[f+8>>2]=o;c[f+12>>2]=b?78768:78784;c[f+16>>2]=h;pt(4,0,78864,f);QN(n);i=e;return}function DC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;KN(h,78632);GN(g,vC(b,h)|0);m=d+4|0;zC(g,m);QN(g);QN(h);KN(k,78648);GN(j,vC(b,k)|0);h=d+8|0;uC(j,h);QN(j);QN(k);KN(l,78504);k=lO(vC(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?78768:78776;c[f+8>>2]=m;c[f+12>>2]=b?78768:78784;pt(4,0,78904,f);QN(l);i=e;return}function EC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;FC(qa);EN(ra);GC(sa,ta);GC(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[91952>>2]|0)==0){KN(za,c[b+80>>2]|0);HC(ya,za,78928);RN(ra,ya)|0;QN(ya);QN(za)}else{SN(ra,c[92080>>2]|0)|0}ta=jc(lO(ra)|0,78944)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=lO(ra)|0;tt(0,78952,pa)}else{Wc=0}}while(0);pa=jo(0)|0;if((pa|0)==0){Xc(Wc|0)|0;tt(0,79056,oa)}uo(pa,Vc);vo(pa,9,46);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;BY(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((wo(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Xc(Wc|0)|0;oa=lO(ra)|0;ya=Eo(Bo(pa)|0)|0;za=Co(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;rt(1,0,79136,na);qo(pa);tt(0,79224,ma)}else if((Yc|0)==14){Xc(Wc|0)|0;break}}else{if((wo(pa,Vc,xY(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Eo(Bo(pa)|0)|0;ta=Co(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;sd(za|0,79248,la|0)|0;za=c[va>>2]|0;ta=Eo(Bo(pa)|0)|0;oa=Co(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;rt(1,0,79264,ka);qo(pa);tt(0,79224,ja)}}while(0);ja=qa;KN(Ca,79352);LC(Ba,ja,Ca);MC(Da,ja);ka=KC(Ba,Da)|0;QN(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=lO(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;rt(1,0,79360,ia)}else{KN(Ea,79352);Ba=tY(Da,lO(vC(ja,Ea)|0)|0)|0;QN(Ea);if((Ba|0)==0){break}qo(pa);KN(Fa,79352);Ba=lO(vC(ja,Fa)|0)|0;va=lO(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;rt(1,0,79408,ha);QN(Fa);tt(0,79224,ga)}}while(0);NC(qa,b,c[92164>>2]|0,c[92168>>2]|0);pt(23,1,79504,fa);fa=qa+12|0;KN(Ha,79544);GN(Ga,vC(fa,Ha)|0);ga=d;AC(Ga,ga,0.0);QN(Ga);QN(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];pt(23,0,79560,ea);KN(Ja,79576);GN(Ia,vC(fa,Ja)|0);ea=d+8|0;AC(Ia,ea,1.0);QN(Ia);QN(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];pt(23,0,79592,da);KN(La,79608);GN(Ka,vC(fa,La)|0);da=d+24|0;AC(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);QN(Ka);QN(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];pt(23,0,79624,ca);KN(Na,79640);GN(Ma,vC(fa,Na)|0);ca=d+32|0;AC(Ma,ca,1.0e-5);QN(Ma);QN(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];pt(23,0,79656,ba);KN(Pa,79672);GN(Oa,vC(fa,Pa)|0);ba=d+40|0;uC(Oa,ba);QN(Oa);QN(Pa);c[aa>>2]=c[ba>>2];pt(23,0,79680,aa);KN(Ra,79704);GN(Qa,vC(fa,Ra)|0);aa=d+44|0;uC(Qa,aa);QN(Qa);QN(Ra);c[$>>2]=c[aa>>2];pt(23,0,79720,$);KN(Ta,79744);GN(Sa,vC(fa,Ta)|0);fa=d+48|0;uC(Sa,fa);QN(Sa);QN(Ta);c[_>>2]=c[fa>>2];pt(23,0,79760,_);KN(Va,79784);GN(Ua,vC(ja,Va)|0);_=d+268|0;uC(Ua,_);QN(Ua);QN(Va);c[Z>>2]=c[_>>2];pt(23,0,79808,Z);if((c[35244>>2]|0)!=0){ae[c[8926]&255](23)}KN(eb,79832);GN(db,vC(ja,eb)|0);xC(db,Wa,0);QN(db);QN(eb);KN(gb,79864);GN(fb,vC(ja,gb)|0);xC(fb,Xa,0);QN(fb);QN(gb);KN(ib,79896);GN(hb,vC(ja,ib)|0);xC(hb,Ya,0);QN(hb);QN(ib);KN(kb,79920);GN(jb,vC(ja,kb)|0);xC(jb,_a,0);QN(jb);QN(kb);KN(mb,79952);GN(lb,vC(ja,mb)|0);xC(lb,Za,0);QN(lb);QN(mb);KN(ob,79992);GN(nb,vC(ja,ob)|0);xC(nb,ab,0);QN(nb);QN(ob);KN(qb,80024);GN(pb,vC(ja,qb)|0);xC(pb,$a,0);QN(pb);QN(qb);KN(tb,80064);GN(rb,vC(ja,tb)|0);xC(rb,cb,0);QN(rb);QN(tb);KN(vb,80096);GN(ub,vC(ja,vb)|0);xC(ub,bb,0);QN(ub);QN(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=80640;pt(4,1,80616,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=OC(lb,wb)|0;tC(ib,jb+(kb*112|0)|0);yC(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(xb,80656);jb=(oO(vC(ib,xb)|0,78792)|0)==0;QN(xb);if(!jb){break}c[N>>2]=c[hb>>2];pt(4,0,80672,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);KN(yb,c[hb>>2]|0);c[(PC(sa,yb)|0)>>2]=kb;QN(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[M>>2]=80704;pt(4,1,80616,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=OC(lb,zb)|0;tC(fb,gb+(jb*112|0)|0);yC(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Ab,80656);gb=(oO(vC(fb,Ab)|0,78792)|0)==0;QN(Ab);if(!gb){break}c[L>>2]=c[eb>>2];pt(4,0,80672,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);KN(Bb,c[eb>>2]|0);c[(PC(sa,Bb)|0)>>2]=jb;QN(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[K>>2]=80728;pt(4,1,80616,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=OC(mb,Cb)|0;tC(gb,hb+(fb*112|0)|0);yC(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Db,80656);hb=(oO(vC(gb,Db)|0,78792)|0)==0;QN(Db);if(!hb){break}c[J>>2]=c[db>>2];pt(4,0,80672,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);KN(Eb,c[db>>2]|0);c[(PC(sa,Eb)|0)>>2]=fb;QN(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[I>>2]=80744;pt(4,1,80616,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=OC(ub,Fb)|0;tC(mb,kb+(ib*60|0)|0);BC(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Gb,80656);kb=(oO(vC(mb,Gb)|0,78792)|0)==0;QN(Gb);if(!kb){break}c[H>>2]=c[gb>>2];pt(4,0,80672,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);KN(Hb,c[gb>>2]|0);c[(PC(sa,Hb)|0)>>2]=ib;QN(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[G>>2]=80768;pt(4,1,80616,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=OC(ib,Ib)|0;tC(mb,ub+(lb*48|0)|0);CC(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Jb,80656);ub=(oO(vC(mb,Jb)|0,78792)|0)==0;QN(Jb);if(!ub){break}c[F>>2]=c[fb>>2];pt(4,0,80672,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);KN(Kb,c[fb>>2]|0);c[(PC(sa,Kb)|0)>>2]=lb;QN(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[E>>2]=80792;pt(4,1,80616,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=OC(lb,Lb)|0;tC(mb,ib+(rb*52|0)|0);DC(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Mb,80656);ib=(oO(vC(mb,Mb)|0,78792)|0)==0;QN(Mb);if(!ib){break}c[D>>2]=c[gb>>2];pt(4,0,80672,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);KN(Nb,c[gb>>2]|0);c[(PC(sa,Nb)|0)>>2]=rb;QN(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[C>>2]=80816;pt(4,1,80616,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=OC(rb,Ob)|0;tC(mb,lb+(pb*112|0)|0);yC(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Pb,80656);lb=(oO(vC(mb,Pb)|0,78792)|0)==0;QN(Pb);if(!lb){break}c[B>>2]=c[fb>>2];pt(4,0,80672,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);KN(Qb,c[fb>>2]|0);c[(PC(ua,Qb)|0)>>2]=pb;QN(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[A>>2]=80832;pt(4,1,80616,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=OC(pb,Rb)|0;tC(mb,rb+(nb*60|0)|0);BC(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Sb,80656);rb=(oO(vC(mb,Sb)|0,78792)|0)==0;QN(Sb);if(!rb){break}c[z>>2]=c[gb>>2];pt(4,0,80672,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);KN(Tb,c[gb>>2]|0);c[(PC(ua,Tb)|0)>>2]=nb;QN(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[y>>2]=80856;pt(4,1,80616,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=OC(nb,Ub)|0;tC(mb,pb+(ja*48|0)|0);CC(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Vb,80656);pb=(oO(vC(mb,Vb)|0,78792)|0)==0;QN(Vb);if(!pb){break}c[x>>2]=c[fb>>2];pt(4,0,80672,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);KN(Wb,c[fb>>2]|0);c[(PC(ua,Wb)|0)>>2]=ja;QN(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}c[w>>2]=80880;pt(4,1,80616,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=OC(ja,Xb)|0;tC(mb,nb+(tb*52|0)|0);DC(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[91948>>2]|0)!=0){break}KN(Yb,80656);nb=(oO(vC(mb,Yb)|0,78792)|0)==0;QN(Yb);if(!nb){break}c[v>>2]=c[gb>>2];pt(4,0,80672,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);KN(Zb,c[gb>>2]|0);c[(PC(ua,Zb)|0)>>2]=tb;QN(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}pt(4,1,80904,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=OC(tb,_b)|0;tC(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);EN($b);c[bc>>2]=ja;mb=OC(tb,bc)|0;KN(cc,80944);GN(ac,vC(mb,cc)|0);QC(ac,$b);QN(ac);QN(cc);mb=(oO($b,80952)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;pt(4,0,80968,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=OC(tb,ec)|0;KN(fc,81008);GN(dc,vC(nb,fc)|0);QC(dc,$b);QN(dc);QN(fc);RC(wa,sa,$b);RC(xa,ua,$b);TC(gc,sa);do{if(SC(wa,gc)|0){nb=c[(UC(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{TC(hc,ua);if(SC(xa,hc)|0){fb=c[(UC(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((oO($b,81024)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);QN($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}zO(kc,81032,$b);HC(ic,kc,81056);QN(kc);c[s>>2]=lO(ic)|0;tt(0,81072,s)}}while(0);if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}pt(4,1,81080,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=OC(ja,lc)|0;tC(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);EN(mc);c[oc>>2]=tb;gb=OC(ja,oc)|0;KN(pc,80944);GN(nc,vC(gb,pc)|0);QC(nc,mc);QN(nc);QN(pc);gb=(oO(mc,80952)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;pt(4,0,80968,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=OC(ja,rc)|0;KN(sc,81008);GN(qc,vC(fb,sc)|0);QC(qc,mc);QN(qc);QN(sc);RC(wa,sa,mc);RC(xa,ua,mc);TC(tc,sa);if(SC(wa,tc)|0){fb=c[(UC(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{TC(uc,ua);if(!(SC(xa,uc)|0)){break}nb=c[(UC(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}QN(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}zO(wc,81120,mc);HC(vc,wc,81056);QN(wc);c[o>>2]=lO(vc)|0;tt(0,81072,o)}}while(0);if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}pt(4,1,81144,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=OC(tb,xc)|0;tC(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);EN(yc);c[Ac>>2]=ja;fb=OC(tb,Ac)|0;KN(Bc,80944);GN(zc,vC(fb,Bc)|0);QC(zc,yc);QN(zc);QN(Bc);fb=(oO(yc,80952)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;pt(4,0,80968,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=OC(tb,Dc)|0;KN(Ec,81008);GN(Cc,vC(gb,Ec)|0);QC(Cc,yc);QN(Cc);QN(Ec);RC(wa,sa,yc);RC(xa,ua,yc);TC(Fc,sa);if(SC(wa,Fc)|0){gb=c[(UC(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{TC(Gc,ua);if(!(SC(xa,Gc)|0)){break}nb=c[(UC(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}QN(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}zO(Ic,81184,yc);HC(Hc,Ic,81056);QN(Ic);c[l>>2]=lO(Hc)|0;tt(0,81072,l)}}while(0);if((c[35168>>2]|0)!=0){ae[c[8926]&255](4)}pt(4,1,81208,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=OC(ja,Jc)|0;tC(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);EN(Kc);c[Mc>>2]=tb;gb=OC(ja,Mc)|0;KN(Nc,80944);GN(Lc,vC(gb,Nc)|0);QC(Lc,Kc);QN(Lc);QN(Nc);gb=(oO(Kc,80952)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;pt(4,0,80968,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=OC(ja,Pc)|0;KN(Qc,81008);GN(Oc,vC(fb,Qc)|0);QC(Oc,Kc);QN(Oc);QN(Qc);RC(wa,sa,Kc);RC(xa,ua,Kc);TC(Rc,sa);if(SC(wa,Rc)|0){fb=c[(UC(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{TC(Sc,ua);if(!(SC(xa,Sc)|0)){break}nb=c[(UC(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}QN(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}zO(Uc,81248,Kc);HC(Tc,Uc,81056);QN(Uc);c[f>>2]=lO(Tc)|0;tt(0,81072,f)}}while(0);if((c[35168>>2]|0)==0){qo(pa);VC(ua);VC(sa);QN(ra);WC(qa);i=e;return}ae[c[8926]&255](4);qo(pa);VC(ua);VC(sa);QN(ra);WC(qa);i=e;return}}while(0);if((c[35240>>2]|c[8786]|0)==0){qo(pa);Zc=qd(0)|0;xd(-1)}rt(22,1,80136,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;rt(22,0,80184,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;rt(22,0,80232,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;rt(22,0,80280,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;rt(22,0,80328,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;rt(22,0,80376,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;rt(22,0,80424,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;rt(22,0,80472,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;rt(22,0,80520,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;rt(22,0,80568,P);ae[c[8926]&255](22);qo(pa);Zc=qd(0)|0;xd(-1)}function FC(a){a=a|0;var b=0;b=i;HJ(a);i=b;return}function GC(a,b){a=a|0;b=b|0;b=i;mF(a,0);i=b;return}function HC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;FN(a,d);e=ON(b)|0;f=uD(c)|0;pO(a,PN(b)|0,e,f+e|0);hO(a,c,f)|0;i=d;return}function IC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((tY(b,81880)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{KN(g,v);w=vC(u,g)|0;SN(w,c[d+((t|1)<<2)>>2]|0)|0;QN(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((tY(b,81904)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{KN(h,g);u=vC(t,h)|0;SN(u,c[d+((v|1)<<2)>>2]|0)|0;QN(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((tY(b,81928)|0)!=0){do{if((tY(b,82184)|0)!=0){if((tY(b,82192)|0)==0){break}if((tY(b,82200)|0)==0){break}if((tY(b,82208)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=OC(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){KN(r,c[t>>2]|0);w=vC(g,r)|0;SN(w,c[d+((u|1)<<2)>>2]|0)|0;QN(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=OC(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}KN(s,82216);SN(vC(x,s)|0,b)|0;QN(s);i=e;return}XC(j,k);EN(l);EN(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{KN(n,g);t=vC(j,n)|0;SN(t,c[d+((x|1)<<2)>>2]|0)|0;QN(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}KN(o,81944);RN(l,vC(j,o)|0)|0;QN(o);KN(p,81960);RN(m,vC(j,p)|0)|0;QN(p);c[k>>2]=Fc(lO(l)|0)|0;if((oO(m,81976)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((oO(m,81984)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((oO(m,81992)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((oO(m,82e3)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((oO(m,82008)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((oO(m,82016)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((oO(m,82024)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((oO(m,82032)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((oO(m,82040)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((oO(m,82048)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((oO(m,82056)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((oO(m,82064)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((oO(m,82072)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((oO(m,82080)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=lO(m)|0;KN(q,78504);N=lO(vC(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;st(0,(O|0)!=0|0,82088,f);QN(q);kI(OC(c[b>>2]|0,s)|0,j)|0;QN(m);QN(l);dD(j);i=e;return}function JC(a,b){a=a|0;b=b|0;i=i;return}function KC(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=XE(a,b)|0;i=c;return d|0}function LC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;eF(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];YE(a,f);i=e;return}function MC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;ZE(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];YE(a,e);i=d;return}



function Ng(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;nu(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(tu(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(tu(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(tu(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(tu(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(tu(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(tu(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(tu(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(tu(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(tu(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(tu(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(tu(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(tu(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(tu(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(tu(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(tu(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(tu(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(tu(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(tu(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(tu(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(tu(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(tu(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(tu(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(tu(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(tu(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(tu(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(tu(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(tu(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(tu(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(tu(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(tu(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(tu(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(tu(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(tu(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(tu(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(tu(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(tu(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(tu(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(tu(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(tu(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(tu(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(tu(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(tu(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(tu(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(tu(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(tu(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(tu(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(tu(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(tu(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(tu(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(tu(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(tu(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(tu(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(tu(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(tu(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(tu(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(tu(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(tu(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(tu(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(tu(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(tu(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(tu(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(tu(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(tu(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(tu(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(tu(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(tu(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(tu(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(tu(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(tu(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(tu(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(tu(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(tu(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(tu(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(tu(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(tu(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(tu(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(tu(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(tu(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(tu(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(tu(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(tu(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(tu(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(tu(Xf,1,se)|0)>>3];c[re>>2]=31;h[(tu(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(tu(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(tu(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(tu(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(tu(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(tu(Xf,1,me)|0)>>3];c[le>>2]=34;h[(tu(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(tu(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(tu(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(tu(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(tu(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(tu(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(tu(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(tu(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(tu(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(tu(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(tu(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(tu(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(tu(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(tu(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(tu(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(tu(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(tu(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(tu(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(tu(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(tu(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(tu(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(tu(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(tu(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(tu(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(tu(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(tu(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(tu(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(tu(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(tu(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(tu(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(tu(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(tu(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(tu(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(tu(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(tu(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(tu(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(tu(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(tu(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(tu(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(tu(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(tu(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(tu(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(tu(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(tu(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(tu(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(tu(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(tu(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(tu(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(tu(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(tu(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function Og(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0;e=i;i=i+88|0;f=e;Ng(f,b,c,d);h[a>>3]=c/(+h[f+16>>3]*+h[f+24>>3]*+h[f+48>>3]*d);i=e;return}function Pg(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;mg(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function Qg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(tu(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[21062]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=6928;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];De[f&31](b,j,4248,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function Rg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;Gg(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+Tu(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function Sg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Rg(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Tg(b,0,0.0,0.0,g);i=f;return}function Tg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Ug(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(tu(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[21062]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=6928;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4320,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(tu(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function Vg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function Wg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Rg(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Vg(b,0,0.0,0.0,g);i=f;return}function Xg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(tu(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[21062]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=6928;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4248,m);}c[l>>2]=1;h[a>>3]=+h[(tu(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function Yg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(tu(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(tu(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(tu(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(tu(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];su(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];Xg(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[21062]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=6928;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];De[l&31](b,j,4392,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function Zg(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function _g(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function $g(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(tu(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(tu(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[21062]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=6928;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];De[f&31](b,j,4616,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function ah(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function bh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function ch(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function dh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;nu(n,1,m);m=n;n=3960;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[21062]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=6928;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];De[m&31](b,g,4704,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[21062]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=6928;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];De[g&31](b,f,4784,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function eh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){Dg(j,0,d);m=+h[j>>3];Pg(k,b,c);n=+h[k>>3];o=m}else{Cg(f,b,d);m=+h[f>>3];dh(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}fh(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function fh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function gh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(tu(f,1,n)|0)>>3]==0.0){pg(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];hh(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(tu(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(tu(f,1,l)|0)>>3]);ih(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){pg(u,b,G,e);J=+h[u>>3];Mg(v,b,F,e,0);K=J+I*+h[v>>3];break}else{pg(r,b,G,e);J=+h[r>>3];Mg(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];jh(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){pg(w,b,G,e);L=+h[w>>3];Mg(x,b,F,e,0);J=+h[x>>3];Sg(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{pg(z,b,G,e);J=+h[z>>3];Mg(A,b,F,e,0);L=+h[A>>3];kh(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function hh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(tu(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(tu(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(tu(f,1,j)|0)>>3]);eh(m,b,d,e);r=+h[m>>3];ih(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function ih(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;eh(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){dh(j,b,c);l=+h[j>>3]}else{Pg(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function jh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;nu(Na,1,Ma);c[La>>2]=4;nu(Oa,1,La);c[Ka>>2]=4;nu(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(tu(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(tu(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(tu(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(tu(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];su(Qa,4,ob,Fa);ou(Qa,Oa);Qa=(wg(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+lu(4920,Fa+ -1|0);c[Ea>>2]=Fa;h[(tu(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((wg(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(tu(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(tu(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(tu(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(tu(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(tu(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(tu(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(tu(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(tu(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(tu(Oa,1,va)|0)>>3];pb=sb*(ob/+lu(4920,Qa+ -1|0));c[ua>>2]=Qa;h[(tu(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((wg(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(tu(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(tu(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(tu(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(tu(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];su(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];Xg($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(tu(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(tu(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(tu(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(tu(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];su(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];Ug(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(tu(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(tu(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(tu(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(tu(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];su(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];Yg(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(tu(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(tu(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(tu(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(tu(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];su(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];Qg(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(tu(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(tu(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(tu(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(tu(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];su(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];$g(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(tu(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(tu(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(tu(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(tu(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];su(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];Xg(eb,b,d,e,o);tb=+h[eb>>3];_g(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(tu(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(tu(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(tu(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(tu(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];su(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];Ug(gb,b,d,e,n);qb=+h[gb>>3];ah(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(tu(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(tu(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(tu(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(tu(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];su(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];Yg(ib,b,d,e,m);vb=+h[ib>>3];Zg(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(tu(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(tu(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(tu(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(tu(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];su(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];Qg(kb,b,d,e,l);d=+h[kb>>3];ch(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(tu(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(tu(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(tu(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(tu(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];su(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];$g(mb,b,0.0,e,j);yb=+h[mb>>3];bh(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(tu(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(tu(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(tu(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(tu(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function kh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;jj(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));Lj(f,0,0.0,0.0,h);i=g;return}function lh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(tu(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(tu(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];su(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];gh(d,b,o,p,f);i=e;return}function mh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;nu(u,1,n);c[m>>2]=2;nu(u,1,m);if((ft(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];og(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +vu(f);su(q,1,w,l);c[k>>2]=q;uu(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];og(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];ou(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function nh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;g=i;i=i+24|0;j=g;k=g+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[m>>2]=1;if(+h[(tu(f,1,m)|0)>>3]==0.0){xg(n,b,d,e);y=+h[n>>3];z=a;A=z;h[A>>3]=y;i=g;return}c[l>>2]=1;B=+h[(tu(f,1,l)|0)>>3];c[k>>2]=1;C=B/(1.0- +h[(tu(f,1,k)|0)>>3]);ih(o,b,d,e);B=+h[o>>3];o=j;k=f;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];hh(p,b,d,e,j);D=+h[p>>3];E=d-D;p=e<273.16;if(C<=B|B==-1.0){if(p){xg(q,b,E,e);y=+h[q>>3]+D/(e*461.51805);z=a;A=z;h[A>>3]=y;i=g;return}else{xg(r,b,E,e);F=+h[r>>3];Og(s,b,D,e);y=F+ +h[s>>3];z=a;A=z;h[A>>3]=y;i=g;return}}else{if(p){xg(t,b,E,e);F=+h[t>>3];Wg(u,b,d,e);y=(C+1.0)/((B+1.0)/(F+D/(e*461.51805))+(C-B)/+h[u>>3]);z=a;A=z;h[A>>3]=y;i=g;return}else{xg(v,b,E,e);E=+h[v>>3];Og(w,b,D,e);D=+h[w>>3];oh(x,b,d,e,0);y=(C+1.0)/((B+1.0)/(E+D)+(C-B)/+h[x>>3]);z=a;A=z;h[A>>3]=y;i=g;return}}}function oh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;jj(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));tj(f,0,0.0,0.0,h);i=g;return}function ph(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;c[l>>2]=1;if(+h[(tu(f,1,l)|0)>>3]==0.0){p=0.0;q=a;r=q;h[r>>3]=p;i=g;return}c[k>>2]=1;s=+h[(tu(f,1,k)|0)>>3];c[j>>2]=1;t=s/(1.0- +h[(tu(f,1,j)|0)>>3]);if(!(e>=273.16)){Dg(n,0,e);u=+h[n>>3]}else{qh(m,b,e);u=+h[m>>3]}fh(o,0,0.0,0.0);e=u*+h[o>>3];u=t*(d/(t+.6221042453709779));if(!(u<=e)){p=-1.0;q=a;r=q;h[r>>3]=p;i=g;return}p=u/e;q=a;r=q;h[r>>3]=p;i=g;return}function qh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;nu(I,1,H);J=+od(+d,647.096);if(!(d>=273.16)){H=c[21062]|0;K=f;L=7040;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];De[H&31](b,f,7064,G);}c[F>>2]=1;h[(tu(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(tu(I,1,E)|0)>>3];c[D>>2]=2;h[(tu(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(tu(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(tu(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(tu(I,1,A)|0)>>3];c[z>>2]=4;h[(tu(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(tu(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(tu(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(tu(I,1,w)|0)>>3];c[v>>2]=6;h[(tu(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(tu(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(tu(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(tu(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(tu(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(tu(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(tu(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(tu(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(tu(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(tu(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(tu(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(tu(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(tu(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(tu(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function rh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];mh(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];lh(j,b,h);i=g;return}function sh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;th(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function _omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(tu(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(tu(l,1,pb)|0)>>3];c[qb>>2]=55;h[(tu(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[21062]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[6928+0>>2];c[a+4>>2]=c[6928+4>>2];c[a+8>>2]=c[6928+8>>2];c[a+12>>2]=c[6928+12>>2];c[a+16>>2]=c[6928+16>>2];c[a+20>>2]=c[6928+20>>2];De[td&31](d,a,4104,rb);}c[sb>>2]=9;sd=+h[(tu(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(tu(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(tu(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(tu(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(tu(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(tu(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(tu(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(tu(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(tu(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(tu(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(tu(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(tu(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(tu(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(tu(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(tu(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(tu(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(tu(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(tu(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(tu(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(tu(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(tu(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(tu(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(tu(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(tu(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(tu(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(tu(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(tu(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(tu(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(tu(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(tu(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(tu(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(tu(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(tu(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(tu(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(tu(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(tu(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(tu(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(tu(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(tu(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(tu(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(tu(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(tu(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(tu(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(tu(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(tu(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(tu(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(tu(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(tu(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(tu(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(tu(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(tu(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(tu(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(tu(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(tu(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(tu(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(tu(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(tu(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(tu(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(tu(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(tu(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(tu(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(tu(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(tu(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(tu(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(tu(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(tu(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(tu(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(tu(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(tu(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(tu(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(tu(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(tu(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(tu(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(tu(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(tu(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(tu(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(tu(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(tu(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(tu(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(tu(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(tu(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(tu(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(tu(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(tu(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(tu(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(tu(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(tu(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(tu(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(tu(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(tu(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(tu(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(tu(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(tu(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(tu(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(tu(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(tu(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(tu(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(tu(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(tu(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(tu(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(tu(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(tu(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(tu(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(tu(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(tu(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(tu(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(tu(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(tu(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(tu(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(tu(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(tu(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(tu(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(tu(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(tu(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(tu(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(tu(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(tu(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(tu(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(tu(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(tu(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(tu(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(tu(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(tu(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(tu(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(tu(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(tu(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(tu(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(tu(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(tu(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(tu(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(tu(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(tu(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(tu(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(tu(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(tu(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(tu(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(tu(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(tu(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(tu(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(tu(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(tu(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(tu(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(tu(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(tu(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(tu(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(tu(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(tu(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(tu(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(tu(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(tu(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(tu(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(tu(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(tu(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(tu(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(tu(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(tu(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(tu(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(tu(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(tu(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(tu(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(tu(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(tu(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(tu(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(tu(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(tu(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(tu(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(tu(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(tu(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(tu(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(tu(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(tu(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(tu(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(tu(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(tu(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(tu(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(tu(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(tu(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(tu(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(tu(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(tu(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(tu(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(tu(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(tu(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(tu(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(tu(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(tu(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(tu(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(tu(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(tu(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(tu(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(tu(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(tu(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(tu(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(tu(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(tu(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(tu(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(tu(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(tu(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(tu(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(tu(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(tu(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(tu(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(tu(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(tu(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(tu(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(tu(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(tu(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(tu(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(tu(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(tu(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(tu(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(tu(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(tu(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(tu(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(tu(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(tu(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(tu(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}



function wo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((xo(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=zo(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{zY(f|0,b|0,d|0)|0;j=Ao(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ce[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=38;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){De[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function xo(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=up()|0}if((a[e+236|0]|0)!=0){f=po(e,26200)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function yo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function zo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;AY(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=de[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;zY(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;ae[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Ao(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((xo(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ce[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=38;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);De[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Bo(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Co(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}De[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Do(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){ze[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Zd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];ze[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Eo(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[24424+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;zY((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=se[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=de[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){zY(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Go(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Ho(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Io(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=de[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){BY(c[m>>2]|0,0,g|0)|0;g=Jo(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Jo(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Ko(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=de[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}BY(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Jo(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}ae[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=de[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){BY(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Jo(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Ko(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Lo(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}ae[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}ae[e&255](c[d>>2]|0);i=b;return}function Mo(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[26008+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[26048+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=se[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=de[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=de[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}ae[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;zY(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}ze[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function No(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ge[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=tp(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Oo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Po(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function Po(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=te[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 6:{a[o+489|0]=0;c[o+316>>2]=Io(o,l+132|0,26080,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}t=Ro(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=43;break a}So(t);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=t;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Ro(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Zd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;mo(o+416|0);h=0;break};case 57:{u=Qo(o,1,e,c[n>>2]|0)|0;if((u|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=Vo(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 1:{v=Qo(o,0,e,c[n>>2]|0)|0;if((v|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Zd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);mo(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;t=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Io(o,l+132|0,26080,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=t;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}ae[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=Uo(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=26184}else{x=(s|0)==32?26168:26192}if((Wo(o+416|0,x)|0)==0){r=111;break a}if((Xo(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=26088;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=26096;r=102;break};case 25:{c[o+332>>2]=26104;r=102;break};case 26:{c[o+332>>2]=26112;r=102;break};case 27:{c[o+332>>2]=26120;r=102;break};case 28:{c[o+332>>2]=26128;r=102;break};case 29:{c[o+332>>2]=26144;r=102;break};case 30:{c[o+332>>2]=26152;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((Yo(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Fo(o+416|0)|0)<<24>>24!=0)){r=128;break a}}t=o+428|0;w=c[t>>2]|0;c[t>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Fo(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;t=c[w>>2]|0;c[w>>2]=t+1;a[t]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);mo(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;t=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Ro(t+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[t+324>>2]=26080}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Io(o,l+132|0,26080,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=Zo(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}t=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((Yo(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,t,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Fo(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Fo(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,t,(s|0)==38|0);mo(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=_o(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=Ro(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;me[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((ge[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}t=Ro(w,b,e,c[n>>2]|0)|0;if((t|0)==0){r=190;break a}c[o+316>>2]=Io(o,l,t,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(t|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}t=Ro(w,b,e,c[n>>2]|0)|0;if((t|0)==0){r=202;break a}c[o+316>>2]=Io(o,l+132|0,t,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(t|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Do(o,b,e,c[n>>2]|0)}h=0;D=$o(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Ro(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=Ro(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}So(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=Ro(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Zd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);mo(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Zd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);mo(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){t=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=de[t&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}t=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=se[t&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=se[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=bp(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=Ro(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=Io(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}ze[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=cp(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=Uo(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=de[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;ze[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((fp(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((ep(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Ro(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=bp(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=Uo(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=dp(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;ze[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=Ro(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}So(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Do(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ce[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((te[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=v;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=u;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){u=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}v=Io(o,l+132|0,26080,36)|0;if((v|0)==0){I=1;J=I;i=m;return J|0}c[v+20>>2]=c[o+360>>2];a[l+131|0]=0;if((te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[v+20>>2]|0,c[v+16>>2]|0,c[v+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=39;I=To(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=40;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Qo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ce[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Ro(n+440|0,p,b,s+(se[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Ro(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);De[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Do(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Ro(n+440|0,e,d,m+(se[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=tp(n,f)|0;mo(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){mo(n+440|0)}q=0;r=q;i=g;return r|0}function Ro(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((Xo(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Fo(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function So(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function To(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=ip(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((qp(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Uo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Ro(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Io(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((rp(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function Vo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Fo(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Ro(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Io(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Io(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Fo(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Fo(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Io(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function Wo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Fo(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function Xo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Fo(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Zd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Fo(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function Yo(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=de[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=se[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function Zo(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=sp(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Fo(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function _o(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Fo(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ce[c[b+20>>2]&63](b,e,f,j)|0){case-4:{r=24;break a;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 10:{s=se[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=zp(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Fo(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-1:{r=46;break a;break};case 7:{r=28;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=Ro(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=Io(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=_o(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(te[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 6:case 9:{if((Xo(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 0:{r=49;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Fo(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function $o(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ce[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case 42:{if((c[k+80>>2]|0)!=0){Do(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function ap(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=$o(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=41;k=Oo(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function bp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=de[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=se[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=de[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function cp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=de[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ce[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Po(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=ip(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=42;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=de[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;hp(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function ep(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Do(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(se[c[a+32>>2]&63](a,b)|0)|0;k=Ro(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=se[c[a+36>>2]&63](a,e)|0;e=Ro(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){gp(e);ze[c[g+64>>2]&15](c[g+4>>2]|0,k,e);mo(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function fp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Do(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Ro(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){gp(k);be[c[g+68>>2]&63](c[g+4>>2]|0,k);mo(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function gp(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function hp(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}hp(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function ip(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ce[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-2:{B=28;break a;break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){D=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{D=de[c[C+12>>2]&127](48)|0;if((D|0)==0){B=72;break a}c[D+36>>2]=de[c[y+12>>2]&127](32)|0;if((c[D+36>>2]|0)==0){B=74;break a}c[D+40>>2]=(c[D+36>>2]|0)+32}c[D+44>>2]=0;c[D>>2]=c[y+364>>2];c[y+364>>2]=D;c[D+16>>2]=0;c[D+20>>2]=0;c[D+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[D+8>>2]=se[c[e+32>>2]&63](e,c[D+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[D+4>>2]|0)+(c[D+8>>2]|0)|0;c[r>>2]=c[D+4>>2];c[q>>2]=c[D+36>>2];while(1){Zd[c[e+60>>2]&31](e,r,C,q,(c[D+40>>2]|0)+ -1|0);E=(c[q>>2]|0)-(c[D+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}F=(c[D+40>>2]|0)-(c[D+36>>2]|0)<<1;G=se[c[y+16>>2]&63](c[D+36>>2]|0,F)|0;if((G|0)==0){B=80;break a}c[D+36>>2]=G;c[D+40>>2]=G+F;c[q>>2]=G+E}c[D+24>>2]=E;c[D+12>>2]=c[D+36>>2];a[c[q>>2]|0]=0;H=lp(y,e,c[m>>2]|0,D+12|0,D+44|0)|0;if((H|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){ze[c[C+52>>2]&15](c[y+4>>2]|0,c[D+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Do(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);mo(y+416|0);break};case-3:{B=6;break a;break};case-4:{B=17;break a;break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;ze[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{C=se[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((C|0)<0){B=135;break a}G=y;if((c[y+60>>2]|0)!=0){F=c[G+60>>2]|0;I=c[y+4>>2]|0;J=zp(C,u)|0;ze[F&15](I,u,J);break b}if((c[G+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break};case 9:{a[p]=ge[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){G=y;if((c[y+60>>2]|0)!=0){ze[c[G+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[G+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break b}G=Ro(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((G|0)==0){B=37;break a}J=Io(y,k,G,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((J|0)!=0){break}I=y;if((c[y+120>>2]|0)!=0){ze[c[I+120>>2]&15](c[y+4>>2]|0,G,0);break b}if((c[I+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((J|0)==0){B=41;break a}if((a[J+34|0]|0)==0){B=43;break a}}if((a[J+32|0]|0)!=0){B=50;break a}if((c[J+28>>2]|0)!=0){B=52;break a}G=y;if((c[J+4>>2]|0)!=0){I=y;if((a[G+308|0]|0)!=0){K=cp(I,J,0)|0;if((K|0)!=0){B=60;break a}else{break b}}F=y;if((c[I+120>>2]|0)!=0){ze[c[F+120>>2]&15](c[y+4>>2]|0,c[J>>2]|0,0);break b}if((c[F+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[G+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[J+32|0]=1;G=kp(y)|0;a[J+32|0]=0;if((G|0)==0){B=63;break a}if((te[c[y+112>>2]&63](c[y+116>>2]|0,G,c[J+20>>2]|0,c[J+16>>2]|0,c[J+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 3:case 4:{G=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;F=1;c[t>>2]=Ro(y+416|0,e,G,G+(se[c[e+32>>2]&63](e,G)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];L=lp(y,e,c[m>>2]|0,t,s)|0;if((L|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){ze[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);F=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}be[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);F=0}do{if((F&255|0)!=0){if((c[y+80>>2]|0)==0){break}Do(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);mo(y+416|0);while(1){if((c[s>>2]|0)==0){break}F=c[s>>2]|0;if((c[y+104>>2]|0)!=0){be[c[y+104>>2]&63](c[y+4>>2]|0,c[c[F>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[F+4>>2]=c[y+376>>2];c[y+376>>2]=F;c[(c[F>>2]|0)+4>>2]=c[F+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 8:{F=y;do{if((c[y+72>>2]|0)!=0){ae[c[F+72>>2]&255](c[y+4>>2]|0)}else{if((c[F+80>>2]|0)==0){break}Do(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);M=np(y,e,n,g,h,j)|0;if((M|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{F=c[y+60>>2]|0;if((F|0)==0){if((c[y+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){ze[F&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Zd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];ze[F&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((ep(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((fp(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}F=c[y+364>>2]|0;c[y+364>>2]=c[F>>2];c[F>>2]=c[y+368>>2];c[y+368>>2]=F;N=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;J=se[c[e+32>>2]&63](e,N)|0;if((J|0)!=(c[F+8>>2]|0)){B=112;break a}if((sY(c[F+4>>2]|0,N,J)|0)!=0){B=112;break a}J=y+312|0;c[J>>2]=(c[J>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){J=c[F+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((J|0)==0){break}G=(c[F+12>>2]|0)+(c[F+28>>2]|0)|0;while(1){if((a[J]|0)==0){break}I=J;J=I+1|0;C=G;G=C+1|0;a[C]=a[I]|0}I=c[F+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((I|0)==0){break}C=G;G=C+1|0;a[C]=a[y+472|0]|0;while(1){if((a[I]|0)==0){break c}C=I;I=C+1|0;O=G;G=O+1|0;a[O]=a[C]|0}}}while(0);a[G]=0}}while(0);be[c[y+56>>2]&63](c[y+4>>2]|0,c[F+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Do(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[F+44>>2]|0)==0){break}J=c[F+44>>2]|0;if((c[y+104>>2]|0)!=0){be[c[y+104>>2]&63](c[y+4>>2]|0,c[c[J>>2]>>2]|0)}c[F+44>>2]=c[(c[F+44>>2]|0)+4>>2];c[J+4>>2]=c[y+376>>2];c[y+376>>2]=J;c[(c[J>>2]|0)+4>>2]=c[J+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Do(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;ze[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Do(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=K;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){ae[c[y+20>>2]&255](D);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=H;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=L;Q=P;i=l;return Q|0}else if((B|0)==107){P=mp(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=N;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=mp(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=M;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=43;P=M;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){ze[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Zd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);ze[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Do(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function jp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ce[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Po(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=ip(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=41;m=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Po(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=ip(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function kp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Fo(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Go(e,b+60|0);a:while(1){k=Ho(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Fo(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Fo(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Go(e,b);b:while(1){b=Ho(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Fo(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Fo(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}



function WX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[125112>>2]|0;if(d>>>0<f>>>0){ed()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){ed()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){ed()}if((p|0)==(c[125116>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[125104>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=125136+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){ed()}if((c[m+12>>2]|0)==(p|0)){break}ed()}}while(0);if((u|0)==(m|0)){c[31274]=c[31274]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){ed()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}ed()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){ed()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){ed()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){ed()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{ed()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=125400+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[125112>>2]|0)>>>0){ed()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[125112>>2]|0)>>>0){ed()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){ed()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){ed()}do{if((C&2|0)==0){if((l|0)==(c[125120>>2]|0)){f=(c[125108>>2]|0)+t|0;c[125108>>2]=f;c[125120>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[125116>>2]|0)){i=b;return}c[125116>>2]=0;c[125104>>2]=0;i=b;return}if((l|0)==(c[125116>>2]|0)){f=(c[125104>>2]|0)+t|0;c[125104>>2]=f;c[125116>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=125136+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[125112>>2]|0)>>>0){ed()}if((c[E+12>>2]|0)==(l|0)){break}ed()}}while(0);if((w|0)==(E|0)){c[31274]=c[31274]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[125112>>2]|0)>>>0){ed()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}ed()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[125112>>2]|0)>>>0){ed()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){ed()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{ed()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=125400+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<g);break b}else{if(d>>>0<(c[125112>>2]|0)>>>0){ed()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[125112>>2]|0)>>>0){ed()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[125116>>2]|0)){J=f;break}c[125104>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=125136+(C<<2)|0;G=c[31274]|0;j=1<<t;do{if((G&j|0)==0){c[31274]=G|j;K=125136+(C+2<<2)|0;L=e}else{t=125136+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[125112>>2]|0)>>>0)){K=t;L=a;break}ed()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=125400+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[125100>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[125100>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[125112>>2]|0;if(O>>>0<K>>>0){ed()}if(f>>>0<K>>>0){ed()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[125128>>2]|0)+ -1|0;c[125128>>2]=s;if((s|0)==0){Q=125552|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[125128>>2]=-1;i=b;return}function XX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=VX(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}BY(b|0,0,e|0)|0;i=d;return b|0}function YX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=VX(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=ZX(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=VX(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;zY(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;WX(a);e=g;i=d;return e|0}function ZX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[125112>>2]|0;if(h>>>0<l>>>0){ed()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){ed()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){ed()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[125576>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;_X(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[125120>>2]|0)){m=(c[125108>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[125120>>2]=a+b;c[125108>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[125116>>2]|0)){h=(c[125104>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[125104>>2]=r;c[125116>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=125136+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){ed()}if((c[h+12>>2]|0)==(k|0)){break}ed()}}while(0);if((m|0)==(h|0)){c[31274]=c[31274]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){ed()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}ed()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){ed()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){ed()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{ed()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=125400+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<u);break a}else{if(t>>>0<(c[125112>>2]|0)>>>0){ed()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[125112>>2]|0)>>>0){ed()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;_X(a+b|0,r);o=a;i=d;return o|0}return 0}function _X(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[125112>>2]|0;if(j>>>0<m>>>0){ed()}if((k|0)==(c[125116>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[125104>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=125136+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){ed()}if((c[q+12>>2]|0)==(k|0)){break}ed()}}while(0);if((r|0)==(q|0)){c[31274]=c[31274]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){ed()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}ed()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){ed()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){ed()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{ed()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=125400+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[125112>>2]|0)>>>0){ed()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[125112>>2]|0)>>>0){ed()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[125112>>2]|0;if(e>>>0<z>>>0){ed()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[125120>>2]|0)){t=(c[125108>>2]|0)+p|0;c[125108>>2]=t;c[125120>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[125116>>2]|0)){i=d;return}c[125116>>2]=0;c[125104>>2]=0;i=d;return}if((f|0)==(c[125116>>2]|0)){t=(c[125104>>2]|0)+p|0;c[125104>>2]=t;c[125116>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=125136+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){ed()}if((c[u+12>>2]|0)==(f|0)){break}ed()}}while(0);if((h|0)==(u|0)){c[31274]=c[31274]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){ed()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}ed()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){ed()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){ed()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){ed()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{ed()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=125400+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[125100>>2]=c[125100>>2]&~(1<<j);break b}else{if(m>>>0<(c[125112>>2]|0)>>>0){ed()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[125112>>2]|0)>>>0){ed()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[125112>>2]|0)>>>0){ed()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[125116>>2]|0)){G=t;break}c[125104>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=125136+(B<<2)|0;D=c[31274]|0;b=1<<p;do{if((D&b|0)==0){c[31274]=D|b;H=125136+(B+2<<2)|0;I=A}else{p=125136+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[125112>>2]|0)>>>0)){H=p;I=a;break}ed()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=125400+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[125100>>2]|0;B=1<<J;if((a&B|0)==0){c[125100>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[125112>>2]|0)>>>0){ed()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[125112>>2]|0;if(L>>>0<B>>>0){ed()}if(G>>>0<B>>>0){ed()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function $X(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=VX(d)|0;if((e|0)!=0){f=6;break}a=c[31398]|0;c[31398]=0+a;if((a|0)==0){f=5;break}Ae[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=125608;Od(d|0,125656,136)}else if((f|0)==6){i=b;return e|0}return 0}function aY(a){a=a|0;var b=0,c=0;b=i;c=$X(a)|0;i=b;return c|0}function bY(a){a=a|0;var b=0;b=i;if((a|0)!=0){WX(a)}i=b;return}function cY(a){a=a|0;var b=0;b=i;bY(a);i=b;return}function dY(a){a=a|0;var b=0;b=i;zb(a|0);bY(a);i=b;return}function eY(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function fY(a){a=a|0;i=i;return 125624}function gY(){var a=0;a=Ec(4)|0;c[a>>2]=125608;Od(a|0,125656,136)}function hY(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0.0,xc=0,yc=0,Ac=0.0,Bc=0.0,Cc=0.0,Dc=0.0,Ec=0.0,Fc=0.0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0.0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=kY(b)|0}}while((gd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=kY(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[125672+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=kY(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[125688+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=kY(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=kY(b)|0}if((B|0)==40){C=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0}else{D=kY(b)|0}if(!((D+ -48|0)>>>0<10|(D+ -65|0)>>>0<26)){if(!((D+ -97|0)>>>0<26|(D|0)==95)){break}}C=C+1|0}if((D|0)==41){l=+y;i=g;return+l}o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;jY(b,0);l=0.0;i=g;return+l}if((C|0)==0|o){l=+y;i=g;return+l}else{E=C}while(1){o=E+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((o|0)==0){l=+y;break}else{E=o}}i=g;return+l}else if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=d[o]|0}else{F=kY(b)|0}if((F|32|0)!=120){if((c[m>>2]|0)==0){G=48;break}c[e>>2]=(c[e>>2]|0)+ -1;G=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=0}else{H=kY(b)|0;I=0}while(1){if((H|0)==46){v=70;break}else if((H|0)!=48){K=0;L=0;M=0;N=0;O=H;P=I;Q=0;R=0;S=1.0;T=0;V=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=1;continue}else{H=kY(b)|0;I=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;W=d[o]|0}else{W=kY(b)|0}if((W|0)==48){X=-1;Y=-1}else{K=0;L=0;M=0;N=0;O=W;P=I;Q=1;R=0;S=1.0;T=0;V=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;Z=d[o]|0}else{Z=kY(b)|0}if((Z|0)!=48){K=X;L=Y;M=0;N=0;O=Z;P=1;Q=1;R=0;S=1.0;T=0;V=0.0;break b}o=HY(X|0,Y|0,-1,-1)|0;X=o;Y=J}}}while(0);c:while(1){o=O+ -48|0;do{if(o>>>0<10){_=o;v=84}else{q=O|32;n=(O|0)==46;if(!((q+ -97|0)>>>0<6|n)){$=O;break c}if(n){if((Q|0)==0){aa=M;ba=N;ca=M;da=N;ea=P;ga=1;ha=R;ia=S;ja=T;ka=V;break}else{$=46;break c}}else{_=(O|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((N|0)<0|(N|0)==0&M>>>0<8){la=R;ma=S;na=_+(T<<4)|0;oa=V}else{if((N|0)<0|(N|0)==0&M>>>0<14){pa=S*.0625;la=R;ma=pa;na=T;oa=V+pa*+(_|0);break}if(!((_|0)!=0&(R|0)==0)){la=R;ma=S;na=T;oa=V;break}la=1;ma=S;na=T;oa=V+S*.5}}while(0);o=HY(M|0,N|0,1,0)|0;aa=K;ba=L;ca=o;da=J;ea=1;ga=Q;ha=la;ia=ma;ja=na;ka=oa}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=ba;M=ca;N=da;O=d[o]|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}else{K=aa;L=ba;M=ca;N=da;O=kY(b)|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}}if((P|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){jY(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((Q|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(Q|0)==0;q=o?M:K;n=o?N:L;if((N|0)<0|(N|0)==0&M>>>0<8){o=M;p=N;qa=T;while(1){ra=qa<<4;sa=HY(o|0,p|0,1,0)|0;ta=J;if((ta|0)<0|(ta|0)==0&sa>>>0<8){qa=ra;p=ta;o=sa}else{ua=ra;break}}}else{ua=T}do{if(($|32|0)==112){o=iY(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){va=o;wa=p;break}if(u){jY(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0;break}}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0}}while(0);p=CY(q|0,n|0,2)|0;o=HY(p|0,J|0,-32,-1)|0;p=HY(o|0,J|0,va|0,wa|0)|0;o=J;if((ua|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}qa=k+ -106|0;ra=((qa|0)<0)<<31>>31;if((o|0)<(ra|0)|(o|0)==(ra|0)&p>>>0<qa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((ua|0)>-1){qa=p;ra=o;sa=ua;pa=V;while(1){ta=sa<<1;if(!(pa>=.5)){xa=pa;ya=ta}else{xa=pa+-1.0;ya=ta|1}za=pa+xa;ta=HY(qa|0,ra|0,-1,-1)|0;Aa=J;if((ya|0)>-1){qa=ta;ra=Aa;sa=ya;pa=za}else{Ba=ta;Ca=Aa;Da=ya;Ea=za;break}}}else{Ba=p;Ca=o;Da=ua;Ea=V}sa=GY(32,0,k|0,((k|0)<0)<<31>>31|0)|0;ra=HY(Ba|0,Ca|0,sa|0,J|0)|0;sa=J;if(0>(sa|0)|0==(sa|0)&j>>>0>ra>>>0){Fa=(ra|0)<0?0:ra}else{Fa=j}do{if((Fa|0)<53){pa=+(r|0);za=+Md(+(+lY(1.0,84-Fa|0)),+pa);if(!((Fa|0)<32&Ea!=0.0)){Ga=pa;Ha=za;Ia=Da;Ja=Ea;break}ra=Da&1;Ga=pa;Ha=za;Ia=(ra^1)+Da|0;Ja=(ra|0)==0?0.0:Ea}else{Ga=+(r|0);Ha=0.0;Ia=Da;Ja=Ea}}while(0);za=Ga*Ja+(Ha+Ga*+(Ia>>>0))-Ha;if(!(za!=0.0)){c[(Nc()|0)>>2]=34}l=+mY(za,Ba);i=g;return+l}else{G=w}}while(0);o=k+j|0;p=0-o|0;ra=G;sa=0;while(1){if((ra|0)==46){v=139;break}else if((ra|0)!=48){Ka=ra;La=0;Ma=0;Na=sa;Oa=0;break}qa=c[e>>2]|0;if(qa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=qa+1;ra=d[qa]|0;sa=1;continue}else{ra=kY(b)|0;sa=1;continue}}d:do{if((v|0)==139){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Pa=d[ra]|0}else{Pa=kY(b)|0}if((Pa|0)==48){Qa=-1;Ra=-1}else{Ka=Pa;La=0;Ma=0;Na=sa;Oa=1;break}while(1){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Sa=d[ra]|0}else{Sa=kY(b)|0}if((Sa|0)!=48){Ka=Sa;La=Qa;Ma=Ra;Na=1;Oa=1;break d}ra=HY(Qa|0,Ra|0,-1,-1)|0;Qa=ra;Ra=J}}}while(0);sa=h;c[sa>>2]=0;ra=Ka+ -48|0;qa=(Ka|0)==46;e:do{if(ra>>>0<10|qa){n=h+496|0;q=Ka;Aa=qa;ta=ra;Ta=0;Ua=0;Va=La;Wa=Ma;Xa=Na;Ya=Oa;Za=0;_a=0;$a=0;while(1){do{if(Aa){if((Ya|0)==0){ab=Ta;bb=Ua;cb=Ta;db=Ua;eb=Xa;fb=1;gb=Za;hb=_a;ib=$a}else{jb=q;kb=Ta;lb=Ua;mb=Va;nb=Wa;ob=Xa;pb=Za;qb=_a;rb=$a;break e}}else{sb=HY(Ta|0,Ua|0,1,0)|0;tb=J;ub=(q|0)!=48;if((_a|0)>=125){if(!ub){ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}c[n>>2]=c[n>>2]|1;ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}vb=h+(_a<<2)|0;if((Za|0)==0){wb=ta}else{wb=q+ -48+((c[vb>>2]|0)*10|0)|0}c[vb>>2]=wb;vb=Za+1|0;xb=(vb|0)==9;ab=Va;bb=Wa;cb=sb;db=tb;eb=1;fb=Ya;gb=xb?0:vb;hb=(xb&1)+_a|0;ib=ub?sb:$a}}while(0);sb=c[e>>2]|0;if(sb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=sb+1;yb=d[sb]|0}else{yb=kY(b)|0}sb=yb+ -48|0;ub=(yb|0)==46;if(sb>>>0<10|ub){q=yb;Aa=ub;ta=sb;Ta=cb;Ua=db;Va=ab;Wa=bb;Xa=eb;Ya=fb;Za=gb;_a=hb;$a=ib}else{zb=yb;Ab=cb;Bb=db;Cb=ab;Db=bb;Eb=eb;Fb=fb;Gb=gb;Hb=hb;Ib=ib;v=162;break}}}else{zb=Ka;Ab=0;Bb=0;Cb=La;Db=Ma;Eb=Na;Fb=Oa;Gb=0;Hb=0;Ib=0;v=162}}while(0);if((v|0)==162){ra=(Fb|0)==0;jb=zb;kb=Ab;lb=Bb;mb=ra?Ab:Cb;nb=ra?Bb:Db;ob=Eb;pb=Gb;qb=Hb;rb=Ib}ra=(ob|0)!=0;do{if(ra){if((jb|32|0)!=101){v=171;break}qa=iY(b,f)|0;$a=J;do{if((qa|0)==0&($a|0)==-2147483648){if(u){jY(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Jb=0;Kb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Jb=0;Kb=0;break}}else{Jb=qa;Kb=$a}}while(0);$a=HY(Jb|0,Kb|0,mb|0,nb|0)|0;Lb=$a;Mb=J}else{v=171}}while(0);do{if((v|0)==171){if(!((jb|0)>-1)){Lb=mb;Mb=nb;break}if((c[m>>2]|0)==0){Lb=mb;Mb=nb;break}c[e>>2]=(c[e>>2]|0)+ -1;Lb=mb;Mb=nb}}while(0);if(!ra){c[(Nc()|0)>>2]=22;jY(b,0);l=0.0;i=g;return+l}u=c[sa>>2]|0;if((u|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Lb|0)==(kb|0)&(Mb|0)==(lb|0)&((lb|0)<0|(lb|0)==0&kb>>>0<10)){if(!(j>>>0>30)){if((u>>>j|0)!=0){break}}l=+(r|0)*+(u>>>0);i=g;return+l}}while(0);u=(k|0)/-2|0;ra=((u|0)<0)<<31>>31;if((Mb|0)>(ra|0)|(Mb|0)==(ra|0)&Lb>>>0>u>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}u=k+ -106|0;ra=((u|0)<0)<<31>>31;if((Mb|0)<(ra|0)|(Mb|0)==(ra|0)&Lb>>>0<u>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((pb|0)==0){Nb=qb}else{if((pb|0)<9){u=h+(qb<<2)|0;ra=c[u>>2]|0;$a=pb;do{ra=ra*10|0;$a=$a+1|0;}while(($a|0)<9);c[u>>2]=ra}Nb=qb+1|0}do{if((rb|0)<9){if(!((rb|0)<=(Lb|0)&(Lb|0)<18)){break}if((Lb|0)==9){l=+(r|0)*+((c[sa>>2]|0)>>>0);i=g;return+l}if((Lb|0)<9){l=+(r|0)*+((c[sa>>2]|0)>>>0)/+(c[125704+(8-Lb<<2)>>2]|0);i=g;return+l}$a=j+27+(fa(Lb,-3)|0)|0;qa=c[sa>>2]|0;if(($a|0)<=30){if((qa>>>$a|0)!=0){break}}l=+(r|0)*+(qa>>>0)*+(c[125704+(Lb+ -10<<2)>>2]|0);i=g;return+l}}while(0);sa=(Lb|0)%9|0;if((sa|0)==0){Ob=0;Pb=0;Qb=Lb;Rb=Nb}else{ra=(Lb|0)>-1?sa:sa+9|0;sa=c[125704+(8-ra<<2)>>2]|0;do{if((Nb|0)==0){Sb=0;Tb=Lb;Ub=0}else{u=1e9/(sa|0)|0;qa=0;$a=0;_a=0;Za=Lb;while(1){Ya=h+(_a<<2)|0;Xa=c[Ya>>2]|0;Wa=((Xa>>>0)/(sa>>>0)|0)+$a|0;c[Ya>>2]=Wa;Vb=fa((Xa>>>0)%(sa>>>0)|0,u)|0;Xa=_a+1|0;if((_a|0)==(qa|0)&(Wa|0)==0){Wb=Xa&127;Xb=Za+ -9|0}else{Wb=qa;Xb=Za}if((Xa|0)==(Nb|0)){break}else{qa=Wb;Za=Xb;_a=Xa;$a=Vb}}if((Vb|0)==0){Sb=Wb;Tb=Xb;Ub=Nb;break}c[h+(Nb<<2)>>2]=Vb;Sb=Wb;Tb=Xb;Ub=Nb+1|0}}while(0);Ob=Sb;Pb=0;Qb=9-ra+Tb|0;Rb=Ub}f:while(1){sa=h+(Ob<<2)|0;if((Qb|0)<18){$a=Pb;_a=Rb;while(1){Za=0;qa=_a+127|0;u=_a;while(1){Xa=qa&127;Wa=h+(Xa<<2)|0;Ya=CY(c[Wa>>2]|0,0,29)|0;Va=HY(Ya|0,J|0,Za|0,0)|0;Ya=J;if(Ya>>>0>0|(Ya|0)==0&Va>>>0>1e9){Ua=RY(Va|0,Ya|0,1e9,0)|0;Ta=SY(Va|0,Ya|0,1e9,0)|0;Yb=Ta;Zb=Ua}else{Yb=Va;Zb=0}c[Wa>>2]=Yb;Wa=(Xa|0)==(Ob|0);if((Xa|0)!=(u+127&127|0)|Wa){_b=u}else{_b=(Yb|0)==0?Xa:u}if(Wa){break}else{Za=Zb;qa=Xa+ -1|0;u=_b}}u=$a+ -29|0;if((Zb|0)==0){$a=u;_a=_b}else{$b=u;ac=Zb;bc=_b;break}}}else{if((Qb|0)==18){cc=Pb;dc=Rb}else{ec=Ob;fc=Pb;gc=Qb;hc=Rb;break}while(1){if(!((c[sa>>2]|0)>>>0<9007199)){ec=Ob;fc=cc;gc=18;hc=dc;break f}_a=0;$a=dc+127|0;u=dc;while(1){qa=$a&127;Za=h+(qa<<2)|0;Xa=CY(c[Za>>2]|0,0,29)|0;Wa=HY(Xa|0,J|0,_a|0,0)|0;Xa=J;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=RY(Wa|0,Xa|0,1e9,0)|0;Ua=SY(Wa|0,Xa|0,1e9,0)|0;ic=Ua;jc=Va}else{ic=Wa;jc=0}c[Za>>2]=ic;Za=(qa|0)==(Ob|0);if((qa|0)!=(u+127&127|0)|Za){kc=u}else{kc=(ic|0)==0?qa:u}if(Za){break}else{_a=jc;$a=qa+ -1|0;u=kc}}u=cc+ -29|0;if((jc|0)==0){cc=u;dc=kc}else{$b=u;ac=jc;bc=kc;break}}}sa=Ob+127&127;if((sa|0)==(bc|0)){u=bc+127&127;$a=h+((bc+126&127)<<2)|0;c[$a>>2]=c[$a>>2]|c[h+(u<<2)>>2];lc=u}else{lc=bc}c[h+(sa<<2)>>2]=ac;Ob=sa;Pb=$b;Qb=Qb+9|0;Rb=lc}g:while(1){mc=hc+1&127;ra=h+((hc+127&127)<<2)|0;sa=ec;u=fc;$a=gc;while(1){_a=($a|0)==18;qa=($a|0)>27?9:1;nc=sa;oc=u;while(1){Za=0;while(1){Wa=Za+nc&127;if((Wa|0)==(hc|0)){pc=2;break}Va=c[h+(Wa<<2)>>2]|0;Wa=c[125696+(Za<<2)>>2]|0;if(Va>>>0<Wa>>>0){pc=2;break}Ua=Za+1|0;if(Va>>>0>Wa>>>0){pc=Za;break}if((Ua|0)<2){Za=Ua}else{pc=Ua;break}}if((pc|0)==2&_a){break g}qc=qa+oc|0;if((nc|0)==(hc|0)){nc=hc;oc=qc}else{break}}_a=(1<<qa)+ -1|0;Za=1e9>>>qa;rc=nc;sc=0;Ua=nc;tc=$a;do{Wa=h+(Ua<<2)|0;Va=c[Wa>>2]|0;Xa=(Va>>>qa)+sc|0;c[Wa>>2]=Xa;sc=fa(Va&_a,Za)|0;Va=(Ua|0)==(rc|0)&(Xa|0)==0;Ua=Ua+1&127;tc=Va?tc+ -9|0:tc;rc=Va?Ua:rc;}while((Ua|0)!=(hc|0));if((sc|0)==0){sa=rc;u=qc;$a=tc;continue}if((mc|0)!=(rc|0)){break}c[ra>>2]=c[ra>>2]|1;sa=rc;u=qc;$a=tc}c[h+(hc<<2)>>2]=sc;ec=rc;fc=qc;gc=tc;hc=mc}$a=nc&127;if(($a|0)==(hc|0)){c[h+(mc+ -1<<2)>>2]=0;uc=mc}else{uc=hc}za=+((c[h+($a<<2)>>2]|0)>>>0);$a=nc+1&127;if(($a|0)==(uc|0)){u=uc+1&127;c[h+(u+ -1<<2)>>2]=0;vc=u}else{vc=uc}pa=+(r|0);wc=pa*(za*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=oc+53|0;u=$a-k|0;if((u|0)<(j|0)){xc=(u|0)<0?0:u;yc=1}else{xc=j;yc=0}if((xc|0)<53){za=+Md(+(+lY(1.0,105-xc|0)),+wc);Ac=+zc(+wc,+(+lY(1.0,53-xc|0)));Bc=za;Cc=Ac;Dc=za+(wc-Ac)}else{Bc=0.0;Cc=0.0;Dc=wc}sa=nc+2&127;do{if((sa|0)==(vc|0)){Ec=Cc}else{ra=c[h+(sa<<2)>>2]|0;do{if(ra>>>0<5e8){if((ra|0)==0){if((nc+3&127|0)==(vc|0)){Fc=Cc;break}}Fc=pa*.25+Cc}else{if(ra>>>0>5e8){Fc=pa*.75+Cc;break}if((nc+3&127|0)==(vc|0)){Fc=pa*.5+Cc;break}else{Fc=pa*.75+Cc;break}}}while(0);if((53-xc|0)<=1){Ec=Fc;break}if(+zc(+Fc,1.0)!=0.0){Ec=Fc;break}Ec=Fc+1.0}}while(0);pa=Dc+Ec-Bc;do{if(($a&2147483647|0)>(-2-o|0)){if(!(+U(+pa)>=9007199254740992.0)){Gc=yc;Hc=oc;Ic=pa}else{Gc=(yc|0)!=0&(xc|0)==(u|0)?0:yc;Hc=oc+1|0;Ic=pa*.5}if((Hc+50|0)<=(p|0)){if(!((Gc|0)!=0&Ec!=0.0)){Jc=Hc;Kc=Ic;break}}c[(Nc()|0)>>2]=34;Jc=Hc;Kc=Ic}else{Jc=oc;Kc=pa}}while(0);l=+mY(Kc,Jc);i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;jY(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function iY(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=kY(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=kY(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=kY(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=QY(q|0,m|0,10,0)|0;b=J;g=HY(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=HY(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=kY(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=kY(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=GY(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function jY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function kY(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=oY(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function lY(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=CY(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function mY(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+lY(a,b);i=c;return+d}function nY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ge[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function oY(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((nY(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ge[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function pY(a){a=a|0;var b=0,c=0.0;b=i;c=+qY(a,0);i=b;return+c}function qY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;jY(e,0);h=+hY(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function rY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;jY(e,0);h=+hY(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function sY(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function tY(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function uY(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function vY(){c[26502]=p;c[26544]=p;c[31186]=p;c[31416]=p}function wY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}ec(116);ec(111);ec(111);ec(32);ec(109);ec(97);ec(110);ec(121);ec(32);ec(115);ec(101);ec(116);ec(106);ec(109);ec(112);ec(115);ec(32);ec(105);ec(110);ec(32);ec(97);ec(32);ec(102);ec(117);ec(110);ec(99);ec(116);ec(105);ec(111);ec(110);ec(32);ec(99);ec(97);ec(108);ec(108);ec(44);ec(32);ec(98);ec(117);ec(105);ec(108);ec(100);ec(32);ec(119);ec(105);ec(116);ec(104);ec(32);ec(97);ec(32);ec(104);ec(105);ec(103);ec(104);ec(101);ec(114);ec(32);ec(118);ec(97);ec(108);ec(117);ec(101);ec(32);ec(102);ec(111);ec(114);ec(32);ec(77);ec(65);ec(88);ec(95);ec(83);ec(69);ec(84);ec(74);ec(77);ec(80);ec(83);ec(10);ga(0);return 0}function xY(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function yY(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function zY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function AY(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{zY(b,c,d)|0}return b|0}function BY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function CY(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function DY(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function EY(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function FY(){return EY(o)|0}function GY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function HY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function IY(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function JY(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function KY(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function LY(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function MY(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function NY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function OY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=GY(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=GY((TY(i,b,GY(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function PY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=GY(h^a,j^b,h,j)|0;b=J;TY(m,b,GY(k^d,l^e,k,l)|0,J,g)|0;l=GY(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function QY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=NY(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function RY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=TY(a,b,c,d,0)|0;return(J=J,e)|0}function SY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;TY(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function TY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((MY(l|0)|0)>>>0);return(J=n,o)|0}p=(LY(l|0)|0)-(LY(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(LY(l|0)|0)-(LY(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(LY(j|0)|0)+33-(LY(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=MY(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=HY(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;GY(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=GY(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function UY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Yd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function VY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Zd[a&31](b|0,c|0,d|0,e|0,f|0)}function WY(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return _d[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function XY(a,b){a=a|0;b=+b;$d[a&1](+b)}function YY(a,b){a=a|0;b=b|0;ae[a&255](b|0)}function ZY(a,b,c){a=a|0;b=b|0;c=c|0;be[a&63](b|0,c|0)}function _Y(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ce[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function $Y(a,b){a=a|0;b=b|0;return de[a&127](b|0)|0}function aZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ee[a&1](b|0,c|0,+d,e|0)}function bZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return fe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function cZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ge[a&63](b|0,c|0,d|0)|0}function dZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return he[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function eZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ie[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function fZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;je[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function gZ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ke[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function hZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return le[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function iZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;me[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function jZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ne[a&3](b|0,c|0,+d,e|0,f|0)}function kZ(a,b,c){a=a|0;b=b|0;c=+c;return oe[a&1](b|0,+c)|0}function lZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;pe[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function mZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;qe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function nZ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;re[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function oZ(a,b,c){a=a|0;b=b|0;c=c|0;return se[a&63](b|0,c|0)|0}function pZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return te[a&63](b|0,c|0,d|0,e|0,f|0)|0}function qZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ue[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function rZ(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+ve[a&1](b|0,+c,+d)}function sZ(a,b,c){a=a|0;b=b|0;c=c|0;return+we[a&1](b|0,c|0)}function tZ(a){a=a|0;return xe[a&7]()|0}function uZ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return ye[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function vZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ze[a&15](b|0,c|0,d|0)}function wZ(a){a=a|0;Ae[a&7]()}function xZ(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Be[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function yZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ce[a&63](b|0,c|0,d|0,e|0)|0}function zZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;De[a&31](b|0,c|0,d|0,e|0)}function AZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function BZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function CZ(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function DZ(a){a=+a;ga(3)}function EZ(a){a=a|0;ga(4)}function FZ(a){a=a|0;xd(a|0)}function GZ(a,b){a=a|0;b=b|0;ga(5)}function HZ(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function IZ(a){a=a|0;ga(7);return 0}function JZ(a){a=a|0;return Oc(a|0)|0}function KZ(a){a=a|0;return Gd(a|0)|0}function LZ(a){a=a|0;return wc(a|0)|0}function MZ(a){a=a|0;return vd(a|0)|0}function NZ(a){a=a|0;return id(a|0)|0}function OZ(a){a=a|0;return qd(a|0)|0}function PZ(a){a=a|0;return Xc(a|0)|0}function QZ(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function RZ(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function SZ(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function TZ(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function UZ(a,b,c){a=a|0;b=b|0;c=c|0;return ic(a|0,b|0,c|0)|0}function VZ(a,b,c){a=a|0;b=b|0;c=c|0;return cc(a|0,b|0,c|0)|0}function WZ(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function XZ(a,b,c){a=a|0;b=b|0;c=c|0;return td(a|0,b|0,c|0)|0}function YZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function ZZ(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function _Z(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function $Z(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function a_(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function b_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function c_(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function d_(a,b){a=a|0;b=+b;ga(18);return 0}function e_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function f_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function g_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function h_(a,b){a=a|0;b=b|0;ga(22);return 0}function i_(a,b){a=a|0;b=b|0;return Ld(a|0,b|0)|0}function j_(a,b){a=a|0;b=b|0;return hc(a|0,b|0)|0}function k_(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function l_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function m_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function n_(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function o_(a,b){a=a|0;b=b|0;ga(26);return 0.0}function p_(){ga(27);return 0}function q_(){return jb()|0}function r_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function s_(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function t_(){ga(30)}function u_(){Uc()}function v_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function w_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function x_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function y_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function z_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function Ej(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;nu(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(tu(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(tu(od,1,ld)|0)>>3];c[kd>>2]=2;h[(tu(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(tu(od,1,jd)|0)>>3];c[id>>2]=3;h[(tu(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(tu(od,1,hd)|0)>>3];c[gd>>2]=4;h[(tu(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(tu(od,1,fd)|0)>>3];c[ed>>2]=5;h[(tu(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(tu(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(tu(od,1,cd)|0)>>3];c[bd>>2]=6;h[(tu(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(tu(od,1,ad)|0)>>3];c[$c>>2]=7;h[(tu(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(tu(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(tu(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(tu(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(tu(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(tu(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(tu(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(tu(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(tu(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(tu(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(tu(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(tu(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(tu(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(tu(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(tu(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(tu(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(tu(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(tu(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(tu(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(tu(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(tu(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(tu(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(tu(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(tu(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(tu(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(tu(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(tu(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(tu(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(tu(od,1,zc)|0)>>3];c[yc>>2]=18;h[(tu(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(tu(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(tu(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(tu(od,1,vc)|0)>>3];c[uc>>2]=19;h[(tu(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(tu(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(tu(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(tu(od,1,rc)|0)>>3];c[qc>>2]=20;h[(tu(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(tu(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(tu(od,1,oc)|0)>>3];c[nc>>2]=21;h[(tu(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(tu(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(tu(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(tu(od,1,kc)|0)>>3];c[jc>>2]=22;h[(tu(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(tu(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(tu(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(tu(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(tu(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(tu(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(tu(od,1,dc)|0)>>3];c[cc>>2]=25;h[(tu(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(tu(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(tu(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(tu(od,1,$b)|0)>>3];c[_b>>2]=27;h[(tu(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(tu(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(tu(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(tu(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(tu(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(tu(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(tu(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(tu(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(tu(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(tu(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(tu(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(tu(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(tu(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(tu(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(tu(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(tu(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(tu(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(tu(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(tu(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(tu(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(tu(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(tu(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(tu(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(tu(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(tu(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(tu(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(tu(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(tu(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(tu(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(tu(od,1,xb)|0)>>3];c[wb>>2]=40;h[(tu(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[21062]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=6928;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];De[xb&31](b,g,3504,vb);}c[ub>>2]=3;rd=+h[(tu(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(tu(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(tu(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(tu(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(tu(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(tu(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(tu(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(tu(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(tu(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(tu(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(tu(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(tu(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(tu(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(tu(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(tu(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(tu(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(tu(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(tu(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(tu(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(tu(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(tu(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(tu(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(tu(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(tu(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(tu(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(tu(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(tu(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(tu(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(tu(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(tu(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(tu(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(tu(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(tu(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(tu(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(tu(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(tu(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(tu(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(tu(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(tu(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(tu(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(tu(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(tu(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(tu(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(tu(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(tu(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(tu(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(tu(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(tu(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(tu(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(tu(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(tu(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(tu(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(tu(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(tu(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(tu(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(tu(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(tu(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(tu(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(tu(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(tu(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(tu(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(tu(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(tu(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(tu(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(tu(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(tu(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(tu(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(tu(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(tu(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(tu(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(tu(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(tu(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(tu(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(tu(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(tu(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(tu(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(tu(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(tu(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(tu(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(tu(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(tu(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(tu(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(tu(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(tu(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(tu(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(tu(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(tu(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(tu(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(tu(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(tu(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(tu(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(tu(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(tu(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(tu(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(tu(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(tu(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(tu(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(tu(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(tu(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(tu(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(tu(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(tu(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(tu(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(tu(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(tu(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(tu(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(tu(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(tu(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(tu(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(tu(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(tu(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(tu(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(tu(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(tu(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(tu(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(tu(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(tu(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function Fj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;nu(ia,1,ha);if(!(d>0.0)){ha=_t(_t(5888,Yt(d,0,1,6)|0)|0,5952)|0;ja=c[21062]|0;ka=m;la=5968;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];De[ja&31](b,m,ha,ga);}if(!(d<=1.0e7)){ga=_t(_t(5992,Yt(d,0,1,6)|0)|0,6040)|0;ha=c[21062]|0;m=l;ja=6080;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];De[ha&31](b,l,ga,fa);}if(!(e<=2273.15)){fa=_t(_t(6104,Yt(e,0,1,6)|0)|0,6152)|0;ga=c[21062]|0;l=j;ha=6208;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];De[ga&31](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(tu(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(tu(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(tu(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(tu(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(tu(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(tu(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(tu(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(tu(ia,1,X)|0)>>3];c[W>>2]=5;h[(tu(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(tu(ia,1,V)|0)>>3];c[U>>2]=6;h[(tu(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(tu(ia,1,T)|0)>>3];c[S>>2]=7;h[(tu(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(tu(ia,1,R)|0)>>3];c[Q>>2]=8;h[(tu(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(tu(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(tu(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(tu(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(tu(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(tu(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[21062]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=6928;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];De[M&31](b,g,4104,K);}c[J>>2]=4;oa=+h[(tu(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(tu(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(tu(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(tu(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(tu(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(tu(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(tu(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(tu(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(tu(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(tu(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(tu(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(tu(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(tu(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(tu(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(tu(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(tu(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(tu(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(tu(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(tu(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(tu(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(tu(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(tu(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(tu(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function Gj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0.0,Ne=0.0,Oe=0.0,Pe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+16|0;c[ve>>2]=45;nu(we,1,ve);if(!(d>611.657)){ve=_t(_t(6232,Yt(d,0,1,6)|0)|0,6296)|0;xe=_t(_t(ve,Yt(611.657,0,1,6)|0)|0,6304)|0;ve=c[21062]|0;ye=k;ze=6336;c[ye+0>>2]=c[ze+0>>2];c[ye+4>>2]=c[ze+4>>2];c[ye+8>>2]=c[ze+8>>2];c[ye+12>>2]=c[ze+12>>2];c[ye+16>>2]=c[ze+16>>2];c[ye+20>>2]=c[ze+20>>2];De[ve&31](b,k,xe,ue);}if(!(d<=1.0e8)){ue=_t(_t(6360,Yt(d,0,1,6)|0)|0,6408)|0;xe=c[21062]|0;k=j;ve=6440;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];De[xe&31](b,j,ue,te);}if(!(e>=273.15)){te=_t(_t(6464,Yt(e,0,1,6)|0)|0,6512)|0;ue=c[21062]|0;j=g;xe=6544;c[j+0>>2]=c[xe+0>>2];c[j+4>>2]=c[xe+4>>2];c[j+8>>2]=c[xe+8>>2];c[j+12>>2]=c[xe+12>>2];c[j+16>>2]=c[xe+16>>2];c[j+20>>2]=c[xe+20>>2];De[ue&31](b,g,te,se);}Ae=d/1653.0e4;Be=1386.0/e;Ce=7.1-Ae;Ee=Be+-1.222;c[re>>2]=1;h[(tu(we,1,re)|0)>>3]=Ee*Ee;c[qe>>2]=1;Fe=+h[(tu(we,1,qe)|0)>>3];c[pe>>2]=2;h[(tu(we,1,pe)|0)>>3]=Fe*Fe;c[oe>>2]=2;Fe=+h[(tu(we,1,oe)|0)>>3];c[ne>>2]=3;h[(tu(we,1,ne)|0)>>3]=Fe*Fe;c[me>>2]=3;Fe=Ee*+h[(tu(we,1,me)|0)>>3];c[le>>2]=4;h[(tu(we,1,le)|0)>>3]=Fe;c[ke>>2]=4;Fe=1.0/+h[(tu(we,1,ke)|0)>>3];c[je>>2]=5;h[(tu(we,1,je)|0)>>3]=Fe;c[ie>>2]=1;Fe=+h[(tu(we,1,ie)|0)>>3];c[he>>2]=2;Ge=Fe*+h[(tu(we,1,he)|0)>>3];c[ge>>2]=6;h[(tu(we,1,ge)|0)>>3]=Ge;c[fe>>2]=1;Ge=Ee*+h[(tu(we,1,fe)|0)>>3];c[ee>>2]=7;h[(tu(we,1,ee)|0)>>3]=Ge;c[de>>2]=7;Ge=1.0/+h[(tu(we,1,de)|0)>>3];c[ce>>2]=8;h[(tu(we,1,ce)|0)>>3]=Ge;c[be>>2]=1;Ge=+h[(tu(we,1,be)|0)>>3];c[ae>>2]=2;Fe=+h[(tu(we,1,ae)|0)>>3];c[$d>>2]=3;He=Ge*Fe*+h[(tu(we,1,$d)|0)>>3];c[_d>>2]=9;h[(tu(we,1,_d)|0)>>3]=He;c[Zd>>2]=2;He=1.0/+h[(tu(we,1,Zd)|0)>>3];c[Yd>>2]=10;h[(tu(we,1,Yd)|0)>>3]=He;c[Xd>>2]=2;He=Ee*+h[(tu(we,1,Xd)|0)>>3];c[Wd>>2]=11;h[(tu(we,1,Wd)|0)>>3]=He;c[Vd>>2]=11;He=1.0/+h[(tu(we,1,Vd)|0)>>3];c[Ud>>2]=12;h[(tu(we,1,Ud)|0)>>3]=He;c[Td>>2]=2;He=+h[(tu(we,1,Td)|0)>>3];c[Sd>>2]=3;Fe=He*+h[(tu(we,1,Sd)|0)>>3];c[Rd>>2]=13;h[(tu(we,1,Rd)|0)>>3]=Fe;c[Qd>>2]=3;Fe=1.0/+h[(tu(we,1,Qd)|0)>>3];c[Pd>>2]=14;h[(tu(we,1,Pd)|0)>>3]=Fe;c[Od>>2]=15;h[(tu(we,1,Od)|0)>>3]=Ce*Ce;c[Nd>>2]=15;Fe=Ce*+h[(tu(we,1,Nd)|0)>>3];c[Md>>2]=16;h[(tu(we,1,Md)|0)>>3]=Fe;c[Ld>>2]=15;Fe=+h[(tu(we,1,Ld)|0)>>3];c[Kd>>2]=17;h[(tu(we,1,Kd)|0)>>3]=Fe*Fe;c[Jd>>2]=17;Fe=+h[(tu(we,1,Jd)|0)>>3];c[Id>>2]=18;h[(tu(we,1,Id)|0)>>3]=Fe*Fe;c[Hd>>2]=17;Fe=+h[(tu(we,1,Hd)|0)>>3];c[Gd>>2]=18;He=Fe*Ce*+h[(tu(we,1,Gd)|0)>>3];c[Fd>>2]=19;h[(tu(we,1,Fd)|0)>>3]=He;c[Ed>>2]=15;He=+h[(tu(we,1,Ed)|0)>>3];c[Dd>>2]=17;Fe=He*+h[(tu(we,1,Dd)|0)>>3];c[Cd>>2]=20;h[(tu(we,1,Cd)|0)>>3]=Fe;c[Bd>>2]=3;Fe=+h[(tu(we,1,Bd)|0)>>3];c[Ad>>2]=21;h[(tu(we,1,Ad)|0)>>3]=Fe*Fe;c[zd>>2]=21;Fe=+h[(tu(we,1,zd)|0)>>3];c[yd>>2]=22;h[(tu(we,1,yd)|0)>>3]=Fe*Fe;c[xd>>2]=22;Fe=+h[(tu(we,1,xd)|0)>>3];c[wd>>2]=3;He=Fe*Ee*+h[(tu(we,1,wd)|0)>>3];c[vd>>2]=23;h[(tu(we,1,vd)|0)>>3]=He;c[ud>>2]=23;He=1.0/+h[(tu(we,1,ud)|0)>>3];c[td>>2]=24;h[(tu(we,1,td)|0)>>3]=He;c[sd>>2]=22;He=+h[(tu(we,1,sd)|0)>>3];c[rd>>2]=3;Fe=He*+h[(tu(we,1,rd)|0)>>3];c[qd>>2]=25;h[(tu(we,1,qd)|0)>>3]=Fe;c[pd>>2]=25;Fe=1.0/+h[(tu(we,1,pd)|0)>>3];c[od>>2]=26;h[(tu(we,1,od)|0)>>3]=Fe;c[nd>>2]=1;Fe=+h[(tu(we,1,nd)|0)>>3];c[md>>2]=2;He=+h[(tu(we,1,md)|0)>>3];c[ld>>2]=22;Ge=Fe*He*Ee*+h[(tu(we,1,ld)|0)>>3];c[kd>>2]=27;h[(tu(we,1,kd)|0)>>3]=Ge;c[jd>>2]=27;Ge=1.0/+h[(tu(we,1,jd)|0)>>3];c[id>>2]=28;h[(tu(we,1,id)|0)>>3]=Ge;c[hd>>2]=1;Ge=+h[(tu(we,1,hd)|0)>>3];c[gd>>2]=2;He=+h[(tu(we,1,gd)|0)>>3];c[fd>>2]=22;Fe=Ge*He*+h[(tu(we,1,fd)|0)>>3];c[ed>>2]=29;h[(tu(we,1,ed)|0)>>3]=Fe;c[dd>>2]=29;Fe=1.0/+h[(tu(we,1,dd)|0)>>3];c[cd>>2]=30;h[(tu(we,1,cd)|0)>>3]=Fe;c[bd>>2]=1;Fe=+h[(tu(we,1,bd)|0)>>3];c[ad>>2]=2;He=+h[(tu(we,1,ad)|0)>>3];c[$c>>2]=21;Ge=+h[(tu(we,1,$c)|0)>>3];c[_c>>2]=3;Ie=Fe*He*Ge*Ee*+h[(tu(we,1,_c)|0)>>3];c[Zc>>2]=31;h[(tu(we,1,Zc)|0)>>3]=Ie;c[Yc>>2]=31;Ie=1.0/+h[(tu(we,1,Yc)|0)>>3];c[Xc>>2]=32;h[(tu(we,1,Xc)|0)>>3]=Ie;c[Wc>>2]=2;Ie=+h[(tu(we,1,Wc)|0)>>3];c[Vc>>2]=21;Ge=+h[(tu(we,1,Vc)|0)>>3];c[Uc>>2]=3;He=Ie*Ge*Ee*+h[(tu(we,1,Uc)|0)>>3];c[Tc>>2]=33;h[(tu(we,1,Tc)|0)>>3]=He;c[Sc>>2]=33;He=1.0/+h[(tu(we,1,Sc)|0)>>3];c[Rc>>2]=34;h[(tu(we,1,Rc)|0)>>3]=He;c[Qc>>2]=1;He=+h[(tu(we,1,Qc)|0)>>3];c[Pc>>2]=3;Ge=He*Ee*+h[(tu(we,1,Pc)|0)>>3];c[Oc>>2]=35;h[(tu(we,1,Oc)|0)>>3]=Ge;c[Nc>>2]=35;Ge=1.0/+h[(tu(we,1,Nc)|0)>>3];c[Mc>>2]=36;h[(tu(we,1,Mc)|0)>>3]=Ge;c[Lc>>2]=1;Ge=+h[(tu(we,1,Lc)|0)>>3];c[Kc>>2]=3;He=Ge*+h[(tu(we,1,Kc)|0)>>3];c[Jc>>2]=37;h[(tu(we,1,Jc)|0)>>3]=He;c[Ic>>2]=37;He=1.0/+h[(tu(we,1,Ic)|0)>>3];c[Hc>>2]=38;h[(tu(we,1,Hc)|0)>>3]=He;c[Gc>>2]=6;He=1.0/+h[(tu(we,1,Gc)|0)>>3];c[Fc>>2]=39;h[(tu(we,1,Fc)|0)>>3]=He;c[Ec>>2]=1;He=+h[(tu(we,1,Ec)|0)>>3];c[Dc>>2]=22;Ge=+h[(tu(we,1,Dc)|0)>>3];c[Cc>>2]=3;Ie=He*Ge*+h[(tu(we,1,Cc)|0)>>3];c[Bc>>2]=40;h[(tu(we,1,Bc)|0)>>3]=Ie;c[Ac>>2]=40;Ie=1.0/+h[(tu(we,1,Ac)|0)>>3];c[zc>>2]=41;h[(tu(we,1,zc)|0)>>3]=Ie;c[yc>>2]=22;Ie=1.0/+h[(tu(we,1,yc)|0)>>3];c[xc>>2]=42;h[(tu(we,1,xc)|0)>>3]=Ie;c[wc>>2]=1;Ie=+h[(tu(we,1,wc)|0)>>3];c[vc>>2]=2;Ge=+h[(tu(we,1,vc)|0)>>3];c[uc>>2]=21;He=+h[(tu(we,1,uc)|0)>>3];c[tc>>2]=3;Fe=Ie*Ge*He*+h[(tu(we,1,tc)|0)>>3];c[sc>>2]=43;h[(tu(we,1,sc)|0)>>3]=Fe;c[rc>>2]=43;Fe=1.0/+h[(tu(we,1,rc)|0)>>3];c[qc>>2]=44;h[(tu(we,1,qc)|0)>>3]=Fe;c[pc>>2]=13;Fe=1.0/+h[(tu(we,1,pc)|0)>>3];c[oc>>2]=45;h[(tu(we,1,oc)|0)>>3]=Fe;c[nc>>2]=10;Fe=+h[(tu(we,1,nc)|0)>>3];c[mc>>2]=2;He=+h[(tu(we,1,mc)|0)>>3];c[lc>>2]=6;Ge=Fe*(He*(+h[(tu(we,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;He=+h[(tu(we,1,kc)|0)>>3];c[jc>>2]=13;Fe=+h[(tu(we,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;Ie=He*(Fe*+h[(tu(we,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Fe=+h[(tu(we,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;He=+h[(tu(we,1,gc)|0)>>3];c[fc>>2]=11;Je=+h[(tu(we,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Ke=Je*+h[(tu(we,1,ec)|0)>>3];c[dc>>2]=19;Je=+h[(tu(we,1,dc)|0)>>3];c[cc>>2]=34;Le=+h[(tu(we,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Me=+h[(tu(we,1,bc)|0)>>3];c[ac>>2]=32;Ne=+h[(tu(we,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Oe=+h[(tu(we,1,$b)|0)>>3];c[_b>>2]=30;Pe=+h[(tu(we,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(tu(we,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(tu(we,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=Ce*(Ge+Ce*(Ie+Ce*(Fe+He*(Ke+Je*(Le+Me*(Ne+Oe*(Pe+Ce*(Qe+Ce*(Re+Ce*+h[(tu(we,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(tu(we,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(tu(we,1,Vb)|0)>>3];c[Ub>>2]=1;Pe=+h[(tu(we,1,Ub)|0)>>3];c[Tb>>2]=9;Oe=Ce*(Re*(Qe*(Ee*(Pe*(+h[(tu(we,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(tu(we,1,Sb)|0)>>3];c[Rb>>2]=1;Pe=+h[(tu(we,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(tu(we,1,Qb)|0)>>3];c[Pb>>2]=1;Re=Ce*(Oe+Se*(Pe*(Qe*(Ee*(Ee*(+h[(tu(we,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(tu(we,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(tu(we,1,Nb)|0)>>3];c[Mb>>2]=2;Pe=+h[(tu(we,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Pe*(+h[(tu(we,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Pe=+h[(tu(we,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(tu(we,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Oe=Pe*(Re*+h[(tu(we,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(tu(we,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Pe=+h[(tu(we,1,Gb)|0)>>3];c[Fb>>2]=11;Ne=+h[(tu(we,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Me=Ne*+h[(tu(we,1,Eb)|0)>>3];c[Db>>2]=19;Ne=+h[(tu(we,1,Db)|0)>>3];c[Cb>>2]=34;Le=+h[(tu(we,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Je=+h[(tu(we,1,Bb)|0)>>3];c[Ab>>2]=32;Ke=+h[(tu(we,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;He=+h[(tu(we,1,zb)|0)>>3];c[yb>>2]=30;Fe=+h[(tu(we,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;Ie=+h[(tu(we,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Ge=+h[(tu(we,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=Ce*(Se+Ce*(Oe+Ce*(Re+Pe*(Me+Ne*(Le+Je*(Ke+He*(Fe+Ce*(Ie+Ce*(Ge+Ce*+h[(tu(we,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Ge=+h[(tu(we,1,ub)|0)>>3];c[tb>>2]=7;Ie=+h[(tu(we,1,tb)|0)>>3];c[sb>>2]=1;Fe=+h[(tu(we,1,sb)|0)>>3];c[rb>>2]=9;He=Ce*(Ge*(Ie*(Ee*(Fe*(+h[(tu(we,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(tu(we,1,qb)|0)>>3];c[pb>>2]=1;Fe=+h[(tu(we,1,pb)|0)>>3];c[ob>>2]=6;Ie=+h[(tu(we,1,ob)|0)>>3];c[nb>>2]=1;Ge=He+Te*(Fe*(Ie*(Ee*(Ee*(+h[(tu(we,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;Ie=+h[(tu(we,1,mb)|0)>>3];c[lb>>2]=2;Fe=+h[(tu(we,1,lb)|0)>>3];c[kb>>2]=6;Te=Ie*(Fe*(+h[(tu(we,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Fe=+h[(tu(we,1,jb)|0)>>3];c[ib>>2]=13;Ie=+h[(tu(we,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;He=Fe*(Ie*+h[(tu(we,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;Ie=+h[(tu(we,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Fe=+h[(tu(we,1,fb)|0)>>3];c[eb>>2]=11;Ke=+h[(tu(we,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Je=Ke*+h[(tu(we,1,db)|0)>>3];c[cb>>2]=19;Ke=+h[(tu(we,1,cb)|0)>>3];c[bb>>2]=34;Le=+h[(tu(we,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Ne=+h[(tu(we,1,ab)|0)>>3];c[$a>>2]=32;Me=+h[(tu(we,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Pe=+h[(tu(we,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(tu(we,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Oe=+h[(tu(we,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(tu(we,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=Ce*(Te+Ce*(He+Ce*(Ie+Fe*(Je+Ke*(Le+Ne*(Me+Pe*(Re+Ce*(Oe+Ce*(Se+Ce*+h[(tu(we,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(tu(we,1,Va)|0)>>3];c[Ua>>2]=7;Oe=+h[(tu(we,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(tu(we,1,Ta)|0)>>3];c[Sa>>2]=9;Pe=Se*(Oe*(Ee*(Re*(+h[(tu(we,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(tu(we,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(tu(we,1,Qa)|0)>>3];c[Pa>>2]=1;Oe=+h[(tu(we,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Oe*+h[(tu(we,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Oe=Ue*(Re*(Se*+h[(tu(we,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(tu(we,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(tu(we,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(tu(we,1,Ka)|0)>>3];c[Ja>>2]=9;Me=Se*(Re*(Ue*(+h[(tu(we,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(tu(we,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(tu(we,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(tu(we,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(tu(we,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Ne=Ue*(Se*+h[(tu(we,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(tu(we,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(tu(we,1,Ca)|0)>>3];c[Ba>>2]=11;Le=+h[(tu(we,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Ke=Le*+h[(tu(we,1,Aa)|0)>>3];c[za>>2]=19;Le=+h[(tu(we,1,za)|0)>>3];c[ya>>2]=44;Je=+h[(tu(we,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Fe=+h[(tu(we,1,xa)|0)>>3];c[wa>>2]=42;Ie=+h[(tu(we,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;He=+h[(tu(we,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(tu(we,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(tu(we,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(tu(we,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=Ce*(Oe+Ce*(Me+Ce*(Re+Ce*(Ne+Ce*(Se+Ue*(Ke+Le*(Je+Fe*(Ie+He*(Te+Ce*(Ve+Ce*(We+Ce*+h[(tu(we,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(tu(we,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(Ee*((Ee*(Ee*(Ee*(Ee*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(tu(we,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(tu(we,1,oa)|0)>>3];c[na>>2]=1;We=+h[(tu(we,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(tu(we,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;He=Xe*(We*(Te*+h[(tu(we,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(tu(we,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(tu(we,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(tu(we,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(tu(we,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(tu(we,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(tu(we,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;Ie=+h[(tu(we,1,ea)|0)>>3];c[da>>2]=19;Fe=+h[(tu(we,1,da)|0)>>3];c[ca>>2]=32;Je=+h[(tu(we,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Le=+h[(tu(we,1,ba)|0)>>3];c[aa>>2]=20;Ke=+h[(tu(we,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(tu(we,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(tu(we,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Ne=+h[(tu(we,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(tu(we,1,Y)|0)>>3];c[X>>2]=22;Me=Re*+h[(tu(we,1,X)|0)>>3];c[W>>2]=3;Re=Ke*(Ue+Ce*(Se+Ce*(Ne+Ce/(Ee*Me*+h[(tu(we,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Me=Fe*(Je+Le*(1.43624813658928e-17/(Ee*+h[(tu(we,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(tu(we,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Le=+h[(tu(we,1,T)|0)>>3];c[S>>2]=3;Je=Ce*(We+Ie*(Re/(Ee*Le*+h[(tu(we,1,S)|0)>>3])+Me));c[R>>2]=13;Me=+h[(tu(we,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Le=Me*+h[(tu(we,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Me=+h[(tu(we,1,P)|0)>>3];c[O>>2]=2;Re=Ce*(He+Ce*(Xe+Ce*(Te+Ce*(Je+Le/(Ee*Me*+h[(tu(we,1,O)|0)>>3])))));c[N>>2]=10;Me=+h[(tu(we,1,N)|0)>>3];c[M>>2]=7;Le=Re+Me*(Ee*((Ee*(Ee*(Ee*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(tu(we,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;Ee=+h[(tu(we,1,L)|0)>>3];c[K>>2]=1;Me=+h[(tu(we,1,K)|0)>>3];c[J>>2]=1;Re=+h[(tu(we,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Je=Re*+h[(tu(we,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=Ee*(Me*(Je*+h[(tu(we,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Je=+h[(tu(we,1,G)|0)>>3];c[F>>2]=2;Me=+h[(tu(we,1,F)|0)>>3];c[E>>2]=1;Ee=+h[(tu(we,1,E)|0)>>3];c[D>>2]=9;Te=Je*(Me*(Ee*(+h[(tu(we,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;Ee=+h[(tu(we,1,C)|0)>>3];c[B>>2]=37;Me=Ee*(+h[(tu(we,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;Ee=+h[(tu(we,1,A)|0)>>3];c[z>>2]=13;Je=+h[(tu(we,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=Ee*(Je*+h[(tu(we,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Je=+h[(tu(we,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;Ee=+h[(tu(we,1,w)|0)>>3];c[v>>2]=11;He=+h[(tu(we,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;Ie=He*+h[(tu(we,1,u)|0)>>3];c[t>>2]=19;He=+h[(tu(we,1,t)|0)>>3];c[s>>2]=44;We=+h[(tu(we,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Fe=+h[(tu(we,1,r)|0)>>3];c[q>>2]=42;Ne=+h[(tu(we,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(tu(we,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(tu(we,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Ke=+h[(tu(we,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Oe=+h[(tu(we,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+Ce*(Te+Ce*(Me+Ce*(Xe+Ce*(Je+Ee*(Ie+He*(We+Fe*(Ne+Se*(Ue+Ce*(Ke+Ce*(Oe+Ce*+h[(tu(we,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Ae;h[a+32>>3]=Be;h[a+40>>3]=Qe;h[a+48>>3]=Ge;h[a+56>>3]=Pe;h[a+64>>3]=Ve;h[a+72>>3]=Le;h[a+80>>3]=Ye;i=f;return}




// EMSCRIPTEN_END_FUNCS
var Yd=[AZ,Sv,Uv,Zv,YK,AZ,AZ,AZ];var Zd=[BZ,mq,nq,Sq,Tq,vr,wr,Tr,Ur,Vr,RX,QX,PX,uu,Gp,Hp,qt,ot,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ,BZ];var _d=[CZ,yx];var $d=[DZ,Ew];var ae=[EZ,Mj,Nj,Sj,Tj,Cl,Vj,lt,Kz,Nz,Mz,Oz,WP,VP,YP,XP,Pz,Rz,bD,zD,AD,BD,HP,GP,JP,IP,iK,uK,HK,IK,JK,LK,NK,DM,EM,KM,LM,RM,SM,YM,ZM,jN,iN,oN,nN,qN,rN,AN,zN,HO,GO,QO,PO,sP,rP,QP,PP,SP,RP,iQ,hQ,kQ,jQ,qQ,pQ,FO,rQ,oQ,sQ,uQ,tQ,CU,AQ,zQ,FQ,EQ,cR,bR,GR,FR,UR,TR,gS,fS,uS,tS,HS,GS,KS,JS,OS,NS,ZS,YS,iT,hT,tT,sT,ET,DT,OT,NT,WT,VT,aU,$T,gU,fU,lU,kU,uU,tU,SU,RU,pU,hV,OV,NV,QV,PV,vQ,BU,EU,$U,pV,AV,LV,MV,CX,BX,EX,HX,FX,GX,IX,JX,eY,dY,eg,FZ,_e,$e,af,cf,df,ef,ff,gf,hf,jf,mf,nf,of,pf,qf,rf,sf,tf,uf,xf,yf,Ff,Gf,Hf,Lf,Mf,Qf,Rf,Sf,Tf,Uf,Vf,Wf,Xf,Yf,Zf,_f,$f,WX,nt,Ue,ow,sw,nw,Bx,uw,zx,Qu,xw,vw,ww,tw,zw,Ax,Aw,pw,Cw,dK,Dw,bM,CM,DU,wW,GT,DW,CW,BW,AW,zW,yW,QN,sO,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ,EZ];var be=[GZ,Uj,gy,Sz,fP,FM,MM,TM,_M,tP,RS,SS,TS,US,WS,XS,aT,bT,cT,dT,fT,gT,lT,mT,nT,oT,qT,rT,wT,xT,yT,zT,BT,CT,jU,oU,VV,XV,ZV,WV,YV,_V,fw,Oj,Qj,yw,JC,iy,hy,jy,py,By,ky,zy,YB,iC,hC,jC,TB,RB,VB,kL,GZ,GZ];var ce=[HZ,Vp,Op,Tv,Vv,Wv,Xv,Yv];var de=[IZ,bg,Um,ag,We,Xe,Ye,Dl,El,$j,Bl,Tm,En,_j,Yj,Fn,Gn,Kn,Ln,Mn,Nn,On,Pn,Qn,Rn,JZ,KZ,LZ,Mt,VX,MZ,Wz,kP,Xz,nP,jP,QK,GM,yP,AP,BP,xP,NM,OM,UM,mP,$M,aN,kN,pN,mQ,hS,$V,bW,dW,jW,lW,fW,hW,vS,aW,cW,eW,kW,mW,gW,iW,PS,QS,VS,_S,$S,eT,jT,kT,pT,uT,vT,AT,lV,mV,oV,RV,TV,SV,UV,dV,eV,gV,vV,wV,zV,GV,HV,KV,DX,fY,Ix,NZ,OZ,Gx,Hx,PZ,YJ,zK,Hw,Pw,Yw,Iw,Sw,Zw,uM,oY,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ,IZ];var ee=[QZ,su];var fe=[RZ,Cv];var ge=[SZ,Xj,dq,jq,Jq,Pq,mr,sr,Tz,lP,pP,gP,uP,zP,HM,DP,VM,uN,vN,yQ,DQ,hU,mU,UU,WU,ZU,FU,KU,MU,PU,KX,fK,tu,Sp,Jp,Qp,Wp,TZ,UZ,VZ,Cx,cK,_J,WZ,mM,XZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ,SZ];var he=[YZ,Gv];var ie=[ZZ,_u];var je=[_Z,OR,RR,aS,cS,_Z,_Z,_Z];var ke=[$Z,IS,LS,FT,JT,PT,RT,$Z];var le=[a_,Av];var me=[b_,it,Uz,OK,vP,hP,HR,IR,MR,SR,VR,WR,_R,dS,iU,nU,UX,TX,SX,jt,b_,b_,b_,b_,b_,b_,b_,b_,b_,b_,b_,b_];var ne=[c_,Qw,Rw,c_];var oe=[d_,dg];var pe=[e_,GQ,IQ,KQ,MQ,OQ,QQ,SQ,UQ,WQ,YQ,_Q,dR,fR,hR,jR,lR,nR,pR,rR,tR,vR,xR,LR,NR,ZR,$R,iS,jS,kS,lS,mS,wS,xS,yS,zS,AS,_T,eU,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_,e_];var qe=[f_,XT,bU,f_];var re=[g_,nS,BS,g_];var se=[h_,Ve,ak,Zj,Wj,Sn,Tn,fq,gq,iq,Lq,Mq,Oq,or,pr,rr,xr,yr,zr,Ar,Br,Cr,Dr,Er,Yz,Zz,RK,SK,CP,IM,PM,EP,oP,WM,bN,qP,TU,VU,XU,JU,LU,NU,qx,$w,Tw,Jw,_w,i_,YX,Dp,Ep,Fp,j_,$t,Mw,mx,dx,Ow,k_,nX,h_,h_,h_,h_];var te=[l_,wQ,BQ,_U,kV,nV,QU,cV,fV,uV,xV,FV,IV,$r,Ss,Ts,es,bs,Qs,Rs,fs,gs,hs,is,js,Gs,Hs,xs,qs,ls,ks,ms,ns,ps,os,cs,as,rs,ss,ts,us,vs,ws,ys,zs,As,Bs,Fs,Ds,Cs,Es,Ms,Is,Js,Ks,Ls,Ns,Os,Ps,Us,Vs,Ws,Xs,JR];var ue=[m_,Nx];var ve=[n_,ax];var we=[o_,iv];var xe=[p_,Vn,q_,Nt,zM,AM,xM,p_];var ye=[r_,Fv];var ze=[s_,hK,tN,nQ,nu,At,tt,by,dy,IC,jL,s_,s_,s_,s_,s_];var Ae=[t_,u_,Lt,_s,gg,t_,t_,t_];var Be=[v_,Un,iV,jV,aV,bV,qV,sV,BV,DV,ex,v_,v_,v_,v_,v_];var Ce=[w_,Zp,_p,$p,aq,bq,cq,eq,hq,lq,Dq,Eq,Fq,Gq,Hq,Iq,Kq,Nq,Rq,gr,hr,ir,jr,kr,lr,nr,qr,ur,YU,GU,HU,IU,OU,hw,x_,yt,Bv,vp,yo,To,ap,Oo,jp,op,mp,pp,Xp,Bp,Lp,Mp,Tp,Up,aR,PR,y_,w_,w_,w_,w_,w_,w_,w_,w_,w_];var De=[z_,kq,Qq,tr,Vz,gK,PK,wP,iP,xQ,CQ,LX,MX,NX,rt,pt,jw,st,xt,Pj,Rj,EL,Np,ut,z_,z_,z_,z_,z_,z_,z_,z_];return{_testSetjmp:KY,_saveSetjmp:wY,_free:WX,_main:fg,_rand_r:EY,_realloc:YX,_i64Add:HY,_memmove:AY,_bitshift64Ashr:yY,_memset:BY,_malloc:VX,_strncpy:IY,_memcpy:zY,_strlen:xY,_bitshift64Lshr:JY,_bitshift64Shl:CY,_i64Subtract:GY,_strcpy:DY,_calloc:XX,_rand:FY,__GLOBAL__I_a:dN,runPostSets:vY,stackAlloc:Ee,stackSave:Fe,stackRestore:Ge,setThrew:He,setTempRet0:Ke,setTempRet1:Le,setTempRet2:Me,setTempRet3:Ne,setTempRet4:Oe,setTempRet5:Pe,setTempRet6:Qe,setTempRet7:Re,setTempRet8:Se,setTempRet9:Te,dynCall_iiiiiiii:UY,dynCall_viiiii:VY,dynCall_iiiiidiii:WY,dynCall_vd:XY,dynCall_vi:YY,dynCall_vii:ZY,dynCall_iiiiiiiiiii:_Y,dynCall_ii:$Y,dynCall_viidi:aZ,dynCall_iiiiiiiiiiiiii:bZ,dynCall_iiii:cZ,dynCall_iiiiiiiiiiiiiiiiiiiiiii:dZ,dynCall_iiiiiiiiiiiiiiiiiiiii:eZ,dynCall_viiiiid:fZ,dynCall_viiiiiiii:gZ,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:hZ,dynCall_viiiiii:iZ,dynCall_viidii:jZ,dynCall_iid:kZ,dynCall_viiiiiii:lZ,dynCall_viiiiiid:mZ,dynCall_viiiiiiiii:nZ,dynCall_iii:oZ,dynCall_iiiiii:pZ,dynCall_iiiiidi:qZ,dynCall_didd:rZ,dynCall_dii:sZ,dynCall_i:tZ,dynCall_iiiiiiiiii:uZ,dynCall_viii:vZ,dynCall_v:wZ,dynCall_iiiiiiiii:xZ,dynCall_iiiii:yZ,dynCall_viiii:zZ}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_atan2": _atan2, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_acos": _acos, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






