var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 130760;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 130800;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(131627);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,131,0,0,0,109,97,120,40,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,1,0,0,0,133,0,0,0,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,1,0,0,0,136,0,0,0,49,46,48,32,45,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,1,0,0,0,137,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,138,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,0,0,0,0,1,0,0,0,142,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,44,32,123,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,0,1,0,0,0,145,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,148,0,0,0,49,46,48,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,149,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,154,0,0,0,109,97,120,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,1,0,0,0,156,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,159,0,0,0,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,1,0,0,0,160,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,161,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,1,0,0,0,163,0,0,0,115,104,111,114,116,80,105,112,101,49,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,169,0,0,0,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,177,0,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,179,0,0,0,118,111,108,117,109,101,49,46,86,0,0,0,0,0,0,0,1,0,0,0,185,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,44,32,123,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,125,41,0,0,0,1,0,0,0,190,0,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,191,0,0,0,1,0,0,0,195,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,84,44,32,123,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,125,41,0,0,0,0,0,0,0,0,1,0,0,0,200,0,0,0,118,111,108,117,109,101,49,46,109,0,0,0,0,0,0,0,1,0,0,0,201,0,0,0,84,101,109,112,101,114,97,116,117,114,101,32,84,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,97,108,108,111,119,101,100,32,114,97,110,103,101,32,49,52,51,46,49,53,32,75,32,60,61,32,40,84,32,61,0,0,0,0,0,0,32,75,41,32,60,61,32,50,48,48,48,32,75,32,114,101,113,117,105,114,101,100,32,102,114,111,109,32,109,101,100,105,117,109,32,109,111,100,101,108,32,34,0,0,0,0,0,0,77,111,105,115,116,32,97,105,114,0,0,0,0,0,0,0,34,46,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,49,93,32,61,32,0,0,0,111,102,32,115,117,98,115,116,97,110,99,101,32,0,0,0,87,97,116,101,114,0,0,0,10,111,102,32,109,101,100,105,117,109,32,0,0,0,0,0,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,114,97,110,103,101,32,48,46,46,49,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,50,93,32,61,32,0,0,0,65,105,114,0,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,88,10,0,0,67,0,0,0,5,0,0,0,69,0,0,0,77,0,0,0,0,0,0,0,16,11,0,0,74,17,0,0,11,0,0,0,77,17,0,0,41,0,0,0,0,0,0,0,16,11,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,82,101,102,101,114,101,110,99,101,65,105,114,46,77,111,105,115,116,65,105,114,50,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,0,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,82,101,102,101,114,101,110,99,101,65,105,114,46,77,111,105,115,116,65,105,114,50,95,105,110,102,111,46,120,109,108,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,84,104,101,32,97,114,103,117,109,101,110,116,115,32,117,95,109,105,110,32,97,110,100,32,117,95,109,97,120,32,112,114,111,118,105,100,101,100,32,105,110,32,116,104,101,32,102,117,110,99,116,105,111,110,32,99,97,108,108,10,32,32,32,32,115,111,108,118,101,79,110,101,78,111,110,108,105,110,101,97,114,69,113,117,97,116,105,111,110,40,102,44,117,95,109,105,110,44,117,95,109,97,120,41,10,100,111,32,110,111,116,32,98,114,97,99,107,101,116,32,116,104,101,32,114,111,111,116,32,111,102,32,116,104,101,32,115,105,110,103,108,101,32,110,111,110,45,108,105,110,101,97,114,32,101,113,117,97,116,105,111,110,32,48,61,102,40,117,41,58,10,32,32,117,95,109,105,110,32,32,61,32,0,0,10,0,0,0,0,0,0,0,32,32,117,95,109,97,120,32,32,61,32,0,0,0,0,0,32,32,102,97,32,61,32,102,40,117,95,109,105,110,41,32,61,32,0,0,0,0,0,0,32,32,102,98,32,61,32,102,40,117,95,109,97,120,41,32,61,32,0,0,0,0,0,0,102,97,32,97,110,100,32,102,98,32,109,117,115,116,32,104,97,118,101,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,119,104,105,99,104,32,105,115,32,110,111,116,32,116,104,101,32,99,97,115,101,0,1,0,0,0,80,34,0,0,88,34,0,0,0,0,0,0,1,0,0,0,176,33,0,0,184,33,0,0,0,0,0,0,1,0,0,0,88,33,0,0,96,33,0,0,0,0,0,0,1,0,0,0,184,32,0,0,192,32,0,0,0,0,0,0,1,0,0,0,96,32,0,0,104,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,116,97,117,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,45,32,101,120,112,40,45,50,53,46,51,54,51,54,53,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,45,32,101,120,112,40,45,49,54,46,57,48,55,52,49,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,48,46,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,54,32,43,32,101,120,112,40,56,55,46,51,49,50,55,57,48,48,48,48,48,48,48,48,49,32,42,32,102,46,116,97,117,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,102,46,116,97,117,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,1,0,0,0,48,32,0,0,56,32,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,1,0,0,0,16,32,0,0,24,32,0,0,0,0,0,0,1,0,0,0,240,31,0,0,248,31,0,0,0,0,0,0,1,0,0,0,152,31,0,0,160,31,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,66,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,65,32,42,32,67,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,40,99,49,46,114,101,32,94,32,50,46,48,32,43,32,99,49,46,105,109,32,94,32,50,46,48,41,32,94,32,48,46,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,65,109,98,105,101,110,116,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,32,42,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,70,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,69,32,42,32,71,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,40,54,53,48,46,49,55,53,51,52,56,52,52,55,57,56,32,43,32,68,41,32,94,32,50,46,48,32,43,32,45,52,46,48,32,42,32,40,45,48,46,50,51,56,53,53,53,53,55,53,54,55,56,52,57,32,43,32,54,53,48,46,49,55,53,51,52,56,52,52,55,57,56,32,42,32,68,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,1,0,0,0,112,31,0,0,120,31,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,82,101,97,99,116,105,111,110,73,110,100,105,99,101,115,46,85,50,40,112,44,32,84,44,32,123,109,111,108,101,70,114,97,99,116,105,111,110,91,49,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,50,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,51,93,44,32,109,111,108,101,70,114,97,99,116,105,111,110,91,52,93,125,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,84,32,61,32,0,0,41,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,184,23,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,184,23,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,184,23,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,184,23,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,184,23,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,184,23,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,184,23,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,184,23,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,184,23,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,184,23,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,184,23,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,184,23,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,184,23,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,184,23,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,184,23,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,184,23,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,23,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,1,0,0,0,64,31,0,0,72,31,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,184,23,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,4,0,0,0,0,0,0,0,238,125,147,110,151,114,146,63,182,225,201,209,144,175,156,63,225,193,5,143,37,98,160,63,146,202,20,115,16,116,164,63,10,0,0,0,0,0,0,0,69,72,146,101,53,60,146,64,230,57,133,85,234,25,38,193,213,154,16,162,231,18,49,192,202,188,217,143,105,122,199,64,133,56,32,132,149,169,72,193,107,204,190,29,137,212,45,64,179,240,72,7,68,215,178,192,229,145,38,159,229,185,24,65,14,166,232,53,253,136,206,191,212,75,22,29,103,81,132,64,3,0,0,0,0,0,0,0,79,211,114,180,129,78,107,63,237,43,205,181,129,78,243,63,162,150,40,115,218,64,251,63,3,0,0,0,0,0,0,0,39,62,45,245,226,54,53,192,248,186,86,140,4,82,59,64,68,243,165,92,134,108,24,192,5,0,0,0,0,0,0,0,70,177,134,119,168,73,35,193,22,51,58,37,241,245,228,63,221,99,66,105,92,85,84,190,215,161,171,33,3,154,238,60,242,95,162,72,204,5,133,187,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,133,235,81,184,30,213,63,41,92,143,194,245,40,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,51,51,51,51,51,195,63,0,0,0,0,0,0,0,0,154,153,153,153,153,153,201,63,102,102,102,102,102,102,214,63,154,153,153,153,153,153,245,63,154,153,153,153,153,153,249,63,154,153,153,153,153,153,233,63,102,102,102,102,102,102,238,63,0,0,0,0,0,0,244,63,205,204,204,204,204,204,12,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,10,64,0,0,0,0,0,0,12,64,0,0,0,0,0,0,46,64,19,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,6,0,0,0,1,0,0,0,3,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,3,0,0,0,11,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,124,252,4,97,200,63,190,63,242,16,199,119,217,209,230,63,184,179,228,163,81,228,249,191,152,16,88,103,48,72,178,63,160,215,149,43,160,39,182,191,18,198,89,243,212,45,193,63,152,159,4,9,226,16,135,63,201,151,243,92,3,136,165,191,52,55,71,248,133,222,161,63,205,17,255,105,11,159,37,63,246,50,202,34,15,243,185,191,244,22,40,235,134,63,198,191,245,117,228,106,243,43,168,191,250,23,206,78,195,23,137,191,160,217,43,81,194,196,194,191,96,8,130,141,155,46,160,191,108,25,21,27,36,158,46,63,220,143,38,101,142,94,142,63,129,224,3,15,237,57,131,191,13,0,0,0,0,0,0,0,115,193,105,214,120,66,112,62,184,97,171,53,133,12,246,190,32,173,224,40,123,210,36,191,39,2,96,50,17,175,43,192,147,78,201,222,119,70,49,64,108,58,221,255,78,155,41,191,158,128,91,180,86,237,3,64,244,102,197,81,104,82,233,63,115,204,200,12,147,42,203,63,99,158,164,223,15,86,201,63,190,48,153,42,24,93,57,64,56,16,146,5,76,232,48,64,4,33,89,192,4,212,85,64,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,45,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,0,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,49,46,112,95,115,116,97,114,116,0,0,0,0,0,0,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,84,32,45,32,118,111,108,117,109,101,49,46,84,95,115,116,97,114,116,0,0,0,0,0,0,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,45,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,49,93,0,0,0,0,0,0,0,64,35,0,0,104,35,0,0,144,35,0,0,184,35,0,0,224,35,0,0,8,36,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,16,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,1,0,0,0,18,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,0,0,0,0,1,0,0,0,22,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,65,109,98,105,101,110,116,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,44,32,123,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,1,0,0,0,25,0,0,0,109,97,120,40,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,1,0,0,0,26,0,0,0,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,29,0,0,0,49,46,48,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,1,0,0,0,30,0,0,0,109,97,120,40,49,101,45,49,51,44,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,31,0,0,0,109,97,120,40,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,1,0,0,0,34,0,0,0,109,97,120,40,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,1,0,0,0,35,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,0,0,0,0,1,0,0,0,42,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,43,0,0,0,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,1,0,0,0,46,0,0,0,49,46,48,32,45,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,1,0,0,0,48,0,0,0,115,104,111,114,116,80,105,112,101,49,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,54,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,84,44,32,123,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,125,41,0,0,0,0,0,0,0,0,1,0,0,0,62,0,0,0,109,97,120,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,1,0,0,0,63,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,1,0,0,0,69,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,44,32,123,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,0,1,0,0,0,72,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,73,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,76,0,0,0,49,46,48,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,81,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,82,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,85,0,0,0,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,1,0,0,0,87,0,0,0,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,89,0,0,0,118,111,108,117,109,101,49,46,86,0,0,0,0,0,0,0,1,0,0,0,91,0,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,94,0,0,0,118,111,108,117,109,101,49,46,109,0,0,0,0,0,0,0,1,0,0,0,98,0,0,0,1,0,0,0,105,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,80,111,114,116,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,44,32,123,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,125,41,0,0,0,1,0,0,0,108,0,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,109,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,230,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,1,0,0,0,232,0,0,0,109,97,120,40,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,1,0,0,0,239,0,0,0,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,0,45,48,46,51,55,55,56,57,53,55,53,52,54,50,57,48,50,50,49,32,43,32,68,73,86,73,83,73,79,78,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,240,0,0,0,109,97,120,40,49,101,45,49,51,44,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,243,0,0,0,51,52,46,53,51,50,48,53,54,49,48,55,54,56,52,55,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,54,56,32,45,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,50,56,57,53,56,54,0,0,0,0,0,0,0,1,0,0,0,246,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,67,111,109,112,111,110,101,110,116,115,46,70,105,120,101,100,65,109,98,105,101,110,116,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,84,88,40,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,44,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,44,32,123,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,125,41,0,0,0,0,1,0,0,0,251,0,0,0,49,46,48,32,45,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,1,0,0,0,252,0,0,0,109,97,120,40,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,49,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,49,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,49,46,100,112,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,100,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,100,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,100,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,49,0,0,107,13,0,0,9,0,0,0,108,13,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,49,0,0,105,13,0,0,9,0,0,0,106,13,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,120,49,0,0,40,13,0,0,9,0,0,0,42,13,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,120,49,0,0,36,13,0,0,9,0,0,0,39,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,49,0,0,31,13,0,0,9,0,0,0,35,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,120,49,0,0,25,13,0,0,9,0,0,0,27,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,120,49,0,0,22,13,0,0,9,0,0,0,24,13,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,120,49,0,0,206,12,0,0,9,0,0,0,207,12,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,49,0,0,202,12,0,0,9,0,0,0,205,12,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,120,49,0,0,197,12,0,0,9,0,0,0,201,12,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,120,49,0,0,191,12,0,0,9,0,0,0,192,12,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,120,49,0,0,117,12,0,0,9,0,0,0,119,12,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,49,0,0,113,12,0,0,9,0,0,0,116,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,49,0,0,108,12,0,0,9,0,0,0,112,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,49,0,0,102,12,0,0,9,0,0,0,104,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,120,49,0,0,99,12,0,0,9,0,0,0,101,12,0,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,120,49,0,0,236,13,0,0,9,0,0,0,236,13,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,120,49,0,0,235,13,0,0,9,0,0,0,235,13,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,49,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,112,69,0,0,65,0,0,0,5,0,0,0,65,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,120,49,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,120,49,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,120,49,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,69,0,0,61,0,0,0,5,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,112,69,0,0,58,0,0,0,5,0,0,0,58,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,69,0,0,59,0,0,0,5,0,0,0,59,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,49,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,69,0,0,63,0,0,0,5,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,69,0,0,54,0,0,0,5,0,0,0,54,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,82,101,102,101,114,101,110,99,101,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,77,0,0,255,11,0,0,9,0,0,0,0,12,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,77,0,0,4,12,0,0,9,0,0,0,5,12,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,97,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,97,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,97,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,97,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,97,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,97,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,77,0,0,252,11,0,0,9,0,0,0,253,11,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,77,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,77,0,0,31,17,0,0,7,0,0,0,32,17,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,77,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,77,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,77,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,77,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,77,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,77,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,77,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,83,0,0,54,0,0,0,5,0,0,0,54,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,83,0,0,58,0,0,0,5,0,0,0,58,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,83,0,0,59,0,0,0,5,0,0,0,59,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,216,83,0,0,61,0,0,0,5,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,216,83,0,0,63,0,0,0,5,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,49,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,83,0,0,65,0,0,0,5,0,0,0,65,0,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,77,0,0,125,12,0,0,9,0,0,0,125,12,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,49,46,109,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,49,46,109,88,105,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,77,0,0,126,12,0,0,9,0,0,0,127,12,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,49,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,49,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,49,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,77,0,0,1,12,0,0,9,0,0,0,2,12,0,0,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,49,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,49,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,49,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,77,0,0,6,12,0,0,9,0,0,0,7,12,0,0,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,49,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,49,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,49,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,77,0,0,118,13,0,0,9,0,0,0,119,13,0,0,87,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,82,101,102,101,114,101,110,99,101,65,105,114,95,77,111,105,115,116,65,105,114,50,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,54,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,54,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,54,44,54,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,54,44,48,93,32,61,32,122,101,114,111,115,40,54,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,54,93,32,61,32,122,101,114,111,115,40,48,44,54,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,54,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,49,80,109,101,100,105,117,109,80,88,105,108,66,49,114,66,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,49,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,49,80,109,101,100,105,117,109,80,84,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,49,80,109,101,100,105,117,109,80,112,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,84,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,112,32,61,32,120,91,54,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,82,101,102,101,114,101,110,99,101,65,105,114,95,77,111,105,115,116,65,105,114,50,59,10,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,119,0,0,40,119,0,0,56,119,0,0,80,119,0,0,112,119,0,0,128,119,0,0,152,119,0,0,168,119,0,0,192,119,0,0,224,119,0,0,8,120,0,0,32,120,0,0,64,120,0,0,88,120,0,0,128,120,0,0,160,120,0,0,208,120,0,0,0,121,0,0,24,121,0,0,80,121,0,0,104,121,0,0,152,121,0,0,184,121,0,0,240,121,0,0,24,122,0,0,80,122,0,0,128,122,0,0,144,122,0,0,176,122,0,0,216,122,0,0,248,122,0,0,32,123,0,0,72,123,0,0,96,123,0,0,120,123,0,0,136,123,0,0,160,123,0,0,208,123,0,0,32,124,0,0,96,124,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,144,138,0,0,32,137,0,0,168,135,0,0,48,134,0,0,48,134,0,0,184,132,0,0,168,135,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,88,149,0,0,224,145,0,0,112,144,0,0,0,143,0,0,0,143,0,0,144,141,0,0,112,144,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,160,147,0,0,176,147,0,0,192,147,0,0,144,132,0,0,200,147,0,0,216,147,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,56,151,0,0,64,151,0,0,72,151,0,0,80,151,0,0,200,150,0,0,88,151,0,0,104,151,0,0,112,151,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,248,152,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,176,153,0,0,192,153,0,0,200,153,0,0,208,153,0,0,224,153,0,0,240,153,0,0,248,153,0,0,8,154,0,0,24,154,0,0,40,154,0,0,56,154,0,0,72,154,0,0,88,154,0,0,104,154,0,0,120,154,0,0,128,154,0,0,136,154,0,0,152,154,0,0,160,154,0,0,176,154,0,0,192,154,0,0,208,154,0,0,224,154,0,0,240,154,0,0,0,155,0,0,16,155,0,0,32,155,0,0,48,155,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,184,155,0,0,192,155,0,0,192,155,0,0,224,155,0,0,16,156,0,0,48,156,0,0,104,156,0,0,152,156,0,0,200,156,0,0,232,156,0,0,24,157,0,0,48,157], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([80,157,0,0,120,157,0,0,152,157,0,0,200,157,0,0,232,157,0,0,16,158,0,0,48,158,0,0,88,158,0,0,136,158,0,0,192,158,0,0,232,158,0,0,24,159,0,0,72,159,0,0,112,159,0,0,160,159,0,0,168,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,184,155,0,0,168,162,0,0,176,162,0,0,184,162,0,0,200,153,0,0,192,162,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,40,164,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,64,164,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,88,164,0,0,96,164,0,0,104,164,0,0,120,164,0,0,136,164,0,0,144,164,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,168,176,0,0,0,0,0,0,32,176,0,0,0,0,0,0,152,175,0,0,0,0,0,0,16,175,0,0,0,0,0,0,8,174,0,0,0,0,0,0,0,173,0,0,0,0,0,0,248,171,0,0,0,0,0,0,240,170,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,144,178,0,0,160,178,0,0,168,178,0,0,176,178,0,0,192,178,0,0,200,178,0,0,208,178,0,0,216,178,0,0,224,178,0,0,232,178,0,0,240,178,0,0,0,179,0,0,8,179,0,0,24,179,0,0,40,179,0,0,56,179,0,0,64,179,0,0,80,179,0,0,88,179,0,0,104,179,0,0,112,179,0,0,136,179,0,0,144,179,0,0,152,179,0,0,168,179,0,0,176,179,0,0,192,179,0,0,208,179,0,0,216,179,0,0,224,179,0,0,232,179,0,0,240,179,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,128,180,0,0,136,180,0,0,208,180,0,0,0,181,0,0,48,181,0,0,120,181,0,0,184,181,0,0,0,182,0,0,48,182,0,0,120,182,0,0,144,182,0,0,176,182,0,0,232,182,0,0,16,183,0,0,56,183,0,0,112,183,0,0,192,183,0,0,32,184,0,0,80,184,0,0,136,184,0,0,184,184,0,0,0,185,0,0,40,185,0,0,88,185,0,0,136,185,0,0,224,185,0,0,40,186,0,0,152,186,0,0,200,186,0,0,16,187,0,0,48,187,0,0,240,179,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,128,180,0,0,240,187,0,0,152,188,0,0,0,181,0,0,48,181,0,0,0,189,0,0,184,181,0,0,0,182,0,0,136,189,0,0,200,189,0,0,144,182,0,0,176,182,0,0,104,190,0,0,168,190,0,0,232,190,0,0,112,183,0,0,192,183,0,0,40,191,0,0,96,191,0,0,232,191,0,0,16,192,0,0,0,185,0,0,40,185,0,0,88,185,0,0,120,192,0,0,0,193,0,0,0,194,0,0,152,186,0,0,200,186,0,0,16,187,0,0,48,187,0,0,240,179,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,199,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+45352);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,217,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+55696);
/* memory initializer */ allocate([24,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,225,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,225,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,227,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,232,6,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,112,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,208,8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,9,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,9,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,9,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,160,21,1,0,192,22,1,0,200,22,1,0,216,22,1,0,232,22,1,0,248,22,1,0,16,23,1,0,40,23,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,160,21,1,0,168,21,1,0,240,21,1,0,24,22,1,0,56,22,1,0,88,22,1,0,128,22,1,0,168,22,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,8,30,1,0,24,30,1,0,32,30,1,0,40,30,1,0,48,30,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,80,30,1,0,88,30,1,0,104,30,1,0,120,30,1,0,48,30,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+66380);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,56,57,1,0,0,59,1,0,8,59,1,0,16,59,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,56,57,1,0,64,58,1,0,144,58,1,0,192,58,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,56,57,1,0,0,58,1,0,8,58,1,0,16,58,1,0,32,58,1,0,40,58,1,0,56,58,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,56,57,1,0,64,57,1,0,88,57,1,0,104,57,1,0,176,57,1,0,192,57,1,0,224,57,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,232,68,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,232,68,1,0,10,0,0,0,11,0,0,0,140,68,1,0,4,69,1,0,24,69,1,0,160,68,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,254,1,0,184,68,1,0,128,186,1,0,0,0,0,0,104,0,0,0,0,0,0,0,128,186,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,128,186,1,0,14,0,0,0,15,0,0,0,0,0,0,0,144,69,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,248,254,1,0,96,69,1,0,120,185,1,0,0,0,0,0,0,0,0,0,24,70,1,0,32,70,1,0,16,70,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,240,69,1,0,0,70,1,0,16,70,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+76624);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,112,86,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,112,86,1,0,20,0,0,0,21,0,0,0,20,86,1,0,140,86,1,0,160,86,1,0,40,86,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,254,1,0,64,86,1,0,240,185,1,0,0,0,0,0,108,0,0,0,0,0,0,0,240,185,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,240,185,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,168,96,1,0,144,98,1,0,152,98,1,0,224,100,1,0,248,98,1,0,8,99,1,0,232,100,1,0,240,100,1,0,248,100,1,0,0,101,1,0,16,101,1,0,32,101,1,0,48,101,1,0,64,101,1,0,80,101,1,0,96,101,1,0,112,101,1,0,136,101,1,0,192,100,1,0,216,100,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,168,96,1,0,144,98,1,0,152,98,1,0,168,98,1,0,248,98,1,0,8,99,1,0,24,99,1,0,56,99,1,0,88,99,1,0,120,99,1,0,160,99,1,0,200,99,1,0,240,99,1,0,24,100,1,0,48,100,1,0,80,100,1,0,112,100,1,0,152,100,1,0,192,100,1,0,216,100,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,168,96,1,0,112,98,1,0,120,98,1,0,128,98,1,0,168,96,1,0,176,97,1,0,0,98,1,0,48,98,1,0,168,96,1,0,112,97,1,0,120,97,1,0,128,97,1,0,144,97,1,0,152,97,1,0,168,97,1,0,0,0,0,0,168,96,1,0,176,96,1,0,200,96,1,0,216,96,1,0,32,97,1,0,48,97,1,0,80,97,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,200,103,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,200,103,1,0,29,0,0,0,30,0,0,0,84,103,1,0,228,103,1,0,248,103,1,0,104,103,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,248,254,1,0,128,103,1,0,128,186,1,0,0,0,0,0,56,0,0,0,0,0,0,0,128,186,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,128,186,1,0,14,0,0,0,15,0,0,0,0,0,0,0,136,104,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,248,254,1,0,64,104,1,0,120,185,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+86864);
/* memory initializer */ allocate([114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,24,125,1,0,24,125,1,0,24,125,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,192,127,1,0,208,127,1,0,232,127,1,0,8,128,1,0,40,128,1,0,64,128,1,0,96,128,1,0,120,128,1,0,136,128,1,0,152,128,1,0,176,128,1,0,200,128,1,0,232,128,1,0,8,129,1,0,152,128,1,0,32,129,1,0,64,129,1,0,88,129,1,0,112,129,1,0,136,129,1,0,168,129,1,0,184,129,1,0,216,129,1,0,248,129,1,0,16,130,1,0,40,130,1,0,64,130,1,0,80,130,1,0,104,130,1,0,128,130,1,0,152,130,1,0,184,130,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+97104);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+104040);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,192,171,1,0,200,171,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,216,171,1,0,224,171,1,0,232,171,1,0,240,171,1,0,144,1,0,0,0,0,0,0,96,172,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+109264);
/* memory initializer */ allocate([56,179,1,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,248,254,1,0,24,179,1,0,184,185,1,0,0,0,0,0,0,0,0,0,160,179,1,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,248,254,1,0,136,179,1,0,184,185,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,56,180,1,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,248,254,1,0,24,180,1,0,120,185,1,0,0,0,0,0,0,0,0,0,160,180,1,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,248,254,1,0,136,180,1,0,120,185,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,208,254,1,0,176,180,1,0,0,0,0,0,24,181,1,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,192,181,1,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,248,254,1,0,8,181,1,0,0,0,0,0,0,0,0,0,0,0,0,0,88,181,1,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,248,254,1,0,64,181,1,0,24,181,1,0,0,0,0,0,0,0,0,0,152,181,1,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,248,254,1,0,128,181,1,0,24,181,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,248,254,1,0,168,181,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,8,182,1,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,248,254,1,0,240,181,1,0,192,181,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,208,254,1,0,24,182,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,248,254,1,0,64,182,1,0,56,182,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,240,184,1,0,49,0,0,0,50,0,0,0,0,0,0,0,120,185,1,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,184,185,1,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,240,185,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,240,185,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,56,186,1,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,56,186,1,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,128,186,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,128,186,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,200,186,1,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,200,186,1,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,184,1,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,184,184,1,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,248,254,1,0,112,184,1,0,8,182,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,208,254,1,0,160,184,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,248,254,1,0,192,184,1,0,184,184,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,248,254,1,0,0,185,1,0,184,184,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,208,254,1,0,64,185,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,208,254,1,0,128,185,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,255,1,0,192,185,1,0,0,0,0,0,1,0,0,0,240,184,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,255,1,0,8,186,1,0,0,0,0,0,1,0,0,0,48,185,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,255,1,0,80,186,1,0,0,0,0,0,1,0,0,0,240,184,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,255,1,0,152,186,1,0,0,0,0,0,1,0,0,0,48,185,1,0,3,244,255,255,0,0,0,0,40,187,1,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,248,254,1,0,8,187,1,0,88,182,1,0,0,0,0,0,0,0,0,0,80,201,1,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,201,1,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,206,1,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,192,206,1,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,207,1,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,208,1,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,64,203,1,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,64,203,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,224,203,1,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,224,203,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,112,204,1,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,204,1,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,201,1,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,202,1,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,202,1,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,202,1,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,208,1,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,56,209,1,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,200,209,1,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,88,210,1,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,205,1,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,205,1,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,40,201,1,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,198,1,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,198,1,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,200,1,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,0,201,1,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,56,197,1,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,248,254,1,0,32,197,1,0,208,180,1,0,0,0,0,0,0,0,0,0,200,197,1,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,208,254,1,0,168,197,1,0,88,255,1,0,144,197,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,197,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,88,255,1,0,232,197,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,197,1,0,2,0,0,0,0,0,0,0,152,198,1,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,208,254,1,0,120,198,1,0,88,255,1,0,80,198,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,144,198,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,88,255,1,0,184,198,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,144,198,1,0,2,0,0,0,0,0,0,0,88,199,1,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,255,1,0,48,199,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,144,198,1,0,2,0,0,0,0,0,0,0,208,199,1,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,255,1,0,168,199,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,144,198,1,0,2,0,0,0,0,0,0,0,72,200,1,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,248,254,1,0,32,200,1,0,208,199,1,0,0,0,0,0,0,0,0,0,176,200,1,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,248,254,1,0,136,200,1,0,208,199,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,248,254,1,0,192,200,1,0,56,197,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,248,254,1,0,232,200,1,0,56,197,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,248,254,1,0,16,201,1,0,56,197,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,248,254,1,0,56,201,1,0,56,197,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,248,254,1,0,96,201,1,0,56,197,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,208,254,1,0,168,201,1,0,88,255,1,0,136,201,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,201,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,88,255,1,0,232,201,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,201,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,88,255,1,0,40,202,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,201,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,88,255,1,0,104,202,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,201,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,208,254,1,0,240,202,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,208,254,1,0,16,203,1,0,88,255,1,0,168,202,1,0,0,0,0,0,3,0,0,0,56,197,1,0,2,0,0,0,8,203,1,0,2,0,0,0,56,203,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,208,254,1,0,176,203,1,0,88,255,1,0,104,203,1,0,0,0,0,0,3,0,0,0,56,197,1,0,2,0,0,0,8,203,1,0,2,0,0,0,216,203,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,208,254,1,0,80,204,1,0,88,255,1,0,8,204,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,104,204,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,88,255,1,0,144,204,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,104,204,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,208,254,1,0,16,205,1,0,88,255,1,0,248,204,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,40,205,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,88,255,1,0,80,205,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,40,205,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,254,1,0,232,205,1,0,88,255,1,0,208,205,1,0,0,0,0,0,1,0,0,0,8,206,1,0,0,0,0,0,88,255,1,0,136,205,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,16,206,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,88,255,1,0,144,206,1,0,0,0,0,0,1,0,0,0,8,206,1,0,0,0,0,0,88,255,1,0,72,206,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,168,206,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,254,1,0,64,207,1,0,88,255,1,0,40,207,1,0,0,0,0,0,1,0,0,0,96,207,1,0,0,0,0,0,88,255,1,0,224,206,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,104,207,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,88,255,1,0,232,207,1,0,0,0,0,0,1,0,0,0,96,207,1,0,0,0,0,0,88,255,1,0,160,207,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,0,208,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,208,254,1,0,128,208,1,0,88,255,1,0,56,208,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,160,208,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,208,254,1,0,16,209,1,0,88,255,1,0,200,208,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,48,209,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,208,254,1,0,160,209,1,0,88,255,1,0,88,209,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,192,209,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,208,254,1,0,48,210,1,0,88,255,1,0,232,209,1,0,0,0,0,0,2,0,0,0,56,197,1,0,2,0,0,0,80,210,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+111316);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,64,252,1,0,110,0,0,0,72,252,1,0,114,0,0,0,80,252,1,0,102,0,0,0,88,252,1,0,97,0,0,0,96,252,1,0,101,0,0,0,104,252,1,0,119,0,0,0,112,252,1,0,87,0,0,0,128,252,1,0,115,0,0,0,144,252,1,0,83,0,0,0,160,252,1,0,100,0,0,0,176,252,1,0,68,0,0,0,192,252,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,72,254,1,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,208,254,1,0,32,254,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,248,254,1,0,56,254,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,248,254,1,0,88,254,1,0,48,254,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,248,254,1,0,144,254,1,0,128,254,1,0,0,0,0,0,0,0,0,0,184,254,1,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,64,255,1,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,248,254,1,0,24,255,1,0,184,254,1,0,0,0,0,0,0,0,0,0,160,255,1,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,248,254,1,0,120,255,1,0,184,254,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,1,2,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,248,254,1,0,208,1,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+121656);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_setjmp=true;

  var _floor=Math_floor;

  var _atan2=Math_atan2;


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_destroy;var Kb=env._lis_solver_set_option;var Lb=env._tmpfile;var Mb=env._send;var Nb=env._pow;var Ob=env._atan2;var Pb=env.___cxa_is_number_type;var Qb=env.___cxa_free_exception;var Rb=env.___cxa_find_matching_catch;var Sb=env._isxdigit_l;var Tb=env.___cxa_guard_release;var Ub=env._truncate;var Vb=env._strtol;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._fscanf;var dc=env._qsort;var ec=env._putchar;var fc=env._floor;var gc=env._pthread_mutex_unlock;var hc=env._printf;var ic=env._sprintf;var jc=env._fopen;var kc=env._vasprintf;var lc=env._emscripten_get_now;var mc=env._stat;var nc=env._vsnprintf;var oc=env._strtoull_l;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._fseek;var Wc=env._isxdigit;var Xc=env._fclose;var Yc=env.__parseInt;var Zc=env._log;var _c=env._pthread_cond_broadcast;var $c=env._popen;var ad=env._recv;var bd=env._fgetc;var cd=env._sysconf;var dd=env.__getFloat;var ed=env._abort;var fd=env._ceil;var gd=env._isspace;var hd=env._localtime;var id=env._pthread_getspecific;var jd=env._pthread_cond_wait;var kd=env._llvm_lifetime_start;var ld=env._acos;var md=env._ungetc;var nd=env._system;var od=env._fmin;var pd=env._fmax;var qd=env._fflush;var rd=env._strftime_l;var sd=env._fprintf;var td=env._sscanf;var ud=env._catgets;var vd=env._strdup;var wd=env._asprintf;var xd=env.__exit;var yd=env.___ctype_toupper_loc;var zd=env._bsearch;var Ad=env.__arraySum;var Bd=env.__formatString;var Cd=env._htonl;var Dd=env.___ctype_tolower_loc;var Ed=env._unlink;var Fd=env._fputs;var Gd=env._GC_malloc_atomic;var Hd=env._pread;var Id=env._lis_vector_set_size;var Jd=env._mkport;var Kd=env.__scanString;var Ld=env._pthread_setspecific;var Md=env._copysign;var Nd=env._fputc;var Od=env.___cxa_throw;var Pd=env._lis_solver_destroy;var Qd=env._isdigit;var Rd=env._strerror;var Sd=env._emscripten_longjmp;var Td=env._lis_vector_create;var Ud=env._atexit;var Vd=env._sqrt;var Wd=env._strerror_r;var Xd=0.0;
// EMSCRIPTEN_START_FUNCS
function Ee(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Fe(){return i|0}function Ge(a){a=a|0;i=a}function He(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ie(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Je(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ke(a){a=a|0;J=a}function Le(a){a=a|0;K=a}function Me(a){a=a|0;L=a}function Ne(a){a=a|0;M=a}function Oe(a){a=a|0;N=a}function Pe(a){a=a|0;O=a}function Qe(a){a=a|0;P=a}function Re(a){a=a|0;Q=a}function Se(a){a=a|0;R=a}function Te(a){a=a|0;S=a}function Ue(a){a=a|0;var b=0,d=0;b=i;Nz(a)|0;d=a+540|0;de[c[(c[d>>2]|0)+40>>2]&127](a)|0;de[c[(c[d>>2]|0)+28>>2]&127](a)|0;de[c[(c[d>>2]|0)+32>>2]&127](a)|0;de[c[(c[d>>2]|0)+48>>2]&127](a)|0;de[c[(c[d>>2]|0)+52>>2]&127](a)|0;xy(a);i=b;return}function Ve(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=C_(B|0)|0;D=_Z(C+11|0)|0;N_(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=jc(D|0,32)|0;if((C|0)==0){B=Rd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;wv(23,0,40,u);Xc(0)|0;F=0}else{F=C}$Z(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}xe[c[41948>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Tw(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Tw(2);Sw(2)}Hw(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];uv(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];ky(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];uv(23,1,144,r);Z=vz(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ue(b);yy(b);if((c[41140>>2]|0)!=0){ae[c[10400]&255](23)}if((c[2]|0)!=0){Sw(4)}A=my(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];uv(7,1,200,q);if((c[97924>>2]|0)==0){be[c[82548>>2]&63](82528,b)}oy(b,c[J>>2]|0,z,d);if((c[41076>>2]|0)!=0){ae[c[10400]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;Cy(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Vw(4)}if((Hz(b,1,1)|0)!=0){c[B>>2]=1;Cy(b)}de[c[(c[K>>2]|0)+88>>2]&127](b)|0;xy(b);Gy(b);yy(b);do{if((T|0)==0){_=0}else{Sw(7);Vw(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Nw(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Nw(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Iw(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Nw(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Vw(7);if((la|0)!=0){_=T;break}c[p>>2]=Rd(c[(Nc()|0)>>2]|0)|0;wv(23,0,240,p);Xc(T|0)|0;_=0}}while(0);if((c[97924>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;be[c[82548>>2]&63](82528,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[22032]|0)!=0){ca=f;ba=88136;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];mv(M,f);Nd(10,M|0)|0;ba=c[22040]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;uv(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((ez(b,0)|0)!=0){ma=58;break}if((Yy(b,0)|0)!=0){ma=58;break}if((Oy(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((ez(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(1,0,448,m);U=_;V=-2;break}if((Yy(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(1,0,536,l);U=_;V=-3;break}T=(Oy(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Xc(U|0)|0;i=e;return V|0}function We(a){a=a|0;i=i;return 0}function Xe(a){a=a|0;i=i;return 0}function Ye(a){a=a|0;i=i;return 0}function Ze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+24>>3];l=+h[a+16>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Tj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3]=+h[f>>3];i=b;return}function _e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+24>>3];l=+h[a+16>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];_j(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3]=+h[f>>3];i=b;return}function $e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=1.0- +h[b>>3];i=i;return}function af(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+112>>3]),1.0e-13);k=+h[g>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,872,864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}function bf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Jj(d,c[a+536>>2]|0,+h[f+24>>3],+h[f+16>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+248>>3]=+h[d>>3];i=b;return}function cf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+248>>3];k=+h[g+24>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,j,912,904,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+248>>3];j=+h[g+24>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+Av(c[b+536>>2]|0,l,912,904,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+264|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+248>>3];l=+h[y+24>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+Av(f,m,912,904,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+Av(f,A+-.3778957546290221,944,904,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+264|0;x=w;h[x>>3]=o;i=d;return}}function df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b>>3]- +h[b+264>>3];i=i;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b>>3]- +h[b+280>>3];i=i;return}function ff(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+280>>3];k=1.0-j;l=+h[g+112>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,1032,1024,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+280>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+272>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+312|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+312|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,1032,1024,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+312|0;z=y;h[z>>3]=w;i=d;return}function gf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+248>>3];k=+pd(1.0e-13,+(+h[g+24>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,1072,1064,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+256>>3]=m*.6221042453709779;i=d;return}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=j/.018015268-j/.0289586+34.53205610768476;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}j=+Av(c[b+536>>2]|0,k,1144,1136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}function jf(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+144>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+8|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+144|0;p=o;h[p>>3]=m;i=b;return}else{g=d+32|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+144|0;p=o;h[p>>3]=m;i=b;return}}function kf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+40>>3];m=+h[(c[g>>2]|0)+152>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Ki(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+448>>3]=+h[f>>3];i=b;return}function lf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+40>>3];m=+h[(c[g>>2]|0)+152>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Ji(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+472>>3]=+h[f>>3];i=b;return}function mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;xw(k,1,+h[(c[o>>2]|0)+32>>3],j);j=b+536|0;p=c[j>>2]|0;q=b+4|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];s=+h[(c[o>>2]|0)+152>>3];t=f;u=k;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];Di(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[(c[o>>2]|0)+32>>3],g);g=c[j>>2]|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];v=+h[(c[o>>2]|0)+152>>3];o=e;m=l;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];Ji(n,g,r,v,e);v=+h[n>>3];n=c[c[q>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+40>>3];if(v!=0.0){w=e;x=r/v;y=s-x;z=w;A=z+464|0;B=A;h[B>>3]=y;i=d;return}if(r==0.0){w=e;x=r;y=s-x;z=w;A=z+464|0;B=A;h[B>>3]=y;i=d;return}C=r/+Av(c[j>>2]|0,v,1248,1240,+h[n>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[q>>2]>>2]|0)+8>>2]|0;x=C;y=s-x;z=w;A=z+464|0;B=A;h[B>>3]=y;i=d;return}function nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+40>>3];m=+h[(c[g>>2]|0)+152>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Li(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[f>>3];i=b;return}function of(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;ki(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+40>>3],+h[(c[a+416>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]=+h[d>>3];i=b;return}function pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+408>>3];k=+h[g+40>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,j,1424,1416,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+408>>3];j=+h[g+40>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+Av(c[b+536>>2]|0,l,1424,1416,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+424|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+408>>3];l=+h[y+40>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+Av(f,m,1424,1416,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+Av(f,A+-.3778957546290221,1464,1416,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+424|0;x=w;h[x>>3]=o;i=d;return}}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+424>>3];i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+440>>3];i=i;return}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+440>>3];k=1.0-j;l=+h[g+184>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,1560,1552,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+440>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+432>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,1560,1552,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}function tf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+408>>3];k=+pd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,1608,1600,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+416>>3]=m*.6221042453709779;i=d;return}function uf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+32>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Tj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[f>>3];i=b;return}function vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+32>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];_j(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3]=+h[f>>3];i=b;return}function wf(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+144>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+392>>3]=-(b*+h[(!(b>=0.0)?d+608|0:d+480|0)>>3]);i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=1.0- +h[b+8>>3];i=i;return}function yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+160>>3]),1.0e-13);k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+568|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+568|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,1688,1680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+568|0;p=o;h[p>>3]=m;i=d;return}function zf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Jj(d,c[a+536>>2]|0,+h[f+40>>3],+h[f+32>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[d>>3];i=b;return}function Af(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=+h[g+40>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,j,1728,1720,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+520>>3];j=+h[g+40>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+Av(c[b+536>>2]|0,l,1728,1720,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+536|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+520>>3];l=+h[y+40>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+Av(f,m,1728,1720,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+Av(f,A+-.3778957546290221,1760,1720,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+536|0;x=w;h[x>>3]=o;i=d;return}}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+8>>3]- +h[b+536>>3];i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+8>>3]- +h[b+552>>3];i=i;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+552>>3];k=1.0-j;l=+h[g+160>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,1848,1840,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+552>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+544>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+584|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+584|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,1848,1840,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+584|0;z=y;h[z>>3]=w;i=d;return}function Ef(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=+pd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,1888,1880,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+528>>3]=m*.6221042453709779;i=d;return}function Ff(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8>>3];k=j/.018015268-j/.0289586+34.53205610768476;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+576|0;q=p;h[q>>3]=n;i=d;return}j=+Av(c[b+536>>2]|0,k,1952,1944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+576|0;q=p;h[q>>3]=n;i=d;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+24>>3]- +h[(c[a+416>>2]|0)+168>>3];i=i;return}function Hf(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+264>>3];g=+h[e+256>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+192>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+200|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+200|0;r=q;h[r>>3]=o;i=d;return}s=l/+Av(c[b+536>>2]|0,g,2048,2040,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+200|0;r=q;h[r>>3]=o;i=d;return}function If(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Ly(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+48|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+136|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a;f=a;g=+h[e>>3];j=f;k=j+136|0;l=k;h[l>>3]=g;i=b;return}}function Jf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+200>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+48|0}else{e=b}h[b+96>>3]=-(d*+h[e>>3]);i=i;return}function Kf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+200>>3];h[b+208>>3]=-(d*+h[(!(d>=0.0)?b+744|0:b+336|0)>>3]);i=i;return}function Lf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Ly(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+384>>3]=+h[(a?e+744|0:e+336|0)>>3];i=b;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=+h[b+40>>3]- +h[b+24>>3];i=i;return}function Nf(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+208>>3];g=+h[e+200>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+360>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}s=l/+Av(c[b+536>>2]|0,g,2080,2072,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}function Of(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+368>>3];h[b+128>>3]=d*+h[(!(d>=0.0)?b:b+8|0)>>3];i=i;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=-+h[b+128>>3]- +h[b+144>>3];i=i;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+128>>3]+ +h[b+96>>3];i=i;return}function Rf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+368>>3];h[b+376>>3]=d*+h[(!(d>=0.0)?b+336|0:b+608|0)>>3];i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=-+h[b+376>>3]- +h[b+392>>3];i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=+h[b+376>>3]+ +h[b+208>>3];i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[(c[a+416>>2]|0)+144>>3]- +h[b+368>>3];i=i;return}function Vf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+104>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+624>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+648|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,e,2112,2104,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+648|0;p=o;h[p>>3]=m;i=d;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=+h[b+368>>3]- +h[b+200>>3];i=i;return}function Xf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+352>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+656|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,e,2136,2128,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+656|0;p=o;h[p>>3]=m;i=d;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+16>>3]+-273.15;i=i;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+24>>3]*1.0e-5;i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function $f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+32>>3]+-273.15;i=i;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function bg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+4|0;xw(k,1,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[q+40>>3];s=+h[q+32>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];Kj(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8>>3],g);g=c[j>>2]|0;m=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[m+40>>3];u=+h[m+32>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];Mi(n,g,r,u,e);u=+h[n>>3];n=c[c[o>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+40>>3];if(u!=0.0){v=e;w=r/u;x=s-w;y=v;z=y+592|0;A=z;h[A>>3]=x;i=d;return}if(r==0.0){v=e;w=r;x=s-w;y=v;z=y+592|0;A=z;h[A>>3]=x;i=d;return}B=r/+Av(c[j>>2]|0,u,2160,2152,+h[n>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[o>>2]>>2]|0)+8>>2]|0;w=B;x=s-w;y=v;z=y+592|0;A=z;h[A>>3]=x;i=d;return}function cg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+32>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Mi(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[f>>3];i=b;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[(c[a+416>>2]|0)+104>>3]*+h[b+600>>3];i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+8>>3]*+h[b+488>>3];i=i;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+488>>3]*+h[b+592>>3];i=i;return}function gg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3];k=+h[g+616>>3]- +h[g+624>>3]*+h[g+592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,2304,2296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}function hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3];k=+h[g+168>>3]- +h[g+8>>3]*+h[g+624>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,2304,2320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}function ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+80>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+80|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+fz(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+80>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+88|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+fz(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+88>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+8>>3]=k;dz(a,2)|0;a=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+80>>3]=+h[a>>3];h[f+88>>3]=+h[a+8>>3];i=b;return}function jg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+4|0;xw(k,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[q+24>>3];s=+h[q+16>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];Kj(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],g);g=c[j>>2]|0;m=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[m+24>>3];u=+h[m+16>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];Mi(n,g,r,u,e);u=+h[n>>3];n=c[c[o>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+24>>3];if(u!=0.0){v=e;w=r/u;x=s-w;y=v;z=y+320|0;A=z;h[A>>3]=x;i=d;return}if(r==0.0){v=e;w=r;x=s-w;y=v;z=y+320|0;A=z;h[A>>3]=x;i=d;return}B=r/+Av(c[j>>2]|0,u,2336,2328,+h[n>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[o>>2]>>2]|0)+8>>2]|0;w=B;x=s-w;y=v;z=y+320|0;A=z;h[A>>3]=x;i=d;return}function kg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+24>>3];l=+h[a+16>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Mi(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3]=+h[f>>3];i=b;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[(c[a+416>>2]|0)+216>>3]*+h[b+328>>3];i=i;return}function mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b>>3]*+h[b+216>>3];i=i;return}function ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+216>>3]*+h[b+320>>3];i=i;return}function og(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3];k=+h[g+344>>3]- +h[g+352>>3]*+h[g+320>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,2488,2480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}function pg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3];k=+h[g+120>>3]- +h[g>>3]*+h[g+352>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,2488,2504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}function qg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+64>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+64|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+fz(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+64>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+72>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+72|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+fz(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+72>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+8>>3]=k;dz(a,3)|0;a=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+64>>3]=+h[a>>3];h[f+72>>3]=+h[a+8>>3];i=b;return}function rg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],143.15)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2512,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,2576)|0,2624)|0,2640)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2736,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,2760)|0,2776)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function tg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2904,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],0,1,6)|0)|0,2760)|0,2928)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2936,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,2952)|0,2624)|0,2976)|0;j=dw(dw(g,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,3008)|0;f=c[a+536>>2]|0;a=c[22536]|0;g=d;k=3064;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];De[a&31](f,d,j,e);i=b;return}function vg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Ly(+h[(c[f>>2]|0)+152>>3],143.15)|0;if(!(g<<24>>24==0|(Ky(+h[(c[f>>2]|0)+152>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2512,bw(+h[(c[f>>2]|0)+152>>3],0,1,6)|0)|0,2576)|0,2624)|0,2640)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function wg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Ly(+h[(c[f>>2]|0)+32>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[f>>2]|0)+32>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2736,bw(+h[(c[f>>2]|0)+32>>3],0,1,6)|0)|0,2760)|0,2776)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2904,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],0,1,6)|0)|0,2760)|0,2928)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2936,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,2952)|0,2624)|0,2976)|0;f=dw(dw(g,bw(+h[(c[a+416>>2]|0)+152>>3],0,1,6)|0)|0,3008)|0;g=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](g,d,f,e);i=b;return}function zg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Ly(+h[(c[f>>2]|0)+184>>3],143.15)|0;if(!(g<<24>>24==0|(Ky(+h[(c[f>>2]|0)+184>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2512,bw(+h[(c[f>>2]|0)+184>>3],0,1,6)|0)|0,2576)|0,2624)|0,2640)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Ag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Ly(+h[(c[f>>2]|0)+48>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[f>>2]|0)+48>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2736,bw(+h[(c[f>>2]|0)+48>>3],0,1,6)|0)|0,2760)|0,2776)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2904,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+176>>3],0,1,6)|0)|0,2760)|0,2928)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Cg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((Ly(+h[(c[f>>2]|0)+168>>3],0.0)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2936,bw(+h[(c[f>>2]|0)+168>>3],0,1,6)|0)|0,2952)|0,2624)|0,2976)|0;j=dw(dw(g,bw(+h[(c[f>>2]|0)+184>>3],0,1,6)|0)|0,3008)|0;f=c[a+536>>2]|0;a=c[22536]|0;g=d;k=3064;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];De[a&31](f,d,j,e);i=b;return}function Dg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],143.15)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],2.0e3)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2512,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,2576)|0,2624)|0,2640)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Eg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2736,bw(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,2760)|0,2776)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Fg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(Ky(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(dw(dw(2904,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>3],0,1,6)|0)|0,2760)|0,2928)|0,2784)|0,2624)|0,2800)|0;f=c[a+536>>2]|0;a=c[22536]|0;j=d;k=3040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Gg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Ly(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=b;return}g=dw(dw(dw(dw(2936,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,2952)|0,2624)|0,2976)|0;j=dw(dw(g,bw(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,3008)|0;f=c[a+536>>2]|0;a=c[22536]|0;g=d;k=3064;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];De[a&31](f,d,j,e);i=b;return}function Hg(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);i=c;return 0}function Ig(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Jg(b);i=c;return 0}function Jg(a){a=a|0;var b=0;b=i;_e(a);jf(a);nf(a);vf(a);wf(a);Gf(a);Hf(a);Jf(a);Kf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);bg(a);cg(a);dg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);og(a);pg(a);qg(a);i=b;return}function Kg(a,b){a=a|0;b=+b;i=i;return 0}function Lg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;xv(c[a+536>>2]|0,(a|0)!=0|0,3296,b);c[a+540>>2]=3104;c[a+84>>2]=3328;c[a+88>>2]=3328;c[a+92>>2]=3376;c[a+96>>2]=3440;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=6;c[a+116>>2]=100;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=34;c[a+140>>2]=0;c[a+144>>2]=15;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=70;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;c[a+176>>2]=6;c[a+180>>2]=0;c[a+184>>2]=6;c[a+188>>2]=0;c[a+56>>2]=3480;c[a+64>>2]=211;c[a+72>>2]=0;c[a+68>>2]=360;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=4;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Mg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=P_(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=41928;F=41952;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[10482]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=P_(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[9712]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=P_(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(47,c[9712]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=P_(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;B_(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=P_(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;B_(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=P_(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(47,c[9712]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=P_(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=P_(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=P_(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,3536,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=P_(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=P_(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=P_(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=P_(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=P_(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=P_(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(47,c[9712]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=P_(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=P_(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=P_(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=P_(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function Ng(){var a=0;a=i;qd(0)|0;rc(3696,18,1,c[r>>2]|0)|0;qd(0)|0;i=a;return}function Og(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;Pg(j,b,d,c);m=+h[j>>3];Pg(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=dw(dw(dw(3720,bw(d,0,1,6)|0)|0,3904)|0,3912)|0;k=dw(dw(dw(o,bw(e,0,1,6)|0)|0,3904)|0,3928)|0;o=dw(dw(dw(k,bw(m,0,1,6)|0)|0,3904)|0,3952)|0;Qg(0,dw(dw(dw(o,bw(n,0,1,6)|0)|0,3904)|0,3976)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;Pg(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function Pg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;fj(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function Qg(a,b){a=a|0;b=b|0;a=i;$w(b);i=a;return}function Rg(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;Sg(j,b,d,c);m=+h[j>>3];Sg(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=dw(dw(dw(3720,bw(d,0,1,6)|0)|0,3904)|0,3912)|0;k=dw(dw(dw(o,bw(e,0,1,6)|0)|0,3904)|0,3928)|0;o=dw(dw(dw(k,bw(m,0,1,6)|0)|0,3904)|0,3952)|0;Qg(0,dw(dw(dw(o,bw(n,0,1,6)|0)|0,3904)|0,3976)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;Sg(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function Sg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;rh(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function Tg(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;Ug(j,b,d,c);m=+h[j>>3];Ug(k,b,e,c);n=+h[k>>3];if(m>0.0&n>0.0){o=3}else{if(m<0.0&n<0.0){o=3}}if((o|0)==3){o=dw(dw(dw(3720,bw(d,0,1,6)|0)|0,3904)|0,3912)|0;k=dw(dw(dw(o,bw(e,0,1,6)|0)|0,3904)|0,3928)|0;o=dw(dw(dw(k,bw(m,0,1,6)|0)|0,3904)|0,3952)|0;Qg(0,dw(dw(dw(o,bw(n,0,1,6)|0)|0,3904)|0,3976)|0)}p=e-d;o=l;q=d;r=e;e=d;d=p;s=p;p=m;t=n;n=m;while(1){if(+U(+n)<+U(+t)){u=r;v=e;w=r;x=t;y=n;z=t}else{u=q;v=r;w=e;x=p;y=t;z=n}m=+U(+v)*2.0e-15+f;A=w*.5+v*-.5;if(+U(+A)<=m|y==0.0){break}do{if(+U(+s)<m){B=A;C=A}else{if(+U(+x)<=+U(+y)){B=A;C=A;break}D=y/x;if(u==w){E=A*D*2.0;F=1.0-D}else{G=x/z;H=y/z;I=H+-1.0;E=D*(A*G*(G-H)*2.0-(v-u)*I);F=(G+-1.0)*(D+-1.0)*I}if(E>0.0){J=E;K=-F}else{J=-E;K=F}if(!(J*2.0<A*K*3.0- +U(+(m*K)))){B=A;C=A;break}if(!(J<+U(+(s*K*.5)))){B=A;C=A;break}B=J/K;C=d}}while(0);do{if(+U(+B)>m){L=B}else{if(A>0.0){L=m;break}L=-m}}while(0);m=v+L;Ug(l,b,m,c);A=+h[o>>3];if(!(A>0.0&z>0.0)){if(!(A<0.0&z<0.0)){q=v;r=m;e=w;d=B;s=C;p=y;t=A;n=z;continue}}I=m-v;q=v;r=m;e=v;d=I;s=I;p=y;t=A;n=y}h[a>>3]=v;i=g;return}function Ug(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0;b=i;i=i+8|0;e=b;Bh(e,0,c);h[a>>3]=+h[e>>3]-d;i=b;return}function Vg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function Wg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Xg(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Yg(b,0,0.0,0.0,g);i=f;return}function Xg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;e=i;i=i+96|0;f=e;g=e+8|0;Zg(f,b,c,d,.1);j=+h[f>>3];_g(g,b,j,d);k=+h[g+24>>3];l=+h[g+32>>3];m=+h[g+48>>3];n=l*+h[g+64>>3];o=(n- +h[g+40>>3])*287.117+-6610.41237132543;p=k*(m*2.0+k*+h[g+56>>3])*d*287.117;q=j*k*(m-l*+h[g+80>>3])*287.117;r=l*l*+h[g+72>>3]*-287.117;l=q/j;s=-+Yw(j,-2)/p;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=(k*m+n)*d*287.117+-1589557.62320524;h[a+24>>3]=287.117;h[a+32>>3]=r+l*l/p*d;h[a+40>>3]=r;h[a+48>>3]=j;h[a+56>>3]=o;h[a+64>>3]=q;h[a+72>>3]=p;h[a+80>>3]=q/(j*j*p);h[a+88>>3]=s;i=e;return}function Yg(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Zg(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0,Z=0,_=0;g=i;i=i+280|0;j=g;k=g+88|0;l=g+176|0;m=g+264|0;n=l;o=l+8|0;p=l+16|0;q=l+24|0;r=l+32|0;s=l+40|0;t=l+48|0;u=l+56|0;v=l+64|0;w=l+72|0;x=l+80|0;y=k;z=k+8|0;A=k+16|0;B=k+24|0;C=k+32|0;D=k+40|0;E=k+48|0;F=k+56|0;G=k+64|0;H=k+72|0;I=k+80|0;J=m;K=m+8|0;L=d/(e*287.117);M=0;do{_g(l,b,L,e);N=+h[o>>3];O=+h[p>>3];P=+h[q>>3];Q=+h[r>>3];R=+h[s>>3];S=+h[t>>3];T=+h[u>>3];V=+h[v>>3];W=+h[w>>3];X=+h[x>>3];h[y>>3]=+h[n>>3];h[z>>3]=N;h[A>>3]=O;h[B>>3]=P;h[C>>3]=Q;h[D>>3]=R;h[E>>3]=S;h[F>>3]=T;h[G>>3]=V;h[H>>3]=W;h[I>>3]=X;Y=j+0|0;Z=k+0|0;_=Y+88|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$g(m,0,j);X=+h[J>>3]-d;L=L-X/+h[K>>3];M=M+1|0;}while((M|0)<100&!(+U(+X)<=f));h[a>>3]=L;i=g;return}function _g(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0;f=i;i=i+176|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=f+120|0;p=f+144|0;q=f+168|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;c[B>>2]=13;sw(C,1,B);B=C;C=4032;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[A>>2]=19;sw(D,1,A);A=D;D=4048;c[A+0>>2]=c[D+0>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];c[z>>2]=19;Fv(E,1,z);z=E;E=4064;c[z+0>>2]=c[E+0>>2];c[z+4>>2]=c[E+4>>2];c[z+8>>2]=c[E+8>>2];c[y>>2]=19;sw(F,1,y);y=F;F=4080;c[y+0>>2]=c[F+0>>2];c[y+4>>2]=c[F+4>>2];c[y+8>>2]=c[F+8>>2];c[x>>2]=19;Fv(G,1,x);x=G;G=4096;c[x+0>>2]=c[G+0>>2];c[x+4>>2]=c[G+4>>2];c[x+8>>2]=c[G+8>>2];H=d/302.55076522;I=132.6312/e;G=(bh(1,1,5)|0)==0;if(G){J=0.0}else{K=0.0;x=1;while(1){L=K+ +qw(4032,x+ -1|0)*+W(+I,+(+(x+ -4|0)));F=x+1|0;if((bh(F,1,5)|0)==0){J=L;break}else{x=F;K=L}}}if(!(H>0.0)){x=c[22536]|0;F=w;h[k>>3]=H;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=x;x=p;y=7728;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];c[x+12>>2]=c[y+12>>2];c[x+16>>2]=c[y+16>>2];c[x+20>>2]=c[y+20>>2];De[F&31](b,p,4120,w);}if(!(I>0.0)){w=c[22536]|0;p=v;h[k>>3]=I;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=w;w=o;F=7728;c[w+0>>2]=c[F+0>>2];c[w+4>>2]=c[F+4>>2];c[w+8>>2]=c[F+8>>2];c[w+12>>2]=c[F+12>>2];c[w+16>>2]=c[F+16>>2];c[w+20>>2]=c[F+20>>2];De[p&31](b,o,4184,v);}K=1.0- +ca(+(I*-25.36365));if(!(K>0.0)){v=c[22536]|0;o=u;h[k>>3]=K;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=v;v=n;p=7728;c[v+0>>2]=c[p+0>>2];c[v+4>>2]=c[p+4>>2];c[v+8>>2]=c[p+8>>2];c[v+12>>2]=c[p+12>>2];c[v+16>>2]=c[p+16>>2];c[v+20>>2]=c[p+20>>2];De[o&31](b,n,4248,u);}L=1.0- +ca(+(I*-16.90741));if(!(L>0.0)){u=c[22536]|0;n=t;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=u;u=m;o=7728;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];De[n&31](b,m,4328,t);}M=+ca(+(I*87.31279))+.6666666666666666;if(!(M>0.0)){t=c[22536]|0;m=s;h[k>>3]=M;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=t;t=l;n=7728;c[t+0>>2]=c[n+0>>2];c[t+4>>2]=c[n+4>>2];c[t+8>>2]=c[n+8>>2];c[t+12>>2]=c[n+12>>2];c[t+16>>2]=c[n+16>>2];c[t+20>>2]=c[n+20>>2];De[m&31](b,l,4408,s);}N=J+(+da(+H)+(+W(+I,1.5)*-.00019536342+(+da(+I)*2.490888032+(+da(+K)*.791309509+(+da(+L)*.212236768+ +da(+M)*.197938904)))));s=(bh(1,1,10)|0)==0;if(s){O=N}else{M=N;l=1;while(1){m=l+ -1|0;N=+qw(4048,m);L=+W(+H,+(+(Ev(4064,m)|0)));K=M+N*L*+W(+I,+(+qw(4080,m)));m=l+1|0;if((bh(m,1,10)|0)==0){O=K;break}else{l=m;M=K}}}l=(bh(11,11,19)|0)==0;if(l){P=O}else{M=O;m=11;while(1){n=m+ -1|0;O=+ca(+-+W(+H,+(+(Ev(4096,n)|0))));K=+qw(4048,n);L=+W(+H,+(+(Ev(4064,n)|0)));N=M+K*L*O*+W(+I,+(+qw(4080,n)));n=m+1|0;if((bh(n,11,19)|0)==0){P=N;break}else{m=n;M=N}}}M=1.0/H;if(s){Q=M}else{N=M;m=1;while(1){n=m+ -1|0;M=+(Ev(4064,n)|0);O=+qw(4048,n);L=+W(+H,+(+((Ev(4064,n)|0)+ -1|0)));K=N+M*O*L*+W(+I,+(+qw(4080,n)));n=m+1|0;if((bh(n,1,10)|0)==0){Q=K;break}else{m=n;N=K}}}if(l){R=Q}else{N=Q;m=11;while(1){n=m+ -1|0;Q=+ca(+-+W(+H,+(+(Ev(4096,n)|0))));K=+qw(4048,n);L=+W(+H,+(+((Ev(4064,n)|0)+ -1|0)));O=+W(+I,+(+qw(4080,n)));M=+(Ev(4064,n)|0);J=+(Ev(4096,n)|0);S=N+K*L*O*Q*(M-J*+W(+H,+(+(Ev(4096,n)|0))));n=m+1|0;if((bh(n,11,19)|0)==0){R=S;break}else{m=n;N=S}}}N=-+Yw(H,-2);if(s){T=N}else{S=N;m=1;while(1){n=m+ -1|0;t=Ev(4064,n)|0;N=+(fa((Ev(4064,n)|0)+ -1|0,t)|0);J=+qw(4048,n);M=+W(+H,+(+((Ev(4064,n)|0)+ -2|0)));Q=S+N*J*M*+W(+I,+(+qw(4080,n)));n=m+1|0;if((bh(n,1,10)|0)==0){T=Q;break}else{m=n;S=Q}}}if(l){U=T}else{S=T;m=11;while(1){n=m+ -1|0;T=+ca(+-+W(+H,+(+(Ev(4096,n)|0))));Q=+(Ev(4096,n)|0);M=+qw(4048,n);J=+W(+H,+(+((Ev(4064,n)|0)+ -2|0)));N=+W(+I,+(+qw(4080,n)));O=+(Ev(4064,n)|0);L=+(Ev(4096,n)|0);K=O-L*+W(+H,+(+(Ev(4096,n)|0)));L=+((Ev(4064,n)|0)+ -1|0);O=+(Ev(4096,n)|0);X=K*(L-O*+W(+H,+(+(Ev(4096,n)|0))));O=S+M*J*N*T*(X-Q*Q*+W(+H,+(+(Ev(4096,n)|0))));n=m+1|0;if((bh(n,11,19)|0)==0){U=O;break}else{m=n;S=O}}}if(G){Y=0.0}else{S=0.0;G=1;while(1){O=S+ +(G+ -4|0)*+qw(4032,G+ -1|0)*+W(+I,+(+(G+ -5|0)));m=G+1|0;if((bh(m,1,5)|0)==0){Y=O;break}else{G=m;S=O}}}G=I>=0.0;if(!G){m=c[22536]|0;n=r;h[k>>3]=I;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m;m=j;t=7728;c[m+0>>2]=c[t+0>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];c[m+12>>2]=c[t+12>>2];c[m+16>>2]=c[t+16>>2];c[m+20>>2]=c[t+20>>2];De[n&31](b,j,4512,r);}S=+ca(+(I*25.36365));O=+ca(+(I*16.90741));Q=+ca(+(I*-87.31279));X=+V(+I);T=S+-1.0;N=O+-1.0;J=Q*.6666666666666666+1.0;M=Y+(X*-.00029304513+(2.490888032/I+(20.07049742794785/T+(3.58837405365088/N+17.28259795778216/J))));if(s){Z=M}else{Y=M;r=1;while(1){j=r+ -1|0;M=+qw(4080,j);L=+qw(4048,j);K=+W(+H,+(+(Ev(4064,j)|0)));_=Y+M*L*K*+W(+I,+(+qw(4080,j)+-1.0));j=r+1|0;if((bh(j,1,10)|0)==0){Z=_;break}else{r=j;Y=_}}}if(l){$=Z}else{Y=Z;r=11;while(1){j=r+ -1|0;Z=+ca(+-+W(+H,+(+(Ev(4096,j)|0))));_=+qw(4080,j);K=+qw(4048,j);L=+W(+H,+(+(Ev(4064,j)|0)));M=Y+_*K*L*Z*+W(+I,+(+qw(4080,j)+-1.0));j=r+1|0;if((bh(j,11,19)|0)==0){$=M;break}else{r=j;Y=M}}}if((bh(1,1,3)|0)==0){aa=0.0}else{Y=0.0;r=1;while(1){M=+(fa(r+ -4|0,r+ -5|0)|0);Z=Y+M*+qw(4032,r+ -1|0)*+W(+I,+(+(r+ -6|0)));j=r+1|0;if((bh(j,1,3)|0)==0){aa=Z;break}else{r=j;Y=Z}}}if(!G){G=c[22536]|0;r=q;h[k>>3]=I;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=G;G=g;j=7728;c[G+0>>2]=c[j+0>>2];c[G+4>>2]=c[j+4>>2];c[G+8>>2]=c[j+8>>2];c[G+12>>2]=c[j+12>>2];c[G+16>>2]=c[j+16>>2];c[G+20>>2]=c[j+20>>2];De[r&31](b,g,4512,q);}Y=aa+(-.000146522565/X+(-2.490888032/(I*I)+(S/(T*T)*-509.0610720883695+(O/(N*N)*-60.67011135843742+Q/(J*J)*1005.994564094842))));if(s){ba=Y}else{J=Y;q=1;while(1){g=q+ -1|0;Y=+qw(4080,g);Q=+qw(4080,g)+-1.0;N=+qw(4048,g);O=+W(+H,+(+(Ev(4064,g)|0)));T=J+Y*Q*N*O*+W(+I,+(+qw(4080,g)+-2.0));g=q+1|0;if((bh(g,1,10)|0)==0){ba=T;break}else{q=g;J=T}}}if(l){ea=ba}else{J=ba;q=11;while(1){g=q+ -1|0;ba=+ca(+-+W(+H,+(+(Ev(4096,g)|0))));T=+qw(4080,g);O=+qw(4080,g)+-1.0;N=+qw(4048,g);Q=+W(+H,+(+(Ev(4064,g)|0)));Y=J+T*O*N*Q*ba*+W(+I,+(+qw(4080,g)+-2.0));g=q+1|0;if((bh(g,11,19)|0)==0){ea=Y;break}else{q=g;J=Y}}}if(s){ga=0.0}else{J=0.0;s=1;while(1){q=s+ -1|0;Y=+(Ev(4064,q)|0);ba=+qw(4080,q);Q=+qw(4048,q);N=+W(+H,+(+((Ev(4064,q)|0)+ -1|0)));O=J+Y*ba*Q*N*+W(+I,+(+qw(4080,q)+-1.0));q=s+1|0;if((bh(q,1,10)|0)==0){ga=O;break}else{s=q;J=O}}}if(l){ha=ga;ia=a;ja=ia;h[ja>>3]=d;ka=a;la=ka+8|0;ma=la;h[ma>>3]=e;na=a;oa=na+16|0;pa=oa;h[pa>>3]=287.117;qa=a;ra=qa+24|0;sa=ra;h[sa>>3]=H;ta=a;ua=ta+32|0;va=ua;h[va>>3]=I;wa=a;xa=wa+40|0;ya=xa;h[ya>>3]=P;za=a;Aa=za+48|0;Ba=Aa;h[Ba>>3]=R;Ca=a;Da=Ca+56|0;Ea=Da;h[Ea>>3]=U;Fa=a;Ga=Fa+64|0;Ha=Ga;h[Ha>>3]=$;Ia=a;Ja=Ia+72|0;Ka=Ja;h[Ka>>3]=ea;La=a;Ma=La+80|0;Na=Ma;h[Na>>3]=ha;i=f;return}else{Oa=ga;Pa=11}while(1){l=Pa+ -1|0;ga=+ca(+-+W(+H,+(+(Ev(4096,l)|0))));J=+qw(4080,l);O=+qw(4048,l);N=+W(+H,+(+((Ev(4064,l)|0)+ -1|0)));Q=+W(+I,+(+qw(4080,l)+-1.0));ba=+(Ev(4064,l)|0);Y=+(Ev(4096,l)|0);T=Oa+J*O*N*Q*ga*(ba-Y*+W(+H,+(+(Ev(4096,l)|0))));l=Pa+1|0;if((bh(l,11,19)|0)==0){ha=T;break}else{Pa=l;Oa=T}}ia=a;ja=ia;h[ja>>3]=d;ka=a;la=ka+8|0;ma=la;h[ma>>3]=e;na=a;oa=na+16|0;pa=oa;h[pa>>3]=287.117;qa=a;ra=qa+24|0;sa=ra;h[sa>>3]=H;ta=a;ua=ta+32|0;va=ua;h[va>>3]=I;wa=a;xa=wa+40|0;ya=xa;h[ya>>3]=P;za=a;Aa=za+48|0;Ba=Aa;h[Ba>>3]=R;Ca=a;Da=Ca+56|0;Ea=Da;h[Ea>>3]=U;Fa=a;Ga=Fa+64|0;Ha=Ga;h[Ha>>3]=$;Ia=a;Ja=Ia+72|0;Ka=Ja;h[Ka>>3]=ea;La=a;Ma=La+80|0;Na=Ma;h[Na>>3]=ha;i=f;return}function $g(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}function ah(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=+e;var f=0.0,g=0.0;f=+ba(+c,+d);if(e==0.0){g=f}else{g=f+ +(~~+T(+((e-f)/6.283185307179586+.5))|0)*6.283185307179586}h[a>>3]=g;i=i;return}function bh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function ch(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;Xg(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));dh(b,0,0.0,0.0,g);i=f;return}function dh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function eh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;var j=0.0,k=0.0,l=0.0;b=i;c=+h[e+48>>3];j=+h[e+64>>3];k=+h[e+72>>3];l=(j*d-c*k)*+Yw(c,-2)*(f/k);f=c*c*k*+h[e+40>>3]+j*j*+h[e+8>>3];h[a>>3]=l+f*+Yw(c,-2)*(g/k);i=b;return}function fh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;d=+h[e+72>>3];h[a>>3]=f/d- +h[e+64>>3]*(g/d);i=i;return}function gh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function hh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;sw(Oa,1,Na);c[Oa+0>>2]=c[4576+0>>2];c[Oa+4>>2]=c[4576+4>>2];c[Oa+8>>2]=c[4576+8>>2];c[Ma>>2]=2;Cv(Pa,16,1,Ma);c[La>>2]=1;Ma=Dv(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=Dv(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;Cv(Qa,16,1,Ja);c[Ia>>2]=1;Ja=Dv(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=Dv(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=Dv(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;Cv(Ua,16,1,Fa);if((bh(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +qw(4576,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((bh(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=Dv(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(Dv(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((bh(2,2,3)|0)!=0){Fa=2;do{Vg(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=Dv(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];ih(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];jh(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((bh(Fa,2,3)|0)!=0)}if((bh(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +qw(4576,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((bh(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}Vg(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=Dv(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];kh(Ya,0,f+2512|0,f+2496|0);Vg(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=Dv(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];kh(_a,0,f+2480|0,f+2464|0);Vg($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];ih(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];jh(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((bh(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +qw(4576,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((bh(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}Vg(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=Dv(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];ih(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;Vg(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=Dv(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];lh(db,0,f+2352|0,f+2336|0);Vg(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=Dv(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];lh(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];mh(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];ih(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=Dv(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(Dv(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;Vg(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=Dv(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];jh(ib,0,f+2240|0,f+2224|0);Vg(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=Dv(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];jh(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];mh(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];ih(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=Dv(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(Dv(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;Vg(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=Dv(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];lh(nb,0,f+2128|0,f+2112|0);Vg(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=Dv(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];lh(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];mh(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];ih(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=Dv(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(Dv(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;Vg(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=Dv(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];jh(sb,0,f+2016|0,f+2e3|0);Vg(tb,0,e/273.16,0.0);c[la>>2]=2;rb=Dv(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];jh(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];mh(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];ih($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=Dv(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(Dv(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;Vg(wb,0,2.0,0.0);c[ia>>2]=1;$c=Dv(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];ih(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=Dv(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];mh(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];ih(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=Dv(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(Dv(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;Vg(zb,0,2.0,0.0);c[ea>>2]=2;ad=Dv(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];ih(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=Dv(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];mh(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];ih(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=Dv(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(Dv(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;Vg(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=Dv(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];kh(cd,0,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=Dv(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(Dv(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;Vg(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=Dv(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];kh(dd,0,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=Dv(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function ih(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];Vg(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function jh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Vg(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function kh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;Vg(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function _omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(Dv(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=Dv(x,16,1,Ua)|0;c[Va>>2]=2;Db=Dv(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];jh(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=Dv(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];lh(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=Dv(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];lh(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=Dv(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(Dv(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=Dv(x,16,1,_a)|0;c[$a>>2]=4;Cb=Dv(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];jh(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=Dv(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];lh(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=Dv(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];lh(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=Dv(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(Dv(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=Dv(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];ih(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=Dv(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];ih(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];jh(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];nh(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=Dv(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];ih(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];nh(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=Dv(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];ih(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];nh(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;Vg(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=Dv(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];jh(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];mh(G,d,a+1248|0);Vg(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=Dv(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];kh(I,0,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];lh(J,0,a+1200|0,a+1184|0);Vg(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=Dv(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];lh(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];mh(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];lh(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=Dv(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(Dv(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;Vg(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=Dv(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];jh(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];mh(P,d,a+1056|0);Vg(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=Dv(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];lh(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];mh(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];lh(T,0,a+992|0,a+976|0);Vg(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=Dv(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];kh(V,0,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];lh(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=Dv(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(Dv(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=Dv(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];ih(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=Dv(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];ih(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];jh(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];nh(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;Vg($,0,1.0,0.0);Vg(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=Dv(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];lh(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];kh(ca,0,a+752|0,a+736|0);Vg(da,0,1.0,0.0);Vg(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=Dv(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];jh(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];kh(ga,0,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];jh(ha,0,a+656|0,a+640|0);Vg(ia,0,2.0,0.0);c[wb>>2]=1;Cb=Dv(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];kh(ja,0,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];lh(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];ih(la,0,a+560|0,a+544|0);Vg(ma,0,1.0,0.0);Vg(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=Dv(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];lh(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];kh(pa,0,a+496|0,a+480|0);Vg(qa,0,1.0,0.0);Vg(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=Dv(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];jh(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];kh(ta,0,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];jh(ua,0,a+400|0,a+384|0);Vg(va,0,2.0,0.0);c[zb>>2]=2;Cb=Dv(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];kh(wa,0,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];lh(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];ih(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];jh(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];nh(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;Vg(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=Dv(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];jh(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];mh(Ca,d,a+192|0);Vg(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=Dv(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];kh(Ea,0,a+176|0,a+160|0);Vg(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=Dv(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];lh(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];mh(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];jh(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];lh(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];ih(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];nh(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function Ui(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;sw(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(yw(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(yw(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(yw(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(yw(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(yw(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(yw(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(yw(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(yw(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(yw(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(yw(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(yw(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(yw(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(yw(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(yw(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(yw(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(yw(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(yw(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(yw(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(yw(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(yw(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(yw(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(yw(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(yw(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(yw(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(yw(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(yw(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(yw(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(yw(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(yw(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(yw(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(yw(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(yw(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(yw(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(yw(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(yw(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(yw(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(yw(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(yw(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(yw(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(yw(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(yw(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(yw(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(yw(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(yw(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(yw(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(yw(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(yw(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(yw(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(yw(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(yw(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(yw(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(yw(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(yw(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(yw(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(yw(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(yw(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(yw(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(yw(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(yw(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(yw(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(yw(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(yw(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(yw(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(yw(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(yw(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(yw(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(yw(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(yw(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(yw(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(yw(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(yw(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(yw(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(yw(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(yw(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(yw(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(yw(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(yw(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(yw(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(yw(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(yw(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(yw(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(yw(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(yw(Xf,1,se)|0)>>3];c[re>>2]=31;h[(yw(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(yw(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(yw(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(yw(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(yw(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(yw(Xf,1,me)|0)>>3];c[le>>2]=34;h[(yw(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(yw(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(yw(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(yw(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(yw(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(yw(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(yw(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(yw(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(yw(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(yw(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(yw(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(yw(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(yw(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(yw(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(yw(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(yw(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(yw(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(yw(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(yw(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(yw(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(yw(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(yw(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(yw(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(yw(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(yw(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(yw(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(yw(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(yw(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(yw(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(yw(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(yw(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(yw(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(yw(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(yw(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(yw(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(yw(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(yw(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(yw(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(yw(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(yw(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(yw(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(yw(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(yw(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(yw(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(yw(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(yw(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(yw(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(yw(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(yw(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(yw(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function Vi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function Wi(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;Ui(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function Xi(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;var j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;e=i;i=i+88|0;j=e;Ui(j,b,c,d);k=+h[j+16>>3];l=+h[j+24>>3];m=+h[j+32>>3];n=+h[j+72>>3];o=l*+h[j+48>>3];p=k*((o-m*l*+h[j+80>>3])/c);h[a>>3]=(1.0/+pd(+(c/(k*o*d)),1.0e-9)-p*d)*f-k*m*m*n*g;i=e;return}function Yi(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;sw(Oa,1,Na);c[Oa+0>>2]=c[4576+0>>2];c[Oa+4>>2]=c[4576+4>>2];c[Oa+8>>2]=c[4576+8>>2];c[Ma>>2]=2;Cv(Pa,16,1,Ma);c[La>>2]=1;Ma=Dv(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=Dv(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;Cv(Qa,16,1,Ja);c[Ia>>2]=1;Ja=Dv(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=Dv(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=Dv(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;Cv(Ua,16,1,Fa);if((bh(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +qw(4576,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((bh(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=Dv(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(Dv(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((bh(2,2,3)|0)!=0){Fa=2;do{Ti(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=Dv(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];Zi(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];_i(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((bh(Fa,2,3)|0)!=0)}if((bh(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +qw(4576,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((bh(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}Ti(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=Dv(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];Si(Ya,b,f+2512|0,f+2496|0);Ti(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=Dv(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];Si(_a,b,f+2480|0,f+2464|0);Ti($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];Zi(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];_i(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((bh(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +qw(4576,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((bh(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}Ti(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=Dv(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];Zi(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;Ti(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=Dv(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];$i(db,0,f+2352|0,f+2336|0);Ti(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=Dv(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];$i(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];aj(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];Zi(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=Dv(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(Dv(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;Ti(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=Dv(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];_i(ib,0,f+2240|0,f+2224|0);Ti(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=Dv(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];_i(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];aj(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];Zi(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=Dv(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(Dv(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;Ti(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=Dv(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];$i(nb,0,f+2128|0,f+2112|0);Ti(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=Dv(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];$i(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];aj(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];Zi(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=Dv(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(Dv(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;Ti(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=Dv(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];_i(sb,0,f+2016|0,f+2e3|0);Ti(tb,0,e/273.16,0.0);c[la>>2]=2;rb=Dv(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];_i(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];aj(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];Zi($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=Dv(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(Dv(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;Ti(wb,0,2.0,0.0);c[ia>>2]=1;$c=Dv(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];Zi(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=Dv(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];aj(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];Zi(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=Dv(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(Dv(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;Ti(zb,0,2.0,0.0);c[ea>>2]=2;ad=Dv(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];Zi(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=Dv(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];aj(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];Zi(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=Dv(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(Dv(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;Ti(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=Dv(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];Si(cd,b,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=Dv(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(Dv(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;Ti(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=Dv(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];Si(dd,b,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=Dv(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function Zi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];Ti(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function _i(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Ti(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function $i(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Ti(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function aj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];ah(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[22536]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=7728;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];De[d&31](b,f,4848,g);}Ti(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function bj(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function cj(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;g=i;i=i+88|0;j=g;Ui(j,b,c,d);k=+h[j+16>>3];l=+h[j+24>>3];m=+h[j+56>>3];n=l*+h[j+48>>3];o=k*((n- +h[j+32>>3]*l*+h[j+80>>3])/c);p=c/(k*n*d);h[a>>3]=-(p*p*(o*f+k*l*l*m*+Yw(c,-2)*d*e));i=g;return}function dj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;Yi(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+Yw(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function ej(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function fj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;sw(g,1,f);f=g;g=4648;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;sw(j,1,e);e=j;j=4664;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((bh(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+qw(4648,j);t=s+d*+W(+k,+(+qw(4664,j)));j=r+1|0;if((bh(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function gj(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;Og(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function hj(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function ij(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;dj(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));hj(b,0,0.0,0.0,g);i=f;return}function jj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;c[g>>2]=3;sw(j,1,g);g=j;j=4648;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[f>>2]=3;sw(k,1,f);f=k;k=4664;c[f+0>>2]=c[k+0>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];l=d/273.16;if((bh(1,1,3)|0)==0){m=0.0;n=0.0;o=m/l;p=+ca(+o);q=l*n;r=m*.003660858105139845;s=q-r;t=+Yw(l,-2);u=p*e;v=t*u;w=s*v;x=w*611.657;y=a;z=y;h[z>>3]=x;i=b;return}else{A=1;B=0.0;C=0.0}while(1){k=A+ -1|0;d=+qw(4648,k);D=B+d*+W(+l,+(+qw(4664,k)));d=+qw(4648,k);E=+qw(4664,k);F=C+d*E*+W(+l,+(+qw(4664,k)+-1.0))*.003660858105139845;k=A+1|0;if((bh(k,1,3)|0)==0){m=D;n=F;break}else{C=F;B=D;A=k}}o=m/l;p=+ca(+o);q=l*n;r=m*.003660858105139845;s=q-r;t=+Yw(l,-2);u=p*e;v=t*u;w=s*v;x=w*611.657;y=a;z=y;h[z>>3]=x;i=b;return}function kj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h[a>>3]=+h[e+32>>3]*g+(1.0/+h[e+48>>3]- +h[e+8>>3]*+h[e+80>>3])*f;i=i;return}function lj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(yw(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[22536]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=7728;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4936,m);}c[l>>2]=1;h[a>>3]=+h[(yw(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function mj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;d=+h[e+48>>3];h[a>>3]=-(d*d*(+h[e+88>>3]*f+ +h[e+80>>3]*g));i=i;return}function nj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(yw(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(yw(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(yw(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(yw(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];xw(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];lj(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[22536]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=7728;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];De[l&31](b,j,5776,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function oj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(yw(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[22536]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=7728;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4776,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(yw(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function pj(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0;m=i;i=i+80|0;n=m;o=m+24|0;p=m+48|0;q=m+72|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+16|0;c[K>>2]=4;sw(L,1,K);c[J>>2]=3;M=+h[(yw(f,1,J)|0)>>3];if(!(M>=0.0)){J=c[22536]|0;K=I;h[k>>3]=M;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=J;J=p;N=7728;c[J+0>>2]=c[N+0>>2];c[J+4>>2]=c[N+4>>2];c[J+8>>2]=c[N+8>>2];c[J+12>>2]=c[N+12>>2];c[J+16>>2]=c[N+16>>2];c[J+20>>2]=c[N+20>>2];De[K&31](b,p,4936,I);}O=+ca(+(-30283.3/e));P=+W(+(d/101325.0),-.5);Q=O*P;R=+V(+M)*Q*1075.5;c[H>>2]=1;h[(yw(L,1,H)|0)>>3]=R;c[G>>2]=1;R=+h[(yw(f,1,G)|0)>>3];c[F>>2]=3;M=R*Q*+W(+(+h[(yw(f,1,F)|0)>>3]),-1.5)*-537.75;c[E>>2]=2;h[(yw(L,1,E)|0)>>3]=M;c[D>>2]=3;M=+h[(yw(f,1,D)|0)>>3];if(!(M>=0.0)){D=c[22536]|0;E=C;h[k>>3]=M;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=o;F=7728;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];De[E&31](b,o,4936,C);}c[B>>2]=1;Q=+h[(yw(f,1,B)|0)>>3]*+W(+d,-1.5)*(O/+V(+M))*-171174.3649259798;c[A>>2]=3;h[(yw(L,1,A)|0)>>3]=Q;c[z>>2]=3;Q=+h[(yw(f,1,z)|0)>>3];if(!(Q>=0.0)){z=c[22536]|0;A=y;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z;z=n;B=7728;c[z+0>>2]=c[B+0>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];c[z+12>>2]=c[B+12>>2];c[z+16>>2]=c[B+16>>2];c[z+20>>2]=c[B+20>>2];De[A&31](b,n,4936,y);}c[x>>2]=1;M=+h[(yw(f,1,x)|0)>>3]*P*(O/(e*e*+V(+Q)))*32569689.15;c[w>>2]=4;h[(yw(L,1,w)|0)>>3]=M;c[v>>2]=1;M=+h[(yw(L,1,v)|0)>>3];c[u>>2]=1;Q=M*+h[(yw(l,1,u)|0)>>3];c[t>>2]=2;M=+h[(yw(L,1,t)|0)>>3];c[s>>2]=3;e=M*+h[(yw(l,1,s)|0)>>3];c[r>>2]=3;M=+h[(yw(L,1,r)|0)>>3]*g;c[q>>2]=4;h[a>>3]=Q+(e+(M+ +h[(yw(L,1,q)|0)>>3]*j));i=m;return}function qj(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0.0;m=i;i=i+80|0;n=m;o=m+24|0;p=m+48|0;q=m+72|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+16|0;c[L>>2]=4;sw(M,1,L);N=+ca(+(-19526.8/e));c[K>>2]=1;O=+h[(yw(f,1,K)|0)>>3];if(!(O>=0.0)){K=c[22536]|0;L=J;h[k>>3]=O;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K;K=p;P=7728;c[K+0>>2]=c[P+0>>2];c[K+4>>2]=c[P+4>>2];c[K+8>>2]=c[P+8>>2];c[K+12>>2]=c[P+12>>2];c[K+16>>2]=c[P+16>>2];c[K+20>>2]=c[P+20>>2];De[L&31](b,p,4776,J);}c[I>>2]=3;Q=+W(+(+h[(yw(f,1,I)|0)>>3]/d),.25)*(N/+V(+O))*1480.390925128686;c[H>>2]=1;h[(yw(M,1,H)|0)>>3]=Q;c[G>>2]=1;Q=+h[(yw(f,1,G)|0)>>3];if(!(Q>=0.0)){G=c[22536]|0;H=F;h[k>>3]=Q;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=o;I=7728;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];De[H&31](b,o,4776,F);}O=+V(+Q);c[E>>2]=3;Q=O*+W(+(+h[(yw(f,1,E)|0)>>3]),-.75)*N*+W(+(d/101325.0),-.25)*41.4875;c[D>>2]=2;h[(yw(M,1,D)|0)>>3]=Q;c[C>>2]=1;Q=+h[(yw(f,1,C)|0)>>3];if(!(Q>=0.0)){C=c[22536]|0;D=B;h[k>>3]=Q;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C;C=n;E=7728;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];De[D&31](b,n,4776,B);}O=+V(+Q);c[A>>2]=3;Q=O*+W(+(+h[(yw(f,1,A)|0)>>3]),.25)*N*+W(+d,-1.25)*-740.1954625643428;c[z>>2]=3;h[(yw(M,1,z)|0)>>3]=Q;c[y>>2]=1;Q=+h[(yw(f,1,y)|0)>>3];c[x>>2]=3;O=Q*+W(+(+h[(yw(f,1,x)|0)>>3]*d),-.25)*(N/(e*e))*-57814595.03360564;c[w>>2]=4;h[(yw(M,1,w)|0)>>3]=O;c[v>>2]=1;O=+h[(yw(M,1,v)|0)>>3];c[u>>2]=1;e=O*+h[(yw(l,1,u)|0)>>3];c[t>>2]=2;O=+h[(yw(M,1,t)|0)>>3];c[s>>2]=3;N=O*+h[(yw(l,1,s)|0)>>3];c[r>>2]=3;O=+h[(yw(M,1,r)|0)>>3]*g;c[q>>2]=4;h[a>>3]=e+(N+(O+ +h[(yw(M,1,q)|0)>>3]*j));i=m;return}function rj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(yw(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[22536]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=7728;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];De[f&31](b,j,4936,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function sj(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0,bb=0;m=i;i=i+160|0;n=m;o=m+24|0;p=m+40|0;q=m+64|0;r=m+80|0;s=m+104|0;t=m+120|0;u=m+136|0;v=m+152|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+24|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+24|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+24|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+24|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;c[ea>>2]=3;sw(fa,1,ea);c[da>>2]=1;pa=+h[(yw(f,1,da)|0)>>3];c[ba>>2]=2;qa=+h[(yw(f,1,ba)|0)>>3];c[aa>>2]=3;ra=+h[(yw(f,1,aa)|0)>>3];c[$>>2]=4;sa=+h[(yw(f,1,$)|0)>>3];$=_;h[k>>3]=qa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=_+8|0;h[k>>3]=ra;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=_+16|0;h[k>>3]=sa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];xw(ga,4,pa,_);c[Z>>2]=1;pa=+h[(yw(l,1,Z)|0)>>3];c[Y>>2]=2;sa=+h[(yw(l,1,Y)|0)>>3];c[X>>2]=3;ra=+h[(yw(l,1,X)|0)>>3];c[U>>2]=4;qa=+h[(yw(l,1,U)|0)>>3];U=T;h[k>>3]=sa;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];U=T+8|0;h[k>>3]=ra;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];U=T+16|0;h[k>>3]=qa;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];xw(ha,4,pa,T);T=u;U=ga;c[T+0>>2]=c[U+0>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];U=t;T=ha;c[U+0>>2]=c[T+0>>2];c[U+4>>2]=c[T+4>>2];c[U+8>>2]=c[T+8>>2];pj(la,b,d,e,u,g,j,t);pa=+h[la>>3];qa=+ca(+(-27488.0/e));c[S>>2]=1;ra=+h[(yw(f,1,S)|0)>>3];c[R>>2]=2;sa=+h[(yw(f,1,R)|0)>>3];c[Q>>2]=3;ta=+h[(yw(f,1,Q)|0)>>3];c[P>>2]=4;ua=+h[(yw(f,1,P)|0)>>3];P=O;h[k>>3]=sa;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=ta;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+16|0;h[k>>3]=ua;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];xw(ia,4,ra,O);O=s;P=ia;c[O+0>>2]=c[P+0>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];lj(ma,b,d,e,s);ra=+h[ma>>3];if(!(ra>=0.0)){ma=c[22536]|0;s=N;h[k>>3]=ra;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=ma;ma=r;P=7728;c[ma+0>>2]=c[P+0>>2];c[ma+4>>2]=c[P+4>>2];c[ma+8>>2]=c[P+8>>2];c[ma+12>>2]=c[P+12>>2];c[ma+16>>2]=c[P+16>>2];c[ma+20>>2]=c[P+20>>2];De[s&31](b,r,5776,N);}ua=+W(+(d/101325.0),-.5);ta=pa*ua*(qa/+V(+ra))*745.875;c[M>>2]=1;h[(yw(fa,1,M)|0)>>3]=ta;c[L>>2]=1;ta=+h[(yw(f,1,L)|0)>>3];c[K>>2]=2;ra=+h[(yw(f,1,K)|0)>>3];c[J>>2]=3;pa=+h[(yw(f,1,J)|0)>>3];c[I>>2]=4;sa=+h[(yw(f,1,I)|0)>>3];I=H;h[k>>3]=ra;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];I=H+8|0;h[k>>3]=pa;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];I=H+16|0;h[k>>3]=sa;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];xw(ja,4,ta,H);H=q;I=ja;c[H+0>>2]=c[I+0>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];lj(na,b,d,e,q);ta=+h[na>>3];if(!(ta>=0.0)){na=c[22536]|0;q=G;h[k>>3]=ta;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=na;na=p;I=7728;c[na+0>>2]=c[I+0>>2];c[na+4>>2]=c[I+4>>2];c[na+8>>2]=c[I+8>>2];c[na+12>>2]=c[I+12>>2];c[na+16>>2]=c[I+16>>2];c[na+20>>2]=c[I+20>>2];De[q&31](b,p,5776,G);}sa=+V(+ta)*qa*+W(+d,-1.5)*-237423.8576274573;c[F>>2]=2;h[(yw(fa,1,F)|0)>>3]=sa;c[E>>2]=1;sa=+h[(yw(f,1,E)|0)>>3];c[D>>2]=2;ta=+h[(yw(f,1,D)|0)>>3];c[C>>2]=3;pa=+h[(yw(f,1,C)|0)>>3];c[B>>2]=4;ra=+h[(yw(f,1,B)|0)>>3];B=A;h[k>>3]=ta;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=pa;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+16|0;h[k>>3]=ra;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];xw(ka,4,sa,A);A=o;B=ka;c[A+0>>2]=c[B+0>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];lj(oa,b,d,e,o);d=+h[oa>>3];if(d>=0.0){va=+V(+d);wa=e*e;xa=qa/wa;ya=ua*xa;za=va*ya;Aa=za*-41005224.0;Ba=y;Ca=Ba;c[Ca>>2]=3;Da=32;Ea=Da;Fa=yw(fa,1,y)|0;h[Fa>>3]=Aa;Ga=x;Ha=Ga;c[Ha>>2]=1;Ia=32;Ja=Ia;Ka=yw(fa,1,x)|0;La=+h[Ka>>3];Ma=w;Na=Ma;c[Na>>2]=2;Oa=32;Pa=Oa;Qa=yw(fa,1,w)|0;Ra=+h[Qa>>3];Sa=Ra*g;Ta=v;Ua=Ta;c[Ua>>2]=3;Va=32;Wa=Va;Xa=yw(fa,1,v)|0;Ya=+h[Xa>>3];Za=Ya*j;_a=Sa+Za;$a=La+_a;ab=a;bb=ab;h[bb>>3]=$a;i=m;return}oa=c[22536]|0;o=z;h[k>>3]=d;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=oa;oa=n;B=7728;c[oa+0>>2]=c[B+0>>2];c[oa+4>>2]=c[B+4>>2];c[oa+8>>2]=c[B+8>>2];c[oa+12>>2]=c[B+12>>2];c[oa+16>>2]=c[B+16>>2];c[oa+20>>2]=c[B+20>>2];De[o&31](b,n,5776,z);va=+V(+d);wa=e*e;xa=qa/wa;ya=ua*xa;za=va*ya;Aa=za*-41005224.0;Ba=y;Ca=Ba;c[Ca>>2]=3;Da=32;Ea=Da;Fa=yw(fa,1,y)|0;h[Fa>>3]=Aa;Ga=x;Ha=Ga;c[Ha>>2]=1;Ia=32;Ja=Ia;Ka=yw(fa,1,x)|0;La=+h[Ka>>3];Ma=w;Na=Ma;c[Na>>2]=2;Oa=32;Pa=Oa;Qa=yw(fa,1,w)|0;Ra=+h[Qa>>3];Sa=Ra*g;Ta=v;Ua=Ta;c[Ua>>2]=3;Va=32;Wa=Va;Xa=yw(fa,1,v)|0;Ya=+h[Xa>>3];Za=Ya*j;_a=Sa+Za;$a=La+_a;ab=a;bb=ab;h[bb>>3]=$a;i=m;return}function tj(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0;l=i;i=i+80|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+16|0;c[C>>2]=3;sw(D,1,C);E=+ca(+(-30807.8/e));c[B>>2]=3;F=+h[(yw(f,1,B)|0)>>3];if(!(F>=0.0)){B=c[22536]|0;C=A;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B;B=o;G=7728;c[B+0>>2]=c[G+0>>2];c[B+4>>2]=c[G+4>>2];c[B+8>>2]=c[G+8>>2];c[B+12>>2]=c[G+12>>2];c[B+16>>2]=c[G+16>>2];c[B+20>>2]=c[G+20>>2];De[C&31](b,o,4936,A);}H=+W(+(d/101325.0),-.5);I=H*(E/+V(+F))*1617.67;c[z>>2]=1;h[(yw(D,1,z)|0)>>3]=I;c[y>>2]=3;I=+h[(yw(f,1,y)|0)>>3];if(!(I>=0.0)){y=c[22536]|0;z=x;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y;y=n;A=7728;c[y+0>>2]=c[A+0>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];c[y+12>>2]=c[A+12>>2];c[y+16>>2]=c[A+16>>2];c[y+20>>2]=c[A+20>>2];De[z&31](b,n,4936,x);}F=+V(+I)*E*+W(+d,-1.5)*-514930.0509712873;c[w>>2]=2;h[(yw(D,1,w)|0)>>3]=F;c[v>>2]=3;F=+h[(yw(f,1,v)|0)>>3];if(F>=0.0){J=+V(+F);K=e*e;L=E/K;M=H*L;N=J*M;O=N*-99673707.652;P=t;Q=P;c[Q>>2]=3;R=32;S=R;T=yw(D,1,t)|0;h[T>>3]=O;U=s;X=U;c[X>>2]=1;Y=32;Z=Y;_=yw(D,1,s)|0;$=+h[_>>3];aa=r;ba=aa;c[ba>>2]=3;da=32;ea=da;fa=yw(f,1,r)|0;ga=+h[fa>>3];ha=$*ga;ia=q;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=yw(D,1,q)|0;na=+h[ma>>3];oa=na*g;pa=p;qa=pa;c[qa>>2]=3;ra=32;sa=ra;ta=yw(D,1,p)|0;ua=+h[ta>>3];va=ua*j;wa=oa+va;xa=ha+wa;ya=a;za=ya;h[za>>3]=xa;i=l;return}v=c[22536]|0;w=u;h[k>>3]=F;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=v;v=m;x=7728;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];De[w&31](b,m,4936,u);J=+V(+F);K=e*e;L=E/K;M=H*L;N=J*M;O=N*-99673707.652;P=t;Q=P;c[Q>>2]=3;R=32;S=R;T=yw(D,1,t)|0;h[T>>3]=O;U=s;X=U;c[X>>2]=1;Y=32;Z=Y;_=yw(D,1,s)|0;$=+h[_>>3];aa=r;ba=aa;c[ba>>2]=3;da=32;ea=da;fa=yw(f,1,r)|0;ga=+h[fa>>3];ha=$*ga;ia=q;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=yw(D,1,q)|0;na=+h[ma>>3];oa=na*g;pa=p;qa=pa;c[qa>>2]=3;ra=32;sa=ra;ta=yw(D,1,p)|0;ua=+h[ta>>3];va=ua*j;wa=oa+va;xa=ha+wa;ya=a;za=ya;h[za>>3]=xa;i=l;return}function uj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function vj(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function wj(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function xj(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function yj(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0;l=i;i=i+80|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+16|0;c[I>>2]=3;sw(J,1,I);g=+ca(+(-10973.6/e));c[H>>2]=2;d=+h[(yw(f,1,H)|0)>>3];c[G>>2]=3;K=d*+h[(yw(f,1,G)|0)>>3];if(!(K>=0.0)){G=c[22536]|0;H=F;h[k>>3]=K;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=o;I=7728;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];De[H&31](b,o,5232,F);}c[E>>2]=3;d=+h[(yw(f,1,E)|0)>>3]*(g/+V(+K))*2.2771;c[D>>2]=1;h[(yw(J,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(yw(f,1,C)|0)>>3];c[B>>2]=3;K=d*+h[(yw(f,1,B)|0)>>3];if(!(K>=0.0)){B=c[22536]|0;C=A;h[k>>3]=K;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B;B=n;D=7728;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[B+12>>2]=c[D+12>>2];c[B+16>>2]=c[D+16>>2];c[B+20>>2]=c[D+20>>2];De[C&31](b,n,5232,A);}c[z>>2]=2;d=+h[(yw(f,1,z)|0)>>3]*(g/+V(+K))*2.2771;c[y>>2]=2;h[(yw(J,1,y)|0)>>3]=d;c[x>>2]=2;d=+h[(yw(f,1,x)|0)>>3];c[w>>2]=3;K=d*+h[(yw(f,1,w)|0)>>3];if(K>=0.0){L=+V(+K);M=e*e;N=g/M;O=L*N;P=O*-49975.96912;Q=u;R=Q;c[R>>2]=3;S=32;T=S;U=yw(J,1,u)|0;h[U>>3]=P;W=t;X=W;c[X>>2]=1;Y=32;Z=Y;_=yw(J,1,t)|0;$=+h[_>>3];aa=s;ba=aa;c[ba>>2]=2;da=32;ea=da;fa=yw(f,1,s)|0;ga=+h[fa>>3];ha=$*ga;ia=r;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=yw(J,1,r)|0;na=+h[ma>>3];oa=q;pa=oa;c[pa>>2]=3;qa=32;ra=qa;sa=yw(f,1,q)|0;ta=+h[sa>>3];ua=na*ta;va=p;wa=va;c[wa>>2]=3;xa=32;ya=xa;za=yw(J,1,p)|0;Aa=+h[za>>3];Ba=Aa*j;Ca=ua+Ba;Da=ha+Ca;Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}w=c[22536]|0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=w;w=m;y=7728;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];De[x&31](b,m,5232,v);L=+V(+K);M=e*e;N=g/M;O=L*N;P=O*-49975.96912;Q=u;R=Q;c[R>>2]=3;S=32;T=S;U=yw(J,1,u)|0;h[U>>3]=P;W=t;X=W;c[X>>2]=1;Y=32;Z=Y;_=yw(J,1,t)|0;$=+h[_>>3];aa=s;ba=aa;c[ba>>2]=2;da=32;ea=da;fa=yw(f,1,s)|0;ga=+h[fa>>3];ha=$*ga;ia=r;ja=ia;c[ja>>2]=2;ka=32;la=ka;ma=yw(J,1,r)|0;na=+h[ma>>3];oa=q;pa=oa;c[pa>>2]=3;qa=32;ra=qa;sa=yw(f,1,q)|0;ta=+h[sa>>3];ua=na*ta;va=p;wa=va;c[wa>>2]=3;xa=32;ya=xa;za=yw(J,1,p)|0;Aa=+h[za>>3];Ba=Aa*j;Ca=ua+Ba;Da=ha+Ca;Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}function zj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-303.0e3/e+-14554.0e6/(e*c))*d;i=i;return}function Aj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-57200.0/e+-6272.0e6/(e*c))*d;i=i;return}function Bj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;sw(n,1,m);m=n;n=4680;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[22536]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=7728;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];De[m&31](b,g,5320,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[22536]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=7728;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];De[g&31](b,f,5400,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function Cj(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function Dj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-393.0e3/e+-11652.0e6/(e*c))*d;i=i;return}function Ej(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function Fj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-15.0e4/e+-15318.0e6/(e*c))*d;i=i;return}function Gj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0;e=c*c;h[a>>3]=(-16200.0/e+-1988.0e6/(e*c))*d;i=i;return}function Hj(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;sw(l,1,j);j=l;l=4680;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+od(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[22536]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=7728;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];De[j&31](b,f,4696,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function _omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(yw(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(yw(l,1,pb)|0)>>3];c[qb>>2]=55;h[(yw(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[22536]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[7728+0>>2];c[a+4>>2]=c[7728+4>>2];c[a+8>>2]=c[7728+8>>2];c[a+12>>2]=c[7728+12>>2];c[a+16>>2]=c[7728+16>>2];c[a+20>>2]=c[7728+20>>2];De[td&31](d,a,4592,rb);}c[sb>>2]=9;sd=+h[(yw(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(yw(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(yw(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(yw(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(yw(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(yw(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(yw(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(yw(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(yw(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(yw(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(yw(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(yw(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(yw(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(yw(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(yw(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(yw(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(yw(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(yw(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(yw(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(yw(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(yw(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(yw(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(yw(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(yw(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(yw(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(yw(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(yw(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(yw(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(yw(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(yw(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(yw(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(yw(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(yw(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(yw(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(yw(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(yw(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(yw(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(yw(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(yw(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(yw(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(yw(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(yw(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(yw(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(yw(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(yw(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(yw(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(yw(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(yw(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(yw(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(yw(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(yw(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(yw(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(yw(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(yw(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(yw(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(yw(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(yw(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(yw(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(yw(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(yw(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(yw(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(yw(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(yw(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(yw(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(yw(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(yw(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(yw(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(yw(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(yw(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(yw(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(yw(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(yw(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(yw(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(yw(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(yw(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(yw(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(yw(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(yw(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(yw(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(yw(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(yw(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(yw(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(yw(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(yw(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(yw(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(yw(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(yw(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(yw(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(yw(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(yw(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(yw(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(yw(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(yw(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(yw(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(yw(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(yw(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(yw(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(yw(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(yw(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(yw(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(yw(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(yw(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(yw(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(yw(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(yw(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(yw(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(yw(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(yw(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(yw(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(yw(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(yw(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(yw(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(yw(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(yw(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(yw(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(yw(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(yw(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(yw(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(yw(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(yw(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(yw(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(yw(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(yw(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(yw(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(yw(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(yw(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(yw(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(yw(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(yw(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(yw(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(yw(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(yw(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(yw(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(yw(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(yw(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(yw(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(yw(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(yw(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(yw(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(yw(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(yw(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(yw(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(yw(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(yw(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(yw(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(yw(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(yw(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(yw(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(yw(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(yw(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(yw(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(yw(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(yw(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(yw(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(yw(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(yw(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(yw(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(yw(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(yw(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(yw(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(yw(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(yw(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(yw(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(yw(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(yw(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(yw(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(yw(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(yw(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(yw(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(yw(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(yw(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(yw(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(yw(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(yw(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(yw(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(yw(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(yw(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(yw(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(yw(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(yw(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(yw(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(yw(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(yw(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(yw(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(yw(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(yw(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(yw(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(yw(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(yw(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(yw(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(yw(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(yw(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(yw(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(yw(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(yw(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(yw(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(yw(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(yw(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(yw(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(yw(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(yw(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(yw(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(yw(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(yw(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(yw(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(yw(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(yw(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(yw(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(yw(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(yw(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(yw(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(yw(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(yw(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(yw(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(yw(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(yw(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(yw(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}function _omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(Dv(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=Dv(x,16,1,Ua)|0;c[Va>>2]=2;Db=Dv(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];_i(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=Dv(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];$i(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=Dv(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];$i(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=Dv(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(Dv(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=Dv(x,16,1,_a)|0;c[$a>>2]=4;Cb=Dv(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];_i(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=Dv(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];$i(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=Dv(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];$i(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=Dv(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(Dv(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=Dv(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];Zi(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=Dv(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];Zi(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];_i(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];bj(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=Dv(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];Zi(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];bj(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=Dv(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];Zi(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];bj(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;Ti(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=Dv(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];_i(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];aj(G,d,a+1248|0);Ti(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=Dv(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];Si(I,d,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];$i(J,0,a+1200|0,a+1184|0);Ti(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=Dv(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];$i(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];aj(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];$i(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=Dv(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(Dv(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;Ti(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=Dv(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];_i(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];aj(P,d,a+1056|0);Ti(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=Dv(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];$i(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];aj(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];$i(T,0,a+992|0,a+976|0);Ti(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=Dv(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];Si(V,d,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];$i(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=Dv(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(Dv(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=Dv(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];Zi(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=Dv(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];Zi(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];_i(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];bj(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;Ti($,0,1.0,0.0);Ti(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=Dv(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];$i(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];Si(ca,d,a+752|0,a+736|0);Ti(da,0,1.0,0.0);Ti(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=Dv(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];_i(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];Si(ga,d,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];_i(ha,0,a+656|0,a+640|0);Ti(ia,0,2.0,0.0);c[wb>>2]=1;Cb=Dv(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];Si(ja,d,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];$i(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];Zi(la,0,a+560|0,a+544|0);Ti(ma,0,1.0,0.0);Ti(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=Dv(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];$i(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];Si(pa,d,a+496|0,a+480|0);Ti(qa,0,1.0,0.0);Ti(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=Dv(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];_i(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];Si(ta,d,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];_i(ua,0,a+400|0,a+384|0);Ti(va,0,2.0,0.0);c[zb>>2]=2;Cb=Dv(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];Si(wa,d,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];$i(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];Zi(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];_i(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];bj(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;Ti(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=Dv(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];_i(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];aj(Ca,d,a+192|0);Ti(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=Dv(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];Si(Ea,d,a+176|0,a+160|0);Ti(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=Dv(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];$i(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];aj(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];_i(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];$i(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];Zi(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];bj(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function Js(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 3:{k=Zs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=ts(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=bt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=ts(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Ks(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=ts(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=ts(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Ls(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=ts(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Ms(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=ts(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 21:{n=29;break a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Zs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=ts(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ns(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=ts(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Zs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=_s(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=ts(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Os(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=ts(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=ts(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Ps(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Qs(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=ts(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Rs(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=ts(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Ss(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=ts(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=ts(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Ts(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Hr(c)|0;k=j;i=b;return k|0}function Us(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){h=a[e+1|0]|0}else{h=-1}if((h|0)==103){f=62;g=f;i=b;return g|0}else if((h|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Vs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=ts(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=ts(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Ws(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=ts(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Xs(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Ys(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Zs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=$s(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=ts(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function _s(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=ts(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function $s(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=at(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=ts(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function at(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=ts(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=ts(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function bt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=ts(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=dt(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=ct(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=ft(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=et(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=ts(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=ts(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 24:case 22:{break};case 6:{o=62;break b;break};case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 5:{o=39;break b;break};case 6:{o=42;break b;break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 11:{o=90;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=ts(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{o=78;break d;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 17:{break c;break};case 11:{o=90;break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=gt(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function ct(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=ts(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function dt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[34720+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function et(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=ts(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=ts(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 7:{p=34;break b;break};case 5:{p=28;break b;break};case 15:{p=62;break b;break};case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((ht(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=ts(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((ht(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function ft(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=ts(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 23:{b=b+2|0;continue b;break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};case 11:{n=48;break b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=ts(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function gt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=ts(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=ts(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 29:{if((c[32400+((d[32144+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 5:{l=30;break a;break};case 24:case 22:{break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[32400+((d[33680+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=ts(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=ts(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=ts(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=Zs(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=ts(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=ts(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 10:case 9:case 21:{break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 24:case 22:{break d;break};case 7:{l=103;break a;break};case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[32400+((d[32144+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function ht(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function it(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=ts(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=ts(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function jt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=ct(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=ts(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=ts(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function kt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=ts(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function lt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((se[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((se[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((se[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((se[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=Wt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Rt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=Lt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((se[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((se[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 12:{k=Vt(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{m=18;b=b+1|0;break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 13:{k=Vt(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=Xt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 29:{n=91;break b;break};case 6:{if((e-b|0)<3){n=99;break b}p=b;if((se[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=p+3|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}q=b;if((se[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=q+2|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}r=b;if((se[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=r+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{m=19;continue b}}break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 15:{n=116;break b;break};case 5:{if((e-b|0)<2){n=72;break b}s=b;if((se[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=s+2|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}t=b;if((se[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=t+4|0;continue b;break};case 6:{if((e-b|0)<3){n=77;break b}u=b;if((se[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=u+3|0;continue b;break};case 29:{n=69;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 34:{n=110;break b;break};case 33:{n=113;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==110){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function mt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=Kt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 2:{k=Ot(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((se[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 6:{if((e-b|0)<3){n=45;break b}if((se[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((se[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function nt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((se[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((se[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((se[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ot(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((se[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((se[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 2:{n=b+1|0;b=n;if((n|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}n=b+1|0;b=n;if((n|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((se[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};case 4:{n=b+1|0;b=n;if((n|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}n=b+1|0;b=n;if((n|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function pt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 2:{m=12;break a;break};case 10:{m=13;break a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 21:{m=23;break a;break};case 9:{m=16;break a;break};case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Kt(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function qt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 30:{m=12;break a;break};case 9:{m=18;break a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};case 10:{m=15;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Kt(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Lt(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function rt(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 5:{break};case 6:{h=5;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){h=12;break a}else{continue a}break};case 7:{j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=4;break a}else{h=5}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function st(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function tt(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{break a}}}i=c;return a-b|0}function ut(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function vt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function wt(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Hr(c)|0;g=f;i=b;return g|0}function xt(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function yt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 6:{a=a+3|0;break};case 5:{a=a+2|0;break};case 7:{a=a+4|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function zt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function At(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Bt(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}o=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;o=o-65536|0;b[j>>1]=o>>>10|55296;b[j+2>>1]=o&1023|56320;j=j+4|0;m=m+4|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Ct(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[32400+(((d[33680+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Dt(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[32400+(((d[33680+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Et(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Ft(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[32400+(((d[32144+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Gt(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[32400+(((d[32144+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Ht(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function It(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Jt(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Kt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 19:{j=Mt(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=38;break b}m=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Lt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=38;break b}m=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Mt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Nt(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Nt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Ot(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=Rt(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=Qt(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=Pt(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 17:{k=St(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{m=73;break b;break};case 17:{break b;break};case 7:{if((e-b|0)<4){m=46;break b}n=b;if((se[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((se[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 11:{m=97;break b;break};case 29:{m=33;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=55;break b;break};case 7:{if((e-b|0)<4){m=68;break b}p=b;if((se[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}q=b;if((se[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}r=b;if((se[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=r+3|0;continue b;break};default:{m=72;break b}}break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((se[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{m=83;break d;break};case 17:{break c;break};case 7:{m=88;break d;break};case 11:{m=97;break c;break};case 24:case 22:{m=77;break d;break};case 5:{m=78;break d;break};case 10:case 9:case 21:{break};case 29:{m=76;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Tt(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Pt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=13;break b}n=b;if((se[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}o=b;if((se[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=o+4|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((se[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Qt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[35096+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Rt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=37;break b}p=b;if((se[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 15:{o=68;break b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((se[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 29:{o=24;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((se[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Ut(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=52;break c}s=b;if((se[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=s+3|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}t=b;if((se[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=t+2|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 7:{if((e-b|0)<4){o=57;break c}u=b;if((se[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=u+4|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Ut(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function St(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 23:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 11:{l=49;break b;break};case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Tt(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}m=b;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=48;break a}}break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}m=(se[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!m){l=31;break a}c[j>>2]=n+2;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}m=(se[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!m){l=41;break a}c[j>>2]=o+4;continue a;break};case 29:{l=26;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}m=(se[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!m){l=36;break a}c[j>>2]=p+3;continue a;break};default:{l=43;break a}}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}m=(se[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!m){l=14;break a}c[j>>2]=q+3;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}m=(se[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!m){l=9;break a}c[j>>2]=r+2;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}m=(se[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!m){l=19;break a}c[j>>2]=s+4;continue a;break};case 14:{break};case 29:{l=4;break a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}m=t;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}m=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((m|0)==(t|0)){break}switch(m|0){case 2:{l=80;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}m=(se[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(m){l=68;break a}c[j>>2]=u+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}m=(se[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(m){l=63;break a}c[j>>2]=v+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}m=(se[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(m){l=73;break a}c[j>>2]=w+4;continue c;break};case 3:{x=Kt(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 29:{l=89;break a;break};case 5:{l=91;break d;break};case 10:case 9:case 21:{break};case 7:{l=101;break d;break};case 6:{l=96;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}m=(se[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!m){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}m=(se[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!m){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}m=(se[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!m){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Ut(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Vt(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((se[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((se[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((se[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function Wt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{l=10;break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=Pt(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function Xt(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function Yt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function Zt(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function _t(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}



function VO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=bd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Be[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=bd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((md(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function WO(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);i=b;return}function XO(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);g_(a);i=b;return}function YO(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=FW(d,115136)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(de[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function ZO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=te[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function _O(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((se[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function $O(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Be[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function aP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=112344;j=b+4|0;BW(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=111696;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;CW(g,j);j=FW(g,115136)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=de[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(de[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){NV(111536)}else{DW(g);i=f;return}}function bP(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);i=b;return}function cP(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);g_(a);i=b;return}function dP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=FW(d,115136)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=de[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(de[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){NV(111536)}else{i=e;return}}function eP(a){a=a|0;var b=0,c=0;b=i;c=hP(a,0)|0;i=b;return c|0}function fP(a){a=a|0;var b=0,c=0;b=i;c=hP(a,1)|0;i=b;return c|0}function gP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Be[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((md(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function hP(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=bd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Be[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=bd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((md(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function iP(){var a=0;a=i;GO(0);Ud(218,110960,q|0)|0;i=a;return}function jP(a){a=a|0;i=i;return}function kP(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function lP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}ae[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function mP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=111840;e=C_(b|0)|0;f=f_(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;E_(g|0,b|0,e+1|0)|0;i=d;return}function nP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=111840;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}h_((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}function oP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=111840;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}h_((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function pP(a){a=a|0;i=i;return c[a+4>>2]|0}function qP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=111864;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=C_(f|0)|0;g=f_(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;E_(h|0,f|0,d+1|0)|0;i=e;return}function rP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=111864;e=C_(b|0)|0;f=f_(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;E_(g|0,b|0,e+1|0)|0;i=d;return}function sP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=111864;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}h_((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}function tP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=111864;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}h_((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function uP(a){a=a|0;i=i;return c[a+4>>2]|0}function vP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=111840;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}h_((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}function wP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=111840;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}h_((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;g_(j);i=b;return}function xP(a){a=a|0;i=i;return}function yP(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function zP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;ze[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function AP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function BP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Rd(e|0)|0;e=C_(f|0)|0;if(e>>>0>4294967279){HP(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;E_(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=e_(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;E_(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function CP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{mQ(e,112080,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;ze[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}mQ(e,o,p)|0;if((a[g]&1)==0){break}g_(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function DP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=C_(e|0)|0;if(j>>>0>4294967279){HP(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=e_(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}E_(k|0,e|0,j|0)|0;a[k+j|0]=0;CP(g,d,h);qP(b,g);if(!((a[g]&1)==0)){g_(c[g+8>>2]|0)}if(!((a[h]&1)==0)){g_(c[h+8>>2]|0)}c[b>>2]=112096;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function EP(a){a=a|0;var b=0;b=i;tP(a);g_(a);i=b;return}function FP(a){a=a|0;var b=0;b=i;tP(a);i=b;return}function GP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(112232)|0;if((c[a>>2]|0)==1){do{jd(112256,112232)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;gc(112232)|0;ae[d&255](b);tc(112232)|0;c[a>>2]=-1;gc(112232)|0;_c(112256)|0;i=e;return}else{gc(112232)|0;i=e;return}}function HP(a){a=a|0;a=Ec(8)|0;mP(a,112304);c[a>>2]=111920;Od(a|0,111960,41)}function IP(a){a=a|0;a=Ec(8)|0;mP(a,112304);c[a>>2]=111984;Od(a|0,112024,41)}function JP(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function KP(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function LP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){HP(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=e_(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}E_(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function MP(b){b=b|0;i=i;return(a[b]&1)!=0|0}function NP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){HP(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=e_(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}E_(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function OP(a){a=a|0;i=i;return a|0}function PP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=C_(d|0)|0;if(f>>>0>4294967279){HP(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;E_(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=e_(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;E_(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function QP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){HP(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=e_(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}G_(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function RP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){HP(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;G_(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=e_(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;G_(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function SP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){IP(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){HP(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;E_(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=e_(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;E_(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function TP(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function UP(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function VP(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}g_(c[b+8>>2]|0);i=d;return}function WP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}nQ(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}F_(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function XP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=YP(a,b)|0;i=c;return d|0}function YP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=C_(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}nQ(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}F_(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function ZP(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function _P(a){a=a|0;i=i;return a+1|0}function $P(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function aQ(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function bQ(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function cQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){dQ(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function dQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){oQ(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}G_(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function eQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){dQ(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function fQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){HP(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=e_(f)|0}else{p=e_(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}E_(l|0,n|0,q+1|0)|0;if(o){g_(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function gQ(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function hQ(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function iQ(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function jQ(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function kQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=mQ(b,g,h)|0;i=e;return d|0}function lQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){oQ(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function mQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){nQ(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}E_(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function nQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){HP(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=e_(q)|0;if((g|0)!=0){E_(e|0,m|0,g|0)|0}if((j|0)!=0){E_(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){E_(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){g_(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function oQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){HP(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=e_(p)|0;if((g|0)!=0){E_(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){E_(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}g_(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function pQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;SP(a,b,c,d,0);i=e;return}function qQ(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function rQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=C_(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function sQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=x_(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function tQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=C_(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){IP(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=x_(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function uQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){HP(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;E_(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=e_(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;E_(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function vQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){HP(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=e_(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}BZ(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function wQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){HP(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=e_(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}DZ(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function xQ(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}g_(c[b+8>>2]|0);i=d;return}function yQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zQ(a,b,AZ(b)|0)|0;i=c;return d|0}function zQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}CQ(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}CZ(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function AQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){HP(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=e_(f)|0}else{p=e_(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}BZ(l,n,q+1|0)|0;if(o){g_(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function BQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){DQ(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function CQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){HP(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=e_(q<<2)|0;p=e;if((g|0)!=0){BZ(p,m,g)|0}if((j|0)!=0){BZ(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){BZ(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){g_(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function DQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){HP(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=e_(p<<2)|0;o=e;if((g|0)!=0){BZ(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){BZ(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}g_(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function EQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=C_(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){HP(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=e_(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}E_(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=mQ(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=mQ(b,m,j)|0;i=f;return}}function FQ(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function GQ(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function HQ(a,b){a=a|0;b=b|0;var c=0;c=i;IQ(a,b);i=c;return}function IQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[112688]|0)==0){if((Za(112688)|0)==0){break}c[28170]=113384;Ud(67,112680,q|0)|0;Tb(112688)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=112680;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];DP(b,f,112736);c[e>>2]=112704;Od(e|0,112784,63)}function JQ(a,b){a=a|0;b=b|0;var d=0;d=i;IQ(a,c[a+16>>2]|b);i=d;return}function KQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=112728;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;ze[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}DW(a+28|0);$Z(c[e>>2]|0);$Z(c[f>>2]|0);$Z(c[a+48>>2]|0);$Z(c[a+60>>2]|0);i=b;return}function LQ(a){a=a|0;var b=0;b=i;KQ(a);g_(a);i=b;return}function MQ(a){a=a|0;var b=0;b=i;KQ(a);i=b;return}function NQ(a){a=a|0;var b=0;b=i;KQ(a);i=b;return}function OQ(a){a=a|0;i=i;return c[a+24>>2]|0}function PQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}CW(d,a+28|0);a=FW(d,115072)|0;f=se[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;DW(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function QQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;CW(e,a+28|0);a=FW(e,115072)|0;f=se[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;DW(e);i=d;return f|0}function RQ(a,b){a=a|0;b=b|0;var c=0;c=i;CW(a,b+28|0);i=c;return}function SQ(a){a=a|0;c[a>>2]=112328;i=i;return}function TQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));BW(b);i=d;return}function UQ(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);g_(a);i=b;return}function VQ(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);i=b;return}function WQ(a){a=a|0;var b=0;b=i;c[a>>2]=112344;DW(a+4|0);i=b;return}function XQ(a,b){a=a|0;b=b|0;var c=0;c=i;CW(a,b+4|0);i=c;return}function YQ(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=de[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function ZQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=se[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function _Q(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ge[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function $Q(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=112344;BW(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function aR(a){a=a|0;i=i;return c[a+8>>2]|0}function bR(a){a=a|0;i=i;return c[a+12>>2]|0}function cR(a){a=a|0;i=i;return c[a+16>>2]|0}function dR(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function eR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function fR(a){a=a|0;i=i;return c[a+20>>2]|0}function gR(a){a=a|0;i=i;return c[a+24>>2]|0}function hR(a){a=a|0;i=i;return c[a+28>>2]|0}function iR(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function jR(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function kR(a,b){a=a|0;b=b|0;i=i;return}function lR(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function mR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function nR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function oR(a){a=a|0;i=i;return 0}function pR(a){a=a|0;i=i;return 0}function qR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=de[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function rR(a){a=a|0;i=i;return-1}function sR(a){a=a|0;var b=0,e=0,f=0;b=i;if((de[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function tR(a,b){a=a|0;b=b|0;i=i;return-1}function uR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((se[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function vR(a,b){a=a|0;b=b|0;i=i;return-1}function wR(a){a=a|0;var b=0;b=i;c[a>>2]=112408;DW(a+4|0);g_(a);i=b;return}function xR(a){a=a|0;var b=0;b=i;c[a>>2]=112408;DW(a+4|0);i=b;return}function yR(a,b){a=a|0;b=b|0;i=i;return}function zR(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function AR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function BR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function CR(a){a=a|0;i=i;return 0}function DR(a){a=a|0;i=i;return 0}function ER(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=de[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function FR(a){a=a|0;i=i;return-1}function GR(a){a=a|0;var b=0,d=0,e=0;b=i;if((de[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function HR(a,b){a=a|0;b=b|0;i=i;return-1}function IR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((se[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function JR(a,b){a=a|0;b=b|0;i=i;return-1}function KR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));BW(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function LR(a){a=a|0;var b=0;b=i;KQ(a+8|0);g_(a);i=b;return}function MR(a){a=a|0;var b=0;b=i;KQ(a+8|0);i=b;return}function NR(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;KQ(a+(d+8)|0);g_(a+d|0);i=b;return}function OR(a){a=a|0;var b=0;b=i;KQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function PR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;QR(a,b,c);i=d;return}function QR(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){IQ(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){RR(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}CW(h,e+(k+28)|0);k=FW(h,115072)|0;DW(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(de[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){de[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((de[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;IQ(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function RR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{RR(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((de[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;IQ(b+h|0,c[b+(h+16)>>2]|1)}}while(0);eS(e);i=d;return b|0}function SR(b){b=b|0;i=i;return(a[b]|0)!=0|0}function TR(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function UR(a){a=a|0;var b=0;b=i;KQ(a+8|0);g_(a);i=b;return}function VR(a){a=a|0;var b=0;b=i;KQ(a+8|0);i=b;return}function WR(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;KQ(a+(d+8)|0);g_(a+d|0);i=b;return}function XR(a){a=a|0;var b=0;b=i;KQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function YR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{YR(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((de[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;IQ(b+h|0,c[b+(h+16)>>2]|1)}}while(0);qS(e);i=d;return b|0}function ZR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));BW(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function _R(a){a=a|0;var b=0;b=i;KQ(a+4|0);g_(a);i=b;return}function $R(a){a=a|0;var b=0;b=i;KQ(a+4|0);i=b;return}function aS(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;KQ(a+(d+4)|0);g_(a+d|0);i=b;return}function bS(a){a=a|0;var b=0;b=i;KQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function cS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){RR(g)|0}a[f]=1;i=e;return}function dS(a){a=a|0;var b=0;b=i;eS(a);i=b;return}function eS(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((de[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;IQ(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function fS(b){b=b|0;i=i;return(a[b]|0)!=0|0}function gS(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=de[b&127](a)|0;i=c;return d|0}function hS(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){eS(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{RR(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;CW(k,b+(p+28)|0);p=FW(k,113792)|0;m=p;DW(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){CW(h,b+(k+28)|0);r=FW(h,115072)|0;s=se[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;DW(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];je[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){eS(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;IQ(b+l|0,c[b+(l+16)>>2]|5);eS(j);i=e;return b|0}function iS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){eS(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{RR(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;eS(f);i=e;return b|0}if((se[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{eS(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;IQ(b+d|0,c[b+(d+16)>>2]|1);eS(f);i=e;return b|0}function jS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){eS(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){RR(k)|0}a[h]=1;if((e|0)==0){eS(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ge[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){eS(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;IQ(b+e|0,c[b+(e+16)>>2]|1);eS(g);i=f;return b|0}function kS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;me[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function lS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){eS(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{RR(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];De[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){eS(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;IQ(b+f|0,c[b+(f+16)>>2]|4);eS(h);i=e;return b|0}function mS(a){a=a|0;var b=0;b=i;KQ(a+4|0);g_(a);i=b;return}function nS(a){a=a|0;var b=0;b=i;KQ(a+4|0);i=b;return}function oS(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;KQ(a+(d+4)|0);g_(a+d|0);i=b;return}function pS(a){a=a|0;var b=0;b=i;KQ(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function qS(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((de[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;IQ(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function rS(a){a=a|0;i=i;return 112624}function sS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){NP(a,112640,35);i=d;return}else{BP(a,b,c);i=d;return}}function tS(a){a=a|0;i=i;return}function uS(a){a=a|0;var b=0;b=i;FP(a);g_(a);i=b;return}function vS(a){a=a|0;var b=0;b=i;FP(a);i=b;return}function wS(a){a=a|0;var b=0;b=i;KQ(a);g_(a);i=b;return}function xS(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function yS(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function zS(a){a=a|0;i=i;return}function AS(a){a=a|0;i=i;return}function BS(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function CS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){HP(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=e_(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function DS(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function ES(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function FS(a){a=a|0;i=i;return}function GS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function HS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){HP(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=e_(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function IS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function JS(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function KS(a){a=a|0;i=i;return}function LS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];pe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}RQ(u,g);m=u;u=c[m>>2]|0;if(!((c[28768]|0)==-1)){c[p>>2]=115072;c[p+4>>2]=219;c[p+8>>2]=0;GP(115072,p,220)}p=(c[115076>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}F=u;lP(c[m>>2]|0)|0;RQ(v,g);g=v;v=c[g>>2]|0;if(!((c[28804]|0)==-1)){c[o>>2]=115216;c[o+4>>2]=219;c[o+8>>2]=0;GP(115216,o,220)}o=(c[115220>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}J=v;lP(c[g>>2]|0)|0;g=w;be[c[(c[v>>2]|0)+24>>2]&63](g,J);be[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=MS(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];VP(w+12|0);VP(w);i=k;return}function MS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=_Z(l)|0;if((n|0)!=0){o=n;p=n;break}l_()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((de[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((de[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=se[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(se[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){de[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((de[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}$Z(o);i=k;return _|0}function NS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];OS(a,0,k,j,f,g,h);i=b;return}function OS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;ET(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}cQ(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}cQ(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((eT(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=AY(F,c[o>>2]|0,h,t)|0;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}function PS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QS(a,0,k,j,f,g,h);i=b;return}function QS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;ET(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}cQ(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}cQ(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((eT(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=zY(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}function RS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SS(a,0,k,j,f,g,h);i=b;return}function SS(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;ET(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((de[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}cQ(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}cQ(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((eT(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){de[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=yY(G,c[p>>2]|0,j,u)|0;RV(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;VP(o);VP(n);i=e;return}if((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;VP(o);VP(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;VP(o);VP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;VP(o);VP(n);i=e;return}function TS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];US(a,0,k,j,f,g,h);i=b;return}function US(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;ET(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}cQ(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}cQ(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((eT(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=xY(F,c[o>>2]|0,h,t)|0;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}function VS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];WS(a,0,k,j,f,g,h);i=b;return}function WS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;ET(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}cQ(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}cQ(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((eT(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=wY(F,c[o>>2]|0,h,t)|0;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;VP(n);VP(m);i=d;return}function XS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];YS(a,0,k,j,f,g,h);i=b;return}function YS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;ET(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}cQ(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}cQ(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((eT(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=vY(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;VP(n);VP(m);i=d;return}function ZS(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_S(a,0,k,j,f,g,h);i=b;return}function _S(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;FT(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}cQ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}cQ(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((GT(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+uY(I,c[p>>2]|0,j);RV(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}function $S(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];aT(a,0,k,j,f,g,h);i=b;return}function aT(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;FT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}cQ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}cQ(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((GT(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+tY(I,c[p>>2]|0,j);RV(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}function bT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];cT(a,0,k,j,f,g,h);i=b;return}function cT(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;FT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}cQ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}cQ(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((GT(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+sY(I,c[p>>2]|0,j);RV(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;VP(o);VP(n);i=d;return}function dT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;RQ(o,g);g=o;o=c[g>>2]|0;if(!((c[28768]|0)==-1)){c[l>>2]=115072;c[l+4>>2]=219;c[l+8>>2]=0;GP(115072,l,220)}l=(c[115076>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}y=m;Ce[c[(c[o>>2]|0)+32>>2]&63](o,113616,113642|0,y)|0;lP(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((de[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}cQ(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}cQ(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(de[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((eT(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){de[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);K=c[28740]|0;c[k>>2]=j;if((fT(E,K,113656,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;VP(p);VP(n);i=d;return}if((de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;VP(p);VP(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;VP(p);VP(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;VP(p);VP(n);i=d;return}function eT(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[113616+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[113616+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function fT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function gT(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function hT(a){a=a|0;i=i;return}function iT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];pe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}RQ(u,g);m=u;u=c[m>>2]|0;if(!((c[28766]|0)==-1)){c[p>>2]=115064;c[p+4>>2]=219;c[p+8>>2]=0;GP(115064,p,220)}p=(c[115068>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}F=u;lP(c[m>>2]|0)|0;RQ(v,g);g=v;v=c[g>>2]|0;if(!((c[28806]|0)==-1)){c[o>>2]=115224;c[o+4>>2]=219;c[o+8>>2]=0;GP(115224,o,220)}o=(c[115228>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}J=v;lP(c[g>>2]|0)|0;g=w;be[c[(c[v>>2]|0)+24>>2]&63](g,J);be[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=jT(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];xQ(w+12|0);xQ(w);i=k;return}function jT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=_Z(l)|0;if((n|0)!=0){o=n;p=n;break}l_()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=se[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(se[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){de[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}$Z(o);i=k;return ba|0}function kT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];lT(a,0,k,j,f,g,h);i=b;return}function lT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;HT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}cQ(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}cQ(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((DT(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=AY(I,c[o>>2]|0,h,t)|0;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}function mT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nT(a,0,k,j,f,g,h);i=b;return}function nT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;HT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}cQ(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}cQ(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((DT(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=zY(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;VP(n);VP(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;VP(n);VP(m);i=d;return}function oT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pT(a,0,k,j,f,g,h);i=b;return}function pT(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;HT(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=de[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}cQ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}cQ(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((DT(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){de[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=yY(J,c[p>>2]|0,j,u)|0;RV(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=de[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;VP(o);VP(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;VP(o);VP(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;VP(o);VP(n);i=e;return}function qT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rT(a,0,k,j,f,g,h);i=b;return}function rT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;HT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}cQ(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}cQ(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((DT(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=xY(I,c[o>>2]|0,h,t)|0;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}function sT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tT(a,0,k,j,f,g,h);i=b;return}function tT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;HT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}cQ(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}cQ(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((DT(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=wY(I,c[o>>2]|0,h,t)|0;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;VP(n);VP(m);i=d;return}function uT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];vT(a,0,k,j,f,g,h);i=b;return}



function vT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;HT(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}cQ(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}cQ(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((DT(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=vY(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;RV(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;VP(n);VP(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;VP(n);VP(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;VP(n);VP(m);i=d;return}function wT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xT(a,0,k,j,f,g,h);i=b;return}function xT(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;IT(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}cQ(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}cQ(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((JT(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+uY(L,c[p>>2]|0,j);RV(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}function yT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];zT(a,0,k,j,f,g,h);i=b;return}function zT(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;IT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}cQ(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}cQ(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((JT(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+tY(L,c[p>>2]|0,j);RV(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}function AT(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];BT(a,0,k,j,f,g,h);i=b;return}function BT(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;IT(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}cQ(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}cQ(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((JT(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+sY(L,c[p>>2]|0,j);RV(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;VP(o);VP(n);i=d;return}function CT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;RQ(o,g);g=o;o=c[g>>2]|0;if(!((c[28766]|0)==-1)){c[l>>2]=115064;c[l+4>>2]=219;c[l+8>>2]=0;GP(115064,l,220)}l=(c[115068>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}y=m;Ce[c[(c[o>>2]|0)+48>>2]&63](o,113616,113642|0,y)|0;lP(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;cQ(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}cQ(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}cQ(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((DT(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){de[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);N=c[28740]|0;c[k>>2]=j;if((fT(H,N,113656,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=de[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;VP(p);VP(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;VP(p);VP(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;VP(p);VP(n);i=d;return}function DT(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[113616+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[113616+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function ET(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;RQ(k,d);d=k;k=c[d>>2]|0;if(!((c[28768]|0)==-1)){c[j>>2]=115072;c[j+4>>2]=219;c[j+8>>2]=0;GP(115072,j,220)}j=(c[115076>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;FZ(n);o=130632;p=128;Od(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;FZ(n);o=130632;p=128;Od(m|0,o|0,p|0)}Ce[c[(c[k>>2]|0)+32>>2]&63](k,113616,113642|0,e)|0;e=c[d>>2]|0;if(!((c[28804]|0)==-1)){c[h>>2]=115216;c[h+4>>2]=219;c[h+8>>2]=0;GP(115216,h,220)}h=(c[115220>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}else{t=e;a[f]=de[c[(c[e>>2]|0)+16>>2]&127](t)|0;be[c[(c[e>>2]|0)+20>>2]&63](b,t);lP(c[d>>2]|0)|0;i=g;return}}function FT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;RQ(l,d);d=l;l=c[d>>2]|0;if(!((c[28768]|0)==-1)){c[k>>2]=115072;c[k+4>>2]=219;c[k+8>>2]=0;GP(115072,k,220)}k=(c[115076>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;FZ(o);p=130632;q=128;Od(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;FZ(o);p=130632;q=128;Od(n|0,p|0,q|0)}Ce[c[(c[l>>2]|0)+32>>2]&63](l,113616,113648|0,e)|0;e=c[d>>2]|0;if(!((c[28804]|0)==-1)){c[j>>2]=115216;c[j+4>>2]=219;c[j+8>>2]=0;GP(115216,j,220)}j=(c[115220>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;FZ(s);t=130632;u=128;Od(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;FZ(s);t=130632;u=128;Od(r|0,t|0,u|0)}else{u=e;a[f]=de[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=de[c[(c[e>>2]|0)+16>>2]&127](u)|0;be[c[(c[e>>2]|0)+20>>2]&63](b,u);lP(c[d>>2]|0)|0;i=h;return}}function GT(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[113616+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function HT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;RQ(j,b);b=j;j=c[b>>2]|0;if(!((c[28766]|0)==-1)){c[h>>2]=115064;c[h+4>>2]=219;c[h+8>>2]=0;GP(115064,h,220)}h=(c[115068>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;FZ(m);n=130632;o=128;Od(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;FZ(m);n=130632;o=128;Od(l|0,n|0,o|0)}Ce[c[(c[j>>2]|0)+48>>2]&63](j,113616,113642|0,d)|0;d=c[b>>2]|0;if(!((c[28806]|0)==-1)){c[g>>2]=115224;c[g+4>>2]=219;c[g+8>>2]=0;GP(115224,g,220)}g=(c[115228>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}else{s=d;c[e>>2]=de[c[(c[d>>2]|0)+16>>2]&127](s)|0;be[c[(c[d>>2]|0)+20>>2]&63](a,s);lP(c[b>>2]|0)|0;i=f;return}}function IT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;RQ(k,b);b=k;k=c[b>>2]|0;if(!((c[28766]|0)==-1)){c[j>>2]=115064;c[j+4>>2]=219;c[j+8>>2]=0;GP(115064,j,220)}j=(c[115068>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;FZ(n);o=130632;p=128;Od(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;FZ(n);o=130632;p=128;Od(m|0,o|0,p|0)}Ce[c[(c[k>>2]|0)+48>>2]&63](k,113616,113648|0,d)|0;d=c[b>>2]|0;if(!((c[28806]|0)==-1)){c[h>>2]=115224;c[h+4>>2]=219;c[h+8>>2]=0;GP(115224,h,220)}h=(c[115228>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}else{t=d;c[e>>2]=de[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=de[c[(c[d>>2]|0)+16>>2]&127](t)|0;be[c[(c[d>>2]|0)+20>>2]&63](a,t);lP(c[b>>2]|0)|0;i=g;return}}function JT(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[113616+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function KT(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function LT(a){a=a|0;i=i;return}function MT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}RQ(n,f);f=n;n=c[f>>2]|0;if(!((c[28804]|0)==-1)){c[l>>2]=115216;c[l+4>>2]=219;c[l+8>>2]=0;GP(115216,l,220)}l=(c[115220>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;FZ(u);v=130632;w=128;Od(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;FZ(u);v=130632;w=128;Od(t|0,v|0,w|0)}w=n;lP(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){be[c[f+24>>2]&63](o,w)}else{be[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((se[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];VP(o);i=j;return}function NT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=113864;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);v=c[28740]|0;c[k>>2]=h;h=OT(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;RQ(q,f);PT(w,y,k,z,o,p,q);lP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];rM(b,j,z,e,o,f,g);i=d;return}function OT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=nc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function PT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[28768]|0)==-1)){c[m>>2]=115072;c[m+4>>2]=219;c[m+8>>2]=0;GP(115072,m,220)}m=(c[115076>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[28804]|0)==-1)){c[l>>2]=115216;c[l+4>>2]=219;c[l+8>>2]=0;GP(115216,l,220)}l=(c[115220>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ce[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=se[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=se[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=se[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;VP(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;VP(n);i=k;return}}function QT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);w=c[28740]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=OT(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;RQ(r,f);PT(x,z,l,A,p,q,r);lP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];rM(b,k,A,e,p,f,g);i=d;return}function RT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=113864;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);v=c[28740]|0;c[k>>2]=h;h=OT(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;RQ(q,f);PT(w,y,k,z,o,p,q);lP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];rM(b,j,z,e,o,f,g);i=d;return}function ST(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);w=c[28740]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=OT(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;RQ(r,f);PT(x,z,l,A,p,q,r);lP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];rM(b,k,A,e,p,f,g);i=d;return}function TT(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=OT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=OT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[114968]|0)==0;if(F){do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=UT(s,r,z,n)|0}else{do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);o=c[28740]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=UT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}l_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=_Z(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}l_()}}while(0);RQ(w,f);VT(N,L,G,P,u,v,w);lP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];rM(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){$Z(O)}if((J|0)==0){i=d;return}$Z(J);i=d;return}function UT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=kc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function VT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[28768]|0)==-1)){c[m>>2]=115072;c[m+4>>2]=219;c[m+8>>2]=0;GP(115072,m,220)}m=(c[115076>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[28804]|0)==-1)){c[l>>2]=115216;c[l+4>>2]=219;c[l+8>>2]=0;GP(115216,l,220)}l=(c[115220>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=se[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=se[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);w=A+1|0;if((Wc(l<<24>>24|0,c[28740]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);l=D+1|0;if((Qd(A<<24>>24|0,c[28740]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ce[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=se[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=se[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=de[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ce[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;VP(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;VP(n);i=k;return}function WT(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=OT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=OT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[114968]|0)==0;if(F){do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=UT(s,r,z,n)|0}else{do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);o=c[28740]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=UT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}l_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=_Z(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}l_()}}while(0);RQ(w,f);VT(N,L,G,P,u,v,w);lP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];rM(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){$Z(O)}if((J|0)==0){i=d;return}$Z(J);i=d;return}function XT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=113872;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);s=c[28740]|0;c[k>>2]=h;h=OT(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;RQ(p,f);r=p;p=c[r>>2]|0;if(!((c[28768]|0)==-1)){c[l>>2]=115072;c[l+4>>2]=219;c[l+8>>2]=0;GP(115072,l,220)}l=(c[115076>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}lP(c[r>>2]|0)|0;Ce[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];rM(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];rM(b,j,u,z,m,f,g);I=j;i=d;return}function YT(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function ZT(a){a=a|0;i=i;return}function _T(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}RQ(n,f);f=n;n=c[f>>2]|0;if(!((c[28806]|0)==-1)){c[l>>2]=115224;c[l+4>>2]=219;c[l+8>>2]=0;GP(115224,l,220)}l=(c[115228>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;FZ(u);v=130632;w=128;Od(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;FZ(u);v=130632;w=128;Od(t|0,v|0,w|0)}w=n;lP(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){be[c[f+24>>2]&63](o,w)}else{be[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=se[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];xQ(o);i=j;return}function $T(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=113864;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);x=c[28740]|0;c[k>>2]=h;h=OT(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;RQ(q,f);aU(w,y,k,z,o,p,q);lP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];bU(b,j,z,e,o,f,g);i=d;return}function aU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[28766]|0)==-1)){c[m>>2]=115064;c[m+4>>2]=219;c[m+8>>2]=0;GP(115064,m,220)}m=(c[115068>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[28806]|0)==-1)){c[l>>2]=115224;c[l+4>>2]=219;c[l+8>>2]=0;GP(115224,l,220)}l=(c[115228>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ce[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=se[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=se[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=se[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;VP(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;VP(n);i=k;return}function bU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ge[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){wQ(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ge[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){xQ(l);break}c[m>>2]=0;c[b>>2]=0;xQ(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ge[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function cU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);y=c[28740]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=OT(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;RQ(r,f);aU(x,z,l,A,p,q,r);lP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];bU(b,k,A,e,p,f,g);i=d;return}function dU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=113864;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);v=c[28740]|0;c[k>>2]=h;h=OT(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;RQ(q,f);aU(w,y,k,z,o,p,q);lP(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];bU(b,j,z,e,o,f,g);i=d;return}function eU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);y=c[28740]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=OT(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;RQ(r,f);aU(x,z,l,A,p,q,r);lP(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];bU(b,k,A,e,p,f,g);i=d;return}function fU(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=OT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=OT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[114968]|0)==0;if(F){do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=UT(s,r,z,n)|0}else{do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);o=c[28740]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=UT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}l_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=_Z(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}l_()}}while(0);RQ(w,f);gU(N,L,G,P,u,v,w);lP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];bU(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){$Z(O)}if((J|0)==0){i=d;return}$Z(J);i=d;return}function gU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[28766]|0)==-1)){c[m>>2]=115064;c[m+4>>2]=219;c[m+8>>2]=0;GP(115064,m,220)}m=(c[115068>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;FZ(r);s=130632;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[28806]|0)==-1)){c[l>>2]=115224;c[l+4>>2]=219;c[l+8>>2]=0;GP(115224,l,220)}l=(c[115228>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;FZ(v);w=130632;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=se[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=se[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);w=A+1|0;if((Wc(l<<24>>24|0,c[28740]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);l=D+1|0;if((Qd(A<<24>>24|0,c[28740]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ce[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=se[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=se[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=de[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ce[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;VP(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;VP(n);i=k;return}function hU(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=OT(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=OT(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[114968]|0)==0;if(F){do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);r=c[28740]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=UT(s,r,z,n)|0}else{do{if(o){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);o=c[28740]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=UT(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}l_()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=_Z(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}l_()}}while(0);RQ(w,f);gU(N,L,G,P,u,v,w);lP(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];bU(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){$Z(O)}if((J|0)==0){i=d;return}$Z(J);i=d;return}function iU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=113872;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);s=c[28740]|0;c[k>>2]=h;h=OT(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}RQ(p,f);u=p;p=c[u>>2]|0;if(!((c[28766]|0)==-1)){c[l>>2]=115064;c[l+4>>2]=219;c[l+8>>2]=0;GP(115064,l,220)}l=(c[115068>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}lP(c[u>>2]|0)|0;u=o;Ce[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];bU(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];bU(b,j,u,z,m,f,g);I=j;i=d;return}function jU(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;RQ(r,h);v=r;r=c[v>>2]|0;if(!((c[28768]|0)==-1)){c[q>>2]=115072;c[q+4>>2]=219;c[q+8>>2]=0;GP(115072,q,220)}q=(c[115076>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;FZ(y);z=130632;A=128;Od(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;FZ(y);z=130632;A=128;Od(x|0,z|0,A|0)}A=r;lP(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ge[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(de[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=se[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(se[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ge[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ge[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];re[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(de[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){de[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){de[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((de[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((de[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function kU(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function lU(a){a=a|0;i=i;return}function mU(a){a=a|0;i=i;return 2}function nU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];jU(a,b,l,k,f,g,h,113976,113984|0);i=j;return}function oU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=de[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];jU(b,d,m,l,g,h,j,s,q);i=k;return}function pU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;RQ(n,f);f=n;n=c[f>>2]|0;if(!((c[28768]|0)==-1)){c[m>>2]=115072;c[m+4>>2]=219;c[m+8>>2]=0;GP(115072,m,220)}m=(c[115076>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}s=n;lP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=MS(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function qU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;RQ(n,f);f=n;n=c[f>>2]|0;if(!((c[28768]|0)==-1)){c[m>>2]=115072;c[m+4>>2]=219;c[m+8>>2]=0;GP(115072,m,220)}m=(c[115076>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}s=n;lP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=MS(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function rU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;RQ(m,f);f=m;m=c[f>>2]|0;if(!((c[28768]|0)==-1)){c[l>>2]=115072;c[l+4>>2]=219;c[l+8>>2]=0;GP(115072,l,220)}l=(c[115076>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;FZ(p);q=130632;r=128;Od(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;FZ(p);q=130632;r=128;Od(o|0,q|0,r|0)}r=m;lP(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=wU(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function sU(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;RQ(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[28768]|0)==-1)){c[ba>>2]=115072;c[ba+4>>2]=219;c[ba+8>>2]=0;GP(115072,ba,220)}ba=(c[115076>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;FZ(Ga);Ha=130632;Ia=128;Od(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;FZ(Ga);Ha=130632;Ia=128;Od(Fa|0,Ha|0,Ia|0)}Ia=ca;lP(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=wU(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 88:{ca=d+8|0;Da=de[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ja=Ha;Ka=Ha;La=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];jU(za,d,q,p,g,h,j,Ka,Ja+La|0);c[ca>>2]=c[za>>2];break};case 99:{ca=d+8|0;Da=de[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ma=Da+1|0;Na=Da+1|0;Oa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];jU(da,d,O,N,g,h,j,Na,Ma+Oa|0);c[ca>>2]=c[da>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];uU(d,j+8|0,e,B,h,Ia);break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];jU(ja,d,J,I,g,h,j,113992,114e3|0);c[ca>>2]=c[ja>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=wU(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];jU(oa,d,A,z,g,h,j,114e3,114011|0);c[Da>>2]=c[oa>>2];break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];jU(ra,d,y,x,g,h,j,114016,114021|0);c[Da>>2]=c[ra>>2];break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=de[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(MS(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=wU(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=wU(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=wU(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=ca|4;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];vU(0,e,m,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=wU(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Pa=Ha+2e3|0}else{Pa=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Pa+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];tU(0,e,C,h,Ia);break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=wU(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=wU(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];jU(ga,d,L,K,g,h,j,113984,113992|0);c[Ha>>2]=c[ga>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];pe[Ha&63](b,d,s,r,g,h,j);i=l;return};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Ha=wU(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Ha+ -1900;break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];jU(ua,d,v,u,g,h,j,114024,114032|0);c[Ha>>2]=c[ua>>2];break};case 104:case 66:case 98:{Ha=c[f>>2]|0;Da=d+8|0;ca=de[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=Ha;c[P+0>>2]=c[$+0>>2];Ha=(MS(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Ha|0)>=288){break a}c[j+16>>2]=((Ha|0)/12|0|0)%12|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=wU(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function tU(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((de[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(de[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){de[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((de[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((de[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function uU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=de[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=MS(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function vU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((de[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(de[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ge[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){de[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function wU(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((de[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(de[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ge[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((de[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((de[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ge[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((de[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function xU(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;RQ(p,f);t=p;p=c[t>>2]|0;if(!((c[28766]|0)==-1)){c[o>>2]=115064;c[o+4>>2]=219;c[o+8>>2]=0;GP(115064,o,220)}o=(c[115068>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;FZ(w);x=130632;y=128;Od(v|0,x|0,y|0)}y=p;lP(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ge[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=se[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(se[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ge[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ge[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];re[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=de[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=de[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){de[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=de[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function yU(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function zU(a){a=a|0;i=i;return}function AU(a){a=a|0;i=i;return 2}function BU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];xU(a,b,l,k,f,g,h,114128,114160|0);i=j;return}function CU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=de[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];xU(b,d,m,l,g,h,j,s,q);i=k;return}function DU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;RQ(n,f);f=n;n=c[f>>2]|0;if(!((c[28766]|0)==-1)){c[m>>2]=115064;c[m+4>>2]=219;c[m+8>>2]=0;GP(115064,m,220)}m=(c[115068>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}s=n;lP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=jT(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function EU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;RQ(n,f);f=n;n=c[f>>2]|0;if(!((c[28766]|0)==-1)){c[m>>2]=115064;c[m+4>>2]=219;c[m+8>>2]=0;GP(115064,m,220)}m=(c[115068>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;FZ(q);r=130632;s=128;Od(p|0,r|0,s|0)}s=n;lP(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=jT(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function FU(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;RQ(m,f);f=m;m=c[f>>2]|0;if(!((c[28766]|0)==-1)){c[l>>2]=115064;c[l+4>>2]=219;c[l+8>>2]=0;GP(115064,l,220)}l=(c[115068>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;FZ(p);q=130632;r=128;Od(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;FZ(p);q=130632;r=128;Od(o|0,q|0,r|0)}r=m;lP(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=KU(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function GU(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;RQ(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[28766]|0)==-1)){c[ba>>2]=115064;c[ba+4>>2]=219;c[ba+8>>2]=0;GP(115064,ba,220)}ba=(c[115068>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;FZ(Ga);Ha=130632;Ia=128;Od(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;FZ(Ga);Ha=130632;Ia=128;Od(Fa|0,Ha|0,Ia|0)}Ia=ca;lP(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=KU(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];HU(0,e,C,h,Ia);break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];xU(ga,d,L,K,g,h,j,114160,114192|0);c[ca>>2]=c[ga>>2];break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=de[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(jT(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];xU(oa,d,A,z,g,h,j,114224,114268|0);c[ca>>2]=c[oa>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=KU(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];xU(ra,d,y,x,g,h,j,114272,114292|0);c[Ha>>2]=c[ra>>2];break};case 99:{Ha=d+8|0;ca=de[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];Da=a[ca]|0;if((Da&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Da&255)>>>1}else{Da=c[ca+8>>2]|0;Ja=Da;Ka=Da;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];xU(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[Ha>>2]=c[da>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];pe[Ha&63](b,d,s,r,g,h,j);i=l;return};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];IU(d,j+8|0,e,B,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=KU(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=KU(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=KU(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=KU(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Ma=Ha+2e3|0}else{Ma=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Ma+ -1900;break};case 65:case 97:{Ha=c[f>>2]|0;ca=d+8|0;Da=de[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Ha;c[Q+0>>2]=c[aa+0>>2];Ha=(jT(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((Ha|0)>=168){break a}c[j+24>>2]=((Ha|0)/12|0|0)%7|0;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=KU(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=KU(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=KU(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[Ha>>2]=Da;break a}}while(0);c[h>>2]=ca|4;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];JU(0,e,m,h,Ia);break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];xU(ua,d,v,u,g,h,j,114296,114328|0);c[Da>>2]=c[ua>>2];break};case 88:{Da=d+8|0;Ha=de[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Fa=a[Ha]|0;if((Fa&1)==0){Na=Ha+4|0;Oa=Ha+4|0;Pa=(Fa&255)>>>1}else{Fa=c[Ha+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[Ha+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];xU(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[Da>>2]=c[za>>2];break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];xU(ja,d,J,I,g,h,j,114192,114224|0);c[Da>>2]=c[ja>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=KU(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function HU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ge[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){de[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=de[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=de[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function IU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=de[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=jT(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}



function JU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=de[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=de[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ge[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){de[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=de[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function KU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=de[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=de[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=de[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ge[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ge[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=de[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=de[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ge[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ge[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){de[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function LU(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);if((f|0)==(c[28740]|0)){g=b;g_(g);i=d;return}ac(c[e>>2]|0);g=b;g_(g);i=d;return}function MU(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);if((b|0)==(c[28740]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function NU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(se[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function OU(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);if((f|0)==(c[28740]|0)){g=b;g_(g);i=d;return}ac(c[e>>2]|0);g=b;g_(g);i=d;return}function PU(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);if((b|0)==(c[28740]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function QU(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;RU(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=se[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function RU(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=bZ(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){NV(115952)}else{c[e>>2]=d+(g<<2);i=j;return}}function SU(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function TU(a){a=a|0;i=i;return}function UU(a){a=a|0;i=i;return 127}function VU(a){a=a|0;i=i;return 127}function WU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function XU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function YU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function ZU(a,b){a=a|0;b=b|0;b=i;RP(a,1,45);i=b;return}function _U(a){a=a|0;i=i;return 0}function $U(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function aV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function bV(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function cV(a){a=a|0;i=i;return}function dV(a){a=a|0;i=i;return 127}function eV(a){a=a|0;i=i;return 127}function fV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function gV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function hV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function iV(a,b){a=a|0;b=b|0;b=i;RP(a,1,45);i=b;return}function jV(a){a=a|0;i=i;return 0}function kV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function lV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function mV(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function nV(a){a=a|0;i=i;return}function oV(a){a=a|0;i=i;return 2147483647}function pV(a){a=a|0;i=i;return 2147483647}function qV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function rV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function sV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function tV(a,b){a=a|0;b=b|0;b=i;wQ(a,1,45);i=b;return}function uV(a){a=a|0;i=i;return 0}function vV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function wV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function xV(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function yV(a){a=a|0;i=i;return}function zV(a){a=a|0;i=i;return 2147483647}function AV(a){a=a|0;i=i;return 2147483647}function BV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function CV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function DV(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function EV(a,b){a=a|0;b=b|0;b=i;wQ(a,1,45);i=b;return}function FV(a){a=a|0;i=i;return 0}function GV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function HV(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function IV(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function JV(a){a=a|0;i=i;return}function KV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=221;y=o+100|0;RQ(r,h);o=r;z=c[o>>2]|0;if(!((c[28768]|0)==-1)){c[n>>2]=115072;c[n+4>>2]=219;c[n+8>>2]=0;GP(115072,n,220)}n=(c[115076>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=MV(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ce[c[(c[z>>2]|0)+32>>2]&63](E,114688,114698|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=_Z(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}l_()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[114688+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,114704,m|0)|0)!=1){t=Ec(8)|0;rP(t,114712);Od(t|0,112064,43)}if((F|0)==0){break}$Z(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;lP(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ae[c[x>>2]&255](o);i=d;return}function LV(a){a=a|0;i=i;return}function MV(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;QV(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=221;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((de[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 0:{X=26;break};case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=(de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){de[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=(de[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ea=c[h>>2]|0;oa=c[ea+12>>2]|0;if((oa|0)==(c[ea+16>>2]|0)){Ia=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Ia=a[oa]|0}if(!(Ia<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Ia<<24>>24<<1)>>1]&8192)==0){X=25;break a}oa=c[h>>2]|0;ea=oa+12|0;qa=c[ea>>2]|0;if((qa|0)==(c[oa+16>>2]|0)){Ja=(de[c[(c[oa>>2]|0)+40>>2]&127](oa)|0)&255}else{c[ea>>2]=qa+1;Ja=a[qa]|0}lQ(A,Ja);X=26;break};case 4:{qa=D;ea=R;oa=r;ra=Q;sa=0;pa=T;c:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((de[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;Ma=c[e>>2]|0;do{if((Ma|0)==0){X=173}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(Ka){break}else{break c}}if((de[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}Ma=c[h>>2]|0;Na=c[Ma+12>>2]|0;if((Na|0)==(c[Ma+16>>2]|0)){Oa=(de[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)&255}else{Oa=a[Na]|0}do{if(Oa<<24>>24>-1){if((b[(c[f>>2]|0)+(Oa<<24>>24<<1)>>1]&2048)==0){X=189;break}Na=c[o>>2]|0;if((Na|0)==(qa|0)){Ma=(c[P>>2]|0)!=221;Pa=c[t>>2]|0;Qa=qa-Pa|0;Ra=Qa>>>0<2147483647?Qa<<1:-1;Sa=b_(Ma?Pa:0,Ra)|0;if((Sa|0)==0){X=182;break a}do{if(Ma){c[t>>2]=Sa;Ta=Sa}else{Pa=c[t>>2]|0;c[t>>2]=Sa;if((Pa|0)==0){Ta=Sa;break}ae[c[P>>2]&255](Pa);Ta=c[t>>2]|0}}while(0);c[P>>2]=196;Sa=Ta+Qa|0;c[o>>2]=Sa;Ua=Sa;Va=(c[t>>2]|0)+Ra|0}else{Ua=Na;Va=qa}c[o>>2]=Ua+1;a[Ua]=Oa;Wa=Va;Xa=ea;Ya=oa;Za=ra;_a=sa+1|0;$a=pa}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){ab=(Ka&255)>>>1}else{ab=c[n>>2]|0}if((ab|0)==0|(sa|0)==0){break}if(!(Oa<<24>>24==(a[v]|0))){break}if((oa|0)==(ra|0)){Ka=oa-ea|0;Sa=Ka>>>0<2147483647?Ka<<1:-1;if((pa|0)==221){bb=0}else{bb=ea}Ma=b_(bb,Sa)|0;if((Ma|0)==0){X=198;break a}cb=Ma;db=Ma+(Ka>>2<<2)|0;eb=Ma+(Sa>>>2<<2)|0;fb=196}else{cb=ea;db=oa;eb=ra;fb=pa}c[db>>2]=sa;Wa=qa;Xa=cb;Ya=db+4|0;Za=eb;_a=0;$a=fb}Sa=c[h>>2]|0;Ma=Sa+12|0;Ka=c[Ma>>2]|0;if((Ka|0)==(c[Sa+16>>2]|0)){de[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0;qa=Wa;ea=Xa;oa=Ya;ra=Za;sa=_a;pa=$a;continue}else{c[Ma>>2]=Ka+1;qa=Wa;ea=Xa;oa=Ya;ra=Za;sa=_a;pa=$a;continue}}if((ea|0)==(oa|0)|(sa|0)==0){gb=ea;hb=oa;ib=ra;jb=pa}else{if((oa|0)==(ra|0)){W=oa-ea|0;da=W>>>0<2147483647?W<<1:-1;if((pa|0)==221){kb=0}else{kb=ea}ba=b_(kb,da)|0;if((ba|0)==0){X=209;break a}lb=ba;mb=ba+(W>>2<<2)|0;nb=ba+(da>>>2<<2)|0;ob=196}else{lb=ea;mb=oa;nb=ra;ob=pa}c[mb>>2]=sa;gb=lb;hb=mb+4|0;ib=nb;jb=ob}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){pb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){pb=da;break}if((de[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;pb=0;break}else{pb=c[h>>2]|0;break}}}while(0);da=(pb|0)==0;sa=c[e>>2]|0;do{if((sa|0)==0){X=223}else{if((c[sa+12>>2]|0)!=(c[sa+16>>2]|0)){if(da){qb=sa;break}else{X=229;break a}}if((de[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){qb=sa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{qb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){rb=(de[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{rb=a[pa]|0}if(!(rb<<24>>24==(a[u]|0))){X=229;break a}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;sb=qb;tb=qb;ub=qa}else{c[sa>>2]=ra+1;sb=qb;tb=qb;ub=qa}while(1){ra=c[h>>2]|0;do{if((ra|0)==0){vb=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){vb=ra;break}if((de[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;vb=0;break}else{vb=c[h>>2]|0;break}}}while(0);ra=(vb|0)==0;do{if((tb|0)==0){wb=sb;X=243}else{if((c[tb+12>>2]|0)!=(c[tb+16>>2]|0)){if(ra){xb=sb;yb=tb;break}else{X=250;break a}}if((de[c[(c[tb>>2]|0)+36>>2]&127](tb)|0)==-1){c[e>>2]=0;wb=0;X=243;break}else{if(ra^(sb|0)==0){xb=sb;yb=sb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ra){X=250;break a}else{xb=wb;yb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){zb=(de[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{zb=a[pa]|0}if(!(zb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(zb<<24>>24<<1)>>1]&2048)==0){X=250;break a}pa=c[o>>2]|0;if((pa|0)==(ub|0)){sa=(c[P>>2]|0)!=221;oa=c[t>>2]|0;ea=ub-oa|0;ba=ea>>>0<2147483647?ea<<1:-1;W=b_(sa?oa:0,ba)|0;if((W|0)==0){X=253;break a}do{if(sa){c[t>>2]=W;Ab=W}else{oa=c[t>>2]|0;c[t>>2]=W;if((oa|0)==0){Ab=W;break}ae[c[P>>2]&255](oa);Ab=c[t>>2]|0}}while(0);c[P>>2]=196;W=Ab+ea|0;c[o>>2]=W;Bb=W;Cb=(c[t>>2]|0)+ba|0}else{Bb=pa;Cb=ub}W=c[h>>2]|0;sa=c[W+12>>2]|0;if((sa|0)==(c[W+16>>2]|0)){ra=(de[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255;Db=ra;Eb=c[o>>2]|0}else{Db=a[sa]|0;Eb=Bb}c[o>>2]=Eb+1;a[Eb]=Db;sa=(c[B>>2]|0)+ -1|0;c[B>>2]=sa;ra=c[h>>2]|0;W=ra+12|0;oa=c[W>>2]|0;if((oa|0)==(c[ra+16>>2]|0)){de[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[W>>2]=oa+1}if((sa|0)>0){sb=xb;tb=yb;ub=Cb}else{Fb=Cb;break}}}else{Fb=qa}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Fb;ha=gb;ia=hb;ja=ib;ka=S;la=jb}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}da=a[x]|0;sa=(da&1)==0;oa=sa?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=da;Kb=oa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=da;Kb=oa;break}W=oa+(sa?(da&255)>>>1:c[K>>2]|0)|0;ra=oa;while(1){if((ra|0)==(W|0)){Lb=W;break}Ka=a[ra]|0;if(!(Ka<<24>>24>-1)){Lb=ra;break}if((b[(c[f>>2]|0)+(Ka<<24>>24<<1)>>1]&8192)==0){Lb=ra;break}else{ra=ra+1|0}}ra=Lb-oa|0;W=a[A]|0;pa=(W&1)==0;if(pa){Mb=(W&255)>>>1}else{Mb=c[N>>2]|0}if(ra>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=da;Kb=oa;break}if(pa){pa=(W&255)>>>1;Nb=A+1+(pa-ra)|0;Ob=L;Pb=pa}else{pa=c[M>>2]|0;W=c[N>>2]|0;Nb=pa+(W-ra)|0;Ob=pa;Pb=W}W=Ob+Pb|0;if((Nb|0)==(W|0)){Hb=Y;Ib=Y;Jb=da;Kb=Lb;break}else{Qb=oa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=da;Kb=oa;break d}pa=Rb+1|0;if((pa|0)==(W|0)){Hb=Y;Ib=Y;Jb=da;Kb=Lb;break}else{Qb=Qb+1|0;Rb=pa}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}da=c[h>>2]|0;do{if((da|0)==0){Ub=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Ub=da;break}if((de[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);da=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(da){Wb=Hb;Xb=Ib;break}else{break e}}if((de[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(da^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(da){break}else{Wb=Vb;Xb=0}}oa=c[h>>2]|0;sa=c[oa+12>>2]|0;if((sa|0)==(c[oa+16>>2]|0)){Yb=(de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255}else{Yb=a[sa]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}sa=c[h>>2]|0;oa=sa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[sa+16>>2]|0)){de[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[oa>>2]=qa+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=a[x]|0;if((qa&1)==0){Zb=j;_b=(qa&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((de[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}da=c[h>>2]|0;qa=c[da+12>>2]|0;if((qa|0)==(c[da+16>>2]|0)){fc=(de[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{fc=a[qa]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}qa=c[h>>2]|0;da=qa+12|0;oa=c[da>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){gc=(de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0)&255}else{c[da>>2]=oa+1;gc=a[oa]|0}lQ(A,gc);$b=dc;ac=ec}}}while(0);oa=p+1|0;if(oa>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=oa;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){l_()}else if((X|0)==198){l_()}else if((X|0)==209){l_()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==253){l_()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((de[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(de[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){de[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;RV(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);VP(A);VP(z);VP(y);VP(x);VP(w);if((ic|0)==0){i=q;return hc|0}ae[jc&255](ic);i=q;return hc|0}function NV(a){a=a|0;var b=0;b=Ec(8)|0;rP(b,a);Od(b|0,112064,43)}function OV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=221;v=n+100|0;RQ(q,h);n=q;w=c[n>>2]|0;if(!((c[28768]|0)==-1)){c[m>>2]=115072;c[m+4>>2]=219;c[m+8>>2]=0;GP(115072,m,220)}m=(c[115076>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;FZ(z);A=130632;B=128;Od(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;FZ(z);A=130632;B=128;Od(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=MV(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){lQ(k,se[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=se[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);PV(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((de[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;lP(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ae[c[u>>2]&255](n);i=d;return}function PV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){oQ(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function QV(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[28628]|0)==-1)){c[p>>2]=114512;c[p+4>>2]=219;c[p+8>>2]=0;GP(114512,p,220)}p=(c[114516>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}E=b;be[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;be[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}fQ(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;VP(r);be[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}fQ(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;VP(s);a[f]=de[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=de[c[(c[b>>2]|0)+16>>2]&127](E)|0;be[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}fQ(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;VP(t);be[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}fQ(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;VP(u);F=de[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[28612]|0)==-1)){c[o>>2]=114448;c[o+4>>2]=219;c[o+8>>2]=0;GP(114448,o,220)}o=(c[114452>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}J=E;be[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;be[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}fQ(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;VP(w);be[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}fQ(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;VP(x);a[f]=de[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=de[c[(c[E>>2]|0)+16>>2]&127](J)|0;be[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}fQ(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;VP(y);be[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}fQ(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;VP(z);F=de[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function RV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function SV(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function TV(a){a=a|0;i=i;return}function UV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=221;y=o+400|0;RQ(r,h);o=r;z=c[o>>2]|0;if(!((c[28766]|0)==-1)){c[n>>2]=115064;c[n+4>>2]=219;c[n+8>>2]=0;GP(115064,n,220)}n=(c[115068>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=VV(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ce[c[(c[z>>2]|0)+48>>2]&63](E,114768,114778|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=_Z((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}l_()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[114768+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,114704,m|0)|0)!=1){t=Ec(8)|0;rP(t,114712);Od(t|0,112064,43)}if((F|0)==0){break}$Z(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=de[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];lP(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ae[c[x>>2]&255](o);i=d;return}function VV(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;YV(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=221;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=de[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}BQ(A,aa);T=28;break};case 0:{T=28;break};case 3:{$=a[y]|0;P=($&1)==0;if(P){ba=($&255)>>>1}else{ba=c[D>>2]|0}R=a[z]|0;ca=(R&1)==0;if(ca){da=(R&255)>>>1}else{da=c[e>>2]|0}if((ba|0)==(0-da|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}if(P){ja=($&255)>>>1}else{ja=c[D>>2]|0}do{if((ja|0)!=0){if(ca){ka=(R&255)>>>1}else{ka=c[e>>2]|0}if((ka|0)==0){break}la=c[g>>2]|0;ma=c[la+12>>2]|0;if((ma|0)==(c[la+16>>2]|0)){na=de[c[(c[la>>2]|0)+36>>2]&127](la)|0;oa=na;pa=a[y]|0}else{oa=c[ma>>2]|0;pa=$}ma=c[g>>2]|0;na=ma+12|0;la=c[na>>2]|0;qa=(la|0)==(c[ma+16>>2]|0);if((oa|0)==(c[((pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(qa){de[c[(c[ma>>2]|0)+40>>2]&127](ma)|0}else{c[na>>2]=la+4}na=a[y]|0;if((na&1)==0){ra=(na&255)>>>1}else{ra=c[D>>2]|0}ea=M;fa=r;ga=L;ha=ra>>>0>1?y:N;ia=O;break b}if(qa){sa=de[c[(c[ma>>2]|0)+36>>2]&127](ma)|0}else{sa=c[la>>2]|0}if((sa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}la=c[g>>2]|0;ma=la+12|0;qa=c[ma>>2]|0;if((qa|0)==(c[la+16>>2]|0)){de[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[ma>>2]=qa+4}a[k]=1;qa=a[z]|0;if((qa&1)==0){ta=(qa&255)>>>1}else{ta=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ta>>>0>1?z:N;ia=O;break b}}while(0);if(P){ua=($&255)>>>1}else{ua=c[D>>2]|0}ca=c[g>>2]|0;qa=c[ca+12>>2]|0;ma=(qa|0)==(c[ca+16>>2]|0);if((ua|0)==0){if(ma){la=de[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;va=la;wa=a[z]|0}else{va=c[qa>>2]|0;wa=R}if((va|0)!=(c[((wa&1)==0?e:c[f>>2]|0)>>2]|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}la=c[g>>2]|0;na=la+12|0;xa=c[na>>2]|0;if((xa|0)==(c[la+16>>2]|0)){de[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[na>>2]=xa+4}a[k]=1;xa=a[z]|0;if((xa&1)==0){ya=(xa&255)>>>1}else{ya=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ya>>>0>1?z:N;ia=O;break b}if(ma){ma=de[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;za=ma;Aa=a[y]|0}else{za=c[qa>>2]|0;Aa=$}if((za|0)!=(c[((Aa&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ea=M;fa=r;ga=L;ha=N;ia=O;break b}qa=c[g>>2]|0;ma=qa+12|0;ca=c[ma>>2]|0;if((ca|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ma>>2]=ca+4}ca=a[y]|0;if((ca&1)==0){Ba=(ca&255)>>>1}else{Ba=c[D>>2]|0}ea=M;fa=r;ga=L;ha=Ba>>>0>1?y:N;ia=O;break};case 4:{ca=M;ma=r;qa=L;xa=0;na=O;c:while(1){la=c[g>>2]|0;do{if((la|0)==0){Ca=1}else{Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Ea=de[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Ea=c[Da>>2]|0}if((Ea|0)==-1){c[g>>2]=0;Ca=1;break}else{Ca=(c[g>>2]|0)==0;break}}}while(0);la=c[b>>2]|0;do{if((la|0)==0){T=188}else{Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Fa=de[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Fa=c[Da>>2]|0}if((Fa|0)==-1){c[b>>2]=0;T=188;break}else{if(Ca){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(Ca){break}}la=c[g>>2]|0;Da=c[la+12>>2]|0;if((Da|0)==(c[la+16>>2]|0)){Ga=de[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Ga=c[Da>>2]|0}if(ge[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ga)|0){Da=c[n>>2]|0;if((Da|0)==(c[q>>2]|0)){ZV(m,n,q);Ha=c[n>>2]|0}else{Ha=Da}c[n>>2]=Ha+4;c[Ha>>2]=Ga;Ia=ca;Ja=ma;Ka=qa;La=xa+1|0;Ma=na}else{Da=a[w]|0;if((Da&1)==0){Na=(Da&255)>>>1}else{Na=c[K>>2]|0}if((Na|0)==0|(xa|0)==0){break}if((Ga|0)!=(c[v>>2]|0)){break}if((ma|0)==(qa|0)){Da=ma-ca|0;la=Da>>>0<2147483647?Da<<1:-1;if((na|0)!=221){Oa=ca}else{Oa=0}Pa=b_(Oa,la)|0;if((Pa|0)==0){T=206;break a}Qa=Pa;Ra=Pa+(Da>>2<<2)|0;Sa=Pa+(la>>>2<<2)|0;Ta=196}else{Qa=ca;Ra=ma;Sa=qa;Ta=na}c[Ra>>2]=xa;Ia=Qa;Ja=Ra+4|0;Ka=Sa;La=0;Ma=Ta}la=c[g>>2]|0;Pa=la+12|0;Da=c[Pa>>2]|0;if((Da|0)==(c[la+16>>2]|0)){de[c[(c[la>>2]|0)+40>>2]&127](la)|0;ca=Ia;ma=Ja;qa=Ka;xa=La;na=Ma;continue}else{c[Pa>>2]=Da+4;ca=Ia;ma=Ja;qa=Ka;xa=La;na=Ma;continue}}if((ca|0)==(ma|0)|(xa|0)==0){Ua=ca;Va=ma;Wa=qa;Xa=na}else{if((ma|0)==(qa|0)){$=ma-ca|0;R=$>>>0<2147483647?$<<1:-1;if((na|0)!=221){Ya=ca}else{Ya=0}P=b_(Ya,R)|0;if((P|0)==0){T=217;break a}Za=P;_a=P+($>>2<<2)|0;$a=P+(R>>>2<<2)|0;ab=196}else{Za=ca;_a=ma;$a=qa;ab=na}c[_a>>2]=xa;Ua=Za;Va=_a+4|0;Wa=$a;Xa=ab}R=c[B>>2]|0;if((R|0)>0){P=c[g>>2]|0;do{if((P|0)==0){bb=1}else{$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){cb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{cb=c[$>>2]|0}if((cb|0)==-1){c[g>>2]=0;bb=1;break}else{bb=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=234}else{xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){db=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{db=c[xa>>2]|0}if((db|0)==-1){c[b>>2]=0;T=234;break}else{if(bb){eb=P;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(bb){T=240;break a}else{eb=0}}P=c[g>>2]|0;xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){fb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{fb=c[xa>>2]|0}if((fb|0)!=(c[u>>2]|0)){T=240;break a}xa=c[g>>2]|0;P=xa+12|0;na=c[P>>2]|0;if((na|0)==(c[xa+16>>2]|0)){de[c[(c[xa>>2]|0)+40>>2]&127](xa)|0;gb=eb;hb=R;ib=eb}else{c[P>>2]=na+4;gb=eb;hb=R;ib=eb}while(1){na=c[g>>2]|0;do{if((na|0)==0){jb=1}else{P=c[na+12>>2]|0;if((P|0)==(c[na+16>>2]|0)){kb=de[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{kb=c[P>>2]|0}if((kb|0)==-1){c[g>>2]=0;jb=1;break}else{jb=(c[g>>2]|0)==0;break}}}while(0);do{if((ib|0)==0){lb=gb;T=257}else{na=c[ib+12>>2]|0;if((na|0)==(c[ib+16>>2]|0)){mb=de[c[(c[ib>>2]|0)+36>>2]&127](ib)|0}else{mb=c[na>>2]|0}if((mb|0)==-1){c[b>>2]=0;lb=0;T=257;break}else{if(jb^(gb|0)==0){nb=gb;ob=gb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(jb){T=263;break a}else{nb=lb;ob=0}}na=c[g>>2]|0;P=c[na+12>>2]|0;if((P|0)==(c[na+16>>2]|0)){pb=de[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{pb=c[P>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,2048,pb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){ZV(m,n,q)}P=c[g>>2]|0;na=c[P+12>>2]|0;if((na|0)==(c[P+16>>2]|0)){qb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{qb=c[na>>2]|0}na=c[n>>2]|0;c[n>>2]=na+4;c[na>>2]=qb;na=hb+ -1|0;c[B>>2]=na;P=c[g>>2]|0;xa=P+12|0;qa=c[xa>>2]|0;if((qa|0)==(c[P+16>>2]|0)){de[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[xa>>2]=qa+4}if((na|0)>0){gb=nb;hb=na;ib=ob}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ea=Ua;fa=Va;ga=Wa;ha=N;ia=Xa}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){rb=(a[J]|0)!=0}else{rb=0}if(!(F|rb)){ea=M;fa=r;ga=L;ha=0;ia=O;break b}}R=a[x]|0;na=(R&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){sb=V;tb=V;ub=R;vb=na}else{if((d[s+(o+ -1)|0]|0)<2){wb=R;xb=na}else{sb=V;tb=V;ub=R;vb=na;break}while(1){if((wb&1)==0){yb=h;zb=(wb&255)>>>1}else{yb=c[G>>2]|0;zb=c[h>>2]|0}if((xb|0)==(yb+(zb<<2)|0)){Ab=wb;break}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[xb>>2]|0)|0)){T=129;break}wb=a[x]|0;xb=xb+4|0}if((T|0)==129){T=0;Ab=a[x]|0}qa=(Ab&1)==0;xa=xb-(qa?h:c[G>>2]|0)>>2;P=a[A]|0;ma=(P&1)==0;if(ma){Bb=(P&255)>>>1}else{Bb=c[H>>2]|0}e:do{if(!(xa>>>0>Bb>>>0)){if(ma){Cb=H+(((P&255)>>>1)-xa<<2)|0;Db=H;Eb=(P&255)>>>1}else{ca=c[I>>2]|0;$=c[H>>2]|0;Cb=ca+($-xa<<2)|0;Db=ca;Eb=$}$=Db+(Eb<<2)|0;if((Cb|0)==($|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}else{Fb=qa?h:c[G>>2]|0;Gb=Cb}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}ca=Gb+4|0;if((ca|0)==($|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}Fb=Fb+4|0;Gb=ca}}}while(0);sb=V;tb=V;ub=Ab;vb=qa?h:c[G>>2]|0}}while(0);f:while(1){if((ub&1)==0){Hb=h;Ib=(ub&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((vb|0)==(Hb+(Ib<<2)|0)){break}na=c[g>>2]|0;do{if((na|0)==0){Jb=1}else{R=c[na+12>>2]|0;if((R|0)==(c[na+16>>2]|0)){Kb=de[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Kb=c[R>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((tb|0)==0){Lb=sb;T=159}else{na=c[tb+12>>2]|0;if((na|0)==(c[tb+16>>2]|0)){Mb=de[c[(c[tb>>2]|0)+36>>2]&127](tb)|0}else{Mb=c[na>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(sb|0)==0){Nb=sb;Ob=sb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}na=c[g>>2]|0;qa=c[na+12>>2]|0;if((qa|0)==(c[na+16>>2]|0)){Pb=de[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Pb=c[qa>>2]|0}if((Pb|0)!=(c[vb>>2]|0)){break}qa=c[g>>2]|0;na=qa+12|0;R=c[na>>2]|0;if((R|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[na>>2]=R+4}sb=Nb;tb=Ob;ub=a[x]|0;vb=vb+4|0}if(!F){ea=M;fa=r;ga=L;ha=N;ia=O;break b}R=a[x]|0;if((R&1)==0){Qb=h;Rb=(R&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((vb|0)==(Qb+(Rb<<2)|0)){ea=M;fa=r;ga=L;ha=N;ia=O}else{T=174;break a}break};default:{ea=M;fa=r;ga=L;ha=N;ia=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){R=c[g>>2]|0;do{if((R|0)==0){Ub=1}else{na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Vb=de[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Vb=c[na>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{R=c[Tb+12>>2]|0;if((R|0)==(c[Tb+16>>2]|0)){Xb=de[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[R>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ea=M;fa=r;ga=L;ha=N;ia=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ea=M;fa=r;ga=L;ha=N;ia=O;break g}else{Yb=Wb;Zb=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){_b=de[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{_b=c[na>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break g}na=c[g>>2]|0;R=na+12|0;qa=c[R>>2]|0;if((qa|0)==(c[na+16>>2]|0)){$b=de[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=qa+4;$b=c[qa>>2]|0}BQ(A,$b);Sb=Yb;Tb=Zb}}}while(0);qa=o+1|0;if(qa>>>0<4){L=ga;r=fa;M=ea;o=qa;N=ha;O=ia}else{W=ea;X=fa;Y=ha;Z=ia;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){l_()}else if((T|0)==217){l_()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==276){i:do{if((Y|0)!=0){ia=Y+4|0;ha=Y+8|0;fa=1;j:while(1){ea=a[Y]|0;if((ea&1)==0){dc=(ea&255)>>>1}else{dc=c[ia>>2]|0}if(!(fa>>>0<dc>>>0)){break i}ea=c[g>>2]|0;do{if((ea|0)==0){ec=1}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){fc=de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ea=c[b>>2]|0;do{if((ea|0)==0){T=295}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){gc=de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ea=c[g>>2]|0;N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){hc=de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ia}else{ic=c[ha>>2]|0}if((hc|0)!=(c[ic+(fa<<2)>>2]|0)){break}N=fa+1|0;ea=c[g>>2]|0;o=ea+12|0;r=c[o>>2]|0;if((r|0)==(c[ea+16>>2]|0)){de[c[(c[ea>>2]|0)+40>>2]&127](ea)|0;fa=N;continue}else{c[o>>2]=r+4;fa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;RV(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);xQ(A);xQ(z);xQ(y);xQ(x);VP(w);if((bc|0)==0){i=p;return ac|0}ae[cc&255](bc);i=p;return ac|0}function WV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=221;v=n+400|0;RQ(q,h);n=q;w=c[n>>2]|0;if(!((c[28766]|0)==-1)){c[m>>2]=115064;c[m+4>>2]=219;c[m+8>>2]=0;GP(115064,m,220)}m=(c[115068>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;FZ(z);A=130632;B=128;Od(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;FZ(z);A=130632;B=128;Od(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=VV(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){BQ(k,se[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=se[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);XV(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=de[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];lP(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ae[c[u>>2]&255](n);i=d;return}function XV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){DQ(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function YV(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[28660]|0)==-1)){c[p>>2]=114640;c[p+4>>2]=219;c[p+8>>2]=0;GP(114640,p,220)}p=(c[114644>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;FZ(C);D=130632;E=128;Od(B|0,D|0,E|0)}E=b;be[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;be[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}AQ(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xQ(r);be[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}AQ(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xQ(s);c[f>>2]=de[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=de[c[(c[b>>2]|0)+16>>2]&127](E)|0;be[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}fQ(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;VP(t);be[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}AQ(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xQ(u);F=de[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[28644]|0)==-1)){c[o>>2]=114576;c[o+4>>2]=219;c[o+8>>2]=0;GP(114576,o,220)}o=(c[114580>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;FZ(H);I=130632;J=128;Od(G|0,I|0,J|0)}J=E;be[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;be[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}AQ(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;xQ(w);be[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}AQ(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;xQ(x);c[f>>2]=de[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=de[c[(c[E>>2]|0)+16>>2]&127](J)|0;be[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}fQ(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;VP(y);be[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}AQ(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;xQ(z);F=de[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function ZV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=221;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=b_(m,l)|0;m=a;if((a|0)==0){l_()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}ae[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=196;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function _V(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function $V(a){a=a|0;i=i;return}function aW(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,114824,o|0)|0;do{if(s>>>0>99){do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);o=c[28740]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=UT(r,o,114824,n)|0;o=c[r>>2]|0;if((o|0)==0){l_()}H=_Z(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}l_()}else{I=0;J=0;K=q;L=s}}while(0);RQ(t,g);s=t;q=c[s>>2]|0;if(!((c[28768]|0)==-1)){c[p>>2]=115072;c[p+4>>2]=219;c[p+8>>2]=0;GP(115072,p,220)}p=(c[115076>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;FZ(N);O=130632;P=128;Od(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;FZ(N);O=130632;P=128;Od(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ce[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;bW(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=_Z(V)|0;if((T|0)!=0){W=T;X=T;break}l_()}else{W=0;X=t}}while(0);cW(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];rM(b,m,X,e,D,g,j);if((W|0)!=0){$Z(W)}VP(A);VP(z);VP(y);lP(c[s>>2]|0)|0;if((J|0)!=0){$Z(J)}if((I|0)==0){i=d;return}$Z(I);i=d;return}function bW(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[28628]|0)==-1)){c[p>>2]=114512;c[p+4>>2]=219;c[p+8>>2]=0;GP(114512,p,220)}p=(c[114516>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;FZ(I);J=130632;K=128;Od(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;FZ(I);J=130632;K=128;Od(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){be[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;be[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}fQ(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;VP(s)}else{be[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;be[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}fQ(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;VP(v)}a[g]=de[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=de[c[(c[e>>2]|0)+16>>2]&127](K)|0;be[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}fQ(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;VP(w);be[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}fQ(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;VP(x);L=de[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[28612]|0)==-1)){c[o>>2]=114448;c[o+4>>2]=219;c[o+8>>2]=0;GP(114448,o,220)}o=(c[114452>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;FZ(N);O=130632;P=128;Od(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;FZ(N);O=130632;P=128;Od(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){be[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;be[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}fQ(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;VP(A)}else{be[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;be[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}fQ(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;VP(D)}a[g]=de[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=de[c[(c[G>>2]|0)+16>>2]&127](P)|0;be[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}fQ(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;VP(E);be[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}fQ(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;VP(F);L=de[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function cW(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){N=(J&255)>>>1}else{N=c[A>>2]|0}if((N|0)==0|x){L=H;break a}if(I){O=y;P=(J&255)>>>1}else{O=c[z>>2]|0;P=c[A>>2]|0}J=O+P|0;I=c[f>>2]|0;if((O|0)==(J|0)){Q=I}else{R=I;I=O;while(1){a[R]=a[I]|0;S=I+1|0;T=R+1|0;if((S|0)==(J|0)){Q=T;break}else{I=S;R=T}}}c[f>>2]=Q;L=H;break};case 1:{c[e>>2]=c[f>>2];R=se[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=R;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};case 4:{R=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){J=I;while(1){T=a[J]|0;if(!(T<<24>>24>-1)){U=J;break b}S=J+1|0;if((b[(c[F>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){U=J;break b}if(S>>>0<j>>>0){J=S}else{U=S;break}}}else{U=I}}while(0);J=U;if(B){if(U>>>0>I>>>0){S=I+(0-J)|0;J=S>>>0<G>>>0?G:S;S=J+s|0;T=R;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=T+1;a[T]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>I>>>0&Z)){break}T=c[f>>2]|0;W=Y;V=X}V=U+J|0;if(Z){_=V;$=S;aa=32}else{ba=0;ca=V;da=S}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=se[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;T=da;while(1){a[W]=ba;X=T+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){T=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(I|0)){W=se[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;T=c[f>>2]|0;c[f>>2]=T+1;a[T]=W}else{W=a[p]|0;T=(W&1)==0;if(T){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(T){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){T=c[f>>2]|0;c[f>>2]=T+1;a[T]=o;T=ja+1|0;W=a[p]|0;S=(W&1)==0;if(S){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(T>>>0<ma>>>0)){na=ia;oa=T;pa=0;break}if(S){qa=C}else{qa=c[D>>2]|0}if((a[qa+T|0]|0)==127){na=-1;oa=T;pa=0;break}if(S){ra=C}else{ra=c[D>>2]|0}na=a[ra+T|0]|0;oa=T;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);T=ha+ -1|0;S=a[T]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=S;if((T|0)==(I|0)){break}else{ha=T;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((R|0)==(V|0)){L=I;break a}T=V+ -1|0;if(T>>>0>R>>>0){sa=R;ta=T}else{L=I;break a}while(1){T=a[sa]|0;a[sa]=a[ta]|0;a[ta]=T;T=sa+1|0;V=ta+ -1|0;if(T>>>0<V>>>0){ta=V;sa=T}else{L=I;break}}break};default:{L=H}}}while(0);I=h+1|0;if(I>>>0<4){H=L;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function dW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;RQ(m,g);z=m;A=c[z>>2]|0;if(!((c[28768]|0)==-1)){c[l>>2]=115072;c[l+4>>2]=219;c[l+8>>2]=0;GP(115072,l,220)}l=(c[115076>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(se[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;bW(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=_Z(P)|0;if((N|0)!=0){Q=N;R=N;break}l_()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}cW(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];rM(b,k,R,e,w,g,h);if((Q|0)==0){VP(t);VP(s);VP(r);U=c[z>>2]|0;V=U;W=V;X=lP(W)|0;i=d;return}$Z(Q);VP(t);VP(s);VP(r);U=c[z>>2]|0;V=U;W=V;X=lP(W)|0;i=d;return}function eW(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function fW(a){a=a|0;i=i;return}function gW(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,114824,o|0)|0;do{if(s>>>0>99){do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);o=c[28740]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=UT(r,o,114824,n)|0;o=c[r>>2]|0;if((o|0)==0){l_()}H=_Z(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}l_()}else{J=0;K=0;L=q;M=s}}while(0);RQ(t,g);s=t;q=c[s>>2]|0;if(!((c[28766]|0)==-1)){c[p>>2]=115064;c[p+4>>2]=219;c[p+8>>2]=0;GP(115064,p,220)}p=(c[115068>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;FZ(O);P=130632;Q=128;Od(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;FZ(O);P=130632;Q=128;Od(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ce[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;hW(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=_Z(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}l_()}else{X=0;Y=t}}while(0);iW(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];bU(b,m,Y,e,D,g,j);if((X|0)!=0){$Z(X)}xQ(A);xQ(z);VP(y);lP(c[s>>2]|0)|0;if((K|0)!=0){$Z(K)}if((J|0)==0){i=d;return}$Z(J);i=d;return}function hW(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[28660]|0)==-1)){c[p>>2]=114640;c[p+4>>2]=219;c[p+8>>2]=0;GP(114640,p,220)}p=(c[114644>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;FZ(I);J=130632;K=128;Od(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;FZ(I);J=130632;K=128;Od(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){be[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;be[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}AQ(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;xQ(s)}else{be[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;be[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}AQ(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xQ(v)}c[g>>2]=de[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=de[c[(c[e>>2]|0)+16>>2]&127](K)|0;be[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}fQ(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;VP(w);be[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}AQ(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xQ(x);L=de[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[28644]|0)==-1)){c[o>>2]=114576;c[o+4>>2]=219;c[o+8>>2]=0;GP(114576,o,220)}o=(c[114580>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;FZ(N);O=130632;P=128;Od(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;FZ(N);O=130632;P=128;Od(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){be[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;be[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}AQ(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;xQ(A)}else{be[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;be[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}AQ(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;xQ(D)}c[g>>2]=de[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=de[c[(c[G>>2]|0)+16>>2]&127](P)|0;be[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}fQ(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;VP(E);be[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}AQ(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;xQ(F);L=de[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function iW(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 3:{E=a[q]|0;F=(E&1)==0;if(F){G=(E&255)>>>1}else{G=c[t>>2]|0}if((G|0)==0){D=C;break a}if(F){H=t}else{H=c[u>>2]|0}F=c[H>>2]|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=F;D=C;break};case 4:{F=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){I=E;while(1){J=I+4|0;if(!(ge[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[I>>2]|0)|0)){K=I;break b}if(J>>>0<h>>>0){I=J}else{K=J;break}}}else{K=E}}while(0);if(y){do{if(K>>>0>E>>>0){I=c[e>>2]|0;J=K;L=r;while(1){M=J+ -4|0;N=I+4|0;c[I>>2]=c[M>>2];O=L+ -1|0;P=(O|0)>0;if(M>>>0>E>>>0&P){L=O;J=M;I=N}else{break}}c[e>>2]=N;if(P){Q=M;R=O;S=34;break}I=c[e>>2]|0;c[e>>2]=I+4;T=I;U=M}else{Q=K;R=r;S=34}}while(0);do{if((S|0)==34){S=0;I=se[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;J=c[e>>2]|0;L=J+4|0;c[e>>2]=L;if((R|0)>0){V=L;W=J;X=R}else{T=J;U=Q;break}while(1){c[W>>2]=I;L=X+ -1|0;if((L|0)>0){X=L;W=V;V=V+4|0}else{break}}c[e>>2]=J+(R+1<<2);T=J+(R<<2)|0;U=Q}}while(0);c[T>>2]=m;Y=U}else{Y=K}if((Y|0)==(E|0)){I=se[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;L=c[e>>2]|0;Z=L+4|0;c[e>>2]=Z;c[L>>2]=I;_=Z}else{Z=a[o]|0;I=(Z&1)==0;if(I){$=(Z&255)>>>1}else{$=c[B>>2]|0}if(($|0)==0){aa=Y;ba=-1;ca=0;da=0}else{if(I){ea=z}else{ea=c[A>>2]|0}aa=Y;ba=a[ea]|0;ca=0;da=0}while(1){I=c[e>>2]|0;do{if((da|0)==(ba|0)){Z=I+4|0;c[e>>2]=Z;c[I>>2]=n;L=ca+1|0;fa=a[o]|0;ga=(fa&1)==0;if(ga){ha=(fa&255)>>>1}else{ha=c[B>>2]|0}if(!(L>>>0<ha>>>0)){ia=Z;ja=ba;ka=L;la=0;break}if(ga){ma=z}else{ma=c[A>>2]|0}if((a[ma+L|0]|0)==127){ia=Z;ja=-1;ka=L;la=0;break}if(ga){na=z}else{na=c[A>>2]|0}ia=Z;ja=a[na+L|0]|0;ka=L;la=0}else{ia=I;ja=ba;ka=ca;la=da}}while(0);I=aa+ -4|0;J=c[I>>2]|0;L=ia+4|0;c[e>>2]=L;c[ia>>2]=J;if((I|0)==(E|0)){_=L;break}else{aa=I;ba=ja;ca=ka;da=la+1|0}}}if((F|0)==(_|0)){D=E;break a}I=_+ -4|0;if(I>>>0>F>>>0){oa=F;pa=I}else{D=E;break a}while(1){I=c[oa>>2]|0;c[oa>>2]=c[pa>>2];c[pa>>2]=I;I=oa+4|0;L=pa+ -4|0;if(I>>>0<L>>>0){pa=L;oa=I}else{D=E;break}}break};case 1:{c[d>>2]=c[e>>2];E=se[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 2:{E=a[p]|0;F=(E&1)==0;if(F){qa=(E&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){D=C;break a}if(F){ra=w;sa=(E&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}E=ra+(sa<<2)|0;F=c[e>>2]|0;if((ra|0)==(E|0)){ta=F}else{I=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;L=F;J=ra;while(1){c[L>>2]=c[J>>2];Z=J+4|0;if((Z|0)==(E|0)){break}L=L+4|0;J=Z}ta=F+(I+1<<2)|0}c[e>>2]=ta;D=C;break};default:{D=C}}}while(0);J=g+1|0;if(J>>>0<4){C=D;g=J}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function jW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;RQ(m,g);z=m;A=c[z>>2]|0;if(!((c[28766]|0)==-1)){c[l>>2]=115064;c[l+4>>2]=219;c[l+8>>2]=0;GP(115064,l,220)}l=(c[115068>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;FZ(D);E=130632;F=128;Od(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(se[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;hW(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=_Z(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}l_()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}iW(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];bU(b,k,R,e,w,g,h);if((Q|0)==0){xQ(t);xQ(s);VP(r);U=c[z>>2]|0;V=U;W=V;X=lP(W)|0;i=d;return}$Z(Q);xQ(t);xQ(s);VP(r);U=c[z>>2]|0;V=U;W=V;X=lP(W)|0;i=d;return}function kW(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function lW(a){a=a|0;i=i;return}function mW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function nW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{lQ(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=ud(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=C_(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{VP(j);i=d;return}do{lQ(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);VP(j);i=d;return}function oW(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function pW(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function qW(a){a=a|0;i=i;return}function rW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function sW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=116728;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=116728|0;while(1){c[m>>2]=y;A=(Be[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{lQ(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}NV(115952)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=ud(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=116832;D=C_(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){VP(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=116832|0;while(1){c[q>>2]=o;h=(Be[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{BQ(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){NV(115952)}else if((E|0)==25){VP(r);i=d;return}}function tW(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function uW(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=115160;e=b+8|0;b=c[e>>2]|0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);if((b|0)==(c[28740]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function vW(a){a=a|0;a=Ec(8)|0;mP(a,114952);c[a>>2]=111920;Od(a|0,111960,41)}function wW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=114992;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);NP(b+144|0,114976,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[119884>>2]=0;c[29970]=113472;if(!((c[28374]|0)==-1)){c[G>>2]=113496;c[G+4>>2]=219;c[G+8>>2]=0;GP(113496,G,220)}xW(b,119880,(c[113500>>2]|0)+ -1|0);c[119876>>2]=0;c[29968]=113512;if(!((c[28384]|0)==-1)){c[F>>2]=113536;c[F+4>>2]=219;c[F+8>>2]=0;GP(113536,F,220)}xW(b,119872,(c[113540>>2]|0)+ -1|0);c[119860>>2]=0;c[29964]=115088;c[119864>>2]=0;a[119868|0]=0;F=c[(yc()|0)>>2]|0;c[119864>>2]=F;if(!((c[28768]|0)==-1)){c[E>>2]=115072;c[E+4>>2]=219;c[E+8>>2]=0;GP(115072,E,220)}xW(b,119856,(c[115076>>2]|0)+ -1|0);c[119852>>2]=0;c[29962]=116048;if(!((c[28766]|0)==-1)){c[D>>2]=115064;c[D+4>>2]=219;c[D+8>>2]=0;GP(115064,D,220)}xW(b,119848,(c[115068>>2]|0)+ -1|0);c[119844>>2]=0;c[29960]=116264;if(!((c[28784]|0)==-1)){c[C>>2]=115136;c[C+4>>2]=219;c[C+8>>2]=0;GP(115136,C,220)}xW(b,119840,(c[115140>>2]|0)+ -1|0);c[119828>>2]=0;c[29956]=115160;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);c[119832>>2]=c[28740];if(!((c[28786]|0)==-1)){c[B>>2]=115144;c[B+4>>2]=219;c[B+8>>2]=0;GP(115144,B,220)}xW(b,119824,(c[115148>>2]|0)+ -1|0);c[119820>>2]=0;c[29954]=116488;if(!((c[28800]|0)==-1)){c[A>>2]=115200;c[A+4>>2]=219;c[A+8>>2]=0;GP(115200,A,220)}xW(b,119816,(c[115204>>2]|0)+ -1|0);c[119812>>2]=0;c[29952]=116608;if(!((c[28802]|0)==-1)){c[z>>2]=115208;c[z+4>>2]=219;c[z+8>>2]=0;GP(115208,z,220)}xW(b,119808,(c[115212>>2]|0)+ -1|0);c[119788>>2]=0;c[29946]=115240;a[119792|0]=46;a[119793|0]=44;z=119796|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[28804]|0)==-1)){c[y>>2]=115216;c[y+4>>2]=219;c[y+8>>2]=0;GP(115216,y,220)}xW(b,119784,(c[115220>>2]|0)+ -1|0);c[119756>>2]=0;c[29938]=115280;c[119760>>2]=46;c[119764>>2]=44;y=119768|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[28806]|0)==-1)){c[x>>2]=115224;c[x+4>>2]=219;c[x+8>>2]=0;GP(115224,x,220)}xW(b,119752,(c[115228>>2]|0)+ -1|0);c[119748>>2]=0;c[29936]=113552;if(!((c[28402]|0)==-1)){c[w>>2]=113608;c[w+4>>2]=219;c[w+8>>2]=0;GP(113608,w,220)}xW(b,119744,(c[113612>>2]|0)+ -1|0);c[119740>>2]=0;c[29934]=113672;if(!((c[28432]|0)==-1)){c[v>>2]=113728;c[v+4>>2]=219;c[v+8>>2]=0;GP(113728,v,220)}xW(b,119736,(c[113732>>2]|0)+ -1|0);c[119732>>2]=0;c[29932]=113744;if(!((c[28448]|0)==-1)){c[u>>2]=113792;c[u+4>>2]=219;c[u+8>>2]=0;GP(113792,u,220)}xW(b,119728,(c[113796>>2]|0)+ -1|0);c[119724>>2]=0;c[29930]=113808;if(!((c[28464]|0)==-1)){c[t>>2]=113856;c[t+4>>2]=219;c[t+8>>2]=0;GP(113856,t,220)}xW(b,119720,(c[113860>>2]|0)+ -1|0);c[119716>>2]=0;c[29928]=114400;if(!((c[28612]|0)==-1)){c[s>>2]=114448;c[s+4>>2]=219;c[s+8>>2]=0;GP(114448,s,220)}xW(b,119712,(c[114452>>2]|0)+ -1|0);c[119708>>2]=0;c[29926]=114464;if(!((c[28628]|0)==-1)){c[r>>2]=114512;c[r+4>>2]=219;c[r+8>>2]=0;GP(114512,r,220)}xW(b,119704,(c[114516>>2]|0)+ -1|0);c[119700>>2]=0;c[29924]=114528;if(!((c[28644]|0)==-1)){c[q>>2]=114576;c[q+4>>2]=219;c[q+8>>2]=0;GP(114576,q,220)}xW(b,119696,(c[114580>>2]|0)+ -1|0);c[119692>>2]=0;c[29922]=114592;if(!((c[28660]|0)==-1)){c[p>>2]=114640;c[p+4>>2]=219;c[p+8>>2]=0;GP(114640,p,220)}xW(b,119688,(c[114644>>2]|0)+ -1|0);c[119684>>2]=0;c[29920]=114656;if(!((c[28670]|0)==-1)){c[o>>2]=114680;c[o+4>>2]=219;c[o+8>>2]=0;GP(114680,o,220)}xW(b,119680,(c[114684>>2]|0)+ -1|0);c[119676>>2]=0;c[29918]=114736;if(!((c[28690]|0)==-1)){c[n>>2]=114760;c[n+4>>2]=219;c[n+8>>2]=0;GP(114760,n,220)}xW(b,119672,(c[114764>>2]|0)+ -1|0);c[119668>>2]=0;c[29916]=114792;if(!((c[28704]|0)==-1)){c[m>>2]=114816;c[m+4>>2]=219;c[m+8>>2]=0;GP(114816,m,220)}xW(b,119664,(c[114820>>2]|0)+ -1|0);c[119660>>2]=0;c[29914]=114840;if(!((c[28716]|0)==-1)){c[l>>2]=114864;c[l+4>>2]=219;c[l+8>>2]=0;GP(114864,l,220)}xW(b,119656,(c[114868>>2]|0)+ -1|0);c[119644>>2]=0;c[29910]=113888;c[119648>>2]=113936;if(!((c[28492]|0)==-1)){c[k>>2]=113968;c[k+4>>2]=219;c[k+8>>2]=0;GP(113968,k,220)}xW(b,119640,(c[113972>>2]|0)+ -1|0);c[119628>>2]=0;c[29906]=114040;c[119632>>2]=114088;if(!((c[28530]|0)==-1)){c[j>>2]=114120;c[j+4>>2]=219;c[j+8>>2]=0;GP(114120,j,220)}xW(b,119624,(c[114124>>2]|0)+ -1|0);c[119612>>2]=0;c[29902]=115984;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);c[119616>>2]=c[28740];c[29902]=114336;if(!((c[28588]|0)==-1)){c[h>>2]=114352;c[h+4>>2]=219;c[h+8>>2]=0;GP(114352,h,220)}xW(b,119608,(c[114356>>2]|0)+ -1|0);c[119596>>2]=0;c[29898]=115984;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);c[119600>>2]=c[28740];c[29898]=114368;if(!((c[28596]|0)==-1)){c[g>>2]=114384;c[g+4>>2]=219;c[g+8>>2]=0;GP(114384,g,220)}xW(b,119592,(c[114388>>2]|0)+ -1|0);c[119588>>2]=0;c[29896]=114880;if(!((c[28726]|0)==-1)){c[f>>2]=114904;c[f+4>>2]=219;c[f+8>>2]=0;GP(114904,f,220)}xW(b,119584,(c[114908>>2]|0)+ -1|0);c[119580>>2]=0;c[29894]=114920;if((c[28736]|0)==-1){N=114944;O=114944;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=119576;xW(b,T,S);i=e;return}c[H>>2]=114944;c[H+4>>2]=219;c[H+8>>2]=0;GP(114944,H,220);N=114944;O=114944;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=119576;xW(b,T,S);i=e;return}function xW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;kP(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){CY(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}lP(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function yW(a){a=a|0;var b=0;b=i;zW(a);g_(a);i=b;return}function zW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=114992;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{lP(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}VP(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{g_(h);i=d;return}}function AW(){var b=0,d=0,e=0,f=0;b=i;if((a[115048]|0)!=0){d=115040;e=c[28760]|0;i=b;return e|0}if((Za(115048)|0)==0){d=115040;e=c[28760]|0;i=b;return e|0}do{if((a[115024]|0)==0){if((Za(115024)|0)==0){break}wW(119416,1);c[28752]=119416;c[28754]=115008;Tb(115024)}}while(0);f=c[c[28754]>>2]|0;c[28758]=f;kP(f);c[28760]=115032;Tb(115048);d=115040;e=c[28760]|0;i=b;return e|0}function BW(a){a=a|0;var b=0,d=0;b=i;d=c[(AW()|0)>>2]|0;c[a>>2]=d;kP(d);i=b;return}function CW(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;kP(e);i=d;return}function DW(a){a=a|0;var b=0;b=i;lP(c[a>>2]|0)|0;i=b;return}function EW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=219;c[e+8>>2]=0;GP(a,e,220)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function FW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=219;c[e+8>>2]=0;GP(a,e,220)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;FZ(h);j=130632;k=128;Od(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;FZ(h);j=130632;k=128;Od(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function GW(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function HW(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}ae[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function IW(a){a=a|0;var b=0;b=c[28764]|0;c[28764]=1+b;c[a+4>>2]=b+1;i=i;return}function JW(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function KW(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function LW(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function MW(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function NW(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function OW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(yd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function PW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(yd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function QW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function RW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function SW(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}



function kM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;B_(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=P_(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=P_(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[22476]=d;u=0;Ha(58,10,215)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=P_(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=P_(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=P_(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=P_(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=P_(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=P_(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(216,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=P_(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=P_(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=P_(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function lM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=id(c[9712]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[41060>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;rc(90240,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Nd(10,a|0)|0;qd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 3:{if((c[41116>>2]|0)==0){i=b;return}c[f>>2]=e;n=c[r>>2]|0;rc(90240,7,1,n|0)|0;Dc(n|0,d|0,f|0)|0;Nd(10,n|0)|0;qd(0)|0;i=b;return};case 5:case 4:{i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;rc(90240,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Nd(10,e|0)|0;qd(0)|0;eb(c[g+80>>2]|0,1);break};default:{yv(g,90248,b)}}}function mM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(90224,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Nd(10,d|0)|0;qd(0)|0;i=a;return}function nM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;uM(90168,b);c[22034]=88896;b=88140|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[88156>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}d=id(c[9712]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}function oM(a,b){a=a|0;b=b|0;var c=0;c=i;qM(a,b);i=c;return}function pM(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function qM(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=OQ(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function rM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;kB(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=sM(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((_Q(b,d,r)|0)==(r|0)){break}kB(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){QP(l,s,h);if((_Q(b,UP(l)|0,s)|0)==(s|0)){VP(l);break}kB(m);c[o>>2]=0;c[a>>2]=0;VP(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((_Q(b,e,l)|0)==(l|0)){break}kB(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);tM(g,0)|0;c[a>>2]=b;i=j;return}function sM(a){a=a|0;i=i;return c[a+12>>2]|0}function tM(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function uM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[22040]|0;if((g|0)==0){c[e>>2]=(C_(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(AF(e,f)|0)>>2]|0;c[22554]=h;f=_Z(h)|0;c[22040]=f;j=h;k=f}else{j=c[22554]|0;k=g}g=nc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[22554]|0)>>>0){i=d;return}$Z(c[22040]|0);j=g<<1|1;c[22554]=j;g=_Z(j)|0;c[22040]=g;nc(g|0,j|0,a|0,b|0)|0;i=d;return}function vM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;wM(g,16);xM(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){yM(a,g);zM(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){aM(hS(m,+h[b+(p<<3)>>3])|0,91608)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){hS(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){aM(m,91616)|0}}while((e|0)<(d|0));yM(a,g);zM(g);i=f;return}function wM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;SQ(e);f=a;c[f>>2]=91988;g=e;c[g>>2]=92008;e=a+4|0;ZR(a,92020|0,e);c[f>>2]=91988;c[g>>2]=92008;LM(e,b|16);i=d;return}function xM(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function yM(a,b){a=a|0;b=b|0;var c=0;c=i;FM(a,b+4|0);i=c;return}function zM(a){a=a|0;var b=0;b=i;PM(a,92016);NQ(a+56|0);i=b;return}function AM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[41104>>2]|0)!=0){tb(92312)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(14,0,91624,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(14,0,91696,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[41104>>2]|0)==0){i=d;return 0}uv(14,0,91744,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(91760,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function BM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[41104>>2]|0)!=0){tb(92312)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(14,0,91624,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(14,0,91696,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[41104>>2]|0)==0){i=d;return 0}uv(14,0,91744,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(91760,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function CM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[41104>>2]|0)!=0){tb(92312)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(14,0,91624,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(14,0,91696,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[41104>>2]|0)==0){i=d;return 0}uv(14,0,91744,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(91760,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function DM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[41104>>2]|0)!=0){tb(92312)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(14,0,91624,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(14,0,91696,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[41104>>2]|0)==0){i=d;return 0}uv(14,0,91744,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(91760,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function EM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=a_(fa(F,F)|0,8)|0;J=I;K=a_(fa(G,F)|0,8)|0;L=K;M=a_(fa(H,F)|0,8)|0;N=M;O=a_(fa(H,G)|0,8)|0;P=O;JP(p);JP(q);JP(r);JP(s);JP(t);JP(u);JP(v);Q=a+536|0;xv(c[Q>>2]|0,(I|0)!=0|0,91768,o);xv(c[Q>>2]|0,(K|0)!=0|0,91768,n);xv(c[Q>>2]|0,(M|0)!=0|0,91768,m);xv(c[Q>>2]|0,(O|0)!=0|0,91768,l);l=a+540|0;m=a;if((de[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;AM(a,J)|0;xv(n,1,91784,k)}vM(w,J,F,F);WP(p,w)|0;VP(w);if((de[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;BM(a,L)|0;xv(w,1,91816,j)}vM(x,L,F,G);WP(q,x)|0;VP(x);if((de[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;CM(a,N)|0;xv(x,1,91848,h)}vM(y,N,H,F);WP(r,y)|0;VP(y);if((de[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;DM(a,P)|0;xv(m,1,91880,g)}vM(z,P,H,G);WP(s,z)|0;VP(z);if((F|0)==0){XP(t,91912)|0}else{vM(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);WP(t,A)|0;VP(A)}if((G|0)==0){XP(u,91912)|0}else{vM(B,c[a+432>>2]|0,1,G);WP(u,B)|0;VP(B)}$Z(I);$Z(K);$Z(M);$Z(O);PP(E,c[a+84>>2]|0);EQ(D,91928,E);ME(C,D,91936);WP(v,C)|0;VP(C);VP(D);VP(E);E=jc(qQ(v)|0,91944)|0;D=c[Q>>2]|0;c[f>>2]=qQ(v)|0;xv(D,(E|0)!=0|0,91952,f);f=xe[c[(c[l>>2]|0)+176>>2]&7]()|0;D=qQ(t)|0;Q=qQ(u)|0;C=qQ(p)|0;a=qQ(q)|0;O=qQ(r)|0;M=qQ(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;sd(E|0,f|0,e|0)|0;if((c[41148>>2]|0)==0){R=qd(E|0)|0;S=Xc(E|0)|0;VP(v);VP(u);VP(t);VP(s);VP(r);VP(q);VP(p);i=b;return 0}e=xe[c[(c[l>>2]|0)+176>>2]&7]()|0;l=qQ(t)|0;f=qQ(u)|0;M=qQ(p)|0;O=qQ(q)|0;a=qQ(r)|0;C=qQ(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;uv(25,0,e,d);R=qd(E|0)|0;S=Xc(E|0)|0;VP(v);VP(u);VP(t);VP(s);VP(r);VP(q);VP(p);i=b;return 0}function FM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=gR(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}GM(a,fR(l)|0,n,e);i=d;return}if((h&8|0)==0){KP(a,g);i=d;return}else{g=b;b=aR(g)|0;GM(a,b,cR(g)|0,f);i=d;return}}function GM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;HM(a,b,c,0);i=d;return}function HM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;IM(a,b,c);i=d;return}function IM(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=JM(c,d)|0;if(g>>>0>4294967279){HP(0)}if(g>>>0<11){$P(b,g);h=_P(b)|0}else{j=gQ(g)|0;k=j+1|0;j=wF(OP(b)|0,k)|0;iQ(b,j);hQ(b,k);ZP(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;xF(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){xF(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;xF(l,f);i=e;return}function JM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=KM(b,c,e)|0;i=d;return g|0}function KM(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function LM(a,b){a=a|0;b=b|0;var c=0;c=i;$M(a,b);i=c;return}function MM(a){a=a|0;var b=0;b=i;zM(a);g_(a);i=b;return}function NM(a){a=a|0;var b=0;b=i;zM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function OM(a){a=a|0;var b=0;b=i;MM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function PM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];QM(a+4|0);i=d;return}function QM(a){a=a|0;var b=0;b=i;RM(a);i=b;return}function RM(a){a=a|0;var b=0;b=i;c[a>>2]=92168;VP(a+32|0);WQ(a);i=b;return}function SM(a){a=a|0;var b=0;b=i;QM(a);g_(a);i=b;return}function TM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=gR(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){yA(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}yA(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=gR(l)|0;j=m-(fR(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=bR(l)|0;m=j-(aR(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(UP(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){yA(a,-1,-1);i=h;return}o=M_(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(UP(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((bR(l)|0)!=0){break}yA(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((gR(l)|0)!=0){break}yA(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=aR(l)|0;eR(l,q,q+o|0,n)}if((g&16|0)!=0){q=fR(l)|0;jR(l,q,hR(l)|0);iR(l,o)}yA(a,o,e);i=h;return}}while(0);yA(a,-1,-1);i=h;return}function UM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=MB(d)|0;me[g&31](a,b,h,J,0,e);i=f;return}function VM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=gR(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((cR(g)|0)>>>0<j>>>0){b=aR(g)|0;eR(g,b,bR(g)|0,j)}j=bR(g)|0;if(!(j>>>0<(cR(g)|0)>>>0)){k=-1;i=d;return k|0}k=iC(a[j]|0)|0;i=d;return k|0}function WM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=gR(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=aR(h)|0;j=bR(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(eC(d,-1)|0){eR(h,g,j+ -1|0,k);l=hC(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=fC(d)|0;do{if(g){if(jC(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=aR(h)|0;eR(h,j,(bR(h)|0)+ -1|0,k);a[bR(h)|0]=b;l=d;i=e;return l|0}function XM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(eC(b,-1)|0){f=hC(b)|0;i=d;return f|0}g=a;h=bR(g)|0;j=h-(aR(g)|0)|0;h=gR(g)|0;do{if((h|0)==(hR(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=fR(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;lQ(o,0);eQ(o,bQ(o)|0);p=UP(o)|0;jR(g,p,p+(TP(o)|0)|0);iR(g,h-l|0);c[m>>2]=(fR(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(gR(g)|0)+1;h=c[(YM(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=UP(a+32|0)|0;eR(g,q,q+j|0,h)}f=ZQ(g,b&255)|0;i=d;return f|0}function YM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=ZM(b,c,e)|0;i=d;return g|0}function ZM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=_M(0,a,b)|0;i=c;return(d?b:a)|0}function _M(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function $M(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;$Q(a);c[a>>2]=92168;JP(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;JP(e);aN(a,e);VP(e);i=d;return}function aN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;WP(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=UP(e)|0;j=g+(TP(e)|0)|0;c[b>>2]=j;g=UP(e)|0;eR(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=TP(e)|0;c[b>>2]=(UP(e)|0)+h;eQ(e,bQ(e)|0);b=a;a=UP(e)|0;jR(b,a,a+(TP(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}iR(b,h);i=d;return}function bN(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=jc(d|0,92592)|0;J=$c(92600,92592)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Rd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;xv(M,(I|0)!=0|0,92656,E);rc(92680,17,1,J|0)|0;rc(92704,10,1,J|0)|0;rc(92720,18,1,J|0)|0;cN(J,f,92744,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,92776)}else{c[G>>2]=Rd(c[L>>2]|0)|0;wv(26,0,92608,G);G=c[b+536>>2]|0;E=Rd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;xv(G,(I|0)!=0|0,92656,F)}rc(92784,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Rd(c[L>>2]|0)|0;wv(26,0,93136,D);Xc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(92336,250,93160,hd(H|0)|0)|0)==0){wv(26,0,93184,C);Xc(I|0)|0;O=1;i=j;return O|0}rc(93208,13,1,I|0)|0;rc(93224,12,1,I|0)|0;dN(I,2);rc(93240,6,1,I|0)|0;eN(I,c[b+84>>2]|0);rc(93248,8,1,I|0)|0;dN(I,2);rc(93264,8,1,I|0)|0;C=b+88|0;eN(I,c[C>>2]|0);rc(93280,10,1,I|0)|0;dN(I,2);rc(93296,6,1,I|0)|0;eN(I,92336);rc(93304,8,1,I|0)|0;dN(I,2);rc(93320,8,1,I|0)|0;eN(I,c[b+280>>2]|0);rc(93336,10,1,I|0)|0;dN(I,2);rc(93352,14,1,I|0)|0;eN(I,c[b+284>>2]|0);rc(93368,16,1,I|0)|0;dN(I,2);rc(93392,16,1,I|0)|0;eN(I,l);rc(93416,18,1,I|0)|0;dN(I,2);c[B>>2]=fN(l)|0;sd(I|0,93440,B|0)|0;dN(I,2);P=+Nw(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(I|0,93480,A|0)|0;dN(I,2);P=+Nw(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];sd(I|0,93520,z|0)|0;dN(I,2);P=+Nw(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(I|0,93552,y|0)|0;dN(I,2);P=+Nw(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(I|0,93584,x|0)|0;dN(I,2);P=+Nw(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(I|0,93616,w|0)|0;dN(I,2);P=+Nw(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(I|0,93648,v|0)|0;dN(I,2);P=+Nw(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(I|0,93688,u|0)|0;dN(I,2);P=+Qw(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];sd(I|0,93720,t|0)|0;dN(I,2);c[s>>2]=Lw(2)|0;sd(I|0,93760,s|0)|0;dN(I,2);P=+Pw(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];sd(I|0,93784,r|0)|0;rc(93816,13,1,I|0)|0;rc(93832,16,1,I|0)|0;dN(I,2);P=+Nw(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];sd(I|0,93856,q|0)|0;dN(I,2);c[p>>2]=Iw(8)|0;sd(I|0,93880,p|0)|0;rc(93920,17,1,I|0)|0;rc(93944,22,1,I|0)|0;gN(I,b);rc(93968,23,1,I|0)|0;rc(93992,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{hN(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{hN(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{hN(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{hN(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{hN(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{hN(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{hN(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{hN(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(94008,13,1,I|0)|0;rc(94024,12,1,I|0)|0;iN(I,J,f,c[C>>2]|0,b);rc(94040,13,1,I|0)|0;rc(94056,12,1,I|0)|0;jN(I,c[b+68>>2]|0,b+56|0);rc(94072,13,1,I|0)|0;rc(94088,16,1,I|0)|0;kN(I,J,f,b);rc(94112,17,1,I|0)|0;rc(94136,14,1,I|0)|0;Xc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((C_(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(C_(K|0)|0)<<1}else{Q=0}I=_Z(b+Q|0)|0;if((I|0)==0){cb(94152,94160,404,94184)}if((ab(J|0)|0)!=0){wv(26,0,94200,o)}if(e){e=c[C>>2]|0;c[n>>2]=94232;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;ic(I|0,94248,n|0)|0;if((nd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=94328|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;wv(1,0,94360,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;uv(1,0,94424,g);$Z(I);O=0;i=j;return O|0}function cN(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Jw(F)|0;H=Kw(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Pw(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(92680,17,1,a|0)|0;rc(95592,12,1,a|0)|0;rc(95608,12,1,a|0)|0;rc(95624,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;sd(a|0,95640,D|0)|0;rc(95680,10,1,a|0)|0;rc(95696,11,1,a|0)|0;rc(95712,11,1,a|0)|0;rc(95728,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];sd(a|0,95744,C|0)|0}else{rc(95768,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;sd(a|0,95368,B|0)|0;rc(95792,13,1,a|0)|0;if(E){rc(95608,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(a|0,95808,A|0)|0}else{rc(95768,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;sd(a|0,95832,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;sd(a|0,95488,y|0)|0;rc(95880,10,1,a|0)|0;rc(95896,10,1,a|0)|0;rc(95880,10,1,a|0)|0;rc(95912,11,1,a|0)|0;c[x>>2]=b;sd(a|0,95928,x|0)|0;c[w>>2]=d;sd(a|0,95952,w|0)|0;rc(95968,33,1,a|0)|0;rc(96008,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;sd(a|0,96048,v|0)|0;rc(95728,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(a|0,95744,u|0)|0}else{rc(95896,10,1,a|0)|0;rc(95880,10,1,a|0)|0;rc(95912,11,1,a|0)|0;c[t>>2]=b;sd(a|0,95928,t|0)|0;c[s>>2]=d;sd(a|0,95952,s|0)|0;rc(95968,33,1,a|0)|0;rc(96008,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;sd(a|0,96048,r|0)|0;rc(95728,10,1,a|0)|0;rc(95768,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;sd(a|0,95368,q|0)|0;rc(95792,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];sd(a|0,95808,p|0)|0}else{rc(95768,17,1,a|0)|0}rc(96080,32,1,a|0)|0;rc(96120,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;sd(a|0,96152,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;sd(a|0,95488,n|0)|0;i=m;return}function dN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Nd(32,a|0)|0;}while((d|0)!=0);i=c;return}function eN(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){rc(95344,4,1,b|0)|0}else if((e|0)==39){rc(95352,6,1,b|0)|0}else if((e|0)==34){rc(95360,6,1,b|0)|0}else if((e|0)==60){rc(95336,4,1,b|0)|0}else{Nd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function fN(a){a=a|0;var b=0,c=0,d=0;b=i;c=jc(a|0,95328)|0;if((c|0)==0){d=-1;i=b;return d|0}Vc(c|0,0,2)|0;a=yb(c|0)|0;Xc(c|0)|0;d=a;i=b;return d|0}function gN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=_Z((C_(l|0)|0)+15|0)|0;c[f>>2]=l;ic(m|0,95056,f|0)|0;dN(a,2);rc(95072,10,1,a|0)|0;eN(a,m);rc(95088,12,1,a|0)|0;dN(a,2);c[e>>2]=fN(m)|0;sd(a|0,95104,e|0)|0;$Z(m);dN(a,2);rc(95136,9,1,a|0)|0;dN(a,4);rc(95152,22,1,a|0)|0;dN(a,4);rc(95176,22,1,a|0)|0;dN(a,4);rc(95200,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){mN(g,m,n);o=c[l>>2]|0;dN(a,4);rc(95232,8,1,a|0)|0;eN(a,o);rc(95248,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{rN(h,m,l);g=c[n>>2]|0;dN(a,4);rc(95232,8,1,a|0)|0;eN(a,g);rc(95248,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{mN(j,m,q);b=c[t>>2]|0;dN(a,4);rc(95272,8,1,a|0)|0;eN(a,b);rc(95288,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){dN(a,2);v=95312;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{rN(k,m,s);e=c[u>>2]|0;dN(a,4);rc(95272,8,1,a|0)|0;eN(a,e);rc(95288,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));dN(a,2);v=95312;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function hN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;dN(a,2);c[f>>2]=c[b>>2];sd(a|0,94992,f|0)|0;eN(a,c[b+4>>2]|0);rc(95024,11,1,a|0)|0;eN(a,c[b+8>>2]|0);rc(94696,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];lN(a,4,e);dN(a,2);rc(95040,12,1,a|0)|0;i=d;return}function iN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{mN(p,r,v);cN(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,94808);w=v+9|0;Tw(w);dN(a,2);c[o>>2]=c[f>>2];sd(a|0,94816,o|0)|0;dN(a,4);rc(93240,6,1,a|0)|0;eN(a,c[s>>2]|0);rc(93248,8,1,a|0)|0;dN(a,4);c[n>>2]=Lw(w)|0;sd(a|0,94592,n|0)|0;dN(a,4);x=+Qw(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(a|0,94616,m|0)|0;dN(a,4);x=+Pw(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(a|0,93784,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];lN(a,6,j);dN(a,2);rc(94840,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function jN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{dN(a,2);qN(l,d,x);c[j>>2]=c[q>>2];sd(a|0,94664,j|0)|0;qN(m,d,x);eN(a,c[r>>2]|0);rc(94696,3,1,a|0)|0;dN(a,4);rc(94704,7,1,a|0)|0;qN(n,d,x);if((c[s>>2]|0)>0){y=0;do{dN(a,6);c[g>>2]=0;sd(a|0,94712,g|0)|0;y=y+1|0;qN(n,d,x);}while((y|0)<(c[s>>2]|0))}dN(a,4);rc(94736,8,1,a|0)|0;dN(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;qN(o,d,x);z=+Nw(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;qN(p,d,x);A=Iw(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;sd(a|0,94752,f|0)|0;dN(a,2);rc(94792,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function kN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{rN(n,o,v-u|0);cN(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,94544);q=v+9|0;Tw(q);dN(a,2);rc(94552,15,1,a|0)|0;dN(a,4);c[m>>2]=c[e>>2];sd(a|0,94568,m|0)|0;dN(a,4);c[l>>2]=Lw(q)|0;sd(a|0,94592,l|0)|0;dN(a,4);w=+Qw(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(a|0,94616,j|0)|0;dN(a,4);w=+Pw(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];sd(a|0,93784,g|0)|0;dN(a,2);rc(94640,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function lN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;dN(a,b);rc(94856,16,1,a|0)|0;eN(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?94960:94976;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;sd(a|0,94880,f|0)|0;i=e;return}function mN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){nN(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function nN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=jc(c[o>>2]|0,96192)|0;if((p|0)!=0){q=p;break}p=Rd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;yv(0,96200,g)}else{q=0}}while(0);g=oq(0)|0;if((g|0)==0){yv(0,96232,f)}f=a+8|0;c[a+20>>2]=a_(c[f>>2]|0,32)|0;p=a+12|0;o=a_((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=96264;c[o+12>>2]=0;c[o+16>>2]=0;zq(g,h);Aq(g,10,63);h=c[n>>2]|0;do{if((h|0)==0){o=j;G_(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Bq(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Jq(Gq(g)|0)|0;s=Hq(g)|0;Xc(q|0)|0;vq(g);r=c[a>>2]|0;c[e>>2]=96368;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;yv(0,96304,e)}else if((t|0)==11){Xc(q|0)|0;break}}else{if((Bq(g,h,C_(h|0)|0,1)|0)!=0){break}s=Jq(Gq(g)|0)|0;o=Hq(g)|0;vq(g);r=c[n>>2]|0;c[d>>2]=96368;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;yv(0,96408,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(96472,96368,295,96512)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(96536,96368,297,96512)}}function oN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((y_(96944,b)|0)==0){if((y_(c[d>>2]|0,96952)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}xv(0,p,96960,l);l=c[24200]|0;p=c[24254]|0;do{if((l|0)==0|(p|0)==0){c[24254]=32;a=_Z(1152)|0;c[24200]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[24254]=p<<1;a=b_(l,p*72|0)|0;c[24200]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(uN(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((y_(97024,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((y_(97032,u)|0)==0){c[24260]=vd(c[t+4>>2]|0)|0}else{if((y_(97064,u)|0)==0){c[97044>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((y_(97080,u)|0)==0){c[97052>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((y_(97088,u)|0)==0){c[97048>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((y_(97104,u)|0)==0){c[97056>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((y_(97112,u)|0)!=0){v=23;break a}c[97060>>2]=(y_(c[t+4>>2]|0,97128)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];yv(0,97136,k)}else if((v|0)==45){i=e;return}}if((y_(96784,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=96368;c[j+4>>2]=k;c[j+8>>2]=v;yv(0,97168,j)}if((y_(97232,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=96368;c[h+4>>2]=j;yv(0,97240,h)}h=Vb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=96368;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;yv(0,97296,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=97360;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((y_(96728,b)|0)!=0){if((y_(96920,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=97464;m=vd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=97472;i=e;return}c[96748>>2]=0;c[96752>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((y_(m,96952)|0)==0){c[96748>>2]=vd(c[b+4>>2]|0)|0}else{if((y_(m,97416)|0)!=0){break}c[96752>>2]=vd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[96748>>2]|0)==0){w=0;break}w=(c[96752>>2]|0)!=0|0}}while(0);xv(0,w,97424,f);c[24186]=-1;f=96756|0;w=97040;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function pN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((y_(96728,b)|0)==0){o=e+0|0;p=96744|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));tN(e);i=d;return}if((y_(96784,b)|0)==0){e=h+24|0;r=_Z((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=_Z(36)|0;t=s;o=s+0|0;p=(c[24200]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((y_(96808,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;wd(e+(k*20|0)+8|0,96816,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((y_(96856,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;wd(h+(k*20|0)+8|0,96872,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((y_(96920,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function qN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){nN(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function rN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){nN(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;yv(0,96576,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=96656;p=o;yv(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=96656;p=o;yv(0,p,f)}}function sN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){$Z(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){$Z(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}$Z(k);c[d>>2]=0;i=b;return}function tN(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=_Z(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=C_(f|0)|0;c[e+64>>2]=k;k=c[24234]|0;do{if((k|0)==0){c[24234]=e;c[e+44>>2]=0;l=_Z(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=_Z(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{G_(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[24234]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[24234]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=C_(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(C_(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 4:{B=o;C=y;D=19;break};case 5:{E=o;F=y;D=18;break};case 7:{G=o;H=y;D=16;break};case 6:{I=o;J=y;D=17;break};case 3:{K=o;L=x;M=y;D=20;break};case 1:{N=o;O=x;P=y;D=22;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;Q=z;D=13;break};case 8:{R=o;D=15;break};case 9:{S=o;D=14;break};case 10:{Q=o;D=13;break};case 2:{T=o;U=x;V=y;D=21;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+Q|0;c[p>>2]=o;S=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+S|0;c[p>>2]=o;R=o;D=15}if((D|0)==15){G=R;H=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){I=G;J=((d[A+6|0]|0)<<16)+H|0;D=17}if((D|0)==17){E=I;F=((d[A+5|0]|0)<<8)+J|0;D=18}if((D|0)==18){B=E;C=(d[A+4|0]|0)+F|0;D=19}if((D|0)==19){K=B;L=((d[A+3|0]|0)<<24)+x|0;M=C;D=20}if((D|0)==20){T=K;U=((d[A+2|0]|0)<<16)+L|0;V=M;D=21}if((D|0)==21){N=T;O=((d[A+1|0]|0)<<8)+U|0;P=V;D=22}if((D|0)==22){W=N;X=(d[A]|0)+O|0;Y=P}P=X-Y-W^W>>>13;X=Y-W-P^P<<8;Y=W-P-X^X>>>13;W=P-X-Y^Y>>>12;P=X-Y-W^W<<16;X=Y-W-P^P>>>5;Y=W-P-X^X>>>3;W=P-X-Y^Y<<10;P=X-Y-W^W>>>15;c[p>>2]=P;p=(c[24234]|0)+40|0;W=c[p>>2]|0;Y=P&(c[W+4>>2]|0)+ -1;P=c[W>>2]|0;W=P+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[P+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[24234]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[24234]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=_Z((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}G_(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;P=c[j>>2]|0;c[Y+24>>2]=(((P<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((P|0)==0){_=e}else{P=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=P}else{W=P;X=j;while(1){j=X+16|0;O=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];N=Z+(A*12|0)+4|0;D=(c[N>>2]|0)+1|0;c[N>>2]=D;V=c[W+24>>2]|0;if(D>>>0>V>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[N>>2]|0)>>>0)/(V>>>0)|0}c[X+12>>2]=0;V=Z+(A*12|0)|0;c[j>>2]=c[V>>2];j=c[V>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[V>>2]=X;V=c[h>>2]|0;if((O|0)==0){$=V;break}else{W=V;X=O}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){P=$;Y=W;e=X}else{_=W;break}}}$Z(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function uN(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[24234]|0)==0){f=24}else{g=C_(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(C_(a|0)|0)+s|0;switch(v|0){case 5:{x=h;y=u;f=11;break};case 4:{z=h;A=u;f=12;break};case 2:{B=h;C=t;D=u;f=14;break};case 7:{E=h;F=u;f=9;break};case 3:{G=h;H=t;I=u;f=13;break};case 8:{J=h;f=8;break};case 11:{K=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 10:{K=h;f=6;break};case 9:{L=h;f=7;break};case 6:{M=h;N=u;f=10;break};case 1:{O=h;P=t;Q=u;f=15;break};default:{R=h;S=t;T=u}}if((f|0)==6){L=((d[w+9|0]|0)<<16)+K|0;f=7}if((f|0)==7){J=((d[w+8|0]|0)<<8)+L|0;f=8}if((f|0)==8){E=J;F=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){M=E;N=((d[w+6|0]|0)<<16)+F|0;f=10}if((f|0)==10){x=M;y=((d[w+5|0]|0)<<8)+N|0;f=11}if((f|0)==11){z=x;A=(d[w+4|0]|0)+y|0;f=12}if((f|0)==12){G=z;H=((d[w+3|0]|0)<<24)+t|0;I=A;f=13}if((f|0)==13){B=G;C=((d[w+2|0]|0)<<16)+H|0;D=I;f=14}if((f|0)==14){O=B;P=((d[w+1|0]|0)<<8)+C|0;Q=D;f=15}if((f|0)==15){R=O;S=(d[w]|0)+P|0;T=Q}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[24234]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=C_(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((x_(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,97496)|0)==0){V=0;break}else{W=97520}i=b;return W|0}}while(0);c[e>>2]=a;xv(0,(V|0)!=0|0,97568,e);W=V+4|0;i=b;return W|0}function vN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((wN(97624,a,b)|0)!=0){d=1;i=c;return d|0}d=(wN(97632,a,b)|0)!=0|0;i=c;return d|0}function wN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((y_(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function xN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(y_(c[46204>>2]|0,97640)|0)==0|0;xv(0,m,97656,l);l=(y_(c[48108>>2]|0,97640)|0)==0|0;xv(0,l,97712,k);k=(y_(c[50100>>2]|0,97640)|0)==0|0;xv(0,k,97768,j);j=97832|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=97960|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[50104+(k<<2)>>2]|0;if((l|0)==1){if((wN(c[46080+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[46080+(k<<2)>>2]|0;if(!((wN(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[46080+(k<<2)>>2]|0;if((zN(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=97832+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=97832+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[97960+(k<<2)>>2]=yN(r,p)|0;t=j}else if((q|0)==13){q=0;l=97832+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[97960+(k<<2)>>2]=AN(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];wv(1,0,98088,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];wv(1,0,98088,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];wv(1,0,98088,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];wv(1,0,98144,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function yN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((y_(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function zN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(AN(a,b)|0)!=0|0;i=c;return d|0}function AN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=C_(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((z_(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function BN(){i=i;return}function CN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(98176,5,1,e|0)|0;f=b;b=0;while(1){Nd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(98184,20,1,e|0)|0;vc(0);return 0}function DN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;sd(d|0,98208,e|0)|0;if((b|0)==0){vc(1)}else{qd(d|0)|0;LN();qd(d|0)|0;ib(6,0)|0;ed()}}function EN(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function FN(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function GN(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function HN(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function IN(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function JN(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}G_(p|0,32,b+(d-p)|0)|0;i=f;return}function KN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=99248+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[99292+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[99288+(e*48|0)>>2]|0)==1){MN(b)|0}k=99252+(e*48|0)|0;if((c[k>>2]|0)==0){break}Xc(c[f>>2]|0)|0;$Z(c[k>>2]|0)}}while(0);do{if((h|0)==10){Xc(g|0)|0;b=99252+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Ed(k|0)|0;$Z(c[b>>2]|0)}}while(0);c[f>>2]=0}c[99284+(e*48|0)>>2]=0;c[99252+(e*48|0)>>2]=0;i=d;return 0}function LN(){var a=0,b=0;a=i;if((c[24554]|0)!=0){i=a;return}c[24554]=1;c[98224>>2]=0;b=0;do{c[98220>>2]=b;KN(98216)|0;b=b+1|0;}while((b|0)<100);i=a;return}function MN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[99264+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=99248+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Vc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[99268+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[99276+(d*48|0)>>2]&2|0)!=0){qd(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Vc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){ON(111,98232);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function NN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function ON(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;sd(m|0,99144,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;sd(m|0,99176,j|0)|0;l=m;break}else{n=c[99016+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;sd(m|0,99200,h|0)|0;l=m;break}}}while(0);h=c[24802]|0;do{if((h|0)==0){rc(104080,29,1,l|0)|0}else{c[g>>2]=(h-99248|0)/48|0;sd(l|0,99216,g|0)|0;b=c[(c[24802]|0)+4>>2]|0;if((b|0)==0){rc(104064,10,1,l|0)|0;break}else{c[f>>2]=b;sd(l|0,104048,f|0)|0;break}}}while(0);f=c[26028]|0;if((f|0)!=0){c[d>>2]=f;sd(l|0,104120,d|0)|0}d=(c[26048]|0)!=0?104200:104216;f=(c[26056]|0)!=0?104232:104248;g=(c[26066]|0)!=0?104272:104288;c[e>>2]=(c[26042]|0)!=0?104176:104184;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;sd(l|0,104144,e|0)|0;DN(104304,1)}function PN(){var a=0,b=0;a=i;c[26078]=1;b=c[r>>2]|0;c[24812]=b;c[99268>>2]=NN(b)|0;c[99272>>2]=1;c[99288>>2]=1;b=c[s>>2]|0;c[99488>>2]=b;c[99508>>2]=NN(b)|0;c[99512>>2]=1;c[99528>>2]=0;b=c[t>>2]|0;c[99536>>2]=b;c[99556>>2]=NN(b)|0;c[99560>>2]=1;c[99576>>2]=1;i=a;return}function QN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[109560+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[26080]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[109560+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[26080]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Vc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Vc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function RN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){ON(b,d)}d=c[26082]|0;if((d|0)!=0){xe[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function SN(a){a=a|0;var b=0,d=0;b=i;c[26112]=0;c[26114]=0;c[26116]=0;d=((TN(a,0)|0)==0)<<31>>31;i=b;return d|0}function TN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[26116]|0;c[26116]=j+1;if((j|0)==1){c[26114]=d}if((YN(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=ZN(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function UN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[26112]|0;l=104472+(k<<4)|0;m=c[l>>2]|0;switch(VN(m)|0){case 21:{c[26090]=0;c[26112]=k+1;continue b;break};case 1:{n=c[104476+(k<<4)>>2]|0;o=(c[27344]|0)+1|0;c[27344]=o;c[109384+(o<<2)>>2]=n;c[26112]=k+1;continue b;break};case 19:case 17:{c[26088]=0;c[26112]=k+1;continue b;break};case 6:{n=c[104476+(k<<4)>>2]|0;o=(c[27328]|0)+1|0;c[27328]=o;c[109320+(o<<2)>>2]=n;c[26112]=k+1;continue b;break};case 33:{c[27356]=1;c[26112]=k+1;continue b;break};case 18:{c[26088]=1;c[26112]=k+1;continue b;break};case 9:{n=(de[c[26096]&127](l)|0)==0;c[26112]=(c[26112]|0)+1;if(n){break b}else{continue b}break};case 3:{n=c[27328]|0;o=109320+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[27328]=n+ -1;c[27344]=(c[27344]|0)+ -1;c[26112]=k+1;continue b}else{n=c[27344]|0;c[27344]=n+ -1;c[26112]=(c[109384+(n<<2)>>2]|0)+1;continue b}break};case 16:{if(b){q=28;break a}c[26112]=k+1;continue b;break};case 2:{c[27328]=0;c[27344]=0;c[26112]=c[104476+(k<<4)>>2];if(b){q=24;break a}if((c[27340]|0)==0){j=0;q=37;break a}n=xe[c[26098]&7]()|0;if((n|0)==0){continue b}else{j=n;q=37;break a}break};case 22:{c[26090]=1;c[26112]=k+1;continue b;break};case 20:{c[26108]=c[104476+(k<<4)>>2];c[26112]=k+1;continue b;break};case 8:{n=c[27328]|0;s=109320+(n<<2)|0;t=c[s>>2]|0;if((t|0)>=1){q=10;break b}c[27328]=n+ -1;c[26112]=k+1;continue b;break};default:{q=4;break a}}}if((q|0)==10){q=0;if(b){q=11;break}c[s>>2]=t+ -1;c[27340]=1;k=ge[c[26094]&63](l,g,d)|0;if((k|0)>0){q=13;break}if((k|0)<0){q=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;q=37;break}}if((q|0)==4){h=c[r>>2]|0;d=c[26028]|0;c[f>>2]=m;c[f+4>>2]=d;sd(h|0,109272,f|0)|0;if((c[c[26084]>>2]|0)==0){ON(100,109304);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((q|0)==11){j=xe[c[26082]&7]()|0;i=e;return j|0}else if((q|0)==13){f=c[c[26084]>>2]|0;j=RN(f,c[(Nc()|0)>>2]|0,109368)|0;i=e;return j|0}else if((q|0)==15){if((c[(c[26084]|0)+8>>2]|0)==0){ON(-1,109368);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((q|0)==24){j=xe[c[26082]&7]()|0;i=e;return j|0}else if((q|0)==28){j=xe[c[26082]&7]()|0;i=e;return j|0}else if((q|0)==37){i=e;return j|0}return 0}function VN(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function WN(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=UN(b,0,0)|0;i=a;return d|0}function XN(){c[26104]=0;c[26112]=0;c[27344]=0;c[27328]=0;c[27340]=0;c[27346]=0;c[27330]=0;i=i;return}function YN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[26112]|0;if((g|0)>299){rc(109448,24,1,c[r>>2]|0)|0;DN(c[26028]|0,1)}else{c[104472+(g<<4)>>2]=a;c[104476+(g<<4)>>2]=b;c[104480+(g<<4)>>2]=d;c[104484+(g<<4)>>2]=e;c[26112]=g+1;i=f;return g|0}return 0}function ZN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=_N(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[26116]|0)+ -1|0;c[26116]=h;if((h|0)==0){YN(2,c[26114]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{YN(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function _N(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if(($N(b,e)|0)!=0){g=c[e>>2]|0;break}if((aO(b,e)|0)!=0){g=c[e>>2]|0;break}h=bO(b,f,1)|0;j=YN(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=TN(h,j)|0}}while(0);i=d;return g|0}function $N(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 112:case 80:{YN(20,1,0,0)|0;g=b;h=30;break};case 43:{j=0;h=13;break};case 39:case 34:case 2:{c[104480+((YN(11,0,0,0)|0)<<4)>>2]=b;k=cO(b)|0;c[d>>2]=k;l=(k|0)!=0|0;i=e;return l|0};case 98:case 66:{k=b+1|0;m=a[k]|0;if(m<<24>>24==90|m<<24>>24==122){YN(22,0,0,0)|0;g=k;h=30;break a}else{YN(21,0,0,0)|0;g=k;h=30;break a}break};case 116:case 84:{k=b+1|0;m=a[k]|0;if(m<<24>>24==82|m<<24>>24==114){n=k;o=14}else if(m<<24>>24==76|m<<24>>24==108){n=k;o=13}else{n=b;o=15}k=bO(n+1|0,f,0)|0;if((k|0)==0){h=15;break a}YN(o,c[f>>2]|0,0,0)|0;g=k+ -1|0;h=30;break};case 45:{j=1;h=13;break};case 47:{YN(5,0,0,0)|0;g=b;h=30;break};case 120:case 88:{YN(4,1,0,0)|0;g=b;h=30;break};case 36:{YN(33,0,0,0)|0;g=b;h=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;h=14;break};case 58:{YN(16,0,0,0)|0;g=b;h=30;break};case 115:case 83:{k=b+1|0;m=a[k]|0;if(m<<24>>24==83|m<<24>>24==115){r=k;s=19}else if(m<<24>>24==80|m<<24>>24==112){r=k;s=18}else{r=b;s=17}YN(s,0,0,0)|0;g=r;h=30;break};default:{l=0;i=e;return l|0}}}while(0);if((h|0)==13){p=b+1|0;q=j;h=14}b:do{if((h|0)==14){j=bO(p,f,0)|0;if((j|0)==0){h=15;break}switch(a[j]|0){case 104:case 72:{b=c[f>>2]|0;c[104480+((YN(12,b,0,0)|0)<<4)>>2]=j+1;g=j+b|0;h=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}YN(20,t,0,0)|0;g=j;h=30;break b;break};case 120:case 88:{YN(4,c[f>>2]|0,0,0)|0;g=j;h=30;break b;break};default:{l=0;i=e;return l|0}}}}while(0);if((h|0)==15){c[d>>2]=0;l=1;i=e;return l|0}else if((h|0)==30){c[d>>2]=g+1;l=1;i=e;return l|0}return 0}function aO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=bO(b,f,1)|0;YN(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 122:case 90:{l=35;m=36;n=38;break};case 103:case 71:{o=0;n=3;break};case 97:case 65:{p=f;while(1){q=a[p]|0;if(q<<24>>24==32){p=p+1|0}else{break}}if(!((q+ -48<<24>>24&255)<10)){YN(30,0,0,0)|0;r=p;n=45;break a}s=bO(p,g,1)|0;t=c[g>>2]|0;if((t|0)==0){r=s;n=45;break a}YN(31,t,0,0)|0;r=s;n=45;break};case 101:case 69:{o=1;n=3;break};case 102:case 70:{s=bO(f,g,0)|0;if((s|0)==0){n=4;break a}t=c[g>>2]|0;if((t|0)==0){r=s;n=45;break a}if((a[s]|0)==46){u=bO(s+1|0,h,0)|0;if((u|0)==0){n=4;break a}v=u;w=c[h>>2]|0}else{c[h>>2]=0;v=s;w=0}YN(23,t,w,0)|0;r=v;n=45;break};case 105:case 73:{l=7;m=10;n=38;break};case 108:case 76:{t=bO(f,g,0)|0;if((t|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){r=t;n=45;break a}YN(29,s,0,0)|0;r=t;n=45;break};case 111:case 79:{l=32;m=34;n=38;break};case 100:case 68:{t=bO(f,g,0)|0;if((t|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){r=t;n=45;break a}if((a[t]|0)==46){u=bO(t+1|0,h,0)|0;if((u|0)==0){n=4;break a}x=u;y=c[h>>2]|0}else{c[h>>2]=0;x=t;y=0}YN(26,s,y,0)|0;r=x;n=45;break};default:{c[26112]=(c[26112]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=bO(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){v=bO(b+1|0,h,0)|0;if((v|0)==0){n=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){YN((o|0)==1?24:27,x,c[h>>2]|0,0)|0;r=A;n=45;break}y=bO(A+1|0,j,0)|0;if((y|0)==0){n=4;break}YN((o|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;r=y;n=45}else if((n|0)==38){y=bO(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=y;n=45;break}if((a[y]|0)!=46){YN(l,x,0,0)|0;r=y;n=45;break}b=bO(y+1|0,h,0)|0;if((b|0)==0){n=4;break}YN(m,x,c[h>>2]|0,0)|0;r=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=r;z=1;i=e;return z|0}return 0}function bO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function cO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[26084]>>2]|0)==0){ON(100,109432);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function dO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[109502|0]=48;k=109502|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=109480+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function eO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[26106]|0;f=c[26102]|0;if((e|0)>(f|0)){c[26102]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[27394]|0)){h=g}else{fO(f,g);h=c[26102]|0}g=c[27396]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Fd(g|0,c[26080]|0)|0;h=C_(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Nd(a[k]|0,c[26080]|0)|0;Fd(h|0,c[26080]|0)|0;b=C_(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function fO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[27396]|0;if((f|0)==109664){c[27394]=1024;g=1024}else{g=c[27394]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[27394]=j;h=j}j=_Z(h)|0;if((j|0)==0){ON(113,110064);k=c[27396]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[27396]|0}else{l=k}if((l|0)==109664){m=109584;c[27396]=j;i=e;return}$Z(l);m=109584;c[27396]=j;i=e;return}function gO(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[26102]|0;f=c[27394]|0;if((e|0)<(f|0)){g=e}else{fO(e,f);g=c[26102]|0}c[26102]=g+1;a[(c[27396]|0)+g|0]=b;i=d;return}function hO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[26066]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){ON(101,109592);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[26078]|0)==0){PN();m=c[f>>2]|0}else{m=k}k=99248+(m*48|0)|0;c[24802]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){mO(k,c[b+12>>2]|0,j);o=nO(j,h)|0;if((o|0)==(c[99256+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[99260+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=KN(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[99280+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=99264+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[99280+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=99272+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[99272+(m*48|0)>>2]=1;r=1;break}else{c[99272+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];ic(j|0,109600,e|0)|0}else{mO(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){iO(107,109592,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=99292+(m*48|0)|0;c[q>>2]=0;c[99284+(m*48|0)>>2]=0;e=99288+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=99276+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 82:case 114:{break};case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){iO(128,109592,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){iO(s,109592,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Lb()|0;c[n>>2]=s;if((s|0)!=0){c[99252+(m*48|0)>>2]=0;c[99260+(m*48|0)>>2]=-1;c[99256+(m*48|0)>>2]=-1;c[99268+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){iO(o,109592,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=jc(j|0,c[27390]|0)|0;if((o|0)==0){break}Xc(o|0)|0}}while(0);q=_Z((C_(j|0)|0)+1|0)|0;c[99252+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){iO(113,109616,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}I_(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=jc(j|0,c[109560+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=jc(j|0,c[109520+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=jc(j|0,c[109560+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){ON(o,109592);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=99268+(m*48|0)|0;c[r>>2]=NN(u)|0;u=nO(j,99260+(m*48|0)|0)|0;c[99256+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){iO(108,109592,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Vc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){iO(129,109592,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function iO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){ON(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[27394]|0)){j=d;k=g}else{fO(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[27396]|0;c[(c[24802]|0)+4>>2]=f;mO(k,j,f);ON(a,b);i=e;return}function jO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;ic(j|0,109600,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=C_(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?109632:109640;c[h+24>>2]=(b|0)==5?109648:109656;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=hO(h)|0;i=e;return a|0}function kO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=99248+(d*48|0)|0;c[24802]=e;if(d>>>0>99){if((c[a>>2]|0)==0){ON(101,110080);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((jO(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){ON(114,110088);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[99272+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){ON(102,110088);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function lO(){var a=0,b=0;a=i;b=WN()|0;c[26028]=0;i=a;return b|0}function mO(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function nO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((mc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function oO(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[26108]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[26088]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ic(p|0,110096,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(C_(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;ae[c[26092]&255](32);}while((A|0)>0)}if((D|0)!=0){ae[c[26092]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{ae[c[26092]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[26108]|0);ic(A|0,110104,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;ae[c[26092]&255](32);}while((z|0)>0)}if((x|0)!=0){ae[c[26092]&255]((w|0)!=0?45:43)}z=c[26108]|0;do{if((z|0)<1){ae[c[26092]&255](46);y=c[26092]|0;if((z|0)<0){G=y;J=z;while(1){ae[G&255](48);I=J+1|0;K=c[26092]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}ae[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}ae[c[26092]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[26092]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){ae[P&255](a[J]|0);R=Q+ -1|0;S=c[26092]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}ae[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;ae[c[26092]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){ae[c[26092]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;ae[c[26092]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){ae[c[26092]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;ae[c[26092]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;ae[c[26092]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;ae[c[26092]&255](42);}while((_|0)>0);i=l;return 0}function pO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[26108]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(ic(n|0,110112,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[26088]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;ae[c[26092]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;ae[c[26092]&255](32);}while((b|0)>0)}do{if(q){if((c[26088]|0)==0){break}ae[c[26092]&255](43)}else{ae[c[26092]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;ae[c[26092]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;ae[c[26092]&255](48);}while((z|0)>0);i=j;return 0}function qO(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{ae[c[26092]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[26092]|0;if((h|0)==0){ae[d&255](70);i=g;return 0}else{ae[d&255](84);i=g;return 0}return 0}function rO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[26104]|0)!=0){g=sO()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 28:case 27:{h=xO(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 31:{wO(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 23:{h=pO(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 10:{uO(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 32:{tO(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 34:{uO(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 36:{yO(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 30:{vO(b,d);h=0;i=e;return h|0};case 29:{qO(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 25:case 24:case 26:{h=oO(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 7:{tO(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 35:{yO(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;sd(h|0,110120,f|0)|0;DN(c[26028]|0,1)}}return 0}function sO(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[26104]|0;c[26104]=0;if((c[26066]|0)!=0){if((b|0)>0){d=c[26106]|0;e=c[26102]|0;if((d|0)<=(e|0)){f=b;while(1){ae[c[26092]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[26102]=f;h=0;i=a;return h|0}f=b-d+e|0;c[26102]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){ae[c[26092]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[26102]|0;f=j+b|0;if((f|0)>=0){if((c[26106]|0)<(j|0)){c[26106]=j}c[26102]=f;h=0;i=a;return h|0}if((c[c[26084]>>2]|0)==0){ON(110,110208);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[26102]|0;if((c[26106]|0)<(f|0)){c[26106]=f}j=f+b|0;c[26102]=j;c[26110]=(c[26110]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[26084]>>2]|0)==0){ON(110,110208);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[26102]|0;f=j+b|0;if((f|0)>=(c[(c[26086]|0)+16>>2]|0)){if((c[c[26084]>>2]|0)==0){ON(110,110224);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[26106]|0;if((d|0)<=(j|0)){e=b;while(1){ae[c[26092]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[26110]=(c[26110]|0)+b;c[26102]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[26110]=(c[26110]|0)+f;c[26102]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){ae[c[26092]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function tO(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=dO(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[26088]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{ae[c[26092]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{ae[c[26092]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[26088]|0)==0){break}ae[c[26092]&255](43)}else{ae[c[26092]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){ae[c[26092]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function uO(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=dO(m,k,l,h)|0;h=c[l>>2]|0;g=(c[26088]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{ae[c[26092]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{ae[c[26092]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[26088]|0)==0){break}ae[c[26092]&255](43)}else{ae[c[26092]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){ae[c[26092]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){ae[c[26092]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{ae[c[26092]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function vO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;ae[c[26092]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function wO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;ae[c[26092]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;ae[c[26092]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function xO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=oO(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=oO(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[26108]|0;c[26108]=0;p=(e|0)==0?4:e+2|0;e=pO(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{ae[c[26092]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[26108]=o;n=e;i=j;return n|0}function yO(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{ae[c[26092]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;ae[c[26092]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;ae[c[26092]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){ae[c[26092]&255](a[110184+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){ae[c[26092]&255](a[110184+((d[p]|0)>>>4)|0]|0);ae[c[26092]&255](a[110184+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function zO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 12:{f=BO(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 15:{c[26104]=(c[a+4>>2]|0)+ -1-(c[26102]|0);f=1;i=b;return f|0};case 13:{g=(c[26104]|0)-(c[a+4>>2]|0)|0;h=0-(c[26102]|0)|0;c[26104]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 11:{f=AO(c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[26104]=(c[26104]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 5:{f=xe[c[26100]&7]()|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;sd(f|0,110152,d|0)|0;DN(c[26028]|0,1)}}return 0}function AO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[26104]|0)!=0){e=sO()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}ae[c[26092]&255](e<<24>>24);n=b}else{ae[c[26092]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function BO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[26104]|0)!=0){f=sO()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;ae[c[26092]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function CO(){var a=0,b=0;a=i;b=eO(10)|0;c[26104]=0;c[26102]=0;c[26106]=0;i=a;return(b|0)==0|0}function DO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[26078]|0)==0){PN()}c[26042]=0;c[26048]=1;c[26056]=1;c[26066]=1;d=kO(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[26084]=a;c[26102]=0;c[26104]=0;c[26106]=0;c[27356]=0;c[26108]=0;d=c[a+12>>2]|0;c[26028]=d;c[26080]=c[c[24802]>>2];if((SN(d)|0)<0){if((c[a>>2]|0)==0){ON(100,110232);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[26092]=217;c[26094]=44;c[26096]=111;c[26082]=4;c[26098]=5;c[26100]=6;XN();c[26088]=0;d=c[24802]|0;c[26090]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((QN(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){ON(f,110240);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function EO(){var a=0,b=0;a=i;if((c[27356]|0)==0){b=eO(10)|0}else{eO(0)|0;qd(c[26080]|0)|0;b=0}c[26104]=0;c[26102]=0;c[26106]=0;i=a;return b|0}function FO(){var a=0,b=0,d=0;a=i;if((c[27340]|0)==0){b=0}else{d=eO(10)|0;c[27340]=0;b=d}c[26104]=0;c[26102]=0;c[26106]=0;i=a;return b|0}function GO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;aP(110968,h,111024);c[27564]=112476;c[110264>>2]=112496;c[110260>>2]=0;TQ(110264|0,110968);c[110336>>2]=0;c[110340>>2]=-1;j=c[t>>2]|0;c[27768]=112344;BW(111076|0);k=111080|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[27768]=111584;c[111104>>2]=j;CW(g,111076|0);k=FW(g,115136)|0;l=k;DW(g);c[111108>>2]=l;c[111112>>2]=111032;a[111116|0]=(de[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[27586]=112556;c[110348>>2]=112576;TQ(110348|0,111072);c[110420>>2]=0;c[110424>>2]=-1;l=c[r>>2]|0;c[27780]=112344;BW(111124|0);k=111128|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[27780]=111584;c[111152>>2]=l;CW(f,111124|0);k=FW(f,115136)|0;g=k;DW(f);c[111156>>2]=g;c[111160>>2]=111040;a[111164|0]=(de[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[27608]=112556;c[110436>>2]=112576;TQ(110436|0,111120);c[110508>>2]=0;c[110512>>2]=-1;g=c[(c[(c[27608]|0)+ -12>>2]|0)+110456>>2]|0;c[27630]=112556;c[110524>>2]=112576;TQ(110524|0,g);c[110596>>2]=0;c[110600>>2]=-1;c[(c[(c[27564]|0)+ -12>>2]|0)+110328>>2]=110344;g=(c[(c[27608]|0)+ -12>>2]|0)+110436|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[27608]|0)+ -12>>2]|0)+110504>>2]=110344;OO(111168,h,111048|0);c[27652]=112516;c[110616>>2]=112536;c[110612>>2]=0;TQ(110616|0,111168);c[110688>>2]=0;c[110692>>2]=-1;c[27806]=112408;BW(111228|0);h=111232|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[27806]=111328;c[111256>>2]=j;CW(e,111228|0);j=FW(e,115144)|0;h=j;DW(e);c[111260>>2]=h;c[111264>>2]=111056;a[111268|0]=(de[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[27674]=112596;c[110700>>2]=112616;TQ(110700|0,111224);c[110772>>2]=0;c[110776>>2]=-1;c[27818]=112408;BW(111276|0);h=111280|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[27818]=111328;c[111304>>2]=l;CW(d,111276|0);l=FW(d,115144)|0;h=l;DW(d);c[111308>>2]=h;c[111312>>2]=111064;a[111316|0]=(de[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[27696]=112596;c[110788>>2]=112616;TQ(110788|0,111272);c[110860>>2]=0;c[110864>>2]=-1;h=c[(c[(c[27696]|0)+ -12>>2]|0)+110808>>2]|0;c[27718]=112596;c[110876>>2]=112616;TQ(110876|0,h);c[110948>>2]=0;c[110952>>2]=-1;c[(c[(c[27652]|0)+ -12>>2]|0)+110680>>2]=110696;h=(c[(c[27696]|0)+ -12>>2]|0)+110788|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[27696]|0)+ -12>>2]|0)+110856>>2]=110696;i=b;return}function HO(a){a=a|0;a=i;RR(110344)|0;RR(110520)|0;YR(110696)|0;YR(110872)|0;i=a;return}function IO(a){a=a|0;var b=0;b=i;c[a>>2]=112408;DW(a+4|0);i=b;return}function JO(a){a=a|0;var b=0;b=i;c[a>>2]=112408;DW(a+4|0);g_(a);i=b;return}function KO(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=FW(d,115144)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(de[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function LO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=te[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function MO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((se[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function NO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Be[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function OO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=112408;j=b+4|0;BW(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=111440;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;CW(g,j);j=FW(g,115144)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=de[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(de[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){NV(111536)}else{DW(g);i=f;return}}function PO(a){a=a|0;var b=0;b=i;c[a>>2]=112408;DW(a+4|0);i=b;return}function QO(a){a=a|0;var b=0;b=i;c[a>>2]=112408;DW(a+4|0);g_(a);i=b;return}function RO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=FW(d,115144)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=de[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(de[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){NV(111536)}else{i=e;return}}function SO(a){a=a|0;var b=0,c=0;b=i;c=VO(a,0)|0;i=b;return c|0}function TO(a){a=a|0;var b=0,c=0;b=i;c=VO(a,1)|0;i=b;return c|0}function UO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Be[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((md(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}



function lh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Vg(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function mh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];ah(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[22536]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=7728;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];De[d&31](b,f,4848,g);}Vg(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function nh(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function oh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;ph(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function ph(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;sw(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(yw(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(yw(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(yw(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(yw(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(yw(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(yw(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(yw(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(yw(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(yw(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(yw(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(yw(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(yw(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(yw(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(yw(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(yw(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(yw(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(yw(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(yw(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(yw(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(yw(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(yw(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(yw(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(yw(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(yw(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(yw(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(yw(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(yw(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(yw(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(yw(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(yw(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(yw(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(yw(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(yw(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(yw(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(yw(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(yw(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(yw(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(yw(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(yw(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(yw(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(yw(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(yw(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(yw(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(yw(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(yw(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(yw(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(yw(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(yw(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(yw(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(yw(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(yw(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(yw(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(yw(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(yw(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(yw(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(yw(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(yw(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(yw(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(yw(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(yw(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(yw(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(yw(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(yw(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(yw(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(yw(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(yw(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(yw(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(yw(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(yw(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(yw(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(yw(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(yw(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(yw(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(yw(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(yw(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(yw(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(yw(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(yw(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(yw(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(yw(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(yw(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(yw(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(yw(Xf,1,se)|0)>>3];c[re>>2]=31;h[(yw(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(yw(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(yw(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(yw(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(yw(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(yw(Xf,1,me)|0)>>3];c[le>>2]=34;h[(yw(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(yw(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(yw(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(yw(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(yw(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(yw(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(yw(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(yw(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(yw(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(yw(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(yw(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(yw(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(yw(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(yw(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(yw(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(yw(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(yw(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(yw(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(yw(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(yw(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(yw(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(yw(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(yw(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(yw(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(yw(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(yw(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(yw(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(yw(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(yw(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(yw(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(yw(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(yw(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(yw(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(yw(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(yw(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(yw(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(yw(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(yw(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(yw(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(yw(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(yw(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(yw(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(yw(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(yw(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(yw(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(yw(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(yw(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(yw(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(yw(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(yw(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function qh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0;e=i;i=i+88|0;f=e;ph(f,b,c,d);h[a>>3]=c/(+h[f+16>>3]*+h[f+24>>3]*+h[f+48>>3]*d);i=e;return}function rh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;sw(g,1,f);f=g;g=4648;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;sw(j,1,e);e=j;j=4664;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((bh(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+qw(4648,j);t=s+d*+W(+k,+(+qw(4664,j)));j=r+1|0;if((bh(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function sh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var f=0;e=i;i=i+88|0;f=e;th(f,b,c,d);h[a>>3]=+h[f+16>>3]*+h[f+32>>3]*+h[f+64>>3]*d;i=e;return}function th(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0.0,Zf=0.0,_f=0.0,$f=0.0;f=i;i=i+5472|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+16|0;c[Wf>>2]=55;sw(Xf,1,Wf);Yf=540.0/e+-.5;c[Vf>>2]=1;h[(yw(Xf,1,Vf)|0)>>3]=Yf*Yf;c[Uf>>2]=1;Zf=Yf*+h[(yw(Xf,1,Uf)|0)>>3];c[Tf>>2]=2;h[(yw(Xf,1,Tf)|0)>>3]=Zf;c[Sf>>2]=2;Zf=+h[(yw(Xf,1,Sf)|0)>>3]*-.05032527872793;c[Rf>>2]=3;h[(yw(Xf,1,Rf)|0)>>3]=Zf;c[Qf>>2]=3;Zf=+h[(yw(Xf,1,Qf)|0)>>3]+-.057581259083432;c[Pf>>2]=4;h[(yw(Xf,1,Pf)|0)>>3]=Zf;c[Of>>2]=4;Zf=Yf*+h[(yw(Xf,1,Of)|0)>>3];c[Nf>>2]=5;h[(yw(Xf,1,Nf)|0)>>3]=Zf;c[Mf>>2]=5;Zf=+h[(yw(Xf,1,Mf)|0)>>3]+-.045996013696365;c[Lf>>2]=6;h[(yw(Xf,1,Lf)|0)>>3]=Zf;c[Kf>>2]=6;Zf=Yf*+h[(yw(Xf,1,Kf)|0)>>3];c[Jf>>2]=7;h[(yw(Xf,1,Jf)|0)>>3]=Zf;c[If>>2]=7;Zf=+h[(yw(Xf,1,If)|0)>>3]+-.017834862292358;c[Hf>>2]=8;h[(yw(Xf,1,Hf)|0)>>3]=Zf;c[Gf>>2]=8;Zf=Yf*+h[(yw(Xf,1,Gf)|0)>>3];c[Ff>>2]=9;h[(yw(Xf,1,Ff)|0)>>3]=Zf;c[Ef>>2]=1;Zf=+h[(yw(Xf,1,Ef)|0)>>3];c[Df>>2]=10;h[(yw(Xf,1,Df)|0)>>3]=Zf*Zf;c[Cf>>2]=10;Zf=+h[(yw(Xf,1,Cf)|0)>>3];c[Bf>>2]=11;h[(yw(Xf,1,Bf)|0)>>3]=Zf*Zf;c[Af>>2]=11;Zf=+h[(yw(Xf,1,Af)|0)>>3];c[zf>>2]=12;h[(yw(Xf,1,zf)|0)>>3]=Zf*Zf;c[yf>>2]=10;Zf=+h[(yw(Xf,1,yf)|0)>>3];c[xf>>2]=11;_f=+h[(yw(Xf,1,xf)|0)>>3];c[wf>>2]=12;$f=Zf*_f*Yf*+h[(yw(Xf,1,wf)|0)>>3];c[vf>>2]=13;h[(yw(Xf,1,vf)|0)>>3]=$f;c[uf>>2]=1;$f=+h[(yw(Xf,1,uf)|0)>>3];c[tf>>2]=10;_f=$f*Yf*+h[(yw(Xf,1,tf)|0)>>3];c[sf>>2]=14;h[(yw(Xf,1,sf)|0)>>3]=_f;c[rf>>2]=10;_f=+h[(yw(Xf,1,rf)|0)>>3];c[qf>>2]=11;$f=_f*Yf*+h[(yw(Xf,1,qf)|0)>>3];c[pf>>2]=15;h[(yw(Xf,1,pf)|0)>>3]=$f;c[of>>2]=1;$f=+h[(yw(Xf,1,of)|0)>>3];c[nf>>2]=12;_f=$f*Yf*+h[(yw(Xf,1,nf)|0)>>3];c[mf>>2]=16;h[(yw(Xf,1,mf)|0)>>3]=_f;c[lf>>2]=1;_f=+h[(yw(Xf,1,lf)|0)>>3];c[kf>>2]=11;$f=_f*Yf*+h[(yw(Xf,1,kf)|0)>>3];c[jf>>2]=17;h[(yw(Xf,1,jf)|0)>>3]=$f;c[hf>>2]=1;$f=+h[(yw(Xf,1,hf)|0)>>3];c[gf>>2]=10;_f=+h[(yw(Xf,1,gf)|0)>>3];c[ff>>2]=11;Zf=$f*_f*+h[(yw(Xf,1,ff)|0)>>3];c[ef>>2]=18;h[(yw(Xf,1,ef)|0)>>3]=Zf;c[df>>2]=10;Zf=+h[(yw(Xf,1,df)|0)>>3];c[cf>>2]=11;_f=+h[(yw(Xf,1,cf)|0)>>3];c[bf>>2]=12;$f=Zf*_f*+h[(yw(Xf,1,bf)|0)>>3];c[af>>2]=19;h[(yw(Xf,1,af)|0)>>3]=$f;c[$e>>2]=1;$f=+h[(yw(Xf,1,$e)|0)>>3];c[_e>>2]=10;_f=$f*+h[(yw(Xf,1,_e)|0)>>3];c[Ze>>2]=20;h[(yw(Xf,1,Ze)|0)>>3]=_f;c[Ye>>2]=21;h[(yw(Xf,1,Ye)|0)>>3]=d/1.0e6*(d/1.0e6);c[Xe>>2]=21;_f=+h[(yw(Xf,1,Xe)|0)>>3];c[We>>2]=22;h[(yw(Xf,1,We)|0)>>3]=_f*_f;c[Ve>>2]=21;_f=+h[(yw(Xf,1,Ve)|0)>>3];c[Ue>>2]=22;$f=_f*+h[(yw(Xf,1,Ue)|0)>>3];c[Te>>2]=23;h[(yw(Xf,1,Te)|0)>>3]=$f;c[Se>>2]=10;$f=+h[(yw(Xf,1,Se)|0)>>3];c[Re>>2]=12;_f=$f*Yf*+h[(yw(Xf,1,Re)|0)>>3];c[Qe>>2]=24;h[(yw(Xf,1,Qe)|0)>>3]=_f;c[Pe>>2]=12;_f=+h[(yw(Xf,1,Pe)|0)>>3];c[Oe>>2]=25;h[(yw(Xf,1,Oe)|0)>>3]=_f*_f;c[Ne>>2]=11;_f=+h[(yw(Xf,1,Ne)|0)>>3];c[Me>>2]=12;$f=+h[(yw(Xf,1,Me)|0)>>3];c[Le>>2]=25;Zf=_f*$f*Yf*+h[(yw(Xf,1,Le)|0)>>3];c[Ke>>2]=26;h[(yw(Xf,1,Ke)|0)>>3]=Zf;c[Je>>2]=10;Zf=+h[(yw(Xf,1,Je)|0)>>3];c[Ie>>2]=12;$f=Zf*+h[(yw(Xf,1,Ie)|0)>>3];c[He>>2]=27;h[(yw(Xf,1,He)|0)>>3]=$f;c[Ge>>2]=1;$f=+h[(yw(Xf,1,Ge)|0)>>3];c[Fe>>2]=10;Zf=+h[(yw(Xf,1,Fe)|0)>>3];c[Ee>>2]=11;_f=$f*Zf*Yf*+h[(yw(Xf,1,Ee)|0)>>3];c[De>>2]=28;h[(yw(Xf,1,De)|0)>>3]=_f;c[Ce>>2]=10;_f=+h[(yw(Xf,1,Ce)|0)>>3];c[Be>>2]=12;Zf=+h[(yw(Xf,1,Be)|0)>>3];c[Ae>>2]=25;$f=_f*Zf*Yf*+h[(yw(Xf,1,Ae)|0)>>3];c[ze>>2]=29;h[(yw(Xf,1,ze)|0)>>3]=$f;c[ye>>2]=1;$f=+h[(yw(Xf,1,ye)|0)>>3];c[xe>>2]=10;Zf=+h[(yw(Xf,1,xe)|0)>>3];c[we>>2]=25;_f=$f*Zf*Yf*+h[(yw(Xf,1,we)|0)>>3];c[ve>>2]=30;h[(yw(Xf,1,ve)|0)>>3]=_f;c[ue>>2]=1;_f=+h[(yw(Xf,1,ue)|0)>>3];c[te>>2]=11;Zf=+h[(yw(Xf,1,te)|0)>>3];c[se>>2]=12;$f=_f*Zf*+h[(yw(Xf,1,se)|0)>>3];c[re>>2]=31;h[(yw(Xf,1,re)|0)>>3]=$f;c[qe>>2]=1;$f=+h[(yw(Xf,1,qe)|0)>>3];c[pe>>2]=12;Zf=$f*+h[(yw(Xf,1,pe)|0)>>3];c[oe>>2]=32;h[(yw(Xf,1,oe)|0)>>3]=Zf;c[ne>>2]=33;h[(yw(Xf,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;Zf=+h[(yw(Xf,1,me)|0)>>3];c[le>>2]=34;h[(yw(Xf,1,le)|0)>>3]=Zf*Zf;c[ke>>2]=13;Zf=+h[(yw(Xf,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(yw(Xf,1,je)|0)>>3]=Zf;c[ie>>2]=35;Zf=+h[(yw(Xf,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(yw(Xf,1,he)|0)>>3]=Zf;c[ge>>2]=2;Zf=+h[(yw(Xf,1,ge)|0)>>3];c[fe>>2]=36;$f=Zf*+h[(yw(Xf,1,fe)|0)>>3];c[ee>>2]=37;h[(yw(Xf,1,ee)|0)>>3]=$f;c[de>>2]=37;$f=+h[(yw(Xf,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(yw(Xf,1,ce)|0)>>3]=$f;c[be>>2]=1;$f=+h[(yw(Xf,1,be)|0)>>3];c[ae>>2]=38;Zf=$f*+h[(yw(Xf,1,ae)|0)>>3];c[$d>>2]=39;h[(yw(Xf,1,$d)|0)>>3]=Zf;c[_d>>2]=39;Zf=+h[(yw(Xf,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(yw(Xf,1,Zd)|0)>>3]=Zf;c[Yd>>2]=40;Zf=Yf*+h[(yw(Xf,1,Yd)|0)>>3];c[Xd>>2]=41;h[(yw(Xf,1,Xd)|0)>>3]=Zf;c[Wd>>2]=41;Zf=+h[(yw(Xf,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(yw(Xf,1,Vd)|0)>>3]=Zf;c[Ud>>2]=42;Zf=Yf*+h[(yw(Xf,1,Ud)|0)>>3];c[Td>>2]=43;h[(yw(Xf,1,Td)|0)>>3]=Zf;c[Sd>>2]=44;h[(yw(Xf,1,Sd)|0)>>3]=Yf*57870447262208.0e-19;c[Rd>>2]=2;Zf=+h[(yw(Xf,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(yw(Xf,1,Qd)|0)>>3]=Zf;c[Pd>>2]=45;Zf=+h[(yw(Xf,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(yw(Xf,1,Od)|0)>>3]=Zf;c[Nd>>2]=46;Zf=Yf*+h[(yw(Xf,1,Nd)|0)>>3];c[Md>>2]=47;h[(yw(Xf,1,Md)|0)>>3]=Zf;c[Ld>>2]=47;Zf=+h[(yw(Xf,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(yw(Xf,1,Kd)|0)>>3]=Zf;c[Jd>>2]=48;Zf=Yf*+h[(yw(Xf,1,Jd)|0)>>3];c[Id>>2]=49;h[(yw(Xf,1,Id)|0)>>3]=Zf;c[Hd>>2]=1;Zf=+h[(yw(Xf,1,Hd)|0)>>3];c[Gd>>2]=11;$f=Zf*+h[(yw(Xf,1,Gd)|0)>>3];c[Fd>>2]=50;h[(yw(Xf,1,Fd)|0)>>3]=$f;c[Ed>>2]=10;$f=+h[(yw(Xf,1,Ed)|0)>>3];c[Dd>>2]=11;Zf=$f*+h[(yw(Xf,1,Dd)|0)>>3];c[Cd>>2]=51;h[(yw(Xf,1,Cd)|0)>>3]=Zf;c[Bd>>2]=11;Zf=+h[(yw(Xf,1,Bd)|0)>>3];c[Ad>>2]=12;$f=+h[(yw(Xf,1,Ad)|0)>>3];c[zd>>2]=25;_f=Zf*$f*+h[(yw(Xf,1,zd)|0)>>3];c[yd>>2]=52;h[(yw(Xf,1,yd)|0)>>3]=_f;c[xd>>2]=10;_f=+h[(yw(Xf,1,xd)|0)>>3];c[wd>>2]=12;$f=+h[(yw(Xf,1,wd)|0)>>3];c[vd>>2]=25;Zf=_f*$f*+h[(yw(Xf,1,vd)|0)>>3];c[ud>>2]=53;h[(yw(Xf,1,ud)|0)>>3]=Zf;c[td>>2]=1;Zf=+h[(yw(Xf,1,td)|0)>>3];c[sd>>2]=10;$f=+h[(yw(Xf,1,sd)|0)>>3];c[rd>>2]=25;_f=Zf*$f*+h[(yw(Xf,1,rd)|0)>>3];c[qd>>2]=54;h[(yw(Xf,1,qd)|0)>>3]=_f;c[pd>>2]=11;c[f+40>>2]=a;c[f+48>>2]=b;g[f+56>>2]=d;g[f+64>>2]=e;g[f+1184>>2]=Yf;c[f+2528>>2]=Xf;c[f+2552>>2]=mb;c[f+2560>>2]=lb;c[f+2568>>2]=kb;c[f+2584>>2]=jb;c[f+2592>>2]=ib;c[f+2600>>2]=hb;c[f+2608>>2]=gb;c[f+2616>>2]=fb;c[f+2624>>2]=eb;c[f+2632>>2]=db;c[f+2640>>2]=cb;c[f+2648>>2]=bb;c[f+2656>>2]=ab;c[f+2672>>2]=$a;c[f+2680>>2]=_a;c[f+2688>>2]=Za;c[f+2696>>2]=Ya;c[f+2704>>2]=Xa;c[f+2712>>2]=Wa;c[f+2720>>2]=Va;c[f+2728>>2]=Ua;c[f+2736>>2]=Ta;c[f+2744>>2]=Sa;c[f+2760>>2]=Ra;c[f+2768>>2]=Qa;c[f+2776>>2]=Pa;c[f+2784>>2]=Oa;c[f+2792>>2]=Na;c[f+2800>>2]=Ma;c[f+2808>>2]=La;c[f+2816>>2]=Ka;c[f+2824>>2]=Ja;c[f+2832>>2]=Ia;c[f+2848>>2]=Ha;c[f+2856>>2]=Ga;c[f+2864>>2]=Fa;c[f+2872>>2]=Ea;c[f+2880>>2]=Da;c[f+2888>>2]=Ca;c[f+2896>>2]=Ba;c[f+2904>>2]=Aa;c[f+2912>>2]=za;c[f+2920>>2]=ya;c[f+2936>>2]=xa;c[f+2944>>2]=wa;c[f+2952>>2]=va;c[f+2960>>2]=ua;c[f+2968>>2]=ta;c[f+2976>>2]=sa;c[f+2984>>2]=ra;c[f+2992>>2]=qa;c[f+3e3>>2]=pa;c[f+3008>>2]=oa;c[f+3024>>2]=na;c[f+3032>>2]=ma;c[f+3040>>2]=la;c[f+3048>>2]=ka;c[f+3056>>2]=ja;c[f+3064>>2]=ia;c[f+3072>>2]=ha;c[f+3080>>2]=ga;c[f+3088>>2]=fa;c[f+3096>>2]=ea;c[f+3112>>2]=da;c[f+3120>>2]=ca;c[f+3128>>2]=ba;c[f+3136>>2]=aa;c[f+3144>>2]=$;c[f+3152>>2]=_;c[f+3160>>2]=Z;c[f+3168>>2]=Y;c[f+3176>>2]=X;c[f+3184>>2]=W;c[f+3200>>2]=V;c[f+3208>>2]=U;c[f+3224>>2]=T;c[f+3232>>2]=S;c[f+3240>>2]=R;c[f+3248>>2]=Q;c[f+3256>>2]=P;c[f+3264>>2]=O;c[f+3272>>2]=N;c[f+3280>>2]=M;c[f+3296>>2]=L;c[f+3304>>2]=K;c[f+3312>>2]=J;c[f+3320>>2]=G;c[f+3328>>2]=F;c[f+3336>>2]=E;c[f+3344>>2]=D;c[f+3352>>2]=C;c[f+3360>>2]=B;c[f+3368>>2]=z;c[f+3384>>2]=y;c[f+3392>>2]=x;c[f+3400>>2]=w;c[f+3408>>2]=v;c[f+3416>>2]=u;c[f+3424>>2]=t;c[f+3432>>2]=s;c[f+3440>>2]=r;c[f+3448>>2]=q;c[f+3456>>2]=p;c[f+3472>>2]=o;c[f+3480>>2]=n;c[f+3488>>2]=m;c[f+3496>>2]=l;c[f+3504>>2]=k;c[f+3512>>2]=j;c[f+4432>>2]=pd;c[f+4440>>2]=od;c[f+4448>>2]=nd;c[f+4456>>2]=md;c[f+4472>>2]=ld;c[f+4480>>2]=kd;c[f+4488>>2]=jd;c[f+4496>>2]=id;c[f+4504>>2]=hd;c[f+4512>>2]=gd;c[f+4520>>2]=fd;c[f+4528>>2]=ed;c[f+4536>>2]=dd;c[f+4544>>2]=cd;c[f+4560>>2]=bd;c[f+4568>>2]=ad;c[f+4576>>2]=$c;c[f+4584>>2]=_c;c[f+4592>>2]=Zc;c[f+4600>>2]=Yc;c[f+4608>>2]=Xc;c[f+4616>>2]=Wc;c[f+4624>>2]=Vc;c[f+4632>>2]=Uc;c[f+4648>>2]=Tc;c[f+4656>>2]=Sc;c[f+4664>>2]=Rc;c[f+4672>>2]=Qc;c[f+4680>>2]=Pc;c[f+4688>>2]=Oc;c[f+4696>>2]=Nc;c[f+4704>>2]=Mc;c[f+4712>>2]=Lc;c[f+4720>>2]=Kc;c[f+4736>>2]=Jc;c[f+4744>>2]=Ic;c[f+4752>>2]=Hc;c[f+4760>>2]=Gc;c[f+4768>>2]=Fc;c[f+4776>>2]=Ec;c[f+4784>>2]=Dc;c[f+4792>>2]=Cc;c[f+4800>>2]=Bc;c[f+4808>>2]=Ac;c[f+4824>>2]=zc;c[f+4832>>2]=yc;c[f+4840>>2]=xc;c[f+4848>>2]=wc;c[f+4856>>2]=vc;c[f+4864>>2]=uc;c[f+4872>>2]=tc;c[f+4880>>2]=sc;c[f+4888>>2]=rc;c[f+4896>>2]=qc;c[f+4912>>2]=pc;c[f+4920>>2]=oc;c[f+4928>>2]=nc;c[f+4936>>2]=mc;c[f+4944>>2]=lc;c[f+4952>>2]=kc;c[f+4960>>2]=jc;c[f+4968>>2]=ic;c[f+4976>>2]=hc;c[f+4984>>2]=gc;c[f+5e3>>2]=fc;c[f+5008>>2]=ec;c[f+5016>>2]=dc;c[f+5024>>2]=cc;c[f+5032>>2]=bc;c[f+5040>>2]=ac;c[f+5048>>2]=$b;c[f+5056>>2]=_b;c[f+5064>>2]=Zb;c[f+5072>>2]=Yb;c[f+5088>>2]=Xb;c[f+5096>>2]=Wb;c[f+5104>>2]=Vb;c[f+5112>>2]=Ub;c[f+5120>>2]=Tb;c[f+5128>>2]=Sb;c[f+5136>>2]=Rb;c[f+5144>>2]=Qb;c[f+5152>>2]=Pb;c[f+5160>>2]=Ob;c[f+5176>>2]=Nb;c[f+5184>>2]=Mb;c[f+5200>>2]=Lb;c[f+5208>>2]=Kb;c[f+5216>>2]=Jb;c[f+5224>>2]=Ib;c[f+5232>>2]=Hb;c[f+5240>>2]=Gb;c[f+5248>>2]=Fb;c[f+5256>>2]=Eb;c[f+5272>>2]=Db;c[f+5280>>2]=Cb;c[f+5288>>2]=Bb;c[f+5296>>2]=Ab;c[f+5304>>2]=zb;c[f+5312>>2]=yb;c[f+5320>>2]=xb;c[f+5328>>2]=wb;c[f+5336>>2]=vb;c[f+5344>>2]=ub;c[f+5360>>2]=tb;c[f+5368>>2]=sb;c[f+5376>>2]=rb;c[f+5384>>2]=qb;c[f+5392>>2]=pb;c[f+5400>>2]=ob;c[f+5408>>2]=nb;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_IF97__new_g2$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function uh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function vh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;sw(l,1,j);j=l;l=4680;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+od(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[22536]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=7728;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];De[j&31](b,f,4696,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function wh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(yw(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[22536]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=7728;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4776,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(yw(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function xh(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;Tg(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function yh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;zh(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Ah(b,0,0.0,0.0,g);i=f;return}function zh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;hh(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+Yw(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function Ah(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Bh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;c[f>>2]=3;sw(g,1,f);f=g;g=4648;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[e>>2]=3;sw(j,1,e);e=j;j=4664;c[e+0>>2]=c[j+0>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];k=d/273.16;if((bh(1,1,3)|0)==0){l=0.0;m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}else{r=1;s=0.0}while(1){j=r+ -1|0;d=+qw(4648,j);t=s+d*+W(+k,+(+qw(4664,j)));j=r+1|0;if((bh(j,1,3)|0)==0){l=t;break}else{s=t;r=j}}m=l/k;n=+ca(+m);o=n*611.657;p=a;q=p;h[q>>3]=o;i=b;return}function Ch(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function Dh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;zh(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));Ch(b,0,0.0,0.0,g);i=f;return}function Eh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(yw(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[22536]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=7728;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4936,m);}c[l>>2]=1;h[a>>3]=+h[(yw(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function Fh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function Gh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(yw(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[22536]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=7728;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];De[f&31](b,j,4936,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function Hh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(yw(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(yw(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(yw(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(yw(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];xw(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];Eh(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[22536]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=7728;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];De[l&31](b,j,5008,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function Ih(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(yw(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(yw(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[22536]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=7728;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];De[f&31](b,j,5232,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function Jh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function Kh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function Lh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function Mh(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function Nh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;sw(n,1,m);m=n;n=4680;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[22536]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=7728;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];De[m&31](b,g,5320,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[22536]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=7728;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];De[g&31](b,f,5400,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function Oh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){Bh(j,0,d);m=+h[j>>3];xh(k,b,c);n=+h[k>>3];o=m}else{vh(f,b,d);m=+h[f>>3];Nh(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}Ph(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function Ph(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function Qh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(yw(f,1,n)|0)>>3]==0.0){Wg(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Rh(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(yw(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(yw(f,1,l)|0)>>3]);Sh(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){Wg(u,b,G,e);J=+h[u>>3];oh(v,b,F,e,0);K=J+I*+h[v>>3];break}else{Wg(r,b,G,e);J=+h[r>>3];oh(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];Th(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){Wg(w,b,G,e);L=+h[w>>3];oh(x,b,F,e,0);J=+h[x>>3];yh(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{Wg(z,b,G,e);J=+h[z>>3];oh(A,b,F,e,0);L=+h[A>>3];Uh(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function Rh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(yw(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(yw(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(yw(f,1,j)|0)>>3]);Oh(m,b,d,e);r=+h[m>>3];Sh(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function Sh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;Oh(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){Nh(j,b,c);l=+h[j>>3]}else{xh(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function _omc_Modelica_Media_Examples_Tests_Components_FixedAmbient_Medium_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(yw(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(yw(l,1,pb)|0)>>3];c[qb>>2]=55;h[(yw(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[22536]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[7728+0>>2];c[a+4>>2]=c[7728+4>>2];c[a+8>>2]=c[7728+8>>2];c[a+12>>2]=c[7728+12>>2];c[a+16>>2]=c[7728+16>>2];c[a+20>>2]=c[7728+20>>2];De[td&31](d,a,4592,rb);}c[sb>>2]=9;sd=+h[(yw(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(yw(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(yw(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(yw(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(yw(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(yw(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(yw(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(yw(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(yw(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(yw(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(yw(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(yw(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(yw(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(yw(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(yw(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(yw(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(yw(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(yw(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(yw(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(yw(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(yw(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(yw(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(yw(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(yw(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(yw(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(yw(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(yw(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(yw(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(yw(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(yw(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(yw(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(yw(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(yw(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(yw(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(yw(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(yw(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(yw(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(yw(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(yw(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(yw(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(yw(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(yw(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(yw(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(yw(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(yw(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(yw(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(yw(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(yw(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(yw(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(yw(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(yw(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(yw(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(yw(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(yw(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(yw(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(yw(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(yw(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(yw(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(yw(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(yw(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(yw(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(yw(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(yw(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(yw(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(yw(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(yw(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(yw(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(yw(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(yw(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(yw(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(yw(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(yw(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(yw(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(yw(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(yw(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(yw(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(yw(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(yw(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(yw(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(yw(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(yw(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(yw(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(yw(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(yw(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(yw(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(yw(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(yw(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(yw(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(yw(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(yw(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(yw(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(yw(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(yw(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(yw(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(yw(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(yw(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(yw(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(yw(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(yw(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(yw(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(yw(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(yw(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(yw(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(yw(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(yw(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(yw(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(yw(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(yw(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(yw(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(yw(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(yw(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(yw(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(yw(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(yw(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(yw(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(yw(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(yw(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(yw(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(yw(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(yw(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(yw(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(yw(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(yw(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(yw(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(yw(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(yw(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(yw(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(yw(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(yw(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(yw(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(yw(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(yw(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(yw(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(yw(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(yw(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(yw(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(yw(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(yw(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(yw(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(yw(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(yw(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(yw(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(yw(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(yw(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(yw(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(yw(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(yw(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(yw(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(yw(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(yw(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(yw(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(yw(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(yw(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(yw(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(yw(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(yw(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(yw(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(yw(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(yw(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(yw(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(yw(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(yw(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(yw(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(yw(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(yw(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(yw(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(yw(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(yw(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(yw(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(yw(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(yw(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(yw(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(yw(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(yw(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(yw(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(yw(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(yw(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(yw(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(yw(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(yw(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(yw(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(yw(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(yw(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(yw(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(yw(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(yw(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(yw(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(yw(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(yw(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(yw(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(yw(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(yw(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(yw(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(yw(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(yw(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(yw(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(yw(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(yw(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(yw(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(yw(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(yw(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(yw(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(yw(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(yw(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(yw(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(yw(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(yw(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(yw(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(yw(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(yw(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(yw(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(yw(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(yw(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(yw(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(yw(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(yw(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(yw(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}function _omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_IF97__new_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0.0,sd=0.0,td=0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0;b=c[a+40>>2]|0;d=c[a+48>>2]|0;e=+g[a+56>>2];f=+g[a+64>>2];j=+g[a+1184>>2];l=c[a+2528>>2]|0;m=c[a+2552>>2]|0;n=c[a+2560>>2]|0;o=c[a+2568>>2]|0;p=c[a+2584>>2]|0;q=c[a+2592>>2]|0;r=c[a+2600>>2]|0;s=c[a+2608>>2]|0;t=c[a+2616>>2]|0;u=c[a+2624>>2]|0;v=c[a+2632>>2]|0;w=c[a+2640>>2]|0;x=c[a+2648>>2]|0;y=c[a+2656>>2]|0;z=c[a+2672>>2]|0;A=c[a+2680>>2]|0;B=c[a+2688>>2]|0;C=c[a+2696>>2]|0;D=c[a+2704>>2]|0;E=c[a+2712>>2]|0;F=c[a+2720>>2]|0;G=c[a+2728>>2]|0;H=c[a+2736>>2]|0;I=c[a+2744>>2]|0;J=c[a+2760>>2]|0;K=c[a+2768>>2]|0;L=c[a+2776>>2]|0;M=c[a+2784>>2]|0;N=c[a+2792>>2]|0;O=c[a+2800>>2]|0;P=c[a+2808>>2]|0;Q=c[a+2816>>2]|0;R=c[a+2824>>2]|0;S=c[a+2832>>2]|0;T=c[a+2848>>2]|0;U=c[a+2856>>2]|0;V=c[a+2864>>2]|0;W=c[a+2872>>2]|0;X=c[a+2880>>2]|0;Y=c[a+2888>>2]|0;Z=c[a+2896>>2]|0;_=c[a+2904>>2]|0;$=c[a+2912>>2]|0;aa=c[a+2920>>2]|0;ba=c[a+2936>>2]|0;ca=c[a+2944>>2]|0;ea=c[a+2952>>2]|0;fa=c[a+2960>>2]|0;ga=c[a+2968>>2]|0;ha=c[a+2976>>2]|0;ia=c[a+2984>>2]|0;ja=c[a+2992>>2]|0;ka=c[a+3e3>>2]|0;la=c[a+3008>>2]|0;ma=c[a+3024>>2]|0;na=c[a+3032>>2]|0;oa=c[a+3040>>2]|0;pa=c[a+3048>>2]|0;qa=c[a+3056>>2]|0;ra=c[a+3064>>2]|0;sa=c[a+3072>>2]|0;ta=c[a+3080>>2]|0;ua=c[a+3088>>2]|0;va=c[a+3096>>2]|0;wa=c[a+3112>>2]|0;xa=c[a+3120>>2]|0;ya=c[a+3128>>2]|0;za=c[a+3136>>2]|0;Aa=c[a+3144>>2]|0;Ba=c[a+3152>>2]|0;Ca=c[a+3160>>2]|0;Da=c[a+3168>>2]|0;Ea=c[a+3176>>2]|0;Fa=c[a+3184>>2]|0;Ga=c[a+3200>>2]|0;Ha=c[a+3208>>2]|0;Ia=c[a+3224>>2]|0;Ja=c[a+3232>>2]|0;Ka=c[a+3240>>2]|0;La=c[a+3248>>2]|0;Ma=c[a+3256>>2]|0;Na=c[a+3264>>2]|0;Oa=c[a+3272>>2]|0;Pa=c[a+3280>>2]|0;Qa=c[a+3296>>2]|0;Ra=c[a+3304>>2]|0;Sa=c[a+3312>>2]|0;Ta=c[a+3320>>2]|0;Ua=c[a+3328>>2]|0;Va=c[a+3336>>2]|0;Wa=c[a+3344>>2]|0;Xa=c[a+3352>>2]|0;Ya=c[a+3360>>2]|0;Za=c[a+3368>>2]|0;_a=c[a+3384>>2]|0;$a=c[a+3392>>2]|0;ab=c[a+3400>>2]|0;bb=c[a+3408>>2]|0;cb=c[a+3416>>2]|0;db=c[a+3424>>2]|0;eb=c[a+3432>>2]|0;fb=c[a+3440>>2]|0;gb=c[a+3448>>2]|0;hb=c[a+3456>>2]|0;ib=c[a+3472>>2]|0;jb=c[a+3480>>2]|0;kb=c[a+3488>>2]|0;lb=c[a+3496>>2]|0;mb=c[a+3504>>2]|0;nb=c[a+3512>>2]|0;ob=c[a+4432>>2]|0;pb=c[a+4440>>2]|0;qb=c[a+4448>>2]|0;rb=c[a+4456>>2]|0;sb=c[a+4472>>2]|0;tb=c[a+4480>>2]|0;ub=c[a+4488>>2]|0;vb=c[a+4496>>2]|0;wb=c[a+4504>>2]|0;xb=c[a+4512>>2]|0;yb=c[a+4520>>2]|0;zb=c[a+4528>>2]|0;Ab=c[a+4536>>2]|0;Bb=c[a+4544>>2]|0;Cb=c[a+4560>>2]|0;Db=c[a+4568>>2]|0;Eb=c[a+4576>>2]|0;Fb=c[a+4584>>2]|0;Gb=c[a+4592>>2]|0;Hb=c[a+4600>>2]|0;Ib=c[a+4608>>2]|0;Jb=c[a+4616>>2]|0;Kb=c[a+4624>>2]|0;Lb=c[a+4632>>2]|0;Mb=c[a+4648>>2]|0;Nb=c[a+4656>>2]|0;Ob=c[a+4664>>2]|0;Pb=c[a+4672>>2]|0;Qb=c[a+4680>>2]|0;Rb=c[a+4688>>2]|0;Sb=c[a+4696>>2]|0;Tb=c[a+4704>>2]|0;Ub=c[a+4712>>2]|0;Vb=c[a+4720>>2]|0;Wb=c[a+4736>>2]|0;Xb=c[a+4744>>2]|0;Yb=c[a+4752>>2]|0;Zb=c[a+4760>>2]|0;_b=c[a+4768>>2]|0;$b=c[a+4776>>2]|0;ac=c[a+4784>>2]|0;bc=c[a+4792>>2]|0;cc=c[a+4800>>2]|0;dc=c[a+4808>>2]|0;ec=c[a+4824>>2]|0;fc=c[a+4832>>2]|0;gc=c[a+4840>>2]|0;hc=c[a+4848>>2]|0;ic=c[a+4856>>2]|0;jc=c[a+4864>>2]|0;kc=c[a+4872>>2]|0;lc=c[a+4880>>2]|0;mc=c[a+4888>>2]|0;nc=c[a+4896>>2]|0;oc=c[a+4912>>2]|0;pc=c[a+4920>>2]|0;qc=c[a+4928>>2]|0;rc=c[a+4936>>2]|0;sc=c[a+4944>>2]|0;tc=c[a+4952>>2]|0;uc=c[a+4960>>2]|0;vc=c[a+4968>>2]|0;wc=c[a+4976>>2]|0;xc=c[a+4984>>2]|0;yc=c[a+5e3>>2]|0;zc=c[a+5008>>2]|0;Ac=c[a+5016>>2]|0;Bc=c[a+5024>>2]|0;Cc=c[a+5032>>2]|0;Dc=c[a+5040>>2]|0;Ec=c[a+5048>>2]|0;Fc=c[a+5056>>2]|0;Gc=c[a+5064>>2]|0;Hc=c[a+5072>>2]|0;Ic=c[a+5088>>2]|0;Jc=c[a+5096>>2]|0;Kc=c[a+5104>>2]|0;Lc=c[a+5112>>2]|0;Mc=c[a+5120>>2]|0;Nc=c[a+5128>>2]|0;Oc=c[a+5136>>2]|0;Pc=c[a+5144>>2]|0;Qc=c[a+5152>>2]|0;Rc=c[a+5160>>2]|0;Sc=c[a+5176>>2]|0;Tc=c[a+5184>>2]|0;Uc=c[a+5200>>2]|0;Vc=c[a+5208>>2]|0;Wc=c[a+5216>>2]|0;Xc=c[a+5224>>2]|0;Yc=c[a+5232>>2]|0;Zc=c[a+5240>>2]|0;_c=c[a+5248>>2]|0;$c=c[a+5256>>2]|0;ad=c[a+5272>>2]|0;bd=c[a+5280>>2]|0;cd=c[a+5288>>2]|0;dd=c[a+5296>>2]|0;ed=c[a+5304>>2]|0;fd=c[a+5312>>2]|0;gd=c[a+5320>>2]|0;hd=c[a+5328>>2]|0;id=c[a+5336>>2]|0;jd=c[a+5344>>2]|0;kd=c[a+5360>>2]|0;ld=c[a+5368>>2]|0;md=c[a+5376>>2]|0;nd=c[a+5384>>2]|0;od=c[a+5392>>2]|0;pd=c[a+5400>>2]|0;qd=c[a+5408>>2]|0;a:do{rd=+h[(yw(l,1,ob)|0)>>3];c[pb>>2]=12;sd=rd*j*+h[(yw(l,1,pb)|0)>>3];c[qb>>2]=55;h[(yw(l,1,qb)|0)>>3]=sd;if(!(e/1.0e6>0.0)){td=c[22536]|0;h[k>>3]=e/1.0e6;c[rb>>2]=c[k>>2];c[rb+4>>2]=c[k+4>>2];c[a+0>>2]=c[7728+0>>2];c[a+4>>2]=c[7728+4>>2];c[a+8>>2]=c[7728+8>>2];c[a+12>>2]=c[7728+12>>2];c[a+16>>2]=c[7728+16>>2];c[a+20>>2]=c[7728+20>>2];De[td&31](d,a,4592,rb);}c[sb>>2]=9;sd=+h[(yw(l,1,sb)|0)>>3];c[tb>>2]=1;rd=+h[(yw(l,1,tb)|0)>>3];c[ub>>2]=13;ud=+h[(yw(l,1,ub)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[vb>>2]=2;vd=j*(j*(rd*(ud*+h[(yw(l,1,vb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[wb>>2]=1;ud=+h[(yw(l,1,wb)|0)>>3];c[xb>>2]=13;rd=+h[(yw(l,1,xb)|0)>>3]*-.040668253562649+-.0015033924542148;c[yb>>2]=2;wd=j*(ud*(rd*+h[(yw(l,1,yb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[zb>>2]=14;rd=+h[(yw(l,1,zb)|0)>>3]*22922076337661.0e-19;c[Ab>>2]=15;ud=+h[(yw(l,1,Ab)|0)>>3];c[Bb>>2]=16;xd=ud*(+h[(yw(l,1,Bb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Cb>>2]=2;ud=+h[(yw(l,1,Cb)|0)>>3]*xd;c[Db>>2]=17;xd=+h[(yw(l,1,Db)|0)>>3];c[Eb>>2]=18;yd=xd*(+h[(yw(l,1,Eb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Fb>>2]=11;xd=+h[(yw(l,1,Fb)|0)>>3];c[Gb>>2]=19;zd=xd*(+h[(yw(l,1,Gb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Hb>>2]=15;xd=+h[(yw(l,1,Hb)|0)>>3]*1.9809712802088e-8;c[Ib>>2]=10;Ad=+h[(yw(l,1,Ib)|0)>>3];c[Jb>>2]=10;Bd=+h[(yw(l,1,Jb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Kb>>2]=20;Cd=Ad*(Bd*+h[(yw(l,1,Kb)|0)>>3]+1.0406965210174e-19);c[Lb>>2]=23;Bd=+h[(yw(l,1,Lb)|0)>>3];c[Mb>>2]=13;Ad=+h[(yw(l,1,Mb)|0)>>3];c[Nb>>2]=24;Dd=Ad*(+h[(yw(l,1,Nb)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[Ob>>2]=21;Ad=+h[(yw(l,1,Ob)|0)>>3];c[Pb>>2]=26;Ed=+h[(yw(l,1,Pb)|0)>>3]*-.33662250574171;c[Qb>>2]=21;Fd=+h[(yw(l,1,Qb)|0)>>3];c[Rb>>2]=27;Gd=+h[(yw(l,1,Rb)|0)>>3];c[Sb>>2]=15;Hd=+h[(yw(l,1,Sb)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[Tb>>2]=28;Id=Gd*(Hd*+h[(yw(l,1,Tb)|0)>>3]+8.9185845355421e-25);c[Ub>>2]=24;Hd=+h[(yw(l,1,Ub)|0)>>3]*-5.9056029685639e-26;c[Vb>>2]=29;Gd=+h[(yw(l,1,Vb)|0)>>3]*37826947613457.0e-19;c[Wb>>2]=30;Jd=+h[(yw(l,1,Wb)|0)>>3]*-1.2768608934681e-15;c[Xb>>2]=31;Kd=+h[(yw(l,1,Xb)|0)>>3];c[Yb>>2]=18;Ld=+h[(yw(l,1,Yb)|0)>>3];c[Zb>>2]=32;Md=e/1.0e6*(sd+e/1.0e6*(vd+e/1.0e6*(wd+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(Cd+Bd*(Dd+Ad*(Ed+Fd*(Id+e/1.0e6*(Hd+e/1.0e6*(Gd+e/1.0e6*(Jd+Kd*e/1.0e6*(Ld*(+h[(yw(l,1,Zb)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Ld=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[_b>>2]=34;Kd=Ld/(540.0/f*+h[(yw(l,1,_b)|0)>>3])+Md;c[$b>>2]=9;Md=+h[(yw(l,1,$b)|0)>>3];c[ac>>2]=43;Ld=+h[(yw(l,1,ac)|0)>>3];c[bc>>2]=1;Jd=+h[(yw(l,1,bc)|0)>>3];c[cc>>2]=13;Gd=+h[(yw(l,1,cc)|0)>>3]*-.122004760687947+-.0045101773626444;c[dc>>2]=2;Hd=j*(Jd*(Gd*+h[(yw(l,1,dc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[ec>>2]=14;Gd=+h[(yw(l,1,ec)|0)>>3]*114610381688305.0e-19;c[fc>>2]=15;Jd=+h[(yw(l,1,fc)|0)>>3];c[gc>>2]=16;Id=Jd*(+h[(yw(l,1,gc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[hc>>2]=2;Jd=+h[(yw(l,1,hc)|0)>>3]*Id;c[ic>>2]=17;Id=+h[(yw(l,1,ic)|0)>>3];c[jc>>2]=18;Fd=Id*(+h[(yw(l,1,jc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[kc>>2]=11;Id=+h[(yw(l,1,kc)|0)>>3];c[lc>>2]=19;Ed=Id*(+h[(yw(l,1,lc)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[mc>>2]=15;Id=+h[(yw(l,1,mc)|0)>>3]*1.78287415218792e-7;c[nc>>2]=10;Ad=+h[(yw(l,1,nc)|0)>>3];c[oc>>2]=10;Dd=+h[(yw(l,1,oc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[pc>>2]=20;Bd=Ad*(Dd*+h[(yw(l,1,pc)|0)>>3]+1.0406965210174e-18);c[qc>>2]=23;Dd=+h[(yw(l,1,qc)|0)>>3];c[rc>>2]=13;Ad=+h[(yw(l,1,rc)|0)>>3];c[sc>>2]=24;Cd=Ad*(+h[(yw(l,1,sc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[tc>>2]=21;Ad=+h[(yw(l,1,tc)|0)>>3];c[uc>>2]=26;xd=+h[(yw(l,1,uc)|0)>>3]*-6.0592051033508;c[vc>>2]=21;zd=+h[(yw(l,1,vc)|0)>>3];c[wc>>2]=27;yd=+h[(yw(l,1,wc)|0)>>3];c[xc>>2]=15;ud=+h[(yw(l,1,xc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[yc>>2]=28;rd=yd*(ud*+h[(yw(l,1,yc)|0)>>3]+1.78371690710842e-23);c[zc>>2]=24;ud=+h[(yw(l,1,zc)|0)>>3]*-1.24017662339842e-24;c[Ac>>2]=29;yd=+h[(yw(l,1,Ac)|0)>>3]*83219284749605.0e-18;c[Bc>>2]=30;wd=+h[(yw(l,1,Bc)|0)>>3]*-2.93678005497663e-14;c[Cc>>2]=31;vd=+h[(yw(l,1,Cc)|0)>>3];c[Dc>>2]=18;sd=+h[(yw(l,1,Dc)|0)>>3];c[Ec>>2]=32;Nd=(e/1.0e6*(Md+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Ed+e/1.0e6*(Id+e/1.0e6*(Bd+Dd*(Cd+Ad*(xd+zd*(rd+e/1.0e6*(ud+e/1.0e6*(yd+e/1.0e6*(wd+vd*e/1.0e6*(sd*(+h[(yw(l,1,Ec)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Fc>>2]=21;sd=+h[(yw(l,1,Fc)|0)>>3];c[Gc>>2]=43;vd=+h[(yw(l,1,Gc)|0)>>3];c[Hc>>2]=1;wd=+h[(yw(l,1,Hc)|0)>>3];c[Ic>>2]=13;yd=+h[(yw(l,1,Ic)|0)>>3]*-.244009521375894+-.0090203547252888;c[Jc>>2]=2;ud=j*(wd*(yd*+h[(yw(l,1,Jc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Kc>>2]=14;yd=+h[(yw(l,1,Kc)|0)>>3]*45844152675322.0e-18;c[Lc>>2]=15;wd=+h[(yw(l,1,Lc)|0)>>3];c[Mc>>2]=16;rd=wd*(+h[(yw(l,1,Mc)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[Nc>>2]=2;wd=+h[(yw(l,1,Nc)|0)>>3]*rd;c[Oc>>2]=17;rd=+h[(yw(l,1,Oc)|0)>>3];c[Pc>>2]=18;zd=rd*(+h[(yw(l,1,Pc)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[Qc>>2]=11;rd=+h[(yw(l,1,Qc)|0)>>3];c[Rc>>2]=19;xd=rd*(+h[(yw(l,1,Rc)|0)>>3]*-460.94350902879+6.303478361857e-10);c[Sc>>2]=15;rd=+h[(yw(l,1,Sc)|0)>>3]*142629932175034.0e-20;c[Tc>>2]=10;Ad=+h[(yw(l,1,Tc)|0)>>3];c[Uc>>2]=10;Cd=+h[(yw(l,1,Uc)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[Vc>>2]=20;Dd=Ad*(Cd*+h[(yw(l,1,Vc)|0)>>3]+9.3662686891566e-18);c[Wc>>2]=23;Cd=+h[(yw(l,1,Wc)|0)>>3];c[Xc>>2]=13;Ad=+h[(yw(l,1,Xc)|0)>>3];c[Yc>>2]=24;Bd=Ad*(+h[(yw(l,1,Yc)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[Zc>>2]=21;Ad=+h[(yw(l,1,Zc)|0)>>3];c[_c>>2]=26;Id=+h[(yw(l,1,_c)|0)>>3]*-103.006486756963;c[$c>>2]=21;Ed=+h[(yw(l,1,$c)|0)>>3];c[ad>>2]=27;Fd=+h[(yw(l,1,ad)|0)>>3];c[bd>>2]=15;Jd=+h[(yw(l,1,bd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[cd>>2]=28;Gd=Fd*(Jd*+h[(yw(l,1,cd)|0)>>3]+3.389062123506e-22);c[dd>>2]=24;Jd=+h[(yw(l,1,dd)|0)>>3]*-2.48035324679684e-23;c[ed>>2]=29;Fd=+h[(yw(l,1,ed)|0)>>3]*.00174760497974171;c[fd>>2]=30;Hd=+h[(yw(l,1,fd)|0)>>3]*-6.4609161209486e-13;c[gd>>2]=31;Ld=+h[(yw(l,1,gd)|0)>>3];c[hd>>2]=18;Md=+h[(yw(l,1,hd)|0)>>3];c[id>>2]=32;Od=e/1.0e6*(yd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(Dd+Cd*(Bd+Ad*(Id+Ed*(Gd+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Hd+Ld*e/1.0e6*(Md*(+h[(yw(l,1,id)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[jd>>2]=44;Md=sd*(vd+e/1.0e6*(ud+e/1.0e6*(j*(j*(+h[(yw(l,1,jd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+Od)+1.22890426153854e-7))+-1.0;c[kd>>2]=21;Od=Md/+h[(yw(l,1,kd)|0)>>3];c[ld>>2]=33;Md=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(yw(l,1,ld)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[md>>2]=33;ud=+h[(yw(l,1,md)|0)>>3];c[nd>>2]=34;vd=Md/(ud*+h[(yw(l,1,nd)|0)>>3]);c[od>>2]=49;ud=+h[(yw(l,1,od)|0)>>3];c[pd>>2]=1;Md=+h[(yw(l,1,pd)|0)>>3];c[qd>>2]=13;sd=+h[(yw(l,1,qd)|0)>>3]*-.00096028372490713+-.306581069554011;c[m>>2]=2;Ld=j*(Md*(sd*+h[(yw(l,1,m)|0)>>3]+-.015757110897342)+-.0003789797503263);c[n>>2]=1;sd=+h[(yw(l,1,n)|0)>>3];c[o>>2]=13;Md=+h[(yw(l,1,o)|0)>>3]*-1.42338887469272+-.0090203547252888;c[p>>2]=2;Hd=sd*(Md*+h[(yw(l,1,p)|0)>>3]+-9683303171571.0e-17);c[q>>2]=20;Md=+h[(yw(l,1,q)|0)>>3]*160454534363627.0e-19;c[r>>2]=1;sd=+h[(yw(l,1,r)|0)>>3];c[s>>2]=15;Fd=+h[(yw(l,1,s)|0)>>3];c[t>>2]=16;Jd=sd*(Fd*(+h[(yw(l,1,t)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[u>>2]=18;Fd=+h[(yw(l,1,u)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[v>>2]=50;sd=Fd*+h[(yw(l,1,v)|0)>>3];c[w>>2]=14;Fd=+h[(yw(l,1,w)|0)>>3];c[x>>2]=19;Gd=Fd*(+h[(yw(l,1,x)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[y>>2]=51;Fd=+h[(yw(l,1,y)|0)>>3]*2.57526266427144e-7;c[z>>2]=2;Ed=+h[(yw(l,1,z)|0)>>3];c[A>>2]=10;Id=+h[(yw(l,1,A)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[B>>2]=20;Ad=Ed*(Id*+h[(yw(l,1,B)|0)>>3]+4.1627860840696e-19);c[C>>2]=23;Id=+h[(yw(l,1,C)|0)>>3];c[D>>2]=19;Ed=+h[(yw(l,1,D)|0)>>3];c[E>>2]=24;Bd=Ed*(+h[(yw(l,1,E)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=21;Ed=+h[(yw(l,1,F)|0)>>3];c[G>>2]=52;Cd=+h[(yw(l,1,G)|0)>>3]*-19.1874828272775;c[H>>2]=21;Dd=+h[(yw(l,1,H)|0)>>3];c[I>>2]=16;rd=+h[(yw(l,1,I)|0)>>3];c[J>>2]=15;xd=+h[(yw(l,1,J)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[K>>2]=28;zd=rd*(xd*+h[(yw(l,1,K)|0)>>3]+1.78371690710842e-23);c[L>>2]=27;xd=+h[(yw(l,1,L)|0)>>3]*-1.24017662339842e-24;c[M>>2]=53;rd=+h[(yw(l,1,M)|0)>>3]*.000200482822351322;c[N>>2]=54;wd=+h[(yw(l,1,N)|0)>>3]*-4.9797574845256e-14;c[O>>2]=18;yd=+h[(yw(l,1,O)|0)>>3];c[P>>2]=32;Pd=yd*(+h[(yw(l,1,P)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[Q>>2]=55;yd=vd+e/1.0e6*(ud+e/1.0e6*(Ld+e/1.0e6*(Hd+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Md+e/1.0e6*(Jd+e/1.0e6*(sd+e/1.0e6*(Gd+e/1.0e6*(Fd+e/1.0e6*(Ad+Id*(Bd+Ed*(Cd+Dd*(zd+e/1.0e6*(xd+e/1.0e6*(rd+e/1.0e6*(wd+e/1.0e6*+h[(yw(l,1,Q)|0)>>3]*Pd))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[R>>2]=33;Pd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(yw(l,1,R)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[S>>2]=33;wd=+h[(yw(l,1,S)|0)>>3];c[T>>2]=34;rd=Pd/(540.0/f*wd*+h[(yw(l,1,T)|0)>>3]);c[U>>2]=2;wd=j*(+h[(yw(l,1,U)|0)>>3]*-1.5097583618379+-.34548755450059);c[V>>2]=1;Pd=+h[(yw(l,1,V)|0)>>3];c[W>>2]=13;xd=+h[(yw(l,1,W)|0)>>3]*-.03360993037175+-1.83948641732407;c[X>>2]=2;zd=Pd*(xd*+h[(yw(l,1,X)|0)>>3]+-.047271332692026);c[Y>>2]=13;xd=+h[(yw(l,1,Y)|0)>>3]*-48.395221739552+-.045101773626444;c[Z>>2]=2;Pd=j*(xd*+h[(yw(l,1,Z)|0)>>3]+-.00019366606343142);c[_>>2]=10;xd=j*+h[(yw(l,1,_)|0)>>3]*96272720618176.0e-18;c[$>>2]=15;Dd=+h[(yw(l,1,$)|0)>>3];c[aa>>2]=16;Cd=j*(Dd*(+h[(yw(l,1,aa)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[ba>>2]=11;Dd=+h[(yw(l,1,ba)|0)>>3];c[ca>>2]=18;Ed=Dd*j*(+h[(yw(l,1,ca)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ea>>2]=19;Dd=+h[(yw(l,1,ea)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[fa>>2]=20;Bd=Dd*+h[(yw(l,1,fa)|0)>>3];c[ga>>2]=17;Dd=+h[(yw(l,1,ga)|0)>>3]*309031519712573.0e-20;c[ha>>2]=1;Id=+h[(yw(l,1,ha)|0)>>3];c[ia>>2]=10;Ad=+h[(yw(l,1,ia)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ja>>2]=20;Fd=Id*(Ad*+h[(yw(l,1,ja)|0)>>3]+1.24883582522088e-18);c[ka>>2]=23;Ad=+h[(yw(l,1,ka)|0)>>3];c[la>>2]=1;Id=+h[(yw(l,1,la)|0)>>3];c[ma>>2]=11;Gd=+h[(yw(l,1,ma)|0)>>3];c[na>>2]=12;sd=+h[(yw(l,1,na)|0)>>3];c[oa>>2]=24;Jd=Id*Gd*sd*j*(+h[(yw(l,1,oa)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[pa>>2]=21;sd=+h[(yw(l,1,pa)|0)>>3];c[qa>>2]=1;Gd=+h[(yw(l,1,qa)|0)>>3];c[ra>>2]=10;Id=+h[(yw(l,1,ra)|0)>>3];c[sa>>2]=12;Md=+h[(yw(l,1,sa)|0)>>3];c[ta>>2]=25;Hd=Gd*Id*Md*j*+h[(yw(l,1,ta)|0)>>3]*-1074.49903832754;c[ua>>2]=21;Md=+h[(yw(l,1,ua)|0)>>3];c[va>>2]=15;Id=+h[(yw(l,1,va)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[wa>>2]=28;Gd=Id*+h[(yw(l,1,wa)|0)>>3]+3.389062123506e-22;c[xa>>2]=32;Id=Gd*+h[(yw(l,1,xa)|0)>>3];c[ya>>2]=16;Gd=+h[(yw(l,1,ya)|0)>>3]*-2.48035324679684e-23;c[za>>2]=1;Ld=+h[(yw(l,1,za)|0)>>3];c[Aa>>2]=12;ud=+h[(yw(l,1,Aa)|0)>>3];c[Ba>>2]=25;vd=Ld*ud*j*+h[(yw(l,1,Ba)|0)>>3]*.0104251067622687;c[Ca>>2]=11;ud=+h[(yw(l,1,Ca)|0)>>3];c[Da>>2]=12;Ld=+h[(yw(l,1,Da)|0)>>3];c[Ea>>2]=18;Qd=+h[(yw(l,1,Ea)|0)>>3];c[Fa>>2]=32;Rd=ud*Ld*e/1.0e6*(Qd*(+h[(yw(l,1,Fa)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ga>>2]=10;Qd=+h[(yw(l,1,Ga)|0)>>3];c[Ha>>2]=25;Ld=rd+e/1.0e6*(wd+e/1.0e6*(zd+e/1.0e6*(Pd+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(Ed+e/1.0e6*(Bd+e/1.0e6*(Dd+e/1.0e6*(Fd+Ad*(Jd+sd*(Hd+Md*(Id+e/1.0e6*(Gd+e/1.0e6*(vd+e/1.0e6*(Rd+Qd*j*+h[(yw(l,1,Ha)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[Ia>>2]=49;Qd=+h[(yw(l,1,Ia)|0)>>3];c[Ja>>2]=1;Rd=+h[(yw(l,1,Ja)|0)>>3];c[Ka>>2]=13;vd=+h[(yw(l,1,Ka)|0)>>3]*-.00192056744981426+-.61316213910802;c[La>>2]=2;Gd=j*(Rd*(vd*+h[(yw(l,1,La)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Ma>>2]=1;vd=+h[(yw(l,1,Ma)|0)>>3];c[Na>>2]=13;Rd=+h[(yw(l,1,Na)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Oa>>2]=2;Id=vd*(Rd*+h[(yw(l,1,Oa)|0)>>3]+-.00029049909514713);c[Pa>>2]=20;Rd=+h[(yw(l,1,Pa)|0)>>3]*80227267181813.0e-18;c[Qa>>2]=1;vd=+h[(yw(l,1,Qa)|0)>>3];c[Ra>>2]=15;Md=+h[(yw(l,1,Ra)|0)>>3];c[Sa>>2]=16;Hd=vd*(Md*(+h[(yw(l,1,Sa)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Ta>>2]=18;Md=+h[(yw(l,1,Ta)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Ua>>2]=50;vd=Md*+h[(yw(l,1,Ua)|0)>>3];c[Va>>2]=14;Md=+h[(yw(l,1,Va)|0)>>3];c[Wa>>2]=19;sd=Md*(+h[(yw(l,1,Wa)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[Xa>>2]=51;Md=+h[(yw(l,1,Xa)|0)>>3]*23177363978443.0e-19;c[Ya>>2]=2;Jd=+h[(yw(l,1,Ya)|0)>>3];c[Za>>2]=10;Ad=+h[(yw(l,1,Za)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[_a>>2]=20;Fd=Jd*(Ad*+h[(yw(l,1,_a)|0)>>3]+4.1627860840696e-18);c[$a>>2]=23;Ad=+h[(yw(l,1,$a)|0)>>3];c[ab>>2]=19;Jd=+h[(yw(l,1,ab)|0)>>3];c[bb>>2]=24;Dd=Jd*(+h[(yw(l,1,bb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[cb>>2]=21;Jd=+h[(yw(l,1,cb)|0)>>3];c[db>>2]=52;Bd=+h[(yw(l,1,db)|0)>>3]*-345.37469089099;c[eb>>2]=21;Ed=+h[(yw(l,1,eb)|0)>>3];c[fb>>2]=16;Cd=+h[(yw(l,1,fb)|0)>>3];c[gb>>2]=15;xd=+h[(yw(l,1,gb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[hb>>2]=28;Pd=Cd*(xd*+h[(yw(l,1,hb)|0)>>3]+3.5674338142168e-22);c[ib>>2]=27;xd=+h[(yw(l,1,ib)|0)>>3]*-2.60437090913668e-23;c[jb>>2]=53;Cd=+h[(yw(l,1,jb)|0)>>3]*.0044106220917291;c[kb>>2]=54;zd=+h[(yw(l,1,kb)|0)>>3]*-1.14534422144089e-12;c[lb>>2]=18;wd=+h[(yw(l,1,lb)|0)>>3];c[mb>>2]=32;rd=wd*(+h[(yw(l,1,mb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[nb>>2]=55;wd=e/1.0e6*(Rd+e/1.0e6*(Hd+e/1.0e6*(vd+e/1.0e6*(sd+e/1.0e6*(Md+e/1.0e6*(Fd+Ad*(Dd+Jd*(Bd+Ed*(Pd+e/1.0e6*(xd+e/1.0e6*(Cd+e/1.0e6*(zd+e/1.0e6*+h[(yw(l,1,nb)|0)>>3]*rd))))))))))));c[(a+24|0)>>2]=44;rd=Qd+e/1.0e6*(Gd+e/1.0e6*(Id+e/1.0e6*(j*(+h[(yw(l,1,a+24|0)|0)>>3]+1.0232574281828e-7)+wd+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Kd;h[b+48>>3]=Nd;h[b+56>>3]=Od;h[b+64>>3]=yd;h[b+72>>3]=Ld;h[b+80>>3]=rd;i=a;c[a+5424>>2]=5;break a}while(0)}



function Ij(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+16|0;c[y>>2]=3;sw(z,1,y);c[x>>2]=10;sw(A,1,x);x=A;A=4680;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];B=+od(+d,553.0);d=B+-650.17534844798;C=B+-.23855557567849/d;B=.23855557567849/(d*d)+1.0;d=C*C;D=d+C*1167.0521452767+-724213.16703206;E=C*12020.82470247+d*-17.073846940092+-3232555.0322333;F=C*-4823.2657361591+d*14.91510861353+405113.40542057;d=C*B;C=B*12020.82470247+d*-34.147693880184;G=B*-4823.2657361591+d*29.83021722706;c[w>>2]=1;h[(yw(z,1,w)|0)>>3]=E*C*2.0+(D*G+(B*1167.0521452767+d*2.0)*F)*-4.0;d=E*E+D*F*-4.0;w=d>=0.0;if(!w){A=c[22536]|0;x=v;h[k>>3]=d;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=A;A=m;y=7728;c[A+0>>2]=c[y+0>>2];c[A+4>>2]=c[y+4>>2];c[A+8>>2]=c[y+8>>2];c[A+12>>2]=c[y+12>>2];c[A+16>>2]=c[y+16>>2];c[A+20>>2]=c[y+20>>2];De[x&31](b,m,4696,v);}c[u>>2]=1;D=+V(+d);B=+h[(yw(z,1,u)|0)>>3]/D*.5-C;c[t>>2]=2;h[(yw(z,1,t)|0)>>3]=B;if(!w){t=c[22536]|0;u=s;h[k>>3]=d;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t;t=l;v=7728;c[t+0>>2]=c[v+0>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[t+12>>2]=c[v+12>>2];c[t+16>>2]=c[v+16>>2];c[t+20>>2]=c[v+20>>2];De[u&31](b,l,4696,s);s=c[22536]|0;l=r;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=s;s=j;u=7728;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];De[l&31](b,j,4696,r);}B=D-E;c[q>>2]=2;E=(G*B-F*+h[(yw(z,1,q)|0)>>3])/(B*B)*2.0;c[p>>2]=3;h[(yw(z,1,p)|0)>>3]=E;if(w){H=F/B;I=H*H;J=H*I;K=n;L=K;c[L>>2]=3;M=32;N=M;O=yw(z,1,n)|0;P=+h[O>>3];Q=P*e;R=J*Q;S=R*32.0e6;T=a;U=T;h[U>>3]=S;i=f;return}w=c[22536]|0;p=o;h[k>>3]=d;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=w;w=g;q=7728;c[w+0>>2]=c[q+0>>2];c[w+4>>2]=c[q+4>>2];c[w+8>>2]=c[q+8>>2];c[w+12>>2]=c[q+12>>2];c[w+16>>2]=c[q+16>>2];c[w+20>>2]=c[q+20>>2];De[p&31](b,g,4696,o);H=F/B;I=H*H;J=H*I;K=n;L=K;c[L>>2]=3;M=32;N=M;O=yw(z,1,n)|0;P=+h[O>>3];Q=P*e;R=J*Q;S=R*32.0e6;T=a;U=T;h[U>>3]=S;i=f;return}function Jj(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){fj(j,0,d);m=+h[j>>3];gj(k,b,c);n=+h[k>>3];o=m}else{Hj(f,b,d);m=+h[f>>3];Bj(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}uj(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function Kj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(yw(f,1,n)|0)>>3]==0.0){Wg(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Oi(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(yw(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(yw(f,1,l)|0)>>3]);Ni(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){Wg(u,b,G,e);J=+h[u>>3];Wi(v,b,F,e,0);K=J+I*+h[v>>3];break}else{Wg(r,b,G,e);J=+h[r>>3];Wi(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];Lj(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){Wg(w,b,G,e);L=+h[w>>3];Wi(x,b,F,e,0);J=+h[x>>3];ij(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{Wg(z,b,G,e);J=+h[z>>3];Wi(A,b,F,e,0);L=+h[A>>3];Uh(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function Lj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;sw(Na,1,Ma);c[La>>2]=4;sw(Oa,1,La);c[Ka>>2]=4;sw(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(yw(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(yw(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(yw(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(yw(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];xw(Qa,4,ob,Fa);tw(Qa,Oa);Qa=(bh(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+qw(5536,Fa+ -1|0);c[Ea>>2]=Fa;h[(yw(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((bh(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(yw(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(yw(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(yw(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(yw(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(yw(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(yw(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(yw(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(yw(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(yw(Oa,1,va)|0)>>3];pb=sb*(ob/+qw(5536,Qa+ -1|0));c[ua>>2]=Qa;h[(yw(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((bh(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(yw(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(yw(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(yw(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(yw(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];xw(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];lj($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(yw(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(yw(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(yw(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(yw(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];xw(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];oj(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(yw(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(yw(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(yw(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(yw(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];xw(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];nj(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(yw(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(yw(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(yw(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(yw(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];xw(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];rj(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(yw(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(yw(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(yw(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(yw(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];xw(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];Ri(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(yw(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(yw(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(yw(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(yw(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];xw(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];lj(eb,b,d,e,o);tb=+h[eb>>3];xj(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(yw(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(yw(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(yw(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(yw(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];xw(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];oj(gb,b,d,e,n);qb=+h[gb>>3];wj(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(yw(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(yw(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(yw(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(yw(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];xw(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];nj(ib,b,d,e,m);vb=+h[ib>>3];vj(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(yw(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(yw(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(yw(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(yw(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];xw(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];rj(kb,b,d,e,l);d=+h[kb>>3];Cj(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(yw(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(yw(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(yw(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(yw(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];xw(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Ri(mb,b,0.0,e,j);yb=+h[mb>>3];Ej(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(yw(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(yw(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(yw(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(yw(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function Mj(a,b,d,e,f,j,l,m){a=a|0;b=b|0;d=+d;e=+e;f=f|0;j=+j;l=+l;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0.0,Eg=0.0,Fg=0.0,Gg=0.0,Hg=0.0,Ig=0.0,Jg=0.0,Kg=0.0,Lg=0.0;n=i;i=i+6224|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+24|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+24|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+24|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+24|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+24|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+24|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+24|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+24|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+24|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+24|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+24|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+24|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+24|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+24|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+24|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+24|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+24|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+24|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+24|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+24|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+24|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+24|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+24|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+24|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+24|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+24|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+24|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+24|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+24|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+24|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+24|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+24|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+24|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+24|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+24|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+24|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+24|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+24|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+24|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+24|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+24|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+16|0;Ne=i;i=i+16|0;Oe=i;i=i+16|0;Pe=i;i=i+16|0;Qe=i;i=i+16|0;Re=i;i=i+16|0;Se=i;i=i+16|0;Te=i;i=i+16|0;Ue=i;i=i+16|0;Ve=i;i=i+16|0;We=i;i=i+16|0;Xe=i;i=i+16|0;Ye=i;i=i+16|0;Ze=i;i=i+16|0;_e=i;i=i+16|0;$e=i;i=i+16|0;af=i;i=i+16|0;bf=i;i=i+16|0;cf=i;i=i+16|0;df=i;i=i+16|0;ef=i;i=i+16|0;ff=i;i=i+16|0;gf=i;i=i+16|0;hf=i;i=i+16|0;jf=i;i=i+16|0;kf=i;i=i+16|0;lf=i;i=i+16|0;mf=i;i=i+16|0;nf=i;i=i+16|0;of=i;i=i+16|0;pf=i;i=i+16|0;qf=i;i=i+16|0;rf=i;i=i+16|0;sf=i;i=i+16|0;tf=i;i=i+16|0;uf=i;i=i+16|0;vf=i;i=i+16|0;wf=i;i=i+16|0;xf=i;i=i+16|0;yf=i;i=i+16|0;zf=i;i=i+16|0;Af=i;i=i+16|0;Bf=i;i=i+16|0;Cf=i;i=i+16|0;Df=i;i=i+16|0;Ef=i;i=i+16|0;Ff=i;i=i+16|0;Gf=i;i=i+16|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+8|0;bg=i;i=i+8|0;cg=i;i=i+8|0;dg=i;i=i+8|0;eg=i;i=i+8|0;fg=i;i=i+8|0;gg=i;i=i+8|0;hg=i;i=i+8|0;ig=i;i=i+8|0;jg=i;i=i+8|0;kg=i;i=i+8|0;lg=i;i=i+8|0;mg=i;i=i+8|0;ng=i;i=i+8|0;og=i;i=i+8|0;pg=i;i=i+8|0;qg=i;i=i+8|0;rg=i;i=i+8|0;sg=i;i=i+8|0;tg=i;i=i+8|0;ug=i;i=i+8|0;vg=i;i=i+8|0;wg=i;i=i+8|0;xg=i;i=i+8|0;yg=i;i=i+8|0;zg=i;i=i+8|0;Ag=i;i=i+8|0;Bg=i;i=i+8|0;Cg=i;i=i+8|0;c[Le>>2]=7;sw(Me,1,Le);c[Ke>>2]=4;sw(Ne,1,Ke);c[Je>>2]=4;sw(Oe,1,Je);c[Ie>>2]=4;sw(Pe,1,Ie);c[He>>2]=4;sw(Qe,1,He);c[Ge>>2]=4;sw(Re,1,Ge);c[Fe>>2]=1;Dg=+h[(yw(f,1,Fe)|0)>>3];c[Ee>>2]=2;Eg=+h[(yw(f,1,Ee)|0)>>3]*.7557;c[De>>2]=2;Fg=+h[(yw(f,1,De)|0)>>3]*.2316;c[Ce>>2]=2;Gg=+h[(yw(f,1,Ce)|0)>>3]*.0127;h[k>>3]=Eg;c[Be>>2]=c[k>>2];c[Be+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(Be+8|0)>>2]=c[k>>2];c[(Be+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(Be+16|0)>>2]=c[k>>2];c[(Be+16|0)+4>>2]=c[k+4>>2];xw(Se,4,Dg,Be);tw(Se,Oe);c[Ae>>2]=1;Dg=+h[(yw(m,1,Ae)|0)>>3];c[ze>>2]=2;Gg=+h[(yw(m,1,ze)|0)>>3]*.7557;c[ye>>2]=2;Fg=+h[(yw(m,1,ye)|0)>>3]*.2316;c[xe>>2]=2;Eg=+h[(yw(m,1,xe)|0)>>3]*.0127;h[k>>3]=Gg;c[we>>2]=c[k>>2];c[we+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(we+8|0)>>2]=c[k>>2];c[(we+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Eg;c[(we+16|0)>>2]=c[k>>2];c[(we+16|0)+4>>2]=c[k+4>>2];xw(Te,4,Dg,we);tw(Te,Pe);Te=(bh(1,1,4)|0)==0;if(!Te){we=1;do{Dg=1.0/+qw(5536,we+ -1|0);c[ve>>2]=we;h[(yw(Ne,1,ve)|0)>>3]=Dg;we=we+1|0;}while((bh(we,1,4)|0)!=0)}c[ue>>2]=1;Dg=+h[(yw(Oe,1,ue)|0)>>3];c[te>>2]=1;Eg=Dg*+h[(yw(Ne,1,te)|0)>>3];c[se>>2]=2;Dg=+h[(yw(Oe,1,se)|0)>>3];c[re>>2]=2;Fg=Dg*+h[(yw(Ne,1,re)|0)>>3];c[qe>>2]=3;Dg=+h[(yw(Oe,1,qe)|0)>>3];c[pe>>2]=3;Gg=Dg*+h[(yw(Ne,1,pe)|0)>>3];c[oe>>2]=4;Dg=+h[(yw(Oe,1,oe)|0)>>3];c[ne>>2]=4;Hg=1.0/(Eg+(Fg+(Gg+Dg*+h[(yw(Ne,1,ne)|0)>>3])));c[me>>2]=1;Dg=+h[(yw(Oe,1,me)|0)>>3];c[le>>2]=1;Gg=Dg*+h[(yw(Ne,1,le)|0)>>3];c[ke>>2]=2;Dg=+h[(yw(Oe,1,ke)|0)>>3];c[je>>2]=2;Fg=Dg*+h[(yw(Ne,1,je)|0)>>3];c[ie>>2]=3;Dg=+h[(yw(Oe,1,ie)|0)>>3];c[he>>2]=3;Eg=Dg*+h[(yw(Ne,1,he)|0)>>3];c[ge>>2]=4;Dg=+h[(yw(Oe,1,ge)|0)>>3];c[fe>>2]=4;Ig=Gg+(Fg+(Eg+Dg*+h[(yw(Ne,1,fe)|0)>>3]));c[ee>>2]=3;Dg=+h[(yw(Pe,1,ee)|0)>>3];c[de>>2]=1;Eg=+h[(yw(Oe,1,de)|0)>>3];c[ce>>2]=1;Fg=Eg*+h[(yw(Ne,1,ce)|0)>>3];c[be>>2]=2;Eg=+h[(yw(Oe,1,be)|0)>>3];c[ae>>2]=2;Gg=Eg*+h[(yw(Ne,1,ae)|0)>>3];c[$d>>2]=3;Eg=+h[(yw(Oe,1,$d)|0)>>3];c[_d>>2]=3;Jg=Eg*+h[(yw(Ne,1,_d)|0)>>3];c[Zd>>2]=4;Eg=+h[(yw(Oe,1,Zd)|0)>>3];c[Yd>>2]=4;Kg=+Yw(Fg+(Gg+(Jg+Eg*+h[(yw(Ne,1,Yd)|0)>>3])),-2);c[Xd>>2]=3;Eg=Dg*Kg*+h[(yw(Ne,1,Xd)|0)>>3];c[Wd>>2]=4;Kg=+h[(yw(Pe,1,Wd)|0)>>3];c[Vd>>2]=1;Dg=+h[(yw(Oe,1,Vd)|0)>>3];c[Ud>>2]=1;Jg=Dg*+h[(yw(Ne,1,Ud)|0)>>3];c[Td>>2]=2;Dg=+h[(yw(Oe,1,Td)|0)>>3];c[Sd>>2]=2;Gg=Dg*+h[(yw(Ne,1,Sd)|0)>>3];c[Rd>>2]=3;Dg=+h[(yw(Oe,1,Rd)|0)>>3];c[Qd>>2]=3;Fg=Dg*+h[(yw(Ne,1,Qd)|0)>>3];c[Pd>>2]=4;Dg=+h[(yw(Oe,1,Pd)|0)>>3];c[Od>>2]=4;Lg=+Yw(Jg+(Gg+(Fg+Dg*+h[(yw(Ne,1,Od)|0)>>3])),-2);c[Nd>>2]=4;Dg=-(Kg*Lg*+h[(yw(Ne,1,Nd)|0)>>3])-Eg;c[Md>>2]=1;Eg=+h[(yw(Pe,1,Md)|0)>>3];c[Ld>>2]=1;Lg=Eg*+h[(yw(Ne,1,Ld)|0)>>3];c[Kd>>2]=2;Eg=+h[(yw(Pe,1,Kd)|0)>>3];c[Jd>>2]=2;Kg=Dg-(Lg+Eg*+h[(yw(Ne,1,Jd)|0)>>3])/(Ig*Ig);if(!Te){Te=1;do{c[Id>>2]=Te;Ig=+h[(yw(Oe,1,Id)|0)>>3];Jd=Te+ -1|0;Eg=Hg*(Ig/+qw(5536,Jd));c[Hd>>2]=Te;h[(yw(Qe,1,Hd)|0)>>3]=Eg;c[Gd>>2]=Te;Eg=Kg*+h[(yw(Oe,1,Gd)|0)>>3];c[Fd>>2]=Te;Ig=Eg+Hg*+h[(yw(Pe,1,Fd)|0)>>3];Eg=Ig/+qw(5536,Jd);c[Ed>>2]=Te;h[(yw(Re,1,Ed)|0)>>3]=Eg;Te=Te+1|0;}while((bh(Te,1,4)|0)!=0)}c[Dd>>2]=1;Hg=+h[(yw(Qe,1,Dd)|0)>>3];c[Cd>>2]=2;Kg=+h[(yw(Qe,1,Cd)|0)>>3];c[Bd>>2]=3;Eg=+h[(yw(Qe,1,Bd)|0)>>3];c[Ad>>2]=4;Ig=+h[(yw(Qe,1,Ad)|0)>>3];h[k>>3]=Kg;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=Eg;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];xw(Ue,4,Hg,zd);c[(n+624|0)+0>>2]=c[Ue+0>>2];c[(n+624|0)+4>>2]=c[Ue+4>>2];c[(n+624|0)+8>>2]=c[Ue+8>>2];lj(Hf,b,d,e,n+624|0);Hg=+h[Hf>>3];c[yd>>2]=1;Ig=+h[(yw(Qe,1,yd)|0)>>3];c[xd>>2]=2;Eg=+h[(yw(Qe,1,xd)|0)>>3];c[wd>>2]=3;Kg=+h[(yw(Qe,1,wd)|0)>>3];c[vd>>2]=4;Lg=+h[(yw(Qe,1,vd)|0)>>3];h[k>>3]=Eg;c[ud>>2]=c[k>>2];c[ud+4>>2]=c[k+4>>2];h[k>>3]=Kg;c[(ud+8|0)>>2]=c[k>>2];c[(ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Lg;c[(ud+16|0)>>2]=c[k>>2];c[(ud+16|0)+4>>2]=c[k+4>>2];xw(Ve,4,Ig,ud);c[(n+608|0)+0>>2]=c[Ve+0>>2];c[(n+608|0)+4>>2]=c[Ve+4>>2];c[(n+608|0)+8>>2]=c[Ve+8>>2];oj(If,b,d,e,n+608|0);Ig=+h[If>>3];c[td>>2]=1;Lg=+h[(yw(Qe,1,td)|0)>>3];c[sd>>2]=2;Kg=+h[(yw(Qe,1,sd)|0)>>3];c[rd>>2]=3;Eg=+h[(yw(Qe,1,rd)|0)>>3];c[qd>>2]=4;Dg=+h[(yw(Qe,1,qd)|0)>>3];h[k>>3]=Kg;c[pd>>2]=c[k>>2];c[pd+4>>2]=c[k+4>>2];h[k>>3]=Eg;c[(pd+8|0)>>2]=c[k>>2];c[(pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Dg;c[(pd+16|0)>>2]=c[k>>2];c[(pd+16|0)+4>>2]=c[k+4>>2];xw(We,4,Lg,pd);c[(n+592|0)+0>>2]=c[We+0>>2];c[(n+592|0)+4>>2]=c[We+4>>2];c[(n+592|0)+8>>2]=c[We+8>>2];nj(Jf,b,d,e,n+592|0);Lg=+h[Jf>>3];c[od>>2]=1;Dg=+h[(yw(Qe,1,od)|0)>>3];c[nd>>2]=2;Eg=+h[(yw(Qe,1,nd)|0)>>3];c[md>>2]=3;Kg=+h[(yw(Qe,1,md)|0)>>3];c[ld>>2]=4;Fg=+h[(yw(Qe,1,ld)|0)>>3];h[k>>3]=Eg;c[kd>>2]=c[k>>2];c[kd+4>>2]=c[k+4>>2];h[k>>3]=Kg;c[(kd+8|0)>>2]=c[k>>2];c[(kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Fg;c[(kd+16|0)>>2]=c[k>>2];c[(kd+16|0)+4>>2]=c[k+4>>2];xw(Xe,4,Dg,kd);c[(n+576|0)+0>>2]=c[Xe+0>>2];c[(n+576|0)+4>>2]=c[Xe+4>>2];c[(n+576|0)+8>>2]=c[Xe+8>>2];rj(Kf,b,d,e,n+576|0);Dg=+h[Kf>>3];c[jd>>2]=1;Fg=+h[(yw(Qe,1,jd)|0)>>3];c[id>>2]=2;Kg=+h[(yw(Qe,1,id)|0)>>3];c[hd>>2]=3;Eg=+h[(yw(Qe,1,hd)|0)>>3];c[gd>>2]=4;Gg=+h[(yw(Qe,1,gd)|0)>>3];h[k>>3]=Kg;c[fd>>2]=c[k>>2];c[fd+4>>2]=c[k+4>>2];h[k>>3]=Eg;c[(fd+8|0)>>2]=c[k>>2];c[(fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(fd+16|0)>>2]=c[k>>2];c[(fd+16|0)+4>>2]=c[k+4>>2];xw(Ye,4,Fg,fd);c[(n+560|0)+0>>2]=c[Ye+0>>2];c[(n+560|0)+4>>2]=c[Ye+4>>2];c[(n+560|0)+8>>2]=c[Ye+8>>2];Ri(Lf,b,0.0,e,n+560|0);Fg=Hg+(Ig+(Lg+(Dg+ +h[Lf>>3])))+1.0;c[ed>>2]=1;Dg=+h[(yw(Qe,1,ed)|0)>>3];c[dd>>2]=2;Lg=+h[(yw(Qe,1,dd)|0)>>3];c[cd>>2]=3;Ig=+h[(yw(Qe,1,cd)|0)>>3];c[bd>>2]=4;Hg=+h[(yw(Qe,1,bd)|0)>>3];h[k>>3]=Lg;c[ad>>2]=c[k>>2];c[ad+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(ad+8|0)>>2]=c[k>>2];c[(ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(ad+16|0)>>2]=c[k>>2];c[(ad+16|0)+4>>2]=c[k+4>>2];xw(Ze,4,Dg,ad);c[$c>>2]=1;Dg=+h[(yw(Re,1,$c)|0)>>3];c[_c>>2]=2;Hg=+h[(yw(Re,1,_c)|0)>>3];c[Zc>>2]=3;Ig=+h[(yw(Re,1,Zc)|0)>>3];c[Yc>>2]=4;Lg=+h[(yw(Re,1,Yc)|0)>>3];h[k>>3]=Hg;c[Xc>>2]=c[k>>2];c[Xc+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(Xc+8|0)>>2]=c[k>>2];c[(Xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Lg;c[(Xc+16|0)>>2]=c[k>>2];c[(Xc+16|0)+4>>2]=c[k+4>>2];xw(_e,4,Dg,Xc);c[(n+544|0)+0>>2]=c[Ze+0>>2];c[(n+544|0)+4>>2]=c[Ze+4>>2];c[(n+544|0)+8>>2]=c[Ze+8>>2];c[(n+528|0)+0>>2]=c[_e+0>>2];c[(n+528|0)+4>>2]=c[_e+4>>2];c[(n+528|0)+8>>2]=c[_e+8>>2];pj(Mf,b,d,e,n+544|0,j,l,n+528|0);Dg=+h[Mf>>3];c[Wc>>2]=1;Lg=+h[(yw(Qe,1,Wc)|0)>>3];c[Vc>>2]=2;Ig=+h[(yw(Qe,1,Vc)|0)>>3];c[Uc>>2]=3;Hg=+h[(yw(Qe,1,Uc)|0)>>3];c[Tc>>2]=4;Gg=+h[(yw(Qe,1,Tc)|0)>>3];h[k>>3]=Ig;c[Sc>>2]=c[k>>2];c[Sc+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Sc+8|0)>>2]=c[k>>2];c[(Sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(Sc+16|0)>>2]=c[k>>2];c[(Sc+16|0)+4>>2]=c[k+4>>2];xw($e,4,Lg,Sc);c[Rc>>2]=1;Lg=+h[(yw(Re,1,Rc)|0)>>3];c[Qc>>2]=2;Gg=+h[(yw(Re,1,Qc)|0)>>3];c[Pc>>2]=3;Hg=+h[(yw(Re,1,Pc)|0)>>3];c[Oc>>2]=4;Ig=+h[(yw(Re,1,Oc)|0)>>3];h[k>>3]=Gg;c[Nc>>2]=c[k>>2];c[Nc+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Nc+8|0)>>2]=c[k>>2];c[(Nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Ig;c[(Nc+16|0)>>2]=c[k>>2];c[(Nc+16|0)+4>>2]=c[k+4>>2];xw(af,4,Lg,Nc);c[(n+512|0)+0>>2]=c[$e+0>>2];c[(n+512|0)+4>>2]=c[$e+4>>2];c[(n+512|0)+8>>2]=c[$e+8>>2];c[(n+496|0)+0>>2]=c[af+0>>2];c[(n+496|0)+4>>2]=c[af+4>>2];c[(n+496|0)+8>>2]=c[af+8>>2];qj(Nf,b,d,e,n+512|0,j,l,n+496|0);Lg=+h[Nf>>3];c[Mc>>2]=1;Ig=+h[(yw(Qe,1,Mc)|0)>>3];c[Lc>>2]=2;Hg=+h[(yw(Qe,1,Lc)|0)>>3];c[Kc>>2]=3;Gg=+h[(yw(Qe,1,Kc)|0)>>3];c[Jc>>2]=4;Eg=+h[(yw(Qe,1,Jc)|0)>>3];h[k>>3]=Hg;c[Ic>>2]=c[k>>2];c[Ic+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(Ic+8|0)>>2]=c[k>>2];c[(Ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Eg;c[(Ic+16|0)>>2]=c[k>>2];c[(Ic+16|0)+4>>2]=c[k+4>>2];xw(bf,4,Ig,Ic);c[Hc>>2]=1;Ig=+h[(yw(Re,1,Hc)|0)>>3];c[Gc>>2]=2;Eg=+h[(yw(Re,1,Gc)|0)>>3];c[Fc>>2]=3;Gg=+h[(yw(Re,1,Fc)|0)>>3];c[Ec>>2]=4;Hg=+h[(yw(Re,1,Ec)|0)>>3];h[k>>3]=Eg;c[Dc>>2]=c[k>>2];c[Dc+4>>2]=c[k+4>>2];h[k>>3]=Gg;c[(Dc+8|0)>>2]=c[k>>2];c[(Dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=Hg;c[(Dc+16|0)>>2]=c[k>>2];c[n+656>>2]=a;c[n+664>>2]=b;g[n+672>>2]=d;g[n+680>>2]=e;g[n+696>>2]=j;g[n+704>>2]=l;c[n+728>>2]=Qf;c[n+752>>2]=Rf;c[n+792>>2]=Sf;c[n+824>>2]=Tf;c[n+864>>2]=Uf;c[n+904>>2]=Vf;c[n+928>>2]=Wf;c[n+968>>2]=Xf;c[n+1008>>2]=Yf;c[n+1024>>2]=Zf;c[n+1072>>2]=_f;c[n+1104>>2]=$f;c[n+1136>>2]=ag;c[n+1168>>2]=bg;c[n+1200>>2]=cg;c[n+1240>>2]=dg;c[n+1280>>2]=eg;c[n+1312>>2]=fg;c[n+1344>>2]=gg;c[n+1392>>2]=hg;g[n+1400>>2]=Fg;c[n+1416>>2]=ig;c[n+1464>>2]=jg;c[n+1496>>2]=kg;g[n+1504>>2]=Dg;c[n+1528>>2]=lg;c[n+1576>>2]=mg;c[n+1592>>2]=ng;g[n+1600>>2]=Lg;c[n+1640>>2]=og;g[n+1648>>2]=Ig;c[n+1680>>2]=pg;c[n+1704>>2]=qg;c[n+1752>>2]=rg;c[n+1784>>2]=sg;c[n+1824>>2]=tg;c[n+1872>>2]=ug;c[n+1880>>2]=vg;c[n+1920>>2]=wg;c[n+1968>>2]=xg;c[n+1984>>2]=yg;c[n+2032>>2]=zg;c[n+2048>>2]=Ag;c[n+2088>>2]=Bg;c[n+2144>>2]=Cg;c[n+3016>>2]=Of;c[n+3272>>2]=Pf;c[n+3424>>2]=Qe;c[n+3432>>2]=Re;c[n+3464>>2]=Oe;c[n+3472>>2]=Pe;c[n+3480>>2]=Me;c[n+3568>>2]=bf;c[n+3576>>2]=cf;c[n+3592>>2]=df;c[n+3600>>2]=ef;c[n+3608>>2]=ff;c[n+3616>>2]=gf;c[n+3624>>2]=hf;c[n+3632>>2]=jf;c[n+3640>>2]=kf;c[n+3648>>2]=lf;c[n+3656>>2]=mf;c[n+3664>>2]=nf;c[n+3672>>2]=of;c[n+3680>>2]=pf;c[n+3688>>2]=qf;c[n+3696>>2]=rf;c[n+3704>>2]=sf;c[n+3712>>2]=tf;c[n+3720>>2]=uf;c[n+3728>>2]=vf;c[n+3736>>2]=wf;c[n+3744>>2]=xf;c[n+3752>>2]=yf;c[n+3760>>2]=zf;c[n+3768>>2]=Af;c[n+3776>>2]=Bf;c[n+3784>>2]=Cf;c[n+3792>>2]=Df;c[n+3800>>2]=Ef;c[n+3808>>2]=Ff;c[n+3816>>2]=Gf;c[n+3840>>2]=ta;c[n+3848>>2]=sa;c[n+3864>>2]=ra;c[n+3872>>2]=qa;c[n+3880>>2]=pa;c[n+3888>>2]=oa;c[n+3896>>2]=na;c[n+3904>>2]=ma;c[n+3912>>2]=la;c[n+3920>>2]=ka;c[n+3928>>2]=ja;c[n+3944>>2]=ia;c[n+3952>>2]=ha;c[n+3960>>2]=ga;c[n+3968>>2]=fa;c[n+3976>>2]=ea;c[n+3984>>2]=da;c[n+3992>>2]=ca;c[n+4e3>>2]=ba;c[n+4008>>2]=aa;c[n+4024>>2]=$;c[n+4032>>2]=_;c[n+4040>>2]=Z;c[n+4048>>2]=Y;c[n+4056>>2]=X;c[n+4064>>2]=W;c[n+4072>>2]=V;c[n+4080>>2]=U;c[n+4088>>2]=T;c[n+4104>>2]=S;c[n+4112>>2]=R;c[n+4120>>2]=Q;c[n+4128>>2]=P;c[n+4136>>2]=O;c[n+4144>>2]=N;c[n+4152>>2]=M;c[n+4160>>2]=L;c[n+4168>>2]=K;c[n+4176>>2]=J;c[n+4192>>2]=G;c[n+4200>>2]=F;c[n+4208>>2]=E;c[n+4216>>2]=D;c[n+4224>>2]=C;c[n+4232>>2]=B;c[n+4240>>2]=z;c[n+4248>>2]=y;c[n+4256>>2]=x;c[n+4264>>2]=w;c[n+4280>>2]=v;c[n+4288>>2]=u;c[n+4296>>2]=t;c[n+4304>>2]=s;c[n+4312>>2]=r;c[n+4320>>2]=q;c[n+4328>>2]=p;c[n+4336>>2]=o;c[n+5096>>2]=Dc;c[n+5104>>2]=Cc;c[n+5112>>2]=Bc;c[n+5120>>2]=Ac;c[n+5136>>2]=zc;c[n+5144>>2]=yc;c[n+5160>>2]=xc;c[n+5168>>2]=wc;c[n+5176>>2]=vc;c[n+5184>>2]=uc;c[n+5192>>2]=tc;c[n+5200>>2]=sc;c[n+5208>>2]=rc;c[n+5216>>2]=qc;c[n+5224>>2]=pc;c[n+5240>>2]=oc;c[n+5248>>2]=nc;c[n+5256>>2]=mc;c[n+5264>>2]=lc;c[n+5272>>2]=kc;c[n+5280>>2]=jc;c[n+5288>>2]=ic;c[n+5296>>2]=hc;c[n+5304>>2]=gc;c[n+5320>>2]=fc;c[n+5328>>2]=ec;c[n+5336>>2]=dc;c[n+5344>>2]=cc;c[n+5352>>2]=bc;c[n+5360>>2]=ac;c[n+5368>>2]=$b;c[n+5376>>2]=_b;c[n+5384>>2]=Zb;c[n+5392>>2]=Yb;c[n+5400>>2]=Xb;c[n+5408>>2]=Wb;c[n+5416>>2]=Vb;c[n+5424>>2]=Ub;c[n+5440>>2]=Tb;c[n+5448>>2]=Sb;c[n+5456>>2]=Rb;c[n+5464>>2]=Qb;c[n+5472>>2]=Pb;c[n+5480>>2]=Ob;c[n+5488>>2]=Nb;c[n+5496>>2]=Mb;c[n+5504>>2]=Lb;c[n+5520>>2]=Kb;c[n+5528>>2]=Jb;c[n+5536>>2]=Ib;c[n+5544>>2]=Hb;c[n+5552>>2]=Gb;c[n+5560>>2]=Fb;c[n+5568>>2]=Eb;c[n+5576>>2]=Db;c[n+5584>>2]=Cb;c[n+5600>>2]=Bb;c[n+5608>>2]=Ab;c[n+5616>>2]=zb;c[n+5624>>2]=yb;c[n+5632>>2]=xb;c[n+5640>>2]=wb;c[n+5648>>2]=vb;c[n+5656>>2]=ub;c[n+5664>>2]=tb;c[n+5680>>2]=sb;c[n+5688>>2]=rb;c[n+5696>>2]=qb;c[n+5704>>2]=pb;c[n+5712>>2]=ob;c[n+5720>>2]=nb;c[n+5728>>2]=mb;c[n+5736>>2]=lb;c[n+5744>>2]=kb;c[n+5760>>2]=jb;c[n+5768>>2]=ib;c[n+5776>>2]=hb;c[n+5784>>2]=gb;c[n+5792>>2]=fb;c[n+5800>>2]=eb;c[n+5808>>2]=db;c[n+5816>>2]=cb;c[n+5824>>2]=bb;c[n+5832>>2]=ab;c[n+5848>>2]=$a;c[n+5856>>2]=_a;c[n+5864>>2]=Za;c[n+5872>>2]=Ya;c[n+5880>>2]=Xa;c[n+5888>>2]=Wa;c[n+5896>>2]=Va;c[n+5904>>2]=Ua;c[n+5912>>2]=Ta;c[n+5928>>2]=Sa;c[n+5936>>2]=Ra;c[n+5952>>2]=Qa;c[n+5960>>2]=Pa;c[n+5968>>2]=Oa;c[n+5976>>2]=Na;c[n+5984>>2]=Ma;c[n+5992>>2]=La;c[n+6e3>>2]=Ka;c[n+6016>>2]=Ja;c[n+6024>>2]=Ia;c[n+6032>>2]=Ha;c[n+6040>>2]=Ga;c[n+6048>>2]=Fa;c[n+6056>>2]=Ea;c[n+6064>>2]=Da;c[n+6072>>2]=Ca;c[n+6080>>2]=Ba;c[n+6096>>2]=Aa;c[n+6104>>2]=za;c[n+6112>>2]=ya;c[n+6120>>2]=xa;c[n+6128>>2]=wa;c[n+6136>>2]=va;c[n+6144>>2]=ua;c[n+6160>>2]=0;c[n+6164>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_h__dis__pTX__der$0(n);H=c[n+6160>>2]|0;A=c[n+6164>>2]|0;I=+g[n+6164>>2];c[n+6160>>2]=0;c[n+6164>>2]=0;if((H|0)==5){return}}function Nj(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0;l=i;i=i+1032|0;m=l;n=l+16|0;o=l+136|0;p=l+256|0;q=l+352|0;r=l+448|0;s=l+544|0;t=l+640|0;u=l+736|0;v=l+752|0;w=l+768|0;x=l+784|0;y=l+880|0;z=l+896|0;A=l+912|0;B=l+928|0;C=l+1024|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+96|0;I=i;i=i+96|0;J=i;i=i+96|0;K=i;i=i+96|0;L=i;i=i+96|0;M=i;i=i+96|0;N=i;i=i+96|0;O=i;i=i+120|0;P=i;i=i+120|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;c[G>>2]=1;if(+h[(yw(f,1,G)|0)>>3]==0.0){Xg(H,b,d,e);Aa=B+0|0;Ba=H+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));eh(Q,0,0.0,e,B,g,j);Da=+h[Q>>3];Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}Q=A;B=f;c[Q+0>>2]=c[B+0>>2];c[Q+4>>2]=c[B+4>>2];c[Q+8>>2]=c[B+8>>2];Oi(R,b,d,e,A);Ga=+h[R>>3];R=z;A=f;c[R+0>>2]=c[A+0>>2];c[R+4>>2]=c[A+4>>2];c[R+8>>2]=c[A+8>>2];A=y;R=k;c[A+0>>2]=c[R+0>>2];c[A+4>>2]=c[R+4>>2];c[A+8>>2]=c[R+8>>2];Oj(S,b,d,e,z,g,j,y);Ha=+h[S>>3];Ia=d-Ga;Ja=g-Ha;c[F>>2]=1;Ka=+h[(yw(f,1,F)|0)>>3];c[E>>2]=1;La=Ka/(1.0- +h[(yw(f,1,E)|0)>>3]);c[D>>2]=1;Ka=1.0- +h[(yw(f,1,D)|0)>>3];c[C>>2]=1;Ma=+h[(yw(k,1,C)|0)>>3]/(Ka*Ka);Ni(T,b,d,e);Ka=+h[T>>3];Pj(U,b,d,e,g,j);Na=+h[U>>3];U=La<=Ka|Ka==-1.0;do{if(U){if(!(e>=773.15)){Xg(J,b,Ia,e);Aa=t+0|0;Ba=J+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));eh(_,0,0.0,e,t,Ja,j);Oa=+h[_>>3];Wi($,b,Ga,e,0);Pa=+h[$>>3];Xi(aa,b,Ga,e,0,Ha,j);Qa=Oa+(Ma*Pa+La*+h[aa>>3]);Ra=11;break}else{Xg(I,b,Ia,e);Aa=x+0|0;Ba=I+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));eh(V,0,0.0,e,x,Ja,j);Pa=+h[V>>3];Wi(W,b,Ga,e,0);Oa=+h[W>>3];Xi(X,b,Ga,e,0,Ha,j);Sa=+h[X>>3];T=w;C=f;c[T+0>>2]=c[C+0>>2];c[T+4>>2]=c[C+4>>2];c[T+8>>2]=c[C+8>>2];Lj(Y,b,d,e,w);Ta=+h[Y>>3];C=v;T=f;c[C+0>>2]=c[T+0>>2];c[C+4>>2]=c[T+4>>2];c[C+8>>2]=c[T+8>>2];T=u;C=k;c[T+0>>2]=c[C+0>>2];c[T+4>>2]=c[C+4>>2];c[T+8>>2]=c[C+8>>2];Mj(Z,b,d,e,v,g,j,u);Ua=Pa+(Ma*Oa+(La*Sa+(Ma*Ta+La*+h[Z>>3])));Ra=10;break}}else{if(e<273.16){Xg(K,b,Ia,e);Aa=s+0|0;Ba=K+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));eh(ba,0,0.0,e,s,Ja,j);Ta=+h[ba>>3];Wi(ca,b,Ga,e,0);Sa=+h[ca>>3];Xi(da,b,Ga,e,0,Ha,j);Oa=+h[da>>3];ij(ea,b,d,e);Pa=+h[ea>>3];dj(L,b,d,e);Aa=r+0|0;Ba=L+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));kj(fa,0,0.0,0.0,r,g,j);Va=+h[fa>>3];ij(ga,b,d,e);Wa=+h[ga>>3];dj(M,b,d,e);Aa=q+0|0;Ba=M+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));kj(ha,0,0.0,0.0,q,g,j);Ua=Ta+(Na*Sa+(Ka*Oa+(Ma*Pa+(La*Va+(-(Na*Wa)-Ka*+h[ha>>3])))));Ra=10;break}else{Xg(N,b,d,e);Aa=p+0|0;Ba=N+0|0;Ca=Aa+96|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));eh(ia,0,0.0,e,p,Ja,j);Wa=+h[ia>>3];Wi(ja,b,Ga,e,0);Va=+h[ja>>3];Xi(ka,b,Ga,e,0,Ha,j);Pa=+h[ka>>3];Uh(la,b,d,e,0);Oa=+h[la>>3];Qj(O,b,d,e,0);Aa=o+0|0;Ba=O+0|0;Ca=Aa+120|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));Rj(ma,0,0.0,e,o,g,j);Sa=+h[ma>>3];Uh(na,b,d,e,0);Ta=+h[na>>3];Qj(P,b,d,e,0);Aa=n+0|0;Ba=P+0|0;Ca=Aa+120|0;do{c[Aa>>2]=c[Ba>>2];Aa=Aa+4|0;Ba=Ba+4|0}while((Aa|0)<(Ca|0));Rj(oa,0,0.0,e,n,g,j);Xa=Wa+(Na*Va+(Ka*Pa+(Ma*Oa+(La*Sa+(-(Na*Ta)-Ka*+h[oa>>3])))));Ra=14;break}}}while(0);if((Ra|0)==10){if(U){Qa=Ua;Ra=11}else{Xa=Ua;Ra=14}}do{if((Ra|0)==11){if(!(e>=773.15)){Wg(sa,b,Ia,e);Ua=+h[sa>>3];Wi(ta,b,Ga,e,0);Ya=Ua+La*+h[ta>>3];Za=Qa;break}else{Wg(pa,b,Ia,e);Ua=+h[pa>>3];Wi(qa,b,Ga,e,0);Na=+h[qa>>3];U=m;oa=f;c[U+0>>2]=c[oa+0>>2];c[U+4>>2]=c[oa+4>>2];c[U+8>>2]=c[oa+8>>2];Lj(ra,b,d,e,m);Ya=Ua+(La*Na+(La+1.0)*+h[ra>>3]);Za=Qa;break}}else if((Ra|0)==14){if(e<273.16){Wg(ua,b,Ia,e);Na=+h[ua>>3];Wi(va,b,Ga,e,0);Ua=+h[va>>3];ij(wa,b,d,e);Ya=Na+(Ka*Ua+(La-Ka)*+h[wa>>3]);Za=Xa;break}else{Wg(xa,b,Ia,e);Ua=+h[xa>>3];Wi(ya,b,Ga,e,0);Na=+h[ya>>3];Uh(za,b,d,e,0);Ya=Ua+(Ka*Na+(La-Ka)*+h[za>>3]);Za=Xa;break}}}while(0);Xa=La+1.0;Da=(Xa*Za-Ma*Ya)/(Xa*Xa);Ea=a;Fa=Ea;h[Fa>>3]=Da;i=l;return}function Oj(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;c[q>>2]=1;if(+h[(yw(f,1,q)|0)>>3]==0.0){t=0.0;u=a;v=u;h[v>>3]=t;i=l;return}c[p>>2]=1;w=+h[(yw(f,1,p)|0)>>3];c[o>>2]=1;x=w/(1.0- +h[(yw(f,1,o)|0)>>3]);c[n>>2]=1;w=1.0- +h[(yw(f,1,n)|0)>>3];c[m>>2]=1;y=+h[(yw(k,1,m)|0)>>3]/(w*w);Sj(r,b,d,e,0.0,j);j=+h[r>>3];Ni(s,b,d,e);e=+h[s>>3];t=x<=e|e==-1.0?y*d*.6221042453709779+x*(g/(x+.6221042453709779)):j;u=a;v=u;h[v>>3]=t;i=l;return}function Pj(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;k=g+8|0;l=g+16|0;m=g+24|0;Jj(j,b,c,d);e=+h[j>>3];Sj(k,b,c,d,0.0,f);f=+h[k>>3];if(!(d<=273.16)){Bj(m,b,c);n=+h[m>>3]}else{gj(l,b,c);n=+h[l>>3]}if(!(n>=d)){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}d=c-e;o=f*(c/(d*d))*.6221042453709779;p=a;q=p;h[q>>3]=o;i=g;return}function Qj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){Uj(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==5){Zj(q,b,d,e);s=+h[q+24>>3];t=+h[q+32>>3];u=+h[q+48>>3];v=+h[q+56>>3];w=+h[q+72>>3];x=+h[q+80>>3];y=t*+h[q+64>>3];z=(y- +h[q+40>>3])*461.526;A=s*u;B=(A-t*s*x)/d*461.526;C=s*s*v*+Yw(d,-2)*e*461.526;s=t*t*w;w=u-t*x;D=0.0;E=0.0;F=B;G=C;H=1.0;I=-B/C;J=y*e*461.526;K=s*-461.526;L=(w*w/v-s)*461.526;M=d/(A*e*461.526);N=z}else if((r|0)==1){Vj(m,b,d,e);z=+h[m+24>>3];A=+h[m+32>>3];s=+h[m+48>>3];v=+h[m+56>>3];w=+h[m+72>>3];y=+h[m+80>>3];C=A*+h[m+64>>3];B=(C- +h[m+40>>3])*461.526;x=z*s;t=(x-A*z*y)/d*461.526;u=z*z*v*+Yw(d,-2)*e*461.526;z=A*A*w;w=s-A*y;D=0.0;E=0.0;F=t;G=u;H=0.0;I=-t/u;J=C*e*461.526;K=z*-461.526;L=(w*w/v-z)*461.526;M=d/(x*e*461.526);N=B}else if((r|0)==3){Xj(o,b,d,e,1.0e-7);B=+h[o>>3];Yj(p,b,B,e);x=+h[p+24>>3];z=+h[p+32>>3];v=+h[p+48>>3];w=z*+h[p+64>>3];C=B*x*(v-z*+h[p+80>>3])*461.526;D=C;E=x*(v*2.0+x*+h[p+56>>3])*e*461.526;F=0.0;G=0.0;H=0.0;I=C;J=(x*v+w)*e*461.526;K=0.0;L=z*z*+h[p+72>>3]*-461.526;M=B;N=(w- +h[p+40>>3])*461.526}else if((r|0)==2){Wj(n,b,d,e);w=+h[n+24>>3];B=+h[n+32>>3];z=+h[n+48>>3];v=+h[n+56>>3];x=+h[n+72>>3];C=+h[n+80>>3];u=B*+h[n+64>>3];t=(u- +h[n+40>>3])*461.526;y=w*z;A=(y-B*w*C)/d*461.526;s=w*w*v*+Yw(d,-2)*e*461.526;w=B*B*x;x=z-B*C;D=0.0;E=0.0;F=A;G=s;H=1.0;I=-A/s;J=u*e*461.526;K=w*-461.526;L=(x*x/v-w)*461.526;M=d/(y*e*461.526);N=t}else{n=dw(dw(6e3,bw(d,0,1,6)|0)|0,6056)|0;p=dw(dw(n,bw(e,0,1,6)|0)|0,6064)|0;n=c[22536]|0;o=j;m=6160;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[o+16>>2]=c[m+16>>2];c[o+20>>2]=c[m+20>>2];De[n&31](b,j,p,k);D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0;L=0.0;M=0.0;N=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=J;h[a+32>>3]=461.526;h[a+40>>3]=K;h[a+48>>3]=L;h[a+56>>3]=M;h[a+64>>3]=N;h[a+72>>3]=D;h[a+80>>3]=E;h[a+88>>3]=F;h[a+96>>3]=G;h[a+104>>3]=H;h[a+112>>3]=I;i=g;return}function Rj(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0;b=i;d=+h[f+56>>3];if((c[f+4>>2]|0)==3){k=+h[f+72>>3];l=+h[f+80>>3];m=(k*e-d*l)*+Yw(d,-2)*(g/l);e=d*d*l*+h[f+48>>3]+k*k*+h[f+16>>3];n=m+e*+Yw(d,-2)*(j/l);o=a;p=o;h[p>>3]=n;i=b;return}else{n=+h[f+40>>3]*j+(1.0/d- +h[f+16>>3]*+h[f+88>>3])*g;o=a;p=o;h[p>>3]=n;i=b;return}}function Sj(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0.0,r=0,s=0;g=i;i=i+32|0;j=g;k=g+8|0;l=g+16|0;m=g+24|0;if(!(d>=273.16)){jj(l,0,d,f);e=+h[l>>3];gj(m,b,c);n=+h[m>>3];o=e;p=!(n>=d);q=p?0.0:o;r=a;s=r;h[s>>3]=q;i=g;return}else{Ij(j,b,d,f);f=+h[j>>3];Bj(k,b,c);n=+h[k>>3];o=f;p=!(n>=d);q=p?0.0:o;r=a;s=r;h[s>>3]=q;i=g;return}}function Tj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;c[l>>2]=1;if(+h[(yw(f,1,l)|0)>>3]==0.0){p=0.0;q=a;r=q;h[r>>3]=p;i=g;return}c[k>>2]=1;s=+h[(yw(f,1,k)|0)>>3];c[j>>2]=1;t=s/(1.0- +h[(yw(f,1,j)|0)>>3]);if(!(e>=273.16)){fj(n,0,e);u=+h[n>>3]}else{_h(m,b,e);u=+h[m>>3]}uj(o,0,0.0,0.0);e=u*+h[o>>3];u=t*(d/(t+.6221042453709779));if(!(u<=e)){p=-1.0;q=a;r=q;h[r>>3]=p;i=g;return}p=u/e;q=a;r=q;h[r>>3]=p;i=g;return}function Uj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}fk(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}gk(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function Vj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0.0,Ne=0.0,Oe=0.0,Pe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+16|0;c[ve>>2]=45;sw(we,1,ve);if(!(d>611.657)){ve=dw(dw(7072,bw(d,0,1,6)|0)|0,6664)|0;xe=dw(dw(ve,bw(611.657,0,1,6)|0)|0,6672)|0;ve=c[22536]|0;ye=k;ze=7136;c[ye+0>>2]=c[ze+0>>2];c[ye+4>>2]=c[ze+4>>2];c[ye+8>>2]=c[ze+8>>2];c[ye+12>>2]=c[ze+12>>2];c[ye+16>>2]=c[ze+16>>2];c[ye+20>>2]=c[ze+20>>2];De[ve&31](b,k,xe,ue);}if(!(d<=1.0e8)){ue=dw(dw(7160,bw(d,0,1,6)|0)|0,7208)|0;xe=c[22536]|0;k=j;ve=7240;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];De[xe&31](b,j,ue,te);}if(!(e>=273.15)){te=dw(dw(7264,bw(e,0,1,6)|0)|0,7312)|0;ue=c[22536]|0;j=g;xe=7344;c[j+0>>2]=c[xe+0>>2];c[j+4>>2]=c[xe+4>>2];c[j+8>>2]=c[xe+8>>2];c[j+12>>2]=c[xe+12>>2];c[j+16>>2]=c[xe+16>>2];c[j+20>>2]=c[xe+20>>2];De[ue&31](b,g,te,se);}Ae=d/1653.0e4;Be=1386.0/e;Ce=7.1-Ae;Ee=Be+-1.222;c[re>>2]=1;h[(yw(we,1,re)|0)>>3]=Ee*Ee;c[qe>>2]=1;Fe=+h[(yw(we,1,qe)|0)>>3];c[pe>>2]=2;h[(yw(we,1,pe)|0)>>3]=Fe*Fe;c[oe>>2]=2;Fe=+h[(yw(we,1,oe)|0)>>3];c[ne>>2]=3;h[(yw(we,1,ne)|0)>>3]=Fe*Fe;c[me>>2]=3;Fe=Ee*+h[(yw(we,1,me)|0)>>3];c[le>>2]=4;h[(yw(we,1,le)|0)>>3]=Fe;c[ke>>2]=4;Fe=1.0/+h[(yw(we,1,ke)|0)>>3];c[je>>2]=5;h[(yw(we,1,je)|0)>>3]=Fe;c[ie>>2]=1;Fe=+h[(yw(we,1,ie)|0)>>3];c[he>>2]=2;Ge=Fe*+h[(yw(we,1,he)|0)>>3];c[ge>>2]=6;h[(yw(we,1,ge)|0)>>3]=Ge;c[fe>>2]=1;Ge=Ee*+h[(yw(we,1,fe)|0)>>3];c[ee>>2]=7;h[(yw(we,1,ee)|0)>>3]=Ge;c[de>>2]=7;Ge=1.0/+h[(yw(we,1,de)|0)>>3];c[ce>>2]=8;h[(yw(we,1,ce)|0)>>3]=Ge;c[be>>2]=1;Ge=+h[(yw(we,1,be)|0)>>3];c[ae>>2]=2;Fe=+h[(yw(we,1,ae)|0)>>3];c[$d>>2]=3;He=Ge*Fe*+h[(yw(we,1,$d)|0)>>3];c[_d>>2]=9;h[(yw(we,1,_d)|0)>>3]=He;c[Zd>>2]=2;He=1.0/+h[(yw(we,1,Zd)|0)>>3];c[Yd>>2]=10;h[(yw(we,1,Yd)|0)>>3]=He;c[Xd>>2]=2;He=Ee*+h[(yw(we,1,Xd)|0)>>3];c[Wd>>2]=11;h[(yw(we,1,Wd)|0)>>3]=He;c[Vd>>2]=11;He=1.0/+h[(yw(we,1,Vd)|0)>>3];c[Ud>>2]=12;h[(yw(we,1,Ud)|0)>>3]=He;c[Td>>2]=2;He=+h[(yw(we,1,Td)|0)>>3];c[Sd>>2]=3;Fe=He*+h[(yw(we,1,Sd)|0)>>3];c[Rd>>2]=13;h[(yw(we,1,Rd)|0)>>3]=Fe;c[Qd>>2]=3;Fe=1.0/+h[(yw(we,1,Qd)|0)>>3];c[Pd>>2]=14;h[(yw(we,1,Pd)|0)>>3]=Fe;c[Od>>2]=15;h[(yw(we,1,Od)|0)>>3]=Ce*Ce;c[Nd>>2]=15;Fe=Ce*+h[(yw(we,1,Nd)|0)>>3];c[Md>>2]=16;h[(yw(we,1,Md)|0)>>3]=Fe;c[Ld>>2]=15;Fe=+h[(yw(we,1,Ld)|0)>>3];c[Kd>>2]=17;h[(yw(we,1,Kd)|0)>>3]=Fe*Fe;c[Jd>>2]=17;Fe=+h[(yw(we,1,Jd)|0)>>3];c[Id>>2]=18;h[(yw(we,1,Id)|0)>>3]=Fe*Fe;c[Hd>>2]=17;Fe=+h[(yw(we,1,Hd)|0)>>3];c[Gd>>2]=18;He=Fe*Ce*+h[(yw(we,1,Gd)|0)>>3];c[Fd>>2]=19;h[(yw(we,1,Fd)|0)>>3]=He;c[Ed>>2]=15;He=+h[(yw(we,1,Ed)|0)>>3];c[Dd>>2]=17;Fe=He*+h[(yw(we,1,Dd)|0)>>3];c[Cd>>2]=20;h[(yw(we,1,Cd)|0)>>3]=Fe;c[Bd>>2]=3;Fe=+h[(yw(we,1,Bd)|0)>>3];c[Ad>>2]=21;h[(yw(we,1,Ad)|0)>>3]=Fe*Fe;c[zd>>2]=21;Fe=+h[(yw(we,1,zd)|0)>>3];c[yd>>2]=22;h[(yw(we,1,yd)|0)>>3]=Fe*Fe;c[xd>>2]=22;Fe=+h[(yw(we,1,xd)|0)>>3];c[wd>>2]=3;He=Fe*Ee*+h[(yw(we,1,wd)|0)>>3];c[vd>>2]=23;h[(yw(we,1,vd)|0)>>3]=He;c[ud>>2]=23;He=1.0/+h[(yw(we,1,ud)|0)>>3];c[td>>2]=24;h[(yw(we,1,td)|0)>>3]=He;c[sd>>2]=22;He=+h[(yw(we,1,sd)|0)>>3];c[rd>>2]=3;Fe=He*+h[(yw(we,1,rd)|0)>>3];c[qd>>2]=25;h[(yw(we,1,qd)|0)>>3]=Fe;c[pd>>2]=25;Fe=1.0/+h[(yw(we,1,pd)|0)>>3];c[od>>2]=26;h[(yw(we,1,od)|0)>>3]=Fe;c[nd>>2]=1;Fe=+h[(yw(we,1,nd)|0)>>3];c[md>>2]=2;He=+h[(yw(we,1,md)|0)>>3];c[ld>>2]=22;Ge=Fe*He*Ee*+h[(yw(we,1,ld)|0)>>3];c[kd>>2]=27;h[(yw(we,1,kd)|0)>>3]=Ge;c[jd>>2]=27;Ge=1.0/+h[(yw(we,1,jd)|0)>>3];c[id>>2]=28;h[(yw(we,1,id)|0)>>3]=Ge;c[hd>>2]=1;Ge=+h[(yw(we,1,hd)|0)>>3];c[gd>>2]=2;He=+h[(yw(we,1,gd)|0)>>3];c[fd>>2]=22;Fe=Ge*He*+h[(yw(we,1,fd)|0)>>3];c[ed>>2]=29;h[(yw(we,1,ed)|0)>>3]=Fe;c[dd>>2]=29;Fe=1.0/+h[(yw(we,1,dd)|0)>>3];c[cd>>2]=30;h[(yw(we,1,cd)|0)>>3]=Fe;c[bd>>2]=1;Fe=+h[(yw(we,1,bd)|0)>>3];c[ad>>2]=2;He=+h[(yw(we,1,ad)|0)>>3];c[$c>>2]=21;Ge=+h[(yw(we,1,$c)|0)>>3];c[_c>>2]=3;Ie=Fe*He*Ge*Ee*+h[(yw(we,1,_c)|0)>>3];c[Zc>>2]=31;h[(yw(we,1,Zc)|0)>>3]=Ie;c[Yc>>2]=31;Ie=1.0/+h[(yw(we,1,Yc)|0)>>3];c[Xc>>2]=32;h[(yw(we,1,Xc)|0)>>3]=Ie;c[Wc>>2]=2;Ie=+h[(yw(we,1,Wc)|0)>>3];c[Vc>>2]=21;Ge=+h[(yw(we,1,Vc)|0)>>3];c[Uc>>2]=3;He=Ie*Ge*Ee*+h[(yw(we,1,Uc)|0)>>3];c[Tc>>2]=33;h[(yw(we,1,Tc)|0)>>3]=He;c[Sc>>2]=33;He=1.0/+h[(yw(we,1,Sc)|0)>>3];c[Rc>>2]=34;h[(yw(we,1,Rc)|0)>>3]=He;c[Qc>>2]=1;He=+h[(yw(we,1,Qc)|0)>>3];c[Pc>>2]=3;Ge=He*Ee*+h[(yw(we,1,Pc)|0)>>3];c[Oc>>2]=35;h[(yw(we,1,Oc)|0)>>3]=Ge;c[Nc>>2]=35;Ge=1.0/+h[(yw(we,1,Nc)|0)>>3];c[Mc>>2]=36;h[(yw(we,1,Mc)|0)>>3]=Ge;c[Lc>>2]=1;Ge=+h[(yw(we,1,Lc)|0)>>3];c[Kc>>2]=3;He=Ge*+h[(yw(we,1,Kc)|0)>>3];c[Jc>>2]=37;h[(yw(we,1,Jc)|0)>>3]=He;c[Ic>>2]=37;He=1.0/+h[(yw(we,1,Ic)|0)>>3];c[Hc>>2]=38;h[(yw(we,1,Hc)|0)>>3]=He;c[Gc>>2]=6;He=1.0/+h[(yw(we,1,Gc)|0)>>3];c[Fc>>2]=39;h[(yw(we,1,Fc)|0)>>3]=He;c[Ec>>2]=1;He=+h[(yw(we,1,Ec)|0)>>3];c[Dc>>2]=22;Ge=+h[(yw(we,1,Dc)|0)>>3];c[Cc>>2]=3;Ie=He*Ge*+h[(yw(we,1,Cc)|0)>>3];c[Bc>>2]=40;h[(yw(we,1,Bc)|0)>>3]=Ie;c[Ac>>2]=40;Ie=1.0/+h[(yw(we,1,Ac)|0)>>3];c[zc>>2]=41;h[(yw(we,1,zc)|0)>>3]=Ie;c[yc>>2]=22;Ie=1.0/+h[(yw(we,1,yc)|0)>>3];c[xc>>2]=42;h[(yw(we,1,xc)|0)>>3]=Ie;c[wc>>2]=1;Ie=+h[(yw(we,1,wc)|0)>>3];c[vc>>2]=2;Ge=+h[(yw(we,1,vc)|0)>>3];c[uc>>2]=21;He=+h[(yw(we,1,uc)|0)>>3];c[tc>>2]=3;Fe=Ie*Ge*He*+h[(yw(we,1,tc)|0)>>3];c[sc>>2]=43;h[(yw(we,1,sc)|0)>>3]=Fe;c[rc>>2]=43;Fe=1.0/+h[(yw(we,1,rc)|0)>>3];c[qc>>2]=44;h[(yw(we,1,qc)|0)>>3]=Fe;c[pc>>2]=13;Fe=1.0/+h[(yw(we,1,pc)|0)>>3];c[oc>>2]=45;h[(yw(we,1,oc)|0)>>3]=Fe;c[nc>>2]=10;Fe=+h[(yw(we,1,nc)|0)>>3];c[mc>>2]=2;He=+h[(yw(we,1,mc)|0)>>3];c[lc>>2]=6;Ge=Fe*(He*(+h[(yw(we,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;He=+h[(yw(we,1,kc)|0)>>3];c[jc>>2]=13;Fe=+h[(yw(we,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;Ie=He*(Fe*+h[(yw(we,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Fe=+h[(yw(we,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;He=+h[(yw(we,1,gc)|0)>>3];c[fc>>2]=11;Je=+h[(yw(we,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Ke=Je*+h[(yw(we,1,ec)|0)>>3];c[dc>>2]=19;Je=+h[(yw(we,1,dc)|0)>>3];c[cc>>2]=34;Le=+h[(yw(we,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Me=+h[(yw(we,1,bc)|0)>>3];c[ac>>2]=32;Ne=+h[(yw(we,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Oe=+h[(yw(we,1,$b)|0)>>3];c[_b>>2]=30;Pe=+h[(yw(we,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(yw(we,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(yw(we,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=Ce*(Ge+Ce*(Ie+Ce*(Fe+He*(Ke+Je*(Le+Me*(Ne+Oe*(Pe+Ce*(Qe+Ce*(Re+Ce*+h[(yw(we,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(yw(we,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(yw(we,1,Vb)|0)>>3];c[Ub>>2]=1;Pe=+h[(yw(we,1,Ub)|0)>>3];c[Tb>>2]=9;Oe=Ce*(Re*(Qe*(Ee*(Pe*(+h[(yw(we,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(yw(we,1,Sb)|0)>>3];c[Rb>>2]=1;Pe=+h[(yw(we,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(yw(we,1,Qb)|0)>>3];c[Pb>>2]=1;Re=Ce*(Oe+Se*(Pe*(Qe*(Ee*(Ee*(+h[(yw(we,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(yw(we,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(yw(we,1,Nb)|0)>>3];c[Mb>>2]=2;Pe=+h[(yw(we,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Pe*(+h[(yw(we,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Pe=+h[(yw(we,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(yw(we,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Oe=Pe*(Re*+h[(yw(we,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(yw(we,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Pe=+h[(yw(we,1,Gb)|0)>>3];c[Fb>>2]=11;Ne=+h[(yw(we,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Me=Ne*+h[(yw(we,1,Eb)|0)>>3];c[Db>>2]=19;Ne=+h[(yw(we,1,Db)|0)>>3];c[Cb>>2]=34;Le=+h[(yw(we,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Je=+h[(yw(we,1,Bb)|0)>>3];c[Ab>>2]=32;Ke=+h[(yw(we,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;He=+h[(yw(we,1,zb)|0)>>3];c[yb>>2]=30;Fe=+h[(yw(we,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;Ie=+h[(yw(we,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Ge=+h[(yw(we,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=Ce*(Se+Ce*(Oe+Ce*(Re+Pe*(Me+Ne*(Le+Je*(Ke+He*(Fe+Ce*(Ie+Ce*(Ge+Ce*+h[(yw(we,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Ge=+h[(yw(we,1,ub)|0)>>3];c[tb>>2]=7;Ie=+h[(yw(we,1,tb)|0)>>3];c[sb>>2]=1;Fe=+h[(yw(we,1,sb)|0)>>3];c[rb>>2]=9;He=Ce*(Ge*(Ie*(Ee*(Fe*(+h[(yw(we,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(yw(we,1,qb)|0)>>3];c[pb>>2]=1;Fe=+h[(yw(we,1,pb)|0)>>3];c[ob>>2]=6;Ie=+h[(yw(we,1,ob)|0)>>3];c[nb>>2]=1;Ge=He+Te*(Fe*(Ie*(Ee*(Ee*(+h[(yw(we,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;Ie=+h[(yw(we,1,mb)|0)>>3];c[lb>>2]=2;Fe=+h[(yw(we,1,lb)|0)>>3];c[kb>>2]=6;Te=Ie*(Fe*(+h[(yw(we,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Fe=+h[(yw(we,1,jb)|0)>>3];c[ib>>2]=13;Ie=+h[(yw(we,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;He=Fe*(Ie*+h[(yw(we,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;Ie=+h[(yw(we,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Fe=+h[(yw(we,1,fb)|0)>>3];c[eb>>2]=11;Ke=+h[(yw(we,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Je=Ke*+h[(yw(we,1,db)|0)>>3];c[cb>>2]=19;Ke=+h[(yw(we,1,cb)|0)>>3];c[bb>>2]=34;Le=+h[(yw(we,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Ne=+h[(yw(we,1,ab)|0)>>3];c[$a>>2]=32;Me=+h[(yw(we,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Pe=+h[(yw(we,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(yw(we,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Oe=+h[(yw(we,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(yw(we,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=Ce*(Te+Ce*(He+Ce*(Ie+Fe*(Je+Ke*(Le+Ne*(Me+Pe*(Re+Ce*(Oe+Ce*(Se+Ce*+h[(yw(we,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(yw(we,1,Va)|0)>>3];c[Ua>>2]=7;Oe=+h[(yw(we,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(yw(we,1,Ta)|0)>>3];c[Sa>>2]=9;Pe=Se*(Oe*(Ee*(Re*(+h[(yw(we,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(yw(we,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(yw(we,1,Qa)|0)>>3];c[Pa>>2]=1;Oe=+h[(yw(we,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Oe*+h[(yw(we,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Oe=Ue*(Re*(Se*+h[(yw(we,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(yw(we,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(yw(we,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(yw(we,1,Ka)|0)>>3];c[Ja>>2]=9;Me=Se*(Re*(Ue*(+h[(yw(we,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(yw(we,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(yw(we,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(yw(we,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(yw(we,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Ne=Ue*(Se*+h[(yw(we,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(yw(we,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(yw(we,1,Ca)|0)>>3];c[Ba>>2]=11;Le=+h[(yw(we,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Ke=Le*+h[(yw(we,1,Aa)|0)>>3];c[za>>2]=19;Le=+h[(yw(we,1,za)|0)>>3];c[ya>>2]=44;Je=+h[(yw(we,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Fe=+h[(yw(we,1,xa)|0)>>3];c[wa>>2]=42;Ie=+h[(yw(we,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;He=+h[(yw(we,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(yw(we,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(yw(we,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(yw(we,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=Ce*(Oe+Ce*(Me+Ce*(Re+Ce*(Ne+Ce*(Se+Ue*(Ke+Le*(Je+Fe*(Ie+He*(Te+Ce*(Ve+Ce*(We+Ce*+h[(yw(we,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(yw(we,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(Ee*((Ee*(Ee*(Ee*(Ee*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(yw(we,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(yw(we,1,oa)|0)>>3];c[na>>2]=1;We=+h[(yw(we,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(yw(we,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;He=Xe*(We*(Te*+h[(yw(we,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(yw(we,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(yw(we,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(yw(we,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(yw(we,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(yw(we,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(yw(we,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;Ie=+h[(yw(we,1,ea)|0)>>3];c[da>>2]=19;Fe=+h[(yw(we,1,da)|0)>>3];c[ca>>2]=32;Je=+h[(yw(we,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Le=+h[(yw(we,1,ba)|0)>>3];c[aa>>2]=20;Ke=+h[(yw(we,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(yw(we,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(yw(we,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Ne=+h[(yw(we,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(yw(we,1,Y)|0)>>3];c[X>>2]=22;Me=Re*+h[(yw(we,1,X)|0)>>3];c[W>>2]=3;Re=Ke*(Ue+Ce*(Se+Ce*(Ne+Ce/(Ee*Me*+h[(yw(we,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Me=Fe*(Je+Le*(1.43624813658928e-17/(Ee*+h[(yw(we,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(yw(we,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Le=+h[(yw(we,1,T)|0)>>3];c[S>>2]=3;Je=Ce*(We+Ie*(Re/(Ee*Le*+h[(yw(we,1,S)|0)>>3])+Me));c[R>>2]=13;Me=+h[(yw(we,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Le=Me*+h[(yw(we,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Me=+h[(yw(we,1,P)|0)>>3];c[O>>2]=2;Re=Ce*(He+Ce*(Xe+Ce*(Te+Ce*(Je+Le/(Ee*Me*+h[(yw(we,1,O)|0)>>3])))));c[N>>2]=10;Me=+h[(yw(we,1,N)|0)>>3];c[M>>2]=7;Le=Re+Me*(Ee*((Ee*(Ee*(Ee*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(yw(we,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;Ee=+h[(yw(we,1,L)|0)>>3];c[K>>2]=1;Me=+h[(yw(we,1,K)|0)>>3];c[J>>2]=1;Re=+h[(yw(we,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Je=Re*+h[(yw(we,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=Ee*(Me*(Je*+h[(yw(we,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Je=+h[(yw(we,1,G)|0)>>3];c[F>>2]=2;Me=+h[(yw(we,1,F)|0)>>3];c[E>>2]=1;Ee=+h[(yw(we,1,E)|0)>>3];c[D>>2]=9;Te=Je*(Me*(Ee*(+h[(yw(we,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;Ee=+h[(yw(we,1,C)|0)>>3];c[B>>2]=37;Me=Ee*(+h[(yw(we,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;Ee=+h[(yw(we,1,A)|0)>>3];c[z>>2]=13;Je=+h[(yw(we,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=Ee*(Je*+h[(yw(we,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Je=+h[(yw(we,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;Ee=+h[(yw(we,1,w)|0)>>3];c[v>>2]=11;He=+h[(yw(we,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;Ie=He*+h[(yw(we,1,u)|0)>>3];c[t>>2]=19;He=+h[(yw(we,1,t)|0)>>3];c[s>>2]=44;We=+h[(yw(we,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Fe=+h[(yw(we,1,r)|0)>>3];c[q>>2]=42;Ne=+h[(yw(we,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(yw(we,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(yw(we,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Ke=+h[(yw(we,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Oe=+h[(yw(we,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+Ce*(Te+Ce*(Me+Ce*(Xe+Ce*(Je+Ee*(Ie+He*(We+Fe*(Ne+Se*(Ue+Ce*(Ke+Ce*(Oe+Ce*+h[(yw(we,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Ae;h[a+32>>3]=Be;h[a+40>>3]=Qe;h[a+48>>3]=Ge;h[a+56>>3]=Pe;h[a+64>>3]=Ve;h[a+72>>3]=Le;h[a+80>>3]=Ye;i=f;return}function _omc_Modelica_Media_Examples_Tests_Components_PortVolume_Medium_Utilities_h__dis__pTX__der$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0.0,be=0.0,ce=0.0,de=0.0,ee=0.0,fe=0.0,ge=0.0,he=0.0,ie=0.0,je=0.0,ke=0.0,le=0.0,me=0.0,ne=0.0;b=c[a+656>>2]|0;d=c[a+664>>2]|0;e=+g[a+672>>2];f=+g[a+680>>2];j=+g[a+696>>2];l=+g[a+704>>2];m=c[a+728>>2]|0;n=c[a+752>>2]|0;o=c[a+792>>2]|0;p=c[a+824>>2]|0;q=c[a+864>>2]|0;r=c[a+904>>2]|0;s=c[a+928>>2]|0;t=c[a+968>>2]|0;u=c[a+1008>>2]|0;v=c[a+1024>>2]|0;w=c[a+1072>>2]|0;x=c[a+1104>>2]|0;y=c[a+1136>>2]|0;z=c[a+1168>>2]|0;A=c[a+1200>>2]|0;B=c[a+1240>>2]|0;C=c[a+1280>>2]|0;D=c[a+1312>>2]|0;E=c[a+1344>>2]|0;F=c[a+1392>>2]|0;G=+g[a+1400>>2];H=c[a+1416>>2]|0;I=c[a+1464>>2]|0;J=c[a+1496>>2]|0;K=+g[a+1504>>2];L=c[a+1528>>2]|0;M=c[a+1576>>2]|0;N=c[a+1592>>2]|0;O=+g[a+1600>>2];P=c[a+1640>>2]|0;Q=+g[a+1648>>2];R=c[a+1680>>2]|0;S=c[a+1704>>2]|0;T=c[a+1752>>2]|0;U=c[a+1784>>2]|0;V=c[a+1824>>2]|0;W=c[a+1872>>2]|0;X=c[a+1880>>2]|0;Y=c[a+1920>>2]|0;Z=c[a+1968>>2]|0;_=c[a+1984>>2]|0;$=c[a+2032>>2]|0;aa=c[a+2048>>2]|0;ba=c[a+2088>>2]|0;ca=c[a+2144>>2]|0;da=c[a+3016>>2]|0;ea=c[a+3272>>2]|0;fa=c[a+3424>>2]|0;ga=c[a+3432>>2]|0;ha=c[a+3464>>2]|0;ia=c[a+3472>>2]|0;ja=c[a+3480>>2]|0;ka=c[a+3568>>2]|0;la=c[a+3576>>2]|0;ma=c[a+3592>>2]|0;na=c[a+3600>>2]|0;oa=c[a+3608>>2]|0;pa=c[a+3616>>2]|0;qa=c[a+3624>>2]|0;ra=c[a+3632>>2]|0;sa=c[a+3640>>2]|0;ta=c[a+3648>>2]|0;ua=c[a+3656>>2]|0;va=c[a+3664>>2]|0;wa=c[a+3672>>2]|0;xa=c[a+3680>>2]|0;ya=c[a+3688>>2]|0;za=c[a+3696>>2]|0;Aa=c[a+3704>>2]|0;Ba=c[a+3712>>2]|0;Ca=c[a+3720>>2]|0;Da=c[a+3728>>2]|0;Ea=c[a+3736>>2]|0;Fa=c[a+3744>>2]|0;Ga=c[a+3752>>2]|0;Ha=c[a+3760>>2]|0;Ia=c[a+3768>>2]|0;Ja=c[a+3776>>2]|0;Ka=c[a+3784>>2]|0;La=c[a+3792>>2]|0;Ma=c[a+3800>>2]|0;Na=c[a+3808>>2]|0;Oa=c[a+3816>>2]|0;Pa=c[a+3840>>2]|0;Qa=c[a+3848>>2]|0;Ra=c[a+3864>>2]|0;Sa=c[a+3872>>2]|0;Ta=c[a+3880>>2]|0;Ua=c[a+3888>>2]|0;Va=c[a+3896>>2]|0;Wa=c[a+3904>>2]|0;Xa=c[a+3912>>2]|0;Ya=c[a+3920>>2]|0;Za=c[a+3928>>2]|0;_a=c[a+3944>>2]|0;$a=c[a+3952>>2]|0;ab=c[a+3960>>2]|0;bb=c[a+3968>>2]|0;cb=c[a+3976>>2]|0;db=c[a+3984>>2]|0;eb=c[a+3992>>2]|0;fb=c[a+4e3>>2]|0;gb=c[a+4008>>2]|0;hb=c[a+4024>>2]|0;ib=c[a+4032>>2]|0;jb=c[a+4040>>2]|0;kb=c[a+4048>>2]|0;lb=c[a+4056>>2]|0;mb=c[a+4064>>2]|0;nb=c[a+4072>>2]|0;ob=c[a+4080>>2]|0;pb=c[a+4088>>2]|0;qb=c[a+4104>>2]|0;rb=c[a+4112>>2]|0;sb=c[a+4120>>2]|0;tb=c[a+4128>>2]|0;ub=c[a+4136>>2]|0;vb=c[a+4144>>2]|0;wb=c[a+4152>>2]|0;xb=c[a+4160>>2]|0;yb=c[a+4168>>2]|0;zb=c[a+4176>>2]|0;Ab=c[a+4192>>2]|0;Bb=c[a+4200>>2]|0;Cb=c[a+4208>>2]|0;Db=c[a+4216>>2]|0;Eb=c[a+4224>>2]|0;Fb=c[a+4232>>2]|0;Gb=c[a+4240>>2]|0;Hb=c[a+4248>>2]|0;Ib=c[a+4256>>2]|0;Jb=c[a+4264>>2]|0;Kb=c[a+4280>>2]|0;Lb=c[a+4288>>2]|0;Mb=c[a+4296>>2]|0;Nb=c[a+4304>>2]|0;Ob=c[a+4312>>2]|0;Pb=c[a+4320>>2]|0;Qb=c[a+4328>>2]|0;Rb=c[a+4336>>2]|0;Sb=c[a+5096>>2]|0;Tb=c[a+5104>>2]|0;Ub=c[a+5112>>2]|0;Vb=c[a+5120>>2]|0;Wb=c[a+5136>>2]|0;Xb=c[a+5144>>2]|0;Yb=c[a+5160>>2]|0;Zb=c[a+5168>>2]|0;_b=c[a+5176>>2]|0;$b=c[a+5184>>2]|0;ac=c[a+5192>>2]|0;bc=c[a+5200>>2]|0;cc=c[a+5208>>2]|0;dc=c[a+5216>>2]|0;ec=c[a+5224>>2]|0;fc=c[a+5240>>2]|0;gc=c[a+5248>>2]|0;hc=c[a+5256>>2]|0;ic=c[a+5264>>2]|0;jc=c[a+5272>>2]|0;kc=c[a+5280>>2]|0;lc=c[a+5288>>2]|0;mc=c[a+5296>>2]|0;nc=c[a+5304>>2]|0;oc=c[a+5320>>2]|0;pc=c[a+5328>>2]|0;qc=c[a+5336>>2]|0;rc=c[a+5344>>2]|0;sc=c[a+5352>>2]|0;tc=c[a+5360>>2]|0;uc=c[a+5368>>2]|0;vc=c[a+5376>>2]|0;wc=c[a+5384>>2]|0;xc=c[a+5392>>2]|0;yc=c[a+5400>>2]|0;zc=c[a+5408>>2]|0;Ac=c[a+5416>>2]|0;Bc=c[a+5424>>2]|0;Cc=c[a+5440>>2]|0;Dc=c[a+5448>>2]|0;Ec=c[a+5456>>2]|0;Fc=c[a+5464>>2]|0;Gc=c[a+5472>>2]|0;Hc=c[a+5480>>2]|0;Ic=c[a+5488>>2]|0;Jc=c[a+5496>>2]|0;Kc=c[a+5504>>2]|0;Lc=c[a+5520>>2]|0;Mc=c[a+5528>>2]|0;Nc=c[a+5536>>2]|0;Oc=c[a+5544>>2]|0;Pc=c[a+5552>>2]|0;Qc=c[a+5560>>2]|0;Rc=c[a+5568>>2]|0;Sc=c[a+5576>>2]|0;Tc=c[a+5584>>2]|0;Uc=c[a+5600>>2]|0;Vc=c[a+5608>>2]|0;Wc=c[a+5616>>2]|0;Xc=c[a+5624>>2]|0;Yc=c[a+5632>>2]|0;Zc=c[a+5640>>2]|0;_c=c[a+5648>>2]|0;$c=c[a+5656>>2]|0;ad=c[a+5664>>2]|0;bd=c[a+5680>>2]|0;cd=c[a+5688>>2]|0;dd=c[a+5696>>2]|0;ed=c[a+5704>>2]|0;fd=c[a+5712>>2]|0;gd=c[a+5720>>2]|0;hd=c[a+5728>>2]|0;id=c[a+5736>>2]|0;jd=c[a+5744>>2]|0;kd=c[a+5760>>2]|0;ld=c[a+5768>>2]|0;md=c[a+5776>>2]|0;nd=c[a+5784>>2]|0;od=c[a+5792>>2]|0;pd=c[a+5800>>2]|0;qd=c[a+5808>>2]|0;rd=c[a+5816>>2]|0;sd=c[a+5824>>2]|0;td=c[a+5832>>2]|0;ud=c[a+5848>>2]|0;vd=c[a+5856>>2]|0;wd=c[a+5864>>2]|0;xd=c[a+5872>>2]|0;yd=c[a+5880>>2]|0;zd=c[a+5888>>2]|0;Ad=c[a+5896>>2]|0;Bd=c[a+5904>>2]|0;Cd=c[a+5912>>2]|0;Dd=c[a+5928>>2]|0;Ed=c[a+5936>>2]|0;Fd=c[a+5952>>2]|0;Gd=c[a+5960>>2]|0;Hd=c[a+5968>>2]|0;Id=c[a+5976>>2]|0;Jd=c[a+5984>>2]|0;Kd=c[a+5992>>2]|0;Ld=c[a+6e3>>2]|0;Md=c[a+6016>>2]|0;Nd=c[a+6024>>2]|0;Od=c[a+6032>>2]|0;Pd=c[a+6040>>2]|0;Qd=c[a+6048>>2]|0;Rd=c[a+6056>>2]|0;Sd=c[a+6064>>2]|0;Td=c[a+6072>>2]|0;Ud=c[a+6080>>2]|0;Vd=c[a+6096>>2]|0;Wd=c[a+6104>>2]|0;Xd=c[a+6112>>2]|0;Yd=c[a+6120>>2]|0;Zd=c[a+6128>>2]|0;_d=c[a+6136>>2]|0;$d=c[a+6144>>2]|0;a:do{c[(Sb+16|0)+4>>2]=c[k+4>>2];xw(la,4,Q,Sb);c[(a+480|0)+0>>2]=c[ka+0>>2];c[(a+480|0)+4>>2]=c[ka+4>>2];c[(a+480|0)+8>>2]=c[ka+8>>2];c[(a+464|0)+0>>2]=c[la+0>>2];c[(a+464|0)+4>>2]=c[la+4>>2];c[(a+464|0)+8>>2]=c[la+8>>2];sj(da,d,e,f,a+480|0,j,l,a+464|0);ae=+h[da>>3];c[Tb>>2]=1;be=+h[(yw(fa,1,Tb)|0)>>3];c[Ub>>2]=2;ce=+h[(yw(fa,1,Ub)|0)>>3];c[Vb>>2]=3;de=+h[(yw(fa,1,Vb)|0)>>3];c[Wb>>2]=4;ee=+h[(yw(fa,1,Wb)|0)>>3];h[k>>3]=ce;c[Xb>>2]=c[k>>2];c[Xb+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Xb+8|0)>>2]=c[k>>2];c[(Xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(Xb+16|0)>>2]=c[k>>2];c[(Xb+16|0)+4>>2]=c[k+4>>2];xw(ma,4,be,Xb);c[Yb>>2]=1;be=+h[(yw(ga,1,Yb)|0)>>3];c[Zb>>2]=2;ee=+h[(yw(ga,1,Zb)|0)>>3];c[_b>>2]=3;de=+h[(yw(ga,1,_b)|0)>>3];c[$b>>2]=4;ce=+h[(yw(ga,1,$b)|0)>>3];h[k>>3]=ee;c[ac>>2]=c[k>>2];c[ac+4>>2]=c[k+4>>2];h[k>>3]=de;c[(ac+8|0)>>2]=c[k>>2];c[(ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ce;c[(ac+16|0)>>2]=c[k>>2];c[(ac+16|0)+4>>2]=c[k+4>>2];xw(na,4,be,ac);c[(a+448|0)+0>>2]=c[ma+0>>2];c[(a+448|0)+4>>2]=c[ma+4>>2];c[(a+448|0)+8>>2]=c[ma+8>>2];c[(a+432|0)+0>>2]=c[na+0>>2];c[(a+432|0)+4>>2]=c[na+4>>2];c[(a+432|0)+8>>2]=c[na+8>>2];tj(ea,d,e,f,a+448|0,j,l,a+432|0);be=+h[ea>>3];c[bc>>2]=1;ce=+h[(yw(fa,1,bc)|0)>>3];c[cc>>2]=2;de=+h[(yw(fa,1,cc)|0)>>3];c[dc>>2]=3;ee=+h[(yw(fa,1,dc)|0)>>3];c[ec>>2]=4;fe=+h[(yw(fa,1,ec)|0)>>3];h[k>>3]=de;c[fc>>2]=c[k>>2];c[fc+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(fc+8|0)>>2]=c[k>>2];c[(fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(fc+16|0)>>2]=c[k>>2];c[(fc+16|0)+4>>2]=c[k+4>>2];xw(oa,4,ce,fc);c[gc>>2]=1;ce=+h[(yw(ga,1,gc)|0)>>3];c[hc>>2]=2;fe=+h[(yw(ga,1,hc)|0)>>3];c[ic>>2]=3;ee=+h[(yw(ga,1,ic)|0)>>3];c[jc>>2]=4;de=+h[(yw(ga,1,jc)|0)>>3];h[k>>3]=fe;c[kc>>2]=c[k>>2];c[kc+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(kc+8|0)>>2]=c[k>>2];c[(kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=de;c[(kc+16|0)>>2]=c[k>>2];c[(kc+16|0)+4>>2]=c[k+4>>2];xw(pa,4,ce,kc);c[(a+416|0)+0>>2]=c[oa+0>>2];c[(a+416|0)+4>>2]=c[oa+4>>2];c[(a+416|0)+8>>2]=c[oa+8>>2];c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];yj(m,d,0.0,f,a+416|0,0.0,l,a+400|0);ce=K+(O+(ae+(be+ +h[m>>3])));c[lc>>2]=1;be=+h[(yw(fa,1,lc)|0)>>3];c[mc>>2]=2;ae=+h[(yw(fa,1,mc)|0)>>3];c[nc>>2]=3;de=+h[(yw(fa,1,nc)|0)>>3];c[oc>>2]=4;ee=+h[(yw(fa,1,oc)|0)>>3];h[k>>3]=ae;c[pc>>2]=c[k>>2];c[pc+4>>2]=c[k+4>>2];h[k>>3]=de;c[(pc+8|0)>>2]=c[k>>2];c[(pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(pc+16|0)>>2]=c[k>>2];c[(pc+16|0)+4>>2]=c[k+4>>2];xw(qa,4,be,pc);c[qc>>2]=1;be=+h[(yw(ga,1,qc)|0)>>3];c[rc>>2]=2;ee=+h[(yw(ga,1,rc)|0)>>3];c[sc>>2]=3;de=+h[(yw(ga,1,sc)|0)>>3];c[tc>>2]=4;ae=+h[(yw(ga,1,tc)|0)>>3];h[k>>3]=ee;c[uc>>2]=c[k>>2];c[uc+4>>2]=c[k+4>>2];h[k>>3]=de;c[(uc+8|0)>>2]=c[k>>2];c[(uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(uc+16|0)>>2]=c[k>>2];c[(uc+16|0)+4>>2]=c[k+4>>2];xw(ra,4,be,uc);c[(a+384|0)+0>>2]=c[qa+0>>2];c[(a+384|0)+4>>2]=c[qa+4>>2];c[(a+384|0)+8>>2]=c[qa+8>>2];c[(a+368|0)+0>>2]=c[ra+0>>2];c[(a+368|0)+4>>2]=c[ra+4>>2];c[(a+368|0)+8>>2]=c[ra+8>>2];pj(n,d,e,f,a+384|0,j,l,a+368|0);be=+h[n>>3];xj(o,0,f);ae=+h[o>>3];c[vc>>2]=1;de=+h[(yw(fa,1,vc)|0)>>3];c[wc>>2]=2;ee=+h[(yw(fa,1,wc)|0)>>3];c[xc>>2]=3;fe=+h[(yw(fa,1,xc)|0)>>3];c[yc>>2]=4;ge=+h[(yw(fa,1,yc)|0)>>3];h[k>>3]=ee;c[zc>>2]=c[k>>2];c[zc+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(zc+8|0)>>2]=c[k>>2];c[(zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(zc+16|0)>>2]=c[k>>2];c[(zc+16|0)+4>>2]=c[k+4>>2];xw(sa,4,de,zc);c[(a+352|0)+0>>2]=c[sa+0>>2];c[(a+352|0)+4>>2]=c[sa+4>>2];c[(a+352|0)+8>>2]=c[sa+8>>2];lj(p,d,e,f,a+352|0);de=+h[p>>3];zj(q,0,f,l);ge=(be*ae+de*+h[q>>3])/-30283.3;c[Ac>>2]=1;h[(yw(ja,1,Ac)|0)>>3]=ge;c[Bc>>2]=1;ge=+h[(yw(fa,1,Bc)|0)>>3];c[Cc>>2]=2;de=+h[(yw(fa,1,Cc)|0)>>3];c[Dc>>2]=3;ae=+h[(yw(fa,1,Dc)|0)>>3];c[Ec>>2]=4;be=+h[(yw(fa,1,Ec)|0)>>3];h[k>>3]=de;c[Fc>>2]=c[k>>2];c[Fc+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Fc+8|0)>>2]=c[k>>2];c[(Fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(Fc+16|0)>>2]=c[k>>2];c[(Fc+16|0)+4>>2]=c[k+4>>2];xw(ta,4,ge,Fc);c[Gc>>2]=1;ge=+h[(yw(ga,1,Gc)|0)>>3];c[Hc>>2]=2;be=+h[(yw(ga,1,Hc)|0)>>3];c[Ic>>2]=3;ae=+h[(yw(ga,1,Ic)|0)>>3];c[Jc>>2]=4;de=+h[(yw(ga,1,Jc)|0)>>3];h[k>>3]=be;c[Kc>>2]=c[k>>2];c[Kc+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Kc+8|0)>>2]=c[k>>2];c[(Kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Kc+16|0)>>2]=c[k>>2];c[(Kc+16|0)+4>>2]=c[k+4>>2];xw(ua,4,ge,Kc);c[(a+336|0)+0>>2]=c[ta+0>>2];c[(a+336|0)+4>>2]=c[ta+4>>2];c[(a+336|0)+8>>2]=c[ta+8>>2];c[(a+320|0)+0>>2]=c[ua+0>>2];c[(a+320|0)+4>>2]=c[ua+4>>2];c[(a+320|0)+8>>2]=c[ua+8>>2];qj(r,d,e,f,a+336|0,j,l,a+320|0);ge=+h[r>>3];wj(s,0,f);de=+h[s>>3];c[Lc>>2]=1;ae=+h[(yw(fa,1,Lc)|0)>>3];c[Mc>>2]=2;be=+h[(yw(fa,1,Mc)|0)>>3];c[Nc>>2]=3;fe=+h[(yw(fa,1,Nc)|0)>>3];c[Oc>>2]=4;ee=+h[(yw(fa,1,Oc)|0)>>3];h[k>>3]=be;c[Pc>>2]=c[k>>2];c[Pc+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(Pc+8|0)>>2]=c[k>>2];c[(Pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(Pc+16|0)>>2]=c[k>>2];c[(Pc+16|0)+4>>2]=c[k+4>>2];xw(va,4,ae,Pc);c[(a+304|0)+0>>2]=c[va+0>>2];c[(a+304|0)+4>>2]=c[va+4>>2];c[(a+304|0)+8>>2]=c[va+8>>2];oj(t,d,e,f,a+304|0);ae=+h[t>>3];Aj(u,0,f,l);ee=(ge*de+ae*+h[u>>3])/-19526.8;c[Qc>>2]=2;h[(yw(ja,1,Qc)|0)>>3]=ee;c[Rc>>2]=1;ee=+h[(yw(fa,1,Rc)|0)>>3];c[Sc>>2]=2;ae=+h[(yw(fa,1,Sc)|0)>>3];c[Tc>>2]=3;de=+h[(yw(fa,1,Tc)|0)>>3];c[Uc>>2]=4;ge=+h[(yw(fa,1,Uc)|0)>>3];h[k>>3]=ae;c[Vc>>2]=c[k>>2];c[Vc+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Vc+8|0)>>2]=c[k>>2];c[(Vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(Vc+16|0)>>2]=c[k>>2];c[(Vc+16|0)+4>>2]=c[k+4>>2];xw(wa,4,ee,Vc);c[Wc>>2]=1;ee=+h[(yw(ga,1,Wc)|0)>>3];c[Xc>>2]=2;ge=+h[(yw(ga,1,Xc)|0)>>3];c[Yc>>2]=3;de=+h[(yw(ga,1,Yc)|0)>>3];c[Zc>>2]=4;ae=+h[(yw(ga,1,Zc)|0)>>3];h[k>>3]=ge;c[_c>>2]=c[k>>2];c[_c+4>>2]=c[k+4>>2];h[k>>3]=de;c[(_c+8|0)>>2]=c[k>>2];c[(_c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(_c+16|0)>>2]=c[k>>2];c[(_c+16|0)+4>>2]=c[k+4>>2];xw(xa,4,ee,_c);c[(a+288|0)+0>>2]=c[wa+0>>2];c[(a+288|0)+4>>2]=c[wa+4>>2];c[(a+288|0)+8>>2]=c[wa+8>>2];c[(a+272|0)+0>>2]=c[xa+0>>2];c[(a+272|0)+4>>2]=c[xa+4>>2];c[(a+272|0)+8>>2]=c[xa+8>>2];sj(v,d,e,f,a+288|0,j,l,a+272|0);ee=+h[v>>3];vj(w,0,f);ae=+h[w>>3];c[$c>>2]=1;de=+h[(yw(fa,1,$c)|0)>>3];c[ad>>2]=2;ge=+h[(yw(fa,1,ad)|0)>>3];c[bd>>2]=3;fe=+h[(yw(fa,1,bd)|0)>>3];c[cd>>2]=4;be=+h[(yw(fa,1,cd)|0)>>3];h[k>>3]=ge;c[dd>>2]=c[k>>2];c[dd+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(dd+8|0)>>2]=c[k>>2];c[(dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(dd+16|0)>>2]=c[k>>2];c[(dd+16|0)+4>>2]=c[k+4>>2];xw(ya,4,de,dd);c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];nj(x,d,e,f,a+256|0);de=+h[x>>3];Dj(y,0,f,l);be=(ee*ae+de*+h[y>>3])/-27488.0;c[ed>>2]=3;h[(yw(ja,1,ed)|0)>>3]=be;c[fd>>2]=1;be=+h[(yw(fa,1,fd)|0)>>3];c[gd>>2]=2;de=+h[(yw(fa,1,gd)|0)>>3];c[hd>>2]=3;ae=+h[(yw(fa,1,hd)|0)>>3];c[id>>2]=4;ee=+h[(yw(fa,1,id)|0)>>3];h[k>>3]=de;c[jd>>2]=c[k>>2];c[jd+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(jd+8|0)>>2]=c[k>>2];c[(jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(jd+16|0)>>2]=c[k>>2];c[(jd+16|0)+4>>2]=c[k+4>>2];xw(za,4,be,jd);c[kd>>2]=1;be=+h[(yw(ga,1,kd)|0)>>3];c[ld>>2]=2;ee=+h[(yw(ga,1,ld)|0)>>3];c[md>>2]=3;ae=+h[(yw(ga,1,md)|0)>>3];c[nd>>2]=4;de=+h[(yw(ga,1,nd)|0)>>3];h[k>>3]=ee;c[od>>2]=c[k>>2];c[od+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(od+8|0)>>2]=c[k>>2];c[(od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=de;c[(od+16|0)>>2]=c[k>>2];c[(od+16|0)+4>>2]=c[k+4>>2];xw(Aa,4,be,od);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+224|0)+0>>2]=c[Aa+0>>2];c[(a+224|0)+4>>2]=c[Aa+4>>2];c[(a+224|0)+8>>2]=c[Aa+8>>2];tj(z,d,e,f,a+240|0,j,l,a+224|0);be=+h[z>>3];Cj(A,0,f);de=+h[A>>3];c[pd>>2]=1;ae=+h[(yw(fa,1,pd)|0)>>3];c[qd>>2]=2;ee=+h[(yw(fa,1,qd)|0)>>3];c[rd>>2]=3;fe=+h[(yw(fa,1,rd)|0)>>3];c[sd>>2]=4;ge=+h[(yw(fa,1,sd)|0)>>3];h[k>>3]=ee;c[td>>2]=c[k>>2];c[td+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(td+8|0)>>2]=c[k>>2];c[(td+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(td+16|0)>>2]=c[k>>2];c[(td+16|0)+4>>2]=c[k+4>>2];xw(Ba,4,ae,td);c[(a+208|0)+0>>2]=c[Ba+0>>2];c[(a+208|0)+4>>2]=c[Ba+4>>2];c[(a+208|0)+8>>2]=c[Ba+8>>2];rj(B,d,e,f,a+208|0);ae=+h[B>>3];Fj(C,0,f,l);ge=(be*de+ae*+h[C>>3])/-30807.8;c[ud>>2]=4;h[(yw(ja,1,ud)|0)>>3]=ge;c[vd>>2]=1;ge=+h[(yw(fa,1,vd)|0)>>3];c[wd>>2]=2;ae=+h[(yw(fa,1,wd)|0)>>3];c[xd>>2]=3;de=+h[(yw(fa,1,xd)|0)>>3];c[yd>>2]=4;be=+h[(yw(fa,1,yd)|0)>>3];h[k>>3]=ae;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=de;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];xw(Ca,4,ge,zd);c[Ad>>2]=1;ge=+h[(yw(ga,1,Ad)|0)>>3];c[Bd>>2]=2;be=+h[(yw(ga,1,Bd)|0)>>3];c[Cd>>2]=3;de=+h[(yw(ga,1,Cd)|0)>>3];c[Dd>>2]=4;ae=+h[(yw(ga,1,Dd)|0)>>3];h[k>>3]=be;c[Ed>>2]=c[k>>2];c[Ed+4>>2]=c[k+4>>2];h[k>>3]=de;c[(Ed+8|0)>>2]=c[k>>2];c[(Ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Ed+16|0)>>2]=c[k>>2];c[(Ed+16|0)+4>>2]=c[k+4>>2];xw(Da,4,ge,Ed);c[(a+192|0)+0>>2]=c[Ca+0>>2];c[(a+192|0)+4>>2]=c[Ca+4>>2];c[(a+192|0)+8>>2]=c[Ca+8>>2];c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];yj(D,d,0.0,f,a+192|0,0.0,l,a+176|0);ge=+h[D>>3];Ej(E,0,f);ae=+h[E>>3];c[Fd>>2]=1;de=+h[(yw(fa,1,Fd)|0)>>3];c[Gd>>2]=2;be=+h[(yw(fa,1,Gd)|0)>>3];c[Hd>>2]=3;fe=+h[(yw(fa,1,Hd)|0)>>3];c[Id>>2]=4;ee=+h[(yw(fa,1,Id)|0)>>3];h[k>>3]=be;c[Jd>>2]=c[k>>2];c[Jd+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(Jd+8|0)>>2]=c[k>>2];c[(Jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(Jd+16|0)>>2]=c[k>>2];c[(Jd+16|0)+4>>2]=c[k+4>>2];xw(Ea,4,de,Jd);c[(a+160|0)+0>>2]=c[Ea+0>>2];c[(a+160|0)+4>>2]=c[Ea+4>>2];c[(a+160|0)+8>>2]=c[Ea+8>>2];Ri(F,d,0.0,f,a+160|0);de=+h[F>>3];Gj(H,0,f,l);ee=(ge*ae+de*+h[H>>3])/-10973.6;c[Kd>>2]=5;h[(yw(ja,1,Kd)|0)>>3]=ee;c[Ld>>2]=1;ee=+h[(yw(fa,1,Ld)|0)>>3];c[Md>>2]=2;de=+h[(yw(fa,1,Md)|0)>>3];c[Nd>>2]=3;ae=+h[(yw(fa,1,Nd)|0)>>3];c[Od>>2]=4;ge=+h[(yw(fa,1,Od)|0)>>3];h[k>>3]=de;c[Pd>>2]=c[k>>2];c[Pd+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(Pd+8|0)>>2]=c[k>>2];c[(Pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(Pd+16|0)>>2]=c[k>>2];c[(Pd+16|0)+4>>2]=c[k+4>>2];xw(Fa,4,ee,Pd);c[(a+144|0)+0>>2]=c[Fa+0>>2];c[(a+144|0)+4>>2]=c[Fa+4>>2];c[(a+144|0)+8>>2]=c[Fa+8>>2];lj(I,d,e,f,a+144|0);ee=+h[I>>3];xj(J,0,f);ge=+h[J>>3];c[Qd>>2]=1;ae=+h[(yw(fa,1,Qd)|0)>>3];c[Rd>>2]=2;de=+h[(yw(fa,1,Rd)|0)>>3];c[Sd>>2]=3;fe=+h[(yw(fa,1,Sd)|0)>>3];c[Td>>2]=4;be=+h[(yw(fa,1,Td)|0)>>3];h[k>>3]=de;c[Ud>>2]=c[k>>2];c[Ud+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(Ud+8|0)>>2]=c[k>>2];c[(Ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(Ud+16|0)>>2]=c[k>>2];c[(Ud+16|0)+4>>2]=c[k+4>>2];xw(Ga,4,ae,Ud);c[(a+128|0)+0>>2]=c[Ga+0>>2];c[(a+128|0)+4>>2]=c[Ga+4>>2];c[(a+128|0)+8>>2]=c[Ga+8>>2];oj(L,d,e,f,a+128|0);ae=+h[L>>3];wj(M,0,f);be=+h[M>>3];c[Vd>>2]=1;fe=+h[(yw(fa,1,Vd)|0)>>3];c[Wd>>2]=2;de=+h[(yw(fa,1,Wd)|0)>>3];c[Xd>>2]=3;he=+h[(yw(fa,1,Xd)|0)>>3];c[Yd>>2]=4;ie=+h[(yw(fa,1,Yd)|0)>>3];h[k>>3]=de;c[Zd>>2]=c[k>>2];c[Zd+4>>2]=c[k+4>>2];h[k>>3]=he;c[(Zd+8|0)>>2]=c[k>>2];c[(Zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ie;c[(Zd+16|0)>>2]=c[k>>2];c[(Zd+16|0)+4>>2]=c[k+4>>2];xw(Ha,4,fe,Zd);c[(a+112|0)+0>>2]=c[Ha+0>>2];c[(a+112|0)+4>>2]=c[Ha+4>>2];c[(a+112|0)+8>>2]=c[Ha+8>>2];nj(N,d,e,f,a+112|0);fe=+h[N>>3];vj(P,0,f);ie=+h[P>>3];c[_d>>2]=1;he=+h[(yw(fa,1,_d)|0)>>3];c[$d>>2]=2;de=+h[(yw(fa,1,$d)|0)>>3];c[Pa>>2]=3;je=+h[(yw(fa,1,Pa)|0)>>3];c[Qa>>2]=4;ke=+h[(yw(fa,1,Qa)|0)>>3];h[k>>3]=de;c[Ra>>2]=c[k>>2];c[Ra+4>>2]=c[k+4>>2];h[k>>3]=je;c[(Ra+8|0)>>2]=c[k>>2];c[(Ra+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ke;c[(Ra+16|0)>>2]=c[k>>2];c[(Ra+16|0)+4>>2]=c[k+4>>2];xw(Ia,4,he,Ra);c[(a+96|0)+0>>2]=c[Ia+0>>2];c[(a+96|0)+4>>2]=c[Ia+4>>2];c[(a+96|0)+8>>2]=c[Ia+8>>2];rj(R,d,e,f,a+96|0);he=+h[R>>3];Cj(S,0,f);ke=+h[S>>3];c[Sa>>2]=1;je=+h[(yw(fa,1,Sa)|0)>>3];c[Ta>>2]=2;de=+h[(yw(fa,1,Ta)|0)>>3];c[Ua>>2]=3;le=+h[(yw(fa,1,Ua)|0)>>3];c[Va>>2]=4;me=+h[(yw(fa,1,Va)|0)>>3];h[k>>3]=de;c[Wa>>2]=c[k>>2];c[Wa+4>>2]=c[k+4>>2];h[k>>3]=le;c[(Wa+8|0)>>2]=c[k>>2];c[(Wa+8|0)+4>>2]=c[k+4>>2];h[k>>3]=me;c[(Wa+16|0)>>2]=c[k>>2];c[(Wa+16|0)+4>>2]=c[k+4>>2];xw(Ja,4,je,Wa);c[(a+80|0)+0>>2]=c[Ja+0>>2];c[(a+80|0)+4>>2]=c[Ja+4>>2];c[(a+80|0)+8>>2]=c[Ja+8>>2];Ri(T,d,0.0,f,a+80|0);je=+h[T>>3];Ej(U,0,f);me=ee*ge*-3302150029884458.0e-20+(ae*be*-5121166806645226.0e-20+(fe*ie*-3637951105937136.0e-20+(he*ke*-32459312252092.0e-18+je*+h[U>>3]*-9112779762338704.0e-20)));c[Xa>>2]=1;je=+h[(yw(fa,1,Xa)|0)>>3];c[Ya>>2]=2;ke=+h[(yw(fa,1,Ya)|0)>>3];c[Za>>2]=3;he=+h[(yw(fa,1,Za)|0)>>3];c[_a>>2]=4;ie=+h[(yw(fa,1,_a)|0)>>3];h[k>>3]=ke;c[$a>>2]=c[k>>2];c[$a+4>>2]=c[k+4>>2];h[k>>3]=he;c[($a+8|0)>>2]=c[k>>2];c[($a+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ie;c[($a+16|0)>>2]=c[k>>2];c[($a+16|0)+4>>2]=c[k+4>>2];xw(Ka,4,je,$a);c[(a+64|0)+0>>2]=c[Ka+0>>2];c[(a+64|0)+4>>2]=c[Ka+4>>2];c[(a+64|0)+8>>2]=c[Ka+8>>2];lj(V,d,e,f,a+64|0);je=+h[V>>3];xj(W,0,f);ie=+h[W>>3];c[ab>>2]=1;he=+h[(yw(fa,1,ab)|0)>>3];c[bb>>2]=2;ke=+h[(yw(fa,1,bb)|0)>>3];c[cb>>2]=3;fe=+h[(yw(fa,1,cb)|0)>>3];c[db>>2]=4;be=+h[(yw(fa,1,db)|0)>>3];h[k>>3]=ke;c[eb>>2]=c[k>>2];c[eb+4>>2]=c[k+4>>2];h[k>>3]=fe;c[(eb+8|0)>>2]=c[k>>2];c[(eb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=be;c[(eb+16|0)>>2]=c[k>>2];c[(eb+16|0)+4>>2]=c[k+4>>2];xw(La,4,he,eb);c[(a+48|0)+0>>2]=c[La+0>>2];c[(a+48|0)+4>>2]=c[La+4>>2];c[(a+48|0)+8>>2]=c[La+8>>2];oj(X,d,e,f,a+48|0);he=+h[X>>3];wj(Y,0,f);be=+h[Y>>3];c[fb>>2]=1;fe=+h[(yw(fa,1,fb)|0)>>3];c[gb>>2]=2;ke=+h[(yw(fa,1,gb)|0)>>3];c[hb>>2]=3;ae=+h[(yw(fa,1,hb)|0)>>3];c[ib>>2]=4;ge=+h[(yw(fa,1,ib)|0)>>3];h[k>>3]=ke;c[jb>>2]=c[k>>2];c[jb+4>>2]=c[k+4>>2];h[k>>3]=ae;c[(jb+8|0)>>2]=c[k>>2];c[(jb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ge;c[(jb+16|0)>>2]=c[k>>2];c[(jb+16|0)+4>>2]=c[k+4>>2];xw(Ma,4,fe,jb);c[(a+32|0)+0>>2]=c[Ma+0>>2];c[(a+32|0)+4>>2]=c[Ma+4>>2];c[(a+32|0)+8>>2]=c[Ma+8>>2];nj(Z,d,e,f,a+32|0);fe=+h[Z>>3];vj(_,0,f);ge=+h[_>>3];c[kb>>2]=1;ae=+h[(yw(fa,1,kb)|0)>>3];c[lb>>2]=2;ke=+h[(yw(fa,1,lb)|0)>>3];c[mb>>2]=3;ee=+h[(yw(fa,1,mb)|0)>>3];c[nb>>2]=4;le=+h[(yw(fa,1,nb)|0)>>3];h[k>>3]=ke;c[ob>>2]=c[k>>2];c[ob+4>>2]=c[k+4>>2];h[k>>3]=ee;c[(ob+8|0)>>2]=c[k>>2];c[(ob+8|0)+4>>2]=c[k+4>>2];h[k>>3]=le;c[(ob+16|0)>>2]=c[k>>2];c[(ob+16|0)+4>>2]=c[k+4>>2];xw(Na,4,ae,ob);c[(a+16|0)+0>>2]=c[Na+0>>2];c[(a+16|0)+4>>2]=c[Na+4>>2];c[(a+16|0)+8>>2]=c[Na+8>>2];rj($,d,e,f,a+16|0);ae=+h[$>>3];Cj(aa,0,f);le=+h[aa>>3];c[pb>>2]=1;ee=+h[(yw(fa,1,pb)|0)>>3];c[qb>>2]=2;ke=+h[(yw(fa,1,qb)|0)>>3];c[rb>>2]=3;de=+h[(yw(fa,1,rb)|0)>>3];c[sb>>2]=4;ne=+h[(yw(fa,1,sb)|0)>>3];h[k>>3]=ke;c[tb>>2]=c[k>>2];c[tb+4>>2]=c[k+4>>2];h[k>>3]=de;c[(tb+8|0)>>2]=c[k>>2];c[(tb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=ne;c[(tb+16|0)>>2]=c[k>>2];c[(tb+16|0)+4>>2]=c[k+4>>2];xw(Oa,4,ee,tb);c[a+0>>2]=c[Oa+0>>2];c[a+4>>2]=c[Oa+4>>2];c[a+8>>2]=c[Oa+8>>2];Ri(ba,d,0.0,f,a);ee=+h[ba>>3];Ej(ca,0,f);ne=(je*ie*-3302150029884458.0e-20+(he*be*-5121166806645226.0e-20+(fe*ge*-3637951105937136.0e-20+(ae*le*-32459312252092.0e-18+ee*+h[ca>>3]*-9112779762338704.0e-20))))*f*-2.0;c[ub>>2]=1;ee=+h[(yw(ja,1,ub)|0)>>3];c[vb>>2]=2;le=+h[(yw(ja,1,vb)|0)>>3];c[wb>>2]=3;ae=+h[(yw(ja,1,wb)|0)>>3];c[xb>>2]=4;ge=+h[(yw(ja,1,xb)|0)>>3];c[yb>>2]=5;fe=ne-f*f*(ee+(le+(ae+(ge+ +h[(yw(ja,1,yb)|0)>>3]))));c[zb>>2]=6;h[(yw(ja,1,zb)|0)>>3]=fe;c[Ab>>2]=1;fe=+h[(yw(ha,1,Ab)|0)>>3]/.018015257;c[Bb>>2]=2;ge=+h[(yw(ha,1,Bb)|0)>>3]/.02801348;c[Cb>>2]=3;ae=+h[(yw(ha,1,Cb)|0)>>3]/.0319988;c[Db>>2]=4;le=ce*(fe+(ge+(ae+ +h[(yw(ha,1,Db)|0)>>3]/.039948)));c[Eb>>2]=1;ae=+h[(yw(ia,1,Eb)|0)>>3]/.018015257;c[Fb>>2]=2;ge=+h[(yw(ia,1,Fb)|0)>>3]/.02801348;c[Gb>>2]=3;fe=+h[(yw(ia,1,Gb)|0)>>3]/.0319988;c[Hb>>2]=4;ce=le+G*(ae+(ge+(fe+ +h[(yw(ia,1,Hb)|0)>>3]/.039948)));c[Ib>>2]=7;h[(yw(ja,1,Ib)|0)>>3]=ce;c[Jb>>2]=1;ce=+h[(yw(ha,1,Jb)|0)>>3]/.018015257;c[Kb>>2]=2;fe=+h[(yw(ha,1,Kb)|0)>>3]/.02801348;c[Lb>>2]=3;ge=+h[(yw(ha,1,Lb)|0)>>3]/.0319988;c[Mb>>2]=4;ae=G*(ce+(fe+(ge+ +h[(yw(ha,1,Mb)|0)>>3]/.039948)));c[Nb>>2]=6;ge=+h[(yw(ja,1,Nb)|0)>>3];c[Ob>>2]=1;fe=+h[(yw(ha,1,Ob)|0)>>3]/.018015257;c[Pb>>2]=2;ce=+h[(yw(ha,1,Pb)|0)>>3]/.02801348;c[Qb>>2]=3;le=+h[(yw(ha,1,Qb)|0)>>3]/.0319988;c[Rb>>2]=4;ee=ge*G*(fe+(ce+(le+ +h[(yw(ha,1,Rb)|0)>>3]/.039948)));c[(a+640|0)>>2]=7;h[b>>3]=(ee-me*+h[(yw(ja,1,a+640|0)|0)>>3])/(ae*ae);i=a;c[a+6160>>2]=5;break a}while(0)}



function qr(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Nq(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=tq(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Nq(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((wr(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ce[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=se[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ce[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=_q(k,b,v,w+(se[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Wq(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=cr(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Rq(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Rq(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=se[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Nq(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Kq(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Kq(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Kq(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=de[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;E_(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}ae[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;E_(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;E_(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function rr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=44;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 15:{if((c[j+80>>2]|0)==0){break b}Iq(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};case-4:{k=7;break a;break};case 0:{k=14;break a;break};case-15:{k=3;break a;break};case 13:{if((kr(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 11:{if((jr(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Iq(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function sr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ce[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 40:{r=6;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;ze[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Iq(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Iq(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){ze[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Zd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];ze[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case-4:case-1:{r=28;break a;break};case-2:{r=25;break a;break};case 0:{r=24;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){ae[c[n+76>>2]&255](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Iq(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function tr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=sr(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=45;k=ur(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=Yq(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function ur(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=nr(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((vr(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function vr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=se[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}E_(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function wr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Kq(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Kq(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Nq(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function xr(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ce[c[b+16>>2]&63](b,f,g,l)|0){case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case-4:{o=3;break a;break};case 10:{p=se[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=Er(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Kq(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 0:{o=4;break a;break};case-1:{o=7;break a;break};case 9:{q=(ge[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Kq(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=Wq(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=Nq(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=xr(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 6:{if((ar(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 7:case 39:{o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Kq(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function yr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ge[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Fr()|0;c[g+240>>2]=de[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ce[((a[g+236|0]&255|0)!=0?46:47)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){ae[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}ae[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function zr(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=K_()|0;i=a;return b|0}function Ar(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=Sq(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=41;h=Tq(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Br(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=de[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Cr(f+80|0,e);Cr(b+104|0,e);Dr(b,e);Dr(b+20|0,e);Dr(b+40|0,e);Dr(b+60|0,e);a[b+131|0]=0;Dr(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Cr(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Dr(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Er(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Fr(){i=i;return 1912}function Gr(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[38232+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[38308+l|0]|0|0)!=28){if((d[38308+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[38308+q|0]|0|0)!=28){if((d[38308+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[38308+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Hr(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[32400+(((d[32144+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[32400+(((d[33680+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Er(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function Hr(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 0:{if((d[38308+c|0]|0|0)!=0){f=7;break a}e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function Ir(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=se[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[32400+(((d[33680+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Jr(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=se[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[32400+(((d[32144+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Kr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=se[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Hr(a)|0)<0;g=f&1;i=d;return g|0}function Lr(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Er(se[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Mr(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(se[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Nr(){i=i;return 37864}function Or(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Pr(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=24;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Pr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((bs(d,c[37768+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Qr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$t(36208,a,0,b,c,d)|0;i=e;return f|0}function Rr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$t(36208,a,1,b,c,d)|0;i=e;return f|0}function Sr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;yt(36976,b,c,d);i=a;return}function Tr(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Ur(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Ur(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(au(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,37712)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((au(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,37720)|0)!=0){h=bu(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ge[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((au(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,37736)|0)!=0){if((a|0)!=0){break}do{if((Ce[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,37752)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ce[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,37760)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((cu(bu(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Vr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((bs(h,33936)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Pr(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[36208+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Wr(){i=i;return 35840}function Xr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Pr(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=50;c[g+4>>2]=51;c[g+52>>2]=24;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Yr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$t(33944,a,0,b,c,d)|0;i=e;return f|0}function Zr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$t(33944,a,1,b,c,d)|0;i=e;return f|0}function _r(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Ur(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function $r(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((bs(h,33936)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Pr(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[33944+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function as(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Gr(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function bs(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function cs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:case 21:{n=25;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 13:{k=Fs(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;n=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 29:{g=b;if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;o=18;n=77;break a}if((c[32400+((d[33680+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;o=19;n=77;break};case 19:{k=Hs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=ts(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{k=Bs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=Gs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{o=18;b=b+2|0;n=77;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=ts(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=vs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 12:{k=Fs(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=ts(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=ts(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 15:{n=122;break b;break};case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};case 33:{n=119;break b;break};case 7:{n=91;break b;break};case 34:{n=116;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}o=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=ts(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 5:{n=105;break b;break};case 6:{n=108;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};default:{o=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 6:{n=88;break b;break};case 5:{n=85;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function ds(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 2:{k=ys(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=us(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=ts(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=ts(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function es(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=ts(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=ts(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function fs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=ts(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function gs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=ts(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=us(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=ts(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function hs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=ts(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 9:{n=21;break a;break};case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=us(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=vs(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=ts(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function is(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=ts(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=ts(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function js(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function ks(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=ts(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function ls(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=ts(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function ms(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=ts(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=ts(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function ns(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Hr(c)|0;k=j;i=b;return k|0}function os(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function ps(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=ts(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=ts(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function qs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=ts(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function rs(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function ss(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function ts(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 223:case 222:case 221:case 220:{e=8;break};case 219:case 218:case 217:case 216:{e=7;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function us(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=ws(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=ts(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function vs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=ts(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function ws(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=xs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=ts(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function xs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=ts(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=ts(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function ys(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 15:{k=Bs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 17:{k=Cs(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=ts(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=zs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=As(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=ts(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{o=45;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=ts(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 11:{o=90;break b;break};case 17:{break b;break};case 6:{o=42;break b;break};case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 10:case 9:case 21:{o=69;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=ts(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 5:{o=78;break d;break};case 10:case 9:case 21:{break};case 11:{o=90;break c;break};case 17:{break c;break};case 29:{o=75;break d;break};case 6:{o=81;break d;break};case 7:{o=84;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Ds(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function zs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=ts(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function As(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[34344+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Bs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=ts(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=ts(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Es(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=ts(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Es(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Cs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=ts(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=ts(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Ds(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=ts(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=ts(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};case 5:{l=10;break a;break};case 7:{l=16;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[32400+((d[33680+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=ts(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 6:{l=33;break a;break};case 29:{if((c[32400+((d[32144+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 24:case 22:{break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=ts(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=ts(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 2:{l=79;break a;break};case 3:{t=us(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=ts(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=ts(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 5:{l=97;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 24:case 22:{break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[32400+((d[32144+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Es(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Fs(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=ts(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=ts(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Gs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=ts(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=ts(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=zs(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Hs(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=ts(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[32400+((d[32144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=ts(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[32400+((d[33680+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Is(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=ts(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 13:{k=it(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=ts(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=et(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=jt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{o=25;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=ts(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 19:{k=kt(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=it(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 29:{g=b;if((c[32400+((d[32144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[32400+((d[33680+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=_s(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=ts(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=ts(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 6:{o=88;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=91;break b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};case 34:{o=116;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=ts(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=111;break b;break};case 29:{if((c[32400+((d[33680+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};case 5:{o=105;break b;break};case 6:{o=108;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 33:{o=119;break b;break};case 15:{o=122;break b;break};case 5:{o=85;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}



function Zn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14864]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+168>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(14872,$v(+h[(c[g>>2]|0)+168>>3],12504)|0)|0;g=c[22538]|0;j=e;k=15008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14864]=1;i=d;return}function _n(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15032]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+40>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(15040,$v(+h[(c[g>>2]|0)+40>>3],12504)|0)|0;g=c[22538]|0;j=e;k=15368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15032]=1;i=d;return}function $n(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15200]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+32>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(15208,$v(+h[(c[g>>2]|0)+32>>3],12504)|0)|0;g=c[22538]|0;j=e;k=15368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15200]=1;i=d;return}function ao(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15392]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+160>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+160>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(15400,$v(+h[(c[g>>2]|0)+160>>3],12504)|0)|0;g=c[22538]|0;j=e;k=15576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15392]=1;i=d;return}function bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15600]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+152>>3],1.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+152>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=dw(15608,$v(+h[(c[g>>2]|0)+152>>3],12504)|0)|0;g=c[22538]|0;j=e;k=15768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15600]=1;i=d;return}function co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15792]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(15800,$v(+h[(c[g>>2]|0)+144>>3],12504)|0)|0;g=c[22538]|0;j=e;k=15960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15792]=1;i=d;return}function eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15984]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+24>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(15992,$v(+h[(c[g>>2]|0)+24>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[15984]=1;i=d;return}function fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16120]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+16>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(16128,$v(+h[(c[g>>2]|0)+16>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16120]=1;i=d;return}function go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16280]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+136>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+136>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(16288,$v(+h[(c[g>>2]|0)+136>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16280]=1;i=d;return}function ho(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16448]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+128>>3],1.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+128>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=dw(16456,$v(+h[(c[g>>2]|0)+128>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16448]=1;i=d;return}function io(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16600]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+120>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(16608,$v(+h[(c[g>>2]|0)+120>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16600]=1;i=d;return}function jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16752]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+112>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(16760,$v(+h[(c[g>>2]|0)+112>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16752]=1;i=d;return}function ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16904]&1){i=d;return}g=b+416|0;if(!((Ly(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=dw(16912,$v(+h[(c[g>>2]|0)+88>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[16904]=1;i=d;return}function lo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17008]&1){i=d;return}g=b+416|0;if(!((Ly(+h[(c[g>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=d;return}b=dw(17016,$v(+h[(c[g>>2]|0)+80>>3],12504)|0)|0;g=c[22538]|0;j=e;k=17088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17008]=1;i=d;return}function mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17112]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],.001)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],.25)|0)<<24>>24==0)){i=d;return}b=dw(17120,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],12504)|0)|0;g=c[22538]|0;j=e;k=17584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17112]=1;i=d;return}function no(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17280]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(17288,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],12504)|0)|0;g=c[22538]|0;j=e;k=18024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17280]=1;i=d;return}function oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17448]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],.001)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],.25)|0)<<24>>24==0)){i=d;return}b=dw(17456,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],12504)|0)|0;g=c[22538]|0;j=e;k=17584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17448]=1;i=d;return}function po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17608]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(17616,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],12504)|0)|0;g=c[22538]|0;j=e;k=17864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17608]=1;i=d;return}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17888]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(17896,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],12504)|0)|0;g=c[22538]|0;j=e;k=18024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[17888]=1;i=d;return}function ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18048]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(18056,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],12504)|0)|0;g=c[22538]|0;j=e;k=18192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18048]=1;i=d;return}function so(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18216]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(18224,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],12504)|0)|0;g=c[22538]|0;j=e;k=18352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18216]=1;i=d;return}function to(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18376]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(18384,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],12504)|0)|0;g=c[22538]|0;j=e;k=19536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18376]=1;i=d;return}function uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18552]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+704>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(18560,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+704>>3],12504)|0)|0;g=c[22538]|0;j=e;k=18696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18552]=1;i=d;return}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18720]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+696>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+696>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(18728,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+696>>3],12504)|0)|0;g=c[22538]|0;j=e;k=18872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18720]=1;i=d;return}function wo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18896]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(18904,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],12504)|0)|0;g=c[22538]|0;j=e;k=19040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[18896]=1;i=d;return}function xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19064]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=dw(19072,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],12504)|0)|0;g=c[22538]|0;j=e;k=19200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19064]=1;i=d;return}function yo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19224]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+672>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+672>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(19232,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+672>>3],12504)|0)|0;g=c[22538]|0;j=e;k=19368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19224]=1;i=d;return}function zo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19392]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(19400,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],12504)|0)|0;g=c[22538]|0;j=e;k=19536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19392]=1;i=d;return}function Ao(a){a=a|0;var b=0;b=i;Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);fn(a);gn(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);qn(a);rn(a);sn(a);tn(a);un(a);vn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);In(a);Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);yo(a);zo(a);i=b;return 0}function Bo(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Co(b);i=c;return 0}function Co(a){a=a|0;var b=0;b=i;Ze(a);$e(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);kf(a);lf(a);mf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);If(a);Lf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);eg(a);fg(a);mg(a);ng(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);i=b;return}function Do(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19560]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(19576,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],19568)|0)|0;g=c[22538]|0;j=e;k=25216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19560]=1;i=d;return}function Eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19784]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(19792,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19784]=1;i=d;return}function Fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19936]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(19944,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[19936]=1;i=d;return}function Go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20096]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(20104,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],19568)|0)|0;g=c[22538]|0;j=e;k=25696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20096]=1;i=d;return}function Ho(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20232]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(20240,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],19568)|0)|0;g=c[22538]|0;j=e;k=25864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20232]=1;i=d;return}function Io(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20368]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(20376,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20368]=1;i=d;return}function Jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20512]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(20520,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20512]=1;i=d;return}function Ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20640]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=dw(20648,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20640]=1;i=d;return}function Lo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20768]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(20776,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20768]=1;i=d;return}function Mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20904]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(20912,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[20904]=1;i=d;return}function No(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21048]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=dw(21056,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21048]=1;i=d;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21184]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],.001)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],.25)|0)<<24>>24==0)){i=d;return}b=dw(21192,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21184]=1;i=d;return}function Po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21320]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(21328,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21320]=1;i=d;return}function Qo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21552]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(21560,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21552]=1;i=d;return}function Ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21696]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(21704,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21696]=1;i=d;return}function So(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21840]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(21848,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21840]=1;i=d;return}function To(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21976]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(21984,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[21976]=1;i=d;return}function Uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22112]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(22120,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22112]=1;i=d;return}function Vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22280]&1){i=d;return}g=b+4|0;if(!((Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=dw(22288,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22280]=1;i=d;return}function Wo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22368]&1){i=d;return}g=b+4|0;if(!((Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=dw(22376,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22368]=1;i=d;return}function Xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22464]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(22472,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22464]=1;i=d;return}function Yo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22632]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(22640,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22632]=1;i=d;return}function Zo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22808]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=dw(22816,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22808]=1;i=d;return}function _o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22976]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(22984,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[22976]=1;i=d;return}function $o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23160]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(23168,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[23160]=1;i=d;return}function ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23336]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(23344,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[23336]=1;i=d;return}function bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23504]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(23512,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[23504]=1;i=d;return}function cp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23672]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(23680,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[23672]=1;i=d;return}function dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23872]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(23880,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[23872]=1;i=d;return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24056]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(24064,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24056]=1;i=d;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24248]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(24256,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],19568)|0)|0;g=c[22538]|0;j=e;k=24392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24248]=1;i=d;return}function gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24416]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(24424,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],19568)|0)|0;g=c[22538]|0;j=e;k=24552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24416]=1;i=d;return}function hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24576]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(24584,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24576]=1;i=d;return}function ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24744]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(24752,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24744]=1;i=d;return}function jp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24920]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(24928,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24920]=1;i=d;return}function kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25064]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(25072,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],19568)|0)|0;g=c[22538]|0;j=e;k=25216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25064]=1;i=d;return}function lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25240]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(25248,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25240]=1;i=d;return}function mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25392]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(25400,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25392]=1;i=d;return}function np(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25560]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(25568,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],19568)|0)|0;g=c[22538]|0;j=e;k=25696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25560]=1;i=d;return}function op(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25720]&1){i=d;return}g=b+4|0;b=Ly(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(25728,$v(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],19568)|0)|0;g=c[22538]|0;j=e;k=25864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25720]=1;i=d;return}function pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25888]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(25896,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25888]=1;i=d;return}function qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26064]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(26072,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26064]=1;i=d;return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26224]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=dw(26232,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26224]=1;i=d;return}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26384]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(26392,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26384]=1;i=d;return}function tp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26544]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(26552,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26544]=1;i=d;return}function up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26712]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=dw(26720,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],19568)|0)|0;g=c[22538]|0;j=e;k=26848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26712]=1;i=d;return}function vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26872]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],.001)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],.25)|0)<<24>>24==0)){i=d;return}b=dw(26880,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26872]=1;i=d;return}function wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27032]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(27040,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27032]=1;i=d;return}function xp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27200]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(27208,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27200]=1;i=d;return}function yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27376]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(27384,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27376]=1;i=d;return}function zp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27544]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(27552,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27544]=1;i=d;return}function Ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27712]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(27720,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],19568)|0)|0;g=c[22538]|0;j=e;k=27856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27712]=1;i=d;return}function Bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27880]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(27888,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27880]=1;i=d;return}function Cp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28072]&1){i=d;return}g=b+4|0;if(!((Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=dw(28080,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28072]=1;i=d;return}function Dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28184]&1){i=d;return}g=b+4|0;if(!((Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=dw(28192,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28184]=1;i=d;return}function Ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28304]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],-1.0e8)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(28312,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28304]=1;i=d;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28496]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(28504,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28496]=1;i=d;return}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28696]&1){i=d;return}g=b+4|0;b=Ly(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],-1.0e5)|0;if(!(b<<24>>24==0|(Ky(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(28704,$v(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],19568)|0)|0;g=c[22538]|0;j=e;k=28840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28696]=1;i=d;return}function Hp(a){a=a|0;var b=0;b=i;Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);i=b;return 0}function Ip(a){a=a|0;i=i;return 1}function Jp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=6;c[a+48>>2]=6;c[a+72>>2]=a_(6,8)|0;a=a_(6,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=a_(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=_Z(24)|0;c[(c[d>>2]|0)+52>>2]=a;a=_Z(136)|0;c[(c[d>>2]|0)+56>>2]=a;a=_Z(24)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=6;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=6;c[e+4>>2]=12;c[e+8>>2]=17;c[e+12>>2]=23;c[e+16>>2]=28;c[e+20>>2]=34;Kp(e,c[a+56>>2]|0);a=c[d>>2]|0;Lp(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Mp(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Np(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Op(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Pp(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+20>>2]=1;c[a+4>>2]=2;c[a+16>>2]=3;c[a+12>>2]=4;c[a>>2]=5;c[a+8>>2]=6;i=b;return 0}function Kp(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=5;i=i;return}function Lp(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=5;i=i;return}function Mp(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=2;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=5;i=i;return}function Np(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=5;i=i;return}function Op(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -6<<2)>>2]=2;c[b+((c[a>>2]|0)+ -5<<2)>>2]=0;c[b+((c[a>>2]|0)+ -4<<2)>>2]=3;c[b+((c[a>>2]|0)+ -3<<2)>>2]=4;c[b+((c[a>>2]|0)+ -2<<2)>>2]=1;c[b+((c[a>>2]|0)+ -1<<2)>>2]=5;i=i;return}function Pp(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=2;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=3;c[b+((c[d>>2]|0)+ -2<<2)>>2]=4;c[b+((c[d>>2]|0)+ -1<<2)>>2]=5;i=i;return}function Qp(a){a=a|0;i=i;return 1}function Rp(a){a=a|0;i=i;return 1}function Sp(a){a=a|0;i=i;return 1}function Tp(a){a=a|0;i=i;return 0}function Up(a){a=a|0;i=i;return 0}function Vp(a){a=a|0;i=i;return 0}function Wp(a){a=a|0;i=i;return 0}function Xp(a){a=a|0;i=i;return 0}function Yp(a,b){a=a|0;b=b|0;i=i;return-1}function Zp(a,b){a=a|0;b=b|0;i=i;return-1}function _p(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function $p(){i=i;return 28864}function aq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function bq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function cq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function dq(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(29680,n|0)|0;i=m;return 0}function eq(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=Gx(a,29688)|0;z=Gx(b,29688)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((Gx(a,29696)|0)!=0){C=5;break}if((Gx(a,29704)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((Gx(b,29696)|0)!=0){break}if((Gx(b,29704)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){G_(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}G_(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}G_(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(29712,r|0)|0;i=q;return 0}function fq(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(Gx(a,29720)|0)!=0;v=c[(u?f:g)>>2]|0;w=Gx(e,29728)|0;x=Gx(b,29736)|0;c[p>>2]=0;do{if(u){y=4}else{if((Gx(a,29744)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((Gx(b,29720)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((Gx(d,29728)|0)==0){if((Gx(d,29752)|0)!=0){break}if((Gx(d,29760)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((Gx(e,29736)|0)==0){if((Gx(e,29728)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){G_(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(Gx(d,29728)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(29768,p|0)|0;i=o;return 0}function gq(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}iq(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}jq(29784,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(29776,l|0)|0;i=k;return 0}function hq(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+nx(29808);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(aq(l,z,29816)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){cq(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;bq(l,n,d+(x-o+v<<3)|0,29816)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;dq(l,m,29824,d+(B+y<<3)|0,29816,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(29800,k|0)|0;i=j;return 0}function iq(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=29856;u=lq(29840,29832,29848,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;hq(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;kq(k,d,e,m,l,f,29840)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;kq(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,29840)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;fq(29864,29872,29880,29896,n,k,29904,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=29880;eq(H,H,k,l,n,29912,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,29904,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);hq(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(29832,j|0)|0;i=h;return 0}function jq(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(Gx(a,29920)|0)!=0;do{if(n){o=5}else{if((Gx(a,29928)|0)!=0){o=5;break}if((Gx(a,29936)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=29952;kq(d,h,j,q,b,g,q)|0;fq(29960,29968,29976,29992,b,d,3e4,e,f,h,j)|0;fq(29960,30008,29976,30016,b,d,3e4,e,f,h,j)|0;i=l;return 0}else{fq(29960,30008,30032,30016,b,d,3e4,e,f,h,j)|0;fq(29960,29968,30032,29992,b,d,3e4,e,f,h,j)|0;kq(d,h,j,29952,b,g,30048)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(29944,m|0)|0;i=l;return 0}function kq(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function lq(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=C_(d|0)|0;switch(c[b>>2]|0){case 4:{q=6;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 10:{q=mq(30288,30296,30304)|0;i=k;return q|0};case 11:{q=mq(30312,30296,30304)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=nq(b,d,e,f,g,h,j)|0;i=k;return q|0};case 6:{h=c[f>>2]|0;f=c[g>>2]|0;q=~~(+(((h|0)>(f|0)?f:h)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 3:case 2:case 1:{h=o;JN(h,d,1,p);p=a[h]|0;do{if((p+ -97<<24>>24&255)<26){d=p+ -32<<24>>24;a[h]=d;f=o+1|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+2|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+3|0;e=a[f]|0;if((e+ -97<<24>>24&255)<26){a[f]=e+ -32<<24>>24}e=o+4|0;f=a[e]|0;if((f+ -97<<24>>24&255)<26){a[e]=f+ -32<<24>>24}f=o+5|0;e=a[f]|0;if(!((e+ -97<<24>>24&255)<26)){r=d;break}a[f]=e+ -32<<24>>24;r=d}else{r=p}}while(0);p=r<<24>>24==83;h=r<<24>>24==68;d=p|h;if(!(r<<24>>24==67|r<<24>>24==68|r<<24>>24==83|r<<24>>24==90)){q=1;i=k;return q|0}e=l;JN(e,o+1|0,1,2);l=m;JN(l,o+3|0,1,3);o=n;JN(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((IN(e,30056,1,2)|0)==0){if((IN(l,30072,1,3)|0)==0){q=2;i=k;return q|0}if((IN(l,30080,1,3)|0)==0){q=2;i=k;return q|0}if((IN(l,30088,1,3)|0)==0){q=2;i=k;return q|0}if((IN(l,30096,1,3)|0)==0){q=2;i=k;return q|0}if((IN(l,30104,1,3)|0)==0){q=2;i=k;return q|0}if((IN(l,30112,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((IN(e,30136,1,2)|0)==0){b=(IN(l,30064,1,3)|0)==0;if(b|(p|h)^1){q=b?8:2;i=k;return q|0}q=2;i=k;return q|0}if(r<<24>>24==67|r<<24>>24==90){s=91}else if(r<<24>>24==68|r<<24>>24==83){s=94}else{q=2;i=k;return q|0}do{if((s|0)==91){if((IN(e,30160,1,2)|0)==0){q=2;i=k;return q|0}else{if(r<<24>>24==67|r<<24>>24==90){break}else if(r<<24>>24==68|r<<24>>24==83){s=94;break}else{q=2}i=k;return q|0}}}while(0);do{if((s|0)==94){if((IN(e,30168,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){break}else{q=2}i=k;return q|0}b=a[l]|0;if(b<<24>>24==71){if((IN(o,30176,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30184,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30192,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30200,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30208,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30216,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(b<<24>>24==77){if((IN(o,30176,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30184,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30192,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30200,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30208,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30216,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((IN(e,30232,1,2)|0)!=0){q=2;i=k;return q|0}b=a[l]|0;if(b<<24>>24==77){if((IN(o,30176,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30184,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30192,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30200,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30208,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30216,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(b<<24>>24==71){if((IN(o,30176,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30184,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30192,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30200,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30208,1,2)|0)==0){q=2;i=k;return q|0}if((IN(o,30216,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else if((m|0)==3){if((IN(e,30056,1,2)|0)==0){if((IN(l,30072,1,3)|0)==0){q=128;i=k;return q|0}if((IN(l,30080,1,3)|0)==0){q=128;i=k;return q|0}if((IN(l,30088,1,3)|0)==0){q=128;i=k;return q|0}if((IN(l,30096,1,3)|0)==0){q=128;i=k;return q|0}if((IN(l,30104,1,3)|0)==0){q=128;i=k;return q|0}m=(IN(l,30112,1,3)|0)==0;q=m?128:0;i=k;return q|0}if((IN(e,30136,1,2)|0)==0){if(!(r<<24>>24==68|r<<24>>24==83)){q=0;i=k;return q|0}m=(IN(l,30144,1,3)|0)==0;q=m?32:0;i=k;return q|0}if(r<<24>>24==68|r<<24>>24==83){s=141}else if(r<<24>>24==67|r<<24>>24==90){s=138}else{q=0;i=k;return q|0}do{if((s|0)==138){if((IN(e,30160,1,2)|0)==0){m=(IN(l,30144,1,3)|0)==0;q=m?32:0;i=k;return q|0}else{if(r<<24>>24==68|r<<24>>24==83){s=141;break}else if(r<<24>>24==67|r<<24>>24==90){break}else{q=0}i=k;return q|0}}}while(0);do{if((s|0)==141){if((IN(e,30168,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((IN(o,30176,1,2)|0)!=0){if((IN(o,30184,1,2)|0)==0){break}if((IN(o,30192,1,2)|0)==0){break}if((IN(o,30200,1,2)|0)==0){break}if((IN(o,30208,1,2)|0)==0){break}if((IN(o,30216,1,2)|0)==0){break}if((IN(o,30224,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((IN(e,30232,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((IN(o,30176,1,2)|0)!=0){if((IN(o,30184,1,2)|0)==0){break}if((IN(o,30192,1,2)|0)==0){break}if((IN(o,30200,1,2)|0)==0){break}if((IN(o,30208,1,2)|0)==0){break}if((IN(o,30216,1,2)|0)==0){break}if((IN(o,30224,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else{if((IN(e,30056,1,2)|0)==0){if((IN(l,30064,1,3)|0)==0){q=64;i=k;return q|0}if((IN(l,30072,1,3)|0)==0){q=32;i=k;return q|0}if((IN(l,30080,1,3)|0)==0){q=32;i=k;return q|0}if((IN(l,30088,1,3)|0)==0){q=32;i=k;return q|0}if((IN(l,30096,1,3)|0)==0){q=32;i=k;return q|0}if((IN(l,30104,1,3)|0)==0){q=32;i=k;return q|0}if((IN(l,30112,1,3)|0)==0){q=32;i=k;return q|0}m=(IN(l,30120,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((IN(e,30128,1,2)|0)==0){m=(IN(l,30064,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((IN(e,30136,1,2)|0)==0){m=(IN(l,30064,1,3)|0)==0;if(m|d^1){q=m?64:1;i=k;return q|0}m=(IN(l,30144,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(IN(l,30152,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(r<<24>>24==68|r<<24>>24==83){s=29}else if(r<<24>>24==67|r<<24>>24==90){if((IN(e,30160,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){s=48;break}else if(r<<24>>24==68|r<<24>>24==83){s=29;break}else{break}}if((IN(l,30064,1,3)|0)==0){q=64;i=k;return q|0}if((IN(l,30144,1,3)|0)==0){q=32;i=k;return q|0}m=(IN(l,30152,1,3)|0)==0;q=m?64:1;i=k;return q|0}}while(0);do{if((s|0)==29){if((IN(e,30168,1,2)|0)!=0){if(r<<24>>24==67|r<<24>>24==90){s=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((IN(o,30176,1,2)|0)!=0){if((IN(o,30184,1,2)|0)==0){break}if((IN(o,30192,1,2)|0)==0){break}if((IN(o,30200,1,2)|0)==0){break}if((IN(o,30208,1,2)|0)==0){break}if((IN(o,30216,1,2)|0)==0){break}if((IN(o,30224,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((IN(o,30176,1,2)|0)!=0){if((IN(o,30184,1,2)|0)==0){break}if((IN(o,30192,1,2)|0)==0){break}if((IN(o,30200,1,2)|0)==0){break}if((IN(o,30208,1,2)|0)==0){break}if((IN(o,30216,1,2)|0)==0){break}if((IN(o,30224,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((s|0)==48){if((IN(e,30232,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((IN(o,30176,1,2)|0)!=0){if((IN(o,30184,1,2)|0)==0){break}if((IN(o,30192,1,2)|0)==0){break}if((IN(o,30200,1,2)|0)==0){break}if((IN(o,30208,1,2)|0)==0){break}if((IN(o,30216,1,2)|0)==0){break}if((IN(o,30224,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((IN(o,30176,1,2)|0)!=0){if((IN(o,30184,1,2)|0)==0){break}if((IN(o,30192,1,2)|0)==0){break}if((IN(o,30200,1,2)|0)==0){break}if((IN(o,30208,1,2)|0)==0){break}if((IN(o,30216,1,2)|0)==0){break}if((IN(o,30224,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((IN(e,30240,1,2)|0)==0){if((IN(l,30064,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((IN(e,30248,1,2)|0)==0){if((IN(l,30064,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((IN(e,30216,1,2)|0)==0){g=(IN(l,30120,1,3)|0)==0;q=g?64:1;i=k;return q|0}if((IN(e,30256,1,2)|0)==0){g=(IN(l,30264,1,3)|0)==0;q=g?64:1;i=k;return q|0}if(!(r<<24>>24==68|r<<24>>24==83)){q=1;i=k;return q|0}if((IN(e,30272,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};default:{q=-1;i=k;return q|0}}return 0}function mq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function nq(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(HN(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 15:{p=o;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 12:{p=75;i=j;return p|0};case 14:{p=14;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function oq(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=pq(a,0,0)|0;i=b;return c|0}function pq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=qq(a,b,c,0)|0;i=d;return e|0}function qq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=de[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=_Z(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=196}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=de[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){ae[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=de[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){ae[c[b+20>>2]&255](c[j+392>>2]|0);ae[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Br(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}ae[c[j+20>>2]&255](c[j+44>>2]|0);ae[c[j+20>>2]&255](c[j+392>>2]|0);ae[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Cr(j+416|0,j+12|0);Cr(j+440|0,j+12|0);sq(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}vq(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Wr()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Nr()|0}k=j;l=k;i=g;return l|0}function rq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}



function TW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function UW(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function VW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function WW(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=115088;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}h_(e)}}while(0);g_(b);i=d;return}function XW(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=115088;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}h_(e);i=d;return}function YW(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(yd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function ZW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(yd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function _W(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function $W(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function aX(a,b){a=a|0;b=b|0;i=i;return b|0}function bX(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function cX(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function dX(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function eX(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function fX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function gX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function hX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function iX(a){a=a|0;i=i;return 1}function jX(a){a=a|0;i=i;return 1}function kX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function lX(a){a=a|0;i=i;return 1}function mX(a){a=a|0;var b=0;b=i;uW(a);g_(a);i=b;return}function nX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=eZ(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=dZ(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=dZ(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function oX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=aZ(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=$Y(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=$Y(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function pX(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=dZ(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function qX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=cZ(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function rX(a){a=a|0;i=i;return 0}function sX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=_Y(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function tX(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function uX(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function vX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=wX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function wX(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function xX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=yX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function yX(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function zX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function AX(a){a=a|0;i=i;return 0}function BX(a){a=a|0;i=i;return 0}function CX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=DX(c,d,e,1114111,0)|0;i=b;return a|0}function DX(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function EX(a){a=a|0;i=i;return 4}function FX(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function GX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=HX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function HX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function IX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=JX(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function JX(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function KX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function LX(a){a=a|0;i=i;return 0}function MX(a){a=a|0;i=i;return 0}function NX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=OX(c,d,e,1114111,0)|0;i=b;return a|0}function OX(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function PX(a){a=a|0;i=i;return 4}function QX(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function RX(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function SX(a){a=a|0;var b=0;b=i;c[a>>2]=115240;VP(a+12|0);g_(a);i=b;return}function TX(a){a=a|0;var b=0;b=i;c[a>>2]=115240;VP(a+12|0);i=b;return}function UX(a){a=a|0;var b=0;b=i;c[a>>2]=115280;VP(a+16|0);g_(a);i=b;return}function VX(a){a=a|0;var b=0;b=i;c[a>>2]=115280;VP(a+16|0);i=b;return}function WX(b){b=b|0;i=i;return a[b+8|0]|0}function XX(a){a=a|0;i=i;return c[a+8>>2]|0}function YX(b){b=b|0;i=i;return a[b+9|0]|0}function ZX(a){a=a|0;i=i;return c[a+12>>2]|0}function _X(a,b){a=a|0;b=b|0;var c=0;c=i;LP(a,b+12|0);i=c;return}function $X(a,b){a=a|0;b=b|0;var c=0;c=i;LP(a,b+16|0);i=c;return}function aY(a,b){a=a|0;b=b|0;b=i;NP(a,115312,4);i=b;return}function bY(a,b){a=a|0;b=b|0;b=i;vQ(a,115320,AZ(115320)|0);i=b;return}function cY(a,b){a=a|0;b=b|0;b=i;NP(a,115344,5);i=b;return}function dY(a,b){a=a|0;b=b|0;b=i;vQ(a,115352,AZ(115352)|0);i=b;return}function eY(b){b=b|0;var d=0,e=0;b=i;if((a[115384]|0)!=0){d=115376;e=c[28844]|0;i=b;return e|0}if((Za(115384)|0)==0){d=115376;e=c[28844]|0;i=b;return e|0}do{if((a[122584]|0)==0){if((Za(122584)|0)==0){break}G_(122416,0,168)|0;Ud(222,0,q|0)|0;Tb(122584)}}while(0);YP(122416,122592)|0;YP(122428|0,122600)|0;YP(122440|0,122608)|0;YP(122452|0,122616)|0;YP(122464|0,122632)|0;YP(122476|0,122648)|0;YP(122488|0,122656)|0;YP(122500|0,122672)|0;YP(122512|0,122680)|0;YP(122524|0,122688)|0;YP(122536|0,122696)|0;YP(122548|0,122704)|0;YP(122560|0,122712)|0;YP(122572|0,122720)|0;c[28844]=122416;Tb(115384);d=115376;e=c[28844]|0;i=b;return e|0}function fY(b){b=b|0;var d=0,e=0;b=i;if((a[115400]|0)!=0){d=115392;e=c[28848]|0;i=b;return e|0}if((Za(115400)|0)==0){d=115392;e=c[28848]|0;i=b;return e|0}do{if((a[122048]|0)==0){if((Za(122048)|0)==0){break}G_(121880,0,168)|0;Ud(223,0,q|0)|0;Tb(122048)}}while(0);yQ(121880,122056)|0;yQ(121892|0,122088)|0;yQ(121904|0,122120)|0;yQ(121916|0,122152)|0;yQ(121928|0,122192)|0;yQ(121940|0,122232)|0;yQ(121952|0,122264)|0;yQ(121964|0,122304)|0;yQ(121976|0,122320)|0;yQ(121988|0,122336)|0;yQ(122e3|0,122352)|0;yQ(122012|0,122368)|0;yQ(122024|0,122384)|0;yQ(122036|0,122400)|0;c[28848]=121880;Tb(115400);d=115392;e=c[28848]|0;i=b;return e|0}function gY(b){b=b|0;var d=0,e=0;b=i;if((a[115416]|0)!=0){d=115408;e=c[28852]|0;i=b;return e|0}if((Za(115416)|0)==0){d=115408;e=c[28852]|0;i=b;return e|0}do{if((a[121656]|0)==0){if((Za(121656)|0)==0){break}G_(121368,0,288)|0;Ud(224,0,q|0)|0;Tb(121656)}}while(0);YP(121368,121664)|0;YP(121380|0,121672)|0;YP(121392|0,121688)|0;YP(121404|0,121696)|0;YP(121416|0,121704)|0;YP(121428|0,121712)|0;YP(121440|0,121720)|0;YP(121452|0,121728)|0;YP(121464|0,121736)|0;YP(121476|0,121752)|0;YP(121488|0,121760)|0;YP(121500|0,121776)|0;YP(121512|0,121792)|0;YP(121524|0,121800)|0;YP(121536|0,121808)|0;YP(121548|0,121816)|0;YP(121560|0,121704)|0;YP(121572|0,121824)|0;YP(121584|0,121832)|0;YP(121596|0,121840)|0;YP(121608|0,121848)|0;YP(121620|0,121856)|0;YP(121632|0,121864)|0;YP(121644|0,121872)|0;c[28852]=121368;Tb(115416);d=115408;e=c[28852]|0;i=b;return e|0}function hY(b){b=b|0;var d=0,e=0;b=i;if((a[115432]|0)!=0){d=115424;e=c[28856]|0;i=b;return e|0}if((Za(115432)|0)==0){d=115424;e=c[28856]|0;i=b;return e|0}do{if((a[120816]|0)==0){if((Za(120816)|0)==0){break}G_(120528,0,288)|0;Ud(225,0,q|0)|0;Tb(120816)}}while(0);yQ(120528,120824)|0;yQ(120540|0,120856)|0;yQ(120552|0,120896)|0;yQ(120564|0,120920)|0;yQ(120576|0,121240)|0;yQ(120588|0,120944)|0;yQ(120600|0,120968)|0;yQ(120612|0,120992)|0;yQ(120624|0,121024)|0;yQ(120636|0,121064)|0;yQ(120648|0,121096)|0;yQ(120660|0,121136)|0;yQ(120672|0,121176)|0;yQ(120684|0,121192)|0;yQ(120696|0,121208)|0;yQ(120708|0,121224)|0;yQ(120720|0,121240)|0;yQ(120732|0,121256)|0;yQ(120744|0,121272)|0;yQ(120756|0,121288)|0;yQ(120768|0,121304)|0;yQ(120780|0,121320)|0;yQ(120792|0,121336)|0;yQ(120804|0,121352)|0;c[28856]=120528;Tb(115432);d=115424;e=c[28856]|0;i=b;return e|0}function iY(b){b=b|0;var d=0,e=0;b=i;if((a[115448]|0)!=0){d=115440;e=c[28860]|0;i=b;return e|0}if((Za(115448)|0)==0){d=115440;e=c[28860]|0;i=b;return e|0}do{if((a[120504]|0)==0){if((Za(120504)|0)==0){break}G_(120216,0,288)|0;Ud(226,0,q|0)|0;Tb(120504)}}while(0);YP(120216,120512)|0;YP(120228|0,120520)|0;c[28860]=120216;Tb(115448);d=115440;e=c[28860]|0;i=b;return e|0}function jY(b){b=b|0;var d=0,e=0;b=i;if((a[115464]|0)!=0){d=115456;e=c[28864]|0;i=b;return e|0}if((Za(115464)|0)==0){d=115456;e=c[28864]|0;i=b;return e|0}do{if((a[120176]|0)==0){if((Za(120176)|0)==0){break}G_(119888,0,288)|0;Ud(227,0,q|0)|0;Tb(120176)}}while(0);yQ(119888,120184)|0;yQ(119900|0,120200)|0;c[28864]=119888;Tb(115464);d=115456;e=c[28864]|0;i=b;return e|0}function kY(b){b=b|0;var c=0;b=i;if((a[115488]|0)!=0){c=115472;i=b;return c|0}if((Za(115488)|0)==0){c=115472;i=b;return c|0}NP(115472,115496,8);Ud(228,115472,q|0)|0;Tb(115488);c=115472;i=b;return c|0}function lY(b){b=b|0;var c=0;b=i;if((a[115528]|0)!=0){c=115512;i=b;return c|0}if((Za(115528)|0)==0){c=115512;i=b;return c|0}vQ(115512,115536,AZ(115536)|0);Ud(229,115512,q|0)|0;Tb(115528);c=115512;i=b;return c|0}function mY(b){b=b|0;var c=0;b=i;if((a[115592]|0)!=0){c=115576;i=b;return c|0}if((Za(115592)|0)==0){c=115576;i=b;return c|0}NP(115576,115600,8);Ud(228,115576,q|0)|0;Tb(115592);c=115576;i=b;return c|0}function nY(b){b=b|0;var c=0;b=i;if((a[115632]|0)!=0){c=115616;i=b;return c|0}if((Za(115632)|0)==0){c=115616;i=b;return c|0}vQ(115616,115640,AZ(115640)|0);Ud(229,115616,q|0)|0;Tb(115632);c=115616;i=b;return c|0}function oY(b){b=b|0;var c=0;b=i;if((a[115696]|0)!=0){c=115680;i=b;return c|0}if((Za(115696)|0)==0){c=115680;i=b;return c|0}NP(115680,115704,20);Ud(228,115680,q|0)|0;Tb(115696);c=115680;i=b;return c|0}function pY(b){b=b|0;var c=0;b=i;if((a[115744]|0)!=0){c=115728;i=b;return c|0}if((Za(115744)|0)==0){c=115728;i=b;return c|0}vQ(115728,115752,AZ(115752)|0);Ud(229,115728,q|0)|0;Tb(115744);c=115728;i=b;return c|0}function qY(b){b=b|0;var c=0;b=i;if((a[115856]|0)!=0){c=115840;i=b;return c|0}if((Za(115856)|0)==0){c=115840;i=b;return c|0}NP(115840,115864,11);Ud(228,115840,q|0)|0;Tb(115856);c=115840;i=b;return c|0}function rY(b){b=b|0;var c=0;b=i;if((a[115896]|0)!=0){c=115880;i=b;return c|0}if((Za(115896)|0)==0){c=115880;i=b;return c|0}vQ(115880,115904,AZ(115904)|0);Ud(229,115880,q|0)|0;Tb(115896);c=115880;i=b;return c|0}function sY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);l=+w_(b,g,c[28740]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function tY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);l=+w_(b,g,c[28740]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function uY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);l=+w_(b,g,c[28740]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function vY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);n=lb(b|0,h|0,f|0,c[28740]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function wY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);m=lb(b|0,h|0,f|0,c[28740]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function xY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);m=lb(b|0,h|0,f|0,c[28740]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function yY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);m=lb(b|0,h|0,f|0,c[28740]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function zY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);n=Gc(b|0,h|0,f|0,c[28740]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function AY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[114968]|0)==0){if((Za(114968)|0)==0){break}c[28740]=Zb(2147483647,114976,0)|0;Tb(114968)}}while(0);m=Gc(b|0,h|0,f|0,c[28740]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function BY(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;ae[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;ae[h&255](a);i=b;return}}function CY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){vW(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=e_(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;E_(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{g_(h);i=e;return}}function DY(a){a=a|0;a=i;xQ(120164|0);xQ(120152|0);xQ(120140|0);xQ(120128|0);xQ(120116|0);xQ(120104|0);xQ(120092|0);xQ(120080|0);xQ(120068|0);xQ(120056|0);xQ(120044|0);xQ(120032|0);xQ(120020|0);xQ(120008|0);xQ(119996|0);xQ(119984|0);xQ(119972|0);xQ(119960|0);xQ(119948|0);xQ(119936|0);xQ(119924|0);xQ(119912|0);xQ(119900|0);xQ(119888);i=a;return}function EY(a){a=a|0;a=i;VP(120492|0);VP(120480|0);VP(120468|0);VP(120456|0);VP(120444|0);VP(120432|0);VP(120420|0);VP(120408|0);VP(120396|0);VP(120384|0);VP(120372|0);VP(120360|0);VP(120348|0);VP(120336|0);VP(120324|0);VP(120312|0);VP(120300|0);VP(120288|0);VP(120276|0);VP(120264|0);VP(120252|0);VP(120240|0);VP(120228|0);VP(120216);i=a;return}function FY(a){a=a|0;a=i;xQ(120804|0);xQ(120792|0);xQ(120780|0);xQ(120768|0);xQ(120756|0);xQ(120744|0);xQ(120732|0);xQ(120720|0);xQ(120708|0);xQ(120696|0);xQ(120684|0);xQ(120672|0);xQ(120660|0);xQ(120648|0);xQ(120636|0);xQ(120624|0);xQ(120612|0);xQ(120600|0);xQ(120588|0);xQ(120576|0);xQ(120564|0);xQ(120552|0);xQ(120540|0);xQ(120528);i=a;return}function GY(a){a=a|0;a=i;VP(121644|0);VP(121632|0);VP(121620|0);VP(121608|0);VP(121596|0);VP(121584|0);VP(121572|0);VP(121560|0);VP(121548|0);VP(121536|0);VP(121524|0);VP(121512|0);VP(121500|0);VP(121488|0);VP(121476|0);VP(121464|0);VP(121452|0);VP(121440|0);VP(121428|0);VP(121416|0);VP(121404|0);VP(121392|0);VP(121380|0);VP(121368);i=a;return}function HY(a){a=a|0;a=i;xQ(122036|0);xQ(122024|0);xQ(122012|0);xQ(122e3|0);xQ(121988|0);xQ(121976|0);xQ(121964|0);xQ(121952|0);xQ(121940|0);xQ(121928|0);xQ(121916|0);xQ(121904|0);xQ(121892|0);xQ(121880);i=a;return}function IY(a){a=a|0;a=i;VP(122572|0);VP(122560|0);VP(122548|0);VP(122536|0);VP(122524|0);VP(122512|0);VP(122500|0);VP(122488|0);VP(122476|0);VP(122464|0);VP(122452|0);VP(122440|0);VP(122428|0);VP(122416);i=a;return}function JY(a){a=a|0;var b=0,c=0;b=i;if((PY(a)|0)==0){c=(KY(a)|0)!=0|0}else{c=1}i=b;return c|0}function KY(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[122728+((d[122728+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function LY(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function MY(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function NY(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 4:{d=MY(a)|0;break};case 1:{d=JY(a)|0;break};case 6:{d=QY(a)|0;break};case 11:{d=VY(a)|0;break};case 12:{d=WY(a)|0;break};case 10:{d=UY(a)|0;break};case 5:{d=PY(a)|0;break};case 9:{d=TY(a)|0;break};case 2:{d=KY(a)|0;break};case 3:{d=LY(a)|0;break};case 8:{d=SY(a)|0;break};case 7:{d=RY(a)|0;break};default:{d=0}}i=c;return d|0}function OY(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=125704;while(1){if(d<<24>>24==e<<24>>24){if((y_(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function PY(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function QY(a){a=a|0;var b=0,c=0;b=i;if((UY(a)|0)==0){c=(SY(a)|0)!=0|0}else{c=0}i=b;return c|0}function RY(a){a=a|0;var b=0,c=0;b=i;if((XY(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function SY(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function TY(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[125784+((d[125784+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function UY(a){a=a|0;var b=0,c=0;b=i;c=(zZ(128952,a)|0)!=0|0;i=b;return c|0}function VY(a){a=a|0;var b=0,c=0;b=i;c=(ZY(a)|0)!=(a|0)|0;i=b;return c|0}function WY(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function XY(a){a=a|0;var b=0,c=0;b=i;c=YY(a,0)|0;i=b;return c|0}function YY(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((KY(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[129042+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[129040+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[129043+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[129288+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[129288+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[129288+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function ZY(a){a=a|0;var b=0,c=0;b=i;c=YY(a,1)|0;i=b;return c|0}function _Y(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=$Y(0,a,b,(c|0)!=0?c:129992)|0;i=d;return e|0}function $Y(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?13e4:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[129784+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function aZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=bZ(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=$Y(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function bZ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[129784+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[129784+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function cZ(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[129784+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function dZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function eZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=fZ(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=dZ(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function fZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=dZ(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=dZ(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=dZ(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}dZ(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function gZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=_Z(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=_Z(2048)|0;c[p+16>>2]=s;if((s|0)==0){$Z(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=wZ(0,0)|0;if((s|0)==0){$Z(c[p+16>>2]|0);$Z(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=hZ(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=a_(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=iZ(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=_Z(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;G_(y|0,-1,v|0)|0;I=H}else{I=0}H=a_(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=a_(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=iZ(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=oZ(q,x)|0;b:do{if((v|0)==0){y=oZ(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=pZ(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=yZ(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=yZ(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=pZ(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=yZ(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=yZ(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=pZ(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=yZ(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=yZ(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=yZ(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=yZ(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=yZ(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=yZ(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=yZ(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=yZ(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==1){U=c[S+4>>2]|0;W=oZ(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=oZ(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=oZ(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=oZ(q,0)|0}else if((T|0)==3){W=c[S+4>>2]|0;U=oZ(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=oZ(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=oZ(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=oZ(q,0)|0}else if((T|0)==0){U=c[S+4>>2]|0;W=c[U>>2]|0;if(!((W|0)>-1|(W|0)==-4)){ra=L;sa=M;ta=N;break}W=U+8|0;U=(c[W>>2]|0)+L|0;c[W>>2]=U;if((U|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=U;ra=L;sa=M;ta=N;break}else if((T|0)==2){T=c[S+4>>2]|0;U=oZ(q,L)|0;if((U|0)!=0){ua=N;va=U;break c}U=oZ(q,S)|0;if((U|0)!=0){ua=N;va=U;break c}U=oZ(q,1)|0;if((U|0)!=0){ua=N;va=U;break c}U=oZ(q,c[T>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=oZ(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=yZ(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=yZ(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=yZ(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=yZ(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=oZ(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=oZ(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;R=c[L>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;Q=L+8|0;T=c[Q>>2]|0;U=yZ(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}W=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=W;W=c[Q>>2]|0;Q=c[L+4>>2]|0;U=yZ(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=W;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=Q;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((R|0)<0){c[U>>2]=1;Q=yZ(s,0,0,1,32)|0;if((Q|0)==0){F=110;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+24>>2]=Q;Q=yZ(s,0,0,1,32)|0;if((Q|0)==0){F=112;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+28>>2]=Q;break}else{c[U>>2]=0;U=L+8|0;Q=c[U>>2]|0;W=L+4|0;T=c[W>>2]|0;ea=yZ(s,0,0,1,64)|0;if((ea|0)==0){F=115;break g}fa=ea;c[ea>>2]=Q;c[ea+4>>2]=R;c[ea+8>>2]=T;c[ea+20>>2]=0;c[ea+24>>2]=0;T=ea+28|0;ea=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ea>>2]=fa;fa=c[U>>2]|0;U=c[L>>2]|0;ea=c[W>>2]|0;W=c[L+12>>2]|0;T=c[L+16>>2]|0;L=yZ(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}R=L;c[L>>2]=fa;c[L+4>>2]=U;c[L+8>>2]=ea;c[L+20>>2]=W;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=R;break}}else if((M|0)==1){R=oZ(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=oZ(q,2)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;L=oZ(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=oZ(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=oZ(q,c[c[R>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=oZ(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==3){L=oZ(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=oZ(q,1)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=oZ(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=oZ(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=oZ(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=oZ(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==2){M=oZ(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=oZ(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=oZ(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=oZ(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==1){M=c[ya+4>>2]|0;R=c[M>>2]|0;L=M+4|0;T=c[L>>2]|0;if((c[R+8>>2]|0)==0){za=(c[T+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;W=mZ(s,c[R+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}W=mZ(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){W=c[ya+4>>2]|0;L=c[W>>2]|0;do{if((c[W+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[W>>2]|0)+28>>2]}else if((S|0)==2){M=c[ya+4>>2]|0;T=c[M>>2]|0;R=T+8|0;if((c[R>>2]|0)==0){Aa=0}else{Aa=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[R>>2]|0)==0){c[ya+24>>2]=c[T+24>>2];Ba=M+4|0}else{R=nZ(q,T,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ca=_Z((c[g>>2]<<2)+4|0)|0;R=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=nZ(q,c[M>>2]|0,R,h,0)|0;if((Da|0)!=0){F=150;break g}T=M+4|0;ea=mZ(s,c[(c[T>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,R,c[h>>2]|0)|0;R=ya+24|0;c[R>>2]=ea;$Z(Ca);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=T}}T=c[Ba>>2]|0;if((c[T+8>>2]|0)==0){c[ya+28>>2]=c[T+28>>2];break}R=nZ(q,T,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ea=_Z((c[g>>2]<<2)+4|0)|0;R=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=nZ(q,c[Ba>>2]|0,R,h,0)|0;if((Fa|0)!=0){F=157;break g}T=mZ(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,R,c[h>>2]|0)|0;R=ya+28|0;c[R>>2]=T;$Z(Ea);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){$Z(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){$Z(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=_Z(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=_Z(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){G_(O|0,0,((E|0)>1?E<<2:4)|0)|0}jZ(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;R=O+(S<<2)|0;T=K+1+(c[R>>2]|0)|0;c[R>>2]=0;R=S+1|0;if((R|0)<(E|0)){S=R;K=T}else{Ga=T;break}}}else{Ga=0}K=a_(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;T=jZ(y,S,x,u)|0;if((T|0)!=0){z=x;A=T;B=u;C=D;break}c[w+20>>2]=0;T=v+24|0;S=c[T>>2]|0;if((c[S>>2]|0)>-1){R=1;M=S;while(1){S=M+32|0;ea=R+1|0;if((c[S>>2]|0)>-1){M=S;R=ea}else{Ha=ea;break}}}else{Ha=1}R=a_(Ha,32)|0;if((R|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=R;M=c[T>>2]|0;y=c[M>>2]|0;if((y|0)>-1){ea=y;y=M;M=0;while(1){c[R+(M<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[R+(M<<5)+12>>2]=ea;S=R+(M<<5)+16|0;c[S>>2]=0;U=y+12|0;fa=c[U>>2]|0;if((fa|0)!=0){Q=0;while(1){Ia=Q+1|0;if((c[fa+(Q<<2)>>2]|0)>-1){Q=Ia}else{break}}Q=Ia<<2;fa=_Z(Q)|0;c[S>>2]=fa;if((fa|0)==0){z=x;A=12;B=u;C=D;break a}E_(fa|0,c[U>>2]|0,Q|0)|0}c[R+(M<<5)+20>>2]=c[y+16>>2];Q=M+1|0;fa=y+32|0;da=c[fa>>2]|0;if((da|0)>-1){ea=da;y=fa;M=Q}else{Ja=Q;break}}}else{Ja=0}c[R+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;xZ(s);$Z(c[p+16>>2]|0);$Z(p);$Z(O);$Z(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);xZ(s);$Z(c[p+16>>2]|0);$Z(p);if((z|0)!=0){$Z(z)}if((B|0)!=0){$Z(B)}c[b+4>>2]=C;kZ(b);r=A;i=f;return r|0}function hZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;oZ(m,c[p>>2]|0)|0;oZ(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=oZ(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=oZ(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=oZ(m,3)|0;break};case 9:{Q=c[q>>2]|0;X=a[Q]|0;switch(X<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 123:{Y=c[v>>2]|0;if((Y&1|0)==0){U=M;V=N;W=0;break c}else{Z=Y;_=Q}break};case 92:{Y=c[v>>2]|0;if((Y&1|0)!=0){U=M;V=N;W=0;break c}$=Q+1|0;if((a[$]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=$;Z=Y;_=$;break};case 42:{T=41;break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Q+1;Q=c[w>>2]|0;$=yZ(Q,0,0,1,32)|0;if(($|0)==0){aa=12;T=294;break b}Y=yZ(Q,0,0,1,16)|0;c[$+4>>2]=Y;if((Y|0)==0){aa=12;T=294;break b}c[$>>2]=2;c[$+8>>2]=-1;c[$+12>>2]=-1;c[Y>>2]=N;c[Y+4>>2]=X<<24>>24==43;c[Y+8>>2]=X<<24>>24==63?1:-1;X=Y+12|0;a[X]=a[X]&-2;c[$+16>>2]=c[N+16>>2];U=M;V=$;W=oZ(m,9)|0;break c}$=_+1|0;c[q>>2]=$;X=a[$]|0;if((X+ -48<<24>>24&255)<10){Y=X<<24>>24;if((Y+ -48|0)>>>0<10){ba=Y;ca=-1;da=$}else{aa=10;T=294;break b}while(1){Y=((ca|0)<0?-48:(ca*10|0)+ -48|0)+ba|0;Q=da+1|0;ea=a[Q]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){da=Q;ca=Y;ba=fa}else{ga=ea;ha=Y;ia=Q;break}}}else{ga=X;ha=-1;ia=$}do{if(ga<<24>>24==44){Q=ia+1|0;Y=a[Q]|0;ea=Y<<24>>24;if((ea+ -48|0)>>>0<10){ja=ea;ka=-1;la=Q}else{ma=Y;na=-1;oa=Q;break}while(1){Q=((ka|0)<0?-48:(ka*10|0)+ -48|0)+ja|0;Y=la+1|0;ea=a[Y]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){la=Y;ka=Q;ja=fa}else{pa=ea;qa=Q;ra=Y;T=54;break}}}else{pa=ga;qa=ha;ra=ia;T=54}}while(0);do{if((T|0)==54){T=0;if(!((qa|0)>-1)){ma=pa;na=qa;oa=ra;break}if((ha|0)>(qa|0)|(qa|0)>255){aa=10;T=294;break b}else{ma=pa;na=qa;oa=ra}}}while(0);if(ma<<24>>24==0){aa=9;T=294;break b}if((oa|0)==($|0)){aa=10;T=294;break b}if((Z&1|0)==0){if(!(ma<<24>>24==92)){aa=10;T=294;break b}if((a[oa+1|0]|0)!=125){aa=10;T=294;break b}sa=oa+2|0}else{if(!(ma<<24>>24==125)){aa=10;T=294;break b}sa=oa+1|0}if((na|ha|0)==0){X=c[w>>2]|0;Y=yZ(X,0,0,1,32)|0;if((Y|0)==0){aa=12;T=294;break b}Q=yZ(X,0,0,1,20)|0;c[Y+4>>2]=Q;if((Q|0)==0){aa=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;ta=Y}else{Y=(na&ha|0)<0;Q=c[w>>2]|0;X=yZ(Q,0,0,1,32)|0;if((X|0)==0){aa=12;T=294;break b}ea=yZ(Q,0,0,1,16)|0;c[X+4>>2]=ea;if((ea|0)==0){aa=12;T=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ea>>2]=N;c[ea+4>>2]=Y?1:ha;c[ea+8>>2]=Y?1:na;Y=ea+12|0;a[Y]=a[Y]&-2;c[X+16>>2]=c[N+16>>2];ta=X}c[q>>2]=sa;U=M;V=ta;W=oZ(m,9)|0;break};case 1:{X=c[q>>2]|0;d:do{switch(a[X]|0){case 91:{Y=X+1|0;c[q>>2]=Y;ea=_Z(128)|0;if((ea|0)==0){aa=12;T=294;break b}if((a[Y]|0)==94){Q=X+2|0;c[q>>2]=Q;ua=Q;va=1}else{ua=Y;va=0}Y=(va|0)==0;Q=ea;ea=0;fa=0;wa=32;xa=ua;e:while(1){ya=a[xa]|0;if(ya<<24>>24==93){if(xa>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(ya<<24>>24==0){za=Q;Aa=xa;Ba=7;T=140;break}ya=cZ(e,xa,-1)|0;if((ya|0)<0){c[e>>2]=-1;Ca=1}else{Ca=ya}ya=xa+Ca|0;do{if((a[ya]|0)==45){Da=Ca+1|0;Ea=xa+Da|0;if((a[Ea]|0)==93){T=94;break}Fa=c[e>>2]|0;Ga=cZ(e,Ea,-1)|0;if((Ga|0)<0){c[e>>2]=-1;Ha=-1;Ia=1}else{Ha=c[e>>2]|0;Ia=Ga}Ja=0;Ka=Ha;La=Fa;Ma=xa+(Ia+Da)|0;Na=Fa>>>0>Ha>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;Fa=a[xa]|0;do{if(Fa<<24>>24==91){Da=a[xa+1|0]|0;if(Da<<24>>24==61|Da<<24>>24==46){za=Q;Aa=xa;Ba=3;T=140;break e}else if(!(Da<<24>>24==58)){Oa=0;break}Da=xa+2|0;Ga=Da;while(1){Ea=a[Ga]|0;Pa=Ea<<24>>24==0;if(Ea<<24>>24!=58&(Pa^1)){Ga=Ga+1|0}else{break}}if(Pa){za=Q;Aa=xa;Ba=4;T=140;break e}Ea=Ga-xa+ -2|0;Qa=(Ea|0)>63?63:Ea;N_(A|0,Da|0,Qa|0)|0;a[f+Qa|0]=0;Qa=OY(A)|0;Ja=Qa;Ka=1114111;La=0;Ma=Ga+2|0;Na=(Qa|0)==0?4:0;break f}else if(Fa<<24>>24==45){if((a[xa+1|0]|0)==93){Oa=0;break}Oa=(c[q>>2]|0)==(xa|0)?0:11}else{Oa=0}}while(0);Fa=c[e>>2]|0;Ja=0;Ka=Fa;La=Fa;Ma=ya;Na=Oa}}while(0);if((Na|0)!=0){za=Q;Aa=Ma;Ba=Na;T=140;break}ya=(Ja|0)!=0;do{if(Y|ya^1){Fa=c[w>>2]|0;if((fa|0)<(wa|0)){Ra=Q;Sa=wa}else{if((wa|0)>1024){za=Q;Aa=Ma;Ba=12;T=140;break e}Qa=b_(Q,wa<<3)|0;if((Qa|0)==0){za=Q;Aa=Ma;Ba=12;T=140;break e}else{Ra=Qa;Sa=wa<<1}}Qa=yZ(Fa,0,0,1,32)|0;if((Qa|0)==0){T=112;break e}Ea=yZ(Fa,0,0,1,20)|0;Fa=Qa+4|0;c[Fa>>2]=Ea;if((Ea|0)==0){T=112;break e}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[Ea>>2]=La;c[Ea+4>>2]=Ka;c[Ea+8>>2]=-1;c[Ra+(fa<<2)>>2]=Qa;c[(c[Fa>>2]|0)+12>>2]=Ja;Ta=Ra;Ua=ea;Va=fa+1|0;Wa=Sa;Xa=0}else{if((ea|0)>63){Ta=Q;Ua=ea;Va=fa;Wa=wa;Xa=12;break}c[g+(ea<<2)>>2]=Ja;Ta=Q;Ua=ea+1|0;Va=fa;Wa=wa;Xa=0}}while(0);Fa=(Xa|0)==0;if(Fa&(((c[v>>2]&2|0)==0|ya)^1)){Ya=Ta;Za=Va;_a=Wa;$a=La}else{if(Fa){Q=Ta;ea=Ua;fa=Va;wa=Wa;xa=Ma;continue}else{za=Ta;Aa=Ma;Ba=Xa;T=140;break}}while(1){Fa=$a;while(1){if(Fa>>>0>Ka>>>0){Q=Ya;ea=Ua;fa=Za;wa=_a;xa=Ma;continue e}if((RY(Fa)|0)!=0){T=118;break}ab=Fa+1|0;if((VY(Fa)|0)==0){Fa=ab}else{T=129;break}}if((T|0)==118){T=0;Qa=XY(Fa)|0;Ea=Fa+1|0;g:do{if((RY(Ea)|0)==0){bb=Qa;cb=Ea}else{db=Qa;eb=Ea;while(1){if((XY(eb)|0)!=(db+1|0)|eb>>>0>Ka>>>0){bb=db;cb=eb;break g}fb=XY(eb)|0;gb=eb+1|0;if((RY(gb)|0)==0){bb=fb;cb=gb;break}else{db=fb;eb=gb}}}}while(0);Ea=c[w>>2]|0;if((Za|0)<(_a|0)){hb=Ya;ib=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;T=140;break e}eb=b_(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;T=140;break e}else{hb=eb;ib=_a<<1}}eb=yZ(Ea,0,0,1,32)|0;db=eb;do{if((eb|0)==0){jb=0}else{Ga=yZ(Ea,0,0,1,20)|0;c[eb+4>>2]=Ga;if((Ga|0)==0){jb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ga>>2]=Qa;c[Ga+4>>2]=bb;c[Ga+8>>2]=-1;jb=db}}while(0);c[hb+(Za<<2)>>2]=jb;kb=jb;lb=hb;mb=ib;nb=cb}else if((T|0)==129){T=0;db=ZY(Fa)|0;h:do{if((VY(ab)|0)==0){ob=db;pb=ab}else{Qa=db;eb=ab;while(1){if((ZY(eb)|0)!=(Qa+1|0)|eb>>>0>Ka>>>0){ob=Qa;pb=eb;break h}Ea=eb+1|0;Ga=ZY(eb)|0;if((VY(Ea)|0)==0){ob=Ga;pb=Ea;break}else{Qa=Ga;eb=Ea}}}}while(0);Fa=c[w>>2]|0;if((Za|0)<(_a|0)){qb=Ya;rb=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;T=140;break e}eb=b_(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;T=140;break e}else{qb=eb;rb=_a<<1}}eb=yZ(Fa,0,0,1,32)|0;Qa=eb;do{if((eb|0)==0){sb=0}else{Ea=yZ(Fa,0,0,1,20)|0;c[eb+4>>2]=Ea;if((Ea|0)==0){sb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ea>>2]=db;c[Ea+4>>2]=ob;c[Ea+8>>2]=-1;sb=Qa}}while(0);c[qb+(Za<<2)>>2]=sb;kb=sb;lb=qb;mb=rb;nb=pb}if((kb|0)==0){T=141;break e}else{Ya=lb;Za=Za+1|0;_a=mb;$a=nb}}}i:do{if((T|0)==85){T=0;c[q>>2]=xa+1;wa=(va|0)!=0;if(wa){dc(Q|0,fa|0,4,59)}j:do{if((fa|0)>0){Y=(ea|0)>0;ya=ea<<2;Qa=ya+4|0;if(wa){tb=0;ub=0;vb=0;wb=0}else{db=0;eb=0;while(1){Fa=Q+(db<<2)|0;Ea=c[(c[Fa>>2]|0)+4>>2]|0;do{if((Ea|0)==0){xb=eb;yb=0}else{c[Ea+8>>2]=c[x>>2];if(Y){Ga=yZ(c[w>>2]|0,0,0,0,Qa)|0;Da=Ea+16|0;c[Da>>2]=Ga;if((Ga|0)==0){zb=Q;Ab=eb;Bb=12;break i}E_(Ga|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(ea<<2)>>2]=0}else{c[Ea+16>>2]=0}if((eb|0)==0){xb=c[Fa>>2]|0;yb=0;break}Da=c[w>>2]|0;Ga=c[Fa>>2]|0;gb=yZ(Da,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){Cb=0}else{Db=yZ(Da,0,0,1,8)|0;Eb=gb+4|0;c[Eb>>2]=Db;if((Db|0)==0){Cb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[Db>>2]=eb;c[(c[Eb>>2]|0)+4>>2]=Ga;c[gb+16>>2]=(c[Ga+16>>2]|0)+(c[eb+16>>2]|0);Cb=fb}}while(0);xb=Cb;yb=(Cb|0)==0?12:0}}while(0);Fa=db+1|0;if((Fa|0)<(fa|0)&(yb|0)==0){db=Fa;eb=xb}else{Fb=0;Gb=xb;Hb=yb;break j}}}while(1){eb=Q+(vb<<2)|0;db=c[(c[eb>>2]|0)+4>>2]|0;Fa=c[db>>2]|0;Ea=db+4|0;fb=c[Ea>>2]|0;do{if((Fa|0)<(tb|0)){Ga=fb+1|0;Ib=(Ga|0)<(tb|0)?tb:Ga;Jb=ub;Kb=wb;Lb=0}else{if((Fa|0)<=(ub|0)){Ga=fb+1|0;Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db>>2]=ub;c[Ea>>2]=Fa+ -1;Ga=fb+1|0;if((db|0)==0){Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db+8>>2]=c[x>>2];if(Y){gb=yZ(c[w>>2]|0,0,0,0,Qa)|0;Da=db+16|0;c[Da>>2]=gb;if((gb|0)==0){zb=Q;Ab=wb;Bb=12;break i}E_(gb|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(ea<<2)>>2]=0}else{c[db+16>>2]=0}if((wb|0)==0){Ib=Ga;Jb=Ga;Kb=c[eb>>2]|0;Lb=0;break}Da=c[w>>2]|0;gb=c[eb>>2]|0;Eb=yZ(Da,0,0,1,32)|0;Db=Eb;do{if((Eb|0)==0){Mb=0}else{Nb=yZ(Da,0,0,1,8)|0;Ob=Eb+4|0;c[Ob>>2]=Nb;if((Nb|0)==0){Mb=0;break}c[Eb>>2]=3;c[Eb+8>>2]=-1;c[Eb+12>>2]=-1;c[Nb>>2]=wb;c[(c[Ob>>2]|0)+4>>2]=gb;c[Eb+16>>2]=(c[gb+16>>2]|0)+(c[wb+16>>2]|0);Mb=Db}}while(0);Ib=Ga;Jb=Ga;Kb=Mb;Lb=(Mb|0)==0?12:0}}while(0);eb=vb+1|0;if((eb|0)<(fa|0)&(Lb|0)==0){tb=Ib;ub=Jb;vb=eb;wb=Kb}else{Fb=Jb;Gb=Kb;Hb=Lb;break}}}else{Fb=0;Gb=0;Hb=0}}while(0);if((Hb|0)!=0|wa^1){zb=Q;Ab=Gb;Bb=Hb;break}ya=c[w>>2]|0;Qa=c[x>>2]|0;Y=yZ(ya,0,0,1,32)|0;eb=Y;if((Y|0)==0){zb=Q;Ab=Gb;Bb=12;break}db=yZ(ya,0,0,1,20)|0;c[Y+4>>2]=db;if((db|0)==0){zb=Q;Ab=Gb;Bb=12;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[db>>2]=Fb;c[db+4>>2]=1114111;c[db+8>>2]=Qa;if((ea|0)>0){Qa=ea<<2;ya=yZ(c[w>>2]|0,0,0,0,Qa+4|0)|0;fb=db+16|0;c[fb>>2]=ya;if((ya|0)==0){zb=Q;Ab=Gb;Bb=12;break}E_(ya|0,z|0,Qa|0)|0;c[(c[fb>>2]|0)+(ea<<2)>>2]=0}else{c[db+16>>2]=0}if((Gb|0)==0){zb=Q;Ab=eb;Bb=0;break}db=c[w>>2]|0;fb=yZ(db,0,0,1,32)|0;Qa=fb;do{if((fb|0)==0){Pb=0}else{ya=yZ(db,0,0,1,8)|0;Fa=fb+4|0;c[Fa>>2]=ya;if((ya|0)==0){Pb=0;break}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ya>>2]=Gb;c[(c[Fa>>2]|0)+4>>2]=eb;c[fb+16>>2]=(c[Y+16>>2]|0)+(c[Gb+16>>2]|0);Pb=Qa}}while(0);zb=Q;Ab=Pb;Bb=(Pb|0)==0?12:0}else if((T|0)==112){T=0;c[Ra+(fa<<2)>>2]=0;za=Ra;Aa=Ma;Ba=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Ma;zb=lb;Ab=0;Bb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Aa;zb=za;Ab=0;Bb=Ba}$Z(zb);c[x>>2]=(c[x>>2]|0)+1;if((Bb|0)==0){U=M;V=Ab;W=0;break c}else{aa=Bb;T=294;break b}break};case 92:{fa=X+1|0;Q=a[fa]|0;do{if((c[v>>2]&1|0)==0){if(Q<<24>>24==40){c[q>>2]=fa;Qb=fa;T=74;break d}else{ea=a[X+1|0]|0;if(ea<<24>>24==41){T=265;break d}else{Rb=ea;break}}}else{Rb=Q}}while(0);Q=X+1|0;fa=Rb<<24>>24==0;if(fa){aa=5;T=294;break b}else{Sb=130012|0;Tb=0}while(1){ea=Tb+1|0;if((a[130008+(Tb<<3)|0]|0)==Rb<<24>>24){Ub=Sb;break}xa=130012+(ea<<3)|0;if((ea|0)==12){Ub=xa;break}else{Sb=xa;Tb=ea}}ea=c[Ub>>2]|0;if((ea|0)!=0){xa=F+0|0;Qa=G+0|0;Y=xa+40|0;do{c[xa>>2]=c[Qa>>2];xa=xa+4|0;Qa=Qa+4|0}while((xa|0)<(Y|0));c[H>>2]=ea;c[I>>2]=1;Qa=hZ(j)|0;if((Qa|0)!=0){aa=Qa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(fa){aa=5;T=294;break b}c[q>>2]=Q;Qa=a[Q]|0;k:do{switch(Qa|0){case 60:{xa=c[w>>2]|0;Y=yZ(xa,0,0,1,32)|0;fb=Y;do{if((Y|0)==0){Wb=0}else{eb=yZ(xa,0,0,1,20)|0;c[Y+4>>2]=eb;if((eb|0)==0){Wb=0;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[eb>>2]=-2;c[eb+4>>2]=16;c[eb+8>>2]=-1;Wb=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=Wb;break};case 98:{fb=c[w>>2]|0;Y=yZ(fb,0,0,1,32)|0;xa=Y;do{if((Y|0)==0){Yb=0}else{eb=yZ(fb,0,0,1,20)|0;c[Y+4>>2]=eb;if((eb|0)==0){Yb=0;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[eb>>2]=-2;c[eb+4>>2]=64;c[eb+8>>2]=-1;Yb=xa}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=Yb;break};case 120:{xa=X+2|0;c[q>>2]=xa;Y=a[xa]|0;if(Y<<24>>24==123){xa=X+3|0;c[q>>2]=xa;fb=xa;xa=0;while(1){eb=a[fb]|0;if(eb<<24>>24==0|eb<<24>>24==125){Zb=xa;_b=fb;break}if((WY(eb<<24>>24)|0)==0){aa=9;T=294;break b}eb=c[q>>2]|0;a[l+xa|0]=a[eb]|0;db=xa+1|0;wa=eb+1|0;c[q>>2]=wa;if(db>>>0>31){Zb=db;_b=wa;break}else{fb=wa;xa=db}}c[q>>2]=_b+1;a[l+Zb|0]=0;xa=Vb(C|0,0,16)|0;fb=c[w>>2]|0;db=c[x>>2]|0;wa=yZ(fb,0,0,1,32)|0;eb=wa;do{if((wa|0)==0){$b=0}else{Fa=yZ(fb,0,0,1,20)|0;c[wa+4>>2]=Fa;if((Fa|0)==0){$b=0;break}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Fa>>2]=xa;c[Fa+4>>2]=xa;c[Fa+8>>2]=db;$b=eb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Xb=$b;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;eb=(WY(Y<<24>>24)|0)==0;db=c[q>>2]|0;if(eb){ac=db}else{a[D]=a[db]|0;eb=db+1|0;c[q>>2]=eb;ac=eb}if((WY(a[ac]|0)|0)!=0){eb=c[q>>2]|0;a[E]=a[eb]|0;c[q>>2]=eb+1}eb=Vb(D|0,0,16)|0;db=c[w>>2]|0;xa=c[x>>2]|0;wa=yZ(db,0,0,1,32)|0;fb=wa;do{if((wa|0)==0){bc=0}else{Fa=yZ(db,0,0,1,20)|0;c[wa+4>>2]=Fa;if((Fa|0)==0){bc=0;break}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=eb;c[Fa+8>>2]=xa;bc=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Xb=bc;break k}break};case 62:{fb=c[w>>2]|0;xa=yZ(fb,0,0,1,32)|0;eb=xa;do{if((xa|0)==0){cc=0}else{wa=yZ(fb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){cc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=32;c[wa+8>>2]=-1;cc=eb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=cc;break};case 66:{eb=c[w>>2]|0;xa=yZ(eb,0,0,1,32)|0;fb=xa;do{if((xa|0)==0){ec=0}else{wa=yZ(eb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){ec=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=128;c[wa+8>>2]=-1;ec=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=ec;break};default:{if((PY(Qa)|0)!=0){fb=(a[c[q>>2]|0]|0)+ -48|0;xa=c[w>>2]|0;eb=c[x>>2]|0;wa=yZ(xa,0,0,1,32)|0;if((wa|0)==0){aa=12;T=294;break b}db=yZ(xa,0,0,1,20)|0;c[wa+4>>2]=db;if((db|0)==0){aa=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[db>>2]=-4;c[db+4>>2]=fb;c[db+8>>2]=eb;c[x>>2]=(c[x>>2]|0)+1;eb=c[B>>2]|0;c[B>>2]=(fb|0)<(eb|0)?eb:fb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=wa;W=0;break c}wa=c[w>>2]|0;fb=a[c[q>>2]|0]|0;eb=c[x>>2]|0;db=yZ(wa,0,0,1,32)|0;xa=db;do{if((db|0)==0){fc=0}else{Y=yZ(wa,0,0,1,20)|0;c[db+4>>2]=Y;if((Y|0)==0){fc=0;break}c[db>>2]=0;c[db+8>>2]=-1;c[db+12>>2]=-1;c[Y>>2]=fb;c[Y+4>>2]=fb;c[Y+8>>2]=eb;fc=xa}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Xb=fc}}}while(0);if((Xb|0)==0){aa=12;T=294;break b}else{U=M;V=Xb;W=0;break c}break};case 46:{Qa=(c[v>>2]&4|0)==0;Q=c[w>>2]|0;fa=c[x>>2]|0;ea=yZ(Q,0,0,1,32)|0;xa=ea;eb=(ea|0)==0;if(Qa){if(eb){aa=12;T=294;break b}Qa=yZ(Q,0,0,1,20)|0;c[ea+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Qa>>2]=0;c[Qa+4>>2]=1114111;c[Qa+8>>2]=fa;gc=xa;hc=(c[x>>2]|0)+1|0}else{if(eb){aa=12;T=294;break b}eb=yZ(Q,0,0,1,20)|0;c[ea+4>>2]=eb;if((eb|0)==0){aa=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[eb>>2]=0;c[eb+4>>2]=9;c[eb+8>>2]=fa;fa=c[w>>2]|0;eb=(c[x>>2]|0)+1|0;Q=yZ(fa,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=yZ(fa,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=11;c[Qa+4>>2]=1114111;c[Qa+8>>2]=eb;eb=c[w>>2]|0;Qa=yZ(eb,0,0,1,32)|0;if((Qa|0)==0){aa=12;T=294;break b}fa=yZ(eb,0,0,1,8)|0;eb=Qa+4|0;c[eb>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Qa>>2]=3;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[fa>>2]=xa;c[(c[eb>>2]|0)+4>>2]=Q;c[Qa+16>>2]=(c[Q+16>>2]|0)+(c[ea+16>>2]|0);gc=Qa;hc=(c[x>>2]|0)+2|0}c[x>>2]=hc;c[q>>2]=(c[q>>2]|0)+1;U=M;V=gc;W=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){Qb=X;T=74}break};case 94:{if((c[v>>2]&1|0)==0){if((X|0)!=(c[r>>2]|0)){break d}Qa=oZ(m,5)|0;if((Qa|0)!=0){R=M;S=Qa;T=6;break b}}Qa=c[w>>2]|0;ea=yZ(Qa,0,0,1,32)|0;if((ea|0)==0){aa=12;T=294;break b}Q=yZ(Qa,0,0,1,20)|0;c[ea+4>>2]=Q;if((Q|0)==0){aa=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=1;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ea;W=0;break c;break};case 41:{if((M|0)!=0){T=264}break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 36:{if((c[v>>2]&1|0)==0){if((a[X+1|0]|0)!=0){break d}}ea=c[w>>2]|0;Q=yZ(ea,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=yZ(ea,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=-2;c[Qa+4>>2]=2;c[Qa+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Q;W=0;break c;break};default:{}}}while(0);if((T|0)==74){T=0;$=M+1|0;c[q>>2]=Qb+1;Q=oZ(m,c[y>>2]|0)|0;if((Q|0)!=0){R=$;S=Q;T=6;break b}Q=oZ(m,2)|0;if((Q|0)!=0){R=$;S=Q;T=6;break b}Q=oZ(m,0)|0;if((Q|0)!=0){R=$;S=Q;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=$;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;$=c[w>>2]|0;Q=yZ($,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=yZ($,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=-1;c[Qa+4>>2]=-1;c[Qa+8>>2]=-1;U=M;V=Q;W=0;break c}Q=cZ(h,X,-1)|0;if((Q|0)<0){c[h>>2]=-1;ic=1}else{ic=Q}do{if((c[v>>2]&2|0)==0){T=280}else{if((VY(c[h>>2]|0)|0)==0){if((RY(c[h>>2]|0)|0)==0){T=280;break}}Q=c[w>>2]|0;Qa=XY(c[h>>2]|0)|0;$=XY(c[h>>2]|0)|0;ea=c[x>>2]|0;eb=yZ(Q,0,0,1,32)|0;if((eb|0)==0){aa=12;T=294;break b}xa=yZ(Q,0,0,1,20)|0;c[eb+4>>2]=xa;if((xa|0)==0){aa=12;T=294;break b}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[xa>>2]=Qa;c[xa+4>>2]=$;c[xa+8>>2]=ea;ea=c[w>>2]|0;xa=ZY(c[h>>2]|0)|0;$=ZY(c[h>>2]|0)|0;Qa=c[x>>2]|0;Q=yZ(ea,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}fa=yZ(ea,0,0,1,20)|0;c[Q+4>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fa>>2]=xa;c[fa+4>>2]=$;c[fa+8>>2]=Qa;Qa=c[w>>2]|0;fa=yZ(Qa,0,0,1,32)|0;if((fa|0)==0){aa=12;T=294;break b}$=yZ(Qa,0,0,1,8)|0;Qa=fa+4|0;c[Qa>>2]=$;if(($|0)==0){aa=12;T=294;break b}c[fa>>2]=3;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[$>>2]=eb;c[(c[Qa>>2]|0)+4>>2]=Q;c[fa+16>>2]=(c[Q+16>>2]|0)+(c[eb+16>>2]|0);jc=fa}}while(0);if((T|0)==280){T=0;X=c[w>>2]|0;fa=c[h>>2]|0;eb=c[x>>2]|0;Q=yZ(X,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=yZ(X,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=fa;c[Qa+4>>2]=fa;c[Qa+8>>2]=eb;jc=Q}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+ic;U=M;V=jc;W=0;break};case 7:{Q=c[q>>2]|0;eb=a[Q]|0;if((eb|0)==41){c[q>>2]=Q+1;U=M;V=N;W=0;break c}else if((eb|0)!=124){U=M;V=N;W=0;break c}eb=oZ(m,7)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}eb=oZ(m,N)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}eb=oZ(m,8)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}eb=oZ(m,3)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 3:{eb=oZ(m,5)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}U=M;V=N;W=oZ(m,4)|0;break};case 8:{eb=L+ -2|0;c[n>>2]=eb;Q=c[P+(eb<<2)>>2]|0;eb=c[w>>2]|0;Qa=yZ(eb,0,0,1,32)|0;if((Qa|0)==0){aa=12;T=294;break b}fa=yZ(eb,0,0,1,8)|0;eb=Qa+4|0;c[eb>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Qa>>2]=3;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[fa>>2]=Q;c[(c[eb>>2]|0)+4>>2]=N;c[Qa+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=Qa;W=0;break};case 6:{Qa=L+ -2|0;c[n>>2]=Qa;Q=c[P+(Qa<<2)>>2]|0;Qa=c[w>>2]|0;eb=yZ(Qa,0,0,1,32)|0;if((eb|0)==0){aa=12;T=294;break b}fa=yZ(Qa,0,0,1,8)|0;Qa=eb+4|0;c[Qa>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[eb>>2]=1;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[fa>>2]=Q;c[(c[Qa>>2]|0)+4>>2]=N;c[eb+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=eb;W=0;break};case 2:{eb=L+ -2|0;c[n>>2]=eb;Q=c[P+(eb<<2)>>2]|0;if((c[N+12>>2]|0)>-1){eb=c[w>>2]|0;Qa=yZ(eb,0,0,1,32)|0;if((Qa|0)==0){aa=12;T=294;break b}fa=yZ(eb,0,0,1,20)|0;c[Qa+4>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[fa>>2]=-1;c[fa+4>>2]=-1;c[fa+8>>2]=-1;fa=c[w>>2]|0;eb=yZ(fa,0,0,1,32)|0;if((eb|0)==0){aa=12;T=294;break b}X=yZ(fa,0,0,1,8)|0;fa=eb+4|0;c[fa>>2]=X;if((X|0)==0){aa=12;T=294;break b}c[eb>>2]=1;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[X>>2]=Qa;c[(c[fa>>2]|0)+4>>2]=N;fa=N+16|0;X=eb+16|0;c[X>>2]=(c[fa>>2]|0)+(c[Qa+16>>2]|0);c[X>>2]=c[fa>>2];kc=eb}else{kc=N}c[kc+12>>2]=Q;Q=kc+16|0;c[Q>>2]=(c[Q>>2]|0)+1;U=M;V=kc;W=0;break};case 10:{Q=L+ -2|0;c[n>>2]=Q;c[v>>2]=c[P+(Q<<2)>>2];U=M;V=N;W=0;break};case 5:{Q=c[q>>2]|0;eb=a[Q]|0;if(eb<<24>>24==0){U=M;V=N;W=0;break c}fa=c[v>>2]&1;X=(fa|0)!=0;if(X&eb<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(X&eb<<24>>24==41&(M|0)>0)){if((fa|0)==0&eb<<24>>24==92){if((a[Q+1|0]|0)==41){break}}Qa=oZ(m,5)|0;if((Qa|0)!=0){R=M;S=Qa;T=6;break b}Qa=oZ(m,N)|0;if((Qa|0)!=0){R=M;S=Qa;T=6;break b}Qa=oZ(m,6)|0;if((Qa|0)!=0){R=M;S=Qa;T=6;break b}U=M;V=N;W=oZ(m,4)|0;break c}}while(0);eb=(fa|M|0)==0?8:0;X=M+ -1|0;if((fa|0)!=0){U=X;V=N;W=eb;break c}c[q>>2]=Q+2;U=X;V=N;W=eb;break};case 4:{eb=oZ(m,9)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}U=M;V=N;W=oZ(m,1)|0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{lc=O;mc=U;nc=V;oc=W;break a}}if((T|0)==6){lc=(S|0)==0;mc=R;nc=N;oc=S;break}else if((T|0)==294){i=d;return aa|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){aa=p?8:oc;i=d;return aa|0}c[b+8>>2]=nc;aa=0;i=d;return aa|0}



function Th(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;sw(Na,1,Ma);c[La>>2]=4;sw(Oa,1,La);c[Ka>>2]=4;sw(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(yw(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(yw(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(yw(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(yw(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];xw(Qa,4,ob,Fa);tw(Qa,Oa);Qa=(bh(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+qw(5536,Fa+ -1|0);c[Ea>>2]=Fa;h[(yw(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((bh(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(yw(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(yw(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(yw(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(yw(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(yw(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(yw(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(yw(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(yw(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(yw(Oa,1,va)|0)>>3];pb=sb*(ob/+qw(5536,Qa+ -1|0));c[ua>>2]=Qa;h[(yw(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((bh(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(yw(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(yw(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(yw(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(yw(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];xw(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];Eh($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(yw(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(yw(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(yw(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(yw(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];xw(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];wh(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(yw(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(yw(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(yw(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(yw(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];xw(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];Hh(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(yw(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(yw(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(yw(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(yw(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];xw(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];Gh(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(yw(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(yw(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(yw(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(yw(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];xw(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];Ih(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(yw(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(yw(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(yw(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(yw(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];xw(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];Eh(eb,b,d,e,o);tb=+h[eb>>3];Fh(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(yw(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(yw(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(yw(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(yw(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];xw(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];wh(gb,b,d,e,n);qb=+h[gb>>3];Kh(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(yw(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(yw(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(yw(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(yw(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];xw(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];Hh(ib,b,d,e,m);vb=+h[ib>>3];Jh(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(yw(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(yw(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(yw(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(yw(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];xw(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];Gh(kb,b,d,e,l);d=+h[kb>>3];Mh(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(yw(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(yw(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(yw(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(yw(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];xw(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];Ih(mb,b,0.0,e,j);yb=+h[mb>>3];Lh(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(yw(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(yw(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(yw(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(yw(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function Uh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;Qj(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));qk(f,0,0.0,0.0,h);i=g;return}function Vh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(yw(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(yw(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];xw(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Qh(d,b,o,p,f);i=e;return}function Wh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;sw(u,1,n);c[m>>2]=2;sw(u,1,m);if((kv(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];gh(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +Aw(f);xw(q,1,w,l);c[k>>2]=q;zw(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];gh(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];tw(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function Xh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;g=i;i=i+24|0;j=g;k=g+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[m>>2]=1;if(+h[(yw(f,1,m)|0)>>3]==0.0){ch(n,b,d,e);y=+h[n>>3];z=a;A=z;h[A>>3]=y;i=g;return}c[l>>2]=1;B=+h[(yw(f,1,l)|0)>>3];c[k>>2]=1;C=B/(1.0- +h[(yw(f,1,k)|0)>>3]);Sh(o,b,d,e);B=+h[o>>3];o=j;k=f;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];Rh(p,b,d,e,j);D=+h[p>>3];E=d-D;p=e<273.16;if(C<=B|B==-1.0){if(p){ch(q,b,E,e);y=+h[q>>3]+D/(e*461.51805);z=a;A=z;h[A>>3]=y;i=g;return}else{ch(r,b,E,e);F=+h[r>>3];qh(s,b,D,e);y=F+ +h[s>>3];z=a;A=z;h[A>>3]=y;i=g;return}}else{if(p){ch(t,b,E,e);F=+h[t>>3];Dh(u,b,d,e);y=(C+1.0)/((B+1.0)/(F+D/(e*461.51805))+(C-B)/+h[u>>3]);z=a;A=z;h[A>>3]=y;i=g;return}else{ch(v,b,E,e);E=+h[v>>3];qh(w,b,D,e);D=+h[w>>3];Yh(x,b,d,e,0);y=(C+1.0)/((B+1.0)/(E+D)+(C-B)/+h[x>>3]);z=a;A=z;h[A>>3]=y;i=g;return}}}function Yh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;Qj(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));ek(f,0,0.0,0.0,h);i=g;return}function Zh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;c[l>>2]=1;if(+h[(yw(f,1,l)|0)>>3]==0.0){p=0.0;q=a;r=q;h[r>>3]=p;i=g;return}c[k>>2]=1;s=+h[(yw(f,1,k)|0)>>3];c[j>>2]=1;t=s/(1.0- +h[(yw(f,1,j)|0)>>3]);if(!(e>=273.16)){Bh(n,0,e);u=+h[n>>3]}else{_h(m,b,e);u=+h[m>>3]}Ph(o,0,0.0,0.0);e=u*+h[o>>3];u=t*(d/(t+.6221042453709779));if(!(u<=e)){p=-1.0;q=a;r=q;h[r>>3]=p;i=g;return}p=u/e;q=a;r=q;h[r>>3]=p;i=g;return}function _h(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;sw(I,1,H);J=+od(+d,647.096);if(!(d>=273.16)){H=c[22536]|0;K=f;L=7752;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];De[H&31](b,f,7776,G);}c[F>>2]=1;h[(yw(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(yw(I,1,E)|0)>>3];c[D>>2]=2;h[(yw(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(yw(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(yw(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(yw(I,1,A)|0)>>3];c[z>>2]=4;h[(yw(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(yw(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(yw(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(yw(I,1,w)|0)>>3];c[v>>2]=6;h[(yw(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(yw(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(yw(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(yw(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(yw(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(yw(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(yw(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(yw(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(yw(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(yw(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(yw(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(yw(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(yw(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(yw(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function $h(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Wh(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];Vh(j,b,h);i=g;return}function ai(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0.0,pd=0.0,qd=0.0,rd=0.0,sd=0.0;f=i;i=i+5488|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;c[Na>>2]=5;sw(Oa,1,Na);c[Oa+0>>2]=c[4576+0>>2];c[Oa+4>>2]=c[4576+4>>2];c[Oa+8>>2]=c[4576+8>>2];c[Ma>>2]=2;Cv(Pa,16,1,Ma);c[La>>2]=1;Ma=Dv(Pa,16,1,La)|0;h[Ma>>3]=.0368017112855051;h[Ma+8>>3]=.0510878114959572;c[Ka>>2]=2;Ma=Dv(Pa,16,1,Ka)|0;h[Ma>>3]=.337315741065416;h[Ma+8>>3]=.335449415919309;c[Ja>>2]=3;Cv(Qa,16,1,Ja);c[Ia>>2]=1;Ja=Dv(Qa,16,1,Ia)|0;h[Ja>>3]=-72.597457432922;h[Ja+8>>3]=-78.100842711287;c[Ha>>2]=2;Ja=Dv(Qa,16,1,Ha)|0;h[Ja>>3]=-557107698030123.0e-19;h[Ja+8>>3]=464578634580806.0e-19;c[Ga>>2]=3;Ja=Dv(Qa,16,1,Ga)|0;h[Ja>>3]=2.34801409215913e-11;h[Ja+8>>3]=-2.85651142904972e-11;c[Fa>>2]=12;Cv(Ua,16,1,Fa);if((bh(2,2,5)|0)==0){od=-632020.233449497}else{pd=-632020.233449497;Fa=2;while(1){Ja=Fa+ -1|0;qd=pd+ +qw(4576,Ja)*+W(+(d/611.657+-165.6565689594004),+(+(Ja|0)));Ja=Fa+1|0;if((bh(Ja,2,5)|0)==0){od=qd;break}else{Fa=Ja;pd=qd}}}c[Ea>>2]=1;Fa=Dv(Qa,16,1,Ea)|0;h[Ra>>3]=+h[Fa>>3];c[Da>>2]=1;Fa=(Dv(Qa,16,1,Da)|0)+8|0;h[(Ra+8|0)>>3]=+h[Fa>>3];if((bh(2,2,3)|0)!=0){Fa=2;do{bi(Va,0,+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -1|0))),0.0);c[Ca>>2]=Fa;Da=Dv(Qa,16,1,Ca)|0;c[(f+2576|0)+0>>2]=c[Da+0>>2];c[(f+2576|0)+4>>2]=c[Da+4>>2];c[(f+2576|0)+8>>2]=c[Da+8>>2];c[(f+2576|0)+12>>2]=c[Da+12>>2];c[(f+2560|0)+0>>2]=c[Va+0>>2];c[(f+2560|0)+4>>2]=c[Va+4>>2];c[(f+2560|0)+8>>2]=c[Va+8>>2];c[(f+2560|0)+12>>2]=c[Va+12>>2];ci(Wa,0,f+2576|0,f+2560|0);c[(f+2544|0)+0>>2]=c[Ra+0>>2];c[(f+2544|0)+4>>2]=c[Ra+4>>2];c[(f+2544|0)+8>>2]=c[Ra+8>>2];c[(f+2544|0)+12>>2]=c[Ra+12>>2];c[(f+2528|0)+0>>2]=c[Wa+0>>2];c[(f+2528|0)+4>>2]=c[Wa+4>>2];c[(f+2528|0)+8>>2]=c[Wa+8>>2];c[(f+2528|0)+12>>2]=c[Wa+12>>2];di(Vc,0,f+2544|0,f+2528|0);pd=+h[(Vc+8|0)>>3];h[Ra>>3]=+h[Vc>>3];h[(Ra+8|0)>>3]=pd;Fa=Fa+1|0;}while((bh(Fa,2,3)|0)!=0)}if((bh(3,3,5)|0)==0){rd=.001070897927529571}else{pd=.001070897927529571;Fa=3;while(1){Vc=Fa+ -1|0;qd=pd+ +qw(4576,Vc)*+(Vc|0)*+W(+(d/611.657+-165.6565689594004),+(+(Fa+ -2|0)))*.001634903221903779;Vc=Fa+1|0;if((bh(Vc,3,5)|0)==0){rd=qd;break}else{Fa=Vc;pd=qd}}}bi(Xa,0,611.657,0.0);c[Ba>>2]=2;Fa=Dv(Qa,16,1,Ba)|0;c[(f+2512|0)+0>>2]=c[Fa+0>>2];c[(f+2512|0)+4>>2]=c[Fa+4>>2];c[(f+2512|0)+8>>2]=c[Fa+8>>2];c[(f+2512|0)+12>>2]=c[Fa+12>>2];c[(f+2496|0)+0>>2]=c[Xa+0>>2];c[(f+2496|0)+4>>2]=c[Xa+4>>2];c[(f+2496|0)+8>>2]=c[Xa+8>>2];c[(f+2496|0)+12>>2]=c[Xa+12>>2];ei(Ya,0,f+2512|0,f+2496|0);bi(Za,0,305.8285,0.0);c[Aa>>2]=3;Xa=Dv(Qa,16,1,Aa)|0;c[(f+2480|0)+0>>2]=c[Xa+0>>2];c[(f+2480|0)+4>>2]=c[Xa+4>>2];c[(f+2480|0)+8>>2]=c[Xa+8>>2];c[(f+2480|0)+12>>2]=c[Xa+12>>2];c[(f+2464|0)+0>>2]=c[Za+0>>2];c[(f+2464|0)+4>>2]=c[Za+4>>2];c[(f+2464|0)+8>>2]=c[Za+8>>2];c[(f+2464|0)+12>>2]=c[Za+12>>2];ei(_a,0,f+2480|0,f+2464|0);bi($a,0,d/611.657+-165.6565689594004,0.0);c[(f+2448|0)+0>>2]=c[_a+0>>2];c[(f+2448|0)+4>>2]=c[_a+4>>2];c[(f+2448|0)+8>>2]=c[_a+8>>2];c[(f+2448|0)+12>>2]=c[_a+12>>2];c[(f+2432|0)+0>>2]=c[$a+0>>2];c[(f+2432|0)+4>>2]=c[$a+4>>2];c[(f+2432|0)+8>>2]=c[$a+8>>2];c[(f+2432|0)+12>>2]=c[$a+12>>2];ci(ab,0,f+2448|0,f+2432|0);c[(f+2416|0)+0>>2]=c[Ya+0>>2];c[(f+2416|0)+4>>2]=c[Ya+4>>2];c[(f+2416|0)+8>>2]=c[Ya+8>>2];c[(f+2416|0)+12>>2]=c[Ya+12>>2];c[(f+2400|0)+0>>2]=c[ab+0>>2];c[(f+2400|0)+4>>2]=c[ab+4>>2];c[(f+2400|0)+8>>2]=c[ab+8>>2];c[(f+2400|0)+12>>2]=c[ab+12>>2];di(Wc,0,f+2416|0,f+2400|0);pd=+h[Wc+8>>3];h[Sa>>3]=+h[Wc>>3];h[Sa+8>>3]=pd;if((bh(4,4,5)|0)==0){sd=-1.01233700452045e-13}else{pd=-1.01233700452045e-13;Wc=4;while(1){ab=Wc+ -1|0;qd=pd+ +qw(4576,ab)*+(ab|0)*+(Wc+ -2|0)*+W(+(d/611.657+-165.6565689594004),+(+(Wc+ -3|0)))*2672908544991358.0e-21;ab=Wc+1|0;if((bh(ab,4,5)|0)==0){sd=qd;break}else{Wc=ab;pd=qd}}}bi(bb,0,5345817089982717.0e-21,0.0);c[za>>2]=3;Wc=Dv(Qa,16,1,za)|0;c[(f+2384|0)+0>>2]=c[Wc+0>>2];c[(f+2384|0)+4>>2]=c[Wc+4>>2];c[(f+2384|0)+8>>2]=c[Wc+8>>2];c[(f+2384|0)+12>>2]=c[Wc+12>>2];c[(f+2368|0)+0>>2]=c[bb+0>>2];c[(f+2368|0)+4>>2]=c[bb+4>>2];c[(f+2368|0)+8>>2]=c[bb+8>>2];c[(f+2368|0)+12>>2]=c[bb+12>>2];ci(Xc,0,f+2384|0,f+2368|0);pd=+h[Xc+8>>3];h[Ta>>3]=+h[Xc>>3];h[Ta+8>>3]=pd;bi(cb,0,e/273.16,0.0);c[ya>>2]=1;Xc=Dv(Pa,16,1,ya)|0;c[(f+2352|0)+0>>2]=c[Xc+0>>2];c[(f+2352|0)+4>>2]=c[Xc+4>>2];c[(f+2352|0)+8>>2]=c[Xc+8>>2];c[(f+2352|0)+12>>2]=c[Xc+12>>2];c[(f+2336|0)+0>>2]=c[cb+0>>2];c[(f+2336|0)+4>>2]=c[cb+4>>2];c[(f+2336|0)+8>>2]=c[cb+8>>2];c[(f+2336|0)+12>>2]=c[cb+12>>2];fi(db,0,f+2352|0,f+2336|0);bi(eb,0,e/273.16,0.0);c[xa>>2]=1;cb=Dv(Pa,16,1,xa)|0;c[(f+2320|0)+0>>2]=c[cb+0>>2];c[(f+2320|0)+4>>2]=c[cb+4>>2];c[(f+2320|0)+8>>2]=c[cb+8>>2];c[(f+2320|0)+12>>2]=c[cb+12>>2];c[(f+2304|0)+0>>2]=c[eb+0>>2];c[(f+2304|0)+4>>2]=c[eb+4>>2];c[(f+2304|0)+8>>2]=c[eb+8>>2];c[(f+2304|0)+12>>2]=c[eb+12>>2];fi(fb,0,f+2320|0,f+2304|0);c[(f+2288|0)+0>>2]=c[fb+0>>2];c[(f+2288|0)+4>>2]=c[fb+4>>2];c[(f+2288|0)+8>>2]=c[fb+8>>2];c[(f+2288|0)+12>>2]=c[fb+12>>2];gi(gb,b,f+2288|0);c[(f+2272|0)+0>>2]=c[db+0>>2];c[(f+2272|0)+4>>2]=c[db+4>>2];c[(f+2272|0)+8>>2]=c[db+8>>2];c[(f+2272|0)+12>>2]=c[db+12>>2];c[(f+2256|0)+0>>2]=c[gb+0>>2];c[(f+2256|0)+4>>2]=c[gb+4>>2];c[(f+2256|0)+8>>2]=c[gb+8>>2];c[(f+2256|0)+12>>2]=c[gb+12>>2];ci(Yc,0,f+2272|0,f+2256|0);pd=+h[Yc>>3];qd=+h[Yc+8>>3];c[wa>>2]=1;Yc=Dv(Ua,16,1,wa)|0;h[Yc>>3]=pd;c[va>>2]=1;Yc=(Dv(Ua,16,1,va)|0)+8|0;h[Yc>>3]=qd;bi(hb,0,e/273.16,0.0);c[ua>>2]=1;Yc=Dv(Pa,16,1,ua)|0;c[(f+2240|0)+0>>2]=c[Yc+0>>2];c[(f+2240|0)+4>>2]=c[Yc+4>>2];c[(f+2240|0)+8>>2]=c[Yc+8>>2];c[(f+2240|0)+12>>2]=c[Yc+12>>2];c[(f+2224|0)+0>>2]=c[hb+0>>2];c[(f+2224|0)+4>>2]=c[hb+4>>2];c[(f+2224|0)+8>>2]=c[hb+8>>2];c[(f+2224|0)+12>>2]=c[hb+12>>2];di(ib,0,f+2240|0,f+2224|0);bi(jb,0,e/273.16,0.0);c[ta>>2]=1;hb=Dv(Pa,16,1,ta)|0;c[(f+2208|0)+0>>2]=c[hb+0>>2];c[(f+2208|0)+4>>2]=c[hb+4>>2];c[(f+2208|0)+8>>2]=c[hb+8>>2];c[(f+2208|0)+12>>2]=c[hb+12>>2];c[(f+2192|0)+0>>2]=c[jb+0>>2];c[(f+2192|0)+4>>2]=c[jb+4>>2];c[(f+2192|0)+8>>2]=c[jb+8>>2];c[(f+2192|0)+12>>2]=c[jb+12>>2];di(kb,0,f+2208|0,f+2192|0);c[(f+2176|0)+0>>2]=c[kb+0>>2];c[(f+2176|0)+4>>2]=c[kb+4>>2];c[(f+2176|0)+8>>2]=c[kb+8>>2];c[(f+2176|0)+12>>2]=c[kb+12>>2];gi(lb,b,f+2176|0);c[(f+2160|0)+0>>2]=c[ib+0>>2];c[(f+2160|0)+4>>2]=c[ib+4>>2];c[(f+2160|0)+8>>2]=c[ib+8>>2];c[(f+2160|0)+12>>2]=c[ib+12>>2];c[(f+2144|0)+0>>2]=c[lb+0>>2];c[(f+2144|0)+4>>2]=c[lb+4>>2];c[(f+2144|0)+8>>2]=c[lb+8>>2];c[(f+2144|0)+12>>2]=c[lb+12>>2];ci(Zc,0,f+2160|0,f+2144|0);qd=+h[Zc>>3];pd=+h[Zc+8>>3];c[sa>>2]=2;Zc=Dv(Ua,16,1,sa)|0;h[Zc>>3]=qd;c[ra>>2]=2;Zc=(Dv(Ua,16,1,ra)|0)+8|0;h[Zc>>3]=pd;bi(mb,0,e/273.16,0.0);c[qa>>2]=2;Zc=Dv(Pa,16,1,qa)|0;c[(f+2128|0)+0>>2]=c[Zc+0>>2];c[(f+2128|0)+4>>2]=c[Zc+4>>2];c[(f+2128|0)+8>>2]=c[Zc+8>>2];c[(f+2128|0)+12>>2]=c[Zc+12>>2];c[(f+2112|0)+0>>2]=c[mb+0>>2];c[(f+2112|0)+4>>2]=c[mb+4>>2];c[(f+2112|0)+8>>2]=c[mb+8>>2];c[(f+2112|0)+12>>2]=c[mb+12>>2];fi(nb,0,f+2128|0,f+2112|0);bi(ob,0,e/273.16,0.0);c[pa>>2]=2;mb=Dv(Pa,16,1,pa)|0;c[(f+2096|0)+0>>2]=c[mb+0>>2];c[(f+2096|0)+4>>2]=c[mb+4>>2];c[(f+2096|0)+8>>2]=c[mb+8>>2];c[(f+2096|0)+12>>2]=c[mb+12>>2];c[(f+2080|0)+0>>2]=c[ob+0>>2];c[(f+2080|0)+4>>2]=c[ob+4>>2];c[(f+2080|0)+8>>2]=c[ob+8>>2];c[(f+2080|0)+12>>2]=c[ob+12>>2];fi(pb,0,f+2096|0,f+2080|0);c[(f+2064|0)+0>>2]=c[pb+0>>2];c[(f+2064|0)+4>>2]=c[pb+4>>2];c[(f+2064|0)+8>>2]=c[pb+8>>2];c[(f+2064|0)+12>>2]=c[pb+12>>2];gi(qb,b,f+2064|0);c[(f+2048|0)+0>>2]=c[nb+0>>2];c[(f+2048|0)+4>>2]=c[nb+4>>2];c[(f+2048|0)+8>>2]=c[nb+8>>2];c[(f+2048|0)+12>>2]=c[nb+12>>2];c[(f+2032|0)+0>>2]=c[qb+0>>2];c[(f+2032|0)+4>>2]=c[qb+4>>2];c[(f+2032|0)+8>>2]=c[qb+8>>2];c[(f+2032|0)+12>>2]=c[qb+12>>2];ci(_c,0,f+2048|0,f+2032|0);pd=+h[_c>>3];qd=+h[_c+8>>3];c[oa>>2]=3;_c=Dv(Ua,16,1,oa)|0;h[_c>>3]=pd;c[na>>2]=3;_c=(Dv(Ua,16,1,na)|0)+8|0;h[_c>>3]=qd;bi(rb,0,e/273.16,0.0);c[ma>>2]=2;_c=Dv(Pa,16,1,ma)|0;c[(f+2016|0)+0>>2]=c[_c+0>>2];c[(f+2016|0)+4>>2]=c[_c+4>>2];c[(f+2016|0)+8>>2]=c[_c+8>>2];c[(f+2016|0)+12>>2]=c[_c+12>>2];c[(f+2e3|0)+0>>2]=c[rb+0>>2];c[(f+2e3|0)+4>>2]=c[rb+4>>2];c[(f+2e3|0)+8>>2]=c[rb+8>>2];c[(f+2e3|0)+12>>2]=c[rb+12>>2];di(sb,0,f+2016|0,f+2e3|0);bi(tb,0,e/273.16,0.0);c[la>>2]=2;rb=Dv(Pa,16,1,la)|0;c[(f+1984|0)+0>>2]=c[rb+0>>2];c[(f+1984|0)+4>>2]=c[rb+4>>2];c[(f+1984|0)+8>>2]=c[rb+8>>2];c[(f+1984|0)+12>>2]=c[rb+12>>2];c[(f+1968|0)+0>>2]=c[tb+0>>2];c[(f+1968|0)+4>>2]=c[tb+4>>2];c[(f+1968|0)+8>>2]=c[tb+8>>2];c[(f+1968|0)+12>>2]=c[tb+12>>2];di(ub,0,f+1984|0,f+1968|0);c[(f+1952|0)+0>>2]=c[ub+0>>2];c[(f+1952|0)+4>>2]=c[ub+4>>2];c[(f+1952|0)+8>>2]=c[ub+8>>2];c[(f+1952|0)+12>>2]=c[ub+12>>2];gi(vb,b,f+1952|0);c[(f+1936|0)+0>>2]=c[sb+0>>2];c[(f+1936|0)+4>>2]=c[sb+4>>2];c[(f+1936|0)+8>>2]=c[sb+8>>2];c[(f+1936|0)+12>>2]=c[sb+12>>2];c[(f+1920|0)+0>>2]=c[vb+0>>2];c[(f+1920|0)+4>>2]=c[vb+4>>2];c[(f+1920|0)+8>>2]=c[vb+8>>2];c[(f+1920|0)+12>>2]=c[vb+12>>2];ci($c,0,f+1936|0,f+1920|0);qd=+h[$c>>3];pd=+h[$c+8>>3];c[ka>>2]=4;$c=Dv(Ua,16,1,ka)|0;h[$c>>3]=qd;c[ja>>2]=4;$c=(Dv(Ua,16,1,ja)|0)+8|0;h[$c>>3]=pd;bi(wb,0,2.0,0.0);c[ia>>2]=1;$c=Dv(Pa,16,1,ia)|0;c[(f+1904|0)+0>>2]=c[wb+0>>2];c[(f+1904|0)+4>>2]=c[wb+4>>2];c[(f+1904|0)+8>>2]=c[wb+8>>2];c[(f+1904|0)+12>>2]=c[wb+12>>2];c[(f+1888|0)+0>>2]=c[$c+0>>2];c[(f+1888|0)+4>>2]=c[$c+4>>2];c[(f+1888|0)+8>>2]=c[$c+8>>2];c[(f+1888|0)+12>>2]=c[$c+12>>2];ci(xb,0,f+1904|0,f+1888|0);c[ha>>2]=1;$c=Dv(Pa,16,1,ha)|0;c[(f+1872|0)+0>>2]=c[$c+0>>2];c[(f+1872|0)+4>>2]=c[$c+4>>2];c[(f+1872|0)+8>>2]=c[$c+8>>2];c[(f+1872|0)+12>>2]=c[$c+12>>2];gi(yb,b,f+1872|0);c[(f+1856|0)+0>>2]=c[xb+0>>2];c[(f+1856|0)+4>>2]=c[xb+4>>2];c[(f+1856|0)+8>>2]=c[xb+8>>2];c[(f+1856|0)+12>>2]=c[xb+12>>2];c[(f+1840|0)+0>>2]=c[yb+0>>2];c[(f+1840|0)+4>>2]=c[yb+4>>2];c[(f+1840|0)+8>>2]=c[yb+8>>2];c[(f+1840|0)+12>>2]=c[yb+12>>2];ci(ad,0,f+1856|0,f+1840|0);pd=+h[ad>>3];qd=+h[ad+8>>3];c[ga>>2]=5;ad=Dv(Ua,16,1,ga)|0;h[ad>>3]=pd;c[fa>>2]=5;ad=(Dv(Ua,16,1,fa)|0)+8|0;h[ad>>3]=qd;bi(zb,0,2.0,0.0);c[ea>>2]=2;ad=Dv(Pa,16,1,ea)|0;c[(f+1824|0)+0>>2]=c[zb+0>>2];c[(f+1824|0)+4>>2]=c[zb+4>>2];c[(f+1824|0)+8>>2]=c[zb+8>>2];c[(f+1824|0)+12>>2]=c[zb+12>>2];c[(f+1808|0)+0>>2]=c[ad+0>>2];c[(f+1808|0)+4>>2]=c[ad+4>>2];c[(f+1808|0)+8>>2]=c[ad+8>>2];c[(f+1808|0)+12>>2]=c[ad+12>>2];ci(Ab,0,f+1824|0,f+1808|0);c[da>>2]=2;ad=Dv(Pa,16,1,da)|0;c[(f+1792|0)+0>>2]=c[ad+0>>2];c[(f+1792|0)+4>>2]=c[ad+4>>2];c[(f+1792|0)+8>>2]=c[ad+8>>2];c[(f+1792|0)+12>>2]=c[ad+12>>2];gi(Bb,b,f+1792|0);c[(f+1776|0)+0>>2]=c[Ab+0>>2];c[(f+1776|0)+4>>2]=c[Ab+4>>2];c[(f+1776|0)+8>>2]=c[Ab+8>>2];c[(f+1776|0)+12>>2]=c[Ab+12>>2];c[(f+1760|0)+0>>2]=c[Bb+0>>2];c[(f+1760|0)+4>>2]=c[Bb+4>>2];c[(f+1760|0)+8>>2]=c[Bb+8>>2];c[(f+1760|0)+12>>2]=c[Bb+12>>2];ci(bd,0,f+1776|0,f+1760|0);qd=+h[bd>>3];pd=+h[bd+8>>3];c[ca>>2]=6;bd=Dv(Ua,16,1,ca)|0;h[bd>>3]=qd;c[ba>>2]=6;bd=(Dv(Ua,16,1,ba)|0)+8|0;h[bd>>3]=pd;bi(Cb,0,e/273.16*(e/273.16),0.0);c[aa>>2]=1;bd=Dv(Pa,16,1,aa)|0;c[(f+1744|0)+0>>2]=c[Cb+0>>2];c[(f+1744|0)+4>>2]=c[Cb+4>>2];c[(f+1744|0)+8>>2]=c[Cb+8>>2];c[(f+1744|0)+12>>2]=c[Cb+12>>2];c[(f+1728|0)+0>>2]=c[bd+0>>2];c[(f+1728|0)+4>>2]=c[bd+4>>2];c[(f+1728|0)+8>>2]=c[bd+8>>2];c[(f+1728|0)+12>>2]=c[bd+12>>2];ei(cd,0,f+1744|0,f+1728|0);pd=+h[cd>>3];qd=+h[cd+8>>3];c[$>>2]=7;cd=Dv(Ua,16,1,$)|0;h[cd>>3]=pd;c[_>>2]=7;cd=(Dv(Ua,16,1,_)|0)+8|0;h[cd>>3]=qd;bi(Db,0,e/273.16*(e/273.16),0.0);c[Z>>2]=2;cd=Dv(Pa,16,1,Z)|0;c[(f+1712|0)+0>>2]=c[Db+0>>2];c[(f+1712|0)+4>>2]=c[Db+4>>2];c[(f+1712|0)+8>>2]=c[Db+8>>2];c[(f+1712|0)+12>>2]=c[Db+12>>2];c[(f+1696|0)+0>>2]=c[cd+0>>2];c[(f+1696|0)+4>>2]=c[cd+4>>2];c[(f+1696|0)+8>>2]=c[cd+8>>2];c[(f+1696|0)+12>>2]=c[cd+12>>2];ei(dd,0,f+1712|0,f+1696|0);qd=+h[dd>>3];pd=+h[dd+8>>3];c[Y>>2]=8;dd=Dv(Ua,16,1,Y)|0;h[dd>>3]=qd;c[X>>2]=8;c[f+2608>>2]=a;c[f+2616>>2]=b;g[f+2624>>2]=d;g[f+2632>>2]=e;c[f+2736>>2]=ed;c[f+2752>>2]=fd;c[f+2760>>2]=gd;c[f+2768>>2]=hd;c[f+2784>>2]=id;c[f+2800>>2]=jd;c[f+2824>>2]=kd;c[f+2840>>2]=ld;c[f+2872>>2]=md;c[f+2888>>2]=nd;g[f+3288>>2]=pd;g[f+3768>>2]=od;g[f+3784>>2]=rd;g[f+3800>>2]=sd;c[f+3856>>2]=Ua;c[f+3864>>2]=Ra;c[f+3872>>2]=Sa;c[f+3880>>2]=Ta;c[f+3896>>2]=Pa;c[f+3904>>2]=Mb;c[f+3912>>2]=Nb;c[f+3920>>2]=Ob;c[f+3928>>2]=Pb;c[f+3936>>2]=Qb;c[f+3944>>2]=Rb;c[f+3952>>2]=Sb;c[f+3968>>2]=Tb;c[f+3976>>2]=Ub;c[f+3984>>2]=Vb;c[f+3992>>2]=Wb;c[f+4e3>>2]=Xb;c[f+4008>>2]=Yb;c[f+4016>>2]=Zb;c[f+4032>>2]=_b;c[f+4040>>2]=$b;c[f+4048>>2]=ac;c[f+4056>>2]=bc;c[f+4064>>2]=cc;c[f+4072>>2]=dc;c[f+4080>>2]=ec;c[f+4088>>2]=fc;c[f+4096>>2]=gc;c[f+4104>>2]=hc;c[f+4112>>2]=ic;c[f+4120>>2]=jc;c[f+4128>>2]=kc;c[f+4136>>2]=lc;c[f+4144>>2]=mc;c[f+4152>>2]=nc;c[f+4160>>2]=oc;c[f+4168>>2]=pc;c[f+4176>>2]=qc;c[f+4184>>2]=rc;c[f+4192>>2]=sc;c[f+4200>>2]=tc;c[f+4208>>2]=uc;c[f+4216>>2]=vc;c[f+4224>>2]=wc;c[f+4232>>2]=xc;c[f+4240>>2]=yc;c[f+4248>>2]=zc;c[f+4256>>2]=Ac;c[f+4264>>2]=Bc;c[f+4272>>2]=Cc;c[f+4280>>2]=Dc;c[f+4288>>2]=Ec;c[f+4296>>2]=Fc;c[f+4304>>2]=Gc;c[f+4312>>2]=Hc;c[f+4320>>2]=Ic;c[f+4328>>2]=Jc;c[f+4336>>2]=Kc;c[f+4344>>2]=Lc;c[f+4352>>2]=Mc;c[f+4360>>2]=Nc;c[f+4368>>2]=Oc;c[f+4376>>2]=Pc;c[f+4384>>2]=Qc;c[f+4392>>2]=Rc;c[f+4400>>2]=Sc;c[f+4408>>2]=Tc;c[f+4416>>2]=Uc;c[f+4704>>2]=Eb;c[f+4712>>2]=Fb;c[f+4720>>2]=Gb;c[f+4728>>2]=Hb;c[f+4736>>2]=Ib;c[f+4744>>2]=Jb;c[f+4752>>2]=Kb;c[f+4760>>2]=Lb;c[f+4944>>2]=X;c[f+4952>>2]=V;c[f+4960>>2]=U;c[f+4968>>2]=T;c[f+4976>>2]=S;c[f+4984>>2]=R;c[f+4992>>2]=Q;c[f+5e3>>2]=P;c[f+5008>>2]=O;c[f+5016>>2]=N;c[f+5032>>2]=M;c[f+5040>>2]=L;c[f+5048>>2]=K;c[f+5056>>2]=J;c[f+5064>>2]=G;c[f+5072>>2]=F;c[f+5080>>2]=E;c[f+5088>>2]=D;c[f+5096>>2]=C;c[f+5104>>2]=B;c[f+5120>>2]=z;c[f+5128>>2]=y;c[f+5136>>2]=x;c[f+5144>>2]=w;c[f+5152>>2]=v;c[f+5160>>2]=u;c[f+5168>>2]=t;c[f+5176>>2]=s;c[f+5184>>2]=r;c[f+5192>>2]=q;c[f+5208>>2]=p;c[f+5216>>2]=o;c[f+5224>>2]=n;c[f+5232>>2]=m;c[f+5240>>2]=l;c[f+5248>>2]=k;c[f+5256>>2]=j;c[f+5424>>2]=0;c[f+5428>>2]=0;_omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(f);H=c[f+5424>>2]|0;A=c[f+5428>>2]|0;I=+g[f+5428>>2];c[f+5424>>2]=0;c[f+5428>>2]=0;if((H|0)==5){return}}function bi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function ci(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];bi(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function di(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;bi(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function ei(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;bi(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function fi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;bi(e,0,+h[c>>3]- +h[d>>3],+h[c+8>>3]- +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function gi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;m=+h[d+8>>3];n=+h[d>>3];ah(j,0,m,n,0.0);o=+h[j>>3];p=+V(+(n*n+m*m));if(!(p>0.0)){j=c[22536]|0;d=g;h[k>>3]=p;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];d=j;j=f;q=7728;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];De[d&31](b,f,4848,g);}bi(l,0,+da(+p),o);o=+h[l+8>>3];h[a>>3]=+h[l>>3];h[a+8>>3]=o;i=e;return}function hi(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function ii(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0;e=i;i=i+88|0;f=e;th(f,b,c,d);h[a>>3]=c/(+h[f+16>>3]*+h[f+24>>3]*+h[f+48>>3]*d);i=e;return}function ji(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;Rg(a,b,c,143.15,2.0e3,1.0e-9);i=d;return}function ki(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;e=i;i=i+40|0;f=e;g=e+8|0;j=e+16|0;k=e+24|0;l=e+32|0;if(!(d>=273.16)){rh(j,0,d);m=+h[j>>3];ji(k,b,c);n=+h[k>>3];o=m}else{li(f,b,d);m=+h[f>>3];mi(g,b,c);n=+h[g>>3];o=m}if(!(n>=d)){p=-1.0;q=a;r=q;h[r>>3]=p;i=e;return}ni(l,0,0.0,0.0);p=o*+h[l>>3];q=a;r=q;h[r>>3]=p;i=e;return}function li(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+16|0;c[j>>2]=10;sw(l,1,j);j=l;l=4680;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];m=+od(+d,553.0);d=m+-.23855557567849/(m+-650.17534844798);m=d*d;n=d*12020.82470247+m*-17.073846940092+-3232555.0322333;o=d*-4823.2657361591+m*14.91510861353+405113.40542057;p=n*n+(m+d*1167.0521452767+-724213.16703206)*o*-4.0;if(p>=0.0){q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}l=c[22536]|0;j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=l;l=f;y=7728;c[l+0>>2]=c[y+0>>2];c[l+4>>2]=c[y+4>>2];c[l+8>>2]=c[y+8>>2];c[l+12>>2]=c[y+12>>2];c[l+16>>2]=c[y+16>>2];c[l+20>>2]=c[y+20>>2];De[j&31](b,f,4696,g);q=+V(+p);r=q-n;s=o/r;t=s*s;u=t*t;v=u*16.0e6;w=a;x=w;h[x>>3]=v;i=e;return}function mi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;c[m>>2]=10;sw(n,1,m);m=n;n=4680;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];o=+W(+(d*1.0e-6),.25);d=o*o;p=o*12020.82470247+d*1167.0521452767+-4823.2657361591;q=o*-3232555.0322333+d*-724213.16703206+405113.40542057;r=p*p+(d+o*-17.073846940092+14.91510861353)*q*-4.0;if(!(r>=0.0)){n=c[22536]|0;m=l;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=n;n=g;s=7728;c[n+0>>2]=c[s+0>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[n+16>>2]=c[s+16>>2];c[n+20>>2]=c[s+20>>2];De[m&31](b,g,5320,l);}o=q/(-p- +V(+r))*2.0;r=o+650.17534844798;p=r*r+(o*650.17534844798+-.23855557567849)*-4.0;if(p>=0.0){t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}l=c[22536]|0;g=j;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=l;l=f;m=7728;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16>>2]=c[m+16>>2];c[l+20>>2]=c[m+20>>2];De[g&31](b,f,5400,j);t=o*.5;u=+V(+p);v=u*-.5;w=t+v;x=w+325.08767422399;y=a;z=y;h[z>>3]=x;i=e;return}function ni(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=1.0;i=i;return}function oi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;c[m>>2]=3;n=+h[(yw(f,1,m)|0)>>3];if(n>=0.0){o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}m=c[22536]|0;f=l;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;y=7728;c[m+0>>2]=c[y+0>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[m+16>>2]=c[y+16>>2];c[m+20>>2]=c[y+20>>2];De[f&31](b,j,4936,l);o=-30807.8/e;p=+ca(+o);q=+V(+n);r=d/101325.0;s=+W(+r,-.5);t=p*s;u=q*t;v=u*3235.34;w=a;x=w;h[x>>3]=v;i=g;return}function pi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;e=i;i=i+88|0;f=e;ai(f,b,c,d);g=+h[f+8>>3];j=+h[f+48>>3];k=+h[f+56>>3];l=+h[f+64>>3];m=+h[f+80>>3];n=1.0/j;o=+h[f+40>>3]-g*l;p=-(g*+h[f+72>>3]);q=j*n;j=m/q;r=k/q;q=-+Yw(n,-2)/r;h[a>>3]=c;h[a+8>>3]=d;h[a+16>>3]=o;h[a+24>>3]=461.52364;h[a+32>>3]=p;h[a+40>>3]=p-g*(m*m/k);h[a+48>>3]=n;h[a+56>>3]=-l;h[a+64>>3]=-j/r;h[a+72>>3]=q;h[a+80>>3]=j;h[a+88>>3]=r;i=e;return}function qi(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;pi(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));ri(b,0,0.0,0.0,g);i=f;return}function ri(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function si(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=1;o=+h[(yw(f,1,n)|0)>>3];if(!(o>=0.0)){n=c[22536]|0;p=m;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=7728;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4776,m);}r=+ca(+(-19526.8/e));e=+V(+o);c[l>>2]=3;h[a>>3]=e*r*+W(+(+h[(yw(f,1,l)|0)>>3]/d),.25)*2960.781850257371;i=g;return}function ti(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+48>>3];i=i;return}function ui(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;pi(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));ti(b,0,0.0,0.0,g);i=f;return}function vi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=+ca(+(-30283.3/e));c[n>>2]=3;e=+h[(yw(f,1,n)|0)>>3];if(!(e>=0.0)){n=c[22536]|0;p=m;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=j;q=7728;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](b,j,4936,m);}c[l>>2]=1;h[a>>3]=+h[(yw(f,1,l)|0)>>3]*+W(+(d/101325.0),-.5)*(o/+V(+e))*1075.5;i=g;return}function wi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;g=i;i=i+48|0;j=g;l=g+24|0;m=g+40|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;c[r>>2]=1;u=+h[(yw(f,1,r)|0)>>3];c[q>>2]=2;v=+h[(yw(f,1,q)|0)>>3];c[p>>2]=3;w=+h[(yw(f,1,p)|0)>>3];c[o>>2]=4;x=+h[(yw(f,1,o)|0)>>3];o=n;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=w;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];xw(s,4,u,n);n=l;o=s;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];vi(t,b,d,e,l);u=+h[t>>3];if(u>=0.0){y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}t=c[22536]|0;l=m;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=t;t=j;o=7728;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];c[t+16>>2]=c[o+16>>2];c[t+20>>2]=c[o+20>>2];De[l&31](b,j,5552,m);y=-27488.0/e;z=+ca(+y);A=+V(+u);B=d/101325.0;C=+W(+B,-.5);D=z*C;E=A*D;F=E*1491.75;G=a;H=G;h[H>>3]=F;i=g;return}function xi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=393.0e3/c+5826.0e6/(c*c)+-3.6;i=i;return}function yi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=303.0e3/c+7277.0e6/(c*c)+-65.2;i=i;return}function zi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(yw(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(yw(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[22536]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=7728;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];De[f&31](b,j,5232,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function Ai(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=57200.0/c+3136.0e6/(c*c)+-18.7;i=i;return}function Bi(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=16200.0/c+994.0e6/(c*c)+-5.6;i=i;return}function Ci(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=15.0e4/c+7659.0e6/(c*c)+-21.8;i=i;return}function Di(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;g=i;i=i+40|0;j=g;k=g+16|0;l=g+32|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;c[n>>2]=1;if(+h[(yw(f,1,n)|0)>>3]==0.0){Wg(o,b,d,e);C=+h[o>>3];D=a;E=D;h[E>>3]=C;i=g;return}o=k;n=f;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Ei(p,b,d,e,k);F=+h[p>>3];G=d-F;c[m>>2]=1;H=+h[(yw(f,1,m)|0)>>3];c[l>>2]=1;I=H/(1.0- +h[(yw(f,1,l)|0)>>3]);Fi(q,b,d,e);H=+h[q>>3];do{if(I<=H|H==-1.0){if(!(e>=773.15)){Wg(u,b,G,e);J=+h[u>>3];sh(v,b,F,e,0);K=J+I*+h[v>>3];break}else{Wg(r,b,G,e);J=+h[r>>3];sh(s,b,F,e,0);L=+h[s>>3];q=j;l=f;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];Gi(t,b,d,e,j);K=J+(I*L+(I+1.0)*+h[t>>3]);break}}else{if(e<273.16){Wg(w,b,G,e);L=+h[w>>3];sh(x,b,F,e,0);J=+h[x>>3];qi(y,b,d,e);K=L+(H*J+(I-H)*+h[y>>3]);break}else{Wg(z,b,G,e);J=+h[z>>3];sh(A,b,F,e,0);L=+h[A>>3];Uh(B,b,d,e,0);K=J+(H*L+(I-H)*+h[B>>3]);break}}}while(0);C=K/(I+1.0);D=a;E=D;h[E>>3]=C;i=g;return}function Ei(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(yw(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(yw(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(yw(f,1,j)|0)>>3]);ki(m,b,d,e);r=+h[m>>3];Fi(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function Fi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;ki(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){mi(j,b,c);l=+h[j>>3]}else{ji(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function Gi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0;g=i;i=i+168|0;j=g;l=g+16|0;m=g+32|0;n=g+48|0;o=g+64|0;p=g+80|0;q=g+96|0;r=g+112|0;s=g+128|0;t=g+144|0;u=g+160|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+24|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+24|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+24|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+24|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+24|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+24|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+24|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+24|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+24|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;c[Ma>>2]=4;sw(Na,1,Ma);c[La>>2]=4;sw(Oa,1,La);c[Ka>>2]=4;sw(Pa,1,Ka);c[Ja>>2]=1;ob=+h[(yw(f,1,Ja)|0)>>3];c[Ia>>2]=2;pb=+h[(yw(f,1,Ia)|0)>>3]*.7557;c[Ha>>2]=2;qb=+h[(yw(f,1,Ha)|0)>>3]*.2316;c[Ga>>2]=2;rb=+h[(yw(f,1,Ga)|0)>>3]*.0127;Ga=Fa;h[k>>3]=pb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+8|0;h[k>>3]=qb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];Ga=Fa+16|0;h[k>>3]=rb;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];xw(Qa,4,ob,Fa);tw(Qa,Oa);Qa=(bh(1,1,4)|0)==0;if(!Qa){Fa=1;do{ob=1.0/+qw(5536,Fa+ -1|0);c[Ea>>2]=Fa;h[(yw(Na,1,Ea)|0)>>3]=ob;Fa=Fa+1|0;}while((bh(Fa,1,4)|0)!=0)}c[Da>>2]=1;ob=+h[(yw(Oa,1,Da)|0)>>3];c[Ca>>2]=1;rb=ob*+h[(yw(Na,1,Ca)|0)>>3];c[Ba>>2]=2;ob=+h[(yw(Oa,1,Ba)|0)>>3];c[Aa>>2]=2;qb=ob*+h[(yw(Na,1,Aa)|0)>>3];c[za>>2]=3;ob=+h[(yw(Oa,1,za)|0)>>3];c[ya>>2]=3;pb=ob*+h[(yw(Na,1,ya)|0)>>3];c[xa>>2]=4;ob=+h[(yw(Oa,1,xa)|0)>>3];c[wa>>2]=4;sb=1.0/(rb+(qb+(pb+ob*+h[(yw(Na,1,wa)|0)>>3])));if(!Qa){Qa=1;do{c[va>>2]=Qa;ob=+h[(yw(Oa,1,va)|0)>>3];pb=sb*(ob/+qw(5536,Qa+ -1|0));c[ua>>2]=Qa;h[(yw(Pa,1,ua)|0)>>3]=pb;Qa=Qa+1|0;}while((bh(Qa,1,4)|0)!=0)}c[ta>>2]=1;sb=+h[(yw(Pa,1,ta)|0)>>3];c[sa>>2]=2;pb=+h[(yw(Pa,1,sa)|0)>>3];c[ra>>2]=3;ob=+h[(yw(Pa,1,ra)|0)>>3];c[qa>>2]=4;qb=+h[(yw(Pa,1,qa)|0)>>3];qa=pa;h[k>>3]=pb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+8|0;h[k>>3]=ob;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];qa=pa+16|0;h[k>>3]=qb;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];xw(Ra,4,sb,pa);pa=t;qa=Ra;c[pa+0>>2]=c[qa+0>>2];c[pa+4>>2]=c[qa+4>>2];c[pa+8>>2]=c[qa+8>>2];vi($a,b,d,e,t);sb=+h[$a>>3];c[oa>>2]=1;qb=+h[(yw(Pa,1,oa)|0)>>3];c[na>>2]=2;ob=+h[(yw(Pa,1,na)|0)>>3];c[ma>>2]=3;pb=+h[(yw(Pa,1,ma)|0)>>3];c[la>>2]=4;rb=+h[(yw(Pa,1,la)|0)>>3];la=ka;h[k>>3]=ob;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+8|0;h[k>>3]=pb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=ka+16|0;h[k>>3]=rb;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];xw(Sa,4,qb,ka);ka=s;la=Sa;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];si(ab,b,d,e,s);qb=+h[ab>>3];c[ja>>2]=1;rb=+h[(yw(Pa,1,ja)|0)>>3];c[ia>>2]=2;pb=+h[(yw(Pa,1,ia)|0)>>3];c[ha>>2]=3;ob=+h[(yw(Pa,1,ha)|0)>>3];c[ga>>2]=4;tb=+h[(yw(Pa,1,ga)|0)>>3];ga=fa;h[k>>3]=pb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=ob;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+16|0;h[k>>3]=tb;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];xw(Ta,4,rb,fa);fa=r;ga=Ta;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];wi(bb,b,d,e,r);rb=+h[bb>>3];c[ea>>2]=1;tb=+h[(yw(Pa,1,ea)|0)>>3];c[da>>2]=2;ob=+h[(yw(Pa,1,da)|0)>>3];c[ca>>2]=3;pb=+h[(yw(Pa,1,ca)|0)>>3];c[ba>>2]=4;ub=+h[(yw(Pa,1,ba)|0)>>3];ba=aa;h[k>>3]=ob;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+8|0;h[k>>3]=pb;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ba=aa+16|0;h[k>>3]=ub;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];xw(Ua,4,tb,aa);aa=q;ba=Ua;c[aa+0>>2]=c[ba+0>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];oi(cb,b,d,e,q);tb=+h[cb>>3];c[$>>2]=1;ub=+h[(yw(Pa,1,$)|0)>>3];c[_>>2]=2;pb=+h[(yw(Pa,1,_)|0)>>3];c[Z>>2]=3;ob=+h[(yw(Pa,1,Z)|0)>>3];c[Y>>2]=4;vb=+h[(yw(Pa,1,Y)|0)>>3];Y=X;h[k>>3]=pb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+8|0;h[k>>3]=ob;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Y=X+16|0;h[k>>3]=vb;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];xw(Va,4,ub,X);X=p;Y=Va;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];zi(db,b,0.0,e,p);ub=sb+(qb+(rb+(tb+ +h[db>>3])))+1.0;c[W>>2]=1;tb=+h[(yw(Pa,1,W)|0)>>3];c[V>>2]=2;rb=+h[(yw(Pa,1,V)|0)>>3];c[U>>2]=3;qb=+h[(yw(Pa,1,U)|0)>>3];c[T>>2]=4;sb=+h[(yw(Pa,1,T)|0)>>3];T=S;h[k>>3]=rb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=qb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+16|0;h[k>>3]=sb;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];xw(Wa,4,tb,S);S=o;T=Wa;c[S+0>>2]=c[T+0>>2];c[S+4>>2]=c[T+4>>2];c[S+8>>2]=c[T+8>>2];vi(eb,b,d,e,o);tb=+h[eb>>3];yi(fb,0,e);sb=+h[fb>>3];c[R>>2]=1;qb=+h[(yw(Pa,1,R)|0)>>3];c[Q>>2]=2;rb=+h[(yw(Pa,1,Q)|0)>>3];c[P>>2]=3;vb=+h[(yw(Pa,1,P)|0)>>3];c[O>>2]=4;ob=+h[(yw(Pa,1,O)|0)>>3];O=N;h[k>>3]=rb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+8|0;h[k>>3]=vb;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=N+16|0;h[k>>3]=ob;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];xw(Xa,4,qb,N);N=n;O=Xa;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];si(gb,b,d,e,n);qb=+h[gb>>3];Ai(hb,0,e);ob=+h[hb>>3];c[M>>2]=1;vb=+h[(yw(Pa,1,M)|0)>>3];c[L>>2]=2;rb=+h[(yw(Pa,1,L)|0)>>3];c[K>>2]=3;pb=+h[(yw(Pa,1,K)|0)>>3];c[J>>2]=4;wb=+h[(yw(Pa,1,J)|0)>>3];J=I;h[k>>3]=rb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+8|0;h[k>>3]=pb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];J=I+16|0;h[k>>3]=wb;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];xw(Ya,4,vb,I);I=m;J=Ya;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];wi(ib,b,d,e,m);vb=+h[ib>>3];xi(jb,0,e);wb=+h[jb>>3];c[H>>2]=1;pb=+h[(yw(Pa,1,H)|0)>>3];c[G>>2]=2;rb=+h[(yw(Pa,1,G)|0)>>3];c[F>>2]=3;xb=+h[(yw(Pa,1,F)|0)>>3];c[E>>2]=4;yb=+h[(yw(Pa,1,E)|0)>>3];E=D;h[k>>3]=rb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=xb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+16|0;h[k>>3]=yb;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];xw(Za,4,pb,D);D=l;E=Za;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];oi(kb,b,d,e,l);d=+h[kb>>3];Ci(lb,0,e);pb=+h[lb>>3];c[C>>2]=1;yb=+h[(yw(Pa,1,C)|0)>>3];c[B>>2]=2;xb=+h[(yw(Pa,1,B)|0)>>3];c[A>>2]=3;rb=+h[(yw(Pa,1,A)|0)>>3];c[z>>2]=4;zb=+h[(yw(Pa,1,z)|0)>>3];z=y;h[k>>3]=xb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=rb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=zb;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];xw(_a,4,yb,y);y=j;z=_a;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];zi(mb,b,0.0,e,j);yb=+h[mb>>3];Bi(nb,0,e);zb=tb*sb*-3302150029884458.0e-20+(qb*ob*-5121166806645226.0e-20+(vb*wb*-3637951105937136.0e-20+(d*pb*-32459312252092.0e-18+yb*+h[nb>>3]*-9112779762338704.0e-20)));c[x>>2]=1;yb=+h[(yw(Oa,1,x)|0)>>3]/.018015257;c[w>>2]=2;pb=+h[(yw(Oa,1,w)|0)>>3]/.02801348;c[v>>2]=3;d=+h[(yw(Oa,1,v)|0)>>3]/.0319988;c[u>>2]=4;h[a>>3]=-(e*e*zb*((yb+(pb+(d+ +h[(yw(Oa,1,u)|0)>>3]/.039948)))/ub));i=g;return}function Hi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(yw(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(yw(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];xw(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Di(d,b,o,p,f);i=e;return}function Ii(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;sw(u,1,n);c[m>>2]=2;sw(u,1,m);if((kv(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];uh(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +Aw(f);xw(q,1,w,l);c[k>>2]=q;zw(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];uh(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];tw(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function Ji(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;g=i;i=i+24|0;j=g;k=g+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[m>>2]=1;if(+h[(yw(f,1,m)|0)>>3]==0.0){ch(n,b,d,e);y=+h[n>>3];z=a;A=z;h[A>>3]=y;i=g;return}c[l>>2]=1;B=+h[(yw(f,1,l)|0)>>3];c[k>>2]=1;C=B/(1.0- +h[(yw(f,1,k)|0)>>3]);Fi(o,b,d,e);B=+h[o>>3];o=j;k=f;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];Ei(p,b,d,e,j);D=+h[p>>3];E=d-D;p=e<273.16;if(C<=B|B==-1.0){if(p){ch(q,b,E,e);y=+h[q>>3]+D/(e*461.51805);z=a;A=z;h[A>>3]=y;i=g;return}else{ch(r,b,E,e);F=+h[r>>3];ii(s,b,D,e);y=F+ +h[s>>3];z=a;A=z;h[A>>3]=y;i=g;return}}else{if(p){ch(t,b,E,e);F=+h[t>>3];ui(u,b,d,e);y=(C+1.0)/((B+1.0)/(F+D/(e*461.51805))+(C-B)/+h[u>>3]);z=a;A=z;h[A>>3]=y;i=g;return}else{ch(v,b,E,e);E=+h[v>>3];ii(w,b,D,e);D=+h[w>>3];Yh(x,b,d,e,0);y=(C+1.0)/((B+1.0)/(E+D)+(C-B)/+h[x>>3]);z=a;A=z;h[A>>3]=y;i=g;return}}}function Ki(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;c[l>>2]=1;if(+h[(yw(f,1,l)|0)>>3]==0.0){p=0.0;q=a;r=q;h[r>>3]=p;i=g;return}c[k>>2]=1;s=+h[(yw(f,1,k)|0)>>3];c[j>>2]=1;t=s/(1.0- +h[(yw(f,1,j)|0)>>3]);if(!(e>=273.16)){rh(n,0,e);u=+h[n>>3]}else{_h(m,b,e);u=+h[m>>3]}ni(o,0,0.0,0.0);e=u*+h[o>>3];u=t*(d/(t+.6221042453709779));if(!(u<=e)){p=-1.0;q=a;r=q;h[r>>3]=p;i=g;return}p=u/e;q=a;r=q;h[r>>3]=p;i=g;return}function Li(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Ii(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];Hi(j,b,h);i=g;return}function Mi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;g=i;i=i+24|0;j=g;k=g+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[m>>2]=1;if(+h[(yw(f,1,m)|0)>>3]==0.0){ch(n,b,d,e);y=+h[n>>3];z=a;A=z;h[A>>3]=y;i=g;return}c[l>>2]=1;B=+h[(yw(f,1,l)|0)>>3];c[k>>2]=1;C=B/(1.0- +h[(yw(f,1,k)|0)>>3]);Ni(o,b,d,e);B=+h[o>>3];o=j;k=f;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];Oi(p,b,d,e,j);D=+h[p>>3];E=d-D;p=e<273.16;if(C<=B|B==-1.0){if(p){ch(q,b,E,e);y=+h[q>>3]+D/(e*461.51805);z=a;A=z;h[A>>3]=y;i=g;return}else{ch(r,b,E,e);F=+h[r>>3];Pi(s,b,D,e);y=F+ +h[s>>3];z=a;A=z;h[A>>3]=y;i=g;return}}else{if(p){ch(t,b,E,e);F=+h[t>>3];Qi(u,b,d,e);y=(C+1.0)/((B+1.0)/(F+D/(e*461.51805))+(C-B)/+h[u>>3]);z=a;A=z;h[A>>3]=y;i=g;return}else{ch(v,b,E,e);E=+h[v>>3];Pi(w,b,D,e);D=+h[w>>3];Yh(x,b,d,e,0);y=(C+1.0)/((B+1.0)/(E+D)+(C-B)/+h[x>>3]);z=a;A=z;h[A>>3]=y;i=g;return}}}function Ni(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0;e=i;i=i+24|0;f=e;g=e+8|0;j=e+16|0;Jj(f,b,c,d);k=+h[f>>3];if(!(d<=273.16)){Bj(j,b,c);l=+h[j>>3]}else{gj(g,b,c);l=+h[g>>3]}if(!(l>=d)){m=-1.0;n=a;o=n;h[o>>3]=m;i=e;return}m=k/(c-k)*.6221042453709779;n=a;o=n;h[o>>3]=m;i=e;return}function Oi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0;g=i;i=i+8|0;j=g;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;c[l>>2]=1;if(+h[(yw(f,1,l)|0)>>3]==0.0){o=0.0;p=a;q=p;h[q>>3]=o;i=g;return}c[k>>2]=1;r=+h[(yw(f,1,k)|0)>>3];c[j>>2]=1;s=r/(1.0- +h[(yw(f,1,j)|0)>>3]);Jj(m,b,d,e);r=+h[m>>3];Ni(n,b,d,e);e=+h[n>>3];o=s<=e|e==-1.0?s*(d/(s+.6221042453709779)):r;p=a;q=p;h[q>>3]=o;i=g;return}function Pi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0;e=i;i=i+88|0;f=e;Ui(f,b,c,d);h[a>>3]=c/(+h[f+16>>3]*+h[f+24>>3]*+h[f+48>>3]*d);i=e;return}function Qi(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,h=0,j=0;f=i;i=i+192|0;g=f;h=f+96|0;dj(h,b,d,e);b=a;a=g+0|0;j=h+0|0;h=a+96|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));ej(b,0,0.0,0.0,g);i=f;return}function Ri(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;c[n>>2]=2;d=+h[(yw(f,1,n)|0)>>3];c[m>>2]=3;o=d*+h[(yw(f,1,m)|0)>>3];if(o>=0.0){p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}m=c[22536]|0;f=l;h[k>>3]=o;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];f=m;m=j;n=7728;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];De[f&31](b,j,5232,l);p=-10973.6/e;q=+ca(+p);r=+V(+o);s=q*r;t=s*4.5542;u=a;v=u;h[v>>3]=t;i=g;return}function Si(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0;b=i;i=i+16|0;e=b;f=+h[d>>3];g=+h[d+8>>3];j=+h[c>>3];k=+h[c+8>>3];l=f*f+g*g;Ti(e,0,(f*j+g*k)/l,(f*k-g*j)/l);l=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=l;i=b;return}function Ti(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function _omc_Modelica_Media_Examples_Tests_Components_FixedMassFlowRate_Medium_Utilities_Ice09__Utilities_Basic_Gibbs$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0;b=c[a+2608>>2]|0;d=c[a+2616>>2]|0;e=+g[a+2624>>2];f=+g[a+2632>>2];j=c[a+2736>>2]|0;k=c[a+2752>>2]|0;l=c[a+2760>>2]|0;m=c[a+2768>>2]|0;n=c[a+2784>>2]|0;o=c[a+2800>>2]|0;p=c[a+2824>>2]|0;q=c[a+2840>>2]|0;r=c[a+2872>>2]|0;s=c[a+2888>>2]|0;t=+g[a+3288>>2];u=+g[a+3768>>2];v=+g[a+3784>>2];w=+g[a+3800>>2];x=c[a+3856>>2]|0;y=c[a+3864>>2]|0;z=c[a+3872>>2]|0;A=c[a+3880>>2]|0;B=c[a+3896>>2]|0;C=c[a+3904>>2]|0;D=c[a+3912>>2]|0;E=c[a+3920>>2]|0;F=c[a+3928>>2]|0;G=c[a+3936>>2]|0;H=c[a+3944>>2]|0;I=c[a+3952>>2]|0;J=c[a+3968>>2]|0;K=c[a+3976>>2]|0;L=c[a+3984>>2]|0;M=c[a+3992>>2]|0;N=c[a+4e3>>2]|0;O=c[a+4008>>2]|0;P=c[a+4016>>2]|0;Q=c[a+4032>>2]|0;R=c[a+4040>>2]|0;S=c[a+4048>>2]|0;T=c[a+4056>>2]|0;U=c[a+4064>>2]|0;V=c[a+4072>>2]|0;W=c[a+4080>>2]|0;X=c[a+4088>>2]|0;Y=c[a+4096>>2]|0;Z=c[a+4104>>2]|0;_=c[a+4112>>2]|0;$=c[a+4120>>2]|0;aa=c[a+4128>>2]|0;ba=c[a+4136>>2]|0;ca=c[a+4144>>2]|0;da=c[a+4152>>2]|0;ea=c[a+4160>>2]|0;fa=c[a+4168>>2]|0;ga=c[a+4176>>2]|0;ha=c[a+4184>>2]|0;ia=c[a+4192>>2]|0;ja=c[a+4200>>2]|0;ka=c[a+4208>>2]|0;la=c[a+4216>>2]|0;ma=c[a+4224>>2]|0;na=c[a+4232>>2]|0;oa=c[a+4240>>2]|0;pa=c[a+4248>>2]|0;qa=c[a+4256>>2]|0;ra=c[a+4264>>2]|0;sa=c[a+4272>>2]|0;ta=c[a+4280>>2]|0;ua=c[a+4288>>2]|0;va=c[a+4296>>2]|0;wa=c[a+4304>>2]|0;xa=c[a+4312>>2]|0;ya=c[a+4320>>2]|0;za=c[a+4328>>2]|0;Aa=c[a+4336>>2]|0;Ba=c[a+4344>>2]|0;Ca=c[a+4352>>2]|0;Da=c[a+4360>>2]|0;Ea=c[a+4368>>2]|0;Fa=c[a+4376>>2]|0;Ga=c[a+4384>>2]|0;Ha=c[a+4392>>2]|0;Ia=c[a+4400>>2]|0;Ja=c[a+4408>>2]|0;Ka=c[a+4416>>2]|0;La=c[a+4704>>2]|0;Ma=c[a+4712>>2]|0;Na=c[a+4720>>2]|0;Oa=c[a+4728>>2]|0;Pa=c[a+4736>>2]|0;Qa=c[a+4744>>2]|0;Ra=c[a+4752>>2]|0;Sa=c[a+4760>>2]|0;Ta=c[a+4944>>2]|0;Ua=c[a+4952>>2]|0;Va=c[a+4960>>2]|0;Wa=c[a+4968>>2]|0;Xa=c[a+4976>>2]|0;Ya=c[a+4984>>2]|0;Za=c[a+4992>>2]|0;_a=c[a+5e3>>2]|0;$a=c[a+5008>>2]|0;ab=c[a+5016>>2]|0;bb=c[a+5032>>2]|0;cb=c[a+5040>>2]|0;db=c[a+5048>>2]|0;eb=c[a+5056>>2]|0;fb=c[a+5064>>2]|0;gb=c[a+5072>>2]|0;hb=c[a+5080>>2]|0;ib=c[a+5088>>2]|0;jb=c[a+5096>>2]|0;kb=c[a+5104>>2]|0;lb=c[a+5120>>2]|0;mb=c[a+5128>>2]|0;nb=c[a+5136>>2]|0;ob=c[a+5144>>2]|0;pb=c[a+5152>>2]|0;qb=c[a+5160>>2]|0;rb=c[a+5168>>2]|0;sb=c[a+5176>>2]|0;tb=c[a+5184>>2]|0;ub=c[a+5192>>2]|0;vb=c[a+5208>>2]|0;wb=c[a+5216>>2]|0;xb=c[a+5224>>2]|0;yb=c[a+5232>>2]|0;zb=c[a+5240>>2]|0;Ab=c[a+5248>>2]|0;Bb=c[a+5256>>2]|0;a:do{Cb=(Dv(x,16,1,Ta)|0)+8|0;h[Cb>>3]=t;c[Ua>>2]=1;Cb=Dv(x,16,1,Ua)|0;c[Va>>2]=2;Db=Dv(x,16,1,Va)|0;c[(a+1680|0)+0>>2]=c[Cb+0>>2];c[(a+1680|0)+4>>2]=c[Cb+4>>2];c[(a+1680|0)+8>>2]=c[Cb+8>>2];c[(a+1680|0)+12>>2]=c[Cb+12>>2];c[(a+1664|0)+0>>2]=c[Db+0>>2];c[(a+1664|0)+4>>2]=c[Db+4>>2];c[(a+1664|0)+8>>2]=c[Db+8>>2];c[(a+1664|0)+12>>2]=c[Db+12>>2];di(La,0,a+1680|0,a+1664|0);c[Wa>>2]=5;Db=Dv(x,16,1,Wa)|0;c[(a+1648|0)+0>>2]=c[La+0>>2];c[(a+1648|0)+4>>2]=c[La+4>>2];c[(a+1648|0)+8>>2]=c[La+8>>2];c[(a+1648|0)+12>>2]=c[La+12>>2];c[(a+1632|0)+0>>2]=c[Db+0>>2];c[(a+1632|0)+4>>2]=c[Db+4>>2];c[(a+1632|0)+8>>2]=c[Db+8>>2];c[(a+1632|0)+12>>2]=c[Db+12>>2];fi(Ma,0,a+1648|0,a+1632|0);c[Xa>>2]=7;Db=Dv(x,16,1,Xa)|0;c[(a+1616|0)+0>>2]=c[Ma+0>>2];c[(a+1616|0)+4>>2]=c[Ma+4>>2];c[(a+1616|0)+8>>2]=c[Ma+8>>2];c[(a+1616|0)+12>>2]=c[Ma+12>>2];c[(a+1600|0)+0>>2]=c[Db+0>>2];c[(a+1600|0)+4>>2]=c[Db+4>>2];c[(a+1600|0)+8>>2]=c[Db+8>>2];c[(a+1600|0)+12>>2]=c[Db+12>>2];fi(j,0,a+1616|0,a+1600|0);Eb=+h[j>>3];Fb=+h[j+8>>3];c[Ya>>2]=9;Db=Dv(x,16,1,Ya)|0;h[Db>>3]=Eb;c[Za>>2]=9;Db=(Dv(x,16,1,Za)|0)+8|0;h[Db>>3]=Fb;c[_a>>2]=3;Db=Dv(x,16,1,_a)|0;c[$a>>2]=4;Cb=Dv(x,16,1,$a)|0;c[(a+1584|0)+0>>2]=c[Db+0>>2];c[(a+1584|0)+4>>2]=c[Db+4>>2];c[(a+1584|0)+8>>2]=c[Db+8>>2];c[(a+1584|0)+12>>2]=c[Db+12>>2];c[(a+1568|0)+0>>2]=c[Cb+0>>2];c[(a+1568|0)+4>>2]=c[Cb+4>>2];c[(a+1568|0)+8>>2]=c[Cb+8>>2];c[(a+1568|0)+12>>2]=c[Cb+12>>2];di(Na,0,a+1584|0,a+1568|0);c[ab>>2]=6;Cb=Dv(x,16,1,ab)|0;c[(a+1552|0)+0>>2]=c[Na+0>>2];c[(a+1552|0)+4>>2]=c[Na+4>>2];c[(a+1552|0)+8>>2]=c[Na+8>>2];c[(a+1552|0)+12>>2]=c[Na+12>>2];c[(a+1536|0)+0>>2]=c[Cb+0>>2];c[(a+1536|0)+4>>2]=c[Cb+4>>2];c[(a+1536|0)+8>>2]=c[Cb+8>>2];c[(a+1536|0)+12>>2]=c[Cb+12>>2];fi(Oa,0,a+1552|0,a+1536|0);c[bb>>2]=8;Cb=Dv(x,16,1,bb)|0;c[(a+1520|0)+0>>2]=c[Oa+0>>2];c[(a+1520|0)+4>>2]=c[Oa+4>>2];c[(a+1520|0)+8>>2]=c[Oa+8>>2];c[(a+1520|0)+12>>2]=c[Oa+12>>2];c[(a+1504|0)+0>>2]=c[Cb+0>>2];c[(a+1504|0)+4>>2]=c[Cb+4>>2];c[(a+1504|0)+8>>2]=c[Cb+8>>2];c[(a+1504|0)+12>>2]=c[Cb+12>>2];fi(k,0,a+1520|0,a+1504|0);Fb=+h[k>>3];Eb=+h[k+8>>3];c[cb>>2]=10;Cb=Dv(x,16,1,cb)|0;h[Cb>>3]=Fb;c[db>>2]=10;Cb=(Dv(x,16,1,db)|0)+8|0;h[Cb>>3]=Eb;h[Pa>>3]=44.7050716285388;h[Pa+8>>3]=65.6876847463481;c[eb>>2]=9;Cb=Dv(x,16,1,eb)|0;c[(a+1488|0)+0>>2]=c[Pa+0>>2];c[(a+1488|0)+4>>2]=c[Pa+4>>2];c[(a+1488|0)+8>>2]=c[Pa+8>>2];c[(a+1488|0)+12>>2]=c[Pa+12>>2];c[(a+1472|0)+0>>2]=c[Cb+0>>2];c[(a+1472|0)+4>>2]=c[Cb+4>>2];c[(a+1472|0)+8>>2]=c[Cb+8>>2];c[(a+1472|0)+12>>2]=c[Cb+12>>2];ci(Qa,0,a+1488|0,a+1472|0);c[fb>>2]=10;Cb=Dv(x,16,1,fb)|0;c[(a+1456|0)+0>>2]=c[y+0>>2];c[(a+1456|0)+4>>2]=c[y+4>>2];c[(a+1456|0)+8>>2]=c[y+8>>2];c[(a+1456|0)+12>>2]=c[y+12>>2];c[(a+1440|0)+0>>2]=c[Cb+0>>2];c[(a+1440|0)+4>>2]=c[Cb+4>>2];c[(a+1440|0)+8>>2]=c[Cb+8>>2];c[(a+1440|0)+12>>2]=c[Cb+12>>2];ci(Ra,0,a+1456|0,a+1440|0);c[(a+1424|0)+0>>2]=c[Qa+0>>2];c[(a+1424|0)+4>>2]=c[Qa+4>>2];c[(a+1424|0)+8>>2]=c[Qa+8>>2];c[(a+1424|0)+12>>2]=c[Qa+12>>2];c[(a+1408|0)+0>>2]=c[Ra+0>>2];c[(a+1408|0)+4>>2]=c[Ra+4>>2];c[(a+1408|0)+8>>2]=c[Ra+8>>2];c[(a+1408|0)+12>>2]=c[Ra+12>>2];di(Sa,0,a+1424|0,a+1408|0);c[(a+1392|0)+0>>2]=c[Sa+0>>2];c[(a+1392|0)+4>>2]=c[Sa+4>>2];c[(a+1392|0)+8>>2]=c[Sa+8>>2];c[(a+1392|0)+12>>2]=c[Sa+12>>2];hi(l,0,a+1392|0);Eb=u+(f/273.16*908895.5292340062+ +h[l>>3]*273.16);c[gb>>2]=10;Cb=Dv(x,16,1,gb)|0;c[(a+1376|0)+0>>2]=c[z+0>>2];c[(a+1376|0)+4>>2]=c[z+4>>2];c[(a+1376|0)+8>>2]=c[z+8>>2];c[(a+1376|0)+12>>2]=c[z+12>>2];c[(a+1360|0)+0>>2]=c[Cb+0>>2];c[(a+1360|0)+4>>2]=c[Cb+4>>2];c[(a+1360|0)+8>>2]=c[Cb+8>>2];c[(a+1360|0)+12>>2]=c[Cb+12>>2];ci(C,0,a+1376|0,a+1360|0);c[(a+1344|0)+0>>2]=c[C+0>>2];c[(a+1344|0)+4>>2]=c[C+4>>2];c[(a+1344|0)+8>>2]=c[C+8>>2];c[(a+1344|0)+12>>2]=c[C+12>>2];hi(m,0,a+1344|0);Fb=v+ +h[m>>3]*273.16;c[hb>>2]=10;Cb=Dv(x,16,1,hb)|0;c[(a+1328|0)+0>>2]=c[A+0>>2];c[(a+1328|0)+4>>2]=c[A+4>>2];c[(a+1328|0)+8>>2]=c[A+8>>2];c[(a+1328|0)+12>>2]=c[A+12>>2];c[(a+1312|0)+0>>2]=c[Cb+0>>2];c[(a+1312|0)+4>>2]=c[Cb+4>>2];c[(a+1312|0)+8>>2]=c[Cb+8>>2];c[(a+1312|0)+12>>2]=c[Cb+12>>2];ci(D,0,a+1328|0,a+1312|0);c[(a+1296|0)+0>>2]=c[D+0>>2];c[(a+1296|0)+4>>2]=c[D+4>>2];c[(a+1296|0)+8>>2]=c[D+8>>2];c[(a+1296|0)+12>>2]=c[D+12>>2];hi(n,0,a+1296|0);Gb=w+ +h[n>>3]*273.16;bi(E,0,f/273.16,0.0);c[ib>>2]=1;Cb=Dv(B,16,1,ib)|0;c[(a+1280|0)+0>>2]=c[Cb+0>>2];c[(a+1280|0)+4>>2]=c[Cb+4>>2];c[(a+1280|0)+8>>2]=c[Cb+8>>2];c[(a+1280|0)+12>>2]=c[Cb+12>>2];c[(a+1264|0)+0>>2]=c[E+0>>2];c[(a+1264|0)+4>>2]=c[E+4>>2];c[(a+1264|0)+8>>2]=c[E+8>>2];c[(a+1264|0)+12>>2]=c[E+12>>2];di(F,0,a+1280|0,a+1264|0);c[(a+1248|0)+0>>2]=c[F+0>>2];c[(a+1248|0)+4>>2]=c[F+4>>2];c[(a+1248|0)+8>>2]=c[F+8>>2];c[(a+1248|0)+12>>2]=c[F+12>>2];gi(G,d,a+1248|0);bi(H,0,f/273.16*2.0,0.0);c[jb>>2]=1;Cb=Dv(B,16,1,jb)|0;c[(a+1232|0)+0>>2]=c[H+0>>2];c[(a+1232|0)+4>>2]=c[H+4>>2];c[(a+1232|0)+8>>2]=c[H+8>>2];c[(a+1232|0)+12>>2]=c[H+12>>2];c[(a+1216|0)+0>>2]=c[Cb+0>>2];c[(a+1216|0)+4>>2]=c[Cb+4>>2];c[(a+1216|0)+8>>2]=c[Cb+8>>2];c[(a+1216|0)+12>>2]=c[Cb+12>>2];ei(I,0,a+1232|0,a+1216|0);c[(a+1200|0)+0>>2]=c[G+0>>2];c[(a+1200|0)+4>>2]=c[G+4>>2];c[(a+1200|0)+8>>2]=c[G+8>>2];c[(a+1200|0)+12>>2]=c[G+12>>2];c[(a+1184|0)+0>>2]=c[I+0>>2];c[(a+1184|0)+4>>2]=c[I+4>>2];c[(a+1184|0)+8>>2]=c[I+8>>2];c[(a+1184|0)+12>>2]=c[I+12>>2];fi(J,0,a+1200|0,a+1184|0);bi(K,0,f/273.16,0.0);c[kb>>2]=1;Cb=Dv(B,16,1,kb)|0;c[(a+1168|0)+0>>2]=c[Cb+0>>2];c[(a+1168|0)+4>>2]=c[Cb+4>>2];c[(a+1168|0)+8>>2]=c[Cb+8>>2];c[(a+1168|0)+12>>2]=c[Cb+12>>2];c[(a+1152|0)+0>>2]=c[K+0>>2];c[(a+1152|0)+4>>2]=c[K+4>>2];c[(a+1152|0)+8>>2]=c[K+8>>2];c[(a+1152|0)+12>>2]=c[K+12>>2];fi(L,0,a+1168|0,a+1152|0);c[(a+1136|0)+0>>2]=c[L+0>>2];c[(a+1136|0)+4>>2]=c[L+4>>2];c[(a+1136|0)+8>>2]=c[L+8>>2];c[(a+1136|0)+12>>2]=c[L+12>>2];gi(M,d,a+1136|0);c[(a+1120|0)+0>>2]=c[J+0>>2];c[(a+1120|0)+4>>2]=c[J+4>>2];c[(a+1120|0)+8>>2]=c[J+8>>2];c[(a+1120|0)+12>>2]=c[J+12>>2];c[(a+1104|0)+0>>2]=c[M+0>>2];c[(a+1104|0)+4>>2]=c[M+4>>2];c[(a+1104|0)+8>>2]=c[M+8>>2];c[(a+1104|0)+12>>2]=c[M+12>>2];fi(o,0,a+1120|0,a+1104|0);Hb=+h[o>>3];Ib=+h[o+8>>3];c[lb>>2]=11;Cb=Dv(x,16,1,lb)|0;h[Cb>>3]=Hb;c[mb>>2]=11;Cb=(Dv(x,16,1,mb)|0)+8|0;h[Cb>>3]=Ib;bi(N,0,f/273.16,0.0);c[nb>>2]=2;Cb=Dv(B,16,1,nb)|0;c[(a+1088|0)+0>>2]=c[Cb+0>>2];c[(a+1088|0)+4>>2]=c[Cb+4>>2];c[(a+1088|0)+8>>2]=c[Cb+8>>2];c[(a+1088|0)+12>>2]=c[Cb+12>>2];c[(a+1072|0)+0>>2]=c[N+0>>2];c[(a+1072|0)+4>>2]=c[N+4>>2];c[(a+1072|0)+8>>2]=c[N+8>>2];c[(a+1072|0)+12>>2]=c[N+12>>2];di(O,0,a+1088|0,a+1072|0);c[(a+1056|0)+0>>2]=c[O+0>>2];c[(a+1056|0)+4>>2]=c[O+4>>2];c[(a+1056|0)+8>>2]=c[O+8>>2];c[(a+1056|0)+12>>2]=c[O+12>>2];gi(P,d,a+1056|0);bi(Q,0,f/273.16,0.0);c[ob>>2]=2;Cb=Dv(B,16,1,ob)|0;c[(a+1040|0)+0>>2]=c[Cb+0>>2];c[(a+1040|0)+4>>2]=c[Cb+4>>2];c[(a+1040|0)+8>>2]=c[Cb+8>>2];c[(a+1040|0)+12>>2]=c[Cb+12>>2];c[(a+1024|0)+0>>2]=c[Q+0>>2];c[(a+1024|0)+4>>2]=c[Q+4>>2];c[(a+1024|0)+8>>2]=c[Q+8>>2];c[(a+1024|0)+12>>2]=c[Q+12>>2];fi(R,0,a+1040|0,a+1024|0);c[(a+1008|0)+0>>2]=c[R+0>>2];c[(a+1008|0)+4>>2]=c[R+4>>2];c[(a+1008|0)+8>>2]=c[R+8>>2];c[(a+1008|0)+12>>2]=c[R+12>>2];gi(S,d,a+1008|0);c[(a+992|0)+0>>2]=c[P+0>>2];c[(a+992|0)+4>>2]=c[P+4>>2];c[(a+992|0)+8>>2]=c[P+8>>2];c[(a+992|0)+12>>2]=c[P+12>>2];c[(a+976|0)+0>>2]=c[S+0>>2];c[(a+976|0)+4>>2]=c[S+4>>2];c[(a+976|0)+8>>2]=c[S+8>>2];c[(a+976|0)+12>>2]=c[S+12>>2];fi(T,0,a+992|0,a+976|0);bi(U,0,f/273.16*2.0,0.0);c[pb>>2]=2;Cb=Dv(B,16,1,pb)|0;c[(a+960|0)+0>>2]=c[U+0>>2];c[(a+960|0)+4>>2]=c[U+4>>2];c[(a+960|0)+8>>2]=c[U+8>>2];c[(a+960|0)+12>>2]=c[U+12>>2];c[(a+944|0)+0>>2]=c[Cb+0>>2];c[(a+944|0)+4>>2]=c[Cb+4>>2];c[(a+944|0)+8>>2]=c[Cb+8>>2];c[(a+944|0)+12>>2]=c[Cb+12>>2];ei(V,0,a+960|0,a+944|0);c[(a+928|0)+0>>2]=c[T+0>>2];c[(a+928|0)+4>>2]=c[T+4>>2];c[(a+928|0)+8>>2]=c[T+8>>2];c[(a+928|0)+12>>2]=c[T+12>>2];c[(a+912|0)+0>>2]=c[V+0>>2];c[(a+912|0)+4>>2]=c[V+4>>2];c[(a+912|0)+8>>2]=c[V+8>>2];c[(a+912|0)+12>>2]=c[V+12>>2];fi(p,0,a+928|0,a+912|0);Ib=+h[p>>3];Hb=+h[p+8>>3];c[qb>>2]=12;Cb=Dv(x,16,1,qb)|0;h[Cb>>3]=Ib;c[rb>>2]=12;Cb=(Dv(x,16,1,rb)|0)+8|0;h[Cb>>3]=Hb;h[W>>3]=44.7050716285388;h[W+8>>3]=65.6876847463481;c[sb>>2]=11;Cb=Dv(x,16,1,sb)|0;c[(a+896|0)+0>>2]=c[W+0>>2];c[(a+896|0)+4>>2]=c[W+4>>2];c[(a+896|0)+8>>2]=c[W+8>>2];c[(a+896|0)+12>>2]=c[W+12>>2];c[(a+880|0)+0>>2]=c[Cb+0>>2];c[(a+880|0)+4>>2]=c[Cb+4>>2];c[(a+880|0)+8>>2]=c[Cb+8>>2];c[(a+880|0)+12>>2]=c[Cb+12>>2];ci(X,0,a+896|0,a+880|0);c[tb>>2]=12;Cb=Dv(x,16,1,tb)|0;c[(a+864|0)+0>>2]=c[y+0>>2];c[(a+864|0)+4>>2]=c[y+4>>2];c[(a+864|0)+8>>2]=c[y+8>>2];c[(a+864|0)+12>>2]=c[y+12>>2];c[(a+848|0)+0>>2]=c[Cb+0>>2];c[(a+848|0)+4>>2]=c[Cb+4>>2];c[(a+848|0)+8>>2]=c[Cb+8>>2];c[(a+848|0)+12>>2]=c[Cb+12>>2];ci(Y,0,a+864|0,a+848|0);c[(a+832|0)+0>>2]=c[X+0>>2];c[(a+832|0)+4>>2]=c[X+4>>2];c[(a+832|0)+8>>2]=c[X+8>>2];c[(a+832|0)+12>>2]=c[X+12>>2];c[(a+816|0)+0>>2]=c[Y+0>>2];c[(a+816|0)+4>>2]=c[Y+4>>2];c[(a+816|0)+8>>2]=c[Y+8>>2];c[(a+816|0)+12>>2]=c[Y+12>>2];di(Z,0,a+832|0,a+816|0);c[(a+800|0)+0>>2]=c[Z+0>>2];c[(a+800|0)+4>>2]=c[Z+4>>2];c[(a+800|0)+8>>2]=c[Z+8>>2];c[(a+800|0)+12>>2]=c[Z+12>>2];hi(q,0,a+800|0);Hb=+h[q>>3]+3327.33756492168;h[_>>3]=44.7050716285388;h[_+8>>3]=65.6876847463481;bi($,0,1.0,0.0);bi(aa,0,f/273.16,0.0);c[ub>>2]=1;Cb=Dv(B,16,1,ub)|0;c[(a+784|0)+0>>2]=c[Cb+0>>2];c[(a+784|0)+4>>2]=c[Cb+4>>2];c[(a+784|0)+8>>2]=c[Cb+8>>2];c[(a+784|0)+12>>2]=c[Cb+12>>2];c[(a+768|0)+0>>2]=c[aa+0>>2];c[(a+768|0)+4>>2]=c[aa+4>>2];c[(a+768|0)+8>>2]=c[aa+8>>2];c[(a+768|0)+12>>2]=c[aa+12>>2];fi(ba,0,a+784|0,a+768|0);c[(a+752|0)+0>>2]=c[$+0>>2];c[(a+752|0)+4>>2]=c[$+4>>2];c[(a+752|0)+8>>2]=c[$+8>>2];c[(a+752|0)+12>>2]=c[$+12>>2];c[(a+736|0)+0>>2]=c[ba+0>>2];c[(a+736|0)+4>>2]=c[ba+4>>2];c[(a+736|0)+8>>2]=c[ba+8>>2];c[(a+736|0)+12>>2]=c[ba+12>>2];ei(ca,0,a+752|0,a+736|0);bi(da,0,1.0,0.0);bi(ea,0,f/273.16,0.0);c[vb>>2]=1;Cb=Dv(B,16,1,vb)|0;c[(a+720|0)+0>>2]=c[Cb+0>>2];c[(a+720|0)+4>>2]=c[Cb+4>>2];c[(a+720|0)+8>>2]=c[Cb+8>>2];c[(a+720|0)+12>>2]=c[Cb+12>>2];c[(a+704|0)+0>>2]=c[ea+0>>2];c[(a+704|0)+4>>2]=c[ea+4>>2];c[(a+704|0)+8>>2]=c[ea+8>>2];c[(a+704|0)+12>>2]=c[ea+12>>2];di(fa,0,a+720|0,a+704|0);c[(a+688|0)+0>>2]=c[da+0>>2];c[(a+688|0)+4>>2]=c[da+4>>2];c[(a+688|0)+8>>2]=c[da+8>>2];c[(a+688|0)+12>>2]=c[da+12>>2];c[(a+672|0)+0>>2]=c[fa+0>>2];c[(a+672|0)+4>>2]=c[fa+4>>2];c[(a+672|0)+8>>2]=c[fa+8>>2];c[(a+672|0)+12>>2]=c[fa+12>>2];ei(ga,0,a+688|0,a+672|0);c[(a+656|0)+0>>2]=c[ca+0>>2];c[(a+656|0)+4>>2]=c[ca+4>>2];c[(a+656|0)+8>>2]=c[ca+8>>2];c[(a+656|0)+12>>2]=c[ca+12>>2];c[(a+640|0)+0>>2]=c[ga+0>>2];c[(a+640|0)+4>>2]=c[ga+4>>2];c[(a+640|0)+8>>2]=c[ga+8>>2];c[(a+640|0)+12>>2]=c[ga+12>>2];di(ha,0,a+656|0,a+640|0);bi(ia,0,2.0,0.0);c[wb>>2]=1;Cb=Dv(B,16,1,wb)|0;c[(a+624|0)+0>>2]=c[ia+0>>2];c[(a+624|0)+4>>2]=c[ia+4>>2];c[(a+624|0)+8>>2]=c[ia+8>>2];c[(a+624|0)+12>>2]=c[ia+12>>2];c[(a+608|0)+0>>2]=c[Cb+0>>2];c[(a+608|0)+4>>2]=c[Cb+4>>2];c[(a+608|0)+8>>2]=c[Cb+8>>2];c[(a+608|0)+12>>2]=c[Cb+12>>2];ei(ja,0,a+624|0,a+608|0);c[(a+592|0)+0>>2]=c[ha+0>>2];c[(a+592|0)+4>>2]=c[ha+4>>2];c[(a+592|0)+8>>2]=c[ha+8>>2];c[(a+592|0)+12>>2]=c[ha+12>>2];c[(a+576|0)+0>>2]=c[ja+0>>2];c[(a+576|0)+4>>2]=c[ja+4>>2];c[(a+576|0)+8>>2]=c[ja+8>>2];c[(a+576|0)+12>>2]=c[ja+12>>2];fi(ka,0,a+592|0,a+576|0);c[(a+560|0)+0>>2]=c[_+0>>2];c[(a+560|0)+4>>2]=c[_+4>>2];c[(a+560|0)+8>>2]=c[_+8>>2];c[(a+560|0)+12>>2]=c[_+12>>2];c[(a+544|0)+0>>2]=c[ka+0>>2];c[(a+544|0)+4>>2]=c[ka+4>>2];c[(a+544|0)+8>>2]=c[ka+8>>2];c[(a+544|0)+12>>2]=c[ka+12>>2];ci(la,0,a+560|0,a+544|0);bi(ma,0,1.0,0.0);bi(na,0,f/273.16,0.0);c[xb>>2]=2;Cb=Dv(B,16,1,xb)|0;c[(a+528|0)+0>>2]=c[Cb+0>>2];c[(a+528|0)+4>>2]=c[Cb+4>>2];c[(a+528|0)+8>>2]=c[Cb+8>>2];c[(a+528|0)+12>>2]=c[Cb+12>>2];c[(a+512|0)+0>>2]=c[na+0>>2];c[(a+512|0)+4>>2]=c[na+4>>2];c[(a+512|0)+8>>2]=c[na+8>>2];c[(a+512|0)+12>>2]=c[na+12>>2];fi(oa,0,a+528|0,a+512|0);c[(a+496|0)+0>>2]=c[ma+0>>2];c[(a+496|0)+4>>2]=c[ma+4>>2];c[(a+496|0)+8>>2]=c[ma+8>>2];c[(a+496|0)+12>>2]=c[ma+12>>2];c[(a+480|0)+0>>2]=c[oa+0>>2];c[(a+480|0)+4>>2]=c[oa+4>>2];c[(a+480|0)+8>>2]=c[oa+8>>2];c[(a+480|0)+12>>2]=c[oa+12>>2];ei(pa,0,a+496|0,a+480|0);bi(qa,0,1.0,0.0);bi(ra,0,f/273.16,0.0);c[yb>>2]=2;Cb=Dv(B,16,1,yb)|0;c[(a+464|0)+0>>2]=c[Cb+0>>2];c[(a+464|0)+4>>2]=c[Cb+4>>2];c[(a+464|0)+8>>2]=c[Cb+8>>2];c[(a+464|0)+12>>2]=c[Cb+12>>2];c[(a+448|0)+0>>2]=c[ra+0>>2];c[(a+448|0)+4>>2]=c[ra+4>>2];c[(a+448|0)+8>>2]=c[ra+8>>2];c[(a+448|0)+12>>2]=c[ra+12>>2];di(sa,0,a+464|0,a+448|0);c[(a+432|0)+0>>2]=c[qa+0>>2];c[(a+432|0)+4>>2]=c[qa+4>>2];c[(a+432|0)+8>>2]=c[qa+8>>2];c[(a+432|0)+12>>2]=c[qa+12>>2];c[(a+416|0)+0>>2]=c[sa+0>>2];c[(a+416|0)+4>>2]=c[sa+4>>2];c[(a+416|0)+8>>2]=c[sa+8>>2];c[(a+416|0)+12>>2]=c[sa+12>>2];ei(ta,0,a+432|0,a+416|0);c[(a+400|0)+0>>2]=c[pa+0>>2];c[(a+400|0)+4>>2]=c[pa+4>>2];c[(a+400|0)+8>>2]=c[pa+8>>2];c[(a+400|0)+12>>2]=c[pa+12>>2];c[(a+384|0)+0>>2]=c[ta+0>>2];c[(a+384|0)+4>>2]=c[ta+4>>2];c[(a+384|0)+8>>2]=c[ta+8>>2];c[(a+384|0)+12>>2]=c[ta+12>>2];di(ua,0,a+400|0,a+384|0);bi(va,0,2.0,0.0);c[zb>>2]=2;Cb=Dv(B,16,1,zb)|0;c[(a+368|0)+0>>2]=c[va+0>>2];c[(a+368|0)+4>>2]=c[va+4>>2];c[(a+368|0)+8>>2]=c[va+8>>2];c[(a+368|0)+12>>2]=c[va+12>>2];c[(a+352|0)+0>>2]=c[Cb+0>>2];c[(a+352|0)+4>>2]=c[Cb+4>>2];c[(a+352|0)+8>>2]=c[Cb+8>>2];c[(a+352|0)+12>>2]=c[Cb+12>>2];ei(wa,0,a+368|0,a+352|0);c[(a+336|0)+0>>2]=c[ua+0>>2];c[(a+336|0)+4>>2]=c[ua+4>>2];c[(a+336|0)+8>>2]=c[ua+8>>2];c[(a+336|0)+12>>2]=c[ua+12>>2];c[(a+320|0)+0>>2]=c[wa+0>>2];c[(a+320|0)+4>>2]=c[wa+4>>2];c[(a+320|0)+8>>2]=c[wa+8>>2];c[(a+320|0)+12>>2]=c[wa+12>>2];fi(xa,0,a+336|0,a+320|0);c[(a+304|0)+0>>2]=c[y+0>>2];c[(a+304|0)+4>>2]=c[y+4>>2];c[(a+304|0)+8>>2]=c[y+8>>2];c[(a+304|0)+12>>2]=c[y+12>>2];c[(a+288|0)+0>>2]=c[xa+0>>2];c[(a+288|0)+4>>2]=c[xa+4>>2];c[(a+288|0)+8>>2]=c[xa+8>>2];c[(a+288|0)+12>>2]=c[xa+12>>2];ci(ya,0,a+304|0,a+288|0);c[(a+272|0)+0>>2]=c[la+0>>2];c[(a+272|0)+4>>2]=c[la+4>>2];c[(a+272|0)+8>>2]=c[la+8>>2];c[(a+272|0)+12>>2]=c[la+12>>2];c[(a+256|0)+0>>2]=c[ya+0>>2];c[(a+256|0)+4>>2]=c[ya+4>>2];c[(a+256|0)+8>>2]=c[ya+8>>2];c[(a+256|0)+12>>2]=c[ya+12>>2];di(za,0,a+272|0,a+256|0);c[(a+240|0)+0>>2]=c[za+0>>2];c[(a+240|0)+4>>2]=c[za+4>>2];c[(a+240|0)+8>>2]=c[za+8>>2];c[(a+240|0)+12>>2]=c[za+12>>2];hi(r,0,a+240|0);Ib=+h[r>>3]*.003660858105139845;bi(Aa,0,f/273.16,0.0);c[Ab>>2]=2;Cb=Dv(B,16,1,Ab)|0;c[(a+224|0)+0>>2]=c[Cb+0>>2];c[(a+224|0)+4>>2]=c[Cb+4>>2];c[(a+224|0)+8>>2]=c[Cb+8>>2];c[(a+224|0)+12>>2]=c[Cb+12>>2];c[(a+208|0)+0>>2]=c[Aa+0>>2];c[(a+208|0)+4>>2]=c[Aa+4>>2];c[(a+208|0)+8>>2]=c[Aa+8>>2];c[(a+208|0)+12>>2]=c[Aa+12>>2];di(Ba,0,a+224|0,a+208|0);c[(a+192|0)+0>>2]=c[Ba+0>>2];c[(a+192|0)+4>>2]=c[Ba+4>>2];c[(a+192|0)+8>>2]=c[Ba+8>>2];c[(a+192|0)+12>>2]=c[Ba+12>>2];gi(Ca,d,a+192|0);bi(Da,0,f/273.16*2.0,0.0);c[Bb>>2]=2;Cb=Dv(B,16,1,Bb)|0;c[(a+176|0)+0>>2]=c[Da+0>>2];c[(a+176|0)+4>>2]=c[Da+4>>2];c[(a+176|0)+8>>2]=c[Da+8>>2];c[(a+176|0)+12>>2]=c[Da+12>>2];c[(a+160|0)+0>>2]=c[Cb+0>>2];c[(a+160|0)+4>>2]=c[Cb+4>>2];c[(a+160|0)+8>>2]=c[Cb+8>>2];c[(a+160|0)+12>>2]=c[Cb+12>>2];ei(Ea,0,a+176|0,a+160|0);bi(Fa,0,f/273.16,0.0);c[(a+2592|0)>>2]=2;Cb=Dv(B,16,1,a+2592|0)|0;c[(a+144|0)+0>>2]=c[Cb+0>>2];c[(a+144|0)+4>>2]=c[Cb+4>>2];c[(a+144|0)+8>>2]=c[Cb+8>>2];c[(a+144|0)+12>>2]=c[Cb+12>>2];c[(a+128|0)+0>>2]=c[Fa+0>>2];c[(a+128|0)+4>>2]=c[Fa+4>>2];c[(a+128|0)+8>>2]=c[Fa+8>>2];c[(a+128|0)+12>>2]=c[Fa+12>>2];fi(Ga,0,a+144|0,a+128|0);c[(a+112|0)+0>>2]=c[Ga+0>>2];c[(a+112|0)+4>>2]=c[Ga+4>>2];c[(a+112|0)+8>>2]=c[Ga+8>>2];c[(a+112|0)+12>>2]=c[Ga+12>>2];gi(Ha,d,a+112|0);c[(a+96|0)+0>>2]=c[Ea+0>>2];c[(a+96|0)+4>>2]=c[Ea+4>>2];c[(a+96|0)+8>>2]=c[Ea+8>>2];c[(a+96|0)+12>>2]=c[Ea+12>>2];c[(a+80|0)+0>>2]=c[Ha+0>>2];c[(a+80|0)+4>>2]=c[Ha+4>>2];c[(a+80|0)+8>>2]=c[Ha+8>>2];c[(a+80|0)+12>>2]=c[Ha+12>>2];di(Ia,0,a+96|0,a+80|0);c[(a+64|0)+0>>2]=c[Ca+0>>2];c[(a+64|0)+4>>2]=c[Ca+4>>2];c[(a+64|0)+8>>2]=c[Ca+8>>2];c[(a+64|0)+12>>2]=c[Ca+12>>2];c[(a+48|0)+0>>2]=c[Ia+0>>2];c[(a+48|0)+4>>2]=c[Ia+4>>2];c[(a+48|0)+8>>2]=c[Ia+8>>2];c[(a+48|0)+12>>2]=c[Ia+12>>2];fi(Ja,0,a+64|0,a+48|0);c[(a+32|0)+0>>2]=c[z+0>>2];c[(a+32|0)+4>>2]=c[z+4>>2];c[(a+32|0)+8>>2]=c[z+8>>2];c[(a+32|0)+12>>2]=c[z+12>>2];c[(a+16|0)+0>>2]=c[Ja+0>>2];c[(a+16|0)+4>>2]=c[Ja+4>>2];c[(a+16|0)+8>>2]=c[Ja+8>>2];c[(a+16|0)+12>>2]=c[Ja+12>>2];ci(Ka,0,a+32|0,a+16|0);c[a+0>>2]=c[Ka+0>>2];c[a+4>>2]=c[Ka+4>>2];c[a+8>>2]=c[Ka+8>>2];c[a+12>>2]=c[Ka+12>>2];hi(s,0,a);Jb=+h[s>>3];h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.52364;h[b+24>>3]=e/611.657;h[b+32>>3]=f/273.16;h[b+40>>3]=Eb;h[b+48>>3]=Fb;h[b+56>>3]=Gb;h[b+64>>3]=Hb;h[b+72>>3]=Ib;h[b+80>>3]=Jb;i=a;c[a+5424>>2]=5;break a}while(0)}



function hy(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+pd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+pd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Xx(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function iy(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function jy(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;ae[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function ky(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Kv(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{se[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Iv(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Kv(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function my(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((ly(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}ny(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Kv(d)|0)>0;h=b?2:0;i=e;return h|0}function ny(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=_Z(q)|0;s=r;t=_Z(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[17942]=Gv(4)|0;if((r|0)==0){cb(71776,71792,308,71824)}if((t|0)==0){cb(71840,71792,309,71824)}v=Nv(b)|0;if((v|0)!=0){w=v;do{v=Pv(w)|0;c[l>>2]=c[v>>2];uv(27,0,71856,l);w=Ov(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;E_(t|0,c[a+384>>2]|0,v|0)|0;E_(r|0,l|0,v|0)|0}h[d>>3]=+qy(a,n,o,q,s,c[17942]|0,b);do{if((Kv(c[17942]|0)|0)==0){s=Lv(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=Nv(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=Pv(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=Ov(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];uv(27,0,71904,j);v=Nv(b)|0;if((v|0)==0){break}else{B=v}do{v=Pv(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[17942]|0;Jv(v,Pv(B)|0);v=Pv(B)|0;c[g>>2]=c[v>>2];uv(27,0,71928,g)}B=Ov(B)|0;}while((B|0)!=0)}}while(0);Hv(b);if((c[41076>>2]|0)!=0){Kv(c[17942]|0)|0}if((Kv(c[17942]|0)|0)>0){B=m;do{g=Lv(c[17942]|0)|0;c[m>>2]=c[g>>2];Mv(c[17942]|0);c[f>>2]=c[m>>2];uv(7,0,71952,f);Iv(b,B);}while((Kv(c[17942]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){E_(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ue(a);ty(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){$Z(t);$Z(r);i=e;return}E_(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;$Z(t);$Z(r);i=e;return}function oy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){xy(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];uv(7,0,71496,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Kv(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[41076>>2]|0)!=0){e=Nv(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=Pv(s)|0;x=c[e>>2]|0;e=se[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;tv(7,0,w,71520,l);s=Ov(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=Pv(Nv(d)|0)|0;x=se[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;tv(1,0,e,71536,j);c[s>>2]=1}}while(0);Hv(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;sy(b);py(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function py(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;uv(27,0,72144,b);d=a+344|0;ge[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function qy(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=_Z(p<<3)|0;if((q|0)==0){cb(71960,71792,409,71976)}if((p|0)>0){E_(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];uv(27,0,71992,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uv(27,0,72040,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){$Z(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Nz(a)|0;de[c[(c[p>>2]|0)+40>>2]&127](a)|0;de[c[(c[p>>2]|0)+28>>2]&127](a)|0;de[c[(c[p>>2]|0)+32>>2]&127](a)|0;ge[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(ry(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}E_(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}$Z(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function ry(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Hv(b);uv(27,0,72064,g);g=Nv(d)|0;if((g|0)==0){j=Kv(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=Pv(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=Pv(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=Pv(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=Pv(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=Pv(a)|0;o=c[g>>2]|0;g=Pv(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?71480:71488;g=Pv(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?71480:71488;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;uv(27,0,72104,f);Iv(b,Pv(a)|0)}a=Ov(a)|0;}while((a|0)!=0);j=Kv(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function sy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;se[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;ty(b);uy(b);de[c[(c[g>>2]|0)+36>>2]&127](b)|0;vy(b,8);h=wy(b)|0;j=de[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{uy(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}xy(b);ty(b);vy(b,8);de[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=wy(b)|0;j=de[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){yv(c[b+536>>2]|0,72184,e)}else if((o|0)==7){uy(b);i=d;return}}function ty(a){a=a|0;var b=0;b=i;E_(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function uy(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function vy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[41048+(d<<2)>>2]|0)==0){i=e;return}uv(d,1,72608,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=de[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=de[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;uv(d,0,72632,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}ae[c[10400]&255](d);i=e;return}function wy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function xy(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;E_(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;E_(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;E_(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;E_(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function yy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ge[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function zy(a){a=a|0;var b=0;b=i;Ay(a);By(a);xy(a);Cy(a);i=b;return}function Ay(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function By(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function Cy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Gw(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];E_(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;E_(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;E_(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;E_(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Gw(c[d>>2]|0)|0));i=b;return}function Dy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[41048+(d<<2)>>2]|0)==0){i=e;return}uv(d,1,72280,q);q=b+136|0;if((c[q>>2]|0)>0){uv(d,1,72304,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?72264:72272;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];uv(d,0,72320,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}ae[c[10400]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){uv(d,1,72376,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?72264:72272;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;uv(d,0,72400,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}ae[c[10400]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){uv(d,1,72456,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?72264:72272;v=(a[n+(m*48|0)+40|0]|0)!=0?72264:72272;n=(a[(c[s>>2]|0)+m|0]|0)!=0?72264:72272;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;uv(d,0,72480,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}ae[c[10400]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){uv(d,1,72536,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;uv(d,0,72560,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}ae[c[10400]&255](d)}ae[c[10400]&255](d);i=e;return}function Ey(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Gw(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];E_(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;E_(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;E_(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;E_(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Gw(c[d>>2]|0)|0));i=b;return}function Fy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function Gy(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];E_(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;E_(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;E_(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;E_(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Hy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Bw(3,32)|0;c[o>>2]=p;if((p|0)==0){yv(c[b+536>>2]|0,72664,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=a_(c[p>>2]|0,8)|0;c[q>>2]=z;xv(c[r>>2]|0,(z|0)!=0|0,72720,l);z=a_(c[s>>2]|0,4)|0;c[t>>2]=z;xv(c[r>>2]|0,(z|0)!=0|0,72720,k);z=a_(c[u>>2]|0,1)|0;c[v>>2]=z;xv(c[r>>2]|0,(z|0)!=0|0,72720,j);z=a_(c[w>>2]|0,4)|0;c[x>>2]=z;xv(c[r>>2]|0,(z|0)!=0|0,72720,g);Fw(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=a_(3,4)|0;c[b+4>>2]=n;Hw(c[o>>2]|0,0,n);c[b+8>>2]=a_(c[p>>2]|0,112)|0;c[b+12>>2]=a_(c[s>>2]|0,60)|0;c[b+16>>2]=a_(c[u>>2]|0,48)|0;c[b+20>>2]=a_(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=a_(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=a_(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=a_(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=a_(g,52)|0;c[b+40>>2]=a_(c[b+216>>2]|0,52)|0;c[b+44>>2]=a_(c[b+220>>2]|0,52)|0;c[b+48>>2]=a_(c[b+224>>2]|0,52)|0;c[b+52>>2]=a_(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=a_(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=a_(x,8)|0;c[b+340>>2]=a_(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=a_(x,8)|0;c[b+348>>2]=a_(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=a_(j,1)|0;c[b+356>>2]=a_(j,1)|0;c[b+360>>2]=a_(j,1)|0;j=_Z(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=_Z(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=a_(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=a_(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=a_(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=a_(u,4)|0;c[b+400>>2]=a_(x,8)|0;c[b+404>>2]=a_(p,4)|0;c[b+408>>2]=a_(s,1)|0;c[b+412>>2]=a_(u,4)|0;c[b+416>>2]=a_(c[n>>2]|0,8)|0;c[b+420>>2]=a_(o,4)|0;c[b+424>>2]=a_(y,1)|0;c[b+428>>2]=a_(g,4)|0;c[b+432>>2]=a_(c[b+152>>2]|0,8)|0;c[b+436>>2]=a_(c[b+156>>2]|0,8)|0;g=_Z((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;ae[c[(c[y>>2]|0)+20>>2]&255](g);g=_Z((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;ae[c[(c[y>>2]|0)+16>>2]&255](g);g=_Z((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;ae[c[(c[y>>2]|0)+12>>2]&255](g);g=_Z((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;be[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=_Z((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=a_(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;xv(c[r>>2]|0,(g|0)!=0|0,72736,f);c[b+512>>2]=100;c[b+516>>2]=a_(100,4)|0;c[b+520>>2]=a_(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=_Z(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;xv(c[r>>2]|0,(g|0)!=0|0,72720,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Bw(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function Iy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;$Z(c[g+8>>2]|0);$Z(c[g+12>>2]|0);$Z(c[g+16>>2]|0);$Z(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);$Z(e);Cw(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){_w(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}$Z(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){_w(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}$Z(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){_w(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}$Z(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){_w(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}$Z(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){_w(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}$Z(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){_w(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}$Z(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){_w(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}$Z(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){_w(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}$Z(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){_w(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}$Z(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){_w(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}$Z(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){_w(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}$Z(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){_w(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}$Z(v);$Z(c[a+108>>2]|0);$Z(c[a+336>>2]|0);$Z(c[a+340>>2]|0);$Z(c[a+344>>2]|0);$Z(c[a+348>>2]|0);$Z(c[a+352>>2]|0);$Z(c[a+356>>2]|0);$Z(c[a+360>>2]|0);$Z(c[a+368>>2]|0);$Z(c[a+384>>2]|0);$Z(c[a+388>>2]|0);$Z(c[a+392>>2]|0);$Z(c[a+396>>2]|0);$Z(c[a+400>>2]|0);$Z(c[a+404>>2]|0);$Z(c[a+408>>2]|0);$Z(c[a+412>>2]|0);$Z(c[a+416>>2]|0);$Z(c[a+420>>2]|0);$Z(c[a+424>>2]|0);$Z(c[a+428>>2]|0);$Z(c[a+488>>2]|0);$Z(c[a+484>>2]|0);$Z(c[a+476>>2]|0);$Z(c[a+468>>2]|0);$Z(c[a+464>>2]|0);$Z(c[a+432>>2]|0);$Z(c[a+436>>2]|0);$Z(c[a+320>>2]|0);$Z(c[a+516>>2]|0);$Z(c[a+520>>2]|0);sN(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;$Z(x);i=b;return}else{y=a;z=0}while(1){Cw(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;$Z(x);i=b;return}function Jy(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[9097]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];uv(8,0,72784,d);i=b;return}function Ky(a,b){a=+a;b=+b;i=i;return a<=b|0}function Ly(a,b){a=+a;b=+b;i=i;return a>=b|0}function My(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=_Z(k)|0;c[e+(h*40|0)+24>>2]=_Z(k)|0;if((c[g>>2]|0)!=1){l=5;break}Py(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){yv(c[a+536>>2]|0,72840,d)}else if((l|0)==6){i=b;return 0}return 0}function Ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){$Z(c[e+(h*40|0)+20>>2]|0);$Z(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Qy(k)|0;$Z(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){yv(c[a+536>>2]|0,72840,d)}else if((j|0)==6){i=b;return 0}return 0}function Oy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[41116>>2]|c[10260]|0)==0){z=w;A=1;break}qN(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];wv(17,1,72872,g);qN(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;qN(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;wv(17,0,72904,f);qN(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ae[c[10400]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=_Z(20)|0;c[b>>2]=f;xv(0,(f|0)!=0|0,72912,e);e=_Z(a)|0;c[f>>2]=e;e=_Z(a)|0;c[f+4>>2]=e;e=_Z(a)|0;c[f+8>>2]=e;e=_Z(a)|0;c[f+16>>2]=e;xv(0,(c[b>>2]|0)!=0|0,72944,d);i=d;return 0}function Qy(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;$Z(c[d>>2]|0);$Z(c[d+4>>2]|0);$Z(c[d+8>>2]|0);$Z(c[d+16>>2]|0);i=b;return 0}function Ry(a,b){a=a|0;b=b|0;b=i;i=i+8|0;yv(c[a+536>>2]|0,72992,b);return 0}function Sy(a){a=a|0;a=i;i=i+8|0;yv(0,72992,a);return 0}function Ty(a,b){a=a|0;b=b|0;b=i;i=i+8|0;yv(c[a+536>>2]|0,72992,b);return 0}function Uy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=_Z(l)|0;c[e+(h<<6)+36>>2]=_Z(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;$y(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=_Z(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;Zy(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){yv(c[a+536>>2]|0,73032,d)}else if((n|0)==8){i=b;return 0}return 0}function Vy(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Wy(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Xy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){$Z(c[e+(h<<6)+28>>2]|0);$Z(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){az(e+(h<<6)+24|0)|0}else if((j|0)==1){_y(e+(h<<6)+24|0)|0;$Z(c[e+(h<<6)+32>>2]|0)}else{k=6;break}$Z(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){yv(c[a+536>>2]|0,73032,d)}else if((k|0)==8){i=b;return 0}return 0}function Yy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[41108>>2]|c[10260]|0)==0){z=w;A=1;break}qN(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];wv(15,1,73064,g);qN(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;qN(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;wv(15,0,73096,f);qN(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ae[c[10400]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=_Z(12)|0;f=_Z(a<<2)|0;c[e>>2]=f;xv(0,(f|0)!=0|0,73104,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function _y(a){a=a|0;var b=0;b=i;$Z(c[c[a>>2]>>2]|0);i=b;return 0}function $y(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=_Z(32)|0;xv(0,(g|0)!=0|0,73160,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Td(0,d|0)|0;Id(c[d>>2]|0,c[b>>2]|0,0)|0;Td(0,g+4|0)|0;Id(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Kb(73208,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function az(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Pd(c[d+12>>2]|0)|0;Jb(c[d+8>>2]|0)|0;Jb(c[d+4>>2]|0)|0;i=b;return 0}function bz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;xv(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,73376,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){xv(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,73416,e);if((de[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=_Z(p)|0;c[g+(m*80|0)+52>>2]=_Z(p)|0;c[g+(m*80|0)+48>>2]=_Z(p)|0;c[g+(m*80|0)+16>>2]=_Z(p)|0;c[g+(m*80|0)+8>>2]=_Z(p)|0;c[g+(m*80|0)+12>>2]=_Z(p)|0;be[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){oz(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){oz(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){Ry(a,n)|0;break}else if((p|0)==1){gz(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){yv(c[j>>2]|0,73456,d)}else if((q|0)==14){i=b;return 0}return 0}function cz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;$Z(c[e+(h*80|0)+44>>2]|0);$Z(c[e+(h*80|0)+52>>2]|0);$Z(c[e+(h*80|0)+48>>2]|0);$Z(c[e+(h*80|0)+16>>2]|0);$Z(c[e+(h*80|0)+8>>2]|0);$Z(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;pz(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==3){n=e+(h*80|0)+40|0;pz(n)|0;l=n;break}else if((k|0)==1){k=e+(h*80|0)+40|0;hz(k)|0;l=k;break}else{m=9;break a}}}while(0);$Z(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){Sy(j)|0}else if((m|0)==9){yv(c[a+536>>2]|0,73456,d)}else if((m|0)==11){i=b;return 0}return 0}function dz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(rz(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(Ty(b,d)|0)&255;break}else if((k|0)==3){j=(rz(b,d)|0)&255;break}else if((k|0)==1){k=b+536|0;l=(c[k>>2]|0)+84|0;m=c[l>>2]|0;c[l>>2]=3;l=iz(b,d)|0;c[(c[k>>2]|0)+84>>2]=m;j=l&255;break}else{yv(c[b+536>>2]|0,73456,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function ez(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;qN(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];vv(17,1,u,73488,m);do{if((a[b+312|0]|0)==0){qN(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;qN(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;wv(17,0,73688,f);qN(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{wv(17,1,73528,l);qN(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;qN(q,d,c[v>>2]|0);if((y_(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wv(17,0,73608,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;qN(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;wv(17,0,73648,g);G=E}qN(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[41116>>2]|c[10260]|0)==0){break}ae[c[10400]&255](17)}}while(0);if((c[41116>>2]|c[10260]|0)==0){x=1;i=e;return x|0}ae[c[10400]&255](17);x=1;i=e;return x|0}function fz(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function gz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=_Z(144)|0;c[b>>2]=f;xv(0,(f|0)!=0|0,73704,e);c[f>>2]=0;e=a<<3;g=_Z(e)|0;c[f+4>>2]=g;g=_Z(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=_Z(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=_Z(e)|0;c[f+24>>2]=g;g=a_(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=_Z(e)|0;c[f+64>>2]=g;g=_Z(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=a_(g,8)|0;c[f+104>>2]=j;j=a_(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=_Z(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=_Z(e)|0;c[f+124>>2]=j;j=_Z(e)|0;c[f+128>>2]=j;j=_Z(e)|0;c[f+132>>2]=j;j=_Z(e)|0;c[f+136>>2]=j;j=_Z(e)|0;c[f+140>>2]=j;xv(0,(c[b>>2]|0)!=0|0,73736,d);i=d;return 0}function hz(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;$Z(c[d+4>>2]|0);$Z(c[d+16>>2]|0);$Z(c[d+12>>2]|0);$Z(c[d+24>>2]|0);$Z(c[d+28>>2]|0);$Z(c[d+64>>2]|0);$Z(c[d+68>>2]|0);$Z(c[d+104>>2]|0);$Z(c[d+108>>2]|0);$Z(c[d+116>>2]|0);$Z(c[d+124>>2]|0);$Z(c[d+128>>2]|0);$Z(c[d+132>>2]|0);$Z(c[d+136>>2]|0);$Z(c[d+140>>2]|0);i=b;return 0}function iz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=_Z(c[Y>>2]|0)|0;if((c[41116>>2]|0)!=0){qN(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];uv(17,1,73776,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];uv(17,1,73832,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];uv(17,0,73848,F);ae[c[10400]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}ae[c[10400]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){E_(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{E_(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+pd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;jz($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+pd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[41120>>2]|0)!=0){kz(c[Q>>2]|0,$,18,73888);kz(c[ca>>2]|0,$,18,73920)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[41120>>2]|0)!=0){kz(c[ca>>2]|0,$,18,73952)}a[da]=R;Fx(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){qN(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];Zw(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;jz($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;jz($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}ty(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[41120>>2]|0)!=0){uv(18,1,73992,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];uv(18,1,74032,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];uv(18,0,74064,C);ae[c[10400]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ae[c[10400]&255](18)}if((c[41124>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;uv(19,1,74096,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];ic(Ja|0,74120,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;uv(19,0,74128,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ae[c[10400]&255](19)}h[K>>3]=+Ex($,c[Ia>>2]|0);h[J>>3]=+Ex($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}E_(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];uv(17,0,74176,w);lz(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}uv(17,0,74248,v);lz(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+pd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}uv(17,0,74312,u);lz(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+pd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}uv(17,0,74384,t);lz(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}E_(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;E_(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}uv(17,0,74448,s);lz(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){E_(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}uv(17,0,74520,r);lz(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}uv(17,0,74592,q);lz(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}uv(17,0,74664,p);lz(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){E_(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}uv(17,0,74728,o);lz(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}uv(17,0,74800,n);lz(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];uv(17,0,74936,l);lz(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){E_(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{E_(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}uv(17,0,74864,m);lz(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[41116>>2]|0)!=0){uv(17,1,74136,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;uv(17,0,74152,x);ae[c[10400]&255](17);lz(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}E_(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;jz($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;$Z(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;$Z(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;$Z(Z);i=e;return kb|0}if((a[Ha]|0)==0){qN(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];Zw(0,f,hb);}if((c[41116>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;uv(17,0,75008,j);lz(S,L,J,K,17)}E_(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;$Z(Z);i=e;return kb|0}return 0}function jz(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[41128>>2]|0)!=0){c[u>>2]=c[y+96>>2];uv(20,0,75256,u);kz(d,b,20,75288)}De[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[41128>>2]|0)!=0){kz(e,b,20,75304);c[t>>2]=c[y+96>>2];uv(20,0,75320,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[41128>>2]|0)!=0){uv(20,0,75360,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){nz(w,f,d,e,m)}else{mz(w,f,m)}do{if((c[41128>>2]|0)!=0){uv(20,0,75400,r);if((c[41124>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;uv(19,1,74096,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ic(m|0,75432,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;uv(19,0,74128,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}ae[c[10400]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;yv(g,75448,n)}return 0}function kz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[41048+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;uv(d,1,74128,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];uv(d,0,75240,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}ae[c[10400]&255](d);i=f;return}function lz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[41048+(f<<2)>>2]|0)==0){i=g;return}uv(f,1,75048,q);uv(f,1,75064,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];uv(f,0,75080,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}ae[c[10400]&255](f);uv(f,1,75120,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];uv(f,0,75136,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}ae[c[10400]&255](f);uv(f,1,75176,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];uv(f,0,75192,j);ae[c[10400]&255](f);ae[c[10400]&255](f);i=g;return}function mz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;G_(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;G_(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}de[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function nz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+pd(+(n*+pd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;jz(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function oz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=_Z(80)|0;c[b>>2]=f;xv(0,(f|0)!=0|0,75528,e);c[f>>2]=0;e=a<<3;g=_Z(e)|0;c[f+4>>2]=g;g=_Z(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=_Z(e)|0;c[f+16>>2]=g;g=a_(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=_Z(fa(e,a)|0)|0;c[f+64>>2]=g;g=_Z(e)|0;c[f+68>>2]=g;g=_Z(a<<2)|0;c[f+72>>2]=g;xv(0,(c[b>>2]|0)!=0|0,75560,d);i=d;return 0}function pz(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;$Z(c[d+4>>2]|0);$Z(c[d+8>>2]|0);$Z(c[d+16>>2]|0);$Z(c[d+20>>2]|0);$Z(c[d+64>>2]|0);$Z(c[d+68>>2]|0);$Z(c[d+72>>2]|0);i=b;return 0}function qz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;G_(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}de[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function rz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;E_(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[41116>>2]|0)==0){J=b+4|0}else{qN(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];uv(17,1,75600,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];uv(17,1,75672,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];uv(17,0,75688,t);ae[c[10400]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}ae[c[10400]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];sz(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){qN(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];Zw(3,g,P);}$=+Ex(H,c[b>>2]|0);aa=+Ex(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){E_(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;uv(17,0,75864,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;uv(17,0,75920,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;uv(17,0,75984,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[41116>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;uv(17,0,75736,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];uv(17,0,75776,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];uv(17,0,75832,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){qN(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];Zw(0,f,L);if((c[41116>>2]|0)==0){da=0;break}c[m>>2]=V;uv(17,0,76064,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uv(17,0,75776,l);if((c[41116>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uv(17,0,75832,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[41116>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;E_(ma|0,oa|0,qa|0)|0;i=e;return da|0}ae[c[10400]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;E_(ma|0,oa|0,qa|0)|0;i=e;return da|0}function sz(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[41120>>2]|0)!=0){c[z>>2]=j;uv(18,0,76104,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];uv(18,0,76152,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){tz(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){uz(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{qz(E,m,r)|0}if((c[41124>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;uv(19,1,76168,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];ic(F|0,76192,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;uv(19,0,76200,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}ae[c[10400]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+Ex(b,_);if(!(!(J<=H)&!(+Ex(b,e)<=H))){$=31;break}gq(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;wv(17,0,76208,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;wv(17,0,76240,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+Ex(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function tz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;De[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function uz(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+pd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;tz(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function vz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){oe[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==2){wz(a,b);f=0;i=d;return f|0}else if((e|0)==3){f=Wx(a,b)|0;i=d;return f|0}else if((e|0)==1){e=c[a+4>>2]|0;g=c[e+4>>2]|0;xz(c[e>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function wz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[76272+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[76272+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];de[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function xz(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function yz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Gv(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=_Z(88)|0;uv(23,0,76304,e);j=Ux(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[774]|0;g=_Z(j<<2)|0;c[19082]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=a_(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[19082]|0;g=n}}else if((f|0)==2){g=_Z(8)|0;c[g+4>>2]=4;m=_Z(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=a_(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);Lz(b)|0;if((c[2]|0)==0){i=e;return k|0}Vw(6);Sw(1);i=e;return k|0}function zz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[774]|0;g=c[19082]|0;if((f|0)>0){h=g;j=0;while(1){$Z(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[19082]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}$Z(m)}else if((e|0)==2){m=b+48|0;g=c[m>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){$Z(c[g+(j<<2)>>2]|0);f=c[m>>2]|0;l=c[f>>2]|0;if((j|0)<(c[f+4>>2]|0)){j=j+1|0;g=l}else{n=l;break}}}else{n=h}$Z(n);$Z(c[m>>2]|0)}else if((e|0)==3){Vx(c[b+48>>2]|0)|0}Mz(a)|0;Gz(a);i=d;return 0}function Az(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(203,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=P_(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=P_(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=P_(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=P_(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=P_(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(204,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=P_(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=P_(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;B_(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=P_(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=P_(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,76336,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=P_(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=P_(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,76432,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=P_(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[82552>>2]|0,82528,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=P_(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,76488,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=P_(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(205,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=P_(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function Bz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];uv(8,0,76584,G);I=b+313|0;a[I]=1;sy(b);if((c[97924>>2]|0)==0){be[c[82548>>2]&63](82528,b)}a[I]=0}}while(0);if((e|0)!=0){Cz(vd(e|0)|0,b)}if((c[41148>>2]|0)==0){i=f;return 0}Vw(0);uv(25,0,76632,F);uv(25,1,76656,E);H=+Nw(6);J=+Nw(6);K=J/+Nw(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];uv(25,0,76664,D);K=+Nw(1);H=+Nw(1);J=H/+Nw(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];uv(25,0,76704,C);J=+Nw(2);K=+Nw(2);H=K/+Nw(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];uv(25,0,76736,B);H=+Nw(3);J=+Nw(3);K=J/+Nw(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];uv(25,0,76760,A);K=+Nw(4);H=+Nw(4);J=H/+Nw(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];uv(25,0,76800,z);J=+Nw(7);K=+Nw(7);H=K/+Nw(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(25,0,76832,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Nw(0);J=H- +Nw(7);H=J- +Nw(4);J=H- +Nw(3);H=J- +Nw(2);J=H- +Nw(1);H=J- +Nw(6);J=+Nw(0);K=J- +Nw(7);J=K- +Nw(4);K=J- +Nw(3);J=K- +Nw(2);K=J- +Nw(1);J=K- +Nw(6);K=J/+Nw(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(25,0,76896,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];uv(25,0,76864,x)}K=+Nw(0);H=+Nw(0);J=H/+Nw(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];uv(25,0,76928,v);ae[c[10400]&255](25);uv(25,1,76952,u);c[t>>2]=c[d+40>>2];uv(25,0,76960,t);c[s>>2]=c[d+44>>2];uv(25,0,76984,s);ae[c[10400]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);uv(25,1,77008,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];uv(25,0,77024,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];uv(25,0,77040,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];uv(25,0,77072,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];uv(25,0,77104,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];uv(25,0,77128,m);ae[c[10400]&255](25)}else if((s|0)!=5){uv(25,1,77160,l);uv(25,0,77168,j);ae[c[10400]&255](25)}uv(25,0,77232,g);Sw(0);i=f;return 0}function Cz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,77704)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(b|0,77712,y|0)|0;if((z|0)==0){C=Nd(10,b|0)|0;D=qd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,77728,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;sd(b|0,77744,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;sd(b|0,77752,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;sd(b|0,77760,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((y_(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,77728,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,77728,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((y_(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;sd(b|0,77744,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;sd(b|0,77744,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((y_(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;sd(b|0,77752,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;sd(b|0,77752,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((y_(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;sd(b|0,77760,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];sd(b|0,77728,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;sd(b|0,77744,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;sd(b|0,77752,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((y_(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;sd(b|0,77760,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,77704)|0;}while((d|0)!=0);C=Nd(10,b|0)|0;D=qd(b|0)|0;i=e;return}function Dz(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 5:{wv(1,0,77328,q);v=1;i=m;return v|0};case 4:{w=c[772]|0;if((w|0)!=0){if((y_(w,77368)|0)==0){break a}}uv(23,0,77384,p);v=1;i=m;return v|0};case 18:{w=c[772]|0;do{if((w|0)!=0){if((y_(w,77512)|0)!=0){break}c[u>>2]=4;break a}}while(0);uv(23,0,77536,o);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 11:case 10:case 9:case 6:case 7:case 8:{wv(1,0,77256,r);v=1;i=m;return v|0};default:{}}}while(0);r=yz(a,s)|0;xe[c[41948>>2]&7]()|0;do{if((r|0)==0){o=Az(a,b,d,e,f,g)|0;xe[c[41948>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){be[c[82548>>2]&63](82528,a);Cy(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];uv(23,0,77664,n);o=se[c[c[a+540>>2]>>2]&63](a,t)|0;xe[c[41948>>2]&7]()|0;Bz(a,s,l)|0;xe[c[41948>>2]&7]()|0;x=o}else{xe[c[41948>>2]&7]()|0;x=r}}while(0);zz(a,s)|0;v=x;i=m;return v|0}function Ez(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){Fz(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((de[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){yv(c[a+536>>2]|0,77776,d)}else if((k|0)==6){Fz(a);i=b;return}}function Fz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;G_(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Gz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;$Z(c[f+(a*48|0)+28>>2]|0);$Z(c[f+(a*48|0)+32>>2]|0);$Z(c[f+(a*48|0)+16>>2]|0);$Z(c[f+(a*48|0)+20>>2]|0);$Z(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}



function Wj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;sw(ag,1,$f);if(!(d>0.0)){$f=dw(dw(7368,bw(d,0,1,6)|0)|0,6792)|0;bg=c[22536]|0;cg=f+96|0;c[cg+0>>2]=c[7432+0>>2];c[cg+4>>2]=c[7432+4>>2];c[cg+8>>2]=c[7432+8>>2];c[cg+12>>2]=c[7432+12>>2];c[cg+16>>2]=c[7432+16>>2];c[cg+20>>2]=c[7432+20>>2];De[bg&31](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=dw(dw(7456,bw(d,0,1,6)|0)|0,7208)|0;$f=c[22536]|0;bg=f+72|0;c[bg+0>>2]=c[7504+0>>2];c[bg+4>>2]=c[7504+4>>2];c[bg+8>>2]=c[7504+8>>2];c[bg+12>>2]=c[7504+12>>2];c[bg+16>>2]=c[7504+16>>2];c[bg+20>>2]=c[7504+20>>2];De[$f&31](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=dw(dw(7528,bw(e,0,1,6)|0)|0,7312)|0;_f=c[22536]|0;$f=f+48|0;c[$f+0>>2]=c[7576+0>>2];c[$f+4>>2]=c[7576+4>>2];c[$f+8>>2]=c[7576+8>>2];c[$f+12>>2]=c[7576+12>>2];c[$f+16>>2]=c[7576+16>>2];c[$f+20>>2]=c[7576+20>>2];De[_f&31](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=dw(dw(7600,bw(e,0,1,6)|0)|0,7656)|0;Zf=c[22536]|0;_f=f+24|0;c[_f+0>>2]=c[7704+0>>2];c[_f+4>>2]=c[7704+4>>2];c[_f+8>>2]=c[7704+8>>2];c[_f+12>>2]=c[7704+12>>2];c[_f+16>>2]=c[7704+16>>2];c[_f+20>>2]=c[7704+20>>2];De[Zf&31](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(yw(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(yw(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(yw(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(yw(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(yw(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(yw(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(yw(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(yw(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(yw(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(yw(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(yw(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(yw(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(yw(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(yw(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(yw(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(yw(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(yw(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(yw(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(yw(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(yw(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(yw(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(yw(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(yw(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(yw(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(yw(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(yw(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(yw(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(yw(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(yw(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(yw(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(yw(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(yw(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(yw(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(yw(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(yw(ag,1,of)|0)>>3];c[nf>>2]=16;h[(yw(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(yw(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(yw(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(yw(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(yw(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(yw(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(yw(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(yw(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(yw(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(yw(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(yw(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(yw(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(yw(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(yw(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(yw(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(yw(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(yw(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(yw(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(yw(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(yw(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(yw(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(yw(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(yw(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(yw(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(yw(ag,1,Qe)|0)>>3];c[Pe>>2]=25;h[(yw(ag,1,Pe)|0)>>3]=fg*fg;c[Oe>>2]=11;fg=+h[(yw(ag,1,Oe)|0)>>3];c[Ne>>2]=12;gg=+h[(yw(ag,1,Ne)|0)>>3];c[Me>>2]=25;eg=fg*gg*dg*+h[(yw(ag,1,Me)|0)>>3];c[Le>>2]=26;h[(yw(ag,1,Le)|0)>>3]=eg;c[Ke>>2]=10;eg=+h[(yw(ag,1,Ke)|0)>>3];c[Je>>2]=12;gg=eg*+h[(yw(ag,1,Je)|0)>>3];c[Ie>>2]=27;h[(yw(ag,1,Ie)|0)>>3]=gg;c[He>>2]=1;gg=+h[(yw(ag,1,He)|0)>>3];c[Ge>>2]=10;eg=+h[(yw(ag,1,Ge)|0)>>3];c[Fe>>2]=11;fg=gg*eg*dg*+h[(yw(ag,1,Fe)|0)>>3];c[Ee>>2]=28;h[(yw(ag,1,Ee)|0)>>3]=fg;c[Ce>>2]=10;fg=+h[(yw(ag,1,Ce)|0)>>3];c[Be>>2]=12;eg=+h[(yw(ag,1,Be)|0)>>3];c[Ae>>2]=25;gg=fg*eg*dg*+h[(yw(ag,1,Ae)|0)>>3];c[ze>>2]=29;h[(yw(ag,1,ze)|0)>>3]=gg;c[ye>>2]=1;gg=+h[(yw(ag,1,ye)|0)>>3];c[xe>>2]=10;eg=+h[(yw(ag,1,xe)|0)>>3];c[we>>2]=25;fg=gg*eg*dg*+h[(yw(ag,1,we)|0)>>3];c[ve>>2]=30;h[(yw(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(yw(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(yw(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(yw(ag,1,se)|0)>>3];c[re>>2]=31;h[(yw(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(yw(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(yw(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(yw(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(yw(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(yw(ag,1,me)|0)>>3];c[le>>2]=34;h[(yw(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(yw(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(yw(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(yw(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(yw(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(yw(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(yw(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(yw(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(yw(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(yw(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(yw(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(yw(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(yw(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(yw(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(yw(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(yw(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(yw(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(yw(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(yw(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(yw(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(yw(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(yw(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(yw(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(yw(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(yw(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(yw(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(yw(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(yw(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(yw(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(yw(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(yw(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(yw(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(yw(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(yw(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(yw(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(yw(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(yw(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(yw(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function Xj(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=dw(dw(6184,bw(d,0,1,6)|0)|0,6256)|0;H=dw(dw(G,bw(16529200.0,0,1,6)|0)|0,6264)|0;G=c[22536]|0;I=n;J=6272;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];De[G&31](b,n,H,r);}if(!(e>=623.15)){r=dw(dw(6296,bw(e,0,1,6)|0)|0,6368)|0;H=dw(dw(r,bw(623.15,0,1,6)|0)|0,6376)|0;r=c[22536]|0;n=m;G=6384;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];De[r&31](b,m,H,q);}hk(t,0,e);if(!(+h[t>>3]<=d)){t=dw(dw(6408,bw(d,0,1,6)|0)|0,6480)|0;q=dw(dw(t,bw(e,0,1,6)|0)|0,6376)|0;t=c[22536]|0;H=l;m=6496;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];De[t&31](b,l,q,p);}gk(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];ik(v,0,d);L=+h[v>>3];jk(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{fk(x,b,d);if(+h[x>>3]>e){ik(y,0,d);M=+h[y>>3];kk(z,0,d);L=+h[z>>3];lk(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{mk(B,0,d);L=+h[B>>3];jk(C,0,d);M=+h[C>>3];nk(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){Yj(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));$g(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[22536]|0;S=j;R=6520;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];De[fa&31](b,j,6544,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function Yj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;sw(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(yw(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(yw(od,1,ld)|0)>>3];c[kd>>2]=2;h[(yw(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(yw(od,1,jd)|0)>>3];c[id>>2]=3;h[(yw(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(yw(od,1,hd)|0)>>3];c[gd>>2]=4;h[(yw(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(yw(od,1,fd)|0)>>3];c[ed>>2]=5;h[(yw(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(yw(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(yw(od,1,cd)|0)>>3];c[bd>>2]=6;h[(yw(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(yw(od,1,ad)|0)>>3];c[$c>>2]=7;h[(yw(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(yw(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(yw(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(yw(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(yw(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(yw(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(yw(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(yw(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(yw(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(yw(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(yw(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(yw(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(yw(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(yw(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(yw(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(yw(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(yw(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(yw(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(yw(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(yw(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(yw(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(yw(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(yw(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(yw(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(yw(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(yw(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(yw(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(yw(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(yw(od,1,zc)|0)>>3];c[yc>>2]=18;h[(yw(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(yw(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(yw(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(yw(od,1,vc)|0)>>3];c[uc>>2]=19;h[(yw(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(yw(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(yw(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(yw(od,1,rc)|0)>>3];c[qc>>2]=20;h[(yw(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(yw(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(yw(od,1,oc)|0)>>3];c[nc>>2]=21;h[(yw(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(yw(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(yw(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(yw(od,1,kc)|0)>>3];c[jc>>2]=22;h[(yw(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(yw(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(yw(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(yw(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(yw(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(yw(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(yw(od,1,dc)|0)>>3];c[cc>>2]=25;h[(yw(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(yw(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(yw(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(yw(od,1,$b)|0)>>3];c[_b>>2]=27;h[(yw(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(yw(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(yw(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(yw(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(yw(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(yw(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(yw(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(yw(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(yw(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(yw(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(yw(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(yw(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(yw(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(yw(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(yw(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(yw(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(yw(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(yw(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(yw(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(yw(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(yw(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(yw(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(yw(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(yw(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(yw(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(yw(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(yw(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(yw(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(yw(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(yw(od,1,xb)|0)>>3];c[wb>>2]=40;h[(yw(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[22536]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=7728;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];De[xb&31](b,g,4120,vb);}c[ub>>2]=3;rd=+h[(yw(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(yw(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(yw(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(yw(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(yw(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(yw(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(yw(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(yw(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(yw(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(yw(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(yw(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(yw(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(yw(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(yw(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(yw(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(yw(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(yw(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(yw(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(yw(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(yw(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(yw(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(yw(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(yw(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(yw(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(yw(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(yw(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(yw(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(yw(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(yw(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(yw(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(yw(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(yw(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(yw(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(yw(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(yw(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(yw(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(yw(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(yw(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(yw(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(yw(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(yw(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(yw(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(yw(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(yw(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(yw(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(yw(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(yw(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(yw(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(yw(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(yw(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(yw(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(yw(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(yw(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(yw(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(yw(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(yw(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(yw(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(yw(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(yw(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(yw(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(yw(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(yw(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(yw(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(yw(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(yw(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(yw(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(yw(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(yw(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(yw(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(yw(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(yw(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(yw(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(yw(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(yw(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(yw(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(yw(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(yw(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(yw(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(yw(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(yw(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(yw(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(yw(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(yw(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(yw(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(yw(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(yw(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(yw(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(yw(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(yw(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(yw(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(yw(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(yw(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(yw(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(yw(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(yw(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(yw(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(yw(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(yw(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(yw(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(yw(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(yw(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(yw(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(yw(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(yw(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(yw(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(yw(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(yw(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(yw(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(yw(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(yw(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(yw(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(yw(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(yw(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(yw(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(yw(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(yw(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(yw(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function Zj(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;sw(ia,1,ha);if(!(d>0.0)){ha=dw(dw(6728,bw(d,0,1,6)|0)|0,6792)|0;ja=c[22536]|0;ka=m;la=6808;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];De[ja&31](b,m,ha,ga);}if(!(d<=1.0e7)){ga=dw(dw(6832,bw(d,0,1,6)|0)|0,6880)|0;ha=c[22536]|0;m=l;ja=6920;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];De[ha&31](b,l,ga,fa);}if(!(e<=2273.15)){fa=dw(dw(6944,bw(e,0,1,6)|0)|0,6992)|0;ga=c[22536]|0;l=j;ha=7048;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];De[ga&31](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(yw(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(yw(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(yw(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(yw(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(yw(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(yw(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(yw(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(yw(ia,1,X)|0)>>3];c[W>>2]=5;h[(yw(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(yw(ia,1,V)|0)>>3];c[U>>2]=6;h[(yw(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(yw(ia,1,T)|0)>>3];c[S>>2]=7;h[(yw(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(yw(ia,1,R)|0)>>3];c[Q>>2]=8;h[(yw(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(yw(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(yw(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(yw(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(yw(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(yw(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[22536]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=7728;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];De[M&31](b,g,4592,K);}c[J>>2]=4;oa=+h[(yw(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(yw(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(yw(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(yw(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(yw(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(yw(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(yw(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(yw(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(yw(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(yw(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(yw(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(yw(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(yw(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(yw(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(yw(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(yw(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(yw(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(yw(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(yw(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(yw(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(yw(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(yw(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(yw(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function _j(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];$j(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];ak(j,b,h);i=g;return}function $j(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;sw(u,1,n);c[m>>2]=2;sw(u,1,m);if((kv(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];Vi(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +Aw(f);xw(q,1,w,l);c[k>>2]=q;zw(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Vi(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];tw(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function ak(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(yw(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(yw(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];xw(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Kj(d,b,o,p,f);i=e;return}function bk(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0;l=i;i=i+968|0;m=l;n=l+120|0;o=l+240|0;p=l+336|0;q=l+432|0;r=l+528|0;s=l+624|0;t=l+720|0;u=l+816|0;v=l+832|0;w=l+848|0;x=l+864|0;y=l+960|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+16|0;fa=i;i=i+96|0;ga=i;i=i+96|0;ha=i;i=i+96|0;ia=i;i=i+96|0;ja=i;i=i+96|0;ka=i;i=i+96|0;la=i;i=i+96|0;ma=i;i=i+120|0;na=i;i=i+120|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;c[da>>2]=5;sw(ea,1,da);c[ca>>2]=1;if(+h[(yw(f,1,ca)|0)>>3]==0.0){Xg(fa,b,d,e);Na=x+0|0;Oa=fa+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));fh(oa,0,0.0,0.0,x,g,j);Qa=+h[oa>>3];Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}c[ba>>2]=1;Ta=+h[(yw(f,1,ba)|0)>>3];c[aa>>2]=1;Ua=Ta/(1.0- +h[(yw(f,1,aa)|0)>>3]);c[$>>2]=1;Ta=1.0- +h[(yw(f,1,$)|0)>>3];c[_>>2]=1;Va=+h[(yw(k,1,_)|0)>>3]/(Ta*Ta);Ni(pa,b,d,e);Ta=+h[pa>>3];Pj(qa,b,d,e,g,j);Wa=+h[qa>>3];qa=w;pa=f;c[qa+0>>2]=c[pa+0>>2];c[qa+4>>2]=c[pa+4>>2];c[qa+8>>2]=c[pa+8>>2];Oi(ra,b,d,e,w);Xa=+h[ra>>3];ra=v;w=f;c[ra+0>>2]=c[w+0>>2];c[ra+4>>2]=c[w+4>>2];c[ra+8>>2]=c[w+8>>2];w=u;ra=k;c[w+0>>2]=c[ra+0>>2];c[w+4>>2]=c[ra+4>>2];c[w+8>>2]=c[ra+8>>2];Oj(sa,b,d,e,v,g,j,u);Ya=+h[sa>>3];Za=d-Xa;_a=g-Ya;sa=e<273.16;if(Ua<=Ta|Ta==-1.0){if(sa){Xg(ga,b,Za,e);Na=t+0|0;Oa=ga+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));fh(ta,0,0.0,0.0,t,_a,j);$a=e*461.51805;Qa=+h[ta>>3]+(Ya*e-Xa*j)/($a*$a)*461.51805;Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}else{Xg(ha,b,Za,e);Na=s+0|0;Oa=ha+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));fh(ua,0,0.0,0.0,s,_a,j);_a=+h[ua>>3];cj(va,b,Xa,e,Ya,j);Qa=_a+ +h[va>>3];Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}}else{if(sa){ch(wa,b,Za,e);_a=+h[wa>>3];c[Z>>2]=1;h[(yw(ea,1,Z)|0)>>3]=_a;Qi(xa,b,d,e);_a=+h[xa>>3];c[Y>>2]=2;h[(yw(ea,1,Y)|0)>>3]=_a;ch(ya,b,Za,e);_a=+h[ya>>3];Qi(za,b,d,e);$a=Ta+1.0;ab=$a/(_a+Xa/(e*461.51805))+(Ua-Ta)/+h[za>>3];c[X>>2]=3;h[(yw(ea,1,X)|0)>>3]=ab;Xg(ia,b,d,e);Na=r+0|0;Oa=ia+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));fh(Aa,0,0.0,0.0,r,g,j);ab=+h[Aa>>3];c[W>>2]=4;h[(yw(ea,1,W)|0)>>3]=ab;c[V>>2]=1;ab=+h[(yw(ea,1,V)|0)>>3];dj(ja,b,d,e);Na=q+0|0;Oa=ja+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));mj(Ba,0,0.0,0.0,q,g,j);_a=+h[Ba>>3];dj(ka,b,d,e);Na=p+0|0;Oa=ka+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));mj(Ca,0,0.0,0.0,p,g,j);bb=+h[Ca>>3];c[U>>2]=2;cb=+h[(yw(ea,1,U)|0)>>3];c[T>>2]=1;db=Wa*+h[(yw(ea,1,T)|0)>>3];c[S>>2]=4;eb=(db-$a*+h[(yw(ea,1,S)|0)>>3])/(ab*ab);c[R>>2]=2;ab=Va*+h[(yw(ea,1,R)|0)>>3]-Ua*_a;c[Q>>2]=2;_a=eb+((Ya*e-Xa*j)/(e*e*461.51805)+(ab+(Ta*bb-Wa*+h[(yw(ea,1,Q)|0)>>3]))/(cb*cb));c[P>>2]=5;h[(yw(ea,1,P)|0)>>3]=_a;c[O>>2]=3;_a=+h[(yw(ea,1,O)|0)>>3];c[N>>2]=3;cb=Va*+h[(yw(ea,1,N)|0)>>3];c[M>>2]=5;Qa=(cb-(Ua+1.0)*+h[(yw(ea,1,M)|0)>>3])/(_a*_a);Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}else{ch(Da,b,Za,e);_a=+h[Da>>3];Pi(Ea,b,Xa,e);cb=_a+ +h[Ea>>3];c[L>>2]=1;h[(yw(ea,1,L)|0)>>3]=cb;Yh(Fa,b,d,e,0);cb=+h[Fa>>3];c[K>>2]=2;h[(yw(ea,1,K)|0)>>3]=cb;ch(Ga,b,Za,e);Za=+h[Ga>>3];Pi(Ha,b,Xa,e);cb=+h[Ha>>3];Yh(Ia,b,d,e,0);_a=Ta+1.0;bb=_a/(Za+cb)+(Ua-Ta)/+h[Ia>>3];c[J>>2]=3;h[(yw(ea,1,J)|0)>>3]=bb;Xg(la,b,d,e);Na=o+0|0;Oa=la+0|0;Pa=Na+96|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));fh(Ja,0,0.0,0.0,o,g,j);bb=+h[Ja>>3];cj(Ka,b,Xa,e,Ya,j);Ya=bb+ +h[Ka>>3];c[I>>2]=4;h[(yw(ea,1,I)|0)>>3]=Ya;c[H>>2]=1;Ya=+h[(yw(ea,1,H)|0)>>3];Qj(ma,b,d,e,0);Na=n+0|0;Oa=ma+0|0;Pa=Na+120|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));ck(La,0,0.0,0.0,n,g,j);bb=+h[La>>3];Qj(na,b,d,e,0);Na=m+0|0;Oa=na+0|0;Pa=Na+120|0;do{c[Na>>2]=c[Oa>>2];Na=Na+4|0;Oa=Oa+4|0}while((Na|0)<(Pa|0));ck(Ma,0,0.0,0.0,m,g,j);j=+h[Ma>>3];c[G>>2]=2;g=+h[(yw(ea,1,G)|0)>>3];c[F>>2]=1;e=Wa*+h[(yw(ea,1,F)|0)>>3];c[E>>2]=4;d=(e-_a*+h[(yw(ea,1,E)|0)>>3])/(Ya*Ya);c[D>>2]=2;Ya=Va*+h[(yw(ea,1,D)|0)>>3]-Ua*bb;c[C>>2]=2;bb=d+(Ya+(Ta*j-Wa*+h[(yw(ea,1,C)|0)>>3]))/(g*g);c[B>>2]=5;h[(yw(ea,1,B)|0)>>3]=bb;c[A>>2]=3;bb=+h[(yw(ea,1,A)|0)>>3];c[z>>2]=3;g=Va*+h[(yw(ea,1,z)|0)>>3];c[y>>2]=5;Qa=(g-(Ua+1.0)*+h[(yw(ea,1,y)|0)>>3])/(bb*bb);Ra=a;Sa=Ra;h[Sa>>3]=Qa;i=l;return}}}function ck(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0,m=0;b=i;if((c[f+4>>2]|0)==3){e=+h[f+80>>3];k=g/e- +h[f+72>>3]*(j/e);l=a;m=l;h[m>>3]=k;i=b;return}else{e=+h[f+56>>3];k=-(e*e*(+h[f+96>>3]*g+ +h[f+88>>3]*j));l=a;m=l;h[m>>3]=k;i=b;return}}function dk(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0;l=i;i=i+128|0;m=l;n=l+16|0;o=l+32|0;p=l+48|0;q=l+64|0;r=l+80|0;s=l+96|0;t=l+104|0;u=l+112|0;v=l+120|0;w=r;x=f;c[w+0>>2]=c[x+0>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];x=q;w=k;c[x+0>>2]=c[w+0>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];Nj(s,b,d,e,r,g,j,q);y=+h[s>>3];s=p;q=f;c[s+0>>2]=c[q+0>>2];c[s+4>>2]=c[q+4>>2];c[s+8>>2]=c[q+8>>2];q=o;s=k;c[q+0>>2]=c[s+0>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];bk(t,b,d,e,p,g,j,o);j=+h[t>>3];t=n;o=f;c[t+0>>2]=c[o+0>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];Mi(u,b,d,e,n);z=+h[u>>3];u=m;n=f;c[u+0>>2]=c[n+0>>2];c[u+4>>2]=c[n+4>>2];c[u+8>>2]=c[n+8>>2];Mi(v,b,d,e,m);e=+h[v>>3];h[a>>3]=y+(j*d-z*g)/(e*e);i=l;return}function ek(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function fk(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;sw(ia,1,ha);if(!(d>611.657)){ha=dw(dw(6600,bw(d,0,1,6)|0)|0,6664)|0;ja=dw(dw(ha,bw(611.657,0,1,6)|0)|0,6672)|0;ha=c[22536]|0;ka=f;la=6704;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];De[ha&31](b,f,ja,ga);}ma=+od(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(yw(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(yw(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(yw(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(yw(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(yw(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(yw(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(yw(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(yw(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(yw(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(yw(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(yw(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(yw(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(yw(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(yw(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(yw(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(yw(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(yw(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(yw(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(yw(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(yw(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(yw(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(yw(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(yw(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(yw(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(yw(ia,1,H)|0)>>3];c[G>>2]=12;h[(yw(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(yw(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(yw(ia,1,E)|0)>>3];c[D>>2]=13;h[(yw(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(yw(ia,1,C)|0)>>3]));c[B>>2]=14;h[(yw(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(yw(ia,1,A)|0)>>3];c[z>>2]=15;h[(yw(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(yw(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(yw(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(yw(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(yw(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(yw(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(yw(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(yw(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(yw(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(yw(ia,1,q)|0)>>3];c[p>>2]=19;h[(yw(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(yw(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(yw(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(yw(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(yw(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(yw(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(yw(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(yw(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function gk(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;sw(k,1,j);j=k;k=7888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=dw(dw(7904,bw(d,0,1,6)|0)|0,6664)|0;j=dw(dw(k,bw(611.657,0,1,6)|0)|0,6672)|0;k=c[22536]|0;s=f;t=7976;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];De[k&31](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function hk(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;sw(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function ik(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;sw(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(yw(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(yw(s,1,p)|0)>>3];c[o>>2]=2;h[(yw(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(yw(s,1,n)|0)>>3];c[m>>2]=3;h[(yw(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(yw(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(yw(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(yw(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(yw(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(yw(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(yw(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(yw(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(yw(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(yw(l,1,tb)|0)>>3];c[ub>>2]=52;h[(yw(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(yw(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(yw(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(yw(l,1,xb)|0)>>3];c[yb>>2]=53;h[(yw(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(yw(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(yw(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(yw(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(yw(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(yw(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(yw(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(yw(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[22536]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[7728+0>>2];c[a+4>>2]=c[7728+4>>2];c[a+8>>2]=c[7728+8>>2];c[a+12>>2]=c[7728+12>>2];c[a+16>>2]=c[7728+16>>2];c[a+20>>2]=c[7728+20>>2];De[Gd&31](d,a,4592,Gb);}c[Hb>>2]=9;Ed=+h[(yw(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(yw(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(yw(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(yw(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(yw(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(yw(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(yw(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(yw(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(yw(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(yw(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(yw(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(yw(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(yw(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(yw(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(yw(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(yw(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(yw(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(yw(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(yw(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(yw(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(yw(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(yw(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(yw(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(yw(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(yw(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(yw(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(yw(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(yw(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(yw(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(yw(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(yw(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(yw(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(yw(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(yw(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(yw(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(yw(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(yw(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(yw(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(yw(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(yw(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(yw(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(yw(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(yw(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(yw(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(yw(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(yw(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(yw(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(yw(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(yw(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(yw(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(yw(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(yw(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(yw(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(yw(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(yw(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(yw(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(yw(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(yw(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(yw(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(yw(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(yw(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(yw(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(yw(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(yw(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(yw(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(yw(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(yw(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(yw(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(yw(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(yw(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(yw(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(yw(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(yw(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(yw(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(yw(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(yw(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(yw(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(yw(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(yw(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(yw(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(yw(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(yw(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(yw(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(yw(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(yw(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(yw(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(yw(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(yw(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(yw(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(yw(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(yw(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(yw(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(yw(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(yw(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(yw(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(yw(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(yw(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(yw(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(yw(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(yw(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(yw(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(yw(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(yw(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(yw(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(yw(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(yw(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(yw(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(yw(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(yw(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(yw(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(yw(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(yw(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(yw(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(yw(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(yw(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(yw(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(yw(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(yw(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(yw(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(yw(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(yw(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(yw(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(yw(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(yw(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(yw(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(yw(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(yw(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(yw(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(yw(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(yw(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(yw(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(yw(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(yw(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(yw(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(yw(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(yw(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(yw(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(yw(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(yw(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(yw(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(yw(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(yw(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(yw(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(yw(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(yw(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(yw(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(yw(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(yw(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(yw(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(yw(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(yw(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(yw(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(yw(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(yw(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(yw(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(yw(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(yw(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(yw(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(yw(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(yw(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(yw(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(yw(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(yw(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(yw(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(yw(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(yw(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(yw(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(yw(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(yw(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(yw(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(yw(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(yw(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(yw(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(yw(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(yw(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(yw(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(yw(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(yw(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(yw(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(yw(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(yw(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(yw(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(yw(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(yw(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(yw(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(yw(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(yw(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(yw(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(yw(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(yw(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(yw(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(yw(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(yw(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(yw(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(yw(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(yw(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(yw(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(yw(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(yw(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(yw(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(yw(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(yw(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(yw(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(yw(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(yw(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(yw(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(yw(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(yw(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(yw(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(yw(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(yw(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(yw(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(yw(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(yw(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(yw(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(yw(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(yw(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function jk(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;sw(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(yw(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(yw(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(yw(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(yw(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(yw(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(yw(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(yw(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(yw(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(yw(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(yw(La,1,Aa)|0)>>3];c[za>>2]=6;h[(yw(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(yw(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(yw(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(yw(La,1,wa)|0)>>3];c[va>>2]=7;h[(yw(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(yw(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(yw(La,1,ta)|0)>>3];c[sa>>2]=8;h[(yw(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(yw(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(yw(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(yw(La,1,pa)|0)>>3];c[oa>>2]=9;h[(yw(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(yw(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(yw(La,1,ma)|0)>>3];c[la>>2]=11;h[(yw(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(yw(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(yw(La,1,ja)|0)>>3];c[ia>>2]=12;h[(yw(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(yw(La,1,ha)|0)>>3];c[ga>>2]=13;h[(yw(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(yw(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(yw(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(yw(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(yw(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(yw(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(yw(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(yw(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(yw(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(yw(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(yw(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(yw(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(yw(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(yw(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(yw(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(yw(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(yw(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(yw(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(yw(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(yw(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(yw(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(yw(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(yw(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(yw(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(yw(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(yw(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(yw(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(yw(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(yw(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(yw(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(yw(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(yw(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(yw(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(yw(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(yw(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(yw(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(yw(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(yw(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(yw(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(yw(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(yw(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(yw(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(yw(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(yw(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(yw(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(yw(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(yw(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(yw(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(yw(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(yw(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(yw(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(yw(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(yw(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(yw(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function kk(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function lk(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;_h(e,b,c);j=+h[e>>3];do{if(c<623.15){pk(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}kk(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function mk(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function nk(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;_h(e,b,c);j=+h[e>>3];do{if(c<623.15){ok(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}mk(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function ok(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;sw(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(yw(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(yw(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(yw(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(yw(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(yw(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(yw(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(yw(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(yw(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(yw(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(yw(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(yw(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(yw(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(yw(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(yw(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(yw(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(yw(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(yw(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(yw(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(yw(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(yw(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(yw(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(yw(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(yw(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(yw(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(yw(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(yw(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(yw(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(yw(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(yw(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(yw(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(yw(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(yw(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(yw(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(yw(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(yw(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(yw(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(yw(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(yw(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(yw(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(yw(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(yw(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(yw(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(yw(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(yw(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(yw(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(yw(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(yw(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(yw(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(yw(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(yw(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(yw(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(yw(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(yw(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(yw(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(yw(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(yw(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(yw(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(yw(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(yw(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(yw(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(yw(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(yw(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(yw(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(yw(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(yw(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(yw(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(yw(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(yw(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(yw(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(yw(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(yw(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(yw(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(yw(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(yw(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(yw(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(yw(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(yw(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(yw(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(yw(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(yw(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(yw(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function pk(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;sw(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(yw(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(yw(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(yw(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(yw(ta,1,oa)|0)>>3];c[na>>2]=3;h[(yw(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(yw(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(yw(ta,1,la)|0)>>3];c[ka>>2]=4;h[(yw(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(yw(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(yw(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(yw(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(yw(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(yw(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(yw(ta,1,ea)|0)>>3];c[da>>2]=8;h[(yw(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(yw(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(yw(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(yw(ta,1,aa)|0)>>3];c[$>>2]=10;h[(yw(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(yw(ta,1,_)|0)>>3];c[Z>>2]=11;h[(yw(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(yw(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(yw(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(yw(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(yw(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(yw(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(yw(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(yw(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(yw(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(yw(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(yw(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(yw(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(yw(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(yw(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(yw(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(yw(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(yw(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(yw(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(yw(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(yw(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(yw(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(yw(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(yw(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(yw(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(yw(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(yw(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(yw(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(yw(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(yw(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(yw(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(yw(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(yw(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(yw(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(yw(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(yw(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(yw(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(yw(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(yw(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(yw(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(yw(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(yw(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(yw(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(yw(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(yw(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(yw(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function qk(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function rk(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;uv(4,0,8896,b);uv(4,0,8936,a);i=a;return}function sk(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}$Z(a);c[d>>2]=0;i=b;return}function tk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+976>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+952>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+960>>3];h[a+8>>3]=+h[d+1088>>3];h[e+8>>3]=+h[d+1064>>3];h[f+8>>3]=+h[d+1072>>3];i=i;return}function uk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;e=i;i=i+72|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=a+4|0;w=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[w+64>>3]=+h[b>>3];h[w+72>>3]=+h[b+8>>3];xw(p,1,+h[w>>3],o);xw(q,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+48>>3],n);n=a+536|0;a=c[n>>2]|0;o=c[(c[c[v>>2]>>2]|0)+8>>2]|0;x=+h[o+24>>3];y=+h[o+16>>3];z=+h[o+72>>3];A=+h[o+64>>3];o=k;w=p;c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];w=j;o=q;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];bk(t,a,x,y,k,z,A,j);j=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[j+656>>3]- +h[t>>3];xw(r,1,+h[j>>3],m);xw(s,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+48>>3],l);l=c[n>>2]|0;n=c[(c[c[v>>2]>>2]|0)+8>>2]|0;A=+h[n+24>>3];z=+h[n+16>>3];y=+h[n+72>>3];x=+h[n+64>>3];n=g;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=f;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];dk(u,l,A,z,g,y,x,f);h[d+8>>3]=+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+640>>3]- +h[u>>3];i=e;return}function vk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1312>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1288>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1296>>3];h[a+8>>3]=+h[d+1200>>3];h[e+8>>3]=+h[d+1176>>3];h[f+8>>3]=+h[d+1184>>3];i=i;return}function wk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;e=i;i=i+72|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=a+4|0;w=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[w+88>>3]=+h[b>>3];h[w+80>>3]=+h[b+8>>3];xw(p,1,+h[w+8>>3],o);xw(q,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+56>>3],n);n=a+536|0;a=c[n>>2]|0;o=c[(c[c[v>>2]>>2]|0)+8>>2]|0;x=+h[o+40>>3];y=+h[o+32>>3];z=+h[o+88>>3];A=+h[o+80>>3];o=k;w=p;c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];w=j;o=q;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];dk(t,a,x,y,k,z,A,j);j=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[j+632>>3]- +h[t>>3];xw(r,1,+h[j+8>>3],m);xw(s,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+56>>3],l);l=c[n>>2]|0;n=c[(c[c[v>>2]>>2]|0)+8>>2]|0;A=+h[n+40>>3];z=+h[n+32>>3];y=+h[n+88>>3];x=+h[n+80>>3];n=g;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=f;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];bk(u,l,A,z,g,y,x,f);h[d+8>>3]=+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+648>>3]- +h[u>>3];i=e;return}function xk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1200>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1176>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1184>>3];h[a+8>>3]=+h[d+1312>>3];h[e+8>>3]=+h[d+1288>>3];h[f+8>>3]=+h[d+1296>>3];i=i;return}function yk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;e=i;i=i+72|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=a+4|0;w=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[w+80>>3]=+h[b>>3];h[w+88>>3]=+h[b+8>>3];xw(p,1,+h[w+8>>3],o);xw(q,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+56>>3],n);n=a+536|0;a=c[n>>2]|0;o=c[(c[c[v>>2]>>2]|0)+8>>2]|0;x=+h[o+40>>3];y=+h[o+32>>3];z=+h[o+88>>3];A=+h[o+80>>3];o=k;w=p;c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];w=j;o=q;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];dk(t,a,x,y,k,z,A,j);j=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[j+632>>3]- +h[t>>3];xw(r,1,+h[j+8>>3],m);xw(s,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+56>>3],l);l=c[n>>2]|0;n=c[(c[c[v>>2]>>2]|0)+8>>2]|0;A=+h[n+40>>3];z=+h[n+32>>3];y=+h[n+88>>3];x=+h[n+80>>3];n=g;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=f;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];bk(u,l,A,z,g,y,x,f);h[d+8>>3]=+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+648>>3]- +h[u>>3];i=e;return}function zk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+976>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+952>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+960>>3];h[a+8>>3]=+h[d+1088>>3];h[e+8>>3]=+h[d+1064>>3];h[f+8>>3]=+h[d+1072>>3];i=i;return}function Ak(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0;e=i;i=i+72|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=a+4|0;w=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[w+64>>3]=+h[b>>3];h[w+72>>3]=+h[b+8>>3];xw(p,1,+h[w>>3],o);xw(q,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+48>>3],n);n=a+536|0;a=c[n>>2]|0;o=c[(c[c[v>>2]>>2]|0)+8>>2]|0;x=+h[o+24>>3];y=+h[o+16>>3];z=+h[o+72>>3];A=+h[o+64>>3];o=k;w=p;c[o+0>>2]=c[w+0>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];w=j;o=q;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];dk(t,a,x,y,k,z,A,j);j=c[(c[c[v>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[j+640>>3]- +h[t>>3];xw(r,1,+h[j>>3],m);xw(s,1,+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+48>>3],l);l=c[n>>2]|0;n=c[(c[c[v>>2]>>2]|0)+8>>2]|0;A=+h[n+24>>3];z=+h[n+16>>3];y=+h[n+72>>3];x=+h[n+64>>3];n=g;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=f;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];bk(u,l,A,z,g,y,x,f);h[d+8>>3]=+h[(c[(c[c[v>>2]>>2]|0)+8>>2]|0)+656>>3]- +h[u>>3];i=e;return}function Bk(a){a=a|0;c[a+4>>2]=101;c[a>>2]=2;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=112;c[a+80>>2]=2;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=194;c[a+160>>2]=2;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=204;c[a+240>>2]=2;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;i=i;return}function Ck(a){a=a|0;i=i;return}function Dk(a,b){a=a|0;b=b|0;i=i;return}function Ek(a){a=a|0;i=i;return}function Fk(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 8984}function Gk(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function Hk(a){a=a|0;i=i;return 8984}function Ik(a,b){a=a|0;b=b|0;i=i;return 0}function Jk(a){a=a|0;a=i;i=i+8|0;uv(8,1,8992,a);if((c[41080>>2]|0)==0){i=a;return 0}ae[c[10400]&255](8);i=a;return 0}function Kk(a){a=a|0;i=i;return c[9272+(a<<2)>>2]|0}function Lk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;uv(21,1,9296,n);n=a+4|0;o=a+416|0;p=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[(c[o>>2]|0)+112>>3];h[b>>3]=p;a=Kk(0)|0;c[m>>2]=1;c[m+4>>2]=a;a=m+8|0;h[k>>3]=p;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];uv(21,0,9328,m);p=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+32>>3]- +h[(c[o>>2]|0)+128>>3];h[b+8>>3]=p;m=Kk(1)|0;c[l>>2]=2;c[l+4>>2]=m;m=l+8|0;h[k>>3]=p;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];uv(21,0,9328,l);p=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+8>>3]- +h[(c[o>>2]|0)+16>>3];h[b+16>>3]=p;l=Kk(2)|0;c[j>>2]=3;c[j+4>>2]=l;l=j+8|0;h[k>>3]=p;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];uv(21,0,9328,j);p=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+24>>3]- +h[(c[o>>2]|0)+224>>3];h[b+24>>3]=p;j=Kk(3)|0;c[g>>2]=4;c[g+4>>2]=j;j=g+8|0;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];uv(21,0,9328,g);p=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[(c[o>>2]|0)+240>>3];h[b+32>>3]=p;g=Kk(4)|0;c[f>>2]=5;c[f+4>>2]=g;g=f+8|0;h[k>>3]=p;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];uv(21,0,9328,f);p=+h[c[(c[c[n>>2]>>2]|0)+8>>2]>>3]- +h[(c[o>>2]|0)+64>>3];h[b+40>>3]=p;b=Kk(5)|0;c[e>>2]=6;c[e+4>>2]=b;b=e+8|0;h[k>>3]=p;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];uv(21,0,9328,e);if((c[41132>>2]|0)==0){i=d;return 0}ae[c[10400]&255](21);i=d;return 0}function Mk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+8>>3];i=i;return}function Nk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b>>3];i=i;return}function Ok(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+88>>3];i=i;return}function Pk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+80>>3];i=i;return}function Qk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b>>3];i=i;return}function Rk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+88>>3];i=i;return}function Sk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+80>>3];i=i;return}function Tk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b>>3]*.5;i=i;return}function Uk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+88>>3]*1.2;i=i;return}function Vk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b>>3];i=i;return}function Wk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+88>>3];i=i;return}function Xk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+80>>3];i=i;return}function Yk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=+h[(c[a+416>>2]|0)+152>>3]+-273.15;i=i;return}function Zk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+784>>3]=+h[(c[a+416>>2]|0)+168>>3]*1.0e-5;i=i;return}function _k(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[(c[a+416>>2]|0)+184>>3]+-273.15;i=i;return}function $k(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+32>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+Av(c[b+536>>2]|0,f,9352,9344,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3]=1.0/j;i=d;return}function al(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+184>>3]=1.0- +h[(c[a+416>>2]|0)+32>>3];i=i;return}function bl(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+48>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+Av(c[b+536>>2]|0,f,9472,9464,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3]=1.0/j;i=d;return}function cl(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=c[a+416>>2]|0;Oh(d,c[a+536>>2]|0,+h[e+168>>3],+h[e+184>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[d>>3];i=b;return}function dl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+176>>3]=1.0- +h[(c[a+416>>2]|0)+48>>3];i=i;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+168>>3];m=+h[k+184>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];$h(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=+h[f>>3];i=b;return}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;xw(k,1,+h[(c[o>>2]|0)+48>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[o>>2]|0;r=+h[q+168>>3];s=+h[q+184>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];Qh(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[(c[o>>2]|0)+48>>3],g);g=c[j>>2]|0;m=c[o>>2]|0;r=+h[m+168>>3];u=+h[m+184>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];Xh(n,g,r,u,e);u=+h[n>>3];r=+h[(c[o>>2]|0)+168>>3];do{if(u!=0.0){v=r/u}else{if(r==0.0){v=r;break}v=r/+Av(c[j>>2]|0,u,9576,9568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+736>>3]=s-v;i=d;return}function gl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+168>>3];m=+h[k+184>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];Xh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[f>>3];i=b;return}function hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+168>>3];m=+h[k+184>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];Zh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+720>>3]=+h[f>>3];i=b;return}function il(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+184>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,9728,9720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}function jl(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+752>>3];j=b+416|0;k=+h[(c[j>>2]|0)+168>>3];do{if(g!=0.0){l=k/g}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,g,9784,9776,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+752>>3];g=+h[(c[j>>2]|0)+168>>3];do{if(l!=0.0){m=g/l}else{if(g==0.0){m=g;break}m=g/+Av(c[b+536>>2]|0,l,9784,9776,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+704|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;y=c[c[e>>2]>>2]|0;m=+h[(c[y+8>>2]|0)+752>>3];l=+h[(c[j>>2]|0)+168>>3];do{if(m!=0.0){z=y;A=l/m}else{if(l==0.0){z=y;A=l;break}g=l/+Av(f,m,9784,9776,+h[y>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=g}}while(0);n=+Av(f,A+-.3778957546290221,9816,9776,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+704|0;x=w;h[x>>3]=o;i=d;return}}function kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+704>>3];i=i;return}function ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+688>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+696>>3];i=i;return}function ml(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+696>>3];k=1.0-j;l=+h[g+176>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,9904,9896,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+696>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+688>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+680|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+680|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,9904,9896,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+680|0;z=y;h[z>>3]=w;i=d;return}function nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+752>>3];k=+pd(1.0e-13,+(+h[(c[b+416>>2]|0)+168>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,9944,9936,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+672>>3]=m*.6221042453709779;i=d;return}function ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+176>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+48>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,10016,10008,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}function pl(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+64>>3];i=i;return}function ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=1.0- +h[b>>3];i=i;return}function rl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+112>>3]),1.0e-13);k=+h[g>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,10056,10048,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=j/.018015268-j/.0289586+34.53205610768476;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}j=+Av(c[b+536>>2]|0,k,10096,10088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}function tl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+240>>3];i=i;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+16>>3]+-273.15;i=i;return}function vl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[(c[a+416>>2]|0)+224>>3];i=i;return}function wl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+24>>3];l=+h[a+16>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Tj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3]=+h[f>>3];i=b;return}function xl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+24>>3];l=+h[a+16>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];_j(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3]=+h[f>>3];i=b;return}function yl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Jj(d,c[a+536>>2]|0,+h[f+24>>3],+h[f+16>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+248>>3]=+h[d>>3];i=b;return}function zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+248>>3];k=+pd(1.0e-13,+(+h[g+24>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,10200,10192,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+256>>3]=m*.6221042453709779;i=d;return}function Al(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+248>>3];k=+h[g+24>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,j,10272,10264,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+248>>3];j=+h[g+24>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+Av(c[b+536>>2]|0,l,10272,10264,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+264|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+248>>3];l=+h[y+24>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+Av(f,m,10272,10264,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+Av(f,A+-.3778957546290221,10304,10264,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+264|0;x=w;h[x>>3]=o;i=d;return}}function Bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b>>3]- +h[b+264>>3];i=i;return}function Cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b>>3]- +h[b+280>>3];i=i;return}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+280>>3];k=1.0-j;l=+h[g+112>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,10392,10384,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+280>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+272>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+312|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+312|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,10392,10384,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+312|0;z=y;h[z>>3]=w;i=d;return}function El(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+24>>3]- +h[(c[a+416>>2]|0)+168>>3];i=i;return}function Fl(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+264>>3];g=+h[e+256>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+192>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+200|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+200|0;r=q;h[r>>3]=o;i=d;return}s=l/+Av(c[b+536>>2]|0,g,10432,10424,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+200|0;r=q;h[r>>3]=o;i=d;return}function Gl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Ly(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+384>>3]=+h[(a?e+744|0:e+336|0)>>3];i=b;return}function Hl(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+200>>3];h[b+208>>3]=-(d*+h[(!(d>=0.0)?b+744|0:b+336|0)>>3]);i=i;return}function Il(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+200>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+48|0}else{e=b}h[b+96>>3]=-(d*+h[e>>3]);i=i;return}function Jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Ly(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+48|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+136|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a;f=a;g=+h[e>>3];j=f;k=j+136|0;l=k;h[l>>3]=g;i=b;return}}function Kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+24>>3]*1.0e-5;i=i;return}function Ll(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+4|0;xw(k,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[q+24>>3];s=+h[q+16>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];Kj(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3],g);g=c[j>>2]|0;m=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[m+24>>3];u=+h[m+16>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];Mi(n,g,r,u,e);u=+h[n>>3];n=c[c[o>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+24>>3];if(u!=0.0){v=e;w=r/u;x=s-w;y=v;z=y+320|0;A=z;h[A>>3]=x;i=d;return}if(r==0.0){v=e;w=r;x=s-w;y=v;z=y+320|0;A=z;h[A>>3]=x;i=d;return}B=r/+Av(c[j>>2]|0,u,10464,10456,+h[n>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[o>>2]>>2]|0)+8>>2]|0;w=B;x=s-w;y=v;z=y+320|0;A=z;h[A>>3]=x;i=d;return}function Ml(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+24>>3];l=+h[a+16>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Mi(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3]=+h[f>>3];i=b;return}function Nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[(c[a+416>>2]|0)+216>>3]*+h[b+328>>3];i=i;return}function Ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+216>>3]*+h[b+320>>3];i=i;return}function Pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b>>3]*+h[b+216>>3];i=i;return}function Ql(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+16>>3];i=i;return}function Rl(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+144>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+8|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+144|0;p=o;h[p>>3]=m;i=b;return}else{g=d+32|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+144|0;p=o;h[p>>3]=m;i=b;return}}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=1.0- +h[b+8>>3];i=i;return}function Tl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+160>>3]),1.0e-13);k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+568|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+568|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,10616,10608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+568|0;p=o;h[p>>3]=m;i=d;return}function Ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8>>3];k=j/.018015268-j/.0289586+34.53205610768476;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+576|0;q=p;h[q>>3]=n;i=d;return}j=+Av(c[b+536>>2]|0,k,10656,10648,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+576|0;q=p;h[q>>3]=n;i=d;return}function Vl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+128>>3];i=i;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+32>>3]+-273.15;i=i;return}function Xl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[(c[a+416>>2]|0)+112>>3];i=i;return}function Yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+40>>3];m=+h[(c[g>>2]|0)+152>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Ki(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+448>>3]=+h[f>>3];i=b;return}function Zl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+40>>3];m=+h[(c[g>>2]|0)+152>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Ji(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+472>>3]=+h[f>>3];i=b;return}function _l(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;xw(k,1,+h[(c[o>>2]|0)+32>>3],j);j=b+536|0;p=c[j>>2]|0;q=b+4|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];s=+h[(c[o>>2]|0)+152>>3];t=f;u=k;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];Di(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[(c[o>>2]|0)+32>>3],g);g=c[j>>2]|0;r=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];v=+h[(c[o>>2]|0)+152>>3];o=e;m=l;c[o+0>>2]=c[m+0>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];Ji(n,g,r,v,e);v=+h[n>>3];n=c[c[q>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+40>>3];if(v!=0.0){w=e;x=r/v;y=s-x;z=w;A=z+464|0;B=A;h[B>>3]=y;i=d;return}if(r==0.0){w=e;x=r;y=s-x;z=w;A=z+464|0;B=A;h[B>>3]=y;i=d;return}C=r/+Av(c[j>>2]|0,v,10752,10744,+h[n>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[q>>2]>>2]|0)+8>>2]|0;x=C;y=s-x;z=w;A=z+464|0;B=A;h[B>>3]=y;i=d;return}function $l(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;k=a+4|0;l=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+40>>3];m=+h[(c[g>>2]|0)+152>>3];g=d;a=e;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Li(f,j,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[f>>3];i=b;return}function am(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;ki(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+40>>3],+h[(c[a+416>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]=+h[d>>3];i=b;return}function bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+408>>3];k=+pd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,10928,10920,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+416>>3]=m*.6221042453709779;i=d;return}function cm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+408>>3];k=+h[g+40>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,j,11008,11e3,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+408>>3];j=+h[g+40>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+Av(c[b+536>>2]|0,l,11008,11e3,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+424|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+408>>3];l=+h[y+40>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+Av(f,m,11008,11e3,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+Av(f,A+-.3778957546290221,11048,11e3,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+424|0;x=w;h[x>>3]=o;i=d;return}}function dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+424>>3];i=i;return}function em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[(c[a+416>>2]|0)+32>>3]- +h[b+440>>3];i=i;return}function fm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+440>>3];k=1.0-j;l=+h[g+184>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,11144,11136,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+440>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+432>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,11144,11136,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}function gm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+32>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Tj(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[f>>3];i=b;return}function hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+32>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];_j(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3]=+h[f>>3];i=b;return}function im(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+144>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+392>>3]=-(b*+h[(!(b>=0.0)?d+608|0:d+480|0)>>3]);i=i;return}function jm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Jj(d,c[a+536>>2]|0,+h[f+40>>3],+h[f+32>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[d>>3];i=b;return}function km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=+pd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,11192,11184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+528>>3]=m*.6221042453709779;i=d;return}function lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=+h[g+40>>3];do{if(j!=0.0){l=k/j}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,j,11256,11248,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=+h[g+520>>3];j=+h[g+40>>3];do{if(l!=0.0){m=j/l}else{if(j==0.0){m=j;break}m=j/+Av(c[b+536>>2]|0,l,11256,11248,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+536|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;g=c[c[e>>2]>>2]|0;y=c[g+8>>2]|0;m=+h[y+520>>3];l=+h[y+40>>3];do{if(m!=0.0){z=g;A=l/m}else{if(l==0.0){z=g;A=l;break}j=l/+Av(f,m,11256,11248,+h[g>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=j}}while(0);n=+Av(f,A+-.3778957546290221,11288,11248,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+536|0;x=w;h[x>>3]=o;i=d;return}}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+8>>3]- +h[b+536>>3];i=i;return}function nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+8>>3]- +h[b+552>>3];i=i;return}function om(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+552>>3];k=1.0-j;l=+h[g+160>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,11376,11368,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+552>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+544>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+584|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+584|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,11376,11368,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+584|0;z=y;h[z>>3]=w;i=d;return}function pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=+h[b+40>>3]- +h[b+24>>3];i=i;return}function qm(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+208>>3];g=+h[e+200>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+360>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}s=l/+Av(c[b+536>>2]|0,g,11416,11408,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}function rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=+h[b+368>>3]- +h[b+200>>3];i=i;return}function sm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+352>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+656|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,e,11448,11440,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+656|0;p=o;h[p>>3]=m;i=d;return}function tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[(c[a+416>>2]|0)+144>>3]- +h[b+368>>3];i=i;return}function um(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+104>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+624>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+648|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+648|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,e,11472,11464,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+648|0;p=o;h[p>>3]=m;i=d;return}function vm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+368>>3];h[b+376>>3]=d*+h[(!(d>=0.0)?b+336|0:b+608|0)>>3];i=i;return}function wm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=+h[b+376>>3]+ +h[b+208>>3];i=i;return}function xm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3];k=+h[g+344>>3]- +h[g+352>>3]*+h[g+320>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,11496,11488,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=-+h[b+376>>3]- +h[b+392>>3];i=i;return}function zm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+368>>3];h[b+128>>3]=d*+h[(!(d>=0.0)?b:b+8|0)>>3];i=i;return}function Am(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+128>>3]+ +h[b+96>>3];i=i;return}function Bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+216>>3];k=+h[g+120>>3]- +h[g>>3]*+h[g+352>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,11496,11512,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+48|0;p=o;h[p>>3]=m;i=d;return}function Cm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+64>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+64|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+fz(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+64>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+72>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+72|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+fz(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+72>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+8>>3]=k;dz(a,0)|0;a=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+64>>3]=+h[a>>3];h[f+72>>3]=+h[a+8>>3];i=b;return}function Dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=-+h[b+128>>3]- +h[b+144>>3];i=i;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function Fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function Gm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+4|0;xw(k,1,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[q+40>>3];s=+h[q+32>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];Kj(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8>>3],g);g=c[j>>2]|0;m=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[m+40>>3];u=+h[m+32>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];Mi(n,g,r,u,e);u=+h[n>>3];n=c[c[o>>2]>>2]|0;e=c[n+8>>2]|0;r=+h[e+40>>3];if(u!=0.0){v=e;w=r/u;x=s-w;y=v;z=y+592|0;A=z;h[A>>3]=x;i=d;return}if(r==0.0){v=e;w=r;x=s-w;y=v;z=y+592|0;A=z;h[A>>3]=x;i=d;return}B=r/+Av(c[j>>2]|0,u,11528,11520,+h[n>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[o>>2]>>2]|0)+8>>2]|0;w=B;x=s-w;y=v;z=y+592|0;A=z;h[A>>3]=x;i=d;return}function Hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;xw(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+32>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Mi(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[f>>3];i=b;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[(c[a+416>>2]|0)+104>>3]*+h[b+600>>3];i=i;return}function Jm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3];k=+h[g+168>>3]- +h[g+8>>3]*+h[g+624>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,11672,11664,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}function Km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+488>>3];k=+h[g+616>>3]- +h[g+624>>3]*+h[g+592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,11672,11688,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}function Lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+88>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+88|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+fz(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+88>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+80|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+fz(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+80>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+8>>3]=k;dz(a,1)|0;a=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+88>>3]=+h[a>>3];h[f+80>>3]=+h[a+8>>3];i=b;return}function Mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+488>>3]*+h[b+592>>3];i=i;return}function Nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+8>>3]*+h[b+488>>3];i=i;return}function Om(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+96>>3];i=i;return}function Pm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+8>>3];i=i;return}function Qm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+192>>3]=+h[b+96>>3];i=i;return}function Rm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+8>>3]*.5;i=i;return}function Sm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+96>>3]*1.2;i=i;return}function Tm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b+8>>3];i=i;return}function Um(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+96>>3];i=i;return}function Vm(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);a[d]=0;i=c;return 0}function Wm(a){a=a|0;i=i;return}function Xm(a){a=a|0;i=i;return 0}function Ym(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;uv(9,1,11696,e);if((c[41084>>2]|0)!=0){ae[c[10400]&255](9)}uv(9,1,11720,d);if((c[41084>>2]|0)!=0){ae[c[10400]&255](9)}uv(9,1,11744,b);if((c[41084>>2]|0)!=0){ae[c[10400]&255](9)}uv(9,1,11768,a);if((c[41084>>2]|0)==0){i=a;return 0}ae[c[10400]&255](9);i=a;return 0}function Zm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+80>>3];i=i;return}function _m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+88>>3];i=i;return}function $m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+96>>3];i=i;return}function an(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b>>3];i=i;return}function bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24>>3]=+h[b+8>>3];i=i;return}function cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+88>>3]*1.2;i=i;return}function dn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=+h[(c[a+416>>2]|0)+152>>3]+-273.15;i=i;return}function en(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+96>>3]*1.2;i=i;return}function fn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32>>3]=+h[b>>3]*.5;i=i;return}function gn(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+32>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+Av(c[b+536>>2]|0,f,11800,11792,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3]=1.0/j;i=d;return}function hn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+184>>3]=1.0- +h[(c[a+416>>2]|0)+32>>3];i=i;return}function jn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+184>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,11920,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+712|0;p=o;h[p>>3]=m;i=d;return}function kn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+8>>3]*.5;i=i;return}function ln(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+80>>3];i=i;return}function mn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+784>>3]=+h[(c[a+416>>2]|0)+168>>3]*1.0e-5;i=i;return}function nn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+88>>3];i=i;return}function on(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[(c[a+416>>2]|0)+184>>3]+-273.15;i=i;return}function pn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=c[a+416>>2]|0;Oh(d,c[a+536>>2]|0,+h[e+168>>3],+h[e+184>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[d>>3];i=b;return}function qn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+752>>3];j=b+416|0;k=+h[(c[j>>2]|0)+168>>3];do{if(g!=0.0){l=k/g}else{if(k==0.0){l=k;break}l=k/+Av(c[b+536>>2]|0,g,11976,11968,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l+-.3778957546290221!=0.0){f=c[c[e>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+752>>3];g=+h[(c[j>>2]|0)+168>>3];do{if(l!=0.0){m=g/l}else{if(g==0.0){m=g;break}m=g/+Av(c[b+536>>2]|0,l,11976,11968,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=m+-.3778957546290221;o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+704|0;x=w;h[x>>3]=o;i=d;return}else{f=c[b+536>>2]|0;y=c[c[e>>2]>>2]|0;m=+h[(c[y+8>>2]|0)+752>>3];l=+h[(c[j>>2]|0)+168>>3];do{if(m!=0.0){z=y;A=l/m}else{if(l==0.0){z=y;A=l;break}g=l/+Av(f,m,11976,11968,+h[y>>3],(a[b+319|0]|0)!=0|0);z=c[c[e>>2]>>2]|0;A=g}}while(0);n=+Av(f,A+-.3778957546290221,12008,11968,+h[z>>3],(a[b+319|0]|0)!=0|0);o=.6221042453709779/n;p=c[e>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+704|0;x=w;h[x>>3]=o;i=d;return}}function rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+752>>3];k=+pd(1.0e-13,+(+h[(c[b+416>>2]|0)+168>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+Av(c[b+536>>2]|0,k,12096,12088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+672>>3]=m*.6221042453709779;i=d;return}function sn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+192>>3]=+h[b+96>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b>>3];i=i;return}function un(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[(c[b+416>>2]|0)+48>>3];f=e/.018015268-e/.0289586+34.53205610768476;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+Av(c[b+536>>2]|0,f,12168,12160,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3]=1.0/j;i=d;return}function vn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+176>>3]=1.0- +h[(c[a+416>>2]|0)+48>>3];i=i;return}function wn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+168>>3];m=+h[k+184>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];$h(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=+h[f>>3];i=b;return}function xn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=b+416|0;xw(k,1,+h[(c[o>>2]|0)+48>>3],j);j=b+536|0;p=c[j>>2]|0;q=c[o>>2]|0;r=+h[q+168>>3];s=+h[q+184>>3];q=f;t=k;c[q+0>>2]=c[t+0>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];Qh(m,p,r,s,f);s=+h[m>>3];xw(l,1,+h[(c[o>>2]|0)+48>>3],g);g=c[j>>2]|0;m=c[o>>2]|0;r=+h[m+168>>3];u=+h[m+184>>3];m=e;f=l;c[m+0>>2]=c[f+0>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];Xh(n,g,r,u,e);u=+h[n>>3];r=+h[(c[o>>2]|0)+168>>3];do{if(u!=0.0){v=r/u}else{if(r==0.0){v=r;break}v=r/+Av(c[j>>2]|0,u,12272,12264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+736>>3]=s-v;i=d;return}function yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+168>>3];m=+h[k+184>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];Xh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[f>>3];i=b;return}function zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;xw(e,1,+h[(c[g>>2]|0)+48>>3],b+16|0);j=c[a+536>>2]|0;k=c[g>>2]|0;l=+h[k+168>>3];m=+h[k+184>>3];k=d;g=e;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];Zh(f,j,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+720>>3]=+h[f>>3];i=b;return}function An(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+704>>3];i=i;return}function Bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+688>>3]=+h[(c[a+416>>2]|0)+48>>3]- +h[b+696>>3];i=i;return}function Cn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+696>>3];k=1.0-j;l=+h[g+176>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+Av(c[b+536>>2]|0,k,12424,12416,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+696>>3];n=s;o=r;p=q}}while(0);k=p*287.117;p=1.0-m;m=+h[n+688>>3];if(p!=0.0){t=n;u=m/p;v=u*461.51805;w=k+v;x=t;y=x+680|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.51805;w=k+v;x=t;y=x+680|0;z=y;h[z>>3]=w;i=d;return}l=m/+Av(c[b+536>>2]|0,p,12424,12416,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.51805;w=k+v;x=t;y=x+680|0;z=y;h[z>>3]=w;i=d;return}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+176>>3]),1.0e-13);k=+h[(c[b+416>>2]|0)+48>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}q=k/+Av(c[b+536>>2]|0,j,12464,12456,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}function En(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+8>>3];i=i;return}function Fn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+80>>3];i=i;return}function Gn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+88>>3];i=i;return}function Hn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+96>>3];i=i;return}function In(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b>>3];i=i;return}function Jn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+8>>3];i=i;return}function Kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12496]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+264>>3],1.0e-10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+264>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(12512,$v(+h[(c[g>>2]|0)+264>>3],12504)|0)|0;g=c[22538]|0;j=e;k=13856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12496]=1;i=d;return}function Ln(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12736]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+256>>3],1.0e-10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(12744,$v(+h[(c[g>>2]|0)+256>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12736]=1;i=d;return}function Mn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12888]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+72>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(12896,$v(+h[(c[g>>2]|0)+72>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[12888]=1;i=d;return}function Nn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13024]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+64>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+64>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(13032,$v(+h[(c[g>>2]|0)+64>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13024]=1;i=d;return}function On(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13160]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+248>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+248>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(13168,$v(+h[(c[g>>2]|0)+248>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13160]=1;i=d;return}function Pn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13304]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+240>>3],1.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=dw(13312,$v(+h[(c[g>>2]|0)+240>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13304]=1;i=d;return}function Qn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13432]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(13440,$v(+h[(c[g>>2]|0)+232>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13432]=1;i=d;return}function Rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13560]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+224>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(13568,$v(+h[(c[g>>2]|0)+224>>3],12504)|0)|0;g=c[22538]|0;j=e;k=16880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13560]=1;i=d;return}function Sn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13696]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+208>>3],1.0e-10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+208>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(13704,$v(+h[(c[g>>2]|0)+208>>3],12504)|0)|0;g=c[22538]|0;j=e;k=13856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13696]=1;i=d;return}function Tn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13880]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+200>>3],1.0e-10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=dw(13888,$v(+h[(c[g>>2]|0)+200>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[13880]=1;i=d;return}function Un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14056]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(14064,$v(+h[(c[g>>2]|0)+56>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14056]=1;i=d;return}function Vn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14200]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+48>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+48>>3],1.0)|0)<<24>>24==0)){i=d;return}b=dw(14208,$v(+h[(c[g>>2]|0)+48>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14200]=1;i=d;return}function Wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14368]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+192>>3],-1.0e10)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+192>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=dw(14376,$v(+h[(c[g>>2]|0)+192>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14368]=1;i=d;return}function Xn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14544]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+184>>3],1.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+184>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=dw(14552,$v(+h[(c[g>>2]|0)+184>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14544]=1;i=d;return}function Yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14704]&1){i=d;return}g=b+416|0;b=Ly(+h[(c[g>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(Ky(+h[(c[g>>2]|0)+176>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=dw(14712,$v(+h[(c[g>>2]|0)+176>>3],12504)|0)|0;g=c[22538]|0;j=e;k=14840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[14704]=1;i=d;return}



function Hz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=_Z(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=_Z(c[y>>2]<<2)|0;Iz(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;E_(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;E_(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Tx(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Jz(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){E_(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;E_(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;$Z(x);$Z(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;wv(5,1,77832,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ic(q|0,77864,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;wv(5,0,77872,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=41600;K=c[10400]|0;ae[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=77880;aa=$;yv(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];wv(5,0,77872,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=41600;K=c[10400]|0;ae[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=77880;aa=$;yv(O,aa,g);return 0}function Iz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;G_(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}de[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Jz(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=a_(d,4)|0;r=a_(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;$Z(q);$Z(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;$Z(q);$Z(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){$Z(q);$Z(r);i=o;return v|0}if((n|0)==0){v=-1;$Z(q);$Z(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uv(5,1,77984,p);Kz(s,d,f,c[g>>2]|0,j,l,m);if((c[41068>>2]|0)==0){v=-1;$Z(q);$Z(r);i=o;return v|0}ae[c[10400]&255](5);v=-1;$Z(q);$Z(r);i=o;return v|0}function Kz(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;G_(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];uv(5,0,78016,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Lz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=jc(78032,78056)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=bd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((bd(n|0)|0)!=10);q=c[b+152>>2]|0;r=a_(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=a_(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=a_(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=cc(n|0,78064,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=cc(n|0,78064,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=a_(s,8)|0;x=v}}while(0);hc(78072,j|0)|0;hc(78128,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hc(78088,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];hc(78112,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(78128)|0;Xc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Mz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}$Z(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){$Z(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}$Z(l);i=d;return 0}function Nz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Oz(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Pz(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[41084>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];uv(9,1,78192,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uv(9,0,78304,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}ae[c[10400]&255](9);g=1;i=b;return g|0}function Pz(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;cA(b);g=f+540|0;de[c[(c[g>>2]|0)+84>>2]&127](f)|0;de[c[(c[g>>2]|0)+36>>2]&127](f)|0;de[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;se[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Pz(b,1.0);if((c[41084>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}uv(9,1,78328,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(9,0,78392,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(9,0,78352,s)}uv(9,1,78416,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;uv(9,0,78488,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];uv(9,0,78440,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;uv(9,0,78576,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(9,0,78512,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;uv(9,0,78664,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];uv(9,0,78608,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}ae[c[10400]&255](9);uv(9,1,78696,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=de[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;uv(9,0,78488,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];uv(9,0,78440,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}ae[c[10400]&255](9);ae[c[10400]&255](9);i=d;return}function Rz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[41084>>2]|0)!=0){Dy(b,9)}if((c[41144>>2]|0)==0){i=d;return}uv(24,1,78720,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){uv(24,1,78760,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];uv(24,0,78784,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}ae[c[10400]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}uv(24,1,78840,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];uv(24,0,78864,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}ae[c[10400]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){uv(24,1,78896,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];uv(24,0,78784,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}ae[c[10400]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){uv(24,1,78920,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;uv(24,0,78944,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}ae[c[10400]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){uv(24,1,78992,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?79064:79072;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?79064:79072;t=(a[(c[l>>2]|0)+n|0]|0)!=0?79064:79072;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;uv(24,0,79016,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}ae[c[10400]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){uv(24,1,79080,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;uv(24,0,79104,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}ae[c[10400]&255](24)}ae[c[10400]&255](24);i=d;return}function Sz(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;uv(9,0,79152,z);if((f|0)==0){Ay(b);By(b);C=6}else{if((a[f]|0)!=0){Tz(b,f,g)}Ay(b);By(b);if((a[f]|0)==0){C=6}}if((C|0)==6){de[c[(c[A>>2]|0)+84>>2]&127](b)|0;de[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(y_(d,80640)|0)==0|0;f=(y_(d,80648)|0)==0;z=(y_(d,80656)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;wv(1,0,79200,y);wv(1,0,79232,x);c[w>>2]=80640;c[w+4>>2]=80448;wv(1,0,79256,w);c[v>>2]=80648;c[v+4>>2]=80528;wv(1,0,79256,v);c[u>>2]=80656;c[u+4>>2]=80576;wv(1,0,79256,u);yv(c[b+536>>2]|0,79288,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(y_(e,c[79312+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;wv(1,0,79344,s);wv(1,0,79232,r);t=1;do{u=c[79376+(t<<2)>>2]|0;c[q>>2]=c[79312+(t<<2)>>2];c[q+4>>2]=u;wv(1,0,79256,q);t=t+1|0;}while((t|0)<7);yv(c[b+536>>2]|0,79288,p)}}while(0);p=c[79272+(D<<2)>>2]|0;c[o>>2]=c[79184+(D<<2)>>2];c[o+4>>2]=p;uv(9,0,79408,o);o=(D|0)==2;if(o){p=c[79376+(F<<2)>>2]|0;c[n>>2]=c[79312+(F<<2)>>2];c[n+4>>2]=p;uv(9,0,79448,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Uz(b,F,j)|0;break}if((D|0)==3){Vz(b,j);I=0;break}else{yv(c[b+536>>2]|0,79488,m)}}}while(0);if((ez(b,1)|0)!=0){J=-2;Rz(b);K=15;L=K;M=79512;N=M;uv(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];jy(b,R,V);W=200;xy(b);X=206;Cy(b);Y=201;sy(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=209;yy(b);i=k;return J|0}if((Yy(b,1)|0)!=0){J=-3;Rz(b);K=15;L=K;M=79512;N=M;uv(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];jy(b,R,V);W=200;xy(b);X=206;Cy(b);Y=201;sy(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=209;yy(b);i=k;return J|0}m=(Oy(b,1)|0)==0;J=m?I:-4;Rz(b);K=15;L=K;M=79512;N=M;uv(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];jy(b,R,V);W=200;xy(b);X=206;Cy(b);Y=201;sy(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=209;yy(b);i=k;return J|0}function Tz(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];uv(9,0,80672,z);z=iw(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;yv(C,80712,y)}uv(9,0,80752,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=jw(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=Yz(c[d+(C*112|0)+4>>2]|0)|0;E=jw(A,D)|0;$Z(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((z_(E,80792,6)|0)==0){if((c[41084>>2]|0)==0){break}}else{D=z_(E,80800,6)|0;if((c[41084>>2]|D|0)==0){break}}c[v>>2]=E;wv(9,0,80808,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;pw(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];uv(9,0,80776,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}uv(9,0,80864,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=jw(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=Yz(c[G+(w*112|0)+4>>2]|0)|0;v=jw(A,F)|0;$Z(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];wv(9,0,80888,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;pw(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];uv(9,0,80776,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}uv(9,0,80944,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=jw(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=Yz(c[t+(x*112|0)+4>>2]|0)|0;K=jw(A,C)|0;$Z(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];wv(9,0,80888,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;pw(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];uv(9,0,80776,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}uv(9,0,80968,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=jw(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=Yz(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=jw(A,u)|0;$Z(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];wv(9,0,81016,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;pw(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;uv(9,0,81e3,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}uv(9,0,81072,l);l=b+144|0;if((c[l>>2]|0)<=0){gw(A);i=f;return}o=b+32|0;b=0;do{x=jw(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=Yz(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=jw(A,n)|0;$Z(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];wv(9,0,81120,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;pw(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?79064:79072;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;uv(9,0,81104,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));gw(A);i=f;return}function Uz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;iy(a,+h[a+240>>3]);xy(a);Cy(a);sy(a);Ey(a);Fz(a);ty(a);xy(a);e=Wz(a,b,c)|0;Cy(a);sy(a);yy(a);Cy(a);i=d;return e|0}function Vz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;iy(b,+h[b+240>>3]);xy(b);Cy(b);Hz(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=a_(c[y>>2]|0,8)|0;A=b+124|0;B=a_(c[A>>2]|0,4)|0;C=b+128|0;D=a_(c[C>>2]|0,1)|0;E=b+132|0;F=a_(c[E>>2]|0,4)|0;G=b+536|0;xv(c[G>>2]|0,(z|0)!=0|0,79544,t);xv(c[G>>2]|0,(B|0)!=0|0,79544,s);xv(c[G>>2]|0,(D|0)!=0|0,79544,r);xv(c[G>>2]|0,(F|0)!=0|0,79544,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[41084>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];ic(x|0,79560,p|0)|0;p=jc(x|0,79576)|0;c[o>>2]=79592;sd(p|0,79584,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];sd(p|0,79584,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Nd(10,p|0)|0;H=p}uv(9,1,79600,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;de[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uv(9,0,79624,l);if((c[41084>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(H|0,79648,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];sd(H|0,79648,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Nd(10,H|0)|0}if((ez(b,0)|0)!=0){break a}if((Yy(b,0)|0)!=0){break a}if((Oy(b,0)|0)!=0){break a}Fy(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);ae[c[10400]&255](9);if((c[41084>>2]|0)!=0){Xc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}$Z(z);$Z(B);$Z(D);$Z(F)}else{h[b+304>>3]=1.0;de[c[w+80>>2]&127](b)|0}uy(b);if((Hz(b,1,1)|0)!=1){i=e;return}de[c[(c[v>>2]|0)+80>>2]&127](b)|0;uy(b);if((Hz(b,1,1)|0)!=1){i=e;return}wv(1,0,79656,f);i=e;return}function Wz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=Zz(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){uv(9,0,79760,u);if((c[b+184>>2]|0)==0){se[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}$Z(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){uv(9,0,79792,t);se[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;$Z(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){uv(9,1,79864,s);t=_Z(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Pz(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Pz(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}uv(9,1,79888,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];uv(9,0,79912,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];uv(9,0,79912,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];uv(9,0,79912,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[41084>>2]|0)!=0){ae[c[10400]&255](9);ae[c[10400]&255](9)}$Z(t);_z(v);H=Zz(b)|0;if((c[H>>2]|0)!=0){$=H;break}uv(9,0,79936,n);$Z(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}uv(9,0,79968,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){uv(9,0,79984,l);Xz($,d,1,e);Qz(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Pz($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){$Z(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){$Z(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){$Z(v);c[l>>2]=0}Xz($,d,0,e);Qz(b,$);+Pz($,1.0)}else{uv(9,0,80008,j)}uv(9,1,80032,g);Qz(b,$);b=Oz($)|0;if((c[41084>>2]|0)!=0){ae[c[10400]&255](9)}_z($);y=b;i=f;return y|0}function Xz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=_Z(c[p>>2]<<3)|0;r=q;s=+Pz(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;aA(a,r);$Z(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=80160;F=E;uv(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;uv(9,0,80072,m);if(!t){$z(a)}switch(b|0){case 3:{G=jA(a,n,e)|0;break};case 2:{G=fA(a)|0;break};case 5:{H=13;break a;break};case 4:{H=12;break a;break};case 1:{G=hA(a)|0;break};case 6:{H=14;break a;break};default:{H=15;break a}}Cy(o);sy(o);yy(o);Cy(o);s=+Pz(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}uv(9,0,80120,k);Qz(o,a);K=s}else{uv(9,0,80136,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){eA(a)|0}else if((H|0)==13){eA(a)|0}else if((H|0)==14){dA(o,a,0)|0}else if((H|0)==15){yv(c[o+536>>2]|0,80096,l)}else if((H|0)==23){aA(a,r);$Z(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=80160;F=E;uv(9,0,F,g);i=f;return}}function Yz(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=C_(b|0)|0;do{if((d|0)==0){e=_Z(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=_Z(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((x_(e,81176,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;E_(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((x_(e,81176,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function Zz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=_Z(64)|0;z=y;xv(0,(y|0)!=0|0,81184,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=a_(Z,8)|0;c[E>>2]=y;xv(0,(y|0)!=0|0,81184,w);w=a_(Z,8)|0;c[F>>2]=w;xv(0,(w|0)!=0|0,81184,v);v=a_(Z,8)|0;c[G>>2]=v;xv(0,(v|0)!=0|0,81184,u);u=a_(Z,8)|0;c[H>>2]=u;xv(0,(u|0)!=0|0,81184,t);t=a_(Z,8)|0;c[I>>2]=t;xv(0,(t|0)!=0|0,81184,s);s=a_(Z,4)|0;t=s;c[J>>2]=t;xv(0,(s|0)!=0|0,81184,r);uv(9,0,81200,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;uv(9,0,81224,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];uv(9,0,81312,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];uv(9,0,81360,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];uv(9,0,81416,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;uv(9,0,81472,l);c[j>>2]=ya;uv(9,0,81544,j);j=a_(sa,8)|0;c[K>>2]=j;xv(0,(j|0)!=0|0,81184,g);g=_Z(sa<<3)|0;c[L>>2]=g;xv(0,(g|0)!=0|0,81184,f);f=_Z(ya<<3)|0;c[M>>2]=f;xv(0,(f|0)!=0|0,81184,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function _z(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+28>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+32>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+36>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+40>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+44>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+48>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+52>>2]|0;if((d|0)!=0){$Z(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;$Z(e);i=b;return}$Z(d);e=a;$Z(e);i=b;return}function $z(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=a_(o,8)|0;q=a_(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=a_(s,8)|0;u=a_(s,8)|0;v=a_(o,8)|0;w=a_(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Pz(b,1.0);s=c[n>>2]|0;if((s|0)>0){E_(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Pz(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){E_(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;uv(9,0,81584,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}$Z(p);$Z(q);$Z(t);$Z(u);$Z(v);$Z(w);i=d;return}function aA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function bA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function cA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function dA(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;yv(c[a+536>>2]|0,81656,d);return 0}function eA(a){a=a|0;a=i;i=i+8|0;yv(0,81688,a);return 0}function fA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[41084>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=a_((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;xv(0,(n|0)!=0|0,81728,b);c[20436]=c[a+60>>2];c[20438]=c[a+48>>2];Kx(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;$Z(n);c[20436]=0;c[20438]=0;n=Oz(a)|0;i=b;return n|0}function gA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[20438];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[20436];h[d>>3]=+Pz(f,1.0);i=e;return}function hA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=_Z(x)|0;z=y;A=_Z(x)|0;x=A;xv(0,(y|0)!=0|0,81760,n);xv(0,(A|0)!=0|0,81760,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[41084>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Pz(a,1.0);h[o>>3]=D;if(D!=0.0){c[20444]=c[a+60>>2];c[20446]=c[a+48>>2];Hx(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[20444]=0;c[20446]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];uv(9,0,81792,l)}D=+Pz(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];uv(9,0,81896,j);j=c[u>>2]|0;do{if((j|0)==2){wv(9,0,81992,f);F=-2;i=b;return F|0}else if((j|0)==4){wv(9,0,82128,d);F=-4;i=b;return F|0}else if((j|0)==3){wv(9,0,82056,e);F=-3;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];wv(9,0,81912,g);F=-1;i=b;return F|0}}while(0);F=Oz(a)|0;i=b;return F|0}function iA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[20446];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[20444];h[d>>3]=+Pz(f,1.0);i=e;return}function jA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;uv(9,1,82184,g);if((c[41084>>2]|0)==0){l=0}else{l=(k|0)/10|0}kA(a,d,k,l,b,j);c[f>>2]=c[j>>2];uv(9,0,82208,f);ae[c[10400]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Oz(a)|0;if((b|0)==0){m=0;i=e;return m|0}wv(9,0,82224,e);m=b;i=e;return m|0}function kA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=_Z(fa(N,M)|0)|0;P=_Z(M<<3)|0;Q=_Z(N)|0;R=Q;S=_Z(N)|0;T=S;V=_Z(N)|0;W=V;X=_Z(N)|0;Y=+h[f>>3];if((c[41084>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];ic(N|0,82272,I|0)|0;I=jc(N|0,82288)|0;c[H>>2]=82304;sd(I|0,82296,H|0)|0;c[G>>2]=82320;sd(I|0,82296,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];sd(I|0,82296,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Nd(10,I|0)|0;c[E>>2]=0;sd(I|0,82328,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(I|0,82336,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];sd(I|0,82336,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Nd(10,I|0)|0;Z=I}else{Z=0}xv(0,(O|0)!=0|0,82344,B);xv(0,(P|0)!=0|0,82344,A);xv(0,(Q|0)!=0|0,82344,z);xv(0,(S|0)!=0|0,82344,y);xv(0,(V|0)!=0|0,82344,x);xv(0,(X|0)!=0|0,82344,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{bA(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Pz(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;bA(a,la);+Pz(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];uv(9,0,82360,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){G_(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);bA(a,R);za=+Pz(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}E_(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}bA(a,T);if(+Pz(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}E_(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}E_(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}bA(a,W);Ba=+Pz(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}bA(a,W);Ba=+Pz(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}E_(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];uv(9,0,82400,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;sd(Z|0,82328,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];sd(Z|0,82336,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(Z|0,82336,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Nd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];wv(9,0,82448,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];wv(9,0,82464,p);yv(0,82480,o)}bA(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){$Z(S);$Z(Q);$Z(V);$Z(X);$Z(P);$Z(O);i=j;return}c[n>>2]=ia;sd(Z|0,82328,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,82336,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,82336,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Nd(10,Z|0)|0;Xc(Z|0)|0;$Z(S);$Z(Q);$Z(V);$Z(X);$Z(P);$Z(O);i=j;return}function lA(a,b){a=a|0;b=b|0;i=i;return}function mA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Sw(3);Vw(0);w=+Nw(0);Sw(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(v|0,82560,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];sd(v|0,82560,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(v|0,82560,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];sd(v|0,82568,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;sd(v|0,82568,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];sd(v|0,82576,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,82560,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,82560,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;sd(v|0,82568,l|0)|0;break}else{c[m>>2]=0-E;sd(v|0,82568,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;sd(v|0,82568,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;sd(v|0,82568,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Nd(10,v|0)|0;Vw(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];sd(v|0,82576,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Nd(10,v|0)|0;Vw(3);i=e;return}function nA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=jc(c[r>>2]|0,82584)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Rd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;xv(t,(s|0)!=0|0,82592,q);c[p>>2]=82648;sd(s|0,82576,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=82656;sd(s|0,82576,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];sd(s|0,82576,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];sd(s|0,82576,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];sd(s|0,82576,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];sd(s|0,82576,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];sd(s|0,82576,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];sd(s|0,82576,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];sd(s|0,82576,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Nd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];sd(s|0,82576,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Nd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function oA(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Sw(3);Xc(d|0)|0;Vw(3);i=b;return}function pA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;kS(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];lS(p,f)|0;qA(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;rA(a,b,82672,c[j>>2]|0,c[g>>2]|0,o,8);$Z(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];lS(p,e)|0;i=d;return}function qA(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=a_(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;xv(c[b+536>>2]|0,(p|0)!=0|0,82952,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function rA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;CA(a,b,d,e,f,h);jS(l,g,fa(fa(f,e)|0,h)|0)|0;if(GQ(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];yv(l,82904,k)}else{i=j;return}}function sA(a){a=a|0;var b=0;b=i;if((uB(a+4|0)|0)!=0){i=b;return}JQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function tA(a){a=a|0;Rc(a|0)|0;Ya()}function uA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=e_(320)|0;G_(q|0,0,320)|0;vA(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Sw(3);t=a+8|0;u=wA(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=xA(a,b,u+s|0)|0;u=q+184|0;yA(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;yA(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;zA(q,c[x>>2]|0,36);if(GQ(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];yv(y,82728,e)}else{rA(a,b,82760,4,11,82680,1);AA((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;rA(a,b,82768,c[g>>2]|0,c[j>>2]|0,e,1);$Z(e);c[f>>2]=0;AA((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;rA(a,b,82776,c[g>>2]|0,c[j>>2]|0,e,1);$Z(e);c[f>>2]=0;BA(a,b,k,g,j,c[r>>2]|0,s);rA(a,b,82792,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;kS(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];qA(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;rA(a,b,82672,c[j>>2]|0,c[g>>2]|0,n,8);kS(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=DA(q+240|0)|0;w=DA(q+264|0)|0;p=DA(q+288|0)|0;CA(a,b,82808,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);$Z(n);$Z(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;RR(s)|0;$Z(v);Vw(3);i=d;return}}function vA(a){a=a|0;var b=0;b=i;ED(a);i=b;return}function wA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(IC(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(IC(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(IC(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function xA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=_Z(e<<2)|0;e=l;c[l>>2]=83360;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=83400;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(IC(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(IC(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(IC(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function yA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;tB(a,b,c);i=d;return}function zA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(sB(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){JQ(d,4);i=e;return}else{HQ(d,0);i=e;return}}function AA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=C_(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=a_((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;xv(0,(o|0)!=0|0,82880,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;N_(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;HA(q,C_(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=a_(1,1)|0;c[d>>2]=q;xv(0,(q|0)!=0|0,82880,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function BA(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=a_(c[f>>2]<<2,4)|0;c[e>>2]=g;xv(c[d+536>>2]|0,(g|0)!=0|0,82928,k);g=s+240|0;f=DA(g)|0;h=s+264|0;t=DA(h)|0;u=s+288|0;v=DA(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=DA(g)|0;D=DA(h)|0;E=DA(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){IA(l,g,A+(v*52|0)+4|0);KA(m,g);if(!(JA(l,m)|0)){F=w;break}G=(c[(LA(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==1){IA(l,b,A+(v*52|0)+4|0);KA(n,b);if(!(JA(l,n)|0)){F=w;break}G=(c[(LA(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){IA(l,v,G+(t*52|0)+4|0);KA(p,v);J=(JA(l,p)|0)&1}else if(f<<24>>24==0){IA(l,h,G+(t*52|0)+4|0);KA(o,h);f=JA(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(LA(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){IA(l,u,y+(t*52|0)+4|0);KA(q,u);F=JA(l,q)|0;M=F?2:0}else if(x<<24>>24==1){IA(l,d,y+(t*52|0)+4|0);KA(r,d);M=(JA(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(LA(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function CA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(C_(d|0)|0)+1;e=m;jS(e,l,20)|0;if(GQ(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];yv(l,82904,k)}jS(e,d,c[f>>2]|0)|0;if(GQ(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];yv(m,82904,j)}else{i=h;return}}function DA(a){a=a|0;var b=0,d=0;b=i;d=c[(pB(a)|0)>>2]|0;i=b;return d|0}function EA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Sw(3);do{if(FQ(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];lS(k,e)|0;k=DA(h+240|0)|0;m=DA(h+264|0)|0;l=DA(h+288|0)|0;CA(a,b,82808,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);sA(h)}else{if((h|0)!=0){break}c[g>>2]=0;Vw(3);i=d;return}}while(0);FA(j);g_(h);c[g>>2]=0;Vw(3);i=d;return}function FA(a){a=a|0;var b=0;b=i;NB(a);i=b;return}function GA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Sw(3);Vw(0);h[j>>3]=+Nw(0);Sw(0);l=k;m=d+4|0;jS(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){jS(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){jS(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);jS(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);jS(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);jS(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(GQ(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];yv(t,82848,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Vw(3);i=e;return}}function HA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((z_(b,83064,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((z_(b,83064,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function IA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;bB(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];TA(a,f);i=e;return}function JA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=RA(a,b)|0;i=c;return d|0}function KA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;UA(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];TA(a,e);i=d;return}function LA(a){a=a|0;var b=0,c=0;b=i;c=MA(NA(a)|0)|0;i=b;return c|0}function MA(a){a=a|0;var b=0,c=0;b=i;c=QA(a)|0;i=b;return c|0}function NA(a){a=a|0;var b=0,d=0;b=i;d=OA((c[a>>2]|0)+16|0)|0;i=b;return d|0}function OA(a){a=a|0;var b=0,c=0;b=i;c=PA(a)|0;i=b;return c|0}function PA(a){a=a|0;i=i;return a|0}function QA(a){a=a|0;i=i;return a|0}function RA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(SA(a,b)|0)^1;i=c;return d|0}function SA(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function TA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];aB(a,e);i=d;return}function UA(a,b){a=a|0;b=b|0;var c=0;c=i;VA(a,WA(b)|0);i=c;return}function VA(a,b){a=a|0;b=b|0;var c=0;c=i;$A(a,b);i=c;return}function WA(a){a=a|0;var b=0,c=0;b=i;c=XA(YA(a+4|0)|0)|0;i=b;return c|0}function XA(a){a=a|0;var b=0,c=0;b=i;c=_A(a)|0;i=b;return c|0}function YA(a){a=a|0;var b=0,c=0;b=i;c=ZA(a)|0;i=b;return c|0}function ZA(a){a=a|0;i=i;return a|0}function _A(a){a=a|0;i=i;return a|0}function $A(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function aB(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function bB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=dB(b)|0;cB(f,b,d,h,WA(b)|0);UA(g,b);do{if(RA(f,g)|0){h=eB(b)|0;if(fB(h,d,gB(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);UA(a,b);i=e;return}function cB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;kB(h);a:do{if((e|0)==0){j=f}else{k=eB(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(lB(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;kB(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;kB(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);VA(a,j);i=g;return}function dB(a){a=a|0;var b=0,d=0;b=i;d=c[(WA(a)|0)>>2]|0;i=b;return d|0}function eB(a){a=a|0;var b=0,c=0;b=i;c=iB(a+8|0)|0;i=b;return c|0}function fB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function gB(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function hB(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function iB(a){a=a|0;var b=0,c=0;b=i;c=jB(a)|0;i=b;return c|0}function jB(a){a=a|0;i=i;return a|0}function kB(a){a=a|0;var b=0;b=i;mB(a,-1);i=b;return}function lB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function mB(a,b){a=a|0;b=b|0;b=i;nB(a,0);i=b;return}function nB(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function oB(a){a=a|0;i=i;return c[a+4>>2]|0}function pB(a){a=a|0;var b=0,c=0;b=i;c=qB(a+8|0)|0;i=b;return c|0}function qB(a){a=a|0;var b=0,c=0;b=i;c=rB(a)|0;i=b;return c|0}function rB(a){a=a|0;i=i;return a|0}function sB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 52:case 20:{h=83016;break};case 13:case 29:{h=83056;break};case 56:{h=83e3;break};case 8:{h=82984;break};case 5:case 21:{h=83024;break};case 60:{h=83048;break};case 9:case 25:{h=83008;break};case 28:{h=83040;break};case 24:{h=82992;break};case 1:case 17:{h=82976;break};case 48:case 16:{h=82968;break};case 12:{h=83032;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=jc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Vc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Xc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function tB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function uB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}vB(d,f,102);f=de[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Xc(wB(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}xB(d);g=h;i=b;return g|0}function vB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;EB(a,b,c);i=d;return}function wB(a){a=a|0;var b=0,d=0;b=i;d=AB(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}



function dx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[12854]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[12854]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){JN(51472,53168,80,25);B=51776;C=51784;cx(51472,53200,51952,B,51856,d,B,B,C,C,80)|0;break}c[12918]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[12918]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}JN(51472,53208,80,34);B=51776;F=51784;cx(51472,53248,51944,B,51856,51672,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[12904]=B;c[12916]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){JN(51472,54032,80,52);I=51776;J=51784;cx(51472,54016,54088,I,51856,G,I,I,J,J,80)|0;break a}c[12904]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[12916]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[12904]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[12916]=F+(c[12904]|0);break b}}}while(0);JN(51472,53960,80,52);B=51776;F=51784;cx(51472,54016,54024,B,51856,q,B,B,F,F,80)|0;break a}}while(0);c[12908]=(c[d>>2]|0)+20;c[q+64>>2]=c[12904];if((c[p>>2]|0)<(c[12916]|0)){JN(51472,53256,80,60);C=51776;F=51784;cx(51472,53320,53328,C,51952,51664,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[12908]|0)){JN(51472,53336,80,60);F=51776;C=51784;cx(51472,53320,53400,F,51952,51632,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){JN(51472,54144,80,24);C=51856;F=51776;B=51784;cx(51472,54176,54184,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[6449]=K;if(!(K<=0.0)){break}JN(51472,53640,80,28);B=51776;cx(51472,52352,53672,B,B,B,B,51856,51592,51784,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){JN(51472,51704,80,49);B=51776;F=51784;cx(51472,51760,51768,B,B,B,B,B,F,F,80)|0;JN(51472,51792,80,47);F=51776;B=51784;cx(51472,51840,51848,F,51856,n,F,F,B,B,80)|0;JN(51472,51864,80,41);B=51776;F=51784;cx(51472,51912,51920,51856,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[51648]=0;K=+h[l>>3];h[6460]=K;L=+h[m>>3];h[6453]=L;A=c[d>>2]|0;c[12854]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[6460]=O;P=+h[m+(F<<3)>>3];h[6453]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[51648]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[12854]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[12864]=p;r=p+(c[w>>2]|0)|0;c[12866]=r;p=r+(c[w>>2]|0)|0;c[12888]=p;F=p+(c[w>>2]|0)|0;c[12858]=F;B=F+(c[d>>2]|0)|0;c[12894]=B;C=B+(c[d>>2]|0)|0;c[12900]=C;c[12890]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[12914]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[6462]=+h[B>>3];a[51584]=0;h[6431]=+h[o+24>>3];J=o+16|0;h[6426]=+h[J>>3];do{if((c[w>>2]|0)!=0){ex(51952,v,w,d,51448,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,51568,B,0,o,q,s,t)|0;if((c[12984]|0)>0){i=y;return 0}if((c[12892]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=51856;Bx(d,o+((c[12858]|0)+ -1<<3)|0,G,g,G)|0;a[51584]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[6426];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[6426]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[6426];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[6461]=O;U=+h[6431];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[12900]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){jx(51448,j,f,g,d,H,I,X)|0;if((c[12984]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[51584]=1;D=197;break d}}else{Y=51448;jx(Y,Y,f,g,d,H,I,X)|0;if((c[12984]|0)>0){i=y;return 0}else{h[e>>3]=+h[6431];c[n>>2]=1;a[51584]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}jx(51448,j,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[51584]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[6462]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[6426]=W;h[J>>3]=W;break}jx(51448,51688,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[6461];a[51584]=1;D=197;break d}}else{W=+h[6431];if(!B){if(P*(W-N)<0.0){break}jx(51448,j,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[51584]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[12900]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){jx(51448,j,f,g,d,G,X,I)|0;if((c[12984]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[51584]=1;D=197;break d}}else{H=51448;jx(H,H,f,g,d,G,X,I)|0;if((c[12984]|0)>0){i=y;return 0}else{h[e>>3]=+h[6431];c[n>>2]=1;a[51584]=1;D=197;break d}}}}while(0);if(a[51584]&1){D=197}else{D=128}}else{h[6431]=+h[e>>3];c[n>>2]=1;gx(d,k+4|0,l,m,f,o+((c[12894]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[12854]=1;e:do{if((B|0)>=1){J=c[12894]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[12854]=X;if((I|0)<(B|0)){I=X}else{break e}}JN(51472,53776,80,39);I=51776;J=51784;cx(51472,53448,53816,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+nx(51928,1);h[6462]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[6462]*4.0*(aa>=ba?aa:ba);h[6451]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){JN(51472,53824,80,60);J=51776;cx(51472,53320,53888,J,J,J,J,51952,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[6430]=ca*.001;U=+hx(d,g,o+((c[12894]|0)+ -1<<3)|0,s,t);if(U>.5/+h[6430]){h[6430]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+GN(51440,z);h[6430]=U;da=U}else{U=+h[o+16>>3];h[6430]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}JN(51472,53728,80,29);J=51776;I=51784;cx(51472,53760,53768,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[6430]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[6461]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[6430]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{ix(51448,f,g,d,b,u,51440,o+((c[12894]|0)+ -1<<3)|0,n,s,t,o+((c[12900]|0)+ -1<<3)|0,o+400|0,o+((c[12858]|0)+ -1<<3)|0,o+((c[12890]|0)+ -1<<3)|0,q,51608,B,k+36|0,51656)|0;if((c[12984]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[6430]}h[6426]=ja;h[o+16>>3]=ja;J=c[12900]|0;X=(c[d>>2]|0)+J|0;c[12910]=X;G=c[d>>2]|0;c[12854]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[6426]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[12854]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[6426];h[o+232>>3]=+h[6426]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}ex(51856,v,w,d,e,j,f,o+((c[12858]|0)+ -1<<3)|0,o+((c[12900]|0)+ -1<<3)|0,J,Y,o+((c[12864]|0)+ -1<<3)|0,o+((c[12866]|0)+ -1<<3)|0,o+((c[12888]|0)+ -1<<3)|0,x,51568,B,0,o,q,s,t)|0;if((c[12984]|0)>0){i=y;return 0}if((c[12892]|0)!=0){JN(51472,54192,80,47);la=51776;ma=51784;cx(51472,51840,54240,51856,la,la,la,la,ma,ma,80)|0;JN(51472,54248,80,38);ma=51776;la=51784;cx(51472,52e3,54240,51856,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}ex(51944,v,w,d,51448,j,f,o+((c[12858]|0)+ -1<<3)|0,o+((c[12900]|0)+ -1<<3)|0,J,Y,o+((c[12864]|0)+ -1<<3)|0,o+((c[12866]|0)+ -1<<3)|0,o+((c[12888]|0)+ -1<<3)|0,x,51568,B,0,o,q,s,t)|0;if((c[12984]|0)>0){i=y;return 0}if((c[12892]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=51856;Bx(d,o+((c[12858]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){JN(51472,53568,80,54);p=51776;cx(51472,53624,53632,p,p,p,p,51952,51688,j,80)|0;break c}else if((D|0)==220){JN(51472,53680,80,34);p=51776;cx(51472,53248,53720,p,p,p,p,51952,j,e,80)|0;break c}else if((D|0)==224){JN(51472,53896,80,49);p=51776;cx(51472,51760,53952,p,p,p,p,51952,51688,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;gx(d,oa,l,m,o+((c[12900]|0)+ -1<<3)|0,o+((c[12894]|0)+ -1<<3)|0,s,t)|0;if((c[12984]|0)>0){D=233;break}p=c[d>>2]|0;c[12854]=1;r=c[12894]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[12854]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+hx(d,o+((c[12900]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[6462];pa=O*V;h[6428]=pa;if(!(pa<=1.0)){D=138;break}O=+h[6431];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[6451]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[6426];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[6426]=V/O}}while(0);kx(51448,f,g,d,b,u,51408,o+((c[12894]|0)+ -1<<3)|0,k,n,s,t,o+((c[12900]|0)+ -1<<3)|0,o+400|0,o+((c[12858]|0)+ -1<<3)|0,o+((c[12890]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,51608,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,51656)|0;if((c[12984]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){ex(51944,v,w,d,51448,j,f,o+((c[12858]|0)+ -1<<3)|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[12864]|0)+ -1<<3)|0,o+((c[12866]|0)+ -1<<3)|0,o+((c[12888]|0)+ -1<<3)|0,x,51568,o+64|0,0,o,q,s,t)|0;if((c[12984]|0)>0){D=233;break f}if((c[12892]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=51856;Bx(d,o+((c[12858]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[6431];V=+h[6426];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}jx(51448,j,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}jx(51448,j,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){jx(51448,j,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[6461];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[6462]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}jx(51448,51688,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[6461];D=197;continue}if(!(U<0.0)){jx(51448,j,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[6461];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[6462]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[6426]=U-O;D=128;continue}else{jx(51448,51688,f,g,d,q+28|0,o+((c[12900]|0)+ -1<<3)|0,o+224|0)|0;if((c[12984]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[6461];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[6431];h[o+16>>3]=+h[6426];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[6428]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[12854]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[6428]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[6428];E=E+1|0;p=B}c[12854]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[12910]=p;switch(p|0){case 2:{JN(51472,52088,80,47);p=51776;cx(51472,51840,52136,p,p,p,p,51856,51448,51784,80)|0;JN(51472,52144,80,48);p=51776;E=51784;cx(51472,52072,52200,p,p,p,p,p,E,E,80)|0;JN(51472,52208,80,45);E=51776;p=51784;cx(51472,52256,52264,E,E,E,E,E,p,p,80)|0;break};case 3:{JN(51472,52272,80,38);p=51776;cx(51472,52e3,52312,p,p,p,p,51856,51448,51784,80)|0;JN(51472,52320,80,28);p=51776;E=51784;cx(51472,52352,52360,p,p,p,p,p,E,E,80)|0;break};case 6:{JN(51472,52368,80,44);E=51776;cx(51472,52416,52424,E,E,E,E,51952,51448,51408,80)|0;JN(51472,52432,80,57);E=51776;p=51784;cx(51472,52496,52504,E,E,E,E,E,p,p,80)|0;break};case 7:{JN(51472,52368,80,44);p=51776;cx(51472,52416,52512,p,p,p,p,51952,51448,51408,80)|0;JN(51472,52520,80,48);p=51776;E=51784;cx(51472,52072,52576,p,p,p,p,p,E,E,80)|0;JN(51472,52584,80,28);E=51776;p=51784;cx(51472,52352,52616,E,E,E,E,E,p,p,80)|0;break};case 8:{JN(51472,52368,80,44);p=51776;cx(51472,52416,52624,p,p,p,p,51952,51448,51408,80)|0;JN(51472,52632,80,37);p=51776;E=51784;cx(51472,52672,52680,p,p,p,p,p,E,E,80)|0;break};case 9:{JN(51472,52368,80,44);E=51776;cx(51472,52416,52688,E,E,E,E,51952,51448,51408,80)|0;JN(51472,52696,80,49);E=51776;p=51784;cx(51472,51760,52752,E,E,E,E,E,p,p,80)|0;JN(51472,52760,80,38);p=51776;E=51784;cx(51472,52e3,52800,p,p,p,p,p,E,E,80)|0;break};case 10:{JN(51472,52368,80,44);E=51776;cx(51472,52416,52808,E,E,E,E,51952,51448,51408,80)|0;JN(51472,52816,80,45);E=51776;p=51784;cx(51472,52256,52864,E,E,E,E,E,p,p,80)|0;JN(51472,52872,80,36);p=51776;E=51784;cx(51472,52912,52920,p,p,p,p,p,E,E,80)|0;break};case 11:{JN(51472,52928,80,40);E=51776;cx(51472,52976,52984,E,E,E,E,51952,51448,51408,80)|0;JN(51472,52992,80,36);E=51776;p=51784;cx(51472,52912,53032,E,E,E,E,E,p,p,80)|0;break};case 12:{JN(51472,52368,80,44);p=51776;cx(51472,52416,53040,p,p,p,p,51952,51448,51440,80)|0;JN(51472,53048,80,45);p=51776;E=51784;cx(51472,52256,53096,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{JN(51472,51960,80,38);E=51776;cx(51472,52e3,52008,E,E,E,E,51856,51448,51784,80)|0;JN(51472,52016,80,48);E=51776;p=51784;cx(51472,52072,52080,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[6431];h[o+24>>3]=+h[6431];h[o+16>>3]=+h[6426];i=y;return 0}else if((D|0)==215){JN(51472,53408,80,39);p=51776;E=51784;cx(51472,53448,53456,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){JN(51472,53464,80,39);E=51776;p=51784;cx(51472,53448,53504,E,E,E,E,E,p,p,80)|0;break c}}}while(0);JN(51472,53512,80,47);A=51776;p=51784;cx(51472,51840,53560,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){JN(51472,53104,80,55);p=51776;A=51784;cx(51472,53160,51856,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){JN(51472,54096,80,39);D=51776;cx(51472,53448,54136,D,D,D,D,51952,j,e,80)|0}if((c[k>>2]|0)==-1){JN(51472,54288,80,46);e=51776;j=51784;cx(51472,54336,54344,e,e,e,e,e,j,j,80)|0;JN(51472,54352,80,47);j=51776;e=51784;cx(51472,51840,54400,51856,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function ex(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[6801]=C;c[t>>2]=0;D=c[e>>2]|0;c[13604]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[13604]|0;E=F+1|0;c[13604]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[6808]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;jx(g,b,k,l,f,o,m,n)|0;if((c[12984]|0)>0){i=v;return 0}D=d;Yd[D&7](f,b,k,e,p,y,z)|0;if((c[12984]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[54472]=0;F=c[e>>2]|0;c[13604]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[54472]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[13604]=F+1;if(!M){break}I=+GN(54464,54408);h[6805]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[6801];do{if((H- +h[g>>3])*I<0.0){jx(g,b,k,l,f,o,m,n)|0;if((c[12984]|0)<=0){break}i=v;return 0}else{G=+h[6805]/I;h[6806]=G;N=c[f>>2]|0;c[13604]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[6806];Q=Q+1|0}c[13604]=N+1}}while(0);Yd[D&7](f,b,k,e,p,y,z)|0;if((c[12984]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[54472]=0;F=c[e>>2]|0;c[13604]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[54472]=1;V=1;W=c[13604]|0}Q=W+1|0;c[13604]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[6801];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;jx(g,F,k,l,f,o,m,n)|0;if((c[12984]|0)>0){i=v;return 0}E=d;Yd[E&7](f,F,k,e,p,y,z)|0;if((c[12984]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[54472]=0;D=c[e>>2]|0;c[13604]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[54472]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[13604]=D+1;if(!aa){i=v;return 0}I=+GN(54464,54408);h[6805]=I;h[F>>3]=I+ +h[F>>3];I=+h[6805]/+h[6801];h[6806]=I;Q=c[f>>2]|0;c[13604]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[6806];R=R+1|0}c[13604]=Q+1}Yd[E&7](f,F,k,e,p,y,z)|0;if((c[12984]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[54472]=0;R=c[e>>2]|0;c[13604]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[54472]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[13604]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[6804]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}jx(g,54432,k,l,f,o,m,n)|0;if((c[12984]|0)<=0){break}i=v;return 0}else{h[6804]=Y;j=c[f>>2]|0;c[13604]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[13604]=j+1}}while(0);ga=d;Yd[ga&7](f,54432,k,e,q,y,z)|0;if((c[12984]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[13614]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){fx(e,54464,54456,R,54432,p,q,r,54424,s,fa,da,x,ca)|0;if((c[12984]|0)>0){ha=76;break}if((c[13614]|0)>1){ha=73;break}jx(g,54424,k,l,f,o,m,n)|0;if((c[12984]|0)>0){ha=76;break}Yd[ga&7](f,54424,k,e,r,y,z)|0;if((c[12984]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[6803];R=51856;Bx(e,r,R,p,R)|0;if((c[13614]|0)==4){i=v;return 0}jx(g,54424,k,l,f,o,m,n)|0;if((c[12984]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function fx(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[13630]=c[o>>2];c[o>>2]=0;h[6811]=0.0;a[54504]=0;t=c[b>>2]|0;c[13620]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+GN(54536,j+(v<<3)|0);if(w==+GN(54536,l+((c[13620]|0)+ -1<<3)|0)){break}y=c[13620]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[6811]){break}h[6811]=B;c[o>>2]=y}else{a[54504]=1}}while(0);v=c[13620]|0;u=v+1|0;c[13620]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[54512]=1;c[13632]=c[p>>2];h[g>>3]=+h[r>>3];t=51856;Bx(b,l,t,k,t)|0;c[p>>2]=1;a[54496]=0;C=0}else{a[54512]=0;c[o>>2]=c[13630];c[13632]=c[p>>2];if(a[54504]&1){h[g>>3]=+h[r>>3];t=51856;Bx(b,l,t,k,t)|0;a[54496]=1;C=1;break}else{t=51856;Bx(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[54496]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[54496]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=51856;Bx(b,k,t,l,t)|0;t=c[b>>2]|0;c[13620]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[13620]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+GN(54536,j+(u<<3)|0);if(!(A!=+GN(54536,k+((c[13620]|0)+ -1<<3)|0))){break}c[n+((c[13620]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[13620]|0;F=u+1|0;c[13620]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[6811]=0.0;a[54504]=0;t=c[b>>2]|0;c[13620]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+GN(54536,j+(v<<3)|0);if(A==+GN(54536,k+((c[13620]|0)+ -1<<3)|0)){break}y=c[13620]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[6811]){break}h[6811]=I;c[o>>2]=y}else{a[54504]=1}}while(0);v=c[13620]|0;u=v+1|0;c[13620]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[54512]=t&1;if(t){a[54496]=0;c[13632]=0;c[p>>2]=1;break}if(!(a[54504]&1)){t=51856;Bx(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=51856;Bx(b,k,t,l,t)|0;t=c[b>>2]|0;c[13620]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[13620]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[13620]|0}u=K+1|0;c[13620]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[13632]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function gx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[6820]=+h[d>>3];h[6819]=+h[e>>3];j=c[a>>2]|0;c[13636]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[6820]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[6820]=o;h[6819]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[6819];a=l+1|0;c[13636]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function hx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[6823]=0.0;e=c[a>>2]|0;c[13642]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[6823]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[13642]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[6822]=0.0;e=c[a>>2]|0;c[13642]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[6822]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[13642]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function ix(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[13660]=0;c[13658]=0;c[13664]=0;h[6835]=+h[b>>3];h[6837]=+hx(f,d,l,0,0);C=c[f>>2]|0;c[13648]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[13648]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[6828]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[13648]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[13648]=G+1}a[54688]=1;c[13650]=0;a[54704]=1;c[C>>2]=(c[C>>2]|0)+1;c[13668]=0;Yd[B&7](b,d,e,q,54672,n,o)|0;b:do{if((c[13668]|0)<0){K=35}else{while(1){if(a[54688]&1){c[E>>2]=(c[E>>2]|0)+1;a[54688]=0;lx(f,b,d,e,q,54624,k,54648,l,r,s,t,g,54672,v,j,n,o,x)|0;h[6827]=1.0e6;if((c[13668]|0)<0|(c[13662]|0)!=0){K=35;break b}c[13664]=0}H=c[f>>2]|0;c[13648]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[13648]=H+1}mx(f,q,s,t)|0;I=c[f>>2]|0;c[13648]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[6828]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[13648]=I+1}N=+hx(f,q,l,0,0);h[6839]=N;if(N<=+h[v>>3]*100.0*+h[6837]){break}J=c[13650]|0;if((J|0)>0){h[z>>3]=N/+h[6840];h[A>>3]=1.0/+(J|0);O=+EN(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[6827]=P;Q=+h[6839];R=P}else{h[6840]=N;Q=N;R=+h[6827]}if(R*Q<=.33){break}J=c[13650]|0;H=J+1|0;c[13650]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[54688]=1}c[C>>2]=(c[C>>2]|0)+1;c[13668]=0;Yd[B&7](b,d,e,q,54672,n,o)|0;if((c[13668]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[13648]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[13648]=H+1}N=+hx(f,q,l,0,0);h[6839]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[13648]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[6828]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[13648]=J+1}}while(0);if(!(a[54704]&1)){break}H=c[f>>2]|0;c[13648]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[13648]=H+1}N=+hx(f,r,l,0,0);h[6833]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[54704]=0}h[b>>3]=+h[6835];G=c[f>>2]|0;c[13648]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[13648]=G+1}if(a[54704]&1){I=(c[13660]|0)+1|0;c[13660]=I;N=.9/(+h[6833]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[6826]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[13662]|0)!=0){I=(c[13664]|0)+1|0;c[13664]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[13668]|0)>-2)){K=53;break}I=(c[13658]|0)+1|0;c[13658]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function jx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[13694]=o;p=+h[b>>3]- +h[a>>3];h[6845]=p;a=c[f>>2]|0;c[13686]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[13686]=a+1;q=+h[6845]}h[6841]=1.0;h[6842]=0.0;p=q/+h[k>>3];h[6846]=p;c[13688]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[6842]=u*t+s/+h[a>>3];p=t*s;h[6841]=p;h[6846]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[13686]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[6842]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[6841];g=g+1|0}c[13686]=a+1}g=v+1|0;c[13688]=g;if((v|0)>=(o|0)){break}r=+h[6845];s=+h[6841];t=+h[6846];u=+h[6842];v=g}i=l;return 0}function kx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[6868]=+h[b>>3];c[13714]=0;c[13722]=0;c[13716]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[6880]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[13710]=(c[I>>2]|0)+1;c[13712]=(c[I>>2]|0)+2;c[13708]=(c[I>>2]|0)+ -1;h[6868]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[13726]=$+1;$=c[13710]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[6871]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[13696]=2;if(($|0)>=2){Y=2;while(1){h[6872]=+h[y+(Y+ -2<<3)>>3];U=+h[6871];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[6872];U=+h[6872]+ +h[k>>3];h[6871]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[13696]=$+1}h[y+($+ -1<<3)>>3]=+h[6871]}h[6878]=0.0;h[6876]=0.0;Y=c[I>>2]|0;c[13696]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[6878]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[6876]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[13696]=Y+1;da=ea}h[6879]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[6878]- +h[6876];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[6853]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[6853]=ha>=ca?ha:ca;h[6871]=.6;h[6872]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[6879]){h[D>>3]=100.0}aa=c[13710]|0;ba=c[13726]|0;if((aa|0)>=(ba|0)){c[13698]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[13696]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[13696]=ba+1}ja=ia+1|0;c[13698]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[13696]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[13696]=ia+1}aa=c[13710]|0;c[13698]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[13696]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[13696]=$+1}la=ba+1|0;c[13698]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[6875]=+hx(f,d,l,0,0);a[55048]=1;c[13700]=0;c[T>>2]=(c[T>>2]|0)+1;c[13730]=0;Yd[m&7](b,d,e,r,54920,o,p)|0;if((c[13730]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;lx(f,b,d,e,r,A,k,54872,l,s,t,u,g,54920,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[13730]|0)<0|(c[13718]|0)!=0){X=70;break}c[13722]=0}ba=c[f>>2]|0;c[13696]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[13696]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[6871]=ca;aa=c[f>>2]|0;c[13696]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[6871];ia=ia+1|0;la=ka}c[13696]=aa+1}mx(f,r,t,u)|0;la=c[f>>2]|0;c[13696]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[13696]=la+1}U=+hx(f,r,l,0,0);h[6880]=U;if(U<=+h[F>>3]*100.0*+h[6875]){X=63;break a}ia=c[13700]|0;if((ia|0)>0){h[O>>3]=U/+h[6882];h[P>>3]=1.0/+(ia|0);ca=+EN(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[6880];oa=ga}else{h[6882]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[13700]|0;c[13700]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[13730]=0;Yd[m&7](b,d,e,r,54920,o,p)|0;if((c[13730]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[13696]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[13696]=ba+1}U=+hx(f,r,l,0,0);h[6880]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[13696]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[13696]=ia+1}}while(0);if((X|0)==70){X=0;a[55048]=0}c[H>>2]=1;if(a[55048]&1){U=+hx(f,s,l,0,0);h[6874]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[6860]=ga;h[6867]=ga*+(ba+1|0);h[6862]=ga;c[13732]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[13696]=1;if((ba|0)>=1){aa=fa(c[13710]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[13696]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+hx(f,r,l,0,0);h[6869]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[6877]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[13696]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[13696]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+hx(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[6877];if((sa>=ca?sa:ca)>+h[6867]){break}ta=+h[6869];ua=Y}else{if(!(ga<=+h[6867]*.5)){break}else{ta=U;ua=ka}}c[13732]=ua+ -1;h[6862]=ta}}while(0);if(!(+h[6853]*+h[6874]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[6868];Y=c[13710]|0;ia=c[13726]|0;if((Y|0)>=(ia|0)){c[13698]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[6871]=ca;ia=c[f>>2]|0;c[13696]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[6871];ja=ja+1|0}c[13696]=ia+1}ja=aa+1|0;c[13698]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[13696]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[13696]=Y+1}if(!(a[55048]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[13718]|0)!=0){aa=(c[13722]|0)+1|0;c[13722]=aa;h[6851]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[13730]|0)>-2)){X=146;break}aa=(c[13714]|0)+1|0;c[13714]=aa;h[6851]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[13716]=(c[13716]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[13716]|0;if((aa|0)<=1){ja=c[13732]|0;c[I>>2]=ja;sa=+(ja+1|0);h[6872]=sa;h[O>>3]=+h[6862]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+EN(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[6851]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[13732];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[13746]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[13732]|0;E=c[13708]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[13710];za=+h[k>>3]*2.0;h[6864]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[13708]|0;Ba=c[13732]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[13710]|0)>=(c[K>>2]|0)|(c[13746]|0)==1){Fa=G;break}G=c[f>>2]|0;c[13696]=1;if((G|0)>=1){E=fa(c[13712]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[13696]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+hx(f,r,l,0,0);h[6870]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[6867];E=xa<=za;if(+h[6877]<=(E?xa:za)){Ea=c[13708]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[6867]*.5){Fa=S;break}}S=c[13710]|0;c[I>>2]=S;h[6862]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[6862]=+h[6869];Fa=Ea}h[6864]=+h[k>>3];ya=+(Fa+1|0);h[6872]=ya;h[O>>3]=+h[6862]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+EN(O,P);h[6851]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[6864];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[6851]=xa;za=+h[k>>3]*xa;h[6864]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[6864]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[13696]=1;if((k|0)<1){break}u=fa(c[13712]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[13696]=k+1}}while(0);Ca=c[f>>2]|0;c[13696]=1;if((Ca|0)>=1){J=fa(c[13710]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[13696]=Ca+1}Ca=c[13710]|0;c[13704]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[13698]=P;s=c[f>>2]|0;c[13696]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[13696]=s+1}P=Ha+1|0;c[13704]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[13730]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[13716]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}jx(b,b,d,e,f,I,q,y)|0;i=N;return 0}function lx(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==3){i=y;return 0}else if((O|0)==4){P=c[q>>2]|0;Q=q+4|0;R=c[Q>>2]|0;S=c[b>>2]|0;T=fa(R+1+(P<<1)|0,S)|0;c[13766]=1;if((T|0)>=1){U=fa(S,R+(P<<1)+1|0)|0;P=(U|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(T|0)){R=R+1|0}else{break}}c[13766]=P?2:U+1|0}ce[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[13800]=(c[Q>>2]|0)+1+(c[q>>2]<<1);W=75}else if((O|0)==5){R=q+4|0;T=(c[R>>2]|0)+(c[q>>2]|0)|0;S=T+1|0;c[13792]=S;X=c[b>>2]|0;c[13782]=(T|0)<(X|0)?S:X;X=c[q>>2]|0;c[13800]=S+X;c[13786]=X+T;T=(c[b>>2]|0)/(S|0)|0;c[13796]=T+1;S=c[x>>2]|0;c[13794]=S+ -1;c[13804]=S+T;c[s>>2]=0;h[6895]=+V(+(+h[t>>3]));T=c[13782]|0;c[13768]=1;if((T|0)<1){W=75;break}S=r;X=1;while(1){Y=c[b>>2]|0;Z=c[13792]|0;c[13774]=X;_=(Z|0)<0;b:do{if(_?(X|0)>=(Y|0):(X|0)<=(Y|0)){$=Z;aa=X;ba=X;while(1){ca=(ba-aa|0)/($|0)|0;c[13770]=ca+1;da=ba+ -1|0;ea=e+(da<<3)|0;h[p+((c[13794]|0)+ca<<3)>>3]=+h[ea>>3];ga=f+(da<<3)|0;h[p+((c[13804]|0)+ca<<3)>>3]=+h[ga>>3];ha=+h[ea>>3];h[N>>3]=ha;if(!(ha>=0.0)){ia=-ha}else{ia=ha}ha=+h[l>>3]*+h[ga>>3];if(!(ha>=0.0)){ja=-ha}else{ja=ha}ha=ia>=ja?ia:ja;ka=+h[n+(da<<3)>>3];if(!(ka>=0.0)){la=-ka}else{la=ka}h[6892]=+h[6895]*(ha>=la?ha:la);h[N>>3]=+h[l>>3]*+h[ga>>3];ha=+GN(55136,N);h[6892]=ha;ga=c[13774]|0;da=ga+ -1|0;ea=e+(da<<3)|0;ka=+h[ea>>3];ma=ha+ka-ka;h[6892]=ma;h[ea>>3]=+h[ea>>3]+ma;ea=f+(da<<3)|0;h[ea>>3]=+h[j>>3]*+h[6892]+ +h[ea>>3];ea=ga+Z|0;c[13774]=ea;if(!(_?(ea|0)>=(Y|0):(ea|0)<=(Y|0))){break b}$=c[13792]|0;aa=c[13768]|0;ba=ea}}}while(0);Yd[S&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}Y=c[b>>2]|0;_=c[13792]|0;Z=c[13768]|0;c[13774]=Z;ba=(_|0)<0;c:do{if(ba?(Z|0)>=(Y|0):(Z|0)<=(Y|0)){aa=_;$=Z;ea=Z;while(1){ga=(ea-$|0)/(aa|0)|0;c[13770]=ga+1;da=ea+ -1|0;ca=e+(da<<3)|0;h[ca>>3]=+h[p+((c[13794]|0)+ga<<3)>>3];ma=+h[p+((c[13804]|0)+ga<<3)>>3];ga=f+(da<<3)|0;h[ga>>3]=ma;ka=+h[ca>>3];h[N>>3]=ka;if(!(ka>=0.0)){na=-ka}else{na=ka}ka=+h[l>>3]*ma;if(!(ka>=0.0)){oa=-ka}else{oa=ka}ka=na>=oa?na:oa;ma=+h[n+(da<<3)>>3];if(!(ma>=0.0)){pa=-ma}else{pa=ma}h[6892]=+h[6895]*(ka>=pa?ka:pa);h[N>>3]=+h[l>>3]*+h[ga>>3];ka=+GN(55136,N);h[6892]=ka;ga=c[13774]|0;ma=+h[e+(ga+ -1<<3)>>3];ha=ka+ma-ma;h[6892]=ha;ma=1.0/ha;h[6901]=ma;da=ga-(c[R>>2]|0)|0;ca=(da|0)>1?da:1;c[13776]=ca;da=c[b>>2]|0;qa=(c[q>>2]|0)+ga|0;ra=(da|0)<=(qa|0)?da:qa;c[13778]=ra;sa=fa(c[13786]|0,ga)|0;ta=sa-(c[q>>2]|0)|0;c[13780]=ta;c[13766]=ca;if((ca|0)<=(ra|0)){sa=~da;da=~qa;qa=~((sa|0)>(da|0)?sa:da);da=(ca|0)>(qa|0)?ca:qa;ha=ma;qa=ca;while(1){ca=qa+ -1|0;h[p+(ca+ta<<3)>>3]=(+h[o+(ca<<3)>>3]- +h[g+(ca<<3)>>3])*ha;if((qa|0)>=(ra|0)){break}ha=+h[6901];qa=qa+1|0}c[13766]=da+1}qa=ga+_|0;c[13774]=qa;ra=c[13768]|0;if(!(ba?(qa|0)>=(Y|0):(qa|0)<=(Y|0))){ua=ra;break c}aa=c[13792]|0;$=ra;ea=qa}}else{ua=Z}}while(0);Z=ua+1|0;c[13768]=Z;if((ua|0)<(T|0)){X=Z}else{W=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[13788]=0;h[6895]=+V(+(+h[t>>3]));X=c[b>>2]|0;c[13766]=1;d:do{if((X|0)>=1){T=r;R=1;while(1){S=R+ -1|0;ha=+h[e+(S<<3)>>3];h[N>>3]=ha;if(!(ha>=0.0)){va=-ha}else{va=ha}Q=f+(S<<3)|0;ha=+h[l>>3]*+h[Q>>3];if(!(ha>=0.0)){wa=-ha}else{wa=ha}ha=va>=wa?va:wa;ma=+h[n+(S<<3)>>3];if(!(ma>=0.0)){xa=-ma}else{xa=ma}h[6892]=+h[6895]*(ha>=xa?ha:xa);h[N>>3]=+h[l>>3]*+h[Q>>3];ha=+GN(55136,N);h[6892]=ha;Q=(c[13766]|0)+ -1|0;S=e+(Q<<3)|0;ma=+h[S>>3];ka=ha+ma-ma;h[6892]=ka;h[6899]=+h[S>>3];U=f+(Q<<3)|0;h[6903]=+h[U>>3];h[S>>3]=ka+ +h[S>>3];h[U>>3]=+h[j>>3]*+h[6892]+ +h[U>>3];Yd[T&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ka=1.0/+h[6892];h[6901]=ka;U=c[b>>2]|0;c[13772]=1;S=c[13788]|0;if((U|0)>=1){ma=ka;Q=1;P=0;while(1){h[p+(P+S<<3)>>3]=(+h[o+(P<<3)>>3]- +h[g+(P<<3)>>3])*ma;if((Q|0)>=(U|0)){break}Z=Q;ma=+h[6901];Q=Q+1|0;P=Z}c[13772]=U+1}c[13788]=S+(c[b>>2]|0);P=c[13766]|0;Q=P+ -1|0;h[e+(Q<<3)>>3]=+h[6899];h[f+(Q<<3)>>3]=+h[6903];R=P+1|0;c[13766]=R;if((P|0)>=(X|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){W=42;break}c[13788]=0;X=c[b>>2]|0;if((c[41104>>2]|0)==0){W=42;break}R=_Z(X*20|0)|0;T=F;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(14,1,55232,F);T=E;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(14,0,55256,E);uv(14,1,55264,D);c[13770]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[C>>2]=T+1;P=C+4|0;h[k>>3]=ma;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];uv(14,0,55272,C);T=(c[13770]|0)+1|0;c[13770]=T;}while((T|0)<(c[b>>2]|0))}ae[c[10400]&255](14);uv(14,1,55328,B);c[13766]=1;if((X|0)>=1){T=R+1|0;P=c[13788]|0;Q=1;do{Z=p+(Q+ -1+P<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[13772]=1;Z=P;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[A>>2]=R;ba=A+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ic(R|0,55312,A|0)|0;ba=c[13772]|0;c[13772]=ba+1;if((ba|0)>=(X|0)){break}Z=c[13788]|0;Y=ba}c[z>>2]=R;uv(14,0,55320,z);Y=c[13788]|0;Z=c[13766]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];P=Y+(c[b>>2]|0)|0;c[13788]=P;Q=Z+1|0;c[13766]=Q;}while((Z|0)<(X|0))}ae[c[10400]&255](14);ae[c[10400]&255](14);$Z(R);W=42}else{X=c[b>>2]|0;Q=fa(X,X)|0;c[13766]=1;if((Q|0)!=0){X=(Q|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(Q|0)){P=P+1|0}else{break}}c[13766]=X?2:Q+1|0}ce[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){W=42;break}c[13788]=0;P=c[b>>2]|0;if((c[41104>>2]|0)==0){W=42;break}R=_Z(P*20|0)|0;T=M;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(14,1,55232,M);T=L;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];uv(14,0,55256,L);uv(14,1,55264,K);c[13770]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[J>>2]=T+1;Z=J+4|0;h[k>>3]=ma;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];uv(14,0,55272,J);T=(c[13770]|0)+1|0;c[13770]=T;}while((T|0)<(c[b>>2]|0))}ae[c[10400]&255](14);uv(14,1,55288,I);c[13766]=1;if((P|0)>=1){T=R+1|0;Q=c[13788]|0;X=1;do{Z=p+(X+ -1+Q<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[13772]=1;Z=Q;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[H>>2]=R;ba=H+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ic(R|0,55312,H|0)|0;ba=c[13772]|0;c[13772]=ba+1;if((ba|0)>=(P|0)){break}Z=c[13788]|0;Y=ba}c[G>>2]=R;uv(14,0,55320,G);Y=c[13788]|0;Z=c[13766]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];Q=Y+(c[b>>2]|0)|0;c[13788]=Q;X=Z+1|0;c[13766]=X;}while((Z|0)<(P|0))}ae[c[10400]&255](14);ae[c[10400]&255](14);$Z(R);W=42}}while(0);if((W|0)==42){tx(p,b,b,q+80|0,m)|0;i=y;return 0}else if((W|0)==75){zx(p,55200,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function mx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[13838]=(c[h>>2]|0)+1+(c[e>>2]<<1);Ax(d,55352,a,e,h,e+80|0,b,55360)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{xx(d,a,a,e+80|0,b,55360)|0;i=f;return 0}return 0}function nx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[55368]&1)){a[55368]=1;ox(55416,55384,55464,55400,55448,55472,55456,55480)|0;h[6926]=+(c[13854]|0);f=c[13846]|0;h[6922]=+(f|0);if((c[13866]|0)==0){h[6924]=0.0;c[e>>2]=1-f;g=+FN(55408,e)}else{h[6924]=1.0;c[e>>2]=1-f;g=+FN(55408,e)*.5}h[6925]=g;h[6929]=g*+h[6926];h[6928]=+(c[13862]|0);h[6930]=+(c[13864]|0);j=+h[6934];h[6937]=j;k=1.0/+h[6935];if(!(k>=j)){break}h[6937]=k*(g+1.0)}}while(0);if((Gx(b,55504,1,1)|0)!=0){g=+h[6925];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55512,1,1)|0)!=0){g=+h[6937];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55520,1,1)|0)!=0){g=+h[6926];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55528,1,1)|0)!=0){g=+h[6929];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55536,1,1)|0)!=0){g=+h[6922];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55544,1,1)|0)!=0){g=+h[6924];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55552,1,1)|0)!=0){g=+h[6928];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55560,1,1)|0)!=0){g=+h[6934];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55568,1,1)|0)!=0){g=+h[6930];h[6936]=g;l=g;i=d;return+l}if((Gx(b,55576,1,1)|0)==0){l=+h[6936];i=d;return+l}else{g=+h[6935];h[6936]=g;l=g;i=d;return+l}return 0.0}function ox(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[55688]&1){q=56056;r=c[14014]|0;c[b>>2]=r;s=55992;t=c[13998]|0;c[d>>2]=t;u=56032;v=c[14008]|0;c[e>>2]=v;w=56040;x=+h[7005];h[f>>3]=x;y=56072;z=c[14018]|0;c[g>>2]=z;A=56120;B=+h[7015];h[j>>3]=B;C=56080;D=c[14020]|0;c[k>>2]=D;E=56128;F=+h[7016];h[l>>3]=F;i=m;return 0}a[55688]=1;h[7006]=0.0;h[7e3]=1.0;h[7001]=2.0;px(56056,55992,56032,56144)|0;h[6996]=+(c[14014]|0);c[n>>2]=0-(c[13998]|0);G=+FN(55968,n);h[6995]=G;h[7005]=G;H=+h[7001];h[6996]=H/3.0;I=+h[7e3];J=I*.5;h[7003]=J;K=-J;h[o>>3]=K;h[7017]=+qx(55968,o);L=56136;h[7014]=+qx(L,L);h[o>>3]=K;h[6996]=+qx(56112,o);K=+qx(55968,56136);h[6996]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[6996]=K;h[7005]=1.0;M=+h[7006];if(K<1.0&K>M){N=K;while(1){h[7005]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+qx(o,p);h[6997]=K;h[o>>3]=-K;h[6997]=+qx(56024,o);K=+qx(56024,55976);h[6996]=K;h[o>>3]=-K;h[6997]=+qx(56024,o);K=+qx(56024,55976);h[6996]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[7005]=G}G=I/+(c[14014]|0);h[7008]=G;h[7012]=I;c[13996]=1;p=1;O=I;do{h[o>>3]=O*G;O=+qx(o,56048);h[7012]=O;p=p+1|0;c[13996]=p;}while((p|0)<4);h[6995]=+qx(56e3,56096);rx(56160,56e3,56056)|0;h[o>>3]=-+h[7e3];rx(56152,o,56056)|0;rx(56104,55960,56056)|0;h[o>>3]=-+h[6995];rx(56088,o,56056)|0;c[14004]=0;p=c[14040]|0;L=c[14038]|0;P=c[14026]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[14022]|0)){if(Q){c[14018]=p;R=0;S=25;break}if((P-p|0)==3){c[14018]=p+ -1+(c[13998]|0);c[14004]=1;R=1;S=25;break}else{c[14018]=(p|0)<=(P|0)?p:P;a[55696]=1;S=26;break}}else{T=Q&(L|0)==(c[14022]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[14018]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[14018]=(p|0)<=(L|0)?p:L;a[55696]=1;S=26;break}}T=c[14022]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[14018]=(V|0)<=(T|0)?V:T;a[55696]=1;S=26;break}if((P-U|0)==3){c[14018]=((p|0)>=(L|0)?p:L)+ -1+(c[13998]|0);R=0;S=25;break}else{c[14018]=U;a[55696]=1;S=26;break}}}while(0);if((S|0)==25){if(a[55696]&1){S=26}else{W=R}}if((S|0)==26){a[55688]=0;DO(56168)|0;UN(56192,56072,4)|0;lO()|0;W=c[14004]|0}if((W|0)==0){X=(c[14036]|0)!=0|0}else{X=1}c[14004]=X;h[7015]=1.0;X=c[14018]|0;W=1-X|0;c[n>>2]=W;c[13996]=1;if((X|0)<=0){O=+h[7008];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+qx(o,56048);h[7015]=I;n=X+1|0;c[13996]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}sx(56056,55992,56072,56016,56080,56128)|0;q=56056;r=c[14014]|0;c[b>>2]=r;s=55992;t=c[13998]|0;c[d>>2]=t;u=56032;v=c[14008]|0;c[e>>2]=v;w=56040;x=+h[7005];h[f>>3]=x;y=56072;z=c[14018]|0;c[g>>2]=z;A=56120;B=+h[7015];h[j>>3]=B;C=56080;D=c[14020]|0;c[k>>2]=D;E=56128;F=+h[7016];h[l>>3]=F;i=m;return 0}function px(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[55584]&1){l=a[55656]&1;m=c[13916]|0;c[b>>2]=m;n=55632;o=c[13908]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=55680;r=c[13920]|0;c[f>>2]=r;i=g;return 0}a[55584]=1;h[6955]=1.0;h[6949]=1.0;h[6951]=1.0;s=1.0;do{s=s*2.0;h[6949]=s;h[6951]=+qx(55592,55640);h[j>>3]=-s;t=+qx(55608,j);h[6951]=t;}while(t==1.0);h[6950]=1.0;t=+qx(55592,55600);h[6951]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[6950]=v;w=+qx(55592,55600);h[6951]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[6956]=.25;h[6959]=x;h[j>>3]=-s;t=+qx(55608,j);h[6951]=t;y=~~(t+.25);c[13916]=y;t=+(y|0);h[6950]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[6952]=+qx(j,k);w=+qx(55616,55592);h[6951]=w;z=w==s;a[55656]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[6952]=+qx(j,k);w=+qx(55616,55592);h[6951]=w;if(z&w==s){a[55656]=0;A=0}else{A=z}h[j>>3]=u;w=+qx(j,55592);h[6953]=w;h[j>>3]=u;z=w==s&+qx(j,55672)>x;c[13920]=z?A&1:0;c[13908]=0;h[6949]=1.0;h[6951]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[13908]=k;s=x*t;h[6949]=s;h[6951]=+qx(55592,55640);h[j>>3]=-s;w=+qx(55608,j);h[6951]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=55632;o=c[13908]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=55680;r=c[13920]|0;c[f>>2]=r;i=g;return 0}function qx(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function rx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[7025]=g;j=1.0/+(c[d>>2]|0);h[7034]=j;h[7033]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+qx(f,56264);h[7027]=k;h[7029]=g;h[7030]=g;h[7031]=g;h[7032]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[7025]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+qx(f,56264);h[7027]=g;h[f>>3]=g*k;k=+qx(f,56264);h[7029]=k;h[7031]=0.0;c[14052]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[7031]=q;c[14052]=b+1;n=q}h[f>>3]=m*j;p=+qx(f,56264);h[7028]=p;h[f>>3]=p/j;r=+qx(f,56264);h[7030]=r;h[7032]=0.0;o=c[d>>2]|0;c[14052]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[7032]=v;c[14052]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function sx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[14076]=1;c[14084]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[14076]=q;r=l+1|0;c[14084]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[14080]=n;u=n}else{c[14080]=m;c[14084]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[14086]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[14084]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[7041]=x;y=w+-1.0;h[7037]=y;h[7036]=0.0;v=c[b>>2]|0;c[14070]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[7037]=B;if(w<1.0){h[7039]=w}C=+qx(56288,56296);h[7036]=C;e=b+1|0;c[14070]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[7039];h[7036]=A;z=A}}while(0);v=c[f>>2]|0;c[14070]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+qx(k,56352);h[7036]=z;f=E+1|0;c[14070]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function tx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[14092]=1;m=1;do{c[14098]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=ux(j,a+(m+b+(fa(m,l)|0)<<3)|0,56400)|0;q=c[14092]|0;r=p+ -1+q|0;c[14094]=r;c[e+(q+ -1<<2)>>2]=r;r=c[14094]|0;q=c[14092]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[7048]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[7048];t=q}u=fa(t,l)|0;h[7048]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;vx(j,56384,a+(t-l+u<<3)|0,56400)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[14098]|0;c[14090]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[14094]|0;x=fa(w,l)|0;h[7048]=+h[a+(x+b+v<<3)>>3];y=c[14092]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[7048];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=56400;wx(k,56384,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[14090]|0;w=A+1|0;c[14090]=w;}while((A|0)<(u|0))}}while(0);q=c[14092]|0;m=q+1|0;c[14092]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function ux(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[14190]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[7096]=k;l=(c[d>>2]|0)+1|0;c[14190]=l;m=c[a>>2]|0;c[14188]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[7096]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[14190]=l;a=n+1|0;c[14188]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[7096]=v;c[14188]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[7096]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[14188]=f+1;g=C;i=e;return g|0}function vx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[14174]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[14174]=l;i=f;return 0}l=(g|0)%5|0;c[14176]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[14174]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[14174]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[14174]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[14174]=o;i=f;return 0}function wx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[14160]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[14158]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[14158]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[14158]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[14158]=s;i=j;return 0}}while(0);c[14162]=1;c[14164]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[14162]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[14164]=s;u=s}else{u=1}s=c[a>>2]|0;c[14158]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[14162]=t;u=x+(c[g>>2]|0)|0;c[14164]=u;a=w+1|0;c[14158]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function xx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[14110]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[14102]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[14104]=o;p=f+(o+ -1<<3)|0;h[7053]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[7053]}c[k>>2]=(c[d>>2]|0)-m;o=56400;wx(k,56424,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[14102]|0;m=o+1|0;c[14102]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[14108]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[14102]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[7053]=-s;c[k>>2]=g;g=56400;wx(k,56424,a+(p-l<<3)|0,g,f,g)|0;g=c[14108]|0;q=g+1|0;c[14108]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[14102]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=56400;s=+yx(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[7053]=s;q=c[14102]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[14102]=n;}while((q|0)<(m|0));t=c[14110]|0}if((t|0)<1){i=j;return 0}c[14108]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[14102]=n;c[k>>2]=(c[d>>2]|0)-n;b=56400;s=+yx(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[14102]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[14104]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[7053]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[7053]}q=c[14108]|0;m=q+1|0;c[14108]=m;}while((q|0)<(t|0));i=j;return 0}function yx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[7093]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[14180]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[14178]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[7093]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[14178]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[14178]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[7093]=t;u=u+5|0;}while((u|0)<=(m|0));c[14178]=u;k=t;i=g;return+k}}while(0);c[14182]=1;c[14184]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[14182]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[14184]=u;y=u}else{y=1}u=c[a>>2]|0;c[14178]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[7093]=t;x=C+(c[d>>2]|0)|0;c[14182]=x;y=B+(c[f>>2]|0)|0;c[14184]=y;a=z+1|0;c[14178]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function zx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[14120]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[14126]=n;o=c[d>>2]|0;p=c[14120]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[14128]=o;do{if((q|0)>(n|0)){c[14136]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[14124]=s;t=c[e>>2]|0;c[14112]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[14112]=t+1}u=r+1|0;c[14136]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[14136]=o;c[14134]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[14116]=1;t=o;o=1;while(1){c[14138]=o+1;p=t+1|0;c[14136]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[14112]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[14112]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[14130]=s;c[l>>2]=s+1;s=ux(l,a+((c[14120]|0)+b+(fa(o,m)|0)<<3)|0,56400)|0;p=s+ -1|0;c[14118]=p+(c[14120]|0);s=c[14116]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[14118]|0;p=c[14116]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[14120]|0;if((s|0)==(u|0)){y=s}else{h[7061]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[7061];y=u}h[7061]=-1.0/+h[a+(y+b+n<<3)>>3];vx(56520,56488,a+(y-m+n<<3)|0,56400)|0;u=c[14134]|0;z=(c[g+((c[14116]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[14134]=u;A=c[14120]|0;c[14132]=A;z=c[14138]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[14114]=z;B=z;z=A;while(1){A=(c[14118]|0)+ -1|0;c[14118]=A;C=z+ -1|0;c[14132]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[7061]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[7061];F=C}C=56400;wx(56520,56488,a+((c[14120]|0)-m+(fa(c[14116]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[14114]|0;D=C+1|0;c[14114]=D;if((C|0)>=(u|0)){break a}B=D;z=c[14132]|0}}}while(0);n=c[14116]|0;s=n+1|0;c[14116]=s;if((n|0)>=(r|0)){break}t=c[14136]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[14120]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function Ax(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[14144]=n;f=c[d>>2]|0;o=f+ -1|0;c[14156]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[14140]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[14154]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[14142]=k;q=j+(k+ -1<<3)|0;h[7073]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[7073]}k=56400;wx(56616,56584,a+((c[14144]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[14140]|0;f=k+1|0;c[14140]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[14148]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[14140]=k;q=c[14144]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[14154]=s;u=q-s|0;c[14150]=u;q=k-s|0;c[14152]=q;h[7073]=-t;s=56400;wx(56616,56584,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[14148]|0;r=s+1|0;c[14148]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[14140]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[14154]=r;s=o-r|0;c[14150]=s;q=n-r|0;c[14152]=q;r=56400;t=+yx(56616,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[7073]=t;r=c[14140]|0;q=j+(r+ -1<<3)|0;o=c[14144]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[14140]=n;}while((r|0)<(f|0));v=o;w=c[14156]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[14148]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[14140]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[14154]=(n|0)<=(b|0)?n:b;b=56400;t=+yx(56616,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[14140]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[14142]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[7073]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[7073]}n=c[14148]|0;b=n+1|0;c[14148]=b;if((n|0)>=(w|0)){break}o=c[14144]|0;v=b}i=l;return 0}function Bx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[14168]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[14166]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[14166]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[14166]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[14166]=o;i=g;return 0}}while(0);c[14170]=1;c[14172]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[14170]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[14172]=o;q=o}else{q=1}o=c[a>>2]|0;c[14166]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[14170]=p;q=s+(c[f>>2]|0)|0;c[14172]=q;a=r+1|0;c[14166]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function Cx(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+Dx(56776);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+Ex(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+Ex(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+Ex(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+Ex(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function Dx(a){a=a|0;i=i;return+(+h[56784+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function Ex(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function Fx(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+Dx(56816);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Be[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+Ex(b,e);c[E>>2]=2;Be[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){Nx(b,b,f,g,56824,N,56816,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+Ex(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=V_(ga|0,0,Z+ -2|0,0)|0;Z=O_(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}Mx(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Be[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);Cx(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+Ex(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Be[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+Ex(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+Ex(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+Ex(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}Px(b,b,s,t,v,w,x,D)|0;Ox(b,b,f,g,w,x)|0;W=56816;Ox(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Be[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Be[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function Gx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[56848]=1;f=d[b]|0;c[14208]=f;b=d[e]|0;c[14210]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[14208]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[14210]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function Hx(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[66380>>2]=6;DO(66376)|0;UN(67120,j,4)|0;lO()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[15896]=0;c[16502]=0;c[16490]=0;a[65984]=0;t=c[e>>2]|0;c[15450]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[15896]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[15450]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[15450]=1;if((v|0)>=1){x=1;while(1){h[58272+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[15450]=v+1}c[16494]=2;x=c[e>>2]|0;c[15450]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[15452]=1;if((E|0)<1){F=C}else{G=1;while(1){h[58272+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[15452]=E+1;F=+h[B>>3]}h[58272+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[16494]=G;D=G}G=z+1|0;c[15450]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[15896]|0;y=z+1|0;c[15892]=y;c[15450]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[15452]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[58272+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[15452]=x+1}ge[u&63](e,b,61632+(z+ -1<<3)|0)|0;c[16502]=(c[16502]|0)+1;if((c[j>>2]|0)>=1){c[66404>>2]=6;DO(66400)|0;UN(67120,66008,4)|0;UN(67120,61632+((c[15450]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[15452]=1;if((v|0)>=1){A=1;do{UN(67120,b+(A+ -1<<3)|0,8)|0;B=c[15452]|0;A=B+1|0;c[15452]=A;}while((B|0)<(v|0))}lO()|0}v=c[15450]|0;z=v+1|0;c[15450]=z;}while((v|0)<(y|0))}y=c[16490]|0;b:while(1){c[16490]=y+1;c[16402]=1;c[16398]=1;C=+h[7704];h[8200]=C;h[8202]=C;z=c[15892]|0;c[15450]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[61632+(A+ -1<<3)>>3];do{if(!(C<=K)){c[16402]=A;L=+h[61632+(A+ -1<<3)>>3];h[8200]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[16398]=A;L=+h[61632+(A+ -1<<3)>>3];h[8202]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[15450]=z+1;H=O}A=c[e>>2]|0;c[15450]=1;if((A|0)>=1){v=1;while(1){h[63752+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[15450]=A+1}c[15450]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[15452]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=63752+(Q+ -1<<3)|0;h[B>>3]=+h[58272+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[15452]=x+1;P=v}}while(0);v=P+1|0;c[15450]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[15452]=1;if((z|0)>=1){K=+(c[15896]|0);v=1;while(1){A=63752+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[15452]=z+1}v=c[e>>2]|0;c[15450]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[63752+(B<<3)>>3];h[66032+(B<<3)>>3]=K+(K- +h[58272+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[15450]=v+1}ge[u&63](e,66032,66024)|0;A=(c[16502]|0)+1|0;c[16502]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[66428>>2]=6;DO(66424)|0;UN(67120,66008,4)|0;UN(67120,66024,8)|0;B=c[e>>2]|0;c[15452]=1;if((B|0)>=1){E=1;do{UN(67120,66032+(E+ -1<<3)|0,8)|0;G=c[15452]|0;E=G+1|0;c[15452]=E;}while((G|0)<(B|0))}lO()|0}}while(0);K=+h[8253];c:do{if(!(K>=+h[8202])){z=c[e>>2]|0;c[15450]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[63752+(v<<3)>>3];h[66200+(v<<3)>>3]=I+(+h[66032+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[15450]=z+1}ge[u&63](e,66200,66192)|0;A=(c[16502]|0)+1|0;c[16502]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[66452>>2]=6;DO(66448)|0;UN(67120,66008,4)|0;UN(67120,66192,8)|0;B=c[e>>2]|0;c[15452]=1;if((B|0)>=1){E=1;do{UN(67120,66200+(E+ -1<<3)|0,8)|0;G=c[15452]|0;E=G+1|0;c[15452]=E;}while((G|0)<(B|0))}lO()|0}}while(0);I=+h[8274];if(I>=+h[8202]){R=118;break}v=c[e>>2]|0;c[15450]=1;A=c[16402]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[58272+((z*21|0)+ -22+A<<3)>>3]=+h[66200+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[15450]=v+1}h[61632+(A+ -1<<3)>>3]=I}else{z=c[15892]|0;c[15450]=1;if((z|0)>=1){B=c[16402]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[61632+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[15450]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[8200])){E=c[e>>2]|0;c[15450]=1;z=c[16402]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[58272+((B*21|0)+ -22+z<<3)>>3]=+h[66032+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[15450]=E+1}h[8200]=K;h[61632+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[15450]=1;if((B|0)>=1){A=c[16402]|0;v=1;while(1){x=v+ -1|0;h[66200+(x<<3)>>3]=+h[58272+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[63752+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[15450]=B+1}ge[u&63](e,66200,66192)|0;v=(c[16502]|0)+1|0;c[16502]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[66476>>2]=6;DO(66472)|0;UN(67120,66008,4)|0;UN(67120,66192,8)|0;z=c[e>>2]|0;c[15452]=1;if((z|0)>=1){E=1;do{UN(67120,66200+(E+ -1<<3)|0,8)|0;x=c[15452]|0;E=x+1|0;c[15452]=E;}while((x|0)<(z|0))}lO()|0}}while(0);I=+h[8274];if(!(I>+h[8200])){A=c[e>>2]|0;c[15450]=1;v=c[16402]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[58272+((B*21|0)+ -22+v<<3)>>3]=+h[66200+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[15450]=A+1}h[61632+(v+ -1<<3)>>3]=I;break}B=c[15892]|0;c[15450]=1;if((B|0)<1){break}else{S=1}do{z=c[16398]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[15452]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=58272+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[58272+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[58272+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[15452]=E+1}ge[u&63](e,b,61632+(S+ -1<<3)|0)|0;G=(c[16502]|0)+1|0;c[16502]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[66500>>2]=6;DO(66496)|0;UN(67120,66008,4)|0;UN(67120,61632+((c[15450]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[15452]=1;if((x|0)>=1){G=1;do{UN(67120,b+(G+ -1<<3)|0,8)|0;T=c[15452]|0;G=T+1|0;c[15452]=G;}while((T|0)<(x|0))}lO()|0}}while(0);z=c[15450]|0;S=z+1|0;c[15450]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[15450]=1;v=c[16402]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[58272+((A*21|0)+ -22+v<<3)>>3]=+h[66032+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[15450]=B+1}h[61632+(v+ -1<<3)>>3]=+h[8253]}A=c[16490]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[8203]=0.0;h[8249]=0.0;A=c[15892]|0;c[15450]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[8249]=0.0/K;c[15450]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[61632+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[8249]=I;c[15450]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[61632+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[8203]=$;c[15450]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[8203]=I;do{if(!(I<=+h[k>>3])){if((c[16502]|0)>(c[g>>2]|0)){break}a[65984]=0;c[16490]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[15450]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[15452]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[58272+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[15452]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[15450]=v+1}ge[u&63](e,b,f)|0;B=(c[16502]|0)+1|0;c[16502]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[66524>>2]=6;DO(66520)|0;UN(67120,66008,4)|0;UN(67120,s,8)|0;z=c[e>>2]|0;c[15452]=1;if((z|0)>=1){E=1;do{UN(67120,b+(E+ -1<<3)|0,8)|0;x=c[15452]|0;E=x+1|0;c[15452]=E;}while((x|0)<(z|0))}lO()|0;ba=c[16502]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[66644>>2]=6;DO(66640)|0;lO()|0;c[66668>>2]=6;DO(66664)|0;B=c[e>>2]|0;c[15450]=1;if((B|0)>=1){A=1;do{UN(67120,b+(A+ -1<<3)|0,8)|0;v=c[15450]|0;A=v+1|0;c[15450]=A;}while((v|0)<(B|0))}lO()|0;c[66692>>2]=6;DO(66688)|0;UN(67120,s,8)|0;lO()|0}if(a[65984]&1){I=+h[8249];K=+h[8295]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[65984]=1;da=+h[8249]}h[8295]=da;c[16490]=0;y=0}if((c[j>>2]|0)>=0){c[66716>>2]=6;DO(66712)|0;UN(67120,66008,4)|0;lO()|0;c[66740>>2]=6;DO(66736)|0;y=c[e>>2]|0;c[15450]=1;if((y|0)>=1){B=1;do{UN(67120,b+(B+ -1<<3)|0,8)|0;A=c[15450]|0;B=A+1|0;c[15450]=B;}while((A|0)<(y|0))}lO()|0;c[66764>>2]=6;DO(66760)|0;UN(67120,s,8)|0;lO()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[66788>>2]=6;DO(66784)|0;lO()|0}h[8202]=+h[f>>3];c[16504]=0;y=c[15892]|0;c[15450]=1;if((y|0)>=1){B=1;while(1){A=61632+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[15450]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[15452]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=58272+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[66200+(E+ -1<<3)>>3]=+h[58272+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[15452]=v+1}ge[u&63](e,66200,A)|0;c[16504]=(c[16504]|0)+1;c[16502]=(c[16502]|0)+1;E=c[15450]|0;I=+h[61632+(E+ -1<<3)>>3];if(I>=+h[8202]){B=E;continue}h[8202]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[66812>>2]=6;DO(66808)|0;UN(67120,66008,4)|0;UN(67120,65616,8)|0;E=c[e>>2]|0;c[15452]=1;if((E|0)>=1){z=1;do{UN(67120,66200+(z+ -1<<3)|0,8)|0;G=c[15452]|0;z=G+1|0;c[15452]=z;}while((G|0)<(E|0))}lO()|0;B=c[15450]|0}}B=c[15896]|0;c[15450]=1;do{if((B|0)<1){h[7729]=+h[7704];c[15450]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[15460]=E;z=c[e>>2]|0;c[15452]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[66032+(A+ -1<<3)>>3]=(+h[58272+(v+ -21<<3)>>3]+ +h[58272+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[15452]=z+1}ge[u&63](e,66032,63592+(y+ -1<<3)|0)|0;c[16504]=(c[16504]|0)+1;c[16502]=(c[16502]|0)+1;A=c[15450]|0;y=A+1|0;c[15450]=y;}while((A|0)<(B|0));y=c[15896]|0;I=+h[7704];h[7729]=I;c[15450]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[15460]=A;c[15462]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[15452]=1;E=1;while(1){v=E+1|0;c[15464]=v;G=c[e>>2]|0;c[15454]=1;if((G|0)>=1){x=c[15462]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[66200+(T+ -1<<3)>>3]=(+h[58272+(U+x<<3)>>3]+ +h[58272+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[15454]=G+1}ge[u&63](e,66200,66192)|0;c[16504]=(c[16504]|0)+1;c[16502]=(c[16502]|0)+1;T=c[15450]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[15452]|0;la=U+x|0;c[15456]=la;I=+h[7729];h[63912+(la+ -1<<3)>>3]=(+h[8274]+I- +h[63592+(v<<3)>>3]- +h[63592+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[15452]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[15450]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[15896]|0;c[15456]=0;c[15450]=1;E=(y|0)<1;if(E){c[15450]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=V_(A|0,0,y+ -2|0,0)|0;A=O_(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[63912+(U+ -1<<3)>>3]=(+h[61632+(v<<3)>>3]+ka- +h[63592+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[15460]=v+1;c[15456]=(z|1)+A;c[15450]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=63592+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[61632+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[15460]=T+1;c[15450]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[15456]=0;c[15450]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[15450]=1;if((B|0)>=1){A=1;while(1){h[65632+(A+ -1<<3)>>3]=+h[58272+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[15450]=B+1}c[15450]=1;do{if(ma){c[15450]=1}else{A=1;while(1){z=A+1|0;c[15460]=z;v=c[e>>2]|0;c[15452]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=58272+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[58272+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[15452]=v+1}c[15450]=z;if((A|0)<(na|0)){A=z}else{break}}c[15450]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[15460]=A;y=c[e>>2]|0;c[15452]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[58272+(T+oa<<3)>>3]=+h[58272+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[15452]=y+1}c[15450]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=63912;Ix(B,63584,B,65792,66368,q,65952)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[66836>>2]=6;DO(66832)|0;lO()|0}c[q>>2]=2;if((c[16502]|0)>(c[g>>2]|0)){R=312;break}c[66860>>2]=6;DO(66856)|0;lO()|0;B=c[e>>2]|0;c[15450]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[15450]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[66548>>2]=6;DO(66544)|0;UN(67120,g,4)|0;lO()|0;c[66572>>2]=6;DO(66568)|0;UN(67120,65624,8)|0;lO()|0;c[66596>>2]=6;DO(66592)|0;u=c[e>>2]|0;c[15450]=1;if((u|0)>=1){E=1;do{UN(67120,b+(E+ -1<<3)|0,8)|0;z=c[15450]|0;E=z+1|0;c[15450]=E;}while((z|0)<(u|0))}lO()|0;c[66620>>2]=6;DO(66616)|0;UN(67120,s,8)|0;lO()|0;i=r;return 0}else if((R|0)==226){u=c[15896]|0;c[16500]=u-(c[16592]|0);c[15450]=1;E=(u|0)<1;do{if(E){h[8246]=0.0;c[15450]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[61632+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=61632+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[63912+(sa+ -1<<3)>>3]*+h[63592+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[15456]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[15452]=z;h[8246]=0.0;c[15450]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[61632+(v<<3)>>3]*+h[63592+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[8246]=wa;c[15450]=u+1;qa=wa}}while(0);h[8246]=+h[7729]-qa;s=c[e>>2]|0;c[15450]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[66200+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=66200+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[61632+(T+ -1<<3)>>3]*+h[58272+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[15450]=s+1;c[15452]=xa}v=c[e>>2]|0;c[15450]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=65632+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[66200+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[15450]=v+1}if((c[j>>2]|0)>=0){c[66884>>2]=6;DO(66880)|0;UN(67120,65968,8)|0;z=c[e>>2]|0;c[15450]=1;if((z|0)>=1){s=1;do{UN(67120,65632+(s+ -1<<3)|0,8)|0;u=c[15450]|0;s=u+1|0;c[15450]=s;}while((u|0)<(z|0))}lO()|0;c[66908>>2]=6;DO(66904)|0;lO()|0}z=c[e>>2]|0;c[15450]=1;if((z|0)>=1){s=c[15896]|0;v=1;while(1){c[15452]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[61632+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=61632+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[63912+(Aa+ -1<<3)>>3]*+h[58272+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[15456]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[15454]=E;c[15452]=s+1}T=c[e>>2]|0;c[15452]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=61888+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[61632+(Ea+ -1<<3)>>3]*+h[58272+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[15452]=T+1;c[15456]=Ca;c[15454]=Da}za=v+1|0;c[15450]=za;if((v|0)<(z|0)){v=za}else{break}}}c[15452]=0;v=c[e>>2]|0;c[15450]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[61888+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[15452]=Ga;c[15450]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[66932>>2]=6;DO(66928)|0;UN(67120,66e3,4)|0;lO()|0;c[15894]=1;z=1;d:while(1){c[15456]=z;do{if((z|0)>(c[e>>2]|0)){s=c[15894]|0;if((s|0)==1){c[66956>>2]=6;DO(66952)|0;lO()|0;Ix(61888,63584,63912,65792,66368,q,65952)|0;c[66980>>2]=6;DO(66976)|0;lO()|0;c[15894]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[15894]=2;c[15466]=0;c[15468]=0;s=c[e>>2]|0;c[15450]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=V_(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=O_(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=61888+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=61888+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[61888+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[15470]=Na;c[15468]=Ta;c[15466]=Ia;c[15452]=Ma;c[15450]=s+1}c[67004>>2]=6;DO(67e3)|0;lO()|0;c[15466]=0;u=c[e>>2]|0;c[15450]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=61888+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[15466]=Wa;c[15450]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[15466]=T;s=c[e>>2]|0;c[15450]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[15460]=B;Qa=za+la|0;c[15466]=Qa;Pa=B+5|0;c[15462]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[15894]|0)==3){c[67076>>2]=6;DO(67072)|0;Pa=c[15462]|0;Qa=c[15460]|0;c[15452]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{UN(67120,63912+(B+ -1<<3)|0,8)|0;Qa=c[15452]|0;B=Qa+1|0;c[15452]=B;}while((Qa|0)<(Pa|0))}lO()|0}else{c[67052>>2]=6;DO(67048)|0;Pa=c[15462]|0;B=c[15460]|0;c[15452]=B;if((B|0)<=(Pa|0)){x=B;do{UN(67120,61888+(x+ -1<<3)|0,8)|0;B=c[15452]|0;x=B+1|0;c[15452]=x;}while((B|0)<(Pa|0))}lO()|0}Pa=c[15450]|0;x=Pa+1|0;c[15450]=x;if((Pa|0)>=(s|0)){break e}E=c[15456]|0;la=c[15466]|0;za=x}}}while(0);c[67100>>2]=6;DO(67096)|0;lO()|0;z=(c[15456]|0)+6|0}c[67028>>2]=6;DO(67024)|0;UN(67120,66016,4)|0;lO()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ge[p&63](e,b,f)|0;i=r;return 0}function Ix(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[16800]=c[b>>2];c[g>>2]=1;if((c[16800]|0)<1){i=k;return 0}c[g>>2]=0;Jx(a,67200,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[16800]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[16792]=f;c[16798]=g;c[16804]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=V_(a|0,0,g+ -2|0,0)|0;m=O_(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[16784]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=V_(p|0,0,a-n|0,0)|0;p=O_(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[16784]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[16782]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[16782]=j}c[16794]=g;c[16796]=f;c[16802]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[8395]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[8395]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[8395]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[16802]=D;E=v+ -1|0;c[16794]=E;F=w+ -1|0;c[16796]=F;q=D;v=E;w=F}c[16786]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[16788]=t;c[16798]=0;c[16804]=l-g;i=k;return 0}function Jx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[8409]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[8409]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[8409];c[16808]=1;c[16810]=0;n=c[b>>2]|0;c[16822]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[16812]=0;c[16824]=1;do{if((o|0)>=1){p=1;q=c[16810]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[8408]=m;u=(p|0)==(o|0);if(u){l=m*+h[8409];h[8410]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[8408]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[8410]=+h[8410]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[16812]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[16812]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[8408];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[16824]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[16806]=y;c[16814]=x;c[16810]=s;break}else if((D|0)==26){D=0;c[16806]=y;c[16814]=x;c[16810]=s;break}}}while(0);m=+V(+(+h[8410]));h[8410]=m;H=+h[8408];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[16810]|0)+ -1<<3)>>3]=G;G=+h[8410]/+h[8408];h[j+((c[16806]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[16810]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[16808]|0;O=c[16822]|0}}while(0);b=N+O|0;c[16808]=b;o=O+1|0;c[16822]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[16806]=y;c[16814]=x;c[16810]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Kx(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[16848]=n;o=(c[d>>2]|0)-n|0;c[16870]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[16868]=s;a[67416]=1;t=c[b>>2]|0;u=t+1|0;c[16864]=u;v=c[b>>2]|0;w=u+v|0;c[16862]=w;u=w+(c[b>>2]|0)|0;c[16866]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[16856]=w;x=w+(c[d>>2]|0)|0;c[16850]=x;y=x+(c[b>>2]|0)|0;c[16852]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[16858]=z;A=z+(c[d>>2]|0)|0;c[16872]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[16874]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[16846]=C;D=C+(c[b>>2]|0)|0;c[16860]=D;Lx(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,67472,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);DO(67504)|0;lO()|0;i=m;return 0}function Lx(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[8523]=.5;h[8514]=1.0;h[8554]=.1;F=(c[a>>2]|0)+1|0;c[17024]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[17016]=H;I=(c[b>>2]|0)-F|0;c[17070]=I;F=c[j>>2]|0;c[17124]=(F|0)<1?1:F;F=c[a>>2]|0;c[17008]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[17010]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[17010]=J+1}L=c[u>>2]|0;c[17006]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[17006]=L+1}K=j+1|0;c[17008]=K;if((j|0)<(F|0)){j=K}else{break}}}c[17012]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[17012]=H+1}H=c[b>>2]|0;c[17010]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[17008]=M;c[17010]=H+1}N=+h[e>>3];O=N*N;h[8559]=O;h[8545]=+h[8514]/O;h[8546]=+V(+(+h[8523]))/O;c[17014]=0;H=y;y=A;M=0;a:while(1){c[17026]=M;F=M-(c[a>>2]|0)|0;c[17050]=F;j=M+1|0;c[17014]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[17100]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[17038]=L;K=L+G|0;c[17036]=K;if((K|0)>(c[a>>2]|0)){c[17100]=L;G=K-(c[a>>2]|0)|0;c[17038]=G;c[17036]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[8536]=O;L=c[17024]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[8536]=N;R=N}else{R=O}O=+h[e>>3];h[8537]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[8537]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[8537];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[17008]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[17008]=S+1}if((M|0)>=(c[17124]|0)){T=j;U=159;break}while(1){ge[H&63](a,d,68016)|0;if((c[g>>2]|0)==3){DO(68544)|0;UN(68712,68056,4)|0;UN(68712,68016,8)|0;I=c[a>>2]|0;c[17006]=1;if((I|0)>=1){F=1;do{UN(68712,d+(F+ -1<<3)|0,8)|0;L=c[17006]|0;F=L+1|0;c[17006]=F;}while((L|0)<(I|0))}lO()|0}I=c[17014]|0;do{if((I|0)>(c[b>>2]|0)){F=c[17054]|0;if((F|0)==-1){break a}h[8555]=0.0;c[17012]=0;L=c[a>>2]|0;c[17008]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[8555]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[8528]=N;if((X|0)==(G|0)){ea=N*+h[8523];h[8528]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[8555]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[17012]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[17006]=Y;c[17008]=L+1;W=Z}J=c[b>>2]|0;c[17010]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[8555]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[17010]=J+1;ia=ja}O=+h[8502];ba=+h[8531];N=O-ba-ia;h[8522]=N;h[8541]=+h[8540];h[8540]=+h[8539];if(!(N>=0.0)){ka=-N}else{ka=N}h[8539]=ka;if(+h[8551]>+h[8517]){c[17098]=I}h[8547]=ba;do{if(O<ba){h[8531]=O;h[8564]=0.0;G=c[a>>2]|0;c[17006]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[8564]=+h[8564]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[17006]=G+1;h[A>>3]=ma}}while(0);c[17096]=F;if((F|0)<=0){O=+h[8555];if(O>=0.0){U=190;break a}ba=+h[8502];N=+h[8547];ea=(ba-N)/O;h[8552]=ea;O=+h[8554];do{if(!(ea<=O)){na=+h[8523]*+h[8544];h[A>>3]=na;oa=+h[8551];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[8544]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[8544]=qa;ra=qa;break}}else{qa=+h[8523]*+h[8551];h[8544]=qa;ra=qa}}while(0);ea=+h[8517];if(!(ra<=ea*1.5)){sa=ra}else{h[8544]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[8559]=ea;c[17112]=0;h[8560]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[17068]|0;c[17112]=J;oa=+h[8514];h[8560]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[17010]=1;if((J|0)<1){va=F}else{L=c[17070]|0;oa=ua;K=1;ca=F;while(1){h[8542]=0.0;c[17008]=1;if((L|0)<1){wa=0.0}else{X=c[17030]|0;aa=K+C|0;qa=+h[8514];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[8528]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[8542]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[17008]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[8524]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[8528]=za;h[8563]=0.0;$=c[a>>2]|0;c[17008]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[8563]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[17008]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[8528]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[8560]=Fa;c[17054]=K;Ga=Fa;Ha=K}aa=K+1|0;c[17010]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Rx(a,b,s,t,68120,u,w,68192,68216,x)|0;ca=c[17054]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[8502];c[17012]=0;J=c[a>>2]|0;c[17006]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[8528]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[8528];G=G+1|0;da=da+1|0}da=X+aa|0;c[17012]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[17008]=La;c[17006]=J+1}h[L>>3]=0.0;X=c[17070]|0;c[17008]=1;aa=(X|0)<1;if(!aa){F=c[17030]|0;K=1;while(1){da=fa(K,B)|0;O=+h[8522]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[8528]=Oa;G=c[b>>2]|0;c[17010]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[8528];$=$+1|0}c[17010]=G+1}$=K+1|0;c[17008]=$;if((K|0)<(X|0)){K=$}else{break}}}h[8533]=0.0;K=c[a>>2]|0;c[17006]=1;if((K|0)>=1){F=1;while(1){O=+h[8522]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[8533]=+h[8533]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[17006]=K+1;h[A>>3]=Pa}F=c[17096]|0;do{if((F|0)==0){if(!(+h[8544]==+h[8517])){break}O=+h[8552];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[17116]=0;break}L=c[b>>2]|0;c[17010]=1;if((L|0)>=1){J=o+((c[17068]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[17010]=L+1}h[8526]=0.0;$=c[a>>2]|0;c[17006]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[8520]=0.0;G=c[b>>2]|0;c[17010]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[8520]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[17010]=G+1;Sa=Ta}h[8526]=+h[8526]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[17006]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[8526]*100.0}J=c[17116]|0;c[17116]=J+1;if(+h[8533]<Ra){c[17116]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[17006]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[17006]=J+1}$=c[17016]|0;c[17012]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[17012]=$+1}c[17008]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[17010]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[17010]=Na+1;Ua=Wa}if((L|0)<(c[17030]|0)){h[J>>3]=-Ua}Va=L+1|0;c[17008]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[17010]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[17008]=Xa;c[17010]=L+1}c[17116]=0}}while(0);O=+h[8502];ea=+h[8547];if(O<ea){c[17068]=ca}oa=+h[8554];if(O<=ea+oa*+h[8555]|(F|0)>0){U=54;break}c[17054]=0;Ia=0;Ja=+h[8544];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[8502];oa=+h[8502];do{if((I|0)==1){h[8521]=oa;h[8531]=oa;c[17068]=1;Ya=1}else{if(!(oa<+h[8531])){Ya=I;break}h[8531]=oa;c[17068]=I;Ya=I}}while(0);F=c[17026]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[17036]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[17038]|0;Va=K+aa|0;c[17012]=Va;if(+h[8536]<0.0){aa=X+(c[a>>2]|0)|0;c[17036]=aa;Za=aa}else{Za=X}if(+h[8537]<0.0){X=K+(c[a>>2]|0)|0;c[17038]=X;_a=X}else{_a=K}K=fa(c[17050]|0,B)|0;h[t+(K-B<<3)>>3]=+h[8545];h[t+(Ya+C+K<<3)>>3]=+h[8545];h[t+(Za-B+K<<3)>>3]=-+h[8545];h[t+(_a-B+K<<3)>>3]=-+h[8545];h[q+(Va+ -1<<3)>>3]=(+h[8521]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[8502])/(+h[8536]*+h[8537])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[17050]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[8523]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[8523]/+h[e>>3];ea=+h[8546];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[8546];h[t+(X+K<<3)>>3]=+h[8546];K=(fa(Va+1|0,Va)|0)/2|0;c[17012]=K;ea=(+h[8521]- +h[8502])/+h[e>>3];h[8528]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[8523]*(+h[X>>3]+ +h[8528]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[8521])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[8514]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[8514]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[8523]*+h[8559]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[8517]=oa;h[8544]=oa;c[17030]=1;h[8539]=0.0;h[8540]=0.0;c[17116]=0;h[8564]=0.0;F=c[a>>2]|0;c[17006]=1;if((F|0)<1){U=53;break}ca=c[17068]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[8564]=+h[8564]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[17006]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[17098]=c[17014];U=54;continue}else if((U|0)==54){U=0;c[17054]=0;I=(c[17024]|0)+ -1|0;K=c[a>>2]|0;Qx(a,b,l,n,p,q,r,68352,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,68488)|0;h[8516]=0.0;K=c[a>>2]|0;c[17006]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[8516]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[17006]=K+1;ab=cb}oa=+h[8544];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[8551]=O;ea=+h[8517];if(!(O<+h[8523]*ea)){db=ab;U=62;break}c[17054]=-1;O=+h[8554];N=O*oa;h[8544]=N;h[8552]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[8544]=ea;eb=ea}if((c[17014]|0)<=((c[17098]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[8561]*.125*ea;h[8528]=N;oa=+h[8539];ba=+h[8540];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[8541];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[8563]=O;I=c[b>>2]|0;c[17010]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[8520]=0.0;X=c[a>>2]|0;c[17008]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[8520]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[17008]=X+1;jb=lb}if(jb>ea){c[17054]=F;h[8563]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[17010]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[8552]>0.0){U=54;continue}ea=+h[8551];O=+h[8517];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[8523];h[8544]=O;ea=hb/+h[f>>3];h[8552]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[8517]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[8517]=na;ob=na;break}}else{na=+h[f>>3];h[8517]=na;ob=na}}while(0);h[8544]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){DO(68592)|0;lO()|0}DO(68616)|0;UN(68712,68136,8)|0;UN(68712,68056,4)|0;lO()|0;DO(68640)|0;UN(68712,68248,8)|0;ca=c[a>>2]|0;c[17006]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];UN(68712,y,8)|0;I=c[17006]|0;F=I+1|0;c[17006]=F;}while((I|0)<(ca|0))}lO()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[8523]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[8517];O=na>=ea?na:ea;h[8553]=O;ea=O*O;h[8516]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[8564];if(db<=ea*.001){h[8557]=ea*.25;ca=c[b>>2]|0;c[17010]=1;if((ca|0)>=1){F=1;while(1){h[8520]=0.0;I=c[a>>2]|0;c[17006]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[8520]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[17006]=I+1;pb=qb}h[8528]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[8523]*+h[8564];h[8520]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[17006]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[8528]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[8523]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[8520]*+h[n+(F+C+Va<<3)>>3]+ +h[8557]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[17018]=aa;c[17008]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[17008]=Va;rb=Va}c[17006]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[17010]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[17070]|0;c[17010]=1;if((F|0)>=1){ca=1;while(1){h[8538]=0.0;X=c[b>>2]|0;c[17006]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[8538]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[17006]=I;if((K|0)>=(X|0)){break b}O=+h[8538];K=I}}}while(0);X=c[a>>2]|0;c[17008]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[8557]*+h[8538]*+h[l+(I<<3)>>3];h[8520]=O;Va=c[b>>2]|0;c[17006]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[8520]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[17006]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[17030]|0)){h[8520]=-+h[8520]}L=c[b>>2]|0;c[17006]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[8520]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[17006]=L+1}J=K+1|0;c[17008]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[17006]=1;if((K|0)>=1){X=c[17030]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[17018]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[8528]=ub;c[17008]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[8528];aa=aa+1|0}aa=J+1|0;c[17008]=aa;vb=aa}c[17006]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[17010]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[17012]=0;ca=c[a>>2]|0;c[17008]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[17010]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[8523]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[17010]=aa+1}c[17006]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[17012]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[17006]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[17008]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[17008]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[17008]=J+1}h[8564]=0.0}if((c[17054]|0)>0){F=(c[17024]|0)+ -1|0;bx(a,b,l,n,s,t,68120,u,68216,68424,v,68344,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[17010]=1;if((F|0)>=1){L=1;while(1){h[8529]=0.0;h[8530]=0.0;h[8520]=0.0;ca=c[a>>2]|0;c[17008]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[8529]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[8530]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[8520]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[17008]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[8523]+Ab);h[w+(K<<3)>>3]=+h[8520];K=L+1|0;c[17010]=K;if((L|0)<(F|0)){L=K}else{break}}}h[8524]=0.0;L=c[17070]|0;c[17010]=1;if((L|0)>=1){F=1;while(1){h[8520]=0.0;J=c[b>>2]|0;c[17006]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[8520]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[17006]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[8524];if((F|0)<(c[17030]|0)){h[8524]=O+ea;na=-Eb;h[8520]=na;Gb=na}else{h[8524]=O-ea;Gb=Eb}K=c[b>>2]|0;c[17006]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[8520];X=X+1|0}c[17006]=K+1}X=F+1|0;c[17010]=X;if((F|0)<(L|0)){F=X}else{break}}}h[8532]=0.0;h[8511]=0.0;F=c[a>>2]|0;c[17008]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[8520]=0.0;X=c[b>>2]|0;c[17006]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[8520]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[17006]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[8532]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[17020]=K;Va=c[a>>2]|0;c[17010]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[8520]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[17010]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[8532]+ +h[8520]*+h[ca>>3];h[8532]=O;na=+h[8511]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[8511]=na;aa=L+1|0;c[17008]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[8516];h[8524]=+h[8524]+(Ib*Ib+ea*(Ib+(Ib+ +h[8564])+ea*+h[8523]))-Hb;L=w+((c[17068]|0)+ -1<<3)|0;h[L>>3]=+h[8514]+ +h[L>>3];L=c[17054]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[8514]+ +h[8543]*+h[8524]/(ea*ea);h[8528]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;ax(a,b,l,n,s,t,68120,u,68272,68216,v,x,w,68192,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[17006]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[17006]=L+1}F=c[17014]|0;aa=F+1|0;c[17014]=aa;if((F|0)>=(c[17124]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[17014]=T+ -1;if((c[g>>2]|0)<=0){break}DO(68520)|0;lO()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}DO(68568)|0;lO()|0}}while(0);Nb=+h[8531];if(Nb<=+h[8502]){U=c[a>>2]|0;c[17006]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[17006]=U+1;Ob=+h[8531]}h[8502]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}DO(68664)|0;UN(68712,68056,4)|0;lO()|0;DO(68688)|0;UN(68712,68016,8)|0;g=c[a>>2]|0;c[17006]=1;if((g|0)>=1){a=1;do{UN(68712,d+(a+ -1<<3)|0,8)|0;U=c[17006]|0;a=U+1|0;c[17006]=a;}while((U|0)<(g|0))}lO()|0;i=z;return 0}function Mx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){G_(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){G_(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function Nx(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+Dx(68720);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+Ex(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+Ex(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+Ex(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function Ox(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function Px(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+Dx(68728);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=V_(u|0,0,t+ -2|0,0)|0;t=O_(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function Qx(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[8611]=.5;h[8629]=6.283185307179586;v=+h[l>>3];h[8624]=v*v;c[17244]=0;l=c[b>>2]|0;c[17262]=l;c[17260]=l;w=c[b>>2]|0;c[17184]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[17184]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[17184]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[17184]=w+1}z=c[d>>2]|0;c[17188]=1;if((z|0)>=1){e=1;while(1){h[8615]=0.0;A=c[b>>2]|0;c[17186]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[8615]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[17186]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[8615]=v;C=c[b>>2]|0;c[17184]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[8615];F=F+1|0}c[17184]=C+1}F=e+1|0;c[17188]=F;if((e|0)<(z|0)){e=F}else{break}}}c[17198]=0;e=c[b>>2]|0;c[17186]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[17198]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[17184]=H;c[17186]=e+1}do{if((y|0)==0){h[8613]=0.0;h[8595]=0.0;w=c[b>>2]|0;c[17184]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[8595]=+h[8595]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[17184]=w+1}h[r>>3]=0.0;D=+h[8595];if(D==0.0){O=55;break a}h[8600]=0.0;h[8603]=0.0;h[8598]=D;h[8618]=D;P=D;Q=0.0;R=0.0;S=+h[8624];T=0}else{if((y|0)>(x|0)){h[8597]=0.0;h[8604]=0.0;h[8605]=0.0;z=c[b>>2]|0;c[17184]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[8597]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[8604]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[8605]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[17184]=z+1;U=ba;W=$;Z=aa}D=+h[8611];v=D*(+h[8608]-Z);h[8596]=v;_=+h[8601];ca=_+v;h[8612]=ca;h[8616]=ca;h[8614]=ca;c[17254]=0;a[68816]=1;da=+h[8629]/50.0;h[8615]=da;c[17184]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[8614]=ka;c[17254]=w;h[8625]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[8626]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[8620]=ha;h[8606]=ia;h[8609]=ja;h[8617]=ka;c[17184]=50;h[8616]=ka;if((la|0)==0){h[8625]=ka;O=46}else if((la|0)==49){h[8626]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[8626]}h[8620]=0.0;ga=+h[8625];if(ga!=na){ea=ga-ma;h[8625]=ea;ga=na-ma;h[8626]=ga;oa=D*(ea-ga)/(ea+ga);h[8620]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[8620]=oa;ga=+X(+oa);h[8606]=ga;ea=+Y(+oa);h[8609]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[8621]=oa;h[8598]=0.0;w=c[b>>2]|0;c[17184]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[8606]*+h[J>>3]+ +h[8609]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[8598]+sa*sa;h[8598]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[8609];ea=+h[8606];F=F+1|0;z=K}c[17184]=w+1;qa=ta;ra=+h[8621]}ea=ra+ +h[8613];h[8613]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[8604]=0.0;z=c[b>>2]|0;c[17186]=1;do{if((z|0)<1){ea=+h[8628];h[8619]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[8604]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[17186]=z+1;ea=+h[8628];h[8619]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[8595];h[8615]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[8615]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[8619];oa=+h[8598];v=+h[8604];_=oa/v;ca=ea<=_?ea:_;h[8619]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[8598];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[8611]*Ca);h[8610]=ca;h[8613]=+h[8613]+ca;h[8623]=Ba;h[8598]=0.0;z=c[b>>2]|0;c[17184]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[8619]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[8598]+oa*oa;h[8598]=Ga;Ha=+h[8619];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[17184]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[8628]){if(+h[8610]<=+h[8613]*.01){O=55;break a}if(Fa<=+h[8618]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[8623];h[8615]=ca;h[8595]=0.0;h[8600]=0.0;h[8603]=0.0;w=c[b>>2]|0;c[17184]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[8595]+ca*ca;h[8595]=La;J=m+(F<<3)|0;Ma=+h[8600]+ +h[K>>3]*+h[J>>3];h[8600]=Ma;ca=+h[J>>3];Na=+h[8603]+ca*ca;h[8603]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[8615];Ja=Ja+1|0;Ka=J}c[17184]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[8624];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[17260]=y;ua=+h[8598];va=y}if(ua<=+h[8618]*1.0e-4){O=55;break a}h[8601]=0.0;h[8608]=0.0;z=c[b>>2]|0;c[17184]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[8601]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[8608]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[17184]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[8607]=ca;oa=+h[8624];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[17244]=J;_=+V(+(v-ca*ca));h[8615]=_;v=oa/_;h[8625]=v;oa=ca/_;h[8626]=oa;w=c[b>>2]|0;c[17184]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[8626];Ta=+h[8625];Ua=Ua+1|0;Va=K}c[17184]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[17244]=e;v=S-R;h[8615]=v;h[8628]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Rx(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[8638]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[17282]=t;c[17272]=1;c[17266]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[17272]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[8640]=D;C=+h[x>>3]/D;h[8647]=C;z=+h[f+(B+y<<3)>>3]/D;h[8648]=z;B=c[d>>2]|0;c[17264]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[8640]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[8640];if((x|0)>=(B|0)){break}D=+h[8648];z=+h[8647];x=x+1|0}c[17264]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[17266]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[8647]=z;if((c[g>>2]|0)>1){D=-z;h[8647]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[8648]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[17264]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[8648]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[8647];t=t+1|0;x=A}c[17264]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[8645]=z;x=k+(w<<3)|0;H=+h[x>>3];h[8639]=H;D=H*H;h[8649]=D;h[8646]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[8638];a[69136]=0;do{if((u|0)==1){z=+h[8646];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[8640]=z;D=+h[8647]/z;h[8648]=D;H=+h[8639]/z;h[8647]=H;x=c[d>>2]|0;c[17264]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[8648];D=+h[8647];w=w+1|0;t=s}c[17264]=x+1;J=+h[8640]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[17268]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[17268]=u;M=u}t=u+1-M|0;c[17270]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[8646];z=+h[f+(t+w<<3)>>3]/D;h[8640]=z;h[8647]=z*+h[l>>3];H=+h[8639];h[8648]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[8640]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[8638]/+V(+(+h[8649]+z*N*z));h[8643]=C;if(!(D>=0.0)){O=-D}else{O=D}h[8644]=C*+V(+O);t=c[d>>2]|0;c[17264]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[8644]*(+h[A>>3]- +h[8647]*+h[n+(G<<3)>>3]- +h[8648]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[8640];z=+h[8639];H=+h[8643];v=v+1|0}c[17264]=t+1;P=+h[8646]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[69136]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[17264]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[8640]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[8640];K=Q+1|0;c[17264]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[17266]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[17274]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[8639];N=+h[8646];J=(+h[8645]*+h[f>>3]-O*P)/N;h[8647]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[8648]=P;c[17264]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[17264]=q;if((f|0)>=(b|0)){break a}N=+h[8648];O=+h[8647];f=q}}}while(0);b=R+1|0;c[17266]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Sx(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Tx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Sx(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(69200,69216,116,69240)}else if((s|0)==14){i=g;return o|0}return 0}function Ux(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((y_(w,c[69248+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[69352+(x<<2)>>2]|0;c[q>>2]=c[69248+(x<<2)>>2];c[q+4>>2]=y;uv(23,0,69424,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=a_(D,8)|0;c[e+40>>2]=B;D=b+536|0;xv(c[D>>2]|0,(B|0)!=0|0,69464,p);B=a_(c[A>>2]|0,4)|0;c[e+36>>2]=B;xv(c[D>>2]|0,(B|0)!=0|0,69464,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=a_(c[C>>2]|0,4)|0;c[e+24>>2]=_Z(8)|0;C=_Z(4)|0;c[e+20>>2]=C;c[C>>2]=c[41104>>2];xv(c[D>>2]|0,(C|0)!=0|0,69464,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=_Z(C)|0;A=e+44|0;c[A>>2]=_Z(C)|0;C=a_(15,4)|0;E=e+12|0;c[E>>2]=C;xv(c[D>>2]|0,(C|0)!=0|0,69464,m);C=a_(5,4)|0;c[e+4>>2]=C;xv(c[D>>2]|0,(C|0)!=0|0,69464,l);C=a_(5,4)|0;c[e+8>>2]=C;xv(c[D>>2]|0,(C|0)!=0|0,69464,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=_Z(C)|0;c[e+76>>2]=_Z(C)|0;c[e+80>>2]=_Z(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((de[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){uv(23,0,69480,j)}else{uv(1,0,69552,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[41140>>2]|c[10260]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=69384;W=V;yv(Q,W,r)}c[t>>2]=w;wv(23,1,69280,t);t=1;do{w=c[69352+(t<<2)>>2]|0;c[s>>2]=c[69248+(t<<2)>>2];c[s+4>>2]=w;wv(23,0,69336,s);t=t+1|0;}while((t|0)<8);ae[c[10400]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=69384;W=V;yv(Q,W,r);return 0}function Vx(a){a=a|0;var b=0;b=i;$Z(c[a+40>>2]|0);$Z(c[a+36>>2]|0);$Z(c[a+20>>2]|0);$Z(c[a+12>>2]|0);$Z(c[a+4>>2]|0);$Z(c[a+8>>2]|0);$Z(a);i=b;return 0}function Wx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;xv(c[N>>2]|0,(c[M>>2]|0)!=0|0,69648,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){uv(3,0,69680,B);uv(3,0,69720,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];de[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];uv(3,0,69744,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];uv(23,0,69784,y);if((c[z>>2]|0)==1){Hw(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Nz(a)|0;de[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 4:{dx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 3:{dx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 7:{dx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 5:{dx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 6:{dx(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){dx(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{dx(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){qd(_|0)|0;qd($|0)|0;wv(3,0,69816,x);uv(3,0,69904,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){qd(_|0)|0;qd($|0)|0;$=dy(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Nz(a)|0;de[c[(c[ba>>2]|0)+40>>2]&127](a)|0}de[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];wv(1,0,69928,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[41060>>2]|0)!=0){uv(3,1,69960,u);c[s>>2]=c[z>>2];uv(3,0,69984,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];uv(3,0,70008,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];uv(3,0,70040,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];uv(3,0,70080,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];uv(3,0,70128,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];uv(3,0,70176,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];uv(3,0,70216,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];uv(3,0,70256,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];uv(3,0,70296,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];uv(3,0,70344,f);ae[c[10400]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(70384,70416,410,70448)}uv(3,0,70464,e);S=0;i=d;return S|0}function Xx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Nz(g)|0;a=f+540|0;de[c[(c[a>>2]|0)+40>>2]&127](g)|0;de[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Yx(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Nz(l)|0;b=k+540|0;de[c[(c[b>>2]|0)+40>>2]&127](l)|0;de[c[(c[b>>2]|0)+28>>2]&127](l)|0;fy(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Zx(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Nz(g)|0;l=e+540|0;de[c[(c[l>>2]|0)+40>>2]&127](g)|0;de[c[(c[l>>2]|0)+28>>2]&127](g)|0;de[c[(c[l>>2]|0)+32>>2]&127](g)|0;ge[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function _x(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;gy(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function $x(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Nz(l)|0;b=k+540|0;de[c[(c[b>>2]|0)+40>>2]&127](l)|0;de[c[(c[b>>2]|0)+28>>2]&127](l)|0;ey(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function ay(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function by(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;hy(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function cy(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function dy(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-9:{wv(1,0,70688,f);m=-9;i=b;return m|0};case-11:{wv(1,0,70872,d);m=-11;i=b;return m|0};case-2:{wv(1,0,70488,k);m=-2;i=b;return m|0};case-1:{wv(3,0,69816,l);m=1;i=b;return m|0};case-12:{wv(1,0,70960,c);m=-12;i=b;return m|0};case-8:{wv(1,0,70640,g);m=-8;i=b;return m|0};case-6:{wv(1,0,70528,j);m=-6;i=b;return m|0};case-7:{wv(1,0,70600,h);m=-7;i=b;return m|0};case-33:{wv(1,0,71008,b);m=-33;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-10:{wv(1,0,70776,e);m=-10;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function ey(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}de[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;de[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function gy(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+pd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+pd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Xx(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function $t(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function au(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((cu(bu(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((cu(bu(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=bu(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((cu(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=bu(k,a,b)|0;n=h;}while((cu(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=bu(k,a,b)|0;while(1){if((cu(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=bu(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=bu(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function bu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function cu(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function du(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function eu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 13:{c[h>>2]=14;j=56;break};case 11:{c[h>>2]=14;j=55;break};case 29:{c[h>>2]=16;j=2;break};case 15:{c[h>>2]=14;j=0;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,38840)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};default:{k=10}}}while(0);if((k|0)==10){j=iu(h,a)|0}i=g;return j|0}function fu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};case 15:{k=0;break};default:{k=hu(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=iu(h,a)|0}i=g;return k|0}function gu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Ce[c[e+28>>2]&63](e,b,d,38824)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Ce[c[e+28>>2]&63](e,b,d,38832)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=iu(h,a)|0;l=k;i=g;return l|0}function hu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 13:{j=56;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 16:{if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,38600)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,38608)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,38616)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,38624)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};default:{}}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function iu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function ju(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function ku(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else{g=iu(e,a)|0}i=f;return g|0}function lu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=iu(e,a)|0}i=f;return g|0}function mu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else if((b|0)==15){g=39}else{g=iu(e,a)|0}i=f;return g|0}function nu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=iu(e,a)|0}i=f;return g|0}function ou(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=iu(e,a)|0}i=f;return g|0}function pu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==11){g=55}else if((b|0)==15){g=0}else{g=iu(e,a)|0}i=f;return g|0}function qu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((Ce[c[e+28>>2]&63](e,b,d,38640)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((Ce[c[e+28>>2]&63](e,b,d,38648)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=iu(h,a)|0;l=k;i=g;return l|0}function ru(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=iu(e,a)|0}i=f;return g|0}function su(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=iu(e,a)|0}i=f;return g|0}function tu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else{g=iu(e,a)|0}i=f;return g|0}function uu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=iu(e,a)|0;h=g;i=f;return h|0}return 0}function vu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,38656)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,38664)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function wu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 32:{c[h>>2]=40;j=54;break};case 20:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,38672)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 31:{c[h>>2]=40;j=52;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 15:{j=39;break};case 30:{c[h>>2]=40;j=53;break};default:{k=10}}}while(0);if((k|0)==10){j=iu(h,a)|0}i=g;return j|0}function xu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else{g=iu(e,a)|0}i=f;return g|0}function yu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 31:{c[e>>2]=40;g=52;break};case 30:{c[e>>2]=40;g=53;break};case 15:{g=39;break};default:{g=iu(e,a)|0}}i=f;return g|0}function zu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};default:{g=iu(e,a)|0;h=g;i=f;return h|0}}return 0}function Au(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=iu(e,a)|0}i=f;return g|0}function Bu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else{g=iu(e,a)|0}i=f;return g|0}function Cu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=iu(e,a)|0}i=f;return g|0}function Du(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ce[m&63](n,o,p,c[38680+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ce[m&63](n,o,p,38624)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function Eu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==20){if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,38784)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,38792)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,38808)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function Fu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=iu(e,a)|0}i=f;return g|0}function Gu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=iu(e,a)|0}i=f;return g|0}function Hu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==15){g=33}else{g=iu(e,a)|0}i=f;return g|0}function Iu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=iu(e,a)|0}i=f;return g|0}function Ju(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=iu(e,a)|0}i=f;return g|0}function Ku(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=iu(e,a)|0}i=f;return g|0}function Lu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=iu(e,a)|0}i=f;return g|0}function Mu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,38640)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,38648)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function Nu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=iu(e,a)|0}i=f;return g|0}function Ou(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=iu(e,a)|0}i=f;return g|0}function Pu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,38816)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function Qu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=iu(e,a)|0}i=f;return g|0}function Ru(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,38640)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,38648)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function Su(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=iu(e,a)|0}i=f;return g|0}function Tu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=iu(e,a)|0}i=f;return g|0}function Uu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=iu(e,a)|0;h=g;i=f;return h|0}return 0}function Vu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=iu(e,a)|0;h=g;i=f;return h|0}return 0}function Wu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=iu(e,a)|0}i=f;return g|0}function Xu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 29:{c[h>>2]=16;j=2;break};case 11:{j=55;break};case 14:{j=0;break};case 16:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,38840)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 13:{j=56;break};case 15:{j=0;break};default:{k=9}}}while(0);if((k|0)==9){j=iu(h,a)|0}i=g;return j|0}function Yu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=iu(e,a)|0}i=f;return g|0}function Zu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,38640)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,38648)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=iu(h,a)|0;k=j;i=g;return k|0}function _u(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=iu(e,a)|0}i=f;return g|0}function $u(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=iu(e,a)|0}i=f;return g|0}function av(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=iu(e,a)|0}i=f;return g|0}function bv(){i=i;return}function cv(){i=i;return}function dv(){var a=0;a=i;Wa(38848,0)|0;i=a;return}function ev(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(38856,29,1,e|0)|0;qd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(38888,54,1,g|0)|0;qd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(38944,47,1,a|0)|0;qd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;sd(k|0,38992,d|0)|0;qd(k|0)|0;f=0;i=b;return f|0}function fv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;sd(j|0,39080,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;sd(n|0,39112,e|0)|0;k=0;i=d;return k|0}function gv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function hv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Vv(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function iv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=Vv(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function jv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[22536]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=39168;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](0,f,39192,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function kv(a,b){a=a|0;b=b|0;var d=0;d=i;if((ev(a)|0)==0){cb(39248,39056,347,39272)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);cb(39304,39056,348,39272);return 0}function lv(){var a=0,b=0,d=0;a=i;b=41048|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=41160|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=41272|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[41052>>2]=1;c[41056>>2]=1;i=a;return}function mv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?41408:41424;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;sd(a|0,41384,e|0)|0;i=d;return}function nv(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=41272+(d<<2)|0;o=41160+(d<<2)|0;p=41472+(b<<2)|0;q=39752+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=41456;hc(41440,l|0)|0;s=41456}else{if((c[10258]|0)==(d|0)){if((c[o>>2]|0)>0){t=41456}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;hc(41440,m|0)|0;do{if((c[10258]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=41456;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;hc(41464,k|0)|0;c[n>>2]=b;c[10258]=d;if((c[o>>2]|0)>0){g=0;while(1){hc(41496,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;qd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function ov(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[41472+(a<<2)>>2]|0;c[j>>2]=c[39752+(b<<2)>>2];c[j+4>>2]=k;hc(41504,j|0)|0;pv(e);if((g|0)==0){Fd(((d|0)!=0?41544:41592)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}tb(41672)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];hc(41552,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}rc(41576,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}function pv(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==38){rc(41616,5,1,e|0)|0}else if(b<<24>>24==62){rc(41632,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==60){rc(41624,4,1,e|0)|0}else{Nd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function qv(a){a=a|0;var b=0;b=41160+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function rv(a){a=a|0;var b=0;b=(a|0)==0;c[10402]=b?1:19;c[10400]=b?7:197;i=i;return}function sv(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(41576,11,1,b|0)|0;qd(b|0)|0;i=a;return}function tv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[41048+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;nc(j|0,2048,e|0,h|0)|0;me[c[10402]&31](1,a,b,j,0,d);i=g;return}function uv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[41048+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;nc(h|0,2048,d|0,g|0)|0;me[c[10402]&31](1,a,b,h,0,0);i=f;return}function vv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[10260]|0)==0){if((c[41048+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;nc(k|0,2048,e|0,j|0)|0;me[c[10402]&31](2,a,b,k,0,d);i=g;return}function wv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[10260]|0)==0){if((c[41048+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;nc(j|0,2048,d|0,h|0)|0;me[c[10402]&31](2,a,b,j,0,0);i=f;return}function xv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;nc(b|0,2048,d|0,g|0)|0;me[c[10402]&31](4,2,0,b,0,0);if((a|0)==0){h=id(c[9712]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function yv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;nc(g|0,2048,b|0,f|0)|0;me[c[10402]&31](5,2,0,g,0,0);if((a|0)==0){h=id(c[9712]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function zv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;nc(h|0,2048,d|0,g|0)|0;me[c[10402]&31](5,2,0,h,0,b);if((a|0)==0){j=id(c[9712]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function Av(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;zv(a,e,41744,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;vv(26,0,e,41680,m);i=j;return+b}return 0.0}function Bv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+8>>2]|0)+(fa(d,b)|0)|0;i=i;return e|0}function Cv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;c[a+8>>2]=Wv(iv(a,d,g)|0,b)|0;i=f;return}function Dv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Bv(a,jv(a,d,g)|0,b)|0;i=f;return e|0}function Ev(a,b){a=a|0;b=b|0;i=i;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function Fv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Uv(iv(a,b,f)|0)|0;i=e;return}function Gv(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=_Z(16)|0;xv(0,(d|0)!=0|0,41792,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Hv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;$Z(c[f>>2]|0);$Z(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Iv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;xv(0,(a|0)!=0|0,41808,f);f=_Z(8)|0;g=f;xv(0,(f|0)!=0|0,41792,e);e=a+8|0;h=_Z(c[e>>2]|0)|0;c[f>>2]=h;xv(0,(h|0)!=0|0,41792,d);E_(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Jv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;xv(0,(a|0)!=0|0,41808,f);f=_Z(8)|0;g=f;xv(0,(f|0)!=0|0,41792,e);e=a+8|0;h=_Z(c[e>>2]|0)|0;c[f>>2]=h;xv(0,(h|0)!=0|0,41792,d);E_(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Kv(a){a=a|0;var b=0;b=i;i=i+8|0;xv(0,(a|0)!=0|0,41808,b);i=b;return c[a+12>>2]|0}function Lv(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;xv(0,(a|0)!=0|0,41808,d);d=a;xv(0,(c[d>>2]|0)!=0|0,41832,b);i=b;return c[c[d>>2]>>2]|0}function Mv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;$Z(c[e>>2]|0);$Z(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function Nv(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;xv(0,(a|0)!=0|0,41808,d);d=a;xv(0,(c[d>>2]|0)!=0|0,41848,b);i=b;return c[d>>2]|0}function Ov(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;xv(0,d&1,41880,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function Pv(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;xv(0,(a|0)!=0|0,41880,d);d=a;xv(0,(c[d>>2]|0)!=0|0,41904,b);i=b;return c[d>>2]|0}function Qv(){var a=0,b=0,d=0;a=i;b=_Z(16)|0;c[10494]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=_Z(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function Rv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Xv(a)|0;tc(41984)|0;Yv(d);a=c[10494]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;gc(41984)|0;G_(g|0,0,d|0)|0;i=b;return g|0}function Sv(){var a=0,b=0,d=0,e=0;a=i;b=c[10494]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;$Z(c[b>>2]|0);$Z(b);if((d|0)==0){break}else{b=d}}e=c[10494]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Tv(a){a=a|0;var b=0,d=0;b=i;d=de[c[41936>>2]&127](a<<3)|0;i=b;return d|0}function Uv(a){a=a|0;var b=0,d=0;b=i;d=de[c[41936>>2]&127](a<<2)|0;i=b;return d|0}function Vv(a){a=a|0;var b=0,d=0;b=i;d=de[c[41936>>2]&127](a<<2)|0;i=b;return d|0}function Wv(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=fa(b,a)|0;a=de[c[41932>>2]&127](e)|0;i=d;return a|0}function Xv(a){a=a|0;i=i;return a+7&-8|0}function Yv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[10494]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=_Z(16)|0;c[f+12>>2]=d;c[10494]=f;c[f+4>>2]=0;d=Zv((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=_Z(d)|0;c[f>>2]=a;i=b;return}function Zv(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function _v(a){a=a|0;var b=0,c=0;b=i;c=C_(a|0)|0;i=b;return c|0}function $v(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;I_(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ic(m|0,l|0,f|0)|0;f=aw(m)|0;i=e;return f|0}function aw(a){a=a|0;var b=0,c=0,d=0;b=i;c=C_(a|0)|0;d=cw(c)|0;E_(d|0,a|0,c|0)|0;i=b;return d|0}function bw(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;ic(o|0,42016,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;ic(o|0,42008,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ic(q|0,p|0,j|0)|0;j=aw(q)|0;i=g;return j|0}function cw(b){b=b|0;var d=0,e=0;d=i;e=de[c[41940>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function dw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=_v(a)|0;e=_v(b)|0;f=cw(e+d|0)|0;E_(f|0,a|0,d|0)|0;E_(f+d|0,b|0,e|0)|0;i=c;return f|0}function ew(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=y_(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function fw(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 4:{f=2;break a;break};case 5:{f=1;break a;break};case 2:{f=4;break a;break};case 3:{f=2;break a;break};case 0:{f=8;break a;break};case 1:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function gw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Xc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){$Z(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{$Z(c[(c[f>>2]|0)+(g<<4)>>2]|0);$Z(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;$Z(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){$Z(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{$Z(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}$Z(d);c[g>>2]=0;i=b;return}function hw(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(C_(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function iw(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=jc(b|0,42184)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Rd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=vd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=42192;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[42160+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=42216;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=42240;E=131;break}G=fw(D)|0;if((G|0)==-1){n=42272;E=131;break}D=c[q>>2]|0;H=_Z(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=42320;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=42344;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((y_(H,c[42136+(C<<2)>>2]|0)|0)!=0){n=42368;E=131;break}$Z(H);H=42944;b:do{switch(C|0){case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=42880;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=a_(c[z>>2]<<1,4)|0;if((Vc(c[m>>2]|0,J|0,1)|0)==-1){n=42912;E=131;break a}else{K=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=42880;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=a_(c[z>>2]<<1,4)|0;F=fa(I,D)|0;if((a[l]|0)==1){G=_Z(F<<3)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=42912;E=131;break a}if((I|0)!=0){L=D<<3;M=(D|0)==0;N=D<<3;O=0;do{P=_Z(L)|0;c[(c[B>>2]|0)+(O<<2)>>2]=P;if(!M){P=G+(fa(N,O)|0)|0;E_(c[(c[B>>2]|0)+(O<<2)>>2]|0,P|0,N|0)|0}O=O+1|0;}while(O>>>0<I>>>0)}O=c[z>>2]|0;N=O<<1;if(O>>>0<N>>>0){M=D<<3;L=(D|0)==0;P=O;do{Q=_Z(M)|0;c[(c[B>>2]|0)+(P<<2)>>2]=Q;if(!L){Q=c[B>>2]|0;R=c[Q+(P-O<<2)>>2]|0;S=c[Q+(P<<2)>>2]|0;Q=0;do{h[S+(Q<<3)>>3]=-+h[R+(Q<<3)>>3];Q=Q+1|0;}while(Q>>>0<D>>>0)}P=P+1|0;}while(P>>>0<N>>>0)}$Z(G)}else{N=_Z(F<<2)|0;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=42912;E=131;break a}if((I|0)!=0){P=D<<3;O=(D|0)==0;L=0;do{M=_Z(P)|0;c[(c[B>>2]|0)+(L<<2)>>2]=M;if(!O){M=c[(c[B>>2]|0)+(L<<2)>>2]|0;Q=0;do{h[M+(Q<<3)>>3]=+g[N+((fa(D,L)|0)+Q<<2)>>2];Q=Q+1|0;}while(Q>>>0<D>>>0)}L=L+1|0;}while(L>>>0<I>>>0)}L=c[z>>2]|0;O=L<<1;if(L>>>0<O>>>0){P=D<<3;F=(D|0)==0;G=L;do{Q=_Z(P)|0;c[(c[B>>2]|0)+(G<<2)>>2]=Q;if(!F){Q=c[B>>2]|0;M=c[Q+(G-L<<2)>>2]|0;R=c[Q+(G<<2)>>2]|0;Q=0;do{h[R+(Q<<3)>>3]=-+h[M+(Q<<3)>>3];Q=Q+1|0;}while(Q>>>0<D>>>0)}G=G+1|0;}while(G>>>0<O>>>0)}$Z(N)}if((Vc(c[m>>2]|0,J|0,1)|0)==-1){n=42912;E=131;break a}else{K=d;E=130}break};case 1:{O=d<<24>>24==0;c[u>>2]=O?D:I;G=_Z((O?D:I)<<4)|0;c[v>>2]=G;c:do{if(d<<24>>24==1){if((I|0)==0){T=0;break}L=D+1|0;F=G;P=0;while(1){c[F+(P<<4)>>2]=_Z(L)|0;if((sb(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=42568;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;Q=c[v>>2]|0;c[Q+(P<<4)+8>>2]=-1;c[Q+(P<<4)+12>>2]=-1;hw(c[Q+(P<<4)>>2]|0);Q=P+1|0;if(!(Q>>>0<I>>>0)){T=I;break c}F=c[v>>2]|0;P=Q}}else{T=I}}while(0);if(!O){K=d;E=130;break b}G=fa(D,T)|0;U=_Z(G+1|0)|0;if((sb(U|0,G|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){G=T+1|0;N=(T|0)==0;P=0;do{F=_Z(G)|0;c[(c[v>>2]|0)+(P<<4)>>2]=F;if(!N){F=0;do{L=a[U+((fa(D,F)|0)+P)|0]|0;a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+F|0]=L;F=F+1|0;}while(F>>>0<T>>>0)}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+T|0]=0;F=c[v>>2]|0;c[F+(P<<4)+8>>2]=-1;c[F+(P<<4)+12>>2]=-1;hw(c[F+(P<<4)>>2]|0);P=P+1|0;}while(P>>>0<D>>>0)}$Z(U);K=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=42632;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=42688;E=131;break a}c[w>>2]=D;P=fa(I,D)|0;if((a[l]|0)==1){N=_Z(P<<3)|0;c[x>>2]=N;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=42728;E=131;break a}}else{N=_Z(P<<2)|0;c[x>>2]=_Z(fa(D<<3,I)|0)|0;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=42728;E=131;break a}if((P|0)!=0){G=c[x>>2]|0;O=0;do{h[G+(O<<3)>>3]=+g[N+(O<<2)>>2];O=O+1|0;}while(O>>>0<P>>>0)}$Z(N)}P=c[w>>2]|0;if(!(P>>>0>1)){K=1;E=130;break b}O=(I|0)==2;G=1;while(1){if(O){F=c[x>>2]|0;if(+h[F+(G<<3)>>3]!=+h[F+(P+G<<3)>>3]){n=42760;E=131;break a}}F=G+1|0;if(F>>>0<P>>>0){G=F}else{K=1;E=130;break b}}}else if(!(d<<24>>24==0)){V=d;E=129;break b}if((I|0)==0){n=42632;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=42840;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){P=_Z(G<<3)|0;c[x>>2]=_Z(fa(D<<3,I)|0)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=42728;E=131;break a}if((D|0)!=0){O=0;do{N=c[x>>2]|0;F=0;do{h[N+((fa(I,O)|0)+F<<3)>>3]=+h[P+((fa(D,F)|0)+O<<3)>>3];F=F+1|0;}while(F>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}$Z(P)}else{O=_Z(G<<2)|0;c[x>>2]=_Z(fa(D<<3,I)|0)|0;if((sb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=42728;E=131;break a}if((D|0)!=0){F=0;do{N=c[x>>2]|0;L=0;do{h[N+((fa(I,F)|0)+L<<3)>>3]=+g[O+((fa(D,L)|0)+F<<2)>>2];L=L+1|0;}while(L>>>0<I>>>0);F=F+1|0;}while(F>>>0<D>>>0)}$Z(O)}F=c[w>>2]|0;if(!(F>>>0>1)){K=d;E=130;break b}G=(D|0)==2;P=1;while(1){if(G){L=c[x>>2]|0;if(+h[L+(P<<3)>>3]!=+h[L+(F+P<<3)>>3]){n=42760;E=131;break a}}L=P+1|0;if(L>>>0<F>>>0){P=L}else{K=d;E=130;break}}break};case 3:{P=fa(I<<2,D)|0;W=_Z(P)|0;if((sb(W|0,P|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}P=c[v>>2]|0;F=0;do{c[P+(F<<4)+8>>2]=(c[W+(F<<2)>>2]|0)==1;c[P+(F<<4)+12>>2]=c[W+(D+F<<2)>>2];F=F+1|0;}while(F>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}F=c[v>>2]|0;P=0;do{G=fa(D,P)|0;c[F+(P<<4)+8>>2]=(c[W+(G<<2)>>2]|0)==1;c[F+(P<<4)+12>>2]=c[W+(G+1<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0)}}while(0);$Z(W);dc(c[v>>2]|0,c[u>>2]|0,16,53);K=d;E=130;break};case 0:{if((D|0)!=4){n=42392;E=131;break a}if((I|0)!=11){n=42432;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){X=0}else{n=42472;E=131;break a}while(1){P=0;do{a[k+P|0]=a[j+((P<<2)+X)|0]|0;P=P+1|0;}while(P>>>0<11);a[k+11|0]=0;if((X|0)==3){break}P=X+1|0;if(P>>>0<4){X=P}else{K=d;E=130;break b}}if((z_(t,c[10510]|0,8)|0)==0){K=1;E=130;break b}if((z_(t,c[10516]|0,9)|0)==0){K=0;E=130}else{n=42504;E=131;break a}break};case 2:{if(d<<24>>24==1){if((I|0)==0){V=1;E=129;break b}P=D+1|0;F=0;while(1){G=_Z(P)|0;c[(c[v>>2]|0)+(F<<4)+4>>2]=G;if((sb(c[(c[v>>2]|0)+(F<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=42568;E=131;break a}a[(c[(c[v>>2]|0)+(F<<4)+4>>2]|0)+D|0]=0;G=F+1|0;if(G>>>0<I>>>0){F=G}else{K=1;E=130;break b}}}else if(!(d<<24>>24==0)){V=d;E=129;break b}F=fa(D,I)|0;Y=_Z(F+1|0)|0;if((sb(Y|0,F|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){F=I+1|0;P=(I|0)==0;G=0;do{O=_Z(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=O;if(!P){O=0;do{L=a[Y+((fa(D,O)|0)+G)|0]|0;a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+O|0]=L;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+I|0]=0;G=G+1|0;}while(G>>>0<D>>>0)}$Z(Y);K=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=V;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=K;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){$Z(U);n=42568;i=e;return n|0}else if((E|0)==46){$Z(Y);n=42568;i=e;return n|0}else if((E|0)==52){$Z(W);n=42600;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function jw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=zd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,53)|0;i=d;return b|0}function kw(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=42984;o=n;p=43032;q=p;r=43056;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=42984;o=n;p=43032;q=p;r=43056;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=_Z(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Vc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}$Z(r);t=0;i=e;return t|0}else{k=_Z(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Vc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}$Z(k);$Z(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);$Z(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function lw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=42984;r=q;s=43032;t=s;u=43080;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=42984;r=q;s=43032;t=s;u=43080;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Vc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Vc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function mw(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function nw(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function ow(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function pw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+ow(b)<e){q=1;i=f;return q|0}if(+nw(b)>e){q=1;i=f;return q|0}if((kw(b,1)|0)==0){q=1;i=f;return q|0}mw(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+lw(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+lw(a,b,d,o);i=f;return q|0}if(+lw(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+lw(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function qw(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function rw(a,b){a=a|0;b=b|0;var c=0;c=i;hv(a,b,Tv(b)|0);i=c;return}function sw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Tv(iv(a,b,f)|0)|0;i=e;return}function tw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((ev(a)|0)==0){cb(43112,43136,127,43160)}if((ev(b)|0)==0){cb(43184,43136,128,43160)}if((fv(a,b)|0)==0){cb(43208,43136,129,43160)}e=gv(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+qw(a,b);uw(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function uw(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function vw(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function ww(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;uw(c[d+8>>2]|0,b,a);i=e;return}function xw(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;rw(a,b);j=g;c[g>>2]=e;ww(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;ww(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function yw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=jv(a,b,f)|0;f=vw(c[a+8>>2]|0,d)|0;i=e;return f|0}function zw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=_Z(d<<2)|0;if((j|0)==0){cb(43248,43136,784,43280)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){cb(43256,43136,795,43280)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){cb(43304,43136,798,43280)}else if((s|0)==17){cb(43344,43136,800,43280)}else if((s|0)==22){cb(43344,43136,804,43280)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=Tv(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=Vv(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){$Z(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+qw(a,k+s|0);uw(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}$Z(j);i=g;return}function Aw(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if((ev(a)|0)==0){cb(43392,43136,1547,43416)}c=gv(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +qw(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function Bw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=_Z(20)|0;xv(0,(f|0)!=0|0,43432,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=a_(e,b)|0;c[f>>2]=a;xv(0,(a|0)!=0|0,43432,d);i=d;return f|0}function Cw(a){a=a|0;var b=0;b=i;$Z(c[a>>2]|0);$Z(a);i=b;return}function Dw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;xv(0,(c[h>>2]|0)>0|0,43448,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;xv(0,(g|0)>(b|0)|0,43472,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;xv(0,(0-f|0)<(b|0)|0,43472,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Ew(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=a_(c[d>>2]<<1,c[e>>2]|0)|0;xv(0,(f|0)!=0|0,43432,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Dw(a,j)|0;h=c[e>>2]|0;E_(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;$Z(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Fw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Ew(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;E_((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Gw(a){a=a|0;i=i;return c[a+12>>2]|0}function Hw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;xv(0,(c[j>>2]|0)>0|0,43448,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;xv(0,(h|0)>(b|0)|0,43472,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;xv(0,b>>>31^1,43472,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Dw(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Iw(a){a=a|0;i=i;return c[(c[10876]|0)+(a<<2)>>2]|0}function Jw(a){a=a|0;i=i;return c[(c[10878]|0)+(a<<2)>>2]|0}function Kw(a){a=a|0;i=i;return c[(c[10880]|0)+(a<<2)>>2]|0}function Lw(a){a=a|0;i=i;return c[(c[10882]|0)+(a<<2)>>2]|0}function Mw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[10878]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[10880]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[10876]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Nw(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[10884]|0;e=+Ow(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Ow(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Pw(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[10886]|0;e=+Ow(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Qw(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[10888]|0;e=+Ow(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Rw(a){a=a|0;i=i;return 0}function Sw(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[10890]|0)+(a<<3)|0)|0;d=(c[10876]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Tw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[10884]|0;f=e+(a<<3)|0;g=c[10888]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[10882]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[10876]|0)+(a<<2)>>2]|0);e=c[10886]|0;g=e+(a<<3)|0;Uw(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Mw(a);d=c[10884]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[10876]|0)+(a<<2)>>2]=0;i=b;return}function Uw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Xw(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Vw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[10890]|0;f=c[10884]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Ww(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=a_(a,8)|0;c[10884]=d;e=a_(a,8)|0;c[10886]=e;f=a_(a,8)|0;c[10888]=f;g=a_(a,8)|0;c[10890]=g;h=a_(a,4)|0;c[10876]=h;j=a_(a,4)|0;c[10882]=j;k=a<<2;l=_Z(k)|0;c[10878]=l;m=a_(a,4)|0;c[10880]=m;G_(l|0,-1,k|0)|0;if((d|0)==0){cb(43568,43584,393,43600)}if((e|0)==0){cb(43608,43584,394,43600)}if((f|0)==0){cb(43624,43584,395,43600)}if((g|0)==0){cb(43640,43584,396,43600)}if((h|0)==0){cb(43656,43584,397,43600)}if((l|0)==0){cb(43680,43584,398,43600)}if((m|0)==0){cb(43704,43584,399,43600)}if((j|0)==0){cb(43728,43584,400,43600)}else{i=b;return}}function Xw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Yw(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function Zw(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==1){c[l>>2]=c[b+8>>2];n=l+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];vv(17,0,o,45408,l);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];l=j+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];vv(17,0,o,45512,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];vv(17,0,o,45608,g);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];g=m+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];vv(17,0,o,45360,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];vv(17,0,o,45672,f);i=e;return}}function _w(a){a=a|0;var b=0;b=i;$Z(c[a+12>>2]|0);$Z(c[a+4>>2]|0);$Z(c[a+8>>2]|0);i=b;return}function $w(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Fd(a|0,d|0)|0;qd(d|0)|0;ae[c[22540]&255](0);i=b;return}function ax(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[6312]=.5;h[6298]=1.0;h[6335]=.25;h[6310]=2.0;h[6337]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[12632]=A;B=c[d>>2]|0;c[12562]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[12562]=D;if((C|0)<(B|0)){C=D}else{break}}}c[12560]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[6313]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[6313]=F;G=F}else{G=E}D=c[d>>2]|0;c[12562]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[12562]=I;if((H|0)>=(D|0)){break a}E=+h[6313];H=I}}}while(0);D=C+1|0;c[12560]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[6317]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[6282]=0.0;h[6284]=0.0;h[6288]=0.0;h[6345]=0.0;c[12558]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[6282]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[6284]+ +h[B>>3]*F;h[6284]=E;F=+h[I>>3];M=+h[6288]+F*F;h[6288]=M;F=+h[H>>3];h[6345]=+h[6345]+F*F;H=A+1|0;c[12558]=H;F=+h[6282];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[12628]=A;E=G/J;h[6334]=E;C=c[d>>2]|0;c[12562]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[6342]=0.0;h[6344]=0.0;I=c[b>>2]|0;c[12558]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[6311]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[6342]=ba;ca=E+aa*aa;h[6344]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[12558]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[12628]=A;h[6334]=E;h[6284]=Z;h[6288]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[12562]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[12558]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[12558]=A+1;da=+h[6284];ea=+h[6288];ga=+h[6282]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[6333]=K;c[12656]=0;h[6341]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[12656]=C;K=+h[6298]/+V(+ga);h[6313]=K;h[6336]=0.0;h[6338]=0.0;B=c[b>>2]|0;c[12558]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[6336]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[6336]=oa;pa=+h[6338]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[6338]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[6284];L=+h[6282];N=+h[6313];D=D+1|0;la=ma}c[12558]=B+1;ia=+h[6282];ja=pa;ka=oa}N=+h[6312];L=ka*N*ka;h[6329]=L;J=ja*N*ja;h[6330]=J;h[6289]=J+(L+ia*(+h[6345]+ia*N));N=+h[6310];h[50320>>3]=N*ka*ia;h[50328>>3]=N*ja*ia;h[50336>>3]=L-J;h[50344>>3]=ka*ja;la=50352|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[12558]=10;la=c[d>>2]|0;c[12562]=1;if((la|0)>=1){D=1;while(1){h[6329]=0.0;h[6330]=0.0;h[6331]=0.0;A=c[b>>2]|0;c[12558]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[6329]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[6330]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[6331]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[12558]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[6335]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[6329]*+h[6331];h[t+(U+D<<3)>>3]=+h[6330]*+h[6331];J=+h[6329];L=+h[6330];h[t+(P+D<<3)>>3]=+h[6335]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[6312]*+h[6329]*+h[6330];na=D+1|0;c[12562]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[12558]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[12570]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[12558]=B;if((la|0)<(D|0)){la=B}else{break}}}c[12566]=1;la=1;do{D=c[d>>2]|0;c[12574]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[12574]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[12562]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[12562]=D+1}na=c[12632]|0;c[12560]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[6309]=0.0;ma=c[d>>2]|0;c[12562]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[6309]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[12562]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[6309]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[12562]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[6309];Ca=Ca+1|0}c[12562]=ta+1}Ca=B+1|0;c[12560]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[12562]=1;if((A|0)<1){break}else{Ea=1}while(1){h[6309]=0.0;B=c[b>>2]|0;c[12560]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[6309]=N;Ca=na+1|0;c[12560]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[12562]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[12560]=1;if((A|0)>=1){ta=1;while(1){h[6309]=0.0;c[12558]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[6309]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[12558]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[12560]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[12566]=la;}while((la|0)<6);la=c[l>>2]|0;c[12562]=1;h[6309]=0.0;c[12558]=1;L=+h[6312];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[50392+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[50392+(A+ -1<<3)>>3]+L;h[6309]=L;A=A+1|0;}while((A|0)<6);h[6289]=+h[6289]- +h[6299]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[6329]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[6330]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[6331]=O;h[50320>>3]=+h[50320>>3]-J-N*(O+K);h[50352>>3]=+h[50352>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[6329]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[6330]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[6331]=J;h[50328>>3]=+h[50328>>3]-O-N*(K-J);h[50360>>3]=+h[50360>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[6329]=J;h[50336>>3]=+h[50408>>3]+(+h[50336>>3]-J- +h[50400>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[6329]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[6330]=K;Oa=+h[6312];h[50344>>3]=+h[50344>>3]-J-K*Oa;h[50368>>3]=+h[50368>>3]- +h[50416>>3]+ +h[50424>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[6329]=K;h[50376>>3]=+h[50376>>3]-Oa*K;h[6309]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[12562]=la+1;c[12558]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[50392+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[50392+(ta+ -1<<3)>>3]+N;h[6309]=N;ta=ta+1|0;c[12558]=ta;}while((ta|0)<6);K=+h[6317];h[6319]=K*+h[6289]+ +h[6299]+N;J=+h[6310];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[6329]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[6330]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[6331]=R;T=R+(K*+h[50320>>3]+O+S);h[50560>>3]=T;O=K*+h[50352>>3]+S-R;h[50592>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[6329]=R;S=+h[I>>3]*+h[ma>>3];h[6330]=S;Z=+h[Ma>>3]*+h[Na>>3];h[6331]=Z;h[50568>>3]=K*+h[50328>>3]+R+S-Z;h[50600>>3]=K*+h[50360>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[6329]=Z;R=+h[50400>>3]+(Z+K*+h[50336>>3])- +h[50408>>3];h[50576>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[6329]=Z;h[50584>>3]=Z+K*+h[50344>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[50368>>3]+ +h[50416>>3]- +h[50424>>3];h[50608>>3]=J;h[50616>>3]=+h[6317]*+h[50376>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[6319]+T+R+O+J;h[6309]=K;h[6339]=K;h[6340]=K;c[12664]=0;J=+h[6337]/50.0;h[6313]=J;h[6299]=+h[6298];c[12558]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[50400>>3]=Z;W=+Y(+Pa);h[50408>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[50392+(Ma+ -1<<3)>>3]=Z;Q=+h[50400>>3]*G+ +h[50408>>3]*W;h[50392+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[50408>>3];ca=+h[50400>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[50552+(Ma<<3)>>3]*+h[50392+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[6340]=Ra;c[12664]=Na;h[6329]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[6330]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[12560]=10;h[6309]=Ra;h[6318]=Pa;h[6343]=O;c[12558]=50;if((Xa|0)==49){h[6330]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[6329]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[6315]=0.0;if(Ya!=Za){S=Ya-Ua;h[6329]=S;T=Za-Ua;h[6330]=T;R=+h[6312]*(S-T)/(S+T);h[6315]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[6318]=R;T=+X(+R);h[50400>>3]=T;S=+Y(+R);h[50408>>3]=S;c[12560]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[50392+(Na+ -1<<3)>>3]=T;W=+h[50400>>3]*G+ +h[50408>>3]*S;h[50392+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[50408>>3];N=+h[50400>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[6340]=0.0;c[12560]=1;Na=1;do{ma=Na+ -1|0;Ma=50392+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[50312+(ma<<3)>>3]*+h[Ma>>3];h[6340]=+h[6340]+ +h[50552+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[12560]=10;Na=c[l>>2]|0;c[12562]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[50392+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[12560]=6;c[12562]=Na+1}h[6308]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[6282]=0.0;h[6329]=0.0;h[6330]=0.0;Ma=c[b>>2]|0;c[12558]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[50400>>3]*+h[la>>3]+ +h[50408>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[6282]=+h[6282]+G*G;bb=+h[6329]+ +h[la>>3]*+h[ta>>3];h[6329]=bb;G=+h[ta>>3];cb=+h[6330]+G*G;h[6330]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[12558]=Ma+1;$a=cb;ab=bb}ma=c[12656]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[6341];S=+h[6339];h[6341]=G>=S?G:S}S=+h[6340];if(!(S>=0.0)){db=-S}else{db=S}G=+h[6341];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[6341]=S;c[12558]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[6313]=N;R=+h[6308]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[6317];la=ta+1|0;c[12558]=la;if((ta|0)>=(Na|0)){break b}S=+h[6330];G=+h[6329];ta=la}}}while(0);Na=c[d>>2]|0;c[12562]=1;if((Na|0)>=1){Ma=1;while(1){h[6309]=0.0;ta=c[b>>2]|0;c[12560]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[6309]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[12560]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[6308]*+h[p+(la+ -1+Ma<<3)>>3]- +h[6317]*+h[q+(Ma+ -1<<3)>>3]);h[6313]=G;c[12558]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[6313];I=I+1|0}c[12558]=la+1}I=Ma+1|0;c[12562]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[6288]=0.0;h[6284]=0.0;Ma=c[b>>2]|0;c[12558]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[6288]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[6284]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[12558]=Ma+1;hb=kb;ib=jb}S=+h[6282];G=S*ib-hb*hb;h[6333]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[50288]=1;C=c[l>>2]|0;c[12562]=1;if((C|0)<1){lb=50384;mb=+h[6298];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[50392+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[12560]=6;c[12562]=C+1;lb=50384;mb=+h[6298];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function bx(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[6365]=.5;h[6361]=1.0;h[6377]=6.283185307179586;z=+h[n>>3];h[6374]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[12736]=A;c[12744]=0;B=c[d>>2]|0;c[12696]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[12696]=B+1}c[12694]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[6366]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[6366]=F;G=F}else{G=z}H=c[d>>2]|0;c[12696]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[6366];I=I+1|0}c[12696]=H+1}I=B+1|0;c[12694]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[6349]=0.0;D=c[b>>2]|0;c[12692]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[6349]=+h[6349]+G*G;A=p+1|0;c[12692]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[12696]=1;if((p|0)>=1){D=1;while(1){h[6366]=0.0;h[6364]=0.0;y=c[b>>2]|0;c[12694]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[6366]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[6364]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[12694]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[6366]=G;h[6364]=+h[g>>3]*L;g=c[b>>2]|0;c[12692]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[6364]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[6366];H=H+1|0}c[12692]=g+1}H=D+1|0;c[12696]=H;if((D|0)<(p|0)){D=H}else{break}}}h[6350]=0.0;h[6352]=0.0;h[6359]=0.0;D=c[b>>2]|0;c[12692]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[6350]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[6352]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[6359]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[12692]=D+1;O=R;P=T;Q=S}S=+h[6349];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[6370]=U;h[6366]=0.0;if(Q*Q>S*.99*O){h[6366]=+h[6361]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[6365]*U*Z);h[6362]=P;if(O*+h[6374]<P*P*.01){h[6366]=+h[6361]}n=c[b>>2]|0;c[12692]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[6370]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[6366]*U;if((D|0)>=(n|0)){break}e=D;P=+h[6370];D=D+1|0;p=e}c[12692]=n+1;_=0}while(1){n=_+1|0;c[12744]=n;h[6349]=0.0;h[6352]=0.0;h[6353]=0.0;p=c[b>>2]|0;c[12692]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[6349]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[6352]=da;Z=+h[H>>3];ea=P+Z*Z;h[6353]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[12692]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[6366]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[6371]=U;D=c[b>>2]|0;c[12692]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[6371];U=+h[6352];O=+h[6349];g=g+1|0;H=e}c[12692]=D+1}H=c[d>>2]|0;c[12696]=1;if((H|0)>=1){g=1;while(1){h[6364]=0.0;p=c[b>>2]|0;c[12694]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[6364]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[12694]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[6364]=O;e=c[b>>2]|0;c[12692]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[6364];l=l+1|0}c[12692]=e+1}l=g+1|0;c[12696]=l;if((g|0)<(H|0)){g=l}else{break}}}h[6354]=0.0;h[6355]=0.0;h[6356]=0.0;h[6357]=0.0;h[6358]=0.0;g=c[b>>2]|0;c[12692]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[6354]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[6355]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[6356]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[6357]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[6358]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[12692]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[6365];O=U*na;h[6354]=O;P=U*ma-O;h[6357]=P;Z=O+la+P;h[6378]=Z;h[6380]=Z;h[6379]=Z;c[12746]=0;a[50808]=1;W=+h[6377]/50.0;h[6366]=W;c[12692]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[6380]=wa;c[12746]=p;h[6375]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[6376]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[6369]=ta;h[6360]=ua;h[6363]=va;h[6362]=wa;c[12692]=50;h[6379]=wa;if((za|0)==0){h[6375]=wa;ga=74}else if((za|0)==49){h[6376]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[6376]}h[6367]=0.0;S=+h[6375];if(S!=Ba){Q=S-Aa;h[6375]=Q;S=Ba-Aa;h[6376]=S;T=U*(Q-S)/(Q+S);h[6367]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[6369]=T;S=+X(+T);h[6360]=S;Q=+Y(+T);h[6363]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[6362]=T;p=c[b>>2]|0;c[12692]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[6360]*+h[y>>3]+ +h[6363]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[6363];Q=+h[6360];H=H+1|0;g=e}c[12692]=p+1;Da=+h[6362]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[6378];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function cx(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[51264]=1;a[51256]=1;c[51276>>2]=6;DO(51272)|0;e=c[d>>2]|0;c[12812]=1;if((e|0)>=1){d=1;do{UN(51392,b+(d+ -1)|0,1)|0;o=c[12812]|0;d=o+1|0;c[12812]=d;}while((o|0)<(e|0))}lO()|0;e=c[g>>2]|0;if((e|0)==1){c[51300>>2]=a[51256]&1?6:0;DO(51296)|0;UN(51392,h,4)|0;lO()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[51324>>2]=a[51256]&1?6:0;DO(51320)|0;UN(51392,h,4)|0;UN(51392,j,4)|0;lO()|0}j=c[k>>2]|0;if((j|0)==1){c[51348>>2]=a[51256]&1?6:0;DO(51344)|0;UN(51392,l,8)|0;lO()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[51372>>2]=a[51256]&1?6:0;DO(51368)|0;UN(51392,l,8)|0;UN(51392,m,8)|0;lO()|0}if((c[f>>2]|0)==2){CN(51400,0)|0}else{i=n;return 0}return 0}



function iZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=_Z((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=_Z((l<<2)+4|0)|0;if((p|0)==0){$Z(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}oZ(d,e)|0;e=oZ(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{F=v;G=w;H=x;I=y;J=z;K=E;L=0;M=B;break}}break};case 1:{E=u+ -2|0;c[h>>2]=E;N=c[D+(E<<2)>>2]|0;if(k){E=c[(c[c[N+4>>2]>>2]|0)+20>>2]|0;O=u+ -3|0;c[h>>2]=O;c[N+20>>2]=(c[D+(O<<2)>>2]|0)+E;F=v;G=-1;H=x;I=y;J=z;K=A;L=0;M=B;break b}else{E=u+ -3|0;c[h>>2]=E;O=c[D+(E<<2)>>2]|0;E=u+ -4|0;c[h>>2]=E;N=(O|0)==0;F=N&1;G=N?w:c[D+(E<<2)>>2]|0;H=x;I=y;J=z;K=A;L=0;M=B;break b}break};case 0:{E=u+ -2|0;c[h>>2]=E;N=c[D+(E<<2)>>2]|0;E=N;O=N+12|0;P=c[O>>2]|0;if((P|0)>-1){Q=0;do{R=A+(Q<<2)|0;Q=Q+1|0}while((c[R>>2]|0)>-1);c[R>>2]=P<<1;c[A+(Q<<2)>>2]=-1;do{if(!k){S=0;while(1){if((c[p+(S<<2)>>2]|0)>-1){S=S+1|0}else{break}}c[(c[s>>2]|0)+(P*12|0)+8>>2]=0;if((S|0)<=0){break}T=_Z((S<<2)+4|0)|0;U=T;if((T|0)==0){V=w;W=y;X=z;Y=A;Z=12;_=B;break a}c[(c[s>>2]|0)+(P*12|0)+8>>2]=U;$=c[p>>2]|0;if(($|0)>-1){aa=U;ba=$;$=0;while(1){c[aa>>2]=ba;ca=$+1|0;da=c[p+(ca<<2)>>2]|0;ea=T+(ca<<2)|0;if((da|0)>-1){$=ca;ba=da;aa=ea}else{fa=ea;break}}}else{fa=U}c[fa>>2]=-1}}while(0);P=oZ(d,c[O>>2]|0)|0;if((P|0)!=0){V=w;W=y;X=z;Y=A;Z=P;_=B;break a}P=oZ(d,6)|0;if((P|0)!=0){V=w;W=y;X=z;Y=A;Z=P;_=B;break a}}P=c[N>>2]|0;do{if((P|0)==3){Q=c[N+4>>2]|0;aa=c[Q>>2]|0;ba=c[Q+4>>2]|0;Q=(c[A>>2]|0)>-1;$=x+1|0;T=oZ(d,Q?$:x)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=oZ(d,Q?x:B)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=oZ(d,A)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=oZ(d,(c[A>>2]|0)>>>31^1)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=oZ(d,N)|0;if((T|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=T;ma=B;break}T=ba;ba=oZ(d,T)|0;if((ba|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=ba;ma=B;break}ba=aa;aa=oZ(d,ba)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=oZ(d,3)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=oZ(d,T)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=oZ(d,0)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=oZ(d,2)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=oZ(d,ba)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}aa=oZ(d,0)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}if((c[A>>2]|0)>-1){if(k){na=w;oa=y;pa=0}else{aa=qZ(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ba=c[t>>2]|0;T=0;while(1){qa=ba+(T<<2)|0;ra=T+1|0;if((c[qa>>2]|0)>-1){T=ra}else{break}}c[qa>>2]=B;c[ba+(ra<<2)>>2]=w;c[ba+(T+2<<2)>>2]=-1;sa=-1;ta=y+1|0}else{sa=w;ta=y}U=c[A>>2]|0;if((U|0)>-1){Q=c[s>>2]|0;S=U;U=0;do{ea=(S|0)/2|0;if((S&1|0)==0){c[Q+(ea*12|0)>>2]=B}else{c[Q+(ea*12|0)+4>>2]=B}U=U+1|0;S=c[A+(U<<2)>>2]|0;}while((S|0)>-1)}c[A>>2]=-1;na=sa;oa=ta;pa=aa}c[A>>2]=-1;ua=na;va=$;wa=oa;xa=z+1|0;ya=pa;za=x}else{ua=w;va=x;wa=y;xa=z;ya=0;za=B}if((c[N+16>>2]|0)<=0){ga=v;ha=ua;ia=va;ja=wa;ka=xa;la=ya;ma=za;break}ga=v;ha=ua;ia=va+2|0;ja=wa;ka=xa;la=ya;ma=va+1|0}else if((P|0)==0){S=c[c[N+4>>2]>>2]|0;if(!((S|0)>-1|(S|0)==-4)){ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}if(!((c[A>>2]|0)>-1)){ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}if(k){c[N+20>>2]=1;Aa=w;Ba=y;Ca=0}else{S=qZ(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){U=c[t>>2]|0;Q=0;while(1){Da=U+(Q<<2)|0;Ea=Q+1|0;if((c[Da>>2]|0)>-1){Q=Ea}else{break}}c[Da>>2]=B;c[U+(Ea<<2)>>2]=w;c[U+(Q+2<<2)>>2]=-1;Fa=-1;Ga=y+1|0}else{Fa=w;Ga=y}$=c[A>>2]|0;if(($|0)>-1){aa=c[s>>2]|0;T=$;$=0;do{ba=(T|0)/2|0;if((T&1|0)==0){c[aa+(ba*12|0)>>2]=B}else{c[aa+(ba*12|0)+4>>2]=B}$=$+1|0;T=c[A+($<<2)>>2]|0;}while((T|0)>-1)}c[A>>2]=-1;Aa=Fa;Ba=Ga;Ca=S}c[A>>2]=-1;ga=v;ha=Aa;ia=x+1|0;ja=Ba;ka=z+1|0;la=Ca;ma=x}else if((P|0)==2){T=c[N+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ha=1}else{Ha=a[T+12|0]&1}$=oZ(d,Ha)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}}else{$=oZ(d,B)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}$=oZ(d,a[T+12|0]&1)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}}$=oZ(d,N)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}$=oZ(d,1)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}$=oZ(d,c[T>>2]|0)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}$=oZ(d,0)|0;if(($|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=$;ma=B;break}if(!((c[A>>2]|0)>-1)){if((a[T+12|0]&1)==0){ga=0;ha=w;ia=x;ja=y;ka=z;la=0;ma=B;break}}if(k){Ia=w;Ja=y;Ka=0}else{$=qZ(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[T+12|0]&1)==0?v:1;if((w|0)>-1){T=c[t>>2]|0;aa=0;while(1){La=T+(aa<<2)|0;Ma=aa+1|0;if((c[La>>2]|0)>-1){aa=Ma}else{break}}c[La>>2]=B;c[T+(Ma<<2)>>2]=w;c[T+(aa+2<<2)>>2]=-1;Na=-1;Oa=y+1|0}else{Na=w;Oa=y}S=c[A>>2]|0;if((S|0)>-1){Q=c[s>>2]|0;U=S;S=0;do{ba=(U|0)/2|0;if((U&1|0)==0){c[Q+(ba*12|0)>>2]=B}else{c[Q+(ba*12|0)+4>>2]=B}S=S+1|0;U=c[A+(S<<2)>>2]|0;}while((U|0)>-1)}c[A>>2]=-1;Ia=Na;Ja=Oa;Ka=$}c[A>>2]=-1;ga=0;ha=Ia;ia=x+1|0;ja=Ja;ka=z+1|0;la=Ka;ma=x}else if((P|0)==1){U=c[N+4>>2]|0;S=c[U>>2]|0;Q=c[U+4>>2]|0;U=oZ(d,N)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=oZ(d,5)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=oZ(d,Q)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=oZ(d,0)|0;if((U|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=U;ma=B;break}U=S+20|0;aa=oZ(d,(c[U>>2]|0)+x|0)|0;if((aa|0)!=0){ga=v;ha=w;ia=x;ja=y;ka=z;la=aa;ma=B;break}if((c[U>>2]|0)>0){U=(c[Q+20>>2]|0)>0;Pa=(U&1)+x|0;Qa=U?x:-1}else{Pa=x;Qa=-1}U=oZ(d,Qa)|0;if((U|0)!=0){ga=v;ha=w;ia=Pa;ja=y;ka=z;la=U;ma=B;break}U=oZ(d,4)|0;if((U|0)!=0){ga=v;ha=w;ia=Pa;ja=y;ka=z;la=U;ma=B;break}U=oZ(d,S)|0;if((U|0)!=0){ga=v;ha=w;ia=Pa;ja=y;ka=z;la=U;ma=B;break}ga=v;ha=w;ia=Pa;ja=y;ka=z;la=oZ(d,0)|0;ma=B}else{ga=v;ha=w;ia=x;ja=y;ka=z;la=0;ma=B}}while(0);N=c[O>>2]|0;if((N|0)>-1){Ra=0}else{F=ga;G=ha;H=ia;I=ja;J=ka;K=A;L=la;M=ma;break b}do{Sa=p+(Ra<<2)|0;Ra=Ra+1|0}while((c[Sa>>2]|0)>-1);c[Sa>>2]=N;c[p+(Ra<<2)>>2]=-1;F=ga;G=ha;H=ia;I=ja;J=ka;K=A;L=la;M=ma;break};case 4:{O=u+ -2|0;c[h>>2]=O;P=c[D+(O<<2)>>2]|0;O=u+ -3|0;c[h>>2]=O;F=v;G=w;H=c[D+(O<<2)>>2]|0;I=y;J=z;K=A;L=0;M=(P|0)>-1?P:B;break};case 5:{P=u+ -2|0;c[h>>2]=P;O=c[D+(P<<2)>>2]|0;if(!k){F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break b}P=c[O+4>>2]|0;c[O+20>>2]=(c[(c[P+4>>2]|0)+20>>2]|0)+(c[(c[P>>2]|0)+20>>2]|0);F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break};case 3:{P=c[D+(u+ -2<<2)>>2]|0;O=c[D+(u+ -3<<2)>>2]|0;E=c[D+(u+ -4<<2)>>2]|0;U=u+ -5|0;c[h>>2]=U;if(k){S=c[E+4>>2]|0;Q=E+16|0;c[E+20>>2]=(c[(c[S>>2]|0)+20>>2]|0)+(c[D+(U<<2)>>2]|0)+(c[(c[S+4>>2]|0)+20>>2]|0)+((c[Q>>2]|0)>0?2:0);Ta=Q;Ua=c[h>>2]|0}else{Ta=E+16|0;Ua=U}U=c[D+(Ua+ -1<<2)>>2]|0;E=Ua+ -2|0;c[h>>2]=E;Q=c[D+(E<<2)>>2]|0;E=Ua+ -3|0;c[h>>2]=E;S=c[D+(E<<2)>>2]|0;if((c[Ta>>2]|0)<=0){F=1;G=w;H=x;I=y;J=z;K=U;L=0;M=B;break b}if(k){Va=0}else{rZ(b,P,Q)|0;c[(c[r>>2]|0)+(Q<<2)>>2]=1;Q=rZ(b,O,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;Va=Q}F=1;G=w;H=x;I=y;J=z+2|0;K=U;L=Va;M=B;break};case 6:{U=u+ -2|0;c[h>>2]=U;Q=c[D+(U<<2)>>2]|0;U=0;do{Wa=A+(U<<2)|0;U=U+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=Q<<1|1;c[A+(U<<2)>>2]=-1;N=0;while(1){if((c[p+(N<<2)>>2]|0)>-1){N=N+1|0}else{break}}c[p+(N+ -1<<2)>>2]=-1;F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B;break};default:{F=v;G=w;H=x;I=y;J=z;K=A;L=0;M=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(L|0)==0){u=D;v=F;w=G;x=H;y=I;z=J;A=K;B=M}else{V=G;W=I;X=J;Y=K;Z=L;_=M;break a}}}else{V=-1;W=0;X=0;Y=n;Z=e;_=0}}while(0);do{if(k){Xa=W}else{e=c[Y>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;M=e;e=0;do{L=(M|0)/2|0;if((M&1|0)==0){c[n+(L*12|0)>>2]=_}else{c[n+(L*12|0)+4>>2]=_}e=e+1|0;M=c[Y+(e<<2)>>2]|0;}while((M|0)>-1)}c[Y>>2]=-1;if(!((V|0)>-1)){Xa=W;break}M=c[f+36>>2]|0;e=0;while(1){Ya=M+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=_;c[M+(Za<<2)>>2]=V;c[M+(e+2<<2)>>2]=-1;Xa=W+1|0}}while(0);c[f+48>>2]=X;c[f+40>>2]=X;c[f+44>>2]=Xa;$Z(m);$Z(p);o=Z;i=g;return o|0}function jZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=lZ(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==3){h=c[g+4>>2]|0;j=jZ(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=lZ(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=jZ(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function kZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{$Z(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}$Z(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){$Z(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){$Z(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}$Z(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{$Z(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}$Z(m)}m=c[d+32>>2]|0;if((m|0)!=0){$Z(m)}m=c[d+20>>2]|0;if((m|0)!=0){$Z(m)}m=c[d+36>>2]|0;if((m|0)!=0){$Z(m)}$Z(d);i=b;return}function lZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=_Z(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){$Z(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=_Z((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function mZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=yZ(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=yZ(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=yZ(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function nZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=oZ(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}B=oZ(a,s)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=oZ(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=oZ(a,r)|0}else if((q|0)==1){r=c[o+4>>2]|0;s=oZ(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}B=oZ(a,c[r+4>>2]|0)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function oZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=b_(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;oZ(a,b)|0;i=d;return 0}return 0}function pZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;oZ(d,e)|0;e=oZ(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==3){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=yZ(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}H=yZ(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;I=oZ(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,F+4|0)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=F;M=oZ(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;I=c[F+8>>2]|0;y=c[F>>2]|0;D=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=D;P=y;Q=s+1|0;R=(c[g>>2]|0)+I|0}else{if(!((y|0)==-3)){N=r;O=D;P=y;Q=s;R=I;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=D;P=-3;Q=s;R=I;break}c[h+(D<<2)>>2]=1;N=0;O=D;P=-3;Q=s;R=I}}while(0);I=yZ(b,0,0,1,32)|0;D=I;do{if((I|0)==0){S=0}else{y=yZ(b,0,0,1,20)|0;c[I+4>>2]=y;if((y|0)==0){S=0;break}c[I>>2]=0;c[I+8>>2]=-1;c[I+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=D}}while(0);c[t>>2]=S;D=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=D;break}c[k>>2]=R;J=N;K=Q;L=t;M=D}else if((z|0)==1){D=c[u+4>>2]|0;I=c[D>>2]|0;y=D+4|0;F=c[y>>2]|0;x=yZ(b,0,0,1,32)|0;if((x|0)==0){G=29;break b}E=yZ(b,0,0,1,8)|0;H=x+4|0;c[H>>2]=E;if((E|0)==0){G=29;break b}c[x>>2]=1;c[x+8>>2]=-1;c[x+12>>2]=-1;c[E>>2]=I;c[(c[H>>2]|0)+4>>2]=F;c[x+16>>2]=(c[F+16>>2]|0)+(c[I+16>>2]|0);c[t>>2]=x;x=c[H>>2]|0;c[x>>2]=0;H=x+4|0;c[H>>2]=0;I=oZ(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,H)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=x;M=oZ(d,0)|0}else if((z|0)==2){x=c[u+4>>2]|0;I=oZ(d,c[x>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=oZ(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=c[x>>2]|0;D=c[x+4>>2]|0;H=c[x+8>>2]|0;y=a[x+12|0]|0;x=yZ(b,0,0,1,32)|0;if((x|0)==0){G=40;break b}F=yZ(b,0,0,1,16)|0;E=x+4|0;c[E>>2]=F;if((F|0)==0){G=40;break b}c[x>>2]=2;c[x+8>>2]=-1;c[x+12>>2]=-1;c[F>>2]=I;c[F+4>>2]=D;c[F+8>>2]=H;H=F+12|0;a[H]=a[H]&-2|y&1;c[x+16>>2]=c[I+16>>2];c[t>>2]=x;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function qZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=yZ(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=yZ(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=yZ(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=yZ(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function rZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=yZ(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=yZ(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=yZ(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=yZ(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function sZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function tZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=130256}else{j=b;k=130256;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((C_(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,130544,g|0)|0)+1|0;i=d;return h|0}function uZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=_Z(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=_Z(y)|0;if((z|0)==0){A=12;break}G_(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=cZ(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((JY(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((JY(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((JY(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((JY(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(JY(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(JY(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(JY(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(JY(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){G_(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=cZ(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((JY(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((JY(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((JY(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((JY(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(JY(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(JY(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(JY(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(JY(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((NY(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=ZY(X)|0;qb=_a+24|0;if((NY(fb,c[qb>>2]|0)|0)!=0){break}fb=XY(X)|0;if((NY(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((NY(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=XY(X)|0;if((NY(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=ZY(X)|0;if((NY(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}$Z(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=wZ(0,0)|0;if((S|0)==0){A=12;break}R=yZ(S,0,0,0,32)|0;Q=R;if((R|0)==0){xZ(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=_Z(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=_Z(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=_Z(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){G_(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){G_(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=cZ(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((JY(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((JY(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((JY(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((JY(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(JY(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(JY(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(JY(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(JY(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=yZ(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=yZ(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;vZ(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((z_(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=cZ(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=cZ(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((JY(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((JY(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((JY(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((JY(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(JY(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(JY(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(JY(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(JY(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((NY(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=ZY(tc)|0;aa=Ca+24|0;if((NY(qa,c[aa>>2]|0)|0)!=0){break}qa=XY(tc)|0;if((NY(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((NY(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=XY(tc)|0;if((NY(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=ZY(tc)|0;if((NY(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=yZ(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=yZ(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){xZ(S);if((Eb|0)!=0){$Z(O)}if((Kb|0)!=0){$Z(Kb)}if((Lb|0)==0){A=12;break a}$Z(N);A=12;break a}else if((sa|0)==67){xZ(S);if((Eb|0)!=0){$Z(O)}if((Kb|0)!=0){$Z(Kb)}if((Lb|0)==0){A=12;break a}$Z(N);A=12;break a}else if((sa|0)==169){xZ(S);if((Eb|0)!=0){$Z(O)}if((Kb|0)!=0){$Z(Kb)}if((Lb|0)==0){A=12;break a}$Z(N);A=12;break a}else if((sa|0)==176){xZ(S);if((Eb|0)!=0){$Z(O)}if((Kb|0)!=0){$Z(Kb)}if((Lb|0)==0){A=12;break a}$Z(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);xZ(S);if((Jb|0)!=0){$Z(Jb)}if((Gb|0)!=0){$Z(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}$Z(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}vZ(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}$Z(m);p=A;i=g;return p|0}function vZ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function wZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=a_(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function xZ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;$Z(e);i=b;return}else{f=d}while(1){$Z(c[f>>2]|0);d=c[f+4>>2]|0;$Z(f);if((d|0)==0){break}else{f=d}}e=a;$Z(e);i=b;return}function yZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=_Z(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=_Z(p)|0;c[o>>2]=r;if((r|0)==0){$Z(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}G_(m|0,0,h|0)|0;j=m;i=g;return j|0}function zZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((AZ(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function AZ(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function BZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function CZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function DZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function EZ(a){a=a|0;i=i;return}function FZ(a){a=a|0;c[a>>2]=130560;i=i;return}function GZ(a){a=a|0;var b=0;b=i;zb(a|0);g_(a);i=b;return}function HZ(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function IZ(a){a=a|0;i=i;return 130576}function JZ(a){a=a|0;i=i;return}function KZ(a){a=a|0;i=i;return}function LZ(a){a=a|0;i=i;return}function MZ(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function NZ(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function OZ(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function PZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=TZ(b,130688,130744,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;De[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function QZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function RZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;De[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function SZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;De[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;De[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function TZ(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;me[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Zd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function UZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;me[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Zd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Zd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Zd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Zd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function VZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Zd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;me[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function WZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function XZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;me[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;me[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function YZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;me[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function ZZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function _Z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[32748]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=131032+(j<<2)|0;l=131032+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[32748]=f&~(1<<h)}else{if(n>>>0<(c[131008>>2]|0)>>>0){ed()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{ed()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[131e3>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=131032+(r<<2)|0;o=131032+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[32748]=f&~(1<<t)}else{if(n>>>0<(c[131008>>2]|0)>>>0){ed()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{ed()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[131e3>>2]|0;if((n|0)!=0){f=c[131012>>2]|0;e=n>>>3;n=e<<1;g=131032+(n<<2)|0;m=c[32748]|0;j=1<<e;do{if((m&j|0)==0){c[32748]=m|j;u=131032+(n+2<<2)|0;v=g}else{e=131032+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[131008>>2]|0)>>>0)){u=e;v=h;break}ed()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[131e3>>2]=o;c[131012>>2]=s;p=k;i=b;return p|0}n=c[130996>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[131296+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[131008>>2]|0;if(h>>>0<k>>>0){ed()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){ed()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){ed()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){ed()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){ed()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{ed()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=131296+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<h);break a}else{if(s>>>0<(c[131008>>2]|0)>>>0){ed()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[131008>>2]|0)>>>0){ed()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[131e3>>2]|0;if((h|0)!=0){s=c[131012>>2]|0;k=h>>>3;h=k<<1;f=131032+(h<<2)|0;m=c[32748]|0;g=1<<k;do{if((m&g|0)==0){c[32748]=m|g;A=131032+(h+2<<2)|0;B=f}else{k=131032+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[131008>>2]|0)>>>0)){A=k;B=e;break}ed()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[131e3>>2]=t;c[131012>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[130996>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[131296+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[131296+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[131e3>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[131008>>2]|0;if(t>>>0<f>>>0){ed()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){ed()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){ed()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){ed()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){ed()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{ed()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=131296+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<e);break c}else{if(t>>>0<(c[131008>>2]|0)>>>0){ed()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[131008>>2]|0)>>>0){ed()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=131032+(t<<2)|0;s=c[32748]|0;r=1<<e;do{if((s&r|0)==0){c[32748]=s|r;S=131032+(t+2<<2)|0;T=f}else{e=131032+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[131008>>2]|0)>>>0)){S=e;T=k;break}ed()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=131296+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[130996>>2]|0;l=1<<U;if((f&l|0)==0){c[130996>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[131008>>2]|0;if(W>>>0<k>>>0){ed()}if(r>>>0<k>>>0){ed()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[131e3>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[131012>>2]|0;if(W>>>0>15){c[131012>>2]=X+q;c[131e3>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[131e3>>2]=0;c[131012>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[131004>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[131004>>2]=W;X=c[131016>>2]|0;c[131016>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[32866]|0)==0){X=cd(30)|0;if((X+ -1&X|0)==0){c[131472>>2]=X;c[131468>>2]=X;c[131476>>2]=-1;c[131480>>2]=-1;c[131484>>2]=0;c[131436>>2]=0;c[32866]=(sc(0)|0)&-16^1431655768;break}else{ed()}}}while(0);X=q+48|0;W=c[131472>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[131432>>2]|0;do{if((U|0)!=0){T=c[131424>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[131436>>2]&4|0)==0){U=c[131016>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=131440|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[131004>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[131468>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[131424>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[131432>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[131472>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[131436>>2]=c[131436>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[131424>>2]|0)+ga|0;c[131424>>2]=ia;if(ia>>>0>(c[131428>>2]|0)>>>0){c[131428>>2]=ia}ia=c[131016>>2]|0;W=131440|0;i:do{if((ia|0)==0){aa=c[131008>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[131008>>2]=fa}c[131440>>2]=fa;c[131444>>2]=ga;c[131452>>2]=0;c[131028>>2]=c[32866];c[131024>>2]=-1;aa=0;do{ha=aa<<1;$=131032+(ha<<2)|0;c[131032+(ha+3<<2)>>2]=$;c[131032+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[131016>>2]=fa+ja;c[131004>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[131020>>2]=c[131480>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[131004>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[131016>>2]=ia+na;c[131004>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[131020>>2]=c[131480>>2];break i}}while(0);if(fa>>>0<(c[131008>>2]|0)>>>0){c[131008>>2]=fa}aa=fa+ga|0;$=131440|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[131016>>2]|0)){ca=(c[131004>>2]|0)+X|0;c[131004>>2]=ca;c[131016>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[131012>>2]|0)){ca=(c[131e3>>2]|0)+X|0;c[131e3>>2]=ca;c[131012>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=131032+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[131008>>2]|0)>>>0){ed()}if((c[V+12>>2]|0)==(ha|0)){break}ed()}}while(0);if((L|0)==(V|0)){c[32748]=c[32748]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[131008>>2]|0)>>>0){ed()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}ed()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[131008>>2]|0)>>>0){ed()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){ed()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{ed()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=131296+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<t);break k}else{if(T>>>0<(c[131008>>2]|0)>>>0){ed()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[131008>>2]|0)>>>0){ed()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=131032+(Z<<2)|0;t=c[32748]|0;T=1<<ca;do{if((t&T|0)==0){c[32748]=t|T;xa=131032+(Z+2<<2)|0;ya=ea}else{ca=131032+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[131008>>2]|0)>>>0)){xa=ca;ya=V;break}ed()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=131296+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[130996>>2]|0;L=1<<za;if((ea&L|0)==0){c[130996>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[131008>>2]|0;if(Ba>>>0<S>>>0){ed()}if(T>>>0<S>>>0){ed()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=131440|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[131016>>2]=fa+Ha;c[131004>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[131020>>2]=c[131480>>2];c[ba+4>>2]=27;X=131440|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[131440>>2]=fa;c[131444>>2]=ga;c[131452>>2]=0;c[131448>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=131032+(da<<2)|0;aa=c[32748]|0;f=1<<M;do{if((aa&f|0)==0){c[32748]=aa|f;Ia=131032+(da+2<<2)|0;Ja=ha}else{M=131032+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[131008>>2]|0)>>>0)){Ia=M;Ja=T;break}ed()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=131296+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[130996>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[130996>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[131008>>2]|0;if(Ma>>>0<f>>>0){ed()}if(M>>>0<f>>>0){ed()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[131004>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[131004>>2]=W;ia=c[131016>>2]|0;c[131016>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}



function SE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;aF(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){yv(0,87168,n)}if(p){ec=vd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;uv(23,0,87312,m);bF(q);cF(q,e,8);if(!(dF(q)|0)){c[l>>2]=e;yv(0,87352,l)}JP(r);l=q;eF(l,r)|0;LP(s,r);while(1){e=eF(l,r)|0;if(!(FQ(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}EQ(t,87432,r);kQ(s,t)|0;VP(t)}t=vd(qQ(s)|0)|0;fF(q);VP(s);VP(r);gF(q);fc=t}if((fc|0)==0){uv(23,0,87520,g);iF(o);i=f;return}JP(u);JP(v);c[k>>2]=fc;uv(23,0,87440,k);k=Xb(fc|0,87432)|0;if((k|0)!=0){g=k;do{k=e_(12)|0;PP(k,g);t=rQ(k,87472,0)|0;pQ(w,k,0,t);WP(u,w)|0;VP(w);pQ(x,k,t+1|0,(aQ(k)|0)+~t|0);WP(v,x)|0;VP(x);WP(AE(o,u)|0,v)|0;t=qQ(u)|0;k=qQ(v)|0;c[j>>2]=t;c[j+4>>2]=k;uv(23,0,87480,j);g=Xb(0,87432)|0;}while((g|0)!=0)}$Z(fc);fc=a+12|0;PP(y,85568);g=AE(fc,y)|0;PP(z,85568);if((hF(o,z)|0)==0){PP(B,85568);gc=1;hc=0;ic=AE(fc,B)|0}else{PP(A,85568);gc=0;hc=1;ic=AE(o,A)|0}WP(g,ic)|0;if(gc){VP(B)}if(hc){VP(A)}VP(z);VP(y);PP(C,85440);y=AE(fc,C)|0;PP(D,85440);if((hF(o,D)|0)==0){PP(F,85440);jc=1;kc=0;lc=AE(fc,F)|0}else{PP(E,85440);jc=0;kc=1;lc=AE(o,E)|0}WP(y,lc)|0;if(jc){VP(F)}if(kc){VP(E)}VP(D);VP(C);PP(G,85472);C=AE(fc,G)|0;PP(H,85472);if((hF(o,H)|0)==0){PP(J,85472);mc=1;nc=0;oc=AE(fc,J)|0}else{PP(I,85472);mc=0;nc=1;oc=AE(o,I)|0}WP(C,oc)|0;if(mc){VP(J)}if(nc){VP(I)}VP(H);VP(G);PP(K,85504);G=AE(fc,K)|0;PP(L,85504);if((hF(o,L)|0)==0){PP(N,85504);pc=0;qc=1;rc=AE(fc,N)|0}else{PP(M,85504);pc=1;qc=0;rc=AE(o,M)|0}WP(G,rc)|0;if(qc){VP(N)}if(pc){VP(M)}VP(L);VP(K);PP(O,85536);K=AE(fc,O)|0;PP(P,85536);if((hF(o,P)|0)==0){PP(R,85536);sc=1;tc=0;uc=AE(fc,R)|0}else{PP(Q,85536);sc=0;tc=1;uc=AE(o,Q)|0}WP(K,uc)|0;if(sc){VP(R)}if(tc){VP(Q)}VP(P);VP(O);PP(S,85600);O=AE(fc,S)|0;PP(T,85600);if((hF(o,T)|0)==0){PP(V,85600);vc=1;wc=0;xc=AE(fc,V)|0}else{PP(U,85600);vc=0;wc=1;xc=AE(o,U)|0}WP(O,xc)|0;if(vc){VP(V)}if(wc){VP(U)}VP(T);VP(S);PP(W,85640);S=AE(fc,W)|0;PP(X,85640);if((hF(o,X)|0)==0){PP(Z,85640);yc=1;zc=0;Ac=AE(fc,Z)|0}else{PP(Y,85640);yc=0;zc=1;Ac=AE(o,Y)|0}WP(S,Ac)|0;if(yc){VP(Z)}if(zc){VP(Y)}VP(X);VP(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=TE(Y,_)|0;PP($,84544);Ac=AE(yc,$)|0;c[aa>>2]=Z;yc=TE(Y,aa)|0;PP(ba,84400);if((hF(o,AE(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=TE(Y,ea)|0;PP(fa,84544);Bc=1;Cc=0;Dc=AE(yc,fa)|0}else{c[ca>>2]=Z;yc=TE(Y,ca)|0;PP(da,84400);Bc=0;Cc=1;Dc=AE(o,AE(yc,da)|0)|0}WP(Ac,Dc)|0;if(Bc){VP(fa)}if(Cc){VP(da)}VP(ba);VP($);c[ga>>2]=Z;Ac=TE(zc,ga)|0;PP(ha,84544);yc=AE(Ac,ha)|0;c[ia>>2]=Z;Ac=TE(zc,ia)|0;PP(ja,84400);if((hF(o,AE(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=TE(zc,ma)|0;PP(na,84544);Ec=1;Fc=0;Gc=AE(Ac,na)|0}else{c[ka>>2]=Z;Ac=TE(zc,ka)|0;PP(la,84400);Ec=0;Fc=1;Gc=AE(o,AE(Ac,la)|0)|0}WP(yc,Gc)|0;if(Ec){VP(na)}if(Fc){VP(la)}VP(ja);VP(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=TE(Hc,oa)|0;PP(pa,84544);ja=AE(ha,pa)|0;c[qa>>2]=Z;ha=TE(Hc,qa)|0;PP(ra,84400);if((hF(o,AE(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=TE(Hc,ua)|0;PP(va,84544);Ic=1;Jc=0;Kc=AE(ha,va)|0}else{c[sa>>2]=Z;ha=TE(Hc,sa)|0;PP(ta,84400);Ic=0;Jc=1;Kc=AE(o,AE(ha,ta)|0)|0}WP(ja,Kc)|0;if(Ic){VP(va)}if(Jc){VP(ta)}VP(ra);VP(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=TE(X,wa)|0;PP(xa,84544);ra=AE(pa,xa)|0;c[ya>>2]=Z;pa=TE(X,ya)|0;PP(za,84400);if((hF(o,AE(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=TE(X,Ca)|0;PP(Da,84544);Lc=1;Mc=0;Nc=AE(pa,Da)|0}else{c[Aa>>2]=Z;pa=TE(X,Aa)|0;PP(Ba,84400);Lc=0;Mc=1;Nc=AE(o,AE(pa,Ba)|0)|0}WP(ra,Nc)|0;if(Lc){VP(Da)}if(Mc){VP(Ba)}VP(za);VP(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=TE(Z,Ea)|0;PP(Fa,84544);Ba=AE(za,Fa)|0;c[Ga>>2]=xa;za=TE(Z,Ga)|0;PP(Ha,84400);if((hF(o,AE(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=TE(Z,Ka)|0;PP(La,84544);Oc=1;Pc=0;Qc=AE(za,La)|0}else{c[Ia>>2]=xa;za=TE(Z,Ia)|0;PP(Ja,84400);Oc=0;Pc=1;Qc=AE(o,AE(za,Ja)|0)|0}WP(Ba,Qc)|0;if(Oc){VP(La)}if(Pc){VP(Ja)}VP(Ha);VP(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=TE(xa,Ma)|0;PP(Na,84544);Ja=AE(Ha,Na)|0;c[Oa>>2]=Fa;Ha=TE(xa,Oa)|0;PP(Pa,84400);if((hF(o,AE(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=TE(xa,Sa)|0;PP(Ta,84544);Rc=1;Sc=0;Tc=AE(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=TE(xa,Qa)|0;PP(Ra,84400);Rc=0;Sc=1;Tc=AE(o,AE(Ha,Ra)|0)|0}WP(Ja,Tc)|0;if(Rc){VP(Ta)}if(Sc){VP(Ra)}VP(Pa);VP(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=TE(Fa,Ua)|0;PP(Va,84544);Ra=AE(Pa,Va)|0;c[Wa>>2]=Na;Pa=TE(Fa,Wa)|0;PP(Xa,84400);if((hF(o,AE(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=TE(Fa,_a)|0;PP($a,84544);Uc=1;Vc=0;Wc=AE(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=TE(Fa,Ya)|0;PP(Za,84400);Uc=0;Vc=1;Wc=AE(o,AE(Pa,Za)|0)|0}WP(Ra,Wc)|0;if(Uc){VP($a)}if(Vc){VP(Za)}VP(Xa);VP(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=TE(Na,ab)|0;PP(bb,84544);Za=AE(Xa,bb)|0;c[cb>>2]=Va;Xa=TE(Na,cb)|0;PP(db,84400);if((hF(o,AE(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=TE(Na,gb)|0;PP(hb,84544);Xc=1;Yc=0;Zc=AE(Xa,hb)|0}else{c[eb>>2]=Va;Xa=TE(Na,eb)|0;PP(fb,84400);Xc=0;Yc=1;Zc=AE(o,AE(Xa,fb)|0)|0}WP(Za,Zc)|0;if(Xc){VP(hb)}if(Yc){VP(fb)}VP(db);VP(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=TE(Va,ib)|0;PP(jb,84544);fb=AE(db,jb)|0;c[kb>>2]=bb;db=TE(Va,kb)|0;PP(lb,84400);if((hF(o,AE(db,lb)|0)|0)==0){c[ob>>2]=bb;db=TE(Va,ob)|0;PP(pb,84544);_c=1;$c=0;ad=AE(db,pb)|0}else{c[mb>>2]=bb;db=TE(Va,mb)|0;PP(nb,84400);_c=0;$c=1;ad=AE(o,AE(db,nb)|0)|0}WP(fb,ad)|0;if(_c){VP(pb)}if($c){VP(nb)}VP(lb);VP(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=TE(bb,qb)|0;PP(rb,84544);nb=AE(lb,rb)|0;c[sb>>2]=jb;lb=TE(bb,sb)|0;PP(tb,84400);if((hF(o,AE(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=TE(bb,wb)|0;PP(xb,84544);bd=1;cd=0;dd=AE(lb,xb)|0}else{c[ub>>2]=jb;lb=TE(bb,ub)|0;PP(vb,84400);bd=0;cd=1;dd=AE(o,AE(lb,vb)|0)|0}WP(nb,dd)|0;if(bd){VP(xb)}if(cd){VP(vb)}VP(tb);VP(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=TE(jb,yb)|0;PP(zb,84544);vb=AE(tb,zb)|0;c[Ab>>2]=rb;tb=TE(jb,Ab)|0;PP(Bb,84400);if((hF(o,AE(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=TE(jb,Eb)|0;PP(Fb,84544);ed=1;fd=0;gd=AE(tb,Fb)|0}else{c[Cb>>2]=rb;tb=TE(jb,Cb)|0;PP(Db,84400);ed=0;fd=1;gd=AE(o,AE(tb,Db)|0)|0}WP(vb,gd)|0;if(ed){VP(Fb)}if(fd){VP(Db)}VP(Bb);VP(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=TE(rb,Gb)|0;PP(Hb,84544);Db=AE(Bb,Hb)|0;c[Ib>>2]=zb;Bb=TE(rb,Ib)|0;PP(Jb,84400);if((hF(o,AE(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=TE(rb,Mb)|0;PP(Nb,84544);hd=0;id=1;jd=AE(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=TE(rb,Kb)|0;PP(Lb,84400);hd=1;id=0;jd=AE(o,AE(Bb,Lb)|0)|0}WP(Db,jd)|0;if(id){VP(Nb)}if(hd){VP(Lb)}VP(Jb);VP(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=TE(zb,Ob)|0;PP(Pb,84544);Lb=AE(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=TE(zb,Qb)|0;PP(Rb,84400);if((hF(o,AE(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=TE(zb,Ub)|0;PP(Vb,84544);kd=1;ld=0;md=AE(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=TE(zb,Sb)|0;PP(Tb,84400);kd=0;ld=1;md=AE(o,AE(Jb,Tb)|0)|0}WP(Lb,md)|0;if(kd){VP(Vb)}if(ld){VP(Tb)}VP(Rb);VP(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=TE(b,Wb)|0;PP(Yb,84544);Pb=AE(Hb,Yb)|0;c[Zb>>2]=a;Hb=TE(b,Zb)|0;PP(_b,84400);if((hF(o,AE(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=TE(b,bc)|0;PP(cc,84544);nd=1;od=0;pd=AE(Hb,cc)|0}else{c[$b>>2]=a;Hb=TE(b,$b)|0;PP(ac,84400);nd=0;od=1;pd=AE(o,AE(Hb,ac)|0)|0}WP(Pb,pd)|0;if(nd){VP(cc)}if(od){VP(ac)}VP(_b);VP(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}uv(23,0,87504,h);VP(v);VP(u);iF(o);i=f;return}function TE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=AH(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}CH(j,a,b);DH(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];BH(g,e);EH(j);j=c[f>>2]|0;FH(a,j,k,GH(g)|0);k=HH(g)|0;EH(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function UE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=cG(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}eG(j,a,b);fG(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];dG(g,e);gG(j);j=c[f>>2]|0;hG(a,j,k,iG(g)|0);k=jG(g)|0;gG(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function VE(a,b){a=a|0;b=b|0;var c=0;c=i;WP(b,a)|0;i=c;return}function WE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;VF(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];NF(a,f);i=e;return}function XE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LF(a,b)|0;i=c;return d|0}function YE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;OF(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];NF(a,e);i=d;return}function ZE(a){a=a|0;var b=0,c=0;b=i;c=IF(a)|0;i=b;return c|0}function _E(a){a=a|0;var b=0;b=i;fK(a);i=b;return}function $E(a){a=a|0;var b=0;b=i;UJ(a);i=b;return}function aF(a,b){a=a|0;b=b|0;b=i;BI(a,0);i=b;return}function bF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;SQ(d);e=a;c[e>>2]=87572;f=d;c[f>>2]=87592;d=a+8|0;KR(a,87604|0,d);c[e>>2]=87572;c[f>>2]=87592;TD(d);i=b;return}function cF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(sB(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){JQ(d,4);i=e;return}else{HQ(d,0);i=e;return}}function dF(a){a=a|0;var b=0,c=0;b=i;c=DF(a+8|0)|0;i=b;return c|0}function eF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=CF(a,b,QQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function fF(a){a=a|0;var b=0;b=i;if((uB(a+8|0)|0)!=0){i=b;return}JQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function gF(a){a=a|0;var b=0;b=i;HF(a,87600);NQ(a+108|0);i=b;return}function hF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=jF(a,b)|0;i=c;return d|0}function iF(a){a=a|0;var b=0;b=i;JJ(a);i=b;return}function jF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=lF(a)|0;kB(e);if((f|0)==0){g=0;i=d;return g|0}h=mF(a)|0;a=f;while(1){f=a+16|0;if(nF(h,b,f)|0){j=a}else{if(!(oF(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;kB(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function kF(a){a=a|0;var b=0,c=0;b=i;c=XA(uF(a+4|0)|0)|0;i=b;return c|0}function lF(a){a=a|0;var b=0,d=0;b=i;d=c[(kF(a)|0)>>2]|0;i=b;return d|0}function mF(a){a=a|0;var b=0,c=0;b=i;c=sF(a+8|0)|0;i=b;return c|0}function nF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function oF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function pF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=qF(b,c)|0;i=a;return d|0}function qF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(sQ(a,b)|0)<0;i=c;return d|0}function rF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=x_(a,b,c)|0;i=d;return e|0}function sF(a){a=a|0;var b=0,c=0;b=i;c=tF(a)|0;i=b;return c|0}function tF(a){a=a|0;i=i;return a|0}function uF(a){a=a|0;var b=0,c=0;b=i;c=vF(a)|0;i=b;return c|0}function vF(a){a=a|0;i=i;return a|0}function wF(a,b){a=a|0;b=b|0;var c=0;a=i;c=yF(0,b,0)|0;i=a;return c|0}function xF(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function yF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=e_(b)|0;i=c;return a|0}function zF(a){a=a|0;var b=0,c=0;b=i;c=C_(a|0)|0;i=b;return c|0}function AF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=BF(b,c,e)|0;i=d;return g|0}function BF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=oC(0,a,b)|0;i=c;return(d?b:a)|0}function CF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;PR(f,a,1);if(!(SR(f)|0)){i=e;return a|0}jQ(b);f=0;while(1){g=YQ(OQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(eC(g,-1)|0){h=2;j=f;break}k=f+1|0;l=fC(g)|0;if(jC(l,d)|0){h=0;j=k;break}lQ(b,l);if((TP(b)|0)==-17){h=4;j=k;break}else{f=k}}JQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function DF(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function EF(a){a=a|0;var b=0;b=i;gF(a);g_(a);i=b;return}function FF(a){a=a|0;var b=0;b=i;gF(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function GF(a){a=a|0;var b=0;b=i;EF(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function HF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];UB(a+8|0);i=d;return}function IF(a){a=a|0;var b=0,d=0;b=i;d=JF((c[a>>2]|0)+16|0)|0;i=b;return d|0}function JF(a){a=a|0;var b=0,c=0;b=i;c=KF(a)|0;i=b;return c|0}function KF(a){a=a|0;i=i;return a|0}function LF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(MF(a,b)|0)^1;i=c;return d|0}function MF(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function NF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];UF(a,e);i=d;return}function OF(a,b){a=a|0;b=b|0;var c=0;c=i;PF(a,QF(b)|0);i=c;return}function PF(a,b){a=a|0;b=b|0;var c=0;c=i;TF(a,b);i=c;return}function QF(a){a=a|0;var b=0,c=0;b=i;c=XA(RF(a+4|0)|0)|0;i=b;return c|0}function RF(a){a=a|0;var b=0,c=0;b=i;c=SF(a)|0;i=b;return c|0}function SF(a){a=a|0;i=i;return a|0}function TF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function UF(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function VF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=XF(b)|0;WF(f,b,d,h,QF(b)|0);OF(g,b);do{if(LF(f,g)|0){h=YF(b)|0;if(ZF(h,d,_F(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);OF(a,b);i=e;return}function WF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;kB(h);a:do{if((e|0)==0){j=f}else{k=YF(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(bG(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;kB(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;kB(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);PF(a,j);i=g;return}function XF(a){a=a|0;var b=0,d=0;b=i;d=c[(QF(a)|0)>>2]|0;i=b;return d|0}function YF(a){a=a|0;var b=0,c=0;b=i;c=$F(a+8|0)|0;i=b;return c|0}function ZF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function _F(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function $F(a){a=a|0;var b=0,c=0;b=i;c=aG(a)|0;i=b;return c|0}function aG(a){a=a|0;i=i;return a|0}function bG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function cG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=XF(h)|0;kB(e);if((a|0)==0){j=QF(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(pF(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(pF(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function dG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];_G(a,e);i=d;return}function eG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=FG(d)|0;d=HG(n,1)|0;IG(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];GG(j,d,h);JG(0,yG((KG(j)|0)+16|0)|0,e);e=LG(j)|0;a[e+4|0]=1;MG(0,wG((KG(j)|0)+28|0)|0);a[e+5|0]=1;NG(m,j);fG(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];dG(b,g);gG(m);gG(j);i=f;return}function fG(a,b){a=a|0;b=b|0;var c=0;c=i;DG(a,b);i=c;return}function gG(a){a=a|0;var b=0;b=i;sG(a);i=b;return}function hG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=oG(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(QF(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=pG(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function iG(a){a=a|0;var b=0,d=0;b=i;d=c[(mG(a)|0)>>2]|0;i=b;return d|0}function jG(a){a=a|0;var b=0,d=0;b=i;d=kG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function kG(a){a=a|0;var b=0,c=0;b=i;c=lG(a)|0;i=b;return c|0}function lG(a){a=a|0;i=i;return a|0}function mG(a){a=a|0;var b=0,c=0;b=i;c=nG(a)|0;i=b;return c|0}function nG(a){a=a|0;i=i;return a|0}function oG(a){a=a|0;i=i;return a|0}function pG(a){a=a|0;var b=0,c=0;b=i;c=qG(a+8|0)|0;i=b;return c|0}function qG(a){a=a|0;var b=0,c=0;b=i;c=rG(a)|0;i=b;return c|0}function rG(a){a=a|0;i=i;return a|0}function sG(a){a=a|0;var b=0;b=i;tG(a,0);i=b;return}function tG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=kG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}vG(uG(e)|0,f);i=d;return}function uG(a){a=a|0;var b=0,c=0;b=i;c=CG(a)|0;i=b;return c|0}function vG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;xG(f,yG(d+16|0)|0)}if((d|0)==0){i=e;return}zG(c[b>>2]|0,d,1);i=e;return}function wG(a){a=a|0;i=i;return a|0}function xG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;BG(d,0,c);i=b;return}function yG(a){a=a|0;i=i;return a|0}function zG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;AG(0,b,0);i=c;return}function AG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;g_(b);i=c;return}function BG(a,b,c){a=a|0;b=b|0;c=c|0;b=i;VP(c);i=b;return}function CG(a){a=a|0;i=i;return a+4|0}function DG(a,b){a=a|0;b=b|0;var c=0;c=i;EG(a,b);i=c;return}function EG(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function FG(a){a=a|0;var b=0,c=0;b=i;c=YG(a+4|0)|0;i=b;return c|0}function GG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];QG(a,b,f);i=e;return}function HG(a,b){a=a|0;b=b|0;var c=0;a=i;c=PG(0,b,0)|0;i=a;return c|0}function IG(a,b){a=a|0;b=b|0;var c=0;c=i;OG(a,b);i=c;return}function JG(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}LP(b,c);i=a;return}function KG(a){a=a|0;var b=0,d=0;b=i;d=c[(mG(a)|0)>>2]|0;i=b;return d|0}function LG(a){a=a|0;var b=0,c=0;b=i;c=uG(a)|0;i=b;return c|0}function MG(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function NG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;DG(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];dG(h,f);fG(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];dG(a,e);gG(h);i=d;return}function OG(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function PG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=e_(b<<5)|0;i=c;return a|0}function QG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(SG(g)|0)>>2]|0;g=TG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];RG(b,a,f);i=e;return}function RG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];UG(a,b,f);i=e;return}function SG(a){a=a|0;i=i;return a|0}function TG(a){a=a|0;i=i;return a|0}function UG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(WG(g)|0)>>2]|0;g=XG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];VG(b,a,f);i=e;return}function VG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(WG(f)|0)>>2];f=XG(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function WG(a){a=a|0;i=i;return a|0}function XG(a){a=a|0;i=i;return a|0}function YG(a){a=a|0;var b=0,c=0;b=i;c=ZG(a)|0;i=b;return c|0}function ZG(a){a=a|0;i=i;return a|0}function _G(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=jG($G(b)|0)|0;h=XG(LG($G(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];RG(g,a,e);i=d;return}function $G(a){a=a|0;i=i;return c[a>>2]|0}function aH(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function bH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];iH(a,e);i=d;return}function cH(a,b){a=a|0;b=b|0;var c=0;c=i;dH(a,eH(b)|0);i=c;return}function dH(a,b){a=a|0;b=b|0;var c=0;c=i;hH(a,b);i=c;return}function eH(a){a=a|0;var b=0,c=0;b=i;c=XA(fH(a+4|0)|0)|0;i=b;return c|0}function fH(a){a=a|0;var b=0,c=0;b=i;c=gH(a)|0;i=b;return c|0}function gH(a){a=a|0;i=i;return a|0}function hH(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function iH(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function jH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=lH(b)|0;kH(f,b,d,h,eH(b)|0);cH(g,b);do{if(mH(f,g)|0){h=nH(b)|0;if(nF(h,d,oH(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);cH(a,b);i=e;return}function kH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;kB(h);a:do{if((e|0)==0){j=f}else{k=nH(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(oF(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;kB(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;kB(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);dH(a,j);i=g;return}function lH(a){a=a|0;var b=0,d=0;b=i;d=c[(eH(a)|0)>>2]|0;i=b;return d|0}function mH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(aH(a,b)|0)^1;i=c;return d|0}function nH(a){a=a|0;var b=0,c=0;b=i;c=pH(a+8|0)|0;i=b;return c|0}function oH(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function pH(a){a=a|0;var b=0,c=0;b=i;c=qH(a)|0;i=b;return c|0}function qH(a){a=a|0;i=i;return a|0}function rH(a,b){a=a|0;b=b|0;b=i;i=i+8|0;sH(a,b);i=b;return}function sH(a,b){a=a|0;b=b|0;b=i;tH(a,0);i=b;return}function tH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;uH(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;vH(f,0,e);e=QF(b)|0;c[(oG(b)|0)>>2]=e;i=d;return}function uH(a){a=a|0;var b=0;b=i;yH(a);i=b;return}function vH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;wH(b,c,f);i=e;return}function wH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;xH(d,b,f);i=e;return}function xH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function yH(a){a=a|0;var b=0;b=i;zH(a);i=b;return}function zH(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function AH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=AI(h)|0;kB(e);if((a|0)==0){j=NH(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(hB(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(hB(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function BH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];yI(a,e);i=d;return}function CH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=dI(d)|0;d=fI(n,1)|0;gI(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];eI(j,d,h);hI(0,gD((iI(j)|0)+16|0)|0,e);e=jI(j)|0;a[e+4|0]=1;kI(0,YH((iI(j)|0)+20|0)|0);a[e+5|0]=1;lI(m,j);DH(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];BH(b,g);EH(m);EH(j);i=f;return}function DH(a,b){a=a|0;b=b|0;var c=0;c=i;bI(a,b);i=c;return}function EH(a){a=a|0;var b=0;b=i;TH(a);i=b;return}function FH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=MH(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(NH(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=OH(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function GH(a){a=a|0;var b=0,d=0;b=i;d=c[(KH(a)|0)>>2]|0;i=b;return d|0}function HH(a){a=a|0;var b=0,d=0;b=i;d=IH(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function IH(a){a=a|0;var b=0,c=0;b=i;c=JH(a)|0;i=b;return c|0}function JH(a){a=a|0;i=i;return a|0}function KH(a){a=a|0;var b=0,c=0;b=i;c=LH(a)|0;i=b;return c|0}function LH(a){a=a|0;i=i;return a|0}function MH(a){a=a|0;i=i;return a|0}function NH(a){a=a|0;var b=0,c=0;b=i;c=XA(RH(a+4|0)|0)|0;i=b;return c|0}function OH(a){a=a|0;var b=0,c=0;b=i;c=PH(a+8|0)|0;i=b;return c|0}function PH(a){a=a|0;var b=0,c=0;b=i;c=QH(a)|0;i=b;return c|0}function QH(a){a=a|0;i=i;return a|0}function RH(a){a=a|0;var b=0,c=0;b=i;c=SH(a)|0;i=b;return c|0}function SH(a){a=a|0;i=i;return a|0}function TH(a){a=a|0;var b=0;b=i;UH(a,0);i=b;return}function UH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=IH(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}WH(VH(e)|0,f);i=d;return}function VH(a){a=a|0;var b=0,c=0;b=i;c=aI(a)|0;i=b;return c|0}function WH(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;XH(f,YH(d+20|0)|0)}if((d|0)==0){i=e;return}ZH(c[b>>2]|0,d,1);i=e;return}function XH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;$H(d,0,c);i=b;return}function YH(a){a=a|0;i=i;return a|0}function ZH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;_H(0,b,0);i=c;return}function _H(a,b,c){a=a|0;b=b|0;c=c|0;c=i;g_(b);i=c;return}function $H(a,b,c){a=a|0;b=b|0;c=c|0;b=i;iF(c);i=b;return}function aI(a){a=a|0;i=i;return a+4|0}function bI(a,b){a=a|0;b=b|0;var c=0;c=i;cI(a,b);i=c;return}function cI(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function dI(a){a=a|0;var b=0,c=0;b=i;c=wI(a+4|0)|0;i=b;return c|0}function eI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];oI(a,b,f);i=e;return}function fI(a,b){a=a|0;b=b|0;var c=0;a=i;c=nI(0,b,0)|0;i=a;return c|0}function gI(a,b){a=a|0;b=b|0;var c=0;c=i;mI(a,b);i=c;return}function hI(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function iI(a){a=a|0;var b=0,d=0;b=i;d=c[(KH(a)|0)>>2]|0;i=b;return d|0}function jI(a){a=a|0;var b=0,c=0;b=i;c=VH(a)|0;i=b;return c|0}function kI(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}aF(b,a);i=a;return}function lI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;bI(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];BH(h,f);DH(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];BH(a,e);EH(h);i=d;return}function mI(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function nI(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=e_(b<<5)|0;i=c;return a|0}function oI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(qI(g)|0)>>2]|0;g=rI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];pI(b,a,f);i=e;return}function pI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];sI(a,b,f);i=e;return}function qI(a){a=a|0;i=i;return a|0}function rI(a){a=a|0;i=i;return a|0}function sI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(uI(g)|0)>>2]|0;g=vI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];tI(b,a,f);i=e;return}function tI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(uI(f)|0)>>2];f=vI(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function uI(a){a=a|0;i=i;return a|0}function vI(a){a=a|0;i=i;return a|0}function wI(a){a=a|0;var b=0,c=0;b=i;c=xI(a)|0;i=b;return c|0}function xI(a){a=a|0;i=i;return a|0}function yI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=HH(zI(b)|0)|0;h=vI(jI(zI(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];pI(g,a,e);i=d;return}function zI(a){a=a|0;i=i;return c[a>>2]|0}function AI(a){a=a|0;var b=0,d=0;b=i;d=c[(NH(a)|0)>>2]|0;i=b;return d|0}function BI(a,b){a=a|0;b=b|0;b=i;i=i+8|0;CI(a,b);i=b;return}function CI(a,b){a=a|0;b=b|0;b=i;DI(a,0);i=b;return}function DI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;EI(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;FI(f,0,e);e=eH(b)|0;c[(GI(b)|0)>>2]=e;i=d;return}function EI(a){a=a|0;var b=0;b=i;JI(a);i=b;return}function FI(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;HI(b,c,f);i=e;return}function GI(a){a=a|0;i=i;return a|0}function HI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;II(d,b,f);i=e;return}function II(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function JI(a){a=a|0;var b=0;b=i;KI(a);i=b;return}function KI(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function LI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=lH(h)|0;kB(e);if((a|0)==0){j=eH(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(pF(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(pF(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function MI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];HJ(a,e);i=d;return}function NI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=mJ(d)|0;d=oJ(n,1)|0;pJ(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];nJ(j,d,h);qJ(0,yG((rJ(j)|0)+16|0)|0,e);e=sJ(j)|0;a[e+4|0]=1;tJ(0,dJ((rJ(j)|0)+28|0)|0);a[e+5|0]=1;uJ(m,j);OI(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];MI(b,g);PI(m);PI(j);i=f;return}function OI(a,b){a=a|0;b=b|0;var c=0;c=i;kJ(a,b);i=c;return}function PI(a){a=a|0;var b=0;b=i;_I(a);i=b;return}function QI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=GI(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(eH(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=XI(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function RI(a){a=a|0;var b=0,d=0;b=i;d=c[(VI(a)|0)>>2]|0;i=b;return d|0}function SI(a){a=a|0;var b=0,d=0;b=i;d=TI(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function TI(a){a=a|0;var b=0,c=0;b=i;c=UI(a)|0;i=b;return c|0}function UI(a){a=a|0;i=i;return a|0}function VI(a){a=a|0;var b=0,c=0;b=i;c=WI(a)|0;i=b;return c|0}function WI(a){a=a|0;i=i;return a|0}function XI(a){a=a|0;var b=0,c=0;b=i;c=YI(a+8|0)|0;i=b;return c|0}function YI(a){a=a|0;var b=0,c=0;b=i;c=ZI(a)|0;i=b;return c|0}function ZI(a){a=a|0;i=i;return a|0}function _I(a){a=a|0;var b=0;b=i;$I(a,0);i=b;return}function $I(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=TI(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}bJ(aJ(e)|0,f);i=d;return}function aJ(a){a=a|0;var b=0,c=0;b=i;c=jJ(a)|0;i=b;return c|0}function bJ(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;cJ(f,dJ(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;eJ(f,yG(d+16|0)|0)}if((d|0)==0){i=e;return}fJ(c[b>>2]|0,d,1);i=e;return}function cJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;iJ(d,0,c);i=b;return}function dJ(a){a=a|0;i=i;return a|0}function eJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;hJ(d,0,c);i=b;return}function fJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;gJ(0,b,0);i=c;return}function gJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;g_(b);i=c;return}function hJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;VP(c);i=b;return}function iJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;VP(c);i=b;return}function jJ(a){a=a|0;i=i;return a+4|0}function kJ(a,b){a=a|0;b=b|0;var c=0;c=i;lJ(a,b);i=c;return}function lJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function mJ(a){a=a|0;var b=0,c=0;b=i;c=FJ(a+4|0)|0;i=b;return c|0}function nJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];xJ(a,b,f);i=e;return}function oJ(a,b){a=a|0;b=b|0;var c=0;a=i;c=wJ(0,b,0)|0;i=a;return c|0}function pJ(a,b){a=a|0;b=b|0;var c=0;c=i;vJ(a,b);i=c;return}function qJ(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}LP(b,c);i=a;return}function rJ(a){a=a|0;var b=0,d=0;b=i;d=c[(VI(a)|0)>>2]|0;i=b;return d|0}function sJ(a){a=a|0;var b=0,c=0;b=i;c=aJ(a)|0;i=b;return c|0}function tJ(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}JP(b);i=a;return}function uJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;kJ(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];MI(h,f);OI(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];MI(a,e);PI(h);i=d;return}function vJ(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function wJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=e_(b*40|0)|0;i=c;return a|0}function xJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(zJ(g)|0)>>2]|0;g=AJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];yJ(b,a,f);i=e;return}function yJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];BJ(a,b,f);i=e;return}function zJ(a){a=a|0;i=i;return a|0}function AJ(a){a=a|0;i=i;return a|0}function BJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DJ(g)|0)>>2]|0;g=EJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];CJ(b,a,f);i=e;return}function CJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(DJ(f)|0)>>2];f=EJ(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function DJ(a){a=a|0;i=i;return a|0}function EJ(a){a=a|0;i=i;return a|0}function FJ(a){a=a|0;var b=0,c=0;b=i;c=GJ(a)|0;i=b;return c|0}function GJ(a){a=a|0;i=i;return a|0}function HJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=SI(IJ(b)|0)|0;h=EJ(sJ(IJ(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];yJ(g,a,e);i=d;return}function IJ(a){a=a|0;i=i;return c[a>>2]|0}function JJ(a){a=a|0;var b=0;b=i;KJ(a);i=b;return}function KJ(a){a=a|0;var b=0;b=i;LJ(a);i=b;return}function LJ(a){a=a|0;var b=0;b=i;MJ(a,lH(a)|0);i=b;return}function MJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}MJ(a,c[b>>2]|0);MJ(a,c[b+4>>2]|0);e=mJ(a)|0;NJ(e,OJ(b+16|0)|0);fJ(e,b,1);i=d;return}function NJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;PJ(d,0,c);i=b;return}function OJ(a){a=a|0;i=i;return a|0}function PJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QJ(c);i=b;return}function QJ(a){a=a|0;var b=0;b=i;RJ(a);i=b;return}function RJ(a){a=a|0;var b=0;b=i;SJ(a);i=b;return}function SJ(a){a=a|0;var b=0;b=i;TJ(a);i=b;return}function TJ(a){a=a|0;var b=0;b=i;VP(a+12|0);VP(a);i=b;return}function UJ(a){a=a|0;var b=0;b=i;VJ(a+180|0);VJ(a+168|0);VJ(a+156|0);VJ(a+144|0);VJ(a+132|0);VJ(a+120|0);VJ(a+108|0);VJ(a+96|0);VJ(a+84|0);VJ(a+72|0);VJ(a+60|0);VJ(a+48|0);VJ(a+36|0);VJ(a+24|0);iF(a+12|0);iF(a);i=b;return}function VJ(a){a=a|0;var b=0;b=i;WJ(a);i=b;return}function WJ(a){a=a|0;var b=0;b=i;XJ(a);i=b;return}function XJ(a){a=a|0;var b=0;b=i;YJ(a);i=b;return}function YJ(a){a=a|0;var b=0;b=i;ZJ(a,AI(a)|0);i=b;return}function ZJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}ZJ(a,c[b>>2]|0);ZJ(a,c[b+4>>2]|0);e=dI(a)|0;_J(e,$J(b+16|0)|0);ZH(e,b,1);i=d;return}function _J(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;aK(d,0,c);i=b;return}function $J(a){a=a|0;i=i;return a|0}function aK(a,b,c){a=a|0;b=b|0;c=c|0;b=i;bK(c);i=b;return}function bK(a){a=a|0;var b=0;b=i;cK(a);i=b;return}function cK(a){a=a|0;var b=0;b=i;dK(a);i=b;return}function dK(a){a=a|0;var b=0;b=i;eK(a);i=b;return}function eK(a){a=a|0;var b=0;b=i;iF(a+4|0);i=b;return}function fK(a){a=a|0;var b=0;b=i;gK(a);i=b;return}function gK(a){a=a|0;var b=0;b=i;hK(a);i=b;return}function hK(a){a=a|0;var b=0;b=i;iK(a,XF(a)|0);i=b;return}function iK(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}iK(a,c[b>>2]|0);iK(a,c[b+4>>2]|0);e=FG(a)|0;jK(e,KF(b+16|0)|0);zG(e,b,1);i=d;return}function jK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;kK(d,0,c);i=b;return}function kK(a,b,c){a=a|0;b=b|0;c=c|0;b=i;lK(c);i=b;return}function lK(a){a=a|0;var b=0;b=i;mK(a);i=b;return}function mK(a){a=a|0;var b=0;b=i;nK(a);i=b;return}function nK(a){a=a|0;var b=0;b=i;oK(a);i=b;return}function oK(a){a=a|0;var b=0;b=i;VP(a);i=b;return}function pK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;qK(a);sK(g,b);tK(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];rK(a,f,e);i=d;return a|0}function qK(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;MJ(a,lH(a)|0);c[(XI(a)|0)>>2]=0;d=eH(a)|0;c[(GI(a)|0)>>2]=d;kB(b);c[d>>2]=0;i=b;return}function rK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;BK(h,a);if(!(CK(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];uK(j,g);o=EK(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];DK(l,a,f,o);FK(b)|0;}while(CK(b,d)|0);i=e;return}function sK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;zK(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];uK(a,e);i=d;return}function tK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;vK(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];uK(a,e);i=d;return}function uK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];yK(a,e);i=d;return}function vK(a,b){a=a|0;b=b|0;var c=0;c=i;wK(a,kF(b)|0);i=c;return}function wK(a,b){a=a|0;b=b|0;var c=0;c=i;xK(a,b);i=c;return}function xK(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function yK(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function zK(a,b){a=a|0;b=b|0;var d=0;d=i;wK(a,c[(AK(b)|0)>>2]|0);i=d;return}function AK(a){a=a|0;i=i;return a|0}function BK(a,b){a=a|0;b=b|0;var c=0;c=i;tK(a,b);i=c;return}function CK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=LL(a,b)|0;i=c;return d|0}function DK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];NK(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];MK(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];bH(a,g);QJ(l);i=f;return}function EK(a){a=a|0;var b=0,c=0;b=i;c=JK(a)|0;i=b;return c|0}function FK(a){a=a|0;var b=0;b=i;GK(a)|0;i=b;return a|0}function GK(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=HK(c[d>>2]|0)|0;i=b;return a|0}function HK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;kB(b);if((e|0)==0){e=a;while(1){a=_C(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=IK(c[d>>2]|0)|0;i=b;return g|0}return 0}function IK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;kB(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;kB(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function JK(a){a=a|0;var b=0,d=0;b=i;d=KK((c[a>>2]|0)+16|0)|0;i=b;return d|0}function KK(a){a=a|0;var b=0,c=0;b=i;c=LK(a)|0;i=b;return c|0}function LK(a){a=a|0;i=i;return a|0}function MK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=RK(b,h,j,e)|0;h=c[p>>2]|0;kB(l);if((h|0)!=0){q=h;dH(a,q);i=f;return}TK(o,b,e);UK(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];SK(m,g);VK(o);o=c[j>>2]|0;QI(b,o,p,WK(m)|0);p=XK(m)|0;VK(m);q=p;dH(a,q);i=f;return}function NK(a,b){a=a|0;b=b|0;var c=0;c=i;OK(a,b);i=c;return}function OK(a,b){a=a|0;b=b|0;var c=0;c=i;PK(a,b);i=c;return}function PK(a,b){a=a|0;b=b|0;var c=0;c=i;QK(a,b);i=c;return}function QK(a,b){a=a|0;b=b|0;var c=0;c=i;LP(a,b);LP(a+12|0,b+12|0);i=c;return}function RK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;cH(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];zL(l,k);do{if(!(yL(b,l)|0)){k=nH(a)|0;x=BL(b)|0;if(AL(k,e,x)|0){break}w=AL(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];FL(r,h,1,0);cH(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];zL(t,g);do{if(!(yL(r,t)|0)){if(AL(k,e,BL(r)|0)|0){break}y=EL(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;kB(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;CL(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];zL(o,j);do{if(!(yL(n,o)|0)){j=nH(a)|0;if(AL(j,BL(DL(n)|0)|0,e)|0){break}y=EL(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;kB(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function SK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];wL(a,e);i=d;return}function TK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=mJ(d)|0;d=oJ(n,1)|0;iL(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];hL(j,d,h);jL(0,OJ((kL(j)|0)+16|0)|0,e);a[(lL(j)|0)+4|0]=1;mL(m,j);UK(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];SK(b,g);VK(m);VK(j);i=f;return}function UK(a,b){a=a|0;b=b|0;var c=0;c=i;fL(a,b);i=c;return}function VK(a){a=a|0;var b=0;b=i;aL(a);i=b;return}function WK(a){a=a|0;var b=0,d=0;b=i;d=c[(_K(a)|0)>>2]|0;i=b;return d|0}function XK(a){a=a|0;var b=0,d=0;b=i;d=YK(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function YK(a){a=a|0;var b=0,c=0;b=i;c=ZK(a)|0;i=b;return c|0}function ZK(a){a=a|0;i=i;return a|0}function _K(a){a=a|0;var b=0,c=0;b=i;c=$K(a)|0;i=b;return c|0}function $K(a){a=a|0;i=i;return a|0}function aL(a){a=a|0;var b=0;b=i;bL(a,0);i=b;return}function bL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=YK(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}dL(cL(e)|0,f);i=d;return}function cL(a){a=a|0;var b=0,c=0;b=i;c=eL(a)|0;i=b;return c|0}function dL(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;NJ(f,OJ(d+16|0)|0)}if((d|0)==0){i=e;return}fJ(c[b>>2]|0,d,1);i=e;return}function eL(a){a=a|0;i=i;return a+4|0}function fL(a,b){a=a|0;b=b|0;var c=0;c=i;gL(a,b);i=c;return}function gL(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function hL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];qL(a,b,f);i=e;return}function iL(a,b){a=a|0;b=b|0;var c=0;c=i;pL(a,b);i=c;return}function jL(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}nL(b,c);i=a;return}function kL(a){a=a|0;var b=0,d=0;b=i;d=c[(_K(a)|0)>>2]|0;i=b;return d|0}function lL(a){a=a|0;var b=0,c=0;b=i;c=cL(a)|0;i=b;return c|0}function mL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;fL(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];SK(h,f);UK(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];SK(a,e);VK(h);i=d;return}function nL(a,b){a=a|0;b=b|0;var c=0;c=i;oL(a,b);i=c;return}function oL(a,b){a=a|0;b=b|0;var c=0;c=i;PK(a,b);i=c;return}function pL(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function qL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(zJ(g)|0)>>2]|0;g=sL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];rL(b,a,f);i=e;return}function rL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];tL(a,b,f);i=e;return}function sL(a){a=a|0;i=i;return a|0}function tL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DJ(g)|0)>>2]|0;g=vL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];uL(b,a,f);i=e;return}function uL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(DJ(f)|0)>>2];f=vL(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function vL(a){a=a|0;i=i;return a|0}function wL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=XK(xL(b)|0)|0;h=vL(lL(xL(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];rL(g,a,e);i=d;return}function xL(a){a=a|0;i=i;return c[a>>2]|0}function yL(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function zL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];KL(a,e);i=d;return}function AL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=pF(0,b,c)|0;i=a;return d|0}function BL(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function CL(a,b){a=a|0;b=b|0;var d=0;d=i;dH(a,c[(GI(b)|0)>>2]|0);i=d;return}function DL(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=IL(c[d>>2]|0)|0;i=b;return a|0}function EL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=lH(a)|0;kB(e);if((h|0)==0){j=eH(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=nH(a)|0;a=h;while(1){h=a+16|0;if(AL(j,d,h)|0){l=a;m=c[l>>2]|0;kB(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(AL(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;kB(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function FL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;GL(b,d);c[a>>2]=c[b>>2];i=e;return}function GL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;HL(b,c,e);i=d;return}function HL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{DL(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{GK(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function IL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;kB(b);if((e|0)==0){e=a;while(1){a=_C(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=JL(c[d>>2]|0)|0;i=b;return g|0}return 0}function JL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;kB(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;kB(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function KL(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function LL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(yL(a,b)|0)^1;i=c;return d|0}function ML(a){a=a|0;var b=0;b=i;i=i+128|0;aF(a,b);aF(a+12|0,b+8|0);NL(a+24|0,b+16|0);NL(a+36|0,b+24|0);NL(a+48|0,b+32|0);NL(a+60|0,b+40|0);NL(a+72|0,b+48|0);NL(a+84|0,b+56|0);NL(a+96|0,b+64|0);NL(a+108|0,b+72|0);NL(a+120|0,b+80|0);NL(a+132|0,b+88|0);NL(a+144|0,b+96|0);NL(a+156|0,b+104|0);NL(a+168|0,b+112|0);NL(a+180|0,b+120|0);i=b;return}function NL(a,b){a=a|0;b=b|0;b=i;OL(a,0);i=b;return}function OL(a,b){a=a|0;b=b|0;b=i;i=i+8|0;PL(a,b);i=b;return}function PL(a,b){a=a|0;b=b|0;b=i;QL(a,0);i=b;return}function QL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;RL(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;SL(f,0,e);e=NH(b)|0;c[(MH(b)|0)>>2]=e;i=d;return}function RL(a){a=a|0;var b=0;b=i;VL(a);i=b;return}function SL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;TL(b,c,f);i=e;return}function TL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;UL(d,b,f);i=e;return}function UL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function VL(a){a=a|0;var b=0;b=i;WL(a);i=b;return}function WL(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function XL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[98036>>2]|0;if((m|0)==0){n=0}else{o=e_(12)|0;PP(o,m);n=o}if((c[97952>>2]|0)!=0){c[10260]=1}if((n|0)==0){c[41052>>2]=1;c[41056>>2]=1;i=b;return}do{if((rQ(n,88176,0)|0)==-1){LP(g,n);JP(h);o=c[9834]|0;m=(o|0)<28;while(1){p=rQ(g,88184,0)|0;q=(p|0)!=-1;if(q){pQ(j,g,0,p);WP(h,j)|0;VP(j);pQ(k,g,p+1|0,-1);WP(g,k)|0;VP(k)}else{WP(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){PP(l,c[39752+(s<<2)>>2]|0);p=YL(h,l)|0;VP(l);if(p){c[41048+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){wv(1,1,88192,f);if(m){v=o}else{w=41600;x=c[10400]|0;ae[x&255](1);y=qQ(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=88232;E=D;yv(0,E,a)}do{p=c[40920+(v<<2)>>2]|0;c[e>>2]=c[39752+(v<<2)>>2];c[e+4>>2]=p;wv(1,0,88216,e);v=v+1|0;}while((v|0)<28);w=41600;x=c[10400]|0;ae[x&255](1);y=qQ(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=88232;E=D;yv(0,E,a)}else if((t|0)==20){wv(1,1,88192,d);w=41600;x=c[10400]|0;ae[x&255](1);y=qQ(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=88232;E=D;yv(0,E,a)}else if((t|0)==23){VP(h);VP(g);break}}else{o=1;do{c[41048+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[41052>>2]=1;c[41056>>2]=1;if((c[41084>>2]|0)!=0){c[41144>>2]=1}if((c[41140>>2]|0)==1){c[41148>>2]=1}if((c[41120>>2]|0)!=0){c[41116>>2]=1}if((c[41128>>2]|0)!=0){c[41116>>2]=1}if((c[41080>>2]|0)!=0){c[41076>>2]=1}if((c[41124>>2]|0)!=0){c[41116>>2]=1}if((c[41072>>2]|0)!=0){c[41068>>2]=1}VP(n);g_(n);i=b;return}function YL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=TP(b)|0;if((e|0)!=(TP(c)|0)){f=0;i=d;return f|0}g=UP(b)|0;h=UP(c)|0;if(MP(b)|0){f=(rF(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function ZL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[98044>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=e_(12)|0;l=k;PP(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(_L(l,c[73272+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=qQ(l)|0;wv(1,1,88264,g);g=c[73356>>2]|0;c[f>>2]=c[73276>>2];c[f+4>>2]=g;wv(1,0,88216,f);f=c[73360>>2]|0;c[e>>2]=c[73280>>2];c[e+4>>2]=f;wv(1,0,88216,e);e=c[73364>>2]|0;c[d>>2]=c[73284>>2];c[d+4>>2]=e;wv(1,0,88216,d);ae[c[10400]&255](1);yv(0,88320,a)}else if((n|0)==6){i=b;return j|0}return 0}function _L(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(tQ(a,b)|0)==0;i=c;return d|0}function $L(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[98028>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=e_(12)|0;l=k;PP(l,h);if((k|0)==0){j=1;i=b;return j|0}PP(f,88344);k=YL(l,f)|0;VP(f);if(k){j=1;i=b;return j|0}PP(g,88352);k=YL(l,g)|0;VP(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=qQ(l)|0;wv(1,1,88360,e);c[d>>2]=88344;c[d+4>>2]=88416;wv(1,0,88216,d);c[a>>2]=88352;c[a+4>>2]=88432;wv(1,0,88216,a);ae[c[10400]&255](1);yv(0,88320,b)}return 0}function aM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;cS(f,a);if(!(fS(f)|0)){dS(f);i=d;return a|0}j=zF(b)|0;oM(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((oB(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=PQ(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];rM(h,e,b,m,k,l,n);if(!(pM(h)|0)){dS(f);i=d;return a|0}JQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);dS(f);i=d;return a|0}function bM(a){a=a|0;var b=0;b=i;iS(a,QQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;RR(a)|0;i=b;return a|0}function cM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;PP(h,d);EQ(k,88440,h);ME(j,k,88448);VP(k);k=qQ(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((y_(c[n+4>>2]|0,88456)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((y_(k,88464)|0)==0){VP(j);VP(h);i=f;return}d=gZ(g,k,1)|0;if((d|0)!=0){m=l;G_(m|0,0,2048)|0;tZ(d,g,m,2048)|0;gS(aM(aM(aM(aM(aM(110432,88472)|0,k)|0,88512)|0,m)|0,88528)|0,103)|0;VP(j);VP(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(uZ(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(uZ(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(uZ(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(uZ(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(uZ(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(uZ(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(uZ(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==0){n=(uZ(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==1){d=(uZ(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){l=b+12|0;o=p;p=0;while(1){t=c[l>>2]|0;if((a[t+(p*52|0)+48|0]|0)==0){k=(uZ(g,c[t+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(p*52|0)+48|0]=k;u=c[m>>2]|0}else{u=o}k=p+1|0;if((k|0)<(u|0)){o=u;p=k}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;o=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{l=c[u>>2]|0;do{if((a[l+(b*52|0)+48|0]|0)==0){k=a[l+(b*52|0)+8|0]|0;if(k<<24>>24==0){t=(uZ(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==1){k=(uZ(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}kZ(g);VP(j);VP(h);i=f;return}function dM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[97892>>2]|0;H=c[98020>>2]|0;I=c[2]|0;if((c[41148>>2]|0)==0){if(!((c[97840>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;uv(23,0,88576,l);l=c[97964>>2]|0;do{if((l|0)==0){M=0}else{if((y_(l,88600)|0)==0){M=1;break}if((y_(l,88608)|0)==0){M=0;break}if((y_(l,88616)|0)==0){M=2;break}c[j>>2]=l;wv(1,0,88624,j);M=0}}while(0);if((Rw(M)|0)!=0){c[g>>2]=l;wv(1,0,88696,g)}if((c[2]|0)!=0){nN(d+56|0);Ww((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Sw(0);Sw(6);Tw(3);Tw(4);Tw(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+u_(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];uv(1,0,88784,f)}do{if((c[97948>>2]|0)!=0){f=e_(12)|0;J=f;PP(J,c[98076>>2]|0);if((f|0)==0){break}f=qQ(J)|0;c[d+280>>2]=f;c[e>>2]=f;uv(23,0,88840,e)}}while(0);e=c[98072>>2]|0;JP(m);if((e|0)==0){PP(p,c[d+88>>2]|0);PP(q,88888);eM(o,p,q);ME(n,o,c[d+284>>2]|0);WP(m,n)|0;VP(n);VP(o);VP(q);VP(p)}else{XP(m,e)|0}PP(r,88896);PP(s,88896);PP(t,88896);PP(u,88896);PP(v,88896);PP(w,88896);e=c[97840>>2]|0;if((c[97860>>2]|0)!=0){XP(r,c[97988>>2]|0)|0}if((c[97876>>2]|0)!=0){XP(s,c[98004>>2]|0)|0}if((c[97856>>2]|0)!=0){XP(t,c[97984>>2]|0)|0}if((c[97864>>2]|0)==0){O=0.0}else{XP(u,c[97992>>2]|0)|0;O=+u_(qQ(u)|0)}if((c[97868>>2]|0)==0){P=1}else{XP(v,c[97996>>2]|0)|0;P=Fc(qQ(v)|0)|0}if((c[97928>>2]|0)!=0){XP(w,c[98056>>2]|0)|0}LP(x,m);LP(y,r);LP(z,s);LP(A,t);LP(B,w);p=fM(d,x,y,z,A,O,P,B,e)|0;VP(B);VP(A);VP(z);VP(y);VP(x);if((p|0)!=0|g^1){Q=p}else{Sw(5);p=EM(d)|0;Vw(5);uv(1,0,88904,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;VP(w);VP(v);VP(u);VP(t);VP(s);VP(r);VP(m);i=b;return R|0}Q=d+88|0;PP(D,c[Q>>2]|0);ME(C,D,88936);VP(D);PP(F,c[Q>>2]|0);ME(E,F,88952);VP(F);Vw(0);F=c[98040>>2]|0;Q=qQ(C)|0;D=qQ(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;bN(d,Q,D,(F|0)!=0?F:88968,I,p,qQ(m)|0)|0;VP(E);VP(C);R=0;VP(w);VP(v);VP(u);VP(t);VP(s);VP(r);VP(m);i=b;return R|0}function eM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;KP(a,d);e=TP(b)|0;f=TP(c)|0;uQ(a,UP(b)|0,e,f+e|0);mQ(a,UP(c)|0,f)|0;i=d;return}function fM(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((TP(j)|0)==0){u=0}else{u=qQ(j)|0}LP(r,b);b=(gM(a,r,k)|0)==0;VP(r);if(!b){v=-1;i=l;return v|0}PP(s,88896);b=a+280|0;r=_L(s,c[b>>2]|0)|0;VP(s);do{if(r){w=3}else{s=1;k=0;do{PP(t,c[89112+(s<<2)>>2]|0);j=_L(t,c[b>>2]|0)|0;VP(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];wv(1,0,89192,q);wv(1,0,88192,p);s=1;do{j=c[89224+(s<<2)>>2]|0;c[o>>2]=c[89112+(s<<2)>>2];c[o+4>>2]=j;wv(1,0,88216,o);s=s+1|0;}while((s|0)<20);yv(c[a+536>>2]|0,88320,n)}}while(0);c[m>>2]=c[89112+(w<<2)>>2];uv(23,0,89304,m);m=qQ(d)|0;d=qQ(e)|0;e=Dz(a,m,d,qQ(f)|0,g,h,w,u)|0;be[c[82556>>2]&63](82528,a);v=e;i=l;return v|0}function gM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[20632]=vd(qQ(b)|0)|0;c[82532>>2]=g;c[82536>>2]=d;d=a+284|0;do{if((c[22042]|0)==0){g=c[d>>2]|0;if((y_(88976,g)|0)==0){h=0;break}if((y_(88984,g)|0)==0){c[82544>>2]=49;c[82548>>2]=50;c[82556>>2]=51;h=0;break}if((y_(88992,g)|0)==0){c[82544>>2]=52;c[82548>>2]=53;c[82552>>2]=54;c[82556>>2]=55;h=1;break}if((y_(89e3,g)|0)==0){c[82544>>2]=56;c[82548>>2]=57;c[82552>>2]=58;c[82556>>2]=59;h=1;break}if((y_(89008,g)|0)==0){c[82544>>2]=60;c[82548>>2]=61;c[82556>>2]=62;h=0;break}g=aM(110432,89016)|0;gS(aM(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);cM(a+8|0,c[a+288>>2]|0,h);be[c[82544>>2]&63](82528,a);a=c[20632]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;uv(23,0,89040,f);j=0;i=e;return j|0}function hM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;lv();do{if((vN(a,b)|0)==0){if((xN(a,b)|0)!=0){break}do{if((c[97896>>2]|0)!=0){w=c[98024>>2]|0;if((y_(w,89424)|0)==0){rv(1);break}if((y_(w,89432)|0)==0){rv(0);break}else{c[p>>2]=w;wv(1,0,89440,p);qd(0)|0;xd(0)}}}while(0);if((c[97852>>2]|0)==0){XL(0,0);Hy(d);if((d|0)==0){gS(aM(110432,89808)|0,103)|0}c[d+300>>2]=ZL(0,0)|0;c[d+292>>2]=$L(0,0)|0;JE(d+8|0,d+240|0);My(d)|0;Uy(d)|0;bz(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}gS(aM(110432,89872)|0,103)|0;x=1;i=e;return x|0}}while(0);c[22042]=c[97920>>2];x=0;i=e;return x|0}PP(u,c[97980>>2]|0);w=1;while(1){y=46080+(w<<2)|0;PP(v,c[y>>2]|0);z=YL(u,v)|0;VP(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=qQ(u)|0;wv(1,0,89712,g);c[f>>2]=c[b>>2];wv(1,0,89752,f);qd(0)|0;xd(0)}A=c[50104+(w<<2)>>2]|0;do{if((A|0)==1){z=c[49976+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;uv(1,1,89512,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[49976+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;uv(1,1,89552,n);break}else{c[m>>2]=z;wv(1,1,89392,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[89224+(A<<2)>>2]|0;c[h>>2]=c[89112+(A<<2)>>2];c[h+4>>2]=z;uv(1,0,88216,h);A=A+1|0;}while((A|0)<20);D=41600;E=c[10400]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else if((w|0)==7){A=1;do{z=c[89632+(A<<2)>>2]|0;c[k>>2]=c[89616+(A<<2)>>2];c[k+4>>2]=z;uv(1,0,88216,k);A=A+1|0;}while((A|0)<4);D=41600;E=c[10400]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else if((w|0)==19){A=c[9834]|0;if((A|0)<28){G=A}else{D=41600;E=c[10400]|0;ae[E&255](1);F=qd(0)|0;xd(0)}do{A=c[40920+(G<<2)>>2]|0;c[l>>2]=c[39752+(G<<2)>>2];c[l+4>>2]=A;uv(1,0,88216,l);G=G+1|0;}while((G|0)<28);D=41600;E=c[10400]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else if((w|0)==11){A=1;do{z=c[89680+(A<<2)>>2]|0;c[j>>2]=c[89648+(A<<2)>>2];c[j+4>>2]=z;uv(1,0,88216,j);A=A+1|0;}while((A|0)<7);D=41600;E=c[10400]|0;ae[E&255](1);F=qd(0)|0;xd(0)}else{D=41600;E=c[10400]|0;ae[E&255](1);F=qd(0)|0;xd(0)}}}while(0);c[t>>2]=c[b>>2];uv(1,1,89328,t);t=1;do{b=c[50104+(t<<2)>>2]|0;do{if((b|0)==1){F=c[47984+(t<<2)>>2]|0;c[s>>2]=c[46080+(t<<2)>>2];c[s+4>>2]=F;uv(1,0,89344,s)}else{F=c[46080+(t<<2)>>2]|0;if((b|0)==2){E=c[47984+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;uv(1,0,89360,r);break}else{c[q>>2]=F;wv(1,0,89392,q);break}}}while(0);t=t+1|0;}while((t|0)<31);ae[c[10400]&255](1);qd(0)|0;xd(0);return 0}function iM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[22476]|0;tb(91552)|0;c[l>>2]=c[m+88>>2];hc(89912,l|0)|0;tb(91568)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hc(89936,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];hc(89976,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hc(90008,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hc(90040,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];hc(90072,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];hc(90104,b|0)|0;tb(91592)|0;i=a;return}function jM(a,b){a=a|0;b=+b;i=i;return}



function xB(a){a=a|0;var b=0;b=i;yB(a);i=b;return}function yB(a){a=a|0;var b=0;b=i;zB(a,0);i=b;return}function zB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=AB(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}de[c[(BB(e)|0)>>2]&127](f)|0;i=d;return}function AB(a){a=a|0;var b=0,c=0;b=i;c=DB(a)|0;i=b;return c|0}function BB(a){a=a|0;var b=0,c=0;b=i;c=CB(a)|0;i=b;return c|0}function CB(a){a=a|0;i=i;return a+4|0}function DB(a){a=a|0;i=i;return a|0}function EB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(GB(f)|0)>>2]|0;FB(a,d,c[(HB(g)|0)>>2]|0);i=e;return}function FB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;IB(a,b,c);i=d;return}function GB(a){a=a|0;i=i;return a|0}function HB(a){a=a|0;i=i;return a|0}function IB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(KB(f)|0)>>2]|0;JB(a,d,c[(LB(g)|0)>>2]|0);i=e;return}function JB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(KB(f)|0)>>2];c[a+4>>2]=c[(LB(g)|0)>>2];i=e;return}function KB(a){a=a|0;i=i;return a|0}function LB(a){a=a|0;i=i;return a|0}function MB(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function NB(a){a=a|0;var b=0;b=i;OB(a+300|0);OB(a+288|0);OB(a+276|0);OB(a+264|0);OB(a+252|0);OB(a+240|0);PB(a);i=b;return}function OB(a){a=a|0;var b=0;b=i;zC(a);i=b;return}function PB(a){a=a|0;var b=0;b=i;QB(a,83112);NQ(a+104|0);i=b;return}function QB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];UB(a+4|0);i=d;return}function RB(a){a=a|0;var b=0;b=i;PB(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function SB(a){a=a|0;var b=0;b=i;PB(a);g_(a);i=b;return}function TB(a){a=a|0;var b=0;b=i;SB(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function UB(a){a=a|0;var b=0;b=i;VB(a);i=b;return}function VB(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=83240;uB(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}h_(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}h_(e)}}while(0);WQ(b);i=d;return}function WB(a){a=a|0;var b=0;b=i;UB(a);g_(a);i=b;return}function XB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=xC(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=yC(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;eR(h,0,0,0);jR(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}h_(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=f_(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=f_(h)|0;a[b+97|0]=1;i=e;return}function YB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;eR(e,0,0,0);jR(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}h_(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}h_(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=f_(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(uC(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=f_(o)|0;a[k]=1;i=f;return e|0}return 0}function ZB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;FZ(n);Od(n|0,130632,128)}n=qC(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((de[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){yA(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=V_(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Vc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;yA(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];tC(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{yA(a,-1,-1);i=g;return}}}while(0);yA(a,-1,-1);i=g;return}function _B(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((de[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=MB(d)|0;if((Vc(j|0,k|0,0)|0)==0){sC(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{yA(a,-1,-1);i=e;return}}}while(0);yA(a,-1,-1);i=e;return}function $B(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;FZ(m);Od(m|0,130632,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=qC(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=cR(s)|0;u=(fa(t-(bR(s)|0)|0,p)|0)+r|0;v=0;break}p=bR(s)|0;if((p|0)==(cR(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=rC(t,g,x,o,p-(aR(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=cR(w)|0;u=q-(bR(w)|0)|0;v=0}}while(0);if((Vc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;eR(b,0,0,0);c[m>>2]=0}else{q=b;y=gR(q)|0;do{if((y|0)!=(fR(q)|0)){if((se[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=pC(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((qd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function aC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=kC(b)|0;o=b;if((bR(o)|0)==0){p=e+1|0;eR(o,e,p,p)}if(n){q=0}else{n=cR(o)|0;c[f>>2]=(n-(aR(o)|0)|0)/2|0;c[g>>2]=4;q=c[(lC(f,g)|0)>>2]|0}g=bR(o)|0;do{if((g|0)==(cR(o)|0)){F_(aR(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=cR(o)|0;n=aR(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=aR(o)|0;eR(o,n,n+q|0,n+(p+q)|0);r=iC(a[bR(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;F_(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(lC(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;FZ(t);Od(t|0,130632,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=aR(o)|0;if((mC(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;eR(o,f,f,c[s>>2]|0);r=iC(a[bR(o)|0]|0)|0;break}s=c[k>>2]|0;f=aR(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}eR(o,f,p,s);r=iC(a[bR(o)|0]|0)|0}else{r=iC(a[g]|0)|0}}while(0);if((aR(o)|0)!=(e|0)){m=r;i=d;return m|0}eR(o,0,0,0);m=r;i=d;return m|0}function bC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=aR(g)|0;j=bR(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(eC(d,-1)|0){dR(g,-1);f=hC(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=fC(d)|0;do{if(h){if(jC(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);dR(g,-1);a[bR(g)|0]=b;f=d;i=e;return f|0}function cC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}dC(b);l=b;m=fR(l)|0;n=hR(l)|0;if(!(eC(d,-1)|0)){if((gR(l)|0)==0){jR(l,f,f+1|0)}f=fC(d)|0;a[gR(l)|0]=f;iR(l,1)}f=gR(l)|0;o=fR(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;FZ(u);v=130632;w=128;Od(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=fR(l)|0;A=gR(l)|0;B=gC(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=fR(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;jR(l,B,gR(l)|0);B=hR(l)|0;iR(l,B-(fR(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;FZ(u);v=130632;w=128;Od(t|0,v|0,w|0)}else if((D|0)==14){q=(gR(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);jR(l,m,n)}k=hC(d)|0;i=e;return k|0}function dC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;eR(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;jR(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;jR(f,h,h+(g+ -1)|0);break}}else{jR(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function eC(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function fC(a){a=a|0;i=i;return a&255|0}function gC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Be[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function hC(a){a=a|0;var b=0,c=0;b=i;c=eC(a,-1)|0;i=b;return(c?0:a)|0}function iC(a){a=a|0;i=i;return a&255|0}function jC(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function kC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;jR(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;eR(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;eR(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function lC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=nC(b,c,e)|0;i=d;return g|0}function mC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Be[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function nC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=oC(0,b,a)|0;i=c;return(d?b:a)|0}function oC(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function pC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=te[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function qC(a){a=a|0;var b=0,d=0;b=i;d=de[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function rC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=te[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function sC(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function tC(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function uC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=vC(b,c,e)|0;i=d;return g|0}function vC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=wC(0,a,b)|0;i=c;return(d?b:a)|0}function wC(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function xC(a){a=a|0;var b=0,c=0;b=i;c=FW(a,115136)|0;i=b;return c|0}function yC(a){a=a|0;var b=0,d=0;b=i;d=de[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function zC(a){a=a|0;var b=0;b=i;AC(a);i=b;return}function AC(a){a=a|0;var b=0;b=i;BC(a);i=b;return}function BC(a){a=a|0;var b=0;b=i;CC(a,dB(a)|0);i=b;return}function CC(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;kB(d);if((b|0)==0){i=d;return}CC(a,c[b>>2]|0);CC(a,c[b+4>>2]|0);EC(DC(a)|0,b,1);i=d;return}function DC(a){a=a|0;var b=0,c=0;b=i;c=GC(a+4|0)|0;i=b;return c|0}function EC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;FC(0,b,0);i=c;return}function FC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;g_(b);i=c;return}function GC(a){a=a|0;var b=0,c=0;b=i;c=HC(a)|0;i=b;return c|0}function HC(a){a=a|0;i=i;return a|0}function IC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=JC(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}LC(j,a,b);MC(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];KC(g,e);NC(j);j=c[f>>2]|0;OC(a,j,k,PC(g)|0);k=QC(g)|0;NC(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function JC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=dB(h)|0;kB(e);if((a|0)==0){j=WA(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(hB(0,d,a)|0){m=l;j=c[m>>2]|0;kB(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(hB(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;kB(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function KC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];CD(a,e);i=d;return}function LC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=DC(d)|0;d=lD(n,1)|0;mD(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];kD(j,d,h);nD(0,gD((oD(j)|0)+16|0)|0,e);e=pD(j)|0;a[e+4|0]=1;qD(0,fD((oD(j)|0)+20|0)|0);a[e+5|0]=1;rD(m,j);MC(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];KC(b,g);NC(m);NC(j);i=f;return}function MC(a,b){a=a|0;b=b|0;var c=0;c=i;iD(a,b);i=c;return}function NC(a){a=a|0;var b=0;b=i;bD(a);i=b;return}function OC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;kB(f);c[e>>2]=0;kB(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=VC(a)|0;b=c[c[e>>2]>>2]|0;kB(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(WA(a)|0)>>2]|0;WC(e,c[d>>2]|0);d=XC(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function PC(a){a=a|0;var b=0,d=0;b=i;d=c[(TC(a)|0)>>2]|0;i=b;return d|0}function QC(a){a=a|0;var b=0,d=0;b=i;d=RC(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function RC(a){a=a|0;var b=0,c=0;b=i;c=SC(a)|0;i=b;return c|0}function SC(a){a=a|0;i=i;return a|0}function TC(a){a=a|0;var b=0,c=0;b=i;c=UC(a)|0;i=b;return c|0}function UC(a){a=a|0;i=i;return a|0}function VC(a){a=a|0;i=i;return a|0}function WC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=_C(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;kB(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;kB(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(_C(j)|0){p=j}else{o=c[k>>2]|0;$C(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;aD(p);i=e;return}else if((l|0)==14){if(_C(j)|0){p=c[k>>2]|0;aD(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;$C(q);i=e;return}else if((l|0)==17){i=e;return}}function XC(a){a=a|0;var b=0,c=0;b=i;c=YC(a+8|0)|0;i=b;return c|0}function YC(a){a=a|0;var b=0,c=0;b=i;c=ZC(a)|0;i=b;return c|0}function ZC(a){a=a|0;i=i;return a|0}function _C(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function $C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;kB(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=_C(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function aD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;kB(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=_C(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function bD(a){a=a|0;var b=0;b=i;cD(a,0);i=b;return}function cD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=RC(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}eD(dD(e)|0,f);i=d;return}function dD(a){a=a|0;var b=0,c=0;b=i;c=hD(a)|0;i=b;return c|0}function eD(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}EC(c[a>>2]|0,b,1);i=d;return}function fD(a){a=a|0;i=i;return a|0}function gD(a){a=a|0;i=i;return a|0}function hD(a){a=a|0;i=i;return a+4|0}function iD(a,b){a=a|0;b=b|0;var c=0;c=i;jD(a,b);i=c;return}function jD(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function kD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];uD(a,b,f);i=e;return}function lD(a,b){a=a|0;b=b|0;var c=0;a=i;c=tD(0,b,0)|0;i=a;return c|0}function mD(a,b){a=a|0;b=b|0;var c=0;c=i;sD(a,b);i=c;return}function nD(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function oD(a){a=a|0;var b=0,d=0;b=i;d=c[(TC(a)|0)>>2]|0;i=b;return d|0}function pD(a){a=a|0;var b=0,c=0;b=i;c=dD(a)|0;i=b;return c|0}function qD(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function rD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;iD(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];KC(h,f);MC(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];KC(a,e);NC(h);i=d;return}function sD(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function tD(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=e_(b*24|0)|0;i=c;return a|0}function uD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(wD(g)|0)>>2]|0;g=xD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];vD(b,a,f);i=e;return}function vD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];yD(a,b,f);i=e;return}function wD(a){a=a|0;i=i;return a|0}function xD(a){a=a|0;i=i;return a|0}function yD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(AD(g)|0)>>2]|0;g=BD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];zD(b,a,f);i=e;return}function zD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(AD(f)|0)>>2];f=BD(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function AD(a){a=a|0;i=i;return a|0}function BD(a){a=a|0;i=i;return a|0}function CD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=QC(DD(b)|0)|0;h=BD(pD(DD(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];vD(g,a,e);i=d;return}function DD(a){a=a|0;i=i;return c[a>>2]|0}function ED(a){a=a|0;var b=0;b=i;i=i+48|0;FD(a);yA(a+184|0,0,0);yA(a+200|0,0,0);GD(a+240|0,b);GD(a+252|0,b+8|0);GD(a+264|0,b+16|0);GD(a+276|0,b+24|0);GD(a+288|0,b+32|0);GD(a+300|0,b+40|0);i=b;return}function FD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;SQ(d);e=a;c[e>>2]=83084;f=d;c[f>>2]=83104;d=a+4|0;ZR(a,83116|0,d);c[e>>2]=83084;c[f>>2]=83104;TD(d);i=b;return}function GD(a,b){a=a|0;b=b|0;b=i;HD(a,0);i=b;return}function HD(a,b){a=a|0;b=b|0;b=i;i=i+8|0;ID(a,b);i=b;return}function ID(a,b){a=a|0;b=b|0;b=i;JD(a,0);i=b;return}function JD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;KD(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;LD(f,0,e);e=WA(b)|0;c[(VC(b)|0)>>2]=e;i=d;return}function KD(a){a=a|0;var b=0;b=i;PD(a);i=b;return}function LD(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;MD(b,c,f);i=e;return}function MD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(OD(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;ND(d,b,f);i=e;return}function ND(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(OD(e)|0)>>2];i=d;return}function OD(a){a=a|0;i=i;return a|0}function PD(a){a=a|0;var b=0;b=i;QD(a);i=b;return}function QD(a){a=a|0;var b=0;b=i;RD(a);i=b;return}function RD(a){a=a|0;var b=0;b=i;SD(a);i=b;return}function SD(a){a=a|0;c[a>>2]=0;i=i;return}function TD(a){a=a|0;var b=0;b=i;UD(a);i=b;return}function UD(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;$Q(j);c[d>>2]=83240;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;kB(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;XQ(g,j);l=VD(g)|0;DW(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ge[r&63](d,0,4096)|0;i=e;return}XQ(h,j);c[k>>2]=xC(h)|0;DW(h);a[f]=(yC(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ge[r&63](d,0,4096)|0;i=e;return}function VD(a){a=a|0;var b=0,c=0;b=i;c=EW(a,115136)|0;i=b;return c|0}function WD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Sw(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){XD(a,b,c[f>>2]|0,h);Vw(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=b_(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;yv(k,83512,e)}XD(a,b,l,h);Vw(3);i=d;return}function XD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Vw(0);k=+Nw(0);Sw(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function YD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=_Z(24)|0;Sw(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;xv(c[m>>2]|0,l>>>31^1,83568,f);f=b+8|0;b=c[a+8>>2]|0;l=ZD(b,f)|0;c[g+20>>2]=l;l=ZD(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=_Z(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;yv(k,83648,e)}else{c[h>>2]=0;c[a+12>>2]=g;Vw(3);i=d;return}}function ZD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function _D(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Sw(3);u=b;v=jc(c[u>>2]|0,83712)|0;if((v|0)==0){$D(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Rd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;yv(w,83720,q)}rc(83776,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];sd(v|0,83824,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];sd(v|0,83848,o|0)|0;rc(83872,40,1,v|0)|0;rc(83920,11,1,v|0)|0;rc(83936,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];aE(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Nd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(83952,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;aE(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Nd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];sd(v|0,83976,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;aE(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Nd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];sd(v|0,83976,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;aE(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Nd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];sd(v|0,83976,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;aE(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Nd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];sd(v|0,83976,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;aE(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Nd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];sd(v|0,83976,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;aE(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Nd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];sd(v|0,83976,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;aE(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Nd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}$D(t);if((Xc(v|0)|0)==0){$Z(c[r>>2]|0);c[r>>2]=0;Vw(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];yv(e,83992,f)}}function $D(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}$Z(a);c[d>>2]=0;i=b;return}function aE(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];sd(a|0,84040,f|0)|0;i=e;return}function bE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=e_(192)|0;G_(m|0,0,192)|0;cE(m);c[a+12>>2]=m;n=m;o=a;zA(n,c[o>>2]|0,36);if(GQ(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];yv(a,84080,g)}else{g=m;jS(g,84056,14)|0;kS(h,g);a=MB(h)|0;h=m+184|0;c[h>>2]=a;jS(g,84072,4)|0;dE(n,b+8|0);kS(j,g);b=MB(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;yA(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];lS(g,f)|0;eE(n,-4-m+b|0);b=c[j>>2]|0;yA(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];lS(g,e)|0;Vw(3);i=d;return}}function cE(a){a=a|0;var b=0;b=i;xE(a);i=b;return}function dE(a,b){a=a|0;b=b|0;var c=0;c=i;gE(a,3);hE(a,84256);gE(a,0);hE(a,84264);gE(a,2);sE(a,b);tE(a,b);hE(a,84272);gE(a,0);i=c;return}function eE(a,b){a=a|0;b=b|0;var d=0;d=i;c[21062]=Cd(b|0)|0;jS(a,84248,4)|0;i=d;return}function fE(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;kS(l,q);r=MB(l)|0;eE(b,0);kS(m,q);l=MB(m)|0;gE(b,1);hE(b,84144);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;iE(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);jE(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{jE(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{kE(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{lE(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{hE(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}kS(n,q);u=MB(n)|0;n=D_(0,r|0,32)|0;yA(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];lS(q,k)|0;eE(b,u-l|0);yA(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];lS(q,j)|0;i=g;return}function gE(b,d){b=b|0;d=d|0;var e=0;e=i;a[84232]=-33;c[21060]=Cd(d|0)|0;d=b;jS(d,84232,1)|0;jS(d,84240,4)|0;i=e;return}function hE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Cd(C_(d|0)|0)|0;a[84224]=-37;g=b;jS(g,84224,1)|0;jS(g,f,4)|0;jS(g,d,C_(d|0)|0)|0;i=e;return}function iE(b,d){b=b|0;d=d|0;var e=0;e=i;a[84208]=-35;c[21054]=Cd(d|0)|0;d=b;jS(d,84208,1)|0;jS(d,84216,4)|0;i=e;return}function jE(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[84192]=-53;rE(c);e=b;jS(e,84192,1)|0;jS(e,84200,8)|0;i=d;return}function kE(b,d){b=b|0;d=d|0;var e=0;e=i;a[84176]=-46;c[21046]=Cd(d|0)|0;d=b;jS(d,84176,1)|0;jS(d,84184,4)|0;i=e;return}function lE(b,c){b=b|0;c=c|0;var d=0;d=i;a[84168]=c?-61:-62;jS(b,84168,1)|0;i=d;return}function mE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;fE(e,+h[f>>3],a,f);fE(e,+h[b+248>>3],a,f);i=d;return}function nE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;kS(j,p);o=MB(j)|0;eE(b,0);kS(k,p);j=MB(k)|0;gE(b,1);hE(b,84152);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;iE(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;jE(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{jE(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{kE(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{lE(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{hE(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}kS(l,p);s=MB(l)|0;l=D_(0,o|0,32)|0;yA(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];lS(p,g)|0;eE(b,s-j|0);yA(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];lS(p,f)|0;i=e;return}function oE(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;sA(a);Sw(3);if((a|0)!=0){pE(a);g_(a)}c[d>>2]=0;Vw(3);i=b;return}function pE(a){a=a|0;var b=0;b=i;qE(a);i=b;return}function qE(a){a=a|0;var b=0;b=i;PB(a);i=b;return}function rE(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Cd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=84200;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[84200+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function sE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;hE(a,84144);gE(a,4);hE(a,84280);gE(a,0);hE(a,84288);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;iE(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);hE(a,84296);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{hE(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{hE(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{hE(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{hE(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=84384;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];uE(a,b,e);hE(a,84320);gE(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);vE(a,84296,84328);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;vE(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;vE(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;vE(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;vE(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function tE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;hE(a,84152);gE(a,4);hE(a,84280);gE(a,0);hE(a,84288);o=g+1+j+l+n|0;iE(a,o);hE(a,84296);if((c[f>>2]|0)>0){n=b;l=0;do{hE(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{hE(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{hE(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{hE(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=84304;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];uE(a,b,e);hE(a,84320);gE(a,o);vE(a,84296,84328);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;vE(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;vE(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;vE(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;vE(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function uE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;hE(b,84352);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}gE(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?84296:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}wE(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?84296:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}wE(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?84296:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}wE(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?84296:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}wE(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function vE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;hE(a,b);gE(a,1);hE(a,84336);hE(a,c);i=d;return}function wE(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;hE(a,b);gE(a,d?2:1);hE(a,84360);hE(a,c);if(!d){i=e;return}hE(a,84368);hE(a,84376);i=e;return}function xE(a){a=a|0;var b=0;b=i;FD(a);i=b;return}function yE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;PP(e,84400);LP(d,AE(a,e)|0);zE(d,b+4|0);VP(d);VP(e);PP(g,84408);LP(f,AE(a,g)|0);BE(f,b);VP(f);VP(g);PP(j,84424);LP(h,AE(a,j)|0);zE(h,b+8|0);VP(h);VP(j);PP(l,84440);LP(k,AE(a,l)|0);zE(k,b+12|0);VP(k);VP(l);PP(n,84456);LP(m,AE(a,n)|0);CE(m,b+16|0,0);VP(m);VP(n);PP(p,84472);LP(o,AE(a,p)|0);CE(o,b+20|0,0);VP(o);VP(p);PP(r,84488);LP(q,AE(a,r)|0);CE(q,b+24|0,0);VP(q);VP(r);PP(t,84496);LP(s,AE(a,t)|0);CE(s,b+28|0,0);VP(s);VP(t);PP(v,84512);LP(u,AE(a,v)|0);CE(u,b+32|0,0);VP(u);VP(v);i=c;return}function zE(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){wv(22,0,87720,d);i=d;return}else{c[b>>2]=vd(qQ(a)|0)|0;i=d;return}}function AE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=LI(a,f,b)|0;l=c[k>>2]|0;kB(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}NI(j,a,b);OI(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];MI(g,e);PI(j);j=c[f>>2]|0;QI(a,j,k,RI(g)|0);k=SI(g)|0;PI(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function BE(a,b){a=a|0;b=b|0;var d=0;d=i;if((tQ(a,84688)|0)==0){c[b>>2]=1;i=d;return}if((tQ(a,84696)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(qQ(a)|0)|0;i=d;return}}function CE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((tQ(a,84664)|0)==0){c[b>>2]=d}if((tQ(a,84688)|0)==0){c[b>>2]=1;i=e;return}if((tQ(a,84696)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(qQ(a)|0)|0;i=e;return}}function DE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;PP(j,84528);LP(g,AE(b,j)|0);y=d+48|0;EE(g,y);VP(g);VP(j);PP(m,84544);LP(l,AE(b,m)|0);j=d+56|0;FE(l,j,0.0);VP(l);VP(m);PP(o,84552);LP(n,AE(b,o)|0);m=d+32|0;EE(n,m);VP(n);VP(o);PP(q,84560);LP(p,AE(b,q)|0);o=d+33|0;EE(p,o);VP(p);VP(q);PP(s,84576);LP(r,AE(b,s)|0);q=d+40|0;FE(r,q,1.0);VP(r);VP(s);PP(u,84584);LP(t,AE(b,u)|0);s=d+16|0;FE(t,s,-1.7976931348623157e+308);VP(t);VP(u);PP(w,84592);LP(v,AE(b,w)|0);u=d+24|0;FE(v,u,1.7976931348623157e+308);VP(v);VP(w);PP(x,84400);w=qQ(AE(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?84688:84696;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?84664:84672;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?84664:84680;c[f+20>>2]=j;c[f+24>>2]=m?84664:84672;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?84664:84680;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];uv(4,0,84600,f);VP(x);i=e;return}function EE(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(tQ(b,84688)|0)==0|0;i=d;return}function FE(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((tQ(a,84664)|0)==0){h[b>>3]=c;i=d;return}if((tQ(a,84688)|0)==0){h[b>>3]=1.0;i=d;return}if((tQ(a,84696)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+u_(qQ(a)|0);i=d;return}}function GE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;PP(h,84528);LP(g,AE(b,h)|0);s=d+13|0;EE(g,s);VP(g);VP(h);PP(k,84544);LP(j,AE(b,k)|0);h=d+16|0;CE(j,h,0);VP(j);VP(k);PP(m,84552);LP(l,AE(b,m)|0);k=d+12|0;EE(l,k);VP(l);VP(m);PP(o,84584);LP(n,AE(b,o)|0);m=d+4|0;CE(n,m,-2147483648);VP(n);VP(o);PP(q,84592);LP(p,AE(b,q)|0);o=d+8|0;CE(p,o,2147483647);VP(p);VP(q);PP(r,84400);q=qQ(AE(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?84688:84696;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?84664:84672;c[f+8>>2]=s;c[f+12>>2]=b?84664:84680;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;uv(4,0,84704,f);VP(r);i=e;return}function HE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;PP(h,84528);LP(g,AE(b,h)|0);o=d+5|0;EE(g,o);VP(g);VP(h);PP(k,84544);LP(j,AE(b,k)|0);h=d+6|0;EE(j,h);VP(j);VP(k);PP(m,84552);LP(l,AE(b,m)|0);k=d+4|0;EE(l,k);VP(l);VP(m);PP(n,84400);m=qQ(AE(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?84688:84696;h=(a[k]|0)!=0?84688:84696;c[f>>2]=m;c[f+4>>2]=b?84664:84672;c[f+8>>2]=o;c[f+12>>2]=b?84664:84680;c[f+16>>2]=h;uv(4,0,84760,f);VP(n);i=e;return}function IE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;PP(h,84528);LP(g,AE(b,h)|0);m=d+4|0;EE(g,m);VP(g);VP(h);PP(k,84544);LP(j,AE(b,k)|0);h=d+8|0;zE(j,h);VP(j);VP(k);PP(l,84400);k=qQ(AE(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?84664:84672;c[f+8>>2]=m;c[f+12>>2]=b?84664:84680;uv(4,0,84800,f);VP(l);i=e;return}function JE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;KE(qa);JP(ra);LE(sa,ta);LE(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[97848>>2]|0)==0){PP(za,c[b+80>>2]|0);ME(ya,za,84824);WP(ra,ya)|0;VP(ya);VP(za)}else{XP(ra,c[97976>>2]|0)|0}ta=jc(qQ(ra)|0,84840)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=qQ(ra)|0;yv(0,84848,pa)}else{Wc=0}}while(0);pa=oq(0)|0;if((pa|0)==0){Xc(Wc|0)|0;yv(0,84952,oa)}zq(pa,Vc);Aq(pa,9,48);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;G_(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((Bq(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Xc(Wc|0)|0;oa=qQ(ra)|0;ya=Jq(Gq(pa)|0)|0;za=Hq(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;wv(1,0,85032,na);vq(pa);yv(0,85120,ma)}else if((Yc|0)==14){Xc(Wc|0)|0;break}}else{if((Bq(pa,Vc,C_(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Jq(Gq(pa)|0)|0;ta=Hq(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;sd(za|0,85144,la|0)|0;za=c[va>>2]|0;ta=Jq(Gq(pa)|0)|0;oa=Hq(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;wv(1,0,85160,ka);vq(pa);yv(0,85120,ja)}}while(0);ja=qa;PP(Ca,85248);QE(Ba,ja,Ca);RE(Da,ja);ka=PE(Ba,Da)|0;VP(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=qQ(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;wv(1,0,85256,ia)}else{PP(Ea,85248);Ba=y_(Da,qQ(AE(ja,Ea)|0)|0)|0;VP(Ea);if((Ba|0)==0){break}vq(pa);PP(Fa,85248);Ba=qQ(AE(ja,Fa)|0)|0;va=qQ(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;wv(1,0,85304,ha);VP(Fa);yv(0,85120,ga)}}while(0);SE(qa,b,c[98060>>2]|0,c[98064>>2]|0);uv(23,1,85400,fa);fa=qa+12|0;PP(Ha,85440);LP(Ga,AE(fa,Ha)|0);ga=d;FE(Ga,ga,0.0);VP(Ga);VP(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];uv(23,0,85456,ea);PP(Ja,85472);LP(Ia,AE(fa,Ja)|0);ea=d+8|0;FE(Ia,ea,1.0);VP(Ia);VP(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];uv(23,0,85488,da);PP(La,85504);LP(Ka,AE(fa,La)|0);da=d+24|0;FE(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);VP(Ka);VP(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];uv(23,0,85520,ca);PP(Na,85536);LP(Ma,AE(fa,Na)|0);ca=d+32|0;FE(Ma,ca,1.0e-5);VP(Ma);VP(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];uv(23,0,85552,ba);PP(Pa,85568);LP(Oa,AE(fa,Pa)|0);ba=d+40|0;zE(Oa,ba);VP(Oa);VP(Pa);c[aa>>2]=c[ba>>2];uv(23,0,85576,aa);PP(Ra,85600);LP(Qa,AE(fa,Ra)|0);aa=d+44|0;zE(Qa,aa);VP(Qa);VP(Ra);c[$>>2]=c[aa>>2];uv(23,0,85616,$);PP(Ta,85640);LP(Sa,AE(fa,Ta)|0);fa=d+48|0;zE(Sa,fa);VP(Sa);VP(Ta);c[_>>2]=c[fa>>2];uv(23,0,85656,_);PP(Va,85680);LP(Ua,AE(ja,Va)|0);_=d+268|0;zE(Ua,_);VP(Ua);VP(Va);c[Z>>2]=c[_>>2];uv(23,0,85704,Z);if((c[41140>>2]|0)!=0){ae[c[10400]&255](23)}PP(eb,85728);LP(db,AE(ja,eb)|0);CE(db,Wa,0);VP(db);VP(eb);PP(gb,85760);LP(fb,AE(ja,gb)|0);CE(fb,Xa,0);VP(fb);VP(gb);PP(ib,85792);LP(hb,AE(ja,ib)|0);CE(hb,Ya,0);VP(hb);VP(ib);PP(kb,85816);LP(jb,AE(ja,kb)|0);CE(jb,_a,0);VP(jb);VP(kb);PP(mb,85848);LP(lb,AE(ja,mb)|0);CE(lb,Za,0);VP(lb);VP(mb);PP(ob,85888);LP(nb,AE(ja,ob)|0);CE(nb,ab,0);VP(nb);VP(ob);PP(qb,85920);LP(pb,AE(ja,qb)|0);CE(pb,$a,0);VP(pb);VP(qb);PP(tb,85960);LP(rb,AE(ja,tb)|0);CE(rb,cb,0);VP(rb);VP(tb);PP(vb,85992);LP(ub,AE(ja,vb)|0);CE(ub,bb,0);VP(ub);VP(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=86536;uv(4,1,86512,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=TE(lb,wb)|0;yE(ib,jb+(kb*112|0)|0);DE(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(xb,86552);jb=(tQ(AE(ib,xb)|0,84688)|0)==0;VP(xb);if(!jb){break}c[N>>2]=c[hb>>2];uv(4,0,86568,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);PP(yb,c[hb>>2]|0);c[(UE(sa,yb)|0)>>2]=kb;VP(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[M>>2]=86600;uv(4,1,86512,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=TE(lb,zb)|0;yE(fb,gb+(jb*112|0)|0);DE(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Ab,86552);gb=(tQ(AE(fb,Ab)|0,84688)|0)==0;VP(Ab);if(!gb){break}c[L>>2]=c[eb>>2];uv(4,0,86568,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);PP(Bb,c[eb>>2]|0);c[(UE(sa,Bb)|0)>>2]=jb;VP(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[K>>2]=86624;uv(4,1,86512,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=TE(mb,Cb)|0;yE(gb,hb+(fb*112|0)|0);DE(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Db,86552);hb=(tQ(AE(gb,Db)|0,84688)|0)==0;VP(Db);if(!hb){break}c[J>>2]=c[db>>2];uv(4,0,86568,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);PP(Eb,c[db>>2]|0);c[(UE(sa,Eb)|0)>>2]=fb;VP(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[I>>2]=86640;uv(4,1,86512,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=TE(ub,Fb)|0;yE(mb,kb+(ib*60|0)|0);GE(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Gb,86552);kb=(tQ(AE(mb,Gb)|0,84688)|0)==0;VP(Gb);if(!kb){break}c[H>>2]=c[gb>>2];uv(4,0,86568,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);PP(Hb,c[gb>>2]|0);c[(UE(sa,Hb)|0)>>2]=ib;VP(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[G>>2]=86664;uv(4,1,86512,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=TE(ib,Ib)|0;yE(mb,ub+(lb*48|0)|0);HE(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Jb,86552);ub=(tQ(AE(mb,Jb)|0,84688)|0)==0;VP(Jb);if(!ub){break}c[F>>2]=c[fb>>2];uv(4,0,86568,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);PP(Kb,c[fb>>2]|0);c[(UE(sa,Kb)|0)>>2]=lb;VP(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[E>>2]=86688;uv(4,1,86512,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=TE(lb,Lb)|0;yE(mb,ib+(rb*52|0)|0);IE(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Mb,86552);ib=(tQ(AE(mb,Mb)|0,84688)|0)==0;VP(Mb);if(!ib){break}c[D>>2]=c[gb>>2];uv(4,0,86568,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);PP(Nb,c[gb>>2]|0);c[(UE(sa,Nb)|0)>>2]=rb;VP(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[C>>2]=86712;uv(4,1,86512,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=TE(rb,Ob)|0;yE(mb,lb+(pb*112|0)|0);DE(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Pb,86552);lb=(tQ(AE(mb,Pb)|0,84688)|0)==0;VP(Pb);if(!lb){break}c[B>>2]=c[fb>>2];uv(4,0,86568,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);PP(Qb,c[fb>>2]|0);c[(UE(ua,Qb)|0)>>2]=pb;VP(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[A>>2]=86728;uv(4,1,86512,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=TE(pb,Rb)|0;yE(mb,rb+(nb*60|0)|0);GE(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Sb,86552);rb=(tQ(AE(mb,Sb)|0,84688)|0)==0;VP(Sb);if(!rb){break}c[z>>2]=c[gb>>2];uv(4,0,86568,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);PP(Tb,c[gb>>2]|0);c[(UE(ua,Tb)|0)>>2]=nb;VP(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[y>>2]=86752;uv(4,1,86512,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=TE(nb,Ub)|0;yE(mb,pb+(ja*48|0)|0);HE(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Vb,86552);pb=(tQ(AE(mb,Vb)|0,84688)|0)==0;VP(Vb);if(!pb){break}c[x>>2]=c[fb>>2];uv(4,0,86568,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);PP(Wb,c[fb>>2]|0);c[(UE(ua,Wb)|0)>>2]=ja;VP(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}c[w>>2]=86776;uv(4,1,86512,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=TE(ja,Xb)|0;yE(mb,nb+(tb*52|0)|0);IE(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[97844>>2]|0)!=0){break}PP(Yb,86552);nb=(tQ(AE(mb,Yb)|0,84688)|0)==0;VP(Yb);if(!nb){break}c[v>>2]=c[gb>>2];uv(4,0,86568,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);PP(Zb,c[gb>>2]|0);c[(UE(ua,Zb)|0)>>2]=tb;VP(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}uv(4,1,86800,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=TE(tb,_b)|0;yE(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);JP($b);c[bc>>2]=ja;mb=TE(tb,bc)|0;PP(cc,86840);LP(ac,AE(mb,cc)|0);VE(ac,$b);VP(ac);VP(cc);mb=(tQ($b,86848)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;uv(4,0,86864,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=TE(tb,ec)|0;PP(fc,86904);LP(dc,AE(nb,fc)|0);VE(dc,$b);VP(dc);VP(fc);WE(wa,sa,$b);WE(xa,ua,$b);YE(gc,sa);do{if(XE(wa,gc)|0){nb=c[(ZE(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{YE(hc,ua);if(XE(xa,hc)|0){fb=c[(ZE(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((tQ($b,86920)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);VP($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}EQ(kc,86928,$b);ME(ic,kc,86952);VP(kc);c[s>>2]=qQ(ic)|0;yv(0,86968,s)}}while(0);if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}uv(4,1,86976,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=TE(ja,lc)|0;yE(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);JP(mc);c[oc>>2]=tb;gb=TE(ja,oc)|0;PP(pc,86840);LP(nc,AE(gb,pc)|0);VE(nc,mc);VP(nc);VP(pc);gb=(tQ(mc,86848)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;uv(4,0,86864,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=TE(ja,rc)|0;PP(sc,86904);LP(qc,AE(fb,sc)|0);VE(qc,mc);VP(qc);VP(sc);WE(wa,sa,mc);WE(xa,ua,mc);YE(tc,sa);if(XE(wa,tc)|0){fb=c[(ZE(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{YE(uc,ua);if(!(XE(xa,uc)|0)){break}nb=c[(ZE(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}VP(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}EQ(wc,87016,mc);ME(vc,wc,86952);VP(wc);c[o>>2]=qQ(vc)|0;yv(0,86968,o)}}while(0);if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}uv(4,1,87040,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=TE(tb,xc)|0;yE(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);JP(yc);c[Ac>>2]=ja;fb=TE(tb,Ac)|0;PP(Bc,86840);LP(zc,AE(fb,Bc)|0);VE(zc,yc);VP(zc);VP(Bc);fb=(tQ(yc,86848)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;uv(4,0,86864,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=TE(tb,Dc)|0;PP(Ec,86904);LP(Cc,AE(gb,Ec)|0);VE(Cc,yc);VP(Cc);VP(Ec);WE(wa,sa,yc);WE(xa,ua,yc);YE(Fc,sa);if(XE(wa,Fc)|0){gb=c[(ZE(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{YE(Gc,ua);if(!(XE(xa,Gc)|0)){break}nb=c[(ZE(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}VP(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}EQ(Ic,87080,yc);ME(Hc,Ic,86952);VP(Ic);c[l>>2]=qQ(Hc)|0;yv(0,86968,l)}}while(0);if((c[41064>>2]|0)!=0){ae[c[10400]&255](4)}uv(4,1,87104,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=TE(ja,Jc)|0;yE(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);JP(Kc);c[Mc>>2]=tb;gb=TE(ja,Mc)|0;PP(Nc,86840);LP(Lc,AE(gb,Nc)|0);VE(Lc,Kc);VP(Lc);VP(Nc);gb=(tQ(Kc,86848)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;uv(4,0,86864,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=TE(ja,Pc)|0;PP(Qc,86904);LP(Oc,AE(fb,Qc)|0);VE(Oc,Kc);VP(Oc);VP(Qc);WE(wa,sa,Kc);WE(xa,ua,Kc);YE(Rc,sa);if(XE(wa,Rc)|0){fb=c[(ZE(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{YE(Sc,ua);if(!(XE(xa,Sc)|0)){break}nb=c[(ZE(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}VP(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}EQ(Uc,87144,Kc);ME(Tc,Uc,86952);VP(Uc);c[f>>2]=qQ(Tc)|0;yv(0,86968,f)}}while(0);if((c[41064>>2]|0)==0){vq(pa);_E(ua);_E(sa);VP(ra);$E(qa);i=e;return}ae[c[10400]&255](4);vq(pa);_E(ua);_E(sa);VP(ra);$E(qa);i=e;return}}while(0);if((c[41136>>2]|c[10260]|0)==0){vq(pa);Zc=qd(0)|0;xd(-1)}wv(22,1,86032,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;wv(22,0,86080,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;wv(22,0,86128,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;wv(22,0,86176,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;wv(22,0,86224,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;wv(22,0,86272,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;wv(22,0,86320,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;wv(22,0,86368,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;wv(22,0,86416,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;wv(22,0,86464,P);ae[c[10400]&255](22);vq(pa);Zc=qd(0)|0;xd(-1)}function KE(a){a=a|0;var b=0;b=i;ML(a);i=b;return}function LE(a,b){a=a|0;b=b|0;b=i;rH(a,0);i=b;return}function ME(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;KP(a,d);e=TP(b)|0;f=zF(c)|0;uQ(a,UP(b)|0,e,f+e|0);mQ(a,c,f)|0;i=d;return}function NE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((y_(b,87776)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{PP(g,v);w=AE(u,g)|0;XP(w,c[d+((t|1)<<2)>>2]|0)|0;VP(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((y_(b,87800)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{PP(h,g);u=AE(t,h)|0;XP(u,c[d+((v|1)<<2)>>2]|0)|0;VP(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((y_(b,87824)|0)!=0){do{if((y_(b,88080)|0)!=0){if((y_(b,88088)|0)==0){break}if((y_(b,88096)|0)==0){break}if((y_(b,88104)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=TE(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){PP(r,c[t>>2]|0);w=AE(g,r)|0;XP(w,c[d+((u|1)<<2)>>2]|0)|0;VP(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=TE(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}PP(s,88112);XP(AE(x,s)|0,b)|0;VP(s);i=e;return}aF(j,k);JP(l);JP(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{PP(n,g);t=AE(j,n)|0;XP(t,c[d+((x|1)<<2)>>2]|0)|0;VP(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}PP(o,87840);WP(l,AE(j,o)|0)|0;VP(o);PP(p,87856);WP(m,AE(j,p)|0)|0;VP(p);c[k>>2]=Fc(qQ(l)|0)|0;if((tQ(m,87872)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((tQ(m,87880)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((tQ(m,87888)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((tQ(m,87896)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((tQ(m,87904)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((tQ(m,87912)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((tQ(m,87920)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((tQ(m,87928)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((tQ(m,87936)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((tQ(m,87944)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((tQ(m,87952)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((tQ(m,87960)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((tQ(m,87968)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((tQ(m,87976)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=qQ(m)|0;PP(q,84400);N=qQ(AE(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;xv(0,(O|0)!=0|0,87984,f);VP(q);pK(TE(c[b>>2]|0,s)|0,j)|0;VP(m);VP(l);iF(j);i=e;return}function OE(a,b){a=a|0;b=b|0;i=i;return}function PE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=aH(a,b)|0;i=c;return d|0}function QE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;jH(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];bH(a,f);i=e;return}function RE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;cH(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];bH(a,e);i=d;return}



function sq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=37;du(f+256|0);if((b|0)!=0){g=tq(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Or(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function tq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Kq(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function uq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Nq(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=tq(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Kq(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Kq(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Rq(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Nq(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;ae[c[e+20>>2]&255](c[g+36>>2]|0);wq(c[g+44>>2]|0,e);ae[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;ae[c[e+20>>2]&255](f)}wq(c[h+376>>2]|0,e);wq(c[e+372>>2]|0,e);xq(e+416|0);xq(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}yq(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);ae[c[e+20>>2]&255](c[e+392>>2]|0);ae[c[e+20>>2]&255](c[e+464>>2]|0);ae[c[e+20>>2]&255](c[e+8>>2]|0);ae[c[e+20>>2]&255](c[e+44>>2]|0);ae[c[e+20>>2]&255](c[e+396>>2]|0);ae[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){ae[c[e+252>>2]&255](c[e+244>>2]|0)}ae[c[e+20>>2]&255](e);i=d;return}function wq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;ae[c[a+20>>2]&255](c[b+16>>2]|0);ae[c[a+20>>2]&255](b)}i=d;return}function xq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ae[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ae[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function yq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Lq(f,g+20|0);while(1){d=Mq(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}ae[c[b+8>>2]&255](c[d+20>>2]|0)}Qq(g);Qq(g+132|0);Qq(g+20|0);Qq(g+40|0);Qq(g+60|0);xq(g+80|0);xq(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ae[m&255](o);i=e;return}ae[c[b+8>>2]&255](c[g+184>>2]|0);ae[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ae[m&255](o);i=e;return}function zq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Aq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Bq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Cq(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Eq(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{E_(f|0,b|0,d|0)|0;j=Fq(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ce[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=38;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){De[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function Cq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=zr()|0}if((a[e+236|0]|0)!=0){f=uq(e,32096)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Dq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Eq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;F_(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=de[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;E_(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;ae[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Fq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Cq(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ce[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=38;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);De[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Gq(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Hq(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}De[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Iq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){ze[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Zd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];ze[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Jq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[30320+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;E_((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=se[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=de[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){E_(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Lq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Mq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Nq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=de[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){G_(c[m>>2]|0,0,g|0)|0;g=Oq(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Oq(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Pq(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=de[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}G_(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Oq(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}ae[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=de[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){G_(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Oq(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Pq(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Qq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}ae[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}ae[e&255](c[d>>2]|0);i=b;return}function Rq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[31904+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[31944+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=se[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=de[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=de[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}ae[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;E_(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}ze[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function Sq(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ge[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=yr(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Tq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Uq(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function Uq(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=te[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=Vq(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Nq(o,l+132|0,31976,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=Wq(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}Xq(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Wq(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Zd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;rq(o+416|0);h=0;break};case 57:{v=Vq(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=_q(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Zd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);rq(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Nq(o,l+132|0,31976,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}ae[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=Zq(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=32080}else{x=(s|0)==32?32064:32088}if(($q(o+416|0,x)|0)==0){r=111;break a}if((ar(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=31984;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=31992;r=102;break};case 25:{c[o+332>>2]=32e3;r=102;break};case 26:{c[o+332>>2]=32008;r=102;break};case 27:{c[o+332>>2]=32016;r=102;break};case 28:{c[o+332>>2]=32024;r=102;break};case 29:{c[o+332>>2]=32040;r=102;break};case 30:{c[o+332>>2]=32048;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((br(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Kq(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Kq(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);rq(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Wq(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=31976}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Nq(o,l+132|0,31976,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=cr(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((br(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Kq(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Kq(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);rq(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=dr(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=Wq(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;me[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((ge[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Wq(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Nq(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Wq(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Nq(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Wq(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Iq(o,b,e,c[n>>2]|0)}h=0;D=er(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=Wq(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}Xq(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=Wq(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Zd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);rq(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Zd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);rq(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=de[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=se[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=se[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=gr(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=Wq(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=Nq(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}ze[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=hr(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=Zq(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=de[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;ze[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((kr(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((jr(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Wq(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=gr(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=Zq(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=ir(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;ze[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=Wq(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}Xq(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Iq(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ce[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((te[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=Nq(o,l+132|0,31976,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=39;I=Yq(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=40;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Vq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ce[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Wq(n+440|0,p,b,s+(se[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Wq(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);De[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Iq(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Wq(n+440|0,e,d,m+(se[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=yr(n,f)|0;rq(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){rq(n+440|0)}q=0;r=q;i=g;return r|0}function Wq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((ar(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Kq(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function Xq(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function Yq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=nr(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((vr(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Zq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Wq(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Nq(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((wr(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function _q(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Kq(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Wq(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Nq(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Nq(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Kq(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Kq(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Nq(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function $q(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Kq(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function ar(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Kq(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Zd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Kq(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function br(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=de[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=se[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function cr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=xr(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Kq(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function dr(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Kq(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ce[c[b+20>>2]&63](b,e,f,j)|0){case-4:{r=24;break a;break};case 10:{s=se[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=Er(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Kq(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=Wq(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=Nq(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=dr(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(te[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 7:{r=28;break};case 0:{r=49;break a;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case-1:{r=46;break a;break};case 6:case 9:{if((ar(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Kq(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function er(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ce[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 42:{if((c[k+80>>2]|0)!=0){Iq(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function fr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=er(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=41;k=Tq(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=de[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=se[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=de[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function hr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=de[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ce[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Uq(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=nr(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=42;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function ir(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=de[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;mr(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function jr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Iq(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(se[c[a+32>>2]&63](a,b)|0)|0;k=Wq(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=se[c[a+36>>2]&63](a,e)|0;e=Wq(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){lr(e);ze[c[g+64>>2]&15](c[g+4>>2]|0,k,e);rq(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function kr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Iq(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Wq(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){lr(k);be[c[g+68>>2]&63](c[g+4>>2]|0,k);rq(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function lr(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function mr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}mr(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function nr(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ce[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;D=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;E=se[c[e+32>>2]&63](e,D)|0;if((E|0)!=(c[C+8>>2]|0)){B=112;break a}if((x_(c[C+4>>2]|0,D,E)|0)!=0){B=112;break a}E=y+312|0;c[E>>2]=(c[E>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){E=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((E|0)==0){break}F=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[E]|0)==0){break}G=E;E=G+1|0;H=F;F=H+1|0;a[H]=a[G]|0}G=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}H=F;F=H+1|0;a[H]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}H=G;G=H+1|0;I=F;F=I+1|0;a[I]=a[H]|0}}}while(0);a[F]=0}}while(0);be[c[y+56>>2]&63](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Iq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}E=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){be[c[y+104>>2]&63](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case-4:{B=17;break a;break};case-3:{B=6;break a;break};case 9:{a[p]=ge[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){ze[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=Wq(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}E=Nq(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((E|0)!=0){break}G=y;if((c[y+120>>2]|0)!=0){ze[c[G+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[G+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((E|0)==0){B=41;break a}if((a[E+34|0]|0)==0){B=43;break a}}if((a[E+32|0]|0)!=0){B=50;break a}if((c[E+28>>2]|0)!=0){B=52;break a}C=y;if((c[E+4>>2]|0)!=0){G=y;if((a[C+308|0]|0)!=0){J=hr(G,E,0)|0;if((J|0)!=0){B=60;break a}else{break b}}H=y;if((c[G+120>>2]|0)!=0){ze[c[H+120>>2]&15](c[y+4>>2]|0,c[E>>2]|0,0);break b}if((c[H+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[E+32|0]=1;C=pr(y)|0;a[E+32|0]=0;if((C|0)==0){B=63;break a}if((te[c[y+112>>2]&63](c[y+116>>2]|0,C,c[E+20>>2]|0,c[E+16>>2]|0,c[E+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){K=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{K=de[c[C+12>>2]&127](48)|0;if((K|0)==0){B=72;break a}c[K+36>>2]=de[c[y+12>>2]&127](32)|0;if((c[K+36>>2]|0)==0){B=74;break a}c[K+40>>2]=(c[K+36>>2]|0)+32}c[K+44>>2]=0;c[K>>2]=c[y+364>>2];c[y+364>>2]=K;c[K+16>>2]=0;c[K+20>>2]=0;c[K+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[K+8>>2]=se[c[e+32>>2]&63](e,c[K+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[K+4>>2]|0)+(c[K+8>>2]|0)|0;c[r>>2]=c[K+4>>2];c[q>>2]=c[K+36>>2];while(1){Zd[c[e+60>>2]&31](e,r,C,q,(c[K+40>>2]|0)+ -1|0);L=(c[q>>2]|0)-(c[K+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}H=(c[K+40>>2]|0)-(c[K+36>>2]|0)<<1;G=se[c[y+16>>2]&63](c[K+36>>2]|0,H)|0;if((G|0)==0){B=80;break a}c[K+36>>2]=G;c[K+40>>2]=G+H;c[q>>2]=G+L}c[K+24>>2]=L;c[K+12>>2]=c[K+36>>2];a[c[q>>2]|0]=0;M=qr(y,e,c[m>>2]|0,K+12|0,K+44|0)|0;if((M|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){ze[c[C+52>>2]&15](c[y+4>>2]|0,c[K+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Iq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);rq(y+416|0);break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;E=1;c[t>>2]=Wq(y+416|0,e,C,C+(se[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];N=qr(y,e,c[m>>2]|0,t,s)|0;if((N|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){ze[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);E=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}be[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);E=0}do{if((E&255|0)!=0){if((c[y+80>>2]|0)==0){break}Iq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);rq(y+416|0);while(1){if((c[s>>2]|0)==0){break}E=c[s>>2]|0;if((c[y+104>>2]|0)!=0){be[c[y+104>>2]&63](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;ze[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{E=se[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((E|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){G=c[C+60>>2]|0;H=c[y+4>>2]|0;I=Er(E,u)|0;ze[G&15](H,u,I);break b}if((c[C+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){ae[c[C+72>>2]&255](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Iq(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=sr(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){ze[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Zd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];ze[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((jr(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((kr(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case-2:{B=28;break a;break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Iq(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){B=181;break}else if((f|0)==3){B=180;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;ze[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Iq(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=J;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){ae[c[y+20>>2]&255](K);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=M;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=N;Q=P;i=l;return Q|0}else if((B|0)==107){P=rr(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=D;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=rr(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=43;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){ze[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Zd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);ze[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Iq(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function or(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ce[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Uq(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=nr(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=41;m=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Uq(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=nr(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function pr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Kq(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Lq(e,b+60|0);a:while(1){k=Mq(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Kq(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Kq(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Lq(e,b);b:while(1){b=Mq(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Kq(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Kq(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}



function $Z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[131008>>2]|0;if(d>>>0<f>>>0){ed()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){ed()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){ed()}if((p|0)==(c[131012>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[131e3>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=131032+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){ed()}if((c[m+12>>2]|0)==(p|0)){break}ed()}}while(0);if((u|0)==(m|0)){c[32748]=c[32748]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){ed()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}ed()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){ed()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){ed()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){ed()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{ed()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=131296+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[131008>>2]|0)>>>0){ed()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[131008>>2]|0)>>>0){ed()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){ed()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){ed()}do{if((C&2|0)==0){if((l|0)==(c[131016>>2]|0)){f=(c[131004>>2]|0)+t|0;c[131004>>2]=f;c[131016>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[131012>>2]|0)){i=b;return}c[131012>>2]=0;c[131e3>>2]=0;i=b;return}if((l|0)==(c[131012>>2]|0)){f=(c[131e3>>2]|0)+t|0;c[131e3>>2]=f;c[131012>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=131032+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[131008>>2]|0)>>>0){ed()}if((c[E+12>>2]|0)==(l|0)){break}ed()}}while(0);if((w|0)==(E|0)){c[32748]=c[32748]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[131008>>2]|0)>>>0){ed()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}ed()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[131008>>2]|0)>>>0){ed()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){ed()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{ed()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=131296+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<g);break b}else{if(d>>>0<(c[131008>>2]|0)>>>0){ed()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[131008>>2]|0)>>>0){ed()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[131012>>2]|0)){J=f;break}c[131e3>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=131032+(C<<2)|0;G=c[32748]|0;j=1<<t;do{if((G&j|0)==0){c[32748]=G|j;K=131032+(C+2<<2)|0;L=e}else{t=131032+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[131008>>2]|0)>>>0)){K=t;L=a;break}ed()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=131296+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[130996>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[130996>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[131008>>2]|0;if(O>>>0<K>>>0){ed()}if(f>>>0<K>>>0){ed()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[131024>>2]|0)+ -1|0;c[131024>>2]=s;if((s|0)==0){Q=131448|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[131024>>2]=-1;i=b;return}function a_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=_Z(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}G_(b|0,0,e|0)|0;i=d;return b|0}function b_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=_Z(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=c_(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=_Z(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;E_(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;$Z(a);e=g;i=d;return e|0}function c_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[131008>>2]|0;if(h>>>0<l>>>0){ed()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){ed()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){ed()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[131472>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;d_(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[131016>>2]|0)){m=(c[131004>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[131016>>2]=a+b;c[131004>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[131012>>2]|0)){h=(c[131e3>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[131e3>>2]=r;c[131012>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=131032+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){ed()}if((c[h+12>>2]|0)==(k|0)){break}ed()}}while(0);if((m|0)==(h|0)){c[32748]=c[32748]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){ed()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}ed()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){ed()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){ed()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{ed()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=131296+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<u);break a}else{if(t>>>0<(c[131008>>2]|0)>>>0){ed()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[131008>>2]|0)>>>0){ed()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;d_(a+b|0,r);o=a;i=d;return o|0}return 0}function d_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[131008>>2]|0;if(j>>>0<m>>>0){ed()}if((k|0)==(c[131012>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[131e3>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=131032+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){ed()}if((c[q+12>>2]|0)==(k|0)){break}ed()}}while(0);if((r|0)==(q|0)){c[32748]=c[32748]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){ed()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}ed()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){ed()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){ed()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{ed()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=131296+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[131008>>2]|0)>>>0){ed()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[131008>>2]|0)>>>0){ed()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[131008>>2]|0;if(e>>>0<z>>>0){ed()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[131016>>2]|0)){t=(c[131004>>2]|0)+p|0;c[131004>>2]=t;c[131016>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[131012>>2]|0)){i=d;return}c[131012>>2]=0;c[131e3>>2]=0;i=d;return}if((f|0)==(c[131012>>2]|0)){t=(c[131e3>>2]|0)+p|0;c[131e3>>2]=t;c[131012>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=131032+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){ed()}if((c[u+12>>2]|0)==(f|0)){break}ed()}}while(0);if((h|0)==(u|0)){c[32748]=c[32748]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){ed()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}ed()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){ed()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){ed()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){ed()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{ed()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=131296+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[130996>>2]=c[130996>>2]&~(1<<j);break b}else{if(m>>>0<(c[131008>>2]|0)>>>0){ed()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[131008>>2]|0)>>>0){ed()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[131008>>2]|0)>>>0){ed()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[131012>>2]|0)){G=t;break}c[131e3>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=131032+(B<<2)|0;D=c[32748]|0;b=1<<p;do{if((D&b|0)==0){c[32748]=D|b;H=131032+(B+2<<2)|0;I=A}else{p=131032+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[131008>>2]|0)>>>0)){H=p;I=a;break}ed()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=131296+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[130996>>2]|0;B=1<<J;if((a&B|0)==0){c[130996>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[131008>>2]|0)>>>0){ed()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[131008>>2]|0;if(L>>>0<B>>>0){ed()}if(G>>>0<B>>>0){ed()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function e_(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=_Z(d)|0;if((e|0)!=0){f=6;break}a=c[32872]|0;c[32872]=0+a;if((a|0)==0){f=5;break}Ae[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=131504;Od(d|0,131552,136)}else if((f|0)==6){i=b;return e|0}return 0}function f_(a){a=a|0;var b=0,c=0;b=i;c=e_(a)|0;i=b;return c|0}function g_(a){a=a|0;var b=0;b=i;if((a|0)!=0){$Z(a)}i=b;return}function h_(a){a=a|0;var b=0;b=i;g_(a);i=b;return}function i_(a){a=a|0;var b=0;b=i;zb(a|0);g_(a);i=b;return}function j_(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function k_(a){a=a|0;i=i;return 131520}function l_(){var a=0;a=Ec(4)|0;c[a>>2]=131504;Od(a|0,131552,136)}function m_(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0.0,xc=0,yc=0,Ac=0.0,Bc=0.0,Cc=0.0,Dc=0.0,Ec=0.0,Fc=0.0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0.0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=p_(b)|0}}while((gd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=p_(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[131568+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=p_(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[131584+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=p_(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=p_(b)|0}if((B|0)==40){C=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0}else{D=p_(b)|0}if(!((D+ -48|0)>>>0<10|(D+ -65|0)>>>0<26)){if(!((D+ -97|0)>>>0<26|(D|0)==95)){break}}C=C+1|0}if((D|0)==41){l=+y;i=g;return+l}o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;o_(b,0);l=0.0;i=g;return+l}if((C|0)==0|o){l=+y;i=g;return+l}else{E=C}while(1){o=E+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((o|0)==0){l=+y;break}else{E=o}}i=g;return+l}else if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=d[o]|0}else{F=p_(b)|0}if((F|32|0)!=120){if((c[m>>2]|0)==0){G=48;break}c[e>>2]=(c[e>>2]|0)+ -1;G=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=0}else{H=p_(b)|0;I=0}while(1){if((H|0)==46){v=70;break}else if((H|0)!=48){K=0;L=0;M=0;N=0;O=H;P=I;Q=0;R=0;S=1.0;T=0;V=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=1;continue}else{H=p_(b)|0;I=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;W=d[o]|0}else{W=p_(b)|0}if((W|0)==48){X=-1;Y=-1}else{K=0;L=0;M=0;N=0;O=W;P=I;Q=1;R=0;S=1.0;T=0;V=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;Z=d[o]|0}else{Z=p_(b)|0}if((Z|0)!=48){K=X;L=Y;M=0;N=0;O=Z;P=1;Q=1;R=0;S=1.0;T=0;V=0.0;break b}o=M_(X|0,Y|0,-1,-1)|0;X=o;Y=J}}}while(0);c:while(1){o=O+ -48|0;do{if(o>>>0<10){_=o;v=84}else{q=O|32;n=(O|0)==46;if(!((q+ -97|0)>>>0<6|n)){$=O;break c}if(n){if((Q|0)==0){aa=M;ba=N;ca=M;da=N;ea=P;ga=1;ha=R;ia=S;ja=T;ka=V;break}else{$=46;break c}}else{_=(O|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((N|0)<0|(N|0)==0&M>>>0<8){la=R;ma=S;na=_+(T<<4)|0;oa=V}else{if((N|0)<0|(N|0)==0&M>>>0<14){pa=S*.0625;la=R;ma=pa;na=T;oa=V+pa*+(_|0);break}if(!((_|0)!=0&(R|0)==0)){la=R;ma=S;na=T;oa=V;break}la=1;ma=S;na=T;oa=V+S*.5}}while(0);o=M_(M|0,N|0,1,0)|0;aa=K;ba=L;ca=o;da=J;ea=1;ga=Q;ha=la;ia=ma;ja=na;ka=oa}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=ba;M=ca;N=da;O=d[o]|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}else{K=aa;L=ba;M=ca;N=da;O=p_(b)|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}}if((P|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){o_(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((Q|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(Q|0)==0;q=o?M:K;n=o?N:L;if((N|0)<0|(N|0)==0&M>>>0<8){o=M;p=N;qa=T;while(1){ra=qa<<4;sa=M_(o|0,p|0,1,0)|0;ta=J;if((ta|0)<0|(ta|0)==0&sa>>>0<8){qa=ra;p=ta;o=sa}else{ua=ra;break}}}else{ua=T}do{if(($|32|0)==112){o=n_(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){va=o;wa=p;break}if(u){o_(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0;break}}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0}}while(0);p=H_(q|0,n|0,2)|0;o=M_(p|0,J|0,-32,-1)|0;p=M_(o|0,J|0,va|0,wa|0)|0;o=J;if((ua|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}qa=k+ -106|0;ra=((qa|0)<0)<<31>>31;if((o|0)<(ra|0)|(o|0)==(ra|0)&p>>>0<qa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((ua|0)>-1){qa=p;ra=o;sa=ua;pa=V;while(1){ta=sa<<1;if(!(pa>=.5)){xa=pa;ya=ta}else{xa=pa+-1.0;ya=ta|1}za=pa+xa;ta=M_(qa|0,ra|0,-1,-1)|0;Aa=J;if((ya|0)>-1){qa=ta;ra=Aa;sa=ya;pa=za}else{Ba=ta;Ca=Aa;Da=ya;Ea=za;break}}}else{Ba=p;Ca=o;Da=ua;Ea=V}sa=L_(32,0,k|0,((k|0)<0)<<31>>31|0)|0;ra=M_(Ba|0,Ca|0,sa|0,J|0)|0;sa=J;if(0>(sa|0)|0==(sa|0)&j>>>0>ra>>>0){Fa=(ra|0)<0?0:ra}else{Fa=j}do{if((Fa|0)<53){pa=+(r|0);za=+Md(+(+q_(1.0,84-Fa|0)),+pa);if(!((Fa|0)<32&Ea!=0.0)){Ga=pa;Ha=za;Ia=Da;Ja=Ea;break}ra=Da&1;Ga=pa;Ha=za;Ia=(ra^1)+Da|0;Ja=(ra|0)==0?0.0:Ea}else{Ga=+(r|0);Ha=0.0;Ia=Da;Ja=Ea}}while(0);za=Ga*Ja+(Ha+Ga*+(Ia>>>0))-Ha;if(!(za!=0.0)){c[(Nc()|0)>>2]=34}l=+r_(za,Ba);i=g;return+l}else{G=w}}while(0);o=k+j|0;p=0-o|0;ra=G;sa=0;while(1){if((ra|0)==46){v=139;break}else if((ra|0)!=48){Ka=ra;La=0;Ma=0;Na=sa;Oa=0;break}qa=c[e>>2]|0;if(qa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=qa+1;ra=d[qa]|0;sa=1;continue}else{ra=p_(b)|0;sa=1;continue}}d:do{if((v|0)==139){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Pa=d[ra]|0}else{Pa=p_(b)|0}if((Pa|0)==48){Qa=-1;Ra=-1}else{Ka=Pa;La=0;Ma=0;Na=sa;Oa=1;break}while(1){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Sa=d[ra]|0}else{Sa=p_(b)|0}if((Sa|0)!=48){Ka=Sa;La=Qa;Ma=Ra;Na=1;Oa=1;break d}ra=M_(Qa|0,Ra|0,-1,-1)|0;Qa=ra;Ra=J}}}while(0);sa=h;c[sa>>2]=0;ra=Ka+ -48|0;qa=(Ka|0)==46;e:do{if(ra>>>0<10|qa){n=h+496|0;q=Ka;Aa=qa;ta=ra;Ta=0;Ua=0;Va=La;Wa=Ma;Xa=Na;Ya=Oa;Za=0;_a=0;$a=0;while(1){do{if(Aa){if((Ya|0)==0){ab=Ta;bb=Ua;cb=Ta;db=Ua;eb=Xa;fb=1;gb=Za;hb=_a;ib=$a}else{jb=q;kb=Ta;lb=Ua;mb=Va;nb=Wa;ob=Xa;pb=Za;qb=_a;rb=$a;break e}}else{sb=M_(Ta|0,Ua|0,1,0)|0;tb=J;ub=(q|0)!=48;if((_a|0)>=125){if(!ub){ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}c[n>>2]=c[n>>2]|1;ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}vb=h+(_a<<2)|0;if((Za|0)==0){wb=ta}else{wb=q+ -48+((c[vb>>2]|0)*10|0)|0}c[vb>>2]=wb;vb=Za+1|0;xb=(vb|0)==9;ab=Va;bb=Wa;cb=sb;db=tb;eb=1;fb=Ya;gb=xb?0:vb;hb=(xb&1)+_a|0;ib=ub?sb:$a}}while(0);sb=c[e>>2]|0;if(sb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=sb+1;yb=d[sb]|0}else{yb=p_(b)|0}sb=yb+ -48|0;ub=(yb|0)==46;if(sb>>>0<10|ub){q=yb;Aa=ub;ta=sb;Ta=cb;Ua=db;Va=ab;Wa=bb;Xa=eb;Ya=fb;Za=gb;_a=hb;$a=ib}else{zb=yb;Ab=cb;Bb=db;Cb=ab;Db=bb;Eb=eb;Fb=fb;Gb=gb;Hb=hb;Ib=ib;v=162;break}}}else{zb=Ka;Ab=0;Bb=0;Cb=La;Db=Ma;Eb=Na;Fb=Oa;Gb=0;Hb=0;Ib=0;v=162}}while(0);if((v|0)==162){ra=(Fb|0)==0;jb=zb;kb=Ab;lb=Bb;mb=ra?Ab:Cb;nb=ra?Bb:Db;ob=Eb;pb=Gb;qb=Hb;rb=Ib}ra=(ob|0)!=0;do{if(ra){if((jb|32|0)!=101){v=171;break}qa=n_(b,f)|0;$a=J;do{if((qa|0)==0&($a|0)==-2147483648){if(u){o_(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Jb=0;Kb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Jb=0;Kb=0;break}}else{Jb=qa;Kb=$a}}while(0);$a=M_(Jb|0,Kb|0,mb|0,nb|0)|0;Lb=$a;Mb=J}else{v=171}}while(0);do{if((v|0)==171){if(!((jb|0)>-1)){Lb=mb;Mb=nb;break}if((c[m>>2]|0)==0){Lb=mb;Mb=nb;break}c[e>>2]=(c[e>>2]|0)+ -1;Lb=mb;Mb=nb}}while(0);if(!ra){c[(Nc()|0)>>2]=22;o_(b,0);l=0.0;i=g;return+l}u=c[sa>>2]|0;if((u|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Lb|0)==(kb|0)&(Mb|0)==(lb|0)&((lb|0)<0|(lb|0)==0&kb>>>0<10)){if(!(j>>>0>30)){if((u>>>j|0)!=0){break}}l=+(r|0)*+(u>>>0);i=g;return+l}}while(0);u=(k|0)/-2|0;ra=((u|0)<0)<<31>>31;if((Mb|0)>(ra|0)|(Mb|0)==(ra|0)&Lb>>>0>u>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}u=k+ -106|0;ra=((u|0)<0)<<31>>31;if((Mb|0)<(ra|0)|(Mb|0)==(ra|0)&Lb>>>0<u>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((pb|0)==0){Nb=qb}else{if((pb|0)<9){u=h+(qb<<2)|0;ra=c[u>>2]|0;$a=pb;do{ra=ra*10|0;$a=$a+1|0;}while(($a|0)<9);c[u>>2]=ra}Nb=qb+1|0}do{if((rb|0)<9){if(!((rb|0)<=(Lb|0)&(Lb|0)<18)){break}if((Lb|0)==9){l=+(r|0)*+((c[sa>>2]|0)>>>0);i=g;return+l}if((Lb|0)<9){l=+(r|0)*+((c[sa>>2]|0)>>>0)/+(c[131600+(8-Lb<<2)>>2]|0);i=g;return+l}$a=j+27+(fa(Lb,-3)|0)|0;qa=c[sa>>2]|0;if(($a|0)<=30){if((qa>>>$a|0)!=0){break}}l=+(r|0)*+(qa>>>0)*+(c[131600+(Lb+ -10<<2)>>2]|0);i=g;return+l}}while(0);sa=(Lb|0)%9|0;if((sa|0)==0){Ob=0;Pb=0;Qb=Lb;Rb=Nb}else{ra=(Lb|0)>-1?sa:sa+9|0;sa=c[131600+(8-ra<<2)>>2]|0;do{if((Nb|0)==0){Sb=0;Tb=Lb;Ub=0}else{u=1e9/(sa|0)|0;qa=0;$a=0;_a=0;Za=Lb;while(1){Ya=h+(_a<<2)|0;Xa=c[Ya>>2]|0;Wa=((Xa>>>0)/(sa>>>0)|0)+$a|0;c[Ya>>2]=Wa;Vb=fa((Xa>>>0)%(sa>>>0)|0,u)|0;Xa=_a+1|0;if((_a|0)==(qa|0)&(Wa|0)==0){Wb=Xa&127;Xb=Za+ -9|0}else{Wb=qa;Xb=Za}if((Xa|0)==(Nb|0)){break}else{qa=Wb;Za=Xb;_a=Xa;$a=Vb}}if((Vb|0)==0){Sb=Wb;Tb=Xb;Ub=Nb;break}c[h+(Nb<<2)>>2]=Vb;Sb=Wb;Tb=Xb;Ub=Nb+1|0}}while(0);Ob=Sb;Pb=0;Qb=9-ra+Tb|0;Rb=Ub}f:while(1){sa=h+(Ob<<2)|0;if((Qb|0)<18){$a=Pb;_a=Rb;while(1){Za=0;qa=_a+127|0;u=_a;while(1){Xa=qa&127;Wa=h+(Xa<<2)|0;Ya=H_(c[Wa>>2]|0,0,29)|0;Va=M_(Ya|0,J|0,Za|0,0)|0;Ya=J;if(Ya>>>0>0|(Ya|0)==0&Va>>>0>1e9){Ua=W_(Va|0,Ya|0,1e9,0)|0;Ta=X_(Va|0,Ya|0,1e9,0)|0;Yb=Ta;Zb=Ua}else{Yb=Va;Zb=0}c[Wa>>2]=Yb;Wa=(Xa|0)==(Ob|0);if((Xa|0)!=(u+127&127|0)|Wa){_b=u}else{_b=(Yb|0)==0?Xa:u}if(Wa){break}else{Za=Zb;qa=Xa+ -1|0;u=_b}}u=$a+ -29|0;if((Zb|0)==0){$a=u;_a=_b}else{$b=u;ac=Zb;bc=_b;break}}}else{if((Qb|0)==18){cc=Pb;dc=Rb}else{ec=Ob;fc=Pb;gc=Qb;hc=Rb;break}while(1){if(!((c[sa>>2]|0)>>>0<9007199)){ec=Ob;fc=cc;gc=18;hc=dc;break f}_a=0;$a=dc+127|0;u=dc;while(1){qa=$a&127;Za=h+(qa<<2)|0;Xa=H_(c[Za>>2]|0,0,29)|0;Wa=M_(Xa|0,J|0,_a|0,0)|0;Xa=J;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=W_(Wa|0,Xa|0,1e9,0)|0;Ua=X_(Wa|0,Xa|0,1e9,0)|0;ic=Ua;jc=Va}else{ic=Wa;jc=0}c[Za>>2]=ic;Za=(qa|0)==(Ob|0);if((qa|0)!=(u+127&127|0)|Za){kc=u}else{kc=(ic|0)==0?qa:u}if(Za){break}else{_a=jc;$a=qa+ -1|0;u=kc}}u=cc+ -29|0;if((jc|0)==0){cc=u;dc=kc}else{$b=u;ac=jc;bc=kc;break}}}sa=Ob+127&127;if((sa|0)==(bc|0)){u=bc+127&127;$a=h+((bc+126&127)<<2)|0;c[$a>>2]=c[$a>>2]|c[h+(u<<2)>>2];lc=u}else{lc=bc}c[h+(sa<<2)>>2]=ac;Ob=sa;Pb=$b;Qb=Qb+9|0;Rb=lc}g:while(1){mc=hc+1&127;ra=h+((hc+127&127)<<2)|0;sa=ec;u=fc;$a=gc;while(1){_a=($a|0)==18;qa=($a|0)>27?9:1;nc=sa;oc=u;while(1){Za=0;while(1){Wa=Za+nc&127;if((Wa|0)==(hc|0)){pc=2;break}Va=c[h+(Wa<<2)>>2]|0;Wa=c[131592+(Za<<2)>>2]|0;if(Va>>>0<Wa>>>0){pc=2;break}Ua=Za+1|0;if(Va>>>0>Wa>>>0){pc=Za;break}if((Ua|0)<2){Za=Ua}else{pc=Ua;break}}if((pc|0)==2&_a){break g}qc=qa+oc|0;if((nc|0)==(hc|0)){nc=hc;oc=qc}else{break}}_a=(1<<qa)+ -1|0;Za=1e9>>>qa;rc=nc;sc=0;Ua=nc;tc=$a;do{Wa=h+(Ua<<2)|0;Va=c[Wa>>2]|0;Xa=(Va>>>qa)+sc|0;c[Wa>>2]=Xa;sc=fa(Va&_a,Za)|0;Va=(Ua|0)==(rc|0)&(Xa|0)==0;Ua=Ua+1&127;tc=Va?tc+ -9|0:tc;rc=Va?Ua:rc;}while((Ua|0)!=(hc|0));if((sc|0)==0){sa=rc;u=qc;$a=tc;continue}if((mc|0)!=(rc|0)){break}c[ra>>2]=c[ra>>2]|1;sa=rc;u=qc;$a=tc}c[h+(hc<<2)>>2]=sc;ec=rc;fc=qc;gc=tc;hc=mc}$a=nc&127;if(($a|0)==(hc|0)){c[h+(mc+ -1<<2)>>2]=0;uc=mc}else{uc=hc}za=+((c[h+($a<<2)>>2]|0)>>>0);$a=nc+1&127;if(($a|0)==(uc|0)){u=uc+1&127;c[h+(u+ -1<<2)>>2]=0;vc=u}else{vc=uc}pa=+(r|0);wc=pa*(za*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=oc+53|0;u=$a-k|0;if((u|0)<(j|0)){xc=(u|0)<0?0:u;yc=1}else{xc=j;yc=0}if((xc|0)<53){za=+Md(+(+q_(1.0,105-xc|0)),+wc);Ac=+zc(+wc,+(+q_(1.0,53-xc|0)));Bc=za;Cc=Ac;Dc=za+(wc-Ac)}else{Bc=0.0;Cc=0.0;Dc=wc}sa=nc+2&127;do{if((sa|0)==(vc|0)){Ec=Cc}else{ra=c[h+(sa<<2)>>2]|0;do{if(ra>>>0<5e8){if((ra|0)==0){if((nc+3&127|0)==(vc|0)){Fc=Cc;break}}Fc=pa*.25+Cc}else{if(ra>>>0>5e8){Fc=pa*.75+Cc;break}if((nc+3&127|0)==(vc|0)){Fc=pa*.5+Cc;break}else{Fc=pa*.75+Cc;break}}}while(0);if((53-xc|0)<=1){Ec=Fc;break}if(+zc(+Fc,1.0)!=0.0){Ec=Fc;break}Ec=Fc+1.0}}while(0);pa=Dc+Ec-Bc;do{if(($a&2147483647|0)>(-2-o|0)){if(!(+U(+pa)>=9007199254740992.0)){Gc=yc;Hc=oc;Ic=pa}else{Gc=(yc|0)!=0&(xc|0)==(u|0)?0:yc;Hc=oc+1|0;Ic=pa*.5}if((Hc+50|0)<=(p|0)){if(!((Gc|0)!=0&Ec!=0.0)){Jc=Hc;Kc=Ic;break}}c[(Nc()|0)>>2]=34;Jc=Hc;Kc=Ic}else{Jc=oc;Kc=pa}}while(0);l=+r_(Kc,Jc);i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;o_(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function n_(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=p_(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=p_(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=p_(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=V_(q|0,m|0,10,0)|0;b=J;g=M_(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=M_(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=p_(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=p_(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=L_(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function o_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function p_(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=t_(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function q_(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=H_(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function r_(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+q_(a,b);i=c;return+d}function s_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ge[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function t_(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((s_(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ge[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function u_(a){a=a|0;var b=0,c=0.0;b=i;c=+v_(a,0);i=b;return+c}function v_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;o_(e,0);h=+m_(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function w_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;o_(e,0);h=+m_(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function x_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function y_(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function z_(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function A_(){c[27976]=p;c[28018]=p;c[32660]=p;c[32890]=p}function B_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}ec(116);ec(111);ec(111);ec(32);ec(109);ec(97);ec(110);ec(121);ec(32);ec(115);ec(101);ec(116);ec(106);ec(109);ec(112);ec(115);ec(32);ec(105);ec(110);ec(32);ec(97);ec(32);ec(102);ec(117);ec(110);ec(99);ec(116);ec(105);ec(111);ec(110);ec(32);ec(99);ec(97);ec(108);ec(108);ec(44);ec(32);ec(98);ec(117);ec(105);ec(108);ec(100);ec(32);ec(119);ec(105);ec(116);ec(104);ec(32);ec(97);ec(32);ec(104);ec(105);ec(103);ec(104);ec(101);ec(114);ec(32);ec(118);ec(97);ec(108);ec(117);ec(101);ec(32);ec(102);ec(111);ec(114);ec(32);ec(77);ec(65);ec(88);ec(95);ec(83);ec(69);ec(84);ec(74);ec(77);ec(80);ec(83);ec(10);ga(0);return 0}function C_(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function D_(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function E_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function F_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{E_(b,c,d)|0}return b|0}function G_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function H_(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function I_(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function J_(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function K_(){return J_(o)|0}function L_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function M_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function N_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function O_(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function P_(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Q_(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function R_(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function S_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function T_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=L_(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=L_((Y_(i,b,L_(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function U_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=L_(h^a,j^b,h,j)|0;b=J;Y_(m,b,L_(k^d,l^e,k,l)|0,J,g)|0;l=L_(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function V_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=S_(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function W_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Y_(a,b,c,d,0)|0;return(J=J,e)|0}function X_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Y_(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function Y_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((R_(l|0)|0)>>>0);return(J=n,o)|0}p=(Q_(l|0)|0)-(Q_(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Q_(l|0)|0)-(Q_(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Q_(j|0)|0)+33-(Q_(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=R_(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=M_(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;L_(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=L_(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function Z_(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Yd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function __(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Zd[a&31](b|0,c|0,d|0,e|0,f|0)}function $_(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return _d[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function a$(a,b){a=a|0;b=+b;$d[a&1](+b)}function b$(a,b){a=a|0;b=b|0;ae[a&255](b|0)}function c$(a,b,c){a=a|0;b=b|0;c=c|0;be[a&63](b|0,c|0)}function d$(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ce[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function e$(a,b){a=a|0;b=b|0;return de[a&127](b|0)|0}function f$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ee[a&1](b|0,c|0,+d,e|0)}function g$(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return fe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function h$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ge[a&63](b|0,c|0,d|0)|0}function i$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return he[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function j$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ie[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function k$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;je[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function l$(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ke[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function m$(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return le[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function n$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;me[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function o$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ne[a&3](b|0,c|0,+d,e|0,f|0)}function p$(a,b,c){a=a|0;b=b|0;c=+c;return oe[a&1](b|0,+c)|0}function q$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;pe[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function r$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;qe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function s$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;re[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function t$(a,b,c){a=a|0;b=b|0;c=c|0;return se[a&63](b|0,c|0)|0}function u$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return te[a&63](b|0,c|0,d|0,e|0,f|0)|0}function v$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ue[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function w$(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+ve[a&1](b|0,+c,+d)}function x$(a,b,c){a=a|0;b=b|0;c=c|0;return+we[a&1](b|0,c|0)}function y$(a){a=a|0;return xe[a&7]()|0}function z$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return ye[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function A$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ze[a&15](b|0,c|0,d|0)}function B$(a){a=a|0;Ae[a&7]()}function C$(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Be[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function D$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ce[a&63](b|0,c|0,d|0,e|0)|0}function E$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;De[a&31](b|0,c|0,d|0,e|0)}function F$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function G$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function H$(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function I$(a){a=+a;ga(3)}function J$(a){a=a|0;ga(4)}function K$(a){a=a|0;xd(a|0)}function L$(a,b){a=a|0;b=b|0;ga(5)}function M$(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function N$(a){a=a|0;ga(7);return 0}function O$(a){a=a|0;return Oc(a|0)|0}function P$(a){a=a|0;return Gd(a|0)|0}function Q$(a){a=a|0;return wc(a|0)|0}function R$(a){a=a|0;return vd(a|0)|0}function S$(a){a=a|0;return id(a|0)|0}function T$(a){a=a|0;return qd(a|0)|0}function U$(a){a=a|0;return Xc(a|0)|0}function V$(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function W$(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function X$(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function Y$(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function Z$(a,b,c){a=a|0;b=b|0;c=c|0;return ic(a|0,b|0,c|0)|0}function _$(a,b,c){a=a|0;b=b|0;c=c|0;return cc(a|0,b|0,c|0)|0}function $$(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function a0(a,b,c){a=a|0;b=b|0;c=c|0;return td(a|0,b|0,c|0)|0}function b0(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function c0(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function d0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function e0(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function f0(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function g0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function h0(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function i0(a,b){a=a|0;b=+b;ga(18);return 0}function j0(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function k0(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function l0(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function m0(a,b){a=a|0;b=b|0;ga(22);return 0}function n0(a,b){a=a|0;b=b|0;return Ld(a|0,b|0)|0}function o0(a,b){a=a|0;b=b|0;return hc(a|0,b|0)|0}function p0(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function q0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function r0(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function s0(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function t0(a,b){a=a|0;b=b|0;ga(26);return 0.0}function u0(){ga(27);return 0}function v0(){return jb()|0}function w0(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function x0(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function y0(){ga(30)}function z0(){Uc()}function A0(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function B0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function C0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function D0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function E0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var Yd=[F$,Xx,Zx,cy,bN,F$,F$,F$];var Zd=[G$,rs,ss,Xs,Ys,At,Bt,Yt,Zt,_t,WZ,VZ,UZ,zw,Lr,Mr,vv,tv,G$,G$,G$,G$,G$,G$,G$,G$,G$,G$,G$,G$,G$,G$];var _d=[H$,Dz];var $d=[I$,Jy];var ae=[J$,rk,sk,Bk,Ck,Wm,Ek,qv,PB,SB,RB,TB,$R,_R,bS,aS,UB,WB,gF,EF,FF,GF,MR,LR,OR,NR,nM,zM,MM,NM,OM,QM,SM,IO,JO,PO,QO,WO,XO,bP,cP,oP,nP,tP,sP,vP,wP,FP,EP,MQ,LQ,VQ,UQ,xR,wR,VR,UR,XR,WR,nS,mS,pS,oS,vS,uS,KQ,wS,tS,xS,zS,yS,HW,FS,ES,KS,JS,hT,gT,LT,KT,ZT,YT,lU,kU,zU,yU,MU,LU,PU,OU,TU,SU,cV,bV,nV,mV,yV,xV,JV,IV,TV,SV,$V,_V,fW,eW,lW,kW,qW,pW,zW,yW,XW,WW,uW,mX,TX,SX,VX,UX,AS,GW,JW,eX,uX,FX,QX,RX,HZ,GZ,JZ,MZ,KZ,LZ,NZ,OZ,j_,i_,Lg,K$,Ze,$e,af,bf,cf,df,ef,ff,gf,hf,kf,lf,mf,of,pf,qf,rf,sf,tf,uf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,If,Lf,Yf,Zf,_f,$f,ag,eg,fg,mg,ng,rg,sg,tg,ug,vg,wg,xg,yg,zg,Ag,Bg,Cg,Dg,Eg,Fg,Gg,$Z,sv,Ue,ty,xy,sy,Gz,zy,Ez,Vw,Cy,Ay,By,yy,Ey,Fz,Fy,uy,Hy,iM,Iy,gO,HO,IW,BY,LV,IY,HY,GY,FY,EY,DY,VP,xQ,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$,J$];var be=[L$,Dk,lA,XB,kR,KO,RO,YO,dP,yR,WU,XU,YU,ZU,$U,aV,fV,gV,hV,iV,kV,lV,qV,rV,sV,tV,vV,wV,BV,CV,DV,EV,GV,HV,oW,tW,_X,aY,cY,$X,bY,dY,ky,tk,vk,xk,zk,Dy,OE,nA,mA,oA,uA,GA,pA,EA,bE,nE,mE,oE,YD,WD,_D,pN];var ce=[M$,_r,Tr,Yx,_x,$x,ay,by];var de=[N$,Ig,Bo,Hg,We,Xe,Ye,Xm,Ym,Kk,Vm,Ao,Hp,Jk,Hk,Ip,Jp,Qp,Rp,Sp,Tp,Up,Vp,Wp,Xp,O$,P$,Q$,Rv,_Z,R$,$B,pR,aC,sR,oR,VM,LO,DR,FR,GR,CR,SO,TO,ZO,rR,eP,fP,pP,uP,rS,mU,eY,gY,iY,oY,qY,kY,mY,AU,fY,hY,jY,pY,rY,lY,nY,UU,VU,_U,dV,eV,jV,oV,pV,uV,zV,AV,FV,qX,rX,tX,WX,YX,XX,ZX,iX,jX,lX,AX,BX,EX,LX,MX,PX,IZ,k_,Nz,S$,T$,Lz,Mz,U$,bM,EM,My,Uy,bz,Ny,Xy,cz,zO,t_,N$,N$,N$,N$,N$,N$,N$,N$,N$,N$,N$,N$,N$,N$,N$];var ee=[V$,xw];var fe=[W$,Hx];var ge=[X$,Gk,is,os,Os,Us,rt,xt,YB,qR,uR,lR,zR,ER,MO,IR,_O,zP,AP,DS,IS,mW,rW,ZW,$W,cX,KW,PW,RW,UW,PZ,kM,yw,Xr,Or,Vr,$r,Y$,Z$,_$,Hz,hM,dM,$$,rO,a0,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$,X$];var he=[b0,Lx];var ie=[c0,dx];var je=[d0,TT,WT,fU,hU,d0,d0,d0];var ke=[e0,NU,QU,KV,OV,UV,WV,e0];var le=[f0,Fx];var me=[g0,nv,ZB,TM,AR,mR,MT,NT,RT,XT,_T,$T,dU,iU,nW,sW,ZZ,YZ,XZ,ov,g0,g0,g0,g0,g0,g0,g0,g0,g0,g0,g0,g0];var ne=[h0,Vy,Wy,h0];var oe=[i0,Kg];var pe=[j0,LS,NS,PS,RS,TS,VS,XS,ZS,$S,bT,dT,iT,kT,mT,oT,qT,sT,uT,wT,yT,AT,CT,QT,ST,cU,eU,nU,oU,pU,qU,rU,BU,CU,DU,EU,FU,dW,jW,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0,j0];var qe=[k0,aW,gW,k0];var re=[l0,sU,GU,l0];var se=[m0,Ve,Lk,Ik,Fk,Yp,Zp,ks,ls,ns,Qs,Rs,Ts,tt,ut,wt,Ct,Dt,Et,Ft,Gt,Ht,It,Jt,bC,cC,WM,XM,HR,NO,UO,JR,tR,$O,gP,vR,YW,_W,aX,OW,QW,SW,vz,ez,Yy,Oy,dz,n0,b_,Ir,Jr,Kr,o0,ew,Ry,rz,iz,Ty,p0,sZ,m0,m0,m0,m0];var te=[q0,BS,GS,dX,pX,sX,VW,hX,kX,zX,CX,KX,NX,eu,Xu,Yu,ju,gu,Vu,Wu,ku,lu,mu,nu,ou,Lu,Mu,Cu,vu,qu,pu,ru,su,uu,tu,hu,fu,wu,xu,yu,zu,Au,Bu,Du,Eu,Fu,Gu,Ku,Iu,Hu,Ju,Ru,Nu,Ou,Pu,Qu,Su,Tu,Uu,Zu,_u,$u,av,OT];var ue=[r0,Sz];var ve=[s0,fz];var we=[t0,nx];var xe=[u0,$p,v0,Sv,EO,FO,CO,u0];var ye=[w0,Kx];var ze=[x0,mM,yP,sS,sw,Fv,yv,gA,iA,NE,oN,x0,x0,x0,x0,x0];var Ae=[y0,z0,Qv,dv,Ng,y0,y0,y0];var Be=[A0,_p,nX,oX,fX,gX,vX,xX,GX,IX,jz,A0,A0,A0,A0,A0];var Ce=[B0,cs,ds,es,fs,gs,hs,js,ms,qs,Is,Js,Ks,Ls,Ms,Ns,Ps,Ss,Ws,lt,mt,nt,ot,pt,qt,st,vt,zt,bX,LW,MW,NW,TW,my,C0,Dv,Gx,Ar,Dq,Yq,fr,Tq,or,tr,rr,ur,as,Gr,Qr,Rr,Yr,Zr,fT,UT,D0,B0,B0,B0,B0,B0,B0,B0,B0,B0];var De=[E0,ps,Vs,yt,_B,lM,UM,BR,nR,CS,HS,QZ,RZ,SZ,wv,uv,oy,xv,Cv,uk,wk,yk,Ak,JN,Sr,zv,E0,E0,E0,E0,E0,E0];return{_testSetjmp:P_,_saveSetjmp:B_,_free:$Z,_main:Mg,_rand_r:J_,_realloc:b_,_i64Add:M_,_memmove:F_,_bitshift64Ashr:D_,_memset:G_,_malloc:_Z,_strncpy:N_,_memcpy:E_,_strlen:C_,_bitshift64Lshr:O_,_bitshift64Shl:H_,_i64Subtract:L_,_strcpy:I_,_calloc:a_,_rand:K_,__GLOBAL__I_a:iP,runPostSets:A_,stackAlloc:Ee,stackSave:Fe,stackRestore:Ge,setThrew:He,setTempRet0:Ke,setTempRet1:Le,setTempRet2:Me,setTempRet3:Ne,setTempRet4:Oe,setTempRet5:Pe,setTempRet6:Qe,setTempRet7:Re,setTempRet8:Se,setTempRet9:Te,dynCall_iiiiiiii:Z_,dynCall_viiiii:__,dynCall_iiiiidiii:$_,dynCall_vd:a$,dynCall_vi:b$,dynCall_vii:c$,dynCall_iiiiiiiiiii:d$,dynCall_ii:e$,dynCall_viidi:f$,dynCall_iiiiiiiiiiiiii:g$,dynCall_iiii:h$,dynCall_iiiiiiiiiiiiiiiiiiiiiii:i$,dynCall_iiiiiiiiiiiiiiiiiiiii:j$,dynCall_viiiiid:k$,dynCall_viiiiiiii:l$,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:m$,dynCall_viiiiii:n$,dynCall_viidii:o$,dynCall_iid:p$,dynCall_viiiiiii:q$,dynCall_viiiiiid:r$,dynCall_viiiiiiiii:s$,dynCall_iii:t$,dynCall_iiiiii:u$,dynCall_iiiiidi:v$,dynCall_didd:w$,dynCall_dii:x$,dynCall_i:y$,dynCall_iiiiiiiiii:z$,dynCall_viii:A$,dynCall_v:B$,dynCall_iiiiiiiii:C$,dynCall_iiiii:D$,dynCall_viiii:E$}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_atan2": _atan2, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_acos": _acos, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






