var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 121456;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 121496;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(122323);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,120,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,42,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,0,0,0,0,0,0,0,0,1,0,0,0,121,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,50,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,51,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,52,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,53,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,54,93,32,47,32,48,46,48,49,54,48,52,50,52,54,0,1,0,0,0,123,0,0,0,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,143,0,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,153,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,0,0,0,0,0,0,0,1,0,0,0,161,0,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,162,0,0,0,1,0,0,0,163,0,0,0,1,0,0,0,164,0,0,0,1,0,0,0,165,0,0,0,1,0,0,0,166,0,0,0,1,0,0,0,170,0,0,0,10,84,101,109,112,101,114,97,116,117,114,101,32,84,32,40,61,0,0,0,0,0,0,0,32,75,32,61,32,50,48,48,32,75,41,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,50,48,48,32,75,32,60,61,32,84,32,60,61,32,54,48,48,48,32,75,10,114,101,113,117,105,114,101,100,32,102,114,111,109,32,109,101,100,105,117,109,32,109,111,100,101,108,32,34,0,0,0,0,0,0,0,83,105,109,112,108,101,78,97,116,117,114,97,108,71,97,115,0,0,0,0,0,0,0,0,34,46,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,73,100,101,97,108,71,97,115,101,115,47,67,111,109,109,111,110,47,112,97,99,107,97,103,101,46,109,111,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,49,93,32,61,32,0,0,0,111,102,32,115,117,98,115,116,97,110,99,101,32,0,0,0,77,101,116,104,97,110,101,0,10,111,102,32,109,101,100,105,117,109,32,0,0,0,0,0,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,114,97,110,103,101,32,48,46,46,49,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,50,93,32,61,32,0,0,0,69,116,104,97,110,101,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,51,93,32,61,32,0,0,0,80,114,111,112,97,110,101,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,52,93,32,61,32,0,0,0,78,45,66,117,116,97,110,101,44,0,0,0,0,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,53,93,32,61,32,0,0,0,78,105,116,114,111,103,101,110,0,0,0,0,0,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,54,93,32,61,32,0,0,0,67,97,114,98,111,110,100,105,111,120,105,100,101,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,200,5,0,0,128,2,0,0,5,0,0,0,131,2,0,0,53,0,0,0,0,0,0,0,128,6,0,0,74,17,0,0,11,0,0,0,77,17,0,0,41,0,0,0,0,0,0,0,128,6,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,77,101,100,105,97,84,101,115,116,77,111,100,101,108,115,46,73,100,101,97,108,71,97,115,101,115,46,83,105,109,112,108,101,78,97,116,117,114,97,108,71,97,115,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,0,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,69,120,97,109,112,108,101,115,46,84,101,115,116,115,46,77,101,100,105,97,84,101,115,116,77,111,100,101,108,115,46,73,100,101,97,108,71,97,115,101,115,46,83,105,109,112,108,101,78,97,116,117,114,97,108,71,97,115,95,105,110,102,111,46,120,109,108,0,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,67,72,52,0,0,0,0,0,67,50,72,54,0,0,0,0,67,51,72,56,0,0,0,0,67,52,72,49,48,95,110,95,98,117,116,97,110,101,0,0,78,50,0,0,0,0,0,0,67,79,50,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,8,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,94,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,0,0,0,1,0,0,0,94,0,0,0,1,0,0,0,171,0,0,0,1,0,0,0,171,0,0,0,192,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,45,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,50,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,51,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,51,93,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,52,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,52,93,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,53,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,53,93,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,54,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,54,93,0,192,12,0,0,232,12,0,0,16,13,0,0,56,13,0,0,96,13,0,0,136,13,0,0,176,13,0,0,216,13,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,27,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,51,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,52,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,53,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,54,93,32,47,32,48,46,48,49,54,48,52,50,52,54,0,0,0,0,0,0,0,1,0,0,0,30,0,0,0,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,51,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,52,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,53,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,54,93,32,47,32,48,46,48,49,54,48,52,50,52,54,0,0,0,1,0,0,0,35,0,0,0,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,42,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,0,0,0,0,1,0,0,0,48,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,50,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,51,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,52,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,53,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,54,93,32,47,32,48,46,48,49,54,48,52,50,52,54,0,1,0,0,0,56,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,42,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,0,0,0,0,0,0,0,0,1,0,0,0,58,0,0,0,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,60,0,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,84,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,0,0,0,0,0,0,0,1,0,0,0,86,0,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,87,0,0,0,1,0,0,0,88,0,0,0,1,0,0,0,89,0,0,0,1,0,0,0,90,0,0,0,1,0,0,0,91,0,0,0,1,0,0,0,93,0,0,0,1,0,0,0,95,0,0,0,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,32,94,32,50,46,48,0,0,0,0,0,0,0,40,45,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,41,32,42,32,68,73,86,73,83,73,79,78,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,44,32,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,32,94,32,50,46,48,41,0,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,216,0,0,0,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,51,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,52,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,53,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,54,93,32,47,32,48,46,48,49,54,48,52,50,52,54,0,0,0,0,0,0,0,1,0,0,0,231,0,0,0,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,51,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,52,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,53,93,32,47,32,48,46,48,49,54,48,52,50,52,54,32,43,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,54,93,32,47,32,48,46,48,49,54,48,52,50,52,54,0,0,0,1,0,0,0,235,0,0,0,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,42,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,32,22,0,0,107,13,0,0,9,0,0,0,108,13,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,100,112,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,22,0,0,105,13,0,0,9,0,0,0,106,13,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,54,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,53,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,52,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,51,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,88,95,97,109,98,105,101,110,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,22,0,0,40,13,0,0,9,0,0,0,42,13,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,104,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,22,0,0,36,13,0,0,9,0,0,0,39,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,22,0,0,31,13,0,0,9,0,0,0,35,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,100,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,22,0,0,25,13,0,0,9,0,0,0,27,13,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,22,0,0,22,13,0,0,9,0,0,0,24,13,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,54,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,53,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,52,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,51,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,88,95,97,109,98,105,101,110,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,22,0,0,206,12,0,0,9,0,0,0,207,12,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,104,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,22,0,0,202,12,0,0,9,0,0,0,205,12,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,32,22,0,0,197,12,0,0,9,0,0,0,201,12,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,22,0,0,191,12,0,0,9,0,0,0,192,12,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,54,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,53,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,52,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,51,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,22,0,0,117,12,0,0,9,0,0,0,119,12,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,22,0,0,113,12,0,0,9,0,0,0,116,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([32,22,0,0,108,12,0,0,9,0,0,0,112,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,100,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,22,0,0,102,12,0,0,9,0,0,0,104,12,0,0,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,22,0,0,99,12,0,0,9,0,0,0,101,12,0,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,22,0,0,176,13,0,0,9,0,0,0,177,13,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,22,0,0,174,13,0,0,9,0,0,0,175,13,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,22,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,22,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,22,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,32,22,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,64,47,0,0,252,11,0,0,9,0,0,0,253,11,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,64,47,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,51,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,52,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,53,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,54,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,64,47,0,0,31,17,0,0,7,0,0,0,32,17,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,64,47,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,64,47,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,64,47,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,64,47,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,64,47,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,64,47,0,0,125,12,0,0,9,0,0,0,125,12,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,51,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,52,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,53,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,54,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,64,47,0,0,126,12,0,0,9,0,0,0,127,12,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,64,47,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,105,120,101,100,77,97,115,115,70,108,111,119,82,97,116,101,46,112,111,114,116,46,109,88,105,95,102,108,111,119,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,64,47,0,0,255,11,0,0,9,0,0,0,0,12,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,51,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,52,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,53,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,53,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,54,93,32,62,61,32,48,46,48,32,97,110,100,32,97,109,98,105,101,110,116,46,112,111,114,116,46,88,105,91,54,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,64,47,0,0,4,12,0,0,9,0,0,0,5,12,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,72,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,64,47,0,0,1,12,0,0,9,0,0,0,2,12,0,0,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,52,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,53,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,53,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,53,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,54,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,54,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,112,111,114,116,95,98,46,109,88,105,95,102,108,111,119,91,54,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,64,47,0,0,6,12,0,0,9,0,0,0,7,12,0,0,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,115,104,111,114,116,80,105,112,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,64,47,0,0,118,13,0,0,9,0,0,0,119,13,0,0,87,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,84,101,115,116,115,95,77,101,100,105,97,84,101,115,116,77,111,100,101,108,115,95,73,100,101,97,108,71,97,115,101,115,95,83,105,109,112,108,101,78,97,116,117,114,97,108,71,97,115,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,56,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,56,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,56,44,56,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,56,44,48,93,32,61,32,122,101,114,111,115,40,56,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,56,93,32,61,32,122,101,114,111,115,40,48,44,56,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,56,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,49,114,66,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([117,109,80,88,105,108,66,50,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,51,114,66,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,52,114,66,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,53,114,66,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,54,114,66,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,84,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,112,32,61,32,120,91,56,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,100,105,97,95,69,120,97,109,112,108,101,115,95,84,101,115,116,115,95,77,101,100,105,97,84,101,115,116,77,111,100,101,108,115,95,73,100,101,97,108,71,97,115,101,115,95,83,105,109,112,108,101,78,97,116,117,114,97,108,71,97,115,59,10,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,84,0,0,208,84,0,0,224,84,0,0,248,84,0,0,24,85,0,0,40,85,0,0,64,85,0,0,80,85,0,0,104,85,0,0,136,85,0,0,176,85,0,0,200,85,0,0,232,85,0,0,0,86,0,0,40,86,0,0,72,86,0,0,120,86,0,0,168,86,0,0,192,86,0,0,248,86,0,0,16,87,0,0,64,87,0,0,96,87,0,0,152,87,0,0,192,87,0,0,248,87,0,0,40,88,0,0,56,88,0,0,88,88,0,0,128,88,0,0,160,88,0,0,200,88,0,0,240,88,0,0,8,89,0,0,32,89,0,0,48,89,0,0,72,89,0,0,120,89,0,0,200,89,0,0,8,90,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,56,104,0,0,200,102,0,0,80,101,0,0,216,99,0,0,216,99,0,0,96,98,0,0,80,101,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,0,115,0,0,136,111,0,0,24,110,0,0,168,108,0,0,168,108,0,0,56,107,0,0,24,110,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,72,113,0,0,88,113,0,0,104,113,0,0,56,98,0,0,112,113,0,0,128,113,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,224,116,0,0,232,116,0,0,240,116,0,0,248,116,0,0,112,116,0,0,0,117,0,0,16,117,0,0,24,117,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,117,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,208,117,0,0,224,117,0,0,232,117,0,0,240,117,0,0,0,118,0,0,16,118,0,0,24,118,0,0,40,118,0,0,56,118,0,0,72,118,0,0,88,118,0,0,104,118,0,0,120,118,0,0,136,118,0,0,152,118,0,0,160,118,0,0,168,118,0,0,184,118,0,0,192,118,0,0,208,118,0,0,224,118,0,0,240,118,0,0,0,119,0,0,16,119,0,0,32,119,0,0,48,119,0,0,64,119,0,0,80,119,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,216,119,0,0,224,119,0,0,224,119,0,0,0,120,0,0,48,120,0,0,80,120,0,0,136,120,0,0,184,120,0,0,232,120,0,0,8,121,0,0,56,121,0,0,80,121,0,0,112,121,0,0,152,121,0,0,184,121,0,0,232,121,0,0,8,122,0,0,48,122,0,0,80,122,0,0,120,122,0,0,168,122,0,0,224,122,0,0,8,123,0,0,56,123,0,0,104,123,0,0,144,123,0,0,192,123,0,0,200,123,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,216,119,0,0,200,126,0,0,208,126,0,0,216,126,0,0,232,117,0,0,224,126,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,72,128,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,96,128,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,120,128,0,0,128,128,0,0,136,128,0,0,152,128,0,0,168,128,0,0,176,128,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,136,139,0,0,0,0,0,0,0,139,0,0,0,0,0,0,120,138,0,0,0,0,0,0,240,137,0,0,0,0,0,0,232,136,0,0,0,0,0,0,224,135,0,0,0,0,0,0,216,134,0,0,0,0,0,0,208,133,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,112,141,0,0,128,141,0,0,136,141,0,0,144,141,0,0,160,141,0,0,168,141,0,0,176,141,0,0,184,141,0,0,192,141,0,0,200,141,0,0,208,141,0,0,224,141,0,0,232,141,0,0,248,141,0,0,8,142,0,0,24,142,0,0,32,142,0,0,48,142,0,0,56,142,0,0,72,142,0,0,80,142,0,0,104,142,0,0,112,142,0,0,120,142,0,0,136,142,0,0,144,142,0,0,160,142,0,0,176,142,0,0,184,142,0,0,192,142,0,0,200,142,0,0,208,142,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,96,143,0,0,104,143,0,0,176,143,0,0,224,143,0,0,16,144,0,0,88,144,0,0,152,144,0,0,224,144,0,0,16,145,0,0,88,145,0,0,112,145,0,0,144,145,0,0,200,145,0,0,240,145,0,0,24,146,0,0,80,146,0,0,160,146,0,0,0,147,0,0,48,147,0,0,104,147,0,0,152,147,0,0,224,147,0,0,8,148,0,0,56,148,0,0,104,148,0,0,192,148,0,0,8,149,0,0,120,149,0,0,168,149,0,0,240,149,0,0,16,150,0,0,208,142,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,96,143,0,0,208,150,0,0,120,151,0,0,224,143,0,0,16,144,0,0,224,151,0,0,152,144,0,0,224,144,0,0,104,152,0,0,168,152,0,0,112,145,0,0,144,145,0,0,72,153,0,0,136,153,0,0,200,153,0,0,80,146,0,0,160,146,0,0,8,154,0,0,64,154,0,0,200,154,0,0,240,154,0,0,224,147,0,0,8,148,0,0,56,148,0,0,88,155,0,0,224,155,0,0,224,156,0,0,120,149,0,0,168,149,0,0,240,149,0,0,16,150,0,0,208,142,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,162,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,162,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+35848);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+46192);
/* memory initializer */ allocate([248,184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,190,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,225,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,168,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,226,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,80,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,168,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,227,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,72,228,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,227,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,128,240,0,0,160,241,0,0,168,241,0,0,184,241,0,0,200,241,0,0,216,241,0,0,240,241,0,0,8,242,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,128,240,0,0,136,240,0,0,208,240,0,0,248,240,0,0,24,241,0,0,56,241,0,0,96,241,0,0,136,241,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,240,249,0,0,0,250,0,0,8,250,0,0,16,250,0,0,24,250,0,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,56,250,0,0,64,250,0,0,80,250,0,0,96,250,0,0,24,250,0,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+56876);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,32,21,1,0,232,22,1,0,240,22,1,0,248,22,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,32,21,1,0,40,22,1,0,120,22,1,0,168,22,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,32,21,1,0,232,21,1,0,240,21,1,0,248,21,1,0,8,22,1,0,16,22,1,0,32,22,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,32,21,1,0,40,21,1,0,64,21,1,0,80,21,1,0,152,21,1,0,168,21,1,0,200,21,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,208,32,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,208,32,1,0,10,0,0,0,11,0,0,0,116,32,1,0,236,32,1,0,0,33,1,0,136,32,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,160,218,1,0,160,32,1,0,40,150,1,0,0,0,0,0,104,0,0,0,0,0,0,0,40,150,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,40,150,1,0,14,0,0,0,15,0,0,0,0,0,0,0,120,33,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,160,218,1,0,72,33,1,0,32,149,1,0,0,0,0,0,0,0,0,0,0,34,1,0,8,34,1,0,248,33,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,216,33,1,0,232,33,1,0,248,33,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+67116);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,88,50,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,88,50,1,0,20,0,0,0,21,0,0,0,252,49,1,0,116,50,1,0,136,50,1,0,16,50,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,160,218,1,0,40,50,1,0,152,149,1,0,0,0,0,0,108,0,0,0,0,0,0,0,152,149,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,152,149,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,80,60,1,0,56,62,1,0,64,62,1,0,136,64,1,0,160,62,1,0,176,62,1,0,144,64,1,0,152,64,1,0,160,64,1,0,168,64,1,0,184,64,1,0,200,64,1,0,216,64,1,0,232,64,1,0,248,64,1,0,8,65,1,0,24,65,1,0,48,65,1,0,104,64,1,0,128,64,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,80,60,1,0,56,62,1,0,64,62,1,0,80,62,1,0,160,62,1,0,176,62,1,0,192,62,1,0,224,62,1,0,0,63,1,0,32,63,1,0,72,63,1,0,112,63,1,0,152,63,1,0,192,63,1,0,216,63,1,0,248,63,1,0,24,64,1,0,64,64,1,0,104,64,1,0,128,64,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,80,60,1,0,24,62,1,0,32,62,1,0,40,62,1,0,80,60,1,0,88,61,1,0,168,61,1,0,216,61,1,0,80,60,1,0,24,61,1,0,32,61,1,0,40,61,1,0,56,61,1,0,64,61,1,0,80,61,1,0,0,0,0,0,80,60,1,0,88,60,1,0,112,60,1,0,128,60,1,0,200,60,1,0,216,60,1,0,248,60,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,112,67,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,112,67,1,0,28,0,0,0,29,0,0,0,252,66,1,0,140,67,1,0,160,67,1,0,16,67,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,160,218,1,0,40,67,1,0,40,150,1,0,0,0,0,0,56,0,0,0,0,0,0,0,40,150,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,40,150,1,0,14,0,0,0,15,0,0,0,0,0,0,0,48,68,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,160,218,1,0,232,67,1,0,32,149,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+77356);
/* memory initializer */ allocate([32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,192,88,1,0,192,88,1,0,192,88,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,104,91,1,0,120,91,1,0,144,91,1,0,176,91,1,0,208,91,1,0,232,91,1,0,8,92,1,0,32,92,1,0,48,92,1,0,64,92,1,0,88,92,1,0,112,92,1,0,144,92,1,0,176,92,1,0,64,92,1,0,200,92,1,0,232,92,1,0,0,93,1,0,24,93,1,0,48,93,1,0,80,93,1,0,96,93,1,0,128,93,1,0,160,93,1,0,184,93,1,0,208,93,1,0,232,93,1,0,248,93,1,0,16,94,1,0,40,94,1,0,64,94,1,0,96,94,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+87596);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+94736);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,104,135,1,0,112,135,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,128,135,1,0,136,135,1,0,144,135,1,0,152,135,1,0,144,1,0,0,0,0,0,0,8,136,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+99960);
/* memory initializer */ allocate([224,142,1,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,160,218,1,0,192,142,1,0,96,149,1,0,0,0,0,0,0,0,0,0,72,143,1,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,160,218,1,0,48,143,1,0,96,149,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,224,143,1,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,160,218,1,0,192,143,1,0,32,149,1,0,0,0,0,0,0,0,0,0,72,144,1,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,160,218,1,0,48,144,1,0,32,149,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,120,218,1,0,88,144,1,0,0,0,0,0,192,144,1,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,104,145,1,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,160,218,1,0,176,144,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,145,1,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,160,218,1,0,232,144,1,0,192,144,1,0,0,0,0,0,0,0,0,0,64,145,1,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,160,218,1,0,40,145,1,0,192,144,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,160,218,1,0,80,145,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,176,145,1,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,160,218,1,0,152,145,1,0,104,145,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,120,218,1,0,192,145,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,160,218,1,0,232,145,1,0,224,145,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,152,148,1,0,48,0,0,0,49,0,0,0,0,0,0,0,32,149,1,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,96,149,1,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,152,149,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,152,149,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,224,149,1,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,224,149,1,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,40,150,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,40,150,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,112,150,1,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,112,150,1,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,148,1,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,96,148,1,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,160,218,1,0,24,148,1,0,176,145,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,120,218,1,0,72,148,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,160,218,1,0,104,148,1,0,96,148,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,160,218,1,0,168,148,1,0,96,148,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,120,218,1,0,232,148,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,120,218,1,0,40,149,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,219,1,0,104,149,1,0,0,0,0,0,1,0,0,0,152,148,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,219,1,0,176,149,1,0,0,0,0,0,1,0,0,0,216,148,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,219,1,0,248,149,1,0,0,0,0,0,1,0,0,0,152,148,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,219,1,0,64,150,1,0,0,0,0,0,1,0,0,0,216,148,1,0,3,244,255,255,0,0,0,0,208,150,1,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,160,218,1,0,176,150,1,0,0,146,1,0,0,0,0,0,0,0,0,0,248,164,1,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,165,1,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,169,1,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,104,170,1,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,171,1,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,171,1,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,232,166,1,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,232,166,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,136,167,1,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,136,167,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,24,168,1,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,168,1,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,165,1,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,165,1,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,165,1,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,166,1,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,172,1,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,224,172,1,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,112,173,1,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,0,174,1,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,168,1,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,169,1,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,208,164,1,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,161,1,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,162,1,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,164,1,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,168,164,1,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,224,160,1,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,160,218,1,0,200,160,1,0,120,144,1,0,0,0,0,0,0,0,0,0,112,161,1,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,120,218,1,0,80,161,1,0,0,219,1,0,56,161,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,161,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,0,219,1,0,144,161,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,161,1,0,2,0,0,0,0,0,0,0,64,162,1,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,120,218,1,0,32,162,1,0,0,219,1,0,248,161,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,56,162,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,0,219,1,0,96,162,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,56,162,1,0,2,0,0,0,0,0,0,0,0,163,1,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,219,1,0,216,162,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,56,162,1,0,2,0,0,0,0,0,0,0,120,163,1,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,219,1,0,80,163,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,56,162,1,0,2,0,0,0,0,0,0,0,240,163,1,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,160,218,1,0,200,163,1,0,120,163,1,0,0,0,0,0,0,0,0,0,88,164,1,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,160,218,1,0,48,164,1,0,120,163,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,160,218,1,0,104,164,1,0,224,160,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,160,218,1,0,144,164,1,0,224,160,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,160,218,1,0,184,164,1,0,224,160,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,160,218,1,0,224,164,1,0,224,160,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,160,218,1,0,8,165,1,0,224,160,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,120,218,1,0,80,165,1,0,0,219,1,0,48,165,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,165,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,0,219,1,0,144,165,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,165,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,0,219,1,0,208,165,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,165,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,0,219,1,0,16,166,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,165,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,120,218,1,0,152,166,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,120,218,1,0,184,166,1,0,0,219,1,0,80,166,1,0,0,0,0,0,3,0,0,0,224,160,1,0,2,0,0,0,176,166,1,0,2,0,0,0,224,166,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,120,218,1,0,88,167,1,0,0,219,1,0,16,167,1,0,0,0,0,0,3,0,0,0,224,160,1,0,2,0,0,0,176,166,1,0,2,0,0,0,128,167,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,120,218,1,0,248,167,1,0,0,219,1,0,176,167,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,16,168,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,219,1,0,56,168,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,16,168,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,120,218,1,0,184,168,1,0,0,219,1,0,160,168,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,208,168,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,0,219,1,0,248,168,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,208,168,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,120,218,1,0,144,169,1,0,0,219,1,0,120,169,1,0,0,0,0,0,1,0,0,0,176,169,1,0,0,0,0,0,0,219,1,0,48,169,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,184,169,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,0,219,1,0,56,170,1,0,0,0,0,0,1,0,0,0,176,169,1,0,0,0,0,0,0,219,1,0,240,169,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,80,170,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,120,218,1,0,232,170,1,0,0,219,1,0,208,170,1,0,0,0,0,0,1,0,0,0,8,171,1,0,0,0,0,0,0,219,1,0,136,170,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,16,171,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,0,219,1,0,144,171,1,0,0,0,0,0,1,0,0,0,8,171,1,0,0,0,0,0,0,219,1,0,72,171,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,168,171,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,120,218,1,0,40,172,1,0,0,219,1,0,224,171,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,72,172,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,120,218,1,0,184,172,1,0,0,219,1,0,112,172,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,216,172,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,120,218,1,0,72,173,1,0,0,219,1,0,0,173,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,104,173,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,120,218,1,0,216,173,1,0,0,219,1,0,144,173,1,0,0,0,0,0,2,0,0,0,224,160,1,0,2,0,0,0,248,173,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102012);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,232,215,1,0,110,0,0,0,240,215,1,0,114,0,0,0,248,215,1,0,102,0,0,0,0,216,1,0,97,0,0,0,8,216,1,0,101,0,0,0,16,216,1,0,119,0,0,0,24,216,1,0,87,0,0,0,40,216,1,0,115,0,0,0,56,216,1,0,83,0,0,0,72,216,1,0,100,0,0,0,88,216,1,0,68,0,0,0,104,216,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,240,217,1,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,120,218,1,0,200,217,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,160,218,1,0,224,217,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,160,218,1,0,0,218,1,0,216,217,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,160,218,1,0,56,218,1,0,40,218,1,0,0,0,0,0,0,0,0,0,96,218,1,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,232,218,1,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,160,218,1,0,192,218,1,0,96,218,1,0,0,0,0,0,0,0,0,0,72,219,1,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,160,218,1,0,32,219,1,0,96,218,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,221,1,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,160,218,1,0,120,221,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112352);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._lis_matrix_assemble;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env._lis_vector_get_values;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_destroy;var Kb=env._lis_solver_set_option;var Lb=env._tmpfile;var Mb=env._send;var Nb=env._pow;var Ob=env._lis_matrix_set_size;var Pb=env.___cxa_free_exception;var Qb=env.___cxa_find_matching_catch;var Rb=env._isxdigit_l;var Sb=env.___cxa_guard_release;var Tb=env._truncate;var Ub=env._strtol;var Vb=env._sin;var Wb=env._strtok;var Xb=env.___setErrNo;var Yb=env._newlocale;var Zb=env._isdigit_l;var _b=env.___resumeException;var $b=env._freelocale;var ac=env._srand;var bc=env._qsort;var cc=env._putchar;var dc=env._floor;var ec=env._pthread_mutex_unlock;var fc=env._printf;var gc=env._sprintf;var hc=env._fopen;var ic=env._vasprintf;var jc=env._emscripten_get_now;var kc=env._stat;var lc=env._lis_solve;var mc=env._strtoull_l;var nc=env._mkport;var oc=env._read;var pc=env.__addDays;var qc=env._fwrite;var rc=env._time;var sc=env._pthread_mutex_lock;var tc=env._catopen;var uc=env._exit;var vc=env._GC_strdup;var wc=env._freopen;var xc=env.___ctype_b_loc;var yc=env._fmod;var zc=env._strtok_r;var Ac=env._lseek;var Bc=env._access;var Cc=env._vfprintf;var Dc=env.___cxa_allocate_exception;var Ec=env._atoi;var Fc=env.__isLeapYear;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._lis_matrix_set_type;var Wc=env._fseek;var Xc=env._isxdigit;var Yc=env._fclose;var Zc=env._vsnprintf;var _c=env.__parseInt;var $c=env._log;var ad=env._pthread_cond_broadcast;var bd=env._popen;var cd=env._recv;var dd=env._fgetc;var ed=env._sysconf;var fd=env.__getFloat;var gd=env._lis_vector_set_value;var hd=env._abort;var id=env._ceil;var jd=env._isspace;var kd=env._localtime;var ld=env._lis_matrix_destroy;var md=env._pthread_getspecific;var nd=env._pthread_cond_wait;var od=env._llvm_lifetime_start;var pd=env.___cxa_is_number_type;var qd=env._ungetc;var rd=env._system;var sd=env._fmax;var td=env._fflush;var ud=env._strftime_l;var vd=env._fprintf;var wd=env._sscanf;var xd=env._catgets;var yd=env._lis_solver_destroy;var zd=env._strdup;var Ad=env._asprintf;var Bd=env.__exit;var Cd=env.___ctype_toupper_loc;var Dd=env._bsearch;var Ed=env.__arraySum;var Fd=env.__formatString;var Gd=env._htonl;var Hd=env.___ctype_tolower_loc;var Id=env._unlink;var Jd=env._fputs;var Kd=env._GC_malloc_atomic;var Ld=env._pread;var Md=env._lis_vector_set_size;var Nd=env._fscanf;var Od=env.__scanString;var Pd=env._pthread_setspecific;var Qd=env._copysign;var Rd=env._fputc;var Sd=env.___cxa_throw;var Td=env._lis_matrix_create;var Ud=env._isdigit;var Vd=env._strerror;var Wd=env._emscripten_longjmp;var Xd=env._lis_vector_create;var Yd=env._atexit;var Zd=env._sqrt;var _d=env._strerror_r;var $d=0.0;
// EMSCRIPTEN_START_FUNCS
function dP(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;vP(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=he[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=he[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}SL(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}SL(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=he[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((rP(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){he[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=mU(J,c[p>>2]|0,j,u)|0;FR(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=he[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=he[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;JL(o);JL(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;JL(o);JL(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;JL(o);JL(n);i=e;return}function eP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];fP(a,0,k,j,f,g,h);i=b;return}function fP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;vP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=he[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=he[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}SL(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}SL(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((rP(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=lU(I,c[o>>2]|0,h,t)|0;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=he[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}function gP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];hP(a,0,k,j,f,g,h);i=b;return}function hP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;vP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=he[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=he[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}SL(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}SL(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((rP(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=kU(I,c[o>>2]|0,h,t)|0;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=he[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}function iP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];jP(a,0,k,j,f,g,h);i=b;return}function jP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;vP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=he[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=he[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}SL(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}SL(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((rP(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=jU(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=he[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;JL(n);JL(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;JL(n);JL(m);i=d;return}function kP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];lP(a,0,k,j,f,g,h);i=b;return}function lP(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;wP(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=he[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=he[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}SL(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}SL(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((xP(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+iU(L,c[p>>2]|0,j);FR(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=he[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}function mP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nP(a,0,k,j,f,g,h);i=b;return}function nP(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;wP(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=he[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=he[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}SL(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}SL(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((xP(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+hU(L,c[p>>2]|0,j);FR(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=he[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}function oP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pP(a,0,k,j,f,g,h);i=b;return}function pP(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;wP(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=he[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=he[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}SL(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}SL(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((xP(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+gU(L,c[p>>2]|0,j);FR(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=he[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;JL(o);JL(n);i=d;return}function qP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FM(o,g);g=o;o=c[g>>2]|0;if(!((c[26440]|0)==-1)){c[l>>2]=105760;c[l+4>>2]=205;c[l+8>>2]=0;uL(105760,l,206)}l=(c[105764>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}y=m;Ge[c[(c[o>>2]|0)+48>>2]&63](o,104312,104338|0,y)|0;$K(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=he[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=he[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}SL(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}SL(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=he[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((rP(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){he[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);N=c[26414]|0;c[k>>2]=j;if((VO(H,N,104352,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=he[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=he[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;JL(p);JL(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;JL(p);JL(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;JL(p);JL(n);i=d;return}function rP(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[104312+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[104312+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function sP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;FM(k,d);d=k;k=c[d>>2]|0;if(!((c[26442]|0)==-1)){c[j>>2]=105768;c[j+4>>2]=205;c[j+8>>2]=0;uL(105768,j,206)}j=(c[105772>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Dc(4)|0;n=m;tV(n);o=121328;p=127;Sd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Dc(4)|0;n=m;tV(n);o=121328;p=127;Sd(m|0,o|0,p|0)}Ge[c[(c[k>>2]|0)+32>>2]&63](k,104312,104338|0,e)|0;e=c[d>>2]|0;if(!((c[26478]|0)==-1)){c[h>>2]=105912;c[h+4>>2]=205;c[h+8>>2]=0;uL(105912,h,206)}h=(c[105916>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}else{t=e;a[f]=he[c[(c[e>>2]|0)+16>>2]&127](t)|0;fe[c[(c[e>>2]|0)+20>>2]&127](b,t);$K(c[d>>2]|0)|0;i=g;return}}function tP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;FM(l,d);d=l;l=c[d>>2]|0;if(!((c[26442]|0)==-1)){c[k>>2]=105768;c[k+4>>2]=205;c[k+8>>2]=0;uL(105768,k,206)}k=(c[105772>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Dc(4)|0;o=n;tV(o);p=121328;q=127;Sd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Dc(4)|0;o=n;tV(o);p=121328;q=127;Sd(n|0,p|0,q|0)}Ge[c[(c[l>>2]|0)+32>>2]&63](l,104312,104344|0,e)|0;e=c[d>>2]|0;if(!((c[26478]|0)==-1)){c[j>>2]=105912;c[j+4>>2]=205;c[j+8>>2]=0;uL(105912,j,206)}j=(c[105916>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Dc(4)|0;s=r;tV(s);t=121328;u=127;Sd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Dc(4)|0;s=r;tV(s);t=121328;u=127;Sd(r|0,t|0,u|0)}else{u=e;a[f]=he[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=he[c[(c[e>>2]|0)+16>>2]&127](u)|0;fe[c[(c[e>>2]|0)+20>>2]&127](b,u);$K(c[d>>2]|0)|0;i=h;return}}function uP(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[104312+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function vP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;FM(j,b);b=j;j=c[b>>2]|0;if(!((c[26440]|0)==-1)){c[h>>2]=105760;c[h+4>>2]=205;c[h+8>>2]=0;uL(105760,h,206)}h=(c[105764>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Dc(4)|0;m=l;tV(m);n=121328;o=127;Sd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Dc(4)|0;m=l;tV(m);n=121328;o=127;Sd(l|0,n|0,o|0)}Ge[c[(c[j>>2]|0)+48>>2]&63](j,104312,104338|0,d)|0;d=c[b>>2]|0;if(!((c[26480]|0)==-1)){c[g>>2]=105920;c[g+4>>2]=205;c[g+8>>2]=0;uL(105920,g,206)}g=(c[105924>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}else{s=d;c[e>>2]=he[c[(c[d>>2]|0)+16>>2]&127](s)|0;fe[c[(c[d>>2]|0)+20>>2]&127](a,s);$K(c[b>>2]|0)|0;i=f;return}}function wP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;FM(k,b);b=k;k=c[b>>2]|0;if(!((c[26440]|0)==-1)){c[j>>2]=105760;c[j+4>>2]=205;c[j+8>>2]=0;uL(105760,j,206)}j=(c[105764>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Dc(4)|0;n=m;tV(n);o=121328;p=127;Sd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Dc(4)|0;n=m;tV(n);o=121328;p=127;Sd(m|0,o|0,p|0)}Ge[c[(c[k>>2]|0)+48>>2]&63](k,104312,104344|0,d)|0;d=c[b>>2]|0;if(!((c[26480]|0)==-1)){c[h>>2]=105920;c[h+4>>2]=205;c[h+8>>2]=0;uL(105920,h,206)}h=(c[105924>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}else{t=d;c[e>>2]=he[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=he[c[(c[d>>2]|0)+16>>2]&127](t)|0;fe[c[(c[d>>2]|0)+20>>2]&127](a,t);$K(c[b>>2]|0)|0;i=g;return}}function xP(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[104312+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function yP(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function zP(a){a=a|0;i=i;return}function AP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];qe[p&31](b,d,k,f,g,q);i=j;return}FM(n,f);f=n;n=c[f>>2]|0;if(!((c[26478]|0)==-1)){c[l>>2]=105912;c[l+4>>2]=205;c[l+8>>2]=0;uL(105912,l,206)}l=(c[105916>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Dc(4)|0;u=t;tV(u);v=121328;w=127;Sd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Dc(4)|0;u=t;tV(u);v=121328;w=127;Sd(t|0,v|0,w|0)}w=n;$K(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){fe[c[f+24>>2]&127](o,w)}else{fe[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((we[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];JL(o);i=j;return}function BP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=104560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);v=c[26414]|0;c[k>>2]=h;h=CP(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;FM(q,f);DP(w,y,k,z,o,p,q);$K(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];gI(b,j,z,e,o,f,g);i=d;return}function CP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=Zc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function DP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26442]|0)==-1)){c[m>>2]=105768;c[m+4>>2]=205;c[m+8>>2]=0;uL(105768,m,206)}m=(c[105772>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26478]|0)==-1)){c[l>>2]=105912;c[l+4>>2]=205;c[l+8>>2]=0;uL(105912,l,206)}l=(c[105916>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}x=s;fe[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ge[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=we[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=we[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=we[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=he[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=we[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;JL(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;JL(n);i=k;return}}function EP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);w=c[26414]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=CP(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;FM(r,f);DP(x,z,l,A,p,q,r);$K(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];gI(b,k,A,e,p,f,g);i=d;return}function FP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=104560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);x=c[26414]|0;c[k>>2]=h;h=CP(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;FM(q,f);DP(w,y,k,z,o,p,q);$K(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];gI(b,j,z,e,o,f,g);i=d;return}function GP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);y=c[26414]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=CP(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;FM(r,f);DP(x,z,l,A,p,q,r);$K(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];gI(b,k,A,e,p,f,g);i=d;return}function HP(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=CP(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=CP(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[105664]|0)==0;if(F){do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=IP(s,r,z,n)|0}else{do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);o=c[26414]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=IP(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}$V()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=OV(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}$V()}}while(0);FM(w,f);JP(N,L,G,P,u,v,w);$K(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];gI(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){PV(O)}if((J|0)==0){i=d;return}PV(J);i=d;return}function IP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=ic(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function JP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26442]|0)==-1)){c[m>>2]=105768;c[m+4>>2]=205;c[m+8>>2]=0;uL(105768,m,206)}m=(c[105772>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26478]|0)==-1)){c[l>>2]=105912;c[l+4>>2]=205;c[l+8>>2]=0;uL(105912,l,206)}l=(c[105916>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}x=s;fe[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=we[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=we[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=we[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[26414]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);l=D+1|0;if((Ud(A<<24>>24|0,c[26414]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ge[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=he[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=we[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=we[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=he[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ge[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;JL(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;JL(n);i=k;return}function KP(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=CP(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=CP(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[105664]|0)==0;if(F){do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=IP(s,r,z,n)|0}else{do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);o=c[26414]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=IP(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}$V()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=OV(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}$V()}}while(0);FM(w,f);JP(N,L,G,P,u,v,w);$K(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];gI(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){PV(O)}if((J|0)==0){i=d;return}PV(J);i=d;return}function LP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=104568;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);s=c[26414]|0;c[k>>2]=h;h=CP(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;FM(p,f);r=p;p=c[r>>2]|0;if(!((c[26442]|0)==-1)){c[l>>2]=105768;c[l+4>>2]=205;c[l+8>>2]=0;uL(105768,l,206)}l=(c[105772>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}$K(c[r>>2]|0)|0;Ge[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];gI(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];gI(b,j,u,z,m,f,g);I=j;i=d;return}function MP(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function NP(a){a=a|0;i=i;return}function OP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];qe[p&31](b,d,k,f,g,q);i=j;return}FM(n,f);f=n;n=c[f>>2]|0;if(!((c[26480]|0)==-1)){c[l>>2]=105920;c[l+4>>2]=205;c[l+8>>2]=0;uL(105920,l,206)}l=(c[105924>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Dc(4)|0;u=t;tV(u);v=121328;w=127;Sd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Dc(4)|0;u=t;tV(u);v=121328;w=127;Sd(t|0,v|0,w|0)}w=n;$K(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){fe[c[f+24>>2]&127](o,w)}else{fe[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=we[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];lM(o);i=j;return}function PP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=104560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);v=c[26414]|0;c[k>>2]=h;h=CP(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;FM(q,f);QP(w,y,k,z,o,p,q);$K(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];RP(b,j,z,e,o,f,g);i=d;return}function QP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26440]|0)==-1)){c[m>>2]=105760;c[m+4>>2]=205;c[m+8>>2]=0;uL(105760,m,206)}m=(c[105764>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26480]|0)==-1)){c[l>>2]=105920;c[l+4>>2]=205;c[l+8>>2]=0;uL(105920,l,206)}l=(c[105924>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}x=s;fe[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ge[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=we[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=we[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=we[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=he[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=we[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;JL(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;JL(n);i=k;return}function RP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ke[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){kM(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ke[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){lM(l);break}c[m>>2]=0;c[b>>2]=0;lM(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ke[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function SP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);w=c[26414]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=CP(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;FM(r,f);QP(x,z,l,A,p,q,r);$K(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];RP(b,k,A,e,p,f,g);i=d;return}function TP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=104560;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);v=c[26414]|0;c[k>>2]=h;h=CP(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;FM(q,f);QP(w,y,k,z,o,p,q);$K(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];RP(b,j,z,e,o,f,g);i=d;return}function UP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);y=c[26414]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=CP(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;FM(r,f);QP(x,z,l,A,p,q,r);$K(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];RP(b,k,A,e,p,f,g);i=d;return}function VP(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=CP(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=CP(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[105664]|0)==0;if(F){do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=IP(s,r,z,n)|0}else{do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);o=c[26414]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=IP(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}$V()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=OV(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}$V()}}while(0);FM(w,f);WP(N,L,G,P,u,v,w);$K(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];RP(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){PV(O)}if((J|0)==0){i=d;return}PV(J);i=d;return}function WP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26440]|0)==-1)){c[m>>2]=105760;c[m+4>>2]=205;c[m+8>>2]=0;uL(105760,m,206)}m=(c[105764>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Dc(4)|0;r=q;tV(r);s=121328;t=127;Sd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26480]|0)==-1)){c[l>>2]=105920;c[l+4>>2]=205;c[l+8>>2]=0;uL(105920,l,206)}l=(c[105924>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Dc(4)|0;v=u;tV(v);w=121328;x=127;Sd(u|0,w|0,x|0)}x=s;fe[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=we[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=we[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=we[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[26414]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);l=D+1|0;if((Ud(A<<24>>24|0,c[26414]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ge[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=he[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=we[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=we[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=he[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ge[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;JL(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;JL(n);i=k;return}function XP(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=CP(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=CP(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[105664]|0)==0;if(F){do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);r=c[26414]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=IP(s,r,z,n)|0}else{do{if(o){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);o=c[26414]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=IP(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}$V()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=OV(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}$V()}}while(0);FM(w,f);WP(N,L,G,P,u,v,w);$K(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];RP(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){PV(O)}if((J|0)==0){i=d;return}PV(J);i=d;return}function YP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=104568;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);s=c[26414]|0;c[k>>2]=h;h=CP(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}FM(p,f);u=p;p=c[u>>2]|0;if(!((c[26440]|0)==-1)){c[l>>2]=105760;c[l+4>>2]=205;c[l+8>>2]=0;uL(105760,l,206)}l=(c[105764>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}$K(c[u>>2]|0)|0;u=o;Ge[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];RP(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];RP(b,j,u,z,m,f,g);I=j;i=d;return}function ZP(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;FM(r,h);v=r;r=c[v>>2]|0;if(!((c[26442]|0)==-1)){c[q>>2]=105768;c[q+4>>2]=205;c[q+8>>2]=0;uL(105768,q,206)}q=(c[105772>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Dc(4)|0;y=x;tV(y);z=121328;A=127;Sd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Dc(4)|0;y=x;tV(y);z=121328;A=127;Sd(x|0,z|0,A|0)}A=r;$K(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((he[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((he[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ke[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(he[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=we[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(we[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ke[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ke[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];ve[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((he[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(he[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){he[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){he[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((he[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((he[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function _P(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function $P(a){a=a|0;i=i;return}function aQ(a){a=a|0;i=i;return 2}function bQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];ZP(a,b,l,k,f,g,h,104672,104680|0);i=j;return}function cQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=he[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];ZP(b,d,m,l,g,h,j,s,q);i=k;return}function dQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;FM(n,f);f=n;n=c[f>>2]|0;if(!((c[26442]|0)==-1)){c[m>>2]=105768;c[m+4>>2]=205;c[m+8>>2]=0;uL(105768,m,206)}m=(c[105772>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}s=n;$K(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=he[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=AO(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function eQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;FM(n,f);f=n;n=c[f>>2]|0;if(!((c[26442]|0)==-1)){c[m>>2]=105768;c[m+4>>2]=205;c[m+8>>2]=0;uL(105768,m,206)}m=(c[105772>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}s=n;$K(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=he[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=AO(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function fQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;FM(m,f);f=m;m=c[f>>2]|0;if(!((c[26442]|0)==-1)){c[l>>2]=105768;c[l+4>>2]=205;c[l+8>>2]=0;uL(105768,l,206)}l=(c[105772>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Dc(4)|0;p=o;tV(p);q=121328;r=127;Sd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Dc(4)|0;p=o;tV(p);q=121328;r=127;Sd(o|0,q|0,r|0)}r=m;$K(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=kQ(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function gQ(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;FM(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[26442]|0)==-1)){c[ba>>2]=105768;c[ba+4>>2]=205;c[ba+8>>2]=0;uL(105768,ba,206)}ba=(c[105772>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Dc(4)|0;Ga=Fa;tV(Ga);Ha=121328;Ia=127;Sd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Dc(4)|0;Ga=Fa;tV(Ga);Ha=121328;Ia=127;Sd(Fa|0,Ha|0,Ia|0)}Ia=ca;$K(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=he[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(AO(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];ZP(ra,d,y,x,g,h,j,104712,104717|0);c[Da>>2]=c[ra>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=kQ(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ja=Da+2e3|0}else{Ja=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ja+ -1900;break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=he[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(AO(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 88:{Da=d+8|0;ca=he[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ka=ca+1|0;La=ca+1|0;Ma=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ka=Ha;La=Ha;Ma=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];ZP(za,d,q,p,g,h,j,La,Ka+Ma|0);c[Da>>2]=c[za>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];iQ(d,j+8|0,e,B,h,Ia);break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=kQ(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=kQ(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=kQ(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=kQ(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];ZP(oa,d,A,z,g,h,j,104696,104707|0);c[Da>>2]=c[oa>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];jQ(0,e,m,h,Ia);break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=kQ(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=kQ(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];hQ(0,e,C,h,Ia);break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];ZP(ja,d,J,I,g,h,j,104688,104696|0);c[ca>>2]=c[ja>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=kQ(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];ZP(ga,d,L,K,g,h,j,104680,104688|0);c[Da>>2]=c[ga>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=kQ(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Da=he[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Na=Da+1|0;Oa=Da+1|0;Pa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];ZP(da,d,O,N,g,h,j,Oa,Na+Pa|0);c[ca>>2]=c[da>>2];break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];te[ca&63](b,d,s,r,g,h,j);i=l;return};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];ZP(ua,d,v,u,g,h,j,104720,104728|0);c[ca>>2]=c[ua>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=kQ(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function hQ(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((he[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(he[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){he[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((he[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((he[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function iQ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=he[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=AO(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function jQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((he[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((he[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(he[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ke[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){he[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((he[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function kQ(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((he[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((he[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(he[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ke[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){he[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((he[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((he[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(he[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ke[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){he[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((he[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function lQ(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;FM(p,f);t=p;p=c[t>>2]|0;if(!((c[26440]|0)==-1)){c[o>>2]=105760;c[o+4>>2]=205;c[o+8>>2]=0;uL(105760,o,206)}o=(c[105764>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}y=p;$K(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=he[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=he[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ke[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ke[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=we[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(we[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ke[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ke[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];ve[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ke[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=he[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=he[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=he[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ke[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){he[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=he[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function mQ(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function nQ(a){a=a|0;i=i;return}function oQ(a){a=a|0;i=i;return 2}function pQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];lQ(a,b,l,k,f,g,h,104824,104856|0);i=j;return}function qQ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=he[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];lQ(b,d,m,l,g,h,j,s,q);i=k;return}function rQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;FM(n,f);f=n;n=c[f>>2]|0;if(!((c[26440]|0)==-1)){c[m>>2]=105760;c[m+4>>2]=205;c[m+8>>2]=0;uL(105760,m,206)}m=(c[105764>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}s=n;$K(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=he[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=ZO(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function sQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;FM(n,f);f=n;n=c[f>>2]|0;if(!((c[26440]|0)==-1)){c[m>>2]=105760;c[m+4>>2]=205;c[m+8>>2]=0;uL(105760,m,206)}m=(c[105764>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Dc(4)|0;q=p;tV(q);r=121328;s=127;Sd(p|0,r|0,s|0)}s=n;$K(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=he[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=ZO(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function tQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;FM(m,f);f=m;m=c[f>>2]|0;if(!((c[26440]|0)==-1)){c[l>>2]=105760;c[l+4>>2]=205;c[l+8>>2]=0;uL(105760,l,206)}l=(c[105764>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Dc(4)|0;p=o;tV(p);q=121328;r=127;Sd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Dc(4)|0;p=o;tV(p);q=121328;r=127;Sd(o|0,q|0,r|0)}r=m;$K(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=yQ(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}



function Qp(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Rp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=Up(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 17:{k=Vp(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=Sp(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=Tp(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}n=b;if((we[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=n+3|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=55;break b;break};case 5:{if((e-b|0)<2){m=58;break b}o=b;if((we[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=o+2|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}p=b;if((we[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}q=b;if((we[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};default:{m=72;break b}}break};case 5:{if((e-b|0)<2){m=36;break b}r=b;if((we[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=r+2|0;continue b;break};case 29:{m=33;break b;break};case 7:{if((e-b|0)<4){m=46;break b}s=b;if((we[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=s+4|0;continue b;break};case 11:{m=97;break b;break};case 10:case 9:case 21:{m=73;break b;break};case 17:{break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{m=77;break d;break};case 6:{m=83;break d;break};case 7:{m=88;break d;break};case 29:{m=76;break d;break};case 10:case 9:case 21:{break};case 11:{m=97;break c;break};case 17:{break c;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Wp(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Sp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 6:{if((e-b|0)<3){m=13;break b}n=b;if((we[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((we[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((we[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Tp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[26304+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Up(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((we[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((we[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((we[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{o=68;break b;break};case 7:{if((e-b|0)<4){o=37;break b}p=b;if((we[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 29:{o=24;break b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((we[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}r=b;if((we[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=r+2|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Xp(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=57;break c}s=b;if((we[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((we[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 8:case 1:case 0:{o=61;break c;break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((we[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Xp(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Vp(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 11:{l=49;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((we[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 29:{l=24;break b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((we[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((we[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Wp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(we[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=m+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}n=b;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=48;break a}}break};case 29:{l=4;break a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=26;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}n=(we[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!n){l=31;break a}c[j>>2]=o+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}n=(we[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!n){l=36;break a}c[j>>2]=p+3;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}n=(we[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!n){l=41;break a}c[j>>2]=q+4;continue a;break};default:{l=43;break a}}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}n=(we[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!n){l=14;break a}c[j>>2]=r+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}n=(we[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!n){l=19;break a}c[j>>2]=s+4;continue a;break};case 14:{break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}n=t;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}n=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((n|0)==(t|0)){break}switch(n|0){case 8:case 1:case 0:{l=75;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}n=(we[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(n){l=73;break a}c[j>>2]=u+4;continue c;break};case 2:{l=80;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}n=(we[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(n){l=63;break a}c[j>>2]=v+2;continue c;break};case 3:{w=Np(k,(c[j>>2]|0)+1|0,e,j)|0;if((w|0)<=0){l=77;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}n=(we[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(n){l=68;break a}c[j>>2]=x+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{l=91;break d;break};case 29:{l=89;break a;break};case 6:{l=96;break d;break};case 10:case 9:case 21:{break};case 7:{l=101;break d;break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 24:case 22:{l=90;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}n=(we[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!n){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}n=(we[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!n){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}n=(we[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!n){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((w|0)==0){c[f>>2]=c[j>>2]}B=w;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Xp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Yp(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((we[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((we[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((we[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function Zp(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==27){j=Sp(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a+1|0]|0)|0]|0;if(!((f|0)==30|(f|0)==10|(f|0)==9|(f|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function _p(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((we[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((we[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((we[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function $p(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function aq(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function bq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function cq(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ge[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ge[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ge[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ge[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function dq(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((fq(eq(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((fq(eq(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=eq(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((fq(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=eq(k,a,b)|0;n=h;}while((fq(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=eq(k,a,b)|0;while(1){if((fq(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=eq(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=eq(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function eq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;be[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function fq(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function gq(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function hq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 13:{c[h>>2]=14;j=56;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((Ge[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,30048)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 29:{c[h>>2]=16;j=2;break};case 15:{c[h>>2]=14;j=0;break};case 11:{c[h>>2]=14;j=55;break};default:{k=10}}}while(0);if((k|0)==10){j=lq(h,a)|0}i=g;return j|0}function iq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};case 15:{k=0;break};default:{k=kq(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=lq(h,a)|0}i=g;return k|0}function jq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Ge[c[e+28>>2]&63](e,b,d,30032)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Ge[c[e+28>>2]&63](e,b,d,30040)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=lq(h,a)|0;l=k;i=g;return l|0}function kq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 16:{if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,29808)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,29816)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,29824)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,29832)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};default:{}}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function lq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function mq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function nq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else{g=lq(e,a)|0}i=f;return g|0}function oq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=lq(e,a)|0}i=f;return g|0}function pq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else if((b|0)==15){g=39}else{g=lq(e,a)|0}i=f;return g|0}function qq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=lq(e,a)|0}i=f;return g|0}function rq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=lq(e,a)|0}i=f;return g|0}function sq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==11){g=55}else if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else{g=lq(e,a)|0}i=f;return g|0}function tq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ge[c[e+28>>2]&63](e,b,d,29848)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b,d,29856)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function uq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=lq(e,a)|0}i=f;return g|0}function vq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=lq(e,a)|0}i=f;return g|0}function wq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else{g=lq(e,a)|0}i=f;return g|0}function xq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=lq(e,a)|0;h=g;i=f;return h|0}return 0}function yq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ge[c[e+28>>2]&63](e,b,d,29864)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b,d,29872)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function zq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 20:{if((Ge[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,29880)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 30:{c[h>>2]=40;j=53;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 15:{j=39;break};case 31:{c[h>>2]=40;j=52;break};case 32:{c[h>>2]=40;j=54;break};default:{k=10}}}while(0);if((k|0)==10){j=lq(h,a)|0}i=g;return j|0}function Aq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else{g=lq(e,a)|0}i=f;return g|0}function Bq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 30:{c[e>>2]=40;g=53;break};case 32:{c[e>>2]=40;g=54;break};case 15:{g=39;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 31:{c[e>>2]=40;g=52;break};default:{g=lq(e,a)|0}}i=f;return g|0}function Cq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};default:{g=lq(e,a)|0;h=g;i=f;return h|0}}return 0}function Dq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=lq(e,a)|0}i=f;return g|0}function Eq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=lq(e,a)|0}i=f;return g|0}function Fq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else{g=lq(e,a)|0}i=f;return g|0}function Gq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ge[m&63](n,o,p,c[29888+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ge[m&63](n,o,p,29832)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function Hq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,29992)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,3e4)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,30016)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function Iq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=lq(e,a)|0}i=f;return g|0}function Jq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=lq(e,a)|0}i=f;return g|0}function Kq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=lq(e,a)|0}i=f;return g|0}function Lq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=lq(e,a)|0}i=f;return g|0}function Mq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=lq(e,a)|0}i=f;return g|0}function Nq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=lq(e,a)|0}i=f;return g|0}function Oq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=lq(e,a)|0}i=f;return g|0}function Pq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ge[c[e+28>>2]&63](e,b,d,29848)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b,d,29856)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function Qq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=lq(e,a)|0}i=f;return g|0}function Rq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=lq(e,a)|0}i=f;return g|0}function Sq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((Ge[c[b+28>>2]&63](b,d,e,30024)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function Tq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=lq(e,a)|0}i=f;return g|0}function Uq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((Ge[c[e+28>>2]&63](e,b,d,29848)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b,d,29856)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function Vq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=lq(e,a)|0}i=f;return g|0}function Wq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=lq(e,a)|0}i=f;return g|0}function Xq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=lq(e,a)|0;h=g;i=f;return h|0}return 0}function Yq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=lq(e,a)|0;h=g;i=f;return h|0}return 0}function Zq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=lq(e,a)|0}i=f;return g|0}function _q(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 11:{j=55;break};case 16:{if((Ge[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,30048)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 15:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 13:{j=56;break};default:{k=9}}}while(0);if((k|0)==9){j=lq(h,a)|0}i=g;return j|0}function $q(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=lq(e,a)|0}i=f;return g|0}function ar(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==18){if((Ge[c[e+28>>2]&63](e,b,d,29848)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ge[c[e+28>>2]&63](e,b,d,29856)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}}while(0);j=lq(h,a)|0;k=j;i=g;return k|0}function br(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=lq(e,a)|0}i=f;return g|0}function cr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=lq(e,a)|0}i=f;return g|0}function dr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=lq(e,a)|0}i=f;return g|0}function er(){i=i;return}function fr(){i=i;return}function gr(){var a=0;a=i;Wa(30056,0)|0;i=a;return}function hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function ir(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Or(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function jr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[20226]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=30072;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];He[p&31](0,f,30096,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function kr(){var a=0,b=0,d=0;a=i;b=31864|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=31976|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=32088|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[31868>>2]=1;c[31872>>2]=1;i=a;return}function lr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?32224:32240;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;vd(a|0,32200,e|0)|0;i=d;return}function mr(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=32088+(d<<2)|0;o=31976+(d<<2)|0;p=32288+(b<<2)|0;q=30568+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=32272;fc(32256,l|0)|0;s=32272}else{if((c[7962]|0)==(d|0)){if((c[o>>2]|0)>0){t=32272}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;fc(32256,m|0)|0;do{if((c[7962]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=32272;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;fc(32280,k|0)|0;c[n>>2]=b;c[7962]=d;if((c[o>>2]|0)>0){g=0;while(1){fc(32312,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;td(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function nr(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[32288+(a<<2)>>2]|0;c[j>>2]=c[30568+(b<<2)>>2];c[j+4>>2]=k;fc(32320,j|0)|0;or(e);if((g|0)==0){Jd(((d|0)!=0?32360:32408)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=td(m|0)|0;i=f;return}tb(32488)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];fc(32368,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=td(m|0)|0;i=f;return}qc(32392,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=td(m|0)|0;i=f;return}function or(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==60){qc(32440,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){qc(32432,5,1,e|0)|0}else if(b<<24>>24==62){qc(32448,4,1,e|0)|0}else{Rd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function pr(a){a=a|0;var b=0;b=31976+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function qr(a){a=a|0;var b=0;b=(a|0)==0;c[8106]=b?1:19;c[8104]=b?7:183;i=i;return}function rr(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;qc(32392,11,1,b|0)|0;td(b|0)|0;i=a;return}function sr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[31864+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Zc(j|0,2048,e|0,h|0)|0;qe[c[8106]&31](1,a,b,j,0,d);i=g;return}function tr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[31864+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;qe[c[8106]&31](1,a,b,h,0,0);i=f;return}function ur(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[7964]|0)==0){if((c[31864+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Zc(k|0,2048,e|0,j|0)|0;qe[c[8106]&31](2,a,b,k,0,d);i=g;return}function vr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[7964]|0)==0){if((c[31864+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Zc(j|0,2048,d|0,h|0)|0;qe[c[8106]&31](2,a,b,j,0,0);i=f;return}function wr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Zc(b|0,2048,d|0,g|0)|0;qe[c[8106]&31](4,2,0,b,0,0);if((a|0)==0){h=md(c[7514]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function xr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Zc(g|0,2048,b|0,f|0)|0;qe[c[8106]&31](5,2,0,g,0,0);if((a|0)==0){h=md(c[7514]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function yr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;qe[c[8106]&31](5,2,0,h,0,b);if((a|0)==0){j=md(c[7514]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function zr(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;yr(a,e,32560,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;ur(26,0,e,32496,m);i=j;return+b}return 0.0}function Ar(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=OV(16)|0;wr(0,(d|0)!=0|0,32608,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Br(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;PV(c[f>>2]|0);PV(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Cr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;wr(0,(a|0)!=0|0,32624,f);f=OV(8)|0;g=f;wr(0,(f|0)!=0|0,32608,e);e=a+8|0;h=OV(c[e>>2]|0)|0;c[f>>2]=h;wr(0,(h|0)!=0|0,32608,d);sW(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Dr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;wr(0,(a|0)!=0|0,32624,f);f=OV(8)|0;g=f;wr(0,(f|0)!=0|0,32608,e);e=a+8|0;h=OV(c[e>>2]|0)|0;c[f>>2]=h;wr(0,(h|0)!=0|0,32608,d);sW(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Er(a){a=a|0;var b=0;b=i;i=i+8|0;wr(0,(a|0)!=0|0,32624,b);i=b;return c[a+12>>2]|0}function Fr(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;wr(0,(a|0)!=0|0,32624,d);d=a;wr(0,(c[d>>2]|0)!=0|0,32648,b);i=b;return c[c[d>>2]>>2]|0}function Gr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;PV(c[e>>2]|0);PV(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function Hr(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;wr(0,(a|0)!=0|0,32624,d);d=a;wr(0,(c[d>>2]|0)!=0|0,32664,b);i=b;return c[d>>2]|0}function Ir(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;wr(0,d&1,32696,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function Jr(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;wr(0,(a|0)!=0|0,32696,d);d=a;wr(0,(c[d>>2]|0)!=0|0,32720,b);i=b;return c[d>>2]|0}function Kr(){var a=0,b=0,d=0;a=i;b=OV(16)|0;c[8198]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=OV(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function Lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Pr(a)|0;sc(32800)|0;Qr(d);a=c[8198]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;ec(32800)|0;uW(g|0,0,d|0)|0;i=b;return g|0}function Mr(){var a=0,b=0,d=0,e=0;a=i;b=c[8198]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;PV(c[b>>2]|0);PV(b);if((d|0)==0){break}else{b=d}}e=c[8198]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Nr(a){a=a|0;var b=0,d=0;b=i;d=he[c[32752>>2]&127](a<<3)|0;i=b;return d|0}function Or(a){a=a|0;var b=0,d=0;b=i;d=he[c[32752>>2]&127](a<<2)|0;i=b;return d|0}function Pr(a){a=a|0;i=i;return a+7&-8|0}function Qr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[8198]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=OV(16)|0;c[f+12>>2]=d;c[8198]=f;c[f+4>>2]=0;d=Rr((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=OV(d)|0;c[f>>2]=a;i=b;return}function Rr(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function Sr(a){a=a|0;var b=0,c=0;b=i;c=qW(a|0)|0;i=b;return c|0}function Tr(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;wW(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];gc(m|0,l|0,f|0)|0;f=Ur(m)|0;i=e;return f|0}function Ur(a){a=a|0;var b=0,c=0,d=0;b=i;c=qW(a|0)|0;d=Wr(c)|0;sW(d|0,a|0,c|0)|0;i=b;return d|0}function Vr(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;gc(o|0,32832,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;gc(o|0,32824,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gc(q|0,p|0,j|0)|0;j=Ur(q)|0;i=g;return j|0}function Wr(b){b=b|0;var d=0,e=0;d=i;e=he[c[32756>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function Xr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=Sr(a)|0;e=Sr(b)|0;f=Wr(e+d|0)|0;sW(f|0,a|0,d|0)|0;sW(f+d|0,b|0,e|0)|0;i=c;return f|0}function Yr(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=mW(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function Zr(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 0:{f=8;break a;break};case 3:{f=2;break a;break};case 1:{f=4;break a;break};case 5:{f=1;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function _r(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Yc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){PV(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{PV(c[(c[f>>2]|0)+(g<<4)>>2]|0);PV(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;PV(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){PV(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{PV(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}PV(d);c[g>>2]=0;i=b;return}function $r(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(qW(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function as(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=hc(b|0,33e3)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Vd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=zd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=33008;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[32976+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=33032;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=33056;E=131;break}G=Zr(D)|0;if((G|0)==-1){n=33088;E=131;break}D=c[q>>2]|0;H=OV(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=33136;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=33160;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((mW(H,c[32952+(C<<2)>>2]|0)|0)!=0){n=33184;E=131;break}PV(H);H=33760;b:do{switch(C|0){case 0:{if((D|0)!=4){n=33208;E=131;break a}if((I|0)!=11){n=33248;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=33288;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((nW(t,c[8214]|0,8)|0)==0){L=1;E=130;break b}if((nW(t,c[8220]|0,9)|0)==0){L=0;E=130}else{n=33320;E=131;break a}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=33696;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=QV(c[z>>2]<<1,4)|0;if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=33728;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=33696;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=QV(c[z>>2]<<1,4)|0;F=fa(I,D)|0;if((a[l]|0)==1){G=OV(F<<3)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=33728;E=131;break a}if((I|0)!=0){M=D<<3;N=(D|0)==0;O=D<<3;P=0;do{Q=OV(M)|0;c[(c[B>>2]|0)+(P<<2)>>2]=Q;if(!N){Q=G+(fa(O,P)|0)|0;sW(c[(c[B>>2]|0)+(P<<2)>>2]|0,Q|0,O|0)|0}P=P+1|0;}while(P>>>0<I>>>0)}P=c[z>>2]|0;O=P<<1;if(P>>>0<O>>>0){N=D<<3;M=(D|0)==0;Q=P;do{R=OV(N)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=R;if(!M){R=c[B>>2]|0;S=c[R+(Q-P<<2)>>2]|0;T=c[R+(Q<<2)>>2]|0;R=0;do{h[T+(R<<3)>>3]=-+h[S+(R<<3)>>3];R=R+1|0;}while(R>>>0<D>>>0)}Q=Q+1|0;}while(Q>>>0<O>>>0)}PV(G)}else{O=OV(F<<2)|0;if((sb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=33728;E=131;break a}if((I|0)!=0){Q=D<<3;P=(D|0)==0;M=0;do{N=OV(Q)|0;c[(c[B>>2]|0)+(M<<2)>>2]=N;if(!P){N=c[(c[B>>2]|0)+(M<<2)>>2]|0;R=0;do{h[N+(R<<3)>>3]=+g[O+((fa(D,M)|0)+R<<2)>>2];R=R+1|0;}while(R>>>0<D>>>0)}M=M+1|0;}while(M>>>0<I>>>0)}M=c[z>>2]|0;P=M<<1;if(M>>>0<P>>>0){Q=D<<3;F=(D|0)==0;G=M;do{R=OV(Q)|0;c[(c[B>>2]|0)+(G<<2)>>2]=R;if(!F){R=c[B>>2]|0;N=c[R+(G-M<<2)>>2]|0;S=c[R+(G<<2)>>2]|0;R=0;do{h[S+(R<<3)>>3]=-+h[N+(R<<3)>>3];R=R+1|0;}while(R>>>0<D>>>0)}G=G+1|0;}while(G>>>0<P>>>0)}PV(O)}if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=33728;E=131;break a}else{L=d;E=130}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=33448;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=33504;E=131;break a}c[w>>2]=D;P=fa(I,D)|0;if((a[l]|0)==1){G=OV(P<<3)|0;c[x>>2]=G;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=33544;E=131;break a}}else{G=OV(P<<2)|0;c[x>>2]=OV(fa(D<<3,I)|0)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=33544;E=131;break a}if((P|0)!=0){M=c[x>>2]|0;F=0;do{h[M+(F<<3)>>3]=+g[G+(F<<2)>>2];F=F+1|0;}while(F>>>0<P>>>0)}PV(G)}P=c[w>>2]|0;if(!(P>>>0>1)){L=1;E=130;break b}F=(I|0)==2;M=1;while(1){if(F){O=c[x>>2]|0;if(+h[O+(M<<3)>>3]!=+h[O+(P+M<<3)>>3]){n=33576;E=131;break a}}O=M+1|0;if(O>>>0<P>>>0){M=O}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){U=d;E=129;break b}if((I|0)==0){n=33448;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=33656;E=131;break a}c[w>>2]=I;M=fa(I,D)|0;if((a[l]|0)==1){P=OV(M<<3)|0;c[x>>2]=OV(fa(D<<3,I)|0)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=33544;E=131;break a}if((D|0)!=0){F=0;do{G=c[x>>2]|0;O=0;do{h[G+((fa(I,F)|0)+O<<3)>>3]=+h[P+((fa(D,O)|0)+F<<3)>>3];O=O+1|0;}while(O>>>0<I>>>0);F=F+1|0;}while(F>>>0<D>>>0)}PV(P)}else{F=OV(M<<2)|0;c[x>>2]=OV(fa(D<<3,I)|0)|0;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=33544;E=131;break a}if((D|0)!=0){O=0;do{G=c[x>>2]|0;Q=0;do{h[G+((fa(I,O)|0)+Q<<3)>>3]=+g[F+((fa(D,Q)|0)+O<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}PV(F)}O=c[w>>2]|0;if(!(O>>>0>1)){L=d;E=130;break b}M=(D|0)==2;P=1;while(1){if(M){Q=c[x>>2]|0;if(+h[Q+(P<<3)>>3]!=+h[Q+(O+P<<3)>>3]){n=33576;E=131;break a}}Q=P+1|0;if(Q>>>0<O>>>0){P=Q}else{L=d;E=130;break}}break};case 3:{P=fa(I<<2,D)|0;V=OV(P)|0;if((sb(V|0,P|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}P=c[v>>2]|0;O=0;do{c[P+(O<<4)+8>>2]=(c[V+(O<<2)>>2]|0)==1;c[P+(O<<4)+12>>2]=c[V+(D+O<<2)>>2];O=O+1|0;}while(O>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}O=c[v>>2]|0;P=0;do{M=fa(D,P)|0;c[O+(P<<4)+8>>2]=(c[V+(M<<2)>>2]|0)==1;c[O+(P<<4)+12>>2]=c[V+(M+1<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0)}}while(0);PV(V);bc(c[v>>2]|0,c[u>>2]|0,16,54);L=d;E=130;break};case 1:{P=d<<24>>24==0;c[u>>2]=P?D:I;O=OV((P?D:I)<<4)|0;c[v>>2]=O;c:do{if(d<<24>>24==1){if((I|0)==0){W=0;break}M=D+1|0;F=O;Q=0;while(1){c[F+(Q<<4)>>2]=OV(M)|0;if((sb(c[(c[v>>2]|0)+(Q<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=33384;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+D|0]=0;G=c[v>>2]|0;c[G+(Q<<4)+8>>2]=-1;c[G+(Q<<4)+12>>2]=-1;$r(c[G+(Q<<4)>>2]|0);G=Q+1|0;if(!(G>>>0<I>>>0)){W=I;break c}F=c[v>>2]|0;Q=G}}else{W=I}}while(0);if(!P){L=d;E=130;break b}O=fa(D,W)|0;X=OV(O+1|0)|0;if((sb(X|0,O|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){O=W+1|0;Q=(W|0)==0;F=0;do{M=OV(O)|0;c[(c[v>>2]|0)+(F<<4)>>2]=M;if(!Q){M=0;do{G=a[X+((fa(D,M)|0)+F)|0]|0;a[(c[(c[v>>2]|0)+(F<<4)>>2]|0)+M|0]=G;M=M+1|0;}while(M>>>0<W>>>0)}a[(c[(c[v>>2]|0)+(F<<4)>>2]|0)+W|0]=0;M=c[v>>2]|0;c[M+(F<<4)+8>>2]=-1;c[M+(F<<4)+12>>2]=-1;$r(c[M+(F<<4)>>2]|0);F=F+1|0;}while(F>>>0<D>>>0)}PV(X);L=0;E=130;break};case 2:{if(d<<24>>24==1){if((I|0)==0){U=1;E=129;break b}F=D+1|0;Q=0;while(1){O=OV(F)|0;c[(c[v>>2]|0)+(Q<<4)+4>>2]=O;if((sb(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=33384;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)+4>>2]|0)+D|0]=0;O=Q+1|0;if(O>>>0<I>>>0){Q=O}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){U=d;E=129;break b}Q=fa(D,I)|0;Y=OV(Q+1|0)|0;if((sb(Y|0,Q|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){Q=I+1|0;F=(I|0)==0;O=0;do{P=OV(Q)|0;c[(c[v>>2]|0)+(O<<4)+4>>2]=P;if(!F){P=0;do{M=a[Y+((fa(D,P)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+P|0]=M;P=P+1|0;}while(P>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(O<<4)+4>>2]|0)+I|0]=0;O=O+1|0;}while(O>>>0<D>>>0)}PV(Y);L=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=U;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){PV(X);n=33384;i=e;return n|0}else if((E|0)==46){PV(Y);n=33384;i=e;return n|0}else if((E|0)==52){PV(V);n=33416;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function bs(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Dd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function cs(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=33800;o=n;p=33848;q=p;r=33872;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=33800;o=n;p=33848;q=p;r=33872;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=OV(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}PV(r);t=0;i=e;return t|0}else{k=OV(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}PV(k);PV(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);PV(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function ds(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=33800;r=q;s=33848;t=s;u=33896;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=33800;r=q;s=33848;t=s;u=33896;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Wc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Wc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function es(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function fs(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function gs(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function hs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+gs(b)<e){q=1;i=f;return q|0}if(+fs(b)>e){q=1;i=f;return q|0}if((cs(b,1)|0)==0){q=1;i=f;return q|0}es(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+ds(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+ds(a,b,d,o);i=f;return q|0}if(+ds(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+ds(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function is(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function js(a,b){a=a|0;b=b|0;var c=0;c=i;ir(a,b,Nr(b)|0);i=c;return}function ks(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function ls(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function ms(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;ks(c[d+8>>2]|0,b,a);i=e;return}function ns(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;js(a,b);j=g;c[g>>2]=e;ms(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;ms(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function os(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=jr(a,b,f)|0;f=ls(c[a+8>>2]|0,d)|0;i=e;return f|0}function ps(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,f=0,g=0.0,h=0.0,j=0.0,k=0;c=i;d=qs(a)|0;if((d|0)==0){e=0.0;i=c;return+e}else{f=0;g=0.0}while(1){h=+is(a,f);j=g+h*+is(b,f);k=f+1|0;if(k>>>0<d>>>0){g=j;f=k}else{e=j;break}}i=c;return+e}function qs(a){a=a|0;var b=0,c=0;b=i;c=hr(a)|0;i=b;return c|0}function rs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=OV(20)|0;wr(0,(f|0)!=0|0,33928,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=QV(e,b)|0;c[f>>2]=a;wr(0,(a|0)!=0|0,33928,d);i=d;return f|0}function ss(a){a=a|0;var b=0;b=i;PV(c[a>>2]|0);PV(a);i=b;return}function ts(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;wr(0,(c[h>>2]|0)>0|0,33944,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;wr(0,(g|0)>(b|0)|0,33968,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;wr(0,(0-f|0)<(b|0)|0,33968,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function us(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=QV(c[d>>2]<<1,c[e>>2]|0)|0;wr(0,(f|0)!=0|0,33928,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=ts(a,j)|0;h=c[e>>2]|0;sW(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;PV(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function vs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){us(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;sW((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function ws(a){a=a|0;i=i;return c[a+12>>2]|0}function xs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;wr(0,(c[j>>2]|0)>0|0,33944,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;wr(0,(h|0)>(b|0)|0,33968,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;wr(0,b>>>31^1,33968,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=ts(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function ys(a){a=a|0;i=i;return c[(c[8500]|0)+(a<<2)>>2]|0}function zs(a){a=a|0;i=i;return c[(c[8502]|0)+(a<<2)>>2]|0}function As(a){a=a|0;i=i;return c[(c[8504]|0)+(a<<2)>>2]|0}function Bs(a){a=a|0;i=i;return c[(c[8506]|0)+(a<<2)>>2]|0}function Cs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[8502]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[8504]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[8500]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Ds(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[8508]|0;e=+Es(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Es(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Fs(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[8510]|0;e=+Es(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Gs(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[8512]|0;e=+Es(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Hs(a){a=a|0;i=i;return 0}function Is(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[8514]|0)+(a<<3)|0)|0;d=(c[8500]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Js(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[8508]|0;f=e+(a<<3)|0;g=c[8512]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[8506]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[8500]|0)+(a<<2)>>2]|0);e=c[8510]|0;g=e+(a<<3)|0;Ks(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Cs(a);d=c[8508]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[8500]|0)+(a<<2)>>2]=0;i=b;return}function Ks(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Ns(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Ls(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[8514]|0;f=c[8508]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Ms(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=QV(a,8)|0;c[8508]=d;e=QV(a,8)|0;c[8510]=e;f=QV(a,8)|0;c[8512]=f;g=QV(a,8)|0;c[8514]=g;h=QV(a,4)|0;c[8500]=h;j=QV(a,4)|0;c[8506]=j;k=a<<2;l=OV(k)|0;c[8502]=l;m=QV(a,4)|0;c[8504]=m;uW(l|0,-1,k|0)|0;if((d|0)==0){cb(34064,34080,393,34096)}if((e|0)==0){cb(34104,34080,394,34096)}if((f|0)==0){cb(34120,34080,395,34096)}if((g|0)==0){cb(34136,34080,396,34096)}if((h|0)==0){cb(34152,34080,397,34096)}if((l|0)==0){cb(34176,34080,398,34096)}if((m|0)==0){cb(34200,34080,399,34096)}if((j|0)==0){cb(34224,34080,400,34096)}else{i=b;return}}function Ns(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Os(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==3){c[g>>2]=c[b+8>>2];n=g+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];ur(17,0,o,36104,g);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];g=l+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ur(17,0,o,35904,l);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];l=j+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];ur(17,0,o,36008,j);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];j=m+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];ur(17,0,o,35856,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ur(17,0,o,36168,f);i=e;return}}function Ps(a){a=a|0;var b=0;b=i;PV(c[a+12>>2]|0);PV(c[a+4>>2]|0);PV(c[a+8>>2]|0);i=b;return}function Qs(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[5124]=.5;h[5110]=1.0;h[5147]=.25;h[5122]=2.0;h[5149]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[10256]=A;B=c[d>>2]|0;c[10186]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[10186]=D;if((C|0)<(B|0)){C=D}else{break}}}c[10184]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[5125]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[5125]=F;G=F}else{G=E}D=c[d>>2]|0;c[10186]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[10186]=I;if((H|0)>=(D|0)){break a}E=+h[5125];H=I}}}while(0);D=C+1|0;c[10184]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[5129]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[5094]=0.0;h[5096]=0.0;h[5100]=0.0;h[5157]=0.0;c[10182]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[5094]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[5096]+ +h[B>>3]*F;h[5096]=E;F=+h[I>>3];M=+h[5100]+F*F;h[5100]=M;F=+h[H>>3];h[5157]=+h[5157]+F*F;H=A+1|0;c[10182]=H;F=+h[5094];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[10252]=A;E=G/J;h[5146]=E;C=c[d>>2]|0;c[10186]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[5154]=0.0;h[5156]=0.0;I=c[b>>2]|0;c[10182]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[5123]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[5154]=ba;ca=E+aa*aa;h[5156]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[10182]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[10252]=A;h[5146]=E;h[5096]=Z;h[5100]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[10186]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[10182]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[10182]=A+1;da=+h[5096];ea=+h[5100];ga=+h[5094]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[5145]=K;c[10280]=0;h[5153]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[10280]=C;K=+h[5110]/+V(+ga);h[5125]=K;h[5148]=0.0;h[5150]=0.0;B=c[b>>2]|0;c[10182]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[5148]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[5148]=oa;pa=+h[5150]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[5150]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[5096];L=+h[5094];N=+h[5125];D=D+1|0;la=ma}c[10182]=B+1;ia=+h[5094];ja=pa;ka=oa}N=+h[5124];L=ka*N*ka;h[5141]=L;J=ja*N*ja;h[5142]=J;h[5101]=J+(L+ia*(+h[5157]+ia*N));N=+h[5122];h[40816>>3]=N*ka*ia;h[40824>>3]=N*ja*ia;h[40832>>3]=L-J;h[40840>>3]=ka*ja;la=40848|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[10182]=10;la=c[d>>2]|0;c[10186]=1;if((la|0)>=1){D=1;while(1){h[5141]=0.0;h[5142]=0.0;h[5143]=0.0;A=c[b>>2]|0;c[10182]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[5141]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[5142]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[5143]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[10182]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[5147]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[5141]*+h[5143];h[t+(U+D<<3)>>3]=+h[5142]*+h[5143];J=+h[5141];L=+h[5142];h[t+(P+D<<3)>>3]=+h[5147]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[5124]*+h[5141]*+h[5142];na=D+1|0;c[10186]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[10182]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[10194]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[10182]=B;if((la|0)<(D|0)){la=B}else{break}}}c[10190]=1;la=1;do{D=c[d>>2]|0;c[10198]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[10198]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[10186]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[10186]=D+1}na=c[10256]|0;c[10184]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[5121]=0.0;ma=c[d>>2]|0;c[10186]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[5121]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[10186]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[5121]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[10186]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[5121];Ca=Ca+1|0}c[10186]=ta+1}Ca=B+1|0;c[10184]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[10186]=1;if((A|0)<1){break}else{Ea=1}while(1){h[5121]=0.0;B=c[b>>2]|0;c[10184]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[5121]=N;Ca=na+1|0;c[10184]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[10186]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[10184]=1;if((A|0)>=1){ta=1;while(1){h[5121]=0.0;c[10182]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[5121]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[10182]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[10184]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[10190]=la;}while((la|0)<6);la=c[l>>2]|0;c[10186]=1;h[5121]=0.0;c[10182]=1;L=+h[5124];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[40888+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[40888+(A+ -1<<3)>>3]+L;h[5121]=L;A=A+1|0;}while((A|0)<6);h[5101]=+h[5101]- +h[5111]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[5141]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[5142]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[5143]=O;h[40816>>3]=+h[40816>>3]-J-N*(O+K);h[40848>>3]=+h[40848>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[5141]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[5142]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[5143]=J;h[40824>>3]=+h[40824>>3]-O-N*(K-J);h[40856>>3]=+h[40856>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[5141]=J;h[40832>>3]=+h[40904>>3]+(+h[40832>>3]-J- +h[40896>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[5141]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[5142]=K;Oa=+h[5124];h[40840>>3]=+h[40840>>3]-J-K*Oa;h[40864>>3]=+h[40864>>3]- +h[40912>>3]+ +h[40920>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[5141]=K;h[40872>>3]=+h[40872>>3]-Oa*K;h[5121]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[10186]=la+1;c[10182]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[40888+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[40888+(ta+ -1<<3)>>3]+N;h[5121]=N;ta=ta+1|0;c[10182]=ta;}while((ta|0)<6);K=+h[5129];h[5131]=K*+h[5101]+ +h[5111]+N;J=+h[5122];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[5141]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[5142]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[5143]=R;T=R+(K*+h[40816>>3]+O+S);h[41056>>3]=T;O=K*+h[40848>>3]+S-R;h[41088>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[5141]=R;S=+h[I>>3]*+h[ma>>3];h[5142]=S;Z=+h[Ma>>3]*+h[Na>>3];h[5143]=Z;h[41064>>3]=K*+h[40824>>3]+R+S-Z;h[41096>>3]=K*+h[40856>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[5141]=Z;R=+h[40896>>3]+(Z+K*+h[40832>>3])- +h[40904>>3];h[41072>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[5141]=Z;h[41080>>3]=Z+K*+h[40840>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[40864>>3]+ +h[40912>>3]- +h[40920>>3];h[41104>>3]=J;h[41112>>3]=+h[5129]*+h[40872>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[5131]+T+R+O+J;h[5121]=K;h[5151]=K;h[5152]=K;c[10288]=0;J=+h[5149]/50.0;h[5125]=J;h[5111]=+h[5110];c[10182]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[40896>>3]=Z;W=+Y(+Pa);h[40904>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[40888+(Ma+ -1<<3)>>3]=Z;Q=+h[40896>>3]*G+ +h[40904>>3]*W;h[40888+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[40904>>3];ca=+h[40896>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[41048+(Ma<<3)>>3]*+h[40888+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[5152]=Ra;c[10288]=Na;h[5141]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[5142]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[10184]=10;h[5121]=Ra;h[5130]=Pa;h[5155]=O;c[10182]=50;if((Xa|0)==49){h[5142]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[5141]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[5127]=0.0;if(Ya!=Za){S=Ya-Ua;h[5141]=S;T=Za-Ua;h[5142]=T;R=+h[5124]*(S-T)/(S+T);h[5127]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[5130]=R;T=+X(+R);h[40896>>3]=T;S=+Y(+R);h[40904>>3]=S;c[10184]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[40888+(Na+ -1<<3)>>3]=T;W=+h[40896>>3]*G+ +h[40904>>3]*S;h[40888+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[40904>>3];N=+h[40896>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[5152]=0.0;c[10184]=1;Na=1;do{ma=Na+ -1|0;Ma=40888+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[40808+(ma<<3)>>3]*+h[Ma>>3];h[5152]=+h[5152]+ +h[41048+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[10184]=10;Na=c[l>>2]|0;c[10186]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[40888+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[10184]=6;c[10186]=Na+1}h[5120]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[5094]=0.0;h[5141]=0.0;h[5142]=0.0;Ma=c[b>>2]|0;c[10182]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[40896>>3]*+h[la>>3]+ +h[40904>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[5094]=+h[5094]+G*G;bb=+h[5141]+ +h[la>>3]*+h[ta>>3];h[5141]=bb;G=+h[ta>>3];cb=+h[5142]+G*G;h[5142]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[10182]=Ma+1;$a=cb;ab=bb}ma=c[10280]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[5153];S=+h[5151];h[5153]=G>=S?G:S}S=+h[5152];if(!(S>=0.0)){db=-S}else{db=S}G=+h[5153];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[5153]=S;c[10182]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[5125]=N;R=+h[5120]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[5129];la=ta+1|0;c[10182]=la;if((ta|0)>=(Na|0)){break b}S=+h[5142];G=+h[5141];ta=la}}}while(0);Na=c[d>>2]|0;c[10186]=1;if((Na|0)>=1){Ma=1;while(1){h[5121]=0.0;ta=c[b>>2]|0;c[10184]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[5121]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[10184]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[5120]*+h[p+(la+ -1+Ma<<3)>>3]- +h[5129]*+h[q+(Ma+ -1<<3)>>3]);h[5125]=G;c[10182]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[5125];I=I+1|0}c[10182]=la+1}I=Ma+1|0;c[10186]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[5100]=0.0;h[5096]=0.0;Ma=c[b>>2]|0;c[10182]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[5100]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[5096]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[10182]=Ma+1;hb=kb;ib=jb}S=+h[5094];G=S*ib-hb*hb;h[5145]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[40784]=1;C=c[l>>2]|0;c[10186]=1;if((C|0)<1){lb=40880;mb=+h[5110];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[40888+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[10184]=6;c[10186]=C+1;lb=40880;mb=+h[5110];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function Rs(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[5177]=.5;h[5173]=1.0;h[5189]=6.283185307179586;z=+h[n>>3];h[5186]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[10360]=A;c[10368]=0;B=c[d>>2]|0;c[10320]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[10320]=B+1}c[10318]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[5178]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[5178]=F;G=F}else{G=z}H=c[d>>2]|0;c[10320]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[5178];I=I+1|0}c[10320]=H+1}I=B+1|0;c[10318]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[5161]=0.0;D=c[b>>2]|0;c[10316]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[5161]=+h[5161]+G*G;A=p+1|0;c[10316]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[10320]=1;if((p|0)>=1){D=1;while(1){h[5178]=0.0;h[5176]=0.0;y=c[b>>2]|0;c[10318]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[5178]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[5176]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[10318]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[5178]=G;h[5176]=+h[g>>3]*L;g=c[b>>2]|0;c[10316]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[5176]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[5178];H=H+1|0}c[10316]=g+1}H=D+1|0;c[10320]=H;if((D|0)<(p|0)){D=H}else{break}}}h[5162]=0.0;h[5164]=0.0;h[5171]=0.0;D=c[b>>2]|0;c[10316]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[5162]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[5164]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[5171]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[10316]=D+1;O=R;P=T;Q=S}S=+h[5161];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[5182]=U;h[5178]=0.0;if(Q*Q>S*.99*O){h[5178]=+h[5173]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[5177]*U*Z);h[5174]=P;if(O*+h[5186]<P*P*.01){h[5178]=+h[5173]}n=c[b>>2]|0;c[10316]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[5182]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[5178]*U;if((D|0)>=(n|0)){break}e=D;P=+h[5182];D=D+1|0;p=e}c[10316]=n+1;_=0}while(1){n=_+1|0;c[10368]=n;h[5161]=0.0;h[5164]=0.0;h[5165]=0.0;p=c[b>>2]|0;c[10316]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[5161]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[5164]=da;Z=+h[H>>3];ea=P+Z*Z;h[5165]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[10316]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[5178]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[5183]=U;D=c[b>>2]|0;c[10316]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[5183];U=+h[5164];O=+h[5161];g=g+1|0;H=e}c[10316]=D+1}H=c[d>>2]|0;c[10320]=1;if((H|0)>=1){g=1;while(1){h[5176]=0.0;p=c[b>>2]|0;c[10318]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[5176]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[10318]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[5176]=O;e=c[b>>2]|0;c[10316]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[5176];l=l+1|0}c[10316]=e+1}l=g+1|0;c[10320]=l;if((g|0)<(H|0)){g=l}else{break}}}h[5166]=0.0;h[5167]=0.0;h[5168]=0.0;h[5169]=0.0;h[5170]=0.0;g=c[b>>2]|0;c[10316]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[5166]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[5167]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[5168]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[5169]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[5170]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[10316]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[5177];O=U*na;h[5166]=O;P=U*ma-O;h[5169]=P;Z=O+la+P;h[5190]=Z;h[5192]=Z;h[5191]=Z;c[10370]=0;a[41304]=1;W=+h[5189]/50.0;h[5178]=W;c[10316]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[5192]=wa;c[10370]=p;h[5187]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[5188]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[5181]=ta;h[5172]=ua;h[5175]=va;h[5174]=wa;c[10316]=50;h[5191]=wa;if((za|0)==49){h[5188]=Z;Ba=Z}else if((za|0)==0){h[5187]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[5188]}h[5179]=0.0;S=+h[5187];if(S!=Ba){Q=S-Aa;h[5187]=Q;S=Ba-Aa;h[5188]=S;T=U*(Q-S)/(Q+S);h[5179]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[5181]=T;S=+X(+T);h[5172]=S;Q=+Y(+T);h[5175]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[5174]=T;p=c[b>>2]|0;c[10316]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[5172]*+h[y>>3]+ +h[5175]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[5175];Q=+h[5172];H=H+1|0;g=e}c[10316]=p+1;Da=+h[5174]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[5190];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function Ss(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[41760]=1;a[41752]=1;c[41772>>2]=6;rK(41768)|0;e=c[d>>2]|0;c[10436]=1;if((e|0)>=1){d=1;do{IJ(41888,b+(d+ -1)|0,1)|0;o=c[10436]|0;d=o+1|0;c[10436]=d;}while((o|0)<(e|0))}$J()|0;e=c[g>>2]|0;if((e|0)==1){c[41796>>2]=a[41752]&1?6:0;rK(41792)|0;IJ(41888,h,4)|0;$J()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[41820>>2]=a[41752]&1?6:0;rK(41816)|0;IJ(41888,h,4)|0;IJ(41888,j,4)|0;$J()|0}j=c[k>>2]|0;if((j|0)==1){c[41844>>2]=a[41752]&1?6:0;rK(41840)|0;IJ(41888,l,8)|0;$J()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[41868>>2]=a[41752]&1?6:0;rK(41864)|0;IJ(41888,l,8)|0;IJ(41888,m,8)|0;$J()|0}if((c[f>>2]|0)==2){qJ(41896,0)|0}else{i=n;return 0}return 0}



function uK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;QK(101664,h,101720);c[25238]=103172;c[100960>>2]=103192;c[100956>>2]=0;HM(100960|0,101664);c[101032>>2]=0;c[101036>>2]=-1;j=c[t>>2]|0;c[25442]=103040;pS(101772|0);k=101776|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[25442]=102280;c[101800>>2]=j;qS(g,101772|0);k=tS(g,105832)|0;l=k;rS(g);c[101804>>2]=l;c[101808>>2]=101728;a[101812|0]=(he[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[25260]=103252;c[101044>>2]=103272;HM(101044|0,101768);c[101116>>2]=0;c[101120>>2]=-1;l=c[r>>2]|0;c[25454]=103040;pS(101820|0);k=101824|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[25454]=102280;c[101848>>2]=l;qS(f,101820|0);k=tS(f,105832)|0;g=k;rS(f);c[101852>>2]=g;c[101856>>2]=101736;a[101860|0]=(he[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[25282]=103252;c[101132>>2]=103272;HM(101132|0,101816);c[101204>>2]=0;c[101208>>2]=-1;g=c[(c[(c[25282]|0)+ -12>>2]|0)+101152>>2]|0;c[25304]=103252;c[101220>>2]=103272;HM(101220|0,g);c[101292>>2]=0;c[101296>>2]=-1;c[(c[(c[25238]|0)+ -12>>2]|0)+101024>>2]=101040;g=(c[(c[25282]|0)+ -12>>2]|0)+101132|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[25282]|0)+ -12>>2]|0)+101200>>2]=101040;CK(101864,h,101744|0);c[25326]=103212;c[101312>>2]=103232;c[101308>>2]=0;HM(101312|0,101864);c[101384>>2]=0;c[101388>>2]=-1;c[25480]=103104;pS(101924|0);h=101928|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[25480]=102024;c[101952>>2]=j;qS(e,101924|0);j=tS(e,105840)|0;h=j;rS(e);c[101956>>2]=h;c[101960>>2]=101752;a[101964|0]=(he[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[25348]=103292;c[101396>>2]=103312;HM(101396|0,101920);c[101468>>2]=0;c[101472>>2]=-1;c[25492]=103104;pS(101972|0);h=101976|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[25492]=102024;c[102e3>>2]=l;qS(d,101972|0);l=tS(d,105840)|0;h=l;rS(d);c[102004>>2]=h;c[102008>>2]=101760;a[102012|0]=(he[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[25370]=103292;c[101484>>2]=103312;HM(101484|0,101968);c[101556>>2]=0;c[101560>>2]=-1;h=c[(c[(c[25370]|0)+ -12>>2]|0)+101504>>2]|0;c[25392]=103292;c[101572>>2]=103312;HM(101572|0,h);c[101644>>2]=0;c[101648>>2]=-1;c[(c[(c[25326]|0)+ -12>>2]|0)+101376>>2]=101392;h=(c[(c[25370]|0)+ -12>>2]|0)+101484|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[25370]|0)+ -12>>2]|0)+101552>>2]=101392;i=b;return}function vK(a){a=a|0;a=i;FN(101040)|0;FN(101216)|0;MN(101392)|0;MN(101568)|0;i=a;return}function wK(a){a=a|0;var b=0;b=i;c[a>>2]=103104;rS(a+4|0);i=b;return}function xK(a){a=a|0;var b=0;b=i;c[a>>2]=103104;rS(a+4|0);WV(a);i=b;return}function yK(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;he[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=tS(d,105840)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(he[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function zK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=xe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((qc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((td(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function AK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=qc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((we[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function BK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((qc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Fe[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((qc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((qc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function CK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=103104;j=b+4|0;pS(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=102136;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;qS(g,j);j=tS(g,105840)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=he[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(he[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){BR(102232)}else{rS(g);i=f;return}}function DK(a){a=a|0;var b=0;b=i;c[a>>2]=103104;rS(a+4|0);i=b;return}function EK(a){a=a|0;var b=0;b=i;c[a>>2]=103104;rS(a+4|0);WV(a);i=b;return}function FK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=tS(d,105840)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=he[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(he[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){BR(102232)}else{i=e;return}}function GK(a){a=a|0;var b=0,c=0;b=i;c=JK(a,0)|0;i=b;return c|0}function HK(a){a=a|0;var b=0,c=0;b=i;c=JK(a,1)|0;i=b;return c|0}function IK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Fe[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function JK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=dd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Fe[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=dd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((qd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function KK(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);i=b;return}function LK(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);WV(a);i=b;return}function MK(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;he[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=tS(d,105832)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(he[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function NK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=xe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((qc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((td(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function OK(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=qc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((we[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function PK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((qc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Fe[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((qc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((qc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function QK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=103040;j=b+4|0;pS(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=102392;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;qS(g,j);j=tS(g,105832)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=he[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(he[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){BR(102232)}else{rS(g);i=f;return}}function RK(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);i=b;return}function SK(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);WV(a);i=b;return}function TK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=tS(d,105832)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=he[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(he[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){BR(102232)}else{i=e;return}}function UK(a){a=a|0;var b=0,c=0;b=i;c=XK(a,0)|0;i=b;return c|0}function VK(a){a=a|0;var b=0,c=0;b=i;c=XK(a,1)|0;i=b;return c|0}function WK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Fe[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function XK(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=dd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Fe[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=dd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((qd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function YK(){var a=0;a=i;uK(0);Yd(204,101656,q|0)|0;i=a;return}function ZK(a){a=a|0;i=i;return}function _K(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function $K(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}ee[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function aL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=102536;e=qW(b|0)|0;f=VV(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;sW(g|0,b|0,e+1|0)|0;i=d;return}function bL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=102536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}XV((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}function cL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=102536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}XV((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function dL(a){a=a|0;i=i;return c[a+4>>2]|0}function eL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=102560;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=qW(f|0)|0;g=VV(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;sW(h|0,f|0,d+1|0)|0;i=e;return}function fL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=102560;e=qW(b|0)|0;f=VV(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;sW(g|0,b|0,e+1|0)|0;i=d;return}function gL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=102560;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}XV((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}function hL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=102560;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}XV((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function iL(a){a=a|0;i=i;return c[a+4>>2]|0}function jL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=102536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}XV((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}function kL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=102536;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}XV((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;WV(j);i=b;return}function lL(a){a=a|0;i=i;return}function mL(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function nL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;De[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function oL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function pL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Vd(e|0)|0;e=qW(f|0)|0;if(e>>>0>4294967279){vL(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;sW(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=UV(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;sW(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function qL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{aM(e,102776,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;De[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}aM(e,o,p)|0;if((a[g]&1)==0){break}WV(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function rL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=qW(e|0)|0;if(j>>>0>4294967279){vL(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=UV(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}sW(k|0,e|0,j|0)|0;a[k+j|0]=0;qL(g,d,h);eL(b,g);if(!((a[g]&1)==0)){WV(c[g+8>>2]|0)}if(!((a[h]&1)==0)){WV(c[h+8>>2]|0)}c[b>>2]=102792;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function sL(a){a=a|0;var b=0;b=i;hL(a);WV(a);i=b;return}function tL(a){a=a|0;var b=0;b=i;hL(a);i=b;return}function uL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;sc(102928)|0;if((c[a>>2]|0)==1){do{nd(102952,102928)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;ec(102928)|0;ee[d&255](b);sc(102928)|0;c[a>>2]=-1;ec(102928)|0;ad(102952)|0;i=e;return}else{ec(102928)|0;i=e;return}}function vL(a){a=a|0;a=Dc(8)|0;aL(a,103e3);c[a>>2]=102616;Sd(a|0,102656,40)}function wL(a){a=a|0;a=Dc(8)|0;aL(a,103e3);c[a>>2]=102680;Sd(a|0,102720,40)}function xL(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yL(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){vL(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=UV(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}sW(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function AL(b){b=b|0;i=i;return(a[b]&1)!=0|0}function BL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){vL(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=UV(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}sW(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function CL(a){a=a|0;i=i;return a|0}function DL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=qW(d|0)|0;if(f>>>0>4294967279){vL(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;sW(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=UV(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;sW(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function EL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){vL(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=UV(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}uW(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function FL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){vL(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;uW(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=UV(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;uW(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function GL(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){wL(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){vL(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;sW(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=UV(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;sW(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function HL(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function IL(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function JL(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}WV(c[b+8>>2]|0);i=d;return}function KL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}bM(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}tW(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function LL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ML(a,b)|0;i=c;return d|0}function ML(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=qW(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}bM(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}tW(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function NL(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function OL(a){a=a|0;i=i;return a+1|0}function PL(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function QL(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function RL(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function SL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){TL(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function TL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){cM(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}uW(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function UL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){TL(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function VL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){vL(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=UV(f)|0}else{p=UV(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}sW(l|0,n|0,q+1|0)|0;if(o){WV(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function WL(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function XL(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function YL(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function ZL(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function _L(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=aM(b,g,h)|0;i=e;return d|0}function $L(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){cM(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function aM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){bM(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}sW(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function bM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){vL(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=UV(q)|0;if((g|0)!=0){sW(e|0,m|0,g|0)|0}if((j|0)!=0){sW(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){sW(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){WV(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function cM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){vL(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=UV(p)|0;if((g|0)!=0){sW(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){sW(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}WV(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function dM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;GL(a,b,c,d,0);i=e;return}function eM(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function fM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=qW(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function gM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=lW(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function hM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=qW(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){wL(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=lW(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function iM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){vL(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;sW(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=UV(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;sW(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function jM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){vL(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=UV(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}pV(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function kM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){vL(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=UV(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}rV(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function lM(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}WV(c[b+8>>2]|0);i=d;return}function mM(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nM(a,b,oV(b)|0)|0;i=c;return d|0}function nM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}qM(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}qV(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function oM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){vL(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=UV(f)|0}else{p=UV(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}pV(l,n,q+1|0)|0;if(o){WV(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function pM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){rM(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function qM(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){vL(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=UV(q<<2)|0;p=e;if((g|0)!=0){pV(p,m,g)|0}if((j|0)!=0){pV(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){pV(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){WV(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function rM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){vL(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=UV(p<<2)|0;o=e;if((g|0)!=0){pV(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){pV(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}WV(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function sM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=qW(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){vL(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=UV(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}sW(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=aM(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=aM(b,m,j)|0;i=f;return}}function tM(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function uM(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function vM(a,b){a=a|0;b=b|0;var c=0;c=i;wM(a,b);i=c;return}function wM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Dc(16)|0;do{if((a[103384]|0)==0){if((Za(103384)|0)==0){break}c[25844]=104080;Yd(66,103376,q|0)|0;Sb(103384)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=103376;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];rL(b,f,103432);c[e>>2]=103400;Sd(e|0,103480,62)}function xM(a,b){a=a|0;b=b|0;var d=0;d=i;wM(a,c[a+16>>2]|b);i=d;return}function yM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=103424;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;De[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}rS(a+28|0);PV(c[e>>2]|0);PV(c[f>>2]|0);PV(c[a+48>>2]|0);PV(c[a+60>>2]|0);i=b;return}function zM(a){a=a|0;var b=0;b=i;yM(a);WV(a);i=b;return}function AM(a){a=a|0;var b=0;b=i;yM(a);i=b;return}function BM(a){a=a|0;var b=0;b=i;yM(a);i=b;return}function CM(a){a=a|0;i=i;return c[a+24>>2]|0}function DM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}qS(d,a+28|0);a=tS(d,105768)|0;f=we[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;rS(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function EM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;qS(e,a+28|0);a=tS(e,105768)|0;f=we[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;rS(e);i=d;return f|0}function FM(a,b){a=a|0;b=b|0;var c=0;c=i;qS(a,b+28|0);i=c;return}function GM(a){a=a|0;c[a>>2]=103024;i=i;return}function HM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));pS(b);i=d;return}function IM(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);WV(a);i=b;return}function JM(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);i=b;return}function KM(a){a=a|0;var b=0;b=i;c[a>>2]=103040;rS(a+4|0);i=b;return}function LM(a,b){a=a|0;b=b|0;var c=0;c=i;qS(a,b+4|0);i=c;return}function MM(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=he[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function NM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=we[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function OM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ke[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function PM(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=103040;pS(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function QM(a){a=a|0;i=i;return c[a+8>>2]|0}function RM(a){a=a|0;i=i;return c[a+12>>2]|0}function SM(a){a=a|0;i=i;return c[a+16>>2]|0}function TM(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function UM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function VM(a){a=a|0;i=i;return c[a+20>>2]|0}function WM(a){a=a|0;i=i;return c[a+24>>2]|0}function XM(a){a=a|0;i=i;return c[a+28>>2]|0}function YM(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function ZM(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function _M(a,b){a=a|0;b=b|0;i=i;return}function $M(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function aN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function bN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function cN(a){a=a|0;i=i;return 0}function dN(a){a=a|0;i=i;return 0}function eN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=he[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function fN(a){a=a|0;i=i;return-1}function gN(a){a=a|0;var b=0,e=0,f=0;b=i;if((he[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function hN(a,b){a=a|0;b=b|0;i=i;return-1}function iN(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((we[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function jN(a,b){a=a|0;b=b|0;i=i;return-1}function kN(a){a=a|0;var b=0;b=i;c[a>>2]=103104;rS(a+4|0);WV(a);i=b;return}function lN(a){a=a|0;var b=0;b=i;c[a>>2]=103104;rS(a+4|0);i=b;return}function mN(a,b){a=a|0;b=b|0;i=i;return}function nN(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function oN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function pN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function qN(a){a=a|0;i=i;return 0}function rN(a){a=a|0;i=i;return 0}function sN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=he[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function tN(a){a=a|0;i=i;return-1}function uN(a){a=a|0;var b=0,d=0,e=0;b=i;if((he[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function vN(a,b){a=a|0;b=b|0;i=i;return-1}function wN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((we[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function xN(a,b){a=a|0;b=b|0;i=i;return-1}function yN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));pS(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function zN(a){a=a|0;var b=0;b=i;yM(a+8|0);WV(a);i=b;return}function AN(a){a=a|0;var b=0;b=i;yM(a+8|0);i=b;return}function BN(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;yM(a+(d+8)|0);WV(a+d|0);i=b;return}function CN(a){a=a|0;var b=0;b=i;yM(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function DN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;EN(a,b,c);i=d;return}function EN(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){wM(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){FN(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}qS(h,e+(k+28)|0);k=tS(h,105768)|0;rS(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(he[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(he[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){he[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((he[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;wM(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function FN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{FN(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((he[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;wM(b+h|0,c[b+(h+16)>>2]|1)}}while(0);UN(e);i=d;return b|0}function GN(b){b=b|0;i=i;return(a[b]|0)!=0|0}function HN(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function IN(a){a=a|0;var b=0;b=i;yM(a+8|0);WV(a);i=b;return}function JN(a){a=a|0;var b=0;b=i;yM(a+8|0);i=b;return}function KN(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;yM(a+(d+8)|0);WV(a+d|0);i=b;return}function LN(a){a=a|0;var b=0;b=i;yM(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function MN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{MN(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((he[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;wM(b+h|0,c[b+(h+16)>>2]|1)}}while(0);eO(e);i=d;return b|0}function NN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));pS(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function ON(a){a=a|0;var b=0;b=i;yM(a+4|0);WV(a);i=b;return}function PN(a){a=a|0;var b=0;b=i;yM(a+4|0);i=b;return}function QN(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;yM(a+(d+4)|0);WV(a+d|0);i=b;return}function RN(a){a=a|0;var b=0;b=i;yM(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function SN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){FN(g)|0}a[f]=1;i=e;return}function TN(a){a=a|0;var b=0;b=i;UN(a);i=b;return}function UN(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((he[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;wM(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function VN(b){b=b|0;i=i;return(a[b]|0)!=0|0}function WN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=he[b&127](a)|0;i=c;return d|0}function XN(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){UN(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{FN(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;qS(k,b+(p+28)|0);p=tS(k,104488)|0;m=p;rS(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){qS(h,b+(k+28)|0);r=tS(h,105768)|0;s=we[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;rS(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ne[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){UN(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;wM(b+l|0,c[b+(l+16)>>2]|5);UN(j);i=e;return b|0}function YN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){UN(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{FN(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;UN(f);i=e;return b|0}if((we[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{UN(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;wM(b+d|0,c[b+(d+16)>>2]|1);UN(f);i=e;return b|0}function ZN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){UN(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){FN(k)|0}a[h]=1;if((e|0)==0){UN(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ke[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){UN(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;wM(b+e|0,c[b+(e+16)>>2]|1);UN(g);i=f;return b|0}function _N(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;qe[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function $N(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){UN(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{FN(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];He[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){UN(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;wM(b+f|0,c[b+(f+16)>>2]|4);UN(h);i=e;return b|0}function aO(a){a=a|0;var b=0;b=i;yM(a+4|0);WV(a);i=b;return}function bO(a){a=a|0;var b=0;b=i;yM(a+4|0);i=b;return}function cO(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;yM(a+(d+4)|0);WV(a+d|0);i=b;return}function dO(a){a=a|0;var b=0;b=i;yM(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function eO(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((he[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;wM(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function fO(a){a=a|0;i=i;return 103320}function gO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){BL(a,103336,35);i=d;return}else{pL(a,b,c);i=d;return}}function hO(a){a=a|0;i=i;return}function iO(a){a=a|0;var b=0;b=i;tL(a);WV(a);i=b;return}function jO(a){a=a|0;var b=0;b=i;tL(a);i=b;return}function kO(a){a=a|0;var b=0;b=i;yM(a);WV(a);i=b;return}function lO(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function mO(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function nO(a){a=a|0;i=i;return}function oO(a){a=a|0;i=i;return}function pO(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function qO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){vL(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=UV(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function rO(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function sO(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function tO(a){a=a|0;i=i;return}function uO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function vO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){vL(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=UV(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function wO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function xO(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function yO(a){a=a|0;i=i;return}function zO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];te[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}FM(u,g);m=u;u=c[m>>2]|0;if(!((c[26442]|0)==-1)){c[p>>2]=105768;c[p+4>>2]=205;c[p+8>>2]=0;uL(105768,p,206)}p=(c[105772>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}F=u;$K(c[m>>2]|0)|0;FM(v,g);g=v;v=c[g>>2]|0;if(!((c[26478]|0)==-1)){c[o>>2]=105912;c[o+4>>2]=205;c[o+8>>2]=0;uL(105912,o,206)}o=(c[105916>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}J=v;$K(c[g>>2]|0)|0;g=w;fe[c[(c[v>>2]|0)+24>>2]&127](g,J);fe[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=AO(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];JL(w+12|0);JL(w);i=k;return}function AO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=OV(l)|0;if((n|0)!=0){o=n;p=n;break}$V()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((he[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((he[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(he[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=we[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(we[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){he[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((he[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}PV(o);i=k;return _|0}function BO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];CO(a,0,k,j,f,g,h);i=b;return}function CO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;sP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}SL(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}SL(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(he[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((UO(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=oU(F,c[o>>2]|0,h,t)|0;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((he[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}function DO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];EO(a,0,k,j,f,g,h);i=b;return}function EO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;sP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}SL(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}SL(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(he[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((UO(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=nU(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((he[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}function FO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];GO(a,0,k,j,f,g,h);i=b;return}function GO(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;sP(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((he[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((he[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}SL(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}SL(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(he[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((UO(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){he[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=mU(G,c[p>>2]|0,j,u)|0;FR(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;JL(o);JL(n);i=e;return}if((he[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;JL(o);JL(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;JL(o);JL(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;JL(o);JL(n);i=e;return}function HO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];IO(a,0,k,j,f,g,h);i=b;return}function IO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;sP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}SL(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}SL(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(he[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((UO(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=lU(F,c[o>>2]|0,h,t)|0;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((he[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}function JO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];KO(a,0,k,j,f,g,h);i=b;return}function KO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;sP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}SL(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}SL(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(he[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((UO(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=kU(F,c[o>>2]|0,h,t)|0;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((he[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;JL(n);JL(m);i=d;return}function LO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];MO(a,0,k,j,f,g,h);i=b;return}function MO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;sP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((he[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((he[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}SL(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}SL(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(he[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((UO(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=jU(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((he[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;JL(n);JL(m);i=d;return}function NO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];OO(a,0,k,j,f,g,h);i=b;return}function OO(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;tP(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((he[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}SL(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}SL(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(he[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((uP(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+iU(I,c[p>>2]|0,j);FR(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((he[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}if((he[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}function PO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QO(a,0,k,j,f,g,h);i=b;return}function QO(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;tP(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((he[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}SL(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}SL(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(he[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((uP(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+hU(I,c[p>>2]|0,j);FR(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((he[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}if((he[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}function RO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SO(a,0,k,j,f,g,h);i=b;return}function SO(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;tP(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((he[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((he[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}SL(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}SL(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(he[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((uP(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){he[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+gU(I,c[p>>2]|0,j);FR(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((he[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}if((he[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;JL(o);JL(n);i=d;return}function TO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FM(o,g);g=o;o=c[g>>2]|0;if(!((c[26442]|0)==-1)){c[l>>2]=105768;c[l+4>>2]=205;c[l+8>>2]=0;uL(105768,l,206)}l=(c[105772>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Dc(4)|0;w=v;tV(w);x=121328;y=127;Sd(v|0,x|0,y|0)}y=m;Ge[c[(c[o>>2]|0)+32>>2]&63](o,104312,104338|0,y)|0;$K(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((he[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((he[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}SL(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}SL(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(he[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((UO(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){he[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);K=c[26414]|0;c[k>>2]=j;if((VO(E,K,104352,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((he[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;JL(p);JL(n);i=d;return}if((he[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;JL(p);JL(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;JL(p);JL(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;JL(p);JL(n);i=d;return}function UO(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[104312+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[104312+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function VO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function WO(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function XO(a){a=a|0;i=i;return}function YO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];te[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}FM(u,g);m=u;u=c[m>>2]|0;if(!((c[26440]|0)==-1)){c[p>>2]=105760;c[p+4>>2]=205;c[p+8>>2]=0;uL(105760,p,206)}p=(c[105764>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}F=u;$K(c[m>>2]|0)|0;FM(v,g);g=v;v=c[g>>2]|0;if(!((c[26480]|0)==-1)){c[o>>2]=105920;c[o+4>>2]=205;c[o+8>>2]=0;uL(105920,o,206)}o=(c[105924>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}J=v;$K(c[g>>2]|0)|0;g=w;fe[c[(c[v>>2]|0)+24>>2]&127](g,J);fe[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=ZO(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];lM(w+12|0);lM(w);i=k;return}function ZO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=OV(l)|0;if((n|0)!=0){o=n;p=n;break}$V()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=he[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=he[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=we[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(we[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){he[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=he[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}PV(o);i=k;return ba|0}function _O(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$O(a,0,k,j,f,g,h);i=b;return}function $O(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;vP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=he[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=he[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}SL(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}SL(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((rP(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=oU(I,c[o>>2]|0,h,t)|0;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=he[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;JL(n);JL(m);i=d;return}function aP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];bP(a,0,k,j,f,g,h);i=b;return}function bP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;vP(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;SL(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=he[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=he[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}SL(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}SL(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((rP(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){he[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=nU(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;FR(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=he[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=he[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;JL(n);JL(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;JL(n);JL(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;JL(n);JL(m);i=d;return}function cP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dP(a,0,k,j,f,g,h);i=b;return}



function Eo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=wo(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=wo(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{p=34;break b;break};case 5:{p=28;break b;break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Ho(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=wo(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Ho(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Fo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wo(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 11:{n=48;break b;break};case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wo(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Go(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=wo(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 14:{break};case 29:{if((c[23608+((d[24888+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=wo(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 7:{l=36;break a;break};case 5:{l=30;break a;break};case 29:{if((c[23608+((d[23352+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 24:case 22:{break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=wo(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=wo(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=wo(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 3:{t=xo(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=wo(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=wo(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 24:case 22:{break d;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[23608+((d[23352+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Ho(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Io(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=wo(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=wo(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Jo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=wo(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wo(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=Co(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Ko(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wo(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Lo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=lp(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=wo(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 16:{k=mp(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=hp(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=wo(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 29:{g=b;if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[23608+((d[24888+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 30:{k=bp(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=lp(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=np(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=wo(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=wo(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=wo(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=111;break b;break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};case 6:{o=108;break b;break};case 5:{o=105;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{o=122;break b;break};case 5:{o=85;break b;break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};case 33:{o=119;break b;break};case 34:{o=116;break b;break};case 7:{o=91;break b;break};case 6:{o=88;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function Mo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wo(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=ap(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=ep(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=wo(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function No(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wo(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=wo(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Oo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=wo(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Po(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wo(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 21:{n=29;break a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=16;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ap(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=wo(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Qo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wo(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ap(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=bp(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=wo(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ro(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=wo(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};case 5:{break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=wo(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function So(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function To(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=wo(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Uo(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=wo(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Vo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=wo(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=wo(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Wo(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Jn(c)|0;k=j;i=b;return k|0}function Xo(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e]|0)==0){h=a[e+1|0]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){f=60;g=f;i=b;return g|0}else if((j|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Yo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=wo(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=wo(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Zo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=wo(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function _o(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function $o(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function ap(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=cp(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wo(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function bp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wo(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function cp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=dp(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wo(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function dp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=wo(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wo(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function ep(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 17:{k=ip(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wo(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=gp(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=fp(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 15:{k=hp(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=wo(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 17:{break b;break};case 11:{o=90;break b;break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=wo(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{o=65;break b;break};case 24:case 22:{break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 10:case 9:case 21:{o=69;break b;break};case 6:{o=42;break b;break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=wo(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=jp(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function fp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=wo(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function gp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[25928+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function hp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=wo(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=wo(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((kp(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=wo(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((kp(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function ip(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wo(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 23:{b=b+2|0;continue b;break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 11:{n=48;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wo(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function jp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=wo(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 29:{if((c[23608+((d[24888+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=wo(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 24:case 22:{break};case 29:{if((c[23608+((d[23352+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};case 7:{l=36;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=wo(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=wo(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=wo(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 3:{t=ap(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=wo(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=wo(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 10:case 9:case 21:{break};case 6:{l=100;break a;break};case 7:{l=103;break a;break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[23608+((d[23352+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function kp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function lp(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=wo(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=wo(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function mp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=wo(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wo(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=fp(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function np(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wo(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[23608+((d[23352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wo(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 29:{if((c[23608+((d[24888+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function op(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((we[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((we[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=Yp(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 12:{k=Yp(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 30:{k=Op(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((we[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((we[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=Zp(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=Up(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((we[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((we[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 19:{k=_p(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 34:{n=110;break b;break};case 15:{n=116;break b;break};case 33:{n=113;break b;break};case 7:{if((e-b|0)<4){n=82;break b}p=b;if((we[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=p+4|0;continue b;break};case 5:{if((e-b|0)<2){n=72;break b}q=b;if((we[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=q+2|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 6:{if((e-b|0)<3){n=77;break b}r=b;if((we[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=r+3|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=94;break b}s=b;if((we[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=s+2|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}t=b;if((we[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=t+4|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}u=b;if((we[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=u+3|0;continue b;break};case 29:{n=91;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{m=19;continue b}}break};case 29:{n=69;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==110){t=b;if((m|0)==19){c[f>>2]=t;k=0;l=k;i=h;return l|0}else{c[f>>2]=t+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){t=b;if((m|0)==19){c[f>>2]=t;k=0;l=k;i=h;return l|0}else{c[f>>2]=t+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){t=b;if((m|0)==19){c[f>>2]=t;k=0;l=k;i=h;return l|0}else{c[f>>2]=t+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function pp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=Np(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=Rp(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((we[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((we[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((we[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function qp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((we[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=47;break b}if((we[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((we[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((we[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function rp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((we[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((we[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}o=b;if((we[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=o+3|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function sp(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 2:{m=12;break a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 21:{m=23;break a;break};case 9:{m=16;break a;break};case 3:{m=9;break a;break};case 10:{m=13;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Np(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function tp(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 10:{m=15;break a;break};case 9:{m=18;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 3:{m=9;break a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Np(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Op(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function up(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function vp(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function wp(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};default:{break a}}}i=c;return a-b|0}function xp(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function yp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:case 11:{if((g|0)!=2){break a}break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function zp(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Jn(c)|0;g=f;i=b;return g|0}function Ap(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function Bp(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 7:{a=a+4|0;break};case 6:{a=a+3|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Cp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Dp(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Ep(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){o=j;j=o+2|0;b[o>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Fp(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[23608+(((d[24888+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Gp(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[23608+(((d[24888+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Hp(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Ip(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[23608+(((d[23352+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Jp(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[23608+(((d[23352+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Kp(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Lp(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Mp(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Np(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=Pp(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((we[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((we[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((we[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Op(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((we[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((we[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((we[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((we[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Pp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Qp(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}



function uQ(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;FM(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[26440]|0)==-1)){c[ba>>2]=105760;c[ba+4>>2]=205;c[ba+8>>2]=0;uL(105760,ba,206)}ba=(c[105764>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Dc(4)|0;Ga=Fa;tV(Ga);Ha=121328;Ia=127;Sd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Dc(4)|0;Ga=Fa;tV(Ga);Ha=121328;Ia=127;Sd(Fa|0,Ha|0,Ia|0)}Ia=ca;$K(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=yQ(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=yQ(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=yQ(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=yQ(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=yQ(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=yQ(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];wQ(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=yQ(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=yQ(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=he[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ka=ca+4|0;La=ca+4|0;Ma=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ka=Ha;La=Ha;Ma=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];lQ(za,d,q,p,g,h,j,La,Ka+(Ma<<2)|0);c[Da>>2]=c[za>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=yQ(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 65:case 97:{ca=c[f>>2]|0;Da=d+8|0;Ha=he[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(ZO(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];lQ(ga,d,L,K,g,h,j,104856,104888|0);c[ca>>2]=c[ga>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];xQ(0,e,m,h,Ia);break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];vQ(0,e,C,h,Ia);break};case 99:{ca=d+8|0;Ha=he[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Na=Ha+4|0;Oa=Ha+4|0;Pa=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Na=Da;Oa=Da;Pa=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];lQ(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[da>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=yQ(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];lQ(ra,d,y,x,g,h,j,104968,104988|0);c[Ha>>2]=c[ra>>2];break};case 104:case 66:case 98:{Ha=c[f>>2]|0;ca=d+8|0;Da=he[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Ha;c[P+0>>2]=c[$+0>>2];Ha=(ZO(e,P,Da,Da+288|0,Ia,h,0)|0)-Da|0;if((Ha|0)>=288){break a}c[j+16>>2]=((Ha|0)/12|0|0)%12|0;break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];lQ(ua,d,v,u,g,h,j,104992,105024|0);c[Ha>>2]=c[ua>>2];break};case 114:{Ha=e;c[pa>>2]=c[Ha>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];lQ(oa,d,A,z,g,h,j,104920,104964|0);c[Ha>>2]=c[oa>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];te[Ha&63](b,d,s,r,g,h,j);i=l;return};case 70:{Ha=e;c[ka>>2]=c[Ha>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];lQ(ja,d,J,I,g,h,j,104888,104920|0);c[Ha>>2]=c[ja>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function vQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=he[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=he[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=he[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ke[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){he[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=he[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=he[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function wQ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=he[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=ZO(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function xQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=he[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=he[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=he[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ke[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){he[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=he[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=he[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function yQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=he[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=he[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=he[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ke[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ke[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){he[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=he[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=he[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=he[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ke[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ke[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){he[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=he[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=he[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function zQ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);if((f|0)==(c[26414]|0)){g=b;WV(g);i=d;return}$b(c[e>>2]|0);g=b;WV(g);i=d;return}function AQ(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);if((b|0)==(c[26414]|0)){i=d;return}$b(c[e>>2]|0);i=d;return}function BQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(we[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function CQ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);if((f|0)==(c[26414]|0)){g=b;WV(g);i=d;return}$b(c[e>>2]|0);g=b;WV(g);i=d;return}function DQ(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);if((b|0)==(c[26414]|0)){i=d;return}$b(c[e>>2]|0);i=d;return}function EQ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;FQ(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=we[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function FQ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=RU(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){BR(106648)}else{c[e>>2]=d+(g<<2);i=j;return}}function GQ(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function HQ(a){a=a|0;i=i;return}function IQ(a){a=a|0;i=i;return 127}function JQ(a){a=a|0;i=i;return 127}function KQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function LQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function MQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function NQ(a,b){a=a|0;b=b|0;b=i;FL(a,1,45);i=b;return}function OQ(a){a=a|0;i=i;return 0}function PQ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function QQ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function RQ(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function SQ(a){a=a|0;i=i;return}function TQ(a){a=a|0;i=i;return 127}function UQ(a){a=a|0;i=i;return 127}function VQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function WQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function XQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function YQ(a,b){a=a|0;b=b|0;b=i;FL(a,1,45);i=b;return}function ZQ(a){a=a|0;i=i;return 0}function _Q(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function $Q(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function aR(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function bR(a){a=a|0;i=i;return}function cR(a){a=a|0;i=i;return 2147483647}function dR(a){a=a|0;i=i;return 2147483647}function eR(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function fR(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function gR(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function hR(a,b){a=a|0;b=b|0;b=i;kM(a,1,45);i=b;return}function iR(a){a=a|0;i=i;return 0}function jR(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function kR(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function lR(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function mR(a){a=a|0;i=i;return}function nR(a){a=a|0;i=i;return 2147483647}function oR(a){a=a|0;i=i;return 2147483647}function pR(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function qR(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function rR(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function sR(a,b){a=a|0;b=b|0;b=i;kM(a,1,45);i=b;return}function tR(a){a=a|0;i=i;return 0}function uR(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function vR(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function wR(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function xR(a){a=a|0;i=i;return}function yR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=207;y=o+100|0;FM(r,h);o=r;z=c[o>>2]|0;if(!((c[26442]|0)==-1)){c[n>>2]=105768;c[n+4>>2]=205;c[n+8>>2]=0;uL(105768,n,206)}n=(c[105772>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=AR(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ge[c[(c[z>>2]|0)+32>>2]&63](E,105384,105394|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=OV(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}$V()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[105384+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((wd(p|0,105400,m|0)|0)!=1){t=Dc(8)|0;fL(t,105408);Sd(t|0,102760,42)}if((F|0)==0){break}PV(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((he[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((he[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;$K(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ee[c[x>>2]&255](o);i=d;return}function zR(a){a=a|0;i=i;return}function AR(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;ER(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=207;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((he[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((he[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(he[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(he[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}$L(A,ea);X=26;break};case 0:{X=26;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){fa=(a[O]|0)!=0}else{fa=0}if(!(I|fa)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}da=a[x]|0;W=(da&1)==0;ba=W?j:c[J>>2]|0;c:do{if((p|0)==0){ma=Y;na=Y;oa=da;pa=ba}else{if((d[s+(p+ -1)|0]|0)>=2){ma=Y;na=Y;oa=da;pa=ba;break}qa=ba+(W?(da&255)>>>1:c[K>>2]|0)|0;ra=ba;while(1){if((ra|0)==(qa|0)){sa=qa;break}ta=a[ra]|0;if(!(ta<<24>>24>-1)){sa=ra;break}if((b[(c[f>>2]|0)+(ta<<24>>24<<1)>>1]&8192)==0){sa=ra;break}else{ra=ra+1|0}}ra=sa-ba|0;qa=a[A]|0;ta=(qa&1)==0;if(ta){ua=(qa&255)>>>1}else{ua=c[N>>2]|0}if(ra>>>0>ua>>>0){ma=Y;na=Y;oa=da;pa=ba;break}if(ta){ta=(qa&255)>>>1;va=A+1+(ta-ra)|0;wa=L;xa=ta}else{ta=c[M>>2]|0;qa=c[N>>2]|0;va=ta+(qa-ra)|0;wa=ta;xa=qa}qa=wa+xa|0;if((va|0)==(qa|0)){ma=Y;na=Y;oa=da;pa=sa;break}else{ya=ba;za=va}while(1){if((a[za]|0)!=(a[ya]|0)){ma=Y;na=Y;oa=da;pa=ba;break c}ta=za+1|0;if((ta|0)==(qa|0)){ma=Y;na=Y;oa=da;pa=sa;break}else{ya=ya+1|0;za=ta}}}}while(0);d:while(1){if((oa&1)==0){Aa=j;Ba=(oa&255)>>>1}else{Aa=c[J>>2]|0;Ba=c[K>>2]|0}if((pa|0)==(Aa+Ba|0)){break}da=c[h>>2]|0;do{if((da|0)==0){Ca=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Ca=da;break}if((he[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Ca=0;break}else{Ca=c[h>>2]|0;break}}}while(0);da=(Ca|0)==0;do{if((na|0)==0){Da=ma;X=147}else{if((c[na+12>>2]|0)!=(c[na+16>>2]|0)){if(da){Ea=ma;Fa=na;break}else{break d}}if((he[c[(c[na>>2]|0)+36>>2]&127](na)|0)==-1){c[e>>2]=0;Da=0;X=147;break}else{if(da^(ma|0)==0){Ea=ma;Fa=ma;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(da){break}else{Ea=Da;Fa=0}}ba=c[h>>2]|0;W=c[ba+12>>2]|0;if((W|0)==(c[ba+16>>2]|0)){Ga=(he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Ga=a[W]|0}if(!(Ga<<24>>24==(a[pa]|0))){break}W=c[h>>2]|0;ba=W+12|0;qa=c[ba>>2]|0;if((qa|0)==(c[W+16>>2]|0)){he[c[(c[W>>2]|0)+40>>2]&127](W)|0}else{c[ba>>2]=qa+1}ma=Ea;na=Fa;oa=a[x]|0;pa=pa+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=a[x]|0;if((qa&1)==0){Ha=j;Ia=(qa&255)>>>1}else{Ha=c[J>>2]|0;Ia=c[K>>2]|0}if((pa|0)==(Ha+Ia|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 4:{qa=D;ba=R;W=r;ta=Q;ra=0;Ja=T;e:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((he[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;da=c[e>>2]|0;do{if((da|0)==0){X=173}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){if(Ka){break}else{break e}}if((he[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}da=c[h>>2]|0;Ma=c[da+12>>2]|0;if((Ma|0)==(c[da+16>>2]|0)){Na=(he[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{Na=a[Ma]|0}do{if(Na<<24>>24>-1){if((b[(c[f>>2]|0)+(Na<<24>>24<<1)>>1]&2048)==0){X=189;break}Ma=c[o>>2]|0;if((Ma|0)==(qa|0)){da=(c[P>>2]|0)!=207;Oa=c[t>>2]|0;Pa=qa-Oa|0;Qa=Pa>>>0<2147483647?Pa<<1:-1;Ra=RV(da?Oa:0,Qa)|0;if((Ra|0)==0){X=182;break a}do{if(da){c[t>>2]=Ra;Sa=Ra}else{Oa=c[t>>2]|0;c[t>>2]=Ra;if((Oa|0)==0){Sa=Ra;break}ee[c[P>>2]&255](Oa);Sa=c[t>>2]|0}}while(0);c[P>>2]=182;Ra=Sa+Pa|0;c[o>>2]=Ra;Ta=Ra;Ua=(c[t>>2]|0)+Qa|0}else{Ta=Ma;Ua=qa}c[o>>2]=Ta+1;a[Ta]=Na;Va=Ua;Wa=ba;Xa=W;Ya=ta;Za=ra+1|0;_a=Ja}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){$a=(Ka&255)>>>1}else{$a=c[n>>2]|0}if(($a|0)==0|(ra|0)==0){break}if(!(Na<<24>>24==(a[v]|0))){break}if((W|0)==(ta|0)){Ka=W-ba|0;Ra=Ka>>>0<2147483647?Ka<<1:-1;if((Ja|0)==207){ab=0}else{ab=ba}da=RV(ab,Ra)|0;if((da|0)==0){X=198;break a}bb=da;cb=da+(Ka>>2<<2)|0;db=da+(Ra>>>2<<2)|0;eb=182}else{bb=ba;cb=W;db=ta;eb=Ja}c[cb>>2]=ra;Va=qa;Wa=bb;Xa=cb+4|0;Ya=db;Za=0;_a=eb}Ra=c[h>>2]|0;da=Ra+12|0;Ka=c[da>>2]|0;if((Ka|0)==(c[Ra+16>>2]|0)){he[c[(c[Ra>>2]|0)+40>>2]&127](Ra)|0;qa=Va;ba=Wa;W=Xa;ta=Ya;ra=Za;Ja=_a;continue}else{c[da>>2]=Ka+1;qa=Va;ba=Wa;W=Xa;ta=Ya;ra=Za;Ja=_a;continue}}if((ba|0)==(W|0)|(ra|0)==0){fb=ba;gb=W;hb=ta;ib=Ja}else{if((W|0)==(ta|0)){Ka=W-ba|0;da=Ka>>>0<2147483647?Ka<<1:-1;if((Ja|0)==207){jb=0}else{jb=ba}Ra=RV(jb,da)|0;if((Ra|0)==0){X=209;break a}kb=Ra;lb=Ra+(Ka>>2<<2)|0;mb=Ra+(da>>>2<<2)|0;nb=182}else{kb=ba;lb=W;mb=ta;nb=Ja}c[lb>>2]=ra;fb=kb;gb=lb+4|0;hb=mb;ib=nb}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){ob=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){ob=da;break}if((he[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;ob=0;break}else{ob=c[h>>2]|0;break}}}while(0);da=(ob|0)==0;ra=c[e>>2]|0;do{if((ra|0)==0){X=223}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){if(da){pb=ra;break}else{X=229;break a}}if((he[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){pb=ra;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{pb=0}}ra=c[h>>2]|0;Ja=c[ra+12>>2]|0;if((Ja|0)==(c[ra+16>>2]|0)){qb=(he[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{qb=a[Ja]|0}if(!(qb<<24>>24==(a[u]|0))){X=229;break a}Ja=c[h>>2]|0;ra=Ja+12|0;ta=c[ra>>2]|0;if((ta|0)==(c[Ja+16>>2]|0)){he[c[(c[Ja>>2]|0)+40>>2]&127](Ja)|0;rb=pb;sb=pb;tb=qa}else{c[ra>>2]=ta+1;rb=pb;sb=pb;tb=qa}while(1){ta=c[h>>2]|0;do{if((ta|0)==0){ub=0}else{if((c[ta+12>>2]|0)!=(c[ta+16>>2]|0)){ub=ta;break}if((he[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)==-1){c[h>>2]=0;ub=0;break}else{ub=c[h>>2]|0;break}}}while(0);ta=(ub|0)==0;do{if((sb|0)==0){vb=rb;X=243}else{if((c[sb+12>>2]|0)!=(c[sb+16>>2]|0)){if(ta){wb=rb;xb=sb;break}else{X=250;break a}}if((he[c[(c[sb>>2]|0)+36>>2]&127](sb)|0)==-1){c[e>>2]=0;vb=0;X=243;break}else{if(ta^(rb|0)==0){wb=rb;xb=rb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ta){X=250;break a}else{wb=vb;xb=0}}ra=c[h>>2]|0;Ja=c[ra+12>>2]|0;if((Ja|0)==(c[ra+16>>2]|0)){yb=(he[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255}else{yb=a[Ja]|0}if(!(yb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(yb<<24>>24<<1)>>1]&2048)==0){X=250;break a}Ja=c[o>>2]|0;if((Ja|0)==(tb|0)){ra=(c[P>>2]|0)!=207;W=c[t>>2]|0;ba=tb-W|0;Ra=ba>>>0<2147483647?ba<<1:-1;Ka=RV(ra?W:0,Ra)|0;if((Ka|0)==0){X=253;break a}do{if(ra){c[t>>2]=Ka;zb=Ka}else{W=c[t>>2]|0;c[t>>2]=Ka;if((W|0)==0){zb=Ka;break}ee[c[P>>2]&255](W);zb=c[t>>2]|0}}while(0);c[P>>2]=182;Ka=zb+ba|0;c[o>>2]=Ka;Ab=Ka;Bb=(c[t>>2]|0)+Ra|0}else{Ab=Ja;Bb=tb}Ka=c[h>>2]|0;ra=c[Ka+12>>2]|0;if((ra|0)==(c[Ka+16>>2]|0)){ta=(he[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255;Cb=ta;Db=c[o>>2]|0}else{Cb=a[ra]|0;Db=Ab}c[o>>2]=Db+1;a[Db]=Cb;ra=(c[B>>2]|0)+ -1|0;c[B>>2]=ra;ta=c[h>>2]|0;Ka=ta+12|0;W=c[Ka>>2]|0;if((W|0)==(c[ta+16>>2]|0)){he[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[Ka>>2]=W+1}if((ra|0)>0){rb=wb;sb=xb;tb=Bb}else{Eb=Bb;break}}}else{Eb=qa}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Eb;ha=fb;ia=gb;ja=hb;ka=S;la=ib}break};case 3:{da=a[y]|0;ra=(da&1)==0;if(ra){Fb=(da&255)>>>1}else{Fb=c[G>>2]|0}W=a[z]|0;Ka=(W&1)==0;if(Ka){Gb=(W&255)>>>1}else{Gb=c[g>>2]|0}if((Fb|0)==(0-Gb|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ra){Hb=(da&255)>>>1}else{Hb=c[G>>2]|0}do{if((Hb|0)!=0){if(Ka){Ib=(W&255)>>>1}else{Ib=c[g>>2]|0}if((Ib|0)==0){break}ta=c[h>>2]|0;Oa=c[ta+12>>2]|0;Jb=c[ta+16>>2]|0;if((Oa|0)==(Jb|0)){Kb=(he[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)&255;Lb=c[h>>2]|0;Mb=Kb;Nb=c[Lb+16>>2]|0;Ob=c[Lb+12>>2]|0;Pb=Lb;Qb=a[y]|0}else{Mb=a[Oa]|0;Nb=Jb;Ob=Oa;Pb=ta;Qb=da}ta=Pb+12|0;Oa=(Ob|0)==(Nb|0);if(Mb<<24>>24==(a[(Qb&1)==0?F:c[H>>2]|0]|0)){if(Oa){he[c[(c[Pb>>2]|0)+40>>2]&127](Pb)|0}else{c[ta>>2]=Ob+1}ta=a[y]|0;if((ta&1)==0){Rb=(ta&255)>>>1}else{Rb=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Rb>>>0>1?y:S;la=T;break b}if(Oa){Sb=(he[c[(c[Pb>>2]|0)+36>>2]&127](Pb)|0)&255}else{Sb=a[Ob]|0}if(!(Sb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}Oa=c[h>>2]|0;ta=Oa+12|0;Jb=c[ta>>2]|0;if((Jb|0)==(c[Oa+16>>2]|0)){he[c[(c[Oa>>2]|0)+40>>2]&127](Oa)|0}else{c[ta>>2]=Jb+1}a[l]=1;Jb=a[z]|0;if((Jb&1)==0){Tb=(Jb&255)>>>1}else{Tb=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Tb>>>0>1?z:S;la=T;break b}}while(0);if(ra){Ub=(da&255)>>>1}else{Ub=c[G>>2]|0}Ka=c[h>>2]|0;qa=c[Ka+12>>2]|0;Jb=(qa|0)==(c[Ka+16>>2]|0);if((Ub|0)==0){if(Jb){ta=(he[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255;Vb=ta;Wb=a[z]|0}else{Vb=a[qa]|0;Wb=W}if(!(Vb<<24>>24==(a[(Wb&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}ta=c[h>>2]|0;Oa=ta+12|0;Lb=c[Oa>>2]|0;if((Lb|0)==(c[ta+16>>2]|0)){he[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[Oa>>2]=Lb+1}a[l]=1;Lb=a[z]|0;if((Lb&1)==0){Xb=(Lb&255)>>>1}else{Xb=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Xb>>>0>1?z:S;la=T;break b}if(Jb){Jb=(he[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255;Yb=Jb;Zb=a[y]|0}else{Yb=a[qa]|0;Zb=da}if(!(Yb<<24>>24==(a[(Zb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;Jb=qa+12|0;Ka=c[Jb>>2]|0;if((Ka|0)==(c[qa+16>>2]|0)){he[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[Jb>>2]=Ka+1}Ka=a[y]|0;if((Ka&1)==0){_b=(Ka&255)>>>1}else{_b=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=_b>>>0>1?y:S;la=T;break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((he[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((he[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}Ja=c[h>>2]|0;Ra=c[Ja+12>>2]|0;if((Ra|0)==(c[Ja+16>>2]|0)){fc=(he[c[(c[Ja>>2]|0)+36>>2]&127](Ja)|0)&255}else{fc=a[Ra]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}Ra=c[h>>2]|0;Ja=Ra+12|0;ba=c[Ja>>2]|0;if((ba|0)==(c[Ra+16>>2]|0)){gc=(he[c[(c[Ra>>2]|0)+40>>2]&127](Ra)|0)&255}else{c[Ja>>2]=ba+1;gc=a[ba]|0}$L(A,gc);$b=dc;ac=ec}}}while(0);da=p+1|0;if(da>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=da;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){$V()}else if((X|0)==198){$V()}else if((X|0)==209){$V()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=fb;jc=ib}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=fb;jc=ib}else if((X|0)==253){$V()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=fb;jc=ib}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((he[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((he[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(he[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){he[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;FR(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);JL(A);JL(z);JL(y);JL(x);JL(w);if((ic|0)==0){i=q;return hc|0}ee[jc&255](ic);i=q;return hc|0}function BR(a){a=a|0;var b=0;b=Dc(8)|0;fL(b,a);Sd(b|0,102760,42)}function CR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=207;v=n+100|0;FM(q,h);n=q;w=c[n>>2]|0;if(!((c[26442]|0)==-1)){c[m>>2]=105768;c[m+4>>2]=205;c[m+8>>2]=0;uL(105768,m,206)}m=(c[105772>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Dc(4)|0;z=y;tV(z);A=121328;B=127;Sd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Dc(4)|0;z=y;tV(z);A=121328;B=127;Sd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=AR(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){$L(k,we[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=we[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);DR(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((he[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((he[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;$K(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ee[c[u>>2]&255](n);i=d;return}function DR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){cM(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function ER(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[26302]|0)==-1)){c[p>>2]=105208;c[p+4>>2]=205;c[p+8>>2]=0;uL(105208,p,206)}p=(c[105212>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}E=b;fe[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;fe[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}VL(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;JL(r);fe[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}VL(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;JL(s);a[f]=he[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=he[c[(c[b>>2]|0)+16>>2]&127](E)|0;fe[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}VL(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;JL(t);fe[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}VL(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;JL(u);F=he[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[26286]|0)==-1)){c[o>>2]=105144;c[o+4>>2]=205;c[o+8>>2]=0;uL(105144,o,206)}o=(c[105148>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}J=E;fe[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;fe[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}VL(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;JL(w);fe[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}VL(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;JL(x);a[f]=he[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=he[c[(c[E>>2]|0)+16>>2]&127](J)|0;fe[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}VL(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;JL(y);fe[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}VL(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;JL(z);F=he[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function FR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function GR(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function HR(a){a=a|0;i=i;return}function IR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=207;y=o+400|0;FM(r,h);o=r;z=c[o>>2]|0;if(!((c[26440]|0)==-1)){c[n>>2]=105760;c[n+4>>2]=205;c[n+8>>2]=0;uL(105760,n,206)}n=(c[105764>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=JR(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ge[c[(c[z>>2]|0)+48>>2]&63](E,105464,105474|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=OV((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}$V()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[105464+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((wd(p|0,105400,m|0)|0)!=1){t=Dc(8)|0;fL(t,105408);Sd(t|0,102760,42)}if((F|0)==0){break}PV(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=he[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=he[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];$K(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ee[c[x>>2]&255](o);i=d;return}function JR(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;MR(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=207;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=he[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=he[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 4:{P=M;R=r;_=L;$=0;aa=O;c:while(1){ba=c[g>>2]|0;do{if((ba|0)==0){ca=1}else{da=c[ba+12>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[da>>2]|0}if((ea|0)==-1){c[g>>2]=0;ca=1;break}else{ca=(c[g>>2]|0)==0;break}}}while(0);ba=c[b>>2]|0;do{if((ba|0)==0){T=188}else{da=c[ba+12>>2]|0;if((da|0)==(c[ba+16>>2]|0)){fa=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{fa=c[da>>2]|0}if((fa|0)==-1){c[b>>2]=0;T=188;break}else{if(ca){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(ca){break}}ba=c[g>>2]|0;da=c[ba+12>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ga=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ga=c[da>>2]|0}if(ke[c[(c[l>>2]|0)+12>>2]&63](l,2048,ga)|0){da=c[n>>2]|0;if((da|0)==(c[q>>2]|0)){NR(m,n,q);ha=c[n>>2]|0}else{ha=da}c[n>>2]=ha+4;c[ha>>2]=ga;ia=P;ja=R;ka=_;la=$+1|0;ma=aa}else{da=a[w]|0;if((da&1)==0){na=(da&255)>>>1}else{na=c[K>>2]|0}if((na|0)==0|($|0)==0){break}if((ga|0)!=(c[v>>2]|0)){break}if((R|0)==(_|0)){da=R-P|0;ba=da>>>0<2147483647?da<<1:-1;if((aa|0)!=207){oa=P}else{oa=0}pa=RV(oa,ba)|0;if((pa|0)==0){T=206;break a}qa=pa;ra=pa+(da>>2<<2)|0;sa=pa+(ba>>>2<<2)|0;ta=182}else{qa=P;ra=R;sa=_;ta=aa}c[ra>>2]=$;ia=qa;ja=ra+4|0;ka=sa;la=0;ma=ta}ba=c[g>>2]|0;pa=ba+12|0;da=c[pa>>2]|0;if((da|0)==(c[ba+16>>2]|0)){he[c[(c[ba>>2]|0)+40>>2]&127](ba)|0;P=ia;R=ja;_=ka;$=la;aa=ma;continue}else{c[pa>>2]=da+4;P=ia;R=ja;_=ka;$=la;aa=ma;continue}}if((P|0)==(R|0)|($|0)==0){ua=P;va=R;wa=_;xa=aa}else{if((R|0)==(_|0)){da=R-P|0;pa=da>>>0<2147483647?da<<1:-1;if((aa|0)!=207){ya=P}else{ya=0}ba=RV(ya,pa)|0;if((ba|0)==0){T=217;break a}za=ba;Aa=ba+(da>>2<<2)|0;Ba=ba+(pa>>>2<<2)|0;Ca=182}else{za=P;Aa=R;Ba=_;Ca=aa}c[Aa>>2]=$;ua=za;va=Aa+4|0;wa=Ba;xa=Ca}pa=c[B>>2]|0;if((pa|0)>0){ba=c[g>>2]|0;do{if((ba|0)==0){Da=1}else{da=c[ba+12>>2]|0;if((da|0)==(c[ba+16>>2]|0)){Ea=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Ea=c[da>>2]|0}if((Ea|0)==-1){c[g>>2]=0;Da=1;break}else{Da=(c[g>>2]|0)==0;break}}}while(0);ba=c[b>>2]|0;do{if((ba|0)==0){T=234}else{$=c[ba+12>>2]|0;if(($|0)==(c[ba+16>>2]|0)){Fa=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Fa=c[$>>2]|0}if((Fa|0)==-1){c[b>>2]=0;T=234;break}else{if(Da){Ga=ba;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Da){T=240;break a}else{Ga=0}}ba=c[g>>2]|0;$=c[ba+12>>2]|0;if(($|0)==(c[ba+16>>2]|0)){Ha=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Ha=c[$>>2]|0}if((Ha|0)!=(c[u>>2]|0)){T=240;break a}$=c[g>>2]|0;ba=$+12|0;aa=c[ba>>2]|0;if((aa|0)==(c[$+16>>2]|0)){he[c[(c[$>>2]|0)+40>>2]&127]($)|0;Ia=Ga;Ja=pa;Ka=Ga}else{c[ba>>2]=aa+4;Ia=Ga;Ja=pa;Ka=Ga}while(1){aa=c[g>>2]|0;do{if((aa|0)==0){La=1}else{ba=c[aa+12>>2]|0;if((ba|0)==(c[aa+16>>2]|0)){Ma=he[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Ma=c[ba>>2]|0}if((Ma|0)==-1){c[g>>2]=0;La=1;break}else{La=(c[g>>2]|0)==0;break}}}while(0);do{if((Ka|0)==0){Na=Ia;T=257}else{aa=c[Ka+12>>2]|0;if((aa|0)==(c[Ka+16>>2]|0)){Oa=he[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0}else{Oa=c[aa>>2]|0}if((Oa|0)==-1){c[b>>2]=0;Na=0;T=257;break}else{if(La^(Ia|0)==0){Pa=Ia;Qa=Ia;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(La){T=263;break a}else{Pa=Na;Qa=0}}aa=c[g>>2]|0;ba=c[aa+12>>2]|0;if((ba|0)==(c[aa+16>>2]|0)){Ra=he[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Ra=c[ba>>2]|0}if(!(ke[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ra)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){NR(m,n,q)}ba=c[g>>2]|0;aa=c[ba+12>>2]|0;if((aa|0)==(c[ba+16>>2]|0)){Sa=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Sa=c[aa>>2]|0}aa=c[n>>2]|0;c[n>>2]=aa+4;c[aa>>2]=Sa;aa=Ja+ -1|0;c[B>>2]=aa;ba=c[g>>2]|0;$=ba+12|0;_=c[$>>2]|0;if((_|0)==(c[ba+16>>2]|0)){he[c[(c[ba>>2]|0)+40>>2]&127](ba)|0}else{c[$>>2]=_+4}if((aa|0)>0){Ia=Pa;Ja=aa;Ka=Qa}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{Ta=ua;Ua=va;Va=wa;Wa=N;Xa=xa}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){Ya=(a[J]|0)!=0}else{Ya=0}if(!(F|Ya)){Ta=M;Ua=r;Va=L;Wa=0;Xa=O;break b}}pa=a[x]|0;aa=(pa&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){Za=V;_a=V;$a=pa;ab=aa}else{if((d[s+(o+ -1)|0]|0)<2){bb=pa;cb=aa}else{Za=V;_a=V;$a=pa;ab=aa;break}while(1){if((bb&1)==0){db=h;eb=(bb&255)>>>1}else{db=c[G>>2]|0;eb=c[h>>2]|0}if((cb|0)==(db+(eb<<2)|0)){fb=bb;break}if(!(ke[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[cb>>2]|0)|0)){T=129;break}bb=a[x]|0;cb=cb+4|0}if((T|0)==129){T=0;fb=a[x]|0}_=(fb&1)==0;$=cb-(_?h:c[G>>2]|0)>>2;ba=a[A]|0;R=(ba&1)==0;if(R){gb=(ba&255)>>>1}else{gb=c[H>>2]|0}e:do{if(!($>>>0>gb>>>0)){if(R){hb=H+(((ba&255)>>>1)-$<<2)|0;ib=H;jb=(ba&255)>>>1}else{P=c[I>>2]|0;da=c[H>>2]|0;hb=P+(da-$<<2)|0;ib=P;jb=da}da=ib+(jb<<2)|0;if((hb|0)==(da|0)){Za=V;_a=V;$a=fb;ab=cb;break d}else{kb=_?h:c[G>>2]|0;lb=hb}while(1){if((c[lb>>2]|0)!=(c[kb>>2]|0)){break e}P=lb+4|0;if((P|0)==(da|0)){Za=V;_a=V;$a=fb;ab=cb;break d}kb=kb+4|0;lb=P}}}while(0);Za=V;_a=V;$a=fb;ab=_?h:c[G>>2]|0}}while(0);f:while(1){if(($a&1)==0){mb=h;nb=($a&255)>>>1}else{mb=c[G>>2]|0;nb=c[h>>2]|0}if((ab|0)==(mb+(nb<<2)|0)){break}aa=c[g>>2]|0;do{if((aa|0)==0){ob=1}else{pa=c[aa+12>>2]|0;if((pa|0)==(c[aa+16>>2]|0)){pb=he[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{pb=c[pa>>2]|0}if((pb|0)==-1){c[g>>2]=0;ob=1;break}else{ob=(c[g>>2]|0)==0;break}}}while(0);do{if((_a|0)==0){qb=Za;T=159}else{aa=c[_a+12>>2]|0;if((aa|0)==(c[_a+16>>2]|0)){rb=he[c[(c[_a>>2]|0)+36>>2]&127](_a)|0}else{rb=c[aa>>2]|0}if((rb|0)==-1){c[b>>2]=0;qb=0;T=159;break}else{if(ob^(Za|0)==0){sb=Za;tb=Za;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(ob){break}else{sb=qb;tb=0}}aa=c[g>>2]|0;_=c[aa+12>>2]|0;if((_|0)==(c[aa+16>>2]|0)){ub=he[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{ub=c[_>>2]|0}if((ub|0)!=(c[ab>>2]|0)){break}_=c[g>>2]|0;aa=_+12|0;pa=c[aa>>2]|0;if((pa|0)==(c[_+16>>2]|0)){he[c[(c[_>>2]|0)+40>>2]&127](_)|0}else{c[aa>>2]=pa+4}Za=sb;_a=tb;$a=a[x]|0;ab=ab+4|0}if(!F){Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break b}pa=a[x]|0;if((pa&1)==0){vb=h;wb=(pa&255)>>>1}else{vb=c[G>>2]|0;wb=c[h>>2]|0}if((ab|0)==(vb+(wb<<2)|0)){Ta=M;Ua=r;Va=L;Wa=N;Xa=O}else{T=174;break a}break};case 0:{T=28;break};case 3:{pa=a[y]|0;aa=(pa&1)==0;if(aa){xb=(pa&255)>>>1}else{xb=c[D>>2]|0}_=a[z]|0;$=(_&1)==0;if($){yb=(_&255)>>>1}else{yb=c[e>>2]|0}if((xb|0)==(0-yb|0)){Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break b}if(aa){zb=(pa&255)>>>1}else{zb=c[D>>2]|0}do{if((zb|0)!=0){if($){Ab=(_&255)>>>1}else{Ab=c[e>>2]|0}if((Ab|0)==0){break}ba=c[g>>2]|0;R=c[ba+12>>2]|0;if((R|0)==(c[ba+16>>2]|0)){da=he[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Bb=da;Cb=a[y]|0}else{Bb=c[R>>2]|0;Cb=pa}R=c[g>>2]|0;da=R+12|0;ba=c[da>>2]|0;P=(ba|0)==(c[R+16>>2]|0);if((Bb|0)==(c[((Cb&1)==0?D:c[E>>2]|0)>>2]|0)){if(P){he[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[da>>2]=ba+4}da=a[y]|0;if((da&1)==0){Db=(da&255)>>>1}else{Db=c[D>>2]|0}Ta=M;Ua=r;Va=L;Wa=Db>>>0>1?y:N;Xa=O;break b}if(P){Eb=he[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Eb=c[ba>>2]|0}if((Eb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}ba=c[g>>2]|0;R=ba+12|0;P=c[R>>2]|0;if((P|0)==(c[ba+16>>2]|0)){he[c[(c[ba>>2]|0)+40>>2]&127](ba)|0}else{c[R>>2]=P+4}a[k]=1;P=a[z]|0;if((P&1)==0){Fb=(P&255)>>>1}else{Fb=c[e>>2]|0}Ta=M;Ua=r;Va=L;Wa=Fb>>>0>1?z:N;Xa=O;break b}}while(0);if(aa){Gb=(pa&255)>>>1}else{Gb=c[D>>2]|0}$=c[g>>2]|0;P=c[$+12>>2]|0;R=(P|0)==(c[$+16>>2]|0);if((Gb|0)==0){if(R){ba=he[c[(c[$>>2]|0)+36>>2]&127]($)|0;Hb=ba;Ib=a[z]|0}else{Hb=c[P>>2]|0;Ib=_}if((Hb|0)!=(c[((Ib&1)==0?e:c[f>>2]|0)>>2]|0)){Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break b}ba=c[g>>2]|0;da=ba+12|0;Jb=c[da>>2]|0;if((Jb|0)==(c[ba+16>>2]|0)){he[c[(c[ba>>2]|0)+40>>2]&127](ba)|0}else{c[da>>2]=Jb+4}a[k]=1;Jb=a[z]|0;if((Jb&1)==0){Kb=(Jb&255)>>>1}else{Kb=c[e>>2]|0}Ta=M;Ua=r;Va=L;Wa=Kb>>>0>1?z:N;Xa=O;break b}if(R){R=he[c[(c[$>>2]|0)+36>>2]&127]($)|0;Lb=R;Mb=a[y]|0}else{Lb=c[P>>2]|0;Mb=pa}if((Lb|0)!=(c[((Mb&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break b}P=c[g>>2]|0;R=P+12|0;$=c[R>>2]|0;if(($|0)==(c[P+16>>2]|0)){he[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[R>>2]=$+4}$=a[y]|0;if(($&1)==0){Nb=($&255)>>>1}else{Nb=c[D>>2]|0}Ta=M;Ua=r;Va=L;Wa=Nb>>>0>1?y:N;Xa=O;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}$=c[g>>2]|0;R=c[$+12>>2]|0;if((R|0)==(c[$+16>>2]|0)){Ob=he[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Ob=c[R>>2]|0}if(!(ke[c[(c[l>>2]|0)+12>>2]&63](l,8192,Ob)|0)){T=27;break a}R=c[g>>2]|0;$=R+12|0;P=c[$>>2]|0;if((P|0)==(c[R+16>>2]|0)){Pb=he[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[$>>2]=P+4;Pb=c[P>>2]|0}pM(A,Pb);T=28;break};default:{Ta=M;Ua=r;Va=L;Wa=N;Xa=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){P=c[g>>2]|0;do{if((P|0)==0){Sb=1}else{$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){Tb=he[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Tb=c[$>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{P=c[Rb+12>>2]|0;if((P|0)==(c[Rb+16>>2]|0)){Vb=he[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[P>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break g}else{Wb=Ub;Xb=0}}P=c[g>>2]|0;$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){Yb=he[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Yb=c[$>>2]|0}if(!(ke[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){Ta=M;Ua=r;Va=L;Wa=N;Xa=O;break g}$=c[g>>2]|0;P=$+12|0;R=c[P>>2]|0;if((R|0)==(c[$+16>>2]|0)){Zb=he[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[P>>2]=R+4;Zb=c[R>>2]|0}pM(A,Zb);Qb=Wb;Rb=Xb}}}while(0);pa=o+1|0;if(pa>>>0<4){L=Va;r=Ua;M=Ta;o=pa;N=Wa;O=Xa}else{W=Ta;X=Ua;Y=Wa;Z=Xa;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){$V()}else if((T|0)==217){$V()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=ua;ac=xa}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=ua;ac=xa}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=ua;ac=xa}else if((T|0)==276){i:do{if((Y|0)!=0){Xa=Y+4|0;Wa=Y+8|0;Ua=1;j:while(1){Ta=a[Y]|0;if((Ta&1)==0){bc=(Ta&255)>>>1}else{bc=c[Xa>>2]|0}if(!(Ua>>>0<bc>>>0)){break i}Ta=c[g>>2]|0;do{if((Ta|0)==0){cc=1}else{N=c[Ta+12>>2]|0;if((N|0)==(c[Ta+16>>2]|0)){dc=he[c[(c[Ta>>2]|0)+36>>2]&127](Ta)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);Ta=c[b>>2]|0;do{if((Ta|0)==0){T=295}else{N=c[Ta+12>>2]|0;if((N|0)==(c[Ta+16>>2]|0)){ec=he[c[(c[Ta>>2]|0)+36>>2]&127](Ta)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}Ta=c[g>>2]|0;N=c[Ta+12>>2]|0;if((N|0)==(c[Ta+16>>2]|0)){fc=he[c[(c[Ta>>2]|0)+36>>2]&127](Ta)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=Xa}else{gc=c[Wa>>2]|0}if((fc|0)!=(c[gc+(Ua<<2)>>2]|0)){break}N=Ua+1|0;Ta=c[g>>2]|0;o=Ta+12|0;r=c[o>>2]|0;if((r|0)==(c[Ta+16>>2]|0)){he[c[(c[Ta>>2]|0)+40>>2]&127](Ta)|0;Ua=N;continue}else{c[o>>2]=r+4;Ua=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;FR(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);lM(A);lM(z);lM(y);lM(x);JL(w);if(($b|0)==0){i=p;return _b|0}ee[ac&255]($b);i=p;return _b|0}function KR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=207;v=n+400|0;FM(q,h);n=q;w=c[n>>2]|0;if(!((c[26440]|0)==-1)){c[m>>2]=105760;c[m+4>>2]=205;c[m+8>>2]=0;uL(105760,m,206)}m=(c[105764>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Dc(4)|0;z=y;tV(z);A=121328;B=127;Sd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Dc(4)|0;z=y;tV(z);A=121328;B=127;Sd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=JR(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){pM(k,we[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=we[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);LR(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=he[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=he[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];$K(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ee[c[u>>2]&255](n);i=d;return}function LR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){rM(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function MR(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[26334]|0)==-1)){c[p>>2]=105336;c[p+4>>2]=205;c[p+8>>2]=0;uL(105336,p,206)}p=(c[105340>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Dc(4)|0;C=B;tV(C);D=121328;E=127;Sd(B|0,D|0,E|0)}E=b;fe[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;fe[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}oM(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;lM(r);fe[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}oM(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;lM(s);c[f>>2]=he[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=he[c[(c[b>>2]|0)+16>>2]&127](E)|0;fe[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}VL(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;JL(t);fe[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}oM(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;lM(u);F=he[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[26318]|0)==-1)){c[o>>2]=105272;c[o+4>>2]=205;c[o+8>>2]=0;uL(105272,o,206)}o=(c[105276>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Dc(4)|0;H=G;tV(H);I=121328;J=127;Sd(G|0,I|0,J|0)}J=E;fe[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;fe[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}oM(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;lM(w);fe[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}oM(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;lM(x);c[f>>2]=he[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=he[c[(c[E>>2]|0)+16>>2]&127](J)|0;fe[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}VL(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;JL(y);fe[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}oM(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;lM(z);F=he[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function NR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=207;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=RV(m,l)|0;m=a;if((a|0)==0){$V()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}ee[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=182;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function OR(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function PR(a){a=a|0;i=i;return}function QR(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,105520,o|0)|0;do{if(s>>>0>99){do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);o=c[26414]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=IP(r,o,105520,n)|0;o=c[r>>2]|0;if((o|0)==0){$V()}H=OV(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}$V()}else{I=0;J=0;K=q;L=s}}while(0);FM(t,g);s=t;q=c[s>>2]|0;if(!((c[26442]|0)==-1)){c[p>>2]=105768;c[p+4>>2]=205;c[p+8>>2]=0;uL(105768,p,206)}p=(c[105772>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Dc(4)|0;N=M;tV(N);O=121328;P=127;Sd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Dc(4)|0;N=M;tV(N);O=121328;P=127;Sd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ge[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;RR(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=OV(V)|0;if((T|0)!=0){W=T;X=T;break}$V()}else{W=0;X=t}}while(0);SR(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];gI(b,m,X,e,D,g,j);if((W|0)!=0){PV(W)}JL(A);JL(z);JL(y);$K(c[s>>2]|0)|0;if((J|0)!=0){PV(J)}if((I|0)==0){i=d;return}PV(I);i=d;return}function RR(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[26302]|0)==-1)){c[p>>2]=105208;c[p+4>>2]=205;c[p+8>>2]=0;uL(105208,p,206)}p=(c[105212>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Dc(4)|0;I=H;tV(I);J=121328;K=127;Sd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Dc(4)|0;I=H;tV(I);J=121328;K=127;Sd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){fe[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;fe[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}VL(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;JL(s)}else{fe[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;fe[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}VL(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;JL(v)}a[g]=he[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=he[c[(c[e>>2]|0)+16>>2]&127](K)|0;fe[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}VL(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;JL(w);fe[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}VL(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;JL(x);L=he[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[26286]|0)==-1)){c[o>>2]=105144;c[o+4>>2]=205;c[o+8>>2]=0;uL(105144,o,206)}o=(c[105148>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Dc(4)|0;N=M;tV(N);O=121328;P=127;Sd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Dc(4)|0;N=M;tV(N);O=121328;P=127;Sd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){fe[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;fe[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}VL(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;JL(A)}else{fe[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;fe[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}VL(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;JL(D)}a[g]=he[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=he[c[(c[G>>2]|0)+16>>2]&127](P)|0;fe[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}VL(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;JL(E);fe[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}VL(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;JL(F);L=he[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function SR(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};case 4:{J=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){N=I;while(1){O=a[N]|0;if(!(O<<24>>24>-1)){P=N;break b}Q=N+1|0;if((b[(c[F>>2]|0)+(O<<24>>24<<1)>>1]&2048)==0){P=N;break b}if(Q>>>0<j>>>0){N=Q}else{P=Q;break}}}else{P=I}}while(0);N=P;if(B){if(P>>>0>I>>>0){Q=I+(0-N)|0;N=Q>>>0<G>>>0?G:Q;Q=N+s|0;O=J;R=P;S=s;while(1){T=R+ -1|0;U=a[T]|0;c[f>>2]=O+1;a[O]=U;U=S+ -1|0;V=(U|0)>0;if(!(T>>>0>I>>>0&V)){break}O=c[f>>2]|0;S=U;R=T}R=P+N|0;if(V){W=R;X=Q;Y=32}else{Z=0;_=R;$=Q}}else{W=P;X=s;Y=32}if((Y|0)==32){Y=0;Z=we[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;_=W;$=X}R=c[f>>2]|0;c[f>>2]=R+1;if(($|0)>0){S=R;O=$;while(1){a[S]=Z;T=O+ -1|0;U=c[f>>2]|0;c[f>>2]=U+1;if((T|0)>0){O=T;S=U}else{aa=U;break}}}else{aa=R}a[aa]=n;ba=_}else{ba=P}if((ba|0)==(I|0)){S=we[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;O=c[f>>2]|0;c[f>>2]=O+1;a[O]=S}else{S=a[p]|0;O=(S&1)==0;if(O){ca=(S&255)>>>1}else{ca=c[E>>2]|0}if((ca|0)==0){da=ba;ea=-1;fa=0;ga=0}else{if(O){ha=C}else{ha=c[D>>2]|0}da=ba;ea=a[ha]|0;fa=0;ga=0}while(1){do{if((ga|0)==(ea|0)){O=c[f>>2]|0;c[f>>2]=O+1;a[O]=o;O=fa+1|0;S=a[p]|0;Q=(S&1)==0;if(Q){ia=(S&255)>>>1}else{ia=c[E>>2]|0}if(!(O>>>0<ia>>>0)){ja=ea;ka=O;la=0;break}if(Q){ma=C}else{ma=c[D>>2]|0}if((a[ma+O|0]|0)==127){ja=-1;ka=O;la=0;break}if(Q){na=C}else{na=c[D>>2]|0}ja=a[na+O|0]|0;ka=O;la=0}else{ja=ea;ka=fa;la=ga}}while(0);O=da+ -1|0;Q=a[O]|0;S=c[f>>2]|0;c[f>>2]=S+1;a[S]=Q;if((O|0)==(I|0)){break}else{da=O;ea=ja;fa=ka;ga=la+1|0}}}R=c[f>>2]|0;if((J|0)==(R|0)){L=I;break a}O=R+ -1|0;if(O>>>0>J>>>0){oa=J;pa=O}else{L=I;break a}while(1){O=a[oa]|0;a[oa]=a[pa]|0;a[pa]=O;O=oa+1|0;R=pa+ -1|0;if(O>>>0<R>>>0){pa=R;oa=O}else{L=I;break}}break};case 1:{c[e>>2]=c[f>>2];I=we[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;L=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){qa=(I&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){L=H;break a}if(J){ra=y;sa=(I&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}I=ra+sa|0;J=c[f>>2]|0;if((ra|0)==(I|0)){ta=J}else{O=J;J=ra;while(1){a[O]=a[J]|0;R=J+1|0;Q=O+1|0;if((R|0)==(I|0)){ta=Q;break}else{J=R;O=Q}}}c[f>>2]=ta;L=H;break};default:{L=H}}}while(0);O=h+1|0;if(O>>>0<4){H=L;h=O}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function TR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;FM(m,g);z=m;A=c[z>>2]|0;if(!((c[26442]|0)==-1)){c[l>>2]=105768;c[l+4>>2]=205;c[l+8>>2]=0;uL(105768,l,206)}l=(c[105772>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(we[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;RR(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=OV(P)|0;if((N|0)!=0){Q=N;R=N;break}$V()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}SR(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];gI(b,k,R,e,w,g,h);if((Q|0)==0){JL(t);JL(s);JL(r);U=c[z>>2]|0;V=U;W=V;X=$K(W)|0;i=d;return}PV(Q);JL(t);JL(s);JL(r);U=c[z>>2]|0;V=U;W=V;X=$K(W)|0;i=d;return}function UR(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function VR(a){a=a|0;i=i;return}function WR(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,105520,o|0)|0;do{if(s>>>0>99){do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);o=c[26414]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=IP(r,o,105520,n)|0;o=c[r>>2]|0;if((o|0)==0){$V()}H=OV(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}$V()}else{J=0;K=0;L=q;M=s}}while(0);FM(t,g);s=t;q=c[s>>2]|0;if(!((c[26440]|0)==-1)){c[p>>2]=105760;c[p+4>>2]=205;c[p+8>>2]=0;uL(105760,p,206)}p=(c[105764>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Dc(4)|0;O=N;tV(O);P=121328;Q=127;Sd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Dc(4)|0;O=N;tV(O);P=121328;Q=127;Sd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ge[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;XR(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=OV(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}$V()}else{X=0;Y=t}}while(0);YR(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];RP(b,m,Y,e,D,g,j);if((X|0)!=0){PV(X)}lM(A);lM(z);JL(y);$K(c[s>>2]|0)|0;if((K|0)!=0){PV(K)}if((J|0)==0){i=d;return}PV(J);i=d;return}function XR(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[26334]|0)==-1)){c[p>>2]=105336;c[p+4>>2]=205;c[p+8>>2]=0;uL(105336,p,206)}p=(c[105340>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Dc(4)|0;I=H;tV(I);J=121328;K=127;Sd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Dc(4)|0;I=H;tV(I);J=121328;K=127;Sd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){fe[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;fe[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}oM(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;lM(s)}else{fe[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;fe[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}oM(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;lM(v)}c[g>>2]=he[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=he[c[(c[e>>2]|0)+16>>2]&127](K)|0;fe[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}VL(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;JL(w);fe[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}oM(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;lM(x);L=he[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[26318]|0)==-1)){c[o>>2]=105272;c[o+4>>2]=205;c[o+8>>2]=0;uL(105272,o,206)}o=(c[105276>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Dc(4)|0;N=M;tV(N);O=121328;P=127;Sd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Dc(4)|0;N=M;tV(N);O=121328;P=127;Sd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){fe[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;fe[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}oM(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;lM(A)}else{fe[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;fe[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}oM(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;lM(D)}c[g>>2]=he[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=he[c[(c[G>>2]|0)+16>>2]&127](P)|0;fe[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}VL(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;JL(E);fe[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}oM(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;lM(F);L=he[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function YR(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){F=E;while(1){G=F+4|0;if(!(ke[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[F>>2]|0)|0)){H=F;break b}if(G>>>0<h>>>0){F=G}else{H=G;break}}}else{H=E}}while(0);if(y){do{if(H>>>0>E>>>0){F=c[e>>2]|0;G=H;I=r;while(1){J=G+ -4|0;K=F+4|0;c[F>>2]=c[J>>2];L=I+ -1|0;M=(L|0)>0;if(J>>>0>E>>>0&M){I=L;G=J;F=K}else{break}}c[e>>2]=K;if(M){N=J;O=L;P=34;break}F=c[e>>2]|0;c[e>>2]=F+4;Q=F;R=J}else{N=H;O=r;P=34}}while(0);do{if((P|0)==34){P=0;F=we[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;G=c[e>>2]|0;I=G+4|0;c[e>>2]=I;if((O|0)>0){S=I;T=G;U=O}else{Q=G;R=N;break}while(1){c[T>>2]=F;I=U+ -1|0;if((I|0)>0){U=I;T=S;S=S+4|0}else{break}}c[e>>2]=G+(O+1<<2);Q=G+(O<<2)|0;R=N}}while(0);c[Q>>2]=m;V=R}else{V=H}if((V|0)==(E|0)){F=we[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;I=c[e>>2]|0;W=I+4|0;c[e>>2]=W;c[I>>2]=F;X=W}else{W=a[o]|0;F=(W&1)==0;if(F){Y=(W&255)>>>1}else{Y=c[B>>2]|0}if((Y|0)==0){Z=V;_=-1;$=0;aa=0}else{if(F){ba=z}else{ba=c[A>>2]|0}Z=V;_=a[ba]|0;$=0;aa=0}while(1){F=c[e>>2]|0;do{if((aa|0)==(_|0)){W=F+4|0;c[e>>2]=W;c[F>>2]=n;I=$+1|0;ca=a[o]|0;da=(ca&1)==0;if(da){ea=(ca&255)>>>1}else{ea=c[B>>2]|0}if(!(I>>>0<ea>>>0)){fa=W;ga=_;ha=I;ia=0;break}if(da){ja=z}else{ja=c[A>>2]|0}if((a[ja+I|0]|0)==127){fa=W;ga=-1;ha=I;ia=0;break}if(da){ka=z}else{ka=c[A>>2]|0}fa=W;ga=a[ka+I|0]|0;ha=I;ia=0}else{fa=F;ga=_;ha=$;ia=aa}}while(0);F=Z+ -4|0;G=c[F>>2]|0;I=fa+4|0;c[e>>2]=I;c[fa>>2]=G;if((F|0)==(E|0)){X=I;break}else{Z=F;_=ga;$=ha;aa=ia+1|0}}}if((D|0)==(X|0)){la=E;break a}F=X+ -4|0;if(F>>>0>D>>>0){ma=D;na=F}else{la=E;break a}while(1){F=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=F;F=ma+4|0;I=na+ -4|0;if(F>>>0<I>>>0){na=I;ma=F}else{la=E;break}}break};case 2:{E=a[p]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0|v){la=C;break a}if(D){pa=w;qa=(E&255)>>>1}else{pa=c[x>>2]|0;qa=c[w>>2]|0}E=pa+(qa<<2)|0;D=c[e>>2]|0;if((pa|0)==(E|0)){ra=D}else{F=(pa+(qa+ -1<<2)+(0-pa)|0)>>>2;I=D;G=pa;while(1){c[I>>2]=c[G>>2];W=G+4|0;if((W|0)==(E|0)){break}I=I+4|0;G=W}ra=D+(F+1<<2)|0}c[e>>2]=ra;la=C;break};case 0:{c[d>>2]=c[e>>2];la=C;break};case 1:{c[d>>2]=c[e>>2];G=we[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;I=c[e>>2]|0;c[e>>2]=I+4;c[I>>2]=G;la=C;break};case 3:{G=a[q]|0;I=(G&1)==0;if(I){sa=(G&255)>>>1}else{sa=c[t>>2]|0}if((sa|0)==0){la=C;break a}if(I){ta=t}else{ta=c[u>>2]|0}I=c[ta>>2]|0;G=c[e>>2]|0;c[e>>2]=G+4;c[G>>2]=I;la=C;break};default:{la=C}}}while(0);I=g+1|0;if(I>>>0<4){C=la;g=I}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function ZR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;FM(m,g);z=m;A=c[z>>2]|0;if(!((c[26440]|0)==-1)){c[l>>2]=105760;c[l+4>>2]=205;c[l+8>>2]=0;uL(105760,l,206)}l=(c[105764>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Dc(4)|0;D=C;tV(D);E=121328;F=127;Sd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(we[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;XR(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=OV(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}$V()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}YR(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];RP(b,k,R,e,w,g,h);if((Q|0)==0){lM(t);lM(s);JL(r);U=c[z>>2]|0;V=U;W=V;X=$K(W)|0;i=d;return}PV(Q);lM(t);lM(s);JL(r);U=c[z>>2]|0;V=U;W=V;X=$K(W)|0;i=d;return}function _R(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function $R(a){a=a|0;i=i;return}function aS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=tc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function bS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{$L(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=xd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=qW(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{JL(j);i=d;return}do{$L(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);JL(j);i=d;return}function cS(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function dS(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function eS(a){a=a|0;i=i;return}function fS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=tc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function gS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=107424;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=107424|0;while(1){c[m>>2]=y;A=(Fe[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{$L(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}BR(106648)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=xd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=107528;D=qW(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){JL(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=107528|0;while(1){c[q>>2]=o;h=(Fe[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{pM(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){BR(106648)}else if((E|0)==25){JL(r);i=d;return}}function hS(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function iS(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=105856;e=b+8|0;b=c[e>>2]|0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);if((b|0)==(c[26414]|0)){i=d;return}$b(c[e>>2]|0);i=d;return}function jS(a){a=a|0;a=Dc(8)|0;aL(a,105648);c[a>>2]=102616;Sd(a|0,102656,40)}



function ZH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;kr();do{if((jJ(a,b)|0)==0){if((lJ(a,b)|0)!=0){break}do{if((c[88592>>2]|0)!=0){w=c[88720>>2]|0;if((mW(w,80184)|0)==0){qr(1);break}if((mW(w,80192)|0)==0){qr(0);break}else{c[p>>2]=w;vr(1,0,80200,p);td(0)|0;Bd(0)}}}while(0);if((c[88548>>2]|0)==0){NH(0,0);vu(d);if((d|0)==0){WN(SH(101128,80568)|0,103)|0}c[d+300>>2]=PH(0,0)|0;c[d+292>>2]=RH(0,0)|0;BA(d+8|0,d+240|0);Bu(d)|0;Ju(d)|0;Vu(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}WN(SH(101128,80632)|0,103)|0;x=1;i=e;return x|0}}while(0);c[19732]=c[88616>>2];x=0;i=e;return x|0}DL(u,c[88676>>2]|0);w=1;while(1){y=36576+(w<<2)|0;DL(v,c[y>>2]|0);z=OH(u,v)|0;JL(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=eM(u)|0;vr(1,0,80472,g);c[f>>2]=c[b>>2];vr(1,0,80512,f);td(0)|0;Bd(0)}A=c[40600+(w<<2)>>2]|0;do{if((A|0)==1){z=c[40472+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;tr(1,1,80272,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[40472+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;tr(1,1,80312,n);break}else{c[m>>2]=z;vr(1,1,80152,m);break}}}while(0);if((w|0)==19){A=c[7538]|0;if((A|0)<28){D=A}else{E=32416;F=c[8104]|0;ee[F&255](1);G=td(0)|0;Bd(0)}do{A=c[31736+(D<<2)>>2]|0;c[l>>2]=c[30568+(D<<2)>>2];c[l+4>>2]=A;tr(1,0,78976,l);D=D+1|0;}while((D|0)<28);E=32416;F=c[8104]|0;ee[F&255](1);G=td(0)|0;Bd(0)}else if((w|0)==11){A=1;do{z=c[80440+(A<<2)>>2]|0;c[j>>2]=c[80408+(A<<2)>>2];c[j+4>>2]=z;tr(1,0,78976,j);A=A+1|0;}while((A|0)<7);E=32416;F=c[8104]|0;ee[F&255](1);G=td(0)|0;Bd(0)}else if((w|0)==29){A=1;do{z=c[79984+(A<<2)>>2]|0;c[h>>2]=c[79872+(A<<2)>>2];c[h+4>>2]=z;tr(1,0,78976,h);A=A+1|0;}while((A|0)<20);E=32416;F=c[8104]|0;ee[F&255](1);G=td(0)|0;Bd(0)}else if((w|0)==7){A=1;do{z=c[80392+(A<<2)>>2]|0;c[k>>2]=c[80376+(A<<2)>>2];c[k+4>>2]=z;tr(1,0,78976,k);A=A+1|0;}while((A|0)<4);E=32416;F=c[8104]|0;ee[F&255](1);G=td(0)|0;Bd(0)}else{E=32416;F=c[8104]|0;ee[F&255](1);G=td(0)|0;Bd(0)}}}while(0);c[t>>2]=c[b>>2];tr(1,1,80088,t);t=1;do{b=c[40600+(t<<2)>>2]|0;do{if((b|0)==1){G=c[38480+(t<<2)>>2]|0;c[s>>2]=c[36576+(t<<2)>>2];c[s+4>>2]=G;tr(1,0,80104,s)}else{G=c[36576+(t<<2)>>2]|0;if((b|0)==2){F=c[38480+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;tr(1,0,80120,r);break}else{c[q>>2]=G;vr(1,0,80152,q);break}}}while(0);t=t+1|0;}while((t|0)<31);ee[c[8104]&255](1);td(0)|0;Bd(0);return 0}function _H(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[20166]|0;tb(82248)|0;c[l>>2]=c[m+88>>2];fc(80672,l|0)|0;tb(82264)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];fc(80696,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];fc(80736,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];fc(80768,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];fc(80800,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];fc(80832,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];fc(80864,b|0)|0;tb(82288)|0;i=a;return}function $H(a,b){a=a|0;b=+b;i=i;return}function aI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;pW(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=DW(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=DW(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[20166]=d;u=0;Ha(61,10,201)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=DW(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=DW(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=DW(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=DW(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=DW(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=DW(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(202,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=DW(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=DW(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=DW(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function bI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=md(c[7514]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 3:{if((c[31932>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;qc(80936,7,1,a|0)|0;Cc(a|0,d|0,f|0)|0;Rd(10,a|0)|0;td(0)|0;i=b;return};case 2:{if((c[31876>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;qc(80936,7,1,a|0)|0;Cc(a|0,d|0,f|0)|0;Rd(10,a|0)|0;td(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 5:case 4:{i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;qc(80936,7,1,e|0)|0;Cc(e|0,d|0,f|0)|0;Rd(10,e|0)|0;td(0)|0;eb(c[g+80>>2]|0,1);break};default:{xr(g,80944,b)}}}function cI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;qc(80920,9,1,d|0)|0;Cc(d|0,b|0,e|0)|0;Rd(10,d|0)|0;td(0)|0;i=a;return}function dI(a,b){a=a|0;b=b|0;var c=0;c=i;fI(a,b);i=c;return}function eI(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function fI(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=CM(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function gI(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;cx(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=hI(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((OM(b,d,r)|0)==(r|0)){break}cx(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){EL(l,s,h);if((OM(b,IL(l)|0,s)|0)==(s|0)){JL(l);break}cx(m);c[o>>2]=0;c[a>>2]=0;JL(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((OM(b,e,l)|0)==(l|0)){break}cx(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);iI(g,0)|0;c[a>>2]=b;i=j;return}function hI(a){a=a|0;i=i;return c[a+12>>2]|0}function iI(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function jI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;kI(g,16);lI(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){mI(a,g);nI(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){SH(XN(m,+h[b+(p<<3)>>3])|0,82304)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){XN(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){SH(m,82312)|0}}while((e|0)<(d|0));mI(a,g);nI(g);i=f;return}function kI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;GM(e);f=a;c[f>>2]=82684;g=e;c[g>>2]=82704;e=a+4|0;NN(a,82716|0,e);c[f>>2]=82684;c[g>>2]=82704;zI(e,b|16);i=d;return}function lI(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function mI(a,b){a=a|0;b=b|0;var c=0;c=i;tI(a,b+4|0);i=c;return}function nI(a){a=a|0;var b=0;b=i;DI(a,82712);BM(a+56|0);i=b;return}function oI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[31920>>2]|0)!=0){tb(83008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(14,0,82320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);he[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(14,0,82392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[31920>>2]|0)==0){i=d;return 0}tr(14,0,82440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(82456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function pI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[31920>>2]|0)!=0){tb(83008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(14,0,82320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);he[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(14,0,82392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[31920>>2]|0)==0){i=d;return 0}tr(14,0,82440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(82456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function qI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[31920>>2]|0)!=0){tb(83008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(14,0,82320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);he[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(14,0,82392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[31920>>2]|0)==0){i=d;return 0}tr(14,0,82440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(82456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function rI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[31920>>2]|0)!=0){tb(83008)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(14,0,82320,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);he[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(14,0,82392,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[31920>>2]|0)==0){i=d;return 0}tr(14,0,82440,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(82456,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function sI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=QV(fa(F,F)|0,8)|0;J=I;K=QV(fa(G,F)|0,8)|0;L=K;M=QV(fa(H,F)|0,8)|0;N=M;O=QV(fa(H,G)|0,8)|0;P=O;xL(p);xL(q);xL(r);xL(s);xL(t);xL(u);xL(v);Q=a+536|0;wr(c[Q>>2]|0,(I|0)!=0|0,82464,o);wr(c[Q>>2]|0,(K|0)!=0|0,82464,n);wr(c[Q>>2]|0,(M|0)!=0|0,82464,m);wr(c[Q>>2]|0,(O|0)!=0|0,82464,l);l=a+540|0;m=a;if((he[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;oI(a,J)|0;wr(n,1,82480,k)}jI(w,J,F,F);KL(p,w)|0;JL(w);if((he[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;pI(a,L)|0;wr(w,1,82512,j)}jI(x,L,F,G);KL(q,x)|0;JL(x);if((he[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;qI(a,N)|0;wr(x,1,82544,h)}jI(y,N,H,F);KL(r,y)|0;JL(y);if((he[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;rI(a,P)|0;wr(m,1,82576,g)}jI(z,P,H,G);KL(s,z)|0;JL(z);if((F|0)==0){LL(t,82608)|0}else{jI(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);KL(t,A)|0;JL(A)}if((G|0)==0){LL(u,82608)|0}else{jI(B,c[a+432>>2]|0,1,G);KL(u,B)|0;JL(B)}PV(I);PV(K);PV(M);PV(O);DL(E,c[a+84>>2]|0);sM(D,82624,E);EA(C,D,82632);KL(v,C)|0;JL(C);JL(D);JL(E);E=hc(eM(v)|0,82640)|0;D=c[Q>>2]|0;c[f>>2]=eM(v)|0;wr(D,(E|0)!=0|0,82648,f);f=Be[c[(c[l>>2]|0)+176>>2]&7]()|0;D=eM(t)|0;Q=eM(u)|0;C=eM(p)|0;a=eM(q)|0;O=eM(r)|0;M=eM(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;vd(E|0,f|0,e|0)|0;if((c[31964>>2]|0)==0){R=td(E|0)|0;S=Yc(E|0)|0;JL(v);JL(u);JL(t);JL(s);JL(r);JL(q);JL(p);i=b;return 0}e=Be[c[(c[l>>2]|0)+176>>2]&7]()|0;l=eM(t)|0;f=eM(u)|0;M=eM(p)|0;O=eM(q)|0;a=eM(r)|0;C=eM(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;tr(25,0,e,d);R=td(E|0)|0;S=Yc(E|0)|0;JL(v);JL(u);JL(t);JL(s);JL(r);JL(q);JL(p);i=b;return 0}function tI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=WM(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}uI(a,VM(l)|0,n,e);i=d;return}if((h&8|0)==0){yL(a,g);i=d;return}else{g=b;b=QM(g)|0;uI(a,b,SM(g)|0,f);i=d;return}}function uI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;vI(a,b,c,0);i=d;return}function vI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;wI(a,b,c);i=d;return}function wI(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=xI(c,d)|0;if(g>>>0>4294967279){vL(0)}if(g>>>0<11){PL(b,g);h=OL(b)|0}else{j=WL(g)|0;k=j+1|0;j=oB(CL(b)|0,k)|0;YL(b,j);XL(b,k);NL(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;pB(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){pB(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;pB(l,f);i=e;return}function xI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=yI(b,c,e)|0;i=d;return g|0}function yI(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function zI(a,b){a=a|0;b=b|0;var c=0;c=i;PI(a,b);i=c;return}function AI(a){a=a|0;var b=0;b=i;nI(a);WV(a);i=b;return}function BI(a){a=a|0;var b=0;b=i;nI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function CI(a){a=a|0;var b=0;b=i;AI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function DI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];EI(a+4|0);i=d;return}function EI(a){a=a|0;var b=0;b=i;FI(a);i=b;return}function FI(a){a=a|0;var b=0;b=i;c[a>>2]=82864;JL(a+32|0);KM(a);i=b;return}function GI(a){a=a|0;var b=0;b=i;EI(a);WV(a);i=b;return}function HI(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=WM(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){qw(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}qw(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=WM(l)|0;j=m-(VM(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=RM(l)|0;m=j-(QM(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(IL(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){qw(a,-1,-1);i=h;return}o=AW(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(IL(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((RM(l)|0)!=0){break}qw(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((WM(l)|0)!=0){break}qw(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=QM(l)|0;UM(l,q,q+o|0,n)}if((g&16|0)!=0){q=VM(l)|0;ZM(l,q,XM(l)|0);YM(l,o)}qw(a,o,e);i=h;return}}while(0);qw(a,-1,-1);i=h;return}function II(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=Ex(d)|0;qe[g&31](a,b,h,J,0,e);i=f;return}function JI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=WM(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((SM(g)|0)>>>0<j>>>0){b=QM(g)|0;UM(g,b,RM(g)|0,j)}j=RM(g)|0;if(!(j>>>0<(SM(g)|0)>>>0)){k=-1;i=d;return k|0}k=ay(a[j]|0)|0;i=d;return k|0}function KI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=WM(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=QM(h)|0;j=RM(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(Yx(d,-1)|0){UM(h,g,j+ -1|0,k);l=$x(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=Zx(d)|0;do{if(g){if(by(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=QM(h)|0;UM(h,j,(RM(h)|0)+ -1|0,k);a[RM(h)|0]=b;l=d;i=e;return l|0}function LI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(Yx(b,-1)|0){f=$x(b)|0;i=d;return f|0}g=a;h=RM(g)|0;j=h-(QM(g)|0)|0;h=WM(g)|0;do{if((h|0)==(XM(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=VM(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;$L(o,0);UL(o,RL(o)|0);p=IL(o)|0;ZM(g,p,p+(HL(o)|0)|0);YM(g,h-l|0);c[m>>2]=(VM(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(WM(g)|0)+1;h=c[(MI(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=IL(a+32|0)|0;UM(g,q,q+j|0,h)}f=NM(g,b&255)|0;i=d;return f|0}function MI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=NI(b,c,e)|0;i=d;return g|0}function NI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=OI(0,a,b)|0;i=c;return(d?b:a)|0}function OI(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function PI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;PM(a);c[a>>2]=82864;xL(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;xL(e);QI(a,e);JL(e);i=d;return}function QI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;KL(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=IL(e)|0;j=g+(HL(e)|0)|0;c[b>>2]=j;g=IL(e)|0;UM(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=HL(e)|0;c[b>>2]=(IL(e)|0)+h;UL(e,RL(e)|0);b=a;a=IL(e)|0;ZM(b,a,a+(HL(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}YM(b,h);i=d;return}function RI(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=hc(d|0,83288)|0;J=bd(83296,83288)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Vd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;wr(M,(I|0)!=0|0,83352,E);qc(83376,17,1,J|0)|0;qc(83400,10,1,J|0)|0;qc(83416,18,1,J|0)|0;SI(J,f,83440,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,83472)}else{c[G>>2]=Vd(c[L>>2]|0)|0;vr(26,0,83304,G);G=c[b+536>>2]|0;E=Vd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;wr(G,(I|0)!=0|0,83352,F)}qc(83480,348,1,I|0)|0;if((rc(H|0)|0)<0){c[D>>2]=Vd(c[L>>2]|0)|0;vr(26,0,83832,D);Yc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(83032,250,83856,kd(H|0)|0)|0)==0){vr(26,0,83880,C);Yc(I|0)|0;O=1;i=j;return O|0}qc(83904,13,1,I|0)|0;qc(83920,12,1,I|0)|0;TI(I,2);qc(83936,6,1,I|0)|0;UI(I,c[b+84>>2]|0);qc(83944,8,1,I|0)|0;TI(I,2);qc(83960,8,1,I|0)|0;C=b+88|0;UI(I,c[C>>2]|0);qc(83976,10,1,I|0)|0;TI(I,2);qc(83992,6,1,I|0)|0;UI(I,83032);qc(84e3,8,1,I|0)|0;TI(I,2);qc(84016,8,1,I|0)|0;UI(I,c[b+280>>2]|0);qc(84032,10,1,I|0)|0;TI(I,2);qc(84048,14,1,I|0)|0;UI(I,c[b+284>>2]|0);qc(84064,16,1,I|0)|0;TI(I,2);qc(84088,16,1,I|0)|0;UI(I,l);qc(84112,18,1,I|0)|0;TI(I,2);c[B>>2]=VI(l)|0;vd(I|0,84136,B|0)|0;TI(I,2);P=+Ds(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];vd(I|0,84176,A|0)|0;TI(I,2);P=+Ds(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];vd(I|0,84216,z|0)|0;TI(I,2);P=+Ds(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];vd(I|0,84248,y|0)|0;TI(I,2);P=+Ds(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];vd(I|0,84280,x|0)|0;TI(I,2);P=+Ds(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];vd(I|0,84312,w|0)|0;TI(I,2);P=+Ds(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];vd(I|0,84344,v|0)|0;TI(I,2);P=+Ds(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];vd(I|0,84384,u|0)|0;TI(I,2);P=+Gs(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];vd(I|0,84416,t|0)|0;TI(I,2);c[s>>2]=Bs(2)|0;vd(I|0,84456,s|0)|0;TI(I,2);P=+Fs(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];vd(I|0,84480,r|0)|0;qc(84512,13,1,I|0)|0;qc(84528,16,1,I|0)|0;TI(I,2);P=+Ds(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];vd(I|0,84552,q|0)|0;TI(I,2);c[p>>2]=ys(8)|0;vd(I|0,84576,p|0)|0;qc(84616,17,1,I|0)|0;qc(84640,22,1,I|0)|0;WI(I,b);qc(84664,23,1,I|0)|0;qc(84688,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{XI(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{XI(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{XI(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{XI(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{XI(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{XI(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{XI(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{XI(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}qc(84704,13,1,I|0)|0;qc(84720,12,1,I|0)|0;YI(I,J,f,c[C>>2]|0,b);qc(84736,13,1,I|0)|0;qc(84752,12,1,I|0)|0;ZI(I,c[b+68>>2]|0,b+56|0);qc(84768,13,1,I|0)|0;qc(84784,16,1,I|0)|0;_I(I,J,f,b);qc(84808,17,1,I|0)|0;qc(84832,14,1,I|0)|0;Yc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((qW(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(qW(K|0)|0)<<1}else{Q=0}I=OV(b+Q|0)|0;if((I|0)==0){cb(84848,84856,404,84880)}if((ab(J|0)|0)!=0){vr(26,0,84896,o)}if(e){e=c[C>>2]|0;c[n>>2]=84928;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;gc(I|0,84944,n|0)|0;if((rd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=85024|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;vr(1,0,85056,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;tr(1,0,85120,g);PV(I);O=0;i=j;return O|0}function SI(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=zs(F)|0;H=As(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Fs(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}qc(83376,17,1,a|0)|0;qc(86288,12,1,a|0)|0;qc(86304,12,1,a|0)|0;qc(86320,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;vd(a|0,86336,D|0)|0;qc(86376,10,1,a|0)|0;qc(86392,11,1,a|0)|0;qc(86408,11,1,a|0)|0;qc(86424,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];vd(a|0,86440,C|0)|0}else{qc(86464,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;vd(a|0,86064,B|0)|0;qc(86488,13,1,a|0)|0;if(E){qc(86304,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];vd(a|0,86504,A|0)|0}else{qc(86464,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;vd(a|0,86528,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;vd(a|0,86184,y|0)|0;qc(86576,10,1,a|0)|0;qc(86592,10,1,a|0)|0;qc(86576,10,1,a|0)|0;qc(86608,11,1,a|0)|0;c[x>>2]=b;vd(a|0,86624,x|0)|0;c[w>>2]=d;vd(a|0,86648,w|0)|0;qc(86664,33,1,a|0)|0;qc(86704,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;vd(a|0,86744,v|0)|0;qc(86424,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];vd(a|0,86440,u|0)|0}else{qc(86592,10,1,a|0)|0;qc(86576,10,1,a|0)|0;qc(86608,11,1,a|0)|0;c[t>>2]=b;vd(a|0,86624,t|0)|0;c[s>>2]=d;vd(a|0,86648,s|0)|0;qc(86664,33,1,a|0)|0;qc(86704,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;vd(a|0,86744,r|0)|0;qc(86424,10,1,a|0)|0;qc(86464,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;vd(a|0,86064,q|0)|0;qc(86488,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];vd(a|0,86504,p|0)|0}else{qc(86464,17,1,a|0)|0}qc(86776,32,1,a|0)|0;qc(86816,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;vd(a|0,86848,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;vd(a|0,86184,n|0)|0;i=m;return}function TI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Rd(32,a|0)|0;}while((d|0)!=0);i=c;return}function UI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==60){qc(86032,4,1,b|0)|0}else if((e|0)==34){qc(86056,6,1,b|0)|0}else if((e|0)==39){qc(86048,6,1,b|0)|0}else if((e|0)==62){qc(86040,4,1,b|0)|0}else{Rd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function VI(a){a=a|0;var b=0,c=0,d=0;b=i;c=hc(a|0,86024)|0;if((c|0)==0){d=-1;i=b;return d|0}Wc(c|0,0,2)|0;a=yb(c|0)|0;Yc(c|0)|0;d=a;i=b;return d|0}function WI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=OV((qW(l|0)|0)+15|0)|0;c[f>>2]=l;gc(m|0,85752,f|0)|0;TI(a,2);qc(85768,10,1,a|0)|0;UI(a,m);qc(85784,12,1,a|0)|0;TI(a,2);c[e>>2]=VI(m)|0;vd(a|0,85800,e|0)|0;PV(m);TI(a,2);qc(85832,9,1,a|0)|0;TI(a,4);qc(85848,22,1,a|0)|0;TI(a,4);qc(85872,22,1,a|0)|0;TI(a,4);qc(85896,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){aJ(g,m,n);o=c[l>>2]|0;TI(a,4);qc(85928,8,1,a|0)|0;UI(a,o);qc(85944,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{fJ(h,m,l);g=c[n>>2]|0;TI(a,4);qc(85928,8,1,a|0)|0;UI(a,g);qc(85944,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{aJ(j,m,q);b=c[t>>2]|0;TI(a,4);qc(85968,8,1,a|0)|0;UI(a,b);qc(85984,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){TI(a,2);v=86008;w=v;x=qc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{fJ(k,m,s);e=c[u>>2]|0;TI(a,4);qc(85968,8,1,a|0)|0;UI(a,e);qc(85984,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));TI(a,2);v=86008;w=v;x=qc(w|0,10,1,a|0)|0;i=d;return}function XI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;TI(a,2);c[f>>2]=c[b>>2];vd(a|0,85688,f|0)|0;UI(a,c[b+4>>2]|0);qc(85720,11,1,a|0)|0;UI(a,c[b+8>>2]|0);qc(85392,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];$I(a,4,e);TI(a,2);qc(85736,12,1,a|0)|0;i=d;return}function YI(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{aJ(p,r,v);SI(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,85504);w=v+9|0;Js(w);TI(a,2);c[o>>2]=c[f>>2];vd(a|0,85512,o|0)|0;TI(a,4);qc(83936,6,1,a|0)|0;UI(a,c[s>>2]|0);qc(83944,8,1,a|0)|0;TI(a,4);c[n>>2]=Bs(w)|0;vd(a|0,85288,n|0)|0;TI(a,4);x=+Gs(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];vd(a|0,85312,m|0)|0;TI(a,4);x=+Fs(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];vd(a|0,84480,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];$I(a,6,j);TI(a,2);qc(85536,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function ZI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{TI(a,2);eJ(l,d,x);c[j>>2]=c[q>>2];vd(a|0,85360,j|0)|0;eJ(m,d,x);UI(a,c[r>>2]|0);qc(85392,3,1,a|0)|0;TI(a,4);qc(85400,7,1,a|0)|0;eJ(n,d,x);if((c[s>>2]|0)>0){y=0;do{TI(a,6);c[g>>2]=0;vd(a|0,85408,g|0)|0;y=y+1|0;eJ(n,d,x);}while((y|0)<(c[s>>2]|0))}TI(a,4);qc(85432,8,1,a|0)|0;TI(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;eJ(o,d,x);z=+Ds(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;eJ(p,d,x);A=ys(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;vd(a|0,85448,f|0)|0;TI(a,2);qc(85488,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function _I(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{fJ(n,o,v-u|0);SI(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,85240);q=v+9|0;Js(q);TI(a,2);qc(85248,15,1,a|0)|0;TI(a,4);c[m>>2]=c[e>>2];vd(a|0,85264,m|0)|0;TI(a,4);c[l>>2]=Bs(q)|0;vd(a|0,85288,l|0)|0;TI(a,4);w=+Gs(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];vd(a|0,85312,j|0)|0;TI(a,4);w=+Fs(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];vd(a|0,84480,g|0)|0;TI(a,2);qc(85336,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function $I(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;TI(a,b);qc(85552,16,1,a|0)|0;UI(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?85656:85672;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;vd(a|0,85576,f|0)|0;i=e;return}function aJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){bJ(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function bJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=hc(c[o>>2]|0,86888)|0;if((p|0)!=0){q=p;break}p=Vd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;xr(0,86896,g)}else{q=0}}while(0);g=pm(0)|0;if((g|0)==0){xr(0,86928,f)}f=a+8|0;c[a+20>>2]=QV(c[f>>2]|0,32)|0;p=a+12|0;o=QV((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=86960;c[o+12>>2]=0;c[o+16>>2]=0;Am(g,h);Bm(g,8,64);h=c[n>>2]|0;do{if((h|0)==0){o=j;uW(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Cm(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Km(Hm(g)|0)|0;s=Im(g)|0;Yc(q|0)|0;wm(g);r=c[a>>2]|0;c[e>>2]=87064;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;xr(0,87e3,e)}else if((t|0)==11){Yc(q|0)|0;break}}else{if((Cm(g,h,qW(h|0)|0,1)|0)!=0){break}s=Km(Hm(g)|0)|0;o=Im(g)|0;wm(g);r=c[n>>2]|0;c[d>>2]=87064;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;xr(0,87104,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(87168,87064,295,87208)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(87232,87064,297,87208)}}function cJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((mW(87640,b)|0)==0){if((mW(c[d>>2]|0,87648)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}wr(0,p,87656,l);l=c[21874]|0;p=c[21928]|0;do{if((l|0)==0|(p|0)==0){c[21928]=32;a=OV(1152)|0;c[21874]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[21928]=p<<1;a=RV(l,p*72|0)|0;c[21874]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(iJ(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((mW(87720,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((mW(87728,u)|0)==0){c[21934]=zd(c[t+4>>2]|0)|0}else{if((mW(87760,u)|0)==0){c[87740>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((mW(87776,u)|0)==0){c[87748>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((mW(87784,u)|0)==0){c[87744>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((mW(87800,u)|0)==0){c[87752>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((mW(87808,u)|0)!=0){v=23;break a}c[87756>>2]=(mW(c[t+4>>2]|0,87824)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];xr(0,87832,k)}else if((v|0)==45){i=e;return}}if((mW(87480,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=87064;c[j+4>>2]=k;c[j+8>>2]=v;xr(0,87864,j)}if((mW(87928,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=87064;c[h+4>>2]=j;xr(0,87936,h)}h=Ub(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=87064;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;xr(0,87992,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=88056;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((mW(87424,b)|0)!=0){if((mW(87616,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=88160;m=zd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=88168;i=e;return}c[87444>>2]=0;c[87448>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((mW(m,87648)|0)==0){c[87444>>2]=zd(c[b+4>>2]|0)|0}else{if((mW(m,88112)|0)!=0){break}c[87448>>2]=zd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[87444>>2]|0)==0){w=0;break}w=(c[87448>>2]|0)!=0|0}}while(0);wr(0,w,88120,f);c[21860]=-1;f=87452|0;w=87736;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function dJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((mW(87424,b)|0)==0){o=e+0|0;p=87440|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));hJ(e);i=d;return}if((mW(87480,b)|0)==0){e=h+24|0;r=OV((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=OV(36)|0;t=s;o=s+0|0;p=(c[21874]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((mW(87504,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Ad(e+(k*20|0)+8|0,87512,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((mW(87552,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Ad(h+(k*20|0)+8|0,87568,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((mW(87616,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function eJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){bJ(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function fJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){bJ(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;xr(0,87272,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=4;n=m;o=87352;p=o;xr(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=4;n=m;o=87352;p=o;xr(0,p,f)}}function gJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){PV(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){PV(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}PV(k);c[d>>2]=0;i=b;return}function hJ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=OV(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=qW(f|0)|0;c[e+64>>2]=k;k=c[21908]|0;do{if((k|0)==0){c[21908]=e;c[e+44>>2]=0;l=OV(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){uc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=OV(384)|0;c[l>>2]=n;if((n|0)==0){uc(-1)}else{uW(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[21908]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[21908]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=qW(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(qW(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 3:{B=o;C=x;D=y;E=20;break};case 1:{F=o;G=x;H=y;E=22;break};case 7:{I=o;J=y;E=16;break};case 4:{K=o;L=y;E=19;break};case 10:{M=o;E=13;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;M=z;E=13;break};case 2:{N=o;O=x;P=y;E=21;break};case 9:{Q=o;E=14;break};case 6:{R=o;S=y;E=17;break};case 5:{T=o;U=y;E=18;break};case 8:{V=o;E=15;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+M|0;c[p>>2]=o;Q=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+Q|0;c[p>>2]=o;V=o;E=15}if((E|0)==15){I=V;J=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){R=I;S=((d[A+6|0]|0)<<16)+J|0;E=17}if((E|0)==17){T=R;U=((d[A+5|0]|0)<<8)+S|0;E=18}if((E|0)==18){K=T;L=(d[A+4|0]|0)+U|0;E=19}if((E|0)==19){B=K;C=((d[A+3|0]|0)<<24)+x|0;D=L;E=20}if((E|0)==20){N=B;O=((d[A+2|0]|0)<<16)+C|0;P=D;E=21}if((E|0)==21){F=N;G=((d[A+1|0]|0)<<8)+O|0;H=P;E=22}if((E|0)==22){W=F;X=(d[A]|0)+G|0;Y=H}H=X-Y-W^W>>>13;X=Y-W-H^H<<8;Y=W-H-X^X>>>13;W=H-X-Y^Y>>>12;H=X-Y-W^W<<16;X=Y-W-H^H>>>5;Y=W-H-X^X>>>3;W=H-X-Y^Y<<10;H=X-Y-W^W>>>15;c[p>>2]=H;p=(c[21908]|0)+40|0;W=c[p>>2]|0;Y=H&(c[W+4>>2]|0)+ -1;H=c[W>>2]|0;W=H+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[H+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[21908]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[21908]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=OV((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){uc(-1)}uW(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;H=c[j>>2]|0;c[Y+24>>2]=(((H<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((H|0)==0){_=e}else{H=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=H}else{W=H;X=j;while(1){j=X+16|0;G=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];F=Z+(A*12|0)+4|0;E=(c[F>>2]|0)+1|0;c[F>>2]=E;P=c[W+24>>2]|0;if(E>>>0>P>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[F>>2]|0)>>>0)/(P>>>0)|0}c[X+12>>2]=0;P=Z+(A*12|0)|0;c[j>>2]=c[P>>2];j=c[P>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[P>>2]=X;P=c[h>>2]|0;if((G|0)==0){$=P;break}else{W=P;X=G}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){H=$;Y=W;e=X}else{_=W;break}}}PV(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function iJ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[21908]|0)==0){f=24}else{g=qW(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(qW(a|0)|0)+s|0;switch(v|0){case 3:{x=h;y=t;z=u;f=13;break};case 2:{A=h;B=t;C=u;f=14;break};case 9:{D=h;f=7;break};case 1:{E=h;F=t;G=u;f=15;break};case 4:{H=h;I=u;f=12;break};case 10:{J=h;f=6;break};case 11:{J=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 6:{K=h;L=u;f=10;break};case 5:{M=h;N=u;f=11;break};case 8:{O=h;f=8;break};case 7:{P=h;Q=u;f=9;break};default:{R=h;S=t;T=u}}if((f|0)==6){D=((d[w+9|0]|0)<<16)+J|0;f=7}if((f|0)==7){O=((d[w+8|0]|0)<<8)+D|0;f=8}if((f|0)==8){P=O;Q=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){K=P;L=((d[w+6|0]|0)<<16)+Q|0;f=10}if((f|0)==10){M=K;N=((d[w+5|0]|0)<<8)+L|0;f=11}if((f|0)==11){H=M;I=(d[w+4|0]|0)+N|0;f=12}if((f|0)==12){x=H;y=((d[w+3|0]|0)<<24)+t|0;z=I;f=13}if((f|0)==13){A=x;B=((d[w+2|0]|0)<<16)+y|0;C=z;f=14}if((f|0)==14){E=A;F=((d[w+1|0]|0)<<8)+B|0;G=C;f=15}if((f|0)==15){R=E;S=(d[w]|0)+F|0;T=G}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[21908]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=qW(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((lW(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,88192)|0)==0){V=0;break}else{W=88216}i=b;return W|0}}while(0);c[e>>2]=a;wr(0,(V|0)!=0|0,88264,e);W=V+4|0;i=b;return W|0}function jJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((kJ(88320,a,b)|0)!=0){d=1;i=c;return d|0}d=(kJ(88328,a,b)|0)!=0|0;i=c;return d|0}function kJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((mW(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function lJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(mW(c[36700>>2]|0,88336)|0)==0|0;wr(0,m,88352,l);l=(mW(c[38604>>2]|0,88336)|0)==0|0;wr(0,l,88408,k);k=(mW(c[40596>>2]|0,88336)|0)==0|0;wr(0,k,88464,j);j=88528|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=88656|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[40600+(k<<2)>>2]|0;if((l|0)==1){if((kJ(c[36576+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[36576+(k<<2)>>2]|0;if(!((kJ(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[36576+(k<<2)>>2]|0;if((nJ(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=88528+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=88528+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[88656+(k<<2)>>2]=mJ(r,p)|0;t=j}else if((q|0)==13){q=0;l=88528+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[88656+(k<<2)>>2]=oJ(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];vr(1,0,88784,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];vr(1,0,88784,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];vr(1,0,88784,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];vr(1,0,88840,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function mJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((mW(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function nJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(oJ(a,b)|0)!=0|0;i=c;return d|0}function oJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=qW(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((nW(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function pJ(){i=i;return}function qJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){uc(0)}e=c[r>>2]|0;qc(88872,5,1,e|0)|0;f=b;b=0;while(1){Rd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}qc(88880,20,1,e|0)|0;uc(0);return 0}function rJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;vd(d|0,88904,e|0)|0;if((b|0)==0){uc(1)}else{td(d|0)|0;zJ();td(d|0)|0;ib(6,0)|0;hd()}}function sJ(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function tJ(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function uJ(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function vJ(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function wJ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function xJ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}uW(p|0,32,b+(d-p)|0)|0;i=f;return}function yJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=89944+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[89988+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[89984+(e*48|0)>>2]|0)==1){AJ(b)|0}k=89948+(e*48|0)|0;if((c[k>>2]|0)==0){break}Yc(c[f>>2]|0)|0;PV(c[k>>2]|0)}}while(0);do{if((h|0)==10){Yc(g|0)|0;b=89948+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Id(k|0)|0;PV(c[b>>2]|0)}}while(0);c[f>>2]=0}c[89980+(e*48|0)>>2]=0;c[89948+(e*48|0)>>2]=0;i=d;return 0}function zJ(){var a=0,b=0;a=i;if((c[22228]|0)!=0){i=a;return}c[22228]=1;c[88920>>2]=0;b=0;do{c[88916>>2]=b;yJ(88912)|0;b=b+1|0;}while((b|0)<100);i=a;return}function AJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[89960+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=89944+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Wc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[89964+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[89972+(d*48|0)>>2]&2|0)!=0){td(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Wc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){CJ(111,88928);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function BJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function CJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;vd(m|0,89840,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;vd(m|0,89872,j|0)|0;l=m;break}else{n=c[89712+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;vd(m|0,89896,h|0)|0;l=m;break}}}while(0);h=c[22476]|0;do{if((h|0)==0){qc(94776,29,1,l|0)|0}else{c[g>>2]=(h-89944|0)/48|0;vd(l|0,89912,g|0)|0;b=c[(c[22476]|0)+4>>2]|0;if((b|0)==0){qc(94760,10,1,l|0)|0;break}else{c[f>>2]=b;vd(l|0,94744,f|0)|0;break}}}while(0);f=c[23702]|0;if((f|0)!=0){c[d>>2]=f;vd(l|0,94816,d|0)|0}d=(c[23722]|0)!=0?94896:94912;f=(c[23730]|0)!=0?94928:94944;g=(c[23740]|0)!=0?94968:94984;c[e>>2]=(c[23716]|0)!=0?94872:94880;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;vd(l|0,94840,e|0)|0;rJ(95e3,1)}function DJ(){var a=0,b=0;a=i;c[23752]=1;b=c[r>>2]|0;c[22486]=b;c[89964>>2]=BJ(b)|0;c[89968>>2]=1;c[89984>>2]=1;b=c[s>>2]|0;c[90184>>2]=b;c[90204>>2]=BJ(b)|0;c[90208>>2]=1;c[90224>>2]=0;b=c[t>>2]|0;c[90232>>2]=b;c[90252>>2]=BJ(b)|0;c[90256>>2]=1;c[90272>>2]=1;i=a;return}function EJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=wc(g|0,c[100256+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[23754]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=wc(c[f>>2]|0,c[100256+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[23754]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Wc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Wc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function FJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){CJ(b,d)}d=c[23756]|0;if((d|0)!=0){Be[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function GJ(a){a=a|0;var b=0,d=0;b=i;c[23786]=0;c[23788]=0;c[23790]=0;d=((HJ(a,0)|0)==0)<<31>>31;i=b;return d|0}function HJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[23790]|0;c[23790]=j+1;if((j|0)==1){c[23788]=d}if((MJ(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=NJ(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function IJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[23786]|0;l=95168+(k<<4)|0;m=c[l>>2]|0;switch(JJ(m)|0){case 6:{n=c[95172+(k<<4)>>2]|0;o=(c[25002]|0)+1|0;c[25002]=o;c[100016+(o<<2)>>2]=n;c[23786]=k+1;continue b;break};case 22:{c[23764]=1;c[23786]=k+1;continue b;break};case 3:{n=c[25002]|0;o=100016+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[25002]=n+ -1;c[25018]=(c[25018]|0)+ -1;c[23786]=k+1;continue b}else{n=c[25018]|0;c[25018]=n+ -1;c[23786]=(c[100080+(n<<2)>>2]|0)+1;continue b}break};case 20:{c[23782]=c[95172+(k<<4)>>2];c[23786]=k+1;continue b;break};case 8:{n=c[25002]|0;q=100016+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){t=10;break b}c[25002]=n+ -1;c[23786]=k+1;continue b;break};case 16:{if(b){t=28;break a}c[23786]=k+1;continue b;break};case 18:{c[23762]=1;c[23786]=k+1;continue b;break};case 2:{c[25002]=0;c[25018]=0;c[23786]=c[95172+(k<<4)>>2];if(b){t=24;break a}if((c[25014]|0)==0){j=0;t=37;break a}n=Be[c[23772]&7]()|0;if((n|0)==0){continue b}else{j=n;t=37;break a}break};case 21:{c[23764]=0;c[23786]=k+1;continue b;break};case 9:{n=(he[c[23770]&127](l)|0)==0;c[23786]=(c[23786]|0)+1;if(n){break b}else{continue b}break};case 33:{c[25030]=1;c[23786]=k+1;continue b;break};case 19:case 17:{c[23762]=0;c[23786]=k+1;continue b;break};case 1:{n=c[95172+(k<<4)>>2]|0;p=(c[25018]|0)+1|0;c[25018]=p;c[100080+(p<<2)>>2]=n;c[23786]=k+1;continue b;break};default:{t=4;break a}}}if((t|0)==10){t=0;if(b){t=11;break}c[q>>2]=s+ -1;c[25014]=1;k=ke[c[23768]&63](l,g,d)|0;if((k|0)>0){t=13;break}if((k|0)<0){t=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;t=37;break}}if((t|0)==4){h=c[r>>2]|0;d=c[23702]|0;c[f>>2]=m;c[f+4>>2]=d;vd(h|0,99968,f|0)|0;if((c[c[23758]>>2]|0)==0){CJ(100,1e5);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((t|0)==11){j=Be[c[23756]&7]()|0;i=e;return j|0}else if((t|0)==13){f=c[c[23758]>>2]|0;j=FJ(f,c[(Nc()|0)>>2]|0,100064)|0;i=e;return j|0}else if((t|0)==15){if((c[(c[23758]|0)+8>>2]|0)==0){CJ(-1,100064);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((t|0)==24){j=Be[c[23756]&7]()|0;i=e;return j|0}else if((t|0)==28){j=Be[c[23756]&7]()|0;i=e;return j|0}else if((t|0)==37){i=e;return j|0}return 0}function JJ(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function KJ(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=IJ(b,0,0)|0;i=a;return d|0}function LJ(){c[23778]=0;c[23786]=0;c[25018]=0;c[25002]=0;c[25014]=0;c[25020]=0;c[25004]=0;i=i;return}function MJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[23786]|0;if((g|0)>299){qc(100144,24,1,c[r>>2]|0)|0;rJ(c[23702]|0,1)}else{c[95168+(g<<4)>>2]=a;c[95172+(g<<4)>>2]=b;c[95176+(g<<4)>>2]=d;c[95180+(g<<4)>>2]=e;c[23786]=g+1;i=f;return g|0}return 0}function NJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=OJ(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[23790]|0)+ -1|0;c[23790]=h;if((h|0)==0){MJ(2,c[23788]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{MJ(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function OJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((PJ(b,e)|0)!=0){g=c[e>>2]|0;break}if((QJ(b,e)|0)!=0){g=c[e>>2]|0;break}h=RJ(b,f,1)|0;j=MJ(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=HJ(h,j)|0}}while(0);i=d;return g|0}function PJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){MJ(22,0,0,0)|0;j=g;k=30;break a}else{MJ(21,0,0,0)|0;j=g;k=30;break a}break};case 112:case 80:{MJ(20,1,0,0)|0;j=b;k=30;break};case 47:{MJ(5,0,0,0)|0;j=b;k=30;break};case 45:{l=1;k=13;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{m=b;n=0;k=14;break};case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==82|h<<24>>24==114){o=g;p=14}else if(h<<24>>24==76|h<<24>>24==108){o=g;p=13}else{o=b;p=15}g=RJ(o+1|0,f,0)|0;if((g|0)==0){k=15;break a}MJ(p,c[f>>2]|0,0,0)|0;j=g+ -1|0;k=30;break};case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==83|h<<24>>24==115){q=g;r=19}else if(h<<24>>24==80|h<<24>>24==112){q=g;r=18}else{q=b;r=17}MJ(r,0,0,0)|0;j=q;k=30;break};case 36:{MJ(33,0,0,0)|0;j=b;k=30;break};case 120:case 88:{MJ(4,1,0,0)|0;j=b;k=30;break};case 43:{l=0;k=13;break};case 58:{MJ(16,0,0,0)|0;j=b;k=30;break};case 39:case 34:case 2:{c[95176+((MJ(11,0,0,0)|0)<<4)>>2]=b;g=SJ(b)|0;c[d>>2]=g;s=(g|0)!=0|0;i=e;return s|0};default:{s=0;i=e;return s|0}}}while(0);if((k|0)==13){m=b+1|0;n=l;k=14}b:do{if((k|0)==14){l=RJ(m,f,0)|0;if((l|0)==0){k=15;break}switch(a[l]|0){case 104:case 72:{b=c[f>>2]|0;c[95176+((MJ(12,b,0,0)|0)<<4)>>2]=l+1;j=l+b|0;k=30;break b;break};case 120:case 88:{MJ(4,c[f>>2]|0,0,0)|0;j=l;k=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((n|0)==0){t=b}else{q=0-b|0;c[f>>2]=q;t=q}MJ(20,t,0,0)|0;j=l;k=30;break b;break};default:{s=0;i=e;return s|0}}}}while(0);if((k|0)==15){c[d>>2]=0;s=1;i=e;return s|0}else if((k|0)==30){c[d>>2]=j+1;s=1;i=e;return s|0}return 0}function QJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=RJ(b,f,1)|0;MJ(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 105:case 73:{l=7;m=10;n=38;break};case 103:case 71:{o=0;n=3;break};case 111:case 79:{l=32;m=34;n=38;break};case 102:case 70:{p=RJ(f,g,0)|0;if((p|0)==0){n=4;break a}q=c[g>>2]|0;if((q|0)==0){r=p;n=45;break a}if((a[p]|0)==46){s=RJ(p+1|0,h,0)|0;if((s|0)==0){n=4;break a}t=s;u=c[h>>2]|0}else{c[h>>2]=0;t=p;u=0}MJ(23,q,u,0)|0;r=t;n=45;break};case 101:case 69:{o=1;n=3;break};case 108:case 76:{q=RJ(f,g,0)|0;if((q|0)==0){n=4;break a}p=c[g>>2]|0;if((p|0)==0){r=q;n=45;break a}MJ(29,p,0,0)|0;r=q;n=45;break};case 122:case 90:{l=35;m=36;n=38;break};case 100:case 68:{q=RJ(f,g,0)|0;if((q|0)==0){n=4;break a}p=c[g>>2]|0;if((p|0)==0){r=q;n=45;break a}if((a[q]|0)==46){s=RJ(q+1|0,h,0)|0;if((s|0)==0){n=4;break a}v=s;w=c[h>>2]|0}else{c[h>>2]=0;v=q;w=0}MJ(26,p,w,0)|0;r=v;n=45;break};case 97:case 65:{p=f;while(1){x=a[p]|0;if(x<<24>>24==32){p=p+1|0}else{break}}if(!((x+ -48<<24>>24&255)<10)){MJ(30,0,0,0)|0;r=p;n=45;break a}q=RJ(p,g,1)|0;s=c[g>>2]|0;if((s|0)==0){r=q;n=45;break a}MJ(31,s,0,0)|0;r=q;n=45;break};default:{c[23786]=(c[23786]|0)+ -1;c[d>>2]=b;y=0;i=e;return y|0}}}while(0);do{if((n|0)==3){b=RJ(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=b;n=45;break}v=a[b]|0;if(v<<24>>24==46){w=RJ(b+1|0,h,0)|0;if((w|0)==0){n=4;break}z=w;A=a[w]|0}else{c[h>>2]=0;z=b;A=v}if(!(A<<24>>24==101|A<<24>>24==69)){MJ((o|0)==1?24:27,x,c[h>>2]|0,0)|0;r=z;n=45;break}v=RJ(z+1|0,j,0)|0;if((v|0)==0){n=4;break}MJ((o|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;r=v;n=45}else if((n|0)==38){v=RJ(f,g,0)|0;if((v|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=v;n=45;break}if((a[v]|0)!=46){MJ(l,x,0,0)|0;r=v;n=45;break}b=RJ(v+1|0,h,0)|0;if((b|0)==0){n=4;break}MJ(m,x,c[h>>2]|0,0)|0;r=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;y=1;i=e;return y|0}else if((n|0)==45){c[d>>2]=r;y=1;i=e;return y|0}return 0}function RJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function SJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[23758]>>2]|0)==0){CJ(100,100128);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function TJ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[100198|0]=48;k=100198|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=100176+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function UJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[23780]|0;f=c[23776]|0;if((e|0)>(f|0)){c[23776]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[25068]|0)){h=g}else{VJ(f,g);h=c[23776]|0}g=c[25070]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Jd(g|0,c[23754]|0)|0;h=qW(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Rd(a[k]|0,c[23754]|0)|0;Jd(h|0,c[23754]|0)|0;b=qW(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function VJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[25070]|0;if((f|0)==100360){c[25068]=1024;g=1024}else{g=c[25068]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[25068]=j;h=j}j=OV(h)|0;if((j|0)==0){CJ(113,100760);k=c[25070]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[25070]|0}else{l=k}if((l|0)==100360){m=100280;c[25070]=j;i=e;return}PV(l);m=100280;c[25070]=j;i=e;return}function WJ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[23776]|0;f=c[25068]|0;if((e|0)<(f|0)){g=e}else{VJ(e,f);g=c[23776]|0}c[23776]=g+1;a[(c[25070]|0)+g|0]=b;i=d;return}function XJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[23740]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){CJ(101,100288);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[23752]|0)==0){DJ();m=c[f>>2]|0}else{m=k}k=89944+(m*48|0)|0;c[22476]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){aK(k,c[b+12>>2]|0,j);o=bK(j,h)|0;if((o|0)==(c[89952+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[89956+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=yJ(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[89976+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=89960+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[89976+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=89968+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[89968+(m*48|0)>>2]=1;r=1;break}else{c[89968+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];gc(j|0,100296,e|0)|0}else{aK(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){YJ(107,100288,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=89988+(m*48|0)|0;c[q>>2]=0;c[89980+(m*48|0)>>2]=0;e=89984+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=89972+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((Bc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){YJ(128,100288,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;o=Lb()|0;c[n>>2]=o;if((o|0)!=0){c[89948+(m*48|0)>>2]=0;c[89956+(m*48|0)>>2]=-1;c[89952+(m*48|0)>>2]=-1;c[89964+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){YJ(s,100288,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Bc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){YJ(o,100288,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=hc(j|0,c[25064]|0)|0;if((o|0)==0){break}Yc(o|0)|0}}while(0);q=OV((qW(j|0)|0)+1|0)|0;c[89948+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){YJ(113,100312,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}wW(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=hc(j|0,c[100256+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=hc(j|0,c[100216+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=hc(j|0,c[100256+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){CJ(o,100288);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=89964+(m*48|0)|0;c[r>>2]=BJ(u)|0;u=bK(j,89956+(m*48|0)|0)|0;c[89952+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){YJ(108,100288,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Wc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){YJ(129,100288,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function YJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){CJ(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[25068]|0)){j=d;k=g}else{VJ(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[25070]|0;c[(c[22476]|0)+4>>2]=f;aK(k,j,f);CJ(a,b);i=e;return}function ZJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;gc(j|0,100296,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=qW(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?100328:100336;c[h+24>>2]=(b|0)==5?100344:100352;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=XJ(h)|0;i=e;return a|0}function _J(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=89944+(d*48|0)|0;c[22476]=e;if(d>>>0>99){if((c[a>>2]|0)==0){CJ(101,100776);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((ZJ(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){CJ(114,100784);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[89968+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){CJ(102,100784);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function $J(){var a=0,b=0;a=i;b=KJ()|0;c[23702]=0;i=a;return b|0}function aK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function bK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((kc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function cK(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[23782]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[23762]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gc(p|0,100792,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(qW(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;ee[c[23766]&255](32);}while((A|0)>0)}if((D|0)!=0){ee[c[23766]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{ee[c[23766]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Ec(A|0)|0)+1|0;c[m>>2]=t-(c[23782]|0);gc(A|0,100800,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;ee[c[23766]&255](32);}while((z|0)>0)}if((x|0)!=0){ee[c[23766]&255]((w|0)!=0?45:43)}z=c[23782]|0;do{if((z|0)<1){ee[c[23766]&255](46);y=c[23766]|0;if((z|0)<0){G=y;J=z;while(1){ee[G&255](48);I=J+1|0;K=c[23766]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}ee[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}ee[c[23766]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[23766]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){ee[P&255](a[J]|0);R=Q+ -1|0;S=c[23766]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}ee[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;ee[c[23766]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){ee[c[23766]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;ee[c[23766]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){ee[c[23766]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;ee[c[23766]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;ee[c[23766]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;ee[c[23766]&255](42);}while((_|0)>0);i=l;return 0}function dK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[23782]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(gc(n|0,100808,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[23762]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;ee[c[23766]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;ee[c[23766]&255](32);}while((b|0)>0)}do{if(q){if((c[23762]|0)==0){break}ee[c[23766]&255](43)}else{ee[c[23766]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;ee[c[23766]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;ee[c[23766]&255](48);}while((z|0)>0);i=j;return 0}function eK(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{ee[c[23766]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[23766]|0;if((h|0)==0){ee[d&255](70);i=g;return 0}else{ee[d&255](84);i=g;return 0}return 0}function fK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[23778]|0)!=0){g=gK()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 23:{h=dK(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 29:{eK(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 34:{iK(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 31:{kK(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 30:{jK(b,d);h=0;i=e;return h|0};case 32:{hK(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 25:case 24:case 26:{h=cK(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=lK(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 7:{hK(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 35:{mK(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 36:{mK(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 10:{iK(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;vd(h|0,100816,f|0)|0;rJ(c[23702]|0,1)}}return 0}function gK(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[23778]|0;c[23778]=0;if((c[23740]|0)!=0){if((b|0)>0){d=c[23780]|0;e=c[23776]|0;if((d|0)<=(e|0)){f=b;while(1){ee[c[23766]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[23776]=f;h=0;i=a;return h|0}f=b-d+e|0;c[23776]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){ee[c[23766]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[23776]|0;f=j+b|0;if((f|0)>=0){if((c[23780]|0)<(j|0)){c[23780]=j}c[23776]=f;h=0;i=a;return h|0}if((c[c[23758]>>2]|0)==0){CJ(110,100904);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[23776]|0;if((c[23780]|0)<(f|0)){c[23780]=f}j=f+b|0;c[23776]=j;c[23784]=(c[23784]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[23758]>>2]|0)==0){CJ(110,100904);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[23776]|0;f=j+b|0;if((f|0)>=(c[(c[23760]|0)+16>>2]|0)){if((c[c[23758]>>2]|0)==0){CJ(110,100920);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[23780]|0;if((d|0)<=(j|0)){e=b;while(1){ee[c[23766]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[23784]=(c[23784]|0)+b;c[23776]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[23784]=(c[23784]|0)+f;c[23776]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){ee[c[23766]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function hK(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=TJ(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[23762]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{ee[c[23766]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{ee[c[23766]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[23762]|0)==0){break}ee[c[23766]&255](43)}else{ee[c[23766]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){ee[c[23766]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function iK(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=TJ(m,k,l,h)|0;h=c[l>>2]|0;g=(c[23762]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{ee[c[23766]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{ee[c[23766]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[23762]|0)==0){break}ee[c[23766]&255](43)}else{ee[c[23766]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){ee[c[23766]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){ee[c[23766]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{ee[c[23766]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function jK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;ee[c[23766]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function kK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;ee[c[23766]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;ee[c[23766]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function lK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=cK(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=cK(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[23782]|0;c[23782]=0;p=(e|0)==0?4:e+2|0;e=dK(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{ee[c[23766]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[23782]=o;n=e;i=j;return n|0}function mK(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{ee[c[23766]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;ee[c[23766]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;ee[c[23766]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){ee[c[23766]&255](a[100880+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){ee[c[23766]&255](a[100880+((d[p]|0)>>>4)|0]|0);ee[c[23766]&255](a[100880+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function nK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 15:{c[23778]=(c[a+4>>2]|0)+ -1-(c[23776]|0);f=1;i=b;return f|0};case 5:{f=Be[c[23774]&7]()|0;i=b;return f|0};case 12:{f=pK(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[23778]=(c[23778]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 11:{f=oK(c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[23778]|0)-(c[a+4>>2]|0)|0;a=0-(c[23776]|0)|0;c[23778]=(g|0)<(a|0)?a:g;f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;vd(f|0,100848,d|0)|0;rJ(c[23702]|0,1)}}return 0}function oK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[23778]|0)!=0){e=gK()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}ee[c[23766]&255](e<<24>>24);n=b}else{ee[c[23766]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function pK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[23778]|0)!=0){f=gK()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;ee[c[23766]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function qK(){var a=0,b=0;a=i;b=UJ(10)|0;c[23778]=0;c[23776]=0;c[23780]=0;i=a;return(b|0)==0|0}function rK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[23752]|0)==0){DJ()}c[23716]=0;c[23722]=1;c[23730]=1;c[23740]=1;d=_J(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[23758]=a;c[23776]=0;c[23778]=0;c[23780]=0;c[25030]=0;c[23782]=0;d=c[a+12>>2]|0;c[23702]=d;c[23754]=c[c[22476]>>2];if((GJ(d)|0)<0){if((c[a>>2]|0)==0){CJ(100,100928);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[23766]=203;c[23768]=44;c[23770]=111;c[23756]=4;c[23772]=5;c[23774]=6;LJ();c[23762]=0;d=c[22476]|0;c[23764]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((EJ(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){CJ(f,100936);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function sK(){var a=0,b=0;a=i;if((c[25030]|0)==0){b=UJ(10)|0}else{UJ(0)|0;td(c[23754]|0)|0;b=0}c[23778]=0;c[23776]=0;c[23780]=0;i=a;return b|0}function tK(){var a=0,b=0,d=0;a=i;if((c[25014]|0)==0){b=0}else{d=UJ(10)|0;c[25014]=0;b=d}c[23778]=0;c[23776]=0;c[23780]=0;i=a;return b|0}



function Xg(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0.0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0,_a=0.0,$a=0.0,ab=0,bb=0.0,cb=0.0,db=0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0.0,Eb=0.0,Fb=0,Gb=0.0,Hb=0.0,Ib=0;e=i;i=i+6760|0;f=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;re[c[(d+8|0)>>2]&3](0,0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+464>>3],0,d);re[c[(d+8|0)>>2]&3](0,1,-1.0,1,d);J=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;K=c[c[(b+4|0)>>2]>>2]|0;L=+h[(c[K+8>>2]|0)+48>>3];do{if(J){if(L>0.0){M=L;N=K}else{O=c[20226]|0;P=c[b+536>>2]|0;h[k>>3]=L;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Q=e+504|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[O&31](P,e+504|0,3016,E);P=c[c[(b+4|0)>>2]>>2]|0;M=+h[(c[P+8>>2]|0)+48>>3];N=P}if(M>0.0){R=M;S=N}else{P=c[20226]|0;O=c[b+536>>2]|0;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Q=e+480|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[P&31](O,e+480|0,3016,D);O=c[c[(b+4|0)>>2]>>2]|0;R=+h[(c[O+8>>2]|0)+48>>3];S=O}T=R*R;O=R!=0.0;if(T*T!=0.0){if(O){U=R;V=R}else{T=+zr(c[b+536>>2]|0,R,3088,3184,+h[S>>3],(a[b+319|0]|0)!=0|0);U=T;V=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}T=V*3.247474414e-16;W=V*(T+-9.322036725e-12)+1.575771013333333e-7;X=V*W+-.0009809873795;Y=V*X+20.49107091;Z=V*Y;_=V*V;$=_*(V*(R*(-13835.01485/U+(V*(V*(V*(T+(T+-9.322036725e-12))+W)+X)+Y))+(+da(+L)*-13835.01485+Z+75320.6691))-(V*(+da(+M)*-13835.01485+Z+75320.6691)+-3730042.76))*518.2791167938085/(_*_);break}if(O){aa=R;ba=R;ca=S}else{_=+zr(c[b+536>>2]|0,R,3088,3184,+h[S>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;aa=_;ba=+h[(c[O+8>>2]|0)+48>>3];ca=O}_=ba*3.247474414e-16;Z=ba*(_+-9.322036725e-12)+1.575771013333333e-7;Y=ba*Z+-.0009809873795;X=ba*Y+20.49107091;W=+da(+L)*-13835.01485;T=ba*X;ea=+da(+M)*-13835.01485;O=ba!=0.0;if(ba*ba*(ba*(R*(-13835.01485/aa+(ba*(ba*(ba*(_+(_+-9.322036725e-12))+Z)+Y)+X))+(W+T+75320.6691))-(ba*(ea+T+75320.6691)+-3730042.76))*518.2791167938085==0.0){if(O){fa=ba;ga=ba}else{T=+zr(c[b+536>>2]|0,ba,3088,3184,+h[ca>>3],(a[b+319|0]|0)!=0|0);fa=T;ga=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}T=ga*3.247474414e-16;X=ga*(T+-9.322036725e-12)+1.575771013333333e-7;Y=ga*X+-.0009809873795;Z=ga*Y+20.49107091;_=ga*Z;$=ga*ga*(ga*(ba*(-13835.01485/fa+(ga*(ga*(ga*(T+(T+-9.322036725e-12))+X)+Y)+Z))+(W+_+75320.6691))-(ga*(ea+_+75320.6691)+-3730042.76))*518.2791167938085;break}if(O){ha=b+319|0;ia=ba;ja=ba;ka=ca}else{_=+zr(c[(b+536|0)>>2]|0,ba,3088,3184,+h[ca>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;ha=b+319|0;ia=_;ja=+h[(c[O+8>>2]|0)+48>>3];ka=O}_=ja*3.247474414e-16;Z=ja*(_+-9.322036725e-12)+1.575771013333333e-7;Y=ja*Z+-.0009809873795;X=ja*Y+20.49107091;T=ja*X;la=ja*ja;$=la*(ja*(ba*(-13835.01485/ia+(ja*(ja*(ja*(_+(_+-9.322036725e-12))+Z)+Y)+X))+(W+T+75320.6691))-(ja*(ea+T+75320.6691)+-3730042.76))*518.2791167938085/+zr(c[(b+536|0)>>2]|0,la*la,3104,3184,+h[ka>>3],(a[ha]|0)!=0|0)}else{if(L>0.0){ma=L;na=K}else{O=c[20226]|0;P=c[b+536>>2]|0;h[k>>3]=L;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];Q=e+552|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[O&31](P,e+552|0,3016,G);P=c[c[(b+4|0)>>2]>>2]|0;ma=+h[(c[P+8>>2]|0)+48>>3];na=P}if(ma>0.0){oa=ma;pa=na}else{P=c[20226]|0;O=c[b+536>>2]|0;h[k>>3]=ma;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Q=e+528|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[P&31](O,e+528|0,3016,F);O=c[c[(b+4|0)>>2]>>2]|0;oa=+h[(c[O+8>>2]|0)+48>>3];pa=O}la=oa*oa;O=oa!=0.0;if(la*la!=0.0){if(O){qa=oa;ra=oa}else{la=+zr(c[b+536>>2]|0,oa,3088,3184,+h[pa>>3],(a[b+319|0]|0)!=0|0);qa=la;ra=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}la=ra*-9.953410979999998e-13;T=ra*(la+5.0671326075e-9)+-1206351476666667.0e-20;ea=ra*T+.01958809645;W=ra*ea+-12.0257785;X=ra*W;Y=ra*ra;$=Y*(ra*(oa*(2786.18102/qa+(ra*(ra*(ra*(la+(la+5.0671326075e-9))+T)+ea)+W))+(+da(+L)*2786.18102+X+-23313.1436))-(ra*(+da(+ma)*2786.18102+X+-23313.1436)+176685.0998))*518.2791167938085/(Y*Y);break}if(O){sa=oa;ta=oa;ua=pa}else{Y=+zr(c[b+536>>2]|0,oa,3088,3184,+h[pa>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;sa=Y;ta=+h[(c[O+8>>2]|0)+48>>3];ua=O}Y=ta*-9.953410979999998e-13;X=ta*(Y+5.0671326075e-9)+-1206351476666667.0e-20;W=ta*X+.01958809645;ea=ta*W+-12.0257785;T=+da(+L)*2786.18102;la=ta*ea;Z=+da(+ma)*2786.18102;O=ta!=0.0;if(ta*ta*(ta*(oa*(2786.18102/sa+(ta*(ta*(ta*(Y+(Y+5.0671326075e-9))+X)+W)+ea))+(T+la+-23313.1436))-(ta*(Z+la+-23313.1436)+176685.0998))*518.2791167938085==0.0){if(O){va=ta;wa=ta}else{la=+zr(c[b+536>>2]|0,ta,3088,3184,+h[ua>>3],(a[b+319|0]|0)!=0|0);va=la;wa=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}la=wa*-9.953410979999998e-13;ea=wa*(la+5.0671326075e-9)+-1206351476666667.0e-20;W=wa*ea+.01958809645;X=wa*W+-12.0257785;Y=wa*X;$=wa*wa*(wa*(ta*(2786.18102/va+(wa*(wa*(wa*(la+(la+5.0671326075e-9))+ea)+W)+X))+(T+Y+-23313.1436))-(wa*(Z+Y+-23313.1436)+176685.0998))*518.2791167938085;break}if(O){xa=b+319|0;ya=ta;za=ta;Aa=ua}else{Y=+zr(c[(b+536|0)>>2]|0,ta,3088,3184,+h[ua>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;xa=b+319|0;ya=Y;za=+h[(c[O+8>>2]|0)+48>>3];Aa=O}Y=za*-9.953410979999998e-13;X=za*(Y+5.0671326075e-9)+-1206351476666667.0e-20;W=za*X+.01958809645;ea=za*W+-12.0257785;la=za*ea;_=za*za;$=_*(za*(ta*(2786.18102/ya+(za*(za*(za*(Y+(Y+5.0671326075e-9))+X)+W)+ea))+(T+la+-23313.1436))-(za*(Z+la+-23313.1436)+176685.0998))*518.2791167938085/+zr(c[(b+536|0)>>2]|0,_*_,3104,3184,+h[Aa>>3],(a[xa]|0)!=0|0)}}while(0);xa=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;Aa=c[c[(b+4|0)>>2]>>2]|0;za=+h[(c[Aa+8>>2]|0)+48>>3];do{if(xa){if(za>0.0){Ba=za;Ca=Aa}else{ua=c[20226]|0;pa=c[b+536>>2]|0;h[k>>3]=za;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];F=e+408|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[ua&31](pa,e+408|0,3016,z);pa=c[c[(b+4|0)>>2]>>2]|0;Ba=+h[(c[pa+8>>2]|0)+48>>3];Ca=pa}if(Ba>0.0){Da=Ba;Ea=Ca}else{pa=c[20226]|0;ua=c[b+536>>2]|0;h[k>>3]=Ba;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];F=e+384|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[pa&31](ua,e+384|0,3016,y);ua=c[c[(b+4|0)>>2]>>2]|0;Da=+h[(c[ua+8>>2]|0)+48>>3];Ea=ua}ya=Da*Da;ua=Da!=0.0;if(ya*ya!=0.0){if(ua){Fa=Da;Ga=Da}else{ya=+zr(c[b+536>>2]|0,Da,3088,3184,+h[Ea>>3],(a[b+319|0]|0)!=0|0);Fa=ya;Ga=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}ya=Ga*6.130937398000001e-16;ta=Ga*(ya+-1.829795625e-11)+2.412801953333333e-7;wa=Ga*ta+-.001918351705;va=Ga*wa+33.2255293;sa=Ga*va;oa=Ga*Ga;Ha=oa*(Ga*(Da*(-20330.22397/Fa+(Ga*(Ga*(Ga*(ya+(ya+-1.829795625e-11))+ta)+wa)+va))+(+da(+za)*-20330.22397+sa+111596.395))-(Ga*(+da(+Ba)*-20330.22397+sa+111596.395)+-5025782.13))*276.5127187299628/(oa*oa);break}if(ua){Ia=Da;Ja=Da;Ka=Ea}else{oa=+zr(c[b+536>>2]|0,Da,3088,3184,+h[Ea>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;Ia=oa;Ja=+h[(c[ua+8>>2]|0)+48>>3];Ka=ua}oa=Ja*6.130937398000001e-16;sa=Ja*(oa+-1.829795625e-11)+2.412801953333333e-7;va=Ja*sa+-.001918351705;wa=Ja*va+33.2255293;ta=+da(+za)*-20330.22397;ya=Ja*wa;ma=+da(+Ba)*-20330.22397;ua=Ja!=0.0;if(Ja*Ja*(Ja*(Da*(-20330.22397/Ia+(Ja*(Ja*(Ja*(oa+(oa+-1.829795625e-11))+sa)+va)+wa))+(ta+ya+111596.395))-(Ja*(ma+ya+111596.395)+-5025782.13))*276.5127187299628==0.0){if(ua){La=Ja;Ma=Ja}else{ya=+zr(c[b+536>>2]|0,Ja,3088,3184,+h[Ka>>3],(a[b+319|0]|0)!=0|0);La=ya;Ma=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}ya=Ma*6.130937398000001e-16;wa=Ma*(ya+-1.829795625e-11)+2.412801953333333e-7;va=Ma*wa+-.001918351705;sa=Ma*va+33.2255293;oa=Ma*sa;Ha=Ma*Ma*(Ma*(Ja*(-20330.22397/La+(Ma*(Ma*(Ma*(ya+(ya+-1.829795625e-11))+wa)+va)+sa))+(ta+oa+111596.395))-(Ma*(ma+oa+111596.395)+-5025782.13))*276.5127187299628;break}if(ua){Na=b+319|0;Oa=Ja;Pa=Ja;Qa=Ka}else{oa=+zr(c[(b+536|0)>>2]|0,Ja,3088,3184,+h[Ka>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;Na=b+319|0;Oa=oa;Pa=+h[(c[ua+8>>2]|0)+48>>3];Qa=ua}oa=Pa*6.130937398000001e-16;sa=Pa*(oa+-1.829795625e-11)+2.412801953333333e-7;va=Pa*sa+-.001918351705;wa=Pa*va+33.2255293;ya=Pa*wa;L=Pa*Pa;Ha=L*(Pa*(Ja*(-20330.22397/Oa+(Pa*(Pa*(Pa*(oa+(oa+-1.829795625e-11))+sa)+va)+wa))+(ta+ya+111596.395))-(Pa*(ma+ya+111596.395)+-5025782.13))*276.5127187299628/+zr(c[(b+536|0)>>2]|0,L*L,3104,3184,+h[Qa>>3],(a[Na]|0)!=0|0)}else{if(za>0.0){Ra=za;Sa=Aa}else{ua=c[20226]|0;pa=c[b+536>>2]|0;h[k>>3]=za;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];F=e+456|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[ua&31](pa,e+456|0,3016,C);pa=c[c[(b+4|0)>>2]>>2]|0;Ra=+h[(c[pa+8>>2]|0)+48>>3];Sa=pa}if(Ra>0.0){Ta=Ra;Ua=Sa}else{pa=c[20226]|0;ua=c[b+536>>2]|0;h[k>>3]=Ra;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];F=e+432|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[pa&31](ua,e+432|0,3016,B);ua=c[c[(b+4|0)>>2]>>2]|0;Ta=+h[(c[ua+8>>2]|0)+48>>3];Ua=ua}L=Ta*Ta;ua=Ta!=0.0;if(L*L!=0.0){if(ua){Va=Ta;Wa=Ta}else{L=+zr(c[b+536>>2]|0,Ta,3088,3184,+h[Ua>>3],(a[b+319|0]|0)!=0|0);Va=L;Wa=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=Wa*-2.638563984e-12;ya=Wa*(L+1.26528395e-8)+-2734724406666666.0e-20;ma=Wa*ya+.03782917795;ta=Wa*ma+-19.51705092;wa=Wa*ta;va=Wa*Wa;Ha=va*(Wa*(Ta*(3406.19186/Va+(Wa*(Wa*(Wa*(L+(L+1.26528395e-8))+ya)+ma)+ta))+(+da(+za)*3406.19186+wa+-27029.3289))-(Wa*(+da(+Ra)*3406.19186+wa+-27029.3289)+186204.4161))*276.5127187299628/(va*va);break}if(ua){Xa=Ta;Ya=Ta;Za=Ua}else{va=+zr(c[b+536>>2]|0,Ta,3088,3184,+h[Ua>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;Xa=va;Ya=+h[(c[ua+8>>2]|0)+48>>3];Za=ua}va=Ya*-2.638563984e-12;wa=Ya*(va+1.26528395e-8)+-2734724406666666.0e-20;ta=Ya*wa+.03782917795;ma=Ya*ta+-19.51705092;ya=+da(+za)*3406.19186;L=Ya*ma;sa=+da(+Ra)*3406.19186;ua=Ya!=0.0;if(Ya*Ya*(Ya*(Ta*(3406.19186/Xa+(Ya*(Ya*(Ya*(va+(va+1.26528395e-8))+wa)+ta)+ma))+(ya+L+-27029.3289))-(Ya*(sa+L+-27029.3289)+186204.4161))*276.5127187299628==0.0){if(ua){_a=Ya;$a=Ya}else{L=+zr(c[b+536>>2]|0,Ya,3088,3184,+h[Za>>3],(a[b+319|0]|0)!=0|0);_a=L;$a=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=$a*-2.638563984e-12;ma=$a*(L+1.26528395e-8)+-2734724406666666.0e-20;ta=$a*ma+.03782917795;wa=$a*ta+-19.51705092;va=$a*wa;Ha=$a*$a*($a*(Ya*(3406.19186/_a+($a*($a*($a*(L+(L+1.26528395e-8))+ma)+ta)+wa))+(ya+va+-27029.3289))-($a*(sa+va+-27029.3289)+186204.4161))*276.5127187299628;break}if(ua){ab=b+319|0;bb=Ya;cb=Ya;db=Za}else{va=+zr(c[(b+536|0)>>2]|0,Ya,3088,3184,+h[Za>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;ab=b+319|0;bb=va;cb=+h[(c[ua+8>>2]|0)+48>>3];db=ua}va=cb*-2.638563984e-12;wa=cb*(va+1.26528395e-8)+-2734724406666666.0e-20;ta=cb*wa+.03782917795;ma=cb*ta+-19.51705092;L=cb*ma;oa=cb*cb;Ha=oa*(cb*(Ya*(3406.19186/bb+(cb*(cb*(cb*(va+(va+1.26528395e-8))+wa)+ta)+ma))+(ya+L+-27029.3289))-(cb*(sa+L+-27029.3289)+186204.4161))*276.5127187299628/+zr(c[(b+536|0)>>2]|0,oa*oa,3104,3184,+h[db>>3],(a[ab]|0)!=0|0)}}while(0);ab=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;db=c[c[(b+4|0)>>2]>>2]|0;cb=+h[(c[db+8>>2]|0)+48>>3];do{if(ab){if(cb>0.0){eb=cb;fb=db}else{Za=c[20226]|0;Ua=c[b+536>>2]|0;h[k>>3]=cb;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];B=e+312|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Za&31](Ua,e+312|0,3016,v);Ua=c[c[(b+4|0)>>2]>>2]|0;eb=+h[(c[Ua+8>>2]|0)+48>>3];fb=Ua}if(eb>0.0){gb=eb;hb=fb}else{Ua=c[20226]|0;Za=c[b+536>>2]|0;h[k>>3]=eb;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];B=e+288|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Ua&31](Za,e+288|0,3016,u);Za=c[c[(b+4|0)>>2]>>2]|0;gb=+h[(c[Za+8>>2]|0)+48>>3];hb=Za}bb=gb*gb;Za=gb!=0.0;if(bb*bb!=0.0){if(Za){ib=gb;jb=gb}else{bb=+zr(c[b+536>>2]|0,gb,3088,3184,+h[hb>>3],(a[b+319|0]|0)!=0|0);ib=bb;jb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}bb=jb*8.01934576e-16;Ya=jb*(bb+-2.3938513075e-11)+3.157072313333333e-7;$a=jb*Ya+-.00251033196;_a=jb*$a+45.3435684;Xa=jb*_a;Ta=jb*jb;kb=Ta*(jb*(gb*(-26597.91134/ib+(jb*(jb*(jb*(bb+(bb+-2.3938513075e-11))+Ya)+$a)+_a))+(+da(+cb)*-26597.91134+Xa+145558.2459))-(jb*(+da(+eb)*-26597.91134+Xa+145558.2459)+-6420731.680000001))*188.5555073270316/(Ta*Ta);break}if(Za){lb=gb;mb=gb;nb=hb}else{Ta=+zr(c[b+536>>2]|0,gb,3088,3184,+h[hb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;lb=Ta;mb=+h[(c[Za+8>>2]|0)+48>>3];nb=Za}Ta=mb*8.01934576e-16;Xa=mb*(Ta+-2.3938513075e-11)+3.157072313333333e-7;_a=mb*Xa+-.00251033196;$a=mb*_a+45.3435684;Ya=+da(+cb)*-26597.91134;bb=mb*$a;Ra=+da(+eb)*-26597.91134;Za=mb!=0.0;if(mb*mb*(mb*(gb*(-26597.91134/lb+(mb*(mb*(mb*(Ta+(Ta+-2.3938513075e-11))+Xa)+_a)+$a))+(Ya+bb+145558.2459))-(mb*(Ra+bb+145558.2459)+-6420731.680000001))*188.5555073270316==0.0){if(Za){ob=mb;pb=mb}else{bb=+zr(c[b+536>>2]|0,mb,3088,3184,+h[nb>>3],(a[b+319|0]|0)!=0|0);ob=bb;pb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}bb=pb*8.01934576e-16;$a=pb*(bb+-2.3938513075e-11)+3.157072313333333e-7;_a=pb*$a+-.00251033196;Xa=pb*_a+45.3435684;Ta=pb*Xa;kb=pb*pb*(pb*(mb*(-26597.91134/ob+(pb*(pb*(pb*(bb+(bb+-2.3938513075e-11))+$a)+_a)+Xa))+(Ya+Ta+145558.2459))-(pb*(Ra+Ta+145558.2459)+-6420731.680000001))*188.5555073270316;break}if(Za){qb=b+319|0;rb=mb;sb=mb;tb=nb}else{Ta=+zr(c[(b+536|0)>>2]|0,mb,3088,3184,+h[nb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;qb=b+319|0;rb=Ta;sb=+h[(c[Za+8>>2]|0)+48>>3];tb=Za}Ta=sb*8.01934576e-16;Xa=sb*(Ta+-2.3938513075e-11)+3.157072313333333e-7;_a=sb*Xa+-.00251033196;$a=sb*_a+45.3435684;bb=sb*$a;za=sb*sb;kb=za*(sb*(mb*(-26597.91134/rb+(sb*(sb*(sb*(Ta+(Ta+-2.3938513075e-11))+Xa)+_a)+$a))+(Ya+bb+145558.2459))-(sb*(Ra+bb+145558.2459)+-6420731.680000001))*188.5555073270316/+zr(c[(b+536|0)>>2]|0,za*za,3104,3184,+h[tb>>3],(a[qb]|0)!=0|0)}else{if(cb>0.0){ub=cb;vb=db}else{Za=c[20226]|0;Ua=c[b+536>>2]|0;h[k>>3]=cb;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];B=e+360|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Za&31](Ua,e+360|0,3016,x);Ua=c[c[(b+4|0)>>2]>>2]|0;ub=+h[(c[Ua+8>>2]|0)+48>>3];vb=Ua}if(ub>0.0){wb=ub;xb=vb}else{Ua=c[20226]|0;Za=c[b+536>>2]|0;h[k>>3]=ub;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];B=e+336|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Ua&31](Za,e+336|0,3016,w);Za=c[c[(b+4|0)>>2]>>2]|0;wb=+h[(c[Za+8>>2]|0)+48>>3];xb=Za}za=wb*wb;Za=wb!=0.0;if(za*za!=0.0){if(Za){yb=wb;zb=wb}else{za=+zr(c[b+536>>2]|0,wb,3088,3184,+h[xb>>3],(a[b+319|0]|0)!=0|0);yb=za;zb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}za=zb*-4.685975988e-12;bb=zb*(za+2.2037059775e-8)+-458769423.0e-13;Ra=zb*bb+.05944763725;Ya=zb*Ra+-29.39466091;$a=zb*Ya;_a=zb*zb;kb=_a*(zb*(wb*(4656.27081/yb+(zb*(zb*(zb*(za+(za+2.2037059775e-8))+bb)+Ra)+Ya))+(+da(+cb)*4656.27081+$a+-35403.3527))-(zb*(+da(+ub)*4656.27081+$a+-35403.3527)+243314.4337))*188.5555073270316/(_a*_a);break}if(Za){Ab=wb;Bb=wb;Cb=xb}else{_a=+zr(c[b+536>>2]|0,wb,3088,3184,+h[xb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;Ab=_a;Bb=+h[(c[Za+8>>2]|0)+48>>3];Cb=Za}_a=Bb*-4.685975988e-12;$a=Bb*(_a+2.2037059775e-8)+-458769423.0e-13;Ya=Bb*$a+.05944763725;Ra=Bb*Ya+-29.39466091;bb=+da(+cb)*4656.27081;za=Bb*Ra;Xa=+da(+ub)*4656.27081;Za=Bb!=0.0;if(Bb*Bb*(Bb*(wb*(4656.27081/Ab+(Bb*(Bb*(Bb*(_a+(_a+2.2037059775e-8))+$a)+Ya)+Ra))+(bb+za+-35403.3527))-(Bb*(Xa+za+-35403.3527)+243314.4337))*188.5555073270316==0.0){if(Za){Db=Bb;Eb=Bb}else{za=+zr(c[b+536>>2]|0,Bb,3088,3184,+h[Cb>>3],(a[b+319|0]|0)!=0|0);Db=za;Eb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}za=Eb*-4.685975988e-12;Ra=Eb*(za+2.2037059775e-8)+-458769423.0e-13;Ya=Eb*Ra+.05944763725;$a=Eb*Ya+-29.39466091;_a=Eb*$a;kb=Eb*Eb*(Eb*(Bb*(4656.27081/Db+(Eb*(Eb*(Eb*(za+(za+2.2037059775e-8))+Ra)+Ya)+$a))+(bb+_a+-35403.3527))-(Eb*(Xa+_a+-35403.3527)+243314.4337))*188.5555073270316;break}if(Za){Fb=b+319|0;Gb=Bb;Hb=Bb;Ib=Cb}else{_a=+zr(c[(b+536|0)>>2]|0,Bb,3088,3184,+h[Cb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;Fb=b+319|0;Gb=_a;Hb=+h[(c[Za+8>>2]|0)+48>>3];Ib=Za}_a=Hb*-4.685975988e-12;$a=Hb*(_a+2.2037059775e-8)+-458769423.0e-13;Ya=Hb*$a+.05944763725;Ra=Hb*Ya+-29.39466091;za=Hb*Ra;Ta=Hb*Hb;kb=Ta*(Hb*(Bb*(4656.27081/Gb+(Hb*(Hb*(Hb*(_a+(_a+2.2037059775e-8))+$a)+Ya)+Ra))+(bb+za+-35403.3527))-(Hb*(Xa+za+-35403.3527)+243314.4337))*188.5555073270316/+zr(c[(b+536|0)>>2]|0,Ta*Ta,3104,3184,+h[Ib>>3],(a[Fb]|0)!=0|0)}}while(0);Fb=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;Ib=c[c[(b+4|0)>>2]>>2]|0;Hb=+h[(c[Ib+8>>2]|0)+48>>3];c[e+592>>2]=b;c[e+600>>2]=d;c[e+2112>>2]=Fb;c[e+2120>>2]=Ib;g[e+2128>>2]=Hb;g[e+6448>>2]=$;g[e+6456>>2]=Ha;g[e+6464>>2]=kb;c[e+6576>>2]=t;c[e+6584>>2]=s;c[e+6600>>2]=r;c[e+6608>>2]=q;c[e+6616>>2]=p;c[e+6624>>2]=o;c[e+6632>>2]=n;c[e+6640>>2]=m;c[e+6648>>2]=l;c[e+6656>>2]=j;c[e+6664>>2]=f;c[e+6696>>2]=0;c[e+6700>>2]=0;_setLinearMatrixA171$0(e);H=c[e+6696>>2]|0;A=c[e+6700>>2]|0;I=+g[e+6700>>2];c[e+6696>>2]=0;c[e+6700>>2]=0;if((H|0)==5){return}}function Yg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0.0,_a=0.0,$a=0.0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0;e=i;i=i+296|0;f=e;g=e+24|0;j=e+48|0;l=e+72|0;m=e+96|0;n=e+120|0;o=e+144|0;p=e+168|0;q=e+192|0;r=e+216|0;s=e+240|0;t=e+264|0;u=e+288|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=b+4|0;H=c[(c[c[G>>2]>>2]|0)+8>>2]|0;I=H+48|0;J=d+36|0;h[c[J>>2]>>3]=-(+h[H+528>>3]*+h[I>>3])- +h[H+512>>3];H=(yu(+h[I>>3],1.0e3)|0)<<24>>24==0;I=c[c[G>>2]>>2]|0;K=+h[(c[I+8>>2]|0)+48>>3];d=K>0.0;do{if(H){if(d){L=K;M=I}else{N=c[20226]|0;O=c[b+536>>2]|0;P=E;h[k>>3]=K;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=N;N=s;Q=3200;c[N+0>>2]=c[Q+0>>2];c[N+4>>2]=c[Q+4>>2];c[N+8>>2]=c[Q+8>>2];c[N+12>>2]=c[Q+12>>2];c[N+16>>2]=c[Q+16>>2];c[N+20>>2]=c[Q+20>>2];He[P&31](O,s,3016,E);O=c[c[G>>2]>>2]|0;L=+h[(c[O+8>>2]|0)+48>>3];M=O}R=L*(+da(+K)*-13835.01485+L*(L*(L*(L*(L*3.247474414e-16+-9.322036725e-12)+1.575771013333333e-7)+-.0009809873795)+20.49107091)+75320.6691)+-3730042.76;if(L!=0.0){S=R/L;break}if(R==0.0){S=R;break}S=R/+zr(c[b+536>>2]|0,L,3088,3192,+h[M>>3],(a[b+319|0]|0)!=0|0)}else{if(d){T=K;U=I}else{O=c[20226]|0;P=c[b+536>>2]|0;Q=F;h[k>>3]=K;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Q=O;O=t;N=3200;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];c[O+12>>2]=c[N+12>>2];c[O+16>>2]=c[N+16>>2];c[O+20>>2]=c[N+20>>2];He[Q&31](P,t,3016,F);P=c[c[G>>2]>>2]|0;T=+h[(c[P+8>>2]|0)+48>>3];U=P}R=T*(+da(+K)*2786.18102+T*(T*(T*(T*(T*-9.953410979999998e-13+5.0671326075e-9)+-1206351476666667.0e-20)+.01958809645)+-12.0257785)+-23313.1436)+176685.0998;if(T!=0.0){S=R/T;break}if(R==0.0){S=R;break}S=R/+zr(c[b+536>>2]|0,T,3088,3192,+h[U>>3],(a[b+319|0]|0)!=0|0)}}while(0);T=S*518.2791167938085;U=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;F=c[c[G>>2]>>2]|0;S=+h[(c[F+8>>2]|0)+48>>3];t=S>0.0;do{if(U){if(t){V=S;W=F}else{I=c[20226]|0;d=c[b+536>>2]|0;M=C;h[k>>3]=S;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=I;I=q;E=3200;c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2];c[I+16>>2]=c[E+16>>2];c[I+20>>2]=c[E+20>>2];He[M&31](d,q,3016,C);d=c[c[G>>2]>>2]|0;V=+h[(c[d+8>>2]|0)+48>>3];W=d}K=V*(+da(+S)*-20330.22397+V*(V*(V*(V*(V*6.130937398000001e-16+-1.829795625e-11)+2.412801953333333e-7)+-.001918351705)+33.2255293)+111596.395)+-5025782.13;if(V!=0.0){X=K/V;break}if(K==0.0){X=K;break}X=K/+zr(c[b+536>>2]|0,V,3088,3192,+h[W>>3],(a[b+319|0]|0)!=0|0)}else{if(t){Y=S;Z=F}else{d=c[20226]|0;M=c[b+536>>2]|0;E=D;h[k>>3]=S;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=d;d=r;I=3200;c[d+0>>2]=c[I+0>>2];c[d+4>>2]=c[I+4>>2];c[d+8>>2]=c[I+8>>2];c[d+12>>2]=c[I+12>>2];c[d+16>>2]=c[I+16>>2];c[d+20>>2]=c[I+20>>2];He[E&31](M,r,3016,D);M=c[c[G>>2]>>2]|0;Y=+h[(c[M+8>>2]|0)+48>>3];Z=M}K=Y*(+da(+S)*3406.19186+Y*(Y*(Y*(Y*(Y*-2.638563984e-12+1.26528395e-8)+-2734724406666666.0e-20)+.03782917795)+-19.51705092)+-27029.3289)+186204.4161;if(Y!=0.0){X=K/Y;break}if(K==0.0){X=K;break}X=K/+zr(c[b+536>>2]|0,Y,3088,3192,+h[Z>>3],(a[b+319|0]|0)!=0|0)}}while(0);Y=X*276.5127187299628;Z=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;D=c[c[G>>2]>>2]|0;X=+h[(c[D+8>>2]|0)+48>>3];r=X>0.0;do{if(Z){if(r){_=X;$=D}else{F=c[20226]|0;t=c[b+536>>2]|0;W=A;h[k>>3]=X;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];W=F;F=o;C=3200;c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[F+16>>2]=c[C+16>>2];c[F+20>>2]=c[C+20>>2];He[W&31](t,o,3016,A);t=c[c[G>>2]>>2]|0;_=+h[(c[t+8>>2]|0)+48>>3];$=t}S=_*(+da(+X)*-26597.91134+_*(_*(_*(_*(_*8.01934576e-16+-2.3938513075e-11)+3.157072313333333e-7)+-.00251033196)+45.3435684)+145558.2459)+-6420731.680000001;if(_!=0.0){aa=S/_;break}if(S==0.0){aa=S;break}aa=S/+zr(c[b+536>>2]|0,_,3088,3192,+h[$>>3],(a[b+319|0]|0)!=0|0)}else{if(r){ba=X;ca=D}else{t=c[20226]|0;W=c[b+536>>2]|0;C=B;h[k>>3]=X;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=t;t=p;F=3200;c[t+0>>2]=c[F+0>>2];c[t+4>>2]=c[F+4>>2];c[t+8>>2]=c[F+8>>2];c[t+12>>2]=c[F+12>>2];c[t+16>>2]=c[F+16>>2];c[t+20>>2]=c[F+20>>2];He[C&31](W,p,3016,B);W=c[c[G>>2]>>2]|0;ba=+h[(c[W+8>>2]|0)+48>>3];ca=W}S=ba*(+da(+X)*4656.27081+ba*(ba*(ba*(ba*(ba*-4.685975988e-12+2.2037059775e-8)+-458769423.0e-13)+.05944763725)+-29.39466091)+-35403.3527)+243314.4337;if(ba!=0.0){aa=S/ba;break}if(S==0.0){aa=S;break}aa=S/+zr(c[b+536>>2]|0,ba,3088,3192,+h[ca>>3],(a[b+319|0]|0)!=0|0)}}while(0);ba=aa*188.5555073270316;ca=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;B=c[c[G>>2]>>2]|0;aa=+h[(c[B+8>>2]|0)+48>>3];p=aa>0.0;do{if(ca){if(p){ea=aa;fa=B}else{D=c[20226]|0;r=c[b+536>>2]|0;$=y;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=D;D=m;A=3200;c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];c[D+16>>2]=c[A+16>>2];c[D+20>>2]=c[A+20>>2];He[$&31](r,m,3016,y);r=c[c[G>>2]>>2]|0;ea=+h[(c[r+8>>2]|0)+48>>3];fa=r}X=ea*(+da(+aa)*-32560.5151+ea*(ea*(ea*(ea*(ea*1.05012705e-15+-3.054734245e-11)+3.933953493333333e-7)+-.003098958405)+57.3673275)+177452.656)+-7682322.45;if(ea!=0.0){ga=X/ea;break}if(X==0.0){ga=X;break}ga=X/+zr(c[b+536>>2]|0,ea,3088,3192,+h[fa>>3],(a[b+319|0]|0)!=0|0)}else{if(p){ha=aa;ia=B}else{r=c[20226]|0;$=c[b+536>>2]|0;A=z;h[k>>3]=aa;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r;r=n;D=3200;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[r+12>>2]=c[D+12>>2];c[r+16>>2]=c[D+16>>2];c[r+20>>2]=c[D+20>>2];He[A&31]($,n,3016,z);$=c[c[G>>2]>>2]|0;ha=+h[(c[$+8>>2]|0)+48>>3];ia=$}X=ha*(+da(+aa)*6176.331819999999+ha*(ha*(ha*(ha*(ha*-6.4033411e-12+2.9991908725e-8)+-6200167196666667.0e-20)+.0792327142)+-38.9156212)+-45403.63390000001)+317587.254;if(ha!=0.0){ga=X/ha;break}if(X==0.0){ga=X;break}ga=X/+zr(c[b+536>>2]|0,ha,3088,3192,+h[ia>>3],(a[b+319|0]|0)!=0|0)}}while(0);ha=ga*143.0515706563069;ia=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;z=c[c[G>>2]>>2]|0;ga=+h[(c[z+8>>2]|0)+48>>3];n=ga>0.0;do{if(ia){if(n){ja=ga;ka=z}else{B=c[20226]|0;p=c[b+536>>2]|0;fa=w;h[k>>3]=ga;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=B;B=j;y=3200;c[B+0>>2]=c[y+0>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];c[B+12>>2]=c[y+12>>2];c[B+16>>2]=c[y+16>>2];c[B+20>>2]=c[y+20>>2];He[fa&31](p,j,3016,w);p=c[c[G>>2]>>2]|0;ja=+h[(c[p+8>>2]|0)+48>>3];ka=p}aa=ja*(+da(+ga)*-2239.249073+ja*(ja*(ja*(ja*(ja*2.123908772e-16+-4.8077637125e-12)+4.97268893e-8)+-.000306984275)+6.06694922)+12832.10415)+-587712.406;if(ja!=0.0){la=aa/ja;break}if(aa==0.0){la=aa;break}la=aa/+zr(c[b+536>>2]|0,ja,3088,3192,+h[ka>>3],(a[b+319|0]|0)!=0|0)}else{if(n){ma=ga;na=z}else{p=c[20226]|0;fa=c[b+536>>2]|0;y=x;h[k>>3]=ga;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=p;p=l;B=3200;c[p+0>>2]=c[B+0>>2];c[p+4>>2]=c[B+4>>2];c[p+8>>2]=c[B+8>>2];c[p+12>>2]=c[B+12>>2];c[p+16>>2]=c[B+16>>2];c[p+20>>2]=c[B+20>>2];He[y&31](fa,l,3016,x);fa=c[c[G>>2]>>2]|0;ma=+h[(c[fa+8>>2]|0)+48>>3];na=fa}aa=ma*(+da(+ga)*-381.846182+ma*(ma*(ma*(ma*(ma*5.039411618000001e-13+-2.406448405e-9)+4615487296666666.0e-21)+-.004265457205)+6.08273836)+710.846086)+-22103.71497;if(ma!=0.0){la=aa/ma;break}if(aa==0.0){la=aa;break}la=aa/+zr(c[b+536>>2]|0,ma,3088,3192,+h[na>>3],(a[b+319|0]|0)!=0|0)}}while(0);ma=la*296.8033869505308;na=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;x=c[c[G>>2]>>2]|0;la=+h[(c[x+8>>2]|0)+48>>3];l=la>0.0;if(na){if(l){oa=la;pa=x}else{na=c[20226]|0;z=c[b+536>>2]|0;n=u;h[k>>3]=la;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=na;na=f;ka=3200;c[na+0>>2]=c[ka+0>>2];c[na+4>>2]=c[ka+4>>2];c[na+8>>2]=c[ka+8>>2];c[na+12>>2]=c[ka+12>>2];c[na+16>>2]=c[ka+16>>2];c[na+20>>2]=c[ka+20>>2];He[n&31](z,f,3016,u);u=c[c[G>>2]>>2]|0;oa=+h[(c[u+8>>2]|0)+48>>3];pa=u}ga=oa*(+da(+la)*-1788.791477+oa*(oa*(oa*(oa*(oa*1.266007318e-16+-4.72763328e-13)+1.621225626666666e-9)+-461157839.0e-13)+8.29152319)+-39083.5059)+-117696.2419;if(oa!=0.0){qa=ga/oa;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}if(ga==0.0){qa=ga;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}qa=ga/+zr(c[b+536>>2]|0,oa,3088,3192,+h[pa>>3],(a[b+319|0]|0)!=0|0);ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}else{if(l){pb=la;qb=x}else{x=c[20226]|0;l=c[b+536>>2]|0;pa=v;h[k>>3]=la;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];pa=x;x=g;u=3200;c[x+0>>2]=c[u+0>>2];c[x+4>>2]=c[u+4>>2];c[x+8>>2]=c[u+8>>2];c[x+12>>2]=c[u+12>>2];c[x+16>>2]=c[u+16>>2];c[x+20>>2]=c[u+20>>2];He[pa&31](l,g,3016,v);v=c[c[G>>2]>>2]|0;pb=+h[(c[v+8>>2]|0)+48>>3];qb=v}oa=pb*(+da(+la)*-626.411601+pb*(pb*(pb*(pb*(pb*5.699355602e-14+-1.922497195e-10)+-7.091029093333333e-8)+.001251906908)+5.30172524)+-45281.9846)+-49436.5054;if(pb!=0.0){qa=oa/pb;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}if(oa==0.0){qa=oa;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}qa=oa/+zr(c[b+536>>2]|0,pb,3088,3192,+h[qb>>3],(a[b+319|0]|0)!=0|0);ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}}function Zg(a){a=a|0;c[a+20>>2]=94;c[a+16>>2]=2;c[a+12>>2]=4;c[a>>2]=44;c[a+4>>2]=45;c[a+84>>2]=171;c[a+80>>2]=2;c[a+76>>2]=4;c[a+64>>2]=46;c[a+68>>2]=47;i=i;return}function _g(a,b){a=a|0;b=b|0;i=i;return}function $g(a){a=a|0;i=i;return}function ah(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 3224}function bh(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function ch(a){a=a|0;i=i;return 3224}function dh(a,b){a=a|0;b=b|0;i=i;return 0}function eh(a){a=a|0;a=i;i=i+8|0;tr(8,1,3232,a);if((c[31896>>2]|0)==0){i=a;return 0}ee[c[8104]&255](8);i=a;return 0}function fh(a){a=a|0;i=i;return c[3584+(a<<2)>>2]|0}function gh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+8|0;tr(21,1,3616,p);p=a+4|0;q=a+416|0;r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+56>>3]- +h[(c[q>>2]|0)+224>>3];h[b>>3]=r;a=fh(0)|0;c[o>>2]=1;c[o+4>>2]=a;a=o+8|0;h[k>>3]=r;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];tr(21,0,3648,o);r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+48>>3]- +h[(c[q>>2]|0)+240>>3];h[b+8>>3]=r;o=fh(1)|0;c[n>>2]=2;c[n+4>>2]=o;o=n+8|0;h[k>>3]=r;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];tr(21,0,3648,n);r=+h[c[(c[c[p>>2]>>2]|0)+8>>2]>>3]- +h[(c[q>>2]|0)+48>>3];h[b+16>>3]=r;n=fh(2)|0;c[m>>2]=3;c[m+4>>2]=n;n=m+8|0;h[k>>3]=r;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(21,0,3648,m);r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+8>>3]- +h[(c[q>>2]|0)+56>>3];h[b+24>>3]=r;m=fh(3)|0;c[l>>2]=4;c[l+4>>2]=m;m=l+8|0;h[k>>3]=r;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];tr(21,0,3648,l);r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[(c[q>>2]|0)+64>>3];h[b+32>>3]=r;l=fh(4)|0;c[j>>2]=5;c[j+4>>2]=l;l=j+8|0;h[k>>3]=r;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];tr(21,0,3648,j);r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+24>>3]- +h[(c[q>>2]|0)+72>>3];h[b+40>>3]=r;j=fh(5)|0;c[g>>2]=6;c[g+4>>2]=j;j=g+8|0;h[k>>3]=r;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];tr(21,0,3648,g);r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+32>>3]- +h[(c[q>>2]|0)+80>>3];h[b+48>>3]=r;g=fh(6)|0;c[f>>2]=7;c[f+4>>2]=g;g=f+8|0;h[k>>3]=r;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];tr(21,0,3648,f);r=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[(c[q>>2]|0)+88>>3];h[b+56>>3]=r;b=fh(7)|0;c[e>>2]=8;c[e+4>>2]=b;b=e+8|0;h[k>>3]=r;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];tr(21,0,3648,e);if((c[31948>>2]|0)==0){i=d;return 0}ee[c[8104]&255](21);i=d;return 0}function hh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+40>>3];i=i;return}function ih(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+32>>3];i=i;return}function jh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+24>>3];i=i;return}function kh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+16>>3];i=i;return}function lh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+8>>3];i=i;return}function mh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b>>3];i=i;return}function nh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+200>>3];i=i;return}function oh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+192>>3];i=i;return}function ph(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+40>>3]*.5;i=i;return}function qh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+32>>3]*.5;i=i;return}function rh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+24>>3]*.5;i=i;return}function sh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+16>>3]*.5;i=i;return}function th(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+8>>3]*.5;i=i;return}function uh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b>>3]*.5;i=i;return}function vh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+200>>3]*1.2;i=i;return}function wh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+40>>3];i=i;return}function xh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+32>>3];i=i;return}function yh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+24>>3];i=i;return}function zh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+16>>3];i=i;return}function Ah(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+8>>3];i=i;return}function Bh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b>>3];i=i;return}function Ch(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+200>>3];i=i;return}function Dh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+192>>3];i=i;return}function Eh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=+h[(c[a+416>>2]|0)+264>>3]+-273.15;i=i;return}function Fh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[(c[a+416>>2]|0)+280>>3]*1.0e-5;i=i;return}function Gh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[(c[a+416>>2]|0)+296>>3]+-273.15;i=i;return}function Hh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[b+416>>2]|0;f=+h[e+96>>3]/.01604246+(+h[e+104>>3]/.01604246+(+h[e+112>>3]/.01604246+(+h[e+120>>3]/.01604246+(+h[e+128>>3]/.01604246+ +h[e+136>>3]/.01604246))));if(f!=0.0){g=b+4|0;j=f;k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+608|0;t=s;h[t>>3]=k;i=d;return}else{e=b+4|0;g=e;j=+zr(c[b+536>>2]|0,f,3672,3664,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+608|0;t=s;h[t>>3]=k;i=d;return}}function Ih(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0;b=i;i=i+56|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+96>>3];n=+h[l+112>>3];o=+h[l+120>>3];p=+h[l+128>>3];q=+h[l+136>>3];r=e;h[k>>3]=+h[l+104>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+8|0;h[k>>3]=n;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+16|0;h[k>>3]=o;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+24|0;h[k>>3]=p;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+32|0;h[k>>3]=q;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ns(f,6,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+264>>3];j=d;r=f;c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];Og(g,e,m,d,1,1,0.0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[g>>3];i=b;return}function Jh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+592>>3]=(+h[b+96>>3]+(+h[b+104>>3]+(+h[b+112>>3]+(+h[b+120>>3]+(+h[b+128>>3]+ +h[b+136>>3])))))*518.2791167938085;i=i;return}function Kh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[b+416>>2]|0;f=+h[e+144>>3]/.01604246+(+h[e+152>>3]/.01604246+(+h[e+160>>3]/.01604246+(+h[e+168>>3]/.01604246+(+h[e+176>>3]/.01604246+ +h[e+184>>3]/.01604246))));if(f!=0.0){g=b+4|0;j=f;k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+584|0;t=s;h[t>>3]=k;i=d;return}else{e=b+4|0;g=e;j=+zr(c[b+536>>2]|0,f,3960,3952,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+584|0;t=s;h[t>>3]=k;i=d;return}}function Lh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0;b=i;i=i+56|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+144>>3];n=+h[l+160>>3];o=+h[l+168>>3];p=+h[l+176>>3];q=+h[l+184>>3];r=e;h[k>>3]=+h[l+152>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+8|0;h[k>>3]=n;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+16|0;h[k>>3]=o;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+24|0;h[k>>3]=p;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+32|0;h[k>>3]=q;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ns(f,6,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+296>>3];j=d;r=f;c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];Mg(g,e,m,d,1,1,0.0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+576>>3]=+h[g>>3];i=b;return}function Mh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+568>>3]=(+h[b+144>>3]+(+h[b+152>>3]+(+h[b+160>>3]+(+h[b+168>>3]+(+h[b+176>>3]+ +h[b+184>>3])))))*518.2791167938085;i=i;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=+h[b+600>>3]- +h[b+592>>3]*+h[(c[a+416>>2]|0)+264>>3];i=i;return}function Oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+576>>3]- +h[b+568>>3]*+h[(c[a+416>>2]|0)+296>>3];i=i;return}function Ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=+h[g+568>>3]*+h[j+296>>3];l=+h[j+280>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+544|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+544|0;q=p;h[q>>3]=n;i=d;return}r=l/+zr(c[b+536>>2]|0,k,4184,4176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+544|0;q=p;h[q>>3]=n;i=d;return}function Qh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[(c[a+416>>2]|0)+88>>3];i=i;return}function Rh(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+40|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+264|0;p=o;h[p>>3]=m;i=b;return}else{g=d+136|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+264|0;p=o;h[p>>3]=m;i=b;return}}function Sh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+80>>3];i=i;return}function Th(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+32|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+256|0;p=o;h[p>>3]=m;i=b;return}else{g=d+128|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+256|0;p=o;h[p>>3]=m;i=b;return}}function Uh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[(c[a+416>>2]|0)+72>>3];i=i;return}function Vh(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+24|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+248|0;p=o;h[p>>3]=m;i=b;return}else{g=d+120|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+248|0;p=o;h[p>>3]=m;i=b;return}}function Wh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+64>>3];i=i;return}function Xh(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+16|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+240|0;p=o;h[p>>3]=m;i=b;return}else{g=d+112|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+240|0;p=o;h[p>>3]=m;i=b;return}}function Yh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+56>>3];i=i;return}function Zh(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+8|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+232|0;p=o;h[p>>3]=m;i=b;return}else{g=d+104|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+232|0;p=o;h[p>>3]=m;i=b;return}}function _h(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+48>>3];i=i;return}function $h(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+224|0;p=o;h[p>>3]=m;i=b;return}else{g=d+96|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+224|0;p=o;h[p>>3]=m;i=b;return}}function ai(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3]/.01604246+(+h[g+8>>3]/.01604246+(+h[g+16>>3]/.01604246+(+h[g+24>>3]/.01604246+(+h[g+32>>3]/.01604246+ +h[g+40>>3]/.01604246))));if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}q=+zr(c[b+536>>2]|0,j,4232,4224,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}function bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=(+h[b>>3]+(+h[b+8>>3]+(+h[b+16>>3]+(+h[b+24>>3]+(+h[b+32>>3]+ +h[b+40>>3])))))*518.2791167938085;i=i;return}function ci(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[a+416>>2]|0)+240>>3];i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+48>>3]+-273.15;i=i;return}function ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0;b=i;i=i+56|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+4|0;l=c[(c[c[j>>2]>>2]|0)+8>>2]|0;m=+h[l>>3];n=+h[l+16>>3];o=+h[l+24>>3];p=+h[l+32>>3];q=+h[l+40>>3];r=e;h[k>>3]=+h[l+8>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+8|0;h[k>>3]=n;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+16|0;h[k>>3]=o;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+24|0;h[k>>3]=p;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+32|0;h[k>>3]=q;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ns(f,6,m,e);e=c[a+536>>2]|0;m=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+48>>3];a=d;r=f;c[a+0>>2]=c[r+0>>2];c[a+4>>2]=c[r+4>>2];c[a+8>>2]=c[r+8>>2];Pg(g,e,m,d,1,1,0.0);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+488>>3]=+h[g>>3];i=b;return}function fi(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+256>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+400>>3]=-(b*+h[(!(b>=0.0)?d+488|0:d+600|0)>>3]);i=i;return}function gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+488>>3]- +h[b+464>>3]*+h[b+48>>3];i=i;return}function hi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=+h[(c[a+416>>2]|0)+224>>3];i=i;return}function ii(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+592>>3]*+h[(c[b+416>>2]|0)+264>>3];k=+h[g+56>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4448,4440,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}function ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+56>>3]- +h[(c[a+416>>2]|0)+280>>3];i=i;return}function ki(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+320>>3];g=+h[e+312>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+368>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+376|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+376|0;r=q;h[r>>3]=o;i=d;return}s=l/+zr(c[b+536>>2]|0,g,4520,4512,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+376|0;r=q;h[r>>3]=o;i=d;return}function li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[(c[a+416>>2]|0)+256>>3]- +h[b+376>>3];i=i;return}function mi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+504>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,e,4552,4544,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}function ni(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+184|0}else{e=b+40|0}h[b+168>>3]=-(d*+h[e>>3]);i=i;return}function oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=+h[b+168>>3]- +h[b+264>>3];i=i;return}function pi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+176|0}else{e=b+32|0}h[b+160>>3]=-(d*+h[e>>3]);i=i;return}function qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=+h[b+160>>3]- +h[b+256>>3];i=i;return}function ri(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+168|0}else{e=b+24|0}h[b+152>>3]=-(d*+h[e>>3]);i=i;return}function si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=+h[b+152>>3]- +h[b+248>>3];i=i;return}function ti(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+160|0}else{e=b+16|0}h[b+144>>3]=-(d*+h[e>>3]);i=i;return}function ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+144>>3]- +h[b+240>>3];i=i;return}function vi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+152|0}else{e=b+8|0}h[b+136>>3]=-(d*+h[e>>3]);i=i;return}function wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+136>>3]- +h[b+232>>3];i=i;return}function xi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+144|0}else{e=b}h[b+128>>3]=-(d*+h[e>>3]);i=i;return}function yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=+h[b+128>>3]- +h[b+224>>3];i=i;return}function zi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];h[b+384>>3]=-(d*+h[(!(d>=0.0)?b+576|0:b+488|0)>>3]);i=i;return}function Ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+384>>3]- +h[b+400>>3];i=i;return}function Bi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+392>>3]=+h[(a?e+576|0:e+488|0)>>3];i=b;return}function Ci(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+144|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+176|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a;f=a;g=+h[e>>3];j=f;k=j+176|0;l=k;h[l>>3]=g;i=b;return}}function Di(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+152|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+184|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+8|0;f=a;g=+h[e>>3];j=f;k=j+184|0;l=k;h[l>>3]=g;i=b;return}}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+160|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+192|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+16|0;f=a;g=+h[e>>3];j=f;k=j+192|0;l=k;h[l>>3]=g;i=b;return}}function Fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+168|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+200|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+24|0;f=a;g=+h[e>>3];j=f;k=j+200|0;l=k;h[l>>3]=g;i=b;return}}function Gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+176|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+208|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+32|0;f=a;g=+h[e>>3];j=f;k=j+208|0;l=k;h[l>>3]=g;i=b;return}}function Hi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+184|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+216|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+40|0;f=a;g=+h[e>>3];j=f;k=j+216|0;l=k;h[l>>3]=g;i=b;return}}function Ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function Ki(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+48>>3]*+h[g+464>>3];k=+h[g+56>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4576,4568,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[(c[a+416>>2]|0)+216>>3]*+h[b+480>>3];i=i;return}function Mi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+320>>3]- +h[g>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}function Ni(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+328>>3]- +h[g+8>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}function Oi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+336>>3]- +h[g+16>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4648,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}function Pi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+344>>3]- +h[g+24>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4656,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}function Qi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+352>>3]- +h[g+32>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+96|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+96|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4664,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+96|0;p=o;h[p>>3]=m;i=d;return}function Ri(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+360>>3]- +h[g+40>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+104|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+104|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4672,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+104|0;p=o;h[p>>3]=m;i=d;return}function Si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=(+h[b+64>>3]+(+h[b+72>>3]+(+h[b+80>>3]+(+h[b+88>>3]+(+h[b+96>>3]+ +h[b+104>>3])))))*518.2791167938085;i=i;return}function Ti(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+496>>3]- +h[g+504>>3]*+h[g+472>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,4624,4680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}function Ui(a){a=a|0;var b=0,d=0,e=0;b=i;Nu(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+112>>3]=+h[d>>3];h[e+520>>3]=+h[d+8>>3];i=b;return}function Vi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+464>>3];k=+h[g+48>>3];l=j*k;m=l*l;n=m!=0.0;do{if(n){o=k;p=j;q=g;r=f;s=k/m}else{if(k==0.0){o=k;p=j;q=g;r=f;s=k;break}l=k/+zr(c[b+536>>2]|0,m,4696,4688,+h[f>>3],(a[b+319|0]|0)!=0|0);t=c[c[e>>2]>>2]|0;u=c[t+8>>2]|0;o=+h[u+48>>3];p=+h[u+464>>3];q=u;r=t;s=l}}while(0);k=+h[q+56>>3];l=-k;v=+h[q+112>>3];w=+h[q+528>>3];x=p*v+w*o;if(j*s!=-0.0){do{if(n){y=x/m*l- +h[q+536>>3];z=p;A=o;B=11}else{if(x==0.0){C=x*l- +h[q+536>>3];D=r;E=p;F=o}else{s=x/+zr(c[b+536>>2]|0,m,4696,4688,+h[r>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+464>>3];G=+h[g+48>>3];H=s*l- +h[g+536>>3];if(n){y=H;z=j;A=G;B=11;break}else{C=H;D=f;E=j;F=G}}if(F==0.0){I=C;J=E;K=F;break}I=C;J=E;K=F/+zr(c[b+536>>2]|0,m,4696,4688,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((B|0)==11){I=y;J=z;K=A/m}L=I/-(J*K);M=c[e>>2]|0;N=c[M>>2]|0;O=N;P=O+8|0;Q=P;R=c[Q>>2]|0;S=R;T=S+120|0;U=T;h[U>>3]=L;i=d;return}do{if(n){V=o;W=w;X=v;Y=p;Z=k;_=q;$=r;aa=x/m}else{if(x==0.0){V=o;W=w;X=v;Y=p;Z=k;_=q;$=r;aa=x;break}K=x/+zr(c[b+536>>2]|0,m,4696,4688,+h[r>>3],(a[b+319|0]|0)!=0|0);D=c[c[e>>2]>>2]|0;f=c[D+8>>2]|0;V=+h[f+48>>3];W=+h[f+528>>3];X=+h[f+112>>3];Y=+h[f+464>>3];Z=+h[f+56>>3];_=f;$=D;aa=K}}while(0);x=+h[_+536>>3];k=-Z;Z=Y*X+W*V;if(aa*l-x==0.0){do{if(n){ba=x;ca=Z/m}else{if(Z==0.0){ba=x;ca=Z;break}l=Z/+zr(c[b+536>>2]|0,m,4696,4688,+h[$>>3],(a[b+319|0]|0)!=0|0);ba=+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+536>>3];ca=l}}while(0);L=ca*k-ba;M=c[e>>2]|0;N=c[M>>2]|0;O=N;P=O+8|0;Q=P;R=c[Q>>2]|0;S=R;T=S+120|0;U=T;h[U>>3]=L;i=d;return}do{if(n){da=c[b+536>>2]|0;ea=Z/m*k-x;fa=$;ga=Y;ha=V;B=30}else{if(Z==0.0){ia=c[b+536>>2]|0;ja=Z*k-x;ka=$;la=Y;ma=V}else{ba=Z/+zr(c[b+536>>2]|0,m,4696,4688,+h[$>>3],(a[b+319|0]|0)!=0|0);_=c[c[e>>2]>>2]|0;r=c[_+8>>2]|0;ca=+h[r+464>>3];l=+h[r+48>>3];aa=ba*k- +h[r+536>>3];r=c[b+536>>2]|0;if(n){da=r;ea=aa;fa=_;ga=ca;ha=l;B=30;break}else{ia=r;ja=aa;ka=_;la=ca;ma=l}}if(ma==0.0){na=ia;oa=ja;pa=la;qa=ka;ra=ma;break}l=ma/+zr(ia,m,4696,4688,+h[ka>>3],(a[b+319|0]|0)!=0|0);na=ia;oa=ja;pa=la;qa=c[c[e>>2]>>2]|0;ra=l}}while(0);if((B|0)==30){na=da;oa=ea;pa=ga;qa=fa;ra=ha/m}L=oa/+zr(na,-(pa*ra),4744,4688,+h[qa>>3],(a[b+319|0]|0)!=0|0);M=c[e>>2]|0;N=c[M>>2]|0;O=N;P=O+8|0;Q=P;R=c[Q>>2]|0;S=R;T=S+120|0;U=T;h[U>>3]=L;i=d;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[b+424>>3]*+h[b+472>>3];i=i;return}function Xi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+40>>3]*+h[b+424>>3];i=i;return}function Yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b+32>>3]*+h[b+424>>3];i=i;return}function Zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+24>>3]*+h[b+424>>3];i=i;return}function _i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+16>>3]*+h[b+424>>3];i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+8>>3]*+h[b+424>>3];i=i;return}function aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b>>3]*+h[b+424>>3];i=i;return}function bj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+304>>3]=+h[b+208>>3];i=i;return}function cj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+208>>3]*1.2;i=i;return}function dj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+208>>3];i=i;return}function ej(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);a[d]=0;i=c;return 0}function fj(a){a=a|0;i=i;return}function gj(a){a=a|0;i=i;return 0}function hj(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;tr(9,1,4840,e);if((c[31900>>2]|0)!=0){ee[c[8104]&255](9)}tr(9,1,4864,d);if((c[31900>>2]|0)!=0){ee[c[8104]&255](9)}tr(9,1,4888,b);if((c[31900>>2]|0)!=0){ee[c[8104]&255](9)}tr(9,1,4912,a);if((c[31900>>2]|0)==0){i=a;return 0}ee[c[8104]&255](9);i=a;return 0}function ij(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+192>>3];i=i;return}function jj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+200>>3];i=i;return}function kj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+208>>3];i=i;return}function lj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b>>3];i=i;return}function mj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b+8>>3];i=i;return}function nj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+16>>3];i=i;return}function oj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+24>>3];i=i;return}function pj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+32>>3];i=i;return}function qj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+40>>3];i=i;return}function rj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+200>>3]*1.2;i=i;return}function sj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=+h[(c[a+416>>2]|0)+264>>3]+-273.15;i=i;return}function tj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+208>>3]*1.2;i=i;return}function uj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b>>3]*.5;i=i;return}function vj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+8>>3]*.5;i=i;return}function wj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+16>>3]*.5;i=i;return}function xj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+24>>3]*.5;i=i;return}function yj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+32>>3]*.5;i=i;return}function zj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+40>>3]*.5;i=i;return}function Aj(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[b+416>>2]|0;f=+h[e+96>>3]/.01604246+(+h[e+104>>3]/.01604246+(+h[e+112>>3]/.01604246+(+h[e+120>>3]/.01604246+(+h[e+128>>3]/.01604246+ +h[e+136>>3]/.01604246))));if(f!=0.0){g=b+4|0;j=f;k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+608|0;t=s;h[t>>3]=k;i=d;return}else{e=b+4|0;g=e;j=+zr(c[b+536>>2]|0,f,4944,4936,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+608|0;t=s;h[t>>3]=k;i=d;return}}function Bj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0;b=i;i=i+56|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+96>>3];n=+h[l+112>>3];o=+h[l+120>>3];p=+h[l+128>>3];q=+h[l+136>>3];r=e;h[k>>3]=+h[l+104>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+8|0;h[k>>3]=n;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+16|0;h[k>>3]=o;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+24|0;h[k>>3]=p;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+32|0;h[k>>3]=q;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ns(f,6,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+264>>3];j=d;r=f;c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];Og(g,e,m,d,1,1,0.0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[g>>3];i=b;return}function Cj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+592>>3]=(+h[b+96>>3]+(+h[b+104>>3]+(+h[b+112>>3]+(+h[b+120>>3]+(+h[b+128>>3]+ +h[b+136>>3])))))*518.2791167938085;i=i;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=+h[b+600>>3]- +h[b+592>>3]*+h[(c[a+416>>2]|0)+264>>3];i=i;return}function Ej(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+192>>3];i=i;return}function Fj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[(c[a+416>>2]|0)+280>>3]*1.0e-5;i=i;return}function Gj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+200>>3];i=i;return}function Hj(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[(c[a+416>>2]|0)+296>>3]+-273.15;i=i;return}function Ij(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+304>>3]=+h[b+208>>3];i=i;return}function _setLinearMatrixA171$0(b){b=b|0;var d=0,e=0,f=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0.0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0,Za=0.0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0.0,zb=0.0,Ab=0,Bb=0,Cb=0,Db=0.0,Eb=0.0,Fb=0,Gb=0,Hb=0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0,Ub=0.0,Vb=0.0,Wb=0,Xb=0.0,Yb=0.0,Zb=0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0,hc=0.0,ic=0.0,jc=0,kc=0.0,lc=0.0,mc=0;d=c[b+592>>2]|0;e=c[b+600>>2]|0;f=c[b+2112>>2]|0;j=c[b+2120>>2]|0;l=+g[b+2128>>2];m=+g[b+6448>>2];n=+g[b+6456>>2];o=+g[b+6464>>2];p=c[b+6576>>2]|0;q=c[b+6584>>2]|0;r=c[b+6600>>2]|0;s=c[b+6608>>2]|0;t=c[b+6616>>2]|0;u=c[b+6624>>2]|0;v=c[b+6632>>2]|0;w=c[b+6640>>2]|0;x=c[b+6648>>2]|0;y=c[b+6656>>2]|0;z=c[b+6664>>2]|0;a:do{do{if(f){if(l>0.0){A=l;B=j}else{C=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=l;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];E=b+216|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[C&31](D,b+216|0,3016,r);D=c[c[(d+4|0)>>2]>>2]|0;A=+h[(c[D+8>>2]|0)+48>>3];B=D}if(A>0.0){F=A;G=B}else{D=c[20226]|0;C=c[d+536>>2]|0;h[k>>3]=A;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];E=b+192|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[D&31](C,b+192|0,3016,s);C=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[C+8>>2]|0)+48>>3];G=C}H=F*F;C=F!=0.0;if(H*H!=0.0){if(C){I=F;J=F}else{H=+zr(c[d+536>>2]|0,F,3088,3184,+h[G>>3],(a[d+319|0]|0)!=0|0);I=H;J=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}H=J*1.05012705e-15;K=J*(H+-3.054734245e-11)+3.933953493333333e-7;L=J*K+-.003098958405;M=J*L+57.3673275;N=J*M;O=J*J;P=O*(J*(F*(-32560.5151/I+(J*(J*(J*(H+(H+-3.054734245e-11))+K)+L)+M))+(+da(+l)*-32560.5151+N+177452.656))-(J*(+da(+A)*-32560.5151+N+177452.656)+-7682322.45))*143.0515706563069/(O*O);break}if(C){Q=F;R=F;S=G}else{O=+zr(c[d+536>>2]|0,F,3088,3184,+h[G>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;Q=O;R=+h[(c[C+8>>2]|0)+48>>3];S=C}O=R*1.05012705e-15;N=R*(O+-3.054734245e-11)+3.933953493333333e-7;M=R*N+-.003098958405;L=R*M+57.3673275;K=+da(+l)*-32560.5151;H=R*L;T=+da(+A)*-32560.5151;C=R!=0.0;if(R*R*(R*(F*(-32560.5151/Q+(R*(R*(R*(O+(O+-3.054734245e-11))+N)+M)+L))+(K+H+177452.656))-(R*(T+H+177452.656)+-7682322.45))*143.0515706563069==0.0){if(C){U=R;V=R}else{H=+zr(c[d+536>>2]|0,R,3088,3184,+h[S>>3],(a[d+319|0]|0)!=0|0);U=H;V=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}H=V*1.05012705e-15;L=V*(H+-3.054734245e-11)+3.933953493333333e-7;M=V*L+-.003098958405;N=V*M+57.3673275;O=V*N;P=V*V*(V*(R*(-32560.5151/U+(V*(V*(V*(H+(H+-3.054734245e-11))+L)+M)+N))+(K+O+177452.656))-(V*(T+O+177452.656)+-7682322.45))*143.0515706563069;break}if(C){W=d+319|0;X=R;Y=R;Z=S}else{O=+zr(c[(d+536|0)>>2]|0,R,3088,3184,+h[S>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;W=d+319|0;X=O;Y=+h[(c[C+8>>2]|0)+48>>3];Z=C}O=Y*1.05012705e-15;N=Y*(O+-3.054734245e-11)+3.933953493333333e-7;M=Y*N+-.003098958405;L=Y*M+57.3673275;H=Y*L;_=Y*Y;P=_*(Y*(R*(-32560.5151/X+(Y*(Y*(Y*(O+(O+-3.054734245e-11))+N)+M)+L))+(K+H+177452.656))-(Y*(T+H+177452.656)+-7682322.45))*143.0515706563069/+zr(c[(d+536|0)>>2]|0,_*_,3104,3184,+h[Z>>3],(a[W]|0)!=0|0)}else{if(l>0.0){$=l;aa=j}else{C=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=l;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];E=b+264|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[C&31](D,b+264|0,3016,p);D=c[c[(d+4|0)>>2]>>2]|0;$=+h[(c[D+8>>2]|0)+48>>3];aa=D}if($>0.0){ba=$;ca=aa}else{D=c[20226]|0;C=c[d+536>>2]|0;h[k>>3]=$;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];E=b+240|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[D&31](C,b+240|0,3016,q);C=c[c[(d+4|0)>>2]>>2]|0;ba=+h[(c[C+8>>2]|0)+48>>3];ca=C}_=ba*ba;C=ba!=0.0;if(_*_!=0.0){if(C){ea=ba;fa=ba}else{_=+zr(c[d+536>>2]|0,ba,3088,3184,+h[ca>>3],(a[d+319|0]|0)!=0|0);ea=_;fa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=fa*-6.4033411e-12;H=fa*(_+2.9991908725e-8)+-6200167196666667.0e-20;T=fa*H+.0792327142;K=fa*T+-38.9156212;L=fa*K;M=fa*fa;P=M*(fa*(ba*(6176.331819999999/ea+(fa*(fa*(fa*(_+(_+2.9991908725e-8))+H)+T)+K))+(+da(+l)*6176.331819999999+L+-45403.63390000001))-(fa*(+da(+$)*6176.331819999999+L+-45403.63390000001)+317587.254))*143.0515706563069/(M*M);break}if(C){ga=ba;ha=ba;ia=ca}else{M=+zr(c[d+536>>2]|0,ba,3088,3184,+h[ca>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;ga=M;ha=+h[(c[C+8>>2]|0)+48>>3];ia=C}M=ha*-6.4033411e-12;L=ha*(M+2.9991908725e-8)+-6200167196666667.0e-20;K=ha*L+.0792327142;T=ha*K+-38.9156212;H=+da(+l)*6176.331819999999;_=ha*T;N=+da(+$)*6176.331819999999;C=ha!=0.0;if(ha*ha*(ha*(ba*(6176.331819999999/ga+(ha*(ha*(ha*(M+(M+2.9991908725e-8))+L)+K)+T))+(H+_+-45403.63390000001))-(ha*(N+_+-45403.63390000001)+317587.254))*143.0515706563069==0.0){if(C){ja=ha;ka=ha}else{_=+zr(c[d+536>>2]|0,ha,3088,3184,+h[ia>>3],(a[d+319|0]|0)!=0|0);ja=_;ka=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=ka*-6.4033411e-12;T=ka*(_+2.9991908725e-8)+-6200167196666667.0e-20;K=ka*T+.0792327142;L=ka*K+-38.9156212;M=ka*L;P=ka*ka*(ka*(ha*(6176.331819999999/ja+(ka*(ka*(ka*(_+(_+2.9991908725e-8))+T)+K)+L))+(H+M+-45403.63390000001))-(ka*(N+M+-45403.63390000001)+317587.254))*143.0515706563069;break}if(C){la=d+319|0;ma=ha;na=ha;oa=ia}else{M=+zr(c[(d+536|0)>>2]|0,ha,3088,3184,+h[ia>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;la=d+319|0;ma=M;na=+h[(c[C+8>>2]|0)+48>>3];oa=C}M=na*-6.4033411e-12;L=na*(M+2.9991908725e-8)+-6200167196666667.0e-20;K=na*L+.0792327142;T=na*K+-38.9156212;_=na*T;O=na*na;P=O*(na*(ha*(6176.331819999999/ma+(na*(na*(na*(M+(M+2.9991908725e-8))+L)+K)+T))+(H+_+-45403.63390000001))-(na*(N+_+-45403.63390000001)+317587.254))*143.0515706563069/+zr(c[(d+536|0)>>2]|0,O*O,3104,3184,+h[oa>>3],(a[la]|0)!=0|0)}}while(0);C=(yu(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;D=c[c[(d+4|0)>>2]>>2]|0;O=+h[(c[D+8>>2]|0)+48>>3];do{if(C){if(O>0.0){pa=O;qa=D}else{E=c[20226]|0;ra=c[d+536>>2]|0;h[k>>3]=O;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sa=b+120|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[E&31](ra,b+120|0,3016,v);ra=c[c[(d+4|0)>>2]>>2]|0;pa=+h[(c[ra+8>>2]|0)+48>>3];qa=ra}if(pa>0.0){ta=pa;ua=qa}else{ra=c[20226]|0;E=c[d+536>>2]|0;h[k>>3]=pa;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sa=b+96|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[ra&31](E,b+96|0,3016,w);E=c[c[(d+4|0)>>2]>>2]|0;ta=+h[(c[E+8>>2]|0)+48>>3];ua=E}_=ta*ta;E=ta!=0.0;if(_*_!=0.0){if(E){va=ta;wa=ta}else{_=+zr(c[d+536>>2]|0,ta,3088,3184,+h[ua>>3],(a[d+319|0]|0)!=0|0);va=_;wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=wa*2.123908772e-16;N=wa*(_+-4.8077637125e-12)+4.97268893e-8;H=wa*N+-.000306984275;T=wa*H+6.06694922;K=wa*T;L=wa*wa;xa=L*(wa*(ta*(-2239.249073/va+(wa*(wa*(wa*(_+(_+-4.8077637125e-12))+N)+H)+T))+(+da(+O)*-2239.249073+K+12832.10415))-(wa*(+da(+pa)*-2239.249073+K+12832.10415)+-587712.406))*296.8033869505308/(L*L);break}if(E){ya=ta;za=ta;Aa=ua}else{L=+zr(c[d+536>>2]|0,ta,3088,3184,+h[ua>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;ya=L;za=+h[(c[E+8>>2]|0)+48>>3];Aa=E}L=za*2.123908772e-16;K=za*(L+-4.8077637125e-12)+4.97268893e-8;T=za*K+-.000306984275;H=za*T+6.06694922;N=+da(+O)*-2239.249073;_=za*H;M=+da(+pa)*-2239.249073;E=za!=0.0;if(za*za*(za*(ta*(-2239.249073/ya+(za*(za*(za*(L+(L+-4.8077637125e-12))+K)+T)+H))+(N+_+12832.10415))-(za*(M+_+12832.10415)+-587712.406))*296.8033869505308==0.0){if(E){Ba=za;Ca=za}else{_=+zr(c[d+536>>2]|0,za,3088,3184,+h[Aa>>3],(a[d+319|0]|0)!=0|0);Ba=_;Ca=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=Ca*2.123908772e-16;H=Ca*(_+-4.8077637125e-12)+4.97268893e-8;T=Ca*H+-.000306984275;K=Ca*T+6.06694922;L=Ca*K;xa=Ca*Ca*(Ca*(za*(-2239.249073/Ba+(Ca*(Ca*(Ca*(_+(_+-4.8077637125e-12))+H)+T)+K))+(N+L+12832.10415))-(Ca*(M+L+12832.10415)+-587712.406))*296.8033869505308;break}if(E){Da=d+319|0;Ea=za;Fa=za;Ga=Aa}else{L=+zr(c[(d+536|0)>>2]|0,za,3088,3184,+h[Aa>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;Da=d+319|0;Ea=L;Fa=+h[(c[E+8>>2]|0)+48>>3];Ga=E}L=Fa*2.123908772e-16;K=Fa*(L+-4.8077637125e-12)+4.97268893e-8;T=Fa*K+-.000306984275;H=Fa*T+6.06694922;_=Fa*H;Ha=Fa*Fa;xa=Ha*(Fa*(za*(-2239.249073/Ea+(Fa*(Fa*(Fa*(L+(L+-4.8077637125e-12))+K)+T)+H))+(N+_+12832.10415))-(Fa*(M+_+12832.10415)+-587712.406))*296.8033869505308/+zr(c[(d+536|0)>>2]|0,Ha*Ha,3104,3184,+h[Ga>>3],(a[Da]|0)!=0|0)}else{if(O>0.0){Ia=O;Ja=D}else{E=c[20226]|0;ra=c[d+536>>2]|0;h[k>>3]=O;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];sa=b+168|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[E&31](ra,b+168|0,3016,t);ra=c[c[(d+4|0)>>2]>>2]|0;Ia=+h[(c[ra+8>>2]|0)+48>>3];Ja=ra}if(Ia>0.0){Ka=Ia;La=Ja}else{ra=c[20226]|0;E=c[d+536>>2]|0;h[k>>3]=Ia;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];sa=b+144|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[ra&31](E,b+144|0,3016,u);E=c[c[(d+4|0)>>2]>>2]|0;Ka=+h[(c[E+8>>2]|0)+48>>3];La=E}Ha=Ka*Ka;E=Ka!=0.0;if(Ha*Ha!=0.0){if(E){Ma=Ka;Na=Ka}else{Ha=+zr(c[d+536>>2]|0,Ka,3088,3184,+h[La>>3],(a[d+319|0]|0)!=0|0);Ma=Ha;Na=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}Ha=Na*5.039411618000001e-13;_=Na*(Ha+-2.406448405e-9)+4615487296666666.0e-21;M=Na*_+-.004265457205;N=Na*M+6.08273836;H=Na*N;T=Na*Na;xa=T*(Na*(Ka*(-381.846182/Ma+(Na*(Na*(Na*(Ha+(Ha+-2.406448405e-9))+_)+M)+N))+(+da(+O)*-381.846182+H+710.846086))-(Na*(+da(+Ia)*-381.846182+H+710.846086)+-22103.71497))*296.8033869505308/(T*T);break}if(E){Oa=Ka;Pa=Ka;Qa=La}else{T=+zr(c[d+536>>2]|0,Ka,3088,3184,+h[La>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;Oa=T;Pa=+h[(c[E+8>>2]|0)+48>>3];Qa=E}T=Pa*5.039411618000001e-13;H=Pa*(T+-2.406448405e-9)+4615487296666666.0e-21;N=Pa*H+-.004265457205;M=Pa*N+6.08273836;_=+da(+O)*-381.846182;Ha=Pa*M;K=+da(+Ia)*-381.846182;E=Pa!=0.0;if(Pa*Pa*(Pa*(Ka*(-381.846182/Oa+(Pa*(Pa*(Pa*(T+(T+-2.406448405e-9))+H)+N)+M))+(_+Ha+710.846086))-(Pa*(K+Ha+710.846086)+-22103.71497))*296.8033869505308==0.0){if(E){Ra=Pa;Sa=Pa}else{Ha=+zr(c[d+536>>2]|0,Pa,3088,3184,+h[Qa>>3],(a[d+319|0]|0)!=0|0);Ra=Ha;Sa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}Ha=Sa*5.039411618000001e-13;M=Sa*(Ha+-2.406448405e-9)+4615487296666666.0e-21;N=Sa*M+-.004265457205;H=Sa*N+6.08273836;T=Sa*H;xa=Sa*Sa*(Sa*(Pa*(-381.846182/Ra+(Sa*(Sa*(Sa*(Ha+(Ha+-2.406448405e-9))+M)+N)+H))+(_+T+710.846086))-(Sa*(K+T+710.846086)+-22103.71497))*296.8033869505308;break}if(E){Ta=d+319|0;Ua=Pa;Va=Pa;Wa=Qa}else{T=+zr(c[(d+536|0)>>2]|0,Pa,3088,3184,+h[Qa>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;Ta=d+319|0;Ua=T;Va=+h[(c[E+8>>2]|0)+48>>3];Wa=E}T=Va*5.039411618000001e-13;H=Va*(T+-2.406448405e-9)+4615487296666666.0e-21;N=Va*H+-.004265457205;M=Va*N+6.08273836;Ha=Va*M;L=Va*Va;xa=L*(Va*(Pa*(-381.846182/Ua+(Va*(Va*(Va*(T+(T+-2.406448405e-9))+H)+N)+M))+(_+Ha+710.846086))-(Va*(K+Ha+710.846086)+-22103.71497))*296.8033869505308/+zr(c[(d+536|0)>>2]|0,L*L,3104,3184,+h[Wa>>3],(a[Ta]|0)!=0|0)}}while(0);D=(yu(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;C=c[c[(d+4|0)>>2]>>2]|0;O=+h[(c[C+8>>2]|0)+48>>3];E=1;if(E){E=0;if(D){if(O>0.0){Xa=O;Ya=C}else{D=c[20226]|0;ra=c[d+536>>2]|0;h[k>>3]=O;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sa=b+24|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[D&31](ra,b+24|0,3016,z);ra=c[c[(d+4|0)>>2]>>2]|0;Xa=+h[(c[ra+8>>2]|0)+48>>3];Ya=ra}if(Xa>0.0){Za=Xa;_a=Ya}else{ra=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=Xa;c[(b+576|0)>>2]=c[k>>2];c[(b+576|0)+4>>2]=c[k+4>>2];c[b+0>>2]=c[3200+0>>2];c[b+4>>2]=c[3200+4>>2];c[b+8>>2]=c[3200+8>>2];c[b+12>>2]=c[3200+12>>2];c[b+16>>2]=c[3200+16>>2];c[b+20>>2]=c[3200+20>>2];He[ra&31](D,b,3016,b+576|0);D=c[c[(d+4|0)>>2]>>2]|0;Za=+h[(c[D+8>>2]|0)+48>>3];_a=D}L=Za*Za;D=Za!=0.0;if(L*L!=0.0){if(D){$a=Za;ab=Za}else{L=+zr(c[d+536>>2]|0,Za,3088,3184,+h[_a>>3],(a[d+319|0]|0)!=0|0);$a=L;ab=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=ab*1.266007318e-16;Ha=ab*(L+-4.72763328e-13)+1.621225626666666e-9;K=ab*Ha+-461157839.0e-13;_=ab*K+8.29152319;M=ab*_;N=ab*ab;bb=N*(ab*(Za*(-1788.791477/$a+(ab*(ab*(ab*(L+(L+-4.72763328e-13))+Ha)+K)+_))+(+da(+O)*-1788.791477+M+-39083.5059))-(ab*(+da(+Xa)*-1788.791477+M+-39083.5059)+-117696.2419))*188.9244822140674/(N*N);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(D){Rb=Za;Sb=Za;Tb=_a}else{N=+zr(c[d+536>>2]|0,Za,3088,3184,+h[_a>>3],(a[d+319|0]|0)!=0|0);D=c[c[(d+4|0)>>2]>>2]|0;Rb=N;Sb=+h[(c[D+8>>2]|0)+48>>3];Tb=D}N=Sb*1.266007318e-16;M=Sb*(N+-4.72763328e-13)+1.621225626666666e-9;_=Sb*M+-461157839.0e-13;K=Sb*_+8.29152319;Ha=+da(+O)*-1788.791477;L=Sb*K;H=+da(+Xa)*-1788.791477;D=Sb!=0.0;if(Sb*Sb*(Sb*(Za*(-1788.791477/Rb+(Sb*(Sb*(Sb*(N+(N+-4.72763328e-13))+M)+_)+K))+(Ha+L+-39083.5059))-(Sb*(H+L+-39083.5059)+-117696.2419))*188.9244822140674==0.0){if(D){Ub=Sb;Vb=Sb}else{L=+zr(c[d+536>>2]|0,Sb,3088,3184,+h[Tb>>3],(a[d+319|0]|0)!=0|0);Ub=L;Vb=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=Vb*1.266007318e-16;K=Vb*(L+-4.72763328e-13)+1.621225626666666e-9;_=Vb*K+-461157839.0e-13;M=Vb*_+8.29152319;N=Vb*M;bb=Vb*Vb*(Vb*(Sb*(-1788.791477/Ub+(Vb*(Vb*(Vb*(L+(L+-4.72763328e-13))+K)+_)+M))+(Ha+N+-39083.5059))-(Vb*(H+N+-39083.5059)+-117696.2419))*188.9244822140674;cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(D){Wb=d+319|0;Xb=Sb;Yb=Sb;Zb=Tb}else{N=+zr(c[(d+536|0)>>2]|0,Sb,3088,3184,+h[Tb>>3],(a[d+319|0]|0)!=0|0);D=c[c[(d+4|0)>>2]>>2]|0;Wb=d+319|0;Xb=N;Yb=+h[(c[D+8>>2]|0)+48>>3];Zb=D}N=Yb*1.266007318e-16;M=Yb*(N+-4.72763328e-13)+1.621225626666666e-9;_=Yb*M+-461157839.0e-13;K=Yb*_+8.29152319;L=Yb*K;T=Yb*Yb;bb=T*(Yb*(Sb*(-1788.791477/Xb+(Yb*(Yb*(Yb*(N+(N+-4.72763328e-13))+M)+_)+K))+(Ha+L+-39083.5059))-(Yb*(H+L+-39083.5059)+-117696.2419))*188.9244822140674/+zr(c[(d+536|0)>>2]|0,T*T,3104,3184,+h[Zb>>3],(a[Wb]|0)!=0|0);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}else{E=1}}if(E){E=0;if(1){if(O>0.0){_b=O;$b=C}else{C=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=O;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];ra=b+72|0;c[ra+0>>2]=c[3200+0>>2];c[ra+4>>2]=c[3200+4>>2];c[ra+8>>2]=c[3200+8>>2];c[ra+12>>2]=c[3200+12>>2];c[ra+16>>2]=c[3200+16>>2];c[ra+20>>2]=c[3200+20>>2];He[C&31](D,b+72|0,3016,x);D=c[c[(d+4|0)>>2]>>2]|0;_b=+h[(c[D+8>>2]|0)+48>>3];$b=D}if(_b>0.0){ac=_b;bc=$b}else{D=c[20226]|0;C=c[d+536>>2]|0;h[k>>3]=_b;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ra=b+48|0;c[ra+0>>2]=c[3200+0>>2];c[ra+4>>2]=c[3200+4>>2];c[ra+8>>2]=c[3200+8>>2];c[ra+12>>2]=c[3200+12>>2];c[ra+16>>2]=c[3200+16>>2];c[ra+20>>2]=c[3200+20>>2];He[D&31](C,b+48|0,3016,y);C=c[c[(d+4|0)>>2]>>2]|0;ac=+h[(c[C+8>>2]|0)+48>>3];bc=C}T=ac*ac;C=ac!=0.0;if(T*T!=0.0){if(C){cc=ac;dc=ac}else{T=+zr(c[d+536>>2]|0,ac,3088,3184,+h[bc>>3],(a[d+319|0]|0)!=0|0);cc=T;dc=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}T=dc*5.699355602e-14;L=dc*(T+-1.922497195e-10)+-7.091029093333333e-8;H=dc*L+.001251906908;Ha=dc*H+5.30172524;K=dc*Ha;_=dc*dc;bb=_*(dc*(ac*(-626.411601/cc+(dc*(dc*(dc*(T+(T+-1.922497195e-10))+L)+H)+Ha))+(+da(+O)*-626.411601+K+-45281.9846))-(dc*(+da(+_b)*-626.411601+K+-45281.9846)+-49436.5054))*188.9244822140674/(_*_);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(C){ec=ac;fc=ac;gc=bc}else{_=+zr(c[d+536>>2]|0,ac,3088,3184,+h[bc>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;ec=_;fc=+h[(c[C+8>>2]|0)+48>>3];gc=C}_=fc*5.699355602e-14;K=fc*(_+-1.922497195e-10)+-7.091029093333333e-8;Ha=fc*K+.001251906908;H=fc*Ha+5.30172524;L=+da(+O)*-626.411601;O=fc*H;T=+da(+_b)*-626.411601;C=fc!=0.0;if(fc*fc*(fc*(ac*(-626.411601/ec+(fc*(fc*(fc*(_+(_+-1.922497195e-10))+K)+Ha)+H))+(L+O+-45281.9846))-(fc*(T+O+-45281.9846)+-49436.5054))*188.9244822140674==0.0){if(C){hc=fc;ic=fc}else{O=+zr(c[d+536>>2]|0,fc,3088,3184,+h[gc>>3],(a[d+319|0]|0)!=0|0);hc=O;ic=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}O=ic*5.699355602e-14;H=ic*(O+-1.922497195e-10)+-7.091029093333333e-8;Ha=ic*H+.001251906908;K=ic*Ha+5.30172524;_=ic*K;bb=ic*ic*(ic*(fc*(-626.411601/hc+(ic*(ic*(ic*(O+(O+-1.922497195e-10))+H)+Ha)+K))+(L+_+-45281.9846))-(ic*(T+_+-45281.9846)+-49436.5054))*188.9244822140674;cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(C){jc=d+319|0;kc=fc;lc=fc;mc=gc}else{_=+zr(c[(d+536|0)>>2]|0,fc,3088,3184,+h[gc>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;jc=d+319|0;kc=_;lc=+h[(c[C+8>>2]|0)+48>>3];mc=C}_=lc*5.699355602e-14;K=lc*(_+-1.922497195e-10)+-7.091029093333333e-8;Ha=lc*K+.001251906908;H=lc*Ha+5.30172524;O=lc*H;M=lc*lc;bb=M*(lc*(fc*(-626.411601/kc+(lc*(lc*(lc*(_+(_+-1.922497195e-10))+K)+Ha)+H))+(L+O+-45281.9846))-(lc*(T+O+-45281.9846)+-49436.5054))*188.9244822140674/+zr(c[(d+536|0)>>2]|0,M*M,3104,3184,+h[mc>>3],(a[jc]|0)!=0|0);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}else{E=1}}}while(0)}



function Ie(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Je(){return i|0}function Ke(a){a=a|0;i=a}function Le(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Me(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ne(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Oe(a){a=a|0;J=a}function Pe(a){a=a|0;K=a}function Qe(a){a=a|0;L=a}function Re(a){a=a|0;M=a}function Se(a){a=a|0;N=a}function Te(a){a=a|0;O=a}function Ue(a){a=a|0;P=a}function Ve(a){a=a|0;Q=a}function We(a){a=a|0;R=a}function Xe(a){a=a|0;S=a}function Ye(a){a=a|0;var b=0,d=0;b=i;Fv(a)|0;d=a+540|0;he[c[(c[d>>2]|0)+40>>2]&127](a)|0;he[c[(c[d>>2]|0)+28>>2]&127](a)|0;he[c[(c[d>>2]|0)+32>>2]&127](a)|0;he[c[(c[d>>2]|0)+48>>2]&127](a)|0;he[c[(c[d>>2]|0)+52>>2]&127](a)|0;lu(a);i=b;return}function Ze(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=qW(B|0)|0;D=OV(C+11|0)|0;BW(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=hc(D|0,32)|0;if((C|0)==0){B=Vd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;vr(23,0,40,u);Yc(0)|0;F=0}else{F=C}PV(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Be[c[32764>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Js(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Js(2);Is(2)}xs(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tr(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];_t(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tr(23,1,144,r);Z=nv(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ye(b);mu(b);if((c[31956>>2]|0)!=0){ee[c[8104]&255](23)}if((c[2]|0)!=0){Is(4)}A=au(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tr(7,1,200,q);if((c[88620>>2]|0)==0){fe[c[73308>>2]&127](73288,b)}cu(b,c[J>>2]|0,z,d);if((c[31892>>2]|0)!=0){ee[c[8104]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;qu(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Ls(4)}if((zv(b,1,1)|0)!=0){c[B>>2]=1;qu(b)}he[c[(c[K>>2]|0)+88>>2]&127](b)|0;lu(b);uu(b);mu(b);do{if((T|0)==0){_=0}else{Is(7);Ls(2);A=(qc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(qc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Ds(2);if(!$){aa=0;break}aa=(qc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Ds(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=ys(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(qc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Ds(ba+9|0);if((ca|0)==0){ka=0}else{ka=(qc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Ls(7);if((la|0)!=0){_=T;break}c[p>>2]=Vd(c[(Nc()|0)>>2]|0)|0;vr(23,0,240,p);Yc(T|0)|0;_=0}}while(0);if((c[88620>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;fe[c[73308>>2]&127](73288,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[19722]|0)!=0){ca=f;ba=78896;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];lr(M,f);Rd(10,M|0)|0;ba=c[19730]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;tr(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((Yu(b,0)|0)!=0){ma=58;break}if((Ou(b,0)|0)!=0){ma=58;break}if((Du(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((Yu(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(1,0,448,m);U=_;V=-2;break}if((Ou(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(1,0,536,l);U=_;V=-3;break}T=(Du(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Yc(U|0)|0;i=e;return V|0}function _e(a){a=a|0;i=i;return 0}function $e(a){a=a|0;i=i;return 0}function af(a){a=a|0;i=i;return 0}function bf(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+40|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+264|0;p=o;h[p>>3]=m;i=b;return}else{g=d+136|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+264|0;p=o;h[p>>3]=m;i=b;return}}function cf(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+32|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+256|0;p=o;h[p>>3]=m;i=b;return}else{g=d+128|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+256|0;p=o;h[p>>3]=m;i=b;return}}function df(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+24|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+248|0;p=o;h[p>>3]=m;i=b;return}else{g=d+120|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+248|0;p=o;h[p>>3]=m;i=b;return}}function ef(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+16|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+240|0;p=o;h[p>>3]=m;i=b;return}else{g=d+112|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+240|0;p=o;h[p>>3]=m;i=b;return}}function ff(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f+8|0;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+232|0;p=o;h[p>>3]=m;i=b;return}else{g=d+104|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+232|0;p=o;h[p>>3]=m;i=b;return}}function gf(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=c[a+416>>2]|0;e=+h[d+256>>3];if(!(e>=0.0)){f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=f;j=f;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+224|0;p=o;h[p>>3]=m;i=b;return}else{g=d+96|0;j=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;k=+h[g>>3];l=e*k;m=-l;n=j;o=n+224|0;p=o;h[p>>3]=m;i=b;return}}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+592>>3]*+h[(c[b+416>>2]|0)+264>>3];k=+h[g+56>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,872,864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+416|0;p=o;h[p>>3]=m;i=d;return}function jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3]/.01604246+(+h[g+8>>3]/.01604246+(+h[g+16>>3]/.01604246+(+h[g+24>>3]/.01604246+(+h[g+32>>3]/.01604246+ +h[g+40>>3]/.01604246))));if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}q=+zr(c[b+536>>2]|0,j,944,936,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+56>>3]- +h[(c[a+416>>2]|0)+280>>3];i=i;return}function lf(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+320>>3];g=+h[e+312>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+368>>3];if(g!=0.0){m=k;n=l/g;o=f*n;p=m;q=p+376|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f*n;p=m;q=p+376|0;r=q;h[r>>3]=o;i=d;return}s=l/+zr(c[b+536>>2]|0,g,1160,1152,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f*n;p=m;q=p+376|0;r=q;h[r>>3]=o;i=d;return}function mf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+184|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+216|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+40|0;f=a;g=+h[e>>3];j=f;k=j+216|0;l=k;h[l>>3]=g;i=b;return}}function nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+176|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+208|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+32|0;f=a;g=+h[e>>3];j=f;k=j+208|0;l=k;h[l>>3]=g;i=b;return}}function of(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+168|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+200|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+24|0;f=a;g=+h[e>>3];j=f;k=j+200|0;l=k;h[l>>3]=g;i=b;return}}function pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+160|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+192|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+16|0;f=a;g=+h[e>>3];j=f;k=j+192|0;l=k;h[l>>3]=g;i=b;return}}function qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+152|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+184|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a+8|0;f=a;g=+h[e>>3];j=f;k=j+184|0;l=k;h[l>>3]=g;i=b;return}}function rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0,l=0;b=i;d=a+4|0;if((Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0){e=(c[a+416>>2]|0)+144|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[e>>3];j=f;k=j+176|0;l=k;h[l>>3]=g;i=b;return}else{a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=a;f=a;g=+h[e>>3];j=f;k=j+176|0;l=k;h[l>>3]=g;i=b;return}}function sf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+144|0}else{e=b}h[b+128>>3]=-(d*+h[e>>3]);i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=+h[b+128>>3]- +h[b+224>>3];i=i;return}function uf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+152|0}else{e=b+8|0}h[b+136>>3]=-(d*+h[e>>3]);i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+136>>3]- +h[b+232>>3];i=i;return}function wf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+160|0}else{e=b+16|0}h[b+144>>3]=-(d*+h[e>>3]);i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+144>>3]- +h[b+240>>3];i=i;return}function yf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+168|0}else{e=b+24|0}h[b+152>>3]=-(d*+h[e>>3]);i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=+h[b+152>>3]- +h[b+248>>3];i=i;return}function Af(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+176|0}else{e=b+32|0}h[b+160>>3]=-(d*+h[e>>3]);i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=+h[b+160>>3]- +h[b+256>>3];i=i;return}function Cf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+184|0}else{e=b+40|0}h[b+168>>3]=-(d*+h[e>>3]);i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=+h[b+168>>3]- +h[b+264>>3];i=i;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[(c[a+416>>2]|0)+256>>3]- +h[b+376>>3];i=i;return}function Ff(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+504>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,e,1192,1184,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+48>>3]+-273.15;i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function Jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0;b=i;i=i+56|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+4|0;l=c[(c[c[j>>2]>>2]|0)+8>>2]|0;m=+h[l>>3];n=+h[l+16>>3];o=+h[l+24>>3];p=+h[l+32>>3];q=+h[l+40>>3];r=e;h[k>>3]=+h[l+8>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+8|0;h[k>>3]=n;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+16|0;h[k>>3]=o;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+24|0;h[k>>3]=p;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+32|0;h[k>>3]=q;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ns(f,6,m,e);e=c[a+536>>2]|0;m=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+48>>3];a=d;r=f;c[a+0>>2]=c[r+0>>2];c[a+4>>2]=c[r+4>>2];c[a+8>>2]=c[r+8>>2];Pg(g,e,m,d,1,1,0.0);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+488>>3]=+h[g>>3];i=b;return}function Kf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(Au(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+376>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+392>>3]=+h[(a?e+576|0:e+488|0)>>3];i=b;return}function Lf(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+256>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+400>>3]=-(b*+h[(!(b>=0.0)?d+488|0:d+600|0)>>3]);i=i;return}function Mf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+376>>3];h[b+384>>3]=-(d*+h[(!(d>=0.0)?b+576|0:b+488|0)>>3]);i=i;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+384>>3]- +h[b+400>>3];i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=(+h[b>>3]+(+h[b+8>>3]+(+h[b+16>>3]+(+h[b+24>>3]+(+h[b+32>>3]+ +h[b+40>>3])))))*518.2791167938085;i=i;return}function Pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+48>>3]*+h[g+464>>3];k=+h[g+56>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1216,1208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[(c[a+416>>2]|0)+216>>3]*+h[b+480>>3];i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b>>3]*+h[b+424>>3];i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+8>>3]*+h[b+424>>3];i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+16>>3]*+h[b+424>>3];i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+24>>3]*+h[b+424>>3];i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b+32>>3]*+h[b+424>>3];i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+40>>3]*+h[b+424>>3];i=i;return}function Xf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+360>>3]- +h[g+40>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+104|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+104|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+104|0;p=o;h[p>>3]=m;i=d;return}function Yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+352>>3]- +h[g+32>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+96|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+96|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+96|0;p=o;h[p>>3]=m;i=d;return}function Zf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+344>>3]- +h[g+24>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1288,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}function _f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+336>>3]- +h[g+16>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+80|0;p=o;h[p>>3]=m;i=d;return}function $f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+328>>3]- +h[g+8>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1304,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}function ag(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+320>>3]- +h[g>>3]*+h[g+504>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1312,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+64|0;p=o;h[p>>3]=m;i=d;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=(+h[b+64>>3]+(+h[b+72>>3]+(+h[b+80>>3]+(+h[b+88>>3]+(+h[b+96>>3]+ +h[b+104>>3])))))*518.2791167938085;i=i;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+488>>3]- +h[b+464>>3]*+h[b+48>>3];i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[b+424>>3]*+h[b+472>>3];i=i;return}function eg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=+h[g+496>>3]- +h[g+504>>3]*+h[g+472>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}q=k/+zr(c[b+536>>2]|0,j,1264,1320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}function fg(a){a=a|0;var b=0,d=0,e=0;b=i;Nu(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+112>>3]=+h[d>>3];h[e+520>>3]=+h[d+8>>3];i=b;return}function gg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+120>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+120|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+Zu(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+120>>3]);h[c[(c[f>>2]|0)+52>>2]>>3]=k;Xu(a,0)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+120>>3]=+h[c[(c[f>>2]|0)+44>>2]>>3];i=b;return}function hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],200.0)|0;if(!(g<<24>>24==0|(zu(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],6.0e3)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(1328,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],0,1,6)|0)|0,1352)|0,1448)|0,1472)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1568,Vr(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,1592)|0,1608)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function jg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1736,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,1592)|0,1760)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function kg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1768,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,1592)|0,1792)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function lg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1800,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,1592)|0,1824)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1840,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,1592)|0,1864)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function ng(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1880,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,1592)|0,1904)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function og(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(1920,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0,1,6)|0)|0,1936)|0,1448)|0,1960)|0;j=Xr(Xr(g,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+48>>3],0,1,6)|0)|0,1992)|0;f=c[a+536>>2]|0;a=c[20226]|0;g=d;k=2048;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];He[a&31](f,d,j,e);i=b;return}function pg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+264>>3],200.0)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+264>>3],6.0e3)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(1328,Vr(+h[(c[f>>2]|0)+264>>3],0,1,6)|0)|0,1352)|0,1448)|0,1472)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function qg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+96>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+96>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1568,Vr(+h[(c[f>>2]|0)+96>>3],0,1,6)|0)|0,1592)|0,1608)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function rg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+104>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+104>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1736,Vr(+h[(c[f>>2]|0)+104>>3],0,1,6)|0)|0,1592)|0,1760)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+112>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+112>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1768,Vr(+h[(c[f>>2]|0)+112>>3],0,1,6)|0)|0,1592)|0,1792)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function tg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+120>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+120>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1800,Vr(+h[(c[f>>2]|0)+120>>3],0,1,6)|0)|0,1592)|0,1824)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+128>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+128>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1840,Vr(+h[(c[f>>2]|0)+128>>3],0,1,6)|0)|0,1592)|0,1864)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function vg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+136>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+136>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1880,Vr(+h[(c[f>>2]|0)+136>>3],0,1,6)|0)|0,1592)|0,1904)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function wg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((Au(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(1920,Vr(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0,1,6)|0)|0,1936)|0,1448)|0,1960)|0;f=Xr(Xr(g,Vr(+h[(c[a+416>>2]|0)+264>>3],0,1,6)|0)|0,1992)|0;g=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](g,d,f,e);i=b;return}function xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+296>>3],200.0)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+296>>3],6.0e3)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(1328,Vr(+h[(c[f>>2]|0)+296>>3],0,1,6)|0)|0,1352)|0,1448)|0,1472)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+144>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+144>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1568,Vr(+h[(c[f>>2]|0)+144>>3],0,1,6)|0)|0,1592)|0,1608)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function zg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+152>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+152>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1736,Vr(+h[(c[f>>2]|0)+152>>3],0,1,6)|0)|0,1592)|0,1760)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function Ag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+160>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+160>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1768,Vr(+h[(c[f>>2]|0)+160>>3],0,1,6)|0)|0,1592)|0,1792)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function Bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+168>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+168>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1800,Vr(+h[(c[f>>2]|0)+168>>3],0,1,6)|0)|0,1592)|0,1824)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function Cg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+176>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+176>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1840,Vr(+h[(c[f>>2]|0)+176>>3],0,1,6)|0)|0,1592)|0,1864)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function Dg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=Au(+h[(c[f>>2]|0)+184>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(zu(+h[(c[f>>2]|0)+184>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(Xr(Xr(1880,Vr(+h[(c[f>>2]|0)+184>>3],0,1,6)|0)|0,1592)|0,1904)|0,1616)|0,1448)|0,1632)|0;f=c[a+536>>2]|0;a=c[20226]|0;j=d;k=2024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[a&31](f,d,g,e);i=b;return}function Eg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((Au(+h[(c[f>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=b;return}g=Xr(Xr(Xr(Xr(1920,Vr(+h[(c[f>>2]|0)+280>>3],0,1,6)|0)|0,1936)|0,1448)|0,1960)|0;j=Xr(Xr(g,Vr(+h[(c[f>>2]|0)+296>>3],0,1,6)|0)|0,1992)|0;f=c[a+536>>2]|0;a=c[20226]|0;g=d;k=2048;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];He[a&31](f,d,j,e);i=b;return}function Fg(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);i=c;return 0}function Gg(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Hg(b);i=c;return 0}function Hg(a){a=a|0;var b=0;b=i;bf(a);cf(a);df(a);ef(a);ff(a);gf(a);kf(a);lf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Jf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);eg(a);fg(a);gg(a);i=b;return}function Ig(a,b){a=a|0;b=+b;i=i;return 0}function Jg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;wr(c[a+536>>2]|0,(a|0)!=0|0,2280,b);c[a+540>>2]=2088;c[a+84>>2]=2312;c[a+88>>2]=2312;c[a+92>>2]=2392;c[a+96>>2]=2456;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=8;c[a+116>>2]=80;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=41;c[a+140>>2]=0;c[a+144>>2]=11;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=117;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;c[a+176>>2]=8;c[a+180>>2]=0;c[a+184>>2]=8;c[a+188>>2]=0;c[a+56>>2]=2496;c[a+64>>2]=20;c[a+72>>2]=0;c[a+68>>2]=327;c[a+192>>2]=0;c[a+196>>2]=2;c[a+200>>2]=1;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Kg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=DW(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=32744;F=32768;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[8186]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=DW(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[7514]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=DW(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(48,c[7514]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=DW(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;pW(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=DW(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;pW(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=DW(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(48,c[7514]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=DW(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=DW(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=DW(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,2584,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=DW(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=DW(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=DW(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=DW(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=DW(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=DW(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(48,c[7514]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=DW(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=DW(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=DW(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=DW(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function Lg(){var a=0;a=i;td(0)|0;qc(2744,18,1,c[r>>2]|0)|0;td(0)|0;i=a;return}function Mg(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;l=i;i=i+616|0;m=l;n=l+96|0;o=l+192|0;p=l+288|0;q=l+384|0;r=l+480|0;s=l+576|0;t=i;i=i+8|0;u=i;i=i+48|0;v=i;i=i+8|0;w=i;i=i+48|0;x=i;i=i+8|0;y=i;i=i+48|0;z=i;i=i+8|0;A=i;i=i+48|0;B=i;i=i+8|0;C=i;i=i+48|0;D=i;i=i+8|0;E=i;i=i+48|0;F=i;i=i+8|0;G=i;i=i+48|0;H=i;i=i+8|0;I=i;i=i+48|0;J=i;i=i+8|0;K=i;i=i+48|0;L=i;i=i+8|0;M=i;i=i+48|0;N=i;i=i+8|0;O=i;i=i+48|0;P=i;i=i+8|0;Q=i;i=i+48|0;R=i;i=i+16|0;S=i;i=i+96|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+96|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+96|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+96|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+96|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+96|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=Q;h[k>>3]=2786.18102;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+8|0;h[k>>3]=-12.0257785;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+16|0;h[k>>3]=.0391761929;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+24|0;h[k>>3]=-361905443.0e-13;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+32|0;h[k>>3]=2.026853043e-8;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+40|0;h[k>>3]=-4.976705489999999e-12;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];ns(T,7,-176685.0998,Q);Q=P;h[k>>3]=89.0432275;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];ns(U,2,-23313.1436,P);P=O;h[k>>3]=-13835.01485;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=20.49107091;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+16|0;h[k>>3]=-.001961974759;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+24|0;h[k>>3]=4.72731304e-7;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+32|0;h[k>>3]=-3.72881469e-11;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+40|0;h[k>>3]=1.623737207e-15;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];ns(V,7,3730042.76,O);O=N;h[k>>3]=-121.9124889;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];ns(W,2,75320.6691,N);c[S>>2]=2768;h[S+8>>3]=.01604246;h[S+16>>3]=-4650159.63885838;h[S+24>>3]=624355.7409524474;h[S+32>>3]=1.0e3;N=S+40|0;O=T;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];O=S+52|0;N=U;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];N=S+64|0;O=V;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];O=S+76|0;N=W;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];h[S+88>>3]=518.2791167938085;N=r+0|0;O=S+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(ua,b,r,d,f,g,j);Ba=+h[ua>>3];ua=M;h[k>>3]=3406.19186;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+8|0;h[k>>3]=-19.51705092;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+16|0;h[k>>3]=.0756583559;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+24|0;h[k>>3]=-820417322.0e-13;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+32|0;h[k>>3]=5.0611358e-8;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+40|0;h[k>>3]=-1.319281992e-11;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ns(Y,7,-186204.4161,M);M=L;h[k>>3]=129.8140496;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];ns(Z,2,-27029.3289,L);L=K;h[k>>3]=-20330.22397;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+8|0;h[k>>3]=33.2255293;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+16|0;h[k>>3]=-.00383670341;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+24|0;h[k>>3]=7.23840586e-7;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+32|0;h[k>>3]=-7.3191825e-11;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+40|0;h[k>>3]=3.065468699e-15;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];ns(_,7,5025782.13,K);K=J;h[k>>3]=-203.9410584;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];ns($,2,111596.395,J);c[X>>2]=2776;h[X+8>>3]=.03006904;h[X+16>>3]=-2788633.890539904;h[X+24>>3]=395476.3437741943;h[X+32>>3]=1.0e3;J=X+40|0;K=Y;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];K=X+52|0;J=Z;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];J=X+64|0;K=_;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];K=X+76|0;J=$;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];h[X+88>>3]=276.5127187299628;N=q+0|0;O=X+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(va,b,q,d,f,g,j);Ca=+h[va>>3];va=I;h[k>>3]=4656.27081;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+8|0;h[k>>3]=-29.39466091;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+16|0;h[k>>3]=.1188952745;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+24|0;h[k>>3]=-.0001376308269;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+32|0;h[k>>3]=8.814823909999999e-8;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+40|0;h[k>>3]=-2.342987994e-11;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];ns(ba,7,-243314.4337,I);I=H;h[k>>3]=184.1749277;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];ns(ca,2,-35403.3527,H);H=G;h[k>>3]=-26597.91134;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+8|0;h[k>>3]=45.3435684;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+16|0;h[k>>3]=-.00502066392;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+24|0;h[k>>3]=9.471216939999999e-7;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+32|0;h[k>>3]=-9.57540523e-11;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+40|0;h[k>>3]=4.00967288e-15;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];ns(da,7,6420731.680000001,G);G=F;h[k>>3]=-281.8374734;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];ns(ea,2,145558.2459,F);c[aa>>2]=2784;h[aa+8>>3]=.04409562;h[aa+16>>3]=-2373931.923397381;h[aa+24>>3]=334301.1845620949;h[aa+32>>3]=1.0e3;F=aa+40|0;G=ba;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];G=aa+52|0;F=ca;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];F=aa+64|0;G=da;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];G=aa+76|0;F=ea;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];h[aa+88>>3]=188.5555073270316;N=p+0|0;O=aa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(wa,b,p,d,f,g,j);Da=+h[wa>>3];wa=E;h[k>>3]=6176.331819999999;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+8|0;h[k>>3]=-38.9156212;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+16|0;h[k>>3]=.1584654284;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+24|0;h[k>>3]=-.0001860050159;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+32|0;h[k>>3]=1.199676349e-7;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+40|0;h[k>>3]=-3.20167055e-11;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];ns(ga,7,-317587.254,E);E=D;h[k>>3]=237.9488665;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ns(ha,2,-45403.63390000001,D);D=C;h[k>>3]=-32560.5151;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=57.3673275;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+16|0;h[k>>3]=-.00619791681;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+24|0;h[k>>3]=1180186048.0e-15;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+32|0;h[k>>3]=-1.221893698e-10;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+40|0;h[k>>3]=5.250635250000001e-15;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ns(ia,7,7682322.45,C);C=B;h[k>>3]=-358.791876;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];ns(ja,2,177452.656,B);c[fa>>2]=2792;h[fa+8>>3]=.0581222;h[fa+16>>3]=-2164233.28779709;h[fa+24>>3]=330832.0228759407;h[fa+32>>3]=1.0e3;B=fa+40|0;C=ga;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];C=fa+52|0;B=ha;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];B=fa+64|0;C=ia;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];C=fa+76|0;B=ja;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];h[fa+88>>3]=143.0515706563069;N=o+0|0;O=fa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(xa,b,o,d,f,g,j);Ea=+h[xa>>3];xa=A;h[k>>3]=-381.846182;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+8|0;h[k>>3]=6.08273836;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+16|0;h[k>>3]=-.00853091441;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+24|0;h[k>>3]=1384646189.0e-14;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+32|0;h[k>>3]=-9.62579362e-9;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+40|0;h[k>>3]=2.519705809e-12;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];ns(la,7,22103.71497,A);A=z;h[k>>3]=-10.76003744;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];ns(ma,2,710.846086,z);z=y;h[k>>3]=-2239.249073;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=6.06694922;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=-.00061396855;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+24|0;h[k>>3]=1.491806679e-7;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+32|0;h[k>>3]=-1.923105485e-11;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+40|0;h[k>>3]=1.061954386e-15;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ns(na,7,587712.406,y);y=x;h[k>>3]=-15.86640027;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ns(oa,2,12832.10415,x);c[ka>>2]=2808;h[ka+8>>3]=.0280134;h[ka+16>>3]=0.0;h[ka+24>>3]=309498.4543111511;h[ka+32>>3]=1.0e3;x=ka+40|0;y=la;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=ka+52|0;x=ma;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];x=ka+64|0;y=na;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=ka+76|0;x=oa;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];h[ka+88>>3]=296.8033869505308;N=n+0|0;O=ka+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(ya,b,n,d,f,g,j);Fa=+h[ya>>3];ya=w;h[k>>3]=-626.411601;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+8|0;h[k>>3]=5.30172524;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+16|0;h[k>>3]=.002503813816;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+24|0;h[k>>3]=-2.127308728e-7;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+32|0;h[k>>3]=-7.68998878e-10;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+40|0;h[k>>3]=2.849677801e-13;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ns(qa,7,49436.5054,w);w=v;h[k>>3]=-7.04827944;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ns(ra,2,-45281.9846,v);v=u;h[k>>3]=-1788.791477;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+8|0;h[k>>3]=8.29152319;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+16|0;h[k>>3]=-922315678.0e-13;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+24|0;h[k>>3]=4.86367688e-9;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+32|0;h[k>>3]=-1.891053312e-12;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+40|0;h[k>>3]=6.330036589999999e-16;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ns(sa,7,117696.2419,u);u=t;h[k>>3]=-26.52669281;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];ns(ta,2,-39083.5059,t);c[pa>>2]=2816;h[pa+8>>3]=.0440095;h[pa+16>>3]=-8941478.544405185;h[pa+24>>3]=212805.6215135368;h[pa+32>>3]=1.0e3;t=pa+40|0;u=qa;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=pa+52|0;t=ra;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];t=pa+64|0;u=sa;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=pa+76|0;t=ta;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];h[pa+88>>3]=188.9244822140674;N=m+0|0;O=pa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(za,b,m,d,f,g,j);j=+h[za>>3];za=s;h[k>>3]=Ca;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+8|0;h[k>>3]=Da;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+16|0;h[k>>3]=Ea;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+24|0;h[k>>3]=Fa;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+32|0;h[k>>3]=j;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];ns(R,6,Ba,s);h[a>>3]=+ps(e,R);i=l;return}function Ng(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0,$=0;l=i;i=i+56|0;m=l;n=l+24|0;o=l+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=e>0.0;if(+h[d+32>>3]>e){if(!G){H=c[20226]|0;I=F;h[k>>3]=e;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];I=H;H=n;J=2888;c[H+0>>2]=c[J+0>>2];c[H+4>>2]=c[J+4>>2];c[H+8>>2]=c[J+8>>2];c[H+12>>2]=c[J+12>>2];c[H+16>>2]=c[J+16>>2];c[H+20>>2]=c[J+20>>2];He[I&31](b,n,2832,F);}K=+h[d+88>>3];c[E>>2]=1;L=+h[(os(d+52|0,1,E)|0)>>3];E=d+40|0;c[D>>2]=2;M=+h[(os(E,1,D)|0)>>3]*+da(+e);c[C>>2]=3;N=+h[(os(E,1,C)|0)>>3];c[B>>2]=4;O=+h[(os(E,1,B)|0)>>3]*.5;c[A>>2]=5;P=+h[(os(E,1,A)|0)>>3]*.3333333333333333;c[z>>2]=6;Q=+h[(os(E,1,z)|0)>>3]*.25;c[y>>2]=7;R=(L+(M+(N+(O+(P+(Q+ +h[(os(E,1,y)|0)>>3]*e*.2)*e)*e)*e)*e))*e;c[x>>2]=1;S=K*((R- +h[(os(E,1,x)|0)>>3])/e)}else{if(!G){G=c[20226]|0;x=w;h[k>>3]=e;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=G;G=m;E=2888;c[G+0>>2]=c[E+0>>2];c[G+4>>2]=c[E+4>>2];c[G+8>>2]=c[E+8>>2];c[G+12>>2]=c[E+12>>2];c[G+16>>2]=c[E+16>>2];c[G+20>>2]=c[E+20>>2];He[x&31](b,m,2832,w);}R=+h[d+88>>3];c[v>>2]=1;K=+h[(os(d+76|0,1,v)|0)>>3];v=d+64|0;c[u>>2]=2;Q=+h[(os(v,1,u)|0)>>3]*+da(+e);c[t>>2]=3;P=+h[(os(v,1,t)|0)>>3];c[s>>2]=4;O=+h[(os(v,1,s)|0)>>3]*.5;c[r>>2]=5;N=+h[(os(v,1,r)|0)>>3]*.3333333333333333;c[q>>2]=6;M=+h[(os(v,1,q)|0)>>3]*.25;c[p>>2]=7;L=(K+(Q+(P+(O+(N+(M+ +h[(os(v,1,p)|0)>>3]*e*.2)*e)*e)*e)*e))*e;c[o>>2]=1;S=R*((L- +h[(os(v,1,o)|0)>>3])/e)}if(f<<24>>24==0){T=0.0}else{T=-+h[d+16>>3]}if((g|0)!=1){U=0.0;V=(g|0)==3;W=V?j:0.0;X=W+U;Y=T+X;Z=S+Y;_=a;$=_;h[$>>3]=Z;i=l;return}U=+h[d+24>>3];V=(g|0)==3;W=V?j:0.0;X=W+U;Y=T+X;Z=S+Y;_=a;$=_;h[$>>3]=Z;i=l;return}function Og(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;l=i;i=i+616|0;m=l;n=l+96|0;o=l+192|0;p=l+288|0;q=l+384|0;r=l+480|0;s=l+576|0;t=i;i=i+8|0;u=i;i=i+48|0;v=i;i=i+8|0;w=i;i=i+48|0;x=i;i=i+8|0;y=i;i=i+48|0;z=i;i=i+8|0;A=i;i=i+48|0;B=i;i=i+8|0;C=i;i=i+48|0;D=i;i=i+8|0;E=i;i=i+48|0;F=i;i=i+8|0;G=i;i=i+48|0;H=i;i=i+8|0;I=i;i=i+48|0;J=i;i=i+8|0;K=i;i=i+48|0;L=i;i=i+8|0;M=i;i=i+48|0;N=i;i=i+8|0;O=i;i=i+48|0;P=i;i=i+8|0;Q=i;i=i+48|0;R=i;i=i+16|0;S=i;i=i+96|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+96|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+96|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+96|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+96|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+96|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=Q;h[k>>3]=2786.18102;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+8|0;h[k>>3]=-12.0257785;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+16|0;h[k>>3]=.0391761929;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+24|0;h[k>>3]=-361905443.0e-13;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+32|0;h[k>>3]=2.026853043e-8;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+40|0;h[k>>3]=-4.976705489999999e-12;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];ns(T,7,-176685.0998,Q);Q=P;h[k>>3]=89.0432275;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];ns(U,2,-23313.1436,P);P=O;h[k>>3]=-13835.01485;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=20.49107091;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+16|0;h[k>>3]=-.001961974759;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+24|0;h[k>>3]=4.72731304e-7;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+32|0;h[k>>3]=-3.72881469e-11;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+40|0;h[k>>3]=1.623737207e-15;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];ns(V,7,3730042.76,O);O=N;h[k>>3]=-121.9124889;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];ns(W,2,75320.6691,N);c[S>>2]=2768;h[S+8>>3]=.01604246;h[S+16>>3]=-4650159.63885838;h[S+24>>3]=624355.7409524474;h[S+32>>3]=1.0e3;N=S+40|0;O=T;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];O=S+52|0;N=U;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];N=S+64|0;O=V;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];O=S+76|0;N=W;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];h[S+88>>3]=518.2791167938085;N=r+0|0;O=S+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(ua,b,r,d,f,g,j);Ba=+h[ua>>3];ua=M;h[k>>3]=3406.19186;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+8|0;h[k>>3]=-19.51705092;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+16|0;h[k>>3]=.0756583559;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+24|0;h[k>>3]=-820417322.0e-13;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+32|0;h[k>>3]=5.0611358e-8;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+40|0;h[k>>3]=-1.319281992e-11;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ns(Y,7,-186204.4161,M);M=L;h[k>>3]=129.8140496;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];ns(Z,2,-27029.3289,L);L=K;h[k>>3]=-20330.22397;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+8|0;h[k>>3]=33.2255293;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+16|0;h[k>>3]=-.00383670341;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+24|0;h[k>>3]=7.23840586e-7;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+32|0;h[k>>3]=-7.3191825e-11;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+40|0;h[k>>3]=3.065468699e-15;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];ns(_,7,5025782.13,K);K=J;h[k>>3]=-203.9410584;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];ns($,2,111596.395,J);c[X>>2]=2776;h[X+8>>3]=.03006904;h[X+16>>3]=-2788633.890539904;h[X+24>>3]=395476.3437741943;h[X+32>>3]=1.0e3;J=X+40|0;K=Y;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];K=X+52|0;J=Z;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];J=X+64|0;K=_;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];K=X+76|0;J=$;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];h[X+88>>3]=276.5127187299628;N=q+0|0;O=X+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(va,b,q,d,f,g,j);Ca=+h[va>>3];va=I;h[k>>3]=4656.27081;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+8|0;h[k>>3]=-29.39466091;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+16|0;h[k>>3]=.1188952745;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+24|0;h[k>>3]=-.0001376308269;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+32|0;h[k>>3]=8.814823909999999e-8;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+40|0;h[k>>3]=-2.342987994e-11;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];ns(ba,7,-243314.4337,I);I=H;h[k>>3]=184.1749277;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];ns(ca,2,-35403.3527,H);H=G;h[k>>3]=-26597.91134;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+8|0;h[k>>3]=45.3435684;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+16|0;h[k>>3]=-.00502066392;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+24|0;h[k>>3]=9.471216939999999e-7;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+32|0;h[k>>3]=-9.57540523e-11;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+40|0;h[k>>3]=4.00967288e-15;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];ns(da,7,6420731.680000001,G);G=F;h[k>>3]=-281.8374734;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];ns(ea,2,145558.2459,F);c[aa>>2]=2784;h[aa+8>>3]=.04409562;h[aa+16>>3]=-2373931.923397381;h[aa+24>>3]=334301.1845620949;h[aa+32>>3]=1.0e3;F=aa+40|0;G=ba;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];G=aa+52|0;F=ca;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];F=aa+64|0;G=da;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];G=aa+76|0;F=ea;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];h[aa+88>>3]=188.5555073270316;N=p+0|0;O=aa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(wa,b,p,d,f,g,j);Da=+h[wa>>3];wa=E;h[k>>3]=6176.331819999999;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+8|0;h[k>>3]=-38.9156212;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+16|0;h[k>>3]=.1584654284;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+24|0;h[k>>3]=-.0001860050159;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+32|0;h[k>>3]=1.199676349e-7;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+40|0;h[k>>3]=-3.20167055e-11;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];ns(ga,7,-317587.254,E);E=D;h[k>>3]=237.9488665;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ns(ha,2,-45403.63390000001,D);D=C;h[k>>3]=-32560.5151;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=57.3673275;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+16|0;h[k>>3]=-.00619791681;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+24|0;h[k>>3]=1180186048.0e-15;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+32|0;h[k>>3]=-1.221893698e-10;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+40|0;h[k>>3]=5.250635250000001e-15;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ns(ia,7,7682322.45,C);C=B;h[k>>3]=-358.791876;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];ns(ja,2,177452.656,B);c[fa>>2]=2792;h[fa+8>>3]=.0581222;h[fa+16>>3]=-2164233.28779709;h[fa+24>>3]=330832.0228759407;h[fa+32>>3]=1.0e3;B=fa+40|0;C=ga;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];C=fa+52|0;B=ha;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];B=fa+64|0;C=ia;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];C=fa+76|0;B=ja;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];h[fa+88>>3]=143.0515706563069;N=o+0|0;O=fa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(xa,b,o,d,f,g,j);Ea=+h[xa>>3];xa=A;h[k>>3]=-381.846182;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+8|0;h[k>>3]=6.08273836;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+16|0;h[k>>3]=-.00853091441;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+24|0;h[k>>3]=1384646189.0e-14;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+32|0;h[k>>3]=-9.62579362e-9;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+40|0;h[k>>3]=2.519705809e-12;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];ns(la,7,22103.71497,A);A=z;h[k>>3]=-10.76003744;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];ns(ma,2,710.846086,z);z=y;h[k>>3]=-2239.249073;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=6.06694922;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=-.00061396855;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+24|0;h[k>>3]=1.491806679e-7;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+32|0;h[k>>3]=-1.923105485e-11;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+40|0;h[k>>3]=1.061954386e-15;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ns(na,7,587712.406,y);y=x;h[k>>3]=-15.86640027;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ns(oa,2,12832.10415,x);c[ka>>2]=2808;h[ka+8>>3]=.0280134;h[ka+16>>3]=0.0;h[ka+24>>3]=309498.4543111511;h[ka+32>>3]=1.0e3;x=ka+40|0;y=la;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=ka+52|0;x=ma;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];x=ka+64|0;y=na;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=ka+76|0;x=oa;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];h[ka+88>>3]=296.8033869505308;N=n+0|0;O=ka+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(ya,b,n,d,f,g,j);Fa=+h[ya>>3];ya=w;h[k>>3]=-626.411601;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+8|0;h[k>>3]=5.30172524;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+16|0;h[k>>3]=.002503813816;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+24|0;h[k>>3]=-2.127308728e-7;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+32|0;h[k>>3]=-7.68998878e-10;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+40|0;h[k>>3]=2.849677801e-13;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ns(qa,7,49436.5054,w);w=v;h[k>>3]=-7.04827944;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ns(ra,2,-45281.9846,v);v=u;h[k>>3]=-1788.791477;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+8|0;h[k>>3]=8.29152319;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+16|0;h[k>>3]=-922315678.0e-13;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+24|0;h[k>>3]=4.86367688e-9;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+32|0;h[k>>3]=-1.891053312e-12;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+40|0;h[k>>3]=6.330036589999999e-16;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ns(sa,7,117696.2419,u);u=t;h[k>>3]=-26.52669281;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];ns(ta,2,-39083.5059,t);c[pa>>2]=2816;h[pa+8>>3]=.0440095;h[pa+16>>3]=-8941478.544405185;h[pa+24>>3]=212805.6215135368;h[pa+32>>3]=1.0e3;t=pa+40|0;u=qa;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=pa+52|0;t=ra;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];t=pa+64|0;u=sa;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=pa+76|0;t=ta;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];h[pa+88>>3]=188.9244822140674;N=m+0|0;O=pa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(za,b,m,d,f,g,j);j=+h[za>>3];za=s;h[k>>3]=Ca;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+8|0;h[k>>3]=Da;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+16|0;h[k>>3]=Ea;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+24|0;h[k>>3]=Fa;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+32|0;h[k>>3]=j;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];ns(R,6,Ba,s);h[a>>3]=+ps(e,R);i=l;return}function Pg(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;l=i;i=i+616|0;m=l;n=l+96|0;o=l+192|0;p=l+288|0;q=l+384|0;r=l+480|0;s=l+576|0;t=i;i=i+8|0;u=i;i=i+48|0;v=i;i=i+8|0;w=i;i=i+48|0;x=i;i=i+8|0;y=i;i=i+48|0;z=i;i=i+8|0;A=i;i=i+48|0;B=i;i=i+8|0;C=i;i=i+48|0;D=i;i=i+8|0;E=i;i=i+48|0;F=i;i=i+8|0;G=i;i=i+48|0;H=i;i=i+8|0;I=i;i=i+48|0;J=i;i=i+8|0;K=i;i=i+48|0;L=i;i=i+8|0;M=i;i=i+48|0;N=i;i=i+8|0;O=i;i=i+48|0;P=i;i=i+8|0;Q=i;i=i+48|0;R=i;i=i+16|0;S=i;i=i+96|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+96|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+96|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+96|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+96|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+96|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=Q;h[k>>3]=2786.18102;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+8|0;h[k>>3]=-12.0257785;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+16|0;h[k>>3]=.0391761929;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+24|0;h[k>>3]=-361905443.0e-13;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+32|0;h[k>>3]=2.026853043e-8;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];Aa=Q+40|0;h[k>>3]=-4.976705489999999e-12;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];ns(T,7,-176685.0998,Q);Q=P;h[k>>3]=89.0432275;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];ns(U,2,-23313.1436,P);P=O;h[k>>3]=-13835.01485;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=20.49107091;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+16|0;h[k>>3]=-.001961974759;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+24|0;h[k>>3]=4.72731304e-7;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+32|0;h[k>>3]=-3.72881469e-11;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+40|0;h[k>>3]=1.623737207e-15;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];ns(V,7,3730042.76,O);O=N;h[k>>3]=-121.9124889;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];ns(W,2,75320.6691,N);c[S>>2]=2768;h[S+8>>3]=.01604246;h[S+16>>3]=-4650159.63885838;h[S+24>>3]=624355.7409524474;h[S+32>>3]=1.0e3;N=S+40|0;O=T;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];O=S+52|0;N=U;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];N=S+64|0;O=V;c[N+0>>2]=c[O+0>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];O=S+76|0;N=W;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];h[S+88>>3]=518.2791167938085;N=r+0|0;O=S+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(ua,b,r,d,f,g,j);Ba=+h[ua>>3];ua=M;h[k>>3]=3406.19186;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+8|0;h[k>>3]=-19.51705092;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+16|0;h[k>>3]=.0756583559;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+24|0;h[k>>3]=-820417322.0e-13;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+32|0;h[k>>3]=5.0611358e-8;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ua=M+40|0;h[k>>3]=-1.319281992e-11;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];ns(Y,7,-186204.4161,M);M=L;h[k>>3]=129.8140496;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];ns(Z,2,-27029.3289,L);L=K;h[k>>3]=-20330.22397;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+8|0;h[k>>3]=33.2255293;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+16|0;h[k>>3]=-.00383670341;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+24|0;h[k>>3]=7.23840586e-7;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+32|0;h[k>>3]=-7.3191825e-11;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=K+40|0;h[k>>3]=3.065468699e-15;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];ns(_,7,5025782.13,K);K=J;h[k>>3]=-203.9410584;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];ns($,2,111596.395,J);c[X>>2]=2776;h[X+8>>3]=.03006904;h[X+16>>3]=-2788633.890539904;h[X+24>>3]=395476.3437741943;h[X+32>>3]=1.0e3;J=X+40|0;K=Y;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];K=X+52|0;J=Z;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];J=X+64|0;K=_;c[J+0>>2]=c[K+0>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];K=X+76|0;J=$;c[K+0>>2]=c[J+0>>2];c[K+4>>2]=c[J+4>>2];c[K+8>>2]=c[J+8>>2];h[X+88>>3]=276.5127187299628;N=q+0|0;O=X+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(va,b,q,d,f,g,j);Ca=+h[va>>3];va=I;h[k>>3]=4656.27081;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+8|0;h[k>>3]=-29.39466091;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+16|0;h[k>>3]=.1188952745;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+24|0;h[k>>3]=-.0001376308269;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+32|0;h[k>>3]=8.814823909999999e-8;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];va=I+40|0;h[k>>3]=-2.342987994e-11;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];ns(ba,7,-243314.4337,I);I=H;h[k>>3]=184.1749277;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];ns(ca,2,-35403.3527,H);H=G;h[k>>3]=-26597.91134;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+8|0;h[k>>3]=45.3435684;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+16|0;h[k>>3]=-.00502066392;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+24|0;h[k>>3]=9.471216939999999e-7;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+32|0;h[k>>3]=-9.57540523e-11;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G+40|0;h[k>>3]=4.00967288e-15;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];ns(da,7,6420731.680000001,G);G=F;h[k>>3]=-281.8374734;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];ns(ea,2,145558.2459,F);c[aa>>2]=2784;h[aa+8>>3]=.04409562;h[aa+16>>3]=-2373931.923397381;h[aa+24>>3]=334301.1845620949;h[aa+32>>3]=1.0e3;F=aa+40|0;G=ba;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];G=aa+52|0;F=ca;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];F=aa+64|0;G=da;c[F+0>>2]=c[G+0>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];G=aa+76|0;F=ea;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];h[aa+88>>3]=188.5555073270316;N=p+0|0;O=aa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(wa,b,p,d,f,g,j);Da=+h[wa>>3];wa=E;h[k>>3]=6176.331819999999;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+8|0;h[k>>3]=-38.9156212;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+16|0;h[k>>3]=.1584654284;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+24|0;h[k>>3]=-.0001860050159;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+32|0;h[k>>3]=1.199676349e-7;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];wa=E+40|0;h[k>>3]=-3.20167055e-11;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];ns(ga,7,-317587.254,E);E=D;h[k>>3]=237.9488665;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];ns(ha,2,-45403.63390000001,D);D=C;h[k>>3]=-32560.5151;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=57.3673275;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+16|0;h[k>>3]=-.00619791681;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+24|0;h[k>>3]=1180186048.0e-15;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+32|0;h[k>>3]=-1.221893698e-10;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+40|0;h[k>>3]=5.250635250000001e-15;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ns(ia,7,7682322.45,C);C=B;h[k>>3]=-358.791876;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];ns(ja,2,177452.656,B);c[fa>>2]=2792;h[fa+8>>3]=.0581222;h[fa+16>>3]=-2164233.28779709;h[fa+24>>3]=330832.0228759407;h[fa+32>>3]=1.0e3;B=fa+40|0;C=ga;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];C=fa+52|0;B=ha;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];B=fa+64|0;C=ia;c[B+0>>2]=c[C+0>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];C=fa+76|0;B=ja;c[C+0>>2]=c[B+0>>2];c[C+4>>2]=c[B+4>>2];c[C+8>>2]=c[B+8>>2];h[fa+88>>3]=143.0515706563069;N=o+0|0;O=fa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(xa,b,o,d,f,g,j);Ea=+h[xa>>3];xa=A;h[k>>3]=-381.846182;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+8|0;h[k>>3]=6.08273836;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+16|0;h[k>>3]=-.00853091441;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+24|0;h[k>>3]=1384646189.0e-14;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+32|0;h[k>>3]=-9.62579362e-9;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];xa=A+40|0;h[k>>3]=2.519705809e-12;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];ns(la,7,22103.71497,A);A=z;h[k>>3]=-10.76003744;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];ns(ma,2,710.846086,z);z=y;h[k>>3]=-2239.249073;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=6.06694922;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=-.00061396855;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+24|0;h[k>>3]=1.491806679e-7;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+32|0;h[k>>3]=-1.923105485e-11;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+40|0;h[k>>3]=1.061954386e-15;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ns(na,7,587712.406,y);y=x;h[k>>3]=-15.86640027;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ns(oa,2,12832.10415,x);c[ka>>2]=2808;h[ka+8>>3]=.0280134;h[ka+16>>3]=0.0;h[ka+24>>3]=309498.4543111511;h[ka+32>>3]=1.0e3;x=ka+40|0;y=la;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=ka+52|0;x=ma;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];x=ka+64|0;y=na;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=ka+76|0;x=oa;c[y+0>>2]=c[x+0>>2];c[y+4>>2]=c[x+4>>2];c[y+8>>2]=c[x+8>>2];h[ka+88>>3]=296.8033869505308;N=n+0|0;O=ka+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(ya,b,n,d,f,g,j);Fa=+h[ya>>3];ya=w;h[k>>3]=-626.411601;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+8|0;h[k>>3]=5.30172524;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+16|0;h[k>>3]=.002503813816;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+24|0;h[k>>3]=-2.127308728e-7;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+32|0;h[k>>3]=-7.68998878e-10;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=w+40|0;h[k>>3]=2.849677801e-13;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ns(qa,7,49436.5054,w);w=v;h[k>>3]=-7.04827944;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];ns(ra,2,-45281.9846,v);v=u;h[k>>3]=-1788.791477;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+8|0;h[k>>3]=8.29152319;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+16|0;h[k>>3]=-922315678.0e-13;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+24|0;h[k>>3]=4.86367688e-9;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+32|0;h[k>>3]=-1.891053312e-12;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+40|0;h[k>>3]=6.330036589999999e-16;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];ns(sa,7,117696.2419,u);u=t;h[k>>3]=-26.52669281;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];ns(ta,2,-39083.5059,t);c[pa>>2]=2816;h[pa+8>>3]=.0440095;h[pa+16>>3]=-8941478.544405185;h[pa+24>>3]=212805.6215135368;h[pa+32>>3]=1.0e3;t=pa+40|0;u=qa;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=pa+52|0;t=ra;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];t=pa+64|0;u=sa;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];u=pa+76|0;t=ta;c[u+0>>2]=c[t+0>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];h[pa+88>>3]=188.9244822140674;N=m+0|0;O=pa+0|0;S=N+96|0;do{c[N>>2]=c[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(S|0));Ng(za,b,m,d,f,g,j);j=+h[za>>3];za=s;h[k>>3]=Ca;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+8|0;h[k>>3]=Da;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+16|0;h[k>>3]=Ea;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+24|0;h[k>>3]=Fa;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];za=s+32|0;h[k>>3]=j;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];ns(R,6,Ba,s);h[a>>3]=+ps(e,R);i=l;return}function Qg(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;tr(4,0,2912,b);tr(4,0,2952,a);i=a;return}function Rg(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}PV(a);c[d>>2]=0;i=b;return}function Sg(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+1760>>3];h[c[b+8>>2]>>3]=+h[d+1736>>3];h[c[b+12>>2]>>3]=+h[d+1744>>3];i=i;return}function Tg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0,g=0.0,j=0.0,k=0.0;f=+h[b>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=f;g=+h[b+464>>3];j=+h[b+48>>3];k=g*j;h[d>>3]=+h[b+536>>3]*k*k+(+h[b+56>>3]*(g*+h[b+112>>3]+j*+h[b+528>>3])-k*f);i=i;return}function Ug(a){a=a|0;c[a+4>>2]=173;c[a>>2]=1;c[a+56>>2]=0;c[a+32>>2]=18;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;i=i;return}



function Ts(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[10478]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[10478]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){xJ(41968,43664,80,25);B=42272;C=42280;Ss(41968,43696,42448,B,42352,d,B,B,C,C,80)|0;break}c[10542]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[10542]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}xJ(41968,43704,80,34);B=42272;F=42280;Ss(41968,43744,42440,B,42352,42168,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[10528]=B;c[10540]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){xJ(41968,44528,80,52);I=42272;J=42280;Ss(41968,44512,44584,I,42352,G,I,I,J,J,80)|0;break a}c[10528]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[10540]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[10528]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[10540]=F+(c[10528]|0);break b}}}while(0);xJ(41968,44456,80,52);B=42272;F=42280;Ss(41968,44512,44520,B,42352,q,B,B,F,F,80)|0;break a}}while(0);c[10532]=(c[d>>2]|0)+20;c[q+64>>2]=c[10528];if((c[p>>2]|0)<(c[10540]|0)){xJ(41968,43752,80,60);C=42272;F=42280;Ss(41968,43816,43824,C,42448,42160,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[10532]|0)){xJ(41968,43832,80,60);F=42272;C=42280;Ss(41968,43816,43896,F,42448,42128,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){xJ(41968,44640,80,24);C=42352;F=42272;B=42280;Ss(41968,44672,44680,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[5261]=K;if(!(K<=0.0)){break}xJ(41968,44136,80,28);B=42272;Ss(41968,42848,44168,B,B,B,B,42352,42088,42280,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==-1){xJ(41968,42200,80,49);B=42272;F=42280;Ss(41968,42256,42264,B,B,B,B,B,F,F,80)|0;xJ(41968,42288,80,47);F=42272;B=42280;Ss(41968,42336,42344,F,42352,n,F,F,B,B,80)|0;xJ(41968,42360,80,41);B=42272;F=42280;Ss(41968,42408,42416,42352,B,B,B,B,F,F,80)|0;i=y;return 0}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else{D=210}}while(0);c:do{if((D|0)==27){a[42144]=0;K=+h[l>>3];h[5272]=K;L=+h[m>>3];h[5265]=L;A=c[d>>2]|0;c[10478]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[5272]=O;P=+h[m+(F<<3)>>3];h[5265]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[42144]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[10478]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[10488]=p;r=p+(c[w>>2]|0)|0;c[10490]=r;p=r+(c[w>>2]|0)|0;c[10512]=p;F=p+(c[w>>2]|0)|0;c[10482]=F;B=F+(c[d>>2]|0)|0;c[10518]=B;C=B+(c[d>>2]|0)|0;c[10524]=C;c[10514]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[10538]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[5274]=+h[B>>3];a[42080]=0;h[5243]=+h[o+24>>3];J=o+16|0;h[5238]=+h[J>>3];do{if((c[w>>2]|0)!=0){Us(42448,v,w,d,41944,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,42064,B,0,o,q,s,t)|0;if((c[10608]|0)>0){i=y;return 0}if((c[10516]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=42352;pt(d,o+((c[10482]|0)+ -1<<3)|0,G,g,G)|0;a[42080]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[5238];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[5238]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[5238];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[5273]=O;U=+h[5243];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[10524]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){Zs(41944,j,f,g,d,H,I,X)|0;if((c[10608]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[42080]=1;D=197;break d}}else{Y=41944;Zs(Y,Y,f,g,d,H,I,X)|0;if((c[10608]|0)>0){i=y;return 0}else{h[e>>3]=+h[5243];c[n>>2]=1;a[42080]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}Zs(41944,j,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[42080]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[5274]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[5238]=W;h[J>>3]=W;break}Zs(41944,42184,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[5273];a[42080]=1;D=197;break d}}else{W=+h[5243];if(!B){if(P*(W-N)<0.0){break}Zs(41944,j,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[42080]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[10524]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){Zs(41944,j,f,g,d,G,X,I)|0;if((c[10608]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[42080]=1;D=197;break d}}else{H=41944;Zs(H,H,f,g,d,G,X,I)|0;if((c[10608]|0)>0){i=y;return 0}else{h[e>>3]=+h[5243];c[n>>2]=1;a[42080]=1;D=197;break d}}}}while(0);if(a[42080]&1){D=197}else{D=128}}else{h[5243]=+h[e>>3];c[n>>2]=1;Ws(d,k+4|0,l,m,f,o+((c[10518]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[10478]=1;e:do{if((B|0)>=1){J=c[10518]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[10478]=X;if((I|0)<(B|0)){I=X}else{break e}}xJ(41968,44272,80,39);I=42272;J=42280;Ss(41968,43944,44312,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+bt(42424,1);h[5274]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[5274]*4.0*(aa>=ba?aa:ba);h[5263]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){xJ(41968,44320,80,60);J=42272;Ss(41968,43816,44384,J,J,J,J,42448,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[5242]=ca*.001;U=+Xs(d,g,o+((c[10518]|0)+ -1<<3)|0,s,t);if(U>.5/+h[5242]){h[5242]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+uJ(41936,z);h[5242]=U;da=U}else{U=+h[o+16>>3];h[5242]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}xJ(41968,44224,80,29);J=42272;I=42280;Ss(41968,44256,44264,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[5242]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[5273]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[5242]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{Ys(41944,f,g,d,b,u,41936,o+((c[10518]|0)+ -1<<3)|0,n,s,t,o+((c[10524]|0)+ -1<<3)|0,o+400|0,o+((c[10482]|0)+ -1<<3)|0,o+((c[10514]|0)+ -1<<3)|0,q,42104,B,k+36|0,42152)|0;if((c[10608]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[5242]}h[5238]=ja;h[o+16>>3]=ja;J=c[10524]|0;X=(c[d>>2]|0)+J|0;c[10534]=X;G=c[d>>2]|0;c[10478]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[5238]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[10478]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[5238];h[o+232>>3]=+h[5238]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}Us(42352,v,w,d,e,j,f,o+((c[10482]|0)+ -1<<3)|0,o+((c[10524]|0)+ -1<<3)|0,J,Y,o+((c[10488]|0)+ -1<<3)|0,o+((c[10490]|0)+ -1<<3)|0,o+((c[10512]|0)+ -1<<3)|0,x,42064,B,0,o,q,s,t)|0;if((c[10608]|0)>0){i=y;return 0}if((c[10516]|0)!=0){xJ(41968,44688,80,47);la=42272;ma=42280;Ss(41968,42336,44736,42352,la,la,la,la,ma,ma,80)|0;xJ(41968,44744,80,38);ma=42272;la=42280;Ss(41968,42496,44736,42352,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}Us(42440,v,w,d,41944,j,f,o+((c[10482]|0)+ -1<<3)|0,o+((c[10524]|0)+ -1<<3)|0,J,Y,o+((c[10488]|0)+ -1<<3)|0,o+((c[10490]|0)+ -1<<3)|0,o+((c[10512]|0)+ -1<<3)|0,x,42064,B,0,o,q,s,t)|0;if((c[10608]|0)>0){i=y;return 0}if((c[10516]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=42352;pt(d,o+((c[10482]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){xJ(41968,44064,80,54);p=42272;Ss(41968,44120,44128,p,p,p,p,42448,42184,j,80)|0;break c}else if((D|0)==220){xJ(41968,44176,80,34);p=42272;Ss(41968,43744,44216,p,p,p,p,42448,j,e,80)|0;break c}else if((D|0)==224){xJ(41968,44392,80,49);p=42272;Ss(41968,42256,44448,p,p,p,p,42448,42184,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;Ws(d,oa,l,m,o+((c[10524]|0)+ -1<<3)|0,o+((c[10518]|0)+ -1<<3)|0,s,t)|0;if((c[10608]|0)>0){D=233;break}p=c[d>>2]|0;c[10478]=1;r=c[10518]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[10478]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+Xs(d,o+((c[10524]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[5274];pa=O*V;h[5240]=pa;if(!(pa<=1.0)){D=138;break}O=+h[5243];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[5263]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[5238];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[5238]=V/O}}while(0);_s(41944,f,g,d,b,u,41904,o+((c[10518]|0)+ -1<<3)|0,k,n,s,t,o+((c[10524]|0)+ -1<<3)|0,o+400|0,o+((c[10482]|0)+ -1<<3)|0,o+((c[10514]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,42104,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,42152)|0;if((c[10608]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){Us(42440,v,w,d,41944,j,f,o+((c[10482]|0)+ -1<<3)|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[10488]|0)+ -1<<3)|0,o+((c[10490]|0)+ -1<<3)|0,o+((c[10512]|0)+ -1<<3)|0,x,42064,o+64|0,0,o,q,s,t)|0;if((c[10608]|0)>0){D=233;break f}if((c[10516]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=42352;pt(d,o+((c[10482]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[5243];V=+h[5238];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}Zs(41944,j,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}Zs(41944,j,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){Zs(41944,j,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[5273];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[5274]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}Zs(41944,42184,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[5273];D=197;continue}if(!(U<0.0)){Zs(41944,j,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[5273];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[5274]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[5238]=U-O;D=128;continue}else{Zs(41944,42184,f,g,d,q+28|0,o+((c[10524]|0)+ -1<<3)|0,o+224|0)|0;if((c[10608]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[5273];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[5243];h[o+16>>3]=+h[5238];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[5240]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[10478]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[5240]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[5240];E=E+1|0;p=B}c[10478]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[10534]=p;switch(p|0){case 2:{xJ(41968,42584,80,47);p=42272;Ss(41968,42336,42632,p,p,p,p,42352,41944,42280,80)|0;xJ(41968,42640,80,48);p=42272;E=42280;Ss(41968,42568,42696,p,p,p,p,p,E,E,80)|0;xJ(41968,42704,80,45);E=42272;p=42280;Ss(41968,42752,42760,E,E,E,E,E,p,p,80)|0;break};case 3:{xJ(41968,42768,80,38);p=42272;Ss(41968,42496,42808,p,p,p,p,42352,41944,42280,80)|0;xJ(41968,42816,80,28);p=42272;E=42280;Ss(41968,42848,42856,p,p,p,p,p,E,E,80)|0;break};case 6:{xJ(41968,42864,80,44);E=42272;Ss(41968,42912,42920,E,E,E,E,42448,41944,41904,80)|0;xJ(41968,42928,80,57);E=42272;p=42280;Ss(41968,42992,43e3,E,E,E,E,E,p,p,80)|0;break};case 7:{xJ(41968,42864,80,44);p=42272;Ss(41968,42912,43008,p,p,p,p,42448,41944,41904,80)|0;xJ(41968,43016,80,48);p=42272;E=42280;Ss(41968,42568,43072,p,p,p,p,p,E,E,80)|0;xJ(41968,43080,80,28);E=42272;p=42280;Ss(41968,42848,43112,E,E,E,E,E,p,p,80)|0;break};case 8:{xJ(41968,42864,80,44);p=42272;Ss(41968,42912,43120,p,p,p,p,42448,41944,41904,80)|0;xJ(41968,43128,80,37);p=42272;E=42280;Ss(41968,43168,43176,p,p,p,p,p,E,E,80)|0;break};case 9:{xJ(41968,42864,80,44);E=42272;Ss(41968,42912,43184,E,E,E,E,42448,41944,41904,80)|0;xJ(41968,43192,80,49);E=42272;p=42280;Ss(41968,42256,43248,E,E,E,E,E,p,p,80)|0;xJ(41968,43256,80,38);p=42272;E=42280;Ss(41968,42496,43296,p,p,p,p,p,E,E,80)|0;break};case 10:{xJ(41968,42864,80,44);E=42272;Ss(41968,42912,43304,E,E,E,E,42448,41944,41904,80)|0;xJ(41968,43312,80,45);E=42272;p=42280;Ss(41968,42752,43360,E,E,E,E,E,p,p,80)|0;xJ(41968,43368,80,36);p=42272;E=42280;Ss(41968,43408,43416,p,p,p,p,p,E,E,80)|0;break};case 11:{xJ(41968,43424,80,40);E=42272;Ss(41968,43472,43480,E,E,E,E,42448,41944,41904,80)|0;xJ(41968,43488,80,36);E=42272;p=42280;Ss(41968,43408,43528,E,E,E,E,E,p,p,80)|0;break};case 12:{xJ(41968,42864,80,44);p=42272;Ss(41968,42912,43536,p,p,p,p,42448,41944,41936,80)|0;xJ(41968,43544,80,45);p=42272;E=42280;Ss(41968,42752,43592,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{xJ(41968,42456,80,38);E=42272;Ss(41968,42496,42504,E,E,E,E,42352,41944,42280,80)|0;xJ(41968,42512,80,48);E=42272;p=42280;Ss(41968,42568,42576,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[5243];h[o+24>>3]=+h[5243];h[o+16>>3]=+h[5238];i=y;return 0}else if((D|0)==215){xJ(41968,43904,80,39);p=42272;E=42280;Ss(41968,43944,43952,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){xJ(41968,43960,80,39);E=42272;p=42280;Ss(41968,43944,44e3,E,E,E,E,E,p,p,80)|0;break c}}}while(0);xJ(41968,44008,80,47);A=42272;p=42280;Ss(41968,42336,44056,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){xJ(41968,43600,80,55);p=42272;A=42280;Ss(41968,43656,42352,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){xJ(41968,44592,80,39);D=42272;Ss(41968,43944,44632,D,D,D,D,42448,j,e,80)|0}if((c[k>>2]|0)==-1){xJ(41968,44784,80,46);e=42272;j=42280;Ss(41968,44832,44840,e,e,e,e,e,j,j,80)|0;xJ(41968,44848,80,47);j=42272;e=42280;Ss(41968,42336,44896,42352,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function Us(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[5613]=C;c[t>>2]=0;D=c[e>>2]|0;c[11228]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[11228]|0;E=F+1|0;c[11228]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[5620]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;Zs(g,b,k,l,f,o,m,n)|0;if((c[10608]|0)>0){i=v;return 0}D=d;ae[D&7](f,b,k,e,p,y,z)|0;if((c[10608]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[44968]=0;F=c[e>>2]|0;c[11228]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[44968]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[11228]=F+1;if(!M){break}I=+uJ(44960,44904);h[5617]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[5613];do{if((H- +h[g>>3])*I<0.0){Zs(g,b,k,l,f,o,m,n)|0;if((c[10608]|0)<=0){break}i=v;return 0}else{G=+h[5617]/I;h[5618]=G;N=c[f>>2]|0;c[11228]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[5618];Q=Q+1|0}c[11228]=N+1}}while(0);ae[D&7](f,b,k,e,p,y,z)|0;if((c[10608]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[44968]=0;F=c[e>>2]|0;c[11228]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[44968]=1;V=1;W=c[11228]|0}Q=W+1|0;c[11228]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[5613];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;Zs(g,F,k,l,f,o,m,n)|0;if((c[10608]|0)>0){i=v;return 0}E=d;ae[E&7](f,F,k,e,p,y,z)|0;if((c[10608]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[44968]=0;D=c[e>>2]|0;c[11228]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[44968]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[11228]=D+1;if(!aa){i=v;return 0}I=+uJ(44960,44904);h[5617]=I;h[F>>3]=I+ +h[F>>3];I=+h[5617]/+h[5613];h[5618]=I;Q=c[f>>2]|0;c[11228]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[5618];R=R+1|0}c[11228]=Q+1}ae[E&7](f,F,k,e,p,y,z)|0;if((c[10608]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[44968]=0;R=c[e>>2]|0;c[11228]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[44968]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[11228]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[5616]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}Zs(g,44928,k,l,f,o,m,n)|0;if((c[10608]|0)<=0){break}i=v;return 0}else{h[5616]=Y;j=c[f>>2]|0;c[11228]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[11228]=j+1}}while(0);ga=d;ae[ga&7](f,44928,k,e,q,y,z)|0;if((c[10608]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[11238]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){Vs(e,44960,44952,R,44928,p,q,r,44920,s,fa,da,x,ca)|0;if((c[10608]|0)>0){ha=76;break}if((c[11238]|0)>1){ha=73;break}Zs(g,44920,k,l,f,o,m,n)|0;if((c[10608]|0)>0){ha=76;break}ae[ga&7](f,44920,k,e,r,y,z)|0;if((c[10608]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[5615];R=42352;pt(e,r,R,p,R)|0;if((c[11238]|0)==4){i=v;return 0}Zs(g,44920,k,l,f,o,m,n)|0;if((c[10608]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function Vs(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[11254]=c[o>>2];c[o>>2]=0;h[5623]=0.0;a[45e3]=0;t=c[b>>2]|0;c[11244]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+uJ(45032,j+(v<<3)|0);if(w==+uJ(45032,l+((c[11244]|0)+ -1<<3)|0)){break}y=c[11244]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[5623]){break}h[5623]=B;c[o>>2]=y}else{a[45e3]=1}}while(0);v=c[11244]|0;u=v+1|0;c[11244]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[45008]=1;c[11256]=c[p>>2];h[g>>3]=+h[r>>3];t=42352;pt(b,l,t,k,t)|0;c[p>>2]=1;a[44992]=0;C=0}else{a[45008]=0;c[o>>2]=c[11254];c[11256]=c[p>>2];if(a[45e3]&1){h[g>>3]=+h[r>>3];t=42352;pt(b,l,t,k,t)|0;a[44992]=1;C=1;break}else{t=42352;pt(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[44992]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[44992]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=42352;pt(b,k,t,l,t)|0;t=c[b>>2]|0;c[11244]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[11244]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+uJ(45032,j+(u<<3)|0);if(!(A!=+uJ(45032,k+((c[11244]|0)+ -1<<3)|0))){break}c[n+((c[11244]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[11244]|0;F=u+1|0;c[11244]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[5623]=0.0;a[45e3]=0;t=c[b>>2]|0;c[11244]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+uJ(45032,j+(v<<3)|0);if(A==+uJ(45032,k+((c[11244]|0)+ -1<<3)|0)){break}y=c[11244]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[5623]){break}h[5623]=I;c[o>>2]=y}else{a[45e3]=1}}while(0);v=c[11244]|0;u=v+1|0;c[11244]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[45008]=t&1;if(t){a[44992]=0;c[11256]=0;c[p>>2]=1;break}if(!(a[45e3]&1)){t=42352;pt(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=42352;pt(b,k,t,l,t)|0;t=c[b>>2]|0;c[11244]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[11244]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[11244]|0}u=K+1|0;c[11244]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[11256]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function Ws(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[5632]=+h[d>>3];h[5631]=+h[e>>3];j=c[a>>2]|0;c[11260]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[5632]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[5632]=o;h[5631]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[5631];a=l+1|0;c[11260]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function Xs(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[5635]=0.0;e=c[a>>2]|0;c[11266]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[5635]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[11266]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[5634]=0.0;e=c[a>>2]|0;c[11266]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[5634]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[11266]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function Ys(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[11284]=0;c[11282]=0;c[11288]=0;h[5647]=+h[b>>3];h[5649]=+Xs(f,d,l,0,0);C=c[f>>2]|0;c[11272]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[11272]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[5640]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[11272]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[11272]=G+1}a[45184]=1;c[11274]=0;a[45200]=1;c[C>>2]=(c[C>>2]|0)+1;c[11292]=0;ae[B&7](b,d,e,q,45168,n,o)|0;b:do{if((c[11292]|0)<0){K=35}else{while(1){if(a[45184]&1){c[E>>2]=(c[E>>2]|0)+1;a[45184]=0;$s(f,b,d,e,q,45120,k,45144,l,r,s,t,g,45168,v,j,n,o,x)|0;h[5639]=1.0e6;if((c[11292]|0)<0|(c[11286]|0)!=0){K=35;break b}c[11288]=0}H=c[f>>2]|0;c[11272]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[11272]=H+1}at(f,q,s,t)|0;I=c[f>>2]|0;c[11272]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[5640]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[11272]=I+1}N=+Xs(f,q,l,0,0);h[5651]=N;if(N<=+h[v>>3]*100.0*+h[5649]){break}J=c[11274]|0;if((J|0)>0){h[z>>3]=N/+h[5652];h[A>>3]=1.0/+(J|0);O=+sJ(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[5639]=P;Q=+h[5651];R=P}else{h[5652]=N;Q=N;R=+h[5639]}if(R*Q<=.33){break}J=c[11274]|0;H=J+1|0;c[11274]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[45184]=1}c[C>>2]=(c[C>>2]|0)+1;c[11292]=0;ae[B&7](b,d,e,q,45168,n,o)|0;if((c[11292]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[11272]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[11272]=H+1}N=+Xs(f,q,l,0,0);h[5651]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[11272]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[5640]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[11272]=J+1}}while(0);if(!(a[45200]&1)){break}H=c[f>>2]|0;c[11272]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[11272]=H+1}N=+Xs(f,r,l,0,0);h[5645]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[45200]=0}h[b>>3]=+h[5647];G=c[f>>2]|0;c[11272]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[11272]=G+1}if(a[45200]&1){I=(c[11284]|0)+1|0;c[11284]=I;N=.9/(+h[5645]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[5638]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[11286]|0)!=0){I=(c[11288]|0)+1|0;c[11288]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[11292]|0)>-2)){K=53;break}I=(c[11282]|0)+1|0;c[11282]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function Zs(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[11318]=o;p=+h[b>>3]- +h[a>>3];h[5657]=p;a=c[f>>2]|0;c[11310]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[11310]=a+1;q=+h[5657]}h[5653]=1.0;h[5654]=0.0;p=q/+h[k>>3];h[5658]=p;c[11312]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[5654]=u*t+s/+h[a>>3];p=t*s;h[5653]=p;h[5658]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[11310]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[5654]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[5653];g=g+1|0}c[11310]=a+1}g=v+1|0;c[11312]=g;if((v|0)>=(o|0)){break}r=+h[5657];s=+h[5653];t=+h[5658];u=+h[5654];v=g}i=l;return 0}function _s(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[5680]=+h[b>>3];c[11338]=0;c[11346]=0;c[11340]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[5692]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[11334]=(c[I>>2]|0)+1;c[11336]=(c[I>>2]|0)+2;c[11332]=(c[I>>2]|0)+ -1;h[5680]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[11350]=$+1;$=c[11334]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[5683]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[11320]=2;if(($|0)>=2){Y=2;while(1){h[5684]=+h[y+(Y+ -2<<3)>>3];U=+h[5683];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[5684];U=+h[5684]+ +h[k>>3];h[5683]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[11320]=$+1}h[y+($+ -1<<3)>>3]=+h[5683]}h[5690]=0.0;h[5688]=0.0;Y=c[I>>2]|0;c[11320]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[5690]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[5688]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[11320]=Y+1;da=ea}h[5691]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[5690]- +h[5688];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[5665]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[5665]=ha>=ca?ha:ca;h[5683]=.6;h[5684]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[5691]){h[D>>3]=100.0}aa=c[11334]|0;ba=c[11350]|0;if((aa|0)>=(ba|0)){c[11322]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[11320]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[11320]=ba+1}ja=ia+1|0;c[11322]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[11320]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[11320]=ia+1}aa=c[11334]|0;c[11322]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[11320]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[11320]=$+1}la=ba+1|0;c[11322]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[5687]=+Xs(f,d,l,0,0);a[45544]=1;c[11324]=0;c[T>>2]=(c[T>>2]|0)+1;c[11354]=0;ae[m&7](b,d,e,r,45416,o,p)|0;if((c[11354]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;$s(f,b,d,e,r,A,k,45368,l,s,t,u,g,45416,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[11354]|0)<0|(c[11342]|0)!=0){X=70;break}c[11346]=0}ba=c[f>>2]|0;c[11320]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[11320]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[5683]=ca;aa=c[f>>2]|0;c[11320]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[5683];ia=ia+1|0;la=ka}c[11320]=aa+1}at(f,r,t,u)|0;la=c[f>>2]|0;c[11320]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[11320]=la+1}U=+Xs(f,r,l,0,0);h[5692]=U;if(U<=+h[F>>3]*100.0*+h[5687]){X=63;break a}ia=c[11324]|0;if((ia|0)>0){h[O>>3]=U/+h[5694];h[P>>3]=1.0/+(ia|0);ca=+sJ(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[5692];oa=ga}else{h[5694]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[11324]|0;c[11324]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[11354]=0;ae[m&7](b,d,e,r,45416,o,p)|0;if((c[11354]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[11320]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[11320]=ba+1}U=+Xs(f,r,l,0,0);h[5692]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[11320]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[11320]=ia+1}}while(0);if((X|0)==70){X=0;a[45544]=0}c[H>>2]=1;if(a[45544]&1){U=+Xs(f,s,l,0,0);h[5686]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[5672]=ga;h[5679]=ga*+(ba+1|0);h[5674]=ga;c[11356]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[11320]=1;if((ba|0)>=1){aa=fa(c[11334]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[11320]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+Xs(f,r,l,0,0);h[5681]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[5689]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[11320]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[11320]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+Xs(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[5689];if((sa>=ca?sa:ca)>+h[5679]){break}ta=+h[5681];ua=Y}else{if(!(ga<=+h[5679]*.5)){break}else{ta=U;ua=ka}}c[11356]=ua+ -1;h[5674]=ta}}while(0);if(!(+h[5665]*+h[5686]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[5680];Y=c[11334]|0;ia=c[11350]|0;if((Y|0)>=(ia|0)){c[11322]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[5683]=ca;ia=c[f>>2]|0;c[11320]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[5683];ja=ja+1|0}c[11320]=ia+1}ja=aa+1|0;c[11322]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[11320]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[11320]=Y+1}if(!(a[45544]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[11342]|0)!=0){aa=(c[11346]|0)+1|0;c[11346]=aa;h[5663]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[11354]|0)>-2)){X=146;break}aa=(c[11338]|0)+1|0;c[11338]=aa;h[5663]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[11340]=(c[11340]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[11340]|0;if((aa|0)<=1){ja=c[11356]|0;c[I>>2]=ja;sa=+(ja+1|0);h[5684]=sa;h[O>>3]=+h[5674]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+sJ(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[5663]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[11356];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[11370]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[11356]|0;E=c[11332]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[11334];za=+h[k>>3]*2.0;h[5676]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[11332]|0;Ba=c[11356]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[11334]|0)>=(c[K>>2]|0)|(c[11370]|0)==1){Fa=G;break}G=c[f>>2]|0;c[11320]=1;if((G|0)>=1){E=fa(c[11336]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[11320]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+Xs(f,r,l,0,0);h[5682]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[5679];E=xa<=za;if(+h[5689]<=(E?xa:za)){Ea=c[11332]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[5679]*.5){Fa=S;break}}S=c[11334]|0;c[I>>2]=S;h[5674]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[5674]=+h[5681];Fa=Ea}h[5676]=+h[k>>3];ya=+(Fa+1|0);h[5684]=ya;h[O>>3]=+h[5674]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+sJ(O,P);h[5663]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[5676];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[5663]=xa;za=+h[k>>3]*xa;h[5676]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[5676]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[11320]=1;if((k|0)<1){break}u=fa(c[11336]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[11320]=k+1}}while(0);Ca=c[f>>2]|0;c[11320]=1;if((Ca|0)>=1){J=fa(c[11334]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[11320]=Ca+1}Ca=c[11334]|0;c[11328]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[11322]=P;s=c[f>>2]|0;c[11320]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[11320]=s+1}P=Ha+1|0;c[11328]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[11354]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[11340]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}Zs(b,b,d,e,f,I,q,y)|0;i=N;return 0}function $s(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==4){P=c[q>>2]|0;Q=q+4|0;R=c[Q>>2]|0;S=c[b>>2]|0;T=fa(R+1+(P<<1)|0,S)|0;c[11390]=1;if((T|0)>=1){U=fa(S,R+(P<<1)+1|0)|0;P=(U|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(T|0)){R=R+1|0}else{break}}c[11390]=P?2:U+1|0}ge[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[11424]=(c[Q>>2]|0)+1+(c[q>>2]<<1);W=75}else if((O|0)==5){R=q+4|0;T=(c[R>>2]|0)+(c[q>>2]|0)|0;S=T+1|0;c[11416]=S;X=c[b>>2]|0;c[11406]=(T|0)<(X|0)?S:X;X=c[q>>2]|0;c[11424]=S+X;c[11410]=X+T;T=(c[b>>2]|0)/(S|0)|0;c[11420]=T+1;S=c[x>>2]|0;c[11418]=S+ -1;c[11428]=S+T;c[s>>2]=0;h[5707]=+V(+(+h[t>>3]));T=c[11406]|0;c[11392]=1;if((T|0)<1){W=75;break}S=r;X=1;while(1){Y=c[b>>2]|0;Z=c[11416]|0;c[11398]=X;_=(Z|0)<0;b:do{if(_?(X|0)>=(Y|0):(X|0)<=(Y|0)){$=Z;aa=X;ba=X;while(1){ca=(ba-aa|0)/($|0)|0;c[11394]=ca+1;da=ba+ -1|0;ea=e+(da<<3)|0;h[p+((c[11418]|0)+ca<<3)>>3]=+h[ea>>3];ga=f+(da<<3)|0;h[p+((c[11428]|0)+ca<<3)>>3]=+h[ga>>3];ha=+h[ea>>3];h[N>>3]=ha;if(!(ha>=0.0)){ia=-ha}else{ia=ha}ha=+h[l>>3]*+h[ga>>3];if(!(ha>=0.0)){ja=-ha}else{ja=ha}ha=ia>=ja?ia:ja;ka=+h[n+(da<<3)>>3];if(!(ka>=0.0)){la=-ka}else{la=ka}h[5704]=+h[5707]*(ha>=la?ha:la);h[N>>3]=+h[l>>3]*+h[ga>>3];ha=+uJ(45632,N);h[5704]=ha;ga=c[11398]|0;da=ga+ -1|0;ea=e+(da<<3)|0;ka=+h[ea>>3];ma=ha+ka-ka;h[5704]=ma;h[ea>>3]=+h[ea>>3]+ma;ea=f+(da<<3)|0;h[ea>>3]=+h[j>>3]*+h[5704]+ +h[ea>>3];ea=ga+Z|0;c[11398]=ea;if(!(_?(ea|0)>=(Y|0):(ea|0)<=(Y|0))){break b}$=c[11416]|0;aa=c[11392]|0;ba=ea}}}while(0);ae[S&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}Y=c[b>>2]|0;_=c[11416]|0;Z=c[11392]|0;c[11398]=Z;ba=(_|0)<0;c:do{if(ba?(Z|0)>=(Y|0):(Z|0)<=(Y|0)){aa=_;$=Z;ea=Z;while(1){ga=(ea-$|0)/(aa|0)|0;c[11394]=ga+1;da=ea+ -1|0;ca=e+(da<<3)|0;h[ca>>3]=+h[p+((c[11418]|0)+ga<<3)>>3];ma=+h[p+((c[11428]|0)+ga<<3)>>3];ga=f+(da<<3)|0;h[ga>>3]=ma;ka=+h[ca>>3];h[N>>3]=ka;if(!(ka>=0.0)){na=-ka}else{na=ka}ka=+h[l>>3]*ma;if(!(ka>=0.0)){oa=-ka}else{oa=ka}ka=na>=oa?na:oa;ma=+h[n+(da<<3)>>3];if(!(ma>=0.0)){pa=-ma}else{pa=ma}h[5704]=+h[5707]*(ka>=pa?ka:pa);h[N>>3]=+h[l>>3]*+h[ga>>3];ka=+uJ(45632,N);h[5704]=ka;ga=c[11398]|0;ma=+h[e+(ga+ -1<<3)>>3];ha=ka+ma-ma;h[5704]=ha;ma=1.0/ha;h[5713]=ma;da=ga-(c[R>>2]|0)|0;ca=(da|0)>1?da:1;c[11400]=ca;da=c[b>>2]|0;qa=(c[q>>2]|0)+ga|0;ra=(da|0)<=(qa|0)?da:qa;c[11402]=ra;sa=fa(c[11410]|0,ga)|0;ta=sa-(c[q>>2]|0)|0;c[11404]=ta;c[11390]=ca;if((ca|0)<=(ra|0)){sa=~da;da=~qa;qa=~((sa|0)>(da|0)?sa:da);da=(ca|0)>(qa|0)?ca:qa;ha=ma;qa=ca;while(1){ca=qa+ -1|0;h[p+(ca+ta<<3)>>3]=(+h[o+(ca<<3)>>3]- +h[g+(ca<<3)>>3])*ha;if((qa|0)>=(ra|0)){break}ha=+h[5713];qa=qa+1|0}c[11390]=da+1}qa=ga+_|0;c[11398]=qa;ra=c[11392]|0;if(!(ba?(qa|0)>=(Y|0):(qa|0)<=(Y|0))){ua=ra;break c}aa=c[11416]|0;$=ra;ea=qa}}else{ua=Z}}while(0);Z=ua+1|0;c[11392]=Z;if((ua|0)<(T|0)){X=Z}else{W=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[11412]=0;h[5707]=+V(+(+h[t>>3]));X=c[b>>2]|0;c[11390]=1;d:do{if((X|0)>=1){T=r;R=1;while(1){S=R+ -1|0;ha=+h[e+(S<<3)>>3];h[N>>3]=ha;if(!(ha>=0.0)){va=-ha}else{va=ha}Q=f+(S<<3)|0;ha=+h[l>>3]*+h[Q>>3];if(!(ha>=0.0)){wa=-ha}else{wa=ha}ha=va>=wa?va:wa;ma=+h[n+(S<<3)>>3];if(!(ma>=0.0)){xa=-ma}else{xa=ma}h[5704]=+h[5707]*(ha>=xa?ha:xa);h[N>>3]=+h[l>>3]*+h[Q>>3];ha=+uJ(45632,N);h[5704]=ha;Q=(c[11390]|0)+ -1|0;S=e+(Q<<3)|0;ma=+h[S>>3];ka=ha+ma-ma;h[5704]=ka;h[5711]=+h[S>>3];U=f+(Q<<3)|0;h[5715]=+h[U>>3];h[S>>3]=ka+ +h[S>>3];h[U>>3]=+h[j>>3]*+h[5704]+ +h[U>>3];ae[T&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ka=1.0/+h[5704];h[5713]=ka;U=c[b>>2]|0;c[11396]=1;S=c[11412]|0;if((U|0)>=1){ma=ka;Q=1;P=0;while(1){h[p+(P+S<<3)>>3]=(+h[o+(P<<3)>>3]- +h[g+(P<<3)>>3])*ma;if((Q|0)>=(U|0)){break}Z=Q;ma=+h[5713];Q=Q+1|0;P=Z}c[11396]=U+1}c[11412]=S+(c[b>>2]|0);P=c[11390]|0;Q=P+ -1|0;h[e+(Q<<3)>>3]=+h[5711];h[f+(Q<<3)>>3]=+h[5715];R=P+1|0;c[11390]=R;if((P|0)>=(X|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){W=42;break}c[11412]=0;X=c[b>>2]|0;if((c[31920>>2]|0)==0){W=42;break}R=OV(X*20|0)|0;T=F;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(14,1,45728,F);T=E;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(14,0,45752,E);tr(14,1,45760,D);c[11394]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[C>>2]=T+1;P=C+4|0;h[k>>3]=ma;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];tr(14,0,45768,C);T=(c[11394]|0)+1|0;c[11394]=T;}while((T|0)<(c[b>>2]|0))}ee[c[8104]&255](14);tr(14,1,45824,B);c[11390]=1;if((X|0)>=1){T=R+1|0;P=c[11412]|0;Q=1;do{Z=p+(Q+ -1+P<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[11396]=1;Z=P;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[A>>2]=R;ba=A+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];gc(R|0,45808,A|0)|0;ba=c[11396]|0;c[11396]=ba+1;if((ba|0)>=(X|0)){break}Z=c[11412]|0;Y=ba}c[z>>2]=R;tr(14,0,45816,z);Y=c[11412]|0;Z=c[11390]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];P=Y+(c[b>>2]|0)|0;c[11412]=P;Q=Z+1|0;c[11390]=Q;}while((Z|0)<(X|0))}ee[c[8104]&255](14);ee[c[8104]&255](14);PV(R);W=42}else{X=c[b>>2]|0;Q=fa(X,X)|0;c[11390]=1;if((Q|0)!=0){X=(Q|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(Q|0)){P=P+1|0}else{break}}c[11390]=X?2:Q+1|0}ge[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){W=42;break}c[11412]=0;P=c[b>>2]|0;if((c[31920>>2]|0)==0){W=42;break}R=OV(P*20|0)|0;T=M;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(14,1,45728,M);T=L;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tr(14,0,45752,L);tr(14,1,45760,K);c[11394]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[J>>2]=T+1;Z=J+4|0;h[k>>3]=ma;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];tr(14,0,45768,J);T=(c[11394]|0)+1|0;c[11394]=T;}while((T|0)<(c[b>>2]|0))}ee[c[8104]&255](14);tr(14,1,45784,I);c[11390]=1;if((P|0)>=1){T=R+1|0;Q=c[11412]|0;X=1;do{Z=p+(X+ -1+Q<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[11396]=1;Z=Q;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[H>>2]=R;ba=H+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];gc(R|0,45808,H|0)|0;ba=c[11396]|0;c[11396]=ba+1;if((ba|0)>=(P|0)){break}Z=c[11412]|0;Y=ba}c[G>>2]=R;tr(14,0,45816,G);Y=c[11412]|0;Z=c[11390]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];Q=Y+(c[b>>2]|0)|0;c[11412]=Q;X=Z+1|0;c[11390]=X;}while((Z|0)<(P|0))}ee[c[8104]&255](14);ee[c[8104]&255](14);PV(R);W=42}}while(0);if((W|0)==42){ht(p,b,b,q+80|0,m)|0;i=y;return 0}else if((W|0)==75){nt(p,45696,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function at(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[11462]=(c[g>>2]|0)+1+(c[e>>2]<<1);ot(d,45848,a,e,g,e+80|0,b,45856)|0;i=f;return 0}else{lt(d,a,a,e+80|0,b,45856)|0;i=f;return 0}return 0}function bt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[45864]&1)){a[45864]=1;ct(45912,45880,45960,45896,45944,45968,45952,45976)|0;h[5738]=+(c[11478]|0);f=c[11470]|0;h[5734]=+(f|0);if((c[11490]|0)==0){h[5736]=0.0;c[e>>2]=1-f;g=+tJ(45904,e)}else{h[5736]=1.0;c[e>>2]=1-f;g=+tJ(45904,e)*.5}h[5737]=g;h[5741]=g*+h[5738];h[5740]=+(c[11486]|0);h[5742]=+(c[11488]|0);j=+h[5746];h[5749]=j;k=1.0/+h[5747];if(!(k>=j)){break}h[5749]=k*(g+1.0)}}while(0);if((ut(b,46e3,1,1)|0)!=0){g=+h[5737];h[5748]=g;l=g;i=d;return+l}if((ut(b,46008,1,1)|0)!=0){g=+h[5749];h[5748]=g;l=g;i=d;return+l}if((ut(b,46016,1,1)|0)!=0){g=+h[5738];h[5748]=g;l=g;i=d;return+l}if((ut(b,46024,1,1)|0)!=0){g=+h[5741];h[5748]=g;l=g;i=d;return+l}if((ut(b,46032,1,1)|0)!=0){g=+h[5734];h[5748]=g;l=g;i=d;return+l}if((ut(b,46040,1,1)|0)!=0){g=+h[5736];h[5748]=g;l=g;i=d;return+l}if((ut(b,46048,1,1)|0)!=0){g=+h[5740];h[5748]=g;l=g;i=d;return+l}if((ut(b,46056,1,1)|0)!=0){g=+h[5746];h[5748]=g;l=g;i=d;return+l}if((ut(b,46064,1,1)|0)!=0){g=+h[5742];h[5748]=g;l=g;i=d;return+l}if((ut(b,46072,1,1)|0)==0){l=+h[5748];i=d;return+l}else{g=+h[5747];h[5748]=g;l=g;i=d;return+l}return 0.0}function ct(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[46184]&1){q=46552;r=c[11638]|0;c[b>>2]=r;s=46488;t=c[11622]|0;c[d>>2]=t;u=46528;v=c[11632]|0;c[e>>2]=v;w=46536;x=+h[5817];h[f>>3]=x;y=46568;z=c[11642]|0;c[g>>2]=z;A=46616;B=+h[5827];h[j>>3]=B;C=46576;D=c[11644]|0;c[k>>2]=D;E=46624;F=+h[5828];h[l>>3]=F;i=m;return 0}a[46184]=1;h[5818]=0.0;h[5812]=1.0;h[5813]=2.0;dt(46552,46488,46528,46640)|0;h[5808]=+(c[11638]|0);c[n>>2]=0-(c[11622]|0);G=+tJ(46464,n);h[5807]=G;h[5817]=G;H=+h[5813];h[5808]=H/3.0;I=+h[5812];J=I*.5;h[5815]=J;K=-J;h[o>>3]=K;h[5829]=+et(46464,o);L=46632;h[5826]=+et(L,L);h[o>>3]=K;h[5808]=+et(46608,o);K=+et(46464,46632);h[5808]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[5808]=K;h[5817]=1.0;M=+h[5818];if(K<1.0&K>M){N=K;while(1){h[5817]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+et(o,p);h[5809]=K;h[o>>3]=-K;h[5809]=+et(46520,o);K=+et(46520,46472);h[5808]=K;h[o>>3]=-K;h[5809]=+et(46520,o);K=+et(46520,46472);h[5808]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[5817]=G}G=I/+(c[11638]|0);h[5820]=G;h[5824]=I;c[11620]=1;p=1;O=I;do{h[o>>3]=O*G;O=+et(o,46544);h[5824]=O;p=p+1|0;c[11620]=p;}while((p|0)<4);h[5807]=+et(46496,46592);ft(46656,46496,46552)|0;h[o>>3]=-+h[5812];ft(46648,o,46552)|0;ft(46600,46456,46552)|0;h[o>>3]=-+h[5807];ft(46584,o,46552)|0;c[11628]=0;p=c[11664]|0;L=c[11662]|0;P=c[11650]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[11646]|0)){if(Q){c[11642]=p;R=0;S=25;break}if((P-p|0)==3){c[11642]=p+ -1+(c[11622]|0);c[11628]=1;R=1;S=25;break}else{c[11642]=(p|0)<=(P|0)?p:P;a[46192]=1;S=26;break}}else{T=Q&(L|0)==(c[11646]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[11642]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[11642]=(p|0)<=(L|0)?p:L;a[46192]=1;S=26;break}}T=c[11646]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[11642]=(V|0)<=(T|0)?V:T;a[46192]=1;S=26;break}if((P-U|0)==3){c[11642]=((p|0)>=(L|0)?p:L)+ -1+(c[11622]|0);R=0;S=25;break}else{c[11642]=U;a[46192]=1;S=26;break}}}while(0);if((S|0)==25){if(a[46192]&1){S=26}else{W=R}}if((S|0)==26){a[46184]=0;rK(46664)|0;IJ(46688,46568,4)|0;$J()|0;W=c[11628]|0}if((W|0)==0){X=(c[11660]|0)!=0|0}else{X=1}c[11628]=X;h[5827]=1.0;X=c[11642]|0;W=1-X|0;c[n>>2]=W;c[11620]=1;if((X|0)<=0){O=+h[5820];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+et(o,46544);h[5827]=I;n=X+1|0;c[11620]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}gt(46552,46488,46568,46512,46576,46624)|0;q=46552;r=c[11638]|0;c[b>>2]=r;s=46488;t=c[11622]|0;c[d>>2]=t;u=46528;v=c[11632]|0;c[e>>2]=v;w=46536;x=+h[5817];h[f>>3]=x;y=46568;z=c[11642]|0;c[g>>2]=z;A=46616;B=+h[5827];h[j>>3]=B;C=46576;D=c[11644]|0;c[k>>2]=D;E=46624;F=+h[5828];h[l>>3]=F;i=m;return 0}function dt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[46080]&1){l=a[46152]&1;m=c[11540]|0;c[b>>2]=m;n=46128;o=c[11532]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=46176;r=c[11544]|0;c[f>>2]=r;i=g;return 0}a[46080]=1;h[5767]=1.0;h[5761]=1.0;h[5763]=1.0;s=1.0;do{s=s*2.0;h[5761]=s;h[5763]=+et(46088,46136);h[j>>3]=-s;t=+et(46104,j);h[5763]=t;}while(t==1.0);h[5762]=1.0;t=+et(46088,46096);h[5763]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[5762]=v;w=+et(46088,46096);h[5763]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[5768]=.25;h[5771]=x;h[j>>3]=-s;t=+et(46104,j);h[5763]=t;y=~~(t+.25);c[11540]=y;t=+(y|0);h[5762]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[5764]=+et(j,k);w=+et(46112,46088);h[5763]=w;z=w==s;a[46152]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[5764]=+et(j,k);w=+et(46112,46088);h[5763]=w;if(z&w==s){a[46152]=0;A=0}else{A=z}h[j>>3]=u;w=+et(j,46088);h[5765]=w;h[j>>3]=u;z=w==s&+et(j,46168)>x;c[11544]=z?A&1:0;c[11532]=0;h[5761]=1.0;h[5763]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[11532]=k;s=x*t;h[5761]=s;h[5763]=+et(46088,46136);h[j>>3]=-s;w=+et(46104,j);h[5763]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=46128;o=c[11532]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=46176;r=c[11544]|0;c[f>>2]=r;i=g;return 0}function et(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function ft(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[5837]=g;j=1.0/+(c[d>>2]|0);h[5846]=j;h[5845]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+et(f,46760);h[5839]=k;h[5841]=g;h[5842]=g;h[5843]=g;h[5844]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[5837]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+et(f,46760);h[5839]=g;h[f>>3]=g*k;k=+et(f,46760);h[5841]=k;h[5843]=0.0;c[11676]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[5843]=q;c[11676]=b+1;n=q}h[f>>3]=m*j;p=+et(f,46760);h[5840]=p;h[f>>3]=p/j;r=+et(f,46760);h[5842]=r;h[5844]=0.0;o=c[d>>2]|0;c[11676]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[5844]=v;c[11676]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function gt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[11700]=1;c[11708]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[11700]=q;r=l+1|0;c[11708]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[11704]=n;u=n}else{c[11704]=m;c[11708]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[11710]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[11708]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[5853]=x;y=w+-1.0;h[5849]=y;h[5848]=0.0;v=c[b>>2]|0;c[11694]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[5849]=B;if(w<1.0){h[5851]=w}C=+et(46784,46792);h[5848]=C;e=b+1|0;c[11694]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[5851];h[5848]=A;z=A}}while(0);v=c[f>>2]|0;c[11694]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+et(k,46848);h[5848]=z;f=E+1|0;c[11694]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function ht(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[11716]=1;m=1;do{c[11722]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=it(j,a+(m+b+(fa(m,l)|0)<<3)|0,46896)|0;q=c[11716]|0;r=p+ -1+q|0;c[11718]=r;c[e+(q+ -1<<2)>>2]=r;r=c[11718]|0;q=c[11716]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[5860]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[5860];t=q}u=fa(t,l)|0;h[5860]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;jt(j,46880,a+(t-l+u<<3)|0,46896)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[11722]|0;c[11714]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[11718]|0;x=fa(w,l)|0;h[5860]=+h[a+(x+b+v<<3)>>3];y=c[11716]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[5860];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=46896;kt(k,46880,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[11714]|0;w=A+1|0;c[11714]=w;}while((A|0)<(u|0))}}while(0);q=c[11716]|0;m=q+1|0;c[11716]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function it(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[11814]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[5908]=k;l=(c[d>>2]|0)+1|0;c[11814]=l;m=c[a>>2]|0;c[11812]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[5908]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[11814]=l;a=n+1|0;c[11812]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[5908]=v;c[11812]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[5908]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[11812]=f+1;g=C;i=e;return g|0}function jt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[11798]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[11798]=l;i=f;return 0}l=(g|0)%5|0;c[11800]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[11798]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[11798]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[11798]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[11798]=o;i=f;return 0}function kt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[11784]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[11782]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[11782]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[11782]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[11782]=s;i=j;return 0}}while(0);c[11786]=1;c[11788]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[11786]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[11788]=s;u=s}else{u=1}s=c[a>>2]|0;c[11782]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[11786]=t;u=x+(c[g>>2]|0)|0;c[11788]=u;a=w+1|0;c[11782]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function lt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[11734]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[11726]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[11728]=o;p=f+(o+ -1<<3)|0;h[5865]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[5865]}c[k>>2]=(c[d>>2]|0)-m;o=46896;kt(k,46920,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[11726]|0;m=o+1|0;c[11726]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[11732]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[11726]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[5865]=-s;c[k>>2]=g;g=46896;kt(k,46920,a+(p-l<<3)|0,g,f,g)|0;g=c[11732]|0;q=g+1|0;c[11732]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[11726]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=46896;s=+mt(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[5865]=s;q=c[11726]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[11726]=n;}while((q|0)<(m|0));t=c[11734]|0}if((t|0)<1){i=j;return 0}c[11732]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[11726]=n;c[k>>2]=(c[d>>2]|0)-n;b=46896;s=+mt(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[11726]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[11728]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[5865]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[5865]}q=c[11732]|0;m=q+1|0;c[11732]=m;}while((q|0)<(t|0));i=j;return 0}function mt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[5905]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[11804]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[11802]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[5905]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[11802]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[11802]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[5905]=t;u=u+5|0;}while((u|0)<=(m|0));c[11802]=u;k=t;i=g;return+k}}while(0);c[11806]=1;c[11808]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[11806]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[11808]=u;y=u}else{y=1}u=c[a>>2]|0;c[11802]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[5905]=t;x=C+(c[d>>2]|0)|0;c[11806]=x;y=B+(c[f>>2]|0)|0;c[11808]=y;a=z+1|0;c[11802]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function nt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[11744]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[11750]=n;o=c[d>>2]|0;p=c[11744]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[11752]=o;do{if((q|0)>(n|0)){c[11760]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[11748]=s;t=c[e>>2]|0;c[11736]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[11736]=t+1}u=r+1|0;c[11760]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[11760]=o;c[11758]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[11740]=1;t=o;o=1;while(1){c[11762]=o+1;p=t+1|0;c[11760]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[11736]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[11736]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[11754]=s;c[l>>2]=s+1;s=it(l,a+((c[11744]|0)+b+(fa(o,m)|0)<<3)|0,46896)|0;p=s+ -1|0;c[11742]=p+(c[11744]|0);s=c[11740]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[11742]|0;p=c[11740]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[11744]|0;if((s|0)==(u|0)){y=s}else{h[5873]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[5873];y=u}h[5873]=-1.0/+h[a+(y+b+n<<3)>>3];jt(47016,46984,a+(y-m+n<<3)|0,46896)|0;u=c[11758]|0;z=(c[g+((c[11740]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[11758]=u;A=c[11744]|0;c[11756]=A;z=c[11762]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[11738]=z;B=z;z=A;while(1){A=(c[11742]|0)+ -1|0;c[11742]=A;C=z+ -1|0;c[11756]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[5873]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[5873];F=C}C=46896;kt(47016,46984,a+((c[11744]|0)-m+(fa(c[11740]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[11738]|0;D=C+1|0;c[11738]=D;if((C|0)>=(u|0)){break a}B=D;z=c[11756]|0}}}while(0);n=c[11740]|0;s=n+1|0;c[11740]=s;if((n|0)>=(r|0)){break}t=c[11760]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[11744]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function ot(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[11768]=n;f=c[d>>2]|0;o=f+ -1|0;c[11780]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[11764]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[11778]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[11766]=k;q=j+(k+ -1<<3)|0;h[5885]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[5885]}k=46896;kt(47112,47080,a+((c[11768]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[11764]|0;f=k+1|0;c[11764]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[11772]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[11764]=k;q=c[11768]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[11778]=s;u=q-s|0;c[11774]=u;q=k-s|0;c[11776]=q;h[5885]=-t;s=46896;kt(47112,47080,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[11772]|0;r=s+1|0;c[11772]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[11764]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[11778]=r;s=o-r|0;c[11774]=s;q=n-r|0;c[11776]=q;r=46896;t=+mt(47112,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[5885]=t;r=c[11764]|0;q=j+(r+ -1<<3)|0;o=c[11768]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[11764]=n;}while((r|0)<(f|0));v=o;w=c[11780]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[11772]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[11764]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[11778]=(n|0)<=(b|0)?n:b;b=46896;t=+mt(47112,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[11764]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[11766]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[5885]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[5885]}n=c[11772]|0;b=n+1|0;c[11772]=b;if((n|0)>=(w|0)){break}o=c[11768]|0;v=b}i=l;return 0}function pt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[11792]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[11790]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[11790]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[11790]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[11790]=o;i=g;return 0}}while(0);c[11794]=1;c[11796]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[11794]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[11796]=o;q=o}else{q=1}o=c[a>>2]|0;c[11790]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[11794]=p;q=s+(c[f>>2]|0)|0;c[11796]=q;a=r+1|0;c[11790]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function qt(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+rt(47272);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+st(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+st(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+st(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+st(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function rt(a){a=a|0;i=i;return+(+h[47280+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function st(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function tt(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+rt(47312);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Fe[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+st(b,e);c[E>>2]=2;Fe[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){Bt(b,b,f,g,47320,N,47312,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+st(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=JW(ga|0,0,Z+ -2|0,0)|0;Z=CW(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}At(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Fe[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);qt(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+st(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Fe[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+st(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+st(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+st(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}Dt(b,b,s,t,v,w,x,D)|0;Ct(b,b,f,g,w,x)|0;W=47312;Ct(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Fe[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Fe[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function ut(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[47344]=1;f=d[b]|0;c[11832]=f;b=d[e]|0;c[11834]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[11832]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[11834]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function vt(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[56876>>2]=6;rK(56872)|0;IJ(57616,j,4)|0;$J()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[13520]=0;c[14126]=0;c[14114]=0;a[56480]=0;t=c[e>>2]|0;c[13074]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[13520]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[13074]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[13074]=1;if((v|0)>=1){x=1;while(1){h[48768+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[13074]=v+1}c[14118]=2;x=c[e>>2]|0;c[13074]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[13076]=1;if((E|0)<1){F=C}else{G=1;while(1){h[48768+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[13076]=E+1;F=+h[B>>3]}h[48768+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[14118]=G;D=G}G=z+1|0;c[13074]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[13520]|0;y=z+1|0;c[13516]=y;c[13074]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[13076]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[48768+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[13076]=x+1}ke[u&63](e,b,52128+(z+ -1<<3)|0)|0;c[14126]=(c[14126]|0)+1;if((c[j>>2]|0)>=1){c[56900>>2]=6;rK(56896)|0;IJ(57616,56504,4)|0;IJ(57616,52128+((c[13074]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[13076]=1;if((v|0)>=1){A=1;do{IJ(57616,b+(A+ -1<<3)|0,8)|0;B=c[13076]|0;A=B+1|0;c[13076]=A;}while((B|0)<(v|0))}$J()|0}v=c[13074]|0;z=v+1|0;c[13074]=z;}while((v|0)<(y|0))}y=c[14114]|0;b:while(1){c[14114]=y+1;c[14026]=1;c[14022]=1;C=+h[6516];h[7012]=C;h[7014]=C;z=c[13516]|0;c[13074]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[52128+(A+ -1<<3)>>3];do{if(!(C<=K)){c[14026]=A;L=+h[52128+(A+ -1<<3)>>3];h[7012]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[14022]=A;L=+h[52128+(A+ -1<<3)>>3];h[7014]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[13074]=z+1;H=O}A=c[e>>2]|0;c[13074]=1;if((A|0)>=1){v=1;while(1){h[54248+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[13074]=A+1}c[13074]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[13076]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=54248+(Q+ -1<<3)|0;h[B>>3]=+h[48768+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[13076]=x+1;P=v}}while(0);v=P+1|0;c[13074]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[13076]=1;if((z|0)>=1){K=+(c[13520]|0);v=1;while(1){A=54248+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[13076]=z+1}v=c[e>>2]|0;c[13074]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[54248+(B<<3)>>3];h[56528+(B<<3)>>3]=K+(K- +h[48768+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[13074]=v+1}ke[u&63](e,56528,56520)|0;A=(c[14126]|0)+1|0;c[14126]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[56924>>2]=6;rK(56920)|0;IJ(57616,56504,4)|0;IJ(57616,56520,8)|0;B=c[e>>2]|0;c[13076]=1;if((B|0)>=1){E=1;do{IJ(57616,56528+(E+ -1<<3)|0,8)|0;G=c[13076]|0;E=G+1|0;c[13076]=E;}while((G|0)<(B|0))}$J()|0}}while(0);K=+h[7065];c:do{if(!(K>=+h[7014])){z=c[e>>2]|0;c[13074]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[54248+(v<<3)>>3];h[56696+(v<<3)>>3]=I+(+h[56528+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[13074]=z+1}ke[u&63](e,56696,56688)|0;A=(c[14126]|0)+1|0;c[14126]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[56948>>2]=6;rK(56944)|0;IJ(57616,56504,4)|0;IJ(57616,56688,8)|0;B=c[e>>2]|0;c[13076]=1;if((B|0)>=1){E=1;do{IJ(57616,56696+(E+ -1<<3)|0,8)|0;G=c[13076]|0;E=G+1|0;c[13076]=E;}while((G|0)<(B|0))}$J()|0}}while(0);I=+h[7086];if(I>=+h[7014]){R=118;break}v=c[e>>2]|0;c[13074]=1;A=c[14026]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[48768+((z*21|0)+ -22+A<<3)>>3]=+h[56696+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[13074]=v+1}h[52128+(A+ -1<<3)>>3]=I}else{z=c[13516]|0;c[13074]=1;if((z|0)>=1){B=c[14026]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[52128+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[13074]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[7012])){E=c[e>>2]|0;c[13074]=1;z=c[14026]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[48768+((B*21|0)+ -22+z<<3)>>3]=+h[56528+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[13074]=E+1}h[7012]=K;h[52128+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[13074]=1;if((B|0)>=1){A=c[14026]|0;v=1;while(1){x=v+ -1|0;h[56696+(x<<3)>>3]=+h[48768+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[54248+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[13074]=B+1}ke[u&63](e,56696,56688)|0;v=(c[14126]|0)+1|0;c[14126]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[56972>>2]=6;rK(56968)|0;IJ(57616,56504,4)|0;IJ(57616,56688,8)|0;z=c[e>>2]|0;c[13076]=1;if((z|0)>=1){E=1;do{IJ(57616,56696+(E+ -1<<3)|0,8)|0;x=c[13076]|0;E=x+1|0;c[13076]=E;}while((x|0)<(z|0))}$J()|0}}while(0);I=+h[7086];if(!(I>+h[7012])){A=c[e>>2]|0;c[13074]=1;v=c[14026]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[48768+((B*21|0)+ -22+v<<3)>>3]=+h[56696+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[13074]=A+1}h[52128+(v+ -1<<3)>>3]=I;break}B=c[13516]|0;c[13074]=1;if((B|0)<1){break}else{S=1}do{z=c[14022]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[13076]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=48768+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[48768+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[48768+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[13076]=E+1}ke[u&63](e,b,52128+(S+ -1<<3)|0)|0;G=(c[14126]|0)+1|0;c[14126]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[56996>>2]=6;rK(56992)|0;IJ(57616,56504,4)|0;IJ(57616,52128+((c[13074]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[13076]=1;if((x|0)>=1){G=1;do{IJ(57616,b+(G+ -1<<3)|0,8)|0;T=c[13076]|0;G=T+1|0;c[13076]=G;}while((T|0)<(x|0))}$J()|0}}while(0);z=c[13074]|0;S=z+1|0;c[13074]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[13074]=1;v=c[14026]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[48768+((A*21|0)+ -22+v<<3)>>3]=+h[56528+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[13074]=B+1}h[52128+(v+ -1<<3)>>3]=+h[7065]}A=c[14114]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[7015]=0.0;h[7061]=0.0;A=c[13516]|0;c[13074]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[7061]=0.0/K;c[13074]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[52128+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[7061]=I;c[13074]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[52128+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[7015]=$;c[13074]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[7015]=I;do{if(!(I<=+h[k>>3])){if((c[14126]|0)>(c[g>>2]|0)){break}a[56480]=0;c[14114]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[13074]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[13076]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[48768+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[13076]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[13074]=v+1}ke[u&63](e,b,f)|0;B=(c[14126]|0)+1|0;c[14126]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[57020>>2]=6;rK(57016)|0;IJ(57616,56504,4)|0;IJ(57616,s,8)|0;z=c[e>>2]|0;c[13076]=1;if((z|0)>=1){E=1;do{IJ(57616,b+(E+ -1<<3)|0,8)|0;x=c[13076]|0;E=x+1|0;c[13076]=E;}while((x|0)<(z|0))}$J()|0;ba=c[14126]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[57140>>2]=6;rK(57136)|0;$J()|0;c[57164>>2]=6;rK(57160)|0;B=c[e>>2]|0;c[13074]=1;if((B|0)>=1){A=1;do{IJ(57616,b+(A+ -1<<3)|0,8)|0;v=c[13074]|0;A=v+1|0;c[13074]=A;}while((v|0)<(B|0))}$J()|0;c[57188>>2]=6;rK(57184)|0;IJ(57616,s,8)|0;$J()|0}if(a[56480]&1){I=+h[7061];K=+h[7107]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[56480]=1;da=+h[7061]}h[7107]=da;c[14114]=0;y=0}if((c[j>>2]|0)>=0){c[57212>>2]=6;rK(57208)|0;IJ(57616,56504,4)|0;$J()|0;c[57236>>2]=6;rK(57232)|0;y=c[e>>2]|0;c[13074]=1;if((y|0)>=1){B=1;do{IJ(57616,b+(B+ -1<<3)|0,8)|0;A=c[13074]|0;B=A+1|0;c[13074]=B;}while((A|0)<(y|0))}$J()|0;c[57260>>2]=6;rK(57256)|0;IJ(57616,s,8)|0;$J()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[57284>>2]=6;rK(57280)|0;$J()|0}h[7014]=+h[f>>3];c[14128]=0;y=c[13516]|0;c[13074]=1;if((y|0)>=1){B=1;while(1){A=52128+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[13074]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[13076]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=48768+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[56696+(E+ -1<<3)>>3]=+h[48768+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[13076]=v+1}ke[u&63](e,56696,A)|0;c[14128]=(c[14128]|0)+1;c[14126]=(c[14126]|0)+1;E=c[13074]|0;I=+h[52128+(E+ -1<<3)>>3];if(I>=+h[7014]){B=E;continue}h[7014]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[57308>>2]=6;rK(57304)|0;IJ(57616,56504,4)|0;IJ(57616,56112,8)|0;E=c[e>>2]|0;c[13076]=1;if((E|0)>=1){z=1;do{IJ(57616,56696+(z+ -1<<3)|0,8)|0;G=c[13076]|0;z=G+1|0;c[13076]=z;}while((G|0)<(E|0))}$J()|0;B=c[13074]|0}}B=c[13520]|0;c[13074]=1;do{if((B|0)<1){h[6541]=+h[6516];c[13074]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[13084]=E;z=c[e>>2]|0;c[13076]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[56528+(A+ -1<<3)>>3]=(+h[48768+(v+ -21<<3)>>3]+ +h[48768+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[13076]=z+1}ke[u&63](e,56528,54088+(y+ -1<<3)|0)|0;c[14128]=(c[14128]|0)+1;c[14126]=(c[14126]|0)+1;A=c[13074]|0;y=A+1|0;c[13074]=y;}while((A|0)<(B|0));y=c[13520]|0;I=+h[6516];h[6541]=I;c[13074]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[13084]=A;c[13086]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[13076]=1;E=1;while(1){v=E+1|0;c[13088]=v;G=c[e>>2]|0;c[13078]=1;if((G|0)>=1){x=c[13086]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[56696+(T+ -1<<3)>>3]=(+h[48768+(U+x<<3)>>3]+ +h[48768+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[13078]=G+1}ke[u&63](e,56696,56688)|0;c[14128]=(c[14128]|0)+1;c[14126]=(c[14126]|0)+1;T=c[13074]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[13076]|0;la=U+x|0;c[13080]=la;I=+h[6541];h[54408+(la+ -1<<3)>>3]=(+h[7086]+I- +h[54088+(v<<3)>>3]- +h[54088+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[13076]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[13074]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[13520]|0;c[13080]=0;c[13074]=1;E=(y|0)<1;if(E){c[13074]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=JW(A|0,0,y+ -2|0,0)|0;A=CW(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[54408+(U+ -1<<3)>>3]=(+h[52128+(v<<3)>>3]+ka- +h[54088+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[13084]=v+1;c[13080]=(z|1)+A;c[13074]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=54088+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[52128+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[13084]=T+1;c[13074]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[13080]=0;c[13074]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[13074]=1;if((B|0)>=1){A=1;while(1){h[56128+(A+ -1<<3)>>3]=+h[48768+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[13074]=B+1}c[13074]=1;do{if(ma){c[13074]=1}else{A=1;while(1){z=A+1|0;c[13084]=z;v=c[e>>2]|0;c[13076]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=48768+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[48768+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[13076]=v+1}c[13074]=z;if((A|0)<(na|0)){A=z}else{break}}c[13074]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[13084]=A;y=c[e>>2]|0;c[13076]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[48768+(T+oa<<3)>>3]=+h[48768+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[13076]=y+1}c[13074]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=54408;wt(B,54080,B,56288,56864,q,56448)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[57332>>2]=6;rK(57328)|0;$J()|0}c[q>>2]=2;if((c[14126]|0)>(c[g>>2]|0)){R=312;break}c[57356>>2]=6;rK(57352)|0;$J()|0;B=c[e>>2]|0;c[13074]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[13074]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[57044>>2]=6;rK(57040)|0;IJ(57616,g,4)|0;$J()|0;c[57068>>2]=6;rK(57064)|0;IJ(57616,56120,8)|0;$J()|0;c[57092>>2]=6;rK(57088)|0;u=c[e>>2]|0;c[13074]=1;if((u|0)>=1){E=1;do{IJ(57616,b+(E+ -1<<3)|0,8)|0;z=c[13074]|0;E=z+1|0;c[13074]=E;}while((z|0)<(u|0))}$J()|0;c[57116>>2]=6;rK(57112)|0;IJ(57616,s,8)|0;$J()|0;i=r;return 0}else if((R|0)==226){u=c[13520]|0;c[14124]=u-(c[14216]|0);c[13074]=1;E=(u|0)<1;do{if(E){h[7058]=0.0;c[13074]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[52128+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=52128+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[54408+(sa+ -1<<3)>>3]*+h[54088+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[13080]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[13076]=z;h[7058]=0.0;c[13074]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[52128+(v<<3)>>3]*+h[54088+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[7058]=wa;c[13074]=u+1;qa=wa}}while(0);h[7058]=+h[6541]-qa;s=c[e>>2]|0;c[13074]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[56696+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=56696+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[52128+(T+ -1<<3)>>3]*+h[48768+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[13074]=s+1;c[13076]=xa}v=c[e>>2]|0;c[13074]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=56128+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[56696+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[13074]=v+1}if((c[j>>2]|0)>=0){c[57380>>2]=6;rK(57376)|0;IJ(57616,56464,8)|0;z=c[e>>2]|0;c[13074]=1;if((z|0)>=1){s=1;do{IJ(57616,56128+(s+ -1<<3)|0,8)|0;u=c[13074]|0;s=u+1|0;c[13074]=s;}while((u|0)<(z|0))}$J()|0;c[57404>>2]=6;rK(57400)|0;$J()|0}z=c[e>>2]|0;c[13074]=1;if((z|0)>=1){s=c[13520]|0;v=1;while(1){c[13076]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[52128+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=52128+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[54408+(Aa+ -1<<3)>>3]*+h[48768+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[13080]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[13078]=E;c[13076]=s+1}T=c[e>>2]|0;c[13076]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=52384+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[52128+(Ea+ -1<<3)>>3]*+h[48768+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[13076]=T+1;c[13080]=Ca;c[13078]=Da}za=v+1|0;c[13074]=za;if((v|0)<(z|0)){v=za}else{break}}}c[13076]=0;v=c[e>>2]|0;c[13074]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[52384+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[13076]=Ga;c[13074]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[57428>>2]=6;rK(57424)|0;IJ(57616,56496,4)|0;$J()|0;c[13518]=1;z=1;d:while(1){c[13080]=z;do{if((z|0)>(c[e>>2]|0)){s=c[13518]|0;if((s|0)==1){c[57452>>2]=6;rK(57448)|0;$J()|0;wt(52384,54080,54408,56288,56864,q,56448)|0;c[57476>>2]=6;rK(57472)|0;$J()|0;c[13518]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[13518]=2;c[13090]=0;c[13092]=0;s=c[e>>2]|0;c[13074]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=JW(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=CW(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=52384+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=52384+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[52384+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[13094]=Na;c[13092]=Ta;c[13090]=Ia;c[13076]=Ma;c[13074]=s+1}c[57500>>2]=6;rK(57496)|0;$J()|0;c[13090]=0;u=c[e>>2]|0;c[13074]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=52384+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[13090]=Wa;c[13074]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[13090]=T;s=c[e>>2]|0;c[13074]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[13084]=B;Qa=za+la|0;c[13090]=Qa;Pa=B+5|0;c[13086]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[13518]|0)==3){c[57572>>2]=6;rK(57568)|0;Pa=c[13086]|0;Qa=c[13084]|0;c[13076]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{IJ(57616,54408+(B+ -1<<3)|0,8)|0;Qa=c[13076]|0;B=Qa+1|0;c[13076]=B;}while((Qa|0)<(Pa|0))}$J()|0}else{c[57548>>2]=6;rK(57544)|0;Pa=c[13086]|0;B=c[13084]|0;c[13076]=B;if((B|0)<=(Pa|0)){x=B;do{IJ(57616,52384+(x+ -1<<3)|0,8)|0;B=c[13076]|0;x=B+1|0;c[13076]=x;}while((B|0)<(Pa|0))}$J()|0}Pa=c[13074]|0;x=Pa+1|0;c[13074]=x;if((Pa|0)>=(s|0)){break e}E=c[13080]|0;la=c[13090]|0;za=x}}}while(0);c[57596>>2]=6;rK(57592)|0;$J()|0;z=(c[13080]|0)+6|0}c[57524>>2]=6;rK(57520)|0;IJ(57616,56512,4)|0;$J()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ke[p&63](e,b,f)|0;i=r;return 0}function wt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[14424]=c[b>>2];c[g>>2]=1;if((c[14424]|0)<1){i=k;return 0}c[g>>2]=0;xt(a,57696,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[14424]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[14416]=f;c[14422]=g;c[14428]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=JW(a|0,0,g+ -2|0,0)|0;m=CW(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[14408]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=JW(p|0,0,a-n|0,0)|0;p=CW(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[14408]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[14406]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[14406]=j}c[14418]=g;c[14420]=f;c[14426]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[7207]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[7207]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[7207]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[14426]=D;E=v+ -1|0;c[14418]=E;F=w+ -1|0;c[14420]=F;q=D;v=E;w=F}c[14410]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[14412]=t;c[14422]=0;c[14428]=l-g;i=k;return 0}function xt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[7221]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[7221]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[7221];c[14432]=1;c[14434]=0;n=c[b>>2]|0;c[14446]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[14436]=0;c[14448]=1;do{if((o|0)>=1){p=1;q=c[14434]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[7220]=m;u=(p|0)==(o|0);if(u){l=m*+h[7221];h[7222]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[7220]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[7222]=+h[7222]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[14436]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[14436]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[7220];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[14448]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[14430]=y;c[14438]=x;c[14434]=s;break}else if((D|0)==26){D=0;c[14430]=y;c[14438]=x;c[14434]=s;break}}}while(0);m=+V(+(+h[7222]));h[7222]=m;H=+h[7220];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[14434]|0)+ -1<<3)>>3]=G;G=+h[7222]/+h[7220];h[j+((c[14430]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[14434]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[14432]|0;O=c[14446]|0}}while(0);b=N+O|0;c[14432]=b;o=O+1|0;c[14446]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[14430]=y;c[14438]=x;c[14434]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function yt(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[14472]=n;o=(c[d>>2]|0)-n|0;c[14494]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[14492]=s;a[57912]=1;t=c[b>>2]|0;u=t+1|0;c[14488]=u;v=c[b>>2]|0;w=u+v|0;c[14486]=w;u=w+(c[b>>2]|0)|0;c[14490]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[14480]=w;x=w+(c[d>>2]|0)|0;c[14474]=x;y=x+(c[b>>2]|0)|0;c[14476]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[14482]=z;A=z+(c[d>>2]|0)|0;c[14496]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[14498]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[14470]=C;D=C+(c[b>>2]|0)|0;c[14484]=D;zt(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,57968,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);rK(58e3)|0;$J()|0;i=m;return 0}function zt(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[7335]=.5;h[7326]=1.0;h[7366]=.1;F=(c[a>>2]|0)+1|0;c[14648]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[14640]=H;I=(c[b>>2]|0)-F|0;c[14694]=I;F=c[j>>2]|0;c[14748]=(F|0)<1?1:F;F=c[a>>2]|0;c[14632]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[14634]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[14634]=J+1}L=c[u>>2]|0;c[14630]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[14630]=L+1}K=j+1|0;c[14632]=K;if((j|0)<(F|0)){j=K}else{break}}}c[14636]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[14636]=H+1}H=c[b>>2]|0;c[14634]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[14632]=M;c[14634]=H+1}N=+h[e>>3];O=N*N;h[7371]=O;h[7357]=+h[7326]/O;h[7358]=+V(+(+h[7335]))/O;c[14638]=0;H=y;y=A;M=0;a:while(1){c[14650]=M;F=M-(c[a>>2]|0)|0;c[14674]=F;j=M+1|0;c[14638]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[14724]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[14662]=L;K=L+G|0;c[14660]=K;if((K|0)>(c[a>>2]|0)){c[14724]=L;G=K-(c[a>>2]|0)|0;c[14662]=G;c[14660]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[7348]=O;L=c[14648]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[7348]=N;R=N}else{R=O}O=+h[e>>3];h[7349]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[7349]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[7349];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[14632]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[14632]=S+1}if((M|0)>=(c[14748]|0)){T=j;U=159;break}while(1){ke[H&63](a,d,58512)|0;if((c[g>>2]|0)==3){rK(59040)|0;IJ(59208,58552,4)|0;IJ(59208,58512,8)|0;I=c[a>>2]|0;c[14630]=1;if((I|0)>=1){F=1;do{IJ(59208,d+(F+ -1<<3)|0,8)|0;L=c[14630]|0;F=L+1|0;c[14630]=F;}while((L|0)<(I|0))}$J()|0}I=c[14638]|0;do{if((I|0)>(c[b>>2]|0)){F=c[14678]|0;if((F|0)==-1){break a}h[7367]=0.0;c[14636]=0;L=c[a>>2]|0;c[14632]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[7367]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[7340]=N;if((X|0)==(G|0)){ea=N*+h[7335];h[7340]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[7367]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[14636]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[14630]=Y;c[14632]=L+1;W=Z}J=c[b>>2]|0;c[14634]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[7367]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[14634]=J+1;ia=ja}O=+h[7314];ba=+h[7343];N=O-ba-ia;h[7334]=N;h[7353]=+h[7352];h[7352]=+h[7351];if(!(N>=0.0)){ka=-N}else{ka=N}h[7351]=ka;if(+h[7363]>+h[7329]){c[14722]=I}h[7359]=ba;do{if(O<ba){h[7343]=O;h[7376]=0.0;G=c[a>>2]|0;c[14630]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[7376]=+h[7376]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[14630]=G+1;h[A>>3]=ma}}while(0);c[14720]=F;if((F|0)<=0){O=+h[7367];if(O>=0.0){U=190;break a}ba=+h[7314];N=+h[7359];ea=(ba-N)/O;h[7364]=ea;O=+h[7366];do{if(!(ea<=O)){na=+h[7335]*+h[7356];h[A>>3]=na;oa=+h[7363];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[7356]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[7356]=qa;ra=qa;break}}else{qa=+h[7335]*+h[7363];h[7356]=qa;ra=qa}}while(0);ea=+h[7329];if(!(ra<=ea*1.5)){sa=ra}else{h[7356]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[7371]=ea;c[14736]=0;h[7372]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[14692]|0;c[14736]=J;oa=+h[7326];h[7372]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[14634]=1;if((J|0)<1){va=F}else{L=c[14694]|0;oa=ua;K=1;ca=F;while(1){h[7354]=0.0;c[14632]=1;if((L|0)<1){wa=0.0}else{X=c[14654]|0;aa=K+C|0;qa=+h[7326];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[7340]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[7354]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[14632]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[7336]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[7340]=za;h[7375]=0.0;$=c[a>>2]|0;c[14632]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[7375]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[14632]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[7340]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[7372]=Fa;c[14678]=K;Ga=Fa;Ha=K}aa=K+1|0;c[14634]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Ft(a,b,s,t,58616,u,w,58688,58712,x)|0;ca=c[14678]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[7314];c[14636]=0;J=c[a>>2]|0;c[14630]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[7340]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[7340];G=G+1|0;da=da+1|0}da=X+aa|0;c[14636]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[14632]=La;c[14630]=J+1}h[L>>3]=0.0;X=c[14694]|0;c[14632]=1;aa=(X|0)<1;if(!aa){F=c[14654]|0;K=1;while(1){da=fa(K,B)|0;O=+h[7334]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[7340]=Oa;G=c[b>>2]|0;c[14634]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[7340];$=$+1|0}c[14634]=G+1}$=K+1|0;c[14632]=$;if((K|0)<(X|0)){K=$}else{break}}}h[7345]=0.0;K=c[a>>2]|0;c[14630]=1;if((K|0)>=1){F=1;while(1){O=+h[7334]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[7345]=+h[7345]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[14630]=K+1;h[A>>3]=Pa}F=c[14720]|0;do{if((F|0)==0){if(!(+h[7356]==+h[7329])){break}O=+h[7364];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[14740]=0;break}L=c[b>>2]|0;c[14634]=1;if((L|0)>=1){J=o+((c[14692]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[14634]=L+1}h[7338]=0.0;$=c[a>>2]|0;c[14630]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[7332]=0.0;G=c[b>>2]|0;c[14634]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[7332]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[14634]=G+1;Sa=Ta}h[7338]=+h[7338]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[14630]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[7338]*100.0}J=c[14740]|0;c[14740]=J+1;if(+h[7345]<Ra){c[14740]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[14630]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[14630]=J+1}$=c[14640]|0;c[14636]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[14636]=$+1}c[14632]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[14634]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[14634]=Na+1;Ua=Wa}if((L|0)<(c[14654]|0)){h[J>>3]=-Ua}Va=L+1|0;c[14632]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[14634]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[14632]=Xa;c[14634]=L+1}c[14740]=0}}while(0);O=+h[7314];ea=+h[7359];if(O<ea){c[14692]=ca}oa=+h[7366];if(O<=ea+oa*+h[7367]|(F|0)>0){U=54;break}c[14678]=0;Ia=0;Ja=+h[7356];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[7314];oa=+h[7314];do{if((I|0)==1){h[7333]=oa;h[7343]=oa;c[14692]=1;Ya=1}else{if(!(oa<+h[7343])){Ya=I;break}h[7343]=oa;c[14692]=I;Ya=I}}while(0);F=c[14650]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[14660]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[14662]|0;Va=K+aa|0;c[14636]=Va;if(+h[7348]<0.0){aa=X+(c[a>>2]|0)|0;c[14660]=aa;Za=aa}else{Za=X}if(+h[7349]<0.0){X=K+(c[a>>2]|0)|0;c[14662]=X;_a=X}else{_a=K}K=fa(c[14674]|0,B)|0;h[t+(K-B<<3)>>3]=+h[7357];h[t+(Ya+C+K<<3)>>3]=+h[7357];h[t+(Za-B+K<<3)>>3]=-+h[7357];h[t+(_a-B+K<<3)>>3]=-+h[7357];h[q+(Va+ -1<<3)>>3]=(+h[7333]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[7314])/(+h[7348]*+h[7349])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[14674]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[7335]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[7335]/+h[e>>3];ea=+h[7358];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[7358];h[t+(X+K<<3)>>3]=+h[7358];K=(fa(Va+1|0,Va)|0)/2|0;c[14636]=K;ea=(+h[7333]- +h[7314])/+h[e>>3];h[7340]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[7335]*(+h[X>>3]+ +h[7340]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[7333])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[7326]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[7326]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[7335]*+h[7371]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[7329]=oa;h[7356]=oa;c[14654]=1;h[7351]=0.0;h[7352]=0.0;c[14740]=0;h[7376]=0.0;F=c[a>>2]|0;c[14630]=1;if((F|0)<1){U=53;break}ca=c[14692]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[7376]=+h[7376]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[14630]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[14722]=c[14638];U=54;continue}else if((U|0)==54){U=0;c[14678]=0;I=(c[14648]|0)+ -1|0;K=c[a>>2]|0;Et(a,b,l,n,p,q,r,58848,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,58984)|0;h[7328]=0.0;K=c[a>>2]|0;c[14630]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[7328]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[14630]=K+1;ab=cb}oa=+h[7356];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[7363]=O;ea=+h[7329];if(!(O<+h[7335]*ea)){db=ab;U=62;break}c[14678]=-1;O=+h[7366];N=O*oa;h[7356]=N;h[7364]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[7356]=ea;eb=ea}if((c[14638]|0)<=((c[14722]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[7373]*.125*ea;h[7340]=N;oa=+h[7351];ba=+h[7352];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[7353];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[7375]=O;I=c[b>>2]|0;c[14634]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[7332]=0.0;X=c[a>>2]|0;c[14632]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[7332]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[14632]=X+1;jb=lb}if(jb>ea){c[14678]=F;h[7375]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[14634]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[7364]>0.0){U=54;continue}ea=+h[7363];O=+h[7329];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[7335];h[7356]=O;ea=hb/+h[f>>3];h[7364]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[7329]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[7329]=na;ob=na;break}}else{na=+h[f>>3];h[7329]=na;ob=na}}while(0);h[7356]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){rK(59088)|0;$J()|0}rK(59112)|0;IJ(59208,58632,8)|0;IJ(59208,58552,4)|0;$J()|0;rK(59136)|0;IJ(59208,58744,8)|0;ca=c[a>>2]|0;c[14630]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];IJ(59208,y,8)|0;I=c[14630]|0;F=I+1|0;c[14630]=F;}while((I|0)<(ca|0))}$J()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[7335]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[7329];O=na>=ea?na:ea;h[7365]=O;ea=O*O;h[7328]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[7376];if(db<=ea*.001){h[7369]=ea*.25;ca=c[b>>2]|0;c[14634]=1;if((ca|0)>=1){F=1;while(1){h[7332]=0.0;I=c[a>>2]|0;c[14630]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[7332]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[14630]=I+1;pb=qb}h[7340]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[7335]*+h[7376];h[7332]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[14630]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[7340]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[7335]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[7332]*+h[n+(F+C+Va<<3)>>3]+ +h[7369]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[14642]=aa;c[14632]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[14632]=Va;rb=Va}c[14630]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[14634]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[14694]|0;c[14634]=1;if((F|0)>=1){ca=1;while(1){h[7350]=0.0;X=c[b>>2]|0;c[14630]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[7350]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[14630]=I;if((K|0)>=(X|0)){break b}O=+h[7350];K=I}}}while(0);X=c[a>>2]|0;c[14632]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[7369]*+h[7350]*+h[l+(I<<3)>>3];h[7332]=O;Va=c[b>>2]|0;c[14630]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[7332]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[14630]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[14654]|0)){h[7332]=-+h[7332]}L=c[b>>2]|0;c[14630]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[7332]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[14630]=L+1}J=K+1|0;c[14632]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[14630]=1;if((K|0)>=1){X=c[14654]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[14642]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[7340]=ub;c[14632]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[7340];aa=aa+1|0}aa=J+1|0;c[14632]=aa;vb=aa}c[14630]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[14634]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[14636]=0;ca=c[a>>2]|0;c[14632]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[14634]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[7335]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[14634]=aa+1}c[14630]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[14636]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[14630]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[14632]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[14632]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[14632]=J+1}h[7376]=0.0}if((c[14678]|0)>0){F=(c[14648]|0)+ -1|0;Rs(a,b,l,n,s,t,58616,u,58712,58920,v,58840,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[14634]=1;if((F|0)>=1){L=1;while(1){h[7341]=0.0;h[7342]=0.0;h[7332]=0.0;ca=c[a>>2]|0;c[14632]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[7341]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[7342]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[7332]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[14632]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[7335]+Ab);h[w+(K<<3)>>3]=+h[7332];K=L+1|0;c[14634]=K;if((L|0)<(F|0)){L=K}else{break}}}h[7336]=0.0;L=c[14694]|0;c[14634]=1;if((L|0)>=1){F=1;while(1){h[7332]=0.0;J=c[b>>2]|0;c[14630]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[7332]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[14630]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[7336];if((F|0)<(c[14654]|0)){h[7336]=O+ea;na=-Eb;h[7332]=na;Gb=na}else{h[7336]=O-ea;Gb=Eb}K=c[b>>2]|0;c[14630]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[7332];X=X+1|0}c[14630]=K+1}X=F+1|0;c[14634]=X;if((F|0)<(L|0)){F=X}else{break}}}h[7344]=0.0;h[7323]=0.0;F=c[a>>2]|0;c[14632]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[7332]=0.0;X=c[b>>2]|0;c[14630]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[7332]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[14630]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[7344]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[14644]=K;Va=c[a>>2]|0;c[14634]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[7332]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[14634]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[7344]+ +h[7332]*+h[ca>>3];h[7344]=O;na=+h[7323]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[7323]=na;aa=L+1|0;c[14632]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[7328];h[7336]=+h[7336]+(Ib*Ib+ea*(Ib+(Ib+ +h[7376])+ea*+h[7335]))-Hb;L=w+((c[14692]|0)+ -1<<3)|0;h[L>>3]=+h[7326]+ +h[L>>3];L=c[14678]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[7326]+ +h[7355]*+h[7336]/(ea*ea);h[7340]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;Qs(a,b,l,n,s,t,58616,u,58768,58712,v,x,w,58688,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[14630]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[14630]=L+1}F=c[14638]|0;aa=F+1|0;c[14638]=aa;if((F|0)>=(c[14748]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[14638]=T+ -1;if((c[g>>2]|0)<=0){break}rK(59016)|0;$J()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}rK(59064)|0;$J()|0}}while(0);Nb=+h[7343];if(Nb<=+h[7314]){U=c[a>>2]|0;c[14630]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[14630]=U+1;Ob=+h[7343]}h[7314]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}rK(59160)|0;IJ(59208,58552,4)|0;$J()|0;rK(59184)|0;IJ(59208,58512,8)|0;g=c[a>>2]|0;c[14630]=1;if((g|0)>=1){a=1;do{IJ(59208,d+(a+ -1<<3)|0,8)|0;U=c[14630]|0;a=U+1|0;c[14630]=a;}while((U|0)<(g|0))}$J()|0;i=z;return 0}function At(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){uW(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){uW(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function Bt(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+rt(59216);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+st(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+st(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+st(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function Ct(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function Dt(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+rt(59224);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=JW(u|0,0,t+ -2|0,0)|0;t=CW(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function Et(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[7423]=.5;h[7441]=6.283185307179586;v=+h[l>>3];h[7436]=v*v;c[14868]=0;l=c[b>>2]|0;c[14886]=l;c[14884]=l;w=c[b>>2]|0;c[14808]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[14808]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[14808]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[14808]=w+1}z=c[d>>2]|0;c[14812]=1;if((z|0)>=1){e=1;while(1){h[7427]=0.0;A=c[b>>2]|0;c[14810]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[7427]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[14810]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[7427]=v;C=c[b>>2]|0;c[14808]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[7427];F=F+1|0}c[14808]=C+1}F=e+1|0;c[14812]=F;if((e|0)<(z|0)){e=F}else{break}}}c[14822]=0;e=c[b>>2]|0;c[14810]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[14822]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[14808]=H;c[14810]=e+1}do{if((y|0)==0){h[7425]=0.0;h[7407]=0.0;w=c[b>>2]|0;c[14808]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[7407]=+h[7407]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[14808]=w+1}h[r>>3]=0.0;D=+h[7407];if(D==0.0){O=55;break a}h[7412]=0.0;h[7415]=0.0;h[7410]=D;h[7430]=D;P=D;Q=0.0;R=0.0;S=+h[7436];T=0}else{if((y|0)>(x|0)){h[7409]=0.0;h[7416]=0.0;h[7417]=0.0;z=c[b>>2]|0;c[14808]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7409]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[7416]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[7417]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[14808]=z+1;U=ba;W=$;Z=aa}D=+h[7423];v=D*(+h[7420]-Z);h[7408]=v;_=+h[7413];ca=_+v;h[7424]=ca;h[7428]=ca;h[7426]=ca;c[14878]=0;a[59312]=1;da=+h[7441]/50.0;h[7427]=da;c[14808]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[7426]=ka;c[14878]=w;h[7437]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[7438]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[7432]=ha;h[7418]=ia;h[7421]=ja;h[7429]=ka;c[14808]=50;h[7428]=ka;if((la|0)==49){h[7438]=ca;na=ca}else if((la|0)==0){h[7437]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[7438]}h[7432]=0.0;ga=+h[7437];if(ga!=na){ea=ga-ma;h[7437]=ea;ga=na-ma;h[7438]=ga;oa=D*(ea-ga)/(ea+ga);h[7432]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[7432]=oa;ga=+X(+oa);h[7418]=ga;ea=+Y(+oa);h[7421]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[7433]=oa;h[7410]=0.0;w=c[b>>2]|0;c[14808]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[7418]*+h[J>>3]+ +h[7421]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[7410]+sa*sa;h[7410]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[7421];ea=+h[7418];F=F+1|0;z=K}c[14808]=w+1;qa=ta;ra=+h[7433]}ea=ra+ +h[7425];h[7425]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[7416]=0.0;z=c[b>>2]|0;c[14810]=1;do{if((z|0)<1){ea=+h[7440];h[7431]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[7416]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[14810]=z+1;ea=+h[7440];h[7431]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[7407];h[7427]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[7427]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[7431];oa=+h[7410];v=+h[7416];_=oa/v;ca=ea<=_?ea:_;h[7431]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[7410];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[7423]*Ca);h[7422]=ca;h[7425]=+h[7425]+ca;h[7435]=Ba;h[7410]=0.0;z=c[b>>2]|0;c[14808]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[7431]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[7410]+oa*oa;h[7410]=Ga;Ha=+h[7431];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[14808]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[7440]){if(+h[7422]<=+h[7425]*.01){O=55;break a}if(Fa<=+h[7430]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[7435];h[7427]=ca;h[7407]=0.0;h[7412]=0.0;h[7415]=0.0;w=c[b>>2]|0;c[14808]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[7407]+ca*ca;h[7407]=La;J=m+(F<<3)|0;Ma=+h[7412]+ +h[K>>3]*+h[J>>3];h[7412]=Ma;ca=+h[J>>3];Na=+h[7415]+ca*ca;h[7415]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[7427];Ja=Ja+1|0;Ka=J}c[14808]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[7436];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[14884]=y;ua=+h[7410];va=y}if(ua<=+h[7430]*1.0e-4){O=55;break a}h[7413]=0.0;h[7420]=0.0;z=c[b>>2]|0;c[14808]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7413]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[7420]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[14808]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[7419]=ca;oa=+h[7436];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[14868]=J;_=+V(+(v-ca*ca));h[7427]=_;v=oa/_;h[7437]=v;oa=ca/_;h[7438]=oa;w=c[b>>2]|0;c[14808]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[7438];Ta=+h[7437];Ua=Ua+1|0;Va=K}c[14808]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[14868]=e;v=S-R;h[7427]=v;h[7440]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Ft(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[7450]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[14906]=t;c[14896]=1;c[14890]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[14896]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[7452]=D;C=+h[x>>3]/D;h[7459]=C;z=+h[f+(B+y<<3)>>3]/D;h[7460]=z;B=c[d>>2]|0;c[14888]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[7452]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[7452];if((x|0)>=(B|0)){break}D=+h[7460];z=+h[7459];x=x+1|0}c[14888]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[14890]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[7459]=z;if((c[g>>2]|0)>1){D=-z;h[7459]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[7460]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[14888]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[7460]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[7459];t=t+1|0;x=A}c[14888]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[7457]=z;x=k+(w<<3)|0;H=+h[x>>3];h[7451]=H;D=H*H;h[7461]=D;h[7458]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[7450];a[59632]=0;do{if((u|0)==1){z=+h[7458];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[7452]=z;D=+h[7459]/z;h[7460]=D;H=+h[7451]/z;h[7459]=H;x=c[d>>2]|0;c[14888]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[7460];D=+h[7459];w=w+1|0;t=s}c[14888]=x+1;J=+h[7452]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[14892]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[14892]=u;M=u}t=u+1-M|0;c[14894]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[7458];z=+h[f+(t+w<<3)>>3]/D;h[7452]=z;h[7459]=z*+h[l>>3];H=+h[7451];h[7460]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[7452]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[7450]/+V(+(+h[7461]+z*N*z));h[7455]=C;if(!(D>=0.0)){O=-D}else{O=D}h[7456]=C*+V(+O);t=c[d>>2]|0;c[14888]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[7456]*(+h[A>>3]- +h[7459]*+h[n+(G<<3)>>3]- +h[7460]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[7452];z=+h[7451];H=+h[7455];v=v+1|0}c[14888]=t+1;P=+h[7458]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[59632]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[14888]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[7452]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[7452];K=Q+1|0;c[14888]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[14890]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[14898]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[7451];N=+h[7458];J=(+h[7457]*+h[f>>3]-O*P)/N;h[7459]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[7460]=P;c[14888]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[14888]=q;if((f|0)>=(b|0)){break a}N=+h[7460];O=+h[7459];f=q}}}while(0);b=R+1|0;c[14890]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Gt(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Ht(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Gt(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(59696,59712,116,59736)}else if((s|0)==14){i=g;return o|0}return 0}function It(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((mW(w,c[59744+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[59848+(x<<2)>>2]|0;c[q>>2]=c[59744+(x<<2)>>2];c[q+4>>2]=y;tr(23,0,59920,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=QV(D,8)|0;c[e+40>>2]=B;D=b+536|0;wr(c[D>>2]|0,(B|0)!=0|0,59960,p);B=QV(c[A>>2]|0,4)|0;c[e+36>>2]=B;wr(c[D>>2]|0,(B|0)!=0|0,59960,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=QV(c[C>>2]|0,4)|0;c[e+24>>2]=OV(8)|0;C=OV(4)|0;c[e+20>>2]=C;c[C>>2]=c[31920>>2];wr(c[D>>2]|0,(C|0)!=0|0,59960,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=OV(C)|0;A=e+44|0;c[A>>2]=OV(C)|0;C=QV(15,4)|0;E=e+12|0;c[E>>2]=C;wr(c[D>>2]|0,(C|0)!=0|0,59960,m);C=QV(5,4)|0;c[e+4>>2]=C;wr(c[D>>2]|0,(C|0)!=0|0,59960,l);C=QV(5,4)|0;c[e+8>>2]=C;wr(c[D>>2]|0,(C|0)!=0|0,59960,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=OV(C)|0;c[e+76>>2]=OV(C)|0;c[e+80>>2]=OV(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((he[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){tr(23,0,59976,j)}else{tr(1,0,60048,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[31956>>2]|c[7964]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=59880;W=V;xr(Q,W,r)}c[t>>2]=w;vr(23,1,59776,t);t=1;do{w=c[59848+(t<<2)>>2]|0;c[s>>2]=c[59744+(t<<2)>>2];c[s+4>>2]=w;vr(23,0,59832,s);t=t+1|0;}while((t|0)<8);ee[c[8104]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=4;U=T;V=59880;W=V;xr(Q,W,r);return 0}function Jt(a){a=a|0;var b=0;b=i;PV(c[a+40>>2]|0);PV(c[a+36>>2]|0);PV(c[a+20>>2]|0);PV(c[a+12>>2]|0);PV(c[a+4>>2]|0);PV(c[a+8>>2]|0);PV(a);i=b;return 0}function Kt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;wr(c[N>>2]|0,(c[M>>2]|0)!=0|0,60144,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){tr(3,0,60176,B);tr(3,0,60216,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];he[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tr(3,0,60240,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];tr(23,0,60280,y);if((c[z>>2]|0)==1){xs(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Fv(a)|0;he[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 5:{Ts(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 4:{Ts(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 7:{Ts(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{Ts(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{Ts(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){Ts(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{Ts(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){td(_|0)|0;td($|0)|0;vr(3,0,60312,x);tr(3,0,60400,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){td(_|0)|0;td($|0)|0;$=Tt(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Fv(a)|0;he[c[(c[ba>>2]|0)+40>>2]&127](a)|0}he[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];vr(1,0,60424,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[31876>>2]|0)!=0){tr(3,1,60456,u);c[s>>2]=c[z>>2];tr(3,0,60480,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];tr(3,0,60504,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];tr(3,0,60536,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tr(3,0,60576,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];tr(3,0,60624,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];tr(3,0,60672,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];tr(3,0,60712,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];tr(3,0,60752,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];tr(3,0,60792,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];tr(3,0,60840,f);ee[c[8104]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(60880,60912,410,60944)}tr(3,0,60960,e);S=0;i=d;return S|0}function Lt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Fv(g)|0;a=f+540|0;he[c[(c[a>>2]|0)+40>>2]&127](g)|0;he[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Mt(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Fv(l)|0;b=k+540|0;he[c[(c[b>>2]|0)+40>>2]&127](l)|0;he[c[(c[b>>2]|0)+28>>2]&127](l)|0;Vt(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Nt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Fv(g)|0;l=e+540|0;he[c[(c[l>>2]|0)+40>>2]&127](g)|0;he[c[(c[l>>2]|0)+28>>2]&127](g)|0;he[c[(c[l>>2]|0)+32>>2]&127](g)|0;ke[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function Ot(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Wt(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Pt(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Fv(l)|0;b=k+540|0;he[c[(c[b>>2]|0)+40>>2]&127](l)|0;he[c[(c[b>>2]|0)+28>>2]&127](l)|0;Ut(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Qt(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function Rt(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Xt(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function St(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function Tt(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-6:{vr(1,0,61024,j);m=-6;i=b;return m|0};case-12:{vr(1,0,61456,c);m=-12;i=b;return m|0};case-1:{vr(3,0,60312,l);m=1;i=b;return m|0};case-10:{vr(1,0,61272,e);m=-10;i=b;return m|0};case-9:{vr(1,0,61184,f);m=-9;i=b;return m|0};case-11:{vr(1,0,61368,d);m=-11;i=b;return m|0};case-2:{vr(1,0,60984,k);m=-2;i=b;return m|0};case-8:{vr(1,0,61136,g);m=-8;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-7:{vr(1,0,61096,h);m=-7;i=b;return m|0};case-33:{vr(1,0,61504,b);m=-33;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function Ut(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}he[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function Vt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;he[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function Wt(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+sd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+sd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Lt(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function Xt(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+sd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+sd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Lt(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function Yt(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function Zt(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;ee[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function _t(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function $t(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Er(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{we[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Cr(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Er(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function au(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if(($t(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}bu(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Er(d)|0)>0;h=b?2:0;i=e;return h|0}function bu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=OV(q)|0;s=r;t=OV(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[15566]=Ar(4)|0;if((r|0)==0){cb(62272,62288,308,62320)}if((t|0)==0){cb(62336,62288,309,62320)}v=Hr(b)|0;if((v|0)!=0){w=v;do{v=Jr(w)|0;c[l>>2]=c[v>>2];tr(27,0,62352,l);w=Ir(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;sW(t|0,c[a+384>>2]|0,v|0)|0;sW(r|0,l|0,v|0)|0}h[d>>3]=+eu(a,n,o,q,s,c[15566]|0,b);do{if((Er(c[15566]|0)|0)==0){s=Fr(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=Hr(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=Jr(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=Ir(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];tr(27,0,62400,j);v=Hr(b)|0;if((v|0)==0){break}else{B=v}do{v=Jr(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[15566]|0;Dr(v,Jr(B)|0);v=Jr(B)|0;c[g>>2]=c[v>>2];tr(27,0,62424,g)}B=Ir(B)|0;}while((B|0)!=0)}}while(0);Br(b);if((c[31892>>2]|0)!=0){Er(c[15566]|0)|0}if((Er(c[15566]|0)|0)>0){B=m;do{g=Fr(c[15566]|0)|0;c[m>>2]=c[g>>2];Gr(c[15566]|0);c[f>>2]=c[m>>2];tr(7,0,62448,f);Cr(b,B);}while((Er(c[15566]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){sW(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ye(a);hu(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){PV(t);PV(r);i=e;return}sW(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;PV(t);PV(r);i=e;return}function cu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){lu(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tr(7,0,61992,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Er(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[31892>>2]|0)!=0){e=Hr(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=Jr(s)|0;x=c[e>>2]|0;e=we[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;sr(7,0,w,62016,l);s=Ir(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=Jr(Hr(d)|0)|0;x=we[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;sr(1,0,e,62032,j);c[s>>2]=1}}while(0);Br(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;gu(b);du(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function du(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;tr(27,0,62640,b);d=a+344|0;ke[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function eu(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=OV(p<<3)|0;if((q|0)==0){cb(62456,62288,409,62472)}if((p|0)>0){sW(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tr(27,0,62488,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(27,0,62536,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){PV(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Fv(a)|0;he[c[(c[p>>2]|0)+40>>2]&127](a)|0;he[c[(c[p>>2]|0)+28>>2]&127](a)|0;he[c[(c[p>>2]|0)+32>>2]&127](a)|0;ke[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(fu(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}sW(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}PV(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function fu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Br(b);tr(27,0,62560,g);g=Hr(d)|0;if((g|0)==0){j=Er(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=Jr(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=Jr(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=Jr(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=Jr(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=Jr(a)|0;o=c[g>>2]|0;g=Jr(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?61976:61984;g=Jr(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?61976:61984;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;tr(27,0,62600,f);Cr(b,Jr(a)|0)}a=Ir(a)|0;}while((a|0)!=0);j=Er(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function gu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;we[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;hu(b);iu(b);he[c[(c[g>>2]|0)+36>>2]&127](b)|0;ju(b,8);h=ku(b)|0;j=he[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{iu(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}lu(b);hu(b);ju(b,8);he[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=ku(b)|0;j=he[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){xr(c[b+536>>2]|0,62680,e)}else if((o|0)==7){iu(b);i=d;return}}function hu(a){a=a|0;var b=0;b=i;sW(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function iu(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function ju(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[31864+(d<<2)>>2]|0)==0){i=e;return}tr(d,1,63104,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=he[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=he[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;tr(d,0,63128,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}ee[c[8104]&255](d);i=e;return}function ku(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function lu(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;sW(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;sW(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;sW(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;sW(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ke[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function nu(a){a=a|0;var b=0;b=i;ou(a);pu(a);lu(a);qu(a);i=b;return}function ou(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function pu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function qu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((ws(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];sW(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;sW(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;sW(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;sW(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(ws(c[d>>2]|0)|0));i=b;return}function ru(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[31864+(d<<2)>>2]|0)==0){i=e;return}tr(d,1,62776,q);q=b+136|0;if((c[q>>2]|0)>0){tr(d,1,62800,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?62760:62768;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];tr(d,0,62816,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}ee[c[8104]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){tr(d,1,62872,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?62760:62768;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;tr(d,0,62896,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}ee[c[8104]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){tr(d,1,62952,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?62760:62768;v=(a[n+(m*48|0)+40|0]|0)!=0?62760:62768;n=(a[(c[s>>2]|0)+m|0]|0)!=0?62760:62768;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;tr(d,0,62976,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}ee[c[8104]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){tr(d,1,63032,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;tr(d,0,63056,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}ee[c[8104]&255](d)}ee[c[8104]&255](d);i=e;return}function su(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((ws(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];sW(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;sW(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;sW(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;sW(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(ws(c[d>>2]|0)|0));i=b;return}function tu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function uu(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];sW(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;sW(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;sW(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;sW(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function vu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=rs(3,32)|0;c[o>>2]=p;if((p|0)==0){xr(c[b+536>>2]|0,63160,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=QV(c[p>>2]|0,8)|0;c[q>>2]=z;wr(c[r>>2]|0,(z|0)!=0|0,63216,l);z=QV(c[s>>2]|0,4)|0;c[t>>2]=z;wr(c[r>>2]|0,(z|0)!=0|0,63216,k);z=QV(c[u>>2]|0,1)|0;c[v>>2]=z;wr(c[r>>2]|0,(z|0)!=0|0,63216,j);z=QV(c[w>>2]|0,4)|0;c[x>>2]=z;wr(c[r>>2]|0,(z|0)!=0|0,63216,g);vs(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=QV(3,4)|0;c[b+4>>2]=n;xs(c[o>>2]|0,0,n);c[b+8>>2]=QV(c[p>>2]|0,112)|0;c[b+12>>2]=QV(c[s>>2]|0,60)|0;c[b+16>>2]=QV(c[u>>2]|0,48)|0;c[b+20>>2]=QV(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=QV(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=QV(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=QV(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=QV(g,52)|0;c[b+40>>2]=QV(c[b+216>>2]|0,52)|0;c[b+44>>2]=QV(c[b+220>>2]|0,52)|0;c[b+48>>2]=QV(c[b+224>>2]|0,52)|0;c[b+52>>2]=QV(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=QV(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=QV(x,8)|0;c[b+340>>2]=QV(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=QV(x,8)|0;c[b+348>>2]=QV(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=QV(j,1)|0;c[b+356>>2]=QV(j,1)|0;c[b+360>>2]=QV(j,1)|0;j=OV(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=OV(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=QV(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=QV(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=QV(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=QV(u,4)|0;c[b+400>>2]=QV(x,8)|0;c[b+404>>2]=QV(p,4)|0;c[b+408>>2]=QV(s,1)|0;c[b+412>>2]=QV(u,4)|0;c[b+416>>2]=QV(c[n>>2]|0,8)|0;c[b+420>>2]=QV(o,4)|0;c[b+424>>2]=QV(y,1)|0;c[b+428>>2]=QV(g,4)|0;c[b+432>>2]=QV(c[b+152>>2]|0,8)|0;c[b+436>>2]=QV(c[b+156>>2]|0,8)|0;g=OV((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;ee[c[(c[y>>2]|0)+20>>2]&255](g);g=OV((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;ee[c[(c[y>>2]|0)+16>>2]&255](g);g=OV((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;ee[c[(c[y>>2]|0)+12>>2]&255](g);g=OV((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;fe[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=OV((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=QV(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;wr(c[r>>2]|0,(g|0)!=0|0,63232,f);c[b+512>>2]=100;c[b+516>>2]=QV(100,4)|0;c[b+520>>2]=QV(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=OV(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;wr(c[r>>2]|0,(g|0)!=0|0,63216,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=rs(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function wu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;PV(c[g+8>>2]|0);PV(c[g+12>>2]|0);PV(c[g+16>>2]|0);PV(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);PV(e);ss(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){Ps(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}PV(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){Ps(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}PV(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){Ps(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}PV(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){Ps(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}PV(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){Ps(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}PV(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){Ps(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}PV(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){Ps(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}PV(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){Ps(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}PV(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){Ps(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}PV(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){Ps(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}PV(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){Ps(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}PV(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){Ps(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}PV(v);PV(c[a+108>>2]|0);PV(c[a+336>>2]|0);PV(c[a+340>>2]|0);PV(c[a+344>>2]|0);PV(c[a+348>>2]|0);PV(c[a+352>>2]|0);PV(c[a+356>>2]|0);PV(c[a+360>>2]|0);PV(c[a+368>>2]|0);PV(c[a+384>>2]|0);PV(c[a+388>>2]|0);PV(c[a+392>>2]|0);PV(c[a+396>>2]|0);PV(c[a+400>>2]|0);PV(c[a+404>>2]|0);PV(c[a+408>>2]|0);PV(c[a+412>>2]|0);PV(c[a+416>>2]|0);PV(c[a+420>>2]|0);PV(c[a+424>>2]|0);PV(c[a+428>>2]|0);PV(c[a+488>>2]|0);PV(c[a+484>>2]|0);PV(c[a+476>>2]|0);PV(c[a+468>>2]|0);PV(c[a+464>>2]|0);PV(c[a+432>>2]|0);PV(c[a+436>>2]|0);PV(c[a+320>>2]|0);PV(c[a+516>>2]|0);PV(c[a+520>>2]|0);gJ(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;PV(x);i=b;return}else{y=a;z=0}while(1){ss(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;PV(x);i=b;return}function xu(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[7909]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];tr(8,0,63280,d);i=b;return}function yu(a,b){a=+a;b=+b;i=i;return a<b|0}function zu(a,b){a=+a;b=+b;i=i;return a<=b|0}function Au(a,b){a=+a;b=+b;i=i;return a>=b|0}function Bu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=OV(k)|0;c[e+(h*40|0)+24>>2]=OV(k)|0;if((c[g>>2]|0)!=1){l=5;break}Eu(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){xr(c[a+536>>2]|0,63336,d)}else if((l|0)==6){i=b;return 0}return 0}function Cu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){PV(c[e+(h*40|0)+20>>2]|0);PV(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Fu(k)|0;PV(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){xr(c[a+536>>2]|0,63336,d)}else if((j|0)==6){i=b;return 0}return 0}function Du(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[31932>>2]|c[7964]|0)==0){z=w;A=1;break}eJ(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];vr(17,1,63368,g);eJ(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;eJ(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;vr(17,0,63400,f);eJ(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ee[c[8104]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Eu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=OV(20)|0;c[b>>2]=f;wr(0,(f|0)!=0|0,63408,e);e=OV(a)|0;c[f>>2]=e;e=OV(a)|0;c[f+4>>2]=e;e=OV(a)|0;c[f+8>>2]=e;e=OV(a)|0;c[f+16>>2]=e;wr(0,(c[b>>2]|0)!=0|0,63440,d);i=d;return 0}function Fu(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;PV(c[d>>2]|0);PV(c[d+4>>2]|0);PV(c[d+8>>2]|0);PV(c[d+16>>2]|0);i=b;return 0}function Gu(a,b){a=a|0;b=b|0;b=i;i=i+8|0;xr(c[a+536>>2]|0,63488,b);return 0}function Hu(a){a=a|0;a=i;i=i+8|0;xr(0,63488,a);return 0}function Iu(a,b){a=a|0;b=b|0;b=i;i=i+8|0;xr(c[a+536>>2]|0,63488,b);return 0}function Ju(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=OV(l)|0;c[e+(h<<6)+36>>2]=OV(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;Su(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=OV(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;Pu(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){xr(c[a+536>>2]|0,63528,d)}else if((n|0)==8){i=b;return 0}return 0}function Ku(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Lu(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){PV(c[e+(h<<6)+28>>2]|0);PV(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){Qu(e+(h<<6)+24|0)|0;PV(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){Tu(e+(h<<6)+24|0)|0}else{k=6;break}PV(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){xr(c[a+536>>2]|0,63528,d)}else if((k|0)==8){i=b;return 0}return 0}function Nu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=Uu(b,d)|0}else if((h|0)==1){j=Ru(b,d)|0}else{xr(c[b+536>>2]|0,63528,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function Ou(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[31924>>2]|c[7964]|0)==0){z=w;A=1;break}eJ(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];vr(15,1,63560,g);eJ(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;eJ(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;vr(15,0,63592,f);eJ(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ee[c[8104]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Pu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=OV(12)|0;f=OV(a<<2)|0;c[e>>2]=f;wr(0,(f|0)!=0|0,63600,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function Qu(a){a=a|0;var b=0;b=i;PV(c[c[a>>2]>>2]|0);i=b;return 0}function Ru(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;uW(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;fe[c[x>>2]&127](C,D);fe[c[w+(d<<6)+4>>2]&127](C,D);if((c[31928>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;tr(16,1,63656,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];gc(D|0,63680,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;tr(16,0,63696,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;tr(16,1,63704,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];gc(D|0,63680,o|0)|0;c[n>>2]=D;tr(16,0,63696,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;tr(16,1,63704,s)}}while(0);ee[c[8104]&255](16)}s=w+(d<<6)+36|0;A=y+8|0;hm(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;vr(1,0,63720,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;sW(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;sW(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;vr(1,0,63808,l);if((c[31924>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;sW(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];gc(l|0,63912,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];gc(l|0,63912,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;sW(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];gc(l|0,63912,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;sW(M|0,O|0,Q|0)|0;i=e;return F|0}function Su(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=OV(32)|0;wr(0,(g|0)!=0|0,63920,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Xd(0,d|0)|0;Md(c[d>>2]|0,c[b>>2]|0,0)|0;Xd(0,g+4|0)|0;Md(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Kb(63968,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function Tu(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;yd(c[d+12>>2]|0)|0;Jb(c[d+8>>2]|0)|0;Jb(c[d+4>>2]|0)|0;i=b;return 0}function Uu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;ld(c[g>>2]|0)|0;Td(0,g|0)|0;j=g+24|0;Ob(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;fe[c[f>>2]&127](k,a);Vc(c[g>>2]|0,1)|0;Ua(c[g>>2]|0)|0;fe[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){gd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(lc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;fb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;ld(c[g>>2]|0)|0;i=d;return l|0}function Vu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;wr(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,64136,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){wr(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,64176,e);if((he[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=OV(p)|0;c[g+(m*80|0)+52>>2]=OV(p)|0;c[g+(m*80|0)+48>>2]=OV(p)|0;c[g+(m*80|0)+16>>2]=OV(p)|0;c[g+(m*80|0)+8>>2]=OV(p)|0;c[g+(m*80|0)+12>>2]=OV(p)|0;fe[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){gv(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){_u(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){Gu(a,n)|0;break}else if((p|0)==3){gv(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){xr(c[j>>2]|0,64216,d)}else if((q|0)==14){i=b;return 0}return 0}function Wu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;PV(c[e+(h*80|0)+44>>2]|0);PV(c[e+(h*80|0)+52>>2]|0);PV(c[e+(h*80|0)+48>>2]|0);PV(c[e+(h*80|0)+16>>2]|0);PV(c[e+(h*80|0)+8>>2]|0);PV(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;hv(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==1){n=e+(h*80|0)+40|0;$u(n)|0;l=n;break}else if((k|0)==3){k=e+(h*80|0)+40|0;hv(k)|0;l=k;break}else{m=9;break a}}}while(0);PV(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){Hu(j)|0}else if((m|0)==9){xr(c[a+536>>2]|0,64216,d)}else if((m|0)==11){i=b;return 0}return 0}function Xu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(jv(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(Iu(b,d)|0)&255;break}else if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=av(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(jv(b,d)|0)&255;break}else{xr(c[b+536>>2]|0,64216,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function Yu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;eJ(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];ur(17,1,u,64248,m);do{if((a[b+312|0]|0)==0){eJ(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;eJ(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;vr(17,0,64448,f);eJ(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{vr(17,1,64288,l);eJ(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;eJ(q,d,c[v>>2]|0);if((mW(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];vr(17,0,64368,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;eJ(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;vr(17,0,64408,g);G=E}eJ(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[31932>>2]|c[7964]|0)==0){break}ee[c[8104]&255](17)}}while(0);if((c[31932>>2]|c[7964]|0)==0){x=1;i=e;return x|0}ee[c[8104]&255](17);x=1;i=e;return x|0}function Zu(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function _u(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=OV(144)|0;c[b>>2]=f;wr(0,(f|0)!=0|0,64464,e);c[f>>2]=0;e=a<<3;g=OV(e)|0;c[f+4>>2]=g;g=OV(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=OV(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=OV(e)|0;c[f+24>>2]=g;g=QV(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=OV(e)|0;c[f+64>>2]=g;g=OV(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=QV(g,8)|0;c[f+104>>2]=j;j=QV(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=OV(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=OV(e)|0;c[f+124>>2]=j;j=OV(e)|0;c[f+128>>2]=j;j=OV(e)|0;c[f+132>>2]=j;j=OV(e)|0;c[f+136>>2]=j;j=OV(e)|0;c[f+140>>2]=j;wr(0,(c[b>>2]|0)!=0|0,64496,d);i=d;return 0}function $u(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;PV(c[d+4>>2]|0);PV(c[d+16>>2]|0);PV(c[d+12>>2]|0);PV(c[d+24>>2]|0);PV(c[d+28>>2]|0);PV(c[d+64>>2]|0);PV(c[d+68>>2]|0);PV(c[d+104>>2]|0);PV(c[d+108>>2]|0);PV(c[d+116>>2]|0);PV(c[d+124>>2]|0);PV(c[d+128>>2]|0);PV(c[d+132>>2]|0);PV(c[d+136>>2]|0);PV(c[d+140>>2]|0);i=b;return 0}function av(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=OV(c[Y>>2]|0)|0;if((c[31932>>2]|0)!=0){eJ(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];tr(17,1,64536,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];tr(17,1,64592,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];tr(17,0,64608,F);ee[c[8104]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}ee[c[8104]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){sW(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{sW(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+sd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;bv($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+sd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[31936>>2]|0)!=0){cv(c[Q>>2]|0,$,18,64648);cv(c[ca>>2]|0,$,18,64680)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[31936>>2]|0)!=0){cv(c[ca>>2]|0,$,18,64712)}a[da]=R;tt(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){eJ(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];Os(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;bv($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;bv($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}hu(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[31936>>2]|0)!=0){tr(18,1,64752,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];tr(18,1,64792,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];tr(18,0,64824,C);ee[c[8104]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ee[c[8104]&255](18)}if((c[31940>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;tr(19,1,64856,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];gc(Ja|0,64880,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;tr(19,0,64888,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ee[c[8104]&255](19)}h[K>>3]=+st($,c[Ia>>2]|0);h[J>>3]=+st($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}sW(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];tr(17,0,64936,w);dv(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}tr(17,0,65008,v);dv(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+sd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}tr(17,0,65072,u);dv(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+sd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}tr(17,0,65144,t);dv(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}sW(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;sW(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}tr(17,0,65208,s);dv(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){sW(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}tr(17,0,65280,r);dv(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tr(17,0,65352,q);dv(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tr(17,0,65424,p);dv(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){sW(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tr(17,0,65488,o);dv(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tr(17,0,65560,n);dv(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];tr(17,0,65696,l);dv(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){sW(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{sW(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}tr(17,0,65624,m);dv(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[31932>>2]|0)!=0){tr(17,1,64896,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;tr(17,0,64912,x);ee[c[8104]&255](17);dv(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}sW(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;bv($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;PV(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;PV(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;PV(Z);i=e;return kb|0}if((a[Ha]|0)==0){eJ(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];Os(0,f,hb);}if((c[31932>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;tr(17,0,65768,j);dv(S,L,J,K,17)}sW(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;PV(Z);i=e;return kb|0}return 0}function bv(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[31944>>2]|0)!=0){c[u>>2]=c[y+96>>2];tr(20,0,66016,u);cv(d,b,20,66048)}He[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[31944>>2]|0)!=0){cv(e,b,20,66064);c[t>>2]=c[y+96>>2];tr(20,0,66080,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[31944>>2]|0)!=0){tr(20,0,66120,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){fv(w,f,d,e,m)}else{ev(w,f,m)}do{if((c[31944>>2]|0)!=0){tr(20,0,66160,r);if((c[31940>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;tr(19,1,64856,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(m|0,66192,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;tr(19,0,64888,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}ee[c[8104]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;xr(g,66208,n)}return 0}function cv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[31864+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;tr(d,1,64888,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];tr(d,0,66e3,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}ee[c[8104]&255](d);i=f;return}function dv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[31864+(f<<2)>>2]|0)==0){i=g;return}tr(f,1,65808,q);tr(f,1,65824,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];tr(f,0,65840,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}ee[c[8104]&255](f);tr(f,1,65880,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];tr(f,0,65896,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}ee[c[8104]&255](f);tr(f,1,65936,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];tr(f,0,65952,j);ee[c[8104]&255](f);ee[c[8104]&255](f);i=g;return}function ev(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;uW(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;uW(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}he[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function fv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+sd(+(n*+sd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;bv(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function gv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=OV(80)|0;c[b>>2]=f;wr(0,(f|0)!=0|0,66288,e);c[f>>2]=0;e=a<<3;g=OV(e)|0;c[f+4>>2]=g;g=OV(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=OV(e)|0;c[f+16>>2]=g;g=QV(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=OV(fa(e,a)|0)|0;c[f+64>>2]=g;g=OV(e)|0;c[f+68>>2]=g;g=OV(a<<2)|0;c[f+72>>2]=g;wr(0,(c[b>>2]|0)!=0|0,66320,d);i=d;return 0}function hv(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;PV(c[d+4>>2]|0);PV(c[d+8>>2]|0);PV(c[d+16>>2]|0);PV(c[d+20>>2]|0);PV(c[d+64>>2]|0);PV(c[d+68>>2]|0);PV(c[d+72>>2]|0);i=b;return 0}function iv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;uW(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}he[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function jv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;sW(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[31932>>2]|0)==0){J=b+4|0}else{eJ(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tr(17,1,66360,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];tr(17,1,66432,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];tr(17,0,66448,t);ee[c[8104]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}ee[c[8104]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];kv(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){eJ(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];Os(3,g,P);}$=+st(H,c[b>>2]|0);aa=+st(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){sW(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;tr(17,0,66624,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;tr(17,0,66680,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;tr(17,0,66744,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[31932>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;tr(17,0,66496,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];tr(17,0,66536,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];tr(17,0,66592,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){eJ(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];Os(0,f,L);if((c[31932>>2]|0)==0){da=0;break}c[m>>2]=V;tr(17,0,66824,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(17,0,66536,l);if((c[31932>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(17,0,66592,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[31932>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;sW(ma|0,oa|0,qa|0)|0;i=e;return da|0}ee[c[8104]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;sW(ma|0,oa|0,qa|0)|0;i=e;return da|0}function kv(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[31936>>2]|0)!=0){c[z>>2]=j;tr(18,0,66864,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];tr(18,0,66912,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){lv(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){mv(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{iv(E,m,r)|0}if((c[31940>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;tr(19,1,66928,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];gc(F|0,66952,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;tr(19,0,66960,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}ee[c[8104]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+st(b,_);if(!(!(J<=H)&!(+st(b,e)<=H))){$=31;break}hm(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;vr(17,0,66968,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;vr(17,0,67e3,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+st(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function lv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;He[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function mv(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+sd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;lv(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function nv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==1){f=c[a+4>>2]|0;g=c[f+4>>2]|0;pv(c[f>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);j=0;i=d;return j|0}else if((e|0)==3){j=Kt(a,b)|0;i=d;return j|0}else if((e|0)==4){se[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];j=0;i=d;return j|0}else if((e|0)==2){ov(a,b);j=0;i=d;return j|0}else{j=1;i=d;return j|0}return 0}function ov(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[67032+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[67032+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];he[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function pv(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function qv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Ar(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=OV(88)|0;tr(23,0,67064,e);j=It(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[520]|0;g=OV(j<<2)|0;c[16772]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=QV(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[16772]|0;g=n}}else if((f|0)==2){g=OV(8)|0;c[g+4>>2]=4;m=OV(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=QV(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);Dv(b)|0;if((c[2]|0)==0){i=e;return k|0}Ls(6);Is(1);i=e;return k|0}function rv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[520]|0;g=c[16772]|0;if((f|0)>0){h=g;j=0;while(1){PV(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[16772]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}PV(m)}else if((e|0)==2){m=b+48|0;g=c[m>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){PV(c[g+(j<<2)>>2]|0);f=c[m>>2]|0;l=c[f>>2]|0;if((j|0)<(c[f+4>>2]|0)){j=j+1|0;g=l}else{n=l;break}}}else{n=h}PV(n);PV(c[m>>2]|0)}else if((e|0)==3){Jt(c[b+48>>2]|0)|0}Ev(a)|0;yv(a);i=d;return 0}function sv(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(189,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=DW(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=DW(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=DW(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=DW(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=DW(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(190,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=DW(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=DW(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;pW(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=DW(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=DW(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,67096,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=DW(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=DW(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,67192,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=DW(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[73312>>2]|0,73288,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=DW(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,67248,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=DW(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(191,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=DW(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function tv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];tr(8,0,67344,G);I=b+313|0;a[I]=1;gu(b);if((c[88620>>2]|0)==0){fe[c[73308>>2]&127](73288,b)}a[I]=0}}while(0);if((e|0)!=0){uv(zd(e|0)|0,b)}if((c[31964>>2]|0)==0){i=f;return 0}Ls(0);tr(25,0,67392,F);tr(25,1,67416,E);H=+Ds(6);J=+Ds(6);K=J/+Ds(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];tr(25,0,67424,D);K=+Ds(1);H=+Ds(1);J=H/+Ds(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];tr(25,0,67464,C);J=+Ds(2);K=+Ds(2);H=K/+Ds(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tr(25,0,67496,B);H=+Ds(3);J=+Ds(3);K=J/+Ds(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];tr(25,0,67520,A);K=+Ds(4);H=+Ds(4);J=H/+Ds(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tr(25,0,67560,z);J=+Ds(7);K=+Ds(7);H=K/+Ds(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(25,0,67592,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Ds(0);J=H- +Ds(7);H=J- +Ds(4);J=H- +Ds(3);H=J- +Ds(2);J=H- +Ds(1);H=J- +Ds(6);J=+Ds(0);K=J- +Ds(7);J=K- +Ds(4);K=J- +Ds(3);J=K- +Ds(2);K=J- +Ds(1);J=K- +Ds(6);K=J/+Ds(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(25,0,67656,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tr(25,0,67624,x)}K=+Ds(0);H=+Ds(0);J=H/+Ds(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];tr(25,0,67688,v);ee[c[8104]&255](25);tr(25,1,67712,u);c[t>>2]=c[d+40>>2];tr(25,0,67720,t);c[s>>2]=c[d+44>>2];tr(25,0,67744,s);ee[c[8104]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);tr(25,1,67768,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];tr(25,0,67784,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];tr(25,0,67800,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];tr(25,0,67832,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];tr(25,0,67864,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];tr(25,0,67888,m);ee[c[8104]&255](25)}else if((s|0)!=5){tr(25,1,67920,l);tr(25,0,67928,j);ee[c[8104]&255](25)}tr(25,0,67992,g);Is(0);i=f;return 0}



function XU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;cV(m,c[p>>2]|0)|0;cV(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=cV(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=cV(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=cV(m,3)|0;break};case 9:{Q=c[q>>2]|0;X=a[Q]|0;switch(X<<24>>24|0){case 92:{Y=c[v>>2]|0;if((Y&1|0)!=0){U=M;V=N;W=0;break c}Z=Q+1|0;if((a[Z]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=Z;_=Y;$=Z;break};case 123:{Z=c[v>>2]|0;if((Z&1|0)==0){U=M;V=N;W=0;break c}else{_=Z;$=Q}break};case 42:{T=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Q+1;Q=c[w>>2]|0;Z=mV(Q,0,0,1,32)|0;if((Z|0)==0){aa=12;T=294;break b}Y=mV(Q,0,0,1,16)|0;c[Z+4>>2]=Y;if((Y|0)==0){aa=12;T=294;break b}c[Z>>2]=2;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[Y>>2]=N;c[Y+4>>2]=X<<24>>24==43;c[Y+8>>2]=X<<24>>24==63?1:-1;X=Y+12|0;a[X]=a[X]&-2;c[Z+16>>2]=c[N+16>>2];U=M;V=Z;W=cV(m,9)|0;break c}Z=$+1|0;c[q>>2]=Z;X=a[Z]|0;if((X+ -48<<24>>24&255)<10){Y=X<<24>>24;if((Y+ -48|0)>>>0<10){ba=Y;ca=-1;da=Z}else{aa=10;T=294;break b}while(1){Y=((ca|0)<0?-48:(ca*10|0)+ -48|0)+ba|0;Q=da+1|0;ea=a[Q]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){da=Q;ca=Y;ba=fa}else{ga=ea;ha=Y;ia=Q;break}}}else{ga=X;ha=-1;ia=Z}do{if(ga<<24>>24==44){Q=ia+1|0;Y=a[Q]|0;ea=Y<<24>>24;if((ea+ -48|0)>>>0<10){ja=ea;ka=-1;la=Q}else{ma=Y;na=-1;oa=Q;break}while(1){Q=((ka|0)<0?-48:(ka*10|0)+ -48|0)+ja|0;Y=la+1|0;ea=a[Y]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){la=Y;ka=Q;ja=fa}else{pa=ea;qa=Q;ra=Y;T=54;break}}}else{pa=ga;qa=ha;ra=ia;T=54}}while(0);do{if((T|0)==54){T=0;if(!((qa|0)>-1)){ma=pa;na=qa;oa=ra;break}if((ha|0)>(qa|0)|(qa|0)>255){aa=10;T=294;break b}else{ma=pa;na=qa;oa=ra}}}while(0);if(ma<<24>>24==0){aa=9;T=294;break b}if((oa|0)==(Z|0)){aa=10;T=294;break b}if((_&1|0)==0){if(!(ma<<24>>24==92)){aa=10;T=294;break b}if((a[oa+1|0]|0)!=125){aa=10;T=294;break b}sa=oa+2|0}else{if(!(ma<<24>>24==125)){aa=10;T=294;break b}sa=oa+1|0}if((na|ha|0)==0){X=c[w>>2]|0;Y=mV(X,0,0,1,32)|0;if((Y|0)==0){aa=12;T=294;break b}Q=mV(X,0,0,1,20)|0;c[Y+4>>2]=Q;if((Q|0)==0){aa=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;ta=Y}else{Y=(na&ha|0)<0;Q=c[w>>2]|0;X=mV(Q,0,0,1,32)|0;if((X|0)==0){aa=12;T=294;break b}ea=mV(Q,0,0,1,16)|0;c[X+4>>2]=ea;if((ea|0)==0){aa=12;T=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ea>>2]=N;c[ea+4>>2]=Y?1:ha;c[ea+8>>2]=Y?1:na;Y=ea+12|0;a[Y]=a[Y]&-2;c[X+16>>2]=c[N+16>>2];ta=X}c[q>>2]=sa;U=M;V=ta;W=cV(m,9)|0;break};case 3:{X=cV(m,5)|0;if((X|0)!=0){R=M;S=X;T=6;break b}U=M;V=N;W=cV(m,4)|0;break};case 6:{X=L+ -2|0;c[n>>2]=X;Y=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;ea=mV(X,0,0,1,32)|0;if((ea|0)==0){aa=12;T=294;break b}Q=mV(X,0,0,1,8)|0;X=ea+4|0;c[X>>2]=Q;if((Q|0)==0){aa=12;T=294;break b}c[ea>>2]=1;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Q>>2]=Y;c[(c[X>>2]|0)+4>>2]=N;c[ea+16>>2]=(c[N+16>>2]|0)+(c[Y+16>>2]|0);U=M;V=ea;W=0;break};case 1:{ea=c[q>>2]|0;d:do{switch(a[ea]|0){case 91:{Y=ea+1|0;c[q>>2]=Y;X=OV(128)|0;if((X|0)==0){aa=12;T=294;break b}if((a[Y]|0)==94){Q=ea+2|0;c[q>>2]=Q;ua=Q;va=1}else{ua=Y;va=0}Y=(va|0)==0;Q=X;X=0;fa=0;wa=32;xa=ua;e:while(1){ya=a[xa]|0;if(ya<<24>>24==93){if(xa>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(ya<<24>>24==0){za=Q;Aa=xa;Ba=7;T=140;break}ya=SU(e,xa,-1)|0;if((ya|0)<0){c[e>>2]=-1;Ca=1}else{Ca=ya}ya=xa+Ca|0;do{if((a[ya]|0)==45){Da=Ca+1|0;Ea=xa+Da|0;if((a[Ea]|0)==93){T=94;break}Fa=c[e>>2]|0;Ga=SU(e,Ea,-1)|0;if((Ga|0)<0){c[e>>2]=-1;Ha=-1;Ia=1}else{Ha=c[e>>2]|0;Ia=Ga}Ja=0;Ka=Ha;La=Fa;Ma=xa+(Ia+Da)|0;Na=Fa>>>0>Ha>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;Fa=a[xa]|0;do{if(Fa<<24>>24==91){Da=a[xa+1|0]|0;if(Da<<24>>24==61|Da<<24>>24==46){za=Q;Aa=xa;Ba=3;T=140;break e}else if(!(Da<<24>>24==58)){Oa=0;break}Da=xa+2|0;Ga=Da;while(1){Ea=a[Ga]|0;Pa=Ea<<24>>24==0;if(Ea<<24>>24!=58&(Pa^1)){Ga=Ga+1|0}else{break}}if(Pa){za=Q;Aa=xa;Ba=4;T=140;break e}Ea=Ga-xa+ -2|0;Qa=(Ea|0)>63?63:Ea;BW(A|0,Da|0,Qa|0)|0;a[f+Qa|0]=0;Qa=CU(A)|0;Ja=Qa;Ka=1114111;La=0;Ma=Ga+2|0;Na=(Qa|0)==0?4:0;break f}else if(Fa<<24>>24==45){if((a[xa+1|0]|0)==93){Oa=0;break}Oa=(c[q>>2]|0)==(xa|0)?0:11}else{Oa=0}}while(0);Fa=c[e>>2]|0;Ja=0;Ka=Fa;La=Fa;Ma=ya;Na=Oa}}while(0);if((Na|0)!=0){za=Q;Aa=Ma;Ba=Na;T=140;break}ya=(Ja|0)!=0;do{if(Y|ya^1){Fa=c[w>>2]|0;if((fa|0)<(wa|0)){Ra=Q;Sa=wa}else{if((wa|0)>1024){za=Q;Aa=Ma;Ba=12;T=140;break e}Qa=RV(Q,wa<<3)|0;if((Qa|0)==0){za=Q;Aa=Ma;Ba=12;T=140;break e}else{Ra=Qa;Sa=wa<<1}}Qa=mV(Fa,0,0,1,32)|0;if((Qa|0)==0){T=112;break e}Ea=mV(Fa,0,0,1,20)|0;Fa=Qa+4|0;c[Fa>>2]=Ea;if((Ea|0)==0){T=112;break e}c[Qa>>2]=0;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[Ea>>2]=La;c[Ea+4>>2]=Ka;c[Ea+8>>2]=-1;c[Ra+(fa<<2)>>2]=Qa;c[(c[Fa>>2]|0)+12>>2]=Ja;Ta=Ra;Ua=X;Va=fa+1|0;Wa=Sa;Xa=0}else{if((X|0)>63){Ta=Q;Ua=X;Va=fa;Wa=wa;Xa=12;break}c[g+(X<<2)>>2]=Ja;Ta=Q;Ua=X+1|0;Va=fa;Wa=wa;Xa=0}}while(0);Fa=(Xa|0)==0;if(Fa&(((c[v>>2]&2|0)==0|ya)^1)){Ya=Ta;Za=Va;_a=Wa;$a=La}else{if(Fa){Q=Ta;X=Ua;fa=Va;wa=Wa;xa=Ma;continue}else{za=Ta;Aa=Ma;Ba=Xa;T=140;break}}while(1){Fa=$a;while(1){if(Fa>>>0>Ka>>>0){Q=Ya;X=Ua;fa=Za;wa=_a;xa=Ma;continue e}if((FU(Fa)|0)!=0){T=118;break}ab=Fa+1|0;if((JU(Fa)|0)==0){Fa=ab}else{T=129;break}}if((T|0)==118){T=0;Qa=LU(Fa)|0;Ea=Fa+1|0;g:do{if((FU(Ea)|0)==0){bb=Qa;cb=Ea}else{db=Qa;eb=Ea;while(1){if((LU(eb)|0)!=(db+1|0)|eb>>>0>Ka>>>0){bb=db;cb=eb;break g}fb=LU(eb)|0;gb=eb+1|0;if((FU(gb)|0)==0){bb=fb;cb=gb;break}else{db=fb;eb=gb}}}}while(0);Ea=c[w>>2]|0;if((Za|0)<(_a|0)){hb=Ya;ib=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;T=140;break e}eb=RV(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;T=140;break e}else{hb=eb;ib=_a<<1}}eb=mV(Ea,0,0,1,32)|0;db=eb;do{if((eb|0)==0){jb=0}else{Ga=mV(Ea,0,0,1,20)|0;c[eb+4>>2]=Ga;if((Ga|0)==0){jb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ga>>2]=Qa;c[Ga+4>>2]=bb;c[Ga+8>>2]=-1;jb=db}}while(0);c[hb+(Za<<2)>>2]=jb;kb=jb;lb=hb;mb=ib;nb=cb}else if((T|0)==129){T=0;db=NU(Fa)|0;h:do{if((JU(ab)|0)==0){ob=db;pb=ab}else{Qa=db;eb=ab;while(1){if((NU(eb)|0)!=(Qa+1|0)|eb>>>0>Ka>>>0){ob=Qa;pb=eb;break h}Ea=eb+1|0;Ga=NU(eb)|0;if((JU(Ea)|0)==0){ob=Ga;pb=Ea;break}else{Qa=Ga;eb=Ea}}}}while(0);Fa=c[w>>2]|0;if((Za|0)<(_a|0)){qb=Ya;rb=_a}else{if((_a|0)>1024){za=Ya;Aa=Ma;Ba=12;T=140;break e}eb=RV(Ya,_a<<3)|0;if((eb|0)==0){za=Ya;Aa=Ma;Ba=12;T=140;break e}else{qb=eb;rb=_a<<1}}eb=mV(Fa,0,0,1,32)|0;Qa=eb;do{if((eb|0)==0){sb=0}else{Ea=mV(Fa,0,0,1,20)|0;c[eb+4>>2]=Ea;if((Ea|0)==0){sb=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Ea>>2]=db;c[Ea+4>>2]=ob;c[Ea+8>>2]=-1;sb=Qa}}while(0);c[qb+(Za<<2)>>2]=sb;kb=sb;lb=qb;mb=rb;nb=pb}if((kb|0)==0){T=141;break e}else{Ya=lb;Za=Za+1|0;_a=mb;$a=nb}}}i:do{if((T|0)==85){T=0;c[q>>2]=xa+1;wa=(va|0)!=0;if(wa){bc(Q|0,fa|0,4,62)}j:do{if((fa|0)>0){Y=(X|0)>0;ya=X<<2;Qa=ya+4|0;if(wa){tb=0;ub=0;vb=0;wb=0}else{db=0;eb=0;while(1){Fa=Q+(db<<2)|0;Ea=c[(c[Fa>>2]|0)+4>>2]|0;do{if((Ea|0)==0){xb=eb;yb=0}else{c[Ea+8>>2]=c[x>>2];if(Y){Ga=mV(c[w>>2]|0,0,0,0,Qa)|0;Da=Ea+16|0;c[Da>>2]=Ga;if((Ga|0)==0){zb=Q;Ab=eb;Bb=12;break i}sW(Ga|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(X<<2)>>2]=0}else{c[Ea+16>>2]=0}if((eb|0)==0){xb=c[Fa>>2]|0;yb=0;break}Da=c[w>>2]|0;Ga=c[Fa>>2]|0;gb=mV(Da,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){Cb=0}else{Db=mV(Da,0,0,1,8)|0;Eb=gb+4|0;c[Eb>>2]=Db;if((Db|0)==0){Cb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[Db>>2]=eb;c[(c[Eb>>2]|0)+4>>2]=Ga;c[gb+16>>2]=(c[Ga+16>>2]|0)+(c[eb+16>>2]|0);Cb=fb}}while(0);xb=Cb;yb=(Cb|0)==0?12:0}}while(0);Fa=db+1|0;if((Fa|0)<(fa|0)&(yb|0)==0){db=Fa;eb=xb}else{Fb=0;Gb=xb;Hb=yb;break j}}}while(1){eb=Q+(vb<<2)|0;db=c[(c[eb>>2]|0)+4>>2]|0;Fa=c[db>>2]|0;Ea=db+4|0;fb=c[Ea>>2]|0;do{if((Fa|0)<(tb|0)){Ga=fb+1|0;Ib=(Ga|0)<(tb|0)?tb:Ga;Jb=ub;Kb=wb;Lb=0}else{if((Fa|0)<=(ub|0)){Ga=fb+1|0;Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db>>2]=ub;c[Ea>>2]=Fa+ -1;Ga=fb+1|0;if((db|0)==0){Ib=Ga;Jb=Ga;Kb=wb;Lb=0;break}c[db+8>>2]=c[x>>2];if(Y){gb=mV(c[w>>2]|0,0,0,0,Qa)|0;Da=db+16|0;c[Da>>2]=gb;if((gb|0)==0){zb=Q;Ab=wb;Bb=12;break i}sW(gb|0,z|0,ya|0)|0;c[(c[Da>>2]|0)+(X<<2)>>2]=0}else{c[db+16>>2]=0}if((wb|0)==0){Ib=Ga;Jb=Ga;Kb=c[eb>>2]|0;Lb=0;break}Da=c[w>>2]|0;gb=c[eb>>2]|0;Eb=mV(Da,0,0,1,32)|0;Db=Eb;do{if((Eb|0)==0){Mb=0}else{Nb=mV(Da,0,0,1,8)|0;Ob=Eb+4|0;c[Ob>>2]=Nb;if((Nb|0)==0){Mb=0;break}c[Eb>>2]=3;c[Eb+8>>2]=-1;c[Eb+12>>2]=-1;c[Nb>>2]=wb;c[(c[Ob>>2]|0)+4>>2]=gb;c[Eb+16>>2]=(c[gb+16>>2]|0)+(c[wb+16>>2]|0);Mb=Db}}while(0);Ib=Ga;Jb=Ga;Kb=Mb;Lb=(Mb|0)==0?12:0}}while(0);eb=vb+1|0;if((eb|0)<(fa|0)&(Lb|0)==0){tb=Ib;ub=Jb;vb=eb;wb=Kb}else{Fb=Jb;Gb=Kb;Hb=Lb;break}}}else{Fb=0;Gb=0;Hb=0}}while(0);if((Hb|0)!=0|wa^1){zb=Q;Ab=Gb;Bb=Hb;break}ya=c[w>>2]|0;Qa=c[x>>2]|0;Y=mV(ya,0,0,1,32)|0;eb=Y;if((Y|0)==0){zb=Q;Ab=Gb;Bb=12;break}db=mV(ya,0,0,1,20)|0;c[Y+4>>2]=db;if((db|0)==0){zb=Q;Ab=Gb;Bb=12;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[db>>2]=Fb;c[db+4>>2]=1114111;c[db+8>>2]=Qa;if((X|0)>0){Qa=X<<2;ya=mV(c[w>>2]|0,0,0,0,Qa+4|0)|0;fb=db+16|0;c[fb>>2]=ya;if((ya|0)==0){zb=Q;Ab=Gb;Bb=12;break}sW(ya|0,z|0,Qa|0)|0;c[(c[fb>>2]|0)+(X<<2)>>2]=0}else{c[db+16>>2]=0}if((Gb|0)==0){zb=Q;Ab=eb;Bb=0;break}db=c[w>>2]|0;fb=mV(db,0,0,1,32)|0;Qa=fb;do{if((fb|0)==0){Pb=0}else{ya=mV(db,0,0,1,8)|0;Fa=fb+4|0;c[Fa>>2]=ya;if((ya|0)==0){Pb=0;break}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ya>>2]=Gb;c[(c[Fa>>2]|0)+4>>2]=eb;c[fb+16>>2]=(c[Y+16>>2]|0)+(c[Gb+16>>2]|0);Pb=Qa}}while(0);zb=Q;Ab=Pb;Bb=(Pb|0)==0?12:0}else if((T|0)==112){T=0;c[Ra+(fa<<2)>>2]=0;za=Ra;Aa=Ma;Ba=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Ma;zb=lb;Ab=0;Bb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Aa;zb=za;Ab=0;Bb=Ba}PV(zb);c[x>>2]=(c[x>>2]|0)+1;if((Bb|0)==0){U=M;V=Ab;W=0;break c}else{aa=Bb;T=294;break b}break};case 92:{fa=ea+1|0;Q=a[fa]|0;do{if((c[v>>2]&1|0)==0){if(Q<<24>>24==40){c[q>>2]=fa;Qb=fa;T=74;break d}else{X=a[ea+1|0]|0;if(X<<24>>24==41){T=265;break d}else{Rb=X;break}}}else{Rb=Q}}while(0);Q=ea+1|0;fa=Rb<<24>>24==0;if(fa){aa=5;T=294;break b}else{Sb=120708|0;Tb=0}while(1){X=Tb+1|0;if((a[120704+(Tb<<3)|0]|0)==Rb<<24>>24){Vb=Sb;break}xa=120708+(X<<3)|0;if((X|0)==12){Vb=xa;break}else{Sb=xa;Tb=X}}X=c[Vb>>2]|0;if((X|0)!=0){xa=F+0|0;Qa=G+0|0;Y=xa+40|0;do{c[xa>>2]=c[Qa>>2];xa=xa+4|0;Qa=Qa+4|0}while((xa|0)<(Y|0));c[H>>2]=X;c[I>>2]=1;Qa=XU(j)|0;if((Qa|0)!=0){aa=Qa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(fa){aa=5;T=294;break b}c[q>>2]=Q;Qa=a[Q]|0;k:do{switch(Qa|0){case 120:{xa=ea+2|0;c[q>>2]=xa;Y=a[xa]|0;if(Y<<24>>24==123){xa=ea+3|0;c[q>>2]=xa;fb=xa;xa=0;while(1){eb=a[fb]|0;if(eb<<24>>24==0|eb<<24>>24==125){Wb=xa;Xb=fb;break}if((KU(eb<<24>>24)|0)==0){aa=9;T=294;break b}eb=c[q>>2]|0;a[l+xa|0]=a[eb]|0;db=xa+1|0;wa=eb+1|0;c[q>>2]=wa;if(db>>>0>31){Wb=db;Xb=wa;break}else{fb=wa;xa=db}}c[q>>2]=Xb+1;a[l+Wb|0]=0;xa=Ub(C|0,0,16)|0;fb=c[w>>2]|0;db=c[x>>2]|0;wa=mV(fb,0,0,1,32)|0;eb=wa;do{if((wa|0)==0){Yb=0}else{Fa=mV(fb,0,0,1,20)|0;c[wa+4>>2]=Fa;if((Fa|0)==0){Yb=0;break}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Fa>>2]=xa;c[Fa+4>>2]=xa;c[Fa+8>>2]=db;Yb=eb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Zb=Yb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;eb=(KU(Y<<24>>24)|0)==0;db=c[q>>2]|0;if(eb){_b=db}else{a[D]=a[db]|0;eb=db+1|0;c[q>>2]=eb;_b=eb}if((KU(a[_b]|0)|0)!=0){eb=c[q>>2]|0;a[E]=a[eb]|0;c[q>>2]=eb+1}eb=Ub(D|0,0,16)|0;db=c[w>>2]|0;xa=c[x>>2]|0;wa=mV(db,0,0,1,32)|0;fb=wa;do{if((wa|0)==0){$b=0}else{Fa=mV(db,0,0,1,20)|0;c[wa+4>>2]=Fa;if((Fa|0)==0){$b=0;break}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=eb;c[Fa+8>>2]=xa;$b=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Zb=$b;break k}break};case 62:{fb=c[w>>2]|0;xa=mV(fb,0,0,1,32)|0;eb=xa;do{if((xa|0)==0){ac=0}else{wa=mV(fb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){ac=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=32;c[wa+8>>2]=-1;ac=eb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=ac;break};case 98:{eb=c[w>>2]|0;xa=mV(eb,0,0,1,32)|0;fb=xa;do{if((xa|0)==0){cc=0}else{wa=mV(eb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){cc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=64;c[wa+8>>2]=-1;cc=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=cc;break};case 60:{fb=c[w>>2]|0;xa=mV(fb,0,0,1,32)|0;eb=xa;do{if((xa|0)==0){dc=0}else{wa=mV(fb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){dc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=16;c[wa+8>>2]=-1;dc=eb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=dc;break};case 66:{eb=c[w>>2]|0;xa=mV(eb,0,0,1,32)|0;fb=xa;do{if((xa|0)==0){ec=0}else{wa=mV(eb,0,0,1,20)|0;c[xa+4>>2]=wa;if((wa|0)==0){ec=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=128;c[wa+8>>2]=-1;ec=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Zb=ec;break};default:{if((DU(Qa)|0)!=0){fb=(a[c[q>>2]|0]|0)+ -48|0;xa=c[w>>2]|0;eb=c[x>>2]|0;wa=mV(xa,0,0,1,32)|0;if((wa|0)==0){aa=12;T=294;break b}db=mV(xa,0,0,1,20)|0;c[wa+4>>2]=db;if((db|0)==0){aa=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[db>>2]=-4;c[db+4>>2]=fb;c[db+8>>2]=eb;c[x>>2]=(c[x>>2]|0)+1;eb=c[B>>2]|0;c[B>>2]=(fb|0)<(eb|0)?eb:fb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=wa;W=0;break c}wa=c[w>>2]|0;fb=a[c[q>>2]|0]|0;eb=c[x>>2]|0;db=mV(wa,0,0,1,32)|0;xa=db;do{if((db|0)==0){fc=0}else{Y=mV(wa,0,0,1,20)|0;c[db+4>>2]=Y;if((Y|0)==0){fc=0;break}c[db>>2]=0;c[db+8>>2]=-1;c[db+12>>2]=-1;c[Y>>2]=fb;c[Y+4>>2]=fb;c[Y+8>>2]=eb;fc=xa}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Zb=fc}}}while(0);if((Zb|0)==0){aa=12;T=294;break b}else{U=M;V=Zb;W=0;break c}break};case 46:{Qa=(c[v>>2]&4|0)==0;Q=c[w>>2]|0;fa=c[x>>2]|0;X=mV(Q,0,0,1,32)|0;xa=X;eb=(X|0)==0;if(Qa){if(eb){aa=12;T=294;break b}Qa=mV(Q,0,0,1,20)|0;c[X+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Qa>>2]=0;c[Qa+4>>2]=1114111;c[Qa+8>>2]=fa;gc=xa;hc=(c[x>>2]|0)+1|0}else{if(eb){aa=12;T=294;break b}eb=mV(Q,0,0,1,20)|0;c[X+4>>2]=eb;if((eb|0)==0){aa=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[eb>>2]=0;c[eb+4>>2]=9;c[eb+8>>2]=fa;fa=c[w>>2]|0;eb=(c[x>>2]|0)+1|0;Q=mV(fa,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=mV(fa,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=11;c[Qa+4>>2]=1114111;c[Qa+8>>2]=eb;eb=c[w>>2]|0;Qa=mV(eb,0,0,1,32)|0;if((Qa|0)==0){aa=12;T=294;break b}fa=mV(eb,0,0,1,8)|0;eb=Qa+4|0;c[eb>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Qa>>2]=3;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[fa>>2]=xa;c[(c[eb>>2]|0)+4>>2]=Q;c[Qa+16>>2]=(c[Q+16>>2]|0)+(c[X+16>>2]|0);gc=Qa;hc=(c[x>>2]|0)+2|0}c[x>>2]=hc;c[q>>2]=(c[q>>2]|0)+1;U=M;V=gc;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((ea|0)!=(c[r>>2]|0)){break d}Qa=cV(m,5)|0;if((Qa|0)!=0){R=M;S=Qa;T=6;break b}}Qa=c[w>>2]|0;X=mV(Qa,0,0,1,32)|0;if((X|0)==0){aa=12;T=294;break b}Q=mV(Qa,0,0,1,20)|0;c[X+4>>2]=Q;if((Q|0)==0){aa=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=1;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=X;W=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){Qb=ea;T=74}break};case 36:{if((c[v>>2]&1|0)==0){if((a[ea+1|0]|0)!=0){break d}}X=c[w>>2]|0;Q=mV(X,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=mV(X,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=-2;c[Qa+4>>2]=2;c[Qa+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Q;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};default:{}}}while(0);if((T|0)==74){T=0;Z=M+1|0;c[q>>2]=Qb+1;Q=cV(m,c[y>>2]|0)|0;if((Q|0)!=0){R=Z;S=Q;T=6;break b}Q=cV(m,2)|0;if((Q|0)!=0){R=Z;S=Q;T=6;break b}Q=cV(m,0)|0;if((Q|0)!=0){R=Z;S=Q;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=Z;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;Z=c[w>>2]|0;Q=mV(Z,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=mV(Z,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=-1;c[Qa+4>>2]=-1;c[Qa+8>>2]=-1;U=M;V=Q;W=0;break c}Q=SU(h,ea,-1)|0;if((Q|0)<0){c[h>>2]=-1;ic=1}else{ic=Q}do{if((c[v>>2]&2|0)==0){T=280}else{if((JU(c[h>>2]|0)|0)==0){if((FU(c[h>>2]|0)|0)==0){T=280;break}}Q=c[w>>2]|0;Qa=LU(c[h>>2]|0)|0;Z=LU(c[h>>2]|0)|0;X=c[x>>2]|0;eb=mV(Q,0,0,1,32)|0;if((eb|0)==0){aa=12;T=294;break b}xa=mV(Q,0,0,1,20)|0;c[eb+4>>2]=xa;if((xa|0)==0){aa=12;T=294;break b}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[xa>>2]=Qa;c[xa+4>>2]=Z;c[xa+8>>2]=X;X=c[w>>2]|0;xa=NU(c[h>>2]|0)|0;Z=NU(c[h>>2]|0)|0;Qa=c[x>>2]|0;Q=mV(X,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}fa=mV(X,0,0,1,20)|0;c[Q+4>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fa>>2]=xa;c[fa+4>>2]=Z;c[fa+8>>2]=Qa;Qa=c[w>>2]|0;fa=mV(Qa,0,0,1,32)|0;if((fa|0)==0){aa=12;T=294;break b}Z=mV(Qa,0,0,1,8)|0;Qa=fa+4|0;c[Qa>>2]=Z;if((Z|0)==0){aa=12;T=294;break b}c[fa>>2]=3;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[Z>>2]=eb;c[(c[Qa>>2]|0)+4>>2]=Q;c[fa+16>>2]=(c[Q+16>>2]|0)+(c[eb+16>>2]|0);jc=fa}}while(0);if((T|0)==280){T=0;ea=c[w>>2]|0;fa=c[h>>2]|0;eb=c[x>>2]|0;Q=mV(ea,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}Qa=mV(ea,0,0,1,20)|0;c[Q+4>>2]=Qa;if((Qa|0)==0){aa=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Qa>>2]=fa;c[Qa+4>>2]=fa;c[Qa+8>>2]=eb;jc=Q}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+ic;U=M;V=jc;W=0;break};case 4:{Q=cV(m,9)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=cV(m,1)|0;break};case 7:{Q=c[q>>2]|0;eb=a[Q]|0;if((eb|0)==41){c[q>>2]=Q+1;U=M;V=N;W=0;break c}else if((eb|0)!=124){U=M;V=N;W=0;break c}eb=cV(m,7)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}eb=cV(m,N)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}eb=cV(m,8)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}eb=cV(m,3)|0;if((eb|0)!=0){R=M;S=eb;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 8:{eb=L+ -2|0;c[n>>2]=eb;Q=c[P+(eb<<2)>>2]|0;eb=c[w>>2]|0;Qa=mV(eb,0,0,1,32)|0;if((Qa|0)==0){aa=12;T=294;break b}fa=mV(eb,0,0,1,8)|0;eb=Qa+4|0;c[eb>>2]=fa;if((fa|0)==0){aa=12;T=294;break b}c[Qa>>2]=3;c[Qa+8>>2]=-1;c[Qa+12>>2]=-1;c[fa>>2]=Q;c[(c[eb>>2]|0)+4>>2]=N;c[Qa+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=Qa;W=0;break};case 5:{Qa=c[q>>2]|0;Q=a[Qa]|0;if(Q<<24>>24==0){U=M;V=N;W=0;break c}eb=c[v>>2]&1;fa=(eb|0)!=0;if(fa&Q<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(fa&Q<<24>>24==41&(M|0)>0)){if((eb|0)==0&Q<<24>>24==92){if((a[Qa+1|0]|0)==41){break}}ea=cV(m,5)|0;if((ea|0)!=0){R=M;S=ea;T=6;break b}ea=cV(m,N)|0;if((ea|0)!=0){R=M;S=ea;T=6;break b}ea=cV(m,6)|0;if((ea|0)!=0){R=M;S=ea;T=6;break b}U=M;V=N;W=cV(m,4)|0;break c}}while(0);Q=(eb|M|0)==0?8:0;fa=M+ -1|0;if((eb|0)!=0){U=fa;V=N;W=Q;break c}c[q>>2]=Qa+2;U=fa;V=N;W=Q;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;fa=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;ea=mV(Q,0,0,1,32)|0;if((ea|0)==0){aa=12;T=294;break b}Z=mV(Q,0,0,1,20)|0;c[ea+4>>2]=Z;if((Z|0)==0){aa=12;T=294;break b}c[ea>>2]=0;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=c[w>>2]|0;Q=mV(Z,0,0,1,32)|0;if((Q|0)==0){aa=12;T=294;break b}xa=mV(Z,0,0,1,8)|0;Z=Q+4|0;c[Z>>2]=xa;if((xa|0)==0){aa=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[xa>>2]=ea;c[(c[Z>>2]|0)+4>>2]=N;Z=N+16|0;xa=Q+16|0;c[xa>>2]=(c[Z>>2]|0)+(c[ea+16>>2]|0);c[xa>>2]=c[Z>>2];kc=Q}else{kc=N}c[kc+12>>2]=fa;fa=kc+16|0;c[fa>>2]=(c[fa>>2]|0)+1;U=M;V=kc;W=0;break};case 10:{fa=L+ -2|0;c[n>>2]=fa;c[v>>2]=c[P+(fa<<2)>>2];U=M;V=N;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{lc=O;mc=U;nc=V;oc=W;break a}}if((T|0)==6){lc=(S|0)==0;mc=R;nc=N;oc=S;break}else if((T|0)==294){i=d;return aa|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){aa=p?8:oc;i=d;return aa|0}c[b+8>>2]=nc;aa=0;i=d;return aa|0}function YU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=OV((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=OV((l<<2)+4|0)|0;if((p|0)==0){PV(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}cV(d,e)|0;e=cV(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 6:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=0;do{G=A+(E<<2)|0;E=E+1|0}while((c[G>>2]|0)>-1);c[G>>2]=F<<1|1;c[A+(E<<2)>>2]=-1;H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[p+(H+ -1<<2)>>2]=-1;I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{I=v;J=w;K=x;L=y;M=z;N=E;O=0;P=B;break}}break};case 5:{E=u+ -2|0;c[h>>2]=E;H=c[D+(E<<2)>>2]|0;if(!k){I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break b}E=c[H+4>>2]|0;c[H+20>>2]=(c[(c[E+4>>2]|0)+20>>2]|0)+(c[(c[E>>2]|0)+20>>2]|0);I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 4:{E=u+ -2|0;c[h>>2]=E;H=c[D+(E<<2)>>2]|0;E=u+ -3|0;c[h>>2]=E;I=v;J=w;K=c[D+(E<<2)>>2]|0;L=y;M=z;N=A;O=0;P=(H|0)>-1?H:B;break};case 1:{H=u+ -2|0;c[h>>2]=H;E=c[D+(H<<2)>>2]|0;if(k){H=c[(c[c[E+4>>2]>>2]|0)+20>>2]|0;F=u+ -3|0;c[h>>2]=F;c[E+20>>2]=(c[D+(F<<2)>>2]|0)+H;I=v;J=-1;K=x;L=y;M=z;N=A;O=0;P=B;break b}else{H=u+ -3|0;c[h>>2]=H;F=c[D+(H<<2)>>2]|0;H=u+ -4|0;c[h>>2]=H;E=(F|0)==0;I=E&1;J=E?w:c[D+(H<<2)>>2]|0;K=x;L=y;M=z;N=A;O=0;P=B;break b}break};case 3:{H=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;F=c[D+(u+ -4<<2)>>2]|0;Q=u+ -5|0;c[h>>2]=Q;if(k){R=c[F+4>>2]|0;S=F+16|0;c[F+20>>2]=(c[(c[R>>2]|0)+20>>2]|0)+(c[D+(Q<<2)>>2]|0)+(c[(c[R+4>>2]|0)+20>>2]|0)+((c[S>>2]|0)>0?2:0);T=S;U=c[h>>2]|0}else{T=F+16|0;U=Q}Q=c[D+(U+ -1<<2)>>2]|0;F=U+ -2|0;c[h>>2]=F;S=c[D+(F<<2)>>2]|0;F=U+ -3|0;c[h>>2]=F;R=c[D+(F<<2)>>2]|0;if((c[T>>2]|0)<=0){I=1;J=w;K=x;L=y;M=z;N=Q;O=0;P=B;break b}if(k){V=0}else{fV(b,H,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;S=fV(b,E,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;V=S}I=1;J=w;K=x;L=y;M=z+2|0;N=Q;O=V;P=B;break};case 0:{Q=u+ -2|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;Q=S;R=S+12|0;E=c[R>>2]|0;if((E|0)>-1){H=0;do{W=A+(H<<2)|0;H=H+1|0}while((c[W>>2]|0)>-1);c[W>>2]=E<<1;c[A+(H<<2)>>2]=-1;do{if(!k){F=0;while(1){if((c[p+(F<<2)>>2]|0)>-1){F=F+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((F|0)<=0){break}X=OV((F<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=cV(d,c[R>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=cV(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[S>>2]|0;do{if((E|0)==2){H=c[S+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ka=1}else{ka=a[H+12|0]&1}ea=cV(d,ka)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}}else{ea=cV(d,B)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,a[H+12|0]&1)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}}ea=cV(d,S)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,1)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,c[H>>2]|0)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,0)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}if(!((c[A>>2]|0)>-1)){if((a[H+12|0]&1)==0){la=0;ma=w;na=x;oa=y;pa=z;qa=0;ra=B;break}}if(k){sa=w;ta=y;ua=0}else{ea=eV(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[H+12|0]&1)==0?v:1;if((w|0)>-1){H=c[t>>2]|0;fa=0;while(1){va=H+(fa<<2)|0;wa=fa+1|0;if((c[va>>2]|0)>-1){fa=wa}else{break}}c[va>>2]=B;c[H+(wa<<2)>>2]=w;c[H+(fa+2<<2)>>2]=-1;xa=-1;ya=y+1|0}else{xa=w;ya=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;X=Y;Y=0;do{F=(X|0)/2|0;if((X&1|0)==0){c[da+(F*12|0)>>2]=B}else{c[da+(F*12|0)+4>>2]=B}Y=Y+1|0;X=c[A+(Y<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;sa=xa;ta=ya;ua=ea}c[A>>2]=-1;la=0;ma=sa;na=x+1|0;oa=ta;pa=z+1|0;qa=ua;ra=x}else if((E|0)==1){X=c[S+4>>2]|0;Y=c[X>>2]|0;da=c[X+4>>2]|0;X=cV(d,S)|0;if((X|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=X;ra=B;break}X=cV(d,5)|0;if((X|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=X;ra=B;break}X=cV(d,da)|0;if((X|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=X;ra=B;break}X=cV(d,0)|0;if((X|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=X;ra=B;break}X=Y+20|0;fa=cV(d,(c[X>>2]|0)+x|0)|0;if((fa|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=fa;ra=B;break}if((c[X>>2]|0)>0){X=(c[da+20>>2]|0)>0;za=(X&1)+x|0;Aa=X?x:-1}else{za=x;Aa=-1}X=cV(d,Aa)|0;if((X|0)!=0){la=v;ma=w;na=za;oa=y;pa=z;qa=X;ra=B;break}X=cV(d,4)|0;if((X|0)!=0){la=v;ma=w;na=za;oa=y;pa=z;qa=X;ra=B;break}X=cV(d,Y)|0;if((X|0)!=0){la=v;ma=w;na=za;oa=y;pa=z;qa=X;ra=B;break}la=v;ma=w;na=za;oa=y;pa=z;qa=cV(d,0)|0;ra=B}else if((E|0)==0){X=c[c[S+4>>2]>>2]|0;if(!((X|0)>-1|(X|0)==-4)){la=v;ma=w;na=x;oa=y;pa=z;qa=0;ra=B;break}if(!((c[A>>2]|0)>-1)){la=v;ma=w;na=x;oa=y;pa=z;qa=0;ra=B;break}if(k){c[S+20>>2]=1;Ba=w;Ca=y;Da=0}else{X=eV(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){Y=c[t>>2]|0;da=0;while(1){Ea=Y+(da<<2)|0;Fa=da+1|0;if((c[Ea>>2]|0)>-1){da=Fa}else{break}}c[Ea>>2]=B;c[Y+(Fa<<2)>>2]=w;c[Y+(da+2<<2)>>2]=-1;Ga=-1;Ha=y+1|0}else{Ga=w;Ha=y}ea=c[A>>2]|0;if((ea|0)>-1){fa=c[s>>2]|0;H=ea;ea=0;do{F=(H|0)/2|0;if((H&1|0)==0){c[fa+(F*12|0)>>2]=B}else{c[fa+(F*12|0)+4>>2]=B}ea=ea+1|0;H=c[A+(ea<<2)>>2]|0;}while((H|0)>-1)}c[A>>2]=-1;Ba=Ga;Ca=Ha;Da=X}c[A>>2]=-1;la=v;ma=Ba;na=x+1|0;oa=Ca;pa=z+1|0;qa=Da;ra=x}else if((E|0)==3){H=c[S+4>>2]|0;ea=c[H>>2]|0;fa=c[H+4>>2]|0;H=(c[A>>2]|0)>-1;da=x+1|0;Y=cV(d,H?da:x)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=cV(d,H?x:B)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=cV(d,A)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=cV(d,(c[A>>2]|0)>>>31^1)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=cV(d,S)|0;if((Y|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=Y;ra=B;break}Y=fa;fa=cV(d,Y)|0;if((fa|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=fa;ra=B;break}fa=ea;ea=cV(d,fa)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,3)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,Y)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,0)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,2)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,fa)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}ea=cV(d,0)|0;if((ea|0)!=0){la=v;ma=w;na=x;oa=y;pa=z;qa=ea;ra=B;break}if((c[A>>2]|0)>-1){if(k){Ia=w;Ja=y;Ka=0}else{ea=eV(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;Y=0;while(1){La=fa+(Y<<2)|0;Ma=Y+1|0;if((c[La>>2]|0)>-1){Y=Ma}else{break}}c[La>>2]=B;c[fa+(Ma<<2)>>2]=w;c[fa+(Y+2<<2)>>2]=-1;Na=-1;Oa=y+1|0}else{Na=w;Oa=y}X=c[A>>2]|0;if((X|0)>-1){H=c[s>>2]|0;F=X;X=0;do{ia=(F|0)/2|0;if((F&1|0)==0){c[H+(ia*12|0)>>2]=B}else{c[H+(ia*12|0)+4>>2]=B}X=X+1|0;F=c[A+(X<<2)>>2]|0;}while((F|0)>-1)}c[A>>2]=-1;Ia=Na;Ja=Oa;Ka=ea}c[A>>2]=-1;Pa=Ia;Qa=da;Ra=Ja;Sa=z+1|0;Ta=Ka;Ua=x}else{Pa=w;Qa=x;Ra=y;Sa=z;Ta=0;Ua=B}if((c[S+16>>2]|0)<=0){la=v;ma=Pa;na=Qa;oa=Ra;pa=Sa;qa=Ta;ra=Ua;break}la=v;ma=Pa;na=Qa+2|0;oa=Ra;pa=Sa;qa=Ta;ra=Qa+1|0}else{la=v;ma=w;na=x;oa=y;pa=z;qa=0;ra=B}}while(0);S=c[R>>2]|0;if((S|0)>-1){Va=0}else{I=la;J=ma;K=na;L=oa;M=pa;N=A;O=qa;P=ra;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=S;c[p+(Va<<2)>>2]=-1;I=la;J=ma;K=na;L=oa;M=pa;N=A;O=qa;P=ra;break};default:{I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(O|0)==0){u=D;v=I;w=J;x=K;y=L;z=M;A=N;B=P}else{Z=J;_=L;$=M;aa=N;ba=O;ca=P;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;P=e;e=0;do{O=(P|0)/2|0;if((P&1|0)==0){c[n+(O*12|0)>>2]=ca}else{c[n+(O*12|0)+4>>2]=ca}e=e+1|0;P=c[aa+(e<<2)>>2]|0;}while((P|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}P=c[f+36>>2]|0;e=0;while(1){Ya=P+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[P+(Za<<2)>>2]=Z;c[P+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;PV(m);PV(p);o=ba;i=g;return o|0}function ZU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;k=$U(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((k|0)!=0){l=k;m=10;break a}k=ZU(c[h>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else if((a|0)==2){k=c[g+4>>2]|0;j=k;if(!((c[k+8>>2]|0)==-1)){n=j;break}h=c[k>>2]|0;k=$U(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else if((a|0)==3){k=c[g+4>>2]|0;j=ZU(c[k>>2]|0,b,d,e)|0;if((j|0)!=0){l=j;m=10;break a}n=k+4|0}else{l=0;m=10;break a}}while(0);g=c[n>>2]|0}if((m|0)==10){i=f;return l|0}return 0}function _U(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{PV(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}PV(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){PV(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){PV(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}PV(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{PV(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}PV(m)}m=c[d+32>>2]|0;if((m|0)!=0){PV(m)}m=c[d+20>>2]|0;if((m|0)!=0){PV(m)}m=c[d+36>>2]|0;if((m|0)!=0){PV(m)}PV(d);i=b;return}function $U(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=OV(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){PV(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=OV((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function aV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=mV(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=mV(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=mV(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function bV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=cV(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==1){r=c[o+4>>2]|0;s=cV(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=cV(a,c[r+4>>2]|0)|0}else if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){u=r;v=d;w=0;while(1){x=w+1|0;if((u|0)==(s|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((s|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=s;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=cV(a,s)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){t=cV(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=cV(a,r)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function cV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=RV(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;cV(a,b)|0;i=d;return 0}return 0}function dV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;cV(d,e)|0;e=cV(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==2){y=c[u+4>>2]|0;x=cV(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=cV(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[y>>2]|0;D=c[y+4>>2]|0;E=c[y+8>>2]|0;F=a[y+12|0]|0;y=mV(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}H=mV(b,0,0,1,16)|0;I=y+4|0;c[I>>2]=H;if((H|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[H>>2]=x;c[H+4>>2]=D;c[H+8>>2]=E;E=H+12|0;a[E]=a[E]&-2|F&1;c[y+16>>2]=c[x+16>>2];c[t>>2]=y;A=s;B=r;t=c[I>>2]|0;s=A;r=B;continue b}else if((z|0)==0){I=c[u+4>>2]|0;y=c[I+8>>2]|0;x=c[I>>2]|0;F=c[I+4>>2]|0;do{if((x|0)>-1|(x|0)==-4){J=r;K=F;L=x;M=s+1|0;N=(c[g>>2]|0)+y|0}else{if(!((x|0)==-3)){J=r;K=F;L=x;M=s;N=y;break}if(!p){J=r;K=-1;L=-1;M=s;N=-1;break}if(q|(r|0)==0){J=r;K=F;L=-3;M=s;N=y;break}c[h+(F<<2)>>2]=1;J=0;K=F;L=-3;M=s;N=y}}while(0);y=mV(b,0,0,1,32)|0;F=y;do{if((y|0)==0){O=0}else{x=mV(b,0,0,1,20)|0;c[y+4>>2]=x;if((x|0)==0){O=0;break}c[y>>2]=0;c[y+8>>2]=-1;c[y+12>>2]=-1;c[x>>2]=L;c[x+4>>2]=K;c[x+8>>2]=N;O=F}}while(0);c[t>>2]=O;F=(O|0)==0?12:0;if((N|0)<=(c[k>>2]|0)){P=J;Q=M;R=t;S=F;break}c[k>>2]=N;P=J;Q=M;R=t;S=F}else if((z|0)==3){F=c[u+4>>2]|0;y=c[F>>2]|0;x=F+4|0;I=c[x>>2]|0;E=mV(b,0,0,1,32)|0;if((E|0)==0){G=20;break b}H=mV(b,0,0,1,8)|0;D=E+4|0;c[D>>2]=H;if((H|0)==0){G=20;break b}c[E>>2]=3;c[E+8>>2]=-1;c[E+12>>2]=-1;c[H>>2]=y;c[(c[D>>2]|0)+4>>2]=I;c[E+16>>2]=(c[I+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=E;E=c[D>>2]|0;D=cV(d,c[x>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,E+4|0)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,c[F>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}P=r;Q=s;R=E;S=cV(d,0)|0}else if((z|0)==1){E=c[u+4>>2]|0;D=c[E>>2]|0;F=E+4|0;x=c[F>>2]|0;y=mV(b,0,0,1,32)|0;if((y|0)==0){G=29;break b}I=mV(b,0,0,1,8)|0;H=y+4|0;c[H>>2]=I;if((I|0)==0){G=29;break b}c[y>>2]=1;c[y+8>>2]=-1;c[y+12>>2]=-1;c[I>>2]=D;c[(c[H>>2]|0)+4>>2]=x;c[y+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=y;y=c[H>>2]|0;c[y>>2]=0;H=y+4|0;c[H>>2]=0;D=cV(d,c[F>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,H)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=cV(d,c[E>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}P=r;Q=s;R=y;S=cV(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((S|0)==0){r=P;s=Q;t=R}else{v=Q;w=S;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function eV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=mV(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=mV(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=mV(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=mV(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function fV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=mV(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=mV(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=mV(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=mV(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function gV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function hV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=120952}else{j=b;k=120952;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((qW(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,121240,g|0)|0)+1|0;i=d;return h|0}function iV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=OV(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=OV(y)|0;if((z|0)==0){A=12;break}uW(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=SU(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((xU(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((xU(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((xU(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((xU(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(xU(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(xU(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(xU(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(xU(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){uW(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=SU(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((xU(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((xU(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((xU(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((xU(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(xU(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(xU(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(xU(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(xU(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((BU(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=NU(X)|0;qb=_a+24|0;if((BU(fb,c[qb>>2]|0)|0)!=0){break}fb=LU(X)|0;if((BU(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((BU(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=LU(X)|0;if((BU(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=NU(X)|0;if((BU(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}PV(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=kV(0,0)|0;if((S|0)==0){A=12;break}R=mV(S,0,0,0,32)|0;Q=R;if((R|0)==0){lV(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=OV(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=OV(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=OV(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){uW(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){uW(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=SU(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((xU(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((xU(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((xU(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((xU(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(xU(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(xU(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(xU(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(xU(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=mV(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=mV(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;jV(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((nW(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=SU(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=SU(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((xU(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((xU(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((xU(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((xU(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(xU(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(xU(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(xU(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(xU(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((BU(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=NU(tc)|0;aa=Ca+24|0;if((BU(qa,c[aa>>2]|0)|0)!=0){break}qa=LU(tc)|0;if((BU(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((BU(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=LU(tc)|0;if((BU(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=NU(tc)|0;if((BU(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=mV(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=mV(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){lV(S);if((Eb|0)!=0){PV(O)}if((Kb|0)!=0){PV(Kb)}if((Lb|0)==0){A=12;break a}PV(N);A=12;break a}else if((sa|0)==67){lV(S);if((Eb|0)!=0){PV(O)}if((Kb|0)!=0){PV(Kb)}if((Lb|0)==0){A=12;break a}PV(N);A=12;break a}else if((sa|0)==169){lV(S);if((Eb|0)!=0){PV(O)}if((Kb|0)!=0){PV(Kb)}if((Lb|0)==0){A=12;break a}PV(N);A=12;break a}else if((sa|0)==176){lV(S);if((Eb|0)!=0){PV(O)}if((Kb|0)!=0){PV(Kb)}if((Lb|0)==0){A=12;break a}PV(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);lV(S);if((Jb|0)!=0){PV(Jb)}if((Gb|0)!=0){PV(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}PV(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}jV(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}PV(m);p=A;i=g;return p|0}function jV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function kV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=QV(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function lV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;PV(e);i=b;return}else{f=d}while(1){PV(c[f>>2]|0);d=c[f+4>>2]|0;PV(f);if((d|0)==0){break}else{f=d}}e=a;PV(e);i=b;return}function mV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=OV(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=OV(p)|0;c[o>>2]=r;if((r|0)==0){PV(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}uW(m|0,0,h|0)|0;j=m;i=g;return j|0}function nV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((oV(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function oV(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function pV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function qV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function rV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function sV(a){a=a|0;i=i;return}function tV(a){a=a|0;c[a>>2]=121256;i=i;return}function uV(a){a=a|0;var b=0;b=i;zb(a|0);WV(a);i=b;return}function vV(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function wV(a){a=a|0;i=i;return 121272}function xV(a){a=a|0;i=i;return}function yV(a){a=a|0;i=i;return}function zV(a){a=a|0;i=i;return}function AV(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function BV(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function CV(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function DV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=HV(b,121384,121440,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;He[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function EV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function FV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;He[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function GV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;He[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;He[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function HV(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;qe[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}be[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function IV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;qe[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;be[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;be[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;be[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;be[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function JV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;be[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;qe[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function KV(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function LV(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;qe[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;qe[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function MV(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;qe[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function NV(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}



function uv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Wb(b|0,68464)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];vd(b|0,68472,y|0)|0;if((z|0)==0){C=Rd(10,b|0)|0;D=td(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];vd(b|0,68488,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;vd(b|0,68504,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;vd(b|0,68512,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;vd(b|0,68520,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((mW(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];vd(b|0,68488,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];vd(b|0,68488,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((mW(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;vd(b|0,68504,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;vd(b|0,68504,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((mW(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;vd(b|0,68512,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;vd(b|0,68512,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((mW(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;vd(b|0,68520,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];vd(b|0,68488,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;vd(b|0,68504,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;vd(b|0,68512,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((mW(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;vd(b|0,68520,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Wb(0,68464)|0;}while((d|0)!=0);C=Rd(10,b|0)|0;D=td(b|0)|0;i=e;return}function vv(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 5:{vr(1,0,68088,q);v=1;i=m;return v|0};case 4:{w=c[518]|0;if((w|0)!=0){if((mW(w,68128)|0)==0){break a}}tr(23,0,68144,p);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 11:case 10:case 9:case 6:case 7:case 8:{vr(1,0,68016,r);v=1;i=m;return v|0};case 18:{w=c[518]|0;do{if((w|0)!=0){if((mW(w,68272)|0)!=0){break}c[u>>2]=4;break a}}while(0);tr(23,0,68296,o);v=1;i=m;return v|0};default:{}}}while(0);o=qv(a,s)|0;Be[c[32764>>2]&7]()|0;do{if((o|0)==0){r=sv(a,b,d,e,f,g)|0;Be[c[32764>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){fe[c[73308>>2]&127](73288,a);qu(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(23,0,68424,n);r=we[c[c[a+540>>2]>>2]&63](a,t)|0;Be[c[32764>>2]&7]()|0;tv(a,s,l)|0;Be[c[32764>>2]&7]()|0;x=r}else{Be[c[32764>>2]&7]()|0;x=o}}while(0);rv(a,s)|0;v=x;i=m;return v|0}function wv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){xv(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((he[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){xr(c[a+536>>2]|0,68536,d)}else if((k|0)==6){xv(a);i=b;return}}function xv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;uW(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function yv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;PV(c[f+(a*48|0)+28>>2]|0);PV(c[f+(a*48|0)+32>>2]|0);PV(c[f+(a*48|0)+16>>2]|0);PV(c[f+(a*48|0)+20>>2]|0);PV(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function zv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=OV(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=OV(c[y>>2]<<2)|0;Av(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;sW(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;sW(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Ht(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Bv(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){sW(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;sW(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;PV(x);PV(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;vr(5,1,68592,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];gc(q|0,68624,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;vr(5,0,68632,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=32416;K=c[8104]|0;ee[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=68640;aa=$;xr(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];vr(5,0,68632,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=32416;K=c[8104]|0;ee[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=4;_=Z;$=68640;aa=$;xr(O,aa,g);return 0}function Av(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;uW(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}he[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Bv(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=QV(d,4)|0;r=QV(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;PV(q);PV(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;PV(q);PV(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){PV(q);PV(r);i=o;return v|0}if((n|0)==0){v=-1;PV(q);PV(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(5,1,68744,p);Cv(s,d,f,c[g>>2]|0,j,l,m);if((c[31884>>2]|0)==0){v=-1;PV(q);PV(r);i=o;return v|0}ee[c[8104]&255](5);v=-1;PV(q);PV(r);i=o;return v|0}function Cv(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;uW(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];tr(5,0,68776,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Dv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=hc(68792,68816)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=dd(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((dd(n|0)|0)!=10);q=c[b+152>>2]|0;r=QV(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=QV(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=QV(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Nd(n|0,68824,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Nd(n|0,68824,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=QV(s,8)|0;x=v}}while(0);fc(68832,j|0)|0;fc(68888,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];fc(68848,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];fc(68872,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(68888)|0;Yc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Ev(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}PV(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){PV(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}PV(l);i=d;return 0}function Fv(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Gv(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Hv(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[31900>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];tr(9,1,68952,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(9,0,69064,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}ee[c[8104]&255](9);g=1;i=b;return g|0}function Hv(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;Wv(b);g=f+540|0;he[c[(c[g>>2]|0)+84>>2]&127](f)|0;he[c[(c[g>>2]|0)+36>>2]&127](f)|0;he[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;we[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Iv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Hv(b,1.0);if((c[31900>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}tr(9,1,69088,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(9,0,69152,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(9,0,69112,s)}tr(9,1,69176,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;tr(9,0,69248,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];tr(9,0,69200,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;tr(9,0,69336,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(9,0,69272,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;tr(9,0,69424,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tr(9,0,69368,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}ee[c[8104]&255](9);tr(9,1,69456,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=he[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;tr(9,0,69248,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];tr(9,0,69200,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}ee[c[8104]&255](9);ee[c[8104]&255](9);i=d;return}function Jv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[31900>>2]|0)!=0){ru(b,9)}if((c[31960>>2]|0)==0){i=d;return}tr(24,1,69480,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){tr(24,1,69520,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tr(24,0,69544,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}ee[c[8104]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}tr(24,1,69600,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tr(24,0,69624,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}ee[c[8104]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){tr(24,1,69656,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tr(24,0,69544,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}ee[c[8104]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){tr(24,1,69680,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;tr(24,0,69704,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}ee[c[8104]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){tr(24,1,69752,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?69824:69832;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?69824:69832;t=(a[(c[l>>2]|0)+n|0]|0)!=0?69824:69832;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;tr(24,0,69776,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}ee[c[8104]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){tr(24,1,69840,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;tr(24,0,69864,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}ee[c[8104]&255](24)}ee[c[8104]&255](24);i=d;return}function Kv(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;tr(9,0,69912,z);if((f|0)==0){ou(b);pu(b);C=6}else{if((a[f]|0)!=0){Lv(b,f,g)}ou(b);pu(b);if((a[f]|0)==0){C=6}}if((C|0)==6){he[c[(c[A>>2]|0)+84>>2]&127](b)|0;he[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(mW(d,71400)|0)==0|0;f=(mW(d,71408)|0)==0;z=(mW(d,71416)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;vr(1,0,69960,y);vr(1,0,69992,x);c[w>>2]=71400;c[w+4>>2]=71208;vr(1,0,70016,w);c[v>>2]=71408;c[v+4>>2]=71288;vr(1,0,70016,v);c[u>>2]=71416;c[u+4>>2]=71336;vr(1,0,70016,u);xr(c[b+536>>2]|0,70048,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(mW(e,c[70072+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;vr(1,0,70104,s);vr(1,0,69992,r);t=1;do{u=c[70136+(t<<2)>>2]|0;c[q>>2]=c[70072+(t<<2)>>2];c[q+4>>2]=u;vr(1,0,70016,q);t=t+1|0;}while((t|0)<7);xr(c[b+536>>2]|0,70048,p)}}while(0);p=c[70032+(D<<2)>>2]|0;c[o>>2]=c[69944+(D<<2)>>2];c[o+4>>2]=p;tr(9,0,70168,o);o=(D|0)==2;if(o){p=c[70136+(F<<2)>>2]|0;c[n>>2]=c[70072+(F<<2)>>2];c[n+4>>2]=p;tr(9,0,70208,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Mv(b,F,j)|0;break}if((D|0)==3){Nv(b,j);I=0;break}else{xr(c[b+536>>2]|0,70248,m)}}}while(0);if((Yu(b,1)|0)!=0){J=-2;Jv(b);K=15;L=K;M=70272;N=M;tr(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];Zt(b,R,V);W=186;lu(b);X=192;qu(b);Y=187;gu(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=he[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=we[ha&63](b,1)|0;ja=195;mu(b);i=k;return J|0}if((Ou(b,1)|0)!=0){J=-3;Jv(b);K=15;L=K;M=70272;N=M;tr(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];Zt(b,R,V);W=186;lu(b);X=192;qu(b);Y=187;gu(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=he[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=we[ha&63](b,1)|0;ja=195;mu(b);i=k;return J|0}m=(Du(b,1)|0)==0;J=m?I:-4;Jv(b);K=15;L=K;M=70272;N=M;tr(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];Zt(b,R,V);W=186;lu(b);X=192;qu(b);Y=187;gu(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=he[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=we[ha&63](b,1)|0;ja=195;mu(b);i=k;return J|0}function Lv(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tr(9,0,71432,z);z=as(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;xr(C,71472,y)}tr(9,0,71512,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=bs(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=Qv(c[d+(C*112|0)+4>>2]|0)|0;E=bs(A,D)|0;PV(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((nW(E,71552,6)|0)==0){if((c[31900>>2]|0)==0){break}}else{D=nW(E,71560,6)|0;if((c[31900>>2]|D|0)==0){break}}c[v>>2]=E;vr(9,0,71568,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;hs(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tr(9,0,71536,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}tr(9,0,71624,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=bs(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=Qv(c[G+(w*112|0)+4>>2]|0)|0;v=bs(A,F)|0;PV(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];vr(9,0,71648,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;hs(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];tr(9,0,71536,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}tr(9,0,71704,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=bs(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=Qv(c[t+(x*112|0)+4>>2]|0)|0;K=bs(A,C)|0;PV(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];vr(9,0,71648,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;hs(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tr(9,0,71536,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}tr(9,0,71728,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=bs(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=Qv(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=bs(A,u)|0;PV(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];vr(9,0,71776,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;hs(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;tr(9,0,71760,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}tr(9,0,71832,l);l=b+144|0;if((c[l>>2]|0)<=0){_r(A);i=f;return}o=b+32|0;b=0;do{x=bs(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=Qv(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=bs(A,n)|0;PV(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];vr(9,0,71880,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;hs(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?69824:69832;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;tr(9,0,71864,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));_r(A);i=f;return}function Mv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;Yt(a,+h[a+240>>3]);lu(a);qu(a);gu(a);su(a);xv(a);hu(a);lu(a);e=Ov(a,b,c)|0;qu(a);gu(a);mu(a);qu(a);i=d;return e|0}function Nv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;Yt(b,+h[b+240>>3]);lu(b);qu(b);zv(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=QV(c[y>>2]|0,8)|0;A=b+124|0;B=QV(c[A>>2]|0,4)|0;C=b+128|0;D=QV(c[C>>2]|0,1)|0;E=b+132|0;F=QV(c[E>>2]|0,4)|0;G=b+536|0;wr(c[G>>2]|0,(z|0)!=0|0,70304,t);wr(c[G>>2]|0,(B|0)!=0|0,70304,s);wr(c[G>>2]|0,(D|0)!=0|0,70304,r);wr(c[G>>2]|0,(F|0)!=0|0,70304,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[31900>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];gc(x|0,70320,p|0)|0;p=hc(x|0,70336)|0;c[o>>2]=70352;vd(p|0,70344,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];vd(p|0,70344,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Rd(10,p|0)|0;H=p}tr(9,1,70360,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;he[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tr(9,0,70384,l);if((c[31900>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];vd(H|0,70408,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];vd(H|0,70408,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Rd(10,H|0)|0}if((Yu(b,0)|0)!=0){break a}if((Ou(b,0)|0)!=0){break a}if((Du(b,0)|0)!=0){break a}tu(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);ee[c[8104]&255](9);if((c[31900>>2]|0)!=0){Yc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}PV(z);PV(B);PV(D);PV(F)}else{h[b+304>>3]=1.0;he[c[w+80>>2]&127](b)|0}iu(b);if((zv(b,1,1)|0)!=1){i=e;return}he[c[(c[v>>2]|0)+80>>2]&127](b)|0;iu(b);if((zv(b,1,1)|0)!=1){i=e;return}vr(1,0,70416,f);i=e;return}function Ov(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=Rv(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){tr(9,0,70520,u);if((c[b+184>>2]|0)==0){we[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}PV(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){tr(9,0,70552,t);we[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;PV(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){tr(9,1,70624,s);t=OV(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Hv(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Hv(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}tr(9,1,70648,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];tr(9,0,70672,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];tr(9,0,70672,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];tr(9,0,70672,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[31900>>2]|0)!=0){ee[c[8104]&255](9);ee[c[8104]&255](9)}PV(t);Sv(v);H=Rv(b)|0;if((c[H>>2]|0)!=0){$=H;break}tr(9,0,70696,n);PV(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}tr(9,0,70728,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){tr(9,0,70744,l);Pv($,d,1,e);Iv(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Hv($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){PV(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){PV(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){PV(v);c[l>>2]=0}Pv($,d,0,e);Iv(b,$);+Hv($,1.0)}else{tr(9,0,70768,j)}tr(9,1,70792,g);Iv(b,$);b=Gv($)|0;if((c[31900>>2]|0)!=0){ee[c[8104]&255](9)}Sv($);y=b;i=f;return y|0}function Pv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=OV(c[p>>2]<<3)|0;r=q;s=+Hv(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;Uv(a,r);PV(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=70920;F=E;tr(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;tr(9,0,70832,m);if(!t){Tv(a)}switch(b|0){case 5:{G=13;break a;break};case 6:{G=14;break a;break};case 3:{H=bw(a,n,e)|0;break};case 1:{H=$v(a)|0;break};case 4:{G=12;break a;break};case 2:{H=Zv(a)|0;break};default:{G=15;break a}}qu(o);gu(o);mu(o);qu(o);s=+Hv(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}tr(9,0,70880,k);Iv(o,a);K=s}else{tr(9,0,70896,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){Yv(a)|0}else if((G|0)==13){Yv(a)|0}else if((G|0)==14){Xv(o,a,0)|0}else if((G|0)==15){xr(c[o+536>>2]|0,70856,l)}else if((G|0)==23){Uv(a,r);PV(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=70920;F=E;tr(9,0,F,g);i=f;return}}function Qv(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=qW(b|0)|0;do{if((d|0)==0){e=OV(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=OV(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((lW(e,71936,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;sW(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((lW(e,71936,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function Rv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=OV(64)|0;z=y;wr(0,(y|0)!=0|0,71944,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=QV(Z,8)|0;c[E>>2]=y;wr(0,(y|0)!=0|0,71944,w);w=QV(Z,8)|0;c[F>>2]=w;wr(0,(w|0)!=0|0,71944,v);v=QV(Z,8)|0;c[G>>2]=v;wr(0,(v|0)!=0|0,71944,u);u=QV(Z,8)|0;c[H>>2]=u;wr(0,(u|0)!=0|0,71944,t);t=QV(Z,8)|0;c[I>>2]=t;wr(0,(t|0)!=0|0,71944,s);s=QV(Z,4)|0;t=s;c[J>>2]=t;wr(0,(s|0)!=0|0,71944,r);tr(9,0,71960,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;tr(9,0,71984,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tr(9,0,72072,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];tr(9,0,72120,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];tr(9,0,72176,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;tr(9,0,72232,l);c[j>>2]=ya;tr(9,0,72304,j);j=QV(sa,8)|0;c[K>>2]=j;wr(0,(j|0)!=0|0,71944,g);g=OV(sa<<3)|0;c[L>>2]=g;wr(0,(g|0)!=0|0,71944,f);f=OV(ya<<3)|0;c[M>>2]=f;wr(0,(f|0)!=0|0,71944,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function Sv(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){PV(d)}d=c[a+28>>2]|0;if((d|0)!=0){PV(d)}d=c[a+32>>2]|0;if((d|0)!=0){PV(d)}d=c[a+36>>2]|0;if((d|0)!=0){PV(d)}d=c[a+40>>2]|0;if((d|0)!=0){PV(d)}d=c[a+44>>2]|0;if((d|0)!=0){PV(d)}d=c[a+48>>2]|0;if((d|0)!=0){PV(d)}d=c[a+52>>2]|0;if((d|0)!=0){PV(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;PV(e);i=b;return}PV(d);e=a;PV(e);i=b;return}function Tv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=QV(o,8)|0;q=QV(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=QV(s,8)|0;u=QV(s,8)|0;v=QV(o,8)|0;w=QV(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Hv(b,1.0);s=c[n>>2]|0;if((s|0)>0){sW(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Hv(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){sW(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;tr(9,0,72344,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}PV(p);PV(q);PV(t);PV(u);PV(v);PV(w);i=d;return}function Uv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Vv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function Wv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function Xv(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;xr(c[a+536>>2]|0,72416,d);return 0}function Yv(a){a=a|0;a=i;i=i+8|0;xr(0,72448,a);return 0}function Zv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[31900>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=QV((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;wr(0,(n|0)!=0|0,72488,b);c[18126]=c[a+60>>2];c[18128]=c[a+48>>2];yt(k,j,c[a+24>>2]|0,g,f,d,e,n,5)|0;PV(n);c[18126]=0;c[18128]=0;n=Gv(a)|0;i=b;return n|0}function _v(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[18128];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[18126];h[d>>3]=+Hv(f,1.0);i=e;return}function $v(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=OV(x)|0;z=y;A=OV(x)|0;x=A;wr(0,(y|0)!=0|0,72520,n);wr(0,(A|0)!=0|0,72520,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[31900>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Hv(a,1.0);h[o>>3]=D;if(D!=0.0){c[18134]=c[a+60>>2];c[18136]=c[a+48>>2];vt(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,6,u)|0;c[18134]=0;c[18136]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];tr(9,0,72552,l)}D=+Hv(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];tr(9,0,72656,j);j=c[u>>2]|0;do{if((j|0)==3){vr(9,0,72816,e);F=-3;i=b;return F|0}else if((j|0)==2){vr(9,0,72752,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];vr(9,0,72672,g);F=-1;i=b;return F|0}else if((j|0)==4){vr(9,0,72888,d);F=-4;i=b;return F|0}}while(0);F=Gv(a)|0;i=b;return F|0}function aw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[18136];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[18134];h[d>>3]=+Hv(f,1.0);i=e;return}function bw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;tr(9,1,72944,g);if((c[31900>>2]|0)==0){l=0}else{l=(k|0)/10|0}cw(a,d,k,l,b,j);c[f>>2]=c[j>>2];tr(9,0,72968,f);ee[c[8104]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Gv(a)|0;if((b|0)==0){m=0;i=e;return m|0}vr(9,0,72984,e);m=b;i=e;return m|0}function cw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=OV(fa(N,M)|0)|0;P=OV(M<<3)|0;Q=OV(N)|0;R=Q;S=OV(N)|0;T=S;V=OV(N)|0;W=V;X=OV(N)|0;Y=+h[f>>3];if((c[31900>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];gc(N|0,73032,I|0)|0;I=hc(N|0,73048)|0;c[H>>2]=73064;vd(I|0,73056,H|0)|0;c[G>>2]=73080;vd(I|0,73056,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];vd(I|0,73056,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Rd(10,I|0)|0;c[E>>2]=0;vd(I|0,73088,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];vd(I|0,73096,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];vd(I|0,73096,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Rd(10,I|0)|0;Z=I}else{Z=0}wr(0,(O|0)!=0|0,73104,B);wr(0,(P|0)!=0|0,73104,A);wr(0,(Q|0)!=0|0,73104,z);wr(0,(S|0)!=0|0,73104,y);wr(0,(V|0)!=0|0,73104,x);wr(0,(X|0)!=0|0,73104,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Vv(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Hv(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Vv(a,la);+Hv(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];tr(9,0,73120,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){uW(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Vv(a,R);za=+Hv(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}sW(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Vv(a,T);if(+Hv(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}sW(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}sW(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Vv(a,W);Ba=+Hv(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Vv(a,W);Ba=+Hv(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}sW(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tr(9,0,73160,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;vd(Z|0,73088,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];vd(Z|0,73096,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];vd(Z|0,73096,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Rd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];vr(9,0,73208,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];vr(9,0,73224,p);xr(0,73240,o)}Vv(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){PV(S);PV(Q);PV(V);PV(X);PV(P);PV(O);i=j;return}c[n>>2]=ia;vd(Z|0,73088,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];vd(Z|0,73096,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];vd(Z|0,73096,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Rd(10,Z|0)|0;Yc(Z|0)|0;PV(S);PV(Q);PV(V);PV(X);PV(P);PV(O);i=j;return}function dw(a,b){a=a|0;b=b|0;i=i;return}function ew(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Is(3);Ls(0);w=+Ds(0);Is(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];vd(v|0,73320,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];vd(v|0,73320,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];vd(v|0,73320,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];vd(v|0,73328,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;vd(v|0,73328,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];vd(v|0,73336,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];vd(v|0,73320,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];vd(v|0,73320,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;vd(v|0,73328,l|0)|0;break}else{c[m>>2]=0-E;vd(v|0,73328,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;vd(v|0,73328,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;vd(v|0,73328,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Rd(10,v|0)|0;Ls(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];vd(v|0,73336,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Rd(10,v|0)|0;Ls(3);i=e;return}function fw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=hc(c[r>>2]|0,73344)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Vd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;wr(t,(s|0)!=0|0,73352,q);c[p>>2]=73408;vd(s|0,73336,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=73416;vd(s|0,73336,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];vd(s|0,73336,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];vd(s|0,73336,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];vd(s|0,73336,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];vd(s|0,73336,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];vd(s|0,73336,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];vd(s|0,73336,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];vd(s|0,73336,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Rd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];vd(s|0,73336,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Rd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function gw(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Is(3);Yc(d|0)|0;Ls(3);i=b;return}function hw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;_N(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];$N(p,f)|0;iw(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;jw(a,b,73432,c[j>>2]|0,c[g>>2]|0,o,8);PV(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];$N(p,e)|0;i=d;return}function iw(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=QV(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;wr(c[b+536>>2]|0,(p|0)!=0|0,73712,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function jw(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;uw(a,b,d,e,f,h);ZN(l,g,fa(fa(f,e)|0,h)|0)|0;if(uM(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];xr(l,73664,k)}else{i=j;return}}function kw(a){a=a|0;var b=0;b=i;if((mx(a+4|0)|0)!=0){i=b;return}xM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function lw(a){a=a|0;Rc(a|0)|0;Ya()}function mw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=UV(320)|0;uW(q|0,0,320)|0;nw(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Is(3);t=a+8|0;u=ow(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=pw(a,b,u+s|0)|0;u=q+184|0;qw(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;qw(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;rw(q,c[x>>2]|0,36);if(uM(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];xr(y,73488,e)}else{jw(a,b,73520,4,11,73440,1);sw((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;jw(a,b,73528,c[g>>2]|0,c[j>>2]|0,e,1);PV(e);c[f>>2]=0;sw((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;jw(a,b,73536,c[g>>2]|0,c[j>>2]|0,e,1);PV(e);c[f>>2]=0;tw(a,b,k,g,j,c[r>>2]|0,s);jw(a,b,73552,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;_N(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];iw(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;jw(a,b,73432,c[j>>2]|0,c[g>>2]|0,n,8);_N(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=vw(q+240|0)|0;w=vw(q+264|0)|0;p=vw(q+288|0)|0;uw(a,b,73568,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);PV(n);PV(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;FN(s)|0;PV(v);Ls(3);i=d;return}}function nw(a){a=a|0;var b=0;b=i;wz(a);i=b;return}function ow(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(Ay(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(Ay(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(Ay(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function pw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=OV(e<<2)|0;e=l;c[l>>2]=74120;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=74160;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(Ay(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(Ay(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(Ay(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function qw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;lx(a,b,c);i=d;return}function rw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(kx(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){xM(d,4);i=e;return}else{vM(d,0);i=e;return}}function sw(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=qW(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=QV((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;wr(0,(o|0)!=0|0,73640,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;BW(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;zw(q,qW(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=QV(1,1)|0;c[d>>2]=q;wr(0,(q|0)!=0|0,73640,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}



function tw(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=QV(c[f>>2]<<2,4)|0;c[e>>2]=g;wr(c[d+536>>2]|0,(g|0)!=0|0,73688,k);g=s+240|0;f=vw(g)|0;h=s+264|0;t=vw(h)|0;u=s+288|0;v=vw(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=vw(g)|0;D=vw(h)|0;E=vw(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){Aw(l,g,A+(v*52|0)+4|0);Cw(m,g);if(!(Bw(l,m)|0)){F=w;break}G=(c[(Dw(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else if(z<<24>>24==1){Aw(l,b,A+(v*52|0)+4|0);Cw(n,b);if(!(Bw(l,n)|0)){F=w;break}G=(c[(Dw(l)|0)+4>>2]|0)+1|0;H=1}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){Aw(l,h,G+(t*52|0)+4|0);Cw(o,h);H=Bw(l,o)|0;J=H?2:0}else if(f<<24>>24==1){Aw(l,v,G+(t*52|0)+4|0);Cw(p,v);J=(Bw(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(Dw(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){Aw(l,d,y+(t*52|0)+4|0);Cw(r,d);M=(Bw(l,r)|0)&1}else if(x<<24>>24==0){Aw(l,u,y+(t*52|0)+4|0);Cw(q,u);x=Bw(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(Dw(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function uw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(qW(d|0)|0)+1;e=m;ZN(e,l,20)|0;if(uM(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];xr(l,73664,k)}ZN(e,d,c[f>>2]|0)|0;if(uM(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];xr(m,73664,j)}else{i=h;return}}function vw(a){a=a|0;var b=0,d=0;b=i;d=c[(hx(a)|0)>>2]|0;i=b;return d|0}function ww(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Is(3);do{if(tM(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];$N(k,e)|0;k=vw(h+240|0)|0;m=vw(h+264|0)|0;l=vw(h+288|0)|0;uw(a,b,73568,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);kw(h)}else{if((h|0)!=0){break}c[g>>2]=0;Ls(3);i=d;return}}while(0);xw(j);WV(h);c[g>>2]=0;Ls(3);i=d;return}function xw(a){a=a|0;var b=0;b=i;Fx(a);i=b;return}function yw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Is(3);Ls(0);h[j>>3]=+Ds(0);Is(0);l=k;m=d+4|0;ZN(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){ZN(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){ZN(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);ZN(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);ZN(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);ZN(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(uM(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];xr(t,73608,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Ls(3);i=e;return}}function zw(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((nW(b,73824,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((nW(b,73824,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function Aw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Vw(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Lw(a,f);i=e;return}function Bw(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Jw(a,b)|0;i=c;return d|0}function Cw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Mw(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Lw(a,e);i=d;return}function Dw(a){a=a|0;var b=0,c=0;b=i;c=Ew(Fw(a)|0)|0;i=b;return c|0}function Ew(a){a=a|0;var b=0,c=0;b=i;c=Iw(a)|0;i=b;return c|0}function Fw(a){a=a|0;var b=0,d=0;b=i;d=Gw((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Gw(a){a=a|0;var b=0,c=0;b=i;c=Hw(a)|0;i=b;return c|0}function Hw(a){a=a|0;i=i;return a|0}function Iw(a){a=a|0;i=i;return a|0}function Jw(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Kw(a,b)|0)^1;i=c;return d|0}function Kw(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Lw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Uw(a,e);i=d;return}function Mw(a,b){a=a|0;b=b|0;var c=0;c=i;Nw(a,Ow(b)|0);i=c;return}function Nw(a,b){a=a|0;b=b|0;var c=0;c=i;Tw(a,b);i=c;return}function Ow(a){a=a|0;var b=0,c=0;b=i;c=Pw(Qw(a+4|0)|0)|0;i=b;return c|0}function Pw(a){a=a|0;var b=0,c=0;b=i;c=Sw(a)|0;i=b;return c|0}function Qw(a){a=a|0;var b=0,c=0;b=i;c=Rw(a)|0;i=b;return c|0}function Rw(a){a=a|0;i=i;return a|0}function Sw(a){a=a|0;i=i;return a|0}function Tw(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Uw(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Vw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=Xw(b)|0;Ww(f,b,d,h,Ow(b)|0);Mw(g,b);do{if(Jw(f,g)|0){h=Yw(b)|0;if(Zw(h,d,_w(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Mw(a,b);i=e;return}function Ww(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;cx(h);a:do{if((e|0)==0){j=f}else{k=Yw(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(dx(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;cx(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;cx(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Nw(a,j);i=g;return}function Xw(a){a=a|0;var b=0,d=0;b=i;d=c[(Ow(a)|0)>>2]|0;i=b;return d|0}function Yw(a){a=a|0;var b=0,c=0;b=i;c=ax(a+8|0)|0;i=b;return c|0}function Zw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=$w(0,b,c)|0;i=a;return d|0}function _w(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function $w(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function ax(a){a=a|0;var b=0,c=0;b=i;c=bx(a)|0;i=b;return c|0}function bx(a){a=a|0;i=i;return a|0}function cx(a){a=a|0;var b=0;b=i;ex(a,-1);i=b;return}function dx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=$w(0,b,c)|0;i=a;return d|0}function ex(a,b){a=a|0;b=b|0;b=i;fx(a,0);i=b;return}function fx(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function gx(a){a=a|0;i=i;return c[a+4>>2]|0}function hx(a){a=a|0;var b=0,c=0;b=i;c=ix(a+8|0)|0;i=b;return c|0}function ix(a){a=a|0;var b=0,c=0;b=i;c=jx(a)|0;i=b;return c|0}function jx(a){a=a|0;i=i;return a|0}function kx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 24:{h=73752;break};case 5:case 21:{h=73784;break};case 9:case 25:{h=73768;break};case 60:{h=73808;break};case 12:{h=73792;break};case 28:{h=73800;break};case 56:{h=73760;break};case 13:case 29:{h=73816;break};case 8:{h=73744;break};case 48:case 16:{h=73728;break};case 52:case 20:{h=73776;break};case 1:case 17:{h=73736;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=hc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Wc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Yc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function lx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function mx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}nx(d,f,102);f=he[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Yc(ox(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}px(d);g=h;i=b;return g|0}function nx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wx(a,b,c);i=d;return}function ox(a){a=a|0;var b=0,d=0;b=i;d=sx(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function px(a){a=a|0;var b=0;b=i;qx(a);i=b;return}function qx(a){a=a|0;var b=0;b=i;rx(a,0);i=b;return}function rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=sx(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}he[c[(tx(e)|0)>>2]&127](f)|0;i=d;return}function sx(a){a=a|0;var b=0,c=0;b=i;c=vx(a)|0;i=b;return c|0}function tx(a){a=a|0;var b=0,c=0;b=i;c=ux(a)|0;i=b;return c|0}function ux(a){a=a|0;i=i;return a+4|0}function vx(a){a=a|0;i=i;return a|0}function wx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(yx(f)|0)>>2]|0;xx(a,d,c[(zx(g)|0)>>2]|0);i=e;return}function xx(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Ax(a,b,c);i=d;return}function yx(a){a=a|0;i=i;return a|0}function zx(a){a=a|0;i=i;return a|0}function Ax(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Cx(f)|0)>>2]|0;Bx(a,d,c[(Dx(g)|0)>>2]|0);i=e;return}function Bx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(Cx(f)|0)>>2];c[a+4>>2]=c[(Dx(g)|0)>>2];i=e;return}function Cx(a){a=a|0;i=i;return a|0}function Dx(a){a=a|0;i=i;return a|0}function Ex(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function Fx(a){a=a|0;var b=0;b=i;Gx(a+300|0);Gx(a+288|0);Gx(a+276|0);Gx(a+264|0);Gx(a+252|0);Gx(a+240|0);Hx(a);i=b;return}function Gx(a){a=a|0;var b=0;b=i;ry(a);i=b;return}function Hx(a){a=a|0;var b=0;b=i;Ix(a,73872);BM(a+104|0);i=b;return}function Ix(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Mx(a+4|0);i=d;return}function Jx(a){a=a|0;var b=0;b=i;Hx(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Kx(a){a=a|0;var b=0;b=i;Hx(a);WV(a);i=b;return}function Lx(a){a=a|0;var b=0;b=i;Kx(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Mx(a){a=a|0;var b=0;b=i;Nx(a);i=b;return}function Nx(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=74e3;mx(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}XV(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}XV(e)}}while(0);KM(b);i=d;return}function Ox(a){a=a|0;var b=0;b=i;Mx(a);WV(a);i=b;return}function Px(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;he[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=py(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=qy(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;UM(h,0,0,0);ZM(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}XV(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=VV(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=VV(h)|0;a[b+97|0]=1;i=e;return}function Qx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;UM(e,0,0,0);ZM(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}XV(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}XV(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=VV(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(my(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=VV(o)|0;a[k]=1;i=f;return e|0}return 0}function Rx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Dc(4)|0;tV(n);Sd(n|0,121328,127)}n=iy(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((he[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){qw(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=JW(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Wc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;qw(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];ly(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{qw(a,-1,-1);i=g;return}}}while(0);qw(a,-1,-1);i=g;return}function Sx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((he[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=Ex(d)|0;if((Wc(j|0,k|0,0)|0)==0){ky(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{qw(a,-1,-1);i=e;return}}}while(0);qw(a,-1,-1);i=e;return}function Tx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Dc(4)|0;tV(m);Sd(m|0,121328,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=iy(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=SM(s)|0;u=(fa(t-(RM(s)|0)|0,p)|0)+r|0;v=0;break}p=RM(s)|0;if((p|0)==(SM(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=jy(t,g,x,o,p-(QM(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=SM(w)|0;u=q-(RM(w)|0)|0;v=0}}while(0);if((Wc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;UM(b,0,0,0);c[m>>2]=0}else{q=b;y=WM(q)|0;do{if((y|0)!=(VM(q)|0)){if((we[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=hy(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((qc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((td(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function Ux(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=cy(b)|0;o=b;if((RM(o)|0)==0){p=e+1|0;UM(o,e,p,p)}if(n){q=0}else{n=SM(o)|0;c[f>>2]=(n-(QM(o)|0)|0)/2|0;c[g>>2]=4;q=c[(dy(f,g)|0)>>2]|0}g=RM(o)|0;do{if((g|0)==(SM(o)|0)){tW(QM(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=SM(o)|0;n=QM(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=QM(o)|0;UM(o,n,n+q|0,n+(p+q)|0);r=ay(a[RM(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;tW(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(dy(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Dc(4)|0;tV(t);Sd(t|0,121328,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=QM(o)|0;if((ey(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;UM(o,f,f,c[s>>2]|0);r=ay(a[RM(o)|0]|0)|0;break}s=c[k>>2]|0;f=QM(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}UM(o,f,p,s);r=ay(a[RM(o)|0]|0)|0}else{r=ay(a[g]|0)|0}}while(0);if((QM(o)|0)!=(e|0)){m=r;i=d;return m|0}UM(o,0,0,0);m=r;i=d;return m|0}function Vx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=QM(g)|0;j=RM(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(Yx(d,-1)|0){TM(g,-1);f=$x(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=Zx(d)|0;do{if(h){if(by(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);TM(g,-1);a[RM(g)|0]=b;f=d;i=e;return f|0}function Wx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}Xx(b);l=b;m=VM(l)|0;n=XM(l)|0;if(!(Yx(d,-1)|0)){if((WM(l)|0)==0){ZM(l,f,f+1|0)}f=Zx(d)|0;a[WM(l)|0]=f;YM(l,1)}f=WM(l)|0;o=VM(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Dc(4)|0;u=t;tV(u);v=121328;w=127;Sd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=VM(l)|0;A=WM(l)|0;B=_x(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=VM(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((qc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;ZM(l,B,WM(l)|0);B=XM(l)|0;YM(l,B-(VM(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Dc(4)|0;u=t;tV(u);v=121328;w=127;Sd(t|0,v|0,w|0)}else if((D|0)==14){q=(WM(l)|0)-C|0;if((qc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((qc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);ZM(l,m,n)}k=$x(d)|0;i=e;return k|0}function Xx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;UM(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;ZM(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;ZM(f,h,h+(g+ -1)|0);break}}else{ZM(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function Yx(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function Zx(a){a=a|0;i=i;return a&255|0}function _x(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Fe[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function $x(a){a=a|0;var b=0,c=0;b=i;c=Yx(a,-1)|0;i=b;return(c?0:a)|0}function ay(a){a=a|0;i=i;return a&255|0}function by(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function cy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;ZM(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;UM(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;UM(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function dy(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=fy(b,c,e)|0;i=d;return g|0}function ey(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Fe[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function fy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=gy(0,b,a)|0;i=c;return(d?b:a)|0}function gy(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function hy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=xe[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function iy(a){a=a|0;var b=0,d=0;b=i;d=he[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function jy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=xe[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function ky(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function ly(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function my(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=ny(b,c,e)|0;i=d;return g|0}function ny(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=oy(0,a,b)|0;i=c;return(d?b:a)|0}function oy(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function py(a){a=a|0;var b=0,c=0;b=i;c=tS(a,105832)|0;i=b;return c|0}function qy(a){a=a|0;var b=0,d=0;b=i;d=he[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function ry(a){a=a|0;var b=0;b=i;sy(a);i=b;return}function sy(a){a=a|0;var b=0;b=i;ty(a);i=b;return}function ty(a){a=a|0;var b=0;b=i;uy(a,Xw(a)|0);i=b;return}function uy(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;cx(d);if((b|0)==0){i=d;return}uy(a,c[b>>2]|0);uy(a,c[b+4>>2]|0);wy(vy(a)|0,b,1);i=d;return}function vy(a){a=a|0;var b=0,c=0;b=i;c=yy(a+4|0)|0;i=b;return c|0}function wy(a,b,c){a=a|0;b=b|0;c=c|0;c=i;xy(0,b,0);i=c;return}function xy(a,b,c){a=a|0;b=b|0;c=c|0;c=i;WV(b);i=c;return}function yy(a){a=a|0;var b=0,c=0;b=i;c=zy(a)|0;i=b;return c|0}function zy(a){a=a|0;i=i;return a|0}function Ay(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=By(a,f,b)|0;l=c[k>>2]|0;cx(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Dy(j,a,b);Ey(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Cy(g,e);Fy(j);j=c[f>>2]|0;Gy(a,j,k,Hy(g)|0);k=Iy(g)|0;Fy(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function By(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Xw(h)|0;cx(e);if((a|0)==0){j=Ow(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if($w(0,d,a)|0){m=l;j=c[m>>2]|0;cx(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!($w(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;cx(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];uz(a,e);i=d;return}function Dy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=vy(d)|0;d=dz(n,1)|0;ez(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];cz(j,d,h);fz(0,_y((gz(j)|0)+16|0)|0,e);e=hz(j)|0;a[e+4|0]=1;iz(0,Zy((gz(j)|0)+20|0)|0);a[e+5|0]=1;jz(m,j);Ey(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Cy(b,g);Fy(m);Fy(j);i=f;return}function Ey(a,b){a=a|0;b=b|0;var c=0;c=i;az(a,b);i=c;return}function Fy(a){a=a|0;var b=0;b=i;Vy(a);i=b;return}function Gy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;cx(f);c[e>>2]=0;cx(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Ny(a)|0;b=c[c[e>>2]>>2]|0;cx(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Ow(a)|0)>>2]|0;Oy(e,c[d>>2]|0);d=Py(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Hy(a){a=a|0;var b=0,d=0;b=i;d=c[(Ly(a)|0)>>2]|0;i=b;return d|0}function Iy(a){a=a|0;var b=0,d=0;b=i;d=Jy(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Jy(a){a=a|0;var b=0,c=0;b=i;c=Ky(a)|0;i=b;return c|0}function Ky(a){a=a|0;i=i;return a|0}function Ly(a){a=a|0;var b=0,c=0;b=i;c=My(a)|0;i=b;return c|0}function My(a){a=a|0;i=i;return a|0}function Ny(a){a=a|0;i=i;return a|0}function Oy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=Sy(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;cx(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;cx(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(Sy(j)|0){p=j}else{o=c[k>>2]|0;Ty(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;Uy(p);i=e;return}else if((l|0)==14){if(Sy(j)|0){p=c[k>>2]|0;Uy(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;Ty(q);i=e;return}else if((l|0)==17){i=e;return}}function Py(a){a=a|0;var b=0,c=0;b=i;c=Qy(a+8|0)|0;i=b;return c|0}function Qy(a){a=a|0;var b=0,c=0;b=i;c=Ry(a)|0;i=b;return c|0}function Ry(a){a=a|0;i=i;return a|0}function Sy(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function Ty(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;cx(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=Sy(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Uy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;cx(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=Sy(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Vy(a){a=a|0;var b=0;b=i;Wy(a,0);i=b;return}function Wy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Jy(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Yy(Xy(e)|0,f);i=d;return}function Xy(a){a=a|0;var b=0,c=0;b=i;c=$y(a)|0;i=b;return c|0}function Yy(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}wy(c[a>>2]|0,b,1);i=d;return}function Zy(a){a=a|0;i=i;return a|0}function _y(a){a=a|0;i=i;return a|0}function $y(a){a=a|0;i=i;return a+4|0}function az(a,b){a=a|0;b=b|0;var c=0;c=i;bz(a,b);i=c;return}function bz(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];mz(a,b,f);i=e;return}function dz(a,b){a=a|0;b=b|0;var c=0;a=i;c=lz(0,b,0)|0;i=a;return c|0}function ez(a,b){a=a|0;b=b|0;var c=0;c=i;kz(a,b);i=c;return}function fz(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function gz(a){a=a|0;var b=0,d=0;b=i;d=c[(Ly(a)|0)>>2]|0;i=b;return d|0}function hz(a){a=a|0;var b=0,c=0;b=i;c=Xy(a)|0;i=b;return c|0}function iz(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;az(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Cy(h,f);Ey(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Cy(a,e);Fy(h);i=d;return}function kz(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function lz(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=UV(b*24|0)|0;i=c;return a|0}function mz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(oz(g)|0)>>2]|0;g=pz(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];nz(b,a,f);i=e;return}function nz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];qz(a,b,f);i=e;return}function oz(a){a=a|0;i=i;return a|0}function pz(a){a=a|0;i=i;return a|0}function qz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(sz(g)|0)>>2]|0;g=tz(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];rz(b,a,f);i=e;return}function rz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(sz(f)|0)>>2];f=tz(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function sz(a){a=a|0;i=i;return a|0}function tz(a){a=a|0;i=i;return a|0}function uz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Iy(vz(b)|0)|0;h=tz(hz(vz(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];nz(g,a,e);i=d;return}function vz(a){a=a|0;i=i;return c[a>>2]|0}function wz(a){a=a|0;var b=0;b=i;i=i+48|0;xz(a);qw(a+184|0,0,0);qw(a+200|0,0,0);yz(a+240|0,b);yz(a+252|0,b+8|0);yz(a+264|0,b+16|0);yz(a+276|0,b+24|0);yz(a+288|0,b+32|0);yz(a+300|0,b+40|0);i=b;return}function xz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;GM(d);e=a;c[e>>2]=73844;f=d;c[f>>2]=73864;d=a+4|0;NN(a,73876|0,d);c[e>>2]=73844;c[f>>2]=73864;Lz(d);i=b;return}function yz(a,b){a=a|0;b=b|0;b=i;zz(a,0);i=b;return}function zz(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Az(a,b);i=b;return}function Az(a,b){a=a|0;b=b|0;b=i;Bz(a,0);i=b;return}function Bz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Cz(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Dz(f,0,e);e=Ow(b)|0;c[(Ny(b)|0)>>2]=e;i=d;return}function Cz(a){a=a|0;var b=0;b=i;Hz(a);i=b;return}function Dz(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Ez(b,c,f);i=e;return}function Ez(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Gz(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Fz(d,b,f);i=e;return}function Fz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Gz(e)|0)>>2];i=d;return}function Gz(a){a=a|0;i=i;return a|0}function Hz(a){a=a|0;var b=0;b=i;Iz(a);i=b;return}function Iz(a){a=a|0;var b=0;b=i;Jz(a);i=b;return}function Jz(a){a=a|0;var b=0;b=i;Kz(a);i=b;return}function Kz(a){a=a|0;c[a>>2]=0;i=i;return}function Lz(a){a=a|0;var b=0;b=i;Mz(a);i=b;return}function Mz(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;PM(j);c[d>>2]=74e3;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;cx(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;LM(g,j);l=Nz(g)|0;rS(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ke[r&63](d,0,4096)|0;i=e;return}LM(h,j);c[k>>2]=py(h)|0;rS(h);a[f]=(qy(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ke[r&63](d,0,4096)|0;i=e;return}function Nz(a){a=a|0;var b=0,c=0;b=i;c=sS(a,105832)|0;i=b;return c|0}function Oz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Is(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){Pz(a,b,c[f>>2]|0,h);Ls(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=RV(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;xr(k,74272,e)}Pz(a,b,l,h);Ls(3);i=d;return}function Pz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Ls(0);k=+Ds(0);Is(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function Qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=OV(24)|0;Is(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;wr(c[m>>2]|0,l>>>31^1,74328,f);f=b+8|0;b=c[a+8>>2]|0;l=Rz(b,f)|0;c[g+20>>2]=l;l=Rz(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=OV(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;xr(k,74408,e)}else{c[h>>2]=0;c[a+12>>2]=g;Ls(3);i=d;return}}function Rz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function Sz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Is(3);u=b;v=hc(c[u>>2]|0,74472)|0;if((v|0)==0){Tz(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Vd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;xr(w,74480,q)}qc(74536,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];vd(v|0,74584,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];vd(v|0,74608,o|0)|0;qc(74632,40,1,v|0)|0;qc(74680,11,1,v|0)|0;qc(74696,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];Uz(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Rd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{qc(74712,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;Uz(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Rd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];vd(v|0,74736,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;Uz(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Rd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];vd(v|0,74736,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;Uz(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Rd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];vd(v|0,74736,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;Uz(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Rd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];vd(v|0,74736,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;Uz(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Rd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];vd(v|0,74736,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;Uz(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Rd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];vd(v|0,74736,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;Uz(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Rd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}Tz(t);if((Yc(v|0)|0)==0){PV(c[r>>2]|0);c[r>>2]=0;Ls(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];xr(e,74752,f)}}function Tz(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}PV(a);c[d>>2]=0;i=b;return}function Uz(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];vd(a|0,74800,f|0)|0;i=e;return}function Vz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=UV(192)|0;uW(m|0,0,192)|0;Wz(m);c[a+12>>2]=m;n=m;o=a;rw(n,c[o>>2]|0,36);if(uM(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];xr(a,74840,g)}else{g=m;ZN(g,74816,14)|0;_N(h,g);a=Ex(h)|0;h=m+184|0;c[h>>2]=a;ZN(g,74832,4)|0;Xz(n,b+8|0);_N(j,g);b=Ex(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;qw(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];$N(g,f)|0;Yz(n,-4-m+b|0);b=c[j>>2]|0;qw(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];$N(g,e)|0;Ls(3);i=d;return}}function Wz(a){a=a|0;var b=0;b=i;pA(a);i=b;return}function Xz(a,b){a=a|0;b=b|0;var c=0;c=i;_z(a,3);$z(a,75016);_z(a,0);$z(a,75024);_z(a,2);kA(a,b);lA(a,b);$z(a,75032);_z(a,0);i=c;return}function Yz(a,b){a=a|0;b=b|0;var d=0;d=i;c[18752]=Gd(b|0)|0;ZN(a,75008,4)|0;i=d;return}function Zz(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;_N(l,q);r=Ex(l)|0;Yz(b,0);_N(m,q);l=Ex(m)|0;_z(b,1);$z(b,74904);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;aA(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);bA(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{bA(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{cA(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{dA(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{$z(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}_N(n,q);u=Ex(n)|0;n=rW(0,r|0,32)|0;qw(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];$N(q,k)|0;Yz(b,u-l|0);qw(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];$N(q,j)|0;i=g;return}function _z(b,d){b=b|0;d=d|0;var e=0;e=i;a[74992]=-33;c[18750]=Gd(d|0)|0;d=b;ZN(d,74992,1)|0;ZN(d,75e3,4)|0;i=e;return}function $z(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Gd(qW(d|0)|0)|0;a[74984]=-37;g=b;ZN(g,74984,1)|0;ZN(g,f,4)|0;ZN(g,d,qW(d|0)|0)|0;i=e;return}function aA(b,d){b=b|0;d=d|0;var e=0;e=i;a[74968]=-35;c[18744]=Gd(d|0)|0;d=b;ZN(d,74968,1)|0;ZN(d,74976,4)|0;i=e;return}function bA(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[74952]=-53;jA(c);e=b;ZN(e,74952,1)|0;ZN(e,74960,8)|0;i=d;return}function cA(b,d){b=b|0;d=d|0;var e=0;e=i;a[74936]=-46;c[18736]=Gd(d|0)|0;d=b;ZN(d,74936,1)|0;ZN(d,74944,4)|0;i=e;return}function dA(b,c){b=b|0;c=c|0;var d=0;d=i;a[74928]=c?-61:-62;ZN(b,74928,1)|0;i=d;return}function eA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;Zz(e,+h[f>>3],a,f);Zz(e,+h[b+248>>3],a,f);i=d;return}function fA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;_N(j,p);o=Ex(j)|0;Yz(b,0);_N(k,p);j=Ex(k)|0;_z(b,1);$z(b,74912);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;aA(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;bA(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{bA(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{cA(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{dA(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{$z(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}_N(l,p);s=Ex(l)|0;l=rW(0,o|0,32)|0;qw(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];$N(p,g)|0;Yz(b,s-j|0);qw(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];$N(p,f)|0;i=e;return}function gA(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;kw(a);Is(3);if((a|0)!=0){hA(a);WV(a)}c[d>>2]=0;Ls(3);i=b;return}function hA(a){a=a|0;var b=0;b=i;iA(a);i=b;return}function iA(a){a=a|0;var b=0;b=i;Hx(a);i=b;return}function jA(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Gd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=74960;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[74960+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function kA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;$z(a,74904);_z(a,4);$z(a,75040);_z(a,0);$z(a,75048);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;aA(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);$z(a,75056);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{$z(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{$z(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{$z(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{$z(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=75144;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];mA(a,b,e);$z(a,75080);_z(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);nA(a,75056,75088);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;nA(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;nA(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;nA(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;nA(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function lA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;$z(a,74912);_z(a,4);$z(a,75040);_z(a,0);$z(a,75048);o=g+1+j+l+n|0;aA(a,o);$z(a,75056);if((c[f>>2]|0)>0){n=b;l=0;do{$z(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{$z(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{$z(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{$z(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=75064;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];mA(a,b,e);$z(a,75080);_z(a,o);nA(a,75056,75088);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;nA(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;nA(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;nA(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;nA(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function mA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;$z(b,75112);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}_z(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?75056:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}oA(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?75056:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}oA(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?75056:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}oA(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?75056:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}oA(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function nA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$z(a,b);_z(a,1);$z(a,75096);$z(a,c);i=d;return}function oA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;$z(a,b);_z(a,d?2:1);$z(a,75120);$z(a,c);if(!d){i=e;return}$z(a,75128);$z(a,75136);i=e;return}function pA(a){a=a|0;var b=0;b=i;xz(a);i=b;return}function qA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;DL(e,75160);zL(d,sA(a,e)|0);rA(d,b+4|0);JL(d);JL(e);DL(g,75168);zL(f,sA(a,g)|0);tA(f,b);JL(f);JL(g);DL(j,75184);zL(h,sA(a,j)|0);rA(h,b+8|0);JL(h);JL(j);DL(l,75200);zL(k,sA(a,l)|0);rA(k,b+12|0);JL(k);JL(l);DL(n,75216);zL(m,sA(a,n)|0);uA(m,b+16|0,0);JL(m);JL(n);DL(p,75232);zL(o,sA(a,p)|0);uA(o,b+20|0,0);JL(o);JL(p);DL(r,75248);zL(q,sA(a,r)|0);uA(q,b+24|0,0);JL(q);JL(r);DL(t,75256);zL(s,sA(a,t)|0);uA(s,b+28|0,0);JL(s);JL(t);DL(v,75272);zL(u,sA(a,v)|0);uA(u,b+32|0,0);JL(u);JL(v);i=c;return}function rA(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){vr(22,0,78480,d);i=d;return}else{c[b>>2]=zd(eM(a)|0)|0;i=d;return}}function sA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=BE(a,f,b)|0;l=c[k>>2]|0;cx(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}DE(j,a,b);EE(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];CE(g,e);FE(j);j=c[f>>2]|0;GE(a,j,k,HE(g)|0);k=IE(g)|0;FE(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function tA(a,b){a=a|0;b=b|0;var d=0;d=i;if((hM(a,75448)|0)==0){c[b>>2]=1;i=d;return}if((hM(a,75456)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Ec(eM(a)|0)|0;i=d;return}}function uA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((hM(a,75424)|0)==0){c[b>>2]=d}if((hM(a,75448)|0)==0){c[b>>2]=1;i=e;return}if((hM(a,75456)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Ec(eM(a)|0)|0;i=e;return}}function vA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;DL(j,75288);zL(g,sA(b,j)|0);y=d+48|0;wA(g,y);JL(g);JL(j);DL(m,75304);zL(l,sA(b,m)|0);j=d+56|0;xA(l,j,0.0);JL(l);JL(m);DL(o,75312);zL(n,sA(b,o)|0);m=d+32|0;wA(n,m);JL(n);JL(o);DL(q,75320);zL(p,sA(b,q)|0);o=d+33|0;wA(p,o);JL(p);JL(q);DL(s,75336);zL(r,sA(b,s)|0);q=d+40|0;xA(r,q,1.0);JL(r);JL(s);DL(u,75344);zL(t,sA(b,u)|0);s=d+16|0;xA(t,s,-1.7976931348623157e+308);JL(t);JL(u);DL(w,75352);zL(v,sA(b,w)|0);u=d+24|0;xA(v,u,1.7976931348623157e+308);JL(v);JL(w);DL(x,75160);w=eM(sA(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?75448:75456;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?75424:75432;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?75424:75440;c[f+20>>2]=j;c[f+24>>2]=m?75424:75432;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?75424:75440;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];tr(4,0,75360,f);JL(x);i=e;return}function wA(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(hM(b,75448)|0)==0|0;i=d;return}function xA(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((hM(a,75424)|0)==0){h[b>>3]=c;i=d;return}if((hM(a,75448)|0)==0){h[b>>3]=1.0;i=d;return}if((hM(a,75456)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+iW(eM(a)|0);i=d;return}}function yA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;DL(h,75288);zL(g,sA(b,h)|0);s=d+13|0;wA(g,s);JL(g);JL(h);DL(k,75304);zL(j,sA(b,k)|0);h=d+16|0;uA(j,h,0);JL(j);JL(k);DL(m,75312);zL(l,sA(b,m)|0);k=d+12|0;wA(l,k);JL(l);JL(m);DL(o,75344);zL(n,sA(b,o)|0);m=d+4|0;uA(n,m,-2147483648);JL(n);JL(o);DL(q,75352);zL(p,sA(b,q)|0);o=d+8|0;uA(p,o,2147483647);JL(p);JL(q);DL(r,75160);q=eM(sA(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?75448:75456;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?75424:75432;c[f+8>>2]=s;c[f+12>>2]=b?75424:75440;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;tr(4,0,75464,f);JL(r);i=e;return}function zA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;DL(h,75288);zL(g,sA(b,h)|0);o=d+5|0;wA(g,o);JL(g);JL(h);DL(k,75304);zL(j,sA(b,k)|0);h=d+6|0;wA(j,h);JL(j);JL(k);DL(m,75312);zL(l,sA(b,m)|0);k=d+4|0;wA(l,k);JL(l);JL(m);DL(n,75160);m=eM(sA(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?75448:75456;h=(a[k]|0)!=0?75448:75456;c[f>>2]=m;c[f+4>>2]=b?75424:75432;c[f+8>>2]=o;c[f+12>>2]=b?75424:75440;c[f+16>>2]=h;tr(4,0,75520,f);JL(n);i=e;return}function AA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;DL(h,75288);zL(g,sA(b,h)|0);m=d+4|0;wA(g,m);JL(g);JL(h);DL(k,75304);zL(j,sA(b,k)|0);h=d+8|0;rA(j,h);JL(j);JL(k);DL(l,75160);k=eM(sA(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?75424:75432;c[f+8>>2]=m;c[f+12>>2]=b?75424:75440;tr(4,0,75560,f);JL(l);i=e;return}function BA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;CA(qa);xL(ra);DA(sa,ta);DA(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[88544>>2]|0)==0){DL(za,c[b+80>>2]|0);EA(ya,za,75584);KL(ra,ya)|0;JL(ya);JL(za)}else{LL(ra,c[88672>>2]|0)|0}ta=hc(eM(ra)|0,75600)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=eM(ra)|0;xr(0,75608,pa)}else{Wc=0}}while(0);pa=pm(0)|0;if((pa|0)==0){Yc(Wc|0)|0;xr(0,75712,oa)}Am(pa,Vc);Bm(pa,7,49);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;uW(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((Cm(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){Yc(Wc|0)|0;oa=eM(ra)|0;ya=Km(Hm(pa)|0)|0;za=Im(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;vr(1,0,75792,na);wm(pa);xr(0,75880,ma)}else if((Xc|0)==14){Yc(Wc|0)|0;break}}else{if((Cm(pa,Vc,qW(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Km(Hm(pa)|0)|0;ta=Im(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;vd(za|0,75904,la|0)|0;za=c[va>>2]|0;ta=Km(Hm(pa)|0)|0;oa=Im(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;vr(1,0,75920,ka);wm(pa);xr(0,75880,ja)}}while(0);ja=qa;DL(Ca,76008);IA(Ba,ja,Ca);JA(Da,ja);ka=HA(Ba,Da)|0;JL(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=eM(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;vr(1,0,76016,ia)}else{DL(Ea,76008);Ba=mW(Da,eM(sA(ja,Ea)|0)|0)|0;JL(Ea);if((Ba|0)==0){break}wm(pa);DL(Fa,76008);Ba=eM(sA(ja,Fa)|0)|0;va=eM(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;vr(1,0,76064,ha);JL(Fa);xr(0,75880,ga)}}while(0);KA(qa,b,c[88756>>2]|0,c[88760>>2]|0);tr(23,1,76160,fa);fa=qa+12|0;DL(Ha,76200);zL(Ga,sA(fa,Ha)|0);ga=d;xA(Ga,ga,0.0);JL(Ga);JL(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];tr(23,0,76216,ea);DL(Ja,76232);zL(Ia,sA(fa,Ja)|0);ea=d+8|0;xA(Ia,ea,1.0);JL(Ia);JL(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];tr(23,0,76248,da);DL(La,76264);zL(Ka,sA(fa,La)|0);da=d+24|0;xA(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);JL(Ka);JL(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];tr(23,0,76280,ca);DL(Na,76296);zL(Ma,sA(fa,Na)|0);ca=d+32|0;xA(Ma,ca,1.0e-5);JL(Ma);JL(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];tr(23,0,76312,ba);DL(Pa,76328);zL(Oa,sA(fa,Pa)|0);ba=d+40|0;rA(Oa,ba);JL(Oa);JL(Pa);c[aa>>2]=c[ba>>2];tr(23,0,76336,aa);DL(Ra,76360);zL(Qa,sA(fa,Ra)|0);aa=d+44|0;rA(Qa,aa);JL(Qa);JL(Ra);c[$>>2]=c[aa>>2];tr(23,0,76376,$);DL(Ta,76400);zL(Sa,sA(fa,Ta)|0);fa=d+48|0;rA(Sa,fa);JL(Sa);JL(Ta);c[_>>2]=c[fa>>2];tr(23,0,76416,_);DL(Va,76440);zL(Ua,sA(ja,Va)|0);_=d+268|0;rA(Ua,_);JL(Ua);JL(Va);c[Z>>2]=c[_>>2];tr(23,0,76464,Z);if((c[31956>>2]|0)!=0){ee[c[8104]&255](23)}DL(eb,76488);zL(db,sA(ja,eb)|0);uA(db,Wa,0);JL(db);JL(eb);DL(gb,76520);zL(fb,sA(ja,gb)|0);uA(fb,Xa,0);JL(fb);JL(gb);DL(ib,76552);zL(hb,sA(ja,ib)|0);uA(hb,Ya,0);JL(hb);JL(ib);DL(kb,76576);zL(jb,sA(ja,kb)|0);uA(jb,_a,0);JL(jb);JL(kb);DL(mb,76608);zL(lb,sA(ja,mb)|0);uA(lb,Za,0);JL(lb);JL(mb);DL(ob,76648);zL(nb,sA(ja,ob)|0);uA(nb,ab,0);JL(nb);JL(ob);DL(qb,76680);zL(pb,sA(ja,qb)|0);uA(pb,$a,0);JL(pb);JL(qb);DL(tb,76720);zL(rb,sA(ja,tb)|0);uA(rb,cb,0);JL(rb);JL(tb);DL(vb,76752);zL(ub,sA(ja,vb)|0);uA(ub,bb,0);JL(ub);JL(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=77296;tr(4,1,77272,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=LA(lb,wb)|0;qA(ib,jb+(kb*112|0)|0);vA(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(xb,77312);jb=(hM(sA(ib,xb)|0,75448)|0)==0;JL(xb);if(!jb){break}c[N>>2]=c[hb>>2];tr(4,0,77328,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);DL(yb,c[hb>>2]|0);c[(MA(sa,yb)|0)>>2]=kb;JL(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[M>>2]=77360;tr(4,1,77272,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=LA(lb,zb)|0;qA(fb,gb+(jb*112|0)|0);vA(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Ab,77312);gb=(hM(sA(fb,Ab)|0,75448)|0)==0;JL(Ab);if(!gb){break}c[L>>2]=c[eb>>2];tr(4,0,77328,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);DL(Bb,c[eb>>2]|0);c[(MA(sa,Bb)|0)>>2]=jb;JL(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[K>>2]=77384;tr(4,1,77272,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=LA(mb,Cb)|0;qA(gb,hb+(fb*112|0)|0);vA(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Db,77312);hb=(hM(sA(gb,Db)|0,75448)|0)==0;JL(Db);if(!hb){break}c[J>>2]=c[db>>2];tr(4,0,77328,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);DL(Eb,c[db>>2]|0);c[(MA(sa,Eb)|0)>>2]=fb;JL(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[I>>2]=77400;tr(4,1,77272,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=LA(ub,Fb)|0;qA(mb,kb+(ib*60|0)|0);yA(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Gb,77312);kb=(hM(sA(mb,Gb)|0,75448)|0)==0;JL(Gb);if(!kb){break}c[H>>2]=c[gb>>2];tr(4,0,77328,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);DL(Hb,c[gb>>2]|0);c[(MA(sa,Hb)|0)>>2]=ib;JL(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[G>>2]=77424;tr(4,1,77272,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=LA(ib,Ib)|0;qA(mb,ub+(lb*48|0)|0);zA(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Jb,77312);ub=(hM(sA(mb,Jb)|0,75448)|0)==0;JL(Jb);if(!ub){break}c[F>>2]=c[fb>>2];tr(4,0,77328,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);DL(Kb,c[fb>>2]|0);c[(MA(sa,Kb)|0)>>2]=lb;JL(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[E>>2]=77448;tr(4,1,77272,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=LA(lb,Lb)|0;qA(mb,ib+(rb*52|0)|0);AA(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Mb,77312);ib=(hM(sA(mb,Mb)|0,75448)|0)==0;JL(Mb);if(!ib){break}c[D>>2]=c[gb>>2];tr(4,0,77328,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);DL(Nb,c[gb>>2]|0);c[(MA(sa,Nb)|0)>>2]=rb;JL(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[C>>2]=77472;tr(4,1,77272,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=LA(rb,Ob)|0;qA(mb,lb+(pb*112|0)|0);vA(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Pb,77312);lb=(hM(sA(mb,Pb)|0,75448)|0)==0;JL(Pb);if(!lb){break}c[B>>2]=c[fb>>2];tr(4,0,77328,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);DL(Qb,c[fb>>2]|0);c[(MA(ua,Qb)|0)>>2]=pb;JL(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[A>>2]=77488;tr(4,1,77272,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=LA(pb,Rb)|0;qA(mb,rb+(nb*60|0)|0);yA(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Sb,77312);rb=(hM(sA(mb,Sb)|0,75448)|0)==0;JL(Sb);if(!rb){break}c[z>>2]=c[gb>>2];tr(4,0,77328,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);DL(Tb,c[gb>>2]|0);c[(MA(ua,Tb)|0)>>2]=nb;JL(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[y>>2]=77512;tr(4,1,77272,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=LA(nb,Ub)|0;qA(mb,pb+(ja*48|0)|0);zA(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Vb,77312);pb=(hM(sA(mb,Vb)|0,75448)|0)==0;JL(Vb);if(!pb){break}c[x>>2]=c[fb>>2];tr(4,0,77328,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);DL(Wb,c[fb>>2]|0);c[(MA(ua,Wb)|0)>>2]=ja;JL(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}c[w>>2]=77536;tr(4,1,77272,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=LA(ja,Xb)|0;qA(mb,nb+(tb*52|0)|0);AA(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[88540>>2]|0)!=0){break}DL(Yb,77312);nb=(hM(sA(mb,Yb)|0,75448)|0)==0;JL(Yb);if(!nb){break}c[v>>2]=c[gb>>2];tr(4,0,77328,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);DL(Zb,c[gb>>2]|0);c[(MA(ua,Zb)|0)>>2]=tb;JL(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}tr(4,1,77560,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=LA(tb,_b)|0;qA(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);xL($b);c[bc>>2]=ja;mb=LA(tb,bc)|0;DL(cc,77600);zL(ac,sA(mb,cc)|0);NA(ac,$b);JL(ac);JL(cc);mb=(hM($b,77608)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;tr(4,0,77624,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=LA(tb,ec)|0;DL(fc,77664);zL(dc,sA(nb,fc)|0);NA(dc,$b);JL(dc);JL(fc);OA(wa,sa,$b);OA(xa,ua,$b);QA(gc,sa);do{if(PA(wa,gc)|0){nb=c[(RA(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{QA(ic,ua);if(PA(xa,ic)|0){fb=c[(RA(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((hM($b,77680)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);JL($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}sM(kc,77688,$b);EA(jc,kc,77712);JL(kc);c[s>>2]=eM(jc)|0;xr(0,77728,s)}}while(0);if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}tr(4,1,77736,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=LA(ja,lc)|0;qA(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);xL(mc);c[oc>>2]=tb;gb=LA(ja,oc)|0;DL(pc,77600);zL(nc,sA(gb,pc)|0);NA(nc,mc);JL(nc);JL(pc);gb=(hM(mc,77608)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;tr(4,0,77624,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=LA(ja,rc)|0;DL(sc,77664);zL(qc,sA(fb,sc)|0);NA(qc,mc);JL(qc);JL(sc);OA(wa,sa,mc);OA(xa,ua,mc);QA(tc,sa);if(PA(wa,tc)|0){fb=c[(RA(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{QA(uc,ua);if(!(PA(xa,uc)|0)){break}nb=c[(RA(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}JL(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}sM(wc,77776,mc);EA(vc,wc,77712);JL(wc);c[o>>2]=eM(vc)|0;xr(0,77728,o)}}while(0);if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}tr(4,1,77800,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=LA(tb,xc)|0;qA(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);xL(yc);c[Ac>>2]=ja;fb=LA(tb,Ac)|0;DL(Bc,77600);zL(zc,sA(fb,Bc)|0);NA(zc,yc);JL(zc);JL(Bc);fb=(hM(yc,77608)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;tr(4,0,77624,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=LA(tb,Dc)|0;DL(Ec,77664);zL(Cc,sA(gb,Ec)|0);NA(Cc,yc);JL(Cc);JL(Ec);OA(wa,sa,yc);OA(xa,ua,yc);QA(Fc,sa);if(PA(wa,Fc)|0){gb=c[(RA(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{QA(Gc,ua);if(!(PA(xa,Gc)|0)){break}nb=c[(RA(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}JL(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}sM(Ic,77840,yc);EA(Hc,Ic,77712);JL(Ic);c[l>>2]=eM(Hc)|0;xr(0,77728,l)}}while(0);if((c[31880>>2]|0)!=0){ee[c[8104]&255](4)}tr(4,1,77864,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=LA(ja,Jc)|0;qA(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);xL(Kc);c[Mc>>2]=tb;gb=LA(ja,Mc)|0;DL(Nc,77600);zL(Lc,sA(gb,Nc)|0);NA(Lc,Kc);JL(Lc);JL(Nc);gb=(hM(Kc,77608)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;tr(4,0,77624,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=LA(ja,Pc)|0;DL(Qc,77664);zL(Oc,sA(fb,Qc)|0);NA(Oc,Kc);JL(Oc);JL(Qc);OA(wa,sa,Kc);OA(xa,ua,Kc);QA(Rc,sa);if(PA(wa,Rc)|0){fb=c[(RA(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{QA(Sc,ua);if(!(PA(xa,Sc)|0)){break}nb=c[(RA(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}JL(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}sM(Uc,77904,Kc);EA(Tc,Uc,77712);JL(Uc);c[f>>2]=eM(Tc)|0;xr(0,77728,f)}}while(0);if((c[31880>>2]|0)==0){wm(pa);SA(ua);SA(sa);JL(ra);TA(qa);i=e;return}ee[c[8104]&255](4);wm(pa);SA(ua);SA(sa);JL(ra);TA(qa);i=e;return}}while(0);if((c[31952>>2]|c[7964]|0)==0){wm(pa);Zc=td(0)|0;Bd(-1)}vr(22,1,76792,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;vr(22,0,76840,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;vr(22,0,76888,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;vr(22,0,76936,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;vr(22,0,76984,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;vr(22,0,77032,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;vr(22,0,77080,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;vr(22,0,77128,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;vr(22,0,77176,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;vr(22,0,77224,P);ee[c[8104]&255](22);wm(pa);Zc=td(0)|0;Bd(-1)}function CA(a){a=a|0;var b=0;b=i;CH(a);i=b;return}function DA(a,b){a=a|0;b=b|0;b=i;hD(a,0);i=b;return}function EA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;yL(a,d);e=HL(b)|0;f=rB(c)|0;iM(a,IL(b)|0,e,f+e|0);aM(a,c,f)|0;i=d;return}



function Jj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b>>3];i=i;return}function Kj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+8>>3];i=i;return}function Lj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+16>>3];i=i;return}function Mj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+24>>3];i=i;return}function Nj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+176>>3]=+h[b+32>>3];i=i;return}function Oj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+40>>3];i=i;return}function Pj(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;e=c[b+416>>2]|0;f=+h[e+144>>3]/.01604246+(+h[e+152>>3]/.01604246+(+h[e+160>>3]/.01604246+(+h[e+168>>3]/.01604246+(+h[e+176>>3]/.01604246+ +h[e+184>>3]/.01604246))));if(f!=0.0){g=b+4|0;j=f;k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+584|0;t=s;h[t>>3]=k;i=d;return}else{e=b+4|0;g=e;j=+zr(c[b+536>>2]|0,f,5232,5224,+h[c[c[e>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=1.0/j;l=c[g>>2]|0;m=c[l>>2]|0;n=m;o=n+8|0;p=o;q=c[p>>2]|0;r=q;s=r+584|0;t=s;h[t>>3]=k;i=d;return}}function Qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0;b=i;i=i+56|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+144>>3];n=+h[l+160>>3];o=+h[l+168>>3];p=+h[l+176>>3];q=+h[l+184>>3];r=e;h[k>>3]=+h[l+152>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+8|0;h[k>>3]=n;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+16|0;h[k>>3]=o;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+24|0;h[k>>3]=p;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=e+32|0;h[k>>3]=q;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];ns(f,6,m,e);e=c[a+536>>2]|0;m=+h[(c[j>>2]|0)+296>>3];j=d;r=f;c[j+0>>2]=c[r+0>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];Mg(g,e,m,d,1,1,0.0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+576>>3]=+h[g>>3];i=b;return}function Rj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+568>>3]=(+h[b+144>>3]+(+h[b+152>>3]+(+h[b+160>>3]+(+h[b+168>>3]+(+h[b+176>>3]+ +h[b+184>>3])))))*518.2791167938085;i=i;return}function Sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+576>>3]- +h[b+568>>3]*+h[(c[a+416>>2]|0)+296>>3];i=i;return}function Tj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=c[b+416>>2]|0;k=+h[g+568>>3]*+h[j+296>>3];l=+h[j+280>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+544|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+544|0;q=p;h[q>>3]=n;i=d;return}r=l/+zr(c[b+536>>2]|0,k,5456,5448,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+544|0;q=p;h[q>>3]=n;i=d;return}function Uj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5496]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+320>>3],1.0e-10)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(5512,Tr(+h[(c[g>>2]|0)+320>>3],5504)|0)|0;g=c[20228]|0;j=e;k=5736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[5496]=1;i=d;return}function Vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5760]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+312>>3],1.0e-10)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(5768,Tr(+h[(c[g>>2]|0)+312>>3],5504)|0)|0;g=c[20228]|0;j=e;k=5912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[5760]=1;i=d;return}function Wj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5936]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+184>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(5944,Tr(+h[(c[g>>2]|0)+184>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[5936]=1;i=d;return}function Xj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6080]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(6088,Tr(+h[(c[g>>2]|0)+176>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[6080]=1;i=d;return}function Yj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6224]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+168>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(6232,Tr(+h[(c[g>>2]|0)+168>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[6224]=1;i=d;return}function Zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6368]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+160>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(6376,Tr(+h[(c[g>>2]|0)+160>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[6368]=1;i=d;return}function _j(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6512]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+152>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+152>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(6520,Tr(+h[(c[g>>2]|0)+152>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[6512]=1;i=d;return}function $j(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6656]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+144>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+144>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(6664,Tr(+h[(c[g>>2]|0)+144>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[6656]=1;i=d;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6824]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+304>>3],-1.0e10)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+304>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Xr(6832,Tr(+h[(c[g>>2]|0)+304>>3],5504)|0)|0;g=c[20228]|0;j=e;k=6976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[6824]=1;i=d;return}function bk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7e3]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+296>>3],1.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+296>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Xr(7008,Tr(+h[(c[g>>2]|0)+296>>3],5504)|0)|0;g=c[20228]|0;j=e;k=7136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7e3]=1;i=d;return}function ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7160]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+288>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(7168,Tr(+h[(c[g>>2]|0)+288>>3],5504)|0)|0;g=c[20228]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7160]=1;i=d;return}function dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7320]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(7328,Tr(+h[(c[g>>2]|0)+280>>3],5504)|0)|0;g=c[20228]|0;j=e;k=7464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7320]=1;i=d;return}function ek(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7488]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+136>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(7496,Tr(+h[(c[g>>2]|0)+136>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7488]=1;i=d;return}function fk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7656]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+128>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+128>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(7664,Tr(+h[(c[g>>2]|0)+128>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7656]=1;i=d;return}function gk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7824]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+120>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+120>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(7832,Tr(+h[(c[g>>2]|0)+120>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7824]=1;i=d;return}function hk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7992]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(8e3,Tr(+h[(c[g>>2]|0)+112>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[7992]=1;i=d;return}function ik(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8160]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+104>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(8168,Tr(+h[(c[g>>2]|0)+104>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[8160]=1;i=d;return}function jk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8328]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+96>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+96>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(8336,Tr(+h[(c[g>>2]|0)+96>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[8328]=1;i=d;return}function kk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8520]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+272>>3],-1.0e10)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+272>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Xr(8528,Tr(+h[(c[g>>2]|0)+272>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[8520]=1;i=d;return}function lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8728]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+264>>3],1.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+264>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Xr(8736,Tr(+h[(c[g>>2]|0)+264>>3],5504)|0)|0;g=c[20228]|0;j=e;k=8896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[8728]=1;i=d;return}function mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8920]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+256>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+256>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(8928,Tr(+h[(c[g>>2]|0)+256>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[8920]=1;i=d;return}function nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9112]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+88>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+88>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(9120,Tr(+h[(c[g>>2]|0)+88>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9112]=1;i=d;return}function ok(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9248]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+80>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+80>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(9256,Tr(+h[(c[g>>2]|0)+80>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9248]=1;i=d;return}function pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9384]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+72>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(9392,Tr(+h[(c[g>>2]|0)+72>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9384]=1;i=d;return}function qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9520]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+64>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+64>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(9528,Tr(+h[(c[g>>2]|0)+64>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9520]=1;i=d;return}function rk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9656]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(9664,Tr(+h[(c[g>>2]|0)+56>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9656]=1;i=d;return}function sk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9792]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+48>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+48>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(9800,Tr(+h[(c[g>>2]|0)+48>>3],5504)|0)|0;g=c[20228]|0;j=e;k=9928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9792]=1;i=d;return}function tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9952]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+248>>3],-1.0e10)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+248>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Xr(9960,Tr(+h[(c[g>>2]|0)+248>>3],5504)|0)|0;g=c[20228]|0;j=e;k=10096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[9952]=1;i=d;return}function uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10120]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+240>>3],1.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Xr(10128,Tr(+h[(c[g>>2]|0)+240>>3],5504)|0)|0;g=c[20228]|0;j=e;k=10248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10120]=1;i=d;return}function vk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10272]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(10280,Tr(+h[(c[g>>2]|0)+232>>3],5504)|0)|0;g=c[20228]|0;j=e;k=10400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10272]=1;i=d;return}function wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10424]&1){i=d;return}g=b+416|0;b=Au(+h[(c[g>>2]|0)+224>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[g>>2]|0)+224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(10432,Tr(+h[(c[g>>2]|0)+224>>3],5504)|0)|0;g=c[20228]|0;j=e;k=10552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10424]=1;i=d;return}function xk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10576]&1){i=d;return}g=b+416|0;if(!((Au(+h[(c[g>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(10584,Tr(+h[(c[g>>2]|0)+200>>3],5504)|0)|0;g=c[20228]|0;j=e;k=10656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10576]=1;i=d;return}function yk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10680]&1){i=d;return}g=b+416|0;if(!((Au(+h[(c[g>>2]|0)+192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(10688,Tr(+h[(c[g>>2]|0)+192>>3],5504)|0)|0;g=c[20228]|0;j=e;k=10760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10680]=1;i=d;return}function zk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10784]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],.001)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],.25)|0)<<24>>24==0)){i=d;return}b=Xr(10792,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10784]=1;i=d;return}function Ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10952]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Xr(10960,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[10952]=1;i=d;return}function Bk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11120]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],.001)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],.25)|0)<<24>>24==0)){i=d;return}b=Xr(11128,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[11120]=1;i=d;return}function Ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11280]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Xr(11288,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[11280]=1;i=d;return}function Dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11440]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],-1.0e8)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(11448,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[11440]=1;i=d;return}function Ek(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11616]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],-1.0e8)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(11624,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[11616]=1;i=d;return}function Fk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11784]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(11792,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],5504)|0)|0;g=c[20228]|0;j=e;k=11920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[11784]=1;i=d;return}function Gk(a){a=a|0;var b=0;b=i;ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Lj(a);Mj(a);Nj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);fk(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);mk(a);nk(a);ok(a);pk(a);qk(a);rk(a);sk(a);tk(a);uk(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);i=b;return 0}function Hk(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Ik(b);i=c;return 0}function Ik(a){a=a|0;var b=0;b=i;hf(a);jf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);Gf(a);Hf(a);If(a);Kf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);dg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);i=b;return}function Jk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11944]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(11960,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],11952)|0)|0;g=c[20228]|0;j=e;k=12168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[11944]=1;i=d;return}function Kk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12192]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],-1.0e8)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(12200,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[12192]=1;i=d;return}function Lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12344]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(12352,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+320>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[12344]=1;i=d;return}function Mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12504]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(12512,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[12504]=1;i=d;return}function Nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12664]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(12672,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[12664]=1;i=d;return}function Ok(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12824]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(12832,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[12824]=1;i=d;return}function Pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12984]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(12992,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[12984]=1;i=d;return}function Qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13144]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(13152,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+360>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[13144]=1;i=d;return}function Rk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13304]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(13312,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],11952)|0)|0;g=c[20228]|0;j=e;k=13440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[13304]=1;i=d;return}function Sk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13464]&1){i=d;return}g=b+4|0;b=Au(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(13472,Tr(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[13464]=1;i=d;return}function Tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13600]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(13608,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[13600]=1;i=d;return}function Uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13736]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(13744,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[13736]=1;i=d;return}function Vk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13872]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(13880,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[13872]=1;i=d;return}function Wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14008]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(14016,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14008]=1;i=d;return}function Xk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14144]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(14152,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14144]=1;i=d;return}function Yk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14304]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],-1.0e10)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Xr(14312,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14304]=1;i=d;return}function Zk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14472]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(14480,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],11952)|0)|0;g=c[20228]|0;j=e;k=16120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14472]=1;i=d;return}function _k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14600]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=Xr(14608,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14600]=1;i=d;return}function $k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14752]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],-1.0e8)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(14760,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],11952)|0)|0;g=c[20228]|0;j=e;k=14896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14752]=1;i=d;return}function al(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14920]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=Xr(14928,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[14920]=1;i=d;return}function bl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15080]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],.001)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],.25)|0)<<24>>24==0)){i=d;return}b=Xr(15088,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15080]=1;i=d;return}function cl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15240]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15248,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15240]=1;i=d;return}function dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15352]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15360,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15352]=1;i=d;return}function el(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15448]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15456,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15448]=1;i=d;return}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15544]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15552,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15544]=1;i=d;return}function gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15640]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15648,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15640]=1;i=d;return}function hl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15736]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15744,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15736]=1;i=d;return}function il(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15832]&1){i=d;return}g=b+4|0;if(!((Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Xr(15840,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],11952)|0)|0;g=c[20228]|0;j=e;k=15928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15832]=1;i=d;return}function jl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15952]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(15960,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],11952)|0)|0;g=c[20228]|0;j=e;k=16120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[15952]=1;i=d;return}function kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16144]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],-1.0e8)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(16152,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[16144]=1;i=d;return}function ll(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16328]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(16336,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[16328]=1;i=d;return}function ml(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16520]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(16528,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[16520]=1;i=d;return}function nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16712]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(16720,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[16712]=1;i=d;return}function ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16904]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(16912,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[16904]=1;i=d;return}function pl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17096]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(17104,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[17096]=1;i=d;return}function ql(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17288]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(17296,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[17288]=1;i=d;return}function rl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17480]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],-1.0e10)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=Xr(17488,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],11952)|0)|0;g=c[20228]|0;j=e;k=17624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[17480]=1;i=d;return}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17648]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(17656,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[17648]=1;i=d;return}function tl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17784]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(17792,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[17784]=1;i=d;return}function ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17920]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(17928,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[17920]=1;i=d;return}function vl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18056]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(18064,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[18056]=1;i=d;return}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18192]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(18200,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[18192]=1;i=d;return}function xl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18328]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0)|0)<<24>>24==0)){i=d;return}b=Xr(18336,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[18328]=1;i=d;return}function yl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18488]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],-1.0e8)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=Xr(18496,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],11952)|0)|0;g=c[20228]|0;j=e;k=18656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[18488]=1;i=d;return}function zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18680]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(18688,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[18680]=1;i=d;return}function Al(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18856]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(18864,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[18856]=1;i=d;return}function Bl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19032]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(19040,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[19032]=1;i=d;return}function Cl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19208]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(19216,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[19208]=1;i=d;return}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19384]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(19392,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[19384]=1;i=d;return}function El(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19560]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(19568,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[19560]=1;i=d;return}function Fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19760]&1){i=d;return}g=b+4|0;b=Au(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],-1.0e5)|0;if(!(b<<24>>24==0|(zu(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=Xr(19768,Tr(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],11952)|0)|0;g=c[20228]|0;j=e;k=19904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[g&15](e,b,f);a[19760]=1;i=d;return}function Gl(a){a=a|0;var b=0;b=i;Jk(a);Kk(a);Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);_k(a);$k(a);al(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);il(a);jl(a);kl(a);ll(a);ml(a);nl(a);ol(a);pl(a);ql(a);rl(a);sl(a);tl(a);ul(a);vl(a);wl(a);xl(a);yl(a);zl(a);Al(a);Bl(a);Cl(a);Dl(a);El(a);Fl(a);i=b;return 0}function Hl(a){a=a|0;i=i;return 1}function Il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=8;c[a+48>>2]=8;c[a+72>>2]=QV(8,8)|0;a=QV(8,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=QV(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=OV(32)|0;c[(c[d>>2]|0)+52>>2]=a;a=OV(256)|0;c[(c[d>>2]|0)+56>>2]=a;a=OV(32)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=8;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+28>>2]=8;c[e>>2]=8;c[e+4>>2]=8;c[e+8>>2]=8;c[e+12>>2]=8;c[e+16>>2]=8;c[e+20>>2]=8;c[e+24>>2]=8;f=8;g=8;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=8){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}Jl(e,c[a+56>>2]|0);a=c[d>>2]|0;Kl(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ll(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ml(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Nl(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ol(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Pl(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ql(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+28>>2]=1;c[a>>2]=2;c[a+4>>2]=3;c[a+8>>2]=4;c[a+12>>2]=5;c[a+16>>2]=6;c[a+20>>2]=7;c[a+24>>2]=8;i=b;return 0}function Jl(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Kl(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -8<<2)>>2]=6;c[b+((c[a>>2]|0)+ -7<<2)>>2]=5;c[b+((c[a>>2]|0)+ -6<<2)>>2]=4;c[b+((c[a>>2]|0)+ -5<<2)>>2]=3;c[b+((c[a>>2]|0)+ -4<<2)>>2]=2;c[b+((c[a>>2]|0)+ -3<<2)>>2]=1;c[b+((c[a>>2]|0)+ -2<<2)>>2]=0;c[b+((c[a>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Ll(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Ml(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Nl(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Ol(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Pl(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Ql(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=6;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function Rl(a){a=a|0;i=i;return 1}function Sl(a){a=a|0;i=i;return 1}function Tl(a){a=a|0;i=i;return 1}function Ul(a){a=a|0;i=i;return 0}function Vl(a){a=a|0;i=i;return 0}function Wl(a){a=a|0;i=i;return 0}function Xl(a){a=a|0;i=i;return 0}function Yl(a){a=a|0;i=i;return 0}function Zl(a,b){a=a|0;b=b|0;i=i;return-1}function _l(a,b){a=a|0;b=b|0;i=i;return-1}function $l(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function am(){i=i;return 19928}function bm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function cm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function dm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function em(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(20888,n|0)|0;i=m;return 0}function fm(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=ut(a,20896)|0;z=ut(b,20896)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((ut(a,20904)|0)!=0){C=5;break}if((ut(a,20912)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((ut(b,20904)|0)!=0){break}if((ut(b,20912)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){uW(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}uW(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}uW(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(20920,r|0)|0;i=q;return 0}function gm(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(ut(a,20928)|0)!=0;v=c[(u?f:g)>>2]|0;w=ut(e,20936)|0;x=ut(b,20944)|0;c[p>>2]=0;do{if(u){y=4}else{if((ut(a,20952)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((ut(b,20928)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((ut(d,20936)|0)==0){if((ut(d,20960)|0)!=0){break}if((ut(d,20968)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((ut(e,20944)|0)==0){if((ut(e,20936)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){uW(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(ut(d,20936)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(20976,p|0)|0;i=o;return 0}function hm(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}jm(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}km(20992,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(20984,l|0)|0;i=k;return 0}function im(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+bt(21016);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(bm(l,z,21024)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){dm(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;cm(l,n,d+(x-o+v<<3)|0,21024)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;em(l,m,21032,d+(B+y<<3)|0,21024,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(21008,k|0)|0;i=j;return 0}function jm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=21064;u=mm(21048,21040,21056,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;im(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;lm(k,d,e,m,l,f,21048)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;lm(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,21048)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;gm(21072,21080,21088,21104,n,k,21112,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=21088;fm(H,H,k,l,n,21120,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,21112,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);im(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(21040,j|0)|0;i=h;return 0}function km(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(ut(a,21128)|0)!=0;do{if(n){o=5}else{if((ut(a,21136)|0)!=0){o=5;break}if((ut(a,21144)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=21160;lm(d,h,j,q,b,g,q)|0;gm(21168,21176,21184,21200,b,d,21208,e,f,h,j)|0;gm(21168,21216,21184,21224,b,d,21208,e,f,h,j)|0;i=l;return 0}else{gm(21168,21216,21240,21224,b,d,21208,e,f,h,j)|0;gm(21168,21176,21240,21200,b,d,21208,e,f,h,j)|0;lm(d,h,j,21160,b,g,21256)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(21152,m|0)|0;i=l;return 0}



function pn(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ge[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 1:case 2:{B=y;if((c[y+368>>2]|0)!=0){C=c[B+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{C=he[c[B+12>>2]&127](48)|0;if((C|0)==0){D=72;break a}c[C+36>>2]=he[c[y+12>>2]&127](32)|0;if((c[C+36>>2]|0)==0){D=74;break a}c[C+40>>2]=(c[C+36>>2]|0)+32}c[C+44>>2]=0;c[C>>2]=c[y+364>>2];c[y+364>>2]=C;c[C+16>>2]=0;c[C+20>>2]=0;c[C+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[C+8>>2]=we[c[e+32>>2]&63](e,c[C+4>>2]|0)|0;B=y+312|0;c[B>>2]=(c[B>>2]|0)+1;B=(c[C+4>>2]|0)+(c[C+8>>2]|0)|0;c[r>>2]=c[C+4>>2];c[q>>2]=c[C+36>>2];while(1){be[c[e+60>>2]&31](e,r,B,q,(c[C+40>>2]|0)+ -1|0);E=(c[q>>2]|0)-(c[C+36>>2]|0)|0;if((c[r>>2]|0)==(B|0)){break}F=(c[C+40>>2]|0)-(c[C+36>>2]|0)<<1;G=we[c[y+16>>2]&63](c[C+36>>2]|0,F)|0;if((G|0)==0){D=80;break a}c[C+36>>2]=G;c[C+40>>2]=G+F;c[q>>2]=G+E}c[C+24>>2]=E;c[C+12>>2]=c[C+36>>2];a[c[q>>2]|0]=0;H=sn(y,e,c[m>>2]|0,C+12|0,C+44|0)|0;if((H|0)!=0){D=82;break a}B=y;do{if((c[y+52>>2]|0)!=0){De[c[B+52>>2]&15](c[y+4>>2]|0,c[C+12>>2]|0,c[y+392>>2]|0)}else{if((c[B+80>>2]|0)==0){break}Jm(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);sm(y+416|0);break};case-4:{D=17;break a;break};case-3:{D=6;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){D=109;break a}B=c[y+364>>2]|0;c[y+364>>2]=c[B>>2];c[B>>2]=c[y+368>>2];c[y+368>>2]=B;I=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;G=we[c[e+32>>2]&63](e,I)|0;if((G|0)!=(c[B+8>>2]|0)){D=112;break a}if((lW(c[B+4>>2]|0,I,G)|0)!=0){D=112;break a}G=y+312|0;c[G>>2]=(c[G>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){G=c[B+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((G|0)==0){break}F=(c[B+12>>2]|0)+(c[B+28>>2]|0)|0;while(1){if((a[G]|0)==0){break}J=G;G=J+1|0;K=F;F=K+1|0;a[K]=a[J]|0}J=c[B+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((J|0)==0){break}K=F;F=K+1|0;a[K]=a[y+472|0]|0;while(1){if((a[J]|0)==0){break c}K=J;J=K+1|0;L=F;F=L+1|0;a[L]=a[K]|0}}}while(0);a[F]=0}}while(0);fe[c[y+56>>2]&127](c[y+4>>2]|0,c[B+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Jm(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[B+44>>2]|0)==0){break}G=c[B+44>>2]|0;if((c[y+104>>2]|0)!=0){fe[c[y+104>>2]&127](c[y+4>>2]|0,c[c[G>>2]>>2]|0)}c[B+44>>2]=c[(c[B+44>>2]|0)+4>>2];c[G+4>>2]=c[y+376>>2];c[y+376>>2]=G;c[(c[G>>2]|0)+4>>2]=c[G+8>>2]}if((c[y+312>>2]|0)==0){D=133;break a}break};case 10:{B=we[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((B|0)<0){D=135;break a}G=y;if((c[y+60>>2]|0)!=0){J=c[G+60>>2]|0;K=c[y+4>>2]|0;L=Gn(B,u)|0;De[J&15](K,u,L);break b}if((c[G+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{G=y;do{if((c[y+72>>2]|0)!=0){ee[c[G+72>>2]&255](c[y+4>>2]|0)}else{if((c[G+80>>2]|0)==0){break}Jm(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);M=un(y,e,n,g,h,j)|0;if((M|0)!=0){D=150;break a}if((c[n>>2]|0)==0){D=152;break a}break};case-5:{D=153;break a;break};case 6:{G=c[y+60>>2]|0;if((G|0)==0){if((c[y+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){De[G&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];be[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];De[G&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 12:{D=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;De[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break};case 9:{a[p]=ke[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){G=y;if((c[y+60>>2]|0)!=0){De[c[G+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[G+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break b}G=Xm(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((G|0)==0){D=37;break a}L=Om(y,k,G,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){D=40;break}if((L|0)!=0){break}K=y;if((c[y+120>>2]|0)!=0){De[c[K+120>>2]&15](c[y+4>>2]|0,G,0);break b}if((c[K+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{D=40}}while(0);if((D|0)==40){D=0;if((L|0)==0){D=41;break a}if((a[L+34|0]|0)==0){D=43;break a}}if((a[L+32|0]|0)!=0){D=50;break a}if((c[L+28>>2]|0)!=0){D=52;break a}G=y;if((c[L+4>>2]|0)!=0){K=y;if((a[G+308|0]|0)!=0){N=jn(K,L,0)|0;if((N|0)!=0){D=60;break a}else{break b}}J=y;if((c[K+120>>2]|0)!=0){De[c[J+120>>2]&15](c[y+4>>2]|0,c[L>>2]|0,0);break b}if((c[J+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[G+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[L+32|0]=1;G=rn(y)|0;a[L+32|0]=0;if((G|0)==0){D=63;break a}if((xe[c[y+112>>2]&63](c[y+116>>2]|0,G,c[L+20>>2]|0,c[L+16>>2]|0,c[L+24>>2]|0)|0)==0){D=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case-1:{D=25;break a;break};case 0:{D=24;break a;break};case 11:{if((ln(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=174;break a}break};case 13:{if((mn(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=176;break a}break};case-2:{D=28;break a;break};case 3:case 4:{G=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;J=1;c[t>>2]=Xm(y+416|0,e,G,G+(we[c[e+32>>2]&63](e,G)|0)|0)|0;if((c[t>>2]|0)==0){D=89;break a}c[y+432>>2]=c[y+428>>2];O=sn(y,e,c[m>>2]|0,t,s)|0;if((O|0)!=0){D=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){De[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);J=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}fe[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);J=0}do{if((J&255|0)!=0){if((c[y+80>>2]|0)==0){break}Jm(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);sm(y+416|0);while(1){if((c[s>>2]|0)==0){break}J=c[s>>2]|0;if((c[y+104>>2]|0)!=0){fe[c[y+104>>2]&127](c[y+4>>2]|0,c[c[J>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[J+4>>2]=c[y+376>>2];c[y+376>>2]=J;c[(c[J>>2]|0)+4>>2]=c[J+8>>2]}if((c[y+312>>2]|0)==0){D=107;break a}break};default:{if((c[y+80>>2]|0)==0){break b}Jm(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){D=180;break}else if((f|0)==2){D=181;break}}if((D|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;De[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Jm(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((D|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((D|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((D|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((D|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((D|0)==37){P=1;Q=P;i=l;return Q|0}else if((D|0)==41){P=11;Q=P;i=l;return Q|0}else if((D|0)==43){P=24;Q=P;i=l;return Q|0}else if((D|0)==50){P=12;Q=P;i=l;return Q|0}else if((D|0)==52){P=15;Q=P;i=l;return Q|0}else if((D|0)==60){P=N;Q=P;i=l;return Q|0}else if((D|0)==63){P=1;Q=P;i=l;return Q|0}else if((D|0)==65){P=21;Q=P;i=l;return Q|0}else if((D|0)==72){P=1;Q=P;i=l;return Q|0}else if((D|0)==74){ee[c[y+20>>2]&255](C);P=1;Q=P;i=l;return Q|0}else if((D|0)==80){P=1;Q=P;i=l;return Q|0}else if((D|0)==82){P=H;Q=P;i=l;return Q|0}else if((D|0)==89){P=1;Q=P;i=l;return Q|0}else if((D|0)==91){P=O;Q=P;i=l;return Q|0}else if((D|0)==107){P=tn(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((D|0)==109){P=13;Q=P;i=l;return Q|0}else if((D|0)==112){c[z>>2]=I;P=7;Q=P;i=l;return Q|0}else if((D|0)==133){P=tn(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((D|0)==135){P=14;Q=P;i=l;return Q|0}else if((D|0)==140){P=17;Q=P;i=l;return Q|0}else if((D|0)==150){P=M;Q=P;i=l;return Q|0}else if((D|0)==152){c[y+280>>2]=42;P=M;Q=P;i=l;return Q|0}else if((D|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){De[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];be[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);De[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Jm(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((D|0)==174){P=1;Q=P;i=l;return Q|0}else if((D|0)==176){P=1;Q=P;i=l;return Q|0}else if((D|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((D|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function qn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ge[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Vm(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=pn(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Ge[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Vm(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=pn(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function rn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Lm(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Mm(e,b+60|0);a:while(1){k=Nm(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Lm(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Lm(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Mm(e,b);b:while(1){b=Nm(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Lm(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function sn(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Om(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=um(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Om(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((yn(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ge[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=we[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ge[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=$m(k,b,v,w+(we[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Xm(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=dn(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Sm(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Sm(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=we[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Om(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Lm(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Lm(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Lm(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=he[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;sW(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}ee[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;sW(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;sW(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function tn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ge[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 13:{if((mn(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-15:{k=3;break a;break};case 0:{k=14;break a;break};case-4:{k=7;break a;break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}Jm(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 11:{if((ln(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Jm(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function un(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ge[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;De[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Jm(o,b,c[k>>2]|0,c[l>>2]|0);break};case-4:case-1:{r=28;break a;break};case 40:{r=6;break a;break};case-2:{r=25;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Jm(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){De[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];be[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];De[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){ee[c[n+76>>2]&255](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Jm(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function vn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=un(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=wn(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Zm(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function wn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=pn(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((xn(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function xn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=we[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}sW(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function yn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Lm(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Lm(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Om(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function zn(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ge[c[b+16>>2]&63](b,f,g,l)|0){case-1:{o=7;break a;break};case 9:{p=(ke[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(p<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Lm(h)|0)<<24>>24!=0)){o=42;break a}}q=h+12|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;break b}p=Xm(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((p|0)==0){o=44;break a}r=Om(n,j,p,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){s=(c[n+300>>2]|0)!=0}else{s=(a[j+129|0]|0)!=0}t=((s^1)&1|0)!=0}else{t=0}u=t&1}else{if((a[j+129|0]|0)!=0){v=(d[j+130|0]|0)!=0}else{v=1}u=v&1}p=(r|0)!=0;if(u<<24>>24!=0){if(!p){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!p){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}p=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;w=zn(n,c[n+228>>2]|0,e,c[r+4>>2]|0,p,h)|0;a[r+32|0]=0;if((w|0)!=0){o=74;break a}break};case 0:{o=4;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 6:{if((bn(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case-4:{o=3;break a;break};case 7:case 39:{o=31;break};case 10:{r=we[c[b+44>>2]&63](b,f)|0;if((r|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((r|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);r=Gn(r,m)|0;if((r|0)==0){o=19;break a}p=0;while(1){if((p|0)>=(r|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Lm(h)|0)<<24>>24!=0)){o=27;break a}}q=a[m+p|0]|0;x=h+12|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=q;p=p+1|0}break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Lm(h)|0)<<24>>24!=0)){o=37;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=w;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function An(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ke[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Hn()|0;c[g+240>>2]=he[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ge[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){ee[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}ee[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Bn(){var a=0,b=0;a=i;i=i+8|0;ac(((rc(0)|0)>>>0)%4294967295|0|0);b=yW()|0;i=a;return b|0}function Cn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=Tm(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=Um(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=he[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{En(f+80|0,e);En(b+104|0,e);Fn(b,e);Fn(b+20|0,e);Fn(b+40|0,e);Fn(b+60|0,e);a[b+131|0]=0;Fn(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function En(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Fn(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Gn(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Hn(){i=i;return 1912}function In(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[29440+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[29516+l|0]|0|0)!=28){if((d[29516+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[29516+q|0]|0|0)!=28){if((d[29516+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[29516+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Jn(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[23608+(((d[23352+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[23608+(((d[24888+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Gn(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function Jn(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[29516+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function Kn(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=we[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[23608+(((d[24888+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Ln(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=we[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[23608+(((d[23352+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Mn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=we[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Jn(a)|0)<0;g=f&1;i=d;return g|0}function Nn(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Gn(we[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function On(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(we[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Pn(){i=i;return 29072}function Qn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Rn(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=20;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((eo(d,c[28976+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Sn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=cq(27416,a,0,b,c,d)|0;i=e;return f|0}function Tn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=cq(27416,a,1,b,c,d)|0;i=e;return f|0}function Un(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Bp(28184,b,c,d);i=a;return}function Vn(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Wn(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Wn(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(dq(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ge[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,28920)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((dq(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ge[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,28928)|0)!=0){h=eq(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ke[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((dq(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ge[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,28944)|0)!=0){if((a|0)!=0){break}do{if((Ge[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,28960)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ge[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,28968)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((fq(eq(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Xn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;be[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((eo(h,25144)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Rn(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[27416+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Yn(){i=i;return 27048}function Zn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Rn(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=20;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function _n(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=cq(25152,a,0,b,c,d)|0;i=e;return f|0}function $n(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=cq(25152,a,1,b,c,d)|0;i=e;return f|0}function ao(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Wn(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function bo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;be[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((eo(h,25144)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Rn(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[25152+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function co(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=In(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function eo(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function fo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 19:{k=Ko(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 10:case 21:{n=25;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;n=77;break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=wo(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=wo(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 16:{k=Jo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=Eo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=yo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;n=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 13:{k=Io(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=Io(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;o=18;n=77;break a}if((c[23608+((d[24888+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;o=19;n=77;break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=wo(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=wo(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 7:{n=91;break b;break};case 5:{n=85;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 6:{n=88;break b;break};case 15:{n=122;break b;break};case 34:{n=116;break b;break};case 33:{n=119;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}o=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=wo(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};case 6:{n=108;break b;break};case 5:{n=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function go(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 2:{k=Bo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=xo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wo(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=wo(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function ho(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wo(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=wo(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function io(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=wo(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function jo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wo(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 9:{n=19;break a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=xo(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=wo(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ko(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wo(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 9:{n=21;break a;break};case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=xo(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=yo(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=wo(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function lo(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=wo(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=wo(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function mo(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function no(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=wo(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function oo(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=wo(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function po(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=wo(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=wo(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function qo(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Jn(c)|0;k=j;i=b;return k|0}function ro(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e+1|0]|0)==0){h=a[e]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==103){f=62;g=f;i=b;return g|0}else if((j|0)==108){f=60;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function so(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=wo(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=wo(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 5:{b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function to(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=wo(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function uo(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function vo(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function wo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 219:case 218:case 217:case 216:{d=7;break};case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function xo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=zo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wo(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function yo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wo(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function zo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Ao(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wo(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Ao(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=wo(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wo(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Bo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wo(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Eo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 17:{k=Fo(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wo(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=Do(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=Co(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=wo(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 29:{if((c[23608+((d[24888+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 17:{break b;break};case 6:{o=42;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=wo(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 29:{if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 11:{o=90;break b;break};case 5:{o=39;break b;break};case 7:{o=45;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=wo(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 17:{break c;break};case 5:{o=78;break d;break};case 11:{o=90;break c;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[23608+((d[23352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Go(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Co(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=wo(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Do(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[25552+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}



function kS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=105688;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);BL(b+144|0,105672,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[110580>>2]=0;c[27644]=104168;if(!((c[26048]|0)==-1)){c[G>>2]=104192;c[G+4>>2]=205;c[G+8>>2]=0;uL(104192,G,206)}lS(b,110576,(c[104196>>2]|0)+ -1|0);c[110572>>2]=0;c[27642]=104208;if(!((c[26058]|0)==-1)){c[F>>2]=104232;c[F+4>>2]=205;c[F+8>>2]=0;uL(104232,F,206)}lS(b,110568,(c[104236>>2]|0)+ -1|0);c[110556>>2]=0;c[27638]=105784;c[110560>>2]=0;a[110564|0]=0;F=c[(xc()|0)>>2]|0;c[110560>>2]=F;if(!((c[26442]|0)==-1)){c[E>>2]=105768;c[E+4>>2]=205;c[E+8>>2]=0;uL(105768,E,206)}lS(b,110552,(c[105772>>2]|0)+ -1|0);c[110548>>2]=0;c[27636]=106744;if(!((c[26440]|0)==-1)){c[D>>2]=105760;c[D+4>>2]=205;c[D+8>>2]=0;uL(105760,D,206)}lS(b,110544,(c[105764>>2]|0)+ -1|0);c[110540>>2]=0;c[27634]=106960;if(!((c[26458]|0)==-1)){c[C>>2]=105832;c[C+4>>2]=205;c[C+8>>2]=0;uL(105832,C,206)}lS(b,110536,(c[105836>>2]|0)+ -1|0);c[110524>>2]=0;c[27630]=105856;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);c[110528>>2]=c[26414];if(!((c[26460]|0)==-1)){c[B>>2]=105840;c[B+4>>2]=205;c[B+8>>2]=0;uL(105840,B,206)}lS(b,110520,(c[105844>>2]|0)+ -1|0);c[110516>>2]=0;c[27628]=107184;if(!((c[26474]|0)==-1)){c[A>>2]=105896;c[A+4>>2]=205;c[A+8>>2]=0;uL(105896,A,206)}lS(b,110512,(c[105900>>2]|0)+ -1|0);c[110508>>2]=0;c[27626]=107304;if(!((c[26476]|0)==-1)){c[z>>2]=105904;c[z+4>>2]=205;c[z+8>>2]=0;uL(105904,z,206)}lS(b,110504,(c[105908>>2]|0)+ -1|0);c[110484>>2]=0;c[27620]=105936;a[110488|0]=46;a[110489|0]=44;z=110492|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[26478]|0)==-1)){c[y>>2]=105912;c[y+4>>2]=205;c[y+8>>2]=0;uL(105912,y,206)}lS(b,110480,(c[105916>>2]|0)+ -1|0);c[110452>>2]=0;c[27612]=105976;c[110456>>2]=46;c[110460>>2]=44;y=110464|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[26480]|0)==-1)){c[x>>2]=105920;c[x+4>>2]=205;c[x+8>>2]=0;uL(105920,x,206)}lS(b,110448,(c[105924>>2]|0)+ -1|0);c[110444>>2]=0;c[27610]=104248;if(!((c[26076]|0)==-1)){c[w>>2]=104304;c[w+4>>2]=205;c[w+8>>2]=0;uL(104304,w,206)}lS(b,110440,(c[104308>>2]|0)+ -1|0);c[110436>>2]=0;c[27608]=104368;if(!((c[26106]|0)==-1)){c[v>>2]=104424;c[v+4>>2]=205;c[v+8>>2]=0;uL(104424,v,206)}lS(b,110432,(c[104428>>2]|0)+ -1|0);c[110428>>2]=0;c[27606]=104440;if(!((c[26122]|0)==-1)){c[u>>2]=104488;c[u+4>>2]=205;c[u+8>>2]=0;uL(104488,u,206)}lS(b,110424,(c[104492>>2]|0)+ -1|0);c[110420>>2]=0;c[27604]=104504;if(!((c[26138]|0)==-1)){c[t>>2]=104552;c[t+4>>2]=205;c[t+8>>2]=0;uL(104552,t,206)}lS(b,110416,(c[104556>>2]|0)+ -1|0);c[110412>>2]=0;c[27602]=105096;if(!((c[26286]|0)==-1)){c[s>>2]=105144;c[s+4>>2]=205;c[s+8>>2]=0;uL(105144,s,206)}lS(b,110408,(c[105148>>2]|0)+ -1|0);c[110404>>2]=0;c[27600]=105160;if(!((c[26302]|0)==-1)){c[r>>2]=105208;c[r+4>>2]=205;c[r+8>>2]=0;uL(105208,r,206)}lS(b,110400,(c[105212>>2]|0)+ -1|0);c[110396>>2]=0;c[27598]=105224;if(!((c[26318]|0)==-1)){c[q>>2]=105272;c[q+4>>2]=205;c[q+8>>2]=0;uL(105272,q,206)}lS(b,110392,(c[105276>>2]|0)+ -1|0);c[110388>>2]=0;c[27596]=105288;if(!((c[26334]|0)==-1)){c[p>>2]=105336;c[p+4>>2]=205;c[p+8>>2]=0;uL(105336,p,206)}lS(b,110384,(c[105340>>2]|0)+ -1|0);c[110380>>2]=0;c[27594]=105352;if(!((c[26344]|0)==-1)){c[o>>2]=105376;c[o+4>>2]=205;c[o+8>>2]=0;uL(105376,o,206)}lS(b,110376,(c[105380>>2]|0)+ -1|0);c[110372>>2]=0;c[27592]=105432;if(!((c[26364]|0)==-1)){c[n>>2]=105456;c[n+4>>2]=205;c[n+8>>2]=0;uL(105456,n,206)}lS(b,110368,(c[105460>>2]|0)+ -1|0);c[110364>>2]=0;c[27590]=105488;if(!((c[26378]|0)==-1)){c[m>>2]=105512;c[m+4>>2]=205;c[m+8>>2]=0;uL(105512,m,206)}lS(b,110360,(c[105516>>2]|0)+ -1|0);c[110356>>2]=0;c[27588]=105536;if(!((c[26390]|0)==-1)){c[l>>2]=105560;c[l+4>>2]=205;c[l+8>>2]=0;uL(105560,l,206)}lS(b,110352,(c[105564>>2]|0)+ -1|0);c[110340>>2]=0;c[27584]=104584;c[110344>>2]=104632;if(!((c[26166]|0)==-1)){c[k>>2]=104664;c[k+4>>2]=205;c[k+8>>2]=0;uL(104664,k,206)}lS(b,110336,(c[104668>>2]|0)+ -1|0);c[110324>>2]=0;c[27580]=104736;c[110328>>2]=104784;if(!((c[26204]|0)==-1)){c[j>>2]=104816;c[j+4>>2]=205;c[j+8>>2]=0;uL(104816,j,206)}lS(b,110320,(c[104820>>2]|0)+ -1|0);c[110308>>2]=0;c[27576]=106680;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);c[110312>>2]=c[26414];c[27576]=105032;if(!((c[26262]|0)==-1)){c[h>>2]=105048;c[h+4>>2]=205;c[h+8>>2]=0;uL(105048,h,206)}lS(b,110304,(c[105052>>2]|0)+ -1|0);c[110292>>2]=0;c[27572]=106680;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);c[110296>>2]=c[26414];c[27572]=105064;if(!((c[26270]|0)==-1)){c[g>>2]=105080;c[g+4>>2]=205;c[g+8>>2]=0;uL(105080,g,206)}lS(b,110288,(c[105084>>2]|0)+ -1|0);c[110284>>2]=0;c[27570]=105576;if(!((c[26400]|0)==-1)){c[f>>2]=105600;c[f+4>>2]=205;c[f+8>>2]=0;uL(105600,f,206)}lS(b,110280,(c[105604>>2]|0)+ -1|0);c[110276>>2]=0;c[27568]=105616;if((c[26410]|0)==-1){N=105640;O=105640;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=110272;lS(b,T,S);i=e;return}c[H>>2]=105640;c[H+4>>2]=205;c[H+8>>2]=0;uL(105640,H,206);N=105640;O=105640;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=110272;lS(b,T,S);i=e;return}function lS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;_K(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){qU(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}$K(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function mS(a){a=a|0;var b=0;b=i;nS(a);WV(a);i=b;return}function nS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=105688;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{$K(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}JL(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{WV(h);i=d;return}}function oS(){var b=0,d=0,e=0,f=0;b=i;if((a[105744]|0)!=0){d=105736;e=c[26434]|0;i=b;return e|0}if((Za(105744)|0)==0){d=105736;e=c[26434]|0;i=b;return e|0}do{if((a[105720]|0)==0){if((Za(105720)|0)==0){break}kS(110112,1);c[26426]=110112;c[26428]=105704;Sb(105720)}}while(0);f=c[c[26428]>>2]|0;c[26432]=f;_K(f);c[26434]=105728;Sb(105744);d=105736;e=c[26434]|0;i=b;return e|0}function pS(a){a=a|0;var b=0,d=0;b=i;d=c[(oS()|0)>>2]|0;c[a>>2]=d;_K(d);i=b;return}function qS(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;_K(e);i=d;return}function rS(a){a=a|0;var b=0;b=i;$K(c[a>>2]|0)|0;i=b;return}function sS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=205;c[e+8>>2]=0;uL(a,e,206)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function tS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=205;c[e+8>>2]=0;uL(a,e,206)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Dc(4)|0;h=g;tV(h);j=121328;k=127;Sd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Dc(4)|0;h=g;tV(h);j=121328;k=127;Sd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function uS(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function vS(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}ee[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function wS(a){a=a|0;var b=0;b=c[26438]|0;c[26438]=1+b;c[a+4>>2]=b+1;i=i;return}function xS(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function yS(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(xc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function zS(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(xc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function AS(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(xc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function BS(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(xc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function CS(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Cd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function DS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Cd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function ES(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Hd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function FS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Hd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function GS(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function HS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function IS(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function JS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function KS(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=105784;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}XV(e)}}while(0);WV(b);i=d;return}function LS(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=105784;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}XV(e);i=d;return}function MS(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Cd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function NS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Cd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function OS(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Hd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function PS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Hd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function QS(a,b){a=a|0;b=b|0;i=i;return b|0}function RS(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function SS(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function TS(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function US(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function VS(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function WS(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function XS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function YS(a){a=a|0;i=i;return 1}function ZS(a){a=a|0;i=i;return 1}function _S(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function $S(a){a=a|0;i=i;return 1}function aT(a){a=a|0;var b=0;b=i;iS(a);WV(a);i=b;return}function bT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=UU(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=TU(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=TU(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function cT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=QU(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=PU(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=PU(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==-2){B=16;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-1){B=15;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function dT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=TU(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function eT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=SU(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function fT(a){a=a|0;i=i;return 0}function gT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=OU(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function hT(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function iT(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function jT(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=kT(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function kT(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function lT(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=mT(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function mT(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function nT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function oT(a){a=a|0;i=i;return 0}function pT(a){a=a|0;i=i;return 0}function qT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=rT(c,d,e,1114111,0)|0;i=b;return a|0}function rT(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function sT(a){a=a|0;i=i;return 4}function tT(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function uT(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=vT(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function vT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function wT(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=xT(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function xT(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function yT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function zT(a){a=a|0;i=i;return 0}function AT(a){a=a|0;i=i;return 0}function BT(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=CT(c,d,e,1114111,0)|0;i=b;return a|0}function CT(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function DT(a){a=a|0;i=i;return 4}function ET(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function FT(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function GT(a){a=a|0;var b=0;b=i;c[a>>2]=105936;JL(a+12|0);WV(a);i=b;return}function HT(a){a=a|0;var b=0;b=i;c[a>>2]=105936;JL(a+12|0);i=b;return}function IT(a){a=a|0;var b=0;b=i;c[a>>2]=105976;JL(a+16|0);WV(a);i=b;return}function JT(a){a=a|0;var b=0;b=i;c[a>>2]=105976;JL(a+16|0);i=b;return}function KT(b){b=b|0;i=i;return a[b+8|0]|0}function LT(a){a=a|0;i=i;return c[a+8>>2]|0}function MT(b){b=b|0;i=i;return a[b+9|0]|0}function NT(a){a=a|0;i=i;return c[a+12>>2]|0}function OT(a,b){a=a|0;b=b|0;var c=0;c=i;zL(a,b+12|0);i=c;return}function PT(a,b){a=a|0;b=b|0;var c=0;c=i;zL(a,b+16|0);i=c;return}function QT(a,b){a=a|0;b=b|0;b=i;BL(a,106008,4);i=b;return}function RT(a,b){a=a|0;b=b|0;b=i;jM(a,106016,oV(106016)|0);i=b;return}function ST(a,b){a=a|0;b=b|0;b=i;BL(a,106040,5);i=b;return}function TT(a,b){a=a|0;b=b|0;b=i;jM(a,106048,oV(106048)|0);i=b;return}function UT(b){b=b|0;var d=0,e=0;b=i;if((a[106080]|0)!=0){d=106072;e=c[26518]|0;i=b;return e|0}if((Za(106080)|0)==0){d=106072;e=c[26518]|0;i=b;return e|0}do{if((a[113280]|0)==0){if((Za(113280)|0)==0){break}uW(113112,0,168)|0;Yd(208,0,q|0)|0;Sb(113280)}}while(0);ML(113112,113288)|0;ML(113124|0,113296)|0;ML(113136|0,113304)|0;ML(113148|0,113312)|0;ML(113160|0,113328)|0;ML(113172|0,113344)|0;ML(113184|0,113352)|0;ML(113196|0,113368)|0;ML(113208|0,113376)|0;ML(113220|0,113384)|0;ML(113232|0,113392)|0;ML(113244|0,113400)|0;ML(113256|0,113408)|0;ML(113268|0,113416)|0;c[26518]=113112;Sb(106080);d=106072;e=c[26518]|0;i=b;return e|0}function VT(b){b=b|0;var d=0,e=0;b=i;if((a[106096]|0)!=0){d=106088;e=c[26522]|0;i=b;return e|0}if((Za(106096)|0)==0){d=106088;e=c[26522]|0;i=b;return e|0}do{if((a[112744]|0)==0){if((Za(112744)|0)==0){break}uW(112576,0,168)|0;Yd(209,0,q|0)|0;Sb(112744)}}while(0);mM(112576,112752)|0;mM(112588|0,112784)|0;mM(112600|0,112816)|0;mM(112612|0,112848)|0;mM(112624|0,112888)|0;mM(112636|0,112928)|0;mM(112648|0,112960)|0;mM(112660|0,113e3)|0;mM(112672|0,113016)|0;mM(112684|0,113032)|0;mM(112696|0,113048)|0;mM(112708|0,113064)|0;mM(112720|0,113080)|0;mM(112732|0,113096)|0;c[26522]=112576;Sb(106096);d=106088;e=c[26522]|0;i=b;return e|0}function WT(b){b=b|0;var d=0,e=0;b=i;if((a[106112]|0)!=0){d=106104;e=c[26526]|0;i=b;return e|0}if((Za(106112)|0)==0){d=106104;e=c[26526]|0;i=b;return e|0}do{if((a[112352]|0)==0){if((Za(112352)|0)==0){break}uW(112064,0,288)|0;Yd(210,0,q|0)|0;Sb(112352)}}while(0);ML(112064,112360)|0;ML(112076|0,112368)|0;ML(112088|0,112384)|0;ML(112100|0,112392)|0;ML(112112|0,112400)|0;ML(112124|0,112408)|0;ML(112136|0,112416)|0;ML(112148|0,112424)|0;ML(112160|0,112432)|0;ML(112172|0,112448)|0;ML(112184|0,112456)|0;ML(112196|0,112472)|0;ML(112208|0,112488)|0;ML(112220|0,112496)|0;ML(112232|0,112504)|0;ML(112244|0,112512)|0;ML(112256|0,112400)|0;ML(112268|0,112520)|0;ML(112280|0,112528)|0;ML(112292|0,112536)|0;ML(112304|0,112544)|0;ML(112316|0,112552)|0;ML(112328|0,112560)|0;ML(112340|0,112568)|0;c[26526]=112064;Sb(106112);d=106104;e=c[26526]|0;i=b;return e|0}function XT(b){b=b|0;var d=0,e=0;b=i;if((a[106128]|0)!=0){d=106120;e=c[26530]|0;i=b;return e|0}if((Za(106128)|0)==0){d=106120;e=c[26530]|0;i=b;return e|0}do{if((a[111512]|0)==0){if((Za(111512)|0)==0){break}uW(111224,0,288)|0;Yd(211,0,q|0)|0;Sb(111512)}}while(0);mM(111224,111520)|0;mM(111236|0,111552)|0;mM(111248|0,111592)|0;mM(111260|0,111616)|0;mM(111272|0,111936)|0;mM(111284|0,111640)|0;mM(111296|0,111664)|0;mM(111308|0,111688)|0;mM(111320|0,111720)|0;mM(111332|0,111760)|0;mM(111344|0,111792)|0;mM(111356|0,111832)|0;mM(111368|0,111872)|0;mM(111380|0,111888)|0;mM(111392|0,111904)|0;mM(111404|0,111920)|0;mM(111416|0,111936)|0;mM(111428|0,111952)|0;mM(111440|0,111968)|0;mM(111452|0,111984)|0;mM(111464|0,112e3)|0;mM(111476|0,112016)|0;mM(111488|0,112032)|0;mM(111500|0,112048)|0;c[26530]=111224;Sb(106128);d=106120;e=c[26530]|0;i=b;return e|0}function YT(b){b=b|0;var d=0,e=0;b=i;if((a[106144]|0)!=0){d=106136;e=c[26534]|0;i=b;return e|0}if((Za(106144)|0)==0){d=106136;e=c[26534]|0;i=b;return e|0}do{if((a[111200]|0)==0){if((Za(111200)|0)==0){break}uW(110912,0,288)|0;Yd(212,0,q|0)|0;Sb(111200)}}while(0);ML(110912,111208)|0;ML(110924|0,111216)|0;c[26534]=110912;Sb(106144);d=106136;e=c[26534]|0;i=b;return e|0}function ZT(b){b=b|0;var d=0,e=0;b=i;if((a[106160]|0)!=0){d=106152;e=c[26538]|0;i=b;return e|0}if((Za(106160)|0)==0){d=106152;e=c[26538]|0;i=b;return e|0}do{if((a[110872]|0)==0){if((Za(110872)|0)==0){break}uW(110584,0,288)|0;Yd(213,0,q|0)|0;Sb(110872)}}while(0);mM(110584,110880)|0;mM(110596|0,110896)|0;c[26538]=110584;Sb(106160);d=106152;e=c[26538]|0;i=b;return e|0}function _T(b){b=b|0;var c=0;b=i;if((a[106184]|0)!=0){c=106168;i=b;return c|0}if((Za(106184)|0)==0){c=106168;i=b;return c|0}BL(106168,106192,8);Yd(214,106168,q|0)|0;Sb(106184);c=106168;i=b;return c|0}function $T(b){b=b|0;var c=0;b=i;if((a[106224]|0)!=0){c=106208;i=b;return c|0}if((Za(106224)|0)==0){c=106208;i=b;return c|0}jM(106208,106232,oV(106232)|0);Yd(215,106208,q|0)|0;Sb(106224);c=106208;i=b;return c|0}function aU(b){b=b|0;var c=0;b=i;if((a[106288]|0)!=0){c=106272;i=b;return c|0}if((Za(106288)|0)==0){c=106272;i=b;return c|0}BL(106272,106296,8);Yd(214,106272,q|0)|0;Sb(106288);c=106272;i=b;return c|0}function bU(b){b=b|0;var c=0;b=i;if((a[106328]|0)!=0){c=106312;i=b;return c|0}if((Za(106328)|0)==0){c=106312;i=b;return c|0}jM(106312,106336,oV(106336)|0);Yd(215,106312,q|0)|0;Sb(106328);c=106312;i=b;return c|0}function cU(b){b=b|0;var c=0;b=i;if((a[106392]|0)!=0){c=106376;i=b;return c|0}if((Za(106392)|0)==0){c=106376;i=b;return c|0}BL(106376,106400,20);Yd(214,106376,q|0)|0;Sb(106392);c=106376;i=b;return c|0}function dU(b){b=b|0;var c=0;b=i;if((a[106440]|0)!=0){c=106424;i=b;return c|0}if((Za(106440)|0)==0){c=106424;i=b;return c|0}jM(106424,106448,oV(106448)|0);Yd(215,106424,q|0)|0;Sb(106440);c=106424;i=b;return c|0}function eU(b){b=b|0;var c=0;b=i;if((a[106552]|0)!=0){c=106536;i=b;return c|0}if((Za(106552)|0)==0){c=106536;i=b;return c|0}BL(106536,106560,11);Yd(214,106536,q|0)|0;Sb(106552);c=106536;i=b;return c|0}function fU(b){b=b|0;var c=0;b=i;if((a[106592]|0)!=0){c=106576;i=b;return c|0}if((Za(106592)|0)==0){c=106576;i=b;return c|0}jM(106576,106600,oV(106600)|0);Yd(215,106576,q|0)|0;Sb(106592);c=106576;i=b;return c|0}function gU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);l=+kW(b,g,c[26414]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function hU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);l=+kW(b,g,c[26414]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function iU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);l=+kW(b,g,c[26414]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function jU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);n=lb(b|0,h|0,f|0,c[26414]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function kU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);m=lb(b|0,h|0,f|0,c[26414]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function lU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);m=lb(b|0,h|0,f|0,c[26414]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function mU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);m=lb(b|0,h|0,f|0,c[26414]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function nU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);n=Gc(b|0,h|0,f|0,c[26414]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function oU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[105664]|0)==0){if((Za(105664)|0)==0){break}c[26414]=Yb(2147483647,105672,0)|0;Sb(105664)}}while(0);m=Gc(b|0,h|0,f|0,c[26414]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function pU(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;ee[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;ee[h&255](a);i=b;return}}function qU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){jS(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=UV(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;sW(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{WV(h);i=e;return}}function rU(a){a=a|0;a=i;lM(110860|0);lM(110848|0);lM(110836|0);lM(110824|0);lM(110812|0);lM(110800|0);lM(110788|0);lM(110776|0);lM(110764|0);lM(110752|0);lM(110740|0);lM(110728|0);lM(110716|0);lM(110704|0);lM(110692|0);lM(110680|0);lM(110668|0);lM(110656|0);lM(110644|0);lM(110632|0);lM(110620|0);lM(110608|0);lM(110596|0);lM(110584);i=a;return}function sU(a){a=a|0;a=i;JL(111188|0);JL(111176|0);JL(111164|0);JL(111152|0);JL(111140|0);JL(111128|0);JL(111116|0);JL(111104|0);JL(111092|0);JL(111080|0);JL(111068|0);JL(111056|0);JL(111044|0);JL(111032|0);JL(111020|0);JL(111008|0);JL(110996|0);JL(110984|0);JL(110972|0);JL(110960|0);JL(110948|0);JL(110936|0);JL(110924|0);JL(110912);i=a;return}function tU(a){a=a|0;a=i;lM(111500|0);lM(111488|0);lM(111476|0);lM(111464|0);lM(111452|0);lM(111440|0);lM(111428|0);lM(111416|0);lM(111404|0);lM(111392|0);lM(111380|0);lM(111368|0);lM(111356|0);lM(111344|0);lM(111332|0);lM(111320|0);lM(111308|0);lM(111296|0);lM(111284|0);lM(111272|0);lM(111260|0);lM(111248|0);lM(111236|0);lM(111224);i=a;return}function uU(a){a=a|0;a=i;JL(112340|0);JL(112328|0);JL(112316|0);JL(112304|0);JL(112292|0);JL(112280|0);JL(112268|0);JL(112256|0);JL(112244|0);JL(112232|0);JL(112220|0);JL(112208|0);JL(112196|0);JL(112184|0);JL(112172|0);JL(112160|0);JL(112148|0);JL(112136|0);JL(112124|0);JL(112112|0);JL(112100|0);JL(112088|0);JL(112076|0);JL(112064);i=a;return}function vU(a){a=a|0;a=i;lM(112732|0);lM(112720|0);lM(112708|0);lM(112696|0);lM(112684|0);lM(112672|0);lM(112660|0);lM(112648|0);lM(112636|0);lM(112624|0);lM(112612|0);lM(112600|0);lM(112588|0);lM(112576);i=a;return}function wU(a){a=a|0;a=i;JL(113268|0);JL(113256|0);JL(113244|0);JL(113232|0);JL(113220|0);JL(113208|0);JL(113196|0);JL(113184|0);JL(113172|0);JL(113160|0);JL(113148|0);JL(113136|0);JL(113124|0);JL(113112);i=a;return}function xU(a){a=a|0;var b=0,c=0;b=i;if((DU(a)|0)==0){c=(yU(a)|0)!=0|0}else{c=1}i=b;return c|0}function yU(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[113424+((d[113424+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function zU(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function AU(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function BU(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 2:{d=yU(a)|0;break};case 3:{d=zU(a)|0;break};case 1:{d=xU(a)|0;break};case 6:{d=EU(a)|0;break};case 4:{d=AU(a)|0;break};case 10:{d=IU(a)|0;break};case 12:{d=KU(a)|0;break};case 11:{d=JU(a)|0;break};case 8:{d=GU(a)|0;break};case 9:{d=HU(a)|0;break};case 5:{d=DU(a)|0;break};case 7:{d=FU(a)|0;break};default:{d=0}}i=c;return d|0}function CU(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=116400;while(1){if(d<<24>>24==e<<24>>24){if((mW(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function DU(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function EU(a){a=a|0;var b=0,c=0;b=i;if((IU(a)|0)==0){c=(GU(a)|0)!=0|0}else{c=0}i=b;return c|0}function FU(a){a=a|0;var b=0,c=0;b=i;if((LU(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function GU(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function HU(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[116480+((d[116480+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function IU(a){a=a|0;var b=0,c=0;b=i;c=(nV(119648,a)|0)!=0|0;i=b;return c|0}function JU(a){a=a|0;var b=0,c=0;b=i;c=(NU(a)|0)!=(a|0)|0;i=b;return c|0}function KU(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function LU(a){a=a|0;var b=0,c=0;b=i;c=MU(a,0)|0;i=b;return c|0}function MU(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((yU(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[119738+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[119736+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[119739+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[119984+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[119984+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[119984+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function NU(a){a=a|0;var b=0,c=0;b=i;c=MU(a,1)|0;i=b;return c|0}function OU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=PU(0,a,b,(c|0)!=0?c:120688)|0;i=d;return e|0}function PU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?120696:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[120480+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function QU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=RU(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=PU(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function RU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[120480+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[120480+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function SU(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[120480+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function TU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function UU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=VU(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=TU(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function VU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=TU(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=TU(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=TU(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}TU(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function WU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=OV(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=OV(2048)|0;c[p+16>>2]=s;if((s|0)==0){PV(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=kV(0,0)|0;if((s|0)==0){PV(c[p+16>>2]|0);PV(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=XU(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=QV(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=YU(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=OV(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;uW(y|0,-1,v|0)|0;I=H}else{I=0}H=QV(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=QV(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=YU(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=cV(q,x)|0;b:do{if((v|0)==0){y=cV(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==1){T=c[S+4>>2]|0;U=cV(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=cV(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=cV(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}X=cV(q,0)|0}else if((P|0)==2){U=c[S+4>>2]|0;T=cV(q,L)|0;if((T|0)!=0){V=N;W=T;break c}T=cV(q,S)|0;if((T|0)!=0){V=N;W=T;break c}T=cV(q,1)|0;if((T|0)!=0){V=N;W=T;break c}T=cV(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=cV(q,0)|0;if((T|0)!=0){V=N;W=T;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{Y=L}}if((F|0)==45){F=0;c[j>>2]=0;Y=0}Z=Y;_=M+1|0;$=N;break}else if((P|0)==3){U=c[S+4>>2]|0;T=cV(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=cV(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=cV(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}X=cV(q,0)|0}else if((P|0)==0){P=c[S+4>>2]|0;T=c[P>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Z=L;_=M;$=N;break}T=P+8|0;P=(c[T>>2]|0)+L|0;c[T>>2]=P;if((P|0)<=(c[k>>2]|0)){Z=L;_=M;$=N;break}c[k>>2]=P;Z=L;_=M;$=N;break}else{Z=L;_=M;$=N;break}if((X|0)==0){Z=L;_=M;$=N}else{V=N;W=X;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=dV(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=mV(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=mV(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=dV(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=mV(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=mV(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=dV(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=mV(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=mV(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=mV(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=mV(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=mV(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=mV(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=mV(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=mV(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Z=da;_=U;$=T;break}c[j>>2]=T;Z=T;_=0;$=T}else{Z=L;_=M;$=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Z;M=_;N=$;O=S}else{V=$;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=mV(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=mV(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=mV(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=mV(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=cV(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=cV(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;Q=c[L>>2]|0;if((Q|0)==-4){c[ya+8>>2]=0;R=L+8|0;T=c[R>>2]|0;U=mV(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}ba=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=ba;ba=c[R>>2]|0;R=c[L+4>>2]|0;U=mV(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=ba;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=R;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((Q|0)<0){c[U>>2]=1;R=mV(s,0,0,1,32)|0;if((R|0)==0){F=110;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+24>>2]=R;R=mV(s,0,0,1,32)|0;if((R|0)==0){F=112;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+28>>2]=R;break}else{c[U>>2]=0;U=L+8|0;R=c[U>>2]|0;ba=L+4|0;T=c[ba>>2]|0;la=mV(s,0,0,1,64)|0;if((la|0)==0){F=115;break g}ma=la;c[la>>2]=R;c[la+4>>2]=Q;c[la+8>>2]=T;c[la+20>>2]=0;c[la+24>>2]=0;T=la+28|0;la=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[la>>2]=ma;ma=c[U>>2]|0;U=c[L>>2]|0;la=c[ba>>2]|0;ba=c[L+12>>2]|0;T=c[L+16>>2]|0;L=mV(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}Q=L;c[L>>2]=ma;c[L+4>>2]=U;c[L+8>>2]=la;c[L+20>>2]=ba;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=Q;break}}else if((M|0)==1){Q=cV(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=cV(q,2)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=ya+4|0;L=cV(q,c[(c[Q>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=cV(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=cV(q,c[c[Q>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=cV(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==3){L=cV(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=cV(q,1)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;Q=cV(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=cV(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=cV(q,c[c[L>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=cV(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((M|0)==2){M=cV(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=cV(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=cV(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=cV(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==3){M=c[ya+4>>2]|0;Q=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[Q+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[Q+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==2){L=c[ya+4>>2]|0;T=c[L>>2]|0;ba=T+8|0;if((c[ba>>2]|0)==0){za=0}else{za=(c[(c[L+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[ba>>2]|0)==0){c[ya+24>>2]=c[T+24>>2];Aa=L+4|0}else{ba=bV(q,T,0,0,g)|0;if((ba|0)!=0){z=0;A=ba;B=0;C=D;break a}Ba=OV((c[g>>2]<<2)+4|0)|0;ba=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=bV(q,c[L>>2]|0,ba,h,0)|0;if((Ca|0)!=0){F=150;break g}T=L+4|0;la=aV(s,c[(c[T>>2]|0)+24>>2]|0,c[(c[L>>2]|0)+24>>2]|0,ba,c[h>>2]|0)|0;ba=ya+24|0;c[ba>>2]=la;PV(Ba);if((c[ba>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=T}}T=c[Aa>>2]|0;if((c[T+8>>2]|0)==0){c[ya+28>>2]=c[T+28>>2];break}ba=bV(q,T,0,0,g)|0;if((ba|0)!=0){z=0;A=ba;B=0;C=D;break a}Da=OV((c[g>>2]<<2)+4|0)|0;ba=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=bV(q,c[Aa>>2]|0,ba,h,0)|0;if((Ea|0)!=0){F=157;break g}T=aV(s,c[(c[L>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,ba,c[h>>2]|0)|0;ba=ya+28|0;c[ba>>2]=T;PV(Da);if((c[ba>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){ba=c[ya+4>>2]|0;T=c[ba>>2]|0;L=ba+4|0;la=c[L>>2]|0;if((c[T+8>>2]|0)==0){Fa=(c[la+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;U=aV(s,c[T+24>>2]|0,c[la+24>>2]|0,0,0)|0;c[ya+24>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}U=aV(s,c[(c[ba>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){PV(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){PV(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=OV(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=OV(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){uW(O|0,0,((E|0)>1?E<<2:4)|0)|0}ZU(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;U=O+(S<<2)|0;L=K+1+(c[U>>2]|0)|0;c[U>>2]=0;U=S+1|0;if((U|0)<(E|0)){S=U;K=L}else{Ga=L;break}}}else{Ga=0}K=QV(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;L=ZU(y,S,x,u)|0;if((L|0)!=0){z=x;A=L;B=u;C=D;break}c[w+20>>2]=0;L=v+24|0;S=c[L>>2]|0;if((c[S>>2]|0)>-1){U=1;ba=S;while(1){S=ba+32|0;la=U+1|0;if((c[S>>2]|0)>-1){ba=S;U=la}else{Ha=la;break}}}else{Ha=1}U=QV(Ha,32)|0;if((U|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=U;ba=c[L>>2]|0;y=c[ba>>2]|0;if((y|0)>-1){la=y;y=ba;ba=0;while(1){c[U+(ba<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[U+(ba<<5)+12>>2]=la;S=U+(ba<<5)+16|0;c[S>>2]=0;T=y+12|0;ma=c[T>>2]|0;if((ma|0)!=0){R=0;while(1){Ia=R+1|0;if((c[ma+(R<<2)>>2]|0)>-1){R=Ia}else{break}}R=Ia<<2;ma=OV(R)|0;c[S>>2]=ma;if((ma|0)==0){z=x;A=12;B=u;C=D;break a}sW(ma|0,c[T>>2]|0,R|0)|0}c[U+(ba<<5)+20>>2]=c[y+16>>2];R=ba+1|0;ma=y+32|0;ka=c[ma>>2]|0;if((ka|0)>-1){la=ka;y=ma;ba=R}else{Ja=R;break}}}else{Ja=0}c[U+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;lV(s);PV(c[p+16>>2]|0);PV(p);PV(O);PV(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);lV(s);PV(c[p+16>>2]|0);PV(p);if((z|0)!=0){PV(z)}if((B|0)!=0){PV(B)}c[b+4>>2]=C;_U(b);r=A;i=f;return r|0}



function FA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((mW(b,78536)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{DL(g,v);w=sA(u,g)|0;LL(w,c[d+((t|1)<<2)>>2]|0)|0;JL(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((mW(b,78560)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{DL(h,g);u=sA(t,h)|0;LL(u,c[d+((v|1)<<2)>>2]|0)|0;JL(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((mW(b,78584)|0)!=0){do{if((mW(b,78840)|0)!=0){if((mW(b,78848)|0)==0){break}if((mW(b,78856)|0)==0){break}if((mW(b,78864)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=LA(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){DL(r,c[t>>2]|0);w=sA(g,r)|0;LL(w,c[d+((u|1)<<2)>>2]|0)|0;JL(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=LA(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}DL(s,78872);LL(sA(x,s)|0,b)|0;JL(s);i=e;return}UA(j,k);xL(l);xL(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{DL(n,g);t=sA(j,n)|0;LL(t,c[d+((x|1)<<2)>>2]|0)|0;JL(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}DL(o,78600);KL(l,sA(j,o)|0)|0;JL(o);DL(p,78616);KL(m,sA(j,p)|0)|0;JL(p);c[k>>2]=Ec(eM(l)|0)|0;if((hM(m,78632)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((hM(m,78640)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((hM(m,78648)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((hM(m,78656)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((hM(m,78664)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((hM(m,78672)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((hM(m,78680)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((hM(m,78688)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((hM(m,78696)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((hM(m,78704)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((hM(m,78712)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((hM(m,78720)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((hM(m,78728)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((hM(m,78736)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=eM(m)|0;DL(q,75160);N=eM(sA(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;wr(0,(O|0)!=0|0,78744,f);JL(q);fG(LA(c[b>>2]|0,s)|0,j)|0;JL(m);JL(l);aB(j);i=e;return}function GA(a,b){a=a|0;b=b|0;i=i;return}function HA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=SC(a,b)|0;i=c;return d|0}function IA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;$C(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];TC(a,f);i=e;return}function JA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;UC(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];TC(a,e);i=d;return}function KA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;UA(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){xr(0,77928,n)}if(p){ec=zd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;tr(23,0,78072,m);VA(q);WA(q,e,8);if(!(XA(q)|0)){c[l>>2]=e;xr(0,78112,l)}xL(r);l=q;YA(l,r)|0;zL(s,r);while(1){e=YA(l,r)|0;if(!(tM(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}sM(t,78192,r);_L(s,t)|0;JL(t)}t=zd(eM(s)|0)|0;ZA(q);JL(s);JL(r);_A(q);fc=t}if((fc|0)==0){tr(23,0,78280,g);aB(o);i=f;return}xL(u);xL(v);c[k>>2]=fc;tr(23,0,78200,k);k=Wb(fc|0,78192)|0;if((k|0)!=0){g=k;do{k=UV(12)|0;DL(k,g);t=fM(k,78232,0)|0;dM(w,k,0,t);KL(u,w)|0;JL(w);dM(x,k,t+1|0,(QL(k)|0)+~t|0);KL(v,x)|0;JL(x);KL(sA(o,u)|0,v)|0;t=eM(u)|0;k=eM(v)|0;c[j>>2]=t;c[j+4>>2]=k;tr(23,0,78240,j);g=Wb(0,78192)|0;}while((g|0)!=0)}PV(fc);fc=a+12|0;DL(y,76328);g=sA(fc,y)|0;DL(z,76328);if(($A(o,z)|0)==0){DL(B,76328);gc=1;hc=0;ic=sA(fc,B)|0}else{DL(A,76328);gc=0;hc=1;ic=sA(o,A)|0}KL(g,ic)|0;if(gc){JL(B)}if(hc){JL(A)}JL(z);JL(y);DL(C,76200);y=sA(fc,C)|0;DL(D,76200);if(($A(o,D)|0)==0){DL(F,76200);jc=1;kc=0;lc=sA(fc,F)|0}else{DL(E,76200);jc=0;kc=1;lc=sA(o,E)|0}KL(y,lc)|0;if(jc){JL(F)}if(kc){JL(E)}JL(D);JL(C);DL(G,76232);C=sA(fc,G)|0;DL(H,76232);if(($A(o,H)|0)==0){DL(J,76232);mc=1;nc=0;oc=sA(fc,J)|0}else{DL(I,76232);mc=0;nc=1;oc=sA(o,I)|0}KL(C,oc)|0;if(mc){JL(J)}if(nc){JL(I)}JL(H);JL(G);DL(K,76264);G=sA(fc,K)|0;DL(L,76264);if(($A(o,L)|0)==0){DL(N,76264);pc=0;qc=1;rc=sA(fc,N)|0}else{DL(M,76264);pc=1;qc=0;rc=sA(o,M)|0}KL(G,rc)|0;if(qc){JL(N)}if(pc){JL(M)}JL(L);JL(K);DL(O,76296);K=sA(fc,O)|0;DL(P,76296);if(($A(o,P)|0)==0){DL(R,76296);sc=1;tc=0;uc=sA(fc,R)|0}else{DL(Q,76296);sc=0;tc=1;uc=sA(o,Q)|0}KL(K,uc)|0;if(sc){JL(R)}if(tc){JL(Q)}JL(P);JL(O);DL(S,76360);O=sA(fc,S)|0;DL(T,76360);if(($A(o,T)|0)==0){DL(V,76360);vc=1;wc=0;xc=sA(fc,V)|0}else{DL(U,76360);vc=0;wc=1;xc=sA(o,U)|0}KL(O,xc)|0;if(vc){JL(V)}if(wc){JL(U)}JL(T);JL(S);DL(W,76400);S=sA(fc,W)|0;DL(X,76400);if(($A(o,X)|0)==0){DL(Z,76400);yc=1;zc=0;Ac=sA(fc,Z)|0}else{DL(Y,76400);yc=0;zc=1;Ac=sA(o,Y)|0}KL(S,Ac)|0;if(yc){JL(Z)}if(zc){JL(Y)}JL(X);JL(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=LA(Y,_)|0;DL($,75304);Ac=sA(yc,$)|0;c[aa>>2]=Z;yc=LA(Y,aa)|0;DL(ba,75160);if(($A(o,sA(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=LA(Y,ea)|0;DL(fa,75304);Bc=1;Cc=0;Dc=sA(yc,fa)|0}else{c[ca>>2]=Z;yc=LA(Y,ca)|0;DL(da,75160);Bc=0;Cc=1;Dc=sA(o,sA(yc,da)|0)|0}KL(Ac,Dc)|0;if(Bc){JL(fa)}if(Cc){JL(da)}JL(ba);JL($);c[ga>>2]=Z;Ac=LA(zc,ga)|0;DL(ha,75304);yc=sA(Ac,ha)|0;c[ia>>2]=Z;Ac=LA(zc,ia)|0;DL(ja,75160);if(($A(o,sA(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=LA(zc,ma)|0;DL(na,75304);Ec=1;Fc=0;Gc=sA(Ac,na)|0}else{c[ka>>2]=Z;Ac=LA(zc,ka)|0;DL(la,75160);Ec=0;Fc=1;Gc=sA(o,sA(Ac,la)|0)|0}KL(yc,Gc)|0;if(Ec){JL(na)}if(Fc){JL(la)}JL(ja);JL(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=LA(Hc,oa)|0;DL(pa,75304);ja=sA(ha,pa)|0;c[qa>>2]=Z;ha=LA(Hc,qa)|0;DL(ra,75160);if(($A(o,sA(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=LA(Hc,ua)|0;DL(va,75304);Ic=1;Jc=0;Kc=sA(ha,va)|0}else{c[sa>>2]=Z;ha=LA(Hc,sa)|0;DL(ta,75160);Ic=0;Jc=1;Kc=sA(o,sA(ha,ta)|0)|0}KL(ja,Kc)|0;if(Ic){JL(va)}if(Jc){JL(ta)}JL(ra);JL(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=LA(X,wa)|0;DL(xa,75304);ra=sA(pa,xa)|0;c[ya>>2]=Z;pa=LA(X,ya)|0;DL(za,75160);if(($A(o,sA(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=LA(X,Ca)|0;DL(Da,75304);Lc=1;Mc=0;Nc=sA(pa,Da)|0}else{c[Aa>>2]=Z;pa=LA(X,Aa)|0;DL(Ba,75160);Lc=0;Mc=1;Nc=sA(o,sA(pa,Ba)|0)|0}KL(ra,Nc)|0;if(Lc){JL(Da)}if(Mc){JL(Ba)}JL(za);JL(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=LA(Z,Ea)|0;DL(Fa,75304);Ba=sA(za,Fa)|0;c[Ga>>2]=xa;za=LA(Z,Ga)|0;DL(Ha,75160);if(($A(o,sA(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=LA(Z,Ka)|0;DL(La,75304);Oc=1;Pc=0;Qc=sA(za,La)|0}else{c[Ia>>2]=xa;za=LA(Z,Ia)|0;DL(Ja,75160);Oc=0;Pc=1;Qc=sA(o,sA(za,Ja)|0)|0}KL(Ba,Qc)|0;if(Oc){JL(La)}if(Pc){JL(Ja)}JL(Ha);JL(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=LA(xa,Ma)|0;DL(Na,75304);Ja=sA(Ha,Na)|0;c[Oa>>2]=Fa;Ha=LA(xa,Oa)|0;DL(Pa,75160);if(($A(o,sA(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=LA(xa,Sa)|0;DL(Ta,75304);Rc=1;Sc=0;Tc=sA(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=LA(xa,Qa)|0;DL(Ra,75160);Rc=0;Sc=1;Tc=sA(o,sA(Ha,Ra)|0)|0}KL(Ja,Tc)|0;if(Rc){JL(Ta)}if(Sc){JL(Ra)}JL(Pa);JL(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=LA(Fa,Ua)|0;DL(Va,75304);Ra=sA(Pa,Va)|0;c[Wa>>2]=Na;Pa=LA(Fa,Wa)|0;DL(Xa,75160);if(($A(o,sA(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=LA(Fa,_a)|0;DL($a,75304);Uc=1;Vc=0;Wc=sA(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=LA(Fa,Ya)|0;DL(Za,75160);Uc=0;Vc=1;Wc=sA(o,sA(Pa,Za)|0)|0}KL(Ra,Wc)|0;if(Uc){JL($a)}if(Vc){JL(Za)}JL(Xa);JL(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=LA(Na,ab)|0;DL(bb,75304);Za=sA(Xa,bb)|0;c[cb>>2]=Va;Xa=LA(Na,cb)|0;DL(db,75160);if(($A(o,sA(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=LA(Na,gb)|0;DL(hb,75304);Xc=1;Yc=0;Zc=sA(Xa,hb)|0}else{c[eb>>2]=Va;Xa=LA(Na,eb)|0;DL(fb,75160);Xc=0;Yc=1;Zc=sA(o,sA(Xa,fb)|0)|0}KL(Za,Zc)|0;if(Xc){JL(hb)}if(Yc){JL(fb)}JL(db);JL(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=LA(Va,ib)|0;DL(jb,75304);fb=sA(db,jb)|0;c[kb>>2]=bb;db=LA(Va,kb)|0;DL(lb,75160);if(($A(o,sA(db,lb)|0)|0)==0){c[ob>>2]=bb;db=LA(Va,ob)|0;DL(pb,75304);_c=1;$c=0;ad=sA(db,pb)|0}else{c[mb>>2]=bb;db=LA(Va,mb)|0;DL(nb,75160);_c=0;$c=1;ad=sA(o,sA(db,nb)|0)|0}KL(fb,ad)|0;if(_c){JL(pb)}if($c){JL(nb)}JL(lb);JL(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=LA(bb,qb)|0;DL(rb,75304);nb=sA(lb,rb)|0;c[sb>>2]=jb;lb=LA(bb,sb)|0;DL(tb,75160);if(($A(o,sA(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=LA(bb,wb)|0;DL(xb,75304);bd=1;cd=0;dd=sA(lb,xb)|0}else{c[ub>>2]=jb;lb=LA(bb,ub)|0;DL(vb,75160);bd=0;cd=1;dd=sA(o,sA(lb,vb)|0)|0}KL(nb,dd)|0;if(bd){JL(xb)}if(cd){JL(vb)}JL(tb);JL(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=LA(jb,yb)|0;DL(zb,75304);vb=sA(tb,zb)|0;c[Ab>>2]=rb;tb=LA(jb,Ab)|0;DL(Bb,75160);if(($A(o,sA(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=LA(jb,Eb)|0;DL(Fb,75304);ed=1;fd=0;gd=sA(tb,Fb)|0}else{c[Cb>>2]=rb;tb=LA(jb,Cb)|0;DL(Db,75160);ed=0;fd=1;gd=sA(o,sA(tb,Db)|0)|0}KL(vb,gd)|0;if(ed){JL(Fb)}if(fd){JL(Db)}JL(Bb);JL(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=LA(rb,Gb)|0;DL(Hb,75304);Db=sA(Bb,Hb)|0;c[Ib>>2]=zb;Bb=LA(rb,Ib)|0;DL(Jb,75160);if(($A(o,sA(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=LA(rb,Mb)|0;DL(Nb,75304);hd=0;id=1;jd=sA(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=LA(rb,Kb)|0;DL(Lb,75160);hd=1;id=0;jd=sA(o,sA(Bb,Lb)|0)|0}KL(Db,jd)|0;if(id){JL(Nb)}if(hd){JL(Lb)}JL(Jb);JL(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=LA(zb,Ob)|0;DL(Pb,75304);Lb=sA(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=LA(zb,Qb)|0;DL(Rb,75160);if(($A(o,sA(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=LA(zb,Ub)|0;DL(Vb,75304);kd=1;ld=0;md=sA(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=LA(zb,Sb)|0;DL(Tb,75160);kd=0;ld=1;md=sA(o,sA(Jb,Tb)|0)|0}KL(Lb,md)|0;if(kd){JL(Vb)}if(ld){JL(Tb)}JL(Rb);JL(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=LA(b,Xb)|0;DL(Yb,75304);Pb=sA(Hb,Yb)|0;c[Zb>>2]=a;Hb=LA(b,Zb)|0;DL(_b,75160);if(($A(o,sA(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=LA(b,bc)|0;DL(cc,75304);nd=1;od=0;pd=sA(Hb,cc)|0}else{c[$b>>2]=a;Hb=LA(b,$b)|0;DL(ac,75160);nd=0;od=1;pd=sA(o,sA(Hb,ac)|0)|0}KL(Pb,pd)|0;if(nd){JL(cc)}if(od){JL(ac)}JL(_b);JL(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}tr(23,0,78264,h);JL(v);JL(u);aB(o);i=f;return}function LA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=qD(a,f,b)|0;l=c[k>>2]|0;cx(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}sD(j,a,b);tD(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];rD(g,e);uD(j);j=c[f>>2]|0;vD(a,j,k,wD(g)|0);k=xD(g)|0;uD(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function MA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=UB(a,f,b)|0;l=c[k>>2]|0;cx(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}WB(j,a,b);XB(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];VB(g,e);YB(j);j=c[f>>2]|0;ZB(a,j,k,_B(g)|0);k=$B(g)|0;YB(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function NA(a,b){a=a|0;b=b|0;var c=0;c=i;KL(b,a)|0;i=c;return}function OA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;LB(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];DB(a,f);i=e;return}function PA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BB(a,b)|0;i=c;return d|0}function QA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;EB(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];DB(a,e);i=d;return}function RA(a){a=a|0;var b=0,c=0;b=i;c=yB(a)|0;i=b;return c|0}function SA(a){a=a|0;var b=0;b=i;XF(a);i=b;return}function TA(a){a=a|0;var b=0;b=i;KF(a);i=b;return}function UA(a,b){a=a|0;b=b|0;b=i;rE(a,0);i=b;return}function VA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;GM(d);e=a;c[e>>2]=78332;f=d;c[f>>2]=78352;d=a+8|0;yN(a,78364|0,d);c[e>>2]=78332;c[f>>2]=78352;Lz(d);i=b;return}function WA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(kx(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){xM(d,4);i=e;return}else{vM(d,0);i=e;return}}function XA(a){a=a|0;var b=0,c=0;b=i;c=tB(a+8|0)|0;i=b;return c|0}function YA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=sB(a,b,EM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function ZA(a){a=a|0;var b=0;b=i;if((mx(a+8|0)|0)!=0){i=b;return}xM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function _A(a){a=a|0;var b=0;b=i;xB(a,78360);BM(a+108|0);i=b;return}function $A(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=bB(a,b)|0;i=c;return d|0}function aB(a){a=a|0;var b=0;b=i;zF(a);i=b;return}function bB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=dB(a)|0;cx(e);if((f|0)==0){g=0;i=d;return g|0}h=eB(a)|0;a=f;while(1){f=a+16|0;if(fB(h,b,f)|0){j=a}else{if(!(gB(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;cx(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function cB(a){a=a|0;var b=0,c=0;b=i;c=Pw(mB(a+4|0)|0)|0;i=b;return c|0}function dB(a){a=a|0;var b=0,d=0;b=i;d=c[(cB(a)|0)>>2]|0;i=b;return d|0}function eB(a){a=a|0;var b=0,c=0;b=i;c=kB(a+8|0)|0;i=b;return c|0}function fB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function gB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function hB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=iB(b,c)|0;i=a;return d|0}function iB(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(gM(a,b)|0)<0;i=c;return d|0}function jB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=lW(a,b,c)|0;i=d;return e|0}function kB(a){a=a|0;var b=0,c=0;b=i;c=lB(a)|0;i=b;return c|0}function lB(a){a=a|0;i=i;return a|0}function mB(a){a=a|0;var b=0,c=0;b=i;c=nB(a)|0;i=b;return c|0}function nB(a){a=a|0;i=i;return a|0}function oB(a,b){a=a|0;b=b|0;var c=0;a=i;c=qB(0,b,0)|0;i=a;return c|0}function pB(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function qB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=UV(b)|0;i=c;return a|0}function rB(a){a=a|0;var b=0,c=0;b=i;c=qW(a|0)|0;i=b;return c|0}function sB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;DN(f,a,1);if(!(GN(f)|0)){i=e;return a|0}ZL(b);f=0;while(1){g=MM(CM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(Yx(g,-1)|0){h=2;j=f;break}k=f+1|0;l=Zx(g)|0;if(by(l,d)|0){h=0;j=k;break}$L(b,l);if((HL(b)|0)==-17){h=4;j=k;break}else{f=k}}xM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function tB(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function uB(a){a=a|0;var b=0;b=i;_A(a);WV(a);i=b;return}function vB(a){a=a|0;var b=0;b=i;_A(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function wB(a){a=a|0;var b=0;b=i;uB(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function xB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Mx(a+8|0);i=d;return}function yB(a){a=a|0;var b=0,d=0;b=i;d=zB((c[a>>2]|0)+16|0)|0;i=b;return d|0}function zB(a){a=a|0;var b=0,c=0;b=i;c=AB(a)|0;i=b;return c|0}function AB(a){a=a|0;i=i;return a|0}function BB(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(CB(a,b)|0)^1;i=c;return d|0}function CB(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function DB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];KB(a,e);i=d;return}function EB(a,b){a=a|0;b=b|0;var c=0;c=i;FB(a,GB(b)|0);i=c;return}function FB(a,b){a=a|0;b=b|0;var c=0;c=i;JB(a,b);i=c;return}function GB(a){a=a|0;var b=0,c=0;b=i;c=Pw(HB(a+4|0)|0)|0;i=b;return c|0}function HB(a){a=a|0;var b=0,c=0;b=i;c=IB(a)|0;i=b;return c|0}function IB(a){a=a|0;i=i;return a|0}function JB(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function KB(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function LB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=NB(b)|0;MB(f,b,d,h,GB(b)|0);EB(g,b);do{if(BB(f,g)|0){h=OB(b)|0;if(PB(h,d,QB(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);EB(a,b);i=e;return}function MB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;cx(h);a:do{if((e|0)==0){j=f}else{k=OB(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(TB(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;cx(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;cx(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);FB(a,j);i=g;return}function NB(a){a=a|0;var b=0,d=0;b=i;d=c[(GB(a)|0)>>2]|0;i=b;return d|0}function OB(a){a=a|0;var b=0,c=0;b=i;c=RB(a+8|0)|0;i=b;return c|0}function PB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function QB(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function RB(a){a=a|0;var b=0,c=0;b=i;c=SB(a)|0;i=b;return c|0}function SB(a){a=a|0;i=i;return a|0}function TB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function UB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=NB(h)|0;cx(e);if((a|0)==0){j=GB(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(hB(0,d,a)|0){m=l;j=c[m>>2]|0;cx(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(hB(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;cx(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function VB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];QC(a,e);i=d;return}function WB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=vC(d)|0;d=xC(n,1)|0;yC(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];wC(j,d,h);zC(0,oC((AC(j)|0)+16|0)|0,e);e=BC(j)|0;a[e+4|0]=1;CC(0,mC((AC(j)|0)+28|0)|0);a[e+5|0]=1;DC(m,j);XB(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];VB(b,g);YB(m);YB(j);i=f;return}function XB(a,b){a=a|0;b=b|0;var c=0;c=i;tC(a,b);i=c;return}function YB(a){a=a|0;var b=0;b=i;iC(a);i=b;return}function ZB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;cx(f);c[e>>2]=0;cx(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=eC(a)|0;b=c[c[e>>2]>>2]|0;cx(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(GB(a)|0)>>2]|0;Oy(e,c[d>>2]|0);d=fC(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function _B(a){a=a|0;var b=0,d=0;b=i;d=c[(cC(a)|0)>>2]|0;i=b;return d|0}function $B(a){a=a|0;var b=0,d=0;b=i;d=aC(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function aC(a){a=a|0;var b=0,c=0;b=i;c=bC(a)|0;i=b;return c|0}function bC(a){a=a|0;i=i;return a|0}function cC(a){a=a|0;var b=0,c=0;b=i;c=dC(a)|0;i=b;return c|0}function dC(a){a=a|0;i=i;return a|0}function eC(a){a=a|0;i=i;return a|0}function fC(a){a=a|0;var b=0,c=0;b=i;c=gC(a+8|0)|0;i=b;return c|0}function gC(a){a=a|0;var b=0,c=0;b=i;c=hC(a)|0;i=b;return c|0}function hC(a){a=a|0;i=i;return a|0}function iC(a){a=a|0;var b=0;b=i;jC(a,0);i=b;return}function jC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=aC(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}lC(kC(e)|0,f);i=d;return}function kC(a){a=a|0;var b=0,c=0;b=i;c=sC(a)|0;i=b;return c|0}function lC(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;nC(f,oC(d+16|0)|0)}if((d|0)==0){i=e;return}pC(c[b>>2]|0,d,1);i=e;return}function mC(a){a=a|0;i=i;return a|0}function nC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;rC(d,0,c);i=b;return}function oC(a){a=a|0;i=i;return a|0}function pC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;qC(0,b,0);i=c;return}function qC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;WV(b);i=c;return}function rC(a,b,c){a=a|0;b=b|0;c=c|0;b=i;JL(c);i=b;return}function sC(a){a=a|0;i=i;return a+4|0}function tC(a,b){a=a|0;b=b|0;var c=0;c=i;uC(a,b);i=c;return}function uC(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function vC(a){a=a|0;var b=0,c=0;b=i;c=OC(a+4|0)|0;i=b;return c|0}function wC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];GC(a,b,f);i=e;return}function xC(a,b){a=a|0;b=b|0;var c=0;a=i;c=FC(0,b,0)|0;i=a;return c|0}function yC(a,b){a=a|0;b=b|0;var c=0;c=i;EC(a,b);i=c;return}function zC(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}zL(b,c);i=a;return}function AC(a){a=a|0;var b=0,d=0;b=i;d=c[(cC(a)|0)>>2]|0;i=b;return d|0}function BC(a){a=a|0;var b=0,c=0;b=i;c=kC(a)|0;i=b;return c|0}function CC(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function DC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;tC(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];VB(h,f);XB(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];VB(a,e);YB(h);i=d;return}function EC(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function FC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=UV(b<<5)|0;i=c;return a|0}function GC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(IC(g)|0)>>2]|0;g=JC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];HC(b,a,f);i=e;return}function HC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];KC(a,b,f);i=e;return}function IC(a){a=a|0;i=i;return a|0}function JC(a){a=a|0;i=i;return a|0}function KC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(MC(g)|0)>>2]|0;g=NC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];LC(b,a,f);i=e;return}function LC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(MC(f)|0)>>2];f=NC(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function MC(a){a=a|0;i=i;return a|0}function NC(a){a=a|0;i=i;return a|0}function OC(a){a=a|0;var b=0,c=0;b=i;c=PC(a)|0;i=b;return c|0}function PC(a){a=a|0;i=i;return a|0}function QC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=$B(RC(b)|0)|0;h=NC(BC(RC(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];HC(g,a,e);i=d;return}function RC(a){a=a|0;i=i;return c[a>>2]|0}function SC(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function TC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];_C(a,e);i=d;return}function UC(a,b){a=a|0;b=b|0;var c=0;c=i;VC(a,WC(b)|0);i=c;return}function VC(a,b){a=a|0;b=b|0;var c=0;c=i;ZC(a,b);i=c;return}function WC(a){a=a|0;var b=0,c=0;b=i;c=Pw(XC(a+4|0)|0)|0;i=b;return c|0}function XC(a){a=a|0;var b=0,c=0;b=i;c=YC(a)|0;i=b;return c|0}function YC(a){a=a|0;i=i;return a|0}function ZC(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function _C(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function $C(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=bD(b)|0;aD(f,b,d,h,WC(b)|0);UC(g,b);do{if(cD(f,g)|0){h=dD(b)|0;if(fB(h,d,eD(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);UC(a,b);i=e;return}function aD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;cx(h);a:do{if((e|0)==0){j=f}else{k=dD(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(gB(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;cx(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;cx(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);VC(a,j);i=g;return}function bD(a){a=a|0;var b=0,d=0;b=i;d=c[(WC(a)|0)>>2]|0;i=b;return d|0}function cD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(SC(a,b)|0)^1;i=c;return d|0}function dD(a){a=a|0;var b=0,c=0;b=i;c=fD(a+8|0)|0;i=b;return c|0}function eD(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function fD(a){a=a|0;var b=0,c=0;b=i;c=gD(a)|0;i=b;return c|0}function gD(a){a=a|0;i=i;return a|0}function hD(a,b){a=a|0;b=b|0;b=i;i=i+8|0;iD(a,b);i=b;return}function iD(a,b){a=a|0;b=b|0;b=i;jD(a,0);i=b;return}function jD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;kD(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;lD(f,0,e);e=GB(b)|0;c[(eC(b)|0)>>2]=e;i=d;return}function kD(a){a=a|0;var b=0;b=i;oD(a);i=b;return}function lD(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;mD(b,c,f);i=e;return}function mD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Gz(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;nD(d,b,f);i=e;return}function nD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Gz(e)|0)>>2];i=d;return}function oD(a){a=a|0;var b=0;b=i;pD(a);i=b;return}function pD(a){a=a|0;var b=0;b=i;Jz(a);i=b;return}function qD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=qE(h)|0;cx(e);if((a|0)==0){j=DD(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if($w(0,d,a)|0){m=l;j=c[m>>2]|0;cx(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!($w(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;cx(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function rD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];oE(a,e);i=d;return}function sD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=VD(d)|0;d=XD(n,1)|0;YD(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];WD(j,d,h);ZD(0,_y((_D(j)|0)+16|0)|0,e);e=$D(j)|0;a[e+4|0]=1;aE(0,OD((_D(j)|0)+20|0)|0);a[e+5|0]=1;bE(m,j);tD(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];rD(b,g);uD(m);uD(j);i=f;return}function tD(a,b){a=a|0;b=b|0;var c=0;c=i;TD(a,b);i=c;return}function uD(a){a=a|0;var b=0;b=i;JD(a);i=b;return}function vD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;cx(f);c[e>>2]=0;cx(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=CD(a)|0;b=c[c[e>>2]>>2]|0;cx(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(DD(a)|0)>>2]|0;Oy(e,c[d>>2]|0);d=ED(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function wD(a){a=a|0;var b=0,d=0;b=i;d=c[(AD(a)|0)>>2]|0;i=b;return d|0}function xD(a){a=a|0;var b=0,d=0;b=i;d=yD(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function yD(a){a=a|0;var b=0,c=0;b=i;c=zD(a)|0;i=b;return c|0}function zD(a){a=a|0;i=i;return a|0}function AD(a){a=a|0;var b=0,c=0;b=i;c=BD(a)|0;i=b;return c|0}function BD(a){a=a|0;i=i;return a|0}function CD(a){a=a|0;i=i;return a|0}function DD(a){a=a|0;var b=0,c=0;b=i;c=Pw(HD(a+4|0)|0)|0;i=b;return c|0}function ED(a){a=a|0;var b=0,c=0;b=i;c=FD(a+8|0)|0;i=b;return c|0}function FD(a){a=a|0;var b=0,c=0;b=i;c=GD(a)|0;i=b;return c|0}function GD(a){a=a|0;i=i;return a|0}function HD(a){a=a|0;var b=0,c=0;b=i;c=ID(a)|0;i=b;return c|0}function ID(a){a=a|0;i=i;return a|0}function JD(a){a=a|0;var b=0;b=i;KD(a,0);i=b;return}function KD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=yD(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}MD(LD(e)|0,f);i=d;return}function LD(a){a=a|0;var b=0,c=0;b=i;c=SD(a)|0;i=b;return c|0}function MD(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;ND(f,OD(d+20|0)|0)}if((d|0)==0){i=e;return}PD(c[b>>2]|0,d,1);i=e;return}function ND(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;RD(d,0,c);i=b;return}function OD(a){a=a|0;i=i;return a|0}function PD(a,b,c){a=a|0;b=b|0;c=c|0;c=i;QD(0,b,0);i=c;return}function QD(a,b,c){a=a|0;b=b|0;c=c|0;c=i;WV(b);i=c;return}function RD(a,b,c){a=a|0;b=b|0;c=c|0;b=i;aB(c);i=b;return}function SD(a){a=a|0;i=i;return a+4|0}function TD(a,b){a=a|0;b=b|0;var c=0;c=i;UD(a,b);i=c;return}function UD(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function VD(a){a=a|0;var b=0,c=0;b=i;c=mE(a+4|0)|0;i=b;return c|0}function WD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];eE(a,b,f);i=e;return}function XD(a,b){a=a|0;b=b|0;var c=0;a=i;c=dE(0,b,0)|0;i=a;return c|0}function YD(a,b){a=a|0;b=b|0;var c=0;c=i;cE(a,b);i=c;return}function ZD(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function _D(a){a=a|0;var b=0,d=0;b=i;d=c[(AD(a)|0)>>2]|0;i=b;return d|0}function $D(a){a=a|0;var b=0,c=0;b=i;c=LD(a)|0;i=b;return c|0}function aE(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}UA(b,a);i=a;return}function bE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;TD(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];rD(h,f);tD(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];rD(a,e);uD(h);i=d;return}function cE(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function dE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=UV(b<<5)|0;i=c;return a|0}function eE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(gE(g)|0)>>2]|0;g=hE(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];fE(b,a,f);i=e;return}function fE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];iE(a,b,f);i=e;return}function gE(a){a=a|0;i=i;return a|0}function hE(a){a=a|0;i=i;return a|0}function iE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(kE(g)|0)>>2]|0;g=lE(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];jE(b,a,f);i=e;return}function jE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(kE(f)|0)>>2];f=lE(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function kE(a){a=a|0;i=i;return a|0}function lE(a){a=a|0;i=i;return a|0}function mE(a){a=a|0;var b=0,c=0;b=i;c=nE(a)|0;i=b;return c|0}function nE(a){a=a|0;i=i;return a|0}function oE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=xD(pE(b)|0)|0;h=lE($D(pE(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];fE(g,a,e);i=d;return}function pE(a){a=a|0;i=i;return c[a>>2]|0}function qE(a){a=a|0;var b=0,d=0;b=i;d=c[(DD(a)|0)>>2]|0;i=b;return d|0}function rE(a,b){a=a|0;b=b|0;b=i;i=i+8|0;sE(a,b);i=b;return}function sE(a,b){a=a|0;b=b|0;b=i;tE(a,0);i=b;return}function tE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;uE(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;vE(f,0,e);e=WC(b)|0;c[(wE(b)|0)>>2]=e;i=d;return}function uE(a){a=a|0;var b=0;b=i;zE(a);i=b;return}function vE(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;xE(b,c,f);i=e;return}function wE(a){a=a|0;i=i;return a|0}function xE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Gz(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;yE(d,b,f);i=e;return}function yE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Gz(e)|0)>>2];i=d;return}function zE(a){a=a|0;var b=0;b=i;AE(a);i=b;return}function AE(a){a=a|0;var b=0;b=i;Jz(a);i=b;return}function BE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=bD(h)|0;cx(e);if((a|0)==0){j=WC(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(hB(0,d,a)|0){m=l;j=c[m>>2]|0;cx(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(hB(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;cx(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function CE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];xF(a,e);i=d;return}function DE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=cF(d)|0;d=eF(n,1)|0;fF(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];dF(j,d,h);gF(0,oC((hF(j)|0)+16|0)|0,e);e=iF(j)|0;a[e+4|0]=1;jF(0,VE((hF(j)|0)+28|0)|0);a[e+5|0]=1;kF(m,j);EE(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];CE(b,g);FE(m);FE(j);i=f;return}function EE(a,b){a=a|0;b=b|0;var c=0;c=i;aF(a,b);i=c;return}function FE(a){a=a|0;var b=0;b=i;QE(a);i=b;return}function GE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;cx(f);c[e>>2]=0;cx(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=wE(a)|0;b=c[c[e>>2]>>2]|0;cx(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(WC(a)|0)>>2]|0;Oy(e,c[d>>2]|0);d=NE(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function HE(a){a=a|0;var b=0,d=0;b=i;d=c[(LE(a)|0)>>2]|0;i=b;return d|0}function IE(a){a=a|0;var b=0,d=0;b=i;d=JE(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function JE(a){a=a|0;var b=0,c=0;b=i;c=KE(a)|0;i=b;return c|0}function KE(a){a=a|0;i=i;return a|0}function LE(a){a=a|0;var b=0,c=0;b=i;c=ME(a)|0;i=b;return c|0}function ME(a){a=a|0;i=i;return a|0}function NE(a){a=a|0;var b=0,c=0;b=i;c=OE(a+8|0)|0;i=b;return c|0}function OE(a){a=a|0;var b=0,c=0;b=i;c=PE(a)|0;i=b;return c|0}function PE(a){a=a|0;i=i;return a|0}function QE(a){a=a|0;var b=0;b=i;RE(a,0);i=b;return}function RE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=JE(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}TE(SE(e)|0,f);i=d;return}function SE(a){a=a|0;var b=0,c=0;b=i;c=$E(a)|0;i=b;return c|0}function TE(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;UE(f,VE(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;WE(f,oC(d+16|0)|0)}if((d|0)==0){i=e;return}XE(c[b>>2]|0,d,1);i=e;return}function UE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;_E(d,0,c);i=b;return}function VE(a){a=a|0;i=i;return a|0}function WE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;ZE(d,0,c);i=b;return}function XE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;YE(0,b,0);i=c;return}function YE(a,b,c){a=a|0;b=b|0;c=c|0;c=i;WV(b);i=c;return}function ZE(a,b,c){a=a|0;b=b|0;c=c|0;b=i;JL(c);i=b;return}function _E(a,b,c){a=a|0;b=b|0;c=c|0;b=i;JL(c);i=b;return}function $E(a){a=a|0;i=i;return a+4|0}function aF(a,b){a=a|0;b=b|0;var c=0;c=i;bF(a,b);i=c;return}function bF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cF(a){a=a|0;var b=0,c=0;b=i;c=vF(a+4|0)|0;i=b;return c|0}function dF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];nF(a,b,f);i=e;return}function eF(a,b){a=a|0;b=b|0;var c=0;a=i;c=mF(0,b,0)|0;i=a;return c|0}function fF(a,b){a=a|0;b=b|0;var c=0;c=i;lF(a,b);i=c;return}function gF(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}zL(b,c);i=a;return}function hF(a){a=a|0;var b=0,d=0;b=i;d=c[(LE(a)|0)>>2]|0;i=b;return d|0}function iF(a){a=a|0;var b=0,c=0;b=i;c=SE(a)|0;i=b;return c|0}function jF(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}xL(b);i=a;return}function kF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;aF(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];CE(h,f);EE(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];CE(a,e);FE(h);i=d;return}function lF(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function mF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=UV(b*40|0)|0;i=c;return a|0}function nF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pF(g)|0)>>2]|0;g=qF(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];oF(b,a,f);i=e;return}function oF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];rF(a,b,f);i=e;return}function pF(a){a=a|0;i=i;return a|0}function qF(a){a=a|0;i=i;return a|0}function rF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(tF(g)|0)>>2]|0;g=uF(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];sF(b,a,f);i=e;return}function sF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(tF(f)|0)>>2];f=uF(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function tF(a){a=a|0;i=i;return a|0}function uF(a){a=a|0;i=i;return a|0}function vF(a){a=a|0;var b=0,c=0;b=i;c=wF(a)|0;i=b;return c|0}function wF(a){a=a|0;i=i;return a|0}function xF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=IE(yF(b)|0)|0;h=uF(iF(yF(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];oF(g,a,e);i=d;return}function yF(a){a=a|0;i=i;return c[a>>2]|0}function zF(a){a=a|0;var b=0;b=i;AF(a);i=b;return}function AF(a){a=a|0;var b=0;b=i;BF(a);i=b;return}function BF(a){a=a|0;var b=0;b=i;CF(a,bD(a)|0);i=b;return}function CF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;cx(d);if((b|0)==0){i=d;return}CF(a,c[b>>2]|0);CF(a,c[b+4>>2]|0);e=cF(a)|0;DF(e,EF(b+16|0)|0);XE(e,b,1);i=d;return}function DF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;FF(d,0,c);i=b;return}function EF(a){a=a|0;i=i;return a|0}function FF(a,b,c){a=a|0;b=b|0;c=c|0;b=i;GF(c);i=b;return}function GF(a){a=a|0;var b=0;b=i;HF(a);i=b;return}function HF(a){a=a|0;var b=0;b=i;IF(a);i=b;return}function IF(a){a=a|0;var b=0;b=i;JF(a);i=b;return}function JF(a){a=a|0;var b=0;b=i;JL(a+12|0);JL(a);i=b;return}function KF(a){a=a|0;var b=0;b=i;LF(a+180|0);LF(a+168|0);LF(a+156|0);LF(a+144|0);LF(a+132|0);LF(a+120|0);LF(a+108|0);LF(a+96|0);LF(a+84|0);LF(a+72|0);LF(a+60|0);LF(a+48|0);LF(a+36|0);LF(a+24|0);aB(a+12|0);aB(a);i=b;return}function LF(a){a=a|0;var b=0;b=i;MF(a);i=b;return}function MF(a){a=a|0;var b=0;b=i;NF(a);i=b;return}function NF(a){a=a|0;var b=0;b=i;OF(a);i=b;return}function OF(a){a=a|0;var b=0;b=i;PF(a,qE(a)|0);i=b;return}function PF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;cx(d);if((b|0)==0){i=d;return}PF(a,c[b>>2]|0);PF(a,c[b+4>>2]|0);e=VD(a)|0;QF(e,RF(b+16|0)|0);PD(e,b,1);i=d;return}function QF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;SF(d,0,c);i=b;return}function RF(a){a=a|0;i=i;return a|0}function SF(a,b,c){a=a|0;b=b|0;c=c|0;b=i;TF(c);i=b;return}function TF(a){a=a|0;var b=0;b=i;UF(a);i=b;return}function UF(a){a=a|0;var b=0;b=i;VF(a);i=b;return}function VF(a){a=a|0;var b=0;b=i;WF(a);i=b;return}function WF(a){a=a|0;var b=0;b=i;aB(a+4|0);i=b;return}function XF(a){a=a|0;var b=0;b=i;YF(a);i=b;return}function YF(a){a=a|0;var b=0;b=i;ZF(a);i=b;return}function ZF(a){a=a|0;var b=0;b=i;_F(a,NB(a)|0);i=b;return}function _F(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;cx(d);if((b|0)==0){i=d;return}_F(a,c[b>>2]|0);_F(a,c[b+4>>2]|0);e=vC(a)|0;$F(e,AB(b+16|0)|0);pC(e,b,1);i=d;return}function $F(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;aG(d,0,c);i=b;return}function aG(a,b,c){a=a|0;b=b|0;c=c|0;b=i;bG(c);i=b;return}function bG(a){a=a|0;var b=0;b=i;cG(a);i=b;return}function cG(a){a=a|0;var b=0;b=i;dG(a);i=b;return}function dG(a){a=a|0;var b=0;b=i;eG(a);i=b;return}function eG(a){a=a|0;var b=0;b=i;JL(a);i=b;return}function fG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;gG(a);iG(g,b);jG(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];hG(a,f,e);i=d;return a|0}function gG(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;CF(a,bD(a)|0);c[(NE(a)|0)>>2]=0;d=WC(a)|0;c[(wE(a)|0)>>2]=d;cx(b);c[d>>2]=0;i=b;return}function hG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;rG(h,a);if(!(sG(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];kG(j,g);o=uG(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];tG(l,a,f,o);vG(b)|0;}while(sG(b,d)|0);i=e;return}function iG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;pG(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];kG(a,e);i=d;return}function jG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;lG(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];kG(a,e);i=d;return}function kG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];oG(a,e);i=d;return}function lG(a,b){a=a|0;b=b|0;var c=0;c=i;mG(a,cB(b)|0);i=c;return}function mG(a,b){a=a|0;b=b|0;var c=0;c=i;nG(a,b);i=c;return}function nG(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function oG(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function pG(a,b){a=a|0;b=b|0;var d=0;d=i;mG(a,c[(qG(b)|0)>>2]|0);i=d;return}function qG(a){a=a|0;i=i;return a|0}function rG(a,b){a=a|0;b=b|0;var c=0;c=i;jG(a,b);i=c;return}function sG(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=BH(a,b)|0;i=c;return d|0}function tG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];DG(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];CG(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];TC(a,g);GF(l);i=f;return}function uG(a){a=a|0;var b=0,c=0;b=i;c=zG(a)|0;i=b;return c|0}function vG(a){a=a|0;var b=0;b=i;wG(a)|0;i=b;return a|0}function wG(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=xG(c[d>>2]|0)|0;i=b;return a|0}function xG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;cx(b);if((e|0)==0){e=a;while(1){a=Sy(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=yG(c[d>>2]|0)|0;i=b;return g|0}return 0}function yG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;cx(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;cx(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function zG(a){a=a|0;var b=0,d=0;b=i;d=AG((c[a>>2]|0)+16|0)|0;i=b;return d|0}function AG(a){a=a|0;var b=0,c=0;b=i;c=BG(a)|0;i=b;return c|0}function BG(a){a=a|0;i=i;return a|0}function CG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=HG(b,h,j,e)|0;h=c[p>>2]|0;cx(l);if((h|0)!=0){q=h;VC(a,q);i=f;return}JG(o,b,e);KG(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];IG(m,g);LG(o);o=c[j>>2]|0;GE(b,o,p,MG(m)|0);p=NG(m)|0;LG(m);q=p;VC(a,q);i=f;return}function DG(a,b){a=a|0;b=b|0;var c=0;c=i;EG(a,b);i=c;return}function EG(a,b){a=a|0;b=b|0;var c=0;c=i;FG(a,b);i=c;return}function FG(a,b){a=a|0;b=b|0;var c=0;c=i;GG(a,b);i=c;return}function GG(a,b){a=a|0;b=b|0;var c=0;c=i;zL(a,b);zL(a+12|0,b+12|0);i=c;return}function HG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;UC(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];pH(l,k);do{if(!(oH(b,l)|0)){k=dD(a)|0;x=rH(b)|0;if(qH(k,e,x)|0){break}w=qH(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];vH(r,h,1,0);UC(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];pH(t,g);do{if(!(oH(r,t)|0)){if(qH(k,e,rH(r)|0)|0){break}y=uH(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;cx(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;sH(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];pH(o,j);do{if(!(oH(n,o)|0)){j=dD(a)|0;if(qH(j,rH(tH(n)|0)|0,e)|0){break}y=uH(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;cx(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function IG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];mH(a,e);i=d;return}function JG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=cF(d)|0;d=eF(n,1)|0;_G(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];ZG(j,d,h);$G(0,EF((aH(j)|0)+16|0)|0,e);a[(bH(j)|0)+4|0]=1;cH(m,j);KG(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];IG(b,g);LG(m);LG(j);i=f;return}function KG(a,b){a=a|0;b=b|0;var c=0;c=i;XG(a,b);i=c;return}function LG(a){a=a|0;var b=0;b=i;SG(a);i=b;return}function MG(a){a=a|0;var b=0,d=0;b=i;d=c[(QG(a)|0)>>2]|0;i=b;return d|0}function NG(a){a=a|0;var b=0,d=0;b=i;d=OG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function OG(a){a=a|0;var b=0,c=0;b=i;c=PG(a)|0;i=b;return c|0}function PG(a){a=a|0;i=i;return a|0}function QG(a){a=a|0;var b=0,c=0;b=i;c=RG(a)|0;i=b;return c|0}function RG(a){a=a|0;i=i;return a|0}function SG(a){a=a|0;var b=0;b=i;TG(a,0);i=b;return}function TG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=OG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}VG(UG(e)|0,f);i=d;return}function UG(a){a=a|0;var b=0,c=0;b=i;c=WG(a)|0;i=b;return c|0}function VG(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;DF(f,EF(d+16|0)|0)}if((d|0)==0){i=e;return}XE(c[b>>2]|0,d,1);i=e;return}function WG(a){a=a|0;i=i;return a+4|0}function XG(a,b){a=a|0;b=b|0;var c=0;c=i;YG(a,b);i=c;return}function YG(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function ZG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];gH(a,b,f);i=e;return}function _G(a,b){a=a|0;b=b|0;var c=0;c=i;fH(a,b);i=c;return}function $G(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}dH(b,c);i=a;return}function aH(a){a=a|0;var b=0,d=0;b=i;d=c[(QG(a)|0)>>2]|0;i=b;return d|0}function bH(a){a=a|0;var b=0,c=0;b=i;c=UG(a)|0;i=b;return c|0}function cH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;XG(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];IG(h,f);KG(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];IG(a,e);LG(h);i=d;return}function dH(a,b){a=a|0;b=b|0;var c=0;c=i;eH(a,b);i=c;return}function eH(a,b){a=a|0;b=b|0;var c=0;c=i;FG(a,b);i=c;return}function fH(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function gH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pF(g)|0)>>2]|0;g=iH(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];hH(b,a,f);i=e;return}function hH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];jH(a,b,f);i=e;return}function iH(a){a=a|0;i=i;return a|0}function jH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(tF(g)|0)>>2]|0;g=lH(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];kH(b,a,f);i=e;return}function kH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(tF(f)|0)>>2];f=lH(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function lH(a){a=a|0;i=i;return a|0}function mH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=NG(nH(b)|0)|0;h=lH(bH(nH(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];hH(g,a,e);i=d;return}function nH(a){a=a|0;i=i;return c[a>>2]|0}function oH(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function pH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];AH(a,e);i=d;return}function qH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=hB(0,b,c)|0;i=a;return d|0}function rH(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function sH(a,b){a=a|0;b=b|0;var d=0;d=i;VC(a,c[(wE(b)|0)>>2]|0);i=d;return}function tH(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=yH(c[d>>2]|0)|0;i=b;return a|0}function uH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=bD(a)|0;cx(e);if((h|0)==0){j=WC(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=dD(a)|0;a=h;while(1){h=a+16|0;if(qH(j,d,h)|0){l=a;m=c[l>>2]|0;cx(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(qH(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;cx(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function vH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;wH(b,d);c[a>>2]=c[b>>2];i=e;return}function wH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;xH(b,c,e);i=d;return}function xH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{tH(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{wG(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function yH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;cx(b);if((e|0)==0){e=a;while(1){a=Sy(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=zH(c[d>>2]|0)|0;i=b;return g|0}return 0}function zH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;cx(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;cx(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function AH(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function BH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(oH(a,b)|0)^1;i=c;return d|0}function CH(a){a=a|0;var b=0;b=i;i=i+128|0;UA(a,b);UA(a+12|0,b+8|0);DH(a+24|0,b+16|0);DH(a+36|0,b+24|0);DH(a+48|0,b+32|0);DH(a+60|0,b+40|0);DH(a+72|0,b+48|0);DH(a+84|0,b+56|0);DH(a+96|0,b+64|0);DH(a+108|0,b+72|0);DH(a+120|0,b+80|0);DH(a+132|0,b+88|0);DH(a+144|0,b+96|0);DH(a+156|0,b+104|0);DH(a+168|0,b+112|0);DH(a+180|0,b+120|0);i=b;return}function DH(a,b){a=a|0;b=b|0;b=i;EH(a,0);i=b;return}function EH(a,b){a=a|0;b=b|0;b=i;i=i+8|0;FH(a,b);i=b;return}function FH(a,b){a=a|0;b=b|0;b=i;GH(a,0);i=b;return}function GH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;HH(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;IH(f,0,e);e=DD(b)|0;c[(CD(b)|0)>>2]=e;i=d;return}function HH(a){a=a|0;var b=0;b=i;LH(a);i=b;return}function IH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;JH(b,c,f);i=e;return}function JH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Gz(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;KH(d,b,f);i=e;return}function KH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Gz(e)|0)>>2];i=d;return}function LH(a){a=a|0;var b=0;b=i;MH(a);i=b;return}function MH(a){a=a|0;var b=0;b=i;Jz(a);i=b;return}function NH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[88732>>2]|0;if((m|0)==0){n=0}else{o=UV(12)|0;DL(o,m);n=o}if((c[88648>>2]|0)!=0){c[7964]=1}if((n|0)==0){c[31868>>2]=1;c[31872>>2]=1;i=b;return}do{if((fM(n,78936,0)|0)==-1){zL(g,n);xL(h);o=c[7538]|0;m=(o|0)<28;while(1){p=fM(g,78944,0)|0;q=(p|0)!=-1;if(q){dM(j,g,0,p);KL(h,j)|0;JL(j);dM(k,g,p+1|0,-1);KL(g,k)|0;JL(k)}else{KL(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){DL(l,c[30568+(s<<2)>>2]|0);p=OH(h,l)|0;JL(l);if(p){c[31864+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){vr(1,1,78952,f);if(m){v=o}else{w=32416;x=c[8104]|0;ee[x&255](1);y=eM(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=78992;E=D;xr(0,E,a)}do{p=c[31736+(v<<2)>>2]|0;c[e>>2]=c[30568+(v<<2)>>2];c[e+4>>2]=p;vr(1,0,78976,e);v=v+1|0;}while((v|0)<28);w=32416;x=c[8104]|0;ee[x&255](1);y=eM(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=78992;E=D;xr(0,E,a)}else if((t|0)==20){vr(1,1,78952,d);w=32416;x=c[8104]|0;ee[x&255](1);y=eM(n)|0;z=a;A=z;c[A>>2]=y;B=4;C=B;D=78992;E=D;xr(0,E,a)}else if((t|0)==23){JL(h);JL(g);break}}else{o=1;do{c[31864+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[31868>>2]=1;c[31872>>2]=1;if((c[31900>>2]|0)!=0){c[31960>>2]=1}if((c[31956>>2]|0)==1){c[31964>>2]=1}if((c[31936>>2]|0)!=0){c[31932>>2]=1}if((c[31944>>2]|0)!=0){c[31932>>2]=1}if((c[31896>>2]|0)!=0){c[31892>>2]=1}if((c[31940>>2]|0)!=0){c[31932>>2]=1}if((c[31888>>2]|0)!=0){c[31884>>2]=1}JL(n);WV(n);i=b;return}function OH(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=HL(b)|0;if((e|0)!=(HL(c)|0)){f=0;i=d;return f|0}g=IL(b)|0;h=IL(c)|0;if(AL(b)|0){f=(jB(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function PH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[88740>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=UV(12)|0;l=k;DL(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(QH(l,c[64032+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=eM(l)|0;vr(1,1,79024,g);g=c[64116>>2]|0;c[f>>2]=c[64036>>2];c[f+4>>2]=g;vr(1,0,78976,f);f=c[64120>>2]|0;c[e>>2]=c[64040>>2];c[e+4>>2]=f;vr(1,0,78976,e);e=c[64124>>2]|0;c[d>>2]=c[64044>>2];c[d+4>>2]=e;vr(1,0,78976,d);ee[c[8104]&255](1);xr(0,79080,a)}else if((n|0)==6){i=b;return j|0}return 0}function QH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(hM(a,b)|0)==0;i=c;return d|0}function RH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[88724>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=UV(12)|0;l=k;DL(l,h);if((k|0)==0){j=1;i=b;return j|0}DL(f,79104);k=OH(l,f)|0;JL(f);if(k){j=1;i=b;return j|0}DL(g,79112);k=OH(l,g)|0;JL(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=eM(l)|0;vr(1,1,79120,e);c[d>>2]=79104;c[d+4>>2]=79176;vr(1,0,78976,d);c[a>>2]=79112;c[a+4>>2]=79192;vr(1,0,78976,a);ee[c[8104]&255](1);xr(0,79080,b)}return 0}function SH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;SN(f,a);if(!(VN(f)|0)){TN(f);i=d;return a|0}j=rB(b)|0;dI(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((gx(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=DM(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];gI(h,e,b,m,k,l,n);if(!(eI(h)|0)){TN(f);i=d;return a|0}xM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);TN(f);i=d;return a|0}function TH(a){a=a|0;var b=0;b=i;YN(a,EM(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;FN(a)|0;i=b;return a|0}function UH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;DL(h,d);sM(k,79200,h);EA(j,k,79208);JL(k);k=eM(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((mW(c[n+4>>2]|0,79216)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((mW(k,79224)|0)==0){JL(j);JL(h);i=f;return}d=WU(g,k,1)|0;if((d|0)!=0){m=l;uW(m|0,0,2048)|0;hV(d,g,m,2048)|0;WN(SH(SH(SH(SH(SH(101128,79232)|0,k)|0,79272)|0,m)|0,79288)|0,103)|0;JL(j);JL(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(iV(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(iV(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(iV(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(iV(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==1){q=(iV(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(iV(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){p=b+8|0;s=m;m=0;while(1){l=c[p>>2]|0;if((a[l+(m*48|0)+44|0]|0)==0){k=(iV(g,c[l+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(m*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=m+1|0;if((k|0)<(t|0)){s=t;m=k}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;p=b+24|0;k=0;do{l=c[t>>2]|0;do{if((a[l+(k*52|0)+48|0]|0)==0){d=a[l+(k*52|0)+8|0]|0;if(d<<24>>24==1){n=(iV(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[p>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(iV(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[d+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[m>>2]|0))}m=b+124|0;k=c[m>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){p=c[s>>2]|0;if((a[p+(k*52|0)+48|0]|0)==0){o=(iV(g,c[p+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==1){p=(iV(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=p;p=c[u>>2]|0;if((a[p+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[p+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(iV(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}_U(g);JL(j);JL(h);i=f;return}function VH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[88588>>2]|0;H=c[88716>>2]|0;I=c[2]|0;if((c[31964>>2]|0)==0){if(!((c[88536>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;tr(23,0,79336,l);l=c[88660>>2]|0;do{if((l|0)==0){M=0}else{if((mW(l,79360)|0)==0){M=1;break}if((mW(l,79368)|0)==0){M=0;break}if((mW(l,79376)|0)==0){M=2;break}c[j>>2]=l;vr(1,0,79384,j);M=0}}while(0);if((Hs(M)|0)!=0){c[g>>2]=l;vr(1,0,79456,g)}if((c[2]|0)!=0){bJ(d+56|0);Ms((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Is(0);Is(6);Js(3);Js(4);Js(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+iW(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];tr(1,0,79544,f)}do{if((c[88644>>2]|0)!=0){f=UV(12)|0;J=f;DL(J,c[88772>>2]|0);if((f|0)==0){break}f=eM(J)|0;c[d+280>>2]=f;c[e>>2]=f;tr(23,0,79600,e)}}while(0);e=c[88768>>2]|0;xL(m);if((e|0)==0){DL(p,c[d+88>>2]|0);DL(q,79648);WH(o,p,q);EA(n,o,c[d+284>>2]|0);KL(m,n)|0;JL(n);JL(o);JL(q);JL(p)}else{LL(m,e)|0}DL(r,79656);DL(s,79656);DL(t,79656);DL(u,79656);DL(v,79656);DL(w,79656);e=c[88536>>2]|0;if((c[88556>>2]|0)!=0){LL(r,c[88684>>2]|0)|0}if((c[88572>>2]|0)!=0){LL(s,c[88700>>2]|0)|0}if((c[88552>>2]|0)!=0){LL(t,c[88680>>2]|0)|0}if((c[88560>>2]|0)==0){O=0.0}else{LL(u,c[88688>>2]|0)|0;O=+iW(eM(u)|0)}if((c[88564>>2]|0)==0){P=1}else{LL(v,c[88692>>2]|0)|0;P=Ec(eM(v)|0)|0}if((c[88624>>2]|0)!=0){LL(w,c[88752>>2]|0)|0}zL(x,m);zL(y,r);zL(z,s);zL(A,t);zL(B,w);p=XH(d,x,y,z,A,O,P,B,e)|0;JL(B);JL(A);JL(z);JL(y);JL(x);if((p|0)!=0|g^1){Q=p}else{Is(5);p=sI(d)|0;Ls(5);tr(1,0,79664,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;JL(w);JL(v);JL(u);JL(t);JL(s);JL(r);JL(m);i=b;return R|0}Q=d+88|0;DL(D,c[Q>>2]|0);EA(C,D,79696);JL(D);DL(F,c[Q>>2]|0);EA(E,F,79712);JL(F);Ls(0);F=c[88736>>2]|0;Q=eM(C)|0;D=eM(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;RI(d,Q,D,(F|0)!=0?F:79728,I,p,eM(m)|0)|0;JL(E);JL(C);R=0;JL(w);JL(v);JL(u);JL(t);JL(s);JL(r);JL(m);i=b;return R|0}function WH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;yL(a,d);e=HL(b)|0;f=HL(c)|0;iM(a,IL(b)|0,e,f+e|0);aM(a,IL(c)|0,f)|0;i=d;return}function XH(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((HL(j)|0)==0){u=0}else{u=eM(j)|0}zL(r,b);b=(YH(a,r,k)|0)==0;JL(r);if(!b){v=-1;i=l;return v|0}DL(s,79656);b=a+280|0;r=QH(s,c[b>>2]|0)|0;JL(s);do{if(r){w=3}else{s=1;k=0;do{DL(t,c[79872+(s<<2)>>2]|0);j=QH(t,c[b>>2]|0)|0;JL(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];vr(1,0,79952,q);vr(1,0,78952,p);s=1;do{j=c[79984+(s<<2)>>2]|0;c[o>>2]=c[79872+(s<<2)>>2];c[o+4>>2]=j;vr(1,0,78976,o);s=s+1|0;}while((s|0)<20);xr(c[a+536>>2]|0,79080,n)}}while(0);c[m>>2]=c[79872+(w<<2)>>2];tr(23,0,80064,m);m=eM(d)|0;d=eM(e)|0;e=vv(a,m,d,eM(f)|0,g,h,w,u)|0;fe[c[73316>>2]&127](73288,a);v=e;i=l;return v|0}function YH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[18322]=zd(eM(b)|0)|0;c[73292>>2]=g;c[73296>>2]=d;d=a+284|0;do{if((c[19732]|0)==0){g=c[d>>2]|0;if((mW(79736,g)|0)==0){h=0;break}if((mW(79744,g)|0)==0){c[73304>>2]=50;c[73308>>2]=51;c[73316>>2]=52;h=0;break}if((mW(79752,g)|0)==0){c[73304>>2]=53;c[73308>>2]=54;c[73312>>2]=55;c[73316>>2]=56;h=1;break}if((mW(79760,g)|0)==0){c[73304>>2]=57;c[73308>>2]=58;c[73312>>2]=59;c[73316>>2]=60;h=1;break}if((mW(79768,g)|0)==0){c[73304>>2]=61;c[73308>>2]=62;c[73316>>2]=63;h=0;break}g=SH(101128,79776)|0;WN(SH(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);UH(a+8|0,c[a+288>>2]|0,h);fe[c[73304>>2]&127](73288,a);a=c[18322]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;tr(23,0,79800,f);j=0;i=e;return j|0}



function OV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[30422]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=121728+(j<<2)|0;l=121728+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[30422]=f&~(1<<h)}else{if(n>>>0<(c[121704>>2]|0)>>>0){hd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{hd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[121696>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=121728+(r<<2)|0;o=121728+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[30422]=f&~(1<<t)}else{if(n>>>0<(c[121704>>2]|0)>>>0){hd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{hd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[121696>>2]|0;if((n|0)!=0){f=c[121708>>2]|0;e=n>>>3;n=e<<1;g=121728+(n<<2)|0;m=c[30422]|0;j=1<<e;do{if((m&j|0)==0){c[30422]=m|j;u=121728+(n+2<<2)|0;v=g}else{e=121728+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[121704>>2]|0)>>>0)){u=e;v=h;break}hd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[121696>>2]=o;c[121708>>2]=s;p=k;i=b;return p|0}n=c[121692>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[121992+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[121704>>2]|0;if(h>>>0<k>>>0){hd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){hd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){hd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){hd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){hd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{hd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=121992+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<h);break a}else{if(s>>>0<(c[121704>>2]|0)>>>0){hd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[121704>>2]|0)>>>0){hd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[121696>>2]|0;if((h|0)!=0){s=c[121708>>2]|0;k=h>>>3;h=k<<1;f=121728+(h<<2)|0;m=c[30422]|0;g=1<<k;do{if((m&g|0)==0){c[30422]=m|g;A=121728+(h+2<<2)|0;B=f}else{k=121728+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[121704>>2]|0)>>>0)){A=k;B=e;break}hd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[121696>>2]=t;c[121708>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[121692>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[121992+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[121992+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[121696>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[121704>>2]|0;if(t>>>0<f>>>0){hd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){hd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){hd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){hd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){hd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{hd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=121992+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<e);break c}else{if(t>>>0<(c[121704>>2]|0)>>>0){hd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[121704>>2]|0)>>>0){hd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=121728+(t<<2)|0;s=c[30422]|0;r=1<<e;do{if((s&r|0)==0){c[30422]=s|r;S=121728+(t+2<<2)|0;T=f}else{e=121728+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[121704>>2]|0)>>>0)){S=e;T=k;break}hd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=121992+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[121692>>2]|0;l=1<<U;if((f&l|0)==0){c[121692>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[121704>>2]|0;if(W>>>0<k>>>0){hd()}if(r>>>0<k>>>0){hd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[121696>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[121708>>2]|0;if(W>>>0>15){c[121708>>2]=X+q;c[121696>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[121696>>2]=0;c[121708>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[121700>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[121700>>2]=W;X=c[121712>>2]|0;c[121712>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[30540]|0)==0){X=ed(30)|0;if((X+ -1&X|0)==0){c[122168>>2]=X;c[122164>>2]=X;c[122172>>2]=-1;c[122176>>2]=-1;c[122180>>2]=0;c[122132>>2]=0;c[30540]=(rc(0)|0)&-16^1431655768;break}else{hd()}}}while(0);X=q+48|0;W=c[122168>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[122128>>2]|0;do{if((U|0)!=0){T=c[122120>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[122132>>2]&4|0)==0){U=c[121712>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=122136|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[121700>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[122164>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[122120>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[122128>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[122168>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[122132>>2]=c[122132>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[122120>>2]|0)+ga|0;c[122120>>2]=ia;if(ia>>>0>(c[122124>>2]|0)>>>0){c[122124>>2]=ia}ia=c[121712>>2]|0;W=122136|0;i:do{if((ia|0)==0){aa=c[121704>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[121704>>2]=fa}c[122136>>2]=fa;c[122140>>2]=ga;c[122148>>2]=0;c[121724>>2]=c[30540];c[121720>>2]=-1;aa=0;do{ha=aa<<1;$=121728+(ha<<2)|0;c[121728+(ha+3<<2)>>2]=$;c[121728+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[121712>>2]=fa+ja;c[121700>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[121716>>2]=c[122176>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[121700>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[121712>>2]=ia+na;c[121700>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[121716>>2]=c[122176>>2];break i}}while(0);if(fa>>>0<(c[121704>>2]|0)>>>0){c[121704>>2]=fa}aa=fa+ga|0;$=122136|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[121712>>2]|0)){ca=(c[121700>>2]|0)+X|0;c[121700>>2]=ca;c[121712>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[121708>>2]|0)){ca=(c[121696>>2]|0)+X|0;c[121696>>2]=ca;c[121708>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=121728+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[121704>>2]|0)>>>0){hd()}if((c[V+12>>2]|0)==(ha|0)){break}hd()}}while(0);if((L|0)==(V|0)){c[30422]=c[30422]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[121704>>2]|0)>>>0){hd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}hd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[121704>>2]|0)>>>0){hd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){hd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{hd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=121992+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<t);break k}else{if(T>>>0<(c[121704>>2]|0)>>>0){hd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[121704>>2]|0)>>>0){hd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=121728+(Z<<2)|0;t=c[30422]|0;T=1<<ca;do{if((t&T|0)==0){c[30422]=t|T;xa=121728+(Z+2<<2)|0;ya=ea}else{ca=121728+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[121704>>2]|0)>>>0)){xa=ca;ya=V;break}hd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=121992+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[121692>>2]|0;L=1<<za;if((ea&L|0)==0){c[121692>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[121704>>2]|0;if(Ba>>>0<S>>>0){hd()}if(T>>>0<S>>>0){hd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=122136|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[121712>>2]=fa+Ha;c[121700>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[121716>>2]=c[122176>>2];c[ba+4>>2]=27;X=122136|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[122136>>2]=fa;c[122140>>2]=ga;c[122148>>2]=0;c[122144>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=121728+(da<<2)|0;aa=c[30422]|0;f=1<<M;do{if((aa&f|0)==0){c[30422]=aa|f;Ia=121728+(da+2<<2)|0;Ja=ha}else{M=121728+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[121704>>2]|0)>>>0)){Ia=M;Ja=T;break}hd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=121992+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[121692>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[121692>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[121704>>2]|0;if(Ma>>>0<f>>>0){hd()}if(M>>>0<f>>>0){hd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[121700>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[121700>>2]=W;ia=c[121712>>2]|0;c[121712>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}function PV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[121704>>2]|0;if(d>>>0<f>>>0){hd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){hd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){hd()}if((p|0)==(c[121708>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[121696>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=121728+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){hd()}if((c[m+12>>2]|0)==(p|0)){break}hd()}}while(0);if((u|0)==(m|0)){c[30422]=c[30422]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){hd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}hd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){hd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){hd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){hd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{hd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=121992+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[121704>>2]|0)>>>0){hd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[121704>>2]|0)>>>0){hd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){hd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){hd()}do{if((C&2|0)==0){if((l|0)==(c[121712>>2]|0)){f=(c[121700>>2]|0)+t|0;c[121700>>2]=f;c[121712>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[121708>>2]|0)){i=b;return}c[121708>>2]=0;c[121696>>2]=0;i=b;return}if((l|0)==(c[121708>>2]|0)){f=(c[121696>>2]|0)+t|0;c[121696>>2]=f;c[121708>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=121728+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[121704>>2]|0)>>>0){hd()}if((c[E+12>>2]|0)==(l|0)){break}hd()}}while(0);if((w|0)==(E|0)){c[30422]=c[30422]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[121704>>2]|0)>>>0){hd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}hd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[121704>>2]|0)>>>0){hd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){hd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{hd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=121992+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<g);break b}else{if(d>>>0<(c[121704>>2]|0)>>>0){hd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[121704>>2]|0)>>>0){hd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[121708>>2]|0)){J=f;break}c[121696>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=121728+(C<<2)|0;G=c[30422]|0;j=1<<t;do{if((G&j|0)==0){c[30422]=G|j;K=121728+(C+2<<2)|0;L=e}else{t=121728+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[121704>>2]|0)>>>0)){K=t;L=a;break}hd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=121992+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[121692>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[121692>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[121704>>2]|0;if(O>>>0<K>>>0){hd()}if(f>>>0<K>>>0){hd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[121720>>2]|0)+ -1|0;c[121720>>2]=s;if((s|0)==0){Q=122144|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[121720>>2]=-1;i=b;return}function QV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=OV(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}uW(b|0,0,e|0)|0;i=d;return b|0}function RV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=OV(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=SV(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=OV(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;sW(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;PV(a);e=g;i=d;return e|0}function SV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[121704>>2]|0;if(h>>>0<l>>>0){hd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){hd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){hd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[122168>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;TV(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[121712>>2]|0)){m=(c[121700>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[121712>>2]=a+b;c[121700>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[121708>>2]|0)){h=(c[121696>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[121696>>2]=r;c[121708>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=121728+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){hd()}if((c[h+12>>2]|0)==(k|0)){break}hd()}}while(0);if((m|0)==(h|0)){c[30422]=c[30422]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){hd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}hd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){hd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){hd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{hd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=121992+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<u);break a}else{if(t>>>0<(c[121704>>2]|0)>>>0){hd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[121704>>2]|0)>>>0){hd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;TV(a+b|0,r);o=a;i=d;return o|0}return 0}function TV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[121704>>2]|0;if(j>>>0<m>>>0){hd()}if((k|0)==(c[121708>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[121696>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=121728+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){hd()}if((c[q+12>>2]|0)==(k|0)){break}hd()}}while(0);if((r|0)==(q|0)){c[30422]=c[30422]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){hd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}hd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){hd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){hd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{hd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=121992+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[121704>>2]|0)>>>0){hd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[121704>>2]|0)>>>0){hd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[121704>>2]|0;if(e>>>0<z>>>0){hd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[121712>>2]|0)){t=(c[121700>>2]|0)+p|0;c[121700>>2]=t;c[121712>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[121708>>2]|0)){i=d;return}c[121708>>2]=0;c[121696>>2]=0;i=d;return}if((f|0)==(c[121708>>2]|0)){t=(c[121696>>2]|0)+p|0;c[121696>>2]=t;c[121708>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=121728+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){hd()}if((c[u+12>>2]|0)==(f|0)){break}hd()}}while(0);if((h|0)==(u|0)){c[30422]=c[30422]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){hd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}hd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){hd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){hd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){hd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{hd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=121992+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[121692>>2]=c[121692>>2]&~(1<<j);break b}else{if(m>>>0<(c[121704>>2]|0)>>>0){hd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[121704>>2]|0)>>>0){hd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[121704>>2]|0)>>>0){hd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[121708>>2]|0)){G=t;break}c[121696>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=121728+(B<<2)|0;D=c[30422]|0;b=1<<p;do{if((D&b|0)==0){c[30422]=D|b;H=121728+(B+2<<2)|0;I=A}else{p=121728+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[121704>>2]|0)>>>0)){H=p;I=a;break}hd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=121992+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[121692>>2]|0;B=1<<J;if((a&B|0)==0){c[121692>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[121704>>2]|0)>>>0){hd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[121704>>2]|0;if(L>>>0<B>>>0){hd()}if(G>>>0<B>>>0){hd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function UV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=OV(d)|0;if((e|0)!=0){f=6;break}a=c[30546]|0;c[30546]=0+a;if((a|0)==0){f=5;break}Ee[a&7]()}if((f|0)==5){d=Dc(4)|0;c[d>>2]=122200;Sd(d|0,122248,135)}else if((f|0)==6){i=b;return e|0}return 0}function VV(a){a=a|0;var b=0,c=0;b=i;c=UV(a)|0;i=b;return c|0}function WV(a){a=a|0;var b=0;b=i;if((a|0)!=0){PV(a)}i=b;return}function XV(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function YV(a){a=a|0;var b=0;b=i;zb(a|0);WV(a);i=b;return}function ZV(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function _V(a){a=a|0;i=i;return 122216}function $V(){var a=0;a=Dc(4)|0;c[a>>2]=122200;Sd(a|0,122248,135)}function aW(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=dW(b)|0}}while((jd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=dW(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[122264+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=dW(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[122280+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=dW(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=dW(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=dW(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=dW(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=dW(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=dW(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=AW(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=AW(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=dW(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){cW(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=AW(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=bW(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){cW(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=vW(q|0,n|0,2)|0;o=AW(p|0,J|0,-32,-1)|0;p=AW(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=AW(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=zW(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=AW(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Qd(+(+eW(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Nc()|0)>>2]=34}l=+fW(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=dW(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=dW(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=dW(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=AW(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=AW(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=dW(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=bW(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){cW(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=AW(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Nc()|0)>>2]=22;cW(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[122296+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[122296+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[122296+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=vW(c[Ra>>2]|0,0,29)|0;Qa=AW(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=KW(Qa|0,Ta|0,1e9,0)|0;pa=LW(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=vW(c[Ua>>2]|0,0,29)|0;Ra=AW(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=KW(Ra|0,Sa|0,1e9,0)|0;Pa=LW(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[122288+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Qd(+(+eW(1.0,105-tc|0)),+sc);vc=+yc(+sc,+(+eW(1.0,53-tc|0)));wc=va;xc=vc;zc=va+(sc-vc)}else{wc=0.0;xc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+yc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Nc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+fW(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=dW(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=dW(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;cW(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;cW(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function bW(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=dW(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=dW(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=dW(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=JW(q|0,m|0,10,0)|0;b=J;g=AW(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=AW(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=dW(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=dW(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=zW(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function cW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function dW(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=hW(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function eW(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=vW(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function fW(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+eW(a,b);i=c;return+d}function gW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ke[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function hW(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((gW(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ke[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function iW(a){a=a|0;var b=0,c=0.0;b=i;c=+jW(a,0);i=b;return+c}function jW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;cW(e,0);h=+aW(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function kW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;cW(e,0);h=+aW(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function lW(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function mW(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function nW(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function oW(){c[25650]=p;c[25692]=p;c[30334]=p;c[30564]=p}function pW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}cc(116);cc(111);cc(111);cc(32);cc(109);cc(97);cc(110);cc(121);cc(32);cc(115);cc(101);cc(116);cc(106);cc(109);cc(112);cc(115);cc(32);cc(105);cc(110);cc(32);cc(97);cc(32);cc(102);cc(117);cc(110);cc(99);cc(116);cc(105);cc(111);cc(110);cc(32);cc(99);cc(97);cc(108);cc(108);cc(44);cc(32);cc(98);cc(117);cc(105);cc(108);cc(100);cc(32);cc(119);cc(105);cc(116);cc(104);cc(32);cc(97);cc(32);cc(104);cc(105);cc(103);cc(104);cc(101);cc(114);cc(32);cc(118);cc(97);cc(108);cc(117);cc(101);cc(32);cc(102);cc(111);cc(114);cc(32);cc(77);cc(65);cc(88);cc(95);cc(83);cc(69);cc(84);cc(74);cc(77);cc(80);cc(83);cc(10);ga(0);return 0}function qW(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function rW(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function sW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function tW(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{sW(b,c,d)|0}return b|0}function uW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function vW(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function wW(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function xW(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function yW(){return xW(o)|0}function zW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function AW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function BW(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function CW(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function DW(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function EW(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function FW(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function GW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function HW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=zW(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=zW((MW(i,b,zW(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function IW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=zW(h^a,j^b,h,j)|0;b=J;MW(m,b,zW(k^d,l^e,k,l)|0,J,g)|0;l=zW(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function JW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=GW(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function KW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=MW(a,b,c,d,0)|0;return(J=J,e)|0}function LW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;MW(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function MW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((FW(l|0)|0)>>>0);return(J=n,o)|0}p=(EW(l|0)|0)-(EW(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(EW(l|0)|0)-(EW(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(EW(j|0)|0)+33-(EW(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=FW(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=AW(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;zW(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=zW(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function NW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ae[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function OW(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;be[a&31](b|0,c|0,d|0,e|0,f|0)}function PW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return ce[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function QW(a,b){a=a|0;b=+b;de[a&1](+b)}function RW(a,b){a=a|0;b=b|0;ee[a&255](b|0)}function SW(a,b,c){a=a|0;b=b|0;c=c|0;fe[a&127](b|0,c|0)}function TW(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ge[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function UW(a,b){a=a|0;b=b|0;return he[a&127](b|0)|0}function VW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ie[a&1](b|0,c|0,+d,e|0)}function WW(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return je[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function XW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ke[a&63](b|0,c|0,d|0)|0}function YW(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return le[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function ZW(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return me[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function _W(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ne[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function $W(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;oe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function aX(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return pe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function bX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qe[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function cX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;re[a&3](b|0,c|0,+d,e|0,f|0)}function dX(a,b,c){a=a|0;b=b|0;c=+c;return se[a&1](b|0,+c)|0}function eX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;te[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function fX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ue[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function gX(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ve[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function hX(a,b,c){a=a|0;b=b|0;c=c|0;return we[a&63](b|0,c|0)|0}function iX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return xe[a&63](b|0,c|0,d|0,e|0,f|0)|0}function jX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ye[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function kX(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+ze[a&1](b|0,+c,+d)}function lX(a,b,c){a=a|0;b=b|0;c=c|0;return+Ae[a&1](b|0,c|0)}function mX(a){a=a|0;return Be[a&7]()|0}function nX(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Ce[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function oX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;De[a&15](b|0,c|0,d|0)}function pX(a){a=a|0;Ee[a&7]()}function qX(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Fe[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function rX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ge[a&63](b|0,c|0,d|0,e|0)|0}function sX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;He[a&31](b|0,c|0,d|0,e|0)}function tX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function uX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function vX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function wX(a){a=+a;ga(3)}function xX(a){a=a|0;ga(4)}function yX(a){a=a|0;Bd(a|0)}function zX(a,b){a=a|0;b=b|0;ga(5)}function AX(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function BX(a){a=a|0;ga(7);return 0}function CX(a){a=a|0;return Oc(a|0)|0}function DX(a){a=a|0;return Kd(a|0)|0}function EX(a){a=a|0;return vc(a|0)|0}function FX(a){a=a|0;return zd(a|0)|0}function GX(a){a=a|0;return md(a|0)|0}function HX(a){a=a|0;return td(a|0)|0}function IX(a){a=a|0;return Yc(a|0)|0}function JX(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function KX(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function LX(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function MX(a,b,c){a=a|0;b=b|0;c=c|0;return vd(a|0,b|0,c|0)|0}function NX(a,b,c){a=a|0;b=b|0;c=c|0;return gc(a|0,b|0,c|0)|0}function OX(a,b,c){a=a|0;b=b|0;c=c|0;return Nd(a|0,b|0,c|0)|0}function PX(a,b,c){a=a|0;b=b|0;c=c|0;return Ad(a|0,b|0,c|0)|0}function QX(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function RX(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function SX(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function TX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function UX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function VX(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function WX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function XX(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function YX(a,b){a=a|0;b=+b;ga(18);return 0}function ZX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function _X(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function $X(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function aY(a,b){a=a|0;b=b|0;ga(22);return 0}function bY(a,b){a=a|0;b=b|0;return Pd(a|0,b|0)|0}function cY(a,b){a=a|0;b=b|0;return fc(a|0,b|0)|0}function dY(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function eY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function fY(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function gY(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function hY(a,b){a=a|0;b=b|0;ga(26);return 0.0}function iY(){ga(27);return 0}function jY(){return jb()|0}function kY(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function lY(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function mY(){ga(30)}function nY(){Uc()}function oY(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function pY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function qY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return qc(a|0,b|0,c|0,d|0)|0}function rY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function sY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function lm(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function mm(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=qW(d|0)|0;switch(c[b>>2]|0){case 11:{q=nm(21520,21504,21512)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=om(b,d,e,f,g,h,j)|0;i=k;return q|0};case 3:case 2:case 1:{h=o;xJ(h,d,1,p);p=a[h]|0;do{if((p+ -97<<24>>24&255)<26){d=p+ -32<<24>>24;a[h]=d;e=o+1|0;r=a[e]|0;if((r+ -97<<24>>24&255)<26){a[e]=r+ -32<<24>>24}r=o+2|0;e=a[r]|0;if((e+ -97<<24>>24&255)<26){a[r]=e+ -32<<24>>24}e=o+3|0;r=a[e]|0;if((r+ -97<<24>>24&255)<26){a[e]=r+ -32<<24>>24}r=o+4|0;e=a[r]|0;if((e+ -97<<24>>24&255)<26){a[r]=e+ -32<<24>>24}e=o+5|0;r=a[e]|0;if(!((r+ -97<<24>>24&255)<26)){s=d;break}a[e]=r+ -32<<24>>24;s=d}else{s=p}}while(0);p=s<<24>>24==83;h=s<<24>>24==68;d=p|h;if(!(s<<24>>24==67|s<<24>>24==68|s<<24>>24==83|s<<24>>24==90)){q=1;i=k;return q|0}r=l;xJ(r,o+1|0,1,2);l=m;xJ(l,o+3|0,1,3);o=n;xJ(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((wJ(r,21264,1,2)|0)==0){if((wJ(l,21280,1,3)|0)==0){q=128;i=k;return q|0}if((wJ(l,21288,1,3)|0)==0){q=128;i=k;return q|0}if((wJ(l,21296,1,3)|0)==0){q=128;i=k;return q|0}if((wJ(l,21304,1,3)|0)==0){q=128;i=k;return q|0}if((wJ(l,21312,1,3)|0)==0){q=128;i=k;return q|0}b=(wJ(l,21320,1,3)|0)==0;q=b?128:0;i=k;return q|0}if((wJ(r,21344,1,2)|0)==0){if(!(s<<24>>24==68|s<<24>>24==83)){q=0;i=k;return q|0}b=(wJ(l,21352,1,3)|0)==0;q=b?32:0;i=k;return q|0}if(s<<24>>24==67|s<<24>>24==90){t=138}else if(s<<24>>24==68|s<<24>>24==83){t=141}else{q=0;i=k;return q|0}do{if((t|0)==138){if((wJ(r,21368,1,2)|0)==0){b=(wJ(l,21352,1,3)|0)==0;q=b?32:0;i=k;return q|0}else{if(s<<24>>24==67|s<<24>>24==90){break}else if(s<<24>>24==68|s<<24>>24==83){t=141;break}else{q=0}i=k;return q|0}}}while(0);do{if((t|0)==141){if((wJ(r,21376,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((wJ(o,21384,1,2)|0)!=0){if((wJ(o,21392,1,2)|0)==0){break}if((wJ(o,21400,1,2)|0)==0){break}if((wJ(o,21408,1,2)|0)==0){break}if((wJ(o,21416,1,2)|0)==0){break}if((wJ(o,21424,1,2)|0)==0){break}if((wJ(o,21432,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((wJ(r,21440,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((wJ(o,21384,1,2)|0)!=0){if((wJ(o,21392,1,2)|0)==0){break}if((wJ(o,21400,1,2)|0)==0){break}if((wJ(o,21408,1,2)|0)==0){break}if((wJ(o,21416,1,2)|0)==0){break}if((wJ(o,21424,1,2)|0)==0){break}if((wJ(o,21432,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else if((m|0)==2){if((wJ(r,21264,1,2)|0)==0){if((wJ(l,21280,1,3)|0)==0){q=2;i=k;return q|0}if((wJ(l,21288,1,3)|0)==0){q=2;i=k;return q|0}if((wJ(l,21296,1,3)|0)==0){q=2;i=k;return q|0}if((wJ(l,21304,1,3)|0)==0){q=2;i=k;return q|0}if((wJ(l,21312,1,3)|0)==0){q=2;i=k;return q|0}if((wJ(l,21320,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((wJ(r,21344,1,2)|0)==0){m=(wJ(l,21272,1,3)|0)==0;if(m|(p|h)^1){q=m?8:2;i=k;return q|0}q=2;i=k;return q|0}if(s<<24>>24==67|s<<24>>24==90){t=91}else if(s<<24>>24==68|s<<24>>24==83){t=94}else{q=2;i=k;return q|0}do{if((t|0)==91){if((wJ(r,21368,1,2)|0)==0){q=2;i=k;return q|0}else{if(s<<24>>24==68|s<<24>>24==83){t=94;break}else if(s<<24>>24==67|s<<24>>24==90){break}else{q=2}i=k;return q|0}}}while(0);do{if((t|0)==94){if((wJ(r,21376,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){break}else{q=2}i=k;return q|0}m=a[l]|0;if(m<<24>>24==77){if((wJ(o,21384,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21392,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21400,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21408,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21416,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21424,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==71){if((wJ(o,21384,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21392,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21400,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21408,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21416,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21424,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((wJ(r,21440,1,2)|0)!=0){q=2;i=k;return q|0}m=a[l]|0;if(m<<24>>24==71){if((wJ(o,21384,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21392,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21400,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21408,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21416,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21424,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(m<<24>>24==77){if((wJ(o,21384,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21392,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21400,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21408,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21416,1,2)|0)==0){q=2;i=k;return q|0}if((wJ(o,21424,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else{if((wJ(r,21264,1,2)|0)==0){if((wJ(l,21272,1,3)|0)==0){q=64;i=k;return q|0}if((wJ(l,21280,1,3)|0)==0){q=32;i=k;return q|0}if((wJ(l,21288,1,3)|0)==0){q=32;i=k;return q|0}if((wJ(l,21296,1,3)|0)==0){q=32;i=k;return q|0}if((wJ(l,21304,1,3)|0)==0){q=32;i=k;return q|0}if((wJ(l,21312,1,3)|0)==0){q=32;i=k;return q|0}if((wJ(l,21320,1,3)|0)==0){q=32;i=k;return q|0}m=(wJ(l,21328,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((wJ(r,21336,1,2)|0)==0){m=(wJ(l,21272,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((wJ(r,21344,1,2)|0)==0){m=(wJ(l,21272,1,3)|0)==0;if(m|d^1){q=m?64:1;i=k;return q|0}m=(wJ(l,21352,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(wJ(l,21360,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(s<<24>>24==68|s<<24>>24==83){t=29}else if(s<<24>>24==67|s<<24>>24==90){if((wJ(r,21368,1,2)|0)!=0){if(s<<24>>24==68|s<<24>>24==83){t=29;break}else if(s<<24>>24==67|s<<24>>24==90){t=48;break}else{break}}if((wJ(l,21272,1,3)|0)==0){q=64;i=k;return q|0}if((wJ(l,21352,1,3)|0)==0){q=32;i=k;return q|0}m=(wJ(l,21360,1,3)|0)==0;q=m?64:1;i=k;return q|0}}while(0);do{if((t|0)==29){if((wJ(r,21376,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){t=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((wJ(o,21384,1,2)|0)!=0){if((wJ(o,21392,1,2)|0)==0){break}if((wJ(o,21400,1,2)|0)==0){break}if((wJ(o,21408,1,2)|0)==0){break}if((wJ(o,21416,1,2)|0)==0){break}if((wJ(o,21424,1,2)|0)==0){break}if((wJ(o,21432,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((wJ(o,21384,1,2)|0)!=0){if((wJ(o,21392,1,2)|0)==0){break}if((wJ(o,21400,1,2)|0)==0){break}if((wJ(o,21408,1,2)|0)==0){break}if((wJ(o,21416,1,2)|0)==0){break}if((wJ(o,21424,1,2)|0)==0){break}if((wJ(o,21432,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((t|0)==48){if((wJ(r,21440,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((wJ(o,21384,1,2)|0)!=0){if((wJ(o,21392,1,2)|0)==0){break}if((wJ(o,21400,1,2)|0)==0){break}if((wJ(o,21408,1,2)|0)==0){break}if((wJ(o,21416,1,2)|0)==0){break}if((wJ(o,21424,1,2)|0)==0){break}if((wJ(o,21432,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((wJ(o,21384,1,2)|0)!=0){if((wJ(o,21392,1,2)|0)==0){break}if((wJ(o,21400,1,2)|0)==0){break}if((wJ(o,21408,1,2)|0)==0){break}if((wJ(o,21416,1,2)|0)==0){break}if((wJ(o,21424,1,2)|0)==0){break}if((wJ(o,21432,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((wJ(r,21448,1,2)|0)==0){if((wJ(l,21272,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((wJ(r,21456,1,2)|0)==0){if((wJ(l,21272,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((wJ(r,21424,1,2)|0)==0){j=(wJ(l,21328,1,3)|0)==0;q=j?64:1;i=k;return q|0}if((wJ(r,21464,1,2)|0)==0){j=(wJ(l,21472,1,3)|0)==0;q=j?64:1;i=k;return q|0}if(!(s<<24>>24==68|s<<24>>24==83)){q=1;i=k;return q|0}if((wJ(r,21480,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};case 4:{q=6;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 6:{r=c[f>>2]|0;f=c[g>>2]|0;q=~~(+(((r|0)>(f|0)?f:r)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 10:{q=nm(21496,21504,21512)|0;i=k;return q|0};default:{q=-1;i=k;return q|0}}return 0}function nm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function om(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(vJ(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 12:{p=75;i=j;return p|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function pm(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=qm(a,0,0)|0;i=b;return c|0}function qm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=rm(a,b,c,0)|0;i=d;return e|0}function rm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=he[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=OV(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=182}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=he[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){ee[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=he[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){ee[c[b+20>>2]&255](c[j+392>>2]|0);ee[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Dn(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}ee[c[j+20>>2]&255](c[j+44>>2]|0);ee[c[j+20>>2]&255](c[j+392>>2]|0);ee[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;En(j+416|0,j+12|0);En(j+440|0,j+12|0);tm(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}wm(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Yn()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Pn()|0}k=j;l=k;i=g;return l|0}function sm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function tm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;gq(f+256|0);if((b|0)!=0){g=um(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Qn(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function um(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Lm(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function vm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Om(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=um(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Lm(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Lm(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Sm(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Lm(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Om(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function wm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;ee[c[e+20>>2]&255](c[g+36>>2]|0);xm(c[g+44>>2]|0,e);ee[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;ee[c[e+20>>2]&255](f)}xm(c[h+376>>2]|0,e);xm(c[e+372>>2]|0,e);ym(e+416|0);ym(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}zm(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);ee[c[e+20>>2]&255](c[e+392>>2]|0);ee[c[e+20>>2]&255](c[e+464>>2]|0);ee[c[e+20>>2]&255](c[e+8>>2]|0);ee[c[e+20>>2]&255](c[e+44>>2]|0);ee[c[e+20>>2]&255](c[e+396>>2]|0);ee[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){ee[c[e+252>>2]&255](c[e+244>>2]|0)}ee[c[e+20>>2]&255](e);i=d;return}function xm(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;ee[c[a+20>>2]&255](c[b+16>>2]|0);ee[c[a+20>>2]&255](b)}i=d;return}function ym(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ee[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ee[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function zm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Mm(f,g+20|0);while(1){d=Nm(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}ee[c[b+8>>2]&255](c[d+20>>2]|0)}Rm(g);Rm(g+132|0);Rm(g+20|0);Rm(g+40|0);Rm(g+60|0);ym(g+80|0);ym(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ee[m&255](o);i=e;return}ee[c[b+8>>2]&255](c[g+184>>2]|0);ee[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ee[m&255](o);i=e;return}function Am(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Bm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Cm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Dm(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Fm(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{sW(f|0,b|0,d|0)|0;j=Gm(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ge[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){He[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function Dm(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Bn()|0}if((a[e+236|0]|0)!=0){f=vm(e,23304)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Em(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Fm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;tW(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=he[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;sW(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;ee[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Gm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Dm(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ge[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);He[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Hm(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Im(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}He[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Jm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){De[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];be[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];De[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Km(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[21528+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;sW((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=we[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=he[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){sW(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Mm(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Nm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Om(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=he[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){uW(c[m>>2]|0,0,g|0)|0;g=Pm(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Pm(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Qm(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=he[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}uW(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Pm(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}ee[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=he[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){uW(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Pm(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Qm(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Rm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}ee[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}ee[e&255](c[d>>2]|0);i=b;return}function Sm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[23112+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[23152+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=we[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=he[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=he[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}ee[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;sW(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}De[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function Tm(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ke[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=An(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Um(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ge[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Vm(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function Vm(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=xe[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){t=o+12|0;if((c[o+468>>2]|0)==0){u=c[t>>2]|0;c[o+468>>2]=32;c[o+464>>2]=he[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[t+4>>2]|0;t=c[o+464>>2]|0;v=o+468|0;w=c[v>>2]<<1;c[v>>2]=w;v=we[u&63](t,w)|0;if((v|0)==0){r=245;break a}c[o+464>>2]=v;if((c[l+184>>2]|0)==0){break}v=we[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((v|0)==0){r=248;break a}c[l+184>>2]=v}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}v=hn(o)|0;if((v|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=v;w=l+180|0;c[w>>2]=(c[w>>2]|0)+1;c[(c[l+164>>2]|0)+(v*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;v=l;do{if((c[o+492>>2]|0)!=0){w=Xm(v+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=273;break a}t=Om(o,l+132|0,w,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((t|0)==0){r=279;break a}if((a[t+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((t|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}De[c[o+120>>2]&15](c[o+4>>2]|0,w,1);h=0;break c}}while(0);if((a[t+32|0]|0)!=0){r=287;break a}if((c[t+4>>2]|0)!=0){x=jn(o,t,((s|0)==60?1:0)&255)|0;if((x|0)!=0){r=290;break a}h=0;break c}w=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[w+130|0]|0;break c}a[w+131|0]=0;a[t+32|0]=1;w=(xe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!w){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[v+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((he[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{y=1;r=319;break};case 52:{y=2;r=319;break};case 54:{y=3;r=319;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Xm(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 1:{z=Wm(o,0,e,c[n>>2]|0)|0;if((z|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Om(o,l+132|0,23184,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ge[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}v=Xm(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((v|0)==0){r=43;break a}Ym(v);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=v;h=0;r=47;break};case 7:{if((c[o+84>>2]|0)==0){break c}be[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;sm(o+416|0);h=0;break};case 57:{A=Wm(o,1,e,c[n>>2]|0)|0;if((A|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=23192;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=23200;r=102;break};case 25:{c[o+332>>2]=23208;r=102;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=_m(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){B=23288}else{B=(s|0)==32?23272:23296}if((an(o+416|0,B)|0)==0){r=111;break a}if((bn(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 22:{c[o+348>>2]=$m(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 9:{if((ke[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}v=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[v+16>>2];c[o+316>>2]=0;break c}w=Xm(v,b,e,c[n>>2]|0)|0;if((w|0)==0){r=190;break a}c[o+316>>2]=Om(o,l,w,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}v=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(w|0)){c[l+92>>2]=c[v+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[v+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{v=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[v+16>>2];c[o+316>>2]=0;break c}w=Xm(v,b,e,c[n>>2]|0)|0;if((w|0)==0){r=202;break a}c[o+316>>2]=Om(o,l+132|0,w,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}v=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(w|0)){c[l+92>>2]=c[v+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[v+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){D=1}else{D=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(D^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Jm(o,b,e,c[n>>2]|0)}h=0;E=fn(o,b,n,f,j,k)|0;if((E|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Xm(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((Ge[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}v=Xm(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((v|0)==0){r=220;break a}Ym(v);c[o+340>>2]=v;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}v=Xm(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((v|0)==0){r=225;break a}c[q>>2]=e;be[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,v,c[o+340>>2]|0);h=0}}while(0);sm(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;be[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);sm(o+416|0);break};case 12:{if((a[l+128|0]|0)==0){break c}F=en(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;v=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=v;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;ve[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=v}}while(0);if((F|0)!=0){r=153;break a}break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=_m(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){v=he[c[o+12>>2]&127](20)|0;if((v|0)==0){r=309;break a}c[v+4>>2]=0;c[v+8>>2]=0;c[v+12>>2]=0;c[v+16>>2]=0;c[v>>2]=(s|0)==41?2:1;c[q>>2]=e;De[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,v);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{y=0;r=319;break};case 47:{y=1;r=334;break};case 46:{y=2;r=334;break};case 48:{y=3;r=334;break};case 45:{y=0;r=334;break};case 56:{if((mn(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((ln(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){be[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);sm(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;v=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Om(o,l+132|0,23184,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((xe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((he[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}ee[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ve[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}v=Xm(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=v;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;qe[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ve[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 26:{c[o+332>>2]=23216;r=102;break};case 27:{c[o+332>>2]=23224;r=102;break};case 28:{c[o+332>>2]=23232;r=102;break};case 29:{c[o+332>>2]=23248;r=102;break};case 30:{c[o+332>>2]=23256;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((cn(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Lm(o+416|0)|0)<<24>>24!=0)){r=128;break a}}v=o+428|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Lm(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;v=c[w>>2]|0;c[w>>2]=v+1;a[v]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;qe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);sm(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;v=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Xm(v+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[v+324>>2]=23184}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((he[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Om(o,l+132|0,23184,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}G=dn(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((G|0)!=0){r=132;break a}v=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((cn(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,v,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Lm(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Lm(o+416|0)|0)<<24>>24!=0)){r=145;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;qe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,v,(s|0)==38|0);sm(o+416|0);h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ge[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Xm(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((y|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=hn(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=y;w=_m(o,b,e,H)|0;if((w|0)==0){r=325;break a}u=c[w>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=u;s=0;do{w=s;s=w+1|0;}while((a[u+w|0]|0)!=0);u=l+168|0;c[u>>2]=(c[u>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}u=l+180|0;c[u>>2]=(c[u>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=y;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){u=kn(o)|0;if((u|0)==0){r=340;break a}c[q>>2]=e;De[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,u)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}u=Xm(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=50;break a}Ym(u);c[(c[o+316>>2]|0)+24>>2]=u;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Jm(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ge[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((xe[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=z;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=A;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){A=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}z=Om(o,l+132|0,23184,36)|0;if((z|0)==0){I=1;J=I;i=m;return J|0}c[z+20>>2]=c[o+360>>2];a[l+131|0]=0;if((xe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[z+20>>2]|0,c[z+16>>2]|0,c[z+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=A;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((he[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=Zm(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=G;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=F;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){F=g;if((F|0)==28){I=10;J=I;i=m;return J|0}else if((F|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=E;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=E;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=x;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Wm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ge[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Xm(n+440|0,p,b,s+(we[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Xm(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);He[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Jm(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Xm(n+440|0,e,d,m+(we[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=An(n,f)|0;sm(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){sm(n+440|0)}q=0;r=q;i=g;return r|0}function Xm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((bn(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Lm(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function Ym(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function Zm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=pn(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((xn(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function _m(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Xm(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Om(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((yn(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function $m(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Lm(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Xm(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Om(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Om(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Lm(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Lm(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Om(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function an(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Lm(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function bn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Lm(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){be[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Lm(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function cn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=he[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=we[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function dn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=zn(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Lm(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function en(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Lm(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ge[c[b+20>>2]&63](b,e,f,j)|0){case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 10:{s=we[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=Gn(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Lm(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 6:case 9:{if((bn(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=Xm(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=Om(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=en(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(xe[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 7:{r=28;break};case-4:{r=24;break a;break};case 0:{r=49;break a;break};case-1:{r=46;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Lm(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function fn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ge[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){Jm(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function gn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=fn(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=Um(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function hn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=he[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=we[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=he[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function jn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=he[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ge[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Vm(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=pn(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function kn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=he[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;on(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function ln(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Jm(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(we[c[a+32>>2]&63](a,b)|0)|0;k=Xm(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=we[c[a+36>>2]&63](a,e)|0;e=Xm(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){nn(e);De[c[g+64>>2]&15](c[g+4>>2]|0,k,e);sm(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function mn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Jm(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Xm(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){nn(k);fe[c[g+68>>2]&127](c[g+4>>2]|0,k);sm(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function nn(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function on(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}on(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}



function Vg(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0.0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0,_a=0.0,$a=0.0,ab=0,bb=0.0,cb=0.0,db=0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0.0,Eb=0.0,Fb=0,Gb=0.0,Hb=0.0,Ib=0;e=i;i=i+6760|0;f=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;re[c[(d+8|0)>>2]&3](0,0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+464>>3],0,d);re[c[(d+8|0)>>2]&3](0,1,-1.0,1,d);J=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;K=c[c[(b+4|0)>>2]>>2]|0;L=+h[(c[K+8>>2]|0)+48>>3];do{if(J){if(L>0.0){M=L;N=K}else{O=c[20226]|0;P=c[b+536>>2]|0;h[k>>3]=L;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Q=e+504|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[O&31](P,e+504|0,3016,E);P=c[c[(b+4|0)>>2]>>2]|0;M=+h[(c[P+8>>2]|0)+48>>3];N=P}if(M>0.0){R=M;S=N}else{P=c[20226]|0;O=c[b+536>>2]|0;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Q=e+480|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[P&31](O,e+480|0,3016,D);O=c[c[(b+4|0)>>2]>>2]|0;R=+h[(c[O+8>>2]|0)+48>>3];S=O}T=R*R;O=R!=0.0;if(T*T!=0.0){if(O){U=R;V=R}else{T=+zr(c[b+536>>2]|0,R,3088,3e3,+h[S>>3],(a[b+319|0]|0)!=0|0);U=T;V=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}T=V*3.247474414e-16;W=V*(T+-9.322036725e-12)+1.575771013333333e-7;X=V*W+-.0009809873795;Y=V*X+20.49107091;Z=V*Y;_=V*V;$=_*(V*(R*(-13835.01485/U+(V*(V*(V*(T+(T+-9.322036725e-12))+W)+X)+Y))+(+da(+L)*-13835.01485+Z+75320.6691))-(V*(+da(+M)*-13835.01485+Z+75320.6691)+-3730042.76))*518.2791167938085/(_*_);break}if(O){aa=R;ba=R;ca=S}else{_=+zr(c[b+536>>2]|0,R,3088,3e3,+h[S>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;aa=_;ba=+h[(c[O+8>>2]|0)+48>>3];ca=O}_=ba*3.247474414e-16;Z=ba*(_+-9.322036725e-12)+1.575771013333333e-7;Y=ba*Z+-.0009809873795;X=ba*Y+20.49107091;W=+da(+L)*-13835.01485;T=ba*X;ea=+da(+M)*-13835.01485;O=ba!=0.0;if(ba*ba*(ba*(R*(-13835.01485/aa+(ba*(ba*(ba*(_+(_+-9.322036725e-12))+Z)+Y)+X))+(W+T+75320.6691))-(ba*(ea+T+75320.6691)+-3730042.76))*518.2791167938085==0.0){if(O){fa=ba;ga=ba}else{T=+zr(c[b+536>>2]|0,ba,3088,3e3,+h[ca>>3],(a[b+319|0]|0)!=0|0);fa=T;ga=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}T=ga*3.247474414e-16;X=ga*(T+-9.322036725e-12)+1.575771013333333e-7;Y=ga*X+-.0009809873795;Z=ga*Y+20.49107091;_=ga*Z;$=ga*ga*(ga*(ba*(-13835.01485/fa+(ga*(ga*(ga*(T+(T+-9.322036725e-12))+X)+Y)+Z))+(W+_+75320.6691))-(ga*(ea+_+75320.6691)+-3730042.76))*518.2791167938085;break}if(O){ha=b+319|0;ia=ba;ja=ba;ka=ca}else{_=+zr(c[(b+536|0)>>2]|0,ba,3088,3e3,+h[ca>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;ha=b+319|0;ia=_;ja=+h[(c[O+8>>2]|0)+48>>3];ka=O}_=ja*3.247474414e-16;Z=ja*(_+-9.322036725e-12)+1.575771013333333e-7;Y=ja*Z+-.0009809873795;X=ja*Y+20.49107091;T=ja*X;la=ja*ja;$=la*(ja*(ba*(-13835.01485/ia+(ja*(ja*(ja*(_+(_+-9.322036725e-12))+Z)+Y)+X))+(W+T+75320.6691))-(ja*(ea+T+75320.6691)+-3730042.76))*518.2791167938085/+zr(c[(b+536|0)>>2]|0,la*la,3104,3e3,+h[ka>>3],(a[ha]|0)!=0|0)}else{if(L>0.0){ma=L;na=K}else{O=c[20226]|0;P=c[b+536>>2]|0;h[k>>3]=L;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];Q=e+552|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[O&31](P,e+552|0,3016,G);P=c[c[(b+4|0)>>2]>>2]|0;ma=+h[(c[P+8>>2]|0)+48>>3];na=P}if(ma>0.0){oa=ma;pa=na}else{P=c[20226]|0;O=c[b+536>>2]|0;h[k>>3]=ma;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Q=e+528|0;c[Q+0>>2]=c[3200+0>>2];c[Q+4>>2]=c[3200+4>>2];c[Q+8>>2]=c[3200+8>>2];c[Q+12>>2]=c[3200+12>>2];c[Q+16>>2]=c[3200+16>>2];c[Q+20>>2]=c[3200+20>>2];He[P&31](O,e+528|0,3016,F);O=c[c[(b+4|0)>>2]>>2]|0;oa=+h[(c[O+8>>2]|0)+48>>3];pa=O}la=oa*oa;O=oa!=0.0;if(la*la!=0.0){if(O){qa=oa;ra=oa}else{la=+zr(c[b+536>>2]|0,oa,3088,3e3,+h[pa>>3],(a[b+319|0]|0)!=0|0);qa=la;ra=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}la=ra*-9.953410979999998e-13;T=ra*(la+5.0671326075e-9)+-1206351476666667.0e-20;ea=ra*T+.01958809645;W=ra*ea+-12.0257785;X=ra*W;Y=ra*ra;$=Y*(ra*(oa*(2786.18102/qa+(ra*(ra*(ra*(la+(la+5.0671326075e-9))+T)+ea)+W))+(+da(+L)*2786.18102+X+-23313.1436))-(ra*(+da(+ma)*2786.18102+X+-23313.1436)+176685.0998))*518.2791167938085/(Y*Y);break}if(O){sa=oa;ta=oa;ua=pa}else{Y=+zr(c[b+536>>2]|0,oa,3088,3e3,+h[pa>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;sa=Y;ta=+h[(c[O+8>>2]|0)+48>>3];ua=O}Y=ta*-9.953410979999998e-13;X=ta*(Y+5.0671326075e-9)+-1206351476666667.0e-20;W=ta*X+.01958809645;ea=ta*W+-12.0257785;T=+da(+L)*2786.18102;la=ta*ea;Z=+da(+ma)*2786.18102;O=ta!=0.0;if(ta*ta*(ta*(oa*(2786.18102/sa+(ta*(ta*(ta*(Y+(Y+5.0671326075e-9))+X)+W)+ea))+(T+la+-23313.1436))-(ta*(Z+la+-23313.1436)+176685.0998))*518.2791167938085==0.0){if(O){va=ta;wa=ta}else{la=+zr(c[b+536>>2]|0,ta,3088,3e3,+h[ua>>3],(a[b+319|0]|0)!=0|0);va=la;wa=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}la=wa*-9.953410979999998e-13;ea=wa*(la+5.0671326075e-9)+-1206351476666667.0e-20;W=wa*ea+.01958809645;X=wa*W+-12.0257785;Y=wa*X;$=wa*wa*(wa*(ta*(2786.18102/va+(wa*(wa*(wa*(la+(la+5.0671326075e-9))+ea)+W)+X))+(T+Y+-23313.1436))-(wa*(Z+Y+-23313.1436)+176685.0998))*518.2791167938085;break}if(O){xa=b+319|0;ya=ta;za=ta;Aa=ua}else{Y=+zr(c[(b+536|0)>>2]|0,ta,3088,3e3,+h[ua>>3],(a[b+319|0]|0)!=0|0);O=c[c[(b+4|0)>>2]>>2]|0;xa=b+319|0;ya=Y;za=+h[(c[O+8>>2]|0)+48>>3];Aa=O}Y=za*-9.953410979999998e-13;X=za*(Y+5.0671326075e-9)+-1206351476666667.0e-20;W=za*X+.01958809645;ea=za*W+-12.0257785;la=za*ea;_=za*za;$=_*(za*(ta*(2786.18102/ya+(za*(za*(za*(Y+(Y+5.0671326075e-9))+X)+W)+ea))+(T+la+-23313.1436))-(za*(Z+la+-23313.1436)+176685.0998))*518.2791167938085/+zr(c[(b+536|0)>>2]|0,_*_,3104,3e3,+h[Aa>>3],(a[xa]|0)!=0|0)}}while(0);xa=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;Aa=c[c[(b+4|0)>>2]>>2]|0;za=+h[(c[Aa+8>>2]|0)+48>>3];do{if(xa){if(za>0.0){Ba=za;Ca=Aa}else{ua=c[20226]|0;pa=c[b+536>>2]|0;h[k>>3]=za;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];F=e+408|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[ua&31](pa,e+408|0,3016,z);pa=c[c[(b+4|0)>>2]>>2]|0;Ba=+h[(c[pa+8>>2]|0)+48>>3];Ca=pa}if(Ba>0.0){Da=Ba;Ea=Ca}else{pa=c[20226]|0;ua=c[b+536>>2]|0;h[k>>3]=Ba;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];F=e+384|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[pa&31](ua,e+384|0,3016,y);ua=c[c[(b+4|0)>>2]>>2]|0;Da=+h[(c[ua+8>>2]|0)+48>>3];Ea=ua}ya=Da*Da;ua=Da!=0.0;if(ya*ya!=0.0){if(ua){Fa=Da;Ga=Da}else{ya=+zr(c[b+536>>2]|0,Da,3088,3e3,+h[Ea>>3],(a[b+319|0]|0)!=0|0);Fa=ya;Ga=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}ya=Ga*6.130937398000001e-16;ta=Ga*(ya+-1.829795625e-11)+2.412801953333333e-7;wa=Ga*ta+-.001918351705;va=Ga*wa+33.2255293;sa=Ga*va;oa=Ga*Ga;Ha=oa*(Ga*(Da*(-20330.22397/Fa+(Ga*(Ga*(Ga*(ya+(ya+-1.829795625e-11))+ta)+wa)+va))+(+da(+za)*-20330.22397+sa+111596.395))-(Ga*(+da(+Ba)*-20330.22397+sa+111596.395)+-5025782.13))*276.5127187299628/(oa*oa);break}if(ua){Ia=Da;Ja=Da;Ka=Ea}else{oa=+zr(c[b+536>>2]|0,Da,3088,3e3,+h[Ea>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;Ia=oa;Ja=+h[(c[ua+8>>2]|0)+48>>3];Ka=ua}oa=Ja*6.130937398000001e-16;sa=Ja*(oa+-1.829795625e-11)+2.412801953333333e-7;va=Ja*sa+-.001918351705;wa=Ja*va+33.2255293;ta=+da(+za)*-20330.22397;ya=Ja*wa;ma=+da(+Ba)*-20330.22397;ua=Ja!=0.0;if(Ja*Ja*(Ja*(Da*(-20330.22397/Ia+(Ja*(Ja*(Ja*(oa+(oa+-1.829795625e-11))+sa)+va)+wa))+(ta+ya+111596.395))-(Ja*(ma+ya+111596.395)+-5025782.13))*276.5127187299628==0.0){if(ua){La=Ja;Ma=Ja}else{ya=+zr(c[b+536>>2]|0,Ja,3088,3e3,+h[Ka>>3],(a[b+319|0]|0)!=0|0);La=ya;Ma=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}ya=Ma*6.130937398000001e-16;wa=Ma*(ya+-1.829795625e-11)+2.412801953333333e-7;va=Ma*wa+-.001918351705;sa=Ma*va+33.2255293;oa=Ma*sa;Ha=Ma*Ma*(Ma*(Ja*(-20330.22397/La+(Ma*(Ma*(Ma*(ya+(ya+-1.829795625e-11))+wa)+va)+sa))+(ta+oa+111596.395))-(Ma*(ma+oa+111596.395)+-5025782.13))*276.5127187299628;break}if(ua){Na=b+319|0;Oa=Ja;Pa=Ja;Qa=Ka}else{oa=+zr(c[(b+536|0)>>2]|0,Ja,3088,3e3,+h[Ka>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;Na=b+319|0;Oa=oa;Pa=+h[(c[ua+8>>2]|0)+48>>3];Qa=ua}oa=Pa*6.130937398000001e-16;sa=Pa*(oa+-1.829795625e-11)+2.412801953333333e-7;va=Pa*sa+-.001918351705;wa=Pa*va+33.2255293;ya=Pa*wa;L=Pa*Pa;Ha=L*(Pa*(Ja*(-20330.22397/Oa+(Pa*(Pa*(Pa*(oa+(oa+-1.829795625e-11))+sa)+va)+wa))+(ta+ya+111596.395))-(Pa*(ma+ya+111596.395)+-5025782.13))*276.5127187299628/+zr(c[(b+536|0)>>2]|0,L*L,3104,3e3,+h[Qa>>3],(a[Na]|0)!=0|0)}else{if(za>0.0){Ra=za;Sa=Aa}else{ua=c[20226]|0;pa=c[b+536>>2]|0;h[k>>3]=za;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];F=e+456|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[ua&31](pa,e+456|0,3016,C);pa=c[c[(b+4|0)>>2]>>2]|0;Ra=+h[(c[pa+8>>2]|0)+48>>3];Sa=pa}if(Ra>0.0){Ta=Ra;Ua=Sa}else{pa=c[20226]|0;ua=c[b+536>>2]|0;h[k>>3]=Ra;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];F=e+432|0;c[F+0>>2]=c[3200+0>>2];c[F+4>>2]=c[3200+4>>2];c[F+8>>2]=c[3200+8>>2];c[F+12>>2]=c[3200+12>>2];c[F+16>>2]=c[3200+16>>2];c[F+20>>2]=c[3200+20>>2];He[pa&31](ua,e+432|0,3016,B);ua=c[c[(b+4|0)>>2]>>2]|0;Ta=+h[(c[ua+8>>2]|0)+48>>3];Ua=ua}L=Ta*Ta;ua=Ta!=0.0;if(L*L!=0.0){if(ua){Va=Ta;Wa=Ta}else{L=+zr(c[b+536>>2]|0,Ta,3088,3e3,+h[Ua>>3],(a[b+319|0]|0)!=0|0);Va=L;Wa=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=Wa*-2.638563984e-12;ya=Wa*(L+1.26528395e-8)+-2734724406666666.0e-20;ma=Wa*ya+.03782917795;ta=Wa*ma+-19.51705092;wa=Wa*ta;va=Wa*Wa;Ha=va*(Wa*(Ta*(3406.19186/Va+(Wa*(Wa*(Wa*(L+(L+1.26528395e-8))+ya)+ma)+ta))+(+da(+za)*3406.19186+wa+-27029.3289))-(Wa*(+da(+Ra)*3406.19186+wa+-27029.3289)+186204.4161))*276.5127187299628/(va*va);break}if(ua){Xa=Ta;Ya=Ta;Za=Ua}else{va=+zr(c[b+536>>2]|0,Ta,3088,3e3,+h[Ua>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;Xa=va;Ya=+h[(c[ua+8>>2]|0)+48>>3];Za=ua}va=Ya*-2.638563984e-12;wa=Ya*(va+1.26528395e-8)+-2734724406666666.0e-20;ta=Ya*wa+.03782917795;ma=Ya*ta+-19.51705092;ya=+da(+za)*3406.19186;L=Ya*ma;sa=+da(+Ra)*3406.19186;ua=Ya!=0.0;if(Ya*Ya*(Ya*(Ta*(3406.19186/Xa+(Ya*(Ya*(Ya*(va+(va+1.26528395e-8))+wa)+ta)+ma))+(ya+L+-27029.3289))-(Ya*(sa+L+-27029.3289)+186204.4161))*276.5127187299628==0.0){if(ua){_a=Ya;$a=Ya}else{L=+zr(c[b+536>>2]|0,Ya,3088,3e3,+h[Za>>3],(a[b+319|0]|0)!=0|0);_a=L;$a=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=$a*-2.638563984e-12;ma=$a*(L+1.26528395e-8)+-2734724406666666.0e-20;ta=$a*ma+.03782917795;wa=$a*ta+-19.51705092;va=$a*wa;Ha=$a*$a*($a*(Ya*(3406.19186/_a+($a*($a*($a*(L+(L+1.26528395e-8))+ma)+ta)+wa))+(ya+va+-27029.3289))-($a*(sa+va+-27029.3289)+186204.4161))*276.5127187299628;break}if(ua){ab=b+319|0;bb=Ya;cb=Ya;db=Za}else{va=+zr(c[(b+536|0)>>2]|0,Ya,3088,3e3,+h[Za>>3],(a[b+319|0]|0)!=0|0);ua=c[c[(b+4|0)>>2]>>2]|0;ab=b+319|0;bb=va;cb=+h[(c[ua+8>>2]|0)+48>>3];db=ua}va=cb*-2.638563984e-12;wa=cb*(va+1.26528395e-8)+-2734724406666666.0e-20;ta=cb*wa+.03782917795;ma=cb*ta+-19.51705092;L=cb*ma;oa=cb*cb;Ha=oa*(cb*(Ya*(3406.19186/bb+(cb*(cb*(cb*(va+(va+1.26528395e-8))+wa)+ta)+ma))+(ya+L+-27029.3289))-(cb*(sa+L+-27029.3289)+186204.4161))*276.5127187299628/+zr(c[(b+536|0)>>2]|0,oa*oa,3104,3e3,+h[db>>3],(a[ab]|0)!=0|0)}}while(0);ab=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;db=c[c[(b+4|0)>>2]>>2]|0;cb=+h[(c[db+8>>2]|0)+48>>3];do{if(ab){if(cb>0.0){eb=cb;fb=db}else{Za=c[20226]|0;Ua=c[b+536>>2]|0;h[k>>3]=cb;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];B=e+312|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Za&31](Ua,e+312|0,3016,v);Ua=c[c[(b+4|0)>>2]>>2]|0;eb=+h[(c[Ua+8>>2]|0)+48>>3];fb=Ua}if(eb>0.0){gb=eb;hb=fb}else{Ua=c[20226]|0;Za=c[b+536>>2]|0;h[k>>3]=eb;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];B=e+288|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Ua&31](Za,e+288|0,3016,u);Za=c[c[(b+4|0)>>2]>>2]|0;gb=+h[(c[Za+8>>2]|0)+48>>3];hb=Za}bb=gb*gb;Za=gb!=0.0;if(bb*bb!=0.0){if(Za){ib=gb;jb=gb}else{bb=+zr(c[b+536>>2]|0,gb,3088,3e3,+h[hb>>3],(a[b+319|0]|0)!=0|0);ib=bb;jb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}bb=jb*8.01934576e-16;Ya=jb*(bb+-2.3938513075e-11)+3.157072313333333e-7;$a=jb*Ya+-.00251033196;_a=jb*$a+45.3435684;Xa=jb*_a;Ta=jb*jb;kb=Ta*(jb*(gb*(-26597.91134/ib+(jb*(jb*(jb*(bb+(bb+-2.3938513075e-11))+Ya)+$a)+_a))+(+da(+cb)*-26597.91134+Xa+145558.2459))-(jb*(+da(+eb)*-26597.91134+Xa+145558.2459)+-6420731.680000001))*188.5555073270316/(Ta*Ta);break}if(Za){lb=gb;mb=gb;nb=hb}else{Ta=+zr(c[b+536>>2]|0,gb,3088,3e3,+h[hb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;lb=Ta;mb=+h[(c[Za+8>>2]|0)+48>>3];nb=Za}Ta=mb*8.01934576e-16;Xa=mb*(Ta+-2.3938513075e-11)+3.157072313333333e-7;_a=mb*Xa+-.00251033196;$a=mb*_a+45.3435684;Ya=+da(+cb)*-26597.91134;bb=mb*$a;Ra=+da(+eb)*-26597.91134;Za=mb!=0.0;if(mb*mb*(mb*(gb*(-26597.91134/lb+(mb*(mb*(mb*(Ta+(Ta+-2.3938513075e-11))+Xa)+_a)+$a))+(Ya+bb+145558.2459))-(mb*(Ra+bb+145558.2459)+-6420731.680000001))*188.5555073270316==0.0){if(Za){ob=mb;pb=mb}else{bb=+zr(c[b+536>>2]|0,mb,3088,3e3,+h[nb>>3],(a[b+319|0]|0)!=0|0);ob=bb;pb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}bb=pb*8.01934576e-16;$a=pb*(bb+-2.3938513075e-11)+3.157072313333333e-7;_a=pb*$a+-.00251033196;Xa=pb*_a+45.3435684;Ta=pb*Xa;kb=pb*pb*(pb*(mb*(-26597.91134/ob+(pb*(pb*(pb*(bb+(bb+-2.3938513075e-11))+$a)+_a)+Xa))+(Ya+Ta+145558.2459))-(pb*(Ra+Ta+145558.2459)+-6420731.680000001))*188.5555073270316;break}if(Za){qb=b+319|0;rb=mb;sb=mb;tb=nb}else{Ta=+zr(c[(b+536|0)>>2]|0,mb,3088,3e3,+h[nb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;qb=b+319|0;rb=Ta;sb=+h[(c[Za+8>>2]|0)+48>>3];tb=Za}Ta=sb*8.01934576e-16;Xa=sb*(Ta+-2.3938513075e-11)+3.157072313333333e-7;_a=sb*Xa+-.00251033196;$a=sb*_a+45.3435684;bb=sb*$a;za=sb*sb;kb=za*(sb*(mb*(-26597.91134/rb+(sb*(sb*(sb*(Ta+(Ta+-2.3938513075e-11))+Xa)+_a)+$a))+(Ya+bb+145558.2459))-(sb*(Ra+bb+145558.2459)+-6420731.680000001))*188.5555073270316/+zr(c[(b+536|0)>>2]|0,za*za,3104,3e3,+h[tb>>3],(a[qb]|0)!=0|0)}else{if(cb>0.0){ub=cb;vb=db}else{Za=c[20226]|0;Ua=c[b+536>>2]|0;h[k>>3]=cb;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];B=e+360|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Za&31](Ua,e+360|0,3016,x);Ua=c[c[(b+4|0)>>2]>>2]|0;ub=+h[(c[Ua+8>>2]|0)+48>>3];vb=Ua}if(ub>0.0){wb=ub;xb=vb}else{Ua=c[20226]|0;Za=c[b+536>>2]|0;h[k>>3]=ub;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];B=e+336|0;c[B+0>>2]=c[3200+0>>2];c[B+4>>2]=c[3200+4>>2];c[B+8>>2]=c[3200+8>>2];c[B+12>>2]=c[3200+12>>2];c[B+16>>2]=c[3200+16>>2];c[B+20>>2]=c[3200+20>>2];He[Ua&31](Za,e+336|0,3016,w);Za=c[c[(b+4|0)>>2]>>2]|0;wb=+h[(c[Za+8>>2]|0)+48>>3];xb=Za}za=wb*wb;Za=wb!=0.0;if(za*za!=0.0){if(Za){yb=wb;zb=wb}else{za=+zr(c[b+536>>2]|0,wb,3088,3e3,+h[xb>>3],(a[b+319|0]|0)!=0|0);yb=za;zb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}za=zb*-4.685975988e-12;bb=zb*(za+2.2037059775e-8)+-458769423.0e-13;Ra=zb*bb+.05944763725;Ya=zb*Ra+-29.39466091;$a=zb*Ya;_a=zb*zb;kb=_a*(zb*(wb*(4656.27081/yb+(zb*(zb*(zb*(za+(za+2.2037059775e-8))+bb)+Ra)+Ya))+(+da(+cb)*4656.27081+$a+-35403.3527))-(zb*(+da(+ub)*4656.27081+$a+-35403.3527)+243314.4337))*188.5555073270316/(_a*_a);break}if(Za){Ab=wb;Bb=wb;Cb=xb}else{_a=+zr(c[b+536>>2]|0,wb,3088,3e3,+h[xb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;Ab=_a;Bb=+h[(c[Za+8>>2]|0)+48>>3];Cb=Za}_a=Bb*-4.685975988e-12;$a=Bb*(_a+2.2037059775e-8)+-458769423.0e-13;Ya=Bb*$a+.05944763725;Ra=Bb*Ya+-29.39466091;bb=+da(+cb)*4656.27081;za=Bb*Ra;Xa=+da(+ub)*4656.27081;Za=Bb!=0.0;if(Bb*Bb*(Bb*(wb*(4656.27081/Ab+(Bb*(Bb*(Bb*(_a+(_a+2.2037059775e-8))+$a)+Ya)+Ra))+(bb+za+-35403.3527))-(Bb*(Xa+za+-35403.3527)+243314.4337))*188.5555073270316==0.0){if(Za){Db=Bb;Eb=Bb}else{za=+zr(c[b+536>>2]|0,Bb,3088,3e3,+h[Cb>>3],(a[b+319|0]|0)!=0|0);Db=za;Eb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}za=Eb*-4.685975988e-12;Ra=Eb*(za+2.2037059775e-8)+-458769423.0e-13;Ya=Eb*Ra+.05944763725;$a=Eb*Ya+-29.39466091;_a=Eb*$a;kb=Eb*Eb*(Eb*(Bb*(4656.27081/Db+(Eb*(Eb*(Eb*(za+(za+2.2037059775e-8))+Ra)+Ya)+$a))+(bb+_a+-35403.3527))-(Eb*(Xa+_a+-35403.3527)+243314.4337))*188.5555073270316;break}if(Za){Fb=b+319|0;Gb=Bb;Hb=Bb;Ib=Cb}else{_a=+zr(c[(b+536|0)>>2]|0,Bb,3088,3e3,+h[Cb>>3],(a[b+319|0]|0)!=0|0);Za=c[c[(b+4|0)>>2]>>2]|0;Fb=b+319|0;Gb=_a;Hb=+h[(c[Za+8>>2]|0)+48>>3];Ib=Za}_a=Hb*-4.685975988e-12;$a=Hb*(_a+2.2037059775e-8)+-458769423.0e-13;Ya=Hb*$a+.05944763725;Ra=Hb*Ya+-29.39466091;za=Hb*Ra;Ta=Hb*Hb;kb=Ta*(Hb*(Bb*(4656.27081/Gb+(Hb*(Hb*(Hb*(_a+(_a+2.2037059775e-8))+$a)+Ya)+Ra))+(bb+za+-35403.3527))-(Hb*(Xa+za+-35403.3527)+243314.4337))*188.5555073270316/+zr(c[(b+536|0)>>2]|0,Ta*Ta,3104,3e3,+h[Ib>>3],(a[Fb]|0)!=0|0)}}while(0);Fb=(yu(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;Ib=c[c[(b+4|0)>>2]>>2]|0;Hb=+h[(c[Ib+8>>2]|0)+48>>3];c[e+592>>2]=b;c[e+600>>2]=d;c[e+2112>>2]=Fb;c[e+2120>>2]=Ib;g[e+2128>>2]=Hb;g[e+6448>>2]=$;g[e+6456>>2]=Ha;g[e+6464>>2]=kb;c[e+6576>>2]=t;c[e+6584>>2]=s;c[e+6600>>2]=r;c[e+6608>>2]=q;c[e+6616>>2]=p;c[e+6624>>2]=o;c[e+6632>>2]=n;c[e+6640>>2]=m;c[e+6648>>2]=l;c[e+6656>>2]=j;c[e+6664>>2]=f;c[e+6696>>2]=0;c[e+6700>>2]=0;_setLinearMatrixA94$0(e);H=c[e+6696>>2]|0;A=c[e+6700>>2]|0;I=+g[e+6700>>2];c[e+6696>>2]=0;c[e+6700>>2]=0;if((H|0)==5){return}}function Wg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0.0,_a=0.0,$a=0.0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0;e=i;i=i+296|0;f=e;g=e+24|0;j=e+48|0;l=e+72|0;m=e+96|0;n=e+120|0;o=e+144|0;p=e+168|0;q=e+192|0;r=e+216|0;s=e+240|0;t=e+264|0;u=e+288|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=b+4|0;H=c[(c[c[G>>2]>>2]|0)+8>>2]|0;I=H+48|0;J=d+36|0;h[c[J>>2]>>3]=-(+h[H+528>>3]*+h[I>>3])- +h[H+512>>3];H=(yu(+h[I>>3],1.0e3)|0)<<24>>24==0;I=c[c[G>>2]>>2]|0;K=+h[(c[I+8>>2]|0)+48>>3];d=K>0.0;do{if(H){if(d){L=K;M=I}else{N=c[20226]|0;O=c[b+536>>2]|0;P=E;h[k>>3]=K;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=N;N=s;Q=3200;c[N+0>>2]=c[Q+0>>2];c[N+4>>2]=c[Q+4>>2];c[N+8>>2]=c[Q+8>>2];c[N+12>>2]=c[Q+12>>2];c[N+16>>2]=c[Q+16>>2];c[N+20>>2]=c[Q+20>>2];He[P&31](O,s,3016,E);O=c[c[G>>2]>>2]|0;L=+h[(c[O+8>>2]|0)+48>>3];M=O}R=L*(+da(+K)*-13835.01485+L*(L*(L*(L*(L*3.247474414e-16+-9.322036725e-12)+1.575771013333333e-7)+-.0009809873795)+20.49107091)+75320.6691)+-3730042.76;if(L!=0.0){S=R/L;break}if(R==0.0){S=R;break}S=R/+zr(c[b+536>>2]|0,L,3088,3176,+h[M>>3],(a[b+319|0]|0)!=0|0)}else{if(d){T=K;U=I}else{O=c[20226]|0;P=c[b+536>>2]|0;Q=F;h[k>>3]=K;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Q=O;O=t;N=3200;c[O+0>>2]=c[N+0>>2];c[O+4>>2]=c[N+4>>2];c[O+8>>2]=c[N+8>>2];c[O+12>>2]=c[N+12>>2];c[O+16>>2]=c[N+16>>2];c[O+20>>2]=c[N+20>>2];He[Q&31](P,t,3016,F);P=c[c[G>>2]>>2]|0;T=+h[(c[P+8>>2]|0)+48>>3];U=P}R=T*(+da(+K)*2786.18102+T*(T*(T*(T*(T*-9.953410979999998e-13+5.0671326075e-9)+-1206351476666667.0e-20)+.01958809645)+-12.0257785)+-23313.1436)+176685.0998;if(T!=0.0){S=R/T;break}if(R==0.0){S=R;break}S=R/+zr(c[b+536>>2]|0,T,3088,3176,+h[U>>3],(a[b+319|0]|0)!=0|0)}}while(0);T=S*518.2791167938085;U=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;F=c[c[G>>2]>>2]|0;S=+h[(c[F+8>>2]|0)+48>>3];t=S>0.0;do{if(U){if(t){V=S;W=F}else{I=c[20226]|0;d=c[b+536>>2]|0;M=C;h[k>>3]=S;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=I;I=q;E=3200;c[I+0>>2]=c[E+0>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2];c[I+16>>2]=c[E+16>>2];c[I+20>>2]=c[E+20>>2];He[M&31](d,q,3016,C);d=c[c[G>>2]>>2]|0;V=+h[(c[d+8>>2]|0)+48>>3];W=d}K=V*(+da(+S)*-20330.22397+V*(V*(V*(V*(V*6.130937398000001e-16+-1.829795625e-11)+2.412801953333333e-7)+-.001918351705)+33.2255293)+111596.395)+-5025782.13;if(V!=0.0){X=K/V;break}if(K==0.0){X=K;break}X=K/+zr(c[b+536>>2]|0,V,3088,3176,+h[W>>3],(a[b+319|0]|0)!=0|0)}else{if(t){Y=S;Z=F}else{d=c[20226]|0;M=c[b+536>>2]|0;E=D;h[k>>3]=S;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=d;d=r;I=3200;c[d+0>>2]=c[I+0>>2];c[d+4>>2]=c[I+4>>2];c[d+8>>2]=c[I+8>>2];c[d+12>>2]=c[I+12>>2];c[d+16>>2]=c[I+16>>2];c[d+20>>2]=c[I+20>>2];He[E&31](M,r,3016,D);M=c[c[G>>2]>>2]|0;Y=+h[(c[M+8>>2]|0)+48>>3];Z=M}K=Y*(+da(+S)*3406.19186+Y*(Y*(Y*(Y*(Y*-2.638563984e-12+1.26528395e-8)+-2734724406666666.0e-20)+.03782917795)+-19.51705092)+-27029.3289)+186204.4161;if(Y!=0.0){X=K/Y;break}if(K==0.0){X=K;break}X=K/+zr(c[b+536>>2]|0,Y,3088,3176,+h[Z>>3],(a[b+319|0]|0)!=0|0)}}while(0);Y=X*276.5127187299628;Z=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;D=c[c[G>>2]>>2]|0;X=+h[(c[D+8>>2]|0)+48>>3];r=X>0.0;do{if(Z){if(r){_=X;$=D}else{F=c[20226]|0;t=c[b+536>>2]|0;W=A;h[k>>3]=X;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];W=F;F=o;C=3200;c[F+0>>2]=c[C+0>>2];c[F+4>>2]=c[C+4>>2];c[F+8>>2]=c[C+8>>2];c[F+12>>2]=c[C+12>>2];c[F+16>>2]=c[C+16>>2];c[F+20>>2]=c[C+20>>2];He[W&31](t,o,3016,A);t=c[c[G>>2]>>2]|0;_=+h[(c[t+8>>2]|0)+48>>3];$=t}S=_*(+da(+X)*-26597.91134+_*(_*(_*(_*(_*8.01934576e-16+-2.3938513075e-11)+3.157072313333333e-7)+-.00251033196)+45.3435684)+145558.2459)+-6420731.680000001;if(_!=0.0){aa=S/_;break}if(S==0.0){aa=S;break}aa=S/+zr(c[b+536>>2]|0,_,3088,3176,+h[$>>3],(a[b+319|0]|0)!=0|0)}else{if(r){ba=X;ca=D}else{t=c[20226]|0;W=c[b+536>>2]|0;C=B;h[k>>3]=X;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=t;t=p;F=3200;c[t+0>>2]=c[F+0>>2];c[t+4>>2]=c[F+4>>2];c[t+8>>2]=c[F+8>>2];c[t+12>>2]=c[F+12>>2];c[t+16>>2]=c[F+16>>2];c[t+20>>2]=c[F+20>>2];He[C&31](W,p,3016,B);W=c[c[G>>2]>>2]|0;ba=+h[(c[W+8>>2]|0)+48>>3];ca=W}S=ba*(+da(+X)*4656.27081+ba*(ba*(ba*(ba*(ba*-4.685975988e-12+2.2037059775e-8)+-458769423.0e-13)+.05944763725)+-29.39466091)+-35403.3527)+243314.4337;if(ba!=0.0){aa=S/ba;break}if(S==0.0){aa=S;break}aa=S/+zr(c[b+536>>2]|0,ba,3088,3176,+h[ca>>3],(a[b+319|0]|0)!=0|0)}}while(0);ba=aa*188.5555073270316;ca=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;B=c[c[G>>2]>>2]|0;aa=+h[(c[B+8>>2]|0)+48>>3];p=aa>0.0;do{if(ca){if(p){ea=aa;fa=B}else{D=c[20226]|0;r=c[b+536>>2]|0;$=y;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=D;D=m;A=3200;c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];c[D+12>>2]=c[A+12>>2];c[D+16>>2]=c[A+16>>2];c[D+20>>2]=c[A+20>>2];He[$&31](r,m,3016,y);r=c[c[G>>2]>>2]|0;ea=+h[(c[r+8>>2]|0)+48>>3];fa=r}X=ea*(+da(+aa)*-32560.5151+ea*(ea*(ea*(ea*(ea*1.05012705e-15+-3.054734245e-11)+3.933953493333333e-7)+-.003098958405)+57.3673275)+177452.656)+-7682322.45;if(ea!=0.0){ga=X/ea;break}if(X==0.0){ga=X;break}ga=X/+zr(c[b+536>>2]|0,ea,3088,3176,+h[fa>>3],(a[b+319|0]|0)!=0|0)}else{if(p){ha=aa;ia=B}else{r=c[20226]|0;$=c[b+536>>2]|0;A=z;h[k>>3]=aa;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r;r=n;D=3200;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[r+12>>2]=c[D+12>>2];c[r+16>>2]=c[D+16>>2];c[r+20>>2]=c[D+20>>2];He[A&31]($,n,3016,z);$=c[c[G>>2]>>2]|0;ha=+h[(c[$+8>>2]|0)+48>>3];ia=$}X=ha*(+da(+aa)*6176.331819999999+ha*(ha*(ha*(ha*(ha*-6.4033411e-12+2.9991908725e-8)+-6200167196666667.0e-20)+.0792327142)+-38.9156212)+-45403.63390000001)+317587.254;if(ha!=0.0){ga=X/ha;break}if(X==0.0){ga=X;break}ga=X/+zr(c[b+536>>2]|0,ha,3088,3176,+h[ia>>3],(a[b+319|0]|0)!=0|0)}}while(0);ha=ga*143.0515706563069;ia=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;z=c[c[G>>2]>>2]|0;ga=+h[(c[z+8>>2]|0)+48>>3];n=ga>0.0;do{if(ia){if(n){ja=ga;ka=z}else{B=c[20226]|0;p=c[b+536>>2]|0;fa=w;h[k>>3]=ga;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=B;B=j;y=3200;c[B+0>>2]=c[y+0>>2];c[B+4>>2]=c[y+4>>2];c[B+8>>2]=c[y+8>>2];c[B+12>>2]=c[y+12>>2];c[B+16>>2]=c[y+16>>2];c[B+20>>2]=c[y+20>>2];He[fa&31](p,j,3016,w);p=c[c[G>>2]>>2]|0;ja=+h[(c[p+8>>2]|0)+48>>3];ka=p}aa=ja*(+da(+ga)*-2239.249073+ja*(ja*(ja*(ja*(ja*2.123908772e-16+-4.8077637125e-12)+4.97268893e-8)+-.000306984275)+6.06694922)+12832.10415)+-587712.406;if(ja!=0.0){la=aa/ja;break}if(aa==0.0){la=aa;break}la=aa/+zr(c[b+536>>2]|0,ja,3088,3176,+h[ka>>3],(a[b+319|0]|0)!=0|0)}else{if(n){ma=ga;na=z}else{p=c[20226]|0;fa=c[b+536>>2]|0;y=x;h[k>>3]=ga;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=p;p=l;B=3200;c[p+0>>2]=c[B+0>>2];c[p+4>>2]=c[B+4>>2];c[p+8>>2]=c[B+8>>2];c[p+12>>2]=c[B+12>>2];c[p+16>>2]=c[B+16>>2];c[p+20>>2]=c[B+20>>2];He[y&31](fa,l,3016,x);fa=c[c[G>>2]>>2]|0;ma=+h[(c[fa+8>>2]|0)+48>>3];na=fa}aa=ma*(+da(+ga)*-381.846182+ma*(ma*(ma*(ma*(ma*5.039411618000001e-13+-2.406448405e-9)+4615487296666666.0e-21)+-.004265457205)+6.08273836)+710.846086)+-22103.71497;if(ma!=0.0){la=aa/ma;break}if(aa==0.0){la=aa;break}la=aa/+zr(c[b+536>>2]|0,ma,3088,3176,+h[na>>3],(a[b+319|0]|0)!=0|0)}}while(0);ma=la*296.8033869505308;na=(yu(+h[(c[(c[c[G>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;x=c[c[G>>2]>>2]|0;la=+h[(c[x+8>>2]|0)+48>>3];l=la>0.0;if(na){if(l){oa=la;pa=x}else{na=c[20226]|0;z=c[b+536>>2]|0;n=u;h[k>>3]=la;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=na;na=f;ka=3200;c[na+0>>2]=c[ka+0>>2];c[na+4>>2]=c[ka+4>>2];c[na+8>>2]=c[ka+8>>2];c[na+12>>2]=c[ka+12>>2];c[na+16>>2]=c[ka+16>>2];c[na+20>>2]=c[ka+20>>2];He[n&31](z,f,3016,u);u=c[c[G>>2]>>2]|0;oa=+h[(c[u+8>>2]|0)+48>>3];pa=u}ga=oa*(+da(+la)*-1788.791477+oa*(oa*(oa*(oa*(oa*1.266007318e-16+-4.72763328e-13)+1.621225626666666e-9)+-461157839.0e-13)+8.29152319)+-39083.5059)+-117696.2419;if(oa!=0.0){qa=ga/oa;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}if(ga==0.0){qa=ga;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}qa=ga/+zr(c[b+536>>2]|0,oa,3088,3176,+h[pa>>3],(a[b+319|0]|0)!=0|0);ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}else{if(l){pb=la;qb=x}else{x=c[20226]|0;l=c[b+536>>2]|0;pa=v;h[k>>3]=la;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];pa=x;x=g;u=3200;c[x+0>>2]=c[u+0>>2];c[x+4>>2]=c[u+4>>2];c[x+8>>2]=c[u+8>>2];c[x+12>>2]=c[u+12>>2];c[x+16>>2]=c[u+16>>2];c[x+20>>2]=c[u+20>>2];He[pa&31](l,g,3016,v);v=c[c[G>>2]>>2]|0;pb=+h[(c[v+8>>2]|0)+48>>3];qb=v}oa=pb*(+da(+la)*-626.411601+pb*(pb*(pb*(pb*(pb*5.699355602e-14+-1.922497195e-10)+-7.091029093333333e-8)+.001251906908)+5.30172524)+-45281.9846)+-49436.5054;if(pb!=0.0){qa=oa/pb;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}if(oa==0.0){qa=oa;ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}qa=oa/+zr(c[b+536>>2]|0,pb,3088,3176,+h[qb>>3],(a[b+319|0]|0)!=0|0);ra=qa*188.9244822140674;sa=c[G>>2]|0;ta=c[sa>>2]|0;ua=ta;va=ua+8|0;wa=va;xa=c[wa>>2]|0;ya=xa;za=ya+64|0;Aa=za;Ba=+h[Aa>>3];Ca=T+5274515.379810827;Da=Ca*Ba;Ea=xa;Fa=Ea+72|0;Ga=Fa;Ha=+h[Ga>>3];Ia=Y+3184110.234314098;Ja=Ia*Ha;Ka=xa;La=Ka+80|0;Ma=La;Na=+h[Ma>>3];Oa=ba+2708233.107959476;Pa=Oa*Na;Qa=xa;Ra=Qa+88|0;Sa=Ra;Ta=+h[Sa>>3];Ua=ha+2495065.310673031;Va=Ua*Ta;Wa=xa;Xa=Wa+96|0;Ya=Xa;Za=+h[Ya>>3];_a=ma+309498.4543111511;$a=_a*Za;ab=xa;bb=ab+104|0;cb=bb;db=+h[cb>>3];eb=ra+9154284.16591872;fb=eb*db;gb=$a+fb;hb=Va+gb;ib=Pa+hb;jb=Ja+ib;kb=Da+jb;lb=c[J>>2]|0;mb=lb;nb=mb+8|0;ob=nb;h[ob>>3]=kb;i=e;return}}function _setLinearMatrixA94$0(b){b=b|0;var d=0,e=0,f=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0.0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0,Za=0.0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0,mb=0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0.0,zb=0.0,Ab=0,Bb=0,Cb=0,Db=0.0,Eb=0.0,Fb=0,Gb=0,Hb=0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0,Ub=0.0,Vb=0.0,Wb=0,Xb=0.0,Yb=0.0,Zb=0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0,hc=0.0,ic=0.0,jc=0,kc=0.0,lc=0.0,mc=0;d=c[b+592>>2]|0;e=c[b+600>>2]|0;f=c[b+2112>>2]|0;j=c[b+2120>>2]|0;l=+g[b+2128>>2];m=+g[b+6448>>2];n=+g[b+6456>>2];o=+g[b+6464>>2];p=c[b+6576>>2]|0;q=c[b+6584>>2]|0;r=c[b+6600>>2]|0;s=c[b+6608>>2]|0;t=c[b+6616>>2]|0;u=c[b+6624>>2]|0;v=c[b+6632>>2]|0;w=c[b+6640>>2]|0;x=c[b+6648>>2]|0;y=c[b+6656>>2]|0;z=c[b+6664>>2]|0;a:do{do{if(f){if(l>0.0){A=l;B=j}else{C=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=l;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];E=b+216|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[C&31](D,b+216|0,3016,r);D=c[c[(d+4|0)>>2]>>2]|0;A=+h[(c[D+8>>2]|0)+48>>3];B=D}if(A>0.0){F=A;G=B}else{D=c[20226]|0;C=c[d+536>>2]|0;h[k>>3]=A;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];E=b+192|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[D&31](C,b+192|0,3016,s);C=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[C+8>>2]|0)+48>>3];G=C}H=F*F;C=F!=0.0;if(H*H!=0.0){if(C){I=F;J=F}else{H=+zr(c[d+536>>2]|0,F,3088,3e3,+h[G>>3],(a[d+319|0]|0)!=0|0);I=H;J=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}H=J*1.05012705e-15;K=J*(H+-3.054734245e-11)+3.933953493333333e-7;L=J*K+-.003098958405;M=J*L+57.3673275;N=J*M;O=J*J;P=O*(J*(F*(-32560.5151/I+(J*(J*(J*(H+(H+-3.054734245e-11))+K)+L)+M))+(+da(+l)*-32560.5151+N+177452.656))-(J*(+da(+A)*-32560.5151+N+177452.656)+-7682322.45))*143.0515706563069/(O*O);break}if(C){Q=F;R=F;S=G}else{O=+zr(c[d+536>>2]|0,F,3088,3e3,+h[G>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;Q=O;R=+h[(c[C+8>>2]|0)+48>>3];S=C}O=R*1.05012705e-15;N=R*(O+-3.054734245e-11)+3.933953493333333e-7;M=R*N+-.003098958405;L=R*M+57.3673275;K=+da(+l)*-32560.5151;H=R*L;T=+da(+A)*-32560.5151;C=R!=0.0;if(R*R*(R*(F*(-32560.5151/Q+(R*(R*(R*(O+(O+-3.054734245e-11))+N)+M)+L))+(K+H+177452.656))-(R*(T+H+177452.656)+-7682322.45))*143.0515706563069==0.0){if(C){U=R;V=R}else{H=+zr(c[d+536>>2]|0,R,3088,3e3,+h[S>>3],(a[d+319|0]|0)!=0|0);U=H;V=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}H=V*1.05012705e-15;L=V*(H+-3.054734245e-11)+3.933953493333333e-7;M=V*L+-.003098958405;N=V*M+57.3673275;O=V*N;P=V*V*(V*(R*(-32560.5151/U+(V*(V*(V*(H+(H+-3.054734245e-11))+L)+M)+N))+(K+O+177452.656))-(V*(T+O+177452.656)+-7682322.45))*143.0515706563069;break}if(C){W=d+319|0;X=R;Y=R;Z=S}else{O=+zr(c[(d+536|0)>>2]|0,R,3088,3e3,+h[S>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;W=d+319|0;X=O;Y=+h[(c[C+8>>2]|0)+48>>3];Z=C}O=Y*1.05012705e-15;N=Y*(O+-3.054734245e-11)+3.933953493333333e-7;M=Y*N+-.003098958405;L=Y*M+57.3673275;H=Y*L;_=Y*Y;P=_*(Y*(R*(-32560.5151/X+(Y*(Y*(Y*(O+(O+-3.054734245e-11))+N)+M)+L))+(K+H+177452.656))-(Y*(T+H+177452.656)+-7682322.45))*143.0515706563069/+zr(c[(d+536|0)>>2]|0,_*_,3104,3e3,+h[Z>>3],(a[W]|0)!=0|0)}else{if(l>0.0){$=l;aa=j}else{C=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=l;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];E=b+264|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[C&31](D,b+264|0,3016,p);D=c[c[(d+4|0)>>2]>>2]|0;$=+h[(c[D+8>>2]|0)+48>>3];aa=D}if($>0.0){ba=$;ca=aa}else{D=c[20226]|0;C=c[d+536>>2]|0;h[k>>3]=$;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];E=b+240|0;c[E+0>>2]=c[3200+0>>2];c[E+4>>2]=c[3200+4>>2];c[E+8>>2]=c[3200+8>>2];c[E+12>>2]=c[3200+12>>2];c[E+16>>2]=c[3200+16>>2];c[E+20>>2]=c[3200+20>>2];He[D&31](C,b+240|0,3016,q);C=c[c[(d+4|0)>>2]>>2]|0;ba=+h[(c[C+8>>2]|0)+48>>3];ca=C}_=ba*ba;C=ba!=0.0;if(_*_!=0.0){if(C){ea=ba;fa=ba}else{_=+zr(c[d+536>>2]|0,ba,3088,3e3,+h[ca>>3],(a[d+319|0]|0)!=0|0);ea=_;fa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=fa*-6.4033411e-12;H=fa*(_+2.9991908725e-8)+-6200167196666667.0e-20;T=fa*H+.0792327142;K=fa*T+-38.9156212;L=fa*K;M=fa*fa;P=M*(fa*(ba*(6176.331819999999/ea+(fa*(fa*(fa*(_+(_+2.9991908725e-8))+H)+T)+K))+(+da(+l)*6176.331819999999+L+-45403.63390000001))-(fa*(+da(+$)*6176.331819999999+L+-45403.63390000001)+317587.254))*143.0515706563069/(M*M);break}if(C){ga=ba;ha=ba;ia=ca}else{M=+zr(c[d+536>>2]|0,ba,3088,3e3,+h[ca>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;ga=M;ha=+h[(c[C+8>>2]|0)+48>>3];ia=C}M=ha*-6.4033411e-12;L=ha*(M+2.9991908725e-8)+-6200167196666667.0e-20;K=ha*L+.0792327142;T=ha*K+-38.9156212;H=+da(+l)*6176.331819999999;_=ha*T;N=+da(+$)*6176.331819999999;C=ha!=0.0;if(ha*ha*(ha*(ba*(6176.331819999999/ga+(ha*(ha*(ha*(M+(M+2.9991908725e-8))+L)+K)+T))+(H+_+-45403.63390000001))-(ha*(N+_+-45403.63390000001)+317587.254))*143.0515706563069==0.0){if(C){ja=ha;ka=ha}else{_=+zr(c[d+536>>2]|0,ha,3088,3e3,+h[ia>>3],(a[d+319|0]|0)!=0|0);ja=_;ka=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=ka*-6.4033411e-12;T=ka*(_+2.9991908725e-8)+-6200167196666667.0e-20;K=ka*T+.0792327142;L=ka*K+-38.9156212;M=ka*L;P=ka*ka*(ka*(ha*(6176.331819999999/ja+(ka*(ka*(ka*(_+(_+2.9991908725e-8))+T)+K)+L))+(H+M+-45403.63390000001))-(ka*(N+M+-45403.63390000001)+317587.254))*143.0515706563069;break}if(C){la=d+319|0;ma=ha;na=ha;oa=ia}else{M=+zr(c[(d+536|0)>>2]|0,ha,3088,3e3,+h[ia>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;la=d+319|0;ma=M;na=+h[(c[C+8>>2]|0)+48>>3];oa=C}M=na*-6.4033411e-12;L=na*(M+2.9991908725e-8)+-6200167196666667.0e-20;K=na*L+.0792327142;T=na*K+-38.9156212;_=na*T;O=na*na;P=O*(na*(ha*(6176.331819999999/ma+(na*(na*(na*(M+(M+2.9991908725e-8))+L)+K)+T))+(H+_+-45403.63390000001))-(na*(N+_+-45403.63390000001)+317587.254))*143.0515706563069/+zr(c[(d+536|0)>>2]|0,O*O,3104,3e3,+h[oa>>3],(a[la]|0)!=0|0)}}while(0);C=(yu(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;D=c[c[(d+4|0)>>2]>>2]|0;O=+h[(c[D+8>>2]|0)+48>>3];do{if(C){if(O>0.0){pa=O;qa=D}else{E=c[20226]|0;ra=c[d+536>>2]|0;h[k>>3]=O;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sa=b+120|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[E&31](ra,b+120|0,3016,v);ra=c[c[(d+4|0)>>2]>>2]|0;pa=+h[(c[ra+8>>2]|0)+48>>3];qa=ra}if(pa>0.0){ta=pa;ua=qa}else{ra=c[20226]|0;E=c[d+536>>2]|0;h[k>>3]=pa;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sa=b+96|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[ra&31](E,b+96|0,3016,w);E=c[c[(d+4|0)>>2]>>2]|0;ta=+h[(c[E+8>>2]|0)+48>>3];ua=E}_=ta*ta;E=ta!=0.0;if(_*_!=0.0){if(E){va=ta;wa=ta}else{_=+zr(c[d+536>>2]|0,ta,3088,3e3,+h[ua>>3],(a[d+319|0]|0)!=0|0);va=_;wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=wa*2.123908772e-16;N=wa*(_+-4.8077637125e-12)+4.97268893e-8;H=wa*N+-.000306984275;T=wa*H+6.06694922;K=wa*T;L=wa*wa;xa=L*(wa*(ta*(-2239.249073/va+(wa*(wa*(wa*(_+(_+-4.8077637125e-12))+N)+H)+T))+(+da(+O)*-2239.249073+K+12832.10415))-(wa*(+da(+pa)*-2239.249073+K+12832.10415)+-587712.406))*296.8033869505308/(L*L);break}if(E){ya=ta;za=ta;Aa=ua}else{L=+zr(c[d+536>>2]|0,ta,3088,3e3,+h[ua>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;ya=L;za=+h[(c[E+8>>2]|0)+48>>3];Aa=E}L=za*2.123908772e-16;K=za*(L+-4.8077637125e-12)+4.97268893e-8;T=za*K+-.000306984275;H=za*T+6.06694922;N=+da(+O)*-2239.249073;_=za*H;M=+da(+pa)*-2239.249073;E=za!=0.0;if(za*za*(za*(ta*(-2239.249073/ya+(za*(za*(za*(L+(L+-4.8077637125e-12))+K)+T)+H))+(N+_+12832.10415))-(za*(M+_+12832.10415)+-587712.406))*296.8033869505308==0.0){if(E){Ba=za;Ca=za}else{_=+zr(c[d+536>>2]|0,za,3088,3e3,+h[Aa>>3],(a[d+319|0]|0)!=0|0);Ba=_;Ca=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}_=Ca*2.123908772e-16;H=Ca*(_+-4.8077637125e-12)+4.97268893e-8;T=Ca*H+-.000306984275;K=Ca*T+6.06694922;L=Ca*K;xa=Ca*Ca*(Ca*(za*(-2239.249073/Ba+(Ca*(Ca*(Ca*(_+(_+-4.8077637125e-12))+H)+T)+K))+(N+L+12832.10415))-(Ca*(M+L+12832.10415)+-587712.406))*296.8033869505308;break}if(E){Da=d+319|0;Ea=za;Fa=za;Ga=Aa}else{L=+zr(c[(d+536|0)>>2]|0,za,3088,3e3,+h[Aa>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;Da=d+319|0;Ea=L;Fa=+h[(c[E+8>>2]|0)+48>>3];Ga=E}L=Fa*2.123908772e-16;K=Fa*(L+-4.8077637125e-12)+4.97268893e-8;T=Fa*K+-.000306984275;H=Fa*T+6.06694922;_=Fa*H;Ha=Fa*Fa;xa=Ha*(Fa*(za*(-2239.249073/Ea+(Fa*(Fa*(Fa*(L+(L+-4.8077637125e-12))+K)+T)+H))+(N+_+12832.10415))-(Fa*(M+_+12832.10415)+-587712.406))*296.8033869505308/+zr(c[(d+536|0)>>2]|0,Ha*Ha,3104,3e3,+h[Ga>>3],(a[Da]|0)!=0|0)}else{if(O>0.0){Ia=O;Ja=D}else{E=c[20226]|0;ra=c[d+536>>2]|0;h[k>>3]=O;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];sa=b+168|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[E&31](ra,b+168|0,3016,t);ra=c[c[(d+4|0)>>2]>>2]|0;Ia=+h[(c[ra+8>>2]|0)+48>>3];Ja=ra}if(Ia>0.0){Ka=Ia;La=Ja}else{ra=c[20226]|0;E=c[d+536>>2]|0;h[k>>3]=Ia;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];sa=b+144|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[ra&31](E,b+144|0,3016,u);E=c[c[(d+4|0)>>2]>>2]|0;Ka=+h[(c[E+8>>2]|0)+48>>3];La=E}Ha=Ka*Ka;E=Ka!=0.0;if(Ha*Ha!=0.0){if(E){Ma=Ka;Na=Ka}else{Ha=+zr(c[d+536>>2]|0,Ka,3088,3e3,+h[La>>3],(a[d+319|0]|0)!=0|0);Ma=Ha;Na=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}Ha=Na*5.039411618000001e-13;_=Na*(Ha+-2.406448405e-9)+4615487296666666.0e-21;M=Na*_+-.004265457205;N=Na*M+6.08273836;H=Na*N;T=Na*Na;xa=T*(Na*(Ka*(-381.846182/Ma+(Na*(Na*(Na*(Ha+(Ha+-2.406448405e-9))+_)+M)+N))+(+da(+O)*-381.846182+H+710.846086))-(Na*(+da(+Ia)*-381.846182+H+710.846086)+-22103.71497))*296.8033869505308/(T*T);break}if(E){Oa=Ka;Pa=Ka;Qa=La}else{T=+zr(c[d+536>>2]|0,Ka,3088,3e3,+h[La>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;Oa=T;Pa=+h[(c[E+8>>2]|0)+48>>3];Qa=E}T=Pa*5.039411618000001e-13;H=Pa*(T+-2.406448405e-9)+4615487296666666.0e-21;N=Pa*H+-.004265457205;M=Pa*N+6.08273836;_=+da(+O)*-381.846182;Ha=Pa*M;K=+da(+Ia)*-381.846182;E=Pa!=0.0;if(Pa*Pa*(Pa*(Ka*(-381.846182/Oa+(Pa*(Pa*(Pa*(T+(T+-2.406448405e-9))+H)+N)+M))+(_+Ha+710.846086))-(Pa*(K+Ha+710.846086)+-22103.71497))*296.8033869505308==0.0){if(E){Ra=Pa;Sa=Pa}else{Ha=+zr(c[d+536>>2]|0,Pa,3088,3e3,+h[Qa>>3],(a[d+319|0]|0)!=0|0);Ra=Ha;Sa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}Ha=Sa*5.039411618000001e-13;M=Sa*(Ha+-2.406448405e-9)+4615487296666666.0e-21;N=Sa*M+-.004265457205;H=Sa*N+6.08273836;T=Sa*H;xa=Sa*Sa*(Sa*(Pa*(-381.846182/Ra+(Sa*(Sa*(Sa*(Ha+(Ha+-2.406448405e-9))+M)+N)+H))+(_+T+710.846086))-(Sa*(K+T+710.846086)+-22103.71497))*296.8033869505308;break}if(E){Ta=d+319|0;Ua=Pa;Va=Pa;Wa=Qa}else{T=+zr(c[(d+536|0)>>2]|0,Pa,3088,3e3,+h[Qa>>3],(a[d+319|0]|0)!=0|0);E=c[c[(d+4|0)>>2]>>2]|0;Ta=d+319|0;Ua=T;Va=+h[(c[E+8>>2]|0)+48>>3];Wa=E}T=Va*5.039411618000001e-13;H=Va*(T+-2.406448405e-9)+4615487296666666.0e-21;N=Va*H+-.004265457205;M=Va*N+6.08273836;Ha=Va*M;L=Va*Va;xa=L*(Va*(Pa*(-381.846182/Ua+(Va*(Va*(Va*(T+(T+-2.406448405e-9))+H)+N)+M))+(_+Ha+710.846086))-(Va*(K+Ha+710.846086)+-22103.71497))*296.8033869505308/+zr(c[(d+536|0)>>2]|0,L*L,3104,3e3,+h[Wa>>3],(a[Ta]|0)!=0|0)}}while(0);D=(yu(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e3)|0)<<24>>24==0;C=c[c[(d+4|0)>>2]>>2]|0;O=+h[(c[C+8>>2]|0)+48>>3];E=1;if(E){E=0;if(D){if(O>0.0){Xa=O;Ya=C}else{D=c[20226]|0;ra=c[d+536>>2]|0;h[k>>3]=O;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sa=b+24|0;c[sa+0>>2]=c[3200+0>>2];c[sa+4>>2]=c[3200+4>>2];c[sa+8>>2]=c[3200+8>>2];c[sa+12>>2]=c[3200+12>>2];c[sa+16>>2]=c[3200+16>>2];c[sa+20>>2]=c[3200+20>>2];He[D&31](ra,b+24|0,3016,z);ra=c[c[(d+4|0)>>2]>>2]|0;Xa=+h[(c[ra+8>>2]|0)+48>>3];Ya=ra}if(Xa>0.0){Za=Xa;_a=Ya}else{ra=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=Xa;c[(b+576|0)>>2]=c[k>>2];c[(b+576|0)+4>>2]=c[k+4>>2];c[b+0>>2]=c[3200+0>>2];c[b+4>>2]=c[3200+4>>2];c[b+8>>2]=c[3200+8>>2];c[b+12>>2]=c[3200+12>>2];c[b+16>>2]=c[3200+16>>2];c[b+20>>2]=c[3200+20>>2];He[ra&31](D,b,3016,b+576|0);D=c[c[(d+4|0)>>2]>>2]|0;Za=+h[(c[D+8>>2]|0)+48>>3];_a=D}L=Za*Za;D=Za!=0.0;if(L*L!=0.0){if(D){$a=Za;ab=Za}else{L=+zr(c[d+536>>2]|0,Za,3088,3e3,+h[_a>>3],(a[d+319|0]|0)!=0|0);$a=L;ab=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=ab*1.266007318e-16;Ha=ab*(L+-4.72763328e-13)+1.621225626666666e-9;K=ab*Ha+-461157839.0e-13;_=ab*K+8.29152319;M=ab*_;N=ab*ab;bb=N*(ab*(Za*(-1788.791477/$a+(ab*(ab*(ab*(L+(L+-4.72763328e-13))+Ha)+K)+_))+(+da(+O)*-1788.791477+M+-39083.5059))-(ab*(+da(+Xa)*-1788.791477+M+-39083.5059)+-117696.2419))*188.9244822140674/(N*N);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(D){Rb=Za;Sb=Za;Tb=_a}else{N=+zr(c[d+536>>2]|0,Za,3088,3e3,+h[_a>>3],(a[d+319|0]|0)!=0|0);D=c[c[(d+4|0)>>2]>>2]|0;Rb=N;Sb=+h[(c[D+8>>2]|0)+48>>3];Tb=D}N=Sb*1.266007318e-16;M=Sb*(N+-4.72763328e-13)+1.621225626666666e-9;_=Sb*M+-461157839.0e-13;K=Sb*_+8.29152319;Ha=+da(+O)*-1788.791477;L=Sb*K;H=+da(+Xa)*-1788.791477;D=Sb!=0.0;if(Sb*Sb*(Sb*(Za*(-1788.791477/Rb+(Sb*(Sb*(Sb*(N+(N+-4.72763328e-13))+M)+_)+K))+(Ha+L+-39083.5059))-(Sb*(H+L+-39083.5059)+-117696.2419))*188.9244822140674==0.0){if(D){Ub=Sb;Vb=Sb}else{L=+zr(c[d+536>>2]|0,Sb,3088,3e3,+h[Tb>>3],(a[d+319|0]|0)!=0|0);Ub=L;Vb=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}L=Vb*1.266007318e-16;K=Vb*(L+-4.72763328e-13)+1.621225626666666e-9;_=Vb*K+-461157839.0e-13;M=Vb*_+8.29152319;N=Vb*M;bb=Vb*Vb*(Vb*(Sb*(-1788.791477/Ub+(Vb*(Vb*(Vb*(L+(L+-4.72763328e-13))+K)+_)+M))+(Ha+N+-39083.5059))-(Vb*(H+N+-39083.5059)+-117696.2419))*188.9244822140674;cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(D){Wb=d+319|0;Xb=Sb;Yb=Sb;Zb=Tb}else{N=+zr(c[(d+536|0)>>2]|0,Sb,3088,3e3,+h[Tb>>3],(a[d+319|0]|0)!=0|0);D=c[c[(d+4|0)>>2]>>2]|0;Wb=d+319|0;Xb=N;Yb=+h[(c[D+8>>2]|0)+48>>3];Zb=D}N=Yb*1.266007318e-16;M=Yb*(N+-4.72763328e-13)+1.621225626666666e-9;_=Yb*M+-461157839.0e-13;K=Yb*_+8.29152319;L=Yb*K;T=Yb*Yb;bb=T*(Yb*(Sb*(-1788.791477/Xb+(Yb*(Yb*(Yb*(N+(N+-4.72763328e-13))+M)+_)+K))+(Ha+L+-39083.5059))-(Yb*(H+L+-39083.5059)+-117696.2419))*188.9244822140674/+zr(c[(d+536|0)>>2]|0,T*T,3104,3e3,+h[Zb>>3],(a[Wb]|0)!=0|0);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}else{E=1}}if(E){E=0;if(1){if(O>0.0){_b=O;$b=C}else{C=c[20226]|0;D=c[d+536>>2]|0;h[k>>3]=O;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];ra=b+72|0;c[ra+0>>2]=c[3200+0>>2];c[ra+4>>2]=c[3200+4>>2];c[ra+8>>2]=c[3200+8>>2];c[ra+12>>2]=c[3200+12>>2];c[ra+16>>2]=c[3200+16>>2];c[ra+20>>2]=c[3200+20>>2];He[C&31](D,b+72|0,3016,x);D=c[c[(d+4|0)>>2]>>2]|0;_b=+h[(c[D+8>>2]|0)+48>>3];$b=D}if(_b>0.0){ac=_b;bc=$b}else{D=c[20226]|0;C=c[d+536>>2]|0;h[k>>3]=_b;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];ra=b+48|0;c[ra+0>>2]=c[3200+0>>2];c[ra+4>>2]=c[3200+4>>2];c[ra+8>>2]=c[3200+8>>2];c[ra+12>>2]=c[3200+12>>2];c[ra+16>>2]=c[3200+16>>2];c[ra+20>>2]=c[3200+20>>2];He[D&31](C,b+48|0,3016,y);C=c[c[(d+4|0)>>2]>>2]|0;ac=+h[(c[C+8>>2]|0)+48>>3];bc=C}T=ac*ac;C=ac!=0.0;if(T*T!=0.0){if(C){cc=ac;dc=ac}else{T=+zr(c[d+536>>2]|0,ac,3088,3e3,+h[bc>>3],(a[d+319|0]|0)!=0|0);cc=T;dc=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}T=dc*5.699355602e-14;L=dc*(T+-1.922497195e-10)+-7.091029093333333e-8;H=dc*L+.001251906908;Ha=dc*H+5.30172524;K=dc*Ha;_=dc*dc;bb=_*(dc*(ac*(-626.411601/cc+(dc*(dc*(dc*(T+(T+-1.922497195e-10))+L)+H)+Ha))+(+da(+O)*-626.411601+K+-45281.9846))-(dc*(+da(+_b)*-626.411601+K+-45281.9846)+-49436.5054))*188.9244822140674/(_*_);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(C){ec=ac;fc=ac;gc=bc}else{_=+zr(c[d+536>>2]|0,ac,3088,3e3,+h[bc>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;ec=_;fc=+h[(c[C+8>>2]|0)+48>>3];gc=C}_=fc*5.699355602e-14;K=fc*(_+-1.922497195e-10)+-7.091029093333333e-8;Ha=fc*K+.001251906908;H=fc*Ha+5.30172524;L=+da(+O)*-626.411601;O=fc*H;T=+da(+_b)*-626.411601;C=fc!=0.0;if(fc*fc*(fc*(ac*(-626.411601/ec+(fc*(fc*(fc*(_+(_+-1.922497195e-10))+K)+Ha)+H))+(L+O+-45281.9846))-(fc*(T+O+-45281.9846)+-49436.5054))*188.9244822140674==0.0){if(C){hc=fc;ic=fc}else{O=+zr(c[d+536>>2]|0,fc,3088,3e3,+h[gc>>3],(a[d+319|0]|0)!=0|0);hc=O;ic=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]}O=ic*5.699355602e-14;H=ic*(O+-1.922497195e-10)+-7.091029093333333e-8;Ha=ic*H+.001251906908;K=ic*Ha+5.30172524;_=ic*K;bb=ic*ic*(ic*(fc*(-626.411601/hc+(ic*(ic*(ic*(O+(O+-1.922497195e-10))+H)+Ha)+K))+(L+_+-45281.9846))-(ic*(T+_+-45281.9846)+-49436.5054))*188.9244822140674;cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}if(C){jc=d+319|0;kc=fc;lc=fc;mc=gc}else{_=+zr(c[(d+536|0)>>2]|0,fc,3088,3e3,+h[gc>>3],(a[d+319|0]|0)!=0|0);C=c[c[(d+4|0)>>2]>>2]|0;jc=d+319|0;kc=_;lc=+h[(c[C+8>>2]|0)+48>>3];mc=C}_=lc*5.699355602e-14;K=lc*(_+-1.922497195e-10)+-7.091029093333333e-8;Ha=lc*K+.001251906908;H=lc*Ha+5.30172524;O=lc*H;M=lc*lc;bb=M*(lc*(fc*(-626.411601/kc+(lc*(lc*(lc*(_+(_+-1.922497195e-10))+K)+Ha)+H))+(L+O+-45281.9846))-(lc*(T+O+-45281.9846)+-49436.5054))*188.9244822140674/+zr(c[(d+536|0)>>2]|0,M*M,3104,3e3,+h[mc>>3],(a[jc]|0)!=0|0);cb=c[(e+8|0)>>2]|0;db=c[(d+4|0)>>2]|0;eb=c[db>>2]|0;fb=eb;gb=fb+8|0;hb=gb;ib=c[hb>>2]|0;jb=+h[ib>>3];kb=m*jb;lb=ib;mb=lb+8|0;nb=mb;ob=+h[nb>>3];pb=n*ob;qb=ib;rb=qb+16|0;sb=rb;tb=+h[sb>>3];ub=o*tb;vb=ib;wb=vb+24|0;xb=wb;yb=+h[xb>>3];zb=P*yb;Ab=ib;Bb=Ab+32|0;Cb=Bb;Db=+h[Cb>>3];Eb=xa*Db;Fb=ib;Gb=Fb+40|0;Hb=Gb;Ib=+h[Hb>>3];Jb=bb*Ib;Kb=-Jb;Lb=Kb-Eb;Mb=Lb-zb;Nb=Mb-ub;Ob=Nb-pb;Pb=Ob-kb;re[cb&3](1,0,Pb,2,e);Qb=c[(e+8|0)>>2]|0;re[Qb&3](1,1,1.0,3,e);i=b;c[b+6696>>2]=5;break a}else{E=1}}}while(0)}




// EMSCRIPTEN_END_FUNCS
var ae=[tX,Lt,Nt,St,RI,tX,tX,tX];var be=[uX,uo,vo,_o,$o,Dp,Ep,$p,aq,bq,KV,JV,IV,Nn,On,ur,sr,uX,uX,uX,uX,uX,uX,uX,uX,uX,uX,uX,uX,uX,uX,uX];var ce=[vX,vv];var de=[wX,xu];var ee=[xX,Qg,Rg,Ug,Zg,fj,$g,pr,Hx,Kx,Jx,Lx,PN,ON,RN,QN,Mx,Ox,_A,uB,vB,wB,AN,zN,CN,BN,nI,AI,BI,CI,EI,GI,wK,xK,DK,EK,KK,LK,RK,SK,cL,bL,hL,gL,jL,kL,tL,sL,AM,zM,JM,IM,lN,kN,JN,IN,LN,KN,bO,aO,dO,cO,jO,iO,yM,kO,hO,lO,nO,mO,vS,tO,sO,yO,xO,XO,WO,zP,yP,NP,MP,$P,_P,nQ,mQ,AQ,zQ,DQ,CQ,HQ,GQ,SQ,RQ,bR,aR,mR,lR,xR,wR,HR,GR,PR,OR,VR,UR,$R,_R,eS,dS,nS,mS,LS,KS,iS,aT,HT,GT,JT,IT,oO,uS,xS,US,iT,tT,ET,FT,vV,uV,xV,AV,yV,zV,BV,CV,ZV,YV,Jg,yX,hf,jf,mf,nf,of,pf,qf,rf,Gf,Hf,If,Kf,Rf,Sf,Tf,Uf,Vf,Wf,dg,hg,ig,jg,kg,lg,mg,ng,og,pg,qg,rg,sg,tg,ug,vg,wg,xg,yg,zg,Ag,Bg,Cg,Dg,Eg,PV,rr,Ye,hu,lu,gu,yv,nu,wv,Ls,qu,ou,pu,mu,su,xv,tu,iu,vu,_H,wu,WJ,vK,wS,pU,zR,wU,vU,uU,tU,sU,rU,JL,lM,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX,xX];var fe=[zX,_g,dw,Px,_M,yK,FK,MK,TK,mN,KQ,LQ,MQ,NQ,PQ,QQ,VQ,WQ,XQ,YQ,_Q,$Q,eR,fR,gR,hR,jR,kR,pR,qR,rR,sR,uR,vR,cS,hS,OT,QT,ST,PT,RT,TT,_t,Sg,Vg,Wg,Xg,Yg,ru,GA,fw,ew,gw,mw,yw,hw,ww,Vz,fA,eA,gA,Qz,Oz,Sz,dJ,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX,zX];var ge=[AX,ao,Vn,Mt,Ot,Pt,Qt,Rt];var he=[BX,Gg,Hk,Fg,_e,$e,af,gj,hj,fh,ej,Gk,Gl,eh,ch,Hl,Il,Rl,Sl,Tl,Ul,Vl,Wl,Xl,Yl,CX,DX,EX,Lr,OV,FX,Tx,dN,Ux,gN,cN,JI,zK,rN,tN,uN,qN,GK,HK,NK,fN,UK,VK,dL,iL,fO,aQ,UT,WT,YT,cU,eU,_T,aU,oQ,VT,XT,ZT,dU,fU,$T,bU,IQ,JQ,OQ,TQ,UQ,ZQ,cR,dR,iR,nR,oR,tR,eT,fT,hT,KT,MT,LT,NT,YS,ZS,$S,oT,pT,sT,zT,AT,DT,wV,_V,Fv,GX,HX,Dv,Ev,IX,TH,sI,Bu,Ju,Vu,Cu,Mu,Wu,nK,hW,BX,BX,BX,BX,BX,BX,BX,BX,BX,BX,BX,BX,BX,BX,BX];var ie=[JX,ns];var je=[KX,vt];var ke=[LX,bh,lo,ro,Ro,Xo,up,Ap,Qx,eN,iN,$M,nN,sN,AK,wN,OK,nL,oL,rO,wO,aS,fS,NS,PS,SS,yS,DS,FS,IS,DV,aI,os,Zn,Qn,Xn,bo,MX,NX,OX,zv,ZH,VH,PX,fK,QX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX,LX];var le=[RX,zt];var me=[SX,Ts];var ne=[TX,HP,KP,VP,XP,TX,TX,TX];var oe=[UX,BQ,EQ,yR,CR,IR,KR,UX];var pe=[VX,tt];var qe=[WX,mr,Rx,HI,oN,aN,AP,BP,FP,LP,OP,PP,TP,YP,bS,gS,NV,MV,LV,nr,WX,WX,WX,WX,WX,WX,WX,WX,WX,WX,WX,WX];var re=[XX,Ku,Lu,XX];var se=[YX,Ig];var te=[ZX,zO,BO,DO,FO,HO,JO,LO,NO,PO,RO,TO,YO,_O,aP,cP,eP,gP,iP,kP,mP,oP,qP,EP,GP,SP,UP,bQ,cQ,dQ,eQ,fQ,pQ,qQ,rQ,sQ,tQ,TR,ZR,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX,ZX];var ue=[_X,QR,WR,_X];var ve=[$X,gQ,uQ,$X];var we=[aY,Ze,gh,dh,ah,Zl,_l,no,oo,qo,To,Uo,Wo,wp,xp,zp,Fp,Gp,Hp,Ip,Jp,Kp,Lp,Mp,Vx,Wx,KI,LI,vN,BK,IK,xN,hN,PK,WK,jN,MS,OS,QS,CS,ES,GS,nv,Yu,Ou,Du,Nu,Xu,bY,RV,Kn,Ln,Mn,cY,Yr,Ru,Uu,Gu,jv,av,Iu,dY,gV,aY];var xe=[eY,pO,uO,TS,dT,gT,JS,XS,_S,nT,qT,yT,BT,hq,_q,$q,mq,jq,Yq,Zq,nq,oq,pq,qq,rq,Oq,Pq,Fq,yq,tq,sq,uq,vq,xq,wq,kq,iq,zq,Aq,Bq,Cq,Dq,Eq,Gq,Hq,Iq,Jq,Nq,Lq,Kq,Mq,Uq,Qq,Rq,Sq,Tq,Vq,Wq,Xq,ar,br,cr,dr,CP];var ye=[fY,Kv];var ze=[gY,Zu];var Ae=[hY,bt];var Be=[iY,am,jY,Mr,sK,tK,qK,iY];var Ce=[kY,yt];var De=[lY,cI,mL,gO,xr,_v,aw,FA,cJ,lY,lY,lY,lY,lY,lY,lY];var Ee=[mY,nY,Kr,gr,Lg,mY,mY,mY];var Fe=[oY,$l,bT,cT,VS,WS,jT,lT,uT,wT,bv,oY,oY,oY,oY,oY];var Ge=[pY,fo,go,ho,io,jo,ko,mo,po,to,Lo,Mo,No,Oo,Po,Qo,So,Vo,Zo,op,pp,qp,rp,sp,tp,vp,yp,Cp,RS,zS,AS,BS,HS,au,qY,ut,Cn,Em,Zm,gn,Um,qn,vn,tn,wn,co,In,Sn,Tn,_n,$n,VO,IP,rY,pY,pY,pY,pY,pY,pY,pY,pY,pY,pY];var He=[sY,so,Yo,Bp,Sx,bI,II,pN,bN,qO,vO,EV,FV,GV,vr,tr,cu,wr,Tg,xJ,Un,yr,sY,sY,sY,sY,sY,sY,sY,sY,sY,sY];return{_testSetjmp:DW,_saveSetjmp:pW,_free:PV,_main:Kg,_rand_r:xW,_realloc:RV,_i64Add:AW,_memmove:tW,_bitshift64Ashr:rW,_memset:uW,_malloc:OV,_strncpy:BW,_memcpy:sW,_strlen:qW,_bitshift64Lshr:CW,_bitshift64Shl:vW,_i64Subtract:zW,_strcpy:wW,_calloc:QV,_rand:yW,__GLOBAL__I_a:YK,runPostSets:oW,stackAlloc:Ie,stackSave:Je,stackRestore:Ke,setThrew:Le,setTempRet0:Oe,setTempRet1:Pe,setTempRet2:Qe,setTempRet3:Re,setTempRet4:Se,setTempRet5:Te,setTempRet6:Ue,setTempRet7:Ve,setTempRet8:We,setTempRet9:Xe,dynCall_iiiiiiii:NW,dynCall_viiiii:OW,dynCall_iiiiidiii:PW,dynCall_vd:QW,dynCall_vi:RW,dynCall_vii:SW,dynCall_iiiiiiiiiii:TW,dynCall_ii:UW,dynCall_viidi:VW,dynCall_iiiiiiiiiiiiii:WW,dynCall_iiii:XW,dynCall_iiiiiiiiiiiiiiiiiiiiiii:YW,dynCall_iiiiiiiiiiiiiiiiiiiii:ZW,dynCall_viiiiid:_W,dynCall_viiiiiiii:$W,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:aX,dynCall_viiiiii:bX,dynCall_viidii:cX,dynCall_iid:dX,dynCall_viiiiiii:eX,dynCall_viiiiiid:fX,dynCall_viiiiiiiii:gX,dynCall_iii:hX,dynCall_iiiiii:iX,dynCall_iiiiidi:jX,dynCall_didd:kX,dynCall_dii:lX,dynCall_i:mX,dynCall_iiiiiiiiii:nX,dynCall_viii:oX,dynCall_v:pX,dynCall_iiiiiiiii:qX,dynCall_iiiii:rX,dynCall_viiii:sX}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "_lis_vector_get_values": _lis_vector_get_values, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "__isLeapYear": __isLeapYear, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






